local BeliefScoreITGTable = {}

--[[
	m_iRELIGION_BELIEF_SCORE_CITY_MULTIPLIER(10),
	m_iRELIGION_BELIEF_SCORE_WORKED_PLOT_MULTIPLIER(8),
	m_iRELIGION_BELIEF_SCORE_OWNED_PLOT_MULTIPLIER(5),
	m_iRELIGION_BELIEF_SCORE_UNOWNED_PLOT_MULTIPLIER(3),
]]

function DLLBasedBeliefScore(iPlayer, iBelief)
	local startValue = 0;
	local iTeam = Players[iPlayer]:GetTeam();
	if BeliefScoreITGTable[iBelief] then
		if BeliefScoreITGTable[iBelief].PlotAIFlavour then
			local tT = {}
			for iCity in Players[iPlayer]:Cities() do
				for i = 0, iCity:GetNumCityPlots() - 1 do
					local fPlot = iCity:GetCityIndexPlot( i );
					if fPlot then
						local fIndex = fPlot:GetPlotIndex();
						if not tT[fIndex] then
							tT[fIndex] = true;
							if fPlot:IsRevealed(iTeam) and (fPlot:GetOwner() == -1 or fPlot:GetOwner() == iPlayer) then
								local plotscore = BeliefScoreITGTable[iBelief].PlotAIFlavour(fPlot, iTeam, iBelief)
								if plotscore ~= 0 then
									if fPlot:IsBeingWorked() then
										plotscore = plotscore * 8;
									elseif fPlot:GetOwner() == iPlayer then
										plotscore = plotscore * 5;
									else
										plotscore = plotscore * 3;
									end					
									startValue = startValue + plotscore;
								end 
							end
						end
					end
				end
			end
		end
		if BeliefScoreITGTable[iBelief].CityAIFlavour then
			for iCity in Players[iPlayer]:Cities() do
				startValue = startValue + BeliefScoreITGTable[iBelief].CityAIFlavour(iCity, iPlayer, iBelief) * 3;
			end
		end
		if BeliefScoreITGTable[iBelief].PlayerAIFlavour then
			startValue = startValue + BeliefScoreITGTable[iBelief].PlayerAIFlavour(iPlayer);
		end
		if (GameInfo.Beliefs[iBelief].Pantheon) then
			startValue = startValue / 2;
		end
		if BeliefScoreITGTable[iBelief].BaseAmount then
			startValue = startValue + BeliefScoreITGTable[iBelief].BaseAmount;
		end
	else
--		if ITGdebug or IWANTTOTESTBELIEFSTODAY then
-- current standard is to not use dll evaluation
			print("Holla, we dont want DLL here! ", iBelief, GameInfo.Beliefs[iBelief].Type)
--		end
		startValue = startValue + Players[iPlayer]:GetBeliefScore(iBelief);
	end
	return math.floor(startValue);
end

function DoPrintAllBeliefsWithOnlyDLLScore()
	for row in GameInfo.Beliefs() do
		if not BeliefScoreITGTable[row.ID] then
			if IsBeliefUsedByAnyEra(row.ID) then
				print("DLL Scored belief:", row.Type)
			end
		end
	end
end

function ITGScoreBeliefAtCity(iBelief, iCity)
--[[
/// AI's evaluation of this belief's usefulness at this one plot
int CvReligionAI::ScoreBeliefAtCity(CvBeliefEntry* pEntry, CvCity* pCity)
{
	int iRtnValue = 0;
	int iTempValue;
	int iMinPop;
	int iMinFollowers;
	int iHappinessMultiplier = 2;

	CvFlavorManager* pFlavorManager = m_pPlayer->GetFlavorManager();
	int iFlavorOffense = pFlavorManager->GetPersonalityIndividualFlavor((FlavorTypes)GC.getInfoTypeForString("FLAVOR_OFFENSE"));
	int iFlavorDefense = pFlavorManager->GetPersonalityIndividualFlavor((FlavorTypes)GC.getInfoTypeForString("FLAVOR_DEFENSE"));
	int iFlavorCityDefense = pFlavorManager->GetPersonalityIndividualFlavor((FlavorTypes)GC.getInfoTypeForString("FLAVOR_CITY_DEFENSE"));
	int iFlavorHappiness = pFlavorManager->GetPersonalityIndividualFlavor((FlavorTypes)GC.getInfoTypeForString("FLAVOR_HAPPINESS"));

	int iHappinessNeedFactor = iFlavorOffense * 2 + iFlavorHappiness - iFlavorDefense;
	if (iHappinessNeedFactor > 15)
	{
		iHappinessMultiplier = 3;
	}
	else if (iHappinessNeedFactor < 6)
	{
		iHappinessMultiplier = 1;
	}

	iMinPop = pEntry->GetMinPopulation();
	iMinFollowers = pEntry->GetMinFollowers();

	// Simple ones
	iRtnValue += pEntry->GetCityGrowthModifier() / 3;
	if(pEntry->RequiresPeace())
	{
		iRtnValue /= 2;
	}
	iRtnValue += (-pEntry->GetPlotCultureCostModifier() * 2) / 10;
	iRtnValue += (pEntry->GetCityRangeStrikeModifier() / 10) * MAX(iFlavorDefense,iFlavorCityDefense);
	iRtnValue += pEntry->GetFriendlyHealChange() / 10;

	// Wonder production multiplier
	if(pEntry->GetObsoleteEra() > 0)
	{	
		if (pEntry->GetObsoleteEra() > GC.getGame().getCurrentEra())
		{
			iRtnValue += (pEntry->GetWonderProductionModifier() * pEntry->GetObsoleteEra()) / 10;
		}
	}
	else
	{
		iRtnValue += pEntry->GetWonderProductionModifier() / 3;
	}

	// River happiness
	iTempValue = pEntry->GetRiverHappiness() * iHappinessMultiplier;
	if(iMinPop > 0)
	{
		if(pCity->getPopulation() >= iMinPop)
		{
			iTempValue *= 2;
		}
	}
	iRtnValue += iTempValue;

	// Happiness per city
	iTempValue = pEntry->GetHappinessPerCity() * iHappinessMultiplier;
	if(iMinPop > 0)
	{
		if(pCity->getPopulation() >= iMinPop)
		{
			iTempValue *= 2;
		}
	}
	iRtnValue += iTempValue;

	// Building class happiness
	for(int jJ = 0; jJ < GC.getNumBuildingClassInfos(); jJ++)
	{
		iTempValue = pEntry->GetBuildingClassHappiness(jJ) * iHappinessMultiplier;
		if(iMinFollowers > 0)
		{
			if(pCity->getPopulation() >= iMinFollowers)
			{
				iTempValue *= 2;
			}
		}
		iRtnValue += iTempValue;
	}

		// City yield change
		iTempValue = pEntry->GetCityYieldChange(iI);
		if(iMinPop > 0)
		{
			if(pCity->getPopulation() >= iMinPop)
			{
				iTempValue *= 2;
			}
		}
		iRtnValue += iTempValue;

		// Trade route yield change
		iTempValue = pEntry->GetYieldChangeTradeRoute(iI);
		if(iMinPop > 0)
		{
			if(pCity->getPopulation() >= iMinPop)
			{
				iTempValue *= 2;
			}
		}
		if(pCity->IsRouteToCapitalConnected())
		{
			iTempValue *= 2;
		}
		iRtnValue += iTempValue;

		// Specialist yield change
		iTempValue = pEntry->GetYieldChangeAnySpecialist(iI);
		if(pCity->getPopulation() >= 8)  // Like it more with large cities
		{
			iTempValue *= 3;
		}
		iRtnValue += iTempValue;

		// Building class yield changes
		iTempValue = pEntry->GetBuildingClassYieldChange(jJ, iI);
			if(iMinFollowers > 0)
				if(pCity->getPopulation() < iMinFollowers)
					iTempValue /= 2;

			BuildingTypes eBuilding = (BuildingTypes)m_pPlayer->getPlayerUniqueBuildings(jJ);
			if (eBuilding != NO_BUILDING)
				if(pCity->GetCityBuildings()->GetNumBuilding(eBuilding) > 0)
					iTempValue *= 2;

			if(pkBuildingClassInfo->getMaxPlayerInstances() == 1)
				iTempValue /= 2;

			iRtnValue += iTempValue;
		}

		// World wonder change
		iRtnValue += pEntry->GetYieldChangeWorldWonder(iI) * 3 / 2;
		// Production per follower
			iTempValue = min(pEntry->GetMaxYieldModifierPerFollower(iI), pCity->getPopulation());
			iTempValue /= 2;
			iRtnValue += iTempValue;
} ]]


end


function ITGScoreBeliefForPlayer(iBelief, iPlayer)
--[[/// AI's evaluation of this belief's usefulness to this player
int CvReligionAI::ScoreBeliefForPlayer(CvBeliefEntry* pEntry)
{
	int iRtnValue = 0;
	CvFlavorManager* pFlavorManager = m_pPlayer->GetFlavorManager();
	CvGameReligions* pGameReligions = GC.getGame().GetGameReligions();

	//--------------------
	// GET BACKGROUND DATA
	//--------------------
	int iFlavorOffense = pFlavorManager->GetPersonalityIndividualFlavor((FlavorTypes)GC.getInfoTypeForString("FLAVOR_OFFENSE"));
	int iFlavorDefense = pFlavorManager->GetPersonalityIndividualFlavor((FlavorTypes)GC.getInfoTypeForString("FLAVOR_DEFENSE"));
	int iFlavorHappiness = pFlavorManager->GetPersonalityIndividualFlavor((FlavorTypes)GC.getInfoTypeForString("FLAVOR_HAPPINESS"));
	int iFlavorCulture = pFlavorManager->GetPersonalityIndividualFlavor((FlavorTypes)GC.getInfoTypeForString("FLAVOR_CULTURE"));
	int iFlavorGold = pFlavorManager->GetPersonalityIndividualFlavor((FlavorTypes)GC.getInfoTypeForString("FLAVOR_GOLD"));
	int iFlavorGP = pFlavorManager->GetPersonalityIndividualFlavor((FlavorTypes)GC.getInfoTypeForString("FLAVOR_GREAT_PEOPLE"));
	int iFlavorScience = pFlavorManager->GetPersonalityIndividualFlavor((FlavorTypes)GC.getInfoTypeForString("FLAVOR_SCIENCE"));
	int iFlavorDiplomacy = pFlavorManager->GetPersonalityIndividualFlavor((FlavorTypes)GC.getInfoTypeForString("FLAVOR_DIPLOMACY"));
	int iFlavorExpansion = pFlavorManager->GetPersonalityIndividualFlavor((FlavorTypes)GC.getInfoTypeForString("FLAVOR_EXPANSION"));

	int iNumEnhancedReligions = pGameReligions->GetNumReligionsEnhanced();
//	int iReligionsEnhancedPercent = (100 * iNumEnhancedReligions) / GC.getMap().getWorldInfo().getMaxActiveReligions();
	int iReligionsEnhancedPercent = (100 * iNumEnhancedReligions) / 5;

	//------------------------------
	// PLAYER-LEVEL PANTHEON BELIEFS
	//------------------------------
	if(pEntry->GetFaithFromKills() > 0)
	{
		int iTemp = pEntry->GetFaithFromKills() * pEntry->GetMaxDistance() * iFlavorOffense / 100;
		if (m_pPlayer->GetDiplomacyAI()->IsGoingForWorldConquest())
		{
			iTemp *= 2;
		}
		iRtnValue += iTemp;
	}

	//-----------------
	// REFORMATION BELIEFS
	//-----------------
	if (pEntry->FaithPurchaseAllGreatPeople())
	{
		// Count number of GP branches we have still to open and score based on that
		int iTemp = 0;
		PolicyBranchTypes eBranch;
		eBranch = (PolicyBranchTypes)GC.getInfoTypeForString("POLICY_BRANCH_TRADITION", true /*bHideAssert*/);
		if (eBranch != NO_POLICY_BRANCH_TYPE && (!m_pPlayer->GetPlayerPolicies()->IsPolicyBranchFinished(eBranch) || m_pPlayer->GetPlayerPolicies()->IsPolicyBranchBlocked(eBranch)))
		{
			iTemp++;
		}
		eBranch = (PolicyBranchTypes)GC.getInfoTypeForString("POLICY_BRANCH_HONOR", true /*bHideAssert*/);
		if (eBranch != NO_POLICY_BRANCH_TYPE && (!m_pPlayer->GetPlayerPolicies()->IsPolicyBranchFinished(eBranch) || m_pPlayer->GetPlayerPolicies()->IsPolicyBranchBlocked(eBranch)))
		{
			iTemp++;
		}
		eBranch = (PolicyBranchTypes)GC.getInfoTypeForString("POLICY_BRANCH_AESTHETICS", true /*bHideAssert*/);
		if (eBranch != NO_POLICY_BRANCH_TYPE && (!m_pPlayer->GetPlayerPolicies()->IsPolicyBranchFinished(eBranch) || m_pPlayer->GetPlayerPolicies()->IsPolicyBranchBlocked(eBranch)))
		{
			iTemp++;
		}
		eBranch = (PolicyBranchTypes)GC.getInfoTypeForString("POLICY_BRANCH_COMMERCE", true /*bHideAssert*/);
		if (eBranch != NO_POLICY_BRANCH_TYPE && (!m_pPlayer->GetPlayerPolicies()->IsPolicyBranchFinished(eBranch) || m_pPlayer->GetPlayerPolicies()->IsPolicyBranchBlocked(eBranch)))
		{
			iTemp++;
		}
		eBranch = (PolicyBranchTypes)GC.getInfoTypeForString("POLICY_BRANCH_EXPLORATION", true /*bHideAssert*/);
		if (eBranch != NO_POLICY_BRANCH_TYPE && (!m_pPlayer->GetPlayerPolicies()->IsPolicyBranchFinished(eBranch) || m_pPlayer->GetPlayerPolicies()->IsPolicyBranchBlocked(eBranch)))
		{
			iTemp++;
		}
		eBranch = (PolicyBranchTypes)GC.getInfoTypeForString("POLICY_BRANCH_RATIONALISM", true /*bHideAssert*/);
		if (eBranch != NO_POLICY_BRANCH_TYPE && (!m_pPlayer->GetPlayerPolicies()->IsPolicyBranchFinished(eBranch) || m_pPlayer->GetPlayerPolicies()->IsPolicyBranchBlocked(eBranch)))
		{
			iTemp++;
		}

		iRtnValue += (iTemp * 6);
	}
	if (pEntry->ConvertsBarbarians())
	{
		MilitaryAIStrategyTypes eStrategyBarbs = (MilitaryAIStrategyTypes) GC.getInfoTypeForString("MILITARYAISTRATEGY_ERADICATE_BARBARIANS");
		if (m_pPlayer->GetMilitaryAI()->IsUsingStrategy(eStrategyBarbs))
		{
			iRtnValue += 40;
		}
		else
		{
			iRtnValue += 15;
		}
	}
	if (pEntry->GetCityStateInfluenceModifier() > 0)
	{
		iRtnValue += (pEntry->GetCityStateInfluenceModifier() * iFlavorDiplomacy / 5);
	}
	if (pEntry->GetInquisitorPressureRetention() > 0)
	{
		iRtnValue += (pEntry->GetInquisitorPressureRetention() / 2);
	}
	if (pEntry->GetSpyPressure() > 0)
	{
		iRtnValue += (pEntry->GetSpyPressure()* 5);
	}
	if (pEntry->GetFaithBuildingTourism() > 0)
	{
		iRtnValue += (pEntry->GetFaithBuildingTourism() * 20);
	}

	return iRtnValue;
}]]

end

function GetAIBeliefScorePlayerFounder1(iPlayer)
	--Science per following city;
	local iFlavorScience = GetAIFlavour(iPlayer, "FLAVOR_SCIENCE");
	return iFlavorScience * 1;
end

function GetAIBeliefScorePlayerFounder2(iPlayer)
	--gold for missionary
	local iFlavorGold = GetAIFlavour(iPlayer, "FLAVOR_GOLD");
	return iFlavorGold * 13 / 5;
end

function GetAIBeliefScorePlayerFounder3(iPlayer)
	--culture for missionary
	local iFlavorGold = GetAIFlavour(iPlayer, "FLAVOR_CULTURE");
	return iFlavorGold * 13 / 5;
end

function GetAIBeliefScorePlayerFounder4(iPlayer)
	--gold from holy sites
	local iFlavorGold = GetAIFlavour(iPlayer, "FLAVOR_GOLD");
	return iFlavorGold * 2;
end

function GetAIBeliefScorePlayerFounder5(iPlayer)
	--gold from holy sites
	local iFlavorGold = 5;
	return iFlavorGold * 2;
end

function GetAIBeliefScorePlayerFounder6(iPlayer)
	local iFlavor = GetAIFlavour(iPlayer, "FLAVOR_LEGAL");
	return iFlavor * 1;
end

function GetAIBeliefScorePlayerFounder7(iPlayer)
	--Legal per city
	local iFlavor = GetAIFlavour(iPlayer, "FLAVOR_LEGAL");
	return iFlavor * 10 / 8;
end

function GetAIBeliefScorePlayerFounder8(iPlayer)
	--influence for missionary
	local iFlavorDiplo = GetAIFlavour(iPlayer, "FLAVOR_DIPLOMACY");
	return iFlavorDiplo * 13 / 5;
end

function GetAIBeliefScorePlayerFounder9(iPlayer)
	--politics
	local iFlavorDiplo = GetAIFlavour(iPlayer, "FLAVOR_DIPLOMACY");
	return iFlavorDiplo * 2;
end

function GetAIBeliefScorePlayerFounder10(iPlayer)
	--Science per followers
	local iFlavorScience = GetAIFlavour(iPlayer, "FLAVOR_SCIENCE");
	return iFlavorScience * 4 / 6;
end

function GetAIBeliefScorePlayerFounder11(iPlayer)
	--gold from holy sites
	local iFlavorScience = GetAIFlavour(iPlayer, "FLAVOR_DIPLOMACY");
	return iFlavorScience * 1;
end

function GetAIBeliefScorePlayerFounder12(iPlayer)
	local iFlavor = GetAIFlavour(iPlayer, "FLAVOR_DIPLOMACY");
	return iFlavor * 10 / 5;
end

function GetAIBeliefScorePlayerFounder13(iPlayer)
	local iFlavorScience = GetAIFlavour(iPlayer, "FLAVOR_HAPPINESS");
	return iFlavorScience * 4 / 6;
end

function GetAIBeliefScorePlayerFounder19(iPlayer)
	local iFlavorScience = GetAIFlavour(iPlayer, "FLAVOR_GREAT_PEOPLE");
	return iFlavorScience * 4 / 7;
end

function GetAIBeliefScorePlayerFounderRelTexts(iPlayer)
	local iFlavor = GetAIFlavour(iPlayer, "FLAVOR_DISRUPTIVE");
	return iFlavor;
end

function GetAIBeliefScorePlayerFounderPeaceLove(iPlayer)
	local iFlavor = GetAIFlavour(iPlayer, "FLAVOR_HAPPINESS");
	return iFlavor;
end

function GetAIBeliefScorePlayerFounderGold(iPlayer)
	return GetAIFlavour(iPlayer, "FLAVOR_GOLD");
end

function GetAIBeliefScorePlayerFounderPrimacy(iPlayer)
	return GetAIFlavour(iPlayer, "FLAVOR_DIPLOMACY");
end

function GetAIBeliefScorePlayerFounderFaith(iPlayer)
	return GetAIFlavour(iPlayer, "FLAVOR_FAITH");
end

function GetAIBeliefScorePlayerFounderCulture(iPlayer)
	return GetAIFlavour(iPlayer, "FLAVOR_CULTURE");
end

function GetAIBeliefScorePlayerFounderDialogue(iPlayer)
	local iFlavor = GetAIFlavour(iPlayer, "FLAVOR_SCIENCE");
	return iFlavor * 3 / 5;
end

function GetAIBeliefScorePlayerFounder14(iPlayer)
	--Legal per city
	local iFlavor = GetAIFlavour(iPlayer, "FLAVOR_LEGAL");
	return iFlavor * 5;
end

function GetAIBeliefScorePlayerFounder15(iPlayer)
	--Legal per city
	local iFlavor = GetAIFlavour(iPlayer, "FLAVOR_GREAT_PEOPLE");
	return iFlavor * 5;
end

function GetAIBeliefScorePlayerFounder16(iPlayer)
	--Legal per city
	local iFlavor = GetAIFlavour(iPlayer, "FLAVOR_GREAT_PEOPLE");
	return iFlavor * 5;
end

function GetAIBeliefScorePlayerFounder17(iPlayer)
	--Legal per city
	local iFlavor = GetAIFlavour(iPlayer, "FLAVOR_EXPANSION");
	return iFlavor * 5;
end

function GetAIBeliefScorePlayerFounder18(iPlayer)
	--Legal per city
	local iFlavor = GetAIFlavour(iPlayer, "FLAVOR_EXPANSION");
	return iFlavor * 5;
end

--[[	//----------------
	// FOUNDER BELIEFS
	//----------------
	iRtnValue += (int)(pEntry->GetHappinessPerFollowingCity() * (float)(iFlavorHappiness + 2 * iFlavorOffense - iFlavorDefense));
	if (pEntry->GetHappinessPerXPeacefulForeignFollowers() > 0 && iFlavorDefense > 0)
	{
		iRtnValue += (iFlavorHappiness * 10 * iFlavorDefense) / (pEntry->GetHappinessPerXPeacefulForeignFollowers() * iFlavorDefense);
	}
	iRtnValue += iFlavorScience * pEntry->GetSciencePerOtherReligionFollower() / 5;
	iRtnValue += pEntry->GetGoldPerFollowingCity() * iFlavorGold;
	if(pEntry->GetGoldPerXFollowers() > 0)
	{
		iRtnValue += (iFlavorGold * 4 / pEntry->GetGoldPerXFollowers());
	}
	iRtnValue += iFlavorGold * pEntry->GetGoldWhenCityAdopts() / 50;

	// Minimum influence with city states
	iRtnValue += iFlavorDiplomacy * pEntry->GetCityStateMinimumInfluence() / 7;

	// Yields for foreign followers
	for(int iI = 0; iI < NUM_YIELD_TYPES; iI++)
	{
		if (iI == YIELD_CULTURE)
		{
			iRtnValue += pEntry->GetYieldChangePerForeignCity(iI) * 2 * iFlavorCulture;
			if (pEntry->GetYieldChangePerXForeignFollowers(iI) > 0)
			{
				iRtnValue += 10 * iFlavorCulture / pEntry->GetYieldChangePerXForeignFollowers(iI);
			}
		}
		else
		{
			iRtnValue += pEntry->GetYieldChangePerForeignCity(iI) * 10;
			if (pEntry->GetYieldChangePerXForeignFollowers(iI) > 0)
			{
				iRtnValue += 50 / pEntry->GetYieldChangePerXForeignFollowers(iI);
			}
		}
	}]]

function GetAIBeliefScorePlayerEnhancer1(iPlayer)
	local iFlavor = GetAIFlavour(iPlayer, "FLAVOR_EXPANSION");
	if GetITGGameTurn() < 33 then
		return 2 * iFlavor;
	elseif GetITGGameTurn() < 67 then
		return iFlavor;
	else
		return iFlavor /2;
	end
end

function GetAIBeliefScorePlayerEnhancer2(iPlayer)
	local iFlavor = GetAIFlavour(iPlayer, "FLAVOR_EXPANSION");
	if GetITGGameTurn() < 33 then
		return 2 * iFlavor;
	elseif GetITGGameTurn() < 67 then
		return iFlavor;
	else
		return iFlavor /2;
	end
end

function GetAIBeliefScorePlayerEnhancer3(iPlayer)
	local iFlavor = GetAIFlavour(iPlayer, "FLAVOR_OFFENSE");
	return 5 * iFlavor;
end

function GetAIBeliefScorePlayerEnhancer4(iPlayer)
	local iFlavor = GetAIFlavour(iPlayer, "FLAVOR_EXPANSION");
	if GetITGGameTurn() < 33 then
		return 2 * iFlavor;
	elseif GetITGGameTurn() < 67 then
		return iFlavor;
	else
		return iFlavor /2;
	end
end

function GetAIBeliefScorePlayerEnhancer5(iPlayer)
	local iFlavor = GetAIFlavour(iPlayer, "FLAVOR_EXPANSION");
	return iFlavor;
end

function GetAIBeliefScorePlayerEnhancer6(iPlayer)
	if GetITGGameTurn() < 33 then
		return 40;
	elseif GetITGGameTurn() < 67 then
		return 33;
	else
		return 21;
	end
end

function GetAIBeliefScorePlayerEnhancer7(iPlayer)
	if GetITGGameTurn() < 33 then
		return 35;
	elseif GetITGGameTurn() < 67 then
		return 39;
	else
		return 29;
	end
end

function GetAIBeliefScorePlayerEnhancer8(iPlayer)
	if gT.Players[iPlayer].OfficialReligion then
		return -5;
	end
	if GetITGGameTurn() < 33 then
		return 50;
	elseif GetITGGameTurn() < 67 then
		return 40;
	else
		return 30;
	end
end

function GetAIBeliefScorePlayerEnhancer9(iPlayer)
	local iFlavor = GetAIFlavour(iPlayer, "FLAVOR_EXPANSION");
	return iFlavor;
end

function GetAIBeliefScorePlayerEnhancer10(iPlayer)
	local iFlavor = GetAIFlavour(iPlayer, "FLAVOR_GREAT_PEOPLE");
	return iFlavor * 4;
end

function GetAIBeliefScorePlayerEnhancer11(iPlayer)
	if GetITGGameTurn() < 33 then
		return 24;
	elseif GetITGGameTurn() < 67 then
		return 38;
	else
		return 51;
	end
end

function GetAIBeliefScorePlayerEnhancer12(iPlayer)
	local iFlavor = GetAIFlavour(iPlayer, "FLAVOR_EXPANSION");
	if GetITGGameTurn() < 33 then
		return 2 * iFlavor;
	elseif GetITGGameTurn() < 67 then
		return iFlavor;
	else
		return iFlavor /2;
	end
end

function GetAIBeliefScorePlayerEnhancer13(iPlayer)
	local iFlavor = GetAIFlavour(iPlayer, "FLAVOR_DEFENSE");
	return iFlavor * 5;
end

function GetAIBeliefScorePlayerEnhancer14(iPlayer)
	local iFlavor = GetAIFlavour(iPlayer, "FLAVOR_OFFENSE");
	return iFlavor * 5;
end

function GetAIBeliefScorePlayerEnhancer15(iPlayer)
	local iFlavor = GetAIFlavour(iPlayer, "FLAVOR_EXPANSION");
	return iFlavor;
end

function GetAIBeliefScorePlayerEnhancerOffense(iPlayer)
	local iFlavor = GetAIFlavour(iPlayer, "FLAVOR_OFFENSE");
	return iFlavor;
end

function GetAIBeliefScorePlayerEnhancerDefense(iPlayer)
	local iFlavor = GetAIFlavour(iPlayer, "FLAVOR_DEFENSE");
	return iFlavor;
end

function GetAIBeliefScorePlayerPantheonGoW(iPlayer)
	return GetAIFlavour(iPlayer, "FLAVOR_OFFENSE")
end


--[[		//-----------------
	// ENHANCER BELIEFS
	//-----------------
	iRtnValue += iFlavorGP * pEntry->GetGreatPersonExpendedFaith() / 10;
	iRtnValue += iFlavorDiplomacy * pEntry->GetFriendlyCityStateSpreadModifier() / 20;
	iRtnValue += iFlavorDefense * pEntry->GetCombatModifierFriendlyCities() / 4;
	iRtnValue += iFlavorOffense * pEntry->GetCombatModifierEnemyCities() / 4;

	// Chosen EARLY?
	if (iReligionsEnhancedPercent < 33)
	{
		// Good early
		iRtnValue += (2 * iFlavorExpansion) + pEntry->GetSpreadDistanceModifier();
		iRtnValue += (2 * iFlavorScience) + pEntry->GetSpreadStrengthModifier();
		iRtnValue += pEntry->GetMissionaryStrengthModifier() * 2;
		iRtnValue += (-1 * pEntry->GetMissionaryCostModifier()) * 2;

		// Poor early
		iRtnValue += pEntry->GetProphetStrengthModifier() / 4;
		iRtnValue += (-1 * pEntry->GetProphetCostModifier()) / 4;
	}

	// Chosen in the MIDDLE?
	else if (iReligionsEnhancedPercent < 66)
	{
		iRtnValue += iFlavorExpansion + pEntry->GetSpreadDistanceModifier() / 2;
		iRtnValue += iFlavorScience + pEntry->GetSpreadStrengthModifier() / 2;
		iRtnValue += pEntry->GetProphetStrengthModifier() / 2;
		iRtnValue += (-1 * pEntry->GetProphetCostModifier()) / 2;
		iRtnValue += pEntry->GetMissionaryStrengthModifier();
		iRtnValue += (-1 * pEntry->GetMissionaryCostModifier());
	}

	// Chosen LATE?
	else
	{
		// Poor late
		iRtnValue += ((2 * iFlavorExpansion) + pEntry->GetSpreadDistanceModifier()) / 4;
		iRtnValue += ((2 * iFlavorScience) + pEntry->GetSpreadStrengthModifier()) / 4;
		iRtnValue += pEntry->GetMissionaryStrengthModifier() / 2;
		iRtnValue += (-1 * pEntry->GetMissionaryCostModifier()) / 2;

		// Good late
		iRtnValue += pEntry->GetProphetStrengthModifier();
		iRtnValue += (-1 * pEntry->GetProphetCostModifier());
	}
]]

function GetAIBeliefScoreCityPantheon5(iCity, iPlayer)
	local base = 2;
	if Players[iPlayer]:IsCapitalConnectedToCity(iCity) then
		base = base * 2;
	end
	return base;
end

function GetAIBeliefScoreCityPantheon6(iCity, iPlayer)
	local base = 2;
	if Players[iPlayer]:IsCapitalConnectedToCity(iCity) then
		base = base * 2;
	end
	return base;
end

function GetAIValueScoreCityPop4(iCity, iPlayer)
	if iCity:GetPopulation() >= 4 then
		return 2;
	end
	return 1;
end
function GetAIValueScoreCityPop5(iCity, iPlayer)
	if iCity:GetPopulation() >= 5 then
		return 2;
	end
	return 1;
end

function GetAIBeliefScoreCityPantheon10(iCity, iPlayer)
	local iFlavorDefense = GetAIFlavour(iPlayer, "FLAVOR_CITY_DEFENSE");
	local iFlavorCityDefense = GetAIFlavour(iPlayer, "FLAVOR_DEFENSE");
	return math.max(iFlavorDefense,iFlavorCityDefense) / 2;
end

function GetAIBeliefScoreCityPantheon11(iCity, iPlayer)
	local iFlavorDefense = GetAIFlavour(iPlayer, "FLAVOR_WONDER");
	local iFlavorCityDefense = GetAIFlavour(iPlayer, "FLAVOR_GREAT_PEOPLE");
	return math.max(iFlavorDefense,iFlavorCityDefense) / 2;
end

function GetAIBeliefScoreCityPantheon12(iCity, iPlayer)
	local iFlavorDefense = GetAIFlavour(iPlayer, "FLAVOR_CULTURE");
	local iFlavorCityDefense = GetAIFlavour(iPlayer, "FLAVOR_GREAT_PEOPLE");
	return math.max(iFlavorDefense,iFlavorCityDefense) / 2;
end

function GetAIBeliefScoreCityPantheon13(iCity, iPlayer)
	local base = 2;
	if Players[iPlayer]:IsCapitalConnectedToCity(iCity) then
		base = base * 2;
	end
	return base;
end

function GetAIBeliefScoreCityPantheon14(iCity, iPlayer)
	local base = 1;
	if iCity:IsCoastal() then
		base = base + 3;
	end
	return base;
end

function GetAIBeliefScoreCityPantheon15(iCity, iPlayer)
	local iFlavorDefense = GetAIFlavour(iPlayer, "FLAVOR_OFFENSE");
	local iFlavorCityDefense = GetAIFlavour(iPlayer, "FLAVOR_MILITARY_TRAINING");
	return math.max(iFlavorDefense,iFlavorCityDefense) / 2;
end

function GetAIBeliefScoreCityPantheon16(iCity, iPlayer)
	local iFlavorDefense = GetAIFlavour(iPlayer, "FLAVOR_CITY_DEFENSE");
	local iFlavorCityDefense = GetAIFlavour(iPlayer, "FLAVOR_DEFENSE");
	return math.max(iFlavorDefense,iFlavorCityDefense) / 2;
end

function GetAIBeliefScoreCityPantheon17(iCity, iPlayer)
	local iFlavorDefense = GetAIFlavour(iPlayer, "FLAVOR_PRODUCTION");
	local iFlavorCityDefense = GetAIFlavour(iPlayer, "FLAVOR_HAPPINESS");
	return math.max(iFlavorDefense,iFlavorCityDefense) / 2;
end

function GetAIBeliefScoreCityPantheon18(iCity, iPlayer)
	local iFlavorDefense = GetAIFlavour(iPlayer, "FLAVOR_TILE_IMPROVEMENT");
	local iFlavorCityDefense = GetAIFlavour(iPlayer, "FLAVOR_NAVAL_TILE_IMPROVEMENT");
	return math.max(iFlavorDefense,iFlavorCityDefense) / 2;
end

function GetAIBeliefScoreCityPantheon19(iCity, iPlayer)
	local iFlavorDefense = GetAIFlavour(iPlayer, "FLAVOR_DIPLOMACY");
	local iFlavorCityDefense = GetAIFlavour(iPlayer, "FLAVOR_ESPIONAGE");
	return math.max(iFlavorDefense,iFlavorCityDefense) / 2;
end

function GetAIBeliefScoreCityPantheon20(iCity, iPlayer)
	local base = 1;
	if iCity:GetPopulation() > 3 then
		base = base * 2;
	end
	return base;
end

function GetAIBeliefScoreCityPantheon21(iCity, iPlayer)
	local base = 1;
	if iCity:GetPopulation() > 3 then
		base = base * 2;
	end
	return base;
end

function GetAIBeliefScoreCityPantheon23(iCity, iPlayer)
	local base = 1;
	if iCity:GetPopulation() > 3 then
		base = base * 2;
	end
	return base;
end

function GetAIBeliefScoreCityPantheon22(iCity, iPlayer)
	if (not gT.Players[iPlayer].AISettlerPointsManagement) or (gT.Players[iPlayer].AISettlerPointsManagement.Type == 1) then
		return 3;
	end
	local iFlavorCityDefense = GetAIFlavour(iPlayer, "FLAVOR_EXPANSION");
	return iFlavorCityDefense / 2;
end

function GetAIBeliefScoreCityFollower23(iCity, iPlayer)
	local value = 2;
	if iCity:GetPopulation() >= 8 then
		value = value * 3;
	end
	return value;
end

function GetAIBeliefScoreCityFollower24(iCity, iPlayer)
	local value = 2;
	local bClass = GameInfoTypes.BUILDINGCLASS_STONE_WORKS
	local bb = Players[iPlayer]:GetPlayerUniqueBuilding(bClass);
	if iCity:IsHasBuilding(bb) then
		value = value + 2;
	end
	bClass = GameInfoTypes.BUILDINGCLASS_WORKSHOP
	bb = Players[iPlayer]:GetPlayerUniqueBuilding(bClass);
	if iCity:IsHasBuilding(bb) then
		value = value + 2;
	end
	return value;
end

function GetAIBeliefScoreCityFollower25(iCity, iPlayer)
	if (iCity:GetPopulation() < 3) then
		return 0.5;
	end
	return 1;
end

function GetAIBeliefScoreCityFollower26(iCity, iPlayer)
	local iFlavorDefense = GetAIFlavour(iPlayer, "FLAVOR_WONDER");
	local iFlavorCityDefense = GetAIFlavour(iPlayer, "FLAVOR_GREAT_PEOPLE");
	return math.max(iFlavorDefense,iFlavorCityDefense) / 2;
end

function GetAIBeliefScoreCityFollower27(iCity, iPlayer)
	local iFlavorDefense = GetAIFlavour(iPlayer, "FLAVOR_CULTURE");
	local iFlavorCityDefense = GetAIFlavour(iPlayer, "FLAVOR_GREAT_PEOPLE");
	return math.max(iFlavorDefense,iFlavorCityDefense) / 2;
end

function GetAIBeliefScoreCityFollower28(iCity, iPlayer)
	local iFlavorDefense = GetAIFlavour(iPlayer, "FLAVOR_RELIGION");
	local iFlavorCityDefense = GetAIFlavour(iPlayer, "FLAVOR_EXPANSION");
	return math.max(iFlavorDefense,iFlavorCityDefense) / 2;
end

function GetAIBeliefScoreCityFollower29(iCity, iPlayer)
	local iFlavorDefense = GetAIFlavour(iPlayer, "FLAVOR_RELIGION");
	local iFlavorCityDefense = GetAIFlavour(iPlayer, "FLAVOR_OFFENSE");
	return math.max(iFlavorDefense,iFlavorCityDefense) / 2;
end

function GetAIBeliefScoreCityFollower30(iCity, iPlayer)
	local iFlavorDefense = GetAIFlavour(iPlayer, "FLAVOR_RELIGION");
	local iFlavorCityDefense = GetAIFlavour(iPlayer, "FLAVOR_PRODUCTION");
	return math.max(iFlavorDefense,iFlavorCityDefense) / 2;
end

function GetAIBeliefScoreCityFollower31(iCity, iPlayer)
	local iFlavorDefense = GetAIFlavour(iPlayer, "FLAVOR_RELIGION");
	local iFlavorCityDefense = GetAIFlavour(iPlayer, "FLAVOR_HAPPINESS");
	return math.max(iFlavorDefense,iFlavorCityDefense) / 2;
end

function GetAIBeliefScoreCityFollower32(iCity, iPlayer)
	return 3;
end

function GetAIBeliefScorePlayerFollower33(iPlayer)
	return 10;
end

function GetAIBeliefScoreCityFollower34(iCity, iPlayer)
	return 2.5;
end

function GetAIBeliefScoreCityFollower35(iCity, iPlayer)
	return 2.5;
end

function GetAIBeliefScorePlayerFollower36(iPlayer)
	local iFlavorDefense = GetAIFlavour(iPlayer, "FLAVOR_OFFENSE");
	local iFlavorCityDefense = GetAIFlavour(iPlayer, "FLAVOR_LEGAL");
	return math.max(iFlavorDefense,iFlavorCityDefense) * 2;
end

function GetAIBeliefScorePlayerFollower37(iPlayer)
	local iFlavorDefense = GetAIFlavour(iPlayer, "FLAVOR_OFFENSE");
	local iFlavorCityDefense = GetAIFlavour(iPlayer, "FLAVOR_GOLD");
	return math.max(iFlavorDefense,iFlavorCityDefense) * 2;
end

function GetAIBeliefScorePlayerFollower38(iPlayer)
	local iFlavorDefense = GetAIFlavour(iPlayer, "FLAVOR_OFFENSE");
	local iFlavorCityDefense = GetAIFlavour(iPlayer, "FLAVOR_CULTURE");
	return math.max(iFlavorDefense,iFlavorCityDefense) * 2;
end

function GetAIBeliefScorePlayerFollower39(iPlayer)
	local iFlavorDefense = GetAIFlavour(iPlayer, "FLAVOR_OFFENSE");
	local iFlavorCityDefense = GetAIFlavour(iPlayer, "FLAVOR_HAPPINESS");
	return math.max(iFlavorDefense,iFlavorCityDefense) * 2;
end

function GetAIBeliefScoreCityFollower40(iCity, iPlayer)
	local iFlavorDefense = GetAIFlavour(iPlayer, "FLAVOR_RELIGION");
	local iFlavorCityDefense = GetAIFlavour(iPlayer, "FLAVOR_INFRASTRUCTURE");
	return math.max(iFlavorDefense,iFlavorCityDefense) / 2;
end

function GetAIBeliefScoreCityFollower41(iCity, iPlayer)
	return 3;
end

function GetAIBeliefScoreCityFollower42(iCity, iPlayer)
	return 2.5;
end

function GetAIBeliefScoreCityFollower43(iCity, iPlayer)
	return 2.5;
end

function GetAIBeliefScoreCityFollower44(iCity, iPlayer)
	return 2.5;
end

function GetAIBeliefScoreCityFollower45(iCity, iPlayer)
	return 2.5;
end
function AIBeliefSimpleTwoBuilding(iCity, iPlayer, cType1, cType2)
	local base = 1;
	local ibuilding = Players[iPlayer]:GetPlayerUniqueBuilding(cType1)
	if ibuilding ~= -1 then
		if iCity:IsHasBuilding(ibuilding) then
			base = base + 1;
		end
	end
	local ibuilding = Players[iPlayer]:GetPlayerUniqueBuilding(cType2)
	if ibuilding ~= -1 then
		if iCity:IsHasBuilding(ibuilding) then
			base = base + 1;
		end
	end
	return base;
end
function GetAIBeliefScoreCityFollower6(iCity, iPlayer)
	return AIBeliefSimpleTwoBuilding(iCity, iPlayer, GameInfoTypes.BUILDINGCLASS_WALLS, GameInfoTypes.BUILDINGCLASS_CASTLE);
end
function GetAIBeliefScoreCityFollower7(iCity, iPlayer)
	return AIBeliefSimpleTwoBuilding(iCity, iPlayer, GameInfoTypes.BUILDINGCLASS_LIBRARY, GameInfoTypes.BUILDINGCLASS_UNIVERSITY);
end
function GetAIBeliefScoreCityFollower8(iCity, iPlayer)
	return AIBeliefSimpleTwoBuilding(iCity, iPlayer, GameInfoTypes.BUILDINGCLASS_MARKET, GameInfoTypes.BUILDINGCLASS_CARAVANSARY);
end
function GetAIBeliefScoreCityFollower9(iCity, iPlayer)
	return AIBeliefSimpleTwoBuilding(iCity, iPlayer, GameInfoTypes.BUILDINGCLASS_GRANARY, GameInfoTypes.BUILDINGCLASS_AQUEDUCT);
end
function GetAIBeliefScoreCityFollower10(iCity, iPlayer)
	return AIBeliefSimpleTwoBuilding(iCity, iPlayer, GameInfoTypes.BUILDINGCLASS_COLOSSEUM, GameInfoTypes.BUILDINGCLASS_COURTHOUSE);
end
function GetAIBeliefScoreCityFollower11(iCity, iPlayer)
	return GetAIBeliefScoreCityBuilding3MinPop(iCity, iPlayer, GameInfoTypes.BUILDINGCLASS_TEMPLE);
end
function GetAIBeliefScoreCityFollower12(iCity, iPlayer)
	return GetAIBeliefScoreCityBuilding3MinPop(iCity, iPlayer, GameInfoTypes.BUILDINGCLASS_WORKSHOP);
end
function GetAIBeliefScoreCityFollower13(iCity, iPlayer)
	return GetAIBeliefScoreCityBuilding3MinPop(iCity, iPlayer, GameInfoTypes.BUILDINGCLASS_UNIVERSITY);
end
function GetAIBeliefScoreCityBuilding3MinPop(iCity, iPlayer, cClass)
	local base = 1;
	if iCity:GetPopulation() < 3 then
		base = base / 2;
	end
	local ibuilding = Players[iPlayer]:GetPlayerUniqueBuilding(cClass)
	if ibuilding ~= -1 then
		if iCity:IsHasBuilding(ibuilding) then
			base = base * 2;
		end
	end
	return base;
end
function GetAIBeliefScoreCityFollowerFW(iCity, iPlayer)
	return AIBeliefSimpleTwoBuilding(iCity, iPlayer, GameInfoTypes.BUILDINGCLASS_TEMPLE, GameInfoTypes.BUILDINGCLASS_SHRINE)
end
function GetAIBeliefScoreCityFollower14(iCity, iPlayer)
	return GetAIBeliefScoreCityBuilding3MinPop(iCity, iPlayer, GameInfoTypes.BUILDINGCLASS_COURTHOUSE);
end
function GetAIBeliefScoreCityFollower15(iCity, iPlayer)
	return GetAIBeliefScoreCityBuilding3MinPop(iCity, iPlayer, GameInfoTypes.BUILDINGCLASS_AQUEDUCT);
end

function GetAIBeliefScoreCityFollower46(iCity, iPlayer)
	if (not gT.Players[iPlayer].AISettlerPointsManagement) or (gT.Players[iPlayer].AISettlerPointsManagement.Type == 1) then
		return 4;
	end
	local iFlavorCityDefense = GetAIFlavour(iPlayer, "FLAVOR_EXPANSION");
	return iFlavorCityDefense / 2;
end
function GetAIBeliefScorePlayerFollower48(iPlayer)
	local iRel = Players[iPlayer]:GetReligionCreatedByPlayer();
	if iRel > 0 then
		return math.max(Game.GetNumCitiesFollowing(iRel) - Players[iPlayer]:GetNumCities(), 0)
	end
	return 0;
end
function GetAIBeliefScoreCityFollowerWonderYield(iCity, iPlayer)
	return 3; --lul ai firaxis ;p
end
function GetAIBeliefHap2FromBuildingClassMinPop5(iCity, iPlayer)
	local iHappinessNeedFactor = GetAIFlavour(iPlayer, "FLAVOR_OFFENSE") * 2 + GetAIFlavour(iPlayer, "FLAVOR_HAPPINESS") - GetAIFlavour(iPlayer, "FLAVOR_DEFENSE");
	local bEb = 2;
	if iHappinessNeedFactor > 15 then
		bEb = 3;
	elseif iHappinessNeedFactor < 6 then
		bEb = 1;
	end
	bEb = bEb * 2
	if iCity:GetPopulation() >= 5 then
		bEb = bEb * 2;
	end
	return bEb;
end
function GetAIBeliefHap1FromBuildingClassMinPop3(iCity, iPlayer)
	local iHappinessNeedFactor = GetAIFlavour(iPlayer, "FLAVOR_OFFENSE") * 2 + GetAIFlavour(iPlayer, "FLAVOR_HAPPINESS") - GetAIFlavour(iPlayer, "FLAVOR_DEFENSE");
	local bEb = 2;
	if iHappinessNeedFactor > 15 then
		bEb = 3;
	elseif iHappinessNeedFactor < 6 then
		bEb = 1;
	end
	if iCity:GetPopulation() >= 3 then
		bEb = bEb * 2;
	end
	return bEb;
end
local BRBclassesRate = {}
for row in GameInfo.Belief_BuildingClassYieldChanges() do
	local iClass = GameInfoTypes[row.BuildingClassType];
	local iBelief = GameInfoTypes[row.BeliefType];
	if not BRBclassesRate[iBelief] then
		BRBclassesRate[iBelief] = {};
	end
	table.insert(BRBclassesRate[iBelief], {iClass, row.YieldChange});
end
function GetAIBeliefValuePopulation(iCity, iPlayer, iBelief)
	return math.floor(iCity:GetPopulation() / 3);
end
function GetAIValueBuildingClassBelief(iCity, iPlayer, iBelief)
	if not BRBclassesRate[iBelief] then
		return 0;
	end
	local value = 0;
	for i, data in pairs(BRBclassesRate[iBelief]) do
		local building = Players[iPlayer]:GetPlayerUniqueBuilding(data[1]);
		if building ~= -1 then
			value = value + data[2];
			if iCity:IsHasBuilding(building) then
				value = value + data[2];
			end
		end
	end
	return value;
end
function CityAIFlavourFertilityRites(iCity, iPlayer)
	return 3;
end
function CityAIFlavourMessengerOfGods(iCity, iPlayer)
	local base = 2;
	if Players[iPlayer]:IsCapitalConnectedToCity(iCity) then
		base = base * 2;
	end
	return base;
end
function CityAIFlavourSacredWaters(iCity, iPlayer)
	if iCity:Plot():IsRiver() then
		return 4;
	end
	return 0;
end
function CityAIFlavourGoddessOfLove(iCity, iPlayer)
	if iCity:GetPopulation() > 5 then
		return 4;
	end
	return 2;
end
function CityAIFlavourGodCraftsMen(iCity, iPlayer)
	if iCity:GetPopulation() > 2 then
		return 2;
	end
	return 1;
end
function GetAIValueSpecialistAnyBelief(iCity, iPlayer)
	if iCity:GetPopulation() > 7 then
		return 6;
	end
	return 2;
end
function PlotAIFlavourGodSea(iPlot, iTeam, selfID)
	if iPlot:CanHaveImprovement(GameInfoTypes.IMPROVEMENT_NEW_ITG_FISHING_BOATS) then
		local hRes = iPlot:GetResourceType();
		if (hRes ~= -1) and (not GameInfo.Resources[hRes].Migration) then
			return 2;
		end
	end
	return 0;
end
function PlotAIFlavourBasicImprovement(iPlot, iTeam, selfID)
	if iPlot:CanHaveImprovement(BeliefScoreITGTable[selfID].Improvement) then
		return BeliefScoreITGTable[selfID].HelpVal;
	end
	return 0;
end
function PlotAIFlavourBasicResource(iPlot, iTeam, selfID)
	if BeliefScoreITGTable[selfID].Resources[iPlot:GetResourceType()] then
		return BeliefScoreITGTable[selfID].HelpVal;
	end
	return 0;
end
function PlotAIFlavourNaturalWonder(iPlot, iTeam, selfID)
	if iPlot:IsNaturalWonder() then
		return BeliefScoreITGTable[selfID].HelpVal;
	end
	return 0;
end
function PlotAIFlavourDesert(iPlot, iTeam)
	if iPlot:GetTerrainType() == tDesert then
		return 1;
	end
	return 0;
end
function PlotAIFlavourAurora(iPlot, iTeam)
	if iPlot:GetTerrainType() == GameInfoTypes.TERRAIN_TUNDRA then
		if iPlot:GetFeatureType() == -1 then
			return 1;
		end
	end
	return 0;
end

function PlotAIFlavourSacredPath(iPlot, iTeam)
	if iPlot:GetFeatureType() == fJungle then
		return 1;
	end
	return 0;
end
--PlotAIFlavour
--CityAIFlavour
BeliefScoreITGTable = {
[GameInfoTypes.BELIEF_ITG_FOUNDER_1] = {PlayerAIFlavour = GetAIBeliefScorePlayerFounder1, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOUNDER_2] = {PlayerAIFlavour = GetAIBeliefScorePlayerFounder2, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOUNDER_3] = {PlayerAIFlavour = GetAIBeliefScorePlayerFounder3, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOUNDER_4] = {PlayerAIFlavour = GetAIBeliefScorePlayerFounder4, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOUNDER_5] = {PlayerAIFlavour = GetAIBeliefScorePlayerFounder5, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOUNDER_6] = {PlayerAIFlavour = GetAIBeliefScorePlayerFounder6, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOUNDER_7] = {PlayerAIFlavour = GetAIBeliefScorePlayerFounder7, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOUNDER_8] = {PlayerAIFlavour = GetAIBeliefScorePlayerFounder8, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOUNDER_9] = {PlayerAIFlavour = GetAIBeliefScorePlayerFounder9, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOUNDER_10] = {PlayerAIFlavour = GetAIBeliefScorePlayerFounder10, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOUNDER_11] = {PlayerAIFlavour = GetAIBeliefScorePlayerFounder11, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOUNDER_12] = {PlayerAIFlavour = GetAIBeliefScorePlayerFounder12, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOUNDER_13] = {PlayerAIFlavour = GetAIBeliefScorePlayerFounder13, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOUNDER_14] = {PlayerAIFlavour = GetAIBeliefScorePlayerFounder14, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOUNDER_15] = {PlayerAIFlavour = GetAIBeliefScorePlayerFounder15, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOUNDER_16] = {PlayerAIFlavour = GetAIBeliefScorePlayerFounder16, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOUNDER_17] = {PlayerAIFlavour = GetAIBeliefScorePlayerFounder17, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOUNDER_18] = {PlayerAIFlavour = GetAIBeliefScorePlayerFounder18, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOUNDER_19] = {PlayerAIFlavour = GetAIBeliefScorePlayerFounder19, BaseAmount = 17},
[GameInfoTypes.BELIEF_PEACE_LOVING] = {PlayerAIFlavour = GetAIBeliefScorePlayerFounderPeaceLove, BaseAmount = 17},
[GameInfoTypes.BELIEF_INTERFAITH_DIALOGUE] = {PlayerAIFlavour = GetAIBeliefScorePlayerFounderDialogue, BaseAmount = 17},
[GameInfoTypes.BELIEF_CEREMONIAL_BURIAL] = {PlayerAIFlavour = GetAIBeliefScorePlayerFounderPeaceLove, BaseAmount = 17},
[GameInfoTypes.BELIEF_CHURCH_PROPERTY] = {PlayerAIFlavour = GetAIBeliefScorePlayerFounderGold, BaseAmount = 17},
[GameInfoTypes.BELIEF_TITHE] = {PlayerAIFlavour = GetAIBeliefScorePlayerFounderGold, BaseAmount = 17},
[GameInfoTypes.BELIEF_PAPAL_PRIMACY] = {PlayerAIFlavour = GetAIBeliefScorePlayerFounderPrimacy, BaseAmount = 17},
[GameInfoTypes.BELIEF_PILGRIMAGE] = {PlayerAIFlavour = GetAIBeliefScorePlayerFounderFaith, BaseAmount = 17},
[GameInfoTypes.BELIEF_WORLD_CHURCH] = {PlayerAIFlavour = GetAIBeliefScorePlayerFounderCulture, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_ENHANCER_1] = {PlayerAIFlavour = GetAIBeliefScorePlayerEnhancer1, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_ENHANCER_2] = {PlayerAIFlavour = GetAIBeliefScorePlayerEnhancer2, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_ENHANCER_3] = {PlayerAIFlavour = GetAIBeliefScorePlayerEnhancer3, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_ENHANCER_4] = {PlayerAIFlavour = GetAIBeliefScorePlayerEnhancer4, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_ENHANCER_5] = {PlayerAIFlavour = GetAIBeliefScorePlayerEnhancer5, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_ENHANCER_6] = {PlayerAIFlavour = GetAIBeliefScorePlayerEnhancer6, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_ENHANCER_7] = {PlayerAIFlavour = GetAIBeliefScorePlayerEnhancer7, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_ENHANCER_8] = {PlayerAIFlavour = GetAIBeliefScorePlayerEnhancer8, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_ENHANCER_9] = {PlayerAIFlavour = GetAIBeliefScorePlayerEnhancer9, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_ENHANCER_10] = {PlayerAIFlavour = GetAIBeliefScorePlayerEnhancer10, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_ENHANCER_11] = {PlayerAIFlavour = GetAIBeliefScorePlayerEnhancer11, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_ENHANCER_12] = {PlayerAIFlavour = GetAIBeliefScorePlayerEnhancer12, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_ENHANCER_13] = {PlayerAIFlavour = GetAIBeliefScorePlayerEnhancer13, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_ENHANCER_14] = {PlayerAIFlavour = GetAIBeliefScorePlayerEnhancer14, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_ENHANCER_15] = {PlayerAIFlavour = GetAIBeliefScorePlayerEnhancer15, BaseAmount = 17},
[GameInfoTypes.BELIEF_JUST_WAR] = {PlayerAIFlavour = GetAIBeliefScorePlayerEnhancerOffense, BaseAmount = 17},
[GameInfoTypes.BELIEF_DEFENDER_FAITH] = {PlayerAIFlavour = GetAIBeliefScorePlayerEnhancerDefense, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITINERANT_PREACHERS] = {PlayerAIFlavour = GetAIBeliefScorePlayerFounderRelTexts, BaseAmount = 17},
[GameInfoTypes.BELIEF_RELIGIOUS_TEXTS] = {PlayerAIFlavour = GetAIBeliefScorePlayerFounderRelTexts, BaseAmount = 17},
[GameInfoTypes.BELIEF_MISSIONARY_ZEAL] = {PlayerAIFlavour = GetAIBeliefScorePlayerFounderFaith, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_PANTHEON_1] =  {CityAIFlavour = GetAIValueBuildingClassBelief, BaseAmount = 8},
[GameInfoTypes.BELIEF_ITG_PANTHEON_2] =  {CityAIFlavour = GetAIValueScoreCityPop4, BaseAmount = 8},
[GameInfoTypes.BELIEF_ITG_PANTHEON_3] =  {CityAIFlavour = GetAIValueScoreCityPop5, BaseAmount = 8},
[GameInfoTypes.BELIEF_ITG_PANTHEON_4] = {PlotAIFlavour = PlotAIFlavourBasicResource, Resources = {[GameInfoTypes.RESOURCE_BISON] = true, [GameInfoTypes.RESOURCE_DEER] = true, [GameInfoTypes.RESOURCE_FUR] = true}, HelpVal = 1, BaseAmount = 8},
[GameInfoTypes.BELIEF_ITG_PANTHEON_5] =  {CityAIFlavour = GetAIBeliefScoreCityPantheon5, BaseAmount = 8},
[GameInfoTypes.BELIEF_ITG_PANTHEON_6] =  {CityAIFlavour = GetAIBeliefScoreCityPantheon6, BaseAmount = 8},
[GameInfoTypes.BELIEF_ITG_PANTHEON_7] =  {CityAIFlavour = GetAIValueBuildingClassBelief, BaseAmount = 8},
[GameInfoTypes.BELIEF_ITG_PANTHEON_8] =  {CityAIFlavour = GetAIValueBuildingClassBelief, BaseAmount = 8},
[GameInfoTypes.BELIEF_ITG_PANTHEON_9] =  {CityAIFlavour = GetAIValueScoreCityPop4, BaseAmount = 8},
[GameInfoTypes.BELIEF_ITG_PANTHEON_10] =  {CityAIFlavour = GetAIBeliefScoreCityPantheon10, BaseAmount = 8},
[GameInfoTypes.BELIEF_ITG_PANTHEON_11] =  {CityAIFlavour = GetAIBeliefScoreCityPantheon11, BaseAmount = 8},
[GameInfoTypes.BELIEF_ITG_PANTHEON_12] =  {CityAIFlavour = GetAIBeliefScoreCityPantheon12, BaseAmount = 8},
[GameInfoTypes.BELIEF_ITG_PANTHEON_13] =  {CityAIFlavour = GetAIBeliefScoreCityPantheon13, BaseAmount = 8},
[GameInfoTypes.BELIEF_ITG_PANTHEON_14] =  {CityAIFlavour = GetAIBeliefScoreCityPantheon14, BaseAmount = 8},
[GameInfoTypes.BELIEF_ITG_PANTHEON_15] =  {CityAIFlavour = GetAIBeliefScoreCityPantheon15, BaseAmount = 8},
[GameInfoTypes.BELIEF_ITG_PANTHEON_16] =  {CityAIFlavour = GetAIBeliefScoreCityPantheon16, BaseAmount = 8},
[GameInfoTypes.BELIEF_ITG_PANTHEON_17] =  {CityAIFlavour = GetAIBeliefScoreCityPantheon17, BaseAmount = 8},
[GameInfoTypes.BELIEF_ITG_PANTHEON_18] =  {CityAIFlavour = GetAIBeliefScoreCityPantheon18, BaseAmount = 8},
[GameInfoTypes.BELIEF_ITG_PANTHEON_19] =  {CityAIFlavour = GetAIBeliefScoreCityPantheon19, BaseAmount = 8},
[GameInfoTypes.BELIEF_ITG_PANTHEON_20] =  {CityAIFlavour = GetAIBeliefScoreCityPantheon20, BaseAmount = 8},
[GameInfoTypes.BELIEF_ITG_PANTHEON_21] =  {CityAIFlavour = GetAIBeliefScoreCityPantheon21, BaseAmount = 8},
[GameInfoTypes.BELIEF_ITG_PANTHEON_22] = {CityAIFlavour = GetAIBeliefScoreCityPantheon22, BaseAmount = 8},
[GameInfoTypes.BELIEF_ITG_PANTHEON_23] = {CityAIFlavour = GetAIBeliefScoreCityPantheon23, BaseAmount = 8},
[GameInfoTypes.BELIEF_FERTILITY_RITES] = {CityAIFlavour = CityAIFlavourFertilityRites, BaseAmount = 8},
[GameInfoTypes.BELIEF_GOD_CRAFTSMEN] = {CityAIFlavour = CityAIFlavourGodCraftsMen, BaseAmount = 8},
[GameInfoTypes.BELIEF_GOD_SEA] = {PlotAIFlavour = PlotAIFlavourGodSea, BaseAmount = 8},
[GameInfoTypes.BELIEF_OPEN_SKY] = {PlotAIFlavour = PlotAIFlavourBasicImprovement, HelpVal = 1, Improvement = GameInfoTypes.IMPROVEMENT_PASTURE, BaseAmount = 8},
[GameInfoTypes.BELIEF_MESSENGER_GODS] = {CityAIFlavour = CityAIFlavourMessengerOfGods, BaseAmount = 8},
[GameInfoTypes.BELIEF_ONE_WITH_NATURE] = {PlotAIFlavour = PlotAIFlavourNaturalWonder, HelpVal = 4, BaseAmount = 8},
[GameInfoTypes.BELIEF_FORMAL_LITURGY] = {PlotAIFlavour = PlotAIFlavourBasicResource, Resources = {[GameInfoTypes.RESOURCE_GOLD] = true, [GameInfoTypes.RESOURCE_SILVER] = true}, HelpVal = 2, BaseAmount = 8},
[GameInfoTypes.BELIEF_STONE_CIRCLES] = {PlotAIFlavour = PlotAIFlavourBasicImprovement, HelpVal = 2, Improvement = GameInfoTypes.IMPROVEMENT_QUARRY, BaseAmount = 8},
[GameInfoTypes.BELIEF_GOD_WAR] = {PlayerAIFlavour = GetAIBeliefScorePlayerPantheonGoW, BaseAmount = 8},
[GameInfoTypes.BELIEF_SACRED_WATERS] = {CityAIFlavour = CityAIFlavourSacredWaters, BaseAmount = 8},
[GameInfoTypes.BELIEF_GODDESS_LOVE] = {CityAIFlavour = CityAIFlavourGoddessOfLove, BaseAmount = 8},
[GameInfoTypes.BELIEF_RELIGIOUS_SETTLEMENTS] = {CityAIFlavour = CityAIFlavourFertilityRites, BaseAmount = 8},
[GameInfoTypes.BELIEF_GOD_FESTIVALS] = {PlotAIFlavour = PlotAIFlavourBasicResource, Resources = {[GameInfoTypes.RESOURCE_WINE] = true, [GameInfoTypes.RESOURCE_INCENSE] = true}, HelpVal = 2, BaseAmount = 8},
[GameInfoTypes.BELIEF_ORAL_TRADITION] = {PlotAIFlavour = PlotAIFlavourBasicImprovement, HelpVal = 1, Improvement = GameInfoTypes.IMPROVEMENT_PLANTATION, BaseAmount = 8},
[GameInfoTypes.BELIEF_DESERT_FOLKLORE] = {PlotAIFlavour = PlotAIFlavourDesert, BaseAmount = 8},
[GameInfoTypes.BELIEF_SACRED_PATH] = {PlotAIFlavour = PlotAIFlavourSacredPath, BaseAmount = 8},
[GameInfoTypes.BELIEF_GODDESS_STRATEGY] = {CityAIFlavour = CityAIFlavourFertilityRites, BaseAmount = 8},
[GameInfoTypes.BELIEF_FAITH_HEALERS] = {CityAIFlavour = CityAIFlavourFertilityRites, BaseAmount = 8},
[GameInfoTypes.BELIEF_DANCE_AURORA] = {PlotAIFlavour = PlotAIFlavourAurora, BaseAmount = 8},
[GameInfoTypes.BELIEF_GOD_KING] = {CityAIFlavour = GetAIValueBuildingClassBelief, BaseAmount = 8},
[GameInfoTypes.BELIEF_TEARS_OF_GODS] = {PlotAIFlavour = PlotAIFlavourBasicResource, Resources = {[GameInfoTypes.RESOURCE_PEARLS] = true, [GameInfoTypes.RESOURCE_GEMS] = true}, HelpVal = 2, BaseAmount = 8},
[GameInfoTypes.BELIEF_EARTH_MOTHER] = {PlotAIFlavour = PlotAIFlavourBasicResource, Resources = {[rIron] = true, [GameInfoTypes.RESOURCE_SALT] = true, [GameInfoTypes.RESOURCE_COPPER] = true}, HelpVal = 1, BaseAmount = 8},
[GameInfoTypes.BELIEF_SUN_GOD] = {PlotAIFlavour = PlotAIFlavourBasicResource, Resources = {[GameInfoTypes.RESOURCE_WHEAT] = true, [GameInfoTypes.RESOURCE_CITRUS] = true, [GameInfoTypes.RESOURCE_BANANA] = true}, HelpVal = 1, BaseAmount = 8},
[GameInfoTypes.BELIEF_GODDESS_HUNT] = {PlotAIFlavour = PlotAIFlavourBasicImprovement, HelpVal = 1, Improvement = GameInfoTypes.IMPROVEMENT_CAMP, BaseAmount = 8},
 
[GameInfoTypes.BELIEF_ITG_FOLLOWER_1] = {CityAIFlavour = GetAIValueSpecialistAnyBelief, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOLLOWER_2] = {CityAIFlavour = GetAIValueSpecialistAnyBelief, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOLLOWER_3] = {CityAIFlavour = GetAIValueSpecialistAnyBelief, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOLLOWER_4] = {CityAIFlavour = GetAIValueSpecialistAnyBelief, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOLLOWER_5] = {CityAIFlavour = GetAIValueSpecialistAnyBelief, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOLLOWER_6] = {CityAIFlavour = GetAIBeliefScoreCityFollower6, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOLLOWER_7] = {CityAIFlavour = GetAIBeliefScoreCityFollower7, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOLLOWER_8] = {CityAIFlavour = GetAIBeliefScoreCityFollower8, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOLLOWER_9] = {CityAIFlavour = GetAIBeliefScoreCityFollower9, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOLLOWER_10] = {CityAIFlavour = GetAIValueBuildingClassBelief, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOLLOWER_10] = {CityAIFlavour = GetAIBeliefScoreCityFollower10, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOLLOWER_11] = {CityAIFlavour = GetAIBeliefScoreCityFollower11, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOLLOWER_12] = {CityAIFlavour = GetAIBeliefScoreCityFollower12, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOLLOWER_13] = {CityAIFlavour = GetAIBeliefScoreCityFollower13, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOLLOWER_14] = {CityAIFlavour = GetAIBeliefScoreCityFollower14, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOLLOWER_15] = {CityAIFlavour = GetAIBeliefScoreCityFollower15, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOLLOWER_16] = {CityAIFlavour = GetAIBeliefHap2FromBuildingClassMinPop5, BaseAmount = 13}, -- requires harbors/naval
[GameInfoTypes.BELIEF_ITG_FOLLOWER_17] = {CityAIFlavour = GetAIBeliefHap2FromBuildingClassMinPop5, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOLLOWER_18] = {CityAIFlavour = GetAIBeliefScoreCityFollowerWonderYield, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOLLOWER_19] = {CityAIFlavour = GetAIBeliefScoreCityFollowerWonderYield, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOLLOWER_20] = {CityAIFlavour = GetAIBeliefScoreCityFollowerWonderYield, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOLLOWER_21] = {CityAIFlavour = GetAIBeliefScoreCityFollowerWonderYield, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOLLOWER_22] = {CityAIFlavour = GetAIBeliefScoreCityFollowerWonderYield, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOLLOWER_23] = {CityAIFlavour = GetAIBeliefScoreCityFollower23, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOLLOWER_24] = {CityAIFlavour = GetAIBeliefScoreCityFollower24, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOLLOWER_25] = {CityAIFlavour = GetAIBeliefScoreCityFollower25, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOLLOWER_26] = {CityAIFlavour = GetAIBeliefScoreCityFollower26, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOLLOWER_27] = {CityAIFlavour = GetAIBeliefScoreCityFollower27, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOLLOWER_28] = {CityAIFlavour = GetAIBeliefScoreCityFollower28, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOLLOWER_29] = {CityAIFlavour = GetAIBeliefScoreCityFollower29, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOLLOWER_30] = {CityAIFlavour = GetAIBeliefScoreCityFollower30, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOLLOWER_31] = {CityAIFlavour = GetAIBeliefScoreCityFollower31, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOLLOWER_32] = {CityAIFlavour = GetAIBeliefScoreCityFollower32, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOLLOWER_33] = {PlayerAIFlavour = GetAIBeliefScorePlayerFollower33, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOLLOWER_34] = {CityAIFlavour = GetAIBeliefScoreCityFollower34, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOLLOWER_35] = {CityAIFlavour = GetAIBeliefScoreCityFollower35, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOLLOWER_36] = {PlayerAIFlavour = GetAIBeliefScorePlayerFollower36, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOLLOWER_37] = {PlayerAIFlavour = GetAIBeliefScorePlayerFollower37, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOLLOWER_38] = {PlayerAIFlavour = GetAIBeliefScorePlayerFollower38, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOLLOWER_39] = {PlayerAIFlavour = GetAIBeliefScorePlayerFollower39, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOLLOWER_40] = {CityAIFlavour = GetAIBeliefScoreCityFollower40, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOLLOWER_41] = {CityAIFlavour = GetAIBeliefScoreCityFollower41, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOLLOWER_42] = {CityAIFlavour = GetAIBeliefScoreCityFollower42, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOLLOWER_43] = {CityAIFlavour = GetAIBeliefScoreCityFollower43, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOLLOWER_44] = {CityAIFlavour = GetAIBeliefScoreCityFollower44, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOLLOWER_45] = {CityAIFlavour = GetAIBeliefScoreCityFollower45, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOLLOWER_46] = {CityAIFlavour = GetAIBeliefScoreCityFollower46, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOLLOWER_47] = {CityAIFlavour = GetAIValueSpecialistAnyBelief, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOLLOWER_48] = {PlayerAIFlavour = GetAIBeliefScorePlayerFollower48, BaseAmount = 17},
[GameInfoTypes.BELIEF_DIVINE_INSPIRATION] = {CityAIFlavour = GetAIBeliefScoreCityFollowerWonderYield, BaseAmount = 17},
[GameInfoTypes.BELIEF_ASCETISM] = {CityAIFlavour = GetAIBeliefHap1FromBuildingClassMinPop3, BaseAmount = 17},
[GameInfoTypes.BELIEF_PEACE_GARDENS] = {CityAIFlavour = GetAIBeliefHap2FromBuildingClassMinPop5, BaseAmount = 17},
[GameInfoTypes.BELIEF_RELIGIOUS_CENTER] = {CityAIFlavour = GetAIBeliefHap2FromBuildingClassMinPop5, BaseAmount = 17},
[GameInfoTypes.BELIEF_ANCESTOR_WORSHIP] = {CityAIFlavour = GetAIValueBuildingClassBelief, BaseAmount = 17},
[GameInfoTypes.BELIEF_FEED_WORLD] = {CityAIFlavour = GetAIValueBuildingClassBelief, BaseAmount = 17},
[GameInfoTypes.BELIEF_CHORAL_MUSIC] = {CityAIFlavour = GetAIValueBuildingClassBelief, BaseAmount = 17},
[GameInfoTypes.BELIEF_LITURGICAL_DRAMA] = {CityAIFlavour = GetAIValueBuildingClassBelief, BaseAmount = 17},
[GameInfoTypes.BELIEF_GURUSHIP] = {CityAIFlavour = GetAIValueSpecialistAnyBelief, BaseAmount = 17},
[GameInfoTypes.BELIEF_RELIGIOUS_COMMUNITY] = {CityAIFlavour = GetAIBeliefValuePopulation, BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_FOUNDER_RELIGIOUS_DECLINE] = {BaseAmount = 17},
[GameInfoTypes.BELIEF_ITG_ENHANCER_RELIGIOUS_DECLINE] = {BaseAmount = 17},
}

for row in GameInfo.Belief_BuildingClassYieldChanges() do
	local iBelief = GameInfo.Beliefs[row.BeliefType].ID;
	if BeliefScoreITGTable[iBelief] then
		if not BeliefScoreITGTable[iBelief].BuildingClassDep then
			BeliefScoreITGTable[iBelief].BuildingClassDep = {};
		end
		table.insert(BeliefScoreITGTable[iBelief].BuildingClassDep, GameInfo.BuildingClasses[row.BuildingClassType].ID)
	end
end
for row in GameInfo.Belief_BuildingClassHappiness() do
	local iBelief = GameInfo.Beliefs[row.BeliefType].ID;
	if BeliefScoreITGTable[iBelief] then
		if not BeliefScoreITGTable[iBelief].BuildingClassDep then
			BeliefScoreITGTable[iBelief].BuildingClassDep = {};
		end
		table.insert(BeliefScoreITGTable[iBelief].BuildingClassDep, GameInfo.BuildingClasses[row.BuildingClassType].ID)
	end
end
for row in GameInfo.Belief_ResourceYieldChanges() do
	local iBelief = GameInfo.Beliefs[row.BeliefType].ID;
	if BeliefScoreITGTable[iBelief] then
		if not BeliefScoreITGTable[iBelief].ResourcesDep then
			BeliefScoreITGTable[iBelief].ResourcesDep = {};
		end
		table.insert(BeliefScoreITGTable[iBelief].ResourcesDep, GameInfo.Resources[row.ResourceType].ID)
	end
end
for row in GameInfo.Belief_FeatureYieldChanges() do
	local iBelief = GameInfo.Beliefs[row.BeliefType].ID;
	if BeliefScoreITGTable[iBelief] then
		BeliefScoreITGTable[iBelief].FeatureDep = GameInfo.Features[row.FeatureType].ID;
	end
end
for row in GameInfo.Belief_TerrainYieldChanges() do
	local iBelief = GameInfo.Beliefs[row.BeliefType].ID;
	if BeliefScoreITGTable[iBelief] then
		BeliefScoreITGTable[iBelief].TerritoryDep = GameInfo.Terrains[row.TerrainType].ID;
	end
end
for row in GameInfo.Belief_ImprovementYieldChanges() do
	local iBelief = GameInfo.Beliefs[row.BeliefType].ID;
	if BeliefScoreITGTable[iBelief] then
		BeliefScoreITGTable[iBelief].ImproDep = GameInfo.Improvements[row.ImprovementType].ID;
	end
end

function DoBanBeliefsIfNoValidResources()
	for iBelief, data in pairs(BeliefScoreITGTable) do
		if data.ResourcesDep then
			local banBelief = true;
			for i, iResource in pairs(data.ResourcesDep) do
				if GetResourcesPresentOnMap(iResource, true) then
					banBelief = false;
					break;
				end
			end
			if banBelief then
				gT.Globals.BannedBeliefs[iBelief] = true;
			end
		end
	end
	-- this one stays, because iron should not be enough:
	if (not GetResourcesPresentOnMap(GameInfoTypes.RESOURCE_SALT, true)) and (not GetResourcesPresentOnMap(GameInfoTypes.RESOURCE_COPPER, true)) then
		gT.Globals.BannedBeliefs[GameInfoTypes.BELIEF_EARTH_MOTHER] = true;
	end
end

function IsValidBeliefTerritory(iPlayer, iTerrain)
	for iCity in Players[iPlayer]:Cities() do
		if iCity:Plot():GetTerrainType() == iTerrain then
			return true;
		end
		for j = 0, 5 do
			local jPlot = Map.PlotDirection(iCity:GetX(), iCity:GetY(), j);
			if jPlot and (jPlot:GetTerrainType() == iTerrain) then
				return true;
			end
		end
	end
	return false;
end

function IsValidBeliefBuildingClass(iPlayer, bClasses)
	for i, buildingClass in pairs(bClasses) do
		local bType = Players[iPlayer]:GetPlayerUniqueBuilding(buildingClass)
		if bType ~= -1 then
			if Players[iPlayer]:CountNumBuildings(bType) > 0 then
				return true;
			end
			if Players[iPlayer]:CanConstruct(bType, 1, 1, 1) then
				return true;
			end
		end
	end
	return false;
end

function IsValidBeliefResources(iPlayer, resources)
	for i, resourceID in pairs(resources) do
		for index, h in pairs(GetResourcesPresentOnMap(resourceID)) do
			local iPlot = Map.GetPlotByIndex(index);
			if iPlot:GetOwner() == iPlayer then
				if iPlot:GetResourceType(iTeam) == resourceID then
					return true;
				end
			end
		end
	end
	return false;
end

function IsValidBeliefFeature(iPlayer, iFeature)
	for iCity in Players[iPlayer]:Cities() do
		for j = 0, 5 do
			local jPlot = Map.PlotDirection(iCity:GetX(), iCity:GetY(), j);
			if jPlot and (jPlot:GetFeatureType() == iFeature) then
				return true;
			end
		end
	end
	return false;
end

function IsValidBeliefImprovement(iPlayer, iImpro)
	for iCity in Players[iPlayer]:Cities() do
		if iCity:CountNumImprovedPlots(iImpro) > 0 then
			return true;
		end
	end
	return false;
end

function IsBeliefPrioritizedForPlayer(eBelief, iPlayer)
	if BeliefScoreITGTable[eBelief] then
		if BeliefScoreITGTable[eBelief].TerritoryDep then
			if not IsValidBeliefTerritory(iPlayer, BeliefScoreITGTable[eBelief].TerritoryDep) then
				return false;
			end
		end
		if BeliefScoreITGTable[eBelief].BuildingClassDep then
			if not IsValidBeliefBuildingClass(iPlayer, BeliefScoreITGTable[eBelief].BuildingClassDep) then
				return false;
			end
		end
		if BeliefScoreITGTable[eBelief].ResourcesDep then
			if not IsValidBeliefResources(iPlayer, BeliefScoreITGTable[eBelief].ResourcesDep) then
				return false;
			end
		end
		if BeliefScoreITGTable[eBelief].FeatureDep then
			if not IsValidBeliefFeature(iPlayer, BeliefScoreITGTable[eBelief].FeatureDep) then
				return false;
			end
		end
		if BeliefScoreITGTable[eBelief].ImproDep then
			if not IsValidBeliefImprovement(iPlayer, BeliefScoreITGTable[eBelief].ImproDep) then
				return false;
			end
		end
	else
		print("Belief not on the BeliefScoreITGTable", eBelief);
	end
	return true;
end