function DoAILogicForAbilitiesAndPoints(iPlayer, bMajor)
	if not Players[iPlayer]:IsHuman() then
		local tTurn = GetITGGameTurn();
		if gT.Players[iPlayer].FestivalPoints > 0 then
			local hTab = Shuffle(GetPlotsValidForFestival(iPlayer))
			local ithelp = gT.Players[iPlayer].FestivalPoints
			for i = 1, ithelp do 
				if hTab[i] then
					DoStartFestival(iPlayer, hTab[i]:GetPlotCity()) -- random ::::::
				else
					break;
				end
			end
		end
		
		for i, actiondata in pairs(gT.Players[iPlayer].QueueActionsRealEndTurn) do
			if actiondata[1] == "AIReplaceSocial" then
				gT.Players[iPlayer].LHRechosenCB = gT.Players[iPlayer].LHRechosenCB + 1;
				RemoveCultureBonusFromPlayer(iPlayer, actiondata[2])
				AddCultureBonusToPlayer(iPlayer, actiondata[3], 2)
			elseif actiondata[1] == "TemplarBelief" then
				AIPlayerChooseTemplarBelief(iPlayer, actiondata[2])
			elseif actiondata[1] == "Inspiration" then
				AIPlayerChooseInspiration(iPlayer, actiondata[2], actiondata[3])
			elseif actiondata[1] == "LeagueResolutionInitial" then
				DoAIChooseInitialResolution(iPlayer, actiondata[2])
			elseif actiondata[1] == "LeagueForcedResolution" then
				if (not actiondata[3]) or (actiondata[3] == GetITGGameTurn()) then
					DoAIChooseSpecialResolution(iPlayer, actiondata[2])
				end
			elseif actiondata[1] == "LeagueInvite" then
				DoAIAnswerInviteToLeague(iPlayer, actiondata[2])
			elseif actiondata[1] == "LeagueSeekerTask" then
				DoAIGuessTheSeekingTask(iPlayer, actiondata[2])
			end
		end
		if gT.Players[iPlayer].AIchooseSpecialUU then
			AIChooseSpecialUU(iPlayer, gT.Players[iPlayer].AIchooseSpecialUU)
		end
		if bMajor and (GetITGGameTurn() == 100) then
			Do100AITurn(iPlayer)
		end
		HandleAIGreatImprovementPoints(iPlayer)
		HandleSettlerPointsAI(iPlayer)
		if gT.Players[iPlayer].FreeColonies > 0 then
			DoAIConsiderSpendingColony(iPlayer)
		end
		for gMc, hMc in pairs(gT.Manufactories) do
			if #hMc.ToChoose > 0 then
				if hMc.Player == iPlayer then
					DoAIChooseTraitForManufactory(gMc, iPlayer, hMc.ToChoose[1])
				end
			end
		end
		if gT.Players[iPlayer].NumMilitaryEngineers > 0 then
			DoAILogicForMilitaryEngineers(iPlayer)
		end
		if gT.Players[iPlayer].IsPickingIdeology then
			DoAIPickNewIdeology(iPlayer)
		end
		for scriptID, sth in pairs(gT.Players[iPlayer].AIScriptQueue) do
			DoTriggerAIScript(iPlayer, scriptID, sth)
		end
		if not Players[iPlayer]:IsMinorCiv() then
			DoAIScriptDoWRebels(iPlayer)
		end
		if gT.Players[iPlayer].InstantWar then
			if gT.Players[iPlayer].InstantWar + 12 <= GetITGGameTurn() then
				if Teams[Players[iPlayer]:GetTeam()]:GetAtWarCount(true) > 0 then
					TriggerInstantWar(iPlayer)
				end
			end
		end
		DoAIBlockTooManyNavalInSmallAquens(iPlayer)
		if gT.Players[iPlayer].BatteringSupport > 0 then
			AIAddsSupportProm(iPlayer, GameInfoTypes.PROMOTION_ITG_BATTERING_RAM_SUPPORT, gT.Players[iPlayer].BatteringSupport)
		end
		if gT.Players[iPlayer].SiegeTowerSupport > 0 then
			AIAddsSupportProm(iPlayer, GameInfoTypes.PROMOTION_ITG_SIEGE_TOWER_SUPPORT, gT.Players[iPlayer].SiegeTowerSupport)
		end
		HandleAILeagueResolutions(iPlayer)
		if bMajor then
			AIDoMakeUsageOfInnovationAbilities(iPlayer)
			AIAnswersDiploNotes(iPlayer) -- before legal
			AIHandlePalacePoints(iPlayer)
			AIHandleUniqueImprovementsCharges(iPlayer)
			if tTurn >= gT.Players[iPlayer].AIPalaceScript then
				DecideIfPalaceBuildingHasSense(iPlayer)
			end
			if tTurn >= (gT.Players[iPlayer].AIGovernorsScript or 1) then
				TakeALookOnAIGovernors(iPlayer)
			end
			if tTurn == 91 then
				DoTriggerAIWonderConstructScript(iPlayer)
			end
			AICityStateProjectsHelpFunction(iPlayer)
			DecideWhatToDoWithLegalPowerAI(iPlayer)
			AISpecialControlPlotsWarScript(iPlayer)

			if gT.Globals.StockActive then
				if CanPlayerEnterStockExchange(iPlayer) then
					DoMakeAIInvestments(iPlayer)
				end
			end
			if tTurn % 5 == 0 then
				Players[iPlayer]:SetITGUnhappyTags(IsAIConsideringTheirCivUnhappy(iPlayer))
			end
		end
		if gT.Players[iPlayer].AIPanicScript then
			if gT.Players[iPlayer].AIPanicScript <= GetITGGameTurn() then
				gT.Players[iPlayer].AIPanicScript = nil
			end
		end
	end
end

function TryToSpendExtraVotesInLeague(iPlayer, leagueNID, aTab)
	for i, actionID in pairs(aTab) do
		if (gT.Leagues[leagueNID].Members[iPlayer].LastAction or -1) <= GetITGGameTurn() then
			if CanBeProposedRightNow(leagueNID, actionID, 1, iPlayer) then
				PlayerProposeChangeToLeague(leagueNID, actionID, iPlayer, nil, nil);
				break;
			end
		else
			break;
		end
	end
end

function Do100AITurn(iPlayer)
	for leagueNID, sth in pairs(gT.Leagues) do
		if sth.Members[iPlayer] then
			if not sth.SpecialProposalTag then
				TryToSpendExtraVotesInLeague(iPlayer, leagueNID, {33, 30, 29, 64})
			end
		end
	end
end

function DecideIfPalaceBuildingHasSense(iPlayer)
	local val;
	local cTurn = GetITGGameTurn();
	local nextT = 10;
	if Players[iPlayer]:GetNumCities() < 2 then
		val = 2;
		nextT = LastRandom(20,25);
	elseif LastRandom(5 , 9) <= GetAIFlavour(iPlayer, "FLAVOR_AUTHORITY") then
		nextT = LastRandom(12, 15);
	elseif HasCSMission(iPlayer, 21) then
		nextT = LastRandom(6, 10);
	elseif cTurn >= LastRandom(75, 95) then
		nextT = 50; --over;
	else
		local bestother = 0;
		local youdeh = gT.Players[iPlayer].Authority;
		local hTeam = Players[iPlayer]:GetTeam();
		for g, j in pairs(gT.Players) do
			if not Players[g]:IsMinorCiv() then
				if g ~= iPlayer then
					if Teams[hTeam]:IsHasMet(Players[g]:GetTeam()) then
						bestother = math.max(bestother, j.Authority)
					end
				end
			end
		end
		local difference = math.abs(youdeh - bestother)
		local totCities = Players[iPlayer]:GetNumCities();
		if (youdeh > bestother) and (difference > 25) then
			if totCities > 5 then
				val = 1;
			else
				val = 2;
			end
			nextT = LastRandom(7,12);
		elseif (youdeh > bestother) and (difference > 15) then
			val = 1;
			nextT = LastRandom(7,10);
		else
			local numCitiesDoingLousyStuff = 0;
			if IsDuringMeaningfulWar(iPlayer) then
				val = 2;
				nextT = LastRandom(8,12)
			else
				for iCity in Players[iPlayer]:Cities() do
					if iCity:GetProductionProcess() ~= -1 then
						numCitiesDoingLousyStuff = numCitiesDoingLousyStuff + 1;
					end
				end
				if difference > 25 then
					if numCitiesDoingLousyStuff < totCities/2 then
						if numCitiesDoingLousyStuff >=2 then
							val = 1
						else
							val = 2
						end 
					end
					nextT = LastRandom(7, 15)
				elseif difference > 15 then
					if numCitiesDoingLousyStuff < totCities/3 then
						val = 1;
					end
					nextT = LastRandom(11, 15)
				end
			end
		end
	end
	gT.Players[iPlayer].AIPalaceBlock = val;
	gT.Players[iPlayer].AIPalaceScript = cTurn + nextT
end

function IsDuringMeaningfulWar(iPlayer)
	local tCity = GetOriginalCapitalOfPlayer(iPlayer);
	local AIteam = Teams[Players[iPlayer]:GetTeam()];
	if tCity and (tCity:GetOwner() ~= iPlayer) and AIteam:IsAtWar(Players[tCity:GetOwner()]) then
		return true
	end
	if (gT.Players[iPlayer].LastTurnCityLost or -10) + 3 >= GetITGGameTurn() then
		if not ((gT.Players[iPlayer].LastTurnCityCaptured or -10) + 6 >= GetITGGameTurn()) then
			return true;
		end
		if Players[iPlayer]:GetNumCities() < 3 then
			return true;
		end
	end
	if LastRandom(1,3) == 2 then
		for i, iHuman in pairs(gT.Globals.HumanPlayers) do
			if AIteam:IsAtWar(Players[iHuman]:GetTeam()) then
				return true;
			end
		end
	end
	return false;
end