local leaderFlavoursDef = {}
local customFlavours = {
["FLAVOR_LEGAL"] = true,
["FLAVOR_AUTHORITY"] = true,
["FLAVOR_PRESENCE"] = true,
["FLAVOR_DISRUPTIVE"] = true, -- this is related to abilities that affect negatively other players
}

function DoInitAIFlavours()
	gT.AIFlavours = {}
	local bRandomPersonalities = PreGame.GetGameOption("GAMEOPTION_RANDOM_PERSONALITIES") == 1;
	for i,v in pairs(Players) do
		if v:IsEverAlive() then
			if not v:IsBarbarian() then
				if not v:IsMinorCiv() then
					gT.AIFlavours[i] = {}
					local lType = v:GetLeaderType();
					for sFlavor, h in pairs(customFlavours) do
						if leaderFlavoursDef[lType] and leaderFlavoursDef[lType][sFlavor] then
							if bRandomPersonalities then
								gT.AIFlavours[i][sFlavor] = math.max(0, leaderFlavoursDef[lType][sFlavor] + LastRandom(-4, 4));
							else
								gT.AIFlavours[i][sFlavor] = leaderFlavoursDef[lType][sFlavor]
							end
						else
							gT.AIFlavours[i][sFlavor] = LastRandom(1, 9);
						end
					end
				end
			end
		end
	end
end

function GetAIFlavour(iPlayer, sFlavor)
	if customFlavours[sFlavor] then
		if gT.AIFlavours[iPlayer] then
			return gT.AIFlavours[iPlayer][sFlavor]
		else
			print("CS tried get AI flavour?", iPlayer, sFlavor)
			return 5;
		end
	else
		return Players[iPlayer]:GetFlavourValue(sFlavor)
	end
end