local iGoldGiftLarge = GameDefines["MINOR_GOLD_GIFT_LARGE"];
local iGoldGiftMedium = GameDefines["MINOR_GOLD_GIFT_MEDIUM"];
local iGoldGiftSmall = GameDefines["MINOR_GOLD_GIFT_SMALL"];
local medwonder9 = GameInfoTypes.BUILDING_ITG_NEW_MEDIEVAL_WONDER_9;
local tPasssageAllWater = GameInfoTypes.TECH_ITG_WATER_ALL_PASSAGE;
local dWonderProcess = GameInfoTypes.PROCESS_ITG_WONDER;
local bAutoAIHandicap = (PreGame.GetGameOption("GAMEOPTION_ITG_AUTO_AI_HANDICAP") == 1)

function AIAutoHandicap(gTurn)
	if not bAutoAIHandicap then
		return;
	end
	if gTurn < 2 then
		return;
	end
	if gTurn % 5 ~= 0 then
		return;
	end
	local iPlayer;
	for i, iHuman in pairs(gT.Globals.HumanPlayers) do
		if Players[iHuman]:IsAlive() then
			if Players[iHuman]:IsHuman() then
				if iPlayer then
					return;
				end
				iPlayer = iHuman;
			end
		end
	end
	if not iPlayer then
		return;
	end
	-- :] okay let's go
	local aFood = gT.Handicap.RefFood;
	local aProd = gT.Handicap.RefGold;
	local aGold = gT.Handicap.RefProduction;
	local aSupply = gT.Handicap.RefSupply;
	--supply is rather based on num ais alive
	local totAIalive, totOutOfSupply = 0, 0;
	for g, h in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			if Players[g]:IsAlive() and (not Players[g]:IsHuman()) then
				totAIalive = totAIalive + 1;
				if Players[g]:GetNumUnitsOutOfSupply() > 0 then
					totOutOfSupply = totOutOfSupply + 1;
				end
			end
		end
	end
	if totAIalive == 0 then
		return;
	end
	if totOutOfSupply == 0 then
		aSupply = math.min(100, gT.Handicap.Supply + 5);
	elseif totOutOfSupply / totAIalive > 0.15 then
		aSupply = math.max(20, gT.Handicap.Supply - 5);
	end
	--num cities
	--num units
	--num allied cs
	local nhCities = Players[iPlayer]:GetNumCities();
	local nhUnits = Players[iPlayer]:GetNumUnits();
	local nhAlliedCS = 0;
	local tCities, tUnits, tCSs = nhCities, nhUnits, 0;
	for g, h in pairs(gT.Players) do
		if Players[g]:IsAlive() and (g ~= iPlayer) then
			if Players[g]:IsMinorCiv() then
				tCSs = tCSs + 1;
				if Players[g]:GetAlly() == iPlayer then
					nhAlliedCS = nhAlliedCS + 1;
				end
			else
				tCities = tCities + Players[g]:GetNumCities();
				tUnits = tUnits + Players[g]:GetNumUnits();
			end
		end
	end
	local avgCities = tCities / (totAIalive + 1) 
	local avgUnits = tUnits / (totAIalive + 1)
	local eValSituation = math.min(40, math.floor(nhCities * 20 / avgCities)) + math.min(30, math.floor(nhUnits * 15 / avgUnits))
	eValSituation = eValSituation + math.min(nhAlliedCS * 5, math.min(30, math.floor(60 * nhAlliedCS / (tCSs + 1))))
	if gT.Globals.AIHandicapEval then
		if eValSituation > 55 then
			if eValSituation < gT.Globals.AIHandicapEval then
				aFood = gT.Handicap.Food;
				aProd = gT.Handicap.Production;
				aGold = gT.Handicap.Gold;
			else
				local finalEval = math.min(100, eValSituation + eValSituation - gT.Globals.AIHandicapEval);
				aFood = math.max(gT.Handicap.Food - 5, aFood - math.ceil(finalEval / 2));
				aProd = math.max(gT.Handicap.Production - 5, aProd - math.ceil(finalEval / 2));
				aGold = math.max(gT.Handicap.Gold - 5, aGold - math.ceil(finalEval / 2));
			end
		elseif eValSituation < 30 then
			if eValSituation > gT.Globals.AIHandicapEval then
				aFood = gT.Handicap.Food;
				aProd = gT.Handicap.Production;
				aGold = gT.Handicap.Gold;
			else
				local finalEval = math.max(0, eValSituation + eValSituation - gT.Globals.AIHandicapEval);
				aFood = math.min(gT.Handicap.Food + 5, aFood + math.max(0, 25 - math.ceil(finalEval)));
				aProd = math.min(gT.Handicap.Production + 5, aProd + math.max(0, 25 - math.ceil(finalEval)));
				aGold = math.min(gT.Handicap.Gold + 5, aGold + math.max(0, 25 - math.ceil(finalEval)));
			end
		end
	elseif eValSituation > 55 then
		aFood = aFood - 5;
		aProd = aProd - 5;
		aGold = aGold - 5;
	elseif eValSituation < 30 then
		aFood = aFood + 5;
		aProd = aProd + 5;
		aGold = aGold + 5;
	end
	gT.Globals.AIHandicapEval = eValSituation;
	DoSetAIHandicap(aFood, aProd, aGold, aSupply, true)
end

function CanCrossOcean(iPlayer)
	return Teams[Players[iPlayer]:GetTeam()]:IsHasTech(tPasssageAllWater);
end

GameEvents.JustBeforeDeclaringWarAI.Add(function(iTeam, ePlayer)
	--spend all possible resources on city-states to change side
	for g, gdata in pairs(gT.Players) do
		if Players[g]:GetTeam() == iTeam then
			if not Players[g]:IsMinorCiv() then
				if Players[g]:IsAlive() then
					if Players[g]:IsTurnActive() then
						DoAITryToSpendVotesInDoFPreWar(g, ePlayer)
						DoAITryToGrabAllCS(g, ePlayer)
					end
				end
			end
		end
	end
end)

function DoAITryToSpendVotesInDoFPreWar(g, ePlayer)
	for uid, sth in pairs(gT.Leagues) do
		if not sth.DoFindepedent then
			if sth.Members[g] and sth.Members[ePlayer] then
				TryToSpendExtraVotesInLeague(g, uid, {33, 30, 29, 64})
			end
		end
	end
end

function DoAITryToGrabAllCS(iPlayer, ePlayer)
	local eTeam = Teams[Players[iPlayer]:GetTeam()]
	local minorToGrab = {}
	local minorToProtect = {}
	for jj, sth in pairs(gT.Players) do
		if Players[jj]:IsMinorCiv() then
			if Players[jj]:IsAlive() then
				if Players[jj]:GetAlly() == ePlayer then
					if eTeam:IsHasMet(Players[jj]:GetTeam()) then
						if not eTeam:IsAtWar(Players[jj]:GetTeam()) then
							if Players[jj]:GetNumCities() > 0 then
							--if protecting
								if not IsITGProtectedByMajor(ePlayer, jj) then
									table.insert(minorToGrab, {jj, Players[jj]:GetMinorCivFriendshipWithMajor(ePlayer) - Players[jj]:GetMinorCivFriendshipWithMajor(iPlayer)})
								elseif not IsITGProtectedByMajor(iPlayer, jj) then
									table.insert(minorToProtect, jj)
								end
							end
						end
					end
				end
			end
		end
	end
	if #minorToGrab > 0 then
		local fColonyPointsToUse = gT.Players[iPlayer].FreeColonies;
		local fLegalPointsToUse = gT.Players[iPlayer].LegalPower;
		if gT.Players[iPlayer].Goverment == 1 then
			fLegalPointsToUse = 0;
		end
		local tGold, t1000, t500, t250;
		local function UpdateGoldVal()
			tGold = Players[iPlayer]:GetGold()
			t1000 = math.floor(tGold / iGoldGiftLarge);
			tGold = tGold - t1000 * iGoldGiftLarge
			t500 = math.floor(tGold / iGoldGiftMedium);
			tGold = tGold - t500 * iGoldGiftMedium
			t250 = math.floor(tGold / iGoldGiftSmall);
		end
		local influencefromcol = GetPlayerBonusForColonyInlfuence(iPlayer);
		local influencefromsettler = 10;
		local fSettlerPointsToUse = gT.Players[iPlayer].SettlerPoints
		table.sort(minorToGrab, SortFunctionForLowestMapDistance)
		for sji, data in pairs(minorToGrab) do
			local iMinor = data[1];
			UpdateGoldVal()
			local pPlot = Players[iMinor]:GetCapitalCity():Plot();
			local inffrom250 = Players[iMinor]:GetFriendshipFromGoldGift(iPlayer, iGoldGiftSmall);
			local inffrom500 = Players[iMinor]:GetFriendshipFromGoldGift(iPlayer, iGoldGiftMedium);
			local inffrom1000 = Players[iMinor]:GetFriendshipFromGoldGift(iPlayer, iGoldGiftLarge);
			local bmt;
			if Players[iMinor]:IsCannotBeInfluencedWithGold() then
				bmt = {t250, t500, t1000}
				t1000 = 0;
				t500 = 0;
				t250 = 0;
			end
			local totinfluenceav = influencefromcol * fColonyPointsToUse + inffrom250 * t250 + t500 * inffrom500 + t1000 * inffrom1000 + fSettlerPointsToUse * influencefromsettler;
			local canLegal = false;
			if fLegalPointsToUse > 0 then
				if (not gT.Players[iPlayer].LegalCSVisitCD[iMinor]) or (gT.Players[iPlayer].LegalCSVisitCD[iMinor] <= GetRealGameTurn()) then
					canLegal = true;
					totinfluenceav = totinfluenceav + GetMinorCivFriendshipFromImproveRelation(iPlayer, iMinor);
				end
			end
			local influencetosurpass = data[2];
			if totinfluenceav <= influencetosurpass + 5 then
				if not IsITGProtectedByMajor(iPlayer, jj) then
					table.insert(minorToProtect, iMinor)
				end
			else
				if influencetosurpass < inffrom250 and (t250 > 0) then
					Players[iMinor]:DoMinorGoldGift(iPlayer, iGoldGiftSmall)
				elseif influencetosurpass < influencefromcol and (fColonyPointsToUse > 0) then
					BoostInfluenceViaColont(pPlot, iPlayer)
					fColonyPointsToUse = fColonyPointsToUse - 1;
				elseif influencetosurpass < 20 and canLegal then
					PushLegalActionForPlayer(iPlayer, 7, iMinor)
					fLegalPointsToUse = fLegalPointsToUse - 1;
				elseif influencetosurpass < inffrom500 and (t500 > 0) then
					Players[iMinor]:DoMinorGoldGift(iPlayer, iGoldGiftMedium)
				else
					--throw everything you got until allied :D
					if fLegalPointsToUse > 5 and canLegal then
						PushLegalActionForPlayer(iPlayer, 7, iMinor)
						fLegalPointsToUse = fLegalPointsToUse - 1;
					end
					if Players[iMinor]:GetAlly() ~= iPlayer then
						for i = 1, t1000 do
							Players[iMinor]:DoMinorGoldGift(iPlayer, iGoldGiftLarge)
							if Players[iMinor]:GetAlly() == iPlayer then
								break;
							end
						end
						if Players[iMinor]:GetAlly() ~= iPlayer then
							if (t500 > 0) then
								Players[iMinor]:DoMinorGoldGift(iPlayer, iGoldGiftMedium)
							end
							if Players[iMinor]:GetAlly() ~= iPlayer then
								if (t250 > 0) then
									Players[iMinor]:DoMinorGoldGift(iPlayer, iGoldGiftSmall)
								end
								if Players[iMinor]:GetAlly() ~= iPlayer then
									if fLegalPointsToUse > 0 and canLegal then
										PushLegalActionForPlayer(iPlayer, 7, iMinor)
										fLegalPointsToUse = fLegalPointsToUse - 1;
									end
									if Players[iMinor]:GetAlly() ~= iPlayer then
										for i = 1, fColonyPointsToUse do
											BoostInfluenceViaColont(pPlot, iPlayer)
											fColonyPointsToUse = fColonyPointsToUse - 1;
											if Players[iMinor]:GetAlly() == iPlayer then
												break;
											end
										end
										if Players[iMinor]:GetAlly() ~= iPlayer then
											local cT = IsCSValidForPlayerToSettler(iMinor, iPlayer);
											if cT then
												PlayerChooseSettlerPointOnPlot(cT, iPlayer)
												fSettlerPointsToUse = fSettlerPointsToUse - 1;
											end
										end
									end
								end
							end
						end
					end
				end
			end
			if bmt then
				t1000 = bmt[3]
				t500 = bmt[2]
				t250 = bmt[1]
			end
		end
	end
	if #minorToProtect > 0 then
		if gT.Players[iPlayer].Goverment == 1 then
			return
		end
		if gT.Players[iPlayer].NumMaxPledges <= #gT.Players[iPlayer].PledgesOfProtection  then
			return
		end
		if gT.Players[iPlayer].LegalPower < 3 then
			return;
		end
		local evaluated = {}
		for i, minor in pairs(minorToProtect) do
			if CanBeProtectedByMajorAction(iPlayer, minor) then
				if Players[minor]:GetMinorCivFriendshipLevelWithMajor(iPlayer) > 0 then
					local value = GetAIPledgeValueOfMinor(iPlayer, minor);
					if value > 0 then
						table.insert(evaluated, {minor, value})
					end
				end
			end
		end
		if #evaluated > 0 then
			PushLegalActionForPlayer(iPlayer, 26, GetRandomFromBiasedChanceTable(evaluated))
		end
	end
end

function GetAIPledgeValueOfMinor(iPlayer, minor)
	local base = 0;
	if Players[minor]:GetMinorCivFriendshipLevelWithMajor(iPlayer) > 0 then
		base = 10 + Players[minor]:GetMinorCivFriendshipWithMajor();
		if Players[minor]:GetAlly() == iPlayer then
			base = base + 5;
		end
		local tCity = Players[minor]:GetCapitalCity();
		local avgdis = 0;
		for iCity in Players[iPlayer]:Cities() do
			avgdis = avgdis + Map.PlotDistance(	tCity:GetX(), tCity:GetY(), iCity:GetX(), iCity:GetY())
		end
		avgdis = avgdis / math.max(1,Players[iPlayer]:GetNumCities()) 
		if avgdis == 0 then
			return 0;
		end
		base = base + math.floor(math.max(12 - avgdis, 0) * 5)	
	end
	return base;
end

function DoTriggerAIScript(iPlayer, iType, exinfo)
	if iType == 1 then
		DoAIScriptWonderRush(iPlayer)
	elseif iType == 2 then
		DoAIScriptScoutingHard(iPlayer)
	elseif iType == 3 then
		DoAIScriptLeagueProjectHard(iPlayer, exinfo)
	elseif iType == 4 then
		DoAIScriptFinishWonder(iPlayer, exinfo)
	end
end

function DoAIScriptLeagueProjectHard(iPlayer, resID)
	local iProcess = GetProcessOutOfResolution(resID);
	if not iProcess then
		print("No Process for AI script 1241251", resID)
		return;
	end
	for iCity in Players[iPlayer]:Cities() do
		if iCity:GetDamage() == 0 then 
		-- it fires only once; rather weak push considering how much AI likes to switch from processes before production is actually collected
			iCity:PushOrder(OrderTypes.ORDER_MAINTAIN, iProcess)
		end
	end
	gT.Players[iPlayer].AIScriptQueue[3] = nil;
end

function DoAIScriptScoutingHard(iPlayer)
	local lScout = Players[iPlayer]:GetPlayerUniqueUnit(GameInfoTypes.UNITCLASS_SCOUT);
	if lScout ~= -1 then
		for iCity in Players[iPlayer]:Cities() do
			if LastRandom(1,100) <= 75 then
				iCity:PushOrder(OrderTypes.ORDER_TRAIN, lScout);
			end
		end
	end
	gT.Players[iPlayer].AIScriptQueue[2] = nil;
end

function GetBestAICityToConstructWonder(iPlayer, iWonder)
	local tab = {}
	for iCity in Players[iPlayer]:Cities() do
		if iCity:CanConstruct(iWonder) then
			local eval = 0;
			if iCity:GetProductionBuilding() == iWonder then
				eval = eval + 1000;
			else
				if iCity:GetDamage() == 0 then
					eval = eval + 500;
				end
				if iCity:GetOriginalOwner() == iPlayer then
					eval = eval + 50;
				end
				if not HasWonderOrRuin(iCity) then
					eval = eval + 350;
				elseif not HasWonderOrRuin(iCity, true) then
					eval = eval + 300;
				end
			end
			table.insert(tab, {iCity, eval})
		end
	end
	if #tab > 0 then
		table.sort(tab, SortFunctionForGreaterInteger2)
		return tab[1][1];
	end
	return nil;
end

function DoTriggerAIWonderConstructScript(iPlayer, bForce)
	for a, b in pairs(gT.Globals.WondersAssigned) do
		if b == iPlayer then
			if not gT.WondersConstructed[a] then
				if (bForce) or (gT.Globals.WondersAssignedT[a] + 15 < GetITGGameTurn()) then
					local bCity = GetBestAICityToConstructWonder(iPlayer, a);
					if bCity then
						if not gT.Players[iPlayer].AIScriptQueue[4] then
							gT.Players[iPlayer].AIScriptQueue[4] = {};
						end
						table.insert(gT.Players[iPlayer].AIScriptQueue[4], {bCity:Plot():GetPlotIndex(), a})
					end
				end
			end
		end
	end
end

function DoAIScriptFinishWonder(iPlayer, exinfo)
	local bNeeded = false;
	for a, b in pairs(exinfo) do
		if Map.GetPlotByIndex(b[1]):GetOwner() == iPlayer then
			if not gT.WondersConstructed[b[2]] then
				Map.GetPlotByIndex(b[1]):GetPlotCity():PushOrder(OrderTypes.ORDER_CONSTRUCT, b[2])
				bNeeded = true;
			end
		end
	end
	if not bNeeded then
		gT.Players[iPlayer].AIScriptQueue[4] = nil;
	end
end

function DoAIScriptWonderRush(iPlayer)
	for iCity in Players[iPlayer]:Cities() do
		if LastRandom(1,100) <= 75 then
			if not IsBuildingWonder(iCity) then
				iCity:PushOrder(OrderTypes.ORDER_MAINTAIN, dWonderProcess);
			end
		end
	end
end

function IsBuildingWonder(iCity)
	local iBuilding = iCity:GetProductionBuilding();
	if iBuilding ~= -1 then
		if GameInfo.Buildings[iBuilding].WonderEra ~= 0 then
			return true;
		end
	end
	return false;
end

function DoAIScriptOnWonderRaceBeingResolved()
	local justEnded = {}
	for g, h in pairs(gT.Players) do --clear any existing
		if h.AIScriptQueue[1] then
			gT.Players[g].AIScriptQueue[1] = nil;
			justEnded[g] = true;
		end
	end
	if GetITGGameTurn() > 88 then
		local avTab = {};
		for g, gData in pairs(gT.Players) do
			if not Players[g]:IsMinorCiv() then
				if not Players[g]:IsHuman() then
					if gData.CanWonderRace then
						if Players[g]:GetNumCities() > 3 then
							if not gData.AIPanicScript then
								table.insert(avTab, {g, (gData.LastWonderResult or 0) + Players[g]:GetNumCities() * 50})
							end
						end
					end		
				end
			end
		end
		table.sort(avTab, SortFunctionForGreaterInteger2)
		for i, v in pairs(avTab) do
			local chance = i;
			local topLimit = gT.Globals.WonderTreshold;
			if DBScenario.WonderCultureGroup then
				topLimit = gT.Globals.WonderCTTresholds[gT.Players[v[1]].CultureType];
			end
			if (gT.Players[v[1]].LastWonderResult or 0) < topLimit then
				chance = chance + 4;
			end
			if LastRandom(1, chance) == i then
				gT.Players[v[1]].AIScriptQueue[1] = true;
				gT.Players[v[1]].AIWonderBlock = nil;
			end
		end
	else
		local avTab = {};
		for g, gData in pairs(gT.Players) do
			if not Players[g]:IsMinorCiv() then
				if not Players[g]:IsHuman() then
					if gData.CanWonderRace and (not gData.AIWonderBlock) then
						if Players[g]:GetNumCities() > 3 then
							if (not gData.AIPanicScript) and (not justEnded[g]) then
								local topLimit = gT.Globals.WonderTreshold;
								if DBScenario.WonderCultureGroup then
									topLimit = gT.Globals.WonderCTTresholds[gData.CultureType];
								end
								if (gData.LastWonderResult or 0) >= 0.9 * topLimit then
									table.insert(avTab, g)
								end
							end
						end
					end		
				end
			end
		end
		if #avTab > 0 then
			local lPlayer = avTab[LastRandom(1,#avTab)];
			gT.Players[lPlayer].AIScriptQueue[1] = true;
		end
	end
end

function InitialAddAIScripts()
	for g, gData in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			if not Players[g]:IsHuman() then
				local initScripts = {}
				local gTeam = Teams[Players[g]:GetTeam()];
				if gTeam:IsHasTech(tPasssageAllWater) then
					if Players[g]:GetNumCities() < 6 then
						if LastRandom(1, 100) <= 15 then
							table.insert(initScripts, {2, 50})			
						end
					end
				end
				if gData.CanWonderRace then
					if Players[g]:GetNumCities() > 3 then
						if gData.Goverment ~= 1 then
							if LastRandom(1, 100) <= 17 then
								table.insert(initScripts, {1, 30})			
							end
						end
					end
				end
				if #initScripts > 0 then
					gT.Players[g].AIScriptQueue[GetRandomFromBiasedChanceTable(initScripts)] = 1;
				end
			end
		end
	end
end

function DoesNotSeemAsDangerToAI(iPlayer, ePlayer)
	if GetMilitaryMightDemographics(iPlayer, iPlayer, false) > 1.7 * GetMilitaryMightDemographics(iPlayer, ePlayer, false) then
		return true;
	end
	local numseenunits = 0;
	local eTeam = Players[iPlayer]:GetTeam();
	for iUnit in Players[ePlayer]:Units() do
		if iUnit:GetPlot():IsVisible(eTeam) then
			numseenunits = numseenunits + 1;
			if iUnit:GetPlot():GetOwner() == iPlayer then
				numseenunits = numseenunits + 1;
			end
		end
	end
	if numseenunits > 9 then
		return false;
	end
	if Players[ePlayer]:GetNumCities() == 0 then
		return true;
	end
	local mindis = 9999;
	for iCity in Players[iPlayer]:Cities() do
		mindis = math.min(mindis, GetClosestCityDistanceToXY(ePlayer, iCity:GetX(), iCity:GetY(), eTeam))
	end
	if LastRandom(10, 20) <= mindis then
		return true;
	end
	return false;
end

function DoAIScriptDoWRebels(iPlayer)
	--our city in other player just rebelled with barbs
	local iTeam = Players[iPlayer]:GetTeam();
	local hTeam = Teams[iTeam];
	for ePlayer, am in pairs(gT.Players[iPlayer].AIScriptDoWFromRiots) do
		local eTeam = Players[iPlayer]:GetTeam();
		if hTeam:CanDeclareWar(eTeam) then
			if not Players[ePlayer]:IsMinorCiv() then
				if not Players[ePlayer]:IsDoF(iPlayer) then
					--geronimo :)
					local chance = 5 * am;
					for iUnit in Players[63]:Units() do
						if iUnit:GetRebelOrigin() == iTeam then
							if iUnit:GetRebelAgainst() == eTeam then
								chance = chance + 1;
								if iUnit:GetDamage() == 0 then
									chance = chance + 1;
								end
							end
						end
					end

					if DoesNotSeemAsDangerToAI(iPlayer, ePlayer) then
						hTeam:DeclareWar(eTeam)
					else
						--finest hour
						local iMight = GetMilitaryMightDemographics(iPlayer, iPlayer, false)
						local eMight = GetMilitaryMightDemographics(iPlayer, ePlayer, false)
						if iMight >= eMight then
							chance = chance + 50;
						elseif iMight >= (eMight / 2) then
							chance = chance + 25;
						end
						if LastRandom(1, 100) <= chance then
							hTeam:DeclareWar(eTeam)
						end
					end
				end
			end
		end
	end
	gT.Players[iPlayer].AIScriptDoWFromRiots = {}		
end

function DoLastTurnAILegalDecision(iPlayer)
	if gT.Players[iPlayer].Goverment == 1 then
		return; --meh
	end
	PlayerWantToPurchaseLegalAuthority(iPlayer, LastRandom(3, 7))
	PlayerWantToClaimLegalWithFaith(iPlayer, 5)
--	local legPower = GetAvailablePowerForLegalAction(iPlayer, false);
--	local legHapPower = GetAvailablePowerForLegalAction(iPlayer, true);
	
	--alphabet --national day --codex
	for ibl, vbl in pairs({21, 18, 19, 29}) do
		if CanDoLegalActionBasic(iPlayer, vbl, false) then
			if CanAffordTheAction(vbl, iPlayer, nil, nil, nil) then
				PushLegalActionForPlayer(iPlayer, vbl, nil, nil)
			end
		end
	end
	if not gT.Players[iPlayer].HasCodex then
		--if no codex then change as many laws as possible ~ based on discount;
		local legalleftlaws = GetAvailablePowerForLegalAction(iPlayer, false) + gT.Players[iPlayer].FreeLaws;
		local lawsleft = math.min(legalleftlaws, 10 - GetPlayerCodexDiscount(iPlayer));
		if lawsleft > 0 then
			local lawsDB = {};
			for i, data in pairs(GetLawsDataTable()) do
				if CanPlayerHaveLaw(iPlayer, i) then
					local cOption = GetAIEvalOfLaw(iPlayer, legalleftlaws - 1, data.ID);
					if cOption then
						table.insert(lawsDB, cOption)
					end
				end
			end
			table.sort(lawsDB, SortFunctionForGreaterInteger4)
			for i, dd in pairs(lawsDB) do
				if i <= lawsleft then
					if CanAffordLawPlayer(iPlayer, dd[2]) then
			 			OnLawChanged(iPlayer, dd[2], dd[3])
					end
				else
					break;
				end
			end
		end
	end
	--if legal left, throw it at city-states relationships;
	local legalleftToThrow = GetAvailablePowerForLegalAction(iPlayer, false);
	if legalleftToThrow > 0 then
		local minorTab = PreparedDataForInfluenceImprove(iPlayer);
		local tsbyinflue = {}
		for i, data in pairs(minorTab.UniqueOptions) do
			table.insert(tsbyinflue, {data.ID, Players[data.ID]:GetMinorCivFriendshipWithMajor(iPlayer)})
		end
		table.sort(tsbyinflue, SortFunctionForGreaterInteger2)
		for i, v in pairs(tsbyinflue) do
			if i <= legalleftToThrow then
				PushLegalActionForPlayer(iPlayer, 7, v[1])
			end
		end
	end
end

function HasAIScriptForLegalTactic(iPlayer, legPower, legHapPower)
--return true to disable basic AI legal logic!
	local emergencyNewCapital = GetNewCapitalForAIEmergency(iPlayer, legPower, legHapPower)
	if emergencyNewCapital then
		PushLegalActionForPlayer(iPlayer, 27, emergencyNewCapital)
		return true;
	end
	if gT.Players[iPlayer].AILegalTactic == -1 then
		return GovMeritocracySlotAIDecision(iPlayer, legPower, legHapPower);
	end
	if not gT.Players[iPlayer].AILegalTactic then
		if not gT.Players[iPlayer].AILegalScriptTurn then
			gT.Players[iPlayer].AILegalScriptTurn = LastRandom(12, 18)
		end
		if gT.Players[iPlayer].AILegalScriptTurn <= GetITGGameTurn() then
			--let's decide what to do in longer terms;
			local totlegalgen = legPower + gT.Players[iPlayer].SpendLegalPower
			if totlegalgen >= 3 and (gT.Globals.ScenarioType == 3) and CanPlayerDoStandardiseAlphabet(iPlayer) and (LastRandom(1, 10) < 8) then
				gT.Players[iPlayer].AILegalTactic = 1;
				gT.Players[iPlayer].AILegalScriptTurn = LastRandom(66, 85);
			elseif CanPlayerDoCodex(iPlayer) then
				if LastRandom(1, 10) < 7 then
					gT.Players[iPlayer].AILegalTactic = 2;
					if (gT.Globals.ScenarioType == 3) then
						gT.Players[iPlayer].AILegalScriptTurn = LastRandom(60, 80);
					else
						gT.Players[iPlayer].AILegalScriptTurn = LastRandom(40, 70);
					end
				end
			end
			if not gT.Players[iPlayer].AILegalTactic then
				gT.Players[iPlayer].AILegalTactic = -1
			end
		end
	end
	if Players[iPlayer]:GetNumCities() < 1 then
		gT.Players[iPlayer].AILegalTactic = -1;
		return false;
	end
	if gT.Players[iPlayer].AILegalTactic == 1 then -- alphabet
		PushLegalActionForPlayerIfPossible(iPlayer, 21)
		if (not CanPlayerDoStandardiseAlphabet(iPlayer)) or (gT.Players[iPlayer].AILegalScriptTurn <= GetITGGameTurn()) then
			gT.Players[iPlayer].AILegalTactic = -1;
		end
		return true;
	elseif gT.Players[iPlayer].AILegalTactic == 2 then -- we want to create codex
		PushLegalActionForPlayerIfPossible(iPlayer, 21)
		if (not CanPlayerDoCodex(iPlayer)) or (gT.Players[iPlayer].AILegalScriptTurn <= GetITGGameTurn()) then
			gT.Players[iPlayer].AILegalTactic = -1;
			return true;
		end
	end
	return false;
end

function ShouldAIuseRelBonusForLegal(iPlayer, legalFromRel)
	if gT.Players[iPlayer].AILegalTactic then
		if gT.Players[iPlayer].AILegalTactic ~= -1 then
			return true;
		end
	end
	if gT.Players[iPlayer].Goverment == 1 then
		return true;
	end
	local legPT = (GetAvailablePowerForLegalAction(iPlayer, false) + gT.Players[iPlayer].SpendLegalPower) / math.max(1, GetITGGameTurn());
	if legPT <= 0.1 then
		return true; -- let's kick it
	end
	local chance = math.floor(legalFromRel / 10);
	if legPT >= 0.5 then -- dont truely need
		chance = chance - 25;
	end
	if CanPlayerDoCodex(iPlayer) then
		chance = chance + 20;
	end
	if CanPlayerDoNationalDay(iPlayer) then
		chance = chance + 10;
	end
	if CanPlayerDoStandardiseAlphabet(iPlayer) then
		chance = chance + 15;
	end
	return LastRandom(1, 100) <= chance;
end

function AISpecialControlPlotsWarScript(iPlayer)
--basically if there is a lot of undefendable control plots nearby, we strike
	if GetITGGameTurn() < 40 then
		return;
	end
	if LastRandom(1, 33) > 1 then
		return;
	end
	if gT.Globals.DominationOn and (not gT.Globals.DominationOff) then
		return;
	end
	if Players[iPlayer]:GetNumCities() < 1 then
		return;
	end
	local niceTargets = {}
	local iTeam = Players[iPlayer]:GetTeam();
	for g, h in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			if g ~= iPlayer then
				if Teams[iTeam]:IsHasMet(Players[g]:GetTeam()) and Teams[iTeam]:CanDeclareWar(Players[g]:GetTeam()) then
					if DoesNotSeemAsDangerToAI(iPlayer, g) then
						niceTargets[g] = 0;
					end
				end
			end
		end
	end
	for g, t in pairs(niceTargets) do
		for j, b in pairs(gT.Players) do
			if not Players[j]:IsMinorCiv() then
				if not niceTargets[j] then
					if Teams[Players[g]:GetTeam()]:IsDefensivePact(Players[j]:GetTeam()) then
						if Teams[iTeam]:IsHasMet(Players[j]:GetTeam()) and (not Teams[iTeam]:IsAtWar(Players[j]:GetTeam())) then
							niceTargets[g] = nil;
							break;
						end
					end
				end
			end
		end
	end
	local bCont = false;
	for a, b in pairs(niceTargets) do
		bCont = true;
		break;
	end
	if not bCont then
		return;
	end
	local strtab = {{"Forts", 10}, {"Colonies", 20}, {"HolySites", 16}, {"ElDorados", 15}, {"Settlements", 20}}
	for i, b in pairs(strtab) do
		for index, data in pairs(gT[b[1]]) do
			if niceTargets[data.Player] then
				if (b[1] ~= "HolySites" or (not gT.Players[data.Player].HasPlayerWonder[medwonder9])) then -- those are unconquerable!!!
					local iPlot = Map.GetPlotByIndex(index);
					if AIIsConsideringThisPlotAnEasyTarget(iPlot, index, iPlayer, iTeam) then
						niceTargets[data.Player] = niceTargets[data.Player] + b[2];
					end
				end
			end
		end 
	end
	local hTab = {}
	local treshold = 55;
	for a, b in pairs(niceTargets) do
		if b > treshold then
			table.insert(hTab, {a, b})
		end
	end
	if #hTab > 0 then
		table.sort(hTab, SortFunctionForGreaterInteger2)
		print("AI found an easy target", iTeam, hTab[1][1])
		Teams[iTeam]:DeclareWar(Players[hTab[1][1]]:GetTeam())
	end
end

function AIIsConsideringThisPlotAnEasyTarget(iPlot, index, iPlayer, iTeam)
	if iPlot:IsRevealed(iTeam) then
		if iPlot:IsVisible(iTeam) then
			return true;
		end
		for i = 0, 5 do
			local nPlot = Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), i);
			if nPlot and (nPlot:GetOwner() == iPlayer) then
				return true;
			end
		end
		if GetNearestCityOfPlayerToPlot(iPlot:GetX(), iPlot:GetY(), iPlayer, 5) then
			return true;
		end
	end
	return false;
end

function DoAIPanicScriptCloseToBeingConquered(tab)
	local iPlayer = tab.Prev;
	if Players[iPlayer]:IsHuman() then
		return;
	end
	if Players[iPlayer]:IsMinorCiv() then
		return;
	end
	if gT.Players[iPlayer].AIPanicScript then
		gT.Players[iPlayer].AIPanicScript = GetITGGameTurn() + 15;
		return;
	end
	local thisIndex = tab.Plot;
	local numCrecently = 1;
	local lastXturn = GetITGGameTurn() - LastRandom(7, 11);
	for a, b in pairs(gT.Globals.HnGData.CityCaptures) do
		if b.Prev == iPlayer then
			if b.Turn > lastXturn then
				if b.Plot ~= thisIndex then
					numCrecently = numCrecently + 1;
				end
			end
		end
	end
	if numCrecently == 1 then
		local numCities = Players[iPlayer]:GetNumCities();
		local chance = 10 - numCities * 3;
		if tab.Notable then
			chance = chance + 5;
		end
		if Players[tab.New]:IsHuman() then
			chance = chance + 8;
		end
		if CityWasOriginallyOurs(thisIndex, iPlayer) then
			chance = chance + 5;
			local tCity = GetOriginalCapitalOfPlayer(iPlayer)
			if (not tCity) then
				print("PLAYER HAS NO ORIGINAL CAPITAL!", iPlayer)
			elseif tCity:Plot():GetPlotIndex() == thisIndex then
				chance = chance + 5;
			end 
		end
		if LastRandom(1, 100) <= chance then
			gT.Players[iPlayer].AIPanicScript = GetITGGameTurn() + 15;
		end
	elseif numCrecently == 2 then
		local numCities = Players[iPlayer]:GetNumCities();
		local chance = 10;
		if numCities < 3 then
			chance = chance + 15;
		end
		if CityWasOriginallyOurs(thisIndex, iPlayer) then
			chance = chance + 8;
			local tCity = GetOriginalCapitalOfPlayer(iPlayer)
			if (not tCity) then
				print("PLAYER HAS NO ORIGINAL CAPITAL!", iPlayer)
			elseif tCity:Plot():GetPlotIndex() == thisIndex then
				chance = chance + 8;
			end 
		end
		if tab.Notable then
			chance = chance + 5;
		end
		if Players[tab.New]:IsHuman() then
			chance = chance + 20;
		end
		if LastRandom(1, 100) <= chance then
			gT.Players[iPlayer].AIPanicScript = GetITGGameTurn() + 15;
		end
	else --loosing 3 cities is emergency
		gT.Players[iPlayer].AIPanicScript = GetITGGameTurn() + 15;
	end
end

function AIPanicScriptDoW(iPlayer, ePlayer)
	if Players[iPlayer]:IsHuman() then
		return;
	end
	if not Players[ePlayer]:IsHuman() then
		return;
	end
	if GetITGGameTurn() >= LastRandom(88, 92) then
		return;
	end
	if gT.Players[ePlayer].UniqueNumConquered >= LastRandom(6, 10) then
		gT.Players[iPlayer].AIPanicScript = GetITGGameTurn() + 15;
	end
end

function CityWasOriginallyOurs(thisIndex, iPlayer)
	for h, b in pairs(gT.Globals.HnGData.CityCaptures) do
		if b.Plot == thisIndex then
			return (iPlayer == b.Prev)
		end
	end
	print("logic error 9342235/234")
	return false;
end

function GetNewCapitalForAIEmergency(iPlayer, legPower, legHapPower)
	if legHapPower < GetDataFromTabLegalAction(27, "Cost") then
		return nil;
	end
	if legHapPower - legPower + 1 < GetDataFromTabLegalAction(27, "Cost") then
		return nil;
	end
	if Players[iPlayer]:GetNumCities() < 4 then
		return nil;
	end
	--first determine if capital is endangered
	local cCity = Players[iPlayer]:GetCapitalCity();
	if cCity:GetDamage() < cCity:GetMaxHitPoints() / 2 then
		return nil;
	end
	local nEnB = 0;
	local iTeam = Players[iPlayer]:GetTeam();
	for j, plot in pairs(GetPlotsInRadiusOfPlot(cCity, 3)) do
		for i = 0, plot:GetNumUnits() - 1 do
			local bUnit = plot:GetUnit(i);
			if Teams[iTeam]:IsAtWar(Players[bUnit:GetOwner()]:GetTeam()) then
				if bUnit:GetBaseCombatStrength(true) > 7 then
					if gT.Players[bUnit:GetOwner()] and CanConquerCitiesRightNow(bUnit:GetOwner()) then
						nEnB = nEnB + 1;
					end
				end
			end
		end
	end
	if nEnB > 4 then
		return GetSafestCityForNewCapital(iPlayer)
	end
	return nil;
end

function GetSafestCityForNewCapital(iPlayer)
	local cCity = Players[iPlayer]:GetCapitalCity();
	local tab = {}
	for i, data in pairs(PreparedDataForNewCapital(iPlayer).UniqueOptions) do
		local iCity = Players[iPlayer]:GetCityByID(data.ID);
		if (iCity:GetDamage() == 0) then
			if not IsCityRecentlyAcquired(iCity, iPlayer) then
				local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
				local eval = Map.PlotDistance(iCity:GetX(), iCity:GetY(), cCity:GetX(), cCity:GetY());
				eval = eval - math.floor(gT.Cities[cID].TotalDamage/ 10) 
				table.insert(tab, {iCity:GetID(), eval}) 			
			end
		end
	end
	if #tab > 0 then
		table.sort(tab, SortFunctionForGreaterInteger2)
		return tab[1][1];
	end
	return nil;
end

function IsAIConsideringTheirCivUnhappy(iPlayer)
	if gT.Players[iPlayer].AverageHappinessCounted == 0 then
		return false;
	end
	local avgHap = math.floor(0.5 + 100 * gT.Players[iPlayer].LHAverageHappiness / gT.Players[iPlayer].AverageHappinessCounted )/100;
	for iCity in Players[iPlayer]:Cities() do
		if iCity:GetPopulation() > 3 then
			local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
			local unhap = GetGenerateUnhappinessChanceCity(iCity, iPlayer, cID, true, false)
			if unhap >= 950 then
				avgHap = avgHap - 1;
			elseif unhap < 500 then
				avgHap = avgHap + 1;
			end
		end
	end
	if gT.Players[iPlayer].Decadentism > 0 then
		avgHap = avgHap + 2;
	end
	return (avgHap < 0);
end

function GetUnitOceansSecured(plot)
	if plot:IsWater() then
		return {GetOceanID(plot)};
	else
		return GetCoastOfOceanTab(plot)
	end
end

local hIndexOceanAIType = {};
function ResetOceanAIType(oceanID)
	if hIndexOceanAIType[oceanID] then
		if hIndexOceanAIType[oceanID][1] ~= 2 then
			hIndexOceanAIType[oceanID] = nil;
		end
	end
end
function DetermineAITypeOfOcean(oceanID)
	local nType, wType = 0, 0;
	local size = GetSizeOfOcean(oceanID);
	local tnavysize = size;
	for ocean, v in pairs(GetAllConnectedAquens(oceanID, true)) do
		if ocean ~= oceanID then
			tnavysize = tnavysize + GetSizeOfOcean(ocean);
		end
	end
	if gT.ValidOceanFish[oceanID] then
		if size < 50 then
			wType = 1;
		elseif size < 100 then
			wType = 3;
		else
			wType = 5;
		end
	end
	if tnavysize >= 140 then
		nType = 2;
	elseif tnavysize < 60 then
		nType = 0;
	else
		nType = 1;
	end
	hIndexOceanAIType[oceanID] = {nType, wType};
end
function DoAIBlockTooManyNavalInSmallAquens(iPlayer)
	if (gT.Players[iPlayer].AItLogicNavalBlock or 3) > GetITGGameTurn() then
		return;
	end
	gT.Players[iPlayer].AItLogicNavalBlock = GetITGGameTurn() + LastRandom(7,12);
	local unitsByOceanID, workbByOceanID = {}, {};
	local bAny = false;
	for iUnit in Players[iPlayer]:Units() do
		if iUnit:GetDomainType() == dSea then
			if iUnit:GetUnitClassType() == GameInfoTypes.UNITCLASS_WORKBOAT then
				for i, oceanID in pairs(GetUnitOceansSecured(iUnit:GetPlot())) do
					workbByOceanID[oceanID] = (workbByOceanID[oceanID] or 0) + 1;
				end
			else
				for i, oceanID in pairs(GetUnitOceansSecured(iUnit:GetPlot())) do
					unitsByOceanID[oceanID] = (unitsByOceanID[oceanID] or 0) + 1;
				end
			end
			bAny = true;
		end
	end
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		if gT.Cities[cID].CanDoWorkboats then
			gT.Cities[cID].AIWorkBoatTrainBlock = nil;
			gT.Cities[cID].AINavalTrainBlock = nil;
			if bAny then
				local aAdj = GetCoastOfOceanTab(iCity:Plot());
				local bNd, bNw = 0, 0;
				for i, oceanID in pairs(aAdj) do
					if not hIndexOceanAIType[oceanID] then
						DetermineAITypeOfOcean(oceanID);
					end
					bNd = math.max(bNd, hIndexOceanAIType[oceanID][1]);
					bNw = math.max(bNw, hIndexOceanAIType[oceanID][2]);
				end
				if bNw > 0 then
					if bNw < 5 then
						local bCanDo = true;
						for i, oceanID in pairs(aAdj) do
							if hIndexOceanAIType[oceanID][2] == bNw then
								if hIndexOceanAIType[oceanID][2] <= (workbByOceanID[oceanID] or 0) then
									bCanDo = false;
									break;
								end
							end
						end
						if not bCanDo then
							gT.Cities[cID].AIWorkBoatTrainBlock = true;
						end
					end
				else
					print("This should never happen (handled by initial can do workboats)", cID, iPlayer)
					gT.Cities[cID].AIWorkBoatTrainBlock = true;
				end
				if bNd == 2 then
					--no block ever
				elseif bNd == 1 then
					local numNavy = 0;
					for i, oceanID in pairs(aAdj) do
						numNavy = numNavy + (unitsByOceanID[oceanID] or 0)
					end
					if numNavy >= 3 then
						for i, iCity in pairs(GetCitiesFromCertainAquenArea(aAdj, true)) do
							if iCity:GetOwner() ~= iPlayer then
								numNavy = numNavy - 2;
								if Teams[Players[iPlayer]:GetTeam()]:IsAtWar(Players[iCity:GetOwner()]:GetTeam()) then
									numNavy = numNavy - 3;
								end
							end
						end
						if numNavy >= 3 then
							gT.Cities[cID].AINavalTrainBlock = true;
						end
					end
				else
					local numNavy = 0;
					for i, oceanID in pairs(aAdj) do
						numNavy = numNavy + (unitsByOceanID[oceanID] or 0)
					end
					if numNavy >= 1 then
						for i, iCity in pairs(GetCitiesFromCertainAquenArea(aAdj, true)) do
							if iCity:GetOwner() ~= iPlayer then
								numNavy = numNavy - 1;
								if Teams[Players[iPlayer]:GetTeam()]:IsAtWar(Players[iCity:GetOwner()]:GetTeam()) then
									numNavy = numNavy - 2;
								end
							end
						end
						if numNavy >= 1 then
							gT.Cities[cID].AINavalTrainBlock = true;
						end
					end
				end
			end
		end
	end
end