local gmedwonder10 = GameInfoTypes.BUILDING_ITG_NEW_MEDIEVAL_WONDER_10;
local MultipleAcademyScenario = {[4] = 1};
local innoindo20 = GameInfoTypes.TECH_UNIQUE_ITG_INDUSTRIAL_20
local innoindu13 = GameInfoTypes.TECH_UNIQUE_ITG_INDUSTRIAL_13
local wonderindu7 = GameInfoTypes.BUILDING_ITG_NEW_INDUSTRIAL_WONDER_7
local tabDepartments = {
Science = {Name = "Research Department", Icon = "[ICON_RESEARCH]", Help = "Increases scientific output."},
Production = {Name = "Faculty of Engineering", Icon = "[ICON_PRODUCTION]", Help = "Speeds up production of city."},
Health = {Name = "Medical Department", Icon = "[ICON_ITG_HEALTH_1]", Help = "Grants better medical care for citizens."},
Military = {Name = "Militaristic Department", Icon = "[ICON_GREAT_GENERAL]", Help = "Grants militartistic bonuses."},
Faith = {Name = "Faculty of Theology", Icon = "[ICON_PEACE]", Help = "Increases faith output."},
Naval = {Name = "Marinal Department", Icon = "[ICON_GREAT_ADMIRAL]", Help = "Bonuses are naval related."},
Economy = {Name = "Economic Department", Icon = "[ICON_INVEST]", Help = "Speeds up gold generation."},
National = {Name = "National Department", Icon = "[ICON_ITG_NAT_UNITY]", Help = "Increases National Unity of your civilization."},
Archaeology = {Name = "Archeological Department", Icon = "[ICON_RES_ARTIFACTS]", Help = "Makes you more competive in Archaeological race."},
}

function CreateNewAcademy(iIndex, iOwner, bInitial)
	--get adjacent city;
	local iPlot = Map.GetPlotByIndex(iIndex);
	TerminateResourceFromPlot(iPlot);
	local iCity = GetAdjacentCity(iPlot)
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local turnbefore = 0;
	if bInitial then
		turnbefore = LastRandom(-50, -5);
	else
		GovTypePowerBoost(iOwner, 8, "Industrialist", 3, false)
	end
	gT.Academies[iIndex] = {RecentLog = {}, KeyAbilities = {}, NumAcquiredBonuses = 0, PointsTowardBonus = 0, MaxPrestigeEver = 100, Prestige = 100, StagnationMod = 0, NationalMod = 0, ActiveRewards = {}, PrestigeTempMods = {}, PrestigeAnchor = BASE_PRESTIGE_ANCHOR, PrestigeDynamic = {}, 
	Year = GetTextDate(GetITGGameTurn() + turnbefore, gT.Globals.StartDate, true), PrestigeActive = {}, CityName = iCity:GetName(), City = iCity:Plot():GetPlotIndex(), TurnFounded = GetRealGameTurn() + turnbefore, ScenarioFounded = gT.Globals.ScenarioType, Plot = iIndex, OriginalPlayer = iOwner, MaxPrestigePlayer = iOwner, MaxPrestigeTurn = GetITGGameTurn(), Player = iOwner, Active = true, ActiveSince = GetRealGameTurn() + turnbefore, SupportCD = -1}
	table.insert(gT.Cities[cID].Academies, iIndex)
	if gT.Players[iOwner].NextAcademyIsNational then
		gT.Academies[iIndex].NationalMod = gT.Players[iOwner].NextAcademyIsNational
		gT.Players[iOwner].NextAcademyIsNational = nil;
	end
	if gT.Cities[cID].CanDoWorkboats then
		gT.Academies[iIndex].CanHaveNaval = true;
	end
	HandleJustInitialName(iIndex, iOwner)
	if gT.Globals.ScenarioType == 4  then
		DoUniqueIndustrialInitOfAcademy(iIndex, iOwner, bInitial)
	else
		gT.Academies[iIndex].Bonuses = {Science = 0, Production = 0, Health = 0, Military = 0}
		if gT.Globals.ScenarioType == 2 then
			gT.Academies[iIndex].Bonuses.Faith = 0;
		end
		if gT.Academies[iIndex].CanHaveNaval then
			gT.Academies[iIndex].Bonuses.Naval = 0;
		end		
		if gT.Globals.ScenarioType == 5 then
			gT.Academies[iIndex].Bonuses.Economy = 0;
		end
	end
	if gT.Academies[iIndex].Bonuses then
	   HandleInitialAcademyBonuses(iIndex, iOwner, bInitial)
	end
	AddSmallInfo(iPlot, nil, "Academy", nil, nil, nil, 1)
end

function GetTabDepartmentData(i, string)
	if not i then
		return tabDepartments;
	end
	if not sType then
		return tabDepartments[i]
	end
	return tabDepartments[i][sType];
end

function GetNameOfDeparmentType(type, bIcon)
	if bIcon then
		return tabDepartments[type].Icon .. " " .. tabDepartments[type].Name;
	else
		return tabDepartments[type].Name;
	end
end

function DoUniqueIndustrialInitOfAcademy(iIndex, iOwner, bInitial)
	if bInitial then
		DoFullRandomIndustrialAcademyBonuses(iIndex, 3, iOwner)
	elseif Players[iOwner]:IsHuman() then
		local data = {BonusType = "Department", TagToRemove = iIndex, Text = "CHOOSE DEPARTMENT", LookAt = iIndex, TitleText = "Choose Department for " .. gT.Academies[iIndex].Name .. ".", TitleIconIndex = 38, TitleIconAtlas = "TERRAIN_ATLAS", Tooltip = "New Academy can have only limited amount of departments. You are allowed to choose one, while the rest are generated randomly."}
		local hTab = {}
		for a, b in pairs({"Science", "Production", "Health", "Military", "Economy", "National", "Archaeology"}) do
			table.insert(hTab, 	{Name = GetNameOfDeparmentType(b, true), ID = b, Help = tabDepartments[b].Help, ExtraInfo = iIndex})
		end
		if gT.Academies[iIndex].CanHaveNaval then
			table.insert(hTab, 	{Name = GetNameOfDeparmentType("Naval", true), ID = "Naval", Help = tabDepartments.Naval.Help, ExtraInfo = iIndex})
		end
		data.UniqueOptions = hTab;
		table.insert(gT.Players[iOwner].NewHumanQueueActions, data)
		Events.SerialEventEndTurnDirty();
		LuaEvents.ITG_GeneralChooseWithPriority("CHOOSE DEPARTMENT")
	else
		DoAILogicForNewAcademy(iIndex, iOwner)
	end
end

function HumanPlayerChoosesAcademyBonus(iPlayer, department, acaIndex)
	local lkey;
	for i, sth in pairs(gT.Players[iPlayer].NewHumanQueueActions) do
		if sth.BonusType == "Department" and sth.TagToRemove == acaIndex then
			lkey = i;
			break;
		end
	end
	if lkey then
		table.remove(gT.Players[iPlayer].NewHumanQueueActions, lkey)
	end
	DoFullRandomIndustrialAcademyBonuses(acaIndex, 2, iPlayer, department)
	PlayerCompletedAcademyBonuses(iPlayer, acaIndex)
end

function GetAIFavouredAcademy(iOwner)
	local tab = {}
	table.insert(tab, {"Science", Players[iOwner]:GetFlavourValue("FLAVOR_SCIENCE")})
	table.insert(tab, {"Military", Players[iOwner]:GetFlavourValue("FLAVOR_OFFENSE")})
	table.insert(tab, {"Naval", Players[iOwner]:GetFlavourValue("FLAVOR_NAVAL")})
	table.insert(tab, {"Health", Players[iOwner]:GetFlavourValue("FLAVOR_GROWTH")})
	table.insert(tab, {"Production", Players[iOwner]:GetFlavourValue("FLAVOR_PRODUCTION")})
	table.insert(tab, {"Economy", Players[iOwner]:GetFlavourValue("FLAVOR_GOLD")})
	table.insert(tab, {"Archaeology", Players[iOwner]:GetFlavourValue("FLAVOR_ARCHAEOLOGY")})
	table.insert(tab, {"National", Players[iOwner]:GetFlavourValue("FLAVOR_CULTURE")})
	return GetRandomFromBiasedChanceTable(tab)
end

function DoAILogicForNewAcademy(iIndex, iOwner)
	if not gT.Players[iOwner].AIFavourAcademy then
		gT.Players[iOwner].AIFavourAcademy = GetAIFavouredAcademy(iOwner)
	end
	DoFullRandomIndustrialAcademyBonuses(iIndex, 2, iOwner, gT.Players[iOwner].AIFavourAcademy)
	PlayerCompletedAcademyBonuses(iOwner, iIndex)
end

function GetRandomBonusTypeForUniversityAcademy(iCity)
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local tab = {"Science", "Military", "Health", "Production"}
	if gT.Cities[cID].CanDoWorkboats then
		table.insert(tab, "Naval")
	end
	if gT.Globals.ScenarioType == 4  then
		table.insert(tab, "Archaeology")
		table.insert(tab, "National")
		table.insert(tab, "Economy")
	elseif gT.Globals.ScenarioType == 2 then
		table.insert(tab, "Faith")
	end
	return tab[LastRandom(1,#tab)];
end

function DoFullRandomIndustrialAcademyBonuses(iIndex, amount, iOwner, exclusion)
	local tab = {"Science", "Military", "Naval", "Health", "Production", "Economy", "Archaeology", "National"}
	if not gT.Academies[iIndex].CanHaveNaval then
		if exclusion == "Naval" then
			DoFullRandomIndustrialAcademyBonuses(iIndex, amount + 1, iOwner) -- AI will random all elements then;
			return;
		end
		table.remove(tab, 3) -- removing naval from randoming
	end
	gT.Academies[iIndex].Bonuses = {}
	if exclusion then
		table.remove(tab, GetIDOfElement(tab, exclusion))
		gT.Academies[iIndex].Bonuses[exclusion] = 0
	end
	tab = Shuffle(tab);
	for i = 1, amount do
		gT.Academies[iIndex].Bonuses[tab[i]] = 0;
	end
	HandleInitialAcademyBonuses(iIndex, iOwner)
end

function HandleJustInitialName(iIndex, iOwner)
	if gT.Globals.AcademyRecreation then
		local cLt = gT.EraData[gT.PreviousEra].Academies[gT.Globals.AcademyRecreation];
		gT.Academies[iIndex].Name = cLt.Name;
		gT.Academies[iIndex].ActiveSince = cLt.ActiveSince;
		gT.Academies[iIndex].TurnFounded = cLt.TurnFounded;
		gT.Academies[iIndex].ScenarioFounded = cLt.ScenarioFounded;
		gT.Academies[iIndex].OriginalPlayer = cLt.OriginalPlayer;
		gT.Academies[iIndex].Year = cLt.Year;
	else
		gT.Academies[iIndex].Name = GetValidNameForAcademy(gT.Academies[iIndex].CityName)
	end
end

function HandleInitialAcademyBonuses(iIndex, iOwner, bInitial)
	if gT.Players[iOwner].HasPlayerWonder[gmedwonder10] then
		gT.Academies[iIndex].SultanHassan = true;
		if gT.Academies[iIndex].Bonuses.Faith then
			for i = 1, 4 do
				AddBonusToAcademy(iIndex, "Faith")
			end
		end
	end
	if gT.Globals.AcademyRecreation then
		local cLt = gT.EraData[gT.PreviousEra].Academies[gT.Globals.AcademyRecreation];
		local bonusTab = {}
		local total = 0;
		local htttab = {}
		local bScience = false;
		for s, h in pairs(gT.Academies[iIndex].Bonuses) do
			table.insert(htttab, s)
			if cLt.Bonuses[s] then
				if s == "Science" then
					bScience = true;
					table.insert(bonusTab, {s, cLt.Bonuses[s] - 2})
					total = total + cLt.Bonuses[s] - 2
				else
					table.insert(bonusTab, {s, cLt.Bonuses[s]})
					total = total + cLt.Bonuses[s]
				end
			end
		end
		total = math.min(total, 5);
		if (gT.Globals.ScenarioType ~= 4) then
			bScience = false;
			total = total + 2;
			if #htttab < total then
				for i, stype in pairs(htttab) do
					AddBonusToAcademy(iIndex, stype)
				end
				total = total - #htttab;
			end
		elseif not bScience then
			total = total + 2;
		end
		for i = 1, total do
			local hKey = GetRandomFromBiasedChanceTable(bonusTab, true)
			if hKey then
				bonusTab[hKey][2] = bonusTab[hKey][2] - 1;
				AddBonusToAcademy(iIndex, bonusTab[hKey][1])
			else
				AddBonusToAcademy(iIndex, htttab[LastRandom(1,#htttab)])
			end
		end
		gT.Academies[iIndex].NumAcquiredBonuses = total - 2;
		gT.Academies[iIndex].PointsTowardBonus = LastRandom(1, 5) * 10;
		gT.Academies[iIndex].Prestige = LastRandom(100, 275);
		gT.Academies[iIndex].StagnationMod = -0.02 * LastRandom(0, 15);
		if bScience then
			AddBonusToAcademy(iIndex, "Science")
			AddBonusToAcademy(iIndex, "Science")
		end
		gT.Globals.AcademyRecreation = nil;
	else
		local initbonus = 2;
		if HasPlayerTech(iOwner, GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_ARABIA_3, "^23432") then
			initbonus = initbonus + 4;
		end
		if bInitial then
			initbonus = initbonus + LastRandom(1,3)
			gT.Academies[iIndex].NumAcquiredBonuses = LastRandom(0, initbonus -2)
			gT.Academies[iIndex].PointsTowardBonus = LastRandom(1, 5) * 10;
			gT.Academies[iIndex].Prestige = LastRandom(100, 275);
			gT.Academies[iIndex].StagnationMod = -0.02 * LastRandom(0, 15);
		end
		if (gT.Academies[iIndex].Bonuses["Science"]) and (gT.Globals.ScenarioType ~= 4) then
			AddBonusToAcademy(iIndex, "Science")
			AddBonusToAcademy(iIndex, "Science")
		else
			initbonus = initbonus + 2;
		end
		local htttab = {}
		for bonusType, sth in pairs(gT.Academies[iIndex].Bonuses) do
			if sth == 0 then
				table.insert(htttab, bonusType)
			end
		end
		if #htttab < initbonus then
			for i, stype in pairs(htttab) do
				AddBonusToAcademy(iIndex, stype)
			end
			initbonus = initbonus - #htttab;
		end
		for i = 1, initbonus do
			AddBonusToAcademy(iIndex, "Random")
		end
	end
end

function DoAddFounderToAcademy(pPlot, pGP)
	gT.Academies[pPlot:GetPlotIndex()].FounderGP = gT.GreatPeople[pGP].Name
end

local validNamAca = {
{"Madrasah"},
{"Academy"},
{"College"},
{"Seminary"},
{"Gurukula"},
{"University of", true},
{"Polytechnique de", true}
}

function GetValidNameForAcademy(iCityname)
	local tab = {}
	for h, s in pairs(validNamAca) do
		if s[2] then
			table.insert(tab, s[1] .. " " .. iCityname)
		else
			table.insert(tab, iCityname .. " " .. s[1])
		end
	end
	tab = Shuffle(tab)
	for i, s in pairs(tab) do
		local bRet = true
		for index, sth in pairs(gT.Academies) do
			if sth.Name == s then
				bRet = false;
			end
		end
		if bRet then
			return s;
		end
	end
	print("Error 132674/234")
end

function GetGeneralPointsFromAcademies(iPlayer, type)
	local points = 0;
	for index, data in pairs(gT.Academies) do
		if data.Player == iPlayer then
			if IsAcademyActiveRightNow(index) then
				if data.Bonuses[type] then
					points = points + data.Bonuses[type] - math.floor(data.Bonuses[type] / 5);
				end
			end
		end
	end
	return points;
end

function GetNumActiveAcademies(iPlayer)
	local s = 0;
	for index, data in pairs(gT.Academies) do
		if data.Player == iPlayer then
			if IsAcademyActiveRightNow(index) then
				s = s + 1;
			end
		end
	end
	return s;
end

function GetCityBasicPointsFromAcademies(iCity, cID, type)
	local base = 0;
	for i, index in pairs(gT.Cities[cID].Academies) do
		if IsAcademyActiveRightNow(index) then
			if gT.Academies[index].Bonuses[type] then
				base = base + gT.Academies[index].Bonuses[type] - math.floor(gT.Academies[index].Bonuses[type] / 5);
			end
		end
	end
	return base;
end

function UpdateProductionFromAcademies(iPlayer)
-- this also updates Gold
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		local points = GetCityBasicPointsFromAcademies(iCity, cID, "Production");
		points = points + GetNumCityAcademiesWithAbility(iCity, 5) * 5;
		SetBasicCityYieldRate(iCity, yProduction, points, "CI_PROD_ACADEMY")
		local goldpoints = 2 * GetCityBasicPointsFromAcademies(iCity, cID, "Economy");
		SetBasicCityYieldRate(iCity, yGold, goldpoints, "CI_GOLD_ACADEMY")
	end
end

function AcademiesPrestigeOverTurn()
	DoSetLastTurnActiveAcademy()
	FadePrestigeInAllAcademies(); -- NOW BEFORE FOR BETTER APPROX OF NETTO PRESTIGE GROWTH
	DoAddPrestigeBonusesFromCityScience();
	DoCheckActiveOldestAcademies();
	DoMakeARankingOfActiveAcademies(true);
	--OLD PLACE OF FADE
	DoRemovePrestigeModifiers();
	DoPassiveIncreaseAcademies();
end

function InitialAcademyMatters()
	DoCheckActiveOldestAcademies()
	DoMakeARankingOfActiveAcademies(false)
end

function PlayerSupportAcademy(iIndex, iPlayer, type)
	if DBScenario.GoldBudgetOnly then
		print("Player supported academy in budget mode", iPlayer, type)
		return;
	end
	if GetITGGameTurn() <= gT.Academies[iIndex].SupportCD then
		print("Error 923/512/233")
		return;
	end
	if type == "Random" then
		if Players[iPlayer]:GetGold() < 100 then
			return;
		end
	elseif Players[iPlayer]:GetGold() < ACADEMY_SUPPORT_NO_RANDOM_GOLD then
		return;
	end
	if Players[iPlayer]:IsHuman() then
		LuaEvents.ITG_AchievementCountChange(86, 1)
	end
	BasicCSMissionCompleteFunc(iPlayer, 15, 1)
	DoSupportToAcademy(iIndex, iPlayer, type)
end
LuaEvents.ITGSG_PlayerSupportAcademy.Add(PlayerSupportAcademy)

function DoSupportToAcademy(iIndex, iPlayer, type, bFree)
	DoIncreasementStockExchange(6)
	if not bFree then
		if type == "Random" then
			SpendITGGold(iPlayer, 100, true)
			gT.Players[iPlayer].GoldSpentOnAcademies = gT.Players[iPlayer].GoldSpentOnAcademies + 100;
		else
			SpendITGGold(iPlayer, 125, true)
			gT.Players[iPlayer].GoldSpentOnAcademies = gT.Players[iPlayer].GoldSpentOnAcademies + 125;
		end
	end
	VictoryTaskCompletion(iPlayer, 59)
	local tcC = 9;
	local tcD = 4;
	if gT.Players[iPlayer].HasPlayerWonder[wonderindu7] then
		ChangeITGCulture(iPlayer, 20)
		ChangeITGScience(iPlayer, 20)
	end
	gT.Academies[iIndex].SupportCD = GetITGGameTurn() + tcC;
	DoAddTempPrestigeModifier(iIndex, 0.2, GetITGGameTurn() + tcD, "Support")
	AddBonusToAcademy(iIndex, type)
	DiploNoteDirty(iPlayer, 18)
end

function DecideWhatToSupportInAcademyAI(index, iPlayer)
	local bbb = {}
	for hh, sth in pairs(gT.Academies[index].Bonuses) do
		if sth % 5 == 4 then
			table.insert(bbb, hh)
		end
	end
	if #bbb > 0 then
		PlayerSupportAcademy(index, iPlayer, bbb[LastRandom(1,#bbb)]);
	else
		PlayerSupportAcademy(index, iPlayer, "Random")
	end
end

function DoAddRandomBonusToAcademy(iIndex)
	local tab = {}
	for string, sth in pairs(gT.Academies[iIndex].Bonuses) do
		table.insert(tab, string)
	end
	AddBonusToAcademy(iIndex, tab[LastRandom(1,#tab)])
end

function DoClearYieldFromAcademyOnPlot(index)
	local iPlot = Map.GetPlotByIndex(index);
	if gT.Academies[index].Bonuses["Science"] then
		local toremove =  math.floor(gT.Academies[index].Bonuses["Science"]/5) - gT.Academies[index].Bonuses["Science"]
		if toremove ~= 0 then
			iPlot:ChangeYieldIfNotPillaged(yScience, toremove)
		end
	end
	if gT.Academies[index].Bonuses["Faith"] then
		local toremove =  math.floor(gT.Academies[index].Bonuses["Faith"]/5) - gT.Academies[index].Bonuses["Faith"]
		if toremove ~= 0 then
			iPlot:ChangeYieldIfNotPillaged(yFaith, toremove)
		end
	end
	DoRemoveAcademyRewardsEndEra(index)
end

function AddBonusToAcademy(iIndex, type)
	if type == "Random" then
		DoAddRandomBonusToAcademy(iIndex);
	else
		gT.Academies[iIndex].Bonuses[type] = gT.Academies[iIndex].Bonuses[type] + 1;
		if gT.Academies[iIndex].Bonuses[type] == 15 then
			if Players[gT.Academies[iIndex].Player]:IsHuman() then
				LuaEvents.ITG_AchievementCompleted(21)
			end
		end
		if gT.Academies[iIndex].Bonuses[type] % 5 == 0 then
			AddKeystoneAbility(iIndex, type)
		else
			if type == "Science" then
				Map.GetPlotByIndex(iIndex):ChangeYieldIfNotPillaged(yScience, 1)
			elseif type == "Military" then
			elseif type == "Naval" then
			elseif type == "Faith" then
				Map.GetPlotByIndex(iIndex):ChangeYieldIfNotPillaged(yFaith, 1)
			elseif type == "Health" then
			elseif type == "Production" then
			elseif type == "Economy" then
			elseif type == "Archaeology" then
			elseif type == "National" then
			end
		end
	end
end

function DoSpecialLightOfHopeAcademyDistribution()
	local plaAca = {}
	for g, gh in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			plaAca[g] = math.ceil(LastRandom(1,5) / 4)
		end
	end
	if gT.EraData and gT.PreviousEra then 
		for i, data in pairs(gT.EraData[gT.PreviousEra].Academies) do
			gT.Globals.AcademyRecreation = i;
			local city = GetCityByName(data.CityName)
			local iPlayer;
			if city then
				iPlayer = city:GetOwner();
			else
				iPlayer = data.OriginalPlayer
			end
			if plaAca[iPlayer] then
				if plaAca[iPlayer] > 0 then
					plaAca[iPlayer] = plaAca[iPlayer] - 1;
					CreateGreatPersonImprovementIfPossible(GameInfoTypes.IMPROVEMENT_ACADEMY, iPlayer, city)
				end
			end
		end
	end
--	
	local pTab = {}
	for i, gd in pairs(gT.Players) do
		if plaAca[i] then
			for j = 1, plaAca[i] do
				CreateGreatPersonImprovementIfPossible(GameInfoTypes.IMPROVEMENT_ACADEMY, i)
			end
		end
	end
end

function AssignInitialAcademies(numMajorPlayers)
	if gT.Globals.ScenarioType == 4 then
		DoSpecialLightOfHopeAcademyDistribution()
		return;
	end
	local amAcademies = math.min(numMajorPlayers, DBScenario.NumAcademies);
	--if very small amount of players
	if gT.EraData and gT.PreviousEra then 
		local numprevAcad = #gT.EraData[gT.PreviousEra].Academies
		if numprevAcad > amAcademies then
			gT.EraData[gT.PreviousEra].Academies = Shuffle(gT.EraData[gT.PreviousEra].Academies)
			for i, data in pairs(gT.EraData[gT.PreviousEra].Academies) do
				if not GetCityByName(data.CityName) then
					gT.EraData[gT.PreviousEra].Academies[i].DoNotRedo = true;
					numprevAcad = numprevAcad - 1;
					if numprevAcad == amAcademies then
						break;
					end
				end
			end
		end
		for i, data in pairs(gT.EraData[gT.PreviousEra].Academies) do
			if not data.DoNotRedo then
				gT.Globals.AcademyRecreation = i;
				local city = GetCityByName(data.CityName)
				if city then
					CreateGreatPersonImprovementIfPossible(GameInfoTypes.IMPROVEMENT_ACADEMY, city:GetOwner(), city)
				else
					CreateGreatPersonImprovementIfPossible(GameInfoTypes.IMPROVEMENT_ACADEMY, data.OriginalPlayer)
				end
				if not gT.Globals.AcademyRecreation then
					amAcademies = amAcademies - 1;
					if amAcademies == 0 then
						return;
					end
				end
			end
		end
	end
--	
	local pTab = {}
	for i, gd in pairs(gT.Players) do
		if not Players[i]:IsMinorCiv() then
			if GetDBCulturePlayerInfo(i, "CanInitAcademy") then
				table.insert(pTab, {i, GetDBCulturePlayerInfo(i, "AcademyChance")})
			end
		end
	end
	if #pTab > 0 then
		for i = 1, amAcademies do
			local lkey = GetRandomFromBiasedChanceTable(pTab, true);
			pTab[lkey][2] = math.max(1, math.floor(3 * pTab[lkey][2] / 4));
			CreateGreatPersonImprovementIfPossible(GameInfoTypes.IMPROVEMENT_ACADEMY, pTab[lkey][1])
		end
	end
end

function GetNumOfAcademies(iPlayer)
	local t = 0;
	for g, s in pairs(gT.Academies) do
		if s.Player == iPlayer then
			t = t + 1;
		end
	end
	return t;
end

function HasAnyAcademy(iPlayer)
	for g, s in pairs(gT.Academies) do
		if s.Player == iPlayer then
			return true;
		end
	end
	return false;
end

function HasAnyOriginalAcademy(iPlayer)
	for g, s in pairs(gT.Academies) do
		if s.OriginalPlayer == iPlayer then
			return true;
		end
	end
	return false;
end

function GetITGAcademyCost(iPlayer)
	return (DBScenario.AcademyCost + gT.Players[iPlayer].ExtraAcademyCost)
end

function CanPurchaseAcademyBasic(iPlayer)
	if DBScenario.GoldBudgetOnly then
		return false;
	end
	if gT.Players[iPlayer].CanPurchaseAcademy then
		if Players[iPlayer]:GetNumCities() > 0 then
			if MultipleAcademyScenario[gT.Globals.ScenarioType] or ((#gT.Players[iPlayer].AcademyPoints == 0) and (not HasAnyOriginalAcademy(iPlayer))) then
				return true;
			end
		end
	end
	return false;
end		

LuaEvents.ITGSG_CanPlayerPurchaseAcademy.Add(function(iPlayer)
	MapModData.ITGSG = CanPurchaseAcademyBasic(iPlayer);
end)

function DoPlayerPurchaseAcademyPoint(iPlayer)
	if CanPurchaseAcademyBasic(iPlayer) then
		if Players[iPlayer]:GetGold() >= GetITGAcademyCost(iPlayer) then
			SpendITGGold(iPlayer, GetITGAcademyCost(iPlayer), true)
			gT.Players[iPlayer].ExtraAcademyCost = gT.Players[iPlayer].ExtraAcademyCost + DBScenario.EPPAcademyCost;
			table.insert(gT.Players[iPlayer].AcademyPoints, "FREE")
			if HasPlayerTech(iPlayer, innoindo20, "kocsiaeje") then
				BoostHappinessInAllCities(iPlayer, 1)
			end
			IfActiveThenRefreshDirty(iPlayer)
		end
	end
end
LuaEvents.ITG_CallPurchaseAcademy.Add(DoPlayerPurchaseAcademyPoint)

function AddAnExtraDepartment(iPlayer, tag, sForce)
	for index, data in pairs(gT.Academies) do
		if data.Player == iPlayer then
			if not data[tag] then
				gT.Academies[index][tag] = 1;
				DoAddExtraDepartmentInAcademy(index, sForce)
			end
		end
	end
end

function DoAddExtraDepartmentInAcademy(index, sForce)
	if sForce then
		if not gT.Academies[index].Bonuses[sForce] then
			gT.Academies[index].Bonuses[sForce] = 0;
			AddBonusToAcademy(index, sForce)
			AddBonusToAcademy(index, sForce)
			return;
		end
	end
	local tab = {"Science", "Military", "Naval", "Health", "Production", "Economy", "Archaeology", "National"}
	if not gT.Academies[index].CanHaveNaval then
		table.remove(tab, 3)
	end
	local fTab = {}
	for i, h in pairs(tab) do
		if not gT.Academies[index].Bonuses[h] then
			table.insert(fTab, h)
		end
	end
	if #fTab > 0 then
		local fc = fTab[LastRandom(1, #fTab)];
		gT.Academies[index].Bonuses[fc] = 0;
		AddBonusToAcademy(index, fc)
		AddBonusToAcademy(index, fc)
	end
end

function PlayerCompletedAcademyBonuses(iOwner, iIndex)
	if HasPlayerTech(iOwner, innoindu13, "adkacmeoe") then
		gT.Academies[iIndex].Electromagnetism = 1;
		DoAddExtraDepartmentInAcademy(iIndex, "Science")
	end
end