local innomodern24 =  GameInfoTypes.TECH_UNIQUE_ITG_MODERN_24;
local BuildingsAcademyDepertments = {
{GameInfoTypes.BUILDING_ITG_HOSPITAL,"Health",5},
{GameInfoTypes.BUILDING_ITG_MILITARY_ACADEMY,"Military",5},
{GameInfoTypes.BUILDING_ITG_STOCK_EXCHANGE,"Economy",5},
{GameInfoTypes.BUILDING_ITG_FACTORY,"Production",5},
{GameInfoTypes.BUILDING_ITG_MODERN_FACTORY,"Production",5},
{GameInfoTypes.BUILDING_ITG_MODERN_STOCK_EXCHANGE,"Economy",5},
{GameInfoTypes.BUILDING_ITG_MODERN_SEAPORT,"Marine",5},
{GameInfoTypes.BUILDING_ITG_MODERN_MILITARY_ACADEMY,"Military",5},
{GameInfoTypes.BUILDING_ITG_IND_OBSERVATORY,"Science",5},
}

function TechInnoDiscoveredAcademyPrestige(iPlayer, techID, teamID)
	--well multiple player team is not supported anyway?
	local bFirst = (not gT.TechsDisc[techID]) or (gT.TechsDisc[techID] == teamID)
	gT.TechsDisc[techID] = teamID;
	if gT.Globals.GameGenerated then
		local tabOfAcademies = {}
		for index, data in pairs(gT.Academies) do
			if data.Player == iPlayer then
				if IsAcademyActiveRightNow(index) then
					table.insert(tabOfAcademies, index);
				end
			end
		end
		if #tabOfAcademies > 0 then
			local lAcademy = RandomFromTab(tabOfAcademies);
			local bonus = LastRandom(65, 80);
			if bFirst then
				bonus = bonus * 2;
			end
			AddPrestigeToAcademy(lAcademy, bonus, "New Technology")
		end
	end
end

function IsAcademyActiveRightNow(index)
	if not gT.Academies[index].Bonuses then
		return false;
	end
	if gT.Academies[index].KeyAbilities[17] then
		return true;
	end
	if not Map.GetPlotByIndex(index):IsImprovementPillaged() then
		return true;
	end
	return false;

end

function AddPrestigeToAcademy(lAcademy, tot, sReason)
	if not (gT.Academies[lAcademy]) then
		print("Bad Academy stuff!",lAcademy, bonus, sReason)
		return;
	end
	gT.Academies[lAcademy].Prestige = gT.Academies[lAcademy].Prestige + tot
	if gT.Academies[lAcademy].Prestige > gT.Academies[lAcademy].MaxPrestigeEver then
		gT.Academies[lAcademy].MaxPrestigeEver = gT.Academies[lAcademy].Prestige
		gT.Academies[lAcademy].MaxPrestigePlayer = gT.Academies[lAcademy].Player
		gT.Academies[lAcademy].MaxPrestigeTurn = GetITGGameTurn();
	end
	if sReason then
		table.insert(gT.Academies[lAcademy].RecentLog, {tot, sReason})
		if #gT.Academies[lAcademy].RecentLog > 10 then
			table.remove(gT.Academies[lAcademy].RecentLog, 1)
		end
	end
end

function GetModOfAcademyPrestige(lAcademy)
	local extraMod = gT.Academies[lAcademy].StagnationMod + gT.Academies[lAcademy].NationalMod;
	for i, row in pairs(gT.Academies[lAcademy].PrestigeTempMods) do
		extraMod = extraMod + row[1];
	end
	return math.max(-1, extraMod)
end

function DoAcademiesGreatPersonBorn(oCity, type)
	local lTab = GetAllAcademiesNearCity(oCity);
	if #lTab > 0 then
		local lA = lTab[LastRandom(1,#lTab)];
		if type == 9 or type == 3 or type == 4 then
			AddPrestigeToAcademy(lA, LastRandom(30, 70), "New Great Person")
		else
			AddPrestigeToAcademy(lA, LastRandom(30, 50), "New Great Person")
		end
	end
end

function GetAllAcademiesNearCity(iCity)
	local tab = {}
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	for i, index in pairs(gT.Cities[cID].Academies) do
		if IsAcademyActiveRightNow(index) then
			table.insert(tab, index);
		end
	end
	return tab;
end

function DoSetLastTurnActiveAcademy()
	local rTurn = GetRealGameTurn()
	for index, sth in pairs(gT.Academies) do
		if not IsAcademyActiveRightNow(index) then
			if sth.Active then
				gT.Academies[index].Active = false;
				gT.Academies[index].ActiveSince = -1;
				DoTurnAcademyInactive(index)
			end
			DoAcademyTurnBonusesOver(index)
		elseif not sth.Active then
			gT.Academies[index].Active = true;
			gT.Academies[index].ActiveSince = rTurn
			DoTurnAcademyActive(index)
		end
		gT.Academies[index].Player = Map.GetPlotByIndex(index):GetOwner();
	end
--	for g, h in pairs(gT.Players) do
--		if h.CultBonusOn[69] then
--			CheckEndTurnUniversityAcaRewards(g)
--		end
--	end
end

function GetPrestigeScienceModifier(iPlayer)
	local mod = 1
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_COMPUTERS, "^y3454") then
		mod = mod + 2;
	end
	return mod;
end

function GetPrestigeFromGoldenAge(iPlayer)
	if Players[iPlayer]:IsGoldenAge() then
		if gT.Players[iPlayer].HasMinorIdeology[6] then
			return 5;
		end
	end
	return 0;
end

function GetPrestigeFromFestival(iPlayer, cID)
	if gT.Players[iPlayer].CultBonusOn[121] then
		if gT.Cities[cID].FestivalET then
			return 10;
		end
	end
	return 0;
end

function GetPrestigeFromInnovations(iPlayer, iCity)
	local a = 0;
	if HasPlayerTech(iPlayer, innomodern24, "$%gf45") then
		if IsHasBuildingClass(iCity, GameInfoTypes.BUILDINGCLASS_MEDICAL_LAB) then
			a = a + 10;
		end
	end
	return a;
end

function GetPrestigeFromHealth(index, cID)
	if gT.Academies[index].KeyAbilities[68] and (gT.Academies[index].KeyAbilities[68][1] > 0) then
		if gT.Cities[cID].Health > 0 then
			return gT.Cities[cID].Health;
		end
	end
	return 0;
end

local modSciencePrestigeNumAca = {1, 0.6, 0.4, 0.3, 0.25, 0.2}
function GetPrestigeFromCityScience(science, amAcademies)
	return math.ceil(science * modSciencePrestigeNumAca[amAcademies]);
end

function DoAddPrestigeBonusesFromCityScience()
	local cityData = {}
	for index, h in pairs(gT.Academies) do
		if h.Active then
			local iCity = Map.GetPlotByIndex(h.City):GetPlotCity();
			local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
			local iPlayer = iCity:GetOwner();
			if not cityData[h.City] then
				cityData[h.City] = {math.floor(iCity:GetYieldRateTimes100(yScience) / 100), GetAcademyPrestigeForGPInCity(iCity), #GetAllAcademiesNearCity(iCity)}
			end
			local iChange = GetPrestigeFromGoldenAge(iPlayer) + GetPrestigeFromFestival(iPlayer, cID);
			iChange = iChange + GetPrestigeFromInnovations(iPlayer, iCity) + GetPrestigeFromHealth(index, cID);
			iChange = iChange + cityData[h.City][2] + GetPrestigeFromCityScience(cityData[h.City][1], cityData[h.City][3]);
			if iChange > 0 then
				iChange = math.floor(iChange * (1 + GetModOfAcademyPrestige(index)))
				if iChange > 0 then
					AddPrestigeToAcademy(index, iChange)
				end
			end
		end
	end
end

function DoCheckActiveOldestAcademies()
	local oldest, oldestactive = 9999, 9999;
	local tabBesties = {}
	for sType, sth in pairs(GetTabDepartmentData()) do
		tabBesties[sType] = 1;
	end
	for index, sth in pairs(gT.Academies) do
		if sth.Active then
			oldest = math.min(oldest, sth.TurnFounded)
			oldestactive = math.min(oldestactive, sth.ActiveSince)
			for str, value in pairs(tabBesties) do
				tabBesties[str] = math.max(value, sth.Bonuses[str] or 0)
			end
		end
	end
	--PrestigeDynamic
	for index, sth in pairs(gT.Academies) do
		if oldest == sth.TurnFounded then
			DoPrestigeBonusDynamic(index, "Oldest", 20)
		else
			DoPrestigeBonusDynamic(index, "Oldest", 0)
		end
		if oldestactive == sth.ActiveSince then
			DoPrestigeBonusDynamic(index, "OldestActive", 20)
		else
			DoPrestigeBonusDynamic(index, "OldestActive", 0)
		end
		for str, val in pairs(tabBesties) do
			if sth.Bonuses[str] == val then
				DoPrestigeBonusDynamic(index, str, 50)
			else
				DoPrestigeBonusDynamic(index, str, 0)
			end
		end
	end
	if gT.Globals.OfxordUni then
		local odt = 9999;
		local oxf;
		for i, aca in pairs(gT.Academies) do
			if aca.Player == gT.Globals.OfxordUni then
				if aca.TurnFounded < odt then
					odt = aca.TurnFounded;
					oxf = i;
				end
			end
		end
	
		if gT.Globals.OxfordAca then
			if oxf ~= gT.Globals.OxfordAca then
				DoPrestigeBonusDynamic(gT.Globals.OxfordAca, "Oxford", 0)
				if oxf then
					DoPrestigeBonusDynamic(oxf, "Oxford", 25)
				end
				gT.Globals.OxfordAca = oxf;
			end
		elseif oxf then
			gT.Globals.OxfordAca = oxf;
		end
	end
	local best, ptab = 1, {};
	for h, hh in pairs(gT.Players) do
		if hh.NumAncientRuins > best then
			best = hh.NumAncientRuins;
			ptab = {[h] = 1}
		elseif hh.NumAncientRuins == best then
			ptab[h] = 1;
		end
	end
	for index, sth in pairs(gT.Academies) do
		if ptab[sth.Player] then
			DoPrestigeBonusDynamic(index, "GoodyHuts", 10)
		else
			DoPrestigeBonusDynamic(index, "GoodyHuts", 0)
		end
		if gT.Players[sth.Player].HasIdeology[88] then
			DoPrestigeBonusDynamic(index, "Ideo88", 10 * GetNumAliveGPTotal(sth.Player))
		else
			DoPrestigeBonusDynamic(index, "Ideo88", 0)
		end
	end
end

function DoPrestigeBonusDynamic(index, type, nvalue)
	local olValue = gT.Academies[index].PrestigeDynamic[type] or 0;
	if olValue ~= nvalue then
		gT.Academies[index].PrestigeAnchor = gT.Academies[index].PrestigeAnchor + nvalue - olValue;
		AddPrestigeToAcademy(index, nvalue - olValue, nil) --, "Dynamic")
		gT.Academies[index].PrestigeDynamic[type] = nvalue;
	end
end

function DoMakeARankingOfActiveAcademies(bAddStagnation)
	local greatestTab = {}
	local tot = 0;
	for index, sth in pairs(gT.Academies) do
		tot = tot + 1;
		if sth.Active then
			table.insert(greatestTab, {index, sth.Prestige})
		else
			gT.Academies[index].Rank = nil;
		end
	end
	if tot > 0 then
		table.sort(greatestTab, SortFunctionForGreaterInteger2);
		local cV;
		local rank = 0;
		local tab = {}
		for h, hh in pairs(greatestTab) do
			if cV ~= hh[2] then
				cV = hh[2];
				if #tab > 0 then
					table.insert(tab, hh[1])
					tab = Shuffle(tab);
					for i, index in pairs(tab) do
						rank = rank + 1;
						gT.Academies[index].Rank = rank;
					end
					tab = {}
				else
					rank = rank + 1;
					gT.Academies[hh[1]].Rank = rank;
				end
			else
				table.insert(tab, hh[1]);
			end
		end
		if #tab > 0 then
			tab = Shuffle(tab);
			for i, index in pairs(tab) do
				rank = rank + 1;
				gT.Academies[index].Rank = rank;
			end
		end
		if bAddStagnation then
			local numAdd = math.max(1, math.min(5, math.floor(tot/2)));
			for index, sth in pairs(gT.Academies) do
				if sth.Rank and (sth.Rank <= numAdd) then
					gT.Academies[index].StagnationMod = math.max(-1 * DBScenario.MaxAcaStagnation / 100, sth.StagnationMod - 0.04);
				else
					gT.Academies[index].StagnationMod = math.min(0, sth.StagnationMod + 0.02);
				end
			end
		end
		DoAcademyRewardsAssign(tot)
	end
end

function FadePrestigeInAllAcademies()
	for index, sth in pairs(gT.Academies) do
		local dif = GetDifFadeAcademy(index);
		if dif > 0 then
			AddPrestigeToAcademy(index, dif, nil) --, "Anchor") -- correcting anchor
		elseif dif < 0 then
			AddPrestigeToAcademy(index, dif, nil)
		end
	end
end

function GetDifFadeAcademy(index)
	local dmd = 0.1;
	if not gT.Academies[index].Active then
		dmd = dmd + 0.05;
	end
	local tofade = gT.Academies[index].Prestige;
	local tonotfade = gT.Academies[index].PrestigeAnchor;
	tofade = math.max(0, tofade - tonotfade);
	return math.floor(tofade * (1 - dmd)) + tonotfade - gT.Academies[index].Prestige;
end

function DoRemovePrestigeModifiers()
	local cTurn = GetITGGameTurn();
	for index, sth in pairs(gT.Academies) do
		local tab = {}
		for i, data in pairs(sth.PrestigeTempMods) do
			if data[3] == cTurn then
				table.insert(tab, i)
			end
		end
		for i = 1, #tab do
			table.remove(gT.Academies[index].PrestigeTempMods, tab[#tab + 1 - i]);
		end
	end
end

function DoAddTempPrestigeModifier(index, val, lTurn, name)
	for i, data in pairs(gT.Academies[index].PrestigeTempMods) do
		if data[2] == name then
			gT.Academies[index].PrestigeTempMods[i][3] = math.max(lTurn, data[3]);
			gT.Academies[index].PrestigeTempMods[i][1] = val;
			return
		end
	end
	table.insert(gT.Academies[index].PrestigeTempMods, {val, name, lTurn})
end

function DoPassiveIncreaseAcademies()
	for i, data in pairs(gT.Academies) do
		if data.Active then
			ChangeAcademyProgress(i, GetAcademyPassiveGrowPerTurn(i))
		end
	end
end

function ChangeAcademyProgress(i, val)
	gT.Academies[i].PointsTowardBonus = gT.Academies[i].PointsTowardBonus + val;
	local treshold = 100 + gT.Academies[i].NumAcquiredBonuses * 20;
	if gT.Academies[i].PointsTowardBonus >= treshold then
		gT.Academies[i].PointsTowardBonus = gT.Academies[i].PointsTowardBonus - treshold;
		DoAddNewLevelPassiveAcademy(i)
	end
end

function IsAboveAverageAcademyPrestigeRank(i)
	if not gT.Academies[i].Rank then
		return false;
	end
	local num = 0;
	for a, t in pairs(gT.Academies) do
		num = num + 0.5;
	end
	return gT.Academies[i].Rank > num
end

function GetAcademyPassiveGrowPerTurn(i)
	local base = 10;
	local iPlayer = gT.Academies[i].Player;
	if not IsHasLaw(iPlayer, 27, 0) then	
		base = base + 4;
	end
	base = base + gT.Players[iPlayer].AcadPointsPerTurn
	if iPlayer == gT.Globals.OfxordUni then
		base = base + 5;
	end
	base = base + 3 * GetNumPlayerManufactoryTrait(iPlayer, 21)
	for league, sth in pairs(gT.Leagues) do
		if sth.Members[iPlayer] then
			if sth.Resolutions[1] then
				base = base + 4;
			end
			if sth.Resolutions[57] then
				if IsAboveAverageAcademyPrestigeRank(i) then
					base = base - 5;
				else
					base = base + 5;
				end
			end
		end
	end
	if gT.Players[iPlayer].CultBonusOn[197] then
		base = base + 4;
	end
	if gT.Academies[i].KeyAbilities[4] and (gT.Academies[i].KeyAbilities[4][1] > 0) then
		base = base + 5;
	end
	local iCity = Map.GetPlotByIndex(gT.Academies[i].City):GetPlotCity();
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	base = base + gT.Cities[cID].AcademyPassiveGen
	if IsCityHaveWonderRuinWithAbility(iCity, 20) then
		base = base + 4;
	end
	if gT.Players[iPlayer].CultBonusOn[121] then
		if gT.Cities[cID].FestivalET then
			base = base + 10;
		end
	end
	if gT.Players[iPlayer].HasIdeology[65] then
		base = base + GetNumOfGPCivilOfType(iPlayer, 3)
	end
	for jij, data in pairs(BuildingsAcademyDepertments) do
		if iCity:IsHasBuilding(data[1]) then
			if gT.Academies[i].Bonuses and gT.Academies[i].Bonuses[data[2]] then
				base = base + data[3];
			end
		end
	end
	if HasPlayerNatureWonder(iPlayer, GameInfoTypes.FEATURE_LAKE_VICTORIA) then
		base = base + 5;
	end
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_MODERN_24, "$%gf45") then
		if IsHasBuildingClass(iCity, GameInfoTypes.BUILDINGCLASS_MEDICAL_LAB) then
			base = base + 10;
		end
	end
	return base;
end

function DoAddNewLevelPassiveAcademy(i)
	gT.Academies[i].NumAcquiredBonuses = gT.Academies[i].NumAcquiredBonuses + 1;
	AddPrestigeToAcademy(i, LastRandom(10, 15), "New Ability")
	if HasPlayerTech(gT.Academies[i].Player, GameInfoTypes.TECH_UNIQUE_ITG_MODERN_23 , "Fecer") then
		BudgetIndustryBonus(gT.Academies[i].Player, 1)
	end
	AddBonusToAcademy(i, "Random")
end

function DoRefreshAcademyForUI(i)
	gT.Academies[i].UIapgpt = GetAcademyPassiveGrowPerTurn(i)
end