local uArchaeologist = GameInfoTypes.UNIT_ITG_ARCHAEOLOGIST
local innoindu5 = GameInfoTypes.TECH_UNIQUE_ITG_INDUSTRIAL_5
local cupTab = {"[ICON_TROPHY_GOLD]", "[ICON_TROPHY_SILVER]", "[ICON_TROPHY_BRONZE]"}
local TabOfNiceAnchorString = {
Oldest = "being the oldest academy",
OldestActive = "being the longest continuously working academy",
Faith = "the most famous Theologic Department",
Production = "the most inventive Engineering Department",
Science = "the most insightful Research Department",
Military = "the most cold-blooded Military Department",
Naval = "the most courageous Marine Department",
Health = "the most accomplished Medical Department",
Archaeology = "the most adventorous Archaeological Department", 
National = "the most patriotic National Department",
Economy = "the most successful Economic Department",
Oxford = "Oxford University",
GoodyHuts = "amount of Ancient Ruins discovered",
Ideo88 = "Great People",
}

function KeyAcaFunc2(index, bRemove)
	if bRemove then
		Map.GetPlotByIndex(index):ChangeYieldIfNotPillaged(yScience, -5)
	else
		Map.GetPlotByIndex(index):ChangeYieldIfNotPillaged(yScience, 5)
	end
end

function KeyAcaFunc16(index, bRemove, uCity, uPlayer)
	local iCity = uCity or Map.GetPlotByIndex(gT.Academies[index].City):GetPlotCity();
	if bRemove then
		AdjustStrengthOfOneCity(iCity, -DEF_FROM_ACA_ABILITY, true)
	else
		AdjustStrengthOfOneCity(iCity, DEF_FROM_ACA_ABILITY, true)
	end
end

function KeyAcaFunc26(index, bRemove)
	if bRemove then
		Map.GetPlotByIndex(index):ChangeYieldIfNotPillaged(yFaith, -5)
	else
		Map.GetPlotByIndex(index):ChangeYieldIfNotPillaged(yFaith, 5)
	end
end

function KeyAcaFunc21(index, bRemove, uCity, uPlayer)
	local iPlayer = uPlayer or gT.Academies[index].Player;
	if bRemove then
		gT.Players[iPlayer].NumTechToChooseFrom = gT.Players[iPlayer].NumTechToChooseFrom - 1;
	else
		gT.Players[iPlayer].NumTechToChooseFrom = gT.Players[iPlayer].NumTechToChooseFrom + 1;
	end
end

function KeyAcaFunc30(index, bRemove)
	local iPlayer = gT.Academies[index].Player;
	local iTeam = Players[iPlayer]:GetTeam();
	if bRemove then
		for i, iPlotIndex in pairs(gT.Academies[index].Visibility or {}) do
			Map.GetPlotByIndex(iPlotIndex):ChangeVisibilityCount(iTeam, -1)
		end
		if gT.Academies[index].LabelExpedition then
			RemoveLabelOnPlot(Map.GetPlotByIndex(gT.Academies[index].LabelExpedition), "AcademyExpedition", nil, nil, iPlayer)
			gT.Academies[index].LabelExpedition = nil;
		end
	else
		gT.Academies[index].DiscoveryCooldown = LastRandom(7, 9);
		local iPlot = GetNicePlotForExploreActionGPCivil(iPlayer);
		if iPlot then
			gT.Academies[index].Visibility = {}
			local iTeam = Players[iPlayer]:GetTeam();
			local sTab = GetPlotsInRadiusOfPlot(iPlot, 3);
			for h, hPlot in pairs(sTab) do
				hPlot:ChangeVisibilityCount(iTeam, 1)
				local iPlotIndex = hPlot:GetPlotIndex();
				table.insert(gT.Academies[index].Visibility, iPlotIndex);
				if gT.Globals.AncientRuins[iPlotIndex] then
					if not hPlot:AlreadyVisitedGoodyHut(iTeam) then
						AncientRuinsSetXY(iPlayer, nil, hPlot, iPlotIndex, nil)
					end
				end
			end
			if Players[iPlayer]:IsHuman() then --Game.GetActivePlayer() == iPlayer then
				gT.Academies[index].LabelExpedition = iPlot:GetPlotIndex()
				AddSmallInfo(iPlot, nil, "AcademyExpedition", nil, nil, nil, nil, iPlayer)
			end
		end
	end
end

function KeyAcaFunc31(index, bRemove, uCity, uPlayer)
	local iCity = uCity or Map.GetPlotByIndex(gT.Academies[index].City):GetPlotCity();
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	if bRemove then
		gT.Cities[cID].SpeedUpTrade = gT.Cities[cID].SpeedUpTrade - 2;
	else
		gT.Cities[cID].SpeedUpTrade = gT.Cities[cID].SpeedUpTrade + 2;
	end
end

function KeyAcaFunc32(index, bRemove, uCity, uPlayer)
	local i = uPlayer or gT.Academies[index].Player;
	if bRemove then
		gT.Players[i].LandAcaCritical = gT.Players[i].LandAcaCritical - 5;
	else
		gT.Players[i].LandAcaCritical = gT.Players[i].LandAcaCritical + 5;
	end
end

function KeyAcaFunc33(index, bRemove, uCity, uPlayer)
	local i = uPlayer or gT.Academies[index].Player;
	if bRemove then
		gT.Players[i].NavalAcaCritical = gT.Players[i].NavalAcaCritical - 5;
	else
		gT.Players[i].NavalAcaCritical = gT.Players[i].NavalAcaCritical + 5;
	end
end

function KeyAcaFunc34(index, bRemove, uCity, uPlayer)
	local iPlayer = uPlayer or gT.Academies[index].Player;
	if bRemove then
		gT.Players[iPlayer].AcaHealth = gT.Players[iPlayer].AcaHealth - 1;
	else
		gT.Players[iPlayer].AcaHealth = gT.Players[iPlayer].AcaHealth + 1;
	end
end

function KeyAcaFunc39(index, bRemove, uCity, uPlayer)
	local iPlayer = uPlayer or gT.Academies[index].Player;
	if bRemove then
		gT.Players[iPlayer].ExtraArcheologistMoves = gT.Players[iPlayer].ExtraArcheologistMoves - 2;
	else
		gT.Players[iPlayer].ExtraArcheologistMoves = gT.Players[iPlayer].ExtraArcheologistMoves + 2;
	end
end

function KeyAcaFunc35(index, bRemove, uCity, uPlayer)
	local iPlayer = uPlayer or gT.Academies[index].Player;
	if bRemove then
		gT.Players[iPlayer].AcaNatUnity = gT.Players[iPlayer].AcaNatUnity - 2.5;
	else
		gT.Players[iPlayer].AcaNatUnity = gT.Players[iPlayer].AcaNatUnity + 2.5;
	end
end

function KeyAcaFunc43(index, bRemove, uCity, uPlayer)
	local iPlayer = uPlayer or gT.Academies[index].Player;
	if bRemove then
		gT.Players[iPlayer].GlobalCultPresFromTech = gT.Players[iPlayer].GlobalCultPresFromTech - 30;
	else
		gT.Players[iPlayer].GlobalCultPresFromTech = gT.Players[iPlayer].GlobalCultPresFromTech + 30;
	end
end

function KeyAcaFunc44(index, bRemove, uCity, uPlayer)
	local iPlayer = uPlayer or gT.Academies[index].Player;
	if bRemove then
		gT.Players[iPlayer].AcaUnifyMod = gT.Players[iPlayer].AcaUnifyMod - 15;
	else
		gT.Players[iPlayer].AcaUnifyMod = gT.Players[iPlayer].AcaUnifyMod + 15;
	end
end

function KeyAcaFunc45(index, bRemove, uCity, uPlayer)
	local iPlayer = uPlayer or gT.Academies[index].Player;
	if bRemove then
		gT.Players[iPlayer].AcaDivideMod = gT.Players[iPlayer].AcaDivideMod + 10;
	else
		gT.Players[iPlayer].AcaDivideMod = gT.Players[iPlayer].AcaDivideMod - 10;
	end
end

function KeyAcaFunc46(index, bRemove, uCity, uPlayer)
	local iPlayer = uPlayer or gT.Academies[index].Player;
	if bRemove then
		gT.Players[iPlayer].ExtraAlliedCultPres = gT.Players[iPlayer].ExtraAlliedCultPres - 10;
	else
		gT.Players[iPlayer].ExtraAlliedCultPres = gT.Players[iPlayer].ExtraAlliedCultPres + 10;
	end
end

function KeyAcaFunc47(index, bRemove, uCity, uPlayer)
	local iPlayer = uPlayer or gT.Academies[index].Player;
	if bRemove then
		gT.Players[iPlayer].GlobalCultPresFromWonder = gT.Players[iPlayer].GlobalCultPresFromWonder - 50;
	else
		gT.Players[iPlayer].GlobalCultPresFromWonder = gT.Players[iPlayer].GlobalCultPresFromWonder + 50;
	end
end

function KeyAcaFunc48(index, bRemove)
	if bRemove then
		Map.GetPlotByIndex(index):ChangeYieldIfNotPillaged(yGold, -5)
	else
		Map.GetPlotByIndex(index):ChangeYieldIfNotPillaged(yGold, 5)
	end
end

function KeyAcaFunc49(index, bRemove, uCity, uPlayer)
	local iPlayer = uPlayer or gT.Academies[index].Player;
	if bRemove then
		gT.Players[iPlayer].CurrPowerAcad = gT.Players[iPlayer].CurrPowerAcad - 35;
	else
		gT.Players[iPlayer].CurrPowerAcad = gT.Players[iPlayer].CurrPowerAcad + 35;
	end
end

function KeyAcaFunc50(index, bRemove, uCity, uPlayer)
	local iPlayer = uPlayer or gT.Academies[index].Player;
	if bRemove then
		gT.Players[iPlayer].TradeGoldModAcademies = gT.Players[iPlayer].TradeGoldModAcademies - 0.15;
	else
		gT.Players[iPlayer].TradeGoldModAcademies = gT.Players[iPlayer].TradeGoldModAcademies + 0.15;
	end
end

function KeyAcaFunc53(index, bRemove, uCity, uPlayer)
	local iPlayer = uPlayer or gT.Academies[index].Player;
	if bRemove then
		gT.Players[iPlayer].DefAgainstCounterfeit = gT.Players[iPlayer].DefAgainstCounterfeit - 15;
	else
		gT.Players[iPlayer].DefAgainstCounterfeit = gT.Players[iPlayer].DefAgainstCounterfeit + 15;
	end
end
function KeyAcaFunc54(index, bRemove, uCity, uPlayer)
	local iPlayer = uPlayer or gT.Academies[index].Player;
	if bRemove then
		gT.Players[iPlayer].WorkRateToScience = gT.Players[iPlayer].WorkRateToScience - 0.01;
	else
		gT.Players[iPlayer].WorkRateToScience = gT.Players[iPlayer].WorkRateToScience + 0.01;
	end
end
function KeyAcaFunc55(index, bRemove, uCity, uPlayer)
	local iPlayer = uPlayer or gT.Academies[index].Player;
	if bRemove then
		gT.Players[iPlayer].ImproGWChance = gT.Players[iPlayer].ImproGWChance - 5;
	else
		gT.Players[iPlayer].ImproGWChance = gT.Players[iPlayer].ImproGWChance + 5;
	end
end
function KeyAcaFunc56(index, bRemove, uCity, uPlayer)
	local iPlayer = uPlayer or gT.Academies[index].Player;
	if bRemove then
		gT.Players[iPlayer].CultPresOnGW = gT.Players[iPlayer].CultPresOnGW - 2;
	else
		gT.Players[iPlayer].CultPresOnGW = gT.Players[iPlayer].CultPresOnGW + 2;
	end
end
function KeyAcaFunc60(index, bRemove, uCity, uPlayer)
	local iPlayer = uPlayer or gT.Academies[index].Player;
	if bRemove then
		ChangeExtraSupply(iPlayer, -3)
	else
		ChangeExtraSupply(iPlayer, 3)
	end
end
function KeyAcaFunc62(index, bRemove, uCity, uPlayer)
	local iPlayer = uPlayer or gT.Academies[index].Player;
	if bRemove then
		gT.Players[iPlayer].UnitGoldCostChange = gT.Players[iPlayer].UnitGoldCostChange + 10;
	else
		gT.Players[iPlayer].UnitGoldCostChange = gT.Players[iPlayer].UnitGoldCostChange - 10;
	end
	DoDirtyUnitGoldCost(iPlayer);
end
function KeyAcaFunc63(index, bRemove, uCity, uPlayer)
	local iPlayer = uPlayer or gT.Academies[index].Player;
	if bRemove then
		Players[iPlayer]:ChangeImprovementYieldChange(GameInfoTypes.IMPROVEMENT_MANUFACTORY, yProduction, -1)
	else
		Players[iPlayer]:ChangeImprovementYieldChange(GameInfoTypes.IMPROVEMENT_MANUFACTORY, yProduction, 1)
	end
end
function KeyAcaFunc64(index, bRemove, uCity, uPlayer)
	local iPlayer = uPlayer or gT.Academies[index].Player;
	if bRemove then
		Players[iPlayer]:ChangeImprovementYieldChange(GameInfoTypes.IMPROVEMENT_MANUFACTORY, yGold, -1)
		Players[iPlayer]:ChangeImprovementYieldChange(GameInfoTypes.IMPROVEMENT_CUSTOMS_HOUSE, yGold, -1)
	else
		Players[iPlayer]:ChangeImprovementYieldChange(GameInfoTypes.IMPROVEMENT_MANUFACTORY, yGold, 1)
		Players[iPlayer]:ChangeImprovementYieldChange(GameInfoTypes.IMPROVEMENT_CUSTOMS_HOUSE, yGold, 1)
	end
end
function KeyAcaFunc65(index, bRemove, uCity, uPlayer)
	local iPlayer = uPlayer or gT.Academies[index].Player;
	if bRemove then
	else
	end
end
function KeyAcaFunc69(index, bRemove, uCity, uPlayer)
	local iPlayer = uPlayer or gT.Academies[index].Player;
	if bRemove then
		Players[iPlayer]:ChangeGreatGeneralCombatBonus(-4)
	else
		Players[iPlayer]:ChangeGreatGeneralCombatBonus(4)
	end
end

function KeyAcaFunc72(index, bRemove, uCity, uPlayer)
	local iPlayer = uPlayer or gT.Academies[index].Player;
	if bRemove then
		gT.Players[iPlayer].AcademyMeritocracy = gT.Players[iPlayer].AcademyMeritocracy - 1;
	else
		gT.Players[iPlayer].AcademyMeritocracy = gT.Players[iPlayer].AcademyMeritocracy + 1;
	end
end
function KeyAcaFunc73(index, bRemove, uCity, uPlayer)
	local iPlayer = uPlayer or gT.Academies[index].Player;
	if bRemove then
		gT.Players[iPlayer].AcaCodexInfluence = gT.Players[iPlayer].AcaCodexInfluence - 33;
	else
		gT.Players[iPlayer].AcaCodexInfluence = gT.Players[iPlayer].AcaCodexInfluence + 33;
	end
end
function KeyAcaFunc57(index, bRemove, uCity, uPlayer)
	local iPlayer = uPlayer or gT.Academies[index].Player;
	if bRemove then
		gT.Players[iPlayer].CultPresWeakerCurrency = gT.Players[iPlayer].CultPresWeakerCurrency - 3;
	else
		gT.Players[iPlayer].CultPresWeakerCurrency = gT.Players[iPlayer].CultPresWeakerCurrency + 3;
	end
end
function KeyAcaFunc58(index, bRemove, uCity, uPlayer)
	local iPlayer = uPlayer or gT.Academies[index].Player;
	if bRemove then
		gT.Players[iPlayer].CulturePresAnchor = gT.Players[iPlayer].CulturePresAnchor - 50;
	else
		gT.Players[iPlayer].CulturePresAnchor = gT.Players[iPlayer].CulturePresAnchor + 50;
	end
end

function KeyAcaFunc52(index, bRemove, uCity, uPlayer)
	local iPlayer = uPlayer or gT.Academies[index].Player;
	if bRemove then
		for res, i in pairs(gT.Globals.ResourcesInScenario) do
			Players[iPlayer]:ChangeNumResourceTotal(res, -2)
		end
	else
		for res, i in pairs(gT.Globals.ResourcesInScenario) do
			Players[iPlayer]:ChangeNumResourceTotal(res, 2)
		end
	end
end


function KeyAcaFunc36(index, bRemove, uCity, uPlayer)
	local iCity = uCity or Map.GetPlotByIndex(gT.Academies[index].City):GetPlotCity();
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	if bRemove then
		gT.Cities[cID].CPfromAca = gT.Cities[cID].CPfromAca - 5;
	else
		gT.Cities[cID].CPfromAca = gT.Cities[cID].CPfromAca + 5;
	end
end

function KeyAcaEndFunc30(index)
	if gT.Academies[index].DiscoveryCooldown then
		gT.Academies[index].DiscoveryCooldown = gT.Academies[index].DiscoveryCooldown - 1;
		if gT.Academies[index].DiscoveryCooldown <= 0 then
			KeyAcaFunc30(index, true)
			KeyAcaFunc30(index)
		end
	end
end

function GetXPPerTurnUnitClassAcademy(index, dType, uPlayer)
	local iclasses = {}
	local iPlayer = uPlayer or gT.Academies[index].Player;
	for iUnit in Players[iPlayer]:Units() do
		if iUnit:GetDomainType() == dType then
			local iClass = iUnit:GetUnitClassType();
			if IsCombatClassITGUnit(iClass, iPlayer) then
				table.insert(iclasses, iClass)
			end
		end
	end
	if #iclasses > 0 then
		local lClass = iclasses[LastRandom(1,#iclasses)];
		gT.Players[iPlayer].UnitClassXP[lClass] = gT.Players[iPlayer].UnitClassXP[lClass] + 6;
	end
end

function KeyAcaEndFunc23(index, uCity, uPlayer)
	GetXPPerTurnUnitClassAcademy(index, dLand, uPlayer)
end

function KeyAcaEndFunc61(index, uCity, uPlayer)
	local iPlayer = uPlayer or gT.Academies[index].Player;
	DoChangeSpecializationProgress(iPlayer, 8)
end

function KeyAcaEndFunc24(index, uCity, uPlayer)
	GetXPPerTurnUnitClassAcademy(index, dSea, uPlayer)
end

local academyKeystones = {
{ID = 1, Help = "Inreases chance for Innovation by 3%.", PortIndex = 50, IconAtlas = 'UNIT_ACTION_ATLAS', Science = 1},
{ID = 2, Help = "+5 [ICON_RESEARCH] Science from working Academy.", PortIndex = 23, IconAtlas = 'UNIT_ACTION_ATLAS', Science = 1, NoUniversity = true, Pillage = true, Func = KeyAcaFunc2},
{ID = 3, Help = "+50 [ICON_RESEARCH] Science from Trade Routes to or from this City.", PortIndex = 10, IconAtlas = 'UNIT_ACTION_ATLAS', Science = 1},
{ID = 4, Help = "+5 [ICON_ITG_ACADEMY_2] Development points per turn.", PortIndex = 12, IconAtlas = 'UNIT_ACTION_ATLAS', Science = 1, NoUniversity = true, Economy = 1, Production = 1, Faith = 1, Military = 1, Health = 1, Naval = 1,  National = 1, Archaelogy = 1, Pillage = true},
{ID = 5, Help = "+5% [ICON_PRODUCTION] Production in city.", PortIndex = 43, IconAtlas = 'UNIT_ACTION_ATLAS', Production = 1},
{ID = 6, Help = "Constructing buildings provides [ICON_RESEARCH] Science.", PortIndex = 40, IconAtlas = 'UNIT_ACTION_ATLAS', Production = 1},
{ID = 7, Help = "Buildings destroyed in Riots are easier to rebuild.", PortIndex = 36, IconAtlas = 'UNIT_ACTION_ATLAS', Production = 1},
{ID = 8, Help = "[ICON_PEACE] Faith output of city reduces chance to generate [ICON_HAPPINESS_4] Unhappiness.", PortIndex = 21, IconAtlas = 'TECH_ATLAS_1', Faith = 1},
{ID = 9, Help = "-4 [ICON_RESISTANCE] Riots' strength in the City.", PortIndex = 18, IconAtlas = 'UNIT_ACTION_ATLAS', Faith = 1,  National = 1, Military = 1},
{ID = 10, Help = "+5 [ICON_CARGO] Naval Trade Route points.", PortIndex = 4, IconAtlas = 'EXPANSION2_UNIT_ATLAS', Naval = 1},
{ID = 11, Help = "+2 [ICON_FOOD] Food from fishing.", PortIndex = 35, IconAtlas = 'UNIT_ACTION_ATLAS', Naval = 1},
{ID = 12, Help = "+1 [ICON_ITG_MORALE] Morale.", PortIndex = 19, IconAtlas = 'UNIT_ACTION_ATLAS', Military = 1, National = 1,  Naval = 1},
{ID = 13, Help = "City has an additional ranged strike.", PortIndex = 13, IconAtlas = 'UNIT_ACTION_ATLAS', Military = 1, Naval = 1, Pillage = true},
{ID = 14, Help = "+5 [ICON_GREAT_GENERAL] Great General points per turn.", PortIndex = 51, IconAtlas = 'UNIT_ACTION_ATLAS', Military = 1},
{ID = 15, Help = "+5 [ICON_GREAT_ADMIRAL] Great Admiral points per turn.", PortIndex = 15, IconAtlas = 'EXPANSION_UNIT_ATLAS_1', Naval = 1},
{ID = 16, Help = "+4 [ICON_STRENGTH] City's Strength.", PortIndex = 30, IconAtlas = 'UNIT_ACTION_ATLAS', Military = 1, Naval = 1, Pillage = true, Func = KeyAcaFunc16},
{ID = 17, Help = "Academy is active even if pillaged.", PortIndex = 37, IconAtlas = 'UNIT_ACTION_ATLAS', Faith = 1, Military = 1, NoUniversity = true, Naval = 1, National = 1,  Pillage = true},
{ID = 18, Help = "+4 [ICON_ITG_HEALTH_1] Health in the City.", PortIndex = 41, IconAtlas = 'UNIT_ACTION_ATLAS', Health = 1},
{ID = 19, Help = "City's [ICON_ITG_HEALTH_1] Health grants +0.5% [ICON_HAPPINESS_1] Happiness chance.", PortIndex = 22, IconAtlas = 'TECH_ATLAS_1', Health = 1},
{ID = 20, Help = "+4 [ICON_GREAT_PEOPLE] Great People generation.", PortIndex = 45, IconAtlas = 'UNIT_ACTION_ATLAS', Science = 1, Production = 1, Faith = 1, Health = 1},
{ID = 21, Help = "Allows choosing from one extra technology upon discovery bonus.", PortIndex = 16, IconAtlas = 'TECH_ATLAS_1', Science = 1, Func = KeyAcaFunc21},
{ID = 22, Help = "Training units provides [ICON_RESEARCH] Science.", PortIndex = 61, IconAtlas = 'BW_ATLAS_1', Military = 1, Naval = 1},
{ID = 23, Help = "+6 XP for random land unit class every turn.", PortIndex = 44, IconAtlas = 'UNIT_ACTION_ATLAS', Military = 1, EndTurnFunc = KeyAcaEndFunc23},
{ID = 24, Help = "+6 XP for random naval unit class every turn.", PortIndex = 48, IconAtlas = 'BW_ATLAS_1', Naval = 1, EndTurnFunc = KeyAcaEndFunc24},
{ID = 25, Help = "Improvement cost reduced by 20% [ICON_WORKER] Work Rate.", PortIndex = 6, IconAtlas = 'UNIT_ACTION_ATLAS', Economy = 1, Production = 1},
{ID = 26, Help = "+5 [ICON_PEACE] Faith from working Academy.", PortIndex = 60, IconAtlas = 'BW_ATLAS_1', NoUniversity = true, Faith = 1, Pillage = true, Func = KeyAcaFunc26},
{ID = 27, Help = "Reduces chances for [ICON_ITG_PLAGUE_4] Epidemies to spread into City.", PortIndex = 3, IconAtlas = 'UNIT_ACTION_ATLAS', Health = 1},
{ID = 28, Help = "Reduces lethality of any [ICON_ITG_PLAGUE_4] Epidemy attacking City.", PortIndex = 11, IconAtlas = 'UNIT_ACTION_ATLAS', Health = 1},
{ID = 29, Help = "+25% [ICON_GREAT_ENGINEER] Wonder points generation.", PortIndex = 55, IconAtlas = 'UNIT_ACTION_ATLAS', Production = 1},
{ID = 30, Help = "Reveals part of the map periodically.", PortIndex = 9, IconAtlas = 'UNIT_ACTION_ATLAS', Science = 1, NoUniversity = true, Func = KeyAcaFunc30, EndTurnFunc = KeyAcaEndFunc30},
{ID = 31, Help = "Trade Units from this City have +2 [ICON_MOVES] Movement.", PortIndex = 8, IconAtlas = 'UNIT_ACTION_ATLAS', Func = KeyAcaFunc31, Naval = 1, Production = 1, Economy = 1, Science = 1},
{ID = 32, Help = "Land units have +5% chance for +100% Critical Strike.", PortIndex = 18, IconAtlas = 'UNIT_ACTION_ATLAS', Func = KeyAcaFunc32, Military = 1},
{ID = 33, Help = "Naval units have +5% chance for +100% Critical Strike", PortIndex = 2, IconAtlas = 'UNIT_ACTION_ATLAS', Func = KeyAcaFunc33, Naval = 1},
{ID = 34, Help = "+1 [ICON_ITG_HEALTH_1] Health empire-wide.", PortIndex = 52, IconAtlas = 'UNIT_ACTION_ATLAS', Health = 1, Func = KeyAcaFunc34},
{ID = 35, Help = "+2.5 [ICON_ITG_UNIFY] Unifying Presence.", PortIndex = 53, IconAtlas = 'UNIT_ACTION_ATLAS', Science = 1, Faith = 1, Military = 1, Func = KeyAcaFunc35},
{ID = 36, Help = "+5 [ICON_ITG_PRESENCE] Cultural Presence per turn.", PortIndex = 53, IconAtlas = 'UNIT_ACTION_ATLAS', Science = 1, Faith = 1, Military = 1, National = 1, Func = KeyAcaFunc36},
{ID = 37, Help = "+50 [ICON_RESEARCH] Science each time somebody creates Archeological Site.", PortIndex = 50, IconAtlas = 'UNIT_ACTION_ATLAS', Archaelogy = 1},
{ID = 38, Help = "+25 [ICON_ITG_PRESENCE] Cultural presence in all Cities upon creating Archeological Site.", PortIndex = 53, IconAtlas = 'UNIT_ACTION_ATLAS', Archaelogy = 1, National = 1},
{ID = 39, Help = "+2 [ICON_MOVES] Movement for Archeologists.", PortIndex = 38, IconAtlas = 'UNIT_ACTION_ATLAS', Archaelogy = 1, Func = KeyAcaFunc39},
{ID = 40, Help = "Reduces delay of locating Antiquity Site. Increases delay for rivals if you are the first to locate the site.", PortIndex = 59, IconAtlas = 'UNIT_ACTION_ATLAS', Archaelogy = 1},
{ID = 41, Help = "+7 [ICON_RES_ARTIFACTS] Historical Sources.", PortIndex = 32, IconAtlas = 'UNIT_ACTION_ATLAS', Archaelogy = 1},
{ID = 42, Help = "+10 [ICON_GREAT_ARTIST] Art points per turn.", PortIndex = 53, IconAtlas = 'UNIT_ACTION_ATLAS', Archaelogy = 1},
{ID = 43, Help = "+30 [ICON_ITG_PRESENCE] Cultural Presence in all Cities upon researching technology first.", PortIndex = 50, IconAtlas = 'UNIT_ACTION_ATLAS', National = 1, Func = KeyAcaFunc43},
{ID = 44, Help = "+15% [ICON_ITG_UNIFY] Unifying Presence.", PortIndex = 9, IconAtlas = 'UNIT_ACTION_ATLAS', National = 1, Func = KeyAcaFunc44},
{ID = 45, Help = "-10% [ICON_ITG_DIVIDE] Dividing Presence.", PortIndex = 13, IconAtlas = 'UNIT_ACTION_ATLAS', National = 1, Func = KeyAcaFunc45},
{ID = 46, Help = "+10 [ICON_ITG_PRESENCE] Cultural presence in allied Cities.", PortIndex = 52, IconAtlas = 'UNIT_ACTION_ATLAS', National = 1, Func = KeyAcaFunc46},
{ID = 47, Help = "+50 [ICON_ITG_PRESENCE] Cultural presence in all Cities upon constructing World Wonder.", PortIndex = 54, IconAtlas = 'UNIT_ACTION_ATLAS', National = 1, Func = KeyAcaFunc47},
{ID = 48, Help = "+5 [ICON_GOLD] Gold from working Academy.", PortIndex = 41, IconAtlas = 'UNIT_ACTION_ATLAS', Economy = 1, NoUniversity = true, Func = KeyAcaFunc48},
{ID = 49, Help = "+35 [ICON_INVEST] Currency power.", PortIndex = 8, IconAtlas = 'UNIT_ACTION_ATLAS', Economy = 1, Func = KeyAcaFunc49},
{ID = 50, Help = "+15% [ICON_GOLD] Gold from all Trade Routes.", PortIndex = 10, IconAtlas = 'UNIT_ACTION_ATLAS', Economy = 1, Func = KeyAcaFunc50},
{ID = 51, Help = "+5 [ICON_CARAVAN] Land Trade Route points.", PortIndex = 9, IconAtlas = 'UNIT_ACTION_ATLAS', Economy = 1},
{ID = 52, Help = "+2 copies of every Strategic Resource.", PortIndex = 22, IconAtlas = 'UNIT_ACTION_ATLAS', Economy = 1, Func = KeyAcaFunc52},
{ID = 53, Help = "Reduces chances for your currency to be counterfeited.", PortIndex = 22, IconAtlas = 'UNIT_ACTION_ATLAS', Economy = 1, Func = KeyAcaFunc53},
{ID = 54, Help = "1% of [ICON_WORKER] Work Rate spent is added to [ICON_RESEARCH] Science.", PortIndex = 22, IconAtlas = 'UNIT_ACTION_ATLAS', Archaeology = 1, Func = KeyAcaFunc54},
{ID = 55, Help = "Creating an improvement has 5% chance to find [ICON_GREAT_WORK] Great Work.", PortIndex = 22, IconAtlas = 'UNIT_ACTION_ATLAS', Archaeology = 1, Func = KeyAcaFunc55},
{ID = 56, Help = "+2 [ICON_ITG_PRESENCE] Cultural presence in all Cities upon creating new [ICON_GREAT_WORK] Great Work.", PortIndex = 22, IconAtlas = 'UNIT_ACTION_ATLAS', National = 1, Func = KeyAcaFunc56},
{ID = 57, Help = "+3 [ICON_ITG_PRESENCE] Cultural presence per turn within Civilizations with weaker Currency.", PortIndex = 22, IconAtlas = 'UNIT_ACTION_ATLAS', National = 1, Economy = 1, Func = KeyAcaFunc57},
{ID = 58, Help = "Increases [ICON_ITG_PRESENCE] National Cultural Presence anchor by 50.", PortIndex = 53, IconAtlas = 'UNIT_ACTION_ATLAS', National = 1, Func = KeyAcaFunc58},
{ID = 59, Help = "+2 [ICON_ITG_AUTHORITY] Authority.", PortIndex = 44, IconAtlas = 'UNIT_ACTION_ATLAS', National = 1, Military = 1, Faith = 1},
{ID = 60, Help = "+3 [ICON_ITG_SUPPLY] Unit Supply.", PortIndex = 20, IconAtlas = 'UNIT_ACTION_ATLAS', Military = 1, Naval = 1, Func = KeyAcaFunc60},
--Science, Economy, Production, Faith, Military, Health, Naval, National, Archaelogy
{ID = 61, Help = "+8 [ICON_ITG_SPECIALIZATION] points towards unit specialization per turn.", PortIndex = 46, IconAtlas = "UNIT_ACTION_ATLAS", Military = 1, Naval = 1, Science = 1, Scenario = {[3] = true, [5] = true}, EndTurnFunc = KeyAcaEndFunc61},
{ID = 62, Help = "Unit [ICON_GOLD] Gold maintenance cost reduced by 0.1.", PortIndex = 20, IconAtlas = "UNIT_ACTION_ATLAS", Military = 1, Naval = 1, Economy = 1, Func = KeyAcaFunc62},
{ID = 63, Help = "+1 [ICON_PRODUCTION] Production from Manufactories.", PortIndex = 56, IconAtlas = "UNIT_ACTION_ATLAS", Science = 1, Production = 1, Func = KeyAcaFunc63},
{ID = 64, Help = "+1 [ICON_GOLD] Gold from Manufactories and Customs Houses.", PortIndex = 57, IconAtlas = "UNIT_ACTION_ATLAS", Economy = 1, Func = KeyAcaFunc64},
{ID = 65, Help = "City gains +5 [ICON_ITG_CHARM] Charm.", PortIndex = 22, IconAtlas = "UNIT_ACTION_ATLAS", Economy = 1, Science = 1, Production = 1, National = 1, Archaeology = 1, Health = 1, Func = KeyAcaFunc65},
{ID = 66, Help = "[ICON_GOLD] Gold earned from investing also provides [ICON_RESEARCH] Science.", PortIndex = 12, IconAtlas = "UNIT_ACTION_ATLAS", Science = 1, Economy = 1, Scenario = {[1] = true, [4] = true, [5] = true}},
{ID = 67, Help = "+3 [ICON_ITG_PILGRIM] Pilgrimage points in the City.", PortIndex = 53, IconAtlas = "UNIT_ACTION_ATLAS", Faith = 1},
{ID = 68, Help = "[ICON_ITG_HEALTH_1] Health of the City is added to [ICON_ITG_ACADEMY_1] Prestige each turn.", PortIndex = 3, IconAtlas = "UNIT_ACTION_ATLAS", Health = 1, NoUniversity = true},
{ID = 69, Help = "Generals and Admirals' leadership aura grants an extra +4% combat bonus.", PortIndex = 44, IconAtlas = "UNIT_ACTION_ATLAS", Military = 1, Naval = 1, Func = KeyAcaFunc69},
{ID = 70, Help = "+40 [ICON_ITG_PRESENCE] Cultural Presence is added to notably conquered Cities.", PortIndex = 53, IconAtlas = "UNIT_ACTION_ATLAS", Military = 1, Naval = 1, National = 1},
{ID = 71, Help = "+10 XP for all trained Units.", PortIndex = 44, IconAtlas = "UNIT_ACTION_ATLAS", Military = 1, Naval = 1},
{ID = 72, Help = "+1 [ICON_ITG_MERITOCRACY] Meritocracy per turn.", PortIndex = 59, IconAtlas = "UNIT_ACTION_ATLAS", National = 1, Faith = 1, NoUniversity = true, Func = KeyAcaFunc72},
{ID = 73, Help = "+33% [ICON_ITG_LAWS_INFLUENCE] Codex Influence.", PortIndex = 55, IconAtlas = "UNIT_ACTION_ATLAS", National = 1, Scenario = {[4] = true, [5] = true}, Func = KeyAcaFunc73},
}

LuaEvents.ITGCivilopediaSpecificAcademy.Add(function(id)
	MapModData.ITGSG = {Name = "Reward " .. id, Help = academyKeystones[id].Help}
end)

function GetCivilopediaAcademyTraits()
	local tab = {}
	for i, v in pairs(academyKeystones) do
		table.insert(tab, {ID = i, Name = "Reward " .. i})
	end
	return tab;
end

function GetNumCityAcademiesWithAbility(iCity, ability)
	local t = 0;
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	for i, index in pairs(gT.Cities[cID].Academies) do
		if gT.Academies[index].KeyAbilities[ability] and (gT.Academies[index].KeyAbilities[ability][1] > 0) then
			t = t + 1;
		end
	end
	if gT.Cities[cID].UniAcademyReward == ability then
		if gT.Cities[cID].UniAcademyRewardActive then
			t = t + 1;
		end
	end
	return t;
end

function GetNumAcademiesWithAbility(iPlayer, ability)
	local t = 0;
	for iCity in Players[iPlayer]:Cities() do
		t = t + GetNumCityAcademiesWithAbility(iCity, ability);
	end
	return t;
end

function GetAcademyKeystonesTab()
	return academyKeystones;
end

function AddNewUniversityAcademyBonus(iCity, iPlayer)
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	if not gT.Cities[cID].UniAcademyReward then
		local vTab = {}
		local type = GetRandomBonusTypeForUniversityAcademy(iCity)
		for h, s in pairs(academyKeystones) do
			if s[type] and ((not s.Scenario) or (s.Scenario[gT.Globals.ScenarioType])) then
				if not s.NoUniversity then
					table.insert(vTab, h)
				end
			end
		end
		if #vTab > 0 then
			gT.Cities[cID].UniAcademyReward = vTab[LastRandom(1,#vTab)];
		else
			print("Major error 245324/324", iPlayer, cID, type)
		end
	end
	if not gT.Cities[cID].UniAcademyRewardActive then
		if gT.Cities[cID].UniAcademyReward then
			if academyKeystones[gT.Cities[cID].UniAcademyReward].Func then
				academyKeystones[gT.Cities[cID].UniAcademyReward].Func(nil, false, iCity, iPlayer)
			end
			gT.Cities[cID].UniAcademyRewardActive = true;
		end
	end
end

function RemoveUniversityAcademyBonus(iCity, iPlayer)
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	if gT.Cities[cID].UniAcademyRewardActive then
		if academyKeystones[gT.Cities[cID].UniAcademyReward].Func then
			academyKeystones[gT.Cities[cID].UniAcademyReward].Func(nil, true, iCity, iPlayer)
		end
		gT.Cities[cID].UniAcademyRewardActive = false;
	end
end

function CheckEndTurnUniversityAcaRewards(iPlayer)
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		local bShouldHaveBonus = IsHasBuildingClass(iCity, GameInfoTypes.BUILDINGCLASS_UNIVERSITY)
		if bShouldHaveBonus then
			if not gT.Cities[cID].UniAcademyRewardActive then
				AddNewUniversityAcademyBonus(iCity, iPlayer)
			end
		elseif gT.Cities[cID].UniAcademyRewardActive then
			RemoveUniversityAcademyBonus(iCity, iPlayer)
		end
		if gT.Cities[cID].UniAcademyRewardActive then
			if academyKeystones[gT.Cities[cID].UniAcademyReward].EndTurnFunc then
				academyKeystones[gT.Cities[cID].UniAcademyReward].EndTurnFunc(index, iCity, iPlayer);
			end
		end
	end
end

function AcaRewardPlayer1(iPlayer)
	if not Players[iPlayer]:IsMinorCiv() then
		gT.Players[iPlayer].NumPrestigeVotes = gT.Players[iPlayer].NumPrestigeVotes + 1;
		UpdatePlayerVotesInAllLeagues(iPlayer)
	end
end

function AcaRewardRemovePlayer1(iPlayer)
	if not Players[iPlayer]:IsMinorCiv() then
		gT.Players[iPlayer].NumPrestigeVotes = gT.Players[iPlayer].NumPrestigeVotes - 1;
		UpdatePlayerVotesInAllLeagues(iPlayer)
	end
end

function AcaRewardAca2(index)
	Map.GetPlotByIndex(index):ChangeYieldIfNotPillaged(yGold, 5)
end

function AcaRewardRemoveAca2(index)
	Map.GetPlotByIndex(index):ChangeYieldIfNotPillaged(yGold, -5)
end

function AcaRewardAca5(index)
	Map.GetPlotByIndex(index):ChangeYieldIfNotPillaged(yProduction, 3)
end

function AcaRewardRemoveAca5(index)
	Map.GetPlotByIndex(index):ChangeYieldIfNotPillaged(yProduction, -3)
end

function AcaBlankFunc(iCity)

end

function AcaRewardPlayer4(iPlayer)
	Teams[Players[iPlayer]:GetTeam()]:ChangeEmbarkedExtraMoves(1)
end

function AcaRewardRemovePlayer4(iPlayer)
	Teams[Players[iPlayer]:GetTeam()]:ChangeEmbarkedExtraMoves(-1)
end

function AcaRewardPlayer7(iPlayer)
	gT.Globals.AcaGlobalPresBonus = iPlayer
end

function AcaRewardPlayerRemove7(iPlayer)
	if gT.Globals.AcaGlobalPresBonus == iPlayer then
		gT.Globals.AcaGlobalPresBonus = nil
	end	
end

function AcaRewardPlayer8(iPlayer)
	gT.Players[iPlayer].GPfromAca = gT.Players[iPlayer].GPfromAca + 7
end

function AcaRewardRemovePlayer8(iPlayer)
	gT.Players[iPlayer].GPfromAca = gT.Players[iPlayer].GPfromAca - 7
end

function AcaRewardPlayer9(iPlayer)
	gT.Players[iPlayer].BudgetAcaMod = gT.Players[iPlayer].BudgetAcaMod + 25;
end

function AcaRewardRemovePlayer9(iPlayer)
	gT.Players[iPlayer].BudgetAcaMod = gT.Players[iPlayer].BudgetAcaMod - 25;
end

function AcaRewardPlayer10(iPlayer)
	gT.Players[iPlayer].AcaCodexInfluence = gT.Players[iPlayer].AcaCodexInfluence + 50;
end
function AcaRewardRemovePlayer10(iPlayer)
	gT.Players[iPlayer].AcaCodexInfluence = gT.Players[iPlayer].AcaCodexInfluence - 50;
end

local AcademyRewardTab = {
{ID = 1, Text = "+1 [ICON_ITG_VOTES] Vote in all Leagues.", Player = true, AddFunction = AcaRewardPlayer1, RemoveFunction = AcaRewardRemovePlayer1},
{ID = 2, Text = "+5 [ICON_GOLD] Gold from working Academy.", Academy = true, AddFunctionAca = AcaRewardAca2, RemoveFunctionAca = AcaRewardRemoveAca2},
{ID = 3, Text = "City has +20 [ICON_ITG_CHARM] Charm.", City = true, AddFunctionCity = AcaBlankFunc, RemoveFunctionCity = AcaBlankFunc},
{ID = 4, Text = "+1 [ICON_MOVES] Movement for naval and embarked units.", Player = true, AddFunction = AcaRewardPlayer4, RemoveFunction = AcaRewardRemovePlayer4},
{ID = 5, Text = "+3 [ICON_PRODUCTION] Production from working Academy.", Academy = true, AddFunctionAca = AcaRewardAca5, RemoveFunctionAca = AcaRewardRemoveAca5},
{ID = 6, Text = "+10 [ICON_GREAT_ENGINEER] Wonder points per turn.", City = true, AddFunctionCity = AcaBlankFunc, RemoveFunctionCity = AcaBlankFunc},
{ID = 7, Text = "+2 [ICON_ITG_PRESENCE] Cultural Presence in all Cities per turn.", Player = true, AddFunction = AcaRewardPlayer7, RemoveFunction = AcaRewardPlayerRemove7}, 
{ID = 8, Text = "+7 [ICON_GREAT_PEOPLE] Great People points per turn.", Player = true, AddFunction = AcaRewardPlayer8, RemoveFunction = AcaRewardRemovePlayer8}, 
{ID = 9, Text = "+25% [ICON_GOLD] Gold into Budget modifier.", Player = true, AddFunction = AcaRewardPlayer9, RemoveFunction = AcaRewardRemovePlayer9}, 
{ID = 10, Text = "+100% [ICON_ITG_LAWS_INFLUENCE] Codex Influence.", Player = true, AddFunction = AcaRewardPlayer10, RemoveFunction = AcaRewardRemovePlayer10}, 
}

function DoAcademyTurnBonusesOver(index)
	for key, sth in pairs(gT.Academies[index].KeyAbilities) do
		if sth[1] > 0 then
			if academyKeystones[key].EndTurnFunc then
				academyKeystones[key].EndTurnFunc(index);
			end
		end
	end
end

function DoTurnAcademiesReward(iPlayer)
	if gT.Players[iPlayer].ExtraArcheologistMoves > 0 then
		for iUnit in Players[iPlayer]:Units() do
			if iUnit:GetUnitType() == uArchaeologist then
				if CanBeSpeedUpByAnything(iUnit) then
					iUnit:ChangeTemporaryMoves(gT.Players[iPlayer].ExtraArcheologistMoves)
				end
			end
		end
	end
	if gT.Globals.AcaGlobalPresBonus == iPlayer then
		AddCulturalPresenceWorldWide(iPlayer, 2, nil, true)
	end
	if gT.Players[iPlayer].CultPresWeakerCurrency > 0 then
		for g, h in pairs(gT.Players) do
			if not Players[g]:IsMinorCiv() then
				if gT.Players[iPlayer].MintPower > h.MintPower then
					AddCulturalPresenceInAllCities(iPlayer, g, gT.Players[iPlayer].CultPresWeakerCurrency)
				end
			end
		end
	end
end

function DoRemoveAcademyRewardsEndEra(index)
	--end era also all keystones :]
	for rew, sth in pairs(gT.Academies[index].ActiveRewards) do
		if AcademyRewardTab[rew].RemoveFunctionAca then
			AcademyRewardTab[rew].RemoveFunctionAca(index)
		end
	end
	for g, h in pairs(gT.Players) do
		for typeReward, h in pairs(h.AcademyRewards) do
			if AcademyRewardTab[typeReward].Player then
				AcademyRewardTab[typeReward].RemoveFunction(g);
			end
		end
	end
	DoRemoveAllKeystonesRelatedAcademy(index, gT.Academies[index].Player)
end

function GetAcademiesTextGenerating(iPlayer)
	local str = "Rewards for the most [ICON_ITG_ACADEMY_1] Prestigious Academies:[NEWLINE]"
	for i = 1, 3 do
		str = str .. "[ICON_BULLET]" .. cupTab[i] .. " " .. AcademyRewardTab[gT.Globals.AcademyRewards[i]].Text .. "[NEWLINE]";
	end
	local bHasAnyAcademy = false;
	for i, index in pairs(gT.Players[iPlayer].DoMdata.InitAcademy) do
		bHasAnyAcademy = true;
		str = str .. "[ICON_BULLET]" .. gT.Academies[index].Name .. "[NEWLINE]"
	end
	if not bHasAnyAcademy then
		str = str .. "[ICON_BULLET]You have no initial Academies.[NEWLINE]"
	end
	return str;
end

function RequestStringAcademyReward(index)
	local sTab = {"", "", "", 0, 0, "", "", "", ""}
	sTab[3] = "Every [ICON_ITG_ACADEMY_2] Academy in the world competes for [ICON_ITG_ACADEMY_1] Prestige which determines position in rank. Top three Academies receive rewards:"
	for i = 1, 3 do
		local sHelp = "[NEWLINE][ICON_BULLET]" .. cupTab[i] .. " " .. AcademyRewardTab[gT.Globals.AcademyRewards[i]].Text;
		if gT.Academies[index].ActiveRewards[gT.Globals.AcademyRewards[i]] then
			sTab[1] = sTab[1] .. cupTab[i];
			sTab[2] = sTab[2] .. sHelp;
		end
		sTab[3] = sTab[3] .. sHelp;
	end
	sTab[3] = sTab[3] .. "[NEWLINE][NEWLINE]Academies on high rank face an increasing stagnation modifier that affects [ICON_ITG_ACADEMY_1] Prestige growth per turn." 
	sTab[9] = "[ICON_ITG_ACADEMY_1] Prestige is earned with city's [ICON_RESEARCH] Science output, [ICON_GREAT_PEOPLE] Great People visiting city and on special events like discovery of Technology, Natural Wonder, or [ICON_GREAT_PEOPLE] Great Person ascendancy."
	local statictab = {};
	table.insert(statictab, {BASE_PRESTIGE_ANCHOR, "Base"});
	for type, value in pairs(gT.Academies[index].PrestigeDynamic) do
		if value ~= 0 then
			table.insert(statictab, {value, TabOfNiceAnchorString[type]})
		end
	end
	sTab[5] = math.min(0, GetDifFadeAcademy(index));
	sTab[9] = sTab[9] .. "[NEWLINE][NEWLINE]Following modifiers affect [ICON_ITG_ACADEMY_1] Prestige anchor (it will not drop below it):"
	for i, ss in pairs(statictab) do
		if ss[1] < 0 then
			sTab[9] = sTab[9] .. "[NEWLINE][ICON_BULLET][COLOR_NEGATIVE_TEXT]" .. ss[1] .. "[ENDCOLOR] from " .. ss[2] .. "."
		else
			sTab[9] = sTab[9] .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]+" .. ss[1] .. "[ENDCOLOR] from " .. ss[2] .. "."
		end
	end
	sTab[7] = "Every turn [ICON_ITG_ACADEMY_1] Prestige fades by [COLOR_NEGATIVE_TEXT]10%[ENDCOLOR]. This rate is increased by 5% for inactive (pillaged) Academies. Value will not drop below the anchor."
	sTab[8] = "Predicted netto change of [ICON_ITG_ACADEMY_1] Prestige next turn.[NEWLINE][NEWLINE][ICON_ITG_ACADEMY_1] Prestige can be also affected by dynamic events."
	if #gT.Academies[index].RecentLog > 0 then
		sTab[8] = sTab[8] .. " Recent related activities:";
		local hTTs = ""
		for i, v in pairs(gT.Academies[index].RecentLog) do
			if v[1] > 0 then
				hTTs = "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]+" .. v[1] .. "[ENDCOLOR] [ICON_ITG_ACADEMY_1] from " .. v[2] .. "." .. hTTs
			else
				hTTs = "[NEWLINE][ICON_BULLET][COLOR_NEGATIVE_TEXT]" .. v[1] .. "[ENDCOLOR] [ICON_ITG_ACADEMY_1] from " .. v[2] .. "." .. hTTs
			end
		end
		sTab[8] = sTab[8] .. hTTs; 
	end
	sTab[6] = "Active academies generate [ICON_ITG_ACADEMY_1] Prestige each turn, mainly from City's [ICON_RESEARCH] Science."
	if gT.Academies[index].Active then
		local tabTurnChange = {}
		local iCity = Map.GetPlotByIndex(gT.Academies[index].City):GetPlotCity();
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		local iPlayer = iCity:GetOwner();
		table.insert(tabTurnChange, {GetPrestigeFromGoldenAge(iPlayer), "Golden Age"})
		table.insert(tabTurnChange, {GetPrestigeFromFestival(iPlayer, cID), "Festival"})
		table.insert(tabTurnChange, {GetPrestigeFromInnovations(iPlayer, iCity), "Innovations"})
		table.insert(tabTurnChange, {GetPrestigeFromHealth(index, cID), "Health"})
		table.insert(tabTurnChange, {GetAcademyPrestigeForGPInCity(iCity), "Great People"})
		table.insert(tabTurnChange, {GetPrestigeFromCityScience(math.floor(iCity:GetYieldRateTimes100(yScience) / 100), #GetAllAcademiesNearCity(iCity)), "Science"})
		for i, ss in pairs(tabTurnChange) do
			if ss[1] > 0 then
				sTab[6] = sTab[6] .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]+" .. ss[1] .. "[ICON_ITG_ACADEMY_1][ENDCOLOR] from " .. ss[2] .. "."
				sTab[4] = sTab[4] + ss[1];
			end
		end
		local modifiertab = {}
		if gT.Academies[index].StagnationMod ~= 0 then
			table.insert(modifiertab, {gT.Academies[index].StagnationMod, "Resting on laurels"})
		end
		if gT.Academies[index].NationalMod ~= 0 then
			table.insert(modifiertab, {gT.Academies[index].NationalMod, "National Academy"})
		end
		local itgTurn = GetITGGameTurn();
		for h, ss in pairs(gT.Academies[index].PrestigeTempMods) do
			table.insert(modifiertab, {ss[1], ss[2] .. " (" .. (1 + ss[3] - itgTurn) .. "[ICON_SWAP])"})
		end
		if #modifiertab > 0 then
			sTab[6] = sTab[6] .. "[NEWLINE][NEWLINE]List of [ICON_ITG_ACADEMY_1] Prestige growth modifiers:"; 
			for i, ss in pairs(modifiertab) do
				if ss[1] < 0 then
					sTab[6] = sTab[6] .. "[NEWLINE][ICON_BULLET][COLOR_NEGATIVE_TEXT]" .. 100 * ss[1] .. "%[ENDCOLOR] from " .. ss[2] .. "."
				else
					sTab[6] = sTab[6] .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]+" .. 100 * ss[1] .. "%[ENDCOLOR] from " .. ss[2] .. "."
				end
			end
		end
		sTab[4] = math.floor(sTab[4] * (1 + GetModOfAcademyPrestige(index)))
	end
	MapModData.ITGSG = sTab;
end

function DoAcademyRewardsAssign(tot)
	if tot > 4 then
		DoAddEndTurnReward(gT.Globals.AcademyRewards[1], 1)
		DoAddEndTurnReward(gT.Globals.AcademyRewards[2], 2)
	elseif tot > 2 then
		DoAddEndTurnReward(gT.Globals.AcademyRewards[2], 2)
	end
	DoAddEndTurnReward(gT.Globals.AcademyRewards[3], 3)
end

function DoAddEndTurnReward(typeReward, amountAcademy)
	local playerTab = {}
	local cityTab = {}
	for index, sth in pairs(gT.Academies) do
		if sth.Rank and sth.Rank <= amountAcademy then
			playerTab[sth.Player] = 1;
			cityTab[Map.GetPlotByIndex(sth.City):GetPlotCity()] = 1;
			if not gT.Academies[index].ActiveRewards[typeReward] then
				gT.Academies[index].ActiveRewards[typeReward] = amountAcademy;
				if AcademyRewardTab[typeReward].Academy then
					AcademyRewardTab[typeReward].AddFunctionAca(index);
				end
			end
		elseif sth.ActiveRewards[typeReward] then
			gT.Academies[index].ActiveRewards[typeReward] = nil
			if AcademyRewardTab[typeReward].Academy then
				AcademyRewardTab[typeReward].RemoveFunctionAca(index);
			end
		end
	end
	if AcademyRewardTab[typeReward].Player then
		for g, gdata in pairs(gT.Players) do
			if playerTab[g] then
				if not gdata.AcademyRewards[typeReward] then
					AcademyRewardTab[typeReward].AddFunction(g);
					gT.Players[g].AcademyRewards[typeReward] = amountAcademy;
				end
			elseif gdata.AcademyRewards[typeReward] then
				AcademyRewardTab[typeReward].RemoveFunction(g);
				gT.Players[g].AcademyRewards[typeReward] = nil;
			end
		end
	end
	if AcademyRewardTab[typeReward].City then
		for g, gdata in pairs(gT.Players) do
			for iCity in Players[g]:Cities() do
				local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
				if cityTab[iCity] then
					if not gT.Cities[cID].AcademyRewards[typeReward] then
						gT.Cities[cID].AcademyRewards[typeReward] = amountAcademy;
						AcademyRewardTab[typeReward].AddFunctionCity(iCity);
					end
				elseif gT.Cities[cID].AcademyRewards[typeReward] then
					gT.Cities[cID].AcademyRewards[typeReward] = nil;
					AcademyRewardTab[typeReward].RemoveFunctionCity(iCity);
				end
			end
		end
	end
end

function DoRemoveAllKeystonesRelatedAcademy(iIndex, jPlayer)
	for h, d in pairs(gT.Academies[iIndex].KeyAbilities) do
		if d[1] > 0 then
			gT.Academies[iIndex].KeyAbilities[h][1] = 0;
			if academyKeystones[h].Func then
				academyKeystones[h].Func(iIndex, true)
			end
		end
	end
end

function DoAddAllKeystonesRelatedAcademy(iIndex, newPlayer)
	for h, d in pairs(gT.Academies[iIndex].KeyAbilities) do
		if gT.Academies[iIndex].Active or academyKeystones[h].Pillage then
			if academyKeystones[h].Pillage then
				gT.Academies[iIndex].KeyAbilities[h][1] = 2;
			else
				gT.Academies[iIndex].KeyAbilities[h][1] = 1;
			end
			if academyKeystones[h].Func then
				academyKeystones[h].Func(iIndex)
			end
		end
	end
end

function DoTurnAcademyInactive(iIndex)
	for h, d in pairs(gT.Academies[iIndex].KeyAbilities) do
		if d[1] == 1 then
			gT.Academies[iIndex].KeyAbilities[h][1] = 0;
			if academyKeystones[h].Func then
				academyKeystones[h].Func(iIndex, true)
			end
		end
	end
end

function DoTurnAcademyActive(iIndex)
	for h, d in pairs(gT.Academies[iIndex].KeyAbilities) do
		if d[1] == 0 then
			gT.Academies[iIndex].KeyAbilities[h][1] = 1;
			if academyKeystones[h].Func then
				academyKeystones[h].Func(iIndex)
			end
		end
	end
end

function AddKeystoneAbility(iIndex, type)
	local tabValid = {}
	for h, s in pairs(academyKeystones) do
		if s[type] and ((not s.Scenario) or (s.Scenario[gT.Globals.ScenarioType])) then
			if not gT.Academies[iIndex].KeyAbilities[h] then
				table.insert(tabValid, h)
			end
		end
	end
	if #tabValid == 0 then
		print("Not enough keystone abilities", iIndex, type)
	else
		local cOne = tabValid[LastRandom(1,#tabValid)];
		local hType = 0;
		if academyKeystones[cOne].Pillage then
			hType = 2;
		elseif gT.Academies[iIndex].Active then
			hType = 1;
		end
		gT.Academies[iIndex].KeyAbilities[cOne] = {hType , type}
		if hType > 0 then
			if academyKeystones[cOne].Func then
				academyKeystones[cOne].Func(iIndex)
			end
		end
		local player = gT.Academies[iIndex].Player;
		if HasPlayerTech(player, innoindu5, "efwefwefw") then
			gT.Players[player].Ind5NatUnity = gT.Players[player].Ind5NatUnity + 1;
			ChangeMeritocracy(player, 1)
		end
	end
end

function GetUniversitiesKeystones(iPlayer)
	local tab = {}
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		if gT.Cities[cID].UniAcademyReward then
			local data = academyKeystones[gT.Cities[cID].UniAcademyReward];
			local hTab = {PortIndex = data.PortIndex, IconAtlas = data.IconAtlas}
			local sToolTip = data.Help .. "[NEWLINE][NEWLINE]" .. iCity:GetName();
			if (not gT.Cities[cID].UniAcademyRewardActive) then
				hTab.Disable = true;
				sToolTip = sToolTip .. "[NEWLINE][NEWLINE]Currently [COLOR_NEGATIVE_TEXT]inactive[ENDCOLOR].";
			end
			hTab.Help = sToolTip;
			table.insert(tab, hTab)
		end
	end
	return tab;
end

function HasPlayerAcademyInTop3(iPlayer)
	for a, b in pairs(gT.Players[iPlayer].AcademyRewards) do
		return true;
	end
	return false;
end