local bcmuseum = GameInfoTypes.BUILDING_ITG_IND_MUSEUM
local scenarioInitSites = {[4] = 3}
local cArchae = GameInfoTypes.UNIT_ITG_ARCHAEOLOGIST
local improSiteArch = GameInfoTypes.IMPROVEMENT_ARCHAEOLOGICAL_DIG;
local innoindu5 = GameInfoTypes.TECH_UNIQUE_ITG_INDUSTRIAL_5
local innoindu9 = GameInfoTypes.TECH_UNIQUE_ITG_INDUSTRIAL_9;
local grArtifacts = GameInfoTypes.RESOURCE_ARTIFACTS;
local induwonder8 = GameInfoTypes.BUILDING_ITG_NEW_INDUSTRIAL_WONDER_8;
local bInduWonder10 = GameInfoTypes.BUILDING_ITG_NEW_INDUSTRIAL_WONDER_10;
local bInduWonder11 = GameInfoTypes.BUILDING_ITG_NEW_INDUSTRIAL_WONDER_11
local ArchPlacesSites = {
"Ruins of Baalbek","Ruins of Leptis Magna","Tomb of Qin Shi Huangdi","Remnants of Mes Aynak",
"Ruins of Phoenice","Cinders of Gemellae","Ruins of Quilmes","Remnants of Baghaberd",
"Sunbury earth rings","Sandberg Celtic city","Remnants of Barbar Temple","Remnants of Choto Katra",
"Ruins of Cahal Pech","Remnants of Iskanwaya","City of Daorson","Thracian Tomb of Kazanlak",
"Angkor","Cinders of Kitwanga Fort","Fell Cave","Malagana Treasure",
"Ruins of Narona","Klimonas Village","Skuldelev ships","Ruins of Tumebamba",
"Remnants of Ismailia Canal","Cara Sucia","Chauvet Cave","Remnants of Dmanisi",
"Minoan Tombs of Armeni","Remnants of Kinal","Stone Circles of Hong Kong","Remnants of Lothal",
"Ruins of Borobudur","Ruins of Hatra","Hill of Tara","Ruins of Magdala",
"Shrine of Hercules Curinus","Hidden City of Petra","Canalizations of Zenobia","Cinders of Bargala",
"Niah Caves","Mnajdra Temples","Remnants of Cempoala","Ruins of Volubilis",
"Te Wairoa","Gokstad ship burial","Remnants of Harappa","Nazca Lines",
"Tabon Caves","Remnants of Biskupin","Castro do Vieito","Ruins of Zubarah",
"Pazyryk burials","Mining site of Rudna Glava","Tomb of Eve","Potok Cave",
"Plovers Lake","Caves of Valeron","Waulpane Cave","Augusta Raurica",
"Tell Barri","Cinders of Van Fortress","Hadrian's Wall","Ruins of Ziwa"
}
--	AddSmallInfo(pPlot, "[ICON_SPY]", "Shinobi are providing vision within 3 range.", "ShinobiVision", nil, nil, nil, nil, iPlayer)

function InitArchaeologySystem()
	gT.ArchaeologicalNamesUsed = {}
	gT.ArchaeologyPlots = {}
	gT.CurrentArchaelogyData = {}
	gT.ArchaeologyTimer = 0;
	if DBScenario.Archaeology then
		AssignInitialArchaeologySites()
		local numsitesinit = scenarioInitSites[gT.Globals.ScenarioType] + LastRandom(-1, 1);
		for vIndex, th in pairs(gT.ArchaeologyPlots) do
			numsitesinit = numsitesinit - 1;
			CreateArchaeologySiteOnPlot(Map.GetPlotByIndex(vIndex))
			if numsitesinit <= 0 then
				break;
			end
		end
		gT.ArchaeologyTimer = LastRandom(3, 5)
		InitNewArchaeologicalData()
		for g, t in pairs(gT.Players) do
			if not Players[g]:IsMinorCiv() then
				gT.CurrentArchaelogyData.Players[g] = math.floor(LastRandom(5, 8) * GetArchaeologyPointsPerTurn(g) / 2)
			end
		end
	end
end

function GetArchaeologyPointsFromGPC(iPlayer)
	local t = 0;
	for gpID, hhh in pairs(gT.Players[iPlayer].GreatPeople) do
		local gpData = gT.GreatPeople[gpID];
		if gpData.Alive and (not gpData.Military) then
			if gpData.Archaeology then
				t = t + gpData.Archaeology
			end
			if gpData.Ability == 52 then
				t = t + 7;
			end
		end
	end
	return t;
end

function InitNewArchaeologicalData()
	gT.CurrentArchaelogyData = {Players = {}}
	for g, h in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			gT.CurrentArchaelogyData.Players[g] = 0;
		end
	end
end

function GetArchaFromTech(iPlayer)
	return gT.Players[iPlayer].ArchaFromTech
end

function GetArchaFromGW(iPlayer)
	local b = 0;
	if gT.Players[iPlayer].HasPlayerWonder[induwonder8] then
		b = b + math.floor(gT.Players[iPlayer].NumGreatWorks/ 5)
	end
	return b
end

function GetArchaFromAcademies(iPlayer)
	local t = GetNumAcademiesWithAbility(iPlayer, 41) * 7 + GetPlayerSmallAcademyPointsOfType(iPlayer, Archaeology);
	return t;
end

function GetArchaFromManufactories(iPlayer)
	return gT.Players[iPlayer].ArchFromManu;
end

function GetPlayerSmallAcademyPointsOfType(iPlayer, sType)
	local t = 0;
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		t = t + 2 * GetCityBasicPointsFromAcademies(iCity, cID, sType);
	end
	return t;
end

function GetArchaFromCustomsHouses(iPlayer)
	local t = 0;
	for iCity in Players[iPlayer]:Cities() do
		if HasCityCHIncomingTrait(iCity, 19) then
			t = t + 5;
		end
	end
	return t;
end

function GetArchaFromMuseums(iPlayer)
	return 4 * Players[iPlayer]:CountNumBuildings(bcmuseum)
end

function GetArchaFromCS(iPlayer)
	local t = 0;
	for i, minor in pairs(gT.Globals.CSbyTypes[GameInfoTypes.MINOR_TRAIT_ANTIQUE]) do
		t = t + math.max(0, Players[minor]:GetMinorCivFriendshipLevelWithMajor(iPlayer)) * 3;
	end
	if gT.Players[iPlayer].CultBonusOn[118] then
		t = math.floor(t * 1.5);
	end
	return t;
end

function GetArchaeologyPointsPerTurn(iPlayer, bTopPanel)
	local base = GetArchaFromMuseums(iPlayer) + CollectCityBonusesEmpireWide(iPlayer, 17) + GetArchaFromTech(iPlayer) + GetArchaFromAcademies(iPlayer) + GetArchaeologyPointsFromGPC(iPlayer);
	base = base + GetArchaPointsFromWonders(iPlayer) + GetArchaFromGW(iPlayer) + GetArchaFromCS(iPlayer) + GetArchaFromCustomsHouses(iPlayer) + GetArchaFromManufactories(iPlayer)
	return base;
end

function GetTotalArchaeologyGlobal()
	local b = 0;
	if DBScenario.Archaeology then
		for i, v in pairs(gT.CurrentArchaelogyData.Players) do
			b = b + v;
		end
	end
	return b;
end

function DoFinishArchaeologicalDig(playerID, x, y)
	local iPlot = Map.GetPlot(x, y)
	local index = iPlot:GetPlotIndex();
	local iOwner = iPlot:GetOwner();
	if not gT.ArchaeologyPlots[index] then
		print("It is duplicate Archaeology call")
		return;
	end
	CreateArchaeologySiteOnPlot(iPlot)
	local archeTab = {}
	local cUnitToKill = 0;
	local numForeign = 0;
	for i = 0, iPlot:GetNumUnits() - 1 do
		local jUnit = iPlot:GetUnit(i);
		if jUnit:GetUnitType() == cArchae then
			if not archeTab[jUnit:GetOwner()] then
				archeTab[jUnit:GetOwner()] = {}
			end
			table.insert(archeTab[jUnit:GetOwner()], jUnit)
			cUnitToKill = cUnitToKill + 1;
			if jUnit:GetOwner() ~= playerID then
				numForeign = numForeign + 1;
			end
		end
	end
	if iPlot:IsVisible(Game.GetActiveTeam()) then
		local hex = ToHexFromGrid(Vector2(iPlot:GetX(),iPlot:GetY()));
		Events.GameplayFX(hex.x, hex.y, -1)
	end
	local gngp = GetNumAcademiesWithAbility(playerID, 38);
	if gngp > 0 then
		AddCulturalPresenceWorldWide(playerID, gngp * 25, nil, true)
	end
	if gT.Wonders[GameInfoTypes.BUILDING_ITG_NEW_INDUSTRIAL_WONDER_3] then
		local lvrPlayer = Map.GetPlotByIndex(gT.Wonders[GameInfoTypes.BUILDING_ITG_NEW_INDUSTRIAL_WONDER_3]):GetOwner();
		CreateGreatWorkOfAmount(lvrPlayer, 1, "Random")
	end
	BasicCallRandomYieldCH(19, nil)
	for g, h in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			local tscpa = GetNumAcademiesWithAbility(g, 37);
			if tscpa > 0 then
				ChangeITGScience(g, 50 * tscpa)
			end
			if not gT.ArchaeologyPlots[index].PlayerDelays[g] then
				gT.Players[g].ArchaeologistNum = gT.Players[g].ArchaeologistNum - 1;
--				print("Player Archa Num", index, g, -1)
				--here also kill archae and grant gworks + notification
				local numgwHap = #(archeTab[g] or {})
				if g == playerID then
					gT.Players[g].ArchSitesDigged = gT.Players[g].ArchSitesDigged + 1;
					local ngw = LastRandom(3, 4)
					local numgold = LastRandom(25, 75)
					local numsc = LastRandom(75, 125)
					local nmclt = LastRandom(50, 100)
					local numprestige = LastRandom(55,85);
					local nummerit = LastRandom(3,5)
					local sleaguestring;
					if IsPlayerObligatedToReturnGWOnArchaeologicalDig(g, iOwner) then
						ngw = ngw - 2;
						CreateGreatWorkOfAmount(iOwner, 2, "Random")
						sleaguestring = "[NEWLINE][NEWLINE]We were obligated to grant 2 [ICON_GREAT_WORK] Great Works to " .. Players[iOwner]:GetCivilizationShortDescription() .. ".";
						if Players[iOwner]:IsHuman() then
							Players[iOwner]:AddNotification(94343293, "We were granted 2 [ICON_GREAT_WORK] Great Works by Archaeologists digging in our territory", "Grant", iPlot:GetX(), iPlot:GetY(), 17, iOwner)
						end
					end
					ChangeITGScience(g, numsc)
					ChangeITGCulture(g, nmclt)
					ChangeITGGold(g, numgold)
					ChangeMeritocracy(g, nummerit)
					VictoryTaskCompletion(g, 5)
					local fg = 50 * (gT.Players[g].WonderRuinsEffects[9] or 0)
					if fg > 0 then
						ChangeITGFaith(g, fg)
					end
					CreateGreatWorkOfAmount(g, ngw, "Random")
					for index, data in pairs(gT.Academies) do
						if data.Player == g then
							if IsAcademyActiveRightNow(index) then
								AddPrestigeToAcademy(index, numprestige, "Archaeological Discovery")
							end
						end
					end
					if HasPlayerTech(g, innoindu9, "234ad34") then
						CreateGreatWorkOfAmount(g, 2, "Literature")
						ngw = ngw + 1;
					end
					if HasPlayerTech(g, innoindu5, "gewwewqwcbb") then
						gT.Players[g].Ind5NatUnity = gT.Players[g].Ind5NatUnity + 1;
						ChangeMeritocracy(g, 1)
					end
					if Players[g]:IsHuman() then
						local sText = "Our Archaeologists have found [COLOR_SELECTED_TEXT]" .. gT.ArchaeologyPlots[index].Name .. "[ENDCOLOR]!"
						sText = sText .. "[NEWLINE][ICON_BULLET]+" .. ngw .. " [ICON_GREAT_WORK] Great Works."
						sText = sText .. "[NEWLINE][ICON_BULLET]+" .. numsc .. " [ICON_RESEARCH] Science."
						sText = sText .. "[NEWLINE][ICON_BULLET]+" .. nmclt .. " [ICON_CULTURE] Culture."
						sText = sText .. "[NEWLINE][ICON_BULLET]+" .. numgold .. " [ICON_GOLD] Gold."
						if fg > 0 then
							sText = sText .. "[NEWLINE][ICON_BULLET]+" .. fg .. " [ICON_PEACE] Faith."
						end
						sText = sText .. "[NEWLINE][ICON_BULLET]+" .. nummerit .. " [ICON_ITG_MERITOCRACY] Meritocracy."
						sText = sText .. "[NEWLINE][ICON_BULLET]+" .. numprestige .. " [ICON_ITG_ACADEMY_1] Prestige in all Academies."
						if sleaguestring then
							sText = sText .. sleaguestring;
						end
						Players[g]:AddNotification(94343293, sText, "Dig Completed", iPlot:GetX(), iPlot:GetY(), 17, g)
						if numForeign >= 4 then
							LuaEvents.ITG_AchievementCompleted(11)
						end
					end
				elseif numgwHap > 0 then
					local rewSecType = LastRandom(1, 5);
					if rewSecType == 1 then
						CreateGreatWorkOfAmount(g, numgwHap, "Random")
					elseif rewSecType == 2 then
						ChangeITGGold(g, numgwHap * 25)
					elseif rewSecType == 3 then
						ChangeITGScience(g, numgwHap * 20)
					elseif rewSecType == 4 then
						ChangeITGCulture(g, numgwHap * 25)
					elseif rewSecType == 5 then
						for index, data in pairs(gT.Academies) do
							if data.Player == g then
								if IsAcademyActiveRightNow(index) then
									AddPrestigeToAcademy(index, numgwHap * 12, "Archaeological Discovery")
								end
							end
						end
					elseif rewSecType == 6 then
						ChangeMeritocracy(g, numgwHap * 3)
					end
					if Players[g]:IsHuman() then
						local notifyS = "Unfortunately " .. Players[playerID]:GetCivilizationShortDescription() .. " located [COLOR_SELECTED_TEXT]" .. gT.ArchaeologyPlots[index].Name .. "[ENDCOLOR] before us. ";
						if rewSecType == 1 then
							notifyS = notifyS .. "Our Archaeologists came back home with [COLOR_POSITIVE_TEXT]" .. numgwHap .. "[ENDCOLOR] [ICON_GREAT_WORK] Great Work" .. GetSIfPlural(numgwHap) .. "."
						elseif rewSecType == 2 then
							notifyS = notifyS .. "Our Archaeologists came back home with [COLOR_POSITIVE_TEXT]" .. numgwHap * 25 .. "[ENDCOLOR] [ICON_GOLD] Gold.";
						elseif rewSecType == 3 then
							notifyS = notifyS .. "Efforts of our archaeologists resulted in [COLOR_POSITIVE_TEXT]+" .. numgwHap * 20 ..  "[ENDCOLOR] [ICON_RESEARCH] Science.";
						elseif rewSecType == 4 then
							notifyS = notifyS .. "Efforts of our archaeologists resulted in [COLOR_POSITIVE_TEXT]+" .. numgwHap * 25 ..  "[ENDCOLOR] [ICON_CULTURE] Culture.";
						elseif rewSecType == 5 then
							notifyS = notifyS .. "Efforts of our archaeologists resulted in [COLOR_POSITIVE_TEXT]+" .. numgwHap * 12 ..  "[ENDCOLOR] [ICON_ITG_ACADEMY_1] Prestige in all Academies.";
						elseif rewSecType == 5 then
							notifyS = notifyS .. "Efforts of our archaeologists resulted in [COLOR_POSITIVE_TEXT]+" .. numgwHap * 3 ..  "[ENDCOLOR] [ICON_ITG_MERITOCRACY] Meritocracy.";
						end
						Players[g]:AddNotification(94343293, notifyS, "Dig Completed", iPlot:GetX(), iPlot:GetY(), 17, playerID)
					end
				end
				for ij, iUnit in pairs(archeTab[g] or {}) do
					iUnit:Kill(true, -1);
				end
			end
		end
	end
	for i, human in pairs(gT.Globals.HumanPlayers) do
		if human == playerID then
			DoInsertArchaeologicalNote(human, "T" .. GetITGGameTurn() .. ": We found [COLOR_SELECTED_TEXT]" .. gT.ArchaeologyPlots[index].Name .. "[ENDCOLOR].")
		else
			DoInsertArchaeologicalNote(human, "T" .. GetITGGameTurn() .. ": " .. Players[playerID]:GetCivilizationShortDescription() .. " found [COLOR_SELECTED_TEXT]" .. gT.ArchaeologyPlots[index].Name .. "[ENDCOLOR].")
		end
	end
	RemoveLabelOnPlot(iPlot, "Archaeology", nil, true, nil, true)
	gT.ArchaeologyPlots[index] = nil;
end

function DoTerminateArchaeologyFromPlot(iPlot, index)
	iPlot:SetResourceType(-1);
	iPlot:SetNumResource(0);
	if gT.ArchaeologyPlots[index] ~= -1 then
		for g, gdata in pairs(gT.Players) do
			if not Players[g]:IsMinorCiv() then
				if gT.ArchaeologyPlots[index].PlayerDelays[g] then
					Map.GetPlotByIndex(gPlot):SetResourceHiddenFromTeam(Players[g]:GetTeam(), false)
				else
					gT.Players[g].ArchaeologistNum = gT.Players[g].ArchaeologistNum - 1;
				end
			end
		end
		RemoveLabelOnPlot(iPlot, "Archaeology", nil, true, nil, true)
	else
		print("Logical error 532434634/12324", index);
	end
	gT.ArchaeologyPlots[index] = nil;
end

function GetNextArchaeologyTimer(gTurn)
	return LastRandom(-1, 1) + math.floor((gTurn + 2) / 5) * 5 + 5
end

function ChangeArchaeologyPoints(g, pett)
	gT.Players[g].ArchPointsTotal = gT.Players[g].ArchPointsTotal + pett;
	gT.CurrentArchaelogyData.Players[g] = gT.CurrentArchaelogyData.Players[g] + pett
	if HasPlayerTech(g, innoindu9, "234ad34") then
		if pett > 1 then
			BoostArtisticPoints(g, math.floor(pett/ 2), false)
		end
	end
end

function ArchaeologyDoTurn()
	if not DBScenario.Archaeology then
		return;
	end
	for g, t in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			local pett = GetArchaeologyPointsPerTurn(g);
			ChangeArchaeologyPoints(g, pett)
			if pett >= 100 then
				if Players[g]:IsHuman() then
					LuaEvents.ITG_AchievementCompleted(105)
				end
			end
		end
	end
	local gTurn = GetITGGameTurn();
	for gIndex, sth in pairs(gT.ArchaeologyPlots) do
		if sth ~= -1 then
			for player, turn in pairs(sth.PlayerDelays) do
				if turn <= gTurn then
					DoShowPlayerANewArtifactPlace(player, gIndex)
					gT.ArchaeologyPlots[gIndex].PlayerDelays[player] = nil
				end
			end
		end
	end
	if gT.ArchaeologyTimer <= gTurn then
		DoNewArchaeologySolution()
		gT.ArchaeologyTimer = GetNextArchaeologyTimer(gTurn)
		InitNewArchaeologicalData()
	end
end

function GetBonusFromBibloteque(iPlayer)
	local base = 0
	if gT.Players[iPlayer].HasPlayerWonder[bInduWonder10] then
		base = base + 5 * GetNumActiveAcademies(iPlayer);
	end
	return base;
end

function GetArchaPointsFromWonders(iPlayer)
	local base = GetBonusFromBibloteque(iPlayer)
	if gT.Players[iPlayer].HasPlayerWonder[bInduWonder10] then
		base = base + 5;
	end
	for iCity in Players[iPlayer]:Cities() do
		if iCity:IsHasBuilding(bInduWonder11) then
			base = base + math.floor(iCity:GetYieldRateTimes100(yScience) / 300)
		end
	end
	return base;
end

function CanBeArchaelogySiteBasic(iPlot)
	if iPlot:GetResourceType(-1) == -1 then
		if not iPlot:IsMountain() and (not iPlot:IsImpassable()) then
			if iPlot:GetTerrainType() ~= tSnow then
				if (iPlot:GetFeatureType() == -1) or (not GameInfo.Features[iPlot:GetFeatureType()].NoImprovement) then
					return true;
				end
			end
		end
	end
	return false;
end

function CanBeArchaeologySiteDynamic(iPlot)
	if not iPlot:IsCity() then
		if not gT.Globals.BadPoints[iPlot:GetPlotIndex()] then
			if not IsSpecialControlPlot(iPlot:GetPlotIndex(), false) then
				if iPlot:GetResourceType() == -1 then
					if (iPlot:GetFeatureType() == -1) or (not GameInfo.Features[iPlot:GetFeatureType()].NoImprovement) then
						return true;
					end
				end
			end
		end
	end
	return false;
end

function CreateArchaeologySiteOnPlot(iPlot)
	local sc, gld, clt = 0, 0, 0;
	for i = 1, 9 do
		local lk = LastRandom(1, 3);
		if lk == 1 then
			sc = sc + 1;
			iPlot:ChangeYieldIfNotPillaged(yScience, 1)
		elseif lk == 2 then
			gld = gld + 1;
			iPlot:ChangeYieldIfNotPillaged(yGold, 1)
		else
			clt = clt + 1;
			iPlot:ChangeYieldIfNotPillaged(yCulture, 1)
		end
	end
	gT.ArchaeologySites[iPlot:GetPlotIndex()] = {Yields = {[yScience] = sc, [yGold] = gld, [yCulture] = clt}}
	if iPlot:GetImprovementType() ~= improSiteArch then
		iPlot:SetImprovementType(improSiteArch, -1);
	end
end

function EndEraConversionClearArchaelogy()
	for index, sth in pairs(gT.ArchaeologySites) do
		local iPlot = Map.GetPlotByIndex(index);
		for yield, val in pairs(sth.Yields) do
			if val > 0 then
				iPlot:ChangeYieldIfNotPillaged(yield, -val)
			end
		end
	end
	for index, sth in pairs(gT.ArchaeologyPlots) do
		if sth ~= -1 then
			for gPlayer, delay in pairs(sth.PlayerDelays) do
				Map.GetPlotByIndex(gPlot):SetResourceHiddenFromTeam(Players[gPlayer]:GetTeam(), false)
			end
		end
	end
end

function GetArchaelogicalName()
	local lTab = {};
	for i, v in pairs(ArchPlacesSites) do
		if not gT.ArchaeologicalNamesUsed[i] then
			table.insert(lTab, i)
		end
	end
	if #lTab > 0 then
		local lkey = lTab[LastRandom(1,#lTab)];
		gT.ArchaeologicalNamesUsed[lkey] = 1;
		return ArchPlacesSites[lkey];
	end
	return "Ancient Ruins"
end

function DoSpecialArchaeologyTarget(iPlayer)
	local gPlot = GetValidPlotForNewArchaeologyDig()
	if not gPlot then
		return;
	end
	local gTurn = GetITGGameTurn();
	local gIndex = gPlot:GetPlotIndex();
	gT.ArchaeologyPlots[gIndex] = {TurnStart = gTurn, PlayerDelays = {}, Name = GetArchaelogicalName()}
	gT.Players[iPlayer].ArchLocatedFirst = gT.Players[iPlayer].ArchLocatedFirst + 1;
	DoShowPlayerANewArtifactPlace(iPlayer, gIndex)
	if Players[iPlayer]:IsHuman() then
		DoInsertArchaeologicalNote(iPlayer, "T" .. gTurn .. ": Our Expedition located [COLOR_SELECTED_TEXT]" .. gT.ArchaeologyPlots[gIndex].Name .. "[ENDCOLOR].")
	end
	for h, v in pairs(gT.CurrentArchaelogyData.Players) do
		if iPlayer ~= h then
			gPlot:SetResourceHiddenFromTeam(Players[h]:GetTeam(), true) -- this one is actually no team friendly mechanism
			gT.ArchaeologyPlots[gIndex].PlayerDelays[h] = gTurn + 10
			if Players[h]:IsHuman() then
				DoInsertArchaeologicalNote(h, "T" .. gTurn .. ": Our Scholars are close to locate [COLOR_SELECTED_TEXT]" .. gT.ArchaeologyPlots[gIndex].Name .. "[ENDCOLOR]. They need [COLOR_POSITIVE_TEXT]10[ENDCOLOR] more turns.")
			end
		end
	end
	gPlot:SetResourceType(grArtifacts)
end

function DoNewArchaeologySolution()
	local gPlot = GetValidPlotForNewArchaeologyDig()
	local gTurn = GetITGGameTurn();
	if gPlot and (gTurn < 93) then
		local gIndex = gPlot:GetPlotIndex();
		gT.ArchaeologyPlots[gIndex] = {TurnStart = gTurn, PlayerDelays = {}, Name = GetArchaelogicalName()}
		local bestValue = 1;
		for h, v in pairs(gT.CurrentArchaelogyData.Players) do
			bestValue = math.max(bestValue, v);
		end
		local basedelay = 0;
		for h, v in pairs(gT.CurrentArchaelogyData.Players) do
			if v == bestValue then
				basedelay = math.max(basedelay, GetNumAcademiesWithAbility(h, 40))
			end
		end
		for h, v in pairs(gT.CurrentArchaelogyData.Players) do
			if v == bestValue then
				BasicCSMissionCompleteFunc(h, 24, nil, nil, nil, 10)
				gT.Players[h].ArchLocatedFirst = gT.Players[h].ArchLocatedFirst + 1;
				DoShowPlayerANewArtifactPlace(h, gIndex)
				if Players[h]:IsHuman() then
					DoInsertArchaeologicalNote(h, "T" .. gTurn .. ": Our Scholars located [COLOR_SELECTED_TEXT]" .. gT.ArchaeologyPlots[gIndex].Name .. "[ENDCOLOR].")
				end
			else
				gPlot:SetResourceHiddenFromTeam(Players[h]:GetTeam(), true) -- this one is actually no team friendly mechanism
				local delay = math.max(1, 10 - math.floor( v / bestValue * 10) + basedelay - GetNumAcademiesWithAbility(h, 40));
				BasicCSMissionCompleteFunc(h, 24, nil, nil, nil, 10 - delay)
				gT.ArchaeologyPlots[gIndex].PlayerDelays[h] = gTurn + delay
				if Players[h]:IsHuman() then
					DoInsertArchaeologicalNote(h, "T" .. gTurn .. ": Our Scholars are close to locate [COLOR_SELECTED_TEXT]" .. gT.ArchaeologyPlots[gIndex].Name .. "[ENDCOLOR]. They need [COLOR_POSITIVE_TEXT]" .. delay .. "[ENDCOLOR] more turn"  .. GetSIfPlural(delay) .. ".")
				end
			end
		end
		gPlot:SetResourceType(grArtifacts)
	else
		--science for everyone !!!111
		for g, val in pairs(gT.CurrentArchaelogyData.Players) do
			if val > 0 then
				ChangeITGScience(g, val)
				if Players[g]:IsHuman() then
					DoInsertArchaeologicalNote(g, "T" .. gTurn .. ": We have earned [COLOR_POSITIVE_TEXT]" .. val .. "[ENDCOLOR] [ICON_RESEARCH] Science from studying old manuscripts.")
				end
			end
		end
	end
end

function DoInsertArchaeologicalNote(iPlayer, sText)
	table.insert(gT.Players[iPlayer].ArchaeologyNotes, sText)
	if #gT.Players[iPlayer].ArchaeologyNotes > 10 then
		table.remove(gT.Players[iPlayer].ArchaeologyNotes, 1)
	end
end

function GetValidPlotForNewArchaeologyDig()
	local lTab = {}
	for index, sth in pairs(gT.ArchaeologyPlots) do
		if sth == -1 then
			table.insert(lTab, index);
		end
	end		
	lTab = Shuffle(lTab);
	for i, index in pairs(lTab) do
		local iPlot = Map.GetPlotByIndex(index);
		if CanBeArchaeologySiteDynamic(iPlot) then
			return iPlot;
		else
			gT.ArchaeologyPlots[index] = nil;
		end
	end
	return nil;
end

function DoShowPlayerANewArtifactPlace(gPlayer, gIndex)
	gT.Players[gPlayer].ArchaeologistNum = gT.Players[gPlayer].ArchaeologistNum + 1;
	local gPlot = Map.GetPlotByIndex(gIndex);
	local gTeam = Players[gPlayer]:GetTeam();
	if not gPlot:IsRevealed(gTeam) then
		gPlot:SetRevealed(gTeam, true); -- it actually happened to spawn on unseen land :)
	end
	if gPlot:IsResourceHiddenFromTeam(gTeam) then
		gPlot:SetResourceHiddenFromTeam(gTeam, false)
	end
	if Players[gPlayer]:IsHuman() then
		AddSmallInfo(gPlot, nil, "Archaeology", nil, nil, nil, nil, gPlayer)
		local hex = ToHexFromGrid(Vector2(gPlot:GetX(),gPlot:GetY()));
		Events.GameplayFX(hex.x, hex.y, -1)
		Players[gPlayer]:AddNotification(94343293, "Our scholars located place that hides [COLOR_SELECTED_TEXT]" .. gT.ArchaeologyPlots[gIndex].Name .. "[ENDCOLOR].", "Archaeological Site",  gPlot:GetX(), gPlot:GetY(), 17)
	end
end

function GetArchaeologyTextForTP(iPlayer)
	local sText = "Every several turns new Antiquity Site is revealed. Civilizations that gathered the most [ICON_RES_ARTIFACTS] Historical Sources are the first to find its location."
	local tTab = {}
	table.insert(tTab, {GetArchaFromMuseums(iPlayer), "Museums"})
	table.insert(tTab, {GetArchaFromTech(iPlayer), "Technologies"})
	table.insert(tTab, {GetArchaFromGW(iPlayer), "Great Works"})
	table.insert(tTab, {GetArchaeologyPointsFromGPC(iPlayer), "Great People"})
	table.insert(tTab, {GetArchaPointsFromWonders(iPlayer), "Wonders"})
	table.insert(tTab, {GetArchaFromAcademies(iPlayer),"Academies"})
	table.insert(tTab, {GetArchaFromManufactories(iPlayer),"Manufactories"})
	table.insert(tTab, {CollectCityBonusesEmpireWide(iPlayer, 17),"Governance"})
	
	
	table.insert(tTab, {GetArchaFromCustomsHouses(iPlayer),"Customs-Houses"})
	table.insert(tTab, {GetArchaFromCS(iPlayer),"City-States"})
	for tt, ttd in pairs(tTab) do
		if ttd[1] > 0 then
			sText = sText .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]+" .. ttd[1] .. "[ENDCOLOR][ICON_RES_ARTIFACTS] from " .. ttd[2] .. ".";
		elseif ttd[1] < 0 then
			sText = sText .. "[NEWLINE][ICON_BULLET][COLOR_NEGATIVE_TEXT]" .. ttd[1] .. "[ENDCOLOR][ICON_RES_ARTIFACTS] from " .. ttd[2] .. ".";
		end
	end
	if #gT.Players[iPlayer].ArchaeologyNotes > 0 then
		sText = sText .. "[NEWLINE][NEWLINE]Recent archaeological events:"
		local tp = #gT.Players[iPlayer].ArchaeologyNotes;
		for i = 1, tp do
			sText = sText .. "[NEWLINE][ICON_BULLET]" .. gT.Players[iPlayer].ArchaeologyNotes[tp + 1 - i];
		end
	end
	if gT.Players[iPlayer].ArchaeologistNum > 0 then
		sText = sText .. "[NEWLINE][NEWLINE]We know location of [COLOR_POSITIVE_TEXT]" .. gT.Players[iPlayer].ArchaeologistNum .. "[ENDCOLOR] Archaeological Site" .. GetSIfPlural(gT.Players[iPlayer].ArchaeologistNum) .. " right now.[NEWLINE]LEFT-CLICK to center map on Archaelogical Site location."
	else
		sText = sText .. "[NEWLINE][NEWLINE]We have no information about any Archaeological Site right now."
	end
	return sText
end

local lALUindex;
LuaEvents.ITG_CallSeeNextArchaeologySite.Add(function()
	local bNext = false; 
	local plot;
	if not lALUindex then
		bNext = true;
	end
	local iTeam = Game.GetActiveTeam();
	local iActivePlayer = Game.GetActivePlayer();
	for index, sth in pairs(gT.ArchaeologyPlots) do
		if sth ~= -1 then
			if Map.GetPlotByIndex(index):IsRevealed(iTeam) then
				if not sth.PlayerDelays[iActivePlayer] then
					if bNext then
						plot = Map.GetPlotByIndex(index)
						break;
					elseif lALUindex == index then
						bNext = true;
					end
				end
			end
		end
	end
	if not plot then
		for index, sth in pairs(gT.ArchaeologyPlots) do
			if sth ~= -1 then
				if Map.GetPlotByIndex(index):IsRevealed(iTeam) then
					if not sth.PlayerDelays[iActivePlayer] then
						plot = Map.GetPlotByIndex(index)
						break;
					end
				end
			end
		end
	end
	if plot then
		lALUindex = plot:GetPlotIndex();
		local hex = ToHexFromGrid(Vector2(plot:GetX(),plot:GetY()));
		Events.GameplayFX(hex.x, hex.y, -1)
		UI.LookAt(plot)
	end
end)