local techTRIALpagan1 = GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_PAGAN_1;
local sistineChapel1 = GameInfoTypes.BUILDING_ITG_NEW_WORLD_WONDER_1
local arabTrial8 = GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_ARABIA_8;
local wonderSphinx = GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_22;

function DoInitAuthorityMatters()
	DoInitPalaces()
	for g, h in pairs(gT.Players) do
		gT.Players[g].ChateauAuthority = 0;
		if not Players[g]:IsMinorCiv() then
			CalculateBasicAuthorityValues(g)
			gT.Players[g].Authority = GetPlayerAuthority(g, false)
		end
	end
	for g, h in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			SetPlayerAuthorityRank(g)
		end
	end
end

function DoTurnBarbAuthority()
	CalculateChateauAuthority()
	for g, h in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			CalculateBasicAuthorityValues(g)
			gT.Players[g].Authority = GetPlayerAuthority(g, true)
			gT.Players[g].LHTotalAuthority = gT.Players[g].LHTotalAuthority + gT.Players[g].Authority;
			gT.Players[g].LHMaxAuthority = math.max(gT.Players[g].LHMaxAuthority,gT.Players[g].Authority)
			if gT.Players[g].Authority >= 100 then
				if Players[g]:IsHuman() then
					LuaEvents.ITG_AchievementCompleted(50)
				end
			end
		end
	end
	for g, h in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			SetPlayerAuthorityRank(g)
		end
	end
end

function IsAlwaysRank1AtAuthority(iPlayer)
	if gT.Players[iPlayer].HasPlayerWonder[GameInfoTypes.BUILDING_ITG_NEW_WORLD_WONDER_31] then
		return true;
	end
	return false;
end

function SetPlayerAuthorityRank(iPlayer)
	local rank = 1;
	local metplayer = 0;
	local hTeam = Players[iPlayer]:GetTeam();
	if not IsAlwaysRank1AtAuthority(iPlayer) then
		for g, j in pairs(gT.Players) do
			if not Players[g]:IsMinorCiv() then
				if g ~= iPlayer then
					if Teams[hTeam]:IsHasMet(Players[g]:GetTeam()) then
						metplayer = metplayer + 1;
						if j.Authority > gT.Players[iPlayer].Authority then
							rank = rank + 1;
						end
					end
				end
			end
		end
	end
	if Players[iPlayer]:IsAlive() then
		DoBonusesOnRankSetAuthority(iPlayer, rank)
	else
		DoBonusesOnRankSetAuthority(iPlayer, 22)
	end
end

function DoBonusesOnRankSetAuthority(iPlayer, rank)
	gT.Players[iPlayer].AuthorityRank = rank;
end

function GetAuthorityFromCultBonus202(iPlayer, hTeam)
	local cEmbassies = 0;
	for g, j in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			if gT.Players[iPlayer].Authority > j.Authority then
				if Teams[hTeam]:HasEmbassyAtTeam(Players[g]:GetTeam()) then
					cEmbassies = cEmbassies + 1;
				end
			elseif gT.Players[iPlayer].Authority < j.Authority then
				if Teams[Players[g]:GetTeam()]:HasEmbassyAtTeam(hTeam) then
					cEmbassies = cEmbassies + 1;
				end
			end
		end
	end
	return cEmbassies;
end

function CalculateBasicAuthorityValues(iPlayer)
	local hTeam = Players[iPlayer]:GetTeam();
	local cAuth = 0;
	if gT.Players[iPlayer].HasCodex then
		cAuth = cAuth + 1 + math.floor(gT.Players[iPlayer].CodexStrength / 40)
		for g, j in pairs(gT.Players) do
			if (j.CodexStrength or 0) > gT.Players[iPlayer].CodexStrength then
				if Teams[hTeam]:IsHasMet(Players[g]:GetTeam()) then
					cAuth = cAuth - 1;
					break;
				end
			end
		end
	end
	gT.Players[iPlayer].AuthorityCodex = cAuth
	gT.Players[iPlayer].AuthorityGoverment = GetPlayerAuthorityFromGoverment(iPlayer, gT.Players[iPlayer].Goverment);
	local bCityID, val = nil, -1;
	for iCity in Players[iPlayer]:Cities() do
		local auth = GetBasicAuthorityFromCity(iPlayer, iCity);
		if auth > val then
			bCityID = iCity:GetID();
			val = auth;
		end
	end
	gT.Players[iPlayer].BestAuthorityCity = bCityID;
end

function GetPlayerAuthorityFromGoverment(iPlayer, gov)
	local gAuth = 0;
	if gT.Players[iPlayer].GovRewards[1] then
		local maj, minor = false, false;
		local iTeam = Players[iPlayer]:GetTeam();
		for g, h in pairs(gT.Players) do
			if (h.Goverment == gov) and (g ~= iPlayer) then
				if Teams[Players[g]:GetTeam()]:IsHasMet(iTeam) then
					if Players[g]:IsMinorCiv() then
						if Players[g]:GetAlly() == iPlayer then
							minor = true
						end
					else
						maj = true;
					end
					if maj and minor then
						gAuth = gAuth + AUTHORITY_PRINCIPLE;
						break;
					end
				end
			end
		end
	end
	if gT.Players[iPlayer].GovRewards[2] then
		if gT.Players[iPlayer].LastTurnCityLost + 8 < GetITGGameTurn() then
			if gT.Players[iPlayer].LastTurnCityCaptured + 8 >= GetITGGameTurn() then
				gAuth = gAuth + AUTHORITY_PRINCIPLE;
			end
		end
	end
	if gT.Players[iPlayer].GovRewards[3] then
		if gT.Players[iPlayer].AverageHappiness >= 0 then
			if gT.Players[iPlayer].LastTurnGPAscended + 10 >= GetITGGameTurn() then
				gAuth = gAuth + AUTHORITY_PRINCIPLE;
			end
		end
	end
	if gT.Players[iPlayer].GovRewards[4] then
		if gT.Players[iPlayer].LastTurnLegalSpend + 8 >= GetITGGameTurn() then
			if GetNumAlliedCS(iPlayer) > 0 then
				gAuth = gAuth + AUTHORITY_PRINCIPLE;
			end
		end
	end
	if gT.Players[iPlayer].GovRewards[5] then
		if (gT.Players[iPlayer].PrevTurnGPT or 0) > 0 then
			if gT.Players[iPlayer].LastTimeAttackedBySpy + 8 < GetITGGameTurn() then
				gAuth = gAuth + AUTHORITY_PRINCIPLE;
			end
		end
	end
	if gT.Players[iPlayer].GovRewards[6] then
		if NoLegallyOwnedCityIsDamaged(iPlayer) then
			gAuth = gAuth + AUTHORITY_PRINCIPLE;
		end
	end
	return gAuth;
end

function NoLegallyOwnedCityIsDamaged(iPlayer)
	for i, v in pairs(Players) do
		for iCity in v:Cities() do
			if iCity:GetOriginalOwner() == iPlayer then
				if (iPlayer ~= i) then
					return false;
				elseif (iCity:GetDamage() > 0) then
					return false;
				end
			end
		end
	end
	return true;
end

function GetAuthorityFromCodex(iPlayer)
	local a = gT.Players[iPlayer].AuthorityCodex;
	if gT.Players[iPlayer].HasIdeology[75] then
		if gT.Players[iPlayer].CodexStrength == gT.Globals.BestCodex then
			a = a + 5;
		end
	end
	return a;
end

function GetAuthorityFromChateaus(iPlayer)
	return gT.Players[iPlayer].ChateauAuthority;
end

function GetAuthorityFromAlliedCS(iPlayer)
	local ifhaveally = 0;
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_4, "^y43") then
		ifhaveally = 2
	end
	local t = 0;
	if ifhaveally ~= 0 then
		local na = GetNumAlliedCS(iPlayer)
		if na > 0 then
			t = t + ifhaveally;
		end
	end
	for i, minor in pairs(gT.Globals.CSbyTypes[GameInfoTypes.MINOR_TRAIT_TRADITIONAL]) do
		t = t + math.max(0, Players[minor]:GetMinorCivFriendshipLevelWithMajor(iPlayer));
	end
	if gT.Players[iPlayer].CultBonusOn[118] then
		t = math.floor(t * 1.5);
	end
	return t;
end

function GetAuthorityFromGoverment(iPlayer)
	return gT.Players[iPlayer].AuthorityGoverment;
end

function GetAuthorityFromPledgesOfProtection(iPlayer, bEndTurn)
	return 0;
end

function GetAuthorityFromCities(iPlayer)
	local tot = 0;
	for iCity in Players[iPlayer]:Cities() do
		tot = tot + GetTotalAuthorityFromCity(iPlayer, iCity)
	end
	return tot;
end

local tNWE8 = GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_EUROPE_8
local tPagan6 = GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_PAGAN_6
function GetAuthorityFromGP(iPlayer)
	local t = 0;
	local percivil = 0;
	local permilit = 0;
	if HasPlayerTech(iPlayer, tNWE8, "%46545t6534") then
		percivil = percivil + 1;
	end
	if HasPlayerTech(iPlayer, tPagan6, "kgoerkf") then
		permilit = permilit + 1;
	end
	if gT.Players[iPlayer].CultBonusOn[140] then
		percivil = percivil + 0.34;
	end
	for gpID, hhh in pairs(gT.Players[iPlayer].GreatPeople) do
		local gpData = gT.GreatPeople[gpID];
		if gpData.Alive then
			if gpData.Ability == 57 then
				t = t + 3
			end
			if (not gpData.Military) then
				t = t + percivil
			else
				t = t + permilit;
			end
		end
	end
	return math.floor(t)
end

function GetTotalAuthorityFromCity(iPlayer, iCity)
	local base = GetBasicAuthorityFromCity(iPlayer, iCity)
	local mod = 1;
	if iCity:GetID() == gT.Players[iPlayer].BestAuthorityCity then
		mod = mod + 1;
	end
	if iCity:IsOriginalCapital() and (iCity:GetOriginalOwner() == iPlayer) then
		mod = mod + GetModifierForCapitalAuthority(iPlayer, iCity);
	end
	if HasPlayerTech(iPlayer, arabTrial8, "arabTrial8") then
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		if gT.Cities[cID].PlacedGovernor then
			mod = mod + 0.5
		end
	end
	return math.floor(base * mod);
end

function HasGreatestPalaceNearby(cID)
	local hPt = 0;
	if gT.Cities[cID].Palace then
		hPt = gT.Cities[cID].Palace.Authority;
		for h, sIndex in pairs(GetNearCities(cID, 10)) do
			local sCity = Map.GetPlotByIndex(sIndex):GetPlotCity();
			local sCID = sCity:Plot():GetPlotIndex() .. "," .. sCity:GetGameTurnFounded();
			if gT.Cities[sCID].Palace then
				if gT.Cities[sCID].Palace.Authority > hPt then
					return false;
				end
			end
		end
		return true;
	end
	return false;
end

function GetBasicAuthorityFromCity(iPlayer, iCity)
	local b = 0;
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	if gT.Cities[cID].Palace then
		b = b + gT.Cities[cID].Palace.Authority;
	end
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_NW_TROPICAL_4, "4594534") then
		if HasGreatestPalaceNearby(cID) then
			b = b + 5;
		end
	end
	if iCity:IsOccupied() then
		b = math.max(0, b - 3);
	end
	return b;
end

function GetAuthorityFromNeverBeingInAnarchy(iPlayer)
	if gT.Players[iPlayer].LastAnarchyRevolution < 0 then
		return 1;
	end
	return 0;
end

function GetAuthorityFromNoblePriviliges(iPlayer)
	if gT.Players[iPlayer].NoblePriviligeUsed then
		return -2;
	end
	return 0;
end

function GetAuthorityFromAcademies(iPlayer)
	local t = GetNumAcademiesWithAbility(iPlayer, 59) * 2;
	return t;
end

function GetAuthorityFromSocialDevs(iPlayer)
	local a = 0;
	if gT.Players[iPlayer].HasIdeology[69] then
		a = a + GetNumForeignGovernors(iPlayer);
	end
	return a;
end

function GetAuthorityFromIdeologies(iPlayer)
	local a = 0;
	if gT.Players[iPlayer].HasMinorIdeology[15] then
		for iCity in Players[iPlayer]:Cities() do
			if HasWonderOrRuin(iCity) then
				a = a + 1;	
			end
		end
	end
	return a;
end

function GetAuthorityFromInnovations(iPlayer)
	local t = gT.Players[iPlayer].GekokujoAuthority;
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_EMPIRE_3, "fkelfe") then
		t = t + 1;
	end
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_PAGAN_5, "tpagan5") then
		t = t + math.floor(gT.Players[iPlayer].PillagedImpros / 8)
	end
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_EMPIRE_18, "fkelfe") then
		if IsFirstAtPrinciples(iPlayer) then
			t = t + 5;
		end
	end
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_1, "^y43") then
		t = t + gT.Players[iPlayer].CitiesFounded;
	end
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_ASIA_8, "325234123") then
		if gT.Players[iPlayer].KingUnitAlive then
			t = t + 1;
		end
	end
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_TRIBE_8, "Fkofkeof") then
		t = t + gT.Players[iPlayer].GreatestCityPopCaptured;
	end
	if HasPlayerTech(iPlayer, techTRIALpagan1, "Uwrewercwer") then
		for iCity in Players[iPlayer]:Cities() do
			if iCity:GetReligiousMajority() > 0 then
				t = t + 1;
			end
		end
	end
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_TRIBE_5, "vekofk") then
		local hb = 0;
		for iUnit in Players[iPlayer]:Units() do
			if (iUnit:GetUnitCombatType() == GameInfoTypes.UNITCOMBAT_MOUNTED) or (IsResourceUnit(iUnit, rHorse)) then
				hb = hb + 1;
			end
		end
		t = t + math.floor(hb / 3)
	end
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_TRIBE_2, "tgrwgwtg") then
		for it, bel in pairs(GetCurrentBeliefs(iPlayer)) do
			if GetBeliefTypeITG(bel) == 1 then
				t = t + 1;
			end
		end
	end
	return t;
end

function GetAuthorityFromGreatWorks(iPlayer)
	local t = 0;
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_EUROPE_2, "%4t6534") then
		t = t  + math.floor(gT.Players[iPlayer].NumGreatWorks / 10)
	end
	if gT.Players[iPlayer].HasPlayerWonder[sistineChapel1] then
		t = t  + math.floor(gT.Players[iPlayer].NumGreatWorks / 8)
	end
	return t;
end

function GetAuthorityFromFascism(iPlayer)
	return gT.Players[iPlayer].FascismAuth;
end

function GetAuthorityFromWonders(iPlayer)
	local a = 0;
	if gT.WondersConstructed[wonderSphinx] == iPlayer then
		for wonderID, h in pairs(gT.Players[iPlayer].HasPlayerWonder) do
			a = a + 1;
		end
	end
	return a;
end

function GetAuthorityFromManufactories(iPlayer)
	local bH = 0;
	for i, v in pairs(gT.Manufactories) do
		if v.Active and v.Player == iPlayer then
			for h, b in pairs(v.Traits) do
				if b.ID == 28 then
					bH = bH + (b.AuthorityBonus or 0)
				end
			end
		end
	end
	return bH;
end

function GetAuthorityFromWealth(iPlayer)
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_MEDIEVAL_AFR_2, "VErw") then
		return math.floor(Players[iPlayer]:GetGold() / 250)
	end
	return 0;
end

function GetAuthorityFromBudget(iPlayer)
	return (gT.Players[iPlayer].AuthorityBudget or 0)
end

function GetAuthorityFromElDorado(iPlayer)
	for index, sth in pairs(gT.ElDorados) do
		if sth.Player == iPlayer then
			return 3;
		end
	end
	return 0;
end

function GetPlayerAuthority(iPlayer, bEndTurn)
	local tA = GetAuthorityFromNoRiots(iPlayer) + GetAuthorityFromCodex(iPlayer) + GetAuthorityFromPledgesOfProtection(iPlayer, bEndTurn) +  GetAuthorityFromNeverBeingInAnarchy(iPlayer)
	tA = tA + GetAuthorityFromCities(iPlayer) + GetAuthorityFromWonderConstructed(iPlayer) + GetAuthorityFromGP(iPlayer) + GetAuthorityFromGoverment(iPlayer) + GetAuthorityFromGreatWorks(iPlayer) + GetAuthorityFromElDorado(iPlayer)
	tA = tA + GetAuthorityFromFascism(iPlayer) + GetAuthorityFromInnovations(iPlayer) + GetAuthorityFromAlliedCS(iPlayer) + GetAuthorityFromAcademies(iPlayer) + GetAuthorityFromNoblePriviliges(iPlayer) + GetAuthorityFromWealth(iPlayer)
	tA = tA + GetAuthorityFromTangCode(iPlayer) + GetAuthorityFromChivalryCode(iPlayer) + GetAuthorityFromBudget(iPlayer) + GetAuthorityFromManufactories(iPlayer) + GetAuthorityFromChateaus(iPlayer) + GetAuthorityFromIdeologies(iPlayer) + GetAuthorityFromSocialDevs(iPlayer)
	return tA;
end

function GetAuthorityFromNoRiots(iPlayer)
	local gturn = GetITGGameTurn();
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		if gT.Cities[cID].LastRiots + 4 >= gturn then
			if gT.Cities[cID].LastAcquired + 4 < gturn then
				return 0;
			end
		end 
	end
	return 1;
end

function GetAuthorityFromWonderConstructed(iPlayer)
	return gT.Players[iPlayer].NumWondersBuild;
end

function GetAverageAuthorityWithoutClumsyMods(g)
	return gT.Players[g].Authority - GetAuthorityFromFascism(g)
end

function GetModifierForCapitalAuthority(iPlayer, iCity)
	return gT.Players[iPlayer].CapitalAuthMod;
end

function GetAuthorityFromChivalryCode(iPlayer)
	local b = 0;
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_EURO_3 ,"Cfoekvoer") then
		local max = 0;
		for iUnit in Players[iPlayer]:Units() do
			max = math.max(max, iUnit:GetExperience());
		end
		b = b + math.floor(max / 60);
	end
	return b;
end

function GetAuthorityFromTangCode(iPlayer)
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_ASIA_5, "#$53242") then
		return math.floor(gT.Players[iPlayer].SpendLegalPower / 3)
	end
	return 0;
end

function GetAuthorityTextForTP(iPlayer)
	local sText = "Authority sources:"
	local tTab = {}
	local bHasTrialArab8 = HasPlayerTech(iPlayer, arabTrial8, "arabTrial8")
	for iCity in Players[iPlayer]:Cities() do
		local totAuth = GetTotalAuthorityFromCity(iPlayer, iCity)
		if totAuth > 0 then
			sText = sText .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]+" .. totAuth .. "[ENDCOLOR][ICON_ITG_AUTHORITY] from " .. iCity:GetName() .. ".";
			if iCity:GetID() == gT.Players[iPlayer].BestAuthorityCity then
				sText = sText .. "[NEWLINE][COLOR_GREY]		+100% Modifier for having the largest Authority output.[ENDCOLOR]"
			end
			if iCity:IsOriginalCapital() and (iCity:GetOriginalOwner() == iPlayer) then
				sText = sText .. "[NEWLINE][COLOR_GREY]		+" .. 100 * GetModifierForCapitalAuthority(iPlayer, iCity) .. "% Modifier for being legal Capital.[ENDCOLOR]" 
			end
			if bHasTrialArab8 then
				local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
				if gT.Cities[cID].PlacedGovernor then
					sText = sText .. "[NEWLINE][COLOR_GREY]		+50% Modifier from Viziers.[ENDCOLOR]"
				end
			end
			if iCity:IsOccupied() then
				sText = sText .. "[NEWLINE][COLOR_GREY]		-3 Authority from being occupied City.[ENDCOLOR]" 
			end
		elseif totAuth < 0 then
			print("Forget something 1325342/2532$?")	
		end
	end
	table.insert(tTab, {GetAuthorityFromCodex(iPlayer), "Codex"})
	table.insert(tTab, {GetAuthorityFromGoverment(iPlayer), "Goverment"})
	table.insert(tTab, {GetAuthorityFromAlliedCS(iPlayer), "allied City-States"})
	table.insert(tTab, {GetAuthorityFromPledgesOfProtection(iPlayer), "Pledges of Protection"})
	table.insert(tTab, {GetAuthorityFromNeverBeingInAnarchy(iPlayer), "never entering Anarchy"})
	table.insert(tTab, {GetAuthorityFromWonderConstructed(iPlayer), "constructed Wonders"})
	table.insert(tTab, {GetAuthorityFromNoRiots(iPlayer), "lack of Public Disorder"})
	table.insert(tTab, {GetAuthorityFromGP(iPlayer), "Great People"})
	table.insert(tTab, {GetAuthorityFromGreatWorks(iPlayer), "Great Works"})
	table.insert(tTab, {GetAuthorityFromElDorado(iPlayer), "El Dorado"})
	table.insert(tTab, {GetAuthorityFromInnovations(iPlayer), "Innovations"})
	table.insert(tTab, {GetAuthorityFromAcademies(iPlayer), "Academies"})
	table.insert(tTab, {GetAuthorityFromChateaus(iPlayer), "Chateaus"})
	table.insert(tTab, {GetAuthorityFromFascism(iPlayer), "Fascism"})
	table.insert(tTab, {GetAuthorityFromManufactories(iPlayer), "Manufactories"})
	table.insert(tTab, {GetAuthorityFromWonders(iPlayer), "Wonders"})
	table.insert(tTab, {GetAuthorityFromTangCode(iPlayer), "Tang Code"})
	table.insert(tTab, {GetAuthorityFromIdeologies(iPlayer), "Ideologies"})
	table.insert(tTab, {GetAuthorityFromSocialDevs(iPlayer), "Social Developments"})
	table.insert(tTab, {GetAuthorityFromWealth(iPlayer), "Wealth"})
	table.insert(tTab, {GetAuthorityFromBudget(iPlayer), "Propaganda"})
	table.insert(tTab, {GetAuthorityFromChivalryCode(iPlayer), "Chivalry Code"})
	table.insert(tTab, {GetAuthorityFromNoblePriviliges(iPlayer), "Noble Priviliges"})

	for tt, ttd in pairs(tTab) do
		if ttd[1] > 0 then
			sText = sText .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]+" .. ttd[1] .. "[ENDCOLOR][ICON_ITG_AUTHORITY] from " .. ttd[2] .. ".";
		elseif ttd[1] < 0 then
			sText = sText .. "[NEWLINE][ICON_BULLET][COLOR_NEGATIVE_TEXT]" .. ttd[1] .. "[ENDCOLOR][ICON_ITG_AUTHORITY] from " .. ttd[2] .. ".";
		end
	end
	sText = sText .. "[NEWLINE][NEWLINE]Authority ranking:"
	local iTeam = Players[iPlayer]:GetTeam();
	local tab = {}
	for g, j in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			if Players[g]:IsAlive() then
				if g == iPlayer or Teams[iTeam]:IsHasMet(Players[g]:GetTeam()) then
					table.insert(tab, {g, j.Authority})
				end
			end
		end
	end
	table.sort(tab,SortFunctionForGreaterInteger2)
	for i, v in pairs(tab) do
		sText = sText .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]" .. v[2] .. "[ENDCOLOR] [ICON_ITG_AUTHORITY] " .. GetNiceEditedPlayerForTPAuthority(v[1], iPlayer)
	end
	sText = sText .. "[NEWLINE][NEWLINE][ICON_ITG_AUTHORITY] Authority provides various bonuses, most of them are active only if you are first at ranking."
	sText = sText .. "[NEWLINE][ICON_BULLET]+" .. CS_POLITICS_FROM_AUTHORITY .. " points in City-State's politics if you have the highest [ICON_ITG_AUTHORITY] Authority within contenders.";
	sText = sText .. "[NEWLINE][ICON_BULLET]+1 [ICON_ITG_VOTES] Vote in the Leagues you have the highest [ICON_ITG_AUTHORITY] Authority within members.";
	sText = sText .. "[NEWLINE][ICON_BULLET]Chance to enter Anarchy is reduced if you are first at [ICON_ITG_AUTHORITY] Authority ranking."
	sText = sText .. "[NEWLINE][ICON_BULLET][ICON_ITG_MERCENARY] Mercenaries have flee chance reduced by 1% for every 50 [ICON_ITG_AUTHORITY] Authority you have."
	sText = sText .. "[NEWLINE][ICON_BULLET]+1 [ICON_ITG_POWER] Power per 5 [ICON_ITG_AUTHORITY] Authority (an extra 5 [ICON_ITG_POWER] Power if you are first)."
	sText = sText .. "[NEWLINE][ICON_BULLET]Some [ICON_GREAT_PEOPLE] Great People are attracted to high [ICON_ITG_AUTHORITY] Authority."
--	sText = sText .. GetGovermentPrincipleAuthorityRewardTT(iPlayer)
	return sText
end

function GetBalancedAuthorityPower(iPlayer)
	local gAuth = gT.Players[iPlayer].Authority or 0;
	local tot = 0;
	for i = 1, 100 do
		if i <= gAuth then
			gAuth = gAuth - i;
		else
			return i - 1;
		end
	end
	return 100;
end

function GetNiceEditedPlayerForTPAuthority(g, iPlayer)
	if g == iPlayer then
		return "You"
	else
		return Players[g]:GetName() .. " of " .. Players[g]:GetCivilizationShortDescription()
	end
end

function ChooseNextCapital(iPlayer, bCity)
	local bCityID, bVal = -1, -1;
	for iCity in Players[iPlayer]:Cities() do
		if iCity ~= bCity then
			local hauth = GetBasicAuthorityFromCity(iPlayer, iCity);
			if hauth > bVal then
				bVal = hauth;
				bCityID = iCity:GetID();
			end
		end
	end
	Players[iPlayer]:SetNextCapitalID(bCityID)
end