local uWorker = GameInfoTypes.UNIT_WORKER;
local hOceanTab;
local rFish = GameInfoTypes.RESOURCE_FISH
local rWhale = GameInfoTypes.RESOURCE_WHALE;
local rExtraFish = GameInfoTypes.RESOURCE_ITG_MORE_FISH;
local avoidDuplicates = {}
local bBuildFish = GameInfoTypes.IMPROVEMENT_FISHING_BOATS;
local bArtifacts = GameInfoTypes.IMPROVEMENT_ARCHAEOLOGICAL_DIG;
local pantheon14 = GameInfoTypes.BELIEF_ITG_PANTHEON_14;
local titv5 = GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_VIKING_5;
local tFoodFromFishin = {}
local tSettlerFromFishin = {}
for row in GameInfo.Buildings() do
	if row.FoodFromFishing > 0 then
		tFoodFromFishin[row.ID] = row.FoodFromFishing;
	end
	if row.SettlerFromFishing > 0 then
		tSettlerFromFishin[row.ID] = row.SettlerFromFishing;
	end
end

function OnBuildFinished( playerID, x, y, improvementID )
	local fID= GetRealGameTurn() .. "," .. x .. "," .. y .. "," .. improvementID;
	local iPlot = Map.GetPlot(x,y);
	local iPlotIndex = iPlot:GetPlotIndex();
	if improvementID == bBuildFish then
		NavalResourceCSQuestLog(playerID)
		table.remove(gT.Globals.WaterResources, iPlotIndex)
		iPlot:SetImprovementType(-1);
		local resType = iPlot:GetResourceType();
		iPlot:SetResourceType(-1)
		if avoidDuplicates[fID] then
			return
		end
		avoidDuplicates[fID] = 1;
		ResetFTDelay(0.5)
		if resType == rWhale then
			if HasPlayerTech(playerID, titv5, "632423") then
				ChangeITGCulture(playerID, 5);
				AddFloatingText(playerID, x, y, "+" .. 5 .. "[ICON_CULTURE]", nil, "Fish")
			end
		end
		BasicCSMissionCompleteFunc(playerID, 37, 1);
		DoIncreasementStockExchange(11)
		VictoryTaskCompletion(playerID, 61)
		local hCity = GetClosestCityOnValidOcean(playerID, iPlot);
		if hCity then
			local fiExtra =  GetExtraFishFoodFromCity(hCity, playerID);
			local foodBonus = gT.Players[playerID].FoodFromFish + fiExtra;
			if IsHasLaw(playerID, 19, 1) or IsHasLaw(playerID, 19, 2) or IsHasLaw(playerID, 19, 3) or IsHasLaw(playerID, 19, 4) then
				foodBonus = foodBonus - 2;
			end
			local sFf = 0;
			if not Players[playerID]:IsMinorCiv() then
				for building, vvv in pairs(tSettlerFromFishin) do
					if hCity:IsHasBuilding(building) then
						sFf = sFf + (hCity:GetNumRealBuilding(building) + hCity:GetNumFreeBuilding(building)) * vvv;
					end
				end
				if IsHasLaw(playerID, 19, 2) then
					sFf = sFf + 1;
				end
				if sFf > 0 then
					ChangeITGSettlerPoints(playerID, sFf)
				end
			end
			local cID = hCity:Plot():GetPlotIndex() .. "," .. hCity:GetGameTurnFounded();
			local goldBonus = math.min(gT.Cities[cID].FishFoodReduction, foodBonus) + GetExtraGoldFromFishing(hCity, playerID);
			foodBonus = math.max(0, foodBonus - gT.Cities[cID].FishFoodReduction);
			if foodBonus > 0 then
				DoAddFoodFromFishing(playerID, cID, hCity, foodBonus)
				gT.Cities[cID].FishFoodReduction = gT.Cities[cID].FishFoodReduction + 2;
			end				
			ChangeITGGold(playerID, goldBonus)
			gT.Cities[cID].FishFoodTotal = gT.Cities[cID].FishFoodTotal + foodBonus;
			local faithBonus = 0;
			if IsBeliefPresentInACity(hCity, pantheon14) then
				faithBonus = 3;
				ChangeITGFaith(playerID, faithBonus)
			end
			local workratepoints, cargopoints = 0, 0;
			if IsHasLaw(playerID, 19, 3) then
				cargopoints = cargopoints + 2;
				gT.Cities[cID].CargoProgress = (gT.Cities[cID].CargoProgress or 0) + 2;
			elseif IsHasLaw(playerID, 19, 4) then
				workratepoints = workratepoints + 7;
				ChangeITGWorkRate(hCity, 7)
			end
			if playerID == Game.GetActivePlayer() then
				if foodBonus > 0 then
					AddFloatingText(playerID, x, y, "+" .. foodBonus .. "[ICON_FOOD]", nil, "Fish")
				end
				if sFf > 0 then
					AddFloatingText(playerID, x, y, "+" .. sFf .. "[ICON_ITG_SETTLER]", nil, "Fish")
				end
				if workratepoints > 0 then
					AddFloatingText(playerID, x, y, "+" .. workratepoints .. "[ICON_WORKER]", nil, "Fish")
				end
				if cargopoints > 0 then
					AddFloatingText(playerID, x, y, "+" .. cargopoints .. "[ICON_CARGO]", nil, "Fish")
				end
				if goldBonus > 0 then
					AddFloatingText(playerID, x, y, "+" .. goldBonus .. "[ICON_GOLD]", nil, "Fish")
				end
				if faithBonus > 0 then
					AddFloatingText(playerID, x, y, "+" .. faithBonus .. "[ICON_PEACE]", nil, "Fish")
				end
			--	Events.SerialEventCityInfoDirty()
				Events.SpecificCityInfoDirty(playerID, hCity:GetID(), CityUpdateTypes.CITY_UPDATE_TYPE_BANNER)
			end
		else
			local goldBonus = gT.Players[playerID].FoodFromFish
			ChangeITGGold(playerID, goldBonus)
			if playerID == Game.GetActivePlayer() then
				AddFloatingText(playerID, x, y, "+" .. goldBonus .. "[ICON_GOLD]", nil, "Fish")
			end
		end
	elseif improvementID == bArtifacts then
		DoFinishArchaeologicalDig(playerID, x, y)
	end
end
GameEvents.BuildFinished.Add(OnBuildFinished)

function GetExtraGoldFromFishing(iCity, iPlayer)
	local xtra = 0;
	if gT.Players[iPlayer].CultBonusOn[123] then
		xtra = xtra + 5;
	end
	if IsHasLaw(iPlayer, 19, 1) then
		xtra = xtra + 4;
	end
	return xtra;
end

function GetExtraFishFoodFromCity(iCity, iPlayer)
	local xtra = 0;
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	for building, vvv in pairs(tFoodFromFishin) do
		if iCity:IsHasBuilding(building) then
			xtra = xtra + (iCity:GetNumRealBuilding(building) + iCity:GetNumFreeBuilding(building)) * vvv;
		end
	end
	xtra = xtra + 2 * GetNumCityAcademiesWithAbility(iCity, 11) + GetITGCityInteger(iCity, "CI_MANU_FISH")
	xtra = xtra + gT.Players[iPlayer].ExtraFoodFromFish;
	return xtra;
end

function GetClosestCityOnValidOcean(playerID, iPlot)
	local oceanID = GetOceanID(iPlot)
	local mindis, hCity = 999,nil;
	for iCity in Players[playerID]:Cities() do
		if IsCoastOfOceanOrOcean(iCity:Plot(), oceanID) then
			if not iCity:IsBlockaded() then
				local dis = Map.PlotDistance(iCity:GetX(), iCity:GetY(), iPlot:GetX(), iPlot:GetY())
				if dis < mindis then
					mindis = dis;
					hCity = iCity;
				end
			end
		end
	end
	return hCity;
end

function GetNumValidWorkPlot(playerID)
	local amount = 0;
	for iPlotIndex, type in pairs(gT.Players[playerID].WorkerQuestConstructionSites) do
		local iPlot = Map.GetPlotByIndex(iPlotIndex);
		if IsValidToWork(iPlot, playerID) then
			amount = amount + 1;
		end
	end
	return amount;
end

function GetNextValidWorkPlot(playerID)
	for iPlotIndex, type in pairs(gT.Players[playerID].WorkerQuestConstructionSites) do
		local iPlot = Map.GetPlotByIndex(iPlotIndex);
		if IsValidToWork(iPlot, playerID) then
			return iPlot, type;
		end
	end
	return nil;
end

function RemoveOceanTabPrepareForNextEra()
	hOceanTab = nil;
end

function PrepareValidOceanFishMigration()
	if not hOceanTab then
		hOceanTab = {}
		local tOceans = RequestOceans();
		for iT, data in pairs(tOceans) do
			hOceanTab[iT] = RevertIntoIntegerTable(tOceans[iT])
			if #hOceanTab[iT] >= 25 then
				gT.ValidOceanFish[iT] = true;
			end
		end
	end
end

function AnnualFishMigration()
	local htEco = {}
	for g, h in pairs(gT.Players) do
		if HasPlayerTech(g, GameInfoTypes.TECH_ECOLOGY, "56324") then
			htEco[g] = Players[g]:GetTeam();
		end
	end
	for i, iPlotIndex in pairs(gT.Globals.WaterResources) do
		local iPlot = Map.GetPlotByIndex(iPlotIndex)
		if htEco[iPlot:GetOwner()] and (iPlot:GetResourceType(htEco[iPlot:GetOwner()]) == rFish or iPlot:GetResourceType(htEco[iPlot:GetOwner()]) == rExtraFish) and iPlot:IsPlayerCityRadius(iPlot:GetOwner()) then 
			iPlot:SetImprovementType(GameInfoTypes.IMPROVEMENT_NEW_ITG_FISHING_BOATS, -1)
		else
			iPlot:SetResourceType(-1)
		end
	end
	if not hOceanTab then
		hOceanTab = {}
		local tOceans = RequestOceans();
		for iT, data in pairs(tOceans) do
			hOceanTab[iT] = RevertIntoIntegerTable(tOceans[iT])
		end
	end
	gT.Globals.WaterResources = {};
	for it, data in pairs(hOceanTab) do
		if gT.ValidOceanFish[it] then
			local numFishes = math.ceil(#data / LastRandom(19, 25));
			local numWhales = math.floor(#data / LastRandom(25, 40));
			local numExtraFish = math.ceil((numFishes+numWhales) * 0.25);
			local hTab = data;
			hTab = Shuffle(hTab);
			for i = 1, numFishes + numWhales + numExtraFish do
				local iPlot = Map.GetPlotByIndex(hTab[i])
				if iPlot:GetResourceType() == -1 then
					if iPlot:GetFeatureType() == -1 then
						if i > numFishes then
							if i > numFishes + numWhales then
								iPlot:SetResourceType(rExtraFish);
							else
								iPlot:SetResourceType(rWhale)
							end
						else
							iPlot:SetResourceType(rFish)
						end
						table.insert(gT.Globals.WaterResources, hTab[i])
					end
				end
			end
		end
	end
end

function DoAddFoodFromFishing(iPlayer, cID, hCity, foodBonus)
	local duration = GetDurationOfFishFood(iPlayer, cID, hCity)
	local basemod = math.floor(foodBonus / duration)
	local secondarymodduration = foodBonus - basemod * duration;
	if basemod > 0 then
		AddFoodFishInTime(cID, hCity, basemod, duration)
	end
	if secondarymodduration > 0 then
		AddFoodFishInTime(cID, hCity, 1, secondarymodduration)
	end
end

function GetDurationOfFishFood(iPlayer, cID, hCity)
	return 5;
end

function AddFoodFishInTime(cID, iCity, amount, duration)
	gT.Cities[cID].FishTotalT = gT.Cities[cID].FishTotalT + amount * duration;
	gT.Cities[cID].FishNextT = gT.Cities[cID].FishNextT + amount;
	iCity:ChangeBaseYieldRateFromBuildings(yFood, amount)
	if gT.Players[iCity:GetOwner()].CultBonusOn[64] then
		local pff = math.ceil(gT.Cities[cID].FishNextT * FISH_INDUSTRY_PERCENT)
		if gT.Cities[cID].FishProd ~= pff then
			iCity:ChangeBaseYieldRateFromBuildings(yProduction, pff - gT.Cities[cID].FishProd)
			gT.Cities[cID].FishProd = pff;
		end
	end
	table.insert(gT.Cities[cID].FishInTime, {amount, GetITGGameTurn() + duration})
end

function DoClearFishOnConquest(cID)
	gT.Cities[cID].FishTotalT = 0;
	gT.Cities[cID].FishNextT = 0;
	gT.Cities[cID].FishProd = 0;
	gT.Cities[cID].FishInTime = {}
	gT.Cities[cID].TRProdT = 0;
	gT.Cities[cID].TRProdNext = 0;
	gT.Cities[cID].ProdTRInTime = {}
	gT.Cities[cID].TRFoodNext = 0;
	gT.Cities[cID].TRFoodT = 0;
	gT.Cities[cID].FoodTRInTime = {}
end

function DoReductionOfFishInTime(cID, iCity, tTurn)
	local totred = 0;
	local nextred = 0;
	local tRem = {}
	for i, v in pairs(gT.Cities[cID].FishInTime) do
		totred = totred + v[1];
		if v[2] <= tTurn then
			nextred = nextred + v[1]
			table.insert(tRem, i)
		end
	end
	gT.Cities[cID].FishTotalT = gT.Cities[cID].FishTotalT - totred;
	if nextred ~= 0 then
		gT.Cities[cID].FishNextT = gT.Cities[cID].FishNextT - nextred;
		iCity:ChangeBaseYieldRateFromBuildings(yFood, - nextred)
		if gT.Players[iCity:GetOwner()].CultBonusOn[64] then
			local pff = math.ceil(gT.Cities[cID].FishNextT * FISH_INDUSTRY_PERCENT)
			if gT.Cities[cID].FishProd ~= pff then
				iCity:ChangeBaseYieldRateFromBuildings(yProduction, pff - gT.Cities[cID].FishProd)
				gT.Cities[cID].FishProd = pff;
			end
		end
	end
	for i = 1, #tRem do
		table.remove(gT.Cities[cID].FishInTime, tRem[#tRem + 1 - i])
	end
end

--hook works just after the annual growth (temporary food bonuses should expire on it)
GameEvents.CityMadeGrowth.Add(function(iPlayer, cityID)
	local iCity = Players[iPlayer]:GetCityByID(cityID);
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local gTurn = GetITGGameTurn();
	DoReductionOfFishInTime(cID, iCity, gTurn)
	DoReductionOfYieldFromTR(cID, iCity, gTurn, "FoodTRInTime", "TRFoodNext", "TRFoodT", yFood)
	DoReductionOfYieldFromTR(cID, iCity, gTurn, "ProdTRInTime", "TRProdNext", "TRProdT", yProduction)
end)

function AddFoodTRInTime(cID, iCity, amount, duration)
	gT.Cities[cID].TRFoodT = gT.Cities[cID].TRFoodT + amount * duration;
	gT.Cities[cID].TRFoodNext = gT.Cities[cID].TRFoodNext + amount;
	iCity:ChangeBaseYieldRateFromBuildings(yFood, amount)
	table.insert(gT.Cities[cID].FoodTRInTime, {amount, GetITGGameTurn() + duration})
end

function AddProdTRInTime(cID, iCity, amount, duration)
	gT.Cities[cID].TRProdT = gT.Cities[cID].TRProdT + amount * duration;
	gT.Cities[cID].TRProdNext = gT.Cities[cID].TRProdNext + amount;
	iCity:ChangeBaseYieldRateFromBuildings(yProduction, amount)
	table.insert(gT.Cities[cID].ProdTRInTime, {amount, GetITGGameTurn() + duration})
end

function DoReductionOfYieldFromTR(cID, iCity, tTurn, intimestr, nextstr, totalstr, yield)
	local totred = 0;
	local nextred = 0;
	local tRem = {}
	for i, v in pairs(gT.Cities[cID][intimestr]) do
		totred = totred + v[1];
		if v[2] <= tTurn then
			nextred = nextred + v[1]
			table.insert(tRem, i)
		end
	end
	gT.Cities[cID][totalstr] = gT.Cities[cID][totalstr] - totred;
	if nextred ~= 0 then
		gT.Cities[cID][nextstr] = gT.Cities[cID][nextstr] - nextred;
		iCity:ChangeBaseYieldRateFromBuildings(yield, -nextred)
	end
	for i = 1, #tRem do
		table.remove(gT.Cities[cID][intimestr], tRem[#tRem + 1 - i])
	end
end