local WonderPreCheck = false;
local bInquisition = GameInfoTypes.BUILDING_ITG_NEW_WORLD_INQUISITION;
local IsSettlerType = {[GameInfoTypes.UNIT_ITG_SETTLER_POINTS] = 1, [GameInfoTypes.UNIT_ITG_SETTLER_POINTS_ANCIENT] = 1}
local dWonderProcess = GameInfoTypes.PROCESS_ITG_WONDER;
local pKronborg = GameInfoTypes.PROCESS_ITG_KRONBORG_FORT_PROCESS;
local pInnovation = GameInfoTypes.PROCESS_LS_PROJECT_INNOVATION;
local pShinobi = GameInfoTypes.PROCESS_ITG_SHINOBI_PROCESS
local pReligiousBelief = GameInfoTypes.PROCESS_ITG_TEMPLAR_PROJECT;
local bChateau = GameInfoTypes.BUILDING_ITG_LS_CHATEAU;
local IsForNavalAIBlock = {}
local tradeProcess = GameInfoTypes.PROCESS_ITG_TRADE;
local leagueprojects = {
[GameInfoTypes.PROCESS_LS_CRUSADE_PROJECT] = 16,
[GameInfoTypes.PROCESS_LS_PROJECT_LEAGUE_38] = 38,
[GameInfoTypes.PROCESS_LS_PROJECT_LEAGUE_39] = 39,
[GameInfoTypes.PROCESS_LS_PROJECT_LEAGUE_40] = 40,
}
function GetProcessOutOfResolution(resID)
	for ibuilding, res in pairs(leagueprojects) do
		if res == resID then
			return ibuilding;
		end
	end
	return nil;
end
function GetLeagueResOutOfProcess(iProcess)
	return leagueprojects[iProcess];
end
local supportUnusedUnits = {
[GameInfoTypes.UNIT_ITG_BATTERING_RAM_SUPPORT] = "BatteringSupport",
[GameInfoTypes.UNIT_ITG_SIEGE_TOWER_SUPPORT] = "SiegeTowerSupport",
}
local cClassLighthouse = GameInfoTypes.BUILDINGCLASS_LIGHTHOUSE;
local cClassSeaport = GameInfoTypes.BUILDINGCLASS_SEAPORT;
local cClassHarbor = GameInfoTypes.BUILDINGCLASS_HARBOR;
local pKronborgWonderC = GameInfoTypes.BUILDING_ITG_NEW_WORLD_WONDER_12;
local uWorkboat = GameInfoTypes.UNIT_WORKBOAT;
local cWorkBoatClass = GameInfoTypes.UNITCLASS_WORKBOAT;
local cArchae = GameInfoTypes.UNIT_ITG_ARCHAEOLOGIST
local cArchaeClass = GameInfoTypes.UNITCLASS_ARCHAEOLOGIST
local techAllWP = GameInfoTypes.TECH_ITG_WATER_ALL_PASSAGE;
local cGuidedMissile = GameInfoTypes.UNIT_ITG_GUIDED_MISSILES
local IsDefensiveBuilding = {}
local IsWonderBuilding = {}
local IsCityStateProcess = {}
local unitClassFromTypeT = {}
local palaceExpandT = {}
local IsCivilianPanicUnit = {}
local CivilianClassesPanic = {["UNITCLASS_SCOUT"] = true, ["UNITCLASS_WORKBOAT"] = true, ["UNITCLASS_ARCHAEOLOGIST"] = true, ["UNITCLASS_ITG_SETTLER_POINTS"] = true}
for row in GameInfo.Units() do
	unitClassFromTypeT[row.ID] = GameInfoTypes[row.Class]
	if CivilianClassesPanic[row.Class] then
		IsCivilianPanicUnit[row.ID] = true;
	end
	if row.Domain == "DOMAIN_SEA" then
		IsForNavalAIBlock[row.ID] = true;
	end
end
for i = 1, 100 do
	if GameInfoTypes["PROCESS_ITG_CITY_STATE_PROCESS_" .. i] then
		IsCityStateProcess[GameInfoTypes["PROCESS_ITG_CITY_STATE_PROCESS_" .. i]] = true;
	else
		break;
	end
end
local ValidNationalWonders = {
["BUILDINGCLASS_NATIONAL_TREASURY"] = 1,
["BUILDINGCLASS_CIRCUS_MAXIMUS"] = 1,
["BUILDINGCLASS_NATIONAL_COLLEGE"] = 1,
["BUILDINGCLASS_ITG_GUILDS_NW_WRITER"] = 1,
["BUILDINGCLASS_ITG_GUILDS_NW_MUSICIAN"] = 1,
["BUILDINGCLASS_ITG_GUILDS_NW_ARTIST"] = 1,
}
local ExtraCheckForReligionWonder = {}
for row in GameInfo.Buildings() do
	if row.WonderRequireReligion then
		ExtraCheckForReligionWonder[row.ID] = true;
	end
	if row.BuildingClass == "BUILDINGCLASS_ITG_LS_PALACE_UPGRADE" then
		palaceExpandT[row.ID] = 1;
	end
	if row.WonderEra ~= 0 then
		IsWonderBuilding[row.ID] = 1;
	else
		if not ValidNationalWonders[row.BuildingClass] then
			if GameInfo.BuildingClasses[row.BuildingClass].MaxGlobalInstances == 1 or (GameInfo.BuildingClasses[row.BuildingClass].MaxPlayerInstances == 1) then
				IsWonderBuilding[row.ID] = 1;
			end
		end
		if row.Defense > 0 then
			IsDefensiveBuilding[row.ID] = 1;
		end
	end
end

function ITGSC_CanConstructBuilding(iPlayer, iCityID, iBuilding)
	local iCity = Players[iPlayer]:GetCityByID(iCityID);
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local bIgnorePanic = false;
	if IsWonder(iBuilding) then
		bIgnorePanic = true;
		if not WonderPreCheck then
			if gT.Globals.WondersAssigned[iBuilding] ~= iPlayer then
				return false;
			end
		end
	end
	if IsDefensiveBuilding[iBuilding] then
		bIgnorePanic = true;
		if IsCityThreatened(iCity, iPlayer) then
			return false;
		end
	end
	if gT.Players[iPlayer].AIPanicScript and (not bIgnorePanic) then
		return false; -- ai will only construct units
	end
	if palaceExpandT[iBuilding] then
		if gT.Players[iPlayer].Goverment == 1 then
			return false;
		end
		if gT.Cities[cID].Palace then
			if gT.Cities[cID].PalaceUpgrades + gT.Cities[cID].Palace.NumUpgrades >= 10 then
				return false;
			end
		end
		if gT.Players[iPlayer].AIPalaceBlock then --pure AI block
			if (gT.Players[iPlayer].AIPalaceBlock == 2) or (not iCity:IsCapital()) then
				if iCity:GetProductionBuilding() ~= iBuilding then
					return false;
				end
			end
		end
	elseif bInquisition == iBuilding then
		if not gT.Players[iPlayer].OfficialReligion then
			return false;
		elseif not Players[iPlayer]:IsHuman() then
			if gT.Cities[cID].InqOfficeBlock then
				return false;
			end
		end
	elseif bChateau == iBuilding then
		if gT.Cities[cID].Palace then
			if gT.Cities[cID].PalaceUpgrades + gT.Cities[cID].Palace.NumUpgrades >= 10 then
				if not Players[iPlayer]:IsHuman() then
					if iCity:GetProductionBuilding() ~= iBuilding then
						if gT.Players[iPlayer].ChateauCharges > 0 then
							return false;
						end
					end
				end
			else
				return false;
			end
		else
			return false;
		end
	end
	return true;
end
GameEvents.CityCanConstruct.Add(ITGSC_CanConstructBuilding)

function IsFullyControlled(iCity, iPlayer)
	if IsCityThreatened(iCity, iPlayer, true) then
		return false;
	end
	if iCity:IsResistance() then
		return false;
	end
	return true;
end

function IsCityThreatened(iCity, iPlayer, bIgnore)
	if not bIgnore then
		if gT.Players[iPlayer].CultBonusOn[3] then
			return false;
		end
	end	
	if iCity:GetDamage() > 0 then
		return true;
	end
	if iCity:CanRangeStrikeNow() then
		return true;
	end
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	if gT.Cities[cID].LastRangedStrike == GetITGGameTurn() then
		return true;
	end
	local iTeam = Players[iPlayer]:GetTeam();
	for i = 0,5 do
		local iPlot = Map.PlotDirection(iCity:GetX(), iCity:GetY(), i);
		if iPlot then
			if iPlot:IsVisibleEnemyUnit(iTeam) then
				for j = 0, iPlot:GetNumUnits() -1 do
					local bUnit = iPlot:GetUnit(j);
					if bUnit:IsEnemyCityAdjacent() then
						if IsCombatClassITGUnit(bUnit:GetUnitClassType(), bUnit:GetOwner()) then
							return true;
						end
					end
				end
			end
		end
	end
	return false
end

function IsCityRecentlyAcquired(iCity, iPlayer)
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	return	gT.Cities[cID].LastAcquired >= GetRealGameTurn() - 5;
end

function ITGSC_CanPurchaseItem(iPlayer, iCityID, unittype, buildingtype)
	local iCity = Players[iPlayer]:GetCityByID(iCityID);
--	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	if IsCityThreatened(iCity, iPlayer) then
		return false;
	end
	if IsCityRecentlyAcquired(iCity, iPlayer) then
		return false;
	end
	return true;
end
GameEvents.CityCanPurchase.Add(ITGSC_CanPurchaseItem)

function IsWonder(iBuilding)
	if IsWonderBuilding[iBuilding] then
		return true;
	end
	return false;
end

function CheckIfCityCanBuildWonder(iCity, wonderID) 
	WonderPreCheck = true;
	local canb = iCity:CanConstruct(wonderID) 
	WonderPreCheck = false;
	if gT.Globals.GameGenerated or (not gT.EraData) or (not gT.PreviousEra) then
		if ExtraCheckForReligionWonder[wonderID] then
			if Players[iCity:GetOwner()]:GetReligionCreatedByPlayer() < 1 then
				return false
			end
		end
	end
	return canb;
end

function OtherCityTrain(playerID, iCityID, iType)
	local ccount = 0;
	for iCity in Players[playerID]:Cities() do
		if iCity:GetID() ~= iCityID then
			if iCity:GetProductionUnit() == iType then
				ccount = ccount + 1;
			end
		end
	end
	return ccount;
end

function GetAmountOfValidMissionsForWorker(playerID)
	local towork = 0;
	for iPlotIndex, type in pairs(gT.Players[playerID].WorkerQuestConstructionSites) do
		if IsValidToWork(Map.GetPlotByIndex(iPlotIndex), playerID) then
			towork = towork + 1;
		end
	end
	for iplotindex, itype in pairs(gT.Players[playerID].Improvements) do
		if Map.GetPlotByIndex(iplotindex):IsImprovementPillaged() then
			if IsValidToWork(Map.GetPlotByIndex(iplotindex), playerID) then
				towork = towork + 1;
			end
		end
	end
	return towork;
end

function GetSupportedFishingBoats(playerID)
	local num = Players[playerID]:GetNumAllowedWorkboats() + gT.Players[playerID].ExtraWorkboats
	if Players[playerID]:IsMinorCiv() then
		return math.min(1, num)
	end
	return num;
end

function GetFishSupTextForTP(iPlayer)
	local text = "Total amount of Work Boats you can own."
	local hTab = {};
	table.insert(hTab, {Players[iPlayer]:GetNumAllowedWorkboats(), "Buildings"})
	table.insert(hTab, {gT.Players[iPlayer].ExtraWorkboats, "extra Sources"})
	for i, v in pairs(hTab) do
		if v[1] ~= 0 then
			text = text .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]" .. v[1] .. "[ENDCOLOR] from " .. v[2] .. ".";
		end
	end
	return text;
end

function ITGSC_CanTrainUnit(playerID, iCityID, iType)
	if supportUnusedUnits[iType] then
		if not Players[playerID]:IsHuman() then
			if gT.Players[playerID][supportUnusedUnits[iType]] > 0 then
				local iCity = Players[playerID]:GetCityByID(iCityID);
				if iCity:GetProductionUnit() ~= iType then
					return false;
				end
			end
		end
	end
	if gT.Players[playerID].AIPanicScript then
		if IsCivilianPanicUnit[iType] then
			return false;
		end
	end
	if iType == uWorkboat then
		local iCity = Players[playerID]:GetCityByID(iCityID);
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		if gT.Cities[cID].AIWorkBoatTrainBlock then
			return false;
		end
		if not gT.Cities[cID].CanDoWorkboats then
			return false;
		end
		local numMax = GetSupportedFishingBoats(playerID)
		local numUsed = Players[playerID]:GetUnitClassCountPlusMaking(cWorkBoatClass)
		local iCity = Players[playerID]:GetCityByID(iCityID);
		if iCity:GetProductionUnit() == iType then
			numUsed = numUsed - 1;
		end
		if numUsed >= numMax then
			return false;
		end
	elseif IsSettlerType[iType] then
		if not Players[playerID]:IsHuman() then
			if gT.Players[playerID].AISettlerPointsManagement then
				if gT.Players[playerID].AISettlerPointsManagement.Type ~= 1 then
					if gT.Players[playerID].AISettlerPointsManagement.Type ~= 5 then
						return false;
					elseif (gT.Players[playerID].AISettlerFoundDiscount or 0) > 40 then
						if Players[playerID]:GetCityByID(iCityID):GetProductionUnit() ~= iType then
							return false;
						end
					end
				end
			end
		end
	else
		if IsForNavalAIBlock[iType] then -- here because it should ignore workboats
			if not Players[playerID]:IsHuman() then
				local iCity = Players[playerID]:GetCityByID(iCityID);
				local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
				if gT.Cities[cID].AINavalTrainBlock then
					return false;
				end
			end
		end
		if iType == cArchae then
			local numUsed = Players[playerID]:GetUnitClassCountPlusMaking(cArchaeClass)
			local iCity = Players[playerID]:GetCityByID(iCityID);
			if iCity:GetProductionUnit() == iType then
				numUsed = numUsed - 1;
			end
			if numUsed >= gT.Players[playerID].ArchaeologistNum then
				return false;
			end
		elseif iType == cGuidedMissile then
			if not Players[playerID]:IsHuman() then
				if gT.Players[playerID].BlockMissilesT then
					if Players[playerID]:GetCityByID(iCityID):GetProductionUnit() ~= iType then
						return false;
					end
				end
			end
		end
	end
	if gT.Players[playerID].ObsoleteUnitClasses[unitClassFromTypeT[iType]] then
		return false;
	end
	return true;
end
GameEvents.CityCanTrain.Add(ITGSC_CanTrainUnit)

function ITGSC_CanMaintainProcess(iPlayer, cityID, process)
	if gT.Players[iPlayer].AIPanicScript then
		return false;
	end
	if process == dWonderProcess then
		if not gT.Players[iPlayer].CanWonderRace then
			return false;
		end
		if gT.Players[iPlayer].AIWonderBlock then
			return false;
		end
	elseif process == pShinobi then
		if gT.Players[iPlayer].ShinobiCooldown > GetRealGameTurn() then
			return false;
		end
	elseif pKronborg == process then
		if not gT.Players[iPlayer].HasPlayerWonder[pKronborgWonderC] then
			return false;
		end
		if gT.Players[iPlayer].KronborgCooldown >= GetRealGameTurn() then
			return false;
		end
	elseif pInnovation == process then
		if not gT.Players[iPlayer].GovRewards[23] then
			return false;
		end
		if gT.Players[iPlayer].GovSlots[gT.Players[iPlayer].GovRewards[23]].Used then
			return false;
		end
	elseif IsCityStateProcess[process] then
		local canProceed = false;
		if gT.Globals.CityStateBuildingProcesses[process] then
			local cs = gT.Globals.CityStateBuildingProcesses[process];
			if not Teams[Players[iPlayer]:GetTeam()]:IsAtWar(Players[cs]:GetTeam()) then
				for i, sth in pairs(gT.Players[cs].CityStateQuests) do
					if sth.Active then
						if sth.ActivePlayers[iPlayer] then
							if Players[iPlayer]:IsHuman() then
								canProceed = true;
							else
								if not gT.Players[iPlayer].AILogicForCSProductionProject[process] then
									DoAILogicForCSProductionProject(cs, process, iPlayer)
								end
								--added here +25;
								if gT.Players[iPlayer].AILogicForCSProductionProject[process] + 25 > (sth.ActivePlayers[iPlayer].ProjectDonated or 0) then
									canProceed = true;
								end
							end
						end
					end
				end
			end
		end
		if not canProceed then
			return false;
		end
	elseif process == pReligiousBelief then
		if Players[iPlayer]:IsMinorCiv() then
			return false;
		end
		if not gT.TemplarBonus[Players[iPlayer]:GetCityByID(cityID):GetReligiousMajority()] then
			return false;
		end
	elseif leagueprojects[process] then
		if not gT.Players[iPlayer].LeagueProjects[leagueprojects[process]] then
			return false;
		end
	elseif tradeProcess == process then
		local iCity = Players[iPlayer]:GetCityByID(cityID)
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		if GetTradeProcessDivider(iCity, cID, iPlayer) <= 0 then
			return false;
		end
	end
	return true;
end
GameEvents.CityCanMaintain.Add(ITGSC_CanMaintainProcess)

function IsNotTrainingMilitaryunit(iCity)
	local th = iCity:GetProductionUnit()
	if th ~= -1 then
		if gT.Players[iCity:GetOwner()].UnitClassPromotions[unitClassFromTypeT[th]] then
			return false;
		end
		if IsCombatUnitWithNoXP(th) then
			return false;
		end
	end
	return true;
end

function AIConstructTrainHelpFunction(iPlayer)
	if gT.Players[iPlayer].FishLost > 0 then
		gT.Players[iPlayer].FishLost = gT.Players[iPlayer].FishLost - 1;
	else
		if Players[iPlayer]:GetUnitClassMaking(cWorkBoatClass) == 0 then
			for iCity in Players[iPlayer]:Cities() do
				if iCity:CanTrain(uWorkboat) then
					if ThereIsASenseForWorkboatInTheCity(iCity, iPlayer) then
						if IsFreeForChangingAction(iCity) then
							iCity:PushOrder(OrderTypes.ORDER_TRAIN, uWorkboat);
						end
					end
				end
			end
		end
	end
end

local WorkboatsPerSea = {
{25, 1},
{75, 3},
{200, 6},
{500, 9},
{100000, 12}
}

function ThereIsASenseForWorkboatInTheCity(iCity, iPlayer)
	local hasOcean = Teams[Players[iPlayer]:GetTeam()]:IsHasTech(techAllWP);
	local iSize, ocean = 0, -1;
	local gPlot;
	for j = 0, 5 do
		local jPlot = Map.PlotDirection(iCity:GetX(), iCity:GetY(), j);
		if jPlot then
			if jPlot:IsWater() then
				if not jPlot:IsImpassable() then
					local aSize = GetSizeOfOcean(GetOceanID(jPlot))
					if aSize > iSize then
						gPlot = jPlot;
						iSize = aSize;
						ocean = GetOceanID(jPlot)
					end
				end
			end
		end
	end
	if iSize > 20 then
		local numval = 1;
		if hasOcean then
			for i = 1, #WorkboatsPerSea do
				if iSize < WorkboatsPerSea[i][1] then
					numval = i;
					break
				end
			end
		end
		local numalr = 0;
		for iUnit in Players[iPlayer]:Units() do
			if iUnit:GetUnitType() == uWorkboat then
				if GetOceanID(iUnit:GetPlot()) == ocean then
					numalr = numalr + 1;
				end
			end
		end
		if numval > numalr then
			return true;
		end
	end
	return false;
end

function IsFreeForChangingAction(iCity)
	if ITGCityCanWorkDoAction(iCity) then
		if iCity:GetDamage() == 0 then
			local iprocess, iunit, ibuilding = iCity:GetProductionProcess(), iCity:GetProductionUnit(), iCity:GetProductionBuilding();
			if iprocess ~= -1 then
				return true;
			elseif ibuilding ~= -1 then
				if iCity:GetBuildingProduction(ibuilding) < 2 * iCity:GetRawProductionDifference() then
					return true;
				end
			elseif iunit ~= -1 then
				if iCity:GetUnitProduction(iunit) < 2 * iCity:GetRawProductionDifference() then
					return true;
				end
			else
				return true;
			end
		end
	end
	return false;
end

