local cultureOwnershipTresholds = {40, 100, 500, 1000, 2000}
local ancInCS19 = GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_19;
local gmedwonder12 = GameInfoTypes.BUILDING_ITG_NEW_MEDIEVAL_WONDER_12
local tmesonw1 = GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_MESOAMERICAN_1;
local techNWasia4 = GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_ASIA_4;
local induwonder2 = GameInfoTypes.BUILDING_ITG_NEW_INDUSTRIAL_WONDER_2
local tinnanctr15 = GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_TRIBE_15;
local wonderindu2 = GameInfoTypes.BUILDING_ITG_NEW_INDUSTRIAL_WONDER_2
local iinoindu6 = GameInfoTypes.TECH_UNIQUE_ITG_INDUSTRIAL_6
local induwonder6 = GameInfoTypes.BUILDING_ITG_NEW_INDUSTRIAL_WONDER_6
local innoindu7 = GameInfoTypes.TECH_UNIQUE_ITG_INDUSTRIAL_7;
local wonderindu4 = GameInfoTypes.BUILDING_ITG_NEW_INDUSTRIAL_WONDER_4;

function GetCultureOwnershipTreshold()
	return cultureOwnershipTresholds;
end

function GetBaseCultureNewCity(iPlayer, iCity)
	return 10;
end

function GetCultureOwnershipLevelFromValue(value, sPlayer)
	for i = 0, #cultureOwnershipTresholds -1 do
		if value >= cultureOwnershipTresholds[#cultureOwnershipTresholds - i] then
			return #cultureOwnershipTresholds - i;
		end
	end
	return nil;
end

function DoInitialCityCulture(cID, iCity, iPlayer) -- new city found
	gT.Cities[cID].CultureStored = {}
	gT.Cities[cID].CultureStored[iPlayer] = GetBaseCultureNewCity(iPlayer, iCity) + LastRandom(0, 5)
	gT.Cities[cID].CultureLevels = {}
	DoCityCultureOwnership(iCity, cID)
end

function CultureCitiesInitialData()
	for g, h in pairs(gT.Players) do
		for iCity in Players[g]:Cities() do
			local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
			gT.Cities[cID].CultureLevels = {}
			gT.Cities[cID].CultureStored = {}
			DoInitialCultureDataOfCity(gT.Players[g].CultureType, g, iCity, cID)
			DoCityCultureOwnership(iCity, cID)
		end
	end
end

function DoCityCultureOwnership(iCity, cID)
	local tot, owner, cc = 0, 63, 0;
	for v, s in pairs(gT.Cities[cID].CultureStored) do
		tot = tot + s * (1 + (gT.Cities[cID].CultureLevels[v] or 0));
		if s >= cultureOwnershipTresholds[1] then
			if s > cc then
				owner = v;
				cc = s;
			elseif s == cc then
				owner = 63;
			end
		end
	end
	gT.Cities[cID].CultureOwner = owner;
	iCity:SetCultureOwner(owner);
	if owner ~= 63 then
		gT.Cities[cID].CulturePercentageOwnership = math.floor(1000 * cc * (1 + (gT.Cities[cID].CultureLevels[owner] or 0)) / tot) / 10
	end
end

function DoInitialCultureDataOfCity(cType, gPlayer, iCity, cID)
--here is initial for industrial
	local bCapital = iCity:IsCapital()
	local cOwn = LastRandom(GetDBCulturePlayerInfo(gPlayer, "MinInitPresence"), GetDBCulturePlayerInfo(gPlayer, "MaxInitPresence"))
	if bCapital then
		cOwn = cOwn * 1.25;
	end
	gT.Cities[cID].CultureStored[gPlayer] = cOwn;
	for h, sIndex in pairs(GetNearCities(cID, 10)) do
		local sCity = Map.GetPlotByIndex(sIndex):GetPlotCity();
		local sOwner = sCity:GetOwner();
		local sAdd = math.max(0, LastRandom(-30, 15))
		if sAdd > 0 then
			gT.Cities[cID].CultureStored[sOwner] = sAdd + (gT.Cities[cID].CultureStored[sOwner] or 0);
		end
	end
	local iOriginPlayer = iCity:GetOriginalOwner();
	if gPlayer ~= iOriginPlayer then
		gT.Cities[cID].CultureStored[iOriginPlayer] = (gT.Cities[cID].CultureStored[iOriginPlayer] or 0) + math.floor(LastRandom(75, 150) * gT.Cities[cID].CultureStored[gPlayer] / 100)
		gT.Cities[cID].CultureStored[gPlayer] = math.floor(LastRandom(50, 100) * gT.Cities[cID].CultureStored[gPlayer] / 100)
	end
	if gT.Globals.ScenarioType == 4 then
		for g, h in pairs(gT.Players) do
			if not Players[g]:IsMinorCiv() then
				if g ~= gPlayer then
					local cLuck = LastRandom(1, 100);
					if cLuck <= 4 then
						gT.Cities[cID].CultureStored[g] = LastRandom(200, 350)
					elseif cLuck <= 16 then
						gT.Cities[cID].CultureStored[g] = LastRandom(85, 150)
					elseif cLuck <= 36 then
						gT.Cities[cID].CultureStored[g] = LastRandom(15, 70)
					end
				end
			end
		end
	elseif gT.Globals.ScenarioType == 5 then
		for g, h in pairs(gT.Players) do
			if not Players[g]:IsMinorCiv() then
				if g ~= gPlayer then
					if LastRandom(1,10) == 5 then
						if LastRandom(1, 2) == 2 then
							gT.Cities[cID].CultureStored[g] = LastRandom(200, 350)
						else
							gT.Cities[cID].CultureStored[g] = LastRandom(50, 150)
						end
					end
				end
			end
		end
	end
	for s, v in pairs(gT.Cities[cID].CultureStored) do
		gT.Cities[cID].CultureLevels[s] = GetCultureOwnershipLevelFromValue(v, s)
	end
end

function TheCultureIndicatorTurn(iPlayer, bMajor)
	DoUpdateCitiesCultureOwnership(iPlayer)
	DirtyCulturePresAnchorFromCities(iPlayer)
	if not bMajor then
		return;
	end
	gT.Players[iPlayer].NatUnity = GetThisTurnCultureIndicator(iPlayer)
	if gT.Players[iPlayer].NatUnity < NAT_UNITY_PENALTY_FREE  then
		if gT.Players[iPlayer].NatUnity == 0 then
			if Players[iPlayer]:IsHuman() then
				LuaEvents.ITG_AchievementCompleted(54)
			end
		end
		if LastRandom(1, 100) <= math.ceil((NAT_UNITY_PENALTY_FREE - gT.Players[iPlayer].NatUnity) / 2) then
			AddToMoraleQueueLog(iPlayer, -1, "Cultural tensions")
		end
	end
end

function DoUpdateCitiesCultureOwnership(iPlayer)
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		DoCityCultureChanges(iCity, cID, iPlayer)
		DoCityCultureOwnership(iCity, cID)
	end
end

function GetCultureFromGreatWorks(iPlayer)
	local b = gT.Players[iPlayer].CulturePerGW * gT.Players[iPlayer].NumGreatWorks;
	return b;
end

function GetGoodCultureFromGW(iPlayer)
	return gT.Players[iPlayer].NumGreatWorks * gT.Players[iPlayer].GWCultureIntoNU;
end

function GetGoodCultureFromCityStates(iPlayer)
	local bm = Players[iPlayer]:GetJONSCulturePerTurnFromMinorCivs();
	if bm > 0 then
		local pG, pT = 0, 0;
		for g, gda in pairs(gT.Players) do
			if Players[g]:IsMinorCiv() then
				if Players[g]:IsAlive() then
					if Players[g]:GetMinorCivFriendshipLevelWithMajor(iPlayer) == 1 then
						pT = pT + 1;
						if gda.CultureType == gT.Players[iPlayer].CultureType then
							pG = pG + 1;
						end
					elseif Players[g]:GetMinorCivFriendshipLevelWithMajor(iPlayer) == 2 then
						pT = pT + 2;
						if gda.CultureType == gT.Players[iPlayer].CultureType then
							pG = pG + 2;
						end
					end
				end
			end
		end
		return math.floor(bm*pG/pT)
	end
	return 0;
end

function GetTabOfNatUnitySources(iPlayer, bTop)
	local tab = {};
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		local gGc, gBc = GetGoodAndBadCulture(iCity, cID, iPlayer)
		if gGc > 0 or gBc > 0 then
			table.insert(tab, {gGc, OccStringNatUnity(iCity) .. iCity:GetName(), gBc})
		end
	end
	table.insert(tab, {GetGoodCultureFromCityStates(iPlayer), "City-States", 0})
	table.insert(tab, {GetGoodCultureFromGW(iPlayer), "Great Works", 0})
	table.insert(tab, GetCultINDFromAcademies(iPlayer))
	table.insert(tab, GetCultINDFromNationalDay(iPlayer))
	table.insert(tab, GetCultINDFromArtStyle(iPlayer))
	table.insert(tab, GetCultINDFromGreatPeople(iPlayer))
	table.insert(tab, GetCultINDFromInnovations(iPlayer))
	table.insert(tab, GetCultINDFromSocialDevs(iPlayer))
	table.insert(tab, GetCultINDFromMtFuji(iPlayer))
	table.insert(tab, GetCultINDFromCS(iPlayer))
	table.insert(tab, GetCultINDFromOneWithNature(iPlayer))
	table.insert(tab, GetCultINDfromMemorial(iPlayer))
	table.insert(tab, GetCultINDFromPhotography(iPlayer))
	table.insert(tab, GetCultINDFromOperas(iPlayer))
	table.insert(tab, GetCultINDFromManufactories(iPlayer))
	table.insert(tab, CultureIndicatorFromWonders(iPlayer))
	table.insert(tab, GetCultINDFromPrinciple(iPlayer))
	table.insert(tab, GetCultINDFromEquality(iPlayer))
	table.insert(tab, GetCultINDFromCodex(iPlayer))
	table.insert(tab, GetCultINDFromIdeology(iPlayer))
	table.insert(tab, GetCultINDFromReligiousUnit(iPlayer))
	table.insert(tab, GetCultINDFromBase(iPlayer))
	table.insert(tab, {0, "Backward Principles", GetDivideFromPrinciples(iPlayer)})
	return tab;
end

function GetNatUnityModifiersTab(iPlayer)
	local tab = {};
	--to be populated
	table.insert(tab, {gT.Players[iPlayer].AcaUnifyMod , "Academies", gT.Players[iPlayer].AcaDivideMod})
	if gT.Players[iPlayer].HasPlayerWonder[induwonder6] then
		table.insert(tab, {0, "Royal Pavilion", -50})
	end
	if gT.Globals.AbolitionMovement then
		if not HasPlayerTech(iPlayer, iinoindu6, "vfvefwef") then
			table.insert(tab, {0, "Abolition Movement", 20})
		end
	end
	if Players[iPlayer]:IsGoldenAge() then
		if gT.Players[iPlayer].HasMinorIdeology[5] then
			table.insert(tab, {33, "Golden Age", 0})
		end
	end
	if gT.Players[iPlayer].HasPlayerWonder[wonderindu4] then
		table.insert(tab, {15, "Eiffel Tower", 0})
	end
	local vl = 0;
	for iT, s in pairs(gT.Players[iPlayer].Embargos) do
		vl = vl - s * 3;
	end
	table.insert(tab, {0, "Embargos", vl})
	if gT.Players[iPlayer].AuthorityRank == 1 then
		if gT.Players[iPlayer].GovRewards[1] then
			table.insert(tab, {15, "Authority", 0})
		end
	end
	return tab;
end

function GetNatUnityModifiers(iPlayer)
	local tab = GetNatUnityModifiersTab(iPlayer)
	local good, bad = 100, 100;
	for a, b in pairs(tab) do
		good = good + b[1];
		bad = bad + b[3];
	end
	return math.max(good, 10), math.max(bad, 10);
end

function GetFinalAdjustmentToNatUnity(iPlayer, preAdjusted, bTop)
	local aTab = {}
	local missing = 100 - preAdjusted;
	if gT.WondersConstructed[wonderindu2] == iPlayer then
		gT.Players[iPlayer].BrandenburgMod = math.floor(missing * 10 / 3) / 10;
		if gT.Players[iPlayer].BrandenburgMod > 0 then
			table.insert(aTab, {gT.Players[iPlayer].BrandenburgMod, "Brandenburg Gate", 33})
		end
	end
	if HasPlayerTech(iPlayer, innoindu7, "adeaddeae") then
		gT.Players[iPlayer].FascismMod = math.floor(missing * 10 / 3) / 10;
		if gT.Players[iPlayer].FascismMod > 0 then
			table.insert(aTab, {gT.Players[iPlayer].FascismMod, "Fascism", 33})
		end
	end
	return aTab;
end

function GetThisTurnCultureIndicator(iPlayer, bTop)
	local goodC = 0;
	local badC = 0;
	for a, b in pairs(GetTabOfNatUnitySources(iPlayer, bTop)) do
		goodC = goodC + b[1];
		badC = badC + b[3];
	end
	local goodMod, badMod = GetNatUnityModifiers(iPlayer);
	goodC = math.max(math.floor(goodC * goodMod) / 100, 0)
	badC = math.max(math.floor(badC * badMod) / 100, 0)
	local preAdjusted = math.floor(math.max(0, goodC - badC) / math.max(goodC + badC) * 1000) / 10
	if bTop then
		return preAdjusted;
	end
	local final = preAdjusted;
	for a, b in pairs(GetFinalAdjustmentToNatUnity(iPlayer, preAdjusted, false)) do
		final = final + b[1];
	end
	return final;
end

function GetModGoodCultureFromSpecialEffects(iCity, cID, iPlayer)
	local mod = 0;
	local iOriginalOwner = iCity:GetOriginalOwner()
	if iOriginalOwner == iPlayer then
		if gT.Players[iOriginalOwner].CultBonusOn[172] then
			mod = mod + 0.25;
		end
	end
	return mod;
end

function GetModBadCultureFromSpecialEffects(iCity, cID, iPlayer)
	local mod = 0;
	local iOriginalOwner = iCity:GetOriginalOwner()
	if iOriginalOwner ~= iPlayer then
		if gT.Players[iOriginalOwner].CultBonusOn[172] then
			mod = mod + 0.25;
		end
	end
	return mod;
end

function GetModBadCultureFromReligionInCity(iRel, iPlayer)
	local ownRel = Players[iPlayer]:GetReligionCreatedByPlayer();
	if ownRel == iRel then
		return 0;
	end
	if iRel < 1 then
		return 0;
	end
	local psRel = GetITGReligion(iPlayer)
	local bPlayer = Game.GetFounder(iRel, -1);
	if psRel == iRel then
		return 0.03 * GetPlayersCulturalDifference(iPlayer, bPlayer)
	else
		return 0.05 * GetPlayersCulturalDifference(iPlayer, bPlayer)
	end
end

function GetBadCultureEffectFromLegalOwnership(iCity, iPlayer)
	if iCity:GetOriginalOwner() ~= iPlayer then
		return 0.2;
	end
	return 0;
end

function GetBadCultureEffectFromCultureOwnership(iCity, cID, iPlayer)
	if gT.Cities[cID].CultureOwner ~= 63 then
		if gT.Cities[cID].CultureOwner ~= iPlayer then
			return 0.5 + 0.1 * math.min(3, (gT.Cities[cID].CultureLevels[gT.Cities[cID].CultureOwner] or 0) - (gT.Cities[cID].CultureLevels[iPlayer] or 0));
		else
			local modBad = 0;
			for a, b in pairs(gT.Cities[cID].CultureLevels) do
				if a ~= iPlayer then
					if b >= (gT.Cities[cID].CultureLevels[iPlayer] or 0) then
						modBad = modBad + 0.2; -- if any other player on the same level;
						break;
					end
				end
			end
			return modBad + math.min(0.2, 0.1 * math.floor((100 - gT.Cities[cID].CulturePercentageOwnership) / 23))
		end
	end
	return 0;
end

function GetModifierBadFromLaws(iCity, iPlayer, cID)
	local modExB = 0;
	if iCity:GetOriginalOwner() ~= iPlayer then
		if IsHasLaw(iPlayer, 4, 1) then	
			if ITGCityCanWorkDoAction(iCity) then
				modExB = modExB - 0.25;
			end
		elseif IsHasLaw(iPlayer, 4, 2) then
			if ITGCityCanWorkDoAction(iCity) then
				modExB = modExB + 0.25;
			end
		end
	end
	return modExB;
end

function GetGoodCultureEffectFromLegalOwnership(iCity, iPlayer)
	if iCity:GetOriginalOwner() == iPlayer then
		return 0.2
	end
	return 0;
end

function GetGoodCultureEffectBase(iCity, cID, iPlayer)
	return 0.3;
end

function GetGoodCultureEffectFromCultureOwnership(iCity, cID, iPlayer)
	local modGood = 0;
	if gT.Cities[cID].CultureOwner == 63 then
		modGood = modGood + 0.25;
	else
	--0.5 good to decide; 0.8 bad to decide;
		if gT.Cities[cID].CultureOwner ~= iPlayer then
			local cOwner = gT.Cities[cID].CultureOwner;
			local tempGood = 0.05 * (gT.Cities[cID].CultureLevels[iPlayer] or 0)
			if (gT.Cities[cID].CultureLevels[cOwner] or 0) == (gT.Cities[cID].CultureLevels[iPlayer] or 0) then
				tempGood = tempGood * 2;
			end
			modGood = modGood + tempGood;
		else
			modGood = modGood + 0.1 * math.floor(gT.Cities[cID].CulturePercentageOwnership / 17);
		end
	end
	return modGood;
end

function GetBaseUnifyingPresence(iCity, iPlayer, cID)
	local bUP = iCity:GetJONSCulturePerTurn();
	if (gT.Cities[cID].CultureLevels[iPlayer] or 0) >= 5 then
		bUP = bUP + 4;
	end
	return bUP;
end

function GetBaseDividingPresence(iCity, iPlayer, cID)
	local base = 5 + math.floor(iCity:GetPopulation() / 2)
	if gT.Players[iPlayer].CultureType == 10 and (not gT.Players[iPlayer].SubcultureType) then
		if iCity:GetOriginalOwner() == iPlayer then
			base = base - 2;
		end
	end
	return base;
end

function GetGoodAndBadCulture(iCity, cID, iPlayer)
-- main change: bad culture no longer based on iCPT;
	local iCPT = GetBaseUnifyingPresence(iCity, iPlayer, cID);
	local bDC = GetBaseDividingPresence(iCity, iPlayer, cID);
	
	local modExB = 1 + GetModifierBadFromLaws(iCity, iPlayer, cID);
	local modGood = GetGoodCultureEffectBase(iCity, cID, iPlayer) + GetGoodCultureEffectFromLegalOwnership(iCity, iPlayer) + GetGoodCultureEffectFromCultureOwnership(iCity, cID, iPlayer);
	modGood = modGood + GetModGoodCultureFromSpecialEffects(iCity, cID, iPlayer);
	local modBad = GetBadCultureEffectFromLegalOwnership(iCity, iPlayer);
	modBad = modBad + GetBadCultureEffectFromCultureOwnership(iCity, cID, iPlayer)
	modBad = modBad + GetModBadCultureFromSpecialEffects(iCity, cID, iPlayer);
	modBad = modBad + GetModBadCultureFromReligionInCity(iCity:GetReligiousMajority(), iPlayer);
	modBad = math.min(1, modBad)
	modGood = math.min(1, modGood)

	local goodC = math.floor(10  * iCPT * modGood) / 10;
	local badC = math.floor(modExB * modBad * bDC * 10 ) / 10;

	if gT.Players[iPlayer].SubcultureType == 12 then
		goodC = math.max(3, goodC)
	elseif gT.Players[iPlayer].SubcultureType == 11 then
		if iCity:IsCapital() then
			goodC = 2 * goodC;
		end
	end
	return math.max(0, goodC), math.max(0, badC);
end

function DoCityCultureChanges(iCity, cID, iPlayer)
	local pTab = GetTurnlyChangeOfCultureCity(iCity, cID, iPlayer);
	for ip, s in pairs(pTab) do
		if s ~= 0 then
			if ip ~= iPlayer then
				DoChangeCityCultureOwnership(cID, iCity, ip, s, "DCCC")
			end
		end
	end
	if pTab[iPlayer] then
		if gT.Players[iPlayer].HasIdeology[64] then
			local red = math.floor(pTab[iPlayer] / 2);
			if red > 0 then
				for rPlayer, rVal in pairs(gT.Cities[cID].CultureStored) do
					if (rVal >= red) and (rPlayer ~= iPlayer) then
						DoChangeCityCultureOwnership(cID, iCity, rPlayer, -red, "DCCCbnw")
					end
				end
			end
		end
		DoChangeCityCultureOwnership(cID, iCity, iPlayer, pTab[iPlayer], "DCCC2")
	end
end

function DoChangeCityCultureOwnership(cID, iCity, iPlayer, amount, hSTR)
	if (not cID) then
		cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		print("Error 45234232", cID, iCity, iPlayer, amount, hSTR)
	end
	if (not cID) or (not gT.Cities[cID]) or (not iPlayer) then
		print("Error 4523423", cID, iCity, iPlayer, amount, hSTR)
		return;
	end
	gT.Cities[cID].CultureStored[iPlayer] = (gT.Cities[cID].CultureStored[iPlayer] or 0) + amount;
	if amount <= 0 then
		if gT.Cities[cID].CultureStored[iPlayer] <= 0 then
			gT.Cities[cID].CultureStored[iPlayer] = nil;
			gT.Cities[cID].CultureLevels[iPlayer] = nil;
			return;
		end
	end
	gT.Cities[cID].CultureLevels[iPlayer] =	GetCultureOwnershipLevelFromValue(gT.Cities[cID].CultureStored[iPlayer], iPlayer)
	if gT.Cities[cID].CultureLevels[iPlayer] == 5 then
		if gT.Players[iPlayer].CultureType == 9 then
			if Players[iPlayer]:IsHuman() then
				LuaEvents.ITG_AchievementCompleted(12)
			end
		end
	end
	Events.SpecificCityInfoDirty(iPlayer, iCity:GetID(), CityUpdateTypes.CITY_UPDATE_TYPE_BANNER)
end

function GetPresencePTfromCultureType(iPlayer)
	local t = 0;
	if gT.Players[iPlayer].SubcultureType == 6 then
		t = t + 1;
	end
	return t;
end

function GetPresencePTfromGoldenAge(iPlayer)
	local t = 0;
	if Players[iPlayer]:IsGoldenAge() then
		if gT.Players[iPlayer].HasMinorIdeology[5] then
			t = t + 7;
		end
	end
	return t;
end

function GetPresencePTfromWonders(iPlayer, iCity, bTooltip)	
	local t = 0;
	if gT.Players[iPlayer].HasMinorIdeology[19] then
		if HasWonderOrRuin(iCity) then
			t = t + 4;
		end
	end
	if gT.Players[iPlayer].HasPlayerWonder[gmedwonder12] then
		local cfd = math.floor(iCity:GetBuildingDefense() / 100);
		if cfd > 0 then
			t = t + cfd
		end
	end
	if bTooltip then
		local iRelMajor = iCity:GetReligiousMajority();
		if iRelMajor > 0 then
			local relOwner = Game.GetFounder(iRelMajor, -1);
			if relOwner == iPlayer then
				if gT.Players[relOwner].HasPlayerWonder[GameInfoTypes.BUILDING_ITG_NEW_WORLD_WONDER_6] then
					t = t + 4
				end
			end
		end
	end
	return t;
end

function GetPresencePTfromGoverment(iPlayer)	
	local t = 0;
	if gT.Players[iPlayer].Goverment == 4 then
		t = t + 2 * gT.Players[iPlayer].GovTraitMod; 
	end
	return t;
end

function GetPresencePTfromDevelopments(iCity, cID, iPlayer)
	local t = 0;
	if gT.Players[iPlayer].CultBonusOn[36] then
		local gTurn = GetITGGameTurn();
		if gTurn - 8 > gT.Cities[cID].LastReligionChange then
			if GetCityModifierFromHeresy(iCity) > 0 then
				t = t + 1.5;
			else
				t = t + 3;
			end
		end
	end
	if gT.Players[iPlayer].CultBonusOn[17] then
		if iCity:Plot():GetPlotIndex() == gT.Players[iPlayer].Cult17City then
			t = t + 10; 
		end
	end
	if gT.Players[iPlayer].CultBonusOn[39] then
		if Players[iPlayer]:IsCapitalConnectedToCity(iCity) then
			t = t + 2 
		end
	end
	if gT.Players[iPlayer].CultBonusOn[155] then
		if gT.Cities[cID].CultureOwner ~= iPlayer then
			local cIndex = iCity:Plot():GetPlotIndex()
			for index, h in pairs(gT.HolySites) do
				if h.Player == iPlayer then
					if h.NearbyCities[cIndex] then
						t = t + 3; 
					end
				end
			end
		end
	end
	return t;
end

function GetPresencePTfromPalace(iCity, cID, iPlayer)
	local t = 0;
	if gT.Cities[cID].Palace then
		if gT.Cities[cID].Palace.Presence ~= 0 then
			t = t + gT.Cities[cID].Palace.Presence * GetCityPalaceYieldMod(iCity, cID, iPlayer);
		end
		if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_ARAB_1, "543kke") then
			if gT.Cities[cID].Palace.NumUpgrades >= 3 then
				t = t + 3;
			end
		end
	end
	return t;
end

function GetPresencePTfromInnovations(iCity, cID, iPlayer, bTooltip)
	local t = 0;
	if gT.Cities[cID].CultGuild == "A" then
		t = t + 3;
	end
	if HasPlayerTech(iPlayer, tmesonw1, "oeoeodkoekde") then
		t = t + gT.Cities[cID].Mountain;
	end
	if HasPlayerTech(iPlayer, techNWasia4, "alaldlaedade") then
		if iCity:GetYieldRateTimes100(yScience) >= 2000 then
			t = t + 3;
		end
	end
	if bTooltip then
		if iPlayer == iCity:GetOriginalOwner() then
			if HasPlayerTech(iPlayer, ancInCS19, "CasdadeeaD") then
				if iPlayer ~= gT.Cities[cID].CultureOwner or ((gT.Cities[cID].CulturePercentageOwnership or 0) < 80) then
					t = t + 2
				end
			end
		end
	end
	return t;
end

function GetPresencePTfromGreatPeople(iCity, cID, iPlayer, bTooltip)
	local t = GetITGCityInteger(iCity, "CI_PRESENCE_FROM_GP");
	if bTooltip then
		local presFromGP = 1;
		local cpIndex = iCity:Plot():GetPlotIndex();
		for gpID, hhh in pairs(gT.Players[iPlayer].GreatPeople) do
			local gd = gT.GreatPeople[gpID];
			if gd.Alive and (not gd.Military) and (gd.OriginPlayer == iPlayer) then
				if gd.City == cpIndex then
					t = t + presFromGP * LOCAL_GP_CIVIL_PRESENCE;
				end
			end
		end
	end
	return t;
end

function GetPresencePTfromFestival(cID)
	if gT.Cities[cID].FestivalET then
		return 7;
	end
	return 0;
end

function GetPresencePTfromAcademies(iPlayer, cID, bExcludeHidden)
	local t = 0;
	if IsHasLaw(iPlayer, 27, 3) then	
		t = t - 2 * #gT.Cities[cID].Academies;
	end
	if gT.Cities[cID].CPfromAca > 0 then
		t = t + gT.Cities[cID].CPfromAca;
	end
	return t;
end

function GetPresencePTfromAnchor(iPlayer, cID)
	local iAnchor = GetCulturalPresenceAnchor(iPlayer)
	if (gT.Cities[cID].CultureStored[iPlayer] or 0) < iAnchor then
		return 2;
	end
	return 0;
end

function GetPresencePTfromFaith(iPlayer, iCity, cID)
	if gT.Players[iPlayer].CultBonusOn[184] then
		return math.ceil(iCity:GetFaithPerTurn() / 2)
	end
	return 0;
end

function GetPresencePTfromCulturePT(iPlayer, iCity, cID)
	local iCPT = iCity:GetJONSCulturePerTurn()
	if iCPT > 0 then
		local mod = gT.Players[iPlayer].CultureToPresence;
		if iCity:GetOriginalOwner() ~= iPlayer then
			mod = mod - 0.2
		end
		if gT.Cities[cID].CultureOwner ~= 63 then
			if gT.Cities[cID].CultureOwner ~= iPlayer then
				mod = mod - 0.1;
			end
		end
		mod = math.max(0, mod);
		return math.floor(iCPT * mod);
	end
	return 0;
end

function GetPresencePTfromGovernance(iCity)
	return GetITGCityInteger(iCity, "CI_GOV_HEALTH")
end

function GetPresenceModfromHeresy(iPlayer, iCity)
	if gT.Players[iPlayer].OfficialReligion then
		if IsHasLaw(iPlayer, 21, 2) then	
			return math.floor(GetCityModifierFromHeresy(iCity) * -50)
		end
	end
	return 0;
end

function GetPresenceModFromLaws(iPlayer, iCity)
	local tMod = 0;
	if iCity:IsOccupied() then
		if IsHasLaw(iPlayer, 4, 1) then	
			tMod = tMod - 50;
		elseif IsHasLaw(iPlayer, 4, 2) then
			tMod = tMod + 50;
		end
	end
	return tMod;
end

function GetPresencePTforCityOwner(iCity, cID, iPlayer, bToolTip)
	local t = GetPresencePTfromCultureType(iPlayer) + GetPresencePTfromGoldenAge(iPlayer) + GetPresencePTfromWonders(iPlayer, iCity) + GetPresencePTfromGoverment(iPlayer)	
	t = t + GetPresencePTfromDevelopments(iCity, cID, iPlayer) + GetPresencePTfromPalace(iCity, cID, iPlayer) + GetPresencePTfromInnovations(iCity, cID, iPlayer)
	t = t + GetPresencePTfromGreatPeople(iCity, cID, iPlayer) + GetPresencePTfromFestival(cID) + GetPresencePTfromAcademies(iPlayer, cID, bToolTip)
	t = t + GetPresencePTfromAnchor(iPlayer, cID) + GetPresencePTfromCulturePT(iPlayer, iCity, cID) + GetPresencePTfromFaith(iPlayer, iCity, cID);
	t = t + GetPresencePTfromGovernance(iCity) + GetPresencePTfromPiracy(iPlayer, iCity)
	local mod = 100 + GetPresenceModfromHeresy(iPlayer, iCity) + GetPresenceModFromLaws(iPlayer, iCity);
	if mod ~= 100 then
		mod = math.max(10, mod);
		t = math.floor(t * mod / 10) / 10 
	end
	if bToolTip then
		t = t + GetCulturalPresenceFromProcess(iCity);
	end
	return t;
end

function GetPresencePTfromPiracy(iPlayer, iCity)
	if gT.Players[iPlayer].PiratePerks[3] then
		if IsLonelyOnLandmass(GetContID(iCity:Plot(), "jiewjidewd")) then
			return 10
		end
	end
	return 0;
end

function GetPresencePTforTTAmalgamation(iPlayer, cID)
	local a = 0;
	if gT.Players[iPlayer].CultBonusOn[107] then
		if gT.Cities[cID].CultureOwner ~= iPlayer then
			for jCity in Players[iPlayer]:Cities() do
				local jID = jCity:Plot():GetPlotIndex() .. "," .. jCity:GetGameTurnFounded();
				if gT.Cities[jID].CultureOwner == iPlayer then
					a = a + 1;
				end
			end
		end
	end
	return a;
end

function GetPresencePTforTTonlySoaking(iPlayer, cID, iCity)
--ToolTip only!!!
	local t = 0;
	for h, sIndex in pairs(GetNearCities(cID, 10)) do
		local sCity = Map.GetPlotByIndex(sIndex):GetPlotCity();
		local sID = sIndex .. "," .. sCity:GetGameTurnFounded();
		local sPlayer = sCity:GetOwner();
		if (gT.Cities[sID].CultureLevels[iPlayer] or 0) >= 4 then
			t = t + 0.5;
		end
		if sPlayer == iPlayer then
			if gT.Players[sPlayer].CulturalPresenceAura > 0 then
				t = t + gT.Players[sPlayer].CulturalPresenceAura;
			end
		end
	end
	return t;
end

function GetTurnlyChangeOfCultureCity(iCity, cID, iPlayer, bToolTip)
	local pAdding = {}
	local pTeam = Teams[Players[iPlayer]:GetTeam()];
	pAdding[iPlayer] = GetPresencePTforCityOwner(iCity, cID, iPlayer, bToolTip)
--	local gTurn = GetITGGameTurn();
--	local dropImmune = {}
--	dropImmune[iPlayer] = true;
	if gT.Players[iPlayer].CultBonusOn[107] then
		for jCity in Players[iPlayer]:Cities() do
			local jID = jCity:Plot():GetPlotIndex() .. "," .. jCity:GetGameTurnFounded();
			local sPlayer = gT.Cities[jID].CultureOwner;
			if sPlayer ~= gT.Cities[cID].CultureOwner then
				if sPlayer ~= 63 then
					pAdding[sPlayer] = (pAdding[sPlayer] or 0) + 1; 
				end
			end
		end
	end
	local ideo77checked = {[iPlayer] = true};
	for h, sIndex in pairs(GetNearCities(cID, 10)) do
		local sCity = Map.GetPlotByIndex(sIndex):GetPlotCity();
		local sID = sIndex .. "," .. sCity:GetGameTurnFounded();
		local sPlayer = sCity:GetOwner();
		for i, level in pairs(gT.Cities[sID].CultureLevels) do
			if level >= 4 then
				pAdding[i] = (pAdding[i] or 0) + 0.5;
			end
		end
		if gT.Players[sPlayer].CulturalPresenceAura > 0 then
			pAdding[sPlayer] = (pAdding[sPlayer] or 0) + gT.Players[sPlayer].CulturalPresenceAura;
		end

		--not necessary aura, but it already checks 10 range here
		if gT.Players[sPlayer].HasIdeology[73] then
			if (not ideo77checked[sPlayer]) then
				local sgv = gT.Cities[sID].PlacedGovernor;
				if gT.Globals.Governors[sgv] then
					local toTop = 0;
					if gT.Globals.Governors[gT.Cities[cID].Governor] then
						toTop = gT.Globals.Governors[gT.Cities[cID].Governor].Power;
					end
					if gT.Globals.Governors[sgv].Power > toTop then
						ideo77checked[sPlayer] = true;
						pAdding[sPlayer] = (pAdding[sPlayer] or 0) + 5; 
					end
				end
			end
		end
	end
	local spowner = iCity:GetOriginalOwner();
	local cowner = gT.Cities[cID].CultureOwner;
--	dropImmune[spowner] = true;
--	dropImmune[gT.Cities[cID].CultureOwner] = true;

	if HasPlayerTech(spowner, ancInCS19, "CasdadeeaD") then
		if spowner ~= cowner or ((gT.Cities[cID].CulturePercentageOwnership or 0) < 80) then
			pAdding[spowner] = (pAdding[spowner] or 0) + 2
		end
	end

	local bCache = {};
	for ghg, ghdd in pairs(gT.Players) do
		if iPlayer ~= ghg then
			if ghdd.PiratePerks[3] then
				if bCache[1] == nil then
					bCache[1] = IsLonelyOnLandmass(GetContID(iCity:Plot(), "jiewjidewd"))
				end
				if bCache[1] then
					pAdding[ghg] = (pAdding[ghg] or 0) + 10
				end
			end
			if ghdd.CultBonusOn[17] then
				if iCity:Plot():GetPlotIndex() == ghdd.Cult17City then
					pAdding[ghg] = (pAdding[ghg] or 0) + 10; 
				end
			end
			if ghdd.CultBonusOn[155] then
				if gT.Cities[cID].CultureOwner ~= ghg then
					local cIndex = iCity:Plot():GetPlotIndex()
					for index, h in pairs(gT.HolySites) do
						if h.Player == ghg then
							if h.NearbyCities[cIndex] then
								pAdding[ghg] = (pAdding[ghg] or 0) + 3; 
							end
						end
					end
				end
			end
		end
	end
	if gT.WondersConstructed[wonderindu4] then
		local etPlayer = gT.WondersConstructed[wonderindu4];
		if etPlayer ~= iPlayer then
			local etAnchor = GetCulturalPresenceAnchor(etPlayer)
			if (gT.Cities[cID].CultureStored[etPlayer] or 0) < etAnchor then
				pAdding[etPlayer] = (pAdding[etPlayer] or 0) + 2; 
			end
		end
	end
	local iRelMajor = iCity:GetReligiousMajority();
	if iRelMajor > 0 then
		local relOwner = Game.GetFounder(iRelMajor, -1);
		if gT.Players[relOwner].HasPlayerWonder[GameInfoTypes.BUILDING_ITG_NEW_WORLD_WONDER_6] then
			pAdding[relOwner] = (pAdding[relOwner] or 0) + 4
		end
	end
	local presFromGP = 1;
	local cpIndex = iCity:Plot():GetPlotIndex();
	for gpID, hhh in pairs(gT.Players[iPlayer].GreatPeople) do
		local gd = gT.GreatPeople[gpID];
		if gd.City == cpIndex then
			if gd.Alive and (not gd.Military) then
				if gd.OriginPlayer == iPlayer then
					pAdding[gd.OriginPlayer] = (pAdding[gd.OriginPlayer] or 0) + presFromGP * LOCAL_GP_CIVIL_PRESENCE;
				else
					pAdding[gd.OriginPlayer] = (pAdding[gd.OriginPlayer] or 0) + presFromGP * FOREIGN_GP_CIVIL_PRESENCE;
				end 
			end
		end
	end
	if Players[iPlayer]:IsMinorCiv() then
		local gAlly = Players[iPlayer]:GetAlly();
		if gAlly ~= -1 then
			pAdding[gAlly] = 1 + gT.Players[gAlly].ExtraAlliedCultPres + (pAdding[gAlly] or 0)
		end
	end
	if HasPlayerTech(iPlayer, tinnanctr15, "Vekorow") then
		for s, h in pairs(gT.Cities[cID].CultureStored) do
			if s ~= iPlayer then
				pAdding[s] = -1 + (pAdding[s] or 0)
			end
		end
	end
	if iPlayer ~= cowner then
		if gT.Players[cowner] and (gT.Players[cowner].CPForeignOwned > 0) then
			pAdding[cowner] = gT.Players[cowner].CPForeignOwned + (pAdding[cowner] or 0)
		end
	end
	-- here drop of inactivity
	for hplayer, val in pairs(pAdding) do
		if val < 0 and (not gT.Cities[cID].CultureStored[hplayer]) then
			pAdding[hplayer] = nil;
		end
	end
	--finally mods
	return pAdding;
end

function CityConqueredCultureOwnership(jPlayer, newPlayer, iCity, cID)
	for j, c in pairs(gT.Cities[cID].CultureStored) do
		if j ~= newPlayer then
			if (gT.Cities[cID].CultureLevels[j] or 0) < 2 then -- only small cultures get eradicated
				DoChangeCityCultureOwnership(cID, iCity, j, -1 * math.max(2, math.floor(c) / 2), "Cconq") -- 50%;
			end
		end
	end
end

function GetPlayerNiceAdjective(i)
	if Game.GetActivePlayer() == i then
		return "[COLOR_POSITIVE_TEXT]" .. Players[i]:GetCivilizationAdjective() .. "[ENDCOLOR]"
	elseif Teams[Game.GetActiveTeam()]:IsHasMet(Players[i]:GetTeam()) then
		return Players[i]:GetCivilizationAdjective()
	end
	return "Unknown"
end

function GetBasicToolTipDataPresence(iCity, cID)
	if gT.Cities[cID] then
		if gT.Cities[cID].CultureOwner then
			local gTab = {}
			local citgowner = gT.Cities[cID].CultureOwner;
			gTab.COwner = gT.Cities[cID].CultureOwner
			local itgcott = "Cultures present in city:"
			local iCowner = iCity:GetOwner();
			local playersDone = {}
			local sTab = GetTurnlyChangeOfCultureCity(iCity, cID, iCity:GetOwner(), true)
			gTab.COwnerChange = sTab[iCowner] or 0;
			--plus tooltip for container
			local toSortT = {}
			local itgTempPlayTT;
			for i, v in pairs(gT.Cities[cID].CultureStored) do
				itgTempPlayTT = "[NEWLINE][ICON_BULLET]"
				if gT.Cities[cID].CultureLevels[i] then
					itgTempPlayTT = itgTempPlayTT .. "[COLOR_YIELD_GOLD]" .. GetRomanNumber(gT.Cities[cID].CultureLevels[i]) .. "[ENDCOLOR] "
				end
				itgTempPlayTT = itgTempPlayTT .. GetPlayerNiceAdjective(i) .. " ([COLOR_MAGENTA]" .. v .. "[ENDCOLOR][ICON_ITG_PRESENCE])"
				playersDone[i] = 1;
				if sTab[i] then
					if sTab[i] > 0 then
						itgTempPlayTT = itgTempPlayTT .. " 		[COLOR_POSITIVE_TEXT]+" .. sTab[i] .. "[ENDCOLOR]";
					elseif sTab[i] < 0 then
						itgTempPlayTT = itgTempPlayTT .. " [COLOR_NEGATIVE_TEXT]" .. sTab[i] .. "[ENDCOLOR]";
					end
				end
				table.insert(toSortT, {itgTempPlayTT, v})
			end
			for i, v in pairs(sTab) do
				if not playersDone[i] then
					itgTempPlayTT = "[NEWLINE][ICON_BULLET]" .. GetPlayerNiceAdjective(i) .. " ([COLOR_MAGENTA]0[ENDCOLOR][ICON_ITG_PRESENCE])"
					if v > 0 then
						itgTempPlayTT = itgTempPlayTT .. " 		[COLOR_POSITIVE_TEXT]+" .. v .. "[ENDCOLOR]";
					elseif v < 0 then
						itgTempPlayTT = itgTempPlayTT .. " [COLOR_NEGATIVE_TEXT]" .. v .. "[ENDCOLOR]";
					end
					playersDone[i] = 1;
					table.insert(toSortT, {itgTempPlayTT, 0})
				end
			end
			table.sort(toSortT, SortFunctionForGreaterInteger2)
			for i, v in pairs(toSortT) do
				itgcott = itgcott .. v[1];
			end
			local alphITGcott = 0.6;
			if citgowner == 63 then
				itgcott = itgcott .. "[NEWLINE][NEWLINE]Citizens are barbaric."
			else
				alphITGcott = 0.6 + 0.4 * gT.Cities[cID].CulturePercentageOwnership / 100;
				itgcott = itgcott .. "[NEWLINE][NEWLINE]Citizens are " .. gT.Cities[cID].CulturePercentageOwnership .. "% " .. Players[citgowner]:GetCivilizationAdjective() .. "."
			end
			gTab.Alpha = alphITGcott
			gTab.ToolTip = itgcott
			return gTab;
		end
	end
	return nil;
end
LuaEvents.ITGSG_RequestCityCultureOwnership.Add(function(cityIndex, cID)
	local iCity = Map.GetPlotByIndex(cityIndex):GetPlotCity()
	MapModData.ITGSG = GetBasicToolTipDataPresence(iCity, cID);
end)

function DoSpreadInfluenceFromPassingLight(iPlayer, jPlayer, hcCity, hcID)
	if GetTotalPlayerCulturalPresence(iPlayer) > GetTotalPlayerCulturalPresence(jPlayer) then
		AddCulturalPresenceInAllCities(iPlayer, jPlayer, 35)
		if hcCity then
			DoChangeCityCultureOwnership(hcID, hcCity, iPlayer, 35, "SLight")
		end
	end
end

function SpreadPresenceToAnyOccupiedCity(fromPlayer, withinPlayer, amount)
	local bAny = false;
	for iCity in Players[withinPlayer]:Cities() do
		if iCity:IsOccupied() then
			local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
			DoChangeCityCultureOwnership(cID, iCity, fromPlayer, amount, "OccupiedSpread")
			bAny = true;
		end
	end
	return bAny;
end

function AddCulturalPresenceInAllNearbyForeignCities(iPlayer, amount)
	local indexT = {}
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		for h, sIndex in pairs(GetNearCities(cID, 10)) do
			indexT[sIndex] = 1;
		end
	end
	for index, sth in pairs(indexT) do
		local iCity = Map.GetPlotByIndex(index):GetPlotCity();
		if iCity:GetOwner() ~= iPlayer then
			local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
			DoChangeCityCultureOwnership(cID, iCity, iPlayer, amount, "All nearby")
		end
	end
end

function AddCulturalPresenceWorldWide(iPlayer, val, excl, bNoErosion)
	for g, h in pairs(gT.Players) do
		if excl ~= g then
			AddCulturalPresenceInAllCities(iPlayer, g, val, bNoErosion)
		end
	end
end

function AddSettlerInstantInfluenceNow(iPlayer)
	local hPt = {}
	local sT = {}
	for g, h in pairs(gT.Players) do
		if Players[g]:GetNumCities() > 0 then
			if iPlayer ~= g then
				if Teams[Players[iPlayer]:GetTeam()]:IsAtWar(Players[g]:GetTeam()) then
					table.insert(sT, g)
				else
					table.insert(hPt, g)
				end
			end
		end
	end
	local cPlayer = nil;
	if #hPt > 0 then
		cPlayer = hPt[LastRandom(1, #hPt)];
	elseif #sT > 0 then
		cPlayer = sT[LastRandom(1, #sT)];
	end
	if cPlayer then
		local cTab = {}
		for iCity in Players[cPlayer]:Cities() do
			table.insert(cTab, iCity);
		end
		local iCity = cTab[LastRandom(1,#cTab)];
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		table.insert(gT.Players[iPlayer].SettlerLog, {2, cPlayer, iCity:Plot():GetPlotIndex(), GetITGGameTurn()})
		if not Players[cPlayer]:IsMinorCiv() then
			table.insert(gT.Players[cPlayer].SettlerLog, {3, iPlayer, iCity:Plot():GetPlotIndex(), GetITGGameTurn()})
		end
		DoChangeCityCultureOwnership(cID, iCity, iPlayer, 100, "AutoSettler")
	end
end

function AddCulturalPresenceInAllCities(iPlayer, jPlayer, val, bNoErosion) --bNoErosion is obsolete
	for iCity in Players[jPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		DoChangeCityCultureOwnership(cID, iCity, iPlayer, val, "AllCities")
	end
end

function GetTotalPlayerCulturalPresence(g)
	local gvv = 0;
	for tid, tdd in pairs(gT.Cities) do
		gvv = gvv + (tdd.CultureStored[g] or 0)
	end
	return gvv;
end

function CityNewRiotDropInCulture(iCity, iPlayer)
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	for player, val in pairs(gT.Cities[cID].CultureStored) do
		local drop = math.min(50, math.ceil(val / 2)) * -1;
		if (iPlayer ~= player) and (gT.Players[iPlayer].HasPlayerWonder[induwonder2]) then
			drop = drop * 2
		end
		DoChangeCityCultureOwnership(cID, iCity, player, drop, "Riots")
	end
end

function CityMigrationToCityInfluence(tCity, iCity)
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local tcID = tCity:Plot():GetPlotIndex() .. "," .. tCity:GetGameTurnFounded();	
	for player, val in pairs(gT.Cities[cID].CultureStored) do
		local tAdd = math.min(math.floor(val / 20), 20)
		if tAdd > 0 then
			DoChangeCityCultureOwnership(tcID, tCity, player, tAdd, "Q?2")
		end
	end
end

function GetCulturalPresenceAnchor(iPlayer)
	local b = gT.Players[iPlayer].CulturePresAnchor + gT.Players[iPlayer].CulturePresAnchorFromCities;
	if gT.Players[iPlayer].StAlphabet == iPlayer then
		b = b + 50;
	end
	return b;
end

function DirtyCulturePresAnchorFromCities(iPlayer)
	local c = 0;
	for cid, d in pairs(gT.Cities) do
		if (d.CultureLevels[iPlayer] or 0) >= 3 then
			c = c + 10;
		end
	end
	gT.Players[iPlayer].CulturePresAnchorFromCities = c;
end

function GetCulturalOwnerOfCS(iPlayer)
	local cPlayer = -1;
	local iCity = Players[iPlayer]:GetCapitalCity();
	if iCity then
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		cPlayer = gT.Cities[cID].CultureOwner or -1;
	end
	return cPlayer;
end

function GetTabOfCitiesNotOwnedCulturally(iPlayer)
	local tab = {}
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		if gT.Cities[cID].CultureOwner ~= iPlayer then
			table.insert(tab, iCity);
		end
	end
	return tab;
end

function DoSpreadCulturalPresenceInRange(iPlayer, val, x, y, cRange)
	local bAnyCity = false;
	local iTeam = Players[iPlayer]:GetTeam();
	for i, plot in pairs(GetPlotsInRadiusOfPlot(Map.GetPlot(x, y), cRange)) do
		if plot:IsCity() then
			if plot:IsRevealed(iTeam) then
				local iCity = plot:GetPlotCity();
				local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
				DoChangeCityCultureOwnership(cID, iCity, iPlayer, val, "OnKill")
				bAnyCity = true;
			end
		end
	end
	return bAnyCity;
end

function DistributePresence(iPlayer, bonus, am, iMax)
	local tab = {};
	local tabFX = {}
	for iCity in Players[iPlayer]:Cities() do
		local index = iCity:Plot():GetPlotIndex();
		local cID = index .. "," .. iCity:GetGameTurnFounded();
		table.insert(tab, {iCity:GetID(), cID, 0, index})
		tabFX[index] = {0, iCity:GetX(), iCity:GetY()}
	end
	for jj = 1, am do
		if #tab > 0 then
			local lKey = LastRandom(1,#tab);
			DoChangeCityCultureOwnership(tab[lKey][2], Players[iPlayer]:GetCityByID(tab[lKey][1]), iPlayer, bonus, "Distribution")
			if iMax then
				tab[lKey][3] = tab[lKey][3] + bonus;
				tabFX[tab[lKey][4]][1] = tab[lKey][3];
				if tab[lKey][3] >= iMax then
					table.remove(tab, lKey);
				end
			end
		else
			break;
		end
	end
	if iPlayer == Game.GetActivePlayer() then
		for index, h in pairs(tabFX) do
			if h[1] ~= 0 then
				Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(h[2], h[3]))), "+" .. h[1] .. "[ICON_ITG_PRESENCE]", 0.5)
			end
		end
	end
end