local follBelief40 = GameInfoTypes.BELIEF_ITG_FOLLOWER_40;
local follBelief28 = GameInfoTypes.BELIEF_ITG_FOLLOWER_28;
local follBelief29 = GameInfoTypes.BELIEF_ITG_FOLLOWER_29;
local follBelief30 = GameInfoTypes.BELIEF_ITG_FOLLOWER_30;
local follBelief31 = GameInfoTypes.BELIEF_ITG_FOLLOWER_31;
local itgnewwWonder15 = GameInfoTypes.BUILDING_ITG_NEW_WORLD_WONDER_15;
local itgnewwWonder32 = GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_32;
local gTabOfProxDistance = {}
local kFollowingDistance = {10, 20, 1000};
local kUltimateDistance = #kFollowingDistance

function InitialCitiesNearbyCache()
	gTabOfProxDistance = {} -- clear on era conv;
	for g, gt in pairs(gT.Players) do
		for iCity in Players[g]:Cities() do
			DoInitialNearbyCities(iCity, true)
		end
	end
end

function GetNearCities(cID, iDis)
	local tab = {};
	for i, dis in pairs(kFollowingDistance) do
		if (dis >= iDis) or (i == kUltimateDistance) then
			for jIndex, jDis in pairs(gTabOfProxDistance[cID][dis]) do
				if jDis <= iDis then
					table.insert(tab, jIndex);
				end
			end
			break;
		end
	end
	return tab;
end

function DoInitialNearbyCities(iCity, bInit)
	local iPlotIndex = iCity:Plot():GetPlotIndex()
	local cID = iPlotIndex .. "," .. iCity:GetGameTurnFounded();
	gTabOfProxDistance[cID] = {[10] = {}, [20] = {}, [1000] = {}}
	local iOwner = iCity:GetOwner();
	for g, gt in pairs(gT.Players) do
		for jCity in Players[g]:Cities() do
			if (jCity:GetID() ~= iCity:GetID()) or (g ~= iOwner) then
				local iDis = Map.PlotDistance(jCity:GetX(), jCity:GetY(), iCity:GetX(), iCity:GetY());
				local jPlotIndex = jCity:Plot():GetPlotIndex()
				for hh, hhjk in pairs(gTabOfProxDistance[cID]) do
					if iDis <= hh then
						gTabOfProxDistance[cID][hh][jPlotIndex] = iDis;
					end					
				end
				if not bInit then
					local jcID = jCity:Plot():GetPlotIndex() .. "," .. jCity:GetGameTurnFounded();
					for hh, hhjk in pairs(gTabOfProxDistance[jcID]) do
						if iDis <= hh then
							gTabOfProxDistance[jcID][hh][iPlotIndex] = iDis;
						end					
					end
				end
			end
		end
	end
end



function GetHumanPlayerTasksOptions(iCity, iPlayer)
	return {};
end

function CanBuildingProdBeHurryUp(unitP)
	if unitP ~= -1 then
		if GameInfo.BuildingClasses[GameInfo.Buildings[unitP].BuildingClass].MaxPlayerInstances < 1 then
			if GameInfo.BuildingClasses[GameInfo.Buildings[unitP].BuildingClass].MaxGlobalInstances < 1 then
				return true;
			end
		end
	end
	return false;
end

function GetHurryCityTaskBuildingProduction(unitP, iCity)
	return math.ceil(iCity:GetBuildingProductionNeeded(unitP) - iCity:GetBuildingProduction(unitP))
end

function GetHurryCityTaskUnitProduction(unitP, iCity)
	return math.ceil(iCity:GetUnitProductionNeeded(unitP) - iCity:GetUnitProduction(unitP))
end

function DoCityITGTask(iCity, taskID)
	print("OH NO CITY ASKED TO DO OUTDATED TASK!!!", iCity:GetName(), iCity:GetOwner(), taskID)
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	if taskID == 1 then
	end
end

function IsCityHasSpecialist(iCity)
	for row in GameInfo.Specialists() do
		if row.ID ~= 0 then
			if iCity:GetSpecialistCount(row.ID) > 0 then
				return true;
			end
		end
	end
	return false;
end

function SetBuildingClassMaintenanceFree(iPlayer, iClass, bRed)
	if bRed then
		gT.Players[iPlayer].MaintenanceFreeClasses[iClass] = (gT.Players[iPlayer].MaintenanceFreeClasses[iClass] or 0)  - 1;
		return;
	else
		gT.Players[iPlayer].MaintenanceFreeClasses[iClass] = (gT.Players[iPlayer].MaintenanceFreeClasses[iClass] or 0)  + 1;
	end
	local iBtype = Players[iPlayer]:GetPlayerUniqueBuilding(iClass);
	if not bRed then
		if iBtype ~= -1 then
			for iCity in Players[iPlayer]:Cities() do
				if iCity:GetNumRealBuilding(iBtype) > 0 then
					iCity:SetNumFreeBuilding(iBtype, iCity:GetNumRealBuilding(iBtype))
					iCity:SetNumRealBuilding(iBtype, 0)
				end
			end
		end
	end
end

function DoAutomaticTemplarBuildingPurchase(gPlayer)
	if gT.Players[gPlayer].AutomaticFaithPurchase then
		for iCity in Players[gPlayer]:Cities() do
			local iRel = iCity:GetReligiousMajority();
			if gT.TemplarRelBuilding[iRel] then
				if (iCity:IsCanPurchase(true, true, -1, gT.TemplarRelBuilding[iRel], -1, yFaith)) then
					Game.CityPurchaseBuilding(iCity, gT.TemplarRelBuilding[iRel], yFaith)
				end
			end
		end
	end
end

function DoAutomaticMissionaries(gPlayer)
	if gT.Players[gPlayer].AutomaticMissionaries then
		if gT.Players[gPlayer].FreeMissioniares > 0 then
			if Players[gPlayer]:GetReligionCreatedByPlayer() > 0 then
				DoAIConsiderSendingMissionary(gPlayer, false)
				RefreshAllDirtyPlayer();
			end
		end
	end
end

function GetTypeToSupportAutomaticAcademy(gPlayer, index)
	if gT.Players[gPlayer].AIAcademyManager == 1 then
		return "Random";
	elseif gT.Players[gPlayer].AIAcademyManager == 2 then
		local tab = {}
		for hh, sth in pairs(gT.Academies[index].Bonuses) do
			if sth % 5 == 4 then
				table.insert(tab, hh)
			end
		end
		if #tab > 0 then
			return tab[LastRandom(1,#tab)];
		end
		return "Random";
	elseif gT.Players[gPlayer].AIAcademyManager == 3 then
		local tH = 0;
		local bBv = 0;
		local bTab = {};
		for hh, sth in pairs(gT.Academies[index].Bonuses) do
			tH = tH + 1;
			if sth > bBv then
				bTab = {hh}
				bBv = sth;
			elseif sth == bBv then
				table.insert(bTab, hh);
			end
		end
		if #bTab == tH then
			return "Random";
		else
			return bTab[LastRandom(1,#bTab)];
		end
	end
	print("Undefined automatic ai academy support", gPlayer, gT.Players[gPlayer].AIAcademyManager)
	return "Random";
end

function IsValidForAIAutoBullying(g, iPlayer)
	if gT.Players[iPlayer].AIBullying == 1 then
		--anything below or equal anchor
		return (Players[g]:GetMinorCivFriendshipWithMajor(iPlayer) <= Players[g]:GetMinorCivFriendshipAnchorWithMajor(iPlayer))
	elseif gT.Players[iPlayer].AIBullying == 2 then
		--non-friendly
		return (Players[g]:GetMinorCivFriendshipLevelWithMajor(iPlayer) < 1);
	elseif gT.Players[iPlayer].AIBullying == 3 then
		--non-allied
		return (Players[g]:GetAlly() ~= iPlayer)
	end
	return false;
end

function DoAutomaticBullying(iPlayer)
	if not gT.Players[iPlayer].AIBullying then
		return;
	end
	local iTeam = Players[iPlayer]:GetTeam();
	for g, h in pairs(gT.Players) do
		if Players[g]:IsMinorCiv() then
			if Players[g]:CanMajorBullyGold(iMajor) then
				if Teams[iTeam]:IsHasMet(Players[g]:GetTeam()) then
					if IsValidForAIAutoBullying(g, iPlayer) then
						Game.DoMinorBullyGold(iPlayer, g);
					end
				end
			end
		end
	end
end

function ShouldDoAutomaticConstruction(iPlayer)
	for iClass, val in pairs(gT.Players[iPlayer].AIConstructionManager or {}) do
		if val then
			return true;
		end
	end
	return false;
end

function CurrentOrderValidToAutomation(iCity)
	local iBuilding = iCity:GetProductionBuilding();
	local iUnit = iCity:GetProductionUnit();
	local iProcess = iCity:GetProductionProcess()
	if (iBuilding == -1) and (iUnit == -1) then
		if (iProcess == -1) or (GameInfo.Processes[iProcess].IsCompetitive == 0) then
			return true;
		end
	end
	return false;
end

function DoAutomaticConstructionOrder(iPlayer)
	local bActivePlayer = (iPlayer == Game.GetActivePlayer())
	if ShouldDoAutomaticConstruction(iPlayer) then
		for iCity in Players[iPlayer]:Cities() do
			if CurrentOrderValidToAutomation(iCity) then
				for iClass, val in pairs(gT.Players[iPlayer].AIConstructionManager) do
					if val then
						local iBuilding = Players[iPlayer]:GetPlayerUniqueBuilding(iClass);
						if iBuilding ~= -1 then
							if iCity:CanConstruct(iBuilding, 1, 1) then
								Game.CityPushOrder(iCity, OrderTypes.ORDER_CONSTRUCT, iBuilding, false, true, true);
								Events.SpecificCityInfoDirty(iPlayer, iCity:GetID(), CityUpdateTypes.CITY_UPDATE_TYPE_BANNER)
	--							iCity:PushOrder(OrderTypes.ORDER_CONSTRUCT, iBuilding)
								break;
							end
						end
					end
				end
			end
		end
	end
end

function DoAutomaticAcademySupport(gPlayer, bIgnore)
	if gT.Players[gPlayer].AIAcademyManager then
		if Players[gPlayer]:GetGold() < ACADEMY_SUPPORT_NO_RANDOM_GOLD then
			return;
		end
		local gTurn = GetITGGameTurn();
		for index, sth in pairs(gT.Academies) do
			if sth.Player == gPlayer then
				if sth.Active then
					if sth.SupportCD < gTurn then
						if IsAcademyActiveRightNow(index) then
							if (bIgnore) or (not HasAcademySupportDiploNote(index, gPlayer)) then
								if Map.GetPlotByIndex(sth.City):GetPlotCity():GetDamage() == 0 then
									PlayerSupportAcademy(index, gPlayer, GetTypeToSupportAutomaticAcademy(gPlayer, index))
									if Players[gPlayer]:GetGold() < ACADEMY_SUPPORT_NO_RANDOM_GOLD then
										return;
									end
								end
							end
						end
					end
				end
			end
		end
	end
end

function CanDefendFromDefenseBroken(iCity)
	local iPlayer = iCity:GetOwner();
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	if gT.Players[iPlayer].HasIdeology[34] then
		if gT.Cities[cID].WorkRate >= 100 then
			MakeCitySpendWorkRate(iCity, iPlayer, 100)
			return true;
		end
	end
	return false;
end

function DoDistributeWorkRateBetweenCities(iPlayer, hval, dCity)
	local nmcities = Players[iPlayer]:GetNumCities() - 1;
	if nmcities > 0 then
		local cr = math.ceil(hval / nmcities);
		if cr > 0 then
			for iCity in Players[iPlayer]:Cities() do
				if iCity ~= dCity then
					ChangeITGWorkRate(iCity, cr)
				end
			end
		end
	end
end

function GetOriginalCapitalOfPlayer(iPlayer)
	for i, gd in pairs(gT.Players) do
		for iCity in Players[i]:Cities() do
			if iCity:IsOriginalMajorCapital() then
				if iCity:GetOriginalOwner() == iPlayer then
					return iCity;
				end
			end
		end
	end
end

function AnyOriginalCityOfPlayer(iPlayer)
	for i, gd in pairs(gT.Players) do
		for iCity in Players[i]:Cities() do
			if iCity:GetOriginalOwner() == iPlayer then
				return iCity;
			end
		end
	end
end

function DoHealNearbyCities(iPlayer, iPlot, dis, healrate)
	for iCity in Players[iPlayer]:Cities() do
		if iCity:GetDamage() > 0 then
			if Map.PlotDistance(iCity:GetX(), iCity:GetY(), iPlot:GetX(), iPlot:GetY()) <= dis then
				HealCityDamage(iCity, healrate)
			end
		end
	end
end

function ITGCityCanWorkDoAction(iCity)
	return (not iCity:IsResistance()) and ((not iCity:IsPlague()) or Players[iCity:GetOwner()]:IsPlagueWorking());
end

function WillITGCityAbleToWorkNextTurn(iCity)
	if (not iCity:IsPlague()) or Players[iCity:GetOwner()]:IsPlagueWorking() then
		if iCity:GetResistanceTurns() < 2 then
			return true;
		end
	end
	return false;
end

function DoAutomaticBombardmentCities(iPlayer)
	if not gT.Players[iPlayer].AutomaticBombardment then
		return;
	end
	local bAnyCity = false;
	for iCity in Players[iPlayer]:Cities() do
		local bAnyAttack = false;
		if iCity:CanRangeStrikeNow() then
			local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
			if gT.Cities[cID].NumAttacks > 0 then
				local bContinue = true;
				local plots = GetPlotsInRadiusOfPlot(iCity:Plot(), iCity:GetCityStrikeRange());
				local iLoopBreak = 0;
				while bContinue and (iLoopBreak < 50) do
					bContinue = false;
					iLoopBreak = iLoopBreak + 1;
					local options = {}
					for a, b in pairs(plots) do
						if iCity:CanRangeStrikeAt(b:GetX(), b:GetY()) then
							if not b:IsFighting() then
								local tUnit = iCity:GetTargetUnitOnPlot(b);
								if tUnit then
									local eval = 100 - tUnit:GetCurrHitPoints();
									if not Players[tUnit:GetOwner()]:IsBarbarian() then
										if Players[tUnit:GetOwner()]:IsMinorCiv() then
											eval = eval + 10;
										else
											eval = eval + 20;
										end
									end
									table.insert(options, {a, eval})
								end
							else
								print("Woah is fighting returned true?")
							end
						end
					end
					if #options > 0 then
						table.sort(options, SortFunctionForGreaterInteger2);
						local tPlot = plots[options[1][1]];
						bAnyAttack = true;
						iCity:DoTask(TaskTypes.TASK_RANGED_ATTACK, tPlot:GetX(), tPlot:GetY())
						if gT.Cities[cID].NumAttacks > 0 then
							bContinue = true;
						end
					end
				end
			end
		end
		if bAnyAttack then
			bAnyCity = true;
			Events.SpecificCityInfoDirty( iPlayer, iCity:GetID(), CityUpdateTypes.CITY_UPDATE_TYPE_BANNER);
		end
	end
	if bAnyCity then
		Players[iPlayer]:UpdateNotifications()
	end
end

function ChangeOccupyLimit(iPlayer, amount)
	if gT.Players[iPlayer].OccupyLimit then
		gT.Players[iPlayer].OccupyLimit = gT.Players[iPlayer].OccupyLimit + amount;
		CityOccupyCountDirty(iPlayer)
	end
end

function CityOccupyCountDirty(iPlayer)
	if not gT.Players[iPlayer] then
		return;
	end
	if gT.Players[iPlayer].OccupyLimit then
		local iCount = 0;
		for iCity in Players[iPlayer]:Cities() do
			if iCity:IsOccupied() then
				iCount = iCount + 1;
			end
		end
		Players[iPlayer]:SetCannotConquerCities(gT.Players[iPlayer].OccupyLimit <= iCount)
	end
end

function CanConquerCitiesRightNow(iPlayer)
	if gT.Players[iPlayer].OccupyLimit then
		local ih = gT.Players[iPlayer].OccupyLimit;
		for iCity in Players[iPlayer]:Cities() do
			if iCity:IsOccupied() then
				ih = ih - 1;
			end
		end
		if ih <= 0 then
			return false;
		end
	end
	return true;
end

function ToolTipOccupyLimit(iPlayer)
	local t = "Your current limit of [ICON_OCCUPIED] occupied Cities: [COLOR_POSITIVE_TEXT]" .. gT.Players[iPlayer].OccupyLimit .. "[ENDCOLOR]."
	local ao = 0;
	for iCity in Players[iPlayer]:Cities() do
		if iCity:IsOccupied() then
			ao = ao + 1;
		end
	end
	if ao > 0 then
		t = t .. "[NEWLINE][NEWLINE]You are currently [ICON_OCCUPIED] occupying [COLOR_NEGATIVE_TEXT]" .. ao .. "[ENDCOLOR] Cities."
	end
	if gT.Players[iPlayer].OccupyLimit > ao then
		t = t .. "[NEWLINE][NEWLINE]You can conquer new City."
	else
		t = t .. "[NEWLINE][NEWLINE]You cannot conquer any new City. Defeating an enemy City will result in plundering it and forcing a peace."
	end
	return t;
end

function GetCityToLegalizeOwnership(g, bCheck)
	for iCity in Players[g]:Cities() do
		local pOrigin = iCity:GetOriginalOwner();
		if pOrigin ~= g then
			if Players[pOrigin]:IsMinorCiv() or (GetNumLegalCities(pOrigin) > 1) then
				if bCheck then
					return true;
				end
				table.insert(valTab, iCity:GetID())
			end
		end
	end
	if #valTab > 0 then
		return RandomFromTab(valTab);
	end
	return nil;
end