function DoStartProtectionOfMinor(iPlayer, minor, fT)
	local gTurn = GetITGGameTurn();
	local maxPledges = math.max(1, gT.Players[iPlayer].NumMaxPledges)
	if maxPledges <= #gT.Players[iPlayer].PledgesOfProtection then
		RemovePledgeOfProtectionByID(iPlayer, 1, "Oldest")
	end
	table.insert(gT.Players[iPlayer].PledgesOfProtection, {minor, fT or GetITGGameTurn(), true})
	ChangePeaceWarLock(iPlayer, minor, 1, "PPledge")
	Game.DoMinorPledgeProtection(iPlayer, minor, true)
	MajorEndedProtectingMinorCSQuestLog(iPlayer, minor, -1)
	if gT.Players[iPlayer].CultBonusOn[31] then
		Players[minor]:ChangeMinorCivExtraAnchorWithMajor(iPlayer, 100)
	end
	TurnOnOffBonusesFromProtectionOfMinor(iPlayer, minor, true)
	if not Players[minor]:IsProtectedByMajor(iPlayer) then
		print("Protection failed", iPlayer, minor, fT)
	end
	if gT.Globals.GameGenerated then
		HnGLogProtectMinor(iPlayer, minor)
	end
end

function TurnOnOffBonusesFromProtectionOfMinor(iPlayer, minor, bAdd)
	if bAdd then
		Players[iPlayer]:ChangeSiphonLuxuryCount(minor, 1)
		Players[minor]:ChangeMinorCivExtraAnchorWithMajor(iPlayer, CS_ANCHOR_FROM_PROTECTION)
	else
		Players[iPlayer]:ChangeSiphonLuxuryCount(minor, -1)
		Players[minor]:ChangeMinorCivExtraAnchorWithMajor(iPlayer, -CS_ANCHOR_FROM_PROTECTION)
	end
	for i, v in pairs(gT.Players[iPlayer].PledgesOfProtection) do
		if v[1] == minor then
			gT.Players[iPlayer].PledgesOfProtection[i][3] = bAdd;
		end
	end
end

function ChangeNumMaxPledgesOfProtection(iPlayer, am)
	gT.Players[iPlayer].NumMaxPledges = gT.Players[iPlayer].NumMaxPledges + am;
	if am < 0 then
		DirtyMaxNumberOfProtection(iPlayer)
	end
end

function DirtyMaxNumberOfProtection(iPlayer)
	local maxPledges = math.max(1, gT.Players[iPlayer].NumMaxPledges)
	if maxPledges < #gT.Players[iPlayer].PledgesOfProtection then
		RemovePledgeOfProtectionByID(iPlayer, 1, "OldestDirty")
	end
end

function RemovePledgeOfProtectionByID(iPlayer, id, sReason, bEndEra)
	local minor = gT.Players[iPlayer].PledgesOfProtection[id][1];
	Game.DoMinorPledgeProtection(iPlayer, minor, false)
	if gT.Players[iPlayer].PledgesOfProtection[id][3] then
		TurnOnOffBonusesFromProtectionOfMinor(iPlayer, minor, false)
	end
	if gT.Players[iPlayer].CultBonusOn[31] then
		Players[minor]:ChangeMinorCivExtraAnchorWithMajor(iPlayer, -100)
	end
	if bEndEra then
		return;
	end
	if sReason == "Oldest" then
		Players[minor]:ChangeMinorCivFriendshipWithMajor(iPlayer, -30)
	end
	ChangePeaceWarLock(iPlayer, minor, -1, "PPledge")
	table.remove(gT.Players[iPlayer].PledgesOfProtection, id)
	local gAlly = Players[minor]:GetAlly();
	if gAlly ~= -1 and gAlly ~= iPlayer then
		if Teams[Players[gAlly]:GetTeam()]:IsAtWar(Players[iPlayer]:GetTeam()) then
			Teams[Players[minor]:GetTeam()]:DeclareWar(iPlayer)
		end
	end
	MajorEndedProtectingMinorCSQuestLog(iPlayer, minor, 1)
end

function RemovePledgeOfProtectionByMinor(iPlayer, minor, sReason)
	for i, v in pairs(gT.Players[iPlayer].PledgesOfProtection) do
		if v[1] == minor then
			RemovePledgeOfProtectionByID(iPlayer, i, sReason)
			return ;
		end
	end
end

function IsITGProtectedByMajor(major, minor)
	for i, v in pairs(gT.Players[major].PledgesOfProtection) do
		if v[1] == minor then
			return true;
		end
	end
	return false;
end

function DoEndAllPledgesOfProtectionOfMinor(iPlayer)
	for i, g in pairs(gT.Players) do
		if not Players[i]:IsMinorCiv() then
			if IsITGProtectedByMajor(i, iPlayer) then
				RemovePledgeOfProtectionByMinor(i, iPlayer, "CSdead")
			end
		end
	end
end

GameEvents.CityLiberated.Add(function(iLiberated, iConqueror, bDomination, iX, iY)
	if Players[iLiberated]:IsMinorCiv() then
		DoLogMinorLiberationForDominationMode(iLiberated, iConqueror, bDomination)
	end
	if gT.Players[iConqueror] then
		local iPlot = Map.GetPlot(iX, iY);
		local index = iPlot:GetPlotIndex();
		if not gT.Players[iConqueror].LiberatedCities[index] then
			gT.Players[iConqueror].LiberatedCities[index] = true;
			if gT.Players[iConqueror].HasIdeology[21] and (not bDomination) then
				ChangeMeritocracy(iConqueror, 20);
			end
			if not Players[iLiberated]:IsMinorCiv() then
				DoAddVoteFromLiberation(iLiberated, iConqueror)
			end
		end
	end
end)