local MissionCityStateTable = {}
local ProjectsCityStateTable = {}
local PoliticsCityStateTable = {}
local RewardMiniCityStateTable = {}
local grelbeleifound9 = GameInfoTypes.BELIEF_ITG_FOUNDER_8;
local betcheuro4 = GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_EUROPE_4;
local techinnoasia3 =GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_ASIA_3;
local wwnewwonder11 = GameInfoTypes.BUILDINGCLASS_ITG_NEW_WORLD_WONDER_11
local arab8tech = GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_ARAB_8;
local ancCStech13 = GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_13
local cCsQAlert = 0;

function GetXXOfMinorCapital(i, xy)
	if Players[i]:GetCapitalCity() then
		if xy == "x" then
			return Players[i]:GetCapitalCity():GetX();
		else
			return Players[i]:GetCapitalCity():GetY();
		end
	end
	return -1;
end

function PrepareCSAlerts(iPlayer)
	cCsQAlert = 0;
	local gTurn = GetITGGameTurn();
	gT.Players[iPlayer].CSAlertQuest = {}
	local hTeam = Players[iPlayer]:GetTeam();
	for g, j in pairs(gT.Players) do
		if Players[g]:IsMinorCiv() then
			for i, data in pairs(gT.Players[g].CityStateQuests) do
				if data.Active then
					if data.EndTurn == gTurn then
						if data.ActivePlayers[iPlayer] then
							local gMinorTeam = Players[g]:GetTeam();
							if not Teams[hTeam]:IsAtWar(gMinorTeam) then
								table.insert(gT.Players[iPlayer].CSAlertQuest, g)
							elseif Teams[hTeam]:CanChangeWarPeace(gMinorTeam) then
								if not Teams[hTeam]:IsPermanentWarPeace(gMinorTeam) then
									if not Players[g]:IsPeaceBlocked(iPlayer) then
										table.insert(gT.Players[iPlayer].CSAlertQuest, g)
									end
								end
							end
						end
					end
				end
			end
		end
	end
end

function GetCSPlotToLookAt(minorP, hTeam)
	for iCity in Players[minorP]:Cities() do
		if iCity:Plot():IsRevealed(hTeam) then
			return iCity:Plot();
		end
	end
end

function AlertCSClicked()
	local iPlayer = Game.GetActivePlayer();
	cCsQAlert = cCsQAlert + 1;
	if #gT.Players[iPlayer].CSAlertQuest < cCsQAlert then
		cCsQAlert = 1;
	end
	local minorP = gT.Players[iPlayer].CSAlertQuest[cCsQAlert]
	local hMessage = Players[minorP]:GetName() .. ": "
	for iQuest, quest in pairs(gT.Players[minorP].CityStateQuests) do
		if quest.Active and quest.ActivePlayers[iPlayer] then
			local iValScale = quest.ActivePlayers[iPlayer].ProjectDonated * ProjectsCityStateTable[quest.Project].Scale;
			if iValScale > 0 then
				hMessage = hMessage .. "[COLOR_POSITIVE_TEXT]" .. iValScale .. "[ENDCOLOR]"
			else
				hMessage = hMessage .. "[COLOR_NEGATIVE_TEXT]" .. iValScale .. "[ENDCOLOR]"
			end
			hMessage = hMessage ..  ProjectsCityStateTable[quest.Project].Icon .. ".";
			break;
		end
	end
	if minorP then
		local gtlp = GetCSPlotToLookAt(minorP, Players[iPlayer]:GetTeam())
		if gtlp then
			UI.LookAt(gtlp)
			Events.GameplayAlertMessage(hMessage)
			return;
		end
		Events.GameplayAlertMessage(hMessage .. "[NEWLINE]No cities found.")
	else
		print("Error 9432523/23432/23")
	end
end
LuaEvents.ITGCallCSQuestAlert.Add(AlertCSClicked)

function GetCityStatePercentage()
	local n = 0;
	for g, gdata in pairs(gT.Players) do
		if Players[g]:IsAlive() then
			if not Players[g]:IsMinorCiv() then
				n = n + 1;
			end
		end
	end
	if n <= 4 then
		return 3;
	elseif n <= 10 then
		return n-1;
	elseif n <= 12 then
		return 10;
	elseif n <= 17 then
		return 11;
	end
	return 12;
end

function UpdateCityStateVariables()
	gT.Globals.BaseCityPercentage = GetCityStatePercentage()
	for g, gdata in pairs(gT.Players) do
		if Players[g]:IsMinorCiv() then
			local pt = Players[g]:GetPersonality();
			if pt == MinorCivPersonalityTypes.MINOR_CIV_PERSONALITY_FRIENDLY then
				Players[g]:SetPercentageOfTotalForFriendship(gT.Globals.BaseCityPercentage - 1)
			elseif pt == MinorCivPersonalityTypes.MINOR_CIV_PERSONALITY_HOSTILE then
				Players[g]:SetPercentageOfTotalForFriendship(gT.Globals.BaseCityPercentage + 1 )
			elseif pt == MinorCivPersonalityTypes.MINOR_CIV_PERSONALITY_NEUTRAL then
				Players[g]:SetPercentageOfTotalForFriendship(gT.Globals.BaseCityPercentage )
			elseif pt == MinorCivPersonalityTypes.MINOR_CIV_PERSONALITY_IRRATIONAL then
				Players[g]:SetPercentageOfTotalForFriendship(gT.Globals.BaseCityPercentage + LastRandom(-1, 1))
			end
		end
	end
end

function CityStateQuestDoTurn(iPlayer)
	local gTurn = GetITGGameTurn();
	for i, data in pairs(gT.Players[iPlayer].CityStateQuests) do
		if data.Active then
			CollectDataForCityStateQuestTurn(iPlayer, i, (data.EndTurn == gTurn))
			if data.EndTurn == gTurn then
				EndCityQuest(iPlayer, i)
				PrepareNewCityQuestData(iPlayer)
			end
			return;
		end
	end
	if gTurn == gT.Players[iPlayer].ForcedNewCSQ then
		PrepareNewCityQuestData(iPlayer)
		return;
	end
	if gTurn <= 15 then
		if gTurn >= 9 then
			if LastRandom(gTurn, 15) == 15 then
				PrepareNewCityQuestData(iPlayer)
			end
		end
	end
	DoSetMinorBullyGoldModifier(iPlayer)
end

function DefeatedCityStateClearData(iPlayer)
	for i, sth in pairs(gT.Players[iPlayer].CityStateQuests) do
		if sth.Active then
			for gPlayer, pdata in pairs(sth.ActivePlayers) do
				local misID = pdata.CSMission.ID;
				gT.Players[gPlayer].CSMissions[misID] = gT.Players[gPlayer].CSMissions[misID] - 1;
			end
		end
		gT.Players[iPlayer].CityStateQuests[i].Active = false;
	end
	gT.Players[iPlayer].ForcedNewCSQ = nil;
	for building, cs in pairs(gT.Globals.CityStateBuildingProcesses) do
		if cs == iPlayer then
			gT.Globals.CityStateBuildingProcesses[building] = nil;
		end
	end
end

function ResurrectCityStateForceCSQ(jPlayer)
	if not gT.Globals.GameGenerated then
		return;
	end
	local gTurn = GetITGGameTurn() + LastRandom(4, 6);
	if gTurn >= 80 then
		return;
	end
	gT.Players[jPlayer].ForcedNewCSQ = gTurn;
end

function GetProperCSProcessFreeBuilding()
	for i = 1, 6 do
		local bid = GameInfoTypes["PROCESS_ITG_CITY_STATE_PROCESS_" .. i];
		if not gT.Globals.CityStateBuildingProcesses[bid] then
			return bid;
		end
	end
	return nil;
end

function PrepareNewCityQuestData(iPlayer)
	local gTurn = GetITGGameTurn();
	if gTurn >= 80 then
		return;
	end
	local newID = #gT.Players[iPlayer].CityStateQuests + 1;
	local data = {EndTurn = gTurn + 20, Active = true, ActivePlayers = {}, Politics = GetRandomPoliticsTypeCityStateQuest(iPlayer), MiniReward = GetMinorCivAdequateMiniReward(iPlayer), Project = GetRandomCityStateProject(), Scale = 1}
	data.Scale = ProjectsCityStateTable[data.Project].Scale;
	local nump = 0;
	for g, gdata in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			if Teams[Players[g]:GetTeam()]:IsHasMet(Players[iPlayer]:GetTeam()) then
				nump = nump + 1;
				data.ActivePlayers[g] = {PoliticsPoints = 0, OtherSourcePoints = 0, ProjectDonated = 0, MissionInitialData = {}, InitInfluence = math.max(0, Players[iPlayer]:GetMinorCivFriendshipWithMajor(g))}
			end
		end
	end
	if nump < 2 then
		return;
	end
	if data.Project == 2 then
		local process = GetProperCSProcessFreeBuilding()
		gT.Globals.CityStateBuildingProcesses[process] = iPlayer;
	end
-- HERE WE should decide about Missions
	local iGlobalMission = GetCSGlobalMission(g);
	if iGlobalMission then
		data.GlobalMission = iGlobalMission;
		local extraGlobalData = MissionCityStateTable[iGlobalMission].ExtraData(iPlayer);
		data.ExtraMissionData = extraGlobalData;
		for g, s in pairs(data.ActivePlayers) do
			data.ActivePlayers[g].CSMission = PrepareCSMissionDataInitial(iPlayer, g, iGlobalMission)
			data.ActivePlayers[g].CSMission.ExtraData = extraGlobalData;
		end
	else
		local prepMisTab = {}
		for i, misData in pairs(MissionCityStateTable) do
			if (not misData.Never) and ((not misData.ScOff) or (not misData.ScOff[gT.Globals.ScenarioType])) then
				table.insert(prepMisTab, i)
			end
		end
		for g, s in pairs(data.ActivePlayers) do
			prepMisTab = Shuffle(prepMisTab);
			for i, missionID in pairs(prepMisTab) do
				if (not MissionCityStateTable[missionID].CanAssign) or MissionCityStateTable[missionID].CanAssign(iPlayer, g) then
					data.ActivePlayers[g].CSMission = PrepareCSMissionDataInitial(iPlayer, g, missionID)
					break;
				end
			end
			if not data.ActivePlayers[g].CSMission then
				data.ActivePlayers[g].CSMission = PrepareCSMissionDataInitial(iPlayer, g, 11)
			end
		end
	end
--
	table.insert(gT.Players[iPlayer].CityStateQuests, data)
	if PoliticsCityStateTable[gT.Players[iPlayer].CityStateQuests[newID].Politics.ID].OnAddedFunc then
		PoliticsCityStateTable[gT.Players[iPlayer].CityStateQuests[newID].Politics.ID].OnAddedFunc(iPlayer, newID)
	end
	for i, gActive in pairs(gT.Globals.HumanPlayers) do
		if data.ActivePlayers[gActive] then
			--notification
			local sTextShort = PrepareNotificationTextForNewCityStateQuest(iPlayer, newID, gActive, true);
			Players[gActive]:AddNotification(NotificationTypes.NOTIFICATION_MINOR, sTextShort, "New City-State Politics", GetXXOfMinorCapital(iPlayer, "x"), GetXXOfMinorCapital(iPlayer, "y"))
		end
	end
end

function BasicCSNotification(iPlayer, cs, sTitle, sText)
	Players[iPlayer]:AddNotification(NotificationTypes.NOTIFICATION_MINOR, sText, sTitle, GetXXOfMinorCapital(cs, "x"), GetXXOfMinorCapital(cs, "y"))
end

function GetCSGlobalMission(g)
	local vTab = {}
	for i, misData in pairs(MissionCityStateTable) do
		if (misData.Global) and ((not misData.ScOff) or (not misData.ScOff[gT.Globals.ScenarioType])) then
			if LastRandom(1, 100) <= misData.Chance then
				table.insert(vTab, i);
			end
		end
	end
	if #vTab > 0 then
		return vTab[LastRandom(1,#vTab)];
	end
	return nil
end

function PrepareIconTextForNewCityStaateQuest(cs, g, d)
	return PoliticsCityStateTable[gT.Players[cs].CityStateQuests[d].Politics.ID].Icon .. MissionCityStateTable[gT.Players[cs].CityStateQuests[d].ActivePlayers[g].CSMission.ID].Icon .. ProjectsCityStateTable[gT.Players[cs].CityStateQuests[d].Project].Icon;
end

function PrepareNotificationTextForNewCityStateQuest(cs, d, gActive, bShort)
	local sText = "Citizens of " .. Players[cs]:GetName() .. " have formulated the new virtues they seek in major civilizations for the next 20 Turns (ends in " .. gT.Players[cs].CityStateQuests[d].EndTurn .. " turn):";
	if bShort then
		local pName;
		if PoliticsCityStateTable[gT.Players[cs].CityStateQuests[d].Politics.ID].FuncName then
			pName = PoliticsCityStateTable[gT.Players[cs].CityStateQuests[d].Politics.ID].FuncName(cs, d);
		else
			pName = PoliticsCityStateTable[gT.Players[cs].CityStateQuests[d].Politics.ID].Name;
		end
		local mName;
		if MissionCityStateTable[gT.Players[cs].CityStateQuests[d].ActivePlayers[gActive].CSMission.ID].FuncName then
			mName = MissionCityStateTable[gT.Players[cs].CityStateQuests[d].ActivePlayers[gActive].CSMission.ID].FuncName(cs, d, gActive);
		else
			mName = MissionCityStateTable[gT.Players[cs].CityStateQuests[d].ActivePlayers[gActive].CSMission.ID].Name;
		end
		sText = sText .. "[NEWLINE][ICON_BULLET]Politics: " .. PoliticsCityStateTable[gT.Players[cs].CityStateQuests[d].Politics.ID].Icon .. " " ..  pName;
		sText = sText .. "[NEWLINE][ICON_BULLET]Mission: " .. MissionCityStateTable[gT.Players[cs].CityStateQuests[d].ActivePlayers[gActive].CSMission.ID].Icon .. " " .. mName;
		sText = sText .. "[NEWLINE][ICON_BULLET]Project: " .. ProjectsCityStateTable[gT.Players[cs].CityStateQuests[d].Project].Icon .. " " .. ProjectsCityStateTable[gT.Players[cs].CityStateQuests[d].Project].Name;
	else
		local pText;
		if PoliticsCityStateTable[gT.Players[cs].CityStateQuests[d].Politics.ID].FuncText then
			pText = PoliticsCityStateTable[gT.Players[cs].CityStateQuests[d].Politics.ID].FuncText(cs, d)
		else
			pText = PoliticsCityStateTable[gT.Players[cs].CityStateQuests[d].Politics.ID].Text
		end
		local mText;
		if MissionCityStateTable[gT.Players[cs].CityStateQuests[d].ActivePlayers[gActive].CSMission.ID].FuncText then
			mText = MissionCityStateTable[gT.Players[cs].CityStateQuests[d].ActivePlayers[gActive].CSMission.ID].FuncText(cs, d, gActive)
		else
			mText = MissionCityStateTable[gT.Players[cs].CityStateQuests[d].ActivePlayers[gActive].CSMission.ID].Text
		end
		if gT.Players[cs].CityStateQuests[d].ActivePlayers[gActive].CSMission.Failed then
			mText = mText .. " ([COLOR_NEGATIVE_TEXT]Failed[ENDCOLOR])"
		elseif gT.Players[cs].CityStateQuests[d].ActivePlayers[gActive].CSMission.Completed then
			mText = mText .. " ([COLOR_POSITIVE_TEXT]Completed[ENDCOLOR])"
		elseif gT.Players[cs].CityStateQuests[d].ActivePlayers[gActive].CSMission.Left then
			local reallyLeft = math.max(0, gT.Players[cs].CityStateQuests[d].ActivePlayers[gActive].CSMission.Left - (gT.Players[cs].CityStateQuests[d].ActivePlayers[gActive].CSMission.Count or 0));
			mText = mText .. " ([COLOR_POSITIVE_TEXT]" .. reallyLeft .. " remaining[ENDCOLOR])"
		elseif MissionCityStateTable[gT.Players[cs].CityStateQuests[d].ActivePlayers[gActive].CSMission.ID].SpecialLeft then
			mText = mText .. " ([COLOR_POSITIVE_TEXT]" .. MissionCityStateTable[gT.Players[cs].CityStateQuests[d].ActivePlayers[gActive].CSMission.ID].SpecialLeft(cs, d, gActive) .. " remaining[ENDCOLOR])"
		end
		sText = sText .. "[NEWLINE][ICON_BULLET]Politics: " .. pText .. " (Reward: Up to " .. CS_QUEST_POLITICS_POINTS .. " points)"
		sText = sText .. "[NEWLINE][ICON_BULLET]Mission: " .. mText .. " (Reward: Up to " .. CS_QUEST_MISSION_POINTS .. " points)"
		sText = sText .. "[NEWLINE][ICON_BULLET]Project: " .. ProjectsCityStateTable[gT.Players[cs].CityStateQuests[d].Project].Text .. " (Reward: Up to " .. CS_QUEST_PROJECT_POINTS .. " points)"
		sText = sText .. "[NEWLINE][ICON_BULLET]Favour: [ICON_CITY_STATE] As always they seek for you to increase your [ICON_INFLUENCE] Influence with them. (Reward: Up to " .. CS_QUEST_INFLUENCE_POINTS .. " points)"
		sText = sText .. "[NEWLINE][ICON_BULLET]Other: You can also acquire points from other sources (ex. Espionage)."
		sText = sText .. "[NEWLINE][NEWLINE]They will reward major civilizations with:"
		sText = sText .. "[NEWLINE][ICON_TROPHY_GOLD] Resting point for [ICON_INFLUENCE] Influence level is increased by " .. CS_QUEST_EXTRA_ANCHOR .. ". (The greatest competitor)"
		sText = sText .. "[NEWLINE][ICON_TROPHY_SILVER] +" .. CS_QUEST_REWARD_INFLUENCE .. " [ICON_INFLUENCE] Influence. (At least " .. GetMinBonusRewardCSQ(Game.GetActivePlayer()) * 2 .. " points)"
		sText = sText .. "[NEWLINE][ICON_TROPHY_BRONZE] " .. RewardMiniCityStateTable[gT.Players[cs].CityStateQuests[d].MiniReward].Text  .. " (At least " .. GetMinBonusRewardCSQ(Game.GetActivePlayer()) .. " points)"
	end	
	return sText;
end

LuaEvents.ITGSG_RequestCityStateQuestData.Add(function(minorID)
	local gActive = Game.GetActivePlayer();
	local tab = {};
	for i, csdata in pairs(gT.Players[minorID].CityStateQuests) do
		if csdata.Active then
			if csdata.ActivePlayers[gActive] then
				tab.OngoingQuest = PrepareNotificationTextForNewCityStateQuest(minorID, i, gActive);
				tab.OngoingQuestIcon = PrepareIconTextForNewCityStaateQuest(minorID, gActive, i)
			end
		end
	end
	if gT.Players[minorID].CSQuestHelpTextOnEnd and gT.Players[minorID].CSQuestHelpTextOnEnd[gActive] then
		tab.PreviousQuest = "Previous politics ended at turn " .. gT.Players[minorID].CSQuestHelpTextOnEnd[gActive].EndTurn .. ".[NEWLINE][NEWLINE]" .. PrepareEndCSQuestNotificationText(minorID, gActive)
	end
	MapModData.ITGSG = tab; 
end)

function GetMinBonusRewardCSQ(iPlayer)
	local base = 50;
	if HasPlayerTech(iPlayer, arab8tech, "Ywvwerqwr") then
		base = base - 10;
	end
	return base;
end

function GetMinorCivAdequateMiniReward(cs)
	local type = Players[cs]:GetMinorCivTrait();
	local tab = {};
	for i, v in pairs(RewardMiniCityStateTable) do
		if (not v.ScOff) or (not v.ScOff[gT.Globals.ScenarioType]) then
			table.insert(tab, i)
			if v.PrefTrait and v.PrefTrait[type] then
				table.insert(tab, i)
			end
		end
	end
	return tab[LastRandom(1,#tab)];
end

function CollectDataForCityStateQuestTurn(iPlayer, iQuest, bFinish)
	local bProdProject = bFinish and (gT.Players[iPlayer].CityStateQuests[iQuest].Project == 2);
	local iProdBuilding; --only last turn we artificially add prod from "next" turn
	if bProdProject then
		for iBuilding, cs in pairs(gT.Globals.CityStateBuildingProcesses) do
			if cs == iPlayer then
				iProdBuilding = iBuilding;
			end
		end
	end
	local pTeam = Teams[Players[iPlayer]:GetTeam()];
	for gPlayer, pdata in pairs(gT.Players[iPlayer].CityStateQuests[iQuest].ActivePlayers) do
		if (not pTeam:IsAtWar(Players[gPlayer]:GetTeam())) and (not gT.Players[gPlayer].IsConsideredBarbarian) then
		--spy
		--politics
			for i, data in pairs(gT.Players[gPlayer].Agents) do
				if (not data.Rekonwalescencja) and (not data.IgnoreItForever) then
					if data.Mission == 7 then
						if data.TargetPlayer == iPlayer then
							gT.Players[iPlayer].CityStateQuests[iQuest].ActivePlayers[gPlayer].OtherSourcePoints = gT.Players[iPlayer].CityStateQuests[iQuest].ActivePlayers[gPlayer].OtherSourcePoints + 0.25 + 0.25 * data.Rank;
						end
					end
				end
			end
			if IsPlayerHaveBelief(gPlayer, grelbeleifound9) then
				local cc = Players[iPlayer]:GetCapitalCity();
				if cc and cc:GetReligiousMajority() == Players[gPlayer]:GetReligionCreatedByPlayer() then
					gT.Players[iPlayer].CityStateQuests[iQuest].ActivePlayers[gPlayer].OtherSourcePoints = gT.Players[iPlayer].CityStateQuests[iQuest].ActivePlayers[gPlayer].OtherSourcePoints + 2;
				end
			end
			if Players[gPlayer]:GetBuildingClassCount(wwnewwonder11) > 0 then
				gT.Players[iPlayer].CityStateQuests[iQuest].ActivePlayers[gPlayer].OtherSourcePoints = gT.Players[iPlayer].CityStateQuests[iQuest].ActivePlayers[gPlayer].OtherSourcePoints + 1;
			end
			gT.Players[iPlayer].CityStateQuests[iQuest].ActivePlayers[gPlayer].PoliticsPoints = gT.Players[iPlayer].CityStateQuests[iQuest].ActivePlayers[gPlayer].PoliticsPoints + PoliticsCityStateTable[gT.Players[iPlayer].CityStateQuests[iQuest].Politics.ID].GetTurnPoints(iPlayer, iQuest, gPlayer)
			if bProdProject then
				local boost = 0;
				for iCity in Players[gPlayer]:Cities() do
					if iCity:GetProductionProcess() == iProdBuilding then
						if WillITGCityAbleToWorkNextTurn(iCity) then
							boost = boost + iCity:GetCurrentProductionDifferenceTimes100(false, false) / 100;
						end
						iCity:PopOrder(0, 1, 1)
					end
				end
				gT.Players[gPlayer].HelpCSGiftsLog[2] = gT.Players[gPlayer].HelpCSGiftsLog[2] + boost;
				gT.Players[iPlayer].CityStateQuests[iQuest].ActivePlayers[gPlayer].ProjectDonated = gT.Players[iPlayer].CityStateQuests[iQuest].ActivePlayers[gPlayer].ProjectDonated + boost;
			end
		end
	end
end

function AddContributionToProjectCS(iPlayer, cs, value)
	--help logs limited to here and there :)
	for iQuest, quest in pairs(gT.Players[cs].CityStateQuests) do
		if quest.Active and quest.ActivePlayers[iPlayer] then
			if quest.ActivePlayers[iPlayer] then
				gT.Players[cs].CityStateQuests[iQuest].ActivePlayers[iPlayer].ProjectDonated = gT.Players[cs].CityStateQuests[iQuest].ActivePlayers[iPlayer].ProjectDonated + value;
				if quest.Project == 1 then
					gT.Players[iPlayer].HelpCSGiftsLog[quest.Project] = gT.Players[iPlayer].HelpCSGiftsLog[quest.Project] + value;
					SpendITGScience(iPlayer, value)
				elseif quest.Project == 3 then
					gT.Players[iPlayer].HelpCSGiftsLog[quest.Project] = gT.Players[iPlayer].HelpCSGiftsLog[quest.Project] + value;
					SpendITGLegalPowerPercent(iPlayer, value, nil, "AI Project")
				elseif quest.Project == 4 then
					gT.Players[iPlayer].HelpCSGiftsLog[quest.Project] = gT.Players[iPlayer].HelpCSGiftsLog[quest.Project] + value;
					SpendITGFaith(iPlayer, value)
				elseif quest.Project == 5 then
					gT.Players[iPlayer].HelpCSGiftsLog[quest.Project] = gT.Players[iPlayer].HelpCSGiftsLog[quest.Project] + value;
					SpendITGCulture(iPlayer, value)
				elseif quest.Project == 6 then
					gT.Players[iPlayer].HelpCSGiftsLog[quest.Project] = gT.Players[iPlayer].HelpCSGiftsLog[quest.Project] + value;
					SpendITGGreatAdmiral(iPlayer, value)
				elseif quest.Project == 7 then
					gT.Players[iPlayer].HelpCSGiftsLog[quest.Project] = gT.Players[iPlayer].HelpCSGiftsLog[quest.Project] + value;
					SpendITGGreatGeneral(iPlayer, value)
				elseif quest.Project == 8 then
					gT.Players[iPlayer].HelpCSGiftsLog[quest.Project] = gT.Players[iPlayer].HelpCSGiftsLog[quest.Project] + value / 5;
					if gT.Players[iPlayer].SettlerGenerationPoints < (value / 5) then
						print("Error, hee 1231245", value / 5, iPlayer, gT.Players[iPlayer].SettlerGenerationPoints)
					end
					SpendITGSettlerGenPoints(iPlayer, value / 5)
				elseif quest.Project == 9 then
					gT.Players[iPlayer].HelpCSGiftsLog[quest.Project] = gT.Players[iPlayer].HelpCSGiftsLog[quest.Project] + 5 * value;
					SpendITGWorkRateEmpireWide(iPlayer, 5 * value)
				end
			else
				print("UBer great bug 1241521: " .. iPlayer);
			end
		end
	end
end

local iWonderMed4 = GameInfoTypes.BUILDING_ITG_NEW_MEDIEVAL_WONDER_4
function GetPlayerInfluenceModFromPolitics(gPlayer, iPlayer)
	local mod = 1;
	local extra = 10 * (gT.Players[gPlayer].WonderRuinsEffects[2] or 0)
	if gT.Players[gPlayer].GovRewards[35] then
		extra = extra + math.floor(gT.Players[gPlayer].NatUnity / 4);
	end
	if gT.Players[gPlayer].HasPlayerWonder[iWonderMed4] then
		local cc = Players[iPlayer]:GetCapitalCity();
		if cc then
			local iRel = cc:GetReligiousMajority();
			if iRel > 0 then
				if iRel == Map.GetPlotByIndex(gT.Globals.AzharWpi):GetPlotCity():GetReligiousMajority() then
					mod = mod + 1
				end
			end
		end
	end
	return math.floor(CS_QUEST_REWARD_INFLUENCE * mod + extra);
end


function EndCityQuest(iPlayer, iQuest)
	local totPlayerTable = {}
	gT.Players[iPlayer].CityStateQuests[iQuest].Active = false;
	for building, cs in pairs(gT.Globals.CityStateBuildingProcesses) do
		if cs == iPlayer then
			gT.Globals.CityStateBuildingProcesses[building] = nil;
			for gPlayer, pdata in pairs(gT.Players) do
				gT.Players[gPlayer].AILogicForCSProductionProject[building] = nil;
			end
		end
	end
	for gPlayer, pdata in pairs(gT.Players[iPlayer].CityStateQuests[iQuest].ActivePlayers) do
		local eTurnOtherSource = 0;
		if gT.Players[gPlayer].CultBonusOn[100] then
			eTurnOtherSource = eTurnOtherSource + 6;
		end
		for gpID, hhh in pairs(gT.Players[gPlayer].GreatPeople) do
			local gd = gT.GreatPeople[gpID];
			if gd.Alive and (not gd.Military) then
				if gd.Ability == 5 then
					eTurnOtherSource = eTurnOtherSource + 5;
				end
			end
		end
		if HasPlayerTech(gPlayer, ancCStech13, "43f34fdaa") then
			eTurnOtherSource = eTurnOtherSource + 10;
		end
		totPlayerTable[gPlayer] = pdata.OtherSourcePoints + eTurnOtherSource;
		gT.Players[iPlayer].CityStateQuests[iQuest].ActivePlayers[gPlayer].OtherSourcePoints = totPlayerTable[gPlayer];
	end
	local prepPointsFromPolitics = PreparePointFromPoliticsCS(iPlayer, iQuest);
	local prepPointsFromProject = PreparePointFromProjectCS(iPlayer, iQuest);
	local prepPointsFromMission = PreparePointFromMissionCS(iPlayer, iQuest);
	local prepPointsFromFavour = PreparePointFromFavourCS(iPlayer, iQuest);
	for gPlayer, points in pairs(totPlayerTable) do
		totPlayerTable[gPlayer] = totPlayerTable[gPlayer] + prepPointsFromPolitics[gPlayer] + prepPointsFromProject[gPlayer] + prepPointsFromMission[gPlayer] + prepPointsFromFavour[gPlayer];
	end
	local bestAuthorityP, bAuthority = nil, -1;
	for gPlayer, points in pairs(totPlayerTable) do
		if gT.Players[gPlayer].Authority > bAuthority then
			bAuthority = gT.Players[gPlayer].Authority
			bestAuthorityP = gPlayer;
		elseif gT.Players[gPlayer].Authority == bAuthority then
			bestAuthorityP = nil;
		end
	end
	if bestAuthorityP then
		totPlayerTable[bestAuthorityP] = totPlayerTable[bestAuthorityP] + CS_POLITICS_FROM_AUTHORITY;
	end
	local cultOwnerP = GetCulturalOwnerOfCS(iPlayer)
	if totPlayerTable[cultOwnerP] then
		totPlayerTable[cultOwnerP] = totPlayerTable[cultOwnerP] + CS_POLITICS_FROM_CULT_OWNER;
	end
	--Here we are cutting with domination mode
	if ShouldTriggerDominationModeCSQuest(iPlayer) then
		DoResolveCSQuestForDomination(iPlayer, totPlayerTable, iQuest, bestAuthorityP, prepPointsFromPolitics, prepPointsFromProject, prepPointsFromMission, prepPointsFromFavour)
		return;
	end
	local max = 1;
	for gPlayer, points in pairs(totPlayerTable) do
		max = math.max(max, points);
	end
	--rewards here
	local extrastring = ""
	local bForceNextSamePolitic = false;
	local cAllyPlayer = Players[iPlayer]:GetAlly()
	local influenceToBoost = {}
	local bPlayerForNot;
	gT.Players[iPlayer].NumCSPoliticsSolved = (gT.Players[iPlayer].NumCSPoliticsSolved or 0) + 1;
	if not gT.Players[iPlayer].CSPoliticsWinnerLog then
		gT.Players[iPlayer].CSPoliticsWinnerLog = {}
	end
	for gPlayer, points in pairs(totPlayerTable) do
		local bAny = false;
		if points == max then
			if not gT.PoliticVictories[iPlayer] then
				gT.PoliticVictories[iPlayer] = {}
			end
			if not gT.PoliticVictories[iPlayer][gPlayer] then
				gT.PoliticVictories[iPlayer][gPlayer] = 0;
			end
			Players[iPlayer]:ChangeMinorCivExtraAnchorWithMajor(gPlayer, CS_QUEST_EXTRA_ANCHOR)
			VictoryTaskCompletion(gPlayer, 33)
			gT.PoliticVictories[iPlayer][gPlayer] = gT.PoliticVictories[iPlayer][gPlayer] + CS_QUEST_EXTRA_ANCHOR;
			gT.Players[gPlayer].NumWonCityQuests = gT.Players[gPlayer].NumWonCityQuests + 1;
			table.insert(gT.Players[iPlayer].CSPoliticsWinnerLog, gPlayer)
			bAny = true;
			if HasPlayerTech(gPlayer, betcheuro4, "235fcf234234") then
				bForceNextSamePolitic = true;
			end
			if Players[gPlayer]:IsHuman() then
				LuaEvents.ITG_AchievementCountChange(88, 1)
			end
			bPlayerForNot = gPlayer;
		end
		if points >= GetMinBonusRewardCSQ(gPlayer) then
			bAny = true;
			local cRt = gT.Players[iPlayer].CityStateQuests[iQuest].MiniReward ;
			if cRt == 1 then
				ChangeITGCulture(gPlayer, 50)
			elseif cRt == 2 then
				for iCity in Players[gPlayer]:Cities() do
					ChangeITGHappinessInTheCity(iCity, 1, nil, "kovokdwe")
				end
			elseif cRt == 3 then
				ChangeITGScience(gPlayer, 50)
			elseif cRt == 4 then
				ChangeITGFaith(gPlayer, 50)
			elseif cRt == 5 then
				ChangeExtraSupply(gPlayer, 1)
			elseif cRt == 6 then
				gT.Players[gPlayer].SpecialUUTresholdRed = gT.Players[gPlayer].SpecialUUTresholdRed - 40;
			elseif cRt == 7 then
				ChangeITGLegalPointsPercent(gPlayer, 50)
			elseif cRt == 8 then
				local cc = Players[gPlayer]:GetCapitalCity();
				if cc then
					cc:ChangeFood(50)
				end
			elseif cRt == 9 then
				CreateGreatWorkOfAmount(gPlayer, 1)
			elseif cRt == 10 then
				BoostArtisticPoints(gPlayer, 50)
			elseif cRt == 11 then
				IncreaseWorkRateInAllCities(gPlayer, 100)
			elseif cRt == 12 then
				ChangeITGGreatPeopleCivilPoints(gPlayer, 75, nil, iPlayer)
			elseif cRt == 13 then
				AddToMoraleQueueLog(gPlayer, 4, "City-State assistance")
			elseif cRt == 14 then
				gT.Players[gPlayer].FestivalVarious = gT.Players[gPlayer].FestivalVarious + 6;
			elseif cRt == 15 then
				for nthCity in Players[gPlayer]:Cities() do
					DoITGCityAcquirePlot(nthCity)
				end
			elseif cRt == 16 then
				ChangeITGExtraResources(gPlayer, rOil, 1)
			elseif cRt == 17 then
				ChangeITGExtraResources(gPlayer, rIron, 1)
			elseif cRt == 18 then
				ChangeITGExtraResources(gPlayer, rHorse, 1)
			elseif cRt == 19 then
				for nthCity in Players[iPlayer]:Cities() do
					DoChangeCityCultureOwnership(nthCity:Plot():GetPlotIndex() .. "," .. nthCity:GetGameTurnFounded(), nthCity, gPlayer, 100, "CSquest")
				end
			elseif cRt == 20 then
				DoStoreResource(gPlayer, rIron, 15)
				DoStoreResource(gPlayer, rHorse, 15);
			elseif cRt == 21 then
				ChangeMeritocracy(gPlayer, 8);
			end
			if points >= 2 * GetMinBonusRewardCSQ(gPlayer) then
				table.insert(influenceToBoost, {gPlayer, Players[iPlayer]:GetMinorCivFriendshipWithMajor(gPlayer)})
			end
		end
		if not bAny then
			if HasPlayerTech(gPlayer, techinnoasia3, "Vdqweqweqwr") then
				ChangeITGLegalPointsPercent(gPlayer, 50)
				if gPlayer == Game.GetActivePlayer() then
					extrastring = extrastring .. "[NEWLINE]Yet your [ICON_ITG_LEGAL_POWER] Legal Power increases by 0.5 from Shogunate."
				end
			end
		end
	end
	if bForceNextSamePolitic then
		gT.Players[iPlayer].CityStateForcedNextPolitic = gT.Players[iPlayer].CityStateQuests[iQuest].Politics.ID;
	end
	for i, gActive in pairs(gT.Globals.HumanPlayers) do
		if totPlayerTable[gActive] then
			--notification
			if not gT.Players[iPlayer].CSQuestHelpTextOnEnd then
				gT.Players[iPlayer].CSQuestHelpTextOnEnd = {}
			end
			if totPlayerTable[gActive] == max then
				if math.floor(totPlayerTable[gActive]) < 100 then
					LuaEvents.ITG_AchievementCompleted(36)
				end
			end
			gT.Players[iPlayer].CSQuestHelpTextOnEnd[gActive] = {BestPlayer = bPlayerForNot, EndTurn = GetITGGameTurn(), BestScore = max, Max = (totPlayerTable[gActive] == max), Authority = (bestAuthorityP == gActive), COwner = (cultOwnerP == gActive), QuestID = iQuest, TotalPoints = math.floor(totPlayerTable[gActive]), PoliticsP = prepPointsFromPolitics[gActive], MissionP = prepPointsFromMission[gActive], ProjectP = prepPointsFromProject[gActive], InfluenceP = prepPointsFromFavour[gActive]};
			local notifyText = PrepareEndCSQuestNotificationText(iPlayer, gActive) 
			if gActive == Game.GetActivePlayer() then
				notifyText = notifyText .. extrastring; -- extra string is unimportant enough for hotseat/future
			end
			Players[gActive]:AddNotification(51646434, notifyText, "City-State Politics Ended", GetXXOfMinorCapital(iPlayer, "x"), GetXXOfMinorCapital(iPlayer, "y"), IfKnownOr(gActive, bPlayerForNot, -1))
		end
	end
	table.sort(influenceToBoost, SortFunctionForGreaterInteger2)
	for it, gdg in pairs(influenceToBoost) do
		Players[iPlayer]:ChangeMinorCivFriendshipWithMajor(gdg[1], GetPlayerInfluenceModFromPolitics(gdg[1], iPlayer));
	end
end

function PrepareEndCSQuestNotificationText(iPlayer, gActive)
	local iQuest = gT.Players[iPlayer].CSQuestHelpTextOnEnd[gActive].QuestID;
	local totPoints = gT.Players[iPlayer].CSQuestHelpTextOnEnd[gActive].TotalPoints;
	local bPlayerForNot = gT.Players[iPlayer].CSQuestHelpTextOnEnd[gActive].BestPlayer;
	local sText = "Political movement in " .. Players[iPlayer]:GetName() .. " has ended, you have earned [COLOR_POSITIVE_TEXT]" .. totPoints .. "[ENDCOLOR] points:";
	local pName = GetNameOfPoliticsQuestCS(iPlayer, iQuest);
	local mName = GetNameOfMissionQuestCS(iPlayer, iQuest, gActive);
	sText = sText .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]" .. gT.Players[iPlayer].CSQuestHelpTextOnEnd[gActive].PoliticsP .. "[ENDCOLOR] for " .. PoliticsCityStateTable[gT.Players[iPlayer].CityStateQuests[iQuest].Politics.ID].Icon .. " " .. pName .. "."
	sText = sText .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]" .. gT.Players[iPlayer].CSQuestHelpTextOnEnd[gActive].MissionP .. "[ENDCOLOR] for " .. MissionCityStateTable[gT.Players[iPlayer].CityStateQuests[iQuest].ActivePlayers[gActive].CSMission.ID].Icon .. " " .. mName .. "."
	sText = sText .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]" .. gT.Players[iPlayer].CSQuestHelpTextOnEnd[gActive].ProjectP .. "[ENDCOLOR] for " .. ProjectsCityStateTable[gT.Players[iPlayer].CityStateQuests[iQuest].Project].Icon .. " " .. ProjectsCityStateTable[gT.Players[iPlayer].CityStateQuests[iQuest].Project].Name .. "."
	sText = sText .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]" .. gT.Players[iPlayer].CSQuestHelpTextOnEnd[gActive].InfluenceP .. "[ENDCOLOR] for recent [ICON_INFLUENCE] Influence increment."
	if gT.Players[iPlayer].CSQuestHelpTextOnEnd[gActive].Authority then
		sText = sText .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]" .. CS_POLITICS_FROM_AUTHORITY .. "[ENDCOLOR] for highest known [ICON_ITG_AUTHORITY] Authority."
	end
	if gT.Players[iPlayer].CSQuestHelpTextOnEnd[gActive].COwner then
		sText = sText .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]" .. CS_POLITICS_FROM_CULT_OWNER .. "[ENDCOLOR] for [ICON_ITG_PRESENCE] cultural Ownership."
	end
	sText = sText .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]" .. gT.Players[iPlayer].CityStateQuests[iQuest].ActivePlayers[gActive].OtherSourcePoints .. "[ENDCOLOR] from other sources."
	if gT.Players[iPlayer].CSQuestHelpTextOnEnd[gActive].LeagueLike then
		if gT.Players[iPlayer].CSQuestHelpTextOnEnd[gActive].PlayerLeagueName ~= "" then
			if gT.Players[iPlayer].CSQuestHelpTextOnEnd[gActive].LeagueWon then
				sText = sText .. "[NEWLINE][NEWLINE]Entire " .. gT.Players[iPlayer].CSQuestHelpTextOnEnd[gActive].PlayerLeagueName .. " has impressed " .. Players[iPlayer]:GetName() .. " enough for them to join our case! (" .. gT.Players[iPlayer].CSQuestHelpTextOnEnd[gActive].PLeagueScore .. " points)"
			else
				sText = sText .. "[NEWLINE][NEWLINE]" .. Players[iPlayer]:GetName() .. " decided to join " .. gT.Players[iPlayer].CSQuestHelpTextOnEnd[gActive].LeagueWinName .. " (" .. gT.Players[iPlayer].CSQuestHelpTextOnEnd[gActive].WinLeagueScore .. " points)! Our " .. gT.Players[iPlayer].CSQuestHelpTextOnEnd[gActive].PlayerLeagueName .. " has earned only " .. gT.Players[iPlayer].CSQuestHelpTextOnEnd[gActive].PLeagueScore  .. " points of reputation."
			end
		else
			sText = sText .. "[NEWLINE][NEWLINE]Unfortunately your input was ignored because you do not follow any ideology."
		end
		return sText;
	end
	if totPoints >= GetMinBonusRewardCSQ(gActive) or gT.Players[iPlayer].CSQuestHelpTextOnEnd[gActive].Max then
		sText = sText .. "[NEWLINE][NEWLINE]Rewards:"
		if gT.Players[iPlayer].CSQuestHelpTextOnEnd[gActive].Max then
			sText = sText .. "[NEWLINE][ICON_TROPHY_GOLD] +" .. CS_QUEST_EXTRA_ANCHOR .. " to [ICON_INFLUENCE] Influence resting point." 
		end
		if totPoints >= GetMinBonusRewardCSQ(gActive) * 2 then
			sText = sText .. "[NEWLINE][ICON_TROPHY_SILVER] +" .. GetPlayerInfluenceModFromPolitics(gActive, iPlayer) .. " [ICON_INFLUENCE] Influence."
		end
		if totPoints >= GetMinBonusRewardCSQ(gActive) then
			sText = sText .. "[NEWLINE][ICON_TROPHY_BRONZE] " .. RewardMiniCityStateTable[gT.Players[iPlayer].CityStateQuests[iQuest].MiniReward].Text;
		end
	else
		sText = sText .. "[NEWLINE][NEWLINE]For your minor input you were not rewarded with anything."
	end
	if not gT.Players[iPlayer].CSQuestHelpTextOnEnd[gActive].Max then
		if bPlayerForNot then
			sText = sText .. "[NEWLINE][NEWLINE]" .. GetNameOrUnknown(bPlayerForNot, Players[gActive]:GetTeam(), "Uknown Civilization") .. " reached best score: [COLOR_POSITIVE_TEXT]" .. gT.Players[iPlayer].CSQuestHelpTextOnEnd[gActive].BestScore .. "[ENDCOLOR]."
		end
	end
	return sText;
end

function PreparePointFromFavourCS(iPlayer, iQuest)
	local tHt = {}
	local max = 1;
	for gPlayer, pdata in pairs(gT.Players[iPlayer].CityStateQuests[iQuest].ActivePlayers) do
		tHt[gPlayer] = math.max(0, Players[iPlayer]:GetMinorCivFriendshipWithMajor(gPlayer) - pdata.InitInfluence)
		if tHt[gPlayer] > max then
			max = tHt[gPlayer];
		end
	end
	for gPlayer, points in pairs(tHt) do
		tHt[gPlayer] = math.floor(CS_QUEST_INFLUENCE_POINTS * points / max);
	end
	return tHt;	
end

function PreparePointFromProjectCS(iPlayer, iQuest)
	local tHt = {}
	local max = 1;
	local pid = gT.Players[iPlayer].CityStateQuests[iQuest].Project;
	if not gT.DiagnosisAICSpro[pid] then
		gT.DiagnosisAICSpro[pid] = {Count = 0, Inputs = {}, HPrs = {}, MaxInputs = {}}
	end
	gT.DiagnosisAICSpro[pid].Count = gT.DiagnosisAICSpro[pid].Count + 1;
	local cPr = 0;
	for gPlayer, pdata in pairs(gT.Players[iPlayer].CityStateQuests[iQuest].ActivePlayers) do
		tHt[gPlayer] = math.floor(100 * pdata.ProjectDonated);
		max = math.max(max, tHt[gPlayer]);
		cPr = cPr + 1;
		table.insert(gT.DiagnosisAICSpro[pid].Inputs, tHt[gPlayer])
	end
	table.insert(gT.DiagnosisAICSpro[pid].HPrs, cPr)
	table.insert(gT.DiagnosisAICSpro[pid].MaxInputs, max)
	for gPlayer, points in pairs(tHt) do
		tHt[gPlayer] =  math.floor(CS_QUEST_PROJECT_POINTS * points / max);
	end
	return tHt;
end

function PreparePointFromPoliticsCS(iPlayer, iQuest)
	local tHt = {}
	local hMin = 0;
	local pid = gT.Players[iPlayer].CityStateQuests[iQuest].Politics.ID;
	local hMax = PoliticsCityStateTable[pid].EndBasicMax or 1;
	if not gT.DiagnosisAICSpol[pid] then
		gT.DiagnosisAICSpol[pid] = {Count = 0, Rewards = {}, HPrs = {}}
	end
	gT.DiagnosisAICSpol[pid].Count = gT.DiagnosisAICSpol[pid].Count + 1;
	if PoliticsCityStateTable[pid].EndTurnExtraPointsFunc then
		PoliticsCityStateTable[pid].EndTurnExtraPointsFunc(iPlayer, iQuest);
	end
	for gPlayer, pdata in pairs(gT.Players[iPlayer].CityStateQuests[iQuest].ActivePlayers) do
		tHt[gPlayer] = pdata.PoliticsPoints;
		if pdata.PoliticsPoints > hMax then
			hMax = pdata.PoliticsPoints;
		end
		if pdata.PoliticsPoints < hMin then
			hMin = pdata.PoliticsPoints;
		end
	end
	if hMin < 0 then
		hMax = hMax - hMin;
		for gPlayer, points in pairs(tHt) do
			tHt[gPlayer] = points - hMin;
		end
	end
	local cPr = 0;
	for gPlayer, points in pairs(tHt) do
		tHt[gPlayer] =  math.floor(CS_QUEST_POLITICS_POINTS * points / hMax);
		cPr = cPr + 1;
		table.insert(gT.DiagnosisAICSpol[pid].Rewards, tHt[gPlayer])
	end
	table.insert(gT.DiagnosisAICSpol[pid].HPrs, cPr)
	return tHt;
end

function PreparePointFromMissionCS(iPlayer, iQuest)
	if gT.Players[iPlayer].CityStateQuests[iQuest].GlobalMission then
		local missionID = gT.Players[iPlayer].CityStateQuests[iQuest].GlobalMission;
		local bRb = MissionCityStateTable[missionID].OnComplete(iPlayer, iQuest);
		if not bRb then
			bRb = {};
			for gPlayer, pdata in pairs(gT.Players[iPlayer].CityStateQuests[iQuest].ActivePlayers) do
				bRb[gPlayer] = 0;
			end
		else
			for j, d in pairs(bRb) do
				bRb[j] = math.floor(d * CS_QUEST_MISSION_POINTS);
			end
		end
		return bRb;
	end
	local tHt = {}
	for gPlayer, pdata in pairs(gT.Players[iPlayer].CityStateQuests[iQuest].ActivePlayers) do
		local misID = pdata.CSMission.ID;
		gT.Players[gPlayer].CSMissions[misID] = gT.Players[gPlayer].CSMissions[misID] - 1;
		if not gT.DiagnosisAICSmis[misID] then
			gT.DiagnosisAICSmis[misID] = {Count = 0, Rewards = {}}
		end
		gT.DiagnosisAICSmis[misID].Count = gT.DiagnosisAICSmis[misID].Count + 1;
		local rewardPoints = DetermineRewardPointsFromMission(iPlayer, iQuest, gPlayer);
		tHt[gPlayer] = rewardPoints;
		table.insert(gT.DiagnosisAICSmis[misID].Rewards, rewardPoints)
	end
	return tHt;
end

function DetermineRewardPointsFromMission(iPlayer, iQuest, gPlayer)
	local tData = gT.Players[iPlayer].CityStateQuests[iQuest].ActivePlayers[gPlayer].CSMission;
	if tData.Failed then
		return 0;
	end
	if tData.Completed then
		return CS_QUEST_MISSION_POINTS;
	end
	local misID = gT.Players[iPlayer].CityStateQuests[iQuest].ActivePlayers[gPlayer].CSMission.ID;
	if MissionCityStateTable[misID].SpecialComplete then
		return math.floor(MissionCityStateTable[misID].SpecialComplete(iPlayer, iQuest, gPlayer) * CS_QUEST_MISSION_POINTS)
	end
	if tData.Left then
		return math.floor(math.min((tData.Count or 0), tData.Left) * CS_QUEST_MISSION_POINTS / tData.Left)
	end
	return 0; -- if not completed...
end

function GetRandomPoliticsTypeCityStateQuest(cs)
	local fid = gT.Players[cs].CityStateForcedNextPolitic;
	if fid then
		if PoliticsCityStateTable[fid].ExtraData then
			return {ID = fid, ExtraData = PoliticsCityStateTable[fid].ExtraData(cs)}
		else
			return {ID = fid}
		end
	end
	local hTab = {}
	for i, data in pairs(PoliticsCityStateTable) do
		if not data.CanHaveFunc or data.CanHaveFunc(cs) then
			table.insert(hTab, i);
		end
	end
	local pid = hTab[LastRandom(1,#hTab)];
	if PoliticsCityStateTable[pid].ExtraData then
		return {ID = pid, ExtraData = PoliticsCityStateTable[pid].ExtraData(cs)}
	else
		return {ID = pid}
	end
end

function GetRandomCityStateProject()
	local hTab = {}
	for i = 1, #ProjectsCityStateTable do
		if i ~= 2 then
			if (not ProjectsCityStateTable[i].ScOff) or (not ProjectsCityStateTable[i].ScOff[gT.Globals.ScenarioType]) then
				table.insert(hTab, i)
			end
		end
	end
	if GetProperCSProcessFreeBuilding() then
		table.insert(hTab, 2)
	end
	return hTab[LastRandom(1,#hTab)]
end

function FuncPoliticsTurnTen(cs, questID, gPlayer)
	local tot, ac = 0, 0;
	local gTeam = Teams[Players[gPlayer]:GetTeam()];
	for g, gData in pairs(gT.Players) do
		if Players[g]:IsMinorCiv() and g ~= cs and Players[g]:IsAlive() then
			tot = 10;
			if Players[g]:IsProtectedByMajor(gPlayer) then
				ac = ac + 2;
			end
			if Players[g]:GetMinorCivFriendshipLevelWithMajor(gPlayer) > 1 then
				ac = ac + 8;
			elseif Players[g]:GetMinorCivFriendshipLevelWithMajor(gPlayer) > 0 then
				ac = ac + 6;
			elseif not gTeam:IsAtWar(Players[g]:GetTeam()) then
				ac = ac + 3;
			end
		end
	end
	if tot == 0 then
		return 0;
	else
		return 50 * ac / tot;
	end
end

function FuncPoliticsTurnEleven(cs, questID, gPlayer)
	local tot, ac = 0, 0;
	local gTeam = Players[gPlayer]:GetTeam();
	for g, diplo in pairs(gT.Players[cs].CityStateQuests[questID].ActivePlayers[gPlayer].MissionInitialData.InitDiploRelations) do
		local rew = 5;
		if Players[g]:IsMinorCiv() then
			rew =1;
		end
		tot = tot + rew;
		if GetCurrentDiploRelationSimple(gTeam, gPlayer, g) == diplo then
			ac = ac + rew;
		end
	end
	if tot == 0 then
		return 0;
	else
		return 10 * ac / tot;
	end
end

function FuncPoliticsTurnThirteen(cs, questID, gPlayer)
	local tot = 10;
	for iCity in Players[gPlayer]:Cities() do
		if iCity:FoodDifference() < 0 then
			tot = 0;
			break;
		end
	end
	return tot;
end

function FuncPoliticsTurnSixTeen(cs, questID, gPlayer)
	return gT.Players[gPlayer].Authority;
end

function FuncPoliticsTurnTwelve(cs, questID, gPlayer)
	local tot, ac = 0, 0;
	local gTeam = Players[gPlayer]:GetTeam();
	for g, diplo in pairs(gT.Players[cs].CityStateQuests[questID].ActivePlayers[gPlayer].MissionInitialData.InitDiploRelations) do
		local rew = 5;
		if Players[g]:IsMinorCiv() then
			rew =1;
		end
		tot = tot + rew;
		if GetCurrentDiploRelationSimple(gTeam, gPlayer, g) ~= diplo then
			ac = ac + rew;
		end
	end
	if tot == 0 then
		return 0;
	else
		return 10 * ac / tot;
	end
end

function FuncPoliticsTurnTwo(cs, questID, gPlayer)
	local ecs = gT.Players[cs].CityStateQuests[questID].Politics.ExtraData;
	if Players[ecs]:IsAlive() then
		if Players[ecs]:GetMinorCivFriendshipLevelWithMajor(gPlayer) > 0 or Players[ecs]:IsProtectedByMajor(gPlayer) then
			return 0;
		end
		local gTeam = Teams[Players[gPlayer]:GetTeam()];
		if gTeam:IsAtWar(Players[ecs]:GetTeam()) then
			return 10;
		end
		return 5;
	end
	return 0;
end

function FuncPoliticsTurnFive(cs, questID, gPlayer)
	local dip = 0;
	for i, data in pairs(gT.Players[gPlayer].Agents) do
		if (not data.IgnoreItForever) and (data.Mission == 7) then
			dip = dip + 1;
		end
	end
	return dip;
end

function FuncPoliticsTurnSeven(cs, questID, gPlayer)
	return 0;
end

function FuncPoliticsTurnFour(cs, questID, gPlayer)
	return 5 - FuncPoliticsTurnThree(cs, questID, gPlayer)
end

function FuncPoliticsTurnSix(cs, questID, gPlayer)
	if Players[gPlayer]:GetNumCities() == 0 then
		return 0;
	end
	local gTurn = GetITGGameTurn();
	local bRiot = 2;
	local bHap = 0;
	local cHap = gT.Players[gPlayer].AverageHappiness
	if cHap >= 0 then
		bHap = math.min(6, cHap / 2) + 2; 
	end
	for iCity in Players[gPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		if gT.Cities[cID].Riots > gTurn  then
			bRiot = 0;
			break;
		end
	end
	return bHap + bRiot;
end

function FuncPoliticsTurnNine(cs, questID, gPlayer)
	local tot = 0;
	for iUnit in Players[gPlayer]:Units() do
		if iUnit:GetDomainType() == dSea then
			tot = tot + 1;
		end
	end
	return tot;
end

function FuncPoliticsTurnEight(cs, questID, gPlayer)
	local numcities = Players[gPlayer]:GetNumCities();
	local tot, ac = 0, 0;
	local gTeam = Teams[Players[gPlayer]:GetTeam()];
	for g, gdata in pairs(gT.Players) do
		if g ~= cs and g ~= gPlayer then
			if Players[g]:GetNumCities() > numcities then
				if Players[g]:IsMinorCiv() then
					tot = tot + 1;
					if gTeam:IsAtWar(Players[g]:GetTeam()) then
						ac = ac + 1;
					end
				else
					tot = tot + 3;
					if gTeam:IsAtWar(Players[g]:GetTeam()) then
						ac = ac + 3;
					end
				end
			elseif Players[g]:GetNumCities() < numcities then
				if Players[g]:IsMinorCiv() then
					tot = tot + 1;
					if not gTeam:IsAtWar(Players[g]:GetTeam()) then
						ac = ac + 1;
					end
				else
					tot = tot + 3;
					if not gTeam:IsAtWar(Players[g]:GetTeam()) then
						ac = ac + 3;
					end
				end
			end
		end
	end
	if tot == 0 then
		return 0;
	else
		return 10 * ac / tot;
	end
end

function FuncPoliticsTurnThree(cs, questID, gPlayer)
	local tot, ac = 0, 0;
	local gTeam = Teams[Players[gPlayer]:GetTeam()];
	for g, gdata in pairs(gT.Players) do
		if g ~= cs and g ~= gPlayer then
			if Players[g]:IsMinorCiv() then
				tot = tot + 1;
				if gTeam:IsAtWar(Players[g]:GetTeam()) then
					ac = ac + 1;
				end
			else
				tot = tot + 3;
				if gTeam:IsAtWar(Players[g]:GetTeam()) then
					ac = ac + 3;
				end
			end
		end
	end
	if tot == 0 then
		return 0;
	else
		return 5 * ac / tot;
	end
end

function FuncPoliticsTurn14(cs, questID, gPlayer)
	if Players[gPlayer]:GetNumCities() == 0 then
		return 0;
	end
	local tot = 0;
	tot = tot + GetAverageValueFromCID(gPlayer, "Health") + GetBestValueFromCID(gPlayer, "Health") + GetWorstValueFromCID(gPlayer, "Health")
	tot = tot + 30 + GetAverageValueFromCID(gPlayer, "HealthLevel") + GetBestValueFromCID(gPlayer, "HealthLevel") + GetWorstValueFromCID(gPlayer, "HealthLevel")
	for iCity in Players[gPlayer]:Cities() do
		if iCity:IsPlague() then
			tot = tot - 15;
		end
	end	
	return math.max(0, tot);
end

function FuncPoliticsTurn15(cs, questID, gPlayer)
	local bH = 0;
	for index, data in pairs(gT.Academies) do
		if data.Player == gPlayer then
			if IsAcademyActiveRightNow(index) then
				bH = bH + 3;
				if data.Rank then
					bH = bH + math.max(0, 15 - data.Rank)
				end
			end
		end
	end
	return bH;
end

function FuncPoliticsTurnOne(cs, questID, gPlayer)
	local cultType = gT.Players[cs].CultureType;
	local tot, ac = 0, 0;
	local gTeam = Teams[Players[gPlayer]:GetTeam()];
	for g, gdata in pairs(gT.Players) do
		if g ~= cs then
			if g ~= gPlayer then
				if Players[g]:IsMinorCiv() then
					tot = tot + 4;	
					if gdata.CultureType == cultType then
						if Players[g]:GetAlly() == gPlayer then
							ac = ac + 4;
						elseif Players[g]:GetMinorCivFriendshipLevelWithMajor(gPlayer) > 0 then
							ac = ac + 2;
						elseif not gTeam:IsAtWar(Players[g]:GetTeam()) then
							ac = ac + 1;
						end
					else
						if gTeam:IsAtWar(Players[g]:GetTeam()) then
							ac = ac + 4;
						elseif Players[g]:GetMinorCivFriendshipLevelWithMajor(gPlayer) <= 0 then
							ac = ac + 2;
						elseif Players[g]:GetAlly() ~= gPlayer then
							ac = ac + 1;
						end
					end
				else
					tot = tot + 4;
					if gdata.CultureType == cultType then
						if not gTeam:IsAtWar(Players[g]:GetTeam()) then
							if Players[gPlayer]:IsDoF(g) then
								ac = ac + 4;
							elseif not Players[gPlayer]:IsDenouncingPlayer(g) then
								ac = ac + 2;
							else	
								ac = ac + 1;
							end
						end
					else
						if gTeam:IsAtWar(Players[g]:GetTeam()) then
							ac = ac + 4;
						elseif Players[gPlayer]:IsDenouncingPlayer(g) then
							ac = ac + 2;
						elseif not Players[gPlayer]:IsDoF(g) then
							ac = ac + 1;
						end
					end
				end
			end
		end
	end
	if tot == 0 then
		return 0;
	else
		return 10 * ac / tot;
	end
end

function PCSTNearbyMinor(cs)
	if GetNearestMinorCSfQ(cs) then
		return true;
	end
	return false;
end

function IsAcademyImportantForCS(cs)
	return (gT.Globals.ScenarioType == 4)
end

function PCSTextradataFallofCityState(cs)
	return GetNearestMinorCSfQ(cs);
end

function GetNearestMinorCSfQ(cs)
	local cc = Players[cs]:GetCapitalCity();
	if not cc then
		return nil
	end
	local hTab = {}
	for g, gdata in pairs(gT.Players) do
		if g ~= cs and Players[g]:IsMinorCiv() then
			if Teams[Players[cs]:GetTeam()]:IsHasMet(Players[g]:GetTeam()) then
				local gc = Players[g]:GetCapitalCity();
				if gc then
					if Map.PlotDistance(gc:GetX(), gc:GetY(), cc:GetX(), cc:GetY()) <= 10 then
						table.insert(hTab, g);
					end
				end
			end
		end
	end
	if #hTab > 0 then
		return hTab[LastRandom(1,#hTab)];
	end
	return nil
end

function PCSTEndInfluenceDifference(cs, d)
	local ecs = gT.Players[cs].CityStateQuests[d].Politics.ExtraData;
	local ecst = Teams[Players[ecs]:GetTeam()];
	if Players[ecs]:IsAlive() then
		for gPlayer, data in pairs(gT.Players[cs].CityStateQuests[d].ActivePlayers) do
		--they were forced to meet
		--	if ecst:IsHasMet(Players[gPlayer]:GetTeam()) then
				local change = gT.Players[cs].CityStateQuests[d].ActivePlayers[gPlayer].InitInfluence - math.max(0, Players[ecs]:GetMinorCivFriendshipWithMajor(gPlayer))
				gT.Players[cs].CityStateQuests[d].ActivePlayers[gPlayer].PoliticsPoints = gT.Players[cs].CityStateQuests[d].ActivePlayers[gPlayer].PoliticsPoints + change;
		--	end
		end
	end
end

function PCSTEndInfluenceDifferenceAll(cs, d)
	for gPlayer, data in pairs(gT.Players[cs].CityStateQuests[d].ActivePlayers) do
		for g, gdata in pairs(gT.Players) do
			if g ~= cs and Players[g]:IsMinorCiv() and Players[g]:IsAlive() then
				local change = gT.Players[cs].CityStateQuests[d].ActivePlayers[gPlayer].MissionInitialData.InitInfluence[g] or 0 - math.max(0, Players[g]:GetMinorCivFriendshipWithMajor(gPlayer))
				gT.Players[cs].CityStateQuests[d].ActivePlayers[gPlayer].PoliticsPoints = gT.Players[cs].CityStateQuests[d].ActivePlayers[gPlayer].PoliticsPoints + change;
			end
		end
	end
end

function MCSTWorldWonderAdded(cs, d)
	local gTurn = GetITGGameTurn();
	local dTurn = nil;
	for i = gTurn, gTurn + 19 do
		if i % 10 == 0 then
			dTurn = i;
		end
	end
	gT.Players[cs].CityStateQuests[d].Mission.WonderTurn = dTurn;
end

function PCSTMeetCityState(cs, d)
	local ecs = gT.Players[cs].CityStateQuests[d].Politics.ExtraData;
	local ecst = Teams[Players[ecs]:GetTeam()];
	for gPlayer, data in pairs(gT.Players[cs].CityStateQuests[d].ActivePlayers) do
		if not ecst:IsHasMet(Players[gPlayer]:GetTeam()) then
			ecst:Meet(Players[gPlayer]:GetTeam())
			gT.Players[cs].CityStateQuests[d].ActivePlayers[gPlayer].MissionInitialData.InitInfluence = math.max(0, Players[ecs]:GetMinorCivFriendshipWithMajor(gPlayer))
		end
	end
end

function PCSTOnAddedProtectorCityState(cs, d)
	for gPlayer, data in pairs(gT.Players[cs].CityStateQuests[d].ActivePlayers) do
		gT.Players[cs].CityStateQuests[d].ActivePlayers[gPlayer].MissionInitialData.InitInfluence = {}
		for g, gdata in pairs(gT.Players) do
			if g ~= cs and Players[g]:IsMinorCiv() then
				gT.Players[cs].CityStateQuests[d].ActivePlayers[gPlayer].MissionInitialData.InitInfluence[g] = math.max(0, Players[g]:GetMinorCivFriendshipWithMajor(gPlayer))
			end
		end
	end
end

LuaEvents.ITGSG_RequestCityStateProjectContributions.Add(function()
	local gActive = Game.GetActivePlayer();
	if not gT.Players[gActive] then
		return;
	end
	local tab = {};
	for g, h in pairs(gT.Players) do
		if Players[g]:IsMinorCiv() and Players[g]:IsAlive() then
			for i, csdata in pairs(h.CityStateQuests) do
				if csdata.Active and csdata.ActivePlayers[gActive] then
					local iContribution = csdata.ActivePlayers[gActive].ProjectDonated * ProjectsCityStateTable[csdata.Project].Scale;
					if iContribution > 0 then
						iContribution = "[COLOR_POSITIVE_TEXT]" .. iContribution
					end
					tab[g] = {iContribution .. ProjectsCityStateTable[csdata.Project].Icon, math.floor(GetAvailableResourceToContributeProjectCS(gActive, csdata.Project, true) / 5)}
				end
			end
		end
	end
	MapModData.ITGSG = tab; 
end)

LuaEvents.ITGSG_RequestCityStateProjectPanelData.Add(function()
	local gActive = Game.GetActivePlayer();
	if not gT.Players[gActive] then
		return;
	end
	local tab = {};
	local hTab = {}
	local gTurn = GetITGGameTurn() - 1;
	for g, h in pairs(gT.Players) do
		if Players[g]:IsMinorCiv() and Players[g]:IsAlive() then
			for i, csdata in pairs(h.CityStateQuests) do
				if csdata.Active and csdata.ActivePlayers[gActive] then
					table.insert(hTab, {g, csdata.EndTurn - gTurn, i})
				end
			end
		end
	end
	table.sort(hTab, SortFunctionForLowestMapDistance)
	local hTeam = Players[gActive]:GetTeam();
	for a, b in pairs(hTab) do
		local prepTab = {}
		prepTab.PlayerID = b[1]
		prepTab.ProjectType = gT.Players[b[1]].CityStateQuests[b[3]].Project
		prepTab.ProjectIcon = ProjectsCityStateTable[prepTab.ProjectType].Icon
		prepTab.ProjectScale = ProjectsCityStateTable[prepTab.ProjectType].Scale 
		prepTab.OngoingQuest = PrepareNotificationTextForNewCityStateQuest(b[1], b[3], gActive)
		prepTab.OngoingQuestIcon = PrepareIconTextForNewCityStaateQuest(b[1], gActive, b[3])
		prepTab.TurnsLeft = b[2];
		prepTab.War = Teams[hTeam]:IsAtWar(Players[b[1]]:GetTeam())
		prepTab.CanChangeWarPeace = (Teams[hTeam]:CanChangeWarPeace(Players[b[1]]:GetTeam()) and (not Teams[hTeam]:IsPermanentWarPeace(Players[b[1]]:GetTeam()))) and (not Players[b[1]]:IsPeaceBlocked(gActive));
		local hptl = GetCSPlotToLookAt(b[1], hTeam)
		if hptl then
			prepTab.PlotIndex = hptl:GetPlotIndex();
		end
		table.insert(tab, prepTab)
	end
	MapModData.ITGSG = tab; 
end)

function GetCurrentDiploRelationSimple(iTeam, gPlayer, g)
	if Players[g]:IsMinorCiv() then
		return Players[g]:GetMinorCivFriendshipLevelWithMajor(gPlayer);
	else
		if Teams[iTeam]:IsAtWar(Players[g]:GetTeam()) then
			return 0;
		elseif Players[gPlayer]:IsDoF(g) then
			return 1;
		else
			return 2;
		end
	end
end

function PCSTOnAddedCurrentRelationsWithMeetCivs(cs, d)
	for gPlayer, data in pairs(gT.Players[cs].CityStateQuests[d].ActivePlayers) do
		gT.Players[cs].CityStateQuests[d].ActivePlayers[gPlayer].MissionInitialData.InitDiploRelations = {}
		local iTeam = Players[gPlayer]:GetTeam()
		for g, gdata in pairs(gT.Players) do
			if g ~= cs and g ~= gPlayer then
				if Teams[iTeam]:IsHasMet(Players[g]:GetTeam()) then
					gT.Players[cs].CityStateQuests[d].ActivePlayers[gPlayer].MissionInitialData.InitDiploRelations[g] = GetCurrentDiploRelationSimple(iTeam, gPlayer, g)
				end
			end
		end
	end
end

function PCSTOnInitialCheckAllCitiesFoodValue(cs, d)
	for gPlayer, data in pairs(gT.Players[cs].CityStateQuests[d].ActivePlayers) do
		gT.Players[cs].CityStateQuests[d].ActivePlayers[gPlayer].MissionInitialData.InitCityPopulation = {}
		for iCity in Players[gPlayer]:Cities() do
			gT.Players[cs].CityStateQuests[d].ActivePlayers[gPlayer].MissionInitialData.InitCityPopulation[iCity:Plot():GetPlotIndex()] = iCity:GetPopulation()
		end
	end
end

function PCSTOnInitialAuthority(cs, d)
	for gPlayer, data in pairs(gT.Players[cs].CityStateQuests[d].ActivePlayers) do
		gT.Players[cs].CityStateQuests[d].ActivePlayers[gPlayer].MissionInitialData.InitUpgrades = gT.Players[gPlayer].LHNumPalaceUpgrades;
		gT.Players[cs].CityStateQuests[d].ActivePlayers[gPlayer].MissionInitialData.InitMaxAuthority = gT.Players[gPlayer].LHMaxAuthority;
	end
end

function PCSTEndAuthorityDifference(cs, d)
	for gPlayer, data in pairs(gT.Players[cs].CityStateQuests[d].ActivePlayers) do
		local change = 0;
		change = change + (gT.Players[gPlayer].LHMaxAuthority -data.MissionInitialData.InitMaxAuthority) * 10;
		change = change + (gT.Players[gPlayer].LHNumPalaceUpgrades -data.MissionInitialData.InitUpgrades) * 10;
		gT.Players[cs].CityStateQuests[d].ActivePlayers[gPlayer].PoliticsPoints = gT.Players[cs].CityStateQuests[d].ActivePlayers[gPlayer].PoliticsPoints + change;
	end
end

function PCSTEndFoodDifferenceAll(cs, d)
	for gPlayer, data in pairs(gT.Players[cs].CityStateQuests[d].ActivePlayers) do
		local change = 0;
		local tot = 0;
		for iCity in Players[gPlayer]:Cities() do
			local initVal = gT.Players[cs].CityStateQuests[d].ActivePlayers[gPlayer].MissionInitialData.InitCityPopulation[iCity:Plot():GetPlotIndex()];
			if initVal then
				tot = tot + 1;
				if iCity:GetPopulation() > initVal then
					change = change + iCity:GetPopulation() - initVal;
				end
			end
		end
		gT.Players[cs].CityStateQuests[d].ActivePlayers[gPlayer].PoliticsPoints = gT.Players[cs].CityStateQuests[d].ActivePlayers[gPlayer].PoliticsPoints + change;
	end
end

function PCSTnameFallOfCityState(cs, d)
	local ecs = gT.Players[cs].CityStateQuests[d].Politics.ExtraData;
	return "The Fall of " .. Players[ecs]:GetName();
end

function PCSTtextFallOfCityState(cs, d)
	local ecs = gT.Players[cs].CityStateQuests[d].Politics.ExtraData;
	return "[ICON_RAZING] They want you to share their hatred towards [ICON_CITY_STATE] " .. Players[ecs]:GetName() .. ". You are earning points for being at war, killing units, capturing cities, bullying or even just for not being friendly towards them. [ICON_INFLUENCE] Influence loss  with  " .. Players[ecs]:GetName() .. " grants extra points and vice versa.";
end

ProjectsCityStateTable = {
{ID = 1, Name = "Scientific Project", Text = "[ICON_RESEARCH] They want you to donate [ICON_RESEARCH] Science to their research program.", Icon = "[ICON_RESEARCH]", Scale = 1},
{ID = 2, Name = "Construction Project", Text = "[ICON_PRODUCTION] They want you to contribute [ICON_PRODUCTION] Production to urbanise their city.", Icon = "[ICON_PRODUCTION]", Scale = 1},
{ID = 3, Name = "The Constitution", Text = "[ICON_ITG_LEGAL_POWER] They want you to contribute [ICON_ITG_LEGAL_POWER] Legal Power, helping them create their code of laws.", Icon = "[ICON_ITG_LEGAL_POWER]", Scale = 0.01},
{ID = 4, Name = "Religious Fervor", Text = "[ICON_PEACE] They want you to contribute [ICON_PEACE] Faith to promote religion in their city.", Icon = "[ICON_PEACE]", Scale = 1, ScOff = {[5] = true}},
{ID = 5, Name = "Artistic Renaissance", Text = "[ICON_CULTURE] They want you to contribute [ICON_CULTURE] Culture to make other City-States envy of their art.", Icon = "[ICON_CULTURE]", Scale = 1},
{ID = 6, Name = "Maritime Academy", Text = "[ICON_GREAT_ADMIRAL] They want you to contribute [ICON_GREAT_ADMIRAL] Great Admiral points to modernise their navy.", Icon = "[ICON_GREAT_ADMIRAL]", Scale = 1},
{ID = 7, Name = "Army Training", Text = "[ICON_GREAT_GENERAL] They want you to contribute [ICON_GREAT_GENERAL] Great General points to modernise their army.", Icon = "[ICON_GREAT_GENERAL]", Scale = 1},
{ID = 8, Name = "Population Boost", Text = "[ICON_ITG_SETTLER] They want you to contribute [ICON_ITG_SETTLER] Settler points to increase population of their city.", Icon = "[ICON_ITG_SETTLER]", Scale = 0.2, ScOff = {[5] = true}},
{ID = 9, Name = "Infrastructure", Text = "[ICON_WORKER] They want you you contribute [ICON_WORKER] Work Rate to modernise their infrastructure.", Icon = "[ICON_WORKER]", Scale = 5},
}

RewardMiniCityStateTable = {
{ID = 1, Text = "+50 [ICON_CULTURE] Culture.", PrefTrait = {[GameInfoTypes.MINOR_TRAIT_TRADITIONAL] = true, [GameInfoTypes.MINOR_TRAIT_ENLIGHTENED] = true, [GameInfoTypes.MINOR_TRAIT_CULTURED] = true}},
{ID = 2, Text = "+1 [ICON_HAPPINESS_1] Happiness in all Cities.", PrefTrait = {[GameInfoTypes.MINOR_TRAIT_IDEOLOGICAL] = true, [GameInfoTypes.MINOR_TRAIT_ECONOMIC] = true, [GameInfoTypes.MINOR_TRAIT_MERCANTILE] = true}},
{ID = 3, Text = "+50 [ICON_RESEARCH] Science.", PrefTrait = {[GameInfoTypes.MINOR_TRAIT_ENLIGHTENED] = true}},
{ID = 4, Text = "+50 [ICON_PEACE] Faith.", PrefTrait = {[GameInfoTypes.MINOR_TRAIT_IDEOLOGICAL] = true, [GameInfoTypes.MINOR_TRAIT_RELIGIOUS] = true}, ScOff = {[5] = true}},
{ID = 5, Text = "+1 [ICON_ITG_SUPPLY] Supply.", PrefTrait = {[GameInfoTypes.MINOR_TRAIT_ECONOMIC] = true, [GameInfoTypes.MINOR_TRAIT_AGRICULTURAL] = true, [GameInfoTypes.MINOR_TRAIT_MILITARISTIC] = true}},
{ID = 6, Text = "Reduces treshold to acquire new special unit by 40.", PrefTrait = {[GameInfoTypes.MINOR_TRAIT_ENLIGHTENED] = true, [GameInfoTypes.MINOR_TRAIT_MILITARISTIC] = true}, ScOff = {[1] = true, [2] = true, [4] = true}},
{ID = 7, Text = "+0.5 [ICON_ITG_LEGAL_POWER] Legal Power.", PrefTrait = {[GameInfoTypes.MINOR_TRAIT_TRADITIONAL] = true, [GameInfoTypes.MINOR_TRAIT_IDEOLOGICAL] = true, [GameInfoTypes.MINOR_TRAIT_RELIGIOUS] = true}},
{ID = 8, Text = "+50 [ICON_FOOD] Food in Capital.", PrefTrait = {[GameInfoTypes.MINOR_TRAIT_MARITIME] = true, [GameInfoTypes.MINOR_TRAIT_AGRICULTURAL] = true}},
{ID = 9, Text = "+1 [ICON_GREAT_WORK] Great Work.", PrefTrait = {[GameInfoTypes.MINOR_TRAIT_ANTIQUE] = true, [GameInfoTypes.MINOR_TRAIT_CULTURED] = true, [GameInfoTypes.MINOR_TRAIT_RELIGIOUS] = true}},
{ID = 10, Text = "+50 [ICON_GREAT_ARTIST] Art points.", PrefTrait = {[GameInfoTypes.MINOR_TRAIT_ANTIQUE] = true, [GameInfoTypes.MINOR_TRAIT_CULTURED] = true, [GameInfoTypes.MINOR_TRAIT_RELIGIOUS] = true}},
{ID = 11, Text = "+100 [ICON_WORKER] Work Rate in all cities.", PrefTrait = {[GameInfoTypes.MINOR_TRAIT_ECONOMIC] = true, [GameInfoTypes.MINOR_TRAIT_AGRICULTURAL] = true, [GameInfoTypes.MINOR_TRAIT_MARITIME] = true, [GameInfoTypes.MINOR_TRAIT_MERCANTILE] = true}},
{ID = 12, Text = "+75 [ICON_GREAT_PEOPLE] Great People points.", PrefTrait = {[GameInfoTypes.MINOR_TRAIT_ANTIQUE] = true, [GameInfoTypes.MINOR_TRAIT_ENLIGHTENED] = true, [GameInfoTypes.MINOR_TRAIT_RELIGIOUS] = true}},
{ID = 13, Text = "+4 [ICON_ITG_MORALE] Morale boost.", PrefTrait = {[GameInfoTypes.MINOR_TRAIT_MILITARISTIC] = true}},
{ID = 14, Text = "Increase chance to acquire [ICON_ITG_FESTIVAL] Festival by 0.6%.", PrefTrait = {[GameInfoTypes.MINOR_TRAIT_TRADITIONAL] = true, [GameInfoTypes.MINOR_TRAIT_IDEOLOGICAL] = true, [GameInfoTypes.MINOR_TRAIT_CULTURED] = true, [GameInfoTypes.MINOR_TRAIT_RELIGIOUS] = true}},
{ID = 15, Text = "All Cities acquire new plot.", PrefTrait = {[GameInfoTypes.MINOR_TRAIT_ECONOMIC] = true, [GameInfoTypes.MINOR_TRAIT_MARITIME] = true, [GameInfoTypes.MINOR_TRAIT_MERCANTILE] = true, [GameInfoTypes.MINOR_TRAIT_AGRICULTURAL] = true}, ScOff = {[4] = true, [5] = true}},
{ID = 16, Text = "+1 [ICON_RES_OIL] Oil.", PrefTrait = {[GameInfoTypes.MINOR_TRAIT_MILITARISTIC] = true, [GameInfoTypes.MINOR_TRAIT_MARITIME] = true, [GameInfoTypes.MINOR_TRAIT_MERCANTILE] = true}, ScOff = {[1] = true, [2] = true, [3] = true, [4] = true}},
{ID = 17, Text = "+1 [ICON_RES_IRON] Iron.", PrefTrait = {[GameInfoTypes.MINOR_TRAIT_MILITARISTIC] = true, [GameInfoTypes.MINOR_TRAIT_MERCANTILE] = true}, ScOff = {[2] = true, [4] = true, [5] = true}},
{ID = 18, Text = "+1 [ICON_RES_HORSE] Horse.", PrefTrait = {[GameInfoTypes.MINOR_TRAIT_AGRICULTURAL] = true, [GameInfoTypes.MINOR_TRAIT_MILITARISTIC] = true, [GameInfoTypes.MINOR_TRAIT_MERCANTILE] = true}, ScOff = {[4] = true, [5] = true}},
{ID = 19, Text = "+100 [ICON_ITG_PRESENCE] Presence within City-State.", PrefTrait = {[GameInfoTypes.MINOR_TRAIT_ANTIQUE] = true, [GameInfoTypes.MINOR_TRAIT_ENLIGHTENED] = true, [GameInfoTypes.MINOR_TRAIT_CULTURED] = true}},
{ID = 20, Text = "+15 [ICON_RES_HORSE] Horses and [ICON_RES_IRON] Iron.", PrefTrait = {[GameInfoTypes.MINOR_TRAIT_AGRICULTURAL] = true, [GameInfoTypes.MINOR_TRAIT_MILITARISTIC] = true, [GameInfoTypes.MINOR_TRAIT_MERCANTILE] = true}, ScOff = {[1] = true, [2] = true, [3] = true, [5] = true}},
{ID = 21, Text = "+8 [ICON_ITG_MERITOCRACY] Meritocracy.", PrefTrait = {[GameInfoTypes.MINOR_TRAIT_ENLIGHTENED] = true, [GameInfoTypes.MINOR_TRAIT_TRADITIONAL] = true, [GameInfoTypes.MINOR_TRAIT_IDEOLOGICAL] = true, [GameInfoTypes.MINOR_TRAIT_CULTURED] = true, [GameInfoTypes.MINOR_TRAIT_RELIGIOUS] = true}},
}

function GetDataForPhilosopherPolitics()
	local sTab = {}
	for i, data in pairs(PoliticsCityStateTable) do
		if data.Name then
			table.insert(sTab, data.ID);
		end
	end
	sTab = Shuffle(sTab);
	local grr = {}
	grr[1] = sTab[1];
	grr[2] = sTab[2];
	return grr;
end

PoliticsCityStateTable = {
{ID = 1, Name = "Friend of the People", Text = "[ICON_SILVER_FIST] They will reward you for keeping peace with civilizations of their Cultural type, while fighting other civilizations. Extra points for allying other [ICON_CITY_STATE] City-States of adequate Cultural type, while remaining neutral or at war with other City-States.", GetTurnPoints = FuncPoliticsTurnOne, Icon = "[ICON_SILVER_FIST]", EndBasicMax = 50},
{ID = 2, FuncName = PCSTnameFallOfCityState, OnAddedFunc = PCSTMeetCityState, CanHaveFunc = PCSTNearbyMinor, EndTurnExtraPointsFunc = PCSTEndInfluenceDifference, FuncText = PCSTtextFallOfCityState, GetTurnPoints = FuncPoliticsTurnTwo, ExtraData = PCSTextradataFallofCityState, Icon = "[ICON_RAZING]", EndBasicMax = 50},
{ID = 3, Name = "World At War", Text = "[ICON_IDEOLOGY_AUTOCRACY] They will reward you for extraordinary warmongering. Try to declare war on everybody except them obviously. Extra points for killing units, plundering Trade-Routes and capturing cities.", GetTurnPoints = FuncPoliticsTurnThree, Icon = "[ICON_IDEOLOGY_AUTOCRACY]", EndBasicMax = 50},
{ID = 4, Name = "Peace Keeper", Text = "[ICON_FLOWER] They will reward you for not engaging into any military conflict. If at war, try to not kill units, capture cities or plunder trade-routes.", GetTurnPoints = FuncPoliticsTurnFour, Icon = "[ICON_FLOWER]", EndBasicMax = 50},
{ID = 5, Name = "Open Relations", Text = "[ICON_SPY] They dream about the world without shadow and filthy spies. Catching rival spies grants you extra points, while your spies being caught cost you penalty. Using spies as diplomats earns extra points each turn.", GetTurnPoints = FuncPoliticsTurnFive, Icon = "[ICON_SPY]", EndBasicMax = 20},
{ID = 6, Name = "Happy World", Text = "[ICON_HAPPINESS_1] They will reward you for keeping your empire happy. You will earn extra points if there are no riots within your empire.", GetTurnPoints = FuncPoliticsTurnSix, Icon = "[ICON_HAPPINESS_1]", EndBasicMax = 50},
{ID = 7, Name = "Global Trade", Text = "[ICON_SWAP] They want you to be a part of global trade network, rewarding your every Caravan and Cargo Ship reaching destination (especially international ones), while penalising every Trade Route you plunder.", GetTurnPoints = FuncPoliticsTurnSeven, Icon = "[ICON_SWAP]", EndBasicMax = 50},
{ID = 8, Name = "Balance of Power", Text = "[ICON_RANGE_STRENGTH] They would like you to mantain peace with civilizations with lesser amount of cities, while be at war with ones with greater number of cities.", GetTurnPoints = FuncPoliticsTurnEight, Icon = "[ICON_RANGE_STRENGTH]", EndBasicMax = 50},
{ID = 9, Name = "Lord of the Seas", Text = "[ICON_GREAT_ADMIRAL] They will reward you for mantaining the largest fleet at world. Extra points for plundering Cargo Ships, killing naval units or obtaining [ICON_FOOD] Food from naval resources.", GetTurnPoints = FuncPoliticsTurnNine, Icon = "[ICON_GREAT_ADMIRAL]", EndBasicMax = 50},
{ID = 10, Name = "Protector of Weak", Text = "[ICON_CITY_STATE] They will reward you for having friendly and protective attitude towards all other city-states (do not bully them!). You earn points from [ICON_INFLUENCE] Influence incresement as well.", OnAddedFunc = PCSTOnAddedProtectorCityState, EndTurnExtraPointsFunc = PCSTEndInfluenceDifferenceAll, GetTurnPoints = FuncPoliticsTurnTen, Icon = "[ICON_CITY_STATE]", EndBasicMax = 50},
{ID = 11, Name = "Stability", Text = "[ICON_OMEGA] They want you to maintain your current relations as long as possible (don't declare war, make peace or new friendships, prolong current declaration of friendships). Keep the same friendship levels with [ICON_CITY_STATE] City-States.", OnAddedFunc = PCSTOnAddedCurrentRelationsWithMeetCivs, GetTurnPoints = FuncPoliticsTurnEleven, Icon = "[ICON_OMEGA]", EndBasicMax = 30},
{ID = 12, Name = "Chaos", Text = "[ICON_ALPHA] They want you to change your current relations (declare wars, make peace with current enemies, make new friendships and do not prolong current declarations of friendship). Change the friendship levels with [ICON_CITY_STATE] City-States.", OnAddedFunc = PCSTOnAddedCurrentRelationsWithMeetCivs, GetTurnPoints = FuncPoliticsTurnTwelve, Icon = "[ICON_ALPHA]", EndBasicMax = 10},
{ID = 13, Name = "Feed the World", Text = "[ICON_FOOD] They will reward nations that made the greatest [ICON_CITIZEN] Population growth in their cities. They do not want to see any starvation.", OnAddedFunc = PCSTOnInitialCheckAllCitiesFoodValue, EndTurnExtraPointsFunc = PCSTEndFoodDifferenceAll, GetTurnPoints = FuncPoliticsTurnThirteen, Icon = "[ICON_FOOD]", EndBasicMax = 50},
{ID = 14, Name = "Life Expectancy", Text = "[ICON_ITG_HEALTH_1] They will reward nations with the most developed [ICON_ITG_HEALTH_1] Healthcare. They would prefer to not witness any [ICON_ITG_PLAGUE_4] Epidemy.", GetTurnPoints = FuncPoliticsTurn14, Icon = "[ICON_ITG_HEALTH_1]", EndBasicMax = 50},
{ID = 15, Name = "Lightbringer", Text = "[ICON_ITG_ACADEMY_1] They seek the nations with the most prestigous Academies.", GetTurnPoints = FuncPoliticsTurn15, Icon = "[ICON_ITG_ACADEMY_1]", CanHaveFunc = IsAcademyImportantForCS, EndBasicMax = 50},
{ID = 16, Name = "Authority", Text = "[ICON_ITG_AUTHORITY] They want to witness the splendour of great civilizations. They value generating [ICON_ITG_AUTHORITY] Authority and upgrading Palaces.", OnAddedFunc = PCSTOnInitialAuthority, EndTurnExtraPointsFunc = PCSTEndAuthorityDifference, GetTurnPoints = FuncPoliticsTurnSixTeen, Icon = "[ICON_ITG_AUTHORITY]", EndBasicMax = 50}
}

function AICityStateProjectsHelpFunction(iPlayer)
	local gTurn = GetITGGameTurn();
	local pTeam = Teams[Players[iPlayer]:GetTeam()];
	for g, gdata in pairs(gT.Players) do
		for iquest, qdata in pairs(gdata.CityStateQuests) do
			if qdata.Active then
				if qdata.EndTurn == gTurn then
					if qdata.ActivePlayers[iPlayer] then
						if qdata.Project ~= 2 then
							if not pTeam:IsAtWar(Players[g]:GetTeam()) then
								local avRes = math.floor(GetAvailableResourceToContributeProjectCS(iPlayer, qdata.Project) / 5)
								if avRes > 0 then
									local getSF = GetShortlyRelationsTowardsCS(iPlayer, g, qdata.Project)
									if getSF == 0 then
										if LastRandom(1, 5) == 4 then
											AddContributionToProjectCS(iPlayer, g, 5 * (math.min(LastRandom(3,5), avRes)))
										else
											AddContributionToProjectCS(iPlayer, g, 5 * (math.min(LastRandom(1,3), avRes)))
										end
									elseif getSF == 1 then
										if LastRandom(1, 7) == 2 then
											AddContributionToProjectCS(iPlayer, g, 5 * (math.min(LastRandom(20, 60), avRes)))
										elseif LastRandom(1, 3) == 3 then
											AddContributionToProjectCS(iPlayer, g, 5 * (math.min(LastRandom(5, 20), avRes)))
										else
											AddContributionToProjectCS(iPlayer, g, 5 * (math.min(LastRandom(1, 5), avRes)))
										end
									elseif getSF == 2 then
										--let's go crazy sometimes to mess up with human player
										if LastRandom(1, 100) == 3 then
											AddContributionToProjectCS(iPlayer, g, 5 * avRes)
										elseif LastRandom(1, 7) == 2 then
											AddContributionToProjectCS(iPlayer, g, 5 * (math.min(LastRandom(50, 70), avRes)))
										elseif LastRandom(1, 4) == 3 then
											AddContributionToProjectCS(iPlayer, g, 5 * (math.min(LastRandom(20, 50), avRes)))
										else
											AddContributionToProjectCS(iPlayer, g, 5 * (math.min(LastRandom(1, 20), avRes)))
										end
									end
								end
							end
						else
							gT.Players[iPlayer].AILogicForCSProductionProject[GetGlobalProjectBuilding(g)] = nil;
						end
					end
				end
			end
		end
	end
end

function GetGlobalProjectBuilding(g)
	for iBuilding, cs in pairs(gT.Globals.CityStateBuildingProcesses) do
		if cs == g then
			return iBuilding;
		end
	end
	print("Error 945/5354234/123")
	return -1;
end

function GetAvailableResourceToContributeProjectCS(iPlayer, project, bRealHuman)
	if project == 1 then
		return gT.Players[iPlayer].Science;
	elseif project == 3 then
		--respect it; do not make AI throw it like no tomorrow
		if bRealHuman then
			return gT.Players[iPlayer].LegalPower * 100 + gT.Players[iPlayer].LegalPowerPercent;
		end
		return gT.Players[iPlayer].LegalPower * 20 + gT.Players[iPlayer].LegalPowerPercent;
	elseif project == 4 then
		return Players[iPlayer]:GetFaith();
	elseif project == 5 then
		return gT.Players[iPlayer].Culture;
	elseif project == 6 then
		return Players[iPlayer]:GetNavalCombatExperience();
	elseif project == 7 then
		return Players[iPlayer]:GetCombatExperience();
	elseif project == 8 then
		return gT.Players[iPlayer].SettlerGenerationPoints * 5;
	elseif project == 9 then
		return math.floor(GetTotalWorkRateStoredPlayer(iPlayer) / 5);
	end
	return 0;
end

function DoAILogicForCSProductionProject(cs, iBuilding, iPlayer)
	local getSF = GetShortlyRelationsTowardsCS(iPlayer, cs, 2)
	local val = 0;
	if getSF == 0 then
		if LastRandom(1, 5) == 4 then
			val = 0;
		else
			val = LastRandom(1,7) * 10;
		end
	elseif getSF == 1 then
		if LastRandom(1, 7) == 2 then
			val = LastRandom(6,10) * 10;
		elseif LastRandom(1, 3) == 3 then
			val = LastRandom(3,7) * 10;
		else
			val = LastRandom(1,4) * 10;
		end
	elseif getSF == 2 then
		--let's go crazy sometimes to mess up with human player
		if LastRandom(1, 50) == 3 then
			val = 9999;
		elseif LastRandom(1, 7) == 2 then
			val = LastRandom(15,35) * 10;
		elseif LastRandom(1, 4) == 3 then
			val = LastRandom(11,22) * 10;
		else
			val = LastRandom(6,13) * 10;
		end
	end
	if val > 5 then
		if gT.Globals.ScenarioType == 3 then
			val = math.max(5, math.floor(0.8 * val));
		end
	end
	gT.Players[iPlayer].AILogicForCSProductionProject[iBuilding] = val;
end

function GetNameOfPoliticsQuestCS(iPlayer, iQuest)
	if PoliticsCityStateTable[gT.Players[iPlayer].CityStateQuests[iQuest].Politics.ID].FuncName then
		return PoliticsCityStateTable[gT.Players[iPlayer].CityStateQuests[iQuest].Politics.ID].FuncName(iPlayer, iQuest);
	else
		return PoliticsCityStateTable[gT.Players[iPlayer].CityStateQuests[iQuest].Politics.ID].Name;
	end
end

function GetNameOfMissionQuestCS(iPlayer, iQuest, gActive)
	if MissionCityStateTable[gT.Players[iPlayer].CityStateQuests[iQuest].ActivePlayers[gActive].CSMission.ID].FuncName then
		return MissionCityStateTable[gT.Players[iPlayer].CityStateQuests[iQuest].ActivePlayers[gActive].CSMission.ID].FuncName(iPlayer, iQuest);
	else
		return MissionCityStateTable[gT.Players[iPlayer].CityStateQuests[iQuest].ActivePlayers[gActive].CSMission.ID].Name;
	end
end

function DoResolveCSQuestForDomination(iPlayer, totPlayerTable, iQuest, bestAuthorityP, prepPointsFromPolitics, prepPointsFromProject, prepPointsFromMission, prepPointsFromFavour)
	local tIdeoTab = {};
	local tIdeoTabMembers = {};
	for l, s in pairs(gT.Leagues) do
		if s.SpecialProposalTag == "IdeologyL" then
			tIdeoTab[l] = 0;
			tIdeoTabMembers[l] = 0;
		end
	end
	local pLeagueT = {}
	for gPlayer, val in pairs(totPlayerTable) do
		local league = GetIdeologyLeagueOfPlayer(gPlayer);
		if league then
			tIdeoTab[league] = tIdeoTab[league] + val;
			tIdeoTabMembers[league] = tIdeoTabMembers[league] + 1;
			pLeagueT[gPlayer] = league;
		end
	end
	for l, v in pairs(tIdeoTab) do
		if tIdeoTabMembers[l] > 1 then
			tIdeoTab[l] = math.floor(tIdeoTab[l] * GetDenominatorCSQuest(tIdeoTabMembers[l]));
		end
	end
	local bLeagues, tv = {}, 0;
	for l,v in pairs(tIdeoTab) do
		if v > tv then
			bLeagues = {l}
			tv = v;
		elseif v == tv then
			table.insert(bLeagues, l)
		end
	end
	local winLeague;
	if #bLeagues > 0 then
		winLeague = bLeagues[LastRandom(1,#bLeagues)];
		ToPLeagueNewMember(winLeague, iPlayer)
		DominationCSJoinedLeague(winLeague, iPlayer)
	end
	--notification
	for i, gActive in pairs(gT.Globals.HumanPlayers) do
		if totPlayerTable[gActive] then
			if not gT.Players[iPlayer].CSQuestHelpTextOnEnd then
				gT.Players[iPlayer].CSQuestHelpTextOnEnd = {};
			end
			local pLeagueName = "";
			local lthScore = 0;
			if pLeagueT[gActive] then
				lthScore = tIdeoTab[pLeagueT[gActive]];
				pLeagueName = gT.Leagues[pLeagueT[gActive]].Name
			end
			gT.Players[iPlayer].CSQuestHelpTextOnEnd[gActive] = {LeagueLike = true, PlayerLeagueName = pLeagueName, LeagueWinName = gT.Leagues[winLeague].Name, WinLeagueScore = tIdeoTab[winLeague], PLeagueScore = lthScore, LeagueWon = (pLeagueT[gActive] == winLeague), EndTurn = GetITGGameTurn(), Authority = (bestAuthorityP == gActive), COwner = (cultOwnerP == gActive), QuestID = iQuest, TotalPoints = math.floor(totPlayerTable[gActive]), PoliticsP = prepPointsFromPolitics[gActive], MissionP = prepPointsFromMission[gActive], ProjectP = prepPointsFromProject[gActive], InfluenceP = prepPointsFromFavour[gActive]};
			local sText = PrepareEndCSQuestNotificationText(iPlayer, gActive);
			Players[gActive]:AddNotification(NotificationTypes.NOTIFICATION_MINOR, sText, "City-State Politics Ended", GetXXOfMinorCapital(iPlayer, "x"), GetXXOfMinorCapital(iPlayer, "y"))
		end
	end
end

function MCSTCanAssign1(cs, major)
	return (GetValidLuxuryResourceForCSQuest(major, true) ~= -1)
end
function MCSTCanAssign2(cs, major)
	return (GetValidBuildingForCSQuest(major, true) ~= -1)
end
function MCSTCanAssign3(cs, major)
	if not gT.Players[major].CanDoRailroad then
		return false;
	end
	return #GetTabOfAllPossibleRailRoadsToMake(major, true) >= 5;
end
function MCSTCanAssign4(cs, major)
	for fType, index in pairs(gT.Globals.NaturalWonders) do
		if not gT.Players[major].DiscoveredNaturalWonders[index] then
			return true;
		end
	end
	return false;
end
function MCSTCanAssign5(cs, major)
	if gT.Players[major].Goverment ~= 1 then
		if gT.Players[major].LegalPower > 2 then
			return true;
		end
	end
	return false;
end
function MCSTCanAssign6(cs, major)
	return (gT.Players[major].Goverment == 1);
end
function MCSTCanAssign7(cs, major)
	if gT.Players[major].Goverment ~= 1 then
		if gT.Players[major].LegalPower > 3 then
			if #gT.Players[major].PledgesOfProtection == 0 then
				return true;
			end
		end
	end
	return false;
end
function MCSTCanAssign8(cs, major)
	local sPlot = Players[cs]:GetStartingPlot();
	local csTeam = Players[cs]:GetTeam();
	local majorTeam = Players[cs]:GetTeam();
	for index, sth in pairs(gT.BarbarianCamps) do
		local iPlot = Map.GetPlotByIndex(index);
		if Map.PlotDistance(sPlot:GetX(), sPlot:GetY(), iPlot:GetX(), iPlot:GetY()) < 10 then
			if iPlot:IsRevealed(csTeam) and iPlot:IsRevealed(majorTeam) then
				if GetNearestCityOfPlayerToPlot(iPlot:GetX(), iPlot:GetY(), major, 17) then
					return true;
				end
			end
		end
	end
	return false;
end
function MCSTCanAssign9(cs, major)
	return (GetITGGameTurn() % 20 < 10)
end
function MCSTCanAssign10(cs, major)
	return (gT.Players[major].MercCostIncrease == 0)
end
function MCSTCanAssign12(cs, major)
	local c = 0;
	local iTeam = Players[major]:GetTeam();
	for i, v in pairs(gT.Globals.AncientRuins) do
		if not Map.GetPlotByIndex(i):AlreadyVisitedGoodyHut(iTeam) then
			c = c + 1;
			if c >= 5 then
				return true;
			end
		end
	end
	return false;
end
function MCSTCanAssign13(cs, major)
	local c = 0;
	local mTeam = Players[major]:GetTeam();
	for g, h in pairs(gT.Players) do
		if Players[g]:IsMinorCiv() and Players[g]:IsAlive() then
			if not Teams[mTeam]:IsHasMet(Players[g]:GetTeam()) then
				c = c + 1;
				if c >= 2 then
					return true;
				end
			end
		end
	end
	return false;
end
function MCSTCanAssign14(cs, major)
	return (gT.Players[major].FestivalPoints == 0)
end
function MCSTCanAssign15(cs, major)
	local itgTurn = GetITGGameTurn();
	for index, sth in pairs(gT.Academies) do
		if (sth.Player == major) and (sth.Active) and (itgTurn <= sth.SupportCD) then
			return true;
		end
	end
	return false;
end
function MCSTCanAssign16(cs, major)
	local iRel = Players[major]:GetReligionCreatedByPlayer();
	if iRel > 0 and (not gT.Players[cs].SecularState) and (not gT.Players[cs].UntargetByMissionary) then
		if gT.Players[major].CanUseMissionaries then
			local cCity = Players[cs]:GetCapitalCity();
			if cCity then
				if not cCity:IsSpreadImmune() then
					if cCity:GetReligiousMajority() ~= iRel then
						return true;
					end
				end
			end
		end
	end
	return false;
end
function MCSTCanAssign17(cs, major)
	for iCity in Players[major]:Cities() do
		if IsHeresyInCity(iCity) then
			return true;
		end
	end
	return false;
end
function MCSTCanAssign18(cs, major)
	return GetMCSTCityToConnect(major, true)
end
function MCSTCanAssign51(cs, major)
	return GetMCSTStrategicResourceToConnect(major, true)
end
function MCSTCanAssign19(cs, major)
	return GetMCSTCapturedCityToControl(major, true)
end
function MCSTCanAssign20(cs, major)
	return CanDoWonderRaceRightNow(major);
end
function MCSTCanAssign21(cs, major)
	for iCity in Players[major]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		if gT.Cities[cID].Palace then
			if gT.Cities[cID].Palace.NumUpgrades < 9 then
				return true;
			end
		end
	end
	return false;
end
function MCSTCanAssign22(cs, major)
	return (gT.Players[major].GreatPeoplePoints < 300)
end
function MCSTCanAssign23(cs, major)
	return (GetMCSTCommanderToKeepAlive(major, true) ~= nil);
end
function MCSTCanAssign24(cs, major)
	local bCan, iTurn = false, -1;
	for a, b in pairs(gT.ArchaeologyPlots) do
		if (b ~= -1) and (b.TurnStart > iTurn) then
			iTurn = b.TurnStart;
			if b.PlayerDelays[major] then
				bCan = ((iTurn - b.PlayerDelays[major]) > 6);
			else
				bCan = false;
			end
		end
	end
	return bCan;
end
function MCSTCanAssign25(cs, major)
	return (GetMilitaryMightDemographics(major, major, true) > 0);
end
function MCSTCanAssign26(cs, major)
	if Players[major]:GetNumCities() >= 3 then
		return (GetITGSciencePerTurn(major, true) > 0);
	end
	return false;
end
function MCSTCanAssign27(cs, major)
	local c = 0;
	for i, v in pairs(GetTheUnknownTerritoryOfPlayer(major)) do
		c = c + 1;
	end
	return c >= 100;
end
function MCSTCanAssign28(cs, major)
	return HasMintAnyCity(major);
end
function MCSTCanAssign29(cs, major)
	if Players[major]:GetNumCities() >= 3 then
		return (GetTotalCulturePerTurn(major, true) > 0);
	end
	return false;
end
function MCSTCanAssign30(cs, major)
	if not gT.Players[major].SecularState then
		if Players[major]:GetNumCities() >= 3 then
			return (GetTotalFaithFromExtraSourcesITG(major, true) > 0);
		end
	end
	return false;
end
function MCSTCanAssign31(cs, major)
	return (gT.Players[major].Morale < -14);
end
function MCSTSpecialInit1(cs, major, missionID)
	return {ID = missionID, ExtraData = GetValidLuxuryResourceForCSQuest(major)};
end
function MCSTSpecialInit2(cs, major, missionID)
	return {ID = missionID, Left = 3, ExtraData = GetValidBuildingForCSQuest(major)};
end
function MCSTSpecialInit18(cs, major, missionID)
	return {ID = missionID, ExtraData = GetMCSTCityToConnect(major)};
end
function MCSTSpecialInit51(cs, major, missionID)
	local res = GetMCSTStrategicResourceToConnect(major);
	return {ID = missionID, ExtraData = res, InitValue = Players[major]:GetNumResourceTotal(res, true)};
end

function MCSTSpecialInit19(cs, major, missionID)
	return {ID = missionID, ExtraData = GetMCSTCapturedCityToControl(major)};
end
function MCSTSpecialInit23(cs, major, missionID)
	return {ID = missionID, ExtraData = GetMCSTCommanderToKeepAlive(major)};
end
function MCSTSpecialInit34(cs, major, missionID)
	return {ID = missionID, ExtraData = MCSTGetAlliedCSForQuest(cs, major)};
end
function MCSTSpecialInit35(cs, major, missionID)
	return {ID = missionID, ExtraData = MCSTDetermineGGPointsToEarn(major), InitValue = GetGeneratedGeneralPoints(major)};
end
function MCSTSpecialInit37(cs, major, missionID)
	return {ID = missionID, Left = 12 * Players[major]:GetUnitClassCount(GameInfoTypes.UNITCLASS_WORKBOAT)};
end
function MCSTSpecialInit39(cs, major, missionID)
	return {ID = missionID, ExtraData = MCSTGetCityToConquer(major)};
end
function MCSTSpecialInit41(cs, major, missionID)
	return {ID = missionID, ExtraData = MCSTGetLongRangeTRTarget(major)};
end
function MCSTinitCheck25(cs, major)
	return GetMilitaryMightDemographics(major, major, true);
end
function MCSTinitCheck26(cs, major)
	return GetITGSciencePerTurn(major, true);
end
function MCSTinitCheck27(cs, major)
	local c = 0;
	for i, v in pairs(GetTheUnknownTerritoryOfPlayer(major)) do
		c = c + 1;
	end
	return c;
end
function MCSTinitCheck28(cs, major)
	return gT.Players[major].MintPower;
end
function MCSTinitCheck29(cs, major)
	return GetTotalCulturePerTurn(major, true);
end
function MCSTinitCheck30(cs, major)
	return GetTotalFaithFromExtraSourcesITG(major, true);
end
function MCSTinitCheck31(cs, major)
	return gT.Players[major].Morale;
end
function MCSTinitCheck38(cs, major)
	return Players[major]:GetTotalLand();
end
function MCSTinitCheck47(cs, major)
	return Players[major]:GetTotalPopulation();
end
function MCSTCanAssign32(cs, major)
	return (NAT_UNITY_PENALTY_FREE > gT.Players[major].NatUnity)
end
function MCSTCanAssign33(cs, major)
	if gT.Players[major].CSBulliedTimes > 1 then
		local c = 0;
		local majorTeam = Players[major]:GetTeam();
		for g, h in pairs(gT.Players) do
			if Players[g]:IsMinorCiv() and (g ~= cs) and (Teams[majorTeam]:IsHasMet(Players[g]:GetTeam())) then
				c = c + 1;
			end
		end
		return c > 3;
	end
	return false;
end
function MCSTCanAssign34(cs, major)
	return (MCSTGetAlliedCSForQuest(cs, major, true) ~= nil)
end
function MCSTCanAssign35(cs, major)
	return MCSTDetermineGGPointsToEarn(major) >= 100;
end
function MCSTCanAssign36(cs, major)
	return (GetSupportedFishingBoats(major) >= 3 + Players[major]:GetUnitClassCountPlusMaking(GameInfoTypes.UNITCLASS_WORKBOAT))
end
function MCSTCanAssign37(cs, major)
	return (Players[major]:GetUnitClassCount(GameInfoTypes.UNITCLASS_WORKBOAT) >= 2)
end
function MCSTCanAssign38(cs, major)
	return (Players[major]:GetNumCities() > 3)
end
function MCSTCanAssign39(cs, major)
	if Teams[Players[major]:GetTeam()]:GetAtWarCount(true) > 1 then
		if gT.Players[major].NumConquered > 0 then
			return (MCSTGetCityToConquer(major, true) ~= nil)
		end
	end
	return false;
end
function MCSTCanAssign40(cs, major)
	local c = 0;
	for iUnit in Players[major]:Units() do
		if iUnit:GetUpgradeUnitType() ~= -1 then	
			 c = c + 1;
		end
	end
	return c > 2;
end
function MCSTCanAssign41(cs, major)
	return (MCSTGetLongRangeTRTarget(major, true) ~= nil);
end
function MCSTCanAssign43(cs, major)
	for i, data in pairs(gT.Players[major].Agents) do
		if (not data.IgnoreItForever) then
			if not data.Rekonwalescencja then
				if data.Mission == 5 then
					return true;
				end
			end
		end
	end
	return false;
end
function MCSTCanAssign44(cs, major)
	if Teams[Players[major]:GetTeam()]:GetAtWarCount(true) > 1 then
		if gT.Players[major].PillagedImpros > 4 then
			return true;
		end
	end
	return false
end
function MCSTCanAssign45(cs, major)
	return (CountBasicImprovementsPillaged(major) > 4);
end
function MCSTCanAssign46(cs, major)
	if gT.Players[major].CultureEra ~= 9 and gT.Players[major].CultureEra ~= 6 then
		return true;
	end
	return false;
end
function MCSTCanAssign47(cs, major)
	return (Players[major]:GetNumCities() > 3);
end
function MCSTCanAssign48(cs, major)
	return ((Players[major]:GetNumUnitsToSupply() - Players[major]:GetNumUnitsSupplied()) > 0);
end
function MCSTCanAssign49(cs, major)
	for index, sth in pairs(gT.Settlements) do
		if sth.Player == major then
			return true;
		end
	end
	return false;
end
function MCSTCanAssign50(cs, major)
	if gT.Players[major].CultureType == 1 then
		for index, sth in pairs(gT.ElDorados) do
			if Map.GetPlotByIndex(index):GetOwner() ~= major then
				if LastChance(60) then
					return true;
				end
			end
		end
	end
	return false;
end

function PrepareCSMissionDataInitial(iPlayer, g, missionID)
	gT.Players[g].CSMissions[missionID] = (gT.Players[g].CSMissions[missionID] or 0) + 1;
	if MissionCityStateTable[missionID].SpecialInit then
		return MissionCityStateTable[missionID].SpecialInit(iPlayer, g, missionID)
	end
	local tab = {ID = missionID, Left = MissionCityStateTable[missionID].BasicCount, Completed = MissionCityStateTable[missionID].StartCompleted}
	if MissionCityStateTable[missionID].InitCheck then
		tab.InitValue = MissionCityStateTable[missionID].InitCheck(iPlayer, g);
	end
	return tab;
end
function MCSTFuncText1(cs, questID, gActive)
	local iExtraData = gT.Players[cs].CityStateQuests[questID].ActivePlayers[gActive].CSMission.ExtraData;
	return "Acquire " .. GameInfo.Resources[iExtraData].IconString .. " " .. Locale.Lookup(GameInfo.Resources[iExtraData].Description) .. "."
end
function MCSTFuncText2(cs, questID, gActive)
	local iExtraData = gT.Players[cs].CityStateQuests[questID].ActivePlayers[gActive].CSMission.ExtraData;
	return "Construct 3 " .. Locale.Lookup(GameInfo.Buildings[iExtraData].Description) .. "."
end
function MCSTFuncText18(cs, questID, gActive)
	local iExtraData = gT.Players[cs].CityStateQuests[questID].ActivePlayers[gActive].CSMission.ExtraData;
	return "Connect " .. Map.GetPlotByIndex(iExtraData):GetPlotCity():GetName() .. " to your Capital."
end
function MCSTFuncText31(cs, questID, gActive)
	local initValue = gT.Players[cs].CityStateQuests[questID].ActivePlayers[gActive].CSMission.InitValue;
	return "Increase your [ICON_ITG_MORALE] Morale to at least " .. (initValue + 15) .. "%." 
end
function MCSTFuncText51(cs, questID, gActive)
	local iExtraData = gT.Players[cs].CityStateQuests[questID].ActivePlayers[gActive].CSMission.ExtraData;
	local initValue = gT.Players[cs].CityStateQuests[questID].ActivePlayers[gActive].CSMission.InitValue;
	return "Increase your total amount of " .. GameInfo.Resources[iExtraData].IconString .. " " .. Locale.Lookup(GameInfo.Resources[iExtraData].Description).. " to at least " .. (initValue + 2) .. "."
end
function MCSTFuncText19(cs, questID, gActive)
	local iExtraData = gT.Players[cs].CityStateQuests[questID].ActivePlayers[gActive].CSMission.ExtraData;
	return "Keep control over " .. Map.GetPlotByIndex(iExtraData):GetPlotCity():GetName() .. "."
end
function MCSTFuncText23(cs, questID, gActive)
	local iExtraData = gT.Players[cs].CityStateQuests[questID].ActivePlayers[gActive].CSMission.ExtraData;
	return "Keep " .. GetGreatPersonName(iExtraData) .. " alive.";
end
function MCSTFuncText34(cs, questID, gActive)
	local iExtraData = gT.Players[cs].CityStateQuests[questID].ActivePlayers[gActive].CSMission.ExtraData;
	return "Mantain alliance with " .. Players[iExtraData]:GetName() .. ".";
end
function MCSTFuncText35(cs, questID, gActive)
	local iExtraData = gT.Players[cs].CityStateQuests[questID].ActivePlayers[gActive].CSMission.ExtraData;
	return "Generate at least " .. iExtraData .. " [ICON_GREAT_GENERAL] General points.";
end
function MCSTFuncText37(cs, questID, gActive)
	local iExtraData = gT.Players[cs].CityStateQuests[questID].ActivePlayers[gActive].CSMission.Left;
	return "Collect at least " .. iExtraData .. " sea resources."
end
function MCSTFuncText39(cs, questID, gActive)
	local iExtraData = gT.Players[cs].CityStateQuests[questID].ActivePlayers[gActive].CSMission.ExtraData;
	return "Conquer " .. Map.GetPlotByIndex(iExtraData):GetPlotCity():GetName() .. ".";
end
function MCSTFuncText41(cs, questID, gActive)
	local iExtraData = gT.Players[cs].CityStateQuests[questID].ActivePlayers[gActive].CSMission.ExtraData;
	return "Establish Trade-Route with " .. Map.GetPlotByIndex(iExtraData):GetPlotCity():GetName() .. ".";
end
function MCSTSpecialComplete1(cs, questID, gActive)
--... if player acquired resource in last turn it will avoid happiness func...
	local iExtraData = gT.Players[cs].CityStateQuests[questID].ActivePlayers[gActive].CSMission.ExtraData;
	if Players[gActive]:GetNumResourceTotal(iExtraData, true) > 0 then
		return 1;
	end
	return 0;
end
function MCSTSpecialComplete18(cs, questID, gActive)
	local iExtraData = gT.Players[cs].CityStateQuests[questID].ActivePlayers[gActive].CSMission.ExtraData;
	local iCity = Map.GetPlotByIndex(iExtraData):GetPlotCity();
	if iCity:GetOwner() == gActive then
		if IsCityConnectedToCapital(iCity) then
			return 1;
		end
	end
	return 0;
end
function MCSTSpecialComplete51(cs, questID, gActive)
	local iExtraData = gT.Players[cs].CityStateQuests[questID].ActivePlayers[gActive].CSMission.ExtraData;
	local initValue = gT.Players[cs].CityStateQuests[questID].ActivePlayers[gActive].CSMission.InitValue;
	local nowValue = Players[gActive]:GetNumResourceTotal(iExtraData, true);
	if nowValue > initValue then
		return math.min(1, 0.5 * (nowValue - initValue))
	end
	return 0;
end
function MCSTSpecialComplete19(cs, questID, gActive)
	local iExtraData = gT.Players[cs].CityStateQuests[questID].ActivePlayers[gActive].CSMission.ExtraData;
	if Map.GetPlotByIndex(iExtraData):GetOwner() == gActive then
		return 1;
	end
	return 0;
end
function MCSTSpecialCompletePerc(cs, questID, gActive)	
	local misID = gT.Players[cs].CityStateQuests[questID].ActivePlayers[gActive].CSMission.ID;
	local initValue = gT.Players[cs].CityStateQuests[questID].ActivePlayers[gActive].CSMission.InitValue;
	local exceptedPerc = MissionCityStateTable[misID].Perc
	local nowValue = MissionCityStateTable[misID].InitCheck(cs, gActive);
	if nowValue > initValue then
		local perc = math.min(exceptedPerc, (nowValue / initValue) * 100 - 100);
		return perc / exceptedPerc;
	end
	return 0;
end
function MCSTSpecialComplete23(cs, questID, gActive)
	local iExtraData = gT.Players[cs].CityStateQuests[questID].ActivePlayers[gActive].CSMission.ExtraData;
	if gT.GreatPeople[iExtraData].Alive then
		return 1;
	end
	return 0;
end
function MCSTSpecialComplete24(cs, questID, gActive)
	local iExtraData = gT.Players[cs].CityStateQuests[questID].ActivePlayers[gActive].CSMission.BestScore;
	if not iExtraData then
		return 0;
	end
	if iExtraData == 10 then
		return 1;
	elseif iExtraData == 9 then
		return 0.75;
	elseif iExtraData == 8 then
		return 0.5;
	elseif iExtraData == 7 then
		return 0.3;
	elseif iExtraData == 6 then
		return 0.2;
	elseif iExtraData == 5 then
		return 0.1;
	elseif iExtraData == 4 then
		return 0.05;
	end
	return 0;
end
function MCSTSpecialComplete27(cs, questID, gActive)
	local initValue = gT.Players[cs].CityStateQuests[questID].ActivePlayers[gActive].CSMission.InitValue;
	local nowValue = MissionCityStateTable[27].InitCheck(cs, gActive);
	return math.min(100, initValue - nowValue) / 100; 
end
function MCSTSpecialComplete31(cs, questID, gActive)
	local initValue = gT.Players[cs].CityStateQuests[questID].ActivePlayers[gActive].CSMission.InitValue;
	local nowValue = MissionCityStateTable[31].InitCheck(cs, gActive);
	return math.min(15, nowValue - initValue) / 15;
end
function MCSTSpecialComplete32(cs, questID, gActive)
	if NAT_UNITY_PENALTY_FREE > gT.Players[gActive].NatUnity then
		return 0;
	end
	return 1;
end
function MCSTSpecialComplete48(cs, questID, gActive)
	if Players[gActive]:GetNumUnitsToSupply() <= Players[gActive]:GetNumUnitsSupplied() then
		return 1;
	end
	return 0;
end
function MCSTSpecialComplete34(cs, questID, gActive)
	local iExtraData = gT.Players[cs].CityStateQuests[questID].ActivePlayers[gActive].CSMission.ExtraData;
	if Players[iExtraData]:IsAlive() and Players[iExtraData]:GetAlly() == gActive then
		return 1;
	end
	return 0;
end
function MCSTSpecialComplete35(cs, questID, gActive)
	local initValue = gT.Players[cs].CityStateQuests[questID].ActivePlayers[gActive].CSMission.InitValue;
	local toDo = gT.Players[cs].CityStateQuests[questID].ActivePlayers[gActive].CSMission.ExtraData;
	local iDone = math.min(GetGeneratedGeneralPoints(gActive) - initValue, toDo);
	return iDone / toDo;
end
function MCSTSpecialLeft35(cs, questID, gActive)
	local initValue = gT.Players[cs].CityStateQuests[questID].ActivePlayers[gActive].CSMission.InitValue;
	local toDo = gT.Players[cs].CityStateQuests[questID].ActivePlayers[gActive].CSMission.ExtraData;
	return math.max(toDo + initValue - GetGeneratedGeneralPoints(gActive), 0)
end
function MCSTSpecialComplete37(cs, questID, gActive)
	local toDo = gT.Players[cs].CityStateQuests[questID].ActivePlayers[gActive].CSMission.Left;
	local iDone = math.min(toDo, gT.Players[cs].CityStateQuests[questID].ActivePlayers[gActive].CSMission.Count or 0);
	return iDone / toDo;
end
local tournamentT = {GameInfoTypes.UNITCLASS_SPEARMAN, GameInfoTypes.UNITCLASS_SWORDSMAN, GameInfoTypes.UNITCLASS_HORSEMAN, GameInfoTypes.UNITCLASS_PIKEMAN, GameInfoTypes.UNITCLASS_LONGSWORDSMAN, GameInfoTypes.UNITCLASS_KNIGHT, GameInfoTypes.UNITCLASS_COMPOSITE_BOWMAN}
function MCSTTournamentExtraData(cs)
	local hTab = {}
	for i, class in pairs(tournamentT) do
		table.insert(hTab, {class, 1 + Players[cs]:GetUnitClassCount(class)})
	end
	return GetRandomFromBiasedChanceTable(hTab)
end
function MCSTglobal42(cs, d)
	return DoCityStateTournament(cs, d)
end
function MCSTnameTournament(cs, questID, gActive)
	local ecs = gT.Players[cs].CityStateQuests[questID].ExtraMissionData
	local defUnit = GameInfo.UnitClasses[ecs].DefaultUnit;
	return Locale.Lookup(GameInfo.Units[defUnit].Description) .. " Tournament";
end
function MCSTFuncText42(cs, questID, gActive)
	local ecs = gT.Players[cs].CityStateQuests[questID].ExtraMissionData
	local defUnit = GameInfo.UnitClasses[ecs].DefaultUnit;
	return "Prepare your " .. Locale.Lookup(GameInfo.Units[defUnit].Description) .. "-class unit to compete in city-state's tournament (" .. gT.Players[cs].CityStateQuests[questID].EndTurn .. "T).";
end
MissionCityStateTable = {
{ID = 1, Name = "Luxury Resource", Icon = "[ICON_RES_PEPPER]", FuncText = MCSTFuncText1, CanAssign = MCSTCanAssign1, SpecialInit = MCSTSpecialInit1, SpecialComplete = MCSTSpecialComplete1},
{ID = 2, Name = "Construct Buildings", Icon = "[ICON_PRODUCTION]", FuncText = MCSTFuncText2, CanAssign = MCSTCanAssign2, SpecialInit = MCSTSpecialInit2},
{ID = 3, Name = "Create Railroads", Text = "Create 5 Railroads.", Icon = "[ICON_CONNECTED]", BasicCount = 5, ScOff = {[1] = true, [2] = true, [3] = true}, CanAssign = MCSTCanAssign3},
{ID = 4, Name = "Discover Natural Wonder", Text = "Discover Natural Wonder.", Icon = "[ICON_GREAT_EXPLORER]", ScOff = {[4] = true, [5] = true}, CanAssign = MCSTCanAssign4},
{ID = 5, Name = "Change a Law", Text = "Change a Law.", Icon = "[ICON_ITG_LEGAL_POWER]", BasicCount = 1, CanAssign = MCSTCanAssign5},
{ID = 6, Name = "End Anarchy", Text = "Centralize Power within your empire.", Icon = "[ICON_CAPITAL]", CanAssign = MCSTCanAssign6},
{ID = 7, Name = "Establish Protectorate", Text = "Establish Protectorate over any City-State.", Icon = "[ICON_STRENGTH]", CanAssign = MCSTCanAssign7},
{ID = 8, Name = "Clear Barbarian Encampment", Text = "Destroy any Barbarian Camp.", Icon = "[ICON_RAZING]", ScOff = {[4] = true, [5] = true}, CanAssign = MCSTCanAssign8},
{ID = 9, Name = "Acquire Great Works", Text = "Acquire 5 [ICON_GREAT_WORK] Great Works.", Icon = "[ICON_GREAT_WORK]", BasicCount = 5, CanAssign = MCSTCanAssign9},
{ID = 10, Name = "Hire Mercenaries", Text = "Hire a [ICON_ITG_MERCENARY] Mercenary.", Icon = "[ICON_ITG_MERCENARY]", BasicCount = 1, ScOff = {[5] = true}, CanAssign = MCSTCanAssign10},
{ID = 11, Name = "Keep Alive", Text = "Prevent elemination of this City-State.", Icon = "[ICON_FLOWER]", Never = true, StartCompleted = true},
{ID = 12, Name = "Find Ancient Ruins", Text = "Visit 5 Ancient Ruins.", Icon = "[ICON_MOVES]", BasicCount = 5, CanAssign = MCSTCanAssign12, ScOff = {[4] = true, [5] = true}},
{ID = 13, Name = "Meet City-States", Text = "Meet 2 City-States.", Icon = "[ICON_CITY_STATE]", BasicCount = 2, CanAssign = MCSTCanAssign13, ScOff = {[4] = true, [5] = true}},
{ID = 14, Name = "Start Festival", Text = "Start [ICON_ITG_FESTIVAL] Festival in any City.", Icon = "[ICON_ITG_FESTIVAL]", CanAssign = MCSTCanAssign14},
{ID = 15, Name = "Support Academy", Text = "Support twice any Academy.", Icon = "[ICON_ITG_ACADEMY_2]", BasicCount = 2, CanAssign = MCSTCanAssign15, ScOff = {[5] = true}},
{ID = 16, Name = "Proselytize", Text = "Send 2 Missionaries to this City-State.", Icon = "[ICON_MISSIONARY]", BasicCount = 2, CanAssign = MCSTCanAssign16, ScOff = {[3] = true, [4] = true, [5] = true}},
{ID = 17, Name = "Destroy Heresy", Text = "Destroy Heretics occupying your City.", Icon = "[ICON_PROPHET]", CanAssign = MCSTCanAssign17, ScOff = {[3] = true, [4] = true, [5] = true}},
{ID = 18, Name = "Connect a City", FuncText = MCSTFuncText18, Icon = "[ICON_CONNECTED]", SpecialComplete = MCSTSpecialComplete18, SpecialInit = MCSTSpecialInit18, CanAssign = MCSTCanAssign18},
{ID = 19, Name = "Keep Control", FuncText = MCSTFuncText19, Icon = "[ICON_OCCUPIED]", SpecialComplete = MCSTSpecialComplete19, SpecialInit = MCSTSpecialInit19, CanAssign = MCSTCanAssign19},
{ID = 20, Name = "Enter Wonder Race", Text = "Enter Wonder Race.", Icon = "[ICON_GREAT_ENGINEER]", ScOff = {[5] = true}, CanAssign = MCSTCanAssign20},
{ID = 21, Name = "Upgrade Palace", Text = "Upgrade twice any Palace.", Icon = "[ICON_ITG_AUTHORITY]", BasicCount = 2, ScOff = {[5] = true}, CanAssign = MCSTCanAssign21},
{ID = 22, Name = "Generate Great Person", Text = "Generate civilian Great Person.", Icon = "[ICON_GREAT_PEOPLE]", CanAssign = MCSTCanAssign22},
{ID = 23, Name = "Keep Commander Alive", FuncText = MCSTFuncText23, Icon = "[ICON_OMEGA]", SpecialComplete = MCSTSpecialComplete23, CanAssign = MCSTCanAssign23, SpecialInit = MCSTSpecialInit23},
{ID = 24, Name = "Find Archaeological Site", Text = "Locate Archaeological Site before rivals.", Icon = "[ICON_RES_ARTIFACTS]", SpecialComplete = MCSTSpecialComplete24, CanAssign = MCSTCanAssign24, ScOff = {[1] = true, [2] = true, [3] = true, [5] = true}},
{ID = 25, Name = "Increase Military Might", Text = "Increase your Military Might by at least 15%.", Icon = "[ICON_STRENGTH]", Perc = 15, SpecialComplete = MCSTSpecialCompletePerc, CanAssign = MCSTCanAssign25, InitCheck = MCSTinitCheck25},
{ID = 26, Name = "Increase Scientific Output", Text = "Increase your [ICON_RESEARCH] Scientific output by at least 15%.", Icon = "[ICON_RESEARCH]", Perc = 15, SpecialComplete = MCSTSpecialCompletePerc, CanAssign = MCSTCanAssign26, InitCheck = MCSTinitCheck26},
{ID = 27, Name = "Explore", Icon = "[ICON_GREAT_EXPLORER]", Text = "Reveal 100 new tiles.", CanAssign = MCSTCanAssign27, InitCheck = MCSTinitCheck27, SpecialComplete = MCSTSpecialComplete27, ScOff = {[4] = true, [5] = true}},
{ID = 28, Name = "Increase Currency Power", Text = "Increase your [ICON_INVEST] Currency Power by at least 15%.", Icon = "[ICON_INVEST]", Perc = 15, SpecialComplete = MCSTSpecialCompletePerc, CanAssign = MCSTCanAssign28, InitCheck = MCSTinitCheck28, ScOff = {[3] = true}},
{ID = 29, Name = "Increase Cultural Output", Text = "Increase your [ICON_CULTURE] Cultural output by at least 15%.", Icon = "[ICON_CULTURE]", Perc = 15, SpecialComplete = MCSTSpecialCompletePerc, CanAssign = MCSTCanAssign29, InitCheck = MCSTinitCheck29},
{ID = 30, Name = "Increase Faith Output", Text = "Increase your [ICON_PEACE] Faith output by at least 15%.", Icon = "[ICON_PEACE]", Perc = 15, SpecialComplete = MCSTSpecialCompletePerc, CanAssign = MCSTCanAssign30, InitCheck = MCSTinitCheck30, ScOff = {[5] = true}},
{ID = 31, Name = "Increase Morale", Icon = "[ICON_ITG_MORALE]", FuncText = MCSTFuncText31, CanAssign = MCSTCanAssign31, SpecialComplete = MCSTSpecialComplete31, InitCheck = MCSTinitCheck31},
{ID = 32, Name = "Unite Nation", Text = "Reach excepted [ICON_ITG_NAT_UNITY] National Unity value.", Icon = "[ICON_ITG_NAT_UNITY]", SpecialComplete = MCSTSpecialComplete32, CanAssign = MCSTCanAssign32},
{ID = 33, Name = "Bully", Text = "Bully twice City-States (excluding this one!).", Icon = "[ICON_TEAM_11]", BasicCount = 2, CanAssign = MCSTCanAssign33, ScOff = {[5] = true}},
{ID = 34, FuncText = MCSTFuncText34, Name = "Maintain Alliance", Icon = "[ICON_INFLUENCE]", SpecialComplete = MCSTSpecialComplete34, SpecialInit = MCSTSpecialInit34, CanAssign = MCSTCanAssign34},
{ID = 35, FuncText = MCSTFuncText35, Name = "Acquire General", Icon = "[ICON_GREAT_GENERAL]", SpecialLeft = MCSTSpecialLeft35, SpecialComplete = MCSTSpecialComplete35, SpecialInit = MCSTSpecialInit35, CanAssign = MCSTCanAssign35},
{ID = 36, Name = "Construct Workboats", Text = "Construct 3 Workboats.", Icon = "[ICON_RES_WHALE]", BasicCount = 3, CanAssign = MCSTCanAssign36},
{ID = 37, FuncText = MCSTFuncText37, Name = "Go Fishing", Icon = "[ICON_RES_FISH]", CanAssign = MCSTCanAssign37, SpecialComplete = MCSTSpecialComplete37, SpecialInit = MCSTSpecialInit37},
{ID = 38, Name = "Expand territory", Text = "Expand your land territory by at least 15%.", Icon = "[ICON_PLUS]", Perc = 15, SpecialComplete = MCSTSpecialCompletePerc, InitCheck = MCSTinitCheck38, CanAssign = MCSTCanAssign38},
{ID = 39, FuncText = MCSTFuncText39, Name = "Conquer", Icon = "[ICON_OCCUPIED]", SpecialInit = MCSTSpecialInit39, CanAssign = MCSTCanAssign39},
{ID = 40, Name = "Upgrade Units", Text = "Upgrade 3 units.", Icon = "[ICON_SILVER_FIST]", BasicCount = 3, CanAssign = MCSTCanAssign40},
{ID = 41, FuncText = MCSTFuncText41, Name = "Establish Trade-Route", Icon = "[ICON_INTERNATIONAL_TRADE]", SpecialInit = MCSTSpecialInit41, CanAssign = MCSTCanAssign41},
{ID = 42, FuncName = MCSTnameTournament, FuncText = MCSTFuncText42, Icon = "[ICON_WAR]", Never = true, Global = true, ScOff = {[1] = true, [3] = true, [4] = true, [5] = true}, Chance = 6, ExtraData = MCSTTournamentExtraData, OnComplete = MCSTglobal42},
{ID = 43, Name = "Sabotage", Text = "Sabotage 2 buildings.", BasicCount = 2, Icon = "[ICON_SPY]", CanAssign = MCSTCanAssign43},
{ID = 44, Name = "Pillage", Text = "Pillage 5 improvements.", BasicCount = 5, Icon = "[ICON_PIRATE]", CanAssign = MCSTCanAssign44},
{ID = 45, Name = "Repair", Text = "Repair 5 improvements.", BasicCount = 5, Icon = "[ICON_WORKER]", CanAssign = MCSTCanAssign45},
{ID = 46, Name = "New Art Style", Text = "Advance to next Art Style.", Icon = "[ICON_GREAT_ARTIST]", CanAssign = MCSTCanAssign46},
{ID = 47, Name = "Population growth", Text = "Increase your population by at least 15%.", Perc = 15, SpecialComplete = MCSTSpecialCompletePerc, InitCheck = MCSTinitCheck47, Icon = "[ICON_FOOD]", CanAssign = MCSTCanAssign47},
{ID = 48, Name = "Supply", Text = "Supply all your units.", Icon = "[ICON_ITG_SUPPLY]", CanAssign = MCSTCanAssign48, SpecialComplete = MCSTSpecialComplete48},
{ID = 49, Name = "Found a City", Text = "Found a City.", Icon = "[ICON_CITIZEN]", CanAssign = MCSTCanAssign49, ScOff = {[2] = true, [4] = true, [5] = true}},
{ID = 50, Name = "Capture El Dorado", Icon = "[ICON_GOLD]", Text = "Capture El Dorado.", CanAssign = MCSTCanAssign50, ScOff = {[2] = true, [3] = true, [4] = true, [5] = true}},
{ID = 51, Name = "Strategic Resource", Icon = "[ICON_PLUS]", FuncText = MCSTFuncText51, CanAssign = MCSTCanAssign51, SpecialInit = MCSTSpecialInit51, SpecialComplete = MCSTSpecialComplete51, ScOff = {[2] = true, [4] = true}},
}
--gT.Players[gPlayer].CSMissions[misID]
