local scCSchances = {
[GameInfoTypes.MINOR_TRAIT_ANTIQUE] = {0,0,0,100,0},
[GameInfoTypes.MINOR_TRAIT_ENLIGHTENED] = {100,25,50,100,50},
[GameInfoTypes.MINOR_TRAIT_IDEOLOGICAL] = {25,25,25,100,100},
[GameInfoTypes.MINOR_TRAIT_ECONOMIC] = {0,0,0,100,100},
[GameInfoTypes.MINOR_TRAIT_TRADITIONAL] = {100,100,100,25,50},
[GameInfoTypes.MINOR_TRAIT_AGRICULTURAL] = {100,100,75,50,25},
[GameInfoTypes.MINOR_TRAIT_CULTURED] = {100,100,100,100,100},
[GameInfoTypes.MINOR_TRAIT_MILITARISTIC] = {100,100,100,100,100},
[GameInfoTypes.MINOR_TRAIT_MARITIME] = {100,100,100,100,100},
[GameInfoTypes.MINOR_TRAIT_MERCANTILE] = {100,100,100,100,100},
[GameInfoTypes.MINOR_TRAIT_RELIGIOUS] = {75,100,75,25,25},
}

function IsValidPlotToBeMaritime(iPlot)
	for j = 0, 5 do
		local jPlot = Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), j);
		if jPlot and jPlot:IsWater() then
			if not jPlot:IsImpassable() then
				if gT.ValidOceanFish[GetOceanID(jPlot)] then
					return true;
				end
			end
		end
	end
	return false;
end

function InitCityStates(minorTab)
	local bNoMaritime = true;
	local reducedInTime = {}
	
	for row in GameInfo.MinorCivTraits() do
		gT.Globals.CSbyTypes[row.ID] = {}
	end
	for jjjj, minor in pairs(minorTab) do
		local baseChance = {}
		for row in GameInfo.MinorCivTraits() do
			if scCSchances[row.ID][gT.Globals.ScenarioType] ~= 0 then
				baseChance[row.ID] = scCSchances[row.ID][gT.Globals.ScenarioType]
			end
		end
		if IsValidPlotToBeMaritime(Players[minor]:GetStartingPlot()) then
			if not bNoMaritime then
				baseChance[GameInfoTypes.MINOR_TRAIT_MARITIME] = baseChance[GameInfoTypes.MINOR_TRAIT_MARITIME] + 100;
			end
		else
			baseChance[GameInfoTypes.MINOR_TRAIT_MARITIME] = nil;
		end
		if gT.EraData and gT.PreviousEra then
			for i, v in pairs(gT.EraData) do
				if v.CityStatesTypes[minor] and (baseChance[v.CityStatesTypes[minor]]) then
					baseChance[v.CityStatesTypes[minor]] = baseChance[v.CityStatesTypes[minor]] + math.min(50, baseChance[v.CityStatesTypes[minor]])
				end
			end
		end
		local pTab = {}
		for i, v in pairs(baseChance) do
			table.insert(pTab, {i, math.max(v + (reducedInTime[i] or 0), 1)})
		end
		local csType = GetRandomFromBiasedChanceTable(pTab)
		Players[minor]:SetMinorCivTrait(csType)
		if csType == GameInfoTypes.MINOR_TRAIT_MARITIME then
			bNoMaritime = false;
		end
		reducedInTime[csType] = (reducedInTime[csType] or 0) - 5;
		table.insert(gT.Globals.CSbyTypes[csType], minor)
		--era ancient could have override in future for CS type !!!
	end
end