local SubCultUniqCST;
local CultUniqCST;
local ae5inno = GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_EMPIRE_6;
local ancCSt30 =  GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_30;
local indusInno8 = GameInfoTypes.TECH_UNIQUE_ITG_INDUSTRIAL_8;
local innoindu15 = GameInfoTypes.TECH_UNIQUE_ITG_INDUSTRIAL_15;

function DefineCSUUTypes()
	if SubCultUniqCST then
		return;
	end
	SubCultUniqCST = {};
	CultUniqCST = {};
	for row in DB.Query("SELECT * FROM ITG_SubculturesCSUU") do
		local iType = ITG_SubcultureTypes[row.SubcultureType]
		if not SubCultUniqCST[iType] then
			SubCultUniqCST[iType] = {};
		end
		table.insert(SubCultUniqCST[iType], GameInfo.Units[row.UnitType].ID);
	end
	for row in DB.Query("SELECT * FROM ITG_CulturesCSUU") do
		local iType = ITG_CultureTypes[row.CultureType]
		if not CultUniqCST[iType] then
			CultUniqCST[iType] = {};
		end
		table.insert(CultUniqCST[iType], GameInfo.Units[row.UnitType].ID);
	end
end

GameEvents.CityStateGiveUnit.Add(function(eMajor, unittype, x, y, eMinor)
	local rut = Players[eMinor]:GetPlayerUniqueUnit(GameInfoTypes[GameInfo.Units[unittype].Class]);
	if rut == -1 then
		rut = GetAnyValidMilitaryUnitType(eMinor, "DOMAIN_LAND");
	end
	if rut ~= -1 then
		local jUnit = Players[eMajor]:InitUnit(rut, x, y)
		if rut == Players[eMinor]:GetMinorCivUniqueUnit() then
			jUnit:SetCannotSelfUpgrade(true)
		end
		jUnit:JumpToNearestValidPlot()
		ITGSCNewUnitCreated(eMajor, jUnit, nil, false, nil, nil, false)
		if eMajor == Game.GetActivePlayer() then
			Players[eMajor]:AddNotification(NotificationTypes.NOTIFICATION_GENERIC, "The city-state of " .. Players[eMinor]:GetName() .. " has gifted us an unit - " .. jUnit:GetName() .. ".", "Unit Gift", jUnit:GetX(), jUnit:GetY())
		end
		if gT.Players[eMajor] then
			if gT.Players[eMajor].HasIdeology[10] then
				local hStrength = math.min(5, GetNumAlliedCS(eMajor))
				if hStrength > 0 then
					ChangeITGBaseCombatStrength(jUnit, hStrength, hStrength)
				end
			end
		end
	end
end)

GameEvents.MajorGiftedUnit.Add(function(eMinor, unitID, eMajor)
	print("Major is gifting unit", eMajor, eMinor, unitID)
	local jUnit = Players[eMinor]:GetUnitByID(unitID)
	if jUnit then
		ITGSCNewUnitCreated(eMinor, jUnit, nil, false, nil, nil, false)
	else
		print("Major gifted unit that does not exist", eMajor, eMinor);
	end
end)

GameEvents.CityStateBuyoutUnitGift.Add(function(eMajor, unitID, eMinor)
	local jUnit = Players[eMajor]:GetUnitByID(unitID)
	print("Major received unit from buyout minor", eMajor, unitID, jUnit:GetName(), eMinor)
	ITGSCNewUnitCreated(eMajor, jUnit, nil, false, nil, nil, false)
end)


function AssignUniqueCityStateUnitsBasedOnCulture(minorTab)
	DefineCSUUTypes()
	for i, player in pairs(minorTab) do
		Players[player]:SetMinorCivUniqueUnit(GetUniqueUnitForCityState(player))
	end
end

function GetUniqueUnitForCityState(player)
	if gT.Players[player].SubcultureType and SubCultUniqCST[gT.Players[player].SubcultureType] and #SubCultUniqCST[gT.Players[player].SubcultureType] > 0 then
		return RandomFromTab(SubCultUniqCST[gT.Players[player].SubcultureType]);
	else
		return RandomFromTab(CultUniqCST[gT.Players[player].CultureType]);
	end
	print("Error undefined cs unique unit", player);
end

function AssignInitialDecayAnchorRecovery(hMajorTab, hMinorTab)
	if not DBScenario.NoCSCultureAffection then
		for i, player in pairs(hMajorTab) do
			for it, mPlayer in pairs(hMinorTab) do
				if gT.Players[player].CultureType == gT.Players[mPlayer].CultureType then
					Players[mPlayer]:ChangeMinorCivExtraAnchorWithMajor(player, 15)
				else
					Players[mPlayer]:ChangeMinorCivDecayModWithMajor(player, 25)
					Players[mPlayer]:ChangeMinorCivRecoveryModWithMajor(player, -25)
				end
			end
		end
	end
end

function CreateBarbarianUnitFromRiots(iPlayer, plot, domain, bPlayer, iCity, bHeresy, cIDuprising)
	local rut = GetAnyValidMilitaryUnitType(iPlayer, domain, true, bPlayer)
	if (not bHeresy) and (not cIDuprising) then
		if HasPlayerTech(iPlayer, ancCSt30, "032i4234032") then
			if LastRandom(1,3) == 2 then
				bPlayer = iPlayer;
			end
		end
	end
	if rut ~= -1 then
		local jUnit = Players[bPlayer]:InitUnit(rut, plot:GetX(), plot:GetY())
		if iPlayer ~= bPlayer then
			if not cIDuprising then -- uprising is special
				local strMod = 0;
				if HasPlayerTech(iPlayer, indusInno8, "5643534") then
					strMod = strMod - 0.1;
				end
				if IsHasLaw(iPlayer, 5, 1) then
					strMod = strMod - 0.1;
				elseif IsHasLaw(iPlayer, 5, 3) then
					jUnit:ChangeMaxHitPoints(-10);
				end
				if strMod ~= 0 then
					local tReduceStr = math.ceil(strMod * GameInfo.Units[jUnit:GetUnitType()].Combat);
					if tReduceStr > 0 then
						ChangeITGBaseCombatStrength(jUnit, tReduceStr, tReduceStr)
					end
				end
			end
			local ohPlayer = -1;
			if bPlayer == 63 then
				local iOwner = iCity:GetOriginalOwner();
				if iOwner ~= iPlayer then
					ohPlayer = Players[iOwner]:GetTeam();
				end
			else
				ohPlayer = Players[bPlayer]:GetTeam()
				jUnit:SetTargetPlotForCombatMod(iCity:Plot():GetPlotIndex());
			end
			jUnit:SetRebelOriginAgainst(ohPlayer, Players[iPlayer]:GetTeam())
			jUnit:SetIsUnjoinable(true)
		end
		if not Players[bPlayer]:IsBarbarian() then
			ITGSCNewUnitCreated(bPlayer, jUnit, nil, false, nil, nil, false)
		else
			jUnit:SetTerritoryRestrictedTo(iPlayer);
			if not Players[iPlayer]:IsMinorCiv() then
				jUnit:SetIgnoredForCityStateInfluence(true);
			end
			if bHeresy then
				jUnit:SetForcedITGStackType(-1);
				jUnit:SetImmobile(true)
				jUnit:SetName("Heretic")
			end
			if cIDuprising then
				gT.Globals.UprisingCID[jUnit:GetID()] = cIDuprising;
				gT.Cities[cIDuprising].Uprising[jUnit:GetID()] = true;
				jUnit:SetForcedITGStackType(-1);
				jUnit:SetImmobile(true)
				jUnit:SetName("Insurgent")
			end
		end
		return 1;
	end
	return 0;
end

GameEvents.SetAlly.Add(function(csPlayer, oldAlly, newAlly)
	gT.Players[csPlayer].LastAllyChange = GetITGGameTurn();
	if gT.Players[oldAlly] then
		if gT.Players[oldAlly].CultBonusOn[87] then
			Players[csPlayer]:ChangeMinorCivDecayModWithMajor(oldAlly, 50);
		end
		if HasPlayerTech(oldAlly, ae5inno, "adsegewa") then
			ChangeBulliableCorruptableCS(csPlayer, -1, -1)
		end
		if gT.Players[newAlly] then
			if HasPlayerTech(oldAlly, innoindu15, "kvkoekwow") then
				if not gT.Players[oldAlly].ImperialismCD then
					Players[oldAlly]:SetPlayerHasTrait(GameInfoTypes.TRAIT_ITG_INDUSTRIAL_15, 1);
				end
				gT.Players[oldAlly].ImperialismCD = GetITGGameTurn() + 7;
			end
		end
	end
	if gT.Players[newAlly] then
		gT.Players[newAlly].EverAlliedCS[csPlayer] = 1;
		if gT.Players[newAlly].CultBonusOn[87] then
			Players[csPlayer]:ChangeMinorCivDecayModWithMajor(newAlly, -50);
		end
		if HasPlayerTech(newAlly, ae5inno, "adsegewa") then
			ChangeBulliableCorruptableCS(csPlayer, 1, 1)
		end
		if gT.Players[oldAlly] then
			if HasPlayerTech(newAlly, innoindu15, "kvkoekwow") then
				TakeCareOfEventMorale(newAlly, 25, {1, "Imperialism"})
			end
		end
	end
	local validPlayersForAnchorLeague = {}
	for b, d in pairs(gT.Leagues) do
		if d.Members[newAlly] then
			if d.Resolutions[5] then
				for imember, sth in pairs(d.Members) do
					if newAlly ~= imember then
						ChangeFriendAnchorAmount(imember, csPlayer, 1)
					end
				end
			end
		end
		if d.Members[oldAlly] then
			if d.Resolutions[5] then
				for imember, sth in pairs(d.Members) do
					if oldAlly ~= imember then
						ChangeFriendAnchorAmount(imember, csPlayer, -1)
					end
				end
			end
		end
	end
	AdjustStrengthOfAllCities(csPlayer) -- ideology tenet 5
end)

function ChangeBulliableCorruptableCS(hPlayer, iam, cam)
	gT.Players[hPlayer].CSUnbulliable = iam + gT.Players[hPlayer].CSUnbulliable;
	gT.Players[hPlayer].CSUncorruptable = cam + gT.Players[hPlayer].CSUncorruptable;
	Players[hPlayer]:SetCannotBeBullied(gT.Players[hPlayer].CSUnbulliable > 0);
	Players[hPlayer]:SetCannotBeInfluencedWithGold(gT.Players[hPlayer].CSUncorruptable > 0);
end

function ChangeFriendAnchorAmount(iPlayer, minor, amount)
	gT.Players[iPlayer].CSfriendanchor[minor] = (gT.Players[iPlayer].CSfriendanchor[minor] or 0) + amount;
	Players[minor]:SetAnchorGrantFriendship(iPlayer, gT.Players[iPlayer].CSfriendanchor[minor] > 0)
end

function AdoptRemoveResLeagueCSAnchor(leagueID, change)
	for g, gdata in pairs(gT.Players) do
		if Players[g]:IsMinorCiv() then
			if gT.Leagues[leagueID].Members[Players[g]:GetAlly()] then
				for iMember, sth in pairs(gT.Leagues[leagueID].Members) do
					if iMember ~= Players[g]:GetAlly() then
						ChangeFriendAnchorAmount(iMember, g, change)					
					end
				end
			end
		end
	end
end

GameEvents.GoldGiftFromMajor.Add(function(minor, major, iGold, iFriendshipChange)
	gT.Players[major].GoldSpendOnMinorGifts = gT.Players[major].GoldSpendOnMinorGifts + iGold;
	if Players[major]:IsHuman() then
		LuaEvents.ITG_AchievementCountChange(91, iGold)
	end
	gT.Players[major].InfluenceFromGoldGifts = gT.Players[major].InfluenceFromGoldGifts + iFriendshipChange;
end)

function GetSafeSpotToSpawn(iPlayer, iPlot)
	if iPlot:IsWater() then
		local oceanID = GetOceanID(iPlot)
		for iCity in Players[iPlayer]:Cities() do
			if not IsCityThreatened(iCity, iPlayer) then
				local tt = GetCoastOfCoastsTab(iCity:Plot())
				for i, d in pairs(tt) do
					if d == oceanID then
						return iCity:Plot();
					end
				end
			end
		end
	else
		local contID = GetContID(iPlot, "6453fc")
		for iCity in Players[iPlayer]:Cities() do
			if not IsCityThreatened(iCity, iPlayer) then
				if contID == GetContID(iCity:Plot(), "34324") then
					return iCity:Plot();
				end
			end
		end
	end
	return nil;
end

function TryToSpawnUnitInSafeCity(iPlayer, unitType, x, y)
	local iPlot = GetSafeSpotToSpawn(iPlayer, Map.GetPlot(x, y))
	if iPlot then
		SimpleGenerateUnitOfType(iPlayer, unitType, iPlot, nil, nil, false, false, false, nil, 1)
	end
end

--MASS SPAWNING AROUND CITY (either land or sea)
function SpawnRandomUnitsAroundPlot(iPlayer, iAmount, tPlot)
	local sPlots = {}
	for i = 0, 5 do
		local nPlot = Map.PlotDirection(tPlot:GetX(), tPlot:GetY(), i)
		if nPlot then
			if nPlot:IsWater() then
				table.insert(sPlots, {nPlot:GetX(), nPlot:GetY(), "DOMAIN_SEA"})
			else
				table.insert(sPlots, {nPlot:GetX(), nPlot:GetY(), "DOMAIN_LAND"})
			end
		end
	end
	if #sPlots == 0 then
		print("Impossiblue 9534/1234")
		return;
	end
	for i = 1, iAmount do
		local lIndex = LastRandom(1,#sPlots);
		local iType = GetAnyValidMilitaryUnitType(iPlayer, sPlots[lIndex][3])
		local jUnit = Players[iPlayer]:InitUnit(iType, sPlots[lIndex][1], sPlots[lIndex][2])
		if gT.Players[iPlayer] then
			ITGSCNewUnitCreated(iPlayer, jUnit, nil, false, nil, nil, false)
		end
		jUnit:JumpToNearestValidPlot() -- so we don't spawn on impassable;
	end
end

function SpawnRandomUnits(iPlayer, iAmount, bFullyStackable, fdomain)
	if not Players[iPlayer]:IsAlive() then
		return;
	end
	local bPlot;
	if Players[iPlayer]:GetCapitalCity() then
		bPlot = Players[iPlayer]:GetCapitalCity():Plot()
	else
		for iUnit in Players[iPlayer]:Units() do
			local cPlot = iUnit:GetPlot()
			if ((fdomain or "DOMAIN_LAND") == "DOMAIN_LAND") == (not cPlot:IsWater()) then
				bPlot = cPlot;
				break;
			end
		end
	end
	if not bPlot then
		print("Cant spawn units", iPlayer, iAmount, bFullyStackable, fdomain)
		return;
	end
	local x, y = bPlot:GetX(), bPlot:GetY();
	for i = 1, iAmount do
		local iType = GetAnyValidMilitaryUnitType(iPlayer, fdomain or "DOMAIN_LAND")
		local jUnit = Players[iPlayer]:InitUnit(iType, x, y)
		if gT.Players[iPlayer] then
			ITGSCNewUnitCreated(iPlayer, jUnit, nil, false, nil, nil, false)
		end
		if bFullyStackable then
			SetUnitForcedStackType(jUnit, -1, "SRU", -1)
		else
			jUnit:JumpToNearestValidPlot()
		end	
	end
end

function SetDirtyCanDominateCS(iPlayer)
	Players[iPlayer]:SetCanDominateMinor(CanDominateCS(iPlayer))
end

function CanDominateCS(iPlayer)
	if gT.Players[iPlayer].HasIdeology[32] then
		return true;
	end
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_31, "gerercwec") then
		return true;
	end
	return false;
end

function GetShortlyRelationsTowardsCS(gPlayer, g, projectType)
	if not gT.Players[gPlayer].CSTargetRelation[g] then
		gT.Players[gPlayer].CSTargetRelation[g] = GetStrategicValueOfCSRelation(gPlayer, g);
	end
	local bLate = GetITGGameTurn() > 80;
	if projectType == 3 then
		if gT.Players[gPlayer].Goverment == 1 then
			return -1;
		end
		if LastRandom(1, 4) == 3 then
			return 0;
		end
	elseif projectType == 8 then
		if gT.Players[gPlayer].AISettlerPointsManagement then
			if gT.Players[gPlayer].AISettlerPointsManagement.Type ~= 1 then
				return 2;
			end
		end
	elseif projectType == 4 then
		if gT.Players[gPlayer].SecularState then
			return 2;
		end
	end
	if projectType == 2 then
		if LastRandom(1, 5) > Players[gPlayer]:GetNumCities() then
			return -1;
		end
	end
	if Players[g]:IsProtectedByMajor(gPlayer) then
		if not bLate then
			return gT.Players[gPlayer].CSTargetRelation[g] - 1;
		end
	end
	if Players[g]:GetMinorCivFriendshipLevelWithMajor(gPlayer) > 1 then
		return math.max(1, gT.Players[gPlayer].CSTargetRelation[g]);
	elseif Players[g]:GetMinorCivFriendshipLevelWithMajor(gPlayer) > 0 then
		if bLate then
			return 2;
		else
			return math.max(1, gT.Players[gPlayer].CSTargetRelation[g]);
		end
	elseif Players[g]:GetMinorCivFriendshipWithMajor(gPlayer) < 0 then
		if bLate then
			return 1;
		end
		return 0;
	else
		return gT.Players[gPlayer].CSTargetRelation[g];
	end
end

function GetStrategicValueOfCSRelation(gPlayer, g)
	local cCity = Players[g]:GetCapitalCity();
	if not cCity then
		return 0;
	end
	local numCities = Players[gPlayer]:GetNumCities()
	local nCity = GetNearestCityOfPlayerToPlot(cCity:GetX(), cCity:GetY(), gPlayer, 8);
	if nCity then
		return 2;
	end
	local gTurn = GetITGGameTurn()
	if gTurn < 30 then
		local tc = 0;
		for gdplayer, gddata in pairs(gT.Players) do
			if Players[gdplayer]:IsMinorCiv() then
				if Teams[Players[gPlayer]:GetTeam()]:IsHasMet(Players[gdplayer]:GetTeam()) then
					tc = tc + 1;
				end
			end
		end
		if tc <= numCities then
			return 2;
		end
	end
	local h = 0;
	for a, b in pairs(gT.Players[gPlayer].CSTargetRelation) do
		if b >= 2 then
			h = h + 1;
		end
	end
	if LastRandom(1, Players[gPlayer]:GetNumCities()) >= h then
		return 2;
	end
	return LastRandom(0, 1);
end

function GetNearestCityStateToXY(iPlayer, x, y, bNonHostile, bNonAllied)
	local dis = 999;
	local bPlayer;
	local pTeam = Teams[Players[iPlayer]:GetTeam()];
	for g, h in pairs(gT.Players) do
		if Players[g]:IsMinorCiv() and Players[g]:IsAlive() and (Players[g]:GetNumCities() > 0) then
			if pTeam:IsHasMet(Players[g]:GetTeam()) then
				if (not bNonHostile) or (not pTeam:IsAtWar(Players[g]:GetTeam())) then
					if (not bNonAllied) or (Players[g]:GetAlly() ~= iPlayer) then
						local cCity = Players[g]:GetCapitalCity();
						local distance = Map.PlotDistance(x, y, cCity:GetX(), cCity:GetY());
						if distance < dis then
							dis = distance;
							bPlayer = g;
						end
					end
				end
			end
		end
	end
	return bPlayer;
end

function DoBoostNearestCityStateInfluence(iPlayer, x, y, amount, bNonHostile, bNonAllied)
	if amount == 0 then
		return;
	end
	local bPlayer = GetNearestCityStateToXY(iPlayer, x, y, bNonHostile, bNonAllied);
	if bPlayer then
		Players[bPlayer]:ChangeMinorCivFriendshipWithMajor(iPlayer, amount);
	end
end