local bWonderPyramid1 = GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_4;
local itgpantheon18 =  GameInfoTypes.BELIEF_ITG_PANTHEON_18;
local techinnomeso1 =GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_MESOAMERICAN_1;
local itgpantheon13 = GameInfoTypes.BELIEF_ITG_PANTHEON_13;
local itgpantheon9 = GameInfoTypes.BELIEF_ITG_PANTHEON_9;
local itgpfollower23 = GameInfoTypes.BELIEF_ITG_FOLLOWER_23;
local itgfollowers32 = GameInfoTypes.BELIEF_ITG_FOLLOWER_32;
local techAsia4 = GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_ASIA_4;
local itgfollower40 = GameInfoTypes.BELIEF_ITG_FOLLOWER_40;
local gmedwonder12 = GameInfoTypes.BUILDING_ITG_NEW_MEDIEVAL_WONDER_12;

LuaEvents.ITGSG_RequestBaseYieldModifications.Add(function(iCity, yield)
	if yield == yFood then
		MapModData.ITGSG = GetBaseFoodRateITG(iCity)
	elseif yield == yProduction then
		MapModData.ITGSG = GetBaseProductionRateITG(iCity)
	elseif yield == yGold then
		MapModData.ITGSG = GetBaseGoldRateITG(iCity)
	elseif yield == yCulture then
		MapModData.ITGSG = GetBaseCultureRateITG(iCity)
	elseif yield == yFaith then
		MapModData.ITGSG = GetBaseFaithRateITG(iCity);
	elseif yield == yScience then
		MapModData.ITGSG = GetBaseScienceRateITG(iCity);
	end
end)

LuaEvents.ITGSG_RequestCityViewDataDetail.Add(function(iCity, type)
	if type == "WorkPT" then
		MapModData.ITGSG = GetTooltipWorkRatePerTurn(iCity)
	elseif type == "SettlerPT" then
		MapModData.ITGSG = GetTooltipSettlerPT(iCity)
	elseif type == "WorkStored" then
		MapModData.ITGSG = GetTooltipWorkRateStored(iCity)
	elseif type == "LegalPT" then
		MapModData.ITGSG = GetTooltipLegalPT(iCity)
	elseif type == "UnhapChance" then
		MapModData.ITGSG = GetTooltipUnhapChance(iCity)
	elseif type == "HapChance" then
		MapModData.ITGSG = GetTooltipHapChance(iCity)
	elseif type == "Health" then
		MapModData.ITGSG = GetTooltipCVHealth(iCity)
	elseif type == "GPAttr" then
		MapModData.ITGSG = GetTooltipCVGPattr(iCity)
	elseif type == "TRAttr" then
		MapModData.ITGSG = GetTooltipCVTRattr(iCity)
	elseif type == "Production" then
		MapModData.ITGSG = GetToolTipITGProduction(iCity)
	elseif type == "Food" then
		MapModData.ITGSG = GetToolTipITGFood(iCity)
	elseif type == "Culture" then
		MapModData.ITGSG = GetToolTipITGCulture(iCity)
	elseif type == "Gold" then
		MapModData.ITGSG = GetToolTipITGGold(iCity)
	elseif type == "Science" then
		MapModData.ITGSG = GetToolTipITGScience(iCity)
	elseif type == "Social Mood" then
		MapModData.ITGSG = GetToolTipITGSocialMoods(iCity)
	elseif type == "CPresence" then
		MapModData.ITGSG = GetToolTipITGCPresence(iCity)
	elseif type == "XP" then
		MapModData.ITGSG = GetToolTipITGxp(iCity)
	elseif type == "NatUnity" then
		MapModData.ITGSG = GetToolTipITGNatUnity(iCity)
	end
end)

function GetTooltipCVHealth(iCity)
	local iPlayer = iCity:GetOwner();
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local hString = "[ICON_ITG_HEALTH_1] Health modifiers of the city."
	local hTbb = {}
	table.insert(hTbb, {1, "Base"})
	table.insert(hTbb, {gT.Players[iPlayer].HealthFromTech, "Technologies"})
	table.insert(hTbb, {GetHealthFromBuildings(iCity, iPlayer), "Buildings"})
	table.insert(hTbb, {gT.Cities[cID].HealthFromEpidemy, "Recent Epidemies"})
	table.insert(hTbb, {gT.Cities[cID].HealthFromGP, "Great People"})
	table.insert(hTbb, {GetITGCityInteger(iCity, "CI_GOV_HEALTH"), "Governance"})
	table.insert(hTbb, {GetHealthFromWonder(iCity, iPlayer), "Wonders"})
	table.insert(hTbb, {GetHealthFromReligion(iCity, iPlayer), "Religion"})
	table.insert(hTbb, {GetHealthFromLaws(iCity, cID, iPlayer), "Laws"})
	table.insert(hTbb, {GetHealthFromSocialPolicies(iCity, iPlayer), "Social Development"})
	table.insert(hTbb, {GetHealthFromInnovations(iCity, cID, iPlayer), "Innovations"})
	table.insert(hTbb, {GetHealthFromAcademies(iCity, iPlayer), "Academies"})
	table.insert(hTbb, {GetHealthFromPolioVaccine(), "Polio Vaccine"})
	table.insert(hTbb, {GetHealthFromQZ(cID), "Quarantine Zone"})
	table.insert(hTbb, {GetHealthFromBudget(iCity), "Healthcare"})
	table.insert(hTbb, {GetHealthFromFestival(iCity, cID, iPlayer), "Festival"})
	table.insert(hTbb, {GetHealthFromForeignDoctors(iPlayer), "Foreign Doctors"})
	table.insert(hTbb, {GetHealthFromLeagues(iPlayer), "Leagues"})
	table.insert(hTbb, {GetHealthFromIdeology(iCity, cID, iPlayer), "Ideology"})
	table.insert(hTbb, {-iCity:GetPopulation(), "Population"})

	for i, v in pairs(hTbb) do
		if v[1] > 0 then
			hString = hString .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]+" .. v[1] .. "[ENDCOLOR] [ICON_ITG_HEALTH_1] Health from " .. v[2] .. "."
		elseif v[1] < 0 then
			hString = hString .. "[NEWLINE][ICON_BULLET][COLOR_NEGATIVE_TEXT]" .. v[1] .. "[ENDCOLOR] [ICON_ITG_HEALTH_3] Health from " .. v[2] .. "."
		end
	end
	local hpp = GetITGCityInteger(iCity, "CI_HEALTH_FOOD_RATE")
	if hpp >= 0 then
		hString = hString .. "[NEWLINE][NEWLINE][ICON_FOOD] Food modifier from [ICON_ITG_HEALTH_1] Health: [COLOR_POSITIVE_TEXT]" ..  hpp .. "%[ENDCOLOR]."
		if not DBScenario.SettlersOff then
			hString = hString .. "[NEWLINE]Positive [ICON_ITG_HEALTH_1] Health increase [ICON_ITG_SETTLER] Settler generation from [ICON_FOOD] Food.";
		end
	else
		hString = hString .. "[NEWLINE][NEWLINE][ICON_FOOD] Food modifier from [ICON_ITG_HEALTH_3] Health: [COLOR_NEGATIVE_TEXT]" ..  hpp .. "%[ENDCOLOR].[NEWLINE]Negative [ICON_ITG_HEALTH_3] Health increase chance to generate [ICON_HAPPINESS_4] Unhappiness.";
	end

	if HasPlayerNatureWonder(iPlayer, GameInfoTypes.FEATURE_FOUNTAIN_YOUTH) then
		hString = hString .. "[NEWLINE][NEWLINE]Lethality of [ICON_ITG_PLAGUE_4] Epidemies is reduced due to Fountain of Youth."
	end
	return hString
end

function GetTooltipSettlerPT(iCity)
	if DBScenario.SettlersOff then
		return ""
	end
	local iPlayer = iCity:GetOwner();
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local hString = "[ICON_ITG_SETTLER] Settler points generated each turn by a city."
	local sPercentFromFood = GetPercentageOfCityFoodIntoSettler(iCity, iPlayer)
	if sPercentFromFood > 0 then
		hString = hString .. "[NEWLINE][NEWLINE]Each turn percentage of [ICON_FOOD] Food surplus is also added to [ICON_ITG_SETTLER] Settler points:"
		local spTab = {}
		table.insert(spTab, {GetPercentageFoodSurplusFromBuildings(iCity, iPlayer), "Buildings"})
		table.insert(spTab, {GetPercentageFoodSurplusFromLaws(iCity, iPlayer), "Laws"})
		table.insert(spTab, {GetPercentageFoodSurplusFromSocDev(iCity, iPlayer), "Social developments"})
		table.insert(spTab, {GetPercentageFoodSurplusFromBeliefs(iCity, iPlayer), "Beliefs"})
		table.insert(spTab, {GetPercentageFoodSurplusFromHealth(iCity, iPlayer, cID), "Health"})
		
		for i, v in pairs(spTab) do
			if v[1] ~= 0 then
				hString = hString .. "[NEWLINE][ICON_BULLET]" .. v[1] .. "% of [ICON_FOOD] from " .. v[2]
			end
		end
		hString = hString .. "[NEWLINE]----------------"
		hString = hString .. "[NEWLINE][COLOR_POSITIVE_TEXT]" .. sPercentFromFood * 100 .. "% of [ICON_FOOD] Total[ENDCOLOR]" 
	end
	local totalSettler = GetSettlerPointsFromCity(iCity, iPlayer, true)	
	if totalSettler ~= 0 then
		hString = hString .. "[NEWLINE][NEWLINE]Sources of [ICON_ITG_SETTLER] Settler points:"
		local tab = {}
		table.insert(tab, {GetSettlerPointsCityFromFoodDif(iCity, iPlayer), "Food surplus"})
		table.insert(tab, {GetSettlerPointsCityFromBuildings(iCity, iPlayer), "Buildings"})
		table.insert(tab, {GetSettlerPointsCityFromPopulation(iCity), "Population"})
		table.insert(tab, {GetSettlerPointsCityFromBeliefs(iCity, iPlayer), "Beliefs"})
		table.insert(tab, {GetSettlerPointsCityFromFarms(iCity, iPlayer), "Farms"})

		for i, data in pairs(tab) do
			if data[1] > 0 then
				hString = hString .. "[NEWLINE][ICON_BULLET]" .. data[2] .. ": +" .. data[1]
			elseif data[1] < 0 then
				hString = hString .. "[NEWLINE][ICON_BULLET]" .. data[2] .. ": " .. data[1]
			end
		end
		--MODS
		local nc = Players[iPlayer]:GetNumCities() - 1;
		if nc > 0 then
			hString = hString .. "[NEWLINE]----------------"
			hString = hString .. "[NEWLINE][COLOR_NEGATIVE_TEXT]-" .. math.min(nc, 75)  .. "%[ENDCOLOR] modifier from number of cities."
		end
		--
		hString = hString .. "[NEWLINE]----------------"
		hString = hString .. "[NEWLINE][COLOR_POSITIVE_TEXT]" .. totalSettler .. " [ICON_ITG_SETTLER] Total[ENDCOLOR]" 
	else
		hString = hString .. "[NEWLINE][NEWLINE]City does not generate any [ICON_ITG_SETTLER] Settler points.";
	end
	return hString;
end

function GetTooltipWorkRatePerTurn(iCity)
	local iPlayer = iCity:GetOwner();
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local hString = "[ICON_WORKER] Work generated each turn by a city."
	if not ITGCityCanWorkDoAction(iCity) then
		return hString .. "[NEWLINE]During [ICON_RESISTANCE] Riots, Resistance or [ICON_ITG_PLAGUE_4] Epidemy, [ICON_WORKER] Work Rate is not increased.";
	end
	local baseTab = {}
	table.insert(baseTab, {10, "City"}) 
	table.insert(baseTab, {GetCityWorkRateFromBuildings(iCity), "Buildings"}) 
	table.insert(baseTab, {GetWorkRateFromPalace(iCity, cID, iPlayer), "Palace"})
	table.insert(baseTab, {GetWorkRateFromTechs(iCity, cID, iPlayer), "Technologies"})
	table.insert(baseTab, {GetWorkRateFromGovernance(iCity), "Governance"})
	table.insert(baseTab, {GetWorkRateFromBeliefs(iCity, iPlayer), "Religion"})
	table.insert(baseTab, {GetWorkRateFromWonderOrRuin(iCity, iPlayer), "Wonder Ruins"})
	local base = 0;
	for j, b in pairs(baseTab) do
		base = base + b[1];
		if b[1] > 0 then
			hString = hString .. "[NEWLINE][ICON_BULLET]+" .. b[1] .. " [ICON_WORKER] from " .. b[2] .. "."
		end
	end
	hString = hString .. "[NEWLINE][COLOR_POSITIVE_TEXT]" .. base .. " [ICON_WORKER] Base[ENDCOLOR]" 
	hString = hString .. "[NEWLINE]----------------"
	if GetITGCityInteger(iCity, "CI_GP_WORK_MOD") ~= 0 then
		hString = hString .. "[NEWLINE][ICON_BULLET]Great People modifier: " ..  GetITGCityInteger(iCity, "CI_GP_WORK_MOD") .. "%"
	end
	if gT.Players[iPlayer].HasPlayerWonder[bWonderPyramid1] then
		hString = hString .. "[NEWLINE][ICON_BULLET]Pyramids modifier: 50%"
	end
	hString = hString .. "[NEWLINE]----------------"
	local tabW = {}
	local ex = 0;
	table.insert(tabW, {GetWorkRateFromGov(iCity, iPlayer), "Goverment"})
	table.insert(tabW, {GetWorkRateFromIdeologies(iCity, cID, iPlayer), "Ideologies"})
	table.insert(tabW, {GetWorkRateFromLaws(iCity, iPlayer), "Laws"})
	table.insert(tabW, {GetWorkRateFromCultDevs(iCity, iPlayer, cID), "Cultural Development"})
	table.insert(tabW, {GetEstimatedWorkRateFromBudget(iPlayer), "Budget"})
	table.insert(tabW, {GetWorkFromCityStates(iPlayer, iCity), "City-States"})
	table.insert(tabW, {GetWorkFromManufactories(iPlayer, iCity), "Manufactories"})
	table.insert(tabW, {GetWorkRateFromProcess(iCity), "Infrastructure"})
	for i, v in pairs(tabW) do
		if v[1] ~= 0 then
			hString = hString .. "[NEWLINE][ICON_BULLET]" .. v[1] .. " [ICON_WORKER] from " .. v[2]
			ex = ex + v[1];
		end
	end
	hString = hString .. "[NEWLINE]----------------"
	if ex > 0 then
		hString = hString .. "[NEWLINE][COLOR_POSITIVE_TEXT]" .. ex .. " [ICON_WORKER] Extra[ENDCOLOR]" 
		hString = hString .. "[NEWLINE]----------------"
	end
	hString = hString .. "[NEWLINE][COLOR_POSITIVE_TEXT]" .. GetWorkRateIncreasement(iPlayer, iCity, cID, true) .. " [ICON_WORKER] Total[ENDCOLOR]" 
	return hString;
end

function GetTooltipWorkRateStored(iCity)
	local hString = "Stored[ICON_WORKER] Work Rate may be used to repair or create new improvement, or constructing routes."
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local iPlayer = iCity:GetOwner();
	if gT.Players[iPlayer].CultBonusOn[44] then
		hString = hString .. "[NEWLINE]This city can spend " .. DBScenario.WorkRatePerAttack .. " [ICON_WORKER] Work Rate on additional ranged strike (social development)."
	end
	if gT.Cities[cID].CurrentWorkAction == -1 then
		hString = hString .. "[NEWLINE][NEWLINE]This city has no plans on spending [ICON_WORKER] Work Rate currently. If no action is available, City will spend 2000 [ICON_WORKER] Work Rate to acquire free Building."
	elseif gT.Cities[cID].CurrentWorkAction == 1 then
		hString = hString .. "[NEWLINE][NEWLINE]This city is planning to build new improvement (requires up to " .. GetCityImprovementCost(cID, iCity, iPlayer) .. " [ICON_WORKER])."
	elseif gT.Cities[cID].CurrentWorkAction == 2 then
		hString = hString .. "[NEWLINE][NEWLINE]This city is planning to build a new route (cost depends on length)."
	elseif gT.Cities[cID].CurrentWorkAction == 3 then
		hString = hString .. "[NEWLINE][NEWLINE]This city is planning to remove a Marsh, Forest or Jungle (requires " .. GetCostToRemoveFeature(iPlayer) .. " [ICON_WORKER])."
	elseif gT.Cities[cID].CurrentWorkAction == 4 then
		hString = hString .. "[NEWLINE][NEWLINE]This city is planning to support an Academy (requires 500 [ICON_WORKER])."
	elseif gT.Cities[cID].CurrentWorkAction == 5 then
		hString = hString .. "[NEWLINE][NEWLINE]This city is planning to construct new Fort (requires 1500 [ICON_WORKER])."
	elseif gT.Cities[cID].CurrentWorkAction == 6 then
		hString = hString .. "[NEWLINE][NEWLINE]This city is planning to send extra Trade Route (requires 800 [ICON_WORKER])."
	elseif gT.Cities[cID].CurrentWorkAction == 7 then
		hString = hString .. "[NEWLINE][NEWLINE]This city is planning to start new Festival (requires 800 [ICON_WORKER])."
	elseif gT.Cities[cID].CurrentWorkAction == 8 then
		hString = hString .. "[NEWLINE][NEWLINE]This city is planning to improve Work Injury Insurance (requires 500 [ICON_WORKER])."
	end
	return hString;
end

function GetTooltipLegalPT(iCity)
	local hString = "[ICON_ITG_LEGAL_POWER] Legal Power generated each turn by a city."
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local iPlayer = iCity:GetOwner();
	if not ITGCityCanWorkDoAction(iCity) then
		return hString .. "[NEWLINE]During [ICON_RESISTANCE] Riots, Resistance or [ICON_ITG_PLAGUE_4] Epidemy [ICON_ITG_LEGAL_POWER] Legal Power is not icreased.";
	end

	local tab = {}
	table.insert(tab, {GetLegalPointsFromBuilding(iCity, iPlayer),"Buildings"})
	table.insert(tab, {GetCityLegalFromReligion(iCity, iPlayer, cID),"Religion"})
	table.insert(tab, {GetCityLegalFromCultBonuses(iCity, iPlayer, cID),"Social Developments"})
	table.insert(tab, {GetCityLegalFromTenshu(iCity, iPlayer, cID),"Tenshu"})


	local legP = 0;
	for i, v in pairs(tab) do
		if v[1] ~= 0 then
			legP = legP + v[1];
			hString = hString .. "[NEWLINE][ICON_BULLET]" .. v[1]/100 .. " [ICON_ITG_LEGAL_POWER] from " .. v[2]
		end
	end
	local legalmod = GetCityLegalMod(iCity, cID, iPlayer);
	if legalmod ~= 100 then
		legP = math.floor(legP * legalmod / 100)
		hString = hString .. "[NEWLINE]----------------"
		hString = hString .. "[NEWLINE]Increased by [COLOR_POSITIVE_TEXT]" ..  (legalmod - 100) .. "%[ENDCOLOR]."
	end
	hString = hString .. "[NEWLINE]----------------"
	hString = hString .. "[NEWLINE][COLOR_POSITIVE_TEXT]" .. legP/100 .. " [ICON_ITG_LEGAL_POWER] Total[ENDCOLOR]" 
	return hString;
end

function GetTooltipHapChance(iCity)
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local iPlayer = iCity:GetOwner();
	local hString = "Chance for city to generate [ICON_HAPPINESS_1] Happiness each turn or roll."
	local tab = {}
	table.insert(tab, {10,"Base"})
	table.insert(tab, {GetHapChanceFromLaws(iCity, iPlayer, cID),"Laws"})
	table.insert(tab, {GetHapChanceFromPalaces(iCity, iPlayer, cID),"Palace"})
	table.insert(tab, {GetITGLocalHappiness(iCity) * 10,"Local Happiness"})
	table.insert(tab, {gT.Cities[cID].HapChanceFromGP,"Great People"})
	table.insert(tab, {GetHapChanceFromsSocialDevelopments(iCity, iPlayer, cID),"Social Developments"})
	table.insert(tab, {GetHapChanceFromNaturalWonders(iCity, iPlayer, cID),"Natural Wonders"})
	table.insert(tab, {GetHapChanceFromTechnologies(iCity, iPlayer, cID),"Innovations"})
	table.insert(tab, {GetHapChanceFromAcademies(iCity, iPlayer, cID),"Academies"})
	table.insert(tab, {GetHapChanceFromWonder(iCity, iPlayer, cID),"Wonders"})
	table.insert(tab, {GetHapChanceFromCorruption(iCity, iPlayer, cID),"Corruption"})
	table.insert(tab, {GetHapChanceFromCityIdeology(iCity, iPlayer, cID), "Ideologies"})
	table.insert(tab, {GetHapChanceFromColonies(iPlayer, iCity),"Colony"})
	table.insert(tab, {GetHapChanceFromFestivals(iCity, iPlayer, cID), "Festival"})
	table.insert(tab, {GetHapChanceFromManufactories(iPlayer, iCity),"Manufactories"})
	table.insert(tab, {GetHapChanceFromGarrisoned(iCity, iPlayer, cID),"Garrison"})
	table.insert(tab, {GetHapChanceFromRiverWarlord(iCity, iPlayer),"River Warlord"})
	table.insert(tab, {GetHapChanceFromHappiness(iCity, iPlayer, cID),"Happiness Overflow"})
	table.insert(tab, {GetPlayerHapChance(iPlayer),"Player Modifier"})
	for i, v in pairs(tab) do
		if v[1] ~= 0 then
			hString = hString .. "[NEWLINE][ICON_BULLET]" .. v[1]/10 .. "% [ICON_HAPPINESS_1] from " .. v[2]
		end
	end
	hString = hString .. "[NEWLINE]----------------"
	if gT.Cities[cID].ReadyToRiot and gT.Players[iPlayer].HasIdeology[26] then
		hString = hString .. "[NEWLINE]Ideological tenet ''We the People'' is now disabling chances to generate [ICON_HAPPINESS_1] Happiness in this City."
		hString = hString .. "[NEWLINE]----------------"
	end
	hString = hString .. "[NEWLINE][COLOR_POSITIVE_TEXT]" .. GetGenerateHappinessChanceCity(iCity, iPlayer, cID, nil, true)/10 .. "% [ICON_HAPPINESS_1] Total[ENDCOLOR]" 
	return hString;
end

function GetTooltipUnhapChance(iCity)
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local iPlayer = iCity:GetOwner();
	local hString = "Chance for city to generate [ICON_HAPPINESS_4] Unhappiness from training Military Units: [COLOR_NEGATIVE_TEXT]" .. GetUnhappinessChanceForMilitaryUnit(iPlayer, iCity, true)/10 .. "%[ENDCOLOR].[NEWLINE][NEWLINE]"
	hString = hString .. "Chance for city to generate [ICON_HAPPINESS_4] Unhappiness each turn or roll."

	local gTT = {}
	table.insert(gTT, {10, "Base"})
	table.insert(gTT, {GetUnhapChanceFromPopulation(iCity, iPlayer, cID), "Population"})
	table.insert(gTT, {GetHapModifierFromHeresy(iCity, true), "Heresy"})
	table.insert(gTT, {GetUnhapChanceFromLocalHappiness(iCity, iPlayer, cID), "Local Happiness (" .. GetITGLocalHappiness(iCity) .. "[ICON_HAPPINESS_1])"})
	table.insert(gTT, {GetUnhapChanceFromOccupied(iCity, iPlayer, cID), "being Occupied"})
	table.insert(gTT, {GetUnhapChanceFromLawsCity(iCity, iPlayer, cID, true), "Laws"})
	table.insert(gTT, {GetUnhapChanceFromSocialDev(iCity, iPlayer, cID), "Social Developments"})
	table.insert(gTT, {GetUnhapChanceFromHealth(iCity, iPlayer, cID), "Health"})
	table.insert(gTT, {GetUnhapChanceFromCodex(iPlayer), "Codex"})
	table.insert(gTT, {GetUnhapChanceFromTech(iCity, iPlayer, cID), "Technologies"})
	table.insert(gTT, {GetUnhapChanceFromDefenses(iCity, iPlayer, cID), "Defenses"})
	table.insert(gTT, {GetUnhapChanceFromTemplarBuildings(iCity, iPlayer), "Templar Buildings"})
	table.insert(gTT, {GetUnhapChanceFromNegativeLaw(iCity, iPlayer, cID), "Weak Legitimacy"})
	table.insert(gTT, {GetUnHapChanceFromRailroad(iCity, iPlayer, cID), "Railroad connection"})
	table.insert(gTT, {GetUnhapChanceFromGovernance(iCity), "Governance"})
	table.insert(gTT, {GetUnhapChanceFromAbolition(iCity, iPlayer, cID), "Aboliton Movements"})
	table.insert(gTT, {GetUnhapFromPrinciples(iPlayer), "Backward Principles"})
	table.insert(gTT, {GetUnhapChanceFromSriPada(iCity, iPlayer, cID), "Sri Pada"})
	
	table.insert(gTT, {- 10 * GetHapFromNaturalWonders(iPlayer, iCity:GetID()), "Natural Wonders"})
	table.insert(gTT, {GetUnhapChanceFromAcademies(iCity, iPlayer, cID), "Academies"})
	table.insert(gTT, {GetUnhapChanceFromGoldenAge(iCity, iPlayer, cID), "Golden Age"})
	table.insert(gTT, {GetUnhapChanceFromIdeologies(iCity, iPlayer, cID), "Ideologies"})
	for i, data in pairs(gTT) do
		if data[1] ~= 0 then
			hString = hString .. "[NEWLINE][ICON_BULLET]" .. data[1]/10 .. "% [ICON_HAPPINESS_4] from " .. data[2]
		end
	end
	hString = hString .. "[NEWLINE]----------------"
	if gT.Players[iPlayer].AuthorityRank == 1 then
		if gT.Players[iPlayer].GovRewards[5] then
			if iCity:IsCapital() then
				hString = hString .. "[NEWLINE][ICON_BULLET]Maximum chance is limited to 50% (Elites).";
			end
		end
	end
	hString = hString .. "[NEWLINE][COLOR_NEGATIVE_TEXT]" .. GetGenerateUnhappinessChanceCity(iCity, iPlayer, cID, true, false)/10 .. "% [ICON_HAPPINESS_4] Total[ENDCOLOR]" 
	return hString;
end

function GetToolTipITGFood(iCity)
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local iPlayer = iCity:GetOwner();
	local hString;
	local hTab = {};
	hString = iCity:GetYieldModifierTooltip(yFood)
	local cMod = iCity:GetBaseYieldRateModifier(yFood) - 100;
--health for sure //
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_IDEO_82"), "Megacities"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_HORSE_FOOD"), "Horse-blood"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_INNO_TRIBE_15"), "Preserving Identity"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_GP_FOOD_MOD"), "Great People"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_IDEO_71"), "Planned Economy"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_INNO_ARAB_TRIAL_7"), "Occasionalism"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_INNO_ARAB_TRIAL_8"), "Viziers"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_HEALTH_FOOD_RATE"), "Health"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_IDEO_61_FOOD"), "Survival of the fittest"})
	table.insert(hTab, {GetFoodRateFromFestivalNow(iCity, cID, iPlayer), "Festival"})
	if GetITGCityInteger(iCity, "CI_CULT_136") ~= 0 then
		table.insert(hTab, {100, "Restoration (" .. GetITGCityInteger(iCity, "CI_CULT_136") - GetITGGameTurn() .. "T)" })
	end
	
	for i, data in pairs(hTab) do
		cMod = cMod - data[1];
	end
	table.insert(hTab, {cMod, "City Modifier"})
	for i, data in pairs(hTab) do
		if data[1] ~= 0 then
			hString = hString .. "[NEWLINE][ICON_BULLET]" .. data[2] .. ": " .. data[1].. "%"
		end
	end
	if hString == "[NEWLINE]----------------" then
		hString = ""
	end
	return hString;
end
function GetToolTipITGCulture(iCity)
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local iPlayer = iCity:GetOwner();
	local hString;
	hString = iCity:GetYieldModifierTooltip(yCulture)
	local hTab = {};
	local cMod = iCity:GetBaseYieldRateModifier(yCulture) - 100;
	table.insert(hTab, {Players[iPlayer]:GetCultureCityModifier(), "Player's modifier"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_CULTURE_FROM_MAP"), "Cartographers"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_HERBAL_MED_CULTURE"), "Herbal Medicine"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_IDEO_27"), "Manufactured Holidays"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_IDEO_60"), "Pop-art"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_IDEO_40"), "Provincial Life"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_IDEO_72"), "Labouring Class"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_IDEO_61_CULTURE"), "Survival of the fittest"})
	table.insert(hTab, {GetCultureRateFromFestivalNow(iCity, cID, iPlayer), "Festival"})
	
	for i, data in pairs(hTab) do
		cMod = cMod - data[1];
	end
	table.insert(hTab, {cMod, "City Modifier"})
	for i, data in pairs(hTab) do
		if data[1] ~= 0 then
			hString = hString .. "[NEWLINE][ICON_BULLET]" .. data[2] .. ": " .. data[1].. "%"
		end
	end
	if hString == "[NEWLINE]----------------" then
		hString = ""
	end
	return hString;
end

function GetToolTipITGProduction(iCity)
--ONLY MODIFIERS!
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local iPlayer = iCity:GetOwner();
	local hString;
	hString = iCity:GetYieldModifierTooltip(yProduction)
	local hTab = {}
	local unitType = iCity:GetProductionUnit();
	if (unitType ~= -1 and (not GameInfo.Units[unitType].FakeCivilian)) or (gT.Players[iPlayer].HasIdeology[56]) then
		local dDomain = -1; 
		local dMod = 0;
		if unitType ~= -1 then
			dDomain = GameInfoTypes[GameInfo.Units[unitType].Domain]
		end
		if dDomain ~= -1 then
			dMod = iCity:GetDomainProductionModifier(dDomain) + Players[iPlayer]:GetDomainProductionModifier(dDomain);
		end
		local dTab = {}
		table.insert(dTab, {GetITGCityInteger(iCity, "CI_MIL_IDEO_5"), "Brotherhood Army"})
		table.insert(dTab, {GetITGCityInteger(iCity, "CI_MIL_LAW"), "Conscription (Law)"})
		table.insert(dTab, {GetITGCityInteger(iCity, "CI_MIL_PROD_SMALL_ARMY"), "Small Army"})
		table.insert(dTab, {GetITGCityInteger(iCity, "CI_COMMON_MIL_SERVICE"), "Common Military Service"})
		table.insert(dTab, {GetITGCityInteger(iCity, "CI_CULT_48"), "Spare Supply"})
		
		for i, data in pairs(dTab) do
			dMod = dMod - data[1]
		end
		table.insert(dTab, {dMod, "Modifier for Unit Domain"})
		for i, data in pairs(dTab) do
			if data[1] ~= 0 then
				hString = hString .. "[NEWLINE][ICON_BULLET]" .. data[2] .. ": " .. data[1].. "%"
			end
		end
	end
	local cMod = iCity:GetBaseYieldRateModifier(yProduction) - 100;
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_FACTORY_PROD"), "Factory"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_CORRUPTION_PROD"), "Corruption"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_POVERTY_PROD"), "Solving Poority"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_OIL_PROD_MOD"), "Oil"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_LAW_SPEC_PROD"), "Specialization"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_IDEO_71"), "Planned Economy"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_MANUFACTORY_PROD"), "Manufactories"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_ORDER_HARMONY"), "Order and Harmony"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_GOVERNANCE_PROD"), "Governance"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_INNO_ARAB_TRIAL_7"), "Occasionalism"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_INNO_ARAB_TRIAL_8"), "Viziers"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_CULT_25"), "Sun Never Sets"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_WILL_CROWD"), "Will of the Crowd"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_NO_IDEOLOGY_MOD"), "being Free from Ideology"})
	if GetITGCityInteger(iCity, "CI_CULT_136") ~= 0 then
		table.insert(hTab, {100, "Restoration (" .. GetITGCityInteger(iCity, "CI_CULT_136") - GetITGGameTurn() .. "T)" })
	end
	if GetITGCityInteger(iCity, "CI_EQUALITY_CONQUEST") > 0 then
		table.insert(hTab, {GetITGCityInteger(iCity, "CI_EQUALITY_CONQUEST"), "Step Forward (" .. GetITGCityInteger(iCity, "CI_EQUALITY_TURN") - GetITGGameTurn() .. ")"})
	end
	if gT.Cities[cID].FestivalET then
		if gT.Players[iPlayer].FestivalBonusesActive[13] then
			table.insert(hTab, {gT.Players[iPlayer].FestivalBonusesActive[13], "Festival"})
		end
	end
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_STATUE_OF_LIBERTY"), "Statue of Liberty"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_PROD_ACADEMY"), "Academy"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_PROD_FROM_MORALE"), "Morale"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_PROD_UNREG_TRADE"), "Unregulated Trade"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_MINT_PROD_RATE"), "Currency Strength"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_FEST_LAW_24_PROD"), "Festival (Law)"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_HORSE_PROD"), "Horse-blood"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_CODEX_PROD"), "Codex"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_ORDER_PROD"), "Order"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_INNO_TRIBE_15"), "Preserving Identity"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_IDEO_67"), "Greener Grass"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_IDEO_78"), "Autocracy"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_IDEO_82"), "Citizens"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_IDEO_87"), "Age of Reason"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_TEMP_PROD"), "Disturbance"})
		
	
	if Players[iPlayer]:IsGoldenAge() then
		table.insert(hTab, {50, "Golden Age"})		
	end
	for i, data in pairs(hTab) do
		cMod = cMod - data[1];
	end
	table.insert(hTab, {cMod, "City Modifier"})
	for i, data in pairs(hTab) do
		if data[1] ~= 0 then
			hString = hString .. "[NEWLINE][ICON_BULLET]" .. data[2] .. ": " .. data[1].. "%"
		end
	end
	if hString == "[NEWLINE]----------------" then
		hString = ""
	end
	return hString;
end

function GetTooltipCVGPattr(iCity)
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local iPlayer = iCity:GetOwner();
	local hString = "[ICON_ITG_CHARM] Charm increases Cities' attractivity for Great People."
	local tab = {}
	table.insert(tab, {20,"Base"})
	table.insert(tab, {gT.Players[iPlayer].AverageHappiness,"Empire Happiness"})
	table.insert(tab, {GetCharmFromGreatPeople(iCity, iPlayer, cID),"Great People"})
	table.insert(tab, {GetITGCityInteger(iCity, "CI_GOV_CHARM"),"Governance"})
	table.insert(tab, {GetGPAttrPlayer(iPlayer),"Player's modifier"})
	table.insert(tab, {GetGPAttrFromCityStates(iPlayer),"City-States"})
	table.insert(tab, {GetGPAttrFromPrinciples(iPlayer),"Principles"})
	table.insert(tab, {GetGPAttrFromBuildings(iCity, iPlayer, cID),"Buildings"})
	table.insert(tab, {GetGPAttrFromIdeologies(iCity, iPlayer, cID),"Ideologies"})
	table.insert(tab, {GetGPAttrFromSocialDevelopments(iCity, iPlayer, cID),"Social Developments"})
	table.insert(tab, {GetGPAttrFromLaws(iCity, iPlayer, cID),"Laws"})
	table.insert(tab, {GetGPAttrFromPalace(iCity, iPlayer, cID),"Palace"})
	table.insert(tab, {GetGPAttrFromGoverment(iCity, cID, iPlayer),"Goverment"})
	table.insert(tab, {GetGPAttrFromManufactories(iCity, iPlayer, cID),"Manufactories"})
	table.insert(tab, {GetGPAttrFromAcademies(iCity, iPlayer, cID),"Academy"})
	table.insert(tab, {GetGPAttrFromPlague(iCity, iPlayer, cID),"Plague"})
	table.insert(tab, {GetGPAttrFromResistance(iCity, iPlayer, cID),"Resistance"})
	table.insert(tab, {GetGPAttrFromCapital(iCity, iPlayer, cID),"Capital"})
	table.insert(tab, {GetCityGPAttractiveness(iCity, iPlayer, cID),"Festival"})
	for i, data in pairs(tab) do
		if data[1] > 0 then
			hString = hString .. "[NEWLINE][ICON_BULLET]" .. data[2] .. ": +" .. data[1]
		elseif data[1] < 0 then
			hString = hString .. "[NEWLINE][ICON_BULLET]" .. data[2] .. ": " .. data[1]
		end
	end
	local bChanceTotal = GetBaseCityGPAttractiveness(iCity, iPlayer, cID)
	hString = hString .. "[NEWLINE]----------------"
	hString = hString .. "[NEWLINE][COLOR_POSITIVE_TEXT]" .. bChanceTotal .. " Total[ENDCOLOR][NEWLINE][NEWLINE]Outcome is affected by favours unique to each Great Person (religion, patriotism, home-loving, happiness-seeking, wonder-admiring and others)."
	hString = hString .. "[NEWLINE]----------------"
	local charm = GetTempStoredGPCityCharm(iCity:Plot():GetPlotIndex(), iCity, iPlayer, cID);
	local iPercentCharm = math.floor(100 * (1 - 100 / (100 + charm)));
	hString = hString .. "[NEWLINE]In addition current [ICON_ITG_CHARM] Charm slows down migration by [COLOR_POSITIVE_TEXT]" .. iPercentCharm .. "%[ENDCOLOR]."	
	return hString;
end

function GetTooltipCVTRattr(iCity)
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local iPlayer = iCity:GetOwner();
	local hString = "Trade appeal increases chances for City to become a destination of [ICON_SWAP] Trade Routes."
	local tab = {}
	table.insert(tab, {10,"Base"})
	table.insert(tab, {GetBaseCityTRattrCapital(iCity, iPlayer, cID),"Capital"})
	table.insert(tab, {GetCityTRAttrFromCustomsHouse(iCity, iPlayer, cID),"Customs House"})
	table.insert(tab, {gT.Cities[cID].TRAttrFromGP,"Great People"})
	table.insert(tab, {GetITGCityInteger(iCity, "CI_GOV_TR_APPEAL"),"Governance"})
	table.insert(tab, {GetBaseCityTRattrReligion(iCity, iPlayer, cID),"Religion"})
	table.insert(tab, {GetBaseCityTRattrBuildings(iCity),"Buildings"})
	table.insert(tab, {GetBaseCityTRattrLaws(iCity, iPlayer),"Laws"})
	table.insert(tab, {GetBaseCityTRattrGoverment(iCity, cID, iPlayer),"Goverment"})
	table.insert(tab, {GetBaseCityTRattrWonders(iCity, iPlayer, cID),"Wonders"})
	table.insert(tab, {GetBaseCityTRattrGoldenAge(iCity, iPlayer, cID),"Golden Age"})
	table.insert(tab, {GetBaseCityTRattrKasbahs(cID),"Kasbahs"})
	table.insert(tab, {GetCityTRattrFestival(iCity, iPlayer, cID),"Festival"})
	table.insert(tab, {GetBaseCityTRPalace(iCity, iPlayer, cID),"Palace"})

	for i, data in pairs(tab) do
		if data[1] > 0 then
			hString = hString .. "[NEWLINE][ICON_BULLET]" .. data[2] .. ": +" .. data[1] .. " [ICON_TRADE_WHITE]"
		elseif data[1] < 0 then
			hString = hString .. "[NEWLINE][ICON_BULLET]" .. data[2] .. ": " .. data[1] .. " [ICON_TRADE_WHITE]"
		end
	end
	local bChanceTotal = GetBaseCityTRAttractiveness(iCity, iPlayer, cID)
	hString = hString .. "[NEWLINE]----------------"
	hString = hString .. "[NEWLINE][COLOR_POSITIVE_TEXT]" .. bChanceTotal .. " [ICON_TRADE_WHITE] Total[ENDCOLOR][NEWLINE][NEWLINE]Outcome is affected by conditional variables (based for example on Trade Route origin)."
	local cTab = {}
	table.insert(cTab, {GetCityTRAttractivenessHolyCity(iCity),"(Religion) Holy City"})
	table.insert(cTab, {GetCityTRAttrLawInternational(iPlayer),"(Foreign) Law"})
	if gT.Players[iPlayer].StAlphabet == iPlayer then
		table.insert(cTab, {10,"(Foreign) Using your Alphabet"})
	end
	table.insert(cTab, {5,"(Foreign) Embassy at Them"})
	table.insert(cTab, {-20,"(Foreign) each Embargo"})
	table.insert(cTab, {-30,"(Foreign) War"})
	if iCity:IsPlague() then
		table.insert(cTab, {-1000,"Plague"})
	end
	for i, data in pairs(cTab) do
		if data[1] > 0 then
			hString = hString .. "[NEWLINE][ICON_BULLET]" .. data[2] .. ": +" .. data[1] .. " [ICON_TRADE_WHITE]"
		elseif data[1] < 0 then
			hString = hString .. "[NEWLINE][ICON_BULLET]" .. data[2] .. ": " .. data[1] .. " [ICON_TRADE_WHITE]"
		end
	end
	return hString;
end

function GetToolTipITGGold(iCity)
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local iPlayer = iCity:GetOwner();
	local hString = iCity:GetYieldModifierTooltip(yGold)
	local hTab = {}
	local cMod = iCity:GetBaseYieldRateModifier(yGold) - 100;
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_CORRUPTION_GOLD"), "Corruption"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_NEW_BEGINNINGS"), "New Beginnings"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_MINT_GOLD_RATE"), "Currency Strength"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_OCCUPIED_GOLD_RATE"), "Occupation"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_HORSE_GOLD"), "Horse-blood"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_GOLD_BIG_PHARMA"), "Big Pharma"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_INNO_ARAB_TRIAL_7"), "Occasionalism"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_INNO_ARAB_TRIAL_8"), "Viziers"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_HERESY_GOLD"), "Heresy"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_CULT_25"), "Sun Never Sets"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_GP_GOLD"), "Great People"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_CALCULUS_GOLD"), "Calculus"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_GOVERMENT_GOLD"), "Goverment"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_LAW_SPEC_GOLD"), "Specialization"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_WEST_ABBEY_GOLD"), "Westminster Abbey"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_GOLD_ACADEMY"), "Academy"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_GOLD_MOD_LAW_27"), "Academic Privileges"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_GOLD_UNREG_TRADE"), "Unregulated Trade"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_STATUE_OF_LIBERTY"), "Statue of Liberty"})
	table.insert(hTab, {-GetITGCityInteger(iCity, "CI_IDEO_71"), "Planned Economy"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_NO_IDEOLOGY_MOD"), "being Free from Ideology"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_RIVER_WARLORD_GOLD"), "River Warlord"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_IDEO_87"), "Age of Reason"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_IDEO_27"), "Manufactured Holidays"})
	
	if gT.Cities[cID].FestivalET then
		if gT.Players[iPlayer].FestivalBonusesActive[7] then
			table.insert(hTab, {gT.Players[iPlayer].FestivalBonusesActive[7], "Festival"})
		end
	end
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_FEST_LAW_24_GOLD"), "Festival (Law)"})
	for i, data in pairs(hTab) do
		cMod = cMod - data[1];
	end
	table.insert(hTab, {cMod, "City Modifier"})
	for i, data in pairs(hTab) do
		if data[1] > 0 then
			hString = hString .. "[NEWLINE][ICON_BULLET]" .. data[2] .. ": +" .. data[1].. "%"
		elseif data[1] < 0 then
			hString = hString .. "[NEWLINE][ICON_BULLET]" .. data[2] .. ": " .. data[1].. "%"
		end
	end
	if hString == "[NEWLINE]----------------" then
		hString = ""
	end
	return hString;
end

function GetToolTipITGSocialMoods(iCity)
	local iPlayer = iCity:GetOwner();
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local str ="Displays current level of Happiness in the city. Negative vaule may lead into riots at the turn start."
	if CanEnterRiots(iCity, cID, iPlayer) then
		str = str .. " Current chance for Riot to start is [COLOR_NEGATIVE_TEXT]" .. math.floor(GetChanceForRiots(iPlayer, iCity, cID, -gT.Cities[cID].Happiness, true)) / 10 ..  "%[ENDCOLOR]."
	end
	str = str .. "[NEWLINE]----------------[NEWLINE]Modifications towards Riots' strength:"
	local hTab = {}
	table.insert(hTab, {5, "Base"})
	table.insert(hTab, {GetRiotLevelBasePlayer(iPlayer), "Corruption"})
	table.insert(hTab, {GetRiotLevelFromMastermind(iPlayer), "Enemy Ideology"})
	table.insert(hTab, {GetRiotLevelFromFascism(iPlayer), "Fascism"})
	table.insert(hTab, {GetRiotLevelFromGovernance(iCity, iPlayer, cID), "Governance"})
	table.insert(hTab, {GetViolenceLevelFromAbolition(iPlayer), "Abolition Movements"})
	table.insert(hTab, {GetRiotLevelFromAcademy(iCity), "Academies"})
	table.insert(hTab, {GetRiotLevelFromDistraction(cID, iPlayer), "Distractions"})
	table.insert(hTab, {GetRiotLevelFromIdeology(iCity, cID, iPlayer), "Ideology"})
	table.insert(hTab, {GetRiotLevelFromBeliefs(iPlayer, iCity), "Beliefs"})
	table.insert(hTab, {GetRiotLevelFromNatUnit(iPlayer, iCity, cID), "Cultural Tensions"})
	table.insert(hTab, {GetRiotLevelFromBuildings(iCity, true), "Buildings"})
	table.insert(hTab, {GetRiotLevelFromInnovation(iCity, iPlayer), "Innovations"})

	table.insert(hTab, {GetRiotLevelFromLaws(iPlayer, iCity, true), "Laws"})
	for i, data in pairs(hTab) do
		if data[1] > 0 then
			str = str .. "[NEWLINE][ICON_BULLET]" .. data[2] .. ": +" .. data[1].. ""
		elseif data[1] < 0 then
			str = str .. "[NEWLINE][ICON_BULLET]" .. data[2] .. ": " .. data[1].. ""
		end
	end
	local totPredictedRiotLevel = GetRiotLevelMod(iPlayer, cID, iCity, true);
	str = str .. "[NEWLINE]----------------[NEWLINE]Total: " .. totPredictedRiotLevel .. " [ICON_RESISTANCE]"
	if IsHasBuildingClass(iCity, GameInfoTypes.BUILDINGCLASS_POLICE_STATION) then
		str = str .. "[NEWLINE][ICON_BULLET](5%) Police Station: +25 [ICON_RESISTANCE]"
	end
	--RESISTANCE DATA
	str = str .. "[NEWLINE][NEWLINE]With " ..  totPredictedRiotLevel .. " [ICON_RESISTANCE] Riots' strength City will face following consequences upon riots' outbreak:"
	if GetITGCityInteger(iCity, "CI_NO_RES_RIOTS") > 0 then
		str = str .. "[NEWLINE][ICON_BULLET]Riots do not cause [ICON_RESISTANCE] Resistance."
	else
		local trc = 400 - totPredictedRiotLevel;
		str = str .. "[NEWLINE][ICON_BULLET](" .. math.floor(1000 * (100 - totPredictedRiotLevel) / trc) / 10 .. "%) 1T of [ICON_RESISTANCE] Resistance"
		if Players[iPlayer]:GetNumCities() == 1 then
			str = str .. "[NEWLINE][ICON_BULLET](" .. math.floor(200000 / trc) / 10 .. "%) 2T of [ICON_RESISTANCE] Resistance"
			str = str .. "[NEWLINE][ICON_BULLET](" .. math.floor(100000 / trc) / 10 .. "%) 3T of [ICON_RESISTANCE] Resistance"
		else
			str = str .. "[NEWLINE][ICON_BULLET](" .. math.floor(100000 / trc) / 10 .. "%) 2T of [ICON_RESISTANCE] Resistance"
			str = str .. "[NEWLINE][ICON_BULLET](" .. math.floor(100000 / trc) / 10 .. "%) 3T of [ICON_RESISTANCE] Resistance"
			str = str .. "[NEWLINE][ICON_BULLET](" .. math.floor(100000 / trc) / 10 .. "%) 4T of [ICON_RESISTANCE] Resistance"
		end
		if NAT_UNITY_BIG_PENALTY > gT.Players[iPlayer].NatUnity then
			str = str .. "[NEWLINE][ICON_BULLET]Duration of [ICON_RESISTANCE] Resistance will be increased by 1 turn due to very low [ICON_ITG_NAT_UNITY] National Unity.";
		end
		if gT.Players[iPlayer].CultBonusOn[103] then
			str = str .. "[NEWLINE][ICON_BULLET]Duration of [ICON_RESISTANCE] Resistance will be reduced by 1 turn for the cost of " .. GetGoldCostToEndRiotsTask() .. " [ICON_GOLD] Gold."
		end
		if gT.Players[iPlayer].CultBonusOn[104] then
			str = str .. "[NEWLINE][ICON_BULLET]Duration of [ICON_RESISTANCE] Resistance will be reduced by 1 turn for the cost of " .. GetFaithCostToEndRiotsTask() .. " [ICON_PEACE] Faith."
		end
	end
	if not HasImmunityToRiotsDestructingBuildings(iPlayer, iCity) then
		str = str .. "[NEWLINE][ICON_BULLET]Buildings demolition may occur (+" .. math.floor(totPredictedRiotLevel / 5) .. "%)."
		local demolitionchancemodifier = GetCityBuildingDemolitionChanceOnRiotsModifier(iPlayer, iCity, cID)
		if demolitionchancemodifier ~= 0 then
			str = str .. "[NEWLINE][ICON_BULLET]Total chance for building demolition is only " .. math.floor(100 * (1 + demolitionchancemodifier)) .. "% effective (modifiers)."
		end
		if ShouldDestroyedBuildingsBePartiallyRebuild(iPlayer, iCity) then
			str = str .. "[NEWLINE][ICON_BULLET]Buildings destroyed are easier to be rebuilt."
		end
		if gT.Players[iPlayer].CultBonusOn[30] then
			str = str .. "[NEWLINE][ICON_BULLET]+2 [ICON_HAPPINESS_1] Happiness per building destroyed (Arsonists)."
		end
	end
	if not HasImmunityToRiotsDestructingPalace(iPlayer, iCity, cID) then
		if gT.Cities[cID].Palace then
			str = str .. "[NEWLINE][ICON_BULLET](" .. GetPalaceDesructionRiotChance(iCity, cID, totPredictedRiotLevel) .. "%) Palace will be demolished."
		end
	end
	str = str .. "[NEWLINE][ICON_BULLET](" .. GetChanceForCulturalPresenceDropOnRiots(iPlayer, iCity, cID, totPredictedRiotLevel) .. "%) [ICON_ITG_PRESENCE] Presence will drop."
--	local legalred = GetLegalReductionOnRiots(iPlayer, iCity, totPredictedRiotLevel);
--	if legalred > 0 then
--		str = str .. "[NEWLINE][ICON_BULLET][ICON_ITG_LEGAL_POWER] Legal Power will be reduced by " .. legalred * 0.01 .. "." 
--	end
	if not IsRebelImmune(iCity, cID, iPlayer) then
		local rebelChance = GetChanceToSpawnRebels(iPlayer, iCity, totPredictedRiotLevel);
		if rebelChance > 0 then
			str = str .. "[NEWLINE][ICON_BULLET](" .. rebelChance .. "%) Rebels will spawn nearby."
		

			local hC = GetHeresyChanceRightNow(iCity, cID, iPlayer);
			if hC > 0 then
				str = str .. "[NEWLINE][ICON_BULLET](" .. hC / 10 .. "%) [ICON_PROPHET] Heretics will spawn instead of Rebels."
			end
		end
	end
	str = str .. "[NEWLINE][ICON_BULLET]+" .. GetHappinessFromRiotsOutbreak(iCity, cID, iPlayer, totPredictedRiotLevel, true) .. " [ICON_HAPPINESS_1] Happiness."
	if gT.Players[iPlayer].GovRewards[34] then
		str = str .. "[NEWLINE][ICON_BULLET](10%) Double [ICON_HAPPINESS_1] Happiness ([ICON_IDEOLOGY_LIBERTY] Liberty)."
	end
	str = str .. "[NEWLINE][NEWLINE]Effects of riots unaffected by strength:"
	str = str .. "[NEWLINE][ICON_BULLET](" .. GetChanceForMoraleToDropOnRiots(iPlayer) .. "%) [ICON_ITG_MORALE] Morale will be reduced by 1."
	if iCity:IsCapital() then
		if not Players[iPlayer]:IsMinorCiv() then
			if gT.Players[iPlayer].Goverment ~= 1 then
				if not gT.Players[iPlayer].NextAnarchyImmune then
					str = str .. "[NEWLINE][ICON_BULLET](" .. GetAnarchyChance(iPlayer, "Riots") / 10 .. "%) Empire will enter Anarchy."
				end
			end
		end
	end
	if gT.Players[iPlayer].HasIdeology[17] then
		str = str .. "[NEWLINE][ICON_BULLET]+2 [ICON_ITG_MERITOCRACY] Meritocracy (Barricades)."
	end
	if IsBeliefPresentInACity(iCity, GameInfoTypes.BELIEF_ITG_FOLLOWER_31) then
		str = str .. "[NEWLINE][ICON_BULLET]+5 [ICON_HAPPINESS_1] Happiness in City from beliefs."
	end

	return str;
end

function GetToolTipITGScience(iCity)
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local iPlayer = iCity:GetOwner();
	local hString;
	hString = iCity:GetYieldModifierTooltip(yScience)
	local hTab = {}
	local cMod = iCity:GetBaseYieldRateModifier(yScience) - 100;
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_POLIO_SCIENCE"), "Medical Lab (Polio)"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_ETCH_CATHEDRAL"), "Etchmiadzin Cathedral"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_SCIENCE_FROM_HEALTH"), "Health"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_LAW_SPEC_SCIENCE"), "Specialization"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_MINT_SCIENCE_RATE"), "Currency Power"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_OCCUPIED_SCIENCE_RATE"), "Occupation"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_INNO_ARAB_NW_5"), "Algebraic equations"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_HERESY_SCIENCE"), "Heresy"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_NO_IDEOLOGY_MOD"), "being Free from Ideology"})
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_IDEO_87"), "Age of Reason"})
	
	for i, data in pairs(hTab) do
		cMod = cMod - data[1];
	end
	table.insert(hTab, {cMod, "City Modifier"})
	for i, data in pairs(hTab) do
		if data[1] > 0 then
			hString = hString .. "[NEWLINE][ICON_BULLET]" .. data[2] .. ": +" .. data[1].. "%"
		elseif data[1] < 0 then
			hString = hString .. "[NEWLINE][ICON_BULLET]" .. data[2] .. ": " .. data[1].. "%"
		end
	end
	if hString == "[NEWLINE]----------------" then
		hString = ""
	end
	return hString;
end

function GetBaseCultureRateITG(iCity)
	local buildingR = 0;
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local tT = {eD = {}}
	local iPlayer = iCity:GetOwner()
	local prepTab = {};
	table.insert(prepTab, {GetCityYieldBasicFromPalaceTT(iCity, cID, iPlayer, "Culture"), "Palace"})
	table.insert(prepTab, {GetYieldFromDhamekStupa(iCity), "Dhamek Stupa"})
	if gT.Players[iPlayer].FestivalBonusesActive[6] and gT.Cities[cID].FestivalET then
		table.insert(prepTab, {gT.Players[iPlayer].FestivalBonusesActive[6], "Festival"})
	end
	for a, b in pairs(prepTab) do
		if b[1] ~= 0 then
			table.insert(tT.eD, {b[1], b[2]})
			buildingR = buildingR + b[1];
		end
	end
	tT.bR = buildingR
	return tT;
end

function GetBaseScienceRateITG(iCity)
	local buildingR = 0;
	local iPlayer = iCity:GetOwner();
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local tT = {eD = {}}
	local ipy = GetCityYieldBasicFromPalaceTT(iCity, cID, iPlayer, "Science")
	if ipy ~= 0 then
		table.insert(tT.eD, {ipy, "Palace"})
		buildingR = buildingR + ipy;
	end
	tT.bR = buildingR
	return tT;
end

function GetBaseFaithRateITG(iCity)
	local buildingR = 0;
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local tT = {eD = {}}
	local iPlayer = iCity:GetOwner()
	local prepTab = {};
	table.insert(prepTab, {GetITGCityInteger(iCity, "CI_CHELLAH"), "Chellah"})
	if gT.Cities[cID].FestivalET then
		if HasPlayerTech(iPlayer,  GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_24, "yhtsdcdf") then
			table.insert(prepTab, {5, "The Dionysia"})
		end
		if gT.Players[iPlayer].FestivalBonusesActive[4] then
			table.insert(prepTab, {1, "Festival"})
		end
	end
	table.insert(prepTab, {GetCityYieldBasicFromPalaceTT(iCity, cID, iPlayer, "Faith"), "Palace"})
	table.insert(prepTab, {GetYieldFromDhamekStupa(iCity), "Dhamek Stupa"})
	for a, b in pairs(prepTab) do
		if b[1] ~= 0 then
			table.insert(tT.eD, {b[1], b[2]})
			buildingR = buildingR + b[1];
		end
	end
	tT.bR = buildingR
	return tT;
end

function GetBaseFoodRateITG(iCity)
	local buildingR = 0;
	local iPlayer = iCity:GetOwner();
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local tT = {eD = {}}
	local prepTab = {};
	table.insert(prepTab, {GetITGCityInteger(iCity, "CI_INNO_IYA"), "Iya"})
	table.insert(prepTab, {GetITGCityInteger(iCity, "CI_FOOD_GOVERNANCE"), "Governance"})
	table.insert(prepTab, {GetITGCityInteger(iCity, "CI_FOOD_FOREIGN_DIS"), "Foreign District"})
	table.insert(prepTab, {GetITGCityInteger(iCity, "CI_FOOD_DISTRIBUTION"), "Food distribution"})
	if IsCityHaveWonderRuinWithAbility(iCity, 4) then
		table.insert(prepTab, {2, "Wonder Ruin"})
	end
	if gT.Cities[cID].TRFoodNext > 0 then
		table.insert(prepTab, {gT.Cities[cID].TRFoodNext, "Trade-Routes (" .. gT.Cities[cID].TRFoodT .. ")"})
	end
	if gT.Cities[cID].FishNextT > 0 then
		table.insert(prepTab, {gT.Cities[cID].FishNextT, "Fishing (" .. gT.Cities[cID].FishTotalT .. ")"})
	end
	if gT.Players[iPlayer].FestivalBonusesActive[14] and gT.Cities[cID].FestivalET then
		table.insert(prepTab, {gT.Players[iPlayer].FestivalBonusesActive[14], "Festival"})
	end
	for a, b in pairs(prepTab) do
		if b[1] ~= 0 then
			table.insert(tT.eD, {b[1], b[2]})
			buildingR = buildingR + b[1];
		end
	end
	tT.bR = buildingR
	return tT;
end

function GetBaseGoldRateITG(iCity)
	local buildingR = 0;
	local iPlayer = iCity:GetOwner();
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local tT = {eD = {}}
	local prepTab = {};
	table.insert(prepTab, {GetCityYieldBasicFromPalaceTT(iCity, cID, iPlayer, "Gold"), "Palace"})
	table.insert(prepTab, {GetITGCityInteger(iCity, "CI_INNO_IYA"), "Iya"})
	table.insert(prepTab, {GetITGCityInteger(iCity, "CI_GOVERNANCE_GOLD"), "Governance"})
	if iCity:IsHasBuilding(GameInfoTypes.BUILDING_ITG_NEW_WORLD_WONDER_26) then
		table.insert(tT.eD, {iCity:GetFaithPerTurn() , "Faith"}) -- THIS one is not reducing buildingR!!!
	end
	for a, b in pairs(prepTab) do
		if b[1] ~= 0 then
			table.insert(tT.eD, {b[1], b[2]})
			buildingR = buildingR + b[1];
		end
	end
	tT.bR = buildingR
	return tT;
end

function GetBaseProductionRateITG(iCity)
	local buildingR = 0;
	local iPlayer = iCity:GetOwner();
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local tT = {eD = {}}
	local prepTab = {};
	table.insert(prepTab, {GetITGCityInteger(iCity, "CI_GP_PROD"), "Great People"})
	table.insert(prepTab, {GetITGCityInteger(iCity, "CI_IDEO_7"), "Work Injury Insurance"})
	table.insert(prepTab, {GetITGCityInteger(iCity, "CI_PROD_FROM_TECH"), "Technologies"})
	table.insert(prepTab, {GetITGCityInteger(iCity, "CI_IDEO_70"), "Science in Service"})
	table.insert(prepTab, {GetITGCityInteger(iCity, "CI_LOGISTICS"), "Logistics"})
	table.insert(prepTab, {GetITGCityInteger(iCity, "CI_CB_QA_PROD"), "Quality Assurance"})
	table.insert(prepTab, {GetITGCityInteger(iCity, "CI_IDEO_30"), "Human Resource"})
	table.insert(prepTab, {GetITGCityInteger(iCity, "CI_PILGRIM_PROD"), "Weary pilgrimage"})
	table.insert(prepTab, {GetITGCityInteger(iCity, "CI_BUDGET_PROD"), "New Deal"})
	table.insert(prepTab, {GetITGCityInteger(iCity, "CI_WORK_RATE_PROD"), "Work Rate"})
	table.insert(prepTab, {gT.Cities[cID].ProdFromBridge or 0, "Bridges"})
	table.insert(prepTab, {GetCityYieldBasicFromPalaceTT(iCity, cID, iPlayer, "Production"), "Palace"})
	if gT.Players[iPlayer].FestivalBonusesActive[12] then
		if gT.Cities[cID].FestivalET then
			table.insert(prepTab, {gT.Players[iPlayer].FestivalBonusesActive[12], "Festival"})
		end
	end
	if gT.Players[iCity:GetOwner()].CultBonusOn[64] then
		if gT.Cities[cID].FishProd > 0 then
			table.insert(prepTab, {gT.Cities[cID].FishProd, "Fishing (" .. math.ceil(gT.Cities[cID].FishTotalT * FISH_INDUSTRY_PERCENT) .. ")"})
		end
	end
	if gT.Cities[cID].TRProdNext > 0 then
		table.insert(prepTab, {gT.Cities[cID].TRProdNext, "Trade-Routes (" .. gT.Cities[cID].TRProdT .. ")"})
	end
	for a, b in pairs(prepTab) do
		if b[1] ~= 0 then
			table.insert(tT.eD, {b[1], b[2]})
			buildingR = buildingR + b[1];
		end
	end
	tT.bR = buildingR
	return tT;
end

function TRCityViewToolTip(iCity, iPlayer, totalLand, totalNaval, totalPilgrim)
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local navalstr = "Progress towards Naval Trade Route: " .. math.floor(gT.Cities[cID].CargoProgress) .. "/" .. GetLandTradeRouteCost(iPlayer) .. "[NEWLINE](+" .. totalNaval .. " [ICON_CARGO])"
	local landstr = "Progress towards Land Trade Route: " .. math.floor(gT.Cities[cID].CaravanProgress) .. "/" .. GetNavalTradeRouteCost(iPlayer) .. "[NEWLINE](+" .. totalLand .. " [ICON_CARAVAN])"
	local pilgrimstr = "Progress towards Pilgrimage: " .. math.floor(gT.Cities[cID].PilgrimProgress) .. "/" .. GetPilgrimageCost(iPlayer) .. "[NEWLINE](+" .. totalPilgrim .. " [ICON_ITG_PILGRIM])[NEWLINE][NEWLINE]Base value is determined by Naval or Land Trade-Route rate (whichever greater), but limited by [ICON_PEACE] Faith generation. The value can be increased by Beliefs, Wonders or Great People."
	if ITGCityCanWorkDoAction(iCity) then
		local lTab = {}
		local nTab = {}
		local lHbTR, nHbTR = GetLNTRPointsFromBuildings(iCity);
		local lHtTR, nHtTR = GetLandNavalTRFromTechs(iCity, iPlayer, cID)
		local lHrTR, nHrTR = GetLandNavalTRFromReligion(iCity, iPlayer, cID)
		local lHiTR, nHiTR = GetLandNavalTRFromIdeology(iCity, iPlayer, cID);
		local lHaTR, nHaTR = GetLandNavalTRFromAcademies(iCity, iPlayer, cID);
		local lHchTR, nHchTR = GetLandNavalTRFromCustomsHouses(iCity, iPlayer, cID);
		
		table.insert(lTab, {lHbTR, "Buildings"});
		table.insert(lTab, {lHtTR, "Technologies"});
		table.insert(lTab, {lHrTR, "Religion"});
		table.insert(lTab, {lHiTR, "Ideology"});
		table.insert(lTab, {lHaTR, "Academies"});
		table.insert(lTab, {lHchTR, "Customs House"});
		table.insert(lTab, {GetITGCityInteger(iCity, "CI_GOV_LAND_TR"), "Governance"});
		table.insert(lTab, { GetLandTRFromFaith(iCity, iPlayer), "Faith"});
		table.insert(lTab, { GetLandTRFromDefense(iCity, iPlayer, cID), "Defense"});
		table.insert(nTab, {nHbTR, "Buildings"});
		table.insert(nTab, {nHtTR, "Technologies"});
		table.insert(nTab, {nHrTR, "Religion"});
		table.insert(nTab, {nHiTR, "Ideology"});
		table.insert(nTab, {nHaTR, "Academies"});
		table.insert(nTab, {nHchTR, "Customs House"});
		local pialo = GetTRPointsIfAtLeastOneGenerated(iCity, iPlayer, cID, nil);
		local pl, pn = GetTradeGainFromProcess(iCity)
		table.insert(lTab, {pl, "Trade Process"});
		table.insert(nTab, {pn, "Trade Process"});
		if totalLand - pl > 0 then
			table.insert(lTab, {pialo, "Generating at least one Point"});
		end
		if totalNaval - pn > 0 then
			table.insert(nTab, {pialo, "Generating at least one Point"});
		end
		local bFirst = true
		for i, d in pairs(lTab) do
			if d[1] ~= 0 then
				if bFirst then
					bFirst = false;
					landstr = landstr .. "[NEWLINE]";
				end
				landstr = landstr .. "[NEWLINE][ICON_BULLET]" .. d[1] .. " [ICON_CARAVAN] from " .. d[2]
			end
		end
		local bFirst = true
		for i, d in pairs(nTab) do
			if d[1] ~= 0 then
				if bFirst then
					bFirst = false;
					navalstr = navalstr .. "[NEWLINE]";
				end
				navalstr = navalstr .. "[NEWLINE][ICON_BULLET]" .. d[1] .. " [ICON_CARGO] from " .. d[2]
			end
		end
	end
	return landstr, navalstr, pilgrimstr;
end

function WonderCityViewToolTip(iCity, iPlayer, wPoints)
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local str = "Progress towards Wonder Race: " .. gT.Players[iPlayer].WonderProduction .. "[NEWLINE](+" .. wPoints .. " [ICON_GREAT_ENGINEER])[NEWLINE]"
	local tTab = {}
	
	table.insert(tTab, {GetWonderPointsFromCityBuildings(iCity) , "Buildings"});
	table.insert(tTab, {GetEstimatedWonderPointsCityFromProcess(iCity) , "Process"});
	table.insert(tTab, {GetCurrentEstimadedPointsFromSpec(iCity, specEngineer) , "Specialists"});

	for i, d in pairs(tTab) do
		if d[1] ~= 0 then
			str = str .. "[NEWLINE][ICON_BULLET]" .. d[1] .. " [ICON_GREAT_ENGINEER] from " .. d[2]
		end
	end
	local modTab = {}
	table.insert(modTab, {GetPercentModifierGreatWonderBelief(iCity), "Beliefs", true})
	table.insert(modTab, {GetITGCityInteger(iCity, "CI_OCCUPIED_GP_RATE"), "Occupation"})
	if Players[iPlayer]:IsGoldenAge() then
		table.insert(modTab, {50, "Golden Age"})
	end
	local cityModifier = iCity:GetTotalGPModifier(specEngineer);
	for a, b in pairs(modTab) do
		if not b[3] then
			cityModifier = cityModifier - b[1];
		end
	end
	table.insert(modTab, {cityModifier, "City Modifier", true})
	local bFirstModifier = true;
	for a, d in pairs(modTab) do
		if d[1] ~= 0 then
			if bFirstModifier then
				bFirstModifier = false;
				str = str .. "[NEWLINE]----------------[NEWLINE]Modifiers:"
			end
			if d[1] > 0 then
				str = str .. "[NEWLINE][ICON_BULLET]+" .. d[1] .. "% [ICON_GREAT_ENGINEER] from " .. d[2]
			else
				str = str .. "[NEWLINE][ICON_BULLET]" .. d[1] .. "% [ICON_GREAT_ENGINEER] from " .. d[2]
			end
		end
	end

	str = str .. "[NEWLINE][NEWLINE]Points are stored empire-wide."
	return str;
end

function ArtCityViewToolTip(iCity, iPlayer, wPoints)
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local str = "Progress towards next Artistic Period: " .. gT.Players[iPlayer].GreatArtistPoints .. "[NEWLINE](+" .. wPoints .. " [ICON_GREAT_ARTIST])[NEWLINE]"
	local tTab = {}
	
	table.insert(tTab, {GetArtistPointsFromCityBuildings(iCity) , "Buildings"});
	table.insert(tTab, {GetArtPointsFromCitySocialBonus(iCity, iPlayer, cID), "Social Developments"});
	table.insert(tTab, {GetArtPointsFromFestival(iCity, iPlayer, cID), "Festival"});
	table.insert(tTab, {GetArtPointsFromSagradaFamilia(iCity, iPlayer, cID), "Sagrada Familia"});
	table.insert(tTab, {GetCurrentEstimadedPointsFromSpec(iCity, specArtist), "Specialists"});

	for i, d in pairs(tTab) do
		if d[1] ~= 0 then
			str = str .. "[NEWLINE][ICON_BULLET]" .. d[1] .. " [ICON_GREAT_ARTIST] from " .. d[2]
		end
	end
	local modTab = {}
	table.insert(modTab, {GetPercentModifierGreatArtistBelief(iCity), "Beliefs", true})
	table.insert(modTab, {GetModifierArtPointsFromFestival(iCity, cID, iPlayer), "Festival", true})
	table.insert(modTab, {GetCityArtModFromSocialDevs(iCity, cID, iPlayer), "Social Developments", true})
	table.insert(modTab, {GetCityArtModFromPrinciples(iCity, cID, iPlayer), "Principles", true})
	table.insert(modTab, {GetITGCityInteger(iCity, "CI_OCCUPIED_GP_RATE"), "Occupation"})
	table.insert(modTab, {GetCurrentModifierFromCultureEra(iPlayer), "Art Style"})
	if Players[iPlayer]:IsGoldenAge() then
		table.insert(modTab, {50, "Golden Age"})
	end
	
	local cityModifier = iCity:GetTotalGPModifier(specArtist);
	for a, b in pairs(modTab) do
		if not b[3] then
			cityModifier = cityModifier - b[1];
		end
	end
	table.insert(modTab, {cityModifier, "City Modifier", true})
	local bFirstModifier = true;
	for a, d in pairs(modTab) do
		if d[1] ~= 0 then
			if bFirstModifier then
				bFirstModifier = false;
				str = str .. "[NEWLINE]----------------[NEWLINE]Modifiers:"
			end
			if d[1] > 0 then
				str = str .. "[NEWLINE][ICON_BULLET]+" .. d[1] .. "% [ICON_GREAT_ARTIST] from " .. d[2]
			else
				str = str .. "[NEWLINE][ICON_BULLET]" .. d[1] .. "% [ICON_GREAT_ARTIST] from " .. d[2]
			end
		end
	end
	str = str .. "[NEWLINE][NEWLINE]Points are stored empire-wide."
	return str;
end

function ColonyCityViewToolTip(iCity, iPlayer, wPoints)
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local str = "Progress towards next Colony: " .. gT.Players[iPlayer].ColonyPoints .. "[NEWLINE](+" .. wPoints .. " [ICON_GREAT_MERCHANT])[NEWLINE]"
	local tTab = {}
	
	table.insert(tTab, {GetColonyPointsFromBeliefs(iCity, iPlayer), "Beliefs"});
	table.insert(tTab, {GetCurrentEstimadedPointsFromSpec(iCity, specMerchant) , "Specialists"});

	for i, d in pairs(tTab) do
		if d[1] ~= 0 then
			str = str .. "[NEWLINE][ICON_BULLET]" .. d[1] .. " [ICON_GREAT_MERCHANT] from " .. d[2]
		end
	end

	local modTab = {}
	table.insert(modTab, {GetITGCityInteger(iCity, "CI_OCCUPIED_GP_RATE"), "Occupation"})
	if Players[iPlayer]:IsGoldenAge() then
		table.insert(modTab, {50, "Golden Age"})
	end
	local cityModifier = iCity:GetTotalGPModifier(specMerchant);
	for a, b in pairs(modTab) do
		cityModifier = cityModifier - b[1];
	end
	table.insert(modTab, {cityModifier, "City Modifier", true})

	local bFirstModifier = true;
	for a, d in pairs(modTab) do
		if d[1] ~= 0 then
			if bFirstModifier then
				bFirstModifier = false;
				str = str .. "[NEWLINE]----------------[NEWLINE]Modifiers:"
			end
			if d[1] > 0 then
				str = str .. "[NEWLINE][ICON_BULLET]+" .. d[1] .. "% [ICON_GREAT_MERCHANT] from " .. d[2]
			else
				str = str .. "[NEWLINE][ICON_BULLET]" .. d[1] .. "% [ICON_GREAT_MERCHANT] from " .. d[2]
			end
		end
	end
	str = str .. "[NEWLINE][NEWLINE]Points are stored empire-wide."
	return str;
end

function GPCityViewToolTip(iCity, iPlayer, wPoints)
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local str = "Progress towards next Great Person: " .. gT.Players[iPlayer].GreatPeoplePoints .. "[NEWLINE](+" .. wPoints .. " [ICON_GREAT_PEOPLE])[NEWLINE]"
	local tTab = {}
	
	table.insert(tTab, {GetGPPointsFromBuildings(iCity, iPlayer, cID) , "Buildings"});
	table.insert(tTab, {GetGPPointsFromFestival(iCity, iPlayer, cID) , "Festival"});
	table.insert(tTab, {GetGPPointsFromWonders(iCity, iPlayer, cID) , "Wonder or Ruin"});
	table.insert(tTab, {GetBeliefsCivilGPPoints(iCity, iPlayer, cID) , "Beliefs"});
	table.insert(tTab, {GetGPPointsFromInnovations(iCity, iPlayer, cID) , "Innovations"});
	table.insert(tTab, {GetCurrentEstimadedPointsFromSpec(iCity, specScientist) , "Specialists"});

	for i, d in pairs(tTab) do
		if d[1] ~= 0 then
			str = str .. "[NEWLINE][ICON_BULLET]" .. d[1] .. " [ICON_GREAT_PEOPLE] from " .. d[2]
		end
	end

	local modTab = {}
	table.insert(modTab, {GetITGCityInteger(iCity, "CI_OCCUPIED_GP_RATE"), "Occupation"})
	if Players[iPlayer]:IsGoldenAge() then
		table.insert(modTab, {50, "Golden Age"})
	end
	table.insert(modTab, {GetGPModFromFestival(iCity, iPlayer, cID) , "Festival", true});
	local cityModifier = iCity:GetTotalGPModifier(specScientist);
	for a, b in pairs(modTab) do
		if not b[3] then
			cityModifier = cityModifier - b[1];
		end
	end
	table.insert(modTab, {cityModifier, "City Modifier", true})

	local bFirstModifier = true;
	for a, d in pairs(modTab) do
		if d[1] ~= 0 then
			if bFirstModifier then
				bFirstModifier = false;
				str = str .. "[NEWLINE]----------------[NEWLINE]Modifiers:"
			end
			if d[1] > 0 then
				str = str .. "[NEWLINE][ICON_BULLET]+" .. d[1] .. "% [ICON_GREAT_PEOPLE] from " .. d[2]
			else
				str = str .. "[NEWLINE][ICON_BULLET]" .. d[1] .. "% [ICON_GREAT_PEOPLE] from " .. d[2]
			end
		end
	end
	str = str .. "[NEWLINE][NEWLINE]Points are stored empire-wide."
	return str;
end

function GetToolTipITGxp(iCity)
	local iPlayer = iCity:GetOwner();
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local unitType = iCity:GetProductionUnit();
	local str;
	local domain = -1;
	local combatType = -1;
	local hTab = {};
	local domainXP;
	if unitType == -1 then
		str = "You are currently not training any unit.[NEWLINE][NEWLINE]Sources of XP for combat units:";
	else
		local unitData = GameInfo.Units[unitType];
		if gT.Players[iPlayer].UnitClassXP[GameInfoTypes[unitData.Class]] then
			domain = GameInfoTypes[unitData.Domain]
			combatType = GameInfoTypes[unitData.CombatClass];
			domainXP = GetXPFromDomainType(unitType, iPlayer, iCity, cID);
			table.insert(hTab, {GetXPFromUnitCombatType(combatType, iPlayer, iCity, cID), "Unit Combat Class Bonus"})
			table.insert(hTab, {GetXPFromResourceRequirement(unitType, iPlayer, iCity, cID), "Resource Requirement Bonus"})
			str = "You are currently training [COLOR_POSITIVE_TEXT]" .. Locale.Lookup(unitData.Description) .. "[ENDCOLOR].[NEWLINE][NEWLINE]Sources of XP:";
		else
			str = "You are currently training [COLOR_POSITIVE_TEXT]" .. Locale.Lookup(unitData.Description) .. "[ENDCOLOR]. This unit does not earn experience.[NEWLINE][NEWLINE]Sources of XP for combat units:";
		end
	end
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_NEXT_UNIT_XP"), "Next Trained Unit Bonus"})
	local bAnyDomainXP = GetXPforAnyDomainFromBuildings(iCity);
	table.insert(hTab, {bAnyDomainXP, "Buildings"})
	if domainXP then
		domainXP = domainXP - bAnyDomainXP;
		table.insert(hTab, {domainXP, "Domain Bonus"})
	end
	table.insert(hTab, {GetXPFromLaws(iPlayer, iCity, cID), "Laws"})
	table.insert(hTab, {GetXPFromInnovations(iPlayer, iCity, cID), "Innovations"})
	table.insert(hTab, {GetXPFromSocialDev(iPlayer, iCity, cID), "Social Developments"})
	table.insert(hTab, {GetXPFromCultureType(iPlayer, iCity, cID), "Culture Type"})
	table.insert(hTab, {GetXPFromBeliefs(iPlayer, iCity, cID), "Beliefs"})
	table.insert(hTab, {GetXPFromAcademies(iPlayer, iCity, cID), "Academies"})
	table.insert(hTab, {GetXPFromGovernance(iCity), "Governance"})
	
	table.insert(hTab, {GetXPFromIdeologies(iPlayer, iCity, cID), "Ideologies"})
	for i,v in pairs(hTab) do
		if v[1] > 0 then
			str = str .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]+" .. v[1].. "[ENDCOLOR] from " .. v[2] .. "."
		elseif v[1] < 0 then
			str = str .. "[NEWLINE][ICON_BULLET][COLOR_NEGATIVE_TEXT]+" .. v[1].. "[ENDCOLOR] from " .. v[2] .. "."
		end
	end
	local totXP = GetBonusXPForTrainedUnit(iCity, iPlayer, domain, combatType, unitType, true);
	str = str .. "[NEWLINE]----------------[NEWLINE]Total: [COLOR_POSITIVE_TEXT]" .. totXP .. "[ENDCOLOR] XP"
	return {totXP,str};
end

function GetToolTipITGCPresence(iCity)
	local iPlayer = iCity:GetOwner();
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local basic = GetBasicToolTipDataPresence(iCity, cID);
	if not basic then
		return 0, nil;
	end
	local str = basic.ToolTip .. "[NEWLINE]----------------[NEWLINE]Sources of your [ICON_ITG_PRESENCE] Cultural Presence per turn:"
	local hTab = {}
	
	table.insert(hTab, {GetPresencePTfromCultureType(iPlayer), "Culture Type"})
	table.insert(hTab, {GetPresencePTfromGoldenAge(iPlayer), "Golden Age"})
	table.insert(hTab, {GetPresencePTfromWonders(iPlayer, iCity, true), "Wonders"})
	table.insert(hTab, {GetPresencePTfromGoverment(iPlayer), "Goverment"})
	table.insert(hTab, {GetPresencePTfromDevelopments(iCity, cID, iPlayer), "Social Developments"})
	table.insert(hTab, {GetPresencePTfromPalace(iCity, cID, iPlayer), "Palace"})
	table.insert(hTab, {GetPresencePTfromInnovations(iCity, cID, iPlayer, true), "Innovations"})
	table.insert(hTab, {GetPresencePTfromGreatPeople(iCity, cID, iPlayer, true), "Great People"})
	table.insert(hTab, {GetPresencePTfromFestival(cID), "Festival"})
	table.insert(hTab, {GetPresencePTfromPiracy(iPlayer, iCity), "Piracy"})
	table.insert(hTab, {GetPresencePTfromAcademies(iPlayer, cID, true), "Academies"})
	table.insert(hTab, {GetPresencePTforTTonlySoaking(iPlayer, cID, iCity), "Nearby Cities"})
	table.insert(hTab, {GetPresencePTforTTAmalgamation(iPlayer, cID), "Amalgamation"})
	

	table.insert(hTab, {GetPresencePTfromAnchor(iPlayer, cID), "Presence Anchor"})
	table.insert(hTab, {GetPresencePTfromGovernance(iCity), "Governance"})
	
	table.insert(hTab, {GetPresencePTfromCulturePT(iPlayer, iCity, cID), "Culture generating"})
	table.insert(hTab, {GetPresencePTfromFaith(iPlayer, iCity, cID), "Faith generating"})
	table.insert(hTab, {GetCulturalPresenceFromProcess(iCity), "Cultural Heritage"})

	
	for i, v in pairs(hTab) do
		if v[1] > 0 then
			str = str .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]+" .. v[1] .. "[ENDCOLOR] from " .. v[2] .. "."
		elseif v[1] < 0 then
			str = str .. "[NEWLINE][ICON_BULLET][COLOR_NEGATIVE_TEXT]" .. v[1] .. "[ENDCOLOR] from " .. v[2] .. "."
		end
	end
	local modTab = {}
	table.insert(modTab, {GetPresenceModfromHeresy(iPlayer, iCity), "Heresy"}) 
	table.insert(modTab, {GetPresenceModFromLaws(iPlayer, iCity), "Laws"})
	for a, b in pairs(modTab) do
		if b[1] > 0 then
			str = str .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]+" .. b[1] .. "[ENDCOLOR]% modifier from " .. b[2] .. "."
		elseif b[1] < 0 then 
			str = str .. "[NEWLINE][ICON_BULLET][COLOR_NEGATIVE_TEXT]" .. b[1] .. "[ENDCOLOR]% modifier from " .. b[2] .. "."
		end
	end

	str = str .. "[NEWLINE][NEWLINE]Cultural Presence tresholds of ownership:"
	local tttct = GetCultureOwnershipTreshold()
	local teffectt = {"Allows becoming Cultural owner of city.","Cultural Presence does not drop upon city capture.","Increases National Cultural Presence anchor by 10.","Spreads 0.5 Cultural Presence to other cities within 10 radius.", "+4 base [ICON_ITG_UNIFY] Unifying Presence."}
	for i, v in pairs(tttct) do
		str = str .. "[NEWLINE][ICON_BULLET][COLOR_YIELD_GOLD]" .. GetRomanNumber(i) .. "[ENDCOLOR] ([COLOR_MAGENTA]" .. v .. "[ENDCOLOR][ICON_ITG_PRESENCE]) " .. teffectt[i]
	end
	local pcAnchor = GetCulturalPresenceAnchor(iPlayer);
	if pcAnchor > 0 then
		str = str .. "[NEWLINE][NEWLINE]National Cultural Presence anchor is at " .. pcAnchor .. ". Your Cities with less cultural presence stored will generate +2 [ICON_ITG_PRESENCE] Presence per turn."
	end
	return {basic.COwnerChange, str};
end

function GetToolTipITGNatUnity(iCity)
	local iPlayer = iCity:GetOwner();
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local goodC, badC = GetGoodAndBadCulture(iCity, cID, iPlayer);
	local str = ""
	if goodC > 0 then
		str = str .. "Base unifying: [COLOR_POSITIVE_TEXT]" ..  GetBaseUnifyingPresence(iCity, iPlayer, cID) .. "[ENDCOLOR] [ICON_ITG_UNIFY][NEWLINE]"
		local hTab = {}
		table.insert(hTab, {GetGoodCultureEffectBase(iCity, cID, iPlayer), "Base"})
		table.insert(hTab, {GetGoodCultureEffectFromLegalOwnership(iCity, iPlayer), "Legal Ownership"})
		table.insert(hTab, {GetGoodCultureEffectFromCultureOwnership(iCity, cID, iPlayer), "Presence"})
		table.insert(hTab, {GetModGoodCultureFromSpecialEffects(iCity, cID, iPlayer), "Special Effects"})
		str = str .. "Effectiveness:"
		local total = 0;
		for i, v in pairs(hTab) do
			if v[1] ~= 0 then
				str = str .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]+" .. v[1] * 100 .. "[ENDCOLOR]% from " .. v[2] .. "."
				total = total + v[1] * 100;
			end
		end
		if gT.Players[iPlayer].SubcultureType == 12 then
			if goodC == 3 then
				str = str .. "[NEWLINE][ICON_BULLET]Always generates at least [COLOR_POSITIVE_TEXT]3[ENDCOLOR] [ICON_ITG_UNIFY] unifying presence (Pioneers)."
			end
		elseif gT.Players[iPlayer].SubcultureType == 11 then
			if iCity:IsCapital() then
				str = str .. "[NEWLINE][ICON_BULLET]Capital's [ICON_ITG_UNIFY] unifying presence is doubled (Winds of Change)."
			end
		end
		str = str .. "[NEWLINE]----------------[NEWLINE]Total: [COLOR_POSITIVE_TEXT]" .. math.min(100,total) .. "[ENDCOLOR]%"
		str = str .. "[NEWLINE]----------------[NEWLINE]City produces [COLOR_POSITIVE_TEXT]" .. goodC .. "[ENDCOLOR] [ICON_ITG_UNIFY] unifying presence."
	else
		str = str .. "City does not produce any [ICON_ITG_UNIFY] unifying presence."
	end
	str = str .. "[NEWLINE]--------------------------------[NEWLINE]"
	if badC > 0 then
		str = str .. "Base separating: [COLOR_NEGATIVE_TEXT]" ..  GetBaseDividingPresence(iCity, iPlayer, cID) .. "[ENDCOLOR][ICON_ITG_DIVIDE][NEWLINE]"
		local hTab = {}
		table.insert(hTab, {GetBadCultureEffectFromLegalOwnership(iCity, iPlayer), "Illegitimate Ownership"})
		table.insert(hTab, {GetBadCultureEffectFromCultureOwnership(iCity, cID, iPlayer), "Foreign Presence"})
		table.insert(hTab, {GetModBadCultureFromReligionInCity(iCity:GetReligiousMajority(), iPlayer), "Invasive Religion"})
		table.insert(hTab, {GetModBadCultureFromSpecialEffects(iCity, cID, iPlayer), "Special Effects"})
		str = str .. "Effectiveness:"
		local total = 0;
		for i, v in pairs(hTab) do
			if v[1] ~= 0 then
				str = str .. "[NEWLINE][ICON_BULLET][COLOR_NEGATIVE_TEXT]+" .. v[1] * 100 .. "[ENDCOLOR]% from " .. v[2] .. "."
				total = total + v[1] * 100;
			end
		end
		str = str .. "[NEWLINE]----------------[NEWLINE]Total: [COLOR_NEGATIVE_TEXT]" .. math.min(100,total) .. "[ENDCOLOR]%"
		local modTab = {}
		local bFirst = true;
		table.insert(modTab, {GetModifierBadFromLaws(iCity, iPlayer, cID), "Laws"})
		for i, v in pairs(modTab) do
			if v[1] ~= 0 then
				if bFirst then
					str = str .. "[NEWLINE]----------------[NEWLINE]Modifiers:"
					bFirst = false;
				end
				if v[1] > 0 then
					str = str .. "[NEWLINE][ICON_BULLET][COLOR_NEGATIVE_TEXT]+" .. v[1] * 100 .. "[ENDCOLOR]% from " .. v[2] .. "."
				elseif v[1] < 0 then
					str = str .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]" .. v[1] * 100 .. "[ENDCOLOR]% from " .. v[2] .. "."
				end
			end
		end
		str = str .. "[NEWLINE]----------------[NEWLINE]City produces [COLOR_NEGATIVE_TEXT]" .. badC .. "[ENDCOLOR] [ICON_ITG_DIVIDE] dividing presence."
	else
		str = str .. "City does not produce any [ICON_ITG_DIVIDE] dividing presence."
	end
	return {"[COLOR_POSITIVE_TEXT]" .. goodC .. "[ENDCOLOR]/[COLOR_NEGATIVE_TEXT]" .. badC, str};
end