local curDefUnit;
local curDefDamage;
local curAttDamage;
local cityUndefDamage;

local tinnopagan8 = GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_PAGAN_8;
local innoTafr5 = GameInfoTypes.TECH_UNIQUE_ITG_MEDIEVAL_AFR_5;
local promGen2 = GameInfoTypes.PROMOTION_GREAT_GENERAL_2;
local promAdm4 = GameInfoTypes.PROMOTION_ITG_GREAT_ADMIRAL_4;
local promMerc8 = GameInfoTypes.PROMOTION_ITG_MERCENARY_8;
local merProm19 = GameInfoTypes.PROMOTION_ITG_MERCENARY_19;
local promGen24 = GameInfoTypes.PROMOTION_GREAT_GENERAL_24
local promAdm7 = GameInfoTypes.PROMOTION_ITG_GREAT_ADMIRAL_7;
local promGen9 = GameInfoTypes.PROMOTION_GREAT_GENERAL_9
local promAdm9 = GameInfoTypes.PROMOTION_ITG_GREAT_ADMIRAL_9;
local promAdm10 = GameInfoTypes.PROMOTION_ITG_GREAT_ADMIRAL_10;
local promAdm12 = GameInfoTypes.PROMOTION_ITG_GREAT_ADMIRAL_12;
local promGen11 = GameInfoTypes.PROMOTION_GREAT_GENERAL_11;
local promGen12 = GameInfoTypes.PROMOTION_GREAT_GENERAL_12;
local promGen14 = GameInfoTypes.PROMOTION_GREAT_GENERAL_14;
local promSubLock = GameInfoTypes.PROMOTION_ITG_SUB_STEER_LOCKED;
local innoMedAfr7 = GameInfoTypes.TECH_UNIQUE_ITG_MEDIEVAL_AFR_7;
local bPromRange = GameInfoTypes.PROMOTION_RANGE;
local promGen19 = GameInfoTypes.PROMOTION_GREAT_GENERAL_19
local promAdm17 = GameInfoTypes.PROMOTION_ITG_GREAT_ADMIRAL_17
local promAdm33 = GameInfoTypes.PROMOTION_ITG_GREAT_ADMIRAL_33
local promGen38 = GameInfoTypes.PROMOTION_GREAT_GENERAL_38
local ucArcher = GameInfoTypes.UNITCOMBAT_ARCHER;
local ucSiege = GameInfoTypes.UNITCOMBAT_SIEGE;
local ucMechanical = GameInfoTypes.UNITCOMBAT_ARMOR;
local uBombard = GameInfoTypes.UNIT_ITG_SIEGE_OTT_TREBUCHET;
local cTypeKnightTrial = GameInfoTypes.UNIT_ITG_TRIAL_HORSEMAN_1
local renWonder29 = GameInfoTypes.BUILDING_ITG_NEW_WORLD_WONDER_29;
local nwwonder22 = GameInfoTypes.BUILDING_ITG_NEW_WORLD_WONDER_22;
local tAncCS21 = GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_21;
local innoANCtr7 = GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_TRIBE_7;
local tinnoindu4 = GameInfoTypes.TECH_UNIQUE_ITG_INDUSTRIAL_4;
local uGarrison = GameInfoTypes.UNIT_GARRISON
local promCombTab = {
[GameInfoTypes.UNITCOMBAT_MOUNTED] = GameInfoTypes.PROMOTION_ITG_IND_COMBINED_ARMS_CAVALRY,
[GameInfoTypes.UNITCOMBAT_GUN] = GameInfoTypes.PROMOTION_ITG_IND_COMBINED_ARMS_INFANTRY,
[GameInfoTypes.UNITCOMBAT_SIEGE] = GameInfoTypes.PROMOTION_ITG_IND_COMBINED_ARMS_ARTILERY,
}
local IsValidUnitClassForLevy = {
[GameInfoTypes.UNITCLASS_ITG_GARRISON] = true,
}
local IsMechanicalTab = {
[GameInfoTypes.UNITCOMBAT_BOMBER] = true,
[GameInfoTypes.UNITCOMBAT_CARRIER] = true,
[GameInfoTypes.UNITCOMBAT_FIGHTER] = true,
[GameInfoTypes.UNITCOMBAT_NAVALRANGED] = true,
[GameInfoTypes.UNITCOMBAT_NAVALMELEE] = true,
[GameInfoTypes.UNITCOMBAT_SUBMARINE] = true,
[GameInfoTypes.UNITCOMBAT_ARMOR] = true,
}
local IsFakeCivilian = {}
for row in GameInfo.Units() do
	if row.FakeCivilian then
		IsFakeCivilian[row.ID] = true;
	end
end

local cCElogH;
function DoCEhLog(from, expect, save, a, b, c, d, e, f, g, h)
	if expect ~= cCElogH then
		print(from, "Expected something else in combat events", expect, cCElogH, a, b, c, d, e, f, g, h)
	end
	cCElogH = save;
end

function UnitWasInCombat(iUnit, iPlayer, bAttack)
	if not iUnit:IsDead() then
		local uID;
		if gT.Players[iPlayer] then
			uID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
			if gT.Players[iPlayer].UnitsByID[uID] then
				gT.Players[iPlayer].UnitsByID[uID].LastCombatT = GetITGGameTurn();
			end
		end
		iUnit:ChangeCombatsMade(1);
		iUnit:SetCriticalPercent(0)
		if bAttack then
			if iUnit:IsHasPromotion(GameInfoTypes.PROMOTION_ITG_MODERN_HIT_AND_RUN) then
				iUnit:ChangeMoves(120); -- first time used changemoves?
			end
			if iUnit:IsHasPromotion(GameInfoTypes.PROMOTION_GREAT_GENERAL_30) or iUnit:IsHasPromotion(GameInfoTypes.PROMOTION_ITG_GREAT_ADMIRAL_26) then
				DoHealNearbyCities(iPlayer, iUnit:GetPlot(), 2, 20)
			end
			if iUnit:IsHasPromotion(GameInfoTypes.PROMOTION_GREAT_GENERAL_31) or iUnit:IsHasPromotion(GameInfoTypes.PROMOTION_ITG_GREAT_ADMIRAL_27) then
				if LastRandom(1, 100) <= 3 then
					DoForTheAllianceGenAdm(iUnit, iPlayer)
				end
			end
			if iUnit:IsHasPromotion(GameInfoTypes.PROMOTION_GREAT_GENERAL_32) or iUnit:IsHasPromotion(GameInfoTypes.PROMOTION_ITG_GREAT_ADMIRAL_28) then
				if LastRandom(1, 100) <= 5 then
					DoWitnessMeGenAdm(iUnit, iPlayer)
				end
			end
			if iUnit:IsHasPromotion(GameInfoTypes.PROMOTION_GREAT_GENERAL_33) or iUnit:IsHasPromotion(GameInfoTypes.PROMOTION_ITG_GREAT_ADMIRAL_29) then
				if LastRandom(1, 100) <= 3 then
					DoForTheHordeGenAdm(iUnit, iPlayer, "FOR THE HORDE!", 3, 0.25)
				end
			end
			if iUnit:GetUnitType() == GameInfoTypes.UNIT_ITG_BOMBER_UU_6 then
				if iUnit:IsOutOfAttacks() then
					if LastRandom(1,5) == 3 then
						iUnit:SetMadeAttack(false);
						iUnit:SetMoves(math.max(60, iUnit:GetMoves()))
					end
				end
			elseif iUnit:GetUnitType() == GameInfoTypes.UNIT_ITG_TRIAL_KNIGHT_1 then
				DoForTheHordeGenAdm(iUnit, iPlayer, nil, 2, nil, 1)
			end
		else

		end
	end
end

function HasAlreadyHPReduced(iUnit)
	local iPlayer = iUnit:GetOwner();
	local uID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
	if gT.Players[iPlayer].UnitsByID[uID] then
		if gT.Players[iPlayer].UnitsByID[uID].RedTempMaxHP then
			return true;
		end
	end
	return false;
end

function ClearUnitTempEffects(cPlayer, pPlayer)
	local gTurn = GetITGGameTurn();
	for i, v in pairs(Players) do
		for iUnit in v:Units() do
			iUnit:SetDefensePenaltyMod(0);
			for cc, prom in pairs(promCombTab) do
				iUnit:SetHasPromotion(prom, false)
			end
			local uID = iUnit:GetID() .. "," .. i .. "," .. iUnit:GetGameTurnCreated();
			if (i == pPlayer) and gT.Players[i] and gT.Players[i].UnitsByID[uID] then
				for a, b in pairs(gT.Players[i].UnitsByID[uID].ForceITGStackType or {}) do
					if (b[2] ~= -1) and (b[2] <= gTurn) then
						CleanTemporaryITGStackType(iUnit, a)
					end
				end
				if gT.Players[i].UnitsByID[uID].RedTempMaxHP then
					iUnit:ChangeMaxHitPoints(gT.Players[i].UnitsByID[uID].RedTempMaxHP)
					gT.Players[i].UnitsByID[uID].RedTempMaxHP = nil;
				end
			end
		end
	end
end

function GetChanceToLockMoves(iUnit, curDefUnit)
	local unitType = iUnit:GetUnitType();
	local chanceToLock = 0;
	if unitType == GameInfoTypes.UNIT_ITG_DESTROYER_UU_3 then
		chanceToLock = chanceToLock + 17;
	elseif unitType == GameInfoTypes.UNIT_ITG_TANK_UU_7 then
		if (curDefUnit:GetUnitCombatType() == ucMechanical) then
			chanceToLock = chanceToLock + 33;
		end
	elseif unitType == GameInfoTypes.UNIT_ITG_ANTI_TANK_GUN_UU_0 then
		if curDefUnit:GetUnitClassType() == GameInfoTypes.UNITCLASS_TANK then
			chanceToLock = chanceToLock + 75;
		end
	elseif unitType == GameInfoTypes.UNIT_ITG_IND_CUIRASS_UU_0 then
		chanceToLock = chanceToLock + 17;
	end
	for a, gfunc in pairs(gf_ChanceToLock) do
		chanceToLock = chanceToLock + gfunc(iUnit, curDefUnit, unitType);
	end
	if iUnit:IsHasPromotion(promSubLock) then
		chanceToLock = chanceToLock + 50;
	end
	return chanceToLock;
end

function PostCombatEffectsTwoUnits(iUnit, curDefUnit, iPlayer, dPlayer)
	local chanceToLock = GetChanceToLockMoves(iUnit, curDefUnit);
	local unitType = iUnit:GetUnitType();
	if unitType == GameInfoTypes.UNIT_ITG_BOMBER_UU_7 then
		curDefUnit:SetDefensePenaltyMod(math.max(curDefUnit:GetDefensePenaltyMod(), 25))
	elseif unitType == GameInfoTypes.UNIT_ITG_AOT_HORSEMAN_UU_1 then
		curDefUnit:SetDefensePenaltyMod(math.max(curDefUnit:GetDefensePenaltyMod(), 25))
	elseif unitType == GameInfoTypes.UNIT_ITG_NW_SPEARMAN then
		curDefUnit:SetDefensePenaltyMod(math.max(curDefUnit:GetDefensePenaltyMod(), 17))
	elseif unitType == GameInfoTypes.UNIT_ITG_TRIAL_PIKEMAN_1 then
		curDefUnit:SetDefensePenaltyMod(math.max(curDefUnit:GetDefensePenaltyMod(), 33))
	elseif unitType == GameInfoTypes.UNIT_ITG_TANK_UU_5 then
		curDefUnit:SetDefensePenaltyMod(math.max(curDefUnit:GetDefensePenaltyMod(), 20))
	elseif unitType == GameInfoTypes.UNIT_ITG_AOT_SWORDSMAN_UU_0 then
		curDefUnit:SetDefensePenaltyMod(math.max(curDefUnit:GetDefensePenaltyMod(), curDefUnit:GetDamage() - curDefDamage))
	elseif unitType == GameInfoTypes.UNIT_ITG_AOT_ARCHER_UU_2 then
		chanceToLock = chanceToLock + curDefUnit:GetDamage() - curDefDamage;
	elseif unitType == GameInfoTypes.UNIT_ITG_TRIAL_LONGSWORDSMAN_4 then
		DoSamuraiCombatStr(iUnit, iPlayer, curDefUnit:GetUnitType())
	elseif unitType == GameInfoTypes.UNIT_ITG_TRIAL_PIKEMAN_6 then
		gT.Globals.Provokes[dPlayer][curDefUnit:GetID()] = {iPlayer, iUnit:GetID()}
	end
	if curDefUnit:GetUnitType() == GameInfoTypes.UNIT_ITG_TRIAL_LONGSWORDSMAN_4 then
		DoSamuraiCombatStr(curDefUnit, dPlayer, iUnit:GetUnitType())
	end
	if iUnit:IsHasPromotion(promAdm9) or iUnit:IsHasPromotion(promGen11) then
		curDefUnit:SetDefensePenaltyMod(math.max(curDefUnit:GetDefensePenaltyMod(), 33))
	end
	if LastChance(chanceToLock) then
		curDefUnit:SetMoves(0);
		if iPlayer == Game.GetActivePlayer() or (curDefUnit:GetOwner() == Game.GetActivePlayer()) then
			Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(curDefUnit:GetX(), curDefUnit:GetY()))), "[ICON_LOCKED]", 0.5)
		end
	end
	if iUnit:GetUnitClassType() == GameInfoTypes.UNITCLASS_BOMBER and HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_MODERN_14, "%T34f") then
		curDefUnit:ChangeExtraTemporaryDefense(-20)
		BombardmentPlotStrike(iX, iY, iPlayer, iUnit, 50)
	end
	if HasPlayerTech(iPlayer, tinnoindu4, "kdeadklcoe") then
		if promCombTab[iUnit:GetUnitCombatType()] then
			for cucc, pp in pairs(promCombTab) do
				curDefUnit:SetHasPromotion( pp, cucc == iUnit:GetUnitCombatType())
			end
		end
	end
	for a, gfunc in pairs(gf_PostCombatTwoUnits) do
		gfunc(iUnit, curDefUnit, iPlayer, dPlayer, unitType)
	end
	if gT.Players[dPlayer] then
		local uID = curDefUnit:GetID() .. "," .. dPlayer .. "," .. curDefUnit:GetGameTurnCreated();
		if gT.Players[dPlayer].UnitsByID[uID] then
			gT.Players[dPlayer].UnitsByID[uID].LastAttacker = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
		end
	end
	--fire last
	if Players[iPlayer]:IsHuman() then
		if iUnit:GetUnitType() == GameInfoTypes.UNIT_ITG_AOT_ARCHER_UU_6 and (curDefDamage == 0) then
			if curDefUnit:GetMaxHitPoints() <= curDefUnit:GetDamage() then
				if curDefUnit:GetUnitClassType() == GameInfoTypes.UNITCLASS_SPEARMAN then
					LuaEvents.ITG_AchievementCompleted(104)
				end
			end
		end
	end
	UnitSurvivedCombatAttack(curDefUnit, curDefDamage, iPlayer)
	UnitWasInCombat(curDefUnit, dPlayer, false)
end

function UnitEndRangedCombatFunction(iPlayer, unitID, iX, iY)
	if ITGdebug then
		print("UERCF", iPlayer, unitID, iX, iY)
	end
	DoCEhLog("UERC", "USRC", nil, iPlayer, unitID, iX, iY)
	local iUnit = Players[iPlayer]:GetUnitByID(unitID);
	if gT.Players[iPlayer] then
		if iUnit:IsHasPromotion(promGen19) or iUnit:IsHasPromotion(promAdm17) then
			if LastChance(17) then
				TakeCareOfEventMorale(iPlayer, 25, {1, "Hero of the Soldiers"})
			end
		end
		if iUnit:IsHasPromotion(promAdm33) or iUnit:IsHasPromotion(promGen38) then
			if LastChance(20) then
				ChangeMeritocracy(iPlayer, 1);
				if iPlayer == Game.GetActivePlayer() then
					Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(iX, iY))), "+1[ICON_ITG_MERITOCRACY]", 0.5)
				end
			end
		end
		local uID = unitID .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
		if not gT.Players[iPlayer].UnitsByID[uID] then
			print("RangedCombatEvent no uID", iPlayer, uID, GameInfo.Units[iUnit:GetUnitType()].Type)
		end
		gT.Players[iPlayer].UnitsByID[uID].LastAttackTurn = GetRealGameTurn();
		gT.Players[iPlayer].UnitsByID[uID].TotalRangedAttacks = (gT.Players[iPlayer].UnitsByID[uID].TotalRangedAttacks or 0) + 1;
		if gT.Players[iPlayer].UnitsByID[uID].TotalRangedAttacks == 10 then
			if Players[iPlayer]:IsHuman() and (iUnit:GetUnitType() == uGarrison) then
				LuaEvents.ITG_AchievementCompleted(37)
			end
		end
	end
	local tCity = Map.GetPlot(iX, iY):GetPlotCity()
	local tcID;
	if tCity then
		if gT.Players[tCity:GetOwner()].HasIdeology[50] then
			ApplyIdeology50Bonus(tCity)
		end
	end
	TakeCareOfExtraBombardment(iUnit, iPlayer, iX, iY, curDefUnit, true)
	if curDefUnit then
		PostCombatEffectsTwoUnits(iUnit, curDefUnit, iPlayer, curDefUnit:GetOwner())
		if curDefUnit:IsHasPromotion(promGen19) or curDefUnit:IsHasPromotion(promAdm17) then
			if LastChance(17) then
				TakeCareOfEventMorale(curDefUnit:GetOwner(), 25, {1, "Hero of the Soldiers"})
			end
		end
		curDefUnit = nil;
	end
	if gT.Players[iPlayer] and gT.Players[iPlayer].HasIdeology[31] then
		Players[iPlayer]:ChangeRangedCombatBonus(2)
	end
	UnitWasInCombat(iUnit, iPlayer, true)
	PostRangedStrikeReturnToNormal(iUnit, iUnit:GetID(), iPlayer)
	gT.Globals.PlotCombatT[Map.GetPlot(iX,iY):GetPlotIndex()] = GetITGGameTurn();
	if ITGdebug then
		print("UERCF end", iPlayer, unitID, iX, iY)
	end
end
GameEvents.UnitEndRangedCombat.Add(UnitEndRangedCombatFunction)

function UnitEndAttackAirFunction(iPlayer, unitID, iX, iY, bMissed)
	if ITGdebug then
		print("ueaaf", iPlayer, unitID, iX, iY)
	end
	DoCEhLog("UEAA", "USAA", nil, iPlayer, unitID, iX, iY, bMissed)
	local iUnit = Players[iPlayer]:GetUnitByID(unitID);
	local tCity = Map.GetPlot(iX, iY):GetPlotCity()
	local tcID;
	local tPlayer;
	if tCity then
		tPlayer = tCity:GetOwner();
		if gT.Players[tCity:GetOwner()].HasIdeology[50] then
			ApplyIdeology50Bonus(tCity)
		end
	end
	if curDefUnit then -- here you don't care if missed;
		tPlayer = curDefUnit:GetOwner();
		if curDefUnit:IsHasPromotion(promGen19) or curDefUnit:IsHasPromotion(promAdm17) then
			if LastChance(17) then
				TakeCareOfEventMorale(tPlayer, 25, {1, "Hero of the Soldiers"})
			end
		end
		PostCombatEffectsTwoUnits(iUnit, curDefUnit, iPlayer, tPlayer)
	end
	if not bMissed then
		TakeCareOfExtraBombardment(iUnit, iPlayer, iX, iY, curDefUnit, true)
		if gT.Players[iPlayer] then
			if gT.Players[iPlayer].HasIdeology[31] then
				Players[iPlayer]:ChangeRangedCombatBonus(2)
			end
		end
		UnitSurvivedCombatHPRelatedBonuses(iUnit, curAttDamage, true)
		UnitWasInCombat(iUnit, iPlayer, true)
	else
		if tPlayer then
			if HasPlayerTech(tPlayer, GameInfoTypes.TECH_UNIQUE_ITG_MODERN_26 ,"Gkeofkew") then
				if LastChance(33) then
					TakeCareOfEventMorale(tPlayer, 25, {1, "Dummies"})
				end
			end
		end
	end
	curDefUnit = nil;
	Game.SetAirStrikeDamageMod(0)
	gT.Globals.PlotCombatT[Map.GetPlot(iX,iY):GetPlotIndex()] = GetITGGameTurn();
	if ITGdebug then
		print("ueaaf end", iPlayer, unitID, iX, iY)
	end
end
GameEvents.UnitEndAttackAir.Add(UnitEndAttackAirFunction)

GameEvents.UnitStartAttackAir.Add(function(iPlayer, unitID, bCity, iX, iY, dPlayer, dUnitID)
	if ITGdebug then
		print("usaa", iPlayer, unitID, bCity, iX, iY, dPlayer, dUnitID)
	end
	DoCEhLog("USAA", nil, "USAA", iPlayer, unitID, bCity, iX, iY, dPlayer, dUnitID)

	--dPlayer dUnitID may be -1, -1
	local iUnit = Players[iPlayer]:GetUnitByID(unitID);
	curAttDamage = iUnit:GetDamage();
	DoClearAllPreCombatStuff(iUnit, iPlayer)
	if gT.Players[iPlayer] then
		gT.Players[iPlayer].Ideo78DataTracking[2] = gT.Players[iPlayer].Ideo78DataTracking[2] + 1;
		if GameInfo.Units[iUnit:GetUnitType()].Suicide then
			gT.Players[iPlayer].LHAirMissiles = gT.Players[iPlayer].LHAirMissiles + 1;
		else
			gT.Players[iPlayer].LHAirRangedStrikes = gT.Players[iPlayer].LHAirRangedStrikes + 1;
		end
		GetBasicCriticalsBasedOnUnitPlayer(iPlayer, iUnit, true, dPlayer, iX,iY, "AirAttack")
		gT.Players[iPlayer].RangedCombatP = gT.Players[iPlayer].RangedCombatP + 1;
	end
	if gT.Players[dPlayer] then
		gT.Players[dPlayer].Ideo78DataTracking[4] = gT.Players[dPlayer].Ideo78DataTracking[4] + 1;
	end
	local defUnit;
	local iCity;
	if bCity then
		iCity = Map.GetPlot(iX, iY):GetPlotCity();
		if LastRandom(1, 100) <= GetCityDefenseBreakChance(iUnit, iPlayer, iCity) then
			if not CanDefendFromDefenseBroken(iCity) then
				iCity:SetDefenseBroken(true)
				if iPlayer == Game.GetActivePlayer() or (iCity:GetOwner() == Game.GetActivePlayer()) then
					Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(iX, iY))), "[ICON_ITG_DEFENSE_BROKEN]", 0.5)
				end
			end
		end
		GetCriticalsWhileAttackingCity(iUnit, iPlayer, true, iCity);
		DisablesOpponentCrits(iUnit, nil, iPlayer, dPlayer, nil, iCity)
		BombardmentCityStrike(iCity, iPlayer, iUnit) --? before combat because can be shoot down by intercept?
	else
		if dUnitID ~= -1 and dPlayer ~= -1 then
			local defUnit = Players[dPlayer]:GetUnitByID(dUnitID);
			DoClearAllPreCombatStuff(defUnit, dPlayer)
			DoAILogForVeteranPromotionAfterCombat(iPlayer, defUnit, Map.GetPlot(iX, iY), iUnit:GetDomainType())
			DoAILogForVeteranPromotionAfterCombat(dPlayer, iUnit, Map.GetPlot(iX, iY), defUnit:GetDomainType())
			curDefUnit = defUnit;
			curDefDamage = defUnit:GetDamage()
			if gT.Players[dPlayer] then
				if IsRealCombatUnit(defUnit) then
					if defUnit:GetDomainType() == dLand then
						gT.Players[dPlayer].LHCombatLand = gT.Players[dPlayer].LHCombatLand + 1;
					elseif defUnit:GetDomainType() == dSea then
						gT.Players[dPlayer].LHCombatNaval = gT.Players[dPlayer].LHCombatNaval + 1;
					elseif defUnit:GetDomainType() == dAir then
						print("Airstrike on air unit?", defUnit:GetName(), dUnitID, defUnit:GetUnitType(), dPlayer, iPlayer, unitID);
					end
				end
				GetBasicCriticalsBasedOnUnitPlayer(dPlayer, defUnit, false, iPlayer, iX, iY, "AirAttack")
				local airStrikeRed = 0;
				if defUnit:GetUnitClassType() == GameInfoTypes.UNITCLASS_INFANTRY then
					if HasPlayerTech(dPlayer, GameInfoTypes.TECH_UNIQUE_ITG_MODERN_20,"EWFWER") then
						airStrikeRed = airStrikeRed - 50;
					end
				end
				if defUnit:IsHasPromotion(GameInfoTypes.PROMOTION_ITG_QUICK_SUBMERGE_I) then
					airStrikeRed = airStrikeRed - 25;
				end
				if defUnit:IsHasPromotion(GameInfoTypes.PROMOTION_ITG_QUICK_SUBMERGE_II) then
					airStrikeRed = airStrikeRed - 25;
				end
				if defUnit:IsHasPromotion(GameInfoTypes.PROMOTION_ITG_QUICK_SUBMERGE_III) then
					airStrikeRed = airStrikeRed - 25;
				end
				if airStrikeRed ~= 0 then
					airStrikeRed = math.max(-90, airStrikeRed);
					Game.SetAirStrikeDamageMod(airStrikeRed)
				end
			end
			GetCriticalsWhenBothUnitsAreDefined(iUnit, defUnit, true);
			GetCriticalInDefense(defUnit, iUnit, true, "Bdkorfser");
			DisablesOpponentCrits(iUnit, defUnit, iPlayer, dPlayer)
			AchievementCheckAttackTwoUnits(iPlayer, iUnit, defUnit)
		end
	end
	if iPlayer == Game.GetActivePlayer() or dPlayer == Game.GetActivePlayer() then
		if iUnit:GetCriticalPercent() ~= 0 then
			Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(iUnit:GetX(), iUnit:GetY()))), math.floor((iUnit:GetCriticalPercent() + 100) * 10) / 1000 .. "[COLOR_NEGATIVE_TEXT]x[ENDCOLOR]", 0.5)
		end
		if defUnit and (defUnit:GetCriticalPercent() ~= 0) then
			Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(iX, iY))), math.floor(defUnit:GetCriticalPercent() * 1000) / 1000 .. "[COLOR_NEGATIVE_TEXT]x[ENDCOLOR]", 0.5)
		end
	end
	if ITGdebug then
		print("usaa ENDED", iPlayer, unitID, bCity, iX, iY, dPlayer, dUnitID)
	end
end)


GameEvents.UnitStartAirSweep.Add(function(iPlayer, unitID, bCity, iX, iY, dPlayer, dUnitID)
	if ITGdebug then
		print("usas", iPlayer, unitID, bCity, iX, iY, dPlayer, dUnitID)
	end
	DoCEhLog("USAS", nil, "USAS", iPlayer, unitID, bCity, iX, iY, dPlayer, dUnitID)
	if dPlayer == -1 and dUnitID then
		--air sweep encountered no enemy!
		return;
	end
	local iUnit = Players[iPlayer]:GetUnitByID(unitID);
	DoClearAllPreCombatStuff(iUnit, iPlayer)
	if gT.Players[iPlayer] then
		gT.Players[iPlayer].LHAirSweeps = gT.Players[iPlayer].LHAirSweeps + 1;
		gT.Players[iPlayer].Ideo78DataTracking[2] = gT.Players[iPlayer].Ideo78DataTracking[2] + 1;
		GetBasicCriticalsBasedOnUnitPlayer(iPlayer, iUnit, true, dPlayer, iX, iY, "AirSweep")
	end
	if gT.Players[dPlayer] then
		gT.Players[dPlayer].Ideo78DataTracking[4] = gT.Players[dPlayer].Ideo78DataTracking[4] + 1;
	end
	local defUnit
	if dUnitID ~= -1 and dPlayer ~= -1 then
		defUnit = Players[dPlayer]:GetUnitByID(dUnitID);
		DoClearAllPreCombatStuff(defUnit, dPlayer)
		DoAILogForVeteranPromotionAfterCombat(iPlayer, defUnit, Map.GetPlot(iX, iY), iUnit:GetDomainType())
		DoAILogForVeteranPromotionAfterCombat(dPlayer, iUnit, Map.GetPlot(iX, iY), defUnit:GetDomainType())
		curDefUnit = defUnit;
		curDefDamage = defUnit:GetDamage()
		if gT.Players[dPlayer] then
			if IsRealCombatUnit(defUnit) then
				if defUnit:GetDomainType() == dLand then
					gT.Players[dPlayer].LHCombatLand = gT.Players[dPlayer].LHCombatLand + 1;
				elseif defUnit:GetDomainType() == dSea then
					gT.Players[dPlayer].LHCombatNaval = gT.Players[dPlayer].LHCombatNaval + 1;
				elseif defUnit:GetDomainType() == dAir then
					-- this is handled in dll hopefully (it probably only happens when air sweep faces intercepting fighter)
				end
			end
			GetBasicCriticalsBasedOnUnitPlayer(dPlayer, defUnit, false, iPlayer, iX, iY, "AirSweep")
		end
		GetCriticalsWhenBothUnitsAreDefined(iUnit, defUnit, true);
		GetCriticalInDefense(defUnit, iUnit, true, "hsds");
		DisablesOpponentCrits(iUnit, defUnit, iPlayer, dPlayer)
		AchievementCheckAttackTwoUnits(iPlayer, iUnit, defUnit)
	end
	if iPlayer == Game.GetActivePlayer() or dPlayer == Game.GetActivePlayer() then
		if iUnit:GetCriticalPercent() ~= 0 then
			Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(iUnit:GetX(), iUnit:GetY()))), math.floor((iUnit:GetCriticalPercent() + 100) * 10) / 1000 .. "[COLOR_NEGATIVE_TEXT]x[ENDCOLOR]", 0.5)
		end
		if defUnit and (defUnit:GetCriticalPercent() ~= 0) then
			Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(iX, iY))), math.floor((defUnit:GetCriticalPercent() + 100) * 10) / 1000 .. "[COLOR_NEGATIVE_TEXT]x[ENDCOLOR]", 0.5)
		end
	end
	if ITGdebug then
		print("usas ENDED", iPlayer, unitID, bCity, iX, iY, dPlayer, dUnitID)
	end
end)

function UnitEndAirSweepFunction(iPlayer, unitID, iX, iY)
	if ITGdebug then
		print("ueasf", iPlayer, unitID, iX, iY)
	end
	DoCEhLog("UEAS", "USAS", nil, iPlayer, unitID, iX, iY)
	if curDefUnit then
		--it means that air sweep actually encountered an enemy :)
		local iUnit = Players[iPlayer]:GetUnitByID(unitID);
		PostCombatEffectsTwoUnits(iUnit, curDefUnit, iPlayer, curDefUnit:GetOwner())
		if gT.Players[iPlayer] and gT.Players[iPlayer].HasIdeology[31] then
			Players[iPlayer]:ChangeRangedCombatBonus(2)
		end
		UnitWasInCombat(iUnit, iPlayer, true)
		curDefUnit = nil;
	end
	if ITGdebug then
		print("ueasf end", iPlayer, unitID, iX, iY)
	end
end
GameEvents.UnitEndAirSweep.Add(UnitEndAirSweepFunction)


function UnitSurvivedCombatAttack(iUnit, dmgBefore, aPlayer) 
	if iUnit:GetMaxHitPoints() > iUnit:GetDamage() then
		local iPlayer = iUnit:GetOwner();
		if gT.Players[iPlayer] then
			if gT.Players[iPlayer].CultBonusOn[152] then
				if iUnit:GetMaxHitPoints() - iUnit:GetDamage() <= 50 then
					if LastRandom(1, 100) <= math.min(33, (iUnit:GetDamage() - dmgBefore)) then
						if iUnit:GetDomainType() == dLand then
							if not iUnit:IsEmbarked() then
								if gT.Players[iPlayer].UnitClassXP[iUnit:GetUnitClassType()] or IsValidUnitClassForLevy[iUnit:GetUnitClassType()] then
									local jUnit = Players[iPlayer]:InitUnit(GameInfoTypes.UNIT_ITG_PEASANT_LEVIES, iUnit:GetX(), iUnit:GetY());
									ITGSCNewUnitCreated(iPlayer, jUnit, nil)
								end
							end
						end
					end
				end
			end
			if iUnit:GetUnitType() == GameInfoTypes.UNIT_ITG_AOT_SPEARMAN_IMMORTAL then
				if not iUnit:IsEmbarked() then
					local dmgTaken = iUnit:GetDamage() - dmgBefore;
					if LastRandom(1, 100) <= dmgTaken then
						local jUnit = Players[iPlayer]:InitUnit(GameInfoTypes.UNIT_ITG_AOT_SPEARMAN_IMMORTAL, iUnit:GetX(), iUnit:GetY());
						jUnit:SetDamage(jUnit:GetMaxHitPoints() - math.max(1, math.floor(dmgTaken/ 2)))
						ITGSCNewUnitCreated(iPlayer, jUnit, nil)
						gT.Players[iPlayer].Ach115 = (gT.Players[iPlayer].Ach115 or 0) + 1;
						if gT.Players[iPlayer].Ach115 == 10 then
							if Players[iPlayer]:IsHuman() then
								LuaEvents.ITG_AchievementCompleted(115)
							end
						end
					end
				end
			elseif iUnit:GetUnitType() == GameInfoTypes.UNIT_ITG_TRIAL_KNIGHT_6 then
				if LastRandom(1, 100) <= math.min(33, (iUnit:GetDamage() - dmgBefore)) then
					if not iUnit:IsEmbarked() then
						local jUnit = Players[iPlayer]:InitUnit(GameInfoTypes.UNIT_ITG_PEASANT_LEVIES, iUnit:GetX(), iUnit:GetY());
						ITGSCNewUnitCreated(iPlayer, jUnit, nil)
					end
				end
			end
			if iUnit:IsHasPromotion(GameInfoTypes.PROMOTION_GREAT_GENERAL_28) then
				if iUnit:GetMaxHitPoints() - iUnit:GetDamage() <= 50 then
					if LastRandom(1, 2) == 2 then
						if not iUnit:IsEmbarked() then
							local jUnit = Players[iPlayer]:InitUnit(GameInfoTypes.UNIT_ITG_PEASANT_LEVIES, iUnit:GetX(), iUnit:GetY());
							ITGSCNewUnitCreated(iPlayer, jUnit, nil)
						end
					end
				end
			end
		end
		if gT.Players[aPlayer] then
			if gT.Players[aPlayer].CultBonusOn[52] then	
				if not iUnit:IsHasPromotion(GameInfoTypes.PROMOTION_ITGSC_UNCONTROLLABLE) then
					if LastRandom(1, 100) <= (iUnit:GetDamage() - dmgBefore) then
						if (not IsImmuneDoDemoralize(iUnit)) then
							iUnit:SetDemoralized(true);
		--					LuaEvents.ITGUnitFlagMercAdmGenDirty(iUnit:GetOwner(), iUnit:GetID())
							if iPlayer == Game.GetActivePlayer() or (aPlayer == Game.GetActivePlayer()) then
								Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(iUnit:GetX(), iUnit:GetY()))), "[ICON_DENOUNCE]", 0.5)
							end
						end
					end
				end
			end
			if HasPlayerTech(aPlayer, GameInfoTypes.TECH_UNIQUE_ITG_MODERN_29, "gergfwerw") then
				if IsMechanicalTab[iUnit:GetUnitCombatType()] then
					if LastRandom(1, 20) == 3 then
						iUnit:SetMoves(0);
						if iPlayer == Game.GetActivePlayer() or (aPlayer == Game.GetActivePlayer()) then
							Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(iUnit:GetX(), iUnit:GetY()))), "[ICON_LOCKED]", 0.5)
						end
					end
				end
			end
		end
		UnitSurvivedCombatHPRelatedBonuses(iUnit, dmgBefore, false)
	end
end

function UnitSurvivedCombatHPRelatedBonuses(iUnit, dmgBefore, bAttacking)
	local iPlayer = iUnit:GetOwner()
	local dmgTaken = iUnit:GetDamage() - dmgBefore;
	local hpleft = iUnit:GetCurrHitPoints();
	if iUnit:IsHasPromotion(promGen12) or iUnit:IsHasPromotion(promAdm10) then
		iUnit:ChangeDamage(dmgTaken * -0.25)
	end
	if gT.Players[iPlayer] then
		if gT.Players[iPlayer].CultBonusOn[37] then
			if hpleft < 5 then
				local uID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
				if gT.Players[iPlayer].UnitsByID[uID] then
					if not gT.Players[iPlayer].UnitsByID[uID].CotW then
						local iFaith = 15;
						local hStr = iFaith .. "[ICON_PEACE]1[ICON_ITG_MORALE]"
						ChangeITGFaith(iPlayer, iFaith);
						TakeCareOfEventMorale(iPlayer, 25, {1, "Cult of the Warrior"})
						iUnit:ChangeDamage(-50)
						gT.Players[iPlayer].UnitsByID[uID].CotW = true;
						if iPlayer == Game.GetActivePlayer() then
							Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(iUnit:GetX(), iUnit:GetY()))), hStr, 0.5)
						end
					end
				end
			end
		end
	end
	if not bAttacking then
		if iUnit:GetUnitType() == GameInfoTypes.UNIT_ITG_BATTLESHIP_UU_1 then
			iUnit:ChangeDamage(-10);
		end
	end
end

function EndTurnCombatStuff(iPlayer)
	for iUnit in Players[iPlayer]:Units() do
		if iUnit:IsHasPromotion(promAdm11) or iUnit:IsHasPromotion(promGen14) then
			iUnit:ChangeExperience(3);
		end
	end
end

GameEvents.UnitStartRangedCombat.Add(function(iPlayer, unitID, bCity, iX, iY, dPlayer, dUnitID)
	if ITGdebug then
		print("usrc", iPlayer, unitID, bCity, iX, iY, dPlayer, dUnitID)
	end
	if not bCity then
		if dPlayer == -1 and dUnitID == -1 then
			print("Pre-melee ranged strike did not find a target...", iPlayer, unitID, bCity, iX, iY, dPlayer, dUnitID)
			return;
		end
	end
	DoCEhLog("USRC", nil, "USRC", iPlayer, unitID, bCity, iX, iY, dPlayer, dUnitID)
	--dPlayer dUnitID may be -1, -1
	local iUnit = Players[iPlayer]:GetUnitByID(unitID);
	DoClearAllPreCombatStuff(iUnit, iPlayer)
	if gT.Players[iPlayer] then
		gT.Players[iPlayer].Ideo78DataTracking[2] = gT.Players[iPlayer].Ideo78DataTracking[2] + 1;
		if iUnit:GetDomainType() == dLand then
			gT.Players[iPlayer].LHCombatLand = gT.Players[iPlayer].LHCombatLand + 1;
		elseif iUnit:GetDomainType() == dSea then
			gT.Players[iPlayer].LHCombatNaval = gT.Players[iPlayer].LHCombatNaval + 1;
		end
		GetBasicCriticalsBasedOnUnitPlayer(iPlayer, iUnit, true, dPlayer, iX,iY, "Ranged")
		gT.Players[iPlayer].RangedCombatP = gT.Players[iPlayer].RangedCombatP + 1;
	end
	if gT.Players[dPlayer] then
		gT.Players[dPlayer].Ideo78DataTracking[4] = gT.Players[dPlayer].Ideo78DataTracking[4] + 1;
	end
	local defUnit;
	if bCity then
		local iCity = Map.GetPlot(iX, iY):GetPlotCity();
		if LastRandom(1, 100) <= GetCityDefenseBreakChance(iUnit, iPlayer, iCity) then
			if not CanDefendFromDefenseBroken(iCity) then
				iCity:SetDefenseBroken(true)
				if iPlayer == Game.GetActivePlayer() or (iCity:GetOwner() == Game.GetActivePlayer()) then
					Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(iX, iY))), "[ICON_ITG_DEFENSE_BROKEN]", 0.5)
				end
			end
		end
		GetCriticalsWhileAttackingCity(iUnit, iPlayer, true, iCity);
		DisablesOpponentCrits(iUnit, nil, iPlayer, dPlayer, nil, iCity)
		BombardmentCityStrike(iCity, iPlayer, iUnit)
	else
		if dUnitID ~= -1 and dPlayer ~= -1 then
			defUnit = Players[dPlayer]:GetUnitByID(dUnitID);
			DoClearAllPreCombatStuff(defUnit, dPlayer)
			DoAILogForVeteranPromotionAfterCombat(iPlayer, defUnit, Map.GetPlot(iX, iY), iUnit:GetDomainType())
			DoAILogForVeteranPromotionAfterCombat(dPlayer, iUnit, Map.GetPlot(iX, iY), defUnit:GetDomainType())
			curDefUnit = defUnit;
			curDefDamage = defUnit:GetDamage()
			if gT.Players[dPlayer] then
				if IsRealCombatUnit(defUnit) then
					if defUnit:GetDomainType() == dLand then
						gT.Players[dPlayer].LHCombatLand = gT.Players[dPlayer].LHCombatLand + 1;
					elseif defUnit:GetDomainType() == dSea then
						gT.Players[dPlayer].LHCombatNaval = gT.Players[dPlayer].LHCombatNaval + 1;
					end
				end
				GetBasicCriticalsBasedOnUnitPlayer(dPlayer, defUnit, false, iPlayer, iX, iY, "Ranged")
			end
			GetCriticalsWhenBothUnitsAreDefined(iUnit, defUnit, true);
			GetCriticalInDefense(defUnit, iUnit, true, "okfoesf");
			DisablesOpponentCrits(iUnit, defUnit, iPlayer, dPlayer)
			AchievementCheckAttackTwoUnits(iPlayer, iUnit, defUnit)
		end
	end
	if iPlayer == Game.GetActivePlayer() or dPlayer == Game.GetActivePlayer() then
		if iUnit:GetCriticalPercent() ~= 0 then
			Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(iUnit:GetX(), iUnit:GetY()))), math.floor((iUnit:GetCriticalPercent() + 100) * 10) / 1000 .. "[COLOR_NEGATIVE_TEXT]x[ENDCOLOR]", 0.5)
		end
		if defUnit and (defUnit:GetCriticalPercent() ~= 0) then
			Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(iX, iY))), math.floor((defUnit:GetCriticalPercent() + 100) * 10) / 1000 .. "[COLOR_NEGATIVE_TEXT]x[ENDCOLOR]", 0.5)
		end
	end
	if ITGdebug then
		print("usrc ENDED", iPlayer, unitID, bCity, iX, iY, dPlayer, dUnitID)
	end
end)

function PrepareCitiesDataForAmountOfAttacks(iPlayer)
	local basePlayer = 1;
	local afrInnoT5 = HasPlayerTech(iPlayer, innoTafr5, "Fser")
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		local hpleft = iCity:GetMaxHitPoints() - iCity:GetDamage();
		if hpleft < 2 then
			gT.Cities[cID].NumAttacks = 0;
		else
			local numattacks = basePlayer;
			local iUnit = iCity:GetGarrisonedUnit();
			if iUnit then
				if iUnit:IsHasPromotion(merProm19) or iUnit:IsHasPromotion(promGen24) then
					numattacks = numattacks + 1;
				end
			end
			if HasPlayerTech(iPlayer, tAncCS21, "Vaweed") then
				if gT.Cities[cID].CultureOwner == iPlayer then
					if gT.Cities[cID].CulturePercentageOwnership >= 75 then
						numattacks = numattacks + 1;
						if gT.Cities[cID].CulturePercentageOwnership >= 90 then
							numattacks = numattacks + 1;
						end						
					end
				end
			end
			if gT.Players[iPlayer].CultBonusOn[43] then
				if iCity:GetDamage() / iCity:GetMaxHitPoints() > 0.5 then
					numattacks = numattacks + 1;
				end
			end
			if gT.Players[iPlayer].HasIdeology[9] then
				if LastChance(30) then
					numattacks = numattacks + 1;
				end
			end
			numattacks = numattacks + GetNumCityAcademiesWithAbility(iCity, 13)
			gT.Cities[cID].NumAttacks = numattacks + (gT.Cities[cID].GPBonusAttack or 0);
			gT.Cities[cID].NumAttacksWorkRate = 0;
			if gT.Players[iPlayer].CultBonusOn[44] then
				if gT.Cities[cID].WorkRate >= DBScenario.WorkRatePerAttack then
					gT.Cities[cID].NumAttacksWorkRate = 1;
				end
			end
		end
		if afrInnoT5 then
			if GetITGGameTurn() - gT.Cities[cID].LastRangedStrike > 1 then
				iCity:ChangeAttackMod(25);
				ChangeITGCityInteger(iCity, "CI_INNO_AFR_TRIAL_5", 25)
			end
		end
	end
end

LuaEvents.ITGSG_RequestCityAttackString.Add(function(iPlayer, cityID)
	local iCity = Players[iPlayer]:GetCityByID(cityID);
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	if gT.Cities[cID] then
		local sText;
		if gT.Cities[cID].NumAttacksWorkRate > 0 then
			if gT.Cities[cID].NumAttacks == 0 then
				sText = "[ICON_WORKER]"
			else
				sText = gT.Cities[cID].NumAttacksWorkRate + gT.Cities[cID].NumAttacks;
			end
		end
		if gT.Cities[cID].NumAttacks > 1 then
			sText = gT.Cities[cID].NumAttacks;
		end
		MapModData.ITGSG = sText;
	end
end)

function WorkRateDirtyCityAttack(iCity, cID)
	if gT.Cities[cID].NumAttacksWorkRate > 0 then
		if gT.Cities[cID].WorkRate < DBScenario.WorkRatePerAttack then
			gT.Cities[cID].NumAttacksWorkRate = 0;
			if gT.Cities[cID].NumAttacks == 0 then
				iCity:SetMadeAttack(true)
			end
			Events.SpecificCityInfoDirty(iCity:GetOwner(), iCity:GetID(), CityUpdateTypes.CITY_UPDATE_TYPE_ENEMY_IN_RANGE)
		end
	end
end

function SpendAttackCityRangedStrike(iPlayer, iCity, cID, bAttack)
	gT.Cities[cID].NumAttacks = gT.Cities[cID].NumAttacks - 1;
	if bAttack then
		gT.Cities[cID].NumAttackesEverMade = gT.Cities[cID].NumAttackesEverMade + 1;
		gT.Cities[cID].LastRangedStrike = GetITGGameTurn();
		if GetITGCityInteger(iCity, "CI_INNO_AFR_TRIAL_5") > 0 then
			iCity:ChangeAttackMod(-GetITGCityInteger(iCity, "CI_INNO_AFR_TRIAL_5"))
			SetITGCityInteger(iCity, "CI_INNO_AFR_TRIAL_5", 0);
		end
	end
	if gT.Cities[cID].NumAttacks > 0 then
		iCity:SetMadeAttack(false)
	else
		if gT.Cities[cID].NumAttacks < 0 then
			if gT.Cities[cID].NumAttacksWorkRate > 0 then
				gT.Cities[cID].NumAttacksWorkRate = gT.Cities[cID].NumAttacksWorkRate - 1;
				MakeCitySpendWorkRate(iCity, iPlayer, DBScenario.WorkRatePerAttack)
				if iPlayer == Game.GetActivePlayer() then
					Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(iCity:GetX(),iCity:GetY()))), -DBScenario.WorkRatePerAttack .. "[ICON_WORKER]", 0.5)
				end
			end
		end
		if gT.Cities[cID].NumAttacksWorkRate > 0 then
			iCity:SetMadeAttack(false)
		end
	end
end

GameEvents.CityPreRangedStrikeAtXY.Add(function(iPlayer, cityID, iX, iY, dUnitID, dPlayer)
	if ITGdebug then
		print("cPrsaxy", iPlayer, cityID, iX, iY, dUnitID, dPlayer)
	end
	DoCEhLog("CPRS", nil, "CPRS", iPlayer, cityID, iX, iY, dUnitID, dPlayer)
	local cityCrit = 1;
	local iCity = Players[iPlayer]:GetCityByID(cityID);
--	DoCallCityStrikeMode(iCity:Plot():GetPlotIndex())
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	if gT.Players[iPlayer] then
		if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_ASIA_2, "Vreee") then
			if LastRandom(1, 5) == 3 then
				Players[iPlayer]:ChangeCityRangeStrikeCriticalMod(300)
				cityCrit = cityCrit + 3;
			end
		end
		if HasPlayerTech(iPlayer, tinnopagan8, "tinnopagan8") then
			if LastChance(GetITGGameTurn() - (gT.Globals.PlotCombatT[Map.GetPlot(iX, iY):GetPlotIndex()] or 0)) then
				Players[iPlayer]:ChangeCityRangeStrikeCriticalMod(200)
				cityCrit = cityCrit + 2;
			end
		end
		if gT.Players[iPlayer].CultBonusOn[8] then
			if LastChance(iCity:GetPopulation()) then
				Players[iPlayer]:ChangeCityRangeStrikeCriticalMod(100)
				cityCrit = cityCrit + 1;
			end
		end
	end
	local dUnit = Players[dPlayer]:GetUnitByID(dUnitID);
	GetCriticalInDefense(dUnit, nil, true, "CityStrike", iCity)
	DisablesOpponentCrits(nil, dUnit, iPlayer, dPlayer, iCity)
	if iPlayer == Game.GetActivePlayer() or dPlayer == Game.GetActivePlayer() then
		if cityCrit ~= 1 then
			Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(iCity:GetX(), iCity:GetY()))), math.floor(cityCrit * 10) / 10 .. "[COLOR_NEGATIVE_TEXT]x[ENDCOLOR]", 0.5)
		end
		if dUnit:GetCriticalPercent() ~= 0 then
			Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(iX, iY))), math.floor((dUnit:GetCriticalPercent() + 100) * 10) / 1000 .. "[COLOR_NEGATIVE_TEXT]x[ENDCOLOR]", 0.5)
		end
	end
end)

GameEvents.CityRangedStrikeAtXY.Add(function(iPlayer, cityID, iX, iY, dUnitID, dPlayer, dHPbefore)
	if ITGdebug then
		print("crsaxy", iPlayer, cityID, iX, iY, dUnitID, dPlayer, dHPbefore)
	end
	DoCEhLog("CRSend", "CPRS", nil, iPlayer, cityID, iX, iY, dUnitID, dPlayer, dHPbefore)

	local iCity = Players[iPlayer]:GetCityByID(cityID);
--	DoCallCityStrikeMode(nil);
	local iUnit = Players[dPlayer]:GetUnitByID(dUnitID);
	if iUnit then
		DoAILogForVeteranPromotionAfterCombat(dPlayer, nil, Map.GetPlot(iX, iY), iUnit:GetDomainType())
		if gT.Players[dPlayer] then
			if IsRealCombatUnit(iUnit) then
				if iUnit:GetDomainType() == dLand then
					gT.Players[dPlayer].LHCombatLand = gT.Players[dPlayer].LHCombatLand + 1;
				elseif iUnit:GetDomainType() == dSea then
					gT.Players[dPlayer].LHCombatNaval = gT.Players[dPlayer].LHCombatNaval + 1;
				end
			end
		end
		if iUnit:IsHasPromotion(promGen19) or iUnit:IsHasPromotion(promAdm17) then
			if LastChance(17) then
				TakeCareOfEventMorale(iPlayer, 25, {1, "Hero of the Soldiers"})
			end
		end
		UnitSurvivedCombatAttack(iUnit, dHPbefore, iPlayer)
		UnitWasInCombat(iUnit, dPlayer, false)
	end
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	if HasPlayerTech(iPlayer, tAncCS21, "Vaweed") then
		DoChangeCityCultureOwnership(cID, iCity, iPlayer, 7)
	end
	if gT.Players[iPlayer].HasPlayerWonder[renWonder29] then
		DoChangeCityCultureOwnership(cID, iCity, iPlayer, 15)
	end
	if gT.Players[gT.Cities[cID].CultureOwner] and gT.Players[gT.Cities[cID].CultureOwner].CultBonusOn[172] then
		DoChangeCityCultureOwnership(cID, iCity, gT.Cities[cID].CultureOwner, 10)
	end
	if iCity:IsHasBuilding(GameInfoTypes.BUILDING_ITG_NEW_WORLD_WONDER_22) then
		TakeCareOfAmberBombardment(iCity, iPlayer, iX, iY, iUnit)
	end
	Players[iPlayer]:SetCityRangeStrikeCriticalMod(0)
	SpendAttackCityRangedStrike(iPlayer, iCity, cID, true)
	gT.Globals.PlotCombatT[Map.GetPlot(iX,iY):GetPlotIndex()] = GetITGGameTurn();
	if ITGdebug then
		print("crsaxy ended", iPlayer, cityID, iX, iY, dUnitID, dPlayer, dHPbefore)
	end
end)

function GetCriticalsWhileAttackingCity(iUnit, iPlayer, bRanged, iCity)
	if gT.Players[iPlayer] then
		if gT.Players[iPlayer].CultBonusOn[175] then
			if iUnit:GetUnitCombatType() == ucSiege then
				if LastChance(17) then
					iUnit:ChangeCriticalPercent(200)
				end
			end
		end
		if iUnit:GetUnitType() == GameInfoTypes.UNIT_ITG_TANK_UU_6 then
			if iCity:GetDamage() == 0 then
				if LastChance(25) then
					iUnit:ChangeCriticalPercent(100)
				end
			end
		end
		if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_MODERN_22, "ITgmod22") then
			if iCity:IsOccupied() then
				if LastChance(10) then
					iUnit:ChangeCriticalPercent(100)
				end
			end
		end
	end
end

function GetCriticalInDefense(defUnit, iUnit, bRanged, hS, iCity)
	if not defUnit then
		print("Error 5125125", hS)
	end
	if bRanged then
		if defUnit:IsHasPromotion(promAdm7) then
			if LastChance(20) then
				defUnit:ChangeCriticalPercent(100)
			end
		end
		if defUnit:GetUnitType() == GameInfoTypes.UNIT_ITG_DESTROYER_UU_4 then
			if LastRandom(1,100) <= 20 then
				defUnit:ChangeCriticalPercent(100)
			end
		end
		if defUnit:IsHasPromotion(GameInfoTypes.PROMOTION_ITG_SEVEN_SEAS_3) then
			if LastRandom(1,100) <= 50 then
				defUnit:ChangeCriticalPercent(100)
			end
		end
		if iUnit then
			if defUnit:IsHasPromotion(promGen9) then
				if iUnit:GetDomainType() == dLand then
					if LastChance(20) then
						defUnit:ChangeCriticalPercent(100)
					end
				end
			end
		end
	end
	if iCity then -- only City!! another is if both are defined
		local dPlayer = defUnit:GetOwner();
		local iCityOwner = iCity:GetOwner();
		if defUnit:GetUnitType() == GameInfoTypes.UNIT_ITG_IND_LINE_INFANTRY_UU_3 then
			if Players[iCityOwner]:IsMinorCiv() then 
				if LastChance(20) then
					defUnit:ChangeCriticalPercent(200)
				end
			end
		end
		if gT.Players[dPlayer] then
			if gT.Players[dPlayer].CritGrievances[iCityOwner] then
				if LastChance(gT.Players[dPlayer].CritGrievances[iCityOwner]) then
					defUnit:ChangeCriticalPercent(100)
				end
			end
			if gT.Players[dPlayer].ParadropTPrev[iCityOwner] then
				if LastChance(15) then
					defUnit:ChangeCriticalPercent(100)
				end
			end
		end
	end
	if defUnit:IsHasPromotion(promMerc8) then
		if LastChance(25) then
			defUnit:ChangeCriticalPercent(100)
		end
	end
	for a, gfunc in pairs(gf_CriticalsInDefense) do
		gfunc(defUnit, iUnit, bRanged, hS, iCity)
	end
end

function GetCriticalsTwoUnitsAttackNoMatter(iPlayer, iUnit, sUnit, bRanged)
	if iUnit:GetUnitType() == GameInfoTypes.UNIT_ITG_ANTI_TANK_GUN_UU_8 then
		if sUnit:GetUnitClassType() == GameInfoTypes.UNITCLASS_TANK then
			if LastChance(30) then
				iUnit:ChangeCriticalPercent(500)
			end
		end
	elseif unitType == GameInfoTypes.UNIT_ITG_TRIAL_PIKEMAN_4 then
		if (not bRanged) and (not sUnit:IsCannotBeFlanked()) then
			if LastChance(25) then
				local iNumAdjacentFriends = sUnit:GetNumEnemyUnitsAdjacent(iUnit);
				if (iNumAdjacentFriends > 0) then
					local baseFlank = iNumAdjacentFriends * GameDefines["BONUS_PER_ADJACENT_FRIEND"];
					local iFlankModifier = iUnit:FlankAttackModifier();
					if (iFlankModifier ~= 0) then
						baseFlank = baseFlank * (100 + iFlankModifier) / 100;
					end
					iUnit:ChangeCriticalPercent(baseFlank * 3)
				end
			end
		end
	end
	if gT.Players[iPlayer] then
		if gT.Players[iPlayer].CultBonusOn[53] then
			if LastRandom(1, 5) == 3 then
				if IsValidForTechnologicalCrit(iUnit, sUnit) then
					iUnit:ChangeCriticalPercent(200)
				end
			end
		end
	end
	if iUnit:GetUnitClassType() == GameInfoTypes.UNITCLASS_INFANTRY then
		if LastChance(2) then
			if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_MODERN_29, "bwbtrgrtg") then
				if (sUnit:GetUnitCombatType() == GameInfoTypes.UNITCOMBAT_ARMOR) or (sUnit:GetDomainType() == "DOMAIN_AIR") then
					iUnit:ChangeCriticalPercent(500)
				end
			end
		end
	end
end

function GetCriticalsWhenBothUnitsAreDefined(iAttacker, iDefender, bRanged)
	local dPlayer = iDefender:GetOwner();
	local iPlayer = iAttacker:GetOwner();
	GetCriticalsTwoUnitsAttackNoMatter(iPlayer, iAttacker, iDefender, bRanged)
	GetCriticalsTwoUnitsAttackNoMatter(dPlayer, iDefender, iAttacker, bRanged)
	if gT.Players[dPlayer] then
		if bRanged then
			if gT.Players[dPlayer].CultBonusOn[81] then
				if iDefender:GetDomainType() == dSea then
					if iAttacker:GetDomainType() == dLand then
						if LastRandom(1,2) == 2 then
							iDefender:ChangeCriticalPercent(100)
						end
					end
				end
			end
		end
		if iAttacker:GetUnitClassType() == GameInfoTypes.UNITCLASS_SUBMARINE then
			if HasPlayerTech(dPlayer, GameInfoTypes.TECH_RADAR, "5g4f4325235g3") then
				if LastRandom(1,4) == 3 then
					iDefender:ChangeCriticalPercent(200)
				end
			end
			if iDefender:GetUnitType() == GameInfoTypes.UNIT_ITG_BATTLESHIP_UU_5 then
				if LastRandom(1,5) == 3 then
					iDefender:ChangeCriticalPercent(200)
				end
			end
		end
	end
	if iAttacker:GetDomainType() == dAir then
		local sPlot = iDefender:GetPlot();
		for s = 0, sPlot:GetNumUnits() - 1 do
			local sUnit = sPlot:GetUnit(s);
			if sUnit:GetOwner() == dPlayer then
				if sUnit:GetUnitType() == GameInfoTypes.UNIT_ITG_FIGHTER_UU_9 then
					if LastRandom(1, 100) <= 17 then
						iDefender:ChangeCriticalPercent(100)
					end
				end
			end
		end
	end
	if iAttacker:IsHasPromotion(promGen2) or iAttacker:IsHasPromotion(promAdm4) then
		if LastRandom(1, 100) <= 15 then
			iAttacker:ChangeCriticalPercent(100)
		end
	end
	if iAttacker:IsHasPromotion(GameInfoTypes.PROMOTION_ITG_SEVEN_SEAS_1) then
		if LastRandom(1, 100) <= 10 then
			iAttacker:ChangeCriticalPercent(500)
		end
	end
	if iAttacker:GetUnitClassType() == GameInfoTypes.UNITCLASS_DESTROYER then
		if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_MODERN_6, "34r4") then
			if LastRandom(1, 100) <= 7 then
				iAttacker:ChangeCriticalPercent(500)
			end
		end
	elseif iAttacker:GetUnitClassType() == GameInfoTypes.UNITCLASS_INFANTRY then
		if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_MODERN_29, "vbtrhrhrth") then
			if iDefender:GetUnitType() == uGarrison then
				if LastChance(2) then
					iAttacker:ChangeCriticalPercent(500)
				end
			end
		end
	end
	if iAttacker:GetUnitType() == GameInfoTypes.UNIT_ITG_BOMBER_UU_14 then
		if iDefender:GetDomainType() == dSea then
			if LastRandom(1, 10) == 7 then
				iAttacker:ChangeCriticalPercent(100)
			end
		end
	elseif (iAttacker:GetUnitType() == GameInfoTypes.UNIT_ITG_BATTLESHIP_UU_9) or (iAttacker:GetUnitType() == GameInfoTypes.UNIT_ITG_IND_MUSKETMAN_UU_7) then
		if LastRandom(1, 100) <= iDefender:GetDamage() then
			iAttacker:ChangeCriticalPercent(100)
		end
	elseif iAttacker:GetUnitType() == GameInfoTypes.UNIT_ITG_TANK_UU_6 then
		if iDefender:GetDamage() == 0 then
			if LastRandom(1, 4) == 3 then
				iAttacker:ChangeCriticalPercent(100)
			end
		end
	elseif iAttacker:GetUnitType() == GameInfoTypes.UNIT_ITG_AOT_HORSEMAN_UU_4 then
		if LastRandom(1, 5) == 3 then
			if gT.Players[iPlayer] then
				local uID = iAttacker:GetID() .. "," .. iPlayer .. "," .. iAttacker:GetGameTurnCreated();
				if gT.Players[iPlayer].UnitsByID[uID] then
					if gT.Players[iPlayer].UnitsByID[uID].LastAttacker == iDefender:GetID() .. "," .. dPlayer .. "," .. iDefender:GetGameTurnCreated() then
						iAttacker:ChangeCriticalPercent(200)
					end
				end
			end
		end
	end
	for a, gfunc in pairs(gf_CritsIfBothDefined) do
		gfunc(iAttacker, iPlayer, iDefender, dPlayer, bRanged);
	end
end

function GetBasicCriticalsBasedOnUnitPlayer(iPlayer, iUnit, bAttack, iSecondPlayer, X, Y, hstr)
	if not iSecondPlayer then
		print("Hola! No secondo playero?", iPlayer, iUnit, bAttack, iSecondPlayer, X, Y, hstr)
	end
	local unitType = iUnit:GetUnitType();
	local iPlot = Map.GetPlot(X, Y);
	local bCity = iPlot:IsCity()
	if (not bCity) and ((iSecondPlayer or -1) ~= -1) then
		if gT.Players[iPlayer].CultBonusOn[165] then
			if LastRandom(1, 10) == 3 then
				if GetITGReligion(iPlayer) ~= GetITGReligion(iSecondPlayer) then
					iUnit:ChangeCriticalPercent(200)
				end
			end
		end	
	end
	if gT.Players[iPlayer].CultBonusOn[14] and (not bAttack) and (not bCity) then
		if iUnit:GetUnitCombatType() == ucArcher then
			local uID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
			if gT.Players[iPlayer].UnitsByID[uID] then
				local pData = gT.Players[iPlayer].UnitsByID[uID].LastKillData;
				if pData and LastChance((GetITGGameTurn() - pData[1]) * 2) then
					iUnit:ChangeCriticalPercent(250)
				end
			end
		end
	end
	if gT.Players[iPlayer].CritGrievances[iSecondPlayer] then
		if LastRandom(1, 100) <= gT.Players[iPlayer].CritGrievances[iSecondPlayer] then
			iUnit:ChangeCriticalPercent(100)
		end
	end
	if gT.Players[iPlayer].ParadropTPrev[iSecondPlayer] then
		if LastChance(15) then
			iUnit:ChangeCriticalPercent(100)
		end
	end
	if gT.Players[iPlayer].CultBonusOn[50] then
		if iPlot:IsImprovementPillaged() then
			if (iPlot:GetOwner() == iPlayer) == bAttack then
				if LastRandom(1,20) <= 3 then
					iUnit:ChangeCriticalPercent(200)
				end
			end
		end
	end
	if bAttack and iUnit:IsHasPromotion(GameInfoTypes.PROMOTION_ITG_PRECISION) and (iUnit:GetMoves() == iUnit:MaxMoves()) then
		if LastChance(15) then
			iUnit:ChangeCriticalPercent(200)
		end
	end
	if bAttack and (iUnit:GetPlot():IsWater()) then
		if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_25 ,"^$53224%#") then
			if iUnit:GetDomainType() == dLand then
				if LastChance(25) then
					iUnit:ChangeCriticalPercent(200)
				end
			end
		end
	end
	if gT.Players[iPlayer].CultBonusOn[148] then
		if Players[iPlayer]:GetNumCities() > 0 then
			if LastRandom(1, 100) <= GetClosestCityDistanceToXY(iPlayer, X, Y) then
				iUnit:ChangeCriticalPercent(100)
			end
		end
	end
	if gT.Players[iPlayer].CultBonusOn[41] then
		if LastChance(20) then
			if IsAdjacentToColony(X, Y) then
				iUnit:ChangeCriticalPercent(100)
			end
		end
	end
	if gT.Players[iPlayer].HasIdeology[29] then
		if gT.Players[iPlayer].ReconCenter then
			local hrplot = Map.GetPlotByIndex(gT.Players[iPlayer].ReconCenter);
			if Map.PlotDistance(X, Y, hrplot:GetX(), hrplot:GetY()) <= 3 then
				if LastChance(10) then
					iUnit:ChangeCriticalPercent(100)
				end
			end
		end
	end
	if HasPlayerTech(iPlayer, tinnopagan8, "tinnopagan8") then
		if not bCity then
			if LastChance(GetITGGameTurn() - (gT.Globals.PlotCombatT[iPlot:GetPlotIndex()] or 0)) then
				iUnit:ChangeCriticalPercent(200)
			end
		end
	end
	if gT.Players[iPlayer].CultBonusOn[150] then
		local chance = 0;
		for jkj = 0, 5 do
			local nPlot = Map.PlotDirection(X, Y, jkj);
			if nPlot and (nPlot:GetOwner() == iPlayer) and (nPlot:GetFeatureType() == fForest or nPlot:GetFeatureType() == fJungle) then
				chance = chance + 5;
			end
		end
		if chance > 0 and LastChance(chance) then
			iUnit:ChangeCriticalPercent(100)
		end
	end
	if IsValidForKiliCrit(iPlayer, iPlot) then
		if LastRandom(1, 100) <= 5 then
			iUnit:ChangeCriticalPercent(100)
		end
	end
	if gT.Players[iPlayer].HasIdeology[51] then
		if gT.Players[iPlayer].Morale < 0 then
			if LastRandom(1, 100) <= -gT.Players[iPlayer].Morale then
				iUnit:ChangeCriticalPercent(100)
			end
		end
	end
	if IsValidForDesertRouteCrit(iPlayer, iPlot) then
		if LastRandom(1, 100) <= 10 then
			iUnit:ChangeCriticalPercent(100)
		end
	end
	if gT.Players[iPlayer].TopkapiPalace then
		if LastChance(5) then
			iUnit:ChangeCriticalPercent(100)
		end
	end
	if gT.Players[iPlayer].HasIdeology[73] then
		if LastChance(20) then
			local iPower = 0;
			for sgv, h in pairs(gT.Players[iPlayer].Governors) do
				if gT.Globals.Governors[sgv].City then
					if gT.Globals.Governors[sgv].Power > iPower then
						local sPlot = Map.GetPlotByIndex(gT.Globals.Governors[sgv].City);
						if Map.PlotDistance(sPlot:GetX(), sPlot:GetY(), X, Y) <= 10 then
							iPower = gT.Globals.Governors[sgv].Power;
						end
					end
				end
			end
			if iPower > 0 then
				iUnit:ChangeCriticalPercent(iPower)
			end
		end
	end
	if Players[iPlayer]:IsMinorCiv() then
		local gAlly = Players[iPlayer]:GetAlly();
		if gT.Players[gAlly] and gT.Players[gAlly].HasIdeology[5] then
			if LastRandom(1, 10) == 7 then
				iUnit:ChangeCriticalPercent(200)
			end
		end
	end
	if gT.Players[iPlayer].HasIdeology[4] then
		if bAttack and ((hstr == "MeleeCity") or (hstr == "Melee")) then
			if ((iSecondPlayer or -1) ~= -1) then
				if LastRandom(1, 100) <= GetCriticalCodexChance(iPlayer, iSecondPlayer) then
					iUnit:ChangeCriticalPercent(100)
				end
			end
		end
	end
	if gT.Players[iPlayer].HasIdeology[85] then
		if bAttack and ((hstr == "MeleeCity") or (hstr == "Melee")) then
			if ((iSecondPlayer or -1) ~= -1) then
				if LastRandom(1, 100) <= GetCriticalMoraleChance(iPlayer, iSecondPlayer) then
					iUnit:ChangeCriticalPercent(100)
				end
			end
		end
	end
	if gT.Players[iPlayer].CultBonusOn[101] then
		if iUnit:GetDamage() > 75 then
			if LastRandom(1,10) == 3 then
				iUnit:ChangeCriticalPercent(500)
			end
		end
	end
	if gT.Players[iPlayer].GovNatDayCrit then
		if LastChance(20) then
			iUnit:ChangeCriticalPercent(100)
		end
	end
	if iUnit:GetDomainType() == dLand then
		if LastRandom(1, 100) <= gT.Players[iPlayer].LandAcaCritical then
			iUnit:ChangeCriticalPercent(100)
		end
	elseif iUnit:GetDomainType() == dSea then
		if LastRandom(1, 100) <= gT.Players[iPlayer].NavalAcaCritical then
			iUnit:ChangeCriticalPercent(100)
		end
	end
	
	if (unitType == GameInfoTypes.UNIT_ITG_AOT_ARCHER_NUBIA) then
		if bAttack then
			if LastChance(GetNumUnitsOfType(iPlayer,GameInfoTypes.UNIT_ITG_AOT_ARCHER_NUBIA)) then
				iUnit:ChangeCriticalPercent(100)
			end
		end
	elseif unitType == GameInfoTypes.UNIT_ITG_NW_MAYAN_ATLATLIST then
		if bAttack then
			if Map.PlotDistance(iUnit:GetX(), iUnit:GetY(), X, Y) == 1 then
				if LastChance(10) then
					iUnit:ChangeCriticalPercent(100)
				end
			end
		end
	elseif (unitType == GameInfoTypes.UNIT_ITG_TRIAL_HORSEMAN_3) then
		if bAttack then
			if LastChance(12 * GetNumAdjacentUnitsOfTypeToPlot(iPlot, iPlayer, unitType, iUnit:GetID())) then
				iUnit:ChangeCriticalPercent(100)
			end
		end
	elseif unitType == GameInfoTypes.UNIT_ITG_AOT_ARCHER_UU_6 then
		if LastRandom(1, 100) <= 5  then
			iUnit:ChangeCriticalPercent(900)
		end
	elseif unitType == GameInfoTypes.UNIT_ITG_AOT_HORSEMAN_GREEK or unitType == GameInfoTypes.UNIT_ITG_TRIAL_PAGAN_HORSEMAN then
		if iUnit:IsGreatGeneral() then
			if LastRandom(1,5) == 3 then
				iUnit:ChangeCriticalPercent(100)
			end
		elseif iUnit:IsNearGreatGeneral() and (LastRandom(1,10) == 4) then
			iUnit:ChangeCriticalPercent(100)
		end
	elseif unitType == GameInfoTypes.UNIT_ITG_AOT_SWORDSMAN_UU_3 then
		if iPlot:GetOwner() == iPlayer then
			if LastRandom(1,4) == 3 then
				iUnit:ChangeCriticalPercent(100)
			end
		end
	elseif unitType == GameInfoTypes.UNIT_ITG_IND_LINE_INFANTRY_UU_4 then
		if LastRandom(1,10) <= GetNumAdjacentMountains(iUnit:GetPlot()) then
			iUnit:ChangeCriticalPercent(100)
		end
	elseif unitType == GameInfoTypes.UNIT_ITG_IND_MUSKETMAN_UU_2 then
		if LastRandom(1,100) <= 15 then
			iUnit:ChangeCriticalPercent(2 * gT.Players[iPlayer].NumGreatWorks)
		end
	elseif unitType == GameInfoTypes.UNIT_ITG_TRIAL_LONGSWORDSMAN_2 then
		if LastChance(5) then
			iUnit:ChangeCriticalPercent(300)
		end
	elseif unitType == GameInfoTypes.UNIT_ITG_IND_LINE_INFANTRY_UU_3 then
		if ((iSecondPlayer or -1) ~= -1) then
			if Players[iSecondPlayer]:IsMinorCiv() then
				if LastRandom(1,100) <= 20 then
					iUnit:ChangeCriticalPercent(200)
				end
			end
		end
	elseif unitType == GameInfoTypes.UNIT_ITG_AOT_ARCHER_UU_4 then
		if ((iSecondPlayer or -1) ~= -1) and Players[iSecondPlayer]:IsBarbarian() then
			if LastRandom(1, 4) == 3 then
				iUnit:ChangeCriticalPercent(200)
			end
		end
	end
	if iUnit:IsHasPromotion(GameInfoTypes.PROMOTION_ITG_RELIABILITY) and (iUnit:GetDamage() == 0) then
		if LastRandom(1,5) == 3 then
			iUnit:ChangeCriticalPercent(100)
		end
	end
	if gT.Players[iPlayer].HasIdeology[90] then
		if LastRandom(1, 100) <= gT.Players[iPlayer].Ideo90CritChance  then
			iUnit:ChangeCriticalPercent(200)
			gT.Players[iPlayer].Ideo90CritChance = 0;
		else
			gT.Players[iPlayer].Ideo90CritChance = gT.Players[iPlayer].Ideo90CritChance + 1;
		end
	end
	for a, gfunc in pairs(gf_CritsPlayerBased) do
		gfunc(iPlayer, iUnit, bAttack, iSecondPlayer, iPlot, bCity, unitType, hstr)
	end
end

local isUSCACid;
local ueacacID;
GameEvents.UnitStartCombatAttackCity.Add(function(iPlayer, unitID, X, Y)
	if ITGdebug then
		print("uscac", iPlayer, unitID, X, Y)
	end
	DoCEhLog("USCAC", nil, "USCAC", iPlayer, unitID, X, Y)
	local cisUSCACid = iPlayer .. "," .. unitID .. "," .. X .. "," .. Y;
	if isUSCACid == cisUSCACid then
		print("Firing twice? UnitStartCombatAttackCity", iPlayer, unitID, X, Y);
-- this event seems to be firing twice / do not remove this return logic;
		return
	end
	ueacacID = nil;
	isUSCACid = cisUSCACid;
	local iUnit = Players[iPlayer]:GetUnitByID(unitID);
	DoClearAllPreCombatStuff(iUnit, iPlayer)
	curAttDamage = iUnit:GetDamage();
	local iPlot = Map.GetPlot(X,Y);
	local iDefender = iPlot:GetOwner();
	if gT.Players[iDefender] then
		gT.Players[iDefender].Ideo78DataTracking[4] = gT.Players[iDefender].Ideo78DataTracking[4] + 1;
	end
	if gT.Players[iPlayer] then
		gT.Players[iPlayer].Ideo78DataTracking[2] = gT.Players[iPlayer].Ideo78DataTracking[2] + 1;
		if iUnit:GetDomainType() == dLand then
			gT.Players[iPlayer].LHCombatLand = gT.Players[iPlayer].LHCombatLand + 1;
		elseif iUnit:GetDomainType() == dSea then
			gT.Players[iPlayer].LHCombatNaval = gT.Players[iPlayer].LHCombatNaval + 1;
		end
		gT.Players[iPlayer].MeleeCombatsP = gT.Players[iPlayer].MeleeCombatsP + 1;
		GetBasicCriticalsBasedOnUnitPlayer(iPlayer, iUnit, true, iDefender, X, Y, "MeleeCity");
		if gT.Players[iPlayer].CultBonusOn[162] or gT.Players[iPlayer].HasIdeology[23] then
			SetUnitForcedStackType(iUnit, -1, "OTB", 1)
		end
		if HasPlayerTech(iPlayer, innoANCtr7, "dddceadf") then 
			if iUnit:GetDomainType() == dSea then
				SetUnitForcedStackType(iUnit, -1, "ancTr7", 1)
			end
		end
		if iPlot:IsCity() then
			local iCity = iPlot:GetPlotCity();
			GetCriticalsWhileAttackingCity(iUnit, iPlayer, false, iCity)
		end
	end
	if iUnit:GetCriticalPercent() ~= 0 then
		if iPlayer == Game.GetActivePlayer() or dPlayer == Game.GetActivePlayer() then
			Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(iUnit:GetX(), iUnit:GetY()))), math.floor((iUnit:GetCriticalPercent()+100) * 10) / 1000 .. "[COLOR_NEGATIVE_TEXT]x[ENDCOLOR]", 0.5)
		end
	end
		if ITGdebug then
		print("uscac ended", iPlayer, unitID, X, Y)
	end
end)

function ApplyIdeology50Bonus(iCity)
	if GetITGCityInteger(iCity, "CI_IDEO_50") < 1000 then
		ChangeITGCityInteger(iCity, "CI_IDEO_50", 100)
		AdjustStrengthOfOneCity(iCity, 100, false)
	end
end

GameEvents.UnitEndCombatAttackCity.Add(function(iPlayer, unitID, X, Y)
	if ITGdebug then
		print("uecac", iPlayer, unitID, X, Y)
	end
	DoCEhLog("UECAC", "USCAC", nil, iPlayer, unitID, X, Y)
	local cuecacID = iPlayer .. "," .. unitID .. "," .. X .. "," .. Y;
	if cuecacID == ueacacID then
		print("Are we firing twice still? UEndCombatAttackCity", iPlayer, unitID, X, Y)
		return;
	end
	isUSCACid = nil;
	ueacacID = cuecacID;
	local iCity = Map.GetPlot(X, Y):GetPlotCity();
	local cID;
	if gT.Players[iCity:GetOwner()].HasIdeology[50] then
		ApplyIdeology50Bonus(iCity)
	end
	local iUnit = Players[iPlayer]:GetUnitByID(unitID);
	if iUnit then
--		if cityUndefDamage then
--			iUnit:SetDamage(math.min(iUnit:GetDamage(), cityUndefDamage))
--		end
		if iUnit:IsHasPromotion(promGen19) or iUnit:IsHasPromotion(promAdm17) then
			if LastChance(50) then
				TakeCareOfEventMorale(iPlayer, 25, {1, "Hero of the Soldiers"})
			end
		end
		if iUnit:IsHasPromotion(promAdm33) or iUnit:IsHasPromotion(promGen38) then
			ChangeMeritocracy(iPlayer, 1);
			if iPlayer == Game.GetActivePlayer() then
				Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(iX, iY))), "+1[ICON_ITG_MERITOCRACY]", 0.5)
			end
		end
		if iUnit:GetMaxHitPoints() > iUnit:GetDamage() then
			UnitSurvivedCombatHPRelatedBonuses(iUnit, curAttDamage, true)
			if iUnit:GetUnitType() == GameInfoTypes.UNIT_ITG_AOT_SWORDSMAN_UU_7 then
				if iCity:GetResistanceTurns() < 4 then
					iCity:ChangeResistanceTurns(1)
				end
			elseif iUnit:GetUnitType() == GameInfoTypes.UNIT_ITG_TRIAL_PIKEMAN_6 then
				gT.Globals.Provokes[iCity:GetOwner()][iCity:GetID()] = {iPlayer, iUnit:GetID(), true}
			end
			if iUnit:IsHasPromotion(GameInfoTypes.PROMOTION_ITG_MERCENARY_28) then
				if iCity:GetResistanceTurns() < 4 then
					iCity:ChangeResistanceTurns(1)
				end
			end
			UnitWasInCombat(iUnit, iPlayer, true)
			TakeCareOfExtraBombardment(iUnit, iPlayer, X, Y, nil, false)
		end
	end
	if LastRandom(1, 100) <= GetCityDefenseBreakChance(iUnit, iPlayer, iCity) then
		if not CanDefendFromDefenseBroken(iCity) then
			iCity:SetDefenseBroken(true)
			if iPlayer == Game.GetActivePlayer() or (iCity:GetOwner() == Game.GetActivePlayer()) then
				Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(X, Y))), "[ICON_ITG_DEFENSE_BROKEN]", 0.5)
			end
		end
	end
	if gT.Players[iPlayer] and gT.Players[iPlayer].HasIdeology[31] then
		Players[iPlayer]:ChangeRangedCombatBonus(5)
	end
--	cityUndefDamage = nil;
	gT.Globals.PlotCombatT[Map.GetPlot(X,Y):GetPlotIndex()] = GetITGGameTurn();
	if ITGdebug then
		print("uecac ended", iPlayer, unitID, X, Y)
	end
end)

function HasHPBeenHalved(iUnit, iPlayer, iPercent)
	if gT.Players[iPlayer] then
		local uID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
		if gT.Players[iPlayer].UnitsByID[uID] then
			if not gT.Players[iPlayer].UnitsByID[uID].RedTempMaxHP then
				local red = math.floor(iUnit:GetMaxHitPoints() * iPercent / 100);
				gT.Players[iPlayer].UnitsByID[uID].RedTempMaxHP = red;
				iUnit:ChangeMaxHitPoints(- red);
				return true;
			end
		end
	end
	return false;
end

function GetTotalMaxHpReduction(iUnit, iPlayer, sUnit, sPlayer, bAttack, bRanged, bPreAttack)
	if IsFakeCivilian[sUnit:GetUnitType()] then
		return 0;
	end
	--SO FAR coded only for pre attack on melee hook;
	local iPercentRed = 0;
	if gT.Players[iPlayer] and gT.Players[sPlayer] then
		if bPreAttack and bAttack and (not bRanged) then
			if gT.Players[iPlayer].CultBonusOn[143] then
				if iUnit:GetLevel() > sUnit:GetLevel() then
					local chance = 10 + math.max(0, -1 * gT.Players[sPlayer].Morale)
					if LastChance(chance) then
						iPercentRed = iPercentRed + 50;
					end
				end
			end
			if gT.Players[iPlayer].CultBonusOn[76] then
				if (not sUnit:IsCannotBeFlanked()) then
					local iNumAdjacentFriends = sUnit:GetNumEnemyUnitsAdjacent(iUnit);
					if iNumAdjacentFriends > 0 then
						iPercentRed = iPercentRed + 10 * iNumAdjacentFriends;
						if iUnit:GetDomainType() == dSea then
							Players[iPlayer]:ChangeNavalCombatExperience(iNumAdjacentFriends)
						else
							Players[iPlayer]:ChangeCombatExperience(iNumAdjacentFriends)
						end
					end
				end
			end
			if HasPlayerTech(iPlayer, innoMedAfr7, "6y4334") then
				if LastChance(20) then
					iPercentRed = iPercentRed + gT.Players[iPlayer].UnitKilled;
				end
			end
		end
	end
	return math.min(75, iPercentRed);
end

function PreCombatEffectsTwoUnits(iUnit, iPlayer, dUnit, dPlayer, bRanged)
	local tMaxHPred = GetTotalMaxHpReduction(iUnit, iPlayer, dUnit, dPlayer, true, bRanged, true)
	if tMaxHPred > 0 then
		if HasHPBeenHalved(dUnit, dPlayer, tMaxHPred) then
			if iPlayer == Game.GetActivePlayer() or dPlayer == Game.GetActivePlayer() then
				Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(dUnit:GetX(), dUnit:GetY()))), "[ICON_HAPPINESS_3]", 0.5)
			end
		end
	end
	local aMaxHPred = GetTotalMaxHpReduction(dUnit, dPlayer, iUnit, iPlayer, false, bRanged, true)
	if aMaxHPred > 0 then
		if HasHPBeenHalved(iUnit, iPlayer, aMaxHPred) then
			if iPlayer == Game.GetActivePlayer() or dPlayer == Game.GetActivePlayer() then
				Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(iUnit:GetX(), iUnit:GetY()))), "[ICON_HAPPINESS_3]", 0.5)
			end
		end
	end
end


GameEvents.UnitStartMeleeCombat.Add(function(iPlayer, unitID, X, Y, dPlayer, dUnitID)
	if ITGdebug then
		print("usmc", iPlayer, unitID, X, Y, dPlayer, dUnitID)
	end
	DoCEhLog("USMC", nil, "USMC", iPlayer, unitID, X, Y, dPlayer, dUnitID)
	local iUnit = Players[iPlayer]:GetUnitByID(unitID);
	DoClearAllPreCombatStuff(iUnit, iPlayer)
	local dUnit = Players[dPlayer]:GetUnitByID(dUnitID);
	DoClearAllPreCombatStuff(dUnit, dPlayer)
	curAttDamage = iUnit:GetDamage();
	if dUnit then
		curDefDamage = dUnit:GetDamage();
		PreCombatEffectsTwoUnits(iUnit, iPlayer, dUnit, dPlayer, false)
		GetCriticalsWhenBothUnitsAreDefined(iUnit, dUnit, false);
		GetCriticalInDefense(dUnit, iUnit, false, "bkorkew");
	end
	if gT.Players[iPlayer] then 
		GetBasicCriticalsBasedOnUnitPlayer(iPlayer, iUnit, true, dPlayer, X, Y, "Melee")
	end
	if gT.Players[dPlayer] then
		GetBasicCriticalsBasedOnUnitPlayer(dPlayer, dUnit, false, iPlayer, X, Y, "Melee")
	end
	if dUnit then
		DisablesOpponentCrits(iUnit, dUnit, iPlayer, dPlayer)
		AchievementCheckAttackTwoUnits(iPlayer, iUnit, dUnit)
	end
	if iPlayer == Game.GetActivePlayer() or dPlayer == Game.GetActivePlayer() then
		if iUnit:GetCriticalPercent() ~= 0 then
			Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(iUnit:GetX(), iUnit:GetY()))), math.floor((iUnit:GetCriticalPercent() + 100) * 10) / 1000 .. "[COLOR_NEGATIVE_TEXT]x[ENDCOLOR]", 0.5)
		end	
		if dUnit and (dUnit:GetCriticalPercent() ~= 0) then
			Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(dUnit:GetX(), dUnit:GetY()))), math.floor((dUnit:GetCriticalPercent() + 100) * 10) / 1000 .. "[COLOR_NEGATIVE_TEXT]x[ENDCOLOR]", 0.5)
		end
	end
	if ITGdebug then
		print("usmc ended", iPlayer, unitID, X, Y, dPlayer, dUnitID)
	end
end)

GameEvents.UnitEndMeleeCombat.Add(function(iPlayer, unitID, X, Y, dPlayer, dUnitID, bHappened)
	if ITGdebug then
		print("uemc", iPlayer, unitID, X, Y, dPlayer, dUnitID)
	end
	DoCEhLog("UEMC", "USMC", nil, iPlayer, unitID, X, Y, dPlayer, dUnitID)
	local iUnit = Players[iPlayer]:GetUnitByID(unitID);
	local dUnit = Players[dPlayer]:GetUnitByID(dUnitID);
	if bHappened then
		if dUnit then
			DoAILogForVeteranPromotionAfterCombat(iPlayer, dUnit, Map.GetPlot(X, Y), iUnit:GetDomainType())
			PostCombatEffectsTwoUnits(iUnit, dUnit, iPlayer, dUnit:GetOwner())
			if gT.Players[dPlayer] then
				gT.Players[dPlayer].Ideo78DataTracking[4] = gT.Players[dPlayer].Ideo78DataTracking[4] + 1;
				if IsRealCombatUnit(dUnit) then
					if dUnit:GetDomainType() == dLand then
						gT.Players[dPlayer].LHCombatLand = gT.Players[dPlayer].LHCombatLand + 1;
					elseif dUnit:GetDomainType() == dSea then
						gT.Players[dPlayer].LHCombatNaval = gT.Players[dPlayer].LHCombatNaval + 1;
					end
				end
				DoAILogForVeteranPromotionAfterCombat(dPlayer, iUnit, Map.GetPlot(X, Y), dUnit:GetDomainType())
			end
			if dUnit:IsHasPromotion(promGen19) or dUnit:IsHasPromotion(promAdm17) then
				if LastChance(50) then
					TakeCareOfEventMorale(dPlayer, 25, {1, "Hero of the Soldiers"})
				end
			end
		end
		if gT.Players[iPlayer] then 
			gT.Players[iPlayer].Ideo78DataTracking[2] = gT.Players[iPlayer].Ideo78DataTracking[2] + 1;
			if iUnit:GetDomainType() == dLand then
				gT.Players[iPlayer].LHCombatLand = gT.Players[iPlayer].LHCombatLand + 1;
			elseif iUnit:GetDomainType() == dSea then
				gT.Players[iPlayer].LHCombatNaval = gT.Players[iPlayer].LHCombatNaval + 1;
			end
			gT.Players[iPlayer].MeleeCombatsP = gT.Players[iPlayer].MeleeCombatsP + 1;
			if gT.Players[iPlayer].CultBonusOn[162] or gT.Players[iPlayer].HasIdeology[23]  then
				SetUnitForcedStackType(iUnit, -1, "OTB", 1)
			end
			if HasPlayerTech(iPlayer, innoANCtr7, "dddceadf") then 
				if iUnit:GetDomainType() == dSea then
					SetUnitForcedStackType(iUnit, -1, "ancTr7", 1)
				end
			end
			if iUnit:IsHasPromotion(promGen19) or iUnit:IsHasPromotion(promAdm17) then
				if LastChance(50) then
					TakeCareOfEventMorale(iPlayer, 25, {1, "Hero of the Soldiers"})
				end
			end
			if iUnit:IsHasPromotion(promAdm33) or iUnit:IsHasPromotion(promGen38) then
				ChangeMeritocracy(iPlayer, 1);
				if iPlayer == Game.GetActivePlayer() then
					Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(iX, iY))), "+1[ICON_ITG_MERITOCRACY]", 0.5)
				end
			end
			if gT.Players[iPlayer].HasIdeology[31] then
				Players[iPlayer]:ChangeRangedCombatBonus(5)
			end
		end
		if iUnit:GetMaxHitPoints() > iUnit:GetDamage() then
			if iUnit:GetUnitType() == cTypeKnightTrial then
				iUnit:SetMoves(iUnit:MaxMoves())
			elseif iUnit:GetUnitType() == GameInfoTypes.UNIT_ITG_AOT_HORSEMAN_UU_7 then
				iUnit:SetMoves(iUnit:MaxMoves())
			end
			UnitSurvivedCombatHPRelatedBonuses(iUnit, curAttDamage, true)
			UnitWasInCombat(iUnit, iPlayer, true)
			TakeCareOfExtraBombardment(iUnit, iPlayer, X, Y, dUnit, false)
		end
	else
		DoClearAllPreCombatStuff(iUnit, iPlayer)
		if dUnit then
			DoClearAllPreCombatStuff(dUnit, dPlayer)
		end
	end
	gT.Globals.PlotCombatT[Map.GetPlot(X,Y):GetPlotIndex()] = GetITGGameTurn();
	if ITGdebug then
		print("uemc ended", iPlayer, unitID, X, Y, dPlayer, dUnitID)
	end
end)

--[[local ITGTimeDiagnosisMaxStrengthModifiers = {}
LuaEvents.ITGCallForTimeDiagnosis.Add(function()
	DoPrintTimeDiagnosisITG(ITGTimeDiagnosisMaxStrengthModifiers, "COMBAT EVENTS MAX STRENGTH")
end)

GameEvents.UnitGenericMaxStrengthModifiers.Add(function(iPlayer, unitID, tPlayer, tUnitID, aX, aY, bIgnoreAdjOrIsAttacking, bForRangedAttack, bIsRanged)
--if ranged, check if bForRangedAttack (otherwise battle is at unit plot; if ax, ay is city!)
	local timer = os.clock()
	if gT.Players[iPlayer] then
		local iUnit = Players[iPlayer]:GetUnitByID(unitID);
		local tPlot = Map.GetPlot(aX, aY);
		if bIsRanged then
			if not bForRangedAttack then
				tPlot = iUnit:GetPlot();
			else
				iUnit:SetHasPromotion(RangeMaxRangeNerf, ShouldHaveMaxRangeNerf(iUnit, tPlot))
			end
		end
	end
	table.insert(ITGTimeDiagnosisMaxStrengthModifiers,  os.clock() - timer)
end]]

LuaEvents.RequestCityCombatBonusesForPanel.Add(function(iCity, theirUnit, bAttack)
	local hTab = {{}, {}, {}};
	local iPlayer = iCity:GetOwner();
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	if bAttack then
		if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_ASIA_2, "Vreee") then
			table.insert(hTab[1], {"20% Gunpowder", 300})
		end
		if GetITGCityInteger(iCity, "CI_INNO_AFR_TRIAL_5") > 0 then
			table.insert(hTab[3], {"Citadel", GetITGCityInteger(iCity, "CI_INNO_AFR_TRIAL_5")})
		end
		if GetITGCityInteger(iCity, "CI_GP_STRIKE_MOD") > 0 then
			table.insert(hTab[3], {"Great People", GetITGCityInteger(iCity, "CI_GP_STRIKE_MOD") * 100})
		end
		if HasPlayerTech(iPlayer, tinnopagan8, "tinnopagan8") then
			local iAmbushVal = GetITGGameTurn() - (gT.Globals.PlotCombatT[Map.GetPlot(theirUnit:GetX(), theirUnit:GetY()):GetPlotIndex()] or 0)
			if iAmbushVal > 0 then
				table.insert(hTab[1], {iAmbushVal .. "% Ambush", 200})
			end
		end
		if gT.Players[iPlayer].CultBonusOn[8] then
			table.insert(hTab[1], {iCity:GetPopulation() .. "% Home", 100})
		end
		if gT.Players[iPlayer].CultBonusOn[168] then
			if iCity:GetOriginalOwner() == iPlayer then
				if #gT.Cities[cID].Manufactories > 0 then
					table.insert(hTab[3], {"Manufactory", 20})
				end
			end
		end
		local fGovernor = GetCityGovTraitBonus(iCity, 14)
		if fGovernor > 0 then
			table.insert(hTab[3], {"Governance", fGovernor})
		end
	end
	MapModData.ITGSG = hTab;
end)

function GetCityDefenseBreakChance(iUnit, iPlayer, iCity)
	local b = iUnit:GetChanceToBreakCityDefense()
	if gT.Players[iPlayer] then
		if gT.Players[iPlayer].HasIdeology[77] then
			local cIndex = iCity:Plot():GetPlotIndex();
			for a, b in pairs(gT.Players[iPlayer].VisionIdeo77) do
				if b == cIndex then
					b = b + 20;
					break;
				end
			end
		end
		if gT.Players[iPlayer].CultBonusOn[58] then
			local iOwner = iCity:GetOwner();
			if gT.Players[iOwner] and (not Players[iOwner]:IsMinorCiv()) then
				if gT.Players[iOwner].NatUnity < gT.Players[iPlayer].NatUnity then
					b = b + 15;
				end
			end
		end
	end
	return b;
end

function GetPreparedCombatBonusesForUnit(iUnit, bIsDefending, sUnit, sCity, bRanged)
	local hTab = {0, {}, 0, {}, 0, {}, {}, {}, {}, {}, 0}
	--1, 2 combat percent
	--3, 4 attack percent
	--5, 6 defense percent
	--7 criticals 
	--
	--10 break city defense
	local cPlot;
	if bIsDefending then
		cPlot = iUnit:GetPlot()
	elseif sCity then
		cPlot = sCity:Plot();
	else
		cPlot = sUnit:GetPlot()
	end
	local iPlayer = iUnit:GetOwner();
	if gT.Players[iPlayer] then
		local unitType = iUnit:GetUnitType();
		if gT.Players[iPlayer].CultBonusOn[148] then
			if Players[iPlayer]:GetNumCities() > 0 then
				if iPlayer == Game.GetActivePlayer() then
					table.insert(hTab[7], {GetClosestCityDistanceToXY(iPlayer, cPlot:GetX(), cPlot:GetY()) .. "% No Return", 100})
				else
					table.insert(hTab[7], {"?% No Return", 100})
				end
			end
		end
		if gT.Players[iPlayer].CultBonusOn[41] then
			if IsAdjacentToColony(cPlot:GetX(), cPlot:GetY()) then
				table.insert(hTab[7], {"20% Colonial Brigades", 100})
			end
		end
		if gT.Players[iPlayer].HasIdeology[29] then
			if gT.Players[iPlayer].ReconCenter then
				local hrplot = Map.GetPlotByIndex(gT.Players[iPlayer].ReconCenter);
				if Map.PlotDistance(cPlot:GetX(), cPlot:GetY(), hrplot:GetX(), hrplot:GetY()) <= 3 then
					table.insert(hTab[7], {"10% Recon", 100})
				end
			end
		end
		if HasPlayerTech(iPlayer, tinnopagan8, "tinnopagan8") then
			if not cPlot:IsCity() then
				local iAmbush = GetITGGameTurn() - (gT.Globals.PlotCombatT[cPlot:GetPlotIndex()] or 0);
				if iAmbush > 0 then
					table.insert(hTab[7], {iAmbush .. "% Ambush", 200})
				end
			end
		end
		if gT.Players[iPlayer].CultBonusOn[150] then
			local chance = 0;
			for jkj = 0, 5 do
				local nPlot = Map.PlotDirection(cPlot:GetX(), cPlot:GetY(), jkj);
				if nPlot and (nPlot:GetOwner() == iPlayer) and (nPlot:GetFeatureType() == fForest or nPlot:GetFeatureType() == fJungle) then
					chance = chance + 5;
				end
			end
			if chance > 0 then
				table.insert(hTab[7], {chance .. "% Warpath", 100})
			end
		end
		if IsValidForKiliCrit(iPlayer, cPlot) then
			table.insert(hTab[7], {"5% Mt Kilimanjaro", 100})
		end
		if DoesUnitDisableCrits(iUnit) then
			table.insert(hTab[8], {"Negates enemy critical bonuses"})
		end
		if gT.Players[iPlayer].HasIdeology[51] then
			if gT.Players[iPlayer].Morale < 0 then
				table.insert(hTab[7], {-gT.Players[iPlayer].Morale .. "% Against the Odds", 100})
			end
		end
		if IsValidForDesertRouteCrit(iPlayer, cPlot) then
			table.insert(hTab[7], {"10% Desert Route", 100})
		end
		if IsCombatClassITGUnit(iUnit:GetUnitClassType(), iPlayer) then
			local uID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
			hTab[2]["Morale"] = (gT.Players[iPlayer].UnitsByID[uID].MoraleModifier or 0);
			hTab[1] = hTab[1] + hTab[2]["Morale"];
			hTab[2]["Veterancy"] = (gT.Players[iPlayer].UnitsByID[uID].VeteranModifier or 0);
			hTab[1] = hTab[1] + hTab[2]["Veterancy"];
		end
		if gT.Players[iPlayer].Ideo90CritChance > 0 then
			table.insert(hTab[7], {gT.Players[iPlayer].Ideo90CritChance .. "% Military Tradition", 200})
		end
		if unitType == GameInfoTypes.UNIT_ITG_AOT_ARCHER_UU_6 then
			table.insert(hTab[7], {"5% Faith and Rock", 900})
		elseif unitType == GameInfoTypes.UNIT_ITG_AOT_SWORDSMAN_UU_3 then
			if cPlot:GetOwner() == iPlayer then
				table.insert(hTab[7], {"25% Homeland", 100})
			end
		elseif unitType == GameInfoTypes.UNIT_ITG_IND_LINE_INFANTRY_UU_4 then
			table.insert(hTab[7], {GetNumAdjacentMountains(iUnit:GetPlot()) * 10 .. "% Adjacent Mountains", 100})
		elseif unitType == GameInfoTypes.UNIT_ITG_IND_MUSKETMAN_UU_2 then
			table.insert(hTab[7], {"15% Romanticism", 2 * gT.Players[iPlayer].NumGreatWorks})
		elseif unitType == GameInfoTypes.UNIT_ITG_TRIAL_LONGSWORDSMAN_2 then
			table.insert(hTab[7], {"5% Critical", 300})
		elseif (unitType == GameInfoTypes.UNIT_ITG_AOT_HORSEMAN_GREEK) or (unitType == GameInfoTypes.UNIT_ITG_TRIAL_PAGAN_HORSEMAN) then
			if iUnit:IsGreatGeneral() then
				table.insert(hTab[7], {"20% General Companion", 100})
			elseif iUnit:IsNearGreatGeneral() then
				table.insert(hTab[7], {"10% General Companion", 100})
			end
		end
		if iUnit:IsHasPromotion(GameInfoTypes.PROMOTION_ITG_RELIABILITY) and (iUnit:GetDamage() == 0) then
			table.insert(hTab[7], {"20% Reliability", 100})
		end
		if gT.Players[iPlayer].CultBonusOn[101] then
			if iUnit:GetDamage() > 75 then
				table.insert(hTab[7], {"15% Last Deed", 500})
			end
		end
		if gT.Players[iPlayer].GovNatDayCrit then
			table.insert(hTab[7], {"20% Battle Memorial", 100})
		end
		if gT.Players[iPlayer].TopkapiPalace then
			table.insert(hTab[7], {"5% Topkapi Palace", 100})
		end
		if gT.Players[iPlayer].HasIdeology[73] then
			local iPower = 0;
			local govID;
			for sgv, h in pairs(gT.Players[iPlayer].Governors) do
				if gT.Globals.Governors[sgv].City then
					if gT.Globals.Governors[sgv].Power > iPower then
						local iPlot = Map.GetPlotByIndex(gT.Globals.Governors[sgv].City);
						if Map.PlotDistance(iPlot:GetX(), iPlot:GetY(), cPlot:GetX(), cPlot:GetY()) <= 10 then
							iPower = gT.Globals.Governors[sgv].Power;
							govID = sgv;
						end
					end
				end
			end
			if iPower > 0 then
				table.insert(hTab[7], {"20% [ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name), math.ceil(iPower / 5) * 5})
			end
		end
		if Players[iPlayer]:IsMinorCiv() then
			local gAlly = Players[iPlayer]:GetAlly();
			if gT.Players[gAlly] and gT.Players[gAlly].HasIdeology[5] then
				table.insert(hTab[7], {"10% Brotherhood Army", 200})
			end
		end
		local sPlayer;
		if sUnit then
			sPlayer = sUnit:GetOwner();
			if gT.Players[iPlayer].CultBonusOn[165] then
				if GetITGReligion(iPlayer) ~= GetITGReligion(sUnit:GetOwner()) then
					table.insert(hTab[7], {"10% God With Us", 200})
				end
			end
			if gT.Players[iPlayer].CultBonusOn[14] and (not bIsDefending) then
				if iUnit:GetUnitCombatType() == ucArcher then
					local uID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
					if gT.Players[iPlayer].UnitsByID[uID] then
						local pData = gT.Players[iPlayer].UnitsByID[uID].LastKillData;
						if pData then
							local chance = math.min(100, (GetITGGameTurn() - pData[1]) * 2);
							if chance > 0 then
								table.insert(hTab[7], {chance .. "% Hunter", 250})
							end
						end
					end
				end
			end
			if gT.Players[iPlayer].CultBonusOn[53] then
				if IsValidForTechnologicalCrit(iUnit, sUnit) then
					table.insert(hTab[7], {"20% Tactical Advantage", 200})
				end
			end
			if iUnit:GetUnitClassType() == GameInfoTypes.UNITCLASS_INFANTRY then
				if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_MODERN_29, "erqwrfref") then
					if sUnit:GetUnitCombatType() == GameInfoTypes.UNITCOMBAT_ARMOR or sUnit:GetDomainType() == "DOMAIN_AIR" or (sUnit:GetUnitType() == uGarrison and (not bIsDefending))  then
						table.insert(hTab[7], {"2% Lucky Shot", 500})
					end
				end
			end
			if unitType == GameInfoTypes.UNIT_ITG_ANTI_TANK_GUN_UU_8 then
				if sUnit:GetUnitClassType() == GameInfoTypes.UNITCLASS_TANK then
					table.insert(hTab[7], {"10% Against Tanks", 500})
				end
			elseif unitType == GameInfoTypes.UNIT_ITG_AOT_ARCHER_UU_4 then
				if Players[sUnit:GetOwner()]:IsBarbarian() then
					table.insert(hTab[7], {"25% Against Barbarians", 200})
				end
			elseif unitType == GameInfoTypes.UNIT_ITG_TRIAL_PIKEMAN_4 then
				if (not bRanged) and (not sUnit:IsCannotBeFlanked()) then
					local iNumAdjacentFriends = sUnit:GetNumEnemyUnitsAdjacent(iUnit);
					if (iNumAdjacentFriends > 0) then
						local baseFlank = iNumAdjacentFriends * GameDefines["BONUS_PER_ADJACENT_FRIEND"];
						local iFlankModifier = iUnit:FlankAttackModifier();
						if (iFlankModifier ~= 0) then
							baseFlank = baseFlank * (100 + iFlankModifier) / 100;
						end
						table.insert(hTab[7], {"25% Ifianyako", baseFlank * 3})
					end
				end
			end
		else
			sPlayer = sCity:GetOwner();
		end
		if sPlayer then
			if Players[sPlayer]:IsMinorCiv() then
				if unitType == GameInfoTypes.UNIT_ITG_IND_LINE_INFANTRY_UU_3 then
					table.insert(hTab[7], {"20% vs City-States", 200})
				end
			end
			if gT.Players[iPlayer].CritGrievances[sPlayer] then
				table.insert(hTab[7], {gT.Players[iPlayer].CritGrievances[sPlayer] .. "% vs " .. Players[sPlayer]:GetCivilizationShortDescription(), 100})
			end
			if gT.Players[iPlayer].ParadropTPrev[sPlayer] then
				table.insert(hTab[7], {"15% Secured Area", 100})
			end
		end
		if iUnit:IsHasPromotion(promGen2) or iUnit:IsHasPromotion(promAdm4) then
			table.insert(hTab[7], {"15% Decisive Victory", 100})
		end
		if iUnit:IsHasPromotion(GameInfoTypes.PROMOTION_ITG_SEVEN_SEAS_1) then
			table.insert(hTab[7], {"10% Seven Seas", 500})
		end
		if iUnit:GetUnitClassType() == GameInfoTypes.UNITCLASS_DESTROYER then
			if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_MODERN_6, "okodke") then
				table.insert(hTab[7], {"7% Destruction", 500})
			end
		end
		if iUnit:GetDomainType() == dLand then 
			if gT.Players[iPlayer].LandAcaCritical > 0 then
				table.insert(hTab[7], {gT.Players[iPlayer].LandAcaCritical .. "% Academy", 100})
			end
		elseif iUnit:GetDomainType() == dSea then
			if gT.Players[iPlayer].NavalAcaCritical > 0 then
				table.insert(hTab[7], {gT.Players[iPlayer].NavalAcaCritical .. "% Academy", 100})
			end
		end
		if bIsDefending then
			if sUnit then
				if gT.Players[iPlayer].CultBonusOn[81] and bRanged then
					if iUnit:GetDomainType() == dSea then
						if sUnit:GetDomainType() == dLand then
							table.insert(hTab[7], {"50% Maneuvers", 100})
						end
					end
				end
				if sUnit:GetUnitClassType() == GameInfoTypes.UNITCLASS_SUBMARINE then
					if HasPlayerTech(iPlayer, GameInfoTypes.TECH_RADAR, "5g4f4g3") then
						table.insert(hTab[7], {"25% Sonar", 200})
					end
					if sUnit:GetUnitType() == GameInfoTypes.UNIT_ITG_BATTLESHIP_UU_5 then
						table.insert(hTab[7], {"20% Chainlink Nets", 200})
					end
				end
				if iUnit:IsHasPromotion(promGen9) then
					if sUnit:GetDomainType() == dLand then
						table.insert(hTab[7], {"20% Evasion", 100})
					end
				end
			end
			if iUnit:IsHasPromotion(promMerc8) then
				table.insert(hTab[7], {"25% Trapper", 100})
			end
			if bRanged then
				if iUnit:IsHasPromotion(GameInfoTypes.PROMOTION_ITG_SEVEN_SEAS_3) then
					table.insert(hTab[7], {"50% Seven Seas", 100})
				end
				if iUnit:IsHasPromotion(promAdm7) then
					table.insert(hTab[7], {"20% Evasion", 100})
				end
				if unitType == GameInfoTypes.UNIT_ITG_DESTROYER_UU_4 then
					table.insert(hTab[7], {"20% Evasion", 100})
				end
			end
			if gT.Players[iPlayer].CultBonusOn[50] then
				if iUnit:GetPlot():GetOwner() ~= iPlayer then
					if iUnit:GetPlot():IsImprovementPillaged() then
						table.insert(hTab[7], {"15% Impaler", 200})
					end
				end
			end
		else
			if sUnit then
				if unitType == GameInfoTypes.UNIT_ITG_BOMBER_UU_14 then
					if sUnit:GetDomainType() == dSea then
						table.insert(hTab[7], {"10% Against Navy", 100})
					end
				elseif (unitType == GameInfoTypes.UNIT_ITG_BATTLESHIP_UU_9) or (unitType == GameInfoTypes.UNIT_ITG_IND_MUSKETMAN_UU_7) then
					if sUnit:GetDamage() > 0 then
						table.insert(hTab[7], {sUnit:GetDamage() .. "% Merciless", 100})
					end
				end
				if unitType == GameInfoTypes.UNIT_ITG_TANK_UU_6 then
					if sUnit:GetDamage() == 0 then
						table.insert(hTab[7], {"25% vs Unwounded", 100})
					end
				elseif unitType == GameInfoTypes.UNIT_ITG_AOT_HORSEMAN_UU_4 then
					if gT.Players[iPlayer] then
						local uID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
						if gT.Players[iPlayer].UnitsByID[uID] then
							if gT.Players[iPlayer].UnitsByID[uID].LastAttacker == sUnit:GetID() .. "," .. sUnit:GetOwner() .. "," .. sUnit:GetGameTurnCreated() then
								table.insert(hTab[7], {"20% Counter-attack", 200})
							end
						end
					end
				end
				local chanceToLock = GetChanceToLockMoves(iUnit, sUnit)
				if chanceToLock > 0 then
					table.insert(hTab[8], {"Chance to lock Movement", chanceToLock .. "%"})
				end
				if gT.Players[iPlayer] and gT.Players[sPlayer] then
					if not IsFakeCivilian[sUnit:GetUnitType()] then
						if gT.Players[iPlayer].CultBonusOn[143] and (not bRanged) then
							if sUnit:GetLevel() < iUnit:GetLevel() then
								if not HasAlreadyHPReduced(sUnit) then
									local chance = 10 + math.max(0, -1 * gT.Players[sPlayer].Morale)
									table.insert(hTab[8], {"Reduce max HP by 50%", chance .. "%"})
								end
							end
						end
						if gT.Players[iPlayer].CultBonusOn[76] then
							if (not bRanged) and (not sUnit:IsCannotBeFlanked()) then
								local iNumAdjacentFriends = sUnit:GetNumEnemyUnitsAdjacent(iUnit);
								if iNumAdjacentFriends > 0 then
									if not HasAlreadyHPReduced(sUnit) then
										table.insert(hTab[8], {"Reduce max HP by " .. 10 * iNumAdjacentFriends .. "%", "100%"})
									end
								end
							end
						end
						if HasPlayerTech(iPlayer, innoMedAfr7, "6y4334") and (not bRanged) then
							if not HasAlreadyHPReduced(sUnit) and (gT.Players[iPlayer].UnitKilled > 0) then
								table.insert(hTab[8], {"Reduce max HP by " .. gT.Players[iPlayer].UnitKilled .. "%", "20%"})
							end
						end
					end
				end
			elseif sCity then
				hTab[10] = GetCityDefenseBreakChance(iUnit, iPlayer, sCity);
				if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_MODERN_22, "ITgmod22") then
					if sCity:IsOccupied() then
						table.insert(hTab[7], {"10% vs Occupied", 100})
					end
				end
				if unitType == GameInfoTypes.UNIT_ITG_TANK_UU_6 then
					if sCity:GetDamage() == 0 then
						table.insert(hTab[7], {"25% vs Unwounded", 100})
					end
				end
				if gT.Players[iPlayer].CultBonusOn[175] then
					if iUnit:GetUnitCombatType() == GameInfoTypes.UNITCOMBAT_SIEGE then
						table.insert(hTab[7], {"17% Siege Strategist", 200})
					end
				end
			end
			if iUnit:IsHasPromotion(GameInfoTypes.PROMOTION_ITG_PRECISION) and (iUnit:GetMoves() == iUnit:MaxMoves()) then
				table.insert(hTab[7], {"15% Precision", 200})
			end
			if (iUnit:GetPlot():IsWater()) then
				if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_25 ,"^$53224%#") then
					if iUnit:GetDomainType() == dLand then
						table.insert(hTab[7], {"25% Sea People", 200})
					end
				end
			end
			if unitType == GameInfoTypes.UNIT_ITG_AOT_ARCHER_NUBIA then
				table.insert(hTab[7], {GetNumUnitsOfType(iPlayer,GameInfoTypes.UNIT_ITG_AOT_ARCHER_NUBIA) .. "% Land of the Bow", 100})
			elseif unitType == GameInfoTypes.UNIT_ITG_TRIAL_HORSEMAN_3 then
				local cLval = 12 * GetNumAdjacentUnitsOfTypeToPlot(cPlot, iPlayer, unitType, iUnit:GetID())
				if cLval > 0 then
					table.insert(hTab[7], {cLval .. "% Akinji", 100})
				end
			elseif unitType == GameInfoTypes.UNIT_ITG_NW_MAYAN_ATLATLIST then
				if Map.PlotDistance(iUnit:GetX(), iUnit:GetY(), cPlot:GetX(), cPlot:GetY()) == 1 then
					table.insert(hTab[7], {"10% Atlatl", 100})
				end
			end
			if gT.Players[iPlayer].CultBonusOn[50] then
				if cPlot:GetOwner() == iPlayer then
					if cPlot:IsImprovementPillaged() then
						table.insert(hTab[7], {"15% Impaler", 200})
					end
				end
			end
			if gT.Players[iPlayer].HasIdeology[85] and (not bRanged) and sPlayer and (iUnit:GetDomainType() ~= dAir) then
				local chance = GetCriticalMoraleChance(iPlayer, sPlayer)
				if chance > 0 then
					table.insert(hTab[7], {chance .. "% Merciless", 100})
				end
			end
			if gT.Players[iPlayer].HasIdeology[4] and (not bRanged) and sPlayer and (iUnit:GetDomainType() ~= dAir) then
				local chance = GetCriticalCodexChance(iPlayer, sPlayer)
				if chance > 0 then
					table.insert(hTab[7], {chance .. "% Righteous Law", 100})
				end
			end
		end
		for a, gfunc in pairs(gf_EnemyUnitPanel) do
			for c, d in pairs(gfunc(iUnit, unitType, bIsDefending, sUnit, sCity, bRanged, cPlot, sPlayer)) do
				table.insert(hTab[d[1]], {d[2], d[3]})
			end
		end
	end
	return hTab;
end

function GetCriticalCodexChance(iPlayer, iSecondPlayer)
	if gT.Players[iSecondPlayer] then
		if gT.Players[iPlayer].HasCodex then
			local base = gT.Players[iPlayer].CodexStrength;
			if gT.Players[iSecondPlayer].HasCodex then
				base = base - gT.Players[iSecondPlayer].CodexStrength
			end
			if base > 0 then
				return math.min(30, base);
			end
		end
	end
	return 0;
end

function GetCriticalMoraleChance(iPlayer, sPlayer)
	local im, hm = 0, 0;
	if gT.Players[iPlayer] then
		im = gT.Players[iPlayer].Morale;
	end	
	if gT.Players[sPlayer] then
		hm = gT.Players[sPlayer].Morale;
	end
	return im - hm;
end

function DoClearAllPreCombatStuff(iUnit, iPlayer)
	--crit only? --to be sure?
	--it also clears stuff if attack failed to trigger
	iUnit:SetCriticalPercent(0)
end