local TLSHT = {}
local TLSCT = {}
local TLSOT = {}
local TLSCSize = {}
local TLSOO = {}
local TLSOC = 0
local TOceanSize = {}
local TLSWT = {}
local LZST = {}
local TLSWC = {}
local rConnectionGlobalT = {}
local gRiverT = {}
local gRiverC = 0;
local hRiverT = {}
local RiverLength = {}
local DesertSize = {}
local thDT = {}
local DSOC = 0;
local DSOT = {}
local ResourcesPresentOnMap;
local gPassTO = {}
local gPassCC = 0;
local gPassLM = {}
local LANC = 0;
local CCHOC = 0;
local CTLSH, CCTOA, LANT, LANI = {}, {}, {}, {}
local GMountainTable = {}
local TOOCC, TOOCT, TOOST = {}, {}, {}
local TOOCB = 0;
local AncientRuinsI = GameInfoTypes.IMPROVEMENT_ITGSG_ANCIENT_RUINS;
local TRbasicCoastsConnect = {}
local TRoceanCoastsConnect = {}
local TPilC, TPilG = {}, {};
function ResetContinentsTablesAndData()
	TLSHT, TLSCT = {}, {}
	TPilC, TPilG = {}, {}
	TRbasicCoastsConnect = {};
	TRoceanCoastsConnect = {};
	TLSOT, TLSCSize, TLSOO = {}, {}, {}
	TLSOC = 0
	TOceanSize, TLSWT, TLSWC = {}, {}, {}
	rConnectionGlobalT = {}
	gRiverT = {}
	gRiverC = 0;
	hRiverT = {}
	RiverLength = {}
	DesertSize = {}
	thDT = {}
	DSOC = 0;
	DSOT = {}
	ResourcesPresentOnMap = nil;
	gPassTO = {}
	gPassCC = 0;
	gPassLM = {}
	LANI = {}
	LANT = {}
	LANC = 0;
	CCHOC = 0;
	CTLSH = {}
	CCTOA = {}
	GMountainTable = {}
	TOOCC, TOOST, TOOCT = {}, {}, {};
	TOOCB = 0;
end

function RequestAllMountains()
	return GMountainTable;
end

function DoResetResourcesPresentOnMap()
	ResourcesPresentOnMap = nil;
end

function GetResourcesPresentOnMap(resID, bIsPresent)
	if not ResourcesPresentOnMap then
		ResourcesPresentOnMap = {}
		for i = 0, Map:GetNumPlots() - 1, 1 do
			local fPlot = Map.GetPlotByIndex( i );
			if fPlot:IsMountain() then
				table.insert(GMountainTable, i)
			end
			if fPlot:GetResourceType() ~= -1 then
				if not ResourcesPresentOnMap[fPlot:GetResourceType()] then
					 ResourcesPresentOnMap[fPlot:GetResourceType()] = {}
				end
				ResourcesPresentOnMap[fPlot:GetResourceType()][i] = 1;
			end
		end
	end
	if resID then
		if bIsPresent then
			if ResourcesPresentOnMap[resID] then
				return true;
			end
			return false;
		end
		return ResourcesPresentOnMap[resID] or {};
	end
	return ResourcesPresentOnMap;
end

local grandTofUnknownTer = {}
function GetTheUnknownTerritoryOfPlayer(jPlayer)
	local iTeam = Players[jPlayer]:GetTeam();
	if not grandTofUnknownTer[iTeam] then
		grandTofUnknownTer[iTeam] = {}
		for i = 0, Map:GetNumPlots() - 1, 1 do
			local fPlot = Map.GetPlotByIndex( i );
			if not fPlot:IsRevealed(iTeam) then
				grandTofUnknownTer[iTeam][i] = 1;
			end
		end
	else
		for i, sth in pairs(grandTofUnknownTer[iTeam]) do
			local fPlot = Map.GetPlotByIndex( i );
			if fPlot:IsRevealed(iTeam) then
				grandTofUnknownTer[iTeam][i] = nil
			end
		end
	end
	return grandTofUnknownTer[iTeam];
end

function GetNumRevealedPlots(jPlayer)
	local tH = Map.GetNumPlots();
	for index, h in pairs(GetTheUnknownTerritoryOfPlayer(jPlayer)) do
		tH = tH - 1;
	end
	return tH;
end

function HidePlotDuringGame(iTeam, iPlot)
	iPlot:SetRevealed(iTeam, false);
	if grandTofUnknownTer[iTeam] then
		grandTofUnknownTer[iTeam][iPlot:GetPlotIndex()] = 1;
	end
end

function GetNumPassableLand()
	if not gT.Globals.NumPassableLand then
		local cCount = 0;
		for i = 0, Map:GetNumPlots() - 1, 1 do
			local fPlot = Map.GetPlotByIndex( i );
			if not fPlot:IsWater() then
				if not fPlot:IsImpassable() then
					cCount = cCount + 1;
				end
			end
		end
		 gT.Globals.NumPassableLand = cCount;
	end
	return gT.Globals.NumPassableLand;
end

local IsLuxuryResource = {}
for row in GameInfo.Resources() do
	if row.Happiness > 0 then
		IsLuxuryResource[row.ID] = 1;
	end
end

function DoGenerateExtra10PercentHiddenLuxuryResources()
	if gT.ExtraLuxuryResources then
		return;
	end
	DoInitialLuxuryResourcesControl()
	gT.ExtraLuxuryResources = {}
	local avLuxuries = {}
	local luxcount = 0;
	local rPlots = {}
	for i = 0, Map:GetNumPlots() - 1, 1 do
		local fPlot = Map.GetPlotByIndex( i );
		if (not fPlot:IsImpassable()) and (not fPlot:IsMountain()) and (fPlot:GetTerrainType() ~= tOcean) then
			local fRes = fPlot:GetResourceType();
			if IsLuxuryResource[fRes] then
				avLuxuries[fRes] = 1;
				luxcount = luxcount + 1;
			elseif fRes == -1 then
				table.insert(rPlots, fPlot);
			end
		end
	end
	local iextrares = math.floor(luxcount * AMOUNT_EXTRA_HIDDEN_LUXURIES);
	rPlots = Shuffle(rPlots);
	for i = 1, #rPlots do
		local lPlot = rPlots[i];
		iextrares = iextrares + SetNiceHiddenLuxury(lPlot, avLuxuries)
		if iextrares == 0 then
			return;
		end
	end
end

function SetNiceHiddenLuxury(lPlot, avLuxuries)
	local dpPlots = GetPlotsInRadiusOfPlot(lPlot, 3);
	local sTab = {}
	for i, plot in pairs(dpPlots) do
		if not gT.ExtraLuxuryResources[plot:GetPlotIndex()] then
			local bRes = plot:GetResourceType();
			if avLuxuries[bRes] then
				if lPlot:CanHaveResource(bRes) then
					table.insert(sTab, bRes);
				end
			end
		end
	end
	if #sTab == 0 then
		for res, sth in pairs(avLuxuries) do
			if lPlot:CanHaveResource(res) then
				table.insert(sTab, res);
			end
		end
	end
	if #sTab == 0 then
		return 0;
	end
	local lRes = sTab[LastRandom(1,#sTab)];
	lPlot:SetResourceType(lRes)
	lPlot:SetNumResource(1)
	lPlot:SetResourceHidden(true)
	gT.ExtraLuxuryResources[lPlot:GetPlotIndex()] = lRes;
	return -1;
end

function CreateContinentsAndCoasts()
	for i = 0, Map:GetNumPlots() - 1, 1 do
		local fPlot = Map.GetPlotByIndex( i );
		if not TLSHT[i] then
			if fPlot:IsCoastalLand() then
				table.insert(TLSCT, {})
				table.insert(TLSOT, {})
				TLSCT[#TLSCT][i] = 1;
				ContinentITP(fPlot, #TLSCT)
			end
		end
		if not TPilC[i] then
			if ValidForLandCoastPassable(fPlot) then
				table.insert(TPilG, {})
				LandCoastPassableITP(fPlot, #TPilG)
			end
		end
		if not TOOCC[i] then
			if fPlot:GetTerrainType() == tOcean and (not fPlot:IsImpassable()) then
				TOOCB = TOOCB + 1;
				TOOCT[TOOCB] = {}
				OceanOnlyITP(fPlot, TOOCB)
			end
		end
		if not LANI[i] then
			if (not fPlot:IsWater()) and (not fPlot:IsImpassable()) then
				LANC = LANC + 1;
				LANT[LANC] = {}
				LandAreaITP(fPlot, LANC)
			end
		end
		if not TLSOO[i] then
			if fPlot:IsWater() and (not fPlot:IsImpassable()) then
				TLSOC = TLSOC + 1;
				TLSWT[TLSOC] = {}
				TLSWC[TLSOC] = {}
				TRoceanCoastsConnect[TLSOC] = {};
				OceanITP(fPlot, TLSOC)
			end
		end
		if not CTLSH[i] then
			if fPlot:GetTerrainType() == tCoast and (not fPlot:IsImpassable()) and (not fPlot:IsMountain()) then
				CCHOC = CCHOC + 1;
				CCTOA[CCHOC] = {}
				TRbasicCoastsConnect[CCHOC] = {}
				CoastITP(fPlot, CCHOC)
			end
		end
		if not thDT[i] then
			if fPlot:GetTerrainType() == tDesert then
				DSOC = DSOC + 1;
				DSOT[DSOC] = {}
				DesertITP(fPlot, DSOC)
			end
		end
		if not gPassTO[i] then
			if not fPlot:IsImpassable() then
				if not fPlot:IsMountain() then
					if fPlot:GetTerrainType() ~= tOcean then
						gPassCC = gPassCC + 1;
						gPassLM[gPassCC] = {}
						PassITP(fPlot, gPassCC)
					end
				end
			end
		end
	end
	for i = 1, DSOC do
		DesertSize[i] = GetTableSizeInteger(DSOT[i], "DesertSize")
	end
	TLSOO = nil;
	TLSHT = nil;
	TPilC = nil;
	for i = 1, TOOCB do
		TOOST[i] = GetTableSizeInteger(TOOCT[i], "TOceanSizeTooST")
	end
	for i = 1, LANC do
		LZST[i] =  GetTableSizeInteger(LANT[i], "TLandAreaSize")
	end
	for i = 1, TLSOC do
		TOceanSize[i] = GetTableSizeInteger(TLSWT[i], "TOceanSize")
	end
	for i, v in pairs(TLSOT) do
		TLSCSize[i] = GetTableSizeInteger(TLSOT[i], "TLSCC")
	end
	RiverGreatFunction()
	for i = 1, gRiverC do
		RiverLength[i] = GetTableSizeInteger(gRiverT[i], "RiverLength")
	end
	InitializePossibleInitCanals()
end

function CreateNamesForRivers()
	CallNamesForRivers(gRiverT, RiverLength, 1)
	CallNamesForRivers(DSOT, DesertSize, 2)
end

function GetContTab(contID)
	return TLSOT[contID] or {};
end

function GetSizeOfCont(contID)
	return TLSCSize[contID] or -1;
end

function AreConnectedWithWater(iPlot, sPlot)
	local index = iPlot:GetPlotIndex();
	local sindex = sPlot:GetPlotIndex();
	for i = 1, TLSOC do
		if TLSWC[i][index] and TLSWC[i][sindex] then
			return true;
		end
	end
	return false;
end

function PassITP(iPlot, gID)
	iPlot:SetITGLandmassID(gID)
	gPassTO[iPlot:GetPlotIndex()] = 1;
	gPassLM[gID][iPlot:GetPlotIndex()] = 1;	
	for j = 0, 5 do
		local jPlot = Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), j);
		if jPlot then
			if not gPassTO[jPlot:GetPlotIndex()] then
				if not jPlot:IsImpassable() then
					if not jPlot:IsMountain() then
						if jPlot:GetTerrainType() ~= tOcean then
							PassITP(jPlot, gID)
						end
					end
				end
			end
		end
	end
end

function GetPassabilityAreaID(iPlot)
	local index = iPlot:GetPlotIndex()
	for i, data in pairs(gPassLM) do
		if data[index] then
			return i;
		end
	end
	return -1;
end

function ValidForLandCoastPassable(jPlot)
	if (not jPlot:IsImpassable()) and (not jPlot:IsMountain()) then
		return (not jPlot:IsWater()) or (jPlot:GetTerrainType() == tCoast); 
	end
	return false;
end

function LandCoastPassableITP(iPlot, gID)
	TPilC[iPlot:GetPlotIndex()] = true;
	TPilG[gID][iPlot:GetPlotIndex()] = true;
	for j = 0, 5 do
		local jPlot = Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), j);
		if jPlot then
			if not TPilC[jPlot:GetPlotIndex()] then
				if ValidForLandCoastPassable(jPlot) then
					LandCoastPassableITP(jPlot, gID)
				end
			end
		end
	end
end

function LandAreaITP(iPlot, dsID)
	LANI[iPlot:GetPlotIndex()] = 1;
	LANT[dsID][iPlot:GetPlotIndex()] = 1;	
	for j = 0, 5 do
		local jPlot = Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), j);
		if jPlot then
			if not LANI[jPlot:GetPlotIndex()] then
				if (not jPlot:IsWater()) and (not jPlot:IsImpassable()) and (not jPlot:IsMountain()) then
					LandAreaITP(jPlot, dsID)
				end
			end
		end
	end
end

function GetCoastLandPassableAreaID(iPlot)
	local index = iPlot:GetPlotIndex();
	for i, data in pairs(TPilG) do
		if data[index] then
			return i;
		end
	end
	return -1;
end

function GetLandAreaID(iPlot)
	local index = iPlot:GetPlotIndex();
	for i, data in pairs(LANT) do
		if data[index] then
			return i;
		end
	end
	return -1;
end

function DesertITP(iPlot, dsID)
	thDT[iPlot:GetPlotIndex()] = 1;
	DSOT[dsID][iPlot:GetPlotIndex()] = 1;	
	for j = 0, 5 do
		local jPlot = Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), j);
		if jPlot then
			if not thDT[jPlot:GetPlotIndex()] then
				if jPlot:GetTerrainType() == tDesert then
					DesertITP(jPlot, dsID)
				end
			end
		end
	end
end

function OceanOnlyITP(iPlot, oceanID)
	TOOCC[iPlot:GetPlotIndex()] = 1;
	TOOCT[oceanID][iPlot:GetPlotIndex()] = 1;	
	for j = 0, 5 do
		local jPlot = Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), j);
		if jPlot then
			if not TOOCC[jPlot:GetPlotIndex()] then
				if jPlot:GetTerrainType() == tOcean and (not jPlot:IsImpassable()) then
					OceanOnlyITP(jPlot, oceanID)
				end
			end
		end
	end
end

function OceanITP(iPlot, oceanID)
	TLSOO[iPlot:GetPlotIndex()] = 1;
	TLSWT[oceanID][iPlot:GetPlotIndex()] = 1;	
	for j = 0, 5 do
		local jPlot = Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), j);
		if jPlot then
			if not TLSOO[jPlot:GetPlotIndex()] then
				if not jPlot:IsImpassable() then
					if not jPlot:IsWater() then
						TLSWC[oceanID][jPlot:GetPlotIndex()] = 1;
					else
						OceanITP(jPlot, oceanID)
					end
				end
			end
		end
	end
end

function IsCoastOfOceanOrOcean(iPlot, oceanID)
	local plotIndex = iPlot:GetPlotIndex()
	if TLSWT[oceanID][plotIndex] or TLSWC[oceanID][plotIndex] then
		return true;
	end
	return false;
end

function IsCoastOfOcean(iPlot, oceanID)
	local plotIndex = iPlot:GetPlotIndex()
	if TLSWC[oceanID][plotIndex] then
		return true;
	end
	return false;
end

function GetCoastOfOceanTab(iPlot)
	local index = iPlot:GetPlotIndex()
	local hTab = {}
	for i = 1, TLSOC do
		if TLSWC[i][index] then
			table.insert(hTab, i)
		end
	end
	return hTab;
end

function GetCityWithLargestOcean(iPlayer, min)
	local bCity;
	local largestocean = min or 0;
	for iCity in Players[iPlayer]:Cities() do
		for a, bOcean in pairs(GetCoastOfOceanTab(iCity:Plot())) do
			local size = GetSizeOfOcean(bOcean);
			if size > largestocean then
				largestocean = size;
				bCity = iCity;
			end
		end
	end
	return bCity;
end

function GetSizeOfJustOcean(OceanID)
	return TOOST[OceanID];
end

function GetSizeOfJustOceanPlot(iPlot)
	local oceanID = GetJustOceanID(iPlot)
	return TOOST[oceanID] or -1;
end

function GetSizeOfOcean(OceanID)
	return TOceanSize[OceanID]
end

function GetSizeOfLandArea(landID)
	return LZST[landID]
end

function CoastITP(iPlot, dsID)
	CTLSH[iPlot:GetPlotIndex()] = 1;
	CCTOA[dsID][iPlot:GetPlotIndex()] = 1;	
	for j = 0, 5 do
		local jPlot = Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), j);
		if jPlot then
			if not CTLSH[jPlot:GetPlotIndex()] then
				if jPlot:GetTerrainType() == tCoast and (not jPlot:IsImpassable()) then
					CoastITP(jPlot, dsID)
				end
			end
		end
	end
end

function GetCoastOfCoastsTab(iPlot)
	local hTab = {}
	for i = 0, 5 do
		local nPlot = Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), i);
		if nPlot then
			local iBasinID = GetBasinCoastID(nPlot)
			if iBasinID ~= -1 then
				table.insert(hTab, iBasinID)
			end
		end
	end
	return hTab;
end

function GetBasinCoastID(iPlot)
	local iPlotIndex = iPlot:GetPlotIndex()
	for i, data in pairs(CCTOA) do
		if data[iPlotIndex] then
			return i;
		end
	end
	return -1;
end

function ContinentITP(iPlot, oceanID)
	iPlot:SetITGContID(oceanID)
	TLSHT[iPlot:GetPlotIndex()] = 1;
	TLSOT[oceanID][iPlot:GetPlotIndex()] = 1;
	for j = 0, 5 do
		local jPlot = Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), j);
		if jPlot then
			if not TLSHT[jPlot:GetPlotIndex()] then
				if not jPlot:IsWater() then
					if jPlot:IsCoastalLand() then
						TLSCT[oceanID][jPlot:GetPlotIndex()] = 1;
					end
					ContinentITP(jPlot, oceanID)
				end
			end
		end
	end
end

function GetJustOceanID(iPlot)
	local index = iPlot:GetPlotIndex()
	for i, data in pairs(TOOCT) do
		if data[index] then
			return i;
		end
	end
	return -1;
end

function GetValidPiratePlotFromOcean(oceanID)
	local modV = Map:GetNumPlots() - 1;
	local realI = LastRandom(0, modV);
	for i = 0, modV, 1 do
		local realI = (realI + i) % modV;
		if TLSWT[oceanID][realI] then
			local fPlot = Map.GetPlotByIndex( realI );
			if fPlot:GetNumUnits() == 0 then
				return fPlot;
			end
		end		
	end
	print("No pirate valid plot!")
end

function GetOceanID(iPlot)
	local index = iPlot:GetPlotIndex()
	for i, data in pairs(TLSWT) do
		if data[index] then
			return i;
		end
	end
	return -1;
end

function GetCoastID(iPlot, hstring)
	local index = iPlot:GetPlotIndex()
	for i, v in pairs(TLSCT) do
		if TLSCT[i][index] ~= nil then
			return i;
		end
	end
	print("GetCoastID reporting in: Failure", hstring)
	return 0;
end

function GetContID(iPlot, hstring)
	local index = iPlot:GetPlotIndex()
	for i, v in pairs(TLSOT) do
		if TLSOT[i][index] ~= nil then
			return i;
		end
	end
	print("GetContID reporting in: Failure", hstring, index)
	return 0;
end

function GetMountainAndImpassableData(fPlot)
	local m, i = 0,0;
	for i = 0, 5 do
		local iPlot = Map.PlotDirection(fPlot:GetX(), fPlot:GetY(), i);
		if iPlot then
			if iPlot:IsMountain() then
				m = m + 1;
				i = i + 1;
			elseif iPlot:IsImpassable() then
				i = i + 1;
			end
		else
			i = i + 15;
		end
	end
	return i, m;
end

local ResourceToReplace = {}
--ResourceToReplace[rIron] = {GameInfoTypes.RESOURCE_WHEAT, GameInfoTypes.RESOURCE_COW, rHorse, GameInfoTypes.RESOURCE_SHEEP, GameInfoTypes.RESOURCE_DEER, GameInfoTypes.RESOURCE_STONE, GameInfoTypes.RESOURCE_BANANA}

--[[ResourceToReplace[GameInfoTypes.RESOURCE_COPPER] = {rIron, GameInfoTypes.RESOURCE_SILVER, GameInfoTypes.RESOURCE_GOLD, GameInfoTypes.RESOURCE_GEMS, GameInfoTypes.RESOURCE_MARBLE, GameInfoTypes.RESOURCE_STONE, GameInfoTypes.RESOURCE_SALT}
ResourceToReplace[GameInfoTypes.RESOURCE_BISON] = {GameInfoTypes.RESOURCE_WHEAT, GameInfoTypes.RESOURCE_COW, rHorse, GameInfoTypes.RESOURCE_SHEEP, GameInfoTypes.RESOURCE_DEER, GameInfoTypes.RESOURCE_SALT}
ResourceToReplace[GameInfoTypes.RESOURCE_CITRUS] = {GameInfoTypes.RESOURCE_BANANA, GameInfoTypes.RESOURCE_COCOA, GameInfoTypes.RESOURCE_WINE, GameInfoTypes.RESOURCE_SPICES, GameInfoTypes.RESOURCE_SUGAR, GameInfoTypes.RESOURCE_IVORY}
ResourceToReplace[GameInfoTypes.RESOURCE_TRUFFLES] = {GameInfoTypes.RESOURCE_DEER, GameInfoTypes.RESOURCE_COCOA, GameInfoTypes.RESOURCE_WINE, GameInfoTypes.RESOURCE_SALT, GameInfoTypes.RESOURCE_IVORY, GameInfoTypes.RESOURCE_SPICES}
ResourceToReplace[GameInfoTypes.RESOURCE_FUR] = {GameInfoTypes.RESOURCE_DEER, GameInfoTypes.RESOURCE_COCOA, GameInfoTypes.RESOURCE_WINE, GameInfoTypes.RESOURCE_SALT, GameInfoTypes.RESOURCE_IVORY, GameInfoTypes.RESOURCE_SPICES}
ResourceToReplace[GameInfoTypes.RESOURCE_DYE] = {GameInfoTypes.RESOURCE_DEER, GameInfoTypes.RESOURCE_COCOA, GameInfoTypes.RESOURCE_WINE, GameInfoTypes.RESOURCE_SALT, GameInfoTypes.RESOURCE_IVORY, GameInfoTypes.RESOURCE_SPICES}
ResourceToReplace[GameInfoTypes.RESOURCE_COTTON] = {GameInfoTypes.RESOURCE_DEER, GameInfoTypes.RESOURCE_COCOA, GameInfoTypes.RESOURCE_WINE, GameInfoTypes.RESOURCE_SALT, GameInfoTypes.RESOURCE_IVORY, GameInfoTypes.RESOURCE_SPICES}
]]
local fboats = GameInfoTypes.IMPROVEMENT_FISHING_BOATS;
local ValidResourceWater = {}
ValidResourceWater[GameInfoTypes.RESOURCE_CRAB] = 1;
ValidResourceWater[GameInfoTypes.RESOURCE_PEARLS] = 1;

function HasValidWaterResource(fPlot)
	if ValidResourceWater[fPlot:GetResourceType()] then
		return true;
	end
	return false;
end

function ReplaceUnvalidResourcesWithProperOnes()
	local bTab = {}
	for row in DB.Query("SELECT ResourceType FROM ITG_ScenarioExcludedResources WHERE ScenarioType = '" .. DBScenario.Type .. "'") do
		bTab[GameInfo.Resources[row.ResourceType].ID] = true;
	end
	gT.Globals.HappinessPlots = {}
	gT.Globals.BadResourcesRemoved = {}
	for i = 0, Map:GetNumPlots() - 1, 1 do
		local fPlot = Map.GetPlotByIndex( i );
		if fPlot:GetResourceType() ~= -1 then
			if bTab[fPlot:GetResourceType()] then
				gT.Globals.BadResourcesRemoved[i] = {fPlot:GetResourceType(), fPlot:GetNumResource()}
				fPlot:SetResourceType(-1)
				fPlot:SetNumResource(0)
			elseif fPlot:IsWater() then
				if not ValidResourceWater[fPlot:GetResourceType()] then
					fPlot:SetResourceType(-1)
					fPlot:SetNumResource(0)
				end
			end
		end
		if fPlot:GetFeatureType() ~= -1 and GameInfo.Features[fPlot:GetFeatureType()].NaturalWonder then
			table.insert(gT.Globals.DiscoveredNaturalWonders, fPlot:GetPlotIndex())
			local hap = GameInfo.Features[fPlot:GetFeatureType()].InBorderHappiness;
			if hap > 0 then
				gT.Globals.HappinessPlots[i] = hap; 
			end
			gT.Globals.NaturalWonders[fPlot:GetFeatureType()] = fPlot:GetPlotIndex();
			
		end
	end
end

function ShortestPathIsPlotValid(jPlot, bTerrainTypes, bIncludeTerrains, bAny, bCanPassMountains, bCanImpassable, iPlayer, bWater, bCityMakesValid)
	if bCityMakesValid and jPlot:IsCity() then
		return true;
	end
	if bAny or (bWater == nil) or (jPlot:IsWater() == bWater) then
		if (not bTerrainTypes) or (not bTerrainTypes[jPlot:GetTerrainType()]) then
			if (not bIncludeTerrains) or (bIncludeTerrains[jPlot:GetTerrainType()]) then
				if bAny or ((bCanPassMountains or (not jPlot:IsMountain())) and (bCanImpassable or (not jPlot:IsImpassable()))) then
					if (not iPlayer) or (jPlot:GetOwner() == -1) or (jPlot:GetOwner() == iPlayer) then
						return true
					end
				end
			end
		end
	end
	return false;
end

local bRoadTempTCleanLock = false;
local roadST = {}
function IsInRoadTempTab(index)
	for i, v in pairs(roadST) do
		if roadST[index] then
			return i;
		end
	end
	return -1;
end
function LockCleaningTempRoads(bVal, bClean)
	bRoadTempTCleanLock = bVal;
	if bClean then
		 roadST = {}
	end
end
function GetRoadTempTab(i)
	return roadST[i]
end
function GetRoutePathEval(jPlot, prefPlayerOrNeutral)
	local a = 0
	if prefPlayerOrNeutral then
		if jPlot:GetOwner() == prefPlayerOrNeutral then
			if IsSpecialControlPlot(jPlot:GetPlotIndex()) then
				a = a + 11;
			else
				a = a + 10;
			end
		elseif jPlot:GetOwner() == -1 then
			a = a + 7;
		end
	end
	for i = 0, 5 do
		local iPlot = Map.PlotDirection(jPlot:GetX(), jPlot:GetY(), i);
		if iPlot and (iPlot:GetRouteType() ~= -1) then
			a = a + 1;
		end
	end
	if jPlot:GetRouteType() ~= -1 then
		a = a + 4;
	end
	return a;
end
function GenerateShortestPath(iPlots, rTargetPlots, bWater, maxD, iPlayer, bAny, bTerrainTypes, bIncludeTerrains, bCanPassMountains, bCanImpassable, prefPlayerOrNeutral, bAnyRoad, bCityMakesValid)
	local hbdp = {}
	local pathT = {[1] = {}}
	local routePassed;
	if bAnyRoad then
		routePassed = {}
		if not bRoadTempTCleanLock then
			roadST = {}
		end
	end
	for i, iPlot in pairs(iPlots) do
		local index = iPlot:GetPlotIndex();
		hbdp[index] = 0;
		table.insert(pathT[1], {index, nil, nil, GetRoutePathEval(iPlot, prefPlayerOrNeutral)})
	end
	local iT = 1;
	local tTab = {};
	local prefTab = {}
	local prefEval ={}
	local prefFinalEval = {}
	local bContinue = true;
	while (iT <= maxD) and bContinue do
		pathT[iT + 1] = {}
		for int, data in pairs(pathT[iT]) do
			local lPlot = Map.GetPlotByIndex(data[1]);
			local lX, lY = lPlot:GetX(), lPlot:GetY()
			for j = 0, 5 do
				local jPlot = Map.PlotDirection(lX, lY, j);
				if jPlot then
					local jIndex = jPlot:GetPlotIndex();
					local eval = GetRoutePathEval(jPlot, prefPlayerOrNeutral);
					if rTargetPlots[jIndex] then
						local returnTab = {} 
						returnTab[iT + 1] = jPlot;
						local key = int;
						for jiT = 1, iT do
							returnTab[iT + 1 - jiT] = Map.GetPlotByIndex(pathT[iT + 1 - jiT][key][1]);
							if pathT[iT + 1 - jiT][key][3] then
								table.insert(routePassed, pathT[iT + 1 - jiT][key][3])
							end
							key = pathT[iT + 1 - jiT][key][2];
						end
						if prefPlayerOrNeutral then
							table.insert(prefTab, returnTab)
							table.insert(prefFinalEval, {#prefTab, eval + data[4]}) 
							bContinue = false;
						else
							return returnTab, routePassed;
						end
					else
						if (not hbdp[jIndex]) then
							hbdp[jIndex] = iT;
							if ShortestPathIsPlotValid(jPlot, bTerrainTypes, bIncludeTerrains, bAny, bCanPassMountains, bCanImpassable, iPlayer, bWater, bCityMakesValid) then
								table.insert(pathT[iT + 1], {jIndex, int, nil, eval + data[4]})
								prefEval[jIndex] = {eval + data[4],#pathT[iT + 1]}
								if bAnyRoad then
									if jPlot:GetRouteType() ~= -1 then
										local morePlotsRoute;
										local fIndexRoute = IsInRoadTempTab(jPlot:GetPlotIndex())
										if fIndexRoute == -1 then
											morePlotsRoute = RoadConnections(jPlot, nil)
											table.insert(roadST, morePlotsRoute)
											fIndexRoute = #roadST;
										else
											morePlotsRoute = GetRoadTempTab(fIndexRoute)
										end
										pathT[iT + 1][#pathT[iT + 1]][3] = fIndexRoute;
										for nRplotIndex, hh in pairs(morePlotsRoute) do
											local nRplot = Map.GetPlotByIndex(nRplotIndex); 
											local hreval = GetRoutePathEval(jPlot, prefPlayerOrNeutral);
											if (not hbdp[nRplotIndex]) then
												hbdp[nRplotIndex] = iT;
												if rTargetPlots[nRplotIndex] and (not iPlayer) then -- shouldnt be possible for what we are using it;
													print("Grand Error 935435/23124", bWater, maxD, iPlayer, bAny, bTerrainTypes, bIncludeTerrains, bCanPassMountains, bCanImpassable, prefPlayerOrNeutral, bAnyRoad)
												elseif ShortestPathIsPlotValid(nRplot, bTerrainTypes, bIncludeTerrains, bAny, bCanPassMountains, bCanImpassable, iPlayer, bWater, bCityMakesValid) then
													table.insert(pathT[iT + 1], {nRplotIndex, int, fIndexRoute, hreval + data[4]})
													prefEval[nRplotIndex] = {hreval + data[4],#pathT[iT + 1]}
												end
											elseif (prefPlayerOrNeutral and (hbdp[nRplotIndex] == iT) and (prefEval[nRplotIndex]) and (data[4] + hreval > prefEval[nRplotIndex][1])) then
												prefEval[nRplotIndex][1] = data[4] + hreval;
												pathT[iT + 1][prefEval[nRplotIndex][2]][2] = int; --replace "optimal path"
											end
										end
									end
								end
							end
						elseif (prefPlayerOrNeutral and (hbdp[jIndex] == iT) and (prefEval[jIndex]) and (data[4] + eval > prefEval[jIndex][1])) then
							prefEval[jIndex][1] = data[4] + eval;
							pathT[iT + 1][prefEval[jIndex][2]][2] = int; --replace "optimal path"
							pathT[iT + 1][prefEval[jIndex][2]][4] = data[4] + eval;
						end
					end
				end
			end
		end
		iT = iT + 1;
	end
	if (not bContinue) then
		local eKey = 1;
		if #prefTab > 1 then
			table.sort(prefFinalEval, SortFunctionForGreaterInteger2)
			eKey = prefFinalEval[1][1]
		end
		return prefTab[eKey], nil;
	end
	return nil;
end

function GetLandPointNearby(iPlot, dis)
	local hTab = {}
	for ix = -1 * dis, dis do
		for iy = -1 * dis, dis do
			local nPlot = Map.PlotXYWithRangeCheck(iPlot:GetX(), iPlot:GetY(), ix, iy, dis)
			if nPlot then
				if not nPlot:IsMountain() then
					if not nPlot:IsWater() then
						if nPlot:GetNumUnits() == 0 then
							table.insert(hTab, nPlot)
						end
					end
				end
			end		
		end
	end
	if #hTab > 0 then
		return hTab[LastRandom(1, #hTab)]
	else
		return nil;
	end
end

function IsProperToNavigate(contID)
	for index, it in pairs(TLSCT[contID]) do
		local iPlot = Map.GetPlotByIndex(index)
		local Coast, numN = false, 0;
		for j = 0, 5 do
			local jPlot = Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), j);
			if jPlot then
				if TLSCT[contID][jPlot:GetPlotIndex()] then
					numN = numN + 1;
				elseif jPlot:IsWater() then
					if (not jPlot:IsLake()) and (not jPlot:IsImpassable()) then
						Coast = true;
					end
				end
			end
		end
		if (not Coast) or numN < 2 then
			return false;
		end
	end
	return true;
end

function GetAndCheckTheLargestContinentForNavigate()
	local contID, dis = -1, -1;
	for i, v in pairs(TLSCT) do
		local iVal = GetTableSizeInteger(TLSCT[i], "GTSI");
		if iVal > dis then
			contID = i;
			dis = iVal;
		end
	end
	print("NavigateTheCont", dis)
	if dis < 450 then
		if dis > 350 then
			if IsProperToNavigate(contID) then
				return contID;
			else
				return nil;
			end
		end
	end
end

local hRttDst = {}
local hDoneTrrS = {}
function SenseForRouteHere(iPlot)
	local hRttDst = {}
	for i = 0, 5 do
		local jPlot = Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), i);
		if jPlot then
			if jPlot:GetRouteType() ~= -1 then
				table.insert(hRttDst, jPlot);
			end
		end
	end
	if #hRttDst > 4 then
		return false
	end
	if #hRttDst < 2 then
		return true;
	end
	hDoneTrrS = {}
	IterateRouteConnection(hRttDst[1])
	for i, jPlot in pairs(hRttDst) do
		if not hDoneTrrS[jPlot] then
			return true;
		end
	end
	return false;
end

function IterateRouteConnection(iPlot)
	hDoneTrrS[iPlot] = 1;
	for n, nPlot in pairs(hRttDst) do
		if not hDoneTrrS[nPlot] then
			if Map.PlotDistance(nPlot:GetX(), nPlot:GetY(), iPlot:GetX(), iPlot:GetY()) == 1 then
				IterateRouteConnection(nPlot)
			end
		end
	end
end

function FixTheRoads()
	for i = 0, Map:GetNumPlots() - 1, 1 do
		local fPlot = Map.GetPlotByIndex( i );
		if fPlot:GetRouteType() ~= -1 then
			if not fPlot:IsCity() then
				if not SenseForRouteHere(fPlot) then
					fPlot:SetRouteType(-1)
				end
			end
		end
	end
end

function RiverGreatFunction()
	for i = 0, Map:GetNumPlots() - 1, 1 do
		local fPlot = Map.GetPlotByIndex( i );
		if fPlot:IsRiver() then
			MakeRiverT(fPlot)
		end
	end
	hRiverT = nil;
end

function MakeRiverT(iPlot)
	if iPlot:IsNEOfRiver() then
		if not hRiverT[iPlot:GetPlotIndex() .. "x3"] then
			hRiverT[iPlot:GetPlotIndex() .. "x3"] = 1;
			gRiverC = gRiverC + 1;
			gRiverT[gRiverC] = {}
			gRiverT[gRiverC][iPlot:GetPlotIndex()] = true;
			MakeRiverNE(Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), 4), Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), 3), iPlot, gRiverC)
		end
	end
	if iPlot:IsNWOfRiver() then
		if not hRiverT[iPlot:GetPlotIndex() .. "x2"] then
			hRiverT[iPlot:GetPlotIndex() .. "x2"] = 1;
			gRiverC = gRiverC + 1;
			gRiverT[gRiverC] = {}
			gRiverT[gRiverC][iPlot:GetPlotIndex()] = true;
			MakeRiverNW(Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), 3), Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), 1), iPlot, gRiverC)
		end
	end
	if iPlot:IsWOfRiver() then		
		if not hRiverT[iPlot:GetPlotIndex() .. "x1"] then
			hRiverT[iPlot:GetPlotIndex() .. "x1"] = 1;
			gRiverC = gRiverC + 1;
			gRiverT[gRiverC] = {}
			gRiverT[gRiverC][iPlot:GetPlotIndex()] = true;
			MakeRiverW(Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), 1), Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), 0), iPlot, gRiverC)
		end
	end
end

function MakeRiverW(iPlot, sPlot, dPlot, riverID)
	if iPlot then
		gRiverT[riverID][iPlot:GetPlotIndex()] = true;
		if not hRiverT[iPlot:GetPlotIndex() .. "x3"] then
			hRiverT[iPlot:GetPlotIndex() .. "x3"] = 1;
			if iPlot:IsNEOfRiver() then
				MakeRiverNE(Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), 4), Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), 3), iPlot, riverID)
			end
		end
	end
	if sPlot then
		if not (sPlot:IsNEOfRiver() or sPlot:IsNWOfRiver()) then
			if sPlot:GetTerrainType() == tCoast then
				gRiverT[riverID][sPlot:GetPlotIndex()] = true;
			end
		else
			if not hRiverT[sPlot:GetPlotIndex() .. "x2"] then
				hRiverT[sPlot:GetPlotIndex() .. "x2"] = 1;
				if sPlot:IsNWOfRiver() then
					gRiverT[riverID][sPlot:GetPlotIndex()] = true;
					MakeRiverNW(Map.PlotDirection(sPlot:GetX(), sPlot:GetY(), 3), Map.PlotDirection(sPlot:GetX(), sPlot:GetY(), 1), sPlot, riverID)
				end
			end
			if not hRiverT[sPlot:GetPlotIndex() .. "x3"] then
				hRiverT[sPlot:GetPlotIndex() .. "x3"] = 1;
				if sPlot:IsNEOfRiver() then
					gRiverT[riverID][sPlot:GetPlotIndex()] = true;
					MakeRiverNE(Map.PlotDirection(sPlot:GetX(), sPlot:GetY(), 4), Map.PlotDirection(sPlot:GetX(), sPlot:GetY(), 3), sPlot, riverID)
				end
			end
		end
	end
	if dPlot:IsNWOfRiver() then
		if not hRiverT[dPlot:GetPlotIndex() .. "x2"] then
			hRiverT[dPlot:GetPlotIndex() .. "x2"] = 1;
			MakeRiverNW(Map.PlotDirection(dPlot:GetX(), dPlot:GetY(), 3), Map.PlotDirection(dPlot:GetX(), dPlot:GetY(), 1), dPlot, gRiverC)
		end
	end
	local lPlot = Map.PlotDirection(dPlot:GetX(), dPlot:GetY(), 2)
	if lPlot and (lPlot:GetTerrainType() == tCoast) then
		gRiverT[riverID][lPlot:GetPlotIndex()] = true;
	end
end

function MakeRiverNE(iPlot, sPlot, dPlot, riverID)
	if iPlot then
		if not (iPlot:IsWOfRiver() or iPlot:IsNWOfRiver()) then
			if iPlot:GetTerrainType() == tCoast then
				gRiverT[riverID][iPlot:GetPlotIndex()] =  true;
			end
		else
			if not hRiverT[iPlot:GetPlotIndex() .. "x1"] then
				hRiverT[iPlot:GetPlotIndex() .. "x1"] = 1;
				if iPlot:IsWOfRiver() then
					gRiverT[riverID][iPlot:GetPlotIndex()] = true;
					MakeRiverW(Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), 1), Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), 0), iPlot, riverID)
				end
			end
			if not hRiverT[iPlot:GetPlotIndex() .. "x2"] then
				hRiverT[iPlot:GetPlotIndex() .. "x2"] = 1;
				if iPlot:IsNWOfRiver() then
					gRiverT[riverID][iPlot:GetPlotIndex()] = true;
					MakeRiverNW(Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), 3), Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), 1), iPlot, riverID)
				end
			end
		end
	end
	if sPlot then
		gRiverT[riverID][sPlot:GetPlotIndex()] = true;
		if not hRiverT[sPlot:GetPlotIndex() .. "x1"] then
			hRiverT[sPlot:GetPlotIndex() .. "x1"] = 1;
			if sPlot:IsWOfRiver() then
				MakeRiverW(Map.PlotDirection(sPlot:GetX(), sPlot:GetY(), 1), Map.PlotDirection(sPlot:GetX(), sPlot:GetY(), 0), sPlot, riverID)
			end
		end
	end
	if dPlot:IsNWOfRiver() then
		if not hRiverT[dPlot:GetPlotIndex() .. "x2"] then
			hRiverT[dPlot:GetPlotIndex() .. "x2"] = 1;
			MakeRiverNW(Map.PlotDirection(dPlot:GetX(), dPlot:GetY(), 3), Map.PlotDirection(dPlot:GetX(), dPlot:GetY(), 1), dPlot, gRiverC)
		end
	end
	local lPlot = Map.PlotDirection(dPlot:GetX(), dPlot:GetY(), 2)
	if lPlot and (lPlot:GetTerrainType() == tCoast) then
		gRiverT[riverID][lPlot:GetPlotIndex()] = true;
	end
end

function MakeRiverNW(iPlot, sPlot, dPlot, riverID)
	if iPlot then
		if not hRiverT[iPlot:GetPlotIndex() .. "x1"] then
			hRiverT[iPlot:GetPlotIndex() .. "x1"] = 1;
			if iPlot:IsWOfRiver() then
				gRiverT[riverID][iPlot:GetPlotIndex()] = true;
				MakeRiverW(Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), 1), Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), 0), iPlot, riverID)
			end
		end
		if iPlot:GetTerrainType() == tCoast then
			gRiverT[riverID][iPlot:GetPlotIndex()] = 1;
		end
	end
	if sPlot then
		if not hRiverT[sPlot:GetPlotIndex() .. "x3"] then
			hRiverT[sPlot:GetPlotIndex() .. "x3"] = 3;
			if sPlot:IsNEOfRiver() then
				gRiverT[riverID][sPlot:GetPlotIndex()] = 1;
				MakeRiverNE(Map.PlotDirection(sPlot:GetX(), sPlot:GetY(), 4), Map.PlotDirection(sPlot:GetX(), sPlot:GetY(), 3), sPlot, riverID)
			end
		end
		if sPlot:GetTerrainType() == tCoast then
			gRiverT[riverID][sPlot:GetPlotIndex()] = 1;
		end
	end
	if dPlot:IsNEOfRiver() then
		if not hRiverT[dPlot:GetPlotIndex() .. "x3"] then
			hRiverT[dPlot:GetPlotIndex() .. "x3"] = 1;
			MakeRiverNE(Map.PlotDirection(dPlot:GetX(), dPlot:GetY(), 4), Map.PlotDirection(dPlot:GetX(), dPlot:GetY(), 3), dPlot, gRiverC)
		end
	end
	if dPlot:IsWOfRiver() then
		if not hRiverT[dPlot:GetPlotIndex() .. "x1"] then
			hRiverT[dPlot:GetPlotIndex() .. "x1"] = 1;
			MakeRiverW(Map.PlotDirection(dPlot:GetX(), dPlot:GetY(), 1), Map.PlotDirection(dPlot:GetX(), dPlot:GetY(), 0), dPlot, gRiverC)
		end
	end
	local lPlot = Map.PlotDirection(dPlot:GetX(), dPlot:GetY(), 2);
	if lPlot then
		gRiverT[riverID][lPlot:GetPlotIndex()] = true;
	end
end

function GetRiverT(i)
	return gRiverT[i];
end

function GetRiversOfPlot(iPlot)
	local index = iPlot:GetPlotIndex();
	local nTab = {}
	for i = 1, gRiverC do
		if gRiverT[i][index] then
			table.insert(nTab, i)
		end
	end
	return nTab;
end

function GetSizeOfRiver(RiverID)
	return RiverLength[RiverID];
end

function GetTombPlot()
	local xs, ys = Map.GetGridSize()
	local hTab = {}
	for i, vbed in pairs(TLSOT) do
		for index, it in pairs(TLSOT[i]) do
			local iPlot = Map.GetPlotByIndex(index)
			if not iPlot:IsCoastalLand() then
				if not iPlot:IsMountain() then
					if iPlot:IsRiver() then
						if not iPlot:IsStartingPlot() then
							if iPlot:GetX() > 3 and iPlot:GetX() < xs - 3 and iPlot:GetY() > 3 and iPlot:GetY() < ys - 3 then
								local value, maxonemountain = 0, false;
								for j = 0, 5 do
									local jPlot = Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), j);
									if jPlot then
										if jPlot:IsMountain() then
											if maxonemountain then
												value = -999;
												break;
											else
												maxonemountain = true;
												value = value + 100;
											end
										else
											if jPlot:IsRiver() then
												value = value + 15;
											end
											if jPlot:GetFeatureType() ~= -1 or jPlot:IsHills() then
												value = value + 25;
											end
										end
									else
										value = -999;
										break;
									end
								end
								table.insert(hTab, {iPlot, value})
							end
						end
					end
				end
			end
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	return hTab[1][1];
end

function ValidDistanceFromPlots(iPlot, tab, dis)
	for xT, xPlot in pairs(tab) do
		if Map.PlotDistance(xPlot:GetX(), xPlot:GetY(), iPlot:GetX(), iPlot:GetY()) < dis then
			return false;
		end
	end
	return true;	
end

function IsGreatPeopleImprovementPlot(index)
	if gT.Manufactories[index] or gT.CustomsHouses[index] or gT.Academies[index] then
		return true;
	end
	return false;
end

function IsSpecialControlPlot(index, bAdjFort, bAdjSetCheck, bForAdjFort)
	if gT.Forts[index] or gT.Colonies[index] or gT.HolySites[index] or gT.ElDorados[index] or gT.Settlements[index] then
		return true;
	end
	if bAdjFort and gT.PlotFortControl[index] then
		return true;
	end
	if gT.Manufactories[index] or gT.CustomsHouses[index] or gT.Academies[index] then
		return true;
	end
	if gT.ArchaeologySites[index] and (not bForAdjFort) then
		return true;
	end
	if gT.Globals.AncientRuins[index] and (not bAdjSetCheck) and (not bForAdjFort) then --added recently! and it ruined settlement check :)
		return true;
	end
	return false;
end

function AssignInitialArchaeologySites()
	--gT.ArchaeologyPlots
	local aPlots = {}
	for i, v in pairs(TLSOT) do
		local tPlots = {};
		for ih, sh in pairs(TLSOT[i]) do
			table.insert(tPlots, ih)
		end
		tPlots = Shuffle(tPlots)
		for iT, index in pairs(tPlots) do
			local iPlot = Map.GetPlotByIndex(index)
			if CanBeArchaelogySiteBasic(iPlot) then
				if CanBeArchaeologySiteDynamic(iPlot) then
					if ValidDistanceFromPlots(iPlot, aPlots, 5) then
						table.insert(aPlots, iPlot)
					end
				end
			end
		end
	end
	aPlots = Shuffle(aPlots)
	for h, v in pairs(aPlots) do
		gT.ArchaeologyPlots[v:GetPlotIndex()] = -1;
	end
end

function AssignTheAncientRuinsStuff()
	if DBScenario.GoodyHutMod100 <= 0 then
		print("Ancient ruins are off")
		return;
	end
	local aPlots = {}
	for i, vked in pairs(TLSOT) do
		for index, iT in pairs(TLSOT[i]) do
			local iPlot = Map.GetPlotByIndex(index)
				if not iPlot:IsCity() then
					if iPlot:GetResourceType() == -1 then
						if not gT.Globals.BadPoints[iPlot:GetPlotIndex()] then
							if not iPlot:IsMountain() and (not iPlot:IsImpassable()) then
								if iPlot:GetTerrainType() ~= tSnow then
									if not IsSpecialControlPlot(iPlot:GetPlotIndex(), false) then
										if ValidDistanceFromPlots(iPlot, aPlots, 5) then
											table.insert(aPlots, iPlot)
										end
									end
								end
							end
						end
					end
				end
			--end
		end
	end
	aPlots = Shuffle(aPlots)
	local min = math.ceil(math.max(gT.Globals.Diameter / 10, Map.GetNumPlots() / 250));
	local numMax = LastRandom(min * 2, min * 4) * DBScenario.GoodyHutMod100 / 100;
	print("Ancient ruin meter", #aPlots, numMax)
	for j = 1, numMax do
		if aPlots[j] then
			CreateAncientRuinOnPlot(aPlots[j])
		end
	end
end

function CreateAncientRuinOnPlot(aPlot)
	gT.Globals.AncientRuins[aPlot:GetPlotIndex()] = {};
	aPlot:SetImprovementType(AncientRuinsI, -1)
	for gplayer, gdata in pairs(gT.Players) do
		if aPlot:IsRevealed(Players[gplayer]:GetTeam()) then
			aPlot:SetAlreadyVisitedGoodyHut(Players[gplayer]:GetTeam(), true)
		else
			aPlot:SetAlreadyVisitedGoodyHut(Players[gplayer]:GetTeam(), false)
		end
	end
end

function PlotIntoMapData(iPlot)
	local iData = {}
	for i = 0, 5 do
		local jPlot = Map.PlotDirection(iPlot:GetX(),iPlot:GetY(), i);
		if jPlot then
			if i == 0 then
				iData[1] = jPlot:IsNEOfRiver()
				iData[7] = jPlot:IsNWOfRiver()
				iData[12] = jPlot:IsWOfRiver();
			elseif i == 1 then
				iData[8] = jPlot:IsNEOfRiver()
				iData[2] = jPlot:IsWOfRiver();
			elseif i == 2 then
				iData[9] = jPlot:IsWOfRiver();
			elseif i == 4 then
				iData[10] = jPlot:IsNWOfRiver()
			elseif i == 5 then
				iData[11] = jPlot:IsNEOfRiver()
				iData[6] = jPlot:IsNWOfRiver()
			end
			iData[i + 13] = {}
			iData[i + 13][2] = jPlot:GetTerrainType();
			iData[i + 13][3] = jPlot:GetFeatureType();
			if jPlot:IsWater() then
				iData[i + 13][1] = 1;
			elseif jPlot:IsMountain() then
				iData[i + 13][1] = 2;
			elseif jPlot:IsHills() then
				iData[i + 13][1] = 3;
			else
				iData[i + 13][1] = 4;
			end
		else
			print("Wrong Plot for map!")
		end
	end
	iData[4] = iPlot:IsNEOfRiver()
	iData[3] = iPlot:IsNWOfRiver()
	iData[5] = iPlot:IsWOfRiver();
	return iData;
end

function GetValidTablePlayersForOlympics()
	local hTab = {}
	for gPlayer, gData in pairs(gT.Players) do
		if gData.NumSecMissions < 3 then
			local contID = GetContID(Map.GetPlotByIndex(gData.StartingPoint), 125125);
			if not hTab[contID] then
				hTab[contID] = {}
			end
			table.insert(hTab[contID], gPlayer)
		end
	end
	for contID, tabl in pairs(hTab) do
		if #tabl > 7 then
			return tabl; 
		end
	end
	return {};
end

local hFCT = {}
local cFCT, mFCT;

function GetNumFeatureNearby(featureType, num, iPlot)
	hFCT = {}
	cFCT = 0;
	mFCT = num;
	for i = 0, 5 do
		local dPlot = Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), i);
		if cFCT < mFCT then
			if dPlot then
				if dPlot:GetFeatureType() == featureType then
					if dPlot:GetResourceType() == -1 then
						if dPlot:GetImprovementType() == -1 then
							IterateLFF(dPlot, featureType)
						end
					end
				end
			end
		end
	end
	if cFCT == mFCT then
		return hFCT;
	end
	return nil;
end

function IterateLFF(iPlot, featureType)
	hFCT[iPlot] = 1;
	cFCT = cFCT + 1;
	for i = 0, 5 do
		local dPlot = Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), i);
		if cFCT < mFCT then
			if dPlot then
				if not hFCT[iPlot] then
					if dPlot:GetFeatureType() == featureType then
						if dPlot:GetResourceType() == -1 then
							if dPlot:GetImprovementType() == -1 then
								IterateLFF(dPlot, featureType)
							end
						end
					end
				end
			end
		end
	end
end

function IsValidForWorkCitFort(nPlot, i, iCity)
	if not nPlot:IsCity() then
		if nPlot:IsHills() then
			if nPlot:GetOwner() == -1 or nPlot:GetOwner() == i then
				if nPlot:GetNumUnits() == 0 then
					if nPlot:GetImprovementType() == -1 then
						if (not iCity) or IsPlotABorder(nPlot, iCity, i) then
							return true;
						end
					end
				end
			end
		end
	end
	return false;
end

function GetValidPlotForCitadel(i, num)
	local hTab = {}
	local bTab = {}
	for iCity in Players[i]:Cities() do
		for ix = -4, 4 do
			for iy = -4, 4 do
				local nPlot = Map.GetPlot(iCity:GetX() +ix, iCity:GetY() + iy);
				if nPlot then
					if not bTab[nPlot] then
						if IsValidForWorkCitFort(nPlot, i, iCity) then
							table.insert(hTab, nPlot);
						end
					end
				end
			end
		end
	end
	local sPlot = Map.GetPlotByIndex(gT.Players[i].StartingPoint);
	if not sPlot:IsCity() then
		for ix = -6, 6 do
			for iy = -6, 6 do
				local nPlot = Map.GetPlot(sPlot:GetX() +ix, sPlot:GetY() + iy);
				if nPlot then
					if not bTab[nPlot] then
						if IsValidForWorkCitFort(nPlot, i, nil) then
							table.insert(hTab, nPlot);
						end
					end
				end
			end
		end
	end
	if #hTab >= num then
		hTab = Shuffle(hTab);
		local sTab = {}
		for j, dt in pairs(hTab) do
			if j <= num then
				table.insert(sTab, dt)
			else
				break;
			end
		end
		return sTab;
	end
	return nil;
end

function IsPlotABorder(nPlot, iCity, i)
	local nDis = Map.PlotDistance(nPlot:GetX(), nPlot:GetY(), iCity:GetX(), iCity:GetY());
	for dCity in Players[i]:Cities() do
		if dCity ~= iCity then
			if Map.PlotDistance(nPlot:GetX(), nPlot:GetY(), dCity:GetX(), dCity:GetY()) < Map.PlotDistance(dCity:GetX(), dCity:GetY(), iCity:GetX(), iCity:GetY()) then
				return false;
			end
		end
	end
	return true;
end

function IsCoastOfHugeArea(iPlot)
	local htab = {}
	for i = 0, 5 do
		local jPlot = Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), i);
		if jPlot then
			if (TOceanSize[GetOceanID(jPlot)] or 0) > 30 then
				table.insert(htab, jPlot)
			end
		end
	end
	return htab;
end

function RequestOceansOnly()
	return TOOCT;
end

function RequestOceans()
	return TLSWT;
end

function GetSizeOfOceanOnPlot(iPlot)
	local oceanID = GetOceanID(iPlot)
	return TOceanSize[oceanID] or -1;
end

function GetSizeOfLargestOcean(bOceanID)
	local mmom, oceanID = 0, -1;
	for i, val in pairs(TOceanSize) do
		if val > mmom then
			mmom = val;
			oceanID = i;
		end	
	end
	if bOceanID then
		return oceanID;
	end
	return mmom;
end

function RequestContinentDataForBarbarians()
--UNUSED 
	local barbData = {}
	for id, plots in pairs(TLSCT) do
		local size = TLSCSize[id];
		local numspawns = LastRandom(math.floor(size/60), math.floor(size/30))
		local hplotT = Shuffle(RevertIntoIntegerTable(plots))
		local tempplots = {}
		if numspawns > 0 then
			for i, hIndex in pairs(hplotT) do
				local hPlot = Map.GetPlotByIndex(hIndex)
				if IsValidForBarbarianSpawn(hPlot) then
					if IsWithinProperDistanceFromOtherPlots(hPlot, tempplots, 8) then
						table.insert(tempplots, {hPlot, IsWithinProperDistanceFromOtherPlots(hPlot, "Cities", 6)})
						if #tempplots >=numspawns then
							break
						end
					end
				end
			end
			if #tempplots > 0 then
				barbData[id] = tempplots;
			end
		end
	end
	return barbData;
end

function IsPartOfAquenOfSizeGreaterThan(iPlot, amount)
	return (TOceanSize[GetOceanID(iPlot)] or -1) > amount;
end

function IsValidForBarbarianSpawn(hPlot)
--ALSO UNUSED
	if hPlot:GetNumUnits() == 0 then
		if hPlot:GetOwner() == -1 then
			if not hPlot:IsMountain() then
				if hPlot:GetImprovementType() == -1 then
					if hPlot:GetRouteType() == -1 then
						if not gT.Globals.BadPoints[hPlot:GetPlotIndex()] then
							return true;
						end
					end
				end
			end
		end
	end
	return false;
end

function GetTheValidTargetCityForLongestCaravan(plot, dis)
	local contID = GetContID(plot, 512515);
	local maxdis, mplot = 0, nil;
	for i, v in pairs(Players) do
		for icity in v:Cities() do
			if GetContID(icity:Plot(), 64646) == contID then
				if Map.PlotDistance(icity:GetX(), icity:GetY(), plot:GetX(), plot:GetY()) > maxdis then
					maxdis=  Map.PlotDistance(icity:GetX(), icity:GetY(), plot:GetX(), plot:GetY());
					mplot = icity:Plot();
				end
			end
		end
	end
	if maxdis >= dis then
		return mplot;
	end
	return nil;
end

function DetectCityAdjacentToPlot(iPlot)
	if iPlot:IsCity() then
		return iPlot;
	end
	for i = 0, 5 do
		local jPlot = Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), i);
		if jPlot then
			if jPlot:IsCity() then
				return jPlot;
			end
		end
	end
	return nil
end

function GetNumCitiesOnRiver(river)
	local count = 0;
	for i, v in pairs(Players) do
		for iCity in v:Cities() do
			for it, riverID in pairs(GetRiversOfPlot(iCity:Plot())) do
				if river == riverID then
					count = count + 1;
					break
				end
			end
		end
	end
	return count;
end

function IsPlotPartOfRiver(iPlot, iRiver)
	for it, riverID in pairs(GetRiversOfPlot(iPlot)) do
		if iRiver == riverID then
			return true;
		end
	end
	return false;
end

function HasEnoughAdjacentFeatures(plot, feature, num)
	local count = 0;
	for i = 0, 5 do
		local nPlot = Map.PlotDirection(plot:GetX(), plot:GeY(), i);
		if nPlot then
			if nPlot:GetFeatureType() == feature then
				count = count + 1;
				if count == num then
					return true;
				end
			end
		end
	end
	return false;
end

function GetNicePlayerToFillCity(cPlot, hLLt)
	local tab = {}
	for g, b in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			if (b.NumStartingCities > (Players[g]:GetNumCities() + (hLLt[g] or 0))) or (GetClosestCityDistanceToXY(g, cPlot:GetX(), cPlot:GetY()) < 9) then
				table.insert(tab, {g, math.max(1, 1 + b.NumStartingCities - Players[g]:GetNumCities() - (hLLt[g] or 0))})
			end
		end
	end
	if #tab == 0 then
		for g, b in pairs(gT.Players) do
			if not Players[g]:IsMinorCiv() then
				table.insert(tab, {g, math.max(1, 10 - Players[g]:GetNumCities() - (hLLt[g] or 0))})
			end
		end
	end
	return GetRandomFromBiasedChanceTable(tab);
end

function HeavyFillWithCities(max)
	local tt = GetCityLocations()
	local done = 1;
	local hPtt = {}
	local pCitiesN = {}
	for aindex, b in pairs(tt) do
		local a = Map.GetPlotByIndex(aindex);
		local bPlayer = GetNicePlayerToFillCity(a, hPtt)
		hPtt[bPlayer] = (hPtt[bPlayer] or 0) + 1
		print("Heavy fill", bPlayer, aindex, done)
		table.insert(pCitiesN, {aindex, bPlayer})
		if done >= max then
			break;
		end
		done = done + 1;
	end
	for i, cp in pairs(pCitiesN) do
		GenerateCity(cp[2], Map.GetPlotByIndex(cp[1]), "Heavy Fill")
	end
end

function GetFillCitiesDistance(iPlayer)
	local base = GetDBCulturePlayerInfo(iPlayer, "FillCitiesMaxDistance")
	if (PreGame.GetGameOption("GAMEOPTION_ITG_BLOB_TERRITORIES") == 1) then
		return math.max(8, math.ceil(base / 2));
	end
	return base;
end

function FillWithCities(tabToFill)
-- this is technically the most brute forced, because it is not based on predefined city locations;
	local hTab = {}
	local totalToDo = 0;
	local leftToDo = {}
	local contsDone = {}
	local alrCovered = {}
	for ittf, ttf in pairs(tabToFill) do
		print("Player need more Cities", ttf[1], ttf[2]);
		local iPlayer = ttf[1];
		local iNum = ttf[2];
		totalToDo = totalToDo + iNum;
		local sPlot = Players[iPlayer]:GetStartingPlot();
		local npc = GetDBCulturePlayerInfo(iPlayer, "NeedPassabilityCheck")
		local contID = GetContID(sPlot, 54657);
		local sAreaID = GetPassabilityAreaID(sPlot);
		leftToDo[iPlayer] = {iNum, sAreaID, GetFillCitiesDistance(iPlayer), npc};
		if not contsDone[contID] then
			contsDone[contID] = true;
			if GetSizeOfCont(contID) > 25 then
				local contTab = GetContTab(contID)
				for index, int in pairs(contTab) do
					alrCovered[index] = true;
					local iPlot = Map.GetPlotByIndex(index)
					if 0 == iPlot:IsCityRadius() then
						if CanPlotBeCityVeryBasic(iPlot) then
							if IsPossibleCity(iPlot:GetX(), iPlot:GetY()) then
								if iPlot:GetOwner() == -1 then
									table.insert(hTab, {index, GetValueAIOfPlotForSettle(iPlot), 1})
								end
							end
						end
					end
				end
			end
		end
	end
	local function SolvePotentialCityLocations()
		print("Potential plots for fill", #hTab)
		hTab = Shuffle(hTab);
		table.sort(hTab, SortFunctionForGreaterInteger2)
		for i, hData in pairs(hTab) do
			local hPlot = Map.GetPlotByIndex(hData[1]);
			if 0 == hPlot:IsCityRadius() then
				local hX, hY = hPlot:GetX(), hPlot:GetY();
				local sAreaID = GetPassabilityAreaID(hPlot);
				local ppT = {};
				for iPlayer, lTD in pairs(leftToDo) do
					if lTD[1] > 0 then
						if (hData[3] ~= 1) or (sAreaID == lTD[2]) then
							if (hData[3] ~= 2) or (not lTD[4]) or (sAreaID == lTD[2]) then
								local iDis = GetClosestCityDistanceToXY(iPlayer, hX, hY)
								if iDis < lTD[3] then
									table.insert(ppT, {iPlayer, iDis * 100 / lTD[1]})
								end
							end
						end
					end
				end
				if #ppT > 0 then
					table.sort(ppT, SortFunctionForLowestMapDistance);
					local lPlayer = ppT[1][1];
					leftToDo[lPlayer][1] = leftToDo[lPlayer][1] - 1;
					GenerateCity(lPlayer, hPlot, "Normal Fill")
					print("Fill with Cities (player / plot / distance / left / #players):", lPlayer, hData[1], ppT[1][2], leftToDo[lPlayer][1], #ppT);
					totalToDo = totalToDo - 1;
					if totalToDo == 0 then
						return;
					end
				end
			end
		end
	end
	SolvePotentialCityLocations();
	if totalToDo == 0 then
		return;
	end
	hTab = {};
	for coastID, cIndexData in pairs(TLSWC) do
		for index, sth in pairs(TLSWC[coastID]) do
			if not alrCovered[index] then
				alrCovered[index] = true;
				local iPlot = Map.GetPlotByIndex(index);
				if 0 == iPlot:IsCityRadius() then
					if CanPlotBeCityVeryBasic(iPlot) then
						if IsPossibleCity(iPlot:GetX(), iPlot:GetY()) then
							if iPlot:GetOwner() == -1 then
								if GetSizeOfCont(GetContID(iPlot, "fWc")) > 2 then
									table.insert(hTab, {index, GetValueAIOfPlotForSettle(iPlot), 2})
								end
							end
						end
					end
				end
			end
		end
	end
	SolvePotentialCityLocations();
	if totalToDo > 0 then
		print("Failure of assigning proper number of cities.", totalToDo)
	end
end

function NoFreeManLandStuff()
	local numf, numt = 3, 12;
	for i, v in pairs(TLSOT) do
		if gT.Globals.NoFreeManContinents[i] then
			if gT.Globals.NoFreeManContinents[i] == 1 then
				DoNoFreeManLandOnCont(i)
				numt = numt +1;
			else
				numf = numf + 1;
			end
		elseif LastRandom(1, numt) <= numf then
			numt = numt +1;
			DoNoFreeManLandOnCont(i)
		else
			numf = numf + 1;
		end
	end
	if gT.Globals.ScenarioType == 5 then
		FinalNoFreeManTerritory()
	end
end

function FinalNoFreeManTerritory()
	local tab = {};
	for g, h in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			if Players[g]:GetNumCities() > 0 then
				table.insert(tab, g)
			end
		end
	end
	for i = 0, Map.GetNumPlots() - 1 do
		local iPlot = Map.GetPlotByIndex(i);
		if (not iPlot:IsWater()) and (iPlot:GetOwner() == -1) then
			local lTab = {}
			local iX, iY = iPlot:GetX(), iPlot:GetY();
			for j = -2, 2 do
				for y = -2, 2 do
					local jPlot = Map.GetPlot(iX + j, iY + y);
					if jPlot then
						if gT.Players[jPlot:GetOwner()] then
							if Players[jPlot:GetOwner()]:GetNumCities() > 0 then
								table.insert(lTab, jPlot:GetOwner())
							end
						end
					end
				end
			end
			if #lTab > 0 then
				local tPlayer = lTab[LastRandom(1,#lTab)];
				iPlot:SetOwner(tPlayer, GetNearestCityOfPlayerToPlot(iX, iY, tPlayer, 1000):GetID())
			else
				local tPlayer = tab[LastRandom(1,#tab)];
				iPlot:SetOwner(tPlayer, GetNearestCityOfPlayerToPlot(iX, iY, tPlayer, 1000):GetID())
			end
		end
	end
end

function DoNoFreeManLandOnCont(i, bFull)
	local isAnyPlayer = false;
	local hTab = {}
	local sTab = {}
	for index, sth in pairs(TLSOT[i]) do
		local iPlot = Map.GetPlotByIndex(index)
		local minTab = {}
		if iPlot:GetOwner() == -1 then
			for j = -2, 2 do
				for y = -2, 2 do
					local jPlot = Map.GetPlot(iPlot:GetX() + j, iPlot:GetY() + y);
					if jPlot then
						if gT.Players[jPlot:GetOwner()] then
							if GetDBCulturePlayerInfo(jPlot:GetOwner(), "LandExpansion") then
								if not IsSpecialControlPlot(jPlot:GetPlotIndex(), true) then
									local dis = Map.PlotDistance(iPlot:GetX() + j, iPlot:GetY() + y, iPlot:GetX(), iPlot:GetY())
									for i = 1, 3 - dis do
										isAnyPlayer = true;
										table.insert(minTab, {jPlot:GetOwner(), jPlot:GetCityPurchaseID()})
									end			
								end
							end
						end
					end
				end
			end
		end
		if #minTab > 0 then
			table.insert(hTab, {iPlot, #minTab, minTab})
		else
			table.insert(sTab, iPlot)
		end
	end
	if not isAnyPlayer then
		return
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		if bFull or i <= #hTab / 2 then
			local luckyP = LastRandom(1,data[2]);
			data[1]:SetOwner(data[3][luckyP][1], data[3][luckyP][2]);
			local iCity = Players[data[3][luckyP][1]]:GetCityByID(data[3][luckyP][2]);
			if iCity then
				iCity:ChangeJONSCultureLevel(1)
			end
		end
	end
	if not bFull then
		DoNoFreeManLandOnCont(i, true)
	else
		--sTab (decided to be left for now?)
	end
end

function GetMapSizeDiameter()
	local x,y = Map.GetGridSize();
	return math.floor(math.pow(math.pow(x,2) + math.pow(y,2), 0.5))
end

function IsGoodyResource(hRes)
	if (Game.GetResourceUsageType(hRes) == ResourceUsageTypes.RESOURCEUSAGE_LUXURY) or gT.Globals.ResourcesInScenario[hRes] then
		return true;
	end
	if gT.CurrencyResources and gT.CurrencyResources[hRes] then
		return true;
	end
	return false;
end

function FindMostProperEmptyCont(majTab)
	local alSettledConts = {}
	for it, gplayer in pairs(majTab) do
		alSettledConts[GetContID(Map.GetPlotByIndex(gT.Players[gplayer].StartingPlot), 65643)] = 1;
	end
	local chosenCont, min = nil, 0;
	for contID, size in pairs(TLSCSize) do
		if not alSettledConts[contID] then
			if size > min then
				min = size;
				chosenCont = contID;
			end
		end
	end
	if chosenCont then
		gT.Globals.BadContIDs[chosenCont] = 1;
		gT.Globals.TreasuryCont = chosenCont;
	end
end

function FillWithResourceTreasuryCont()
	if not gT.Globals.TreasuryCont then
		return
	end
	local tTab = {}
	for index, meh in pairs(TLSOT[gT.Globals.TreasuryCont]) do
		local plot = Map.GetPlotByIndex(index)
		if plot:GetOwner() == -1 then
			if plot:GetResourceType() == -1 then
				if plot:GetImprovementType() == -1 then
					if not plot:IsMountain() then
						table.insert(tTab, plot)
					end
				end
			end
		end
	end
	tTab = Shuffle(tTab);
	for i, plot in pairs(tTab) do
		if i <= #tTab * 2/ 3 then
			GenerateBestResourceMaintainingBalance(plot, true, true)
		end
	end
end

function TerminateResourceFromPlot(iPlot)
	local iRes = iPlot:GetResourceType(-1);
	if iRes ~= -1 then
		local index = iPlot:GetPlotIndex();
		--ARCHAEOLOGY EXCEPTION
		if gT.ArchaeologyPlots and gT.ArchaeologyPlots[index] then
			DoTerminateArchaeologyFromPlot(iPlot, index);
		else
			if not gT.Globals.OriginalResource[index] then
				gT.Globals.OriginalResource[index] = iRes;
				gT.Globals.ResourceQuantity[index] = iPlot:GetNumResource();
			end
			iPlot:SetResourceType(-1);
			iPlot:SetNumResource(0);
			if ResourcesPresentOnMap and ResourcesPresentOnMap[iRes] then
				ResourcesPresentOnMap[iRes][index] = nil;
			end
			if (not gT.ExtraLuxuryResources[index]) or gT.Globals.HiddenResourcesFound then
				LogResourceForCurrency(iRes, -1)
			end
		end
	end
end

function ReadjustTempResNum(plot, amount)
	gT.Globals.ResourceQuantity[plot:GetPlotIndex()] = plot:GetNumResource();
	plot:SetNumResource(amount)
end

function AddProperlyResourceOnPlot(plot, restype, oneera, bHighlight, iAmount)
	local impro = plot:GetImprovementType();
	local bPill = plot:IsImprovementPillaged()
	local prevRes = plot:GetResourceType(-1)
	local prevAmount = plot:GetNumResource()
	plot:SetImprovementType(-1)
	plot:SetResourceType(restype)
	if iAmount then
		if iAmount < 1 and (restype ~= -1) then
			print("Incorrect usage of AddProperlyResource", restype, oneera, bHighlight, iAmount)
		end
		plot:SetNumResource(iAmount)
	elseif gT.Globals.ResNumReference[restype] then
		plot:SetNumResource(LastRandom(gT.Globals.ResNumReference[restype][1],gT.Globals.ResNumReference[restype][2]))
	else
		plot:SetNumResource(1)
	end
	if ResourcesPresentOnMap and (restype ~= -1) then
		if not ResourcesPresentOnMap[restype] then
			ResourcesPresentOnMap[restype] = {}
		end
		ResourcesPresentOnMap[restype][plot:GetPlotIndex()] = 1;
	end
	plot:SetImprovementType(impro, -1)
	plot:SetImprovementPillaged(bPill)
	if oneera then
		gT.Globals.OriginalResource[plot:GetPlotIndex()] = prevRes;
		gT.Globals.ResourceQuantity[plot:GetPlotIndex()] = prevAmount;
	end
	if restype ~= -1 then
		LogResourceForCurrency(restype, 1) -- Currency resources should not be added in greater amount
	end
	if bHighlight then	
		if plot:IsVisible(Game.GetActiveTeam()) then
			local hex = ToHexFromGrid(Vector2(plot:GetX(),plot:GetY()));
			Events.GameplayFX(hex.x, hex.y, -1)
		end
	end
end

function ShouldBecomeNomadicBasedOnStart(iPlayer)
	local iPlot = Players[iPlayer]:GetStartingPlot();
	local dis = 2;
	local totalhorses = 0;
	for i, nPlot in pairs(GetPlotsInRadiusOfPlot(iPlot, 2)) do
		if nPlot:GetResourceType() == rHorse then
			totalhorses = totalhorses + 1;
		end
	end
	return (LastRandom(1,2) <= totalhorses)
end

function GetSizeOfOceanAdjacentToPlot(iPlot)
	local tSize = 0;
	for i = 0, 5 do
		local nPlot = Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), i);
		if nPlot and nPlot:IsWater() then
			tSize = math.max(tSize, GetSizeOfOceanOnPlot(nPlot));
		end
	end
	return tSize;
end

function ShouldBecomeNordicBasedOnStart(iPlayer)
	local iPlot = Players[iPlayer]:GetStartingPlot();
	local tSize = GetSizeOfOceanAdjacentToPlot(iPlot)
	if tSize > 60 then
		if tSize > 250 then
			return true;
		end
		local best = 0;
		for i, t in pairs(TOceanSize) do
			best = math.max(best, t);
		end
		if tSize > best / 2 then
			return true;
		end
	end
	return false;
end

function RevealTerrainInRadius(iTeam, iPlot, rad)
	for ix = -rad, rad do
		for iy = -rad, rad do
			local nPlot = Map.PlotXYWithRangeCheck(iPlot:GetX(), iPlot:GetY(), ix, iy, rad)
			if nPlot then
				nPlot:SetRevealed(iTeam, true);
			end
		end	
	end
end

function DoSnowflakeReveal(iTeam, iPlot, rad, radT)
	for ix = -rad, rad do
		for iy = -rad, rad do
			local nPlot = Map.GetPlot(iPlot:GetX() + ix, iPlot:GetY() + iy);
			if nPlot then
				local iDis = Map.PlotDistance(iPlot:GetX(), iPlot:GetY(), nPlot:GetX(), nPlot:GetY());
				if radT[iDis] and LastChance(radT[iDis]) then
					nPlot:SetRevealed(iTeam, true);
				end
			end
		end
	end
end

function HasRiverBetweenPlots(iPlot, nPlot, i)
	if i == 0 then
		return nPlot:IsNEOfRiver()
	elseif i == 1 then
		return nPlot:IsWOfRiver()
	elseif i == 2 then
		return iPlot:IsNWOfRiver()
	elseif i == 3 then
		return iPlot:IsNEOfRiver()
	elseif i == 4 then
		return iPlot:IsWOfRiver()
	elseif i == 5 then
		return nPlot:IsNWOfRiver()
	end
	print("Incorrectly used function 5423452341", i)
	return false;
end

function BasicCoastCanalConnect(ocean1, ocean2, change)
	TRbasicCoastsConnect[ocean1][ocean2] = (TRbasicCoastsConnect[ocean1][ocean2] or 0) + change;
	TRbasicCoastsConnect[ocean2][ocean1] = (TRbasicCoastsConnect[ocean2][ocean1] or 0) + change;
end
function OceanCoastCanalConnect(ocean1, ocean2, change)
	TRoceanCoastsConnect[ocean1][ocean2] = (TRoceanCoastsConnect[ocean1][ocean2] or 0) + change;
	TRoceanCoastsConnect[ocean2][ocean1] = (TRoceanCoastsConnect[ocean2][ocean1] or 0) + change;
	ResetOceanAIType(ocean1)
	ResetOceanAIType(ocean2)
end

local aVcOrN = {}
function GetAllConnectedAquens(oceanID, bOcean)
	aVcOrN = {}
	IterateConnectedCanals(oceanID, bOcean)
	return aVcOrN;
end

function IterateConnectedCanals(oceanID, bOcean)
	aVcOrN[oceanID] = true;
	if bOcean then
		for sOcean, val in pairs(TRoceanCoastsConnect[oceanID]) do
			if (val > 0) and (not aVcOrN[sOcean]) then
				IterateConnectedCanals(sOcean, bOcean)
			end
		end
	else
		for sOcean, val in pairs(TRbasicCoastsConnect[oceanID]) do
			if (val > 0) and (not aVcOrN[sOcean]) then
				IterateConnectedCanals(sOcean, bOcean)
			end
		end
	end
end

function GetNumAdjacentMountains(iPlot)
	local iC = 0;
	for j = 0, 5 do
		local nPlot = Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), j)
		if nPlot and nPlot:IsMountain() then
			iC = iC + 1;
		end
	end
	return iC;
end

function GetRevealedCoastalCitiesPercent(iPlayer)
	local iTeam = Players[iPlayer]:GetTeam();
	local tt, cc = 0, 0;
	for g, h in pairs(gT.Players) do
		for iCity in Players[g]:Cities() do
			if iCity:Plot():IsRevealed(iTeam) then
				tt = tt + 1;
				if iCity:IsCoastal() then
					cc = cc + 1;
				end
			end
		end
	end
	if tt == 0 then
		return 0;
	end
	return math.floor(cc * 100 / tt);
end