local validTurnsforCQueue = {[16] = 1,[33] = 1,[50] =1,[67] = 1}
local uWorkboat = GameInfoTypes.UNIT_WORKBOAT;

function RestoreAIFlavours(tab)
	for i, g in pairs(tab) do
		RestoredAIFlavours(g)
	end
end

function RestoredAIFlavours(iPlayer)
	if tempconvinit and tempconvinit[iPlayer] then 
		if tempconvinit[iPlayer].AIStrategyValues then
			gT.Players[iPlayer].AIStrategyValues = {}
			gT.Players[iPlayer].AISocDevPerfection = tempconvinit[iPlayer].AISocDevPerfection
			for a, b in pairs(tempconvinit[iPlayer].AIStrategyValues) do
				gT.Players[iPlayer].AIStrategyValues[a] = b;
			end
			return true;
		end
	end
	return false;
end

function GenerateBaseAIFlavourValues(iPlayer)
	if not gT.Players[iPlayer].AIStrategyValues then
		if not RestoredAIFlavours(iPlayer) then
			gT.Players[iPlayer].AIStrategyValues = {}
			gT.Players[iPlayer].AISocDevPerfection = 20 + 5 * LastRandom(0,16);
			local lbyc, anarchyc, workc = 1, 1, 1;
			if GetAIFlavour(iPlayer, "FLAVOR_FOOD") >= 8 then
				lbyc = lbyc + 1;
				workc = workc + 1;
			end
			if GetAIFlavour(iPlayer, "FLAVOR_GOLD") >= 8 then
				lbyc = lbyc + 1;
				workc = workc + 1;
				anarchyc = anarchyc + 1;
			end
			if GetAIFlavour(iPlayer, "FLAVOR_PRODUCTION") >= 8 then
				lbyc = lbyc + 1;
				anarchyc = anarchyc + 1;
			end
			if GetAIFlavour(iPlayer, "FLAVOR_CULTURE") >= 8 then
				lbyc = lbyc + 1;
			end
			if GetAIFlavour(iPlayer, "FLAVOR_SCIENCE") >= 8 then
				lbyc = lbyc + 1;
				anarchyc = anarchyc + 1;
			end
			if GetAIFlavour(iPlayer, "FLAVOR_INFRASTRUCTURE") >= 8 then
				workc = workc + 3;
			end
			gT.Players[iPlayer].AIStrategyValues.LikeBasicYields = lbyc <= LastRandom(1, 10);
			gT.Players[iPlayer].AIStrategyValues.AfraidOfAnarchy = anarchyc <= LastRandom(1, 10);
			gT.Players[iPlayer].AIStrategyValues.WorkRate = workc <= LastRandom(1, 10);
			if gT.Players[iPlayer].AIStrategyValues.LikeBasicYields then
				gT.Players[iPlayer].AIStrategyValues.EnjoyRandom = 3 == LastRandom(1, 10)
			else
				gT.Players[iPlayer].AIStrategyValues.EnjoyRandom = 3 == LastRandom(1, 3)
			end
			if LastRandom(1, 3) == 3 then
				local tabOfOptions = {}
				table.insert(tabOfOptions, {1, 1}) -- Total Random Strategy;
				table.insert(tabOfOptions, {2, 3}) -- Stack Festival Bonuses;
				table.insert(tabOfOptions, {3, 1}) -- Stack Happiness Bonuses;
				table.insert(tabOfOptions, {4, 2}) -- Stack Great People Bonuses;
				table.insert(tabOfOptions, {5, 1}) -- Stack General Admiral Bonuses;
				table.insert(tabOfOptions, {6, 4}) -- Stack Trade Bonuses;
				table.insert(tabOfOptions, {7, 1}) -- Stack Cheesy Military Bonuses;
				table.insert(tabOfOptions, {8, 4}) -- Stack Basic Military Bonuses;
				table.insert(tabOfOptions, {9, 2}) -- Stack Production Bonuses;
					table.insert(tabOfOptions, {10, 2}) -- Ultra Boring Four;
				table.insert(tabOfOptions, {11, 2}) -- Mobility Exploration ;
				table.insert(tabOfOptions, {12, 3}) -- Legal Bonuses;
				table.insert(tabOfOptions, {13, 3}) -- Military Economic;
				table.insert(tabOfOptions, {14, 3}) -- Governors;
				table.insert(tabOfOptions, {15, 3}) -- Spread Presence;
				gT.Players[iPlayer].AIStrategyValues.GrandStrategy = GetRandomFromBiasedChanceTable(tabOfOptions)
			else
				gT.Players[iPlayer].AIStrategyValues.GrandStrategy = 0;
			end
		end
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 1 then
		return;
	end

	gT.Players[iPlayer].AIFlavourValues = {}
	local gTurn = GetITGGameTurn()
	gT.Players[iPlayer].AIFlavourValues.Early = false;
	gT.Players[iPlayer].AIFlavourValues.Late = false;
	if gTurn < 20 then
		gT.Players[iPlayer].AIFlavourValues.Early = true;
	elseif gTurn > 60 then
		gT.Players[iPlayer].AIFlavourValues.Late = true;
	end

	gT.Players[iPlayer].AIFlavourValues.CultureGroupMembers = 0;
	for i, p in pairs(gT.Players) do
		if p.CultureType == gT.Players[iPlayer].CultureType then
			if (i == iPlayer) or Teams[Players[iPlayer]:GetTeam()]:IsHasMet(Players[i]:GetTeam()) then
				gT.Players[iPlayer].AIFlavourValues.CultureGroupMembers = gT.Players[iPlayer].AIFlavourValues.CultureGroupMembers + 1;
			end
		end
	end

	gT.Players[iPlayer].AIFlavourValues.NumAlliedCS = GetNumAlliedCS(iPlayer);
	gT.Players[iPlayer].AIFlavourValues.NumMetCS = GetNumMetCS(iPlayer);

	gT.Players[iPlayer].AIFlavourValues.TradeRoutesForeign = 0;
	gT.Players[iPlayer].AIFlavourValues.NavalTradeRoutes = 0;
	gT.Players[iPlayer].AIFlavourValues.TRSuccess = 0;
	gT.Players[iPlayer].AIFlavourValues.TRCS = 0
	gT.Players[iPlayer].AIFlavourValues.TRkilled = 0;
	for i, data in pairs(gT.Globals.TradeRouteLog) do
		if (data.FromPlayer == iPlayer) and (not data.Pilgrim) then
			if data.Killed then
				gT.Players[iPlayer].AIFlavourValues.TRkilled = gT.Players[iPlayer].AIFlavourValues.TRkilled + 1;
			else
				if data.ToPlayer and Players[data.ToPlayer]:IsMinorCiv() then
					gT.Players[iPlayer].AIFlavourValues.TRCS = gT.Players[iPlayer].AIFlavourValues.TRCS + 1;
				end
				gT.Players[iPlayer].AIFlavourValues.TRSuccess = gT.Players[iPlayer].AIFlavourValues.TRSuccess + 1;
				if data.DomainType == 2 then
					gT.Players[iPlayer].AIFlavourValues.NavalTradeRoutes = gT.Players[iPlayer].AIFlavourValues.NavalTradeRoutes + 1;
				end
			end
		elseif data.ToPlayer == iPlayer then
			if (not data.Pilgrim) then
				gT.Players[iPlayer].AIFlavourValues.TradeRoutesForeign = gT.Players[iPlayer].AIFlavourValues.TradeRoutesForeign + 1;
			end
		end
	end
	local divider = math.max(1, GetITGGameTurn());
	gT.Players[iPlayer].AIFlavourValues.TradeRoutesPT = (gT.Players[iPlayer].AIFlavourValues.TRkilled + gT.Players[iPlayer].AIFlavourValues.TRSuccess) / divider
	gT.Players[iPlayer].AIFlavourValues.GPmigrateToPT = gT.Players[iPlayer].GPMigratedTo / divider
	gT.Players[iPlayer].AIFlavourValues.GPmigrateAwayPT = gT.Players[iPlayer].GPMigratedAway / divider
	gT.Players[iPlayer].AIFlavourValues.GeneralPointsPT = GetGeneratedGeneralPoints(iPlayer) / divider
	gT.Players[iPlayer].AIFlavourValues.AdmiralPointsPT = GetGeneratedAdmiralPoints(iPlayer) / divider
	gT.Players[iPlayer].AIFlavourValues.FestivalPT = gT.Players[iPlayer].NumFestivalsStarted / divider
	gT.Players[iPlayer].AIFlavourValues.UnitsKilledPT = gT.Players[iPlayer].UnitKilled / divider;
	gT.Players[iPlayer].AIFlavourValues.UnitsLostPT = gT.Players[iPlayer].UnitLost / divider;
	gT.Players[iPlayer].AIFlavourValues.AverageHappinessEmpire = math.floor(0.5 + 100 * gT.Players[iPlayer].LHAverageHappiness / gT.Players[iPlayer].AverageHappinessCounted )/100
	gT.Players[iPlayer].AIFlavourValues.CoastCitiesPerc = GetRevealedCoastalCitiesPercent(iPlayer)
	gT.Players[iPlayer].AIFlavourValues.MaxTrainedUnitsPT = 0;
	local numCitiesdiv = math.max(1, Players[iPlayer]:GetNumCities());
	local numRiots = 0;
	local numDBriots = 0;
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		numRiots = numRiots + gT.Cities[cID].RiotsEnter;
		numDBriots = numDBriots	+ gT.Cities[cID].RiotsBuildingDestroyed
		gT.Players[iPlayer].AIFlavourValues.MaxTrainedUnitsPT = math.max(gT.Players[iPlayer].AIFlavourValues.MaxTrainedUnitsPT, GetITGCityInteger(iCity, "CI_LH_TRAINED_UNITS"))
	end
	gT.Players[iPlayer].AIFlavourValues.MaxTrainedUnitsPT = gT.Players[iPlayer].AIFlavourValues.MaxTrainedUnitsPT / divider
	
	gT.Players[iPlayer].AIFlavourValues.RiotsPerCityPT = numRiots / divider
	gT.Players[iPlayer].AIFlavourValues.BuildingsDestroyed = numDBriots

	gT.Players[iPlayer].AIFlavourValues.UnitCombatsCount = {}
	gT.Players[iPlayer].AIFlavourValues.NumMilitaryUnits = 0;
	
	local artPperGW = gT.Globals.BaseArtCost * GetModifierToBaseGWCostOfArt(iPlayer)
	local projArtp = gT.Players[iPlayer].GreatArtistPoints / math.max(1,(GetITGGameTurn() % 20))
	gT.Players[iPlayer].AIFlavourValues.GWnextTime = math.floor(projArtp/artPperGW)

	gT.Players[iPlayer].AIFlavourValues.FeelsSafe = (not IsDuringMeaningfulWar(iPlayer))
	
	for iUnit in Players[iPlayer]:Units() do
		if gT.Players[iPlayer].UnitClassXP[iUnit:GetUnitClassType()] then
			gT.Players[iPlayer].AIFlavourValues.UnitCombatsCount[iUnit:GetUnitCombatType()] = (gT.Players[iPlayer].AIFlavourValues.UnitCombatsCount[iUnit:GetUnitCombatType()] or 0) + 1;
			gT.Players[iPlayer].AIFlavourValues.NumMilitaryUnits = gT.Players[iPlayer].AIFlavourValues.NumMilitaryUnits	 + 1;
		end
	end
	gT.Players[iPlayer].AIFlavourValues.SciencePTtoNextTreshold = GetITGSciencePerTurn(iPlayer, true) / NiceCostOfTechOrPolicy(iPlayer, GetDBCulturePlayerInfo(iPlayer, "BaseTechCost"), gT.Players[iPlayer].ScienceBonusAdopted, 1, nil, "hadsxre")
	--end of new flavours
end


local GetAIValueForCultureBonusTable = {
[1] = function(iPlayer, bHasAlready) local base = 0;
	if gT.Players[iPlayer].AIStrategyValues.WorkRate then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_HAPPINESS") >= 7 then
		base = base + 1;
	end
	if Players[iPlayer]:GetNumCities() > 4 then
		base = base + 1;
	end
	if not gT.Players[iPlayer].AIStrategyValues.LikeBasicYields then
		base = base + 1;
	end
	base = base + LastRandom(0, 1)
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 3 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[2] = function(iPlayer, bHasAlready) local base = 0;
	if gT.Players[iPlayer].AIStrategyValues.WorkRate then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_INFRASTRUCTURE") >= 7 then
		base = base + 1;
	end
	if bHasAlready or gT.Players[iPlayer].AIFlavourValues.Early then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.LikeBasicYields then
		base = base + 1;
	end
	if Players[iPlayer]:GetNumCities() > 4 then
		base = base + 1;
	end
	return math.min(5, base)
end,
[3] = function(iPlayer, bHasAlready) local base = 0;
	if Players[iPlayer]:GetNumCities() > 4 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_DEFENSE") >= 8 then
		base = base + 1;
	end
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		if gT.Cities[cID].NumAttackesEverMade >= 5 then
			base = base + 1;
			break;
		end
	end
	if GetAIFlavour(iPlayer, "FLAVOR_GOLD") >= 8 then
		base = base + 1;
	end
	if Players[iPlayer]:GetGold() > 600 then
		base = base + 1;
	else
		local gsipt = gT.Players[iPlayer].TotalGoldSpendInternally / math.max(1, GetITGGameTurn()) * 100;
		if gsipt > 1000 then
			base = base + 1;
		end
	end
	if bHasAlready then
		base = base + 1;
	end
	return math.min(5, base)
end,
[4] = function(iPlayer, bHasAlready) local base = 0;
	if Players[iPlayer]:GetNumCities() > 4 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.TRkilled > 3 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.TradeRoutesPT >= 0.4 then
		base = base + 1;
	end
	if bHasAlready or Teams[Players[iPlayer]:GetTeam()]:GetAtWarCount(false) > 1 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIhateValues[63] >= 10 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 6 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[5] = function(iPlayer, bHasAlready) local base = 0;
	if GetAIFlavour(iPlayer, "FLAVOR_ESPIONAGE") >= 8 then
		base = base + 1;
	end
	if bHasAlready or (gT.Players[iPlayer].AIFlavourValues.Early) then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.LikeBasicYields and (not gT.Players[iPlayer].AIStrategyValues.EnjoyRandom) then
		base = base + 1;
	end
	local numSpies = 0;
	for i, data in pairs(gT.Players[iPlayer].Agents) do
		if (not data.IgnoreItForever) then 
			if data.IsAlive then
				numSpies = numSpies + 1;
			end
		end
	end
	if numSpies >= 3 then
		base = base + 1;
	end
	if Players[iPlayer]:GetNumCities() > 5 then
		base = base + 1;
	end
	return math.min(5, base)
end,
[6] = function(iPlayer, bHasAlready) local base = 0;
	if Players[iPlayer]:GetBuildingClassCount(GameInfoTypes.BUILDINGCLASS_LIBRARY) >= 1 then
		base = base + 1;
	end
	if Players[iPlayer]:GetBuildingClassCount(GameInfoTypes.BUILDINGCLASS_UNIVERSITY) >= 1 then
		base = base + 1;
	end
	local cac = GetNumActiveAcademies(iPlayer)
	if cac > 2 then
		base = base + 2;
	elseif cac > 0 then
		base = base + 1;
	end
	if gT.Players[iPlayer].FestivalBonusesActive[3] or gT.Players[iPlayer].FestivalBonusesActive[4] or gT.Players[iPlayer].FestivalBonusesActive[2] then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 2 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[7] = function(iPlayer, bHasAlready) local base = 0;
	if GetAIFlavour(iPlayer, "FLAVOR_MOBILE") >= 8 then
		base = base + 2;
	end
	local min = 2;
	if bHasAlready then
		min = 4;
	end
	if Players[iPlayer]:GetNumStrategicResourceAvailable(rHorse, true) <= min then
		base = base + 1;
	end
	if (gT.Players[iPlayer].AIFlavourValues.UnitCombatsCount[GameInfoTypes.UNITCOMBAT_MOUNTED] or 0) > 4 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.GeneralPointsPT >= 20 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 8 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[8] = function(iPlayer, bHasAlready) local base = 0;
	if gT.Players[iPlayer].Goverment == 3 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_HAPPINESS") >= 7 then
		base = base + 1;
	end
	if Players[iPlayer]:GetNumCities() > 4 then
		base = base + 1;
	end
	local numshots = 0;
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		numshots = numshots + gT.Cities[cID].NumAttackesEverMade
	end
	if numshots / math.max(1, GetITGGameTurn()) >= 0.4 then
		base = base + 2;
	end
	return math.min(5, base)
end,
[9] = function(iPlayer, bHasAlready) local base = 0;
	if Players[iPlayer]:GetNumCities() > 7 then
		base = base + 2;
	elseif Players[iPlayer]:GetNumCities() > 3 then
		base = base + 1;
	end
	if bHasAlready or (gT.Players[iPlayer].AIFlavourValues.TRkilled < 5) then
		base = base + 1;
	end
	if Players[iPlayer]:GetBuildingClassCount(GameInfoTypes.BUILDINGCLASS_LIGHTHOUSE) >= 3 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.LikeBasicYields then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 6 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[10] = function(iPlayer, bHasAlready) local base = 0;
	if Players[iPlayer]:GetBuildingClassCount(GameInfoTypes.BUILDINGCLASS_TEMPLE) >= 3 then
		base = base + 1; -- leave it as "faith" -> pilgrimage
	end
	if Players[iPlayer]:GetNumCities() > 6 then
		base = base + 2;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_PRODUCTION") >= 7 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.LikeBasicYields then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 9 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[11] = function(iPlayer, bHasAlready) local base = 0;
	if GetAIFlavour(iPlayer, "FLAVOR_GOLD") > 5 then
		base = base + 1;
	end
	if GetNumActiveGovernors(iPlayer) > 1 then
		base = base + 1;
	end
	if Players[iPlayer]:GetNumCities() > 5 then
		base = base + 1;
	end
	if Players[iPlayer]:GetCityConnectionGoldTimes100() / 100 - GetDBCulturePlayerInfo(iPlayer, "UnmoddedCityConnection") > 0 then
		base = base + 2;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 14 then
		return math.max(5, base + 1)
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 10 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[12] = function(iPlayer, bHasAlready) local base = 0;
	if gT.Players[iPlayer].AIFlavourValues.UnitsLostPT >= 0.5 then
		base = base + 2;
	end
	if gT.Players[iPlayer].AIFlavourValues.NumMilitaryUnits >= 18 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_OFFENSE") >= 7 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_CULTURE") >= 7 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 7 then
		return math.max(5, base + 1)
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 13 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[13] = function(iPlayer, bHasAlready) local base = 0;
	if Players[iPlayer]:GetNumCities() < 4 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.FestivalPT >= 0.08 then
		base = base + 1;
	end
	if bHasAlready or gT.Players[iPlayer].AIFlavourValues.Early then
		base = base + 1;
	end
	if gT.Players[iPlayer].FestivalBonusesActive[3] then
		base = base + 1;
	end
	if gT.Players[iPlayer].FestivalBonusesActive[4] then
		base = base + 1;
	end
	if gT.Players[iPlayer].FestivalBonusesActive[2] then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 2 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[14] = function(iPlayer, bHasAlready) local base = 0;
	if GetAIFlavour(iPlayer, "FLAVOR_OFFENSE") >= 6 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_CULTURE") >= 7 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_RANGED") >= 8 then
		base = base + 2;
	end
	if bHasAlready or (gT.Players[iPlayer].AIFlavourValues.UnitCombatsCount[GameInfoTypes.UNITCOMBAT_ARCHER] or 0) > 5 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.EnjoyRandom then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 7 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[15] = function(iPlayer, bHasAlready) local base = 0;
	if GetAIFlavour(iPlayer, "FLAVOR_PRODUCTION") >= 8 then
		base = base + 1;
	end
	if Players[iPlayer]:GetNumCities() > 6 then
		base = base + 2;
	elseif Players[iPlayer]:GetNumCities() > 3 then
		base = base + 1;
	end
	local cCity = Players[iPlayer]:GetCapitalCity();
	if cCity and (cCity:GetPopulation() >= 10) then
		base = base + 1;
	end
	if bHasAlready or gT.Players[iPlayer].AIFlavourValues.Early then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 9 then
		return math.max(5, base + 1)
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 10 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[16] = function(iPlayer, bHasAlready) local base = 0;
	if GetAIFlavour(iPlayer, "FLAVOR_RELIGION") >= 7 then
		base = base + 1;
	end
	if Players[iPlayer]:GetNumCities() > 6 then
		base = base + 2;
	elseif Players[iPlayer]:GetNumCities() > 3 then
		base = base + 1;
	end
	if not gT.Players[iPlayer].OfficialReligion then
		if Players[iPlayer]:GetReligionCreatedByPlayer() > 0 then
			base = base + 1;
		end
	else
		local tother = 0;
		for iCity in Players[iPlayer]:Cities() do
			tother = tother + GetCityModifierFromHeresy(iCity);
		end
		if tother >= 2 then
			base = base + 1;
		end
	end
	if gT.Players[iPlayer].AIStrategyValues.EnjoyRandom then
		base = base + 1;
	end
	return math.min(5, base)
end,
[17] = function(iPlayer, bHasAlready) local base = 0;
	if GetAIFlavour(iPlayer, "FLAVOR_CULTURE") >= 7 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_OFFENSE") < 5 then
		base = base + 1;
	end
	if not gT.Players[iPlayer].AIStrategyValues.EnjoyRandom then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.LikeBasicYields then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_DISRUPTIVE") >= 7 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 15 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[18] = function(iPlayer, bHasAlready) local base = 0;
	if GetAIFlavour(iPlayer, "FLAVOR_DEFENSE") >= 8 then
		base = base + 1;
	end
	if not gT.Players[iPlayer].AIFlavourValues.Late then
		base = base + 1;
	end
	base = base + math.floor(GetNumSpecialControlPoint(iPlayer, "Forts", true) / 2)
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 8 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[19] = function(iPlayer, bHasAlready) local base = 0;
	if gT.Players[iPlayer].AIStrategyValues.EnjoyRandom then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_ESPIONAGE") >= 8 then
		base = base + 1;
	end
	local nad = 0;
	for i, b in pairs(gT.Players[iPlayer].EspionageLog) do
		if b[3] == 6 then
			nad = nad + 1;
		end
	end
	base = base + math.floor(nad / 3);
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 12 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[20] = function(iPlayer, bHasAlready) local base = 0;
	if GetAIFlavour(iPlayer, "FLAVOR_DEFENSE") >= 8 then
		base = base + 1;
	end
	if Players[iPlayer]:GetNumCities() > 7 then
		base = base + 1;
	end
	if #gT.Players[iPlayer].NumWarsDeclaredOn > 0 then
		if #gT.Players[iPlayer].NumWarsDeclaredOn > 3 then
			base = base + 2;
		else
			base = base + 1
		end
	end
	if Players[iPlayer]:GetTotalLand() > 125 then
		base = base + 1;
	end
	return math.min(5, base)
end,
[21] = function(iPlayer, bHasAlready) local base = 0;
	local nga = 0;
	local bDead = false;
	for gpID, hhh in pairs(gT.Players[iPlayer].GreatPeople) do
		local gd = gT.GreatPeople[gpID];
		if gd.Military then
			if gd.Alive then
				nga = nga + 1;
			elseif not gd.Assassinated then
				bDead = true
			end
		end
	end
	if nga > 3 then
		base = base + 1;
		if nga > 6 then
			base = base + 1;
		end
		if GetAIFlavour(iPlayer, "FLAVOR_MILITARY_TRAINING") >= 8 then
			base = base + 1;
		end
		if #gT.Players[iPlayer].NumWarsDeclared > 0 then
			base = base + 1;
		end
		if bDead then
			base = base + 1;
		end
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 5 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[22] = function(iPlayer, bHasAlready) local base = 0;
	if GetAIFlavour(iPlayer, "FLAVOR_SCIENCE") >= 7 then
		base = base + 2;
	end
	if gT.Players[iPlayer].AIFlavourValues.Early or (bHasAlready) then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.SciencePTtoNextTreshold > 0.1 then
		base = base + 1;
	end
	if Players[iPlayer]:GetNumCities() < 6 then
		base = base + 1;
	end
	return math.min(5, base)
end,
[23] = function(iPlayer, bHasAlready) local base = 0;
	if GetAIFlavour(iPlayer, "FLAVOR_WONDER") >= 8 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_CULTURE") >= 8 then
		base = base + 1;
	end
	if gT.Players[iPlayer].NumWondersBuild > 0 then
		base = base + 1;
	end
	if gT.Players[iPlayer].CanWonderRace then
		base = base + 1;
	end
	if Players[iPlayer]:GetNumCities() > 3 then
		base = base + 1;
	end
	return math.min(5, base)
end,
[24] = function(iPlayer, bHasAlready) local base = 0;
	if GetAIFlavour(iPlayer, "FLAVOR_DISRUPTIVE") >= 7 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_CULTURE") >= 7 then
		base = base + 1;
	end
	if (gT.Players[iPlayer].AISettlerPointsManagement) and (gT.Players[iPlayer].AISettlerPointsManagement.Type ~= 1 ) then
		base = base + 1;
	end
	for a, b in pairs(gT.Players[iPlayer].SettlerLog) do
		if b[1] == 1 or b[1] == 2 then
			base = base + 1;
			break;
		end
	end
	if bHasAlready or LastChance(50) then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 15 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[25] = function(iPlayer, bHasAlready) local base = 0;
	for iCity in Players[iPlayer]:Cities() do
		base = base + GetCityCult25Mod(iPlayer, iCity, true) / 10;
	end
	return math.min(5, base)
end,
[26] = function(iPlayer, bHasAlready) local base = 0;
	if gT.Globals.ScenarioType ~= 3 then
		return 0;
	end
	local numunits = 0;
	for iUnit in Players[iPlayer]:Units() do
		if iUnit:GetUnitClassType() == BASE_INFANTRY_CLASS then
			numunits = numunits + 1;
		end
	end
	base = base + math.floor(numunits / 5);
	if Players[iPlayer]:GetNumCities() > 4 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 8 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[27] = function(iPlayer, bHasAlready) local base = 0;
	for govID, h in pairs(gT.Players[iPlayer].Governors) do
		base = base + 1;
	end
	if gT.Players[iPlayer].MeritocracyLevel < 50 then
		base = base + 1;
	end
	if (gT.Players[iPlayer].MerZeroT or 0) > 2 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 9 then
		return math.max(5, base + 1)
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 12 then
		return math.max(5, base + 1)
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 14 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[28] = function(iPlayer, bHasAlready) local base = 0;
	if gT.Players[iPlayer].AIStrategyValues.LikeBasicYields then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.UnitsKilledPT > 0.4 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_GOLD") >= 8 then
		base = base + 1;
	end
	if bHasAlready or Teams[Players[iPlayer]:GetTeam()]:GetAtWarCount(false) > 1 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.NumMilitaryUnits >= 15 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 13 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[29] = function(iPlayer, bHasAlready) local base = 0;
	if gT.Players[iPlayer].AIFlavourValues.RiotsPerCityPT >= 0.05 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.BuildingsDestroyed > 3 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_PRODUCTION") >= 8 then
		base = base + 1;
	end
	if Players[iPlayer]:GetNumCities() > 4 then
		base = base + 1;
	end
	if not gT.Players[iPlayer].AIStrategyValues.EnjoyRandom then
		base = base + 1;
	end
	return math.min(5, base)
end,
[30] = function(iPlayer, bHasAlready) local base = 0;
	if Players[iPlayer]:GetUnitClassCountPlusMaking(GameInfoTypes.UNITCLASS_WORKBOAT) >= 2 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_NAVAL") >= 7 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_RECON") >= 7 then
		base = base + 1;
	end
	base = base + math.min(2, GetNumOfGPCivilOfType(iPlayer, 2));
	return math.min(5, base)
end,
[31] = function(iPlayer, bHasAlready) local base = 0;
	local maxPledges = math.max(1, gT.Players[iPlayer].NumMaxPledges)
	if maxPledges <= #gT.Players[iPlayer].PledgesOfProtection then
		if bHasAlready then
			return 5;
		end
		base = base + 2;
	end
	if #gT.Players[iPlayer].PledgesOfProtection > 0 then
		if #gT.Players[iPlayer].NumWarsDeclaredOn > 0 then
			base = base + 1;
		end
		for i, b in pairs(gT.Players[iPlayer].PledgesOfProtection) do
			if Players[b[1]]:GetMinorCivFriendshipWithMajor(iPlayer) <= 50 then
				base = base + 1;
				break;
			end
		end
		if gT.Players[iPlayer].AIFlavourValues.NumAlliedCS > 2 then
			base = base + 1;
		end
	end
	return math.min(5, base)
end,
[32] = function(iPlayer, bHasAlready) local base = 0;
	local perInsp = math.max(0.3, 0.3 + GetAIFlavour(iPlayer, "CULTURE"));
	for bClass, iT in pairs(gT.Players[iPlayer].Inspirations) do
		base = base + perInsp;
	end
	base = math.floor(base);
	return math.min(5, base)
end,
[33] = function(iPlayer, bHasAlready) local base = 0;
	if GetAIFlavour(iPlayer, "FLAVOR_MILITARY_TRAINING") >= 7 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.NumMilitaryUnits >= 12 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.GeneralPointsPT >= 20 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.LikeBasicYields then
		base = base + 1;
	end
	if bHasAlready or gT.Players[iPlayer].AIFlavourValues.Early then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 8 then
		return math.max(5, base + 1)
	end

	return math.min(5, base)
end,
[34] = function(iPlayer, bHasAlready) local base = 0;
	local plundered = (gT.Players[iPlayer].KilledCivilians["Caravan"] or 0) + (gT.Players[iPlayer].KilledCivilians["Cargo Ship"] or 0)
	base = math.ceil(plundered / math.max(GetITGGameTurn(), 1) * 25)
	return math.min(5, base)
end,
[35] = function(iPlayer, bHasAlready) local base = 0;
	if gT.Players[iPlayer].AIStrategyValues.LikeBasicYields then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_RELIGION") >= 7 then
		base = base + 1;
	end
	if Players[iPlayer]:GetNumCities() >= 8 then
		base = base + 2;
	elseif Players[iPlayer]:GetNumCities() >= 4 then
		base = base + 1;
	end
	if not gT.Players[iPlayer].AIFlavourValues.Late then
		base = base + 1;
	end
	return math.min(5, base)
end,
[36] = function(iPlayer, bHasAlready) local base = 0;
	if gT.Players[iPlayer].AIStrategyValues.LikeBasicYields then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_HAPPINESS") >= 7 then
		base = base + 1;
	end
	if Players[iPlayer]:GetNumCities() >= 8 then
		base = base + 2;
	elseif Players[iPlayer]:GetNumCities() >= 4 then
		base = base + 1;
	end
	if gT.Players[iPlayer].OfficialReligion then
		base = base + 1;
	end
	return math.min(5, base)
end,
[37] = function(iPlayer, bHasAlready) local base = 0;
	if gT.Players[iPlayer].AIStrategyValues.LikeBasicYields then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.UnitsKilledPT > 0.4 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_RELIGION") >= 8 then
		base = base + 1;
	end
	if bHasAlready or Teams[Players[iPlayer]:GetTeam()]:GetAtWarCount(false) > 1 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.NumMilitaryUnits >= 15 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 13 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[38] = function(iPlayer, bHasAlready) local base = 0;
	if Players[iPlayer]:GetNumCities() > 3 then
		base = base + 1;
	end
	if not gT.Players[iPlayer].AIPalaceBlock then
		base = base + 1;
	end
	if gT.Players[iPlayer].LHNumPalaceUpgrades > 4 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.AfraidOfAnarchy then
		base = base + 1;
	end
	if bHasAlready or gT.Players[iPlayer].AIFlavourValues.FeelsSafe then
		base = base + 1;
	end
	return math.min(5, base)
end,
[39] = function(iPlayer, bHasAlready) local base = 0;
	local nc = 0;
	for iCity in Players[iPlayer]:Cities() do
		if not iCity:IsCapital() then
			if Players[iPlayer]:IsCapitalConnectedToCity(iCity) then
				nc = nc + 1;
			end
		end
	end
	if GetAIFlavour(iPlayer, "FLAVOR_HAPPINESS") >= 8 then
		base = base + math.floor(nc * 5 / 8);
	elseif GetAIFlavour(iPlayer, "FLAVOR_HAPPINESS") >= 6 then
		base = base + math.floor(nc * 3 / 8);
	end
	if GetAIFlavour(iPlayer, "FLAVOR_CULTURE") >= 8 then
		base = base + math.floor(nc * 3 / 8);
	elseif GetAIFlavour(iPlayer, "FLAVOR_CULTURE") >= 6 then
		base = base + math.floor(nc * 1 / 8);
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 3 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[40] = function(iPlayer, bHasAlready) local base = 0;
	if gT.Players[iPlayer].AIFlavourValues.NumMilitaryUnits >= 20 then
		base = base + 2;
	elseif gT.Players[iPlayer].AIFlavourValues.NumMilitaryUnits >= 10 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_DEFENSE") >= 7 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_OFFENSE") >= 7 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.LikeBasicYields then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 8 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[41] = function(iPlayer, bHasAlready) local base = 0;
	local numC = GetNumSpecialControlPoint(iPlayer, "Colonies", true)
	if numC > 4 then
		base = base + 1;
		if numC > 9 then
			base = base + 1;
		end
		if GetAIFlavour(iPlayer, "FLAVOR_DEFENSE") >= 7 then
			base = base + 1;
		end
		if GetAIFlavour(iPlayer, "FLAVOR_OFFENSE") >= 7 then
			base = base + 1;
		end
		if GetAIFlavour(iPlayer, "FLAVOR_HAPPINESS") >= 7 then
			base = base + 1;
		end
	end
	return math.min(5, base)
end,
[42] = function(iPlayer, bHasAlready) local base = 0;
	local numC = GetNumSpecialControlPoint(iPlayer, "HolySites", true)
	if numC > 4 then
		base = base + 1;
		if numC > 9 then
			base = base + 1;
		end
		if GetAIFlavour(iPlayer, "FLAVOR_DEFENSE") >= 7 then
			base = base + 1;
		end
		if GetAIFlavour(iPlayer, "FLAVOR_OFFENSE") >= 7 then
			base = base + 1;
		end
		if GetAIFlavour(iPlayer, "FLAVOR_RELIGION") >= 7 then
			base = base + 1;
		end
	end
	return math.min(5, base)
end, 
[43] = function(iPlayer, bHasAlready) local base = 0;
--this one actually feels weak
	if Players[iPlayer]:GetNumCities() > 4 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_DEFENSE") >= 8 then
		base = base + 1;
	end
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		if gT.Cities[cID].NumAttackesEverMade >= 5 then
			base = base + 1;
			break;
		end
	end
	if Teams[Players[iPlayer]:GetTeam()]:GetAtWarCount(false) > 1 then
		base = base + 1;
	end
	if Players[iPlayer]:GetTotalLand() < gT.Players[iPlayer].TotalBestLand * 0.85 then
		base = base + 1;
	end
	return math.min(5, base)
end,
[44] = function(iPlayer, bHasAlready) local base = 0;
	if GetAIFlavour(iPlayer, "FLAVOR_DEFENSE") >= 7 then
		base = base + 1;
	end
	if Players[iPlayer]:GetNumCities() < 4 then
		base = base + 1
	end
	if gT.Players[iPlayer].AIStrategyValues.WorkRate then
		base = base + 1;
	end
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		if gT.Cities[cID].NumAttackesEverMade >= 5 then
			base = base + 2;
			break;
		end
	end
	return math.min(5, base)
end,
[45] = function(iPlayer, bHasAlready) local base = 0;
	if GetAIFlavour(iPlayer, "FLAVOR_DEFENSE") >= 8 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIhateValues[63] >= 10 then
		base = base + 1;
	end
	if gT.Players[iPlayer].Goverment == 3 then
		base = base + 1;
	end
	if gT.Globals.ScenarioType == 1 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.EnjoyRandom then
		base = base + 1;
	end
	if bHasAlready then
		base = base + 1;
	else
		local numSeeBcamps = 0;
		for index, sth in pairs(gT.BarbarianCamps) do
			local iPlot = Map.GetPlotByIndex(index);
			if iPlot:IsRevealed(Players[iPlayer]:GetTeam()) then
				if iPlot:GetImprovementType(Players[iPlayer]:GetTeam()) == GameInfoTypes.IMPROVEMENT_BARBARIAN_CAMP then
					numSeeBcamps = numSeeBcamps + 1;
				end
			end
		end
		if numSeeBcamps > 2 then
			base = base + 1;
		end
	end
	return math.min(5, base)
end,
[46] = function(iPlayer, bHasAlready) local base = 0;
	if gT.Players[iPlayer].AIFlavourValues.GeneralPointsPT >= 10 then
		base = base + 1;
		if gT.Players[iPlayer].AIFlavourValues.GeneralPointsPT >= 20 then
			base = base + 1
		end
	end
	if gT.Players[iPlayer].AIFlavourValues.AdmiralPointsPT >= 10 then
		base = base + 1;
		if gT.Players[iPlayer].AIFlavourValues.AdmiralPointsPT >= 20 then
			base = base + 1
		end
	end
	if gT.Players[iPlayer].AIFlavourValues.Early then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 5 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[47] = function(iPlayer, bHasAlready) local base = 0;
	local ncc = 0;
	for iCity in Players[iPlayer]:Cities() do
		if iCity:Plot():IsCoastalLand() then
			ncc = ncc + 1;
		end
	end
	if ncc > 3 then
		base = base + 1;
	end
	if (gT.Players[iPlayer].AIFlavourValues.UnitCombatsCount[GameInfoTypes.UNITCOMBAT_NAVALMELEE] or 0) > 10 then
		base = base + 2
	end
	if gT.Players[iPlayer].LHCombatLand / 2 <= gT.Players[iPlayer].LHCombatNaval then
		base = base + 1
		if gT.Players[iPlayer].LHCombatLand <= gT.Players[iPlayer].LHCombatNaval then
			base = base + 1
		end	
	end
	return math.min(5, base)
end,
[48] = function(iPlayer, bHasAlready) local base = 0;
	if gT.Players[iPlayer].AIStrategyValues.LikeBasicYields then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_MILITARY_TRAINING") >= 7 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_PRODUCTION") >= 7 then
		base = base + 1;
	end
	if Players[iPlayer]:GetNumCities() >= 3 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.NumMilitaryUnits >= 25 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 13 then
		return math.max(5, base + 1)
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 10 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[49] = function(iPlayer, bHasAlready) local base = 0;
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		if (gT.Cities[cID].LogTrainedXP or 0) >= 30 then
			if GetITGCityInteger(iCity, "CI_LH_TRAINED_UNITS") > (GetITGGameTurn() / 8) then
				return 5;
			end
		end
	end
	if GetAIFlavour(iPlayer, "FLAVOR_MILITARY_TRAINING") >= 7 then
		base = base + 1;
	end
	if Players[iPlayer]:GetNumCities() > 3 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_OFFENSE") >= 7 then
		base = base + 1;
	end
	return math.min(5, base)
end,
[50] = function(iPlayer, bHasAlready) local base = 0;
	if gT.Players[iPlayer].AIStrategyValues.EnjoyRandom then
		if GetAIFlavour(iPlayer, "FLAVOR_OFFENSE") >= 7 then
			if gT.Players[iPlayer].AIFlavourValues.GeneralPointsPT > 7 then
				base = base + LastRandom(1, 5);
			end
		end
	end
	return math.min(5, base)
end,
[51] = function(iPlayer, bHasAlready) local base = 0;
	if GetAIFlavour(iPlayer, "FLAVOR_MILITARY_TRAINING") >= 7 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.NumMilitaryUnits > 10 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.UnitsKilledPT >= 0.5 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.EnjoyRandom then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.UnitsKilledPT > gT.Players[iPlayer].AIFlavourValues.UnitsLostPT then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 7 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[52] = function(iPlayer, bHasAlready) local base = 0;
	if gT.Players[iPlayer].AIStrategyValues.EnjoyRandom then
		if GetAIFlavour(iPlayer, "FLAVOR_OFFENSE") >= 7 then
			if gT.Players[iPlayer].AIFlavourValues.GeneralPointsPT > 7 then
				base = base + LastRandom(1, 5);
			end
		end
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 7 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[53] = function(iPlayer, bHasAlready) local base = 0;
	if gT.Globals.ScenarioType == 1 then
		if gT.Players[iPlayer].CultureType == 1 then
			base = base + 1;
		end
		if HasPlayerTech(iPlayer, GameInfoTypes.UNIT_MUSKETMAN, "EFwd") then
			base = base + 2;
		elseif Players[iPlayer]:GetCurrentEra() == GameInfoTypes.ERA_RENAISSANCE then
			base = base + 1;
		end
	end
	if GetAIFlavour(iPlayer, "FLAVOR_OFFENSE") >= 8 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.EnjoyRandom then
		base = base + 1;
	end
	return math.min(5, base)
end,
[54] = function(iPlayer, bHasAlready) local base = 0;
	if gT.Players[iPlayer].AIFlavourValues.TRSuccess > 5 * gT.Players[iPlayer].AIFlavourValues.TRkilled then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.TRCS >= gT.Players[iPlayer].AIFlavourValues.TRSuccess * 3 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.NumAlliedCS >= 2 then
		base = base + 1
	end
	if gT.Players[iPlayer].AIFlavourValues.TRSuccess >= GetITGGameTurn() / 4 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_GOLD") >= 8 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 6 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[55] = function(iPlayer, bHasAlready) local base = 0;
	if Players[iPlayer]:GetNumCities() > 5 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_FOOD") >= 8 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_PRODUCTION") >= 8 then
		base = base + 1;
	end
	if gT.Players[iPlayer].LHFoodTR > GetITGGameTurn() then
		base = base + 1;
	end
	if gT.Players[iPlayer].LHProdTR > GetITGGameTurn() then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 6 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[56] = function(iPlayer, bHasAlready) local base = 0;
	base = Players[iPlayer]:GetNumCities() - 3;
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 10 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[57] = function(iPlayer, bHasAlready) local base = 0;
	if GetAIFlavour(iPlayer, "FLAVOR_HAPPINESS") >= 6 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_GROWTH") >= 6 then
		base = base + 1;
	end
	base = base + math.floor(Players[iPlayer]:GetNumCities() / 3)	
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 2 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[58] = function(iPlayer, bHasAlready) local base = 0;
	if GetAIFlavour(iPlayer, "FLAVOR_DIPLOMACY") >= 7 then
		base = base + 1;
	end
	if gT.Players[iPlayer].NatUnity > 70 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_OFFENSE") >= 7 then
		base = base + 1;
	end
	local numWorse = 0;
	for a, b in pairs(gT.Players) do
		if not Players[a]:IsMinorCiv() then
			if b.NatUnity < gT.Players[iPlayer].NatUnity then
				numWorse = numWorse + 1;
			end
		end
	end
	base = base + math.min(math.floor(numWorse / 2), 3)
	return math.min(5, base)
end,
[59] = function(iPlayer, bHasAlready) local base = 0;
	local gsipt = gT.Players[iPlayer].TotalGoldSpendInternally / math.max(1, GetITGGameTurn()) * 100;
	if bHasAlready then
		base = base + 1;
	end
	base = base + math.floor(gsipt / 600)
	return math.min(5, base)
end,
[60] = function(iPlayer, bHasAlready) local base = 0;
	local numdeals = GetNumDealsAuctionHouse(iPlayer, bImport, bExport);
	if numdeals > 2 then
		base = 2;
		if gT.Players[iPlayer].AIStrategyValues.LikeBasicYields  then
			base = base + 1;
		end
		if GetAIFlavour(iPlayer, "FLAVOR_HAPPINESS") >= 7 then
			base = base + 1;
		end
		if GetAIFlavour(iPlayer, "FLAVOR_GOLD") >= 7 then
			base = base + 1;
		end
	end
	return math.min(5, base)
end,
[61] = function(iPlayer, bHasAlready) local base = 0;
	if gT.Players[iPlayer].AIStrategyValues.EnjoyRandom then
		base = base + 1;
	end
	base = math.floor(gT.Players[iPlayer].AIFlavourValues.UnitsLostPT /0.2)
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 7 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[62] = function(iPlayer, bHasAlready) local base = 0;
	if gT.Players[iPlayer].AIStrategyValues.LikeBasicYields then
		base = base + 1;
	end
	if #gT.Players[iPlayer].NumWarsDeclared > 1 then
		base = base + 1;
	end
	if GetEstimatedColonyPointsPerTurn(iPlayer, true) >= 20 then
		base = base + 1;
	end
	if bHasAlready or gT.Players[iPlayer].AIFlavourValues.Late then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.NumAlliedCS > 1 then
		base = base + 1;
	end
	return math.min(5, base)
end,
[63] = function(iPlayer, bHasAlready) local base = 0;
	local numNavalUnits = (gT.Players[iPlayer].AIFlavourValues.UnitCombatsCount[GameInfoTypes.UNITCOMBAT_NAVALMELEE] or 0) + (gT.Players[iPlayer].AIFlavourValues.UnitCombatsCount[GameInfoTypes.UNITCOMBAT_NAVALRANGED] or 0)
	if numNavalUnits > 8 then
		base = base + 2;
	end
	local ncc = 0;
	for iCity in Players[iPlayer]:Cities() do
		if iCity:Plot():IsCoastalLand() then
			ncc = ncc + 1;
		end
	end
	if ncc > 3 then
		base = base + 1;
	end
	if bHasAlready or gT.Players[iPlayer].AIFlavourValues.Early then
		base = base + 1;
	end
	if GetSizeOfLargestOcean() > 450 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 11 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[64] = function(iPlayer, bHasAlready) local base = 0;
	local toFish = 0;
	for iCity in Players[iPlayer]:Cities() do
		toFish = toFish + gT.Cities[ iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded()].FishFoodTotal
	end
	toFish = toFish / math.max(GetITGGameTurn(), 1);
	if GetAIFlavour(iPlayer, "FLAVOR_PRODUCTION") >= 8 then
		base = base + math.floor(toFish / 0.6)
	else
		base = base + math.floor(toFish / 1.25)
	end
	return math.min(5, base)
end,
[65] = function(iPlayer, bHasAlready) local base = 0;
	if Players[iPlayer]:GetBuildingClassCount(GameInfoTypes.BUILDINGCLASS_LIGHTHOUSE) >= 3 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_GOLD") >= 8 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.NavalTradeRoutes > 4 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.TRkilled < 2 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.LikeBasicYields then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 6 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[66] = function(iPlayer, bHasAlready) local base = 0;
	if Players[iPlayer]:GetNumCities() > 4 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_CULTURE") >= 8 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.TradeRoutesForeign == 0 then
		return 0;
	elseif gT.Players[iPlayer].AIFlavourValues.TradeRoutesForeign >= (GetITGGameTurn() / 10) then
		base = base + 2;
	end
	if gT.Players[iPlayer].AIStrategyValues.EnjoyRandom then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 2 then
		return math.max(5, base + 1)
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 6 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[67] = function(iPlayer, bHasAlready) local base = 0;
	local numChad = 0;
	if Players[iPlayer]:GetNumResourceTotal(gT.Players[iPlayer].Currencies) > 0 then
		numChad = 1;
	end
	if numChad > 0 then
		base = numChad;
		if GetAIFlavour(iPlayer, "FLAVOR_HAPPINESS") >= 8 then
			base = base + 1;
		end
		if gT.Players[iPlayer].AIFlavourValues.AverageHappinessEmpire <= 3 then
			base = base + 1;
		end
		if gT.Players[iPlayer].AIStrategyValues.LikeBasicYields then
			base = base + 1;
		end
	end
	if gT.Players[iPlayer].AIStrategyValues.LikeBasicYields then
		base = base + 1;
	end
	if gT.Players[iPlayer].TotalDecadentism == 0 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 3 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[68] = function(iPlayer, bHasAlready) local base = 0;
	if gT.Players[iPlayer].AIStrategyValues.LikeBasicYields then
		base = base + 1
	end
	if gT.Players[iPlayer].AIFlavourValues.Late then
		base = base + 1
	end
	if GetAIFlavour(iPlayer, "FLAVOR_CULTURE") >= 8 then
		base = base + 2
	end
	if Players[iPlayer]:GetReligionCreatedByPlayer() <= 0 then
		base = base + 1
	end
	return math.min(5, base)
end,
[69] = function(iPlayer, bHasAlready) local base = 0;
	local numForeign = GetNumForeignGovernors(iPlayer)
	if numForeign > 0 then
		if Players[iPlayer]:GetNumCities() < 5 then
			base = base + 1;
		end
		if GetAIFlavour(iPlayer, "FLAVOR_CULTURE") >= 7 then
			base = base + 1;
		end
		if GetAIFlavour(iPlayer, "FLAVOR_SCIENCE") >= 7 then
			base = base + 1;
		end
		if GetAIFlavour(iPlayer, "FLAVOR_AUTHORITY") >= 7 then
			base = base + 1;
		end
		if numForeign > 2 then
			base = base + 1;
		end
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 14 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[70] = function(iPlayer, bHasAlready) local base = 0;
	if bHasAlready then
		if gT.Globals.ScenarioType == 1 then
			if gT.Players[iPlayer].AIFlavourValues.Late then
				return 1;
			else
				return 5;
			end
		elseif gT.Globals.ScenarioType == 2 then
			if not gT.Players[iPlayer].AIFlavourValues.Late then
				return 1;
			end
		else
			return 5;
		end
	end
	if gT.Players[iPlayer].AIFlavourValues.Early then
		base = base + 2;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_RECON") >= 8 then
		base = base + 1;
	end
	if Teams[Players[iPlayer]:GetTeam()]:GetAtWarCount(false) == 0 then
		base = base + 1;
	end
	if Players[iPlayer]:GetUnitClassCountPlusMaking(GameInfoTypes.UNITCLASS_SCOUT) > 3 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 11 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[71] = function(iPlayer, bHasAlready) local base = 0;
	if Players[iPlayer]:GetNumCities() > 6 then
		base = base + 2;
	elseif Players[iPlayer]:GetNumCities() > 3 then
		base = base + 1;
	end
	if not gT.Players[iPlayer].OfficialReligion then
		if Players[iPlayer]:GetReligionCreatedByPlayer() > 0 then
			base = base + 1;
		end
		if GetAIFlavour(iPlayer, "FLAVOR_HAPPINESS") >= 8 then
			base = base + 1;
		end
	else
		local tother = 0;
		for iCity in Players[iPlayer]:Cities() do
			tother = tother + GetCityModifierFromHeresy(iCity);
		end
		if tother >= 2 then
			base = base + 2;
		end
	end
	if gT.Players[iPlayer].AIStrategyValues.EnjoyRandom then
		base = base + 1;
	end
	return math.min(5, base)
end,
[72] = function(iPlayer, bHasAlready) local base = 0;
	if GetAIFlavour(iPlayer, "FLAVOR_SCIENCE") >= 7 then
		base = base + 1;
	end
	if not gT.Players[iPlayer].AIStrategyValues.EnjoyRandom then
		base = base + 1;
	end
	if bHasAlready or gT.Players[iPlayer].AIFlavourValues.Early then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.SciencePTtoNextTreshold >= 0.1 then
		base = base + 2;
	end
	return math.min(5, base)
end,
[73] = function(iPlayer, bHasAlready) local base = 0;
	if GetAIFlavour(iPlayer, "FLAVOR_HAPPINESS") >= 7 then
		base = base + 2;
	end
	if gT.Players[iPlayer].AIStrategyValues.AfraidOfAnarchy then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.LikeBasicYields then
		base = base + 2;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 3 then
		return math.max(5, base + 1)
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 10 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[74] = function(iPlayer, bHasAlready) local base = 0;
	if gT.Players[iPlayer].AIFlavourValues.TradeRoutesForeign == 0 then
		return 0;
	elseif gT.Players[iPlayer].AIFlavourValues.TradeRoutesForeign >= (GetITGGameTurn() / 15) then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.TradeRoutesPT >= 0.2 then
		base = base + 1;
	end
	if Players[iPlayer]:GetNumCities() > 4 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_HAPPINESS") >= 8 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.AfraidOfAnarchy then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 6 then
		return math.max(5, base + 1)
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 3 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[75] = function(iPlayer, bHasAlready) local base = 0;
	base = base + GetAIFlavour(iPlayer, "FLAVOR_MILITARY_TRAINING") - 5;
	if gT.Players[iPlayer].AIStrategyValues.LikeBasicYields then
		base = base + 2;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 8 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[76] = function(iPlayer, bHasAlready) local base = 0;
	if GetAIFlavour(iPlayer, "FLAVOR_OFFENSE") >= 7 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_MOBILE") >= 7 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_RANGED") <= 4 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.UnitsKilledPT > 0.2 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.NumMilitaryUnits > 16 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 7 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[77] = function(iPlayer, bHasAlready) local base = 0;
	if GetAIFlavour(iPlayer, "FLAVOR_RELIGION") >= 7 then
		base = base + 2;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_SCIENCE") >= 7 then
		base = base + 2;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_HAPPINESS") < 5 then
		base = base + 1
	end
	if bHasAlready then
		base = base + 1; -- it gets better in later eras
	end
	return math.min(5, base)
end,
[78] = function(iPlayer, bHasAlready) local base = 0;
	if gT.Players[iPlayer].AIStrategyValues.LikeBasicYields then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.UnitsKilledPT > 0.4 then
		base = base + 1;
	end
	if bHasAlready or Teams[Players[iPlayer]:GetTeam()]:GetAtWarCount(false) > 1 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.NumMilitaryUnits >= 15 then
		base = base + 1;
	end
	if gT.Players[iPlayer].MeleeCombatsP > 1.5 * gT.Players[iPlayer].RangedCombatP then
		base = base + 1;
	end
	return math.min(5, base)
end,
[79] = function(iPlayer, bHasAlready) local base = 0;
	if GetAIFlavour(iPlayer, "FLAVOR_DEFENSE") >= 8 then
		base = base + 1;
	end
	base = base + math.floor(GetNumSpecialControlPoint(iPlayer, "HolySites", true) / 3)
	base = base + math.floor(GetNumSpecialControlPoint(iPlayer, "Colonies", true) / 4)
	base = base + math.floor(GetNumSpecialControlPoint(iPlayer, "Forts", true) / 4)
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 13 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[80] = function(iPlayer, bHasAlready) local base = 0;
	if bHasAlready then
		if GetITGGameTurn() > 50 then
			base = math.floor((gT.Players[iPlayer].Cult80t[1] + gT.Players[iPlayer].Cult80t[2]) / 8);
		else
			base = 4;
		end
	else
		if gT.Players[iPlayer].AIFlavourValues.Early then
			base = base + 2;
		end
		if GetAIFlavour(iPlayer, "FLAVOR_OFFENSE") >= 7 then
			base = base + 1;
		end
		if GetAIFlavour(iPlayer, "FLAVOR_MILITARY_TRAINING") >= 7 then
			base = base + 1;
		end
		if gT.Players[iPlayer].AIStrategyValues.LikeBasicYields then
			base = base + 1;
		end
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 3 then
		base = base + 1; -- not the best
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 10 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[81] = function(iPlayer, bHasAlready) local base = 0;
	local totnavy = (gT.Players[iPlayer].AIFlavourValues.UnitCombatsCount[GameInfoTypes.UNITCOMBAT_NAVALRANGED] or 0) + (gT.Players[iPlayer].AIFlavourValues.UnitCombatsCount[GameInfoTypes.UNITCOMBAT_NAVALMELEE] or 0);
	base = base + math.floor(totnavy / 4.5)
	if GetAIFlavour(iPlayer, "FLAVOR_NAVAL") >= 7 then
		base = base + 1
	end
	return math.min(5, base)
end,
[82] = function(iPlayer, bHasAlready) local base = 0;
	if GetAIFlavour(iPlayer, "FLAVOR_RELIGION") >= 7 then
		if bHasAlready or gT.Players[iPlayer].AIFlavourValues.Early then
			if Players[iPlayer]:GetReligionCreatedByPlayer() > 0  then
				if gT.Players[iPlayer].AIStrategyValues.LikeBasicYields then
					base = base + LastRandom(4, 6);
				end
			end
		end
	end
	return math.min(5, base)
end,
[83] = function(iPlayer, bHasAlready) local base = 0;
	if gT.Players[iPlayer].AIStrategyValues.EnjoyRandom then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_RECON") >= 7 then
		base = base + 1;
	end
	if bHasAlready or gT.Players[iPlayer].AIFlavourValues.Early then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.TRkilled < 2 then
		base = base + 1;
	end
	if Players[iPlayer]:GetNumCities() > 3 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 6 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[84] = function(iPlayer, bHasAlready) local base = 0;
	base = base + math.floor(GetAIFlavour(iPlayer, "FLAVOR_GREAT_PEOPLE") / 4)
	base = base + math.max(0, math.floor(GetITGGameTurn() * 0.15) - gT.Players[iPlayer].GPCivilGenerated)
	if Players[iPlayer]:GetNumCities() < 5 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 4 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[85] = function(iPlayer, bHasAlready) local base = 0;
	local totprod = 0;
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		totprod = totprod + math.floor(GetWorkRateIncreasement(iPlayer, iCity, cID) / 17)
	end
	if GetAIFlavour(iPlayer, "FLAVOR_PRODUCTION") >= 8 then
		base = base + math.floor(totprod / 3)
	else
		base = base + math.floor(totprod / 4)
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 9 then
		return math.max(5, base + 1)
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 10 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[86] = function(iPlayer, bHasAlready) local base = 0;
	if gT.Players[iPlayer].AIStrategyValues.LikeBasicYields then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.UnitsKilledPT > 0.4 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.WorkRate then
		base = base + 1;
	end
	if bHasAlready or Teams[Players[iPlayer]:GetTeam()]:GetAtWarCount(false) > 1 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.NumMilitaryUnits >= 15 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 13 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[87] = function(iPlayer, bHasAlready) local base = 0;
	base = base + math.ceil(3 * gT.Players[iPlayer].AIFlavourValues.NumAlliedCS / 5)
	if #gT.Players[iPlayer].NumWarsDeclaredOn == 0 then
		base = base + 1;
	end
	return math.min(5, base)
end,
[88] = function(iPlayer, bHasAlready) local base = 0;
	if gT.Players[iPlayer].AIStrategyValues.WorkRate then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.LikeBasicYields then
		base = base + 1;
	end
	if bHasAlready or gT.Players[iPlayer].AIFlavourValues.Early then
		base = base + 1;
	end
	if Players[iPlayer]:GetNumCities() > 4 then
		base = base + 1;
	end
	for iCity in Players[iPlayer]:Cities() do
		if not iCity:IsCapital() then
			if not Players[iPlayer]:IsCapitalConnectedToCity(iCity) then
				base = base + 1;
				break;
			end
		end
	end
	return math.min(5, base)
end,
[89] = function(iPlayer, bHasAlready) local base = 0;
	if gT.Players[iPlayer].AIStrategyValues.LikeBasicYields then
		base = base + 1;
	end
	if bHasAlready or gT.Players[iPlayer].AIFlavourValues.Early then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_EXPANSION") >= 8 then
		base = base + 1;
	end
	if Players[iPlayer]:GetNumCities() > 5 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_HAPPINESS") >= 8 then
		base = base + 1;
	end
	return math.min(5, base)
end,
[90] = function(iPlayer, bHasAlready) local base = 0;
	if Players[iPlayer]:GetNumCities() < 4 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_HAPPINESS") >= 8 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.LikeBasicYields then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.AfraidOfAnarchy then
		if gT.Players[iPlayer].EEFAnarchyOutbreaks == 0 then
			base = base + 1;
		end
	end
	local cCity = Players[iPlayer]:GetCapitalCity();
	if cCity then
		if cCity:GetPopulation() >= 10 then
			base = base + 1;
		end
	else
		return 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 3 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[91] = function(iPlayer, bHasAlready) local base = 0;
	if Players[iPlayer]:GetBuildingClassCount(GameInfoTypes.BUILDINGCLASS_LIGHTHOUSE) >= 2 then
		base = base + 1;
	end
	if Players[iPlayer]:GetUnitClassCountPlusMaking(GameInfoTypes.UNITCLASS_WORKBOAT) >= 2 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_FOOD") >= 7 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_NAVAL_TILE_IMPROVEMENT") >= 7 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_NAVAL_GROWTH") >= 7 then
		base = base + 1;
	end
	return math.min(5, base)
end,
[92] = function(iPlayer, bHasAlready) local base = 0;
	if gT.Players[iPlayer].AIFlavourValues.Early or bHasAlready then
		base = base + 2;
	end
	if Players[iPlayer]:GetNumCities() > 5 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.LikeBasicYields then
		base = base + 1;
	end
	if not gT.Players[iPlayer].AIStrategyValues.EnjoyRandom then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 10 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[93] = function(iPlayer, bHasAlready) local base = 0;
	if GetAIFlavour(iPlayer, "FLAVOR_MOBILE") >= 7 then
		if GetAIFlavour(iPlayer, "FLAVOR_NAVAL") >= 7 then
			if GetAIFlavour(iPlayer, "FLAVOR_OFFENSE") >= 7 then
				if GetAIFlavour(iPlayer, "FLAVOR_RECON") >= 7 then
					base = base + LastRandom(3, 5);
				end
			end
		end
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 11 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[94] = function(iPlayer, bHasAlready) local base = 0;
	local h = 0;
	local TIt = {[GameInfoTypes.IMPROVEMENT_CUSTOMS_HOUSE] = true, [GameInfoTypes.IMPROVEMENT_MANUFACTORY] = true, [GameInfoTypes.IMPROVEMENT_ACADEMY] = true}
	for iCity in Players[iPlayer]:Cities() do
		for i = 0, 5 do
			local iPlot = Map.PlotDirection(iCity:GetX(), iCity:GetY(), i);
			if iPlot and TIt[iPlot:GetImprovementType()] then
				h = h + 1;
			end
		end
	end
	if GetAIFlavour(iPlayer, "FLAVOR_RELIGION") >= 7 then
		base = base + h;
	else
		base = base + math.floor(h * 5 / 8)
	end
	return math.min(5, base)
end,
[95] = function(iPlayer, bHasAlready) local base = 0;
	base = base + gT.Players[iPlayer].AIFlavourValues.NumAlliedCS
	return math.min(5, base)
end,
[96] = function(iPlayer, bHasAlready) local base = 0;
	if GetAIFlavour(iPlayer, "FLAVOR_RELIGION") >= 7 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.EnjoyRandom then
		base = base + 1;
	end
	if Players[iPlayer]:GetReligionCreatedByPlayer() > 0 then
		base = base + 1;
	end
	if bHasAlready or (not gT.Players[iPlayer].AIFlavourValues.Late) then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_DIPLOMACY") >= 7 then
		base = base + 1;
	end
	return math.min(5, base)
end,
[97] = function(iPlayer, bHasAlready) local base = 0;
	for gpID, hhh in pairs(gT.Players[iPlayer].GreatPeople) do
		local gd = gT.GreatPeople[gpID];
		if gd.Alive and gd.Military then
			base = base + 1;
		end
	end
	base = math.min(4, base);
	if gT.Players[iPlayer].AIStrategyValues.LikeBasicYields then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 5 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[98] = function(iPlayer, bHasAlready) local base = 0;
	if GetAIFlavour(iPlayer, "FLAVOR_SCIENCE") >= 7 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_CULTURE") >= 7 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.LikeBasicYields then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.TradeRoutesForeign >= (GetITGGameTurn() / 10) then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.TradeRoutesPT >= 0.2 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 6 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[99] = function(iPlayer, bHasAlready) local base = 0;
	if gT.Players[iPlayer].AIFlavourValues.NumMetCS > 9 then
		base = base + 1;
	end
	for i, d in pairs(gT.Players) do
		if Players[i]:IsMinorCiv() then
			if Teams[Players[i]:GetTeam()]:IsHasMet(Players[iPlayer]:GetTeam()) then
				if Players[i]:CanMajorBullyGold(iPlayer) then
					base = base + 1;
					break;
				end
			end
		end
	end
	base = base + math.ceil(gT.Players[iPlayer].CSBulliedTimes / 2)
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 13 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[100] = function(iPlayer, bHasAlready) local base = 0;
	if bHasAlready then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.LikeBasicYields then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.NumMetCS > 6 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.Early or gT.Players[iPlayer].AIFlavourValues.Late  then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_DIPLOMACY") >= 8 then
		base = base + 1;
	end
	for i, ldata in pairs(gT.Leagues) do
		if ldata.Members[iPlayer] then
			base = base + 1;
			break;
		end
	end
	return math.min(5, base)
end,
[101] = function(iPlayer, bHasAlready) local base = 0;
	if gT.Players[iPlayer].AIStrategyValues.EnjoyRandom then
		base = base + 3;
	end
	if gT.Players[iPlayer].AIFlavourValues.NumMilitaryUnits >= 16 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.UnitsKilledPT > 0.2 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 7 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[102] = function(iPlayer, bHasAlready) local base = 0;
	if gT.Players[iPlayer].AIStrategyValues.LikeBasicYields then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.NumMilitaryUnits >= 10 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_RANGED") < 6 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.UnitsKilledPT > 0.2 then
		base = base + 1;
	end
	base = base + LastRandom(0, 1) --random
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 8 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[103] = function(iPlayer, bHasAlready) local base = 0;
	if Players[iPlayer]:GetNumCities() > 3 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_GOLD") < 6 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_PRODUCTION") >= 8 then
		base = base + 1;
	end
	if gT.Players[iPlayer].TotalGoldSpendInternally == 0 then
		base = base + 1;
	end
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		if gT.Cities[cID].RiotsEnter > 3 then
			base = base + 1;
		end
	end
	return math.min(5, base)
end,
[104] = function(iPlayer, bHasAlready) local base = 0;
	if Players[iPlayer]:GetNumCities() > 3 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_RELIGION") < 6 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_PRODUCTION") >= 8 then
		base = base + 1;
	end
	if gT.Players[iPlayer].TotalGoldSpendInternally == 0 then
		base = base + 1;
	end
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		if gT.Cities[cID].RiotsEnter > 3 then
			base = base + 1;
		end
	end
	return math.min(5, base)
end,
[105] = function(iPlayer, bHasAlready) local base = 0;
	if gT.Globals.ScenarioType ~= 3 then
		return 1;
	end
	if Players[iPlayer]:GetNumCities() > 4 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_EXPANSION") >= 8 then
		base = base + 1;
	end
	if (gT.Players[iPlayer].AISettlerPointsManagement) and (gT.Players[iPlayer].AISettlerPointsManagement.Type == 1 ) then
		base = base + 1;
	end
	if HasMintAnyCity(iPlayer) then
		base = base + 1;
	end
	if gT.Players[iPlayer].CitiesFounded > 0 then
		base = base + 1;
	end
	return math.min(5, base)
end,
[106] = function(iPlayer, bHasAlready) local base = 0;
	if HasMintAnyCity(iPlayer) then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.Early then
		base = base + 1;
	end
	if not gT.Players[iPlayer].AIStrategyValues.EnjoyRandom then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_GOLD") >= 8 then
		base = base + 1;
	end
	if not gT.Players[iPlayer].AIStrategyValues[106] then
		gT.Players[iPlayer].AIStrategyValues[106] = LastRandom(0, 2);
	end
	base = base + gT.Players[iPlayer].AIStrategyValues[106];
	return math.min(5, base)
end,
[107] = function(iPlayer, bHasAlready) local base = 0;
	if GetAIFlavour(iPlayer, "FLAVOR_CULTURE") >= 7 then
		base = base + 1;
	end
	if GetNumOccupiedCities(iPlayer) > 0 then
		base = base + 1;
	end
	if Players[iPlayer]:GetNumCities() > 6 then
		base = base + 1;
	end
	if gT.Players[iPlayer].UniqueNumConquered > 2 then
		base = base + 1;
	end
	if gT.Players[iPlayer].NatUnity < NAT_UNITY_PENALTY_FREE then
		base = base + 1;
	end
	return math.min(5, base)
end,
[108] = function(iPlayer, bHasAlready) local base = 0;
	return - 5;
end,
[109] = function(iPlayer, bHasAlready) local base = 0;
	return - 5;
end,
[110] = function(iPlayer, bHasAlready) local base = 0;
	local t = GetNumActiveGovernors(iPlayer);
	if Players[iPlayer]:GetNumCities() < t + 1 then
		return 0;
	end
	if t > 1 then
		base = base + t - 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_PRODUCTION") >= 7 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_AUTHORITY") >= 7 then
		base = base + 2;
	end
	if gT.Players[iPlayer].AIStrategyValues.LikeBasicYields then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 14 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[111] = function(iPlayer, bHasAlready) local base = 0;
	local bcon = Players[iPlayer]:GetBuildingClassCount(GameInfoTypes.BUILDINGCLASS_CONSTABLE)
	if bcon >= 2 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.EnjoyRandom then
		base = base + 1;
	end
	if Players[iPlayer]:GetNumCities() > 5 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.AfraidOfAnarchy then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_PRODUCTION") >= 7 then
		base = base + 1;
	end
	return math.min(5, base)
end,
[112] = function(iPlayer, bHasAlready) local base = 0;
	local t, p = Players[iPlayer]:GetNumCities(), 0;
	if bHasAlready then
		base = base + LastRandom(1, 2);
	end
	for iCity in Players[iPlayer]:Cities() do
		if iCity:GetProductionProcess() ~= -1 then
			p = p + 1;
		end
	end
	if t ~= 0 then
		base = base + math.floor(5.5 * p / t)
	end
	if t < 3 then
		base = base - 2;
	end
	return math.min(5, base)
end,
[113] = function(iPlayer, bHasAlready) local base = 0;
	if GetAIFlavour(iPlayer, "FLAVOR_GREAT_PEOPLE") >= 8 then
		base = base + 1;
	end
	if bHasAlready or gT.Players[iPlayer].AIFlavourValues.Early then
		base = base + 1;
	end
	base = base + math.floor(Players[iPlayer]:GetNumCities() / 3)
	if gT.Players[iPlayer].WonderProduction > 400 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 4 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[114] = function(iPlayer, bHasAlready) local base = 0;
	local nmc = 0;
	for gpID, hhh in pairs(gT.Players[iPlayer].GreatPeople) do
		local gd = gT.GreatPeople[gpID];
		if gd.Alive and gd.Military then
			if gd.Type == 1 then
				nmc = nmc + 1;
			end
		end
	end
	if GetAIFlavour(iPlayer, "FLAVOR_MILITARY_TRAINING") >= 7 then
		if GetAIFlavour(iPlayer, "FLAVOR_OFFENSE") >= 7 then
			base = base + 2 + nmc;
		else
			base = base + 1 + nmc;
		end
	else
		base = base + nmc;
	end
	if bHasAlready then
		base = base + 1
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 5 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[115] = function(iPlayer, bHasAlready) local base = 0;
	if GetAIFlavour(iPlayer, "FLAVOR_MILITARY_TRAINING") >= 7 then
		if GetAIFlavour(iPlayer, "FLAVOR_NAVAL") >= 7 then
			base = base + 2;
		else
			base = base + 1;
		end
	end
	base = base + math.ceil(gT.Players[iPlayer].AIFlavourValues.CoastCitiesPerc / 20)
	return math.min(5, base)
end,
[116] = function(iPlayer, bHasAlready) local base = 0;
	if GetAIFlavour(iPlayer, "FLAVOR_MILITARY_TRAINING") >= 7 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.NumMilitaryUnits >= 15 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_OFFENSE") >= 7 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.MaxTrainedUnitsPT > 0.3 then
		base = base + 1;
	end
	if bHasAlready or Teams[Players[iPlayer]:GetTeam()]:GetAtWarCount(false) > 0 then
		base = base + 1;
	end
	return math.min(5, base)
end,
[117] = function(iPlayer, bHasAlready) local base = 0;
	if gT.Players[iPlayer].AIStrategyValues.EnjoyRandom then
		base = base + 3;
	end
	if Players[iPlayer]:GetNumCities() > 4 then
		base = base + 1;
	end
	if bHasAlready or gT.Players[iPlayer].AIFlavourValues.Early then
		base = base + 2;
	end
	return math.min(5, base)
end,
[118] = function(iPlayer, bHasAlready) local base = 0;
	for g, h in pairs(gT.Players) do
		if Players[g]:IsMinorCiv() then
			if Players[g]:IsAlive() and Players[g]:GetMinorCivFriendshipLevelWithMajor(iPlayer) > 0 then
				base = base + 0.75;
			end
		end
	end
	base = math.floor(base);
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 10 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[119] = function(iPlayer, bHasAlready) local base = 0;
	if GetAIFlavour(iPlayer, "FLAVOR_MOBILE") >= 7 then
		base = base + 1;
	end
	for iCity in Players[iPlayer]:Cities() do
		if iCity:Plot():IsRiver() then
			base = base + 1;
		end
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 11 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[120] = function(iPlayer, bHasAlready) local base = 0;
	return -5;
end,
[121] = function(iPlayer, bHasAlready) local base = 0;
	local aca = GetNumActiveAcademies(iPlayer)
	local nmc = Players[iPlayer]:GetNumCities();
	if aca == 0 or nmc == 0 then
		return 0;
	end
	if aca > 3 then
		base = base + 2;
	end
	if aca >= nmc / 2 then
		base = base + 2;
	end
	if gT.Players[iPlayer].AIFlavourValues.Early or gT.Players[iPlayer].AIStrategyValues.EnjoyRandom then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 2 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[122] = function(iPlayer, bHasAlready) local base = 0;
	if GetAIFlavour(iPlayer, "FLAVOR_INFRASTRUCTURE") >= 7 then
		if GetAIFlavour(iPlayer, "FLAVOR_MOBILE") >= 7 then
			if Players[iPlayer]:GetNumCities() >= 6 then
				base = base + LastRandom(3,5)
			end
		end
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 11 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[123] = function(iPlayer, bHasAlready) local base = 0;
	if GetAIFlavour(iPlayer, "FLAVOR_GOLD") >= 7 then
		base = base + 1;
		if Players[iPlayer]:GetBuildingClassCount(GameInfoTypes.BUILDINGCLASS_HARBOR) >= 3 then
			base = base + 1;
		end
		if Players[iPlayer]:GetBuildingClassCount(GameInfoTypes.BUILDINGCLASS_LIGHTHOUSE) >= 3 then
			base = base + 1;
		end
		if Players[iPlayer]:GetUnitClassCountPlusMaking(GameInfoTypes.UNITCLASS_WORKBOAT) >= 3 then
			base = base + 2;
		end
	end
	return math.min(5, base)
end,
[124] = function(iPlayer, bHasAlready) local base = 0;
	if GetAIFlavour(iPlayer, "FLAVOR_GOLD") >= 7 then
		if GetAIFlavour(iPlayer, "FLAVOR_RELIGION") >= 7 then
			if gT.Players[iPlayer].AIFlavourValues.TRkilled >= 8 then
				base = base + 2;
			end
			base = base + 1;
			if (gT.Players[iPlayer].AIFlavourValues.TRkilled + gT.Players[iPlayer].AIFlavourValues.TRSuccess) / math.max(1, GetITGGameTurn()) > 0.6 then
				base = base + 2;
			end
		end
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 6 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[125] = function(iPlayer, bHasAlready) local base = 0;
	if GetAIFlavour(iPlayer, "FLAVOR_MILITARY_TRAINING") >= 8 then
		base = base + 2;
	end
	if gT.Players[iPlayer].AIFlavourValues.MaxTrainedUnitsPT > 0.3 then
		base = base + 2;
	end
	if gT.Players[iPlayer].CultBonusOn[116] then
		base = base + 1;
	end
	if gT.Players[iPlayer].CultBonusOn[126] then
		base = base + 1;
	end
	if Players[iPlayer]:GetBuildingClassCount(GameInfoTypes.BUILDINGCLASS_BARRACKS) >= 3 then
		base = base + 1;
	end
	return math.min(5, base)
end,
[126] = function(iPlayer, bHasAlready) local base = 0;
	if Players[iPlayer]:GetBuildingClassCount(GameInfoTypes.BUILDINGCLASS_BARRACKS) >= 3 then
		base = base + 1;
	end
	if gT.Players[iPlayer].CultBonusOn[116] then
		base = base + 1;
	end
	if gT.Players[iPlayer].CultBonusOn[125] then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_MILITARY_TRAINING") >= 7 then
		base = base + 1;
	end
	if not 	gT.Players[iPlayer].AIFlavourValues.Late then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.MaxTrainedUnitsPT > 0.3 then
		base = base + 2;
	end
	if Players[iPlayer]:GetNumCities() > 5 then
		base = base + 1;
	end
	return math.min(5, base);
end,
[127] = function(iPlayer, bHasAlready) local base = 0;
	if Players[iPlayer]:GetNumCities() > 4 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_DEFENSE") >= 7 then
		base = base + 1;
	end
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		if gT.Cities[cID].TotalDamage > 200 then
			base = base + 1;
			if gT.Cities[cID].TotalDamage > 600 then
				base = base + 3;
				break;
			end
		end
	end
	return math.min(5, base);
end,
[128] = function(iPlayer, bHasAlready) local base = 0;
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		if gT.Cities[cID].TotalDamage == 0 then	
			base = base + 1;
		end
	end
	return math.min(5, base);
end,
[129] = function(iPlayer, bHasAlready) local base = 0;
	return -5;
end,
[130] = function(iPlayer, bHasAlready) local base = 0;
	if GetAIFlavour(iPlayer, "FLAVOR_DEFENSE") >= 7 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_GREAT_PEOPLE") >= 7 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_ESPIONAGE") >= 7 then
		base = base + 1;
	end
	local numtargets = 0;
	for gpid, sth in pairs(gT.Players[iPlayer].GreatPeople) do
		if gT.GreatPeople[gpid].Alive then
			if gT.GreatPeople[gpid].CanBeAssassinated then
				numtargets = numtargets + 1;
			end
		end
	end
	if numtargets > 3 then
		base = base + 1;
	end
	if bHasAlready or (gT.Players[iPlayer].NumAssassinatedGP > 0) then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 4 then
		return math.max(5, base + 1)
	end
	return math.min(5, base);
end,
[131] = function(iPlayer, bHasAlready) local base = 0;
	if gT.Players[iPlayer].AIStrategyValues.EnjoyRandom  then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.LikeBasicYields then
		base = base + 1;
	end
	if bHasAlready then
		base = base + 2;
	end
	if Players[iPlayer]:GetReligionCreatedByPlayer() > 0 or gT.Players[iPlayer].OfficialReligion then
		base = base + 2;
	end
	base = base + LastRandom(0,1);
	return math.min(5, base);
end,
[132] = function(iPlayer, bHasAlready) local base = 0;
	if gT.Players[iPlayer].AIFlavourValues.NumMilitaryUnits >= 20 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_CULTURE") >= 7 then
		base = base + 1;
	end
	if not gT.Players[iPlayer].AIStrategyValues[132] then
		gT.Players[iPlayer].AIStrategyValues[132] = LastRandom(0, 3);
	end
	base = base + gT.Players[iPlayer].AIStrategyValues[132];
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 15 then
		return math.max(5, base + 1)
	end
	return math.min(5, base);
end,
[133] = function(iPlayer, bHasAlready) local base = 0;
	return -5;
end,
[134] = function(iPlayer, bHasAlready) local base = 0;
	return -5;
end,
[135] = function(iPlayer, bHasAlready) local base = 0;
	return -5;
end,
[136] = function(iPlayer, bHasAlready) local base = 0;
	if GetAIFlavour(iPlayer, "FLAVOR_PRODUCTION") >= 7 then
		if GetAIFlavour(iPlayer, "FLAVOR_GROWTH") >= 7 then
			if not gT.Players[iPlayer].AIStrategyValues.EnjoyRandom then
				base = base + 3;
				if Players[iPlayer]:GetNumCities() > 5 then
					base = base + 2;
				end
			end
		end
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 9 then
		return math.max(5, base + 1)
	end
	return math.min(5, base);
end,
[137] = function(iPlayer, bHasAlready) local base = 0;
	if gT.Players[iPlayer].AIStrategyValues.LikeBasicYields then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.UnitsKilledPT > 0.4 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_GREAT_PEOPLE") >= 8 then
		base = base + 1;
	end
	if bHasAlready or Teams[Players[iPlayer]:GetTeam()]:GetAtWarCount(false) > 1 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.NumMilitaryUnits >= 15 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 4 then
		return math.max(5, base + 1)
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 13 then
		return math.max(5, base + 1)
	end
	return math.min(5, base);
end,
[138] = function(iPlayer, bHasAlready) local base = 0;
	if GetAIFlavour(iPlayer, "FLAVOR_GREAT_PEOPLE") >= 8 then
		base = base + 1 + math.floor(gT.Players[iPlayer].AIFlavourValues.AverageHappinessEmpire)
	else
		base = base - 1 + math.floor(gT.Players[iPlayer].AIFlavourValues.AverageHappinessEmpire)
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 4 then
		return math.max(5, base + 1)
	end
	return math.min(5, base);
end,
[139] = function(iPlayer, bHasAlready) local base = 0;
	if GetEstimatedColonyPointsPerTurn(iPlayer, true) >= 20 then
		base = base + 1;
	end
	if bHasAlready or (GetColonyITGTreshold(iPlayer) < 400) then
		base = base + 1;
	end
	if Players[iPlayer]:GetNumCities() > 4 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_HAPPINESS") >= 7 then
		base = base + 1;
	end
	if #gT.Players[iPlayer].NumWarsDeclaredOn == 0 then
		base = base + 1;
	end
	return math.min(5, base);
end,
[140] = function(iPlayer, bHasAlready) local base = 0;
	if GetAIFlavour(iPlayer, "FLAVOR_GREAT_PEOPLE") >= 8 then
		base = base + 2;
	end
	local numgptomigrateaway = 0;
	for gpID, hhh in pairs(gT.Players[iPlayer].GreatPeople) do
		local gd = gT.GreatPeople[gpID];
		if gd.Alive and (not gd.Military) then
			if not gd.LifeDone then
				numgptomigrateaway = numgptomigrateaway + 1;
			end
		end
	end
	if numgptomigrateaway > 8 then
		base = base + 2;
	elseif numgptomigrateaway > 5 then
		base = base + 1;
	end
	if Players[iPlayer]:GetNumCities() < 4 then
		base = base + 1;
	end
	if (bHasAlready) or (gT.Players[iPlayer].GPMigratedTo < gT.Players[iPlayer].GPMigratedAway) then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 4 then
		return math.max(5, base + 1)
	end
	return math.min(5, base);
end,
[141] = function(iPlayer, bHasAlready) local base = 0;
	return -5;
end,
[142] = function(iPlayer, bHasAlready) local base = 0;
	if GetAIFlavour(iPlayer, "FLAVOR_SCIENCE") >= 7 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_CULTURE") >= 7 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.EnjoyRandom then
		base = base + 1;
	end
	if not gT.Players[iPlayer].AIStrategyValues.LikeBasicYields then
		base = base + 1;
	end
	if (bHasAlready) or (gT.Players[iPlayer].NumFirstTechs > 1) then
		base = base + 1;
	end
	return math.min(5, base);
end,
[143] = function(iPlayer, bHasAlready) local base = 0;
	if GetAIFlavour(iPlayer, "FLAVOR_MILITARY_TRAINING") >= 7 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_MILITARY_OFFENSE") >= 7 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.EnjoyRandom then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.NumMilitaryUnits > 17 then
		base = base + 1;
	end
	if Teams[Players[iPlayer]:GetTeam()]:GetAtWarCount(false) > 1 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 7 then
		return math.max(5, base + 1)
	end
	return math.min(5, base);
end,
[144] = function(iPlayer, bHasAlready) local base = 0;
	local exb = gT.Players[iPlayer].NumGreatWorks;
	base = base + math.floor(exb / 9)
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 3 then
		return math.max(5, base + 1)
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 10 then
		return math.max(5, base + 1)
	end
	return math.min(5, base);
end,
[145] = function(iPlayer, bHasAlready) local base = 0;
	return -5;
end,
[146] = function(iPlayer, bHasAlready) local base = 0;
	if GetAIFlavour(iPlayer, "FLAVOR_LEGAL") >= 6 then
		base = base + 1;
	end
	local mPt = GetMeritocracyChangePerTurn(iPlayer);
	if bHasAlready then
		mPt = mPt - 1;
	end
	if mPt < -3 then
		base = base + 2;
	elseif mPt < 0 then
		base = base + 1;
	end
	if gT.Players[iPlayer].MeritocracyLevel < 20 then
		base = base + 2;
	elseif gT.Players[iPlayer].MeritocracyLevel < 50 then
		base = base + 1;
	end
	return math.min(5, base);
end,
[147] = function(iPlayer, bHasAlready) local base = 0;
	if gT.Players[iPlayer].AIStrategyValues.EnjoyRandom then
		base = base + 2;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_OFFENSE") >= 6 then
		base = base + 1;
	end
	if Players[iPlayer]:GetNumCities() > 4 then
		base = base + 1;
	end
	if not gT.Players[iPlayer].AIStrategyValues[147] then
		gT.Players[iPlayer].AIStrategyValues[147] = LastRandom(0, 2);
	end
	base = base + gT.Players[iPlayer].AIStrategyValues[147];
	return math.min(5, base);
end,
[148] = function(iPlayer, bHasAlready) local base = 0;
--this one mathematically is very weak;
	if gT.Players[iPlayer].AIStrategyValues.EnjoyRandom then
		if GetAIFlavour(iPlayer, "FLAVOR_OFFENSE") >= 8 then
			if #gT.Players[iPlayer].NumWarsDeclared > 0 then
				if LastRandom(1,3) == 2 then
					base = base + 5;
				end
			end
		end
	end
	return math.min(5, base);
end,
[149] = function(iPlayer, bHasAlready) local base = 0;
	if GetAIFlavour(iPlayer, "FLAVOR_WONDER") >= 8 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.LikeBasicYields then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.WorkRate then
		base = base + 1;
	end
	if Players[iPlayer]:GetNumCities() > 3 then
		if Players[iPlayer]:GetNumCities() > 5 then
			base = base + 2;
		else
			base = base + 1;
		end
	end
	return math.min(5, base);
end,
[150] = function(iPlayer, bHasAlready) local base = 0;
	local numfj = 0;
	for iCity in Players[iPlayer]:Cities() do
		for i = 0, 5 do
			local nPlot = Map.PlotDirection(iCity:GetX(), iCity:GetY(), i);
			if nPlot and (nPlot:GetFeatureType() == fForest or nPlot:GetFeatureType() == fJungle) then
				numfj = numfj + 1;
			end
		end
	end
	if numfj > 15 then
		base = base + 2;
	elseif numfj > 6 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_MOBILE") >= 7 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_DEFENSE") >= 7 then
		base = base + 1;
	end		
	if GetAIFlavour(iPlayer, "FLAVOR_INFRASTRUCTURE") >= 7 then
		base = base + 1;
	end		
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 11 then
		return math.max(5, base + 1)
	end
	return math.min(5, base);
end,
[151] = function(iPlayer, bHasAlready) local base = 0;
	return -5;
end,
[152] = function(iPlayer, bHasAlready) local base = 0;
	if gT.Players[iPlayer].AIFlavourValues.UnitsLostPT >= 0.5 then
		base = base + 2;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_DEFENSE") >= 6 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.EnjoyRandom then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.NumMilitaryUnits >= 20 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 7 then
		return math.max(5, base + 1)
	end	
	return math.min(5, base);
end,
[153] = function(iPlayer, bHasAlready) local base = 0;
	if GetAIFlavour(iPlayer, "FLAVOR_FOOD") >= 7 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_RELIGION") >= 7 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.LikeBasicYields then
		base = base + 1;
	end
	local acc = 0;
	for iPlotIndex, sth in pairs(gT.Globals.AncientRuins) do
		local iPlot = Map.GetPlotByIndex(iPlotIndex)
		if iPlot:GetOwner() == iPlayer then
			if iPlot:IsPlayerCityRadius(iPlayer) then
				acc = acc + 1;
			end
		end
	end
	if acc == 0 then
		return 1;
	elseif acc > 3 then
		base = base + 2;
	end
	return math.min(5, base);
end,
[154] = function(iPlayer, bHasAlready) local base = 0;
	return -5;
end,
[155] = function(iPlayer, bHasAlready) local base = 0;
	local perHolySite = 0.25;
	if GetAIFlavour(iPlayer, "FLAVOR_CULTURE") >= 7 then
		perHolySite = perHolySite + 0.25;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_RELIGION") >= 7 then
		perHolySite = perHolySite + 0.25;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_DISRUPTIVE") >= 7 then
		perHolySite = perHolySite + 0.25;
	end
	base = math.floor(perHolySite * GetNumSpecialControlPoint(iPlayer, "HolySites", true))
	if base > 0 then
		if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 15 then
			return math.max(5, base + 1)
		end
	end
	return math.min(5, base);
end,
[156] = function(iPlayer, bHasAlready) local base = 0;
	if GetAIFlavour(iPlayer, "FLAVOR_OFFENSE") >= 7 then
		base = base + math.floor(gT.Players[iPlayer].AIFlavourValues.GWnextTime / 1.2)
	else
		base = base + math.floor(gT.Players[iPlayer].AIFlavourValues.GWnextTime / 1.8)
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 8 then
		return math.max(5, base + 1)
	end
	return math.min(5, base);
end,
[157] = function(iPlayer, bHasAlready) local base = 0;
	if GetAIFlavour(iPlayer, "FLAVOR_CULTURE") >= 7 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_RELIGION") >= 7 then
		base = base + 1;
	end
	if Players[iPlayer]:GetNumCities() > 5 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.LikeBasicYields then
		base = base + 1;
	end
	if not gT.Players[iPlayer].AIStrategyValues.EnjoyRandom then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 10 then
		return math.max(5, base + 1)
	end
	return math.min(5, base);
end,
[158] = function(iPlayer, bHasAlready) local base = 0;	
	if gT.Players[iPlayer].AIFlavourValues.Late then
		base = base + 1;
	end
	if bHasAlready or (gT.Players[iPlayer].NumUnitsUpdated == 0) then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_GOLD") >= 7 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_MILITARY_TRAINING") >= 7 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.NumMilitaryUnits >= 15 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 13 then
		return math.max(5, base + 1)
	end
	return math.min(5, base);
end,
[159] = function(iPlayer, bHasAlready) local base = 0;	
	if gT.Players[iPlayer].Morale >= 15 then
		base = base + 2;
		if gT.Players[iPlayer].AIStrategyValues.EnjoyRandom then
			base = base + 1;
		end
		local avgmorale = gT.Players[iPlayer].AverageMorale / math.max(gT.Players[iPlayer].AverageTurnCounted, 1)
		base = base + math.floor(avgmorale / 4) - 3
	end
	return math.min(5, base);
end,
[160] = function(iPlayer, bHasAlready) local base = 0;	
	if gT.Players[iPlayer].AIStrategyValues.LikeBasicYields then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_HAPPINESS") >= 7 then
		base = base + 1;
	end
	local avgmorale = gT.Players[iPlayer].AverageMorale / math.max(gT.Players[iPlayer].AverageTurnCounted, 1)
	if avgmorale < 3 then
		return 1;
	elseif avgmorale < 8 then
		base = base + 1;
	elseif avgmorale < 11 then
		base = base + 2;
	else
		base = base + 3;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 3 then
		return math.max(5, base + 1)
	end
	return math.min(5, base);
end,
[161] = function(iPlayer, bHasAlready) local base = 0;	
	if GetAIFlavour(iPlayer, "FLAVOR_OFFENSE") >= 7 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_DEFENSE") >= 7 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_MILITARY_TRAINING") >= 7 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.LikeBasicYields then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.NumMilitaryUnits <= 15 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 7 then
		return math.max(5, base + 1)
	end
	return math.min(5, base);
end,
[162] = function(iPlayer, bHasAlready) local base = 0;	
	if GetAIFlavour(iPlayer, "FLAVOR_OFFENSE") >= 7 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_MILITARY_TRAINING") >= 7 then
		base = base + 1;
	end
	if not gT.Players[iPlayer].AIStrategyValues.LikeBasicYields then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.NumMilitaryUnits >= 15 then
		base = base + 1;
	end
	if bHasAlready or (LastRandom(1,3) == 2) then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 7 then
		return math.max(5, base + 1)
	end
	return math.min(5, base);
end,
[163] = function(iPlayer, bHasAlready) local base = 0;	
	if bHasAlready then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.Early then
		base = base + 1;
	end
	local fScience = GetAIFlavour(iPlayer, "FLAVOR_SCIENCE");
	if (fScience >= 8) or (fScience <= 3) then
		base = base + 1;
	end
	if Players[iPlayer]:GetNumCities() < 4 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.LikeBasicYields then
		base = base + 1;
	end
	if not gT.Players[iPlayer].AIStrategyValues.EnjoyRandom then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 10 then
		return math.max(5, base + 1)
	end
	return math.min(5, base);
end,
[164] = function(iPlayer, bHasAlready) local base = 0;
	local tot, dis = 0, 0;
	for type, a in pairs(gT.Globals.NaturalWonders) do
		tot = tot + 1;
		if gT.Players[iPlayer].DiscoveredNaturalWonders[a] then
			dis = dis + 1;
		end
	end
	return math.min(5, math.floor(tot / 3 + dis))
end,
[165] = function(iPlayer, bHasAlready) local base = 0;	
	if (gT.Players[iPlayer].CultureType == 3) or (gT.Players[iPlayer].CultureType == 4) then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.EnjoyRandom then
		base = base + 1;
	end
	if Teams[Players[iPlayer]:GetTeam()]:GetAtWarCount(false) > 1 then
		base = base + 1;
	end
	if gT.Players[iPlayer].OfficialReligion or (Players[iPlayer]:GetReligionCreatedByPlayer() > 0) then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_OFFENSE") >= 7 then
		base = base + 1;
	end
	return math.min(5, base)
end,
[166] = function(iPlayer, bHasAlready) local base = 0;	
	if gT.Players[iPlayer].Morale < gT.Players[iPlayer].MaxMoraleRange - 5 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_RECON") >= 7 then
		base = base + 1;
	end
	if Teams[Players[iPlayer]:GetTeam()]:GetAtWarCount(false) < 2 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.Early then
		base = base + 1;
	end
	local visit = 0;
	base = base + 1;
	local iTeam = Players[iPlayer]:GetTeam();
	for a, b in pairs(gT.Globals.AncientRuins) do
		if Map.GetPlotByIndex(a):AlreadyVisitedGoodyHut(iTeam) then
			visit = visit + 1;
			if visit > 12 then
				base = base - 1;
				break;
			end
		end
	end
	return math.min(5, base)
end,
[167] = function(iPlayer, bHasAlready) local base = 0;
	if bHasAlready or gT.Players[iPlayer].AIFlavourValues.Early then
		if GetAIFlavour(iPlayer, "FLAVOR_SCIENCE") >= 7 then
			local htt = gT.Players[iPlayer].AIFlavourValues.GeneralPointsPT + gT.Players[iPlayer].AIFlavourValues.AdmiralPointsPT
			base = base + math.floor(htt / 9)
		end
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 5 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[168] = function(iPlayer, bHasAlready) local base = 0;
	local aca = GetNumManufactories(iPlayer)
	if GetAIFlavour(iPlayer, "FLAVOR_DEFENSE") >= 7 then
		base = base + aca;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_HAPPINESS") >= 7 then
		base = base + aca;
	end
	return math.min(5, base)
end,
[169] = function(iPlayer, bHasAlready) local base = 0;	
	return -5;
end,
[170] = function(iPlayer, bHasAlready) local base = 0;	
	if HasMintAnyCity(iPlayer) then
		if gT.Players[iPlayer].AIStrategyValues.LikeBasicYields then
			base = base + 1;
		end
		if GetAIFlavour(iPlayer, "FLAVOR_GOLD") >= 8 then
			base = base + 1;
		end
		if not gT.Players[iPlayer].AIFlavourValues.Late then
			base = base + 1;
		end
		if GetNumGraphData(iPlayer, 13, 0) < 10 then
			base = base + 1;
		end
		if Players[iPlayer]:GetNumCities() > 3 then
			base = base + 1;
		end
	end
	return math.min(5, base)
end,
[171] = function(iPlayer, bHasAlready) local base = 0;	
	return -5;
end,
[172] = function(iPlayer, bHasAlready) local base = 0;
	if GetAIFlavour(iPlayer, "FLAVOR_CULTURE") >= 7 then
		base = base + 1;
	end
	local bA = 0;
	for iCity in Players[iPlayer]:Cities() do
		if iCity:GetOriginalOwner() == iPlayer then
			base = base + 0.75;
			local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
			bA = math.max(bA, gT.Cities[cID].NumAttackesEverMade)
		end
	end
	base = math.floor(base + bA / math.max(1,GetITGGameTurn()) * 10);
	return math.min(5, base)
end,
[173] = function(iPlayer, bHasAlready) local base = 0;	
	return -5;
end,
[174] = function(iPlayer, bHasAlready) local base = 0;	
	if gT.Globals.NumPlayersMajor > 12 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_DISRUPTIVE") >= 7 then
		base = base + 2;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_RELIGION") >= 7 then
		base = base + 2;
	end
	return math.min(5, base)
end,
[175] = function(iPlayer, bHasAlready) local base = 0;	
	if (gT.Players[iPlayer].AIFlavourValues.UnitCombatsCount[GameInfoTypes.UNITCOMBAT_SIEGE] or 0) > 7 then
		base = base + 3;
	end
	if gT.Players[iPlayer].NumConquered > 0 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_MOBILE") >= 7 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 8 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[176] = function(iPlayer, bHasAlready) local base = 0;	
	return -5;
end,
[177] = function(iPlayer, bHasAlready) local base = 0;	
	if Players[iPlayer]:GetNumCities() > 4 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_EXPANSION") >= 8 then
		base = base + 1;
	end
	if (gT.Players[iPlayer].AISettlerPointsManagement) and (gT.Players[iPlayer].AISettlerPointsManagement.Type == 1 ) then
		base = base + 2;
	end
	local totfood = 0;
	for iCity in Players[iPlayer]:Cities() do
		totfood = totfood + math.max(iCity:FoodDifference(), 0)
	end
	if totfood >= 40 then
		base = base + 2;
	end
	return math.min(5, base)
end,
[178] = function(iPlayer, bHasAlready) local base = 0;	
	if gT.Players[iPlayer].AIStrategyValues.EnjoyRandom then
		base = base + 1;
	end
	if gT.Players[iPlayer].LHCombatNaval / math.max(GetITGGameTurn(), 1) > 0.2 then
		base = base + 1;
	end
	if (gT.Players[iPlayer].AIFlavourValues.UnitCombatsCount[GameInfoTypes.UNITCOMBAT_NAVALMELEE] or 0) > 8 then
		base = base + 2;
	end
	if Players[iPlayer]:GetBuildingClassCount(GameInfoTypes.BUILDINGCLASS_LIGHTHOUSE) >= 3 then
		base = base + 1;
	end		
	return math.min(5, base)
end,
[179] = function(iPlayer, bHasAlready) local base = 0;	
	if gT.Players[iPlayer].AIStrategyValues.EnjoyRandom then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.UnitsKilledPT > 0.4 then
		base = base + 1;
	end
	if bHasAlready or Teams[Players[iPlayer]:GetTeam()]:GetAtWarCount(false) > 1 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.NumMilitaryUnits >= 15 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_OFFENSE") >= 7 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 13 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[180] = function(iPlayer, bHasAlready) local base = 0;	
	if gT.Players[iPlayer].AIStrategyValues.EnjoyRandom then
		if GetAIFlavour(iPlayer, "FLAVOR_OFFENSE") >= 8 then
			if GetAIFlavour(iPlayer, "FLAVOR_GREAT_PEOPLE") >= 8 then
				if gT.Players[iPlayer].AIFlavourValues.NumMilitaryUnits > 12 then
					base = base + 5;
				end
			end
		end
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 5 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[181] = function(iPlayer, bHasAlready) local base = 0;
	if Players[iPlayer]:GetNumCities() < 4 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.FestivalPT >= 0.08 then
		base = base + 1;
	end
	if bHasAlready or gT.Players[iPlayer].AIFlavourValues.Early then
		base = base + 1;
	end
	if gT.Players[iPlayer].FestivalBonusesActive[2] then
		base = base + 1;
	end
	if gT.Players[iPlayer].FestivalBonusesActive[3] then
		base = base + 1;
	end
	if gT.Players[iPlayer].FestivalBonusesActive[4] then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_HAPPINESS") >= 8 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 2 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[182] = function(iPlayer, bHasAlready) local base = 0;
	return math.min(5, base)
end,
[183] = function(iPlayer, bHasAlready) local base = 0;
	if Players[iPlayer]:GetNumCities() > 6 then
		base = base + 1;
	end
	if gT.Players[iPlayer].FestivalBonusesActive[2] then
		base = base + 1;
	end
	if gT.Players[iPlayer].FestivalBonusesActive[3] then
		base = base + 1;
	end
	if gT.Players[iPlayer].FestivalBonusesActive[4] then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.GPmigrateToPT >= 0.1 then
		base = base + 2;
	end
	if gT.Players[iPlayer].AIStrategyValues.EnjoyRandom then
		base = base + 1;
	end
	return math.min(5, base)
end,
[184] = function(iPlayer, bHasAlready) local base = 0;
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		if gT.Cities[cID].CultureOwner ~= iPlayer then
			base = base + 1
		end
		if iCity:GetFaithPerTurn() > 5 then
			base = base + 1;
		end
	end
	base = math.floor(base / 2);
	return math.min(5, base)
end,
[185] = function(iPlayer, bHasAlready) local base = 0;	
	base = base + 1;
	if GetAIFlavour(iPlayer, "FLAVOR_GREAT_PEOPLE") >= 8 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_CULTURE") >= 8 then
		base = base + 1;
	end
	if GetReliableFestivalChance(iPlayer) >= 30 then
		base = base + 2;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 4 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[186] = function(iPlayer, bHasAlready) local base = 0;	
	if (GetNumOwnResourcesLuxury(iPlayer) >= 5) then
		base = base + 1
	end
	if Players[iPlayer]:GetNumCities() < 4 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.FestivalPT >= 0.08 then
		base = base + 1;
	end
	if bHasAlready or gT.Players[iPlayer].AIFlavourValues.Early then
		base = base + 1;
	end
	if bHasAlready or (not gT.Players[iPlayer].FestivalBonusesActive[2]) or (not gT.Players[iPlayer].FestivalBonusesActive[3]) or (not gT.Players[iPlayer].FestivalBonusesActive[4])  then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 2 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[187] = function(iPlayer, bHasAlready) local base = 0;	
	return math.min(5, base)
end,
[188] = function(iPlayer, bHasAlready) local base = 0;	
	if GetAIFlavour(iPlayer, "FLAVOR_OFFENSE") >= 8 then
		base = base + 1;
	end
	if gT.Players[iPlayer].MeleeCombatsP > 2 * gT.Players[iPlayer].RangedCombatP then
		base = base + 2;
		if gT.Players[iPlayer].MeleeCombatsP / math.max(GetITGGameTurn(), 1) >= 1 then
			base = base + 1;
		end
	end
	if gT.Players[iPlayer].AIFlavourValues.NumMilitaryUnits > 15 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 7 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[189] = function(iPlayer, bHasAlready) local base = 0;	
	if bHasAlready or (gT.Players[iPlayer].AIFlavourValues.UnitCombatsCount[GameInfoTypes.UNITCOMBAT_MELEE] or 0) > 11 then
		base = base + 1;
	end
	if gT.Players[iPlayer].UniqueNumConquered > 1 then
		base = base + 1;
	end
	if gT.Players[iPlayer].NumConquered > 3 then
		base = base + 1;
	end
	if bHasAlready or Teams[Players[iPlayer]:GetTeam()]:GetAtWarCount(false) > 1 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.LikeBasicYields then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 7 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[190] = function(iPlayer, bHasAlready) local base = 0;
	return -5;
end,
[191] = function(iPlayer, bHasAlready) local base = 0;
	if GetAIFlavour(iPlayer, "FLAVOR_MOBILE") >= 8 then
		base = base + 2;
	end
	if gT.Players[iPlayer].MeleeCombatsP > gT.Players[iPlayer].RangedCombatP then
		base = base + 1;
	end
	if (gT.Players[iPlayer].AIFlavourValues.UnitCombatsCount[GameInfoTypes.UNITCOMBAT_MOUNTED] or 0) > 8 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.GeneralPointsPT >= 20 then
		base = base + 1;
	end
	if Players[iPlayer]:GetNumResourceTotal(rHorse) >= 12 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 7 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[192] = function(iPlayer, bHasAlready) local base = 0;
	return math.min(5, base)
end,
[193] = function(iPlayer, bHasAlready) local base = 0;
	if gT.Globals.ScenarioType == 2 then
		return 5;
	end	
	if gT.Players[iPlayer].AIStrategyValues.EnjoyRandom then
		if GetAIFlavour(iPlayer, "FLAVOR_FOOD") >= 8 then
			if gT.Players[iPlayer].AIFlavourValues.Early or gT.Players[iPlayer].AIFlavourValues.Late then
				if Players[iPlayer]:GetNumCities() > 3 then
					base = base + 5;
				end
			end
		end
	end
	return math.min(5, base)
end,
[194] = function(iPlayer, bHasAlready) local base = 0;
	if Players[iPlayer]:GetNumCities() > 7 then
		if gT.Players[iPlayer].AIStrategyValues.EnjoyRandom then
			if gT.Players[iPlayer].AIFlavourValues.Early then
				if GetAIFlavour(iPlayer, "FLAVOR_FOOD") >= 8 then
					base = base + LastRandom(4, 5)
				end
			end
		end
	end
	return math.min(5, base)
end, 
[195] = function(iPlayer, bHasAlready) local base = 0;
	if bHasAlready or Teams[Players[iPlayer]:GetTeam()]:GetAtWarCount(false) > 1 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIFlavourValues.NumMilitaryUnits > 15 then
		base = base + 1;
	end
	if gT.Players[iPlayer].UniqueNumConquered > 1 then
		base = base + 1;
	end
	if gT.Players[iPlayer].PillagedImpros > 10 then
		base = base + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_FOOD") >= 8 then
		base = base + 1;
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 13 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[196] = function(iPlayer, bHasAlready) local base = 0;
	return math.min(5, base)
end,
[197] = function(iPlayer, bHasAlready) local base = 0;
	local aca = GetNumActiveAcademies(iPlayer) + GetNumManufactories(iPlayer) + GetNumCustomsHouses(iPlayer)
	if GetAIFlavour(iPlayer, "FLAVOR_GREAT_PEOPLE") >= 8 then
		base = base + math.floor(1 * aca)
	else
		base = base + math.floor(0.7 * aca)
	end
	return math.min(5, base)
end,
[198] = function(iPlayer, bHasAlready) local base = 0;
	local numMerc = 0;
	for iUnit in Players[iPlayer]:Units() do
		if iUnit:IsMercenary() then
			base = base + 1;
		end
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 13 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[199] = function(iPlayer, bHasAlready) local base = 0;
	local nmpt = gT.Players[iPlayer].NumMercTotal / math.max(1, GetITGGameTurn());
	if GetAIFlavour(iPlayer, "FLAVOR_GOLD") >= 8 then
		if gT.Players[iPlayer].AIStrategyValues.LikeBasicYields then
			base = base + math.floor(nmpt * 50)
		else
			base = base + math.floor(nmpt * 500 / 12)
		end
	else
		base = base + math.floor(nmpt * 500 / 13)
	end
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 13 then
		return math.max(5, base + 1)
	end
	return math.min(5, base)
end,
[200] = function(iPlayer, bHasAlready) local base = gT.Players[iPlayer].NumMercTotal;
	return math.min(5, base)
end,
}

function GetAIValueForCultureBonus(iPlayer, cultid)
	local aiVal = GetAIValueForCultureBonusTable[cultid](iPlayer, (gT.Players[iPlayer].CultBonusOn[cultid] ~= nil))
	gT.DiagnosisAISP[cultid][1] = gT.DiagnosisAISP[cultid][1] + 1;
	gT.DiagnosisAISP[cultid][2] = gT.DiagnosisAISP[cultid][2] + aiVal;
	gT.DiagnosisAISP[cultid][3] = math.max(aiVal, gT.DiagnosisAISP[cultid][3])
	return aiVal;
end

function DefineCulturalGroupsForVoting()
	local totPlayers = 0;
	local cgTypes = {}
	for g, h in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			totPlayers = totPlayers + 1;
			local gType = 100 * h.CultureType + (h.SubcultureType or 0);
			if not cgTypes[gType] then
				cgTypes[gType] = {};
			end
			table.insert(cgTypes[gType], g) 
		end
	end
	local cGroups = {};
	local leftovers = {}
	for i, v in pairs(cgTypes) do
		if #v >= 3 then
			table.insert(cGroups, {})
			for j, b in pairs(v) do
				table.insert(cGroups[#cGroups], b);
			end
		else
			local cType = gT.Players[v[1]].CultureType;
			if not leftovers[cType] then
				leftovers[cType] = {};
			end
			for j, b in pairs(v) do
				table.insert(leftovers[cType], b);
			end
		end
	end
	local iLeft = 0;
	for cType, players in pairs(leftovers) do
		if #players >= 3 then
			local iAddTo = #cGroups + 1;
			table.insert(cGroups, {});
			for j, b in pairs(players) do
				table.insert(cGroups[iAddTo], b);
			end
		else
			iLeft = iLeft + #players;
		end
	end	
	if iLeft >= 3 then
		local iAddTo = #cGroups + 1;
		table.insert(cGroups, {});
		for cType, players in pairs(leftovers) do
			if #players < 3 then
				for j, b in pairs(players) do
					table.insert(cGroups[iAddTo], b);
				end
			end
		end	
	else
		for cType, players in pairs(leftovers) do
			if #players < 3 then
				local iAddTo;
				local min = 999;
				for i, v in pairs(cGroups) do
					local eVal = 100 + #v * 50;
					if cType == gT.Players[v[1]].CultureType then
						eVal = eVal - 50;
					end
					if eVal < min then
						min = eVal;
						iAddTo = i;
					end
				end
				for j, b in pairs(players) do
					table.insert(cGroups[iAddTo], b);
				end
			end
		end
	end
	for i, v in pairs(cGroups) do
		for j, player in pairs(v) do
			gT.Players[player].CultGroup = i;
		end
	end
end

function GreatOverCultureBonusFunctionDoTurn()
	local gTurn = GetITGGameTurn();
	if gT.Globals.GrandCultBonusVote[gTurn] then
		local hcType = {}
		for i, data in pairs(gT.Globals.GrandCultBonusVote[gTurn]) do
			local gType = gT.Players[data[1]].CultGroup;    --CultureType;
			if not hcType[gType] then
				hcType[gType] ={};
			end
			table.insert(hcType[gType], data);
		end
		local takenCareOf = {}
		for i, data in pairs(hcType) do
			DoNiceCultureVoteFromData(data, i)
			takenCareOf[i] = true;
		end
		for g, h in pairs(gT.Players) do
			if h.CultGroup and (not takenCareOf[h.CultGroup]) then
				--very safelocked :)
				takenCareOf[h.CultGroup] = true;
				DoTakeCareOfDeadCultureVote({}, h.CultGroup, nil)
			end
		end
	end
	if validTurnsforCQueue[gTurn] then
		if not DBScenario.CultDevelopOff then
			gT.Globals.GrandCultBonusVote[gTurn + 1] = {}
			for g, gdata in pairs(gT.Players) do
				if Players[g]:IsAlive() then
					if not Players[g]:IsMinorCiv() then
						table.insert(gT.Players[g].CultureBonusQueue, 1);
					end
				end
			end
		end
	end
end

function GetNewCulturalBonusOptionAI(iPlayer)
	local hTab = {}
	if gT.Players[iPlayer].AIStrategyValues.GrandStrategy == 1 then
		for h, data in pairs(RequestCultureTypeData()) do
			if not gT.Players[iPlayer].CultBonusOn[data.ID] then
				if MeetTheRequirementsCultureBonus(iPlayer, data.ID) then
					table.insert(hTab, data.ID)
				end
			end
		end
		return hTab[LastRandom(1,#hTab)];
	else 
		for h, data in pairs(RequestCultureTypeData()) do
			if not gT.Players[iPlayer].CultBonusOn[data.ID] then
				if MeetTheRequirementsCultureBonus(iPlayer, data.ID) then
					table.insert(hTab, {data.ID, GetAIValueForCultureBonus(iPlayer, data.ID)})
				end
			end
		end
	end
	hTab = Shuffle(hTab);
	table.sort(hTab, SortFunctionForGreaterInteger2);
	return hTab[1][1];
end

function CultureBonusFunctionDoTurn(iPlayer)
	if not Players[iPlayer]:IsHuman() then
		if #gT.Players[iPlayer].CultureBonusQueue > 0 then
			GenerateBaseAIFlavourValues(iPlayer)
			for i, type in pairs(gT.Players[iPlayer].CultureBonusQueue ) do
				if type == 1 then
					if gT.Globals.GrandCultBonusVote[GetITGGameTurn()] then
						table.insert(gT.Globals.GrandCultBonusVote[GetITGGameTurn()], {iPlayer, GetNewCulturalBonusOptionAI(iPlayer)}) 
					else
						print("AI tried to vote even if there is no voting :(, some errors earlier? - could be resurrection", iPlayer)
					end
				elseif type == 2 then
					print("Is it firing? How? 3452344532")
					gT.Players[iPlayer].LHRechosenCB = gT.Players[iPlayer].LHRechosenCB + 1;
					AddCultureBonusToPlayer(iPlayer, hTab[1][1], 2)
				end
			end
			gT.Players[iPlayer].CultureBonusQueue = {};
		end
	end
end

function DoNiceCultureVoteFromData(btab, cGroupType)
	local tab = {}
	for i, data in pairs(btab) do
		tab[data[1]] = data[2];
	end
	local total, max = 0, 0;
	for iPlayer, vote in pairs(tab) do
		total = total + gT.Players[iPlayer].NatUnity;
		if gT.Players[iPlayer].NatUnity > max then
			max = gT.Players[iPlayer].NatUnity;
		end
	end
	local VoteValue = {};
	local tv = 0;
	for iPlayer, cvote in pairs(tab) do
		local vote = math.ceil(gT.Players[iPlayer].NatUnity * 100 / total)
		if gT.Players[iPlayer].NatUnity == max then
			vote = vote + 10; 
		end
		if not VoteValue[cvote] then
			VoteValue[cvote] = vote;
		else
			VoteValue[cvote] = VoteValue[cvote] + vote;
		end
		tv = tv + vote;
	end
	local hTab = {}
	for j,k in pairs(VoteValue)	do
		table.insert(hTab, {j,k})
	end
	local chosen = nil;
	if #hTab > 1 then
		table.sort(hTab, SortFunctionForGreaterInteger2)
		if hTab[1][2] == hTab[2][2] then
			local acScPerks = {};
			for iPlayer, vote in pairs(tab) do
				gT.Players[iPlayer].LHOwnChosenCB = gT.Players[iPlayer].LHOwnChosenCB + 1;
				AddCultureBonusToPlayer(iPlayer, vote, 2)
				table.insert(acScPerks, vote);
				if Players[iPlayer]:IsHuman() then
					gT.Players[iPlayer].SocDevPopup = {Type = 1, Acquired = vote, PerkData = {}, Chosen = vote, CanBeChanged = false}
					for ijh, vData in pairs(hTab) do
						table.insert(gT.Players[iPlayer].SocDevPopup.PerkData, vData);
					end
					local str = "Your cultural group is strongly divided, many different social developments were achieved. Your people believe in " .. RequestCultureTypeData(vote, "Name") .. " (" .. VoteValue[vote] .. "/" .. tv .. ").[NEWLINE][NEWLINE]As you choose this social development, you are not able to replace it.";
					Players[iPlayer]:AddNotification(94343293,str, "Social Development", -1, -1, 6, iPlayer)
				end
			end
			DoTakeCareOfDeadCultureVote(tab, cGroupType, RandomFromTab(acScPerks))
			return;
		else
			chosen = hTab[1][1];
		end
	else
		chosen = hTab[1][1];
	end
	for iPlayer, vote in pairs(tab) do
		if not gT.Players[iPlayer].CultBonusOn[chosen] then
			if vote == chosen then
				VictoryTaskCompletion(iPlayer, 50)
				gT.Players[iPlayer].LHOwnChosenCB = gT.Players[iPlayer].LHOwnChosenCB + 1;
				AddCultureBonusToPlayer(iPlayer, chosen, 2)
				if Players[iPlayer]:IsHuman() then
					gT.Players[iPlayer].SocDevPopup = {Type = 2, Acquired = chosen, PerkData = {}, Chosen = vote, CanBeChanged = false}
					for ijh, vData in pairs(hTab) do
						table.insert(gT.Players[iPlayer].SocDevPopup.PerkData, vData);
					end
					local str = "You set a direction for your cultural group, developing " .. RequestCultureTypeData(chosen, "Name") .. " (" .. VoteValue[chosen] .. "/" .. tv .. ").[NEWLINE][NEWLINE]As you choose this social development, you are not able to replace it.";
					Players[iPlayer]:AddNotification(94343293,str, "Social Development", -1, -1, 6,iPlayer)
				end
			else
				AddCultureBonusToPlayer(iPlayer, chosen, 1)
				if Players[iPlayer]:IsHuman() then
					gT.Players[iPlayer].SocDevPopup = {Type = 3, Acquired = chosen, PerkData = {}, Chosen = vote, CanBeChanged = true}
					for ijh, vData in pairs(hTab) do
						table.insert(gT.Players[iPlayer].SocDevPopup.PerkData, vData);
					end
					local str = "Your cultural group has developed new social bonus, " .. RequestCultureTypeData(chosen, "Name") .. " (" .. VoteValue[chosen] .. "/" .. tv .. ").[NEWLINE][NEWLINE]You are able to replace it with Cultural bonus.";
					Players[iPlayer]:AddNotification(94343293,str, "Social Development",-1,-1,6)
				end
			end
		else
			if not gT.Players[iPlayer].CultBonusOn[vote] then
				gT.Players[iPlayer].LHOwnChosenCB = gT.Players[iPlayer].LHOwnChosenCB + 1;
				AddCultureBonusToPlayer(iPlayer, vote, 2)
				if Players[iPlayer]:IsHuman() then
					gT.Players[iPlayer].SocDevPopup = {Type = 4, Acquired = vote, PerkData = {}, Chosen = vote, CanBeChanged = false}
					for ijh, vData in pairs(hTab) do
							table.insert(gT.Players[iPlayer].SocDevPopup.PerkData, vData);
					end
					local str = "The rest of your cultural group is so backward, the majority of it developed skills that your people knows for decades (" .. RequestCultureTypeData(chosen, "Name") .. "). You decided that " .. RequestCultureTypeData(vote, "Name") .. " (" .. VoteValue[vote] .. "/" .. tv .. ") is the best choice for future.[NEWLINE][NEWLINE]As you choose this social development, you are not able to replace it.";
					Players[iPlayer]:AddNotification(94343293,str, "Social Development",-1,-1, 6,iPlayer)
				end
			else
				local rPerk = GetRandomSocialDevelopment(iPlayer)
				AddCultureBonusToPlayer(iPlayer, rPerk, 1)
				if Players[iPlayer]:IsHuman() then
					gT.Players[iPlayer].SocDevPopup = {Type = 5, Acquired = rPerk, PerkData = {}, Chosen = vote, CanBeChanged = true}
					for ijh, vData in pairs(hTab) do
							table.insert(gT.Players[iPlayer].SocDevPopup.PerkData, vData);
					end
					local str = "It seems you already have a social development you wanted to adopt (" .. RequestCultureTypeData(vote, "Name") .. "). In this case your people developed a random trait: " .. RequestCultureTypeData(rPerk, "Name") .. ".[NEWLINE][NEWLINE]You are able to replace it with Cultural bonus.";
					Players[iPlayer]:AddNotification(94343293,str, "Social Development",-1,-1, 6)
				end
			end
		end
	end
	DoTakeCareOfDeadCultureVote(tab, cGroupType, chosen)
end

function DoTakeCareOfDeadCultureVote(tab, cType, chosen)
	for g, h in pairs(gT.Players) do
		if h.CultGroup == cType then
			if not tab[g] then
				if chosen and (not h.CultBonusOn[chosen]) then
					AddCultureBonusToPlayer(g, chosen, 1);
				else
					AddCultureBonusToPlayer(g, GetRandomSocialDevelopment(g), 1)
				end
				local abc = GetKeyFromIntegerTable(gT.Players[g].CultureBonusQueue, 1);
				if abc ~= -1 then
					print("We are clearing cultural queue of not alive player", g)
					table.remove(gT.Players[g].CultureBonusQueue,abc)
				end
			end
		end
	end
end

function DistributeInitialCultureBonuses()
	if gT.Globals.ScenarioType == 5 then
		return
	end
	DefineCulturalGroupsForVoting();
	if gT.EraData and gT.PreviousEra then
		DistributeCulturalBonusesFromPrevEra()
		return 
	end
	local pErasTab = GetPreviousErasTable(gT.Globals.ScenarioType)
	for i, scEra in pairs(pErasTab) do
		DistributeCultureBonusesOfEra(scEra)
	end
end

function DistributeCultureBonusesOfEra(scEra)
	local alMC = {}
	for g, gdata in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			local alAS = {}
			local pcID = gdata.CultureType .. "s" .. (gdata.SubcultureType or 0);
			if not alMC[pcID] then
				alMC[pcID] = {}
				for i = 1, 4 do
					alMC[pcID][GetRandomCultureBonusOfEra(scEra, alMC[pcID])] = 1;
				end
			end
			for cb, sth in pairs(alMC[pcID]) do
				alAS[cb] = 1;
			end
			for cb, sth in pairs(alMC[pcID]) do
				if LastRandom(1, 10) < 8 then
					AddCultureBonusToPlayer(g, cb, 1)
				else
					local na = GetRandomCultureBonusOfEra(scEra, alAS)
					alAS[na] = 1;
					AddCultureBonusToPlayer(g, na, 1)
				end
			end
		end
	end
end

function DistributeCulturalBonusesFromPrevEra(scEra)
	local lastEra = gT.PreviousEra
	for g, gdata in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			local tabused = {}
			local numtoAdd = 0;
			for cultID, cData in pairs(tempconvinit[g].CulturalBonuses) do
				tabused[cultID] = 1;
				local bDoNotAdd = false;
				if (cData[1] == lastEra) then
					local baseChance = ERA_CONV_SOCIAL_CHANGE;
					if cData[2] ~= 2 then
						baseChance = baseChance + ERA_CONV_SOCIAL_CHANGE;
					end
					if LastChance(baseChance) then
						bDoNotAdd = true;
					end
				end
				if not bDoNotAdd then
					AddCultureBonusToPlayer(g, cultID, 1, cData[3])
				else
					numtoAdd = numtoAdd + 1;
				end
			end
			for i = 1, numtoAdd do
				local na = GetRandomCultureBonusOfEra(lastEra, tabused)
				tabused[na] = 1;
				AddCultureBonusToPlayer(g, na, 1)
			end
		end
	end
end