local wondenw5 = GameInfoTypes.BUILDING_ITG_NEW_WORLD_WONDER_5;
local techAsiaInno4 = GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_ASIA_4;
local preWonder11 = GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_11;
local techinnoasia3 = GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_ASIA_3;
local techinnomeso5 = GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_MESOAMERICAN_5;
local itgenhbeleif10 = GameInfoTypes.BELIEF_ITG_ENHANCER_10;
local innoTRasia6 = GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_ASIA_6;
local innoancienttribe1 = GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_TRIBE_1;
local innoAncEmp19 =  GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_EMPIRE_19
local wonderindu13 = GameInfoTypes.BUILDING_ITG_NEW_INDUSTRIAL_WONDER_13
local induwonder19 = GameInfoTypes.BUILDING_ITG_NEW_INDUSTRIAL_WONDER_19
local bInduWonder24 = GameInfoTypes.BUILDING_ITG_NEW_INDUSTRIAL_WONDER_24
local induWonder14 = GameInfoTypes.BUILDING_ITG_NEW_INDUSTRIAL_WONDER_14
local g_DBculturalstylenames;
local LiteratureChanceBuildings = {}
local MusicChanceBuildings = {}
local ArtChanceBuildings = {}
for row in GameInfo.Buildings() do --this is very old, mechanic need check one day
	if row.LiteratureChance > 0 then
		LiteratureChanceBuildings[row.ID] = row.LiteratureChance
	end
	if row.MusicChance > 0 then
		MusicChanceBuildings[row.ID] = row.MusicChance
	end
	if row.ArtChance > 0 then
		ArtChanceBuildings[row.ID] = row.ArtChance
	end
end

function CultureIndicatorFromWonders(iPlayer)
	local b = 0;
	if gT.Players[iPlayer].HasPlayerWonder[preWonder11] then
		b = b + 30;
	end
	if gT.WondersConstructed[induWonder14] == iPlayer then
		b = b + 15;
	end
	return {b, "Wonders", 0};
end

function InitDBCulturalStyles()
	g_DBculturalstylenames = {}
	for row in DB.Query("SELECT * FROM ITG_CultureArtStyles") do
		if not g_DBculturalstylenames[row.CultureType] then
			g_DBculturalstylenames[row.CultureType] = {{}, {}, {}}
		end
		table.insert(g_DBculturalstylenames[row.CultureType][1], row.First)
		table.insert(g_DBculturalstylenames[row.CultureType][2], row.Second)
		table.insert(g_DBculturalstylenames[row.CultureType][3], row.Third)
	end
end

function GetDBArtStyles(iPlayer)
	if gT.Players[iPlayer].SubcultureType then
		local sType = ITG_SubcultureData[gT.Players[iPlayer].SubcultureType].Type;
		if g_DBculturalstylenames[sType] then
			return g_DBculturalstylenames[sType];
		end
	end
	return g_DBculturalstylenames[ITG_CultureData[gT.Players[iPlayer].CultureType].Type];
end

function GetDBPlayerArtStyleNames(iPlayer)
	local tab = GetDBArtStyles(iPlayer)
	return Locale.Lookup(RandomFromTab(tab[1])), Locale.Lookup(RandomFromTab(tab[2])), Locale.Lookup(RandomFromTab(tab[3]))
end

function OnInitialCulture(majTab)
	gT.Globals.CultureErasNames = {}
	local sEarly = Locale.Lookup("TXT_KEY_ITG_EARLY") .. " "
	local sMiddle = Locale.Lookup("TXT_KEY_ITG_MIDDLE") .. " "
	local sLate = Locale.Lookup("TXT_KEY_ITG_LATE") .. " "
	InitDBCulturalStyles();
	for i, player in pairs(Shuffle(majTab)) do
		local gType = gT.Players[player].CultureType;
		if not gT.Globals.CultureErasNames[gType] then
			local nameone, nametwo, namethree = GetDBPlayerArtStyleNames(player);
			gT.Globals.CultureErasNames[gType] = {}
			gT.Globals.CultureErasNames[gType][1] = sEarly .. nameone;
			gT.Globals.CultureErasNames[gType][4] = sEarly .. nametwo; 
			gT.Globals.CultureErasNames[gType][7] = sEarly .. namethree; 
			gT.Globals.CultureErasNames[gType][2] = sMiddle .. nameone;
			gT.Globals.CultureErasNames[gType][5] = sMiddle .. nametwo; 
			gT.Globals.CultureErasNames[gType][8] = sMiddle .. namethree;
			gT.Globals.CultureErasNames[gType][3] = sLate .. nameone;
			gT.Globals.CultureErasNames[gType][6] = sLate .. nametwo; 
			gT.Globals.CultureErasNames[gType][9] = sLate .. namethree; 		 
		end
		UpdatePlayerGWCulture(player)
		gT.Players[player].CultureEra = LastRandom(1,3);
		local gwBlessType = GetGWBlessType(player);
		if gwBlessType then
			if gwBlessType == -1 then
				gT.Players[player].CultureEra = math.min(gT.Players[player].CultureEra, LastRandom(1,3));
			elseif gwBlessType > 0 then
				for jkj = 1, gwBlessType do
					gT.Players[player].CultureEra = math.max(gT.Players[player].CultureEra, LastRandom(1,3));
				end
			end
		end
		local hv = (gT.Players[player].CultureEra / 3) * (GetDBCulturePlayerInfo(player, "MaxCultureStartCost") - GetDBCulturePlayerInfo(player, "MinCultureStartCost"))
		gT.Players[player].CultureBonusAdopted = GetDBCulturePlayerInfo(player, "MinCultureStartCost") + LastRandom(math.floor(hv), math.ceil(hv));
	
		local getNextCost = NiceCostOfTechOrPolicy(player, GetDBCulturePlayerInfo(player, "BaseCultureCost"), gT.Players[player].CultureBonusAdopted, 2)
		gT.Players[player].Culture = LastRandom(0, math.floor(getNextCost*3/4))
	end
	UpdateAllTheBonusOfCultureEras()
	g_DBculturalstylenames = nil;
end

function UpgradePlayerToNextCulturalEra(iPlayer, bForce, bWithCBonus)
	if gT.Players[iPlayer].CultureEra == 9 then
		return;
	end
	if (not bForce) and (gT.Players[iPlayer].CultureEra == 6) and (not Teams[Players[iPlayer]:GetTeam()]:IsHasTech(gT.Players[iPlayer].LastCultureTechPrereq)) then
		PlayerDiscoverTech(iPlayer, gT.Players[iPlayer].LastCultureTechPrereq, nil, "hDT12")
	else
		DoIncreasementStockExchange(16)
		if gT.Players[iPlayer].HasPlayerWonder[bInduWonder24] then
			BoostHappinessInAllCities(iPlayer, 3)
		end
		BasicCSMissionCompleteFunc(iPlayer, 46)
		gT.Players[iPlayer].CultureEra = math.min(9, gT.Players[iPlayer].CultureEra + 1);
		UpdateAllTheBonusOfCultureEras()
		HnGLogCulturalAdvance(iPlayer)
		if bWithCBonus then
			if gT.Players[iPlayer].HasPlayerWonder[GameInfoTypes.BUILDING_ITG_NEW_INDUSTRIAL_WONDER_3] then
				ChangeITGCulture(iPlayer, math.floor(0.3 * gT.Players[iPlayer].CurrentCultureTreshold))
			end
			ChangeMeritocracy(iPlayer, 2)
		end
		if Players[iPlayer]:IsHuman() then
			Players[iPlayer]:AddNotification(94343293, "We have advanced to [COLOR_POSITIVE_TEXT]" .. gT.Globals.CultureErasNames[gT.Players[iPlayer].CultureType][gT.Players[iPlayer].CultureEra] .. "[ENDCOLOR] (" .. gT.Players[iPlayer].CultureEra .. "/9).", "New Art Style", -1, -1, 38)
		end
	end
end

function ChangeITGCulture(player, amount)
	if not gT.Players[player].Culture  then
		--city-state got some bonus, probably from belief
		return;
	end
	gT.Players[player].Culture = gT.Players[player].Culture + amount;
	if player == Game.GetActivePlayer() then
		LuaEvents.ITGSGTopPanelDirty()
	end
end

function SpendITGCulture(iPlayer, value)
	gT.Players[iPlayer].CultureLost = gT.Players[iPlayer].CultureLost + value;
	gT.Players[iPlayer].Culture = gT.Players[iPlayer].Culture - value;
	if iPlayer == Game.GetActivePlayer() then
		LuaEvents.ITGSGTopPanelDirty()
	end
end

function GetCultureFromCaligraphy(iPlayer)
	if HasPlayerTech(iPlayer, techAsiaInno4, "uwvqweeeeeeeeeeer") then
		return math.floor(0.1 * GetITGSciencePerTurn(iPlayer, true))
	end
	return 0;	
end

function GetITGCultureFromAncientRuins(iPlayer)
	local base = 0;
	if HasPlayerTech(iPlayer, innoTRasia6, "uwqeadccccccew") then
		local iTeam = Players[iPlayer]:GetTeam();
		local car = 0;
		for index, sth in pairs(gT.Globals.AncientRuins) do
			if Map.GetPlotByIndex(index):IsRevealed(iTeam) then
				car = car + 1;
			end
		end
		base = base + math.floor(car / 3);
	end
	return base;
end

function GetCultureFromTechs(iPlayer)
	return gT.Players[iPlayer].CultureFromTech;
end

function GetCultureFromForts(iPlayer)
	local b = 0;
	if HasPlayerTech(iPlayer, innoAncEmp19, " casdvsad") then
		b = b + GetNumSpecialControlPoint(iPlayer, "Forts", false);
	end
	return b;
end

function GetCultureFromElDorados(iPlayer)
	local total = GetNumSpecialControlPoint(iPlayer, "ElDorados", false) * 10;
	return total;
end

function GetCultureFromSocialDevs(iPlayer)
	local b = 0;
	if gT.Players[iPlayer].HasIdeology[69] then
		b = b + GetNumForeignGovernors(iPlayer);
	end
	return b;
end

function GetCultureFromIdeologies(iPlayer, bTooltip)
	local b = 0;
	if gT.Players[iPlayer].HasIdeology[8] then
		b = b + 20;
		for gpID, hhh in pairs(gT.Players[iPlayer].GreatPeople) do
			local gd = gT.GreatPeople[gpID];
			if gd.Alive and (not gd.Military) then
				b = b - 1;
			end
		end
	end
	return b;
end

function GetCultureFromTradeRoutes(iPlayer)
	return gT.Players[iPlayer].TRCulture;
end

function GetTotalCulturePerTurn(iPlayer, bTooltip, bRightNow)
	local tCulturePT = Players[iPlayer]:GetTotalJONSCulturePerTurn() + GetCultureFromGreatWorks(iPlayer);
	tCulturePT = tCulturePT + GetCultureFromCaligraphy(iPlayer) + GetITGCultureFromAncientRuins(iPlayer) + GetPlayer10thBonusFromCaliph(iPlayer) + GetCultureFromForts(iPlayer) +  GetCultureFromElDorados(iPlayer) + GetCultureFromTechs(iPlayer);
	tCulturePT = tCulturePT + GetCultureFromIdeologies(iPlayer, bTooltip) + GetCultureFromTradeRoutes(iPlayer) + GetCultureFromSocialDevs(iPlayer)
	if bTooltip then
		tCulturePT = tCulturePT + GetFaithCultureFromWonderProcess(iPlayer) + GetCultureFromTithe(iPlayer);
	end
	if bRightNow then
		if gT.Players[iPlayer].Ideo41 ~= 0 then
			tCulturePT = tCulturePT + math.floor(tCulturePT * gT.Players[iPlayer].Ideo41)
		end
	end
	return tCulturePT;
end

function GetITGCulturePerTurnFromModifiers(iPlayer)
	local h = 0;
	local bt;
	if gT.Players[iPlayer].Ideo41 ~= 0 then
		bt = bt or (GetTotalCulturePerTurn(iPlayer, false, false))
		h = h + math.floor(bt * gT.Players[iPlayer].Ideo41)
	end
	return h;
end

function IsCultureBonusChosenRandomly(iPlayer)
	if GetGovernorWithExtraCredentials(iPlayer, "Curator") then
		return true;
	end
	return false;
end

function NewTurnPlayerCulture(iPlayer)
	local theCulture =  GetTotalCulturePerTurn(iPlayer, false, true)
	ChangeITGCulture(iPlayer, theCulture)
	local getNextCost = NiceCostOfTechOrPolicy(iPlayer, GetDBCulturePlayerInfo(iPlayer, "BaseCultureCost"), gT.Players[iPlayer].CultureBonusAdopted, 2)
	if gT.Players[iPlayer].Culture >= getNextCost then
		SpendITGCulture(iPlayer, getNextCost)
		DoYieldBonuses(iPlayer, "Culture", getNextCost)
		gT.Players[iPlayer].CultureBonusAdopted =  gT.Players[iPlayer].CultureBonusAdopted + 1;
		gT.Players[iPlayer].CurrentCultureTreshold = getNextCost;
		AddGraphData(iPlayer, 1, 1, false)
		if IsCultureBonusChosenRandomly(iPlayer) then
			local tabOptions = PrepareExtraDataForHumanCultureBonus(iPlayer).UniqueOptions;
			if #tabOptions == 0 then
				print("Impossiblue 53333f", iPlayer)
			else
				local lTab = tabOptions[GetProperRandomYieldBonus(tabOptions)];
				local baseRngData = HumanPlayerChooseCultureBonus(iPlayer, lTab.ID, lTab.ExtraInfo, true)
				if Players[iPlayer]:IsHuman() then
					--option 1: governor
					local govIDCurator = GetGovernorWithExtraCredentials(iPlayer, "Curator")
					baseRngData.Type = 2;
					baseRngData.GovID = govIDCurator;
					baseRngData.Title = lTab.Name;
					if not gT.Players[iPlayer].RandomRewardPopup then
						gT.Players[iPlayer].RandomRewardPopup = {};
					end
					table.insert(gT.Players[iPlayer].RandomRewardPopup, baseRngData);
					local notstr = "Curator [ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govIDCurator].Name) .. " has chosen '" .. lTab.Name .. "' as a reward from cultural bonus.";
					Players[iPlayer]:AddNotification(81468343,notstr,"Curator",-1,-1, govIDCurator)
				end
			end
		else
			if Players[iPlayer]:IsHuman() then
				gT.Players[iPlayer].HumanQueueActions["CHOOSE CULTURAL BONUS"] = PrepareExtraDataForHumanCultureBonus(iPlayer);
			else
				AIPlayerChooseCultureBonus(iPlayer)
			end
		end
	end
end

function AIPlayerChooseCultureBonus(iPlayer)
	local minlevel = 4;
	local toreplace;
	local bGenerated = false;
	if HasCSMission(iPlayer, 46) then
		if gT.Players[iPlayer].CultureEra < 9 then
			HumanPlayerChooseCultureBonus(iPlayer, 1, nil, false, true)
			return;
		end
	end
	if (not DBScenario.IdeologyOn) and (gT.Players[iPlayer].AIStrategyValues) then
		if (not gT.Players[iPlayer].AIStrategyValues.GrandStrategy) or (gT.Players[iPlayer].AIStrategyValues.GrandStrategy ~= 1) then
			if (not gT.Players[iPlayer].AISocDevPerfection) or LastChance(gT.Players[iPlayer].AISocDevPerfection) then
				local bIgnoreSocReq = gT.Players[iPlayer].NumPointsChangeSocialBonus > 0;
				for cultid, data in pairs(gT.Players[iPlayer].CultBonusOn) do
					if bIgnoreSocReq or (data.Type == 1 and gT.Globals.ScenarioType == data.Scenario) then
						if not bGenerated then
							bGenerated = true;
							GenerateBaseAIFlavourValues(iPlayer)
						end
						local value = GetAIValueForCultureBonus(iPlayer, cultid);
						if value < minlevel then
							toreplace = cultid;
							minlevel = value;
						end
					end
				end
			end
		end
	end
	if toreplace and (minlevel < 3) then
		local getBetterOne, newLevel = GetBetterSocialForAI(iPlayer, minlevel);
		if (getBetterOne ~= -1) and ((newLevel >= 5) or ((minlevel <= 1) and (newLevel >= 3))) then
			table.insert(gT.Players[iPlayer].QueueActionsRealEndTurn, {"AIReplaceSocial", toreplace, getBetterOne})
			return;
		end
	end
	if ShouldAIDoGoldenAge(iPlayer, 2, "Culture") then
		HumanPlayerChooseCultureBonus(iPlayer, 5, nil, false, true)
		return;
	end
	--wonder race
	--wonder race push
	--culture era
	-- great works
	if ShouldAISpendBonusOnWonderRaceBoost(iPlayer) then
		HumanPlayerChooseCultureBonus(iPlayer, 2, nil, false, true)
		return;
	end
	if gT.Players[iPlayer].CultureEra > 4 then
		if gT.Players[iPlayer].GovRewards[20] then
			if not gT.Players[iPlayer].GovSlots[gT.Players[iPlayer].GovRewards[20]].Used then
				local tInno = GetRandomInnovation(iPlayer, true);
				gT.Players[iPlayer].GovSlots[gT.Players[iPlayer].GovRewards[20]].Used = true;
				if tInno then
					PlayerWantsToChooseBetweenInnoTechs(tInno, iPlayer, "GovReward20")
					return;
				end
			end
		end
	end
	if gT.Players[iPlayer].CultureEra > 6 then
		if not gT.Players[iPlayer].bInspFromCulture then
			if LastChance(85) then
				if GetProperBuildingForNewInspiration(iPlayer, nil) then
					HumanPlayerChooseCultureBonus(iPlayer, 7, nil, false, true)
					return;
				end
			end
		end
	end
	if gT.Players[iPlayer].CultureEra < 9 and LastRandom(1,3) <= 3 then
		if GetITGGameTurn() <= 85 then
			HumanPlayerChooseCultureBonus(iPlayer, 1, nil, false, true)
			return;
		end
	end
	if toreplace and (minlevel == 3) then
		local getBetterOne, newLevel = GetBetterSocialForAI(iPlayer, minlevel);
		if (getBetterOne ~= -1) and (newLevel >= 5) then
			table.insert(gT.Players[iPlayer].QueueActionsRealEndTurn, {"AIReplaceSocial", toreplace, getBetterOne})
			return;
		end
	end
	if LastChance(75) then
	-- gov rewards options here
		if gT.Players[iPlayer].GovRewards[56] then
			HumanPlayerChooseCultureBonus(iPlayer, 6, nil, false, true)
			return;
		end
		if gT.Players[iPlayer].GovRewards[60] then
			if GetAvailableTargetsForUprising(iPlayer, false, true) then
				HumanPlayerChooseCultureBonus(iPlayer, 9, nil, false, true)
				return;
			end
		end
		if gT.Players[iPlayer].GovRewards[55] then
			if HasMintAnyCity(iPlayer) then
				HumanPlayerChooseCultureBonus(iPlayer, 10, nil, false, true)
				return;
			end
		end
		if gT.Players[iPlayer].GovRewards[59] then
			if Players[iPlayer]:GetNumCities() > 0 then
				HumanPlayerChooseCultureBonus(iPlayer, 11, nil, false, true)
				return;
			end
		end
		if gT.Players[iPlayer].GovRewards[58] then
			if #PreparedDataForInfluenceImprove(iPlayer).UniqueOptions > 2 then
				HumanPlayerChooseCultureBonus(iPlayer, 12, nil, false, true)
				return;
			end
		end
		if gT.Players[iPlayer].GovRewards[57] then
			HumanPlayerChooseCultureBonus(iPlayer, 13, nil, false, true)
			return;
		end
	end
	HumanPlayerChooseCultureBonus(iPlayer, 3, nil, false, true)
end

local HelpCultureEraBonusFromInteger = {100, 50, 33, 25}
function GetDataForNewEraTooltip(player, eratype)
	local gType = gT.Players[player].CultureType;
	local maxera, numplayers, totplayers, maxeraplayers = eratype, 0, 1, 1;
	for g, gData in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			if Players[g]:IsAlive() then	
				if player ~= g then
					if gData.CultureType == gType then
						totplayers = totplayers + 1;
						if gData.CultureEra > maxera then
							maxera = gData.CultureEra;
							maxeraplayers = 1;
						elseif gData.CultureEra == maxera then
							maxeraplayers = maxeraplayers + 1;
						end
						if gData.CultureEra >= eratype then
							numplayers = numplayers + 1;
						end
					end
				end
			end
		end
	end
	if maxera ~= eratype then
		return numplayers, 0;
	else
		return numplayers, GetCultureEraBonusForBestPlayers(maxeraplayers, totplayers, maxera) or 0;
	end
end

function GetCurrentModifierFromCultureEra(iPlayer)
	return gT.Players[iPlayer].GreatArtistModifier;
--	local base = 5 * (gT.Players[iPlayer].CultureEra - 1)
end

function GetToolTipForNewArtisticEra(numcivs, getnewmod, newera, eraname)
	local numeraname = eraname .. " ([COLOR_POSITIVE_TEXT]" .. newera .. "[ENDCOLOR]/9)"
	local str = "[NEWLINE]Entering new Art Style recalculates extra bonus towards generating [ICON_GREAT_ARTIST] Art by you and possibly other players. Base Art points modifier at " .. eraname .. " is " .. (newera-1) * BASE_ART_MOD_PER_PERIOD .. "%.[NEWLINE][NEWLINE]";
	if getnewmod == 0 then
		str = str .. "There is no extra modifier for entering " .. numeraname .. ", there are [COLOR_YELLOW]" .. numcivs .. "[ENDCOLOR] civilization(s) with even more advanced style."
	else
		str = str .. "Extra modifier for entering " .. numeraname .. " is +" .. getnewmod .. "%, which means it is currently the most advanced Art Style."
		if numcivs ~= 0 then
			str = str .. " There are [COLOR_YELLOW]" .. numcivs .. "[ENDCOLOR] civilization(s) with this Art Style"
		end
	end
	str = str .. "[NEWLINE][NEWLINE]Increases [ICON_ITG_MERITOCRACY] Meritocracy by 2.";
	return str;
end

function PrepareExtraDataForHumanCultureBonus(iPlayer, tooltip)
	local data = {BonusType = "BonusCulture", TitleText = "Choose your bonus wisely.", TitleIconIndex = 4, TitleIconAtlas = "CITIZEN_ATLAS", Tooltip = tooltip or "You have accumulated enough culture for extra bonus."}
	local hTab = {}
	local gType = gT.Players[iPlayer].CultureType;
	if gT.Players[iPlayer].CultureEra < 9 then
		local eraname = gT.Globals.CultureErasNames[gType][gT.Players[iPlayer].CultureEra + 1];
		if (gT.Players[iPlayer].CultureEra == 6) and (not Teams[Players[iPlayer]:GetTeam()]:IsHasTech(gT.Players[iPlayer].LastCultureTechPrereq)) then
			local tech = GameInfo.Technologies[gT.Players[iPlayer].LastCultureTechPrereq];
			table.insert(hTab, {Name = "Discover " .. Locale.Lookup(tech.Description),
						ID = 1,
						PortraitIndex = tech.PortraitIndex,
						IconAtlas = tech.IconAtlas,
						Help = "[NEWLINE]Before you can advance to the " .. eraname .. " you have to discover " .. Locale.Lookup(tech.Description) .. " first. You can adapt this technology now.";
						})		
		else
			local numcivs, getnewmod = GetDataForNewEraTooltip(iPlayer, gT.Players[iPlayer].CultureEra + 1);
			table.insert(hTab, {Name = eraname,
						ID = 1,
						PortraitIndex = 0,
						IconAtlas = "POLICY_ATLAS_EXP2",
						Help = GetToolTipForNewArtisticEra(numcivs, getnewmod, gT.Players[iPlayer].CultureEra + 1, eraname)
						})
		end
	end
	local cultToReplace = {}
	if (not DBScenario.IdeologyOn) then
		local bIgnoreSocReq = gT.Players[iPlayer].NumPointsChangeSocialBonus > 0;
		for cultid, data in pairs(gT.Players[iPlayer].CultBonusOn) do
			if (bIgnoreSocReq) or (data.Type == 1 and gT.Globals.ScenarioType == data.Scenario) then
				local csd = RequestCultureTypeData(cultid);
				table.insert(cultToReplace, {ID = cultid, Name = csd.Name, Help = csd.Help, PortraitIndex = csd.PortIndex, IconAtlas = csd.IconAtlas})
			end
		end
	end
	if #cultToReplace > 0 then
		table.insert(hTab, {Name = "Social Development",
			ID = 4,
			PortraitIndex = 0,
			IconAtlas = "POLICY_ATLAS",
			Help = "[NEWLINE]Allows you to replace a Social Development that was forced on you and choose a new one.";
			ExtraInfo = cultToReplace,
			DoubleChooseType = "SocialDevelopment"
			})	
	end
	if CanDoWonderRaceRightNow(iPlayer) or CanDoWonderBoost(iPlayer) then
		local sText = Locale.Lookup("TXT_KEY_ITG_NEW_WONDER_RACE_START")
		if gT.Players[iPlayer].CanWonderRace then
			sText = Locale.ConvertTextKey("TXT_KEY_ITG_NEW_WONDER_RACE_BOOST", GetRewardWonderPushProd());
		end
		table.insert(hTab, {Name = "Wonder",
							ID = 2,
							PortraitIndex = 0,
							IconAtlas = "INTL_PROJECT_ATLAS_EXP2",
							Help = sText})
	end
	local numGreatWorks = 3 + GetExtraGreatWorksFromCulturalFaithBonuses(iPlayer);
	table.insert(hTab, {Name = "Great Work",
						ID = 3,
						PortraitIndex = 6,
						IconAtlas = "EXPANSION2_UNIT_ATLAS",
						Help = "[NEWLINE]Create " .. numGreatWorks .. " [ICON_GREAT_WORK] Great Works. Increases [ICON_ITG_MERITOCRACY] Meritocracy by 1.",
						ExtraInfo = numGreatWorks})
	if (not gT.Players[iPlayer].HadGoldenAge) then
		local pointsGA = GetGoldenAgePointsFromType(iPlayer, 2);
		table.insert(hTab, {Name = "Golden Age",
				ID = 5,						
				PortraitIndex = 40,
				IconAtlas = "POLICY_ATLAS",
				Help = Locale.ConvertTextKey("TXT_KEY_ITG_NEW_GOLDEN_AGE_POINTS", pointsGA, pointsGA * MERITOCRACY_PER_GOLDEN_AGE_POINT)})
	elseif Players[iPlayer]:IsGoldenAge() then
		if not gT.Players[iPlayer].CanGABeProlonged["Culture"] then
			table.insert(hTab, {Name = "Prolong Golden Age",
					ID = 5,						
					PortraitIndex = 40,
					IconAtlas = "POLICY_ATLAS",
					Help = "[NEWLINE]Increases duration of current [ICON_GOLDEN_AGE] Golden Age by " .. GetNumTurnsPrelongGoldenAge(iPlayer) .. " turns."})
		end
	end
	if gT.Players[iPlayer].GovRewards[56] then
		table.insert(hTab, {Name = "Cultural Propaganda",
						ID = 6,
						PortraitIndex = 55,
						IconAtlas = "TECH_ATLAS_1",
						Help = "[NEWLINE]Randomly distributes 20 [ICON_HAPPINESS_1] Happiness (one City cannot gain more than +4 [ICON_HAPPINESS_1] Happiness).[NEWLINE]Increases [ICON_ITG_MERITOCRACY] Meritocracy by 4."})
	end
	if gT.Players[iPlayer].CultureEra > 6 then
		if not gT.Players[iPlayer].bInspFromCulture then
			if GetProperBuildingForNewInspiration(iPlayer, nil) then
				table.insert(hTab, {Name = "Inspiration",
							ID = 7,
							PortraitIndex = 0,
							IconAtlas = "SHARED_TECH_ATLAS",
							Help = "[NEWLINE]Allows you too choose an Inspiration for a random building class."})
			end
		end
	end
	if gT.Players[iPlayer].CultureEra > 4 then
		if gT.Players[iPlayer].GovRewards[20] then
			if not gT.Players[iPlayer].GovSlots[gT.Players[iPlayer].GovRewards[20]].Used then
				if #GetValidTableOfTechs(iPlayer, false, true, true) > 0 then
					table.insert(hTab, {Name = "Beyond Art",
										ID = 8,
										PortraitIndex = 7,
										IconAtlas = "CITIZEN_ATLAS",
										Help = "Acquire new Innovation."})
				end
			end
		end
	end
	if gT.Players[iPlayer].GovRewards[60] then
		if GetAvailableTargetsForUprising(iPlayer, false, true) then
			table.insert(hTab, {Name = "Cultural Revolution",
							ID = 9,
							PortraitIndex = 19,
							IconAtlas = "EXPANSION_UNIT_ATLAS_1",
							Help = "[NEWLINE]Starts an uprising in up to 2 foreign occupied Cities.[NEWLINE]Increases [ICON_ITG_MORALE] Morale by 3."})
		end
	end
	if gT.Players[iPlayer].GovRewards[55] then
		if HasMintAnyCity(iPlayer) then
			table.insert(hTab, {Name = "Consumer Culture",
							ID = 10,
							PortraitIndex = 2,
							IconAtlas = "EXPANSION_TECH_ATLAS_1",
							Help = "[NEWLINE]Increases [ICON_INVEST] Currency Power by 400 (fades by 25 each turn).[NEWLINE]+5 [ICON_CARAVAN] Land and [ICON_CARGO] Naval Trade-Route points in all Cities."})
		end
	end
	if gT.Players[iPlayer].GovRewards[59] then
		if Players[iPlayer]:GetNumCities() > 0 then
			table.insert(hTab, {Name = "Indoctrination",
							ID = 11,
							PortraitIndex = 10,
							IconAtlas = "TECH_ATLAS_2",
							Help = "[NEWLINE]Randomly distributes 1000 [ICON_ITG_PRESENCE] Presence among your Cities (one City cannot gain more than +200 [ICON_ITG_PRESENCE] Presence).[NEWLINE]+5 XP for next trained unit in all Cities."})
		end
	end
	if gT.Players[iPlayer].GovRewards[58] then
		if #PreparedDataForInfluenceImprove(iPlayer).UniqueOptions > 0 then
			table.insert(hTab, {Name = "World Leadership",
							ID = 12,
							PortraitIndex = 26,
							IconAtlas = "BW_ATLAS_2",
							Help = "[NEWLINE]Improve relations with up to 5 random City-States.[NEWLINE]+15% [ICON_ITG_LAWS_INFLUENCE] Codex Influence."})
		end
	end
	if gT.Players[iPlayer].GovRewards[57] then
		table.insert(hTab, {Name = "Quality Assurance",
						ID = 13,
						PortraitIndex = 12,
						IconAtlas = "TECH_ATLAS_1",
						Help = "[NEWLINE]Reduces [ICON_TOURISM] Migration progress of residing Great People by up to 500 points total. Unused amount is added to [ICON_GREAT_PEOPLE] Great People points.[NEWLINE]Increases [ICON_PRODUCTION] Production by 1 in all Cities."})
	end

	data.UniqueOptions = hTab;
	return data;
end

function ChangeArtModFromArtPeriod(gplayer, val)
	gT.Players[gplayer].ModFromArtPeriod = gT.Players[gplayer].ModFromArtPeriod + val;
	UpdateAllTheBonusOfCultureEras()
end

function UpdateAllTheBonusOfCultureEras()
	local grandHtab = {}
	local playerMajorArtistBonust = {}
	for g, gData in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			if Players[g]:IsAlive() then
				local gType = gData.CultureType;
				if not grandHtab[gType] then
					grandHtab[gType] = {Max = 0, MaxTab = {}, NumPlayers = 0}
				end
				if gData.CultureEra > grandHtab[gType].Max then
					grandHtab[gType].Max = gData.CultureEra
					grandHtab[gType].MaxTab = {g};
				elseif gData.CultureEra == grandHtab[gType].Max then
					table.insert(grandHtab[gType].MaxTab, g)
				end
				grandHtab[gType].NumPlayers = grandHtab[gType].NumPlayers + 1;
				--static bonus;
				playerMajorArtistBonust[g] = (gData.CultureEra - 1) * (gData.ModFromArtPeriod + BASE_ART_MOD_PER_PERIOD);
			end
		end
	end
	for gtype, moredata in pairs(grandHtab) do
		local gb = GetCultureEraBonusForBestPlayers(#moredata.MaxTab, moredata.NumPlayers, moredata.Max)
		for i, g in pairs(moredata.MaxTab) do
			playerMajorArtistBonust[g] = playerMajorArtistBonust[g] + gb;
		end
	end
	for player, value in pairs(playerMajorArtistBonust) do
		if gT.Players[player].HasPlayerWonder[induwonder19] and (value < 50) then
			Players[player]:ChangeGreatArtistRateModifier(50 - gT.Players[player].GreatArtistModifier)
			gT.Players[player].GreatArtistModifier = 50;
		else
			Players[player]:ChangeGreatArtistRateModifier(value - gT.Players[player].GreatArtistModifier)
			gT.Players[player].GreatArtistModifier = value;
		end
	end
end

function GetCultureEraBonusForBestPlayers(bestplayers, allplayers, maxEra)
	if allplayers == 1 then 
		return 10 + (maxEra - 1) * 2; --new stuff supporting levelling // winning alone 10% + 2% x (Era-1), up to 26% (max total 66%) 
	end
	if (bestplayers > 4) or bestplayers >= allplayers then
		return 10; -- new stuff: always at least 10; (max total 50%)
	end
	if bestplayers == 1 then
		if allplayers > 2 then
			return 50; -- winnin between at least 3 players: 50%
		else
			return 33; -- winning race within 2 players: 33%
		end
	elseif bestplayers == 2 then
		return 33; -- two best
	elseif bestplayers == 3 then
		return 17; -- three best out of at least 4
	else
		return 14 -- actually can fire
	end
end

function UpdatePlayerGWCulture(player)
	gT.Players[player].CulturePerGW = 1;
end

function GetPlayersCulturalDifference(iPlayer, bPlayer)
	if gT.Players[bPlayer].CultureType == gT.Players[iPlayer].CultureType then
		if gT.Players[bPlayer].SubcultureType == gT.Players[iPlayer].SubcultureType then
			return 0;
		else
			return 1;
		end
	else
		return 2;
	end
end

function GetCultINDFromSocialDevs(iPlayer)
	local b = 0;
	if gT.Players[iPlayer].Cult32t then
		b = b + 5 * gT.Players[iPlayer].Cult32t[1];
	end
	return {b, "Social Developments", 0}
end

function GetCultINDFromInnovations(iPlayer)
	local b = 0;
	if HasPlayerTech(iPlayer, techinnoasia3, "vcewrerwer") then
		b = b + 25;
	end
	if HasPlayerTech(iPlayer, innoancienttribe1, "vcewrerwer") then
		 b = b + 10;
	end
	return {b, "Innovations", 0};
end

function GetCultINDFromManufactories(gPlayer)
	local base = 0;
	for i, v in pairs(gT.Manufactories) do
		if v.Player == gPlayer and v.Active then
			for j, b in pairs(v.Traits) do
				if b.ID == 16 then
					base = base + 3 + 1 * math.floor(Map.GetPlotByIndex(v.City):GetPlotCity():GetBaseYieldRate(yProduction)/17)
				end
			end
		end
	end
	return {base, "Manufactories", 0};
end

function GetCultINDFromCS(iPlayer)
	local base = 0;
	if HasPlayerTech(iPlayer, techinnomeso5, "uvvvvvvvvwerew") then
		for g, gdata in pairs(gT.Players) do
			if Players[g]:IsMinorCiv() and (Players[g]:GetAlly() == iPlayer) and Players[g]:IsAlive() then
				base = base + 5;
			end
		end
	end
	for i, minor in pairs(gT.Globals.CSbyTypes[GameInfoTypes.MINOR_TRAIT_IDEOLOGICAL]) do
		if Players[minor]:GetMinorCivFriendshipLevelWithMajor(iPlayer) > 0 then
			if Players[minor]:GetMinorCivFriendshipLevelWithMajor(iPlayer) > 1 then
				base = base + 6;
			else
				base = base + 3;
			end
		end
	end
	if gT.Players[iPlayer].CultBonusOn[118] then
		base = math.floor(base * 15) / 10;
	end
	return {base, "City-States", 0};
end

function GetCultINDFromBase(iPlayer)
	return {0, "Base", BASE_DIVIDE_PRESENCE}
end

function GetCultINDFromReligiousUnit(iPlayer)
	if gT.Globals.ScenarioType == 5 then
		return {0, "", 0};
	end
	if HasOngoingHeresy(iPlayer) then
		return {0, "Heresy", 5};
	end
	if gT.Players[iPlayer].OfficialReligion then
		return {MAX_RELIGIOUS_UNIFY * gT.Players[iPlayer].ReligionUnityMod, "Religious Unity", 0};
	else
		local tot = Players[iPlayer]:GetNumCities();
		if tot > 0 then
			local relTab = {}
			local max = 0;
			for iCity in Players[iPlayer]:Cities() do
				local iRel = iCity:GetReligiousMajority();
				if iRel ~= -1 then -- added recently
					if not relTab[iRel] then
						relTab[iRel] = 1;
					else
						relTab[iRel] = relTab[iRel] + 1;
					end
					if relTab[iRel] > max then
						max = relTab[iRel];
					end
				end
			end	
			return {math.floor(MAX_RELIGIOUS_UNIFY * max / tot) * gT.Players[iPlayer].ReligionUnityMod, "Religious Unity", 0};
		else
			return {0, "", 0};
		end
	end
end

function GetCultINDFromAcademies(iPlayer)
	local t = gT.Players[iPlayer].AcaNatUnity;
	for iCity in Players[iPlayer]:Cities() do
		t = t + 0.5 * GetCityBasicPointsFromAcademies(iCity, iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded(), "National");
	end
	return {t, "Academies", 0};
end

function GetCultINDFromCodex(iPlayer)
	return {GetBasicRewardGovFromCodex(iPlayer, 9, 9), "Codex", 0}
end

function GetCultINDFromNationalDay(iPlayer) 
	return {gT.Players[iPlayer].NationalDays * 7, "National Days", 0};
end

local bcindopera = GameInfoTypes.BUILDING_ITG_IND_OPERA_HOUSE;
local bcindikanda = GameInfoTypes.BUILDING_ITG_NW_AFR_IKANDA;
function GetCultINDFromOperas(iPlayer)
	local a = 2 * Players[iPlayer]:CountNumBuildings(bcindopera)
	a = a + 2 * Players[iPlayer]:CountNumBuildings(bcindikanda)
	if gT.Players[iPlayer].HasCultGuild then
		for iCity in Players[iPlayer]:Cities() do
			local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
			if gT.Cities[cID].CultGuild == "W" then
				a = a + 2;
			end
		end
	end
	return {a, "Buildings", 0};
end

function GetCultINDFromEquality(iPlayer)
	if gT.Players[iPlayer].GovRewards[35] then
		return {2 * gT.Players[iPlayer].Ideologies.E, "Equality", 0};
	end
	return {0, "", 0};
end

function GetCultINDFromPrinciple(iPlayer)
	local a = 0;
	return {a, "Principles", 0};
end

function GetCultINDFromIdeology(iPlayer)
	local a = gT.Players[iPlayer].CDIdeology12;
	if gT.Players[iPlayer].HasIdeology[56] then
		local maxdef = 0;
		for iCity in Players[iPlayer]:Cities() do
			maxdef = math.max(maxdef, iCity:GetStrengthValue())
		end
		a = a + math.floor(maxdef / 500)
	end	
	if gT.Players[iPlayer].HasIdeology[25] then
		for class, type in pairs(gT.Players[iPlayer].Inspirations) do
			a = a + 2;
		end
	end
	if gT.Players[iPlayer].HasIdeology[65] then
		a = a + 3 * GetNumOfGPCivilOfType(iPlayer, 6)
	end
	if gT.Players[iPlayer].HasIdeology[60] then
		a = a + gT.Players[iPlayer].NumGPArtStyles * 2;
	end
	if gT.Players[iPlayer].HasIdeology[35] then
		if gT.Players[iPlayer].MintBonus > gT.Globals.AverageMintBonus then
			a = a + 10;
		end
	end
	return {a, "Ideology", 0};
end

function GetCultINDFromPhotography(iPlayer)
	return {gT.Players[iPlayer].Ind5NatUnity, "Photography", 0};
end

function GetCultINDfromMemorial(iPlayer)
	return {gT.Players[iPlayer].CultINDMemorial, "National Memorial", 0};
end

function GetCultINDFromArtStyle(iPlayer)
	return {2 * gT.Players[iPlayer].CultureEra, "Art Style", 0};
end

function GetCultINDFromGreatPeople(iPlayer)
	return {gT.Players[iPlayer].CultIndFromGP, "Great People", 0};
end

function InitialCultureIndicator()
	for g, gdata in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			gT.Players[g].NatUnity = GetThisTurnCultureIndicator(g)
		end
	end
end

function GetMusicianChanceFromBuildings(iPlayer)
	local aV = 0;
	for ib, iv in pairs(MusicChanceBuildings) do
		aV = aV + iv * Players[iPlayer]:CountNumBuildings(ib);
	end	
	if gT.Players[iPlayer].HasCultGuild then
		for iCity in Players[iPlayer]:Cities() do
			local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
			if gT.Cities[cID].CultGuild == "M" then
				aV = aV + iCity:GetPopulation();
			end
		end
	end
	return aV;
end

function GetWriterChanceFromBuildings(iPlayer)
	local aV = 0;
	for ib, iv in pairs(LiteratureChanceBuildings) do
		aV = aV + iv * Players[iPlayer]:CountNumBuildings(ib);
	end	
	if gT.Players[iPlayer].HasCultGuild then
		for iCity in Players[iPlayer]:Cities() do
			local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
			if gT.Cities[cID].CultGuild == "W" then
				aV = aV + iCity:GetPopulation();
			end
		end
	end
	return aV;
end

function GetArtistChanceFromBuildings(iPlayer)
	local aV = 0;
	for ib, iv in pairs(ArtChanceBuildings) do
		aV = aV + iv * Players[iPlayer]:CountNumBuildings(ib);
	end	
	if gT.Players[iPlayer].HasCultGuild then
		for iCity in Players[iPlayer]:Cities() do
			local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
			if gT.Cities[cID].CultGuild == "A" then
				aV = aV + iCity:GetPopulation();
			end
		end
	end
	return aV;
end

local titv8 = GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_VIKING_8;
function GetPlayerChanceForCreatingGreatWorksOfType(iPlayer)
	local bm, bl, ba = 5, 5, 5;	
	for ib, iv in pairs(LiteratureChanceBuildings) do
		bl = bl + iv * Players[iPlayer]:CountNumBuildings(ib);
	end
	for ib, iv in pairs(MusicChanceBuildings) do
		bm = bm + iv * Players[iPlayer]:CountNumBuildings(ib);
	end	
	for ib, iv in pairs(ArtChanceBuildings) do
		ba = ba + iv * Players[iPlayer]:CountNumBuildings(ib);
	end
	if gT.Players[iPlayer].HasCultGuild then
		for iCity in Players[iPlayer]:Cities() do
			local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
			if gT.Cities[cID].CultGuild == "W" then
				bl = bl + iCity:GetPopulation();
			elseif gT.Cities[cID].CultGuild == "A" then
				ba = ba + iCity:GetPopulation();
			elseif gT.Cities[cID].CultGuild == "M" then
				bm = bm + iCity:GetPopulation();
			end
		end
	end
	bm = bm + 5 * GetNumOfGPCivilOfType(iPlayer, 6);
	bl = bl + 5 * GetNumOfGPCivilOfType(iPlayer, 7);
	ba = ba + 5 * GetNumOfGPCivilOfType(iPlayer, 8);
	if HasPlayerTech(iPlayer, titv8, "Vaeaewdqwe") then
		bl = bl * 2;
	end
	return bm, bl, ba, bl + bm + ba;
end

function CreateGreatWorkOfAmount(iPlayer, amount, type, bNotGenerated)
	gT.Players[iPlayer].NumGreatWorks = gT.Players[iPlayer].NumGreatWorks + amount;
	BasicCSMissionCompleteFunc(iPlayer, 9, amount)
	if not bNotGenerated then
		VictoryTaskCompletion(iPlayer, 7, amount)	
	end
	if gT.Globals.GameGenerated then
--bonuses only after generated
		local iRel = Players[iPlayer]:GetReligionCreatedByPlayer()
		if IsReligionHaveBelief(iRel, itgenhbeleif10) then
			ChangeITGFaith(iPlayer, amount * 25)
		end
		if gT.Players[iPlayer].CultPresOnGW > 0 then
			AddCulturalPresenceWorldWide(iPlayer, gT.Players[iPlayer].CultPresOnGW * amount)
		end
		TakeCareOfEventMorale(iPlayer, 13, {amount})
	end
	if type == "Music" then
		gT.Players[iPlayer].NumGWoM = gT.Players[iPlayer].NumGWoM + amount; 
		if gT.Players[iPlayer].HasPlayerWonder[wonderindu13] then
			AddCulturalPresenceWorldWide(iPlayer, amount * 15)
		end
	elseif type == "Literature" then
		gT.Players[iPlayer].NumGWoL = gT.Players[iPlayer].NumGWoL + amount; 
	elseif type == "Art" then
		gT.Players[iPlayer].NumGWoA = gT.Players[iPlayer].NumGWoA + amount; 
	elseif type == "Random" then
		local bm, bl, ba, bt = 1, 1, 1, 3;
		for i = 1, amount do
			local ll = LastRandom(1, bt);
			if ll <= bm then
				gT.Players[iPlayer].NumGWoM = gT.Players[iPlayer].NumGWoM + 1; 
				if gT.Players[iPlayer].HasPlayerWonder[wonderindu13] then
					AddCulturalPresenceWorldWide(iPlayer, 15)
				end
			elseif ll <= bm + bl then
				gT.Players[iPlayer].NumGWoL = gT.Players[iPlayer].NumGWoL + 1; 
			else
				gT.Players[iPlayer].NumGWoA = gT.Players[iPlayer].NumGWoA + 1; 
			end
		end
	else
		local bm, bl, ba, bt = GetPlayerChanceForCreatingGreatWorksOfType(iPlayer);
		for i = 1, amount do
			local ll = LastRandom(1, bt);
			if ll <= bm then
				gT.Players[iPlayer].NumGWoM = gT.Players[iPlayer].NumGWoM + 1;
				if gT.Players[iPlayer].HasPlayerWonder[wonderindu13] then
					AddCulturalPresenceWorldWide(iPlayer, 15)
				end
			elseif ll <= bm + bl then
				gT.Players[iPlayer].NumGWoL = gT.Players[iPlayer].NumGWoL + 1; 
			else
				gT.Players[iPlayer].NumGWoA = gT.Players[iPlayer].NumGWoA + 1; 
			end
		end
	end
end

function GetExtraGreatWorksFromCulturalFaithBonuses(iPlayer, type)
	local base = 0;
	if gT.Players[iPlayer].CultBonusOn[68] then
		base = base + 2;
	end
	if type == "Faith" then
		if gT.Players[iPlayer].GovRewards[50] then
			base = base + 3;
		end
	end
	return base;
end

function AssignInitialGreatWorks()
	if gT.EraData and gT.PreviousEra then
		for g, h in pairs(gT.Players) do
			if not Players[g]:IsMinorCiv() then
				local totalassign = LastRandom(DBScenario.MinStartingGW, DBScenario.MaxStartingGW)
				local gwBlessType = GetGWBlessType(g)
				if gwBlessType == -1 then
					totalassign = math.min(totalassign, LastRandom(DBScenario.MinStartingGW, DBScenario.MaxStartingGW));
				elseif gwBlessType > 0 then
					for jij = 1, gwBlessType do
						totalassign = math.max(totalassign, LastRandom(DBScenario.MinStartingGW, DBScenario.MaxStartingGW));
					end
				end
				local amount = math.min(tempconvinit[g].NumGreatWorks, totalassign);
				local numM = tempconvinit[g].NumGWoM;
				local numL = tempconvinit[g].NumGWoL;
				local numA = tempconvinit[g].NumGWoA;
				local tab = {{"Music",numM},{"Literature",numL},{"Art",numA}}
				for d = 1, amount do
					local lkey = GetRandomFromBiasedChanceTable(tab, true)
					tab[lkey][2] = tab[lkey][2] - 1;
				end
				local nummusic =  tempconvinit[g].NumGWoM - tab[1][2];
				local numliterature =  tempconvinit[g].NumGWoL - tab[2][2];
				local numart =  tempconvinit[g].NumGWoA - tab[3][2];
				if nummusic > 0 then
					CreateGreatWorkOfAmount(g, nummusic, "Music", true)	
				end
				if numart > 0 then
					CreateGreatWorkOfAmount(g, numart, "Art", true)	
				end
				if numliterature > 0 then
					CreateGreatWorkOfAmount(g, numliterature, "Literature", true)	
				end
				if totalassign > amount then
					CreateGreatWorkOfAmount(g, totalassign - amount, "Random", true)
				end
			end
		end
	else
		for g, h in pairs(gT.Players) do
			if not Players[g]:IsMinorCiv() then
				local amount = LastRandom(DBScenario.MinStartingGW, DBScenario.MaxStartingGW);
				if amount > 0 then
					CreateGreatWorkOfAmount(g, amount, "Random", true)
				end
			end
		end
	end
end

function DoTransferArt(iPlayer, tPlayer, stype, iPresence)
	gT.Players[iPlayer].NumGreatWorks = gT.Players[iPlayer].NumGreatWorks - 1; 
	gT.Players[tPlayer].NumGreatWorks = gT.Players[tPlayer].NumGreatWorks + 1
	if stype == "Random" then
		local options = {}
		if gT.Players[iPlayer].NumGWoM > 0 then
			table.insert(options, "Music")
		end
		if gT.Players[iPlayer].NumGWoA > 0 then
			table.insert(options, "Art")
		end
		if gT.Players[iPlayer].NumGWoL > 0 then
			table.insert(options, "Literature")
		end
		stype = options[LastRandom(1,#options)];
	end
	if stype == "Music" then
		gT.Players[iPlayer].NumGWoM  = gT.Players[iPlayer].NumGWoM  - 1;
		gT.Players[tPlayer].NumGWoM  = gT.Players[tPlayer].NumGWoM  + 1;
	elseif stype == "Art" then
		gT.Players[iPlayer].NumGWoA  = gT.Players[iPlayer].NumGWoA  - 1;
		gT.Players[tPlayer].NumGWoA  = gT.Players[tPlayer].NumGWoA  + 1;
	elseif stype == "Literature" then
		gT.Players[iPlayer].NumGWoL  = gT.Players[iPlayer].NumGWoL  - 1;
		gT.Players[tPlayer].NumGWoL  = gT.Players[tPlayer].NumGWoL  + 1;
	end
	if iPresence > 0 then
		AddCulturalPresenceInAllCities(iPlayer, tPlayer, iPresence)
	end
end

function GetChanceToHaveGWStolenInCityCapture(iPlayer)
	if gT.Players[iPlayer].NumGreatWorks > 0 then
		return math.max(10, gT.Players[iPlayer].NumGreatWorks * 2);
	end
	return 0;
end

function OccStringNatUnity(iCity)
	if iCity:IsOccupied() then
		return " [ICON_OCCUPIED] " 
	else
		return ""
	end
end

function ToolTipNatUnit(gPlayer)
	local strText = "National Unity is based on total unifying and dividing presence in your empire."
	local totg, totb = 0, 0;
	for i, dd in pairs(GetTabOfNatUnitySources(gPlayer, true)) do
		totb = totb + dd[3];
		totg = totg + dd[1];
		if dd[3] ~= 0 then
			if dd[1] ~= 0 then
				strText = strText .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]" ..  dd[1] .. "[ENDCOLOR]/[COLOR_NEGATIVE_TEXT]" ..  dd[3] .. "[ENDCOLOR] from " .. dd[2] .. ".";
			else
				strText = strText .. "[NEWLINE][ICON_BULLET][COLOR_NEGATIVE_TEXT]" ..  dd[3] .. "[ENDCOLOR] from " .. dd[2] .. ".";
			end
		elseif dd[1] ~= 0 then
			strText = strText .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]" ..  dd[1] .. "[ENDCOLOR] from " .. dd[2] .. ".";
		end
	end
	local modGood, modBad = 100, 100;
	for i, mm in pairs(GetNatUnityModifiersTab(gPlayer)) do
		if mm[1] ~= 0 then
			modGood = modGood + mm[1];
			if mm[1] > 0 then
				strText = strText .. "[NEWLINE][ICON_BULLET]+" ..  mm[1] .. "%[ENDCOLOR][ICON_ITG_UNIFY] from " .. mm[2] .. ".";
			else
				strText = strText .. "[NEWLINE][ICON_BULLET][COLOR_YELLOW]" ..  mm[1] .. "%[ENDCOLOR][ICON_ITG_UNIFY] from " .. mm[2] .. ".";
			end
		end
		if mm[3] ~= 0 then
			modBad = modBad + mm[3];
			if mm[3] > 0 then
				strText = strText .. "[NEWLINE][ICON_BULLET][COLOR_YELLOW]+" ..  mm[3] .. "%[ENDCOLOR][ICON_ITG_DIVIDE] from " .. mm[2] .. ".";
			else
				strText = strText .. "[NEWLINE][ICON_BULLET]" ..  mm[3] .. "%[ENDCOLOR][ICON_ITG_DIVIDE] from " .. mm[2] .. ".";
			end
		end
	end
	
	totg = math.max(math.floor(totg * modGood) / 100, 0)
	totb = math.max(math.floor(totb * modBad) / 100, 0)

	strText = strText .. "[NEWLINE]Total: [COLOR_POSITIVE_TEXT]" .. totg .."[ENDCOLOR][ICON_ITG_UNIFY]/[COLOR_NEGATIVE_TEXT]" .. totb .. "[ENDCOLOR][ICON_ITG_DIVIDE]."

	if not DBScenario.CultDevelopOff then
		strText = strText .. "[NEWLINE][NEWLINE]Civilizations with the highest [ICON_ITG_NAT_UNITY] National Unity are more likely to choose next Social Development for their cultural group."
	elseif gT.Globals.ScenarioType == 4 then
		strText = strText .. "[NEWLINE][NEWLINE]Civilizations with greater [ICON_ITG_NAT_UNITY] National Unity choose new Ideological Tenets first."
	else
		strText = strText .. "[NEWLINE]"
	end
	local preAdjusted = GetThisTurnCultureIndicator(gPlayer, true)
	local final = preAdjusted;
	for a, b in pairs(GetFinalAdjustmentToNatUnity(gPlayer, preAdjusted, false)) do
		if b[1] ~= 0 then
			final = final + b[1];
			strText = strText .. "[NEWLINE][ICON_BULLET]+" .. b[1] .. "% [ICON_ITG_NAT_UNITY] from " .. b[2] .. " (" .. b[3] .. "% of missing)" 
		end
	end
	strText = strText .. "[NEWLINE][NEWLINE]Predicted [ICON_ITG_NAT_UNITY] National Unity for next turn: " 
	if final < NAT_UNITY_PENALTY_FREE then
		if final < NAT_UNITY_BIG_PENALTY then
			strText = strText .. "[COLOR_NEGATIVE_TEXT]" .. final
		else
			strText = strText .. "[COLOR_YELLOW]" .. final
		end
	else
		strText = strText .. "[COLOR_POSITIVE_TEXT]" .. final
	end
	strText = strText .. "%[ENDCOLOR]."
	if final < NAT_UNITY_PENALTY_FREE then
		strText = strText .. "[NEWLINE][NEWLINE]Results in following penalties:"
		strText = strText .. "[NEWLINE][ICON_BULLET]" .. math.ceil((NAT_UNITY_PENALTY_FREE - final) / 2) .. "% chance for [ICON_ITG_MORALE] Morale to drop."
		strText = strText .. "[NEWLINE][ICON_BULLET]" .. -2 * math.ceil(NAT_UNITY_PENALTY_FREE - final) / 10 .. "% [ICON_HAPPINESS_1] Happiness chance."
		strText = strText .. "[NEWLINE][ICON_BULLET]+" .. math.ceil((NAT_UNITY_PENALTY_FREE - final) / 10) .. " [ICON_RESISTANCE] Riots' Strength."
		strText = strText .. "[NEWLINE][ICON_BULLET]Rebellions spawn 1 extra unit and deal 25 damage to Cities."
		if final < NAT_UNITY_BIG_PENALTY then
			strText = strText .. "[NEWLINE][ICON_BULLET]Duration of resistance is increased by 1 turn upon [ICON_RESISTANCE] Riots."
			strText = strText .. "[NEWLINE][ICON_BULLET]-1 [ICON_ITG_MERITOCRACY] Meritocracy."
		end
	end
	return strText;
end

function GetPrincipleModToCulturalBonus(iPlayer)
	local mod = 0;
	if gT.Globals.GameGenerated then
		if gT.Players[iPlayer].GovRewards[55] then
			mod = mod + math.floor(gT.Players[iPlayer].GoldSpentOnAcademies / 100);
		end
		if gT.Players[iPlayer].GovRewards[56] then
			mod = mod + math.floor(gT.Players[iPlayer].WorkRateSpent / 2000);
		end
		if gT.Players[iPlayer].GovRewards[57] then
			mod = mod + math.floor(1.5 * (gT.Players[iPlayer].LHSpecialDeals + gT.Players[iPlayer].LHAuctionDealsBuy))
		end
		if gT.Players[iPlayer].GovRewards[58] then
			for iTurn, val in pairs(Players[iPlayer]:GetGraphData(5)) do
				mod = mod + 3;
			end
		end
		if gT.Players[iPlayer].GovRewards[59] then
			for iClass, level in pairs(gT.Players[iPlayer].UnitClassTreshold) do
				if level >= 3 then
					mod = mod + 2;
				end
			end
		end
		if gT.Players[iPlayer].GovRewards[60] then
			for iTurn, val in pairs(Players[iPlayer]:GetGraphData(21)) do
				if val > 50 then
					mod = mod + 0.5;
				end
			end
			mod = math.floor(mod);
		end
	end
	return math.min(20, mod) * -0.01;
end

function GetTTCultureString(gPlayer)
	local strText = gT.Players[gPlayer].Culture .. " [ICON_CULTURE] Culture has been generated empire-wide.";
	local pPlayer = Players[gPlayer];
	local bFirstEntry = true;
	local cultab ={}
	table.insert(cultab, {GetPlayer10thBonusFromCaliph(gPlayer), "Caliphate"})
	table.insert(cultab, {pPlayer:GetJONSCulturePerTurnFromCities(), "Cities"})
	table.insert(cultab, {pPlayer:GetJONSCulturePerTurnFromTraits(), "Traits"})
	table.insert(cultab, {pPlayer:GetCulturePerTurnFromMinorCivs(), "City-States"})
	table.insert(cultab, {pPlayer:GetCulturePerTurnFromReligion(), "Religion"})
	table.insert(cultab, {GetCultureFromTithe(gPlayer), "Tithe"})
	table.insert(cultab, {GetFaithCultureFromWonderProcess(gPlayer), "Wonder Process"})
	table.insert(cultab, {GetCultureFromElDorados(gPlayer), "Golden Cities"})
	table.insert(cultab, {GetCultureFromCaligraphy(gPlayer), "Caligraphy"})
	table.insert(cultab, {GetITGCultureFromAncientRuins(gPlayer), "revealed Ancient Ruins"})
	table.insert(cultab, {GetCultureFromTechs(gPlayer), "Technologies"})
	table.insert(cultab, {GetCultureFromForts(gPlayer), "Forts and Citadels"})
	table.insert(cultab, {GetCultureFromTradeRoutes(gPlayer), "Trade-Routes"})
	table.insert(cultab, {GetCultureFromSocialDevs(gPlayer), "Social Developments"})
	table.insert(cultab, {GetCultureFromIdeologies(gPlayer), "Ideology"})
	table.insert(cultab, {GetCultureFromGreatWorks(gPlayer), "Great Works"})
	table.insert(cultab, {GetITGCulturePerTurnFromModifiers(gPlayer), "Total Modifiers"})
	for i, data in pairs(cultab) do
		if data[1] ~= 0 then
			if (bFirstEntry) then
				strText = strText .. "[NEWLINE]";
				bFirstEntry = false;
			end
			if data[1] > 0 then
				strText = strText .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]+" ..  data[1] .. "[ENDCOLOR][ICON_CULTURE] from " .. data[2] .. ".";
			else
				strText = strText .. "[NEWLINE][ICON_BULLET][COLOR_NEGATIVE_TEXT]" ..  data[1] .. "[ENDCOLOR][ICON_CULTURE] from " .. data[2] .. ".";
			end
		end
	end

	local getNextCost = NiceCostOfTechOrPolicy(gPlayer, GetDBCulturePlayerInfo(gPlayer, "BaseCultureCost"), gT.Players[gPlayer].CultureBonusAdopted, 2)
	strText = strText .. "[NEWLINE][NEWLINE]You need " .. getNextCost .. " [ICON_CULTURE] Culture for next cultural bonus.";
	local modTreshold = {};
	--HERE treshold
	if gT.WondersConstructed[GameInfoTypes.BUILDING_ITG_NEW_INDUSTRIAL_WONDER_21] == gPlayer then
		strText = strText .. "[NEWLINE]Treshold is reduced by victiorious melee combats (" .. Players[gPlayer]:GetVictoriousMeleeCombatCount() .. ").";
	end
	if HasPlayerTech(gPlayer, GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_ASIA_6, "gsdds") then
		strText = strText .. "[NEWLINE]Treshold is equalized with religious and scientific bonuses."
	end
	table.insert(modTreshold, {100 * GetModTresholdCultureFromSocials(gPlayer), "Social Developments"})	
	table.insert(modTreshold, {100 * GetModTresholdCultureFromLaws(gPlayer), "Laws"})	
	table.insert(modTreshold, {100 * GetModTresholdCultureFromIdeologies(gPlayer), "Ideologies"})	
	table.insert(modTreshold, {100 * GetModTresholdCultureFromGovernors(gPlayer), "Governors"})	
	table.insert(modTreshold, {100 * GetPrincipleModToCulturalBonus(gPlayer), "Principles"})	
	strText = HandleGGAttTresholdMods(strText, modTreshold)

	if IsCultureBonusChosenRandomly(gPlayer) then
		strText = strText .. "[NEWLINE][NEWLINE]Cultural bonus is chosen randomly.";
	end
	return strText;
end