local bcMint = GameInfoTypes.BUILDINGCLASS_NATIONAL_TREASURY
local wwonderesc = GameInfoTypes.BUILDING_ITG_NEW_WORLD_WONDER_14;
local techBanking = GameInfoTypes.TECH_BANKING			
local techEconomics = GameInfoTypes.TECH_ECONOMICS;	
local bcMarkets = GameInfoTypes.BUILDINGCLASS_MARKET;
local bcBanks = GameInfoTypes.BUILDINGCLASS_BANK;
local bcStock = GameInfoTypes.BUILDINGCLASS_STOCK_EXCHANGE;
local innoMedAfr2 = GameInfoTypes.TECH_UNIQUE_ITG_MEDIEVAL_AFR_2;
local tAncCs23 = GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_23
local techmeso = GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_MESOAMERICAN_6;
local phiCityHall = GameInfoTypes.BUILDING_ITG_NEW_INDUSTRIAL_WONDER_16
local induinno12 = GameInfoTypes.TECH_UNIQUE_ITG_INDUSTRIAL_12
local hSpeakForTrees;
local IsFeatureTrees = {[fForest] = true, [fJungle] = true};

local g_MintSitStrings = {
"Investments",
"Golden Touch",
"Big Pharma",
"Banking",
"Currency",
"Economics",
"Wealth Process",
"Markets",
"Banks",
"Stock Exchange", -- 10
"Wonder Ruins",
"Ecology",
"Budget",
"Custom Houses",
"Colonies",
"City-States",
"Foreign Currency Reserves",
"Science",
"Economy",
"Academies", -- 20
"Potosi", 
"Great People",
"Social Development",
"Mercantilism",
"Foreign Wealth Sources",
"Bankruptcy",
"Embargos",
"Inflation",
"Stability",
"Internal Expenses", -- 30
"Temporary modifiers",
"Counterfeit",
"Trade-Routes",
"Manufactories",
"Consumer Culture", -- 35
}

function GetMintSitString(type, g)
	if g_MintSitStrings[type] then
		return g_MintSitStrings[type];
	else
		return "ERROR 9685"
	end
end

function GetMintSituationOfPlayer(iPlayer)
	local strText = "";
	for i, sth in pairs(gT.Players[iPlayer].MintSituation) do
		if sth[2] > 0 then
			strText = strText .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]+" .. sth[2] .. "[ENDCOLOR] [ICON_INVEST] from " .. GetMintSitString(sth[1], iPlayer);
		elseif sth[2] < 0 then
			strText = strText .. "[NEWLINE][ICON_BULLET][COLOR_NEGATIVE_TEXT]" .. sth[2] .. "[ENDCOLOR] [ICON_INVEST] from " .. GetMintSitString(sth[1], iPlayer);
		end
	end
	return strText;
end

LuaEvents.ITG_RequestMintSituation.Add(function(iPlayer)
	MapModData.ITGSG = GetMintSituationOfPlayer(iPlayer);
end)

function GetStrengthOfCurrencyGold(iPlayer, iCity)
	local base = DBScenario.GoldFromCurrency;
	if iCity then
		if HaveMint(iCity) then
			base = base + 2;
		end
	end
	if HasPlayerTech(iPlayer, techmeso, "Dacweqwe") then
		base = base + 6;
	end
	if HasPlayerTech(iPlayer, induinno12, "fgergreg") then
		base = base + 3;
	end
	return base;
end

function AddNewCurrencyToPlayer(iPlayer, eResource, bTurn)
	if gT.Players[iPlayer].Currencies == eResource then
		return
	end
	gT.Players[iPlayer].Currencies = eResource; --bTurn or GetRealGameTurn();
	Players[iPlayer]:ChangeCanTradeResourceAway(eResource, 1)
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		local bonusGold = GetStrengthOfCurrencyGold(iPlayer, iCity)
		gT.Cities[cID].CurrencyResYield[eResource] = bonusGold;
		iCity:ChangeResourceExtraYield(eResource, yGold, bonusGold)
	end	
	if	gT.Players[iPlayer].HapChanceFromLuxuries[eResource] then
		if not gT.Players[iPlayer].CultBonusOn[67] then
			gT.Players[iPlayer].SleepHapChanceFromLuxuries[eResource] =	gT.Players[iPlayer].HapChanceFromLuxuries[eResource];
			gT.Players[iPlayer].HapChanceFromLuxuries[eResource] = nil;
		end
	end
	Players[iPlayer]:SetCurrencyResourceOne(gT.Players[iPlayer].Currencies)
end

function RemoveCurrencyFromPlayer(iPlayer, eResource)
	if gT.Players[iPlayer].Currencies ~= eResource then
		return
	end
	gT.Players[iPlayer].Currencies = nil;
	Players[iPlayer]:ChangeCanTradeResourceAway(eResource, -1)
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		if gT.Cities[cID].CurrencyResYield[eResource] then
			iCity:ChangeResourceExtraYield(eResource, yGold, - gT.Cities[cID].CurrencyResYield[eResource])
			gT.Cities[cID].CurrencyResYield[eResource] = nil;
		end
	end
	Players[iPlayer]:SetCurrencyResourceOne(-1)
end

function GetValidCurrencyFromPrevEra(iPlayer)
	if gT.EraData and gT.PreviousEra then
		if tempconvinit[iPlayer].Currencies then
			if LastRandom(1,5) ~= 4 then
				return tempconvinit[iPlayer].Currencies;
			end
		end
	end
	return nil;
end

function OnInitialAssignCurrencies(hMajorTab)
	local resPresent = GetResourcesPresentOnMap()
	for i, player in pairs(hMajorTab) do
		if Teams[Players[player]:GetTeam()]:IsHasTech(MINT_TECHNOLOGY) then
			if LastRandom(1,100) <= DBScenario.MintChance then
				local iCity = GetBestCityForMint(player)
				local bMint = Players[player]:GetPlayerUniqueBuilding(bcMint)
				iCity:SetNumRealBuilding(bMint, 1)
				gT.Players[player].MintPowerFromEvents = LastRandom(53,153)
			end
		end
		local gRes = GetValidCurrencyFromPrevEra(player);
		if not gRes then
			local pTab = {}
			local hTab = {}
			for res, H in pairs(gT.CurrencyResources) do
				if Players[player]:GetNumResourceTotal(res) > 0 then
					table.insert(pTab, res)
				else
					table.insert(hTab, res)
				end
			end
			if #pTab > 0 then
				gRes = pTab[LastRandom(1,#pTab)]
			else
				gRes = hTab[LastRandom(1,#pTab)]
			end					
		end
		if gRes then
			AddNewCurrencyToPlayer(player, gRes, -1)
		end
	end
end

function HaveMint(iCity)
	local bMint = Players[iCity:GetOwner()]:GetPlayerUniqueBuilding(bcMint);
	if bMint ~= -1 then
		if iCity:IsHasBuilding(bMint) then
			return true;
		end
	end
	return false;
end

function GetCityWithMint(iPlayer)
	for iCity in Players[iPlayer]:Cities() do
		if HaveMint(iCity) then
			return iCity;
		end
	end
end

function HasMintAnyCity(iPlayer)
	if gT.Players[iPlayer].HasPlayerWonder[wwonderesc] then
		return true;
	end
	if (gT.Players[iPlayer].HasMintAlways or 0) > 0 then
		return true;
	end
	for iCity in Players[iPlayer]:Cities() do
		if HaveMint(iCity) then
			return true;
		end
	end
	return false;
end

function GetBestCityForMint(player)
	local cap = Players[player]:GetCapitalCity();
	local hTab = {}
	for iCity in Players[player]:Cities() do
		if iCity:GetDamage() == 0 then
			table.insert(hTab, {iCity, iCity:GetStrengthValue()})
		end
	end
	if #hTab > 0 then
		table.sort(hTab,SortFunctionForGreaterInteger2)
		return hTab[1][1]
	else
		return cap
	end
end

function GetCurrentMintBonusTotal()
	local b = gT.Globals.MintTotalBonus;
	for g, gt in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			if HasMintAnyCity(g) then
				b = b + DBScenario.MintBonusPerMint
			end
		end
	end
	return b;
end

local wondernewowrld14 = GameInfoTypes.BUILDINGCLASS_ITG_NEW_WORLD_WONDER_14;
function AssignMintBonus()
	local hTab = {}
	local pLeft = GetCurrentMintBonusTotal();
	for gPlayer, gd in pairs(gT.Players) do
		if not Players[gPlayer]:IsMinorCiv() then
			if gd.MintPower > 0 then
				table.insert(hTab, {gPlayer, gd.MintPower})
			else
				AdjustMintPower(gPlayer, 0)
			end
		end
	end
	table.sort(hTab,SortFunctionForGreaterInteger2)
	local jic = #hTab;
	local uETab = {}
	for i = 1, jic do
		local tot, ps, player = 0, hTab[jic + 1 - i][2], hTab[jic + 1 - i][1];
		for it, sth in pairs(hTab) do
			if it <= jic + 1 - i then
				tot = tot + sth[2];
			end
		end
		local per = math.max(1, math.floor(pLeft * ps / tot))
		pLeft = pLeft - per;
		local pmod = 1;
		if gT.Players[player].HasPlayerWonder[wwonderesc] then
			pmod = pmod + 0.25;
		end
		if HasPlayerTech(player, tAncCs23, "beadae") then
			pmod = pmod + 0.25;
		end
		per = math.ceil(per * pmod );
		--add extra from leagues :)
		uETab[player] = per;
	end
	for player, per in pairs(uETab) do
		local extra = 0;
		for league, sth in pairs(gT.Leagues) do
			if sth.Members[player] and sth.Resolutions[7] then
				for jMember, h in pairs(sth.Members) do
					if jMember ~= player then
						if uETab[jMember] then
							local contr = math.ceil(uETab[jMember] / 10);
							extra = extra + contr;
							gT.Leagues[league].Members[jMember].HelpPoints[7] = gT.Leagues[league].Members[jMember].HelpPoints[7] + contr;
						end
					end
				end
			end
		end
		if gT.Globals.TechFirstTeams[induinno12] == player then
			extra = extra + 5;
		end
		AdjustMintPower(player, per + extra)
	end
end

function AdjustMintPower(player, per)
--	local prevper = gT.Players[player].MintBonus;
	Players[player]:SetCurrencyBonus(per)
--	if prevper == per then
--		return
--	end
--	local goldInPlayerCurrenct = Players[player]:GetGold()
--	local goldchange = math.floor(goldInPlayerCurrenct * (100 + per) / (100 + prevper)) - goldInPlayerCurrenct;
--	ChangeITGGold(player, goldchange)
	gT.Players[player].MintBonus = per;
	UpdateDirtyAllCitiesMintBonuses(player)
end

function UpdateDirtyAllCitiesMintBonuses(player)
	for iCity in Players[player]:Cities() do
		MakeCityMintBonuses(iCity, gT.Players[player].MintBonus)
	end
end

function MakeCityMintBonuses(iCity, per)
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local tGoldper = per;
	local tProdper = 0;
	if gT.Players[iCity:GetOwner()].HasIdeology[48] then
		tProdper = per;
		tGoldper = 0;
	end
	local scFromMint = 0;
	if gT.Players[iCity:GetOwner()].HasIdeology[42] then
		scFromMint = math.floor(per / 2)
	end
	SetBasicCityYieldRate(iCity, yGold, tGoldper, "CI_MINT_GOLD_RATE")
	SetBasicCityYieldRate(iCity, yScience, scFromMint, "CI_MINT_SCIENCE_RATE")
	SetBasicCityYieldRate(iCity, yProduction, tProdper, "CI_MINT_PROD_RATE")
end

function GetCurrencyBonusFromCS(iPlayer)
	local a = GetNumAlliedCS(iPlayer) * 3;
	for i, minor in pairs(gT.Globals.CSbyTypes[GameInfoTypes.MINOR_TRAIT_ECONOMIC]) do
		if Players[minor]:GetMinorCivFriendshipLevelWithMajor(iPlayer) > 0 then
			if Players[minor]:GetMinorCivFriendshipLevelWithMajor(iPlayer) > 1 then
				a = a + 50;
			else
				a = a + 20;
			end			
		end
	end
	if gT.Players[iPlayer].CultBonusOn[118] then
		a = math.floor(a * 1.5);
	end
	return a;	
end

function AdjustMilitaryPenalty()
	--it is now a support for small civs instead penalty 
	for g, gplayer in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
		--	local pen = math.max(0, Players[g]:GetNumUnits() - gT.Globals.MaxMilitaryUnits)
			local bonus = math.max(0, 100 - 10 * Players[g]:GetNumMilitaryUnits())
			local bonusIdeology5 = 0;
			if gplayer.HasIdeology[5] then
				bonusIdeology5 = GetNumAlliedCS(g) * 7;
			end
			tbonus = bonus + bonusIdeology5
			for iCity in Players[g]:Cities() do
				local ccb = GetITGCityInteger(iCity, "CI_MIL_IDEO_5") + GetITGCityInteger(iCity, "CI_MIL_PROD_SMALL_ARMY")
				iCity:ChangeDomainProductionModifier(dLand, tbonus - ccb)
				iCity:ChangeDomainProductionModifier(dSea, tbonus - ccb)
				iCity:ChangeDomainProductionModifier(dAir, tbonus - ccb)
				SetITGCityInteger(iCity, "CI_MIL_PROD_SMALL_ARMY", bonus);
				SetITGCityInteger(iCity, "CI_MIL_IDEO_5", bonusIdeology5)
			end
		end
	end
end

function ExtraFromMarketBankStockCH(iPlayer, iClass)
	local extra = 0;
	return extra;
end

function GetMintPowerFromStockExchange(iPlayer, iClass, val)
	local numBS = Players[iPlayer]:GetBuildingClassCount(iClass);
	if numBS == 0 then
		return 0;
	end
	local numcities, numstocks = 0, 0;
	for g, gh in pairs(gT.Players) do
		numcities = numcities + Players[g]:GetNumCities();
		numstocks = numstocks + Players[g]:GetBuildingClassCount(iClass);
	end
	return numBS * math.floor(val * numcities / numstocks)
end

function GetMintPowerFromBuildingClass(iPlayer, iClass, sAmount)
	local sBase = sAmount;
	local base = 0;
	local numBS = Players[iPlayer]:GetBuildingClassCount(iClass);
	for i = 1, numBS do
		base = base + sBase;
		sBase = math.max(1, math.floor(sBase / 2))
	end
	return base
end

function GetInflationFromValue(iValue, max, start)
	local sDown = start;
	local inf = 0;
	local bValue = iValue;
	while bValue > 0 do
		inf = inf + 1;
		bValue = bValue - sDown;
		sDown = math.min(max, sDown * 2)
	end
	return inf;
end

function DefineCurrTradeRoutesBonus()
	local hmax, hmin = 0, 90000;
	for g, gd in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			if HasMintAnyCity(g) then
				hmax = math.max(hmax, gd.CurrFromTR);
				hmin = math.min(hmin, gd.CurrFromTR);
			end
		end
	end
	if hmax - hmin > 300 then
		for g, gd in pairs(gT.Players) do
			if not Players[g]:IsMinorCiv() then
				gT.Players[g].CurrFromTR = math.floor(gT.Players[g].CurrFromTR / 2)
			end
		end
		hmin = math.floor(hmin / 2);
	end
	gT.Globals.TRCurrReduce = hmin;
end

function DoEndTurnMintPowerFromEcologyCount()
	if not hSpeakForTrees then
		hSpeakForTrees = {}
		for i = 0, Map:GetNumPlots() - 1, 1 do
			local fPlot = Map.GetPlotByIndex( i );
			if IsFeatureTrees[fPlot:GetFeatureType()] then
				hSpeakForTrees[i] = true;
			end
		end
	end
	local pEcoTab = {}
	for g, h in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			if HasPlayerTech(g, GameInfoTypes.TECH_ECOLOGY, "^#4534%") then
				pEcoTab[g] = 0;
			end
		end
	end
	local totHb = 0;
	for a, b in pairs(hSpeakForTrees) do
		local bPlot = Map.GetPlotByIndex(a);
		if IsFeatureTrees[bPlot:GetFeatureType()] then
			totHb = totHb + 1;
			local bOwner = bPlot:GetOwner();
			if pEcoTab[bOwner] then
				pEcoTab[bOwner] = pEcoTab[bOwner] + 1;
			end
		else
			hSpeakForTrees[a] = nil;
		end
	end
	local vOneTree = math.ceil(1000 / math.max(1, totHb)) 
	for a, h in pairs(pEcoTab) do
		gT.Players[a].EcologyMintPower = h * vOneTree;
	end
end

function InitialMintRelatedStuff()
	local thc = 25;
	if gT.Globals.ScenarioType == 4 then
		thc = 75;
	elseif gT.Globals.ScenarioType == 5 then
		thc = 90;
	end
	for g, gd in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			if HasMintAnyCity(g) then
				if LastChance(thc) then
					local options = {}
					for j, b in pairs(gT.Players) do
						if (not Players[j]:IsMinorCiv()) and (j ~= g) and (HasMintAnyCity(j)) then
							if Teams[Players[g]:GetTeam()]:IsHasMet(Players[j]:GetTeam()) then
								table.insert(options, j);
							end
						end
					end
					if #options > 0 then
						gT.Players[g].ForeignReserve = options[LastRandom(1,#options)];
					end
				end
			end
		end
	end
end

function GetMintPowerFromManufactories(iPlayer)
	local iPerEngineer = 3 * GetNumPlayerManufactoryTrait(iPlayer, 8)
	local iBonus = 0;
	if iPerEngineer > 0 then
		for iCity in Players[iPlayer]:Cities() do
			iBonus = iBonus + iCity:GetSpecialistCount(specEngineer) * iPerEngineer;
		end
	end
	return iBonus;
end

function AssignEndTurnMintPowerChanges()
	local cgpinf = 0;
	local gTurn = GetITGGameTurn();
	DefineCurrTradeRoutesBonus()
	DefineCurrencyBasicValues()
	if gT.Globals.EcologyOn then
		DoEndTurnMintPowerFromEcologyCount()
	end
	local cachedMintPower = {};
	local mInternalExpenses = 5000;
	for g, gd in pairs(gT.Players) do
		cachedMintPower[g] = gd.MintPower or 0;
		mInternalExpenses = math.max(mInternalExpenses, gd.TotalGoldSpendInternally or 0);
	end
	for g, gd in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			gT.Players[g].MintSituation = {}
			gT.Players[g].InflationLastTurn = 0;
			if HasMintAnyCity(g) then
				if not gd.MintActive then
					gT.Players[g].MintEstablished = gTurn;
					gT.Players[g].MintActive = true;
				end
				local BasicMintVals = {}
				local totalpower = 0;
				table.insert(BasicMintVals, {gd.InvestCurrencyPower, 1})
				if HasPlayerTech(g, tAncCs23, "beadae") then
					table.insert(BasicMintVals, {100, 2})
				end
				if gd.HasIdeology[19] then
					local cth = GetPlayerTotalHealth(g)
					table.insert(BasicMintVals, {cth, 3})
				end
--CURRENCY STARTS				
				local maxpowertechcurrency = 0;
				if HasPlayerTech(g, techBanking, "Caceaew") then
					maxpowertechcurrency = maxpowertechcurrency - 100;
					table.insert(BasicMintVals, {100, 4})
				end
				table.insert(BasicMintVals, {EstimateCurValueFromFakeTab(g, gd.Currencies, maxpowertechcurrency), 5})
--RES POWER ends!
				
				if HasPlayerTech(g, techEconomics, "caeqweqwe") then
					table.insert(BasicMintVals, {50, 6})
				end
				if (gd.MintPowerFromWealthProcess or 0) > 0 then
					table.insert(BasicMintVals, {GetProperlyBalancedWealthProcessBonus(gd.MintPowerFromWealthProcess), 7})
					gT.Players[g].MintPowerFromWealthProcess = 0;
				end
				table.insert(BasicMintVals, {GetMintPowerFromBuildingClass(g, bcMarkets, 10) + ExtraFromMarketBankStockCH(g, bcMarkets), 8})
				table.insert(BasicMintVals, {GetMintPowerFromBuildingClass(g, bcBanks, 25) + ExtraFromMarketBankStockCH(g, bcBanks), 9})
				table.insert(BasicMintVals, {GetMintPowerFromStockExchange(g, bcStock, 5) + ExtraFromMarketBankStockCH(g, bcStock), 10})
				table.insert(BasicMintVals, {25 * (gd.WonderRuinsEffects[23] or 0), 11})
				table.insert(BasicMintVals, {gd.EcologyMintPower or 0, 12})
				table.insert(BasicMintVals, {gd.EconomicsBudget or 0, 13})

				local customhousepower = 0;
				for index, sth in pairs(gT.CustomsHouses) do
					if sth.Player == g then
						if IsCustomsHouseActiveReady(index) then
							customhousepower = customhousepower + sth.BasicBonuses[2];
							if sth.IncomingBonuses[14] then
								customhousepower = customhousepower + 30;
							end
						end
					end
				end
				table.insert(BasicMintVals, {customhousepower, 14})
				table.insert(BasicMintVals, {GetNumSpecialControlPoint(g, "Colonies"), 15})

				table.insert(BasicMintVals, {GetCurrencyBonusFromCS(g), 16})
				local fuycar = 0;
				for jbc, dhk in pairs(gT.Players) do
					if dhk.ForeignReserve == g then
						fuycar = fuycar + 25;
					end
				end
				if gd.ForeignReserve then
					fuycar = fuycar + math.min(75, math.floor(cachedMintPower[gd.ForeignReserve] / 15))
				end
				table.insert(BasicMintVals, {fuycar, 17})
				local acadCP = gd.CurrPowerAcad;
				if gd.HasIdeology[42] then
					acadCP = acadCP + GetPlayerSmallAcademyPointsOfType(g, 18)
					acadCP = acadCP + GetPlayerSmallAcademyPointsOfType(g, 19)
				end
				table.insert(BasicMintVals, {acadCP, 20})
				table.insert(BasicMintVals, {GetMintPowerFromManufactories(g), 34})
				if HasPlayerNatureWonder(g, GameInfoTypes.FEATURE_POTOSI) then
					table.insert(BasicMintVals, {25, 21})
				end
				local bankrupcypower = 0;
				local inflationpower = 0;
				-- events
				local curpowerGP = 0;
				for gpID, hhh in pairs(gd.GreatPeople) do
					local gd = gT.GreatPeople[gpID];
					if gd.Alive and (not gd.Military) then
						if not gd.LifeDone then
							if gd.Ability == 39 then
								curpowerGP = curpowerGP + 35;
							end
						end
					end
				end
				if gd.HasIdeology[65] then
					curpowerGP = curpowerGP + 20 * GetNumOfGPCivilOfType(g, 8)
				end
				table.insert(BasicMintVals, {curpowerGP, 22})
				if gd.CultBonusOn[170] then	
					table.insert(BasicMintVals, {50, 23})
				end
				if gd.CultBonusOn[60] then
					table.insert(BasicMintVals, {20 * GetNumDealsAuctionHouse(g, false, true), 24})
				end
				table.insert(BasicMintVals, {math.max(0, math.ceil((GetGoldFromAuctionDeals(g) + Players[g]:GetGoldPerTurnFromDiplomacy())/3)), 25})

				--
				local gpt = gd.PrevTurnGPT or 0;
				local tGold = Players[g]:GetGold();
				gT.Players[g].MintStability = math.min(100, gT.Players[g].MintStability + 10);
				if DBScenario.GoldBudgetOnly then
					if gpt > 200 then
						inflationpower = inflationpower - GetInflationFromValue(gpt - 200, 25, 1)
						gT.Players[g].MintStability = 0;
					elseif gpt < 0 then
						bankrupcypower = bankrupcypower - math.ceil(-gpt / 5)
						gT.Players[g].MintStability = 0;
					end
				else
					if gpt < 0 then
						bankrupcypower = bankrupcypower - math.ceil(-gpt / 5)
						gT.Players[g].MintStability = 0;
					elseif gpt > 50 then
						inflationpower = inflationpower - GetInflationFromValue(gpt - 50, 100, 1)
						gT.Players[g].MintStability = 0;
					end
					if tGold < 50 then
						bankrupcypower = bankrupcypower - 10;
						gT.Players[g].MintStability = 0;
					elseif tGold > 1500 then
						inflationpower = inflationpower - GetInflationFromValue(tGold - 1500, 500, 10)
						gT.Players[g].MintStability = 0;
					end
				end
				if not gd.HasPlayerWonder[phiCityHall] then
					table.insert(BasicMintVals, {bankrupcypower * 3, 26})
				end
				local iEmbargoPenalty = gd.EmbargoCount * -25;
				if gd.HasIdeology[38] then
					iEmbargoPenalty = math.floor(iEmbargoPenalty / 2);
				end
				table.insert(BasicMintVals, {iEmbargoPenalty, 27})
				if HasPlayerTech(g, innoMedAfr2 , "sdces") then
					cgpinf = math.min(cgpinf, inflationpower)
				end
				inflationpower = math.min(gT.Globals.GlobalInflation, inflationpower)
				if inflationpower ~= 0 then
					if not gT.Players[g].HasIdeology[62] then
						table.insert(BasicMintVals, {inflationpower * 5, 28})
					end
					gT.Players[g].InflationLastTurn = inflationpower;
				end			
				table.insert(BasicMintVals, {gT.Players[g].MintStability, 29})
				
				--trying new approach for internal expenses
				gT.Players[g].CurrGoldInternal = math.floor(-200 * gd.TotalGoldSpendInternally / mInternalExpenses)

--				option with fading each turn, even if spent gold:
--				gT.Players[g].CurrGoldInternal = math.min(0, gT.Players[g].CurrGoldInternal + math.max(8, math.floor(gT.Players[g].CurrGoldInternal * 0.08)))
--				if gT.Players[g].GoldSpendInternally > 0 then
--					gT.Players[g].CurrGoldInternal = gT.Players[g].CurrGoldInternal - math.ceil(gT.Players[g].GoldSpendInternally / 15)
--				end
				table.insert(BasicMintVals, {gT.Players[g].CurrGoldInternal, 30})
				DoTrimObsoleteTempCurrMods(g, gTurn)
				if gT.Players[g].CurrFromWarfare ~= 0 then
					table.insert(BasicMintVals, {gT.Players[g].CurrFromWarfare, 31})
				end
				if gT.Players[g].CurrCounterfeit ~= 0 then
					table.insert(BasicMintVals, {gT.Players[g].CurrCounterfeit, 32})
					gT.Players[g].CurrCounterfeit = math.min(0, gT.Players[g].CurrCounterfeit + math.max(10, math.floor(-gT.Players[g].CurrCounterfeit / 10)))
				end
				table.insert(BasicMintVals, {gT.Players[g].CurrFromTR - gT.Globals.TRCurrReduce, 33})
				
				if gd.CPFromConsumerCulture then
					table.insert(BasicMintVals, {gT.Players[g].CPFromConsumerCulture, 35})
					gT.Players[g].CPFromConsumerCulture = gT.Players[g].CPFromConsumerCulture - 25;
					if gT.Players[g].CPFromConsumerCulture <= 0 then
						gT.Players[g].CPFromConsumerCulture = nil;
					end
				end


				for a, b in pairs(BasicMintVals) do
					if b[1] and b[1] ~= 0 then
						totalpower = totalpower + b[1]
						table.insert(gT.Players[g].MintSituation, {b[2], b[1], b[3]})
					elseif not b[1] then
						print("Missing b[1]", b[2])
					end
				end

				gT.Players[g].MintPower = math.max(1, totalpower);
			else
				gT.Players[g].MintPower = 0;
			end
			gT.Players[g].GoldSpendInternally = 0;
		end
	end
	AssignMintBonus()
	local t, h = 0, 0;
	for g, j in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			t = t + j.MintBonus
			h = h + 1;
		end
	end
	gT.Globals.GlobalInflation = cgpinf;
	gT.Globals.AverageMintBonus = math.floor(t/h)
end

function PlayerMayJustLooseAMint(jPlayer)
	if gT.Players[jPlayer].MintActive then
		-- it actually loose the mint!!!
		local amGold = 0.8 * Players[jPlayer]:GetGold();
		if gT.Players[jPlayer].ForeignReserve then
			amGold = amGold / 2;
		end
		amGold = math.floor(amGold);
		if amGold > 0 then
			ChangeITGGold(jPlayer, -amGold)
			if jPlayer == Game.GetActivePlayer() then
				Players[jPlayer]:AddNotification(94343293, "We have no longer have a Mint, our currency became worthless (" .. -amGold .. " [ICON_GOLD]).", "Mint Lost", -1, -1, 3)
			end
		end
		for g, gData in pairs(gT.Players) do
			if g ~= jPlayer and (not Players[g]:IsMinorCiv()) then
				if gData.ForeignReserve == jPlayer then
					local goldloss = math.floor(Players[g]:GetGold() * 0.2);
					if (goldloss or 0) > 0 then
						ChangeITGGold(g, -goldloss)
						if g == Game.GetActivePlayer() then
							Players[g]:AddNotification(94343293, Players[jPlayer]:GetCivilizationAdjective() .. " currency became worthless (" .. -goldloss .. " [ICON_GOLD]).", "Currency Rate", -1, -1, 3, jPlayer)
						end
					end
					gT.Players[g].ForeignReserve = nil;
				end
			end
		end
		gT.Players[jPlayer].MintSituation = {}
		CheckThisRandomActivePlayerInvestingInMintJustDestroyed(jPlayer)
	end
	gT.Players[jPlayer].CurrGoldInternal = 0;
	gT.Players[jPlayer].CurrFromWarfare = 0;
	gT.Players[jPlayer].TempCurrData = {};
	gT.Players[jPlayer].CurrCounterfeit = 0;
	gT.Players[jPlayer].MintPower = 0;
	gT.Players[jPlayer].ForeignReserve = nil;
	gT.Players[jPlayer].MintActive = false;
	gT.Players[jPlayer].InvestCurrencyPower = 150;
	AdjustMintPower(jPlayer, 0)
end

function DoApplyCurrencyChangeOnCityCapture(jPlayer, newPlayer)
	DoAddTemporalCurrencyPower(jPlayer, -LastRandom(15,25))
	DoAddTemporalCurrencyPower(newPlayer, LastRandom(15,25))
end

function ChangeGoldSpendInternally(iPlayer, amount)
	gT.Players[iPlayer].GoldSpendInternally = gT.Players[iPlayer].GoldSpendInternally + amount;
	gT.Players[iPlayer].TotalGoldSpendInternally = gT.Players[iPlayer].TotalGoldSpendInternally + amount;
end

function CanHaveMintPower(iPlayer)
	if gT.Players[iPlayer] then
		if not Players[iPlayer]:IsMinorCiv() then
			if HasMintAnyCity(iPlayer) then
				return true;
			end
		end
	end
	return false;
end

function GetExtraEffectivenessInMoneyForgery(tPlayer, gPlayer)
	return Players[gPlayer]:GetNumResourceTotal(gT.Players[tPlayer].Currencies, true)
end

function DoCounterFeit(gPlayer, tPlayer, iAgent, iRank)
	local percentageloss = LastRandom(18, 22 + iRank + GetExtraEffectivenessInMoneyForgery(tPlayer, gPlayer));
	if not gT.Players[tPlayer].ForeignReserve then
		percentageloss = percentageloss + 10;
	end
	local mintpowerloss = gT.Players[tPlayer].MintPower -  math.floor(gT.Players[tPlayer].MintPower * (1 - percentageloss/100));
	local goldloss = - math.floor(Players[tPlayer]:GetGold() * (percentageloss/100));
	if gT.Players[tPlayer].HasPlayerWonder[wwonderesc] then
		percentageloss = percentageloss / 2;
		mintpowerloss = mintpowerloss / 2;
		goldloss = goldloss / 2;
	end
	gT.Players[tPlayer].CurrCounterfeit = gT.Players[tPlayer].CurrCounterfeit - math.floor(gT.Players[tPlayer].MintPower * (percentageloss/100))
	if goldloss ~= 0 then
		ChangeITGGold(tPlayer, goldloss)
	end
	gT.Players[tPlayer].LastTimeAttackedBySpy = GetITGGameTurn();
	gT.Players[tPlayer].NumCounterfeited = gT.Players[tPlayer].NumCounterfeited + 1;
	if Players[gPlayer]:IsHuman() then
		local sText = GetNiceTextForEspionageLog(5, gPlayer, iAgent, 6, tPlayer, nil);
		sText = sText .. "[NEWLINE][NEWLINE]Enemy has suffered: " .. goldloss .. "[ICON_GOLD], " .. -mintpowerloss .. "[ICON_INVEST].";
		Players[gPlayer]:AddNotification(NotificationTypes.NOTIFICATION_INTRIGUE_DECEPTION, sText, "Counterfeit Succeed");
	end
	if Players[tPlayer]:IsHuman() then
		local sText = GetNiceTextForEspionageLog(6, tPlayer, iAgent, 6, gPlayer, nil);
		sText = sText .. "[NEWLINE][NEWLINE]We have suffered: " .. goldloss .. "[ICON_GOLD], " .. -mintpowerloss .. "[ICON_INVEST].";
		Players[tPlayer]:AddNotification(NotificationTypes.NOTIFICATION_TECH_STOLEN_SPY_DETECTED, sText, "Fake Money!");
	end

	for g, gData in pairs(gT.Players) do
		if g ~= tPlayer and (not Players[g]:IsMinorCiv()) then
			if gData.ForeignReserve == tPlayer then
				local goldloss = math.floor(Players[g]:GetGold() * 0.07)
				if (goldloss or 0) > 0 then
					ChangeITGGold(g, -goldloss)
					if g == Game.GetActivePlayer() then
						Players[g]:AddNotification(94343293, Players[tPlayer]:GetCivilizationAdjective() .. " currency was counterfeit and its value dropped (" .. -goldloss .. " [ICON_GOLD]).", "Currency Rate", -1, -1, 3)
					end
				end
			end
		end
	end
	VictoryTaskCompletion(gPlayer, 39)
	DoLogDominationEvent(12, gPlayer, tPlayer, 20, -40, true)
end

function PreparedDataForCurrencyAction(iPlayer)
	local data = {BonusType = 1, SpecialType = "Action", TitleText = "Adjust your currency.", TitleIconIndex = 34, TitleIconAtlas = "BW_ATLAS_1"}
	local hTab = {}
	local cRes = gT.Players[iPlayer].Currencies;
	local cVal = EstimateCurValueFromFakeTab(iPlayer, cRes)
	for res, data in pairs(gT.CurrencyResources) do
		if gT.Players[iPlayer].Currencies ~= res then
			table.insert(hTab, {Name = "Establish Currency ([COLOR_POSITIVE_TEXT]" .. Players[iPlayer]:GetNumResourceTotal(res, true) .. "[ENDCOLOR])",
				ID = res,
				PortraitIndex = GameInfo.Resources[res].PortraitIndex,
				IconAtlas = GameInfo.Resources[res].IconAtlas,
				Help = GetHelpForCurrencyAdjust(iPlayer, res, cVal)
				})	
		end
	end
	data.UniqueOptions = hTab;
	return data;
end

function HumanPlayerChooseCurrencyChange(iPlayer, res)
	if gT.Players[iPlayer].Currencies == res then
		print("Error 9124215123")
	else
		RemoveCurrencyFromPlayer(iPlayer, gT.Players[iPlayer].Currencies)
		gT.Players[iPlayer].AILastCurrencyChange = GetITGGameTurn();
		AddNewCurrencyToPlayer(iPlayer, res)
	end
end

LuaEvents.ITGSG_RequestCurrencyGeneralInfo.Add(function(iPlayer)
	local tab = {Currencies = {}, HaveMint = HasMintAnyCity(iPlayer), Power = gT.Players[iPlayer].MintPower, Bonus = gT.Players[iPlayer].MintBonus, Defense = GetDefAgainstMoneyForgery(iPlayer), DefTT = GetEspionageMoneyForgeryDef(iPlayer)}
	for iCity in Players[iPlayer]:Cities() do
		if HaveMint(iCity) then
			tab.Location = iCity:GetName();
			break;
		end
	end
	table.insert(tab.Currencies, {gT.Players[iPlayer].Currencies, Players[iPlayer]:GetNumResourceTotal(gT.Players[iPlayer].Currencies, true)})
	MapModData.ITGSG = tab;
end)

function GetProperlyBalancedWealthProcessBonus(iVal)
	local rValue = 0;
	--100; 80; 60; 40; 20; 10; 10; 10
	local iMod = 1;
	while iVal > 0 do
		if iVal >= 100 then
			rValue = rValue + 100 * iMod;
			iVal = iVal - 100;
			iMod = math.max(0.1, iMod - 0.2);
		else
			rValue = rValue + iVal * iMod;
			iVal = 0;		
		end
	end
	return math.ceil(rValue);
end

function DoAddTemporalCurrencyPower(iPlayer, iVal)
	if iVal ~= 0 then
		if CanHaveMintPower(iPlayer) then
			local iTurn = GetITGGameTurn() + 10;
			gT.Players[iPlayer].CurrFromWarfare = gT.Players[iPlayer].CurrFromWarfare + iVal;
			gT.Players[iPlayer].TempCurrData[iTurn] = (gT.Players[iPlayer].TempCurrData[iTurn] or 0) + iVal;
		end
	end
end

function DoTrimObsoleteTempCurrMods(iPlayer, gTurn)
	if gT.Players[iPlayer].TempCurrData[gTurn] then
		gT.Players[iPlayer].CurrFromWarfare = gT.Players[iPlayer].CurrFromWarfare - gT.Players[iPlayer].TempCurrData[gTurn];
		gT.Players[iPlayer].TempCurrData[gTurn] = nil;
	end
end

