local gRcoreRes = {GameInfoTypes.RESOURCE_COCOA,GameInfoTypes.RESOURCE_PEARLS,
GameInfoTypes.RESOURCE_COPPER,
GameInfoTypes.RESOURCE_SALT,
GameInfoTypes.RESOURCE_IVORY,
GameInfoTypes.RESOURCE_SILVER,
GameInfoTypes.RESOURCE_FUR,
GameInfoTypes.RESOURCE_SPICES,
GameInfoTypes.RESOURCE_GEMS,
GameInfoTypes.RESOURCE_GOLD}
local techBanking = GameInfoTypes.TECH_BANKING			
local techEconomics = GameInfoTypes.TECH_ECONOMICS;	

function TakeCareOfCurrencyResources()
	local resTab = GetResourcesPresentOnMap()
	if not gT.CurrencyResources then
		gT.CurrencyResources = {}
		local tab = {}
		for g, h in pairs(gRcoreRes) do
			if resTab[h] then
				table.insert(tab, h)
			end
		end
		tab = Shuffle(tab)
		local finalR = {}
		for i = 1, NUM_CURRENCY_RESOURCES do
			if tab[i] then
				table.insert(finalR, tab[i])
			end
		end
		local iLeft = NUM_CURRENCY_RESOURCES - #finalR;
		if iLeft > 0 then
			local reservR = {}
			for row in GameInfo.Resources() do
				if not row.Migration then
					if row.Happiness > 0 then
						if resTab[row.ID] then
							table.insert(reservR, row.ID)
						end
					end
				end
			end
			if #reservR < iLeft then
				print("Not even X luxuries resources dected on map. Game Is Over")
				return;
			end
			reservR = Shuffle(reservR)
			for i = 1, iLeft do
				table.insert(finalR, reservR[i])
			end
		end

		for i, res in pairs(finalR) do
			gT.CurrencyResources[res] = {}
		end
	end
	for res, dD in pairs(gT.CurrencyResources) do
		local icT = 0;
		for index, sth in pairs(resTab[res]) do
			if not gT.ExtraLuxuryResources[index] then
				icT = icT + 1;
			end
		end
		gT.CurrencyResources[res].Quantity = icT;
	end
	DefineInitPriceAuctionHouse()
	DefineCurrencyBasicValues()
end

function LogResourceForCurrency(restype, amount)
	if gT.CurrencyResources and gT.CurrencyResources[restype] then
		gT.CurrencyResources[restype].Quantity = gT.CurrencyResources[restype].Quantity + amount;
	end
end

function PlayerFindsHiddenResources()
	if not gT.Globals.HiddenResourcesFound then
		local resTab = GetResourcesPresentOnMap()
		gT.Globals.HiddenResourcesFound = true;
		for res, data in pairs(gT.CurrencyResources) do
			local icT = 0;
			for index, sth in pairs(resTab[res]) do
				if gT.ExtraLuxuryResources[index] then
					icT = icT + 1;
				end
			end
			gT.CurrencyResources[res].Quantity = gT.CurrencyResources[res].Quantity + icT;
		end
	end
end

function GetDefAgainstMoneyForgery(iPlayer)
	local base = 15;
	base = base + gT.Players[iPlayer].DefAgainstCounterfeit
--	base = base + GetExtraDefenseFromRarityOfCurrencyRes(iPlayer)
	base = base + GetPlayerBaseDefenseAgainstEspionage(iPlayer, iCity)
	return base
end

function GetEspionageMoneyForgeryDef(iPlayer)
	local htr = "Sources of defense against Money Forgery:"
	local tabD = {}
	table.insert(tabD, {gT.Players[iPlayer].DefAgainstCounterfeit, "Academies"})
--	table.insert(tabD, {GetExtraDefenseFromRarityOfCurrencyRes(iPlayer), "Currency Rarity"})
	table.insert(tabD, {GetPlayerBaseDefenseAgainstEspionage(iPlayer, iCity), "Espionage"})
	table.insert(tabD, {15, "Base"})
	local rdef = 0;
	for a, b in pairs(tabD) do
		if b[1] > 0 then
			rdef = rdef + b[1];
			htr = htr .. "[NEWLINE][ICON_BULLET]+" .. b[1] .. " from " .. b[2] .. "."
		end
	end
	htr = htr .. "[NEWLINE][NEWLINE]This means that average rival agent with second rank has " .. math.floor(100 * (1 - rdef / 60)) .. "% chance to counterfeit our [ICON_INVEST] Currency."
	return htr;
end

function DefineCurrencyBasicValues()	
	for eRes, sth in pairs(gT.CurrencyResources) do
		local iCount = 0;
		for g, h in pairs(gT.Players) do
			iCount = iCount + GetNumCurrencyResource(g, eRes)
		end
		gT.CurrencyResources[eRes].GlobalAmount = math.max(math.ceil(sth.Quantity / 2), iCount);
	end
end

function TryToFindNewLuxuryResourceGP(iPlayer, gpID)
	local tabRes = {[gT.Players[iPlayer].Currencies] = {}}
	for i = 0, Map:GetNumPlots() - 1, 1 do
		local fPlot = Map.GetPlotByIndex( i );
		if fPlot:GetOwner() == iPlayer then
			if fPlot:GetResourceType() == -1 then
				if not IsSpecialControlPlot(i) then
					for res, a in pairs(tabRes) do
						if fPlot:CanHaveResource(res) then
							table.insert(tabRes[res], i)
						end
					end
				end
			end
		end
	end
	local lplot, res;
	local hhhT = {}
	for res, a in pairs(tabRes) do
		if #a > 0 then
			table.insert(hhhT, res)
		end
	end
	if #hhhT == 0 then
		return;
	end
	res = hhhT[LastRandom(1,#hhhT)];
	lplot = Map.GetPlotByIndex(tabRes[res][LastRandom(1,#tabRes[res])]);
	AddProperlyResourceOnPlot(lplot, res, true, true)
	if not lplot:IsResourceConnectedByImprovement(lplot:GetImprovementType()) then
		MakeAnyValidImprovement(lplot, true, false, nil)
	end
	if Players[iPlayer]:IsHuman() then
		local strTitle = "Resource discovered!";
		local string = "Most adventorous " .. GetGreatPersonName(gpID) .. " discovered a new source of " .. GameInfo.Resources[res].IconString .. " " .. Locale.Lookup(GameInfo.Resources[res].Description) .. "!";
		Players[iPlayer]:AddNotification(5521344, string, strTitle, res:GetX(), res:GetY(), gT.GreatPeople[gpID].Type)
	end
end

function GetNumCurrencyResource(iPlayer, res)
	return Players[iPlayer]:GetNumResourceTotal(res, true) * gT.Players[iPlayer].ResCurrencyAmountMod
end

function GetHelpForCurrencyAdjust(iPlayer, res, cVal)
	local str = "[NEWLINE]" .. GameInfo.Resources[res].IconString .. " " .. Locale.Lookup(GameInfo.Resources[res].Description) .. " (" .. GetNumCurrencyResource(iPlayer, res) .. "/" ..  gT.CurrencyResources[res].GlobalAmount .. ") will yield extra [ICON_GOLD] Gold and contribute towards your [ICON_INVEST] Mint power, however it will no longer count as a luxury resource (current currency resource will be replaced).";
	local sNewResVal = EstimateCurValueFromFakeTab(iPlayer, res)
	local sText = "[COLOR_POSITIVE_TEXT]";
	if sNewResVal < (cVal or 0) then
		sText = "[COLOR_NEGATIVE_TEXT]"
	end
	str = str .. "[NEWLINE][NEWLINE]After this action expected [ICON_INVEST] Currency Power from resource is: " .. sText .. sNewResVal .. "[ENDCOLOR][ICON_INVEST].";
	return str;
end

function EstimateCurValueFromFakeTab(iPlayer, iResource, tRed)
	local maxpowerfromcurrency = 350;
	if not tRed then
		if HasPlayerTech(iPlayer, techBanking, "Caceaew") then
			maxpowerfromcurrency = maxpowerfromcurrency - 100;
		end
	else	
		maxpowerfromcurrency = maxpowerfromcurrency + tRed;
	end
	if gT.CurrencyResources[iResource].GlobalAmount > 0 then
		maxpowerfromcurrency = maxpowerfromcurrency + 10 * gT.CurrencyResources[iResource].GlobalAmount
		return math.floor(GetNumCurrencyResource(iPlayer, iResource) * maxpowerfromcurrency / gT.CurrencyResources[iResource].GlobalAmount)
	end
	return 0;
end