local g_DBnoinitrelations;

function InitDBInitialRelations()
	g_DBnoinitrelations = {};
	for row in DB.Query("SELECT * FROM ITG_CultureNoRelations") do
		if not g_DBnoinitrelations[row.CultureType] then
			g_DBnoinitrelations[row.CultureType] = {}
		end
		g_DBnoinitrelations[row.CultureType][row.OtherCultureType] = true;
	end
end

function CanHaveInitialRelation(j, g)
	if not g_DBnoinitrelations then
		InitDBInitialRelations()
	end
	local jType = ITG_CultureData[gT.Players[j].CultureType].Type;
	local gType = ITG_CultureData[gT.Players[g].CultureType].Type;
	if g_DBnoinitrelations[jType] and g_DBnoinitrelations[jType][gType] then
		return false;
	end
	if g_DBnoinitrelations[gType] and g_DBnoinitrelations[gType][jType] then
		return false;
	end
	return true;
end

GameEvents.StartedDoF.Add(function(iPlayer, sPlayer)
	if gT.Globals.GameGenerated then
		gT.Players[iPlayer].LHLeagueForm = gT.Players[iPlayer].LHLeagueForm + 1;
		gT.Players[sPlayer].LHLeagueForm = gT.Players[sPlayer].LHLeagueForm + 1;
	end
	if not AreSharingDoFLeague(iPlayer, sPlayer) then
		CreateNewLeague(iPlayer, sPlayer)
	else
		print("Wonderful error 5623432", iPlayer, sPlayer)
	end
end)

LuaEvents.ITG_HotseatHumanDealDoF.Add(function(iPlayer, sPlayer)
	if not AreSharingDoFLeague(iPlayer, sPlayer) then
		CreateNewLeague(iPlayer, sPlayer)
	else
		print("Wonderful error 5431423", iPlayer, sPlayer)
	end
end)

GameEvents.EndedDoF.Add(function(badPlayer, sPlayer, bNegative, bDefensivePact)
--	print("Friendship declaration broken", badPlayer, sPlayer)
	if bNegative then
		gT.Players[badPlayer].LHLeagueDisband = gT.Players[badPlayer].LHLeagueDisband + 1;
		VictoryTaskCompletion(badPlayer, 78)
		RemoveBadPlayerLeague(badPlayer, sPlayer, "War")
		AddRelationWithinAllPlayers(badPlayer, 15)
	else
		if bDefensivePact then
			RemoveBadPlayerLeague(sPlayer, badPlayer, "DefensivePact")
		else
			RemoveBadPlayerLeague(badPlayer, sPlayer, "Other")
		end
	end
end)

function GetChanceForInitDoF(g, j)
	if gT.Players[g].IdeologyFromPlayer then
		if gT.Players[g].IdeologyFromPlayer == gT.Players[j].IdeologyFromPlayer then
			return 8;
		end
		return 12;
	end
	return 10;
end

function DoInitialRelations()
	for g, gdata in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			local gTeam = Teams[Players[g]:GetTeam()];
			for j, jdata in pairs(gT.Players) do
				if j > g and not Players[j]:IsMinorCiv() then
					if gTeam:IsHasMet(Players[j]:GetTeam()) then
						if LastRandom(1, GetChanceForInitDoF(g, j)) == 2 and CanHaveInitialRelation(j, g) then
							if not gTeam:IsAtWar(Players[j]:GetTeam()) then
								Players[g]:DoForceDoF(j);
							end
							gT.Players[g].RelationModifiers[j] = -100;
							gT.Players[j].RelationModifiers[g] = -100;
							Players[g]:SetNumITGDiplo(j, - 100); 
							Players[j]:SetNumITGDiplo(g, - 100); 
						elseif LastRandom(1, 10) < 4 then
							gT.Players[g].RelationModifiers[j] = -20;
							gT.Players[j].RelationModifiers[g] = -20;
							Players[g]:SetNumITGDiplo(j, - 20); 
							Players[j]:SetNumITGDiplo(g, - 20); 
						elseif LastRandom(1, 10) == 2 then
							gT.Players[g].RelationModifiers[j] = 20;
							gT.Players[j].RelationModifiers[g] = 20;
							Players[g]:SetNumITGDiplo(j, 20); 
							Players[j]:SetNumITGDiplo(g, 20); 
						else
							gT.Players[g].RelationModifiers[j] = 0;
							gT.Players[j].RelationModifiers[g] = 0;
						end
					end
				end
			end
			local chanceToProtect = 3;
			if gT.EraData and gT.PreviousEra and tempconvinit[g].Protecting then
				chanceToProtect = 15;
			end
			if LastRandom(1, 20) <= chanceToProtect then
				--minor to protect
				local bCont = true;
				if gT.EraData and gT.PreviousEra then
					local candidate = tempconvinit[g].Protecting;
					if candidate then
						if CanBeProtectedByMajorAction(g, candidate) then
							bCont = false;
							DoStartProtectionOfMinor(g, candidate, LastRandom(-25,-5))
						end	
					end
				end 
				if bCont then
					local minorTab = PreparedDataForPledge(g);
					if #minorTab.UniqueOptions > 0 then
						local chosenone = minorTab.UniqueOptions[LastRandom(1,#minorTab.UniqueOptions)].ID;
						DoStartProtectionOfMinor(g, chosenone, LastRandom(-25,-5))
					end
				end
			end
		else
			ChangeBulliableCorruptableCS(g, 1, 0)
		end
	end
	gT.Globals.CSBullyOn = LastRandom(3,7)
	gT.Globals.CSBullyOnP = LastRandom(0, 63)
	DoAlphabetInitial()
end

function ChangeDiploRelation(g, gPlayer, amount)
	local cur = gT.Players[g].RelationModifiers[gPlayer] or 0;
	Players[g]:SetNumITGDiplo(gPlayer, cur + amount); 
	gT.Players[g].RelationModifiers[gPlayer] = cur + amount;
end

function AddRelationWithinAllPlayers(gPlayer, amount)
	for g, gdata in pairs(gT.Players) do
		if g ~= gPlayer then
			if not Players[g]:IsMinorCiv() then
				ChangeDiploRelation(g, gPlayer, amount)
			end
		end
	end
end

function DoRelationScriptOnCityCapture(newPlayer, iCity)
	if gT.Players[newPlayer].UniqueNumConquered  == 4 then
		AddRelationWithinAllPlayers(newPlayer, 50);
	elseif gT.Players[newPlayer].UniqueNumConquered == 8 then
		AddRelationWithinAllPlayers(newPlayer, 100);
	elseif gT.Players[newPlayer].UniqueNumConquered > 8 then
		if iCity:GetOriginalOwner() ~= newPlayer then
			AddRelationWithinAllPlayers(newPlayer, 50);
		end
	end
end

function DoAlphabetInitial()
	for g, h in pairs(gT.Players) do
		if h.StAlphabet == -1 then
			local tab = {}
			local pTeam = Teams[Players[g]:GetTeam()];
			for j, b in pairs(gT.Players) do
				if b.StAlphabet == j then
					if pTeam:IsHasMet(Players[j]:GetTeam()) then
						table.insert(tab, j)
						--if in previous era; then triple the chance
						if gT.EraData and gT.PreviousEra then
							if gT.Globals.ScenarioType ~= 2 or (LastRandom(1,2) == 2) then
								if gT.EraData[gT.PreviousEra].Players[g].StAlphabet == j then
									table.insert(tab, j)
									table.insert(tab, j)
								end
							end
						end
					end
				end
			end
			if #tab > 0 then
				SetNewAlphabet(g, tab[LastRandom(1,#tab)])
			end
		end
	end
end

function ShouldAdoptNewAlphabetChanced(g, newAlph)
	if gT.Players[g].StAlphabet == -1 then
		if not gT.Players[g].AlphInTime then
			return true;
		end
	end
	if gT.Players[g].StAlphabet == g then
		return false;
	end
	if gT.EraData and gT.PreviousEra then
		if gT.EraData[gT.PreviousEra].Players[g].StAlphabet == gT.Players[g].StAlphabet then
			return false;
		end
	end
	 --maybe chance here should be less randomly distributing (aim to create similarly numerous alphabets)
	local numPN = 0;
	local pTeam = Teams[Players[g]:GetTeam()];
	for j, c in pairs(gT.Players) do
		if (c.StAlphabet == j) then
			if pTeam:IsHasMet(Players[j]:GetTeam()) then
				numPN = numPN + 1;
			end
		end
	end
	if numPN < 2 then -- it should know at least new challenger and old alpha player
		print("Error known alphabets too low!", g, newAlph, numPN)
	end
	return (LastRandom(1,numPN) == 2);
end

function PlayerHasAdoptedAlphabet(j)
	local pTeam = Teams[Players[j]:GetTeam()];
	local aCost = 3;
	for g, h in pairs(gT.Players) do
		if pTeam:IsHasMet(Players[g]:GetTeam()) then
			if ShouldAdoptNewAlphabetChanced(g, j) then
				SetNewAlphabetInTime(g, j)
			end
		end
		if h.StAlphabet == g then
			aCost = aCost + 1;
		end
	end
	gT.Globals.AlphabetCost = aCost;
end

function DoAlphabetPlayerMeetTeam(i, team)
	if not gT.Globals.GameGenerated then
		return;
	end
	if gT.Players[i].StAlphabet == i then
		for g, h in pairs(gT.Players) do
			if Players[g]:GetTeam() == team then
				if ShouldAdoptNewAlphabetChanced(g, i) then
					SetNewAlphabetInTime(g, i)
				end
			end
		end
	end
end

