local domStab = {"MilitaryPower", "Population", "Territory", "Cities"};

function DoTriggerDominationMode()
	if gT.Globals.DominationOn then
		return;
	end
	if gT.Globals.ScenarioType ~= 5 then
		return;
	end
	local lHd = 0;
	local ltt = {}
	for l, s in pairs(gT.Leagues) do
		if s.SpecialProposalTag == "IdeologyL" then
			lHd = lHd + 1;
			ltt[l] = {}
		end
	end
	if lHd < 2 then
		return;
	end
	local tWc = 0
	for l, s in pairs(gT.Leagues) do
		if s.SpecialProposalTag == "IdeologyL" then
			for b, c in pairs(s.Resolutions) do
				if c.ResID == 42 then
					if gT.Leagues[c.ExtraInfo] and gT.Leagues[c.ExtraInfo].SpecialProposalTag == "IdeologyL" then
						if not ltt[l][c.ExtraInfo] then
							tWc = tWc + 1;
							ltt[l][c.ExtraInfo] = true;
							ltt[c.ExtraInfo][l] = true;
						end
					end
				end
			end
		end
	end
	print("League chance Total War", tWc, lHd - 1)
	if tWc >= (lHd - 1)  then
		StartDominationMode()
	end
end

function StartDominationMode()
	gT.Globals.DominationOn = true;
	local gTurn = GetITGGameTurn();
	gT.Globals.Domination = {WarLocks = {}, Sides = {}, Best = {}, Worst = {}, TurnStart = gTurn, Events = {}}
	for l, s in pairs(gT.Leagues) do
		if s.SpecialProposalTag == "IdeologyL" then
			gT.Globals.Domination.Sides[l] = {Active = true, Initial = {}, Acronym = GetAcronymOf(s.Name), Victories = 0, Losses = 0, Espionage = 0, Name = s.Name, League = l}
		end
	end
	DoTriggerDefensivePact5thEra()
	for g, h in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			ChangeExtraSupply(g, UNIT_SUPPLY_WORLD_AT_WAR)
		end
	end
	for jj, iHuman in pairs(gT.Globals.HumanPlayers) do
		local lideo = GetIdeologyLeagueOfPlayer(iHuman)
		local str = "";
		if not lideo then
			str = "The maelstrom of chaos has begun, the humanity succumbed to the illusion of power once again. Shall we survive to tell our tales?";
		else
			str = "We at " .. gT.Globals.Domination.Sides[lideo].Acronym .. " didn't want this war, but we cannot stand passively while others outcry for help. We shall eradicate the evil from the surface of Earth so we can have peace, once more!"
		end
		Players[iHuman]:AddNotification(563469232, str, "World at War", -1, -1, 2, -1)
	end
	DoTurnDataDomination()
	for l, c in pairs(gT.Globals.Domination.Sides) do
		for a, h in pairs(domStab) do
			gT.Globals.Domination.Sides[l].Initial[h] = c[h]; 
		end
	end
	InitialDominationWarlocks()
	--achievements
	local yearStarted = GetYearFromTurn(gTurn)
	local iSeason = GetSeasonFromTurn(gTurn);
	if yearStarted == 1939 then
		if iSeason == 2 then
			LuaEvents.ITG_AchievementCompleted(137)
		end
	elseif yearStarted == 1941 then
		if iSeason == 2 then
			LuaEvents.ITG_AchievementCompleted(139)
		elseif iSeason == 4 then
			LuaEvents.ITG_AchievementCompleted(138)
		end
	end
end

--[[

Types.
	"Combat", --admiral defeat
	"Combat", --general combat
	"Training", --admiral acquisition
	"Training", --general acquisition
	"Nuclear", -- nuclear explosion
	"Nuclear", -- nuclear project
	"Combat", -- notable city capture
	"Progress", -- Innovation
	"State", --Anarchy
	"State", -- Centralized power
	"Defeat", --Elemination
	"Espionage", --Money Forgery   
	"Espionage", --Assassination
	"Espionage", --Hostile takeover
]]

function DoLogDominationEvent(type, aPlayer, sPlayer, aChange, sChange, bEspionage, extra1, extra2)
	if gT.Globals.DominationOn and (not gT.Globals.DominationOff) then
		local aIdeo1, aIdeo2;
		if aPlayer then
			aIdeo1 = GetIdeologyLeagueOfPlayer(aPlayer);
			if (not aIdeo1) or (not gT.Globals.Domination.Sides[aIdeo1].Active) then
				return;
			end
			if bEspionage then
				gT.Globals.Domination.Sides[aIdeo1].Espionage = gT.Globals.Domination.Sides[aIdeo1].Espionage + 1;
			end
		end
		if sPlayer then
			aIdeo2 = GetIdeologyLeagueOfPlayer(sPlayer);
			if (not aIdeo2) or (not gT.Globals.Domination.Sides[aIdeo2].Active) then
				return;
			end
		end
		if aIdeo1 and aChange then
			if aChange < 0 then
				gT.Globals.Domination.Sides[aIdeo1].Losses = gT.Globals.Domination.Sides[aIdeo1].Losses - aChange;
				gT.Players[aPlayer].LHIdeoLosses = gT.Players[aPlayer].LHIdeoLosses - aChange;
			else
				gT.Globals.Domination.Sides[aIdeo1].Victories = gT.Globals.Domination.Sides[aIdeo1].Victories + aChange;
				gT.Players[aPlayer].LHIdeoVictories = gT.Players[aPlayer].LHIdeoVictories + aChange;
			end
		end
		if aIdeo2 and sChange then
			if sChange < 0 then
				gT.Globals.Domination.Sides[aIdeo2].Losses = gT.Globals.Domination.Sides[aIdeo2].Losses - sChange;
				gT.Players[sPlayer].LHIdeoLosses = gT.Players[sPlayer].LHIdeoLosses - aChange;
			else
				gT.Globals.Domination.Sides[aIdeo2].Victories = gT.Globals.Domination.Sides[aIdeo2].Victories + sChange;
				gT.Players[sPlayer].LHIdeoVictories = gT.Players[sPlayer].LHIdeoVictories + aChange;
			end
		end
		if type ~= -1 then
			table.insert(gT.Globals.Domination.Events, {type, GetITGGameTurn(), aPlayer, sPlayer, aChange, sChange, aIdeo1, aIdeo2, LastRandom(1,100), extra1, extra2})
		end
	end
end

function GetDominationData(l)
	local a, b, c, d, e, f = 0, 0, 0, 0, 0, 0;
	for member, sth in pairs(gT.Leagues[l].Members) do
		a = a + 1;
		if not Players[member]:IsMinorCiv() then
			b = b + GetWeirldyCountedMilitaryMight(member);
		end
		c = c + Players[member]:GetTotalPopulation()
		d = d + Players[member]:GetTotalLand()
		e = e + Players[member]:GetNumCities();
		f = f + Players[member]:GetUnitClassCount(GameInfoTypes.UNITCLASS_ATOMIC_BOMB);
	end
	return a, b, c, d, e, f;
end

function DoTurnDataDomination()
	gT.Globals.Domination.Best = {}
	gT.Globals.Domination.Worst = {}
	for l, c in pairs(gT.Globals.Domination.Sides) do
		local d,f,g,h,i,j =  GetDominationData(l)
		gT.Globals.Domination.Sides[l].NumMembers = d
		gT.Globals.Domination.Sides[l].MilitaryPower = f
		gT.Globals.Domination.Sides[l].Population = g
		gT.Globals.Domination.Sides[l].Territory = h
		gT.Globals.Domination.Sides[l].Cities = i
		gT.Globals.Domination.Sides[l].NuclearWeapons = j
	end
	for l, c in pairs(gT.Globals.Domination.Sides) do
		for a, h in pairs(domStab) do
			gT.Globals.Domination.Best[h] = math.max(gT.Globals.Domination.Best[h] or 0, c[h])
			if not gT.Globals.Domination.Worst[h] then
				gT.Globals.Domination.Worst[h] = c[h]
			else
				gT.Globals.Domination.Worst[h] = math.min(gT.Globals.Domination.Worst[h], c[h])
			end
		end
	end
end

function DoOverturnDominationMode()
	if not gT.Globals.DominationOn then
		if gT.Globals.ScenarioType == 5 and AnotherReasonToStartDominationMode() then
			StartDominationMode()
		end
		return;
	end
	if gT.Globals.DominationOff then
		return;
	end
	DoTurnDataDomination()
	local tabToSurrender = {}
	for l, c in pairs(gT.Globals.Domination.Sides) do
		if c.Active then
			if ShouldSurrenderInDominationMode(l) then
				table.insert(tabToSurrender, l)
			end
		end
	end
	for c, l in pairs(tabToSurrender) do
		DoMarkEndOfLeagueInDominationMode(l, true)
	end
end

function ShouldTriggerDominationModeCSQuest(iPlayer)
	if gT.Globals.DominationOn and (not gT.Globals.DominationOff) then
		if not GetIdeologyLeagueOfPlayer(iPlayer) then
			local lLeft = 0;
			for l, s in pairs(gT.Leagues) do
				if s.SpecialProposalTag == "IdeologyL" then
					lLeft = lLeft + 1;
				end
			end
			return lLeft > 1;
		end
	end
	return false;
end

function GetDenominatorCSQuest(i)
	if i == 2 then
		return 0.55
	elseif i == 3 then
		return 0.4
	elseif i == 4 then
		return 0.325
	elseif i == 5 then
		return 0.28
	else
		return 1 / (i - 2);
	end
end

function LogDestructionOfIdeologyDominationMode(uid)
	if gT.Leagues[uid].SpecialProposalTag == "IdeologyL" then
		if (not gT.Globals.DominationOff) and gT.Globals.DominationOn then
			DoMarkEndOfLeagueInDominationMode(uid, false)
		end
		for g, h in pairs(gT.Players) do
			if h.IdeologyFromPlayer == gT.Leagues[uid].Ideology then
				for a, b in pairs(gT.IdeologyTaken) do
					if b == g then
						gT.IdeologyTaken[a] = nil;
					end
				end
				ClearAllIdeologies(g)
				gT.Players[g].IdeologyFromPlayer = nil;
				gT.Players[g].NoIdeologyBonus = 50;
			end
		end
	end
end

function DoMarkEndOfLeagueInDominationMode(league, bTurn)
	if not gT.Globals.Domination.Sides[league].Active then
		return;
	end
	table.insert(gT.Globals.Domination.Events, {11, GetITGGameTurn(), nil, nil, nil, nil, league, nil, LastRandom(1,100)})
	gT.Globals.Domination.Sides[league].Active = false;
	gT.Globals.Domination.Sides[league].LostTurn = GetITGGameTurn();
	HnGLogWorldWarEvents({Type = "Sur", League = league})
	for g, h in pairs(gT.Leagues[league].Members) do
		gT.Players[g].HnGLeagueSide = league;
	end
	if bTurn then
		for jj, iHuman in pairs(gT.Globals.HumanPlayers) do
			local lideo = GetIdeologyLeagueOfPlayer(iHuman)
			local str = "";
			if lideo == league then
				str = "We fought bravely for our cause yet we fail. The " .. gT.Leagues[league].Name .. " have not stand the test of time. We must face new tomorrow."
			else
				str = "The world can feel a relief knowing that " .. gT.Leagues[league].Name .. " is no longer! Leaders of " .. gT.Globals.Domination.Sides[league].Acronym .. " announced unconditional surrender."
			end
			Players[iHuman]:AddNotification(563469232, str, "Unconditional Surrender", -1, -1, 2, -1)
		end
		DoEndLeagueProperly(league)
	end
	local numLeft = 0;
	for a, b in pairs(gT.Globals.Domination.Sides) do
		if b.Active then
			numLeft = numLeft + 1;
		end
	end
	if numLeft < 3 then
		DoTriggerEndOfDominationMode()
	end
end

function DoTriggerEndOfDominationMode()
	gT.Globals.DominationOff = true;
	gT.Globals.Domination.TurnEnd = GetITGGameTurn();
	for l, s in pairs(gT.Leagues) do
		if s.SpecialProposalTag == "IdeologyL" then
			for a, b in pairs(s.Resolutions) do
				if b.ResID == 42 then
					DoRemoveResolution(l, a, b.ResID, b.ExtraInfo)
				end
			end
		end
	end
	
	for g, h in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			ChangeExtraSupply(g, -UNIT_SUPPLY_WORLD_AT_WAR)
		end
	end
	--
	for a, b in pairs(gT.Globals.Domination.Sides) do
		if b.Active then
			if gT.Leagues[b.League] then
				for member, sth in pairs(gT.Leagues[b.League].Members) do
					BoostHappinessInAllCities(member, 5)
					ChangeMeritocracy(member, 30);
					if Players[member]:IsHuman() then
						LuaEvents.ITG_AchievementCompleted(95)
					end
					VictoryTaskCompletion(member, 18)
				end
			end
		end
	end
	for i, data in pairs(gT.Globals.Domination.WarLocks) do
		ChangePeaceWarLock(data[1], data[2], -1, "DomM")
	end
	local dTtb;
	for jj, iHuman in pairs(gT.Globals.HumanPlayers) do
		if Players[iHuman]:IsAlive() then
			local str = "The Great War has ended! Let it be a lesson for humanity not to forget."
			Players[iHuman]:AddNotification(563469232, str, "Peace", -1, -1, 2, -1)
			if not dTtb then
				dTtb = {}
				for a, b in pairs(gT.Globals.Domination.Sides) do
					table.insert(dTtb, {b.Acronym, b.Victories - b.Losses, b.Name, b.Active})
				end
				table.sort(dTtb, SortFunctionForGreaterInteger2)
			end
			table.insert(gT.Players[iHuman].TheRaceInfoTable, {Type = "DomOver", Ideology = GetIdeologyLeagueOfPlayer(iHuman), Data = dTtb})
		end
	end
end

function GetAcronymOf(sText, bIncludeOf)
	local hS = ""
	for w in sText:gmatch("%S+") do 
		if w ~= "of" then
			hS = hS .. string.upper(string.sub(w, 1, 1))
		elseif bIncludeOf then
			hS = hS .. "o";
		end
	end
	return hS;
end

function ShouldSurrenderInDominationMode(league)
	if gT.Globals.Domination.Sides[league].Cities == 0 then
		return true;
	end
	if gT.Globals.Domination.Sides[league].MilitaryPower >= 0.9 * gT.Globals.Domination.Sides[league].Initial.MilitaryPower then
		return false;
	end
	if gT.Globals.Domination.Sides[league].Population >= 0.8 * gT.Globals.Domination.Sides[league].Initial.Population then
		return false;
	end
	if gT.Globals.Domination.Sides[league].Territory >= 0.8 * gT.Globals.Domination.Sides[league].Initial.Territory then
		return false;
	end
	if gT.Globals.Domination.Sides[league].Cities >= 0.8 * gT.Globals.Domination.Sides[league].Initial.Cities then
		return false;
	end
--	gT.Globals.Domination.Sides[l] = {Active = true, Initial = {}, Acronym = GetAcronymOf(s.Name), Victories = 0, Losses = 0, Espionage = 0, Name = s.Name}	
--	gT.Globals.Domination = {Sides = {}, Best = {}, TurnStart = GetITGGameTurn(), Events = {}}
	local turnPassed = GetITGGameTurn() - gT.Globals.Domination.TurnStart
	if turnPassed < 10 then
		return false;
	end
	local numReasons = 0
	for a, b in pairs({"MilitaryPower", "Population", "Territory", "Cities"}) do
		if ShouldLeagueSurrenderBasedOnValue(league, b) then
			numReasons = numReasons + 1;
		end
	end
--numbers may be off!!!
	if gT.Globals.Domination.Sides[league].Losses > 750 then
		if gT.Globals.Domination.Sides[league].Losses >= 2 * gT.Globals.Domination.Sides[league].Victories then
			numReasons = numReasons + 1;
		elseif gT.Globals.Domination.Sides[league].Losses >= gT.Globals.Domination.Sides[league].Victories + 2500 then
			numReasons = numReasons + 1;
		end
	end
	if numReasons == 0 then
		return false;
	end
	local tHshold = math.max(5 - math.floor(turnPassed / 12), 1) 
	if numReasons >= tHshold then
		return true;
	elseif LastRandom(1, 100) <= numReasons then
		return true;
	end
	return false;
end

function ShouldLeagueSurrenderBasedOnValue(league, b)
	if gT.Globals.Domination.Worst[b] ~= gT.Globals.Domination.Sides[league][b] then
		for side, cth in pairs(gT.Globals.Domination.Sides) do
			if cth[b] < gT.Globals.Domination.Sides[league][b] then
				--1 lesser; and also lesser than initial;
				if cth[b] < cth.Initial[b] then
					return false;
				end
			end
		end
	end
	if gT.Globals.Domination.Best[b] == 0 then
		return false;
	end
	local ratioToBest = (gT.Globals.Domination.Sides[league][b] / gT.Globals.Domination.Best[b])
	if ratioToBest < 0.35 then
		local bestInitValue = 0;
		for side, cth in pairs(gT.Globals.Domination.Sides) do
			bestInitValue = math.max(bestInitValue, cth[b]) 
		end
		if bestInitValue == 0 then
			print("Weird 4525324")
			return false;
		end
		if (gT.Globals.Domination.Sides[league].Initial[b] / bestInitValue) > ratioToBest then
			return true;
		end
	end
	return false;
end

function AnotherReasonToStartDominationMode()
	local Tteams = {}
	local iTeams = {}
	local numMt = 0
	local exR = 0;
	for g, b in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			if Players[g]:IsAlive() then
				local iTeam = Players[g]:GetTeam();
				if not Tteams[iTeam] then
					Tteams[iTeam] = true
					table.insert(iTeams, iTeam)
					numMt = numMt + 1;
				end
			else
				exR = exR + 1;
			end	
		elseif not Players[g]:IsAlive() then
			exR = exR + 0.5;
		end
	end
	local wC = 0;
	for a = 1, #iTeams do
		for b = a + 1, #iTeams do
			if Teams[iTeams[a]]:IsAtWar(iTeams[b]) then
				wC = wC + 1;
			end
		end
	end
	if #iTeams > 1 and (wC > 0) then
		local trsh = CalculateTotalWarTresholdNow(#iTeams); -- initially 0.2
--		print("War chance Total War", wC + exR, trsh, #iTeams)
		if wC + exR >= trsh then
			return true;
		end
	end
	return false; 
end

function CalculateTotalWarTresholdNow(numPlayers)
	local numIdeologies = GetNumIdeologiesFromPlayer(numPlayers)
	local wars = 0;
	for i = 2, numIdeologies do
		local tempP = math.ceil(numPlayers / (numIdeologies + 2 - i))
		numPlayers = numPlayers - tempP;
		wars = wars + tempP * numPlayers;
	end
	return wars * 0.45; -- 0.5 is a bit too harsh;
end

function InitialDominationWarlocks()
	for getPlayerA, h in pairs(gT.Players) do
		if (not Players[getPlayerA]:IsMinorCiv()) and (not h.IsConsideredBarbarian) then
			local ideo1 = GetIdeologyLeagueOfPlayer(getPlayerA);
			local teamId = Players[getPlayerA]:GetTeam();
			if ideo1 then
				for getPlayerB, c in pairs(gT.Players) do
					if getPlayerB > getPlayerA and (not Players[getPlayerB]:IsMinorCiv()) and (not c.IsConsideredBarbarian) then
						local otherTeamId = Players[getPlayerB]:GetTeam();
						if Teams[teamId]:IsAtWar(otherTeamId) then
							if ideo1 ~= GetIdeologyLeagueOfPlayer(getPlayerB) then
								ChangePeaceWarLock(getPlayerA, getPlayerB, 1, "DomM")
								table.insert(gT.Globals.Domination.WarLocks, {getPlayerA, getPlayerB})
							end
						end
					end
				end
			end
		end
	end
end

function DominationWarDeclared(teamId, otherTeamId)
	if not gT.Globals.DominationOn then
		return;
	end
	if gT.Globals.DominationOff then
		return;
	end
	local getPlayerA = GetOnlyPlayerFromTeam(teamId);
	local getPlayerB = GetOnlyPlayerFromTeam(otherTeamId);
	if not (getPlayerA and getPlayerB) then
		return;
	end
	if Players[getPlayerA]:IsMinorCiv() or Players[getPlayerB]:IsMinorCiv() then
		return;
	end
	if gT.Players[getPlayerA].IsConsideredBarbarian or gT.Players[getPlayerB].IsConsideredBarbarian then
		return;
	end
	local ideo1 = GetIdeologyLeagueOfPlayer(getPlayerA);
	local ideo2 = GetIdeologyLeagueOfPlayer(getPlayerB);
	if (not ideo1) or (ideo1 == ideo2) then
		return;
	end
	ChangePeaceWarLock(getPlayerA, getPlayerB, 1, "DomM")
	table.insert(gT.Globals.Domination.WarLocks, {getPlayerA, getPlayerB})
end

function GetOnlyPlayerFromTeam(iTeam)
	local player;
	for g, h in pairs(gT.Players) do
		if Players[g]:GetTeam() == iTeam then
			if player then
				return nil;
			end
			player = g;
		end
	end
	return player;
end

function DoLogMinorLiberationForDominationMode(iMinor, iMajor, bDomination)
	if not gT.Globals.DominationOn then
		return;
	end
	if gT.Globals.DominationOff then
		return;
	end
	local ideoMinor = GetIdeologyLeagueOfPlayer(iMinor)
	local ideoMajor = GetIdeologyLeagueOfPlayer(iMajor)
	if not ideoMajor then
		return;
	end
	if ideoMinor == ideoMajor then
		return;
	end
	if ideoMinor then
		RemovePlayerFromLeague(iMinor, ideoMinor, "LiberDom")
	end
	ToPLeagueNewMember(ideoMajor, iMinor)
end

function DominationCSJoinedLeague(league, member)
	if gT.Globals.Domination.Sides[league] then
		gT.Globals.Domination.Sides[league].Initial.Population = gT.Globals.Domination.Sides[league].Initial.Population + Players[member]:GetTotalPopulation();
		gT.Globals.Domination.Sides[league].Initial.Territory = gT.Globals.Domination.Sides[league].Initial.Territory + Players[member]:GetTotalLand();
		gT.Globals.Domination.Sides[league].Initial.Cities = gT.Globals.Domination.Sides[league].Initial.Cities + Players[member]:GetNumCities();
	end
end