local tOcean = GameInfoTypes.TERRAIN_OCEAN;
local iGoody = GameInfoTypes.IMPROVEMENT_ITGSG_ANCIENT_RUINS;
local fuss = GameInfoTypes.UNIT_SETTLER;
local hRevealT = {}
local KeepOnEraCleaingT = {LimitSocials = 1, VictoryPoints = 1, ToS = 1, CurrencyResources = 1, ExtraLuxuryResources = 1, EraData = 1, RelicInfluence = 1, IdeologiesPosition = 1, PoliticVictories = 1, GlobalInfos = 1, AchievementData = 1, AIFlavours = 1, Handicap = 1, PlotsCityName = 1, FToptions = 1, WondersConstructed = 1, WondersRuins = 1, LastChosenInspiration = 1}
local tempconvInfo = {"AISocDevPerfection", "Currencies", "IdeologyName", "NumGWoM", "NoblePriviligeEC", "NumGWoL", "NumGWoA", "NumGreatWorks", "HasCodex", "CodexDate", "CodexTurn", "CodexScenario", "RevolutionGoverment", "CodexDiscount", "Goverment", "GovermentBeforeAnarchy", "NationalDays"}
local tempconvCloneInfo = {"Inspirations", "AIFavourOfLaws", "NatDays", "AIStrategyValues", "HasIdeology", "HasMinorIdeology"}
local globalsKeptT = {"DhamekStupa", "HumanPlayers"}
local globalsDataKept = {}
local settleBless = {}
local builderBless = {}
local gwBless = {}
local ForceRevealedResources = {}
for row in GameInfo.Resources() do
	if row.ForcedReveal then
		table.insert(ForceRevealedResources, row.ID)
	end
end

function DoEraConversionITG()
	DoInitConvTab()
	Game.SetITGWarmUpTurn(Game.GetGameTurn() + 1)
	Game.SetITGEndTurn(-1)
	gT.Globals.EndGamePanel = false;
--	Game.SetITGPaused(false)
	local currentEra = gT.Globals.ScenarioType;
	local nextScenarioType = DBScenario.NextScenario
	if nextScenarioType then
		local nextScenarioID = ITG_ScenariosTypes[nextScenarioType];
		bEraConversionNow = true;
		DetermineBlessingsForNextEra()
		local tabOfHumans = {}
		local numhumans = 0;
		for g, h in pairs(gT.Players) do
			if Players[g]:IsHuman() then
				tabOfHumans[g] = 1;
				numhumans = numhumans + 1;
			end
		end
		local nttt = #gT.Globals.AuctionDeals;
		for i = 1, nttt do
			EndDealAuctionHouse(nttt + 1 - i, nil, true)
		end
		nttt = #gT.Globals.PirateDeals;
		for i = 1, nttt do
			EndPirateDeal(nttt + 1 - i)
		end
		--save data
		if not gT.EraData then
			gT.EraData = {}
		end
		for iUnit in Players[63]:Units() do
			iUnit:Kill(false, -1);
		end
		for i, globald in pairs(globalsKeptT) do
			globalsDataKept[globald] = gT.Globals[globald];
		end
		if nextScenarioType == "SCENARIO_LIGHT_OF_HOPE" then
			CollectRevealMapOfMajorPlayers()
		end
		gT.EraData[currentEra] = {CityStatesTypes = {}, Players = {}, Wonders = {}, WondersAssigned = {}, Academies = {}, WondersAssignedT = {}};
		gT.VictoryPoints.EraData[currentEra] = {}
		for player, sth in pairs(gT.VictoryPoints.Players) do
			gT.VictoryPoints.EraData[currentEra][player] = sth.Points
		end
		for index, sth in pairs(gT.Academies) do
			local tab = {Bonuses = {}, Name = sth.Name, ActiveSince = sth.ActiveSince, TurnFounded = sth.TurnFounded, ScenarioFounded = sth.ScenarioFounded, OriginalPlayer = sth.OriginalPlayer, CityName = Map.GetPlotByIndex(sth.City):GetPlotCity():GetName(), Year = sth.Year}
			for h, s in pairs(sth.Bonuses) do
				tab.Bonuses[h] = s;
			end
			table.insert(gT.EraData[currentEra].Academies, tab)
			DoClearYieldFromAcademyOnPlot(index)
		end
		for index, sth in pairs(gT.CustomsHouses) do
			DoClearYieldFromCustomsHouseOnPlot(index)
		end
		for index, sth in pairs(gT.Manufactories) do
			DoClearEndEraManufactory(index)
		end
		EndEraConversionClearArchaelogy()
		for eBuilding, player in pairs(gT.Globals.WondersAssigned) do
			gT.EraData[currentEra].WondersAssigned[eBuilding] = player;
		end
		for eBuilding, tt in pairs(gT.Globals.WondersAssignedT) do
			gT.EraData[currentEra].WondersAssignedT[eBuilding] = tt;
		end
		for eBuilding, cityPlotIndex in pairs(gT.Wonders) do
			local iCity = Map.GetPlotByIndex(cityPlotIndex):GetPlotCity()
			local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
			gT.EraData[currentEra].Wonders[eBuilding] = gT.Cities[cID].geIndex;
		end
		if gT.ArchaeologyPlots then
			for h, b in pairs(gT.ArchaeologyPlots) do
				Map.GetPlotByIndex(h):SetResourceType(-1)
			end
		end
		for h, b in pairs(gT.HolySites) do -- this is used for "nearby" Holy Site combat bonus
			local hPlot = Map.GetPlotByIndex(h);
			for hbb, rel in pairs(b.Religions) do
				ChangeReligiousHolySitePresenceWithinArea(rel, hPlot, 2, -1)
			end
		end
		EraConversionRemoveGovernorAbilities()
		for g, gd in pairs(gT.Players) do
			gT.EraData[currentEra].Players[g] = {};
			tempconvinit[g] = {}
			if not Players[g]:IsMinorCiv() then
				tempconvinit[g].Laws = {}
				tempconvinit[g].CustomsHouseChance = EvaluateCustomsHouseChanceNextEra(g)
				PrepareLawsForEraConversion(currentEra, g)
				for agentID, data in pairs(gd.Agents) do
					MakeSpyUnassigned(g, agentID, false)
				end
				if #gT.Players[g].PledgesOfProtection > 0 then
					tempconvinit[g].Protecting = gT.Players[g].PledgesOfProtection[1][1];
				end
			else
				gT.EraData[currentEra].CityStatesTypes[g] = Players[g]:GetMinorCivTrait();
			end
			gT.EraData[currentEra].Players[g].StAlphabet = gd.StAlphabet;
			gT.EraData[currentEra].Players[g].CultureString = gd.CultureString;
			for i, string in pairs(tempconvInfo) do
				tempconvinit[g][string] = gd[string]
			end
			for i, string in pairs(tempconvCloneInfo) do
				tempconvinit[g][string] = {}
				for h, v in pairs(gT.Players[g][string] or {}) do
					tempconvinit[g][string][h] = v;
				end
			end

			tempconvinit[g].GovSlotPrinciples = {}; -- simplified GovSlots
			for slot, sth in pairs(gT.Players[g].GovSlots) do
				tempconvinit[g].GovSlotPrinciples[slot] = sth.Principle;
			end
			
			if not Players[g]:IsMinorCiv() then
				tempconvinit[g].CulturalBonuses = {}
				for cultID, cdd in pairs(gd.CultBonusOn) do
					tempconvinit[g].CulturalBonuses[cultID] = {cdd.Scenario, cdd.Type, cdd.Turn - 100};
				end
			end
			local iRel = Players[g]:GetReligionCreatedByPlayer();
			gT.EraData[currentEra].Players[g].Pantheons = {}
			if iRel > 0 then
				gT.EraData[currentEra].Players[g].ReligionCreated = {};
				gT.EraData[currentEra].Players[g].ReligionCreated[iRel] = {}
				for i, belief in pairs(Game.GetBeliefsInReligion(iRel)) do
					table.insert(gT.EraData[currentEra].Players[g].ReligionCreated[iRel], belief)
				end
			elseif Players[g]:HasCreatedPantheon() then
				for i, belief in pairs(Game.GetBeliefsInReligion(0, g)) do
					table.insert(gT.EraData[currentEra].Players[g].Pantheons, belief)
				end
			end
			for iCity in Players[g]:Cities() do
				local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
				if gT.Cities[cID].WonderRuin then
					AssignEffectOfRuinsToCityAndPlayer(iCity, cID, g, gT.Cities[cID].WonderRuin, -1)
				end
			end
			CleanPirateVision(g)
			DoClearTradeOutpostVision(g)
			if Players[g]:GetGoldenAgeTurns() > 0 then
				Players[g]:ChangeGoldenAgeTurns(-1 * Players[g]:GetGoldenAgeTurns())
			end
		end

		

		--//done saving data
		SetXYLoaded(false)
		ResetContinentsTablesAndData()
		gT.Globals.GameGenerated = nil;
		MapModData.ITGSG = tabOfHumans;
		LuaEvents.ITGSGGameLoaded(false)
		MapModData.ITGSG = nil;
		for gpID, sth in pairs(gT.GreatPeople) do
			if sth.Alive then
				KillGreatPerson(gpID, false)
			end
		end
		--leagues effect !!!
		DoRemoveLeaguesEffectOnEraEnd()
		--most resolutions seems to be done anyway;
		for g, gdata in pairs(gT.Players) do
			if not Players[g]:IsMinorCiv() then
				if gdata.Goverment ~= 1 then
					OnAcquiringAnarchyAllLawsTurnedOff(g)
					AnarchyGovRewards(g, true);
				end
			end
		end
		for g, gdata in pairs(gT.Players) do
			Players[g]:SetStartingPlot(Players[g]:GetInitStartingPlot()) -- return starting locations properly
		end
		--reshuffle starting positions
		if PreGame.GetGameOption("GAMEOPTION_ITG_POSITION_SHUFFLE") == 1 then
			local tabP = {}
			local tabA = {}
			for g, h in pairs(gT.Players) do
				if not Players[g]:IsMinorCiv() then
					table.insert(tabP, g);
					table.insert(tabA, Players[g]:GetStartingPlot());
				end
			end
			tabP = Shuffle(tabP);
			for ijk, g in pairs(tabP) do
				Players[g]:SetStartingPlot(tabA[ijk])
			end
		end
		for g, gdata in pairs(gT.Players) do	
			local sPlot = Players[g]:GetStartingPlot();
			local jUnit = Players[g]:InitUnit(fuss, sPlot:GetX(), sPlot:GetY())
			for iUnit in Players[g]:Units() do 
				if iUnit:GetUnitType() ~= fuss then
					iUnit:Kill(false, -1);
				end
			end
			-- deleting units first prevent some dll crashes due to new stack rules (destroying cities removes territory and changes rules)
			for id, vhd in pairs(gdata.PledgesOfProtection) do
				RemovePledgeOfProtectionByID(g, id, "EndEra", true)	
			end
		end
		for g, gdata in pairs(gT.Players) do
			for iCity in Players[g]:Cities() do
				iCity:Kill();
			end
		end
		local hTeams = {}
		EraseEffectOfEra(currentEra)
		EraseEffectsOfWorldWonder()
		for wonderID, iPlayer in pairs(gT.WondersConstructed) do
			AddEffectUponConstructing(wonderID, iPlayer, true)
		end
		for g, gdata in pairs(gT.Players) do
			if not hTeams[Players[g]:GetTeam()] then
				hTeams[Players[g]:GetTeam()] = {}
			end
			for res, amount in pairs(gdata.ExtraResources) do
				if amount ~= 0 then
					Players[g]:ChangeNumResourceTotal(res, -amount)
				end
			end
			table.insert(hTeams[Players[g]:GetTeam()], g)
--			Players[g]:SetStartingPlot(Players[g]:GetInitStartingPlot()) -- return starting locations properly
--			local sPlot = Players[g]:GetStartingPlot();
--			local jUnit = Players[g]:InitUnit(fuss, sPlot:GetX(), sPlot:GetY())
			ClearAllIdeologies(g)
			ClearAllSocialPerks(g)
			ClearAllWonders(g)
			ClearUnlockedBuildingClasses(g)
			HandleBenefitsFromCultureType(g, -1, false, 0)
			ClearEffectsOfPreviousGoverment(g, gdata.Goverment)
			if Players[g]:IsMinorCiv() then
				for jg, jgd in pairs(gT.Players) do
					if not Players[jg]:IsMinorCiv() then
						Players[g]:ChangeMinorCivFriendshipWithMajor(jg, -math.max(0,Players[g]:GetMinorCivFriendshipWithMajor()))
					end
				end
			else
				if not gdata.bInspFromCulture then
					AddInspirationToRandomBuilding(g, gT.Globals.ScenarioType, true, true)
				end
			end
			for a, b in pairs(gdata.Satellites) do
				MoveSatelliteToPosition(g, a, nil)
			end
			SetNewAlphabet(g, -1)
		end
		ChangeTradeabilityOfStrategicResources(-1);
		for i = 0, Map:GetNumPlots() - 1, 1 do
			local fPlot = Map.GetPlotByIndex( i );
			fPlot:SetRouteType(-1)
	--		if fPlot:GetImprovementType() ~= iGoody then
			fPlot:SetImprovementType(-1)
			fPlot:SetCurrentDirection(-1)
			fPlot:SetOpenBorderForEveryone(false)
			fPlot:SetOwner(-1)
			fPlot:SetImprovementPillaged(false)
			fPlot:SetCanHaveYield(true)
			fPlot:SetYieldIfNotPillaged(yScience, 0)
			fPlot:SetYieldIfNotPillaged(yFaith, 0)
			fPlot:SetYieldIfNotPillaged(yFood, 0)
			fPlot:SetYieldIfNotPillaged(yGold, 0)
			for iTeam, sth in pairs(hTeams) do
				if not fPlot:IsVisible(iTeam) then
					fPlot:SetRevealed(iTeam, false)
				end
			end
			if fPlot:GetAllowsSwimLand() ~= 0 then
				fPlot:ChangeAllowsSwimLand(-fPlot:GetAllowsSwimLand());
			end
			if fPlot:GetPlague() ~= 0 then
				fPlot:ChangePlague(-fPlot:GetPlague());
			end
			if gT.Globals.BadResourcesRemoved[i] then
				fPlot:SetResourceType(gT.Globals.BadResourcesRemoved[i][1])
				fPlot:SetNumResource(gT.Globals.BadResourcesRemoved[i][2])
			end
			fPlot:SetSpecialControl(false)
		end
		for iTeam, pp in pairs(hTeams) do
			for row in GameInfo.Technologies() do
				if Teams[iTeam]:IsHasTech(row.ID) then
					Teams[iTeam]:SetHasTech(row.ID, false)
					for i, player in pairs(pp) do
						ITGRemoveEffectOfTech(player, row.ID);
						DoAddRemoveTechEffect(player, row.ID, -1, false, 0)
					end
				end
			end
		end
		--map scripto
		for index, sth in pairs(gT.Globals.MedievalOceansIntoCoast or {}) do
			Map.GetPlotByIndex(index):SetTerrainType(tOcean);
		end
		for index, origin in pairs(gT.Globals.OriginalTerrain or {}) do
			Map.GetPlotByIndex(index):SetTerrainType(origin);
		end
		for index, origin in pairs(gT.Globals.OriginalResource or {}) do
			Map.GetPlotByIndex(index):SetResourceType(origin);
		end
		for index, amount in pairs(gT.Globals.ResourceQuantity) do
			Map.GetPlotByIndex(index):SetNumResource(amount)
		end
		for index, origin in pairs(gT.Globals.OriginalFeature or {}) do
			Map.GetPlotByIndex(index):SetFeatureType(origin);
		end
		--// map scripto
		-- grand clean
		Game.ResetReligions();
		print("Resetting deals")
		Game.RemoveAllExistingDeals()
		print("pre team")
		for iteam, sth in pairs(hTeams) do
			Teams[iteam]:ITGReset();
			for steam, bb in pairs(hTeams) do
				if steam ~= iteam then
					if Teams[iteam]:IsAtWar(steam) then
						Teams[iteam]:MakePeace(steam);
					end
					Teams[iteam]:SetPermanentWarPeace(steam, false);
					Teams[iteam]:ITGUnmet(steam);
				end
			end
			for i, iRes in pairs(ForceRevealedResources) do
				Teams[iteam]:SetForceRevealedResource(iRes, false)
			end
		end
		print("past team")
		for i, player in pairs(gT.Players) do
			
			Players[i]:ChangeCombatExperience(-Players[i]:GetCombatExperience())
			Players[i]:ChangeNavalCombatExperience(-Players[i]:GetNavalCombatExperience())
			Players[i]:ChangeGold(-Players[i]:GetGold())
			Players[i]:ChangeVictoriousMeleeCombatCount(-Players[i]:GetVictoriousMeleeCombatCount())
			for row in GameInfo.Traits() do
				Players[i]:SetPlayerHasTrait(row.ID, 0);
			end
			--artist % modifiers
			if Players[i]:GetExtraGreatArtistRateModifier() ~= 0 then
				Players[i]:ChangeGreatArtistRateModifier(- Players[i]:GetExtraGreatArtistRateModifier())
			end
			Players[i]:ITGResetPlayer();
			-- this should reset minors:
			--	ChangeMinorCivDecayModWithMajor
			--	ChangeMinorCivRecoveryModWithMajor
			--	ChangeMinorCivExtraAnchorWithMajor
			for row in GameInfo.Resources() do
				if Players[i]:GetNumResourceTotal(row.ID) > 0 or Players[i]:GetNumResourceTotal(row.ID, true) > 0 then
				-- this seems quite useless here.
					print("ERA CONV PLAYER / RES / AMOUNT / AMOUNT", i, row.ID, Players[i]:GetNumResourceTotal(row.ID, true), Players[i]:GetNumResourceTotal(row.ID))
					Players[i]:ChangeNumResourceTotal(row.ID, -Players[i]:GetNumResourceTotal(row.ID))
				end
				Players[i]:SetNumResourceStrategicReserve(row.ID, 0);
			end
		end
		print("past minors")
		DoClearPlotEffects()
		EndConversionTestFreeUnits()
--		FindLeftoverMinorMods();
--		EndEraCheckResources()
	
		--remove cached data
		RemoveOceanTabPrepareForNextEra()
		ReInitializeTradeRouteData();
		ReInitializePilgridRouteData();
		OnEraResetClearUsedNames()
		-- // grand clean		
		CleanGTTableProperly()
		Game.ITGReset(); --right now; it resets only wonder count and barbarians?

--// 
--[[
		for i = 0, Map:GetNumPlots() - 1, 1 do
			local fPlot = Map.GetPlotByIndex( i );
			for iTeam, sth in pairs(hTeams) do
				if fPlot:GetVisibilityCount(iTeam) < 0 then
					print("Bad visibility count (reload!)", i, iTeam);
				end
			end
		end
]]--
--//

		gT.ITGReduceTurns = GetRealGameTurn() + 1;
		gT.QuickSaveHelp = true;
		gT.PreviousEra = currentEra
		if numhumans > 1 then --hotseat
			for hp, h in pairs(tabOfHumans) do
				Players[hp]:SetIgnoreDiplomacyThisTurn(true)
				print("Player should ignore diplomacy for now", hp, Players[hp]:IsTurnActive(), Players[hp]:IsIgnoreDiplomacyThisTurn())
			end
		end
--		local saveData = Modding.OpenSaveData();
		bEraConversionNow = false;
		OnFirstGameStart(nextScenarioID)
		--reload :D
		TableSave(gT, "LSITGSG") -- just for sure :)
	else
		print("Error 983525")
	end
end
LuaEvents.ITGSG_DoEraConversion.Add(DoEraConversionITG)

function CleanGTTableProperly()
	for s, h in pairs(gT) do
		if not KeepOnEraCleaingT[s] then
			gT[s] = nil;
		end
	end
end

local eCachedTurn;
function GetRealGameTurn()
	if not eCachedTurn then
		eCachedTurn = Game.GetGameTurn();
	end
	return eCachedTurn;
end

function GetITGGameTurn()
	if not eCachedTurn then
		eCachedTurn = Game.GetGameTurn();
	end
	return eCachedTurn - (gT.ITGReduceTurns or 0);
end

GameEvents.NewGameTurn.Add(function(iTurn)
	eCachedTurn = iTurn;
end)

LuaEvents.ITGRequestReduceTurns.Add(function()
	MapModData.ITGSG =  (gT.ITGReduceTurns or 0);
end)

function ClearAllSocialPerks(g)
	for cultID, sth in pairs(gT.Players[g].CultBonusOn) do
		RemoveCultureBonusFromPlayer(g, cultID, true)
	end
end

function ClearAllWonders(g)
	for wonder, bad in pairs(gT.Players[g].HasPlayerWonder) do
		WonderWasConquered(nil, g, wonder, nil, true)
	end
end

local topkapipalace1 = GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_27;
function EraseEffectsOfWorldWonder()
	for wonder, sth in pairs(gT.Wonders) do
		if wonder == topkapipalace1 then
			for i, plot in pairs(GetPlotsInRadiusOfPlot(Map.GetPlotByIndex(sth), 3)) do
				plot:SetTopkapiPalaceNearby(false);
			end
		end
	end
	if gT.Globals.Vorontsov then
		for index, yield in pairs(gT.Globals.Vorontsov) do
			local plot = Map.GetPlotByIndex(index)
			Game.SetPlotExtraYield(plot:GetX(), plot:GetY(), yield, -1)
		end
		gT.Globals.Vorontsov = nil
	end
end

function HandleBenefitsFromCultureType(g, iAdd, bAdd, iZeroOne)
	if GetDBCulturePlayerInfo(g,"CanNavalAttackCoast") then
		Players[g]:ChangeCanNavalMeleeAttackCoast(iAdd)
	end
	local iExtraEmbarked = GetDBCulturePlayerInfo(g,"ExtraEmbarkedMoves");
	if iExtraEmbarked ~= 0 then
		Teams[Players[g]:GetTeam()]:ChangeEmbarkedExtraMoves(iAdd * iExtraEmbarked)
	end
	if GetDBCulturePlayerInfo(g,"IsPirate") then
		gT.Players[g].NumPirateMods = 0;
	end
	if GetDBCulturePlayerInfo(g,"BarbarianPeace") then
		if bAdd then
			Teams[63]:MakePeace(Players[g]:GetTeam())
			Teams[Players[g]:GetTeam()]:SetPermanentWarPeace(63, true)
		else
			Teams[63]:DeclareScriptedWar(Players[g]:GetTeam())
		end
	end
end

function EraseEffectOfEra(cEra)
	if gT.Globals.DoubleFounderBenefits then
		for g, gd in pairs(gT.Players) do
			if not Players[g]:IsMinorCiv() then
				gT.Players[g].FounderBeliefModifier = gT.Players[g].FounderBeliefModifier - 1;
				Players[g]:ChangeFounderBeliefModifier(-1);
			end
		end
		gT.Globals.DoubleFounderBenefits = nil;
	end
end

function DoRemoveLeaguesEffectOnEraEnd()
--both city-states and defensive pacts are handled anyway, but just to be sure:
	for league, sth in pairs(gT.Leagues) do
		for hString, h in pairs(sth.Resolutions) do
			DoRemoveResolution(league, hString, h.ResID, h.ExtraInfo)
		end
		for member, m in pairs(sth.Members) do
			RemovePlayerFromLeague(member, league, "EndEra")
		end
	end
end

function RedopoliticsVictories()
	for minor, data in pairs(gT.PoliticVictories) do
		for major, value in pairs(data) do
			Players[minor]:ChangeMinorCivExtraAnchorWithMajor(major, value)
		end
	end
	for minor, data in pairs(gT.RelicInfluence) do
		for major, value in pairs(data) do
			Players[minor]:ChangeMinorCivExtraAnchorWithMajor(major, value)
		end
	end
end

function CallPreviousEraIfConversion()
	for g, j in pairs(hRevealT) do
		local gTeam = Players[g]:GetTeam();
		for i, index in pairs(j) do
			Map.GetPlotByIndex(index):SetRevealed(gTeam, true)
		end
	end
end

function CollectRevealMapOfMajorPlayers()
	for g, h in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			hRevealT[g] = {}
			local gTeam = Players[g]:GetTeam();
			for i = 0, Map:GetNumPlots() - 1, 1 do
				local fPlot = Map.GetPlotByIndex( i );
				if fPlot:IsRevealed(gTeam) then
					table.insert(hRevealT[g], i)
				end
			end
		end
	end
end

function GetGlobalDataKept(key)
	return globalsDataKept[key];
end

function HasBuildingBless(iPlayer)
	return builderBless[iPlayer];
end
function HasSettlerBless(iPlayer)
	return settleBless[iPlayer];
end
function GetGWBlessType(iPlayer)
	return gwBless[iPlayer];
end

function DetermineBlessingsForNextEra()
	local tab = {}
	local gwTot, nummp = 0, 0;
	local avgsgw = math.ceil((DBScenario.MinStartingGW + DBScenario.MaxStartingGW)/ 2)
	for g, h in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			local iMaxCities = 0;
			for c, d in pairs(Players[g]:GetGraphData(12)) do
				iMaxCities = math.max(iMaxCities, d);
			end
			table.insert(tab, {g, math.floor(h.LHBuildingsConstructed/ (math.max(1, iMaxCities)) * 1000)})
			gwTot = gwTot + math.max(0, h.NumGreatWorks - avgsgw)
			nummp = nummp + 1;
		end
	end
	if gT.Globals.ScenarioType == 1 or gT.Globals.ScenarioType == 3 then
		DetermineSettlerBlessing()
	end
	local gwAvg = (gwTot / nummp)
	gwBless = {};
	for g, h in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			local generated = math.max(0, h.NumGreatWorks - avgsgw);
			if generated > gwAvg * 2 then
				gwBless[g] = 2;
			elseif generated > gwAvg * 1.35 then
				gwBless[g] = 1;
			elseif generated > gwAvg * 0.6 then
				gwBless[g] = 0;
			else
				gwBless[g] = -1;	
			end
		end
	end
	table.sort(tab, SortFunctionForGreaterInteger2)
	local good = math.ceil(#tab / 4);
	for i, v in pairs(tab) do
		if i <= good then
			builderBless[v[1]] = true;
		else
			break;
		end
	end
end

function DetermineSettlerBlessing()
	for g, h in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			if h.CitiesFounded > 0 then
				local treshold = LastRandom(15,35) * gT.Players[g].LHInitCities/ 100;
				if h.CitiesFounded > treshold then
					settleBless[g] = true;
					if h.CitiesFounded < LastRandom(3,4) then
						for j, b in pairs(gT.Players) do
							if (h.CitiesFounded < b.CitiesFounded) and (h.CultureType == b.CultureType) then
								settleBless[g] = false;
								break;
							end
						end
					end
				end
			end
		end
	end
end

function ClearNoLongerNeededEraData()
	local pEra = gT.PreviousEra;
	if gT.EraData and pEra then
		gT.EraData[pEra].WondersAssignedT = nil;
		gT.EraData[pEra].WondersAssigned = nil;
		gT.EraData[pEra].Wonders = nil;
		gT.EraData[pEra].Academies = nil;
		--CityStatesTypes used over the eras
	end
end

function DiagnosisToolResourcesQuantity()
	local resTab = {};
	for row in GameInfo.Resources() do
		resTab[row.ID] = {};
		for g, h in pairs(gT.Players) do
			resTab[row.ID][g] = 0;
		end
	end
	for i = 0, Map.GetNumPlots() - 1 do
		local iPlot = Map.GetPlotByIndex(i);
		local iOwner = iPlot:GetOwner();
		if iOwner ~= -1 then
			local iResource = iPlot:GetResourceType(iOwner);
			if iResource ~= -1 then
				if iPlot:IsCity() or (iPlot:IsResourceConnectedByImprovement(iPlot:GetImprovementType()) and (not iPlot:IsImprovementPillaged())) then
					resTab[iResource][iOwner] = resTab[iResource][iOwner] + iPlot:GetNumResource();
				end
			end
		end
	end
	for res, h in pairs(resTab) do
		for g, a in pairs(h) do
			local expected = Players[g]:GetNumResourceTotal(res, false) + Players[g]:GetResourceExport(res) - (gT.Players[g].ExtraResources[res] or 0);
			if a ~= expected then
				print("DTRQ", g, res, GameInfo.Resources[res].Type, a, expected, gT.Players[g].ExtraResources[res])
			end
		end
	end
end

function EndEraCheckResources()
-- about export
	local expResCheck = {};
	for i, v in pairs(gT.Globals.ExportLog) do
		if not expResCheck[v[1]] then
			expResCheck[v[1]] = {};
		end
		if not expResCheck[v[2]] then
			expResCheck[v[2]] = {};
		end
		expResCheck[v[1]][v[3]] = (expResCheck[v[1]][v[3]] or 0) + v[4];
		expResCheck[v[2]][v[3]] = (expResCheck[v[2]][v[3]] or 0) + v[4];
	end
	for player, vData in pairs(expResCheck) do
		for res, amount in pairs(vData) do
			if amount ~= 0 then
				print("Broken export value", player, res, amount)
			end
		end
	end
	local tabRes = {}
	for g, h in pairs(gT.Players) do
		for row in GameInfo.Resources() do
			tabRes[row.ID] = (tabRes[row.ID] or 0) + Players[g]:GetResourceImport() + Players[g]:GetResourceFromMinors() - Players[g]:GetResourceExport();
		end
	end
	for res, h in pairs(tabRes) do
		if h ~= 0 then
			print("EraConv wrong resource count", res, h, GameInfo.Resources[res].Type)
		end
	end
end