local generalNames = {"Acacius", "Achaikos", "Adalberht", "Adalbern", "Adalbert", "Adalfuns", "Adalhard", "Adalheidis", "Adalwin", "Adalwolf", "Adelais", "Adelina", "Aelia", "Aeliana", "Aelianus", "Aelius", "Aemilia", "Aemilianus", "Aenor", "Aesop", "Agape", "Agapetos", "Agapetus", "Agapios", "Agatha", "Agathon", "Aghi", "Agmundr", "Agnes", "Agrippa", "Ahmose", "Aikaterine", "Akakios", "Akhenaton", "Alaric", "Alba", "Albanus", "Alcaeus", "Alda", "Aldric", "Alexander", "Alfwin", "Ambrosios", "Anso", "Aniketos", "Antigonos", "Avitus",
"Bagadata", "Barak", "Balbinus", "Balbus", "Berenike", "Bion", "Bjarni", "Birgir", "Bjartr", "Blandina", "Boadicea", "Bradan", "Caius", "Callias", "Caratacus", "Chariton", "Charis", "Chlothar", "Chloe", "Colobert", "Cornelius", "Cosmas", "Crispinus", "Cyrus", "Dagr", "Danr", "Cyprianus", "Drest", "Drakon", "Drusus", "Eburwin", "Egill", "Ennius", "Epiktetos", "Epiphanius", "Erastos", "Eukleides", "Euphemios", "Eupraxia", "Eusebios", "Fabiola" ,"Faramund", "Faustus", "Finnr", "Florus", "Gallus", "Gaios", "Galene", "Gennados", "Godric",
"Godeliva", "Halli", "Hamilcar", "Haraldr", "Herleva", "Hermokrates", "Hermolaos", "Homeroes", "Horatius", "Huguo", "Hunberct", "Iodocus", "Iovianus", "Iunius", "Jarl", "Judocus", "Kyrakios", "Kyros", "Lambert", "Lanzo" ,"Laurentia", "Livius", "Longina", "Loukios", "Lucia", "Lysimachos", "Manlius", "Manno", "Mnason", "Narseh", "Narses", "Nicolaus", "Nikanor", "Nikias", "Odovacar", "Osgar", "Pelagios", "Perikles", "Phaidros", "Phile", "Pomponius", "Porcia", "Raban", "Raginald", "Rhode", "Regulus", "Saxa", "Scaevola", "Seneca", "Sigmundr",
"Solon", "Tacitus", "Tahmasp", "Theobald", "Theodora", "Theodosia", "Theodosios", "Thracius", "Tiberius", "Valdis", "Unnr", "Valens", "Vita", "Vitus", "Waldo", "Wandal", "Walahfrid", "Xanthe", "Xenia", "Xenocrates", "Yeshua", "Zenais", "Zeno", "Zoticus", "Zotikos"  }
--ancient names only?
local genNamesPrep;
local SpyMissionsT ={}
local bPoliceStation = GameInfoTypes.BUILDING_ITG_POLICE_STATION;
local bConstable = GameInfoTypes.BUILDING_ITG_CONSTABLE;
local horde4inno = GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_HORDE_4;

function OnEraResetClearUsedNames()
	genNamesPrep = nil;
end

function PrepareSpyNames()
	genNamesPrep = {}
	generalNames = Shuffle(generalNames);
	local usedT = {}
	for a, b in pairs(gT.Players) do
		for c, d in pairs(b.Agents or {}) do
			usedT[d.Name] = true;
		end
	end
	for i, name in pairs(generalNames) do
		if not usedT[name] then
			genNamesPrep[name] = true;
		end
	end
end

function AssignEspionage()
	for g, gData in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			InitDemographicsMargins(g)
			gT.Players[g].NumCounterSpies = 0;	
			gT.Players[g].NumIntrigueSpies = 0;
			gT.Players[g].MinAgentsForIntel = LastRandom(2, 6) -- AI value to favour demographics data
			gT.Players[g].EspionageFlavour = LastRandom(1, #SpyMissionsT); -- AI value to favour single espionage action
			local numInitAgents = LastRandom(1,3);
			if GetDBCulturePlayerInfo(g, "MinNumAgents") then
				numInitAgents = LastRandom(GetDBCulturePlayerInfo(g, "MinNumAgents"), GetDBCulturePlayerInfo(g, "MaxNumAgents"));
			end
			CreateAgents(g, numInitAgents, nil)
			gT.Players[g].NumBoughtSpies = LastRandom(1,math.max(numInitAgents, 1));
			AIReassignSpies(g, true)
			for i, agentData in pairs(gT.Players[g].Agents) do
				if SpyMissionsT[agentData.Mission] then
					if SpyMissionsT[agentData.Mission].TurnsNeeded then
						gT.Players[g].Agents[i].TurnsActiveAction = LastRandom(0,SpyMissionsT[agentData.Mission].TurnsNeeded - 1) 
					end
				end
			end
		end
	end
end

function GetCostOfNewAgent(iPlayer)
	local goldCost = DBScenario.BaseAgentCost + DBScenario.ExtraAgentCost * gT.Players[iPlayer].NumSpyBought;
	if gT.Players[iPlayer].HasIdeology[39] then
		goldCost = math.floor(goldCost / 2)
	end
	return goldCost;
end

function PlayerBoughtNewAgentWithGold(iPlayer)
	if DBScenario.GoldBudgetOnly then
		print("Player tried to purchase agent in budget mode", iPlayer)
		return;
	end
	local goldCost = GetCostOfNewAgent(iPlayer)
	SpendITGGold(iPlayer, goldCost)
	gT.Players[iPlayer].NumSpyBought = gT.Players[iPlayer].NumSpyBought + 1;
	CreateAgentNew(iPlayer, false, false)
end

function GetSpyName(gPlayer, g)
	if not genNamesPrep then
		PrepareSpyNames()
	end
--	local civType = GameInfo.Civilizations[Players[gPlayer]:GetCivilizationType()].Type
	for name, sth in pairs(genNamesPrep) do
		genNamesPrep[name] = nil;
		return name;
	end
	return "Unique" .. gPlayer .. "Spy" .. g;
end

function CreateAgents(gPlayer, numagents, missionT)
	for i = 1, numagents do
		CreateAgentNew(gPlayer, true)
	end	
end

function GetNumAgents(iPlayer, bDeadOrAlive)
	local c = 0;
	for a, h in pairs(gT.Players[iPlayer].Agents) do
		if (not h.IgnoreItForever) then
			if bDeadOrAlive or h.IsAlive then
				c = c + 1;
			end
		end
	end
	return c;
end

function CreateAgentNew(gPlayer, bInitial, bReady, gpID)
	local nID = #gT.Players[gPlayer].Agents + 1;
	local aTab = {Name = GetSpyName(gPlayer, nID), LinkGP = gpID, DecayMod = {}, RecoveryMod = {}, Visibility = {}, Mission = -1, IsAlive = true, LastTimeRelocated = -10, XP = 0, Rank = 1, TurnsActiveAction = 0}
	local xp = 0;
	if bInitial then
		xp = LastRandom(0,132);
	elseif not bReady then
		aTab.LastTimeRelocated = GetITGGameTurn() - 3;
		if gT.Players[gPlayer].HasIdeology[39] then
			for g, h in pairs(gT.Players[gPlayer].Agents) do
				if not h.IgnoreItForever then
					xp = xp + 10;
				end
			end
		end
	end
	aTab.XP = xp;
	if xp >= 100 then
		if xp >= 200 then
			aTab.Rank = 3;
		else
			aTab.Rank = 2;
		end
	end
	aTab.MaxRank = aTab.Rank;
	table.insert(gT.Players[gPlayer].Agents, aTab)
end

function RemoveAgentFromGP(iPlayer, gpID)
	for i, add in pairs(gT.Players[iPlayer].Agents) do
		if add.LinkGP == gpID then
			MakeSpyUnassigned(iPlayer, i)
			gT.Players[iPlayer].Agents[i].IgnoreItForever = true;
		end
	end
end

function DoEndMovingToNextTask(iPlayer, agentID)
	local city = gT.Players[iPlayer].Agents[agentID].TempData[2];
	local actionID = gT.Players[iPlayer].Agents[agentID].TempData[1];
	local enemyPlayer = gT.Players[iPlayer].Agents[agentID].TempData[3];
	local gpTarget = gT.Players[iPlayer].Agents[agentID].TempData[4];
	local iteam = Players[iPlayer]:GetTeam();
	gT.Players[iPlayer].Agents[agentID].Mission = actionID
	local aID = iPlayer .. "," .. agentID;
	if gpTarget then
		gT.Players[iPlayer].Agents[agentID].TargetGreatPerson = gpTarget;
		gT.GreatPeople[gpTarget].RivalSpiesActive[aID] = {iPlayer, agentID, actionID}
	else
		gT.Players[iPlayer].Agents[agentID].TargetGreatPerson = nil;
	end
	if enemyPlayer then
		gT.Players[iPlayer].Agents[agentID].TargetPlayer = enemyPlayer;
		if not city then
			gT.Players[enemyPlayer].RivalSpiesActive[aID] = {iPlayer, agentID, actionID}
		end
	end
	if city then
		gT.Players[iPlayer].Agents[agentID].TargetCity = city;
		local iCity = Map.GetPlotByIndex(city):GetPlotCity();
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		gT.Cities[cID].SpiesActive[aID] = {iPlayer, agentID, actionID}
		if actionID == 8 then
			local relID = Players[iPlayer]:GetReligionCreatedByPlayer();
			gT.Players[iPlayer].Agents[agentID].RelPressure = relID;
			gT.Cities[cID].SpiesRelPressure[relID] = (gT.Cities[cID].SpiesRelPressure[relID] or 0) + 15;
			iCity:ChangeBaseReligionPressure(relID, 15)
		end
	end
	if actionID == 1 then
		local iPlot = Map.GetPlotByIndex(city);
		iPlot:ChangeVisibilityCount(iteam, 1);
		table.insert(gT.Players[iPlayer].Agents[agentID].Visibility, city)
		for i = 0, 5 do
			local dPlot = Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), i);
			if dPlot then
				dPlot:ChangeVisibilityCount(iteam, 1);
				table.insert(gT.Players[iPlayer].Agents[agentID].Visibility, dPlot:GetPlotIndex())
			end
		end
	elseif actionID == 2 then
		local shTab = GetValidTargetForFollowSpy(iPlayer, agentID, enemyPlayer)
		for i = 1, 5 do
			if shTab[i] then
				gT.Players[iPlayer].Agents[agentID].UnitTracked[shTab[i]:GetID()] = 1;
				table.insert(gT.Players[iPlayer].Agents[agentID].Visibility, shTab[i]:GetPlot():GetPlotIndex())
				shTab[i]:GetPlot():ChangeVisibilityCount(iteam, 1)
			end
		end
	elseif actionID == 4 then
		gT.Players[iPlayer].NumCounterSpies = gT.Players[iPlayer].NumCounterSpies +1;
	elseif actionID == 9 then
		gT.Players[iPlayer].NumIntrigueSpies = gT.Players[iPlayer].NumIntrigueSpies + 1;
	elseif actionID == 7 then
		for g, gdata in pairs(gT.Players) do
			if not Players[g]:IsMinorCiv() then
				if g ~= iPlayer then
					Players[enemyPlayer]:ChangeMinorCivDecayModWithMajor(g, DIPLOMAT_RIVAL_RATE_MOD)
					gT.Players[iPlayer].Agents[agentID].DecayMod[g] = DIPLOMAT_RIVAL_RATE_MOD;
					Players[enemyPlayer]:ChangeMinorCivRecoveryModWithMajor(g,-DIPLOMAT_RIVAL_RATE_MOD)
					gT.Players[iPlayer].Agents[agentID].RecoveryMod[g] = -DIPLOMAT_RIVAL_RATE_MOD;
				else
					Players[enemyPlayer]:ChangeMinorCivDecayModWithMajor(g, -DIPLOMAT_YOUR_RATE_MOD)
					gT.Players[iPlayer].Agents[agentID].DecayMod[g] = -DIPLOMAT_YOUR_RATE_MOD;
					Players[enemyPlayer]:ChangeMinorCivRecoveryModWithMajor(g, DIPLOMAT_YOUR_RATE_MOD)
					gT.Players[iPlayer].Agents[agentID].RecoveryMod[g] = DIPLOMAT_YOUR_RATE_MOD;
				end
			end
		end
	end
	gT.Players[iPlayer].Agents[agentID].TempData = nil
end

function GetMinorEnemyDiplomats(iMinor, iMajor)
	local t = 0;
	for i, v in pairs(gT.Players[iMinor].RivalSpiesActive) do
		if (v[1] ~= iMajor) and (v[3] == 7) then
			t = t + 1;
		end
	end
	return t;
end

function HasMinorDiplomat(iMinor, iMajor)
	for i, v in pairs(gT.Players[iMinor].RivalSpiesActive) do
		if (v[1] == iMajor) and (v[3] == 7) then
			return true;
		end
	end
	return false;
end
 
function EspionageReassignSpy(iPlayer, agentID, actionID, city, enemyPlayer, gpType)
	local turn = GetITGGameTurn();
	if actionID ~= gT.Players[iPlayer].Agents[agentID].Mission or city ~= gT.Players[iPlayer].Agents[agentID].TargetCity or enemyPlayer ~= gT.Players[iPlayer].Agents[agentID].TargetPlayer then
		MakeSpyUnassigned(iPlayer, agentID)
		gT.Players[iPlayer].Agents[agentID].TempData = {actionID, city, enemyPlayer, gpType}
		gT.Players[iPlayer].Agents[agentID].Mission = 0;
		if not gT.Globals.GameGenerated then
			DoEndMovingToNextTask(iPlayer, agentID)
		else
			gT.Players[iPlayer].Agents[agentID].LastTimeRelocated = turn
		end
	end
	if gT.Globals.GameGenerated then
		if iPlayer == Game.GetActivePlayer() then
			Events.OpenInfoCorner()
			Events.SerialEventEndTurnDirty()
			LuaEvents.ITGSGTopPanelDirty()
		end
	end
end
LuaEvents.ITGSG_EspionageCall.Add(EspionageReassignSpy)

function ChangeSpyExperience(g, i, base)
	local amount = base;
	if gT.Players[g].CultBonusOn[5] and (base > 0) then
		amount = amount + base;
	end
	gT.Players[g].Agents[i].XP = math.max(0, gT.Players[g].Agents[i].XP + amount);
	gT.Players[g].Agents[i].Rank = math.min(3, 1 + math.floor(gT.Players[g].Agents[i].XP/100))
end

function ChangeAllSpiesExperience(iPlayer, base)
	for i, data in pairs(gT.Players[iPlayer].Agents) do
		if (not data.IgnoreItForever) then
			ChangeSpyExperience(iPlayer, i, base)
		end
	end
end

function GetPlayerXPAgentPerTurn(g, hi)
	local b = 0;
	if gT.Players[g].HasIdeology[76] then
		local cexp = gT.Players[g].Agents[hi].XP
		for i, data in pairs(gT.Players[g].Agents) do
			if data.XP > cexp then
				b = b + 3;
				break;
			end
		end
	end
	return b;
end

function GetValidAgentToExpose(iPlayer, g)
	for i, data in pairs(gT.Players[iPlayer].Agents) do
		if (not data.IgnoreItForever) then
			if not data.Rekonwalescencja then
				if data.Mission ~= -1 and data.Mission ~= 0 then
					if data.TargetPlayer == g then
						if SpyMissionsT[data.Mission].Daily then
							if not data.Exposed then
								return i;
							end
						end
					end
				end
			end
		end
	end
	return nil;
end

function GreatSpyFunction()
	local gturn = GetITGGameTurn();
	local takeoverT = {}
	for g, gData in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			local iTeam = Players[g]:GetTeam();
			for i, data in pairs(gData.Agents) do
				if (not data.IgnoreItForever) then
					if data.Rekonwalescencja then
						if data.Rekonwalescencja <= 1 then
							gT.Players[g].Agents[i].Rekonwalescencja = nil
							gT.Players[g].Agents[i].IsAlive = true
						else
							gT.Players[g].Agents[i].Rekonwalescencja = gT.Players[g].Agents[i].Rekonwalescencja -1;
						end
					else
						local pRank = gT.Players[g].Agents[i].Rank;
						local lAction = data.LastTimeRelocated;
						local lTurns = data.TurnsActiveAction or 0;
						if data.Mission ~= -1 and data.Mission ~= 0 then
							local tPlayer = data.TargetPlayer;
							-- and data.Mission ~= 4
							--take care about soft ones, like Observation, Infiltration, Propaganda
							local xpperturn = GetPlayerXPAgentPerTurn(g, i)
							if xpperturn > 0 then
								ChangeSpyExperience(g, i, xpperturn)
							end
							if SpyMissionsT[data.Mission].Daily then
								local bKilled = DetermineIfShouldBeKilledDaily(data.Rank, g, tPlayer, data.Mission, data.TargetCity, i)
								if bKilled then
									KillTheAgent(g, i, data.Mission, tPlayer, data.TargetCity)
								else
									--XP
									ChangeSpyExperience(g, i, LastRandom(1,3))
									if data.Mission == 1 then
										--Observation
										local estScience = GetScienceStealSpy(data.Rank, g, tPlayer, data.TargetCity);
										ChangeITGScience(g, estScience)
									elseif data.Mission == 2 then
										--Inflitration
										IncreaseGeneralPointsByNonCombat(g, 1 + data.Rank)
										IncreaseAdmiralPointsByNonCombat(g, 1 + data.Rank)
										local isupport = HasAgentSupportingOtherAgents(g);
										for th = 1, isupport do
											if LastRandom(1, 2) == 2 then
												IncreaseGeneralPointsByNonCombat(g, 1)
											else
												IncreaseAdmiralPointsByNonCombat(g, 1)
											end
										end
										TakeCareOfTrackingMilitaryUnits(g, i)
									elseif data.Mission == 3 then
										--Propaganda codex influence
										local cdxgrowth = 1 + 0.5 * data.Rank;
										if HasAgentSupportingOtherAgents(g) > 0 then
											cdxgrowth = cdxgrowth + 0.5;
										end
										gT.Players[g].EspCodexInfluence = gT.Players[g].EspCodexInfluence + cdxgrowth;
									elseif data.Mission == 7 then
										--City-state
									elseif data.Mission == 8 then
										local estFaith = GetFaithGainSpy(data.Rank, g, tPlayer, data.TargetCity);
										ChangeITGFaith(g, estFaith)
									end
								end
							elseif data.Mission == 4 then
								ChangeSpyExperience(g, i, LastRandom(1,2))
							elseif data.Mission == 9 then
								ChangeITGLegalPointsPercent(g, GetLegalFromAgent(g, i), nil, "Espionage9")
								ChangePlayerPowerFromEspionage(g, i);
								ChangeSpyExperience(g, i, LastRandom(1,3))
							elseif data.Mission == 11 then
								ChangeSpyExperience(g, i, LastRandom(1,2))
							elseif data.Mission == 13 then
								ChangeSpyExperience(g, i, LastRandom(3,7))
							else
								local nTurns = lTurns + 1;
								if nTurns >= SpyMissionsT[data.Mission].TurnsNeeded - gData.SpyTurnReduction then
									gT.Players[g].Agents[i].TurnsActiveAction = 0;
									if data.Mission == 5 then
										--sabotage
										local bKilled = DetermineIfShouldBeKilledSabotage(data.Rank, g, tPlayer, data.TargetCity, i)
										if bKilled and HaveNotTurnedEspionageAround(g, i) then
											KillTheAgent(g, i, data.Mission, tPlayer, data.TargetCity)
										else
											local iCity = Map.GetPlotByIndex(data.TargetCity):GetPlotCity();
											local iBuildingType = GetValidBuildingToSabotage(iCity);
											if iBuildingType then
												ChangeSpyExperience(g, i, LastRandom(20,30))
												DoSabotage(iBuildingType, g, tPlayer, i, iCity)
												table.insert(gT.Players[g].EspionageLog, {gturn, gT.Players[g].Agents[i].LChance, 5, data.Mission, tPlayer, data.TargetCity, i, iBuildingType, nil})
												if gT.Players[g].CanHaveShinobiVision then
													table.insert(gT.Players[g].EspionageLog, {gturn, nil, 903, nil, nil, nil, nil, i})
													table.insert(gT.Players[tPlayer].EspionageLog, {gturn, nil, 904, nil, g})
													iCity:ChangeDamage(100);
												end
												CallLogSimplySpyActionBig(g, "Sabotage")
												table.insert(gT.Players[tPlayer].EspionageLog, {gturn, gT.Players[g].Agents[i].LChance, 6, data.Mission, g, data.TargetCity, nil, iBuildingType})
												if not GetValidBuildingToSabotage(iCity) then
													--spy cannot continue sabotaging
													MakeSpyUnassigned(g, i, true)
												end
												if Players[g]:IsHuman() then
													LuaEvents.ITG_AchievementCountChange(87, 1)
												end
											else
												MakeSpyUnassigned(g, i, true)
											end
										end
										ClearAgentLogChance(g, i)
									elseif data.Mission == 6 then
										--counterfeit
										local bKilled = DetermineIfShouldBeKilledCounterfeit(data.Rank, g, tPlayer, i)
										if bKilled and HaveNotTurnedEspionageAround(g, i) then
											KillTheAgent(g, i, data.Mission, tPlayer, data.TargetCity)
										else
											ChangeSpyExperience(g, i, LastRandom(20,30))
											table.insert(gT.Players[g].EspionageLog, {gturn, gT.Players[g].Agents[i].LChance, 5, data.Mission, tPlayer, data.TargetCity, i})
											CallLogSimplySpyActionBig(g, "Money Forgery")
											table.insert(gT.Players[tPlayer].EspionageLog, {gturn, gT.Players[g].Agents[i].LChance, 6, data.Mission, g, data.TargetCity})
											DoCounterFeit(g, tPlayer, i, data.Rank, true)
										end
										ClearAgentLogChance(g, i)
									elseif data.Mission == 10 then
										--assassination
										local bKilled = DetermineIfShouldBeKilledAsssassination(data.Rank, g, tPlayer, i)
										if bKilled and HaveNotTurnedEspionageAround(g, i, 10) then
											if gT.Players[g].CanHaveShinobiVision and (LastRandom(1, 2) == 2) then
												table.insert(gT.Players[g].EspionageLog, {gturn, nil, 5, data.Mission, tPlayer, data.TargetCity, i, nil, data.TargetGreatPerson})
												CallLogSimplySpyActionBig(g, "Assassination")
												table.insert(gT.Players[tPlayer].EspionageLog, {gturn, nil, 6, data.Mission, g, data.TargetCity, nil, nil, data.TargetGreatPerson})
												DoAssassination(g, tPlayer, i, data.TargetGreatPerson)
											end
											KillTheAgent(g, i, data.Mission, tPlayer, data.TargetCity) 
										else
											ChangeSpyExperience(g, i, LastRandom(25,40))
											table.insert(gT.Players[g].EspionageLog, {gturn, gT.Players[g].Agents[i].LChance, 5, data.Mission, tPlayer, data.TargetCity, i, nil, data.TargetGreatPerson})
											CallLogSimplySpyActionBig(g, "Assassination")
											table.insert(gT.Players[tPlayer].EspionageLog, {gturn, gT.Players[g].Agents[i].LChance, 6, data.Mission, g, data.TargetCity, nil, nil, data.TargetGreatPerson})
											DoAssassination(g, tPlayer, i, data.TargetGreatPerson)
										end
										ClearAgentLogChance(g, i)
									elseif data.Mission == 12 then
										local bKilled = DetermineIfShouldBeKilledCoup(data.Rank, g, tPlayer, i)
										if bKilled and HaveNotTurnedEspionageAround(g, i) then
											KillTheAgent(g, i, data.Mission, tPlayer)
										else
											ChangeSpyExperience(g, i, LastRandom(35,50))
											table.insert(gT.Players[g].EspionageLog, {gturn, gT.Players[g].Agents[i].LChance, 5, data.Mission, tPlayer, data.TargetCity, i})
											CallLogSimplySpyActionBig(g, "Coup")
											table.insert(gT.Players[tPlayer].EspionageLog, {gturn, gT.Players[g].Agents[i].LChance, 6, data.Mission, g, data.TargetCity})
											DoCoup(g, tPlayer, i)
										end
										ClearAgentLogChance(g, i)
									elseif data.Mission == 14 then
										local bKilled = DetermineIfShouldBeKilledHostileTakeOver(data.Rank, g, tPlayer, i)
										if bKilled and HaveNotTurnedEspionageAround(g, i) then
											KillTheAgent(g, i, data.Mission, tPlayer)
											ClearAgentLogChance(g, i)
										else
											ChangeSpyExperience(g, i, LastRandom(35,50))
											table.insert(takeoverT, {g, tPlayer, i})
											table.insert(gT.Players[g].EspionageLog, {gturn, gT.Players[g].Agents[i].LChance, 5, data.Mission, tPlayer, data.TargetCity, i})
											CallLogSimplySpyActionBig(g, "Takeover")
											table.insert(gT.Players[tPlayer].EspionageLog, {gturn, gT.Players[g].Agents[i].LChance, 6, data.Mission, g, data.TargetCity})
										end
									end
								else
									gT.Players[g].Agents[i].TurnsActiveAction = nTurns;
								end
							end
							if gT.Players[g].Agents[i].Rank > pRank then
								table.insert(gT.Players[g].EspionageLog, {gturn, nil, 4, nil, nil, nil, i, pRank, gT.Players[g].Agents[i].Rank})
								if gT.Players[g].Agents[i].Rank > gT.Players[g].Agents[i].MaxRank then
									CallLogSimplySpyActionBig(g, "Rank up")
									gT.Players[g].Agents[i].MaxRank = gT.Players[g].Agents[i].Rank 
								end
							end
						end
					end
				end
			end
		end
	end
	for i, h in pairs(takeoverT) do
		DoEspionageTakeOver(h[1], h[2], h[3])
		ClearAgentLogChance(h[1], h[3])
	end

	--add new ones at the end (after takeover?)
	for g, gData in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			local iTeam = Players[g]:GetTeam();
			for i, data in pairs(gData.Agents) do
				if (not data.IgnoreItForever) then
					if data.Mission == 0 then
						DoEndMovingToNextTask(g, i)	
					end
				end
			end
		end
	end
end

function ClearAgentLogChance(gPlayer, iAgent)
	gT.Players[gPlayer].Agents[iAgent].LturnedAround = nil;
	gT.Players[gPlayer].Agents[iAgent].LChance = nil;
	gT.Players[gPlayer].Agents[iAgent].Lprevented = nil;
end

function MakeSpyUnassigned(iPlayer, agentID, bShow, bDoNotClearGPActions)
	local aID = iPlayer .. "," .. agentID;
	local enemyPlayer = gT.Players[iPlayer].Agents[agentID].TargetPlayer;
	if gT.Players[iPlayer].Agents[agentID].Mission == 4 then
		gT.Players[iPlayer].NumCounterSpies = gT.Players[iPlayer].NumCounterSpies -1;
	elseif gT.Players[iPlayer].Agents[agentID].Mission == 9 then
		gT.Players[iPlayer].NumIntrigueSpies = gT.Players[iPlayer].NumIntrigueSpies - 1;
	end
	local city = gT.Players[iPlayer].Agents[agentID].TargetCity;
	local gpID = gT.Players[iPlayer].Agents[agentID].TargetGreatPerson;
	if gpID then
		if not bDoNotClearGPActions then
			gT.GreatPeople[gpID].RivalSpiesActive[aID] = nil;
		end
	end
	if city then
		local iCity = Map.GetPlotByIndex(city):GetPlotCity();
		local cID = city .. "," .. iCity:GetGameTurnFounded();
		gT.Cities[cID].SpiesActive[aID] = nil;
		if gT.Players[iPlayer].Agents[agentID].RelPressure then
			local relID = gT.Players[iPlayer].Agents[agentID].RelPressure;
			gT.Players[iPlayer].Agents[agentID].RelPressure = nil;
			gT.Cities[cID].SpiesRelPressure[relID] = (gT.Cities[cID].SpiesRelPressure[relID] or 0) -15;
			iCity:ChangeBaseReligionPressure(relID, -15)
		end
	end
	if gT.Players[iPlayer].Agents[agentID].TargetPlayer then
		gT.Players[enemyPlayer].RivalSpiesActive[aID] = nil;
	end
	gT.Players[iPlayer].Agents[agentID].Mission = -1;
	ClearTheVisiblity(iPlayer, agentID)
	ClearTheCityStateModifier(iPlayer, agentID, enemyPlayer)
	gT.Players[iPlayer].Agents[agentID].TargetCity = nil;
	gT.Players[iPlayer].Agents[agentID].TargetPlayer = nil;
	gT.Players[iPlayer].Agents[agentID].UnitTracked = {}
	gT.Players[iPlayer].Agents[agentID].TurnsActiveAction = 0
	gT.Players[iPlayer].Agents[agentID].LastTimeRelocated = -10;
	gT.Players[iPlayer].Agents[agentID].TempData = nil;
	gT.Players[iPlayer].Agents[agentID].Exposed = nil
	if bShow then
		if Game.GetActivePlayer() == iPlayer then
			Events.OpenInfoCorner()
		end
	end
end 

function KillTheAgent(iPlayer, agentID, mission, tPlayer, cityplotindex, bSpecial)
	local iCity;
	local gTurn = GetITGGameTurn();
	if mission and (mission ~= -1) then
		local gpID = gT.Players[iPlayer].Agents[agentID].TargetGreatPerson
		local secTarget = gT.Players[iPlayer].Agents[agentID].TargetPlayer -- useful if coup or representation kill
		local chanceToBeKilled;
		if gT.Players[iPlayer].Agents[agentID].LChance then
			chanceToBeKilled = (1000 - gT.Players[iPlayer].Agents[agentID].LChance)
		end
		table.insert(gT.Players[iPlayer].EspionageLog, {gTurn, chanceToBeKilled, 1, mission, tPlayer, cityplotindex, agentID, secTarget, gpID})
		if cityplotindex then
			iCity = Map.GetPlotByIndex(cityplotindex):GetPlotCity()
		end
		local sName = gT.Players[iPlayer].Agents[agentID].Name;
		local x,y = -1, -1;
		if iCity then
			x = iCity:GetX();
			y = iCity:GetY();
		end
		if tPlayer then
			if not Players[tPlayer]:IsMinorCiv() then
				table.insert(gT.Players[tPlayer].EspionageLog, {gTurn, chanceToBeKilled, 2, mission, iPlayer, cityplotindex, nil, secTarget, gpID})
				CallLogSimplySpyActionBig(tPlayer, "Uncover Spy")
				gT.Players[tPlayer].LastCapturedSpyT = gTurn;
				gT.Players[tPlayer].NumCaughtSpies = gT.Players[tPlayer].NumCaughtSpies + 1;
				GovTypePowerBoost(tPlayer, 2, "Spies Caught", 1, false)
			end
		end

		if Players[iPlayer]:IsHuman() then
			local sText = GetNiceTextForEspionageLog(1, iPlayer, agentID, mission, tPlayer, cityplotindex, secTarget, gpID);
			Players[iPlayer]:AddNotification(NotificationTypes.NOTIFICATION_SPY_WAS_KILLED, sText, sName .. " - uncovered", x ,y);
		end
		if Players[tPlayer]:IsHuman() then
			local sText = GetNiceTextForEspionageLog(2, tPlayer, agentID, mission, iPlayer, cityplotindex, secTarget, gpID);
			Players[tPlayer]:AddNotification(NotificationTypes.NOTIFICATION_SPY_KILLED_A_SPY, sText, "Uncovered enemy Agent", x ,y);
		end
	end
	if bSpecial then
		if Players[iPlayer]:IsHuman() then
			Players[iPlayer]:AddNotification(NotificationTypes.NOTIFICATION_SPY_WAS_KILLED, "Our Agent was unconvered!", gT.Players[iPlayer].Agents[agentID].Name .. " - uncovered", x ,y);
		end
		if Players[tPlayer]:IsHuman() then
			Players[tPlayer]:AddNotification(NotificationTypes.NOTIFICATION_SPY_KILLED_A_SPY, "We uncovered enemy Agent!", "Uncovered enemy Agent", x ,y);
		end
	end
	--Now Kill the Spy and his data;
	SpyKilledCSLog(tPlayer, iPlayer)
	MakeSpyUnassigned(iPlayer, agentID)
	gT.Players[iPlayer].Agents[agentID].LastTimeRelocated = -10;
	gT.Players[iPlayer].Agents[agentID].IsAlive = false;
	local pRank = gT.Players[iPlayer].Agents[agentID].Rank
	gT.Players[iPlayer].Agents[agentID].XP = math.max(gT.Players[iPlayer].Agents[agentID].XP - 50, math.floor(gT.Players[iPlayer].Agents[agentID].XP / 2))
	gT.Players[iPlayer].Agents[agentID].Rank = math.min(3, 1 + math.floor(gT.Players[iPlayer].Agents[agentID].XP/100))
	if gT.Players[iPlayer].Agents[agentID].Rank < pRank then
		table.insert(gT.Players[iPlayer].EspionageLog, {gTurn, nil, 3, mission, tPlayer, cityplotindex, agentID, pRank, gT.Players[iPlayer].Agents[agentID].Rank})
	end
	gT.Players[iPlayer].Agents[agentID].Rekonwalescencja = GetTurnOfRekonwalesencja(iPlayer, agentID)
end

function GetTurnOfRekonwalesencja(iPlayer, agentID)
	local base = LastRandom(3,7)
	if gT.Players[iPlayer].HasIdeology[39] then
		base = base - 1;
	end
	if gT.Players[iPlayer].CondemnEspionage > 0 then
		base = base + 2;
	end
	return math.max(1, base);
end

local IsNotBadAlmostScoutClass = {[GameInfoTypes.UNITCLASS_CARAVEL] = 1}
function GetValidTargetForFollowSpy(gPlayer, iAgent, tPlayer)
	local lTab = {}
	for iUnit in Players[tPlayer]:Units() do
		if IsCombatClassITGUnit(iUnit:GetUnitClassType(), tPlayer) then
			if not IsNotBadAlmostScoutClass[iUnit:GetUnitClassType()] then
				if not gT.Players[gPlayer].Agents[iAgent].UnitTracked[iUnit:GetID()] then
					table.insert(lTab, iUnit)
				end
			end
		end
	end
	return Shuffle(lTab)
end

function GetValidBuildingToSabotage(iCity)
	local hTab = {}
	for row in GameInfo.Buildings() do
		if iCity:GetNumRealBuilding(row.ID) == 1 then
			if row.Cost > 0 then
				if GameInfo.BuildingClasses[row.BuildingClass].MaxGlobalInstances == -1 then
					if GameInfo.BuildingClasses[row.BuildingClass].MaxPlayerInstances == -1 then
						if not row.HolyCity then
							table.insert(hTab, row.ID)
						end
					end
				end
			end
		end
	end
	if #hTab > 0 then
		return hTab[LastRandom(1,#hTab)];
	end
	return nil;
end

function GetDataForOverviewDisplay(gPlayer, type)
	local iTeam = Players[gPlayer]:GetTeam();
	local hTab = {}
	if (type == 1) or (type == 3) or (type == 5) then
		for d, data in pairs(gT.Players) do
			if d ~= gPlayer then
				if not Players[d]:IsMinorCiv() then
					if Teams[iTeam]:IsHasMet(Players[d]:GetTeam()) then
						for iCity in Players[d]:Cities() do
							if iCity:Plot():IsRevealed(iTeam) then
								local bHasAlready = HasAlreadySpyDoingIt(gPlayer, type, iCity:Plot():GetPlotIndex())
								table.insert(hTab, {Already = bHasAlready, TargetMain = Players[d]:GetCivilizationShortDescription(), TargetCity = iCity:GetName(), InfoCity = iCity:Plot():GetPlotIndex(), InfoPlayer = d,  PlayerIcon = d, ExtraInfo = iCity:GetPopulation() .."[ICON_CITIZEN]"})
							end	
						end
					end
				end
			end
		end
	elseif type == 2 or (type == 14) then
		for d, data in pairs(gT.Players) do
			if d ~= gPlayer then
				if (not Players[d]:IsMinorCiv()) and Players[d]:IsAlive() then
					if Teams[iTeam]:IsHasMet(Players[d]:GetTeam()) then
						local bHasAlready = HasAlreadySpyDoingIt(gPlayer, type, nil, d)
						table.insert(hTab, {Already = bHasAlready, TargetMain = Players[d]:GetCivilizationShortDescription(), InfoPlayer = d, PlayerIcon = d})
					end
				end
			end
		end
	elseif type == 6 then
		for d, data in pairs(gT.Players) do
			if d ~= gPlayer then
				if (not Players[d]:IsMinorCiv()) and Players[d]:IsAlive() then
					if data.MintPower > 0 then
						if Teams[iTeam]:IsHasMet(Players[d]:GetTeam()) then
							local bHasAlready = HasAlreadySpyDoingIt(gPlayer, type, nil, d)
							table.insert(hTab, {Already = bHasAlready, TargetMain = Players[d]:GetCivilizationShortDescription(), InfoPlayer = d, PlayerIcon = d, ExtraInfo = data.MintPower .. "[ICON_INVEST]"})
						end
					end
				end
			end
		end
	elseif type == 7 then
		for d, data in pairs(gT.Players) do
			if Players[d]:IsMinorCiv() and Players[d]:IsAlive() then
				if not Teams[Players[d]:GetTeam()]:IsAtWar(iTeam) then
					if Teams[iTeam]:IsHasMet(Players[d]:GetTeam()) then
						local bHasAlready = HasAlreadySpyDoingIt(gPlayer, type, nil, d)
						table.insert(hTab, {Already = bHasAlready, TargetMain = Players[d]:GetCivilizationShortDescription(), InfoPlayer = d, PlayerIcon = d, TargetCity = gT.Players[d].CultureString, ExtraInfo = Players[d]:GetMinorCivFriendshipWithMajor(gPlayer) .."[ICON_INFLUENCE]"})
					end
				end
			end
		end
	elseif type == 8 then
		local iRel = Players[gPlayer]:GetReligionCreatedByPlayer();
		if iRel > 0 then
			for d, data in pairs(gT.Players) do
				if d ~= gPlayer then
					if data.OfficialReligion ~= iRel then
						if not Players[d]:IsMinorCiv() then
							if Teams[iTeam]:IsHasMet(Players[d]:GetTeam()) then
								for iCity in Players[d]:Cities() do
									if iCity:Plot():IsRevealed(iTeam) then
										local bHasAlready = HasAlreadySpyDoingIt(gPlayer, type, iCity:Plot():GetPlotIndex())
										table.insert(hTab, {Already = bHasAlready, TargetMain = Players[d]:GetCivilizationShortDescription(), TargetCity = iCity:GetName(), InfoCity = iCity:Plot():GetPlotIndex(), InfoPlayer = d,  PlayerIcon = d, ExtraInfo = iCity:GetPopulation() .."[ICON_CITIZEN]"})
									end	
								end
							end
						end
					end
				end
			end
		end
	elseif type == 10 then
		for d, data in pairs(gT.Players) do
			if d ~= gPlayer then
				if not gT.Players[d].CultBonusOn[130] then
					if Teams[iTeam]:IsHasMet(Players[d]:GetTeam()) then
						for gpid, sth in pairs(data.GreatPeople) do
							if gT.GreatPeople[gpid].Alive then
								if gT.GreatPeople[gpid].CanBeAssassinated then
									if (gT.GreatPeople[gpid].Type ~= 1) or (not HasPlayerTech(d, horde4inno, "caweweqe")) then
										local bHasAlready = HasAlreadySpyDoingIt(gPlayer, type, nil, nil, gpid)
										table.insert(hTab, {Already = bHasAlready, TargetMain = Players[d]:GetCivilizationShortDescription(), InfoPlayer = d,  PlayerIcon = d, TargetGreatPerson = gpid, TargetGPString = GetGreatPersonName(gpid)})
									end
								end
							end
						end
					end
				end
			end
		end
	elseif type == 12 then
		for d, data in pairs(gT.Players) do
			if Players[d]:IsMinorCiv() and Players[d]:IsAlive() then
				if not gT.Players[d].CoupDone then
					if Teams[iTeam]:IsHasMet(Players[d]:GetTeam()) then
						local bHasAlready = HasAlreadySpyDoingIt(gPlayer, type, nil, d)
						table.insert(hTab, {Already = bHasAlready, TargetMain = Players[d]:GetCivilizationShortDescription(), InfoPlayer = d, PlayerIcon = d, TargetCity = gT.Players[d].CultureString, ExtraInfo = Players[d]:GetMinorCivFriendshipWithMajor(gPlayer) .."[ICON_INFLUENCE]"})
					end
				end
			end
		end
	end
	return hTab;
end

function ProvideDataForOverviewDisplay(type)
	local gPlayer = Game.GetActivePlayer()
	MapModData.ITGSG = GetDataForOverviewDisplay(gPlayer, type);
end
LuaEvents.ITGSG_EspionageValidData.Add(ProvideDataForOverviewDisplay)

function HasAlreadySpyDoingIt(gPlayer, type, city, tPlayer, tGP)
	for i, dd in pairs(gT.Players[gPlayer].Agents) do
		if (not dd.IgnoreItForever) then
			if dd.Mission == type then
				if (not tPlayer) or (dd.TargetPlayer == tPlayer) then
					if (not city) or (dd.TargetCity == city) then
						if (not tGP) or (dd.TargetGreatPerson == tGP) then
							return true;
						end
					end
				end
			elseif dd.Mission == 0 then
				if dd.TempData[1] == type then
					if (not tPlayer) or (dd.TempData[3] == tPlayer) then
						if (not city) or (dd.TempData[2] == city) then
							if (not tGP) or (dd.TempData[4] == tGP) then
								return true;
							end
						end
					end
				end
			end
		end
	end
	return false;
end

function DoRecheckSpiesActive(jPlayer, newPlayer, iCity, cID, gpID)
	if gpID then
		if gT.GreatPeople[gpID].Alive then
			for aID, data in pairs(gT.GreatPeople[gpID].RivalSpiesActive or {}) do
				if data[1] == jPlayer then
					MakeSpyUnassigned(data[1], data[2], true, true)
					gT.GreatPeople[gpID].RivalSpiesActive[aID] = nil;
				end
			end
		else
			for aID, data in pairs(gT.GreatPeople[gpID].RivalSpiesActive or {}) do
		--		print(data[1], data[2], gpID, "GP was killed or assassinated")
				MakeSpyUnassigned(data[1], data[2], true, true)
			end
			gT.GreatPeople[gpID].RivalSpiesActive = {}
		end
	else
		local bDead = (not Players[jPlayer]:IsAlive());
		if cID then
			for aID, data in pairs(gT.Cities[cID].SpiesActive) do
				if data[1] == newPlayer then
					MakeSpyUnassigned(data[1], data[2], true)
				else
				--NOTE if in future spy can target OWN Cities we have to edit HERE
					gT.Players[data[1]].Agents[data[2]].TargetPlayer = newPlayer;
				end
			end
		end
		for aID, data in pairs(gT.Players[jPlayer].RivalSpiesActive) do
			if bDead or CannotContinueMission(jPlayer, data[3], data[1], aID) then
				MakeSpyUnassigned(data[1], data[2], true)
			end
		end
		for i, agentdata in pairs(gT.Players[jPlayer].Agents) do
			if bDead or CannotContinueMission(nil, agentdata.Mission, jPlayer, i) then
				MakeSpyUnassigned(jPlayer, i, true)
			end
		end
	end
end

function CannotContinueMission(jPlayer, mission, fPlayer, agentID)
	if not CanPlayerDoEspionageAction(fPlayer, mission, agentID) then
		return true;
	end
	if jPlayer then
		if mission == 6 then
			if not HasMintAnyCity(jPlayer) then
				return true;
			end
		elseif mission == 7 then
			if Teams[Players[jPlayer]:GetTeam()]:IsAtWar(Players[fPlayer]:GetTeam()) then
				return true;
			end
		elseif mission == 12 then
			if gT.Players[jPlayer].CoupDone then
				return true;
			end
		end
	end
	return false;
end

local AITesttingTab = {0, 0, 0, 0, 0,0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}
function AIReassignSpies(iPlayer, bInit)
	if gT.Players[iPlayer].Goverment == 1 then
		if not bInit then
			return;
		end
	end
	local gTurn = GetITGGameTurn();
	if gT.Players[iPlayer].AIEspCacheT or -999 < gTurn then
		gT.Players[iPlayer].AIEspNumCounter = GetAINumCounterSpiesMinimum(iPlayer)
		gT.Players[iPlayer].AIEspNumIntrigue = GetAINumIntrigueSpiesMinimum(iPlayer)
		gT.Players[iPlayer].AIEspCacheT = gTurn + LastRandom(5,8);
	end
	local numdefdif = gT.Players[iPlayer].AIEspNumCounter - gT.Players[iPlayer].NumCounterSpies - GetNumSpiesMovingToMission(iPlayer, 4)
	local numintrdif = gT.Players[iPlayer].AIEspNumIntrigue - gT.Players[iPlayer].NumIntrigueSpies - GetNumSpiesMovingToMission(iPlayer, 9)
	local numsupportdif = GetAINumSupportSpiesMinimum(iPlayer)

	for agentID, data in pairs(gT.Players[iPlayer].Agents) do
		if data.IsAlive and (not data.IgnoreItForever) and (data.LastTimeRelocated < GetITGGameTurn()) then
			if AICanShouldBeReassigned(agentID, iPlayer, data, numdefdif, numintrdif, numsupportdif) then
				local newTaskData = FindNewTaskForAgentAI(agentID, iPlayer, data, numdefdif, numintrdif, numsupportdif)
				if newTaskData then
					if (newTaskData[1] ~= data.Mission) or (newTaskData[3] ~= data.TargetCity) or (newTaskData[4] ~= data.TargetPlayer) then
						if data.Mission == 4 then
							numdefdif = numdefdif + 1;
						end
						if newTaskData[1] == 4 then
							numdefdif = numdefdif -1;
						end
						if data.Mission == 9 then
							numintrdif = numintrdif + 1;
						end
						if newTaskData[1] == 9 then
							numintrdif = numintrdif -1;
						end
						if data.Mission == 11 then
							numsupportdif = numsupportdif + 1;
						end
						if newTaskData[1] == 11 then
							numsupportdif = numsupportdif -1;
						end
						AITesttingTab[newTaskData[1]]= AITesttingTab[newTaskData[1]] + 1;
						EspionageReassignSpy(iPlayer, agentID, newTaskData[1], newTaskData[3], newTaskData[4], newTaskData[5])
					end
				end
			end
		end
	end
end

function AICanShouldBeReassigned(agentID, iPlayer, data, numdefdif, numintdif, numsupportdif)
	if data.Mission == -1 then
		return true;
	end
	local TurnsActive = GetITGGameTurn() - data.LastTimeRelocated;
	if TurnsActive < 4 then
		return false;
	end
	if data.Mission == 0 then
		--should never occur
		print("but occured 125125 How agent go 0 mission ~ moving somewhere?")
		return false;
	end
	if data.Mission == 4 then
		if numdefdif < 0  then
			return true
		end
	end
	if data.Mission == 9 then
		if numintdif < 0 then
			return true
		end
	end
	if data.Mission == 11 then
		if numsupportdif < 0 then
			return true;
		end
	end
	if data.Mission == 13 then
		if not LooksOkToMakeIntelAI(agentID, iPlayer) then
			return true;
		end
	end
	if SpyMissionsT[data.Mission].Daily then
		if LastRandom(1, 100) <= TurnsActive then
			return true;
		end
	end
	if SpyMissionsT[data.Mission].TurnsNeeded then
		if TurnsActive > 2 then
			if data.TurnsActiveAction == 0 then
				return true;
			end
		end
	end
	return false;
end

function FindNewTaskForAgentAI(agentID, iPlayer, agentdata, numdefdif, numintdif, numsupdif)
	local hTab = {}
	local baseV = GetBaseEspionageAIValues(iPlayer)
	if numdefdif > 0 then
		if agentdata.Mission ~= 4 then
			return {4};
		end
	end
	if numintdif > 0 then
		if agentdata.Mission ~= 9 then
			return {9};
		end
	end
	if numsupdif > 0 then
		if agentdata.Mission ~= 11 then
			return {11};
		end
	end
	if LooksOkToMakeIntelAI(agentID, iPlayer) then
		return {13};
	end
	local detPlayerTab = {}
	for g, gdata in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			if g ~= iPlayer then
				detPlayerTab[g] = GetPlayerAISpyValueAgainstPlayer(iPlayer, g)
			end
		end
	end
	if agentdata.Mission ~= -1 then
		if not CannotContinueMission(agentdata.TargetPlayer, agentdata.Mission, iPlayer, agentID) then
			if SpyMissionsT[agentdata.Mission].GetValueForActionTypeAI then
				local tValue = SpyMissionsT[agentdata.Mission].GetValueForActionTypeAI(agentdata.TargetPlayer, agentdata.TargetCity, iPlayer) + baseV[agentdata.Mission];
				if agentdata.Mission == gT.Players[iPlayer].EspionageFlavour then
					tValue = tValue + 3;
				end
				if agentdata.TargetPlayer then
					tValue = (detPlayerTab[agentdata.TargetPlayer] or 0) + tValue;
				end
				if tValue > 0 then
					table.insert(hTab, {agentdata.Mission, tValue, agentdata.TargetCity, agentdata.TargetPlayer, agentdata.TargetGreatPerson})
				end
			end
		end
	end
	for i, spydata in pairs(SpyMissionsT) do
		if spydata.GetValueForActionTypeAI then
			if CanPlayerDoEspionageAction(iPlayer, i, agentID) then
				local obsTab = GetDataForOverviewDisplay(iPlayer, i)
				local tempTab = {};
				for it, data in pairs(obsTab) do
					if not data.Already then
						local tValue = spydata.GetValueForActionTypeAI(data.InfoPlayer, data.InfoCity, iPlayer) + baseV[i];
						if data.InfoPlayer then
							tValue = (detPlayerTab[data.InfoPlayer] or 0) + tValue;
						end
						if i == gT.Players[iPlayer].EspionageFlavour then
							tValue = tValue + 3;
						end
						if tValue > 0 then
							table.insert(tempTab, {i, tValue, data.InfoCity, data.InfoPlayer, data.TargetGreatPerson})
						end
					end
				end
				if #tempTab > 0 then
					table.sort(tempTab, SortFunctionForGreaterInteger2)
					table.insert(hTab, tempTab[1])
				end
			end
		end
	end
	if #hTab > 0 then
--		for i, data in pairs(hTab) do
			--exclude negative values
--			hTab[i][2] = math.max(1, data[2])
--		end
		return hTab[GetRandomFromBiasedChanceTable(hTab, true)]
	else
--		print("Seriously not enough spy tasks?", agentID, iPlayer, agentdata, numdefdif, numintdif)
		return {4}
	end
end

function GetPlayerAISpyValueAgainstPlayer(iPlayer, g)
	local base = 0;
	local gTurn = GetITGGameTurn()
	if Teams[Players[iPlayer]:GetTeam()]:HasEmbassyAtTeam(Players[g]:GetTeam()) then
		base = base + 5;
	end
	for i, logdata in pairs(gT.Players[iPlayer].EspionageLog) do
		local difturns = gTurn - logdata[1];
		if logdata[5] == g then
			if logdata[3] == 1 then
				if difturns < 10 then
					base = base - 15;
				elseif difturns < 30 then
					base = base - 8;
				else
					base = base - 3;
				end
			elseif logdata[3] == 2 then
				if difturns < 2 then
					base = base + 30;
				elseif difturns < 4 then
					base = base + 10;
				end
			elseif logdata[3] == 5 then
				if difturns < 5 then
					 base = base + 3;
				elseif difturns < 25 then
					 base = base + 5;
				else
					base = base + 15;
				end
			elseif logdata[3] == 6 then
				base = base + 1;
			end
		end
	end
	return base;
end

local TableAIValueObserving = {10, 25, 25, 15, 30, 10, 10, 15, 20, 10, 6}
local TableAIValueTargetObserve = {25, 10, 15, 20, 5, 25, 25, 20, 5, 20, 18}
function GetBaseEspionageAIValues(iPlayer)
	local tTab = {}
	for a, b in pairs(SpyMissionsT) do
		tTab[a] = b.BaseAIEval;
	end
	tTab[1] = TableAIValueObserving[gT.Players[iPlayer].CultureType]
	tTab[2] = tTab[2] + math.floor((gT.Players[iPlayer].GeneralCombatLost or 0)/80)
	tTab[3] = tTab[3] + GetAIAttitudeTowardCodexStrength(iPlayer);
	tTab[6] = tTab[6] + (gT.Players[iPlayer].MintBonus or 0);
	tTab[8] = tTab[8] + GetAIFlavour(iPlayer, "FLAVOR_RELIGION");
	return tTab;
end

function GetValueForObservation(tPlayer, cityIndexPlot, iPlayer)
	local iCity = Map.GetPlotByIndex(cityIndexPlot):GetPlotCity();
	local base = math.floor(iCity:GetPopulation()/2);
	base = base + TableAIValueTargetObserve[gT.Players[tPlayer].CultureType];
	if Teams[Players[tPlayer]:GetTeam()]:IsAtWar(Players[iPlayer]:GetTeam()) then
		base = base + 10;
	end
	return base;
end

function GetValueForHostileTakeover(tPlayer, cityIndexPlot, iPlayer)
	local base = 2;
	if Teams[Players[tPlayer]:GetTeam()]:IsAtWar(Players[iPlayer]:GetTeam()) then
		base = base + 15;
	end
	return base;
end

function GetValueForAssassination(tPlayer, cityIndexPlot, iPlayer)
	local base = 2;
	if Teams[Players[tPlayer]:GetTeam()]:IsAtWar(Players[iPlayer]:GetTeam()) then
		base = base + 5;
	end
	local count = 0;
	for gpid, sth in pairs(gT.Players[tPlayer].GreatPeople) do
		if gT.GreatPeople[gpid].Alive then
			count = count + 1;
		end
	end
	base = base + math.abs(count - 3);
	return base;
end

function GetValueForInfiltration(tPlayer, fill, iPlayer)
	local base = math.floor(Players[tPlayer]:GetNumUnits() / 2)
	if Teams[Players[tPlayer]:GetTeam()]:IsAtWar(Players[iPlayer]:GetTeam()) then
		base = base + 20;
	end
	return base;
end

function GetValueForPropaganda(tPlayer, cityIndexPlot, iPlayer)
	local iCity = Map.GetPlotByIndex(cityIndexPlot):GetPlotCity();
	local base = iCity:GetPopulation();
	if Teams[Players[tPlayer]:GetTeam()]:IsAtWar(Players[iPlayer]:GetTeam()) then
		base = base * 2;
	end
	return base;
end

function GetValueForSabotage(tPlayer, cityIndexPlot, iPlayer)
	local iCity = Map.GetPlotByIndex(cityIndexPlot):GetPlotCity();
	local base = iCity:GetPopulation()
	if Teams[Players[tPlayer]:GetTeam()]:IsAtWar(Players[iPlayer]:GetTeam()) then
		base = base + 5;
	end
	if gT.Players[iPlayer].CanWonderRace then
		base = base + 10 * (gT.Players[tPlayer].NumWondersBuild or 0)
	end
	if HasCSMission(iPlayer, 43) then
		base = base + 5;
	end
	return base;
end

function GetValueForMoneyForgery(tPlayer, fill, iPlayer)
	local base = 5;
	if Teams[Players[tPlayer]:GetTeam()]:IsAtWar(Players[iPlayer]:GetTeam()) then
		base = base + 10;
	end
	if gT.Players[tPlayer].MintPower > gT.Players[iPlayer].MintPower then
		if gT.Players[iPlayer].MintPower ~= 0 then
			base = base + math.ceil(5 * gT.Players[tPlayer].MintPower / gT.Players[iPlayer].MintPower) ;
		else
			base = base + 1;
		end
	end
	return base;
end

function GetValueForCoupAction(tPlayer, fill, iPlayer) 
	local base = 2;
	local gAlly = Players[tPlayer]:GetAlly()
	if iPlayer == gAlly then
		return -1000;
	elseif gAlly == -1 then
		return 0;
	else
		local infdif = Players[tPlayer]:GetMinorCivFriendshipWithMajor(gAlly) - Players[tPlayer]:GetMinorCivFriendshipWithMajor(iPlayer)
		base = base + math.ceil(infdif / 30)
		if Teams[Players[gAlly]:GetTeam()]:IsAtWar(Players[iPlayer]:GetTeam()) then
			base = base + 10;
		end
	end
	return base;
end

function GetValueForMissionary(tPlayer, cityIndexPlot, iPlayer)
	local iCity = Map.GetPlotByIndex(cityIndexPlot):GetPlotCity();
	local base = iCity:GetPopulation();
	local kValue = GetMinimumFaithPlusForReligionConv(Players[iPlayer]:GetReligionCreatedByPlayer(), iCity, true)
	if kValue > 2000 or kValue < 50 then
		return 0;
	end
	if iCity:IsHolyCityAnyReligion() then
		base = base + 2;
	end
	base = base + math.floor((2000 - kValue)/200)
	if Teams[Players[tPlayer]:GetTeam()]:IsAtWar(Players[iPlayer]:GetTeam()) then
		base = base + 2;
	end
	return base;
end

function GetValueForRepresentation(tPlayer, fill, iPlayer)
	local base = 0;
	local ally = Players[tPlayer]:GetAlly();
	if ally ~= - 1 then
		if ally ~= iPlayer then
			for i, logdata in pairs(gT.Players[iPlayer].EspionageLog) do
				if logdata[3] == 1 then
					if logdata[5] == ally then
						base = base - 5;
					end
				end
			end
		else
			base = base + 20;
		end
	end
	local numfriendship = Players[tPlayer]:GetMinorCivFriendshipWithMajor(iPlayer)
	if numfriendship > 60 then
		base = base + math.floor(numfriendship/5)
	else
		base = base + math.floor(numfriendship/10)
	end
	return base;
end

function GetAINumCounterSpiesMinimum(iPlayer)
	--cities/pop
	--ifhavemint
	--num aggression actions (recent more valuable)
	local points, tohave = 0, 0;
	points = points + math.floor(-15 * GetPercentageOfCitiesHavingBuilding(iPlayer, bConstable))
	points = points + math.floor(-15 * GetPercentageOfCitiesHavingBuilding(iPlayer, bPoliceStation))
	if HasMintAnyCity(iPlayer) then
		points = points + 15;
	end
	points = points + 3 * Players[iPlayer]:GetNumCities() + math.floor(Players[iPlayer]:GetTotalPopulation() / 10);
	local gTurn = GetITGGameTurn();
	for i, logdata in pairs(gT.Players[iPlayer].EspionageLog) do
		if gTurn - logdata[1] < 20 then
			if logdata[3] == 2 or logdata[3] == 6 then
				points = points + math.floor(30 * (20 - gTurn + logdata[1])/20)
			end
		end
	end
	if points > 95 then
		tohave = 2;
	elseif points > 24 then
		tohave = 1;
	end
	local numAgentsTotal = GetNumAgents(iPlayer, true);
--	print("AI counter spies minimum", points, tohave,  numAgentsTotal)
	if GetAIFlavour(iPlayer, "FLAVOR_DEFENSE") > 6 then
		tohave = math.min(tohave, math.ceil(numAgentsTotal / 3))
	else
		tohave = math.min(tohave, math.floor(numAgentsTotal / 3))
	end
	return tohave
end

function LooksOkToMakeIntelAI(agentID, iPlayer)
	if gT.Players[iPlayer].Agents[agentID].Rank == 1 then
		if CanPlayerDoEspionageAction(iPlayer, 13, agentID) then
			if gT.Players[iPlayer].MinAgentsForIntel <= GetNumAgents(iPlayer, true) then
				return true;
			end
		end
	end
	return false;
end

function GetAINumSupportSpiesMinimum(iPlayer)
	local val = 0; 
	val = val - GetNumSpiesMovingToMission(iPlayer, 11);
	if HasAgentSupportingOtherAgents(iPlayer) then
		val = val - 1;
	end
	if gT.Players[iPlayer].HasIdeology[76] then
		if GetNumAgents(iPlayer, true) > 4 then
			val = val + 1;
		end
	end
	return val;
end

function GetNumSpiesMovingToMission(iPlayer, spyAction)
	local c = 0;
	for agentID, sth in pairs(gT.Players[iPlayer].Agents) do
		if (not sth.IgnoreItForever) then
			if not sth.Rekonwalescencja then
				if sth.TempData then
					if sth.TempData[1] == spyAction then
						c = c + 1;
					end
				end
			end
		end
	end
	return c;
end

function GetAINumIntrigueSpiesMinimum(iPlayer)
	local points, tohave = GetAIFlavour(iPlayer, "FLAVOR_LEGAL") * 2, 0;
	points = points + GetNumAgents(iPlayer, true) * 8 + GetNumActiveGovernors(iPlayer) * 6;
	local gTurn = GetITGGameTurn();
	local recentLegal = GetLastGraphData(iPlayer, 8) or 15;
	recentLegal = recentLegal - EstimatedLegalGrowthFromSpies(iPlayer)
	points = points + math.max(0, 25 - recentLegal)
	if points > 50 then
		tohave = 1;
	end
	return tohave
end

function GetNiceTextForEspionageLog(type, iPlayer, agentID, mission, tPlayer, cityplotindex, pRank, gP, bLog)
--type 1 killed by enemy
--2 killed enemy spy
--3 spy deranked after being killed
--4 spy advanced rank
--5 spy succeded
--6 rival spy succeded
	local name = "";
	if gP then
		name = GetGreatPersonName(gP);
	end
	local str = ""
	if type == 1 then
		str = "Agent, " ..  gT.Players[iPlayer].Agents[agentID].Name .. ", was uncovered by " .. Players[tPlayer]:GetCivilizationAdjective() .. " counter-intelligence"
		if mission == 1 then
			str = str .. " during an observation of " .. Map.GetPlotByIndex(cityplotindex):GetPlotCity():GetName() .. " city."
		elseif mission == 2 then
			str = str .. ", while infiltrating rival army."
		elseif mission == 3 then
			str = str .. ", while spreading propaganda in " .. Map.GetPlotByIndex(cityplotindex):GetPlotCity():GetName() .. " city."
		elseif mission == 5 then
			str = str .. ", while trying to sabotage a building in " .. Map.GetPlotByIndex(cityplotindex):GetPlotCity():GetName() .. " city."
		elseif mission == 6 then
			str = str .. ", while trying to forge rival currency."
		elseif mission == 7 then
			str = str .. ", while representing our interests in the city-state of " .. Players[pRank]:GetName() .. "."
		elseif mission == 8 then
			str = str .. ", while enlightening their people about the glorious aspects of our religion in " .. Map.GetPlotByIndex(cityplotindex):GetPlotCity():GetName() .. " city." 
		elseif mission == 10 then
			str = str .. ", while bravely trying to take down an enemy of our country, " .. name .. "."
		elseif mission == 12 then
			str = str .. ", while trying to free our minor friend, " .. Players[pRank]:GetName() .. ", from the influence of imperialists." 
		elseif mission == 14 then
			str = str .. ", while trying to infiltrate those agencies.";
		end
		if (mission == 5) or (mission == 6) or (mission == 12) or (mission == 10) or (mission == 14) then
			if not bLog then
				if gT.Players[iPlayer].Agents[agentID].Lprevented then
					str = str .. " (" .. gT.Players[iPlayer].Agents[agentID].Lprevented .. ")"
				elseif gT.Players[iPlayer].Agents[agentID].LChance then
					str = str .. " (" .. (1000 - gT.Players[iPlayer].Agents[agentID].LChance) / 10 .. "%)"
				end
			end
		end
	elseif type == 2 then
		str = "Our counter-intelligence uncovered rival Agent (believed to work for " .. Players[tPlayer]:GetCivilizationShortDescription() .. ")"
		if mission == 1 then
			str = str .. " during an observation of " .. Map.GetPlotByIndex(cityplotindex):GetPlotCity():GetName() .. " city."
		elseif mission == 2 then
			str = str .. ", infiltrating our army."
		elseif mission == 3 then
			str = str .. ", spreading propaganda in " .. Map.GetPlotByIndex(cityplotindex):GetPlotCity():GetName() .. " city."
		elseif mission == 5 then
			str = str .. " before they sabotage a building in " .. Map.GetPlotByIndex(cityplotindex):GetPlotCity():GetName() .. " city."
		elseif mission == 6 then
			str = str .. " trying to fake our currency."
		elseif mission == 7 then
			str = str .. ", harming our influence in the city-state of " .. Players[pRank]:GetName() .. "."
		elseif mission == 8 then
			str = str .. ", organising underground sect of their filthy religion in " .. Map.GetPlotByIndex(cityplotindex):GetPlotCity():GetName() .. " city."
		elseif mission == 10 then
			str = str .. ", trying to assassinate our beloved " .. name .. "!";
		elseif mission == 12 then
			str = str .. ", preparing a Coup in " .. Players[pRank]:GetName() .. ".";
		elseif mission == 14 then
			str = str .. ", trying to infiltrate our agencies.";
		end
		if (mission == 5) or (mission == 6) or (mission == 12) or (mission == 10) or (mission == 14) then
			if not bLog then
				if gT.Players[tPlayer].Agents[agentID].Lprevented then
					str = str .. " (" .. gT.Players[tPlayer].Agents[agentID].Lprevented .. ")"
				elseif gT.Players[tPlayer].Agents[agentID].LChance then
					str = str .. " (" .. (1000 - gT.Players[tPlayer].Agents[agentID].LChance) / 10 .. "%)"
				end
			end
		end
	elseif type == 3 then
		str = "Our Agent, cryptonim " ..  gT.Players[iPlayer].Agents[agentID].Name .. ", degraded from rank " .. pRank .. " to " .. gP .. " after being uncovered and losing valuable assets.";
	elseif type == 4 then
		str = "Our Agent, cryptonim " ..  gT.Players[iPlayer].Agents[agentID].Name .. ", advanced from rank " .. pRank .. " to " .. gP .. " earning valuable experience.";
	elseif type == 5 then
		if mission == 5 then
			str = "Agent, " ..  gT.Players[iPlayer].Agents[agentID].Name .. ", has successfully destroyed " .. Locale.Lookup(GameInfo.Buildings[pRank].Description) .. " in " ..  Map.GetPlotByIndex(cityplotindex):GetPlotCity():GetName() .. " city (" .. Players[tPlayer]:GetCivilizationShortDescription() .. ").";
		elseif mission == 6 then
			str = "Agent, " ..  gT.Players[iPlayer].Agents[agentID].Name .. ", has successfully forged currency of " .. Players[tPlayer]:GetCivilizationShortDescription() .. ", reducing their economic strength and wealth."
		elseif mission == 10  then
			str = "Agent, " ..  gT.Players[iPlayer].Agents[agentID].Name .. ", has successfully assassinated " .. name .. " from " .. Players[tPlayer]:GetCivilizationShortDescription() .. "."
		elseif mission == 12  then
			str = "Agent, " ..  gT.Players[iPlayer].Agents[agentID].Name .. ", has successfully arranged a Coup in " .. Players[tPlayer]:GetName() .. "."
		elseif mission == 14 then
			str = "Agent, " .. gT.Players[iPlayer].Agents[agentID].Name .. ", has successfully completed a hostile takeover of " .. Players[tPlayer]:GetName() .. "'s agencies! They are completely fragile until reorganization."
		end
		if not bLog then
			if gT.Players[iPlayer].Agents[agentID].LturnedAround then
				str = str .. " (" .. gT.Players[iPlayer].Agents[agentID].LturnedAround .. ")"
			elseif gT.Players[iPlayer].Agents[agentID].LChance then
				str = str .. " (" .. gT.Players[iPlayer].Agents[agentID].LChance / 10 .. "%)"
			end
		end
	elseif type == 6 then
		if mission == 5 then
			str = "Rival Agent (" .. Players[tPlayer]:GetCivilizationShortDescription() .. ") destroyed " .. Locale.Lookup(GameInfo.Buildings[pRank].Description) .. " in " ..  Map.GetPlotByIndex(cityplotindex):GetPlotCity():GetName() .. " city.";
		elseif mission == 6 then
			str = "Rival Agent (" .. Players[tPlayer]:GetCivilizationShortDescription() .. ") faked our money, reducing the reliability of our currency greatly.";
		elseif mission == 10 then
			str = "Rival Agent (" .. Players[tPlayer]:GetCivilizationShortDescription() .. ") assassinated " .. name .. ", what a loss!";
		elseif mission == 12  then
			str = "Rival Agent (" .. Players[tPlayer]:GetCivilizationShortDescription() .. ") arranged a Coup in ??? (When it is firing?)."
		elseif mission == 14 then
			str = "Rival Agent (" .. Players[tPlayer]:GetCivilizationShortDescription() .. ") has performed a hostile takeover of our agencies! Our agents are compromised and needs to be reorganized."
		end
		if not bLog then
			if gT.Players[tPlayer].Agents[agentID].LturnedAround then
				str = str .. " (" .. gT.Players[tPlayer].Agents[agentID].LturnedAround .. ")"
			elseif gT.Players[tPlayer].Agents[agentID].LChance then
				str = str .. " (" .. gT.Players[tPlayer].Agents[agentID].LChance / 10 .. "%)"
			end
		end
	elseif type == 901 then
		str = "Our Shinobi put " .. Locale.Lookup(GameInfo.Units[pRank].Description) .. " (" .. Players[tPlayer]:GetCivilizationShortDescription() .. ") out of its misery.";
	elseif type == 902 then
		str = "Out of nowhere Shinobi (" .. Players[tPlayer]:GetCivilizationShortDescription() .. ") killed " .. Locale.Lookup(GameInfo.Units[pRank].Description) .. "! We must protect our troops!";
	elseif type == 903 then
		str = "Shinobi dealt 100 damage to city upon successful Sabotage!"
	elseif type == 904 then
		str = "Shinobi dealt 100 damage to city upon treacherous Sabotage!"
	end
	return str;
end

function DoSpyActionAfterTurn(iPlayer)
	for aID, data in pairs(gT.Players[iPlayer].RivalSpiesActive) do
		if data[3] == 2 then
			--infiltration moves
			TakeCareOfTrackingMilitaryUnits(data[1], data[2])
		end
	end
end

function TakeCareOfTrackingMilitaryUnits(g, i)
	local data = gT.Players[g].Agents[i];
	local iTeam = Players[g]:GetTeam();
	local tPlayer = data.TargetPlayer;
	local numTracked, sTracked = 0, 4 + data.Rank;
	ClearTheVisiblity(g, i)
	for unitID, sth in pairs(data.UnitTracked) do
		local iUnit = Players[tPlayer]:GetUnitByID(unitID);
		if iUnit then
			numTracked = numTracked + 1;
			table.insert(gT.Players[g].Agents[i].Visibility, iUnit:GetPlot():GetPlotIndex())
			iUnit:GetPlot():ChangeVisibilityCount(iTeam, 1)
			if gT.Players[g].CanHaveShinobiVision then
				if iUnit:GetCurrHitPoints() < 12 then
					local gturn = GetITGGameTurn();
					table.insert(gT.Players[g].EspionageLog, {gturn, nil, 901, nil, tPlayer, nil, i, iUnit:GetUnitType()})
					table.insert(gT.Players[tPlayer].EspionageLog, {gturn, nil, 902, nil, g, nil, nil, iUnit:GetUnitType()})
					if Players[g]:IsHuman() then
						local sText = GetNiceTextForEspionageLog(901, g, i, nil, tPlayer, nil, iUnit:GetUnitType())
						Players[g]:AddNotification(NotificationTypes.NOTIFICATION_SPY_KILLED_A_SPY, sText, "Shinobi Success", iUnit:GetX(), iUnit:GetY());
					end
					if Players[tPlayer]:IsHuman() then
						local sText = GetNiceTextForEspionageLog(902, tPlayer, i, nil, g, nil, iUnit:GetUnitType())
						Players[tPlayer]:AddNotification(NotificationTypes.NOTIFICATION_SPY_WAS_KILLED, sText, "Shinobi Attack", iUnit:GetX(), iUnit:GetY());
					end
					iUnit:ChangeDamage(15, g)
				end
			end
		else
			gT.Players[g].Agents[i].UnitTracked[unitID] = nil;
		end
	end
	if numTracked < sTracked then
		local shTab = GetValidTargetForFollowSpy(g, i, tPlayer)
		for it = 1, sTracked - numTracked do
			if shTab[it] then
				gT.Players[g].Agents[i].UnitTracked[shTab[it]:GetID()] = 1;
				table.insert(gT.Players[g].Agents[i].Visibility, shTab[it]:GetPlot():GetPlotIndex())
				shTab[it]:GetPlot():ChangeVisibilityCount(iTeam, 1)
			end
		end
	end
end

function RequestPlayerCanDoEspionageTasks(iPlayer, agentID)
	local tTab = {}
	for i, data in pairs(SpyMissionsT) do
		if CanPlayerDoEspionageAction(iPlayer, i, agentID) then
			tTab[i] = 1;
		end
	end
	MapModData.ITGSG = tTab;
end
LuaEvents.ITGSG_EspionageValidActions.Add(RequestPlayerCanDoEspionageTasks);

function CanPlayerDoEspionageAction(iPlayer, type, agentID)
	if type == 6 then
		if not HasMintAnyCity(iPlayer) then
			return false;
		end
	elseif type == 8 then
		if Players[iPlayer]:GetReligionCreatedByPlayer() < 1 then
			return false;
		end
	elseif type == 11 then
		if (not gT.Players[iPlayer].HasIdeology[76]) then
			return false;
		end
	elseif type == 12 then
		if not HasPlayerTech(iPlayer, GameInfoTypes.TECH_INDUSTRIALIZATION, "techindu") then
			return false;
		end
	elseif type == 14 then
		return DBScenario.HostileTakeoverOn;
	end
	if SpyMissionsT[type] then
		if SpyMissionsT[type].OnlyOne then
			if CountAgentsDoingMission(iPlayer, type, true) > 0 then
				if (not agentID) or (gT.Players[iPlayer].Agents[agentID].Mission ~= type) then
					return false;
				end
			end
		end
	end
	return true;
end

function HasAgentSupportingOtherAgents(iPlayer)
	for i, data in pairs(gT.Players[iPlayer].Agents) do
		if data.Mission == 11 then
			return data.Rank;
		end
	end
	return 0;
end

function CountAgentsDoingMission(iPlayer, iMission, bGoing)
 	local t = 0;
	for i, data in pairs(gT.Players[iPlayer].Agents) do
		if data.Mission == iMission then
			t = t + 1;
		end
	end
	if bGoing then
		for i, data in pairs(gT.Players[iPlayer].Agents) do
			if (data.Mission == 0) and (data.TempData) and (data.TempData[1] == iMission) then	
				t = t + 1;
			end
		end
	end
	return t;
end

function HasAgentGatheringIntel(iPlayer)
	if Players[iPlayer]:IsMinorCiv() then
		return 0;
	end
 	for i, data in pairs(gT.Players[iPlayer].Agents) do
		if data.Mission == 13 then
			return data.Rank;
		end
	end
	return 0;
end

LuaEvents.ITGSG_RequestEspionageLog.Add(function(iPlayer)
	local tab = {}
	if gT.Players[iPlayer] then
		for i,v in pairs(gT.Players[iPlayer].EspionageLog) do
			local tName;
			local tCiv;
			if v[7] then
				tName = gT.Players[iPlayer].Agents[v[7]].Name;
			elseif v[5] then
				tName = Players[v[5]]:GetCivilizationShortDescription();
				tCiv = v[5];
			end
			table.insert(tab, {v[1], GetNiceTextForEspionageLog(v[3], iPlayer, v[7], v[4], v[5], v[6], v[8], v[9], true), v[2], tName, tCiv})
		end
	end
	MapModData.ITGSG = tab;
end)

LuaEvents.ITGSG_DoLeaderHeadStats.Add(function()
	if gT.Globals.EspionageLH then
		return;
	end
	gT.Globals.EspionageLH = {}
	local hTab = {};
	for g, h in pairs(gT.Players) do
		for i,v in pairs(h.EspionageLog or {}) do
			if (v[3] == 5) and (v[2]) then
				table.insert(hTab, {g, v[2], i})
			end
		end
	end
	table.sort(hTab, SortFunctionForLowestMapDistance)
	for i = 1, 20 do
		if hTab[i] then
			table.insert(gT.Globals.EspionageLH, { SpyMissionsT[gT.Players[hTab[i][1]].EspionageLog[hTab[i][3]][4]].Description, --action Name
			hTab[i][2], -- chance
			hTab[i][3], -- id log for help text 
			hTab[i][1], -- playerID
			})
		else
			break;
		end
	end
end)

function GetNumAgentsWorkingDailyInTargetPlayer(iPlayer, sPlayer)
	local c = 0;
	for i, data in pairs(gT.Players[iPlayer].Agents) do
		if (not data.IgnoreItForever) then
			if not data.Rekonwalescencja then
				if data.Mission ~= -1 and data.Mission ~= 0 then
					if SpyMissionsT[data.Mission].Daily then
						local tPlayer = data.TargetPlayer;
						if tPlayer == sPlayer then
							c = c + 1;
						end
					end
				end
			end
		end
	end
	return c;
end

LuaEvents.ITG_LH_EspionageToolTip.Add(function(iPlayer, iLog)
	local v = gT.Players[iPlayer].EspionageLog[iLog];
	local sText = GetNiceTextForEspionageLog(v[3], iPlayer, v[7], v[4], v[5], v[6], v[8], v[9], true)
	sText = sText .. "[NEWLINE][NEWLINE]Action took place in " .. v[1] .. "T and had " .. v[2]/10 .. "% chance for success.";
	MapModData.ITGSG = sText;
end)

--tTable
SpyMissionsT =	{ --Name not used // Description
{Name = "Observation", GetValueForActionTypeAI = GetValueForObservation},
{Name = "Infiltration", GetValueForActionTypeAI = GetValueForInfiltration},
{Name = "Propaganda", GetValueForActionTypeAI = GetValueForPropaganda},
{Name = "Counter-Intelligence"},
{Name = "Sabotage", GetValueForActionTypeAI = GetValueForSabotage},
{Name = "Counterfeit", GetValueForActionTypeAI = GetValueForMoneyForgery},
{Name = "Representation", GetValueForActionTypeAI = GetValueForRepresentation},
{Name = "Sect", GetValueForActionTypeAI = GetValueForMissionary},
{Name = "Intrigue"},  --9
{Name = "Assassination", GetValueForActionTypeAI = GetValueForAssassination},
{Name = "Support"},
{Name = "Coup", GetValueForActionTypeAI = GetValueForCoupAction},
{Name = "Intelligence"}, -- 13
{Name = "Hostile takeover", GetValueForActionTypeAI = GetValueForHostileTakeover}
}

for row in DB.Query("SELECT * FROM ITG_EspionageActions") do
	local index = row.ID;
	if not SpyMissionsT[index] then
		SpyMissionsT[index] = {}
	end
	for a, b in pairs(row) do
		SpyMissionsT[index][a] = b
	end
end

function GetEspActionData(id, type)
	return SpyMissionsT[id][type];
end