local bConstable = GameInfoTypes.BUILDING_ITG_CONSTABLE;
local bPoliceStation = GameInfoTypes.BUILDING_ITG_POLICE_STATION;
local bModernPoliceStation = GameInfoTypes.BUILDING_ITG_MODERN_POLICE_STATION;
local ancCSt30 =  GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_30;
local DemographicsData = {};
local tIndoInno8 = GameInfoTypes.TECH_UNIQUE_ITG_INDUSTRIAL_8;
local uReducementAssassinate = {
[GameInfoTypes.UNIT_ITG_AOT_SPEARMAN_UU_1] = 5,
}

function ClearTheCityStateModifier(iPlayer, agentID, minorID)
	for ePlayer, change in pairs(gT.Players[iPlayer].Agents[agentID].DecayMod) do
		Players[minorID]:ChangeMinorCivDecayModWithMajor(ePlayer,-change)
	end
	for ePlayer, change in pairs(gT.Players[iPlayer].Agents[agentID].RecoveryMod) do
		Players[minorID]:ChangeMinorCivRecoveryModWithMajor(ePlayer,-change)
	end
	gT.Players[iPlayer].Agents[agentID].DecayMod = {}
	gT.Players[iPlayer].Agents[agentID].RecoveryMod = {}
end

function ClearTheVisiblity(iPlayer, agentID)
	local iteam = Players[iPlayer]:GetTeam();
	if gT.Players[iPlayer].Agents[agentID].Visibility then
		for i, iPlotIndex in pairs(gT.Players[iPlayer].Agents[agentID].Visibility) do
			Map.GetPlotByIndex(iPlotIndex):ChangeVisibilityCount(iteam, -1)
		end
		gT.Players[iPlayer].Agents[agentID].Visibility = {};
	end
end

function DiplomatsCannotBeCompromised(gPlayer)
	if HasPlayerTech(gPlayer, GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_13, "okeofkrew") then
		return true;
	end
	return false;
end

function DetermineIfShouldBeKilledInCityState(agentRank, gPlayer, tPlayer, missionType, cityPlotIndex)
	local ally = Players[tPlayer]:GetAlly();
	if DiplomatsCannotBeCompromised(gPlayer) then
		return false;
	end
	local agentChance = 1400 + agentRank * 200
	--it basically checks every player with own agent and an ally (grants small chance to reveal agent)
	if ally ~= -1 then
		if ally ~= gPlayer then
			local bChance = 4 + GetBasicDefenseFromCounterIntelligence(ally, tPlayer, 20);
			local extraAgentChance = 0;
			if Teams[Players[gPlayer]:GetTeam()]:HasEmbassyAtTeam(Players[ally]:GetTeam()) then
				extraAgentChance = extraAgentChance + 250;
			end
			if LastRandom(1,agentChance + extraAgentChance) <= bChance then
				return ally;
			end
		end
	end
	for aID, data in pairs(gT.Players[tPlayer].RivalSpiesActive) do
		if data[1] ~= gPlayer and data[1] ~= ally then
			if data[3] == 7 then
				local hPlayer = data[1];
				local bChance = 4 + GetBasicDefenseFromCounterIntelligence(hPlayer, tPlayer, 20);
				local extraAgentChance = 0;
				if Teams[Players[gPlayer]:GetTeam()]:HasEmbassyAtTeam(Players[hPlayer]:GetTeam()) then
					extraAgentChance = extraAgentChance + 250;
				end
				if LastRandom(1,agentChance + extraAgentChance) <= bChance then
					return hPlayer;
				end
			end
		end
	end
	return false;
end

function DetermineIfShouldBeKilledDaily(agentRank, gPlayer, tPlayer, missionType, cityPlotIndex, agentID)
	if missionType == 7 then
		--city state has much weirder counter intelligence;
		return DetermineIfShouldBeKilledInCityState(agentRank, gPlayer, tPlayer, missionType, cityPlotIndex)
	end
	if gT.Players[gPlayer].Agents[agentID].Exposed then
		if gT.Players[gPlayer].Agents[agentID].Exposed == tPlayer then
			return true;
		end
		gT.Players[gPlayer].Agents[agentID].Exposed = nil
	end

	local iCity;
	if cityPlotIndex then
		iCity = Map.GetPlotByIndex(cityPlotIndex):GetPlotCity();
	end
	local bChance = 15 + GetPlayerBaseDefenseAgainstEspionage(tPlayer, iCity);
	local agentChance = 700 + agentRank * 100;
	if Teams[Players[gPlayer]:GetTeam()]:HasEmbassyAtTeam(Players[tPlayer]:GetTeam()) then
		agentChance = agentChance + 100
	end
	if gT.Players[gPlayer].HasIdeology[62] then
		if gT.Players[tPlayer].InflationLastTurn ~= 0 then
			agentChance = agentChance + 200;
		end
	end
	if HasGovernorProtectionOverSpies(gPlayer, tPlayer) then
		agentChance = agentChance * 2;
	end
	if LastRandom(1, agentChance) <= bChance then -- this actually may get high, around 6%?
		return true;
	end
	return false;
end

function ApplyMaxMinChanceEspionage(gPlayer, tPlayer, iAgent, bOffensive)
	if bOffensive then
		if gT.Players[gPlayer].HasIdeology[9] then
			gT.Players[gPlayer].Agents[iAgent].LChance = math.max(gT.Players[gPlayer].Agents[iAgent].LChance, 300);
		end
	end
end

function GetEspionageAttackAction(gPlayer, tPlayer, missionID)
	local agentChance = 0;
	if gT.Players[gPlayer].HasIdeology[49] and HasPlayerGPOfPlayer(tPlayer, gPlayer) then
		if missionID == 5 then
			agentChance = agentChance + 30;
		elseif missionID == 6 then
			agentChance = agentChance + 15;
		elseif missionID == 10 then
			agentChance = agentChance + 10;
		elseif missionID == 14 then
			agentChance = agentChance + 15;
		else
			print("Undefined espionage attack for mission 49", missionID)
		end
	end
	if Teams[Players[gPlayer]:GetTeam()]:HasEmbassyAtTeam(Players[tPlayer]:GetTeam()) then
		if missionID == 5 then
			agentChance = agentChance + 15;
		elseif missionID == 6 then
			agentChance = agentChance + 10;
		elseif missionID == 10 then
			agentChance = agentChance + 5;
		elseif missionID == 14 then
			agentChance = agentChance + 10;
		else
			print("Undefined espionage attack for mission Embassy", missionID)
		end
	end
	if gT.Players[gPlayer].HasIdeology[62] then
		if gT.Players[tPlayer].InflationLastTurn ~= 0 then
			if missionID == 5 then
				agentChance = agentChance + 30;
			elseif missionID == 6 then
				agentChance = agentChance + 15;
			elseif missionID == 10 then
				agentChance = agentChance + 10;
			elseif missionID == 14 then
				agentChance = agentChance + 15;
			else
				print("Undefined espionage attack for mission 62", missionID)
			end
		end
	end
	local isupport = HasAgentSupportingOtherAgents(gPlayer);
	if isupport > 0 then
		if missionID == 5 then
			agentChance = agentChance + 10 + 5 * isupport;
		elseif missionID == 6 then
			agentChance = agentChance + 4 + 2 * isupport;
		elseif missionID == 10 then
			agentChance = agentChance + 3 + isupport
		elseif missionID == 14 then
			agentChance = agentChance + 4 + 2 * isupport;
		else
			print("Undefined espionage attack for mission support", missionID)
		end
	end
	if gT.Players[gPlayer].GovRewards[33] then
		agentChance = agentChance + math.max(0, gT.Players[gPlayer].Morale)
	end
	return agentChance;
end

function DetermineIfShouldBeKilledSabotage(agentRank, gPlayer, tPlayer, cityPlotIndex, iAgent)
	local iCity = Map.GetPlotByIndex(cityPlotIndex):GetPlotCity();
	local bChance = 10 + GetPlayerBaseDefenseAgainstEspionage(tPlayer, iCity);
	bChance = bChance + gT.Players[tPlayer].DefenseFromSabotage -- increases with every successful sabotage
	local agentChance = 75 + agentRank * 25 + GetEspionageAttackAction(gPlayer, tPlayer, 5);
	if gT.Players[tPlayer].HasMinorIdeology[21] then
		if HasWonderOrRuin(iCity) then
			bChance = bChance + 30;
		end
	end
	if bChance / agentChance > 0.9 then --min chance 10%
		gT.Players[gPlayer].Agents[iAgent].LChance = 100;
	elseif bChance / agentChance < 0.1 then --max chance 90%
		gT.Players[gPlayer].Agents[iAgent].LChance = 900;
	else
		gT.Players[gPlayer].Agents[iAgent].LChance = math.floor((agentChance - bChance) / agentChance * 1000)
	end
--	print("EspPrint Sabotage chance", gT.Players[gPlayer].Agents[iAgent].LChance / 10, bChance, agentChance)
	ApplyMaxMinChanceEspionage(gPlayer, tPlayer, iAgent, true)
	return (LastRandom(1, 1000) > gT.Players[gPlayer].Agents[iAgent].LChance);
end

function GetAssassinationChanceOnTargetPlayer(iPlayer)
	local targets = 0
	for gpID, sth in pairs(gT.Players[iPlayer].GreatPeople) do
		if gT.GreatPeople[gpID].Alive then
			if gT.GreatPeople[gpID].RivalSpiesActive then
				targets = targets + 1;
			end
		end
	end
	return math.min(25, 5 * targets)
end

function GetAssassinateDefenseFromUnits(tPlayer)
	local b = 0;
	for iUnit in Players[tPlayer]:Units() do
		b = b + (uReducementAssassinate[iUnit:GetUnitType()] or 0);
	end
	return b;
end

function DetermineIfShouldBeKilledAsssassination(agentRank, gPlayer, tPlayer, iAgent)
	if HasPlayerTech(tPlayer, ancCSt30, "htrg456234") then
		if LastRandom(1,3) == 2 then --additional innovation defense
			gT.Players[gPlayer].Agents[iAgent].LChance = nil; -- just to be sure :)
			gT.Players[gPlayer].Agents[iAgent].Lprevented = "Speech";
			return true;
		end
	end
	local agentChance = 2 + agentRank * 4 + GetEspionageAttackAction(gPlayer, tPlayer, 10);
	local bChance = 10 + GetPlayerBaseDefenseAgainstEspionage(tPlayer, nil, true)
	agentChance = agentChance + GetAssassinationChanceOnTargetPlayer(tPlayer);
	if gT.Players[tPlayer].HasIdeology[80] then
		bChance = bChance + 10;
	end
	bChance = bChance + GetAssassinateDefenseFromUnits(tPlayer)
	if bChance / agentChance > 0.95 then --min chance 5%
		gT.Players[gPlayer].Agents[iAgent].LChance = 50;
	elseif bChance / agentChance < 0.34 then --max chance 66%
		gT.Players[gPlayer].Agents[iAgent].LChance = 660;
	else
		gT.Players[gPlayer].Agents[iAgent].LChance = math.floor((agentChance - bChance) / agentChance * 1000)
	end
--	print("EspPrint Assassination chance", gT.Players[gPlayer].Agents[iAgent].LChance / 10, bChance, agentChance)
	ApplyMaxMinChanceEspionage(gPlayer, tPlayer, iAgent, true)
	return (LastRandom(1, 1000) > gT.Players[gPlayer].Agents[iAgent].LChance);
end

function DetermineIfShouldBeKilledHostileTakeOver(agentRank, gPlayer, tPlayer, iAgent)
	local bChance = 10 + GetPlayerBaseDefenseAgainstEspionage(tPlayer);
	local agentChance = 40 + agentRank * 15 + GetEspionageAttackAction(gPlayer, tPlayer, 14)
	if bChance / agentChance > 0.9 then --min chance 10%
		gT.Players[gPlayer].Agents[iAgent].LChance = 100;
	elseif bChance / agentChance < 0.25 then --max chance 75%
		gT.Players[gPlayer].Agents[iAgent].LChance = 750;
	else
		gT.Players[gPlayer].Agents[iAgent].LChance = math.floor((agentChance - bChance) / agentChance * 1000)
	end
--	print("EspPrint Takeover chance", gT.Players[gPlayer].Agents[iAgent].LChance / 10, bChance, agentChance)
	ApplyMaxMinChanceEspionage(gPlayer, tPlayer, iAgent, true)
	return (LastRandom(1, 1000) > gT.Players[gPlayer].Agents[iAgent].LChance);
end

function DetermineIfShouldBeKilledCounterfeit(agentRank, gPlayer, tPlayer, iAgent)
	local bChance = GetDefAgainstMoneyForgery(tPlayer)
	local agentChance = 40 + agentRank * 15 + GetEspionageAttackAction(gPlayer, tPlayer, 6)
	agentChance = agentChance + 2 * Players[gPlayer]:GetNumResourceTotal(gT.Players[tPlayer].Currencies, true);
	if bChance / agentChance > 0.9 then --min chance 10%
		gT.Players[gPlayer].Agents[iAgent].LChance = 100;
	elseif bChance / agentChance < 0.25 then --max chance 75%
		gT.Players[gPlayer].Agents[iAgent].LChance = 750;
	else
		gT.Players[gPlayer].Agents[iAgent].LChance = math.floor((agentChance - bChance) / agentChance * 1000)
	end
--	print("EspPrint Counterfeit chance", gT.Players[gPlayer].Agents[iAgent].LChance / 10, bChance, agentChance)
	ApplyMaxMinChanceEspionage(gPlayer, tPlayer, iAgent, true)
	return (LastRandom(1, 1000) > gT.Players[gPlayer].Agents[iAgent].LChance);
end

function GetLegalFromAgent(gPlayer, aid)
	local t = 2 + gT.Players[gPlayer].Agents[aid].Rank;
	if gT.Globals.TechFirstTeams[tIndoInno8] == gPlayer then
		t = t + 1;
	end
	if HasAgentSupportingOtherAgents(gPlayer) > 0 then
		t = t + 1;
	end
	return t;
end

function EstimatedLegalGrowthFromSpies(gPlayer)
	local sc = 0;
	for aid, adata in pairs(gT.Players[gPlayer].Agents) do
		if adata.Mission == 9 then
			sc = sc + GetLegalFromAgent(gPlayer, aid);
		end
	end
	return sc;
end

function EstimatedScienceSteal(gPlayer)
	local sc = 0;
	for aid, adata in pairs(gT.Players[gPlayer].Agents) do
		if adata.Mission == 1 then
			sc = sc + GetScienceStealSpy(adata.Rank, gPlayer, adata.TargetPlayer, adata.TargetCity);
		end
	end
	return sc;
end

function EstimatedFaithSectGain(gPlayer)
	local sc = 0;
	for aid, adata in pairs(gT.Players[gPlayer].Agents) do
		if adata.Mission == 8 then
			sc = sc + GetFaithGainSpy(adata.Rank, gPlayer, adata.TargetPlayer, adata.TargetCity);
		end
	end
	return sc;
end

function GetFaithGainSpy(rank, gPlayer, tPlayer, cityplotindex)
	local base = 3 + rank;
	local iCity = Map.GetPlotByIndex(cityplotindex):GetPlotCity();
	local iRel = Players[gPlayer]:GetReligionCreatedByPlayer();
	base = base + iCity:GetNumFollowers(iRel)/2
	if iCity:IsHolyCityAnyReligion() then
		base = base + 2;
	end
	base = base + HasAgentSupportingOtherAgents(gPlayer)
	return math.floor(base);
end

function GetScienceStealSpy(rank, gPlayer, tPlayer, cityplotindex)
	local base = rank;
	if gT.Globals.ScenarioType ~= 3 then
		base = base + 3;
	end
	local iCity = Map.GetPlotByIndex(cityplotindex):GetPlotCity();
	base = base + iCity:GetPopulation() / 10;
	local gScience, tScience = GetUnknownValidTechs(gPlayer, tPlayer)
	base = base + gScience / 2;
	local isupport = HasAgentSupportingOtherAgents(gPlayer);
	if isupport > 0 then
		base = base * (0.75 + 0.25 * isupport)
	end
	return math.floor(base)
end

function DoAssassination(gPlayer, tPlayer, i, gP)
--	print("Great People Pre Kill1", gP)
	gT.GreatPeople[gP].Assassinated = true;
	gT.GreatPeople[gP].AssassinatedBy = gPlayer;
	KillGreatPerson(gP, false)
	if gT.Players[tPlayer] then
		gT.Players[tPlayer].LastTimeAttackedBySpy = GetITGGameTurn();
	end
	if gT.Players[gPlayer].HasPlayerWonder[GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_31] then
		ChangeITGFaith(gPlayer, 100)
		BoostPlayerPower(gPlayer, "Assassinations", 20)
	end
	gT.Players[tPlayer].NumAssassinatedGP = gT.Players[tPlayer].NumAssassinatedGP + 1;
	if Players[gPlayer]:IsHuman() then
		local sText = GetNiceTextForEspionageLog(5, gPlayer, i, 10, tPlayer, nil, nil, gP);
		Players[gPlayer]:AddNotification(NotificationTypes.NOTIFICATION_INTRIGUE_DECEPTION, sText, "Assassination Succeed");
	end
	if Players[tPlayer]:IsHuman() then
		local sText = GetNiceTextForEspionageLog(6, tPlayer, i, 10, gPlayer, nil, nil, gP);
		Players[tPlayer]:AddNotification(NotificationTypes.NOTIFICATION_TECH_STOLEN_SPY_DETECTED, sText, GetGreatPersonName(gP) .. " assassinated");
		if Players[tPlayer]:IsDoF(gPlayer) then
			LuaEvents.ITG_AchievementCompleted(9)
		end
	end
	VictoryTaskCompletion(gPlayer, 38)
	DoLogDominationEvent(13, gPlayer, tPlayer, 10, -20, true, gP)
end

function DoTrySabotageMiscPlot(iPlayer, iPlot)
	local tPlayer = iPlot:GetOwner();
	local bMinor = Players[tPlayer]:IsMinorCiv();
	local tCity = Players[tPlayer]:GetCityByID(iPlot:GetCityPurchaseID())
	if not tCity then
		return;
	end
	if Map.PlotDistance(iPlot:GetX(), iPlot:GetY(), tCity:GetX(), tCity:GetY()) > 2 then
		return;
	end
	local bChance = 10 + gT.Players[tPlayer].DefenseFromSabotage;
	if not bMinor then
		bChance = bChance + GetPlayerBaseDefenseAgainstEspionage(tPlayer, tCity);
	end
	bChance = math.min(90, bChance);
	if LastRandom(1, 100) > bChance then
		local iBuildingType = GetValidBuildingToSabotage(tCity);
		if iBuildingType then
			tCity:SetNumRealBuilding(iBuildingType, 0)
			VictoryTaskCompletion(iPlayer, 36)
			gT.Players[tPlayer].DefenseFromSabotage = gT.Players[tPlayer].DefenseFromSabotage + 2;
			gT.Players[tPlayer].LastSabotage = GetITGGameTurn();
			DoLogDominationEvent(-1, iPlayer, tPlayer, 5, -5, true)
			if (Game.GetActivePlayer() == iPlayer) or (tPlayer == Game.GetActivePlayer()) then
				Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(tCity:GetX(), tCity:GetY()))), "[COLOR_NEGATIVE_TEXT]" .. Locale.Lookup(GameInfo.Buildings[iBuildingType].Description), 0.5)
			end
		end
	end
end

function DoSabotage(iBuildingType, gPlayer, tPlayer, i, iCity)
	iCity:SetNumRealBuilding(iBuildingType, 0)
	VictoryTaskCompletion(gPlayer, 36)
	local aPlayer = Game.GetActivePlayer();
	if gT.Players[tPlayer] then
		gT.Players[tPlayer].LastTimeAttackedBySpy = GetITGGameTurn();
	end
	BasicCSMissionCompleteFunc(gPlayer, 43, 1)
	gT.Players[tPlayer].DefenseFromSabotage = gT.Players[tPlayer].DefenseFromSabotage + 2;
	gT.Players[tPlayer].LastSabotage = GetITGGameTurn();
	if Players[gPlayer]:IsHuman() then
		local sText = GetNiceTextForEspionageLog(5, gPlayer, i, 5, tPlayer, iCity:Plot():GetPlotIndex(), iBuildingType);
		Players[gPlayer]:AddNotification(NotificationTypes.NOTIFICATION_INTRIGUE_DECEPTION, sText, "Sabotage Succeed", iCity:GetX(), iCity:GetY());
	end
	if Players[tPlayer]:IsHuman() then
		local sText = GetNiceTextForEspionageLog(6, tPlayer, i, 5, gPlayer, iCity:Plot():GetPlotIndex(), iBuildingType);
		Players[tPlayer]:AddNotification(NotificationTypes.NOTIFICATION_TECH_STOLEN_SPY_DETECTED, sText, Locale.Lookup(GameInfo.Buildings[iBuildingType].Description) .. " sabotaged", iCity:GetX(), iCity:GetY());
	end
	DoLogDominationEvent(-1, gPlayer, tPlayer, 10, -10, true)
end

function GetPlayerBaseDefenseAgainstEspionage(tPlayer, iCity, bExclude)
	local bChance = 0;
	if iCity then
		if iCity:IsHasBuilding(bConstable) then
			bChance = bChance + 15
		end
		if iCity:IsHasBuilding(bPoliceStation) then
			bChance = bChance + 15;
		end
		if iCity:IsHasBuilding(bModernPoliceStation) then
			bChance = bChance + 15;
		end
		if IsBeliefPresentInACity(iCity, GameInfoTypes.BELIEF_ITG_PANTHEON_19) then
			bChance = bChance + 15;
		end
		if gT.Players[tPlayer].HasIdeology[25] then
			local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
			if gT.Cities[cID].Happiness > 0 then
				bChance = bChance + 15;
			end
		end
--		bChance = bChance + GetCityGovTraitBonus(iCity, 5)
	else
		bChance = bChance + math.floor(15 * GetPercentageOfCitiesHavingBuilding(tPlayer, bConstable))
		bChance = bChance + math.floor(15 * GetPercentageOfCitiesHavingBuilding(tPlayer, bModernPoliceStation))
		bChance = bChance + math.floor(15 * GetPercentageOfCitiesHavingBuilding(tPlayer, bPoliceStation))
	end
	if gT.Players[tPlayer].HasIdeology[13] then
		bChance = bChance + 15;
	end
	if gT.Players[tPlayer].GovRewards[33] then
		bChance = bChance + math.max(0, gT.Players[tPlayer].Morale)
	end
	if not bExclude then
		bChance = bChance + GetBasicDefenseFromCounterIntelligence(tPlayer, nil, 15, true);
	end
	if Players[tPlayer]:IsGoldenAge() then
		if gT.Players[tPlayer].HasMinorIdeology[2] then
			bChance = bChance + 20;
		end
	end
	return math.floor(bChance)
end

function GetBasicDefenseFromCounterIntelligence(iPlayer, csPlayer, perspy, bSupport)
	local hTab = {}
	for i, data in pairs(gT.Players[iPlayer].Agents) do
		if data.Mission == 4 or (csPlayer and data.Mission == 7 and data.TargetPlayer == csPlayer) then
			table.insert(hTab, data.Rank)
		end
	end
	table.sort(hTab, SortFunctionHighestInteger)
	local counterintelligencedef = 0;
	for i, rank in pairs(hTab) do
		counterintelligencedef = counterintelligencedef + (perspy + rank * 5) *math.pow(0.75, i-1)*(1-0.1*(i-1))
	end
	if bSupport and HasAgentSupportingOtherAgents(iPlayer) then
		counterintelligencedef = math.floor(counterintelligencedef * 1.2)
	end
	if gT.Globals.TechFirstTeams[tIndoInno8] == iPlayer then
		counterintelligencedef = math.floor(counterintelligencedef * 1.2);
	end
	return math.floor(counterintelligencedef);
end

function DetermineIfShouldBeKilledCoup(agentRank, gPlayer, tPlayer, iAgent)
	local ally = Players[tPlayer]:GetAlly();
	local agentChance = 15 + agentRank * 5; -- very base chance is 20/25/30%
	local iSupport = HasAgentSupportingOtherAgents(gPlayer);
	if iSupport > 0 then
		agentChance = agentChance + 4 + iSupport * 2;
	end
	local bChance = 100;
	if ally ~= -1 then
		if ally ~= gPlayer then
			bChance = bChance + 25 + GetBasicDefenseFromCounterIntelligence(ally, tPlayer, 15);
			if not Teams[Players[gPlayer]:GetTeam()]:HasEmbassyAtTeam(Players[ally]:GetTeam()) then
				bChance = bChance + 5;
			end
		end
	end
	for aID, data in pairs(gT.Players[tPlayer].RivalSpiesActive) do
		if data[1] ~= gPlayer and data[1] ~= ally then
			if data[3] == 7 then
				local hPlayer = data[1];
				local bChance = 10 + GetBasicDefenseFromCounterIntelligence(hPlayer, tPlayer, 15);
				if not Teams[Players[gPlayer]:GetTeam()]:HasEmbassyAtTeam(Players[hPlayer]:GetTeam()) then
					bChance = bChance + 5;
				end
			end
		end
	end
--NOTE COUP IS NOT BOOSTED BY MANY MAJOR vs MAJOR espionage attack boosts
	if bChance / agentChance > 0.92 then --min chance 8%
		gT.Players[gPlayer].Agents[iAgent].LChance = 80;
	elseif bChance / agentChance < 0.5 then --max chance 50%
		gT.Players[gPlayer].Agents[iAgent].LChance = 500;
	else
		gT.Players[gPlayer].Agents[iAgent].LChance = math.floor((agentChance - bChance) / agentChance * 1000)
	end
--	print("EspPrint Coup chance", gT.Players[gPlayer].Agents[iAgent].LChance / 10, bChance, agentChance)
	ApplyMaxMinChanceEspionage(gPlayer, tPlayer, iAgent, true)
	return (LastRandom(1, 1000) > gT.Players[gPlayer].Agents[iAgent].LChance);
end

function DoCoup(gPlayer, tPlayer, iAgent)
	local percentageloss = LastRandom(50, 100);
	local t = 0;
	local tLossTab = {}
	for g, p in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			local infl = Players[tPlayer]:GetMinorCivFriendshipWithMajor(g);
			if g == gPlayer then
				if infl < AFTER_COUP_INFLUENCE then
					if not Teams[Players[g]:GetTeam()]:IsAtWar(Players[tPlayer]:GetTeam()) then
						Players[tPlayer]:ChangeMinorCivFriendshipWithMajor(g, AFTER_COUP_INFLUENCE - infl)
					end
				end
			else
				if infl > 0 then
					local infloss = math.floor(infl * percentageloss / 100);
					if infloss > 0 then
						t = t + infloss;
						table.insert(tLossTab, {g, infloss})
						if Players[g]:IsHuman() then
							if g ~= gPlayer then
								Players[g]:AddNotification(NotificationTypes.NOTIFICATION_TECH_STOLEN_SPY_DETECTED, "Due to recent Coup in " .. Players[tPlayer]:GetName() .. " we lost " .. infloss .. " [ICON_INFLUENCE] Influence!", "Coup in " .. Players[tPlayer]:GetName());
							end
						end
					end
				end
			end
		end
	end
	table.sort(tLossTab, SortFunctionForLowestMapDistance)
	for i, data in pairs(tLossTab) do
		Players[tPlayer]:ChangeMinorCivFriendshipWithMajor(data[1], -data[2])
	end
	if gT.Players[tPlayer].GovAsLeader then
		GovernorWasRemovedFromCSLeadership(gT.Players[tPlayer].GovAsLeader, gPlayer)	
	end
	gT.Players[tPlayer].CoupDone = {gPlayer, GetITGGameTurn()};
	DoRecheckSpiesActive(tPlayer) -- no more coups
	if Players[gPlayer]:IsHuman() then
		local sText = GetNiceTextForEspionageLog(5, gPlayer, iAgent, 12, tPlayer, nil);
		sText = sText .. "[NEWLINE][NEWLINE]In the result all major players lost " .. t .. " [ICON_INFLUENCE] Influence combined.";
		Players[gPlayer]:AddNotification(NotificationTypes.NOTIFICATION_INTRIGUE_DECEPTION, sText, "Coup Succeed");
	end
	VictoryTaskCompletion(gPlayer, 40)
end

--demographics
function EndWonderRaceDoWonderDemoMin()
	for g, h in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			gT.Players[g].DemographicsWonderMin = {}
			local gTeam = Players[g]:GetTeam()
			for j, d in pairs(gT.Players) do
				if g ~= j and (not Players[j]:IsMinorCiv()) then
					if Teams[gTeam]:IsHasMet(Players[j]:GetTeam()) then
						gT.Players[g].DemographicsWonderMin[j] = d.WonderProduction;
					end
				end
			end
		end
	end
end

function GetWonderPointsDemographics(iPlayer, g, bHasIntel, bIgnoreCheck, selfID)
	local base = gT.Players[g].WonderProduction;
	if iPlayer ~= g then
		base = math.floor(base * (100 + Players[iPlayer]:GetDemographicMargin(selfID, g)) / 100)
		if gT.Players[iPlayer].DemographicsWonderMin[g] then
			base = math.max(base, gT.Players[iPlayer].DemographicsWonderMin[g])
		end
	end
	return base;
end

function BasicMarginChangeTurn(iPlayer, selfID)
	local mgeT = DemographicsData[selfID].BaseMargins;
	local mgTa = DemographicsData[selfID].IntelMargins;
	local iMarginChange = DemographicsData[selfID].MarginChange;
	local maxM;
	if HasAgentGatheringIntel(iPlayer) > 0 then
		maxM = mgTa[gT.Globals.ScenarioType];
	else
		maxM = mgeT[gT.Globals.ScenarioType];
	end
	for g, p in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			local newValue = Players[iPlayer]:GetDemographicMargin(selfID, g) + LastRandom(-iMarginChange, iMarginChange)
			newValue = math.max(newValue, -maxM)
			newValue = math.min(newValue, maxM)
			Players[iPlayer]:SetDemographicMargin(selfID, g, newValue)
		end
	end
end

function GetDemographicsDataProper(iPlayer, g, bHasIntel, type)
	local selfID = ITG_EspDemoTypes[type];
	return DemographicsData[selfID].FuncDemo(iPlayer, g, bHasIntel, false, selfID);
end

function DemographicsFuncBasicPopulate(iPlayer, bHasIntel, selfID)
	DoDemographicsOnNewTurnIfNeeded(iPlayer)
	local tab = {}
	local pTeam = Teams[Players[iPlayer]:GetTeam()];
	for g, h in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			if Players[g]:IsAlive() then
				if pTeam:IsHasMet(Players[g]:GetTeam()) then
					if (not DemographicsData[selfID].CanHaveDemo) or DemographicsData[selfID].CanHaveDemo(g) then
						local xval, xval2 = DemographicsData[selfID].FuncDemo(iPlayer, g, bHasIntel, true, selfID);
						table.insert(tab, {GetPlayerNiceCivName(g), xval, g, xval, xval2 or "", Locale.Lookup(DemographicsData[selfID].Help1), Locale.Lookup(DemographicsData[selfID].Help2)})
					end
				end
			end
		end
	end
	table.sort(tab, SortFunctionForGreaterInteger2)
	return tab;
end

function GetGoldDemographics(iPlayer, tPlayer)
	return Players[tPlayer]:GetGold(), GetRealCalculateGoldRate(tPlayer, true);
end

function GetAgentsDemographics(iPlayer, tPlayer)
	local t, c = 0, 0;
	for agentID, data in pairs(gT.Players[tPlayer].Agents) do
		if (not data.IgnoreItForever) then
			t = t + 1;
			if data.IsAlive and (data.Mission == 4) then
				c = c + 1; 
			end
		end
	end
	return t, c;
end

function GetNatUnityDemographics(iPlayer, g)
	local base = gT.Players[g].NatUnity;
	if iPlayer ~= g then
		base = math.floor(100 * base * (100 + Players[iPlayer]:GetDemographicMargin(ITG_EspDemoTypes["ITG_ESP_DEM_NAT_UNITY"], g)) / 100) / 100
	end
	return math.min(100, base);
end

function GetNumKnownTechsDemographics(iPlayer, g, bHasIntel, bIgnoreCheck, selfID)
	if not bIgnoreCheck then
		DoDemographicsOnNewTurnIfNeeded(iPlayer)
	end
	local tech, inno = 0, 0;
	local gTeam = Teams[Players[g]:GetTeam()];
	for row in GameInfo.Technologies() do
		if row.Show then
			if gTeam:IsHasTech(row.ID) then			
				if row.IsInnovation then
					inno = inno + 1;	
				elseif row.Era and gT.Globals.GoodEras[row.Era] then
					tech = tech + 1;
				end
			end
		end 
	end
	if iPlayer ~= g then
		tech = math.max(0, tech + Players[iPlayer]:GetDemographicMargin(selfID, g))
		if not bHasIntel then
			inno = "N/A"
		end
	end
	return tech, inno;
end

function GetDemographicsLegalPower(iPlayer, g, bHasIntel, bIgnoreCheck, selfID)
	local lStored = gT.Players[g].LegalPower
	local lpt = GetLegalPointsPerTurn(g, true)
	if iPlayer ~= g then
		if not Players[iPlayer]:IsDoF(g) then
			lStored = math.floor(lStored * (100 + Players[iPlayer]:GetDemographicMargin(selfID, g)) / 100)
			lpt = math.floor(lpt * (100 + Players[iPlayer]:GetDemographicMargin(selfID, g)) / 100) / 100
		end
	else
		lpt = lpt / 100;
	end
	return lStored, lpt;
end

function GetMilitaryMightDemographics(iPlayer, g, bIgnoreCheck) -- used by various funcs!
	if Players[iPlayer]:IsMinorCiv() then
		return GetWeirldyCountedMilitaryMight(g);
	end
	if not bIgnoreCheck then
		DoDemographicsOnNewTurnIfNeeded(iPlayer)
	end
	local base = GetWeirldyCountedMilitaryMight(g)
	if iPlayer ~= g then
		if g ~= 63 and (not Players[g]:IsMinorCiv()) then
			base = math.floor(base * (100 + Players[iPlayer]:GetDemographicMargin(ITG_EspDemoTypes["ITG_ESP_DEM_SOLDIERS"], g)) / 100)
		end
	end
	return base;
end

function GetNumProductionDemographics(iPlayer, g, bHasIntel, bIgnoreCheck, selfID)
	if not bIgnoreCheck then
		DoDemographicsOnNewTurnIfNeeded(iPlayer)
	end
	local total, max = Players[g]:CalculateTotalYield(yProduction), 0;
	for iCity in Players[g]:Cities() do
		max = math.max(max, iCity:GetYieldRateTimes100(yProduction) / 100)
	end
	if iPlayer ~= g then
		total = math.floor(total * (100 + Players[iPlayer]:GetDemographicMargin(selfID, g)) / 100)
		max = math.min(total, max)
		if not bHasIntel then
			max = "N/A"
		end
	end
	return total, max;
end
function GetNumLandDemographics(iPlayer, g, bHasIntel)
	local numPlot = 0;
	local iTeam = Players[iPlayer]:GetTeam()
	for i = 0, Map:GetNumPlots() - 1, 1 do
		local fPlot = Map.GetPlotByIndex( i );
		if fPlot:GetOwner() == g then
			if bHasIntel or fPlot:IsRevealed(iTeam) then
				numPlot = numPlot + 1;
			end
		end
	end
	return numPlot;
end

function GetNumPopulationDemographics(iPlayer, g, bHasIntel)
	local pop, cities = 0, 0;
	local iTeam = Players[iPlayer]:GetTeam()
	for iCity in Players[g]:Cities() do
		if bHasIntel or iCity:Plot():IsRevealed(iTeam) then
			cities = cities + 1;
			pop = pop + iCity:GetPopulation();
		end
	end
	return pop, cities;
end

function CanHaveDemoWonderPoints(g)
	if gT.Players[g].CanWonderRace then
		return true;
	end
	return false;
end

function CanHaveDemoCodex(g)
	if gT.Players[g].HasCodex then
		return true;
	end
	return false;
end	

function GetMeritocracyDemographics(iPlayer, g, bHasIntel, bIgnoreCheck, selfID)
	local eval1 = gT.Players[g].MeritocracyLevel
	local eval2 = GetNumActiveGovernors(g)
	if iPlayer ~= g then
		eval1 = math.floor(eval1 * (100 + Players[iPlayer]:GetDemographicMargin(selfID, g)) / 100)
		eval1 = math.max(0, math.min(100, eval1))
	end
	return eval1, eval2;
end

function GetCodexDemographics(iPlayer, g, bHasIntel, bIgnoreCheck, selfID)
	local eval1 = gT.Players[g].CodexStrength;
	local eval2 = GetCodexInfluence100(g)
	if iPlayer ~= g then
		local iMargin = Players[iPlayer]:GetDemographicMargin(selfID, g);
		eval1 = math.max(0, math.min(100, math.floor(eval1 * (100 + iMargin) / 100)))
		eval2 = math.max(100, math.floor(eval2 * (100 + iMargin) / 100))
	end
	return eval1, eval2;
end

function GetGPDemographics(iPlayer, g, bHasIntel, bIgnoreCheck, selfID)
	local eval1 = GetNumOfGPCivilOfType(g)
	local eval2 = GetNumOfGPCivilOfType(g, 1) + GetNumOfGPCivilOfType(g, 2)
	if iPlayer ~= g then
		eval1 = eval1 + Players[iPlayer]:GetDemographicMargin(selfID, g)
		eval1 = math.max(GetNumOfGPCivilOfType(g, 5), eval1)
	end
	return eval1, eval2;
end

for row in DB.Query("SELECT * FROM ITG_EspionageDemographics") do
	DemographicsData[row.ID] = {BaseMargins = {}, IntelMargins = {}}
	for a, b in pairs(row) do
		DemographicsData[row.ID][a] = b;
	end
end
for row in DB.Query("SELECT * FROM ITG_EspDemScenarioMargins") do
	DemographicsData[ITG_EspDemoTypes[row.EspDemType]].BaseMargins[ITG_ScenariosTypes[row.ScenarioType]] = row.Base;
	DemographicsData[ITG_EspDemoTypes[row.EspDemType]].IntelMargins[ITG_ScenariosTypes[row.ScenarioType]] = row.Intel
end
DemographicsData[ITG_EspDemoTypes["ITG_ESP_DEM_GREAT_PEOPLE"]].FuncDemo = GetGPDemographics;
DemographicsData[ITG_EspDemoTypes["ITG_ESP_DEM_POPULATION"]].FuncDemo = GetNumPopulationDemographics;
DemographicsData[ITG_EspDemoTypes["ITG_ESP_DEM_PRODUCTION"]].FuncDemo = GetNumProductionDemographics;
DemographicsData[ITG_EspDemoTypes["ITG_ESP_DEM_LAND"]].FuncDemo = GetNumLandDemographics;
DemographicsData[ITG_EspDemoTypes["ITG_ESP_DEM_LITERACY"]].FuncDemo = GetNumKnownTechsDemographics;
DemographicsData[ITG_EspDemoTypes["ITG_ESP_DEM_SOLDIERS"]].FuncDemo = GetMilitaryMightDemographics;
DemographicsData[ITG_EspDemoTypes["ITG_ESP_DEM_WONDER"]].FuncDemo = GetWonderPointsDemographics;
DemographicsData[ITG_EspDemoTypes["ITG_ESP_DEM_NAT_UNITY"]].FuncDemo = GetNatUnityDemographics;
DemographicsData[ITG_EspDemoTypes["ITG_ESP_DEM_AGENTS"]].FuncDemo = GetAgentsDemographics;
DemographicsData[ITG_EspDemoTypes["ITG_ESP_DEM_LEGAL"]].FuncDemo = GetDemographicsLegalPower;
DemographicsData[ITG_EspDemoTypes["ITG_ESP_DEM_GOLD"]].FuncDemo = GetGoldDemographics;
DemographicsData[ITG_EspDemoTypes["ITG_ESP_DEM_MERITOCRACY"]].FuncDemo = GetMeritocracyDemographics;
DemographicsData[ITG_EspDemoTypes["ITG_ESP_DEM_CODEX"]].FuncDemo = GetCodexDemographics;
DemographicsData[ITG_EspDemoTypes["ITG_ESP_DEM_WONDER"]].CanHaveDemo = CanHaveDemoWonderPoints;
DemographicsData[ITG_EspDemoTypes["ITG_ESP_DEM_CODEX"]].CanHaveDemo = CanHaveDemoCodex;

LuaEvents.ITGSG_RequestDemographicsPopulate.Add(function(iPlayer, cSelectedList)
	MapModData.ITGSG = {Val1Text = Locale.Lookup(DemographicsData[cSelectedList].Headline1), Val2Text = Locale.Lookup(DemographicsData[cSelectedList].Headline2), List =  DemographicsFuncBasicPopulate(iPlayer, (HasAgentGatheringIntel(iPlayer) > 0), cSelectedList) }
end)

LuaEvents.ITGSG_RequestDemographicsCulturalGroup.Add(function(iPlayer)
	local tab = {};
	if gT.Players[iPlayer] then
		DoDemographicsOnNewTurnIfNeeded(iPlayer)
		local bHasIntel = (HasAgentGatheringIntel(iPlayer) > 0)
		local bShow, bDisabled, sTooltip = DemographicsFuncList(iPlayer, bHasIntel, 7)
		local cGroup = gT.Players[iPlayer].CultGroup;
		for g, h in pairs(gT.Players) do
			if h.CultGroup == cGroup then
				if g == iPlayer then
					table.insert(tab, {iPlayer, GetNatUnityDemographics(iPlayer, g)})
				else
					if (bShow) and (not bDisabled) then
						if Teams[Players[g]:GetTeam()]:IsHasMet(Players[iPlayer]:GetTeam()) then
							table.insert(tab, {g, GetNatUnityDemographics(iPlayer, g)})
						else
							table.insert(tab, {-1, GetNatUnityDemographics(iPlayer, g)})
						end
					else
						if Teams[Players[g]:GetTeam()]:IsHasMet(Players[iPlayer]:GetTeam()) then
							table.insert(tab, {g, "?"})
						else
							table.insert(tab, {-1, "?"})
						end
					end
				end
			end
		end
	end
	MapModData.ITGSG = tab;
end)

function DemographicsFuncList(iPlayer, bHasIntel, selfID)
	local bShow, bDisabled, sTooltip = true, false, "";
	if DemographicsData[selfID].RequireIntel and (not bHasIntel) then
		bDisabled = true;
	end
	if DemographicsData[selfID].MarginChange then
		local mgeT = DemographicsData[selfID].BaseMargins;
		local mgTa = DemographicsData[selfID].IntelMargins;
		local aV = mgTa[gT.Globals.ScenarioType];
		local bV = mgeT[gT.Globals.ScenarioType];
		if bHasIntel and DemographicsData[selfID].ListHelpIntel then
			sTooltip = Locale.ConvertTextKey(DemographicsData[selfID].ListHelpIntel, aV, bV);
		else
			sTooltip = Locale.ConvertTextKey(DemographicsData[selfID].ListHelpBase, aV, bV);
		end
	else
		if bHasIntel and DemographicsData[selfID].ListHelpIntel then
			sTooltip = Locale.Lookup(DemographicsData[selfID].ListHelpIntel);
		else
			sTooltip = Locale.Lookup(DemographicsData[selfID].ListHelpBase);
		end
	end
	return bShow, bDisabled, sTooltip;
end

function GetListOfDemographicsOptions(iPlayer)
	local hTab = {}
	local bHasIntel = (HasAgentGatheringIntel(iPlayer) > 0)
	for i, data in pairs(DemographicsData) do
		local bShow, bDisabled, sTooltip = DemographicsFuncList(iPlayer, bHasIntel, i)
		if bShow then
			table.insert(hTab, {data.ID, Locale.Lookup(data.Description), bDisabled, sTooltip})
		end
	end
	MapModData.ITGSG = hTab;
end
LuaEvents.ITGSG_RequestDemographicsList.Add(GetListOfDemographicsOptions)

function GetWeirldyCountedMilitaryMight(g)
	return math.floor(math.sqrt( Players[g]:GetMilitaryMight() ) * 2000)
end

function DoDemographicsOnNewTurnIfNeeded(iPlayer)
	if gT.Players[iPlayer].DemographicsTurn ~= GetITGGameTurn() then
		for i, j in pairs(DemographicsData) do
			if j.MarginChange then
				BasicMarginChangeTurn(iPlayer, i)
			end
		end
		gT.Players[iPlayer].DemographicsTurn = GetITGGameTurn();
	end
end

function DoEspionageTakeOver(gPlayer, tPlayer, iAgent)
	for i, data in pairs(gT.Players[tPlayer].Agents) do
		if (not data.IgnoreItForever) then
			if not data.Rekonwalescencja then
				KillTheAgent(tPlayer, i)
			else
				gT.Players[tPlayer].Agents[i].Rekonwalescencja = math.max(gT.Players[tPlayer].Agents[i].Rekonwalescencja, GetTurnOfRekonwalesencja(tPlayer, i))
			end
		end
	end
	if gT.Players[tPlayer] then
		gT.Players[tPlayer].LastTimeAttackedBySpy = GetITGGameTurn();
	else
		print("How 134d34324?")
	end
	if Players[gPlayer]:IsHuman() then
		local sText = GetNiceTextForEspionageLog(5, gPlayer, iAgent, 14, tPlayer, nil);
		Players[gPlayer]:AddNotification(NotificationTypes.NOTIFICATION_INTRIGUE_DECEPTION, sText, "Takeover Succeed");
	end
	if Players[tPlayer]:IsHuman() then
		local sText = GetNiceTextForEspionageLog(6, tPlayer, iAgent, 14, gPlayer, nil);
		Players[tPlayer]:AddNotification(NotificationTypes.NOTIFICATION_TECH_STOLEN_SPY_DETECTED, sText, "Hostile takeover!");
	end
	DoLogDominationEvent(14, gPlayer, tPlayer, 25, -50, true)
end

function CallLogSimplySpyActionBig(g, str)
	table.insert(gT.Players[g].SpyActionsBig, str)
	VictoryTaskCompletion(g, 37)
end

function HaveNotTurnedEspionageAround(gPlayer, iAgent)
	if gT.Players[gPlayer].HasIdeology[49] then
		if gT.Players[gPlayer].GreatPeoplePoints >= 300 then
			ChangeITGGreatPeopleCivilPoints(gPlayer, -300);
			gT.Players[gPlayer].Agents[iAgent].LChance = nil;
			gT.Players[gPlayer].Agents[iAgent].LturnedAround = "Academic Network";
			return false;
		end
		for index, sth in pairs(gT.Academies) do
			if (sth.Rank) and (sth.Rank <= 3) and (sth.Player == gPlayer) then
				AddPrestigeToAcademy(index, -100, "Academic Network")
				gT.Players[gPlayer].Agents[iAgent].LChance = nil;
				gT.Players[gPlayer].Agents[iAgent].LturnedAround = "Academic Network";
				return false;
			end
		end
	end
	if HasPlayerTech(gPlayer, GameInfoTypes.TECH_UNIQUE_ITG_MODERN_29, "Frkofkeof") then
		if LastChance(5) then
			gT.Players[gPlayer].Agents[iAgent].LChance = nil;
			gT.Players[gPlayer].Agents[iAgent].LturnedAround = "Lucky Shot";
			return false;
		end
	end
	return true;
end

function HasPlayerGPOfPlayer(tPlayer, gPlayer)
	for gpID, sth in pairs(gT.Players[tPlayer].GreatPeople) do
		if gT.GreatPeople[gpID].Alive and (gT.GreatPeople[gpID].OriginPlayer == gPlayer) then
			return true;
		end
	end
	return false;
end

function InitDemographicsMargins(iPlayer)
	for g, h in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			for j, data in pairs(DemographicsData) do
				if data.MarginChange then
					Players[iPlayer]:GetDemographicMargin(j, g, LastRandom(-data.MarginChange, data.MarginChange))
				end
			end
		end
	end
end

LuaEvents.ITGDialogWarInfo.Add(function(tPlayer, aPlayer)
	local iPlayer = Game.GetActivePlayer();
	local tab = {};
	if Players[iPlayer]:IsDoF(tPlayer) then
		table.insert(tab, {"[COLOR_POSITIVE_TEXT]They are your friends!","Declaring war on them will break an alliance and make us untrustworthy in eyes of other leaders."})
		table.insert(tab, {" ",""})
	end
	if Players[tPlayer]:IsMadeMilitaryPromiseFrom(iPlayer) then
		table.insert(tab, {"[COLOR_YELLOW]We promised to leave them alone!","Declaring war on them will break our promise."})
		table.insert(tab, {" ",""})
	end
	local bFirstDef = true;
	local myTeam = Teams[Players[iPlayer]:GetTeam()];
	local pAITeam = Teams[Players[tPlayer]:GetTeam()];
	for g, h in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			if (g ~= iPlayer) and (g ~= aPlayer) then
				local gTeam = Players[g]:GetTeam();
				if pAITeam:IsDefensivePact(gTeam) then
					if myTeam:IsHasMet(gTeam) then
						if bFirstDef then 
							bFirstDef = false;
							table.insert(tab, {"DEFENSIVE PACTS","Declaring war will result in greater conflict."})
						end
						if myTeam:IsAtWar(gTeam) then
							table.insert(tab, {"[ICON_STRENGTH][ICON_WAR] " .. Players[g]:GetCivilizationShortDescription(), "We are already at war with them."})
						else
							table.insert(tab, {"[ICON_STRENGTH] " .. Players[g]:GetCivilizationShortDescription()})
						end
					end
				end
			end
		end
	end
	if not bFirstDef then
		table.insert(tab, {" ",""})
	end
	local numAllied = 0;
	local alliedToolTip = "They are allies of:";
	for g, h in pairs(gT.Players) do
		if Players[g]:IsMinorCiv() then
			if Players[g]:GetAlly() == tPlayer then
				local gTeam = Players[g]:GetTeam();
				if myTeam:IsHasMet(gTeam) then
					numAllied = numAllied + 1;
					if Players[g]:IsProtectedByMajor(iPlayer) and (not pAITeam:IsDefensivePact(gTeam)) then
						alliedToolTip = alliedToolTip .. "[NEWLINE][ICON_BULLET]" .. Players[g]:GetName() .. " (our protectorate will not declare war on us)";
					elseif myTeam:IsAtWar(gTeam) then
						alliedToolTip = alliedToolTip .. "[NEWLINE][ICON_BULLET]" .. Players[g]:GetName() .. " (we are at war)";
					else
						alliedToolTip = alliedToolTip .. "[NEWLINE][ICON_BULLET]" .. Players[g]:GetName();
					end
				end
			end
		end
	end
	if numAllied > 0 then
		table.insert(tab, {numAllied .. " allied [ICON_CITY_STATE] City-State(s).",alliedToolTip})
		table.insert(tab, {" ",""})
	end
	table.insert(tab, {"DEMOGRAPHICS","Based on your currently available intelligence."})

	local tdemCities, tdemSoldier, tdemPopulation, tdemProduction, tdemTech = "", "", "", "", "";
	local bHasIntel = (HasAgentGatheringIntel(iPlayer) > 0)
	local iPop, iCities = GetDemographicsDataProper(iPlayer, iPlayer, bHasIntel, "ITG_ESP_DEM_POPULATION")
	local tPop, tCities = GetDemographicsDataProper(iPlayer, tPlayer, bHasIntel, "ITG_ESP_DEM_POPULATION")
	local iTech, iInno = GetDemographicsDataProper(iPlayer, iPlayer, bHasIntel, "ITG_ESP_DEM_LITERACY")
	local tTech, tInno = GetDemographicsDataProper(iPlayer, tPlayer, bHasIntel, "ITG_ESP_DEM_LITERACY")
	local iProd, iProdBest = GetDemographicsDataProper(iPlayer, iPlayer, bHasIntel, "ITG_ESP_DEM_PRODUCTION")
	local tProd, tProdBest = GetDemographicsDataProper(iPlayer, tPlayer, bHasIntel, "ITG_ESP_DEM_PRODUCTION")
	
	tdemSoldier = "[ICON_BULLET]Our military strength: " .. GetDemographicsDataProper(iPlayer, iPlayer, bHasIntel, "ITG_ESP_DEM_SOLDIERS") .. "."; 
	tdemCities = "[ICON_BULLET]Our number of cities: " .. iCities .. "."; 
	tdemPopulation = "[ICON_BULLET]Our population: " .. iPop .. " [ICON_CITIZEN]";
	tdemTech = "[ICON_BULLET]We have discovered " .. iTech .. " technologies."
	tdemProduction = "[ICON_BULLET]Our cities generate " .. iProd .. " [ICON_PRODUCTION] Production per turn."
	if aPlayer then
		local aAdj = Players[aPlayer]:GetCivilizationAdjective();
		local aName = Players[aPlayer]:GetCivilizationShortDescription();
		local aPop, aCities = GetDemographicsDataProper(iPlayer, aPlayer, bHasIntel, "ITG_ESP_DEM_POPULATION")
		local aTech, aInno = GetDemographicsDataProper(iPlayer, aPlayer, bHasIntel, "ITG_ESP_DEM_LITERACY")
		local aProd, aProdBest = GetDemographicsDataProper(iPlayer, aPlayer, bHasIntel, "ITG_ESP_DEM_PRODUCTION")
		tdemSoldier = tdemSoldier .. "[NEWLINE][ICON_BULLET]" .. aAdj .. " military strength: " .. GetDemographicsDataProper(iPlayer, aPlayer, bHasIntel, "ITG_ESP_DEM_SOLDIERS") .. "."; 
		tdemCities = tdemCities .. "[NEWLINE][ICON_BULLET]" .. aAdj .. " number of cities: " .. aCities .. "."; 
		tdemPopulation = tdemPopulation .. "[NEWLINE][ICON_BULLET]" .. aAdj .. " population: " .. aPop  .. " [ICON_CITIZEN]"; 
		tdemTech = tdemTech .. "[NEWLINE][ICON_BULLET]" .. aName .. " has discovered " .. aTech .. " technologies."
		tdemProduction = tdemProduction .. "[NEWLINE][ICON_BULLET]" .. aAdj .. " cities generate " .. aProd .. " [ICON_PRODUCTION] Production per turn."
	end
	table.insert(tab, {"Soldiers: " .. GetDemographicsDataProper(iPlayer, tPlayer, bHasIntel, "ITG_ESP_DEM_SOLDIERS"),tdemSoldier})
	table.insert(tab, {"Cities: " .. tCities,tdemCities})
	table.insert(tab, {"Population: " .. tPop .. " [ICON_CITIZEN]",tdemPopulation})
	table.insert(tab, {"Production: " .. tProd .. " [ICON_PRODUCTION]",tdemProduction})
	table.insert(tab, {"Technologies: " .. tTech,tdemTech})
	MapModData.ITGSG = tab;
end)