local festivalbonusestable;
local cirmax = GameInfoTypes.BUILDINGCLASS_CIRCUS_MAXIMUS
local horsebackT = GameInfoTypes.TECH_HORSEBACK_RIDING;
local bITGfound19 =  GameInfoTypes.BELIEF_ITG_FOUNDER_19;
local itgfestivalwonder1 = GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_44
local techAncemp17 = GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_EMPIRE_17;
local ancCS24 = GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_24;
local nwinnomeso4 = GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_MESOAMERICAN_4
local innoindu5 = GameInfoTypes.TECH_UNIQUE_ITG_INDUSTRIAL_5;
local innoViking8 = GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_VIKING_8;
local ancientTribe10 = GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_TRIBE_10;
local fNotreDame = GameInfoTypes.BUILDING_ITG_NEW_WORLD_WONDER_3;
local asia2trial = GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_ASIA_2;
local ResetFestivalChance = {"CHFestChance", "WLTKChance", "LastFestivalTA", "FestivalVarious", "UlamaChanceFestival", "FestivalTriumph", "FairFestival", "MedievalFairFestival"}
local g_CultureFestivalRewards;

function InitDBCultureFestivalRewards()
	g_CultureFestivalRewards = {};
	for row in DB.Query("SELECT * FROM ITG_CultureFestivalRewards") do
		if not g_CultureFestivalRewards[row.CultureType] then
			g_CultureFestivalRewards[row.CultureType] = {}
		end
		g_CultureFestivalRewards[row.CultureType][row.Type] = row.Value;
	end
end

function GetPlayerFestivalOptions(iPlayer)
	if gT.Players[iPlayer].SubcultureType then
		if g_CultureFestivalRewards[ITG_SubcultureData[gT.Players[iPlayer].SubcultureType].Type] then
			return g_CultureFestivalRewards[ITG_SubcultureData[gT.Players[iPlayer].SubcultureType].Type]
		end
	end
	if g_CultureFestivalRewards[ITG_CultureData[gT.Players[iPlayer].CultureType].Type] then
		return g_CultureFestivalRewards[ITG_CultureData[gT.Players[iPlayer].CultureType].Type];
	end
	return {}
end

function OnInitialAssignFestivals(hMajorTab)
	for i, player in pairs(hMajorTab) do
		if Teams[Players[player]:GetTeam()]:IsHasTech(horsebackT) then
			if LastRandom(1,100) <= 25 then
				local iCity = GetBestCityForMint(player)
				local bCircus = Players[player]:GetPlayerUniqueBuilding(cirmax)
				iCity:SetNumRealBuilding(bCircus, 1)
			end
		end
	end
end

function ChangeITGFestivalPoints(iPlayer, amount)
	gT.Players[iPlayer].FestivalPoints = gT.Players[iPlayer].FestivalPoints + amount
	if iPlayer == Game.GetActivePlayer() then
		Events.OpenInfoCorner()
	end
end

function HighlightProperPlotsForFestivaAction(iPlayer)
	MapModData.ITGSG = GetPlotsValidForFestival(iPlayer)
end

function GetPlotsValidForFestival(iPlayer)
	local hTab = {}
	for iCity in Players[iPlayer]:Cities() do
		if IsValidForFestival(iPlayer, iCity) then
			table.insert(hTab, iCity:Plot())
		end		
	end
	return hTab;
end

function IsValidForFestival(iPlayer, iCity)
	if iCity:GetDamage() == 0 then	
		if (not iCity:IsResistance()) and (not iCity:IsPlague()) then
			if (not iCity:CanRangeStrikeNow()) then
				if (not iCity:HasPerformedRangedStrikeThisTurn()) then
					local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
					if not gT.Cities[cID].FestivalET then
						if not gT.Cities[cID].FestivalCD then
							return true;
						end
					end
				end
			end
		end
	end
	return false;
end

function GetChanceFestivalPointsHap(iPlayer)
	return math.max(0, gT.Players[iPlayer].AverageHappiness)
end

function GetChanceFromReligion(iPlayer)
	local base = 0;
	if IsPlayerHaveBelief(iPlayer, bITGfound19) then
		base = base + Game.GetNumCitiesFollowing(Players[iPlayer]:GetReligionCreatedByPlayer()) * gT.Players[iPlayer].FounderBeliefModifier;
	end	
	return base;
end

function GetChanceFestivalFromOccupied(iPlayer)
	local base = 0;
	for iCity in Players[iPlayer]:Cities() do
		if iCity:IsOccupied() then
			base = base - 1;
		end
	end
	return base;
end

local IsValidFFCP = {
[6] = 1, [7] = 1, [8] = 1
}

function GetChanceFestivalTriumph(iPlayer)
	return gT.Players[iPlayer].FestivalTriumph;
end

function GetChanceFestivalIdeology(iPlayer)
	local t = 0;
	if gT.Players[iPlayer].HasIdeology[67] then
		t = t + math.floor(20 * gT.Players[iPlayer].HapComparisionMod);
	end
	if gT.Players[iPlayer].GovRewards[32] then
		t = t + 2 * gT.Players[iPlayer].Ideologies.F;
	end
	if gT.Players[iPlayer].HasIdeology[1] then
		for g, h in pairs(gT.Players) do
			if (h.Goverment == 1) and (g ~= iPlayer) and (not Players[g]:IsMinorCiv()) and (Players[g]:IsAlive()) then
				t = t + 15;
			end
		end
	end
	return t;
end

function GetChanceFestivalFromWonderRuins(iPlayer)
	return 2 * (gT.Players[iPlayer].WonderRuinsEffects[13] or 0)
end

function GetChanceFestivalGoldenAge(iPlayer)
	local t = 0;
	if Players[iPlayer]:IsGoldenAge() then
		if gT.Players[iPlayer].HasMinorIdeology[7] then
			t = t + 10;
		end
	end
	return t;
end

function GetChanceFestivalFromArtists(iPlayer)
	local base = 0;
	for gpID, hhh in pairs(gT.Players[iPlayer].GreatPeople) do
		local gpData = gT.GreatPeople[gpID];
		if gpData.Alive then
			if IsValidFFCP[gpData.Type] then
				base = base + 1;
			end
		end
	end
	return base;
end

function GetChanceFestivalFromNationalDay(iPlayer)
	return gT.Players[iPlayer].NationalDays * 5;
end

function GetChanceForFestivalFromColosseums(iPlayer)
	local b = 0;
	if HasPlayerTech(iPlayer, techAncemp17, "v,verre") then
		b = b + Players[iPlayer]:GetBuildingClassCount(GameInfoTypes.BUILDINGCLASS_COLOSSEUM)
	end
	return b;
end

function GetChanceForFestivalFromTemplarBuildings(iPlayer)
	if IsHasLaw(iPlayer, 22, 3) then	
		return -1 * GetNumPlayerTemplarBuildings(iPlayer);
	end
	return 0;
end

function GetChanceForFestivalFromUlama(iPlayer)
	return gT.Players[iPlayer].UlamaChanceFestival;
end

function GetChanceForFestivalFromMF(iPlayer)
	return gT.Players[iPlayer].MedievalFairFestival;
end

function GetChanceForFestivalFromFairs(iPlayer)
	return gT.Players[iPlayer].FairFestival
end

function GetChanceForFestivalFromAcademies(iPlayer)
	if gT.Players[iPlayer].CultBonusOn[6] then
		return 3 * GetNumActiveAcademies(iPlayer);
	end
	return 0;
end

function GetChanceForFestivalBoudhanath(iPlayer)
	if gT.Players[iPlayer].HasPlayerWonder[GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_50] then
		for iCity in Players[iPlayer]:Cities() do
			if iCity:IsHasBuilding(GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_50) then
				local iRel = iCity:GetReligiousMajority();
				if iRel ~= -1 then
					return iCity:GetNumFollowers(iRel);
				end
				return 0;
			end
		end
	end
	return 0;
end

function GetChanceFestivalFromThDionysia(iPlayer)
	if HasPlayerTech(iPlayer, ancCS24, "Vadcekooew") then
		return 2 * (gT.Players[iPlayer].BonusesAcquired["Faith"] or 0);
	end
	return 0;
end

function GetChanceForFestivalFromSocialPolicies(iPlayer)
	local base = 0;
	return base;
end
function GetChanceFestivalWLTK(iPlayer)
	return gT.Players[iPlayer].WLTKChance;
end
function GetChanceFromCulturalHeritage(iPlayer)
	return 0;
end
function GetChanceFestivalCustomsHouses(iPlayer)
	return gT.Players[iPlayer].CHFestChance;
end

function GetChanceForFestivalPoint(iPlayer, fMod) 
	local base = 10 + GetChanceFestivalLuxury(iPlayer) + GetChanceFromReligion(iPlayer) + GetChanceFestivalFromCircusMaximus(iPlayer) + GetChanceFestivalPointsHap(iPlayer) + GetChanceForFestivalSinceLastOne(iPlayer) + GetChanceFestivalFromOccupied(iPlayer) + GetChanceForFestivalFromUlama(iPlayer);
	base = base + GetChanceFestivalTriumph(iPlayer) + GetChanceFestivalFromArtists(iPlayer) + GetChanceFestivalFromThDionysia(iPlayer) + GetChanceFestivalFromNationalDay(iPlayer) + GetChanceForFestivalFromColosseums(iPlayer) + GetChanceForFestivalFromSocialPolicies(iPlayer) + GetChanceForFestivalFromMF(iPlayer);
	base = base + GetChanceFestivalGoldenAge(iPlayer) + GetChanceFestivalFromWonderRuins(iPlayer) + GetChanceFestivalIdeology(iPlayer) + GetChanceForFestivalBoudhanath(iPlayer) + GetChanceForFestivalFromFairs(iPlayer) + GetChanceForFestivalFromAcademies(iPlayer) + GetChanceForFestivalVarious(iPlayer);
	base = base + GetChanceFestivalWLTK(iPlayer) + GetChanceFestivalFromScenario() + GetChanceFestivalCustomsHouses(iPlayer) + GetChanceFromCulturalHeritage(iPlayer) + GetChanceForFestivalFromTemplarBuildings(iPlayer) + GetBasicRewardGovFromCodex(iPlayer, 10, 12);
	return math.max(0, math.floor(base * (fMod or gT.Players[iPlayer].FestivalChanceMod)));
end

function GetMoraleBoostFromTriumph(iPlayer)
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_EMPIRE_12, "dedefuiyr") then
		for iCity in Players[iPlayer]:Cities() do
			local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
			if gT.Cities[cID].FestivalET then
				return 1;
			end
		end
	end
	return 0;
end

function GetReliableFestivalChance(iPlayer)
	local b = GetChanceForFestivalPoint(iPlayer)
	for a, h in pairs(ResetFestivalChance) do
		b = b - gT.Players[iPlayer][h];
	end
	return b;
end
function ResetFestivalTemporaryChance(iPlayer)
	for a, h in pairs(ResetFestivalChance) do
		gT.Players[iPlayer][h] = 0;
	end
end

function DoTriggerRewardsOnChancedFestivalObtained(iPlayer)
	if gT.Players[iPlayer].GovRewards[32] then
		for iCity in Players[iPlayer]:Cities() do
			if iCity:GetDamage() > 0 then
				HealCityDamage(iCity, 25)
			else
				iCity:ChangeMaxHitPoints(10);
			end	
		end
		for iUnit in Players[iPlayer]:Units() do
			if iUnit:GetDamage() > 0 then
				iUnit:ChangeDamage(-15);
			elseif gT.Players[iPlayer].UnitClassXP[iUnit:GetUnitClassType()] then
				iUnit:ChangeMaxHitPoints(3);
			end
		end
	end
end

function DoTurnFestivals(iPlayer)
	local gTurn = GetRealGameTurn();
	CheckWLTKTurn(iPlayer)
	if LastRandom(1,1000) <= GetChanceForFestivalPoint(iPlayer) then
		ChangeITGFestivalPoints(iPlayer, 1)
		DoTriggerRewardsOnChancedFestivalObtained(iPlayer)
		ResetFestivalTemporaryChance(iPlayer)
	else
		gT.Players[iPlayer].LastFestivalTA = gT.Players[iPlayer].LastFestivalTA + 1;
	end
	local bAll = true;
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		if gT.Cities[cID].FestivalET then
		-- turnly bonuses before end of festival!
			if gT.Players[iPlayer].FestivalBonusesActive[1] then
				ChangeITGCityInteger(iCity, "CI_NEXT_UNIT_XP", gT.Players[iPlayer].FestivalBonusesActive[1])
			end
			if gT.Players[iPlayer].FestivalBonusesActive[15] then
				iCity:ChangeMaxHitPoints(gT.Players[iPlayer].FestivalBonusesActive[15]);
			end
			if gT.Cities[cID].FestivalET <= gTurn then
				EndImmediatelyFestival(iCity, cID, iPlayer)
			end
		end
		if gT.Cities[cID].FestivalCD then
			if gT.Cities[cID].FestivalCD < GetITGGameTurn() then
				gT.Cities[cID].FestivalCD = nil;
			end
		else
			bAll = false;
		end
	end
	if bAll then
		for iCity in Players[iPlayer]:Cities() do
			local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
			gT.Cities[cID].FestivalCD = nil;
		end
	end
	DoLaw25Indicator(iPlayer)
end

function EndImmediatelyFestival(iCity, cID, iPlayer, newPlayer)
	if not newPlayer then
		if HasPlayerTech(iPlayer, innoViking8, "innoViking8") then
			iCity:ChangeYieldRateModifier(yCulture, -50)
		end
		if gT.Players[iPlayer].FestivalBonusesActive[5] then
			iCity:ChangeYieldRateModifier(yFood, -gT.Players[iPlayer].FestivalBonusesActive[5])
		end
		if gT.Players[iPlayer].FestivalBonusesActive[7] then
			iCity:ChangeYieldRateModifier(yGold, -gT.Players[iPlayer].FestivalBonusesActive[7])
		end
		if gT.Players[iPlayer].FestivalBonusesActive[13] then
			iCity:ChangeYieldRateModifier(yProduction, -gT.Players[iPlayer].FestivalBonusesActive[13])
		end
		if gT.Players[iPlayer].FestivalBonusesActive[4] then
			iCity:ChangeFaithPerTurnFromBuildings(-1)
			iCity:ChangeYieldRateModifier(yFaith, -gT.Players[iPlayer].FestivalBonusesActive[4])
		end
		if HasPlayerTech(iPlayer, ancCS24, "nherewr") then
			iCity:ChangeFaithPerTurnFromBuildings(-5)
		end
		if gT.Players[iPlayer].FestivalBonusesActive[6] then
			iCity:ChangeJONSCulturePerTurnFromBuildings(-gT.Players[iPlayer].FestivalBonusesActive[6])
		end
		if gT.Players[iPlayer].FestivalBonusesActive[12] then
			iCity:ChangeBaseYieldRateFromBuildings(yProduction, -gT.Players[iPlayer].FestivalBonusesActive[12])
		end
		if gT.Players[iPlayer].FestivalBonusesActive[14] then
			iCity:ChangeBaseYieldRateFromBuildings(yFood, -gT.Players[iPlayer].FestivalBonusesActive[14])
		end
		SetBasicCityYieldRate(iCity, yProduction, 0, "CI_FEST_LAW_24_PROD")
		SetBasicCityYieldRate(iCity, yGold, 0, "CI_FEST_LAW_24_GOLD")
		SetBasicCityYieldRate(iCity, yFood, 0, "CI_FEST_LAW_24_FOOD")
	end
	if gT.Players[iPlayer].FestivalBonusesActive[16] then
		ChangeCityPalaceYieldMod(iCity, iPlayer, -1)
	end
	gT.Cities[cID].FestivalET = nil
end

function PlayerChooseFestivalPointOnPlot(pPlot, iPlayer)
	local iCity = pPlot:GetPlotCity();
	if iCity and iCity:GetOwner() == iPlayer then
		if IsValidForFestival(iPlayer, iCity) then
			DoStartFestival(iPlayer, iCity)
		end
	end
end

function DoTriggerNewFestivalIfPossible(iPlayer, iCity)
	if IsValidForFestival(iPlayer, iCity) then	
		DoStartFestival(iPlayer, iCity, true)
	end
end	

function GetHappinessFromFestivalOutbreak(iPlayer)
	local b = 0;
	if gT.Players[iPlayer].CultBonusOn[181] then
		b = b + 2;
	end
	if Players[iPlayer]:GetBuildingClassCount(cirmax) > 0 then
		b = b + 2;
	end 
	if HasPlayerTech(iPlayer, nwinnomeso4, "elelleded") then
		b = b + 4;
	end
	if gT.WondersConstructed[fNotreDame] == iPlayer then
		b = b + 2;
	end
	return b;
end

function GetFestivalDuration(iPlayer, iCity)
	local exDur = 4;
	if gT.Players[iPlayer].CultBonusOn[181] then
		exDur = exDur + 2;
	end
	if Players[iPlayer]:GetBuildingClassCount(cirmax) > 0 then
		exDur = exDur + 2;
	end
	if HasPlayerTech(iPlayer, nwinnomeso4, "elelleded") then
		exDur = exDur + 2;
	end
	if HasPlayerTech(iPlayer, ancientTribe10, "okoekfoe") then
		exDur = exDur + 2;
	end
	if gT.Players[iPlayer].CultBonusOn[6] and iCity then
		if IsHasBuildingClass(iCity, GameInfoTypes.BUILDINGCLASS_LIBRARY) then
			exDur = exDur + 1;
		end
		if IsHasBuildingClass(iCity, GameInfoTypes.BUILDINGCLASS_UNIVERSITY) then
			exDur = exDur + 1;
		end	
	end
	return exDur;
end

function DoStartFestival(iPlayer, iCity, bFree, bKarnak) 
	DoIncreasementStockExchange(2)
	local exDur = GetFestivalDuration(iPlayer, iCity)
	local haps = GetHappinessFromFestivalOutbreak(iPlayer);
	gT.Players[iPlayer].NumFestivalsStarted = gT.Players[iPlayer].NumFestivalsStarted + 1;
	if not bFree then
		ChangeITGFestivalPoints(iPlayer, -1)
	end
	BasicCSMissionCompleteFunc(iPlayer, 14)
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	gT.Cities[cID].FestivalET = GetRealGameTurn() + exDur;
	if haps > 0 then
		ChangeITGHappinessInTheCity(iCity, haps, nil, "pkpvolprlverf")
	end
	if HasPlayerTech(iPlayer, innoindu5, "vokeode") then
		gT.Players[iPlayer].Ind5NatUnity = gT.Players[iPlayer].Ind5NatUnity + 1;
		ChangeMeritocracy(iPlayer, 1)
	end
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_EMPIRE_12, "dedefuiyr") then
		ChangeMeritocracy(iPlayer, 4)
	end
	if gT.Players[iPlayer].FestivalBonusesActive[4] then
		iCity:ChangeFaithPerTurnFromBuildings(1)
		iCity:ChangeYieldRateModifier(yFaith, gT.Players[iPlayer].FestivalBonusesActive[4])
	end
	if gT.Players[iPlayer].FestivalBonusesActive[5] then
		iCity:ChangeYieldRateModifier(yFood, gT.Players[iPlayer].FestivalBonusesActive[5])
	end
	if HasPlayerTech(iPlayer, innoViking8, "innoViking8") then
		iCity:ChangeYieldRateModifier(yCulture, 50)
	end
	if gT.Players[iPlayer].FestivalBonusesActive[6] then
		iCity:ChangeJONSCulturePerTurnFromBuildings(gT.Players[iPlayer].FestivalBonusesActive[6])
	end
	if gT.Players[iPlayer].FestivalBonusesActive[7] then
		iCity:ChangeYieldRateModifier(yGold, gT.Players[iPlayer].FestivalBonusesActive[7])
	end
	if gT.Players[iPlayer].FestivalBonusesActive[10] then
		gT.Cities[cID].TRattrFest = gT.Cities[cID].TRattrFest + gT.Players[iPlayer].FestivalBonusesActive[10];
	end
	if gT.Players[iPlayer].FestivalBonusesActive[11] then
		gT.Cities[cID].HealthFestival = (gT.Cities[cID].HealthFestival or 0) + 1;
	end
	if gT.Players[iPlayer].FestivalBonusesActive[12] then
		iCity:ChangeBaseYieldRateFromBuildings(yProduction, gT.Players[iPlayer].FestivalBonusesActive[12])
	end
	if gT.Players[iPlayer].FestivalBonusesActive[13] then
		iCity:ChangeYieldRateModifier(yProduction, gT.Players[iPlayer].FestivalBonusesActive[13])
	end
	if gT.Players[iPlayer].FestivalBonusesActive[14] then
		iCity:ChangeBaseYieldRateFromBuildings(yFood, gT.Players[iPlayer].FestivalBonusesActive[14])
	end
	if gT.Players[iPlayer].FestivalBonusesActive[15] then
		gT.Cities[cID].DefFestival = (gT.Cities[cID].DefFestival or 0) + 100;
		AdjustStrengthOfOneCity(iCity, 100, false)
	end
	if gT.Players[iPlayer].FestivalBonusesActive[16] then
		ChangeCityPalaceYieldMod(iCity, iPlayer, 1)
	end
	if gT.Players[iPlayer].HasIdeology[68] then
		gT.Cities[cID].HapChanceFromFestival = gT.Cities[cID].HapChanceFromFestival + 5;
	end
	if HasPlayerTech(iPlayer, ancCS24, "Vadcekooew") then
		iCity:ChangeFaithPerTurnFromBuildings(5)
	end
	if IsHasLaw(iPlayer, 24, 1) then
		SetBasicCityYieldRate(iCity, yProduction, -10, "CI_FEST_LAW_24_PROD")
	elseif IsHasLaw(iPlayer, 24, 2) then
		SetBasicCityYieldRate(iCity, yProduction, -10, "CI_FEST_LAW_24_PROD")
		SetBasicCityYieldRate(iCity, yGold, 25, "CI_FEST_LAW_24_GOLD")
	elseif IsHasLaw(iPlayer, 24, 3) then
		SetBasicCityYieldRate(iCity, yProduction, -10, "CI_FEST_LAW_24_PROD")
		SetBasicCityYieldRate(iCity, yFood, 25, "CI_FEST_LAW_24_FOOD")
	end
	local cMor = LastRandom(0, 2);
	if cMor > 0 then
		TakeCareOfEventMorale(iPlayer, 25, {cMor, "Festival"})
	end
	local hex = ToHexFromGrid(Vector2(iCity:GetX(),iCity:GetY()));
	local bActivePlayer = (iPlayer == Game.GetActivePlayer());
	local delay = 0;
	if bActivePlayer then
		if (haps > 0) then
			delay = delay + 0.5;
			Events.AddPopupTextEvent(HexToWorld(hex), "+" .. haps .. "[ICON_HAPPINESS_1]", delay)
		end
		Events.GameplayFX(hex.x, hex.y, -1)
	end
	if gT.Players[iPlayer].GovRewards[10] then
		ChangeITGLegalPointsPercent(iPlayer, 25, nil, "egregad")
		if bActivePlayer then
			delay = delay + 0.5;
			Events.AddPopupTextEvent(HexToWorld(hex), "+0.25[ICON_ITG_LEGAL_POWER]", delay)
		end
	end
	if HasPlayerTech(iPlayer, ancientTribe10, "okoekfoe") then
		iCity:ChangePopulation(1, true)
	end
	--karnak
	if gT.Players[iPlayer].HasPlayerWonder[itgfestivalwonder1] then
		if not bKarnak then
			local ktab = {}
			for iCity in Players[iPlayer]:Cities() do
				if IsValidForFestival(iPlayer, iCity) then
					table.insert(ktab, iCity)
				end
			end
			if #ktab > 0 then
				DoStartFestival(iPlayer, ktab[LastRandom(1,#ktab)], true, true)
			end
		end
	end
	if not bKarnak then
		gT.Cities[cID].FestivalCD = GetITGGameTurn() + GetPlayerFestivalCD(iPlayer)
	end
	DoLaw25Indicator(iPlayer)
end

function DoLaw25Indicator(iPlayer)
	local inf, inn = 0, 0;
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		if gT.Cities[cID].FestivalET then
			inf = inf + 1;
		else
			inn = inn + 1;
		end
	end
	if inf > 0 then
		gT.Players[iPlayer].Law25Int = inn;
	else
		gT.Players[iPlayer].Law25Int = 0;
	end
end

function GetPlayerFestivalCD(iPlayer)
	if gT.Players[iPlayer].HasPlayerWonder[GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_50] then
		return 0;
	end
	return 6 + Players[iPlayer]:GetNumCities() * 2;
end

LuaEvents.ITGSG_RequestFestivalStringNewOne.Add(function(iPlayer)
	local sTT = "You can start a Festival in chosen city, which boosts your [ICON_ITG_PRESENCE] Cultural Presence by 7 each turn and also grants temporary bonuses:" 
	for i, s in pairs(festivalbonusestable) do
		if gT.Players[iPlayer].FestivalBonusesActive[i] then
			sTT = sTT .. "[NEWLINE][ICON_BULLET]" .. s.StringFunction(gT.Players[iPlayer].FestivalBonusesActive[i])
		end
	end
	sTT = sTT .. GetStringFromPlayerLaws(iPlayer)
	if gT.Players[iPlayer].CultBonusOn[121] then
		sTT = sTT .. "[NEWLINE][ICON_BULLET]Academies have +10 [ICON_ITG_ACADEMY_1] Prestige and [ICON_ITG_ACADEMY_2] Development points." 
	end
	if HasPlayerTech(iPlayer, innoViking8, "innoViking8") then
		sTT = sTT .. "[NEWLINE][ICON_BULLET]+50% [ICON_CULTURE] Culture (Skalds)."
	end
	local duration = GetFestivalDuration(iPlayer)
	sTT = sTT .. "[NEWLINE][NEWLINE]Festival will last " .. duration .. " turns."
	local haps = GetHappinessFromFestivalOutbreak(iPlayer);
	if haps > 0 then
		sTT = sTT .. "[NEWLINE]+" .. haps .. " [ICON_HAPPINESS_1] Happiness upon start."
	end
	if HasPlayerTech(iPlayer, ancientTribe10, "okoekfoe") then
		sTT = sTT .. "[NEWLINE]+1 [ICON_CITIZEN] Population upon start."
	end
	if gT.Players[iPlayer].GovRewards[10] then
		sTT = sTT .. "[NEWLINE]+0.25 [ICON_ITG_LEGAL_POWER] Legal Power upon start."
	end
	sTT = sTT .. "[NEWLINE][NEWLINE]Starting [ICON_ITG_FESTIVAL] Festival will prevent next [ICON_ITG_FESTIVAL] Festival in chosen City for " ..  GetPlayerFestivalCD(iPlayer) .. " turns (value is based on amount of Cities and can be bypassed if all Cities are on cooldown)." 
	MapModData.ITGSG = sTT;
end)

function GetStringFromPlayerLaws(iPlayer)
	local str = ""
	if IsHasLaw(iPlayer, 24, 1) then
		str = str .. "[NEWLINE][ICON_BULLET]-10% [ICON_PRODUCTION] Production. (Law)"
		str = str .. "[NEWLINE][ICON_BULLET]+25% chance to generate [ICON_HAPPINESS_1] Happiness. (Law)"
	elseif IsHasLaw(iPlayer, 24, 2) then
		str = str .. "[NEWLINE][ICON_BULLET]-10% [ICON_PRODUCTION] Production. (Law)"
		str = str .. "[NEWLINE][ICON_BULLET]+25% [ICON_GOLD] Gold. (Law)"
	elseif IsHasLaw(iPlayer, 24, 3) then
		str = str .. "[NEWLINE][ICON_BULLET]-10% [ICON_PRODUCTION] Production. (Law)"
		str = str .. "[NEWLINE][ICON_BULLET]+20% [ICON_FOOD] Food. (Law)"
	end
	if HasPlayerTech(iPlayer, ancCS24, "Vadcekooew") then
		str = str .. "[NEWLINE][ICON_BULLET]+5 [ICON_PEACE] Faith. (Dionysia)"
		str = str .. "[NEWLINE][ICON_BULLET]+5 [ICON_GREAT_ARTIST] Art. (Dionysia)"
	end
	if IsHasLaw(iPlayer, 25, 1) then
		str = str .. "[NEWLINE][ICON_BULLET]+50% more [ICON_ITG_CHARM] Charm per City without Festival. (Law)"
	elseif IsHasLaw(iPlayer, 25, 2) then
		str = str .. "[NEWLINE][ICON_BULLET]+5 [ICON_TRADE_WHITE] Trade Appeal per City without Festival. (Law)"
	end
	return str;
end

LuaEvents.ITGSG_RequestFestivalString.Add(function(iCity)
	local sTT;
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	if gT.Cities[cID].FestivalET then
		sTT = {"Festival! (" .. (gT.Cities[cID].FestivalET - GetRealGameTurn()) .. ")",""}
		local str = "Festival is now taking a place in the city."
		str = str .. "[NEWLINE][ICON_BULLET]+7 [ICON_ITG_PRESENCE] Cultural Presence."
		local iOwn = iCity:GetOwner();
		for i, s in pairs(festivalbonusestable) do
			if gT.Players[iOwn].FestivalBonusesActive[i] then
				str = str .. "[NEWLINE][ICON_BULLET]" .. s.StringFunction(gT.Players[iOwn].FestivalBonusesActive[i])
			end
		end
		str = str .. GetStringFromPlayerLaws(iOwn)
		if gT.Players[iOwn].CultBonusOn[121] then
			str = str .. "[NEWLINE][ICON_BULLET]Academies have +10 [ICON_ITG_ACADEMY_1] Prestige and [ICON_ITG_ACADEMY_2] Development points." 
		end
		if HasPlayerTech(iOwn, innoViking8, "innoViking8") then
			str = str .. "[NEWLINE][ICON_BULLET]+50% [ICON_CULTURE] Culture (Skalds)."
		end
		sTT[2] = str;
	end
	MapModData.ITGSG = sTT;
end)

function GetChanceFestivalFromCircusMaximus(gPlayer)
	if Players[gPlayer]:GetBuildingClassCount(cirmax) > 0 then
		return 5;
	end
	return 0;
end

function GetChanceForFestivalSinceLastOne(iPlayer)
	local mod = 1;
	if HasPlayerTech(iPlayer, asia2trial, "dedafve") then
		mod = mod + 1;
	end
	return gT.Players[iPlayer].LastFestivalTA * mod;
end

function GetChanceFestivalFromScenario()
	if gT.Globals.ScenarioType == 5 then
		return -20;
	end
	return 0;
end

function GetChanceForFestivalVarious(iPlayer)
	return gT.Players[iPlayer].FestivalVarious;
end

function GetFestivalTextForTP(gPlayer)
	local strText = "Indicates the chance to generate [ICON_ITG_FESTIVAL] Festival point each turn.[NEWLINE][NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]+1%[ENDCOLOR] from Base"
	local festTab = {}
	table.insert(festTab, {GetChanceFestivalLuxury(gPlayer), "Luxuries"})
	table.insert(festTab, {GetChanceFestivalPointsHap(gPlayer), "Happiness"})
	table.insert(festTab, {GetChanceFestivalTriumph(gPlayer), "Triumph"})
	table.insert(festTab, {GetChanceFestivalGoldenAge(gPlayer), "Golden Age"})
	table.insert(festTab, {GetChanceFestivalFromWonderRuins(gPlayer), "Wonder Ruins"})
	table.insert(festTab, {GetChanceFestivalIdeology(gPlayer), "Ideologies"})
	table.insert(festTab, {GetChanceFestivalFromArtists(gPlayer), "Great People (Artists, Musicians, Writers)"})
	table.insert(festTab, {GetChanceFestivalFromOccupied(gPlayer), "Occupied cities"})
	table.insert(festTab, {GetChanceFestivalFromCircusMaximus(gPlayer), "Circus Maximus"})
	table.insert(festTab, {GetChanceFromReligion(gPlayer), "Religion"})
	table.insert(festTab, {GetChanceFestivalFromNationalDay(gPlayer), "National Day"})
	table.insert(festTab, {GetChanceFestivalWLTK(gPlayer), "We Love The King"})
	table.insert(festTab, {GetChanceFestivalCustomsHouses(gPlayer), "Customs Houses"})
	table.insert(festTab, {GetChanceFestivalFromThDionysia(gPlayer), "The Dionysia"})
	table.insert(festTab, {GetChanceForFestivalFromSocialPolicies(gPlayer), "Social Developments"})
	table.insert(festTab, {GetChanceForFestivalFromColosseums(gPlayer), "Colosseums"})
	table.insert(festTab, {GetChanceForFestivalFromTemplarBuildings(gPlayer), "Templar Buildings"})
	table.insert(festTab, {GetChanceForFestivalFromUlama(gPlayer), "Ulama Festival"})
	table.insert(festTab, {GetChanceForFestivalFromMF(gPlayer), "Medieval Fair"})
	table.insert(festTab, {GetChanceForFestivalBoudhanath(gPlayer), "Boudhanath"})
	table.insert(festTab, {GetChanceForFestivalFromFairs(gPlayer), "Fairs"})
	table.insert(festTab, {GetBasicRewardGovFromCodex(gPlayer, 10, 17), "Codex"})
	table.insert(festTab, {GetChanceForFestivalFromAcademies(gPlayer), "Academies"})
	table.insert(festTab, {GetChanceForFestivalVarious(gPlayer), "Various Events"})
	table.insert(festTab, {GetChanceFromCulturalHeritage(gPlayer), "Cultural Heritage"})
	table.insert(festTab, {GetChanceFestivalFromScenario(), "Mark of Time"})
	
	for i, data in pairs(festTab) do
		if data[1] > 0 then
			strText = strText .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]+" .. data[1]/10 .. "%[ENDCOLOR] from " .. data[2];
		elseif data[1] < 0 then
			strText = strText .. "[NEWLINE][ICON_BULLET][COLOR_NEGATIVE_TEXT]" .. data[1] /10 .. "%[ENDCOLOR] from " .. data[2];
		end
	end
	local cplastone = GetChanceForFestivalSinceLastOne(gPlayer)
	if cplastone > 0 then
		strText = strText .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]+" .. cplastone/10 .. "%[ENDCOLOR] for each turn since last [ICON_ITG_FESTIVAL] Festival point was acquired"
	end
	if gT.Players[gPlayer].WLTKResource then
		strText = strText .. "[NEWLINE][NEWLINE]Acquiring a source of " .. GameInfo.Resources[gT.Players[gPlayer].WLTKResource].IconString .. " " .. Locale.Lookup(GameInfo.Resources[gT.Players[gPlayer].WLTKResource].Description) .. " would increase chance to acquire new [ICON_ITG_FESTIVAL] Festival by 1%."
	end
	return strText;
end

function GetFestivalBonusStringXPnextTrained(p)
	return "+" .. p .. " XP for next trained unit per turn."
end
function GetFestivalBonusStringReducedUnhappinessGenerating(p)
	return "+" .. p .. "% [ICON_HAPPINESS_1] Happiness chance."
end
function GetFestivalBonusStringLegal(p)
	return "+" .. p .. "% [ICON_ITG_LEGAL_POWER] Legal Power."
end
function GetFestivalBonusStringFaith(p)
	return "+1 [ICON_PEACE] Faith, +" .. p .. "% [ICON_PEACE] Faith."
end
function GetFestivalBonusStringFood(p)
	return "+" .. p .. "% [ICON_FOOD] Food."
end
function GetFestivalBonusStringCulture(p)
	return "+" .. p .. " [ICON_CULTURE] Culture per turn."
end
function GetFestivalBonusStringGold(p)
	return "+" .. p .. "% [ICON_GOLD] Gold."
end
function GetFestivalBonusStringArt(p)
	return "+1 [ICON_GREAT_ARTIST] Art point, +" .. p .. "% [ICON_GREAT_ARTIST] Art points."
end
function GetFestivalBonusStringGP(p)
	return "+1 [ICON_GREAT_PEOPLE] Great People point, +" .. p .. "% [ICON_GREAT_PEOPLE] Great People points."
end
function GetFestivalBonusStringTRAttr(p)
	return "+" .. p .. " [ICON_TRADE_WHITE] Trade Appeal."
end
function GetFestivalBStringHealth(p)
	return "+1 [ICON_ITG_HEALTH_1] Health permanent. An extra +" .. p .. " [ICON_ITG_HEALTH_1] Health during Festival.";
end
function GetFestivalBStringRawProd(p)
	return "+" .. p .. " [ICON_PRODUCTION] Production per turn.";
end
function GetFestivalBStringModProd(p)
	return "+" .. p .. "% [ICON_PRODUCTION] Production.";
end
function GetFestivalBStringFoodRaw(p)
	return "+" .. p .. " [ICON_FOOD] Food per turn.";
end
function GetFestivalBStringDefense(p)
	return "+1 [ICON_STRENGTH] Defense permanent. +" .. p .. " max HP per turn.";
end
function GetFestivalBStringPalace(p)
	return "+100% basic yields from Palace.";
end

festivalbonusestable = {
{ID = 1, StringFunction = GetFestivalBonusStringXPnextTrained}, -- XP for next trained unit
{ID = 2, StringFunction = GetFestivalBonusStringReducedUnhappinessGenerating}, -- % hap chance
{ID = 3, StringFunction = GetFestivalBonusStringLegal}, -- +% legal power
{ID = 4, StringFunction = GetFestivalBonusStringFaith}, -- +% Faith per turn
{ID = 5, StringFunction = GetFestivalBonusStringFood}, -- +% food
{ID = 6, StringFunction = GetFestivalBonusStringCulture}, -- +raw Culture UNUSED CAN BE REPLACED
{ID = 7, StringFunction = GetFestivalBonusStringGold}, -- +% gold
{ID = 8, StringFunction = GetFestivalBonusStringArt}, -- +% Art points
{ID = 9, StringFunction = GetFestivalBonusStringGP}, -- +% GP points
{ID = 10, StringFunction = GetFestivalBonusStringTRAttr}, -- more attractive tr target
{ID = 11, StringFunction = GetFestivalBStringHealth}, --+1 perm, + health
{ID = 12, StringFunction = GetFestivalBStringRawProd}, -- + production
{ID = 13, StringFunction = GetFestivalBStringModProd}, -- +% production
{ID = 14, StringFunction = GetFestivalBStringFoodRaw}, -- + food
{ID = 15, StringFunction = GetFestivalBStringDefense}, -- +1 perm defense, + max hp per turn
{ID = 16, StringFunction = GetFestivalBStringPalace}, -- +100% palace yields; (no variable)
}

function GetFestivalRewardString(id, extrainfo)
	return festivalbonusestable[id].StringFunction(extrainfo)
end

function OnInitialFestivals(majTab)
	for i, player in pairs(majTab) do
		gT.Players[player].FestivalRewards = {}
		DoAddNewFestivalAbilityToPlayer(player)
	end
end

function DoInitialDionysia(iPlayer, ival)
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		if gT.Cities[cID].FestivalET then
			iCity:ChangeFaithPerTurnFromBuildings(ival * 10)
		end
	end
end

function GetFoodRateFromFestivalNow(iCity, cID, iPlayer)
	local t = GetITGCityInteger(iCity, "CI_FEST_LAW_24_FOOD");
	if gT.Cities[cID].FestivalET then
		if gT.Players[iPlayer].FestivalBonusesActive[5] then
			t = t + gT.Players[iPlayer].FestivalBonusesActive[5];
		end
	end
	return t;
end

function GetCultureRateFromFestivalNow(iCity, cID, iPlayer)
	local t = 0;
	if gT.Cities[cID].FestivalET then
		if HasPlayerTech(iPlayer, innoViking8, "innoViking8") then
			t = t + 50;
		end
	end
	return t;
end


function GetNewFestivalReward(iPlayer)
	if not g_CultureFestivalRewards then
		InitDBCultureFestivalRewards();
	end
	local options = {}
	for a, b in pairs(GetPlayerFestivalOptions(iPlayer)) do
		if not gT.Players[iPlayer].FestivalBonusesActive[a] then
			table.insert(options, {a,b})
		end
	end
	if #options > 0 then
		return RandomFromTab(options);
	end
	return nil;
end

function DoAddNewFestivalAbilityToPlayer(iPlayer)
	local tab = GetNewFestivalReward(iPlayer)
	if tab then
		gT.Players[iPlayer].FestivalBonusesActive[tab[1]] = tab[2]
		table.insert(gT.Players[iPlayer].FestivalRewards, tab[1]);
		ApplyFestivalRewardToOngoingFestivals(iPlayer, tab[1], tab[2], 1, true)
	end
end

function ApplyFestivalRewardToOngoingFestivals(iPlayer, b1, iChange, iAdd, bAdd)
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		if gT.Cities[cID].FestivalET then
			if b1 == 4 then
				iCity:ChangeFaithPerTurnFromBuildings(iAdd)
				iCity:ChangeYieldRateModifier(yFaith, iChange)
			elseif b1 == 5 then
				iCity:ChangeYieldRateModifier(yFood, iChange)
			elseif b1 == 6 then
				iCity:ChangeJONSCulturePerTurnFromBuildings(iChange)
			elseif b1 == 7 then
				iCity:ChangeYieldRateModifier(yGold, iChange)
			elseif b1 == 12 then
				iCity:ChangeBaseYieldRateFromBuildings(yProduction, iChange)
			elseif b1 == 13 then
				iCity:ChangeYieldRateModifier(yProduction, iChange)
			elseif b1 == 14 then
				iCity:ChangeBaseYieldRateFromBuildings(yFood, iChange)
			elseif b1 == 16 then
				ChangeCityPalaceYieldMod(iCity, iPlayer, iAdd)
			end
		end
	end
end

function DoRemoveFestivalAbilityToPlayer(iPlayer)
	local rKey = #gT.Players[iPlayer].FestivalRewards;
	if rKey == 0 then
		print("Uh error festivalo", iPlayer)
	end
	local b1 = gT.Players[iPlayer].FestivalRewards[rKey];
	table.remove(gT.Players[iPlayer].FestivalRewards, rKey)
	if b1 then
		local b2 = gT.Players[iPlayer].FestivalBonusesActive[b1]
		gT.Players[iPlayer].FestivalBonusesActive[b1] = nil;
		ApplyFestivalRewardToOngoingFestivals(iPlayer, b1, -b2, -1, false)
	else
		print("Error 123/55/4/3")
	end
end

function GetFestivalFlavourValue(iPlayer)
	local base = 10 - Players[iPlayer]:GetNumCities();
	base = base + GetChanceForFestivalPoint(iPlayer, 1) - 5;
	return base;
end

function PlayerRemovedFestivalBonusLaw(iPlayer, optionID)
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		if gT.Cities[cID].FestivalET then
			SetBasicCityYieldRate(iCity, yProduction, 0, "CI_FEST_LAW_24_PROD")
			SetBasicCityYieldRate(iCity, yGold, 0, "CI_FEST_LAW_24_GOLD")
			SetBasicCityYieldRate(iCity, yFood, 0, "CI_FEST_LAW_24_FOOD")
		end
	end
end

function PlayerEnabledFestivalBonusLaw(iPlayer, optionID)
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		if gT.Cities[cID].FestivalET then
			SetBasicCityYieldRate(iCity, yProduction, -10, "CI_FEST_LAW_24_PROD")
			if optionID == 2 then
				SetBasicCityYieldRate(iCity, yGold, 25, "CI_FEST_LAW_24_GOLD")
			elseif optionID == 3 then
				SetBasicCityYieldRate(iCity, yFood, 25, "CI_FEST_LAW_24_FOOD")
			end
		end
	end
end