local bIsAIGame = (PreGame.GetGameOption("GAMEOPTION_ITG_AI_GAME") == 1)
local iFTDelay = 0;
local sFTUIoptions = {"Fish", "Trade", "Missionary", "TechQuote", "CultSounds"}

function ResetFTDelay(val)
	iFTDelay = val;
end

function GetInitFTOption(ft)
	return ((MUD_Get("UI_FT_BASIC_" .. ft) or 1) == 1);
end

function DefineInitialFTOptions(iPlayer)
	gT.FToptions[iPlayer] = {};
	for a, s in pairs(sFTUIoptions) do
		gT.FToptions[iPlayer][s] = GetInitFTOption(s)
	end
end

LuaEvents.ITG_UIFT_BasicCheckChange.Add(function(s, bIsChecked)
	if not bIsAIGame then
		local iActivePlayer = Game.GetActivePlayer();
		if gT.Players[iActivePlayer] then
			if not gT.FToptions[iActivePlayer] then
				DefineInitialFTOptions(iActivePlayer)
			end
			gT.FToptions[iActivePlayer][s] = bIsChecked;
			if bIsChecked then
				MUD_Save("UI_FT_BASIC_" .. s, 1)
			else
				MUD_Save("UI_FT_BASIC_" .. s, 0)
			end
		end
	end
end)

LuaEvents.ITG_RequestUIFloatOptions.Add(function(iPlayer)
	if not bIsAIGame then
		if gT.Players[iPlayer] then
			if not gT.FToptions[iPlayer] then
				DefineInitialFTOptions(iPlayer)
			end
			MapModData.ITGSG = gT.FToptions[iPlayer];
		end
	end
end)

function IsFTOptionOn(iPlayer, sFTtype)
	if not gT.FToptions[iPlayer] then
		DefineInitialFTOptions(iPlayer);
	end
	return gT.FToptions[iPlayer][sFTtype];
end

function AddFloatingText(iPlayer, x, y, text, delay, sFTtype, sPlayer)
	if bIsAIGame then
		return;
	end
	local iActivePlayer = Game.GetActivePlayer();
	if (not iPlayer) or (iPlayer == iActivePlayer) or (sPlayer == iActivePlayer) then
		if (not sFTtype) or (sFTtype == -1) or IsFTOptionOn(iActivePlayer, sFTtype) then
			local iDelay = delay;
			if not iDelay then
				iDelay = iFTDelay;
				iFTDelay = iFTDelay + 0.5;
			end
			Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(x, y))), text, iDelay)
		end
	end
end