local iFort = GameInfoTypes.IMPROVEMENT_ITG_FORT
local iCitadel = GameInfoTypes.IMPROVEMENT_ITG_CITADEL
local uGarrison = GameInfoTypes.UNIT_GARRISON
local malborkcastle1 = GameInfoTypes.BUILDING_ITG_NEW_MEDIEVAL_WONDER_7;
local GetMaxFortsForType = {10, 7, 3, 5}
local ImprotFort = {iFort, iCitadel}
local uColonyWorker = GameInfoTypes.UNIT_ITG_WORKER_COLONY;
local uProphet = GameInfoTypes.UNIT_ITGSG_PROPHET_IMMOBILE;
local bBlobTerritory = (PreGame.GetGameOption("GAMEOPTION_ITG_BLOB_TERRITORIES") == 1)
local techANCemp7 = GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_EMPIRE_7
local ValidFortImproTab = {
[GameInfoTypes.IMPROVEMENT_FARM] = 1,
[GameInfoTypes.IMPROVEMENT_MINE] = 1,
[GameInfoTypes.IMPROVEMENT_LUMBERMILL] = 1
}

function GetRandomTypeOfFort()
	if LastRandom(1,10) == 3 then
		return 2
	end
	return 1
end

function FortAdjacentToThePlot(iPlot, bIgnoreFort)
	for i = 0, 5 do
		local jPlot = Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), i)
		if jPlot then
			if (not bIgnoreFort) and gT.Forts[jPlot:GetPlotIndex()] then
				return true;
			end
			if jPlot:IsCity() then
				return true;
			end
			if gT.Settlements[jPlot:GetPlotIndex()] then
				return true;
			end
		end
	end
	return false;
end

function IsPlotAdjacentToPlayer(iPlot, iPlayer)
	for i = 0, 5 do
		local jPlot = Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), iPlayer);
		if jPlot then
			if jPlot:GetOwner() == iPlayer then
				return true;
			end
		end
	end
	return false;
end

function InitialFortsAndCitadels()
	local hTab = GetNiceLocationsForDefensiveStructures();
	for g, gData in pairs(gT.Players) do
		if GetDBCulturePlayerInfo(g, "CanControlForts") then
			local numforts = LastRandom(0, Players[g]:GetNumCities());
			local gDistance = GetDBCulturePlayerInfo(g, "InitFortDistance")
			if numforts > 0 then
				local iTab = {}
				local sPlot = Map.GetPlotByIndex(gData.StartingPlot)
				local npc = GetDBCulturePlayerInfo(g, "NeedPassabilityCheck")
				for it, fData in pairs(hTab) do
					if (not npc) or (GetPassabilityAreaID(fData[1]) == GetPassabilityAreaID(sPlot)) then
						if ((not bBlobTerritory) and (Map.PlotDistance(fData[1]:GetX(), fData[1]:GetY(), sPlot:GetX(), sPlot:GetY()) < gDistance)) or IsPlotAdjacentToPlayer(fData[1], g) then
							if not gT.Forts[fData[1]:GetPlotIndex()] then
								if fData[1]:GetOwner() == -1 or fData[1]:GetOwner() == g then
									if not FortAdjacentToThePlot(fData[1]) then
										table.insert(iTab, fData[1])
									end
								end
							end
						end
					end
				end
				for it, iPlot in pairs(iTab) do
					if not FortAdjacentToThePlot(iPlot) then
						if numforts > 0 then
							numforts = numforts - 1;
							CreateNewFortForPlayer(g, iPlot, GetRandomTypeOfFort(), true)
						end
					end
				end
			end
		end
	end
end


function GetNiceLocationsForDefensiveStructures()
	local hTab = {}
	for i = 0, Map:GetNumPlots() - 1, 1 do
		local fPlot = Map.GetPlotByIndex( i );
		if IfCanBeFortTrivial(fPlot, true) then
			if not gT.Globals.BadContIDs[GetContID(fPlot, 612366)] then
				if not gT.Globals.BadPoints[fPlot:GetPlotIndex()] then
					table.insert(hTab, {fPlot, GetPlotValueToBeAFort(fPlot)})
				end
			end
		end
	end
	hTab = Shuffle(hTab)
	table.sort(hTab, SortFunctionForGreaterInteger2)
	return hTab;
end

function GetPlotValueToBeAFort(fPlot)
	local points = 0;
	if fPlot:IsHills() then
		points = points + 3;
	end
	if fPlot:IsNEOfRiver() then
		points = points + 1;
	end
	if fPlot:IsWOfRiver() then
		points = points + 1;
	end
	if fPlot:IsNWOfRiver() then
		points = points + 1;
	end
	local impass = {}
	for i = 0, 5 do
		local iPlot = Map.PlotDirection(fPlot:GetX(), fPlot:GetY(), i)
		if iPlot then
			if i == 0 then
				if iPlot:IsNEOfRiver() then
					points = points + 1;
				end
			elseif i == 5 then
				if iPlot:IsNWOfRiver() then
					points = points + 1;
				end
			elseif i == 4 then
				if iPlot:IsWOfRiver() then
					points = points + 1;
				end
			end
			if iPlot:IsCity() then
				point = points + 1;
			end
			if iPlot:IsWater() or iPlot:IsMountain() then
				impass[i] = 1;
			end
		end
	end
	if fPlot:GetTerrainType() == tSnow then
		points = points - 3;
	end
	points = points + GetPointsFromImpassableFort(impass)
	return points;
end

function GetPointsFromImpassableFort(impass)
	local cCount = 0;
	for side, sv in pairs(impass) do
		cCount = cCount + 1;
	end
	if cCount > 4 then
		return -10;
	end
	local nums = GetRozgalezienie(impass)
	if nums == 3 then
		return 10;
	elseif nums == 2 then
		return 5;
	end
	if impass == 1 then
		return 1;
	end
	return 0;
end


function GetRozgalezienie(impass)
	local tt = 0
	local tTable = {}
	for dir, sth in pairs(impass) do
		if not tTable[dir] then
			tTable[dir] = 1;
			tt = tt + 1;
			for i = 1, 5 do
				if impass[(dir + i) % 6] then
					tTable[(dir + i) % 6] = 1
				else
					break
				end
			end
			for i = 1, 5 do
				if impass[(dir - i + 6) % 6] then
					tTable[(dir - i + 6) % 6] = 1
				else
					break
				end
			end
		end
	end
	return tt;
end

local gWallFortBonusScenario = {2, 2, 2, 3, 5}
local GetFortPowerForBarbarian = {12, 10, 8, 16, 25}

function GetPlayerRangedStrengthForFort(iPlayer, type)
	return GetPlayerStrengthForFort(iPlayer, type)
end

function GetPlayerStrengthForFort(iPlayer, type)
	local base;
	if not gT.Players[iPlayer] then
		if not GetFortPowerForBarbarian[gT.Globals.ScenarioType] then
			print("Undefined fort strength for barbarian!");
		end
		base = GetFortPowerForBarbarian[gT.Globals.ScenarioType];
	else
		base = gT.Players[iPlayer].FortPowerFromTech;
		if type == 1 then
			base = base + GetDBCulturePlayerInfo(iPlayer, "FortPower")
		else
			base = base + GetDBCulturePlayerInfo(iPlayer, "CitadelPower")
		end
		if gT.Players[iPlayer].CultBonusOn[18] then
			base = base + DBScenario.FortBonusStrength;
		end
		if gT.Players[iPlayer].HasPlayerWonder[GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_5] then
			base = base + gWallFortBonusScenario[gT.Globals.ScenarioType]; -- this will runtime error if new scenario
		end
	end
	return base;
end

function CanFortAcquireThisPlot(nPlot, iPlayer)
	if IsSpecialControlPlot(nPlot:GetPlotIndex(), true, nil, true) then
		return false;
	end
	for i = 0, 5 do
		local iPlot = Map.PlotDirection(nPlot:GetX(), nPlot:GetY(), i);
		if iPlot then
			if iPlot:IsCity() then
				return false;
			end
			if gT.Settlements[iPlot:GetPlotIndex()] then
				return false;
			end
		end
	end
	if not CanBeFortForPlayer(nPlot, iPlayer, true) then
		return false;
	end
	return true;
end

function FortClaimAdjacentPlot(iPlayer, plot, iPlot, fIndex)
	gT.PlotFortControl[plot:GetPlotIndex()] = iPlot:GetPlotIndex();
	plot:SetOpenBorderForEveryone(true)
	if fIndex then
		table.insert(gT.Forts[fIndex].AdjacentPlots, plot:GetPlotIndex());
	end
	if plot:GetOwner() ~= iPlayer then
		plot:SetOwner(iPlayer, GetClosestCityIDToPlotOrNil(iPlayer, plot));
	end
end

function DoAcquireExtraPlotsForFort(iPlayer, iPlot, max, fIndex)
	local hTab = {};
	for i = 0, 5 do
		local nPlot = Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), i);
		if nPlot then
			if CanFortAcquireThisPlot(nPlot, iPlayer) then
				table.insert(hTab, nPlot)
			end
		end
	end
	local adjPlots = {}
	if #hTab > 0 then
		hTab = Shuffle(hTab);
		local tAdd = max;
		local iOplots = {}
		for i, plot in pairs(hTab) do
			if tAdd > 0 then
				if plot:GetOwner() == iPlayer then
					table.insert(iOplots, plot);
				else
					table.insert(adjPlots, plot:GetPlotIndex())
					FortClaimAdjacentPlot(iPlayer, plot, iPlot, fIndex)
					tAdd = tAdd - 1;
				end
			end
		end
		for i, plot in pairs(iOplots) do
			if tAdd > 0 then
				table.insert(adjPlots, plot:GetPlotIndex())
				FortClaimAdjacentPlot(iPlayer, plot, iPlot, fIndex)
				tAdd = tAdd - 1;
			end
		end
	end
	return adjPlots;
end

function DoAddMalborkEffectOnExistingForts(iPlayer)
	for iIndex, sth in pairs(gT.Forts) do
		if sth.Player == iPlayer then
			if not sth.Malbork then
				gT.Forts[iIndex].Malbork = true;
				DoAcquireExtraPlotsForFort(iPlayer, Map.GetPlotByIndex(iIndex), 2, iIndex)
			end
		end
	end
	for jUnit in Players[iPlayer]:Units() do
		local jID = jUnit:GetID() .. "," .. iPlayer .. "," .. jUnit:GetGameTurnCreated();
		if gT.FortsByUnitID[jID] then
			jUnit:ChangeMaxHitPoints(50);
		end
	end
end

function DoRemoveMalborkEffectOnExistingForts(iPlayer)
	for jUnit in Players[iPlayer]:Units() do
		local jID = jUnit:GetID() .. "," .. iPlayer .. "," .. jUnit:GetGameTurnCreated();
		if gT.FortsByUnitID[jID] then
			jUnit:ChangeMaxHitPoints(-50);
		end
	end
end

function CreateNewFortForPlayer(iPlayer, iPlot, type, bFort, bFeitoria)
	if gT.Globals.GameGenerated then
		if Players[iPlayer]:GetBuildingClassCount(GameInfoTypes.BUILDINGCLASS_ITG_NEW_WORLD_WONDER_10) > 0 then
			CreateGreatWorkOfAmount(iPlayer, 1)
		end
		VictoryTaskCompletion(iPlayer, 29)
	end
	iPlot:SetOwner(iPlayer, GetClosestCityIDToPlotOrNil(iPlayer, iPlot));
	MakeJumpAwayFromSpecialPoint(iPlayer, iPlot)
	gT.PlotFortControl[iPlot:GetPlotIndex()] = nil;
	local jUnit = SpawnFortUnit(iPlayer, iPlot, type, 0)
	local max = 2;
	if type == 2 then
		max = max + 2;
	end
	local bMalbork;
	if gT.Players[iPlayer].HasPlayerWonder[malborkcastle1] then
		max = max + 2;
		bMalbork = true;
	end
	if gT.Players[iPlayer].HasIdeology[66] then
		DoAddTemporalCurrencyPower(iPlayer, LastRandom(70,80))
	end
	local adjPlots = DoAcquireExtraPlotsForFort(iPlayer, iPlot, max, nil)
	if bFort then
		jUnit:PushMission(GameInfoTypes.MISSION_FORTIFY)
	else
		jUnit:SetMoves(0)
		if jUnit:GetPlot():IsVisible(Game.GetActiveTeam()) then
			local hex = ToHexFromGrid(Vector2(jUnit:GetX(), jUnit:GetY()));
			Events.GameplayFX(hex.x, hex.y, -1);
		end
	end
	iPlot:SetSpecialControl(true)
	gT.Forts[iPlot:GetPlotIndex()] = {Player = iPlayer, Type = type, AdjacentPlots = adjPlots, ControlPlayer = iPlayer, Malbork = bMalbork}
	if bFeitoria then
		gT.Forts[iPlot:GetPlotIndex()].Feitoria = true;
		gT.Forts[iPlot:GetPlotIndex()].CannotBeUpgraded = true;
		iPlot:SetImprovementType(GameInfoTypes.IMPROVEMENT_FEITORIA, -1)
		MakeLandPlotSwimmable(iPlot, iPlayer)
	else
		iPlot:SetImprovementType(ImprotFort[type] or iFort, -1)
		if not ImprotFort[type] then
			print("No fort made with valid type?", type)
		end
	end
	iPlot:SetImprovementPillaged(false);
	iPlot:SetCanHaveYield(false)
	AddSmallInfo(iPlot, nil, "Fort")
end

function MakeLandPlotSwimmable(iPlot, iFeitoriaPlayer)
	iPlot:ChangeAllowsSwimLand(1);
	DoPointPossibleCanalConnection(iPlot, 1, iFeitoriaPlayer)
end

function HighlightProperPlotForNewFort(iPlayer)
	local hTab = {}
	for i = 0, Map:GetNumPlots() - 1, 1 do
		local fPlot = Map.GetPlotByIndex( i );
		if CanBeAFortUpgradeOrNewForPlayer(fPlot, iPlayer) then
			table.insert(hTab, fPlot)
		end
	end
	MapModData.ITGSG = hTab;
end

function CanBeAFortUpgradeOrNewForPlayer(fPlot, iPlayer, bNewOnly)
	local fIndex = fPlot:GetPlotIndex()
	if gT.Forts[fIndex] then
		if (not bNewOnly) then
			if gT.Forts[fIndex].Player == iPlayer then
				if (gT.Forts[fIndex].Type == 1) and (not gT.Forts[fIndex].CannotBeUpgraded) then
					for jUnit in Players[iPlayer]:Units() do
						if jUnit:GetDamage() == 0 then
							local jID = jUnit:GetID() .. "," .. iPlayer .. "," .. jUnit:GetGameTurnCreated();
							if fIndex == gT.FortsByUnitID[jID] then
								return true;
							end
						end
					end
				end
			end
		end
	elseif fPlot:IsRevealed(Players[iPlayer]:GetTeam()) then
		if IfCanBeFortTrivial(fPlot) then
			if not FortAdjacentToThePlot(fPlot, HasPlayerTech(iPlayer, techANCemp7, "vbfadeef")) then
				if CanBeFortForPlayer(fPlot, iPlayer) then
					return true;
				end
			end
		end
	end
	return false;
end

function CanBeFortForPlayer(fPlot, fPlayer, bOnlyFreeSpace)
	if (not bOnlyFreeSpace) and (fPlot:GetResourceType(Players[fPlayer]:GetTeam()) ~= -1) then
		return false;
	end	
	if fPlot:GetOwner() == fPlayer or fPlot:GetOwner() == -1 then
		if bOnlyFreeSpace or (fPlot:GetNumUnits() == 0 or (fPlot:GetUnit(0):GetOwner() == fPlayer and GameInfo.Units[fPlot:GetUnit(0):GetUnitType()].StackITGType ~= -2)) then
			return true;
		end
	else
		local nPlayer = fPlot:GetOwner();
		if Teams[Players[fPlayer]:GetTeam()]:IsAtWar(Players[nPlayer]:GetTeam()) then
			local bEnemy = false;
			for i = 0, fPlot:GetNumUnits() - 1 do
				local iUnit = fPlot:GetUnit(i)
				if iUnit:GetITGStackType() ~= -2 then
					if iUnit:GetOwner() == fPlayer then
						return true;
					elseif iUnit:GetOwner() == nPlayer then
						bEnemy = true;
					end
				end
			end
			if bOnlyFreeSpace and (not bEnemy) then
				return true;
			end
		end
	end
	return false;
end

function IfCanBeFortTrivial(fPlot, bCheckRes)
	if not fPlot:IsImpassable() then
		if not fPlot:IsWater() then
			if not fPlot:IsMountain() then
				if not fPlot:IsCity() then
					if (not bCheckRes) or (fPlot:GetResourceType(-1) == -1) then
						if fPlot:GetImprovementType() == -1 or ValidFortImproTab[fPlot:GetImprovementType()] then
							return true;
						end
					end
				end
			end
		end
	end
	return false;
end

function UpgradeFort(pPlot, iPlayer)
	local fIndex = pPlot:GetPlotIndex()
	local type = 2;
	local jUnit;
	for iUnit in Players[iPlayer]:Units() do
		local jID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
		if fIndex == gT.FortsByUnitID[jID] then
			jUnit = iUnit;
		end
	end


	DoAcquireExtraPlotsForFort(iPlayer, pPlot, 2, fIndex)
	
	jUnit:SetBaseCombatStrength(GetPlayerStrengthForFort(iPlayer, type));
	jUnit:SetBaseRangedCombatStrength(GetPlayerRangedStrengthForFort(iPlayer, type))
	if gT.Globals.ScenarioType == 5 then
		jUnit:SetHasPromotion(GameInfoTypes.PROMOTION_CARGO_IV, true);
		jUnit:SetHasPromotion(GameInfoTypes.PROMOTION_CARGO_II, false);
	end
	gT.Forts[fIndex].Type = type;
	pPlot:SetImprovementType(ImprotFort[type] or iFort, -1)
	if not ImprotFort[type] then
		print("No fort made with valid type?", type)
	end
	if pPlot:IsVisible(Game.GetActiveTeam()) then
		local hex = ToHexFromGrid(Vector2(pPlot:GetX(), pPlot:GetY()));
		Events.GameplayFX(hex.x, hex.y, -1);
	end
end

function PlayerChosesFortUpgradeOrNewOnPlot(pPlot, iPlayer, bFree, bHighlight)
	if CanBeAFortUpgradeOrNewForPlayer(pPlot, iPlayer) then
		local fIndex = pPlot:GetPlotIndex()
		if not bFree then
			gT.Players[iPlayer].NumFortPoints = gT.Players[iPlayer].NumFortPoints - 1;
		end
		if gT.Forts[fIndex] then
			UpgradeFort(pPlot, iPlayer)
		else
			CreateNewFortForPlayer(iPlayer, pPlot, 1, false)
		end
		if bHighlight then
			if pPlot:IsRevealed(Game.GetActiveTeam()) then
				local hex = ToHexFromGrid(Vector2(pPlot:GetX(), pPlot:GetY()));
				Events.GameplayFX(hex.x, hex.y, -1);
			end
		end
	end
end

function AssignAINewFortPoint(iPlayer)
	HighlightProperPlotForNewFort(iPlayer)
	local hTab = MapModData.ITGSG;
	MapModData.ITGSG = nil;
	if hTab[1] then
		hTab = Shuffle(hTab);
		local nTab, maxval = {}, 0;
		for i, plot in pairs(hTab) do
			local val = GetPlotValueToBeAFort(plot)
			table.insert(nTab, {plot, val})
			maxval = math.max(maxval, val)
		end
		for i, data in pairs(nTab) do
			if data[2] >= maxval - 5 then
				PlayerChosesFortUpgradeOrNewOnPlot(data[1], iPlayer)
				return
			end
		end
	end
end

function DirtyPlayerForts(iPlayer)
	for iUnit in Players[iPlayer]:Units() do
		local jID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
		if gT.FortsByUnitID[jID] then
			local fIndex = gT.FortsByUnitID[jID];
			local type = gT.Forts[fIndex].Type;
			iUnit:SetBaseCombatStrength(GetPlayerStrengthForFort(iPlayer, type));
			iUnit:SetBaseRangedCombatStrength(GetPlayerRangedStrengthForFort(iPlayer, type))
		elseif gT.ColoniesByUnitID[jID] then
			if gT.Players[iPlayer].CultBonusOn[41] then
				iUnit:SetBaseCombatStrength(GetPlayerStrengthForFort(iPlayer, 1));
				iUnit:SetBaseRangedCombatStrength(GetPlayerRangedStrengthForFort(iPlayer, 1))
			end
		elseif gT.HolySitesUnits[jID] then
			if gT.Players[iPlayer].CultBonusOn[42] then
				iUnit:SetBaseCombatStrength(GetPlayerStrengthForFort(iPlayer, 1));
				iUnit:SetBaseRangedCombatStrength(GetPlayerRangedStrengthForFort(iPlayer, 1))
			end
		end
	end
end

function DirtyUpdateAllFortsPower()
	for i,v in pairs(gT.Players) do
		DirtyPlayerForts(i)
	end
end

function MakeJumpAwayFromSpecialPoint(iPlayer, iPlot)
	local bTab = {}
	for i = 0, iPlot:GetNumUnits() - 1 do
		local iUnit = iPlot:GetUnit(i);
		if iUnit:GetOwner() ~= iPlayer then
			if GameInfo.Units[iUnit:GetUnitType()].StackITGType ~= -2 then
				if not iUnit:IsImmobile() then
					table.insert(bTab, iUnit)
				end
			end
		end
	end
	for i, iUnit in pairs(bTab) do
		iUnit:JumpToNearestValidPlot();
	end
end

function TakeControlOverPlotBonuses(iPlayer, iPlot)
--	if gT.Players[iPlayer] then
--	end
end

function ConquerSpecialPlotBonuses(iPlayer, iPlot, iUnit)
	if gT.Players[iPlayer] then
		if gT.Players[iPlayer].CultBonusOn[147] and iUnit then
			local index = iPlot:GetPlotIndex();
			if not gT.Players[iPlayer].Cult147T[index] then
				local hTxt, hFloat = ObtainRewardFromGoodyHut(iPlayer, iPlot, iUnit);
				if iPlayer == Game.GetActivePlayer() then
					if hTxt then
						Events.GameplayAlertMessage(hTxt)
					end
					if hFloat then
						Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(iPlot:GetX(),iPlot:GetY()))), hFloat, 0.5)
					end
				end
			end
		end
	end
end

function SpawnFortUnit(iPlayer, iPlot, fType, iDamage)
	local jUnit = GetNewFortUnit(iPlayer, iPlot, fType)
	FortUnitGarrisonWasCreatedForPlayer(jUnit, iPlayer, fType)
	jUnit:SetDamage(iDamage or 75);
	if (not gT.Players[iPlayer]) or (not gT.Players[iPlayer].CultBonusOn[79]) then
		if gT.Globals.GameGenerated then
			jUnit:SetMoves(0);
		end
	end
	local jID = jUnit:GetID() .. "," .. iPlayer .. "," .. jUnit:GetGameTurnCreated();
	if gT.Players[iPlayer] then
		gT.Players[iPlayer].UnitsByID[jID] = {XP = 0}
	end
	gT.FortsByUnitID[jID] = iPlot:GetPlotIndex();
	if gT.Globals.ScenarioType == 5 then
		jUnit:SetHasPromotion(GameInfoTypes.PROMOTION_ITG_GARRISON_DEFENSE_AGAINST_SEA,false) -- in 5th era it is too much;
	end
	TakeControlOverPlotBonuses(iPlayer, iPlot)
	return jUnit;
end

function SpawnElDoradoUnit(iPlayer, iPlot)
	local jUnit = Players[iPlayer]:InitUnit(uGarrison, iPlot:GetX(), iPlot:GetY())
	if not gT.Players[iPlayer].CultBonusOn[79] then
		jUnit:SetMoves(0);
	end
	jUnit:SetBaseCombatStrength(17);
	jUnit:SetBaseRangedCombatStrength(17)
	jUnit:SetDamage(75);
	local jID = jUnit:GetID() .. "," .. iPlayer .. "," .. jUnit:GetGameTurnCreated();
	gT.Players[iPlayer].UnitsByID[jID] = {XP = 0} -- barb should never spawn here
	gT.ElDoradoByUnitID[jID] = iPlot:GetPlotIndex();
end

function GetNewFortUnit(iPlayer, iPlot, fType)
	local nUnit = Players[iPlayer]:InitUnit(uGarrison, iPlot:GetX(), iPlot:GetY())
	if not nUnit then
		print("Fort Check", iPlayer, iPlot:GetX(), iPlot:GetY(), fType, uGarrison)
	end
	nUnit:SetBaseCombatStrength(GetPlayerStrengthForFort(iPlayer, fType));
	nUnit:SetBaseRangedCombatStrength(GetPlayerRangedStrengthForFort(iPlayer, fType))
	return nUnit;
end

function GetNewHolySiteUnit(iPlayer, iPlot)
	local nUnit = Players[iPlayer]:InitUnit(uProphet, iPlot:GetX(), iPlot:GetY())
	nUnit:SetMaxXPValue(0)
	nUnit:SetBaseCombatStrength(GetBaseCombatStrengthOfHolySites(iPlayer, iPlot:GetPlotIndex()));
	return nUnit;
end

function GetNewColonyUnit(iPlayer, iPlot)
	local nUnit = Players[iPlayer]:InitUnit(uColonyWorker, iPlot:GetX(), iPlot:GetY())
	nUnit:SetMaxXPValue(0)
	nUnit:SetBaseCombatStrength(GetBaseCombatStrengthOfColony(iPlayer, iPlot:GetPlotIndex()));
	return nUnit;
end

function SpawnHolySiteUnit(iPlayer, iPlot, iDamage)
	local jUnit;
	if gT.Players[iPlayer] and gT.Players[iPlayer].CultBonusOn[42] then
		jUnit = GetNewFortUnit(iPlayer, iPlot, 1)
	else
		jUnit = GetNewHolySiteUnit(iPlayer, iPlot);
	end
	jUnit:SetMountainAttritionImmunity(true);
	jUnit:SetDamage(iDamage or 75);
	jUnit:SetMoves(0);
	local jID = jUnit:GetID() .. "," .. iPlayer .. "," .. jUnit:GetGameTurnCreated();
	if gT.Players[iPlayer] then
		gT.Players[iPlayer].UnitsByID[jID] = {XP = 0}
	end
	gT.HolySitesUnits[jID] = iPlot:GetPlotIndex();
	TakeControlOverPlotBonuses(iPlayer, iPlot)
end

function SpawnColonyUnit(iPlayer, iPlot, iDamage)
	local jUnit;
	if gT.Players[iPlayer] and gT.Players[iPlayer].CultBonusOn[41] then
		jUnit = GetNewFortUnit(iPlayer, iPlot, 1)
	else
		jUnit = GetNewColonyUnit(iPlayer, iPlot);
	end
	jUnit:SetDamage(iDamage or 75);
	jUnit:SetMoves(0);
	local jID = jUnit:GetID() .. "," .. iPlayer .. "," .. jUnit:GetGameTurnCreated();
	gT.ColoniesByUnitID[jID] = iPlot:GetPlotIndex();
	if gT.Players[iPlayer] then
		gT.Players[iPlayer].UnitsByID[jID] = {XP = 0}
	end
	TakeControlOverPlotBonuses(iPlayer, iPlot)
	return jUnit;
end

function CheckEmptyFortsAndColonies()
	for fIndex, fdata in pairs(gT.Forts) do
		local iPlot = Map.GetPlotByIndex(fIndex);
	--	if (not gT.Players[fdata.Player]) then --GetDBCulturePlayerInfo(fdata.Player, "CanControlForts") then
			local hasUnit = false;
			for i = 0, iPlot:GetNumUnits() -1 do
				local iUnit = iPlot:GetUnit(i);
				local jID = iUnit:GetID() .. "," .. iUnit:GetOwner() .. "," .. iUnit:GetGameTurnCreated();
				if gT.FortsByUnitID[jID] == fIndex then
					hasUnit = true;
				end
			end
			if not hasUnit then
				gT.Forts[fIndex].UnitRebornTurns = (gT.Forts[fIndex].UnitRebornTurns or 0) + 1;
				if gT.Forts[fIndex].UnitRebornTurns >= 3 then
					local iPlayer = fdata.Player;
					if gT.Players[iPlayer] then
						gT.Forts[fIndex].UnitRebornTurns = gT.Players[iPlayer].BaseUnitRebornTurns;
					else
						gT.Forts[fIndex].UnitRebornTurns = 0;
					end
					if iPlayer ~= gT.Forts[fIndex].ControlPlayer then
						if gT.Players[gT.Forts[fIndex].ControlPlayer] then
							TakeCareOfEventMorale(gT.Forts[fIndex].ControlPlayer, 7)
						end
						gT.Forts[fIndex].ControlPlayer = iPlayer;
						if gT.Players[iPlayer] then
							TakeCareOfEventMorale(iPlayer, 8)
							if gT.Players[iPlayer].HasIdeology[66] then
								DoAddTemporalCurrencyPower(iPlayer, LastRandom(20,30))
							end
						end
					end
					SpawnFortUnit(iPlayer, iPlot, fdata.Type)
					iPlot:SetImprovementPillaged(false);
					MakeJumpAwayFromSpecialPoint(iPlayer, iPlot)
				end
			else
				if Players[fdata.Player]:IsBarbarian() then
					gT.Forts[fIndex].BarbSpawn = gT.Forts[fIndex].BarbSpawn + 1;
					if gT.Forts[fIndex].BarbSpawn >= LastRandom(4, 8) then
						gT.Forts[fIndex].BarbSpawn = 0;
						iPlot:SpawnRandomBarbarian(true, true, true)
					end
				end
			end
--		end
		if fdata.Player ~= iPlot:GetOwner() then
			iPlot:SetOwner(fdata.Player, GetClosestCityIDToPlotOrNil(fdata.Player, iPlot))
		end
	end
	for fIndex, fdata in pairs(gT.Colonies) do
		local iPlot = Map.GetPlotByIndex(fIndex);
		local hasUnit = false;
		for i = 0, iPlot:GetNumUnits() -1 do
			local iUnit = iPlot:GetUnit(i);
			local jID = iUnit:GetID() .. "," .. iUnit:GetOwner() .. "," .. iUnit:GetGameTurnCreated();
			if gT.ColoniesByUnitID[jID] == fIndex then
				hasUnit = true;
			end
		end
		if not hasUnit then
			gT.Colonies[fIndex].UnitRebornTurns = (gT.Colonies[fIndex].UnitRebornTurns or 0) + 1;
			if gT.Colonies[fIndex].UnitRebornTurns == 3 then
				gT.Colonies[fIndex].UnitRebornTurns = 0;
				local iPlayer = fdata.Player;
				gT.Colonies[fIndex].ControlPlayer = iPlayer;
				SpawnColonyUnit(iPlayer, iPlot)
				iPlot:SetImprovementPillaged(false);
				MakeJumpAwayFromSpecialPoint(iPlayer, iPlot)
			end
		end
		if fdata.Player ~= iPlot:GetOwner() then
			iPlot:SetOwner(fdata.Player, GetClosestCityIDToPlotOrNil(fdata.Player, iPlot))
		end
	end
	for fIndex, fdata in pairs(gT.HolySites) do
		local iPlot = Map.GetPlotByIndex(fIndex);
		local hasUnit = false;
		for i = 0, iPlot:GetNumUnits() -1 do
			local iUnit = iPlot:GetUnit(i);
			local jID = iUnit:GetID() .. "," .. iUnit:GetOwner() .. "," .. iUnit:GetGameTurnCreated();
			if gT.HolySitesUnits[jID] == fIndex then
				hasUnit = true;
			end
		end
		if not hasUnit then
			gT.HolySites[fIndex].UnitRebornTurns = (gT.HolySites[fIndex].UnitRebornTurns or 0) + 1;
			if gT.HolySites[fIndex].UnitRebornTurns == 3 then
				gT.HolySites[fIndex].UnitRebornTurns = 0;
				local iPlayer = fdata.Player;
				if gT.Players[gT.HolySites[fIndex].ControlPlayer] then
					TakeCareOfEventMorale(gT.HolySites[fIndex].ControlPlayer, 9, {fIndex})
				end
				if gT.Players[iPlayer] then
					TakeCareOfEventMorale(iPlayer, 10, {fIndex})
				end
				gT.HolySites[fIndex].ControlPlayer = iPlayer;
				SpawnHolySiteUnit(iPlayer, iPlot)
				iPlot:SetImprovementPillaged(false);
				MakeJumpAwayFromSpecialPoint(iPlayer, iPlot)
			end
		end
		if fdata.Player ~= iPlot:GetOwner() then
			iPlot:SetOwner(fdata.Player, GetClosestCityIDToPlotOrNil(fdata.Player, iPlot))
		end
	end
	--El Dorado has a bit different healing mechanics
	for fIndex, fdata in pairs(gT.ElDorados) do
		local iPlot = Map.GetPlotByIndex(fIndex);
		local numunits = 0;
		for i = 0, iPlot:GetNumUnits() -1 do
			local iUnit = iPlot:GetUnit(i);
			local jID = iUnit:GetID() .. "," .. iUnit:GetOwner() .. "," .. iUnit:GetGameTurnCreated();
			if gT.ElDoradoByUnitID[jID] == fIndex then
				numunits = numunits + 1;
			end
		end
		if numunits < 3 then
			if CanEldoRadoHeal(iPlot) then
				gT.ElDorados[fIndex].UnitRebornTurns = (gT.ElDorados[fIndex].UnitRebornTurns or 0) + 1;
				if gT.ElDorados[fIndex].UnitRebornTurns == 3 then
					gT.ElDorados[fIndex].UnitRebornTurns = 0;
					local iPlayer = fdata.Player;
					gT.ElDorados[fIndex].ControlPlayer = iPlayer;
					for i = 1, 3 - numunits do
						SpawnElDoradoUnit(iPlayer, iPlot)
					end
					iPlot:SetImprovementPillaged(false);
					MakeJumpAwayFromSpecialPoint(iPlayer, iPlot)
				end
			else
				gT.ElDorados[fIndex].UnitRebornTurns = 0;
			end
		end
		if fdata.Player ~= iPlot:GetOwner() then
			iPlot:SetOwner(fdata.Player, GetClosestCityIDToPlotOrNil(fdata.Player, iPlot))
		end
	end
end

function CanEldoRadoHeal(iPlot)
	for i = 0, iPlot:GetNumUnits() -1 do
		local nUnit = iPlot:GetUnit(i)
		if nUnit:GetDamage() > 0 then
			return false
		end
	end
	return true;
end

function DoUpdateAllColoniesStrength(i)
	local tabDone = {}
	for iUnit in Players[i]:Units() do
		local jID = iUnit:GetID() .. "," .. i .. "," .. iUnit:GetGameTurnCreated();
		if gT.ColoniesByUnitID[jID] then
			table.insert(tabDone, {gT.ColoniesByUnitID[jID], iUnit:GetDamage()})
			iUnit:Kill(true, i)
		end
	end
	for j, data in pairs(tabDone) do
		SpawnColonyUnit(i, Map.GetPlotByIndex(data[1]), data[2])
	end
end

function DoUpdateAllHolySitesStrength(i)
	local tabDone = {}
	for iUnit in Players[i]:Units() do
		local jID = iUnit:GetID() .. "," .. i .. "," .. iUnit:GetGameTurnCreated();
		if gT.HolySitesUnits[jID] then
			table.insert(tabDone, {gT.HolySitesUnits[jID], iUnit:GetDamage()})
			iUnit:Kill(true, i)
		end
	end
	for j, data in pairs(tabDone) do
		SpawnHolySiteUnit(i, Map.GetPlotByIndex(data[1]), data[2])
	end
end

function GetBaseCombatStrengthOfColony(iPlayer, fIndex)
	return 1;
end

function GetBaseCombatStrengthOfHolySites(iPlayer, fIndex)
	return 1;
end

function GetNumSpecialControlPoint(iPlayer, type, bPillaged)
	local num = 0;
	for index, data in pairs(gT[type]) do
		if data.Player == iPlayer then
			if bPillaged or (not Map.GetPlotByIndex(index):IsImprovementPillaged()) then
				num = num + 1;
			end
		end
	end
	return num;
end

function CheckTemporaryControlOfHolySitesForstETC(teama, teamb)
	for fIndex, fdata in pairs(gT.Colonies) do
		local iPlayer = fdata.Player;
		local team1, team2 = nil, nil;
		if iPlayer ~= nil then
			if Players[iPlayer]:GetTeam() == teama then
				team1, team2 = teama, teamb;
			elseif Players[iPlayer]:GetTeam() == teamb then
				team1, team2 = teamb, teama;
			end
			if team1 then
				if Players[fdata.ControlPlayer]:GetTeam() == team2 then
					ColonyTakeOver(fdata.ControlPlayer, iPlayer, Map.GetPlotByIndex(fIndex))
				end
			end
		end
	end
	for fIndex, fdata in pairs(gT.Forts) do
		local iPlayer = fdata.Player;
		local team1, team2 = nil, nil;
		if iPlayer ~= nil then
			if Players[iPlayer]:GetTeam() == teama then
				team1, team2 = teama, teamb;
			elseif Players[iPlayer]:GetTeam() == teamb then
				team1, team2 = teamb, teama;
			end
			if team1 then
				if Players[fdata.ControlPlayer]:GetTeam() == team2 then
					FortTakeOver(fdata.ControlPlayer, iPlayer, Map.GetPlotByIndex(fIndex))
				end
			end
		end
	end
	for fIndex, fdata in pairs(gT.HolySites) do
		local iPlayer = fdata.Player;
		local team1, team2 = nil, nil;
		if iPlayer ~= nil then
			if Players[iPlayer]:GetTeam() == teama then
				team1, team2 = teama, teamb;
			elseif Players[iPlayer]:GetTeam() == teamb then
				team1, team2 = teamb, teama;
			end
			if team1 then
				if Players[fdata.ControlPlayer]:GetTeam() == team2 then
					HolySiteTakeOver(fdata.ControlPlayer, iPlayer, Map.GetPlotByIndex(fIndex), true)
				end
			end
		end
	end
	for fIndex, fdata in pairs(gT.ElDorados) do
		local iPlayer = fdata.Player;
		local team1, team2 = nil, nil;
		if iPlayer ~= nil then
			if Players[iPlayer]:GetTeam() == teama then
				team1, team2 = teama, teamb;
			elseif Players[iPlayer]:GetTeam() == teamb then
				team1, team2 = teamb, teama;
			end
			if team1 then
				if Players[fdata.ControlPlayer]:GetTeam() == team2 then
					ElDoradoTakeOver(fdata.ControlPlayer, iPlayer, Map.GetPlotByIndex(fIndex))
				end
			end
		end
	end
end

function FortsAndCitadelsLegalPointsPerTurn(iPlayer)
	return 0;
end

function IsAdjacentToColony(x, y)
	for i = 0, 5 do
		local nPlot = Map.PlotDirection(x, y, i);
		if nPlot and gT.Colonies[nPlot:GetPlotIndex()] then
			return true;
		end
	end
	return false;
end