ITGdebug = false;
bEraConversionNow = false;

function DoInitConvTab()
	tempconvinit = {};
end

ITG_CityIntegersTypes = {}
for row in DB.Query("SELECT * FROM CityIntegers") do
	ITG_CityIntegersTypes[row.Type] = row.ID;
end

function GetITGCityInteger(iCity, sType)
	if not ITG_CityIntegersTypes[sType] then
		print("Missing City integer!", sType)
	end
	return iCity:GetITGInteger(ITG_CityIntegersTypes[sType]);
end
function ChangeITGCityInteger(iCity, sType, iChange)
	if not ITG_CityIntegersTypes[sType] then
		print("Missing City integer!", sType)
	end
	iCity:ChangeITGInteger(ITG_CityIntegersTypes[sType], iChange);
end
function SetITGCityInteger(iCity, sType, iValue)
	if not ITG_CityIntegersTypes[sType] then
		print("Missing City integer!", sType)
	end
	iCity:SetITGInteger(ITG_CityIntegersTypes[sType], iValue);
end

ITG_ScenariosTypes = {}
ITG_ScenarioCultures = {}
ITG_ScenarioOrder = {}
function GetPreviousScenario(iScenario)
	for i, scType in pairs(ITG_ScenarioOrder) do
		if ITG_ScenariosTypes[scType] == iScenario then
			if i == 1 then
				return -1;
			end
			return ITG_ScenariosTypes[ITG_ScenarioOrder[i-1]];
		end
	end
	print("Error looking for previous scenario", iScenario)
	return -1;
end

function GetFirstScenarioIndex()
	return ITG_ScenariosTypes[ITG_ScenarioOrder[1]];
end

local tmpScTab = {};
local hSearchString = "NO_NEXT"
function DoSortOutScenarioOrder()
	local bResponse = false;
	for i, data in pairs(tmpScTab) do
		if data[2] == hSearchString then
			table.insert(ITG_ScenarioOrder, 1, data[1])
			hSearchString = data[1];
			bResponse = true;
			break;
		end
	end
	return bResponse;
end

for row in DB.Query("SELECT ID, Type, IFNULL(NextScenario, '" .. hSearchString .. "') AS NS FROM ITG_Scenarios") do
	ITG_ScenariosTypes[row.Type] = row.ID;
	ITG_ScenarioCultures[row.ID] = {}
	table.insert(tmpScTab, {row.Type, row.NS})
end
local iLoopBreak = 1;
while DoSortOutScenarioOrder() and (iLoopBreak < 200) do
	iLoopBreak = iLoopBreak + 1;
end
ITG_GovermentTypes = {}
for row in DB.Query("SELECT * FROM ITG_Goverments") do
	ITG_GovermentTypes[row.Type] = row.ID;
end
ITG_EspDemoTypes = {};
for row in DB.Query("SELECT * FROM ITG_EspionageDemographics") do
	ITG_EspDemoTypes[row.Type] = row.ID;
end

ITG_CultureTypes = {}
ITG_CultureData = {}
ITG_CultureSubcultures = {}
for row in DB.Query("SELECT * FROM ITG_Cultures") do
	local index = row.ID;
	ITG_CultureTypes[row.Type] = index;
	ITG_CultureData[index] = {}
	ITG_CultureSubcultures[index] = {}
	for a, b in pairs(row) do
		ITG_CultureData[index][a] = b
	end
end
ITG_SubcultureTypes = {}
ITG_SubcultureData = {}
ITG_CultureDisabledTechs = {}
for row in DB.Query("SELECT * FROM ITG_Subcultures") do
	local index = row.ID;
	ITG_SubcultureTypes[row.Type] = index;
	ITG_SubcultureData[index] = {}
	for a, b in pairs(row) do
		ITG_SubcultureData[index][a] = b
	end
end
for row in DB.Query("SELECT * FROM ITG_CultureDisabledTechs") do
	if not ITG_CultureDisabledTechs[row.CultureType] then
		ITG_CultureDisabledTechs[row.CultureType] = {};
	end
	ITG_CultureDisabledTechs[row.CultureType][GameInfo.Technologies[row.TechType].ID] = true;
end
for row in DB.Query("SELECT * FROM ITG_ScenarioCultures") do
	table.insert(ITG_ScenarioCultures[ITG_ScenariosTypes[row.ScenarioType]], ITG_CultureTypes[row.CultureType])
end
for row in DB.Query("SELECT * FROM ITG_CultureSubcultures") do
	table.insert(ITG_CultureSubcultures[ITG_CultureTypes[row.CultureType]], ITG_SubcultureTypes[row.SubcultureType])
end

ITG_PalaceTypes = {}
ITG_PalaceUpgradeTypes = {}
for row in DB.Query("SELECT * FROM ITG_Palaces") do
	ITG_PalaceTypes[row.Type] = row.ID;
end
for row in DB.Query("SELECT * FROM ITG_PalaceUpgrades") do
	ITG_PalaceUpgradeTypes[row.Type] = row.ID;
end

function SetCurrentScenarioData(scType)
	MapModData.DBScenario = {}
	DBScenario = {}
	for a, b in pairs(DB.Query("SELECT * FROM ITG_Scenarios WHERE ID = " .. scType)()) do
		DBScenario[a] = b;
		MapModData.DBScenario[a] = b;
	end
	if DBScenario.MF_Resource then
		MF_ResourceIndex = GameInfo.Resources[DBScenario.MF_Resource].ID;
	end
	START_WONDER_TAGS = {};
	for row in DB.Query("SELECT WonderTag FROM ITG_ScenarioWonders WHERE ScenarioType = '" .. DBScenario.Type .. "'") do
		START_WONDER_TAGS[row.WonderTag] = true;
	end
	BASE_DIVIDE_PRESENCE = DBScenario.BaseDividePresence;
	MINT_TECHNOLOGY = GameInfo.Technologies[DBScenario.MintTech].ID;
	BASE_INFANTRY_CLASS = GameInfo.UnitClasses[DBScenario.BaseInfantryClass].ID;
	LuaEvents.ITG_DB_Initialized();
end
dLand = DomainTypes.DOMAIN_LAND
dSea = DomainTypes.DOMAIN_SEA
dAir = DomainTypes.DOMAIN_AIR;
yGold = YieldTypes.YIELD_GOLD
yProduction = YieldTypes.YIELD_PRODUCTION
yScience = YieldTypes.YIELD_SCIENCE
yCulture = YieldTypes.YIELD_CULTURE
yFaith = YieldTypes.YIELD_FAITH
yFood = YieldTypes.YIELD_FOOD
tSnow = GameInfoTypes.TERRAIN_SNOW;
tCoast = GameInfoTypes.TERRAIN_COAST;
tOcean = GameInfoTypes.TERRAIN_OCEAN;
tDesert = GameInfoTypes.TERRAIN_DESERT;
tGrass = GameInfoTypes.TERRAIN_GRASS;
tPlains = GameInfoTypes.TERRAIN_PLAINS;
tTundra = GameInfoTypes.TERRAIN_TUNDRA;
fForest = GameInfoTypes.FEATURE_FOREST;
fJungle = GameInfoTypes.FEATURE_JUNGLE;
fMarsh = GameInfoTypes.FEATURE_MARSH;
rHorse = GameInfoTypes.RESOURCE_HORSE;
rIron = GameInfoTypes.RESOURCE_IRON;
rOil = GameInfoTypes.RESOURCE_OIL;
rCoal = GameInfoTypes.RESOURCE_COAL;
rUran = GameInfoTypes.RESOURCE_URANIUM;
specScientist = GameInfoTypes.SPECIALIST_SCIENTIST;
specArtist = GameInfoTypes.SPECIALIST_ARTIST;
specEngineer = GameInfoTypes.SPECIALIST_ENGINEER;
specMerchant = GameInfoTypes.SPECIALIST_MERCHANT;
CS_QUEST_POLITICS_POINTS = 70;
CS_QUEST_MISSION_POINTS = 30;
CS_QUEST_PROJECT_POINTS = 50;
CS_QUEST_INFLUENCE_POINTS = 10;
CS_QUEST_EXTRA_ANCHOR = 8;
CS_QUEST_REWARD_INFLUENCE = 40;
LEGAL_MIN_CODEX_COST = 3;
YIELD_GOLD_CUSTOMS_HOUSE = 3;
CURRENCY_CUSTOMS_HOUSE = 6;
GOLD_MOD_CUSTOMS_HOUSE = 10;
TRESHOLD_INCREASE_CUSTOMS_HOUSE = 10;
MANUFACTORY_NUM_TRAITS_TO_CHOOSE = 6;
CHATEAU_AUTHORITY = 2;
XP_TO_PROGRESS_SPECIAL_UU = 0.5;
TRESHOLD_SPECIAL_UU_GROWTH_CLASS = 40;
PROGRESS_SPECIAL_UU_TRAINED = 40;
AMOUNT_EXTRA_HIDDEN_LUXURIES = 0.2;
CS_ANCHOR_FROM_PROTECTION = 15;
CS_ANCHOR_FROM_COMMON_GOV = 10;
DIPLOMAT_RIVAL_RATE_MOD = 15;
DIPLOMAT_YOUR_RATE_MOD = 25;
MANUFACTORY_PROD_DIVIDER = 20;
MANUFACTORY_WONDER_DIVIDER = 20;
TCOMBINE_ARMS_PROD_MOD = 15;
CULT_HERITAGE_PRESENCE_VAL = 2;
TURNS_TO_CONSIDER_BARB = 5;
HNG_EXTRA_SPACE = "[ICON_BULLET]"
EST_PLAGUE_PER_CITIES = 8;
DECADENCE_FREE_TRESHOLD = 20;
BASE_MANUFACTORY_PRODUCTION = 2; -- note this should be read from Improvement_Yields
BASE_MANUFACTORY_WONDER_POINTS = 2;
TURNS_WAR_LOCKED_ON_MINOR = 5;
MINOR_CIV_ANCHOR_FASCISM = 10;
RES_IRON_HORSE_GEN_RATIO = 2;
RES_STORED_MAX_TO_GEN_NEW = 20;
FISH_INDUSTRY_PERCENT = 0.5;
LEAGUE_SUPPLY_DEMILITARIZATION = -6;
BASE_INFLUENCE_FROM_GLOBAL_COLONY = 10;
BASE_ART_MOD_PER_PERIOD = 5;
SHINOBI_PROCESS_TRESHOLD = 200;
KRONBORG_PROCESS_TRESHOLD = 300;
LOCAL_GP_CIVIL_PRESENCE = 0.5;
FOREIGN_GP_CIVIL_PRESENCE = 1;
XP_TO_MAX_LIFE_CULT_DEV_40 = 2;
TURNS_WAR_LOCKED_ON_DEF_PACT = 16;
ALPHABET_INFLUENCE_MOD = 20;
MIN_PILGRIMAGE_DISTANCE_HS = 10;
REL_PRESSURE_PILGRIMAGE = 1000;
MAX_MISSIONARY_CHECK = 25;
DOMESTIC_TR_BONUS_DURATION = 6;
ACADEMY_SUPPORT_NO_RANDOM_GOLD = 125;
MIN_DISTANCE_HOLY_SITE = 8;
HOLYSITE_START_FAITH = 3;
HOLYSITE_START_PRESSURE = 6;
HOLYSITE_START_MISSIONARY = 4;
BASE_AV_GOVERNORS = 2;
BASE_GOVERNOR_POWER = 20;
BASE_PLAYER_POWER = 75;
POWER_FROM_PRINCIPLE = 25;
CS_POLITICS_FROM_AUTHORITY = 7;
CS_POLITICS_FROM_CULT_OWNER = 10;
GP_SUPPORT_POWER = 4;
MERITOCRACY_PER_GOLDEN_AGE_POINT = 4;
MAX_EMBARGO_ON_PLAYER = 3;
NUM_CURRENCY_RESOURCES = 3;
NUM_LUXURIES_TOTAL = 11;
INTRIGUE_EFFECTIVENESS_MOD = 2;
CONSTRIPTION_LAW_MOD = 7;
ANARCHY_BASE_CHANCE_CONQUEST = 80;
ANARCHY_BASE_CHANCE_RIOTS = 25;
ANARCHY_MER_CHANCE_CONQUEST = 80;
ANARCHY_MER_CHANCE_RIOTS = 50;
ANARCHY_MER_CHANCE_LEGAL = 40;
CS_INFLUENCE_RATE_DIF_GOV = 10;
UNIT_SUPPLY_WORLD_AT_WAR = 5;
BASE_PLAYER_CITY_GOV_RANGE = 10;
BASE_GOV_CITY_RANGE = 10;
NAT_UNITY_PENALTY_FREE = 60;
NAT_UNITY_BIG_PENALTY = 20;
MAX_RELIGIOUS_UNIFY = 8;
AFTER_COUP_INFLUENCE = 50;
BASE_GP_MIGRATE_PROGRESS = 10;
CODEX_INFLUENCE_FROM_LEAGUE_RES = 10;
CODEX_INFLUENCE_FROM_CITY_STATE = 33;
CODEX_INFLUENCE_FROM_LAW_CHANGED = 5;
ERA_CONV_LAW_CHANGE_WITH_CODEX = 5;
ERA_CONV_LAW_CHANGE_WITHOUT_CODEX = 25;
ERA_CONV_SOCIAL_CHANGE = 20;
ERA_CONV_WONDER_DESIGN_SURE_T = 95;
ERA_CONV_RUINS_FORGOTTEN = 15;
MERC_COST_INCREASE = 10;
BASE_PRESTIGE_ANCHOR = 25;
IDEO_77_CITIES = 5;
LEAGUE_PROPOSE_CD = 4;
AUTHORITY_PRINCIPLE = 5;
CODEX_INF_REDUCE_FROM_PRINCIPLE = -10;
DEF_FROM_ACA_ABILITY = 400;