local indwonder26 = GameInfoTypes.BUILDING_ITG_NEW_INDUSTRIAL_WONDER_26

function GetRealCalculateGoldRate(iPlayer, bTooltip)
	local base = Players[iPlayer]:CalculateGoldRate()
	if bTooltip then
		local mod = 1 + gT.Players[iPlayer].Ideo41;
		if gT.Players[iPlayer].TrialTithe then
			mod = mod - 0.1;		
		end
		base = math.ceil(base * mod);
	end
	return base;
end

function GetITGExtraGoldPerTurn100(iPlayer)
	local base = GetGoldFromTech(iPlayer) + GetGoldFromColonies(iPlayer) + GetGoldFromGreatWorks(iPlayer) + GetPlayer10thBonusFromCaliph(iPlayer) + GetGoldFromHolySites(iPlayer) + GetGoldFromGreatPeople(iPlayer);
	base = base + GetGoldFromTradeRoutesInTime(iPlayer) + GetGoldFromSolvePoority(iPlayer) + GetGoldFromLeagues(iPlayer) + GetGoldFromCasino(iPlayer) + GetGoldFromWorldWideEconomy() + GetGoldFromCityStates(iPlayer)
	base = base + GetGoldFromAuctionDeals(iPlayer) + GetGoldPTFromPancras(iPlayer) + GetPlayerQuarantineCost(iPlayer) + GetPlayerGreatPeopleCost(iPlayer) + GetExtraCostOfMercenaries(iPlayer)
	return base * 100;
end

function GetGoldPTFromPancras(iPlayer)
	return gT.Players[iPlayer].GoldPTPancras;
end

function GetGoldFromAuctionDeals(iPlayer)
	return gT.Players[iPlayer].GoldFromAuctionHouse
end

function GetGoldFromLeagues(iPlayer)
	local base = 0;
	for league, sth in pairs(gT.Leagues) do
		if sth.Members[iPlayer] then
			if sth.Resolutions[49] then
				base = base - 5;
			end
			if sth.Resolutions[53] then
				base = base - 20;
			end
		end
	end
	return base;
end

GameEvents.GameRequestITGGold.Add(function(iPlayer)
	if gT.Players[iPlayer] then
		if not Players[iPlayer]:IsMinorCiv() then
			UpdateUnitCostFromLaws(iPlayer);
		end
		Players[iPlayer]:SetITGGoldRate(GetITGExtraGoldPerTurn100(iPlayer))
	else
		Players[iPlayer]:SetITGGoldRate(0)
	end
end)

function GetGoldFromTech(iPlayer)
	return gT.Players[iPlayer].GoldFromTech;
end

function GetGoldFromGreatPeople(iPlayer)
--	local base = 0;
--	return base * gT.Players[iPlayer].GPYieldsMod;
	return 0;
end

function GetGoldFromColonies(iPlayer)
	local base = 0;
	local curbonus = 2;
	if HasMintAnyCity(iPlayer) then
		curbonus = curbonus + 2;
	end
	for index, data in pairs(gT.Colonies) do
		if data.Player == iPlayer then
			local iPlot = Map.GetPlotByIndex(index);
			if not iPlot:IsImprovementPillaged() then
				if gT.Players[iPlayer].Currencies == iPlot:GetResourceType() then
					base = base + curbonus;
				end
			end
		end
	end
	return base;
end

function GetGoldFromCityStates(iPlayer)
	local b = 0;
	if gT.Players[iPlayer].HasIdeology[6] then
		for v, g in pairs(gT.Players) do
			if Players[v]:IsMinorCiv() and Players[v]:GetAlly() == iPlayer then
				for iCity in Players[v]:Cities() do
					b = b + iCity:GetYieldRateTimes100(yGold) / 200
				end
			end
		end
	end
	if gT.Players[iPlayer].CultBonusOn[95] then
		b = b + 5 * GetNumAlliedCSWithNoSpecialists(iPlayer)
	end
	if gT.Players[iPlayer].HasIdeology[16] then
		local totdifinfluence = 0
		for v, g in pairs(gT.Players) do
			if Players[v]:IsMinorCiv() and Players[v]:GetAlly() == iPlayer then
				local mfriendship = Players[v]:GetMinorCivFriendshipWithMajor(iPlayer)
				local motherf = 0;
				for jv, jg in pairs(gT.Players) do
					if (not Players[jv]:IsMinorCiv()) and (jv ~= iPlayer) then
						motherf = math.max(motherf, Players[v]:GetMinorCivFriendshipWithMajor(jv))
					end
				end
				totdifinfluence = totdifinfluence + mfriendship - motherf
			end
		end
		b = b + math.floor(totdifinfluence / 4)
	end
	return b;
end

function GetGoldFromHolySites(iPlayer)
	local base = 0;
	local iRel = Players[iPlayer]:GetReligionCreatedByPlayer()
	if IsReligionHaveBelief(iRel, GameInfoTypes.BELIEF_ITG_FOUNDER_4) then
		for index, data in pairs(gT.HolySites) do
			if HasActiveReligionHolySite(index, iRel) then
				if not Map.GetPlotByIndex(index):IsImprovementPillaged() then
					base = base + 4 * gT.Players[iPlayer].FounderBeliefModifier;
				end
			end
		end
	end
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_EUROPE_1, "ewrwcewr") then
		base = base + 3 * GetNumSpecialControlPoint(iPlayer, "HolySites", false)
	end
	return base;
end

function GetGoldFromWorldWideEconomy()
	return gT.Globals.WorldWideEconomy;
end

function GetGoldFromGreatWorks(iPlayer)
	local base = 0;
	local sModifier = 1;
	for gpID, hhh in pairs(gT.Players[iPlayer].GreatPeople) do
		local gd = gT.GreatPeople[gpID];
		if gd.Alive and (not gd.Military) and gd.Ability == 9 then
			sModifier = sModifier + 1;
		end
	end
	if gT.Players[iPlayer].HasPlayerWonder[indwonder26] then
		sModifier = sModifier + 1;
	end
	if gT.Players[iPlayer].CultBonusOn[144] then
		base = base + sModifier * gT.Players[iPlayer].NumGreatWorks / 2;
	else
		base = base + sModifier * gT.Players[iPlayer].NumGWoA / 2;
	end
	return base;
end

function ChangeITGGold(iPlayer, bamount, htt)
	if not (gT.Players[iPlayer]) then
		print("Unknown gold player", iPlayer, bamount, htt)
		return;
	end
	local tt = bamount + gT.Players[iPlayer].Gold100/ 100;
	local ttt = math.floor(tt)
	gT.Players[iPlayer].Gold100 = tt - ttt;
	Players[iPlayer]:ChangeGold(ttt)
end

function SpendITGGold(iPlayer, bamount, bInter)
	if (not iPlayer) or (not Players[iPlayer]) then
		print("Error 934", iPlayer, bamount, bInter)
	end
	Players[iPlayer]:ChangeGold(- bamount)
	if bInter then
		ChangeGoldSpendInternally(iPlayer, bamount);
	end
end

GameEvents.PlayerTreasureIncome.Add(function(iPlayer, iGold)
	if not gT.Players[iPlayer] then
		return;
	end
	local iMod = 0;
	if gT.Players[iPlayer].TrialTithe then
		local degold = math.floor(iGold / 10)
		if degold > 0 then
	--		bonus = bonus - degold;
			ChangeITGGold(gT.Players[iPlayer].TrialTithe[2], degold)
			ChangeITGGold(iPlayer, -degold)
			AddToTitheReward(iPlayer, degold)
			iMod = iMod - degold;
		end
	end
	if gT.Players[iPlayer].Ideo41 then
		local degold = math.floor(iGold * gT.Players[iPlayer].Ideo41);
		if degold > 0 then
			ChangeITGGold(iPlayer, degold)
			iMod = iMod + degold;
		end
	end
	--after modifiers
	local incomeTotal = iGold + iMod;
	gT.Players[iPlayer].HapFromIncomeChange = false;
	if gT.Players[iPlayer].HasIdeology[69] then
		if (incomeTotal > gT.Players[iPlayer].PrevTurnGPT or 0) then
			gT.Players[iPlayer].HapFromIncomeChange = true
			ChangeMeritocracy(iPlayer, 2);
			gT.Players[iPlayer].FestivalVarious = gT.Players[iPlayer].FestivalVarious + 2;
		end
	end
	gT.Players[iPlayer].PrevTurnGPT = incomeTotal
end)

function DoInitPrevGPTValues()
	for g, h in pairs(gT.Players) do
		Players[g]:DirtyGoldPerTurn();
		gT.Players[g].PrevTurnGPT = Players[g]:GetCachedGoldRate()
	end
end

function AddToTitheReward(iPlayer, degold)
	gT.Players[iPlayer].TrialTithe[1] = gT.Players[iPlayer].TrialTithe[1] + degold;
	if gT.Players[iPlayer].TrialTithe[3] == 1 then
		local fBoos = math.floor(gT.Players[iPlayer].TrialTithe[1] / 4);
		if fBoos > 0 then
			ChangeITGFaith(iPlayer, fBoos)
			gT.Players[iPlayer].TrialTithe[1] = gT.Players[iPlayer].TrialTithe[1] - fBoos * 4;
		end
	elseif gT.Players[iPlayer].TrialTithe[3] == 2 then
		local fBoos = math.floor(gT.Players[iPlayer].TrialTithe[1] / 5);
		if fBoos > 0 then
			ChangeITGCulture(iPlayer, fBoos)
			gT.Players[iPlayer].TrialTithe[1] = gT.Players[iPlayer].TrialTithe[1] - fBoos * 5;
		end
	else
		local fBoos = math.floor(gT.Players[iPlayer].TrialTithe[1] / 5);
		if fBoos > 0 then
			ChangeITGLegalPointsPercent(iPlayer, fBoos, nil, "Tithe")
			gT.Players[iPlayer].TrialTithe[1] = gT.Players[iPlayer].TrialTithe[1] - fBoos * 5;
		end
	end
end

function GetTitheGoldReduction(iPlayer)
	if gT.Players[iPlayer].TrialTithe then
		return math.max(0, math.floor(GetRealCalculateGoldRate(iPlayer)/10))
	else
		return 0;
	end
end

function GetIdeology41Gold(iPlayer)
	if gT.Players[iPlayer].Ideo41 ~= 0 then
		return math.max(0, math.floor(GetRealCalculateGoldRate(iPlayer) * gT.Players[iPlayer].Ideo41))
	else
		return 0;
	end
end

function GetCultureFromTithe(iPlayer)
	if gT.Players[iPlayer].TrialTithe and (gT.Players[iPlayer].TrialTithe[3] == 2) then
		return math.floor(gT.Players[iPlayer].TrialTithe[1] + GetTitheGoldReduction(iPlayer)/5)
	end
	return 0;
end

function GetFaithFromTithe(iPlayer)
	if gT.Players[iPlayer].TrialTithe and (gT.Players[iPlayer].TrialTithe[3] == 1) then
		return math.floor(gT.Players[iPlayer].TrialTithe[1] + GetTitheGoldReduction(iPlayer)/4)
	end
	return 0;
end

function GetLegalPercentFromTithe(iPlayer)
	if gT.Players[iPlayer].TrialTithe and (gT.Players[iPlayer].TrialTithe[3] == 3) then
		return math.floor(gT.Players[iPlayer].TrialTithe[1] + GetTitheGoldReduction(iPlayer)/5)
	end
	return 0;
end