function DoIncreasePointsTowardGoldenAge(iPlayer, iType, source, amount, bRecheckCost)
	if Players[iPlayer]:IsGoldenAge() then
		if not bRecheckCost then
			if iType == 6 then
				Players[iPlayer]:ChangeGoldenAgeTurns(amount or 1)
			else
				Players[iPlayer]:ChangeGoldenAgeTurns(GetNumTurnsPrelongGoldenAge(iPlayer))
				if source then
					if gT.Players[iPlayer].CanGABeProlonged[source] then
						print("AI just cheated Golden Age duration with", source)
					else
						gT.Players[iPlayer].CanGABeProlonged[source] = 1;
					end
				end
			end
		end
	else
		if not gT.Players[iPlayer].HadGoldenAge then
			if iType then
				local bPoints = amount or GetGoldenAgePointsFromType(iPlayer, iType)
				gT.Players[iPlayer].GoldenAgePointsFrom[iType] = (gT.Players[iPlayer].GoldenAgePointsFrom[iType] or 0) + bPoints;
				gT.Players[iPlayer].TotalGoldenAgePoints = gT.Players[iPlayer].TotalGoldenAgePoints + bPoints;
				if iType ~= 6 then
					ChangeMeritocracy(iPlayer, bPoints * MERITOCRACY_PER_GOLDEN_AGE_POINT)
				end
			end
			if gT.Players[iPlayer].TotalGoldenAgePoints >= GetPointsCostForGoldenEra(iPlayer) then
				Players[iPlayer]:ChangeGoldenAgeTurns(GetPlayerGoldenAgeLength(iPlayer))
				gT.Players[iPlayer].DuringGoldenAge = true;
				DoTriggerIdeologyTenetsOnGoldenAgeOutbreak(iPlayer)
				if gT.Globals.CurrentGoldenAgeLength > 12 then
					gT.Globals.CurrentGoldenAgeLength = gT.Globals.CurrentGoldenAgeLength - 2;
				end
				gT.Players[iPlayer].HadGoldenAge = true;
				if Players[iPlayer]:IsHuman() then
					LuaEvents.ITG_AchievementCompleted(47)
				end
			end
		end
	end
end

function GetPointsCostForGoldenEra(iPlayer)
	local base = 10;
	if gT.Players[iPlayer].SecularState then
		base = base - 2;
	end
	return base;
end

function GetPlayerGoldenAgeLength(iPlayer)

	local tot = gT.Globals.CurrentGoldenAgeLength;
	if gT.Players[iPlayer].HasPlayerWonder[GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_13] then
		tot = tot + 5;
	end
	if gT.Players[iPlayer].HasMinorIdeology[1] then
		tot = tot + 2;
	end
	return tot;
end

function DoDuomoGoldenAgeBonus(iPlayer)
	if Players[iPlayer]:IsGoldenAge() then
		Players[iPlayer]:ChangeGoldenAgeTurns(5)
	elseif gT.Players[iPlayer].HadGoldenAge then
		gT.Players[iPlayer].CanGABeProlonged = {}
		Players[iPlayer]:ChangeGoldenAgeTurns(5)
	end
end


function GetNumTurnsPrelongGoldenAge(iPlayer)
	return 3;
end

function GetGoldenAgePointsFromType(iPlayer, iType)
	if iType ~= 6 and (not gT.Players[iPlayer].GoldenAgePointsFrom[iType]) then
		return 2;
	end
	return 1;
end

function InititalGoldenAge()
	for g, gdata in pairs(gT.Players) do	
		if not Players[g]:IsMinorCiv() then
			if LastRandom(1,10) == 3 then
				gT.Players[g].HadGoldenAge = true;
			else
				for i = 1, 5 do
					if (i ~= 4 or (not gdata.SecularState)) then
						if LastRandom(1, 8) == 3 then
							gT.Players[g].GoldenAgePointsFrom[i] = 2
							gT.Players[g].TotalGoldenAgePoints = gT.Players[g].TotalGoldenAgePoints + 2;
						elseif LastRandom(1, 58) == 3 then
							gT.Players[g].GoldenAgePointsFrom[i] = 3
							gT.Players[g].TotalGoldenAgePoints = gT.Players[g].TotalGoldenAgePoints + 3;
						end
					end
				end
				if gT.Players[g].TotalGoldenAgePoints >= 10 then
					gT.Players[g].HadGoldenAge = true;	
					Players[g]:ChangeGoldenAgeTurns(LastRandom(8,12))
				end
			end
		end
	end
end

function ShouldAIDoGoldenAge(iPlayer, iType, string)
	if Players[iPlayer]:IsGoldenAge() then
		if (not string) or (not gT.Players[iPlayer].CanGABeProlonged[string]) then
			if GetITGGameTurn() + Players[iPlayer]:GetGoldenAgeTurns() + 4 < 100 then
				if Players[iPlayer]:GetGoldenAgeTurns() < 3 then
					return true;
				end
				if Players[iPlayer]:GetGoldenAgeTurns() < 8 then
					if iType == 1 then
						if Players[iPlayer]:GetNumCities() > 4 then
							return true;
						end
					elseif iType == 5 then
						if LastRandom(1,3) == 2 then
							return true;
						end
					else
						return true;
					end
				end
			end
		end
	elseif not (gT.Players[iPlayer].HadGoldenAge) then
		if not gT.Players[iPlayer].AIDedicationToGoldenAge then
			DetermineAIDedicationToGoldenAge(iPlayer)
		end
		if GetITGGameTurn() > 90 then
			return false;
		end
		if gT.Players[iPlayer].HadGoldenAge then
			return false;
		end
		local gTurn = GetITGGameTurn();
		local pointsEarned = GetGoldenAgePointsFromType(iPlayer, iType);
		if gT.Globals.ScenarioType == 3 then --ai delays GA to wait for Ideology Bonus for it
			if gTurn > 35 and (gTurn <= 70) then
				if GetPointsCostForGoldenEra(iPlayer) <= pointsEarned + gT.Players[iPlayer].TotalGoldenAgePoints then
					return false;
				end
			end
		end
		if gT.Players[iPlayer].AIDedicationToGoldenAge > 0 then
			if gT.Players[iPlayer].AIDedicationToGoldenAge == 4 then
				return true;
			elseif gT.Players[iPlayer].AIDedicationToGoldenAge == 3 then
				if gTurn > 50 or (pointsEarned == 2) then
					return true;
				end
			elseif gT.Players[iPlayer].AIDedicationToGoldenAge == 2 then
				if pointsEarned == 2 then
					return true;
				end
			else
				if gTurn > 50 and pointsEarned == 2 then
					return true;
				end
			end
		end
	end
	return false;
end

function DetermineAIDedicationToGoldenAge(iPlayer)
	if Players[iPlayer]:GetNumCities() == 1 then
		if LastRandom(1,4) == 3 or gT.Players[iPlayer].TotalGoldenAgePoints > 5 then
			gT.Players[iPlayer].AIDedicationToGoldenAge = 2;
		elseif LastRandom(1,4) == 2 or gT.Players[iPlayer].TotalGoldenAgePoints > 2 then
			gT.Players[iPlayer].AIDedicationToGoldenAge = 1;
		else
			gT.Players[iPlayer].AIDedicationToGoldenAge = 0;
		end
	elseif Players[iPlayer]:GetNumCities() > 5 then
		if LastRandom(1,17) == 3 and gT.Players[iPlayer].TotalGoldenAgePoints == 0 then
			gT.Players[iPlayer].AIDedicationToGoldenAge = 0;
		elseif LastRandom(1,5) == 2 then
			gT.Players[iPlayer].AIDedicationToGoldenAge = 1;
		elseif LastRandom(1,5) == 3 then
			gT.Players[iPlayer].AIDedicationToGoldenAge = 2;
		elseif LastRandom(1,5) == 4 then
			gT.Players[iPlayer].AIDedicationToGoldenAge = 4;
		else
			gT.Players[iPlayer].AIDedicationToGoldenAge = 3;
		end
	else
		if LastRandom(1,7) == 3 and gT.Players[iPlayer].TotalGoldenAgePoints == 0 then
			gT.Players[iPlayer].AIDedicationToGoldenAge = 0;
		elseif LastRandom(1,5) == 2 or gT.Players[iPlayer].TotalGoldenAgePoints > 7 then
			gT.Players[iPlayer].AIDedicationToGoldenAge = 3;
		elseif LastRandom(1,3) then
			gT.Players[iPlayer].AIDedicationToGoldenAge = 2;
		else
			gT.Players[iPlayer].AIDedicationToGoldenAge = 1;
		end
	end
end

function DoTriggerIdeologyTenetsOnGoldenAgeOutbreak(player, fIdeology)
	if gT.Players[player].HasMinorIdeology[1] and (fIdeology == 1) then -- length fires only if golden age currently on
		Players[player]:ChangeGoldenAgeTurns(2)
	end
	if gT.Players[player].HasMinorIdeology[6] and ((not fIdeology) or fIdeology == 6) then
		gT.Players[player].GPYieldsMod = gT.Players[player].GPYieldsMod + 1;
	end
	--effects
	--on adopted fire' on started fire
end

function OnGoldenAgeEnds(player)
	if gT.Players[player].HasMinorIdeology[6] then
		gT.Players[player].GPYieldsMod = gT.Players[player].GPYieldsMod - 1;
	end
	gT.Players[player].DuringGoldenAge = nil;
end