local pUncontrol = GameInfoTypes.PROMOTION_ITGSC_UNCONTROLLABLE
local iAncTr11 = GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_TRIBE_11;
local iMeso7 = GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_MESOAMERICAN_7;

function AncientRuinsSetXY(iPlayer, iUnit, iPlot, iPlotIndex, uID)
	if Players[iPlayer]:IsBarbarian() then
		return;
	end
	if iUnit and iUnit:IsHasPromotion(pUncontrol) then
		return
	end
	local iTeam = Players[iPlayer]:GetTeam();
	if (not iPlot:AlreadyVisitedGoodyHut(iTeam)) then
		iPlot:SetAlreadyVisitedGoodyHut(iTeam, true)
		if gT.Players[iPlayer].AncientRadarLeft then
			gT.Players[iPlayer].AncientRadarLeft[iPlotIndex] = nil;
		end
		if not gT.Globals.GameGenerated then
			if Players[iPlayer]:IsHuman() then -- == Game.GetActivePlayer() then
				RemoveLabelOnPlot(iPlot, "AncientRuin", nil, nil, iPlayer)
			end
			return
		end
		if Players[iPlayer]:IsMinorCiv() then
			print("Seems that minors wanted into ancient ruins")
			return
		end
		BasicCSMissionCompleteFunc(iPlayer, 12, 1)
		gT.Players[iPlayer].NumAncientRuins = gT.Players[iPlayer].NumAncientRuins + 1;
		gT.Players[iPlayer].LastAncientRuinT = GetITGGameTurn()
		if gT.Players[iPlayer].CultBonusOn[166] then
			if gT.Players[iPlayer].Morale < 5 then
				TakeCareOfEventMorale(iPlayer, 25, {1, "Legends and Myths"}, true)
			end
			local cPlot = GetNextAncientRuinToReveal(iPlayer, iPlot)
			if cPlot then
				cPlot:SetRevealed(Players[iPlayer]:GetTeam(), true)
			end
		end
		local hStrAlert, hStringFloat = ObtainRewardFromGoodyHut(iPlayer, iPlot, iUnit);
		if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_EURO_6, "Czceeaea") then
			if LastRandom(1,100) <= 5 then
				if DoTriggerRandomTechFromGoodyHut(iPlayer) then
					hStrAlert = hStrAlert .. "[NEWLINE]Our scholars managed to rediscover knowledge from the past!"
				end
			end
		end
		local fg = 15 * (gT.Players[iPlayer].WonderRuinsEffects[9] or 0)
		if fg > 0 then
			ChangeITGFaith(iPlayer, fg)
			hStrAlert = hStrAlert .. "[NEWLINE]We gain an extra " .. fg .. " [ICON_PEACE] Faith!"
		end
		if HasPlayerTech(iPlayer, iAncTr11, "lfkfew") then
			AddOneRadiusVisibility(iPlot, iPlayer, "AncientRuinsVisMod")
		end
		if HasPlayerTech(iPlayer, iMeso7, "kdoewkfw") then
			if LastChance(20) then
				local hStrAlert2, hStringFloat2 = ObtainRewardFromGoodyHut(iPlayer, iPlot, iUnit);
				hStrAlert = hStrAlert .. "[NEWLINE]" .. hStrAlert2
				if hStringFloat then
					if hStringFloat2 then
						hStringFloat = hStringFloat .. "[NEWLINE]" .. hStringFloat2
					end
				else
					hStringFloat = hStringFloat2;
				end
			end
		end
		VictoryTaskCompletion(iPlayer, 2)
		if Players[iPlayer]:IsHuman() then
			RemoveLabelOnPlot(iPlot, "AncientRuin", nil, nil, iPlayer)
			if iPlayer == Game.GetActivePlayer() then
				if hStrAlert then
					Events.GameplayAlertMessage(hStrAlert)
				end
				if hStringFloat then
					local hex = ToHexFromGrid(Vector2(iPlot:GetX(),iPlot:GetY()));
					Events.AddPopupTextEvent(HexToWorld(hex), hStringFloat, 0.5)
				end
				LuaEvents.ITGSGTopPanelDirty()
			end
		end
	end
end

function GetValidCityStateForGoodyHutReward(iPlayer, iPlot)
	local iTeam = Players[iPlayer]:GetTeam();
	local maxdis, cccs = 11, nil;
	for g, gdata in pairs(gT.Players) do
		if Players[g]:IsMinorCiv() then
			if Teams[iTeam]:IsHasMet(Players[g]:GetTeam()) and (not Teams[iTeam]:IsAtWar(Players[g]:GetTeam())) then
				local cc = Players[g]:GetCapitalCity();
				if cc then
					local dis = Map.PlotDistance(cc:GetX(), cc:GetY(), iPlot:GetX(), iPlot:GetY());
					if dis < maxdis then
						maxdis = dis;
						cccs = g;
					end
				end
			end
		end
	end
	return cccs;
end

GameEvents.GoodyHutVisitedFirstTime.Add(function(iPlayer, unitID, x, y)
	local iPlot = Map.GetPlot(x, y)
	local iUnit = Players[iPlayer]:GetUnitByID(unitID);
	local uID = unitID .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
	AncientRuinsSetXY(iPlayer, iUnit, iPlot, iPlot:GetPlotIndex(), uID)
end)

function DoTriggerRandomTechFromGoodyHut(iPlayer)
	local tech = GetRandomTechWithProperUniqueWage(iPlayer, {}, false)
	if tech then
		PlayerDiscoverTech(iPlayer, tech, nil, "hDT7")
		return true;
	end
	return false;
end

function DoRetroactiveBonusFromAntiquity(iPlayer)
	local iTeam = Players[iPlayer]:GetTeam();
	for index, info in pairs(gT.Globals.AncientRuins) do
		if Map.GetPlotByIndex(index):AlreadyVisitedGoodyHut(iTeam) then
			if LastChance(5) then
				if not DoTriggerRandomTechFromGoodyHut(iPlayer) then
					return;
				end
			end
		end
	end
end

function AddOneRadiusVisibility(iPlot, iPlayer, text)
	local iTeam = Players[iPlayer]:GetTeam();
	for i = 0, 5 do
		local nPlot = Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), i)
		if nPlot then
			local nIndex = nPlot:GetPlotIndex()
			nPlot:ChangeVisibilityCount(iTeam, 1)
			gT.Players[iPlayer][text][nIndex] = (gT.Players[iPlayer][text][nIndex] or 0) + 1;
		end
	end
	iPlot:ChangeVisibilityCount(iTeam, 1)
	gT.Players[iPlayer][text][iPlot:GetPlotIndex()] = (gT.Players[iPlayer][text][iPlot:GetPlotIndex()] or 0) + 1;
end

function PostNoFreeLandAncientRuins()
	for aIndex, data in pairs(gT.Globals.AncientRuins) do
		local aPlot = Map.GetPlotByIndex(aIndex)
		local aOwner = aPlot:GetOwner();
		if aOwner ~= -1 then
			if not aPlot:AlreadyVisitedGoodyHut(Players[aOwner]:GetTeam()) then
				aPlot:SetAlreadyVisitedGoodyHut(Players[aOwner]:GetTeam(), true)
			end
		end
		PrepareAncientRuinLabel(aPlot)
	end
end

function GetNextAncientRuinToReveal(iPlayer, dPlot)
	local sClosest, dist = nil, 9999;
	local iTeam = Players[iPlayer]:GetTeam();
	for index, data in pairs(gT.Globals.AncientRuins) do
		local iPlot = Map.GetPlotByIndex(index);
		if not iPlot:IsRevealed(iTeam) then
			local dis = Map.PlotDistance(dPlot:GetX(), dPlot:GetY(), iPlot:GetX(), iPlot:GetY());
			if dis < dist then
				if dis < 8 then
					return iPlot;
				end
				sClosest = iPlot;
				dist = dis;
			end
		end
	end
	if dist < 13 then
		return sClosest;
	end
	return nil;
end

function ObtainRewardFromGoodyHut(iPlayer, iPlot, iUnit)
	--science
	--culture
	--faith (if culture group allows)
	--GA points
	--Great Work
	--Wonder Race points
	--XP land
	--XP naval if coastal
	--XP for unit if valid class
	--gold
	local tab = {}
	if GetDBCulturePlayerInfo(iPlayer, "CanHaveFaithGoodyHuts") then
		table.insert(tab, {1, 20})
	end
	--science
	table.insert(tab, {2, 20})
	--culture
	table.insert(tab, {3, 20})
	--GA points
	table.insert(tab, {4, 20})
	--GreatWork
	table.insert(tab, {5, 2})
	if gT.Players[iPlayer].CanWonderRace then
		table.insert(tab, {6, 20})
	end
	if iPlot:IsCoastalLand() then
		if (gT.Players[iPlayer].AdmiralGoody < 100) or (gT.Players[iPlayer].AdmiralGoody < GetGeneratedAdmiralPoints(iPlayer) / 2) then
			table.insert(tab, {7, 15})
		end
	end
	if (gT.Players[iPlayer].GeneralGoody < 100) or (gT.Players[iPlayer].GeneralGoody < GetGeneratedGeneralPoints(iPlayer) / 2) then
		table.insert(tab, {8, 15})
	end
	--gold
	table.insert(tab, {9, 20})
	if iUnit and gT.Players[iPlayer].UnitClassXP[iUnit:GetUnitClassType()] then
		table.insert(tab, {10, 20})
	end
	if Players[iPlayer]:IsGoldenAge() or (not gT.Players[iPlayer].HadGoldenAge) then
		table.insert(tab, {11, 1})
	end
	if GetValidCityStateForGoodyHutReward(iPlayer, iPlot) then
		table.insert(tab, {12, 3})
	end
	--morale
	table.insert(tab, {13, 2})
	if CanHaveMercenaryFromGoodyHut(iPlayer) then
		table.insert(tab, {14, 2})
	end
	--festival chance
	table.insert(tab, {15, 5})
	if gT.Globals.ScenarioType == 3 then
		table.insert(tab, {16, 4})
	end
	--specialization
	if GetBestClassForSpecializationBonus(iPlayer, true) then
		table.insert(tab, {17, 5})
	end
	--governor
	table.insert(tab, {18, 1})
	--meritocracy
	if gT.Players[iPlayer].MeritocracyLevel < 50 then
		table.insert(tab, {19, 1})
	end

	local pick = GetRandomFromBiasedChanceTable(tab)
	local hStrAlert, hStringFloat;
	if pick == 1 then
		local bonus = LastRandom(25,35);
		hStrAlert = "Witnessing the ruins have enriched us spiritually (+" .. bonus .. "[ICON_PEACE]).";
		hStringFloat = "+" .. bonus .. "[ICON_PEACE]";
		ChangeITGFaith(iPlayer, bonus)
	elseif pick == 2 then
		local bonus = LastRandom(25,35);
		hStrAlert = "Investigating the ruins resulted in scientific debate (+" .. bonus .. "[ICON_RESEARCH]).";
		hStringFloat = "+" .. bonus .. "[ICON_RESEARCH]";
		ChangeITGScience(iPlayer, bonus)
	elseif pick == 3 then
		local bonus = LastRandom(25,35);
		hStrAlert = "We could admire the achievements of our ancestors  (+" .. bonus .. "[ICON_CULTURE]).";
		hStringFloat = "+" .. bonus .. "[ICON_CULTURE]";
		ChangeITGCulture(iPlayer, bonus)
	elseif pick == 4 then
		local bonus = LastRandom(30,80);
		hStrAlert = "Our Artists find those ruins to be inspirational  (+" .. bonus .. "[ICON_GREAT_ARTIST]).";
		hStringFloat = "+" .. bonus .. "[ICON_GREAT_ARTIST]";
		BoostArtisticPoints(iPlayer, bonus)
	elseif pick == 5 then
		hStrAlert = "We have found the Great Work of Art in the ruins (+1[ICON_GREAT_WORK]).";
		hStringFloat = "+1[ICON_GREAT_WORK]";
		CreateGreatWorkOfAmount(iPlayer, 1)
	elseif pick == 6 then
		local bonus = LastRandom(25,75);
		hStrAlert = "The architecture of those ruins may help us in our Wonder project (+" .. bonus .. "[ICON_GREAT_ENGINEER]).";
		hStringFloat = "+" .. bonus .. "[ICON_GREAT_ENGINEER]";
		BoostWonderProduction(iPlayer, bonus)
	elseif pick == 7 then
		local bonus = LastRandom(25,35);
		hStrAlert = "It seems that inhabitants of those ruins were advanced sailmen (+" .. bonus .. "[ICON_GREAT_ADMIRAL]).";
		hStringFloat = "+" .. bonus .. "[ICON_GREAT_ADMIRAL]";
		IncreaseAdmiralPointsByNonCombat(iPlayer, bonus)
		gT.Players[iPlayer].AdmiralGoody = gT.Players[iPlayer].AdmiralGoody + bonus;
	elseif pick == 8 then
		local bonus = LastRandom(25,35);
		hStrAlert = "We have found left-overs of some ancient warrior clan (+" .. bonus .. "[ICON_GREAT_GENERAL]).";
		hStringFloat = "+" .. bonus .. "[ICON_GREAT_GENERAL]";
		IncreaseGeneralPointsByNonCombat(iPlayer, bonus)
		gT.Players[iPlayer].GeneralGoody = gT.Players[iPlayer].GeneralGoody + bonus;
	elseif pick == 9 then
		local bonus = LastRandom(40,70);
		hStrAlert = "We have found some valuable items in ruins and decided to not left them behind (+" .. bonus .. "[ICON_GOLD]).";
		hStringFloat = "+" .. bonus .. "[ICON_GOLD]";
		ChangeITGGold(iPlayer, bonus)
	elseif pick == 10 then
		local bonus = LastRandom(10,20)
		hStrAlert = "Our troops have used an area as training ground (+" .. bonus .. "XP).";
		iUnit:ChangeExperience(bonus)
	elseif pick == 11 then
		if Players[iPlayer]:IsGoldenAge() then
			hStrAlert = "The Magnificent look at the glory of the past inspired our people (+1 [ICON_GOLDEN_AGE] TURN).";
			if Players[iPlayer]:IsHuman() then
				LuaEvents.ITG_AchievementCompleted(48)
			end
		else
			hStrAlert = "The Magnificent look at the glory of the past inspired our people (+1 [ICON_GOLDEN_AGE]).";
		end
		hStringFloat = "+1 [ICON_GOLDEN_AGE]";
		DoIncreasePointsTowardGoldenAge(iPlayer, 6)
	elseif pick == 12 then
		local citystate = GetValidCityStateForGoodyHutReward(iPlayer, iPlot)
		hStrAlert = "We have found a relic important to citizens of " .. Players[citystate]:GetName() .. " (+5 [ICON_INFLUENCE] Anchor).";
		Players[citystate]:ChangeMinorCivExtraAnchorWithMajor(iPlayer, 5)
		if not gT.RelicInfluence[citystate] then
			gT.RelicInfluence[citystate] = {}
		end
		gT.RelicInfluence[citystate][iPlayer] = (gT.RelicInfluence[citystate][iPlayer] or 0) + 5;
		hStringFloat = "+5 [ICON_INFLUENCE]"
	elseif pick == 13 then
		local iRewardMorale = LastRandom(4, 7)
		hStrAlert = "We have translated an war epic written on the ancient stelle (+" .. iRewardMorale .. "% [ICON_ITG_MORALE] Morale boost)."
		hStringFloat = "+" .. iRewardMorale .. "% [ICON_ITG_MORALE]"
		TakeCareOfEventMorale(iPlayer, 25, {iRewardMorale, "Ancient Ruins"})
	elseif pick == 14 then
		hStrAlert = "We have found an encampment of famous and adventorous Mercenary group, which decided to join us."
		DoSpawnMercenaryFromGoodyHut(iPlayer, iPlot)
	elseif pick == 15 then
		hStrAlert = "We have discovered remnants of tribe with highly developed celebration rituals (+4% chance for [ICON_ITG_FESTIVAL] Festival)."
		hStringFloat = "+4% [ICON_ITG_FESTIVAL]"
		gT.Players[iPlayer].FestivalVarious = gT.Players[iPlayer].FestivalVarious + 40;
	elseif pick == 16 then
		local bonus = LastRandom(5,8);
		ChangeITGSettlerPoints(iPlayer, bonus, nil, "goodyhut")
		hStringFloat = "+" .. bonus .. " [ICON_ITG_SETTLER]";
		hStrAlert = "Locals awed by supremacy of our civilization decided to join us (+" .. bonus .. " [ICON_ITG_SETTLER] Settler points)."
	elseif pick == 17 then
		local bonus = LastRandom(50, 70);
		local iClass = DoChangeSpecializationProgress(iPlayer, bonus)
		local cUnitType = Players[iPlayer]:GetPlayerUniqueUnit(iClass);
		if cUnitType == -1 then
			cUnitType = GameInfo.UnitClasses[iClass].DefaultUnit;
		end
		hStrAlert = "We have observed local " .. Locale.Lookup(GameInfo.Units[cUnitType].Description) .. " with an extraordinary skills (+" .. bonus .. "[ICON_ITG_SPECIALIZATION]).";
		hStringFloat = "+" .. bonus .. " [ICON_ITG_SPECIALIZATION]";
	elseif pick == 18 then
		CreateNewGovernor(iPlayer, false)	
		hStrAlert = "We have freed a [ICON_ITG_GOVERNOR] nobleman imprisoned by savages."
		hStringFloat = "[ICON_ITG_GOVERNOR]"
	elseif pick == 19 then
		ChangeMeritocracy(iPlayer, 15);
		hStrAlert = "A glimpse on once thriving civilization reduced to ruins have awaken our society (+15 [ICON_ITG_MERITOCRACY] Meritocracy)."
		hStringFloat = "+15[ICON_ITG_MERITOCRACY]"
	end
	return hStrAlert, hStringFloat;
end