local innoTasian5 = GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_ASIA_5;
local innoTasian8 = GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_ASIA_8;
local tInAemp10 = GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_EMPIRE_10;

function DoCodexOverTurn()
	if GetITGGameTurn() >= gT.Globals.NextCodexSolution then
		DoCodexSolution()
	end
end

function GetCodexInfluenceFromLeagues(iPlayer)
	return gT.Players[iPlayer].CodexInfluenceFromLeague;
end

function GetCodexInfluenceFromIdeologies(iPlayer)
	local a = 0;
	if gT.Players[iPlayer].HasIdeology[4] then
		a = a + 50;
	end
	if gT.Players[iPlayer].HasMinorIdeology[15] then
		for iCity in Players[iPlayer]:Cities() do
			if HasWonderOrRuin(iCity) then
				a = a + 15;
			end
		end
	end
	return a;
end

function EnforceCodexForCS(iPlayer, cs)
	gT.Players[cs].CodexFrom = iPlayer;
end

function GetCodexInfluenceFromEspionage(iPlayer)
	return math.floor(gT.Players[iPlayer].EspCodexInfluence);
end

function GetCodexInfluenceFromGP(iPlayer)
	return gT.Players[iPlayer].GPCodexInfluence
end

function GetCodexInfluenceFromAcademies(iPlayer)
	local base = gT.Players[iPlayer].AcaCodexInfluence;
	return base;
end

function GetCodexInfluenceFromConsolidation(iPlayer)
	return gT.Players[iPlayer].ConsCodex;
end

function GetCodexInfluenceFromCityStates(iPlayer)
--uh alive anyway
	local a = 0;
	for g, b in pairs(gT.Players) do
		if b.CodexFrom == iPlayer then
			if Players[g]:IsAlive() then
				a = a + CODEX_INFLUENCE_FROM_CITY_STATE
			end
		end
	end
	return a;
end

function GetCodexInfluenceFromPrinciples(iPlayer)
	local a = gT.Players[iPlayer].InfCodexFromPrinciples;
	return a;
end

function GetCodexInfluenceFromGovernors(iPlayer)
	return gT.Players[iPlayer].GoverCodexInfluence;
end

function GetCodexInfluenceFromLawsChanged(iPlayer)
	return CODEX_INFLUENCE_FROM_LAW_CHANGED * gT.Players[iPlayer].LawsChanged;
end

function ChangeGlobalCodexInfluence(amount, iPlayer)
	gT.Globals.CodexInfReduction = gT.Globals.CodexInfReduction + amount;
	if iPlayer ~= -1 then
		gT.Players[iPlayer].CodexInfGlobal = gT.Players[iPlayer].CodexInfGlobal - amount;
	end
end

function GetCodexInlfuenceFromGlobal(iPlayer)
	local a = gT.Globals.CodexInfReduction + gT.Players[iPlayer].CodexInfGlobal;
	return a;
end

function GetCodexInfluence100(iPlayer)
	if not gT.Players[iPlayer].HasCodex then
		return 50;
	end
	local base = 100;
	base = base + GetCodexInfluenceFromIdeologies(iPlayer);
	base = base + GetCodexInfluenceFromLeagues(iPlayer);
	base = base + GetCodexInfluenceFromCityStates(iPlayer);
	base = base + GetCodexInfluenceFromGP(iPlayer);
	base = base + GetCodexInfluenceFromAcademies(iPlayer);
	base = base + GetCodexInfluenceFromConsolidation(iPlayer);
	base = base + GetCodexInfluenceFromLawsChanged(iPlayer);
	base = base + GetCodexInfluenceFromPrinciples(iPlayer);
	base = base + GetCodexInfluenceFromGovernors(iPlayer);
	base = base + GetCodexInfluenceFromEspionage(iPlayer);
	base = base + GetCodexInlfuenceFromGlobal(iPlayer);
	return math.max(50, base);
end

function GetCodexUIData(iPlayer)
	local aVal = GetCodexInfluence100(iPlayer);
	local hToolTip = "[ICON_ITG_LAWS_INFLUENCE] Codex Influence determines impact on global popularity your laws have."
	local lToolTip = "Amount of adjustable laws."
	if not gT.Players[iPlayer].HasCodex then
		hToolTip = hToolTip .. "[NEWLINE]Since you have no Codex yet, influence is set to [COLOR_NEGATIVE_TEXT]50%[ENDCOLOR].";
	else
		local hTab = {};
		table.insert(hTab, {"Base", 100})
		table.insert(hTab, {"Ideologies", GetCodexInfluenceFromIdeologies(iPlayer)})
		table.insert(hTab, {"Leagues", GetCodexInfluenceFromLeagues(iPlayer)})
		table.insert(hTab, {"City-States", GetCodexInfluenceFromCityStates(iPlayer)})
		table.insert(hTab, {"Great People", GetCodexInfluenceFromGP(iPlayer)})
		table.insert(hTab, {"Academies", GetCodexInfluenceFromAcademies(iPlayer)})
		table.insert(hTab, {"Governors", GetCodexInfluenceFromGovernors(iPlayer)})
		table.insert(hTab, {"Consolidation", GetCodexInfluenceFromConsolidation(iPlayer)})
		table.insert(hTab, {"Laws Changed", GetCodexInfluenceFromLawsChanged(iPlayer)})
		table.insert(hTab, {"Propaganda", GetCodexInfluenceFromEspionage(iPlayer)})
		table.insert(hTab, {"Principles", GetCodexInfluenceFromPrinciples(iPlayer)})
		table.insert(hTab, {"Rival Effects", GetCodexInlfuenceFromGlobal(iPlayer)})
		for a, v in pairs(hTab) do
			if v[2] > 0 then
				hToolTip = hToolTip .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]+" .. v[2] .. "%[ENDCOLOR] from " .. v[1] .. ".";
			elseif v[2] < 0 then
				hToolTip = hToolTip .. "[NEWLINE][ICON_BULLET][COLOR_NEGATIVE_TEXT]" .. v[2] .. "%[ENDCOLOR] from " .. v[1] .. ".";
			end
		end
		hToolTip = hToolTip .. "[NEWLINE]TOTAL: [COLOR_POSITIVE_TEXT]" .. aVal .. "%[ENDCOLOR] [ICON_ITG_LAWS_INFLUENCE]."
		if gT.Players[iPlayer].CodexInfluencePercent then
			hToolTip = hToolTip .. "[NEWLINE][NEWLINE]Last time the laws were compared our Codex was " .. gT.Players[iPlayer].CodexInfluencePercent .. "% influential in global scale and " .. gT.Players[iPlayer].CodexLawFavoured .. " of our laws are currently considered as universal."
			lToolTip = lToolTip .. "[NEWLINE][NEWLINE]" .. gT.Players[iPlayer].CodexLawFavoured .. " of our laws are currently considered as universal."
		end
	end
	return {aVal, hToolTip, #GetAdjustableLaws(iPlayer), lToolTip}
end

function DoAdjustRivalCodexInfluenceEffects()
	for i, v in pairs(gT.Globals.CodexInfPrinciples) do
		ChangeGlobalCodexInfluence(-CODEX_INF_REDUCE_FROM_PRINCIPLE, v);
	end
	gT.Globals.CodexInfPrinciples = {};
	local aTab = {0, 0, 0, 0, 0, 0}
	local aPlayers = {-1, -1, -1, -1, -1, -1}
	local function DoPrincipleCodexInfluenceAdjustment(g, val, index, bHasReward)
		if (val or -1) >= aTab[index] then
			if val == aTab[index] then
				aPlayers[index] = -1;
			else
				aTab[index] = val;
				if gT.Players[g].GovRewards[index + 6] then
					aPlayers[index] = g;
				end
			end
		end
	end
	for g, h in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			if Players[g]:GetNumCities() > 0 then
				DoPrincipleCodexInfluenceAdjustment(g, h.MeritocracyLevel, 1)
				DoPrincipleCodexInfluenceAdjustment(g, h.UnitKilled, 2)
				DoPrincipleCodexInfluenceAdjustment(g, h.NatUnity, 3)
				DoPrincipleCodexInfluenceAdjustment(g, GetNumAlliedCS(g), 4)
				DoPrincipleCodexInfluenceAdjustment(g, (GetNumOfGPCivilOfType(g) + GetNumOfGPCivilOfType(g, 1) + GetNumOfGPCivilOfType(g, 2)), 5)
				DoPrincipleCodexInfluenceAdjustment(g, h.CodexStrength, 6)
			end
		end
	end
	for i, v in pairs(aPlayers) do
		if v ~= -1 then
			ChangeGlobalCodexInfluence(CODEX_INF_REDUCE_FROM_PRINCIPLE, v);
			table.insert(gT.Globals.CodexInfPrinciples, v)
		end
	end
end

function GetCalculatedCodexStrengths()
	local pTab = {}
	local hTab = {};
	local ciTotal = 0;
	local maxPower = {};
	DoAdjustRivalCodexInfluenceEffects()
	for g, h in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			if h.HasCodex then
				hTab[g] = 0;
				maxPower[g] = 0;
				gT.Players[g].CodexLawFavoured = 0;
			end
			local gInfluence = GetCodexInfluence100(g);
			ciTotal = ciTotal + gInfluence;
			pTab[g] = gInfluence;
		end
	end
	for law, data in pairs(GetLawsDataTable()) do
		local tot = 0;
		local aValuigi = 0;
		local options = {};
		local lP = {}
		for gPlayer, gInfluence in pairs(pTab) do
			if CanPlayerHaveLaw(gPlayer, law) then
				tot = tot + gInfluence;
				aValuigi = aValuigi + 1;
				table.insert(lP, gPlayer)
				options[gT.Players[gPlayer].Laws[law][1]] = (options[gT.Players[gPlayer].Laws[law][1]] or 0) + gInfluence;
			end
		end
		if aValuigi > 1 then
			aValuigi = math.min(aValuigi, 5);
			local bestScore, bestOption = 0, nil;
			for a, b in pairs(options) do
				if b > bestScore then
					bestOption = a;
					bestScore = b;
				elseif b == bestScore then
					bestOption = nil;
				end
			end
			for j, g in pairs(lP) do
				if hTab[g] then
					if gT.Players[g].Laws[law][1] == bestOption then
						hTab[g] = hTab[g] + aValuigi;
						maxPower[g] = maxPower[g] + aValuigi;
						gT.Players[g].CodexLawFavoured = gT.Players[g].CodexLawFavoured + 1;
					elseif bestOption then
						maxPower[g] = maxPower[g] + aValuigi;
					else
						maxPower[g] = maxPower[g] + 1;
					end
				end
			end
		end
	end
	local prerefined = {}
	local prefmax = 1;
	for g, v in pairs(hTab) do
		prerefined[g] = math.floor(100 * v / math.max(1, maxPower[g]));
		prefmax = math.max(prefmax, prerefined[g])
	end
	local finalTab = {}
	for g, v in pairs(prerefined) do
		finalTab[g] = math.floor(200 * v / (100 + prefmax))
		gT.Players[g].CodexInfluencePercent = math.floor(100 * pTab[g] / ciTotal);
		-- here achievement
		if gT.Players[g].CodexInfluencePercent > 50 then
			if Players[g]:IsHuman() then
				LuaEvents.ITG_AchievementCompleted(122)
			end
		end
	end
	return finalTab;
end

function DoCodexSolution(bSpecial)
	gT.Globals.NextCodexSolution = GetITGGameTurn() + 5;
	gT.Globals.BestCodex = 0;
	local pTab = GetCalculatedCodexStrengths();
	for player, new in pairs(pTab) do
		local iChange = new - gT.Players[player].CodexStrength;
		gT.Players[player].CodexStrength = new;
		gT.Globals.BestCodex = math.max(gT.Globals.BestCodex, new)
	end
end

LuaEvents.ITGSG_DoLeaderHeadStats.Add(function()
	DoCodexSolution(true)
end)

function GetAIAttitudeTowardCodexStrength(iPlayer)
	local aiEval = 0;
	if gT.Players[iPlayer].HasCodex then
		local flav = GetAIFlavour(iPlayer, "FLAVOR_LEGAL");
		if flav > 5 then
			aiEval = aiEval + 1;
			if flav > 7 then
				aiEval = aiEval + 1;
			end
		end
		if gT.Players[iPlayer].CodexStrength >= 60 then
			aiEval = aiEval + 1;
		end
		for reward, sth in pairs(gT.Players[iPlayer].GovRewards) do
			if RequestGovSlotData(reward).Type == "Codex" then
				aiEval = aiEval + 1;
			end
		end
		aiEval = aiEval + LastRandom(0,1);
		if GetAIFlavour(iPlayer, "FLAVOR_DISRUPTIVE") > 7 then
			aiEval = aiEval + 1;
		end
		--so far, max 7;
		if gT.Players[iPlayer].HasIdeology[75] then
			aiEval = aiEval + 1;
		end
		if HasPlayerTech(iPlayer, innoTasian5, "innoTasian5") then
			aiEval = aiEval + 1;		
		end
		if gT.Players[iPlayer].HasIdeology[4] then
			aiEval = aiEval + 1;		
		end
		if HasPlayerTech(iPlayer, innoTasian8, "tasia8") then
			aiEval = aiEval + 1;		
		end
		if HasPlayerTech(iPlayer, tInAemp10, "tanaie") then
			aiEval = aiEval + 1;
		end
	end
	return math.min(aiEval, 10);
end