function CanBeTargetOfEmbargo(iPlayer, i)
	if i ~= iPlayer then
		if not Players[i]:IsMinorCiv() then
			if Teams[Players[iPlayer]:GetTeam()]:IsHasMet(Players[i]:GetTeam()) then
				for l, lld in pairs(gT.Leagues) do
					if lld.Resolutions[7] then
						if lld.Members[iPlayer] and lld.Members[i] then
							return false;
						end
					end
				end
				return true;
			end
		end
	end
	return false;
end

function PreparedCommanderOptions(iPlayer)
	local data = {UniqueOptions = {}, BonusType = 29, SpecialType = "Action", TitleText = "Nominate Commander.", TitleIconIndex = 5, TitleIconAtlas = "BW_ATLAS_1"}
	if gT.Players[iPlayer].FallenGenerals > 0 then
		table.insert(data.UniqueOptions, {Name = "Nominate General",
						ID = 1,
						Help = "You can replace " .. gT.Players[iPlayer].FallenGenerals .. " fallen general(s).";
						})
	end
	if gT.Players[iPlayer].FallenAdmirals > 0 then
		table.insert(data.UniqueOptions, {Name = "Nominate Admiral",
					ID = 2,
					Help = "You can replace " .. gT.Players[iPlayer].FallenAdmirals .. " fallen admiral(s).";
					})
	end
	return data;
end

function PreparedDataForPledge(iPlayer)
	local civ = GameInfo.Civilizations[Players[iPlayer]:GetCivilizationType()];
	local data = {UniqueOptions = {}, BonusType = 26, SpecialType = "Action", TitleText = "Pledge to protect a City-State.", TitleIconIndex = civ.PortraitIndex, TitleIconAtlas = civ.IconAtlas}
	local iTeam = Players[iPlayer]:GetTeam();
	if gT.Players[iPlayer].NumMaxPledges <= #gT.Players[iPlayer].PledgesOfProtection then
		data.TitleText = "[COLOR_NEGATIVE_TEXT]New pledge will remove protection over " .. Players[gT.Players[iPlayer].PledgesOfProtection[1][1]]:GetName() .. "."
	end
--	if gT.Players[iPlayer].NumMaxPledges > #gT.Players[iPlayer].PledgesOfProtection then
		for i, pdata in pairs(gT.Players) do
			if Players[i]:IsMinorCiv() then
				if CanBeProtectedByMajorAction(iPlayer, i) then
					table.insert(data.UniqueOptions, {Name = "Pledge to protect " .. Players[i]:GetName(),
						ID = i,
						Help = "";
						})
				end
			end
		end
--	end
	return data;
end

function PreparedDataForInfluenceImprove(iPlayer)
	local civ = GameInfo.Civilizations[Players[iPlayer]:GetCivilizationType()];
	local data = {UniqueOptions = {}, BonusType = 7, SpecialType = "Action", TitleText = "Improve relations with City-State.", TitleIconIndex = civ.PortraitIndex, TitleIconAtlas = civ.IconAtlas}
	local iTeam = Players[iPlayer]:GetTeam();
	local gTurn = GetITGGameTurn();
	for i, pdata in pairs(gT.Players) do
		if Players[i]:IsMinorCiv() then
			if Players[i]:IsAlive() and (Players[i]:GetNumCities() > 0) then
				if (not gT.Players[iPlayer].LegalCSVisitCD[i]) or (gT.Players[iPlayer].LegalCSVisitCD[i] <= gTurn) then
					local mTeam = Players[i]:GetTeam();
					if Teams[iTeam]:IsHasMet(mTeam) and (not Teams[iTeam]:IsAtWar(mTeam)) then
						local cI = Players[i]:GetMinorCivFriendshipWithMajor(iPlayer);
						local cIs = "[COLOR_POSITIVE_TEXT]" .. cI .. "[ENDCOLOR]";
						if cI < 0 then
							cIs = "[COLOR_NEGATIVE_TEXT]" .. cI .. "[ENDCOLOR]";
						end
						table.insert(data.UniqueOptions, {Name = "Visit " .. Players[i]:GetName() .. " (" .. cIs .. ")",
							ID = i,
							Help = "[NEWLINE]Your [ICON_INFLUENCE] Influence with " .. Players[i]:GetName() .. " will be increased by " .. GetMinorCivFriendshipFromImproveRelation(iPlayer, i) .. ".";
							})	
					end
				end
			end
		end
	end
	return data;
end

function PrepareDataForForeignGovernors(iPlayer)
	local civ = GameInfo.Civilizations[Players[iPlayer]:GetCivilizationType()];
	local data = {UniqueOptions = {}, BonusType = 3, SpecialType = "Action", TitleText = "Invite foreign Governor to your court.", TitleIconIndex = civ.PortraitIndex, TitleIconAtlas = civ.IconAtlas}
	local maxAllowed = 5;
	if gT.Players[iPlayer].CultBonusOn[69] then
		maxAllowed = maxAllowed + 2;
	end
	if GetNumForeignGovernors(iPlayer) + GetNumDiploNotesOfTypeWaiting(iPlayer, 1) < maxAllowed then
		local pTeam = Teams[Players[iPlayer]:GetTeam()];
		for g, h in pairs(gT.Players) do
			if (not Players[g]:IsMinorCiv()) and (Players[g]:IsAlive()) then
				if g ~= iPlayer then
					if pTeam:HasEmbassyAtTeam(Players[g]:GetTeam()) then
						for govID, h in pairs(h.Governors) do
							if not gT.Players[iPlayer].ForeignGovernors[govID] then
								if not IsDiploNoteFromGovernorWaiting(iPlayer, govID, 1) then
									table.insert(data.UniqueOptions, {Name = "Invite " .. Locale.Lookup(gT.Globals.Governors[govID].Name),
									ID = govID,
									PortraitIndex = gT.Globals.Governors[govID].PIndex, 
									IconAtlas = gT.Globals.Governors[govID].IconAtlas,
									Help = "[NEWLINE]You will establish relations with [ICON_ITG_GOVERNOR] Governor from " .. Players[g]:GetCivilizationShortDescription() .. ".";
									})	
								end
							end
						end
					end
				end
			end
		end
	end
	return data;
end

function PreparedDataForEnforceCodex(iPlayer)
	local civ = GameInfo.Civilizations[Players[iPlayer]:GetCivilizationType()];
	local data = {UniqueOptions = {}, BonusType = 36, SpecialType = "Action", TitleText = "Persuade City-State to adopt your Codex.", TitleIconIndex = civ.PortraitIndex, TitleIconAtlas = civ.IconAtlas}
	if gT.Players[iPlayer].HasCodex then
		for i, pdata in pairs(gT.Players) do
			if Players[i]:IsMinorCiv() then
				if Players[i]:IsAlive() then
					if Players[i]:GetAlly() == iPlayer then
						if iPlayer ~= pdata.CodexFrom then
							if Players[i]:GetNumCities() > 0 then
								if pdata.CodexFrom and Teams[Players[iPlayer]:GetTeam()]:IsHasMet(Players[pdata.CodexFrom]:GetTeam()) then
									table.insert(data.UniqueOptions, {Name = "Regulate [COLOR_POSITIVE_TEXT]" .. Players[i]:GetName(),
									ID = i,
									Help = "[NEWLINE]" .. Players[i]:GetName() .. " will replace [COLOR_YELLOW]" .. Players[pdata.CodexFrom]:GetCivilizationAdjective() .. "[ENDCOLOR] with your Codex.";
									})	
								else
									table.insert(data.UniqueOptions, {Name = "Regulate [COLOR_POSITIVE_TEXT]" .. Players[i]:GetName(),
									ID = i,
									Help = "[NEWLINE]" .. Players[i]:GetName() .. " will adopt your Codex.";
									})	
								end
							end
						end
					end
				end
			end
		end
	end
	return data;
end

function PreparedDataForEnforcingOfficialReligion(iPlayer)
	local civ = GameInfo.Civilizations[Players[iPlayer]:GetCivilizationType()];
	local data = {UniqueOptions = {}, BonusType = 8, SpecialType = "Action", TitleText = "Persuade City-State to adopt your official Religion.", TitleIconIndex = civ.PortraitIndex, TitleIconAtlas = civ.IconAtlas}
	local iRel = gT.Players[iPlayer].OfficialReligion;
	if not gT.Players[iPlayer].SecularState then
		if iRel then
			for i, pdata in pairs(gT.Players) do
				if Players[i]:IsMinorCiv() then
					if Players[i]:IsAlive() then
						if Players[i]:GetAlly() == iPlayer then
							if iRel ~= pdata.OfficialReligion then
								local cc = Players[i]:GetCapitalCity();
								if cc then
									local cRel = cc:GetReligiousMajority()
									if cRel >= 0 then
										table.insert(data.UniqueOptions, {Name = "Enlighten " .. Players[i]:GetName() .. " (" .. GameInfo.Religions[cRel].IconString .. ")",
											ID = i,
											Help = "[NEWLINE]" .. Players[i]:GetName() .. " will adopt " .. GameInfo.Religions[iRel].IconString .. " " .. Locale.Lookup(Game.GetReligionName(iRel)) .. " as their official religion.";
											})	
									else
											table.insert(data.UniqueOptions, {Name = "Enlighten " .. Players[i]:GetName(),
										ID = i,
										Help = "[NEWLINE]" .. Players[i]:GetName() .. " will adopt " .. GameInfo.Religions[iRel].IconString .. " " .. Locale.Lookup(Game.GetReligionName(iRel)) .. " as their official religion.";
										})	
									end
								end
							end
						end
					end
				end
			end
		end
	end
	return data;
end

function PreparedDataForEmbassyAction(iPlayer)
	local civ = GameInfo.Civilizations[Players[iPlayer]:GetCivilizationType()];
	local data = {BonusType = 6, SpecialType = "Action", TitleText = "Establish the International Relations.", TitleIconIndex = civ.PortraitIndex, TitleIconAtlas = civ.IconAtlas}
	local hTab = {}
	local iTeam = Players[iPlayer]:GetTeam();
	for i, pdata in pairs(gT.Players) do
		if CanEstablishEmbassyWithPlayer(iPlayer, iTeam, i) then
			table.insert(hTab, {Name = "Establish Embassy",
				ID = i,
				PortraitIndex = GameInfo.Civilizations[Players[i]:GetCivilizationType()].PortraitIndex,
				IconAtlas = GameInfo.Civilizations[Players[i]:GetCivilizationType()].IconAtlas,
				Help = "[NEWLINE]Establish Embassy in " ..  Players[i]:GetCivilizationAdjective() .. " Capital, allowing you to establish city-connections through this civilization's territory, and also increasing both sides Legal rights each turn and helps your spies in rival territory.";
				})	
		end
	end
	data.UniqueOptions = hTab;
	return data;
end

function CanEstablishEmbassyWithPlayer(iPlayer, iTeam, toPlayer)
	if toPlayer ~= iPlayer then
		if not Players[toPlayer]:IsMinorCiv() then
			if Players[toPlayer]:GetNumCities() > 0 then
				if Teams[iTeam]:IsHasMet(Players[toPlayer]:GetTeam()) then
					if not Teams[iTeam]:IsAtWar(Players[toPlayer]:GetTeam()) then
						if not Teams[iTeam]:HasEmbassyAtTeam(Players[toPlayer]:GetTeam()) then
							return true;
						end
					end
				end
			end
		end
	end
	return false
end

function GetAIValueToEmbassyPlayer(iPlayer, ePlayer)
	if gT.Players[iPlayer].Goverment == 1 then
		return 0;
	end
	local emb = LastRandom(25,35)
	local gTurn = GetITGGameTurn();
	for i, logdata in pairs(gT.Players[iPlayer].EspionageLog) do
		local difturns = gTurn - logdata[1];
		if logdata[5] == g then
			if logdata[3] == 6 then
				if difturns < 10 then
					emb = emb - 4;
				else
					emb = emb - 2;
				end
			elseif logdata[3] == 2 then
				emb = emb - 1;
			end
		end
	end

	return emb;
end

function GetAIValueToEmbargoPlayer(iPlayer, ePlayer)
	local emb = GetAIFlavour(iPlayer, "FLAVOR_DISRUPTIVE");
	if Players[iPlayer]:IsDoF(ePlayer) then
		emb = emb - 50;
	end
	if Players[iPlayer]:IsDenouncingPlayer(ePlayer) then
		emb = emb + 20;
	end
	if Players[ePlayer]:IsDenouncingPlayer(iPlayer) then
		emb = emb + 5;
	end
	emb = emb + 8 * (gT.Players[ePlayer].Embargos[iPlayer] or 0);
	if gT.Players[ePlayer].MintBonus > gT.Players[iPlayer].MintBonus then
		emb = emb + 5;
	end
	emb = emb - 3 + Players[ePlayer]:GetNumCities();
	local gTurn = GetITGGameTurn();
	for i, logdata in pairs(gT.Players[iPlayer].EspionageLog) do
		local difturns = gTurn - logdata[1];
		if logdata[5] == g then
			if logdata[3] == 6 then
				if difturns < 10 then
					emb = emb + 4;
				else
					emb = emb + 2;
				end
			elseif logdata[3] == 2 then
				emb = emb + 1;
			end
		end
	end
	for i, data in pairs(gT.Players[iPlayer].TradeRoutesLost) do
		if data[3] == ePlayer then
			emb = emb + 1;
		end
	end
	for i, data in pairs(gT.Players[ePlayer].SettlerLog) do
		if data[2] == iPlayer then
			emb = emb + 1;
		end
	end
	return emb;
end

function PlayersEmbargoChange(iPlayer, tPlayer, iVal, bNot)
	gT.Players[iPlayer].Embargos[tPlayer] = (gT.Players[iPlayer].Embargos[tPlayer] or 0) + iVal;
	gT.Players[tPlayer].EmbargoCount = gT.Players[tPlayer].EmbargoCount + iVal;
	if gT.Players[iPlayer].Embargos[tPlayer] <= 0 then
		gT.Players[iPlayer].Embargos[tPlayer] = nil;
	elseif gT.Players[iPlayer].Embargos[tPlayer] == 1 then
		if (not bNot) and Players[tPlayer]:IsHuman() then
			str = Players[iPlayer]:GetName() .. " established Trade Embargo on us.";
			Players[tPlayer]:AddNotification(94343293,str, "Embargo",-1,-1,11)
		end
	end
end

function PlayerSetEmbasssy(iPlayer, tPlayer, bNot)
	Teams[Players[iPlayer]:GetTeam()]:SetHasEmbassyAtTeam(Players[tPlayer]:GetTeam(), true)
	Teams[Players[tPlayer]:GetTeam()]:SetAllowsOpenBordersToTeam(Players[iPlayer]:GetTeam(), true)
	if not gT.Globals.Embassies[iPlayer] then
		gT.Globals.Embassies[iPlayer] = {}
	end
	gT.Globals.Embassies[iPlayer][tPlayer] = true;
	
	if (not bNot) and (tPlayer == Game.GetActivePlayer()) then
		str = Players[iPlayer]:GetName() .. " established Embassy in our Capital.";
		Players[tPlayer]:AddNotification(NotificationTypes.NOTIFICATION_PEACE_ACTIVE_PLAYER, str, "Embassy", -1, -1, iPlayer)
	end
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_29, "kkadekaed") then
		local cH = Players[tPlayer]:GetCapitalCity(); --may be needed to push into dll?
		if cH then
			RevealTerrainInRadius(Players[iPlayer]:GetTeam(), cH:Plot(), 4)
		end
	end
end

function RemoveProperlyEmbassy(gTeam, jTeam)
	Teams[gTeam]:SetHasEmbassyAtTeam(jTeam, false)
	Teams[jTeam]:SetAllowsOpenBordersToTeam(gTeam, false)
end

function ReInstallEmbassyOnPeace(iTeam, tTeam)
	for g, h in pairs(gT.Players) do
		if Players[g]:GetTeam() == iTeam then
			for sp, tt in pairs(gT.Globals.Embassies[g] or {}) do
				if Players[sp]:GetTeam() == tTeam then
					PlayerSetEmbasssy(g, sp, true)
				end
			end
		end
	end
end

function ReInstallEmbassiesOnRessurect(iPlayer)
	local pTeam = Teams[Players[iPlayer]:GetTeam()];
	for sp, tt in pairs(gT.Globals.Embassies[iPlayer] or {}) do
		if not pTeam:IsAtWar(Players[sp]:GetTeam()) then
			PlayerSetEmbasssy(iPlayer, sp, true)
		end
	end
	for sp, sth in pairs(gT.Globals.Embassies) do
		if sth[iPlayer] then
			if not pTeam:IsAtWar(Players[sp]:GetTeam()) then
				PlayerSetEmbasssy(sp, iPlayer, true)
			end
		end
	end
end

function DoReallyRemoveEmbassiesOnWar(teamId, otherTeamId)
	for sp, sth in pairs(gT.Globals.Embassies) do
		if Players[sp]:GetTeam() == teamId then
			for op, ttt in pairs(sth) do
				if Players[op]:GetTeam() == otherTeamId then
					gT.Globals.Embassies[sp][op] = nil;
				end
			end
		end
	end
end

function ReInstallDefensivePactsOnRessurect(iPlayer)
	local iTeam = Players[iPlayer]:GetTeam();
	local cTeams = {[iTeam] = true};
	for g, h in pairs(gT.Players) do
		local nTeam = Players[g]:GetTeam();
		if not cTeams[nTeam] then
			cTeams[nTeam] = true;
			if ShouldReaddDefensivePact(iTeam, nTeam) then
				Teams[iTeam]:SetDefensivePact(nTeam, true)
				Teams[nTeam]:SetDefensivePact(iTeam, true)
			end
		end
	end
end