local baseMeritocracyValues = {
{ID= 1, Help = "[ICON_GOLD] Gold Corruption", Min = 5, Max = 30, Percent = true, ToolTip = "Negative modifier affecting Cities' [ICON_GOLD] Gold."},
{ID= 2, Help = "[ICON_PRODUCTION] Production Corruption", Min = 5, Max = 30, Percent = true, ToolTip = "Negative modifier affecting Cities' [ICON_PRODUCTION] Production."},
{ID= 3, Help = "[ICON_ITG_LEGAL_POWER] Legal Corruption", Min = 5, Max = 20, Percent = true, ToolTip = "Negative modifier applied to [ICON_ITG_LEGAL_POWER] Legal Power from Cities."},
{ID= 4, Help = "[ICON_HAPPINESS_1] Happiness Corruption", Min = 2, Max = 10, Percent = true, ToolTip = "Negative modifier applied to [ICON_HAPPINESS_1] Happiness chance generating in Cities."},
{ID= 5, Help = "[ICON_RESISTANCE] Riots' strength", Min = 5, Max = 20, ToolTip = "Affects the negative effects of [ICON_RESISTANCE] Riots."},
{ID= 6, Help = "[ICON_CHECKBOX] Budget effectiveness", Min = 5, Max = 20, Sc = {[5] = true}, Percent = true, ToolTip = "Reduces effectiveness of [ICON_GOLD] Gold added to Budget."},
{ID= 7, Help = "[ICON_HAPPINESS_4] On unit trained", Min = 5, Max = 25, Percent = true, ToolTip = "Provides extra chance to generate [ICON_HAPPINESS_4] Unhappiness upon training unit."},
}
local govSlots;
local govSlotsTenets;
local arabtrial7 = GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_ARABIA_7
local bInduWonder25 = GameInfoTypes.BUILDING_ITG_NEW_INDUSTRIAL_WONDER_25;
local cliffpalace1 = GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_20;
local csAncient32 = GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_32;
local innoTasian5 = GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_ASIA_5;
local innoNWafr8 = GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_AFR_8
local arabNW6 = GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_ARAB_6;

function GetMaxValueFromMeritocracy(iPlayer, i)
	local val = baseMeritocracyValues[i].Max;
	if i == 1 then
		if IsHasLaw(iPlayer, 12, 1) then
			val = val - 10;
		elseif IsHasLaw(iPlayer, 12, 2) then
			val = val + 10;
		end
		if gT.Players[iPlayer].AuthorityRank == 1 then
			if gT.Players[iPlayer].GovRewards[2] then
				val = val - 8;
			end
		end
		if HasPlayerTech(iPlayer, csAncient32, "Vewfsdf") then
			val = val - 5;
		end
	elseif i == 2 then
		if IsHasLaw(iPlayer, 12, 2) then
			val = val - 10;
		elseif IsHasLaw(iPlayer, 12, 4) then
			val = val + 5;
		end
		if gT.Players[iPlayer].AuthorityRank == 1 then
			if gT.Players[iPlayer].GovRewards[2] then
				val = val - 8;
			end
		end
		if HasPlayerTech(iPlayer, csAncient32, "Vewfsdf") then
			val = val - 5;
		end
	elseif i == 3 then
		if HasPlayerTech(iPlayer, csAncient32, "Vewfsdf") then
			val = val - 5;
		end
		if IsHasLaw(iPlayer, 12, 3) then
			val = val - 10;
		end
		if gT.Players[iPlayer].CultBonusOn[27] then
			for govID, h in pairs(gT.Players[iPlayer].Governors) do
				val = val - 1
			end
		end
	elseif i == 4 then
	elseif i == 5 then
		if IsHasLaw(iPlayer, 12, 3) then
			val = val + 7;
		elseif IsHasLaw(iPlayer, 12, 4) then
			val = val - 5;
		end
	elseif i == 7 then
	end
	return math.max(baseMeritocracyValues[i].Min,val);
end

function GetBasicValueMeritocracy(iPlayer, val)
	if gT.Players[iPlayer].Goverment == 1 then
		return GetMaxValueFromMeritocracy(iPlayer, val)
	else
		return gT.Players[iPlayer].MeritocracyValues[val];
	end
end

function DoDirtyValuesBasedOnMeritocracy(iPlayer, bInit)
	local corruption = (100 - gT.Players[iPlayer].MeritocracyLevel) / 100;
	for i, v in pairs(baseMeritocracyValues) do
		gT.Players[iPlayer].MeritocracyValues[i] = math.floor(corruption * GetMaxValueFromMeritocracy(iPlayer, i))
	end
	DoUpdateCitiesGovCorruption(iPlayer)
	DoDirtyBudgetValues(iPlayer)
end

function GetMeritocracyAnchor(iPlayer)
	local a = gT.Players[iPlayer].MinMeritocracy;
	if gT.Players[iPlayer].HasIdeology[67] then
		a = math.max(a, math.floor(50 * gT.Players[iPlayer].HapComparisionMod));
	end
	if gT.Players[iPlayer].HasIdeology[65] then
		a = math.max(a, math.floor(5 * GetNumOfGPCivilOfType(iPlayer, 9)));
	end
	if gT.Players[iPlayer].CultureType == 6 then
		a = math.max(a, math.floor(5 * (GetNumOfGPCivilOfType(iPlayer) + GetNumOfGPCivilOfType(iPlayer, 1) + GetNumOfGPCivilOfType(iPlayer, 2))));
	end
	return a;
end

function GetMeritocracyAvailable(iPlayer)
	return gT.Players[iPlayer].MeritocracyLevel - GetMeritocracyAnchor(iPlayer);
end

function ChangeMeritocracy(iPlayer, val)
	local nVal;
	if val < 0 then
		local anchor = GetMeritocracyAnchor(iPlayer);
		if gT.Players[iPlayer].MeritocracyLevel > anchor then
			nVal = math.max(anchor, gT.Players[iPlayer].MeritocracyLevel + val);
		else
			return false;
		end
	else
		nVal = math.min(100, gT.Players[iPlayer].MeritocracyLevel + val);
	end
	if nVal ~= gT.Players[iPlayer].MeritocracyLevel then
		gT.Players[iPlayer].MeritocracyLevel = nVal;
		DoDirtyValuesBasedOnMeritocracy(iPlayer)
		if iPlayer == Game.GetActivePlayer() then
			LuaEvents.ITGSGTopPanelDirty()
		end
		return true;
	end
	return false;
end

function GetGoldProdCorruptionFromMeritocracy(iPlayer)
	return GetBasicValueMeritocracy(iPlayer, 1), GetBasicValueMeritocracy(iPlayer, 2);
end
--
function DoInitMeritocracy()
	for g, h in pairs(gT.Players) do
		if Players[g]:IsMinorCiv() then
			gT.Players[g].MeritocracyLevel = 100;
		else
			gT.Players[g].MeritocracyLevel = LastRandom(0, 100);
		end
		DoDirtyValuesBasedOnMeritocracy(g, true)

		local nobleChance = GetDBCulturePlayerInfo(g, "NoblePrivilige")
		if gT.EraData and gT.PreviousEra then
			if tempconvinit[g].NoblePriviligeEC then
				nobleChance = math.min(80, math.max(2 * nobleChance, nobleChance + 20));
			end
		end
		gT.Players[g].NoblePriviligeUsed = LastChance(nobleChance);
	end
end

local arabtrial7 = GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_ARABIA_7
function ShouldChangeMeritocracy(iPlayer, iChangeMerit)
	if iChangeMerit < 0 then
		if HasPlayerTech(iPlayer, arabtrial7, "arabtrial7") then
			if LastChance(7 * GetNumOfGPCivilOfType(iPlayer, 9)) then
				return false
			end
		end
	end
	return true;
end

function DoTurnMeritocracy(iPlayer)
	local iChangeMerit = GetMeritocracyChangePerTurn(iPlayer);
	if ShouldChangeMeritocracy(iPlayer, iChangeMerit) then
		if not ChangeMeritocracy(iPlayer, iChangeMerit) then
			DoDirtyValuesBasedOnMeritocracy(iPlayer, bInit) -- want this to fire every turn start;
		end
	else
		DoDirtyValuesBasedOnMeritocracy(iPlayer, bInit)
	end
	if gT.Players[iPlayer].GovRewards[23] then
		if (not gT.Players[iPlayer].GovSlots[gT.Players[iPlayer].GovRewards[23]].Used) then
			if not GetRandomInnovation(iPlayer, true) then
				gT.Players[iPlayer].GovSlots[gT.Players[iPlayer].GovRewards[23]].Used = true;
			end
		end
	end
end

function GetMeritocracyChangeFromEoE(iPlayer)
	local ath = -Players[iPlayer]:GetNumCities() + 1;
	if ath == 1 then
		return 0; -- still alive
	end
	for govID, h in pairs(gT.Players[iPlayer].Governors) do
		ath = ath + 1;
	end
	if ath > 0 then
		return ath;
	end
	return 0;
end

function GetMeritocracyFromNatUnity(iPlayer)
	if gT.Players[iPlayer].NatUnity < NAT_UNITY_BIG_PENALTY then
		return -1;
	end
	return 0;
end

function GetMeritocracyChangeFromGoverment(iPlayer)
	local val = 0;
	if gT.Players[iPlayer].Goverment == 1 then
		val = val + 5;
	elseif IsFirstAtPrinciples(iPlayer) then
		val = val + 1;
	end
	for i, v in pairs(gT.Players[iPlayer].GovRewards) do
		val = val - 1;
	end
	return val;
end

function GetMeritocracyFromLowMeritocracy(iPlayer)
	local a = 0;
	if gT.Players[iPlayer].MeritocracyLevel < 10 then
		a = 3;
	elseif gT.Players[iPlayer].MeritocracyLevel < 25 then
		a = 2;
	elseif gT.Players[iPlayer].MeritocracyLevel < 50 then
		a = 1;
	end
	if gT.Players[iPlayer].HasIdeology[13] then
		if gT.Players[iPlayer].MeritocracyLevel < 40 then
			if gT.Players[iPlayer].MeritocracyLevel < 20 then
				a = a + 1;
			end
			a = a + 1;
		end
	end
	return a;
end

function GetMeritocracyFromTech(iPlayer)
	return gT.Players[iPlayer].MeritocracyFromTech;
end

function GetMeritocracyFromSocialDevelopments(iPlayer)
	if gT.Players[iPlayer].CultBonusOn[146] then
		return 1;
	end
	return 0;	
end

function GetMeritocracyFromNoblePrivilige(iPlayer)
	if gT.Players[iPlayer].NoblePriviligeUsed then
		return -1;
	end
	return 0;
end

function GetMeritocracyFromReignDuration(iPlayer)
	if HasPlayerTech(iPlayer, arabNW6, "arabnw6") then
		return 0;
	end
	return math.floor(GetITGGameTurn() / 20) * -1;
end

function GetMeritocracyFromGreatPeople(iPlayer)
	return gT.Players[iPlayer].GPMeritocracy;
end

function GetMeritocracyFromScenario()
	return DBScenario.MeritocracyPerTurn;
end

function GetMeritocracyFromUngovernedCities(iPlayer)
	if GetPercentGovernedCities(iPlayer) < 25 then
		return -1;
	end
	return 0;
end

function GetMeritocracyFromGoldenAge(iPlayer)
	if Players[iPlayer]:IsGoldenAge() then
		if gT.Players[iPlayer].HasMinorIdeology[7] then
			return 3;
		end
		return 1;
	end
	return 0;
end

function GetMeritocracyFromGovernors(iPlayer)
	local b = 0;
	for govID, boold in pairs(gT.Players[iPlayer].Governors) do
		if gT.Globals.Governors[govID].MeritPT then
			b = b + gT.Globals.Governors[govID].MeritPT;
		end
	end
	return b;
end

function GetMeritocracyFromIdeology(iPlayer)
	local a = 0;
	if gT.Players[iPlayer].HasIdeology[79] then
		if gT.Players[iPlayer].Morale >= 10 then
			a = a + 1;
		end
	end
	a = a + math.floor(gT.Players[iPlayer].Ideo78DataTracking[1] / 20);
	if gT.Players[iPlayer].HasIdeology[35] then
		if gT.Players[iPlayer].MintBonus > gT.Globals.AverageMintBonus then
			a = a + 1;
		end
	end
	if gT.Players[iPlayer].HasIdeology[2] then
		a = a + 1;
	end
	if gT.Players[iPlayer].HasIdeology[75] then
		if gT.Players[iPlayer].CodexStrength == gT.Globals.BestCodex then
			a = a + 1;
		end
	end
	if gT.Players[iPlayer].HapGuaranteeFunds == 100 then
		a = a + 1;
	end
	return a;
end

function GetMeritocracyChangePerTurn(iPlayer, bToolTip)
	local t = GetMeritocracyChangeFromGoverment(iPlayer) + GetMeritocracyFromWorldAtWar()
	t = t + GetMeritocracyFromTech(iPlayer) + GetMeritocracyFromLowMeritocracy(iPlayer) + GetMeritocracyFromScenario()
	t = t + GetMeritocracyFromNoblePrivilige(iPlayer) + GetMeritocracyFromEradicateCorruption(iPlayer) + GetMeritocracyFromInnovations(iPlayer)
	t = t + GetMeritocracyFromSocialDevelopments(iPlayer) + GetMeritocracyChangeFromEoE(iPlayer) + GetMeritocracyFromAcademies(iPlayer);
	t = t + GetMeritocracyFromGoldenAge(iPlayer) + GetMeritocracyFromGovernors(iPlayer) + GetMeritocracyFromGreatPeople(iPlayer);
	t = t + GetMeritocracyFromReignDuration(iPlayer) + GetMeritocracyFromWonders(iPlayer) + GetMeritocracyFromUngovernedCities(iPlayer)
	t = t + GetMeritocracyFromIdeology(iPlayer) + GetMeritocracyFromNatUnity(iPlayer)
	if bToolTip then
		t = t + GetMeritocracyFromBudget(iPlayer);
	end
	return t;
end

function GetAnarchyToolTip(iPlayer, iReason, meritocracy)
	local str
	if iReason == "Riots" then
		str = "Each time your Capital city starts [ICON_RESISTANCE] Riots there is a chance for your empire to enter Anarchy. [ICON_ITG_MERITOCRACY] Meritocracy adds from 0 (at 100%) to " .. ANARCHY_MER_CHANCE_RIOTS / 10 .. "% (at 0%) extra chance."
		str = str .. "[NEWLINE][ICON_BULLET]+" .. ANARCHY_BASE_CHANCE_RIOTS / 10 .. "% from base."
	elseif iReason == "Conquest" then
		str = "Each time your Capital city is conquered there is a chance for your empire to enter Anarchy. [ICON_ITG_MERITOCRACY] Meritocracy adds from 0 (at 0%) to " .. ANARCHY_MER_CHANCE_CONQUEST / 10 .. "% (at 100%) extra chance."
		str = str .. "[NEWLINE][ICON_BULLET]+" .. ANARCHY_BASE_CHANCE_CONQUEST / 10 .. "% from base."
	elseif iReason == "Legal" then
		str = "Each turn if you have negative [ICON_ITG_LEGAL_POWER] Legal Power stored there is a chance to enter Anarchy. [ICON_ITG_MERITOCRACY] Meritocracy adds from 0 (at 100%) to " .. ANARCHY_MER_CHANCE_LEGAL / 10 .. "% (at 0%) extra chance."
		str = str .. "[NEWLINE][ICON_BULLET]+" .. (-1 * gT.Players[iPlayer].LegalPower) .. "% from negative [ICON_ITG_LEGAL_POWER] Legal Power."
	end
	str = str .. "[NEWLINE][ICON_BULLET]+" .. meritocracy .. "% from current [ICON_ITG_MERITOCRACY] Meritocracy."
	local modFromAnarchyRecent = math.max(0, 25 - GetITGGameTurn() + gT.Players[iPlayer].LastAnarchyRevolution);
	if modFromAnarchyRecent ~= 0 then
		str = str .. "[NEWLINE][ICON_BULLET]-" .. modFromAnarchyRecent .. "% of total chance from memory of last Anarchy."
	end
	if gT.Players[iPlayer].AuthorityRank == 1 then
		str = str .. "[NEWLINE][ICON_BULLET]-15% of total chance from [ICON_ITG_AUTHORITY] Authority rank."
	end
	if gT.Players[iPlayer].HasPlayerWonder[GameInfoTypes.BUILDING_ITG_NEW_WORLD_WONDER_13] then
		str = str .. "[NEWLINE][ICON_BULLET]Chance reduced to 1% (Longleat)."
	end
	if iReason == "Riots" then
		if gT.Players[iPlayer].NextAnarchyImmune then
			str = str .. "[NEWLINE][NEWLINE]Next [ICON_RESISTANCE] Riots will not trigger Anarchy chance (because previous [ICON_RESISTANCE] Riots started Anarchy)."
		end
	end
	return str;
end

LuaEvents.ITGSG_RequestMeritocracyData.Add(function(iPlayer)
	local tab = {MiniInfos = {}, PerTurn = GetMeritocracyChangePerTurn(iPlayer, true), ToolTip = GetMeritocracyPTToolTip(iPlayer),
	GovToolTip = GetGovToolTip(iPlayer)}
	for i, data in pairs(baseMeritocracyValues) do
		if (not data.Sc) or (data.Sc[gT.Globals.ScenarioType]) then
			local sPer = " ";
			if data.Percent then
				sPer = "%";
			end
			table.insert(tab.MiniInfos, {Txt1 = data.Help, Txt2 = GetBasicValueMeritocracy(iPlayer, i) .. sPer, Txt3 = GetMaxValueFromMeritocracy(iPlayer, i) .. sPer, ToolTip1 = data.ToolTip, ToolTip2 = "Current value based on your [ICON_ITG_MERITOCRACY] Meritocracy level.", ToolTip3 = "Max value (reached when your [ICON_ITG_MERITOCRACY] Meritocracy drops to 0."})
		end
	end
	local anarchyRiots, merRiots = GetAnarchyChance(iPlayer, "Riots"), GetAnarchyChanceFromMeritocracy(iPlayer, "Riots");
	local anarchyConquest, merConquest = GetAnarchyChance(iPlayer, "Conquest"), GetAnarchyChanceFromMeritocracy(iPlayer, "Conquest");
	table.insert(tab.MiniInfos, {Txt1 = "Anarchy on [ICON_RESISTANCE] Riots", Txt2 = (anarchyRiots / 10) .. "%", Txt3 = "",
	ToolTip1 = GetAnarchyToolTip(iPlayer, "Riots", merRiots / 10)})
	table.insert(tab.MiniInfos, {Txt1 = "Anarchy on Capital loss", Txt2 = (anarchyConquest / 10) .. "%", Txt3 = "",
	ToolTip1 = GetAnarchyToolTip(iPlayer, "Conquest", merConquest / 10)})
	if ShouldTriggerAnarchyChanceFromLegal(iPlayer) then
		local anarchyLegal, merLegal = GetAnarchyChance(iPlayer, "Legal"), GetAnarchyChanceFromMeritocracy(iPlayer, "Legal");
		table.insert(tab.MiniInfos, {Txt1 = "Anarchy on [ICON_RESISTANCE] Riots", Txt2 = (anarchyLegal / 10) .. "%", Txt3 = "",
		ToolTip1 = GetAnarchyToolTip(iPlayer, "Legal", merLegal / 10)})
	end
	MapModData.ITGSG = tab;
end)

function GetMeritocracyFromInnovations(iPlayer)
	local b = 0;
	if gT.Players[iPlayer].AuthorityRank == 1 then
		if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_MODERN_25, "gergerg") then
			b = b + 1;
		end
	end
	if HasPlayerTech(iPlayer, innoTasian5, "innoTasian5") then
		if gT.Players[iPlayer].HasCodex then
			b = b + math.floor(gT.Players[iPlayer].CodexStrength / 35);
		end
	end
	if HasPlayerTech(iPlayer, innoNWafr8, "innoNWafr8") then
		if gT.Players[iPlayer].Morale >= 10 then
			b = b + 1;
		end
	end
	return b;
end

function GetMeritocracyFromWonders(iPlayer)
	local b = 0;
	if gT.Players[iPlayer].HasPlayerWonder[bInduWonder25] then
		b = b + 2;
	end
	return b;
end

function GetMeritocracyFromWorldAtWar()
	if gT.Globals.DominationOn and (not gT.Globals.DominationOff) then
		return 1;
	end
	return 0;
end

function GetMeritocracyFromEradicateCorruption(iPlayer)
	if gT.Players[iPlayer].EradicatedCorruption >= GetITGGameTurn() then
		return 1;
	end
	return 0;
end

function GetMeritocracyFromAcademies(iPlayer)
	local a = gT.Players[iPlayer].AcademyMeritocracy;
	return a;
end

function GetMeritocracyPTToolTip(iPlayer)
	local strText = "The lower is [ICON_ITG_MERITOCRACY] Meritocracy, the greater is corruption in your empire."
	local tab = {}
	table.insert(tab, {GetMeritocracyChangeFromGoverment(iPlayer), "Goverment"});
	table.insert(tab, {GetMeritocracyFromTech(iPlayer), "Technologies"});
	table.insert(tab, {GetMeritocracyFromNoblePrivilige(iPlayer), "Noble Priviliges"});
	table.insert(tab, {GetMeritocracyFromSocialDevelopments(iPlayer), "Social Developments"});
	table.insert(tab, {GetMeritocracyFromReignDuration(iPlayer), "Reign Duration"});
	table.insert(tab, {GetMeritocracyFromGovernors(iPlayer), "Governors"});
	table.insert(tab, {GetMeritocracyFromGoldenAge(iPlayer), "Golden Age"});
	table.insert(tab, {GetMeritocracyFromWonders(iPlayer), "Wonders"});
	table.insert(tab, {GetMeritocracyFromInnovations(iPlayer), "Innovations"});
	table.insert(tab, {GetMeritocracyFromAcademies(iPlayer), "Academies"});
	table.insert(tab, {GetMeritocracyFromNatUnity(iPlayer), "low National Unity"});
	table.insert(tab, {GetMeritocracyFromScenario(), "Scenario"});
	table.insert(tab, {GetMeritocracyFromIdeology(iPlayer), "Ideology"});
	table.insert(tab, {GetMeritocracyFromBudget(iPlayer), "Budget"});
	table.insert(tab, {GetMeritocracyFromGreatPeople(iPlayer), "Great People"});
	table.insert(tab, {GetMeritocracyFromUngovernedCities(iPlayer), "Ungoverned Cities"});
	table.insert(tab, {GetMeritocracyFromEradicateCorruption(iPlayer), "Eradicate Corruption (" .. gT.Players[iPlayer].EradicatedCorruption + 1 - GetITGGameTurn() .. "T)"});
	table.insert(tab, {GetMeritocracyFromLowMeritocracy(iPlayer), "low Meritocracy"});
	table.insert(tab, {GetMeritocracyFromWorldAtWar(), "World at War"});
	table.insert(tab, {GetMeritocracyChangeFromEoE(iPlayer), "Edge of Extinction"});

	for i, v in pairs(tab) do
		if v[1] > 0 then
			strText = strText .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]+" ..  v[1] .. "[ENDCOLOR] from " .. v[2] .. ".";
		elseif v[1] < 0 then
			strText = strText .. "[NEWLINE][ICON_BULLET][COLOR_NEGATIVE_TEXT]" ..  v[1] .. "[ENDCOLOR] from " .. v[2] .. ".";
		end
	end
	local iPalaceUnhap = GetPalaceUnhappinessFromLowMeritocracy(iPlayer);
	if iPalaceUnhap > 0 then
		strText = strText .. "[NEWLINE][NEWLINE]Due to low [ICON_ITG_MERITOCRACY] Meritocracy, expanding Palaces generates " .. iPalaceUnhap .. " [ICON_HAPPINESS_4] Unhappiness in a city.";
	end
	local iAnchor = GetMeritocracyAnchor(iPlayer);
	if iAnchor ~= 0 then
		strText = strText .. "[NEWLINE][NEWLINE]Due to anchor [ICON_ITG_MERITOCRACY] Meritocracy will not drop below [COLOR_POSITIVE_TEXT]" .. iAnchor .. "[ENDCOLOR].";
	end
	return strText;
end

function GetPalaceUnhappinessFromLowMeritocracy(iPlayer)
	if gT.Players[iPlayer].HasPlayerWonder[cliffpalace1] then
		return 0;
	end
	if gT.Players[iPlayer].MeritocracyLevel < 10 then
		return 3;
	elseif gT.Players[iPlayer].MeritocracyLevel < 10 then
		return 2;
	elseif gT.Players[iPlayer].MeritocracyLevel < 10 then
		return 1;
	end
	return 0;
end

govSlots = {
{ID = 1, Description = "Authority", Type = "Authority", Help = "TXT_KEY_ITG_GOV_SLOT_HELP_1", OffX = 164, OffY = 293, Atlas="GOV_ITG_SLOT_ATLAS", AtlasHave="GOV_ITG_SLOT_FILLED_ATLAS", IconIndex=1},
{ID = 2, Description = "Codex", Type = "Codex", Help = "TXT_KEY_ITG_GOV_SLOT_HELP_2", OffX = 160, OffY = 225, Req = 1, Atlas="GOV_ITG_SLOT_ATLAS", AtlasHave="GOV_ITG_SLOT_FILLED_ATLAS", IconIndex=0},
{ID = 3, Description = "Governor", Type = "Governor", Help = "TXT_KEY_ITG_GOV_SLOT_HELP_3", OffX = 154, OffY = 151, ScType = 1, Req = 2, Atlas="GOV_ITG_SLOT_ATLAS", AtlasHave="GOV_ITG_SLOT_FILLED_ATLAS", IconIndex=5, Disabled = true},
{ID = 4, Description = "Ideological", Type = "Ideology", Help = "TXT_KEY_ITG_GOV_SLOT_HELP_4", OffX = 148, OffY = 96, ScType = 5, Req = 11, Atlas="GOV_ITG_SLOT_ATLAS", AtlasHave="GOV_ITG_SLOT_FILLED_ATLAS", IconIndex=3},
{ID = 5, Description = "Budget", Type = "Budget", Help = "TXT_KEY_ITG_GOV_SLOT_HELP_5", OffX = 228, OffY = 172, Req = 2, Atlas="GOV_ITG_SLOT_ATLAS", AtlasHave="GOV_ITG_SLOT_FILLED_ATLAS", IconIndex=6, GoldBudgetOnly = true},
{ID = 6, Description = "Random #1", Type = "Rng1", Help = "TXT_KEY_ITG_GOV_SLOT_HELP_6", OffX = 228, OffY = 172, Req = 2, Atlas="GOV_ITG_SLOT_ATLAS", AtlasHave="GOV_ITG_SLOT_FILLED_ATLAS", IconIndex=4, Disabled = true},
{ID = 7, Description = "Random #2", Type = "Rng2", Help = "TXT_KEY_ITG_GOV_SLOT_HELP_7", OffX = 115, OffY = 56, Req = 4, Atlas="GOV_ITG_SLOT_ATLAS", AtlasHave="GOV_ITG_SLOT_FILLED_ATLAS", IconIndex=4, Disabled = true},
{ID = 8, Description = "Innovation", Type = "Innovation", Help = "TXT_KEY_ITG_GOV_SLOT_HELP_8", OffX = 96, OffY = 229, ScType = 2, Req = 1, Atlas="GOV_ITG_SLOT_ATLAS", AtlasHave="GOV_ITG_SLOT_FILLED_ATLAS", IconIndex=9},
{ID = 9, Description = "Religious", Type = "Faith", Help = "TXT_KEY_ITG_GOV_SLOT_HELP_9", OffX = 250, OffY = 221, Req = 1, Atlas="GOV_ITG_SLOT_ATLAS", AtlasHave="GOV_ITG_SLOT_FILLED_ATLAS", IconIndex=8, noSecularState = true},
{ID = 10, Description = "Economic", Type = "Gold", Help = "TXT_KEY_ITG_GOV_SLOT_HELP_10", OffX = 228, OffY = 172, ScType = 2, Req = 2, Atlas="GOV_ITG_SLOT_ATLAS", AtlasHave="GOV_ITG_SLOT_FILLED_ATLAS", IconIndex=7, NoGoldBudgetOnly = true},
{ID = 11, Description = "National Day", Type = "Day", Help = "TXT_KEY_ITG_GOV_SLOT_HELP_11", OffX = 154, OffY = 151, ScType = 1, Req = 2, Atlas="GOV_ITG_SLOT_ATLAS", AtlasHave="GOV_ITG_SLOT_FILLED_ATLAS", IconIndex=2},
{ID = 12, Description = "Secular", Type = "Secular", Help = "TXT_KEY_ITG_GOV_SLOT_HELP_12", OffX = 250, OffY = 221, Req = 1, Atlas="GOV_ITG_SLOT_ATLAS", AtlasHave="GOV_ITG_SLOT_FILLED_ATLAS", IconIndex=5, SecularState = true},
}

local govSlotInitChance = {
{{1,100}, {9,40}, {8,45}, {2,80}, {10,50}, {11,25}},
{{1,100}, {9,30}, {8, 30}, {2, 25}, {10, 20}},
{{1,50}, {9,15}, {8, 15}},
{{1,100}, {2,100}, {11,100}, {9,80}, {8,75}, {10,40}, {12, 25}},
{{1,100}, {2,100}, {11,100}, {4,25}, {5, 15}, {8,100}, {12, 50}},
}

function GetInitPrinciplesChance(iScType)
	return govSlotInitChance[iScType]
end

function GetCivInfoPrinciples(iPlayer)
	local tab = {};
	for slot, sth in pairs(gT.Players[iPlayer].GovSlots) do
		local rewardData = RequestGovSlotData(sth.Principle);
		table.insert(tab, {govSlots[slot].Description .. ": [COLOR_CITY_GREEN]" .. Locale.Lookup(rewardData.Name), rewardData.Help, slot})
	end
	return tab;
end

function GetInitPrinciplesForCivInfo(iScType)
	local tab = {}
	for a, b in pairs(GetInitPrinciplesChance(iScType)) do
		table.insert(tab, {b[1], govSlots[b[1]].Description .. " slot: " .. b[2] .. "%"})
	end
	return tab;
end

function GetDataFromSlotType(govSlotType, data, id)
	for i, slotData in pairs(govSlots) do
		if (slotData.Type == govSlotType) or (slotData.ID == id) then
			return slotData[data];
		end
	end
	return nil;
end

function GovPrinciple49AddRemove(iPlayer, iAdd)
	Players[iPlayer]:ChangePlayerBuildingClassYieldChange(GameInfoTypes.BUILDINGCLASS_COURTHOUSE, yFaith, iAdd * 2);
end

function GovPrinciple53AddRemove(iPlayer, iAdd)
	Players[iPlayer]:ChangePlayerBuildingClassYieldChange(GameInfoTypes.BUILDINGCLASS_MARKET, yFaith, iAdd * 2);
end

function GovPrinciple55AddRemove(iPlayer, iAdd)
	Players[iPlayer]:ChangeImprovementYieldChange(GameInfoTypes.IMPROVEMENT_ACADEMY, yCulture, iAdd)
end
function GovPrinciple56AddRemove(iPlayer, iAdd)
	Players[iPlayer]:ChangeImprovementYieldChange(GameInfoTypes.IMPROVEMENT_MANUFACTORY, yCulture, iAdd)
end
function GovPrinciple57AddRemove(iPlayer, iAdd)
	Players[iPlayer]:ChangeImprovementYieldChange(GameInfoTypes.IMPROVEMENT_CUSTOMS_HOUSE, yCulture, iAdd)
end
function GovPrinciple58AddRemove(iPlayer, iAdd)
	Players[iPlayer]:ChangePlayerBuildingClassYieldChange(GameInfoTypes.BUILDINGCLASS_SEAPORT, yCulture, iAdd * 1);
end
function GovPrinciple59AddRemove(iPlayer, iAdd)
	Players[iPlayer]:ChangePlayerBuildingClassYieldChange(GameInfoTypes.BUILDINGCLASS_MILITARY_ACADEMY, yCulture, iAdd * 1);
end
function GovPrinciple60AddRemove(iPlayer, iAdd)
	Players[iPlayer]:ChangePlayerBuildingClassYieldChange(GameInfoTypes.BUILDINGCLASS_HOSPITAL, yCulture, iAdd * 1);
end

function GPaiEvalIDeology(iPlayer, selfID)
	local val = 0;
	for letter, s in pairs(gT.Players[iPlayer].Ideologies) do
		if govSlotsTenets[selfID][letter] then
			val = val + s * 5;
		end
	end
	return math.max(1, val)
end

function IVaiEvalMeritocracy(iPlayer, selfID)
	local val = 1;
	if selfID == 13 then
		val = val + 7 * gT.Players[iPlayer].UniqueNumConquered
	elseif selfID == 14 then
		val = val + 6 * gT.Players[iPlayer].NumCaughtSpies
	elseif selfID == 15 then
		val = val + 5 * gT.Players[iPlayer].NumGovernorChanges
	elseif selfID == 16 then
		val = val + 7 * gT.Players[iPlayer].NumFestivalsStarted
	elseif selfID == 17 then
		val = val + 8 * gT.Players[iPlayer].GPCivilGenerated
	elseif selfID == 18 then
		val = val + 5 * gT.Players[iPlayer].NumWonCityQuests
	end
	return val;
end

function GovPrincipleBasicPower(iPlayer, iAdd)
	BoostPlayerPower(iPlayer, "Principle", iAdd * POWER_FROM_PRINCIPLE); 
end

govSlotsTenets = {
{ID = 1, Type = "Authority", Name = "TXT_KEY_GOV_TENET_NAME_1", Help = "TXT_KEY_GOV_TENET_HELP_1", AIFlavor = "FLAVOR_PRESENCE", OnAddRemove = GovPrincipleBasicPower},
{ID = 2, Type = "Authority", Name = "TXT_KEY_GOV_TENET_NAME_2", Help = "TXT_KEY_GOV_TENET_HELP_2", AIFlavor = "FLAVOR_PRODUCTION", OnAddRemove = GovPrincipleBasicPower},
{ID = 3, Type = "Authority", Name = "TXT_KEY_GOV_TENET_NAME_3", Help = "TXT_KEY_GOV_TENET_HELP_3", AIFlavor = "FLAVOR_CULTURE", OnAddRemove = GovPrincipleBasicPower},
{ID = 4, Type = "Authority", Name = "TXT_KEY_GOV_TENET_NAME_4", Help = "TXT_KEY_GOV_TENET_HELP_4", AIFlavor = "FLAVOR_LEGAL", OnAddRemove = GovPrincipleBasicPower},
{ID = 5, Type = "Authority", Name = "TXT_KEY_GOV_TENET_NAME_5", Help = "TXT_KEY_GOV_TENET_HELP_5", AIFlavor = "FLAVOR_HAPPINESS", OnAddRemove = GovPrincipleBasicPower},
{ID = 6, Type = "Authority", Name = "TXT_KEY_GOV_TENET_NAME_6", Help = "TXT_KEY_GOV_TENET_HELP_6", AIFlavor = "FLAVOR_DEFENSE", OnAddRemove = GovPrincipleBasicPower},
{ID = 7, Type = "Codex", Name = "TXT_KEY_GOV_TENET_NAME_7", Help = "TXT_KEY_GOV_TENET_HELP_7", AIFlavor = "FLAVOR_HAPPINESS"},
{ID = 8, Type = "Codex", Name = "TXT_KEY_GOV_TENET_NAME_8", Help = "TXT_KEY_GOV_TENET_HELP_8", AIFlavor = "FLAVOR_OFFENSE"},
{ID = 9, Type = "Codex", Name = "TXT_KEY_GOV_TENET_NAME_9", Help = "TXT_KEY_GOV_TENET_HELP_9", AIFlavor = "FLAVOR_PRESENCE"},
{ID = 10, Type = "Codex", Name = "TXT_KEY_GOV_TENET_NAME_10", Help = "TXT_KEY_GOV_TENET_HELP_10", AIFlavor = "FLAVOR_GROWTH"},
{ID = 11, Type = "Codex", Name = "TXT_KEY_GOV_TENET_NAME_11", Help = "TXT_KEY_GOV_TENET_HELP_11", AIFlavor = "FLAVOR_GREAT_PEOPLE"},
{ID = 12, Type = "Codex", Name = "TXT_KEY_GOV_TENET_NAME_12", Help = "TXT_KEY_GOV_TENET_HELP_12", AIFlavor = "FLAVOR_PRODUCTION"},
{ID = 13, Type = "Governor", Name = "TXT_KEY_GOV_TENET_NAME_13", Help = "TXT_KEY_GOV_TENET_HELP_13", AIEval = IVaiEvalMeritocracy},
{ID = 14, Type = "Governor", Name = "TXT_KEY_GOV_TENET_NAME_14", Help = "TXT_KEY_GOV_TENET_HELP_14", AIEval = IVaiEvalMeritocracy},
{ID = 15, Type = "Governor", Name = "TXT_KEY_GOV_TENET_NAME_15", Help = "TXT_KEY_GOV_TENET_HELP_15", AIEval = IVaiEvalMeritocracy},
{ID = 16, Type = "Governor", Name = "TXT_KEY_GOV_TENET_NAME_16", Help = "TXT_KEY_GOV_TENET_HELP_16", AIEval = IVaiEvalMeritocracy},
{ID = 17, Type = "Governor", Name = "TXT_KEY_GOV_TENET_NAME_17", Help = "TXT_KEY_GOV_TENET_HELP_17", AIEval = IVaiEvalMeritocracy},
{ID = 18, Type = "Governor", Name = "TXT_KEY_GOV_TENET_NAME_18", Help = "TXT_KEY_GOV_TENET_HELP_18", AIEval = IVaiEvalMeritocracy},
{ID = 19, Type = "Innovation", Name = "TXT_KEY_GOV_TENET_NAME_19", Help = "TXT_KEY_GOV_TENET_HELP_19", AIFlavor = "FLAVOR_OFFENSE"},
{ID = 20, Type = "Innovation", Name = "TXT_KEY_GOV_TENET_NAME_20", Help = "TXT_KEY_GOV_TENET_HELP_20", AIFlavor = "FLAVOR_CULTURE"},
{ID = 21, Type = "Innovation", Name = "TXT_KEY_GOV_TENET_NAME_21", Help = "TXT_KEY_GOV_TENET_HELP_21", AIFlavor = "FLAVOR_GOLD"},
{ID = 22, Type = "Innovation", Name = "TXT_KEY_GOV_TENET_NAME_22", Help = "TXT_KEY_GOV_TENET_HELP_22", AIFlavor = "FLAVOR_GREAT_PEOPLE"},
{ID = 23, Type = "Innovation", Name = "TXT_KEY_GOV_TENET_NAME_23", Help = "TXT_KEY_GOV_TENET_HELP_23", AIFlavor = "FLAVOR_PRODUCTION"},
{ID = 24, Type = "Innovation", Name = "TXT_KEY_GOV_TENET_NAME_24", Help = "TXT_KEY_GOV_TENET_HELP_24", AIFlavor = "FLAVOR_LEGAL"},
{ID = 25, Type = "Budget", Name = "TXT_KEY_GOV_TENET_NAME_25", Help = "TXT_KEY_GOV_TENET_HELP_25", AIFlavor = "FLAVOR_INFRASTRUCTURE"},
{ID = 26, Type = "Budget", Name = "TXT_KEY_GOV_TENET_NAME_26", Help = "TXT_KEY_GOV_TENET_HELP_26", AIFlavor = "FLAVOR_HAPPINESS"},
{ID = 27, Type = "Budget", Name = "TXT_KEY_GOV_TENET_NAME_27", Help = "TXT_KEY_GOV_TENET_HELP_27", AIFlavor = "FLAVOR_ESPIONAGE"},
{ID = 28, Type = "Budget", Name = "TXT_KEY_GOV_TENET_NAME_28", Help = "TXT_KEY_GOV_TENET_HELP_28", AIFlavor = "FLAVOR_LEGAL"},
{ID = 29, Type = "Budget", Name = "TXT_KEY_GOV_TENET_NAME_29", Help = "TXT_KEY_GOV_TENET_HELP_29", AIFlavor = "FLAVOR_SCIENCE"},
{ID = 30, Type = "Budget", Name = "TXT_KEY_GOV_TENET_NAME_30", Help = "TXT_KEY_GOV_TENET_HELP_30", AIFlavor = "FLAVOR_OFFENSE"},
{ID = 31, Type = "Ideology", O = 1, Name = "TXT_KEY_GOV_TENET_NAME_31", Help = "TXT_KEY_GOV_TENET_HELP_31", AIEval = GPaiEvalIDeology},
{ID = 32, Type = "Ideology", F = 1, Name = "TXT_KEY_GOV_TENET_NAME_32", Help = "TXT_KEY_GOV_TENET_HELP_32", AIEval = GPaiEvalIDeology},
{ID = 33, Type = "Ideology", A = 1, Name = "TXT_KEY_GOV_TENET_NAME_33", Help = "TXT_KEY_GOV_TENET_HELP_33", AIEval = GPaiEvalIDeology},
{ID = 34, Type = "Ideology", L = 1, Name = "TXT_KEY_GOV_TENET_NAME_34", Help = "TXT_KEY_GOV_TENET_HELP_34", AIEval = GPaiEvalIDeology},
{ID = 35, Type = "Ideology", E = 1, Name = "TXT_KEY_GOV_TENET_NAME_35", Help = "TXT_KEY_GOV_TENET_HELP_35", AIEval = GPaiEvalIDeology},
{ID = 36, Type = "Ideology", S = 1, Name = "TXT_KEY_GOV_TENET_NAME_36", Help = "TXT_KEY_GOV_TENET_HELP_36", AIEval = GPaiEvalIDeology},
{ID = 37, Type = "Gold", Name = "TXT_KEY_GOV_TENET_NAME_37", Help = "TXT_KEY_GOV_TENET_HELP_37", AIFlavor = "FLAVOR_OFFENSE"},
{ID = 38, Type = "Gold", Name = "TXT_KEY_GOV_TENET_NAME_38", Help = "TXT_KEY_GOV_TENET_HELP_38", AIFlavor = "FLAVOR_INFRASTRUCTURE"},
{ID = 39, Type = "Gold", Name = "TXT_KEY_GOV_TENET_NAME_39", Help = "TXT_KEY_GOV_TENET_HELP_39", AIFlavor = "FLAVOR_HAPPINESS"},
{ID = 40, Type = "Gold", Name = "TXT_KEY_GOV_TENET_NAME_40", Help = "TXT_KEY_GOV_TENET_HELP_40", AIFlavor = "FLAVOR_SCIENCE"},
{ID = 41, Type = "Gold", Name = "TXT_KEY_GOV_TENET_NAME_41", Help = "TXT_KEY_GOV_TENET_HELP_41", AIFlavor = "FLAVOR_LEGAL"},
{ID = 42, Type = "Gold", Name = "TXT_KEY_GOV_TENET_NAME_42", Help = "TXT_KEY_GOV_TENET_HELP_42", AIFlavor = "FLAVOR_GREAT_PEOPLE"},
{ID = 43, Type = "Day", Name = "TXT_KEY_GOV_TENET_NAME_43", Help = "TXT_KEY_GOV_TENET_HELP_43", AIFlavor = "FLAVOR_OFFENSE"},
{ID = 44, Type = "Day", Name = "TXT_KEY_GOV_TENET_NAME_44", Help = "TXT_KEY_GOV_TENET_HELP_44", AIFlavor = "FLAVOR_HAPPINESS"},
{ID = 45, Type = "Day", Name = "TXT_KEY_GOV_TENET_NAME_45", Help = "TXT_KEY_GOV_TENET_HELP_45", AIFlavor = "FLAVOR_GREAT_PEOPLE"},
{ID = 46, Type = "Day", Name = "TXT_KEY_GOV_TENET_NAME_46", Help = "TXT_KEY_GOV_TENET_HELP_46", AIFlavor = "FLAVOR_GOLD"},
{ID = 47, Type = "Day", Name = "TXT_KEY_GOV_TENET_NAME_47", Help = "TXT_KEY_GOV_TENET_HELP_47", AIFlavor = "FLAVOR_DIPLOMACY"},
{ID = 48, Type = "Day", Name = "TXT_KEY_GOV_TENET_NAME_48", Help = "TXT_KEY_GOV_TENET_HELP_48", AIFlavor = "FLAVOR_CULTURE"},
{ID = 49, Type = "Faith", Name = "TXT_KEY_GOV_TENET_NAME_49", Help = "TXT_KEY_GOV_TENET_HELP_49", OnAddRemove = GovPrinciple49AddRemove, AIFlavor = "FLAVOR_LEGAL"},
{ID = 50, Type = "Faith", Name = "TXT_KEY_GOV_TENET_NAME_50", Help = "TXT_KEY_GOV_TENET_HELP_50", AIFlavor = "FLAVOR_CULTURE"},
{ID = 51, Type = "Faith", Name = "TXT_KEY_GOV_TENET_NAME_51", Help = "TXT_KEY_GOV_TENET_HELP_51", AIFlavor = "FLAVOR_OFFENSE"},
{ID = 52, Type = "Faith", Name = "TXT_KEY_GOV_TENET_NAME_52", Help = "TXT_KEY_GOV_TENET_HELP_52", AIFlavor = "FLAVOR_GREAT_PEOPLE"},
{ID = 53, Type = "Faith", Name = "TXT_KEY_GOV_TENET_NAME_53", Help = "TXT_KEY_GOV_TENET_HELP_53", OnAddRemove = GovPrinciple53AddRemove, AIFlavor = "FLAVOR_GOLD"},
{ID = 54, Type = "Faith", Name = "TXT_KEY_GOV_TENET_NAME_54", Help = "TXT_KEY_GOV_TENET_HELP_54", AIFlavor = "FLAVOR_HAPPINESS"},
{ID = 55, Type = "Secular", Name = "TXT_KEY_GOV_TENET_NAME_55", Help = "TXT_KEY_GOV_TENET_HELP_55", OnAddRemove = GovPrinciple55AddRemove, AIFlavor = "FLAVOR_SCIENCE"},
{ID = 56, Type = "Secular", Name = "TXT_KEY_GOV_TENET_NAME_56", Help = "TXT_KEY_GOV_TENET_HELP_56", OnAddRemove = GovPrinciple56AddRemove, AIFlavor = "FLAVOR_PRODUCTION"},
{ID = 57, Type = "Secular", Name = "TXT_KEY_GOV_TENET_NAME_57", Help = "TXT_KEY_GOV_TENET_HELP_57", OnAddRemove = GovPrinciple57AddRemove, AIFlavor = "FLAVOR_GOLD"},
{ID = 58, Type = "Secular", Name = "TXT_KEY_GOV_TENET_NAME_58", Help = "TXT_KEY_GOV_TENET_HELP_58", OnAddRemove = GovPrinciple58AddRemove, AIFlavor = "FLAVOR_NAVAL"},
{ID = 59, Type = "Secular", Name = "TXT_KEY_GOV_TENET_NAME_59", Help = "TXT_KEY_GOV_TENET_HELP_59", OnAddRemove = GovPrinciple59AddRemove, AIFlavor = "FLAVOR_OFFENSE"},
{ID = 60, Type = "Secular", Name = "TXT_KEY_GOV_TENET_NAME_60", Help = "TXT_KEY_GOV_TENET_HELP_60", OnAddRemove = GovPrinciple60AddRemove, AIFlavor = "FLAVOR_GROWTH"},
};

function RequestGovSlotData(id)
	return govSlotsTenets[id];
end

function DoAddIdeologyGovTenet(rPlayer, tenet, c)
	local rowData = govSlotsTenets[tenet]
	for i, letter in pairs(GetIdeoLetters()) do
		if (rowData[letter] or 0) > 0 then
			gT.Players[rPlayer].Ideologies[letter] = gT.Players[rPlayer].Ideologies[letter] + c * rowData[letter]
		end
	end
end

function CanPlayerHavRewardType(iPlayer, principle)
	local type = govSlotsTenets[principle].Type;
	if type == "Faith" then
		if gT.Players[iPlayer].SecularState then
			return false;
		end
	end
	return true;
end

function DoRemoveSlotGoverment(iPlayer, slot)
	local rewardType = gT.Players[iPlayer].GovSlots[slot].Principle;
	DoAddIdeologyGovTenet(iPlayer, rewardType, -1)
	if gT.Players[iPlayer].GovRewards[rewardType] then
		if govSlotsTenets[rewardType].OnAddRemove then
			govSlotsTenets[rewardType].OnAddRemove(iPlayer, -1)
		end
		gT.Players[iPlayer].GovRewards[rewardType] = nil;
	end
	gT.Players[iPlayer].GovSlots[slot] = nil;
	PlayerDirtyGovPrinciplesNumber(iPlayer)
end

function OnRevolutionDeleteAllPrincipleSlots(iPlayer)
	for slot, data in pairs(gT.Players[iPlayer].GovSlots) do
		DoRemoveSlotGoverment(iPlayer, slot)
	end
end

function DoMeritocracyRemoveReligiousPrinciples(iPlayer)
	for slot, data in pairs(gT.Players[iPlayer].GovSlots) do
		if govSlotsTenets[data.Principle].Type == "Faith" then
			DoRemoveSlotGoverment(iPlayer, slot)
		end
	end
end

function GetGoldBudgetModFromPrinciples(iPlayer)
	local a = 0;
	for tenet, h in pairs(gT.Players[iPlayer].GovRewards) do
		if govSlotsTenets[tenet].Type == "Budget" then
			a = a + 7;
		end
	end
	return a;
end

function GetChangeMaxBudget(iPlayer)
	local a = 0;
--[[	for tenet, h in pairs(gT.Players[iPlayer].GovRewards) do
		if govSlotsTenets[tenet].Type == "Budget" then
			a = a - 2;
		end
	end ]]
	return a;
end

function AppointGovPrincipleToSlot(iPlayer, slot, reward)
	if gT.Players[iPlayer].Goverment ~= 1 then
		gT.Players[iPlayer].GovRewards[reward] = slot;
		if govSlotsTenets[reward].OnAddRemove then
			govSlotsTenets[reward].OnAddRemove(iPlayer, 1)
		end
	end
	gT.Players[iPlayer].GovSlots[slot] = {Principle = reward};
	DoAddIdeologyGovTenet(iPlayer, reward, 1)
	if govSlotsTenets[reward].Type == "Budget" then
		DoDirtyBudgetValues(iPlayer)
	end
	PlayerDirtyGovPrinciplesNumber(iPlayer)
end

function GetNumGovSlotsFilled(iPlayer)
	local a = 0;
	for slot, data in pairs(gT.Players[iPlayer].GovSlots) do
		a = a + 1;
	end
	return a;
end

function ReinstallGovRewards(iPlayer)
	for slot, data in pairs(gT.Players[iPlayer].GovSlots) do
		gT.Players[iPlayer].GovRewards[data.Principle] = slot;
		if govSlotsTenets[data.Principle].OnAddRemove then
			govSlotsTenets[data.Principle].OnAddRemove(iPlayer, 1)
		end
	end
end

function AnarchyGovRewards(iPlayer, bEndEra)
	for reward, slot in pairs(gT.Players[iPlayer].GovRewards) do
		if govSlotsTenets[reward].OnAddRemove then
			govSlotsTenets[reward].OnAddRemove(iPlayer, -1)
		end
	end
	gT.Players[iPlayer].GovRewards = {};
end

function IsGovSlotValidForScenario(govSlot) 
	local scType = govSlots[govSlot].ScType;
	if scType == 5 then
		return (gT.Globals.ScenarioType == 5)
	elseif scType == 4 then
		return (gT.Globals.ScenarioType >= 4)
	elseif scType == 1 then
		return ((gT.Globals.ScenarioType > 3) or (gT.Globals.ScenarioType == 1))
	elseif scType == 2 then
		return (gT.Globals.ScenarioType ~= 3);
	end
	return true;
end
--GovSlots[slotType] = {govREward, moredata}
--GovRewards[govReward] = slotType
function CanHaveGovSlot(iPlayer, govSlot)
	if govSlots[govSlot].Disabled then
		return false
	end
	if govSlots[govSlot].Req then
		if not gT.Players[iPlayer].GovSlots[govSlots[govSlot].Req] then 
			return false;
		end
	end
	if govSlots[govSlot].Type == "Codex" then
		if not gT.Players[iPlayer].HasCodex then
			return false;
		end
	end
	if govSlots[govSlot].noSecularState then
		if gT.Players[iPlayer].SecularState then
			return false;
		end
	end
	if govSlots[govSlot].SecularState then
		if not gT.Players[iPlayer].SecularState then
			return false;
		end
	end
	if govSlots[govSlot].GoldBudgetOnly then
		if not DBScenario.GoldBudgetOnly then
			return false;
		end
	end
	if govSlots[govSlot].NoGoldBudgetOnly then
		if DBScenario.GoldBudgetOnly then
			return false;
		end
	end
	return IsGovSlotValidForScenario(govSlot)
end

function GetGovSlotShowcase(iPlayer, i)
	if gT.Players[iPlayer].GovSlots[i] then
		return 1;
	end
	if CanHaveGovSlot(iPlayer, i) then
		return 2;
	end
	return 3;
end

LuaEvents.ITGSG_RequestGovermentTree.Add(function(iPlayer, bShowAll)
	local tab = {{}, {}}
	for i, v in pairs(govSlots) do
		if v.Type ~= "Off" then
			if bShowAll or gT.Players[iPlayer].GovSlots[i] then
				if (not v.Disabled) then
					if (not v.GoldBudgetOnly) or (DBScenario.GoldBudgetOnly) then
						if (not v.NoGoldBudgetOnly) or (not DBScenario.GoldBudgetOnly) then
							if (not v.noSecularState) or (not gT.Players[iPlayer].SecularState) then
								if (not v.SecularState) or (gT.Players[iPlayer].SecularState) then
									local iShowcase = GetGovSlotShowcase(iPlayer, i);
									table.insert(tab[1], {ID = i, x = v.OffX, y = v.OffY, Showcase = iShowcase, ToolTip = "", PortraitIndex = v.IconIndex, IconAtlas = v.Atlas})
									local hID = #tab[1];
									if iShowcase == 1 then
						--				tab[1][hID].IconAtlas = v.AtlasHave  UNUSED NOW
										local t = "[COLOR_SELECTED_TEXT]" .. Locale.Lookup(govSlotsTenets[gT.Players[iPlayer].GovSlots[i].Principle].Name)
										t = t .. "[ENDCOLOR][NEWLINE]----------------[NEWLINE]" .. Locale.Lookup(govSlotsTenets[gT.Players[iPlayer].GovSlots[i].Principle].Help)
										t = t .. "[NEWLINE][NEWLINE][COLOR_NEGATIVE_TEXT]-1[ENDCOLOR] [ICON_ITG_MERITOCRACY] Meritocracy per turn.";
										tab[1][hID].ToolTip = t;
									else
										local t = Locale.Lookup(v.Help)
										t = t .. "[NEWLINE][NEWLINE]Filling this slot costs 4 [ICON_HAPPINESS_1][ICON_ITG_LEGAL_POWER] Legal Power and will increase [ICON_ITG_MERITOCRACY] Meritocracy by 25. (Filled goverment slots decreases [ICON_ITG_MERITOCRACY] Meritocracy by [COLOR_NEGATIVE_TEXT]1[ENDCOLOR] each turn.)";
										if not IsGovSlotValidForScenario(i) then
											t = t .. "[NEWLINE][NEWLINE][COLOR_NEGATIVE_TEXT]Unavailable during this Scenario.[ENDCOLOR]";
										end
										tab[1][hID].ToolTip = t;
									end
									if v.Req then
										local iLineType = 2;
										if gT.Players[iPlayer].GovSlots[i] then
											iLineType = 1;
										end
										table.insert(tab[2], {X1 = v.OffX, Y1 = v.OffY, X2 = govSlots[v.Req].OffX, Y2 = govSlots[v.Req].OffY, Type = iLineType})
									end
								end
							end
						end
					end
				end
			end
		end
	end
	if gT.Players[iPlayer].GovSlots[1] then
		table.insert(tab[2], {X1 = 164, Y1 = 380, X2 = govSlots[1].OffX, Y2 = govSlots[1].OffY, Type = 1})
	else
		table.insert(tab[2], {X1 = 164, Y1 = 380, X2 = govSlots[1].OffX, Y2 = govSlots[1].OffY, Type = 2})
	end
	MapModData.ITGSG = tab;
	MapModData.ITGSG2 = CanAffordTheAction(33, iPlayer);
end)

function DoInitGovTenets(hMajorTab)
	for i, major in pairs(hMajorTab) do
		--reinstall
		if gT.EraData and gT.PreviousEra then
			local bAdded = true;
			while bAdded do
				bAdded = false;
				for slot, principle in pairs(tempconvinit[major].GovSlotPrinciples) do
					if not gT.Players[major].GovSlots[slot] then
						if CanHaveGovSlot(major, slot) then
							if CanPlayerHavRewardType(major, principle) then -- added because it was dodging secular state rule
								AppointGovPrincipleToSlot(major, slot, principle)
								bAdded = true;
							end
						end
					end
				end
			end
		end
		for i, data in pairs(GetInitPrinciplesChance(gT.Globals.ScenarioType)) do
			AssignInitialRandomlyGovSlotIfPossible(major, data[1], data[2])
		end
	end
	InitGovernors(hMajorTab)
end

function DoAddRandomlyPrincipleSlots(iPlayer, iNum)
	local hTab = {}
	for id, slotData in pairs(govSlots) do
		table.insert(hTab, id)
	end
	hTab = Shuffle(hTab)
	local iLeft = iNum;
	for i = 1, iNum do
		local prem = iLeft;
		for j, id in pairs(hTab) do
			if not gT.Players[iPlayer].GovSlots[id] then
				AssignInitialRandomlyGovSlotIfPossible(iPlayer, id, 100)
				if gT.Players[iPlayer].GovSlots[id] then
					iLeft = iLeft - 1;
					if iLeft < 1 then
						return;
					end
				end
			end
		end
		if prem == iLeft then
			print("Revolution principles seem bad.", iPlayer, iNum, iLeft, i)
			return;
		end
	end
	print("Revolution principles seem bad.", iPlayer, iNum, iLeft)
end

function AssignInitialRandomlyGovSlotIfPossible(iPlayer, slotID, chance, bForce)
-- this will be used for rng probably;
	if not bForce then
		if not LastChance(chance) then	
			return;
		end
		if not CanHaveGovSlot(iPlayer, slotID) then
			return;
		end
	end
	if gT.Players[iPlayer].GovSlots[slotID] then --on initial it may fire on already filled slot...
		return;
	end
	local slotType = govSlots[slotID].Type
	local avTab = {[slotType] = true}
	if slotType == "Rng1" then
		avTab = {};
		for a, b in pairs({1,2,8,9}) do
			if CanHaveGovSlot(iPlayer, b) then
				avTab[govSlots[b].Type] = true;
			end
		end 
	elseif slotType == "Rng2" then
		avTab = {};
		for a, b in pairs({3,4,10,11}) do
			if CanHaveGovSlot(iPlayer, b) then
				avTab[govSlots[b].Type] = true;
			end
		end 
	end
	local getAvOption = GetGovSlotRewardsAvailable(iPlayer, avTab);
	if #getAvOption > 0 then
		AppointGovPrincipleToSlot(iPlayer, slotID, getAvOption[LastRandom(1,#getAvOption)])
	else
		print("Diggity? 123/44")
	end
end

function GetGovSlotRewardsAvailable(iPlayer, avTab)
	local alrT = {}
	for slot, data in pairs(gT.Players[iPlayer].GovSlots) do
		alrT[data.Principle] = true;
	end
	local tab = {};
	for i, data in pairs(govSlotsTenets) do
		if avTab[data.Type] and (not alrT[data.ID]) then
			table.insert(tab, data.ID);
		end
	end
	return tab;
end

function CanHaveThisSlotRightNow(iPlayer, slotID)
	if not gT.Players[iPlayer].GovSlots[slotID] then
		if CanHaveGovSlot(iPlayer, slotID) then
			return true;
		end
	end
	return false;
end

function GetAvailableGovSlotsToFill(iPlayer)
	local tab = {}
	for slotID, b in pairs(govSlots) do
		if CanHaveThisSlotRightNow(iPlayer, slotID) then
			table.insert(tab, slotID);
		end
	end
	return tab;
end

function PrepareDataForGovSlots(iPlayer)
	local data = {BonusType = 33, SpecialType = "Action", TitleText = "Choose Goverment slot to fill.", TitleIconIndex = 35, TitleIconAtlas = "TECH_ATLAS_1", UniqueOptions = {}}
	for a, b in pairs(gT.Players[iPlayer].NewHumanQueueActions) do
		if b.BonusType == "GovPrinciple" then
			return data;
		end
	end
	for i, slotID in pairs(GetAvailableGovSlotsToFill(iPlayer)) do
		table.insert(data.UniqueOptions, {Name = "Slot #" .. slotID,
			ID = slotID,
			Help = Locale.Lookup(govSlots[slotID].Help),
			})	
	end
	return data;
end

function PlayerRequestedFillingGovSlot(iPlayer, slotID)
	local slotType = govSlots[slotID].Type;
	if slotType == "Rng1" or slotType == "Rng2" then
		AssignInitialRandomlyGovSlotIfPossible(iPlayer, slotID, 100, true)
		if Game.GetActivePlayer() == iPlayer then
			LuaEvents.ITG_CallGovermentOverview(3, govSlots[slotID].OffX, govSlots[slotID].OffY) 
			Events.AudioPlay2DSound("AS2D_EVENT_NOTIFICATION_VERY_GOOD")
		end
	else
		local slotType = govSlots[slotID].Type
		local avTab = {[slotType] = true}
		if Players[iPlayer]:IsHuman() then
			local data = {BonusType = "GovPrinciple", ExtraInfo = slotID, Text = "CHOOSE PRINCIPLE", TitleText = "Choose new Goverment principle.", TitleIconIndex = 35, TitleIconAtlas = "TECH_ATLAS_1", UniqueOptions = {}, Tooltip = "There is an empty slot available in goverment tree."}
			for i, principleID in pairs(GetGovSlotRewardsAvailable(iPlayer, avTab)) do
				table.insert(data.UniqueOptions, {Name = Locale.Lookup(govSlotsTenets[principleID].Name),
							ID = principleID,
							ExtraInfo = slotID,
							Help = Locale.Lookup(govSlotsTenets[principleID].Help),
							})
			end
			table.insert(gT.Players[iPlayer].NewHumanQueueActions, data)
			LuaEvents.ITG_GeneralChooseWithPriority("CHOOSE PRINCIPLE");
			Events.SerialEventEndTurnDirty()
		else
			local evTab = {}
			for i, principleID in pairs(GetGovSlotRewardsAvailable(iPlayer, avTab)) do
				local eval = 50;
				if govSlotsTenets[principleID].AIEval then
					eval = govSlotsTenets[principleID].AIEval(iPlayer, principleID)
				elseif govSlotsTenets[principleID].AIFlavor then
					eval = math.max(1, 5 * GetAIFlavour(iPlayer, govSlotsTenets[principleID].AIFlavor))
				elseif govSlotsTenets[principleID].RevAIFlavor then
					eval = math.max(1, 5 * (10 - GetAIFlavour(iPlayer, govSlotsTenets[principleID].RevAIFlavor)))
				end				
				table.insert(evTab, {principleID, eval});
			end
			AppointGovPrincipleToSlot(iPlayer, slotID, GetRandomFromBiasedChanceTable(evTab))
		end
	end 
end

function HumanPlayerChoosesGovPrinciple(iPlayer, principleID, slotID)
	for i, sth in pairs(gT.Players[iPlayer].NewHumanQueueActions) do
		if sth.BonusType == "GovPrinciple" and sth.ExtraInfo == slotID then
			lkey = i;
			break;
		end
	end
	if lkey then
		table.remove(gT.Players[iPlayer].NewHumanQueueActions, lkey)
	end
	AppointGovPrincipleToSlot(iPlayer, slotID, principleID)
	LuaEvents.ITG_CallGovermentOverview(3, govSlots[slotID].OffX, govSlots[slotID].OffY) 
	Events.AudioPlay2DSound("AS2D_EVENT_NOTIFICATION_VERY_GOOD")
end

function DefineAIGovSlotLogic(iPlayer)
	gT.Players[iPlayer].AIGovSlotLogic = LastRandom(1,5);
	gT.Players[iPlayer].AIGovSlotOnlyHap = GetAIFlavour(iPlayer, "FLAVOR_LEGAL") > GetAIFlavour(iPlayer, "FLAVOR_HAPPINESS");
end

function DoAITryFillOneGovSlot(iPlayer, slots)
	for a, slotID in pairs(slots) do
		if not gT.Players[iPlayer].GovSlots[slotID] then
			if CanHaveGovSlot(iPlayer, slotID) then
				PushLegalActionForPlayer(iPlayer, 33, slotID)
				return true;
			end
		end
	end
	return false;
end

function GovMeritocracySlotAIDecision(iPlayer, legPower, legHapPower)
	if not gT.Players[iPlayer].AIGovSlotLogic then
		DefineAIGovSlotLogic(iPlayer)
	end
	if legHapPower < 4 then
		return false;
	end
	if gT.Players[iPlayer].AIGovSlotOnlyHap then
		if legHapPower - legPower < 4 then
			return false;
		end
	end
	if gT.Players[iPlayer].AIGovSlotLogic == 1 then
		--ALL THE SLOTS // merit non-negative pt // or equal less than 80;
		if (gT.Players[iPlayer].MeritocracyLevel < 80) or (GetMeritocracyChangePerTurn(iPlayer) >= 0) then
			return DoAITryFillOneGovSlot(iPlayer, Shuffle(GetAvailableGovSlotsToFill(iPlayer)))
		end
	elseif gT.Players[iPlayer].AIGovSlotLogic == 2 then
		--double dip removed since no random slots anymore
		if GetPrinciplesBehind(iPlayer) > 0 then
			return DoAITryFillOneGovSlot(iPlayer, Shuffle(GetAvailableGovSlotsToFill(iPlayer)))
		end
	elseif gT.Players[iPlayer].AIGovSlotLogic == 3 then
		--heavy ignore
		if GetITGGameTurn() > 80 then
			return DoAITryFillOneGovSlot(iPlayer, {1,2,11,4})
		end
	elseif gT.Players[iPlayer].AIGovSlotLogic == 4 then
		--more serious approach
		if (gT.Players[iPlayer].MeritocracyLevel < 70) or (GetMeritocracyChangePerTurn(iPlayer) >= 0) then
			local tab = {}
			if GetITGGameTurn() < 40 then
				table.insert(tab, 8)
				table.insert(tab, 12)
			end
			if Players[iPlayer]:GetReligionCreatedByPlayer() > 0 then
				table.insert(tab, 9)
			end
			local hIL = 0;
			for letter, val in pairs(gT.Players[iPlayer].Ideologies) do
				hIL = math.max(hIL, val);
			end
			if hIL >= 10 then
				table.insert(tab, 4)
			end
			if Players[iPlayer]:GetGold() >= 1000 then
				table.insert(tab, 5)
				table.insert(tab, 10)
			end
			if gT.Players[iPlayer].NationalDays >= 2 then
				table.insert(tab, 11)
			end
			if DoAITryFillOneGovSlot(iPlayer, Shuffle(tab)) then
				return true;
			end
			return DoAITryFillOneGovSlot(iPlayer, {1,2})
		end
	elseif gT.Players[iPlayer].AIGovSlotLogic == 5 then
		--ultra random
		if LastChance(3) then
			return DoAITryFillOneGovSlot(iPlayer, Shuffle(GetAvailableGovSlotsToFill(iPlayer)))
		end	
	end
	return false
end

function GetGovermentPrincipleAuthorityRewardTT(iPlayer)
	local str = ""
	for reward, v in pairs(gT.Players[iPlayer].GovRewards) do
		if govSlotsTenets[reward].Type == "Authority" then
			str = str .. "[NEWLINE][ICON_BULLET]" .. Locale.Lookup(govSlotsTenets[reward].Help) .. " (" .. Locale.Lookup(govSlotsTenets[reward].Name) .. ")"
		end
	end
	return str;
end

function PlayerDirtyGovPrinciplesNumber(iPlayer)
	local cNumber = GetNumGovSlotsFilled(iPlayer);
	local cPrev = gT.Players[iPlayer].NumPrinciples;
	if cNumber ~= cPrev then
		gT.Players[iPlayer].NumPrinciples = cNumber;
		if (cNumber > gT.Globals.NumBestPrinciples) or (cPrev == gT.Globals.NumBestPrinciples) then
			DoGlobalBestPrinciplesNumberDirty()
		end 
	end
end

function DoGlobalBestPrinciplesNumberDirty()
	local cPrev = gT.Globals.NumBestPrinciples;
	gT.Globals.NumBestPrinciples = 0;
	for g, h in pairs(gT.Players) do
		gT.Globals.NumBestPrinciples = math.max(gT.Globals.NumBestPrinciples, h.NumPrinciples);
	end
	if gT.Globals.NumBestPrinciples ~= cPrev then
	--was dirty indeed; add changes

	end
end

LuaEvents.ITGSG_RequestPrincipleTT.Add(function(iPlayer)
	local tab = {}
	if gT.Players[iPlayer].Goverment == 1 then
		tab = {"", "", true}
	else
		local hStr;
		if gT.Players[iPlayer].NumPrinciples >= gT.Globals.NumBestPrinciples then
			tab[1] = "[COLOR_POSITIVE_TEXT]" .. gT.Players[iPlayer].NumPrinciples;
			hStr = "Having a Goverment with the greatest amount of Principles in the world provides:"
			hStr = hStr .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]+1[ENDCOLOR] [ICON_ITG_MERITOCRACY] Meritocracy per turn."
--amount of principles reduced from 11 to 7 ~ reduced rewards:
--			hStr = hStr .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]+3[ENDCOLOR] [ICON_ITG_CHARM] Charm in all Cities."
			if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_EMPIRE_18, "fkelfe") then
				hStr = hStr .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]+5[ENDCOLOR] [ICON_ITG_AUTHORITY] Authority (Senate).";
			end
		else
			local iBehind = GetPrinciplesBehind(iPlayer);
			tab[1] = "[COLOR_NEGATIVE_TEXT]-" .. iBehind;
			hStr = "The more your Goverment falls behind in amount of Principles the more severe consequences you face:"
			hStr = hStr .. "[NEWLINE][ICON_BULLET]Your [ICON_ITG_GOVERNOR] Governors have extra cause to be unhappy."
			hStr = hStr .. "[NEWLINE][ICON_BULLET][COLOR_NEGATIVE_TEXT]+" .. GetUnhapFromPrinciples(iPlayer) / 10 .. "%[ENDCOLOR] [ICON_HAPPINESS_4] Unhappiness chance in all Cities."
			hStr = hStr .. "[NEWLINE][ICON_BULLET][COLOR_NEGATIVE_TEXT]+" .. GetDivideFromPrinciples(iPlayer) .. "[ENDCOLOR] [ICON_ITG_DIVIDE] Dividing Presence."
			hStr = hStr .. "[NEWLINE][ICON_BULLET][COLOR_NEGATIVE_TEXT]" .. GetGPFavourFromPrinciplesBackward(iPlayer) .."[ENDCOLOR] [ICON_ITG_CHARM] Charm in all Cities."
		end
		tab[2] = hStr;
	end
	MapModData.ITGSG = tab;
end)

function IsFirstAtPrinciples(iPlayer)
	if gT.Players[iPlayer].Goverment == 1 then
		return false;
	end
	return gT.Players[iPlayer].NumPrinciples >= gT.Globals.NumBestPrinciples;
end

function GetPrinciplesBehind(iPlayer)
	if gT.Players[iPlayer].Goverment == 1 then
		return 0;
	end	
	if gT.Players[iPlayer].NumPrinciples >= gT.Globals.NumBestPrinciples then
		return 0;
	end
	return gT.Globals.NumBestPrinciples - gT.Players[iPlayer].NumPrinciples;
end

function GetDivideFromPrinciples(iPlayer)
	local iTer = GetPrinciplesBehind(iPlayer);
	local red = 0;
	for i = 1, iTer do
		red = red + math.ceil(i / 2); -- 1/2/4/6/9/12/16...
	end
	return red;
end

function GetGPFavourFromPrinciplesBackward(iPlayer)
	local iTer = GetPrinciplesBehind(iPlayer);
	local red = 0;
	for i = 1, iTer do
		red = red - 2;  -- 2/4/6/8/10/12/14
	end
	return red;
end

function GetUnhapFromPrinciples(iPlayer)
	local iTer = GetPrinciplesBehind(iPlayer);
	local red = 0;
	for i = 1, iTer do
		red = red + 4 + i; -- 0.5/1.1/1.7/2.4/3.2/4.1/5.1...
	end
	return red;
end