local arabtrial6 =GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_ARABIA_6
local tInAemp11 = GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_EMPIRE_11;
local wonderpnw33 = GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_33;
local palaceriofrio1 = GameInfoTypes.BUILDING_ITG_NEW_INDUSTRIAL_WONDER_22

function GetBasicRewardGovFromCodex(iPlayer, govReward, div)
	if gT.Players[iPlayer].HasCodex and gT.Players[iPlayer].GovRewards[govReward] then
		return math.floor(gT.Players[iPlayer].CodexStrength / div)
	end
	return 0;
end

function LegalPointsFromIdeologies(iPlayer, bToolTip)
	local b = 0;
	if gT.Players[iPlayer].HasIdeology[15] then
		if gT.Players[iPlayer].LegalPower < 5 then
			b = b + 15;
		end
	end
	if gT.Players[iPlayer].HasIdeology[4] then
		if IsFirstAtPrinciples(iPlayer) then
			b = b + 10;
		end
	end
	if gT.Players[iPlayer].HasIdeology[33] then
		if gT.Players[iPlayer].LastTurnCityLost + 8 < GetITGGameTurn() then
			b = b + 10;
		end
	end
	if gT.Players[iPlayer].HasIdeology[41] then
		if gT.Players[iPlayer].Goverment == 1 then
			b = b + 25;
		elseif bToolTip then
			b = b - math.min(15, math.max(0, math.floor((gT.Players[iPlayer].LegalPower * 100 + gT.Players[iPlayer].LegalPowerPercent) / 20)))
		end
	end
	if gT.Players[iPlayer].HasIdeology[65] then
		b = b + math.floor(50 * GetPercentageOfLawsNotUsedTimes0x01(iPlayer))
	end
	b = b + gT.Players[iPlayer].CDIdeology12
	if gT.Players[iPlayer].HasIdeology[32] then
		for h, dlvp in pairs(gT.Players) do
			if Players[h]:IsMinorCiv() and Players[h]:IsAlive() then
				if Players[h]:CanMajorBullyGold(iPlayer, true) then
					b = b + 2;
				end
			end
		end
	end
	return b
end

function LegalPointsFromShogunate(iPlayer)
	local iTeam = Players[iPlayer]:GetTeam();
	local count = 0;
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_ASIA_3, "uvvvcewwrew") then
		for g, gdata in pairs(gT.Players) do
			if Players[g]:IsAlive() and (iPlayer ~= g) and (not Players[g]:IsMinorCiv()) then
				if not Teams[iTeam]:HasEmbassyAtTeam(Players[g]:GetTeam()) then
					if Teams[iTeam]:IsHasMet(Players[g]:GetTeam()) then
						count = count + 2;
					end
				end
			end
		end
	end
	return count;
end

function AllEmbassiesLegalPointsPerTurn(iPlayer)
	local iTeam = Players[iPlayer]:GetTeam();
	local countF, countT = 0, 0;
	local tv = 0;
	for g, gdata in pairs(gT.Players) do
		if Players[g]:IsAlive() and (not Players[g]:IsMinorCiv()) and (g ~= iPlayer) and Teams[iTeam]:IsHasMet(Players[g]:GetTeam()) then
			tv = tv + 1;
			if Teams[Players[g]:GetTeam()]:HasEmbassyAtTeam(iTeam) then
				countT = countT + 1;
			end
			if Teams[iTeam]:HasEmbassyAtTeam(Players[g]:GetTeam()) then
				countF = countF + 1;
			end
		end
	end
	local legalP = 0;
	if tv > 0 then -- it is limited now to 10 //
		legalP = math.ceil(math.max(math.min(6,countF), countF * 6 / tv) + math.max(math.min(4,countT), countT * 4 / tv))
	end
	if gT.Players[iPlayer].HasPlayerWonder[wonderpnw33] then
		legalP = legalP * 2;
	end
	return legalP;
end

function CanDefendFromAnarchy(iPlayer)
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_EUROPE_4, "Ywefvewrewr") then
		if gT.Players[iPlayer].LegalPower + GetAvailableHapForLegalAction(iPlayer) >= 6 then
			ChangeITGLegalPower(iPlayer, 6, false, false, "Defend from Anarchy")
			if iPlayer == Game.GetActivePlayer() then
				Players[iPlayer]:AddNotification(94343293, "Our empire were close to turn into Anarchy! Only your absolute power defended people from chaos.", "Unrest", -1, -1, 4)
			end
			return true;
		end
	end
	return false;
end

function PlayerWantToPurchaseLegalAuthority(iPlayer, iTimes)
	local cost = gT.Players[iPlayer].LegalAuthorityCost
	if cost > 0 then
		for i = 1, (iTimes or 1) do
			if Players[iPlayer]:GetGold() >= cost then
				gT.Players[iPlayer].LegalPower = gT.Players[iPlayer].LegalPower + 1;
				SpendITGGold(iPlayer, cost);
			else
				break;
			end
		end
	end
end
LuaEvents.ITG_CallPurchaseLegalForGold.Add(PlayerWantToPurchaseLegalAuthority)

function GetLegalCostWithFaithSecular(iPlayer)
	if gT.Players[iPlayer].SecularState then
		if not DBScenario.NoFaithGeneration then
			return 400;
		end
	end
	return -1;
end

function PlayerWantToClaimLegalWithFaith(iPlayer, iTimes)
	local cost = GetLegalCostWithFaithSecular(iPlayer)
	if cost > 0 then
		for i = 1, (iTimes or 1) do
			if Players[iPlayer]:GetFaith() >= cost then
				gT.Players[iPlayer].LegalPower = gT.Players[iPlayer].LegalPower + 1;
				SpendITGFaith(iPlayer, cost);
			else
				break;
			end
		end
	end
end
LuaEvents.ITG_CallPurchaseLegalForFaith.Add(PlayerWantToClaimLegalWithFaith)

function CanPlayerHaveThisGov(iPlayer, gov, bChoose)
	if gov == 1 then
		if bChoose then
			return false;
		end
		if Players[iPlayer]:IsMinorCiv() then
			return false;
		end
	end
	return true;
end

function GetCityLegalFromReligion(iCity, iPlayer, cID)
	local lGain = 0;
	if IsBeliefPresentInACity(iCity, GameInfoTypes.BELIEF_ITG_PANTHEON_13) then
		if Players[iPlayer]:IsCapitalConnectedToCity(iCity) then
			lGain = lGain + 2;
		end
	end
	if IsBeliefPresentInACity(iCity, GameInfoTypes.BELIEF_ITG_PANTHEON_9) then
		if iCity:GetPopulation() >= 4 then
			lGain = lGain + 1;
		end
	end
	if IsBeliefPresentInACity(iCity, GameInfoTypes.BELIEF_ITG_FOLLOWER_23) then
		if IsCityHasSpecialist(iCity) then
			lGain = lGain + 2;
		end
	end
	if IsBeliefPresentInACity(iCity, GameInfoTypes.BELIEF_ITG_FOLLOWER_32) then
		lGain = lGain + gT.Cities[cID].NumWonders * 2;
	end
	return lGain;
end

function GetCityLegalMod(iCity, cID, iPlayer)
	local mod = 100;
	if gT.Cities[cID].FestivalET then
		if gT.Players[iPlayer].FestivalBonusesActive[3] then
			mod = mod + gT.Players[iPlayer].FestivalBonusesActive[3]
		end
	end
	return mod;
end

function GetCityLegalFromCultBonuses(iCity, iPlayer, cID)
	local lGain = 0;
	return lGain;
end

function GetCityLegalFromTenshu(iCity, iPlayer, cID)
	local lGain = 0;
	if iCity:IsHasBuilding(GameInfoTypes.BUILDING_ITG_JAPAN_CASTLE) then
		lGain = lGain + GetLegalFromTenshuCastle(iCity, iPlayer)
	end
	return lGain;
end

function GetLegalPointsPerTurnCity(iCity, iPlayer)
	local lGain = 0;
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	if ITGCityCanWorkDoAction(iCity) then
		lGain = GetLegalPointsFromBuilding(iCity, iPlayer);
		lGain = lGain + GetCityLegalFromReligion(iCity, iPlayer, cID);
		lGain = lGain + GetCityLegalFromCultBonuses(iCity, iPlayer, cID);
		lGain = lGain + GetCityLegalFromTenshu(iCity, iPlayer, cID);

		local mod = GetCityLegalMod(iCity, cID, iPlayer);
		if mod ~= 100 then
			lGain = math.floor(lGain * mod / 100)
		end
	end
	return lGain;
end

function GetLegalPointsFromBuilding(iCity, iPlayer)
	local lGain = iCity:GetLegalPowerPoints();
	for bClass, amount in pairs(gT.Players[iPlayer].LegalPointsFromBuildingClasses) do
		local bb = Players[iPlayer]:GetPlayerUniqueBuilding(bClass);
		if iCity:IsHasBuilding(bb) then
			local numBuilding = iCity:GetNumRealBuilding(bb) + iCity:GetNumFreeBuilding(bb);
			lGain = lGain + numBuilding * amount;
		end
	end
	if IsBeliefPresentInACity(iCity, GameInfoTypes.BELIEF_ITG_FOLLOWER_24) then
		local bClass = GameInfoTypes.BUILDINGCLASS_STONE_WORKS
		local bb = Players[iPlayer]:GetPlayerUniqueBuilding(bClass);
		if iCity:IsHasBuilding(bb) then
			local numBuilding = iCity:GetNumRealBuilding(bb) + iCity:GetNumFreeBuilding(bb);
			lGain = lGain + numBuilding * 1;
		end
		bClass = GameInfoTypes.BUILDINGCLASS_WORKSHOP
		bb = Players[iPlayer]:GetPlayerUniqueBuilding(bClass);
		if iCity:IsHasBuilding(bb) then
			local numBuilding = iCity:GetNumRealBuilding(bb) + iCity:GetNumFreeBuilding(bb);
			lGain = lGain + numBuilding * 1;
		end
	end
	if IsBeliefPresentInACity(iCity, GameInfoTypes.BELIEF_ITG_FOLLOWER_25) then
		if iCity:GetNumFollowers(iCity:GetReligiousMajority()) >= 3 then
			local bClass = GameInfoTypes.BUILDINGCLASS_MARKET
			local bb = Players[iPlayer]:GetPlayerUniqueBuilding(bClass);
			if iCity:IsHasBuilding(bb) then
				local numBuilding = iCity:GetNumRealBuilding(bb) + iCity:GetNumFreeBuilding(bb);
				lGain = lGain + numBuilding * 1;
			end
		end
	end
	return lGain;
end

function LegalPointsFromOccupiedCities(iPlayer)
	local lgain = 0;
	for iCity in Players[iPlayer]:Cities() do
		if iCity:IsOccupied() then
			lgain = lgain - 1;
		end
	end
	return lgain;
end

function GetLegalFromTenshuCastle(iCity, iPlayer)
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	for h, sIndex in pairs(GetNearCities(cID, 10)) do
		local hCity = Map.GetPlotByIndex(sIndex):GetPlotCity();
		if hCity:GetOwner() ~= iPlayer then 
			return 0;
		end
	end
	return 2;
end

function LegalPointsFromLeagues(iPlayer, bAddHelp)
	local val = 0;
	for league, sth in pairs(gT.Leagues) do
		if sth.Members[iPlayer] then
			if sth.Resolutions[8] then
				local cval = 0;
				for b, h in pairs(sth.Members) do
					if b ~= iPlayer then
						if gT.Players[b].LegalPower > 0 then
							cval = cval + gT.Players[b].LegalPower;
							if bAddHelp then
								gT.Leagues[league].Members[b].HelpPoints[8] = (gT.Leagues[league].Members[b].HelpPoints[8] or 0) + gT.Players[b].LegalPower;
							end
						end
					end
				end
				val = val + math.min(cval, 5);
			end
		end
	end
	return val;
end

function LegalPointsFromLaws(iPlayer)
	local t = 0
	return t;
end
function LegalPointsFromPriviliges(iPlayer)
	return 0;
end
function LegalPointsFromManufactories(iPlayer)
	local t = 0;
	for i, v in pairs(gT.Manufactories) do
		if v.Player == iPlayer and v.Active then
			for j, b in pairs(v.Traits) do
				if b.ID == 25 then
					t = t + math.floor(v.TActive / 8)
				end
			end
		end
	end
	return t;
end
function GetLegalPointsFromPalace(iPlayer)
	local b = 0;
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		if gT.Cities[cID].Palace then
			b = b + gT.Cities[cID].Palace.Legal * GetCityPalaceYieldMod(iCity, cID, iPlayer)
		end		
	end
	return b;
end

function GetConvertedLegalIntoFaith(iPlayer, amount)
--	if IsHasLaw(iPlayer, 22, 2) then
--		local lnew = gT.Players[iPlayer].Law22LegalPoints + amount;
--		return -math.floor(lnew / 4);
--	end
	return 0;
end

function GetConvertedScienceIntoFaith(iPlayer, amount)
--	if IsHasLaw(iPlayer, 22, 3) then
--		local lnew = gT.Players[iPlayer].Law22SciencePoints + amount;
--		return -3 * math.floor(lnew / 30);
--	end
	return 0;
end

function GetConvertedFaithIntoLegal(iPlayer, amount)
--	if IsHasLaw(iPlayer, 22, 1) then
--		local lnew = gT.Players[iPlayer].Law22FaithPoints + amount;
--		return -5 * math.floor(lnew / 20);
--	end
	return 0;
end

function LegalPointsFromCodex(iPlayer)
	local t = 0;
	if gT.Players[iPlayer].HasCodex then	
		t = t + 2 + math.floor(gT.Players[iPlayer].CodexStrength / 30)
	end
	return t;
end

function GetLegalPointsFromAuthority(iPlayer)
	local t = 0;
	if gT.Players[iPlayer].Goverment == 1 then
		t = math.floor(gT.Players[iPlayer].Authority / 4)
	end
	return t;
end

function GetLegalFromPrinciplesPT(iPlayer)
	local b = 0;
	if gT.Players[iPlayer].GovRewards[9] then
		for cID, dd in pairs(gT.Cities) do
			if (dd.CultureLevels[iPlayer] or 0) >= 4 then
				b = b + 1;
			end
		end
	end
	if gT.Players[iPlayer].GovRewards[9] then
		if gT.Players[iPlayer].AverageHappiness > 0 then
			b = b + 2;
		end
	end
	return b
end

function GetLegalPointsFromInnovations(iPlayer)
	local t = 0;
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_TRIBE_8, "Fkofkeof") then
		t = t + gT.Players[iPlayer].GreatestCityPopCaptured;
	end
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_EMPIRE_18, "kfokeof") then
		t = t + gT.Players[iPlayer].NumPrinciples
	end
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_ASIA_8, "dkoea") then
		t = t + gT.Players[iPlayer].NumUniqueGPTypes;
	end
	return t;
end

function GetLegalPointsPerTurn(iPlayer, bTooltip, bTurnMade, bIgnoreConvert)
	if gT.Players[iPlayer].LegalGainDisabled > 0 then
		return 0;
	end
	local base = GreatPeopleLegalPointsPerTurn(iPlayer) + FortsAndCitadelsLegalPointsPerTurn(iPlayer) + WorldWonderLegalPointsPerTurn(iPlayer) + GetCurrentLegalPowerPerTurnFromGoverment(iPlayer) + AllEmbassiesLegalPointsPerTurn(iPlayer);
	local legfromcities = AllCitiesLegalPointsPerTurn(iPlayer);
	base = base + legfromcities + GetCorruptionLegal(iPlayer, legfromcities) + LegalPointsFromLaws(iPlayer);
	base = base + LegalPointsFromHeresy(iPlayer) + LegalPointsFromCodex(iPlayer);
	base = base + GetLegalPointsFromAuthority(iPlayer) + GetLegalFromPrinciplesPT(iPlayer)
	base = base + LegalPointsFromPriviliges(iPlayer) + LegalPointsFromManufactories(iPlayer) + GetLegalPointsFromInnovations(iPlayer)
	base = base + LegalPointsFromLeagues(iPlayer, bTurnMade) + GetLegalPointsFromPalace(iPlayer) ;
	base = base + LegalPointsFromOccupiedCities(iPlayer) + LegalPointsFromTechnology(iPlayer) + LegalPointsFromIdeologies(iPlayer, bTooltip)
	base = base + LegalPointsFromShogunate(iPlayer) + GetPlayer10thBonusFromCaliph(iPlayer);
	base = base + LegalPointsFromDoFs(iPlayer) + LegalPointsFromAlliedCSs(iPlayer) + LegalPointsFromReligion(iPlayer);
	if bTooltip then
		base = base + EstimatedLegalGrowthFromSpies(iPlayer) + GetLegalPercentFromTithe(iPlayer);
		base = base + GetEstimatedLegalFromBudget(iPlayer);
		if not bIgnoreConvert then
			local cTotal = base;
			base = base - 2 * GetConvertedFaithIntoLegal(iPlayer, GetTotalFaithFromExtraSourcesITG(iPlayer, true, true)) / 5;
			base = base + GetConvertedLegalIntoFaith(iPlayer, cTotal)
		end
	end
	return base;
end

function LegalPointsFromAlliedCSs(iPlayer)
	local lpa = 3; -- first +3; second +2; rest +1; up to 8;
	local base = 0;
	for g, gdata in pairs(gT.Players) do
		if g ~= iPlayer then
			if Players[g]:IsMinorCiv() then
				if Players[g]:GetAlly() == iPlayer then
					base = base + lpa;
					if base >= 8 then
						break;
					else
						lpa = math.max(1, lpa - 1);
					end
				end
			end
		end
	end
	for i, minor in pairs(gT.Globals.CSbyTypes[GameInfoTypes.MINOR_TRAIT_TRADITIONAL]) do
		base = base + math.max(0, Players[minor]:GetMinorCivFriendshipLevelWithMajor(iPlayer));
	end
	local mod = 1;
	if gT.Players[iPlayer].HasPlayerWonder[wonderpnw33] then
		mod = mod + 1;
	end
	if gT.Players[iPlayer].CultBonusOn[118] then
		mod = mod + 0.5;
	end
	return math.floor(base * mod);
end

function HasAtLeastOneDof(iPlayer)
	for l, h in pairs(gT.Leagues) do
		if h.Members[iPlayer] and (not h.DoFindepedent) then
			return true;
		end
	end
	--[[
	for g, gdata in pairs(gT.Players) do
		if g ~= iPlayer then
			if not Players[g]:IsMinorCiv() then
				if Players[iPlayer]:IsDoF(g) then
	]]
	return false;
end

function LegalPointsFromDoFs(iPlayer)
	if HasAtLeastOneDof(iPlayer) then
		return 4;
	end
	return 0;
end

function AllCitiesLegalPointsPerTurn(iPlayer)
	local base = 0;
	for iCity in Players[iPlayer]:Cities() do
		base = base + GetLegalPointsPerTurnCity(iCity, iPlayer)
	end
	return base;
end

function ChangeITGLegalPointsPercent(iPlayer, amount, bNotConvertable, hString)
	if amount > 0 then
--[[	if IsHasLaw(iPlayer, 22, 2) and (not bNotConvertable) then
			local lnew = gT.Players[iPlayer].Law22LegalPoints + amount;
			local lred = math.floor(lnew / 4);
			if lred > 0 then
				amount = amount - lred;
				gT.Players[iPlayer].Law22LegalPoints = lnew - lred * 4;
				ChangeITGFaith(iPlayer, lred * 3, true)
			end
		end ]] --left if needed to do any kind of conversion again...
	elseif amount < 0 then
		if hString ~= "DoTurn" then
			print("ChangeITGLegalPointsNegative", iPlayer, amount, bNotConvertable, hString)
		end
	end
	local ntt = amount + gT.Players[iPlayer].LegalPowerPercent;
	if ntt >= 100 then
		gT.Players[iPlayer].LegalPower = math.floor(ntt/100) + gT.Players[iPlayer].LegalPower
		ntt = ntt - math.floor(ntt/100) * 100;
	end
	if ntt < 0 then
		if gT.Players[iPlayer].LegalPower > 0 then
			gT.Players[iPlayer].LegalPower = gT.Players[iPlayer].LegalPower - 1;
			ntt = ntt + 100;
		end
	end
	gT.Players[iPlayer].LegalPowerPercent = ntt;
	if iPlayer == Game.GetActivePlayer() then
		LuaEvents.ITGSGTopPanelDirty()
	end
end

function GetTotalLegalPercentAvailable(iPlayer)
	return (gT.Players[iPlayer].LegalPower * 100 + gT.Players[iPlayer].LegalPowerPercent);
end

function SpendITGLegalPowerPercent(iPlayer, amount, bRemoved, sLog)
	if not bRemoved then
		LogSpendLegalPower(iPlayer, amount/100)
	end
	local tt = math.floor(amount / 100);
	table.insert(gT.Players[iPlayer].AISpendLegalLog, {GetITGGameTurn(), amount/100, true, 0, sLog or "spend?", bRemoved})
	gT.Players[iPlayer].LegalPower = gT.Players[iPlayer].LegalPower - tt;
	local ntt = gT.Players[iPlayer].LegalPowerPercent - amount + tt * 100;
	if ntt < 0 then
		gT.Players[iPlayer].LegalPower = gT.Players[iPlayer].LegalPower - 1;
		ntt = ntt + 100;
	end
	gT.Players[iPlayer].LegalPowerPercent = ntt;
	if iPlayer == Game.GetActivePlayer() then
		LuaEvents.ITGSGTopPanelDirty()
	end
end

function DoTurnLegalPostApocalypse(iPlayer)
	local getTotallChange = GetLegalPointsPerTurn(iPlayer, false, true)
	gT.Players[iPlayer].Ideo41 = 0;
	if gT.Players[iPlayer].HasIdeology[41] then
		if gT.Players[iPlayer].Goverment ~= 1 then
			local cModNew = math.min(15, math.max(0, math.floor((gT.Players[iPlayer].LegalPower * 100 + gT.Players[iPlayer].LegalPowerPercent) / 20)))
			if cModNew ~= 0 then
				gT.Players[iPlayer].Ideo41 = cModNew * 0.02;
				SpendITGLegalPowerPercent(iPlayer, cModNew, true, "Ideo41")
			end
		end
	end
	AddGraphData(iPlayer, 8, getTotallChange, false)
	gT.Players[iPlayer].LastTurnLegalPoints = getTotallChange;
	ChangeITGLegalPointsPercent(iPlayer, getTotallChange, nil, "DoTurn")
	if gT.Players[iPlayer].Goverment == 1 then
		gT.Players[iPlayer].CentralizeDiscount = gT.Players[iPlayer].CentralizeDiscount + 0.25;
	end
	if ShouldTriggerAnarchyChanceFromLegal(iPlayer) then
		DoTriggerAnarchyChance(iPlayer, "Legal")
	end
end

function ShouldTriggerAnarchyChanceFromLegal(iPlayer)
	if gT.Players[iPlayer].LegalPower < 0 then
		if not gT.Players[iPlayer].HasIdeology[1] then
			if gT.Players[iPlayer].Goverment ~= 1 then
				return true;
			end
		end
	end
	return false;
end

function WorldWonderLegalPointsPerTurn(iPlayer)
	local base = 0;
	base = base + 3 * (gT.Players[iPlayer].WonderRuinsEffects[7] or 0)
	if gT.Players[iPlayer].HasPlayerWonder[palaceriofrio1] then
		if gT.Players[iPlayer].Goverment == 1 then
			base = base + 25;
		end
	end
	return base;
end

function GreatPeopleLegalPointsPerTurn(iPlayer)
	local base = 0;
	local bGSEX1 = HasPlayerTech(iPlayer, tInAemp11, "buedderj")
	for jUnit in Players[iPlayer]:Units() do
		if jUnit:IsHasPromotion(GameInfoTypes.PROMOTION_GREAT_GENERAL_15) or jUnit:IsHasPromotion(GameInfoTypes.PROMOTION_ITG_GREAT_ADMIRAL_13) then
			base = base + 1;
		end
	end
	for gpID, hhh in pairs(gT.Players[iPlayer].GreatPeople) do
		local gpData = gT.GreatPeople[gpID];
		if gpData.Alive then
			if gpData.Legal then
				base = base + gpData.Legal * gT.Players[iPlayer].YieldModGreatPeople[gpData.Type]
			end
			if bGSEX1 then
				if gpData.Type == 3 then
					base = base + 1;
				end
			end
		end
	end
	return base * gT.Players[iPlayer].GPYieldsMod;
end

function LegalPointsFromTechnology(iPlayer)
	return gT.Players[iPlayer].LegalFromTech
end

function LegalPointsFromReligion(iPlayer)
	local base = 0;
	if IsPlayerHaveBelief(iPlayer, GameInfoTypes.BELIEF_ITG_FOUNDER_6) then
		base = base + Game.GetNumCitiesFollowing(Players[iPlayer]:GetReligionCreatedByPlayer()) * gT.Players[iPlayer].FounderBeliefModifier;
	end	
	if IsPlayerHaveBelief(iPlayer, GameInfoTypes.BELIEF_ITG_FOUNDER_7) then
		base = base + math.floor(Players[iPlayer]:GetNumForeignFollowers(true) / 8) * gT.Players[iPlayer].FounderBeliefModifier;
	end
	return base;
end

function LegalPointsFromHeresy(iPlayer)
	local t = 0;
	return t;
end

function UpdateMinorRelationsGov(iPlayer)
	local govtype = gT.Players[iPlayer].Goverment;
	local pp = govtype == 1
	for g, gdata in pairs(gT.Players) do
		if Players[g]:IsMinorCiv() then
			local SR, SD, SA = 0, 0, 0;
			if pp then
				SR, SD, SA = -20, 20, 0;
			elseif gdata.Goverment == govtype then 
				SR, SD, SA = 0, 0, CS_ANCHOR_FROM_COMMON_GOV;
			elseif gdata.Goverment ~= 1 then
				SR, SD, SA = -CS_INFLUENCE_RATE_DIF_GOV, CS_INFLUENCE_RATE_DIF_GOV, 0;
			end
			Players[g]:ChangeMinorCivDecayModWithMajor(iPlayer, SD - (gT.Players[iPlayer].GovMinorDecay[g] or 0))
			gT.Players[iPlayer].GovMinorDecay[g] = SD;
			Players[g]:ChangeMinorCivRecoveryModWithMajor(iPlayer, SR - (gT.Players[iPlayer].GovMinorRecovery[g] or 0))
			gT.Players[iPlayer].GovMinorRecovery[g] = SR;
			Players[g]:ChangeMinorCivExtraAnchorWithMajor(iPlayer, SA - (gT.Players[iPlayer].GovMinorAnchor[g] or 0))
			gT.Players[iPlayer].GovMinorAnchor[g] = SA;
		end
	end
end

function UpdateAllPlayerMinorGovRelations()
	for g, gdata in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			UpdateMinorRelationsGov(g)
		end
	end
end

function GetCodexDiscountInit()
	return LastRandom(DBScenario.MinCodexDiscount, DBScenario.MaxCodexDiscount);
end

function AssignInitialGoverment()
	for g, gdata in pairs(gT.Players) do
		local chosengov;
		if gT.EraData and gT.PreviousEra then
			local revGov = tempconvinit[g].RevolutionGoverment
			gT.Players[g].CodexDiscount = GetCodexDiscountInit();
			if gT.Players[g].CodexDiscount < tempconvinit[g].CodexDiscount then
				gT.Players[g].CodexDiscount = math.max(gT.Players[g].CodexDiscount, math.min(tempconvinit[g].CodexDiscount, GetCodexDiscountInit()))
			end
			if revGov then
				if CanPlayerHaveThisGov(g, revGov) then
					chosengov = revGov;
				end
			else
				local prevGov = tempconvinit[g].Goverment
				if prevGov == 1 then
					prevGov = tempconvinit[g].GovermentBeforeAnarchy
				end
				if CanPlayerHaveThisGov(g, prevGov) then
					chosengov = prevGov;
				end
			end
			local anarchInitChance = 0; -- keep chance to start at anarchy
			local totalchance = 0;
			for i, data in pairs(RequestCultureTypeGoverments(gdata.CultureType)) do
				if CanPlayerHaveThisGov(g, data[1]) then
					totalchance = totalchance + data[2];
					if data[1] == 1 then
						anarchInitChance = anarchInitChance + 1;
					end
				end
			end
			if anarchInitChance >= LastRandom(1, totalchance) then
				chosengov = 1;
			end
		else
			gT.Players[g].CodexDiscount = GetCodexDiscountInit()
		end
		if not chosengov then
			local hTab = {}
			for i, data in pairs(RequestCultureTypeGoverments(gdata.CultureType)) do
				if CanPlayerHaveThisGov(g, data[1]) then
					table.insert(hTab, data)
				end
			end
			chosengov = GetRandomFromBiasedChanceTable(hTab)
		end
		ChooseNewGoverment(g, chosengov, true)
		gT.Players[g].NextAnarchyImmune = (1 == chosengov);
	end
	UpdateAllPlayerMinorGovRelations()
end

function GetPlayerScienceLegalCost(iPlayer)
	local base = 0;
	if HasPlayerTech(iPlayer, arabtrial6, "Uvvvvwwwerwe") then
		base = base + math.ceil(gT.Players[iPlayer].LastScienceBonusCost / 300);
	end
	return base;
end

function DoRevolution(iPlayer, gv, iExtraPrinciples)
	OnRevolutionDeleteAllPrincipleSlots(iPlayer)
	gT.Players[iPlayer].RevolutionGoverment = gv
	ChooseNewGoverment(iPlayer, gv)
	gT.Players[iPlayer].ITGTitle = nil; -- it will reset title to new gov
	if iExtraPrinciples > 0 then
		DoAddRandomlyPrincipleSlots(iPlayer, iExtraPrinciples)
	end
	if Players[iPlayer]:IsHuman() then
		LuaEvents.ITG_AchievementCompleted(60)
	end
	VictoryTaskCompletion(iPlayer, 64)
end

function EstablishCodex(iPlayer)
-- only used for mid-game?
	gT.Players[iPlayer].HasCodex = true
	gT.Players[iPlayer].CodexStrength = 50;
	gT.Players[iPlayer].CodexDate =  GetTextDate(GetITGGameTurn(), gT.Globals.StartDate, true)
	gT.Players[iPlayer].CodexTurn = GetITGGameTurn();
	gT.Players[iPlayer].CodexScenario = gT.Globals.ScenarioType;
end