function TakeALookOnAIGovernors(iPlayer)
	AIOnReassigningGovernors(iPlayer)
	AIOnExecutingGovernors(iPlayer)
	AIOnNominatingGovernors(iPlayer)
	gT.Players[iPlayer].AIGovernorsScript = GetITGGameTurn() + LastRandom(4,15);
end

function AIOnReassigningGovernors(iPlayer)
	if not HasFreeLocationForGovernor(iPlayer) then
		return;
	end
	local bDoneSth = false;
	for govID, bool in pairs(gT.Players[iPlayer].Governors) do
		if not cityIndex then
			MakeAIAssignUnassignedGovernor(iPlayer, govID)
			if not HasFreeLocationForGovernor(iPlayer) then
				return;
			end
			bDoneSth = true;
		end		
	end
	if bDoneSth then
		return;
	end
	local cCity = Players[iPlayer]:GetCapitalCity();
	local emptyCities = {}
	local gNoinfluence, gLinfluence = 0, 0
	for iCity in Players[iPlayer]:Cities() do
		local cityplotindex = iCity:Plot():GetPlotIndex()
		if not iCity:IsCapital() then
			if not gT.Cities[cityplotindex .. "," .. iCity:GetGameTurnFounded()].PlacedGovernor then
				table.insert(emptyCities, cityplotindex)
			end
		end
		local govID = gT.Cities[cityplotindex .. "," .. iCity:GetGameTurnFounded()].PlacedGovernor;
		if not govID then
			gNoinfluence = gNoinfluence + 1
		elseif govID == -1 then
			gLinfluence = gLinfluence + 1;
		end
	end
	local options = {}
	for govID, bool in pairs(gT.Players[iPlayer].Governors) do
		if CanBeReassigned(govID, iPlayer) then 
			for i, cityplotindex in pairs(emptyCities) do
				local preDoneGovTab = {}
				preDoneGovTab[govID] = cityplotindex;
				for hgovID, bBb in pairs(gT.Players[iPlayer].Governors) do
					if hgovID ~= govID then
						local cityIndex = gT.Globals.Governors[hgovID].City;
						if cityIndex then
							preDoneGovTab[hgovID] = cityIndex;
						end
					end		
				end
				local fTab, governors = GenerateGovernorCitiesData(iPlayer, cCity, preDoneGovTab);
				local iCountUndefined = 0;
				for dsd, brb in pairs(fTab) do
					if brb == -2 then
						iCountUndefined = iCountUndefined + 1;
					end
				end
				table.insert(options, {{govID, cityplotindex}, iCountUndefined, governors[-1][2], governors[govID][2]})
			end
		end
	end
	table.insert(options, {{-1, -1}, gNoinfluence, gLinfluence, 1000})
	table.sort(options, SortFunctionLowest2Greatest3Greatest4)
	if options[1][1][1] ~= -1 then
		AssignGovernorToCity(iPlayer, options[1][1][1], options[1][1][2], nil, true)
	end
end

function GetPlayerGovernorReassignCD(iPlayer, govID)
	local base = 20;
	if gT.Players[iPlayer].HasIdeology[89] then
		base = base - 10;
	end
	return math.max(5, base);
end

function CanGovernorBeReassigned(govID, iPlayer)
	if gT.Globals.Governors[govID].LastTAssign + GetPlayerGovernorReassignCD(iPlayer, govID) < GetITGGameTurn() then
		if gT.Globals.Governors[govID].City then
			if Map.GetPlotByIndex(gT.Globals.Governors[govID].City):GetPlotCity():GetDamage() > 0 then
				return false;
			end
		end
		return true;
	end
	return false;
end

function MakeAIAssignUnassignedGovernor(iPlayer, govID)
	local options = {}
	local cCity = Players[iPlayer]:GetCapitalCity();
	for iCity in Players[iPlayer]:Cities() do
		if not iCity:IsCapital() then
			local cityplotindex = iCity:Plot():GetPlotIndex()
			if not gT.Cities[cityplotindex .. "," .. iCity:GetGameTurnFounded()].PlacedGovernor then
				local preDoneGovTab = {}
				preDoneGovTab[govID] = cityplotindex;
				for hgovID, bool in pairs(gT.Players[iPlayer].Governors) do
					if hgovID ~= govID then
						local cityIndex = gT.Globals.Governors[hgovID].City;
						if cityIndex then
							preDoneGovTab[hgovID] = cityIndex;
						end
					end		
				end
				local fTab, governors = GenerateGovernorCitiesData(iPlayer, cCity, preDoneGovTab);
				local iCountUndefined = 0;
				for dsd, brb in pairs(fTab) do
					if brb == -2 then
						iCountUndefined = iCountUndefined + 1;
					end
				end
				table.insert(options, {cityplotindex, iCountUndefined, governors[-1][2], governors[govID][2]})
			end
		end
	end
	if #options > 0 then
		table.sort(options, SortFunctionLowest2Greatest3Greatest4)
		AssignGovernorToCity(iPlayer, govID, options[1][1])
	end
end

function AIOnExecutingGovernors(iPlayer)
	if LastChance(math.max(50, GetITGGameTurn())) then
		return;
	end
	local tresh, gov = 50, nil;
	for govID, sth in pairs(gT.Players[iPlayer].Governors) do
		local eval = GetAIReasonToExecuteGovernor(iPlayer, govID)
		if eval > tresh then
			tresh = eval;
			gov = govID;
		end
	end
	if gov and LastChance(tresh) then
		AIExecuteGovernorReason(iPlayer, gov)
	end
end

function AIExecuteGovernorReason(iPlayer, govID)
	print("AI is executing Governor", iPlayer, govID)
	local actionID = 1;
	if gT.Players[iPlayer].OfficialReligion and (gT.Players[iPlayer].OfficialReligion ~= gT.Globals.Governors[govID].CityReligion) then
		actionID = 3;
	else
		local iForeignPlotting = math.min(100, gT.Globals.Governors[govID].PowerSources["Foreign Relations"] or 0)
		local iCompetence = math.min(100, -1 * (gT.Globals.Governors[govID].PowerSources["Incompetence"] or 0))
		if gT.Globals.Governors[govID].Type == 7 then
			iForeignPlotting = 0;
		end
		if iCompetence > 0 then
			if iForeignPlotting > iCompetence then
				actionID = 2;
			else
				actionID = 4;
			end
		elseif iForeignPlotting > 0 then
			actionID = 2;
		end
	end
	AIResolveVoidedDiploNote(iPlayer, 32, actionID, govID)
end

function GetAIReasonToExecuteGovernor(iPlayer, govID)
	local eval = 1 + (gT.Globals.Governors[govID].PowerSources["Foreign Relations"] or 0)
	local numgovernors = GetNumActiveGovernors(iPlayer)
	local numtotalavailable = GetNumAvailableGovernors(iPlayer)
	local ungoverned = GetNumCitiesUnderGovernor(iPlayer, govID)
	local totalCities = Players[iPlayer]:GetNumCities();
	local govPower = gT.Globals.Governors[govID].Power;
	local playerPower = GetPlayerGovernorPower(iPlayer);
	local ePower = math.max(0, (govPower - playerPower) / 2)
	if totalCities < 1 + numgovernors then
		eval = eval + ePower + 4;
	end
	if numgovernors == numtotalavailable then -- okay some room to make free space
		eval = eval + ePower / 2 + 4;
	end
	if ungoverned == 0 then
		eval = eval + ePower / 3 + 3 * totalCities;
	end
	local gTurn = GetITGGameTurn();
	if gTurn > 75 then
		eval = math.max(1, eval - gTurn + 75)
	end
	return math.floor(eval);
end

function GetRelationWithThirdGovernor(govID, oGov)
	if not gT.Globals.Governors[govID].EvalRelations[oGov] then
		print("Governor has not defined relation with 3rd governor", govID, oGov);
		return 50;
	end
	if gT.Globals.Governors[govID].Character.LoyaltyType == 5 then
		return math.min(gT.Globals.Governors[govID].EvalRelations[oGov], 100 - gT.Globals.Governors[govID].EvalRelations[oGov]);
	end
	return gT.Globals.Governors[govID].EvalRelations[oGov];
end

local innoTafr6 = GameInfoTypes.TECH_UNIQUE_ITG_MEDIEVAL_AFR_6
function DoFirstGovImpression(govID, gov, iPlayer)
	local base = 50;
	if gT.Globals.Governors[gov].Betrayed then
		base = base - 20;
	end
	local rngfactor = gT.Globals.Governors[govID].Character.Decisiveness * 2
	base = base + LastRandom(-rngfactor, rngfactor);
	if LastChance(gT.Globals.Governors[govID].Character.Pettiness) then
		base = base - 50;
	end
	if LastChance(gT.Globals.Governors[govID].Character.Conflict * 7) then
		base = base - 15;
	end
	if gT.Globals.Governors[govID].CityTrait == gT.Globals.Governors[gov].CityTrait then
		base = base - 10;
	end
	if HasPlayerTech(iPlayer, innoTafr6, "innoTafr6") then
		base = base - 25;
	end
	if gT.Globals.Governors[govID].Character.LoyaltyType == 10 then
		base = base + 15;
	elseif gT.Globals.Governors[govID].Character.LoyaltyType == 6 then
		base = base - 5;
	elseif gT.Globals.Governors[govID].Character.LoyaltyType == 4 then
		base = base + 10;
	elseif gT.Globals.Governors[govID].Character.LoyaltyType == 5 then
		base = base + LastRandom(-10, 10);
	elseif gT.Globals.Governors[govID].Character.LoyaltyType == 8 then
		base = LastRandom(1,100);
	elseif gT.Globals.Governors[govID].Character.LoyaltyType == 9 then
		if base < 50 then
			base = 30;
		else
			base = 70;
		end
	end
	gT.Globals.Governors[govID].EvalRelations[gov] = math.max(30, math.min(70, base));
end

function DoOnTurnGovRelationChange(govID, gov, iPlayer)
	local bad, good = 1, 1;
	if gT.Globals.Governors[gov].EvalRelations[govID] <= 25 then
		bad = bad + math.ceil(gT.Globals.Governors[govID].Character.Decisiveness / 5);
	elseif gT.Globals.Governors[gov].EvalRelations[govID] >= 75 then
		good = good + math.ceil(gT.Globals.Governors[govID].Character.Decisiveness / 5);
	end
	bad = bad + math.floor(gT.Globals.Governors[govID].Character.Pettiness / 5);
	if gT.Globals.Governors[govID].Character.Conflict > 5 then
		bad = bad + 1;
	else
		good = good + 1;
	end
	if not gT.Globals.Governors[gov].City then
		good = good + 1;
	end
	if HasPlayerTech(iPlayer, innoTafr6, "innoTafr6") then
		bad = bad + 3;
	end
	if gT.Globals.Governors[govID].Character.LoyaltyType == 1 then
		if gT.Globals.Governors[gov].Betrayed then
			bad = bad + 1;
		end
	elseif gT.Globals.Governors[govID].Character.LoyaltyType == 2 then
		if gT.Globals.Governors[gov].Betrayed then
			bad = bad + 2;
		end
	elseif gT.Globals.Governors[govID].Character.LoyaltyType == 6 then
		bad = bad + 1;
	elseif gT.Globals.Governors[govID].Character.LoyaltyType == 7 then
		if gT.Globals.Governors[govID].Power  > gT.Globals.Governors[gov].Power then
			good = good + 1;
		else
			bad = bad + 1;
		end
	elseif gT.Globals.Governors[govID].Character.LoyaltyType == 8 then
		bad = bad * 2;
		good = good * 2;
	elseif gT.Globals.Governors[govID].Character.LoyaltyType == 9 then
		if good > bad then
			DoChangeRelationsBetweenGovs(govID, gov, 1)
		elseif bad > good then
			DoChangeRelationsBetweenGovs(govID, gov, -1)
		end
		return;
	elseif gT.Globals.Governors[govID].Character.LoyaltyType == 10 then
		good = good + 1;
	end
	DoChangeRelationsBetweenGovs(govID, gov, LastRandom(-bad, good))
end

function DoChangeRelationsBetweenGovs(govID, gov, iChange, bMutual)
	if iChange ~= 0 then
		gT.Globals.Governors[govID].EvalRelations[gov] = math.max(0, math.min(100, gT.Globals.Governors[govID].EvalRelations[gov] + iChange))
		if bMutual then
			gT.Globals.Governors[gov].EvalRelations[govID] = math.max(0, math.min(100, gT.Globals.Governors[gov].EvalRelations[govID] + iChange))
		end
	end
end