local GreatCivilianPeopleBonusesTable;
local mahabodhitemple1 = GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_41;
local bWonder20pnw = GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_20;
local bClassColosseum = GameInfoTypes.BUILDINGCLASS_COLOSSEUM;
local bClassGarden = GameInfoTypes.BUILDINGCLASS_GARDEN;
local ancCSt30 =  GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_30;
local iWonderSh = GameInfoTypes.BUILDING_ITG_NEW_MEDIEVAL_WONDER_14;
local bIndTheathre = GameInfoTypes.BUILDING_ITG_IND_AMPHITHEATER;
local indo17inno = GameInfoTypes.TECH_UNIQUE_ITG_INDUSTRIAL_17;
local tAncCS18 = GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_18;
local oracleW = GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_7;
local trialAsia8 = GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_ASIA_8;
local arabtrial7 = GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_ARABIA_7;
local phiCityHall = GameInfoTypes.BUILDING_ITG_NEW_INDUSTRIAL_WONDER_16
local tempStoredCharm;
local lSgreatpeopleData = {}
for row in DB.Query("SELECT * FROM ITGGreatPeople") do
	local index = row.ID;
	lSgreatpeopleData[index] = {}
	for a, b in pairs(row) do
		lSgreatpeopleData[index][a] = b
	end
end
function GetGPDataOrAlt(type, string)
	if DBScenario.AltGreatPeopleArt then
		return lSgreatpeopleData[type]["Alt" .. string];
	end
	return lSgreatpeopleData[type][string];
end

function ReadBasicGPInfo(gpID)
	local type = gT.GreatPeople[gpID].Type;
	gT.GreatPeople[gpID].Military = lSgreatpeopleData[type].Military;
	gT.GreatPeople[gpID].CanBeAssassinated = lSgreatpeopleData[type].CanBeAssassinated;
	gT.GreatPeople[gpID].DNIC = lSgreatpeopleData[type].DoNotIncreaseCost;
	gT.GreatPeople[gpID].DoNotMigrate = lSgreatpeopleData[type].DoNotMigrate;
	gT.GreatPeople[gpID].DoNotTravelAway = lSgreatpeopleData[type].DoNotTravelAway;
	if LastChance(lSgreatpeopleData[type].MentorChance) then
		gT.GreatPeople[gpID].ICTAO = true;
	end
	if not lSgreatpeopleData[type].Military then
		if not gT.GreatPeople[gpID].DoNotMigrate then
			if gT.Globals.GameGenerated then
				gT.GreatPeople[gpID].MigrateMeter = 0;
			else
				gT.GreatPeople[gpID].MigrateMeter = LastRandom(0, 50);
			end
		end
	end
end

function ResetGPMigrationInTheCity(iPlayer, iCity, cID)
	if GetITGCityInteger(iCity, "CI_NUM_GP") > 0 then
		local cindex = iCity:Plot():GetPlotIndex();
		local iPlayer = iCity:GetOwner();
		for gpID, hhh in pairs(gT.Players[iPlayer].GreatPeople) do
			local gd = gT.GreatPeople[gpID];
			if gd.City == cindex then
				if gd.MigrateMeter then
					gT.GreatPeople[gpID].MigrateMeter = 0;
				end
			end
		end
	end
end

LuaEvents.ITGSG_RequestGPAbilities.Add(function(gpID)
	if gT.GreatPeople[gpID].Type == 1 then
		MapModData.ITGSG = GetGGHelpText(gpID)
	elseif gT.GreatPeople[gpID].Type == 2 then
		MapModData.ITGSG = GetGAHelpText(gpID)
	else
		MapModData.ITGSG = {Help = GetCivilianGPAbilityHelp(gpID)};
	end
end)

function GetAcademyPrestigeForGPInCity(iCity)
	local bonus = 0;
	if GetITGCityInteger(iCity, "CI_NUM_GP") > 0 then
		local cindex = iCity:Plot():GetPlotIndex();
		local iPlayer = iCity:GetOwner();
		for gpID, hhh in pairs(gT.Players[iPlayer].GreatPeople) do
			local gd = gT.GreatPeople[gpID];
			if gd.City == cindex then
				if gd.Alive and (not gd.Military) then
					bonus = bonus + lSgreatpeopleData[gd.Type].PrestigePerTurn;
				end
			end
		end
	end
	return bonus;
end

function GetCivilianGPAbilityHelp(gpID)
	local ability = gT.GreatPeople[gpID].Ability;
	if ability and GreatCivilianPeopleBonusesTable[ability].Help then
		return GreatCivilianPeopleBonusesTable[ability].Help;
	else
		return "";
	end
end

function GenerateGreatGeneralForPlayer(iPlayer, fturn, bPromote)
	if (not bPromote) and ((not fturn) or fturn >= 0) then
		TakeCareOfEventMorale(iPlayer, 18)
	end
	local name, que = GetGreatNameOfType("UNIT_GREAT_GENERAL")
	gT.Globals.GreatPersonNamesUsed[name] = (gT.Globals.GreatPersonNamesUsed[name] or 0) + 1;
	local gpID = #gT.GreatPeople + 1;
	local ability = LinkGreatGeneralBonus()
	local sability = LinkGreatGeneralBonus({ability})
	table.insert(gT.GreatPeople, {OriginPlayer = iPlayer, Ascendancy = (fturn or GetITGGameTurn()), RivalSpiesActive = {}, Type = 1, Name = name, SecAbility = sability, Ability = ability, Que = que, Player = iPlayer, Alive = true})
	ReadBasicGPInfo(gpID)
	table.insert(gT.Players[iPlayer].ReservedGenerals, { GPID = gpID})
	gT.Players[iPlayer].GreatPeople[gpID] = 1;
	PlayerGeneratedGreatPerson(iPlayer, true)
	DoInnovationOnGreatGeneralAcquired(iPlayer);
	DoLogDominationEvent(4, iPlayer, nil, 15, nil, false, gpID)
end

function GenerateGreatAdmiralForPlayer(iPlayer, fturn, bPromote)
	if (not bPromote) and ((not fturn) or fturn >= 0) then
		TakeCareOfEventMorale(iPlayer, 18)
	end
	local name, que = GetGreatNameOfType("UNIT_GREAT_ADMIRAL")
	gT.Globals.GreatPersonNamesUsed[name] = 1;
	local gpID = #gT.GreatPeople + 1;
	local ability = LinkGreatAdmiralBonus()
	local sability = LinkGreatAdmiralBonus({ability})
	table.insert(gT.GreatPeople, {OriginPlayer = iPlayer, Ascendancy = (fturn or GetITGGameTurn()), RivalSpiesActive = {}, Type = 2, Name = name, SecAbility = sability, Ability = ability, Que = que, Player = iPlayer, Alive = true})
	ReadBasicGPInfo(gpID)
	table.insert(gT.Players[iPlayer].ReservedAdmirals, {GPID = gpID})
	gT.Players[iPlayer].GreatPeople[gpID] = 1;
	PlayerGeneratedGreatPerson(iPlayer, true)
	DoLogDominationEvent(3, iPlayer, nil, 15, nil, false, gpID)
end

function GetRandomAbilityForGreatPerson(tab, xTab)
	local bTab = {}
	for i, data in pairs(tab) do
		if not xTab[i] then
			if (not data.ScenarioOff) or (not data.ScenarioOff[gT.Globals.ScenarioType]) then
				table.insert(bTab, {i, data.Chance})
			end
		end
	end
	return GetRandomFromBiasedChanceTable(bTab);
end

function KillGreatPerson(gpID, bUnitKilled)
	gT.GreatPeople[gpID].Alive = false;
	local iPlayer = gT.GreatPeople[gpID].Player;
	DoRecheckSpiesActive(nil, nil, nil, nil, gpID)
	gT.GreatPeople[gpID].TurnDied = GetITGGameTurn()
	if gT.GreatPeople[gpID].Military then
		GovernorsGPRemovedFromPlayer(iPlayer, gpID)
		if not bUnitKilled then
			TakeCareOfEventMorale(iPlayer, 5, {true})
			for uID, data in pairs(gT.Players[iPlayer].UnitsByID) do
				if data.GreatPersonID == gpID then
					if gT.GreatPeople[gpID].Type == 1 then
						RemoveGreatGeneralFromUnit(uID, iPlayer, gpID)
					elseif gT.GreatPeople[gpID].Type == 2 then
						RemoveGreatAdmiralFromUnit(uID, iPlayer, gpID)
					end
				end
			end
			DoRemoveGreatPersonMilitaryFromQueue(iPlayer, gpID) 
		else
			TakeCareOfEventMorale(iPlayer, 5, {false})
		end
		if gT.GreatPeople[gpID].Type == 1 then
			gT.Players[iPlayer].FallenGenerals = gT.Players[iPlayer].FallenGenerals + 1;
		elseif gT.GreatPeople[gpID].Type == 2 then
			gT.Players[iPlayer].FallenAdmirals = gT.Players[iPlayer].FallenAdmirals + 1;
		end
	else
		RemoveCivilianGPFromThePlayer(gpID, iPlayer, "Killed")
		if gT.GreatPeople[gpID].City then
			RemoveGPCivilFromTheCity(gpID, Map.GetPlotByIndex(gT.GreatPeople[gpID].City):GetPlotCity(), iPlayer)
		end
	end
end

local GetRomanNumberString = {"I", "II", "III", "IV", "V", "VI", "VII", "VIII", "IX", "X", "XI", "XII"}
function GetGreatPersonName(gP, bExcludeIcon)
	local name = ""
	if not bExcludeIcon then
		name = (lSgreatpeopleData[gT.GreatPeople[gP].Type].FontIcon or "[ICON_GREAT_PEOPLE]") .. " " .. Locale.Lookup(gT.GreatPeople[gP].Name);
	else
		name = Locale.Lookup(gT.GreatPeople[gP].Name);
	end
	if gT.GreatPeople[gP].Que then
		name = name .. " " .. GetRomanNumberString[gT.GreatPeople[gP].Que];
	end
	return name;
end



function GetGPName(gP)
	local name = Locale.Lookup(gT.GreatPeople[gP].Name);	
	if gT.GreatPeople[gP].Que then
		name = name .. " " .. GetRomanNumberString[gT.GreatPeople[gP].Que];
	end
	return name;
end

function RequestedGreatPersonName(gP)
	MapModData.ITGSG = GetGreatPersonName(gP);
end
LuaEvents.ITGSG_RequestGreatPersonName.Add(RequestedGreatPersonName)

function GenerateInitialCivilianGP()
	for g, gdata in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			local amountGP = LastRandom(GetDBCulturePlayerInfo(g, "MinStartingGP"), GetDBCulturePlayerInfo(g, "MaxStartingGP"))
			for i = 1, amountGP do
				GenerateNewCivilianGP(g, false, -LastRandom(4, 64))
			end
		end
	end
end

function GetForcedTypeOfNewlyAscendedGP(iPlayer)
	if gT.Players[iPlayer].HasIdeology[60] then
		if not IsCurrentArtStyleRepresented(iPlayer) then
			return LastRandom(6,8);
		end
	end
	return nil;
end

local TableOfGreatStringCivilGP = {"Great General", "Great Admiral", "Great Scientist", "Great Engineer", "Great Statesman", "Great Musician", "Great Writer", "Great Artist", "Great Philosopher", "Great Seer"}
function GenerateNewCivilianGP(iPlayer, bPoints, fturn, forcedData)
	local tfDF = forcedData or {}
	local gpType = tfDF.Type or GetForcedTypeOfNewlyAscendedGP(iPlayer) or GetRandomGPTypeNow(iPlayer, bPoints);
	if gpType == 10 then
		GenerateGreatSeer(iPlayer)
		return;
	elseif gpType == 1 then
		GenerateGreatGeneralForPlayer(iPlayer)
		return;
	elseif gpType == 2 then
		GenerateGreatAdmiralForPlayer(iPlayer)
		return;
	end
	--possibleplayers origin
	local pChance = 1000;
	local pTab = {}
	for g, value in pairs(gT.Players[iPlayer].GreatPeopleFavourTowards) do
		table.insert(pTab, {g, value})
		pChance = pChance - value;
	end
	table.insert(pTab, {iPlayer, math.max(1, pChance)})
	local oPlayer = tfDF.Player or GetRandomFromBiasedChanceTable(pTab);
	local oCity = tfDF.City or GetGPCivilBirth(oPlayer)
	if gpType == 3 then
		GenerateGreatScientistForPlayer(iPlayer, oPlayer, oCity, fturn)
	elseif gpType == 4 then
		GenerateGreatEngineerForPlayer(iPlayer, oPlayer, oCity, fturn)
	elseif gpType == 5 then
		GenerateGreatStatesmanForPlayer(iPlayer, oPlayer, oCity, fturn)
	elseif gpType == 6 then
		GenerateGreatMusicianForPlayer(iPlayer, oPlayer, oCity, fturn)
	elseif gpType == 7 then
		GenerateGreatWriterForPlayer(iPlayer, oPlayer, oCity, fturn)
	elseif gpType == 8 then
		GenerateGreatArtistForPlayer(iPlayer, oPlayer, oCity, fturn)
	elseif gpType == 9 then
		GenerateGreatPhilosopherForPlayer(iPlayer, oPlayer, oCity, fturn)
	else
		print("Error k1230")
	end
	local gpID = #gT.GreatPeople;
	if tfDF.ForcedBonusClass then
		gT.GreatPeople[gpID].ForcedBonusClass = tfDF.ForcedBonusClass
	end
	if tfDF.ForcedCity then
		gT.GreatPeople[gpID].ForcedCity = tfDF.ForcedCity
	end
	if tfDF.OriginPlayer then
		gT.GreatPeople[gpID].OriginPlayer = tfDF.OriginPlayer
	end
	if gpType == 6 or gpType == 7 or gpType == 8 then -- define style based on origin player
		gT.GreatPeople[gpID].CultEra = gT.Players[gT.GreatPeople[gpID].OriginPlayer].CultureEra or gT.Players[iPlayer].CultureEra or 1;
		gT.GreatPeople[gpID].CultEraType = gT.Players[gT.GreatPeople[gpID].OriginPlayer].CultureType;
	end
	if tfDF.OriginCity then
		gT.GreatPeople[gpID].OriginCity = tfDF.OriginCity
	end
	if tfDF.DoNotMigrateBefore then
		if tfDF.DoNotMigrateBefore > 100 then
			gT.GreatPeople[gpID].DoNotMigrate = true;
		else
			gT.GreatPeople[gpID].DoNotMigrateBefore = tfDF.DoNotMigrateBefore;
		end
	end
	AssingYieldBonusesToCivilianGP(gpID, iPlayer)
	gT.GreatPeople[gpID].TravelPlayerLog = {}
	if bPoints then
		gT.Players[iPlayer].GPQueue[gpID] = 1;
		if gT.Players[iPlayer].HasPlayerWonder[iWonderSh] then
			CreateGreatWorkOfAmount(iPlayer, 1)
		end
	else
		FinishAddingNewGPToThePlayer(iPlayer, gpID, true)
	end
	if gT.Globals.GameGenerated then
		gT.Players[iPlayer].LastTurnGPAscended = GetITGGameTurn();
		DoAcademiesGreatPersonBorn(oCity, gpType)
	end
	PlayerGeneratedGreatPerson(iPlayer)
end

function GenerateThreeTroubadours(iPlayer)
	GenerateGreatMusicianForPlayer(iPlayer, iPlayer, GetGPCivilBirth(iPlayer), GetITGGameTurn())
	local gpID = #gT.GreatPeople;
	AssingYieldBonusesToCivilianGP(gpID, iPlayer)
	FinishAddingNewGPToThePlayer(iPlayer, gpID, true, 41)
	PlayerGeneratedGreatPerson(iPlayer)
	GenerateGreatArtistForPlayer(iPlayer, iPlayer, GetGPCivilBirth(iPlayer), GetITGGameTurn())
	gpID = #gT.GreatPeople;
	AssingYieldBonusesToCivilianGP(gpID, iPlayer)
	FinishAddingNewGPToThePlayer(iPlayer, gpID, true, 78)
	PlayerGeneratedGreatPerson(iPlayer)
	GenerateGreatWriterForPlayer(iPlayer, iPlayer, GetGPCivilBirth(iPlayer), GetITGGameTurn())
	gpID = #gT.GreatPeople;
	AssingYieldBonusesToCivilianGP(gpID, iPlayer)
	FinishAddingNewGPToThePlayer(iPlayer, gpID, true, 79)
	PlayerGeneratedGreatPerson(iPlayer)
end
function GenerateGreatSeer(iPlayer)
	GenerateGreatSeerForPlayer(iPlayer, iPlayer, GetGPCivilBirth(iPlayer), GetITGGameTurn())
	local gpID = #gT.GreatPeople;
	AssingYieldBonusesToCivilianGP(gpID, iPlayer)
	FinishAddingNewGPToThePlayer(iPlayer, gpID, true)
	PlayerGeneratedGreatPerson(iPlayer)
end

function GetNumGPTalentsOption(iPlayer)
	local base = gT.Players[iPlayer].GPNumTalentsOption;
	if gT.Players[iPlayer].HasIdeology[89] then
		base = base + GetNumActiveGovernors(iPlayer);
	end
	return base
end

local HelpTalentGPString = {1, 2, "Scientist", "Engineer", "Statesman", "Musician", "Writer", "Artist", "Philosopher", "Prophet"}
function FinishAddingNewGPToThePlayer(iPlayer, gpID, bForceOne, abilityID)
	local numOptions = GetNumGPTalentsOption(iPlayer)
	if abilityID or bForceOne or (numOptions == 1) then
		local ability = abilityID or GetCivGPAbility(HelpTalentGPString[gT.GreatPeople[gpID].ForcedBonusClass or gT.GreatPeople[gpID].Type], nil, iPlayer)
		AddGPToThePlayerWithTalent(iPlayer, gpID, ability)
	else
		local bTab = {};
		for i = 1, numOptions do
			local nabID = GetCivGPAbility(HelpTalentGPString[gT.GreatPeople[gpID].ForcedBonusClass or gT.GreatPeople[gpID].Type], bTab, iPlayer)
			if nabID then
				bTab[nabID] = 1;
			end
		end
		if Players[iPlayer]:IsHuman() then
			if gT.Players[iPlayer].HumanQueueActions["CHOOSE TALENT"] then
				gT.Players[iPlayer].GPHumanActionReserver[gpID] = GenerateTextForHumanTalentChoose(gpID, iPlayer, bTab);
			else
				gT.Players[iPlayer].CurrentGPQueue = gpID;
				gT.Players[iPlayer].HumanQueueActions["CHOOSE TALENT"] = GenerateTextForHumanTalentChoose(gpID, iPlayer, bTab)
			end
		else
			AddGPToThePlayerWithTalent(iPlayer, gpID, ChooseBestTalentForAI(bTab))
		end
	end
end

function HumanPlayerChooseGPTalent(iPlayer, abID)
	AddGPToThePlayerWithTalent(iPlayer, gT.Players[iPlayer].CurrentGPQueue , abID)
	gT.Players[iPlayer].HumanQueueActions["CHOOSE TALENT"] = nil;
	for gpID, sth in pairs(gT.Players[iPlayer].GPHumanActionReserver) do
		gT.Players[iPlayer].HumanQueueActions["CHOOSE TALENT"] = sth;
		gT.Players[iPlayer].CurrentGPQueue = gpID;
		gT.Players[iPlayer].GPHumanActionReserver[gpID] = nil;
		return;
	end
end

function GenerateTextForHumanTalentChoose(gpID, iPlayer, bTab)
	local data = {BonusType = "ChooseTalentGP", TitleText = "Choose talent of Great Person.", TitleIconIndex = 22, TitleIconAtlas = "LEADER_ATLAS", Tooltip = "You are able to choose the talent of Great Person."}
	local hTab = {}
	for abID, sth in pairs(bTab) do
		table.insert(hTab, {Name = "",
							ID = abID,
							Help = GreatCivilianPeopleBonusesTable[abID].Help})
	end
	data.UniqueOptions = hTab;
	return data;
end

function AddGPToThePlayerWithTalent(iPlayer, gpID, ability)
	gT.GreatPeople[gpID].Ability = ability;
	if GreatCivilianPeopleBonusesTable[ability].Troubadour then
		gT.GreatPeople[gpID].FlavourTravel = 12
		gT.GreatPeople[gpID].DoNotTravelAway = true;
	end
	if Game.GetActivePlayer() == iPlayer then
		local strTitle = TableOfGreatStringCivilGP[gT.GreatPeople[gpID].Type];
		local string = "The new person ascended among others in our empire: " .. (lSgreatpeopleData[gT.GreatPeople[gpID].Type].FontIcon or "[ICON_GREAT_PEOPLE]") .. " " .. TableOfGreatStringCivilGP[gT.GreatPeople[gpID].Type] .. "! (" .. GetCivilianGPAbilityHelp(gpID) .. ")";
		Players[iPlayer]:AddNotification(5521344, string, strTitle, -1, -1, gT.GreatPeople[gpID].Type, iPlayer)
	end
	AssignNewCivilianGPToThePlayer(gpID, iPlayer)
end

function GenerateGreatScientistForPlayer(iPlayer, oPlayer, oCity, fturn)
	local name, que = GetGreatNameOfType("UNIT_SCIENTIST")
	gT.Globals.GreatPersonNamesUsed[name] = (gT.Globals.GreatPersonNamesUsed[name] or 0) + 1;
	local gpID = #gT.GreatPeople + 1;
	local sTab = {DoNotMigrateBefore = -1, OriginPlayer = oPlayer, OriginCity = oCity:Plot():GetPlotIndex(), Ascendancy = (fturn or GetITGGameTurn()), Type = 3, Name = name, Ability = ability, Que = que, Player = iPlayer, Alive = true}
	table.insert(gT.GreatPeople, sTab)
	ReadBasicGPInfo(gpID)
end

function GenerateGreatEngineerForPlayer(iPlayer, oPlayer, oCity, fturn)
	local name, que = GetGreatNameOfType("UNIT_ENGINEER")
	gT.Globals.GreatPersonNamesUsed[name] = (gT.Globals.GreatPersonNamesUsed[name] or 0) + 1;
	local gpID = #gT.GreatPeople + 1;
	local sTab = {DoNotMigrateBefore = -1, OriginPlayer = oPlayer, OriginCity = oCity:Plot():GetPlotIndex(), Ascendancy = (fturn or GetITGGameTurn()), Type = 4, Name = name, Ability = ability, Que = que, Player = iPlayer, Alive = true}
	table.insert(gT.GreatPeople, sTab)
	ReadBasicGPInfo(gpID)
end

function GenerateGreatStatesmanForPlayer(iPlayer, oPlayer, oCity, fturn)
	local name, que = GetGreatNameOfType("UNIT_MERCHANT")
	gT.Globals.GreatPersonNamesUsed[name] = (gT.Globals.GreatPersonNamesUsed[name] or 0) + 1;
	local gpID = #gT.GreatPeople + 1;
	local sTab = {DoNotMigrateBefore = -1, RivalSpiesActive = {}, OriginPlayer = oPlayer, OriginCity = oCity:Plot():GetPlotIndex(), Ascendancy = (fturn or GetITGGameTurn()), Type = 5, Name = name, Ability = ability, Que = que, Player = iPlayer, Alive = true}
	table.insert(gT.GreatPeople, sTab)
	ReadBasicGPInfo(gpID)
end

function GenerateGreatMusicianForPlayer(iPlayer, oPlayer, oCity, fturn)
	local name, que = GetGreatNameOfType("UNIT_MUSICIAN")
	gT.Globals.GreatPersonNamesUsed[name] = (gT.Globals.GreatPersonNamesUsed[name] or 0) + 1;
	local gpID = #gT.GreatPeople + 1;
	local sTab = {DoNotMigrateBefore = -1, OriginPlayer = oPlayer, OriginCity = oCity:Plot():GetPlotIndex(), Ascendancy = (fturn or GetITGGameTurn()), Type = 6, Name = name, Que = que, Player = iPlayer, Alive = true}
	table.insert(gT.GreatPeople, sTab)
	ReadBasicGPInfo(gpID)
end

function GenerateGreatWriterForPlayer(iPlayer, oPlayer, oCity, fturn)
	local name, que = GetGreatNameOfType("UNIT_WRITER")
	gT.Globals.GreatPersonNamesUsed[name] = (gT.Globals.GreatPersonNamesUsed[name] or 0) + 1;
	local gpID = #gT.GreatPeople + 1;
	local sTab = {DoNotMigrateBefore = -1, OriginPlayer = oPlayer, OriginCity = oCity:Plot():GetPlotIndex(), Ascendancy = (fturn or GetITGGameTurn()), Type = 7, Name = name, Ability = ability, Que = que, Player = iPlayer, Alive = true}
	table.insert(gT.GreatPeople, sTab)
	ReadBasicGPInfo(gpID)
end

function GenerateGreatArtistForPlayer(iPlayer, oPlayer, oCity, fturn)
	local name, que = GetGreatNameOfType("UNIT_ARTIST")
	gT.Globals.GreatPersonNamesUsed[name] = (gT.Globals.GreatPersonNamesUsed[name] or 0) + 1;
	local gpID = #gT.GreatPeople + 1;
	local sTab = {DoNotMigrateBefore = -1, OriginPlayer = oPlayer, OriginCity = oCity:Plot():GetPlotIndex(), Ascendancy = (fturn or GetITGGameTurn()), Type = 8, Name = name, Ability = ability, Que = que, Player = iPlayer, Alive = true}
	table.insert(gT.GreatPeople, sTab)
	ReadBasicGPInfo(gpID)
end

function GenerateGreatPhilosopherForPlayer(iPlayer, oPlayer, oCity, fturn)
	local name, que = GetGreatNameOfType("Philosopher")
	gT.Globals.GreatPersonNamesUsed[name] = (gT.Globals.GreatPersonNamesUsed[name] or 0) + 1;
	local gpID = #gT.GreatPeople + 1;
	local sTab = {DoNotMigrateBefore = -1, OriginPlayer = oPlayer, OriginCity = oCity:Plot():GetPlotIndex(), Ascendancy = (fturn or GetITGGameTurn()), Type = 9, Name = name, Ability = ability, Que = que, Player = iPlayer, Alive = true}
	table.insert(gT.GreatPeople, sTab)
	ReadBasicGPInfo(gpID)
end

function GenerateGreatSeerForPlayer(iPlayer, oPlayer, oCity, fturn)
	local name, que = GetGreatNameOfType("Prophet")
	gT.Globals.GreatPersonNamesUsed[name] = (gT.Globals.GreatPersonNamesUsed[name] or 0) + 1;
	local gpID = #gT.GreatPeople + 1;
	local sTab = {TravelPlayerLog = {}, DoNotMigrateBefore = -1, OriginPlayer = oPlayer, OriginCity = oCity:Plot():GetPlotIndex(), Ascendancy = (fturn or GetITGGameTurn()), Type = 10, Name = name, Que = que, Player = iPlayer, Alive = true}
	table.insert(gT.GreatPeople, sTab)
	ReadBasicGPInfo(gpID)
end

function AssignNewCivilianGPToThePlayer(gpID, iPlayer, bDoNotAddToCity)
	gT.Players[iPlayer].GreatPeople[gpID] = 1;

	gT.GreatPeople[gpID].Player = iPlayer;
	DoRecheckSpiesActive(iPlayer, nil, nil, nil, gpID) -- on city capture statesman?
	local iCity;
	local gd = gT.GreatPeople[gpID];
	if gd.Ability == 4 then
		CreateAgentNew(iPlayer, false, false, gpID)
	elseif gd.Ability == 11 then
		gT.Players[iPlayer].CultIndFromGP = gT.Players[iPlayer].CultIndFromGP + 7;
	elseif gd.Ability == 13 then
		Players[iPlayer]:ChangeBaseFreeUnits(3)
	elseif gd.Ability == 14 then
		gT.Players[iPlayer].HapChanceFromGP = gT.Players[iPlayer].HapChanceFromGP + 20;
	elseif gd.Ability == 16 then
		for g, gdata in pairs(gT.Players) do
			if Players[g]:IsMinorCiv() then
				if gT.Players[iPlayer].CultureType == gdata.CultureType then
					Players[g]:ChangeMinorCivExtraAnchorWithMajor(iPlayer, 10)
				end
			end
		end
	elseif gd.Ability == 19 then
		Teams[Players[iPlayer]:GetTeam()]:ChangeRouteChange(GameInfo.Routes.ROUTE_ROAD.ID, -1);
	elseif gd.Ability == 22 then
		gT.Players[iPlayer].NumTechToChooseFrom = gT.Players[iPlayer].NumTechToChooseFrom + 1;
	elseif gd.Ability == 23 then
		if not gd.LifeDone then
			gT.Players[iPlayer].NumPointsChangeSocialBonus = gT.Players[iPlayer].NumPointsChangeSocialBonus + 1;
		end
	elseif gd.Ability == 32 then
		gT.Players[iPlayer].MoraleFromGP = gT.Players[iPlayer].MoraleFromGP + 3;
	elseif gd.Ability == 34 then
		Players[iPlayer]:ChangePlayerBuildingClassYieldChange(GameInfoTypes.BUILDINGCLASS_LIBRARY, yScience, 1);
	elseif gd.Ability == 36 then
		for g, gdata in pairs(gT.Players) do
			if Players[g]:IsMinorCiv() then
				Players[g]:ChangeMinorCivExtraAnchorWithMajor(iPlayer, 7)
			end
		end
	elseif gd.Ability == 37 then
		for g, gdata in pairs(gT.Players) do
			if Players[g]:IsMinorCiv() then
				if Players[g]:GetMinorCivTrait() == GameInfoTypes.MINOR_TRAIT_MERCANTILE then
					Players[g]:ChangeMinorCivExtraAnchorWithMajor(iPlayer, 10)
				end
			end
		end
	elseif gd.Ability == 47 then
		gT.Players[iPlayer].NumPantheonsToChoose = gT.Players[iPlayer].NumPantheonsToChoose + 1;	
	elseif gd.Ability == 48 then
		gT.Players[iPlayer].GPNumTalentsOption = gT.Players[iPlayer].GPNumTalentsOption + 1;
	elseif gd.Ability == 49 then
		Players[iPlayer]:ChangeDamageLuck(300)
	elseif gd.Ability == 55 then
		Players[iPlayer]:ChangePlayerBuildingClassYieldChange(GameInfoTypes.BUILDINGCLASS_MARKET, yGold, 1);		
	elseif gd.Ability == 56 then
		gT.Players[iPlayer].RailroadDiscount = gT.Players[iPlayer].RailroadDiscount + 25;
	elseif gd.Ability == 60 then
		Players[iPlayer]:ChangeCityConnectionTradeRouteGoldModifier(15);
	elseif gd.Ability == 61 then
		Players[iPlayer]:ChangeImprovementYieldChange(GameInfoTypes.IMPROVEMENT_CUSTOMS_HOUSE, yGold, 2)
	elseif gd.Ability == 66 then
		gT.Players[iPlayer].FoodFromFish = gT.Players[iPlayer].FoodFromFish + 1;
	elseif gd.Ability == 67 then
		Players[iPlayer]:ChangeAirStrikeDodgeChance(5)
	elseif gd.Ability == 72 then
		gT.Players[iPlayer].InfluenceIRGP = gT.Players[iPlayer].InfluenceIRGP + 5; 
	elseif gd.Ability == 73 then
		gT.Players[iPlayer].VotesGP = gT.Players[iPlayer].VotesGP + 1; 
	elseif gd.Ability == 76 then
		ChangeITGExtraResources(iPlayer, rCoal, 1)
	elseif gd.Ability == 77 then
		gT.Players[iPlayer].GPMeritocracy = gT.Players[iPlayer].GPMeritocracy + 1; 
	elseif gd.Ability == 80 then
		gT.Players[iPlayer].GPCodexInfluence = gT.Players[iPlayer].GPCodexInfluence + 50;
	end
	if not bDoNotAddToCity then
		if gd.Ability ~= 15 then
			if Players[iPlayer]:GetNumCities() > 0 then	
				local iCity = ChooseMostNiceCityForGP(iPlayer, nil, gpID)
				AssignGPCivilToTheCity(gpID, iCity, iPlayer)
			end
		end
	end
	gT.Players[iPlayer].CapturedGP[gpID] = nil;
	gT.Players[iPlayer].EmigratedGP[gpID] = nil;
	GreatPeopleAmountDirty(iPlayer)
end

function GetGPCivilBirth(iPlayer)
	if Players[iPlayer]:GetNumCities() > 0 then
		local sTab = {}
		for iCity in Players[iPlayer]:Cities() do
			table.insert(sTab, iCity)
		end
		return sTab[LastRandom(1,#sTab)]
	else
		local tCity = GetOriginalCapitalOfPlayer(iPlayer)
		if tCity then
			return tCity;
		else
			print("Players has no original capital! (GP birth - CS ok?)", iPlayer)
			return AnyOriginalCityOfPlayer(iPlayer)
		end
	end
end
function AssignGPCivilToTheCity(gpID, iCity, iPlayer)
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local gd = gT.GreatPeople[gpID];
	if gd.Ability == 6 then
		iCity:ChangeYieldRateModifier(yFood, 15)
		ChangeITGCityInteger(iCity, "CI_GP_FOOD_MOD", 15)
	elseif gd.Ability == 12 then
		iCity:ChangePlotCultureCostModifier(-50)
		gT.Cities[cID].GPplotCultcost = (gT.Cities[cID].GPplotCultcost or 0) - 50; 
	elseif gd.Ability == 10 then
		gT.Cities[cID].CanDoTradeProcess = gT.Cities[cID].CanDoTradeProcess + 1
	elseif gd.Ability == 20 then
		iCity:ChangeYieldRateModifier(yGold, 15)
		ChangeITGCityInteger(iCity, "CI_GP_GOLD", 15);
	elseif gd.Ability == 24 then
		ChangeITGCityInteger(iCity, "CI_GP_WORK_MOD", 50)
	elseif gd.Ability == 25 then
		gT.Cities[cID].GPTradeRoutesModifier = gT.Cities[cID].GPTradeRoutesModifier + 0.5;
	elseif gd.Ability == 26 then
		ChangeITGCityInteger(iCity, "CI_CHARM_FROM_GP", 25)
	elseif gd.Ability == 31 then
		gT.Cities[cID].GPBonusAttack = (gT.Cities[cID].GPBonusAttack or 0 ) + 1;
	elseif gd.Ability == 33 then
		ChangeITGCityInteger(iCity, "CI_NO_RES_RIOTS", 1)
	elseif gd.Ability == 41 then
		ChangeITGHappinessInTheCity(iCity, 1, nil, "gp41")
	elseif gd.Ability == 42 then
		gT.Cities[cID].HealthFromGP = gT.Cities[cID].HealthFromGP + 4;
		gT.Cities[cID].PlagueDefense = gT.Cities[cID].PlagueDefense + 5;
	elseif gd.Ability == 43 then
		gT.Cities[cID].AcademyPassiveGen = gT.Cities[cID].AcademyPassiveGen + 5;
	elseif gd.Ability == 44 then
		gT.Cities[cID].AcademyPrestigeGen = gT.Cities[cID].AcademyPrestigeGen + 10;
	elseif gd.Ability == 50 then
		ChangeITGCityInteger(iCity, "CI_PRESENCE_FROM_GP", 6)
	elseif gd.Ability == 53 then
		ChangeITGCityInteger(iCity, "CI_GP_LESS_MIGRATE", 1)
	elseif gd.Ability == 54 then
		ChangeITGCityInteger(iCity, "CI_GP_DEFENSE", 500)
		AdjustStrengthOfOneCity(iCity, 500, true)
	elseif gd.Ability == 56 then
		ChangeITGCityInteger(iCity, "CI_GP_ROAD_COST", -100)
	elseif gd.Ability == 61 then
		gT.Cities[cID].CHUpgradePassive = gT.Cities[cID].CHUpgradePassive + 4;
	elseif gd.Ability == 68 then
		ChangeITGCityInteger(iCity, "CI_GP_BOMB_IMMUNE", 1)
	elseif gd.Ability == 69 then
		ChangeITGCityInteger(iCity, "CI_GP_STRIKE_MOD", 1)
		iCity:ChangeAttackMod(100);
	elseif gd.Ability == 71 then
		gT.Cities[cID].TRAttrFromGP = gT.Cities[cID].TRAttrFromGP + 15;
	elseif gd.Ability == 74 then
		gT.Cities[cID].PilgrimGP = gT.Cities[cID].PilgrimGP + 5;
	elseif gd.Ability == 78 then
		DoChangeCityCultureOwnership(cID, iCity, iPlayer, 50, "gp78")
	elseif gd.Ability == 79 then
		CreateGreatWorkOfAmount(iPlayer, 1, "Literature")
	end
	ChangeITGCityInteger(iCity, "CI_NUM_GP", 1)
	gT.GreatPeople[gpID].City = iCity:Plot():GetPlotIndex()
	if gT.GreatPeople[gpID].Production then
		DirtyProductionFromGPInACity(iCity, iPlayer)
	end
	if gT.GreatPeople[gpID].HapChance then
		gT.Cities[cID].HapChanceFromGP = gT.Cities[cID].HapChanceFromGP + gT.GreatPeople[gpID].HapChance * 10;
	end
end

function AllCitiesDirtyProductionFromGP(iPlayer)
	for iCity in Players[iPlayer]:Cities() do
		DirtyProductionFromGPInACity(iCity, iPlayer)
	end
end

function DirtyProductionFromGPInACity(iCity, iPlayer)
	local cIndex = iCity:Plot():GetPlotIndex();
	local totProd = 0;
	for i, r in pairs(gT.GreatPeople) do
		if r.City == cIndex then
			if r.Alive then
				if r.Production then
					totProd = totProd + gT.Players[iPlayer].YieldModGreatPeople[r.Type] * r.Production
				end
			end
		end
	end
	SetRawCityYield(iCity, yProduction, totProd, "CI_GP_PROD")
end

function RemoveGPCivilFromTheCity(gpID, iCity, iPlayer, bTempCityCapture)
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local gd = gT.GreatPeople[gpID];
	if gd.Ability == 10 then
		gT.Cities[cID].CanDoTradeProcess = gT.Cities[cID].CanDoTradeProcess -1
	elseif gd.Ability == 12 then
		iCity:ChangePlotCultureCostModifier(50)
		gT.Cities[cID].GPplotCultcost = (gT.Cities[cID].GPplotCultcost or 0) + 50; 
	elseif gd.Ability == 20 then
		iCity:ChangeYieldRateModifier(yGold, -15)
		ChangeITGCityInteger(iCity, "CI_GP_GOLD", -15);
	elseif gd.Ability == 24 then
		ChangeITGCityInteger(iCity, "CI_GP_WORK_MOD", -50)
	elseif gd.Ability == 25 then
		gT.Cities[cID].GPTradeRoutesModifier = gT.Cities[cID].GPTradeRoutesModifier - 0.5;
	elseif gd.Ability == 26 then
		ChangeITGCityInteger(iCity, "CI_CHARM_FROM_GP", -25)
	elseif gd.Ability == 31 then
		gT.Cities[cID].GPBonusAttack = gT.Cities[cID].GPBonusAttack -1;
	elseif gd.Ability == 33 then
		ChangeITGCityInteger(iCity, "CI_NO_RES_RIOTS", -1)
	elseif gd.Ability == 42 then
		gT.Cities[cID].HealthFromGP = gT.Cities[cID].HealthFromGP - 4;
		gT.Cities[cID].PlagueDefense = gT.Cities[cID].PlagueDefense - 5;
	elseif gd.Ability == 43 then
		gT.Cities[cID].AcademyPassiveGen = gT.Cities[cID].AcademyPassiveGen - 5;
	elseif gd.Ability == 44 then
		gT.Cities[cID].AcademyPrestigeGen = gT.Cities[cID].AcademyPrestigeGen - 10;
	elseif gd.Ability == 53 then
		ChangeITGCityInteger(iCity, "CI_GP_LESS_MIGRATE", -1)
	elseif gd.Ability == 54 then
		ChangeITGCityInteger(iCity, "CI_GP_DEFENSE", -500)
		AdjustStrengthOfOneCity(iCity, -500, true)
	elseif gd.Ability == 50 then
		ChangeITGCityInteger(iCity, "CI_PRESENCE_FROM_GP", -6)
	elseif gd.Ability == 56 then
		ChangeITGCityInteger(iCity, "CI_GP_ROAD_COST", 100)
	elseif gd.Ability == 61 then
		gT.Cities[cID].CHUpgradePassive = gT.Cities[cID].CHUpgradePassive - 4;
	elseif gd.Ability == 68 then
		ChangeITGCityInteger(iCity, "CI_GP_BOMB_IMMUNE", -1)
	elseif gd.Ability == 69 then
		ChangeITGCityInteger(iCity, "CI_GP_STRIKE_MOD", -1)
		iCity:ChangeAttackMod(-100);
	elseif gd.Ability == 74 then
		gT.Cities[cID].PilgrimGP = gT.Cities[cID].PilgrimGP - 5
	elseif gd.Ability == 71 then
		gT.Cities[cID].TRAttrFromGP = gT.Cities[cID].TRAttrFromGP - 15;
	elseif gd.Ability == 6 then
		iCity:ChangeYieldRateModifier(yFood, -15)
		ChangeITGCityInteger(iCity, "CI_GP_FOOD_MOD", -15)
	end
	--REMEMBER THAT SOME ABILITIES LIKE 6 (food modifier) have to be reinstalled upon city-capture
	ChangeITGCityInteger(iCity, "CI_NUM_GP", -1)
	gT.GreatPeople[gpID].City = nil;
	if gT.GreatPeople[gpID].Production then
		DirtyProductionFromGPInACity(iCity, iPlayer)
	end
	if gT.GreatPeople[gpID].HapChance then
		gT.Cities[cID].HapChanceFromGP = gT.Cities[cID].HapChanceFromGP - gT.GreatPeople[gpID].HapChance * 10;
	end
end

local IsValidCultBonus183 = {[6] = 1, [7] = 1, [8] = 1}
local arab6tech = GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_ARAB_6
function DoMigrationOfGPCivilian(gpID, iPlayer, nCity, bCapture)
	local nPlayer = nCity:GetOwner();
	local oldIndex = gT.GreatPeople[gpID].City;
	local oldCity; -- can be nil;
	if oldIndex then
		local oldCity = Map.GetPlotByIndex(oldIndex):GetPlotCity()
		RemoveGPCivilFromTheCity(gpID, oldCity, iPlayer)
	end
	if nPlayer ~= iPlayer then
		RemoveCivilianGPFromThePlayer(gpID, iPlayer, "Migration")
		-- selim
		if HasPlayerTech(iPlayer, arab6tech, "tqweqwe") then
			if LastRandom(1, 100) < 34 then
				KillGreatPerson(gpID, true)
				if Game.GetActivePlayer() == iPlayer then
					Players[iPlayer]:AddNotification(54126774, "It seems that " .. GetGreatPersonName(gpID) .. " got bored with this world and decided to visit ancestors.", "Viziers of Selim's")
				end
				return;
			end
		end
		-- end
		--bonuses on emigration
		if gT.Players[iPlayer].HasIdeology[89] then
			if gT.GreatPeople[gpID].OriginPlayer == iPlayer then
				DoChangeCityCultureOwnership(nCity:Plot():GetPlotIndex() .. "," .. nCity:GetGameTurnFounded(), nCity, iPlayer, 200, "Ideo80")
			end
		end
		--
		if Game.GetActivePlayer() == iPlayer then
			local strTitle = "Emigration";
			local string = "It seems that " .. GetGreatPersonName(gpID) .. " got bored with our empire and emigrated to the city of " .. nCity:GetName() .. ".";
			if bCapture then
				string = GetGreatPersonName(gpID) .. " left our empire cursed by war to find a new life in the city of " .. nCity:GetName() .. ".";
				strTitle = "Escape"
			end
			Players[iPlayer]:AddNotification(13551235, string, strTitle, -1, -1, gT.GreatPeople[gpID].Type, 9)
		end
		AssignNewCivilianGPToThePlayer(gpID, nPlayer, true)
		if Game.GetActivePlayer() == nPlayer then
			local strTitle = "Migration";
			local string = "It seems that " .. GetGreatPersonName(gpID) .. " got bored with its home and migrated to our city of " .. nCity:GetName() .. " (" .. GetCivilianGPAbilityHelp(gpID) .. ").";
			if bCapture then
				string = GetGreatPersonName(gpID) .. " left his previous home that was cursed by war to find a new place to live in our city of " .. nCity:GetName() .. " (" .. GetCivilianGPAbilityHelp(gpID) .. ").";
				strTitle = "Refugee"
			end
			Players[nPlayer]:AddNotification(13551235, string, strTitle, -1, -1, gT.GreatPeople[gpID].Type, 10)
		end
		if gT.Players[nPlayer].CultBonusOn[183] then
			if IsValidCultBonus183[gT.GreatPeople[gpID].Type] then
				DoTriggerNewFestivalIfPossible(nPlayer, nCity)
			end
		end
		gT.Players[iPlayer].GPMigratedAway = gT.Players[iPlayer].GPMigratedAway + 1 ;
		gT.Players[nPlayer].GPMigratedTo = gT.Players[nPlayer].GPMigratedTo + 1;
	end
	AssignGPCivilToTheCity(gpID, nCity, nPlayer)
	LogTravelForGP(gpID, iPlayer, oldIndex)
	gT.GreatPeople[gpID].DoNotMigrateBefore = math.max(gT.GreatPeople[gpID].DoNotMigrateBefore, GetITGGameTurn() + 4);
	gT.GreatPeople[gpID].NumTravels = (gT.GreatPeople[gpID].NumTravels or 0) + 1;
end

function LogTravelForGP(gpID, iPlayer, oldIndex)
	local nPlayer = gT.GreatPeople[gpID].Player;
	if not gT.GreatPeople[gpID].TravelPlayerLog then
		gT.GreatPeople[gpID].TravelPlayerLog = {};
	end
	table.insert(gT.GreatPeople[gpID].TravelPlayerLog, {iPlayer, nPlayer, oldIndex, gT.GreatPeople[gpID].City})
	if nPlayer and (nPlayer ~= -1) then
		if Players[nPlayer]:IsHuman() then
			if nPlayer ~= iPlayer then
				for a, b in pairs(gT.GreatPeople[gpID].TravelPlayerLog) do
					if b[1] == nPlayer then
						LuaEvents.ITG_AchievementCompleted(22)
						break;
					end
				end
			end
		end
	end
end	

function RemoveCivilianGPFromThePlayer(gpID, iPlayer, reason)
	GovernorsGPRemovedFromPlayer(iPlayer, gpID)
	local gd = gT.GreatPeople[gpID];
	if gd.Ability == 4 then
		RemoveAgentFromGP(iPlayer, gpID)
	elseif gd.Ability == 11 then
		gT.Players[iPlayer].CultIndFromGP = gT.Players[iPlayer].CultIndFromGP - 7;
	elseif gd.Ability == 13 then
		Players[iPlayer]:ChangeBaseFreeUnits(-3)
	elseif gd.Ability == 14 then
		gT.Players[iPlayer].HapChanceFromGP = gT.Players[iPlayer].HapChanceFromGP - 20;
	elseif gd.Ability == 16 then
		for g, gdata in pairs(gT.Players) do
			if Players[g]:IsMinorCiv() then
				if gT.Players[iPlayer].CultureType == gdata.CultureType then
					Players[g]:ChangeMinorCivExtraAnchorWithMajor(iPlayer, -10)
				end
			end
		end
	elseif gd.Ability == 19 then
		Teams[Players[iPlayer]:GetTeam()]:ChangeRouteChange(GameInfo.Routes.ROUTE_ROAD.ID, 1);
	elseif gd.Ability == 22 then
		gT.Players[iPlayer].NumTechToChooseFrom = gT.Players[iPlayer].NumTechToChooseFrom - 1;
	elseif gd.Ability == 23 then
		if not gd.LifeDone then
			gT.Players[iPlayer].NumPointsChangeSocialBonus = gT.Players[iPlayer].NumPointsChangeSocialBonus - 1;
		end
	elseif gd.Ability == 34 then
		Players[iPlayer]:ChangePlayerBuildingClassYieldChange(GameInfoTypes.BUILDINGCLASS_LIBRARY, yScience, -1);
	elseif gd.Ability == 32 then
		gT.Players[iPlayer].MoraleFromGP = gT.Players[iPlayer].MoraleFromGP - 3;
	elseif gd.Ability == 36 then
		for g, gdata in pairs(gT.Players) do
			if Players[g]:IsMinorCiv() then
				Players[g]:ChangeMinorCivExtraAnchorWithMajor(iPlayer, -7)
			end
		end
	elseif gd.Ability == 47 then
		gT.Players[iPlayer].NumPantheonsToChoose = gT.Players[iPlayer].NumPantheonsToChoose - 1;	
	elseif gd.Ability == 48 then
		gT.Players[iPlayer].GPNumTalentsOption = gT.Players[iPlayer].GPNumTalentsOption - 1;
	elseif gd.Ability == 49 then
		Players[iPlayer]:ChangeDamageLuck(-300)
	elseif gd.Ability == 55 then
		Players[iPlayer]:ChangePlayerBuildingClassYieldChange(GameInfoTypes.BUILDINGCLASS_MARKET, yGold, -1);
	elseif gd.Ability == 56 then
		gT.Players[iPlayer].RailroadDiscount = gT.Players[iPlayer].RailroadDiscount - 25;
	elseif gd.Ability == 60 then
		Players[iPlayer]:ChangeCityConnectionTradeRouteGoldModifier(-15);
	elseif gd.Ability == 61 then
		Players[iPlayer]:ChangeImprovementYieldChange(GameInfoTypes.IMPROVEMENT_CUSTOMS_HOUSE, yGold, -2)
	elseif gd.Ability == 66 then
		gT.Players[iPlayer].FoodFromFish = gT.Players[iPlayer].FoodFromFish + 1;
	elseif gd.Ability == 67 then
		Players[iPlayer]:ChangeAirStrikeDodgeChance(5)
	elseif gd.Ability == 72 then
		gT.Players[iPlayer].InfluenceIRGP = gT.Players[iPlayer].InfluenceIRGP - 5; 
	elseif gd.Ability == 73 then
		gT.Players[iPlayer].VotesGP = gT.Players[iPlayer].VotesGP - 1; 
	elseif gd.Ability == 76 then
		ChangeITGExtraResources(iPlayer, rCoal, -1)
	elseif gd.Ability == 77 then
		gT.Players[iPlayer].GPMeritocracy = gT.Players[iPlayer].GPMeritocracy -1;
	elseif gd.Ability == 80 then
		gT.Players[iPlayer].GPCodexInfluence = gT.Players[iPlayer].GPCodexInfluence - 50;
	end
	if gT.GreatPeople[gpID].Visibility then
		ClearTheVisionModifierAndLabel(iPlayer, gpID)
	end
	if reason ~= "Killed" then
		gT.Players[iPlayer].GreatPeople[gpID] = nil;
		if reason == "Captured" then
			gT.Players[iPlayer].CapturedGP[gpID] = 1;
		else
			gT.Players[iPlayer].EmigratedGP[gpID] = 1;
		end
	end
	GreatPeopleAmountDirty(iPlayer)
end

function ChooseMostNiceCityForGP(iPlayer, sCity, gpID)
	local sTab = {}
	if gT.GreatPeople[gpID].ForcedCity then
		local th = Map.GetPlotByIndex(gT.GreatPeople[gpID].ForcedCity):GetPlotCity();
		if th:GetOwner() == iPlayer then
			return th;
		end
	end
	for iCity in Players[iPlayer]:Cities() do
		if sCity ~= iCity then
			table.insert(sTab, {iCity, math.max(1, GetFavourToTheCity(gpID, iPlayer, iCity))})
		end
	end
	return GetRandomFromBiasedChanceTable(sTab)
end

GreatCivilianPeopleBonusesTable = {
{ID = 1, Help = "Has 1% chance to design a World Wonder each turn.", ScenarioLocked = {[1] = 1, [2] = 1, [3] = 1, [4] = 1}, Scientist = 1, Engineer = 25, Artist = 1, AIFavour1 = 20, AIFavour2 = 10, AIFavour3 = 1},
{ID = 2, Help = "Has 1% chance to discover Technology each turn.", Scientist = 25, Engineer = 1, AIFavour1 = 20, AIFavour2 = 10, AIFavour3 = 1},
{ID = 3, Help = "Has 5% chance to create [ICON_GREAT_WORK] Great Work each turn.", Scientist = 1, Engineer = 1, Artist = 25, Writer = 25, Musician = 25, AIFavour1 = 17, AIFavour2 = 12, AIFavour3 = 1},
{ID = 4, Help = "Provides one extra Agent.", Statesman = 25, AIFavour1 = 12, AIFavour2 = 10, AIFavour3 = 6},
{ID = 5, Help = "+5 points towards [ICON_CITY_STATE] City-States' politics.", Statesman = 5, Philosopher = 5, AIFavour1 = 15, AIFavour2 = 9, AIFavour3 = 1},
{ID = 6, Help = "+15% [ICON_FOOD] Food in city.", Scientist = 25, Engineer = 1, AIFavour1 = 15, AIFavour2 = 7, AIFavour3 = 5},
{ID = 7, Help = "[ICON_HAPPINESS_1] Happiness chance from [ICON_GREAT_WORK] Great Works of Music doubled.", Artist = 3, Writer = 3, Musician = 25, AIFavour1 = 5, AIFavour2 = 10, AIFavour3 = 15},
{ID = 8, Help = "[ICON_RESEARCH] Science from [ICON_GREAT_WORK] Great Works of Literature doubled.", Scientist = 5, Artist = 3, Writer = 25, Musician = 3, AIFavour1 = 5, AIFavour2 = 10, AIFavour3 = 15},
{ID = 9, Help = "[ICON_GOLD] Gold from [ICON_GREAT_WORK] Great Works of Art doubled.", Engineer = 3, Artist = 25, Writer = 3, Musician = 3, AIFavour1 = 5, AIFavour2 = 10, AIFavour3 = 15},
{ID = 10, Help = "Allows a City to mantain a Trade Process which converts [ICON_PRODUCTION] Production into Trade Route points.", Engineer = 1, Statesman = 25, AIFavour1 = 12, AIFavour2 = 8, AIFavour3 = 4},
{ID = 11, Help = "+7 [ICON_ITG_UNIFY] Unifying Presence.", Artist = 25, Writer = 25, Musician = 25, AIFavour1 = 11, AIFavour2 = 9, AIFavour3 = 7},
{ID = 12, Help = "+50% border growth in the City.", Engineer = 25, Statesman = 5, AIFavour1 = 6, AIFavour2 = 4, AIFavour3 = 4},
{ID = 13, Help = "Makes 3 units maintenance free ([ICON_GOLD]).", Statesman = 25, AIFavour1 = 9, AIFavour2 = 9, AIFavour3 = 9},
{ID = 14, Help = "+2% [ICON_HAPPINESS_1] Happiness chance in all Cities.", Statesman = 1, Artist = 3, Writer = 3, Musician = 5, Philosopher = 25, AIFavour1 = 11, AIFavour2 = 11, AIFavour3 = 11},
{ID = 15, Help = "Every several turns discovers new area.", Scientist = 25, Writer = 1, AIFavour1 = 15, AIFavour2 = 6, AIFavour3 = 2, PrevMigration = true, ScenarioLocked = {[1] = 1, [2] = 1, [3] = 1}},
{ID = 16, Help = "[ICON_INFLUENCE] Influence resting point with [ICON_CITY_STATE] City-States of same culture type is increased by 10.", Artist = 1, Writer = 1, Musician = 1, Philosopher = 25, AIFavour1 = 7, AIFavour2 = 7, AIFavour3 = 7, ScenarioLocked = {[1] = 1, [2] = 1, [3] = 1}},
{ID = 17, Help = "Has 3% chance to grant Fort each turn.", Scientist = 1, Engineer = 25, Statesman = 3, AIFavour1 = 15, AIFavour2 = 12, AIFavour3 = 1},
{ID = 18, Help = "Has 3% chance to grant Colony point each turn.", Engineer = 3, Statesman = 25, AIFavour1 = 15, AIFavour2 = 12, AIFavour3 = 1},
{ID = 19, Help = "Slightly reduces movement cost on roads.", Engineer = 25, Statesman = 5, Scientist = 1, AIFavour1 = 7, AIFavour2 = 7, AIFavour3 = 7},
{ID = 20, Help = "+15% [ICON_GOLD] Gold in city.", Statesman = 25, AIFavour1 = 4, AIFavour2 = 4, AIFavour3 = 4},
{ID = 21, Help = "+1 [ICON_RESEARCH] Science per unknown technology.", Scientist = 25, AIFavour1 = 35, AIFavour2 = 16, AIFavour3 = 1},
{ID = 22, Help = "Can choose from one extra technology upon discovery bonus.", Prophet = 25, Scientist = 25, AIFavour1 = 7, AIFavour2 = 7, AIFavour3 = 5},
{ID = 23, Help = "Allows you to change one Social Bonus, which you wouldn't be able otherwise.", ScenarioLocked = {[1] = 1, [2] = 1}, Philosopher = 25, Statesman = 1, Artist = 1, Writer = 3, Musician = 1, AIFavour1 = 12, AIFavour2 = 12, AIFavour3 = 12},
{ID = 24, Help = "+50% [ICON_WORKER] Work Rate in the city.", Engineer = 25, Statesman = 15, Scientist = 1, AIFavour1 = 5, AIFavour2 = 5, AIFavour3 = 2},
{ID = 25, Help = "+50% [ICON_GOLD] Gold from incoming and outgoing Trade Routes.", Statesman = 25, AIFavour1 = 15, AIFavour2 = 14, AIFavour3 = 11},
{ID = 26, Help = "Adds +25 [ICON_ITG_CHARM] Charm to the City.", Philosopher = 15, Artist = 15, Musician = 15, Writer = 15, AIFavour1 = 5, AIFavour2 = 6, AIFavour3 = 12},
{ID = 27, Help = "Has 5% chance to hurry up the building construction in the City each turn.", Engineer = 25, Scientist = 5, AIFavour1 = 17, AIFavour2 = 14, AIFavour3 = 6, ScenarioLocked = {[1] = 1}, [2] = 1, [3] = 1, [4] = 1},
{ID = 28, Help = "Has 3% chance to provide an Academy each turn.", Scientist = 25, Engineer = 10, Philosopher = 1, AIFavour1 = 20, AIFavour2 = 11, AIFavour3 = 1},
{ID = 29, Help = "Has 3% chance to provide a Manufactory each turn.", Scientist = 10, Engineer = 25, Statesman = 1, AIFavour1 = 20, AIFavour2 = 11, AIFavour3 = 1},
{ID = 30, Help = "Has 3% chance to provide a Customs House each turn.", Statesman = 25, AIFavour1 = 20, AIFavour2 = 11, AIFavour3 = 1},
{ID = 31, Help = "Grants an additional ranged strike to the City.", Statesman = 20, Engineer = 15, AIFavour1 = 15, AIFavour2 = 13, AIFavour3 = 10},
{ID = 32, Help = "+3 [ICON_ITG_MORALE] Morale.", Philosopher = 20, Writer = 20, Musician = 1, AIFavour1 = 20, AIFavour2 = 11, AIFavour3 = 1},
{ID = 33, Help = "Riots do not cause [ICON_RESISTANCE] Resistance in the City.", Statesman = 25, Philosopher = 15, Writer = 1, Artist = 1, AIFavour1 = 16, AIFavour2 = 12, AIFavour3 = 7},
{ID = 34, Help = "+1 [ICON_RESEARCH] Science from Libraries.", Scientist = 20, Philosopher = 10, Writer = 1, AIFavour1 = 14, AIFavour2 = 13, AIFavour3 = 12},
{ID = 35, Help = "5% chance to make one random building maintenance free each turn.", Statesman = 25, Scientist = 1, Engineer = 1, AIFavour1 = 20, AIFavour2 = 12, AIFavour3 = 1},
{ID = 36, Help = "+7 [ICON_INFLUENCE] Influence to resting point with all [ICON_CITY_STATE] City-States.", Statesman = 15, Philosopher = 10, Musician = 1, Writer = 1, Artist = 1, AIFavour1 = 20, AIFavour2 = 15, AIFavour3 = 10},
{ID = 37, Help = "+7 [ICON_INFLUENCE] Influence from Trade-Routes arriving to [ICON_CITY_STATE] City-States.", Statesman = 15, Musician = 1, Writer = 1, Artist = 1, AIFavour1 = 20, AIFavour2 = 15, AIFavour3 = 10},
{ID = 38, Help = "Has 1% chance to advance to the next Art Style each turn.", Writer = 25, Artist = 25, Musician = 25, AIFavour1 = 20, AIFavour2 = 7, AIFavour3 = 2},
{ID = 39, Help = "+35 [ICON_INVEST] Currency Power.", Statesman = 25, AIFavour1 = 15, AIFavour2 = 14, AIFavour3 = 12},
{ID = 40, Help = "+1 [ICON_ITG_SETTLER] Settler point per turn.", Statesman = 25, AIFavour1 = 10, AIFavour2 = 3, AIFavour3 = 1},
{ID = 41, Help = "Migrating to a City increases [ICON_HAPPINESS_1] Happiness by 1. Traveller. Will not abandon homeland unless forced by War.", Musician = 1, AIFavour1 = 10, AIFavour2 = 3, AIFavour3 = 1, Troubadour = true},
{ID = 42, Help = "+4 [ICON_ITG_HEALTH_1] Health in the city. [ICON_ITG_PLAGUE_4] Epidemies are less likely to spread into city.", Statesman = 3, Scientist = 25, AIFavour1 = 13, AIFavour2 = 12, AIFavour3 = 6},
{ID = 43, Help = "+5 [ICON_ITG_ACADEMY_2] Development points in every active Academy adjacent to city.", Statesman = 3, Scientist = 10, Philosopher = 5, Engineer = 3, AIFavour1 = 10, AIFavour2 = 5, AIFavour3 = 2},
{ID = 44, Help = "+10 [ICON_ITG_ACADEMY_1] Prestige per turn in every active Academy adjacent to city.", Statesman = 6, Scientist = 6, Philosopher = 6, Engineer = 6, AIFavour1 = 11, AIFavour2 = 7, AIFavour3 = 3},
{ID = 45, Help = "Has 3% chance to provide an Inspiration to random building each turn.", Statesman = 5, Engineer = 5, Philosopher = 1, Writer = 1, AIFavour1 = 10,  AIFavour2 = 7, AIFavour3 = 2},
{ID = 46, Help = "Your Cities are more rebelous when [ICON_OCCUPIED] occupied.", Statesman = 5, Artist = 5, Writer = 10, AIFavour1 = 5, AIFavour2 = 4, AIFavour3 = 4},
{ID = 47, Help = "Can choose from one extra Belief upon founding Pantheon.", Prophet = 25, AIFavour1 = 5, AIFavour2 = 5, AIFavour3 = 5},
{ID = 48, Help = "Can choose from one extra Talent upon Great Person ascension.", Prophet = 25, AIFavour1 = 5, AIFavour2 = 5, AIFavour3 = 5},
{ID = 49, Help = "Your combat damage is lucky.", Prophet = 25, AIFavour1 = 5, AIFavour2 = 5, AIFavour3 = 5},
{ID = 50, Help = "+6 [ICON_ITG_PRESENCE] Cultural Presence per turn.", Writer = 20, Artist = 20, Musician = 20, Statesman = 8, AIFavour1 = 8, AIFavour2 = 7, AIFavour3 = 6},
{ID = 51, Help = "Grants Free Railroad every 7th turn.", ScenarioLocked = {[4] = 1}, Engineer = 20, Scientist = 15, Statesman = 5, AIFavour1 = 15, AIFavour2 = 10, AIFavour3 = 5},
{ID = 52, Help = "+7 [ICON_RES_ARTIFACTS] Historical Sources per turn.", ScenarioLocked = {[4] = 1}, Philosopher = 5, Statesman = 5, Engineer = 5, Scientist = 5, Statesman = 5, AIFavour1 = 12, AIFavour2 = 11, AIFavour3 = 10},
{ID = 53, Help = "Citizens are less likely to migrate away.", Philosopher = 10, Statesman = 15, AIFavour1 = 4, AIFavour2 = 4, AIFavour3 = 4},
{ID = 54, Help = "+5 [ICON_STRENGTH] City's strength.", Engineer = 3, Statesman = 15, AIFavour1 = 7, AIFavour2 = 11, AIFavour3 = 13},
{ID = 55, Help = "+1 [ICON_GOLD] Gold from Markets.", Engineer = 20, Scientist = 15, Statesman = 5, AIFavour1 = 15, AIFavour2 = 10, AIFavour3 = 5},
{ID = 56, Help = "Reduces [ICON_WORKER] Work Rate cost to construct Roads by 100 and Railroads by 25.", Engineer = 25, Statesman = 5, AIFavour1 = 16, AIFavour2 = 8, AIFavour3 = 7},
{ID = 57, Help = "+3 [ICON_ITG_AUTHORITY] Authority.", Statesman = 12, AIFavour1 = 7, AIFavour2 = 8, AIFavour3 = 12},
{ID = 58, Help = "Has 3% chance to grant Palace Upgrade each turn.", Statesman = 12, AIFavour1 = 15, AIFavour2 = 9, AIFavour3 = 5},
{ID = 59, Help = "Has 3% chance to find new Currency Resource each turn.", Statesman = 7, Engineer = 5, AIFavour1 = 15, AIFavour2 = 9, AIFavour3 = 5},
{ID = 60, Help = "+15% [ICON_GOLD] Gold from City Connections.", Statesman = 10, Engineer = 1, Scientist = 1, AIFavour1 = 9, AIFavour2 = 9, AIFavour3 = 9},
{ID = 61, Help = "+2 [ICON_GOLD] Gold from all Customs House in empire. Customs House in this City develops an extra 4 [ICON_ITG_CUSTOMS_HOUSE] points each turn.", Statesman = 10, AIFavour1 = 11, AIFavour2 = 7, AIFavour3 = 4},
{ID = 62, Help = "Has 1% chance to discover Innovation each turn.", Engineer = 8, Scientist = 8, ScenarioLocked = {[1] = 1, [5] = 1}, AIFavour1 = 11, AIFavour2 = 10, AIFavour3 = 5},
{ID = 63, Help = "Has 7% chance to boost Nuclear Project by 200 each turn.", Engineer = 8, Scientist = 8, ScenarioLocked = {[5] = 1}, AIFavour1 = 15, AIFavour2 = 3, AIFavour3 = 1},
{ID = 64, Help = "Has 7% chance to boost Spaceflight Program by 200 each turn.", Engineer = 8, Scientist = 8, ScenarioLocked = {[5] = 1}, AIFavour1 = 7, AIFavour2 = 3, AIFavour3 = 1},
{ID = 65, Help = "Has 3% chance to support Doctrine of your Ideology by 400 each turn.", Statesman = 7, Philosopher = 7, ScenarioLocked = {[5] = 1}, AIFavour1 = 6, AIFavour2 = 2, AIFavour3 = 2},
{ID = 66, Help = "+1 [ICON_FOOD] Food from Fishing.", Statesman = 19, Engineer = 4, Scientist = 2, AIFavour1 = 8, AIFavour2 = 7, AIFavour3 = 6},
{ID = 67, Help = "Extra 5% chance that enemy air strike will miss.", Engineer = 5, ScenarioLocked = {[5] = 1}, AIFavour1 = 10, AIFavour2 = 10, AIFavour3 = 10},
{ID = 68, Help = "City's buildings cannot be destroyed by bombardment.", Engineer = 6, Statesman = 5, ScenarioLocked = {[5] = 1}, AIFavour1 = 7, AIFavour2 = 7, AIFavour3 = 7},
{ID = 69, Help = "City's ranged strikes deal more damage.", Engineer = 2, Statesman = 2, AIFavour1 = 9, AIFavour2 = 8, AIFavour3 = 8},
{ID = 70, Help = "Has 2% chance to reduce [ICON_PRODUCTION] Production cost of random mechanical unit class each turn.", Engineer = 9, Scientist = 7, ScenarioLocked = {[5] = 1}, AIFavour1 = 12, AIFavour2 = 10, AIFavour3 = 4},
{ID = 71, Help = "+15 [ICON_TRADE_WHITE] Trade appeal in the City.", Statesman = 10, Artist = 1, Engineer = 1, AIFavour1 = 7, AIFavour2 = 6, AIFavour3 = 5},
{ID = 72, Help = "+5 [ICON_INFLUENCE] Influence from Improving Relations.", Statesman = 10, Artist = 1, Writer = 1, Musician = 1, AIFavour1 = 20, AIFavour2 = 15, AIFavour3 = 10},
{ID = 73, Help = "+1 [ICON_ITG_VOTES] Vote in all Leagues.", Statesman = 4, Philosopher = 1, Artist = 1, Writer = 1, Musician = 1, AIFavour1 = 20, AIFavour2 = 15, AIFavour3 = 10},
{ID = 74, Help = "City produces +5 [ICON_ITG_PILGRIM] Pilgrimage points per turn.", Philosopher = 10, Statesman = 2, ScenarioLocked = {[1] = 1, [2] = 1}, AIFavour1 = 8, AIFavour2 = 8, AIFavour3 = 8},
{ID = 75, Help = "+10 [ICON_ITG_SPECIALIZATION] points towards unit specialization per turn.", Scientist = 3, Engineer = 3, Statesman = 1, ScenarioLocked = {[3] = 1, [5] = 1}, AIFavour1 = 15, AIFavour2 = 10, AIFavour3 = 3},
{ID = 76, Help = "+1 source of [ICON_RES_COAL] Coal.", Scientist = 4, Engineer = 4, Statesman = 4, ScenarioLocked = {[4] = 1}, AIFavour1 = 11, AIFavour2 = 8, AIFavour3 = 5},
{ID = 77, Help = "+1 [ICON_ITG_MERITOCRACY] Meritocracy per turn.", Scientist = 1, Engineer = 1, Statesman = 1, Philospher = 7, AIFavour1 = 20, AIFavour2 = 15, AIFavour3 = 10},
{ID = 78, Help = "Migrating to a City increases [ICON_ITG_PRESENCE] Presence by 50. Traveller. Will not abandon homeland unless forced by War.", Artist = 1, AIFavour1 = 10, AIFavour2 = 3, AIFavour3 = 1, Troubadour = true},
{ID = 79, Help = "Creates [ICON_GREAT_WORK] Great Work of Literature upon migration. Traveller. Will not abandon homeland unless forced by War.", Writer = 1, AIFavour1 = 10, AIFavour2 = 3, AIFavour3 = 1, Troubadour = true},
{ID = 80, Help = "+50% [ICON_ITG_LAWS_INFLUENCE] Codex Influence.", ScenarioLocked = {[5] = 1, [4] = 1}, Scientist = 1, Writer = 1, Philosopher = 2, Statesman = 10, AIFavour1 = 5, AIFavour2 = 8, AIFavour3 = 15},
}

function GetCivilopediaTalents()
	local tab = {}
	for i, v in pairs(GreatCivilianPeopleBonusesTable) do
		table.insert(tab, {ID = i + 2000, Name = "Talent " .. i})
	end
	return tab;
end

LuaEvents.ITGCivilopediaRequestTalent.Add(function(id)
	MapModData.ITGSG = {Name = "Talent " .. id, Help = GreatCivilianPeopleBonusesTable[id].Help}
end)

function ChooseBestTalentForAI(bTab)
	local bFID = 2;
	if GetITGGameTurn() < 35 then
		bFID = 1;
	elseif GetITGGameTurn() > 85 then
		bFID = 3;
	end
	local bo, bv = nil, 0;
	for abID, sth in pairs(bTab) do
		local nv = GreatCivilianPeopleBonusesTable[abID]["AIFavour" .. bFID];
		if nv > bv or (nv == bv and LastRandom(1, 2) == 2) then
			bv = nv;
			bo = abID;
		end
	end
	return bo;
end

local hBasicYT = {"Archaeology", "Science","Production","Legal","HapChance","Faith"}
local hExtraYT = {"GPpoints", "ArtPoints", "WonderPoints"}
function GetTotalYieldsOfGP(gpID)
	local h = 0;
	for i, v in pairs(hBasicYT) do
		h = h + (gT.GreatPeople[gpID][v] or 0)
	end
	for i, v in pairs(hExtraYT) do
		h = h + (gT.GreatPeople[gpID][v] or 0)
	end
	return h;
end

function AddYieldToGPMidGame(gpID, am, bOnlyBasic)
	local vTab ={}
	for i, b in pairs(hBasicYT) do
		if (gT.GreatPeople[gpID][b] or 0) > 0 then
			table.insert(vTab, b);
		end
	end
	if not bOnlyBasic then
		for i, b in pairs(hExtraYT) do
			if (gT.GreatPeople[gpID][b] or 0) > 0 then
				table.insert(vTab, b);
			end
		end
	end
	if #vTab > 0 then
		local cID;
		if gT.GreatPeople[gpID].City then
			local iCity = Map.GetPlotByIndex(gT.GreatPeople[gpID].City):GetPlotCity();
			cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		end
		for i = 1, am do
			local lDD = vTab[LastRandom(1,#vTab)];
			gT.GreatPeople[gpID][lDD] = gT.GreatPeople[gpID][lDD] + 1
			if "HapChance" == lDD then
				if cID then
					gT.Cities[cID].HapChanceFromGP = gT.Cities[cID].HapChanceFromGP + 10;
				end
			end
		end
	end
end

function AssingYieldBonusesToCivilianGP(gpID, iPlayer)
	local data = lSgreatpeopleData[gT.GreatPeople[gpID].Type];
	for i, ds in pairs(hBasicYT) do
		if data[ds] > 0 then
			if ds ~= "Faith" or (gT.Globals.ScenarioType ~= 5) then
				local val = LastRandom(0, data[ds])
				if ds == "Faith" and gT.Globals.ScenarioType == 4 then -- decline of faith
					val = math.max(0, val - 2);
				end 
				if val > 0 then
					if ds ~= "Archaeology" or DBScenario.Archaeology then
						gT.GreatPeople[gpID][ds] = val;
					end
				end
			end
		end
	end
	if gT.Players[iPlayer].HasIdeology[91] then
		local tab = {}
		for i, ds in pairs(hBasicYT) do
			if data[ds] > 0 then
				if ds ~= "Archaeology" or DBScenario.Archaeology then
					if ds ~= "Faith" or (gT.Globals.ScenarioType ~= 5) then
						table.insert(tab, ds)
					end
				end
			end
		end
		if #tab > 0 then
			for i = 1, 4 do
				local ls = tab[LastRandom(1,#tab)]
				gT.GreatPeople[gpID][ls] = (gT.GreatPeople[gpID][ls] or 0) + 1;
			end
		end
	end
	local artpoints, wonderpoints, gppoints = 0, 0, 0;
	for i = 0, data.ArtPoints do
		if LastRandom(1, 100) <= data.ArtChance then
			artpoints = artpoints + 1;
		end
	end
	if artpoints > 0 then
		gT.GreatPeople[gpID].ArtPoints = artpoints;
	end
	if DBScenario.WonderRaceOn then
		for i = 0, data.WonderPoints do
			if LastRandom(1, 100) <= data.WonderChance then
				wonderpoints = wonderpoints + 1;
			end
		end
		if wonderpoints > 0 then
			gT.GreatPeople[gpID].WonderPoints = wonderpoints;
		end
	end
	for i = 0, data.GPpoints do
		if LastRandom(1, 100) <= data.GPchance then
			gppoints = gppoints + 1;
		end
	end
	if gppoints > 0 then
		gT.GreatPeople[gpID].GPPoints = gppoints;
	end
	-- migration related staff;
	gT.GreatPeople[gpID].FlavourTravel = LastRandom(0, 12);
	gT.GreatPeople[gpID].FearOfWar = LastRandom(-10, 40);
	gT.GreatPeople[gpID].PrefCityPop = LastRandom(1, 30);
	gT.GreatPeople[gpID].PrefEmpireSize = LastRandom(1, 12);
	gT.GreatPeople[gpID].FavourPatriotism = LastRandom(-20, 20)
	gT.GreatPeople[gpID].FavourHighMorale = LastRandom(-5, 7)
	gT.GreatPeople[gpID].HomeLover = LastRandom(-5, 5)
	gT.GreatPeople[gpID].FavourReligion = LastRandom(0, 10);
	gT.GreatPeople[gpID].FavourUnpredictable = LastRandom(0, 19);
	gT.GreatPeople[gpID].HappinessLover = LastRandom(-5, 5)
	gT.GreatPeople[gpID].WonderWhale = LastRandom(-1, 5);
	gT.GreatPeople[gpID].FeelMorale = LastRandom(-10, 10) / 10;
	gT.GreatPeople[gpID].FlavourAuthority = math.max(0, LastRandom(-2, 1))
	--religion
	local relTab = {}
	local total = 3;
	local iCity = Map.GetPlotByIndex(gT.GreatPeople[gpID].OriginCity):GetPlotCity();
	for row in GameInfo.Religions() do
		if row.ID ~= 0 then
			local numfol = iCity:GetNumFollowers(row.ID);
			if numfol > 0 then
				total = total + numfol;
				table.insert(relTab, {row.ID, numfol})
			end
		end
	end
	if #relTab > 0 then
		gT.GreatPeople[gpID].Religion = GetRandomFromBiasedChanceTable(relTab)
	end
end

function GetCivGPAbility(type, bTab, iPlayer)
	local rTab = {}
	local iForcedBias;
	if gT.Players[iPlayer].CultBonusOn[84] then
		iForcedBias = 1; -- equality
	end
	for i, data in pairs(GreatCivilianPeopleBonusesTable) do
		if data[type] then
			if (not data.ScenarioLocked) or data.ScenarioLocked[gT.Globals.ScenarioType] then
				if (not bTab) or (not bTab[data.ID]) then
					table.insert(rTab, {data.ID, iForcedBias or data[type]})
				end
			end
		end
	end
	if #rTab > 0 then
		return GetRandomFromBiasedChanceTable(rTab)
	else
		return nil
	end
end

function GetAnyAliveCivilianGPWithAbility(iPlayer, ability)
	for gpID, hhh in pairs(gT.Players[iPlayer].GreatPeople) do
		local gd = gT.GreatPeople[gpID];
		if gd.Alive and (not gd.Military) and gd.Ability == ability then
			return gpID;
		end
	end
	return nil;
end

function GetNumGPWithAbility(iPlayer, ability, fType)
	local l = 0;
	for gpID, hhh in pairs(gT.Players[iPlayer].GreatPeople) do
		local gd = gT.GreatPeople[gpID];
		if gd.Alive and (ability == gd.Ability) then
			if (gd.Type == fType) or ((not fType) and (not gd.Military)) then
				l = l + 1;
			end
		end
	end
	return l;
end

function FindGPResponsibleAndMakeHimLifeDone(iPlayer, string)
	for gpID, hhh in pairs(gT.Players[iPlayer].GreatPeople) do
		local gd = gT.GreatPeople[gpID];
		if gd.Alive and (not gd.Military) then
			if not gd.LifeDone then
				if gd.Ability == 23 then
					gT.GreatPeople[gpID].LifeDone = "Convinced people of " .. Players[iPlayer]:GetCivilizationShortDescription() .. " to abandon social development of " .. string .. ".";
					if Game.GetActivePlayer() == iPlayer then
						local strTitle = "Cultural Revolution"
						local string = "Thanks to campaign and teachings of " .. GetGreatPersonName(gpID) .. " our people no longer follow the doctrine of " .. string .. "!";
						Players[iPlayer]:AddNotification(5521344, string, strTitle, -1, -1, gT.GreatPeople[gpID].Type, iPlayer)
					end
					return;
				end
			end
		end
	end
end

function DoGreatPeopleCivilBonusesAndMigration(iPlayer)
	local queueMigration = {}
	tempStoredCharm = {};
	local gTurn = GetITGGameTurn();
	for gpID, hhh in pairs(gT.Players[iPlayer].GreatPeople) do
		local gd = gT.GreatPeople[gpID];
		if gd.Alive and (not gd.Military) then
			if not gd.LifeDone then
				local prevMigration = false;
				if gT.Players[iPlayer].GovRewards[36] then
					if LastChance(10) then
						AddYieldToGPMidGame(gpID, 1, false)
					end
				end
				if gd.Ability == 1 then
					if LastRandom(1, 100) == 17 then
						local iWonder = GetValidWonderToClaim(iPlayer)
						if iWonder then
							HnGLogWonderData(iWonder, "GP", gpID)
							AssignWonderToThePlayer(iPlayer, iWonder, nil)
							gT.GreatPeople[gpID].LifeDone = "Designed the World Wonder: " .. Locale.Lookup(GameInfo.Buildings[iWonder].Description) .. ".";
							prevMigration = true;
							if Players[iPlayer]:IsHuman() then
								local strTitle = Locale.Lookup(GameInfo.Buildings[iWonder].Description);
								local string = "Due to enormous efforts of " .. GetGreatPersonName(gpID) .. " we are now able to construct new World Wonder, " .. Locale.Lookup(GameInfo.Buildings[iWonder].Description) .. "!";
								Players[iPlayer]:AddNotification(48558833, string, strTitle, -1, -1, iWonder)
							end
						end
					end
				elseif gd.Ability == 2 then
					if LastRandom(1, 100) == 17 then
						local pTab = GetValidTableOfTechs(iPlayer, true, false);
						if #pTab > 0 then
							local iTech = GetTechForCiviGP(iPlayer)
							if iTech then
								prevMigration = true;
								PlayerDiscoverTech(iPlayer, iTech, nil, "hDT6")
								gT.GreatPeople[gpID].LifeDone = "Discovered the Technology: " .. Locale.Lookup(GameInfo.Technologies[iTech].Description) .. ".";
								if Players[iPlayer]:IsHuman() then
									local strTitle = Locale.Lookup(GameInfo.Technologies[iTech].Description);
									local string = "Due to extraordinary intelect of " .. GetGreatPersonName(gpID) .. " we have acquired the secrets of new technology, " .. Locale.Lookup(GameInfo.Technologies[iTech].Description) .. "!";
									Players[iPlayer]:AddNotification(5521344, string, strTitle, -1, -1, gT.GreatPeople[gpID].Type)
								end
							end
						end
					end
				elseif gd.Ability == 3 then
					if LastRandom(1, 20) == 17 then
						prevMigration = true;
						if gd.Type == 6 then
							CreateGreatWorkOfAmount(iPlayer, 1, "Music")
						elseif gd.Type == 7 then
							CreateGreatWorkOfAmount(iPlayer, 1, "Literature")
						elseif gd.Type == 8 then
							CreateGreatWorkOfAmount(iPlayer, 1, "Art")
						else
							CreateGreatWorkOfAmount(iPlayer, 1)
						end
						if Players[iPlayer]:IsHuman() then
							local strTitle = "Great Work";
							local string = "Our splendid " .. GetGreatPersonName(gpID) .. " finished creating new [ICON_GREAT_WORK] Great Work!";
							Players[iPlayer]:AddNotification(5521344, string, strTitle, -1, -1, gT.GreatPeople[gpID].Type)
						end
					end
				elseif gd.Ability == 15 then
					if (gd.DiscoveryCooldown or 0) == 0 then
						ClearTheVisionModifierAndLabel(iPlayer, gpID)
						AddNewExplorationPointToDiscover(iPlayer, gpID)
					else
						gT.GreatPeople[gpID].DiscoveryCooldown = gT.GreatPeople[gpID].DiscoveryCooldown - 1;
					end
				elseif gd.Ability == 17 then
					if LastRandom(1, 100) <= 3 then
						prevMigration = true;
						gT.Players[iPlayer].NumFortPoints = gT.Players[iPlayer].NumFortPoints + 1; 
						if Players[iPlayer]:IsHuman() then
							local strTitle = "New Fort";
							local string = "Thanks to the effort of our magnificent " .. GetGreatPersonName(gpID) .. " we are able to create one new fort or improve one fort to the citadel!";
							Players[iPlayer]:AddNotification(5521344, string, strTitle, -1, -1, gT.GreatPeople[gpID].Type)
						end
					end
				elseif gd.Ability == 18 then
					if LastRandom(1, 100) <= 3 then
						prevMigration = true;
						DoAddNewColonyPoint(iPlayer, 1)
						if Players[iPlayer]:IsHuman() then
							local strTitle = "New Colony";
							local string = "Thanks to the effort of our magnificent " .. GetGreatPersonName(gpID) .. " we are able to establish new colony!";
							Players[iPlayer]:AddNotification(5521344, string, strTitle, -1, -1, gT.GreatPeople[gpID].Type)
						end
					end
				elseif gd.Ability == 27 then
					if LastRandom(1, 20) == 13 then
						if gT.GreatPeople[gpID].City then
							local iCity = Map.GetPlotByIndex(gT.GreatPeople[gpID].City):GetPlotCity();
							if iCity then
								local unitP = iCity:GetProductionBuilding()
								if CanBuildingProdBeHurryUp(unitP) then
									prevMigration = true;
									ITGCityPurchasedBuilding(iCity, unitP, false, false, true)
									if Players[iPlayer]:IsHuman() then
										local strTitle = Locale.Lookup(GameInfo.Buildings[unitP].Description) .. " constrcuted";
										local string = "By the great effort of " .. GetGreatPersonName(gpID) .. " the construction in the city of " .. iCity:GetName() .. " has ended prematurely!";
										Players[iPlayer]:AddNotification(5521344, string, strTitle, -1, -1, gT.GreatPeople[gpID].Type)
									end	
								end
							end
						end
					end
				elseif gd.Ability == 28 then
					if LastRandom(1, 100) <= 3 then
						prevMigration = true;
						table.insert(gT.Players[iPlayer].AcademyPoints, gpID)
						gT.GreatPeople[gpID].LifeDone = "Created an Academy.";
						if Players[iPlayer]:IsHuman() then
							local strTitle = "New Academy";
							local string = "Thanks to the beatiful mind of " .. GetGreatPersonName(gpID) .. " we are able to place new academy!";
							Players[iPlayer]:AddNotification(5521344, string, strTitle, -1, -1, gT.GreatPeople[gpID].Type)
						end
					end
				elseif gd.Ability == 29 then
					if LastRandom(1, 100) <= 3 then
						prevMigration = true;
						table.insert(gT.Players[iPlayer].ManufactoryPoints, gpID)
						DoReduceManufactoryMaintByFree(iPlayer);
						if DBScenario.MF_RequireRes and DBScenario.MF_ImproCost100 then
							gT.GreatPeople[gpID].LifeDone = "Created a Manufactory. (Adequately reduced maintenance cost of Manufactories.)";
						else
							gT.GreatPeople[gpID].LifeDone = "Created a Manufactory.";
						end
						if Players[iPlayer]:IsHuman() then
							local strTitle = "New Manufactory";
							local string = "Thanks to the ingenuity of " .. GetGreatPersonName(gpID) .. " we are able to place new manufactory!";
							if DBScenario.MF_RequireRes and DBScenario.MF_ImproCost100 then
								string = string .. "[NEWLINE][NEWLINE](Maintenance cost of Manufactories is adequately reduced.)"
							end
							Players[iPlayer]:AddNotification(5521344, string, strTitle, -1, -1, gT.GreatPeople[gpID].Type)
						end
					end
				elseif gd.Ability == 30 then
					if LastRandom(1, 100) <= 3 then
						prevMigration = true;
						table.insert(gT.Players[iPlayer].CustomHousePoints, gpID)
						gT.GreatPeople[gpID].LifeDone = "Created a Customs House.";
						if Players[iPlayer]:IsHuman() then
							local strTitle = "New Customs House";
							local string = "Thanks to the initiative  of " .. GetGreatPersonName(gpID) .. " we are able to place new customs house!";
							Players[iPlayer]:AddNotification(5521344, string, strTitle, -1, -1, gT.GreatPeople[gpID].Type)
						end
					end
				elseif gd.Ability == 35 then
					if LastRandom(1, 100) <= 5 then
						local cCity = Map.GetPlotByIndex(gd.City):GetPlotCity();
						local bBuilding = GetBuildingToMakeFree(cCity)
						if bBuilding then
							prevMigration = true;
							cCity:SetNumFreeBuilding(bBuilding, 1);
							cCity:SetNumRealBuilding(bBuilding, 0);
							if Players[iPlayer]:IsHuman() then
								local strTitle = "Privatisation";
								local string = "Thanks to the generosity of " .. GetGreatPersonName(gpID) .. " we are no longer in need to maintain " .. Locale.Lookup(GameInfo.Buildings[bBuilding].Description) .. " in " .. cCity:GetName() .. "!";
								Players[iPlayer]:AddNotification(5521344, string, strTitle, -1, -1, gT.GreatPeople[gpID].Type)
							end
						end
					end
				elseif gd.Ability == 38 then
					if LastRandom(1, 100) == 13 then
						if gT.Players[iPlayer].CultureEra < 9 then
							prevMigration = true;
							local string;
							if (gT.Players[iPlayer].CultureEra == 6) and (not Teams[Players[iPlayer]:GetTeam()]:IsHasTech(gT.Players[iPlayer].LastCultureTechPrereq)) then
								gT.GreatPeople[gpID].LifeDone = "Discovered the Technology: " .. Locale.Lookup(GameInfo.Technologies[gT.Players[iPlayer].LastCultureTechPrereq].Description) .. ".";
								string = "Due to extraordinary intelect of " .. GetGreatPersonName(gpID) .. " we have acquired the secrets of new technology, " .. Locale.Lookup(GameInfo.Technologies[gT.Players[iPlayer].LastCultureTechPrereq].Description) .. "!";
							else
								local eraname = gT.Globals.CultureErasNames[gT.Players[iPlayer].CultureType][gT.Players[iPlayer].CultureEra + 1];
								gT.GreatPeople[gpID].LifeDone = "Advanced to " .. eraname .. ".";
								string = "Rarely a single person is significant enough to push entire nation into new era of art. " .. GetGreatPersonName(gpID) .. " entered " .. eraname .. "!";
							end
							UpgradePlayerToNextCulturalEra(iPlayer)
							if Players[iPlayer]:IsHuman() then
								local strTitle = "Artistic Revolution";
								Players[iPlayer]:AddNotification(5521344, string, strTitle, -1, -1, gT.GreatPeople[gpID].Type)
							end
						end
					end
				elseif gd.Ability == 45 then
					if LastRandom(1, 100) <= 3 then
						local bClass = GetProperBuildingForNewInspiration(iPlayer)
						if bClass then
							prevMigration = true;
							gT.GreatPeople[gpID].LifeDone = "Granted meaning to " .. Locale.Lookup(GameInfo.Buildings[Players[iPlayer]:GetPlayerUniqueBuilding(bClass)].Description) .. ".";
							AddInspirationChooseToPlayer(iPlayer, bClass)
							if Players[iPlayer]:IsHuman() then
								local strTitle = "New Inspiration";
								local string = "Thanks to the extraordinary vision of " .. GetGreatPersonName(gpID) .. " we will never look the same at " .. Locale.Lookup(GameInfo.Buildings[Players[iPlayer]:GetPlayerUniqueBuilding(bClass)].Description) .. "!";
								Players[iPlayer]:AddNotification(5521344, string, strTitle, -1, -1, gT.GreatPeople[gpID].Type)
							end
						end
					end
				elseif gd.Ability == 51 then
					if (gd.RailroadCD or 0) == 0 then
						gT.Players[iPlayer].NumFreeRailroads = gT.Players[iPlayer].NumFreeRailroads + 1;
						gT.GreatPeople[gpID].RailroadCD = 7
					else
						gT.GreatPeople[gpID].RailroadCD = gT.GreatPeople[gpID].RailroadCD - 1;
					end
				elseif gd.Ability == 58 then
					if LastRandom(1, 100) <= 3 then
						AddFreePalaceUpgrade(iPlayer, 1)
						if Players[iPlayer]:IsHuman() then
							local strTitle = "Palace Upgrade";
							local string = "Most honourable " .. GetGreatPersonName(gpID) .. " funded the Palace Upgrade!";
							Players[iPlayer]:AddNotification(5521344, string, strTitle, -1, -1, gT.GreatPeople[gpID].Type)
						end
					end
				elseif gd.Ability == 58 then
					if LastRandom(1, 100) <= 3 then
						TryToFindNewLuxuryResourceGP(iPlayer, gpID)
					end
				elseif gd.Ability == 62 then
					if LastRandom(1, 100) == 17 then
						local pTab = GetValidTableOfTechs(iPlayer, false, true);
						if #pTab > 0 then
							local iTech = pTab[LastRandom(1,#pTab)];
							if iTech then
								prevMigration = true;
								PlayerDiscoverTech(iPlayer, iTech, nil, "hDT4")
								gT.GreatPeople[gpID].LifeDone = "Discovered the Innovation: " .. Locale.Lookup(GameInfo.Technologies[iTech].Description) .. ".";
								if Players[iPlayer]:IsHuman() then
									local strTitle = Locale.Lookup(GameInfo.Technologies[iTech].Description);
									local string = "Due to extraordinary intelect of " .. GetGreatPersonName(gpID) .. " we have developed new Innovation, " .. Locale.Lookup(GameInfo.Technologies[iTech].Description) .. "!";
									Players[iPlayer]:AddNotification(5521344, string, strTitle, -1, -1, gT.GreatPeople[gpID].Type)
								end
							end
						end
					end
				elseif gd.Ability == 63 then
					if LastChance(7) then
						if not Players[iPlayer]:IsMinorCiv() then
							if not gT.Players[iPlayer].NuclearProjectDone then
								prevMigration = true;
								DoChangeNuclearContribution(iPlayer, 20000)
								gT.GreatPeople[gpID].LifeDone = "Made a great input towards our Nuclear Project.";
								if Players[iPlayer]:IsHuman() then
									local string = "The knowledge " .. GetGreatPersonName(gpID) .. " allowed us to make next step to subdue the power of atom (+200 points towards Nuclear Project)!";
									Players[iPlayer]:AddNotification(5521344, string, "Nuclear Project", -1, -1, gT.GreatPeople[gpID].Type)
								end
							end
						end
					end
				elseif gd.Ability == 64 then
					if LastChance(7) then
						if not gT.Players[iPlayer].SpaceFlightDone then
							prevMigration = true;
							DoChangeSpaceflightContribution(iPlayer, 20000)
							gT.GreatPeople[gpID].LifeDone = "Made a great input towards our Spaceflight Program.";
							if Players[iPlayer]:IsHuman() then
								local string = "The knowledge " .. GetGreatPersonName(gpID) .. " made us closer to achieve unexplored (+200 points towards Spaceflight Program)!";
								Players[iPlayer]:AddNotification(5521344, string, "Spaceflight Program", -1, -1, gT.GreatPeople[gpID].Type)
							end
						end
					end
				elseif gd.Ability == 65 then
					if LastChance(3) then
						local ideoleague = GetIdeologyLeagueOfPlayer(iPlayer)
						if ideoleague then
							prevMigration = true;
							gT.Leagues[ideoleague].Members[iPlayer].BudgetSupport = gT.Leagues[ideoleague].Members[iPlayer].BudgetSupport + 20000;
							gT.Leagues[ideoleague].BudgetTotal = gT.Leagues[ideoleague].BudgetTotal + 20000;
							gT.GreatPeople[gpID].LifeDone = "Popularized our Ideology to the masses.";
							if Players[iPlayer]:IsHuman() then
								local string = "The arrogance of " .. GetGreatPersonName(gpID) .. " has brought into general use the concepts of our ideology (+400 points towards Doctrine)!";
								Players[iPlayer]:AddNotification(5521344, string, "Doctrine", -1, -1, gT.GreatPeople[gpID].Type)
							end
						end
					end
				elseif gd.Ability == 70 then
					if LastRandom(1, 50) == 17 then
						local mechclass = GetMechClassToMakeCheaper(iPlayer)
						if mechclass then
							prevMigration = true;
							local cName = Locale.Lookup(GameInfo.UnitClasses[mechclass].Description)
							gT.GreatPeople[gpID].LifeDone = "Reduced the cost of constructing " .. cName .. " by 15 [ICON_PRODUCTION] Production.";
							Players[iPlayer]:ChangeUnitClassRawProdDiscount(mechclass, -15);
							if Players[iPlayer]:IsHuman() then
								local string = "The bright mind of " .. GetGreatPersonName(gpID) .. " noticed the way to make construction of " .. cName .. " cheaper by 15 [ICON_PRODUCTION] Production!";
								Players[iPlayer]:AddNotification(5521344, string, "Optimization", -1, -1, gT.GreatPeople[gpID].Type)
							end
						end
					end
				elseif gd.Ability == 75 then
					DoChangeSpecializationProgress(iPlayer, 10)
				end
				if not prevMigration then
					prevMigration = GreatCivilianPeopleBonusesTable[gd.Ability].PrevMigration
				end
				if not prevMigration then
					if gT.Players[iPlayer].HasIdeology[63] then
						if ShouldRetireRightNow(gpID, iPlayer) then
							DoGreatPersonRetire(gpID, iPlayer)
							prevMigration = true;
						end
					end
				end
				if not prevMigration then
					if not gd.DoNotMigrate then
						if not HasPlayerGPMigratePrevention(iPlayer) then
							if gd.DoNotMigrateBefore < gTurn then
								if not SpecificGPMigratePrevention(iPlayer, gpID) then
									local mdT = DoTickGPMigration(iPlayer, gpID)
									if mdT then
										table.insert(queueMigration, mdT);
									end
								end
							end
						end
					end
				end
			end
		end
	end
	-- migration after all gp are handled now (charm dirty)
	for a, b in pairs(queueMigration) do
		DoMigrationOfGPCivilian(b[1], b[2], Map.GetPlotByIndex(b[3]):GetPlotCity())
	end
	tempStoredCharm = nil;
end

function GetTempStoredGPCityCharm(cIndex, iCity, iPlayer, cID)
	if tempStoredCharm then
		if not tempStoredCharm[cIndex] then
			tempStoredCharm[cIndex] = math.max(0, GetBaseCityGPAttractiveness(iCity, iPlayer, cID))
		end
		return tempStoredCharm[cIndex]
	else
		return math.max(0, GetBaseCityGPAttractiveness(iCity, iPlayer, cID));
	end
end

function GetGrowthMigrationMeter(iPlayer, gpID)
	if not gT.GreatPeople[gpID].City then
		return 100;
	end
 	local iCity = Map.GetPlotByIndex(gT.GreatPeople[gpID].City):GetPlotCity();
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local base = BASE_GP_MIGRATE_PROGRESS + gT.GreatPeople[gpID].FlavourTravel;
	if gT.Players[iPlayer].HasIdeology[8] then
		base = base + 5;
	end
	if gT.Players[iPlayer].CultBonusOn[140] then
		base = base - 2;
	end
	if gT.Players[iPlayer].HasPlayerWonder[phiCityHall] then
		base = base - 2;
	end
	local charm = GetTempStoredGPCityCharm(gT.GreatPeople[gpID].City, iCity, iPlayer, cID);
	return math.max(1, math.ceil((base) * 100 / (100 + charm)));
end

function DoTickGPMigration(iPlayer, gpID)
	local growthNow = GetGrowthMigrationMeter(iPlayer, gpID)
	gT.GreatPeople[gpID].MigrateMeter = gT.GreatPeople[gpID].MigrateMeter + growthNow;
	if LastRandom(1, 100) <= (gT.GreatPeople[gpID].MigrateMeter - 100) then
		local nCity = GetValidNextTargetToVisitForCivilGP(gpID, iPlayer)
		gT.GreatPeople[gpID].MigrateMeter = 0;
		if nCity then
			return {gpID, iPlayer, nCity:Plot():GetPlotIndex()}
		end
	end
end


function HasPlayerGPMigratePrevention(iPlayer)
	if gT.Players[iPlayer].GPMigrateBlocker then
		if gT.Players[iPlayer].GPMigrateBlocker >= GetITGGameTurn() then
			return true;
		end
	end
	return false;
end

function GetMostOptimalEmpireSizeForGP(pref)
	local base = pref;
	local min, max = 100, 0;
	for g, gdata in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			local size = Players[g]:GetNumCities();
			if size > 0 then
				max = math.max(max, size)
				min = math.min(min, size)
			end
		end
	end
	pref = math.min(max, pref)
	pref = math.max(min, pref)
	return pref;
end

function GetGPAttrFromBuildings(iCity, iOwner, hID)
	return iCity:GetCharm();
end

function GetGPAttrFromLaws(iCity, iPlayer, cID)
	local bChance = 0;
	if not IsHasLaw(iPlayer, 13, 0) then
		bChance = bChance + 10;
	end
	if IsHasLaw(iPlayer, 6, 3) then
		bChance = bChance - 4;
	end
	if IsHasLaw(iPlayer, 30, 2) then
		bChance = bChance - 1;
	end
	if IsHasLaw(iPlayer, 27, 2) then
		bChance = bChance - 4 * #gT.Cities[cID].Academies;
	end	
	if IsHasLaw(iPlayer, 9, 2) then
		if not iCity:IsOccupied() then
			bChance = bChance + GetNumOccupiedCities(iPlayer);
		else
			bChance = bChance - GetNumNonOccupiedCities(iPlayer);
		end
	end
	return bChance;
end

function GetGPAttrFromPalace(iCity, iOwner, hID)
	local bChance = 0;
	if gT.Players[iOwner].PalaceAttraction then
		if gT.Cities[hID].Palace then
			bChance = bChance + 4 * gT.Cities[hID].Palace.NumUpgrades + 5;
		end
	end
	return bChance;
end

function GetGPAttrFromGoverment(iCity, cID, iPlayer)
	local t = 0;
	if gT.Players[iPlayer].AuthorityRank == 1 then
		if gT.Players[iPlayer].GovRewards[4] then
			t = t + 3;
		end
	end
	return t;
end

function GetGPAttrFromManufactories(iCity, iOwner, hID)
	local bChance = 8 * GetNumCityManufactoryTrait(iCity, 31);
	return bChance;
end

function GetGPAttrFromAcademies(iCity, iOwner, hID)
	local bChance = 5 * GetNumCityAcademiesWithAbility(iCity, 65)
	if gT.Cities[hID].AcademyRewards[3] then
		bChance = bChance + 20;
	end
	return bChance;
end

function GetGPAttrFromPlague(iCity, iOwner, hID)
	local bChance = 0;
	if iCity:IsPlague() then
		bChance = bChance - 50;
	end
	return bChance;
end

function GetGPAttrFromResistance(iCity, iPlayer, cID)
	local bChance = 0;
	if iCity:IsResistance() then
		bChance = bChance - 25;
	end
	return bChance;
end

function GetGPAttrFromCapital(iCity, iOwner, hID)
	local bChance = 0;
	if iCity:IsCapital() then
		bChance = bChance + 10;
	end
	return bChance;
end

function GetGPAttrFromPrinciples(iPlayer)
	local b = 0;
	if not IsFirstAtPrinciples(iPlayer) then
		b = b + GetGPFavourFromPrinciplesBackward(iPlayer)
	end
	return b;
end

function GetGPAttrPlayer(iPlayer)
	return gT.Players[iPlayer].ExtraGPAttractions;
end

function GetGPAttrFromSocialDevelopments(iCity, iPlayer, cID)
	local b = 0;
	if gT.Players[iPlayer].CultBonusOn[130] then
		b = b + math.ceil(iCity:GetBuildingDefense() / 100);
	end
	return b;
end

function GetGPAttrFromIdeologies(iCity, iPlayer, cID)
	local b = 0;
	if iCity:GetID() == gT.Players[iPlayer].Ideology62City then
		b = b + 10;
	end
	if gT.Players[iPlayer].HasIdeology[62] then
		if #gT.Cities[cID].CustomsHouses > 0 then
			b = b + 5;
		end
	end
	if gT.Players[iPlayer].HasIdeology[73] then
		local govID = gT.Cities[cID].Governor;
		if gT.Globals.Governors[govID] then
			b = b + math.floor(gT.Globals.Governors[govID].Power / 8);
		end
	end
	return b;
end

function GetCharmFromGreatPeople(iCity, iPlayer, cID)
	local base = GetITGCityInteger(iCity, "CI_CHARM_FROM_GP");
	if HasPlayerTech(iPlayer, tAncCS18, "tAncCS18") then
		base = base + GetITGCityInteger(iCity, "CI_NUM_GP")
	end
	return base;
end

function GetGPAttrFromCityStates(iPlayer)
	local b = 0;
	for i, minor in pairs(gT.Globals.CSbyTypes[GameInfoTypes.MINOR_TRAIT_ENLIGHTENED]) do
		b = b + math.max(0, Players[minor]:GetMinorCivFriendshipLevelWithMajor(iPlayer)) * 2;
	end
	return b;
end

function GetBaseCityGPAttractiveness(iCity, iPlayer, cID)
	local bChance = 20 + gT.Players[iPlayer].AverageHappiness + GetCharmFromGreatPeople(iCity, iPlayer, cID) + GetGPAttrFromBuildings(iCity, iPlayer, cID) + GetGPAttrFromIdeologies(iCity, iPlayer, cID)
	bChance = bChance + GetGPAttrFromCapital(iCity, iPlayer, cID) + GetGPAttrFromPlague(iCity, iPlayer, cID) + GetGPAttrFromAcademies(iCity, iPlayer, cID) + GetGPAttrFromPalace(iCity, iPlayer, cID) + GetGPAttrFromResistance(iCity, iPlayer, cID)
	bChance = bChance + GetGPAttrPlayer(iPlayer) + GetGPAttrFromCityStates(iPlayer) + GetGPAttrFromLaws(iCity, iPlayer, cID) + GetGPAttrFromManufactories(iCity, iPlayer, cID) + GetITGCityInteger(iCity, "CI_GOV_CHARM")
	bChance = bChance + GetGPAttrFromGoverment(iCity, cID, iPlayer) + GetCityGPAttractiveness(iCity, iPlayer, cID) + GetGPAttrFromPrinciples(iPlayer) + GetGPAttrFromSocialDevelopments(iCity, iPlayer, cID)
	return bChance;
end

function GetCityGPAttractiveness(iCity, iPlayer, cID)
	local val = 0;
	if IsHasLaw(iPlayer, 25, 1) then
		if gT.Cities[cID].FestivalET then
			val = val + 8 * gT.Players[iPlayer].Law25Int;
		elseif gT.Players[iPlayer].Law25Int > 0 then
			val = val - 8;
		end
	end
	return val;
end

function GetFavourToTheCity(gpID, iPlayer, iCity)	
	local hID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local iOwner = iCity:GetOwner();
	local bChance = GetBaseCityGPAttractiveness(iCity, iOwner, hID);
	if gT.GreatPeople[gpID].Ability == 26 then
		bChance = bChance - GetITGCityInteger(iCity, "CI_CHARM_FROM_GP");
	elseif gT.GreatPeople[gpID].Ability == 43 or gT.GreatPeople[gpID].Ability == 44 then
		bChance = bChance + 20 * #gT.Cities[hID].Academies;
	elseif gT.GreatPeople[gpID].Ability == 61 then
		if #gT.Cities[hID].CustomsHouses > 0 then
			bChance = bChance + 20;
		end
	elseif gT.GreatPeople[gpID].Ability == 66 then
		if gT.Cities[hID].CanDoWorkboats then
			bChance = bChance + 20;
		end
	end
	if iOwner ~= iPlayer then
		if HasPlayerCHIncomingTrait(iOwner, 12) then
			bChance = bChance + 7;
		end	
	else
		if gT.Players[iPlayer].HasIdeology[8] then
			bChance = bChance - 100;
		end
	end
	if gT.Players[gT.GreatPeople[gpID].OriginPlayer].StAlphabet == iOwner then
		if iOwner ~= iPlayer then
			bChance = bChance + 10;
		end
	end

	if iCity:GetDamage() > 50 then
		if gT.Cities[hID].LastTimeDamaged >= GetRealGameTurn() - 1 then
			bChance = bChance - 2 * gT.GreatPeople[gpID].FearOfWar;
		else
			bChance = bChance - gT.GreatPeople[gpID].FearOfWar;
		end
	end
	if not iCity:Plot():IsRevealed(Players[iPlayer]:GetTeam()) then
		bChance = bChance - 15;
	end
	if gT.Players[iPlayer].CultBonusOn[140] then
		if iCity:GetOwner() == iPlayer then
			bChance = bChance + 15;
		end
	end
	if iCity:IsHasBuilding(bWonder20pnw) then
		if iCity:Plot():GetPlotIndex() ~= gT.GreatPeople[gpID].City then
			bChance = bChance + 25;
		end
	end
	if gT.Cities[hID].Happiness < 0 then
		bChance = bChance - gT.GreatPeople[gpID].HappinessLover;
	else
		bChance = bChance + gT.GreatPeople[gpID].HappinessLover;
	end
	bChance = bChance + gT.GreatPeople[gpID].WonderWhale * gT.Cities[hID].NumWonders
	bChance = bChance + math.ceil(gT.GreatPeople[gpID].FeelMorale * gT.Players[iOwner].Morale);
	bChance = math.abs(iCity:GetPopulation() - gT.GreatPeople[gpID].PrefCityPop)
	bChance = math.abs(Players[iOwner]:GetNumCities() - GetMostOptimalEmpireSizeForGP(gT.GreatPeople[gpID].PrefEmpireSize))

	if iOwner ~= gT.GreatPeople[gpID].OriginPlayer then
		bChance = bChance - gT.GreatPeople[gpID].FavourPatriotism;
	else
		bChance = bChance + gT.GreatPeople[gpID].FavourPatriotism;
	end
	if gT.GreatPeople[gpID].FlavourAuthority ~= 0 then
		bChance = bChance + gT.GreatPeople[gpID].FlavourAuthority * GetBalancedAuthorityPower(iOwner)
	end
	if iCity:Plot():GetPlotIndex() == gT.GreatPeople[gpID].OriginCity then
		bChance = bChance - gT.GreatPeople[gpID].HomeLover;
	else
		bChance = bChance + gT.GreatPeople[gpID].HomeLover;
	end
	if gT.GreatPeople[gpID].Religion then
		if iCity:GetReligiousMajority() == gT.GreatPeople[gpID].Religion then
			bChance = bChance + gT.GreatPeople[gpID].FavourReligion
		else
			bChance = bChance - gT.GreatPeople[gpID].FavourReligion
		end
		if iCity:IsHolyPlaceForReligion(gT.GreatPeople[gpID].Religion) then
			bChance = bChance + gT.GreatPeople[gpID].FavourReligion
		end
	end
	bChance = bChance + LastRandom(-gT.GreatPeople[gpID].FavourUnpredictable, gT.GreatPeople[gpID].FavourUnpredictable);
	return bChance;
end

function GetValidNextTargetToVisitForCivilGP(gpID, iPlayer, bPlayer, bForceByWar)
	local hCity;
	if gT.GreatPeople[gpID].City then
		hCity = gT.GreatPeople[gpID].City;
	end
	local sTab = {}
	local oPlayer = gT.GreatPeople[gpID].OriginPlayer;
	local cTypeOnly;
	if not GetDBCulturePlayerInfo(oPlayer, "CanMigrateToOther") then
		cTypeOnly = gT.Players[oPlayer].CultureType
	end
	local boPlayer;
	if not bForceByWar then
		if (gT.Players[iPlayer].GPDoNotMigrateAway > 0) or gT.GreatPeople[gpID].DoNotTravelAway then
			if oPlayer == iPlayer then
				boPlayer = iPlayer;
			end
		elseif gT.GreatPeople[gpID].TravelTo then
			boPlayer = gT.GreatPeople[gpID].TravelTo;
		end
	end
	gT.GreatPeople[gpID].TravelTo = nil; -- this should be interrupted by war
	local iTeam = Players[iPlayer]:GetTeam();
	for g, gdata in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			if bPlayer ~= g and ((not boPlayer) or (boPlayer == g)) then
				if (not cTypeOnly) or (cTypeOnly == gdata.CultureType) then 
					if iPlayer == g or Teams[Players[g]:GetTeam()]:IsHasMet(iTeam) then
						for iCity in Players[g]:Cities() do
							if iCity:Plot():GetPlotIndex() ~= hCity then
								local cfavour = math.max(1, GetFavourToTheCity(gpID, g, iCity)); 
								table.insert(sTab, {iCity, cfavour})
							end
						end
					end
				end
			end
		end
	end 
	if #sTab > 0 then
		local tCity = GetRandomFromBiasedChanceTable(sTab);
		if not bForceByWar then --disable migration random stuff
			if tCity:GetOwner() ~= iPlayer then
				if HasPlayerTech(iPlayer, ancCSt30, "76543fvth") then
					if LastChance(33) then
						return nil;
					end
				end	
				if gT.Players[iPlayer].HasIdeology[79] then
					if LastChance(50) then
						return nil;
					end
				end
			end
		end
		return tCity;
	end
	return nil;
end

function ClearTheVisionModifierAndLabel(iPlayer, gpID)
	if gT.GreatPeople[gpID].Visibility then
		local iTeam = Players[iPlayer]:GetTeam();
		for h, hPlot in pairs(GetPlotsInRadiusOfPlot(Map.GetPlotByIndex(gT.GreatPeople[gpID].Visibility), 3)) do
			hPlot:ChangeVisibilityCount(iTeam, -1)
		end
		gT.GreatPeople[gpID].Visibility = nil;
	end
	if gT.GreatPeople[gpID].LabelPosition then
		RemoveLabelOnPlot(Map.GetPlotByIndex(gT.GreatPeople[gpID].LabelPosition), "GreatExplorer", nil, nil, iPlayer)
		gT.GreatPeople[gpID].LabelPosition = nil;
	end
end

function AddNewExplorationPointToDiscover(iPlayer, gpID)
	gT.GreatPeople[gpID].DiscoveryCooldown = LastRandom(7, 9);
	local iPlot = GetNicePlotForExploreActionGPCivil(iPlayer);
	if iPlot then
		gT.GreatPeople[gpID].Visibility = iPlot:GetPlotIndex()
		local iTeam = Players[iPlayer]:GetTeam();
		local sTab = GetPlotsInRadiusOfPlot(iPlot, 3);
		for h, hPlot in pairs(sTab) do
			hPlot:ChangeVisibilityCount(iTeam, 1)
			local iPlotIndex = hPlot:GetPlotIndex();
			if gT.Globals.AncientRuins[iPlotIndex] then
				if not hPlot:AlreadyVisitedGoodyHut(iTeam) then
					AncientRuinsSetXY(iPlayer, nil, hPlot, iPlotIndex, nil)
				end
			end
		end
		if Players[iPlayer]:IsHuman() then --Game.GetActivePlayer() == iPlayer then
			gT.GreatPeople[gpID].LabelPosition = iPlot:GetPlotIndex()
			AddSmallInfo(iPlot, nil, "GreatExplorer", nil, nil, nil, nil, iPlayer)
		end
	end
end

function GetNicePlotForExploreActionGPCivil(iPlayer)
	local iTeam = iPlayer;
	local sTab = {}
	for b = 0, Map:GetNumPlots() - 1, 1 do
		local fPlot = Map.GetPlotByIndex( b );
		if not fPlot:IsRevealed(iTeam) then
			if not fPlot:IsWater() then
				local val = 1;
				if fPlot:IsCity() then
					val = val + 25;
				end
				if fPlot:IsMountain() then
					val = val + 5;
				end
				if gT.Globals.AncientRuins[b] then
					val = val + 25;
				end
				table.insert(sTab, {fPlot, val})
			end
		end
	end
	if #sTab > 0 then
		return GetRandomFromBiasedChanceTable(sTab)
	else
		return nil;
	end
end

function TakeCareOfGPCapture(iCity, cID, newPlayer, jPlayer, bFriendly)
	local cpIndex = iCity:Plot():GetPlotIndex();
	for gpID, hhh in pairs(gT.Players[jPlayer].GreatPeople) do
		local gd = gT.GreatPeople[gpID];
		if gd.Alive and (not gd.Military) then
			if gd.City == cpIndex then
				if bFriendly or (gd.OriginPlayer == newPlayer) then
					AssignNewCivilianGPToThePlayer(gpID, newPlayer, true)
					RemoveCivilianGPFromThePlayer(gpID, jPlayer, "Captured")
				else
					local bcont = true;
					if gT.Players[newPlayer].HasIdeology[58] then
						if gd.Science then
							DoCaptureGPCivil(gpID, newPlayer, jPlayer, iCity)
							bcont = false;
						end
					end
					if bcont then
						local chancetodie = 150;
						local chancetoflee = 500;
						if gd.OriginPlayer == jPlayer then
							chancetodie = 330;
							chancetoflee = 1000;
						end
						if LastRandom(1, 1000) <= chancetodie then
							KillGreatPerson(gpID, true)
							if jPlayer == Game.GetActivePlayer() then
								local strTitle = "Great Person killed!";
								local string = GetGreatPersonName(gpID) .. " died during street fights in " .. iCity:GetName() .. "!";
								Players[jPlayer]:AddNotification(54126774, string, strTitle, -1, -1, gT.GreatPeople[gpID].Type)
							end
							if Players[newPlayer]:IsHuman() then
								if iCity:GetOriginalOwner() ~= newPlayer then
									if gT.GreatPeople[gpID].OriginPlayer == newPlayer then
										LuaEvents.ITG_AchievementCompleted(119)
									end
								end
							end
						else
							if LastRandom(1, 1000) <= chancetoflee then
								local nCity = GetValidNextTargetToVisitForCivilGP(gpID, jPlayer, newPlayer, true)
								if nCity then
									DoMigrationOfGPCivilian(gpID, jPlayer, nCity, true)
								else
									DoCaptureGPCivil(gpID, newPlayer, jPlayer, iCity)
								end
							else
								DoCaptureGPCivil(gpID, newPlayer, jPlayer, iCity)
							end
						end
					end
				end
			end
		end
	end
	DirtyProductionFromGPInACity(iCity, newPlayer)
end

function DoCaptureGPCivil(gpID, newPlayer, jPlayer, iCity)
	AssignNewCivilianGPToThePlayer(gpID, newPlayer, true)
	RemoveCivilianGPFromThePlayer(gpID, jPlayer, "Captured")
	gT.GreatPeople[gpID].DoNotMigrateBefore = GetITGGameTurn() + LastRandom(6, 12);
	if jPlayer == Game.GetActivePlayer() then
		local strTitle = "Great Person captured!";
		local string = GetGreatPersonName(gpID) .. " did not flee from " .. iCity:GetName() .. " in time, becoming a prisoner of new reign!";
		Players[jPlayer]:AddNotification(54126774, string, strTitle, -1, -1, gT.GreatPeople[gpID].Type)
	end
end

function GetBuildingToMakeFree(cCity)
	local posTab = {}
	for row in GameInfo.Buildings() do
		if row.GoldMaintenance > 0 then
			if cCity:GetNumRealBuilding(row.ID) == 1 then
				table.insert(posTab, row.ID)
			end
		end
	end
	if #posTab > 0 then
		return posTab[LastRandom(1,#posTab)]
	end
	return nil;
end

function GetChanceForGPToRetire(gpID, iPlayer)
	local chance = math.floor(GetITGGameTurn() - gT.GreatPeople[gpID].Ascendancy); --num turns alive?
	if gT.GreatPeople[gpID].LifeDone then
		chance = chance + 35;
	end
	if (gT.Players[iPlayer].GPRetiredTD or -1) >= GetITGGameTurn() then
		return chance;
	end
	return chance * 5;
end

function ShouldRetireRightNow(gpID, iPlayer)
	return LastRandom(1, 1000) <= GetChanceForGPToRetire(gpID, iPlayer);
end

--  local HelpTalentGPString = {1, 2, "Scientist", "Engineer", "Statesman", "Musician", "Writer", "Artist", "Philosopher", "Prophet"}
function DoGreatPersonRetire(gpID, iPlayer)
	gT.GreatPeople[gpID].Retired = true;
	gT.Players[iPlayer].GPRetiredTD = GetITGGameTurn() + 10;
	gT.Players[iPlayer].RetiredGPPoints = gT.Players[iPlayer].RetiredGPPoints + 7;
	local sbonus2;
	if gT.GreatPeople[gpID].Type == 3 then
		ChangeITGScience(iPlayer, 250)
		sbonus2 = ", +250 [ICON_RESEARCH] Science"
	elseif gT.GreatPeople[gpID].Type == 4 then
		if gT.Globals.NoMoreWonderRace then
			IncreaseWorkRateInAllCities(iPlayer, 500)
			sbonus2 = ", +500 [ICON_WORKER] Work Rate in all Cities"
		else
			BoostWonderProduction(iPlayer, 200, false)
			sbonus2 = ", +200 [ICON_GREAT_ENGINEER] Wonder points"
		end
	elseif gT.GreatPeople[gpID].Type == 5 then
		ChangeITGGold(iPlayer, 300)
		sbonus2 = ", +300 [ICON_GOLD] Gold"
	elseif gT.GreatPeople[gpID].Type == 6 or gT.GreatPeople[gpID].Type == 7 or gT.GreatPeople[gpID].Type == 8 then
		ChangeITGCulture(iPlayer, 250)
		sbonus2 = ", +250 [ICON_CULTURE] Culture"
	elseif gT.GreatPeople[gpID].Type == 9 then
		BoostHappinessInAllCities(iPlayer, 1)
		sbonus2 = ", +1 [ICON_HAPPINESS_1] Happiness in all Cities"
	end
	KillGreatPerson(gpID)
	if Players[iPlayer]:IsHuman() then
		local strTitle = GetGreatPersonName(gpID) .. " retired";
		local string = GetGreatPersonName(gpID) .. " decided to retire, leaving a scene for new bright minds (+7 [ICON_GREAT_PEOPLE] Great People points per turn" .. sbonus2 .. ").";
		Players[iPlayer]:AddNotification(13551235, string, strTitle, -1, -1, gT.GreatPeople[gpID].Type, 18)
	end
end

function DoSuccessfulHeadhunter(gpID, nPlayer, bAuctionHouse)
	local nCity;
	if not bAuctionHouse then
		gT.Players[nPlayer].HeadhuntingDone = gT.Players[nPlayer].HeadhuntingDone + 1;
		gT.GreatPeople[gpID].Headhunted = true;
		gT.GreatPeople[gpID].DoNotMigrate = true;
		nCity = Players[nPlayer]:GetCapitalCity();
	else
		nCity = GetRandomCity(nPlayer)
		gT.GreatPeople[gpID].DoNotMigrateBefore = math.max(gT.GreatPeople[gpID].DoNotMigrateBefore, GetITGGameTurn() + 4);
	end
	local iPlayer = gT.GreatPeople[gpID].Player
	local oldIndex = gT.GreatPeople[gpID].City;
	if gT.GreatPeople[gpID].City then
		RemoveGPCivilFromTheCity(gpID, Map.GetPlotByIndex(gT.GreatPeople[gpID].City):GetPlotCity(), iPlayer)
	end
	RemoveCivilianGPFromThePlayer(gpID, iPlayer, "Migration")
	if Players[iPlayer]:IsHuman() then
		local strTitle = "Emigration";
		local string = "It seems that " .. GetGreatPersonName(gpID) .. " got bribed by our rival, " .. Players[nPlayer]:GetName() .. ". Absolutely disgusting.";
		Players[iPlayer]:AddNotification(13551235, string, strTitle, -1, -1, gT.GreatPeople[gpID].Type, 20)
	end
	AssignNewCivilianGPToThePlayer(gpID, nPlayer, true)
	if Players[nPlayer]:IsHuman() then
		local strTitle = "Invitation";
		local string = GetGreatPersonName(gpID) .. " proudly announced changing occupation to " .. nCity:GetName() .. " (" .. GetCivilianGPAbilityHelp(gpID) .. ").";
		Players[nPlayer]:AddNotification(13551235, string, strTitle, -1, -1, gT.GreatPeople[gpID].Type, 19)
	end
	AssignGPCivilToTheCity(gpID, nCity, nPlayer)
	LogTravelForGP(gpID, iPlayer, oldIndex)
	gT.GreatPeople[gpID].NumTravels = (gT.GreatPeople[gpID].NumTravels or 0) + 1;
end

LuaEvents.ITG_RequestCenterGP.Add(function(gpID)
	if gT.GreatPeople[gpID] then
		local iPlayer = Game.GetActivePlayer()
		if gT.GreatPeople[gpID].Alive and (gT.GreatPeople[gpID].Player == iPlayer) then
			if gT.GreatPeople[gpID].City then
				UI.LookAt(Map.GetPlotByIndex(gT.GreatPeople[gpID].City));
			elseif gT.GreatPeople[gpID].LabelPosition then
				UI.LookAt(Map.GetPlotByIndex(gT.GreatPeople[gpID].LabelPosition));
			elseif gT.GreatPeople[gpID].Military then
				for iUnit in Players[iPlayer]:Units() do
					local uID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
					if gT.Players[iPlayer].UnitsByID[uID] then
						if gT.Players[iPlayer].UnitsByID[uID].GreatPersonID == gpID then
							UI.LookAt(iUnit:GetPlot())
							break;
						end
					end
				end
			end
		end
	end
end)

function GetValidGPForGovernorToInvite(iPlayer, tPlayer)
	local iTurn = GetITGGameTurn()
	local tab = {}
	if HasPlayerGPMigratePrevention(iPlayer) then
		return;
	end
	for gpID, hhh in pairs(gT.Players[iPlayer].GreatPeople) do
		local gd = gT.GreatPeople[gpID];
		if gd.Alive and (not gd.Military) then
			if (not gd.LifeDone) and (not GreatCivilianPeopleBonusesTable[gd.Ability].PrevMigration) then
				if gd.DoNotMigrateBefore < iTurn then
					if (gT.Players[iPlayer].GPDoNotMigrateAway > 0) or gd.DoNotTravelAway then
						if not SpecificGPMigratePrevention(iPlayer, gpID) then
							if gd.MigrateMeter > 100 then
								table.insert(tab, gpID)
							end
						end
					end
				end
			end
		end
	end
	if #tab > 0 then
		return tab[LastRandom(1,#tab)];
	end
end

function GetNumAliveGPTotal(iPlayer) -- GetNumGP
	return GetNumOfGPCivilOfType(iPlayer, 1) + GetNumOfGPCivilOfType(iPlayer, 2) + GetNumOfGPCivilOfType(iPlayer)
end

function GetNumOfGPCivilOfType(iPlayer, type)
	if not type then
		return gT.Players[iPlayer].NumCivilGP;
	else
		return gT.Players[iPlayer].NumGPType[type] or 0;
	end
end

function GreatPeopleAmountDirty(iPlayer)
	gT.Players[iPlayer].NumCivilGP = 0;
	gT.Players[iPlayer].NumGPArtStyles = 0;
	gT.Players[iPlayer].GPArtStyles = {}
	gT.Players[iPlayer].NumGPType = {};
	gT.Players[iPlayer].NumUniqueGPTypes = 0;
	local bCareAboutArtStyle = false;
	if gT.Players[iPlayer].HasIdeology[60] then
		bCareAboutArtStyle = true;
	end
	for gpID, hhh in pairs(gT.Players[iPlayer].GreatPeople) do
		local gd = gT.GreatPeople[gpID];
		if gd.Alive then
			if (not gd.Military) then
				gT.Players[iPlayer].NumCivilGP = gT.Players[iPlayer].NumCivilGP + 1;
			end
			gT.Players[iPlayer].NumGPType[gd.Type] = 1 + (gT.Players[iPlayer].NumGPType[gd.Type] or 0);
			if gT.Players[iPlayer].NumGPType[gd.Type] == 1 then
				gT.Players[iPlayer].NumUniqueGPTypes = gT.Players[iPlayer].NumUniqueGPTypes + 1;
			end
			if bCareAboutArtStyle then
				if gd.CultEra then
					if not gT.Players[iPlayer].GPArtStyles[gd.CultEraType] then
						gT.Players[iPlayer].GPArtStyles[gd.CultEraType] = {[gd.CultEra] = 1};
						gT.Players[iPlayer].NumGPArtStyles = gT.Players[iPlayer].NumGPArtStyles + 1;
					elseif not gT.Players[iPlayer].GPArtStyles[gd.CultEraType][gd.CultEra] then
						gT.Players[iPlayer].GPArtStyles[gd.CultEraType][gd.CultEra] = 1;
						gT.Players[iPlayer].NumGPArtStyles = gT.Players[iPlayer].NumGPArtStyles + 1;
					else
						gT.Players[iPlayer].GPArtStyles[gd.CultEraType][gd.CultEra] = gT.Players[iPlayer].GPArtStyles[gd.CultEraType][gd.CultEra] + 1;
					end
				end
			end
		end
	end
end

function IsCurrentArtStyleRepresented(iPlayer)
	if gT.Players[iPlayer].GPArtStyles[gT.Players[iPlayer].CultureType] then
		if gT.Players[iPlayer].GPArtStyles[gT.Players[iPlayer].CultureType][gT.Players[iPlayer].CultureEra] then
			return true;
		end
	end
	return false;
end

function SpecificGPMigratePrevention(iPlayer, gpID)
	if not gT.GreatPeople[gpID].City then
		return false;
	end
	if gT.GreatPeople[gpID].DoNotMigrate then
		return true;
	end
	if gT.Players[iPlayer].HasIdeology[60] then
		if gT.GreatPeople[gpID].CultEra then
			if gT.Players[iPlayer].GPArtStyles[gT.GreatPeople[gpID].CultEraType][gT.GreatPeople[gpID].CultEra] == 1 then
				return true;
			end
		end
	end
	local iCity = Map.GetPlotByIndex(gT.GreatPeople[gpID].City):GetPlotCity();
	if iCity:IsHasBuilding(GameInfoTypes.BUILDING_ITG_NEW_WORLD_WONDER_19) then
		return true;
	end
	if gT.Players[iPlayer].HasPlayerWonder[mahabodhitemple1] then
		if gT.GreatPeople[gpID].Religion == GetITGReligion(iPlayer) then
			return true;
		end
	end
	return false;
end

function GetGPChanceScientistFromBuildings(iPlayer)
	return Players[iPlayer]:GetBuildingClassCount(GameInfoTypes.BUILDINGCLASS_UNIVERSITY) * 5;
end

function GetChanceForGPToBeScientist(iPlayer, bPoints)
	local base = GetCommonGPChance(iPlayer, 3, true) + GetGPChanceScientistFromBuildings(iPlayer)
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_ARAB_5, "deade") then
		base = base + 100;
	end
	if IsHasLaw(iPlayer, 30, 1) then
		base = base + 50;
	end
	base = base + gT.Players[iPlayer].AHScienceComp * 10;
	return base;
end
function GetChanceForGPToBeEngineer(iPlayer, bPoints)
	local base = GetCommonGPChance(iPlayer, 4, true)
	if IsHasLaw(iPlayer, 30, 2) then
		base = base + 50;
	end
	return base;
end
function GetChanceForGPToBeStatesman(iPlayer, bPoints)
	local base = GetCommonGPChance(iPlayer, 5, true)
	if IsHasLaw(iPlayer, 30, 3) then
		base = base + 50;
	end
	return base;
end
function GetChanceForGPToBeMusician(iPlayer, bPoints)
	local base = GetCommonGPChance(iPlayer, 6, false) + GetMusicianChanceFromBuildings(iPlayer)
	if bPoints then
		base = base + math.ceil((gT.Players[iPlayer].GreatPeopleFavourType[6] or 0) / 3);
	end
	if IsHasLaw(iPlayer, 30, 4) then
		base = base + 20;
	end
	return base;
end
function GetChanceForGPToBeWriter(iPlayer, bPoints)
	local base = GetCommonGPChance(iPlayer, 7, false) + GetWriterChanceFromBuildings(iPlayer)
	if bPoints then
		base = base + math.ceil((gT.Players[iPlayer].GreatPeopleFavourType[6] or 0) / 3);
	end
	if IsHasLaw(iPlayer, 30, 4) then
		base = base + 40;
	end
	return base;
end
function GetChanceForGPToBeArtist(iPlayer, bPoints)
	local base = GetCommonGPChance(iPlayer, 8, false) + GetArtistChanceFromBuildings(iPlayer)
	if bPoints then
		base = base + math.ceil((gT.Players[iPlayer].GreatPeopleFavourType[6] or 0) / 3);
	end
	if IsHasLaw(iPlayer, 30, 4) then
		base = base + 40;
	end
	return base;
end
function GetChanceForGPToBePhilosopher(iPlayer, bPoints)
	local base = GetCommonGPChance(iPlayer, 9, bPoints)
	if HasPlayerTech(iPlayer, arabtrial7, "Yqwrqwrdfa") then
		base = base * 2;
	end
	if HasPlayerTech(iPlayer, indo17inno, "daedadeae") then
		base = 0
	end
	return base;
end
function GetChanceForGPToBeSeer(iPlayer, bPoints)
	local base = GetCommonGPChance(iPlayer, 10, bPoints)
	base = base - 50; -- seer base is only 50;
	return base;
end
function GetCommonGPChance(iPlayer, type, bPoints)
	local base = 100 + GetChanceForGPFromExisting(iPlayer, type);
	if HasPlayerTech(iPlayer, trialAsia8, "trialAsia8") then
		if GetNumOfGPCivilOfType(iPlayer, type) == 0 then
			base = base + 100;
		end
	end
	if bPoints then
		base = base + (gT.Players[iPlayer].GreatPeopleFavourType[type] or 0);
	end
	return base;
end
function GetChanceForGPFromExisting(iPlayer, type)
	local val = 0;
	for gpID, sth in pairs(gT.Players[iPlayer].GreatPeople) do
		if gT.GreatPeople[gpID].ICTAO and (gT.GreatPeople[gpID].Alive) and (gT.GreatPeople[gpID].Type == type) then
			val = val + 30;
		end
	end
	return val;
end
function GetRandomGPTypeNow(iPlayer, bPoints)
	return GetRandomFromBiasedChanceTable(GetTabOfGPChances(iPlayer, bPoints));
end

function GetTabOfGPChances(iPlayer, bPoints)
	local hTab = {
		{3, GetChanceForGPToBeScientist(iPlayer, bPoints)}, 
		{4, GetChanceForGPToBeEngineer(iPlayer, bPoints)}, 
		{5, GetChanceForGPToBeStatesman(iPlayer, bPoints)}, 
		{6, GetChanceForGPToBeMusician(iPlayer, bPoints)}, 
		{7, GetChanceForGPToBeWriter(iPlayer, bPoints)}, 
		{8, GetChanceForGPToBeArtist(iPlayer, bPoints)}, 
		{9, GetChanceForGPToBePhilosopher(iPlayer, bPoints)}
	}
	if gT.Players[iPlayer].HasPlayerWonder[oracleW] and (gT.Globals.GameGenerated) then
		table.insert(hTab, {10, GetChanceForGPToBeSeer(iPlayer, bPoints)})
	end
	if gT.Players[iPlayer].HasIdeology[80] then
		table.insert(hTab, {1, 100})
		table.insert(hTab, {2, 100})
	end
	return hTab;
end

function GetNiceGPString(type)
	return (lSgreatpeopleData[type].FontIcon or "[ICON_GREAT_PEOPLE]") .. " " .. TableOfGreatStringCivilGP[type]
end

function PrepareChancesToolTipsGP(iPlayer)
	local hTab = GetTabOfGPChances(iPlayer, true)
	local total = 0;
	local bHasTrialAsia8 = HasPlayerTech(iPlayer, trialAsia8, "trialAsia8")
	for a, b in pairs(hTab) do
		total = total + b[2];
		hTab[a][3] = "Chance for new " .. (lSgreatpeopleData[b[1]].FontIcon or "[ICON_GREAT_PEOPLE]") .. " " .. TableOfGreatStringCivilGP[b[1]] .. ":"
		if b[1] == 10 then
			hTab[a][3] = hTab[a][3] .. "[NEWLINE][ICON_BULLET]50 from Base" 
		else
			hTab[a][3] = hTab[a][3] .. "[NEWLINE][ICON_BULLET]100 from Base" 
		end
		hTab[a][4] = (lSgreatpeopleData[b[1]].FontIcon or "[ICON_GREAT_PEOPLE]")
		local iOT = GetChanceForGPFromExisting(iPlayer, b[1])
		if iOT ~= 0 then
			hTab[a][3] = hTab[a][3] .. "[NEWLINE][ICON_BULLET]" .. iOT .. " from Great People" 
		end
		local hValF = 0;
		if b[1] == 6 or b[1] == 7 or b[1] == 8 then
			hValF = math.ceil((gT.Players[iPlayer].GreatPeopleFavourType[6] or 0) / 3);
		else
			hValF = (gT.Players[iPlayer].GreatPeopleFavourType[b[1]] or 0)
		end
		if hValF ~= 0 then
			hTab[a][3] = hTab[a][3] .. "[NEWLINE][ICON_BULLET]" .. hValF .. " from Points Sources" 
		end
		if bHasTrialAsia8 and (b[1] > 2) then
			if GetNumOfGPCivilOfType(iPlayer, b[1]) == 0 then
				hTab[a][3] = hTab[a][3] .. "[NEWLINE][ICON_BULLET]100 from Imperial examination" 
			end
		end
	end
	local sTab = {{},{},{},{},{},{},{},{},{},{}}
	--all the special help strings
	local iSCfB = GetGPChanceScientistFromBuildings(iPlayer);
	local iaRTfB = GetArtistChanceFromBuildings(iPlayer);
	local imusicfB = GetMusicianChanceFromBuildings(iPlayer);
	local iwriterfB = GetWriterChanceFromBuildings(iPlayer);
	if iSCfB ~= 0 then
		table.insert(sTab[3], iSCfB .. " from Buildings")
	end
	if imusicfB ~= 0 then
		table.insert(sTab[6], imusicfB .. " from Buildings")
	end
	if iwriterfB ~= 0 then
		table.insert(sTab[7], iwriterfB .. " from Buildings")
	end
	if iaRTfB ~= 0 then
		table.insert(sTab[8], iaRTfB .. " from Buildings")
	end
	if gT.Players[iPlayer].AHScienceComp > 0 then
		table.insert(sTab[3], 10 * gT.Players[iPlayer].AHScienceComp  .. " from Science Competitions")
	end
	if IsHasLaw(iPlayer, 30, 1) then
		table.insert(sTab[3], "50 from Laws")
	elseif IsHasLaw(iPlayer, 30, 2) then
		table.insert(sTab[4], "50 from Laws")
	elseif IsHasLaw(iPlayer, 30, 3) then
		table.insert(sTab[5], "50 from Laws")
	elseif IsHasLaw(iPlayer, 30, 4) then
		table.insert(sTab[6], "20 from Laws")
		table.insert(sTab[7], "20 from Laws")
		table.insert(sTab[8], "20 from Laws")
	end
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_ARAB_5, "deade") then
		table.insert(sTab[3], "100 from Innovation")
	end
	if HasPlayerTech(iPlayer, arabtrial7, "Yqwrqwrdfa") then
		table.insert(sTab[9], "+100% from Innovation")
	end
	if HasPlayerTech(iPlayer, indo17inno, "daedadeae") then
		table.insert(sTab[9], "Set to 0 by Innovation") --? not visible anyway
	end
	--
	for a, b in pairs(hTab) do
		hTab[a][2] = math.floor(b[2] / total * 1000) / 10
		for c, d in pairs(sTab[b[1]]) do
			hTab[a][3] = hTab[a][3] .. "[NEWLINE][ICON_BULLET]" .. d;
		end
	end
	MapModData.ITGSG = hTab
end
LuaEvents.ITGSG_RequestGPChances.Add(PrepareChancesToolTipsGP)

function GenerateGPYieldString(gpID)
	local hString = ""
	if (gT.GreatPeople[gpID].Production or 0) > 0 then
		hString = hString .. gT.GreatPeople[gpID].Production .. "[ICON_PRODUCTION] "
	end
	if (gT.GreatPeople[gpID].HapChance or 0) > 0 then
		hString = hString .. gT.GreatPeople[gpID].HapChance .. "%[ICON_HAPPINESS_1] "
	end
	return hString;
end

function GenerateGPMigrationToolTipData(gpID)
	local iActivePlayer = Game.GetActivePlayer();
	local iOwner = gT.GreatPeople[gpID].Player
	if (iActivePlayer ~= iOwner) or (gT.GreatPeople[gpID].Military) or (not gT.GreatPeople[gpID].City) then
		return {false, "", ""}
	end
	if (gT.GreatPeople[gpID].DoNotMigrate) or (gT.GreatPeople[gpID].LifeDone) then
		return {false, "Does not migrate.", "This Great Person does not migrate."}
	end
	local hText = ""
	local hToolTip = "Current migration progress: " .. gT.GreatPeople[gpID].MigrateMeter .. "[ICON_TOURISM].[NEWLINE][NEWLINE]"
	hToolTip = hToolTip .. "Base migration growth: +" .. BASE_GP_MIGRATE_PROGRESS .. "[ICON_TOURISM].[NEWLINE]"
	hToolTip = hToolTip .. "Personality: +" .. gT.GreatPeople[gpID].FlavourTravel .. "[ICON_TOURISM].[NEWLINE]"
	if gT.Players[iOwner].HasIdeology[8] then
		hToolTip = hToolTip .. "Equality-Mediocrity: +5[ICON_TOURISM].[NEWLINE]"
	end
	if gT.Players[iOwner].CultBonusOn[140] then
		hToolTip = hToolTip .. "Eternal Glory: -2[ICON_TOURISM].[NEWLINE]"
	end
	if gT.Players[iOwner].HasPlayerWonder[phiCityHall] then
		hToolTip = hToolTip .. "Philadelphia City Hall: -2[ICON_TOURISM].[NEWLINE]"
	end
 	local iCity = Map.GetPlotByIndex(gT.GreatPeople[gpID].City):GetPlotCity();
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local charm = GetTempStoredGPCityCharm(gT.GreatPeople[gpID].City, iCity, iOwner, cID);
	local iPercentCharm = math.floor(100 * (1 - 100 / (100 + charm)));
	hToolTip = hToolTip .. "City's [ICON_ITG_CHARM] Charm: -" .. iPercentCharm .. "%[ICON_TOURISM].[NEWLINE]"
	local hGrowthCalc = GetGrowthMigrationMeter(iOwner, gpID);
	hToolTip = hToolTip .. "[NEWLINE]TOTAL: [COLOR_NEGATIVE_TEXT]+" .. hGrowthCalc .. "[ENDCOLOR][ICON_TOURISM]." 
	local bGrowthPrevented = false;
	local gTurn = GetITGGameTurn();
	--SPECIAL ABILITIES PREVENTING GROWTH
	if gT.Players[iOwner].HasIdeology[63] then
		hToolTip = hToolTip .. "[NEWLINE][NEWLINE]Has " .. GetChanceForGPToRetire(gpID, iOwner) .. "% chance to retire next turn.";
	end
	if gT.Players[iOwner].GPMigrateBlocker then
		if gT.Players[iOwner].GPMigrateBlocker >= gTurn then
			hToolTip = hToolTip .. "[NEWLINE][NEWLINE]Migration is inactive due to player's modifier (" .. (gT.Players[iOwner].GPMigrateBlocker + 1 - gTurn) .. "T)."
			hText = "Disabled (" .. (gT.Players[iOwner].GPMigrateBlocker + 1 - gTurn) .. "T)."
			bGrowthPrevented = true;
		end
	end
	if gT.GreatPeople[gpID].DoNotMigrateBefore >= gTurn then
		hToolTip = hToolTip .. "[NEWLINE][NEWLINE]Migration is inactive due to great person's modifier (" .. (gT.GreatPeople[gpID].DoNotMigrateBefore + 1 - gTurn) .. "T)."
		hText = "Disabled (" .. (gT.GreatPeople[gpID].DoNotMigrateBefore + 1 - gTurn) .. "T)."
		bGrowthPrevented = true;
	end
	if gT.Players[iOwner].HasIdeology[60] then
		if gT.GreatPeople[gpID].CultEra then
			if gT.Players[iOwner].GPArtStyles[gT.GreatPeople[gpID].CultEraType][gT.GreatPeople[gpID].CultEra] == 1 then
				hToolTip = hToolTip .. "[NEWLINE][NEWLINE]Migration is disabled by Cultural amalgamation.";
				hText = "No migration (Ideology)."
				bGrowthPrevented = true;
			end
		end
	end
	if iCity:IsHasBuilding(GameInfoTypes.BUILDING_ITG_NEW_WORLD_WONDER_19) then
		hToolTip = hToolTip .. "[NEWLINE][NEWLINE]Migration is disabled by Globe Theater.";
		hText = "No migration (Wonder)."
		bGrowthPrevented = true;
	end
	if gT.Players[iOwner].HasPlayerWonder[mahabodhitemple1] then
		if gT.GreatPeople[gpID].Religion == GetITGReligion(iOwner) then
			hToolTip = hToolTip .. "[NEWLINE][NEWLINE]Migration is disabled by Mahabodhi Temple.";
			hText = "No migration (Wonder)."
			bGrowthPrevented = true;
		end
	end

	--SPECIAL ABILITIES AFFECTING MIGRATION
	if (gT.Players[iOwner].GPDoNotMigrateAway > 0) or gT.GreatPeople[gpID].DoNotTravelAway then
		hToolTip = hToolTip .. "[NEWLINE][NEWLINE]Will not migrate abroad.";
	else
		if HasPlayerTech(iOwner, ancCSt30, "76543fvth") then
			hToolTip = hToolTip .. "[NEWLINE][NEWLINE]There is 33% chance that Great Person will change mind before migrating abroad (migration meter will resets to 0).";
		end	
		if gT.Players[iOwner].HasIdeology[79] then
			hToolTip = hToolTip .. "[NEWLINE][NEWLINE]There is 50% chance that Great Person will be prevented from migrating abroad (migration meter will resets to 0).";
		end
	end
	if not bGrowthPrevented then
		local migchance = math.max(0, math.min(100, gT.GreatPeople[gpID].MigrateMeter + hGrowthCalc - 100));
		hToolTip = hToolTip .. "[NEWLINE][NEWLINE]Next turn there is " .. migchance .. "% chance for this [ICON_GREAT_PEOPLE] Great Person to migrate."
		hText = "[ICON_TOURISM] Migration: " .. migchance .. "%."
	else
		hGrowthCalc = 0;
	end
	return {true, hText, hToolTip, gT.GreatPeople[gpID].MigrateMeter, hGrowthCalc}
end

function GetCityGPTab(iCity)
	local tab = {};
	local iIndex = iCity:Plot():GetPlotIndex();
	for gpID, data in pairs(gT.GreatPeople) do
		if (data.City == iIndex) then
			if not (data.Alive) then
				print("Error 953/23532/12", gpID, iIndex)
			end
			local gpTab = {Name = GetGPName(gpID), IconAtlas = GetGPDataOrAlt(data.Type, "IconAtlas"), PIndex = GetGPDataOrAlt(data.Type, "PortraitIndex"),
			YieldCityString = GenerateGPYieldString(gpID), MigrationData = GenerateGPMigrationToolTipData(gpID)}
			table.insert(tab, gpTab);
		end
	end
	MapModData.ITGSG = tab
end
LuaEvents.ITGSG_RequestCityGreatPeople.Add(GetCityGPTab)

function GetGPInfoForOverview(gpID)
	local v = gT.GreatPeople[gpID]
	local tab = {
		IconAtlas = GetGPDataOrAlt(v.Type, "IconAtlas"),
		PortraitIndex = GetGPDataOrAlt(v.Type, "PortraitIndex"),
		Name = GetGreatPersonName(gpID, true),
		NameType = lSgreatpeopleData[v.Type].Description,
		IconString = lSgreatpeopleData[v.Type].FontIcon,
		MigrationData = GenerateGPMigrationToolTipData(gpID),
	}
	MapModData.ITGSG = tab;
end
LuaEvents.ITGSG_RequestGPInfoForOverview.Add(GetGPInfoForOverview)