local phthe = GameInfoTypes.BELIEF_ITG_PANTHEON_23
local phtce = GameInfoTypes.BELIEF_ITG_FOLLOWER_47;
local wonderindRoyalSalt = GameInfoTypes.BUILDING_ITG_NEW_INDUSTRIAL_WONDER_28
local itghealthwonder1 = GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_45

function GetHealthFromWonder(iCity, iPlayer)
	local base = 0;
	if IsCityHaveWonderRuinWithAbility(iCity, 17) then
		base = base + 2;
	end
	if gT.Players[iPlayer].HasPlayerWonder[itghealthwonder1] then
		base = base + 2;
	end
	if gT.Players[iPlayer].HasPlayerWonder[wonderindRoyalSalt] then
		base = base + 3;
	end
	return base;
end

function GetHealthFromAcademies(iCity, iPlayer)
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local mis = 0;
	mis = mis + 4 * GetNumCityAcademiesWithAbility(iCity, 18)
	for i, index in pairs(gT.Cities[cID].Academies) do
		if IsAcademyActiveRightNow(index) then
			if gT.Academies[index].Bonuses.Health then
				mis = mis + gT.Academies[index].Bonuses.Health - math.floor(gT.Academies[index].Bonuses.Health / 5);
			end
		end
	end
	mis = mis + gT.Players[iPlayer].AcaHealth;
	return mis;
end

function GetHealthFromPolioVaccine()
	if gT.Globals.PolioDone then
		return 4;
	end
	return 0;
end

function GetHealthFromReligion(iCity, iPlayer)
	local rel = 0;
	if IsBeliefPresentInACity(iCity, phthe) then
		if iCity:GetPopulation() >= 4 then
			rel = rel + 1;
		end
	end
	if IsBeliefPresentInACity(iCity, phtce) then
		if IsCityHasSpecialist(iCity) then
			rel = rel + 2;
		end
	end
	return rel;
end

function GetHealthFromBuildings(iCity, iPlayer)
	local base = iCity:GetITGHealth()
	for bClass, amount in pairs(gT.Players[iPlayer].HealthFromBuildingClasses) do
		local bb = Players[iPlayer]:GetPlayerUniqueBuilding(bClass);
		if (bb ~= -1) and iCity:IsHasBuilding(bb) then
			local numBuilding = iCity:GetNumRealBuilding(bb) + iCity:GetNumFreeBuilding(bb);
			base = base + (iCity:GetNumRealBuilding(bb) + iCity:GetNumFreeBuilding(bb)) * amount;
		end
	end
	return base;
end

function GetHealthFromLaws(iCity, cID, iPlayer)
	local a = 0;
	if IsHasLaw(iPlayer, 6, 2) then
		a = a - 2;
	end
	return a;
end

function GetHealthFromSocialPolicies(iCity, iPlayer)
	local bs = 0;
	if gT.Players[iPlayer].CultBonusOn[193] then
		bs = bs + 1;
	end
	if gT.Players[iPlayer].CultBonusOn[195] then
		for j = 0, 5 do
			local nPlot = Map.PlotDirection(iCity:GetX(), iCity:GetY(), j);
			if nPlot and (nPlot:IsMountain() or nPlot:GetTerrainType() == tSnow or nPlot:GetTerrainType() == tTundra or nPlot:GetTerrainType() == tDesert) then
				bs = bs + 1;
			end
		end
	end
	return bs;
end

local techcoastalv = GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_VIKING_5;
local techmoralev = GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_AFR_8;
local ancCSinno15 = GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_15;
function GetHealthFromFestival(iCity, cID, iPlayer)
	local b = (gT.Cities[cID].HealthFestival or 0)
	if gT.Cities[cID].FestivalET then
		if gT.Players[iPlayer].FestivalBonusesActive[11] then
			b = b + gT.Players[iPlayer].FestivalBonusesActive[11];
		end
	end
	return b;
end
function GetHealthFromInnovations(iCity, cID, iPlayer)
	local rs = GetITGCityInteger(iCity, "CI_HEALTH_FROM_INNO");
	if iCity:IsCoastal() then
		if HasPlayerTech(iPlayer, techcoastalv, "beradeae") then
			rs = rs + 1;
		end
		if HasPlayerTech(iPlayer, ancCSinno15, "gegdfe") then
			rs = rs + 2;
		end
	end
	if HasPlayerTech(iPlayer, techmoralev, "Hadearrer") then
		if gT.Players[iPlayer].Morale > 0 then
			rs = rs + 1;
		end
	end
	return rs;
end

function GetAverageHealthPreModifiers(iPlayer)
	local b, h = 0, Players[iPlayer]:GetNumCities();
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		b = b + GetCurrentHealthCity(iCity, cID, iPlayer, true); 
	end
	if h ~= 0 then
		b = math.floor(b / h)
	end
	return b;
end

function DoUpdateHealthModifiers(iPlayer)
	local avgH;
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		SetITGCityInteger(iCity, "CI_IDEO_AVG_HEALTH", 0)
		SetITGCityInteger(iCity, "CI_IDEO_2_HAP", 0)
	end
	if gT.Players[iPlayer].HasIdeology[2] then -- first
		if not avgH then
			avgH = GetAverageHealthPreModifiers(iPlayer);
		end
		for iCity in Players[iPlayer]:Cities() do
			local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
			local extraH = math.max(0, avgH - GetCurrentHealthCity(iCity, cID, iPlayer, true));
			SetITGCityInteger(iCity, "CI_IDEO_AVG_HEALTH", extraH)
			if extraH == 0 then
				SetITGCityInteger(iCity, "CI_IDEO_2_HAP", 1)
			end
		end
	end
end

function GetHealthFromIdeology(iCity, cID, iPlayer, bNoModifiers)
	local b = GetITGCityInteger(iCity, "CI_IDEO_61_HEALTH") + GetITGCityInteger(iCity, "CI_IDEO_7");
	if not bNoModifiers then
		b = b + GetITGCityInteger(iCity, "CI_IDEO_AVG_HEALTH");
	end
	if gT.Players[iPlayer].HasIdeology[70] then
		if #gT.Cities[cID].Academies > 0 then
			b = b + 2; 
		end
	end
	if gT.Players[iPlayer].HasIdeology[82] then
		b = b + math.floor(iCity:GetPopulation() / 7)
	end
	return b;
end

function GetHealthFromBudget(iCity)
	return GetITGCityInteger(iCity, "CI_BUDGET_HEALTH")
end

function GetHealthFromQZ(cID)
	return gT.Cities[cID].HealthFromQZ or 0;
end

function GetHealthFromForeignDoctors(iPlayer)
	return gT.Players[iPlayer].HealthForeignDocs or 0;
end

function GetCurrentHealthCity(iCity, cID, iPlayer, bNoModifiers)
	local base = 1 + GetHealthFromBudget(iCity) + GetHealthFromInnovations(iCity, cID, iPlayer) + GetHealthFromSocialPolicies(iCity, iPlayer) + GetHealthFromReligion(iCity, iPlayer) + gT.Players[iPlayer].HealthFromTech + gT.Cities[cID].HealthFromGP + GetHealthFromBuildings(iCity, iPlayer) + gT.Cities[cID].HealthFromEpidemy;
	base = base + GetITGCityInteger(iCity, "CI_GOV_HEALTH") + GetHealthFromLaws(iCity, cID, iPlayer)
	base = base + GetHealthFromWonder(iCity, iPlayer) + GetHealthFromAcademies(iCity, iPlayer) + GetHealthFromLeagues(iPlayer) + GetHealthFromIdeology(iCity, cID, iPlayer, bNoModifiers)
	base = base + GetHealthFromPolioVaccine() + GetHealthFromFestival(iCity, cID, iPlayer) + GetHealthFromQZ(cID) + GetHealthFromForeignDoctors(iPlayer);
	return base;
end

function GetHealthFromLeagues(iPlayer)
	local base = 0;
	for league, sth in pairs(gT.Leagues) do
		if sth.Members[iPlayer] then
			if sth.Resolutions[49] then
				base = base + 1;
			end
			if sth.Resolutions[34] then 
				base = base + 1;
			end
		end
	end
	return base;
end

function HealthInitial()
	for g, gdata in pairs(gT.Players) do
		UpdateHealthInAllCities(g)	
	end
end

function UpdateHealthInAllCities(iPlayer)
	DoUpdateHealthModifiers(iPlayer)
	for iCity in Players[iPlayer]:Cities() do
		UpdateHealthInSingleCity(iCity, iPlayer)
	end
end

function UpdateHealthInSingleCity(iCity, iPlayer)
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	gT.Cities[cID].Health = GetCurrentHealthCity(iCity, cID, iPlayer);
	gT.Cities[cID].HealthLevel = gT.Cities[cID].Health - iCity:GetPopulation();
	local foodrate = math.floor(gT.Cities[cID].HealthLevel);
	if GetITGCityInteger(iCity, "CI_HEALTH_FOOD_RATE") ~= foodrate then
		iCity:ChangeYieldRateModifier(yFood, foodrate - GetITGCityInteger(iCity, "CI_HEALTH_FOOD_RATE"))
		SetITGCityInteger(iCity, "CI_HEALTH_FOOD_RATE", foodrate);
	end
	gT.Cities[cID].MaxHealthEver = math.max(gT.Cities[cID].MaxHealthEver, gT.Cities[cID].Health);
	local prodideo30 = 0;
	if gT.Players[iPlayer].HasIdeology[30] then
		if gT.Cities[cID].HealthLevel >= 0 then
			prodideo30 = 3;
		end
	end
	SetRawCityYield(iCity, yProduction, prodideo30, "CI_IDEO_30")
end

function ChangeExtraHealthFromBuildingClass(iPlayer, bClass, amount)
	if not gT.Players[iPlayer].HealthFromBuildingClasses[bClass] then
		gT.Players[iPlayer].HealthFromBuildingClasses[bClass] = amount;
	else
		gT.Players[iPlayer].HealthFromBuildingClasses[bClass] = gT.Players[iPlayer].HealthFromBuildingClasses[bClass] + amount;
		if gT.Players[iPlayer].HealthFromBuildingClasses[bClass] == 0 then
			gT.Players[iPlayer].HealthFromBuildingClasses[bClass] = nil;
		end
	end
end

local socHealthPol = {193, 194, 195, 196}
local techHealthPol = {GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_ARABIA_4, GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_ASIA_3 , GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_VIKING_5 , GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_AFR_8 }
function GetExtraReasonsForHealthcareLeague(iPlayer, leagueID)
	local rS = 0;
	for lg, s in pairs(gT.Leagues) do
		if s.Resolutions[34] then
			if s.Members[iPlayer] then
				if lg ~= leagueID then
					rS = rS + 5;
				end
			end
		end
	end
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		rS = rS + gT.Cities[cID].HealthFromGP + GetHealthFromReligion(iCity, iPlayer) + GetHealthFromAcademies(iCity, iPlayer);
	end
	for i, polid in pairs(socHealthPol) do
		if gT.Players[iPlayer].CultBonusOn[polid] then
			rS = rS + 5;
		end	
	end
	if gT.Players[iPlayer].HasPlayerWonder[itghealthwonder1] then
		rS = rS + 5;
	end
	--innovations
	for i, tech in pairs(techHealthPol) do
		if HasPlayerTech(iPlayer, tech, "Haddaeda") then
			rS = rS + 5;
		end
	end
	return rS;
end

function GetPlayerTotalHealth(iPlayer)
	local b = 0;
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		b = b + gT.Cities[cID].Health;
	end
	return b;
end