local SeasonTableName = {"Spring", "Summer", "Autumn", "Winter"}

function AlphabeticalSortFunction(field, direction)
	if(direction == "asc") then
		return function(a,b)
			return Locale.Compare(a[field], b[field]) == -1;
		end
	elseif(direction == "desc") then
		return function(a,b)
			return Locale.Compare(a[field], b[field]) == 1;
		end
	end
end
function NumericSortFunction(field, direction)
	if(direction == "asc") then
		return function(a,b)
			return a[field] <= b[field];
		end
	elseif(direction == "desc") then
		return function(a,b)
			return a[field] > b[field];
		end
	end
end

local strSort = "";
function SetSortByStringColumn(str)
	strSort = str;
end

function SortByStringColumnnLowest(a,b)
	local va = (a ~= nil and a[strSort] ~= nil) and a[strSort] or 999;
	local vb = (b ~= nil and b[strSort] ~= nil) and b[strSort] or 999;
	return tonumber(va) < tonumber(vb);
end

--??? those are actually float sort function
function SortFunctionLowestInteger(a,b)
	local va = (a ~= nil) and a or -1;
	local vb = (b ~= nil) and b or -1;
	return tonumber(va) < tonumber(vb);
end

function SortFunctionHighestInteger(a,b)
	local va = (a ~= nil) and a or -1;
	local vb = (b ~= nil) and b or -1;
	return tonumber(va) > tonumber(vb);
end

function SortFunctionForLowestInteger1(a, b)
	local va = (a ~= nil and a[1] ~= nil) and a[1] or 999;
	local vb = (b ~= nil and b[1] ~= nil) and b[1] or 999;
	return tonumber(va) < tonumber(vb);
end

function SortFunctionForGreaterInteger1(a, b)
	local va = (a ~= nil and a[1] ~= nil) and a[1] or 999;
	local vb = (b ~= nil and b[1] ~= nil) and b[1] or 999;
	return tonumber(va) > tonumber(vb);
end

function SortFunctionForGreaterInteger2(a, b)
	local va = (a ~= nil and a[2] ~= nil) and a[2] or 999;
	local vb = (b ~= nil and b[2] ~= nil) and b[2] or 999;
	return tonumber(va) > tonumber(vb);
end

function SortFunctionForGreaterInteger4(a, b)
	local va = (a ~= nil and a[4] ~= nil) and a[4] or 999;
	local vb = (b ~= nil and b[4] ~= nil) and b[4] or 999;
	return tonumber(va) > tonumber(vb);
end

--used only for non-null integers
function SortFunctionGreatest2Lowest3(a, b)
	if a[2] > b[2] then
		return true;
	elseif b[2] > a[2] then
		return false;
	elseif a[3] < b[3] then
		return true;
	end
	return false;
end
function SortFunctionLowest2Greatest1(a, b)
	if a[2] < b[2] then
		return true;
	elseif b[2] < a[2] then
		return false;
	elseif a[1] > b[1] then
		return true;
	end
	return false;
end
function SortFunctionLowest2Lowest3(a, b)
	if a[2] < b[2] then
		return true;
	elseif b[2] < a[2] then
		return false;
	elseif a[3] < b[3] then
		return true;
	end
	return false;
end
function SortFunctionLowest2Greatest3(a, b)
	if a[2] < b[2] then
		return true;
	elseif b[2] < a[2] then
		return false;
	elseif a[3] > b[3] then
		return true;
	end
	return false;
end
function SortFunctionGreatest2Greatest3Lowest4(a, b)
	if a[2] > b[2] then
		return true;
	elseif b[2] > a[2] then
		return false;
	elseif a[3] > b[3] then
		return true;
	elseif b[3] > a[3] then
		return false;
	elseif a[4] < b[4] then
		return true;
	end
	return false;
end
function SortFunctionLowest2Greatest3Greatest4(a, b)
	if a[2] < b[2] then
		return true;
	elseif b[2] < a[2] then
		return false;
	elseif a[3] > b[3] then
		return true;
	elseif b[3] > a[3] then
		return false;
	elseif a[4] > b[4] then
		return true;
	end
	return false;
end
function SortFunctionGreatest2Greatest3(a, b)
	if a[2] > b[2] then
		return true;
	elseif b[2] > a[2] then
		return false;
	elseif a[3] > b[3] then
		return true;
	end
	return false;
end

function SortFunctionForGreaterInteger3(a, b)
	local va = (a ~= nil and a[3] ~= nil) and a[3] or 999;
	local vb = (b ~= nil and b[3] ~= nil) and b[3] or 999;
	return tonumber(va) > tonumber(vb);
end

function SortFunctionForLowestInteger3(a,b)
	local va = (a ~= nil and a[3] ~= nil) and a[3] or -1;
	local vb = (b ~= nil and b[3] ~= nil) and b[3] or -1;
	return tonumber(va) < tonumber(vb);
end
function SortFunctionForLowestInteger4(a,b)
	local va = (a ~= nil and a[4] ~= nil) and a[4] or -1;
	local vb = (b ~= nil and b[4] ~= nil) and b[4] or -1;
	return tonumber(va) < tonumber(vb);
end
function SortFunctionForLowestInteger5(a,b)
	local va = (a ~= nil and a[5] ~= nil) and a[5] or -1;
	local vb = (b ~= nil and b[5] ~= nil) and b[5] or -1;
	return tonumber(va) < tonumber(vb);
end

function SortFunctionForLowestMapDistance(a, b)
	local va = (a ~= nil and a[2] ~= nil) and a[2] or -1;
	local vb = (b ~= nil and b[2] ~= nil) and b[2] or -1;
	return tonumber(va) < tonumber(vb);
end

function LastRandom(int1, int2)
	if (not int1) or (not int2) then
		print("Let it runtime elsewhere", int1, int2)
		return nil;
	end
	local rand = Game.Rand(int2 - int1 + 1,"Hehe")
	return int1 + rand;
end

function LastChance(int1)
	if not int1 then
		print("Let it runtime elsewhere LC")
		return nil;
	end
	return (LastRandom(1, 100) <= int1)
end

function ShuffleSort(a, b)
	return a[2] < b[2];
end

function Shuffle(iTable)
	local n, order, oTable = #iTable, {}, {}
	for i = 1, n do
		order[i] = {i, LastRandom(1, 10000)}
	end
	table.sort(order, ShuffleSort)
	for i = 1, n do 
		oTable[i] = iTable[order[i][1]];
	end
	return oTable;
end

function GetTableSizeInteger(tab, string)
	local it = 0;
	if tab then
		for x, v in pairs(tab) do
			it = it + 1;
		end
	else
		print("GetTableSizeInteger!!! NIL", string)
		return 0;
	end
	return it;
end

function HasCityWithinADistance(iPlayer, iPlot, distance)
	for iCity in Players[iPlayer]:Cities() do
		if Map.PlotDistance(iCity:GetX(), iCity:GetY(),iPlot:GetX(), iPlot:GetY()) <= distance then
			return true;
		end
	end
	return false;
end

function GetClosestCityIDToPlotOrNil(iPlayer, iPlot)
	local iDist = 999;
	local hCity;
	for iCity in Players[iPlayer]:Cities() do
		if Map.PlotDistance(iCity:GetX(), iCity:GetY(),iPlot:GetX(), iPlot:GetY()) < iDist then
			iDist = Map.PlotDistance(iCity:GetX(), iCity:GetY(),iPlot:GetX(), iPlot:GetY());
			hCity = iCity;
		end
	end
	if hCity then
		return hCity:GetID();
	else
		return nil;
	end
end

function MetTheCivFromTable(table)
	for i, iPlayer in pairs(table) do
		local iTeam = Players[iPlayer]:GetTeam();
		for j = i + 1, #table do
			local jTeam = Players[table[j]]:GetTeam();
			if not Teams[iTeam]:IsHasMet(jTeam) then
				Teams[iTeam]:Meet(jTeam);
			end
		end
	end
end

function GetMiddleValueFromTable(Data)
	local hData = {}
	for value, meh in pairs(Data) do
		table.insert(hData, value)
	end
	if #hData > 1 then
		return  hData[math.max(1, math.floor(#hData / 2))];
	end
end

function GetSeasonFromTurn(gameturn)
	--1 spring, 2 summer, 3 autumn, 4 winter
	return (gT.Globals.StartDate + gameturn) % 4 + 1;
end

function GetSeasonNameFromID(seasonID)
	return SeasonTableName[seasonID]
end

function RevealNowPlot(sPlot, iTeam, iPlayer)
	if not sPlot:IsRevealed(iTeam) then
		sPlot:ChangeVisibilityCount(iTeam, 1);
		sPlot:ChangeVisibilityCount(iTeam, -1);
--		table.insert(gT.Players[iPlayer].BeforeLoadVisionModifier, sPlot:GetPlotIndex());
		if iTeam == Game.GetActiveTeam() then
			sPlot:UpdateFog()
		end
	end
end

function GetNearestNeighbour(i, tPlot, tab)
	local iPlot;
	if (not i) and (not tPlot) then
		print("BAD getnearestneighbour, helpfunctions")
	end
	if i then
		iPlot = Map.GetPlotByIndex(gT.Players[i].StartingPlot);
	else
		iPlot = tPlot;
	end
	local rPlayer, rDis = nil, 999;
	for j, gdata in pairs(gT.Players) do
		local jPlot = Map.GetPlotByIndex(gdata.StartingPlot);
		if (j ~= i) and ((not tab) or (not tab[j])) then
			if Map.PlotDistance(jPlot:GetX(), jPlot:GetY(), iPlot:GetX(), iPlot:GetY()) < rDis then
				rDis = Map.PlotDistance(jPlot:GetX(), jPlot:GetY(), iPlot:GetX(), iPlot:GetY());
				rPlayer = j;
			end
		end
	end
	return rPlayer;
end

function RevertIntoIntegerTable(tab)
	local hTab = {}
	for j, sth in pairs(tab) do
		table.insert(hTab, j)
	end
	return hTab;
end

function GetIDOfElement(tab, element)
	for i,v in pairs(tab) do
		if v == element then
			return i;
		end
	end
end

function IsWithinProperDistanceFromOtherPlots(hPlot, xData, mindis)
--ALSO UNUSED
	if xData == "Cities" then
		for i,gh in pairs(gT.Players) do
			for iCity in Players[i]:Cities() do
				if Map.PlotDistance(hPlot:GetX(), hPlot:GetY(), iCity:GetX(), iCity:GetY()) < mindis then
					return false;
				end
			end
		end
		for iplotinedx, sth in pairs(gT.Globals.BadPoints) do
			local iPlot = Map.GetPlotByIndex(iplotinedx);
			if Map.PlotDistance(hPlot:GetX(), hPlot:GetY(), iPlot:GetX(), iPlot:GetY()) < mindis then
				return false;
			end
		end
	else
		for it, iPlot in pairs(xData) do
			if Map.PlotDistance(hPlot:GetX(), hPlot:GetY(), iPlot[1]:GetX(), iPlot[1]:GetY()) < mindis then
				return false;
			end
		end
	end
	return true;
end

function GetScNameForSave()
	return GetAcronymOf(Locale.Lookup(DBScenario.Description), true)
end

function GetSeasonFromNatDay(iDay)
	if iDay < 80 then
		return 4;
	elseif iDay < 172 then
		return 1;
	elseif iDay < 263 then
		return 2;
	elseif iDay < 354 then
		return 3;
	else
		return 4;
	end
end

function GetValidDayForNatDayFromSeason(fSeason)
	local iSeason = fSeason or GetSeasonFromTurn(GetITGGameTurn());
	if iSeason == 1 then
		return LastRandom(80, 171)
	elseif iSeason == 2 then
		return LastRandom(172, 262)
	elseif iSeason == 3 then
		return LastRandom(263, 353)
	else
		return LastRandom(354, 444) % 365;
	end
end

function GetYearFromTurn(turn)
	return -4000 + math.floor((gT.Globals.StartDate + turn)/4);
end
function GetTextDateForSave()
	local year = -4000 + math.floor((gT.Globals.StartDate + GetITGGameTurn())/4);
	local season = SeasonTableName[(gT.Globals.StartDate + GetITGGameTurn())%4 + 1];
	if year < 0 then
		year = -year .. "BC"
	else
		year = year .. "AD"
	end
	return string.sub(season,1,3) .. "_" .. year;
end
function GetTextDate(turn, StartDate, bYearOnly, bNumberOnly)
	local year = -4000 + math.floor((StartDate + turn)/4);
	local season = SeasonTableName[(StartDate + turn)%4 + 1];
	if year < 0 then
		if bYearOnly then
	--		if bNumberOnly then
	--			return -year;
	--		end
			return -year .. " BC";
		else
			return season .. " " .. -year .. " BC";
		end
	else
		if bYearOnly then
			if bNumberOnly and (year > 99) then
				return year;
			end
			return year .. " AD";
		else
			return season .. " " .. year .. " AD";
		end
	end
end

function GetThStNdRd(number)
	local tens = math.floor(number / 10)
	if tens == 1 then
		return "th"
	end
	local ith = number % 10;
	if ith == 1 then
		return "st"
	elseif ith == 2 then
		return "nd"
	elseif ith == 3 then
		return "rd"
	end
	return "th";
end

function GetCenturyFromTurn(turn, StartDate)
	local year = -4000 + math.floor((StartDate + turn)/4);
	if year == 0 then
		return 1;
	end
	if year < 0 then
		return -1 * math.ceil(math.abs(year)/ 100)
	end
	return math.ceil(year/ 100)
end

function ReverseIntoIterable(tab)
	local hTab = {}
	for it, dit in pairs(tab) do
		table.insert(hTab, it)
	end
	return hTab;
end
function ReverseTable(tab)
	local hTab = {}
	for it, dit in pairs(tab) do
		hTab[dit] = it;
	end
	return hTab;
end

function GetNearestCityOfPlayerToPlot(x, y, iPlayer, maxdis)
	local min, city = maxdis + 1, nil;
	for iCity in Players[iPlayer]:Cities() do
		local hid = Map.PlotDistance(iCity:GetX(), iCity:GetY(), x, y);
		if hid < min then
			min = hid;
			city = iCity;
		end
	end
	return city;
end

function GetNearestUnitCityToThePlot(plot, bOnlyCity)
	local x,y = plot:GetX(), plot:GetY();
	local min, player = 9, 63;
	for i, gh in pairs(gT.Players) do
		for iCity in Players[i]:Cities() do
			if Map.PlotDistance(iCity:GetX(), iCity:GetY(), x, y) < min then
				min =  Map.PlotDistance(iCity:GetX(), iCity:GetY(), x, y)
				player = i;
			end
		end
		for iCity in Players[i]:Units() do
			if Map.PlotDistance(iCity:GetX(), iCity:GetY(), x, y) < min then
				min =  Map.PlotDistance(iCity:GetX(), iCity:GetY(), x, y)
				player = i;
			end
		end
	end
	return player;
end

function GetRandomNotFullyRandomClosePlayers(iPlayer, num, excludeCultureType)
	local iTeam, hTab, iPlot, hp1, hp2 = Players[iPlayer]:GetTeam(), {}, Map.GetPlotByIndex(gT.Players[iPlayer].StartingPlot), 0, 0;
	for g, gData in pairs(gT.Players) do
		if g ~= iPlayer then
			if not gData.OccupyLimit then
				if (not excludeCultureType[gData.CultureType]) then
					local c = 1;
					if Teams[iTeam]:IsHasMet(Players[g]:GetTeam()) then
						c = c + 2;
					end
					local iDis = Map.PlotDistance(iPlot:GetX(), iPlot:GetY(), Map.GetPlotByIndex(gData.StartingPlot):GetX(), Map.GetPlotByIndex(gData.StartingPlot):GetX())
					if iDis < 20 then
						c = c + 2;
					elseif iDis < 40 then
						c = c + 1;
					end
					table.insert(hTab, {g, c});
					hp1 = hp1 + c;
				end
			end
		end
	end
	local mTab = {}
	for i = 1, num do
		if #hTab > 0 then
			local lKey = GetRandomFromBiasedChanceTable(hTab, true)
			table.insert(mTab, hTab[lKey][1])
			table.remove(hTab, lKey)
		end
	end
	return mTab;
end

function GetRandomCity(jPlayer)
	local jRand = LastRandom(1, Players[jPlayer]:GetNumCities());
	for iCity in Players[jPlayer]:Cities() do
		if jRand == 1 then
			return iCity;
		else
			jRand = jRand - 1;
		end
	end
	return nil;
end

function GetClosestCityDistanceToXY(playerid, x, y, eTeam)
	local hDis = 9999;
	for iCity in Players[playerid]:Cities() do
		if (not eTeam) or iCity:Plot():IsRevealed(eTeam) then
			hDis = math.min(hDis, Map.PlotDistance(iCity:GetX(), iCity:GetY(), x, y))
		end
	end
	return hDis;
end

function GetInitConquerDistance(playerid)
	if (PreGame.GetGameOption("GAMEOPTION_ITG_BLOB_TERRITORIES") == 1) then
		return 8;
	end
	return GetDBCulturePlayerInfo(playerid, "InitConquerDistance");
end

function DetermineLuckyConqueror(iCity, luckyminor, exclude) 
	local pTab = GetRandomNotFullyRandomClosePlayers(luckyminor, 3, exclude);
	local nTab = {};
	local x, y;
	if iCity then
		x = iCity:GetX();
		y = iCity:GetY();
	else
		x = Players[luckyminor]:GetStartingPlot():GetX();
		y = Players[luckyminor]:GetStartingPlot():GetY();
	end
	for it, playerid in pairs(pTab) do
		if GetClosestCityDistanceToXY(playerid, x, y) <= GetInitConquerDistance(playerid) then
			if Players[playerid]:IsMinorCiv() then
				table.insert(nTab, {playerid, 5})
			elseif (not Players[luckyminor]:IsMinorCiv()) and Players[playerid]:IsDoF(luckyminor) then
				table.insert(nTab, {playerid, 5})
			else
				table.insert(nTab, {playerid, 45})
			end
		end
	end
	if #nTab > 0 then
		return GetRandomFromBiasedChanceTable(nTab)
	end
	return nil;
end

function GetNearestDistanceWithSetOfPlots(iPlot, iTab)
	local dis = 999;
	for i, nPlot in pairs(iTab) do
		dis = math.min(dis, Map.PlotDistance(iPlot:GetX(), iPlot:GetY(), nPlot:GetX(), nPlot:GetY()))
	end
	return dis;
end

function IsNavalUnit(iUnit)
	return (iUnit:GetDomainType() == dSea);
end

function GetRandomBiasedAmplifiedTable(tab, amplify, bKey)
	local min, max;
	for a, v in pairs(tab) do
		if (not min) or (min > v[2]) then
			min = v[2];
		end
		if (not max) or (max < v[2]) then
			max = v[2];
		end
	end
	if min == max then
		return GetRandomFromBiasedChanceTable(tab, bKey)
	else
		local aTab = {}
		for a, v in pairs(tab) do
			table.insert(aTab, {v[1], math.floor(math.pow(1 + (v[2] - min) / (max - min), amplify) * min)})
		end
		return GetRandomFromBiasedChanceTable(aTab, bKey)
	end
end

function GetLowestRandomFromTable(tab, bReverse)
	local vals = {};
	local hMin;
	for i, v in pairs(tab) do
		if (not hMin) or ((hMin > v[2]) ~= bReverse) then
			hMin = v[2]
			vals = {v[1]}
		elseif v[2] == hMin then
			table.insert(vals, v[1])
		end
	end
	if #vals == 0 then
		print("Congratulations, GetLowestRandomFromTable failed", #tab);
	end
	return vals[LastRandom(1,#vals)];
end

function GetRandomFromBiasedChanceTable(tab, bKey)
	local bias = 0;
	for it, data in pairs(tab) do
		bias = bias + data[2];
	end
	local lucky = LastRandom(1, bias)
	for it, data in pairs(tab) do
		if lucky <= data[2] then
			if bKey then
				return it;
			else
				return data[1];
			end
		else
			lucky = lucky - data[2];
		end
	end
end

function GetTotalYieldValue(iPlot)
	local val = 0;
	for row in GameInfo.Yields() do
		val = val + iPlot:GetYield(row.ID);
	end
	return val;
end

function GetSimplePlotValueForAI(iPlot, iTeam)
	local base = GetTotalYieldValue(iPlot)
	local iRes = iPlot:GetResourceType(iTeam);
	if iRes ~= -1 then
		if not GameInfo.Resources[iRes].Migration then
			if GameInfo.Resources[iRes].Happiness > 0 then
				base = base + 1;
			else
				for b, a in pairs(gT.Globals.ResourcesInScenario) do
					if b == iRes then
						base = base + 3;
					end
				end
			end
		end
	end
	return base;
end


function GetPercentageOfCitiesHavingBuilding(tPlayer, b)
	if Players[tPlayer]:GetNumCities() == 0 then
		return 0
	end
	return Players[tPlayer]:GetBuildingClassCount(GameInfoTypes[GameInfo.Buildings[b].BuildingClass])/Players[tPlayer]:GetNumCities();
end

function GetRealNumTechsKnown(iTeam)
	local count, pTeam = 0, Teams[iTeam]
	for row in GameInfo.Technologies() do
		if row.Show and (not row.IsInnovation) then
			if pTeam:IsHasTech(row.ID) then
				count = count + 1;
			end
		end
	end
	return count;
end

local ScenarioOrderT = {3, 2, 1}
function GetPreviousErasTable(sct)
	local hTab = {};
	for i, sc in pairs(ScenarioOrderT) do
		if sct == sc then
			return hTab;
		else
			table.insert(hTab, sc)
		end
	end
	return hTab;
end

function GetPlotsInRadiusOfPlot(iPlot, dis)
	local tTab = {}
	for ix = - dis, dis do
		for iy = -dis, dis do
			local nPlot = Map.PlotXYWithRangeCheck(iPlot:GetX(), iPlot:GetY(), ix, iy, dis)
			if nPlot then
				table.insert(tTab, nPlot)
			end
		end
	end
	return tTab;
end

function GetPlotsInRadiusExactOfPlot(iPlot, dis)
	local tTab = {}
	for ix = - dis, dis do
		for iy = -dis, dis do
			local nPlot = Map.PlotXYWithRangeCheck(iPlot:GetX(), iPlot:GetY(), ix, iy, dis)
			if nPlot then
				if Map.PlotDistance(iPlot:GetX(), iPlot:GetY(), nPlot:GetX(), nPlot:GetY()) == dis then
					table.insert(tTab, nPlot)
				end
			end
		end
	end
	return tTab;
end

function GetMountainCityValue(iCity)
	local val = 0;
	local hTab = GetPlotsInRadiusOfPlot(iCity:Plot(), 2)
	for i, plot in pairs(hTab) do
		if plot:IsMountain() then
			if Map.PlotDistance(plot:GetX(), plot:GetY(), iCity:GetX(), iCity:GetY()) == 1 then
				return 2;
			else
				val = 1;
			end
		end	
	end
	return val;
end

function GetNumDofs(iPlayer)
	local c = 0;
	for g, gd in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			if not Players[g]:IsBarbarian() then
				if Players[g]:IsDoF(iPlayer) then
					c = c + 1;
				end
			end
		end
	end
	return c;
end

function GetNameOrUnknown(iPlayer, fTeam, fResponse)
	if Teams[fTeam or Game.GetActiveTeam()]:IsHasMet(Players[iPlayer]:GetTeam()) then
		return Players[iPlayer]:GetCivilizationShortDescription()
	else
		return fResponse or "Unknown member"
	end
end

function IsInTable(tab, val)
	for h, v in pairs(tab) do
		if v == val then
			return true;
		end
	end
	return false;
end


function GetAverageValueFromCID(g, string)
	if Players[g]:GetNumCities() == 0 then
		return -1;
	end
	local s = 0;
	for iCity in Players[g]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		s = s + gT.Cities[cID][string]
	end
	return s / Players[g]:GetNumCities();
end

function GetBestValueFromCID(g, string)
	local s = -9999;
	for iCity in Players[g]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		s = math.max(s, gT.Cities[cID][string])
	end
	return s;
end

function GetWorstValueFromCID(g, string)
	local s = 9999;
	for iCity in Players[g]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		s = math.min(s, gT.Cities[cID][string])
	end
	return s;
end

function GetAdjacentCity(iPlot)
	for i = 0, 5 do
		local nPlot= Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), i);
		if nPlot and nPlot:IsCity() then
			return nPlot:GetPlotCity();
		end
	end
	return nil;
end

function GetRandomPlayerFromTeam(teamId)
	local tab = {}
	for h, c in pairs(gT.Players) do
		if Players[h]:GetTeam() == teamId then
			table.insert(tab, h)
		end
	end
	return tab[LastRandom(1,#tab)];
end

function GetNumMetCS(iPlayer)
	local b = 0;
	for g, p in pairs(gT.Players) do
		if Players[g]:IsMinorCiv() then
			if Teams[Players[g]:GetTeam()]:IsHasMet(Players[iPlayer]:GetTeam()) then
				if Players[g]:IsAlive() then
					b = b + 1;
				end
			end
		end
	end
	return b;
end

function GetNumAlliedCS(iPlayer)
	local b = 0;
	for g, p in pairs(gT.Players) do
		if Players[g]:IsMinorCiv() then
			if Players[g]:GetAlly() == iPlayer then
				if Players[g]:IsAlive() then
					b = b + 1;
				end
			end
		end
	end
	return b;
end

function GetNumOccupiedCities(iPlayer)
	local numoccupied = 0;
	for iCity in Players[iPlayer]:Cities() do
		if iCity:IsOccupied() then
			numoccupied = numoccupied + 1;
		end
	end
	return numoccupied;
end

function GetRandomMinorPlayer()
	local tab = {}
	for g, h in pairs(gT.Players) do
		if Players[g]:IsMinorCiv() then
			table.insert(tab, g)
		end
	end
	if #tab > 0 then
		return tab[LastRandom(1,#tab)];
	end
	return nil;
end

function GetMajorNeedingResForBalance(res, val)
	local imin, imax, minTab = 100, 0, {};
	for g, h in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			local nr = Players[g]:GetNumResourceTotal(res);
			imax = math.max(imax, nr)
			if nr < imin then
				imin = nr;
				minTab = {g};
			elseif imin == nr then
				table.insert(minTab, g);
			end
		end
	end
	if imin <= imax - val then
		if #minTab > 0 then
			return minTab[LastRandom(1,#minTab)];
		end
	end
	return nil;
end

function GetProperSubcultureForCityState(iPlayer)
	if Players[iPlayer]:IsMinorCiv() then
		if Players[iPlayer]:GetMinorCivTrait() == GameInfoTypes.MINOR_TRAIT_MILITARISTIC then
			return ITG_SubcultureTypes["SUBCULTURE_CS_MILITARISTIC"];
		elseif Players[iPlayer]:GetMinorCivTrait() == GameInfoTypes.MINOR_TRAIT_CULTURED then
			return ITG_SubcultureTypes["SUBCULTURE_CS_CULTURAL"];
		elseif Players[iPlayer]:GetMinorCivTrait() == GameInfoTypes.MINOR_TRAIT_MARITIME then
			return ITG_SubcultureTypes["SUBCULTURE_CS_MARITIME"];
		elseif Players[iPlayer]:GetMinorCivTrait() == GameInfoTypes.MINOR_TRAIT_MERCANTILE then
			return ITG_SubcultureTypes["SUBCULTURE_CS_MERCANTILE"];
		elseif Players[iPlayer]:GetMinorCivTrait() == GameInfoTypes.MINOR_TRAIT_RELIGIOUS then
			return ITG_SubcultureTypes["SUBCULTURE_CS_RELIGIOUS"];
		end
		print("Hola error - new City-States have no adequate subculture in ancient scenario :)")
	end
	--NEED rewriting
	local lTab = {};
	for i, subcultureType in pairs(ITG_CultureSubcultures[ITG_CultureTypes["CULTURE_CITY_STATE"]]) do
		local bCanBeChosen = true;
		if subcultureType == ITG_SubcultureTypes["SUBCULTURE_CS_MARITIME"] then
			if not StartingPlotValidForMaritimeCS(Players[iPlayer]:GetStartingPlot()) then
				bCanBeChosen = false;
			end
		end
		if bCanBeChosen then
			table.insert(lTab, subcultureType);
		end
	end
	return RandomFromTab(lTab);
end

function GetCityFromGEIndex(tgIndex)
	for g, gh in pairs(gT.Players) do
		for iCity in Players[g]:Cities() do
			local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
			if gT.Cities[cID].geIndex == tgIndex then
				return iCity;
			end
		end
	end
	return nil;
end

function GetSIfPlural(am)
	if am == 1 then
		return ""
	end
	return "s"
end

function GetNumUnitsNearbyPlot(iPlayer, x, y, dis, bCombatOnly)
	local d = 0;
	for iUnit in Players[iPlayer]:Units() do
		if Map.PlotDistance(x, y, iUnit:GetX(), iUnit:GetY()) <= dis then
			if (not bCombatOnly) or iUnit:IsCombatUnit() then
				d =d + 1;
			end
		end
	end
	return d;
end

function IntegerTableHasField(tab, field)
	for i, b in pairs(tab) do
		if b == field then
			return true;
		end
	end
end

function GetKeyFromIntegerTable(tab, field)
	for i, b in pairs(tab) do
		if b == field then
			return i;
		end
	end
	return -1;
end

function GetMaxFromIntegerTab(tab)
	local th;
	for a, b in pairs(tab) do
		if not th then
			th = b;
		else
			th = math.max(th, b)
		end
	end
	return th;
end

function GetAverageFromIntegerTab(tab)
	if #tab == 0 then
		return 0;
	end
	local th = 0;
	for a, b in pairs(tab) do
		th = th + b;
	end
	return th / #tab;
end

function HasPlayerUnitAdjacentToPlot(iPlayer, iPlot)
	for i = 0, 5 do
		local nPlot = Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), i);
		if nPlot then
			for j = 0, nPlot:GetNumUnits() - 1 do
				if nPlot:GetUnit(j):GetOwner() == iPlayer then
					return true;
				end
			end
		end
	end
	return false;
end

function GetTurnActivePlayer()
	for i, v in pairs(Players) do
		if v:IsTurnActive() then
			return i;
		end
	end
	return -1;
end

function StringSplitBasic(inputstr, sep)
    if sep == nil then
		sep = "%s"
    end
    local t = {}
    for str in string.gmatch(inputstr, "([^"..sep.."]+)") do
        table.insert(t, str)
    end
    return t;
end

function StringSplitToNumbers(inputstr, sep)
    if sep == nil then
		sep = "%s"
    end
    local t = {}
    for str in string.gmatch(inputstr, "([^"..sep.."]+)") do
        table.insert(t, tonumber(str))
    end
    return t;
end

function IsEdgeOfMap(fPlot)
	for i = 0, 5 do
		local nPlot = Map.PlotDirection(fPlot:GetX(), fPlot:GetY(), i);
		if not nPlot then
			return true;
		end
	end
	return false;
end

function RandomFromTab(tab)
	return tab[LastRandom(1,#tab)]
end

function IfKnownOr(gActive, bPlayerForNot, otherVal)
	if bPlayerForNot then
		if Teams[Players[gActive]:GetTeam()]:IsHasMet(Players[bPlayerForNot]:GetTeam()) then
			return bPlayerForNot;
		end
	end
	return otherVal;
end

function OnBasicError(string)
	print(string);
	return EditedError(string);
end

function OnErrorInitialScript(string)
	print(string);
	ThereWasErrorOnLoadInit(); -- this will stop reloading? dunno if needed;
	LuaEvents.ITG_FailedOnInitialScript({EditedError(string)});
	return false;
end

LuaEvents.ITG_RequestToConvertErrConv.Add(function(string)
	LuaEvents.ITG_EraConversionError(EditedError(string))
end)

function EditedError(string)
	local tab = StringSplitBasic(string, "\\")
	local errString = "..."
	local bAdd = false;
	for i, str in pairs(tab) do
		if bAdd then
			errString = errString .. "\\" .. str;
		elseif str == "MODS" then
			bAdd = true;
		end
	end
	if errString == "..." then
		return string;
	end
	return errString;
end

function GetRandomYield()
	local t = {yGold,yCulture,yProduction,yFood,yScience}
	if gT.Globals.ScenarioType ~= 5 then
		table.insert(t, yFaith);
	end
	return t[LastRandom(1,#t)];
end

function HasGTPlayer(iPlayer, tabStr, val, returnVal)
	if gT.Players[iPlayer][tabStr][val] then
		return returnVal;
	end
	return 0;
end

function GetNewlineIFNot(tt, str)
	if tt ~= str then
		return tt .. "[NEWLINE]";
	end
	return tt;
end

function GetDecisiveWinnerIndexOr(tab, adv, orVal)
	local iBestIndex, iSecondBest;
	for i, v in pairs(tab) do
		if not iBestIndex then
			iBestIndex = i;
		elseif v >= tab[iBestIndex] then
			iSecondBest = iBestIndex
			iBestIndex = i;
		end
	end
	if iBestIndex then
		if iSecondBest then
			if tab[iBestIndex] < tab[iSecondBest] + adv then
				return orVal;
			end
		end
		return iBestIndex
	end
	return orVal;
end

function IsPlayerAdjacentToPlot(iPlot, iPlayer)
	for i = 0, 5 do
		local nPlot = Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), i);
		if nPlot and (nPlot:GetOwner() == iPlayer) then
			return true;
		end
	end
	return false;
end

function AddGraphData(iPlayer, gType, iValue, bCheckPrev, fTurn)
	Players[iPlayer]:SetGraphData(gType, fTurn or GetITGGameTurn(), iValue, bCheckPrev);
end

function GetNumGraphData(iPlayer, gType, iExclude)
	local a = 0;
	if iExclude then
		for c, d in pairs(Players[iPlayer]:GetGraphData(gType)) do
			if d ~= iExclude then
				a = a + 1;
			end
		end
	else
		for c, d in pairs(Players[iPlayer]:GetGraphData(gType)) do
			a = a + 1;
		end
	end
	return a;
end

function GetLastGraphData(iPlayer, gType)
	local a;
	local b = -1;
	for c, d in pairs(Players[iPlayer]:GetGraphData(gType)) do
		if c > b then
			b = c;
			a = d;
		end
	end
	return a;
end

function HasMilitaryUnitOrCityAdjacentToPlot(x, y, iPlayer)
	for i = 0, 5 do
		local nPlot = Map.PlotDirection(x, y, i);
		if nPlot then
			if nPlot:IsCity() then
				if nPlot:GetOwner() == iPlayer then
					return true;
				end
			else
				for j = 0, nPlot:GetNumUnits() - 1 do
					local nUnit = nPlot:GetUnit(j);
					if nUnit:GetOwner() == iPlayer then
						if gT.Players[iPlayer].UnitClassXP[nUnit:GetUnitClassType()] then
							return true;
						end
					end
				end
			end
		end
	end
	return false;
end