local bInquisition = GameInfoTypes.BUILDING_ITG_NEW_WORLD_INQUISITION;
local uHeretic = GameInfoTypes.UNIT_ITG_HERETIC;
local tpg1 = GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_PAGAN_1;
local arab4tech = GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_ARAB_4;
local arabtrial7 = GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_ARABIA_7

local heresyNames = {"Adoptionism", "Apollinarism", "Arabici", "Arianism", "Collyridianism", "Docetism", "Luciferians", "Pneumatomachians", "Melchisedechians", "Monarchianism", "Eutychianism", "Monothelitism",
"Nestorianism", "Patripassianism", "Psilanthropism", "Sabellianism", "Tritheism", "Manichaeism", "Paulicianism", "Priscillianism", "Naassenes", "Sethian", "Ophites", "Valentianism", "Antinomianism",
"Audianism", "Barallot", "Circumcellions", "Donatism", "Ebionites", "Euchites", "Iconoclasm", "Marcionism", "Montanism", "Pelagianism", "Semipelagianism", "Bogomils", "Catharism", "Free Spirit", "Fraticelli", "Henricians",
"Triclavianism", "Waldensians", "Febronianism", "Gallicanism", "Jansenism", "Josephinism"}


local hereticsNames = {"Theodotus of Byzantium", "Paul of Samosata", "Apollinaris of Laodicea", "Arius", "Epiphanius", "Lucifer Calaritanus", "Macedonius I", "Eutyches", "Nestorius", "Noetus of Smyrna",
"Sabellius", "Mani", "Priscillian", "Naassenes", "Mariamne", "Valentinus", "Audius", "Donatus Magnus", "Marcion of Sinope", "Montanus", "Pelagius", "Henry of Lausanne"}

function HasOngoingHeresy(iPlayer)
	for iCity in Players[iPlayer]:Cities() do
		if IsHeresyInCity(iCity) then
			return true;
		end
	end
	return false;
end

function DoGrantAltRewardFromHeresy(iPlayer, iCity, cID, iReward)
	local strText = "";
	local bHuman = Players[iPlayer]:IsHuman();
	if iReward == 1 then
		ChangeITGScience(iPlayer, 100)
		ChangeMeritocracy(iPlayer, 5);
		if bHuman then
			strText = "Some new school of an old religion was founded in " .. iCity:GetName() .. ", thankfully nobody has overreacted and we learnt something today (+100[ICON_RESEARCH]+5[ICON_ITG_MERITOCRACY])."
		end
	elseif iReward == 2 then
		ChangeITGCulture(iPlayer, 100)
		ChangeITGHappinessInTheCity(iCity, 4)
		if bHuman then
			strText = "New teachings of an old religion were spread across " .. iCity:GetName() .. ", a great occassion for new dialogue (+100[ICON_CULTURE]+4[ICON_HAPPINESS_1])."
		end
	end
	if bHuman then
		Players[iPlayer]:AddNotification(94343293, strText, "Heresy?", iCity:GetX(), iCity:GetY(), 23)
	end
end

function DoHeresyOnRiots(iCity, cID, iPlayer, bForce)
	if not DBScenario.HeresyOn then
		return false;
	end
	if IsHeresyInCity(iCity) then
		return false;
	end
	if iCity:GetReligiousMajority() < 1 then
		return false;
	end
	if HasPlayerTech(iPlayer, tpg1, "tpg1") then
		return false;
	end
	if bForce or (LastRandom(1, 1000) <= GetHeresyChanceRightNow(iCity, cID, iPlayer)) then
		gT.Globals.HeresyGlobal = math.max(0, gT.Globals.HeresyGlobal - 10);
		gT.Players[iPlayer].HeresyLocal = gT.Players[iPlayer].HeresyLocal - 10;
		gT.Players[iPlayer].HeresyPilgrimSlayer = math.floor(gT.Players[iPlayer].HeresyPilgrimSlayer / 2);
		if (not bForce) and HasFoundedReligionFromHeresy(iPlayer, iCity) then
			return true;
		end
		local altRewards = {};
		if gT.Players[iPlayer].CultBonusOn[16] then
			if LastChance(50) then
				table.insert(altRewards, 1)
			end
		end
		if gT.Players[iPlayer].CultBonusOn[71] then
			if LastChance(50) then
				table.insert(altRewards, 2)
			end
		end
		if #altRewards > 0 then
			DoGrantAltRewardFromHeresy(iPlayer, iCity, cID, RandomFromTab(altRewards));
			return true;
		end
		local pPlot = GetEmptyPlotForHeresyUprising(iCity, iPlayer);
		if pPlot then
			local jUnit = Players[63]:InitUnit(uHeretic, pPlot:GetX(), pPlot:GetY())
			local sName = hereticsNames[LastRandom(1, #hereticsNames)]
			jUnit:SetName(sName);
			jUnit:SetIsUnjoinable(true)
			table.insert(gT.Heresies, {Active = true, UnitID = jUnit:GetID(), LeaderName = sName, City = iCity:Plot():GetPlotIndex(), Start = GetITGGameTurn(), Pstarted = iPlayer, Name = heresyNames[LastRandom(1,#heresyNames)]})
			gT.Cities[cID].Heresy = #gT.Heresies;
			local tSpawn = LastRandom(2, 4)
			if gT.Globals.CultBonus174 > 0 then
				if not gT.Players[iPlayer].CultBonusOn[174] then
					tSpawn = tSpawn + 1;
				end
			end
			if Players[iPlayer]:IsHuman() then
				Players[iPlayer]:AddNotification(94343293, "Heretics following " .. sName .. " took control over " .. iCity:GetName() .. " declaring it a Holy City for their false beliefs of " .. gT.Heresies[#gT.Heresies].Name .. ".", "Heresy!", iCity:GetX(), iCity:GetY(), 23)
			end
			for i = 1, tSpawn do
				gT.Players[iPlayer].LHRebelsSpawned = gT.Players[iPlayer].LHRebelsSpawned + CreateBarbarianUnitFromRiots(iPlayer, pPlot, "DOMAIN_LAND", 63, iCity, true)
			end
			iCity:ChangeResistanceTurns(999)
			if Players[iPlayer]:IsHuman() then
				LuaEvents.ITG_AchievementCompleted(39)
			end
			return true;
		end
		print("Heresy can't find empty plot!!!", iCity:GetName())
	end
	return false;
end

function GetEmptyPlotForHeresyUprising(iCity, iPlayer)
	local pTab = GetEmptyValidPlotsInArea(iCity:Plot(), 1, iPlayer, true);
	local pPlot;
	if #pTab > 0 then
		pPlot = pTab[LastRandom(1, #pTab)];
	else
		--jump make space
		local eTab = {}
		for j = 0, 5 do
			local nPlot = Map.PlotDirection(iCity:GetX(), iCity:GetY(), j);
			if nPlot then
				if not nPlot:IsWater() then
					if not IsSpecialControlPlot(nPlot:GetPlotIndex()) then
						if IsValidTerrainForUnitSpawn(nPlot) then
							table.insert(eTab, nPlot)
						end
					end
				end
			end
		end
		if #eTab > 0 then
			pPlot = eTab[LastRandom(1, #eTab)];
			local tabToJump = {};
			for j = 0, pPlot:GetNumUnits() - 1 do
				table.insert(tabToJump, pPlot:GetUnit(j));
			end
			for j, jUnit in pairs(tabToJump) do
				jUnit:JumpToNearestValidPlot();
			end
		end
	end
	return pPlot;
end

function CallToEndHeresy(unitId, eKillingPlayer)
	for a, b in pairs(gT.Heresies) do
		if b.UnitID == unitId then
			if b.Active then
				EndHeresyImmediately(a, eKillingPlayer)
			end
			return;
		end
	end
end

function DoCheckAllHeresies() --aka doturn
	for a, b in pairs(gT.Heresies) do
		if b.Active then
			local hUnit = Players[63]:GetUnitByID(b.UnitID);
			if not hUnit then
				EndHeresyImmediately(a)
			end
		end
	end
	if gT.Globals.ScenarioType == 2 then
		DoIncreaseHeresyProbability(3)
	end
	for junitID, cID in pairs(gT.Globals.UprisingCID) do
		if not Players[63]:GetUnitByID(junitID) then
			print("WOAH BARB UNIT DISAPPEARED actually? rebel join?", jUnitID, cID)
			if gT.Cities[cID].Uprising then
				gT.Cities[cID].Uprising[junitID] = nil;
				if ShouldCityEndUprising(cID) then
					EndUprisingImmediately(Map.GetPlotByIndex(gT.Cities[cID].Plot):GetPlotCity(), cID, -1, false)
				end
			else
				print("AND there was no uprising on-going!")
			end
			gT.Globals.UprisingCID[junitID] = nil;
		end
	end
	--now insurgents will join origin player if military unit is adjacent
	local toCheck = {}
	for junitID, cID in pairs(gT.Globals.UprisingCID) do
		if not toCheck[cID] then
			local bUnit = Players[63]:GetUnitByID(junitID);
			if bUnit then
				toCheck[cID] = {bUnit:GetX(), bUnit:GetY(), bUnit:GetRebelOrigin(), bUnit:GetRebelAgainst()}
			end
		end
	end
	for cID, data in pairs(toCheck) do
		if Teams[data[3]]:IsAtWar(data[4]) then
			if gT.Players[data[3]] then
				if HasMilitaryUnitOrCityAdjacentToPlot(data[1], data[2], data[3]) then
					local toSpawn = {}
					local iPlot = Map.GetPlot(data[1], data[2]);
					for junitID, hID in pairs(gT.Globals.UprisingCID) do
						if hID == cID then
							local bUnit = Players[63]:GetUnitByID(junitID);
							if bUnit then
								table.insert(toSpawn, {bUnit:GetUnitType(), bUnit:GetMaxHitPoints() - bUnit:GetDamage()});
							end
							gT.Globals.UprisingCID[junitID] = nil;
							bUnit:Kill(true, -1)
						end
					end
					EndUprisingImmediately(Map.GetPlotByIndex(gT.Cities[cID].Plot):GetPlotCity(), cID, -1, false)
					for a, b in pairs(toSpawn) do
						local iUnit = SimpleGenerateUnitOfType(data[3], b[1], iPlot, nil, nil, nil, nil, nil, nil, b[2], nil);
						SetUnitForcedStackType(iUnit, -1, "EndUpr", 4);
					end
					if Players[data[3]]:IsHuman() then
						LuaEvents.ITG_AchievementCompleted(126)
					end
				end
			end
		end
	end
end

function SpawnExtraHeretics(iHeresyID, tSpawn)
	local hUnit = Players[63]:GetUnitByID(gT.Heresies[iHeresyID].UnitID);
	if hUnit then
		local pPlot = hUnit:GetPlot();
		local iCity = Map.GetPlotByIndex(gT.Heresies[iHeresyID].City):GetPlotCity();
		local iPlayer = iCity:GetOwner();
		for i = 1, tSpawn do
			gT.Players[iPlayer].LHRebelsSpawned = gT.Players[iPlayer].LHRebelsSpawned + CreateBarbarianUnitFromRiots(iPlayer, pPlot, "DOMAIN_LAND", 63, iCity, true)
		end
	end
end

function EndHeresyDiplomatically(iHeresyID)
	local hUnit = Players[63]:GetUnitByID(gT.Heresies[iHeresyID].UnitID);
	local tabToKill = {}
	if hUnit then
		local iPlot = hUnit:GetPlot();
		for i = 0, iPlot:GetNumUnits() - 1 do
			local jUnit = iPlot:GetUnit(i);
			if jUnit:GetOwner() == 63 then
				table.insert(tabToKill, jUnit);
			end
		end
	end
	EndHeresyImmediately(iHeresyID, nil, nil)
	for i, iUnit in pairs(tabToKill) do
		iUnit:Kill(true, -1);
	end
end

function EndHeresyImmediately(a, eKillingPlayer, bConquer)
	if not gT.Heresies[a].Active then
		return;
	end
	local iCity = Map.GetPlotByIndex(gT.Heresies[a].City):GetPlotCity()
	local iOwner = iCity:GetOwner();
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	if not bConquer then
		if not gT.Cities[cID].Uprising then
			iCity:ChangeResistanceTurns(-1 * iCity:GetResistanceTurns())
		end
	end
	gT.Cities[cID].Heresy = nil;
	gT.Heresies[a].Active = false;
	gT.Heresies[a].End = GetITGGameTurn();
	gT.Heresies[a].Pended = iOwner;
	if eKillingPlayer and (eKillingPlayer ~= -1) then
		if Players[eKillingPlayer]:IsHuman() then
			if eKillingPlayer ~= iOwner then
				LuaEvents.ITG_AchievementCompleted(40)
			end
		end
		if eKillingPlayer == iOwner then
			BasicCSMissionCompleteFunc(eKillingPlayer, 17)
		end
	end
	DiploNoteDirty(iOwner, 19)
end

function HaveRiotsSpawnedUprising(iPlayer, iCity, cID)
	if gT.Cities[cID].Uprising then
		return false;
	end
	if gT.Globals.Ideo21 then
		if not gT.Players[iPlayer].HasIdeology[21] then
			local tPlayer = iCity:GetOriginalOwner();
			if tPlayer ~= iPlayer then
				local chance = 25;
				if gT.Players[tPlayer].HasIdeology[21] then
					chance = chance + 25;
				end
				if LastChance(chance) then
					return StartCityUprising(iCity, cID, LastRandom(2,4))
				end
			end
		end
	end
	return false;
end

function StartCityUprising(iCity, cID, tSpawn)
	local iPlayer = iCity:GetOwner();
	local pPlot = GetEmptyPlotForHeresyUprising(iCity, iPlayer);
	if pPlot then
		gT.Cities[cID].Uprising = {};
		if IsAffectedBySponsorRebels(iPlayer) then
			tSpawn = tSpawn + 2;
		end
		for i = 1, tSpawn do
			gT.Players[iPlayer].LHRebelsSpawned = gT.Players[iPlayer].LHRebelsSpawned + CreateBarbarianUnitFromRiots(iPlayer, pPlot, "DOMAIN_LAND", 63, iCity, false, cID)
		end
		if ShouldCityEndUprising(cID) then
			gT.Cities[cID].Uprising = nil
			return false;
		end
		gT.Cities[cID].UprisingOrigin = iCity:GetOriginalOwner();
		iCity:ChangeResistanceTurns(999)
		if Players[iPlayer]:IsHuman() then
			Players[iPlayer]:AddNotification(94343293, "Insurgents took control over " .. iCity:GetName() .. ".", "Uprising!", iCity:GetX(), iCity:GetY(), 5)
		end
		return true;
	end
	return false;
end

function ShouldCityEndUprising(cID)
	for jid, h in pairs(gT.Cities[cID].Uprising) do
		return false;
	end
	return true;
end

function CheckUnitUprisingKill(unitId, eKillingPlayer)
	local cID = gT.Globals.UprisingCID[unitId]
	if cID then
		if gT.Cities[cID].Uprising then
			gT.Cities[cID].Uprising[unitId] = nil;
			if ShouldCityEndUprising(cID) then
				EndUprisingImmediately(Map.GetPlotByIndex(gT.Cities[cID].Plot):GetPlotCity(), cID, eKillingPlayer, false)
			end
		end
		gT.Globals.UprisingCID[unitId] = nil;
	end
end

function EndUprisingImmediately(iCity, cID, eKillingPlayer, bConquer)
	if not gT.Cities[cID].Uprising then
		return;
	end
	gT.Cities[cID].Uprising = nil;
	gT.Cities[cID].UprisingOrigin = nil;
	if not bConquer then
		if not gT.Cities[cID].Heresy then
			iCity:ChangeResistanceTurns(-1 * iCity:GetResistanceTurns())
		end
	end
end

function GetHeresyChanceRightNow(iCity, cID, iPlayer, bNoMods)
	if Players[iPlayer]:GetNumCities() < 3 then
		return 0;
	end
	if not DBScenario.HeresyOn then
		return 0;
	end
	if gT.Players[iPlayer].SecularState then
		return 0;
	end
	local baseV = gT.Globals.HeresyGlobal + gT.Players[iPlayer].HeresyLocal + gT.Players[iPlayer].HeresyPilgrimSlayer + GetHeresyChanceFromCult174(iPlayer);
	baseV = baseV + GetHeresyChanceFromLackOfficial(iPlayer) + GetHeresyChanceFromCitiesHeresy(iPlayer) + GetHeresyChanceFromInnovation(iPlayer);
	if iCity then
		baseV = baseV + GetHeresyChanceTemplarBuildings(iPlayer, iCity);
	end
	if HasPlayerTech(iPlayer, arab4tech, "7124124") then
		baseV = math.ceil(baseV / 2);
	end
	return math.max(0,baseV);
end

function GetHeresyChanceTemplarBuildings(iPlayer, iCity)
	if IsHasLaw(iPlayer, 22, 1) then
		return 70 * GetNumCityTemplarBuildings(iCity);
	end
	return 0;
end

function GetHeresyChanceFromCitiesHeresy(iPlayer)
	local numCities = Players[iPlayer]:GetNumCities();
	if numCities == 0 then	
		return 0;
	end
	local baseV = 0;
	for dCity in Players[iPlayer]:Cities() do 
		baseV = baseV + GetCityModifierFromHeresy(dCity);
	end
	return math.floor(baseV * 10 + 50 * baseV / numCities);
end

function GetHeresyChanceFromLackOfficial(iPlayer)
	if not gT.Players[iPlayer].OfficialReligion then
		return -50;
	end
	return 0;
end

function GetHeresyChanceFromCult174(iPlayer)
	if gT.Globals.CultBonus174 > 0 then
		if not gT.Players[iPlayer].CultBonusOn[174] then
			return 50;
		end
	end
	return 0;
end

function IsHeresyInCity(iCity)
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	if gT.Cities[cID].Heresy then
		return true;
	end
	return false;
end

function HasFoundedReligionFromHeresy(iPlayer, iCity)
	if gT.Players[iPlayer].OfficialReligion then
		if Players[iPlayer]:IsMinorCiv() then
			if Players[iPlayer]:GetReligionCreatedByPlayer() < 1 then
				if LastRandom(1, 8) == 3 then
					DoRemoveOfficialReligion(iPlayer)
					DoNewReligion(iPlayer, iCity)
					local aRel = Players[iPlayer]:GetReligionCreatedByPlayer();
					if aRel > 0 then
						for bm, h in pairs(gT.Globals.HumanPlayers) do
							if Teams[Players[h]:GetTeam()]:IsHasMet(Players[iPlayer]:GetTeam()) then
								Players[iPlayer]:AddNotification(94343293, "Heretics found new religion, " .. Locale.Lookup(GameInfo.Religions[aRel].Description) .. " in " .. Players[iPlayer]:GetName() .. ".", "Heresy!", iCity:GetX(), iCity:GetY(), 23)
							end
						end
					else
						print("Error 9252340234")
					end
					return true;
				end
			end
		end
	end
	return false;
end

function DoIncreaseHeresyProbability(val, iPlayer)
	if gT.Globals.GameGenerated then
		gT.Globals.HeresyGlobal = gT.Globals.HeresyGlobal + val;
		if iPlayer then
			gT.Players[iPlayer].HeresyLocal = gT.Players[iPlayer].HeresyLocal + val;
		end
	end
end

function DoChangeLocalTheologyHeresy(iPlayer, val)
	gT.Players[iPlayer].HeresyLocal = gT.Players[iPlayer].HeresyLocal + val;
end

function GetHeresyChanceFromInnovation(iPlayer)
	local a = 0;
	if HasPlayerTech(iPlayer, arabtrial7, "adaweqdqw") then
		a = a - 10 * GetNumOfGPCivilOfType(iPlayer, 9)
	end
	return a;
end

function GetHeresyTextForTP(iPlayer)
	local str = "Player's [ICON_PROPHET] Heresy displays a chance for normal rebels to be replaced with religious fanatics. City overrun by heretics remains in [ICON_RESISTANCE] Resistance as long as [ICON_PROPHET] Heretic leader is alive.[NEWLINE][NEWLINE][ICON_PROPHET] Heresy sources:"
	local tab = {}
	table.insert(tab, {gT.Globals.HeresyGlobal, "Global theology"})
	table.insert(tab, {gT.Players[iPlayer].HeresyLocal, "Local theology"})
	table.insert(tab, {gT.Players[iPlayer].HeresyPilgrimSlayer, "Slayed Pilgrims"})
	table.insert(tab, {GetHeresyChanceFromCitiesHeresy(iPlayer), "Cities' Heresy"})
	table.insert(tab, {GetHeresyChanceFromCult174(iPlayer), "Rival Social Development"})
	table.insert(tab, {GetHeresyChanceFromInnovation(iPlayer), "Innovations"})
	table.insert(tab, {GetHeresyChanceFromLackOfficial(iPlayer), "Lack of Official Religion"})
	for a, b in pairs(tab) do 
		if b[1] ~= 0 then
			if b[1] > 0 then
				str =  str .. "[NEWLINE][ICON_BULLET]+" .. b[1]/10 .. "% from " .. b[2] .. ".";
			else
				str =  str .. "[NEWLINE][ICON_BULLET]" .. b[1]/10 .. "% from " .. b[2] .. ".";
			end
		end
	end
	local bFirst = true;
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		if gT.Cities[cID].Heresy then
			if bFirst then
				bFirst = false;
				str = str .. "[NEWLINE][NEWLINE]Cities with ongoing [ICON_PROPHET] Heresy:"
			end
			str = str .. "[NEWLINE][ICON_BULLET]" .. iCity:GetName() .. " is overrun with followers of [COLOR_NEGATIVE_TEXT]" .. gT.Heresies[gT.Cities[cID].Heresy].Name .. "[ENDCOLOR]."
		end
	end
	if IsHasLaw(iPlayer, 22, 1) then
		str = str .. "[NEWLINE][NEWLINE]Chance for invidual Cities is modified by Cult Objects (law)."
	end
	str = str .. "[NEWLINE][NEWLINE]Founding new Religion or adopting new beliefs increase [ICON_PROPHET] Heresy globally. Increasement from reforming beliefs is greater and also doubled for a player responsible." 
	return str;
end

function GetCityHeresyStringOrNil(iCity)
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	if gT.Cities[cID].Heresy then
		MapModData.ITGSG = gT.Heresies[gT.Cities[cID].Heresy].Name;
	end
	if gT.Cities[cID].Uprising then
		MapModData.ITGSG2 = gT.Cities[cID].UprisingOrigin;
	end
end
LuaEvents.ITGRequestHeresyCityString.Add(GetCityHeresyStringOrNil)

function CheckTheIncomingYear(season, nTurn)
	if season == 1 then
		TickTheYear(GetYearFromTurn(nTurn))
	end
	gT.Globals.Season = (season % 4) + 1;
end

function TickTheYear(year)
--[[	if year == 1000 then
		DoIncreaseHeresyProbability(300)
		for i, human in pairs(gT.Globals.HumanPlayers) do
			Players[human]:AddNotification(NotificationTypes.NOTIFICATION_GENERIC, "Unfortunately common folks are easily seduced to round numbers in decimal system. In every town and village you can hear an idiot proclaiming end of the times (+30% chance for Heresy)!", "Millennialism!", -1, -1)
		end
	end 

	Such events should be optional content;
	]]
end