local cultEraString;

function GetCultureHnGTitle(iPlayer)
	local hh = LastRandom(1, 7);
	if hh == 1 then
		return cultEraString;
	elseif hh == 2 then
		return "Cultural patronage"
	elseif hh == 3 then
		return cultEraString .. " in " .. Players[iPlayer]:GetCivilizationShortDescription(); 
	elseif hh == 4 then
		return HnGLeaderName() .. " and " .. cultEraString;
	elseif hh == 5 then
		return "Art and architecture in " .. HnGLeaderName() .. "'s reign"
	elseif hh == 6 then
		return "Artistic revolution"
	elseif hh == 7 then
		return "Architectural style"
	end
end

function GetArtNameBasicOfGPType(iType)
	local tab = {"pieces", "works"}
	if iType == 6 then
		table.insert(tab, "operas")
	elseif iType == 7 then
		table.insert(tab,"epics")
	elseif iType == 8 then
		table.insert(tab,"paintings")
	end
	return tab[LastRandom(1, #tab)];
end

function MadeADecentAmountOfGW(iPlayer)
	local iavg, itotal = 0, 0;
	for g, h in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			iavg = iavg + h.NumGreatWorks;
			itotal = itotal + 1;
		end
	end
	iavg = iavg / itotal;
	return gT.Players[iPlayer].NumGreatWorks >= iavg * 2;
end

function HnGGetDecadenceOrPoverty(iPlayer)
	if gT.Players[iPlayer].TotalDecadentism > 50 then
		return "decadence";
	else
		return "poverty";
	end
end

function GetCultureHnGString(iPlayer)
	local tString = gT.Globals.CultureErasNames[gT.Players[iPlayer].CultureType][math.ceil(gT.Players[iPlayer].CultureEra / 3) * 3];
	local lH = string.len(tString);
	if lH > 5 then
		return string.sub(tString, 5 - lH)
	end
	return "Uh no culture strinG " .. iPlayer .. " " .. tString
end

function GetHnGCultureNote(iPlayer)
	local cType = gT.Players[iPlayer].CultureType;
	if gT.Globals.HnGData.CultureAdvances[cType] and gT.Globals.HnGData.CultureAdvances[cType][1] == iPlayer then
		local iLevel = gT.Players[iPlayer].CultureEra;
		cultEraString = GetCultureHnGString(iPlayer);
		local gArtMusWri = {};
		local gForeign = {}
		local text;
		for gpid, th in pairs(gT.GreatPeople) do
			if (th.Type == 6 or th.Type == 7 or th.Type == 8) then
				if (not th.TurnDied) or (th.TurnDied > gT.Globals.HnGData.CultureAdvances[cType][2]) then
					if th.OriginPlayer == iPlayer then
						table.insert(gArtMusWri, gpid)
					elseif th.Player == iPlayer then
						table.insert(gForeign, gpid);
					end
				end
			end
		end
		local turn = gT.Globals.HnGData.CultureAdvances[cType][2];
		local bMadeADecentAmountofGW = MadeADecentAmountOfGW(iPlayer)
		gArtMusWri = Shuffle(gArtMusWri);
		gForeign = Shuffle(gForeign);
		local hh = LastRandom(1,5);
		if hh == 1 then
			text = HnGLeaderName() .. " actively supported art and liked to surround " .. HnGGS("himself") .. " with renowned artists. This created a solid ground for an outburst of new ideas and concepts, which ultimately lead to an art style today known as " .. cultEraString .. "."
			if #gArtMusWri >= 3 then
				text = text .. " Both " .. GetGPName(gArtMusWri[1]) .. " and " .. GetGPName(gArtMusWri[2]) .. " were common visitors at court. Other notable artist of " ..  cultEraString .. ", " .. GetGPName(gArtMusWri[3]) .. " dedicated several of " .. GetArtNameBasicOfGPType(gT.GreatPeople[gArtMusWri[3]].Type) .. " to " .. HnGLeaderTitle() .. "."
			end
			if #gForeign >= 2 then
				text = text .. " New style was refreshing and attractive even to artists outside the realm, many artists decided to settle in " .. Players[iPlayer]:GetCivilizationShortDescription() .. " to learn it, among others " ..  GetGPName(gForeign[1]) .. " and " .. GetGPName(gForeign[2]) .. ".";
			end
			text = text .. " Scholars dispute about the role and impact " .. HnGLeaderName() .. " had upon the birth of " .. cultEraString .. ", some radical voices are neglecting " .. HnGGS("his") .. "'s role and stating that it was rather the effect of changing world and times rather than " .. HnGLeaderName() .. "'s generousity."
			if bMadeADecentAmountofGW then
				text = text .. " Yet one thing is certain, this period created a " .. HnGSynonym("substantial") .. " amount of great works that passed the test of time.";
			end
		elseif hh == 2 then
			text = "The reign of " .. HnGLeaderName() .. " is marked by cultural revolution that started in " .. Players[iPlayer]:GetCivilizationShortDescription() .. ". Artists felt bored with existing forms and standards which lead to the birth of the style called later " .. cultEraString .. "."
			if #gArtMusWri >= 1 then
				text = text .. " Some researchers are pointing the date of " .. HnGDate(turn) .. " as official birth of " .. cultEraString .. ". In this year, " .. GetGPName(gArtMusWri[1]) .. " presented world the newest collection of " .. GetArtNameBasicOfGPType(gT.GreatPeople[gArtMusWri[1]].Type) .. " that marked next century."
				if #gArtMusWri >= 3 then
					text = text .. " Shortly after that, other famous personalities, " .. GetGPName(gArtMusWri[2]) .. " or " .. GetGPName(gArtMusWri[3]) .. " followed up those ideas and forged their place in history of art."
				end
			end
			if #gForeign >= 2 then
				text = text .. " " .. Players[iPlayer]:GetCivilizationShortDescription() .. " became a destination of aspiring artist from other nations, " .. GetGPName(gForeign[1]) .. " spend an early years on studying " .. cultEraString .. " while " .. GetGPName(gForeign[2]) .. " documented his visit in journals."
			end
			if bMadeADecentAmountofGW then
				text = text .. " Today, tourists can admire a " .. HnGSynonym("substantial") .. " amount of art created during " .. HnGLeaderName() .. "'s title in numerous exhibitions' dedicated to " .. cultEraString .. ".";
			end
		elseif hh == 3 then
			text = "Within " .. HnGGS("his") .. " rule artists developed new unique style of " .. cultEraString .. " in response to quickly evolving world. It was marked by a " .. HnGGetDecadenceOrPoverty(iPlayer) .. " of times and melancholy. " .. HnGLeaderName() .. "'s " .. HnGGS("spouse") .. " is known to actively supporting this new movement in literature and art."
			if #gArtMusWri >= 3 then
				text = text .. " Some great names of " .. cultEraString .. " like " .. GetGPName(gArtMusWri[1]) .. ", " .. GetGPName(gArtMusWri[2]) .. " or " .. GetGPName(gArtMusWri[3]) .. " personally benefited from this patronage. It is uknown if they ever met " .. HnGLeaderTitle() .. ", who was busy with more important matters." 
			end
			if #gForeign >= 2 then
				text = text .. " Two foreign artists were invited to court, " .. GetGPName(gForeign[1]) .. " and " .. GetGPName(gForeign[2]) .. " were living and creating in " .. GetRandomCityForHnG(iPlayer):GetName() .. " to their deaths."
			end
			if bMadeADecentAmountofGW then
				text = text .. " It all resulted in creation of " .. HnGSynonym("substantial") .. " amount of works that can be still admired by millions around the world."
			end
		elseif hh == 4 then
			text = "The " .. HnGLeaderName() .. "'s reign is a birthplace of " .. cultEraString .. " which is traced by scholars to " .. GetCenturyThFromYear(turn) .. "'s " .. GetRandomCityForHnG(iPlayer):GetName() .. "."			
			if #gArtMusWri >= 3 then
				text = text .. " In this city three of the most important " .. cultEraString .. "'s creators started their journey with new style and revolutionized art. The house of " .. GetGPName(gArtMusWri[1]) .. " is still standing and now serving as museum, in the city we can also find a graves of " .. GetGPName(gArtMusWri[2]) .. " and " .. GetGPName(gArtMusWri[3]) .. "."
			end
			if #gForeign >= 2 then
				text = text .. " Style was quickly adapted by foreign artists, within a decade other prominent personalities like " .. GetGPName(gForeign[1]) .. " and " .. GetGPName(gForeign[2]) .. " adapted their style to the new one."
			end
			if bMadeADecentAmountofGW then
				text = text .. " " ..  HnGLeaderName() .. " collected enormous collection of " .. cultEraString .. "'s art, some of which unfortunately was lost in fire. The rest can be now admired in " .. HnGGS("his") .. " palace."
			end
		elseif hh == 5 then
			text = CapitalFL(cultEraString) .. " is strongly related to " .. HnGLeaderName() .. "'s leadership and some scholars even believe that it would be impossible for this style to arise without " .. HnGLeaderTitle() .. "'s support and patronage of arts. During " .. HnGGS("his") .. " younger years " .. HnGGS("he") .. " was aspiring to become an artist however fate decided otherwise."
			if #gArtMusWri >= 3 then
				text = text .. " Yet through " .. HnGGS("his") .. " sympathy and generousity others could spread their wings and now we can admire works of " .. GetGPName(gArtMusWri[1]) .. ", " .. GetGPName(gArtMusWri[2]) .. ", " .. GetGPName(gArtMusWri[3]) .. " and others." 
			end
			if #gForeign >= 2 then
				text = text .. " " .. HnGLeaderName() .. " believed that artists are separate, spiritual nation and therefore was ignoring political differences by inviting foreign masters from rival countries. " .. CapitalFL(HnGGS("he")) .. " personally met " .. GetGPName(gForeign[1]) .. " and " .. GetGPName(gForeign[2]) .. ".";
			end
			if bMadeADecentAmountofGW then
				text = text .. " Most of great works from " .. HnGGS("his") .. " reign can be admired in national museums. Unfortunately some notable paintings and statues are in ownership of private collectors."
			end
		end
		table.insert(gT.Players[iPlayer].HistoryNote, {Title = GetCultureHnGTitle(iPlayer), Text = text, TitleDivider = true})
	end
end