function GetHnGAlphabetTitle(iPlayer)
	local lTab = {{1, 10}, {2, 10}, {3, 10}, {4, 10}, {5, 10}, {6, 10}, {7, 10}}
	local hh = GetRandomFromBiasedChanceTable(lTab)
	if hh == 1 then
		return CapitalFL(HnGGS("man")) .. " of letters"
	elseif hh == 2 then
		return "Promotion of " .. Players[iPlayer]:GetCivilizationAdjective() .. " language"
	elseif hh == 3 then
		return "Standardized alphabet"
	elseif hh == 4 then
		return "Unified alphabet and language"
	elseif hh == 5 then
		return Players[iPlayer]:GetCivilizationAdjective() .. " language"
	elseif hh == 6 then
		return "New alphabet"
	elseif hh == 7 then
		return "Literacy"
	end
end

function GetHnGAlphabetNote(iPlayer)
	if gT.Globals.HnGData.Alphabets[iPlayer] then
		local title = GetHnGAlphabetTitle(iPlayer);
		local text;
		local lTab = {{1, 10}, {2, 10}, {3, 10}, {4, 10}, {5,10}, {6, 10}, {7, 10}, {8, 10}}
		local hh = GetRandomFromBiasedChanceTable(lTab)
		if hh == 1 then
			text = HnGLeaderName() .. " took several steps to eradicate the monopoly of foreign languages as those of knowledge. In " .. HnGDate(gT.Globals.HnGData.Alphabets[iPlayer]) .. ", " .. HnGGS("he") .. " declared " .. Players[iPlayer]:GetCivilizationAdjective() .. " the national language of the kingdom, and that same year standardized alphabet. Some efforts were also made to standardize language within the realm, however local dialects outlasted those actions."
		elseif hh == 2 then
			text = "In " .. HnGDate(gT.Globals.HnGData.Alphabets[iPlayer]) .. ", in " .. HnGGS("his") .. " residence, " .. HnGLeaderName() .. " signed the important edict known as Ordinance of " .. GetRandomCityForHnG(iPlayer):GetName() .. ", which, among other reforms, made " .. Players[iPlayer]:GetCivilizationAdjective() .. " the administrative language of the kingdom and standardized alphabet. This same edict required governors to register births, marriages, and deaths, and to establish a registry office in every parish."
		elseif hh == 3 then
			text = "For " .. HnGGS("his") .. " role in the development and promotion of a standardized " .. Players[iPlayer]:GetCivilizationAdjective() .. " alphabet and language, " .. HnGGS("he") .. " became known as the ''" .. CapitalFL(HnGGS("father")) .. " and Restorer of Letters''."
		elseif hh == 4 then
			text = HnGLeaderName() .. " was also renowned as a man of letters. " .. CapitalFL(HnGGS("he")) .. " had the great hope to bring culture to the " .. Players[iPlayer]:GetCivilizationAdjective() .. " nation. Not only did " .. HnGLeaderName() .. " support a number of major writers of the period, " .. HnGGS("he") .. " was a poet " .. HnGGS("himself") .. ", if not one of particular abilities. " .. HnGLeaderName() .. " worked diligently at improving the royal library, but " .. HnGGS("his") .. " greatest achievement was of course standardizing " .. Players[iPlayer]:GetCivilizationAdjective() .. " alphabet."
		elseif hh == 5 then
			text = "According to " .. Players[iPlayer]:GetCivilizationAdjective() .. " history, " .. HnGLeaderName() .. " developed the " .. Players[iPlayer]:GetCivilizationAdjective() .. " alphabet from several foreign transcripts already in use. Scholars are unable to confirm it, however first recorded usage of " .. Players[iPlayer]:GetCivilizationAdjective() .. " is indeed dated to " .. GetCenturyThFromYear(80) .. "."
		elseif hh == 6 then
			text = "The " .. Players[iPlayer]:GetCivilizationAdjective() .. " script was adapted from the foreign script, which ultimately descended in popularity in " .. GetCenturyThFromYear(80) .. ". The oldest dated inscription in " ..  Players[iPlayer]:GetCivilizationAdjective() .. " was found at " .. GetRandomCityForHnG(iPlayer):GetName() .. " and dates from " .. HnGDate(gT.Globals.HnGData.Alphabets[iPlayer]) .. ". The modern script differs somewhat from precedent forms seen on the inscriptions from ancient relics. " .. HnGLeaderName() .. "'s input in the creation of script is undocumented."
		elseif hh == 7 then
			text = Players[iPlayer]:GetCivilizationAdjective() .. " is written from left to right. Words within the same sentence or phrase are generally run together with no spaces between them. Consonant clusters within a word are ''stacked'', with the second (and occasionally third) consonant being written in reduced form under the main consonant. Originally there were " .. LastRandom(30, 40) .. " consonant characters, but modern alphabet uses only " .. LastRandom(20, 29) .. ". Each character represents a consonant sound together with an inherent vowel, either a or o; in many cases, in the absence of another vowel mark, the inherent vowel is to be pronounced after the consonant. The creation of alphabet is credited to " .. HnGLeaderName() .. "."
		elseif hh == 8 then
			text =  HnGLeaderName() .. " invented the new alphabet associated to national standards, with a very regular spelling system with a nearly one-to-one correspondence between letters and phonemes. Strictly speaking, " .. HnGLeaderName() .. " saved nation from a nonsense of spelling bee. It had a great impact on national literacy and unity." 
		end
		table.insert(gT.Players[iPlayer].HistoryNote, {Title = title, Text = text, TitleDivider = true})
	end
end

function GetHnGLegalNote(iPlayer)
	GetHnGAlphabetNote(iPlayer)
	if gT.Players[iPlayer].CodexScenario  then
		if gT.Players[iPlayer].CodexScenario == gT.Globals.ScenarioType then
		--codex narrations
			local title = HnGLeaderName() .. "'s Codex";
			local text;
			local bFirstInTheWorld = true;
			local anarchyAfterCodex;
			for a, b in pairs(gT.Globals.HnGData.Anarchies) do
				if b[1] == iPlayer and (b[2] > gT.Players[iPlayer].CodexScenario) and (not b[3]) then
					anarchyAfterCodex = b[2];
					break;
				end
			end
			for g, h in pairs(gT.Players) do
				if g ~= iPlayer then
					if h.CodexScenario then
						if h.CodexScenario ~= gT.Players[iPlayer].CodexScenario then
							bFirstInTheWorld = false;
							break;
						elseif h.CodexTurn < gT.Players[iPlayer].CodexTurn then
							bFirstInTheWorld = false;
							break;
						end
					end
				end
			end
			local lawTab = {}
			local lTab = {}	
			for a, b in pairs(gT.Globals.LawsChangeLog) do
				if b[1] == iPlayer then
					if b[4] < gT.Players[iPlayer].CodexTurn then
						if not lTab[b[2]] then
							lTab[b[2]] = true;
							table.insert(lawTab, {b[2], b[4]})
						end
					end
				end
			end
			lTab = {{1, 10}, {2, 10}, {3, 10}};
			if gT.Globals.ScenarioType == 3 then
				table.insert(lTab, {4, 10})
				table.insert(lTab, {5, 10})
				table.insert(lTab, {6, 10})
			end
			if anarchyAfterCodex then
				table.insert(lTab, {7, 15})
			end
			local maxRand = 1;
			if #lawTab > 0 then
				table.insert(lTab, {8, 12})
				if #lawTab > 5 then
					table.insert(lTab, {11, 15})
				end
			end
			if gT.Players[iPlayer].CodexTurn == 100 then
				table.insert(lTab, {9, 15})
				table.insert(lTab, {10, 15})
			end
			local lType = GetRandomFromBiasedChanceTable(lTab)
			--6+ laws changed before
			--at least 1 law changed	
			--generic no law mentioned
			--anarchy after codex
			if lType == 1 then
				text = "The Codex of " .. HnGLeaderName() .. " is the earliest codification of " .. Players[iPlayer]:GetCivilizationAdjective() .. " law ordered early in the " .. GetCenturyThFromYear(10) .. ". All three main units, were created during " .. HnGGS("his") .. " reign. The fourth part, was compiled unofficially shortly after " .. HnGGS("his") .. " death but is now also thought of as part of the " .. title .. ". This work is a foundation of " .. Players[iPlayer]:GetCivilizationAdjective() .. " legislation and even though some adjustments due to the changing world was needed, is still functioning as official codex in several countries."
			elseif lType == 2 then
				text = "Shortly after " .. HnGLeaderName() .. " became " .. HnGLeaderTitle() .. " in " .. HnGDate(0) .. ", " .. HnGGS("he") .. " decided the empire's legal system needed repair. There existed some codices of imperial laws and other individual laws, many of which conflicted or were out of date. Soon after, " .. HnGLeaderName() .. " promulgated a ten-man commission to review earlier compilations as well as individual laws, eliminate everything unnecessary or obsolete, make changes as it saw fit, and create a single compilation of imperial laws in force. A little is known about members of commission, but their mutual efforts resulted in the official publication of codex in " .. HnGDate(gT.Players[iPlayer].CodexTurn) .. "."
			elseif lType == 3 then
				text = "In " .. HnGDate(gT.Players[iPlayer].CodexTurn) .. " the special commission finished its work in 14 months, and the compilation was promulgated by " .. HnGLeaderTitle() .. " " .. HnGGS("himself") .. ". However, this compilation did not eliminate all the conflicts that had arisen over the years in " .. Players[iPlayer]:GetCivilizationAdjective() .. " jurisprudence, and the constitutions in the Code were to be used alongside the conflicting opinions of ancient jurists. " .. HnGLeaderName() .. " attempted to harmonize these conflicting opinions by issuing his ''" .. CapitalFL(GetNumberString(LastRandom(1,7))) .. " Decisions''. Thus, " .. HnGLeaderName() .. " ordered a new compilation to supersede the first, and this form of Codex is what we know today." 
			elseif lType == 4 then
				text = "The Code of " .. HnGLeaderName() .. " is a well-preserved " .. Players[iPlayer]:GetCivilizationAdjective() .. " code of law of ancient times, dated back to about " .. HnGDate(LastRandom(30, 70)) .. ". It is one of the oldest deciphered writings of significant length in the world. The " .. GetNumberTH(LastRandom(1, 8))  .. " " ..  HnGLeaderTitle() .. ", " .. HnGLeaderName() .. ", enacted the code. A partial copy exists on a 2.25-meter stone stele. It consists of 282 laws, with scaled punishments, adjusting ''an eye for an eye, a tooth for a tooth'' as graded based on social stratification depending on social status and gender, of slave versus free, man versus woman."
			elseif lType == 5 then
				text = "The ancient codex of " .. HnGLeaderName() .. " was edicted in " .. HnGDate(gT.Players[iPlayer].CodexTurn) .. ". Nearly half of the code deals with matters of contract, establishing the wages to be paid to an ox driver or a surgeon for example. Other provisions set the terms of a transaction, the liability of a builder for a house that collapses, or property that is damaged while left in the care of another. A third of the code addresses issues concerning household and family relationships such as inheritance, divorce, paternity, and reproductive behaviour. Only one provision appears to impose obligations on an official; this provision establishes that a judge who alters his decision after it is written down is to be fined and removed from the bench permanently. A few provisions address issues related to military service."
			elseif lType == 6 then
				text = HnGLeaderName() .. " ruled from " .. HnGDate(LastRandom(-10, 10)) .. " to " .. HnGDate(LastRandom(100, 120)) .. " according to the most common chronology. In the preface to the law, " .. HnGGS("he") .. " states, ''Gods called by name me, " .. HnGLeaderName() .. ", the exalted " .. HnGLeaderTitle() .. ", who feared God of Justice, to bring about the rule of righteousness in the land, to destroy the wicked and the evil-doers; so that the strong should not harm the weak; so that I should rule over the black-headed people like shepherd, and enlighten the land, to further the well-being of mankind.'' On the stone slab are " .. LastRandom(35, 55) .. " columns and " .. LastRandom(25, 35) .. " paragraphs that contained " .. LastRandom(40, 300) .. " laws. Some of these laws follow along the rules of ''an eye for an eye''."
			elseif lType == 7 then
				text = "On of the most " .. HnGSynonym("important") .. " achievements, " .. title .. " had " .. HnGSynonym("unpleasant") .. " repercussion on " .. HnGGS("his") .. " reign. The code was released in " .. HnGDate(gT.Players[iPlayer].CodexTurn) .. " and contained mainly laws about civil service, jurisdiction and public space, however some of them were considered a " .. HnGSynonym("blatant") .. " attack on nobility. It is believed that it was the main reason behind " .. HnGDate(anarchyAfterCodex) .. " coup, which interrupted " .. HnGLeaderTitle() .. " reforms. In longer term, " .. HnGLeaderName() .. " won over reactionists, because " .. HnGGS("his") .. " laws are used to this day." 
			elseif lType == 8 then
				text = "In " .. HnGDate(lawTab[1][2]) .. " " .. HnGLeaderName() .. " changed " .. HnGGS("his") .. " first law (about " .. Locale.Lookup(GetInfoFromLawT(lawTab[1][1], "Description")) .. "). Positive outcome and reception must had been a pleasant surprise to " .. HnGGS("him") .. " as " .. HnGGS("he") .. " wrote ''I didn't know that words can wield such power and have impact on life of so many...''. After that " .. HnGGS("he") .. " worked for next " .. HnGPeriodOfTime(gT.Players[iPlayer].CodexTurn - lawTab[1][2]) .. " to finish " .. HnGGS("his") .. " grand work, which is nowadays known as codex of " .. HnGLeaderName() .. ". After that " .. HnGGS("he") .. " was actively propagating the knowledge about civil rights with the common folks up until " .. HnGGS("his") .. " death."
			elseif lType == 9 then
				text = "On " .. HnGGS("his") .. "'s deathbed " .. HnGLeaderTitle() .. " proclaimed the establishment of new code of laws. It is uknown why " .. HnGGS("he") .. " didn't do it earlier, some historians claim that incoming death surprised while the codex was halfway done, mainly pointing at some obvious conflicts and omissions within the codex. Other scholars are rejecting those arguments by pointing that " .. HnGLeaderName() .. " had never received juridical education and was not considered a titan of intelligence. They believe that codex was finished for years, but " .. HnGLeaderName() .. " treated it as a project of lesser importance."
			elseif lType == 10 then
				text = "Despite of " ..  HnGGS("his") .. " supreme title of " .. HnGLeaderTitle() .. ", " .. HnGLeaderName() .. " had never wield much power and was dependant on other influential people within empire. " .. CapitalFL(HnGGS("his")) .. " actions were limited and " .. HnGGS("he") .. " couldn't afford movement that would not met an approvement from nobility. Yet in " .. HnGDate(gT.Players[iPlayer].CodexTurn) .. " " .. HnGGS("he") .. " openly and widely announced the establishing of codex on which " .. HnGGS("he") .. " was working for years. It is unknown if this was a reason of " .. HnGGS("his") .. " death later the same year or " .. HnGGS("he") .. " felt incoming death, which gave " .. HnGGS("him") .. " bravery to announce " .. HnGGS("his") .. " work. Codex didn't stand and was ignored for almost a century waiting for better times."
			elseif lType == 11 then
				text = HnGLeaderName() .. " was very active in juridicial area, " .. HnGGS("his") .. " first edict was describing " .. Locale.Lookup(GetInfoFromLawT(lawTab[1][1], "Description")) .. " and was published in " .. HnGDate(lawTab[1][2]) .. ". After that " .. HnGGS("he") .. " started working on " .. Locale.Lookup(GetInfoFromLawT(lawTab[2][1], "Description")) .. " (issued in " .. HnGDate(lawTab[1][2]) .. "). That lead to changing the law about " .. Locale.Lookup(GetInfoFromLawT(lawTab[3][1], "Description")) .. "(".. HnGDate(lawTab[3][2]) ..") which was followed by " .. Locale.Lookup(GetInfoFromLawT(lawTab[4][1], "Description")) .. " (".. HnGDate(lawTab[4][2]) ..") and " .. Locale.Lookup(GetInfoFromLawT(lawTab[5][1], "Description")) .. " (".. HnGDate(lawTab[5][2]) .."). Shortly " .. HnGGS("he") .. " realized that " .. Players[iPlayer]:GetCivilizationShortDescription() .. " needs unified code of laws and started working on official codex, which he finished in " .. HnGDate(gT.Players[iPlayer].CodexTurn) .. "."
			end
			table.insert(gT.Players[iPlayer].HistoryNote, {Title = title, Text = text, TitleDivider = true})
		end
	end

end