local hntTbeliefBuildings = {
[GameInfoTypes.BUILDING_ITG_BELIEF_TEMPLE_27] = "TXT_KEY_BELIEF_ITG_TEMPLAR_27_L_NOTE",
[GameInfoTypes.BUILDING_ITG_BELIEF_TEMPLE_26] = "TXT_KEY_BELIEF_ITG_TEMPLAR_27_L_NOTE",
[GameInfoTypes.BUILDING_ITG_BELIEF_TEMPLE_25] = "TXT_KEY_BELIEF_ITG_TEMPLAR_27_L_NOTE",
[GameInfoTypes.BUILDING_ITG_BELIEF_TEMPLE_22] = "TXT_KEY_BELIEF_ITG_TEMPLAR_22_L_NOTE",
[GameInfoTypes.BUILDING_ITG_BELIEF_TEMPLE_21] = "TXT_KEY_BELIEF_ITG_TEMPLAR_21_L_NOTE",
[GameInfoTypes.BUILDING_ITG_BELIEF_TEMPLE_20] = "TXT_KEY_BELIEF_ITG_TEMPLAR_20_L_NOTE",
[GameInfoTypes.BUILDING_ITG_BELIEF_TEMPLE_19] = "TXT_KEY_BELIEF_ITG_TEMPLAR_19_L_NOTE",
[GameInfoTypes.BUILDING_ITG_BELIEF_TEMPLE_18] = "TXT_KEY_BELIEF_ITG_TEMPLAR_18_L_NOTE",
[GameInfoTypes.BUILDING_ITG_BELIEF_TEMPLE_17] = "TXT_KEY_BELIEF_ITG_TEMPLAR_17_L_NOTE",
[GameInfoTypes.BUILDING_ITG_BELIEF_TEMPLE_14] = "TXT_KEY_BELIEF_ITG_TEMPLAR_14_L_NOTE",
[GameInfoTypes.BUILDING_ITG_BELIEF_TEMPLE_13] = "TXT_KEY_BELIEF_ITG_TEMPLAR_13_L_NOTE",
[GameInfoTypes.BUILDING_ITG_BELIEF_TEMPLE_11] = "TXT_KEY_BELIEF_ITG_TEMPLAR_11_L_NOTE",
[GameInfoTypes.BUILDING_ITG_BELIEF_TEMPLE_9] = "TXT_KEY_BELIEF_ITG_TEMPLAR_9_L_NOTE",
[GameInfoTypes.BUILDING_ITG_BELIEF_TEMPLE_8] = "TXT_KEY_BELIEF_ITG_TEMPLAR_8_L_NOTE",
[GameInfoTypes.BUILDING_ITG_BELIEF_TEMPLE_7] = "TXT_KEY_BELIEF_ITG_TEMPLAR_7_L_NOTE",
[GameInfoTypes.BUILDING_ITG_BELIEF_TEMPLE_6] = "TXT_KEY_BELIEF_ITG_TEMPLAR_6_L_NOTE",
[GameInfoTypes.BUILDING_ITG_BELIEF_TEMPLE_5] = "TXT_KEY_BELIEF_ITG_TEMPLAR_5_L_NOTE",
[GameInfoTypes.BUILDING_ITG_BELIEF_TEMPLE_4] = "TXT_KEY_BELIEF_ITG_TEMPLAR_4_L_NOTE",
[GameInfoTypes.BUILDING_ITG_BELIEF_TEMPLE_3] = "TXT_KEY_BELIEF_ITG_TEMPLAR_3_L_NOTE",
[GameInfoTypes.BUILDING_ITG_BELIEF_TEMPLE_2] = "TXT_KEY_BELIEF_ITG_TEMPLAR_2_L_NOTE",
[GameInfoTypes.BUILDING_ITG_BELIEF_TEMPLE_1] = "TXT_KEY_BELIEF_ITG_TEMPLAR_1_L_NOTE",
}

function GetSecularHnGTitle(iPlayer)
	local h = LastRandom(1, 8)
	if h == 1 then
		return "Secular state"
	elseif h == 2 then
		return "Secular movement"
	elseif h == 3 then
		return "Organized secularism"
	elseif h == 4 then
		return "Secularity"
	elseif h == 5 then
		return "Quiet Revolution"
	elseif h == 6 then
		return "Secularism in " .. HnGCivName();
	elseif h == 7 then
		return "Separation of religion and state in the " .. HnGCivName();
	end
	return "Secular reforms"
end

function GetHNGRelReformationHeadline(iPlayer, relName)
	local th = LastRandom(1,5);
	if th == 1 then
		return "Reformation attempts"
	elseif th == 2 then
		return "Reformation"
	elseif th == 3 then
		return relName .. "'s reformation"
	elseif th == 4 then
		return "Reforms in " .. relName
	elseif th == 5 then
		return HnGLeaderName() .. " and reformation"
	end
end

function GetHNGRelMuchConvertingHeadline(iPlayer, relName)
	local th = LastRandom(1,5);
	if th == 1 then
		return "Spreading " .. relName
	elseif th == 2 then
		return "Supporting " .. relName
	elseif th == 3 then
		return relName .. "'s missions"
	elseif th == 4 then
		return "Spread of " .. relName
	elseif th == 5 then
		return relName
	end
end

function GetHnGGPSecularNoteTitle(iPlayer)
	local th = LastRandom(1,5);
	if th == 1 then
		return "Most notable participants of public debate on secularization:"
	elseif th == 2 then
		return "People recognized for their support in secularization:"
	elseif th == 3 then
		return "Notable figures that were opposing secularization:"
	elseif th == 4 then
		return "Dignitaries openly supporting secularization of state:"
	elseif th == 5 then
		return "Some notable people that accused " .. HnGLeaderName() .. " of heresy:"
	end
	return "List of famous people supporting secularization:"
end

function GetHNGReligionFoundedHeadline(iPlayer, hCity, hRelFounded)
	local th = LastRandom(1,7);
	if th == 1 then
		return "First Council of " .. hCity:GetName()
	elseif th == 2 then
		return Locale.Lookup(GameInfo.Religions[hRelFounded].Description)
	elseif th == 3 then
		return "Unification of " .. Locale.Lookup(GameInfo.Religions[hRelFounded].Description)
	elseif th == 4 then
		return HnGLeaderName() .. " and " .. Locale.Lookup(GameInfo.Religions[hRelFounded].Description)
	elseif th == 5 then
		return CapitalFL(HnGLeaderTitle()) .. " and " .. Locale.Lookup(GameInfo.Religions[hRelFounded].Description)
	elseif th == 6 then
		return "Constitution of " .. hCity:GetName()
	elseif th == 7 then
		return "Edicts of " .. HnGLeaderName();
	end
end

function GetHNGSchismHeadline(iPlayer, hRelFounded, hCity, oldRelFounded)
	local th = LastRandom(1,7);
	if th == 1 then
		return "Schism"
	elseif th == 2 then
		return HnGCivAdj() .. " separatism"
	elseif th == 3 then
		return Locale.Lookup(GameInfo.Religions[oldRelFounded].Description)  .. " and " .. Locale.Lookup(GameInfo.Religions[hRelFounded].Description)
	elseif th == 4 then
		return "New school of " .. Locale.Lookup(GameInfo.Religions[oldRelFounded].Description)
	elseif th == 5 then
		return HnGCivAdj() .. " ''heresy''"
	elseif th == 6 then
		return "Rise of " .. Locale.Lookup(GameInfo.Religions[hRelFounded].Description)
	elseif th == 7 then
		return "Religious denomination"
	elseif th == 8 then
		return "Apostasy";
	end
end

function GetHNGRelClaimedHeadline(iPlayer, relName)
	local th = LastRandom(1,5);
	if th == 1 then
		return "Rights to " .. relName
	elseif th == 2 then
		return relName .. "'s matter"
	elseif th == 3 then
		return "Control over " .. relName
	elseif th == 4 then
		return HnGCivAdj() .. " " .. relName
	elseif th == 5 then
		return "Acquisition of " .. relName
	end
end

function GetHNGRelOfficialHeadline(iPlayer, relName)
	local th = LastRandom(1,9);
	if th == 1 then
		return "Official religion of " .. HnGCivName()
	elseif th == 2 then
		return "State religion of " .. HnGCivName()
	elseif th == 3 then
		return relName .. " in " .. HnGCivName()
	elseif th == 4 then
		return HnGLeaderName() .. " and " .. relName
	elseif th == 5 then
		return "Official religion"
	elseif th == 6 then
		return "State religion"
	elseif th == 7 then
		return "Embracing " .. relName
	elseif th == 8 then
		return "Adopting " .. relName
	elseif th == 9 then
		return relName
	end
end

function GetHNGRelPantheonsHeadline(iPlayer)
	local th = LastRandom(1,7);
	if th == 1 then
		return "Beliefs"
	elseif th == 2 then
		return "Early Religion"
	elseif th == 3 then
		return "Primal beliefs"
	elseif th == 4 then
		return "Cults and beliefs"
	elseif th == 5 then
		return "Local beliefs"
	elseif th == 6 then
		return "Spiritual life"
	elseif th == 7 then
		return "Gods of ancient " .. HnGCivName();
	end
end

function GetHnGReligionNote(iPlayer)
	local bGhazi = gT.Globals.HnGData.Constants["Ghazi"][iPlayer];
	local bPantheonFounder = (gT.Globals.HnGData.PantheonsFounded[iPlayer]) and (#gT.Globals.HnGData.PantheonsFounded[iPlayer] > 2)
	local bReligionFounder = (gT.Globals.HnGData.ReligionFounded[iPlayer] ~= nil)
	local bSchism = (gT.Globals.HnGData.Schism[iPlayer] ~= nil)
	local bReformations = (gT.Globals.HnGData.Reformations[iPlayer]) and (#gT.Globals.HnGData.Reformations[iPlayer] > 2)
	local bOfficialRels = (gT.Globals.HnGData.OfficialReligion[iPlayer] ~= nil);
	local bSecular = (gT.Globals.HnGData.SecularState[iPlayer] ~= nil);
	local bClaimReligion = (gT.Globals.HnGData.ClaimReligion[iPlayer] ~= nil);
	local mainRel, iconAtlas, portIndex;
	mainRel = GetReligionForHnGIcon(iPlayer)
	if mainRel then
		iconAtlas = GameInfo.Religions[mainRel].IconAtlas;
		portIndex = GameInfo.Religions[mainRel].PortraitIndex;
	end
	local bHeresy = false;
	if gT.Globals.HnGData.Constants.Heresy then
		bHeresy = (gT.Heresies[gT.Globals.HnGData.Constants.Heresy].Pstarted == iPlayer);
	end
	local bHasAlreadyHeadline = false;
	if bSecular then
		bHasAlreadyHeadline = true;
		local secText = ""
		local hT = {5}
		if mainRel then
			table.insert(hT, 1)
			table.insert(hT, 2)
			table.insert(hT, 3)
			table.insert(hT, 4)
		end
		if gT.Globals.HnGData.SecularState[iPlayer] > 90 then
			table.insert(hT, 6)
		end
		local th = hT[LastRandom(1,#hT)];
		if th == 1 then
			secText = "Despite being devoted follower of " .. Locale.Lookup(GameInfo.Religions[mainRel].Description) .. ", " .. HnGLeaderName() .. " understood the need for splitting religion from the state. The legislation act took place in " .. GetRandomCityForHnG(iPlayer):GetName() .. ", c. " .. HnGDate(gT.Globals.HnGData.SecularState[iPlayer]) .. "." 
		elseif th == 2 then
			secText = Locale.Lookup(GameInfo.Religions[mainRel].Description) .. "'s leaders were never actively involved in politics or influencing actions of goverment. The aggressive campaign against them that preluded the secularization act of " .. HnGDate(gT.Globals.HnGData.SecularState[iPlayer]) .. " is a mystery even nowadays. Most popular theories are: covering a scandal, empowering " .. HnGGS("his") .. " rule, private revenge and... boredom of " .. HnGLeaderTitle() .. "."
		elseif th == 3 then
			secText = CapitalFL(HnGGS("his")) .. " " .. HnGGS("father") .. " had his hands tied by " .. Locale.Lookup(GameInfo.Religions[mainRel].Description) .. "'s leaders during entire reign. That's why " .. HnGLeaderName() .. " seek independence and declared " .. HnGCivName() .. " a secular state in " .. HnGDate(gT.Globals.HnGData.SecularState[iPlayer]) .. "."
		elseif th == 4 then
			secText = Locale.Lookup(GameInfo.Religions[mainRel].Description) .. " was in decline for some time, most notable due to corruption scandals (" .. HnGDate(gT.Globals.HnGData.SecularState[iPlayer] - LastRandom(20,40)) .. " and " .. HnGDate(gT.Globals.HnGData.SecularState[iPlayer] - LastRandom(6,14)) .. "). Common folk was rather supportive towards secularization of state, even too much, considering the massacre of clergy in " .. GetRandomCityForHnG(iPlayer):GetName() .. "."
		elseif th == 5 then
			secText = "Right now people of " .. HnGCivName() .. " consider secularism as a natural state of the country, however back in " .. HnGLeaderName() .. "'s times such movement was treated as ''demonic'' action and spread fear among common folks. Lucky for " .. HnGLeaderTitle() .. " the " .. HnGCivName() .. " was highly divided religiously and " .. HnGGS("he") .. " managed to pass legislation, which ''shall make sure no religion is above other''."
		elseif th == 6 then
			secText = "Last years of " .. HnGGS("his") .. " reign were focused on secularization of country. " .. CapitalFL(HnGGS("he")) .. " wanted to ensure that no religious majority will ever interfere with the rule of his successors. Many scholars find " .. HnGCivAdj() .. " the most peaceful one."
		end
		if gT.Globals.TempHnGData.NumGreatPeople > 3 and (LastRandom(1,2) == 1) then
			secText = secText .. "[NEWLINE][NEWLINE]" .. GetHnGGPSecularNoteTitle(iPlayer)
			local gpTab = GetHnGShuffledTabOfValidGP(iPlayer, true, false);
			local tgpn = math.min(LastRandom(2, #gpTab), 8);
			for i = 1, tgpn do
				secText = secText .. "[NEWLINE]" .. Locale.Lookup(gT.GreatPeople[gpTab[i]].Name);
			end
		end
		table.insert(gT.Players[iPlayer].HistoryNote, {HideImageFrame = true, ImageAtlas = iconAtlas, PortraitIndex = portIndex, Title = GetSecularHnGTitle(iPlayer), Text = secText, TitleDivider = true})
	elseif bReligionFounder then
		bHasAlreadyHeadline = true;
		local secText = ""
		local hRelFounded = gT.Globals.HnGData.ReligionFounded[iPlayer][1];
		local relName = Locale.Lookup(GameInfo.Religions[hRelFounded].Description)
		local hCity = Map.GetPlotByIndex(gT.Globals.HnGData.ReligionFounded[iPlayer][3]):GetPlotCity();
--	gT.Globals.HnGData.ReligionFounded[iPlayer] = {newreligiondata,  GetITGGameTurn(), hCity:Plot():GetPlotIndex()}
		local hT = {1, 2, 3, 5, 6, 7, 8, 9}
		if WasFirstEverReligion(iPlayer, gT.Globals.HnGData.ReligionFounded[iPlayer][2]) then
			table.insert(hT, 4);
		end
		local th = hT[LastRandom(1,#hT)];
		if th == 1 then
			secText = "The gathering of spiritual leaders of " .. relName .. " took place in " .. hCity:GetName() .. " and was convened by the " .. HnGLeaderTitle() .. " " .. HnGGS("himself") .. ". This synod had been charged with investigation of the trouble brought about by the several crucial differences between north and south believers. In the " .. HnGDate(gT.Globals.HnGData.ReligionFounded[iPlayer][1]) ..  ", the bishops of all provinces were summoned to " .. hCity:GetName() .. ", a place reasonably accessible to many delegates, where the beliefs of " .. relName .. " were finally standardized."
		elseif th == 2 then
			secText = "During " .. HnGGS("his") .. " reign took place the first general council in the history of the " .. relName .. ". It is widely agreed that the Church had taken her first great step to define revealed doctrine more precisely in response to a challenge from a heretical theology. This unification lead to foundation of " .. relName .. "."
		elseif th == 3 then
			secText = HnGLeaderName() .. " had invited almost " .. LastRandom(15,25) .. "00 clerics of the " .. relName .. " within the " .. HnGCivName() .. ", but a smaller and unknown number attended. The number " .. LastRandom(301, 502) .. " is preserved in some traditions. Delegates came from every region of the " .. HnGCivName() .. ", and even from foreign temples. The participating bishops were given free travel to and from their episcopal sees to the council, as well as lodging. This gathering had formalized and shaped the church of " .. relName .. "."
		elseif th == 4 then
			secText = relName .. " is considered to be the first formed religion in the world and is widely associated with " .. HnGCivName() .. " and " .. HnGLeaderName() .. ". What differs it from tribal beliefs and primitive pantheons, is unprecedented complexity of ceremonies, tradition and hierarchy. Without a doubt, " .. relName .. " became an important factor of " .. HnGCivName() .. " and was beneficial for local rulers."  
		elseif th == 5 then
			secText = "After " .. LastRandom(7,15) .. " years of the persecution of " .. relName .. "'s followers they gathered in the city of " .. hCity:GetName() .. " in " ..  HnGDate(gT.Globals.HnGData.ReligionFounded[iPlayer][1]) .. ". There, with the local converts and other pilgrims, they have established political and religious authority. The Constitution of " .. hCity:GetName() .. " was formulated, instituting a number of rights and responsibilities for the faithful and pagan communities of state. Soon the persecution was lifted and religion was embraced by " .. HnGCivName() .. "."
		elseif th == 6 then	
			secText = "All the " .. HnGCivAdj() .. " tribes signed the agreement to defend " .. hCity:GetName() .. " from all external threats and to live in harmony amongst themselves. " .. hCity:GetName() .. " became the first holy city of newly established religion, " .. relName .. ". The followers in the rest of " .. HnGCivName() .. " formed a confederation converting even more people. By " .. HnGDate(gT.Globals.HnGData.ReligionFounded[iPlayer][1]) .. " " .. relName .. " had united the tribes of " .. HnGCivName() .. " into a single religious polity."
		elseif th == 7 then	
			secText = "The legends state that " .. HnGLeaderName() .. " converted to " .. relName .. ", although this has been debated by a section of scholars. The minor rock edict leaves no doubt that " .. HnGLeaderName() .. " was a follower of " .. relName .. ". In this edict, " .. HnGGS("he") .. " calls " .. HnGGS("himself") .. " a follower of " .. relName .. " and claiming " .. HnGGS("his") .. " divine rights to rule. This and several other edicts are evidence of " .. HnGGS("his") .. " affiliation. It is plausible that due " .. HnGGS("his") .. " actions " .. relName .. " ascenced to an important religion from local beliefs." 
		elseif th == 8 then
			secText = "In the " .. HnGCivAdj() .. " tradition, prophet - patronised by " .. HnGLeaderName() .. " - sends out " .. GetNumberString(LastRandom(5,9)) .. " missions to spread " .. relName .. " in the realm and  ''border areas'' in c. " .. HnGDate(gT.Globals.HnGData.ReligionFounded[iPlayer][1]) .. ". This tradition does not credit " .. HnGLeaderName() .. " directly with sending these missions, yet scholars generally agreed that it was during " .. HnGGS("his") .. " reign when " .. relName .. " finally emerged as a full-fledged religion. There are several proofs about spreading it to remote locations."
		elseif th == 9 then
			secText = "The origins of " .. relName .. " are still not completely understood and there are numerous competing theories. The earliest historical accounts of " .. relName .. " assumed that it existed before the birth of " .. HnGLeaderName() .. ". According to those studies, the leading theories about the origins of " .. relName .. " were that it was either a lay movement or that it developed among the other " .. HnGCivAdj() .. " beliefs. These theories have recently been mostly overturned or shown to be problematic. The earliest textual evidence of ''" .. relName .. "'' comes from " .. HnGLeaderName() .. "'s times. " .. CapitalFL(HnGLeaderTitle()) .. "'s role in foundation of " .. relName .. " is unknown." 
		end	
		--if time allows: add more (but no more than 15!!!)
		table.insert(gT.Players[iPlayer].HistoryNote, {HideImageFrame = true, ImageAtlas = iconAtlas, PortraitIndex = portIndex, Title = GetHNGReligionFoundedHeadline(iPlayer, hCity, hRelFounded), Text = secText, TitleDivider = true})
	elseif bSchism then
		bHasAlreadyHeadline = true;
		local secText = ""
		local hRelFounded = gT.Globals.HnGData.Schism[iPlayer][1];
		local relName = Locale.Lookup(GameInfo.Religions[hRelFounded].Description)
		local oldRelFounded = gT.Globals.HnGData.Schism[iPlayer][4];
		local oldFounder = Game.GetFounder(oldRelFounded, -1);
		local oldRelName = Locale.Lookup(GameInfo.Religions[oldRelFounded].Description)
		local hCity = Map.GetPlotByIndex(gT.Globals.HnGData.Schism[iPlayer][3]):GetPlotCity();
		local turn = gT.Globals.HnGData.Schism[iPlayer][2];
--	gT.Globals.HnGData.Schism[iPlayer] = {newreligiondata, GetITGGameTurn(), hCity:Plot():GetPlotIndex(), oReligion}
		local hT = {1, 2, 3, 4, 5, 6, 7, 8}
		local th = hT[LastRandom(1,#hT)];
		if th == 1 then
			secText = "It remains unknown if establishment of " .. relName .. " was political, ideological or religious action. " .. HnGLeaderName() .. " did not left any personal notes on this subject. Decline of " .. oldRelName .. " was visible in " .. HnGCivAdj() .. " society yet nothing indicated the need for such drastic measures. The most plausible theory blames local clergy and their lust of power and authority to be the major force behind this division."
		elseif th == 2 then
			secText = "The " .. HnGCivAdj() .. "-" .. Players[oldFounder]:GetCivilizationAdjective() .. " Schism, also called the Great Schism and the Schism of " .. HnGDate(turn, false, true) .. ", was the break of communion between what are now the " .. oldRelName .. " and " .. relName .. ", which has lasted since the " .. GetCenturyThFromYear(turn) .. " century. The Schism was the culmination of theological and political differences between the " .. HnGCivAdj() .. " and " .. Players[oldFounder]:GetCivilizationAdjective() .. " which had developed over the preceding decades."
		elseif th == 3 then
			secText = "A succession of ecclesiastical differences and theological disputes between the " .. HnGCivAdj() .. " and " .. Players[oldFounder]:GetCivilizationAdjective() .. " pre-dated the formal rupture that occurred in " .. HnGDate(turn, false, true) .. ". Prominent among these were the issues of the procession of the divine spirit, several disputes in ceremonies, the " .. Players[oldFounder]:GetCivilizationAdjective() .. " Leader's claim to universal jurisdiction, and the constant rise of " .. hCity:GetName() .. "'s significance."
		elseif th == 4 then
			secText = "The most significant " .. HnGGetScenarioAdjective() .. " schism was the " .. HnGCivAdj() .. "-" .. Players[oldFounder]:GetCivilizationAdjective() ..  " schism that divided " .. oldRelName .. " into " .. relName .. ". It began in " .. HnGDate(turn, false, true) .. " because of various disputes and actions, and it has never been healed, although some actions were made to improve relations between both religions."
		elseif th == 5 then
			secText = "The Great " ..  HnGCivAdj() .. " Schism split the main faction of " .. oldRelName .. " into a new division, " .. relName .. ". Today, they remain the two largest denominations of " .. oldRelName .. " and maintain minimum formal relations. Both sides accused others of heresy, worshipping of devil and put excommunication on leaders of opposite religion."
		elseif th == 6 then
			secText = "On " .. HnGDate(turn, false, true) .. ", Patriarch of " .. hCity:GetName() .. " was excommunicated from the " .. oldRelName .. " church based in " .. Players[oldFounder]:GetName() .. ". This excommunication severed the largest faction of " .. oldRelName .. ", called " .. relName .. ". The split is known as the " .. CapitalFL(HnGSynonym("enormous")) .. " Schism and was politically used by " .. HnGLeaderName() .. " to centralize religious authority around " .. HnGGS("him") .. "."
		elseif th == 7 then
			secText = "The Great " .. HnGCivAdj() .. " Schism was both a spiritual and practical conflicts. Spiritual issues were based in separate traditions and minor differences in ceremonies. A more practical conflict that led to the schism was whether the the spiritual leader of " .. Players[oldFounder]:GetName() .. ", had authority over the patriarchs, religious leaders in the " .. Players[iPlayer]:GetName() .. "."
		elseif th == 8 then
			secText = "The political power behind the schism of " .. HnGDate(turn, false, true) .. " (separation of " .. relName .. " from " .. oldRelName .. ") were spiritual leaders of " .. hCity:GetName() .. " that had support of " .. HnGLeaderTitle() .. ". Nowadays, scholars do not recognize many political benefits of that action, however the schism was important factor in creating national identity of " .. HnGCivAdj() .. " people.";
		end
		table.insert(gT.Players[iPlayer].HistoryNote, {HideImageFrame = true, ImageAtlas = iconAtlas, PortraitIndex = portIndex, Title = GetHNGSchismHeadline(iPlayer, hRelFounded, hCity, oldRelFounded), Text = secText, TitleDivider = true})
	elseif bClaimReligion then
		bHasAlreadyHeadline = true;
		local hRelFounded = gT.Globals.HnGData.ClaimReligion[iPlayer][3];
		local prevRelOwner = gT.Globals.HnGData.ClaimReligion[iPlayer][1];
		local relName = Locale.Lookup(GameInfo.Religions[hRelFounded].Description)
		local turn = gT.Globals.HnGData.ClaimReligion[iPlayer][2];
		local hCity = Game.GetHolyCityForReligion(hRelFounded, -1);		
		local hT = {1, 2, 3}
		local th = hT[LastRandom(1,#hT)];
		local secText = ""
		if th == 1 then
			secText = HnGLeaderName() .. " decided to capitalize on controlling the Holy City of " .. relName .. ", " .. hCity:GetName() .. ". In " .. HnGDate(turn, false, true) .. ", " .. HnGGS("he") .. " declared " .. HnGGS("himself") .. " the spiritual leader and protector of " .. relName .. ". Followers and clergy from " .. Players[prevRelOwner]:GetCivilizationShortDescription() .. " were definitely not happy about this, yet they had neither military nor legal power to oppose it."
		elseif th == 2 then
			secText = "In " .. HnGDate(turn, false, true) .. " religious leaders of " .. hCity:GetName() .. " announced to all the followers that " .. HnGLeaderName() .. " is chosen by Divinity as protector and leader of " .. relName .. ". This edict was obviously forced by " .. HnGLeaderTitle() .. " in order to reduce " .. Players[prevRelOwner]:GetCivilizationAdjective() .. " influence over the region. Those days " .. hCity:GetName() .. " was religious center of " .. relName .. ", and most followers accepted their new overlords."
		elseif th == 3 then
			secText = "The Holy City of " .. hCity:GetName() .. " is crucial for followers of " .. relName .. " and for centuries the one who controlled the city, could seek the control over the entire religion. " .. HnGLeaderName() .. " acted no differentially and in " .. HnGDate(turn, false, true) .. " declared " .. HnGGS("himself") .. " the one and the only protector of the " .. relName .. ", which granted " .. HnGGS("him") .. " an additional power over the region and upperhand in negotiations with " .. Players[prevRelOwner]:GetName() .. "."
		end
		table.insert(gT.Players[iPlayer].HistoryNote, {HideImageFrame = true, ImageAtlas = iconAtlas, PortraitIndex = portIndex, Title = GetHNGRelClaimedHeadline(iPlayer, relName), Text = secText, TitleDivider = true})
	elseif bOfficialRels then
		-- official religion text :)
		bHasAlreadyHeadline = true;
		local hRel = gT.Globals.HnGData.OfficialReligion[iPlayer][#gT.Globals.HnGData.OfficialReligion[iPlayer]][1];
		local relName = Locale.Lookup(GameInfo.Religions[hRel].Description)
		local turn = gT.Globals.HnGData.OfficialReligion[iPlayer][#gT.Globals.HnGData.OfficialReligion[iPlayer]][2];
		local prevRel = gT.Globals.HnGData.OfficialReligion[iPlayer][#gT.Globals.HnGData.OfficialReligion[iPlayer]][3];
		local prevRelName = ""
		local hT = {1, 2, 3}
		if prevRel and (prevRel ~= -1) and (prevRel ~= 0) then
			prevRelName = Locale.Lookup(GameInfo.Religions[hRel].Description)
			table.insert(hT, 4)
			table.insert(hT, 5)
			table.insert(hT, 6)
		end
		local th = hT[LastRandom(1,#hT)];
		local secText = ""
		if th == 1 then
			secText = "In " .. HnGDate(turn, false, true) .. " " .. HnGLeaderName() .. " has used all " .. HnGGS("his") .. " legal power and authority to enforce " .. relName .. " becoming the state religion of " .. HnGCivName() .. ". This event marked cultural and spiritual history of the nation."
		elseif th == 2 then
			secText = "Goverment officially announced " .. relName .. " as official religion in " .. HnGDate(turn, false, true) .. ". To this day it remains unknown if " .. HnGLeaderTitle() .. " was a believer or had more pragmatic reason for this action."
		elseif th == 3 then
			secText = CapitalFL(relName) .. " was a widely followed religion and in " .. HnGDate(turn, false, true) .. " it became the official religion of " .. HnGCivName() .. ". The impact of this action on social and cultural life was rather insignificant, however the political implications made a mark on history."
		elseif th == 4 then
			secText = "There was a noticeable decline in interest in " .. prevRelName .. " and " .. HnGLeaderName() .. " decided to capitalize on that. In " .. HnGDate(turn, false, true) .. " " .. HnGGS("he") .. " replaced it with new official religion, the " .. relName .. ". The social outrage was minor, however orthodox followers of " .. prevRelName .. " in " .. HnGCivName() .. " still consider " .. HnGLeaderName() .. " as a servant of evil."
		elseif th == 5 then
			secText = "One of the most risky political decisions in " .. HnGLeaderName() .. "'s life was replacing " .. prevRelName .. " with " .. relName .. " as the new state religion. The consequences could end " .. HnGGS("his") .. " reign, thankfully social unrest was as short as it was loud."
		elseif th == 6 then
			secText = "Today not many citizens of " .. HnGCivName() .. " remember that " .. prevRelName .. " was once an official religion in their country. Precisely till " .. HnGDate(turn, false, true) .. " when " .. HnGLeaderName() .. " decided to replace it with " .. relName .. "."
		end
		table.insert(gT.Players[iPlayer].HistoryNote, {HideImageFrame = true, ImageAtlas = iconAtlas, PortraitIndex = portIndex, Title = GetHNGRelOfficialHeadline(iPlayer, relName), Text = secText, TitleDivider = true})
	elseif bPantheonFounder then
		bHasAlreadyHeadline = true;
		local beliefsName = {}
		for ijk, data in pairs(gT.Globals.HnGData.PantheonsFounded[iPlayer]) do
			table.insert(beliefsName, Locale.Lookup(GameInfo.Beliefs[data[1]].ShortDescription))
		end
		beliefsName = Shuffle(beliefsName);
		local hT = {1, 2, 3, 4, 5, 6}
		local th = hT[LastRandom(1,#hT)];
		iconAtlas = GameInfo.Religions[0].IconAtlas;
		portIndex = GameInfo.Religions[0].PortraitIndex;
		local secText = ""
		if th == 1 then
			secText = "In the times of " .. HnGLeaderName() .. " some of the very first beliefs in " .. HnGCivName() .. " were formed. The society was evolving both spiritually and culturally, which in future allowed establishing longer lasting states."
		elseif th == 2 then
			secText = "Scholars are intrigued by so-called 'beliefs explosion' in " .. HnGCivName() .. " around the times of " .. HnGLeaderName() .. ". It's like first cults and Gods were inspiring new ones leading to spiritual awakening of the region. Some researchers imply the foreign influence in this happening."
		elseif th == 3 then
			secText = "Beliefs in ancient " .. HnGCivName() .. " are classified in three main groups: " .. beliefsName[1] .. ", " .. beliefsName[2] .. " and " .. beliefsName[3] .. ". All of them emerged around the times of " .. HnGLeaderName() .. " however any further connections with " .. HnGLeaderTitle() .. " are not backed up with any evidence."
		elseif th == 4 then
			secText = "There are implications (grave bas-reliefs) that " .. HnGLeaderName() .. " was a follower of " .. beliefsName[1] .. ". Other than that, people of " .. HnGCivName() .. " were also worshipping " .. beliefsName[2] .. " and " .. beliefsName[3] .. " before more unified religion emerged."
		elseif th == 5 then
			secText = "Under the strong leadership of " .. HnGLeaderName() .. " " .. HnGCivAdj() .. " people started gathering in larger social groups, which resulted in emerging of more unified beliefs like " .. beliefsName[1] .. " or " .. beliefsName[2] .. "." 
		elseif th == 6 then
			secText = "Scholars mark " .. HnGLeaderName() .. "'s reign as plausible time for emerging of " .. HnGCivAdj() .. "'s pantheon. Some even believe that " .. HnGGS("he") .. " could be an inspiration for a mythological " .. HnGGS("king") .. " from beliefs dated century later."
		end
		table.insert(gT.Players[iPlayer].HistoryNote, {HideImageFrame = true, ImageAtlas = iconAtlas, PortraitIndex = portIndex, Title = GetHNGRelPantheonsHeadline(iPlayer), Text = secText, TitleDivider = true})
	elseif bReformations then
		bHasAlreadyHeadline = true;
		local hRel = gT.Globals.HnGData.Reformations[iPlayer][#gT.Globals.HnGData.Reformations[iPlayer]][1];
		local relName = Locale.Lookup(GameInfo.Religions[hRel].Description)
		local beliefsName = {}
		local oldbeliefsName = {}
		local hCity = Game.GetHolyCityForReligion(hRel, -1);		
		for ijk, data in pairs(gT.Globals.HnGData.Reformations[iPlayer]) do
			table.insert(beliefsName, Locale.Lookup(GameInfo.Beliefs[data[4]].ShortDescription))
			table.insert(oldbeliefsName, Locale.Lookup(GameInfo.Beliefs[data[3]].ShortDescription))
		end
		beliefsName = Shuffle(beliefsName);
		local hT = {1, 2, 3, 4, 5, 6}
		local th = hT[LastRandom(1,#hT)];
		local secText = ""
		if th == 1 then
			secText = HnGLeaderName() .. " picked up the burden of reforming the institution of " .. relName .. ", which was controlled by corrupted caste. The reforms we widely welcomed by society and gave religion a second chance." 
		elseif th == 2 then
			secText = "During the reign of " .. HnGLeaderName() .. " the leadership of " .. relName .. " was in the hands of old and weak religious elites that neglected the rot in their structures. Foreign religions became more and more popular within empire, which was a situation any wise " .. HnGGS("king") .. " couldn't tolerate. The state interfered in interior matters of " .. relName .. ", forcing it to reform." 
		elseif th == 3 then
			secText = "This period was additionally marked by the renovation of " .. relName .. ", which reformed some of their outdated beliefs like " .. oldbeliefsName[1] .. " or " .. oldbeliefsName[2] .. " to face the reality of modern world. It was widely considered a bald move and made a lot of orthodox believers quite angry."
		elseif th == 4 then
			secText = "As devoted follower of " .. HnGLeaderName() .. " and a " .. HnGGS("man") .. " of enormous ego, " .. HnGLeaderName() .. " decided to rewrite religious doctrine, turning the world of sacred institutions upside down in the matter of days. This religious madness is widely studied by theologists around the world to this day." 
		elseif th == 5 then
			secText = CapitalFL(HnGGS("his")) .. " reign was marked by slow renovation of " .. relName .. " which abandoned some of their older beliefs (" .. oldbeliefsName[1] .. ") and formulated new ones: " .. beliefsName[1] .. " and " .. beliefsName[2] .. ". This silent revolution is considered today the most interesting event of " .. GetCenturyThFromYear(50) .. " century " .. HnGCivName() .. "."
		elseif th == 6 then
			secText = "The most important religion of " .. HnGCivName() .. ", the " .. relName .. ", developed new beliefs: " .. beliefsName[1] .. " and " .. beliefsName[2] .. ", which originated on the province and reached the capital city during " .. HnGLeaderName() .. "'s life. Their attractiveness outshined some older cults of " .. oldbeliefsName[1] .. " and " .. oldbeliefsName[2] .. "."
		end
		table.insert(gT.Players[iPlayer].HistoryNote, {HideImageFrame = true, ImageAtlas = iconAtlas, PortraitIndex = portIndex, Title = GetHNGRelReformationHeadline(iPlayer, relName), Text = secText, TitleDivider = true})
	end
	local numMissionares = gT.Players[iPlayer].LHMissionaries;
	local bRelPressureChange = false;
	local iRel = Players[iPlayer]:GetReligionCreatedByPlayer();
	if iRel > 0 then
		if (gT.ReligionsEE[iRel].BestReligiousPressure or 0) > 0 then
			if gT.ReligionsEE[iRel].StartReligiousPressure > 200 then
				if gT.ReligionsEE[iRel].BestReligiousPressure > gT.ReligionsEE[iRel].StartReligiousPressure * 2 then
					bRelPressureChange = true;
				end
			end
		end
	end
	local tabOfForceMinorRel = {}
	for jj, vv in pairs(gT.Globals.HnGData.OfficialReligion) do
		if jj ~= iPlayer then
			for bb, cc in pairs(vv) do
				if cc[1] == iRel and cc[4] == iPlayer then
					table.insert(tabOfForceMinorRel, {cc[2], jj})
					break;
				end
			end
		end
	end
	if iRel > 0 and #tabOfForceMinorRel > 1 or bRelPressureChange or (numMissionares > 15) then
		local hT = {1, 2, 3}
		local relName = Locale.Lookup(GameInfo.Religions[iRel].Description)
		local secText = ""
		local th = hT[LastRandom(1,#hT)];
		if th == 1 then
			secText = "The " .. relName .. " were favoured by the " .. HnGLeaderName() .. " who supported the cause whenever " .. HnGGS("he") .. " could."
		elseif th == 2 then
			secText = CapitalFL(relName) .. " was fighting for domination over the globe with several foreign religions. It was a conflict with no peace declarations."
		elseif th == 3 then
			secText = "Religion were important part of " .. HnGLeaderName() .. "'s life, who like many others leaders tried to promote very own beliefs. It were a golden times for " .. relName .. "."
		end
		--much pressure change
		if bRelPressureChange then
			local th = LastRandom(1,3)
			if th == 1 then
				secText = secText .. " The overall efforts to spread " .. relName .. " are considered to double their value during " .. HnGGS("his") .. " reign."
			elseif th == 2 then
				secText = secText .. " The amount of preaching, conversions, and the presence of religion in the state have at least doubled under the leadership of " .. HnGLeaderTitle() .. "."
			elseif th == 3 then
				secText = secText .. " " .. HnGLeaderName() .. " wanted to outshine " .. HnGGS("his") .. " precedessor in the devotion, which lead to doubling promotion of " .. relName .. "."
			end
		end
		--much missionares
		if numMissionares > 15 then
			local th = LastRandom(1,3)
			if th == 1 then
				secText = secText .. " Enormous amount of missionaries were funded and send to spread the one and the only true word. There are informations about " .. numMissionares .. " missions in the holy chronicles." 
			elseif th == 2 then
				secText = secText .. " In those times it was a norm for an aristocratic family to have at least one child becoming a missionary. Missionaries returning from successful preaching were a common guests in " .. HnGLeaderTitle() .. "'s court."
			elseif th == 3 then
				secText = secText .. " Archives mention " .. numMissionares .. " missions that were sent by the order of " .. HnGLeaderName() .. ". The effect of those conversions was rather minor, most of them didn't outlive " .. HnGLeaderTitle() .. "."
			end
		end
		--forcing official religion
		if #tabOfForceMinorRel > 1 then
			tabOfForceMinorRel = Shuffle(tabOfForceMinorRel);
			local th = LastRandom(1,3)
			if th == 1 then
				secText = secText .. " " .. HnGLeaderName() .. " used political influence and connections to force" 
				for a, b in pairs(tabOfForceMinorRel) do
					if a == #tabOfForceMinorRel then
						secText = secText .. " and " .. Players[b[2]]:GetName()
					elseif a == 1 then
						secText = secText .. " " .. Players[b[2]]:GetName()
					else
						secText = secText .. ", " .. Players[b[2]]:GetName()
					end
				end
				secText = secText .. " to adopt " .. relName .. " as an official religion of state."
			elseif th == 2 then
				secText = secText .. " During " .. HnGGS("his") .. " reign city-states of"
			for a, b in pairs(tabOfForceMinorRel) do
					if a == #tabOfForceMinorRel then
						secText = secText .. " and " .. Players[b[2]]:GetName()
					elseif a == 1 then
						secText = secText .. " " .. Players[b[2]]:GetName()
					else
						secText = secText .. ", " .. Players[b[2]]:GetName()
					end
				end
				secText = secText .. " have officially adopted " .. relName .. " as their official religions."
			elseif th == 3 then
				secText = secText .. " The greatest success was persuading city-states of"
				for a, b in pairs(tabOfForceMinorRel) do
					if a == #tabOfForceMinorRel then
						secText = secText .. " and " .. Players[b[2]]:GetName()
					elseif a == 1 then
						secText = secText .. " " .. Players[b[2]]:GetName()
					else
						secText = secText .. ", " .. Players[b[2]]:GetName()
					end
				end
				secText = secText .. " into adopting " .. relName .. " as state religion."
			end
		end
		if bHasAlreadyHeadline then
			table.insert(gT.Players[iPlayer].HistoryNote, {Text = secText})
		else
			iconAtlas = GameInfo.Religions[iRel].IconAtlas;
			portIndex = GameInfo.Religions[iRel].PortraitIndex;
			table.insert(gT.Players[iPlayer].HistoryNote, {HideImageFrame = true, ImageAtlas = iconAtlas, PortraitIndex = portIndex, Title = GetHNGRelMuchConvertingHeadline(iPlayer, relName), Text = secText, TitleDivider = true})
		end
	end
	-- much converting extra panel
	if bGhazi then
		local hT = {1, 2, 3}
		local secText = ""
		local th = hT[LastRandom(1,#hT)];
		if th == 1 then
			secText = "During " .. HnGGS("his") .. " lifetime, " .. HnGLeaderName() .. " was known as Ghazi, defender of faith and whole Islamic world. That was a result of an agressive politics against heathens and followers of other religions."
  		elseif th == 2 then
			secText = "In medieval times, rulers of Islamic world were competing for the tile of Ghazi, defender of faith. " .. HnGLeaderName() .. " was one of the few that earned it through bravery and wisdom. The prestige surrounding Ghazi was an important political factor in those days."
		elseif th == 3 then
			secText = HnGLeaderName() .. " was fighting against heathens, barbarians and other enemies of Islam entire life. " .. CapitalFL(HnGGS("he")) .. " was using armies to secure islamic Trade-Routes and settlements. Those efforts were recognized by fellow islamic leaders that respectfully titled " .. HnGGS("him") .. " a Ghazi." 
		end
		table.insert(gT.Players[iPlayer].HistoryNote, {Title = "Ghazi", Text = secText, TitleDivider = true})
	end
	if bHeresy then
		local secText = ""
		local heresyID = gT.Globals.HnGData.Constants.Heresy;
		local title = gT.Heresies[heresyID].Name;
	--table.insert(gT.Heresies, {Active = true, UnitID = jUnit:GetID(), LeaderName = sName, City = iCity:Plot():GetPlotIndex(), Start = GetITGGameTurn(), Pstarted = iPlayer, Name = heresyNames[LastRandom(1,#heresyNames)]})
		local cityName = Map.GetPlotByIndex(gT.Heresies[heresyID].City):GetPlotCity():GetName();
		local hT = {1, 2, 3}
		local th = hT[LastRandom(1,#hT)];

		if th == 1 then
			secText = "In " .. HnGDate(turn, false, true) .. " the self-called prophet, " .. gT.Heresies[heresyID].LeaderName .. " reached the city of " .. cityName .. " and started preaching. Soon after his followers took control over the region, declaring themselves apostles of " .. gT.Heresies[heresyID].Name .. ". Declared heretics they all eventually were hunted down, but those events are important part of local folklore."
		elseif th == 2 then
			secText = "The largest heretical movement in " .. HnGCivName() .. " took place in " .. cityName .. " where followers of " .. gT.Heresies[heresyID].Name .. " renounced authority of " .. HnGLeaderTitle() .. ". This revolt endangered the structural unity of the country. Unfortunately, false idols turned to be ineffective once the loyal army arrived to cleanse this heresy."
		elseif th == 3 then
			secText = gT.Heresies[heresyID].LeaderName .. " was a lesser known priest in a town of " .. cityName .. " when he started preaching at the market. After eight hours he ended his speech, effectively converting a small percentage of listeners, who started terrorizing the city, which converted even more people afraid of their lives. Eventually it lead to full-scale rebellion. Once caught, " .. gT.Heresies[heresyID].LeaderName .. " claimed that he is not to be responsible of actions of his followers, who simply misunderstood his words about peace and love."
		end
		table.insert(gT.Players[iPlayer].HistoryNote, {Title = title, Text = secText, TitleDivider = true})
	end
	for i, v in pairs(gT.Globals.HnGData.TemplarBeliefs) do
		if v[1] == iPlayer then
			if hntTbeliefBuildings[v[3]] then
				local iconAtlas = GameInfo.Buildings[v[3]].IconAtlas
				local relName = Locale.Lookup(GameInfo.Religions[v[2]].Description)
				local portIndex = GameInfo.Buildings[v[3]].PortraitIndex
				local sBuilding = Locale.Lookup(GameInfo.Buildings[v[3]].Description)
				local title = sBuilding
				local hT = {1, 2, 3, 4, 5}
				local th = hT[LastRandom(1,#hT)];
				local secText = ""
				if th == 1 then
					secText = CapitalFL(relName) .. "'s followers in " .. HnGCivName() .. " started gathering in buildings called " .. sBuilding .. ". Soon this trend spread to the entire religion."
				elseif th == 2 then
					secText = "Over the years followers of " .. relName .. " started designing their temples in certain fashion, the model of perfect temple soon emerged in the building called " .. sBuilding .. "."
				elseif th == 3 then
					secText = CapitalFL(sBuilding) .. " were originally a simple buildings dedicated to cult of " .. relName .. ". Right know they are considered the only orthodox temple in this religion."
				elseif th == 4 then
					secText = "Once the structures of " .. relName .. " were established the variety of temples decidated to it decreased. Soon the 'perfect' sacred place arose in the form of " .. sBuilding .. "." 
				elseif th == 5 then
					secText = "In " .. HnGDate(v[4], false, true) .. " the highest authorities of " .. relName .. " declared " .. sBuilding .. " as the one and the only form worthy to be a temple."
				end
				table.insert(gT.Players[iPlayer].HistoryNote, {ImageAtlas = iconAtlas, PortraitIndex = portIndex, Title = title, Text = secText, TitleDivider = true})
				table.insert(gT.Players[iPlayer].HistoryNote, {Text = Locale.Lookup(hntTbeliefBuildings[v[3]])})
				break;
			end
		end
	end

	if gT.Globals.HnGData.Crusades[iPlayer] then
		for i, v in pairs(gT.Globals.HnGData.Crusades[iPlayer]) do
		--= {pOwner, pCity:Plot():GetPlotIndex(), GetITGGameTurn(), calledBy, tH}
			local title = CapitalFL(GetNumberTH(v[5])) .. " crusade"
			local targetCity = Map.GetPlotByIndex(v[2]):GetPlotCity():GetName();
			local hT = {1, 2, 3}
			local secText = ""
			if (iPlayer ~= v[4]) and (v[4]) then
				table.insert(hT, 4)
				table.insert(hT, 5)
			end
			local th = hT[LastRandom(1,#hT)];
			if th == 1 then
				secText = "Scholars claim that " .. targetCity .. " was important trade center rivalizing with christian merchants, which was the main reason for this crusade. " .. HnGLeaderName() .. " was the main commander of forces besieging city."
			elseif th == 2 then
				secText = "In " .. HnGDate(v[3], false, true) .. ", " .. HnGLeaderName() .. " lead the crusade with a task of conquering the city of " .. targetCity .. ". This was a great occasion to proof " .. HnGGS("his") .. " devotion and military skills." 
			elseif th == 3 then
				secText = "The path to " .. targetCity .. " (target of " .. GetNumberTH(v[5]) .. " crusade) was long and treacherous. Thankfully, " .. HnGLeaderName() .. " was wise enough to avoid rivers on " .. HnGGS("his") .. " path and safely returned from this expedition."	
			elseif th == 4 then
				secText = "Answering the call of " .. Players[v[4]]:GetName() .. ", " .. HnGLeaderName() .. " lead the crusaders to conquer the city of " .. targetCity .. " in the year of " .. HnGDate(v[3], false, true) .. "." 
			elseif th == 5 then
				secText = "In " .. HnGDate(v[3], false, true) .. " the leader of christian world, " .. Players[v[4]]:GetName() .. " called to arms. The crusade main target was " .. targetCity .. " and quite surprisingly it was lead by " .. HnGLeaderName() .. "."
			end
			if not v[6] then
				secText = secText .. "[NEWLINE][NEWLINE]When crusaders reached " .. targetCity .. ", the city was already under christian leadership."
			else
				local hFt = GetAfterTurnConqueredBy(Map.GetPlotByIndex(v[2]):GetPlotCity(), iPlayer, v[3])
				if hFt then
					local sTv = LastRandom(1,3);
					if sTv == 1 then
						secText = secText .. "[NEWLINE][NEWLINE]Crusaders easily crushed unprepared defenders and triumphally entered city in " .. HnGDate(hFt, false, true) .. ". This success made great impact on " .. HnGLeaderTitle() .. "'s reputation and reign."
					elseif sTv == 2 then
						secText = secText .. "[NEWLINE][NEWLINE]The crusade succeed in capturing " .. targetCity .. " (" ..  HnGDate(hFt, false, true) .. "), however it was victory without greater strategical or political consequences."
					elseif sTv == 3 then
						secText = secText .. "[NEWLINE][NEWLINE]The gates of " .. targetCity .. " were broken in " .. HnGDate(hFt, false, true) .. ". Legend says that " .. HnGLeaderTitle() .. " was commanding from first lines, however most scholars are sceptical about that." 
					end
				else
					local sTv = LastRandom(1,3);
					if sTv == 1 then
						secText = secText .. "[NEWLINE][NEWLINE]The crusade failed, " .. HnGLeaderName() .. " never step into " .. targetCity .. " and returned to country in shame."
					elseif sTv == 2 then
						secText = secText .. "[NEWLINE][NEWLINE]After months of sieging, crusaders' army was forced to retreat. Even though " .. HnGLeaderTitle() .. " didn't manage to conquer " .. targetCity .. " " .. HnGGS("his") .. " reputation has increased within christian world." 
					elseif sTv == 3 then
						secText = secText .. "[NEWLINE][NEWLINE]Scholars are unsure why the great number of fanatics were not able to force the gates of " .. targetCity .. ". Some point on lack of unity, others on incompetence of " .. HnGLeaderName() .. "." 
					end
				end
			end
			table.insert(gT.Players[iPlayer].HistoryNote, {Title = title, Text = secText, TitleDivider = true})
		end
	end
end

function GetAfterTurnConqueredBy(iCity, iPlayer, turn)
	local cIndex = iCity:Plot():GetPlotIndex();
	for i, v in pairs(gT.Globals.HnGData.CityCaptures) do
		if v.Plot == cIndex and turn <= v.Turn and (v.New == iPlayer) then
			return v.Turn;
		end
	end
	return nil;
end

function GetReligionForHnGIcon(iPlayer)
	if Players[iPlayer]:GetReligionCreatedByPlayer() ~= -1 then
		return Players[iPlayer]:GetReligionCreatedByPlayer();
	end
	for l, b in pairs(gT.Players[iPlayer].EverControlReligion) do
		return l;
	end
	if gT.Players[iPlayer].OfficialReligion then
		return gT.Players[iPlayer].OfficialReligion;
	end
	return nil;
end

function DoInitHNGBooleansAndConstants()
	if gT.Globals.HnGData.Constants then
		return
	end
	gT.Globals.HnGData.Constants = {}
	--trade center
	local bcID;
	local bScore = 0;
	for cID, h in pairs(gT.Cities) do
		local cScore = #gT.Cities[cID].TradeRoutesCompleted
		if cScore > bScore then
			bcID = cID;
			bScore = cScore;
		end
	end
	if bcID then
		if (gT.Cities[bcID].NumConquered or 0) == 0 then
			gT.Globals.HnGData.Constants.CityCenter = {gT.Cities[bcID].Plot, Map.GetPlotByIndex(gT.Cities[bcID].Plot):GetOwner()};
		end
	end
	--academy prestige 
	gT.Globals.HnGData.Constants.AcademyPrestige = {};
	local ibaindex, ibaplayer;
	local ibascore = 0;
	for g, gd in pairs(gT.Academies) do
		if gd.MaxPrestigeEver > ibascore then
			ibascore = gd.MaxPrestigeEver;
			ibaplayer = gd.MaxPrestigePlayer;
			ibaindex = g;
		end
	end
	if ibaplayer and (gT.Academies[ibaindex].OriginalPlayer == ibaplayer) then
		gT.Globals.HnGData.Constants.AcademyPrestige = {ibaindex, ibaplayer}
	end
	--ghazi
	local sBhf = {"Ghazi"};
	for idd, hstring in pairs(sBhf) do
		local bVal, bP = 1, {};
		for l, h in pairs(gT.Leagues) do
			for iPlayer, d in pairs(h.Members) do
				if d.VotesFromScripts[hstring] then
					if d.VotesFromScripts[hstring] > bVal then
						bP = {[iPlayer] = true}
						bVal = d.VotesFromScripts[hstring];
					elseif d.VotesFromScripts[hstring] == bVal then
						bP[iPlayer] = true;
					end
				end
			end
		end
		gT.Globals.HnGData.Constants[hstring] = bP;
	end
	local hTrbesy = {}
	for a, b in pairs(gT.Heresies) do
		table.insert(hTrbesy, {a, (b.End or 100) - b.Start})
	end 
	if #hTrbesy > 0 then
		local tKey = GetRandomFromBiasedChanceTable(hTrbesy);
		gT.Globals.HnGData.Constants.Heresy = tKey
	end
end

function WasFirstEverReligion(iPlayer, gTurn)
	if gT.Globals.ScenarioType ~= 3 then
		return false;
	end
	for i, rr in pairs(gT.Globals.HnGData.ReligionFounded) do
		if i ~= iPlayer then
			if (rr[2] < gTurn) or (rr[2] == gTurn and (i < iPlayer)) then
				return false;
			end
		end
	end
	return true;
end