local palaceExclT = {}

function GetAtlasAndPIfromPalace(type)
	if GameInfo.ITG_Palaces[type].IconAtlas then
		return GameInfo.ITG_Palaces[type].IconAtlas, GameInfo.ITG_Palaces[type].PortraitIndex
	end
	print("Undefined 563435$#", GameInfo.ITG_Palaces[type].Type)
	return "BUILDING_ITG_PALACE_ATLAS_1", 0;
end

function GetHnGPalaceTitle(iPlayer)
	local hh = LastRandom(1, 9)
	if hh == 1 then
		return "Palaces"
	elseif hh == 2 then
		return "Residences"
	elseif hh == 3 then
		return CapitalFL(HnGLeaderTitle()) .. "'s houses"
	elseif hh == 4 then
		return "Palaces - construction and improvement"
	elseif hh == 5 then
		return "Residences of " .. HnGLeaderName();
	elseif hh == 6 then
		return "Public image"
	elseif hh == 7 then
		return "Monuments of power"
	elseif hh == 8 then
		return "Renovation of houses"
	elseif hh == 9 then
		return "Restoration and construction of palaces"
	end
end

function GetPalaceHnGImageLabel(iPlayer, turn, city)
	local hh = LastRandom(1, 9)
	if hh == 1 then
		return "Court in " .. city:GetName() .. "."
	elseif hh == 2 then
		return "Grand palace of " .. city:GetName() .. "."
	elseif hh == 3 then
		return city:GetName() .. "'s palace, completed in " .. HnGDate(turn) .. "."
	elseif hh == 4 then
		return "Most prestigious " .. HnGLeaderName() .. "'s palace, " .. city:GetName() .. "."
	elseif hh == 5 then
		return "Palace of " .. city:GetName() .. ", c. " .. HnGDate(turn) .. "."
	elseif hh == 6 then
		return "In " .. HnGDate(turn) .. " " .. HnGLeaderName() .. " moved into palace of " .. city:GetName() .."."
	elseif hh == 7 then
		return CapitalFL(HnGLeaderTitle()) .. "'s residence in " .. city:GetName() .. "."
	elseif hh == 8 then
		return HnGLeaderName() .. "'s pride, the residence in " .. city:GetName() .. ", finished around " .. HnGDate(turn) .. "."
	else
		return nil;
	end
end

function GetHnGPalaceHeadline(iPlayer)
	local hh = LastRandom(1, 6);
	if hh == 1 then
		return "List of palaces' locations:" 
	elseif hh == 2 then
		return "Palaces and residences constructed or developed by " .. HnGLeaderName() .. ":"
	elseif hh == 3 then
		return "Locations of residences:" 
	elseif hh == 4 then
		return "Cities where " .. HnGLeaderName() .. " constructed palaces:" 
	elseif hh == 5 then
		return "Favourite places of " .. HnGLeaderName() .. ":"
	elseif hh == 6 then
		return "Locations:"
	end
end

function GetRarePalacePlaceHnGText(i, toptier, turn, city, iPlayer)
	local hh = LastRandom(1, 30);
	if palaceExclT[hh] then
		return "";
	else
		palaceExclT[hh] = true;
	end
	if hh == 1 then
		return ", favourite " .. HnGLeaderName() .. "'s palace."
	elseif hh == 2 then
		if toptier < 5 then
			return ", smaller residence."
		else
			return ", grand palace."
		end
	elseif hh == 3 then
		if city:GetPopulation() < 7 then
			return ", summer residence, visited several times."
		else
			return ", palace used during frequent visits."
		end
	elseif hh == 4 then
		return ", small court."
	elseif hh == 5 then
		return ", hunting residence."
	elseif hh == 6 then
		return ", finished in " .. HnGDate(turn) .. "."
	elseif hh == 7 then
		return ", place of annual royal balls."
	elseif hh == 8 then
		return ", one visit."
	elseif hh == 9 then
		return ", " .. HnGLeaderName() .. " personally commissioned renovation after visiting the palace."
	elseif hh == 10 then
		if city:GetOwner() ~= iPlayer then
			return ", captured by " .. Players[city:GetOwner()]:GetCivilizationAdjective() .. " invaders.";
		end
	elseif hh == 11 then
		return ", palace was reconstructed after a fire."
	elseif hh == 12 then
		return ", birthplace of " .. HnGLeaderName() .. "."
	elseif hh == 13 then
		return ", winter residence."
	elseif hh == 14 then
		return ", lesser palace."
	end
	return "";
end

function GetHnGPalaceBaseText(iPlayer, nmpMade)
	if nmpMade > LastRandom(10, 12) then
		local hh = LastRandom(1, 6);
		if hh == 1 then
			return HnGLeaderName() .. " was not saving national treasury from expenses on " .. HnGGS("his") .. " residences. It is documented that " .. HnGGS("he") .. " ordered at least " .. nmpMade .. " renovations and new constructions around the empire. It is hard for a tourist to visit " .. Players[iPlayer]:GetCivilizationShortDescription() .. " without visiting a place related to " .. HnGGS("him") .. "."
		elseif hh == 2 then
			return "In order to increase " .. HnGGS("his") .. " authority and prestige within the subjects and rivals, " .. HnGLeaderName() .. " commisioned the construction of multiple palaces, some older houses were renovated to meet new standards and architectural styles. It had increased amount of skilled architects and artistans while also developed the cultural elites from young artists invited to courts. Some of those palaces haven't survived to our times, other have turned into museums and are opened to visitors."
		elseif hh == 3 then
			return HnGLeaderName() .. " was a passionate hunter, and constructed several residences to fulfill the hobby in free time. Several new palaces was built and some older, forgotten houses received a second youth. Those construction helped " .. HnGGS("him") .. " to present an image of unchallengeable authority and irresistible power on which " .. HnGGS("he") .. " was working entire reign."
		elseif hh == 4 then
			return "Inspired by architectural news and innovations, " .. HnGLeaderName() .. " ordered construction and improvement of several significant buildings that inspired nobles and magnates around " .. Players[iPlayer]:GetCivilizationShortDescription() .. " to copy royal residences. This all resulted in creating new unique " .. Players[iPlayer]:GetCivilizationAdjective() .. " style of palaces, courts and residences that lasted about a century."
		elseif hh == 5 then
			return "This reign resulted also in construction of multiple palaces, which unfortunately became neglected and forgotten after " .. HnGLeaderTitle() .. "'s death. Most scholars believe that those whims ruined otherwise stable economy of realm."	
		elseif hh == 6 then		
			return "Developing several palaces at once is the best proof of " .. HnGLeaderTitle() .. "'s enormous ego. Most of those constructions were rarely visited by " .. HnGGS("him") .. " if at all, and served more as symbols of prestige and power. Most of those residences were given away to the nobles and magnates by the " .. HnGLeaderTitle() .. "'s successor in exchange of loyalty and notable service."
		end
	else
		local hh = LastRandom(1, 5);
		if hh == 1 then
			return "Constructing palaces was a secondary hobby of " .. HnGLeaderName() .. ", which resulted in the creation of several architectural pearls around the " .. Players[iPlayer]:GetCivilizationAdjective() .. ". Most of them are now open to visitors, but during " .. HnGGS("his") .. " reign only the chosen were invited to dine with " .. HnGLeaderTitle() .. "."
		elseif hh == 2 then
			return "During " .. HnGLeaderName() .. "'s reign multiple palaces' construction and renovation took place, but it was never a priority to " .. HnGGS("him") .. ". Most of those residences are still existing."  
		elseif hh == 3 then
			return "Another notable achivement was construction of several residences that served " .. HnGGS("him") .. " and " .. HnGGS("his") .. " successors for centuries. Some of those constructions became prime examples of " .. GetCenturyThFromYear(90) .. " architecture."
		elseif hh == 4 then
			return "Travelling around the " .. Players[iPlayer]:GetCivilizationShortDescription() .. " we can find several places dedicated to " .. HnGLeaderName() .. ", mostly palaces and residences where " .. HnGGS("he") .. " lived. " .. HnGLeaderName() .. " started a trend of constructing palaces and residences, every next successor tried to outdid the predecessor in this field."
		elseif hh == 5 then
			return CapitalFL(HnGLeaderTitle()) .. " is responsible for several notable residences that can be found in " .. Players[iPlayer]:GetCivilizationShortDescription() .. ". Unfortunately all of them are quite insignificant to the palace made by " .. HnGGS("his") .. " father."
		end
	end
end

function GetHnGPalacesNote(iPlayer)
	local nmpMade = gT.Players[iPlayer].LHNumPalaceUpgrades
	if nmpMade >= LastRandom(7, 12) then
		palaceExclT = {}
		local citiesT = {}
		for cID, h in pairs(gT.Cities) do
			if h.LHPalacePlayer == iPlayer then
				table.insert(citiesT, {cID, h.LHPalaceTop, h.LHPalaceTurn, Map.GetPlotByIndex(h.Plot):GetPlotCity()})
				if not h.LHPalaceTurn then
					print("Palace has no turn of completion", cID, iPlayer);
				end
			end
		end
		citiesT = Shuffle(citiesT)
		local listText = ""
		if #citiesT >= LastRandom(3, 6) then
			listText = "[NEWLINE][NEWLINE]" .. GetHnGPalaceHeadline(iPlayer)
			for a, b in pairs(citiesT) do
				listText = listText .. "[NEWLINE][ICON_BULLET]" .. b[4]:GetName() .. GetRarePalacePlaceHnGText(a, b[2], b[3], b[4], iPlayer)
			end
		end
		local imageAtlas, imagePI, imageLabel;
		table.sort(citiesT, SortFunctionForGreaterInteger2)
		if citiesT[1][2] == 10 then
			if gT.Cities[citiesT[1][1]].Palace then
				imageAtlas, imagePI = GetAtlasAndPIfromPalace(gT.Cities[citiesT[1][1]].Palace.Type)
				imageLabel = GetPalaceHnGImageLabel(iPlayer, citiesT[1][3], citiesT[1][4])
			end
		end
		local title = GetHnGPalaceTitle(iPlayer)
		local text = GetHnGPalaceBaseText(iPlayer, nmpMade)
		text = text .. listText
		table.insert(gT.Players[iPlayer].HistoryNote, {ImageAtlas = imageAtlas, PortraitIndex = imagePI, ImageLabel = imageLabel, Title = title, Text = text, TitleDivider = true})
	end
end

function HnGInnoCompanionCavalry(iPlayer, turn, tech)
	local title = Locale.Lookup(GameInfo.Technologies[tech].Description)
	local imageAtlas, imagePI = "UNIT_ATLAS_1", 18;
	local text;
	local hh = LastRandom(1, 3);
	if hh == 1 then
		text = "The Companions (hetairoi) were the elite cavalry of the " .. Players[iPlayer]:GetCivilizationAdjective() .. " army from the time of " .. HnGLeaderName() .. ", achieved prestige and have been regarded as the first or among the first shock cavalry used in world. Chosen Companions, or Hetairoi, formed the elite guard of the king."
	elseif hh == 2 then
		text = "The name of the military unit derives from Hetairoi, those near the king. The Hetairoi (Companions) could be members of the " .. Players[iPlayer]:GetCivilizationAdjective() .. " aristocracy or commoners of any origin who enjoyed the trust and friendship of the regent. The Hetairideia, a festival pertaining to the sacred relationship which bound the king and his companions together was celebrated. The Royal friends (Philoi) or the king's Companions (basilikoi hetairoi) were named for life by the king among the aristocracy."
	elseif hh == 3 then
		text = "Companion cavalry would ride the best horses, and receive the best weaponry available. In " .. HnGLeaderName() .. "'s day, each carried a xyston, and wore a bronze muscle cuirass or linothorax, shoulder guards and Boeotian helmets, but bore no shield. A kopis (curved slashing sword) or xiphos (cut and thrust sword) was also carried for close combat, should the xyston break."
	end
	return text, title, imageAtlas, imagePI
end
function HnGInnoTangCode(iPlayer, turn, tech)
	local title = Locale.Lookup(GameInfo.Technologies[tech].Description)
	local text;
	local hh = LastRandom(1, 3);
	if hh == 1 then
		text = "The Tang Code was a penal code that was established and used during the " .. HnGLeaderName() .. "'s reign in " .. Players[iPlayer]:GetCivilizationShortDescription() .. ". Supplemented by civil statutes and regulations, it became the basis for later dynastic codes in the entire region. The Code synthesized Legalist and Religious interpretations of law. Created in " .. HnGDate(turn) .. " it was promulgated and enhanced with a commentary. Considered as one of the greatest achievements of traditional law, the Tang Code is also the earliest " .. Players[iPlayer]:GetCivilizationAdjective() .. " Code to have been transmitted to the present in its complete form."
	elseif hh == 2 then
		text =  "The Tang code took its roots in the code of the previous dynasty, which was itself based on the earlier codes from ancient times. Aiming to smooth the earlier laws and reduce physical punishments (such as mutilations) in order to appease social tensions in the newly pacified territories, it was created in " .. HnGDate(turn) .. " at the request of " .. HnGLeaderTitle() .. ". After further revisions, the code was completed by commentaries, under successor of " .. HnGLeaderName() .. "."
	elseif hh == 3 then
		text =  "Historian once called the Tang Code ''an admirable composition of faultless logic in spite of its size and complexity.'' Other scholars described it as ''a very rational system of justice'' in which ''both the accuser and the officials involved had to be careful lest they themselves face punishment''. The Tang Code contained more than 500 articles divided into twelve large sections (see right-side table)."
	end
	return text, title
end
function HnGInnoRococo(iPlayer, turn, tech)
	local title = Locale.Lookup(GameInfo.Technologies[tech].Description)
	local text;
	local hh = LastRandom(1, 3);
	if hh == 1 then
		text = "Rococo, less commonly roccoco, or ''Late Baroque'', is an exceptionally ornamental and theatrical style of architecture, art and decoration which combines asymmetry, scrolling curves, gilding, white and pastel colors, sculpted molding, and trompe l'oeil frescoes to create the illusions of surprise, motion and drama. It first appeared in " .. Players[iPlayer]:GetCivilizationShortDescription() .. " in the " .. HnGDate(turn) .. " and spread to region decade later. It is often described as the final expression of the Baroque movement."
	elseif hh == 2 then
		text = "The Rococo style began in " .. Players[iPlayer]:GetCivilizationShortDescription() .. " in the " .. GetCenturyThFromYear(turn) .. " century in the reign of " .. HnGLeaderName() .. " as a reaction against the more formal and geometric Style of " .. HnGGS("his") .. " predecessor. It was known as the style rocaille, or rocaille style. It soon spread to other parts of continent. It also came to influence the other arts, particularly sculpture, furniture, silverware and glassware, painting, music, and theatre. The term rococo was first used in print century later to describe decoration which was ''out of style and old-fashioned''."
	elseif hh == 3 then
		text = "The word rococo was first used as a humorous variation of the word rocaille. Rocaille was originally a method of decoration, using pebbles, seashells and cement, which was often used to decorate grottoes and fountains since the Renaissance. In the late " .. GetCenturyThFromYear(turn - 400) .. " and " .. GetCenturyThFromYear(turn) .. " century rocaille became the term for a kind of decorative motif or ornament in the form of a seashell interlaced with acanthus leaves. The carved or molded seashell motif was combined with palm leaves or twisting vines to decorate doorways, furniture, wall panels and other architectural elements."
	end
	return text, title
end
function HnGDruidicLore(iPlayer, turn, tech)
	local title = Locale.Lookup(GameInfo.Technologies[tech].Description)
	local text;
	local hh = LastRandom(1, 3);
	if hh == 1 then
		text = "Druids also play a prominent role in " .. Players[iPlayer]:GetCivilizationAdjective() .. " Folklore, generally serving lords and kings as high ranking priest-counselors with the gift of prophecy and other assorted mystical abilities - the best example of these possibly being Cathbad. The chief druid in the court of " .. HnGLeaderTitle() .. " " .. HnGLeaderName() .. ", Cathbad features in several tales, most of which detail his ability to foretell the future. In the tale of Deirdre of the Sorrows - the foremost tragic heroine of the Ulster Cycle - the druid prophesied before the court of Conchobar that Deirdre would grow up to be very beautiful, but that kings and lords would go to war over her, much blood would be shed because of her, and " .. HnGLeaderName() .. "'s three greatest warriors would be forced into exile for her sake. This prophecy, ignored by the " .. HnGLeaderTitle() .. ", came true.";
	elseif hh == 2 then
		text = "Arguably the greatest of these mythological druids was Amergin Glingel, a bard and judge for the Milesians featured in the Mythological Cycle. The Milesians were seeking to overrun the Tuatha De Danann and win the land of " .. Players[iPlayer]:GetCivilizationShortDescription() .. " but, as they approached, the druids of the Tuatha D Danann raised a magical storm to bar their ships from making landfall. Thus Amergin called upon the spirit of land itself, chanting a powerful incantation that has come to be known as The Song of Amergin and, eventually (after successfully making landfall), aiding and dividing the land between his royal brothers in the conquest of " .. Players[iPlayer]:GetCivilizationShortDescription() .. ". Other such mythological druids were Tadg mac Nuadat of the Fenian Cycle, and Mug Ruith, a powerful blind druid of Munster."
	elseif hh == 3 then
		text = "Sources by ancient and medieval writers provide an idea of the religious duties and social roles involved in being a druid. The vernacular " .. Players[iPlayer]:GetCivilizationAdjective() .. " sources agree that the druids played an important part in pagan society. Scholars claimed that they were one of the two most important social groups in the region (alongside the equites, or nobles) and were responsible for organizing worship and sacrifices, divination, and judicial procedure in societies of the region. They were exempt from military service and from the payment of taxes, and had the power to excommunicate people from religious festivals, making them social outcasts. Other classical writers, also wrote about the role of druids in " .. Players[iPlayer]:GetCivilizationAdjective() .. " society, claiming that the druids were held in such respect that if they intervened between two armies they could stop the battle."
	end
	return text, title
end
function HnGRomanTriumph(iPlayer, turn, tech)
	local title = Locale.Lookup(GameInfo.Technologies[tech].Description)
	local text;
	local hh = LastRandom(1, 3);
	if hh == 1 then
		text = "Earliest ''triumphs'' were probably simple victory parades, celebrating the return of a victorious " .. HnGLeaderTitle() .. " and " .. HnGGS("his") .. " army to the city, along with the fruits of his victory, and ending with some form of dedication to the gods. This is probably so for the earliest legendary and later semi-legendary triumphs of regal era, when the " .. HnGLeaderTitle() .. " functioned as Rome's highest magistrate and war-leader. As empire population, power, influence, and territory increased, so did the scale, length, variety, and extravagance of its triumphal processions."
	elseif hh == 2 then
		text = "Victorious parades have their origin with " .. HnGLeaderName() .. "'s reign. The procession (pompa) mustered in the open space of the field of God of War probably well before first light. From there, all unforeseen delays and accidents aside, it would have managed a slow walking pace at best, punctuated by various planned stops en route to its final destination of the high temple, a distance of just under 4 km. Triumphal processions were notoriously long and slow; the longest could last for two or three days, and possibly more, and some may have been of greater length than the route itself."
	elseif hh == 3 then
		text = "In " .. HnGLeaderName() .. "'s " .. Players[iPlayer]:GetCivilizationShortDescription() .. ", truly exceptional military achievement merited the highest possible honours, which connected the ''man of triumph'', later known as a triumphator, to mythical and semi-mythical past. In effect, the general was close to being ''king for a day'', and possibly close to divinity. He wore the regalia traditionally associated both with the ancient monarchy and with the statue of supreme deity: the purple and gold ''toga picta'', laurel crown, red boots and, again possibly, the red-painted face of supreme deity. He was drawn in procession through the city in a four-horse chariot, under the gaze of his peers and an applauding crowd, to the high temple. The spoils and captives of his victory led the way; his armies followed behind."
	end
	return text, title
end
local hngInnoT = {
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_EMPIRE_12] = HnGRomanTriumph,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_27] = HnGInnoCompanionCavalry,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_TRIBE_2] = HnGDruidicLore,
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_ASIA_5] = HnGInnoTangCode,
[GameInfoTypes.TECH_UNIQUE_ITG_INDUSTRIAL_10] = HnGInnoRococo,
--TECH_UNIQUE_ITG_NEW_WORLD_ASIA_1 --> Shinobi has text in espionage //
}

function GetHnGInnovationsNote(iPlayer)
	for a, b in pairs(gT.Globals.HnGData.Innovations) do
		if b[1] == iPlayer then
			if hngInnoT[a] then
				local text, title, imageAtlas, imagePI, imageLabel = hngInnoT[a](iPlayer, b[2], a);
				table.insert(gT.Players[iPlayer].HistoryNote, {ImageAtlas = imageAtlas, PortraitIndex = imagePI, ImageLabel = imageLabel, Title = title, Text = text, TitleDivider = true})
			end
		end
	end
end

function GetHnGHeadlingSpaceflight(iPlayer)
	local l = LastRandom(1, 7)
	if l == 1 then
		return "Project Apollo"
	elseif l == 2 then
		return "Moonwalk"
	elseif l == 3 then
		return "Spaceflight program of " .. HnGCivName()
	elseif l == 4 then
		return "Spaceflight program"
	elseif l == 5 then
		return "Lunar program"
	elseif l == 6 then
		return "Big Cheese program"
	elseif l == 7 then
		return "Moon landing"
	end
end

function GetHnGHeadlineNuclearProject(iPlayer)
	local l = LastRandom(1, 7)
	if l == 1 then
		return "Project Manhattan"
	elseif l == 2 then
		return "Project Big Boom"
	elseif l == 3 then
		return "Nuclear Program"
	elseif l == 4 then
		return "Atomic Bomb"
	elseif l == 5 then
		return "Nuclear tests"
	elseif l == 6 then
		return HnGCivAdj() .. " Nuclear Pogram"
	elseif l == 7 then
		return "Project Ragnarok"
	end
end

function GetHnGProjectsBudget(iPlayer)
	if gT.Globals.ScenarioType ~= 5 then
		return;
	end
	local tab = {} -- sort it by turn
	--nuclear
	if gT.Players[iPlayer].LHNuclearTurn then
		local bFirst = gT.Globals.NuclearPt == gT.Players[iPlayer].LHNuclearTurn;
		local turn = gT.Players[iPlayer].LHNuclearTurn;
		local sText = ""
		if bFirst then
			local l = LastRandom(1,3);
			if l == 1 then
				sText = "In the world deep in the war, new technologies were crucial to obtain strategical advantage. Scientists formulated their fear of possibility of creating nuclear weapon, and " .. HnGLeaderTitle() .. " made sure those fears will become real. In " .. HnGDate(turn, false, true) .. ", " .. HnGCivName() .. " has officially acquired new weapon into their arsenal, Atomic Bomb."
			elseif l == 2 then
				sText = "Military commanders of " .. HnGCivName() .. " were in grave need of acquiring weapon that could change the war. Thankfully, the egghead neither failer nor disappointed them this time. In " .. HnGDate(turn, false, true) .. " first test of Atomic Bomb was conducted and " .. HnGLeaderTitle() .. " announced that all enemies of state will perish in the newly acquire power of the sun."
			elseif l == 3 then
				sText = "In " .. HnGDate(turn, false, true) .. " world trembled in fear when " .. HnGLeaderName() .. " announced creation of the most destructive weapon in human history. All other leaders were extremely jealous about big red button on " .. HnGLeaderTitle() .. "'s desk. The war has moved into completely new stage where entire cities could be anihilated in the matter of seconds."
			end
		else
			local fPlayer;
			local fTurn = gT.Globals.NuclearPt;
			for g, h in pairs(gT.Players) do
				if h.LHNuclearTurn == fTurn then
					fPlayer = g;
					break;
				end
			end
			local l = LastRandom(1,3);
			if l == 1 then
				sText = "When in " .. HnGDate(fTurn, false, true) .. " the " .. Players[fPlayer]:GetCivilizationShortDescription() .. " announced creation of ultimate weapon, the goverment of " .. HnGCivName() .. " and " .. HnGLeaderTitle() .. " decided to double their efforts in creating atomic bomb. The work paid off in " .. HnGDate(turn, false, true) .. ", when first successful test of " .. HnGCivAdj() .. " atomic bomb was performed." 
			elseif l == 2 then
				sText = "Armaments race of 20th century lead to the creation of Atomic Bomb by " .. Players[fPlayer]:GetCivilizationShortDescription() .. " in " .. HnGDate(fTurn, false, true) .. ". However, scientists from " .. HnGCivName() .. " quickly catched up (with some help from espionage) and were ready to perform first test in " .. HnGDate(turn, false, true) .. ". " .. CapitalFL(HnGLeaderTitle()) .. " " .. HnGLeaderName() .. " announced new era of supremacy."
			elseif l == 3 then
				sText = HnGLeaderName() .. " couldn't accept lack of access to the newest weapons. " .. CapitalFL(HnGCivAdj()) .. " nuclear program accelerated once " .. Players[fPlayer]:GetCivilizationShortDescription() .. " announced first successful test of the weapon. Announcing acquisition of atomic bomb in " .. HnGDate(turn, false, true) .. " was crucial to maintain " .. HnGLeaderTitle() .. "'s position and dreams about becoming world power."    
			end
		end
		--+usage
		local usages = {}
		for i, v in pairs(gT.Globals.HnGData.NucLog) do
			if v[1] == iPlayer then
				table.insert(usages, i)
			end
		end
--	table.insert(gT.Globals.HnGData.NucLog, {iPlayer, iPlot:GetPlotIndex(), iPlot:GetOwner(), GetITGGameTurn()})
		if #usages == 0 then
			local l = LastRandom(1,3);
			if l == 1 then
				sText = sText .. " Thankfully, " .. HnGLeaderTitle() .. " was sane enough to never used this weapon."
			elseif l == 2 then
				sText = sText .. " Despite big words atomit bomb has never been used in combat by " .. HnGCivName() .. "."
			elseif l == 3 then
				sText = sText .. " Surprisingly " .. HnGLeaderName() .. " has never agreed to use this weapon even though the pressure from commanders were significant."
			end			
		elseif #usages == 1 then
			local ttt = "neutral territory"
			local turn = gT.Globals.HnGData.NucLog[usages[1]][4]
			local tPlot = Map.GetPlotByIndex(gT.Globals.HnGData.NucLog[usages[1]][2]);
			if tPlot:IsCity() then
				ttt = "city of " .. tPlot:GetPlotCity():GetName();
			elseif gT.Globals.HnGData.NucLog[usages[1]][3] ~= -1 then
				local adjCity = GetAdjacentCity(tPlot)
				if adjCity then
					ttt = "city of " .. adjCity:GetName();
				else
					ttt = Players[gT.Globals.HnGData.NucLog[usages[1]][3]]:GetCivilizationAdjective() .. " territory"
				end
			end
			local l = LastRandom(1,3);
			if l == 1 then
				sText = sText .. " Atomic bomb was used once, in " .. HnGDate(turn, false, true) .. ", on " .. ttt .. "."
			elseif l == 2 then
				sText = sText .. " " .. HnGLeaderTitle() .. " ordered usage of Atomic Bomb only once, targeting " .. ttt .. " in " .. HnGDate(turn, false, true) .. "."
			elseif l == 3 then
				sText = sText .. " This weapon was used in " .. HnGDate(turn, false, true) .. ", targeting " .. ttt .. "."
			end
		else
			local l = LastRandom(1,3);
			if l == 1 then
				sText = sText .. "[NEWLINE][NEWLINE]List of Atomic Bomb usages:"
			elseif l == 2 then
				sText = sText .. "[NEWLINE][NEWLINE]Atomic Bombs used in combat:"
			elseif l == 3 then
				sText = sText .. "[NEWLINE][NEWLINE]List of atomic explosions ordered by " .. HnGLeaderName() .. ":"
			end
			--make a list
			for i, v in pairs(usages) do
				local ttt = "neutral territory"
				local turn = gT.Globals.HnGData.NucLog[v][4] 
				local tPlot = Map.GetPlotByIndex(gT.Globals.HnGData.NucLog[v][2]);
				if tPlot:IsCity() then
					ttt = "city of " .. tPlot:GetPlotCity():GetName();
				elseif gT.Globals.HnGData.NucLog[v][3] ~= -1 then
					local adjCity = GetAdjacentCity(tPlot)
					if adjCity then
						ttt = "city of " .. adjCity:GetName();
					else
						ttt = Players[gT.Globals.HnGData.NucLog[v][3]]:GetCivilizationAdjective() .. " territory"
					end
				end
				sText = sText .. "[NEWLINE][ICON_BULLET]" .. CapitalFL(ttt) .. " (" .. HnGDate(turn, false, true) .. ")"
			end
		end

		table.insert(tab, {ImageAtlas = "BW_ATLAS_2", PortraitIndex = 41, [2] = gT.Players[iPlayer].LHNuclearTurn, Title = GetHnGHeadlineNuclearProject(iPlayer), Text = sText, TitleDivider = true})
	end
	--polio
	if gT.Players[iPlayer].BudgetOptions[14][2] >= 150000 then
		local polioTurn = gT.Globals.PolioDone or 101;
		local sText = ""
		local lH = LastRandom(1,3)
		if lH == 1 then
			sText = "In a generic sense, vaccination works by priming the immune system with an 'immunogen'. Stimulating immune response, by use of an infectious agent, is known as immunization. The development of immunity to polio efficiently blocks person-to-person transmission of wild poliovirus, thereby protecting both individual vaccine recipients and the wider community. Polio vaccine remains one of the greatest achievement of humanity."
		elseif lH == 2 then
			sText = "In the world on the edge of war Polio diseases united scientist around the globe against a common enemy. Developing a successful and safe vaccine was long and costly battle. However, even the most corrupted political leaders knew that this research is worth every single dime. We, the future generations, are greatful for this gift, the gift of normal life."
		elseif lH == 3 then
			sText = "Definitely not as spectacular as explosives, death and atrocity of war, or amazing as man walking on the moon, yet the Polio vaccine development may be the most crucial achievement of 20th century. Created above divisions made the greatest impact on common folks of future generations. They will not have to live in fear about their offspring, living in blissful obliviousness."
		end
		if gT.Players[iPlayer].BudgetOptions[14][2] >= 500000 then
			lH = LastRandom(1,3)
			if lH == 1 then
				sText = sText .. " " .. HnGCivName() .. " were a crucial source of funding the process and their citizens can proudly claim the autorship of vaccine. Most of key scientists were of " .. HnGCivAdj() .. " as well."
			elseif lH == 2 then
				sText = sText .. " The leading medical lab was located and sponsored by " .. HnGCivName() .. ". " .. HnGLeaderName() .. " were publicly speaking about the importance of creating vaccine and mobilized citizens to gather extra funds for the process."
			elseif lH == 3 then
				sText = sText .. " It remains one of the personal successes of " .. HnGLeaderName() .. " who invested enormous amount of budget into vaccine. Thankfully, the citizens were educated enough to understand the importance of vaccination."
			end
		else
			lH = LastRandom(1,3)
			if lH == 1 then
				sText = sText .. " " .. HnGCivName() .. " and their scientist were actively supporting the development of vaccine."	
			elseif lH == 2 then
				sText = sText .. " The significant amount of funding had its source in " .. HnGCivName() .. "."
			elseif lH == 3 then
				sText = sText .. " Medical labs in " .. HnGCivName() .. " were cooperating in the proccess."
			end
		end
		table.insert(tab, {[2] = polioTurn, Title = "Polio vaccine", Text = sText, TitleDivider = true})
	end
	--spaceflight
	if gT.Players[iPlayer].LHSpaceFlightTurn then
		local turn = gT.Players[iPlayer].LHSpaceFlightTurn;
		local bFirst = gT.Globals.SpaceFlightTurn == gT.Players[iPlayer].LHSpaceFlightTurn;
		local sText = ""
		if bFirst then
			local l = LastRandom(1, 3)
			if l == 1 then
				sText = "It was a great step for " .. HnGCivName() .. " and humanity of course. Sending a man to moon was technological and social challenge of the century. Not only the brightest minds had to solve countless problems of a journey, the entire generation had to support this project with their contributions to the budget. The mission was great scientific, political and social success." 
			elseif l == 2 then
				sText = "In " .. HnGDate(turn, false, true) .. " humanity reached next frontier, the Moon. It was claimed by " .. HnGCivAdj() .. " astronauts who proudly put the flag into the ground. The entire nation celebrated this achievement for the following year when astronauts made a tour around the country. One of them claimed that those countless parades were much more exhausting than travel to the moon."
			elseif l == 3 then
				sText = "For the centuries people looked at the skies in awe. The moon was mysterious and alien being, in most mythologies considered a deity whose cycle allows life at Earth. In " .. HnGDate(turn, false, true) .. " humanity reached this unknown, and it was done by " .. HnGCivAdj() .. " spaceflight program. " .. CapitalFL(HnGLeaderTitle()) .. " took all the credits and produly announced " .. HnGGS("himself") .. " 'the smartest in the universe'."
			end
		else
			local l = LastRandom(1, 3)
			if l == 1 then
				sText = "In " .. HnGDate(turn, false, true) .. " " .. HnGCivName() .. " finally reached moon, which ended " .. HnGCivAdj() .. " spaceflight programs."
			elseif l == 2 then
				sText = "After a decade of preparations citizens of " .. HnGCivName() .. " could watch their astrounats landing on moon on national television (" .. HnGDate(turn, false, true) .. ")."
			elseif l == 3 then
				sText = "In " .. HnGDate(turn, false, true) .. " " .. HnGCivName() .. " proudly joined the group of countries that successfuly send their astronauts on the moon and safely brought them back."
			end
		end
		table.insert(tab, {ImageAtlas = "BW_ATLAS_2", PortraitIndex = 33, [2] = gT.Players[iPlayer].LHSpaceFlightTurn, Title = GetHnGHeadlingSpaceflight(iPlayer), Text = sText, TitleDivider = true})
	end
	table.sort(tab, SortFunctionForLowestMapDistance)
	for i, v in pairs(tab) do
		table.insert(gT.Players[iPlayer].HistoryNote, {ImageAtlas = v.ImageAtlas, PortraitIndex = v.PortraitIndex, Title = v.Title, Text = v.Text, TitleDivider = v.TitleDivider})
	end
end

function GetBestPlayerForExplorNote()
	if gT.Globals.ScenarioType == 4 or gT.Globals.ScenarioType == 5 then
		return {};
	end
	local bestScore = 0;
	local hTab = {}
	for g, gd in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			local numdis = 0;
			local iTeam = Players[g]:GetTeam();
			for i = 0, Map:GetNumPlots() - 1, 1 do
				local fPlot = Map.GetPlotByIndex( i );
				if fPlot:IsRevealed(iTeam) then
					numdis = numdis + 1;
				end
			end
			hTab[g] = numdis;
			bestScore = math.max(bestScore, numdis)
		end
	end
	local rTab = {}
	for g, v in pairs(hTab) do
		if v == bestScore then
			rTab[g] = v;
		end
	end
	return rTab;
end

function GetHnGExplorationTitle(iPlayer)
	local tc = LastRandom(1, 9);
	if tc == 1 then
		return "Expeditions";
	elseif tc == 2 then
		return "Voyage sponsoring";
	elseif tc == 3 then
		return HnGLeaderName() .. " the Navigator";
	elseif tc == 4 then
		return "Exploration";
	elseif tc == 5 then
		return "Map Atlas";
	elseif tc == 6 then
		return "Cartography";
	elseif tc == 7 then
		return "Age of Discovery";
	elseif tc == 8 then
		return "Curiousity"
	elseif tc == 9 then
		return "Beyond the Horizon"
	end
end

function GetHnGExplorationNot(iPlayer)
	if not gT.Globals.HnGData.ExploPlayer then
		gT.Globals.HnGData.ExploPlayer = GetBestPlayerForExplorNote()
	end
	if not gT.Globals.HnGData.ExploPlayer[iPlayer] then
		return;
	end
	local sText = "";
	local dT = LastRandom(1, 4);
	local percentage = math.floor(100 * gT.Globals.HnGData.ExploPlayer[iPlayer] / Map.GetNumPlots());
	if dT == 1 then
		sText = "Since the younger years, " .. HnGLeaderName() .. " was always curious about surrounding world. Upon becoming a leader of " .. HnGCivName() .. " " .. HnGGS("he") .. " ordered numerous voyages and expeditions, reaching further than anyone could imagine. To this day scientists are amazed by precision of maps created during this epoque.";
	elseif dT == 2 then
		sText = HnGLeaderName() .. " found exploration a crucial part of " .. HnGCivAdj() .. " economy and supported it whenever " .. HnGGS("he") .. " could. New trade links, luxury resources and alliances were more than enough to justify those investitions. During those times it was common for younger citizens to participate in long-term expeditions even though many of them were not destined to come back.";
	elseif dT == 3 then
		sText = "The world got a lot smaller during " .. HnGLeaderTitle() .. "'s reign. " .. CapitalFL(HnGGS("he")) .. " started the age of exploration in " .. HnGCivName() .. " and by the end of " .. HnGGS("his") .. " life " .. HnGCivAdj() .. " cartographers have properly mapped around " .. percentage .. " percent of the globe. Archaeologists are finding proofs of " .. HnGCivAdj() .. " presence in many distant places."
	elseif dT == 4 then
		sText = "To conquer a world one has to define its borders first. Even though " .. HnGLeaderName() .. " hasn't managed to conquer much, " .. HnGGS("his") .. " contributions to the " .. HnGCivAdj() .. " world map were significant. It is believed that about " .. percentage .. "% of the world was known to them, which was a result of numerous expeditions and map exchanges initiated by " .. HnGLeaderTitle() .. ".";
	end
	table.insert(gT.Players[iPlayer].HistoryNote, {Title = GetHnGExplorationTitle(iPlayer), Text = sText, TitleDivider = true})
end

function GetGPSponsouringAgency(iPlayer)
	return GetAnyAliveCivilianGPWithAbility(iPlayer, 4)
end

function GetHnGEspionageTitle(iPlayer)
	local lh = LastRandom(1, 7);
	if lh == 1 then
		return "Espionage";
	elseif lh == 2 then
		return "Secrets and plots";
	elseif lh == 3 then
		return "Spies";
	elseif lh == 4 then
		return "Intrigues";
	elseif lh == 5 then
		return "Agents";
	elseif lh == 6 then
		return "Intelligence";
	elseif lh == 7 then
		return "Secret conflicts";
	end
end

local badESPbig = {["Rank up"] = true, ["Uncover Spy"] = true}
function GetHnGEspionageNote(iPlayer)
	if gT.Globals.HnGData.Innovations[GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_ASIA_1] then
		if gT.Globals.HnGData.Innovations[GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_ASIA_1][1] == iPlayer then
			-- shinobi rnd text;
			local text;
			local title = "Shinobi";
			local hh = LastRandom(1, 3);
			if hh == 1 then
				text = "A shinobi or a ninja was a covert agent or mercenary in " .. HnGLeaderName() .. "'s " .. HnGCivName() .. ". The functions of a shinobi included espionage, deception, and surprise attacks. Their covert methods of waging irregular warfare were deemed dishonorable and beneath the honor of the noble class. Though shinobi proper, as specially trained spies and mercenaries, appeared in the " .. GetCenturyThFromYear(50) .. " century, antecedents may have existed as early as the " .. GetCenturyThFromYear(-800) .. " century."
			elseif hh == 2 then
				text = "Despite many popular folktales, historical accounts of the shinobi are scarce. Historians assert that the ninja were mostly recruited from the lower class, and therefore little literary interest was taken in them. The social origin of the ninja is seen as the reason they agree to operate in secret, trading their service for money without honor and glory. The scarcity of historical accounts is also demonstrated in war epics, which focus mainly on the aristocratic warriors, whose deeds were apparently more appealing to the audience."
			elseif hh == 3 then
				text = "It was not until the " .. GetCenturyThFromYear(50) .. " century that spies were specially trained for their purpose. It was around this time that the word shinobi appeared to define and clearly identify ninja as a secretive group of agents. Evidence for this can be seen in historical documents, which began to refer to stealthy soldiers as shinobi during the " .. HnGLeaderName() .. "'s period. Later manuals regarding espionage are often grounded in " .. HnGCivAdj() .. " military strategy. Shinobi were recruited as spies, raiders, arsonists and even terrorists.";
			end
			table.insert(gT.Players[iPlayer].HistoryNote, {Title = title, Text = text, TitleDivider = true})
			return;
		end
	end
	--num bought;
	--num actions;
	--favourite actions;
	local nbought = gT.Players[iPlayer].NumSpyBought;
	local gpID = GetGPSponsouringAgency(iPlayer)
	local tot = 0;
--"Money Forgery"
--"Assassination"
--"Coup"
--"Takeover"
--"Rank up"
--"Uncover Spy"
--"Sabotage"
	local rhTab = {};
	for it, string in pairs(gT.Players[iPlayer].SpyActionsBig) do
		rhTab[string] = (rhTab[string] or 0) + 1;
		tot = tot + 1;
	end
	local fav;
	local bfav = 2;
	for string, sth in pairs(rhTab) do
		if sth > bfav and (not badESPbig[string]) then
			fav = string;
			bfav = sth;
		end 
	end
	if (tot > 14) and (fav) and (nbought > 0) then
		--basic text
		local title = GetHnGEspionageTitle(iPlayer)
		local text = "";
		local lbt = LastRandom(1,4);
		if lbt == 1 then
			text = "During the reign of " .. HnGLeaderName() .. " the expenses on espionage were increased significantly. " .. CapitalFL(HnGLeaderTitle()) .. " claimed that even during peace enemies of the state do not rest. " .. CapitalFL(HnGGS("he")) .. " tried to ensure that " .. HnGCivName() .. " will have an upperhand in the war of shadows."
		elseif lbt == 2 then
			text = "Secrets, mysteries and plots. This was an enviroment of " .. HnGCivAdj() .. " court before the ascension of " .. HnGLeaderTitle() .. ". " .. CapitalFL(HnGGS("he")) .. " ensured that overactive members of the court will not plot against " .. HnGGS("himself") .. " by redirecting those efforts on enemies, both external and internal. With creation of several competing agencies " .. HnGGS("he") .. " secured " .. HnGGS("his") .. " leadership.";
		elseif lbt == 3 then
			text = "Espionage was not an important craftmanship in " .. HnGCivName() .. " till the rise of " .. HnGLeaderName() .. " who ensured that the country will maintain multiple agencies to compete with other countries in the war of shadows. From our perspective, we obviously know that it was a mistake that lead to the demise of " .. HnGGS("his") .. " dynasty within next fifty years.";
		elseif lbt == 4 then
			text = "We can only guess if " .. HnGLeaderName() .. " was a " .. HnGGS("father") .. " of " .. HnGCivAdj() .. " espionage or " .. HnGGS("his") .. " agencies were the first ones to be sloppy enough to leave numeroues evidence of their existence. However, we know that " .. HnGCivAdj() .. " agents were active abroad the country and supported military in conflicts." 
		end
		text = text .. "[NEWLINE]"
		--extra text based on fav;
		if fav == "Money Forgery" then
			text = text .. HnGLeaderName() .. " has mostly used " .. HnGGS("his") .. " agents to interfere with foreign economies.";
		elseif fav == "Assassination" then
			text = text .. "Shortening lifes of enemies was the most favoured agents' utility of " .. HnGLeaderName() .. ".";
		elseif fav == "Coup" then
			text = text .. "Agencies had a great interest in installing puppet leaders in lesser states.";
		elseif fav == "Takeover" then
			text = text .. "Spies were mostly used to compromise rival agencies.";
		elseif fav == "Sabotage" then
			text = text .. "Agents were usally tasked with simple sabotage missions to disrupt rival production lines.";
		end
		if rhTab["Uncover Spy"] > 6 then
			--add extra text about catching enemy spies
			local lus = LastRandom(1,3)
			text = text .. "[NEWLINE]"
			if lus == 1 then
				text = text .. "In private diary, " .. HnGLeaderName() .. " explained increasing fundings of spy agencies as a necessary to stop rival agents' activity within the realm. In fact, we know of at least " .. rhTab["Uncover Spy"] .. " hostile major actions that were prevented by " .. HnGLeaderName() .. "'s agents."
			elseif lus == 2 then
				text = text .. "Many official documents survived to this day and are displayed in museums nowadays. We found out that " .. HnGCivAdj() .. " agents have prevented " .. rhTab["Uncover Spy"] .. " rival actions. What is more, the papers are describing in details the attrocious tortures that enemy spies had to suffer before an execution."
			elseif lus == 3 then
				text = text .. "One of the greatest accomplishments of " .. HnGLeaderName() .. "'s was preventing numerous hostile actions of rival agencies. Those heroic defensive missions were widely bragged about and were an important part of " .. HnGLeaderTitle() .. "'s popularity within common folks. Scholars hostile to " .. HnGLeaderName() .. " even suggest that there were poorly staged provocations." 
			end
		end
		if gpID then
			--add extra text about great person;
			local lgp = LastRandom(1,3)
			local gpname = Locale.Lookup(gT.GreatPeople[gpID].Name)
			text = text .. "[NEWLINE][NEWLINE]"
			if lgp == 1 then
				text = text .. "Recently scholars have found an encrypted documents which revealed that " .. gpname .. " was one the most important agents of " .. HnGCivName() .. ". Little is known about how this respected and wealthy person became a master of whispers. There is a theory that " .. gpname .. " used espionage and plots to become respected and wealthy." 
			elseif lgp == 2 then
				text = text .. gpname .. " was a statesman who actively supported espionage activities of " .. HnGCivName() .. ". Little is known about the motives and early life of that persona. Some conspiracy theorists even claim that " .. gpname .. " was in fact a double-agent working for the " .. Players[GetRandomOtherPlayerForHnG(iPlayer, true)]:GetCivilizationShortDescription() .. ".";
			elseif lgp == 3 then
				text = text .. "Little is known about " .. gpname .. "'s connections to the most important espionage events of " .. HnGLeaderTitle() .. "'s reign. There is simply no historical evidence to support any claim that " .. gpname .. " was in fact overseeing any secret operations. However in popular tradition and culture " .. gpname .. " is considered the hidden mastermind behind " .. HnGCivAdj() .. " successes."
			end
		end
		table.insert(gT.Players[iPlayer].HistoryNote, {Title = title, Text = text, TitleDivider = true})
	end
end

function GetHnGRailroadNote(iPlayer)
	if gT.Globals.ScenarioType ~= 4 then
		return;
	end
	local madeRailroads = gT.Players[iPlayer].NumRailroadsMade
	if madeRailroads == 0 then
		return;
	end
	for g, gd in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			if gd.NumRailroadsMade > madeRailroads then
				return;
			end
		end
	end
	local title = RandomFromTab({"Railways", "Railroads", "Railway Pioneers", "Steam Power", HnGCivAdj() .. " railways", HnGCivAdj() .. " railroads", "Rail transport"})
	local sTh = LastRandom(1, 3);
	local text;
	if sTh == 1 then
		text = "The earliest railway in " .. HnGCivName() .. " was a wagonway system, a horse drawn wooden rail system, used by miners mostly. With the invention of steam power and more sophisticated engineering the true revolution begun during the " .. HnGLeaderTitle() .. "'s reign. Hundreds kilometers of railways were created and first locomotives allowed to carry more cargo, further and cheaper than ever before."
	elseif sTH == 2 then
		text = "The modern history of railways started with " .. HnGCivName() .. " which was the most enthusiastic nation about the invetion of steam power. First railroad companies were found, first fortunes were made on this new source of transportation. " .. HnGLeaderName() .. " personally disliked and much likely was never a passenger of 'smoking machines'. However, steam accelerated industrialization of country."
	else
		text = HnGLeaderName() .. " was a great supporter of railway transport, at the end of " .. HnGGS("his") .. " reign " .. HnGCivName() .. " had the longest sum of railway connections in the world. Most scholars agree that it was a main reason for rapid industrialization and golden age " .. HnGCivName() .. " faced in the next century."
	end
	table.insert(gT.Players[iPlayer].HistoryNote, {Title = title, Text = text, TitleDivider = true})
end

function GetHnGTradeCenterNote(iPlayer)
	if not gT.Globals.HnGData.Constants.CityCenter then
		return;
	end
	if gT.Globals.HnGData.Constants.CityCenter[2] ~= iPlayer then
		return;
	end
	local iCity = Map.GetPlotByIndex(gT.Globals.HnGData.Constants.CityCenter[1]):GetPlotCity();
	local cName = iCity:GetName();
	local title = RandomFromTab({cName, "Pearl of the " .. HnGCivName(), "Traders of " .. cName, "Merchants of " .. cName, "Regional trading hub", "Trade Routes", "Commercial Routes", "Trade Center"})
	local sTh = LastRandom(1, 7);
	if sTh == 1 then
		text = "During the reign of " .. HnGLeaderTitle() .. " " .. cName .. " became a centre of regional trade. One of the main things that " .. cName .. " is known for is its diverse architecture. It grants reflection on the different types of cultures that the " .. HnGCivAdj() .. " people traded with.";
	elseif sTh == 2 then
		text = "At the time " .. cName .. " grew wealthy from numerous traders visiting the city; the " .. HnGCivAdj() .. " people became renowned as merchants who established colonies along the important trade-routes and operated throughout the entire region. Incoming wealth enabled the construction of monumental projects and was a crucial part of " .. HnGCivAdj() .. " economy.";
	elseif sTh == 3 then
		text = "The " .. GetCenturyThFromYear(90) .. " was " .. cName .. "'s golden era: the city was the regional hub of commerce, and acquired great riches by exploiting the trade in exotic goods. To this day " .. cName .. " is recognised as a 'global city'.";
	elseif sTh == 4 then
		text = cName .. " quickly became the base of foreign trade in " .. HnGCivName() .. ". Foreigners initially occupied the low-lying district of the city, residential districts later expanding as the settlement grew to incorporate much of the elevated territory overlooking the city. The foreign trade and commercial district, was surrounded by a moat, foreign residents enjoying extraterritorial status both within and outside the compound."
	elseif sTh == 5 then
		text = cName .. "s economic and political history has been primarily determined by its geographical location. In a sense, there is considerable continuity in " .. cName .. "s position in the international economy since its origins were as a commercial entrepot for " .. HnGCivAdj() .. " regional and global trade, and this is still a role it plays today. From a relatively unpopulated territory at the beginning of the " .. GetCenturyThFromYear(-300) .. ", " .. cName .. " grew to become one of the most important international financial centers in the world."
	elseif sTh == 6 then
		text = cName .. " started out as a small seasonal settlement. After a shift in trading routes, particularly after the visit by " .. HnGLeaderName() .. " around " .. GetRandomYearDateForHnG(1,17) .. ", " .. cName .. " flourished from the trade of various goods. In its Golden Age, the town's numerous scholars and extensive trading network supported an important book trade of the region."
	elseif sTh == 7 then
		text = cName .. " is noted for its unique history and it is one of the major tourist destinations in " .. HnGCivName() .. ". With a highly strategic state position for international trade routes, " .. cName .. " was once a well-known international trade centre of the region."
	end
	--BUILDING chanced image
	local ia, pi, il = GetHnGImageDataFromCityBuildings(iCity, {GameInfoTypes.BUILDINGCLASS_CARAVANSARY, GameInfoTypes.BUILDINGCLASS_MARKET, GameInfoTypes.BUILDINGCLASS_BANK, GameInfoTypes.BUILDINGCLASS_HARBOR, GameInfoTypes.BUILDINGCLASS_SEAPORT, GameInfoTypes.BUILDINGCLASS_STOCK_EXCHANGE, GameInfoTypes.BUILDINGCLASS_LIGHTHOUSE}, 5)
	table.insert(gT.Players[iPlayer].HistoryNote, {Title = title, Text = text, TitleDivider = true, ImageAtlas = ia, PortraitIndex = pi, ImageLabel = il})
end

function GetFirstAndOnlyAcademy(iPlayer)
	local iAnswer;
	for g, h in pairs(gT.Academies) do
		if h.OriginalPlayer == iPlayer then
			if iAnswer then
				return;
			end
			if h.TurnFounded < GetRealGameTurn() - 100 then
				return;
			end
			iAnswer = g;
		end
	end
	return iAnswer;
end

function GetHnGImageDataFromCityBuildings(iCity, cClass, aCheck)
	local tab = {}
	for i, class in pairs(cClass) do
		local iBtype = GetHasBuildingClass(iCity, class)
		if iBtype ~= -1 then
			table.insert(tab, iBtype)
		end
	end
	if #tab == 0 then
		return;
	end
	if aCheck and (not tab[LastRandom(1,aCheck)]) then
		return;
	end
	local iBuildingType = RandomFromTab(tab);
	local lText;
	local lLabelType = LastRandom(1,4);
	if lLabelType == 1 then
		lText = "Old " .. Locale.Lookup(GameInfo.Buildings[iBuildingType].Description)
	elseif lLabelType == 2 then
		lText = Locale.Lookup(GameInfo.Buildings[iBuildingType].Description) .. " in " .. iCity:GetName();
	elseif lLabelType == 3 then
		lText = iCity:GetName() .. "'s " .. Locale.Lookup(GameInfo.Buildings[iBuildingType].Description)
	end
	return GameInfo.Buildings[iBuildingType].IconAtlas, GameInfo.Buildings[iBuildingType].PortraitIndex, lText;
end

function GetHnGAcademyNote(iPlayer)
	local iFirstOnlyAcademy = GetFirstAndOnlyAcademy(iPlayer)
	if gT.Globals.HnGData.Constants.AcademyPrestige[2] == iPlayer then
		local iAcaIndex = gT.Globals.HnGData.Constants.AcademyPrestige[1];
		local acaName = gT.Academies[iAcaIndex].Name;
		local title = gT.Academies[iAcaIndex].Name;
		local sYearFounded = gT.Academies[iAcaIndex].Year;
		local acaCityName = gT.Academies[iAcaIndex].CityName;
		local bestYear = gT.Academies[iAcaIndex].MaxPrestigeTurn;
		local text;
		local sTrng = LastRandom(1,5);
		if sTrng == 1 then
			text = "Today it may be hard to believe, but " .. acaName .. " was the most prestigious scientific center of " .. GetCenturyThFromYear(bestYear) .. ". During its golden age academy was responsible for the great technological advance of " .. HnGCivAdj() .. " civilization and was a place of many famous disputes. After years of decline and lack of funds " .. acaName .. " ended in ruin known today. One could say it did not stand the test of time."
		elseif sTrng == 2 then
			text = "Many scholars dream to see " .. acaName .. " in its prime. Some call this institution one of the pillars of humankind. In fact it was the most prestigious school of its time, and countless famous people were studying there or at least visited it during the reign of " .. HnGLeaderName() .. ". It was all possible due to generous support from the goverment and an extraordinary talent of " .. HnGCivAdj() .. " people."
		elseif sTrng == 3 then
			text = CapitalFL(HnGLeaderTitle()) .. " heavily supported " .. acaName .. " and soon the campus attracted many talents and gave birth to an extraordinary inventions and innovations. The prestige of academy was greatly renowned even in foreign nations. Unfortunately, some time after " .. HnGLeaderName() .. "'s death the quality of teaching and scientific debates declined as once young and energetic professors turned into the old ones resting on laurels of their former glory."
		elseif sTrng == 4 then
			text = "During " .. GetCenturyThFromYear(bestYear) .. " " .. acaName .. " was in the center of attention of the whole scientific world. It lead the humanity onward towards the brighter future, questioned old dogmas and extended the borders of human perception. Unfortunately " .. HnGLeaderName() .. " was blind to this wondrous world, as " .. HnGGS("he") .. " believed that life of the egghead is not worthy a real " .. HnGGS("man") .. ". Some scholars believe that lack of supervision and political interference had a key role in " .. acaName .. "'s success."
		elseif sTrng == 5 then
			text = "One of the greatest " .. HnGLeaderName() .. "'s achievements was allowing foreigners to study on " .. acaName .. ". The exchange of thought from different cultures lead to scientific bloom of knowledge in " .. HnGCivName() .. ". Within years the whole world was watching carefully the newest theories developed in " .. acaName .. ". It was truely a golden age for " .. HnGCivAdj() .. " science."
		end
		if iFirstOnlyAcademy and (iFirstOnlyAcademy == iAcaIndex) and (gT.Globals.ScenarioType ~= 3) then
			text = text .. " All those achievements are even more impressive considering the fact that " .. acaName .. " was the first " .. HnGCivAdj() .. " academy, as it was founded in " .. sYearFounded .. " by " .. HnGLeaderTitle() .. " " .. HnGGS("himself") .. ".";
		end
		if gT.Academies[iAcaIndex].Player ~= iPlayer then
			text = text .. " Unfortunately by the end of " .. HnGLeaderName() .. "'s reign the city of " .. acaCityName .. " and " .. acaName .. " were lost to " .. Players[gT.Academies[iAcaIndex].Player]:GetCivilizationAdjective() .. " invaders."
		end
		local ia, pi, il = GetHnGImageDataFromCityBuildings(Map.GetPlotByIndex(gT.Academies[iAcaIndex].City):GetPlotCity(), {GameInfoTypes.BUILDINGCLASS_OBSERVATORY, GameInfoTypes.BUILDINGCLASS_UNIVERSITY, GameInfoTypes.BUILDINGCLASS_LIBRARY, GameInfoTypes.BUILDINGCLASS_MEDICAL_LAB, GameInfoTypes.BUILDINGCLASS_LABORATORY}, 5)
		table.insert(gT.Players[iPlayer].HistoryNote, {Title = title, Text = text, TitleDivider = true, ImageAtlas = ia, PortraitIndex = pi, ImageLabel = il})
	elseif iFirstOnlyAcademy then
		local title = gT.Academies[iFirstOnlyAcademy].Name;
		local acaName = gT.Academies[iFirstOnlyAcademy].Name;
		local sYearFounded = gT.Academies[iFirstOnlyAcademy].Year;
		local acaCityName = gT.Academies[iFirstOnlyAcademy].CityName;
		local text;
		local sTrng = LastRandom(1,5);
		if sTrng == 1 then
			text = "During the reign of " .. HnGLeaderName() .. " the very first academy in " .. HnGCivName() .. " was founded. The " .. acaName .. " hosted first lectures in " .. sYearFounded .. ". It is unclear if " .. HnGLeaderTitle() .. " has ever visited it."
		elseif sTrng == 2 then
			text = HnGLeaderName() .. " is remembered today in " ..HnGCivName() .. " for founding first national academy (" .. sYearFounded .. ". " ..  CapitalFL(acaName) .. " had humble beginnings, but on-going support made it a respectable scientific domain in the region."
		elseif sTrng == 3 then
			text = CapitalFL(HnGLeaderTitle()) .. " liked to call " .. HnGGS("himself") .. " a friend of science and reason. By " .. sYearFounded .. " " .. HnGGS("he") .. " managed to gather many distinguished scholars in one place and officially open " .. acaName .. ". To this day a main hall is named after " .. HnGGS("him") .. "."
		elseif sTrng == 4 then
			text = "By " .. sYearFounded .. " the first academy of " .. HnGCivName() .. " was founded. Academic society was not fond of " .. HnGLeaderTitle() .. " and " .. HnGGS("his") .. " leadership. It is unclear if " .. HnGLeaderName() .. " was truely ignorant, dull-witted and illiterate invidual or those widely spread rumours were manufactured by hostile people of science."
		elseif sTrng == 5 then
			text = "One of the remarkable achievements of " .. HnGLeaderName() .. "'s era was a foundation of " .. acaName .. ", the first pernament scientific campus in " .. HnGCivName() .. ". It was not uncommon for nobleman paid a lot to have their children taught in this prestigious institution."
		end
		if gT.Academies[iFirstOnlyAcademy].Player ~= iPlayer then
			text = text .. " Unfortunately by the end of " .. HnGLeaderName() .. "'s reign the city of " .. acaCityName .. " and " .. acaName .. " were lost to " .. Players[gT.Academies[iAcaIndex].Player]:GetCivilizationAdjective() .. " invaders."
		end
		local ia, pi, il = GetHnGImageDataFromCityBuildings(Map.GetPlotByIndex(gT.Academies[iFirstOnlyAcademy].City):GetPlotCity(), {GameInfoTypes.BUILDINGCLASS_OBSERVATORY, GameInfoTypes.BUILDINGCLASS_UNIVERSITY, GameInfoTypes.BUILDINGCLASS_LIBRARY, GameInfoTypes.BUILDINGCLASS_MEDICAL_LAB, GameInfoTypes.BUILDINGCLASS_LABORATORY}, 5)
		table.insert(gT.Players[iPlayer].HistoryNote, {Title = title, Text = text, TitleDivider = true, ImageAtlas = ia, PortraitIndex = pi, ImageLabel = il})
	end
end