local holySite = GameInfoTypes.IMPROVEMENT_HOLY_SITE;
local HolySitesLocations = {};
local prambanan = GameInfoTypes.BUILDING_ITG_NEW_MEDIEVAL_WONDER_15;
local bHolySiteShuffled = false;
local bBlobTerritory = (PreGame.GetGameOption("GAMEOPTION_ITG_BLOB_TERRITORIES") == 1)
local holySiteNames = {
"Bodh Gaya", "Kushinagar", "Lumbini", "Sarnath", "Sravasti", "Rajgir",
"Sankassa", "Vaishali", "Jokhang", "Norbulingka", "Bethlehem", "Nazareth",
"Jordan", "Cumorah", "Adam-ondi-Ahman", "Stonehenge", "Ayodhya", "Mathura",
"Haridwar", "Varanasi", "Kanchipuram", "Ujjain", "Puri", "Rameshwaram",
"Badrinath", "Prayagraj", "Nashik", "Tirupati", "Somnath", "Amarnath",
"Kanyakumari", "Vaishno Devi", "Masjid al-Haram", "Al-Masjid al-Nabawi",
"Al-Aqsa", "Wudang", "Qingcheng", "Longhu", "Qiyun"
}
local tHolySiteTraits;

function MissionaryHSfunc1(iPlayer, iCity, cID, val, biActive, sfType, selfID)
	local totReward = val * tHolySiteTraits[selfID].Val;
	DoChangeCityCultureOwnership(cID, iCity, iPlayer, totReward, "HSmis")
	if biActive then
		AddFloatingText(nil,iCity:GetX(),iCity:GetY(),totReward .. "[ICON_ITG_PRESENCE]",nil, sfType)	
	end
end

function MissionaryHSModifier2(iPlayer, iCity, iOwner, val, selfID)
	if iCity:Plot():IsRiver() then
		return val * tHolySiteTraits[selfID].Val;
	end
	return 0;
end
function MissionaryHSModifier3(iPlayer, iCity, iOwner, val, selfID)
	for i = 0, 5 do
		local nPlot = Map.PlotDirection(iCity:GetX(), iCity:GetY(), i);
		if nPlot and (nPlot:IsMountain()) then
			return val * tHolySiteTraits[selfID].Val;
		end
	end
	return 0;
end
function MissionaryHSModifier4(iPlayer, iCity, iOwner, val, selfID)
	if iCity:Plot():GetTerrainType() == tDesert then
		return val * tHolySiteTraits[selfID].Val;
	end
	for i = 0, 5 do
		local nPlot = Map.PlotDirection(iCity:GetX(), iCity:GetY(), i);
		if nPlot and (nPlot:GetTerrainType() == tDesert) then
			return val * tHolySiteTraits[selfID].Val;
		end
	end
	return 0;
end
function MissionaryHSModifier5(iPlayer, iCity, iOwner, val, selfID)
	if iCity:Plot():IsCoastalLand() then
		return val * tHolySiteTraits[selfID].Val;
	end
	return 0;
end
function MissionaryHSModifier6(iPlayer, iCity, iOwner, val, selfID)
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	if gT.Cities[cID].LastAcquired >= GetITGGameTurn() - 4 then
		return val * tHolySiteTraits[selfID].Val;
	end
	return 0;
end
function MissionaryHSModifier7(iPlayer, iCity, iOwner, index, selfID)
	local iPlot = Map.GetPlotByIndex(index);
	if Map.PlotDistance(iPlot:GetX(), iPlot:GetY(), iCity:GetX(), iCity:GetY()) <= 10 then
		return tHolySiteTraits[selfID].Val;
	end
	return 0;
end
function MissionaryHSModifier8(iPlayer, iCity, iOwner, val, selfID)
	return gT.Players[iPlayer].MintBonus;
end
function MissionaryHSModifier9(iPlayer, iCity, iOwner, val, selfID)
	if iCity:GetPopulation() < 5 then
		return val * tHolySiteTraits[selfID].Val;
	end
	return 0;
end
function MissionaryHSModifier10(iPlayer, iCity, iOwner, val, selfID)
	if Players[iOwner]:IsMinorCiv() then
		return val * tHolySiteTraits[selfID].Val;
	end
	return 0;
end
function MissionaryHSModifier21(iPlayer, iCity, iOwner, val, selfID)
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	if gT.Cities[cID].Riots > GetITGGameTurn()  then
		return val * tHolySiteTraits[selfID].Val;
	end
	return 0;
end
function MissionaryHSModifier22(iPlayer, iCity, iOwner, val, selfID)
	return gT.Players[iPlayer].NumWondersBuild * val * tHolySiteTraits[selfID].Val;
end

function MissionaryHSfunc10(iPlayer, iCity, cID, val, biActive, sfType, selfID)
	if Players[iCity:GetOwner()]:IsMinorCiv() then
		local totReward = val * 2;
		Players[iCity:GetOwner()]:ChangeMinorCivFriendshipWithMajor(iPlayer, totReward);
		if biActive then
			AddFloatingText(nil,iCity:GetX(),iCity:GetY(),totReward .. "[ICON_INFLUENCE]",nil, sfType)	
		end
	end
end
function MissionaryHSfunc14(iPlayer, iCity, cID, val, biActive, sfType, selfID, rel)
	local totReward = iCity:GetPopulation();
	ChangeITGGreatPeopleCivilPoints(iPlayer, totReward)
	if LastRandom(1, 100) <= 7 then
		local cpIndex = iCity:Plot():GetPlotIndex();
		for gpID, hhh in pairs(gT.Players[iCity:GetOwner()].GreatPeople) do
			local gd = gT.GreatPeople[gpID];
			if gd.Alive and (not gd.Military) then
				if gd.City == cpIndex then
					gT.GreatPeople[gpID].Religion = rel;
				end
			end
		end
	end
	if biActive then
		AddFloatingText(nil,iCity:GetX(),iCity:GetY(),totReward .. "[ICON_GREAT_PEOPLE]",nil, sfType)	
	end
end
function MissionaryHSfunc15(iPlayer, iCity, cID, val, biActive, sfType, selfID)
	CreateVisibilityTradeOutpost(iPlayer, iCity, 4)
end
function MissionaryHSfunc16(iPlayer, iCity, cID, val, biActive, sfType, selfID)
	local totReward = val * tHolySiteTraits[selfID].Val;
	DoChangeMercHolyArmCost(iPlayer, -totReward)
end
function MissionaryHSfunc17(iPlayer, iCity, cID, val, biActive, sfType, selfID)
	local totReward = -val * tHolySiteTraits[selfID].Val;
	DoChangeLocalTheologyHeresy(iPlayer, 10 * totReward)
end
function MissionaryHSfunc18(iPlayer, iCity, cID, val, biActive, sfType, selfID)
	local totReward = val * tHolySiteTraits[selfID].Val;
	gT.Players[iPlayer].Decadentism = math.max(0, gT.Players[iPlayer].Decadentism - totReward);
end
function MissionaryHSModifier11(iPlayer, iCity, iOwner, val, selfID)
	if iCity:IsPlague() then
		return val * tHolySiteTraits[selfID].Val;
	end
	return 0;
end
function OnMartyrdomHS12(iPlayer, iCity, cID, val, biActive, sfType, selfID)
	local totReward = val * tHolySiteTraits[selfID].Val;
	BoostArtisticPoints(iPlayer, totReward, false)
	if biActive then
		AddFloatingText(nil,iCity:GetX(),iCity:GetY(),totReward .. "[ICON_GREAT_ARTIST]",nil, sfType)
	end
end
function OnMartyrdomHS13(iPlayer, iCity, cID, val, biActive, sfType, selfID)
	local totReward = val * tHolySiteTraits[selfID].Val;
	TakeCareOfEventMorale(iPlayer, 25, {totReward, "Vengeful Spirits"})
	if biActive then
		AddFloatingText(nil,iCity:GetX(),iCity:GetY(),totReward .. "[ICON_ITG_MORALE]",nil, sfType)
	end
end
function OnMartyrdomHS19(iPlayer, iCity, cID, val, biActive, sfType, selfID)
	local totReward = val * tHolySiteTraits[selfID].Val;
	DoChangeLocalTheologyHeresy(iCity:GetOwner(), 10 * totReward)
	if biActive then
		AddFloatingText(nil,iCity:GetX(),iCity:GetY(),totReward .. "%[ICON_PROPHET]",nil, sfType)
	end
end
function OnMartyrdomHS20(iPlayer, iCity, cID, val, biActive, sfType, selfID, iRel)
	local numFollowers = iCity:GetNumFollowers(iRel)
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	if StartBasicResistance(iCity, cID, math.max(1, math.ceil(numFollowers / 3)), true) then
		if biActive then
			AddFloatingText(nil,iCity:GetX(),iCity:GetY(),"[ICON_RESISTANCE]",nil, sfType)
		end
	end
end
function HSCanTraitBeAssigned8(index, iPlayer)
	return HasMintAnyCity(iPlayer);
end

tHolySiteTraits = {
--ScOff    CanBeAssigned(iIndex)
{ID = 1, Name = "TXT_KEY_HOLY_SITE_TRAIT_NAME_1", Help = "TXT_KEY_HOLY_SITE_TRAIT_HELP_1", Val = 25, OnMissionary = MissionaryHSfunc1},
{ID = 2, Name = "TXT_KEY_HOLY_SITE_TRAIT_NAME_2", Help = "TXT_KEY_HOLY_SITE_TRAIT_HELP_2", Val = 20, MissionaryStrength = MissionaryHSModifier2},
{ID = 3, Name = "TXT_KEY_HOLY_SITE_TRAIT_NAME_3", Help = "TXT_KEY_HOLY_SITE_TRAIT_HELP_3", Val = 30, MissionaryStrength = MissionaryHSModifier3},
{ID = 4, Name = "TXT_KEY_HOLY_SITE_TRAIT_NAME_4", Help = "TXT_KEY_HOLY_SITE_TRAIT_HELP_4", Val = 25, MissionaryStrength = MissionaryHSModifier4},
{ID = 5, Name = "TXT_KEY_HOLY_SITE_TRAIT_NAME_5", Help = "TXT_KEY_HOLY_SITE_TRAIT_HELP_5", Val = 20, MissionaryStrength = MissionaryHSModifier5},
{ID = 6, Name = "TXT_KEY_HOLY_SITE_TRAIT_NAME_6", Help = "TXT_KEY_HOLY_SITE_TRAIT_HELP_6", Val = 50, MissionaryStrength = MissionaryHSModifier6},
{ID = 7, Name = "TXT_KEY_HOLY_SITE_TRAIT_NAME_7", Help = "TXT_KEY_HOLY_SITE_TRAIT_HELP_7", Val = 50, UponMissionaryStrength = MissionaryHSModifier7},
{ID = 8, Name = "TXT_KEY_HOLY_SITE_TRAIT_NAME_8", Help = "TXT_KEY_HOLY_SITE_TRAIT_HELP_8", Val = 1, MissionaryStrength = MissionaryHSModifier8, CanBeAssigned = HSCanTraitBeAssigned8},
{ID = 9, Name = "TXT_KEY_HOLY_SITE_TRAIT_NAME_9", Help = "TXT_KEY_HOLY_SITE_TRAIT_HELP_9", Val = 20, MissionaryStrength = MissionaryHSModifier9},
{ID = 10, Name = "TXT_KEY_HOLY_SITE_TRAIT_NAME_10", Help = "TXT_KEY_HOLY_SITE_TRAIT_HELP_10", Val = 20, MissionaryStrength = MissionaryHSModifier10, OnMissionary = MissionaryHSfunc10},
{ID = 11, Name = "TXT_KEY_HOLY_SITE_TRAIT_NAME_11", Help = "TXT_KEY_HOLY_SITE_TRAIT_HELP_11", Val = 33, MissionaryStrength = MissionaryHSModifier11},
{ID = 12, Name = "TXT_KEY_HOLY_SITE_TRAIT_NAME_12", Help = "TXT_KEY_HOLY_SITE_TRAIT_HELP_12", Val = 50, OnMartyrdom = OnMartyrdomHS12},
{ID = 13, Name = "TXT_KEY_HOLY_SITE_TRAIT_NAME_13", Help = "TXT_KEY_HOLY_SITE_TRAIT_HELP_13", Val = 2, OnMartyrdom = OnMartyrdomHS13},
{ID = 14, Name = "TXT_KEY_HOLY_SITE_TRAIT_NAME_14", Help = "TXT_KEY_HOLY_SITE_TRAIT_HELP_14", Val = 7, OnMissionary = MissionaryHSfunc14},
{ID = 15, Name = "TXT_KEY_HOLY_SITE_TRAIT_NAME_15", Help = "TXT_KEY_HOLY_SITE_TRAIT_HELP_15", Val = 1, OnMissionary = MissionaryHSfunc15},
{ID = 16, Name = "TXT_KEY_HOLY_SITE_TRAIT_NAME_16", Help = "TXT_KEY_HOLY_SITE_TRAIT_HELP_16", Val = 5, OnMissionary = MissionaryHSfunc16},
{ID = 17, Name = "TXT_KEY_HOLY_SITE_TRAIT_NAME_17", Help = "TXT_KEY_HOLY_SITE_TRAIT_HELP_17", Val = 0.3, OnMissionary = MissionaryHSfunc17},
{ID = 18, Name = "TXT_KEY_HOLY_SITE_TRAIT_NAME_18", Help = "TXT_KEY_HOLY_SITE_TRAIT_HELP_18", Val = 2, OnMissionary = MissionaryHSfunc18, ScOff = {[3] = true}},
{ID = 19, Name = "TXT_KEY_HOLY_SITE_TRAIT_NAME_19", Help = "TXT_KEY_HOLY_SITE_TRAIT_HELP_19", Val = 2, OnMartyrdom = OnMartyrdomHS19},
{ID = 20, Name = "TXT_KEY_HOLY_SITE_TRAIT_NAME_20", Help = "TXT_KEY_HOLY_SITE_TRAIT_HELP_20", Val = 1, OnMartyrdom = OnMartyrdomHS20},
{ID = 21, Name = "TXT_KEY_HOLY_SITE_TRAIT_NAME_21", Help = "TXT_KEY_HOLY_SITE_TRAIT_HELP_21", Val = 15, MissionaryStrength = MissionaryHSModifier21},
{ID = 22, Name = "TXT_KEY_HOLY_SITE_TRAIT_NAME_22", Help = "TXT_KEY_HOLY_SITE_TRAIT_HELP_22", Val = 10, MissionaryStrength = MissionaryHSModifier22},

}

function DoHolySiteMartyrdomEffects(iPlayer, iCity, cID, biActive, sfType, rel)
	local hTraits = {}
	for index, s in pairs(gT.HolySites) do
		if (s.Player == iPlayer) then
			hTraits[s.MainTrait] = (hTraits[s.MainTrait] or 0) + 1;
		end
	end
	for trait, val in pairs(hTraits) do
		if tHolySiteTraits[trait].OnMartyrdom then
			tHolySiteTraits[trait].OnMartyrdom(iPlayer, iCity, cID, val, biActive, sfType, trait, rel)
		end
	end
end

function DoHolySiteMissionaryEffects(iPlayer, iCity, cID, biActive, sfType, rel)
	local hTraits = {}
	for index, s in pairs(gT.HolySites) do
		if (s.Player == iPlayer) then
			hTraits[s.MainTrait] = (hTraits[s.MainTrait] or 0) + 1;
		end
	end
	for trait, val in pairs(hTraits) do
		if tHolySiteTraits[trait].OnMissionary then
			tHolySiteTraits[trait].OnMissionary(iPlayer, iCity, cID, val, biActive, sfType, trait, rel)
		end
	end
end

function GetMissionaryStrengthModFromHolySites(iPlayer, iCity, iOwner)
	local hTraits = {}
	local mod = 0;
	for index, s in pairs(gT.HolySites) do
		if (s.Player == iPlayer) then
			if tHolySiteTraits[s.MainTrait].UponMissionaryStrength then
				mod = mod + tHolySiteTraits[s.MainTrait].UponMissionaryStrength(iPlayer, iCity, iOwner, index, s.MainTrait)
			else
				hTraits[s.MainTrait] = (hTraits[s.MainTrait] or 0) + 1;
			end
		end
	end
	for trait, val in pairs(hTraits) do
		if tHolySiteTraits[trait].MissionaryStrength then
			mod = mod + tHolySiteTraits[trait].MissionaryStrength(iPlayer, iCity, iOwner, val, trait)
		end
	end
	return mod;
end

function GetValidNameForHolySite()
	if not bHolySiteShuffled then
		holySiteNames = Shuffle(holySiteNames);
		bHolySiteShuffled = true;
	end
	local hTab = {}
	local aTab = {}
	for index, sth in pairs(gT.HolySites) do
		aTab[sth.Name] = (aTab[sth.Name] or 0) + 1;
	end
	for i, name in pairs(holySiteNames) do
		table.insert(hTab, {name, aTab[name] or 0});
	end
	table.sort(hTab, SortFunctionForLowestMapDistance)
	return hTab[1][1];
end

function GenerateHolySitesLocations()
	for i = 0, Map:GetNumPlots() - 1, 1 do
		local fPlot = Map.GetPlotByIndex( i );
		if not fPlot:IsWater() then
			if fPlot:GetImprovementType() == -1 then
				if not fPlot:IsMountain() then
					if not fPlot:IsCity() then
						if IsHolySitePossible(fPlot:GetX(), fPlot:GetY(), fPlot:GetPlotIndex()) then
							if not gT.Globals.BadContIDs[GetContID(fPlot, 61235)] then
								if not gT.Globals.BadPoints[fPlot:GetPlotIndex()] then
									table.insert(HolySitesLocations, i);
								end
							end
						end
					end
				end
			end
		end
	end
	for gPlayer, gdata in pairs(gT.Players) do
		local iRel = Players[gPlayer]:GetReligionCreatedByPlayer();
		if iRel > 0 then
			local numHS = LastRandom(GetDBCulturePlayerInfo(gPlayer, "MinHolySite"), GetDBCulturePlayerInfo(gPlayer, "MaxHolySite"))
			GenerateHolySitesForReligion(iRel, numHS, gPlayer, Game.GetHolyCityForReligion(iRel, -1))
		end
	end
	RefreshReligionSitesLabels()
	HolySitesLocations = {};
end

function IsHolySitePossible(x, y, index, player, iRel)
	if IsSpecialControlPlot(index, false, false, false) then
		return false;
	end
	local iPlot = Map.GetPlot(x,y);
	if iPlot:IsCity() then
		return false;
	end
	for i = 0, 5 do
		local iPlot = Map.PlotDirection(x,y, i)
		if iPlot then
			if iPlot:IsCity() then
				return false;
			end
			if gT.Settlements[iPlot:GetPlotIndex()] then
				return false;
			end
		end
	end
	for i, index in pairs(HolySitesLocations) do
		local iPlot = Map.GetPlotByIndex(index);
		if Map.PlotDistance(x,y, iPlot:GetX(), iPlot:GetY()) < MIN_DISTANCE_HOLY_SITE then
			return false;
		end
	end
	for index, sth in pairs(gT.HolySites) do
		local iPlot = Map.GetPlotByIndex(index);
		if Map.PlotDistance(x,y, iPlot:GetX(), iPlot:GetY()) < MIN_DISTANCE_HOLY_SITE then
			return false;
		end
	end
	if iRel then
		local cityID = iPlot:GetCityPurchaseID()
		local iOwner = iPlot:GetOwner();
		if not CanBeFortForPlayer(iPlot, player) then
			if iOwner ~= player then
				if cityID and iOwner ~= -1 then
					local iCity = Players[iOwner]:GetCityByID(cityID);
					if iCity then
						if iCity:GetReligiousMajority() ~= iRel then
							return false;
						end
					end
				end
			end
		end
	end
	return true;
end

function ApplyHolySiteBonusOnLevel(index)
	gT.HolySites[index].BasicBonuses[1] = gT.HolySites[index].BasicBonuses[1] + 1;
	gT.HolySites[index].BasicBonuses[2] = gT.HolySites[index].BasicBonuses[2] + 1;
end

function GetHolySiteLevelTreshold(index)
	return 10 * gT.HolySites[index].Level;
end

function ChangeHolySiteXP(index, amount)
	gT.HolySites[index].XP = gT.HolySites[index].XP + amount;
	if gT.HolySites[index].XP >= GetHolySiteLevelTreshold(index) then
		gT.HolySites[index].XP = gT.HolySites[index].XP - GetHolySiteLevelTreshold(index);
		gT.HolySites[index].Level = gT.HolySites[index].Level + 1;
		ApplyHolySiteBonusOnLevel(index)
		DoUpdatePressureOfHolySite(index)
	end
end

function HolySiteVisitedByPilgrim(index, fPlayer)
	table.insert(gT.HolySites[index].VisitLog, {fPlayer, GetITGGameTurn()});
	ChangeHolySiteXP(index, 10)
	local iOwner = gT.HolySites[index].Player;
	if gT.Players[iOwner] and gT.Players[iOwner].CultBonusOn[155] then
		for cIndex, h in pairs(gT.HolySites[index].NearbyCities) do
			local iCity = Map.GetPlotByIndex(cIndex):GetPlotCity();
			local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
			if gT.Cities[cID].CultureOwner ~= iOwner then
				DoChangeCityCultureOwnership(cID, iCity, iOwner, 25, "CultBonus155")
			end
		end
	end
end

function CanOwnerSanctifyHolySite(index, fRel, fPlayer)
	local iPlayer = fPlayer or gT.HolySites[index].Player;
	if iPlayer ~= gT.HolySites[index].ControlPlayer then
		return false;
	end
	if iPlayer ~= gT.HolySites[index].Player then
		return false;
	end
	local pRel = fRel or Players[iPlayer]:GetReligionCreatedByPlayer();
	if pRel < 1 then
		return false;
	end
	if gT.HolySites[index].ActiveReligions[pRel] then
		return false;
	end
	if Map.GetPlotByIndex(index):IsImprovementPillaged() then
		return false;
	end
	return true;
end

function GetCityReligionString(iCity)
	local iRel = iCity:GetReligiousMajority();
	if iRel >= 0 then
		return GameInfo.Religions[iRel].IconString
	end
	return "";
end

function GetCitiesAffectedByHolySite(index)
	local iTeam = Game.GetActiveTeam();
	local hText = "";
	local atc = {};
	for iRel, sth in pairs(gT.HolySites[index].PressureOnPlots) do
		for cIndex, val in pairs(sth) do
			if not atc[cIndex] then
				atc[cIndex] = true;
				local cPlot = Map.GetPlotByIndex(cIndex);
				if cPlot:IsRevealed(iTeam) then
					local iCity = cPlot:GetPlotCity();
					hText = hText .. "[ICON_BULLET]" .. GetCityReligionString(iCity) .. " " .. iCity:GetName() .. "[NEWLINE]";
				end
			end
		end
	end 
	return hText;
end

LuaEvents.ITGSG_RequestDetailsOnHolySite.Add(function(index)
	local data = {Treshold = GetHolySiteLevelTreshold(index), CanSanctify = CanOwnerSanctifyHolySite(index), CityLabel = GetCitiesAffectedByHolySite(index)}
	if data.CanSanctify then
		data.CanSanctifyRightNow = CanAffordTheAction(32, Game.GetActivePlayer(), nil, index)
	end
	MapModData.ITGSG = data;
end)

function AddTraitHolySite(index)
	local iPlayer = Map.GetPlotByIndex(index):GetOwner();
	local tabValid = {{},{},{}};
	local g_Bonuses = {};
	for index, sth in pairs(gT.HolySites) do
		if sth.MainTrait then
			if sth.Player == iPlayer then
				g_Bonuses[sth.MainTrait] = 2;
			else
				g_Bonuses[sth.MainTrait] = g_Bonuses[sth.MainTrait] or 1;
			end
		end
	end
	for i, v in pairs(tHolySiteTraits) do
		if (not v.ScOff) or (not v.ScOff[gT.Globals.ScenarioType]) then
			if (not v.CanBeAssigned) or (v.CanBeAssigned(index, iPlayer)) then
				if g_Bonuses[i] == 2 then
					table.insert(tabValid[3], i)
				elseif g_Bonuses[i] == 1 then
					table.insert(tabValid[2], i)
				else
					table.insert(tabValid[1], i)
				end
			end
		end
	end
	local lucky;
	for j, s in pairs(tabValid) do
		if #s > 0 then
			lucky = s[LastRandom(1,#s)]
			break;
		end
	end
	gT.HolySites[index].MainTrait = lucky;
end

function AddHolySiteToAPlot(plot, relID, fPlayer, bInitial)
	local index = plot:GetPlotIndex();
	if not gT.HolySites[index] then
		if fPlayer then
			VictoryTaskCompletion(fPlayer, 30)
		end
		local iPlayer = fPlayer or plot:GetOwner();
		if not gT.Players[iPlayer] then
			if bBlobTerritory then
				local pth = {}
				for kji = 0, 5 do
					local nPlot = Map.PlotDirection(plot:GetX(), plot:GetY(), kji);
					if nPlot and gT.Players[nPlot:GetOwner()] then
						table.insert(pth, nPlot:GetOwner());
					end
				end
				if #pth == 0 then
					return;
				end
				iPlayer = RandomFromTab(pth);
			else
				iPlayer = GetNearestUnitCityToThePlot(plot); -- it has radius of 9
				if not gT.Players[iPlayer] then
					print("Holy Site tried to be made in place so far away, nobody wanted it?")
					return;
				end
			end
		end
		MakeJumpAwayFromSpecialPoint(iPlayer, plot)
		SpawnHolySiteUnit(iPlayer, plot, 0)
		plot:SetSpecialControl(true)
		gT.PlotFortControl[index] = nil;
		gT.HolySites[index] = {Name = GetValidNameForHolySite(), Religions = {}, ActiveReligions = {}, ControlPlayer = iPlayer, Player = iPlayer, NearbyCities = {}, PressureOnPlots = {}, LCP_ID = GetCoastLandPassableAreaID(plot)}
		plot:SetImprovementType(holySite, -1)
		plot:SetOpenBorderForEveryone(true)
		plot:SetImprovementPillaged(false);
		plot:SetCanHaveYield(false)
		plot:SetOwner(iPlayer);
		--new stuff for Holy Site
		gT.HolySites[index].BasicBonuses = {HOLYSITE_START_FAITH, HOLYSITE_START_PRESSURE, HOLYSITE_START_MISSIONARY}
		gT.HolySites[index].Level = 1;
		gT.HolySites[index].XP = 0;
		gT.HolySites[index].VisitLog = {};
		if bInitial then
			gT.HolySites[index].Level = LastRandom(1, DBScenario.HolySiteInitLevel)
			gT.HolySites[index].XP = math.floor(LastRandom(0, GetHolySiteLevelTreshold(index) -1) / 10) * 10;
			for i = 2, gT.HolySites[index].Level do
				ApplyHolySiteBonusOnLevel(index)
			end
		end
		AddTraitHolySite(index)
	end
	if relID then
		table.insert(gT.HolySites[index].Religions, relID)
		gT.HolySites[index].PressureOnPlots[relID] = {}
		ChangeReligiousHolySitePresenceWithinArea(relID, plot, 2, 1)
		DoUpdatePressureOfHolySite(index)
	else
		print("Holy site on barbarian land?", dOwner, relID) -- well it happened with hanging temple
	end
	if gT.Globals.GameGenerated then
		RefreshReligionLabelOnPlot(index)
		if plot:IsVisible(Game.GetActiveTeam()) then
			local hex = ToHexFromGrid(Vector2(plot:GetX(), plot:GetY()));
			Events.GameplayFX(hex.x, hex.y, -1);
		end
	end
end

function ChangeReligiousHolySitePresenceWithinArea(iRel, iPlot, dis, amount)
	for i, plot in pairs(GetPlotsInRadiusOfPlot(iPlot, dis)) do
		plot:ChangeNumHolySitesActiveNearby(iRel, amount)
	end
end

function GenerateHolySitesForReligion(relID, numholysites, iPlayer, hCity)
	if numholysites < 1 then
		return;
	end
	local maxdistance = GetDBCulturePlayerInfo(iPlayer, "HolySiteDistance")
	local pTab = {hCity:Plot()}
	local hTab = {}
	local npc = GetDBCulturePlayerInfo(iPlayer, "NeedPassabilityCheck")
	for it, index in pairs(HolySitesLocations) do
		local fPlot = Map.GetPlotByIndex(index);
		for ip, ipPlot in pairs(pTab) do
			if Map.PlotDistance(ipPlot:GetX(), ipPlot:GetY(), fPlot:GetX(), fPlot:GetY()) < maxdistance then
				if gT.Players[GetNearestUnitCityToThePlot(fPlot)] then
					if (not npc) or (GetPassabilityAreaID(fPlot) == GetPassabilityAreaID(hCity:Plot())) then
						table.insert(hTab, fPlot);
						break
					end
				end
			end
		end
	end
	hTab = Shuffle(hTab);
	for i = 1, numholysites do
		if hTab[i] then
			AddHolySiteToAPlot(hTab[i], relID, nil, true)
		else
			print("Not enough holysites places", numholysites - i + 1, npc)
			break
		end
	end
end

function UpdatePressureOfAllHolySites()
	for index, data in pairs(gT.HolySites) do
		DoUpdatePressureOfHolySite(index)
		RefreshReligionLabelOnPlot(index)
	end
end

function DoUpdatePressureOfHolySite(index)
	local iPlayer = gT.HolySites[index].Player;
	local plot = Map.GetPlotByIndex(index)
	gT.HolySites[index].NearbyCities = {};
	for i, iRel in pairs(gT.HolySites[index].Religions) do
		gT.HolySites[index].ActiveReligions[iRel] = GetPressureOfHolySite(index, iRel, iPlayer)
		local distPressure = GetReligionDistanceHolySite(iRel);
		for i,v in pairs(Players) do
			for iCity in v:Cities() do
				if Map.PlotDistance(plot:GetX(), plot:GetY(), iCity:GetX(), iCity:GetY()) <= distPressure then
					local cIndex = iCity:Plot():GetPlotIndex();
					gT.HolySites[index].NearbyCities[cIndex] = true;
					local cID = cIndex .. "," .. iCity:GetGameTurnFounded();
					if (gT.HolySites[index].PressureOnPlots[iRel][cIndex] or 0) ~= gT.HolySites[index].ActiveReligions[iRel] then
						local change = gT.HolySites[index].ActiveReligions[iRel] - (gT.HolySites[index].PressureOnPlots[iRel][cIndex] or 0)
						iCity:ChangeBaseReligionPressure(iRel, change)
						gT.Cities[cID].HolySitesPressures[iRel] = (gT.Cities[cID].HolySitesPressures[iRel] or 0) + change;
					end
					gT.HolySites[index].PressureOnPlots[iRel][cIndex] = gT.HolySites[index].ActiveReligions[iRel];
				end
			end
		end
	end
end

function IsHolySitePossibleRightNow(x, y, i, iPlayer, iRel)
	local fPlot = Map.GetPlot(x, y);
	if gT.HolySites[i] then
		return false;
	elseif not IsHolySitePossible(fPlot:GetX(), fPlot:GetY(), i, iPlayer, iRel) then
		return false;
	end
	return true
end

function CanBeHolySiteBasicFunc(fPlot, iTeam, iPlayer)
	if fPlot:IsRevealed(iTeam) then
		if not fPlot:IsWater() then
			if (not fPlot:IsMountain()) or gT.Players[iPlayer].CanPlaceHolySiteOnMountain then
				return true;
			end
		end
	end
	return false;
end

function HighlighProperPlotsForHolySites(iPlayer)
	local hTab = {}
	local iTeam = Players[iPlayer]:GetTeam();
	local iRel = Players[iPlayer]:GetReligionCreatedByPlayer();
	if iRel > 0 then
		for i = 0, Map:GetNumPlots() - 1, 1 do
			local fPlot = Map.GetPlotByIndex( i );
			if CanBeHolySiteBasicFunc(fPlot, iTeam, iPlayer) then
				if IsHolySitePossible(fPlot:GetX(), fPlot:GetY(), fPlot:GetPlotIndex(), iPlayer, iRel) then
					table.insert(hTab, fPlot)
				end
			end
		end
	end
	MapModData.ITGSG = hTab;
end

function PlayerChooseHolySiteOnPlot(pPlot, iPlayer)
	local index = pPlot:GetPlotIndex();
	if pPlot:IsRevealed(Players[iPlayer]:GetTeam()) then
		local iRel = Players[iPlayer]:GetReligionCreatedByPlayer();
		if CanBeHolySiteBasicFunc(pPlot, Players[iPlayer]:GetTeam(), iPlayer) then
			if IsHolySitePossible(pPlot:GetX(), pPlot:GetY(), index, iPlayer, iRel) then
				AddHolySiteToAPlot(pPlot, iRel, iPlayer)
				PlayerSpendHolySitePoint(iPlayer)
			end
		end
	end
end

function DoAIConsiderPlacingHolySite(iPlayer)
	local iRel = Players[iPlayer]:GetReligionCreatedByPlayer(iPlayer);
	if iRel < 1 then
		return;
	end
	local bJustDoIt = false;
	if gT.Players[iPlayer].AIHolySiteDelay then
		bJustDoIt = gT.Players[iPlayer].AIHolySiteDelay <= GetITGGameTurn();
		gT.Players[iPlayer].AIIgnoreHolySiteAcq = true;
	end
	local nPlot, value = GetBestPlotForHolySiteForAI(iPlayer, true);
	if nPlot and ((value > 25) or (bJustDoIt)) then
		gT.Players[iPlayer].AIHolySiteDelay = nil;
		if gT.HolySites[nPlot:GetPlotIndex()] then
			AddHolySiteToAPlot(nPlot, iRel)
		else
			AddHolySiteToAPlot(nPlot, iRel, iPlayer)
		end
	elseif not gT.Players[iPlayer].AIHolySiteDelay then
		gT.Players[iPlayer].AIHolySiteDelay = math.min(GetITGGameTurn() + LastRandom(7, 12), 99)
	end
end

function PlayerSpendHolySitePoint(iPlayer)
	gT.Players[iPlayer].HolySitePoints = gT.Players[iPlayer].HolySitePoints - 1;
	if gT.Players[iPlayer].HasPlayerWonder[GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_50] then
		ChangeITGFestivalPoints(iPlayer, 1)
	end
end

function WouldBeActiveReligionOnHolySite(iPlot, iRel)
	local iOwner = iPlot:GetOwner();
	if gT.Players[iOwner] then
		if gT.Players[iOwner].OfficialReligion ~= iRel then
			return false;
		end
	end
	return true;
end

function GetNumCitiesAffectedByHolySite(plot, iRel, iPlayer)
	local value = 0;
	local distPressure = GetReligionDistanceHolySite(iRel);
	for i,v in pairs(Players) do
		for iCity in v:Cities() do
			if Map.PlotDistance(plot:GetX(), plot:GetY(), iCity:GetX(), iCity:GetY()) <= distPressure then
				if not iCity:IsSpreadImmune() then
					value = value + 4
				else
					value = value + 2;
				end
				if iPlayer == i then
					value = value + 1;
				end
			end
		end
	end
	return value;
end

function IsInDanger(iPlot, iPlayer)
	if iPlot:GetOwner() ~= -1 then
		if Teams[Players[iPlayer]:GetTeam()]:IsAtWar(Players[iPlot:GetOwner()]:GetTeam()) then
			if iPlot:GetNumDefenders(iPlayer) == 0 then
				return true;
			end
		end
	end
	for i = 0, 5 do
		local nPlot = Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), i);
		if nPlot then
			if nPlot:IsVisibleEnemyUnit(iPlayer) then
				return true;
			end
		end
	end
	return false;
end

function ShouldAIEvenConsiderPlacingHolySiteOnPlot(iPlot, pTeam)
	local iOwner = iPlot:GetOwner();
	if iOwner == -1 or (not pTeam:IsAtWar(Players[iOwner]:GetTeam())) then
		for j = 0, 5 do
			local jPlot = Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), j);
			if jPlot and jPlot:GetOwner() ~= -1 and pTeam:IsAtWar(Players[jPlot:GetOwner()]:GetTeam()) then
				return false;
			end
		end
		return true;
	end
	return false;
end

function GetTemporaryValueAIHolySite(iPlayer, index, iPlot, iRel)
	local value = 0;
	if gT.HolySites[index] then
		if WouldBeActiveReligionOnHolySite(iPlot, iRel) then
			if iPlot:GetOwner() ~= iPlayer then
				value = value - 10;
			end
		else
			return -999;
		end
	else
		if iPlot:GetOwner() ~= iPlayer then
			value = value + 15;
		elseif iPlot:GetImprovementType() ~= -1 then
			value = value - 10;
		end
		if IsInDanger(iPlot, iPlayer) then
			value = value - 50;
		end
		--we don't want too many holy sites too far from home too close to each other to not provoke wars
		local nCities = Players[iPlayer]:GetNumCities();
		if nCities > 0 then
			local bDis = 999;
			for iCity in Players[iPlayer]:Cities() do
				bDis = math.min(bDis, Map.PlotDistance(iPlot:GetX(), iPlot:GetY(), iCity:GetX(), iCity:GetY()))
			end
			for hindex, sth in pairs(gT.HolySites) do
				if Map.GetPlotByIndex(hindex):GetOwner() == iPlayer then
					local th = Map.GetPlotByIndex(hindex);
					if Map.PlotDistance(th:GetX(), th:GetY(), iPlot:GetX(), iPlot:GetY()) < bDis then
						value = value - 8;
					end
				end
			end
		end
	end
	return value;
end

function GetBestPlotForHolySiteForAI(iPlayer, bAbsoluteBest)
	local pTeam = Teams[Players[iPlayer]:GetTeam()];
	local iRel = Players[iPlayer]:GetReligionCreatedByPlayer(iPlayer);
	if gT.Players[iPlayer].AIHolySitesPlots then
		local bVal, bIndex = -1, -1;
		for i, value in pairs(gT.Players[iPlayer].AIHolySitesPlots) do
			local fPlot = Map.GetPlotByIndex(i);
			if IsHolySitePossibleRightNow(fPlot:GetX(), fPlot:GetY(), i, iPlayer, iRel) then
				if ShouldAIEvenConsiderPlacingHolySiteOnPlot(fPlot, pTeam) then
					local nVal = value + GetTemporaryValueAIHolySite(iPlayer, i, fPlot, iRel)
					if nVal < 25 then
						gT.Players[iPlayer].AIHolySitesPlots[i] = nil;	
					elseif bVal < nVal then
						bVal = nVal;
						bIndex = i;
					end
				end
			else
				gT.Players[iPlayer].AIHolySitesPlots[i] = nil;
			end
		end
		if bIndex ~= -1 then
			if (not bAbsoluteBest) or (bVal > 30) then
				return Map.GetPlotByIndex(bIndex), bVal;
			end
		end
	else
		gT.Players[iPlayer].AIHolySitesPlots = {}
	end
	HighlighProperPlotsForHolySites(iPlayer)
	local hTab = MapModData.ITGSG;
	MapModData.ITGSG = nil;
	local vTab = {}
	for i, iPlot in pairs(hTab) do
		if ShouldAIEvenConsiderPlacingHolySiteOnPlot(iPlot, pTeam) then
			local value = GetNumCitiesAffectedByHolySite(iPlot, iRel, iPlayer) + GetTemporaryValueAIHolySite(iPlayer, iPlot:GetPlotIndex(), iPlot, iRel);
			table.insert(vTab, {iPlot, value});
		end
	end
	if #vTab > 0 then
		table.sort(vTab, SortFunctionForGreaterInteger2);
		for i, v in pairs(vTab) do
			if i <= 5 then
				gT.Players[iPlayer].AIHolySitesPlots[v[1]:GetPlotIndex()] = v[2];
			end
		end
		return vTab[1][1], vTab[1][2];
	end
	return nil, -1;
end

function GetReligionDistanceHolySite(iRel)
	local base = 10;
	if IsReligionHaveBelief(iRel, GameInfoTypes.BELIEF_ITG_ENHANCER_2) then
		base = base + 4;
	end
	local iOwner = Game.GetFounder(iRel, -1)
	if gT.WondersConstructed[prambanan] == iOwner then
		base = base + 3;
	end
	return base;
end
 
function GetPressureOfHolySite(index, iRel, dOwner)
	local base = gT.HolySites[index].BasicBonuses[2];
	local mod = 100;
	if gT.Players[dOwner] then
		if gT.Players[dOwner].OfficialReligion and (gT.Players[dOwner].OfficialReligion ~= iRel) and (not HolySiteReligionIgnoresOfficials(iRel))  then
			mod = mod - 50;
		end
	end
	if IsReligionHaveBelief(iRel, GameInfoTypes.BELIEF_ITG_ENHANCER_1) then
		mod = mod + 66;
	end
	if gT.WondersConstructed[prambanan] then
		local iOwner = Game.GetFounder(iRel, -1)
		if gT.WondersConstructed[prambanan] == iOwner then
			mod = mod + 50;
		end
	end
	return math.ceil(base * mod / 100);
end

function HolySiteReligionIgnoresOfficials(iRel)
	local iOwner = Game.GetFounder(iRel, -1)
	if gT.WondersConstructed[prambanan] == iOwner then
		return true;
	end
	return false;
end

LuaEvents.RequestAllHolySiteData.Add(function(iPlayer, iTeam, bShowOnlyYours, bShowOnlyReligion, pRel)
	if (not gT) or (not gT.HolySites) then
		return;
	end
	local tabAlph = {}
	for index, gdd in pairs(gT.HolySites) do
		if Map.GetPlotByIndex(index):IsRevealed(iTeam) then
			if (not bShowOnlyYours) or (gdd.Player == iPlayer) then
				if (not bShowOnlyReligion) or (pRel < 1) or (gdd.ActiveReligions[pRel]) then
					local iTrait = gdd.MainTrait;
					local dn = " "
					for rel, val in pairs(gdd.ActiveReligions) do
						dn = dn .. GameInfo.Religions[rel].IconString
					end
					table.insert(tabAlph, {index, gdd.Name, gdd.Player ~= gdd.ControlPlayer, dn, tHolySiteTraits[iTrait].Name, tHolySiteTraits[iTrait].Help, tHolySiteTraits[iTrait].Val})
				end
			end
		end
	end
	table.sort(tabAlph, AlphabeticalSortFunction(2, "asc"))
	MapModData.ITGSG = tabAlph;
end)