local ideostringTab = {
R = "[ICON_IDEOLOGY_REASON]", O = "[ICON_IDEOLOGY_ORDER]", F = "[ICON_IDEOLOGY_FREEDOM]", A = "[ICON_IDEOLOGY_AUTOCRACY]", L = "[ICON_IDEOLOGY_LIBERTY]", E = "[ICON_IDEOLOGY_EQUALITY]", S = "[ICON_IDEOLOGY_SUPREMACY]"
}
local ideologytab = {A = "Autocracy", R = "Reason", F = "Freedom", L = "Liberty", O = "Order", E = "Equality", S = "Supremacy"}

function GetIdeoNameString(letter)
	return ideostringTab[letter] .. " " .. ideologytab[letter];
end

function IDBmAIValFunc1(iPlayer)
	local bV = 0;
	local hV1 = GetLegalPointsPerTurn(iPlayer, true);
	if hV1 > 150 then
		bV = 4;
	elseif hV1 > 80 then
		bV = 2;
	end
	return bV;
end
function IDBmAIValFunc2(iPlayer)
	local bV = 0;
	local hV1 = Players[iPlayer]:GetNumCities();
	if hV1 > 10 then
		bV = 6;
	elseif hV1 > 7 then
		bV = 4;
	elseif hV1 > 5 then
		bV = 2;
	end
	return bV;
end
function IDBmAIValFunc3(iPlayer)
	local bV = gT.Players[iPlayer].AIIdeologyFavours.MassUnits;
	return bV;
end
function IDBmAIValFunc4(iPlayer)
	local bV = 0;
	local hV1 = 0;
	if gT.Players[iPlayer].HasCodex then
		if gT.Players[iPlayer].CodexStrength > 50 then
			bV = bV + 2;
		end
	end
	if IsFirstAtPrinciples(iPlayer) then
		bV = bV + 2;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_HAPPINESS") > 6 then
		bV = bV + 2;
	end
	return bV;
end
function IDBmAIValFunc5(iPlayer)
	local bV = 0;
	local hV1 = GetNumAlliedCS(iPlayer)
	if hV1 > 6 then
		bV = 6;
	elseif hV1 > 1 then
		bV = 2;
	end
	return bV;
end
function IDBmAIValFunc6(iPlayer)
	local bV = 0;
	local hV1 = GetNumAlliedCS(iPlayer)
	if hV1 > 6 then
		bV = 6;
	elseif hV1 > 1 then
		bV = 2;
	end
	return bV;
end
function IDBmAIValFunc7(iPlayer)
	local bV = 0;
	if GetAIFlavour(iPlayer, "FLAVOR_PRODUCTION") > 6 then
		bV = bV + 2;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_HAPPINESS") > 6 then
		bV = bV + 2;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_INFRASTRUCTURE") < 7 then
		bV = bV + 2;
	end	
	return bV;
end
function IDBmAIValFunc8(iPlayer)
	local bV = 0;
	local hV1 = GetAIFlavour(iPlayer, "FLAVOR_HAPPINESS") - GetAIFlavour(iPlayer, "FLAVOR_GREAT_PEOPLE");
	if hV1 > 3 then
		bV = 6;
	elseif hV1 > 0 then
		bV = 2;
	end
	return bV;
end
function IDBmAIValFunc9(iPlayer)
	local bV = 0;
	local hV1 = gT.Globals.AverageMintBonus - gT.Players[iPlayer].MintBonus;
	if hV1 > 20 then
		bV = 6;
	elseif hV1 > 15 then
		bV = 4;
	elseif hV1 > 5 then
		bV = 2;
	end
	return bV;
end
function IDBmAIValFunc10(iPlayer)
	local bV = 0;
	if GetNumAlliedCS(iPlayer) > 1 then
		bV = gT.Players[iPlayer].AIIdeologyFavours.MassUnits
	end
	return bV;
end
function IDBmAIValFunc11(iPlayer)
	local bV = math.floor((gT.Players[iPlayer].AIIdeologyFavours.QualityUnits + gT.Players[iPlayer].AIIdeologyFavours.MassUnits)/2);
	return bV;
end
function IDBmAIValFunc12(iPlayer)
	local bV = 0;
	if GetNumActiveGovernors(iPlayer) > 2 then
		bV = bV + 2;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_LEGAL") > 7 then
		bV = bV + 2;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_HAPPINESS") > 7 then
		bV = bV + 2;
	end
	return bV;
end
function IDBmAIValFunc13(iPlayer)
	local bV = gT.Players[iPlayer].AIIdeologyFavours.SpyDefense;
	return bV;
end
function IDBmAIValFunc14(iPlayer)
	local bV = 0;
	local hV1 = Players[iPlayer]:GetBuildingClassCount(GameInfoTypes.BUILDINGCLASS_STOCK_EXCHANGE);
	if hV1 > 5 then
		bV = 4;
	elseif hV1 > 2 then
		bV = 2;
	end
	return bV;
end
function IDBmAIValFunc15(iPlayer)
	local bV = 0;
	local hV1 = GetLegalPointsPerTurn(iPlayer, true);
	if hV1 > 100 then
		bV = 6;
	elseif hV1 > 50 then
		bV = 2;
	end
	return bV;
end
function IDBmAIValFunc16(iPlayer)
	local bV = 0;
	local hV1 = GetNumAlliedCS(iPlayer)
	if hV1 > 4 then
		bV = 6;
	elseif hV1 > 1 then
		bV = 4;
	else
		bV = 2;
	end
	return bV;
end
function IDBmAIValFunc17(iPlayer)
	local bV = 0;
	if gT.Players[iPlayer].AverageHappiness < 6 then
		bV = 6;
	elseif gT.Players[iPlayer].AverageHappiness < 0 then
		bV = 2;
	end
	return bV;
end
function IDBmAIValFunc18(iPlayer)
	local bV = 0;
	local hV1 = 0;
	local lLeagueV = GetPlayerTradeRoutePointsFromLeagues(iPlayer)
	for iCity in Players[iPlayer]:Cities() do
		local lGain, nGain, pGain =  GetTradeRoutePointsPerTurn(iCity, iPlayer, lLeagueV)
		hV1 = hV1 + math.max(lGain, nGain)
	end
	if hV1 > 90 then
		bV = 6;
	elseif hV1 > 50 then
		bV = 4;
	end
	return bV;
end
function IDBmAIValFunc19(iPlayer)
	local bV = 0;
	local hV1 = GetPlayerTotalHealth(iPlayer);
	if hV1 > 100 then
		bV = 6;
	elseif hV1 > 50 then
		bV = 2;
	end
	return bV;
end
function IDBmAIValFunc20(iPlayer)
	local bV = gT.Players[iPlayer].AIIdeologyFavours.QualityUnits;
	return bV;
end
function IDBmAIValFunc21(iPlayer)
	return math.max(math.min(6, GetAIFlavour(iPlayer, "FLAVOR_DISRUPTIVE") - 3));
end
function IDBmAIValFunc22(iPlayer)
	local bV = gT.Players[iPlayer].AIIdeologyFavours.FeelLucky;
	return bV;
end
function IDBmAIValFunc23(iPlayer)
	local bV = gT.Players[iPlayer].AIIdeologyFavours.QualityUnits;
	return bV;
end
function IDBmAIValFunc24(iPlayer)
	local bV = 0;
	local hV1 = Players[iPlayer]:GetBuildingClassCount(GameInfoTypes.BUILDINGCLASS_PUBLIC_SCHOOL);
	if hV1 > 5 then
		bV = 4;
	elseif hV1 > 2 then
		bV = 2;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_PRODUCTION") > 7 then
		bV = bV + 2;
	end
	return bV;
end
function IDBmAIValFunc25(iPlayer)
	local bV = gT.Players[iPlayer].AIIdeologyFavours.MishMash;
	return bV;
end
function IDBmAIValFunc26(iPlayer)
	local bV = 0;
	local hV1 = Players[iPlayer]:GetNumCities();
	if hV1 > 7 then
		bV = 6;
	elseif hV1 > 4 then
		bV = 4;
	end
	return bV;
end
function IDBmAIValFunc27(iPlayer)
	local bV = gT.Players[iPlayer].AIIdeologyFavours.MishMash;
	return bV;
end
function IDBmAIValFunc28(iPlayer)
	local bV = gT.Players[iPlayer].AIIdeologyFavours.QualityUnits;
	return bV;
end
function IDBmAIValFunc29(iPlayer)
	local bV = gT.Players[iPlayer].AIIdeologyFavours.SpyOffense;
	return bV;
end
function IDBmAIValFunc30(iPlayer)
	local bV = 0;
	local hV1 = Players[iPlayer]:GetBuildingClassCount(GameInfoTypes.BUILDINGCLASS_HOSPITAL);
	if hV1 > 5 then
		bV = 4;
	elseif hV1 > 2 then
		bV = 2;
	end
	return bV;
end
function IDBmAIValFunc31(iPlayer)
	local bV = gT.Players[iPlayer].AIIdeologyFavours.QualityUnits;
	return bV;
end
function IDBmAIValFunc32(iPlayer)
	local bV = 0;
	local hV1 = 0;
	for g, j in pairs(gT.Players) do
		if Players[g]:IsMinorCiv() then
			if Players[g]:CanMajorBullyGold(iPlayer, true) then
				hV1 = hV1 + 1
			end
		end
	end
	if hV1 > 4 then
		bV = 6;
	elseif hV1 > 2 then
		bV = 4;
	elseif hV1 > 0 then
		bV = 2;
	end
	return bV;
end
function IDBmAIValFunc33(iPlayer)
	local bV = 0;
	local hV1 = 0;
	for iCity in Players[iPlayer]:Cities() do
		if iCity:IsOccupied() then
			hV1 = hV1 + 1;
		end
	end
	bV = math.min(6, 2 * math.floor(hV1 / 2))
	return bV;
end
function IDBmAIValFunc34(iPlayer)
	local bV = 0;
	local hV1 = GetAIFlavour(iPlayer, "FLAVOR_OFFENSE") - GetAIFlavour(iPlayer, "FLAVOR_DEFENSE");
	if hV1 < -3 then
		bV = 6;
	elseif hV1 < 0 then
		bV = 2;
	end
	return bV;
end
function IDBmAIValFunc35(iPlayer)
	local bV = 0;
	local hV1 = gT.Globals.AverageMintBonus - gT.Players[iPlayer].MintBonus;
	if hV1 < -10 then
		bV = 6;
	elseif hV1 < -3 then
		bV = 2;
	end
	return bV;
end
function IDBmAIValFunc36(iPlayer)
	local bV = 6 - gT.Players[iPlayer].AIIdeologyFavours.FeelLucky;
	return bV;
end
function IDBmAIValFunc37(iPlayer)
	local bV = gT.Players[iPlayer].AIIdeologyFavours.FeelLucky;
	return bV;
end
function IDBmAIValFunc38(iPlayer)
	local bV = 0;
	local hV1 = GetAIFlavour(iPlayer, "FLAVOR_INFRASTRUCTURE") - GetAIFlavour(iPlayer, "FLAVOR_GOLD");
	if hV1 < -3 then
		bV = 6;
	elseif hV1 < -1 then
		bV = 2;
	end 
	return bV;
end
function IDBmAIValFunc39(iPlayer)
	local bV = gT.Players[iPlayer].AIIdeologyFavours.SpyOffense;
	return bV;
end
function IDBmAIValFunc40(iPlayer)
	local bV = 0;
	local hV1 = Players[iPlayer]:GetNumCities()
	if hV1 > 8 then
		bV = 6;
	elseif hV1 > 4 then
		bV = 2;
	end
	return bV;
end
function IDBmAIValFunc41(iPlayer)
	local bV = 0;
	if GetLegalPointsPerTurn(iPlayer, true) > 45 then
		bV = 6;
	end
	return bV;
end
function IDBmAIValFunc42(iPlayer)
	local bV = 0;
	if gT.Players[iPlayer].MintBonus > 24 then
		bV = 6;
	elseif gT.Players[iPlayer].MintBonus > 10 then
		bV = 2;
	end
	return bV;
end
function IDBmAIValFunc43(iPlayer)
	local bV = 0;
	local hV1 = GetPlayerTotalHealth(iPlayer);
	if hV1 > 50 then
		bV = gT.Players[iPlayer].AIIdeologyFavours.QualityUnits
	end
	return bV;
end
function IDBmAIValFunc44(iPlayer)
	local bV = gT.Players[iPlayer].AIIdeologyFavours.MassUnits;
	return bV;
end
function IDBmAIValFunc45(iPlayer)
	local bV = 0;
	local hV1 = 0;
	for j, b in pairs(gT.Players[iPlayer].Inspirations) do
		hV1 = hV1 + 1;
	end
	if hV1 > 3 then
		bV = 6;
	end
	return bV;
end
function IDBmAIValFunc46(iPlayer)
	local bV = 6 - gT.Players[iPlayer].AIIdeologyFavours.FeelLucky;
	return bV;
end
function IDBmAIValFunc47(iPlayer)
	local bV = 0;
	for iCity in Players[iPlayer]:Cities() do
		if iCity:GetPopulation() >= 8 then
			bV = bV + 1;
		end
	end
	return math.min(6, bV);
end
function IDBmAIValFunc48(iPlayer)
	local bV = 0;
	if gT.Players[iPlayer].MintBonus > 20 then
		bV = 6;
	else 
		bV = 2;
	end
	return bV;
end
function IDBmAIValFunc49(iPlayer)
	local bV = gT.Players[iPlayer].AIIdeologyFavours.SpyOffense;
	return bV;
end
function IDBmAIValFunc50(iPlayer)
	local bV = 0;
	local hV1 = GetAIFlavour(iPlayer, "FLAVOR_OFFENSE") - GetAIFlavour(iPlayer, "FLAVOR_DEFENSE");
	if hV1 < -3 then
		bV = 6;
	elseif hV1 < 0 then
		bV = 2;
	end
	return bV;
end
function IDBmAIValFunc51(iPlayer)
	local bV = math.floor((gT.Players[iPlayer].AIIdeologyFavours.QualityUnits + gT.Players[iPlayer].AIIdeologyFavours.FeelLucky)/2);
	return bV;
end
function IDBmAIValFunc52(iPlayer)
	local bV = gT.Players[iPlayer].AIIdeologyFavours.QualityUnits;
	return bV;
end
function IDBmAIValFunc53(iPlayer)
	local bV = gT.Players[iPlayer].AIIdeologyFavours.QualityUnits;
	return bV;
end
function IDBmAIValFunc54(iPlayer)
	local bV = 0;
	local hV1 = Players[iPlayer]:GetBuildingClassCount(GameInfoTypes.BUILDINGCLASS_FACTORY);
	if hV1 > 5 then
		bV = 4;
	elseif hV1 > 2 then
		bV = 2;
	end
	return bV;
end
function IDBmAIValFunc55(iPlayer)
	local bV = 0;
	local hV1 = GetNumSpecialControlPoint(iPlayer, "Forts", true)
	if hV1 > 6 then
		bV = 4;
	elseif hV1 > 3 then
		bV = 2;
	end
	return bV;
end
function IDBmAIValFunc56(iPlayer)
	local bV = 0;
	local hV1 = Players[iPlayer]:GetBuildingClassCount(GameInfoTypes.BUILDINGCLASS_ARSENAL);
	if hV1 > 5 then
		bV = 4;
	elseif hV1 > 2 then
		bV = 2;
	end
	return bV;
end
function IDBmAIValFunc57(iPlayer)
	local bV = math.floor((gT.Players[iPlayer].AIIdeologyFavours.QualityUnits + gT.Players[iPlayer].AIIdeologyFavours.FeelLucky)/2);
	return bV;
end
function IDBmAIValFunc58(iPlayer)
	local bV = 2 * LastRandom(0, 2);
	return bV;
end
function IDBmAIValFunc59(iPlayer)
	local bV = 0;
	local hV1 = GetAIFlavour(iPlayer, "FLAVOR_OFFENSE") - GetAIFlavour(iPlayer, "FLAVOR_DEFENSE");
	if hV1 < -3 then
		bV = 6;
	elseif hV1 < 0 then
		bV = 2;
	end
	return bV;
end
function IDBmAIValFunc60(iPlayer)
	local bV = gT.Players[iPlayer].AIIdeologyFavours.FeelLucky;
	return bV;
end
function IDBmAIValFunc61(iPlayer)
	return math.max(0, math.min(6, Players[iPlayer]:GetNumCities() - 2));
end
function IDBmAIValFunc62(iPlayer)
	local bV = 0;
	local gpt = gT.Players[iPlayer].PrevTurnGPT;
	local inflationpower = 0;
	if gpt > 50 then
		inflationpower = inflationpower - GetInflationFromValue(gpt - 50, 100, 1)
	end
	if inflationpower < -10 then
		bV = 4;
	end
	return bV;
end
function IDBmAIValFunc63(iPlayer)
	local bV = 0;
	local hV1 = GetNumOfGPCivilOfType(iPlayer)
	if hV1 > 9 then
		bV = 6;
	elseif hV1 > 4 then
		bV = 2;
	end
	return bV;
end
function IDBmAIValFunc64(iPlayer)
	local bV = 0;
	local hV1 = Players[iPlayer]:GetBuildingClassCount(GameInfoTypes.BUILDINGCLASS_THEATRE);
	if hV1 > 5 then
		bV = 4;
	elseif hV1 > 2 then
		bV = 2;
	end
	return bV;
end
function IDBmAIValFunc65(iPlayer)
	return math.min(6, math.max(0, GetNumOfGPCivilOfType(iPlayer) - 4));
end
function IDBmAIValFunc66(iPlayer)
	local bV = gT.Players[iPlayer].AIIdeologyFavours.MishMash;
	return bV;
end
function IDBmAIValFunc67(iPlayer)
	local bV = 0;
	if gT.Players[iPlayer].AverageHappinessCounted > 0 then
		local hV1 =	math.floor(0.5 + 100 * gT.Players[iPlayer].AverageHappiness / gT.Players[iPlayer].AverageHappinessCounted )/100;
		local hV2 = gT.Players[iPlayer].GreatestHappiness;
		if hV1 > 5 or (hV1 > 3 and hV2 < 15) then
			bV = 6;
		elseif hV1 > 3 then
			bV = 2;
		end
	end
	return bV;
end
function IDBmAIValFunc68(iPlayer)
	local bV = 0;
	local hV1 = GetAIFlavour(iPlayer, "FLAVOR_HAPPINESS")
	if hV1 > 7 then
		bV = 4;
	end
	return bV;
end
function IDBmAIValFunc69(iPlayer)
	local bV = gT.Players[iPlayer].AIIdeologyFavours.MishMash;
	return bV;
end
function IDBmAIValFunc70(iPlayer)
	local bV = 0;
	local hV1 = 0;
	for iCity in Players[iPlayer]:Cities() do
		hV1 = hV1 + math.floor(iCity:GetYieldRateTimes100(yScience) / 1000)
	end
	if hV1 > 12 then
		bV = 6;
	elseif hV1 > 7 then
		bV = 4;
	end
	return bV;
end
function IDBmAIValFunc71(iPlayer)
	local bV = 0;
	local hV1 = 0;
	for iCity in Players[iPlayer]:Cities() do
		if iCity:IsIndustrialRouteToCapital() then
			hV1 = hV1 + 1;
		end
	end
	if hV1 > 4 then
		bV = 6
	elseif hV1 > 2 then
		bV = 2
	end
	return bV;
end
function IDBmAIValFunc72(iPlayer)
	local bV = 0;
	local hV1 = 0;
	for iCity in Players[iPlayer]:Cities() do
		if iCity:IsIndustrialRouteToCapital() then
			local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
			hV1 = hV1 + gT.Cities[cID].Health;
		end
	end
	if hV1 > 40 then
		bV = 6;
	elseif hV1 > 25 then
		bV = 2;
	end
	return bV;
end
function IDBmAIValFunc73(iPlayer)
	local bV = math.min(4, GetNumActiveGovernors(iPlayer));
	if GetAIFlavour(iPlayer, "FLAVOR_GREAT_PEOPLE") > 6 then
		bV = bV + 2;
	end
	return bV;
end
function IDBmAIValFunc74(iPlayer)
	local bV = gT.Players[iPlayer].AIIdeologyFavours.QualityUnits;
	return bV;
end
function IDBmAIValFunc75(iPlayer)
	local bV = 0;
	if gT.Players[iPlayer].HasCodex then
		if gT.Players[iPlayer].CodexStrength > 55 then
			bV = bV + 2;
		end
	end
	if GetAIFlavour(iPlayer, "FLAVOR_DISRUPTIVE") > 6 then
		bV = bV + 1;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_LEGAL") > 6 then
		bV = bV + 2;
	end
	if gT.Players[iPlayer].AIIdeologyFavours.FeelLucky > 4 then
		bV = bV + 1;
	end
	return bV;
end
function IDBmAIValFunc76(iPlayer)
	local bV = 0;
	local hV1 = GetNumAgents(iPlayer, true)
	if hV1 > 5 then
		bV = 6;
	elseif hV1 > 4 then
		bV = 4;
	end
	return bV;
end
function IDBmAIValFunc77(iPlayer)
	local bV = 0
	if GetAIFlavour(iPlayer, "FLAVOR_DISRUPTIVE") > 5 then
		bV = bV + 2;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_OFFENSE") > 6 then
		bV = bV + 2;
	end
	if GetAIFlavour(iPlayer, "FLAVOR_CULTURE") > 6 then
		bV = bV + 2;
	end
	return bV;
end
function IDBmAIValFunc78(iPlayer)
	local bV = gT.Players[iPlayer].AIIdeologyFavours.MassUnits;
	return bV;
end
function IDBmAIValFunc79(iPlayer)
	local bV = 0;	
	local hV1 = Players[iPlayer]:GetBuildingClassCount(GameInfoTypes.BUILDINGCLASS_POLICE_STATION);
	if hV1 > 5 then
		bV = 4;
	elseif hV1 > 2 then
		bV = 2;
	end
	return bV;
end
function IDBmAIValFunc80(iPlayer)
	local bV = math.floor((gT.Players[iPlayer].AIIdeologyFavours.MassUnits + gT.Players[iPlayer].AIIdeologyFavours.QualityUnits) / 2);
	return bV;
end
function IDBmAIValFunc81(iPlayer)
	return math.min(math.floor((gT.Players[iPlayer].AIIdeologyFavours.FeelLucky + gT.Players[iPlayer].AIIdeologyFavours.MishMash) * 0.75), 6);
end
function IDBmAIValFunc82(iPlayer)
	local bV = 0;
	local hV1 = Players[iPlayer]:GetTotalPopulation();
	if hV1 > 70 then
		bV = 6;
	elseif hV1 > 40 then
		bV = 2;
	end
	return bV;
end
function IDBmAIValFunc83(iPlayer)
	local bV = gT.Players[iPlayer].AIIdeologyFavours.SpyOffense;
	return bV;
end
function IDBmAIValFunc84(iPlayer)
	local bV = 0;
	local hV1 = 0;
	for g, c in pairs(gT.Players) do
		if Players[g]:IsMinorCiv() then
			hV1 = hV1 + 1;
		end
	end
	if hV1 > 7 then
		bV = 6;
	elseif hV1 > 3 then
		bV = 4;
	elseif hV1 > 1 then
		bV = 2;
	end
	return bV;
end
function IDBmAIValFunc85(iPlayer)
	local bV = gT.Players[iPlayer].AIIdeologyFavours.QualityUnits;
	return bV;
end
function IDBmAIValFunc86(iPlayer)
	local bV = gT.Players[iPlayer].AIIdeologyFavours.FeelLucky;
	return bV;
end
function IDBmAIValFunc87(iPlayer)
	local bV = 0;
	local hV1 = GetNumOfGPCivilOfType(iPlayer)
	if hV1 > 9 then
		bV = 6;
	elseif hV1 > 5 then
		bV = 4;
	end
	return bV;
end
function IDBmAIValFunc88(iPlayer)
	local bV = 0;
	local hV1 = 0;
	for g, c in pairs(gT.Players) do
		if Players[g]:IsMinorCiv() then
			hV1 = hV1 + 1;
		end
	end
	if hV1 > 7 then
		bV = 6;
	elseif hV1 > 3 then
		bV = 4;
	elseif hV1 > 1 then
		bV = 2;
	end
	return bV;
end
function IDBmAIValFunc89(iPlayer)
	local val1, val2 = GetNumActiveGovernors(iPlayer), GetAIFlavour(iPlayer, "FLAVOR_GREAT_PEOPLE"); 
	if val1 >= 3 and val2 >= 8 then
		return 6;
	elseif val1 >= 2 and val2 >= 6 then
		return 4;
	elseif val1 >= 1 and val2 >= 4 then
		return 2;
	end
	return 0;
end
function IDBmAIValFunc90(iPlayer)
	local bV = gT.Players[iPlayer].AIIdeologyFavours.QualityUnits;
	return bV;
end
function IDBmAIValFunc91(iPlayer)
	local bV = 0;
	local hV1 = GetNumOfGPCivilOfType(iPlayer)
	if hV1 > 8 then
		bV = 6;
	elseif hV1 > 4 then
		bV = 4
	end
	return bV;
end
function IDBmAIValFunc92(iPlayer)
	local bV = 0;
	if GetAIFlavour(iPlayer, "FLAVOR_WONDER") > 6 then
		bV = bV + 2;
		for iCity in Players[iPlayer]:Cities() do
			local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded()
			if gT.Cities[cID].WonderRuin then
				bV = bV + 2;
			end
		end
	end
	return math.min(6, bV);
end
function IDBmAIValFunc93(iPlayer)
	local bV = 0;	
	local hV1 = Players[iPlayer]:GetBuildingClassCount(GameInfoTypes.BUILDINGCLASS_MILITARY_ACADEMY);
	if hV1 > 5 then
		bV = 4;
	elseif hV1 > 2 then
		bV = 2;
	end
	return bV;
end

local IdeologyDB = {
{ID = 1, z = 1, x = 3, y = 1, R = 0, O = 0, F = 2, A = 0, L = 0, E = 2, S = 0, AIValueFunc = IDBmAIValFunc1, Connected = {3, 15}, Name = "Worldwide Anarchy", Help = "+7% [ICON_HAPPINESS_1] Happiness chance if there is a rival player with negative amount of [ICON_ITG_LEGAL_POWER] Legal Power.[NEWLINE]+1.5% [ICON_ITG_FESTIVAL] Festival chance if there is a rival player in Anarchy.[NEWLINE]Having negative [ICON_ITG_LEGAL_POWER] Legal Power has no effect.[NEWLINE]Unlocks legal action [COLOR_POSITIVE_TEXT]Worldwide Anarchy[ENDCOLOR] (4[ICON_ITG_LEGAL_POWER])[NEWLINE]----------------[NEWLINE]All other players' [ICON_ITG_LEGAL_POWER] Legal Power is reduced by 3."},
{ID = 2, z = 1, x = 2, y = 2, R = 0, O = 0, F = 1, A = 0, L = 1, E = 2, S = 0, AIValueFunc = IDBmAIValFunc2, Connected = {3, 6, 18}, Name = "Universal Healthcare", Help = "Cities with under average [ICON_ITG_HEALTH_1] Health have it increased to average level.[NEWLINE]Other cities gain +1 [ICON_HAPPINESS_1] local Happiness.[NEWLINE]+1 [ICON_ITG_MERITOCRACY] Meritocracy per turn.[NEWLINE]-2 [ICON_RESISTANCE] Riots' Strength in [ICON_ITG_HEALTH_1] Healthy Cities."},
{ID = 3, z = 1, x = 3, y = 2, R = 0, O = 0, F = 1, A = 0, L = 0, E = 3, S = 0, AIValueFunc = IDBmAIValFunc3, Connected = {1, 2, 4, 7, 19}, Name = "Free folks' Army", Help = "Negative [ICON_ITG_MORALE] Morale and [ICON_HAPPINESS_4] Unhappiness of defeated enemy increase chance for unit capture. +3% chance to capture defeated barbarian units.[NEWLINE][NEWLINE]Notable conquest of [ICON_HAPPINESS_4] Unhappy City has chance to spawn up to 5 free units (if you are not out of [ICON_ITG_SUPPLY] Supply)."},
{ID = 4, z = 1, x = 4, y = 2, R = 0, O = 1, F = 1, A = 0, L = 0, E = 2, S = 0, AIValueFunc = IDBmAIValFunc4, Connected = {3, 8, 20}, Name = "Righteous Law", Help = "[NEWLINE]Low [ICON_ITG_MERITOCRACY] Meritocracy does not increase chance to enter Anarchy.[NEWLINE]+0.1 [ICON_ITG_LEGAL_POWER] Legal Power if no other player has greater number of Principles.[NEWLINE]Captured Cities are less [ICON_HAPPINESS_4] Unhappy if they had common laws.[NEWLINE]During melee attack [ICON_ITG_CODEX] Codex strength difference grants chance to perform +100% Critical Strike.[NEWLINE]+50% [ICON_ITG_LAWS_INFLUENCE] Codex Influence."},
{ID = 5, z = 1, x = 1, y = 3, R = 0, O = 0, F = 0, A = 0, L = 2, E = 2, S = 0, AIValueFunc = IDBmAIValFunc5, Connected = {6, 22}, Name = "Brotherhood Army", Help = "Allied City-States' units have 10% chance for +300% combat bonus.[NEWLINE]Allied City-States train double units.[NEWLINE]Allied City-States cities gain +10 [ICON_STRENGTH] Defenses.[NEWLINE]+7% [ICON_PRODUCTION] Production modifier towards training Military units per allied City-State."},
{ID = 6, z = 1, x = 2, y = 3, R = 0, O = 0, F = 0, A = 0, L = 1, E = 3, S = 0, AIValueFunc = IDBmAIValFunc6, Connected = {2, 5,7,10, 23}, Name = "Boundless Union", Help = "You get 50% of [ICON_GOLD] Gold and [ICON_RESEARCH] Science outputs of allied City-States.[NEWLINE][ICON_HAPPINESS_1] Happiness of allied City-States is considered in your average [ICON_HAPPINESS_1] Happiness."},
{ID = 7, z = 1, x = 3, y = 3, R = 1, O = 0, F = 0, A = 0, L = 0, E = 3, S = 0, AIValueFunc = IDBmAIValFunc7, Connected = {3, 6, 8, 11, 24}, Name = "Work Injury Insurance", Help = "Cities may spend 500 [ICON_WORKER] Work Rate to permanently increase [ICON_ITG_HEALTH_1] Health and [ICON_PRODUCTION] Production by 1.[NEWLINE]+1 local [ICON_HAPPINESS_1] Happiness in all Cities."},
{ID = 8, z = 1, x = 4, y = 3, R = 0, O = 1, F = 0, A = 0, L = 0, E = 3, S = 0, AIValueFunc = IDBmAIValFunc8, Connected = {4, 7, 9, 12, 25}, Name = "Equality-Mediocrity", Help = "+1 [ICON_HAPPINESS_1] Happiness in all Cities and +250 [ICON_CULTURE] Culture instead new Great Person upon reaching a [ICON_GREAT_PEOPLE] Great People points' treshold.[NEWLINE]Great People have +5 [ICON_TOURISM] base migration generation.[NEWLINE]+20% [ICON_HAPPINESS_1] Happiness chance.[NEWLINE]+20 [ICON_CULTURE] Culture per turn.[NEWLINE]-1% [ICON_HAPPINESS_1] Happiness chance and -1 [ICON_CULTURE] Culture per civilian Great Person."},
{ID = 9, z = 1, x = 5, y = 3, R = 0, O = 2, F = 0, A = 0, L = 0, E = 2, S = 0, AIValueFunc = IDBmAIValFunc9, Connected = {8, 26}, Name = "Against the Odds", Help = "Your spies have always at least 30% chance to succeed in offensive missions.[NEWLINE]Grants 30% chance to negate enemy unit's Critical Bonus.[NEWLINE]Cities have 30% chance to have an additional ranged strike each turn."},
{ID = 10, z = 1, x = 2, y = 4, R = 0, O = 0, F = 0, A = 1, L = 1, E = 2, S = 0, AIValueFunc = IDBmAIValFunc10, Connected = {6, 11, 27}, Name = "Commander-in-chief", Help = "All types of City-States periodically gift units (if friendly or allied).[NEWLINE]Units gifted by City-States gain +1 [ICON_STRENGTH] Strength for each allied City-State you have (up to +5 [ICON_STRENGTH]).[NEWLINE]+20 [ICON_INFLUENCE] Influence with random friendly City-State upon notable conquest."},
{ID = 11, z = 1, x = 3, y = 4, R = 0, O = 0, F = 0, A = 1, L = 0, E = 3, S = 0, AIValueFunc = IDBmAIValFunc11, Connected = {7, 10, 12, 13, 28}, Name = "Common Military Service", Help = "Newly trained units start with an extra Veteran promotion(s) based on unitclass experience (250/750/1500...).[NEWLINE][NEWLINE]Cities gain +4% [ICON_PRODUCTION] Production towards military units per turn of not training such unit. Resets to 0 upon training a military unit.[NEWLINE][NEWLINE]Trained units gain +2 [ICON_MOVES] Movement for first turn."},
{ID = 12, z = 1, x = 4, y = 4, R = 0, O = 1, F = 0, A = 1, L = 0, E = 2, S = 0, AIValueFunc = IDBmAIValFunc12, Connected = {8, 11, 29}, Name = "Populism", Help = "+0.01 [ICON_ITG_LEGAL_POWER] Legal Power and +1 [ICON_ITG_UNIFY] Unifying Presence for each turn your empire remains [ICON_HAPPINESS_1] Happy (up to 15x).[NEWLINE]Whenever empire becomes [ICON_HAPPINESS_4] Unhappy your [ICON_ITG_GOVERNOR] Governors generate special diplomatic action that boosts [ICON_HAPPINESS_1] Happiness in all Cities."},
{ID = 13, z = 1, x = 3, y = 5, R = 0, O = 0, F = 0, A = 2, L = 0, E = 2, S = 0, AIValueFunc = IDBmAIValFunc13, Connected = {11, 33}, Name = "Big Brother", Help = "+15 defense against rival spies.[NEWLINE]+1 [ICON_ITG_MERITOCRACY] Meritocracy if level is below 40.[NEWLINE]+1 [ICON_ITG_MERITOCRACY] Meritocracy if level is below 20.[NEWLINE]+10% chance to generate [ICON_HAPPINESS_1] Happiness if you captured enemy spy in last 8 turns.[NEWLINE]+15 [ICON_ITG_POWER] Power if you have at least 2 [ICON_ITG_GOVERNOR] Governors."},

{ID = 14, z = 2, x = 2, y = 1, R = 0, O = 0, F = 2, A = 0, L = 1, E = 1, S = 0, AIValueFunc = IDBmAIValFunc14, Connected = {15, 18, 36}, Name = "Logistics", Help = "+1 [ICON_PRODUCTION] Production from Stock Exchange.[NEWLINE]+1 [ICON_PRODUCTION] Production in City for every Trade Route established with it.[NEWLINE]Allows using process transforming [ICON_PRODUCTION] Production into [ICON_CARAVAN][ICON_CARGO] Trade Route points."},
{ID = 15, z = 2, x = 3, y = 1, R = 0, O = 0, F = 3, A = 0, L = 0, E = 1, S = 0, AIValueFunc = IDBmAIValFunc15, Connected = {1, 14, 16, 19, 37}, Name = "Will of the Crowd", Help = "+0.15 [ICON_ITG_LEGAL_POWER] Legal Power if your [ICON_ITG_LEGAL_POWER] Legal Power is below 5.[NEWLINE]+7% chance to generate [ICON_HAPPINESS_1] Happiness if you spend [ICON_ITG_LEGAL_POWER] Legal Power in last 4 turns.[NEWLINE]+20% [ICON_PRODUCTION] Production for each [ICON_ITG_LEGAL_POWER] Legal Power spend previous turn."},
{ID = 16, z = 2, x = 4, y = 1, R = 0, O = 1, F = 2, A = 0, L = 0, E = 1, S = 0, AIValueFunc = IDBmAIValFunc16, Connected = {15, 20, 38}, Name = "Economic Leash", Help = "Rival Trade Routes do not grant [ICON_INFLUENCE] Influence within your allied City-States.[NEWLINE]+30 [ICON_INFLUENCE] Influence from your Trade Routes arriving to City-States.[NEWLINE]You gain [ICON_GOLD] Gold from allied City-States (+0.25 [ICON_GOLD] Gold per [ICON_INFLUENCE] Influence advantage over the second best major player)."},
{ID = 17, z = 2, x = 1, y = 2, R = 0, O = 0, F = 1, A = 0, L = 2, E = 1, S = 0, AIValueFunc = IDBmAIValFunc17, Connected = {18, 22, 40}, Name = "Barricades", Help = "[ICON_RESISTANCE] Riots have a constant 5% chance to start not related to [ICON_HAPPINESS_4] Unhappiness.[NEWLINE][ICON_RESISTANCE] Riots increase [ICON_ITG_MERITOCRACY] Meritocracy by 2.[NEWLINE][ICON_RESISTANCE] Riots' strength is reduced by 5 in [ICON_HAPPINESS_1] happy Cities.[NEWLINE]Chance for buildings to be destroyed in Riots is reduced by 50%."},
{ID = 18, z = 2, x = 2, y = 2, R = 1, O = 0, F = 1, A = 0, L = 1, E = 1, S = 0, AIValueFunc = IDBmAIValFunc18, Connected = {2, 14, 17, 19, 23, 41}, Name = "Unregulated Trade", Help = "+4 [ICON_CARAVAN] Land and [ICON_CARGO] Naval Trade Route points (in Cities that generate at least 1 respective point) if you haven't established Trade Route and none of your Trade Routes were plundered in last turn.[NEWLINE]Cities gain [ICON_PRODUCTION] Production modifier based on Trade Route points generated each turn.[NEWLINE]Cities generate +1% [ICON_GOLD] Gold per existing Trade Unit."},
{ID = 19, z = 2, x = 3, y = 2, R = 1, O = 0, F = 2, A = 0, L = 0, E = 1, S = 0, AIValueFunc = IDBmAIValFunc19, Connected = {3, 15, 18, 20, 24, 42}, Name = "Big Pharma", Help = "Total [ICON_ITG_HEALTH_1] Health contributes toward [ICON_INVEST] Currency Power.[NEWLINE]Cities with negative level of [ICON_ITG_HEALTH_3] Health gain extra [ICON_GOLD] Gold modifier.[NEWLINE]+2 [ICON_GOLD] Gold from Hospitals."},
{ID = 20, z = 2, x = 4, y = 2, R = 1, O = 1, F = 1, A = 0, L = 0, E = 1, S = 0, AIValueFunc = IDBmAIValFunc20, Connected = {4, 16, 19, 21, 25, 43}, Name = "No Man Behind", Help = "Units' heal rate is increased by 10.[NEWLINE]Units starting turn with 25% HP or less gain +2 [ICON_MOVES] Movement.[NEWLINE]Units gain +1% [ICON_STRENGTH] Combat Bonus per 25 damage ever taken (up to +33%)."},
{ID = 21, z = 2, x = 5, y = 2, R = 0, O = 2, F = 1, A = 0, L = 0, E = 1, S = 0, AIValueFunc = IDBmAIValFunc21, Connected = {20, 26, 44}, Name = "World Liberation", Help = "[ICON_BULLET]Cities occupied by players without this ideology have 25% chance to start Uprising upon [ICON_RESISTANCE] Riots (spawn extra barbarian units and remain in [ICON_RESISTANCE] resistance as long as they are alive. Those insurgents may join their original player: it requires war with city owner and a military unit adjacent to them). Chance is increased to 50% if you are original owner of the City.[NEWLINE][NEWLINE][ICON_BULLET]+20 [ICON_ITG_MERITOCRACY] Meritocracy upon liberating City.[NEWLINE][ICON_BULLET]Players without this ideology need 1 extra [ICON_ITG_LEGAL_POWER] Legal Power to legalize conquest.[NEWLINE][ICON_BULLET]Units take 50% less damage while attacking occupied City."},
{ID = 22, z = 2, x = 1, y = 3, R = 0, O = 0, F = 0, A = 0, L = 3, E = 1, S = 0, AIValueFunc = IDBmAIValFunc22, Connected = {5, 17, 23, 27, 45}, Name = "Scientific Liberty", Help = "Scientific Bonus cost reduced by 33% (15% if you have Chancellor).[NEWLINE]Reward from Scientific Bonus is acquired randomly."},
{ID = 23, z = 2, x = 2, y = 3, R = 1, O = 0, F = 0, A = 0, L = 2, E = 1, S = 0, AIValueFunc = IDBmAIValFunc23, Connected = {6, 18, 22, 24, 28, 46}, Name = "Heroic Mission", Help = "+10% chance that unit will take 1 damage instead lethal damage while defending.[NEWLINE]Melee units become fully stackable after an attack (ends if unit does not attack for a turn)."},
{ID = 24, z = 2, x = 3, y = 3, R = 2, O = 0, F = 0, A = 0, L = 0, E = 2, S = 0, AIValueFunc = IDBmAIValFunc24, Connected = {7, 19, 23, 25, 29, 47}, Name = "Public Education", Help = "+1 [ICON_PRODUCTION] Production from Public School.[NEWLINE]Cultural Heritage, Infrastructure, Research and Wealth processes grant double yields.[NEWLINE]+1 [ICON_GREAT_PEOPLE] Great People point per City with 10+ [ICON_CITIZEN] Population."},
{ID = 25, z = 2, x = 4, y = 3, R = 1, O = 2, F = 0, A = 0, L = 0, E = 1, S = 0, AIValueFunc = IDBmAIValFunc25, Connected = {8, 20, 24, 26, 30, 48}, Name = "Monumentalism", Help = "Every 25 turns you can choose new Inspiration.[NEWLINE]+2 [ICON_ITG_UNIFY] Unifying Presence per Inspiration.[NEWLINE]Buildings with Inspiration are not destroyed upon [ICON_RESISTANCE] Riots or City conquer.[NEWLINE]+5 [ICON_ITG_MERITOCRACY] Meritocracy upon choosing an Inspiration."},
{ID = 26, z = 2, x = 5, y = 3, R = 0, O = 3, F = 0, A = 0, L = 0, E = 1, S = 0, AIValueFunc = IDBmAIValFunc26, Connected = {9, 21, 25, 31, 49}, Name = "We the People", Help = "Your Cities [ICON_RESISTANCE] Riot only all at once.[NEWLINE]Your [ICON_HAPPINESS_1] Happiness and [ICON_RESISTANCE] Riot rolls are triggered at the end of turn instead of the beginning.[NEWLINE]Cities that already want to Riot have 0% chance to generate [ICON_HAPPINESS_1] Happiness and [ICON_HAPPINESS_4] Unhappiness generated by them is transferred to other Cities. In addition, an average [ICON_HAPPINESS_1] Happiness is increased by 1 for each such City."},
{ID = 27, z = 2, x = 1, y = 4, R = 0, O = 0, F = 0, A = 1, L = 2, E = 1, S = 0, AIValueFunc = IDBmAIValFunc27, Connected = {22, 28, 50}, Name = "Manufactured holidays", Help = "Every 5th National Day you gain 1 [ICON_ITG_MORALE] Morale, all currently owned Cities gain +5% [ICON_GOLD] Gold and [ICON_CULTURE] Culture."},
{ID = 28, z = 2, x = 2, y = 4, R = 1, O = 0, F = 0, A = 1, L = 1, E = 1, S = 0, AIValueFunc = IDBmAIValFunc28, Connected = {10, 23, 27, 29, 32, 51}, Name = "Military Engineering", Help = "Grants 4 Military Engineers promotions: chosen military land unit ignores terrain cost and creates temporary roads upon movement."},
{ID = 29, z = 2, x = 3, y = 4, R = 1, O = 0, F = 0, A = 2, L = 0, E = 1, S = 0, AIValueFunc = IDBmAIValFunc29, Connected = {11, 24, 28, 30, 33, 52}, Name = "Spy Wars", Help = "Newly trained units gain +5 XP for every active Agent.[NEWLINE]Recon ability: can target plots outside your territory, provides 3-radius vision, 10% chance for +100% critical bonus while fighting there, military units starting next turn there are speed up by 1 [ICON_MOVES] Movement."},
{ID = 30, z = 2, x = 4, y = 4, R = 1, O = 1, F = 0, A = 1, L = 0, E = 1, S = 0, AIValueFunc = IDBmAIValFunc30, Connected = {12, 25, 29, 31, 34, 53}, Name = "Human Resources", Help = "+1 [ICON_PRODUCTION] Production from Military Bases and Armories.[NEWLINE][ICON_ITG_HEALTH_1] Healthy Cities gain +2 [ICON_PRODUCTION] Production.[NEWLINE][ICON_ITG_HEALTH_1] Health grants XP for trained units."},
{ID = 31, z = 2, x = 5, y = 4, R = 0, O = 2, F = 0, A = 1, L = 0, E = 1, S = 0, AIValueFunc = IDBmAIValFunc31, Connected = {26, 30, 54}, Name = "Precise Strike", Help = "Every attack in turn increases combat bonus of all ranged and air units by 5% (2% if attack was ranged)."},
{ID = 32, z = 2, x = 2, y = 5, R = 0, O = 0, F = 0, A = 2, L = 1, E = 1, S = 0, AIValueFunc = IDBmAIValFunc32, Connected = {28, 33, 56}, Name = "Big Stick Policy", Help = "Can turn conquered City-States into allies.[NEWLINE]+3 [ICON_INFLUENCE] Influence per turn if you can bully City-State.[NEWLINE]+0.02 [ICON_ITG_LEGAL_POWER] Legal Power per City-State you can bully."},
{ID = 33, z = 2, x = 3, y = 5, R = 0, O = 0, F = 0, A = 3, L = 0, E = 1, S = 0, AIValueFunc = IDBmAIValFunc33, Connected = {13, 29, 32, 34, 57}, Name = "Military State", Help = "[ICON_ITG_GOVERNOR] Governors generate a special diplomatic action with a reward on notable conquest of foreign City.[NEWLINE]+15% [ICON_HAPPINESS_1] Happiness chance if you legally claimed city ownership in last 8 turns.[NEWLINE]+0.1 [ICON_ITG_LEGAL_POWER] Legal Power per turn if you haven't lost a city in last 8 turns."},
{ID = 34, z = 2, x = 4, y = 5, R = 0, O = 1, F = 0, A = 2, L = 0, E = 1, S = 0, AIValueFunc = IDBmAIValFunc34, Connected = {30, 33, 58}, Name = "Patriotic War", Help = "Capturing Cities claim stored [ICON_WORKER] Work Rate and distribute it to other Cities.[NEWLINE]Cities may spend 100 [ICON_WORKER] Work Rate to avoid having their [ICON_ITG_DEFENSE_BROKEN] Defense broken or prevent destruction of Buildings from bombardment.[NEWLINE]Cities may repair Garrisons (up to 20 HP each turn) with [ICON_WORKER] Work Rate (1HP:4[ICON_WORKER]).[NEWLINE]Doubles max [ICON_WORKER] Work Rate that Cities can spend to repair damage each turn.[NEWLINE]Each time you spend 500 [ICON_WORKER] Work Rate on healing Garrisons or Cities you gain +1 [ICON_ITG_MORALE] Morale."},

{ID = 35, z = 3, x = 1, y = 1, R = 0, O = 0, F = 2, A = 0, L = 2, E = 0, S = 0, AIValueFunc = IDBmAIValFunc35, Connected = {36, 40}, Name = "War of Corporations", Help = "Extra combat bonus while fighting units of major civilizations with weaker [ICON_INVEST] Currency.[NEWLINE]+1 [ICON_ITG_MERITOCRACY] Meritocracy per turn and +10 [ICON_ITG_UNIFY] Unifying Presence if your [ICON_INVEST] Currency Power is above average.[NEWLINE]You can invest 1 extra token in Stock Exchange and earn +3 [ICON_ITG_CUSTOMS_HOUSE] upgrade points per turn in all Customs Houses if your [ICON_INVEST] Currency Power is not above average."},
{ID = 36, z = 3, x = 2, y = 1, R = 1, O = 0, F = 2, A = 0, L = 1, E = 0, S = 0, AIValueFunc = IDBmAIValFunc36, Connected = {14, 35, 37, 41, 60}, Name = "Trade Funds Guarantee", Help = "Trade units gain +4 [ICON_MOVES] Movement.[NEWLINE]-10% [ICON_GOLD] Gold from your Trade Routes.[NEWLINE]Every successfully established Trade Route increase chance to generate [ICON_HAPPINESS_1] Happiness by 0.5% up to +10% (resets if your Trade Route was plundered).[NEWLINE]International Trade-Routes boosts [ICON_ITG_MERITOCRACY] Meritocracy by 1 (if you have completed at least 20 Trade-Routes since last time your Trade-Route was pillaged).[NEWLINE]Cities generate +1 [ICON_CARAVAN] Land and [ICON_CARGO] Naval Trade-Route points if [ICON_ITG_MERITOCRACY] Meritocracy is above 50."},
{ID = 37, z = 3, x = 3, y = 1, R = 1, O = 0, F = 3, A = 0, L = 0, E = 0, S = 0 , AIValueFunc = IDBmAIValFunc37, Connected = {15, 36, 38, 42, 61}, Name = "Trade Convoys", Help = "25% chance to create an extra Trade Route (33% if City has Customs House)."},
{ID = 38, z = 3, x = 4, y = 1, R = 1, O = 1, F = 2, A = 0, L = 0, E = 0, S = 0, AIValueFunc = IDBmAIValFunc38, Connected = {16, 37, 39, 43, 62}, Name = "Unchained Capitalism", Help = "800 [ICON_WORKER] Work Rate may be spend to create Trade Routes.[NEWLINE]+3 [ICON_GOLD] Gold from unemployed Citizens.[NEWLINE]Rival Embargos are 50% less effective in reducing your [ICON_INVEST] Currency Power.[NEWLINE]Cities with [ICON_ITG_CUSTOMS_HOUSE] Customs House generate +10 [ICON_WORKER] Work Rate."},
{ID = 39, z = 3, x = 5, y = 1, R = 0, O = 2, F = 2, A = 0, L = 0, E = 0, S = 0, AIValueFunc = IDBmAIValFunc39, Connected = {38, 44}, Name = "Central Intelligence", Help = "Cost of acquiring new Agents reduced by half.[NEWLINE]New Agent starts with +10 XP for every active Agent.[NEWLINE]Agents' reorganization requires 1 turn less."},
{ID = 40, z = 3, x = 1, y = 2, R = 1, O = 0, F = 1, A = 0, L = 2, E = 0, S = 0, AIValueFunc = IDBmAIValFunc40, Connected = {17, 35, 41, 45, 63}, Name = "Provincial Life", Help = "Cities gain +1% [ICON_HAPPINESS_1] Happiness chance and +5% [ICON_CULTURE] Culture per larger City you control.[NEWLINE]Cities gain +4% [ICON_HAPPINESS_1] Happiness chance and +25% [ICON_CULTURE] Culture if they have no [ICON_ITG_ACADEMY_1] Academy, [ICON_ITG_CUSTOMS_HOUSE] Customs House and [ICON_ITG_MANUFACTORY] Manufactory.[NEWLINE]Cities gain +1% [ICON_HAPPINESS_1] Happiness chance and +5% [ICON_CULTURE] Culture per unimproved adjacent land tile."},
{ID = 41, z = 3, x = 2, y = 2, R = 2, O = 0, F = 1, A = 0, L = 1, E = 0, S = 0, AIValueFunc = IDBmAIValFunc41, Connected = {18, 36, 40, 42, 46, 64}, Name = "Liberty of Mind", Help = "While not in Anarchy 5% of stored [ICON_ITG_LEGAL_POWER] Legal Power (up to 0.15 [ICON_ITG_LEGAL_POWER]) is converted into [ICON_RESEARCH] Science, [ICON_GOLD] Gold and [ICON_CULTURE] Culture modifiers (up to +30%).[NEWLINE]+0.25 [ICON_ITG_LEGAL_POWER] Legal Power while at Anarchy."},
{ID = 42, z = 3, x = 3, y = 2, R = 2, O = 0, F = 2, A = 0, L = 0, E = 0, S = 0, AIValueFunc = IDBmAIValFunc42, Connected = {19, 37, 41, 43, 47, 65}, Name = "Technology-based economy", Help = "[ICON_INVEST] Currency bonus is also applied to [ICON_RESEARCH] Science (half value).[NEWLINE]Economic and Scientific branches of Academies contribute to [ICON_INVEST] Currency Power."},
{ID = 43, z = 3, x = 4, y = 2, R = 2, O = 1, F = 1, A = 0, L = 0, E = 0, S = 0, AIValueFunc = IDBmAIValFunc43, Connected = {20, 38, 42, 44, 48, 66}, Name = "Field hospital", Help = "Each turn total [ICON_ITG_HEALTH_1] Health is distributed to heal land units with less than 60% HP (capped by an invidual heal rate)."},
{ID = 44, z = 3, x = 5, y = 2, R = 1, O = 2, F = 1, A = 0, L = 0, E = 0, S = 0, AIValueFunc = IDBmAIValFunc44, Connected = {21, 39, 43, 49, 67}, Name = "Gunboat Diplomacy", Help = "Trade units gain +2 Sight and heal every turn with rate increased by 10.[NEWLINE]Upon establishing Trade Route units are replaced with a military unit (8T cooldown)."},
{ID = 45, z = 3, x = 1, y = 3, R = 1, O = 0, F = 0, A = 0, L = 3, E = 0, S = 0, AIValueFunc = IDBmAIValFunc45, Connected = {22, 40, 46, 50, 68}, Name = "Symbolism", Help = "Triples effect of Inspirations.[NEWLINE]+2 [ICON_HAPPINESS_1] Happiness when City constructs building with an Inspiration.[NEWLINE]+2 [ICON_HAPPINESS_4] Unhappiness when City sells building with an Inspiration."},
{ID = 46, z = 3, x = 2, y = 3, R = 2, O = 0, F = 0, A = 0, L = 2, E = 0, S = 0, AIValueFunc = IDBmAIValFunc46, Connected = {23, 41, 45, 47, 51, 69}, Name = "Academic freedom", Help = "Can choose from one extra technology upon discovery bonus.[NEWLINE]Grants extra reward upon discovering non-innovation Technology."},
{ID = 47, z = 3, x = 3, y = 3, R = 4, O = 0, F = 0, A = 0, L = 0, E = 0, S = 0, AIValueFunc = IDBmAIValFunc47, Connected = {24, 42, 46, 48, 52, 70}, Name = "Specialization", Help = "Specialists provide +2 [ICON_FOOD] Food and +1 of their respective yield."},
{ID = 48, z = 3, x = 4, y = 3, R = 2, O = 2, F = 0, A = 0, L = 0, E = 0, S = 0, AIValueFunc = IDBmAIValFunc48, Connected = {25, 43, 47, 49, 53, 71}, Name = "Steel intensity", Help = "[ICON_INVEST] Currency bonus is applied to [ICON_PRODUCTION] Production instead [ICON_GOLD] Gold."},
{ID = 49, z = 3, x = 5, y = 3, R = 1, O = 3, F = 0, A = 0, L = 0, E = 0, S = 0, AIValueFunc = IDBmAIValFunc49, Connected = {26, 44, 48, 54, 72}, Name = "Academic Network", Help = "Agents have increased chance to succeed if target location has Great Person from your empire.[NEWLINE]Caught Agents may still succeed by sacrificing 250 [ICON_GREAT_PEOPLE] Great People points.[NEWLINE]Caught Agents may still succeed if you own Academy with rank 3 or greater (that Academy looses 100 [ICON_ITG_PRESTIGE] Prestige)."},
{ID = 50, z = 3, x = 1, y = 4, R = 1, O = 0, F = 0, A = 1, L = 2, E = 0, S = 0, AIValueFunc = IDBmAIValFunc50, Connected = {27, 45, 51, 55, 73}, Name = "Fight Everywhere", Help = "+1 [ICON_STRENGTH] City Defense (up to +10 [ICON_STRENGTH]) for every attack made on this City (resets when City fully repairs).[NEWLINE]Cities below 50% HP may sacrifice [ICON_CITIZEN] Population for +50 Heal Rate.[NEWLINE]Combat including your fortified units generate 25% less damage."},
{ID = 51, z = 3, x = 2, y = 4, R = 2, O = 0, F = 0, A = 1, L = 1, E = 0, S = 0, AIValueFunc = IDBmAIValFunc51, Connected = {28, 46, 50, 52, 56, 74}, Name = "Finest Hour", Help = "Negative [ICON_ITG_MORALE] Morale grants chance to deal +100% Critical Strike and cannot [ICON_DENOUNCE] Demoralize units.[NEWLINE]Each turn for every 10% [ICON_ITG_MERITOCRACY] Meritocracy missing there is 1% chance to recover half of missing [ICON_ITG_MERITOCRACY] Meritocracy.[NEWLINE]Cities' heal rate is increased by 1 for every 20 HP missing."},
{ID = 52, z = 3, x = 3, y = 4, R = 2, O = 0, F = 0, A = 2, L = 0, E = 0, S = 0, AIValueFunc = IDBmAIValFunc52, Connected = {29, 47, 51, 53, 57, 75}, Name = "Healthy Competition", Help = "Every second Scientific bonus grants free Unitclass Promotion.[NEWLINE]Each time Commander's unit kills enemy (or notably conquer City) one other Commander receive +1 (+3) [ICON_STRENGTH] Combat Bonus (up to +17)."},
{ID = 53, z = 3, x = 4, y = 4, R = 2, O = 1, F = 0, A = 1, L = 0, E = 0, S = 0, AIValueFunc = IDBmAIValFunc53, Connected = {30, 48, 52, 54, 58, 76}, Name = "Cold War", Help = "Each time you obtain Scientific, General or Admiral bonus all units receive +1 [ICON_STRENGTH] Strength (up to +5 for a single unit)."},
{ID = 54, z = 3, x = 5, y = 4, R = 1, O = 2, F = 0, A = 1, L = 0, E = 0, S = 0, AIValueFunc = IDBmAIValFunc54, Connected = {31, 49, 53, 59, 77}, Name = "Order and Harmony", Help = "+1 [ICON_PRODUCTION] Production from Factories.[NEWLINE]+1% [ICON_PRODUCTION] Production per turn since last [ICON_RESISTANCE] Riots.[NEWLINE][ICON_HAPPINESS_4] Unhappiness chance reduced by 7% in Cities with [ICON_ITG_MANUFACTORY] Manufactory."},
{ID = 55, z = 3, x = 1, y = 5, R = 0, O = 0, F = 0, A = 2, L = 2, E = 0, S = 0, AIValueFunc = IDBmAIValFunc55, Connected = {50, 56}, Name = "First Line", Help = "+1 range and +33 HP for Forts and Citadels.[NEWLINE]-1% chance to generate [ICON_HAPPINESS_4] Unhappiness per active Fort (up to -10%).[NEWLINE]Units starting turn in Fort gain +2 [ICON_MOVES] Movement."},
{ID = 56, z = 3, x = 2, y = 5, R = 1, O = 0, F = 0, A = 2, L = 1, E = 0, S = 0, AIValueFunc = IDBmAIValFunc56, Connected = {32, 51, 55, 57, 78}, Name = "Arsenals of Liberty", Help = "+1 [ICON_PRODUCTION] Production from Arsenals.[NEWLINE]Training military units grants [ICON_ITG_PRESENCE] Cultural Presence and [ICON_CULTURE] Culture.[NEWLINE]+1 [ICON_ITG_UNIFY] Unifying Presence per 5 [ICON_STRENGTH] Defense in City with the greatest defense."},
{ID = 57, z = 3, x = 3, y = 5, R = 1, O = 0, F = 0, A = 3, L = 0, E = 0, S = 0, AIValueFunc = IDBmAIValFunc57, Connected = {33, 52, 56, 58, 79}, Name = "Lightning war", Help = "Provides an ability with 12 turns of cooldown: During this turn your units gain +2 [ICON_MOVES] Movement, ignore terrain cost and stacking rules, and claim forts instantly."},
{ID = 58, z = 3, x = 4, y = 5, R = 1, O = 1, F = 0, A = 2, L = 0, E = 0, S = 0, AIValueFunc = IDBmAIValFunc58, Connected = {34, 53, 57, 59, 80}, Name = "The Hunt for Scientists", Help = "Has 20% chance to gain 500% [ICON_RESEARCH] Science from kills.[NEWLINE]Yield 10x [ICON_RESEARCH] Science on notable City Conquest.[NEWLINE]Great People yielding [ICON_RESEARCH] Science cannot escape upon city capture."},
{ID = 59, z = 3, x = 5, y = 5, R = 0, O = 2, F = 0, A = 2, L = 0, E = 0, S = 0, AIValueFunc = IDBmAIValFunc59, Connected = {54, 58}, Name = "Authoritarianism", Help = "Cities with placed [ICON_ITG_GOVERNOR] Governor do not spawn rebels. If you are first in [ICON_ITG_AUTHORITY] Authority ranking this applies to all Cities.[NEWLINE]Each [ICON_ITG_GOVERNOR] Governor reduces training cost of one military unitclass by 30 [ICON_PRODUCTION] Production.[NEWLINE]You gain +50 [ICON_ITG_POWER] Power.[NEWLINE][ICON_ITG_GOVERNOR] Governors are more happy with current situation if you are first in [ICON_ITG_AUTHORITY] Authority ranking."},

{ID = 60, z = 4, x = 2, y = 1, R = 0, O = 0, F = 2, A = 0, L = 1, E = 0, S = 1, AIValueFunc = IDBmAIValFunc60, Connected = {36, 61, 64}, Name = "Pop-art", Help = "Each turn one random City gains additive [ICON_CULTURE] Culture multiplier equal to your current level of Art Style.[NEWLINE]+1% [ICON_HAPPINESS_1] Happiness, +2 [ICON_ITG_UNIFY] Unifying Presence and +5 [ICON_GREAT_ARTIST] Art points for each Art Style represented by your Great People.[NEWLINE]+20 [ICON_GREAT_PEOPLE] Great People points if your current Art Style is not represented by any of your Great People.[NEWLINE]Civilian Great People do not migrate if they are the only representants of their Art Style.[NEWLINE]Newly ascended civilian Great Person will be a cultural one if none of your Great People represents current Art Style."},
{ID = 61, z = 4, x = 3, y = 1, R = 0, O = 0, F = 3, A = 0, L = 0, E = 0, S = 1, AIValueFunc = IDBmAIValFunc61, Connected = {37, 60, 62, 65, 81}, Name = "Survival of the Finest", Help = "+4 [ICON_ITG_HEALTH_1] Health in top half Cities with greatest [ICON_GOLD] Gold income, -1 [ICON_ITG_HEALTH_3] Health in other Cities.[NEWLINE]+10% [ICON_HAPPINESS_1] Happiness chance in top half Cities with greatest [ICON_PRODUCTION] Production, -5% [ICON_HAPPINESS_1] Happiness in other Cities.[NEWLINE]+20% [ICON_FOOD] Food in top half Cities with greatest [ICON_WORKER] Work Rate, -10% [ICON_FOOD] Food in other Cities.[NEWLINE]+33% [ICON_CULTURE] Culture in top half Cities with greatest [ICON_ITG_PRESENCE] Cultural Presence, -15% [ICON_CULTURE] Culture in other Cities."},
{ID = 62, z = 4, x = 4, y = 1, R = 0, O = 1, F = 2, A = 0, L = 0, E = 0, S = 1, AIValueFunc = IDBmAIValFunc62, Connected = {38, 61, 66}, Name = "Pursuit of Happiness", Help = "Inflation does not affect [ICON_INVEST] Currency Power.[NEWLINE]Spies are more effective against players with Inflation.[NEWLINE]+2 local [ICON_HAPPINESS_1] Happiness and +10 [ICON_ITG_CHARM] Charm in the most wealthy city.[NEWLINE]+1 local [ICON_HAPPINESS_1] Happiness and +5 [ICON_ITG_CHARM] Charm in Cities with [ICON_ITG_CUSTOMS_HOUSE] Customs House."},
{ID = 63, z = 4, x = 1, y = 2, R = 0, O = 0, F = 1, A = 0, L = 2, E = 0, S = 1, AIValueFunc = IDBmAIValFunc63, Connected = {40, 64, 68}, Name = "Pantheon", Help = "Civilian Great People may retire, permanently increasing [ICON_GREAT_PEOPLE] Great People generation by 7 and granting an additional instant bonus based on Great Person type."},
{ID = 64, z = 4, x = 2, y = 2, R = 1, O = 0, F = 1, A = 0, L = 1, E = 0, S = 1, AIValueFunc = IDBmAIValFunc64, Connected = {41, 60, 63, 65, 69, 82}, Name = "Brave New World", Help = "Your turnly growth of [ICON_ITG_PRESENCE] Cultural Presence reduces foreign [ICON_ITG_PRESENCE] Presence in your Cities (50% effectiveness).[NEWLINE]Constructing building already present in all other cities grants +5 [ICON_HAPPINESS_1] Happiness and +100 [ICON_CULTURE] Culture (it works once per building type)."},
{ID = 65, z = 4, x = 3, y = 2, R = 1, O = 0, F = 2, A = 0, L = 0, E = 0, S = 1, AIValueFunc = IDBmAIValFunc65, Connected = {42, 61, 64, 66, 70, 83}, Name = "Great Purpose", Help = "+1 [ICON_ITG_ACADEMY_2] development in all Academies per Great Scientist.[NEWLINE]+1 [ICON_ITG_CUSTOMS_HOUSE] upgrade point in all Customs Houses per Great Statesman.[NEWLINE][ICON_PRODUCTION] Production bonus from activity period is increased by 5% in all [ICON_ITG_MANUFACTORY] Manufactories per Great Engineer.[NEWLINE]+20 [ICON_INVEST] Currency Power per Great Arist.[NEWLINE]+1% chance to obtain Innovation per Great Writer.[NEWLINE]+3 [ICON_ITG_UNIFY] Unifying Presence per Great Musician.[NEWLINE]Grants 5 [ICON_ITG_MERITOCRACY] Meritocracy anchor per Great Philosopher."},
{ID = 66, z = 4, x = 4, y = 2, R = 1, O = 1, F = 1, A = 0, L = 0, E = 0, S = 1, AIValueFunc = IDBmAIValFunc66, Connected = {43, 62, 65, 67, 71, 84}, Name = "Warfare-based Economy", Help = "Extra temporary [ICON_INVEST] Currency Power from defeating enemy units (25% chance for +100%[ICON_INVEST]), notable conquests (~50[ICON_INVEST]), building Forts (~75[ICON_INVEST]), claiming Forts (~25[ICON_INVEST]) and discovering technologies (~50[ICON_INVEST]).[NEWLINE][NEWLINE]Temporary modifiers to [ICON_INVEST] Currency Power last 10 turns."},
{ID = 67, z = 4, x = 5, y = 2, R = 0, O = 2, F = 1, A = 0, L = 0, E = 0, S = 1, AIValueFunc = IDBmAIValFunc67, Connected = {44, 66, 72}, Name = "Greener Grass", Help = "Up to +2% [ICON_ITG_FESTIVAL] Festival chance, +15% [ICON_PRODUCTION] Production modifier, 50 [ICON_ITG_MERITOCRACY] Meritocracy anchor and +2 [ICON_ITG_MORALE] Morale based on how happy empire is compared to other civilizations."},
{ID = 68, z = 4, x = 1, y = 3, R = 0, O = 0, F = 0, A = 0, L = 3, E = 0, S = 1, AIValueFunc = IDBmAIValFunc68, Connected = {45, 63, 69, 73, 85}, Name = "Social Celebrations", Help = "800 [ICON_WORKER] Work Rate may be spend to start a [ICON_ITG_FESTIVAL] Festival.[NEWLINE]Every [ICON_ITG_FESTIVAL] Festival started in a City permanently increases chance to generate [ICON_HAPPINESS_1] Happiness by 0.5%."},
{ID = 69, z = 4, x = 2, y = 3, R = 1, O = 0, F = 0, A = 0, L = 2, E = 0, S = 1, AIValueFunc = IDBmAIValFunc69, Connected = {46, 64, 68, 70, 74, 86}, Name = "Primal Capitalism", Help = "+5% [ICON_HAPPINESS_1] Happiness chance, +2 [ICON_ITG_MERITOCRACY] Meritocracy and +0.2% chance to acquire next [ICON_ITG_FESTIVAL] Festival if [ICON_GOLD] Gold income is greater than last turn.[NEWLINE]Starvation does not cause Citizens to migrate."},
{ID = 70, z = 4, x = 3, y = 3, R = 2, O = 0, F = 0, A = 0, L = 0, E = 0, S = 2, AIValueFunc = IDBmAIValFunc70, Connected = {47, 65, 69, 71, 75, 87}, Name = "Science in service", Help = "+2 [ICON_ITG_HEALTH_1] Health and +10 [ICON_WORKER] Work Rate in Cities with [ICON_ITG_ACADEMY_1] Academy.[NEWLINE]Cities gain +1 [ICON_PRODUCTION] Production per 25 [ICON_RESEARCH] Science.[NEWLINE]Whenever you reach half progress towards next Scientific bonus your [ICON_ITG_GOVERNOR] Governors generate special diplomatic reward."},
{ID = 71, z = 4, x = 4, y = 3, R = 1, O = 2, F = 0, A = 0, L = 0, E = 0, S = 1, AIValueFunc = IDBmAIValFunc71, Connected = {48, 66, 70, 72, 76, 88}, Name = "Planned economy", Help = "Internal Trade-Routes yield +100% [ICON_FOOD] Food and [ICON_PRODUCTION] Production, but -33% [ICON_GOLD] Gold.[NEWLINE]Capital City and Cities connected to it with Industrial route generate +10% [ICON_FOOD] Food and [ICON_PRODUCTION] Production, but -10% [ICON_GOLD] Gold.[NEWLINE]Capital City and Cities with placed [ICON_ITG_GOGVERNOR] Governor generate +10% [ICON_FOOD] Food and [ICON_PRODUCTION] Production, but -10% [ICON_GOLD] Gold.[NEWLINE]Your Trade-Routes are more likely to target your Cities (+30[ICON_TRADE_WHITE])."},
{ID = 72, z = 4, x = 5, y = 3, R = 0, O = 3, F = 0, A = 0, L = 0, E = 0, S = 1, AIValueFunc = IDBmAIValFunc72, Connected = {49, 67, 71, 77, 89}, Name = "Labouring Class", Help = "+2 [ICON_PRODUCTION] Production in Cities with positive [ICON_ITG_HEALTH_1] Health.[NEWLINE][ICON_ITG_MANUFACTORY] Manufactories yield [ICON_FOOD] Food and [ICON_CULTURE] Culture equal to [ICON_PRODUCTION] Production."},
{ID = 73, z = 4, x = 1, y = 4, R = 0, O = 0, F = 0, A = 1, L = 2, E = 0, S = 1, AIValueFunc = IDBmAIValFunc73, Connected = {50, 68, 74}, Name = "Extraordinary Leadership", Help = "Cities under [ICON_ITG_GOVERNOR] Governor's influence gain +1 [ICON_ITG_CHARM] Charm per 8 [ICON_ITG_POWER] Power.[NEWLINE]Governors expand 10-range sphere of inluence (greater [ICON_ITG_POWER] Power claims ownership over plots contested by multiple [ICON_ITG_GOVERNOR] Governors) in which:[NEWLINE][ICON_BULLET]Your combat units have 20% chance for critical bonus equal to [ICON_ITG_GOVERNOR] Governor's [ICON_ITG_POWER] Power.[NEWLINE][ICON_BULLET]Rival Cities generate +5 [ICON_ITG_PRESENCE] Cultural Presence if their [ICON_ITG_GOVERNOR] Governor has less [ICON_ITG_POWER] Power."},
{ID = 74, z = 4, x = 2, y = 4, R = 1, O = 0, F = 0, A = 1, L = 1, E = 0, S = 1, AIValueFunc = IDBmAIValFunc74, Connected = {51, 69, 73, 75, 78, 90}, Name = "Heavy military", Help = "Siege units have 33% chance that they will damage all Units on target plot.[NEWLINE]Siege and Air units have 15% chance to damage units adjacent to target (with 50% damage).[NEWLINE]Ranged units have 25% chance that they will damage all Units on target plot (with 50% damage)."},
{ID = 75, z = 4, x = 3, y = 4, R = 1, O = 0, F = 0, A = 2, L = 0, E = 0, S = 1, AIValueFunc = IDBmAIValFunc75, Connected = {52, 70, 74, 76, 79, 91}, Name = "Law Supremacy", Help = "Rival players receive -5% [ICON_ITG_LAWS_INFLUENCE] Codex Influence each time you legalize occupied City.[NEWLINE]Gain a random yield bonus each time you spend 15 [ICON_ITG_LEGAL_POWER] Legal Power.[NEWLINE]+1 [ICON_ITG_MERITOCRACY] Meritocracy per turn and +5 [ICON_ITG_AUTHORITY] Authority if you have the strongest [ICON_ITG_CODEX] Codex."},
{ID = 76, z = 4, x = 4, y = 4, R = 1, O = 1, F = 0, A = 1, L = 0, E = 0, S = 1, AIValueFunc = IDBmAIValFunc76, Connected = {53, 71, 75, 77, 80, 92}, Name = "Combined Intelligence", Help = "Allows using Agents on Support action that will increase effectiveness of other Agents.[NEWLINE]For every active Agent unit combat is more lucky.[NEWLINE]Agents gain +3XP per turn if there is more experienced Agent."},
{ID = 77, z = 4, x = 5, y = 4, R = 0, O = 2, F = 0, A = 1, L = 0, E = 0, S = 1, AIValueFunc = IDBmAIValFunc77, Connected = {54, 72, 76}, Name = "Natural Expansion", Help = "Provides 1-range vision around 5 rival Cities closest to your starting position. Those Cities have [ICON_RESISTANCE] Riots' strength increased by 5. Attacking such City has +20% chance to [ICON_ITG_DEFENSE_BROKEN] break City defenses. Capturing such City increases your [ICON_ITG_PRESENCE] Cultural Presence there to 300."},
{ID = 78, z = 4, x = 2, y = 5, R = 0, O = 0, F = 0, A = 2, L = 1, E = 0, S = 1, AIValueFunc = IDBmAIValFunc78, Connected = {56, 74, 79}, Name = "War Never Ends", Help = "+1 [ICON_ITG_MERITOCRACY] Meritocracy for every 20 attacks made in last turn.[NEWLINE]+1% [ICON_PRODUCTION] Production for every attack received in last turn (up to +50%).[NEWLINE]+5% chance to generate [ICON_ITG_MORALE] Morale for every unit defeated or lost in last turn."},
{ID = 79, z = 4, x = 3, y = 5, R = 0, O = 0, F = 0, A = 3, L = 0, E = 0, S = 1, AIValueFunc = IDBmAIValFunc79, Connected = {57, 75, 78, 80, 93}, Name = "Police State", Help = "+1 [ICON_PRODUCTION] Production from Police Station.[NEWLINE]+1 [ICON_ITG_MERITOCRACY] Meritocracy per turn if you have 10 [ICON_ITG_MORALE] Morale or more.[NEWLINE]50% chance to prevent Great People from migrating away (it will reset [ICON_TOURISM] migration meter to 0)."},
{ID = 80, z = 4, x = 4, y = 5, R = 0, O = 1, F = 0, A = 2, L = 0, E = 0, S = 1, AIValueFunc = IDBmAIValFunc80, Connected = {58, 76, 79}, Name = "General staff", Help = "Newly ascended civilian Great People have chance to become Great General or Admiral.[NEWLINE]Great Generals' and Admirals' leadership bonuses are stackable.[NEWLINE]+10 defense against Assassination."},

{ID = 81, z = 5, x = 3, y = 1, R = 0, O = 0, F = 2, A = 0, L = 0, E = 0, S = 2, AIValueFunc = IDBmAIValFunc81, Connected = {61, 83}, Name = "Megalomania", Help = "Every 17th receive a random yield bonus.[NEWLINE]Tresholds of all yield bonuses are reduced by 4%."},
{ID = 82, z = 5, x = 2, y = 2, R = 0, O = 0, F = 1, A = 0, L = 1, E = 0, S = 2, AIValueFunc = IDBmAIValFunc82, Connected = {64, 83, 86}, Name = "Megacities", Help = "+1% [ICON_PRODUCTION] Production and [ICON_FOOD] Food per Citizen.[NEWLINE]+1 [ICON_ITG_HEALTH_1] Health for every 7 [ICON_CITIZEN] Citizens in a City.[NEWLINE]Citizens are more likely to migrate to large cities."},
{ID = 83, z = 5, x = 3, y = 2, R = 0, O = 0, F = 1, A = 0, L = 0, E = 0, S = 3, AIValueFunc = IDBmAIValFunc83, Connected = {65, 81, 82, 84, 87}, Name = "Hidden Masterminds", Help = "Espionage actions take one turn less to complete.[NEWLINE][ICON_RESISTANCE] Riots' strength is increased by 3 for players without this Ideology.[NEWLINE]+20 [ICON_INFLUENCE] Influence with City-State each time it [ICON_RESISTANCE] Riots.[NEWLINE]-50 [ICON_ITG_POWER] Power for players without this Ideology."},
{ID = 84, z = 5, x = 4, y = 2, R = 0, O = 1, F = 1, A = 0, L = 0, E = 0, S = 2, AIValueFunc = IDBmAIValFunc84, Connected = {66, 83, 88}, Name = "World Leadership", Help = "+50 [ICON_INFLUENCE] Influence anchor with all City-States.[NEWLINE]+100% [ICON_INFLUENCE] Influence recovery mod.[NEWLINE]Triple [ICON_INFLUENCE] Influence from improving relations if City-State is not friendly."},
{ID = 85, z = 5, x = 1, y = 3, R = 0, O = 0, F = 0, A = 0, L = 2, E = 0, S = 2, AIValueFunc = IDBmAIValFunc85, Connected = {68, 86}, Name = "Merciless", Help = "Victorious melee attack has 33% chance to ignore damage taken.[NEWLINE]Victorious melee attack has 33% chance to deal double damage.[NEWLINE]During melee attack [ICON_ITG_MORALE] Morale difference grants chance to perform +100% Critical Strike."},
{ID = 86, z = 5, x = 2, y = 3, R = 0, O = 0, F = 0, A = 0, L = 1, E = 0, S = 3, AIValueFunc = IDBmAIValFunc86, Connected = {69, 82, 85, 87, 90}, Name = "Eureka", Help = "Great People yield no [ICON_RESEARCH] Science, instead they have chance for scientific outbreak: +1000 [ICON_RESEARCH] Science, +3% [ICON_ITG_MORALE] Morale and +8 [ICON_ITG_MERITOCRACY] Meritocracy."},
{ID = 87, z = 5, x = 3, y = 3, R = 1, O = 0, F = 0, A = 0, L = 0, E = 0, S = 3, AIValueFunc = IDBmAIValFunc87, Connected = {70, 83, 86, 88, 91}, Name = "Age of Reason", Help = "Cities gain increased [ICON_RESEARCH] Science, [ICON_GOLD] Gold and [ICON_PRODUCTION] Production modifiers based on number of Great People:[NEWLINE][ICON_BULLET](1) +5%[NEWLINE][ICON_BULLET](2) +15%[NEWLINE][ICON_BULLET](3+) +33%"},
{ID = 88, z = 5, x = 4, y = 3, R = 0, O = 1, F = 0, A = 0, L = 0, E = 0, S = 3, AIValueFunc = IDBmAIValFunc88, Connected = {71, 84, 87, 89, 92}, Name = "Soil of the Earth", Help = "+5 [ICON_GREAT_PEOPLE] Great People points per allied City-State.[NEWLINE]+2 [ICON_INFLUENCE] Influence anchor within all City-States per Great Person.[NEWLINE]+10 [ICON_ITG_ACADEMY_1] Prestige anchor in all Academies per Great Person.[NEWLINE]Relations with random [ICON_CITY_STATE] City-State is improved and [ICON_ITG_MERITOCRACY] Meritocracy is increased by 8 whenever a new civilian Great Person ascends."},
{ID = 89, z = 5, x = 5, y = 3, R = 0, O = 2, F = 0, A = 0, L = 0, E = 0, S = 2, AIValueFunc = IDBmAIValFunc89, Connected = {72, 88}, Name = "National Mission", Help = "Can choose talent of civilian [ICON_GREAT_PEOPLE] Great Person from one more option for each active [ICON_ITG_GOVERNOR] Governor.[NEWLINE][ICON_GREAT_PEOPLE] Great People treshold is automatically reached if you haven't reached it in last 17 turns.[NEWLINE]Reassigning [ICON_ITG_GOVERNOR] Governors' cooldown is reduced by 10 turns.[NEWLINE]Whenever your [ICON_GREAT_PEOPLE] Great Person migrates from your City to foreign City, your [ICON_ITG_PRESENCE] Presence is boosted by 200 in foreign City."},
{ID = 90, z = 5, x = 2, y = 4, R = 0, O = 0, F = 0, A = 1, L = 1, E = 0, S = 2, AIValueFunc = IDBmAIValFunc90, Connected = {74, 86, 91}, Name = "Military Tradition", Help = "Units with Great General or Admiral gain +20% [ICON_STRENGTH] Combat Bonus.[NEWLINE]+1% chance to deal +200% critical for every combat without dealing this critical.[NEWLINE]Combat bonus from veterancy is exponentially increased."},
{ID = 91, z = 5, x = 3, y = 4, R = 0, O = 0, F = 0, A = 1, L = 0, E = 0, S = 3, AIValueFunc = IDBmAIValFunc91, Connected = {75, 87, 90, 92, 93}, Name = "Nationalism", Help = "Great People originating from your empire do not migrate away and cannot be bribed.[NEWLINE]+1 [ICON_GREAT_PEOPLE] Great People point per civilian Great Person.[NEWLINE]Newly ascended Great People grant 4 more basic yields."},
{ID = 92, z = 5, x = 4, y = 4, R = 0, O = 1, F = 0, A = 1, L = 0, E = 0, S = 2, AIValueFunc = IDBmAIValFunc92, Connected = {76, 88, 91}, Name = "Glorious Past", Help = "Every 30th turn rebuilt ruins of Wonder (+15 [ICON_ITG_MERITOCRACY] Meritocracy when it happens)."},
{ID = 93, z = 5, x = 3, y = 5, R = 0, O = 0, F = 0, A = 2, L = 0, E = 0, S = 2, AIValueFunc = IDBmAIValFunc93, Connected = {79, 91}, Name = "Total War", Help = "+1 [ICON_PRODUCTION] Production from Military Academies.[NEWLINE]Great General or Admiral bonuses' treshold cannot be larger than 500.[NEWLINE]Allows obtaining Total War with Admiral and General bonuses: +1% [ICON_ITG_MORALE] Morale and +3 [ICON_ITG_MERITOCRACY] Meritocracy per alive General and Admiral (up to 10x)."},
}

function GetCivilopediaIdeologies()
	local tab = {}
	for i, v in pairs(IdeologyDB) do
		table.insert(tab, {ID = i, Name = v.Name})
	end
	return tab;
end

function GetIdeologyLettersString(ideoID)
	local posID = GetPositionOfIdeology(ideoID);
	local hRs = ""
	for l, sIcon in pairs(ideostringTab) do
		if IdeologyDB[posID][l] > 0 then
			if hRs ~= "" then
				hRs = hRs .. " ";
			end
			hRs = hRs .. IdeologyDB[posID][l] .. sIcon;
		end
	end
	return hRs;
end

function GetIdeologyCivilopedia(id)
	return {Name = IdeologyDB[id].Name, Help = IdeologyDB[id].Help}
end

function MinorIdeologyTenetAIValue1(iPlayer)
	return GetAIFlavour(iPlayer, "FLAVOR_SCIENCE") + GetAIFlavour(iPlayer, "FLAVOR_GREAT_PEOPLE");
end
function MinorIdeologyTenetAIValue2(iPlayer)
	return GetAIFlavour(iPlayer, "FLAVOR_HAPPINESS") + GetAIFlavour(iPlayer, "FLAVOR_ESPIONAGE");
end
function MinorIdeologyTenetAIValue3(iPlayer)
	return GetAIFlavour(iPlayer, "FLAVOR_MILITARY_TRAINING") + GetAIFlavour(iPlayer, "FLAVOR_OFFENSE");
end
function MinorIdeologyTenetAIValue4(iPlayer)
	return GetAIFlavour(iPlayer, "FLAVOR_GOLD") + GetAIFlavour(iPlayer, "FLAVOR_EXPANSION");
end
function MinorIdeologyTenetAIValue5(iPlayer)
	return GetAIFlavour(iPlayer, "FLAVOR_CULTURE") + GetAIFlavour(iPlayer, "FLAVOR_DIPLOMACY");
end
function MinorIdeologyTenetAIValue6(iPlayer)
	return GetAIFlavour(iPlayer, "FLAVOR_GREAT_PEOPLE") + GetAIFlavour(iPlayer, "FLAVOR_HAPPINESS");
end
function MinorIdeologyTenetAIValue7(iPlayer)
	return GetAIFlavour(iPlayer, "FLAVOR_CULTURE") + GetAIFlavour(iPlayer, "FLAVOR_HAPPINESS");
end
function MinorIdeologyTenetAIValue8(iPlayer)
	return GetAIFlavour(iPlayer, "FLAVOR_OFFENSE") + GetAIFlavour(iPlayer, "FLAVOR_DEFENSE");
end
function MinorIdeologyTenetAIValue9(iPlayer)
	return GetAIFlavour(iPlayer, "FLAVOR_INFRASTRUCTURE") + GetAIFlavour(iPlayer, "FLAVOR_DEFENSE");
end
function MinorIdeologyTenetAIValue10(iPlayer)
	return GetAIFlavour(iPlayer, "FLAVOR_HAPPINESS") + GetAIFlavour(iPlayer, "FLAVOR_OFFENSE");
end
function MinorIdeologyTenetAIValue11(iPlayer)
	return GetAIFlavour(iPlayer, "FLAVOR_MILITARY_TRAINING") + GetAIFlavour(iPlayer, "FLAVOR_OFFENSE");
end
function MinorIdeologyTenetAIValue12(iPlayer)
	return GetAIFlavour(iPlayer, "FLAVOR_CULTURE") + GetAIFlavour(iPlayer, "FLAVOR_DIPLOMACY");
end
function MinorIdeologyTenetAIValue13(iPlayer)
	return GetAIFlavour(iPlayer, "FLAVOR_GREAT_PEOPLE") + GetAIFlavour(iPlayer, "FLAVOR_OFFENSE");
end
function MinorIdeologyTenetAIValue14(iPlayer)
	return GetAIFlavour(iPlayer, "FLAVOR_PRODUCTION") * 2;
end
function MinorIdeologyTenetAIValue15(iPlayer)
	return GetAIFlavour(iPlayer, "FLAVOR_HAPPINESS") + GetAIFlavour(iPlayer, "FLAVOR_DIPLOMACY");
end
function MinorIdeologyTenetAIValue16(iPlayer)
	return GetAIFlavour(iPlayer, "FLAVOR_INFRASTRUCTURE") + GetAIFlavour(iPlayer, "FLAVOR_GROWTH");
end
function MinorIdeologyTenetAIValue17(iPlayer)
	return GetAIFlavour(iPlayer, "FLAVOR_MILITARY_TRAINING") + GetAIFlavour(iPlayer, "FLAVOR_OFFENSE");
end
function MinorIdeologyTenetAIValue18(iPlayer)
	return GetAIFlavour(iPlayer, "FLAVOR_GOLD") * 2;
end
function MinorIdeologyTenetAIValue19(iPlayer)
	return GetAIFlavour(iPlayer, "FLAVOR_CULTURE") + GetAIFlavour(iPlayer, "FLAVOR_DIPLOMACY");
end
function MinorIdeologyTenetAIValue20(iPlayer)
	return GetAIFlavour(iPlayer, "FLAVOR_GREAT_PEOPLE") * 2;
end
function MinorIdeologyTenetAIValue21(iPlayer)
	return GetAIFlavour(iPlayer, "FLAVOR_PRODUCTION") + GetAIFlavour(iPlayer, "FLAVOR_GROWTH");
end
local MinorIdeologyTenetDB = {
{ID = 1, Scenario = 3, Ideology = "R", Name = "Mind and Matter", Help = "+0.75 [ICON_RESEARCH] Science per [ICON_CITIZEN] Citizen during [ICON_GOLDEN_AGE] Golden Age. Length of [ICON_GOLDEN_AGE] Golden Ages is increased by 2.", AIValueFunc = MinorIdeologyTenetAIValue1, OnGoldenAge = true},
{ID = 2, Scenario = 3, Ideology = "O", Name = "Prosperity of Joy", Help = "-33% chance to generate [ICON_HAPPINESS_4] Unhappiness and increased chances to detect rival spies during [ICON_GOLDEN_AGE] Golden Age." , AIValueFunc = MinorIdeologyTenetAIValue2},
{ID = 3, Scenario = 3, Ideology = "A", Name = "Mobilization", Help = "+1% [ICON_ITG_MORALE] Morale per turn and +15XP for all trained units during [ICON_GOLDEN_AGE] Golden Age.", AIValueFunc = MinorIdeologyTenetAIValue3},
{ID = 4, Scenario = 3, Ideology = "F", Name = "Great Expansion", Help = "+3 [ICON_CARAVAN] Land and [ICON_CARGO] Naval points if City generates at least one adequate point and +15 [ICON_TRADE_WHITE] Trade Appeal during [ICON_GOLDEN_AGE] Golden Age.", AIValueFunc = MinorIdeologyTenetAIValue4},
{ID = 5, Scenario = 3, Ideology = "L", Name = "Time of Words", Help = "+7 [ICON_ITG_PRESENCE] Cultural Presence per turn and +33% [ICON_ITG_UNIFY] Unifying Presence during [ICON_GOLDEN_AGE] Golden Age.", AIValueFunc = MinorIdeologyTenetAIValue5},
{ID = 6, Scenario = 3, Ideology = "S", Name = "Boundless Minds", Help = "Yields from civilian [ICON_GREAT_PEOPLE] Great People doubled and +5 [ICON_ITG_ACADEMY_1] Prestige in all Academies during [ICON_GOLDEN_AGE] Golden Age.", AIValueFunc = MinorIdeologyTenetAIValue6},
{ID = 7, Scenario = 3, Ideology = "E", Name = "Holiday for Masses", Help = "An extra +2 [ICON_ITG_MERITOCRACY] Meritocracy per turn and +1% chance to obtain new [ICON_ITG_FESTIVAL] Festival during [ICON_GOLDEN_AGE] Golden Age.", AIValueFunc = MinorIdeologyTenetAIValue7, OnGoldenAge = true},
{ID = 8, Scenario = 2, Ideology = "R", Name = "Securing Area", Help = "Upon notable City Conquest deals 35 damage to nearby enemy units.", AIValueFunc = MinorIdeologyTenetAIValue8},
{ID = 9, Scenario = 2, Ideology = "O", Name = "New City Order", Help = "Upon notable City Conquest reduces [ICON_RESISTANCE] Resistance turns to 1 and repairs half damage of City.", AIValueFunc = MinorIdeologyTenetAIValue9},
{ID = 10, Scenario = 2, Ideology = "A", Name = "Action before Promise", Help = "Upon notable City Conquest 5 [ICON_HAPPINESS_1] Happiness is distributed between other Cities.", AIValueFunc = MinorIdeologyTenetAIValue10},
{ID = 11, Scenario = 2, Ideology = "F", Name = "Partisans", Help = "Upon notable City Conquest a free military unit will spawn (an additional unit spawns if city was legally or culturally occupied). Does not work if you have negative [ICON_ITG_SUPPLY] Unit Supply.", AIValueFunc = MinorIdeologyTenetAIValue11},
{ID = 12, Scenario = 2, Ideology = "L", Name = "Cultural Liberation", Help = "Upon notable City Conquest 150 [ICON_ITG_PRESENCE] Cultural Presence is added to City.", AIValueFunc = MinorIdeologyTenetAIValue12},
{ID = 13, Scenario = 2, Ideology = "S", Name = "Strategic Approach", Help = "Upon notable City Conquest you gain +75 [ICON_GREAT_GENERAL] General or [ICON_GREAT_ADMIRAL] Admiral points.", AIValueFunc = MinorIdeologyTenetAIValue13},
{ID = 14, Scenario = 2, Ideology = "E", Name = "Step Forward", Help = "Upon notable City Conquest the City's production is increased by 100% for 15 turns.", AIValueFunc = MinorIdeologyTenetAIValue14},
{ID = 15, Scenario = 1, Ideology = "R", Name = "Ashes in Shadow", Help = "Cities with World Wonder or ruins of Wonder provide +15% [ICON_ITG_LAWS_INFLUENCE] Codex Influence and +1 [ICON_ITG_AUTHORITY] Authority.", AIValueFunc = MinorIdeologyTenetAIValue15},
{ID = 16, Scenario = 1, Ideology = "O", Name = "Monumental Work", Help = "Cities with World Wonder or ruins of Wonder generate +20 [ICON_WORKER] Work Rate per turn.", AIValueFunc = MinorIdeologyTenetAIValue16},
{ID = 17, Scenario = 1, Ideology = "A", Name = "Prism of Spirit", Help = "Cities with World Wonder or ruins of Wonder grant +20 XP for all trained units.", AIValueFunc = MinorIdeologyTenetAIValue17},
{ID = 18, Scenario = 1, Ideology = "F", Name = "New Beginnings", Help = "Cities with World Wonder or ruins of Wonder generate +10% [ICON_GOLD] Gold.", AIValueFunc = MinorIdeologyTenetAIValue18, WonderDirty = true},
{ID = 19, Scenario = 1, Ideology = "L", Name = "Ancestors' Story", Help = "Cities with World Wonder or ruins of Wonder generate +4 [ICON_ITG_PRESENCE] Cultural Presence per turn.", AIValueFunc = MinorIdeologyTenetAIValue19},
{ID = 20, Scenario = 1, Ideology = "S", Name = "Challenge of Past", Help = "Cities with World Wonder or ruins of Wonder generate +3 [ICON_GREAT_PEOPLE] Great People points per turn.", AIValueFunc = MinorIdeologyTenetAIValue20},
{ID = 21, Scenario = 1, Ideology = "E", Name = "Shape and Form", Help = "Cities with World Wonder or ruins of Wonder have reduced chance for buildings to be destroyed in [ICON_RESISTANCE] Riots or sabotaged.", AIValueFunc = MinorIdeologyTenetAIValue21, WonderDirty = true},
}

function GetCivilopediaMinorIdeologies()
	local tab = {}
	for i, v in pairs(MinorIdeologyTenetDB) do
		table.insert(tab, {ID = i, Name = v.Name})
	end
	return tab;
end

function GetMinorIdeologyCivilopedia(id)
	return {Name = MinorIdeologyTenetDB[id].Name, Help = MinorIdeologyTenetDB[id].Help}
end

function GetTabOfEraMinorIdeologies(h)
	local t ={}
	for i, data in pairs(MinorIdeologyTenetDB) do
		if data.Scenario == h then
			table.insert(t, i)
		end
	end
	return t;
end

function GetPlayerNiceCivName(i)
	if Game.GetActivePlayer() == i then
		return "You"
	elseif Teams[Game.GetActiveTeam()]:IsHasMet(Players[i]:GetTeam()) then
		return Players[i]:GetCivilizationShortDescription()
	end
	return "Unknown Player"
end

function GetMiniIdeologyDB()
	return MinorIdeologyTenetDB
end

function GetMinorIdeologyDBRow(i)
	return MinorIdeologyTenetDB[i]
end

function GetIdeologyDBRow(i)
	return IdeologyDB[i];
end

function GetIdeologyDB()
	return IdeologyDB;
end

function GetPrintData(id)
	local c = ", Connected = {"
	local bFirst = true;
	for i, data in pairs(IdeologyDB) do
		if math.abs(data.z - IdeologyDB[id].z) + math.abs(data.y - IdeologyDB[id].y) + math.abs(data.x - IdeologyDB[id].x) == 1 then
			if bFirst then
				c = c .. i
				bFirst = false;
			else
				c = c .. ", " .. i
			end
		end
	end
	return c .. "}"
end

local tabOfCoreHeavy = {A = "Autocracy", O = "Union", E = "Party", L = "States", F = "Coalition", S = "Leadership", R = "Group"}
local tabOfCoreMedium = {AxO = "Fatherland", AxE = "Majority", AxL = "Dawn", AxF = "Segregation", AxS = "Force", AxR = "Front", OxE = "Motherland", OxL = "Balance", OxF = "People", OxS = "Nations", OxR = "Order", ExL = "Commune", ExF = "Gathering", ExS = "Revolution", ExR = "Equality", LxF = "Anarchy", LxS = "Pride", LxR = "Liberty", FxS = "Oligarchy", FxR = "Freedom", SxR = "Enlightment"}
local tabOfCoreRandom = {"Movement", "Friendship", "Land", "Cities", "Project", "League", "Alliance"}
local SuffixTabES = {"Fraternity", "Brotherhood", "Comrades", "Compatriots", "Citizens", "Masses", "Heroes", "Gentlemen", "Elite", "Overlords", "Master Race"}
local SuffixTabAF = {"World Order", "Entity", "Empire", "Eagles", "Country", "Realm", "Beginning", "Rights", "Horizon", "Future", "Opportunities"}
local SuffixTabOL = {"New Tomorrow", "Peace", "Work", "Socialism", "Control", "Justice", "Independence", "Autonomy", "Dawn", "Sovereignty", "Emancipation"}
local prefixTabES = {"Egalitarian", "Communist", "Undivided", "United", "Popular", "Natural", "National", "Ultimate", "Unconditional", "Highest", "Supreme"}
local prefixTabAF = {"Fanatical", "Loyalist", "Absolute", "Protective", "Rightful", "General", "Civilized", "Revolutionary", "Untamed", "Free", "Lawless"}
local prefixTabOL = {"Universal", "Eternal", "Sovereign", "Collaborative", "Joint", "Common", "Singular", "Federal", "Independent", "Borderless", "Radical"}

function GetIdeologyName(iPlayer, ideologiesTab)
	local tTab = {}
	for h, v in pairs(ideologiesTab) do
		table.insert(tTab, {h,v})
	end
	local core;
	table.sort(tTab, SortFunctionForGreaterInteger2)
	if tTab[1][2] ~= tTab[2][2] then
		core = tabOfCoreHeavy[tTab[1][1]]
	else
		if tTab[1][2] == tTab[3][2] then
			core = tabOfCoreRandom[LastRandom(1,#tabOfCoreRandom)];
		else
			core = tabOfCoreMedium[tTab[1][1] .. "x" .. tTab[2][1]] or tabOfCoreMedium[tTab[2][1] .. "x" .. tTab[1][1]]
		end
	end
	local OLdifference = math.max(math.min(5, ideologiesTab.O - ideologiesTab.L), -5);
	local AFdifference = math.max(math.min(5, ideologiesTab.A - ideologiesTab.F), -5);
	local ESdifference = math.max(math.min(5, ideologiesTab.E - ideologiesTab.S), -5);
	local precore;
	local presuffix;
	local suffix;
	if (math.abs(ESdifference) > math.abs(AFdifference)) or (math.abs(ESdifference) == math.abs(AFdifference) and LastRandom(1, 2) == 2) then
		if (math.abs(ESdifference) > math.abs(OLdifference)) or (math.abs(ESdifference) == math.abs(OLdifference) and LastRandom(1, 2) == 2) then
			suffix = SuffixTabES[ESdifference + 6]
			if LastRandom(1, 2) == 2 then
				precore = prefixTabAF[AFdifference + 6]
				presuffix = prefixTabOL[OLdifference + 6]
			else
				presuffix = prefixTabAF[AFdifference + 6]
				precore = prefixTabOL[OLdifference + 6]
			end
		else
			suffix = SuffixTabOL[OLdifference + 6]
			if LastRandom(1, 2) == 2 then
				precore = prefixTabES[ESdifference + 6]
				presuffix = prefixTabAF[AFdifference + 6]
			else
				presuffix = prefixTabES[ESdifference + 6]
				precore = prefixTabAF[AFdifference + 6]
			end
		end
	elseif (math.abs(OLdifference) > math.abs(AFdifference)) or (math.abs(OLdifference) == math.abs(AFdifference) and LastRandom(1, 2) == 2) then
		suffix = SuffixTabAF[AFdifference + 6]
		if LastRandom(1, 2) == 2 then
			precore = prefixTabES[ESdifference + 6]
			presuffix = prefixTabOL[OLdifference + 6]
		else
			presuffix = prefixTabES[ESdifference + 6]
			precore = prefixTabOL[OLdifference + 6]
		end
	else
		suffix = SuffixTabOL[OLdifference + 6]
		if LastRandom(1, 2) == 2 then
			precore = prefixTabES[ESdifference + 6]
			presuffix = prefixTabAF[AFdifference + 6]
		else
			presuffix = prefixTabES[ESdifference + 6]
			precore = prefixTabAF[AFdifference + 6]
		end
	end
	precore = (precore or "Error X1");
	core = (core or "Error X2");
	presuffix = (presuffix or "Error X3");
	suffix = (suffix or "Error X4");
	return precore .. " " .. core .. " of " .. presuffix .. " " .. suffix    
end

function GetIdeoBonusesHelp(iPlayer, tab)
	for ideo, sth in pairs(gT.Players[iPlayer].HasIdeology) do
		table.insert(tab, {Name = IdeologyDB[ideo].Name, Help = IdeologyDB[ideo].Help})
	end
	return tab;
end

function GetCivInfoMinorIdeologies(iPlayer)
	local tab = {}
	for h, v in pairs(gT.Players[iPlayer].HasMinorIdeology) do
		table.insert(tab, {MinorIdeologyTenetDB[h].Name, MinorIdeologyTenetDB[h].Help, ideostringTab[MinorIdeologyTenetDB[h].Ideology], v})
	end
	return tab;
end

function GetCivInfoIdeologyTenets(iPlayer)
	local tab = {};
	for i, v in pairs(gT.Players[iPlayer].HasIdeology) do
		local iRow = IdeologyDB[i];
		local hString = iRow.Name .. "[NEWLINE]"
		for letter, iconstring in pairs(ideostringTab) do
			if iRow[letter] > 0 then
				hString = hString .. iRow[letter] .. iconstring .. " " 
			end
		end
		hString = hString .. "[NEWLINE]" .. iRow.Help
		table.insert(tab, {iRow.Name, hString})
	end
	return tab;
end

local mutBadIdeologies = {
--8th collides with GreatPeople bonuses.
{8, {[63] = true, [81] = true, [86] = true, [87] = true, [88] = true, [89] = true, [91] = true}},
}

function GetAIEvalOfIdeologyTenet(iPlayer, id)
	for a, b in pairs(mutBadIdeologies) do
		if id == b[1] then
			for hID, b in pairs(b[2]) do
				if gT.Players[iPlayer].HasIdeology[hID] then
					return 0;
				end
			end
		elseif gT.Players[iPlayer].HasIdeology[b[1]] then
			if b[2][id] then
				return 0;
			end
		end
	end
	return IdeologyDB[id].AIValueFunc(iPlayer)
end