local HelpImprovementTab = {GameInfoTypes.IMPROVEMENT_MINE, GameInfoTypes.IMPROVEMENT_CAMP, GameInfoTypes.IMPROVEMENT_FARM, GameInfoTypes.IMPROVEMENT_PLANTATION, GameInfoTypes.IMPROVEMENT_PASTURE, GameInfoTypes.IMPROVEMENT_QUARRY, GameInfoTypes.IMPROVEMENT_LUMBERMILL, GameInfoTypes.IMPROVEMENT_OFFSHORE_PLATFORM, GameInfoTypes.IMPROVEMENT_WELL, GameInfoTypes.IMPROVEMENT_NEW_ITG_FISHING_BOATS}
local BadFeature = {}
BadFeature[fForest] = 1;
BadFeature[fJungle] = 1;
BadFeature[fMarsh] = 3;
local BadFIMmpro = {}
BadFIMmpro[GameInfoTypes.IMPROVEMENT_MINE] = 80;
BadFIMmpro[GameInfoTypes.IMPROVEMENT_QUARRY] = 75;
BadFIMmpro[GameInfoTypes.IMPROVEMENT_FARM] = 85;
BadFIMmpro[GameInfoTypes.IMPROVEMENT_PLANTATION] = 50;
BadFIMmpro[GameInfoTypes.IMPROVEMENT_CHATEAU] = 90;
BadFIMmpro[GameInfoTypes.IMPROVEMENT_TERRACE_FARM] = 80;
local BuildTab = {}
local tAncCS8 = GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_8
local tradingPost = GameInfoTypes.IMPROVEMENT_TRADING_POST;
local rRoad = GameInfoTypes.ROUTE_ROAD;
local ancTcs11 = GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_11;
local ancTribeInno16 = GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_TRIBE_16;
local innoindu19 = GameInfoTypes.TECH_UNIQUE_ITG_INDUSTRIAL_19;
local innoindu20 = GameInfoTypes.TECH_UNIQUE_ITG_INDUSTRIAL_20;
local promEngRoads = GameInfoTypes.PROMOTION_ROAD_ENGINEER;
local resOutsideRadiusStr;
local resOutsideRadiusStrPillage;
local tResMakingFeaturesValid = {}
function IsNotRemovingForestJungle(impro)
	local build;
	for row in GameInfo.Builds() do
		if row.ImprovementType and (GameInfoTypes[row.ImprovementType] == impro) then
			build = row.Type;
			break;
		end
	end
	if not build then
		return false;
	end
	for row in GameInfo.BuildFeatures() do
		if row.BuildType == build then
			if row.FeatureType == "FEATURE_JUNGLE" or row.FeatureType == "FEATURE_FOREST" then
				return false;
			end
		end
	end
	return true;
end

function GetBasicImpros()
	return HelpImprovementTab;
end

for a, impro in pairs(HelpImprovementTab) do
	if IsNotRemovingForestJungle(impro) then
		local improType = GameInfo.Improvements[impro].Type;
		for row in GameInfo.Improvement_ResourceTypes() do
			if row.ImprovementType == improType then
				tResMakingFeaturesValid[GameInfoTypes[row.ResourceType]] = true;
			end
		end
	end
end

function PreparePlayerOutsideStrategicResources(iPlayer)
	resOutsideRadiusStr = {};
	resOutsideRadiusStrPillage = {};
	local schTab = {}
	for a, b in pairs(gT.CurrencyResources) do
		table.insert(schTab, a)
	end
	for iRes, i in pairs(gT.Globals.ResourcesInScenario) do
		table.insert(schTab, iRes)
	end
	local pTeam = Teams[Players[iPlayer]:GetTeam()];
	for i, iRes in pairs(schTab) do
		if CanSeeUseResource(iPlayer, iRes) then
			local th = GetResourcesPresentOnMap(iRes)
			for index, j in pairs(th) do
				local jPlot = Map.GetPlotByIndex(index);
				if jPlot:GetOwner() == iPlayer then
					if not jPlot:IsPlayerCityRadius(iPlayer) then
						if CanDoWorkOnPlotNow(jPlot, iPlayer, false, true) then
							if jPlot:IsImprovementPillaged() then
								table.insert(resOutsideRadiusStrPillage, index)
							elseif (jPlot:GetImprovementType() == -1) or (not jPlot:IsResourceConnectedByImprovement(jPlot:GetImprovementType())) then
								if CanHaveAnyImprovement(jPlot, iPlayer) then
									table.insert(resOutsideRadiusStr, index)
								end
							end
						end
					end
				end
			end
		end
	end
end

for row in GameInfo.Builds() do
	if row.ImprovementType then
		BuildTab[GameInfoTypes[row.ImprovementType]] = row.ID;
	end
end

function CreateGreatPersonImprovementIfPossible(improID, player, city)
	local pPlots = {}
	for iCity in Players[player]:Cities() do
		if (not city) or (city == iCity) then
			for i = 0, 5 do
				local iPlot = Map.PlotDirection(iCity:GetX(), iCity:GetY(), i);
				if iPlot then
					if iPlot:CanHaveImprovement(improID, -1) then
						if CanPlayerHaveGreatImproOnPlot(iPlot, player, improID, true) then
							table.insert(pPlots, iPlot)
						end
					end
				end
			end
		end
	end
	if #pPlots > 0 then
		local lPlot = pPlots[LastRandom(1, #pPlots)];
		CreateNewImprovementOnPlot(lPlot, improID, false, true)
	end
end

function DoTemporaryRoadsFromEngineers(iPlayer)
	if gT.Players[iPlayer].HasIdeology[28] then
		for iUnit in Players[iPlayer]:Units() do
			if iUnit:IsHasPromotion(promEngRoads) then
				if IsValidPlotForTemporaryRoute(iUnit:GetPlot()) then
					iUnit:GetPlot():SetRouteType(rRoad)
					gT.Globals.TemporaryRoads[iUnit:GetPlot():GetPlotIndex()] = 1;
				end
			end
		end
	end
end

function IsBetterOrEqualYieldOption(iPlot, cImproID, uniqueimpro, iPlayer)
	if not cImproID then
		return true;
	end
	local cont = 0;
	local def = 0;
	for row in GameInfo.Yields() do
		cont = cont + iPlot:CalculateImprovementYieldChange(cImproID, row.ID, iPlayer)
		cont = cont + iPlot:CalculateImprovementYieldChange(uniqueimpro, row.ID, iPlayer)
	end
	if cont == def then
		return (LastRandom(1,2) == 2)
	else
		return cont > def;
	end
end

function CanHaveTruelyImprovement(improID, iPlot, iPlayer)
	local buildID = BuildTab[improID]
--	local tech = GameInfo.Builds[buildID].PrereqTech;
--	if tech then
--		if not Teams[Players[iPlayer]:GetTeam()]:IsHasTech(GameInfoTypes[tech]) then
--			return false;
--		end
--	end
	local iOwner = iPlot:GetOwner();
	if GameInfo.Improvements[improID].OnlyCityStateTerritory then
		if iOwner == - 1 then
			return false;
		elseif not Players[iOwner]:IsMinorCiv() then
			return false;
		end
	elseif GameInfo.Improvements[improID].InAdjacentFriendly then
		if iOwner ~= iPlayer then
			local isadj = false;
			for i =0, 5 do
				local xPlot = Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), i);
				if xPlot then
					if xPlot:GetOwner() == iPlayer then
						isadj = true;
					end
				end
			end
			if not isadj then
				return false;
			end
		end
	elseif not GameInfo.Improvements[improID].OutsideBorders then
		if iOwner ~= iPlayer then
			return false
		end
	end
	if GameInfo.Improvements[improID].Water then
		if (not iPlot:IsWater()) or (iPlot:IsImpassable()) then
			return false;
		end
	end
	if GameInfo.Improvements[improID].RequiresXAdjacentLand > 0 then
		local t = 0;
		for i =0, 5 do
			local xPlot = Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), i);
			if xPlot and ((not xPlot:IsWater()) or (xPlot:GetImprovementType() == improID)) then
				t = t + 1;
			end
		end
		if t < GameInfo.Improvements[improID].RequiresXAdjacentLand then
			return false;
		end
	end
	if GameInfo.Improvements[improID].AdjacentLuxury then
		local isLuxury = false;
		local iTeam;
		if iPlayer and iPlayer ~= -1 then
			iTeam = Players[iPlayer]:GetTeam();
		end
		for i = 0 , 5 do
			local xPlot = Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), i);
			if xPlot then
				if xPlot:GetResourceType(iTeam) ~= -1 then
					if GameInfo.Resources[xPlot:GetResourceType()].Happiness > 0 then
						isLuxury = true;
						break;
					end
				end
			end
		end
		if not isLuxury then
			return false;
		end
	end
	if GameInfo.Improvements[improID].NoTwoAdjacent then
		for i =0, 5 do
			local xPlot = Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), i);
			if xPlot then
				if xPlot:GetImprovementType() == improID then
					return false;
				end
			end
		end
	end
	return true;
end

function CanHaveAnyImprovement(iPlot, iPlayer)
	if iPlot:GetTerrainType() == tSnow then
		return false;
	end
	for iT, improID in pairs(HelpImprovementTab) do
		if iPlot:CanHaveImprovement(improID, Players[iPlayer]:GetTeam()) then
			return true;
		end
	end
	if gT.Players[iPlayer].TradingPost > 0 then
		if iPlot:CanHaveImprovement(tradingPost, Players[iPlayer]:GetTeam()) then
			return true;
		end			
	end
	for uniqueimpro, sth in pairs(gT.Players[iPlayer].UniqueImprovements) do
		if iPlot:CanHaveImprovement(uniqueimpro, Players[iPlayer]:GetTeam()) then
			if CanHaveTruelyImprovement(uniqueimpro, iPlot, iPlayer) then
				return true
			end
		end
	end
	return false;
end

function MakeAnyValidImprovement(iPlot, ignoreF, bColony, iCity, bInitial)
	if gT.Academies[iPlot:GetPlotIndex()] then
		print("ERROR Academies Make any valid improvement", iPlot:GetPlotIndex(), ignoreF, bColony, iCity:GetID())
	end
	if gT.Globals.AncientRuins[iPlot:GetPlotIndex()] then
		print("ERROR Ancient ruins Make any valid improvement", iPlot:GetPlotIndex(), ignoreF, bColony, iCity:GetID())
	end
	local iPlayer = iPlot:GetOwner(); -- should be the same as city
	local iTeam = Players[iPlayer]:GetTeam();
	local cImproID;
	local fType = iPlot:GetFeatureType();
	for iT, improID in pairs(HelpImprovementTab) do
		if iPlot:CanHaveImprovement(improID, iTeam) then
			if (ignoreF) or (not BadFeature[fType]) then
				if IsBetterOrEqualYieldOption(iPlot, cImproID, improID, iPlayer) then
					cImproID = improID;
				end
			end
		end
	end
	if not bColony then
		if gT.Players[iPlayer].TradingPost > 0 then
			if iPlot:CanHaveImprovement(tradingPost, iTeam) then
				if (ignoreF) or (not BadFeature[fType]) then
					if IsBetterOrEqualYieldOption(iPlot, cImproID, tradingPost, iPlayer) then
						cImproID = tradingPost;
					end
				end
			end			
		end
		for uniqueimpro, sth in pairs(gT.Players[iPlayer].UniqueImprovements) do
			if iPlot:CanHaveImprovement(uniqueimpro, iTeam) then
				if CanHaveTruelyImprovement(uniqueimpro, iPlot, iPlayer) then
					if IsBetterOrEqualYieldOption(iPlot, cImproID, uniqueimpro, iPlayer) then
						cImproID = uniqueimpro;
					end
				end
			end
		end
	end
	if cImproID then
		CreateNewImprovementOnPlot(iPlot, cImproID, bColony)
		if BadFeature[fType] then
			if BadFIMmpro[cImproID] then
				if not tResMakingFeaturesValid[iPlot:GetResourceType(Players[iPlayer]:GetTeam())] then
					if LastRandom(1,100) <= BadFIMmpro[cImproID] * gT.Players[iPlayer].FeatureRemovalMod then
						if not IsFeatureProtectedByPlayer(iPlayer, fType) then
							if bInitial then -- this is to keep more features over the eras
								if LastChance(DBScenario.InitialFeaturesSave) then
									local iIndex = iPlot:GetPlotIndex();
									if not gT.Globals.OriginalFeature[iIndex] then
										gT.Globals.OriginalFeature[iIndex] = fType;
									end
								end
							end
							CityRemovedFeature(iCity, iPlayer, fType, true, iPlot)
							iPlot:SetFeatureType(-1)
							if iCity then
								UpdateCityMaxHitPoints(iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded(), iPlayer, iCity)
							end
						end
					end
				end
			end
		end
	end
end

function IsFeatureProtectedByPlayer(iPlayer, fType)
	if fType == fForest then
		if gT.Players[iPlayer].CultBonusOn[150] then
			return true;
		end
		if IsHasLaw(iPlayer, 29, 1) then
			return true;
		end
	elseif fType == fJungle then
		if gT.Players[iPlayer].CultBonusOn[150] then
			return true;
		end
		if IsHasLaw(iPlayer, 29, 1) then
			return true;
		end
	elseif fType == fMarsh then
		if IsHasLaw(iPlayer, 29, 1) then
			return true;
		end
	end
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_TRIBE_16, "okfeorfa") then
		return true;
	end
	return false;
end

function CreateNewImprovementOnPlot(iPlot, improID, bColony, bInitial)
	if gT.Globals.AncientRuins[iPlot:GetPlotIndex()] then
		print("Impro is replacing ancient ruins!", iPlot:GetPlotIndex(), improID, bColony, bInitial)
	end
	iPlot:SetImprovementType(improID, -1)
	local iOwner = iPlot:GetOwner();
	if not bColony then
		gT.Globals.Improvements[iPlot:GetPlotIndex()] = iPlot:GetImprovementType();
	end
	if gT.Players[iOwner] then
		gT.Players[iOwner].Improvements[iPlot:GetPlotIndex()] = iPlot:GetImprovementType()
	end
	if gT.Academies[iPlot:GetPlotIndex()] then
		print("Impro created new on Plot with academy", iPlot:GetPlotIndex(), improID, bColony, bInitial)
	end
	if improID == GameInfoTypes.IMPROVEMENT_ACADEMY then
		CreateNewAcademy(iPlot:GetPlotIndex(), iOwner, bInitial)
--		gT.Academies[iPlot:GetPlotIndex()] = GetITGGameTurn();
	elseif improID == GameInfoTypes.IMPROVEMENT_CUSTOMS_HOUSE then
		CreateNewCustomHouse(iPlot:GetPlotIndex(), iOwner, bInitial)
--		gT.CustomsHouses[iPlot:GetPlotIndex()] = GetITGGameTurn();
	elseif improID == GameInfoTypes.IMPROVEMENT_MANUFACTORY then
		CreateNewManufactory(iPlot:GetPlotIndex(), iOwner, bInitial)
--		gT.Manufactories[iPlot:GetPlotIndex()] = GetITGGameTurn();
	elseif improID == GameInfoTypes.IMPROVEMENT_KASBAH then
		if not gT.Globals.Kasbahs then
			gT.Globals.Kasbahs = {};
		end
		gT.Globals.Kasbahs[iPlot:GetPlotIndex()] = true;
		if not bInitial then
			RecalculateKasbahsBonus()
		end
	end
end

function UpdateImprovementsOwner(jPlayer)
	if Players[jPlayer]:IsBarbarian() then
		for iplotindex, itype in pairs(gT.Globals.Improvements) do
			if Map.GetPlotByIndex(iplotindex):GetOwner() ~= -1 then
				local owner = Map.GetPlotByIndex(iplotindex):GetOwner();
				if owner ~= jPlayer then
					gT.Players[owner].Improvements[iplotindex] = itype;
				end
			end
		end
	else
		for iplotindex, itype in pairs(gT.Players[jPlayer].Improvements) do
			if Map.GetPlotByIndex(iplotindex):GetOwner() ~= jPlayer then
				if gT.Players[Map.GetPlotByIndex(iplotindex):GetOwner()] then
					gT.Players[Map.GetPlotByIndex(iplotindex):GetOwner()].Improvements[iplotindex] = itype;
				end
				gT.Players[jPlayer].Improvements[iplotindex] = nil;
			end
		end
	end
end

function SpendITGWorkRateEmpireWide(iPlayer, hVal)
	local topay = hVal;
	local numcities = Players[iPlayer]:GetNumCities();
	if numcities == 0 then
		print("Error 403543/324234")
		return
	end
	local percity = math.floor(hVal / numcities);
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		if gT.Cities[cID].WorkRate >= percity then
			MakeCitySpendWorkRate(iCity, iPlayer, percity)
			topay = topay - percity;
		end
	end
	for iCity in Players[iPlayer]:Cities() do
		if topay <= 0 then
			return;
		end
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		local hPay = math.min(topay, gT.Cities[cID].WorkRate)
		if hPay > 0 then
			MakeCitySpendWorkRate(iCity, iPlayer, hPay)
			topay = topay - hPay;
		end
	end
end

function GetTotalWorkRateStoredPlayer(iPlayer)
	local t = 0;
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		t = t + gT.Cities[cID].WorkRate;
	end
	return t;
end

function DoWorkRate(iPlayer)
	local tot = 0;
--[[	for iUnit in Players[iPlayer]:Units() do
		if UnitsGrantingWorkRate[iUnit:GetUnitType()] then
			local iCity = Players[iPlayer]:GetCityByID(iUnit:GetPlot():GetCityPurchaseID())
			if iCity then
				if Map.PlotDistance(iUnit:GetX(), iUnit:GetY(), iCity:GetX(), iCity:GetY()) < 4 then
					ChangeITGWorkRate(iCity, UnitsGrantingWorkRate[iUnit:GetUnitType()])
					tot = tot + UnitsGrantingWorkRate[iUnit:GetUnitType()] 
				end
			end
		end
	end ]]
	resOutsideRadiusStr = nil;
	resOutsideRadiusStrPillage = nil
	PreparePlayerOutsideStrategicResources(iPlayer)
	for iCity in Players[iPlayer]:Cities() do
		if ITGCityCanWorkDoAction(iCity) then
			local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
			local loc = GetWorkRateIncreasement(iPlayer, iCity, cID);
			ChangeITGWorkRate(iCity, loc)
			tot = tot + loc;
			DoFindValidWorkIfProperWorkRate(iCity, cID, iPlayer)
		end
	end
	DoTemporaryRoadsFromEngineers(iPlayer)
end

function GetCityWorkRateFromBuildings(iCity)
	local base = iCity:GetWorkRateChange();
	local iPlayer = iCity:GetOwner();
	for bClass, amount in pairs(gT.Players[iPlayer].WorkRateFromBuildingClasses) do
		local bb = Players[iPlayer]:GetPlayerUniqueBuilding(bClass);
		if iCity:IsHasBuilding(bb) then
			local numBuilding = iCity:GetNumRealBuilding(bb) + iCity:GetNumFreeBuilding(bb);
			base = base + numBuilding * amount;
		end
	end
	return base;
end

function GetWorkRateFromIdeologies(iCity, cID, iPlayer)
	local t = 0;
	if gT.Players[iPlayer].HasIdeology[38] then
		if #gT.Cities[cID].CustomsHouses > 0 then
			t = t + 10;
		end
	end
	if gT.Players[iPlayer].HasIdeology[25] then
		if gT.Cities[cID].Happiness > 0 then
			t = t + 10;
		end
	end
	if gT.Players[iPlayer].HasIdeology[70] then
		if #gT.Cities[cID].Academies > 0 then
			t = t + 10;
		end
	end
	return t;
end

function GetWorkRateIncreasement(iPlayer, iCity, cID, bTooltip)
	if not ITGCityCanWorkDoAction(iCity) then
		return 0;
	end
	local base = 10 + GetCityWorkRateFromBuildings(iCity) + GetWorkRateFromPalace(iCity, cID, iPlayer);
	base = base + GetWorkRateFromTechs(iCity, cID, iPlayer) +  GetWorkRateFromWonderOrRuin(iCity, iPlayer) + GetWorkRateFromBeliefs(iCity, iPlayer) + GetWorkRateFromGovernance(iCity)
	local extra = 0;
	local mod = 1 + (GetITGCityInteger(iCity, "CI_GP_WORK_MOD") / 100);
	if gT.Players[iPlayer].HasPlayerWonder[GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_4] then
		mod = mod + 0.5;
	end
	extra = extra + GetWorkRateFromGov(iCity, iPlayer) + GetWorkRateFromCultDevs(iCity, iPlayer, cID) + GetWorkRateFromLaws(iCity, iPlayer);
	extra = extra + GetWorkRateFromIdeologies(iCity, cID, iPlayer) + GetWorkFromManufactories(iPlayer, iCity) + GetWorkFromCityStates(iPlayer, iCity)
	if bTooltip then
		extra = extra + GetWorkRateFromProcess(iCity) + GetEstimatedWorkRateFromBudget(iPlayer);
	end
	return math.floor(base * mod + extra);
end

function GetWorkRateFromGov(iCity, iPlayer)
	local extra =0;
	if gT.Players[iPlayer].Goverment == 7 then
		extra = extra + (5 + iCity:GetPopulation()) * gT.Players[iPlayer].GovTraitMod;
	end
	return extra;
end

function GetWorkRateFromTechs(iCity, cID, iPlayer)
	local extra = gT.Players[iPlayer].WorkFromTech;
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_MESOAMERICAN_1, "wellhellore") then
		extra = extra + 5 * gT.Cities[cID].Mountain;
	end
	return extra;
end

function GetWorkRateFromBeliefs(iCity, iPlayer)
	local extra = 0;
	if IsBeliefPresentInACity(iCity, GameInfoTypes.BELIEF_ITG_PANTHEON_18) then
		extra = extra + 7;
	end	
	if IsBeliefPresentInACity(iCity, GameInfoTypes.BELIEF_ITG_FOLLOWER_40) then
		extra = extra + 4 * iCity:GetFaithPerTurn();
	end
	return extra;
end

function GetWorkRateFromPalace(iCity, cID, iPlayer)
	if gT.Cities[cID].Palace then
		return gT.Cities[cID].Palace.WorkRate * GetCityPalaceYieldMod(iCity, cID, iPlayer);
	end
	return 0;
end

function GetWorkRateFromGovernance(iCity)
	return GetITGCityInteger(iCity, "CI_GOV_WORK_RATE");
end

local WorkRateFromCSScT = {15,10,10,20,20}
function GetWorkFromCityStates(iPlayer, iCity)
	local b = 0;
	local bCapital = iCity:IsCapital();
	for i, minor in pairs(gT.Globals.CSbyTypes[GameInfoTypes.MINOR_TRAIT_AGRICULTURAL]) do
		local fLevel = Players[minor]:GetMinorCivFriendshipLevelWithMajor(iPlayer);
		if (fLevel == 2) or ((fLevel == 1) and bCapital) then
			b = b + WorkRateFromCSScT[gT.Globals.ScenarioType]
		end
	end
	if gT.Players[iPlayer].CultBonusOn[118] then
		b = math.floor(b * 1.5);
	end
	return b;	
end

function GetWorkFromManufactories(iPlayer, iCity)
	local nump = GetNumPlayerManufactoryTrait(iPlayer, 12) 
	if nump > 0 then
		return nump * 5 + 10 * GetNumCityManufactoryTrait(iCity, 12);
	end
	return 0;
end

function GetWorkRateFromLaws(iCity, iPlayer)
	local extra = 0;
	if not IsHasLaw(iPlayer, 6, 0) then	
		extra = extra + 10;
	end
	return extra;
end

function GetWorkRateFromCultDevs(iCity, iPlayer, cID)
	local extra = 0;
	if gT.Players[iPlayer].CultBonusOn[149] then
		extra = extra - 5;
	end
	if gT.Players[iPlayer].CultBonusOn[2] then
		extra = extra + 8 + math.floor(iCity:GetYieldRateTimes100(yGold) / 100);
	end	
	return extra;
end

function GetWorkRateFromWonderOrRuin(iCity, iPlayer)
	local ht = 0
	if gT.Players[iPlayer].HasMinorIdeology[16] then
		if HasWonderOrRuin(iCity) then
			ht = ht + 20;
		end
	end
	if IsCityHaveWonderRuinWithAbility(iCity, 25) then
		ht = ht + 20;
	end
	return ht;
end

function MakeCitySpendWorkRate(iCity, iPlayer, amount, bHeal)
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local refund = 0;
	if gT.Players[iPlayer].CultBonusOn[88] then
		local iSaved = math.floor(amount / 5 + 0.5);
		refund = refund + iSaved;
		gT.Players[iPlayer].Cult88 = gT.Players[iPlayer].Cult88 + iSaved;
		if gT.Players[iPlayer].Cult88 >= 300 then
			local iReward = math.floor(gT.Players[iPlayer].Cult88 / 300);
			ChangeMeritocracy(iPlayer, iReward);
			gT.Players[iPlayer].Cult88 = gT.Players[iPlayer].Cult88 - 300 * iReward;
		end
	end
	if gT.Players[iPlayer].WorkRateToScience > 0 then
		if not Players[iPlayer]:IsMinorCiv() then
			ChangeITGScience(iPlayer, math.ceil(gT.Players[iPlayer].WorkRateToScience * amount))
		end
	end
	gT.Cities[cID].WorkRate = gT.Cities[cID].WorkRate - amount + refund;
	gT.Players[iPlayer].WorkRateSpent = gT.Players[iPlayer].WorkRateSpent + amount - refund;
	if bHeal and gT.Players[iPlayer].HasIdeology[34] then
		gT.Players[iPlayer].WorkRateToHealSpend = gT.Players[iPlayer].WorkRateToHealSpend + amount;
		if gT.Players[iPlayer].WorkRateToHealSpend >= 500 then
			TakeCareOfEventMorale(iPlayer, 25, {1, "Patriotic War"})
			gT.Players[iPlayer].WorkRateToHealSpend = gT.Players[iPlayer].WorkRateToHealSpend - 500;
		end
	end
	WorkRateDirtyCityAttack(iCity, cID)
end

function IncreaseWorkRateInAllCities(iPlayer, amount)
	for iCity in Players[iPlayer]:Cities() do
		ChangeITGWorkRate(iCity, amount)
	end
end

function ChangeITGWorkRate(iCity, amount)
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	gT.Cities[cID].WorkRate = gT.Cities[cID].WorkRate + amount;
end

function GetCityImprovementCost(cID, iCity, iPlayer)
	local base = gT.Cities[cID].ImprovementCost;
	local mod = gT.Players[iPlayer].ImproCostMod;
	mod = mod - 0.2 * GetNumCityAcademiesWithAbility(iCity, 25);
	mod = math.max(mod, 0.25)
	return math.floor(base * mod);
end

function DoMakeImprovementOnThePlot(cID, iCity, iPlayer, lPlot)
	if gT.Academies[lPlot:GetPlotIndex()] then
		print("ERROR Academy impro replaced", cID, iCity, iPlayer, lPlot)
	end
	MakeCitySpendWorkRate(iCity, iPlayer, GetCityImprovementCost(cID, iCity, iPlayer))
	gT.Cities[cID].ImprovementCost = math.min(1000, gT.Cities[cID].ImprovementCost + 200)
	MakeAnyValidImprovement(lPlot, true, false, iCity)
	VictoryTaskCompletion(iPlayer, 54)
	local delay = 0.5;
	local bActivePlayer = (iPlayer == Game.GetActivePlayer());
	if gT.Players[iPlayer].CultBonusOn[1] then
		ChangeITGHappinessInTheCity(iCity, 1, nil, "okockoekodacede")
		if bActivePlayer then
			Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(lPlot:GetX(),lPlot:GetY()))), "[ICON_HAPPINESS_1]", delay)
			delay = delay + 0.5;
		end
	end
	if gT.Players[iPlayer].GovRewards[12] then
		ChangeITGLegalPointsPercent(iPlayer, 4, nil, "Hfsfe")
		if bActivePlayer then
			Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(lPlot:GetX(),lPlot:GetY()))), "0.04[ICON_ITG_LEGAL_POWER]", delay)
			delay = delay + 0.5;
		end
	end
	if HasPlayerTech(iPlayer, tAncCS8, "123132dc") then
		ChangeITGSettlerPoints(iPlayer, 1);
	end
	if LastRandom(1, 100) <= gT.Players[iPlayer].ImproGWChance then
		CreateGreatWorkOfAmount(iPlayer, 1, "Random")
		if bActivePlayer then
			Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(lPlot:GetX(),lPlot:GetY()))), "[ICON_GREAT_WORK]", delay)
			delay = delay + 0.5;
		end
	end
	if bActivePlayer then
		Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(lPlot:GetX(),lPlot:GetY()))), "[ICON_WORKER]", delay)
	end
end

function MakeARoadOnThePlot(iPlot, iPlayer)
	iPlot:SetRouteType(rRoad)
	DoIncreasementStockExchange(12)
	VictoryTaskCompletion(iPlayer, 14)
	if iPlot:IsMountain() then
		iPlot:SetMountainPassable(true)
		if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_MESOAMERICAN_1, "Kdaweae") then
			if iPlot:GetOwner() == iPlayer then
				gT.Plots.GreatAndeanBonus[iPlot:GetPlotIndex()] = true;
				Game.SetPlotExtraYield(iPlot:GetX(), iPlot:GetY(), yFood, 1)
				Game.SetPlotExtraYield(iPlot:GetX(), iPlot:GetY(), yProduction, 1)
				Game.SetPlotExtraYield(iPlot:GetX(), iPlot:GetY(), yGold, 1)
			end
		end
	end
end

function DoFindValidWorkIfProperWorkRate(iCity, cID, iPlayer)
	if ITGCityCanWorkDoAction(iCity) then
		if iCity:GetDamage() == 0 then
			if not iCity:CanRangeStrikeNow() then
				if gT.Cities[cID].WorkRate >= 100 then
				--minumum repair is 100?
					local pillagedPlots = GetPillagedPlotsInArea(iCity:Plot(), 3, iPlayer)
					--so it detects also forts and holy sites -> do not waste work rate if there is some warring around
						
					if #pillagedPlots > 0 then
						pillagedPlots = Shuffle(pillagedPlots)
						for it, iPlot in pairs(pillagedPlots) do
							if IsGreatPeopleImprovementPlot(iPlot:GetPlotIndex()) then
								if CanDoWorkOnPlotNow(iPlot, iPlayer) then
									DoRepairOnPlot(iCity, cID, iPlayer, iPlot)
									return
								end
							end
						end
						for it, iPlot in pairs(pillagedPlots) do
							if CanDoWorkOnPlotNow(iPlot, iPlayer) then
								DoRepairOnPlot(iCity, cID, iPlayer, iPlot)
								return
							end
						end
					else
						if #resOutsideRadiusStrPillage > 0 then
							resOutsideRadiusStrPillage = Shuffle(resOutsideRadiusStrPillage);
							DoRepairOnPlot(iCity, cID, iPlayer, Map.GetPlotByIndex(resOutsideRadiusStrPillage[1]))
							table.remove(resOutsideRadiusStrPillage, 1)
							return
						end
						if gT.Cities[cID].CurrentWorkAction == -1 then
							gT.Cities[cID].ExceptedRoadCost = nil;
							--TO DO
							MakeCityConsiderNewActionForWorkRate(iCity, cID, iPlayer)
							if gT.Cities[cID].CurrentWorkAction ~= -1 then
								gT.Cities[cID].CDIdeo7 = nil;
							end
						end
						if gT.Cities[cID].CurrentWorkAction == -1 then
							--nothing to do and 2000 work rate stored
							if gT.Cities[cID].WorkRate >= 2000 then
								if DoAddFreeBuildingIfPossible(iCity, iPlayer) then
									MakeCitySpendWorkRate(iCity, iPlayer, 2000)
								end
							end
						elseif gT.Cities[cID].CurrentWorkAction == 1 then
							--if 1 then improvement
							if gT.Cities[cID].WorkRate >= GetCityImprovementCost(cID, iCity, iPlayer) then
								if #resOutsideRadiusStr > 0 then
									if gT.Cities[cID].ImprovementCost >= 1000 then --only developed cities will consider upgrading those tiles
										local lIndex = LastRandom(1,#resOutsideRadiusStr)
										DoMakeImprovementOnThePlot(cID, iCity, iPlayer, Map.GetPlotByIndex(resOutsideRadiusStr[lIndex]))
										table.remove(resOutsideRadiusStr, lIndex)
										gT.Cities[cID].CurrentWorkAction = -1;
										return;
									end
								end
								local hTab = GetTabOfImprovablePlots(iCity, cID, iPlayer, 3)
								if #hTab > 0 then
									local resTabH = {}
									local iTeam = Players[iPlayer]:GetTeam();
									for dd, plot in pairs(hTab) do
										if plot:GetResourceType(iTeam) ~= -1 then
											table.insert(resTabH, plot);
										end
									end
									if #resTabH > 0 then
										DoMakeImprovementOnThePlot(cID, iCity, iPlayer, resTabH[LastRandom(1,#resTabH)])
									else
										DoMakeImprovementOnThePlot(cID, iCity, iPlayer, hTab[LastRandom(1,#hTab)])
									end
								end
								gT.Cities[cID].CurrentWorkAction = -1;
							end
						elseif gT.Cities[cID].CurrentWorkAction == 2 then
							--if 2 then road
							if (not gT.Cities[cID].ExceptedRoadCost) or (gT.Cities[cID].ExceptedRoadCost <= gT.Cities[cID].WorkRate) or (GetITGGameTurn()%5 == 0) then
								local plotTable = GetNiceRoadFromTheCity(iCity, cID, iPlayer, true)
								if #plotTable > 0 then
									local exceptedcost = #plotTable * GetCostOfOneRoad(iPlayer, iCity, cID);
									if gT.Cities[cID].WorkRate >= exceptedcost then
										for i, iPlot in pairs(plotTable) do
											MakeARoadOnThePlot(iPlot, iPlayer)
											MakeCitySpendWorkRate(iCity, iPlayer, GetCostOfOneRoad(iPlayer, iCity, cID))
											if iPlayer == Game.GetActivePlayer() then
												Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(iPlot:GetX(),iPlot:GetY()))), "[ICON_WORKER]", 0.5)
											end
											gT.Cities[cID].CurrentWorkAction = -1;
										end
										if #plotTable >= 10 then
											if Players[iPlayer]:IsHuman() then
												LuaEvents.ITG_AchievementCompleted(13)
											end
										end
									else
										gT.Cities[cID].ExceptedRoadCost = exceptedcost
									end
								else
									gT.Cities[cID].ExceptedRoadCost = nil;
									gT.Cities[cID].CurrentWorkAction = -1;
								end
							end
						elseif gT.Cities[cID].CurrentWorkAction == 3 then
							if gT.Cities[cID].WorkRate >= GetCostToRemoveFeature(iPlayer) then
								local pTab, oTab = GetTabOfBadFeaturePlots(iCity, cID, iPlayer, 3)
								if #pTab + #oTab > 0 then
									local lPlot;
									if #pTab > 0 then
										lPlot = pTab[LastRandom(1,#pTab)];
									else
										lPlot = oTab[LastRandom(1,#oTab)];
									end
									CityRemovedFeature(iCity, iPlayer, lPlot:GetFeatureType(), false, lPlot)
									lPlot:SetFeatureType(-1);
									MakeCitySpendWorkRate(iCity, iPlayer, GetCostToRemoveFeature(iPlayer))
									if iPlayer == Game.GetActivePlayer() then
										Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(lPlot:GetX(),lPlot:GetY()))), "[ICON_WORKER]", 0.5)
									end
								end
								gT.Cities[cID].CurrentWorkAction = -1;
							end
						elseif gT.Cities[cID].CurrentWorkAction == 4 then
							if gT.Cities[cID].WorkRate >= 500 then
								if CanStoreWorkRateForAcademy(iCity, cID, iPlayer) then
									local tab = {}
									for ha, index in pairs(gT.Cities[cID].Academies) do
										if IsAcademyActiveRightNow(index) then
											table.insert(tab, index)
										end
									end
									AddBonusToAcademy(tab[LastRandom(1,#tab)], "Random")
									MakeCitySpendWorkRate(iCity, iPlayer, 500)
								end
								gT.Cities[cID].CurrentWorkAction = -1;
							end
						elseif gT.Cities[cID].CurrentWorkAction == 5 then
							if gT.Cities[cID].WorkRate >= 2000 then
								gT.Players[iPlayer].NumFortPoints = gT.Players[iPlayer].NumFortPoints + 1;
								MakeCitySpendWorkRate(iCity, iPlayer, 2000)
								gT.Cities[cID].CurrentWorkAction = -1;
							end
						elseif gT.Cities[cID].CurrentWorkAction == 6 then
							if gT.Cities[cID].WorkRate >= 800 then
								local type = {1}
								if gT.Cities[cID].MTnavalTR > 0 then
									table.insert(type, 2)
								end
								GenerateCaravanIfPossibleTarget(iCity, iPlayer, false, (LastRandom(1, #type) == 2))
								MakeCitySpendWorkRate(iCity, iPlayer, 800)
								gT.Cities[cID].CurrentWorkAction = -1;
							end
						elseif gT.Cities[cID].CurrentWorkAction == 7 then
							if gT.Cities[cID].WorkRate >= 800 then
								if IsValidForFestival(iPlayer, iCity) then	
									DoStartFestival(iPlayer, iCity, true, false)
									MakeCitySpendWorkRate(iCity, iPlayer, 800)
								end
								gT.Cities[cID].CurrentWorkAction = -1;
							end
						elseif gT.Cities[cID].CurrentWorkAction == 8 then
							if gT.Cities[cID].WorkRate >= 500 then
								ChangeITGCityInteger(iCity, "CI_IDEO_7", 1)
								iCity:ChangeBaseYieldRateFromBuildings(yProduction, 1);
								gT.Cities[cID].CDIdeo7 = true;
								MakeCitySpendWorkRate(iCity, iPlayer, 500)
								gT.Cities[cID].CurrentWorkAction = -1;
							end
						end
					end
				end
			end
		end
	end
end

function GetCostToRemoveFeature(iPlayer)
	local base = 300;
	if HasPlayerTech(iPlayer, ancTcs11, "Dkoead") then
		base = base - 150;
	end
	return base;
end

function GetCostOfOneRoad(iPlayer, iCity, cID)
	local base = 200 + GetITGCityInteger(iCity, "CI_GP_ROAD_COST")
	if gT.Players[iPlayer].CultBonusOn[122] then
		base = base - 100;
	end
	if IsCityHaveWonderRuinWithAbility(iCity, 15) then
		base = base - 50;
	end
	return math.max(50,base);
end

function GetTabOfBadFeaturePlots(iCity, cID, iPlayer, dis)
	local sx, sy = iCity:GetX(), iCity:GetY()
	local hTab = {};
	local lTab = {};
	for ix = -dis, dis do
		for iy = -dis, dis do
			local iPlot = Map.GetPlot(sx + ix, sy + iy);
			if iPlot then
				if (not iPlayer) or (iPlot:GetOwner() == iPlayer) then
					if (iPlot:GetImprovementType() ~= -1) then
						if BadFeature[iPlot:GetFeatureType()] then
							if not tResMakingFeaturesValid[iPlot:GetResourceType()] then
								if iPlot:GetTerrainType() ~= tTundra then
									if not IsFeatureProtectedByPlayer(iPlayer, iPlot:GetFeatureType()) then
										if BadFeature[iPlot:GetFeatureType()] == 3 then
											table.insert(hTab, iPlot)
										else
											table.insert(lTab, iPlot)
										end
									end
								end
							end
						end
					end
				end
			end
		end
	end
	return hTab, lTab;
end

function GetTabOfImprovablePlots(iCity, cID, iPlayer, dis, bReverse)
	local sx, sy = iCity:GetX(), iCity:GetY()
	local hTab = {}
	for ix = -dis, dis do
		for iy = -dis, dis do
			local iPlot = Map.GetPlot(sx + ix, sy + iy);
			if iPlot then
				if (not iPlayer) or iPlot:GetOwner() == iPlayer then
					if (not IsSpecialControlPlot(iPlot:GetPlotIndex())) then
						if ((iPlot:GetImprovementType() == -1) or ( (not iPlot:IsResourceConnectedByImprovement(iPlot:GetImprovementType())) and (not IsGreatPeopleImprovementPlot(iPlot:GetPlotIndex())) ) ) == (not bReverse) then
							if Map.PlotDistance(sx, sy, sx + ix, sy + iy) <= dis then
								if bReverse or CanHaveAnyImprovement(iPlot, iPlayer) then
									table.insert(hTab, iPlot)
								end
							end
						end
					end
				end
			end
		end
	end
	return hTab;
end

function GetPillagedPlotsInArea(plot, dis, iPlayer)
	local sx, sy = plot:GetX(), plot:GetY()
	local hTab = {}
	for ix = -dis, dis do
		for iy = -dis, dis do
			local iPlot = Map.GetPlot(sx + ix, sy + iy);
			if iPlot then
				if (not iPlayer) or iPlot:GetOwner() == iPlayer then
					if iPlot:IsImprovementPillaged() then
						if Map.PlotDistance(sx, sy, sx + ix, sy + iy) <= dis then
							table.insert(hTab, iPlot)
						end
					end
				end
			end
		end
	end
	return hTab;
end

function CountBasicImprovementsPillaged(iPlayer)
	local c = 0;
	local alC = {}
	for iCity in Players[iPlayer]:Cities() do
		for ix = -3, 3 do
			for iy = -3, 3 do
				local iPlot = Map.GetPlot(iCity:GetX() + ix, iCity:GetY() + iy);
				if iPlot then
					if iPlot:IsImprovementPillaged() then
						if iPlot:GetOwner() == iPlayer then
							local index = iPlot:GetPlotIndex();
							if (not alC[index]) and (not IsSpecialControlPlot(index)) then
								c = c + 1;
								alC[index] = true;
							end
						end
					end
				end
			end
		end
	end
	return c;
end

function CanDoWorkOnPlotNow(iPlot, iPlayer, bRailroad, bIgnoreCity)
	local iTeam = Players[iPlayer]:GetTeam();
	if bRailroad or (not IsSpecialControlPlot(iPlot:GetPlotIndex())) or (IsGreatPeopleImprovementPlot(iPlot:GetPlotIndex())) then
		if not iPlot:IsVisibleEnemyUnit(iTeam) then
			for j = 0, 5 do
				local jPlot= Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), j);
				if jPlot then
					if jPlot:IsVisibleEnemyUnit(iTeam) then
						return false;
					end
				end
			end
			if not bIgnoreCity then
				local cityID = iPlot:GetCityPurchaseID();
				local iCity = Players[iPlayer]:GetCityByID(cityID);
				if iCity then
					if iCity:GetDamage() > iCity:GetMaxHitPoints() / 2 then
						return false;
					end
					local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
					if gT.Cities[cID].LastTimeDamaged >= GetITGGameTurn() -1 then
						return false;
					end
				end
			end
			return true;
		end
	end
	return false;
end

function GetRepairCost(iPlayer, cID, iCity)
	local tCost = 100;
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_PLASTIC, "^&#$%") then
		tCost = tCost - 50;
	end
	if gT.Players[iPlayer].CultBonusOn[29] then
		tCost = tCost / 2;
	end
	return tCost;
end

function DoRepairOnPlot(iCity, cID, iPlayer, iPlot)
	MakeCitySpendWorkRate(iCity, iPlayer, GetRepairCost(iPlayer, cID, iCity))
	iPlot:SetImprovementPillaged(false);
	BasicCSMissionCompleteFunc(iPlayer, 45, 1)
	if iPlayer == Game.GetActivePlayer() then
		Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(iPlot:GetX(),iPlot:GetY()))), "[ICON_WORKER]", 0.5)
	end
end

local hgatad = {}
local vhadat = {}
function GetCityRoadSystemNearby(iPlot, nearbyTab)
	hgatad = {}
	for i, plot in pairs(nearbyTab) do
		vhadat[plot] = 1;
	end
	DoIterateSystemNearby(iPlot)
	return hgatad;
end

function DoIterateSystemNearby(iPlot)
	hgatad[iPlot] = 1;
	for i = 0, 5 do
		local nPlot = Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), i);
		if nPlot and (not hgatad[nPlot]) and (vhadat[nPlot]) then
			if nPlot:GetRouteType() ~= -1 then
				DoIterateSystemNearby(nPlot)
			end
		end
	end
end

function GetConnectingPlot(iPlot, iCityP)
	local cTab = {}
	for i =0 , 5 do
		local nPlot = Map.PlotDirection(iCityP:GetX(), iCityP:GetY(), i);
		if nPlot and Map.PlotDistance(iPlot:GetX(), iPlot:GetY(), nPlot:GetX(), nPlot:GetY()) == 1 then
			table.insert(cTab, nPlot);
		end
	end
	return cTab;
end

function GetNiceRoadFromTheCity(iCity, cID, iPlayer, bNow)
	local getroadTabRev;
	local getroadTab;
	local bHasGreatAndeanRoad = HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_MESOAMERICAN_1, "Eqdaeghe")
	local bCanPassMountains = bHasGreatAndeanRoad;
	local contID = GetContID(iCity:Plot(), 76542);
	local possCities = {}
	for jCity in Players[iPlayer]:Cities() do
		local jCityIndex = jCity:Plot():GetPlotIndex();
		if not gT.Cities[cID].DoNotCheckRoads[jCityIndex] then
			if not getroadTabRev then
				getroadTabRev = RoadConnections(iCity:Plot(), nil)
				getroadTab = {}
				for iplot, sth in pairs(getroadTabRev) do
					table.insert(getroadTab, Map.GetPlotByIndex(iplot))
				end
			end
			if (not getroadTabRev[jCityIndex]) and (GetContID(jCity:Plot(), 123125) == contID) then
				table.insert(possCities, {jCity, Map.PlotDistance(iCity:GetX(), iCity:GetY(), jCity:GetX(), jCity:GetY())})
			else
				gT.Cities[cID].DoNotCheckRoads[jCity:Plot():GetPlotIndex()] = true;
				if getroadTabRev[jCityIndex] then
					gT.Cities[cID].RoadConnected[jCityIndex] = true;
				end
			end
		end
	end
	table.sort(possCities, SortFunctionForLowestMapDistance)
	for a, bD in pairs(possCities) do
		local jCity = bD[1];
		local jCityIndex = jCity:Plot():GetPlotIndex();
		local targetRoad = RoadConnections(jCity:Plot(), nil);
		local nTab;
		if bNow then
			nTab = GenerateShortestPath(getroadTab, targetRoad, false, 15, nil, nil, nil, nil, bCanPassMountains, nil, iPlayer, true)
		else
			nTab = GenerateShortestPath(getroadTab, targetRoad, false, 15, nil, nil, nil, nil, bCanPassMountains, nil, nil, nil) -- just want to know if possible! doesnt need to be perfect here
		end
		if nTab then
			local fTab = {}
			for i, iPlot in pairs(nTab) do
				if iPlot:GetRouteType() == -1 then
					table.insert(fTab, iPlot)
				end
			end
			if #fTab < 16 then
				return fTab;
			else
				print("Seriously how 3564513868?")
			end 
		end
	end
	local nearbyTab = GetPlotsInRadiusOfPlot(iCity:Plot(), 2);
	local getCRSN = GetCityRoadSystemNearby(iCity:Plot(), nearbyTab)
	local maxhv, thth, gcPlot = 0, {}, nil;
	for i, iPlot in pairs(nearbyTab) do
		if iPlot:GetRouteType() ~= -1 then
			if not getCRSN[iPlot] then
				if GetContID(iPlot, 63432) == contID then
					local cConnectingTAB = GetConnectingPlot(iPlot, iCity:Plot())
					for d, cConnectingPlot in pairs(cConnectingTAB) do
						if (bCanPassMountains or (not cConnectingPlot:IsMountain())) then
							if not cConnectingPlot:IsWater() then
								if not thth[cConnectingPlot] then
									thth[cConnectingPlot] = 1
								else
									thth[cConnectingPlot] = thth[cConnectingPlot] + 1;
								end
								if thth[cConnectingPlot] > maxhv then
									maxhv = thth[cConnectingPlot]
									gcPlot = cConnectingPlot;
								end
							end
						end
					end
				end
			end
		end
	end
	if gcPlot then
		return {gcPlot}
	end
	if bHasGreatAndeanRoad then
		for sth, iiindex in pairs(RequestAllMountains()) do
			local iPlot = Map.GetPlotByIndex(iiindex)
			if iPlot:GetOwner() == iPlayer then
				if not getroadTabRev then
					getroadTabRev = RoadConnections(iCity:Plot(), nil)
					getroadTab = {}
					for iplot, sth in pairs(getroadTabRev) do
						table.insert(getroadTab, Map.GetPlotByIndex(iplot))
					end
				end
				if not getroadTabRev[iPlot:GetPlotIndex()] then
					if GetContID(iPlot, 234623) == contID then
						local targetRoad = RoadConnections(iPlot, nil);
						local nTab = GenerateShortestPath(getroadTab, targetRoad, false, 15, nil, nil, nil, nil, bCanPassMountains)
						if nTab then
							local fTab = {}
							for i, iPlot in pairs(nTab) do
								if iPlot:GetRouteType() == -1 then
									table.insert(fTab, iPlot)
								end
							end
							if #fTab < 16 then
								return fTab;
							end 
						end
					end
				end
			end
		end
	end
	if gT.Players[iPlayer].CultBonusOn[122] then
		for fIndex, fdata in pairs(gT.Forts) do
			if fdata.Player == iPlayer then
				local iPlot = Map.GetPlotByIndex(fIndex)
				if not getroadTabRev then
					getroadTabRev = RoadConnections(iCity:Plot(), nil)
					getroadTab = {}
					for iplot, sth in pairs(getroadTabRev) do
						table.insert(getroadTab, Map.GetPlotByIndex(iplot))
					end
				end
				if not getroadTabRev[iPlot:GetPlotIndex()] then
					if GetContID(iPlot, 62341) == contID then
						local targetRoad = RoadConnections(iPlot, nil);
						local nTab = GenerateShortestPath(getroadTab, targetRoad, false, 15, nil, nil, nil, nil, bCanPassMountains)
						if nTab then
							local fTab = {}
							for i, iPlot in pairs(nTab) do
								if iPlot:GetRouteType() == -1 then
									table.insert(fTab, iPlot)
								end
							end
							if #fTab < 16 then
								return fTab;
							end 
						end
					end
				end
			end
		end
		for fIndex, fdata in pairs(gT.Colonies) do
			if fdata.Player == iPlayer then
				local iPlot = Map.GetPlotByIndex(fIndex)
				if not iPlot:IsWater() then
					if not getroadTabRev then
						getroadTabRev = RoadConnections(iCity:Plot(), nil)
						getroadTab = {}
						for iplot, sth in pairs(getroadTabRev) do
							table.insert(getroadTab, Map.GetPlotByIndex(iplot))
						end
					end
					if not getroadTabRev[iPlot:GetPlotIndex()] then
						if GetContID(iPlot, 62431) == contID then
							local targetRoad = RoadConnections(iPlot, nil);
							local nTab = GenerateShortestPath(getroadTab, targetRoad, false, 15, nil, nil, nil, nil, bCanPassMountains)
							if nTab then
								local fTab = {}
								for i, iPlot in pairs(nTab) do
									if iPlot:GetRouteType() == -1 then
										table.insert(fTab, iPlot)
									end
								end
								if #fTab < 16 then
									return fTab;
								end 
							end
						end
					end
				end
			end
		end
		for fIndex, fdata in pairs(gT.HolySites) do
			if fdata.Player == iPlayer then
				local iPlot = Map.GetPlotByIndex(fIndex)
				if not getroadTabRev then
					getroadTabRev = RoadConnections(iCity:Plot(), nil)
					getroadTab = {}
					for iplot, sth in pairs(getroadTabRev) do
						table.insert(getroadTab, Map.GetPlotByIndex(iplot))
					end
				end
				if not getroadTabRev[iPlot:GetPlotIndex()] then
					if GetContID(iPlot, 62342123) == contID then
						local targetRoad = RoadConnections(iPlot, nil);
						local nTab = GenerateShortestPath(getroadTab, targetRoad, false, 15, nil, nil, nil, nil, bCanPassMountains)
						if nTab then
							local fTab = {}
							for i, iPlot in pairs(nTab) do
								if iPlot:GetRouteType() == -1 then
									table.insert(fTab, iPlot)
								end
							end
							if #fTab < 16 then
								return fTab;
							end 
						end
					end
				end
			end
		end
	end
	--NEW ROAD STUFF
	if gT.Globals.ScenarioType == 4 or gT.Globals.ScenarioType == 5 then
		local bConnected = IsCityConnectedToCapital(iCity)
		local possCities = {}
		getroadTabRev = nil;
		for jCity in Players[iPlayer]:Cities() do
			if IsCityConnectedToCapital(jCity) ~= bConnected then
				if (GetContID(jCity:Plot(), 912742) == GetContID(iCity:Plot(), 5831258235)) then
					if Map.PlotDistance(iCity:GetX(), iCity:GetY(), jCity:GetX(), jCity:GetY()) <= 10 then
						if not getroadTabRev then
							getroadTabRev = RoadConnections(iCity:Plot(), iPlayer)
							getroadTab = {}
							for iplot, sth in pairs(getroadTabRev) do
								table.insert(getroadTab, Map.GetPlotByIndex(iplot))
							end
						end
						local targetRoad = RoadConnections(jCity:Plot(), iPlayer);
						local nTab = GenerateShortestPath(getroadTab, targetRoad, false, 15, iPlayer, nil, nil, nil, bCanPassMountains, nil, iPlayer, true)
						if nTab then
							local fTab = {}
							for i, iPlot in pairs(nTab) do
								if iPlot:GetRouteType() == -1 then
									table.insert(fTab, iPlot)
								end
							end
							if #fTab < 16 then
								return fTab;
							else
								print("Seriously how 523456123?")
							end 
						end
					end
				end
			end
		end
	end
	return {}
end

function MakeCityConsiderNewActionForWorkRate(iCity, cID, iPlayer)
	if gT.Players[iPlayer].HasIdeology[7] then
		if not gT.Cities[cID].CDIdeo7 then
			gT.Cities[cID].CurrentWorkAction = 8;
			return;
		end
	end
	local getNIPT = GetTabOfImprovablePlots(iCity, cID, iPlayer, 3, true)
	local getImproP = GetTabOfImprovablePlots(iCity, cID, iPlayer, 3, false)
	local getNTFP, getNNoMarsh = GetTabOfBadFeaturePlots(iCity, cID, iPlayer, 3)
	local iPop = iCity:GetPopulation();
	gT.Cities[cID].CurrentWorkAction = -1;
	if (#getImproP + #resOutsideRadiusStr) > 0 then
		gT.Cities[cID].CurrentWorkAction = 1;
		if GetCityImprovementCost(cID, iCity, iPlayer) < 700 then
			return;
		end
		if (#getNIPT < iPop) and iPop < 6 then
			return;
		end
	end
	if #resOutsideRadiusStr > 0 then
		if gT.Cities[cID].ImprovementCost >= 1000 then
			if LastRandom(1,4) == 3 then
				return;
			end
		end
	end
	local tOfSpecial = {}
	local tRemoveF = (#getNTFP * 3 + #getNNoMarsh) * gT.Players[iPlayer].FeatureRemovalMod;
	if (iPop * gT.Players[iPlayer].FeatureRemovalMod > 7 or LastRandom(1,3) == 2) and (tRemoveF > 0) then
		if LastRandom(1, 20) <= tRemoveF then
			gT.Cities[cID].CurrentWorkAction = 3;
			return;
		else
			table.insert(tOfSpecial, 3)
		end
	end
	if CanStoreWorkRateForAcademy(iCity, cID, iPlayer) and LastRandom(1, 2) == 2 then
		table.insert(tOfSpecial, 4)
	end
	if CanStoreWorkRateForCitadel(iCity, cID, iPlayer) and LastRandom(1, 2) == 2 then
		table.insert(tOfSpecial, 5)
	end
	if CanStoreWorkRateForFestival(iCity, cID, iPlayer) and LastRandom(1, 2) == 2 then
		table.insert(tOfSpecial, 7)
	end
	if CanStoreWorkRateForTradeRoute(iCity, cID, iPlayer) and LastRandom(1, 2) == 2 then
		table.insert(tOfSpecial, 6)
	end
	if #tOfSpecial > 0 then
		if LastRandom(1, #tOfSpecial + 1) <= #tOfSpecial then
			gT.Cities[cID].CurrentWorkAction = tOfSpecial[LastRandom(1,#tOfSpecial)];
			return;
		end
	end
	if not Players[iPlayer]:IsMinorCiv() then
		if IsThereASenseToMakeRouteNow(iPop, GetITGGameTurn(), gT.Cities[cID].CurrentWorkAction, iPlayer, gT.Cities[cID].WorkRate)  then
			local plotTable = GetNiceRoadFromTheCity(iCity, cID, iPlayer)
			if #plotTable > 0 then
				gT.Cities[cID].ExceptedRoadCost = #plotTable * GetCostOfOneRoad(iPlayer, iCity, cID);
				gT.Cities[cID].CurrentWorkAction = 2;
			end
		end 
	end
end

function IsThereASenseToMakeRouteNow(iPop, gTurn, cWaction, iPlayer, sWorkRate)
	if cWaction == -1 then
		return true;
	end
	if gTurn >= 90 and (sWorkRate < 700) then
		return false;
	end
	local chance = iPop * 7;
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		if gT.Cities[cID].CurrentWorkAction == 2 then
			chance = chance - 20;
		end
	end
	if gT.Globals.ScenarioType == 3 then
		chance = chance + 10;
	end
	if GetITGGameTurn() > LastRandom(40, 60) then --impromevents value will fade
		chance = chance + 20;
	end
	chance = math.min(80, math.max(15, chance));
	return LastRandom(1, 100) <= chance;
end

function CanStoreWorkRateForFestival(iCity, cID, iPlayer)
	if gT.Players[iPlayer].HasIdeology[68] then
		return true;
	end
	return false;
end

function CanStoreWorkRateForTradeRoute(iCity, cID, iPlayer)
	if gT.Players[iPlayer].HasIdeology[38] then
		return true;
	end
	return false;
end

function CanStoreWorkRateForCitadel(iCity, cID, iPlayer)
	if HasPlayerTech(iPlayer, innoindu19, "32423234234f325") then
		return true;
	end
	return false;
end

function CanStoreWorkRateForAcademy(iCity, cID, iPlayer)
	if HasPlayerTech(iPlayer, innoindu20, "324234325") then
		for ha, index in pairs(gT.Cities[cID].Academies) do
			if IsAcademyActiveRightNow(index) then
				return true;
			end
		end
	end
	return false;
end


local HasAlreadyTooGoodImprovement = {
[GameInfoTypes.IMPROVEMENT_ITGSG_ANCIENT_RUINS] = 1,
[GameInfoTypes.IMPROVEMENT_ACADEMY] = 1,
[GameInfoTypes.IMPROVEMENT_CUSTOMS_HOUSE] = 1,
[GameInfoTypes.IMPROVEMENT_MANUFACTORY] = 1}
function HighlightProperPlotsForGreatImprovement(iPlayer, type)
	local hTab = {}
	local improType = GameInfoTypes.IMPROVEMENT_ACADEMY;
	if type == 12 then
		improType = GameInfoTypes.IMPROVEMENT_CUSTOMS_HOUSE;
	elseif type == 13 then
		improType = GameInfoTypes.IMPROVEMENT_MANUFACTORY;
	end
	for iCity in Players[iPlayer]:Cities() do
		for i = 0, 5 do
			local iPlot = Map.PlotDirection(iCity:GetX(), iCity:GetY(), i);
			if iPlot then
				if CanPlayerHaveGreatImproOnPlot(iPlot, iPlayer, improType, false) then
					table.insert(hTab, iPlot)
				end
			end
		end
	end
	MapModData.ITGSG = hTab;
end

function CanPlayerHaveGreatImproOnPlot(iPlot, iPlayer, type, bInitial)
	if iPlot:CanHaveImprovement(type or GameInfoTypes.IMPROVEMENT_ACADEMY, -1) then
		if not IsSpecialControlPlot(iPlot:GetPlotIndex()) then
			if not HasAlreadyTooGoodImprovement[iPlot:GetImprovementType()] then
				if iPlot:GetOwner() == iPlayer then
					if iPlot:GetResourceType(Players[iPlayer]:GetTeam()) == -1 then
						if (type ~= GameInfoTypes.IMPROVEMENT_CUSTOMS_HOUSE) or AdjacentCityHasNoCustomHouse(iPlot) then
							if CanDoWorkOnPlotNow(iPlot, iPlayer) then
								return true;
							end
						end
					end
				end
			end
		end
	end
	return false;
end

function GetCityNameOfAdjacentPlot(iPlot)
	for i = 0, 5 do
		local nPlot = Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), i);
		if nPlot and nPlot:IsCity() then
			return nPlot:GetPlotCity():GetName();
		end
	end
	return "???"
end

function IsAdjacentToAnyCity(iPlot, iPlayer)
	for i = 0, 5 do
		local nPlot = Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), i);
		if nPlot and nPlot:GetOwner() == iPlayer and nPlot:IsCity() then
			return true;
		end
	end
	return false;
end

function PlayerChooseGreatImprovementOnPlot(pPlot, iPlayer, type)
	local improtype = GameInfoTypes.IMPROVEMENT_ACADEMY
	if type == 12 then
		improtype = GameInfoTypes.IMPROVEMENT_CUSTOMS_HOUSE
	elseif type == 13 then
		improtype = GameInfoTypes.IMPROVEMENT_MANUFACTORY
	end
	if CanPlayerHaveGreatImproOnPlot(pPlot, iPlayer, improtype, false) then
		if IsAdjacentToAnyCity(pPlot, iPlayer) then
			local hex = ToHexFromGrid(Vector2(pPlot:GetX(),pPlot:GetY()));
			Events.GameplayFX(hex.x, hex.y, -1)
			if type == 11 then
				CreateNewImprovementOnPlot(pPlot, GameInfoTypes.IMPROVEMENT_ACADEMY, false)
				DoFindAndGlorifyGPForAcademy(iPlayer, pPlot)
			elseif type == 12 then
				CreateNewImprovementOnPlot(pPlot, GameInfoTypes.IMPROVEMENT_CUSTOMS_HOUSE, false)
				DoFindAndGlorifyGPForCustomsHouse(iPlayer, pPlot)
			elseif type == 13 then
				CreateNewImprovementOnPlot(pPlot, GameInfoTypes.IMPROVEMENT_MANUFACTORY, false)
				DoFindAndGlorifyGPForManufactory(iPlayer, pPlot)
			end
		end
	end
end

function GetNiceValidPlotForAcademyAI(iPlayer)
	local hTab = {}
	for iCity in Players[iPlayer]:Cities() do
		if not IsCityThreatened(iCity, iPlayer, true) then
			if (iCity:IsResistance() or iCity:IsPlague()) and iCity:IsCapital() then
				return; -- no need to decide now;
			end
			local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
			local numAcas = #gT.Cities[cID].Academies * 2 + 1;
			local sciencePT = (math.floor(iCity:GetYieldRateTimes100(yScience) / 100) + GetAcademyPrestigeForGPInCity(iCity) + gT.Cities[cID].AcademyPassiveGen) / numAcas;
			for i = 0, 5 do
				local iPlot = Map.PlotDirection(iCity:GetX(), iCity:GetY(), i);
				if iPlot then
					if CanPlayerHaveGreatImproOnPlot(iPlot, iPlayer, GameInfoTypes.IMPROVEMENT_ACADEMY, false) then
						if iPlot:GetResourceType(Players[iPlayer]:GetTeam()) == -1 then
							table.insert(hTab, {iPlot, math.max(1,sciencePT)})
						end
					end
				end
			end
		end
	end
	if #hTab > 0 then
		return GetRandomFromBiasedChanceTable(hTab)
	end
	return;
end

function HandleAIGreatImprovementPoints(iPlayer)
	if #gT.Players[iPlayer].ManufactoryPoints > 0 then
		local pPlot = GetNiceValidPlotForManufactoryAI(iPlayer);
		if pPlot then
			CreateNewImprovementOnPlot(pPlot, GameInfoTypes.IMPROVEMENT_MANUFACTORY, false)
			DoFindAndGlorifyGPForManufactory(iPlayer, pPlot)
		end
	end
	if #gT.Players[iPlayer].AcademyPoints > 0 then
		local pPlot = GetNiceValidPlotForAcademyAI(iPlayer);
		if pPlot then
			CreateNewImprovementOnPlot(pPlot, GameInfoTypes.IMPROVEMENT_ACADEMY, false)
			DoFindAndGlorifyGPForAcademy(iPlayer, pPlot)
		end
	end
	if #gT.Players[iPlayer].CustomHousePoints > 0 then
		local pPlot = GetNiceValidPlotForCustomsHouseAI(iPlayer);
		if pPlot then
			CreateNewImprovementOnPlot(pPlot, GameInfoTypes.IMPROVEMENT_CUSTOMS_HOUSE, false)
			DoFindAndGlorifyGPForCustomsHouse(iPlayer, pPlot)
		end
	end
	if not gT.Players[iPlayer].HandleExistingGImproT then
		gT.Players[iPlayer].HandleExistingGImproT = GetITGGameTurn() + LastRandom(5,7);
	elseif gT.Players[iPlayer].HandleExistingGImproT <= GetITGGameTurn() then
		MakeAIChangeCustomsHousesTraits(iPlayer)
		MakeAIDoManufactories(iPlayer)
		gT.Players[iPlayer].HandleExistingGImproT = GetITGGameTurn() + LastRandom(5,7);
	end
end

function DoFindAndGlorifyGPForAcademy(iPlayer, pPlot)
	for i, pGP in pairs(gT.Players[iPlayer].AcademyPoints) do
		if gT.GreatPeople[pGP] then
			gT.GreatPeople[pGP].LifeDone = "Created an Academy of " .. GetCityNameOfAdjacentPlot(pPlot) .. ".";
			DoAddFounderToAcademy(pPlot, pGP)
			if Players[iPlayer]:IsHuman() then
				LuaEvents.ITG_AchievementCompleted(51)
			end
		end
		break;
	end
	table.remove(gT.Players[iPlayer].AcademyPoints, 1)
end

function DoFindAndGlorifyGPForManufactory(iPlayer, pPlot)
	for i, pGP in pairs(gT.Players[iPlayer].ManufactoryPoints) do
		if gT.GreatPeople[pGP] then
			gT.GreatPeople[pGP].LifeDone = "Constructed a Manufactory near " .. GetCityNameOfAdjacentPlot(pPlot) .. ".";
		end
		break;
	end
	table.remove(gT.Players[iPlayer].ManufactoryPoints, 1)
end

function DoFindAndGlorifyGPForCustomsHouse(iPlayer, pPlot)
	for i, pGP in pairs(gT.Players[iPlayer].CustomHousePoints) do
		if gT.GreatPeople[pGP] then
			gT.GreatPeople[pGP].LifeDone = "Funded a Customs House near " .. GetCityNameOfAdjacentPlot(pPlot) .. ".";
		end
		break;
	end
	table.remove(gT.Players[iPlayer].CustomHousePoints, 1)
end

function CityRemovedFeature(iCity, iPlayer, featureType, bImpro, tPlot)
	if iCity then
		if gT.Globals.GameGenerated then
			local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
			gT.Cities[cID].FeaturesRemoved = gT.Cities[cID].FeaturesRemoved + 1; 
			if HasPlayerTech(iPlayer, ancTcs11, "dedaedaecc") then
				iCity:ChangeMaxHitPoints(25)
				ChangeITGCityInteger(iCity, "CI_HEALTH_FROM_INNO", 1)
				tPlot:SetRouteType(rRoad)
			end
		end
	end
end

function GetCultINDFromMtFuji(iPlayer)
	if HasPlayerNatureWonder(iPlayer, GameInfoTypes.FEATURE_FUJI) then
		return {8, "Mt Fuji", 0};
	end	
	return {0, "", 0};
end

function GetNumUnimprovedFeaturesAdjacent(iPCU)
	local b = 0;
	for i = 0, 5 do
		local nPlot = Map.PlotDirection(iPCU:GetX(), iPCU:GetY(), i)
		if nPlot then
			if BadFeature[nPlot:GetFeatureType()] then
				if nPlot:GetImprovementType() == -1 then
					b = b + 1;
				end
			end
		end
	end
	return b;
end

function GetRiotLevelFromInnovation(iCity, iPlayer)
	local b = 0;
	if HasPlayerTech(iPlayer, ancTribeInno16, "grtgeadad") then
		b = b - GetNumUnimprovedFeaturesAdjacent(iCity)
	end
	return b;
end

function GetCultINDFromOneWithNature(iPlayer)
	local b = 0;
	if HasPlayerTech(iPlayer, ancTribeInno16, "evefrwad") then
		for iCity in Players[iPlayer]:Cities() do
			b = b + GetNumUnimprovedFeaturesAdjacent(iCity)
		end
		for index, sth in pairs(gT.Players[iPlayer].DiscoveredNaturalWonders) do
			b = b + 5;
		end
	end
	return {b, "One with Nature", 0};
end

function IsDemolitionPrevented(iCity, cID, iPlayer, buildingType)
	if gT.Players[iPlayer].HasIdeology[25] then
		if gT.Players[iPlayer].Inspirations[GameInfoTypes[GameInfo.Buildings[buildingType].BuildingClass]] then
			return true;
		end
	end
	return false;
end

function IsCityConnectedToCapital(iCity)
	if iCity:IsCapital() then
		return true;
	end
	return Players[iCity:GetOwner()]:IsCapitalConnectedToCity(iCity)
end

function CreateGPImprovementNearCapital(iPlayer, impro)
	local iCity = Players[iPlayer]:GetCapitalCity();
	if iCity then
		local tab = {}
		for i = 0, 5 do
			local iPlot = Map.PlotDirection(iCity:GetX(), iCity:GetY(), i);
			if iPlot then
				if CanPlayerHaveGreatImproOnPlot(iPlot, iPlayer, impro, false) then
					table.insert(tab, iPlot);
				end
			end
		end
		if #tab > 0 then
			CreateNewImprovementOnPlot(tab[LastRandom(1,#tab)], impro, false)
		end
	end
end