local g_InfoIM = InstanceManager:new( "SmallInfoInstance",  "Anchor", ContextPtr:LookUpControl("/InGame/ResourceIconManager/ITGLabelIconContainer") );
local SmallInfoT = {}
local GeoNames = {}
GeoNames[1] = {"Nile", "Amazon", "Yangtze", "Mississippi", "Missouri", "Jefferson", "Yenisei", "Angara", "Selenge", "Huang He", "Ob-Irtysh", "Rio de la Plata", "Congo", "Chambeshi", "Amur", "Argun", "Lena", "Mekong", "Mackenzie", "Slave", "Peace", "Finlay", "Niger", "Murray", "Darling", "Tocantins", "Araguaia", "Volga", "Euphrates", "Shatt al-Arab", "Madeira", "Yukon", "Indus", "Rio Grande", "Salween", "Zambezi", "Araguaia", "Kolyma", "Vitim", "Xingu", "Don", "Pechora", "Kama", "Han", "Pecos", "Okavango"}
GeoNames[2] = {"Kalahari", "Karoo", "Namib", "Danakil", "Guban", "Grand Bara", "Ogaden", "Chalbi", "Nyiri", "Lompoul", "Sahara", "Tanezrouft", "El Djouf", "Djurab", "Tin-Toumma", "Libyan", "White", "Nubian", "Bayuda", "Sinai", "Blue", "Al-Dahna", "Nefud", "Wahiba", "Cholistan", "Dasht-i-Margo", "Gobi", "Kara Kum", "Kharan", "Kyzyl", "Lop", "Ordos", "Taklamakan", "Thal", "Thar", "Negev", "Maranjab", "Accona", "Bardenas", "Larzac", "Monegros", "Oleshky", "Oltenian"}
local AncientRuinsI = GameInfoTypes.IMPROVEMENT_ITGSG_ANCIENT_RUINS;
local GeoName = {"River", "Desert"}

local g_LabelIconByType = {
["AncientRuin"] = "[ICON_RES_ARTIFACTS]",
["HolySite"] = "[ICON_RELIGION]",
["Manufactory"] = "[ICON_ITG_MANUFACTORY]",
["Satellite"] = "[ICON_ITG_SATELLITE]",
["Settlement"] = "[ICON_TRADE_WHITE]",
["GreatExplorer"] = "[ICON_GREAT_EXPLORER]",
["Fort"] = "[ICON_RANGE_STRENGTH]",
["Customs House"] = "[ICON_ITG_CUSTOMS_HOUSE]",
["Archaeology"] = "[ICON_RES_ARTIFACTS]",
["AcademyExpedition"] = "[ICON_GREAT_EXPLORER]",
["ElDorado"] = "[ICON_CONNECTED]",
["ShinobiVision"] = "[ICON_SPY]",
["Academy"] = "[ICON_ITG_ACADEMY_2]",
--["Colony"] ~ various icons
}

-- Globals
local Instances = {};
local SVInstances = {};
local WorldPositionOffset = { x = 0, y = 0, z = 0 };
local WorldPositionOffsetName = { x = 0, y = -15, z = 0 };
local TempPreLoadCache = {}
local DirOffsets = {{ x = 11, y = 11, z = 0 }, { x = 18, y = 0, z = 0 }, { x = 11, y = -11, z = 0 }, { x = -11, y = -11, z = 0 }, { x = -18, y = 0, z = 0 }, { x = -11, y = 11, z = 0 }}

function ITGLinkInfoLabel(a,b)
	OnInfoLabel(a,b)
end

function OnInfoLabel(type, plotIndex)
	if IsGameCoreBusy() then
		return;
	end
	if not Players[Game.GetActivePlayer()]:IsTurnActive() then
		return;
	end
	if UI.IsCameraMoving() then -- added in v24
		return;
	end
	if type == 1 then
		LuaEvents.ITG_CallStateOverview(1, plotIndex)
	elseif type == 2 then
		LuaEvents.ITG_CallStateOverview(4, plotIndex)
	elseif type == 3 then
		LuaEvents.ITG_CallStateOverview(5, plotIndex)
	elseif type == 4 then
		LuaEvents.ITG_CallHolySite(plotIndex) -- events popup was too heavy?
	end
end

function DoCreateLabels()
	for i, data in pairs(gT.LabelsToAdd) do
		AddSmallInfo(Map.GetPlotByIndex(data[1]), data[2], data[3], data[4], data[5], data[6], data[7], data[8])
	end
	gT.LabelsToAdd = {}
end
	
function AddSmallInfo(iPlot, iText, types, remade, dir, subtype, linkType, tPlayer)
	if (not Players[Game.GetActivePlayer()]:IsTurnActive()) then
		table.insert(gT.LabelsToAdd, {iPlot:GetPlotIndex(), iText, types, remade, dir, subtype, linkType, tPlayer})
		return;
	end
	local HexPos = HexToWorld(ToHexFromGrid(Vector2(iPlot:GetX(), iPlot:GetY())));
	local controlTable = g_InfoIM:GetInstance();
	local offset = WorldPositionOffset;
	if g_LabelIconByType[types] then
		controlTable.InfoLabel:SetText(g_LabelIconByType[types])
	elseif types == "Colony" then
		controlTable.InfoLabel:SetText(GameInfo.Resources[iText].IconString)
	else
		controlTable.InfoLabel:SetText(iText or "ERROR452")
	end
	if dir then
		print("Direction", dir, iTooltip)
		offset = DirOffsets[dir + 1];
	end
	controlTable.InfoLabel:SetToolTipString(GetInfoLabelToolTip(types, iPlot:GetPlotIndex(), tPlayer))
	if types == "Name" then
		if not dir then
			offset = WorldPositionOffsetName;
		end
		if subtype == "Geo1" then
			controlTable.InfoLabel:SetText("[COLOR_CITY_BLUE]" .. iText .."[ENDCOLOR]")
		elseif subtype == "Geo2" then
			controlTable.InfoLabel:SetText("[COLOR_CITY_BROWN]" .. iText .."[ENDCOLOR]")
		end
		controlTable.GridH:SetSizeX(string.len(iText) * 8 + 7)
		controlTable.GPBox:SetAlpha(0.8)
		controlTable.GridH:SetAlpha(0.3)
	end
	local ipindex = iPlot:GetPlotIndex();
	controlTable.Anchor:SetWorldPosition( VecAdd( HexPos, offset ) );
	if not SmallInfoT[ipindex] then
		SmallInfoT[ipindex] = {}
	end
	if ContextPtr:LookUpControl("/InGame/ResourceIconManager/ITGLabelIconContainer") then
		controlTable.Anchor:ChangeParent(ContextPtr:LookUpControl("/InGame/ResourceIconManager/ITGLabelIconContainer"))
	end
	table.insert(SmallInfoT[ipindex], {Inst = controlTable, Type = types, Player = tPlayer})
	ShouldBeVisibleOrNot(SmallInfoT[ipindex][#SmallInfoT[ipindex]], iPlot)
	if linkType then
		controlTable.LinkButton:SetVoid1(linkType)	
		controlTable.LinkButton:SetVoid2(iPlot:GetPlotIndex())
		controlTable.LinkButton:RegisterCallback(Mouse.eLClick, ITGLinkInfoLabel);
	else
		controlTable.LinkButton:SetVoid1(0)	
		controlTable.LinkButton:SetVoid2(0)
		controlTable.LinkButton:ClearCallback(Mouse.eLClick)
	end
	if not gT.Globals.InfoLabels[iPlot:GetPlotIndex()] then
		gT.Globals.InfoLabels[iPlot:GetPlotIndex()] = {}
	end
	if not remade then
		table.insert(gT.Globals.InfoLabels[iPlot:GetPlotIndex()], {Text = iText, Type = types, Direction = dir, Link = linkType, Player = tPlayer})
	end
end

function ShouldBeVisibleOrNot(data, iPlot, fPlayer)
	if (data.Player) and (data.Player ~= (fPlayer or Game.GetActivePlayer())) then
		data.Inst.GPBox:SetHide(true)
	else
		data.Inst.GPBox:SetHide(not iPlot:IsRevealed(Game.GetActiveTeam()))
	end
end

------------------------------------------------------------
------------------------------------------------------------
function OnHexFogEvent( hexPos, fowType, bWholeMap )
    local gridPosX, gridPosY = ToGridFromHex( hexPos.x, hexPos.y );
	local plot = Map.GetPlot( gridPosX, gridPosY );
	if plot then
		local ipindex = plot:GetPlotIndex();
		if SmallInfoT[ipindex] then
			for i, data in pairs(SmallInfoT[ipindex]) do
				ShouldBeVisibleOrNot(data, plot)
			end
		end
	end
end
Events.HexFOWStateChanged.Add( OnHexFogEvent );

function rtt()
	return SmallInfoT;
end

function GetHolySiteLabelOfPlot(ipindex)
	if SmallInfoT[ipindex] then
		for i, data in pairs(SmallInfoT[ipindex]) do
			if data.Type == "HolySite" then
				return data.Inst;
			end
		end
	end
	return nil;
end

function HasNameLabelOn(rPlot)
	local ipindex = rPlot:GetPlotIndex();
	if SmallInfoT[ipindex] then
		for i, data in pairs(SmallInfoT[ipindex]) do
			if data.Type == "Name" then
				return true;
			end
		end
	end
	return false;
end

function IsRiverBetweenPlot(iPlot, bPlot, i)
	if i == 0 then
		return bPlot:IsNEOfRiver()
	elseif i == 1 then
		return iPlot:IsWOfRiver();
	elseif i == 2 then
		return iPlot:IsNWOfRiver();
	elseif i == 3 then
		return iPlot:IsNEOfRiver()
	elseif i == 4 then
		return bPlot:IsWOfRiver();
	else
		return bPlot:IsNWOfRiver();
	end
	return false;
end

function GetMostProperPlotFrom(riverData, id)
	local max, mplot, dir = 0, nil, nil;
	for iPlot, sth in pairs(riverData) do
		if not HasNameLabelOn(iPlot) then
			local b, kdir = 0, nil;
			for i = 0, 5 do
				local bPlot = Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), i);
				if bPlot then
					if riverData[bPlot] then
						b = b + 1;
						if id == 1 then
							if IsRiverBetweenPlot(iPlot, bPlot, i) then
								kdir = i;
							end
						end
					end
				end
			end
			if b > max then
				max, mplot, dir = b, iPlot, kdir;
			end
		end
	end
	return mplot, dir;
end

--[[
function CallNamesForRivers(gRiverT, RiverLength, ID)
	GeoNames[ID] = Shuffle(GeoNames[ID])
	if not gT.Globals.RiverNames then
		gT.Globals.RiverNames = {}
	end
	gT.Globals.RiverNames[ID] = {}
	for riverID, riverData in pairs(gRiverT) do
		if RiverLength[riverID] > 4 then
			local rPlot, dir = GetMostProperPlotFrom(riverData, ID);
			local rName = GeoNames[ID][riverID] or "TooLittleNames";
			AddSmallInfo(rPlot, rName, rName .. " " .. GeoName[ID], "Name", nil, dir, "Geo" .. ID)
			--questionable if needed
			gT.Globals.RiverNames[ID][riverID] = {Name = rName, Plot = rPlot:GetPlotIndex()}
		end
	end
end ]]

function RenToFAncientRuing(iPlotIndex, iPlayer)
	return (not Map.GetPlotByIndex(iPlotIndex):AlreadyVisitedGoodyHut(Players[iPlayer]:GetTeam()))
end
function RenToFSettlement(iPlotIndex, iPlayer)
	return (gT.Settlements[iPlotIndex] ~= nil)
end
local fRenTOfLRC = {AncientRuin = RenToFAncientRuing, Settlement = RenToFSettlement}
function RenewTheInfoLabels()
	local gActivePlayer = Game.GetActivePlayer()
	for iPlotIndex, data in pairs(gT.Globals.InfoLabels) do
		for v, mdata in pairs(data) do
			if (not fRenTOfLRC[mdata.Type]) or fRenTOfLRC[mdata.Type](iPlotIndex, mdata.Player) then
				AddSmallInfo(Map.GetPlotByIndex(iPlotIndex), mdata.Text, mdata.Type, true, mdata.Direction, nil, mdata.Link, mdata.Player)
			end
		end
	end
end

function PrepareAncientRuinLabel(aPlot, bool)
	for g, gdd in pairs(gT.Players) do
		if gdd.IsHuman then
			if not aPlot:AlreadyVisitedGoodyHut(Players[g]:GetTeam()) then
				AddSmallInfo(aPlot, nil, "AncientRuin", nil, nil, nil, nil, g)
			end
		end
	end
end

function RemoveLabelOnPlot(iPlot, name, bNoPrints, bInfoClean, ePlayer, bOnlyInfoClean)
	local ipindex = iPlot:GetPlotIndex();
	if SmallInfoT[ipindex] and (not bOnlyInfoClean) then
		local toRemove, gToRemove = {}, {};
		for i, data in pairs(SmallInfoT[ipindex]) do
			if data.Type == name then
				if ((not ePlayer) or (not data.Player) or (ePlayer == data.Player)) then
					table.insert(toRemove, i);
					g_InfoIM:ReleaseInstance(data.Inst)
				elseif (ePlayer and (not data.Player)) or ((not ePlayer) and (data.Player)) then
					print("Very bady info label removing", ePlayer, data.Player, name)
				end
			end
		end
		if #toRemove > 0 then
			for i, b in pairs(toRemove) do
				table.remove(SmallInfoT[ipindex], toRemove[#toRemove + 1 - i])
			end
		elseif not bNoPrints then
			print("Havent found info label to remove!", iPlot:GetPlotIndexx(), it, name)
		end
		for it, data in pairs(gT.Globals.InfoLabels[iPlot:GetPlotIndex()]) do
			if data.Type == name and ((not ePlayer) or (not data.Player) or (ePlayer == data.Player)) then
				table.insert(gToRemove, it);
			end
		end	
		if #gToRemove > 0 then
			for i, b in pairs(gToRemove) do
				table.remove(gT.Globals.InfoLabels[iPlot:GetPlotIndex()], gToRemove[#gToRemove + 1 - i])
			end
		end
		if not bNoPrints then
			for it, data in pairs(gT.Globals.InfoLabels[iPlot:GetPlotIndex()]) do
				if data.Type == name and ((not ePlayer) or (not data.Player) or (ePlayer == data.Player)) then
					print("Despite removing there is still info label!", iPlot:GetPlotIndex(), it, name, gToRemove)
				end
			end	
		end
	end
	if bInfoClean then
		if not gT.InfoClean then
			gT.InfoClean = {}
		end
		table.insert(gT.InfoClean, {iPlot:GetPlotIndex(), name, ePlayer})
	end
end

function CallChangeParentsOfAnchor()
	if SmallInfoT then
		for ipindex, data in pairs(SmallInfoT) do
			for int, mdata in pairs(data) do
				mdata.Inst.Anchor:ChangeParent(ContextPtr:LookUpControl("/InGame/ResourceIconManager/ITGLabelIconContainer"))
			end
		end
	end
end

function RefreshReligionSitesLabels()
-- this actually triggers only on first init
	for plotindex, data in pairs(gT.HolySites) do
		AddSmallInfo(Map.GetPlotByIndex(plotindex), nil, "HolySite", nil, nil, nil, 4)
	end
end

function RefreshReligionLabelOnPlot(plotindex)
	local inst = GetHolySiteLabelOfPlot(plotindex)
	if inst then
		inst.InfoLabel:SetToolTipString(GetInfoLabelToolTip("HolySite", plotindex, nil))
	else
		for i, v in pairs(gT.LabelsToAdd) do
			if v[1] == plotindex and v[3] == "HolySite" then
				return;
			end
		end
		AddSmallInfo(Map.GetPlotByIndex(plotindex), nil, "HolySite", nil, nil, nil, 4)
	end
end

function OnInfoLabelsActivePlayerChanged( iActivePlayer, iPrevActivePlayer )
	print("Starting Info labels", iActivePlayer, iPrevActivePlayer, os.clock())
	CleanGTInfoLabels()
	for ipindex, data in pairs(SmallInfoT) do
		local plot = Map.GetPlotByIndex(ipindex);
		for i, v in pairs(data) do
			ShouldBeVisibleOrNot(v, plot, iActivePlayer)
		end
	end
	print("Ended Info labels", os.clock())
	if iPrevActivePlayer and gT and gT.Players and gT.Players[iPrevActivePlayer] then
		if not gT.Players[iPrevActivePlayer].AIFavourOfLaws then
			if not Players[iPrevActivePlayer]:IsHuman() then
				print("Noticed Human status player changed", iPrevActivePlayer)
				gT.Players[iPrevActivePlayer].AIFavourOfLaws = {}
				PrepareAIFavoursOfLaws(iPrevActivePlayer)
			end
		end
	end
	bITGObserverMode = (not Players[iActivePlayer]:IsEverAlive())
end
Events.GameplaySetActivePlayer.Add(OnInfoLabelsActivePlayerChanged);

function GetInfoLabelToolTip(types, plotindex, hPlayer)
	if types == "AncientRuin" then
		return "Those Ancient Ruins are not visited yet!"
	elseif types == "HolySite" then
		local sText = gT.HolySites[plotindex].Name .. " Holy Site:"
		for it , relID in pairs(gT.HolySites[plotindex].Religions) do
			local relPressure = gT.HolySites[plotindex].ActiveReligions[relID] or 0;
			if relPressure == 0 then
				sText = sText .. "[NEWLINE][ICON_BULLET]" .. GameInfo.Religions[relID].IconString .. " " .. Locale.Lookup(Game.GetReligionName(relID));
			else
				sText = sText .. "[NEWLINE][ICON_BULLET]" .. GameInfo.Religions[relID].IconString .. " " .. Locale.Lookup(Game.GetReligionName(relID)) .. " (+" .. relPressure .. ")";
			end
		end
		return sText;
	elseif types == "Fort" then
		return "The structure can be conquered by simply defeating Garrison."
	elseif types == "Settlement" then
		return "The structure can be destroyed before becoming a new city."
	elseif types == "GreatExplorer" then
		return "Our great explorer is currently there.";
	elseif types == "Academy" then
		return gT.Academies[plotindex].Name;
	elseif types == "Manufactory" then
		return gT.Manufactories[plotindex].Name;
	elseif types == "Colony" then
		return "The Colony can be conquered."
	elseif types == "ElDorado" then
		return "Mythical Golden City."
	elseif types == "ShinobiVision" then
		return "Shinobi are providing vision within 3 range."
	elseif types == "Customs House" then
		local iCity = GetAdjacentCity(Map.GetPlotByIndex(plotindex))
		if iCity then
			return "Customs House of " .. iCity:GetName();
		else
			return "ERROR 7yg546/3"
		end
	elseif types == "Archaeology" then
		return "Scholars think this place hides [COLOR_SELECTED_TEXT]" .. gT.ArchaeologyPlots[plotindex].Name .. "[ENDCOLOR].";
	elseif types == "Satellite" then
		local satName = "ERROR 9g46/f"
		for iSat, data in pairs(gT.Players[hPlayer].Satellites) do
			if data.Pos == plotindex then
				satName = data.Name 
				break;
			end
		end
		return "Satellite " .. satName .. " is providing vision within 5 range."
	elseif types == "AcademyExpedition" then
		local sAcaName = "ERROR 9btr4l/4";
		for iAca, data in pairs(gT.Academies) do
			if data.LabelExpedition == plotindex then
				if data.Player == hPlayer then
					sAcaName = data.Name;
					break;
				end
			end
		end
		return "Expedition from " .. sAcaName .. " is currently established here."
	end
	return "";
end