local mesoSGR = GameInfoTypes.UNIT_ITG_MESO_BARB_TRAINING;
local improElDorado = GameInfoTypes.IMPROVEMENT_ITG_ELDORADO;
local uGarrison = GameInfoTypes.UNIT_GARRISON;
local uNaureasean = GameInfoTypes.UNIT_ITG_NW_ELEPHANT_KNIGHT;
local euro7tech = GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_EUROPE_7;
local artInnoguilds = GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_EUROPE_2
local arab3tech = GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_ARAB_3;
local afr3tech = GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_AFR_3
local innomodern21 = GameInfoTypes.TECH_UNIQUE_ITG_MODERN_21;
local cMilit = GameInfoTypes.BUILDINGCLASS_MILITARY_BASE;
local afr2tech = GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_AFR_2;
local meso5inno = GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_MESOAMERICAN_5
local afr5tech = GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_AFR_5
local afr6tech = GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_AFR_6
local afr7tech = GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_AFR_7
local innoTrialEuro3 = GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_EURO_3
local innoTrialEuro4 = GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_EURO_4
local meso3 = GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_MESOAMERICAN_3;
local asian8 = GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_ASIA_8
local techTRIALpagan5 = GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_PAGAN_5;
local techTRIALpagan8 = GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_PAGAN_8;
local techTRIALHorde1 = GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_HORDE_1;
local techTRIALHorde7 = GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_HORDE_7;
local techTRIALviking5 = GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_VIKING_5
local techTRIALviking4 = GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_VIKING_4
local techTRIALviking1 = GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_VIKING_1
local ancTRinno13 = GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_TRIBE_13
local malborkcastle1 = GameInfoTypes.BUILDING_ITG_NEW_MEDIEVAL_WONDER_7;
local ae4inno = GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_EMPIRE_4
local rRoad = GameInfoTypes.ROUTE_ROAD;
local techANCemp7 = GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_EMPIRE_7;
local tAncientTR18 = GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_TRIBE_18;
local tAncientCS16 = GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_16;
local tAncientCS19 = GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_19;
local indo16inno = GameInfoTypes.TECH_UNIQUE_ITG_INDUSTRIAL_16;
local innoindu7 = GameInfoTypes.TECH_UNIQUE_ITG_INDUSTRIAL_7;

function HighlighProperPlotsForShinobiVisionModifier(iPlayer)
	local iTeam = Players[iPlayer]:GetTeam();
	local hTab = {}
	for i = 0, Map:GetNumPlots() - 1, 1 do
		local fPlot = Map.GetPlotByIndex( i );
		if fPlot:IsRevealed(iTeam) then
			if not fPlot:IsWater() then
				if i ~= gT.Players[iPlayer].ShinobiVisionPlot then
					table.insert(hTab, fPlot)
				end
			end
		end
	end
	MapModData.ITGSG = hTab;
end

function HighlighProperPlotsResMovement(iPlayer)
	local iTeam = Players[iPlayer]:GetTeam();
	local hTab = {}
	for g, h in pairs(gT.Players) do
		if g ~= iPlayer then
			for iCity in Players[g]:Cities() do
				if CanCityStartUprising(iCity:Plot(), iCity, iPlayer) then
					table.insert(hTab, iCity:Plot());
				end
			end
		end
	end
	MapModData.ITGSG = hTab;
end

function HighlighProperPlotsForMesoElDorado(iPlayer)
	local hTab = {}
	for i = 0, Map:GetNumPlots() - 1, 1 do
		local fPlot = Map.GetPlotByIndex( i );
		if CanBeAElDorado(fPlot, iPlayer) then
			table.insert(hTab, fPlot)
		end
	end
	MapModData.ITGSG = hTab;
end

function CanBeAElDorado(fPlot, iPlayer)
	local fIndex = fPlot:GetPlotIndex()
	if fPlot:GetOwner() == iPlayer then
		if not gT.Forts[fIndex] then
			if IfCanBeFortTrivial(fPlot) then
				if not FortAdjacentToThePlot(fPlot) then
					if IsEmptyEnoughOfEnemyUnitsPlot(fPlot, iPlayer) then
						return true;
					end
				end
			end
		end
	end
	return false;
end

function IsEmptyEnoughOfEnemyUnitsPlot(fPlot, fPlayer, bOnlyFreeSpace)
	if fPlot:GetNumUnits() == 0 or (fPlot:GetUnit(0):GetOwner() == fPlayer and GameInfo.Units[fPlot:GetUnit(0):GetUnitType()].StackITGType ~= -2) then
		return true;
	end
	return false;
end

function IsValidPlotForMesoSGR(nPlot, iPlayer)
	if not nPlot:IsWater() then
		if nPlot:GetOwner() == iPlayer then
			if not nPlot:IsMountain() then
				if nPlot:GetNumUnits() == 0 then
					if not IsSpecialControlPlot(nPlot) then
						return true;
					end
				end
			end
		end
	end
	return false;
end

function CanPlayerCaptureElDoradoOrPlunderIt(iPlayer)
	if Players[iPlayer]:IsBarbarian() then
		return true;
	end
	if gT.Players[iPlayer].CultureType == 2 and gT.Players[iPlayer].SubcultureType == nil then
		return true;
	end
	return false;
end

function PlayerChooseElDoradoOnPlot(pPlot, iPlayer)
	if CanBeAElDorado(pPlot, iPlayer) then
		gT.Players[iPlayer].MesoElDoradoPoints = gT.Players[iPlayer].MesoElDoradoPoints - 1;
		DoNewElDorado(pPlot, iPlayer)
	end
end

function DoNewElDorado(iPlot, iPlayer)
	local hTeam = Players[iPlayer]:GetTeam();
	for g, h in pairs(gT.Players) do
		local gTeam = Players[g]:GetTeam();
		if gTeam ~= hTeam then
			if iPlot:IsRevealed(gTeam) and (not iPlot:IsVisible(gTeam)) then
				HidePlotDuringGame(gTeam, iPlot)
			end
		end
	end

	iPlot:SetOwner(iPlayer, GetClosestCityIDToPlotOrNil(iPlayer, iPlot));
	MakeJumpAwayFromSpecialPoint(iPlayer, iPlot)
	gT.PlotFortControl[iPlot:GetPlotIndex()] = nil;
	for i = 1, 3 do
		local jUnit = Players[iPlayer]:InitUnit(uGarrison, iPlot:GetX(), iPlot:GetY())
		jUnit:SetBaseCombatStrength(17);
		jUnit:SetBaseRangedCombatStrength(17)
		local jID = jUnit:GetID() .. "," .. iPlayer .. "," .. jUnit:GetGameTurnCreated();
		jUnit:SetMoves(0)
		if jUnit:GetPlot():IsVisible(Game.GetActiveTeam()) then
			local hex = ToHexFromGrid(Vector2(jUnit:GetX(), jUnit:GetY()));
			Events.GameplayFX(hex.x, hex.y, -1);
		end
		gT.ElDoradoByUnitID[jID] = iPlot:GetPlotIndex();
		gT.Players[iPlayer].UnitsByID[jID] = {XP = 0}
	end
	gT.ElDorados[iPlot:GetPlotIndex()] = {Player = iPlayer, ControlPlayer = iPlayer}
	iPlot:SetSpecialControl(true)
	iPlot:SetImprovementType(improElDorado, -1)
	iPlot:SetImprovementPillaged(false);
	iPlot:SetCanHaveYield(false)
	AddSmallInfo(iPlot, nil, "ElDorado")
	for jjh, human in pairs(gT.Globals.HumanPlayers) do
		if iPlayer ~= human then
			if gT.Players[human].CultureType ~= 2 or gT.Players[human].SubcultureType ~= nil then
				Players[human]:AddNotification(1242141255, "There are rumours about a golden city, far, far away.", "Legend of El Dorado", -1, -1, 0, 1)
			end
		end
	end
end

function PlayerChooseMesoSGROnPlot(pPlot, iPlayer)
	if IsValidPlotForMesoSGR(pPlot, iPlayer) then
		local bCityAdj;
		for iCity in Players[iPlayer]:Cities() do
			if Map.PlotDistance(pPlot:GetX(), pPlot:GetY(), iCity:GetX(), iCity:GetY()) == 1 then
				bCityAdj = iCity;
				break
			end
		end
		if bCityAdj then
			if IsFullyControlled(bCityAdj, iPlayer) then
				DoMesoSGROnPlot(pPlot, iPlayer)
			end
		end
	end
end

function DoMesoSGROnPlot(pPlot, iPlayer)
	gT.Players[iPlayer].MesoSGRPoints = gT.Players[iPlayer].MesoSGRPoints - 1;
	local jUnit = Players[63]:InitUnit(mesoSGR, pPlot:GetX(), pPlot:GetY())
	jUnit:SetIsUnjoinable(true);
	jUnit:ChangeMaxHitPoints(400);
	jUnit:SetBaseCombatStrength(12);
end

function HighlighProperPlotsForMesoSGRModifier(iPlayer)
	local hTab = {}
	for iCity in Players[iPlayer]:Cities() do
		if IsFullyControlled(iCity, iPlayer) then
			for i = 0, 5 do
				local nPlot = Map.PlotDirection(iCity:GetX(), iCity:GetY(), i);
				if nPlot then
					if IsValidPlotForMesoSGR(nPlot, iPlayer) then
						table.insert(hTab, nPlot)
					end
				end
			end
		end
	end
	MapModData.ITGSG = hTab;
end

function PlayerChooseShinobiModifierOnPlot(pPlot, iPlayer)
	if not pPlot:IsWater() then
		if pPlot:IsRevealed(Players[iPlayer]:GetTeam()) then
			if pPlot:GetPlotIndex() ~= gT.Players[iPlayer].ShinobiVisionPlot then
				if gT.Players[iPlayer].ShinobiVisionPlot then
					RemoveLabelOnPlot(Map.GetPlotByIndex(gT.Players[iPlayer].ShinobiVisionPlot), "ShinobiVision", nil, nil, iPlayer)
				end
				AddShinobiVisionModifierForPlayer(iPlayer, pPlot)
				AddSmallInfo(pPlot, nil, "ShinobiVision", nil, nil, nil, nil, iPlayer)
			end
		end
	end
end

function AddShinobiVisionModifierForPlayer(iPlayer, pPlot, bRemoveOnly)
	local iTeam = Players[iPlayer]:GetTeam();
	for i, iPlotIndex in pairs(gT.Players[iPlayer].ShinobiVisibility or {}) do
		Map.GetPlotByIndex(iPlotIndex):ChangeVisibilityCount(iTeam, -1)
	end
	gT.Players[iPlayer].ShinobiVisibility = {}
	if bRemoveOnly then
		return;
	end
	gT.Players[iPlayer].ShinobiVisionPlot = pPlot:GetPlotIndex()
	local sTab = GetPlotsInRadiusOfPlot(pPlot, 3);
	for h, hPlot in pairs(sTab) do
		hPlot:ChangeVisibilityCount(iTeam, 1)
		table.insert(gT.Players[iPlayer].ShinobiVisibility, hPlot:GetPlotIndex());
	end
	gT.Players[iPlayer].ShinobiVisionCooldown = GetRealGameTurn() + 7
	--(not gData.Players[gPlayer].CanHaveShinobiVision) or (GetRealGameTurn() <= gData.Players[gPlayer].ShinobiVisionCooldown))
end

function DoTurnInnovationsAbilityRelated(iPlayer)
	if HasPlayerTech(iPlayer, techANCemp7, "xafsbvade") then 
		gT.Players[iPlayer].FortGenTimer = gT.Players[iPlayer].FortGenTimer + 1;
		if gT.Players[iPlayer].FortGenTimer >= 10 then
			gT.Players[iPlayer].FortGenTimer = 0;		
			gT.Players[iPlayer].NumFortPoints = gT.Players[iPlayer].NumFortPoints + 1; 
		end
	end
	if HasPlayerTech(iPlayer, meso5inno, "meso5inno") then
		DoCheckMeso5Beliefs(iPlayer)
	end
	if HasPlayerTech(iPlayer, ancTRinno13, "dkodeowqd") then
		if GetSeasonFromTurn(GetITGGameTurn()) == 1 then
			for iUnit in Players[iPlayer]:Units() do
				iUnit:ChangeDamage(-25);
				if CanBeSpeedUpByAnything(iUnit) then
					iUnit:ChangeTemporaryMoves(1);
				end
			end
		end
	end
	if HasPlayerTech(iPlayer, afr2tech, "kodkeode") then
		for iCity in Players[iPlayer]:Cities() do
			local iUnit = iCity:GetGarrisonedUnit();
			if iUnit and gT.Players[iPlayer].UnitClassXP[iUnit:GetUnitClassType()] then
				iUnit:ChangeExperience(3);
				iUnit:ChangeMaxHitPoints(3);
			end
		end
	end
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_MODERN_15, "^y546t45") then
		for iUnit in Players[iPlayer]:Units() do
			if iUnit:GetDomainType() == dSea or iUnit:GetDomainType() == dAir then
				if gT.Players[iPlayer].UnitClassXP[iUnit:GetUnitClassType()] then
					if LastChance(7) then
						iUnit:ChangeDamage(-50)
					end					
				end
			end
		end
	end
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_NW_TROPICAL_8, "oekfkorefr") then
		for iUnit in Players[iPlayer]:Units() do
			if iUnit:GetDomainType() == dSea then
				if gT.Players[iPlayer].UnitClassXP[iUnit:GetUnitClassType()] then
					if CanBeSpeedUpByAnything(iUnit) then
						iUnit:ChangeTemporaryMoves(1 + math.ceil(iUnit:GetDamage() / 25));
					end
				end
			end
		end
	end
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_MODERN_3, "^346345234") then
		local plots = {}
		for iUnit in Players[iPlayer]:Units() do
			if iUnit:GetUnitClassType() == GameInfoTypes.UNITCLASS_TANK then
				plots[iUnit:GetPlot()] = true;
			end
		end
		for iUnit in Players[iPlayer]:Units() do
			if plots[iUnit:GetPlot()] then
				if iUnit:GetUnitClassType() ~= GameInfoTypes.UNITCLASS_TANK then
					if iUnit:GetDomainType() == dLand then
						if gT.Players[iPlayer].UnitClassXP[iUnit:GetUnitClassType()] then
							if CanBeSpeedUpByAnything(iUnit) then
								iUnit:ChangeTemporaryMoves(1)
								iUnit:ChangeTemporaryCombatStrength(5);
							end
						end
					end
				end
			end
		end
	end
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_MODERN_4, "23fre342") then
		for iUnit in Players[iPlayer]:Units() do
			if iUnit:GetUnitClassType() == GameInfoTypes.UNITCLASS_CARRIER then
			--	local uID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
				local tPlot = iUnit:GetPlot();
				for jth = 0, tPlot:GetNumUnits() -1 do
					local jthUnit = tPlot:GetUnit(jth);
					if jthUnit:IsCargo() and jthUnit:GetOwner() == iPlayer then
						if jthUnit:GetTransportUnit() == iUnit then
							jthUnit:ChangeDamage(-10);
						end
					end
				end
			end
		end
	end
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_25, "Vdkfr") then
		for iUnit in Players[iPlayer]:Units() do
			if iUnit:IsEmbarked() then
				local lMoves = LastRandom(0, 3);
				if lMoves > 0 then
					if CanBeSpeedUpByAnything(iUnit) then
						iUnit:ChangeTemporaryMoves(lMoves)
					end
				end
			end
		end
	end
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_MODERN_27, "g45g45gs") then
		for iUnit in Players[iPlayer]:Units() do
			if iUnit:GetUnitClassType() == GameInfoTypes.UNITCLASS_CARRIER then
				local uID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
				local tPlot = iUnit:GetPlot();
				local nBonus = 0
				for jth = 0, tPlot:GetNumUnits() -1 do
					local jthUnit = tPlot:GetUnit(jth);
					if jthUnit:IsCargo() and jthUnit:GetOwner() == iPlayer then
						if jthUnit:GetTransportUnit() == iUnit then
							nBonus = nBonus + 8;
						end
					end
				end
				if nBonus ~= (gT.Players[iPlayer].UnitsByID[uID].InnoModern27 or 0) then
					ChangeITGBaseCombatStrength(iUnit, nil, nBonus - (gT.Players[iPlayer].UnitsByID[uID].InnoModern27 or 0))
					gT.Players[iPlayer].UnitsByID[uID].InnoModern27 = nBonus;
				end
			end
		end
	end
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_MODERN_5, "214325345") then
		for iUnit in Players[iPlayer]:Units() do
			if iUnit:GetUnitClassType() == GameInfoTypes.UNITCLASS_CARRIER then
				local uID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
				if iUnit:GetDamage() == 0 then
					if not gT.Players[iPlayer].UnitsByID[uID].InnoModern5 then
						gT.Players[iPlayer].UnitsByID[uID].InnoModern5 = true;
						iUnit:ChangeMaxHitPoints(200);
					end
				elseif gT.Players[iPlayer].UnitsByID[uID].InnoModern5 then
					gT.Players[iPlayer].UnitsByID[uID].InnoModern5 = false;
					iUnit:ChangeMaxHitPoints(-200);
				end
			end
		end
	end
	if HasPlayerTech(iPlayer, meso3, "Dqweade") then 
		gT.Players[iPlayer].MesoSGRGenerated = gT.Players[iPlayer].MesoSGRGenerated + 1;
		if gT.Players[iPlayer].MesoSGRGenerated >= 5 then
			gT.Players[iPlayer].MesoSGRGenerated = 0;
			gT.Players[iPlayer].MesoSGRPoints = gT.Players[iPlayer].MesoSGRPoints + 1;
		end
	end
	if HasPlayerTech(iPlayer, asian8, "TEWFWERc") then
		if not gT.Players[iPlayer].KingUnitAlive then
			gT.Players[iPlayer].KingUnitCD = gT.Players[iPlayer].KingUnitCD + 1;
			if gT.Players[iPlayer].KingUnitCD >= 5 then
				DoSpawnKingUnit(iPlayer)
			end
		end
	end
	if HasPlayerTech(iPlayer, afr7tech, "wfefewrwer") then
		DoUniteBarbariansSeen(iPlayer)
	end
	if HasPlayerTech(iPlayer, innoTrialEuro4, "Fewrwdadsa") then
		local nRH = Players[iPlayer]:GetNumStrategicResourceAvailable(rHorse, true);
		if nRH > 0 then
			local tab = {};
			for iUnit in Players[iPlayer]:Units() do
				if iUnit:GetUnitCombatType() == GameInfoTypes.UNITCOMBAT_MELEE then
					if gT.Players[iPlayer].UnitClassXP[iUnit:GetUnitClassType()] then
						if not iUnit:IsEmbarked() then
							if CanBeSpeedUpByAnything(iUnit) then
								table.insert(tab, iUnit)
							end
						end
					end
				end
			end
			tab = Shuffle(tab);
			for i = 1, nRH do
				if tab[i] then
					tab[i]:ChangeTemporaryMoves(2)
				else
					break;
				end
			end
		end
	end
	if HasPlayerTech(iPlayer, ae4inno, "llaf,aea123") then
		TryToAddOneRoadIfPossible(iPlayer)
	end
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_NW_TROPICAL_4, "56753gtfvrt") then
		TryToAttractNearbyCargos(iPlayer)
	end
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_NW_TROPICAL_6, "6534324") then
		DoTurnSevenSeasPromotions(iPlayer)
	end
	if gT.Players[iPlayer].GlassTdisc then
		local gNow = GetNumManufactories(iPlayer)
		if gNow > gT.Players[iPlayer].GlassTdisc then
			Players[iPlayer]:ChangeNumResourceTotal(GameInfoTypes.RESOURCE_ITG_GLASS, gNow - gT.Players[iPlayer].GlassTdisc);
			gT.Players[iPlayer].GlassTdisc = gNow;
		end
	end
	gT.Players[iPlayer].ParadropTPrev = {};
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_MODERN_30, "Frkofkoef") then
		for a, b in pairs(gT.Players[iPlayer].ParadropTNow) do
			gT.Players[iPlayer].ParadropTPrev[a] = true;
		end
	end
	if HasPlayerTech(iPlayer, innomodern21, "gtwgg") then
		for iCity in Players[iPlayer]:Cities() do
			local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
			local bHasMilit = IsHasBuildingClass(iCity, cMilit);
			if bHasMilit and (not gT.Cities[cID].ModernRange21) then
				iCity:ChangeExtraRangeStrike(1);
				gT.Cities[cID].ModernRange21 = true;
			elseif gT.Cities[cID].ModernRange21 and (not bHasMilit) then
				iCity:ChangeExtraRangeStrike(-1);
				gT.Cities[cID].ModernRange21 = nil;
			end
		end
	end
	gT.Players[iPlayer].ParadropTNow = {};
end

function AIDoMakeUsageOfInnovationAbilities(iPlayer)
	if gT.Players[iPlayer].CanHaveShinobiVision then
		if GetRealGameTurn() > gT.Players[iPlayer].ShinobiVisionCooldown then
			local nPlot = GetNiceAITargetForShinobiVision(iPlayer)
			if nPlot then
				AddShinobiVisionModifierForPlayer(iPlayer, nPlot)
			end
		end
	end
	if gT.Players[iPlayer].CanResMovement then
		if GetRealGameTurn() > gT.Players[iPlayer].ResMovementCooldown then
			local tCity = GetNiceAITargetForResMovement(iPlayer)
			if tCity then
				PlayerTriggerResistanceMovement(iPlayer, tCity)
			end
		end
	end
	if gT.Players[iPlayer].LastCallCharges > 0 then
		if ShouldAIUseLastCall(iPlayer) then
			TriggerLastCallAbility(iPlayer)
		end
	end
	DoAISatellites(iPlayer)
	if gT.Players[iPlayer].MesoSGRPoints > 0 then
		if Teams[Players[iPlayer]:GetTeam()]:GetAtWarCount(true) == 0 then
			HighlighProperPlotsForMesoSGRModifier(iPlayer)
			local hTab = MapModData.ITGSG
			MapModData.ITGSG = nil;
			if #hTab > 0 then
				DoMesoSGROnPlot(hTab[LastRandom(1,#hTab)], iPlayer)
			end
		end
	end
	if gT.Players[iPlayer].MesoElDoradoPoints > 0 then
		HighlighProperPlotsForMesoElDorado(iPlayer)
		local hTab = MapModData.ITGSG
		MapModData.ITGSG = nil;
		if #hTab > 0 then
		--AI El Dorado
			hTab = Shuffle(hTab);
			local nTab, maxval = {}, 0;
			for i, plot in pairs(hTab) do
				local val = GetPlotValueToBeAElDorado(plot)
				table.insert(nTab, {plot, val})
				maxval = math.max(maxval, val)
			end
			for i, data in pairs(nTab) do
				if data[2] >= maxval - 5 then
					PlayerChooseElDoradoOnPlot(data[1], iPlayer)
					return
				end
			end
		end
	end
end

local ElDoradoValueForImpass = {0, 3, 9, 18, 35, 100, 10000}
function GetPlotValueToBeAElDorado(fPlot)
	-- just keep it safe
	local points = 0;
	if fPlot:IsHills() then
		points = points + 9;
	end
	if fPlot:IsNEOfRiver() then
		points = points + 1;
	end
	if fPlot:IsWOfRiver() then
		points = points + 1;
	end
	if fPlot:IsNWOfRiver() then
		points = points + 1;
	end
	local impass = 1
	for i = 0, 5 do
		local iPlot = Map.PlotDirection(fPlot:GetX(), fPlot:GetY(), i)
		if iPlot then
			if i == 0 then
				if iPlot:IsNEOfRiver() then
					points = points + 1;
				end
			elseif i == 5 then
				if iPlot:IsNWOfRiver() then
					points = points + 1;
				end
			elseif i == 4 then
				if iPlot:IsWOfRiver() then
					points = points + 1;
				end
			end
			if iPlot:IsImpassable() or iPlot:IsMountain() then
				impass =  impass + 1;
			end
			if iPlot:IsLake() then
				points = points + 1;
			end
		end
	end
	points = points + ElDoradoValueForImpass[impass]
	return points;
end

function GetNiceAITargetForShinobiVision(iPlayer, bSat)
	local lDis, cPlot = 500;
	local lPlot;
	local cc = Players[iPlayer]:GetCapitalCity();
	if cc then
		lPlot = cc:Plot();
	else
		lPlot = Players[iPlayer]:GetStartingPlot();
	end
	if not lPlot then
		print("Very strange bug 12412512")
		return nil
	end
	local iTeam = Players[iPlayer]:GetTeam();
	for g, gdata in pairs(gT.Players) do
		if Teams[iTeam]:IsAtWar(Players[g]:GetTeam()) then
			for iCity in Players[g]:Cities() do
				if not iCity:Plot():IsRevealed(iTeam) then
					local dis = Map.PlotDistance(lPlot:GetX(), lPlot:GetY(), iCity:GetX(), iCity:GetY())
					if dis < lDis then
						if not IsWithinRangeOfSatellites(iCity:Plot(), iPlayer, 7) then
							lDis = dis;
							cPlot = iCity:Plot();
						end
					end
				end
			end
		end
	end
	return cPlot;
end

function GetAvailableTargetsForUprising(iPlayer, bOnlyWar, bCheck)
	local iTeam = Players[iPlayer]:GetTeam();
	local sTab = {}
	for g, h in pairs(gT.Players) do
		if g ~= iPlayer then
			if (not bOnlyWar) or Teams[iTeam]:IsAtWar(Players[g]:GetTeam()) then
				for iCity in Players[g]:Cities() do
					if iCity:IsOccupied() then
						if not iCity:IsResistance() then
							if iCity:Plot():IsRevealed(iTeam) then
								if bCheck then
									return true;
								end
								table.insert(sTab, iCity);
							end
						end
					end
				end
			end	
		end
	end
	if bCheck then
		return false;
	end
	return sTab;
end

function GetNiceAITargetForResMovement(iPlayer)
	local sTab = GetAvailableTargetsForUprising(iPlayer, true, false)
	if #sTab > 0 then
		return sTab[LastRandom(1,#sTab)];
	else
		return nil;
	end
end

function FortUnitGarrisonWasCreatedForPlayer(iUnit, iPlayer, fType)
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_MESOAMERICAN_3, "Fewfcew") then 
		iUnit:SetHasPromotion(GameInfoTypes.PROMOTION_ITG_INNOVATION_AZTEC_FEAR_10, true)
	end
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_MODERN_21, "$5646") then
		iUnit:SetHasPromotion(GameInfoTypes.PROMOTION_ANTI_TANK, true)
		iUnit:SetHasPromotion(GameInfoTypes.PROMOTION_ANTI_AIR, true)
	end
	if gT.Players[iPlayer] then
		if gT.Players[iPlayer].CultBonusOn[18] then
			iUnit:SetHasPromotion(GameInfoTypes.PROMOTION_ITG_FORT_LEADERSHIP, true)
		end
		if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_MEDIEVAL_AFR_6, "gtvrew") then
			iUnit:SetHasPromotion(GameInfoTypes.PROMOTION_ITG_MED_INNO_AFR_6, true)
		end
		if gT.Players[iPlayer].HasPlayerWonder[malborkcastle1] then
			iUnit:ChangeMaxHitPoints(50);
		end
		if gT.Players[iPlayer].HasIdeology[55] then
			iUnit:SetHasPromotion(GameInfoTypes.PROMOTION_IDEOLOGY_55_RANGE, true)
		end
		if gT.Globals.ScenarioType == 5 then
			iUnit:SetHasPromotion(GameInfoTypes.PROMOTION_CARGO_II, true);
			if fType == 2 then
				iUnit:SetHasPromotion(GameInfoTypes.PROMOTION_CARGO_IV, true);
				iUnit:SetHasPromotion(GameInfoTypes.PROMOTION_CARGO_II, false);
			end
		end
	end
end

local MesoFearAuraTP = {GameInfoTypes.PROMOTION_ITG_INNOVATION_AZTEC_FEAR_1, GameInfoTypes.PROMOTION_ITG_INNOVATION_AZTEC_FEAR_2, GameInfoTypes.PROMOTION_ITG_INNOVATION_AZTEC_FEAR_4, GameInfoTypes.PROMOTION_ITG_INNOVATION_AZTEC_FEAR_8}
function DoIncrementInFearAuraMeso(iUnit, iPlayer)
	local uID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
	if gT.Players[iPlayer].UnitsByID[uID] then
		gT.Players[iPlayer].UnitsByID[uID].MesoFearAuraPower = math.min(15, (gT.Players[iPlayer].UnitsByID[uID].MesoFearAuraPower or 0) + 1)
	end
	local power = gT.Players[iPlayer].UnitsByID[uID].MesoFearAuraPower;
	for i = 0, #MesoFearAuraTP do
		local bProm = false
		if power >= math.pow(2, #MesoFearAuraTP - 1 - i) then
			bProm = true;
			power = power - math.pow(2, #MesoFearAuraTP - 1 - i)
		end
		iUnit:SetHasPromotion(MesoFearAuraTP[#MesoFearAuraTP - i], bProm)
	end
end

function GetFoodBonusToNearestCity(kPlayer, unitX, unitY, food)
	local iCity = GetNearestCityOfPlayerToPlot(unitX, unitY, kPlayer, 10)
	if iCity then
		iCity:ChangeFood(food)
		return food;
	end
	return 0
end

function InitialRadiusEmbassyInno(iPlayer)
	local iTeam = Players[iPlayer]:GetTeam()
	local iTeams = {}
	for g, gh in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			if g ~= iPlayer then
				if Teams[iTeam]:HasEmbassyAtTeam(Players[g]:GetTeam()) then
					local cH = Players[g]:GetCapitalCity();
					if cH then
						RevealTerrainInRadius(iTeam, cH:Plot(), 4)
					end
				end
			end
		elseif Teams[iTeam]:IsHasMet(Players[g]:GetTeam()) then
			table.insert(iTeams, Players[g]:GetTeam())
		end
	end
	for i = 0, Map:GetNumPlots() - 1, 1 do
		local fPlot = Map.GetPlotByIndex( i );
		if not fPlot:IsRevealed(iTeam) then
			local bC = false;
			for k, kTeam in pairs(iTeams) do
				if fPlot:IsRevealed(kTeam) then
					bC = true;
					break;
				end
			end
			if bC then
				fPlot:SetRevealed(iTeam, true)
			end
		end
	end
end

function DoRevealTerritoryOfPlayer(iPlayer, mPlayer)
	local iTeam = Players[iPlayer]:GetTeam();
	for i = 0, Map:GetNumPlots() - 1, 1 do
		local fPlot = Map.GetPlotByIndex( i );
		if fPlot:GetOwner() == mPlayer then
			if not fPlot:IsRevealed(iTeam) then
				fPlot:SetRevealed(iTeam, true)
			end
		end
	end
	DoDeferredFog(iTeam)
end

function DoMeetCSRevealMap(iPlayer, mPlayer)
	local iTeam = Players[iPlayer]:GetTeam();
	local mTeam = Players[mPlayer]:GetTeam();
	for i = 0, Map:GetNumPlots() - 1, 1 do
		local fPlot = Map.GetPlotByIndex( i );
		if not fPlot:IsRevealed(iTeam) then
			if fPlot:IsRevealed(mTeam) then
				fPlot:SetRevealed(iTeam, true)
			end
		end
	end
end

function DoApplyInnovationBonuses(newPlayer, iCity, cID, jPlayer, bConquest, bVeryFirst)
	if jPlayer then
		--bonuses upon conquer only
		if HasPlayerTech(jPlayer, meso5inno, "meso5inno") then
			UpdateAllFoodForeignDis(jPlayer)
		end
		if bVeryFirst then
			--uh oh nothing
		end
		if HasPlayerTech(newPlayer, GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_26, "yhtrt") then
			HearMeRoar(iCity:Plot(), 2, jPlayer)
		end
		if gT.Players[jPlayer] then
			if Players[jPlayer]:GetNumCities() == 0 then
				for index, sth in pairs(gT.Players[jPlayer].PlotsClaimedBySetXY) do
					if not IsSpecialControlPlot(index, true) then
						Map.GetPlotByIndex(index):SetOwner(-1, -1)
					else
						gT.Players[jPlayer].PlotsClaimedBySetXY[index] = nil
					end
				end
			else
				local cityId = Players[jPlayer]:GetCapitalCity():GetID();
				for index, sth in pairs(gT.Players[jPlayer].PlotsClaimedBySetXY) do
					if not IsSpecialControlPlot(index, true) then
						Map.GetPlotByIndex(index):SetOwner(jPlayer, cityId)
					else
						gT.Players[jPlayer].PlotsClaimedBySetXY[index] = nil
					end
				end
			end
		end
		if HasPlayerTech(newPlayer, GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_EMPIRE_20, "vvesrhew") then
			if Players[jPlayer]:IsMinorCiv() then
				iCity:ChangeResistanceTurns(-1 * iCity:GetResistanceTurns())
				local cCity = Players[newPlayer]:GetCapitalCity();
				if cCity and (cCity ~= iCity) then
					local scID = cCity:Plot():GetPlotIndex() .. "," .. cCity:GetGameTurnFounded();
					DoChangeCityCultureOwnership(cID, iCity, newPlayer, math.ceil((gT.Cities[scID].CultureStored[jPlayer] or 1)/2))
				end
			end
		end
		if HasPlayerTech(newPlayer, meso5inno, "meso5inno") then
			UpdateAllFoodForeignDis(newPlayer)
		end
		if HasPlayerTech(jPlayer, artInnoguilds, "artinnoguils") then
			OnDirtyCulturalGuilds(jPlayer)
		end
	else
		--here bonuses on found city;
		if HasPlayerTech(newPlayer, GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_8, "d32462341") then
			ChangeITGWorkRate(iCity, 5000)
		end
		if HasPlayerTech(newPlayer, GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_TRIBE_13, "bgfjfjhdfgfa") then
			gT.Players[newPlayer].NumFortPoints = gT.Players[newPlayer].NumFortPoints + 1; 
		end
		if HasPlayerTech(newPlayer, GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_TRIBE_20, "vasdaecc") then
			for i = 1, 6 do
				DoITGCityAcquirePlot(iCity)
			end
		end
	end
	-- here bonuses for both found and conquer
	if HasPlayerTech(newPlayer, indo16inno, "dsfadaed") then
		iCity:ChangeWorkersAmount(1)
	end
	if HasPlayerTech(newPlayer, artInnoguilds, "artinnoguils") then
		OnDirtyCulturalGuilds(newPlayer)
	end
	if HasPlayerTech(newPlayer, GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_TRIBE_20, "vdasvddzfa") then
		iCity:ChangeWorkersAmount(1)
	end
	if HasPlayerTech(newPlayer, GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_TRIBE_17, "867jht567") then
		iCity:ChangeResourceExtraYield(GameInfoTypes.RESOURCE_GOLD, yCulture, 2)
		iCity:ChangeResourceExtraYield(rIron, yCulture, 2)
		iCity:ChangeResourceExtraYield(GameInfoTypes.RESOURCE_SILVER, yCulture, 2)
		iCity:ChangeResourceExtraYield(GameInfoTypes.RESOURCE_COPPER, yCulture, 2)
	end
	if HasPlayerTech(newPlayer, GameInfoTypes.TECH_UNIQUE_ITG_MEDIEVAL_AFR_2, "getrgres") then
		for row in GameInfo.Resources() do
			if row.Happiness > 0 then
				iCity:ChangeResourceExtraYield(rowID, yGold, 3)
			end
		end
	end
	if HasPlayerTech(newPlayer, GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_EMPIRE_16, "brwfwerwer") then
		iCity:ChangeMaxFoodKeptPercent(25)
	end
	if HasPlayerTech(newPlayer, GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_ARAB_2, "3452342") then
		iCity:ChangeExtraLuxuryCount(1)
	end
	if HasPlayerTech(newPlayer, GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_PAGAN_6, "Y2wdadas432") then
		iCity:ChangeFeatureExtraYield(fForest, yFood, 1)
	end
	if HasPlayerTech(newPlayer, afr5tech, "^32523r23") then			
		iCity:ChangeTerrainExtraYield(tDesert, yProduction, 2)
	end
	if HasPlayerTech(newPlayer, afr6tech, "^23fc354@#$") then
		iCity:ChangeFeatureExtraYield(fJungle, yGold, 1)
	end
	if HasPlayerTech(newPlayer, GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_11, "foefoekfr") then
		local fr = gT.Cities[cID].FeaturesRemoved;
		if fr > 0 then
			iCity:ChangeMaxHitPoints(25 * fr)
			ChangeITGCityInteger(iCity, "CI_HEALTH_FROM_INNO", fr)
		end
	end
end

local bForeignDis = BUILDING_ITG_INNO_FOREIGN_DISTRICT
function UpdateAllFoodForeignDis(iPlayer)
	for iCity in Players[iPlayer]:Cities() do
		local iFoodFromFD = 0;
		if iCity:IsCapital() and iCity:IsHasBuilding(bForeignDis) then
			iFoodFromFD = 5;
		end
		SetRawCityYield(iCity, yFood, iFoodFromFD, "CI_FOOD_FOREIGN_DIS")
	end
end

function DoInnovationForbiddenPalace(iPlayer)
	local hTab = {};
	local cCity	= Players[iPlayer]:GetCapitalCity()
	local sPlot = Players[iPlayer]:GetStartingPlot();
	if cCity then
		sPlot = cCity:Plot();
	end
	for g, gdata in pairs(gT.Players) do
		if Players[g]:IsMinorCiv() then
			if Players[g]:IsAlive() then
				local dPlot = Players[g]:GetStartingPlot();
				table.insert(hTab, {g, Map.PlotDistance(sPlot:GetX(), sPlot:GetY(), dPlot:GetX(), dPlot:GetY())})
			end
		end
	end
	if #hTab > 0 then
		table.sort(hTab, SortFunctionForLowestMapDistance)
		for i = 1, 2 do
			if hTab[i] then
				Players[hTab[i][1]]:ChangeMinorCivExtraAnchorWithMajor(iPlayer, 60)
				gT.Players[iPlayer].ExtraCityStateAnchor[hTab[i][1]] = (gT.Players[iPlayer].ExtraCityStateAnchor[hTab[i][1]] or 0) + 60;
			end
		end
	end
end

function DoSpawnKingUnit(iPlayer)
	local cCity = Players[iPlayer]:GetCapitalCity();
	if cCity then
		gT.Players[iPlayer].KingUnitAlive = true;
		gT.Players[iPlayer].KingUnitCD = 0;
		local iUnit = Players[iPlayer]:InitUnit(uNaureasean, cCity:GetX(), cCity:GetY())
		ITGSCNewUnitCreated(iPlayer, iUnit, nil, false, nil, nil, false)
		local uID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
		gT.Players[iPlayer].UnitsByID[uID].IsKing = true
		iUnit:SetBaseCombatStrength(22);
		iUnit:SetHasPromotion(GameInfoTypes.PROMOTION_GREAT_GENERAL_19, true);
		iUnit:SetHasPromotion(GameInfoTypes.PROMOTION_GREAT_GENERAL_11, true);
		iUnit:SetHasPromotion(GameInfoTypes.PROMOTION_GREAT_GENERAL_17, true);
		SetUnitForcedStackType(iUnit, -1, "King", -1)
		iUnit:SetName(Players[iPlayer]:GetName() .. "'s Elephant")
		iUnit:SetCanUpgrade(false);
	end
end

function DoInitialRadarAncientData(iPlayer)	
	gT.Players[iPlayer].AncientRadarLeft = {}
	local iTeam = Players[iPlayer]:GetTeam();
	for iPlotIndex, v in pairs(gT.Globals.AncientRuins) do
		local pPlot = Map.GetPlotByIndex(iPlotIndex);
		if not pPlot:AlreadyVisitedGoodyHut(iTeam) then
			gT.Players[iPlayer].AncientRadarLeft[iPlotIndex] = {pPlot:GetX(), pPlot:GetY()};
		end
	end
end

function NewUnitCreatedForInnovations(iPlayer, iUnit, iCity, uID)
	if HasPlayerTech(iPlayer, euro7tech, "^2d324234") then 
		if iUnit:GetUnitCombatType() == GameInfoTypes.UNITCOMBAT_SIEGE then
			ChangeITGBaseCombatStrength(iUnit, nil, 2)
		end
	end
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_TRIBE_7, "kdfkdsfds") then
		if iUnit:GetDomainType() == dSea then
			if gT.Players[iPlayer].UnitClassXP[iUnit:GetUnitClassType()] then
				iUnit:SetHasPromotion(GameInfoTypes.PROMOTION_ITG_VANDAL_NAVY, true);
			end
		end
	end
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_VIKING_2, "doekke") then
		if gT.Players[iPlayer].UnitClassXP[iUnit:GetUnitClassType()] then
			iUnit:SetHasPromotion(GameInfoTypes.PROMOTION_ITG_TRIAL_VIKING_2, true)
		end
	end
	if iUnit:GetUnitClassType() == GameInfoTypes.UNITCLASS_ANTI_TANK_GUN then
		if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_MODERN_18, "234324geg") then
			ChangeITGBaseCombatStrength(iUnit, 10)
		end
	elseif iUnit:GetUnitClassType() == GameInfoTypes.UNITCLASS_INFANTRY then
		if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_MODERN_18, "2535432") then
			iUnit:SetHasPromotion(GameInfoTypes.PROMOTION_ITG_MODERN_INF_ANTI_TANK, true);
		end
		if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_MODERN_19, "2535432") then
			iUnit:SetHasPromotion(GameInfoTypes.PROMOTION_ITG_MODERN_INF_REINFORCEMENT, true);
		end
	elseif iUnit:GetUnitClassType() == GameInfoTypes.UNITCLASS_SUBMARINE then
		if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_MODERN_7, "^avddfasf") then
			local ts = iUnit:GetMoves() / iUnit:MaxMoves();
			iUnit:SetHasPromotion(GameInfoTypes.PROMOTION_ITG_MODERN_LONG_HUNT, true)
			iUnit:SetMoves(math.floor(iUnit:MaxMoves() * ts)); 
		end
		if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_MODERN_8, "^vrfferef") then
			iUnit:SetHasPromotion(GameInfoTypes.PROMOTION_ITG_MODERN_HIT_AND_RUN, true)
		end
	elseif iUnit:GetUnitClassType() == GameInfoTypes.UNITCLASS_FIGHTER then
		if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_MODERN_9, "^gtrwge") then
			iUnit:ChangeMaxCombatFromCombatsMade(50);
			iUnit:ChangeBonusPerCombatMade(2);
		end
	elseif iUnit:GetUnitClassType() == GameInfoTypes.UNITCLASS_ANTI_AIRCRAFT_GUN then
		if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_MODERN_16, "^bre") then
			iUnit:SetHasPromotion(GameInfoTypes.PROMOTION_ITG_MODERN_COVER_AREA, true);
		end
		if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_MODERN_17, "2erfeffg") then
			iUnit:SetHasPromotion(GameInfoTypes.PROMOTION_ITG_MODERN_EXTRA_INTERCEPTION, true);
		end
	elseif iUnit:GetUnitClassType() == GameInfoTypes.UNITCLASS_TANK then
		if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_MODERN_2, "^Y4gv") then
			iUnit:ChangeMaxHitPoints(35);
		end
		if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_MODERN_2, "^346345234") then
			iUnit:SetHasPromotion(GameInfoTypes.PROMOTION_ITG_MODERN_RAMMING, true);
		end
	elseif iUnit:GetUnitClassType() == GameInfoTypes.UNITCLASS_CARRIER then
		if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_MODERN_4, "53523") then
			iUnit:ChangeCargoSpace(1)
		end
		if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_MODERN_5, "34234") then
			local uID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
			if iUnit:GetDamage() == 0 then
				if not gT.Players[iPlayer].UnitsByID[uID].InnoModern5 then
					gT.Players[iPlayer].UnitsByID[uID].InnoModern5 = true;
					iUnit:ChangeMaxHitPoints(200);
				end
			elseif gT.Players[iPlayer].UnitsByID[uID].InnoModern5 then
				gT.Players[iPlayer].UnitsByID[uID].InnoModern5 = false;
				iUnit:ChangeMaxHitPoints(-200);
			end
		end
	elseif iUnit:GetUnitClassType() == GameInfoTypes.UNITCLASS_BATTLESHIP then
		if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_MODERN_12, "34234") then
			iUnit:SetHasPromotion(GameInfoTypes.PROMOTION_ITG_MODERN_SONAR, true)
		end
	end
	if HasPlayerTech(iPlayer, tAncientTR18, "^vcsdfsr") then
		if iUnit:GetUnitClassType() == GameInfoTypes.UNITCLASS_SCOUT then
			iUnit:SetHasPromotion(GameInfoTypes.PROMOTION_ITG_INNO_ANCIENT_TR_18, true)
		end
	end
	if gT.Players[iPlayer].HasIdeology[44] then
		if iUnit:GetUnitClassType() == GameInfoTypes.UNITCLASS_CARAVAN or iUnit:GetUnitClassType() == GameInfoTypes.UNITCLASS_CARGO_SHIP then
			iUnit:SetHasPromotion(GameInfoTypes.PROMOTION_ITG_IDEOLOGY_44, true)
		end
	end
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_NW_TROPICAL_8, "^5335") then
		if iUnit:GetUnitClassType() == GameInfoTypes.UNITCLASS_CARGO_SHIP then
			iUnit:SetHasPromotion(GameInfoTypes.PROMOTION_ITG_FLEE_TROPICAL_INNO, true);
		end
	end
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_ARABIA_2, "^gdsgdg") then
		if iUnit:GetDomainType() == dSea then
			if gT.Players[iPlayer].UnitClassXP[iUnit:GetUnitClassType()] then
				SetUnitForcedStackType(iUnit, -1, "tArab2", -1)
			end
		end
	end
	if HasPlayerTech(iPlayer, techTRIALHorde7, "^23dc324324") then
		if LastRandom(1, 10) == 4 then
			if iUnit:GetUnitCombatType() == GameInfoTypes.UNITCOMBAT_MOUNTED then
				if iCity then
					DoTriggerNewFestivalIfPossible(iPlayer, iCity)
				end
			end
		end
	end
	if HasPlayerTech(iPlayer, techTRIALviking5, "^2342d324324") then
		if iUnit:GetDomainType() == dSea then
			iUnit:SetHasPromotion(GameInfoTypes.PROMOTION_ITG_INNO_VIKING_SEA_SIGHT, true)
			if iUnit:GetUnitClassType() == GameInfoTypes.UNITCLASS_WORKBOAT then
				iUnit:SetHasPromotion(GameInfoTypes.PROMOTION_ITG_INNO_VIK_FISHBOATS, true)
			end
		end
	end
	if HasPlayerTech(iPlayer, techTRIALviking1, "$2d324326324") then
		if iCity then
			if iUnit:GetDomainType() == dSea then
				local navpoints = math.ceil(iUnit:GetBaseCombatStrength(true)/2);
				if navpoints > 0 then
					local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
					gT.Cities[cID].CargoProgress = (gT.Cities[cID].CargoProgress or 0) + navpoints;
				end
			end
		end
	end
	if HasPlayerTech(iPlayer, techTRIALviking4, "@35234dda") then
		if iUnit:GetDomainType() == dLand then
			iUnit:SetHasPromotion(GameInfoTypes.PROMOTION_ITG_INNO_VIK_EMBARK, true)
		elseif iUnit:GetDomainType() == dSea then
			SetUnitForcedStackType(iUnit, -1, "tVik4", -1)
		end
	end
	if HasPlayerTech(iPlayer, arab3tech, "%234324235") then 
		if iUnit:GetUnitCombatType() == GameInfoTypes.UNITCOMBAT_MELEE then
			ChangeITGBaseCombatStrength(iUnit, 2, nil)
		end
	end
	if HasPlayerTech(iPlayer, afr3tech, "Ad42341234") then
		if iUnit:GetDomainType() == dLand then
			if iUnit:GetUnitCombatType() ~= GameInfoTypes.UNITCOMBAT_SIEGE then
				SetUnitForcedStackType(iUnit, -1, "nwAfr3", -1)
			end
		end
	end
	if HasPlayerTech(iPlayer, afr5tech, "%234adc324") then
		iUnit:SetHasPromotion(GameInfoTypes.PROMOTION_ITG_INNO_DESERT_AFR, true)
	end
	if HasPlayerTech(iPlayer, afr6tech, "^2rc234234") then
		iUnit:SetHasPromotion(GameInfoTypes.PROMOTION_ITG_INNO_JUNGLE_AFR, true)
	end
	if HasPlayerTech(iPlayer, techTRIALpagan8, "&235234132") then
		if iUnit:GetDomainType() == dLand then
			if CanBeSpeedUpByAnything(iUnit) then
				if gT.Players[iPlayer].UnitClassXP[iUnit:GetUnitClassType()] then
					iUnit:SetHasPromotion(GameInfoTypes.PROMOTION_ITG_TECH_AMBUSH, true)
				end
			end
		end
	end
	if HasPlayerTech(iPlayer, techTRIALpagan5, "&gsgegg") then
		iUnit:SetHasPromotion(GameInfoTypes.PROMOTION_ITG_TRIAL_PAGAN_5, true)
	end
	if HasPlayerTech(iPlayer, innoTrialEuro3, "23523427235") then
		if iUnit:GetUnitCombatType() == GameInfoTypes.UNITCOMBAT_MELEE or (iUnit:GetUnitCombatType() == GameInfoTypes.UNITCOMBAT_MOUNTED) then
			iUnit:ChangeAdjacentSameClassModifier(8);
		end
	end
end

function DoDiscoverExtraOasis(iPlayer, amount)
	local tTab = {}
	for i = 0, Map:GetNumPlots() - 1, 1 do
		local fPlot = Map.GetPlotByIndex( i );
		if fPlot:GetTerrainType() == tDesert then
			if fPlot:GetOwner() == iPlayer then
				if not fPlot:IsHills() then
					if (fPlot:GetFeatureType() == -1) and (fPlot:GetResourceType() == -1) then
						if not IsSpecialControlPlot(fPlot) then
							table.insert(tTab, fPlot);
						end
					end
				end
			end
		end
	end
	local fOasis = GameInfoTypes.FEATURE_OASIS;
	if #tTab > 0 then
		tTab = Shuffle(tTab);
		for i = 1, amount do
			if tTab[i] then
				tTab[i]:SetFeatureType(fOasis)
			else
				return;
			end
		end
	end
end

function DoInnovationOnGreatGeneralAcquired(iPlayer)
	if HasPlayerTech(iPlayer, afr7tech, "^234142!24") then
		ChangeITGScience(iPlayer, 250)
		if Players[iPlayer]:GetNumUnitsOutOfSupply() <= 0 then
			GenerateFreeUnits(iPlayer, 5, "DOMAIN_LAND");
		end
	end
end

function DoUniteBarbariansSeen(iPlayer)
	local iTeam = Players[iPlayer]:GetTeam();
	if Players[iPlayer]:GetNumUnitsOutOfSupply() <= 0 then
		for iUnit in Players[63]:Units() do
			if not iUnit:IsUnjoinable() then
				if iUnit:GetPlot():IsVisible(iTeam) then
					local hDmg = iUnit:GetDamage();
					local hType = iUnit:GetUnitType();
					local nPlot = iUnit:GetPlot();
					iUnit:Kill(false, -1);
					local jUnit = Players[iPlayer]:InitUnit(hType, nPlot:GetX(), nPlot:GetY());
					jUnit:SetDamage(hDmg);
					ITGSCNewUnitCreated(iPlayer, jUnit, nil, false, nil, nil, false)
					if Players[iPlayer]:GetNumUnitsOutOfSupply() > 0 then
						return;
					end	
				end
			end
		end
	end
end

function AdjustMoraleBonusesOnInno(iPlayer, cMorale)
	for iCity in Players[iPlayer]:Cities() do
		SetBasicCityYieldRate(iCity, yProduction, cMorale, "CI_PROD_FROM_MORALE")
	end
	local cHealRate = gT.Players[iPlayer].ExtraHealRateFromMorale;
	if cHealRate ~= cMorale then
		Players[iPlayer]:ChangeExtraHealRateUnits(cMorale - cHealRate);
		gT.Players[iPlayer].ExtraHealRateFromMorale = cMorale;
	end
end


function DoDiscoverCertainAmountOfPlotsNotRandomly(iPlayer, numplots)
	local unrevealed = GetTheUnknownTerritoryOfPlayer(iPlayer)
	local todo = numplots;
	local iTeam = Players[iPlayer]:GetTeam();
	local revRev = ReverseIntoIterable(unrevealed);
	local toIterate = {};
	local iterated = 0;
	if #revRev > todo then
		revRev = Shuffle(revRev)
		local fTab = {};
		for a, b in pairs(revRev) do
			if Map.GetPlotByIndex(b):IsWater() then
				table.insert(fTab, b);
			else
				table.insert(fTab, 1, b);
			end
		end
		for i, plotindex in pairs(fTab) do
			if unrevealed[plotindex] then
				Map.GetPlotByIndex(plotindex):SetRevealed(iTeam, true);
				todo = todo - 1;
				unrevealed[plotindex] = nil;
				table.insert(toIterate, plotindex)
				if todo == 0 then
					DoDeferredFog(iTeam)
					return;
				end
				while iterated < #toIterate do
					iterated = iterated + 1;
					local iPlot = Map.GetPlotByIndex(toIterate[iterated])
					for j = 0, 5 do
						local nPlot = Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), j);
						if nPlot and unrevealed[nPlot:GetPlotIndex()] then
							nPlot:SetRevealed(iTeam, true);
							todo = todo - 1;
							unrevealed[nPlot:GetPlotIndex()] = nil;
							table.insert(toIterate, nPlot:GetPlotIndex())
							if todo == 0 then
								DoDeferredFog(iTeam)
								return;
							end
						end
					end
				end
			end
		end
	else
		for i, index in pairs(revRev) do
			Map.GetPlotByIndex(index):SetRevealed(iTeam, true);
		end
	end
	DoDeferredFog(iTeam)
end

function DoDeferredFog(iTeam)
	if iTeam == Game.GetActiveTeam() then
		Map.UpdateDeferredFog()
	end
end

function TryToAddOneRoadIfPossible(iPlayer)
	local hVt = {}
	for plotindex, x in pairs(gT.Players[iPlayer].AllRoadsT or {}) do
		local iPlot = Map.GetPlotByIndex(plotindex);
		if iPlot:GetOwner() == iPlayer then
			if iPlot:GetRouteType() == -1 then
				table.insert(hVt, iPlot)
			end
		end
	end
	if #hVt == 0 then
		gT.Players[iPlayer].AllRoadsT = {}
		for i = 0, Map:GetNumPlots() - 1, 1 do
			local fPlot = Map.GetPlotByIndex( i );
			if fPlot:GetOwner() == iPlayer then
				if fPlot:GetRouteType() == -1 then
					if not fPlot:IsWater() then
						if not fPlot:IsMountain() then
							if not fPlot:IsImpassable() then
								table.insert(hVt, fPlot)
								gT.Players[iPlayer].AllRoadsT[i] = 1;
							end
						end
					end
				end
			end
		end
	end
	if #hVt > 0 then
		local hxplot = hVt[LastRandom(1,#hVt)];
		hxplot:SetRouteType(rRoad)
		gT.Players[iPlayer].AllRoadsT[hxplot:GetPlotIndex()] = nil;
	end
end

function InnoAlliesNotBulliable(iPlayer, am)
	for h, pl in pairs(gT.Players)	do
		if Players[h]:IsMinorCiv() then
			if Players[h]:GetAlly() == iPlayer then
				ChangeBulliableCorruptableCS(h, am, am)
			end
		end
	end
end

function ChangeStrengthOfAllGenAdm(iPlayer, val)
	for iUnit in Players[iPlayer]:Units() do
		if IsGreatGeneralAdmiral(iUnit, "GeneralName") or IsGreatGeneralAdmiral(iUnit, "AdmiralName") then
			ChangeITGBaseCombatStrength(iUnit, val, val)
		end
	end
end

function HearMeRoar(plot, radius, player)
	for iUnit in Players[player]:Units() do
		if Map.PlotDistance(plot:GetX(), plot:GetY(), iUnit:GetX(), iUnit:GetY()) <= radius then
			iUnit:SetMadeAttack(true)
		end
	end
end

function GetTurnValuesForGlobalization(turn)
	if turn <= 30 then
		return 27, 22;
	elseif turn <= 60 then
		return 22, 17;
	else
		return 17, 12;
	end
end

local wonderindu12 = GameInfoTypes.BUILDING_ITG_NEW_INDUSTRIAL_WONDER_12;
function DoTurnGlobalization()
	local gTurn = GetITGGameTurn()
	if gT.Globals.GlobalizationTech then
		for tech, turn in pairs(gT.Globals.GlobalizationTech) do
			if turn ~= -99 then
				local rand1, rand2 = GetTurnValuesForGlobalization(turn)
				local tdif = gTurn - turn;
				if (tdif < rand1) and (tdif >= rand2) then
					if LastRandom(1, rand1 - tdif) == 1 then
						gT.Globals.GlobalizationTech[tech] = -99;
						for g, gh in pairs(gT.Players) do
							if (not Players[g]:IsMinorCiv()) and Players[g]:IsAlive() then
								local pTeam = Players[g]:GetTeam();
								if not Teams[pTeam]:IsHasTech(tech) then
									if HasAllNeededPrereqs(g, Teams[pTeam], GameInfo.Technologies[tech].Type) then
										PlayerDiscoverTech(g, tech, true, "hDT1")
									end
								end
							end
						end
					end
				end
			end
		end
		if gT.Wonders[wonderindu12] then
			local tPlayer = Map.GetPlotByIndex(gT.Wonders[wonderindu12]):GetOwner();
			local pTeam = Players[tPlayer]:GetTeam();
			if (not Players[tPlayer]:IsMinorCiv()) then
				for tech, turn in pairs(gT.Globals.GlobalizationTech) do
					if turn ~= -99 then
						if not Teams[pTeam]:IsHasTech(tech) then
							local rand1, rand2 = GetTurnValuesForGlobalization(turn)
							local tdif = gTurn - turn;
							rand2 = rand2 - 6;
							if (tdif < rand1) and (tdif >= rand2) then
								if LastRandom(1, math.max(1, rand1 - tdif - 6)) == 1 then
									if HasAllNeededPrereqs(tPlayer, Teams[pTeam], GameInfo.Technologies[tech].Type) then
										PlayerDiscoverTech(tPlayer, tech, nil, "hDT2")
									end
								end
							end
						end
					end
				end
			end
		end
	end
end

function CheckForExistingInnoGlobalization(gplayer)
	if Players[gplayer]:IsMinorCiv() or Players[gplayer]:IsBarbarian() then
		return;
	end
	local pTeam = Players[gplayer]:GetTeam();
	for tech, turn in pairs(gT.Globals.GlobalizationTech) do
		if turn == -99 then
			if not Teams[pTeam]:IsHasTech(tech) then
				if HasAllNeededPrereqs(gplayer, Teams[pTeam], GameInfo.Technologies[tech].Type) then
					PlayerDiscoverTech(gplayer, tech, true, "hDT3")
				end
			end
		end
	end
end

local luxTab = {}
for row in GameInfo.Resources() do
	if row.Happiness > 0 then
		table.insert(luxTab, row.ID)
	end
end

local wonderindu17 = GameInfoTypes.BUILDING_ITG_NEW_INDUSTRIAL_WONDER_17
function FascismAndCommercialismDoTurn()
	local tab = {}
	for g, h in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
		-- pure check to see if there are issues with num of resource
			for i, resID in pairs(luxTab) do
				local c = Players[g]:GetNumResourceTotal(resID, true);
				if c < 0 then
					print("Luxury resource incorrect", g, GameInfo.Resources[resID].Type, c, Players[g]:GetResourceExport(resID))
				end
			end

			if HasPlayerTech(g, innoindu7, "adeaddeae") then
				table.insert(tab, g)
			end
		end
	end
	if #tab > 0 then
		local avgAuth, pl = 0, 0, 0;
		for g, h in pairs(gT.Players) do
			if not Players[g]:IsMinorCiv() then
				avgAuth = avgAuth + GetAverageAuthorityWithoutClumsyMods(g)
				pl = pl + 1;
			end
		end
		avgAuth = math.floor(100 * avgAuth / pl) / 100;
		for t, h in pairs(tab) do
			local fauth = 0;
			local pauth = GetAverageAuthorityWithoutClumsyMods(h)
			if pauth < avgAuth then
				fauth = math.min(5, math.ceil( (avgAuth - pauth) / 2))
			end
			gT.Players[h].FascismAuth = fauth
		end
	end
	if gT.WondersConstructed[wonderindu17] then
		gT.Globals.CasinoBonus = Get20PercentOfBestPositiveIncome()
	end
	if DBScenario.IsWorldWideEconomy then
		local val = 999;
		for g, h in pairs(gT.Players) do
			if not Players[g]:IsMinorCiv() then
				val = math.min(val, h.PrevTurnGPT)
			end
		end
		local finiteVal = (-1 * val) + gT.Globals.WorldWideEconomy;
		gT.Globals.WorldWideEconomy = math.min(0, finiteVal)
	end
end

function ChangeGeneralGlobalAura(iPlayer, num)
	gT.Players[iPlayer].GeneralGlobalAura = gT.Players[iPlayer].GeneralGlobalAura + num;
	Players[iPlayer]:SetGeneralGlobalAura(gT.Players[iPlayer].GeneralGlobalAura > 0 )
end

function Get20PercentOfBestPositiveIncome()
	local bVal = 0;
	for g, h in pairs(gT.Players) do
		if not h.HasPlayerWonder[wonderindu17] then
			bVal = math.max(bVal, h.PrevTurnGPT)
		end
	end
	return math.floor(bVal / 5)
end

function GetGoldFromCasino(iPlayer)
	local b = 0;
	if gT.Players[iPlayer].HasPlayerWonder[wonderindu17] then
		b = b + gT.Globals.CasinoBonus; 
	end
	return b;
end

local citiesByRiver;
local citiesByConts;
function GetInnoCityLogTables()
	return citiesByRiver, citiesByConts;
end

function DoLogCityLocation(iPlot)
	if citiesByRiver then
		for a, river in pairs(GetRiversOfPlot(iPlot)) do
			if not citiesByRiver[river] then
				citiesByRiver[river] = {}
			end
			table.insert(citiesByRiver[river], iPlot:GetPlotIndex())
		end
		local iContID = GetContID(iPlot, "vkeorkfoe")
		if not citiesByConts[iContID] then
			citiesByConts[iContID] = {}
		end
		table.insert(citiesByConts[iContID], iPlot:GetPlotIndex())
	end
end

function IsLonelyOnLandmass(contID)
	if not citiesByConts then
		DoInitCitiesRiverLog()
	end
	if citiesByConts[contID] then
		if #citiesByConts[contID] == 1 then
			return true;
		end
	else
		print("Error Logic 9345354/345435")
	end
	return false;
end

function DoInitCitiesRiverLog()
	citiesByRiver = {}
	citiesByConts = {}
	for g, h in pairs(gT.Players) do
		for iCity in Players[g]:Cities() do
			DoLogCityLocation(iCity:Plot())
		end
	end
end

function IsCityValidForRiverWarlordBonus(iCity, iPlayer)
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_MEDIEVAL_AFR_7, "6y4334") then
		local iTeam = Players[iPlayer]:GetTeam()
		local bIndex = iCity:Plot():GetPlotIndex();
		if not citiesByRiver then
			DoInitCitiesRiverLog()
		end
		for a, river in pairs(GetRiversOfPlot(iCity:Plot())) do
			if not citiesByRiver[river] then
				print("Error 943/242/545", river, iPlayer)
			else
				for d, index in pairs(citiesByRiver[river]) do
					if index ~= bIndex then
						if Map.GetPlotByIndex(index):IsRevealed(iTeam) then
							return true;
						end
					end
				end
			end
		end
	end
	return false;
end

function DoTurnSevenSeasPromotions(iPlayer)
	local tabAv = {[GameInfoTypes.PROMOTION_ITG_SEVEN_SEAS_1] = 1,
	[GameInfoTypes.PROMOTION_ITG_SEVEN_SEAS_2] = 1,
	[GameInfoTypes.PROMOTION_ITG_SEVEN_SEAS_3] = 1,
	[GameInfoTypes.PROMOTION_ITG_SEVEN_SEAS_4] = 1,
	[GameInfoTypes.PROMOTION_ITG_SEVEN_SEAS_5] = 2,
	[GameInfoTypes.PROMOTION_ITG_SEVEN_SEAS_6] = 3,
	[GameInfoTypes.PROMOTION_ITG_SEVEN_SEAS_7] = 1,}
	local haveN = 5;
	local avUnits = {}
	for iUnit in Players[iPlayer]:Units() do
		if iUnit:GetDomainType() == dSea then
			if gT.Players[iPlayer].UnitClassXP[iUnit:GetUnitClassType()] then
				local bHave = false;
				for iprom, sth in pairs(tabAv) do
					if iUnit:IsHasPromotion(iprom) then
						bHave = true;
						haveN = haveN - 1;
						tabAv[iprom] = nil;
					end
				end
				if not bHave then
					table.insert(avUnits, iUnit)
				end
			end
		end
	end
	for i = 1, haveN do
		if #avUnits > 0 then
			local lKey = LastRandom(1,#avUnits);
			local lUnit = avUnits[lKey];
			local tabP = {}
			for prom, htype in pairs(tabAv) do
				if (htype == 1) or ((htype == 2) and (lUnit:GetBaseRangedCombatStrength() > 0)) or ((htype == 3) and (lUnit:GetBaseRangedCombatStrength() == 0)) then
					table.insert(tabP, prom)
				end
			end
			local lProm = tabP[LastRandom(1,#tabP)];
			lUnit:SetHasPromotion(lProm, true)
			tabAv[lProm] = nil;
			table.remove(avUnits, lKey)
		else
			return;
		end
	end
end

function InitResistanceVision(iPlayer)
	gT.Players[iPlayer].ResMovementVision = {}
	local iTeam = Players[iPlayer]:GetTeam();
	for g, h in pairs(gT.Players) do
		for iCity in Players[g]:Cities() do
			if iCity:IsOccupied() then
				local sTab = GetPlotsInRadiusOfPlot(iCity:Plot(), 1);
				for c, hPlot in pairs(sTab) do
					hPlot:ChangeVisibilityCount(iTeam, 1)
				end
				gT.Players[iPlayer].ResMovementVision[iCity:Plot():GetPlotIndex()] = true;
			end
		end
	end
end

function RemoveResistanceVision(iPlayer)
	local iTeam = Players[iPlayer]:GetTeam();
	for index, sth in pairs(gT.Players[iPlayer].ResMovementVision) do
		local sTab = GetPlotsInRadiusOfPlot(Map.GetPlotByIndex(index), 1);
		for c, hPlot in pairs(sTab) do
			hPlot:ChangeVisibilityCount(iTeam, -1)
		end
	end
	gT.Players[iPlayer].ResMovementVision = nil;
end

function CityStatusForResistanceVisionDirty(iCity)
	local cIndex = iCity:Plot():GetPlotIndex();
	local bOccupied = iCity:IsOccupied();
	local sTab = GetPlotsInRadiusOfPlot(iCity:Plot(), 1);
	for g, h in pairs(gT.Players) do
		if h.ResMovementVision then
			if bOccupied then
				if not h.ResMovementVision[cIndex] then
					local iTeam = Players[g]:GetTeam();
					for c, hPlot in pairs(sTab) do
						hPlot:ChangeVisibilityCount(iTeam, 1)
					end
					gT.Players[g].ResMovementVision[cIndex] = true;
				end
			elseif h.ResMovementVision[cIndex] then
				local iTeam = Players[g]:GetTeam();
				for c, hPlot in pairs(sTab) do
					hPlot:ChangeVisibilityCount(iTeam, -1)
				end
				gT.Players[g].ResMovementVision[cIndex] = nil;
			end
		end
	end
end

function CanCityStartUprising(pPlot, iCity, iPlayer)
	if pPlot:GetOwner() ~= iPlayer then
		if iCity:IsOccupied() then
			if pPlot:IsRevealed(Players[iPlayer]:GetTeam()) then
				if not iCity:IsResistance() then
					return true;
				end
			end
		end
	end
	return false;
end

function HumanWantsResMovement(iPlayer, pPlot)
	if pPlot:IsCity() then
		if CanCityStartUprising(pPlot, pPlot:GetPlotCity(), iPlayer) then	
			PlayerTriggerResistanceMovement(iPlayer, pPlot:GetPlotCity())
		end
	end
end

function PlayerTriggerResistanceMovement(iPlayer, iCity)
	gT.Players[iPlayer].ResMovementCooldown = GetRealGameTurn() + 15;
	StartCityUprising(iCity, iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded(), 3)
	if iPlayer == Game.GetActivePlayer() or (iCity:GetOwner() == Game.GetActivePlayer()) then
		Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(iCity:GetX(), iCity:GetY()))), "[ICON_RESISTANCE] UPRISING [ICON_RESISTANCE]", 0.5)
	end
end

function GetNumUnitsFromCityLastCall(iCity, iPlayer)
	local ibase = math.ceil(iCity:GetPopulation() / 10)
	if iCity:GetOwner() ~= iPlayer then
		ibase = ibase * 2;
		if iCity:IsOccupied() then
			ibase = ibase * 2;
		end
		if Teams[Players[iPlayer]:GetTeam()]:IsAtWar(Players[iCity:GetOwner()]:GetTeam()) then
			ibase = ibase * 2;
		end
	end
	return ibase;
end

function ShouldAIUseLastCall(iPlayer)
	local t = 0;
	for g, h in pairs(gT.Players) do
		for iCity in Players[g]:Cities() do
			local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
			if gT.Cities[cID].CultureOwner == iPlayer then
				t = t + GetNumUnitsFromCityLastCall(iCity, iPlayer)
			end
		end
	end
	if t > 0 then
		if Players[iPlayer]:GetNumCities() == 0 then
			return true;
		end
		if t >= 10 then
			return true;
		end
	end
	return false;
end

function TriggerLastCallAbility(iPlayer)
	gT.Players[iPlayer].LastCallCharges = gT.Players[iPlayer].LastCallCharges - 1;
	local bActivePlayer = iPlayer == Game.GetActivePlayer();
	TakeCareOfEventMorale(iPlayer, 25, {10, "Last Call"})
	local unittype = Players[iPlayer]:GetPlayerUniqueUnit(BASE_INFANTRY_CLASS);
	if unittype ~= -1 then
		for g, h in pairs(gT.Players) do
			for iCity in Players[g]:Cities() do
				local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
				if gT.Cities[cID].CultureOwner == iPlayer then
					local numunits = GetNumUnitsFromCityLastCall(iCity, iPlayer)
					local pTab = GetEmptyValidPlotsInArea(iCity:Plot(), 2, iPlayer);
					for i, h in pairs(pTab) do
						if not h:IsWater() then
							SimpleGenerateUnitOfType(iPlayer, unittype, h, nil, nil, nil, true)
							if bActivePlayer then
								local hex = ToHexFromGrid(Vector2(h:GetX(), h:GetY()));
								Events.GameplayFX(hex.x, hex.y, -1);
							end
							numunits = numunits - 1;
							if numunits == 0 then
								break;
							end
						end
					end
				end
			end
		end
	end
	if bActivePlayer then
		RefreshAllDirtyPlayer()
	end
end
LuaEvents.ITGCallLastCall.Add(TriggerLastCallAbility)


function DoAddPropagandaInnoBonuses(iPlayer, numworks)
	if numworks < 1 then
		return;
	end
	local tabAvaBonus = {1, 2, 3, 4, 5}
	local tabAcquired = {}
	if BudgetBelongsToIdeoLeague(iPlayer) then
		table.insert(tabAvaBonus, 6)
	end
	for i = 1, numworks do
		local lBonus = tabAvaBonus[LastRandom(1,#tabAvaBonus)];
		tabAcquired[lBonus] = (tabAcquired[lBonus] or 0) + 1
		if lBonus == 1 then
			DistributeRandomlyHappiness(iPlayer, 3)
		elseif lBonus == 2 then
			TakeCareOfEventMorale(iPlayer, 25, {1, "Propaganda"})
		elseif lBonus == 3 then
			IncreaseWorkRateInAllCities(iPlayer, 150)
		elseif lBonus == 4 then
			ChangeITGGold(iPlayer, 75)
		elseif lBonus == 5 then
			gT.Players[iPlayer].FestivalVarious = gT.Players[iPlayer].FestivalVarious + 7;
		elseif lBonus == 6 then
			local ideoleague = GetIdeologyLeagueOfPlayer(iPlayer)
			gT.Leagues[ideoleague].Members[iPlayer].BudgetSupport = gT.Leagues[ideoleague].Members[iPlayer].BudgetSupport + 100;
		end
	end
	if Players[iPlayer]:IsHuman() then
		local str = "Due to efforts of our talented artists we achieved:"
		for a, b in pairs(tabAcquired) do	
			str = str .. "[NEWLINE][ICON_BULLET]+"
			if a == 1 then
				str = str .. b * 3 .. " [ICON_HAPPINESS_1] Happiness randomly distributed among the Cities."
			elseif a == 2 then
				str = str .. b .. "% [ICON_ITG_MORALE] Morale."
			elseif a == 3 then
				str = str .. 150 * b .. " [ICON_WORKER] Work Rate in all Cities."
			elseif a == 4 then
				str = str .. 75 * b .. " [ICON_GOLD] Gold."
			elseif a == 5 then
				str = str ..  0.7 * b .. "% extra chance for new [ICON_ITG_FESTIVAL] Festival."
			elseif a == 6 then
				str = str ..  100 * b .. " contribution for doctrine of your Ideology." 
			end
		end
		Players[iPlayer]:AddNotification(NotificationTypes.NOTIFICATION_GREAT_WORK_COMPLETED_ACTIVE_PLAYER, str, "Propaganda", -1, -1, -1, -1)
	end
end

function DoCheckMeso5Beliefs(iPlayer)
	if not gT.Players[iPlayer].Meso5Palace then
		local iCity = Players[iPlayer]:GetCapitalCity();
		if iCity then
			local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
			if gT.Cities[cID].Palace then
				if gT.Cities[cID].Palace.NumUpgrades >= 8 then
					gT.Players[iPlayer].Meso5Palace = true;
					if Players[iPlayer]:GetReligionCreatedByPlayer() < 1 then
						DoAddNewBeliefOfType(iPlayer, 1)
					else
						DoAddNewBeliefOfType(iPlayer, 3)
					end
				end
			end
		end
	end
	if not gT.Players[iPlayer].Meso5Principle then
		if gT.Players[iPlayer].NumPrinciples >= 6 then
			gT.Players[iPlayer].Meso5Principle = true;
			if Players[iPlayer]:GetReligionCreatedByPlayer() < 1 then
				DoAddNewBeliefOfType(iPlayer, 1)
			else
				DoAddNewBeliefOfType(iPlayer, 2)
			end
		end
	end
	if not gT.Players[iPlayer].Meso5Connection then
		local iC = 0;
		for iCity in Players[iPlayer]:Cities() do
			if not iCity:IsCapital() then
				if Players[iPlayer]:IsCapitalConnectedToCity(iCity) then
					iC = iC + 1;
				end
			end
		end
		if iC >= 4 then
			gT.Players[iPlayer].Meso5Connection = true;
			if Players[iPlayer]:GetReligionCreatedByPlayer() < 1 then
				DoAddNewBeliefOfType(iPlayer, 1)
			else
				DoAddNewBeliefOfType(iPlayer, 2)
			end
		end
	end
end

function DoOnEndTurnInnovations(iPlayer)
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_NW_TROPICAL_8, "tropical8") then
		for iUnit in Players[iPlayer]:Units() do
			if (iUnit:GetDomainType() == dSea) and gT.Players[iPlayer].UnitClassXP[iUnit:GetUnitClassType()] then
				iUnit:SetHasPromotion(GameInfoTypes.PROMOTION_ITG_FLEE_TROPICAL_INNO, iUnit:GetDamage() > iUnit:GetMaxHitPoints() / 2)
			end
		end
	end
end

function OnDirtyCulturalGuilds(iPlayer)
	local tabOfCities = {}
	gT.Players[iPlayer].HasCultGuild = nil;
	for iCity in Players[iPlayer]:Cities() do
		local guildType;
		if iCity:IsHasBuilding(GameInfoTypes.BUILDING_ITG_GUILDS_NW_WRITER) then
			guildType = "W"
		elseif iCity:IsHasBuilding(GameInfoTypes.BUILDING_ITG_GUILDS_NW_ARTIST) then
			guildType = "A"
		elseif iCity:IsHasBuilding(GameInfoTypes.BUILDING_ITG_GUILDS_NW_MUSICIAN) then
			guildType = "M"
		end
		if guildType then
			gT.Players[iPlayer].HasCultGuild = true;
			for jCity in Players[iPlayer]:Cities() do
				local hDis = Map.PlotDistance(iCity:GetX(), iCity:GetY(), jCity:GetX(), jCity:GetY());
				if hDis < 7 then
					local cID = jCity:Plot():GetPlotIndex() .. "," .. jCity:GetGameTurnFounded();
					if (not tabOfCities[cID]) or (tabOfCities[cID][2] > hDis) then
						tabOfCities[cID] = {guildType, hDis}
					end
				end
			end
		end
	end
	for jCity in Players[iPlayer]:Cities() do
		local cID = jCity:Plot():GetPlotIndex() .. "," .. jCity:GetGameTurnFounded();
		if tabOfCities[cID] then
			gT.Cities[cID].CultGuild = tabOfCities[cID][1];
		else
			gT.Cities[cID].CultGuild = nil;
		end
	end
end