local InspHelpTab = {
{ID = 1, Name = "Mind", Reward = "+1 [ICON_RESEARCH] Science", Flavour = "FLAVOR_SCIENCE"},
{ID = 2, Name = "Greed", Reward = "+1 [ICON_GOLD] Gold", Flavour = "FLAVOR_GOLD"},
{ID = 3, Name = "Beauty", Reward = "+1 [ICON_GREAT_ARTIST] Art point", Flavour = "FLAVOR_CULTURE"},
{ID = 4, Name = "Immortality", Reward = "+1 [ICON_GREAT_ENGINEER] Wonder production", Flavour = "FLAVOR_WONDER", Sc = {[1] = true, [2] = true, [3] = true, [4] = true}},
{ID = 5, Name = "Humanity", Reward = "+1 [ICON_GREAT_PEOPLE] Great People point", Flavour = "FLAVOR_GREAT_PEOPLE"},
{ID = 6, Name = "Justice", Reward = "+0.01 [ICON_ITG_LEGAL_POWER] Legal Power", Flavour = "FLAVOR_LEGAL"},
{ID = 7, Name = "War", Reward = "+1 [ICON_GREAT_GENERAL] Great General", Flavour = "FLAVOR_OFFENSE"},
{ID = 8, Name = "Divinity", Reward = "+1 [ICON_PEACE] Faith", Flavour = "FLAVOR_RELIGION", Sc = {[1] = true, [2] = true, [3] = true}},
{ID = 9, Name = "Tomorrow", Reward = "+5 [ICON_WORKER] Work Rate", Flavour = "FLAVOR_INFRASTRUCTURE"},
{ID = 10, Name = "Parenthood", Reward = "+1 [ICON_FOOD] Food", Flavour = "FLAVOR_GROWTH"},
{ID = 11, Name = "Hedonism", Reward = "+1 [ICON_HAPPINESS_1] Happiness", Flavour = "FLAVOR_HAPPINESS"},
{ID = 12, Name = "Spirit and Body", Reward = "+1 [ICON_ITG_HEALTH_1] Health", Flavour = "FLAVOR_GROWTH"}
}

LuaEvents.ITG_RequestInspirationDB.Add(function()
	MapModData.ITGSG = InspHelpTab;
end)

local sagradaFamilia = GameInfoTypes.BUILDING_ITG_NEW_INDUSTRIAL_WONDER_18

function AddInspirationToBuildingClass(iPlayer, iType, buildingClass, bRemove)
	local bNeedMajorRefresh = false;
	if bRemove then
--		for i, v in pairs(gT.Players[iPlayer].Inspirations) do
--			if v == iType then
--				Events.GameplayAlertMessage("Incorrect Inspiration.")
--				return;
--			end
--		end
		local lkey;
		for i, sth in pairs(gT.Players[iPlayer].NewHumanQueueActions) do
			if sth.BonusType == "Inspiration" and sth.BClass == buildingClass then
				lkey = i;
				break;
			end
		end
		if lkey then
			table.remove(gT.Players[iPlayer].NewHumanQueueActions, lkey)
		end
	end
	if gT.Players[iPlayer].Inspirations[buildingClass] then
		return;
	end
	gT.LastChosenInspiration[buildingClass] = iType;
	gT.Players[iPlayer].Inspirations[buildingClass] = iType;
	local dval = 1;
	if gT.WondersConstructed[sagradaFamilia] == iPlayer then
		dval = dval + 1;
	end
	if gT.Players[iPlayer].HasIdeology[45] then
		dval = dval + 2;
	end
	if gT.Globals.GameGenerated then
		if gT.Players[iPlayer].HasIdeology[25] then
			ChangeMeritocracy(iPlayer, 25);
		end
	end
	DoDirtyCult32Bonuses()
	DoChangeBonusForInspiration(iPlayer, buildingClass, iType, dval)
end

function DoDirtyCult32Bonuses()
	for g, h in pairs(gT.Players) do
		if h.CultBonusOn[32] then
			gT.Players[g].Cult32t = {0, 0}
			local shared = {};
			for bClass, iT in pairs(h.Inspirations or {}) do
				gT.Players[g].Cult32t[1] = gT.Players[g].Cult32t[1] + 1;
				for j, b in pairs(gT.Players) do
					if iT == b.Inspirations[bClass] then
						if j ~= g then
							gT.Players[g].Cult32t[1] = gT.Players[g].Cult32t[1] - 1;
							gT.Players[g].Cult32t[2] = gT.Players[g].Cult32t[2] + 1;
							break;
						end
					end
				end
			end
		end
	end
end

function DoChangeBonusForInspiration(iPlayer, buildingClass, iType, dval)
	if iType == 1 then
		Players[iPlayer]:ChangePlayerBuildingClassYieldChange(buildingClass, yScience, dval);
	elseif iType == 2 then
		Players[iPlayer]:ChangePlayerBuildingClassYieldChange(buildingClass, yGold, dval);
	elseif iType == 3 then
		ChangeExtraArtPointsFromBuildingClass(iPlayer, buildingClass, dval)
	elseif iType == 4 then
		ChangeExtraWonderPointsFromBuildingClass(iPlayer, buildingClass, dval)
	elseif iType == 5 then
		ChangeExtraGPPointsfromBuildingClass(iPlayer, buildingClass, dval)
	elseif iType == 6 then
		ChangeExtraLegalFromBuildingClass(iPlayer, buildingClass, dval)
	elseif iType == 7 then
		ChangeExtraCombatExperienceFromBuildingClass(iPlayer, buildingClass, dval)
	elseif iType == 8 then
		Players[iPlayer]:ChangePlayerBuildingClassYieldChange(buildingClass, yFaith, dval);
	elseif iType == 9 then
		ChangeExtraWorkRareFromBuildingClass(iPlayer, buildingClass, 5 * dval)
	elseif iType == 10 then
		Players[iPlayer]:ChangePlayerBuildingClassYieldChange(buildingClass, yFood, dval);
	elseif iType == 11 then
		Players[iPlayer]:ChangeBuildingClassHappiness(buildingClass, dval)
	elseif iType == 12 then
		ChangeExtraHealthFromBuildingClass(iPlayer, buildingClass, dval)
	end
end

function ChangeExtraWorkRareFromBuildingClass(iPlayer, bClass, amount)
	if not gT.Players[iPlayer].WorkRateFromBuildingClasses[bClass] then
		gT.Players[iPlayer].WorkRateFromBuildingClasses[bClass] = amount;
	else
		gT.Players[iPlayer].WorkRateFromBuildingClasses[bClass] = gT.Players[iPlayer].WorkRateFromBuildingClasses[bClass] + amount;
		if gT.Players[iPlayer].WorkRateFromBuildingClasses[bClass] == 0 then
			gT.Players[iPlayer].WorkRateFromBuildingClasses[bClass] = nil;
		end
	end
end

function ChangeExtraWonderPointsFromBuildingClass(iPlayer, bClass, amount)
	if not gT.Players[iPlayer].WonderPointsFromBuildingClasses[bClass] then
		gT.Players[iPlayer].WonderPointsFromBuildingClasses[bClass] = amount;
	else
		gT.Players[iPlayer].WonderPointsFromBuildingClasses[bClass] = gT.Players[iPlayer].WonderPointsFromBuildingClasses[bClass] + amount;
		if gT.Players[iPlayer].WonderPointsFromBuildingClasses[bClass] == 0 then
			gT.Players[iPlayer].WonderPointsFromBuildingClasses[bClass] = nil;
		end
	end
end

function ChangeExtraArtPointsFromBuildingClass(iPlayer, bClass, amount)
	if not gT.Players[iPlayer].ArtPointsFromBuildingClasses[bClass] then
		gT.Players[iPlayer].ArtPointsFromBuildingClasses[bClass] = amount;
	else
		gT.Players[iPlayer].ArtPointsFromBuildingClasses[bClass] = gT.Players[iPlayer].ArtPointsFromBuildingClasses[bClass] + amount;
		if gT.Players[iPlayer].ArtPointsFromBuildingClasses[bClass] == 0 then
			gT.Players[iPlayer].ArtPointsFromBuildingClasses[bClass] = nil;
		end
	end
end

function ChangeExtraCombatExperienceFromBuildingClass(iPlayer, bClass, amount)
	if not gT.Players[iPlayer].CombatExperienceFromBuildingClasses[bClass] then
		gT.Players[iPlayer].CombatExperienceFromBuildingClasses[bClass] = amount;
	else
		gT.Players[iPlayer].CombatExperienceFromBuildingClasses[bClass] = gT.Players[iPlayer].CombatExperienceFromBuildingClasses[bClass] + amount;
		if gT.Players[iPlayer].CombatExperienceFromBuildingClasses[bClass] == 0 then
			gT.Players[iPlayer].CombatExperienceFromBuildingClasses[bClass] = nil;
		end
	end
end

function ChangeExtraLegalFromBuildingClass(iPlayer, bClass, amount)
	if not gT.Players[iPlayer].LegalPointsFromBuildingClasses[bClass] then
		gT.Players[iPlayer].LegalPointsFromBuildingClasses[bClass] = amount;
	else
		gT.Players[iPlayer].LegalPointsFromBuildingClasses[bClass] = gT.Players[iPlayer].LegalPointsFromBuildingClasses[bClass] + amount;
		if gT.Players[iPlayer].LegalPointsFromBuildingClasses[bClass] == 0 then
			gT.Players[iPlayer].LegalPointsFromBuildingClasses[bClass] = nil;
		end
	end
end

function ChangeExtraGPPointsfromBuildingClass(iPlayer, bClass, amount)
	if not gT.Players[iPlayer].GPPointsFromBuildingClasses[bClass] then
		gT.Players[iPlayer].GPPointsFromBuildingClasses[bClass] = amount;
	else
		gT.Players[iPlayer].GPPointsFromBuildingClasses[bClass] = gT.Players[iPlayer].GPPointsFromBuildingClasses[bClass] + amount;
		if gT.Players[iPlayer].GPPointsFromBuildingClasses[bClass] == 0 then
			gT.Players[iPlayer].GPPointsFromBuildingClasses[bClass] = nil;
		end
	end
end

function GetInspirationAvailable(iPlayer)
	local sTab = {}
	local badInsp = {}
	for bClass, inspiration in pairs(gT.Players[iPlayer].Inspirations) do
		badInsp[inspiration] = true;
	end
	for i, data in pairs(InspHelpTab) do
		if not badInsp[i] then
			if (not data.Sc) or (data.Sc[gT.Globals.ScenarioType]) then
				table.insert(sTab, i)
			end
		end
	end
	if #sTab == 0 then
		for i, data in pairs(InspHelpTab) do
			table.insert(sTab, i)
		end
	end
	return sTab;
end

function GetRandomValidInspiration(iPlayer)
	local sTab = {}
	local badInsp = {}
	for bClass, inspiration in pairs(gT.Players[iPlayer].Inspirations) do
		badInsp[inspiration] = true;
	end
	for i, data in pairs(InspHelpTab) do
		if not badInsp[i] then
			table.insert(sTab, i)
		end
	end
	if #sTab == 0 then
		for i, data in pairs(InspHelpTab) do
			table.insert(sTab, i)
		end
	end
	return sTab[LastRandom(1,#sTab)];
end

function AddInspirationChooseToPlayer(iPlayer, bClass, bUICall)
	if gT.Players[iPlayer].Inspirations[bClass] then
		AddInspirationToRandomBuilding(iPlayer)
		return;
	end
	local sTab = GetInspirationAvailable(iPlayer);
	VictoryTaskCompletion(iPlayer, 74)
	if #sTab < 2 then
		if #sTab == 1 then
			AddInspirationToBuildingClass(iPlayer, sTab[1], bClass)
			if iPlayer == Game.GetActivePlayer() then
				local bstring = Locale.Lookup(GameInfo.Buildings[Players[iPlayer]:GetPlayerUniqueBuilding( bClass)].Description);
				Players[iPlayer]:AddNotification(94343293,"From this day all " .. bstring .. "s will inspire our people (" .. InspHelpTab[sTab[1]].Reward .. ")." , "New Inspiration",-1,-1,12)
			end
		else
			AddInspirationToBuildingClass(iPlayer, gT.LastChosenInspiration[bClass], bClass)
			if iPlayer == Game.GetActivePlayer() then
				local bstring = Locale.Lookup(GameInfo.Buildings[Players[iPlayer]:GetPlayerUniqueBuilding( bClass)].Description);
				Players[iPlayer]:AddNotification(94343293,"From this day all " .. bstring .. "s will inspire our people (" .. InspHelpTab[gT.LastChosenInspiration[bClass]].Reward .. ")." , "New Inspiration",-1,-1,12)
			end
		end
	else
		if #sTab > 4 then
			local ttt = Shuffle(sTab);
			sTab = {ttt[1], ttt[2], ttt[3], ttt[4]};
		end
		if Players[iPlayer]:IsHuman() then
			table.insert(gT.Players[iPlayer].NewHumanQueueActions, GetHumanInspirationsAvailable(iPlayer, bClass, sTab))
			if bUICall then
				LuaEvents.ITG_GeneralChooseWithPriority("CHOOSE INSPIRATION");
			end
		else
			table.insert(gT.Players[iPlayer].QueueActionsRealEndTurn, {"Inspiration", bClass, sTab})
		end
	end
end

function PrepareExtraDataForHumanInspiration(iPlayer, bClassInsp)
	local sTab = GetInspirationAvailable(iPlayer);
	local rsTab = ReverseTable(sTab);
	local tKey;
	for a, b in pairs(gT.Players[iPlayer].NewHumanQueueActions) do
		if b.BonusType == "Inspiration" and b.BClass == bClassInsp then
			local bContinue = true;
			tKey = a;
			for c, d in pairs(b.UniqueOptions) do
				if not rsTab[d.ID] then
					bContinue = false;
					break;
				end
			end
			if bContinue then
				return nil;
			end
		end
	end
	if not tKey then
		print("FATAL error with inspirations human")
	end
	if #sTab > 4 then
		local ttt = Shuffle(sTab);
		sTab = {ttt[1], ttt[2], ttt[3], ttt[4]};
	end
	gT.Players[iPlayer].NewHumanQueueActions[tKey] = GetHumanInspirationsAvailable(iPlayer, bClassInsp, sTab);
	return gT.Players[iPlayer].NewHumanQueueActions[tKey];
end

function GetBuildingClassBestString(iPlayer, bClass)
	local btype = Players[iPlayer]:GetPlayerUniqueBuilding(bClass);
	if btype == -1 then
		btype = GameInfo.BuildingClasses[bClass].DefaultBuilding;
	end
	return Locale.Lookup(GameInfo.Buildings[btype].Description);
end

function GetHumanInspirationsAvailable(iPlayer, bClass, sTab)
	local bstring = GetBuildingClassBestString(iPlayer, bClass)
	local btype = Players[iPlayer]:GetPlayerUniqueBuilding(bClass);
	if btype == -1 then
		btype = GameInfo.BuildingClasses[bClass].DefaultBuilding;
	end
	local data = {BonusType = "Inspiration", BClass = bClass, Text = "CHOOSE INSPIRATION", TitleText = "Choose Inspiration for " .. bstring .. ".", TitleIconIndex = GameInfo.Buildings[btype].PortraitIndex, TitleIconAtlas = GameInfo.Buildings[btype].IconAtlas, Tooltip = "You have earned a right to give building a deeper meaning to your people."}
	local hTab = {}
	for i, sid in pairs(sTab) do
		table.insert(hTab, {Name = bstring .. " of " .. InspHelpTab[sid].Name,
			ID = sid,						
			Help = bstring .. " will grant " .. InspHelpTab[sid].Reward .. ".";
			ExtraInfo = bClass})
	end
	data.UniqueOptions = hTab;
	return data;
end

function AIPlayerChooseInspiration(iPlayer, bClass, sTab)
	local besttab = Shuffle(ValidateOptionsForInspiration(iPlayer, sTab));
	local besop, bestval = nil, -1;
	for i, sid in pairs(besttab) do
		local sValue = GetAIFlavour(iPlayer, InspHelpTab[sid].Flavour)
		if sValue > bestval then
			bestval = sValue;
			besop = sid;
		elseif sValue == bestval then
			if LastRandom(1,2) == 2 then
				besop = sid;
			end
		end
	end
	AddInspirationToBuildingClass(iPlayer, besop, bClass)
end

function GetProperBuildingForNewInspiration(iPlayer, scType)
	local bClasses = {}
	if gT.Players[iPlayer].QueueActionsRealEndTurn then
		for i, h in pairs(gT.Players[iPlayer].QueueActionsRealEndTurn) do
			bClasses[h[2]] = 1;
		end
	end
	if gT.Players[iPlayer].NewHumanQueueActions then
		for i, v in pairs(gT.Players[iPlayer].NewHumanQueueActions) do
			if v.BonusType == "Inspiration" then
				bClasses[v.BClass] = 1;
			end
		end
	end
	for i, s in pairs(gT.Players[iPlayer].Inspirations) do
		bClasses[i] = 1
	end
	local hTabP = {{}, {}, {}, {}}
	for bclass, b in pairs(GetBuildingClassesValidForScenario()) do
		if not bClasses[bclass] then
			if GameInfo.BuildingClasses[bclass].MaxPlayerInstances ~= 1 then
				if Players[iPlayer]:GetPlayerUniqueBuilding(bclass) > -1 then
					if IsFavouredBuildingClassForInspiration(bclass, scType or gT.Globals.ScenarioType) then
						if Players[iPlayer]:GetBuildingClassCount(bclass) > 0 then
							table.insert(hTabP[1], bclass)
						else
							table.insert(hTabP[2], bclass)
						end
					else
						if Players[iPlayer]:GetBuildingClassCount(bclass) > 0 then
							table.insert(hTabP[3], bclass)
						else
							table.insert(hTabP[4], bclass)
						end
					end
				end
			end
		end
	end
	for i = 1, 4 do
		if #hTabP[i] > 0 then
			return RandomFromTab(hTabP[i]);
		end
	end
	return nil
end

function AddInspirationToRandomBuilding(iPlayer, scType, bForce, bEraConv, bUICall)
	local bClass = GetProperBuildingForNewInspiration(iPlayer, scType)
	if bClass then
		if bForce then
			local sTab = GetInspirationAvailable(iPlayer);
			local insp = sTab[LastRandom(1,#sTab)];
			AddInspirationToBuildingClass(iPlayer, insp, bClass, false)
			if bEraConv then
				tempconvinit[iPlayer].Inspirations[bClass] = insp;
			end
		else
			AddInspirationChooseToPlayer(iPlayer, bClass, bUICall)
		end
	end
	return bClass;
end

function AddRemoveSagradaFamilia(iPlayer, hval)
	for iClass, iType in pairs(gT.Players[iPlayer].Inspirations) do
		DoChangeBonusForInspiration(iPlayer, iClass, iType, hval)
	end
end

function GenerateInspirationIfPossible(iPlayer, bClass) -- this one is fine (wonders mainly)
	if gT.EraData and gT.PreviousEra then 
		if tempconvinit[iPlayer].Inspirations[bClass] then
			return;
		end
	end
	AddInspirationToBuildingClass(iPlayer, LastRandom(1,#InspHelpTab), bClass, false)
end

function RedoInspirations()
	if gT.EraData and gT.PreviousEra then 
		for i, v in pairs(gT.Players) do
			if not Players[i]:IsMinorCiv() then
				for buildingclass, iType in pairs(tempconvinit[i].Inspirations) do
					AddInspirationToBuildingClass(i, iType, buildingclass, false)
				end
			end
		end
	else
		for g, h in pairs(gT.Players) do
			if not Players[g]:IsMinorCiv() then
				if gT.Globals.ScenarioType == 1 then
					AddInspirationToRandomBuilding(g, 3, true)
					AddInspirationToRandomBuilding(g, 2, true)
					if LastChance(50) then
						AddInspirationToRandomBuilding(g, 2, true)
					end
				elseif gT.Globals.ScenarioType == 2 then
					AddInspirationToRandomBuilding(g, 3, true)
					if LastChance(50) then
						AddInspirationToRandomBuilding(g, 3, true)
					end
				elseif gT.Globals.ScenarioType == 3 then
				elseif gT.Globals.ScenarioType == 4 then
					AddInspirationToRandomBuilding(g, 3, true)
					AddInspirationToRandomBuilding(g, 2, true)
					AddInspirationToRandomBuilding(g, 1, true)
					if LastChance(50) then
						AddInspirationToRandomBuilding(g, 1, true)
					end
				elseif gT.Globals.ScenarioType == 5 then
					AddInspirationToRandomBuilding(g, 3, true)
					AddInspirationToRandomBuilding(g, 2, true)
					AddInspirationToRandomBuilding(g, 1, true)
					AddInspirationToRandomBuilding(g, 4, true)
					if LastChance(50) then
						AddInspirationToRandomBuilding(g, 4, true)
					end
				else
					print("undefined scenario 6534/2/123")
				end
			end
		end
	end
end

function ValidateOptionsForInspiration(iPlayer, cTab)
	local sTab = GetInspirationAvailable(iPlayer);
	local rsTab = ReverseTable(sTab);
	for c, d in pairs(cTab) do
		if not rsTab[d] then
			local newTab = {};
			sTab = Shuffle(sTab)
			for i = 1, 4 do
				if sTab[i] then
					table.insert(newTab, sTab[i]);
				else
					break;
				end
			end
			if #newTab > 0 then
				return newTab;
			end
			break;
		end
	end
	return cTab;
end