local logLawsAItab = {}
function RequestLogLawsAITab()
	return logLawsAItab
end

function DecideWhatToDoWithLegalPowerAI(iPlayer)
	if GetITGGameTurn() == 100 then
		DoLastTurnAILegalDecision(iPlayer)
		return
	end
	local legPower = GetAvailablePowerForLegalAction(iPlayer, false);
	local legHapPower = GetAvailablePowerForLegalAction(iPlayer, true);
	local hapAvailable = legHapPower - legPower;
	local alloptions = {}
	if gT.Players[iPlayer].Goverment == 1 then
		gT.Players[iPlayer].AILegalTactic = -1; -- remove any legal tactic
		table.insert(alloptions, {1, 25, nil, 500})
	else
		if HasAIScriptForLegalTactic(iPlayer, legPower, legHapPower) then
			return;
		end
		if (gT.Players[iPlayer].AILegalTactic ~= 2) then
			if GetITGGameTurn() > 20 or (LastRandom(1,3) ~= 2) then -- this it to grant Early Laws an advantage
				local lPt = GetLegalPointsPerTurn(iPlayer, true);
				for i, data in pairs(GetDataFromTabLegalAction()) do
					if CanDoLegalActionBasic(iPlayer, data.ID, false) then
						local cOption;
						local cCost = (data.Cost or data.EstCost)
						if data.OnlyLegal then
							cOption =  data.AIHelpFunction(iPlayer, math.min(3, legPower -cCost ), lPt);
						else
							cOption =  data.AIHelpFunction(iPlayer, math.max(math.min(6, 2 * (hapAvailable - cCost)), math.min(3, legHapPower - cCost)), lPt);
						end
						if cOption then
							table.insert(alloptions, cOption)
						end
					end	
				end
			end
		end
		--laws;
		local cdAI = GetITGGameTurn() - 8;
		local bcdLaws = {}
		if gT.Globals.LawsChangeLog then
			local iter = #gT.Globals.LawsChangeLog + 1;
			for a, b in pairs(gT.Globals.LawsChangeLog) do
				if gT.Globals.LawsChangeLog[iter - a][4] >= cdAI then
					if gT.Globals.LawsChangeLog[iter - a][1] == iPlayer then
						bcdLaws[gT.Globals.LawsChangeLog[iter - a][2]] = 1;
					end
				else
					break;
				end
			end
		end
		local iExtraTowardsLaw = 0;
		if HasCSMission(iPlayer, 5) then
			iExtraTowardsLaw = iExtraTowardsLaw + 5;
		end
		if gT.Players[iPlayer].FreeLaws > 0 then
			iExtraTowardsLaw = iExtraTowardsLaw + 10;
		end
		if (not gT.Players[iPlayer].HasCodex) or (GetITGGameTurn() < 40) or (LastRandom(1,13) == 5) or (GetITGGameTurn() > 97) then
			for i, data in pairs(GetLawsDataTable()) do
				if not bcdLaws[i] then
					if CanPlayerHaveLaw(iPlayer, i) then
						local cOption = GetAIEvalOfLaw(iPlayer, legPower - 1, data.ID);
						if cOption then
							cOption[4] = cOption[4] + iExtraTowardsLaw;
							table.insert(alloptions, cOption)
						end
					end
				end
			end
		end
	end
	local bestID, bv = nil, 0;
	for i, data in pairs(alloptions) do
		if bv < data[4] then
			bestID = i;
			bv = data[4];
		end
	end
	if bestID then
	--HERE IS some AI log
		PlayerWantToClaimLegalWithFaith(iPlayer, 1)
		table.insert(logLawsAItab, {iPlayer, Game.GetGameTurn(), alloptions[bestID][1], alloptions[bestID][2], alloptions[bestID][3], alloptions[bestID][4]})

		if alloptions[bestID][1] == 1 then
			--action legal
			if not CanAffordTheAction(alloptions[bestID][2], iPlayer, nil, alloptions[bestID][3], alloptions[bestID][5]) then
				if LastRandom(1,7) == 3 then
					if Players[iPlayer]:GetGold() > gT.Players[iPlayer].LegalAuthorityCost * LastRandom(2,4) then
						PlayerWantToPurchaseLegalAuthority(iPlayer)
					end
				end
			end
			if CanAffordTheAction(alloptions[bestID][2], iPlayer, nil, alloptions[bestID][3], alloptions[bestID][5]) then
				PushLegalActionForPlayer(iPlayer, alloptions[bestID][2], alloptions[bestID][3], alloptions[bestID][5])
			end
		elseif alloptions[bestID][1] == 2 then
			if not CanAffordLawPlayer(iPlayer, alloptions[bestID][2])  then
				if LastRandom(1,7) == 3 then
					if Players[iPlayer]:GetGold() > gT.Players[iPlayer].LegalAuthorityCost * LastRandom(2,4)  then
						PlayerWantToPurchaseLegalAuthority(iPlayer)
					end
				end
			end
			if CanAffordLawPlayer(iPlayer, alloptions[bestID][2]) then
		 		OnLawChanged(iPlayer, alloptions[bestID][2], alloptions[bestID][3])
			end
		end
	end
end

function AIHelpInnovationAction(iPlayer, lPowerAv, lpp)
	if lPowerAv >= 0 then
		if GetAvailableHapForLegalAction(iPlayer) >= 5 then
			return {1, 2, nil, math.max(5, math.ceil((100 - GetITGGameTurn()) / 4))}
		end
	end
	return nil;
end

function AIHelpInviteGovernorAction(iPlayer, lPowerAv, lpp)
	if lPowerAv > 4 then
		local gTurn = GetITGGameTurn();
		if gTurn > 17 and gTurn < 64 then
			local extraReasons = 0;
			if gT.Players[iPlayer].CultBonusOn[69] then
				extraReasons = extraReasons + 2;
			end
			if LastChance(25 + extraReasons) then
				local options = PrepareDataForForeignGovernors(iPlayer).UniqueOptions;
				if #options > 0 then
					local govID = RandomFromTab(options).ID;
					--REVISIT
					return {1, 3, govID, 8 + extraReasons}
				end
			end
		end
	end
	return nil;
end

function AIHelpGainIntriguePower(iPlayer, lPowerAv, lpp)
	if lpp < 35 then
		return nil;
	end
	local inumgovs = GetNumActiveGovernors(iPlayer);
	if inumgovs == 0 then
		return nil;
	end
	if lPowerAv < 4 then
		return nil;
	end
	local iChance = inumgovs * 5
	if GetITGGameTurn() < 50 then
		iChance = iChance + 5;
	end
	if gT.Players[iPlayer].MeritocracyLevel < 50 then
		iChance = iChance + 2;
	end
	return {1, 35, nil, iChance}
end

function AIHelpEnforceCodex(iPlayer, lPowerAv, lpp)
	if gT.Players[iPlayer].HasCodex then
		local base = 1 + GetAIAttitudeTowardCodexStrength(iPlayer);
		local bo, bv = nil, 0;
		local minorTab = PreparedDataForEnforceCodex(iPlayer);
		for i, data in pairs(minorTab.UniqueOptions) do
			local val = Players[data.ID]:GetNumCities();
			if data.CodexFrom then
				val = val + 3;
			end
			if val > bv then
				bo = data.ID;
				bv = val;
			end
		end
		if bo then
			return {1, 36, bo, math.min(base, bv)}
		end
	end
	return nil
end

function AIHelpConsolidateCodex(iPlayer, lPowerAv, lpp)
	if lPowerAv > 4 then
		return {1, 37, nil, math.max(1, GetAIAttitudeTowardCodexStrength(iPlayer))}
	end
	return nil;
end

function AIHelpAppointGovernor(iPlayer, lPowerAv, lpp)
	local numUngovCities = GetNumCitiesUnderGovernor(iPlayer, nil);
	local totCities = Players[iPlayer]:GetNumCities();
	local bestGovPower = 0;
	local numgovs = 0;
	for govid, h in pairs(gT.Players[iPlayer].Governors) do
		numgovs = numgovs + 1;
		bestGovPower = math.max(bestGovPower, gT.Globals.Governors[govid].Power)
	end
	if totCities > 1 + numgovs then
		local iChance = math.floor(numUngovCities * 2 + totCities / 2 + bestGovPower / 30)
		if numgovs == 0 then
			iChance = iChance + 2;
		end
		if gT.Players[iPlayer].MeritocracyLevel < 50 then
			iChance = iChance + 2;
		end
		return {1, 34, nil, iChance}
	end
	return nil;
end

function AIHelpLegalCurrencyAction(iPlayer, extraFromLPAv)
--max 10 value;
	local base = 4 + math.min(0, extraFromLPAv);
	if gT.Players[iPlayer].AILastCurrencyChange then --don't change too often
		if gT.Players[iPlayer].AILastCurrencyChange + 10 >= GetITGGameTurn() then
			return nil;
		end
	end
	if HasMintAnyCity(iPlayer) then
		if not HasPlayerTech(iPlayer, GameInfoTypes.TECH_BANKING, "Caceaew") then
			base = base + 4;
		end
	else
		if gT.Globals.ScenarioType ~= 3 then
			return nil; -- don't bother wasting happiness
		end
		if GetITGGameTurn() > 50 then
			return nil; -- don't bother wasting hap to gain hap
		end
	end
	local currentResource = gT.Players[iPlayer].Currencies;
	local bestResID, bestValue = nil, EstimateCurValueFromFakeTab(iPlayer, currentResource);
	local baseValue = bestValue;
	for res, sth in pairs(gT.CurrencyResources) do
		if gT.Players[iPlayer].Currencies ~= res then
			local nValue = EstimateCurValueFromFakeTab(iPlayer, res)
			if nValue > bestValue then
				bestResID = res;
				bestValue = nValue;
			end
		end
	end
	if not bestResID then
		return nil;
	end
	if bestValue < 60 then
		return nil;
	end
	if bestValue - baseValue < 25 then
		return nil;
	end
	return {1, 1, bestResID, base + math.floor((bestValue - baseValue) / 40)}
end

function AIDoLegalSchism(iPlayer, extraFromLPAv)
	if GetITGGameTurn() > 85 then
		return nil;
	end
	-- max 40
	local val = 5 + 3 * Players[iPlayer]:GetNumCities() + math.min(0, extraFromLPAv);
	local rPlayer = Game.GetFounder(gT.Players[iPlayer].OfficialReligion, -1);
	if not Players[rPlayer]:IsAlive() then
		val = val + 15;
	end
	if Players[rPlayer]:IsMinorCiv() then
		val = val + 8;
	end
	if Players[iPlayer]:IsDenouncingPlayer(rPlayer) then
		val = val + 5;
	end
	if Players[rPlayer]:IsDenouncingPlayer(iPlayer) then
		val = val + 5;
	end
	return {1, 4, nil, math.min(40, val)}
end


function AISetLegalOfficialReligion(iPlayer, extraFromLPAv)
--max 20
	if GetITGGameTurn() > 85 then
		return nil;
	end
	local base = 10 + math.min(0, extraFromLPAv);
	local iRel = Players[iPlayer]:GetReligionCreatedByPlayer();
	if iRel > 0 then
		if gT.Players[iPlayer].OfficialReligion ~= iRel then
			local val = 5;
			for iCity in Players[iPlayer]:Cities() do
				if iCity:GetReligiousMajority() ~= iRel then
					val = val + iCity:GetPopulation()
				end
			end
			return {1, 5, iRel, math.min(base, val)}  
		end
	end
	return nil;
end

function AIHelpLegalEmbassy(iPlayer, extraFromLPAv, lPt)
	local base = 2 + math.min(0, extraFromLPAv);
	if GetITGGameTurn() < 20 then
		base = base + 3;
	elseif GetITGGameTurn() < 50 then
		base = base + 2;
	end
	if lPt > 50 then
		base = base + 1;
	end
	local iTeam = Players[iPlayer]:GetTeam();
	local bestoption, bestvalue = nil, 20;
	for i, pdata in pairs(gT.Players) do
		if CanEstablishEmbassyWithPlayer(iPlayer, iTeam, i) then
			if not( Players[iPlayer]:IsDenouncingPlayer(i) or Players[i]:IsDenouncingPlayer(iPlayer) ) then
				if not WereAtWarDuringThisScenario(iTeam, Players[i]:GetTeam()) then
					local value = LastRandom(15,20) - #gT.Players[i].NumWarsDeclared * 2;
					if Players[iPlayer]:IsDoF(i) then
						value = value + 30;
					end
					if Teams[Players[i]:GetTeam()]:HasEmbassyAtTeam(iTeam) then
						value = value + 10;
					end
					local gTurn = GetITGGameTurn();
					for i, logdata in pairs(gT.Players[iPlayer].EspionageLog) do
						local difturns = gTurn - logdata[1];
						if logdata[5] == i then
							if logdata[3] == 6 then
								if difturns < 10 then
									value = value - 4;
								else
									value = value - 2;
								end
							elseif logdata[3] == 2 then
								value = value - 1;
							end
						end
					end
					if value > bestvalue then
						bestvalue = value;
						bestoption = i;
					end
				end
			end
		end
	end
	if bestoption then
		return {1, 6, bestoption, base}
	else
		return nil;
	end
end

function AIHelpClaimReligion(iPlayer, extraFromLPAv)
	local base = 15 + math.min(0, extraFromLPAv);
	local bestValue, extraInfo, bestOption = 0, nil, nil;
	if Players[iPlayer]:GetReligionCreatedByPlayer() < 1 then
		for g, gdata in pairs(gT.Players) do
			local rel = Players[iPlayer]:GetReligionCreatedByPlayer();
			if rel > 0 then
				local holyCity = Game.GetHolyCityForReligion(rel, -1);
				if holyCity:GetOwner() == iPlayer then
					if IsFullyControlled(holyCity, iPlayer) then
						if gT.Players[iPlayer].EverControlReligion[rel] then
							if bestValue < 19 then
								bestValue = 19;
								bestOption = rel;
							end
						elseif bestValue < 15 then
							bestValue = 15;
							bestOption = rel;
						end
					end
				end
			end
		end
	end
	if bestOption then
		return {1, 14, bestOption, math.min(base, bestValue), extraInfo}
	end
end

function AIHelpDiplomaticMarriage(iPlayer, extraFromLPAv)
	local base = 11 + math.min(0, extraFromLPAv);
	local bestValue, extraInfo, bestOption = 0, nil, nil;
	for g, gdata in pairs(gT.Players) do
		if Players[g]:IsMinorCiv() and (Players[g]:GetAlly() == iPlayer) and Players[g]:IsAlive() then
			if Players[g]:GetNumCities() > 0 then
				if gdata.LastAllyChange <= GetITGGameTurn() - 20 then
					bestOption = g;
					break;
				end
			end
		end
	end
	if bestOption then
		return {1, 16, bestOption, math.min(base, bestValue), extraInfo}
	end
end

function AIHelpChangeOfficialCapital(iPlayer, extraFromLPAv)
	local base = 3 + math.min(0, extraFromLPAv);
	local cOne =  GetOriginalCapitalOfPlayer(iPlayer)
	if not cOne then
		return;
	end
	if cOne:GetOwner() ~= iPlayer then
		if not Teams[Players[iPlayer]:GetTeam()]:IsAtWar(Players[cOne:GetOwner()]:GetTeam()) then
			local bestValue, extraInfo, bestOption = 0, nil, nil;
			local tab = PreparedDataForNewCapital(iPlayer).UniqueOptions
			for i, data in pairs(tab) do
				local iCity = Players[iPlayer]:GetCityByID(data.ID);
				local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
				local val = iCity:GetPopulation() + GetBasicAuthorityFromCity(iPlayer, iCity)
				-- + 1000 - GetSimpleCalculateCorruptionIfThisCityCapital(iPlayer, {iCity});
				if val > bestValue then
					bestValue = val;
					bestOption = iCity;
				end
			end
			if bestOption then
				if bestOption:GetDamage() == 0 then
					return {1, 27, bestOption:GetID(), math.min(base, bestValue), extraInfo}
				end
			end
		end
	end
end

function AIHelpClaimCityLegal(iPlayer, extraFromLPAv)
	local base = 3 + math.min(0, extraFromLPAv);
	local bestValue, extraInfo, bestOption = 0, nil, nil;
	local tab = PreparedDataForClaimCities(iPlayer).UniqueOptions
	for i, data in pairs(tab) do
		local iCity = Players[iPlayer]:GetCityByID(data.ID);
		if iCity:GetPopulation() > bestValue then
			bestValue = iCity:GetPopulation();
			bestOption = iCity:GetID();
		end
	end
	if bestOption then
		return {1, 15, bestOption, math.min(base, bestValue), extraInfo}
	end
end

function AIHelpLegalModernizeUnit(iPlayer, extraFromLPAv)
	--max value 12
	local base = 12 + math.min(0, extraFromLPAv);
	local unitupgrado = PrepareTabOfPossibleUpgradeClasses(iPlayer);
	local bestValue, extraInfo, bestOption = 0, nil, nil;
	for j, fdata in pairs(unitupgrado) do
		local value = 0;
		for iUnit in Players[iPlayer]:Units() do
			if iUnit:GetUnitClassType() == fdata[1] then
				value = value + 1;
			elseif iUnit:GetUnitClassType() == fdata[2] then
				value = value + 0.01;
			end
		end
		if gT.Players[iPlayer].UnitClassXP[fdata[1]] > 160 then
			value = value + math.ceil((gT.Players[iPlayer].UnitClassXP[fdata[1]] - 160) / 10);
		end
		value = value + gT.Players[iPlayer].UnitClassXP[fdata[2]] / 100;
		if value > bestValue then
			bestOption = fdata[1];
			extraInfo = fdata[2];
			bestValue = value;
		end
	end
	if bestOption then
		return {1, 12, bestOption, math.min(base, bestValue), extraInfo}
	end
end

function AIHelpLegalPledgeToProtect(iPlayer, extraFromLPAv)
	local base = 5 + math.min(0, extraFromLPAv);
	local bestValue, bestOption = 50, nil;
	if gT.Players[iPlayer].NumMaxPledges <= #gT.Players[iPlayer].PledgesOfProtection  then
		return
	end
	local ier = 0;
	if gT.Players[iPlayer].CultBonusOn[31] then
		ier = ier + 2;
	end
	local minorTab = PreparedDataForPledge(iPlayer);
	for i, data in pairs(minorTab.UniqueOptions) do
		if Players[data.ID]:GetMinorCivFriendshipLevelWithMajor(iPlayer) > 0 then
			local cvalue = GetAIPledgeValueOfMinor(iPlayer, data.ID)
			if cvalue > bestValue then
				bestValue = cvalue;
				bestOption = data.ID;
			end
		end
	end
	if bestOption then
		if HasCSMission(iPlayer, 7) then
			ier = ier + 5;
		end
		return {1, 26, bestOption, math.min(base, bestValue) + ier}
	end
end

function AIHelpChooseForeignCurrency(iPlayer, extraFromLPAv)
	if extraFromLPAv < 4 then -- no happiness available;
		return nil;
	end
	if gT.Players[iPlayer].ForeignReserve then
		return nil;
	end
	local bVal, bOption;
	local gTurn = GetITGGameTurn();
	for j, b in pairs(gT.Players) do
		if (not Players[j]:IsMinorCiv()) and (j ~= iPlayer) and (b.MintPower > 0) then
			if Teams[Players[iPlayer]:GetTeam()]:IsHasMet(Players[j]:GetTeam()) then
				local eVal = math.min(75, math.floor(b.MintPower / 15));
				local tEst = b.MintEstablished or gTurn;
				eVal = eVal + gTurn - b.MintEstablished - b.NumCounterfeited * 30;
				
				if Teams[Players[iPlayer]:GetTeam()]:IsAtWar(Players[j]:GetTeam()) then
					eVal = eVal - 30;
				end
				if Players[iPlayer]:IsDoF(j) then
					eVal = eVal + 30;
				end
				if (not bVal) or (bVal < eVal) then
					bVal = eVal;
					bOption = j;
				end
			end
		end
	end
	if bOption then
		return {1, 31, bOption, 10}
	end
	return nil;
end

function AIHelpChooseSanctifyHolySite(iPlayer, extraFromLPAv)
	local hsTab = PrepareDataForHolySiteSanctify(iPlayer);
	for i, data in pairs(hsTab.UniqueOptions) do
		return {1, 32, data.ID, math.max(2, GetAIFlavour(iPlayer, "FLAVOR_RELIGION"))}
	end
end

function AIHelpLegalImproveRelation(iPlayer, extraFromLPAv)
--max value 5
	local base = 5 + math.min(0, extraFromLPAv);
	local bestValue, bestOption = 0, nil;
	local minorTab = PreparedDataForInfluenceImprove(iPlayer);
	for i, data in pairs(minorTab.UniqueOptions) do
	--data.ID
		local numtimes = GetNumColonyBoostsNeededToAlly(iPlayer, data.ID, 20)
		local cvalue = 0;
		if numtimes == 1 then
			cvalue = 5
		elseif numtimes == 2 then
			cvalue = 2;
		elseif LastRandom(1, 100) == 33 then
			cvalue = 5;
		end
		if gT.Players[iPlayer].HasIdeology[84] and (Players[data.ID]:GetMinorCivFriendshipLevelWithMajor(iPlayer) < 1) then
			cvalue = cvalue + 12;
		end
		if HasCSMission(iPlayer, 34, data.ID) then
			cvalue = cvalue + 5;
		end
		if cvalue > bestValue then
			bestValue = cvalue;
			bestOption = data.ID;
		end
	end
	if bestOption then
		return {1, 7, bestOption, math.min(base, bestValue)}
	end
end

function AIHelpLegalResettlement(iPlayer, extraFromLPAv)
	local base = 8 + math.min(0, extraFromLPAv);
	if gT.Players[iPlayer].LegalPower > 4 then
		if gT.Players[iPlayer].SettlerPoints == 0 then
			for index, sth in pairs(gT.Settlements) do
				if sth.Player == iPlayer then
					if CanSettlementBeUpdatedNow(index, iPlayer) then
						return {1, 13, nil, base}
					end
				end
			end
		end
	end
	return nil;
end
function AIHelpDoPrivilige(iPlayer, extraFromLPAv, lpt)
	local base = math.min(0, extraFromLPAv);
	if gT.Players[iPlayer].LegalPower > 4 then
		if GetITGGameTurn() >= 80 then
			local unhap = gT.Players[iPlayer].AverageHappiness
			if unhap < -4 then
				base = base - unhap + 4;
				if gT.Players[iPlayer].MeritocracyLevel < 5 then
					base = base + 5;
				end
				return {1,17,nil,base}
			end
		end
	end  
	return nil;
end
function AIDoEradicateCorrupt(iPlayer, extraFromLPAv)
	local base = 0;
	if GetITGGameTurn() > 85 then
		return nil;
	end
	if gT.Players[iPlayer].MeritocracyLevel > 80 then
		return nil;
	end
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		base = base + GetITGCityInteger(iCity, "CI_CORRUPTION_GOLD") * (1 + GetITGCityInteger(iCity, "CI_CORRUPTION_GOLD")) / 2;		
		base = base + GetITGCityInteger(iCity, "CI_CORRUPTION_PROD") * (1 + GetITGCityInteger(iCity, "CI_CORRUPTION_PROD")) / 2;		
	end
	base = math.floor(base / 100);
	if base > 0 then
		return {1, 20, nil, base}
	else
		return nil;
	end
end
function AIHelpDoCodex(iPlayer, extraFromLPAv)
	if not gT.Players[iPlayer].GovSlots[1] then
		return nil; -- first ai should acquire authority slot
	end
	local getCost = DoCheckCostOfCodex(iPlayer)
	if getCost < 9 then -- AI should not bother with too much cost
		local legal = gT.Players[iPlayer].LegalPower
		local hap = GetAvailableHapForLegalAction(iPlayer);
		if (hap >= getCost - 2) and ((hap + legal) >= getCost) then
			local eval = 9;
			if GetITGGameTurn() <= 40 then
				eval = eval + 16;
			end
			eval = eval + 3 * GetPrinciplesBehind(iPlayer);
			return {1,18,nil,eval}
		end
	end
	return nil
end
function AIHelpDoNationalDay(iPlayer, extraFromLPAv)
	if GetITGGameTurn() > 10 and GetITGGameTurn() < 95 then
		return nil;
	end
	local base = 5 + math.min(0, extraFromLPAv);
	if Players[iPlayer]:GetNumCities() < 3 then
		base= base + 1;
	end
	if NAT_UNITY_PENALTY_FREE - gT.Players[iPlayer].NatUnity > 0 then
		base = base + 1;
	end
	return {1, 19, nil, base}
end
function AIHelpDoStandardiseAlphabet(iPlayer, extraFromLPAv)
	if GetITGGameTurn() > 15 and GetITGGameTurn() < 85 then
		if gT.Globals.AlphabetCost > 5 then
			return nil;
		end
	end
	local base = 5 + math.min(0, extraFromLPAv) + Players[iPlayer]:GetNumCities();
	if NAT_UNITY_PENALTY_FREE - gT.Players[iPlayer].NatUnity > 0 then
		base = base + 1;
	end
	return {1, 21, nil, base}
end
function AIDoLeaveLeagueOfNations(iPlayer, extraFromLPAv)
	local base = 3 + math.min(0, extraFromLPAv)
	if Players[iPlayer]:GetNumCities() < 2 then
		return nil;
	end
	if IsHalfOrLessInLeague("LeagueOfNations", -1) then
		base = base - 15 -- on the edge of disbanding
	end
	if gT.Leagues["LeagueOfNations"].Resolutions[48] then
		base = base + 4;
	end
	base = base + (gT.Leagues["LeagueOfNations"].Members[iPlayer].DenounceWarmongerPenalty or 0) / 7
	local tab = {{54, 3}, {55, 3}, {56,3}, {49, 3}, {47, 3}, {46, 3}}
	for i, data in pairs(tab) do
		if gT.Leagues["LeagueOfNations"].Resolutions[data[1]] then
			base = base + data[2];
		end
	end
	if gT.Leagues["LeagueOfNations"].Resolutions[51] then
		base = base + Players[iPlayer]:GetNumCities();
	end
	if gT.Leagues["LeagueOfNations"].Resolutions[57] then
		for i, aca in pairs(gT.Academies) do
			if aca.Player == iPlayer then
				if IsAboveAverageAcademyPrestigeRank(i) then
					base = base +2;
				else
					base = base -1;
				end
			end
		end
	end
	if gT.Leagues["LeagueOfNations"].Resolutions[53] then
		if Players[iPlayer]:GetTotalPopulation() >= 90 then
			base = base - 2;
		else
			base = base + 3;
		end
	end
	base = math.floor(base)
	return {1, 22, nil, base}
end
function AIDoNationalMemorial(iPlayer, extraFromLPAv)
	local base = 7 + math.min(0, extraFromLPAv)
	return {1, 23, nil, base}
end
function AIDoWorldWideAnarchy(iPlayer, extraFromLPAv)
	local base = math.min(0, extraFromLPAv + 5 * math.floor((extraFromLPAv + 4) / 4)) 
	return {1, 24, nil, base}
end
function AIDoExpandPalaceLegal(iPlayer, extraFromLPAv)
	if gT.Players[iPlayer].AIPalaceBlock then
		return {1, 28, nil, 3}
	end
	return {1, 28, nil, 8}
end
function AIDoFormalizeRanks(iPlayer, extraFromLPAv)
	local gTurn = GetITGGameTurn();
	if gTurn < 90 then
		if gT.Players[iPlayer].FallenGenerals > 0 then
			local numtotal, numgenerals = GetNumGGACombatUnits(iPlayer, 1, "GeneralName")
			if numtotal > numgenerals then
				if math.floor( numtotal / 5) > numgenerals then
					return {1, 29, 1, (math.floor( numtotal / 5) - numgenerals) * 5}
				end
			end
		end
		if gT.Players[iPlayer].FallenAdmirals > 0 then
			local numtotal, numgenerals = GetNumGGACombatUnits(iPlayer, 3, "AdmiralName")
			if numtotal > numgenerals then
				if math.floor( numtotal / 5) > numgenerals then
					return {1, 29, 2, (math.floor( numtotal / 5) - numgenerals) * 5}
				end
			end
		end
	end
	return nil;
end
function AIDoEstablishCH(iPlayer, extraFromLPAv)
	local gTurn = GetITGGameTurn();
	if (gTurn < 40) or (extraFromLPAv > 15) then
		if Players[iPlayer]:GetNumCities() > 3 then
			return {1, 30, nil, 10}
		end
	end
	return nil;
end
function AIHelpLegalForceOfficialReligion(iPlayer, extraFromLPAv)
	if GetITGGameTurn() > 85 then
		return nil;
	end
	local base = 5 + math.min(0, extraFromLPAv);
	local bo, bv = nil, 0;
	local minorTab = PreparedDataForEnforcingOfficialReligion(iPlayer);
	local iRel = Players[iPlayer]:GetReligionCreatedByPlayer();
	if iRel == gT.Players[iPlayer].OfficialReligion then
		for i, data in pairs(minorTab.UniqueOptions) do
			local val = 0;
			if Players[data.ID]:GetNumCities() > 0 then
				if Players[data.ID]:GetCapitalCity():GetReligiousMajority() ~= iRel then
					val = val + 5 * Players[data.ID]:GetNumCities();
				end
				if gT.Players[data.ID].OfficialReligion ~= nil then
					val = val + 5;
				end
			end
			if val > bv then
				bo = data.ID;
				bv = val;
			end
		end
	end
	if bo then
		return {1, 8, bo, math.min(base, bv)}
	else
		return nil
	end
end

function AIHelpLegalWonderBoost(iPlayer, extraFromLPAv)
	--max 15
	if GetITGGameTurn() % 10 < 8 then
		return;
	end
	local base = 9 + math.min(0, extraFromLPAv);
	local val = 0;
	if (not gT.Globals.NoMoreWonderRace) then
		if (not gT.Players[iPlayer].CanWonderRace) then
			val = val + LastRandom(0, 10);
		end
		if (not gT.Players[iPlayer].CannotWonderBoost) then
			if ShouldAIBoostWonderRace(iPlayer) then
				val = val + 30;
			end
		end
	end
	return {1, 9, nil, math.min(base, val)}
end

function AIHelpLegalGoldenAge(iPlayer, extraFromLPAv)
	--max 40
	local base = 20 + math.min(0, extraFromLPAv);
	if ShouldAIDoGoldenAge(iPlayer, 5, "Legal") then
		return  {1, 10, nil, math.min(GetITGGameTurn(), base)}
	else
		return nil
	end
end

function AIHelpLegalSecularState(iPlayer, extraFromLPAv)
	--max 35;
	local base = 16 + math.min(0, extraFromLPAv);
	local cVal = 0;
	local relPT = GetTotalFaithFromExtraSourcesITG(iPlayer);
	if relPT > 50 then
		cVal = cVal + 30;
	elseif relPT > 20 then
		cVal = cVal + 15;
	end
	local getNextCost = NiceCostOfNextFaithBonus(iPlayer, gT.Players[iPlayer].ReligionRewardTreshold)
	if getNextCost >= 800 then
		cVal = cVal + 25;
	end
	if GetITGGameTurn() > LastRandom(90, 98) then
		return nil;
	end		
	return {1, 11, nil, math.min(cVal, base)}
end

function CallRealLawAIHelp1(iPlayer, extraFromLPAv, lawID)
	local cOption = gT.Players[iPlayer].Laws[lawID][1];
	local base = 4 + math.min(0, extraFromLPAv)
	local pOption = gT.Players[iPlayer].AIFavourOfLaws[lawID];
	if cOption ~= pOption then
		return {2, lawID, pOption, base}
	end
	return nil;
end

function CallRealLawAIHelp2(iPlayer, extraFromLPAv, lawID)
	return BasicCallLawAIHelp(iPlayer, extraFromLPAv, lawID, 6, 70)
end

function CallRealLawAIHelp3(iPlayer, extraFromLPAv, lawID)
	local cOption = gT.Players[iPlayer].Laws[lawID][1];
	local base = 3 + math.min(0, extraFromLPAv)
	local pOption = gT.Players[iPlayer].AIFavourOfLaws[lawID];
	if cOption ~= pOption then
		return {2, 3, pOption, base}
	end
	return nil;
end

function CallRealLawAIHelp4(iPlayer, extraFromLPAv, lawID)
	local cOption = gT.Players[iPlayer].Laws[lawID][1];
	local base = 4 + math.min(0, extraFromLPAv)
	local numoccupied = 0;
	for iCity in Players[iPlayer]:Cities() do
		if iCity:IsOccupied() then
			numoccupied = numoccupied + 1;
		end
	end
	if numoccupied < 2 then
		return nil
	end
	if gT.Players[iPlayer].NatUnity < NAT_UNITY_PENALTY_FREE + 6 then
		if cOption ~= 2 then
			return {2, 4, 2, math.min(base, numoccupied)}
		end
	elseif gT.Players[iPlayer].NatUnity > NAT_UNITY_PENALTY_FREE + 15 then
		if cOption ~= 1 then
			return {2, 4, 1, math.min(base, numoccupied)}
		end
	end
	return nil
end

function CallRealLawAIHelp5(iPlayer, extraFromLPAv, lawID)
	if Players[iPlayer]:GetNumCities() > 3 then
		return BasicCallLawAIHelp(iPlayer, extraFromLPAv, lawID, 4)
	end
	return nil;
end

function CallRealLawAIHelp6(iPlayer, extraFromLPAv, lawID)
	return BasicCallLawAIHelp(iPlayer, extraFromLPAv, lawID, 3, 50)
end

function BasicCallLawAIHelp(iPlayer, extraFromLPAv, lawID, iBase, gTurn)
	local pOption = gT.Players[iPlayer].AIFavourOfLaws[lawID];
	if pOption ~= -1 then
		if (not gTurn) or (GetITGGameTurn() < gTurn) then
			local cOption = gT.Players[iPlayer].Laws[lawID][1];
			if cOption ~= pOption then
				return {2, lawID, pOption, iBase + math.min(0, extraFromLPAv)}
			end
		end
	end
	return nil
end

function CallRealLawAIHelp7(iPlayer, extraFromLPAv, lawID)
	return BasicCallLawAIHelp(iPlayer, extraFromLPAv, lawID, 4)
end

function CallRealLawAIHelp8(iPlayer, extraFromLPAv, lawID)
	return BasicCallLawAIHelp(iPlayer, extraFromLPAv, lawID, 3)
end

function CallRealLawAIHelp9(iPlayer, extraFromLPAv, lawID)
	if GetITGGameTurn() > 90 then
		return nil
	end
	if gT.Players[iPlayer].Laws[lawID][1] ~= 0 then
		return nil;
	end
	local base = 2 + math.min(0, extraFromLPAv)
	if GetNumOccupiedCities(iPlayer) < 2 then
		return nil
	end
	return {2, lawID, gT.Players[iPlayer].AIFavourOfLaws[lawID], base}
end

function CallRealLawAIHelp10(iPlayer, extraFromLPAv, lawID)
	local cOption = gT.Players[iPlayer].Laws[lawID][1];
	local base = 6 + math.min(0, extraFromLPAv)
	local numcities = Players[iPlayer]:GetNumCities();
	if numcities > 6 then
		if cOption ~= 1 then
			return {2, 10, 1, base}
		end
	elseif numcities == 2 or numcities == 3 then
		if cOption ~= 2 then
			return {2, 10, 2, base}
		end
	end
	return nil;
end

function CallRealLawAIHelp11(iPlayer, extraFromLPAv, lawID)
	local cOption = gT.Players[iPlayer].Laws[lawID][1];
	local base = 5 + math.min(0, extraFromLPAv)
	local info1 = (gT.Players[iPlayer].PrevTurnGPT or 0) - 5 * GetAIFlavour(iPlayer, "FLAVOR_GOLD") - Players[iPlayer]:GetNumPaidUnits() * 0.25;
	-- be careful; this one may easily flip heavily
	if (info1 > 35) then
		if cOption == 0 or cOption == 3 or cOption == 4 then
			local nOption = LastRandom(0, 2);
			if nOption ~= cOption then
				return {2, 11, nOption, base}
			end
		end
	elseif (info1 < -35) then
		if cOption == 0 or cOption == 1 or cOption == 2 then
			if GetAIFlavour(iPlayer, "FLAVOR_HAPPINESS") >= 8 then
				return {2, 11, 3, base}
			elseif GetAIFlavour(iPlayer, "FLAVOR_HAPPINESS") <= 4 then
				return {2, 11, 4, base}
			elseif cOption ~= 0 then
				return {2, 11, 0, base}	
			end 
		end
	end
	return nil;
end

function CallRealLawAIHelp12(iPlayer, extraFromLPAv, lawID)
	return BasicCallLawAIHelp(iPlayer, extraFromLPAv, lawID, 10)
end

function CallRealLawAIHelp13(iPlayer, extraFromLPAv, lawID)
	if Players[iPlayer]:GetNumCities() < 5 then
		return nil;
	end
	local cOption = gT.Players[iPlayer].Laws[lawID][1];
	local base = 5 + math.min(0, extraFromLPAv)
	local numgp = 0;
	local numWaste = 0;
	for gpID, hhh in pairs(gT.Players[iPlayer].GreatPeople) do
		local gpData = gT.GreatPeople[gpID];
		if gpData.Alive and (not gpData.Military) then
			if (not gpData.LifeDone) and (not gpData.DoNotMigrate) then
				numgp = numgp + 1;
			else
				numWaste = numWaste + 1;
			end
		end
	end
	if numWaste > 2 then
		if cOption ~= 0 then
			return {2, 13, 0, base + numWaste}
		end
	elseif numgp > 3 then
		local pOption = gT.Players[iPlayer].AIFavourOfLaws[lawID];
		if pOption ~= cOption then
			return {2, 13, pOption, base + numgp}
		end
	end
	return nil;
end

function CallRealLawAIHelp14(iPlayer, extraFromLPAv, lawID)
	return BasicCallLawAIHelp(iPlayer, extraFromLPAv, lawID, 3, 30)
end

function CallRealLawAIHelp15(iPlayer, extraFromLPAv, lawID)
	local cOption = gT.Players[iPlayer].Laws[lawID][1];
	local base = 10 + math.min(0, extraFromLPAv)
	local pOption = gT.Players[iPlayer].AIFavourOfLaws[lawID];
	if gT.Players[iPlayer].SecularState then
		if pOption == 2 then
			pOption = RandomFromTab({1,3,4});
			gT.Players[iPlayer].AIFavourOfLaws[lawID] = pOption;
		end
		if cOption == 2 then
			base = base + 20;
		end
	end
	if cOption ~= pOption then
		return {2, 15, pOption, base}
	end
	return nil;
end

function CallRealLawAIHelp31(iPlayer, extraFromLPAv, lawID)
	return BasicCallLawAIHelp(iPlayer, extraFromLPAv, lawID, 10)
end

function CallRealLawAIHelp16(iPlayer, extraFromLPAv, lawID)
	
	return nil;
end

function CallRealLawAIHelp17(iPlayer, extraFromLPAv, lawID)
	local cOption = gT.Players[iPlayer].Laws[lawID][1];
	if cOption == 0 then
		if gT.Players[iPlayer].LastTurnLegalPoints then
			if gT.Players[iPlayer].LastTurnLegalPoints < 33 then
				return nil;
			end
		end
	end
	return BasicCallLawAIHelp(iPlayer, extraFromLPAv, lawID, 2)
end

function CallRealLawAIHelp18(iPlayer, extraFromLPAv, lawID)
	local cOption = gT.Players[iPlayer].Laws[lawID][1];
	local base = 2 + math.min(0, extraFromLPAv)
	if cOption == 3 or cOption == 4 then
		if NAT_UNITY_PENALTY_FREE > gT.Players[iPlayer].NatUnity then
			return {2, 18, GetLowestRandomFromTable({{0,GetAIFlavour(iPlayer, "FLAVOR_GOLD")},{1,GetAIFlavour(iPlayer, "FLAVOR_GROWTH")}, {2,GetAIFlavour(iPlayer, "FLAVOR_PRODUCTION")}}, true), base + 12}
		end
	else
		if gT.Players[iPlayer].PrevTurnGPT < -20 then
			if cOption == 1 or cOption == 2 then
				return {2, 18, 0, base};
			end
		elseif gT.Players[iPlayer].PrevTurnGPT > 90 then
			if cOption ~= 1 or cOption == 2 then
				return {2, 18, LastRandom(1,2), base};
			end
		end
	end
	return nil;
end

function CallRealLawAIHelp19(iPlayer, extraFromLPAv, lawID)
	local cOption = gT.Players[iPlayer].Laws[lawID][1];
	local numunits = Players[iPlayer]:GetUnitClassCountPlusMaking(GameInfoTypes.UNITCLASS_WORKBOAT);
	if numunits < 5 then
		return nil;
	end
	local base = numunits + math.min(0, extraFromLPAv)
	local pOption;
	if gT.Players[iPlayer].AISettlerPointsManagement and (gT.Players[iPlayer].AISettlerPointsManagement.Type == 1) then
		if cOption ~= 0 then
			pOption = 2;
		end
	else
		if GetITGGameTurn() > 25 then
			pOption = gT.Players[iPlayer].AIFavourOfLaws[19];
		end
	end
	if pOption and (pOption ~= cOption) then
		return {2, 19, pOption, base}
	end
	return nil;
end

function CallRealLawAIHelp20(iPlayer, extraFromLPAv, lawID)
	local cOption = gT.Players[iPlayer].Laws[lawID][1];
	local base = 5 + math.min(0, extraFromLPAv)
	if gT.Players[iPlayer].AISettlerPointsManagement then
		if gT.Players[iPlayer].AISettlerPointsManagement.Type == 1 then
			if cOption == 0 then
				return {2, 20, 1, base - 2}
			elseif cOption ~= 1 then
				return {2, 20, 1, base}
			end
		elseif gT.Players[iPlayer].AISettlerPointsManagement.Type == 4 then
			if cOption == 1 then
				if Players[iPlayer]:GetFlavourValue("FLAVOR_GOLD") > Players[iPlayer]:GetFlavourValue("FLAVOR_HAPPINESS") then
					return {2, 20, 3, base}
				else
					return {2, 20, 2, base}
				end
			end
		end
	elseif cOption ~= 0 then
		return {2, 20, 0, base - 3}
	end
	return nil;
end

function CallRealLawAIHelp21(iPlayer, extraFromLPAv, lawID)
	return BasicCallLawAIHelp(iPlayer, extraFromLPAv, lawID, 5)
end

function CallRealLawAIHelp22(iPlayer,  extraFromLPAv, lawID)
	return BasicCallLawAIHelp(iPlayer, extraFromLPAv, lawID, 5)
end

function CallRealLawAIHelp23(iPlayer,  extraFromLPAv, lawID)
	return BasicCallLawAIHelp(iPlayer, extraFromLPAv, lawID, 3, 80)
end

function CallRealLawAIHelp24(iPlayer, extraFromLPAv, lawID)
	local cOption = gT.Players[iPlayer].Laws[lawID][1];
	local base = 3 + math.min(0, extraFromLPAv)
	local pOption = gT.Players[iPlayer].AIFavourOfLaws[lawID];
	if GetITGGameTurn() < 33 then
		if cOption ~= pOption then
			return {2, 24, pOption, base}
		end
	end
	return nil;
end

function CallRealLawAIHelp25(iPlayer,  extraFromLPAv, lawID)
	local cOption = gT.Players[iPlayer].Laws[lawID][1];
	local base = 3 + math.min(0, extraFromLPAv)
	if Players[iPlayer]:GetNumCities() < 7 then
		return nil;
	end
	--low interest law;
	if GetITGGameTurn() < 50 then
		if gT.Players[iPlayer].NumFestivalsStarted > math.ceil((GetITGGameTurn() + 1) / 10) then
			local pOption;
			local tRt = gT.Players[iPlayer].GPMigratedTo - gT.Players[iPlayer].GPMigratedAway;
			local gFt = GetLastGraphData(iPlayer, 6) or 0;
			if tRt >= 2 then
				if (cOption ~= 2) or (gFt < 40) then
					pOption = 1;
				end
			elseif gFt > 62 then
				if (cOption ~= 1) or tRt < 0 then
					pOption = 2;
				end
			end
			if pOption and (pOption ~= cOption) then
				return {2, 25, pOption, base}
			end
		end
	end
	return nil;
end

function CallRealLawAIHelp26(iPlayer,  extraFromLPAv, lawID)
	local cOption = gT.Players[iPlayer].Laws[lawID][1];
	if cOption ~= 1 then
		local base = math.floor(DBScenario.PlagueStrength) + math.min(0, extraFromLPAv)
		if Players[iPlayer]:GetNumCities() < 3 then
			return nil;
		end
		for iCity in Players[iPlayer]:Cities() do
			if iCity:IsPlague() then
				base = base + 2;
			end
		end
		if base > GetAIFlavour(iPlayer, "FLAVOR_GOLD") then
			return {2, lawID, 1, base}
		end
	end
	return nil;
end

function CallRealLawAIHelp27(iPlayer,  extraFromLPAv, lawID)
	local cOption = gT.Players[iPlayer].Laws[lawID][1];
	local base = 3 + math.min(0, extraFromLPAv)
	if not HasAnyAcademy(iPlayer) then
		return nil;
	end
	local pOption = gT.Players[iPlayer].AIFavourOfLaws[lawID];
	if cOption ~= pOption then
		return {2, lawID, pOption, base}
	end
	return nil;
end

function CallRealLawAIHelp28(iPlayer,  extraFromLPAv, lawID)
	local cOption = gT.Players[iPlayer].Laws[lawID][1];
	local pOption = gT.Players[iPlayer].AIFavourOfLaws[lawID];
	if cOption ~= pOption then
		local base = math.min(0, extraFromLPAv)
		local numMerc = 0;
		for iUnit in Players[iPlayer]:Units() do
			if iUnit:IsMercenary() then
				numMerc = numMerc + 1;
			end
		end
		if numMerc > 0 then
			return {2, lawID, pOption, base + numMerc}
		end
	end
	return nil;
end

function CallRealLawAIHelp29(iPlayer,  extraFromLPAv, lawID)
	local cOption = gT.Players[iPlayer].Laws[lawID][1];
	local base = math.min(0, extraFromLPAv)
	if LastChance(7) then
		local evalTab = {{0, 4}, {1, 0}}
		local cIt = {};
		local hTab = {[fForest] = 2, [fJungle] = 2, [fMarsh] = 2};
		for iCity in Players[iPlayer]:Cities() do
			for i = 0, iCity:GetNumCityPlots() - 1 do
				local fPlot = iCity:GetCityIndexPlot( i );
				if fPlot then
					local fIndex = fPlot:GetPlotIndex();
					if not cIt[fIndex] then
						cIt[fIndex] = true;
						local fVal = hTab[fPlot:GetFeatureType()];
						if fVal then
							evalTab[fVal][2] = evalTab[fVal][2] + 1;
						end
					end
				end
			end
		end
		evalTab[1][2] = evalTab[1][2] * GetAIFlavour(iPlayer, "FLAVOR_GOLD")
		evalTab[2][2] = evalTab[2][2] * (GetAIFlavour(iPlayer, "FLAVOR_GROWTH") + GetAIFlavour(iPlayer, "FLAVOR_PRODUCTION") + GetAIFlavour(iPlayer, "FLAVOR_SCIENCE")) / 3
		local bOption, bVal = 0, 0;
		for a, b in pairs(evalTab) do
			if b[2] > bVal then
				bVal = b[2];
				bOption = b[1];
			end
		end
		if bOption ~= cOption then
			if evalTab[bOption + 1][2] >= 2 * evalTab[cOption + 1][2] then
				return {2, lawID, bOption, base + math.floor(bVal / 4)}
			end
		end
	end
	return nil;
end

function CallRealLawAIHelp30(iPlayer, extraFromLPAv, lawID)
	return BasicCallLawAIHelp(iPlayer, extraFromLPAv, lawID, 4)
end

function CallRealLawAIHelp32(iPlayer, extraFromLPAv, lawID)
	local cOption = gT.Players[iPlayer].Laws[lawID][1];
	local base = math.min(0, extraFromLPAv)
	local goodC, badC = 0, 0;
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		local chc = math.min(1, #gT.Cities[cID].Academies) + math.min(1, #gT.Cities[cID].CustomsHouses) + math.min(1, #gT.Cities[cID].Manufactories)
		if chc == 1 then
			goodC = goodC + 1;
		elseif chc > 1 then
			badC = badC + 1;
		end
	end
	if (goodC > badC) and (cOption == 0) then
		if goodC > Players[iPlayer]:GetNumCities() / 5 then
			return {2, lawID, 1, base + goodC - badC};
		end
	elseif (badC > goodC) and (cOption == 1) then
		if badC > Players[iPlayer]:GetNumCities() / 5 then
			return {2, lawID, 0, base + badC - goodC};
		end
	end
	return nil;
end

function CallRealLawAIHelp33(iPlayer, extraFromLPAv, lawID)
	local nc = Players[iPlayer]:GetNumCities();
	if nc < 3 then
		return;
	end
	local cOption = gT.Players[iPlayer].Laws[lawID][1];
	local base = 3 + math.min(0, extraFromLPAv)
	local th = {[1] = 0, [2] = 0, [3] = 0}
	if GetAIFlavour(iPlayer, "FLAVOR_HAPPINESS") >= 8 then
		th[0] = 3;	
	end
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		if #gT.Cities[cID].Academies > 0 then
			th[1] = th[1] + 1;
		end
		if #gT.Cities[cID].CustomsHouses > 0 then
			th[2] = th[2] + 1;
		end
		if #gT.Cities[cID].Manufactories > 0 then
			th[3] = th[3] + 1;
		end
	end
	local cValue = 1;
	if th[cOption] then
		cValue = math.max(cValue, th[cOption])
	end
	local bestValue = cValue;
	local bestOpt = cOption;
	for i, v in pairs(th) do
		if v > bestValue then
			bestOpt = i;
			bestValue = v;
		end
	end
	if cOption ~= bestOpt then
		return {2, lawID, bestOpt, base + 3 * (bestValue - cValue)};
	end
	return;
end

local aiEvalLawTab = {
CallRealLawAIHelp1,
CallRealLawAIHelp2,
CallRealLawAIHelp3,
CallRealLawAIHelp4,
CallRealLawAIHelp5,
CallRealLawAIHelp6,
CallRealLawAIHelp7,
CallRealLawAIHelp8,
CallRealLawAIHelp9,
CallRealLawAIHelp10,
CallRealLawAIHelp11,
CallRealLawAIHelp12,
CallRealLawAIHelp13,
CallRealLawAIHelp14,
CallRealLawAIHelp15,
CallRealLawAIHelp16,
CallRealLawAIHelp17,
CallRealLawAIHelp18,
CallRealLawAIHelp19,
CallRealLawAIHelp20,
CallRealLawAIHelp21,
CallRealLawAIHelp22,
CallRealLawAIHelp23,
CallRealLawAIHelp24,
CallRealLawAIHelp25,
CallRealLawAIHelp26,
CallRealLawAIHelp27,
CallRealLawAIHelp28,
CallRealLawAIHelp29,
CallRealLawAIHelp30,
CallRealLawAIHelp31,
CallRealLawAIHelp32,
CallRealLawAIHelp33,
}

function GetAIEvalOfLaw(iPlayer, legalAbove, lawID)
	return aiEvalLawTab[lawID](iPlayer, legalAbove, lawID);
end