include( "InstanceManager" );
include( "IconSupport" ); 

g_BasicTextYSizeChange = 9;
socImageOffsetX = 152;
miniPositions = {{80,80}, {160,0}, {0,0}}
local cSelPlayer;
local pTinstances = {}
local tPrepTab = {};
local gGdata;
local g_LawsText = InstanceManager:new( "BasicTextInstance", "Root", Controls.ListStackLaws );
local g_IdeologyText = InstanceManager:new( "BasicTextInstance", "Root", Controls.ListStackIdeologies );
local g_GovermentText = InstanceManager:new( "BasicTextInstance", "Root", Controls.ListStackGoverment );
local g_WondersText = InstanceManager:new( "BasicTextInstance", "Root", Controls.ListStackWonders );
local g_Wonders = InstanceManager:new( "WonderInstance", "Button", Controls.ListStackWonders );
local g_Inspirations = InstanceManager:new( "InspirationInstance", "Button", Controls.ListStackInsp );
local g_SocialsText = InstanceManager:new( "SocialTextInstance", "Root", Controls.ListStackSocials );
local g_TopPanelSelection = InstanceManager:new( "TopPanelPlayerInstance", "Button", Controls.TopPanelInfoStack );
local g_HasMiniIdeologyIcons = InstanceManager:new("IdeologyMiniITGButton", "IdeologyIcon", Controls.BoxMiniIdeologies );

LuaEvents.ITG_ClearInstancesEndEra.Add(function()
	cSelPlayer = nil;
	pTinstances = {};
	g_TopPanelSelection:ResetInstances();
	g_HasMiniIdeologyIcons:ResetInstances();
	g_SocialsText:ResetInstances();
	g_LawsText:ResetInstances();
	g_Wonders:ResetInstances();
	g_WondersText:ResetInstances();
	g_GovermentText:ResetInstances();
	g_Inspirations:ResetInstances();
	g_IdeologyText:ResetInstances();
end)

function PrepareTotalGridToolTip(currentTT, addTT)
	if currentTT == "" then
		return addTT;
	end
	return currentTT .. "[NEWLINE][NEWLINE]" .. addTT;
end

function PopulateLawsData()
	g_LawsText:ResetInstances();
	local tBasicText = {};
	local grandEraConversionTT = ""
	-- codex  / alphabet  / num nation days
	local codexString, codexStringTT = "", "";
	local codexDiscount, codexDiscountTT = "", "";
	if tPrepTab[cSelPlayer].HasCodex then
		codexString = "You have an established [ICON_ITG_CODEX] Codex.";
	else
		codexString = "You have not established a [ICON_ITG_CODEX] Codex.";
		codexDiscount = "You have reached " .. tPrepTab[cSelPlayer].CodexDiscount .. " [ICON_ITG_LEGAL_POWER] Codex discount.";
	end
	local alphString, alphStringTT = "", "";
	local bAlphabetExtra = false;
	if tPrepTab[cSelPlayer].Alphabet == cSelPlayer then
		alphString = "You have your own alphabet.";
	elseif tPrepTab[cSelPlayer].Alphabet == -1 then
		alphString = "You have not developed an alphabet.";
	else
		bAlphabetExtra = true;
		alphString = "You are using " .. Players[tPrepTab[cSelPlayer].Alphabet]:GetCivilizationAdjective() .. " alphabet.";
	end
	local numDaysString, numDaysStringTT = "", "";
	numDaysString = "You celebrate " .. tPrepTab[cSelPlayer].NumDays .. " National Days.";
	local noblePriviligeString, noblePriviligeTT = "", "";
	if tPrepTab[cSelPlayer].NoblePriviligeEC then
		noblePriviligeString = "You have granted a Noble privilege."
	else
		noblePriviligeString = "You have not granted a Noble privilege."
	end
	local lawsString, lawsStringTT = "", "";
	lawsString = "Your Laws:"
	if gGdata.NextScenarioID then
		codexStringTT = "In next scenario approximately [COLOR_POSITIVE_TEXT]" .. gGdata.CodexChance .. "[ENDCOLOR]% of players will start with a Codex (with an extreme possible variation of 0-100%). Players which ended current scenario with an established [ICON_ITG_CODEX] Codex will be prioritized ([COLOR_SELECTED_TEXT]" .. gGdata.NumCodexes .. "[ENDCOLOR])." 
		grandEraConversionTT = PrepareTotalGridToolTip(grandEraConversionTT, codexStringTT)
		codexDiscountTT = "In case you will start next scenario without a Codex, your initial discount to establish it will be from [COLOR_NEGATIVE_TEXT]" .. gGdata.MinCodexDiscount .. "[ENDCOLOR] to [COLOR_POSITIVE_TEXT]" .. gGdata.MaxCodexDiscount .. "[ENDCOLOR]."
		if tPrepTab[cSelPlayer].CodexDiscount >= gGdata.MaxCodexDiscount then
			codexDiscountTT = codexDiscountTT .. " You are more likely to have [COLOR_SELECTED_TEXT]" .. gGdata.MaxCodexDiscount .. "[ENDCOLOR] [ICON_ITG_LEGAL_POWER] discount."
		elseif tPrepTab[cSelPlayer].CodexDiscount > gGdata.MinCodexDiscount then
			codexDiscountTT = codexDiscountTT .. " You are more likely to have at least [COLOR_SELECTED_TEXT]" .. tPrepTab[cSelPlayer].CodexDiscount .. "[ENDCOLOR] [ICON_ITG_LEGAL_POWER] discount."
		end
		grandEraConversionTT = PrepareTotalGridToolTip(grandEraConversionTT, codexDiscountTT)
		alphStringTT = "In next scenario approximately [COLOR_POSITIVE_TEXT]" .. gGdata.AlphabetChance .. "[ENDCOLOR]% of players will start with an own Alphabet (with an extreme possible variation of 0-100%). Players with their own Alphabets will be prioritized ([COLOR_SELECTED_TEXT]" .. gGdata.NumAlphabets .. "[ENDCOLOR])." 
		if bAlphabetExtra then
			alphStringTT = alphStringTT .. "[NEWLINE]If you will start without our own Alphabet, you will have increased chance to continue using " .. Players[tPrepTab[cSelPlayer].Alphabet]:GetCivilizationAdjective() .. " alphabet."
		end
		grandEraConversionTT = PrepareTotalGridToolTip(grandEraConversionTT, alphStringTT)
		numDaysStringTT = "In next scenario each player will start with [COLOR_NEGATIVE_TEXT]" .. gGdata.MinNatDays .. "[ENDCOLOR] to [COLOR_POSITIVE_TEXT]" .. gGdata.MaxNatDays .. "[ENDCOLOR] National Days."
		if tPrepTab[cSelPlayer].NumDays >= gGdata.MaxNatDays then
			numDaysStringTT = numDaysStringTT .. " You are more likely to have [COLOR_SELECTED_TEXT]" .. gGdata.MaxNatDays .. "[ENDCOLOR] National Days.";
		end
		if tPrepTab[cSelPlayer].NumDays > gGdata.MinNatDays then
			if tPrepTab[cSelPlayer].NumDays < gGdata.MaxNatDays then
				numDaysStringTT = numDaysStringTT .. " You are more likely to have at least [COLOR_SELECTED_TEXT]" .. tPrepTab[cSelPlayer].NumDays .. "[ENDCOLOR] National Days.";
			end
			if tPrepTab[cSelPlayer].NumDays > 1 then
				numDaysStringTT = numDaysStringTT .. " If you will start with less National Days, a random one will be removed.";
			end
		end
		grandEraConversionTT = PrepareTotalGridToolTip(grandEraConversionTT, numDaysStringTT)
		noblePriviligeTT = "Base chance to start a scenario with Noble Privilige already granted is based on culture type assigned."
		if tPrepTab[cSelPlayer].NoblePriviligeEC then
			noblePriviligeTT = noblePriviligeTT .. " However you have granted a Noble Privilige in this scenario which will [COLOR_NEGATIVE_TEXT]double[ENDCOLOR] a base chance or add [COLOR_NEGATIVE_TEXT]+20%[ENDCOLOR] to it, whichever is greater."
		end
		grandEraConversionTT = PrepareTotalGridToolTip(grandEraConversionTT, noblePriviligeTT)
		if tPrepTab[cSelPlayer].HasCodex then
			lawsStringTT = "Since you have ended a scenario with a Codex each of your Law has only [COLOR_POSITIVE_TEXT]" .. gGdata.LawChangeCodex .. "%[ENDCOLOR] chance to be changed."
		else
			lawsStringTT = "Players without an established Codex have [COLOR_NEGATIVE_TEXT]" .. gGdata.LawChangeNoCodex .. "%[ENDCOLOR] chance for each Law to be changed."
		end
		lawsStringTT = lawsStringTT .. " Laws are restricted to some scenarios and cultures, therefore some may disappear and a new one may be available.";
		grandEraConversionTT = PrepareTotalGridToolTip(grandEraConversionTT, lawsStringTT)
	end
	table.insert(tBasicText, {" ",""}) -- looks better
	table.insert(tBasicText, {codexString, codexStringTT})
	if codexDiscount ~= "" then
		table.insert(tBasicText, {codexDiscount, codexDiscountTT})
	end
	table.insert(tBasicText, {alphString, alphStringTT})
	table.insert(tBasicText, {numDaysString, numDaysStringTT})
	table.insert(tBasicText, {noblePriviligeString, noblePriviligeTT})
	table.insert(tBasicText, {" ",""}) -- looks better
	table.insert(tBasicText, {lawsString, lawsStringTT})
	-- laws
	for row in DB.Query("SELECT * FROM ITGLaws") do
		if tPrepTab[cSelPlayer].LawsData[row.ID] then
			if tPrepTab[cSelPlayer].LawsData[row.ID] == 0 then
				table.insert(tBasicText, {"[ICON_BULLET][COLOR_LIGHT_GREY]" .. Locale.Lookup(row.Description), "Undefined."})
			else
				table.insert(tBasicText, {"[ICON_BULLET]" .. Locale.Lookup(row.Description), Locale.Lookup("TXT_KEY_ITG_LAW_" .. row.ID .. "_OPTION_" .. tPrepTab[cSelPlayer].LawsData[row.ID])})
			end
		end
	end
	for i, v in pairs(tBasicText) do
		local instance = g_LawsText:GetInstance();
		instance.TextMain:SetText(v[1])
		instance.Root:SetToolTipString(v[2]);
		instance.Root:SetSizeY(instance.TextMain:GetSizeY() + g_BasicTextYSizeChange)
	end
	Controls.MainGridLaw:SetToolTipString(grandEraConversionTT)
	Controls.ListStackLaws:CalculateSize();
	Controls.ListStackLaws:ReprocessAnchoring();
	Controls.ScrollPanelLaws:CalculateInternalSize();
end

function PopulateSocialDevsData()
	g_SocialsText:ResetInstances();
	if #tPrepTab[cSelPlayer].SocialDevelopments == 0 then
		Controls.MainGridSocials:SetHide(true)
		return
	end		
	local grandEraConversionTT = ""
	local bAddChance = true;
	if gGdata.NextScenarioID == 5 then --mmmm, best kind of hardcoooode
		grandEraConversionTT = "All social developments become obsolete in next scenario and will be removed."
		bAddChance = false;
	elseif gGdata.NextScenarioID then
		grandEraConversionTT = "Social developments from current scenario have [COLOR_NEGATIVE_TEXT]" .. gGdata.SocialChange .. "[ENDCOLOR]% base chance to be changed (which is doubled if you have not chosen the development). Older social developments will not be affected by era conversion.";  
	end
	Controls.SocialText1:SetText("[NEWLINE]Your Social Developments:[NEWLINE]")
	Controls.SocialButton1:SetSizeY(Controls.SocialText1:GetSizeY() + g_BasicTextYSizeChange)
	Controls.SocialButton1:SetToolTipString(grandEraConversionTT)

	for i, data in pairs(tPrepTab[cSelPlayer].SocialDevelopments) do
		local instance = g_SocialsText:GetInstance();
		local tt = data[4];
		if bAddChance and (data[1] == gGdata.ScenarioID) then
			if data[7] == 2 then
				tt = tt .. "[NEWLINE][NEWLINE][COLOR_NEGATIVE_TEXT]" .. gGdata.SocialChange .. "[ENDCOLOR]% to be replaced.";
			else
				tt = tt .. "[NEWLINE][NEWLINE][COLOR_NEGATIVE_TEXT]" .. (gGdata.SocialChange * 2) .. "[ENDCOLOR]% to be replaced.";
			end
			instance.TextMain:SetText("[COLOR_SELECTED_TEXT]" .. data[3]);
		else
			instance.TextMain:SetText(data[3]);
		end
		IconHookup( data[5], 64, data[6], instance.PolicyImage );
		instance.Root:SetToolTipString(tt)
		if i % 2 == 1 then
			instance.PolicyImage:SetOffsetX(-socImageOffsetX)
		else
			instance.PolicyImage:SetOffsetX(socImageOffsetX)
		end
	end

	Controls.MainGridSocials:SetHide(false)


	Controls.MainGridSocials:SetToolTipString(grandEraConversionTT)
	Controls.ListStackSocials:CalculateSize();
	Controls.ListStackSocials:ReprocessAnchoring();
	Controls.ScrollPanelSocials:CalculateInternalSize();
end

function StringSplit(inputstr, sep)
        if sep == nil then
                sep = "%s"
        end
        local t={}
        for str in string.gmatch(inputstr, "([^"..sep.."]+)") do
                table.insert(t, str)
        end
        return t
end

function PopulateInspData()
	local grandEraConversionTT = ""
	if #tPrepTab[cSelPlayer].Inspirations > 0 then
		Controls.InspText1:SetText("[NEWLINE]Your Inspirations:[NEWLINE]")
		Controls.MainGridInsp:SetHide(false);
	else
		Controls.MainGridInsp:SetHide(true);
		return;
	end
	if gGdata.NextScenarioID then
		grandEraConversionTT = "All Inspirations have 100% chance to be passed on era conversion."
		if not tPrepTab[cSelPlayer].HadInspFromCulture then
			grandEraConversionTT = grandEraConversionTT .. "[NEWLINE][NEWLINE]Since you have not obtained Inspiration with Cultural Bonus, you will obtain a random one upon conversion.";
		end
	end
	LuaEvents.ITG_RequestInspirationDB()
	local InspHelpTab = MapModData.ITGSG;
	MapModData.ITGSG = nil;
	g_Inspirations:ResetInstances();
	for a, b in pairs(tPrepTab[cSelPlayer].Inspirations) do
		local instance = g_Inspirations:GetInstance();
		local iClass = b[1];
		local iType = b[2];
		local buildingType = Players[cSelPlayer]:GetPlayerUniqueBuilding( iClass);
		if buildingType == -1 then
			buildingType = GameInfoTypes[GameInfo.BuildingClasses[iClass].DefaultBuilding]
		end
		IconHookup( GameInfo.Buildings[buildingType].PortraitIndex, 45, GameInfo.Buildings[buildingType].IconAtlas, instance.Icon1 );
		local buildingName = Locale.Lookup(GameInfo.Buildings[buildingType].Description)  .. " of " .. InspHelpTab[iType].Name;
		instance.Button:SetToolTipString(buildingName  .. " (" .. InspHelpTab[iType].Reward .. ")")
		instance.InspBuilding:SetText(buildingName)
		local sT = StringSplit(InspHelpTab[iType].Reward, " ");
		instance.InspHelp:SetText(sT[1] .. " " .. sT[2])
	end
	Controls.InspButton1:SetToolTipString(grandEraConversionTT)
	Controls.MainGridInsp:SetToolTipString(grandEraConversionTT)
	Controls.ListStackInsp:CalculateSize();
	Controls.ListStackInsp:ReprocessAnchoring();
	Controls.ScrollPanelInsp:CalculateInternalSize();
end

function PopulateWondersData()
	g_WondersText:ResetInstances();
	g_Wonders:ResetInstances();
	local tBasicText = {};
	local grandEraConversionTT = ""
	local certainText, certainTT = "", "";
	certainText = gGdata.NumWondersCertain .. " wonders were designed late and not built."
	local contestText, contestTT = "", "";
	contestText = gGdata.NumWondersContest .. " wonders constructed/designed."
	local ruinsText, ruinsTT = "", "";
	ruinsText = gGdata.NumWondersRuins .. " wonder ruins."
	if gGdata.NextScenarioID then
		certainTT = "Wonders that were designed in [COLOR_SELECTED_TEXT]" .. gGdata.WonderTCertain .. "[ENDCOLOR] turn or later and were not built are certain to appear in next scenario (in one of designer's cities).";
		grandEraConversionTT = PrepareTotalGridToolTip(grandEraConversionTT, certainTT)

		contestTT = "There will be approximately [COLOR_SELECTED_TEXT]" .. gGdata.NumWondersToAssign .. "[ENDCOLOR] initial wonders in next scenario."
		if gGdata.NumWondersCertain >= gGdata.NumWondersToAssign then
			contestTT = contestTT .. " This amount should be covered by wonders designed lately."
		end
		contestTT = contestTT .. " What is more, each City can start with only one Wonder. All remaining wonders will automatically become ruins.";
		grandEraConversionTT = PrepareTotalGridToolTip(grandEraConversionTT, contestTT)
		
		ruinsTT = "Ruins from previous scenario have [COLOR_SELECTED_TEXT]" .. gGdata.RuinsForgotten .. "%[ENDCOLOR] chance to become forgotten and not be passed. In addition, each City can start with only one Wonder Ruin. Some of forgotten Wonders still provide bonus for their constuctor."
		grandEraConversionTT = PrepareTotalGridToolTip(grandEraConversionTT, ruinsTT)
	end
	table.insert(tBasicText, {" ",""}) -- looks better
	table.insert(tBasicText, {certainText, certainTT})
	table.insert(tBasicText, {contestText, contestTT})
	table.insert(tBasicText, {ruinsText, ruinsTT})

	if #tPrepTab[cSelPlayer].WonderData > 0 then
		table.insert(tBasicText, {" ",""}) -- looks better
		table.insert(tBasicText, {"Your Wonders:", ""})
	end
	for i, v in pairs(tBasicText) do
		local instance = g_WondersText:GetInstance();
		instance.TextMain:SetText(v[1])
		instance.Root:SetToolTipString(v[2]);
		instance.Root:SetSizeY(instance.TextMain:GetSizeY() + g_BasicTextYSizeChange)
	end
	for i, data in pairs(tPrepTab[cSelPlayer].WonderData) do
		local instance = g_Wonders:GetInstance();
		instance.Icon1:SetColor({x = 1, y = 1, z = 1, w = 1})
		instance.Button:SetAlpha(1)
		instance.WonderName:SetText(Locale.Lookup(GameInfo.Buildings[data.Wonder].Description));
		IconHookup( GameInfo.Buildings[data.Wonder].PortraitIndex, 45, GameInfo.Buildings[data.Wonder].IconAtlas, instance.Icon1 );
		local toolTip = "";
		if data.Type == 1 then
			instance.WonderCity:SetText(data.City)
			instance.WonderStatus:SetText("Constructed")
			toolTip = data.Tooltip .. "[NEWLINE]" .. data.Ruin;
		elseif data.Type == 2 then
			instance.WonderCity:SetText("")
			instance.WonderCity:SetText(data.Turn .. "T")
			if gGdata.WonderTCertain <= data.Turn then
				instance.WonderStatus:SetText("[COLOR_POSITIVE_TEXT]Designed")
				toolTip = data.Tooltip .. "[NEWLINE][NEWLINE]Designed in " .. data.Turn .. " turn.[NEWLINE][NEWLINE]This wonder is [COLOR_POSITIVE_TEXT]certain[ENDCOLOR] to be assigned next scenario."
			else
				instance.WonderStatus:SetText("Designed")
				toolTip = data.Tooltip .. "[NEWLINE]" .. data.Ruin .. "[NEWLINE][NEWLINE]Designed in " .. data.Turn .. " turn.";
			end
		elseif data.Type == 3 then
			instance.Icon1:SetColor({x = 0.8, y = 0.8, z = 0.5, w = 1})
			instance.WonderCity:SetText(data.City)
			instance.WonderStatus:SetText("Ruins")
			toolTip = data.Ruin;
		elseif data.Type == 4 then
			instance.Button:SetAlpha(0.5)
			instance.WonderCity:SetText("")
			instance.WonderStatus:SetText("Forgotten")
			toolTip = data.Tooltip;
			instance.Icon1:SetColor({x = 0.8, y = 0.8, z = 0.5, w = 1})
		end
		instance.Button:SetToolTipString(toolTip)
	end

	Controls.MainGridWonders:SetToolTipString(grandEraConversionTT)
	Controls.ListStackWonders:CalculateSize();
	Controls.ListStackWonders:ReprocessAnchoring();
	Controls.ScrollPanelWonders:CalculateInternalSize();
end

function GetCivIdeoString(iPlayer, jplayer)
	if iPlayer == jplayer then
		return "[COLOR_POSITIVE_TEXT]you[ENDCOLOR]";
	else
		return "[COLOR_SELECTED_TEXT]" .. Players[jplayer]:GetCivilizationShortDescription() .. "[ENDCOLOR]";
	end
end

function PopulateIdeologiesData()
	g_IdeologyText:ResetInstances();
	g_HasMiniIdeologyIcons:ResetInstances();
	local tBasicText = {};
	local grandEraConversionTT = ""
	local specIdeoText, specIdeoTT = "", "";
	for letter, value in pairs(tPrepTab[cSelPlayer].Ideologies) do
		Controls["GovInfoLabel" .. letter]:SetText(value)
	end
	
	for h, v in pairs(tPrepTab[cSelPlayer].MinorIdeology) do
		local controlTable = g_HasMiniIdeologyIcons:GetInstance();
		controlTable.BoxImageID:SetHide(false)
		controlTable.IdeologyIcon:SetDisabled(true)
		controlTable.IdeologyImage:SetHide(false)
		controlTable.IdeologyImage:SetTexture("IdeologyITGSingleTaken.dds")
		CivIconHookup( cSelPlayer, 32, controlTable.Icon, controlTable.CivIconBG, controlTable.CivIconShadow, false, true); 
		
		local t = v[1] .. "[NEWLINE]----------------[NEWLINE]" .. v[3] .. ": 1[NEWLINE]----------------[NEWLINE]" .. v[2]
		controlTable.IdeologyIcon:SetToolTipString(t)
		controlTable.IdeologyIcon:SetOffsetVal(miniPositions[v[4]][1], miniPositions[v[4]][2])
		controlTable.IdeoFont1:SetText(v[3])
	end
	if gGdata.NextScenarioID then
		local boxMiniIdeoTT = "Small ideological tenets will not change for an entire game."
		grandEraConversionTT = PrepareTotalGridToolTip(grandEraConversionTT, boxMiniIdeoTT)
		Controls.BoxMiniIdeologies:SetToolTipString(boxMiniIdeoTT)

		if gGdata.NextScenarioID == 5 then
			specIdeoTT = "In next scenario world will be divided between " .. gGdata.NumIdeologies .. " ideologies. Civilizations will be chosen based on the most radical ideas and they most likely will be: "
			local hIndex = 1;
			for jplayer, v in pairs(gGdata.DevelopIdeo) do
				if hIndex == 1 then
					specIdeoTT = specIdeoTT .. GetCivIdeoString(cSelPlayer, jplayer)
				elseif hIndex == gGdata.NumIdeologies then
					specIdeoTT = specIdeoTT .. " and " .. GetCivIdeoString(cSelPlayer, jplayer) .. "."
				else
					specIdeoTT = specIdeoTT .. ", " .. GetCivIdeoString(cSelPlayer, jplayer)
				end
				hIndex = hIndex + 1;
			end
			specIdeoTT = specIdeoTT .. "[NEWLINE][NEWLINE]All other members will be distributed among those ideologies (based on similiraties yet keeping numerical balance in mind). They will loose their ideological tenets and will inherit those of host player." 
			if gGdata.DevelopIdeo[cSelPlayer] then
				specIdeoText = "You will most likely [COLOR_POSITIVE_TEXT]host[ENDCOLOR] an ideological league.";
				specIdeoTT = specIdeoTT .. "[NEWLINE][NEWLINE]You are most likely to keep [COLOR_POSITIVE_TEXT]your[ENDCOLOR] Ideological tenents.";
			else
				specIdeoText = "You will most likely join [COLOR_SELECTED_TEXT]" .. Players[gGdata.FollowIdeo[cSelPlayer]]:GetCivilizationAdjective() .. "[ENDCOLOR] ideological league.";
				specIdeoTT = specIdeoTT .. "[NEWLINE][NEWLINE]You are most likely to adopt [COLOR_SELECTED_TEXT]" .. Players[gGdata.FollowIdeo[cSelPlayer]]:GetCivilizationAdjective() .. "[ENDCOLOR] Ideological tenents.";
			end
			grandEraConversionTT = PrepareTotalGridToolTip(grandEraConversionTT, specIdeoTT)
		end
	end

	-- here major ideologies if any
	if #tPrepTab[cSelPlayer].IdeologyTenets > 0 then
		if specIdeoText ~= "" then
			table.insert(tBasicText, {specIdeoText, specIdeoTT})
			table.insert(tBasicText, {" ",""}) -- looks better
		end
		table.insert(tBasicText, {"Your Ideological Tenets:", specIdeoTT})
		for i, v in pairs(tPrepTab[cSelPlayer].IdeologyTenets) do
			table.insert(tBasicText, {v[1], v[2]})
		end
	end
	for i, v in pairs(tBasicText) do
		local instance = g_IdeologyText:GetInstance();
		instance.TextMain:SetText(v[1])
		instance.Root:SetToolTipString(v[2]);
		instance.Root:SetSizeY(instance.TextMain:GetSizeY() + g_BasicTextYSizeChange)
	end
	Controls.MainGridIdeologies:SetToolTipString(grandEraConversionTT)
	Controls.ListStackIdeologies:CalculateSize();
	Controls.ListStackIdeologies:ReprocessAnchoring();
	Controls.ScrollPanelIdeologies:CalculateInternalSize();
end

function PopulateGovermentData()
	g_GovermentText:ResetInstances();
	local grandEraConversionTT = ""
	local tBasicText = {}
	local govermentText, govermentTT = "", ""
	local principlesTT = "";
	local govName = Locale.Lookup(tPrepTab[cSelPlayer].GovName)
	local alrHaveSlots = {}
	for b, c in pairs(tPrepTab[cSelPlayer].Principles) do
		alrHaveSlots[c[3]] = true;
	end
	govermentText = "You have adopted " .. govName .. "."
	if gGdata.NextScenarioID then
		govermentTT = "You will start next scenario with " .. govName .. " (there is small chance though that you will have to centralize power first).";
		grandEraConversionTT = PrepareTotalGridToolTip(grandEraConversionTT, govermentTT)
		principlesTT = "All your current principles will be reassigned back to if possible (ex. Codex principle requires you to start with a Codex).[NEWLINE][NEWLINE]In addition you will have a chance to fill following principles' slots:"
		for b, c in pairs(gGdata.NextPrinciples) do
			if alrHaveSlots[c[1]] then
				principlesTT = principlesTT .. "[NEWLINE][ICON_BULLET][COLOR_GREY]" .. c[2] .. "[ENDCOLOR]";
			else
				principlesTT = principlesTT .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_KEY]" .. c[2] .. "[ENDCOLOR]";
			end
		end
		grandEraConversionTT = PrepareTotalGridToolTip(grandEraConversionTT, principlesTT)
	end
	
	table.insert(tBasicText, {" ",""}) -- looks better
	table.insert(tBasicText, {govermentText,govermentTT})
	if #tPrepTab[cSelPlayer].Principles > 0 then
		table.insert(tBasicText, {" ",""}) -- looks better
		table.insert(tBasicText, {"Your Principles:",principlesTT})
		for b, c in pairs(tPrepTab[cSelPlayer].Principles) do
			table.insert(tBasicText, {c[1], Locale.Lookup(c[2])})
		end
	end
	for i, v in pairs(tBasicText) do
		local instance = g_GovermentText:GetInstance();
		instance.TextMain:SetText(v[1])
		instance.Root:SetToolTipString(v[2]);
		instance.Root:SetSizeY(instance.TextMain:GetSizeY() + g_BasicTextYSizeChange)
	end
	Controls.MainGridGoverment:SetToolTipString(grandEraConversionTT)
	Controls.ListStackGoverment:CalculateSize();
	Controls.ListStackGoverment:ReprocessAnchoring();
	Controls.ScrollPanelGoverment:CalculateInternalSize();
end

function DoUpdateCivInfoData()
	if not cSelPlayer then
		PrepareTopPanelStuff()
	end
	if not gGdata then
		LuaEvents.ITGSG_LH_GlobalCivInfoRequest()
		gGdata = MapModData.ITGSG;
		MapModData.ITGSG = nil;
	end
	if not tPrepTab[cSelPlayer] then
		LuaEvents.ITGSG_LH_CivInfoRequest(cSelPlayer)
		tPrepTab[cSelPlayer] = MapModData.ITGSG;
		MapModData.ITGSG = nil;
	end
	PopulateLawsData()
	PopulateSocialDevsData()
	PopulateWondersData()
	PopulateIdeologiesData()
	PopulateGovermentData()
	PopulateInspData()
	
	Controls.MainInfoStack:CalculateSize();
	Controls.MainInfoStack:ReprocessAnchoring();
	Controls.MainScrollPanel:CalculateInternalSize();
end

function OnTopPanelClicked(i)
	if cSelPlayer ~= i then
		if pTinstances[cSelPlayer] then
			pTinstances[cSelPlayer].Button:SetAlpha(0.6);
			pTinstances[cSelPlayer].ImageFrame:SetHide(true);
		end
		pTinstances[i].Button:SetAlpha(1);
		pTinstances[i].ImageFrame:SetHide(false);

		cSelPlayer = i;
		DoUpdateCivInfoData()
	end
end

function PrepareTopPanelStuff()
	LuaEvents.ITGSG_RequestGT()
	local gData = MapModData.ITGSG;
	MapModData.ITGSG = nil;
	cSelPlayer = Game.GetActivePlayer();
	if not gData.Players[cSelPlayer] then
		cSelPlayer = nil;
	end
	local bIsAIGame = (PreGame.GetGameOption("GAMEOPTION_ITG_AI_GAME") == 1)
	g_TopPanelSelection:ResetInstances()
	for i, v in pairs(Players) do
		if gData.Players[i] and (not v:IsMinorCiv()) then
			if (bIsAIGame) or v:IsHuman() then
				local controlTable = g_TopPanelSelection:GetInstance();
				IconHookup( 62, 32, "ABILITY_ATLAS", controlTable.ImageFrame );
				CivIconHookup( i, 32, controlTable.CivIcon, controlTable.CivIconBG, controlTable.CivIconShadow, false, true );
				pTinstances[i] = controlTable;
				controlTable.Button:SetVoid1(i)
				controlTable.Button:RegisterCallback( Mouse.eLClick, OnTopPanelClicked );
				if not cSelPlayer then
					cSelPlayer = i;
				end
				if cSelPlayer == i then
					controlTable.Button:SetAlpha(1);
					controlTable.ImageFrame:SetHide(false)
				else
					controlTable.Button:SetAlpha(0.6);
					controlTable.ImageFrame:SetHide(true)
				end
			end
		end
	end
	
	Controls.TopPanelInfoStack:CalculateSize();
	Controls.TopPanelInfoStack:ReprocessAnchoring();
	Controls.TopPanelScrollPanel:CalculateInternalSize();
	
	local screenSizeX, screenSizeY = UIManager:GetScreenSizeVal();
	Controls.MainScrollPanel:SetOffsetY(30 + math.floor((screenSizeY - 30 - 700 - 50) / 2))
end

function PrepareCivInfoForCurrentEra(gType)
	tPrepTab = {};
	gGdata = nil;
end
LuaEvents.ITGLHInitAll.Add(PrepareCivInfoForCurrentEra)

function ShowHideHandler( bIsHide, bInitState )
    if( not bIsHide ) then
    	DoUpdateCivInfoData();
	end
end
ContextPtr:SetShowHideHandler( ShowHideHandler );
