include( "InstanceManager" );
include( "IconSupport" ); 
include( "FLuaVector" );

local g_InfosManager = GenerationalInstanceManager:new( "GlobalInfosInstance", "Base", Controls.GlobalInfosStack);
local g_PianoKeys = {
	[0] = {19/255,32/255,46/255,120/255},
	[1] = {12/255,22/255,30/255,120/255},
}

local tabGlobalInfos = {
--{ID = 1, Name = "Date"},
{ID = 2, Name = "[ICON_CITIZEN] Population"},
{ID = 3, Name = "Forests"},
{ID = 4, Name = "Jungles"},
{ID = 5, Name = "Marshes"},
{ID = 6, Name = "Improvements"},
{ID = 7, Name = "[ICON_FOOD] Food"},
{ID = 8, Name = "[ICON_PRODUCTION] Production"},
{ID = 9, Name = "[ICON_GREAT_PEOPLE] Great People"},
{ID = 10, Name = "[ICON_GREAT_ENGINEER] Wonders"},
{ID = 11, Name = "[ICON_GREAT_WORK] Great Works"},
{ID = 12, Name = "[ICON_ITG_HEALTH_1] Health"},
}

LuaEvents.ITG_ClearInstancesEndEra.Add(function()
	g_InfosManager:ResetInstances();
end)


function DoUpdateGlobals()
--nothing to do?
end

LuaEvents.ITGLHInitAll.Add(function()
	local screenSizeX, screenSizeY = UIManager:GetScreenSizeVal()
	Controls.GlobalInfosScrollPanel:SetOffsetY(math.max(50, math.floor((screenSizeY - Controls.GlobalInfosScrollPanel:GetSizeY()) / 2)));
	Controls.DateBox:SetOffsetY(Controls.GlobalInfosScrollPanel:GetSizeY() + Controls.GlobalInfosScrollPanel:GetOffsetY() + 3)

	LuaEvents.ITGSG_RequestGT();
	local cdata = MapModData.ITGSG.GlobalInfos;
	MapModData.ITGSG = nil;
	g_InfosManager:ResetInstances();

	Controls.DateBox:SetColorVal(unpack(false and g_PianoKeys[0] or g_PianoKeys[1]));
	Controls.TypeName:SetText("Date")
	for j = 1, 10 do
		if cdata[j] then
			Controls["Info" .. j]:SetText(cdata[j][1])
		else
			Controls["Info" .. j]:SetText("")
		end
	end

	local bTickTock = true;
	for i,v in pairs(tabGlobalInfos) do
		local instance = g_InfosManager:GetInstance();
		instance.Base:SetColorVal(unpack(bTickTock and g_PianoKeys[0] or g_PianoKeys[1]));
		instance.TypeName:SetText(v.Name)
		for j = 1, 10 do
			if cdata[j] then
				instance["Info" .. j]:SetText(cdata[j][v.ID])
			else
				instance["Info" .. j]:SetText("")
			end
		end
		bTickTock = not bTickTock;
	end

	Controls.GlobalInfosStack:CalculateSize();
	Controls.GlobalInfosStack:ReprocessAnchoring();
	Controls.GlobalInfosScrollPanel:CalculateInternalSize();
end)

function ShowHideHandler( bIsHide, bInitState )
    if( not bIsHide ) then
    	DoUpdateGlobals();
	else
	end
end
ContextPtr:SetShowHideHandler( ShowHideHandler );
