include( "InstanceManager" );
include( "IconSupport" ); 
include( "ITGSG_HelpFunctions.lua" );

local currentIDs = {3,1,2}
local aMadeT = {}
local maxshowCities = 20;
local gCaNodes = {}
local cSel = {}
local rData = {}
local gGTdata;
local gTopInstances;
local g_PlayerListInstanceManager = {}
g_PlayerListInstanceManager[1] = InstanceManager:new( "PlayerEntryInstance", "PlayerEntryBox", Controls.PlayerListStack1 );
g_PlayerListInstanceManager[2] = InstanceManager:new( "PlayerEntryInstance", "PlayerEntryBox", Controls.PlayerListStack2 );
g_PlayerListInstanceManager[3] = InstanceManager:new( "PlayerEntryInstance", "PlayerEntryBox", Controls.PlayerListStack3 );
local g_TopPanelSelection = InstanceManager:new( "TopPanelInstance", "Box", Controls.TopPanelInfoStack );

LuaEvents.ITG_ClearInstancesEndEra.Add(function()
	gTopInstances = nil;
	g_TopPanelSelection:ResetInstances();
	g_PlayerListInstanceManager[1]:ResetInstances();
	g_PlayerListInstanceManager[2]:ResetInstances();
	g_PlayerListInstanceManager[3]:ResetInstances();
end)

function ListDataFunc1()
	--Great Works
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			table.insert(hTab, {g, gd.NumGreatWorks})
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2] .. " [ICON_GREAT_WORK]", "Number of Great Works of Art created."})
	end
end
function ListDataFunc2()
	--Goody Huts
	local hTab = {}
	local total = 0;
	for a, b in pairs(gGTdata.Globals.AncientRuins) do
		total = total + 1;
	end
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			local notvisited = 0;
			local lTurn = gd.LastAncientRuinT;
			local visitedafter = gd.NumAncientRuins;
			local gTeam = Players[g]:GetTeam();
			for index, ruinsdata in pairs(gGTdata.Globals.AncientRuins) do
				if not Map.GetPlotByIndex(index):AlreadyVisitedGoodyHut(gTeam) then
					notvisited= notvisited + 1;
				end
			end
			table.insert(hTab, {g, visitedafter, notvisited, total, lTurn})
		end
	end
	table.sort(hTab, SortFunctionForLowestInteger5)
	for i, data in pairs(hTab) do
		if 0 == data[3] then
			table.insert(rData, {data[1], data[5] .. "T", "Visited every ancient ruin on map by turn " .. data[5] .. ".[NEWLINE]Visited " .. data[2] .. " Ancient Ruins.[NEWLINE][NEWLINE]Total number of Ancient Ruins: " .. data[4] .. "."})
		end
	end
	table.sort(hTab, SortFunctionGreatest2Greatest3)
	for i, data in pairs(hTab) do
		if 0 ~= data[3] then
			table.insert(rData, {data[1], data[2].. " (" .. data[3] .. ")[ICON_RES_ARTIFACTS]", "Number of Ancient Ruins visited (not visited).[NEWLINE][NEWLINE]Total number of Ancient Ruins: " .. data[4] .. "."})
		end
	end
end
function ListDataFunc3()
	--Science
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			table.insert(hTab, {g, gd.Science - gd.ScienceStart + gd.ScienceLost})
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], math.floor(data[2]).. " [ICON_RESEARCH]", "Amount of [ICON_RESEARCH] Science generated through entire game."})
	end
end
function ListDataFunc4()
	--Culture
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			table.insert(hTab, {g, gd.Culture - gd.CultureStart + gd.CultureLost})
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2].. " [ICON_CULTURE]", "Amount of [ICON_CULTURE] Culture generated through entire game."})
	end
end
function ListDataFunc5()
	--Faith
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			table.insert(hTab, {g, Players[g]:GetFaith() - gd.FaithStart + gd.FaithLost})
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2].. " [ICON_PEACE]", "Amount of [ICON_PEACE] Faith generated through entire game."})
	end
end
function ListDataFunc6()
	--generals
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			table.insert(hTab, {g, Players[g]:GetCombatExperience() - gd.GeneralCombatStart + gd.GeneralCombatLost})
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2].. " [ICON_GREAT_GENERAL]", "Amount of [ICON_GREAT_GENERAL] General points earned through entire game."})
	end
end
function ListDataFunc7()
	--generals
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			table.insert(hTab, {g, Players[g]:GetNavalCombatExperience() - gd.AdmiralCombatStart + gd.AdmiralCombatLost})
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2].. " [ICON_GREAT_ADMIRAL]", "Amount of [ICON_GREAT_ADMIRAL] Admiral points earned through entire game."})
	end
end
function ListDataFunc8()
	-- conquerors
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			table.insert(hTab, {g, gd.UniqueNumConquered, gd.NumConquered })
		end
	end
	table.sort(hTab, SortFunctionGreatest2Greatest3)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2] .. " (" .. data[3] .. ")", "Amount of cities conquered by the player through entire game (counting multiple conquering of same city)."})
	end
end
function ListDataFunc9()
	-- followers
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			local iRel = Players[g]:GetReligionCreatedByPlayer();
			if iRel > 0 then
				local numcities, numfollowers = 0, 0;
				for h,hv in pairs(gGTdata.Players) do
					for iCity in Players[h]:Cities() do
						numfollowers = numfollowers + iCity:GetNumFollowers(iRel);
						if iCity:GetReligiousMajority() == iRel then
							numcities = numcities + 1;
						end
					end
				end
				table.insert(hTab, {g, numfollowers, numcities, iRel })
			end
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2] .. "[ICON_CITIZEN] (" .. data[3] .. ") " .. GameInfo.Religions[data[4]].IconString, "Number of population (cities) following " .. GameInfo.Religions[data[4]].IconString .. " " .. Locale.Lookup(Game.GetReligionName(data[4])) .. "."})
	end
end
function ListDataFunc10()
	-- wonders
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			if gd.NumWondersBuild > 0 then
				table.insert(hTab, {g, gd.NumWondersBuild })
			end
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2], "Amount of wonders build by a Player."})
	end
end
function ListDataFunc11()
	-- territory discovered;
	local hTab = {}
	local numplots =  Map:GetNumPlots()
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			local numdis = 0;
			local iTeam = Players[g]:GetTeam();
			for i = 0, Map:GetNumPlots() - 1, 1 do
				local fPlot = Map.GetPlotByIndex( i );
				if fPlot:IsRevealed(iTeam) then
					numdis = numdis + 1;
				end
			end
			table.insert(hTab, {g, numdis})
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2] .. " (" .. math.floor((data[2]/numplots * 200))/ 2 .. "%)", "Amount of territory discovered."})
	end
end
function ListDataFunc12()
	-- cities that welcomed most trade routes
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		for iCity in Players[g]:Cities() do
			local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
			if #gGTdata.Cities[cID].TradeRoutesCompleted > 0 then
				table.insert(hTab, {iCity, #gGTdata.Cities[cID].TradeRoutesCompleted, gGTdata.Cities[cID].LHTradeAppeal})
			end
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		if i <= maxshowCities then
			table.insert(rData, {data[1], data[2] .." (" .. data[3] .. "[ICON_TRADE_WHITE])", "Number of Trade Routes that arrived at city (base [ICON_TRADE_WHITE] Trade Appeal)."})
		end
	end
end
function ListDataFunc13()
	-- gold from trade routes
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			table.insert(hTab, {g, gd.GoldFromTradeRoutes, gd.LHScienceTR, gd.LHCultureTR, gd.LHFoodTR, gd.LHProdTR})
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2] .. "[ICON_GOLD]", "Total Gold earned from Trade Routes (also " .. data[3] .. " [ICON_RESEARCH] Science, " .. data[5] .. " [ICON_FOOD] Food, " .. data[6] .. " [ICON_PRODUCTION] Production and " .. data[4] .. " [ICON_CULTURE] Culture)."})
	end
end
function ListDataFunc14()
	-- kill death ratio
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			table.insert(hTab, {g, math.floor(gd.UnitKilled/ (math.max(0.1, gd.UnitLost)) * 1000), gd.UnitKilled, gd.UnitLost})
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[3] .. "/" .. data[4], "Unit kills/deaths."})
	end
end
function ListDataFunc15()
	--work rate spent
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			table.insert(hTab, {g, gd.WorkRateSpent})
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2] .. "[ICON_WORKER]", "Total amount of Work Rate spent."})
	end
end
function ListDataFunc16()
--spy activity
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			local str = "List of each notable spy activity:"
			local rhTab = {}
			if #gd.SpyActionsBig == 0 then
				str = "None notable spy activity detected.";
			else
				for it, string in pairs(gd.SpyActionsBig) do
					rhTab[string] = (rhTab[string] or 0) + 1;
				end
				for string, num in pairs(rhTab) do
					str = str .. "[NEWLINE][ICON_BULLET]" .. string .. ": [COLOR_POSITIVE_TEXT]" .. num .. "[ENDCOLOR].";
				end
			end
			if gd.NumSpyBought > 0 then
				str = str .. "[NEWLINE][ICON_BULLET]Hired new agents: [COLOR_POSITIVE_TEXT]" .. gd.NumSpyBought .. "[ENDCOLOR].";
			end 
			table.insert(hTab, {g, #gd.SpyActionsBig + gd.NumSpyBought , str})
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2], data[3]})
	end
end
function ListDataFunc17()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		for iCity in Players[g]:Cities() do
			local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
			table.insert(hTab, {iCity, gGTdata.Cities[cID].HighestPop, gGTdata.Cities[cID].HighestPopFood})
		end
	end
	table.sort(hTab, SortFunctionGreatest2Greatest3)
	for i, data in pairs(hTab) do
		if i <= maxshowCities then
			table.insert(rData, {data[1], data[2] .." [ICON_CITIZEN]/" .. data[3] .. "[ICON_FOOD]", "The largest [ICON_CITIZEN] Population ever achieved by this City."})
		end
	end
end
function ListDataFunc18()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		for iCity in Players[g]:Cities() do
			local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
			table.insert(hTab, {iCity, gGTdata.Cities[cID].HighestPop - gGTdata.Cities[cID].StartingPop, gGTdata.Cities[cID].HighestPopFood - gGTdata.Cities[cID].StartingPopFood, gGTdata.Cities[cID].StartingPop, gGTdata.Cities[cID].StartingPopFood})
		end
	end
	table.sort(hTab, SortFunctionGreatest2Greatest3)
	for i, data in pairs(hTab) do
		if i <= maxshowCities then
			table.insert(rData, {data[1], "+" .. data[2] .." [ICON_CITIZEN]/" .. data[3] .. "[ICON_FOOD]", "The largest [ICON_CITIZEN] Population difference between the starting population and the highest one.[NEWLINE][NEWLINE]Starting Population: " .. data[4] .. "[ICON_CITIZEN], " .. data[5] .. "[ICON_FOOD]."})
		end
	end
end
function ListDataFunc19()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			table.insert(hTab, {g, gd.SpendLegalPower})
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2] .. "[ICON_ITG_LEGAL_POWER]", "Total amount of Legal Power spent."})
	end
end
function ListDataFunc20()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			table.insert(hTab, {g, gd.CityStateAlly, gd.CityStateFriends, gd.MaxCityStateAlly, math.max(1,gd.TurnDataCollected)})
		end
	end
	table.sort(hTab, SortFunctionGreatest2Greatest3)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], math.floor(data[2]/data[5]*100)/100 .. " (" .. math.floor(data[3]/data[5]*100)/100 ..")" , "The amount of average allied (friendly) city states per turn. The highest amount of allied city-states: " .. data[4] .. "."})
	end
end
function ListDataFunc21()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			local max, tot, div = 0, 0, 0;
			for c, d in pairs(Players[g]:GetGraphData(15)) do
				div = div + 1;
				tot = tot + d;
				max = math.max(max, d)
			end
			if div > 0 then
				table.insert(hTab, {g, math.floor(tot * 100 / div) / 100, max})
			end
		end
	end
	table.sort(hTab, SortFunctionGreatest2Greatest3)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2] .. " (" .. data[3] .. ")[ICON_ITG_NAT_UNITY]", "The average (greatest) National Unity of civilization."})
	end
end
function ListDataFunc22()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			local total, tooltip = 0, "Amount of civilian units killed:"
			for t, am in pairs(gd.KilledCivilians) do
				total = total + am;
				if am > 1 then
					tooltip = tooltip .. "[NEWLINE][ICON_BULLET]" .. am .. " " .. t .. "s."
				else
					tooltip = tooltip .. "[NEWLINE][ICON_BULLET]" .. am .. " " .. t .. "."
				end
			end
			if total == 0 then
				tooltip = "Amount of civilian units killed."
			end
			table.insert(hTab, {g, total, tooltip})
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2], data[3]})
	end
end
function ListDataFunc23()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			table.insert(hTab, {g, gd.TotalGoldSpendInternally})
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2] .. "[ICON_GOLD]", "The amount of [ICON_GOLD] Gold spent internally."})
	end
end
function ListDataFunc24()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			local total, max, am = 0, 0, 0;
			for c, d in pairs(Players[g]:GetGraphData(13)) do
				if d ~= 0 then
					total = total + d;
					am = am + 1;
					max = math.max(max, d);
				end
			end
			if am > 0 then
				total = total / am;
				table.insert(hTab, {g, total, max}) 
			end
		end
	end
	table.sort(hTab, SortFunctionGreatest2Greatest3)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], math.floor(data[2]*100)/100 .. " (" .. data[3] .. ")%[ICON_INVEST]", "The average (best) amount of Currency bonus"})
	end
end
function ListDataFunc25()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			local iRel = Players[g]:GetReligionCreatedByPlayer();
			if iRel > 0 then
				if (gGTdata.ReligionsEE[iRel].BestReligiousPressure or 0) > 0 then
					table.insert(hTab, {g, gGTdata.ReligionsEE[iRel].BestReligiousPressure - gGTdata.ReligionsEE[iRel].StartReligiousPressure, gGTdata.ReligionsEE[iRel].BestReligiousPressure})
				end
			end
		end
	end
	table.sort(hTab, SortFunctionGreatest2Greatest3)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2]/10 .. " (" .. data[3]/10 .. ") " .. GameInfo.Religions[Players[data[1]]:GetReligionCreatedByPlayer()].IconString, "The difference between the greatest value of global Religious Pressure and the initial one. (the greatest value recorded)"})
	end
		
end
function ListDataFunc26()
	--territory expansion
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			table.insert(hTab, {g, gd.TotalBestLand - gd.TotalStartLand, gd.TotalBestLand})
		end
	end
	table.sort(hTab, SortFunctionGreatest2Greatest3)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2] .. " (" .. data[3] .. ")", "The difference between territory at start and greatest recorded. (the greatest value recorded)"})
	end
end
function ListDataFunc27()
	--most skilled classes
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			for iclass, xp in pairs(gd.UnitClassXP) do
				local unittype = Players[g]:GetPlayerUniqueUnit(iclass);
				if unittype ~= -1 then
					table.insert(hTab, {g, xp, unittype})
				end
			end
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		if i <= maxshowCities then
			table.insert(rData, {data[1], data[2] .. " XP[NEWLINE] (" .. Locale.Lookup(GameInfo.Units[data[3]].Description) .. ")", "Total XP of this unitclass of Player."})
		else
			break;
		end
	end
end
function ListDataFunc28()
	-- most riots per city
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		for iCity in Players[g]:Cities() do
			local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
			table.insert(hTab, {iCity, gGTdata.Cities[cID].RiotsEnter, gGTdata.Cities[cID].RiotsBuildingDestroyed})
		end
	end
	table.sort(hTab, SortFunctionGreatest2Greatest3)
	for i, data in pairs(hTab) do
		if i <= maxshowCities then
			table.insert(rData, {data[1], data[2] .. " (" .. data[3] .. ")", "Number of times city entered riots. (buildings destroyed during riots)"})
		end
	end
end
function ListDataFunc29()
	--technologies
	local cTab = {}
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			local total = GetRealNumTechsKnown(Players[g]:GetTeam());
			local disc = total - gd.StartTechKnown - gd.BackwardTechHelp;
			if gd.TechTreeCompleted then
				table.insert(cTab, {g, disc, total, gd.TechTreeCompleted, gd.StartTechKnown, gd.BackwardTechHelp})
			else
				table.insert(hTab, {g, disc, total, -1, gd.StartTechKnown, gd.BackwardTechHelp})
			end
		end
	end
	table.sort(cTab, SortFunctionForLowestInteger4)
	for i, data in pairs(cTab) do
		table.insert(rData, {data[1], data[4] .. "T", "Discovered all " .. data[3] .. " technologies by turn " .. data[4] .. ".[NEWLINE][NEWLINE]Number of technology known at start: " .. data[5] .. ".[NEWLINE][NEWLINE]Technologies from Step Forward: [COLOR_NEGATIVE_TEXT]" .. data[6] .. "[ENDCOLOR]."})
	end
	table.sort(hTab, SortFunctionGreatest2Greatest3)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2] .. " (" .. data[3] .. ")[ICON_RESEARCH]", "Number of technology discovered (total known).[NEWLINE][NEWLINE]Technologies from Step Forward: [COLOR_NEGATIVE_TEXT]" .. data[6] .. "[ENDCOLOR]."})
	end
end
function ListDataFunc30()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		for iCity in Players[g]:Cities() do
			local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
			table.insert(hTab, {iCity, gGTdata.Cities[cID].FishFoodTotal})
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		if i <= maxshowCities and (data[2] >0) then
			table.insert(rData, {data[1], data[2] .. "[ICON_FOOD]", "Amount of Food gained from migrating Sea Resources."})
		else
			break;
		end
	end
end
function ListDataFunc31()
	--luxury owned
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			if gd.AverageLuxuryTurnCounted > 0 then
				table.insert(hTab, {g, math.floor(0.5 + 100 * gd.AverageLuxuryCount / gd.AverageLuxuryTurnCounted )/100, gd.GreatestNumLuxuryOwned})
			end
		end
	end
	table.sort(hTab, SortFunctionGreatest2Greatest3)
--		table.sort(hTab, SortFunctionForGreaterInteger3)
--		table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2] .. "[ICON_RES_MARBLE] (" .. data[3] .. ")", "Average amount of luxuries owned. (the greatest value)"})
	end
end
function ListDataFunc32()
	--happiness average
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			if gd.AverageHappinessCounted > 0 then
				table.insert(hTab, {g, math.floor(0.5 + 100 * gd.LHAverageHappiness / gd.AverageHappinessCounted )/100, gd.GreatestHappiness})
			end
		end
	end
	table.sort(hTab, SortFunctionGreatest2Greatest3)
--		table.sort(hTab, SortFunctionForGreaterInteger3)
--		table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		local hapstring = "[ICON_HAPPINESS_1]";
		if data[2] < 0 then
			hapstring = "[ICON_HAPPINESS_4]";
		end
		table.insert(rData, {data[1], data[2] .. hapstring .. " (" .. data[3] .. ")", "Average Happiness of the empire. (the greatest value)"})
	end
end
function ListDataFunc33()
	--natural wonders
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			local lastturn, total, start = 0, 0, 0;
			for i, index in pairs(gGTdata.Globals.DiscoveredNaturalWonders) do
				if Map.GetPlotByIndex(index):IsRevealed(Players[g]:GetTeam()) then
					total = total + 1;
					if gd.DiscoveredNaturalWonders[index] then
						if gd.DiscoveredNaturalWonders[index] > lastturn then
							lastturn = gd.DiscoveredNaturalWonders[index];
						end
					else
						start = start + 1;
					end
				end
			end
			table.insert(hTab, {g, total, start, #gGTdata.Globals.DiscoveredNaturalWonders, lastturn})
		end
	end
	table.sort(hTab, SortFunctionForLowestInteger5)
	for i, data in pairs(hTab) do
		if data[2] == data[4] then
			table.insert(rData, {data[1], data[5] .."T", "Discovered all (" .. data[4] .. ") Natural Wonders by turn " .. data[5] .. ".[NEWLINE][NEWLINE]Natural Wonders known from start: " .. data[3] .. "."})
		end
	end
	table.sort(hTab, SortFunctionGreatest2Lowest3)
--		table.sort(hTab, SortFunctionForLowestInteger3)
--		table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		if data[2] ~= data[4] then
			table.insert(rData, {data[1], data[2] .." (" .. data[3] .. ")", "Number of discovered Natural Wonders (known at start).[NEWLINE][NEWLINE]Total number of Natural Wonders: ".. data[4] .. "."})
		end
	end
end
function ListDataFunc34()
	--fort  owned
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			if gd.AverageLuxuryTurnCounted > 0 then
				table.insert(hTab, {g, math.floor(0.5 + 100 * gd.AverageFortCount / gd.AverageTurnCounted )/100, gd.GreatestNumFortOwned})
			end
		end
	end
	table.sort(hTab, SortFunctionGreatest2Greatest3)
--		table.sort(hTab, SortFunctionForGreaterInteger3)
--		table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2] .. "[ICON_STRENGTH] (" .. data[3] .. ")", "Average amount of Forts controlled. (the greatest value)"})
	end
end
function ListDataFunc35()
	--colonies  owned
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			if gd.AverageLuxuryTurnCounted > 0 then
				table.insert(hTab, {g, math.floor(0.5 + 100 * gd.AverageColoniesCount / gd.AverageTurnCounted )/100, gd.GreatestNumColoniesOwned})
			end
		end
	end
	table.sort(hTab, SortFunctionGreatest2Greatest3)
--		table.sort(hTab, SortFunctionForGreaterInteger3)
--		table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2] .. "[ICON_GREAT_MERCHANT] (" .. data[3] .. ")", "Average amount of Colonies controlled. (the greatest value)"})
	end
end
function ListDataFunc36()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			if gd.LengthGoldenAge > 0 then
				table.insert(hTab, {g,  gd.LengthGoldenAge})
			end
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2] .. "[ICON_GOLDEN_AGE]", "Length of Golden Age."})
	end	
end
function ListDataFunc37()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			table.insert(hTab, {g,  gd.NumWonCityQuests})
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2] .. "[ICON_CITY_STATE]", "Amount of victories in City-States' politics."})
	end	
end
function ListDataFunc38()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		for iCity in Players[g]:Cities() do
			local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
			if gGTdata.Cities[cID].TotalDamage > 0 then
				table.insert(hTab, {iCity, gGTdata.Cities[cID].TotalDamage, gGTdata.Cities[cID].NumConquered or 0, gGTdata.Cities[cID].NumRaided or 0})
			end
		end
	end
	table.sort(hTab, SortFunctionGreatest2Lowest3)
	for i, data in pairs(hTab) do
		if i <= maxshowCities then
			if data[4] > 0 then
				table.insert(rData, {data[1], data[2] .. "[ICON_RAZING] (" .. data[3] .. ")", "Amount of damage taken by a City (times of ownership change).[NEWLINE][NEWLINE]City was plundered [COLOR_NEGATIVE_TEXT]" .. data[4] .. "[ENDCOLOR] time(s)."})
			else
				table.insert(rData, {data[1], data[2] .. "[ICON_RAZING] (" .. data[3] .. ")", "Amount of damage taken by a City (times of ownership change)."})
			end
		else
			break;
		end
	end
end
function ListDataFunc39()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		for iCity in Players[g]:Cities() do
			local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
			table.insert(hTab, {iCity, gGTdata.Cities[cID].NumAttackesEverMade})
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		if i <= maxshowCities then
			table.insert(rData, {data[1], data[2] .. "[ICON_RANGE_STRENGTH]", "Amount of ranged strikes performed by a City."})
		else
			break;
		end
	end
end
function ListDataFunc40()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			table.insert(hTab, {g, gd.GPPointsEarned, gd.GPCivilGenerated})
		end
	end
	table.sort(hTab, SortFunctionGreatest2Greatest3)
--		table.sort(hTab, SortFunctionForGreaterInteger3)
--		table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], math.floor(data[2]) .. "[ICON_GREAT_PEOPLE] (" .. data[3] .. ")", "Amount of Great People points generated (Great People acquired)."})
	end	
end
function ListDataFunc41()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			table.insert(hTab, {g, gd.GPMigratedTo - gd.GPMigratedAway, gd.GPMigratedTo, gd.GPMigratedAway})
		end
	end
	table.sort(hTab, SortFunctionGreatest2Greatest3)
--		table.sort(hTab, SortFunctionForGreaterInteger3)
--		table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], "[COLOR_POSITIVE_TEXT]+" .. data[3] .. "[ENDCOLOR]|[COLOR_NEGATIVE_TEXT]-" .. data[4] .. "[ICON_GREAT_PEOPLE]", "Amount of Great People who migrated to/from this civilization."})
	end
end
function ListDataFunc42()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			if gd.NumUnitsUpdated > 0 then
				table.insert(hTab, {g, gd.NumUnitsUpdated})
			end
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2] .. "[ICON_IDEOLOGY_AUTOCRACY]", "Amount of units upgraded."})
	end
end
function ListDataFunc43()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			table.insert(hTab, {g, math.floor(gd.MeleeCombatsP/ (math.max(0.1, gd.RangedCombatP)) * 1000), gd.MeleeCombatsP, gd.RangedCombatP})
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[3] .. "/" .. data[4], "Attacks in melee/ranged ratio."})
	end
end
function ListDataFunc44()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			if gd.AverageLuxuryTurnCounted > 0 then
				table.insert(hTab, {g, math.floor(0.5 + 100 * gd.AverageMorale / gd.AverageTurnCounted )/100, gd.GreatestMoraleEver})
			end
		end
	end
	table.sort(hTab, SortFunctionGreatest2Greatest3)
--		table.sort(hTab, SortFunctionForGreaterInteger3)
--		table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2] .. "%[ICON_ITG_MORALE] (" .. data[3] .. ")", "Average amount of troops Morale. (the greatest value)"})
	end
end
function ListDataFunc45()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			local pmString = "Wars declared by this civilization:"
			for jtt, hpdata in pairs(gd.NumWarsDeclared) do
				pmString = pmString .. "[NEWLINE][ICON_BULLET]Against [COLOR_POSITIVE_TEXT]" .. Players[hpdata[1]]:GetCivilizationShortDescription() .. "[ENDCOLOR] on turn " .. hpdata[2];
			end
			pmString = pmString .. "[NEWLINE][NEWLINE]Wars declared on this civilization:"
			for jtt, hpdata in pairs(gd.NumWarsDeclaredOn) do
				pmString = pmString .. "[NEWLINE][ICON_BULLET]By [COLOR_NEGATIVE_TEXT]" .. Players[hpdata[1]]:GetCivilizationShortDescription() .. "[ENDCOLOR] on turn " .. hpdata[2];
			end
			table.insert(hTab, {g, math.floor(#gd.NumWarsDeclared/ (math.max(0.1, #gd.NumWarsDeclaredOn)) * 1000), #gd.NumWarsDeclared, #gd.NumWarsDeclaredOn, pmString})
		end
	end
	table.sort(hTab, SortFunctionGreatest2Greatest3Lowest4)
--		table.sort(hTab, SortFunctionForLowestInteger4)
--		table.sort(hTab, SortFunctionForGreaterInteger3)
--		table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], "[COLOR_POSITIVE_TEXT]" .. data[3] .. "[ENDCOLOR]/[COLOR_NEGATIVE_TEXT]" .. data[4] .. "[ENDCOLOR]", data[5]})
	end
end
function ListDataFunc46()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			local pmString = "The similarity to closest civilization (" .. Players[gd.EEFNationality[1]]:GetCivilizationShortDescription() .. ").[NEWLINE][NEWLINE]This factor considers civilizations' culture types, social developments, laws, innovations, inspirations, wonders, goverments, religions and more."
			table.insert(hTab, {g, gd.EEFNationality[2], pmString})
		end
	end
	table.sort(hTab, SortFunctionForLowestMapDistance)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2] .. "%", data[3]})
	end
end
function ListDataFunc47()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			if (gd.EEFTurnsOfAnarchy > 0) or (gd.EEFAnarchyOutbreaks > 0) then
				table.insert(hTab, {g, gd.EEFTurnsOfAnarchy, gd.EEFAnarchyOutbreaks})
			end
		end
	end
	table.sort(hTab, SortFunctionGreatest2Greatest3)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2] .. "T (" .. data[3] .. ")", "Total amount of turns spend during Anarchy (Anarchy outbreaks)."})
	end
end
function ListDataFunc48()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			table.insert(hTab, {g, gd.EEFTurnsOfPeace, gd.EEFMTurnsOfPeace})
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2] .. "T (" .. data[2] + data[3] .. ")", "Total amount of turns spend at Peace (excluding minor wars)."})
	end
end
function ListDataFunc49()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			table.insert(hTab, {g, gd.SettlerGenerationPoints - gd.SettlerPointsStart + gd.SettlerPointsSpend, gd.CitiesFounded, gd.LHsettlers})
		end
	end
	table.sort(hTab, SortFunctionGreatest2Lowest3)
--		table.sort(hTab, SortFunctionForGreaterInteger3)
--		table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		if data[4] ~= 0 then
			table.insert(rData, {data[1], data[2].. " [ICON_ITG_SETTLER] (" .. data[3] .. ")", "Amount of [ICON_ITG_SETTLER] Settler points earned through entire game (number of cities founded).[NEWLINE][NEWLINE]Cities trained Settler [COLOR_POSITIVE_TEXT]" .. data[4] .. "[ENDCOLOR] times."})
		else
			table.insert(rData, {data[1], data[2].. " [ICON_ITG_SETTLER] (" .. data[3] .. ")", "Amount of [ICON_ITG_SETTLER] Settler points earned through entire game (number of cities founded)."})
		end
	end
end
function ListDataFunc50()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			table.insert(hTab, {g, gd.NumFestivalsStarted})
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2], "Number of [ICON_ITG_FESTIVAL] Festivals started."})
	end
end
function ListDataFunc51()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			if gd.HasCodex then
				table.insert(hTab, {g, gd.CodexStrength, -1, gd.CodexDate, gd.CodexLawFavoured, gd.CodexInfluencePercent})
			end
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2] .. "%[ICON_ITG_CODEX]", "Strength of Codex.[NEWLINE]Founded in " .. data[4] .. ".[NEWLINE]" .. data[6] .. "% influential in global scale.[NEWLINE]" .. data[5] .. " laws are recognized globally."})
	end
end
function ListDataFunc52()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			if gd.GoldSpendOnMinorGifts > 0 or gd.InfluenceFromGoldGifts > 0 then
				table.insert(hTab, {g, gd.GoldSpendOnMinorGifts, gd.InfluenceFromGoldGifts})
			end
		end
	end
--		table.sort(hTab, SortFunctionGreatest2Lowest3) ?? why that was used?
	table.sort(hTab, SortFunctionGreatest2Greatest3)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2] .. "[ICON_GOLD] (" .. data[3] .. "[ICON_INFLUENCE])", "Total amount of [ICON_GOLD] Gold spend on gifts for Minors ([ICON_INFLUENCE] Influence gained from that)."})
	end
end
function ListDataFunc53()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			table.insert(hTab, {g, gd.CSBulliedTimes, gd.CSBulliedGold})
		end
	end
	table.sort(hTab, SortFunctionGreatest2Greatest3)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2] .. " (" .. data[3] .. "[ICON_GOLD])", "Number of times player bullied a city-state ([ICON_GOLD] Gold acquired from that)."})
	end
end
function ListDataFunc54()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		for iCity in Players[g]:Cities() do
			local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
			table.insert(hTab, {iCity, gGTdata.Cities[cID].MaxHealthEver, g})
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	local bCount = 0;
	local aip = {};
	for i, data in pairs(hTab) do
		if not aip[data[3]] then
			aip[data[3]] = true;
			table.insert(rData, {data[1], data[2] .. "[ICON_ITG_HEALTH_1]", "Best [ICON_ITG_HEALTH_1] Health ever observed in the city."})
			bCount = bCount + 1;
			if bCount >= maxshowCities then
				break;
			end
		end
	end
end
function ListDataFunc55()
	local hTab = {}
	for g, gd in pairs(gGTdata.Globals.PlaguesByID) do
		table.insert(hTab, {gd.Type .. " (" .. gd.Origin .. ")[NEWLINE]" .. GetTextDate(gd.Outbreak, gGTdata.Globals.StartDate), gd.NumKilled, gd.NumCities})
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2] .. "[ICON_ITG_PLAGUE_4] (" .. data[3] .. ")", data[1] .. "[NEWLINE][NEWLINE]Amount of [ICON_CITIZEN] Citizen that died in epidemy (number of cities affected)."})
	end	
end
function ListDataFunc56()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			table.insert(hTab, {g, gd.LawsChanged})
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2], "Amount of times the law was changed by a player."})
	end	
end
function ListDataFunc57()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			table.insert(hTab, {g, gd.LHNumVetProms, gd.LHNumUnitLevelsUP})
		end
	end
	table.sort(hTab, SortFunctionGreatest2Greatest3)
	for i, data in pairs(hTab) do
		if data[3] > 0 then
			table.insert(rData, {data[1], data[2] .. " (" .. data[3] .. ")", "Amount of Veteran promotions obtained by player's troops (total levels gained)."})
		end
	end	
end
function ListDataFunc58()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			local h = 99999;
			if gd.LHCombatLand + gd.LHCombatNaval > 0 then
				if gd.LHCombatLand == 0 then
					h = gd.LHCombatNaval
				elseif gd.LHCombatNaval == 0 then
					h = gd.LHCombatLand
				else
					h = math.abs(gd.LHCombatNaval - gd.LHCombatLand) * 2 / (gd.LHCombatLand + gd.LHCombatNaval)
				end
			end
			table.insert(hTab, {g, gd.LHCombatNaval, h, gd.LHCombatLand})
		end
	end
	table.sort(hTab, SortFunctionForLowestInteger3)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2] .. "[ICON_GREAT_ADMIRAL]/" .. data[4] .. "[ICON_GREAT_GENERAL]", "Ratio between naval and land combats made by player."})
	end
end
function ListDataFunc59()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		for iCity in Players[g]:Cities() do
			local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
			table.insert(hTab, {iCity, gGTdata.Cities[cID].NumBuildingConstructed})
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		if i <= maxshowCities then
			table.insert(rData, {data[1], data[2], "Amount of buildings constructed in the city."})
		else
			break;
		end
	end
end
function ListDataFunc60()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			if gd.GoldSpentOnAcademies > 0 then
				table.insert(hTab, {g, gd.GoldSpentOnAcademies})
			end
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2] .. "[ICON_GOLD]", "Amount of [ICON_GOLD] Gold spent on supporting Academies."})
	end
end
function ListDataFunc61()
	local hTab = {}
	for g, gd in pairs(gGTdata.Academies) do
		table.insert(hTab, {gd.Name, gd.MaxPrestigeEver, gd.Year, gd.MaxPrestigePlayer, gd.MaxPrestigeTurn})
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], math.floor(data[2]) .. "[ICON_ITG_ACADEMY_1][NEWLINE](" .. data[5] .. "T)", "Greatest amount of [ICON_ITG_ACADEMY_1] Prestige recorded by Academy.[NEWLINE]" .. data[1] .. " was founded in " .. data[3] .. ".", data[4]})
	end
end
function ListDataFunc62()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if Players[g]:IsMinorCiv() then
			if gd.CSBulliedX > 0 then
				table.insert(hTab, {g, gd.CSBulliedX})
			end
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2], "Amount of times City-State was bullied."})
	end
end
function ListDataFunc63()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			table.insert(hTab, {g, gd.TotalDecadentism})
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2] .. "%", "Amount of [ICON_HAPPINESS_1] Happiness chance lost by decadent society (too much luxuries)."})
	end
end
function ListDataFunc64()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		for iCity in Players[g]:Cities() do
			local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
			if gGTdata.Cities[cID].Tplagues > 0 then
				table.insert(hTab, {iCity, gGTdata.Cities[cID].Tplagues, iCity:GetITGInteger(GameInfo.CityIntegers["CI_PLAGUE_POP_LOST"].ID)})
			end
		end
	end
	table.sort(hTab, SortFunctionGreatest2Greatest3)
	for i, data in pairs(hTab) do
		if i <= maxshowCities then
			table.insert(rData, {data[1], data[2] .. " (" .. data[3] .. "[ICON_CITIZEN])", "Amount of Epidemies' outbreaks in the city ([ICON_CITIZEN] Population lost)."})
		else
			break;
		end
	end
end
function ListDataFunc65()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			table.insert(hTab, {g, gd.TotalBarbCleared, gd.TotalBarbKilled})
		end
	end
	table.sort(hTab, SortFunctionGreatest2Greatest3)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2] .. " (" .. data[3] .. ")", "Amount of barbarian camps cleared (barbarians killed)."})
	end
end
function ListDataFunc66()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			if gd.NumSpecialMerc > 0 or gd.NumMercTotal > 0 then
				table.insert(hTab, {g, gd.NumSpecialMerc, gd.NumMercTotal})
			end
		end
	end
	table.sort(hTab, SortFunctionGreatest2Greatest3)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2] .. " (" .. data[3] .. ")", "Amount of famous Mercenaries acquired (total amount of Mercenaries purchased)."})
	end
end
function ListDataFunc67()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			local gvv = 0;
			for tid, tdd in pairs(gGTdata.Cities) do
				gvv = gvv + (tdd.CultureStored[g] or 0)
			end
			table.insert(hTab, {g, gvv})
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], math.floor(data[2]) .. "[ICON_ITG_PRESENCE]", "Amount of Cultural Presence globally."})
	end
end
function ListDataFunc68()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		for iCity in Players[g]:Cities() do
			local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
			local val = 0;
			for b, bh in pairs(gGTdata.Cities[cID].CultureStored) do
				val = val + bh;
			end
			table.insert(hTab, {iCity, val})
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		if i <= maxshowCities then
			local tooltipExtra = "Cultures present: "
			local cID = data[1]:Plot():GetPlotIndex() .. "," .. data[1]:GetGameTurnFounded();
			for b, bh in pairs(gGTdata.Cities[cID].CultureStored) do
				tooltipExtra = tooltipExtra .. "[NEWLINE][ICON_BULLET]" .. Players[b]:GetCivilizationAdjective() .. " " .. bh .. "[ICON_CULTURE]";
			end
			table.insert(rData, {data[1], data[2] .. "[ICON_ITG_PRESENCE]", tooltipExtra})
		else
			break;
		end
	end
end
function ListDataFunc69()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		for iCity in Players[g]:Cities() do
			local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
			table.insert(hTab, {iCity, iCity:GetITGInteger(GameInfo.CityIntegers["CI_LH_TRAINED_UNITS"].ID), gGTdata.Cities[cID].UnhapFromTrained})
		end
	end
	table.sort(hTab, SortFunctionGreatest2Greatest3)
	for i, data in pairs(hTab) do
		if i <= maxshowCities then
			table.insert(rData, {data[1], data[2] .. " (" .. data[3] .. "[ICON_HAPPINESS_4])", "Amount of units trained by city (unhappiness generated)."})
		else
			break;
		end
	end
end
function ListDataFunc70()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			if gd.NumRailroadsMade > 0 then
				table.insert(hTab, {g, gd.NumRailroadsMade})
			end
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2], "Amount of Railroads made."})
	end
end
function ListDataFunc71()
	for i, data in pairs(gGTdata.Globals.LHlongestRoutes) do
		table.insert(rData, {Map.GetPlotByIndex(data[1]):GetPlotCity():GetName() .. "-" .. Map.GetPlotByIndex(data[3]):GetPlotCity():GetName(), data[2], "The distance between cities (connected by the most advanced route type).", data[4]})
	end
end
function ListDataFunc72()
	local typeIconData = {}
	local bAltArt = MapModData.DBScenario.AltGreatPeopleArt;
	for row in DB.Query("SELECT * FROM ITGGreatPeople") do
		if bAltArt then
			typeIconData[row.ID] = {row.AltPortraitIndex, row.AltIconAtlas}
		else
			typeIconData[row.ID] = {row.PortraitIndex, row.IconAtlas}
		end
	end
	local hTab = {}
	for g, gd in pairs(gGTdata.GreatPeople) do
		if gd.NumTravels then
			table.insert(hTab, {gd.Name, gd.NumTravels, gd.OriginPlayer, gd.Type})
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		if i <= maxshowCities then
			table.insert(rData, {Locale.Lookup(data[1]), data[2], "Amount of times Great Person travelled between Cities.", data[3], typeIconData[data[4]]})
		else
			break;
		end
	end
end
function ListDataFunc73()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			table.insert(hTab, {g, gd.ArchPointsTotal, gd.ArchLocatedFirst})
		end
	end
	table.sort(hTab, SortFunctionGreatest2Greatest3)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2] .. "[ICON_RES_ARTIFACTS] (" .. data[3] .. ")", "Amount of [ICON_RES_ARTIFACTS] Archeological points generated (times player was first to locate Antiquity Site).", data[3]})
	end
end
function ListDataFunc74()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			table.insert(hTab, {g, gd.ArchSitesDigged})
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2], "Amount of Archaeological Sites completed."})
	end
end
function ListDataFunc75()
	if MapModData.DBScenario.IdeologyOn then
		for i, data in pairs(gGTdata.Globals.IdeologiesLH) do
			table.insert(rData, {gGTdata.Players[data[1]].IdeologyName, data[2], "The difference between player's ideology and the average one.", data[1]})
		end
	end
end
function ListDataFunc76()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			table.insert(hTab, {g, gd.LHTotalAuthority, gd.LHMaxAuthority})
		end
	end
	table.sort(hTab, SortFunctionGreatest2Greatest3)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2] .. " (" .. data[3] .. ") [ICON_ITG_AUTHORITY]", "Amount of Authority summed through the entire scenario (max value in single turn)."})
	end
end
function ListDataFunc77()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			table.insert(hTab, {g, gd.LHNumPalaceUpgrades})
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2], "Amount of Palace upgrades constructed by Player."})
	end
end
function ListDataFunc78()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		for iCity in Players[g]:Cities() do
			local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
			if gGTdata.Cities[cID].LHPalaceTop then
				table.insert(hTab, {iCity, gGTdata.Cities[cID].LHPalaceTop, gGTdata.Cities[cID].LHPalaceTurn, gGTdata.Cities[cID].LHPalacePlayer})
			end
		end
	end
	table.sort(hTab, SortFunctionGreatest2Lowest3)
	for i, data in pairs(hTab) do
		if i <= maxshowCities then
			table.insert(rData, {data[1], data[2] .. " (" .. data[3] .. "T)", "Max palace upgrades acquired by a City (turn acquired).", data[4]})
		else
			break;
		end
	end
end
function ListDataFunc79()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			table.insert(hTab, {g, gd.PillagedImpros, gd.PillagedImprosGold})
		end
	end
	table.sort(hTab, SortFunctionGreatest2Greatest3)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2] .. " (" .. data[3] .. "[ICON_GOLD])", "Amount of improvements pillaged by Player ([ICON_GOLD] Gold earned)."})
	end
end
function ListDataFunc80()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			table.insert(hTab, {g, gd.LHOwnChosenCB + gd.LHRechosenCB, gd.LHRechosenCB})
		end
	end
	table.sort(hTab, SortFunctionGreatest2Greatest3)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2] .. " (" .. data[3] .. ")", "Amount of Social Developments defined by Player (amount of times replacement was used)."})
	end
end
function ListDataFunc81()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			table.insert(hTab, {g, gd.LHRebelsSpawned, gd.LHRebelsSpawnedNB})
		end
	end
	table.sort(hTab, SortFunctionGreatest2Greatest3)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2] .. " (" .. data[3] .. ")", "Amount of rebels spawned (non-barbarian ones)."})
	end
end
function ListDataFunc82()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			if #gd.LHStockCurrency > 0 then
				local max, tot = 0, 0;
				for dg, vg in pairs(gd.LHStockCurrency) do
					max = math.max(max, vg);
					tot = tot + vg;
				end
				table.insert(hTab, {g, tot, max})
			end
		end
	end
	table.sort(hTab, SortFunctionGreatest2Greatest3)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2] .. " (" .. data[3] .. ")[ICON_INVEST]", "Amount of currency power gained from investments (greatest value from single session)."})
	end
end
function ListDataFunc83()
	local hTab = {}
	for i, data in pairs(gGTdata.LHStockRises) do
		table.insert(hTab, {data[1], data[2], data[3]})
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		if i <= 20 then
			table.insert(rData, {data[3] .. "T " .. data[1],"+" .. data[2] .. "%", "Stock Rate's increasement noted."})
		else
			break;
		end
	end			
end
function ListDataFunc84()
	local hTab = {}
	for i, data in pairs(gGTdata.Heresies) do
		local iCity = Map.GetPlotByIndex(data.City):GetPlotCity();
		table.insert(hTab, {data.Name, (data.End or 100) - data.Start, iCity:GetName(), iCity:GetOwner(), data.Start})
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1] .. " in " .. data[3],data[2] .. "T", data[1] .. " in " .. data[3] .. "[NEWLINE][NEWLINE]Amount of turns [ICON_PROPHET] Heresy was active in a city. Started in " .. data[5] .. "T.", data[4]})
	end
end
function ListDataFunc85()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			table.insert(hTab, {g, gd.LHAuctionDeals, gd.LHAuctionDealsBuy, gd.LHSpecialDeals})
		end
	end
	table.sort(hTab, SortFunctionGreatest2Greatest3)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2] .. " (" .. data[3] .. ")", "Amount of deals made in Auction House (importing only). Player also finalized " .. data[4] .. " special deals."})
	end
end
function ListDataFunc86()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			table.insert(hTab, {g, 3 * gd.LHLeagueDisband + gd.LHLeagueRes + gd.LHLeagueAction + 4 * gd.LHLeagueForm, gd.LHLeagueForm, gd.LHLeagueRes, gd.LHLeagueDisband, gd.LHLeagueAction})
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2], "League-related actions:" .. "[NEWLINE][ICON_BULLET]" .. data[3] .. " forming New League.[NEWLINE][ICON_BULLET]" .. data[5] .. " leaving League.[NEWLINE][ICON_BULLET]" .. data[4] .. " passed Resolutions.[NEWLINE][ICON_BULLET]" .. data[6] .. " taken Actions."})
	end
end
function ListDataFunc87()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			if gd.LHMissionaries > 0 then
				table.insert(hTab, {g, gd.LHMissionaries, gd.LHMartyrs})
			end
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2] .. " (" .. data[3] .. ")", "Missionaries' used (martyrs)."})
	end
end
function ListDataFunc88()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			if gd.LHNuclearTurn then
				table.insert(hTab, {g, gd.LHNuclearStrikes, gd.LHNuclearTurn})
			end
		end
	end
	table.sort(hTab, SortFunctionGreatest2Lowest3)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2] .. " (" .. data[3] .. "T)", "Atomic bombs used (turn of finishing nuclear project)."})
	end
end
function ListDataFunc89()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			if gd.LHSpaceFlightTurn then
				table.insert(hTab, {g, gd.LHSpaceFlightTurn})
			end
		end
	end
	table.sort(hTab, SortFunctionForLowestMapDistance)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2] .. "T", "Turn of finishing Spaceflight Program."})
	end
end
function ListDataFunc90()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			table.insert(hTab, {g, gd.LHAirRangedStrikes + gd.LHAirSweeps + Players[g]:GetInterceptionCount(), gd.LHAirRangedStrikes, gd.LHAirSweeps, Players[g]:GetInterceptionCount()})
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[3] .. "/" .. data[4] .. "/" .. data[5], "Amount of air strikes/sweeps/interceptions."})
	end
end
function ListDataFunc91()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		for iCity in Players[g]:Cities() do
			local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
			table.insert(hTab, {iCity, gGTdata.Cities[cID].LHBombBuildings + gGTdata.Cities[cID].LHBombPop, gGTdata.Cities[cID].LHBombBuildings, gGTdata.Cities[cID].LHBombPop})
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		if i <= maxshowCities then
			table.insert(rData, {data[1], data[3] .. " (" .. data[4] .. "[ICON_CITIZEN])", "Amount of buildings destroyed in bombings (population loss)."})
		else
			break;
		end
	end
end
function ListDataFunc92()
	for i, data in pairs(gGTdata.Globals.BudgetLH) do
		table.insert(rData, {data[1], data[2] / 100 .. "[ICON_GOLD]", "The amount of [ICON_GOLD] Gold that went into " .. data[3] .. " from player's budget."})
	end
end
function ListDataFunc93()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if (not Players[g]:IsMinorCiv()) and (gd.LHAirMissiles > 0) then
			table.insert(hTab, {g, gd.LHAirMissiles})
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2], "Amount of Guided Missiles used."})
	end
end

function ListDataFunc94()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			table.insert(hTab, {g, gd.LHIdeoVictories + gd.LHIdeoLosses, gd.LHIdeoVictories , gd.LHIdeoLosses})
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], "[COLOR_POSITIVE_TEXT]" .. data[3] .. "[ENDCOLOR]|[COLOR_NEGATIVE_TEXT]" .. data[4], "Victories and losses for ideological league."})
	end
end

function ListDataFunc95()
	local hTab = {}
	local estr = ""
	if gGTdata.Globals.PolioDone then
		estr = " Project was finished in " .. gGTdata.Globals.PolioDone .. "T."
		for g, c in pairs(gGTdata.Globals.PolioContributers) do
			table.insert(hTab, {g, c})
		end
	else
		for g, gd in pairs(gGTdata.Players) do
			if not Players[g]:IsMinorCiv() then
				if gd.BudgetOptions[14][2] >= 100 then
					table.insert(hTab, {g, gd.BudgetOptions[14][2]})
				end
			end
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], math.floor(data[2] / 100) .. "[ICON_GOLD]", "Contribution towards Polio Vaccine project." .. estr})
	end
end

function ListDataFunc96()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			table.insert(hTab, {g, gd.LHPilgrimage})
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2], "Amount of completed pilgrimages."})
	end
end

function ListDataFunc97()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			table.insert(hTab, {g, gd.LHSpecialArmy})
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2], "Amount of specialized unit classes."})
	end
end

function ListDataFunc98()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			table.insert(hTab, {g, math.floor(gd.LHBuildingsConstructed/ (math.max(0.1, gd.LHUntisTrained)) * 1000), gd.LHBuildingsConstructed, gd.LHUntisTrained})
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[3] .. "/" .. data[4], "Constructed buildings/trained units."})
	end
end

function ListDataFunc99()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			for res, cons in pairs(gd.ConsumedRes) do
				table.insert(hTab, {g, cons, res})
			end
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		if i <= 20 then
			table.insert(rData, {data[1], data[2] .. " " ..  GameInfo.Resources[data[3]].IconString, "Amount of resource consumed by player."})
		else
			break;
		end
	end
end

function ListDataFunc100()
	for i, data in pairs(gGTdata.Globals.EspionageLH) do
		LuaEvents.ITG_LH_EspionageToolTip(data[4], data[3])
		table.insert(rData, {Locale.Lookup(data[1]), (data[2] / 10) .. "%", MapModData.ITGSG, data[4]})
		MapModData.ITGSG = nil;
	end
end
function ListDataFunc101()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			if gd.StAlphabet == g then
				local pop, pla, cit = 0, 0, 0;
				for j, jd in pairs(gGTdata.Players) do
					if jd.StAlphabet == g then
						pop = pop + Players[j]:GetTotalPopulation();
						cit = cit + Players[j]:GetNumCities();
						pla = pla + 1;
					end
				end
				table.insert(hTab, {g, pop, cit, pla})
			end
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2] .. "/" .. data[3] .. "/" .. data[4], "Amount of population/cities/civilizations that adopted " .. Players[data[1]]:GetCivilizationAdjective() .. " alphabet."})
	end
end
function ListDataFunc102()
	local hTab = {}
	for g, gd in pairs(gGTdata.Players) do
		if not Players[g]:IsMinorCiv() then
			local tt, ht = 0, 0;
			for j, b in pairs(Players[g]:GetGraphData(21)) do
				ht = ht + 1;
				tt = tt + b;
			end
			if ht > 0 then
				table.insert(hTab, {g, math.floor(100 * tt / ht) / 100 })
			end
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		table.insert(rData, {data[1], data[2] .. "%[ICON_ITG_MERITOCRACY]", "Average level of [ICON_ITG_MERITOCRACY] Meritocracy."})
	end
end
function ListDataFunc103()
	local hTab = {}
	for g, gd in pairs(gGTdata.Globals.Governors) do
		table.insert(hTab, {Locale.Lookup(gd.Name), gd.LHMaxPower, gd.Type, gd.LHMaxPowerT, gd.LHMaxPowerPlayer, {gd.PIndex,gd.IconAtlas}})
	end
	LuaEvents.ITG_RequestGovernorTypesStrings();
	local GovTypeString = MapModData.ITGSG;
	MapModData.ITGSG = nil;
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		if i <= 20 then
			table.insert(rData, {data[1], data[2] .. "[ICON_ITG_POWER]", "Highest [ICON_ITG_POWER] Power was achieved in " .. data[4] .. "T (" .. GovTypeString[data[3]] .. ").", data[5], data[6]})
		end
	end	
end
function ListDataFunc104()
	local hTab = {}
	for cID, d in pairs(gGTdata.Cities) do
		if d.HighestPopConquer then
			local iCity = Map.GetPlotByIndex(d.Plot):GetPlotCity();
			table.insert(hTab, {iCity, d.HighestPopConquer, d.HighestPopTurn, d.HighestPopPlayer})
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for i, data in pairs(hTab) do
		if i<= 20 then
			table.insert(rData, {data[1], data[2] .. "[ICON_CITIZEN] (" .. data[3] .. "T)", "Population of the City when it was conquered.", data[4]})
		else
			break;
		end
	end
end

local gTabOfLists = {
{ID = 1, StrIcon = "[ICON_GREAT_WORK]", Title = "The most inspiring Civilizations", Dfunc = ListDataFunc1, ToolTip = "Display list with number of Great Works of Art created."},
{ID = 2, StrIcon = "[ICON_RES_ARTIFACTS]", Title = "The Globetrotter",Dfunc = ListDataFunc2, ToolTip = "Display list with number of Ancient Ruins discovered.", NoScenario = {[4] = true, [5] = true}},
{ID = 3, StrIcon = "[ICON_RESEARCH]", Title = "The most enlightened Entities", Dfunc = ListDataFunc3, ToolTip = "Display list with amount of Science generated."},
{ID = 4, StrIcon = "[ICON_CULTURE]", Title = "The ART in Earth", Dfunc = ListDataFunc4, ToolTip = "Display list with amount of Culture generated."},
{ID = 5, StrIcon = "[ICON_PEACE]", Title = "Beyond Seekers", Dfunc = ListDataFunc5, ToolTip = "Display list with amount of Faith generated.", NoScenario = {[5] = true}},
{ID = 6, StrIcon = "[ICON_GREAT_GENERAL]", Title = "The Warmongers", Dfunc = ListDataFunc6, ToolTip = "Display list with amount of Great General points earned."},
{ID = 7, StrIcon = "[ICON_GREAT_ADMIRAL]", Title = "Lords of the Seas", Dfunc = ListDataFunc7, ToolTip = "Display list with amount of Great Admiral points earned."},
{ID = 8, StrIcon = "[ICON_OCCUPIED]", Title = "The Greatest Conquerors", Dfunc = ListDataFunc8, ToolTip = "Display list with number of cities conquered."},
{ID = 9, StrIcon = "[ICON_RELIGION]", Title = "Lords of the Souls", Font = "TwCenMT20", Dfunc = ListDataFunc9, ToolTip = "Display list with number of religious followers.", NoScenario = {[5] = true}},
{ID = 10, StrIcon = "[ICON_GREAT_ENGINEER]", Title = "The Magnificent Ones", Dfunc = ListDataFunc10, ToolTip = "Display list with number of Wonders build.", NoScenario = {[5] = true}},
{ID = 11, StrIcon = "[ICON_MOVES]", Title = "Cartographers", Font = "TwCenMT20", Dfunc = ListDataFunc11, ToolTip = "Display list with amount of territory discovered.", NoScenario = {[5] = true}},
{ID = 12, StrIcon = "[ICON_SWAP]", Title = "Trade Centers", EntryType = 2, Dfunc = ListDataFunc12, ToolTip = ("Display list with cities that were visited by the greatest amount of Trade Routes.")},
{ID = 13, StrIcon = "[ICON_SWAP]", Title = "Good Good Exchangers", Dfunc = ListDataFunc13, ToolTip = "Display list with amount of Gold earned through Trade Routes."},
{ID = 14, StrIcon = "[ICON_WAR]", Title = "Lords of Life and Death", Dfunc = ListDataFunc14, ToolTip = "Display list with unit kills/deaths ratios."},
{ID = 15, StrIcon = "[ICON_WORKER]", Title = "Work never ends", Dfunc = ListDataFunc15, ToolTip = "Display list with most work rate spend."},
{ID = 16, StrIcon = "[ICON_SPY]", Title = "Masters of Puppets", Dfunc = ListDataFunc16, ToolTip = "Display list with most active spies' users."},
{ID = 17, StrIcon = "[ICON_CITIZEN]", Title = "Megalopolis", Font = "TwCenMT20", EntryType = 2, Dfunc = ListDataFunc17, ToolTip = "Display list with the largest cities that ever existed."},
{ID = 18, StrIcon = "[ICON_CITIZEN]", Title = "The Greatest Mushrooms", Font = "TwCenMT20", EntryType = 2, Dfunc = ListDataFunc18, ToolTip = "Display list with cities with the largest population boom."},
{ID = 19, StrIcon = "[ICON_ITG_LEGAL_POWER]", Title = "The Reformators", Dfunc = ListDataFunc19, ToolTip = "Display list with amount of Legal Power spend."},
{ID = 20, StrIcon = "[ICON_INFLUENCE]", Title = "League Makers", Dfunc = ListDataFunc20, ToolTip = "Display list with the average number of allied city-states."},
{ID = 21, StrIcon = "[ICON_ITG_NAT_UNITY]", Title = "Cultures of World", Font = "TwCenMT20", Dfunc = ListDataFunc21, ToolTip = "Display list with the most united Nations."},
{ID = 22, StrIcon = "[ICON_PIRATE]", Title = "Warlords", Dfunc = ListDataFunc22, ToolTip = "Display list with amount of civilians killed."},
{ID = 23, StrIcon = "[ICON_GOLD]", Title = "The Sun Kings and Queens", Dfunc = ListDataFunc23, ToolTip = "Display list with amount of Gold spent internally.", NoScenario = {[5] = true}},
{ID = 24, StrIcon = "[ICON_INVEST]", Title = "Adam Smith's Award", Font = "TwCenMT18", Dfunc = ListDataFunc24, ToolTip = "Display list with average power of Currency."},
{ID = 25, StrIcon = "[ICON_MISSIONARY]", Title = "Religious Heat", Font = "TwCenMT18", Dfunc = ListDataFunc25, ToolTip = "Display list with increase of Religious pressures.", NoScenario = {[4] = true, [5] = true}},
{ID = 26, StrIcon = "[ICON_CONNECTED]", Title = "Khan", Dfunc = ListDataFunc26, ToolTip = "Display list with the greatest land expansions."},
{ID = 27, StrIcon = "[ICON_GREAT_GENERAL]", Title = "Elite Troops", Font = "TwCenMT14", Dfunc = ListDataFunc27, ToolTip = "Display list with the most skilled Combat Classes."},
{ID = 28, StrIcon = "[ICON_HAPPINESS_4]", Title = "The Hateful Ones", EntryType = 2, Dfunc = ListDataFunc28, ToolTip = "Display list with the most unhappy Cities."},
{ID = 29, StrIcon = "[ICON_RESEARCH]", Title = "Craddle of Future", Dfunc = ListDataFunc29, ToolTip = "Display list with most technological advanced nations."},
{ID = 30, StrIcon = "[ICON_RES_FISH]", Title = "Fishermen' Heaven", EntryType = 2, Dfunc = ListDataFunc30, ToolTip = "Display list with cities which gain the greatest amount of Food from sea resources."},
{ID = 31, StrIcon = "[ICON_HAPPINESS_1]", Title = "Addictive Collecting", Dfunc = ListDataFunc31, ToolTip = "Display list with average number of owned Luxuries."},
{ID = 32, StrIcon = "[ICON_HAPPINESS_1]", Title = "Happy Tree Friends", Dfunc = ListDataFunc32, ToolTip = "Display list with average Happiness."},
{ID = 33, StrIcon = "[ICON_GREAT_EXPLORER]", Title = "Eternal Wonders", Dfunc = ListDataFunc33, ToolTip = "Display list with number of Natural Wonders discovered.", NoScenario = {[4] = true, [5] = true}},
{ID = 34, StrIcon = "[ICON_STRENGTH]", Title = "Citadel of World", Dfunc = ListDataFunc34, ToolTip = "Display list with average number of controlled Forts."},
{ID = 35, StrIcon = "[ICON_GREAT_MERCHANT]", Title = "Colonialists", Dfunc = ListDataFunc35, ToolTip = "Display list with average number of controlled Colonies."},
{ID = 36, StrIcon = "[ICON_GOLDEN_AGE]", Title = "Golden Times", Dfunc = ListDataFunc36, ToolTip = "Display list with length of Golden Age."},
{ID = 37, StrIcon = "[ICON_CITY_STATE]", Title = "Friends of the Weak", Dfunc = ListDataFunc37, ToolTip = "Display list with amount of victories in City-States' politics."},
{ID = 38, StrIcon = "[ICON_RAZING]", Title = "Survivors", EntryType = 2, Dfunc = ListDataFunc38, ToolTip = "Display list with greatest damage taken by cities."},
{ID = 39, StrIcon = "[ICON_RANGE_STRENGTH]", Title = "Stone Throwers", EntryType = 2, Dfunc = ListDataFunc39, ToolTip = "Display list with greatest amount of ranged strikes performed by cities."},
{ID = 40, StrIcon = "[ICON_GREAT_PEOPLE]", Title = "Craddle of Greatness", Font = "TwCenMT20", Dfunc = ListDataFunc40, ToolTip = "Display list with greatest amount of Great People generated."},
{ID = 41, StrIcon = "[ICON_GREAT_PEOPLE]", Title = "The Land of the Free", Dfunc = ListDataFunc41, ToolTip = "Display list with migration ratio of Great People."},
{ID = 42, StrIcon = "[ICON_IDEOLOGY_AUTOCRACY]", Title = "Toy Army", Dfunc = ListDataFunc42, ToolTip = "Display list with amount of units upgraded."},
{ID = 43, StrIcon = "[ICON_SILVER_FIST]", Title = "Achilles and Robin Hood", Font = "TwCenMT20", Dfunc = ListDataFunc43, ToolTip = "Display list with melee/ranged attacks ratios."},
{ID = 44, StrIcon = "[ICON_ITG_MORALE]", Title = "Into Valhalla", Font = "TwCenMT20", Dfunc = ListDataFunc44, ToolTip = "Display list with average Morale of troops."},
{ID = 45, StrIcon = "[ICON_TEAM_11]", Title = "Do not Hesitate", Dfunc = ListDataFunc45, ToolTip = "Display list with ratios between number of wars declared to wars declared on civilization."},
{ID = 46, StrIcon = "[ICON_FLOWER]", Title = "Special Cherry Blossom", Dfunc = ListDataFunc46, ToolTip = "Display list with most unique civilizations."},
{ID = 47, StrIcon = "[ICON_PIRATE]", Title = "Lords of Chaos", Dfunc = ListDataFunc47, ToolTip = "Display list with total length of Anarchy."},
{ID = 48, StrIcon = "[ICON_PEACE]", Title = "Pigeons", Dfunc = ListDataFunc48, ToolTip = "Display list with total length of Peace."},
{ID = 49, StrIcon = "[ICON_ITG_SETTLER]", Title = "Spring of Nations", Font = "TwCenMT18", Dfunc = ListDataFunc49, ToolTip = "Display list with total acquired Settler points.", NoScenario = {[5] = true}},
{ID = 50, StrIcon = "[ICON_ITG_FESTIVAL]", Title = "Neverending", Dfunc = ListDataFunc50, ToolTip = "Display list with number of Festivals started."},
{ID = 51, StrIcon = "[ICON_ITG_CODEX]", Title = "Land of the Law", Font = "TwCenMT20", Dfunc = ListDataFunc51, ToolTip = "Display list with the most popular Codexes."},
{ID = 52, StrIcon = "[ICON_CITY_STATE]", Title = "''Generousity''", Font = "TwCenMT18", Dfunc = ListDataFunc52, ToolTip = "Display list with gold spent on gifts for Minors.", NoScenario = {[5] = true}},
{ID = 53, StrIcon = "[ICON_HAPPINESS_3]", Title = "Sheep shearers", Font = "TwCenMT20", Dfunc = ListDataFunc53, ToolTip = "Display list with gold bullied from Minors.", NoScenario = {[5] = true}},
{ID = 54, StrIcon = "[ICON_ITG_HEALTH_1]", Title = "Universal Healthcare", EntryType = 2, Dfunc = ListDataFunc54, ToolTip = "Display list with the most healthy Cities (1 per player)."},
{ID = 55, StrIcon = "[ICON_ITG_PLAGUE_4]", Title = "Divine punishment", Font = "TwCenMT18", EntryType = 3, Dfunc = ListDataFunc55, ToolTip = "Display list with the most lethal Epidemies."},
{ID = 56, StrIcon = "[ICON_ITG_LEGAL_POWER]", Title = "Lawgivers", Dfunc = ListDataFunc56, ToolTip = "Display list with number of Laws changed."},
{ID = 57, StrIcon = "[ICON_WAR]", Title = "Veterans", Dfunc = ListDataFunc57, ToolTip = "Display list with number of Veteran promotions obtained."},
{ID = 58, StrIcon = "[ICON_RELIGION_TAOISM]", Title = "Lords of Warfare", Dfunc = ListDataFunc58, ToolTip = "Display list with equilibrium between Land and Naval combats done."},
{ID = 59, StrIcon = "[ICON_PRODUCTION]", Title = "Construction Sites", EntryType = 2, Dfunc = ListDataFunc59, ToolTip = "Display list with number of buildings constructed by Cities."},
{ID = 60, StrIcon = "[ICON_ITG_ACADEMY_2]", Title = "Illuminati", Dfunc = ListDataFunc60, ToolTip = "Display list with amount of gold spent on supporting Academies."},
{ID = 61, StrIcon = "[ICON_ITG_ACADEMY_1]", Title = "Titans of World", Font = "TwCenMT16", EntryType = 3, Dfunc = ListDataFunc61, ToolTip = "Display list with the greatest prestige values of Academies."},
{ID = 62, StrIcon = "[ICON_SILVER_FIST]", Title = "Punching Bags", Font = "TwCenMT20", Dfunc = ListDataFunc62, ToolTip = "Display list with amount of times City-States were bullied.", NoScenario = {[5] = true}},
{ID = 63, StrIcon = "[ICON_HAPPINESS_4]", Title = "Decadentism", Dfunc = ListDataFunc63, ToolTip = "Display list with the most decadent societes."},
{ID = 64, StrIcon = "[ICON_HAPPINESS_3]", Title = "Chosen by Fate", EntryType = 2, Dfunc = ListDataFunc64, ToolTip = "Display list with cities the most devastated by Epidemies."},
{ID = 65, StrIcon = "[ICON_WAR]", Title = "Germanicus", Dfunc = ListDataFunc65, ToolTip = "Display list with Civilizations most actively defeating Barbarians."},
{ID = 66, StrIcon = "[ICON_ITG_MERCENARY]", Title = "Golden Army", Dfunc = ListDataFunc66, ToolTip = "Display list with amount of purchased Mercenaries.", NoScenario = {[5] = true}},
{ID = 67, StrIcon = "[ICON_CULTURE]", Title = "The Ways", Dfunc = ListDataFunc67, ToolTip = "Display list with greatest Cultural Presences."},
{ID = 68, StrIcon = "[ICON_CULTURE]", Title = "Very Cultured Cities", EntryType = 2, Dfunc = ListDataFunc68, ToolTip = "Display list with the most cultured Cities."},
{ID = 69, StrIcon = "[ICON_WAR]", Title = "Forges of Heroes", EntryType = 2, Dfunc = ListDataFunc69, ToolTip = "Display list with number of units trained by Cities."},
{ID = 70, StrIcon = "[ICON_WORKER]", Title = "Railway Pioneers", Dfunc = ListDataFunc70, ToolTip = "Display list with amount of created Railroads.", Scenario = {[4] = true}},
{ID = 71, StrIcon = "[ICON_CONNECTED]", Title = "Trans-Siberian", EntryType = 3, Dfunc = ListDataFunc71, ToolTip = "Display list with the longest land connections between Cities."},
{ID = 72, StrIcon = "[ICON_TOURISM]", Title = "Fogg and Friends", EntryType = 3, Dfunc = ListDataFunc72, ToolTip = "Display list with the most adventorous Great People."},
{ID = 73, StrIcon = "[ICON_RES_ARTIFACTS]", Title = "The Librarians", Dfunc = ListDataFunc73, ToolTip = "Display list with amount of Historical Sources researched.", Scenario = {[4] = true}},
{ID = 74, StrIcon = "[ICON_RES_ARTIFACTS]", Title = "Desecrators", Dfunc = ListDataFunc74, ToolTip = "Display list with amount of Archaeological Sites completed.", Scenario = {[4] = true}},
{ID = 75, StrIcon = "[ICON_IDEOLOGY_EQUALITY]", Title = "Destroyers of World Order", EntryType = 3, Dfunc = ListDataFunc75, ToolTip = "Display list with most radical Ideologies.", Scenario = {[4] = true}},
{ID = 76, StrIcon = "[ICON_ITG_AUTHORITY]", Title = "Awe, Respect & Fear", Font = "TwCenMT18", Dfunc = ListDataFunc76, ToolTip = "Display list with amount of Authority generated."},
{ID = 77, StrIcon = "[ICON_CAPITAL]", Title = "Narcissism", Dfunc = ListDataFunc77, ToolTip = "Display list with amount of Palace Upgrades constructed.", NoScenario = {[5] = true}},
{ID = 78, StrIcon = "[ICON_CITY_STATE]", Title = "Glass Palaces", EntryType = 2, Dfunc = ListDataFunc78, ToolTip = "Display list with most developed Palaces."},
{ID = 79, StrIcon = "[ICON_WAR]", Title = "Redistributors of Goods", Dfunc = ListDataFunc79, ToolTip = "Display list with amount of tiles Pillaged."},
{ID = 80, StrIcon = "[ICON_CULTURE]", Title = "Architect of own Fate", Dfunc = ListDataFunc80, ToolTip = "Display list with amount of self-defined Social Developments.", NoScenario = {[4] = true, [5] = true}},
{ID = 81, StrIcon = "[ICON_RESISTANCE]", Title = "Tyrants", Dfunc = ListDataFunc81, ToolTip = "Display list with amount of rebels spawned."},
{ID = 82, StrIcon = "[ICON_INVEST]", Title = "Investors", Dfunc = ListDataFunc82, ToolTip = "Display list with amount of currency power acquired from Investments.", NoScenario = {[3] = true}},
{ID = 83, StrIcon = "[ICON_INVEST]", Title = "Boom!", EntryType = 3, Dfunc = ListDataFunc83, ToolTip = "Display list with the greatest Stock Exchange booms.", NoScenario = {[3] = true}},
{ID = 84, StrIcon = "[ICON_PROPHET]", Title = "Submit, heretic!", EntryType = 3, Dfunc = ListDataFunc84, ToolTip = "Display list with the longest existing Heresies.", NoScenario = {[3] = true, [4] = true, [5] = true}},
{ID = 85, StrIcon = "[ICON_RES_GOLD]", Title = "Shiny!", Dfunc = ListDataFunc85, ToolTip = "Display list with amount of deals made in Auction House."},
{ID = 86, StrIcon = "[ICON_ITG_VOTES]", Title = "Grand Scheme", Dfunc = ListDataFunc86, ToolTip = "Display list with players the most active in Leagues."},
{ID = 87, StrIcon = "[ICON_RELIGION]", Title = "Lightbringers", Dfunc = ListDataFunc87, ToolTip = "Display list with the greatest Missionary usages.", NoScenario = {[3] = true, [4] = true, [5] = true}},
{ID = 88, StrIcon = "[ICON_RES_URANIUM]", Title = "Destroyers of worlds", Dfunc = ListDataFunc88, ToolTip = "Display list with the most numerous usage of nuclear weapons.", Scenario = {[5] = true}},
{ID = 89, StrIcon = "[ICON_VICTORY_SPACE]", Title = "Star Reachers", Dfunc = ListDataFunc89, ToolTip = "Display list with turns of finishing Space Flight programs.", Scenario = {[5] = true}},
{ID = 90, StrIcon = "[ICON_RANGE_STRENGTH]", Title = "Flying Aces", Dfunc = ListDataFunc90, ToolTip = "Display list with amounts of air combats made.", Scenario = {[5] = true}},
{ID = 91, StrIcon = "[ICON_RAZING]", Title = "Ruins", Dfunc = ListDataFunc91, EntryType = 2, ToolTip = "Display list with Cities the most destroyed by bombing.", Scenario = {[5] = true}},
{ID = 92, StrIcon = "[ICON_INVEST]", Title = "Budget-focused", Dfunc = ListDataFunc92, ToolTip = "Display list with highest expenses on single budget options.", Scenario = {[5] = true}},
{ID = 93, StrIcon = "[ICON_RANGE_STRENGTH]", Title = "Rocket Mania", Dfunc = ListDataFunc93, ToolTip = "Display list with amount of Missiles used.", Scenario = {[5] = true}},
{ID = 94, StrIcon = "[ICON_IDEOLOGY_AUTOCRACY]", Title = "Ideological Crusaders", Dfunc = ListDataFunc94, ToolTip = "Display list with victories and losses players' achieved for their ideological league.", Scenario = {[5] = true}},
{ID = 95, StrIcon = "[ICON_ITG_HEALTH_1]", Title = "Man vs Nature", Dfunc = ListDataFunc95, ToolTip = "Display list with contributions towards Polio Vaccine.", Scenario = {[5] = true}},
{ID = 96, StrIcon = "[ICON_ITG_PILGRIM]", Title = "Pilgrim", Dfunc = ListDataFunc96, ToolTip = "Display list with amount of completed Pilgrimages.", Scenario = {[2] = true, [1] = true}},
{ID = 97, StrIcon = "[ICON_GREAT_GENERAL]", Title = "Upgrades!", Dfunc = ListDataFunc97, ToolTip = "Display list with amount of specialized units.", Scenario = {[5] = true}, {[3] = true}},
{ID = 98, StrIcon = "[ICON_PRODUCTION]", Title = "The Builders", Dfunc = ListDataFunc98, ToolTip = "Display list with ratio of constructed buildings to constructed units."},
{ID = 99, StrIcon = "[ICON_RES_COAL]", Title = "Consumption!", Dfunc = ListDataFunc99, ToolTip = "Display list with the most consumed resources.", Scenario = {[4] = true}},
{ID = 100, StrIcon = "[ICON_SPY]", Title = "Against the odds!", EntryType = 3, Dfunc = ListDataFunc100, ToolTip = "Display list with espionage actions that were the least likely to succeed."},
{ID = 101, StrIcon = "[ICON_ALPHA]", Title = "Master of symbols", Dfunc = ListDataFunc101, Font = "TwCenMT18", ToolTip = "Display list with alphabets used by the greatest populations."},
{ID = 102, StrIcon = "[ICON_ITG_MERITOCRACY]", Title = "Unmoved, Uncorrupted", Dfunc = ListDataFunc102, Font = "TwCenMT18", ToolTip = "Display list with average [ICON_ITG_MERITOCRACY] Meritocracy levels."},
{ID = 103, StrIcon = "[ICON_ITG_POWER]", Title = "Red Eminences", Font = "TwCenMT18", EntryType = 3, Dfunc = ListDataFunc103, ToolTip = "Display list with the most powerful Governors."},
{ID = 104, StrIcon = "[ICON_OCCUPIED]", Title = "Fall of Rome", Font = "TwCenMT18", EntryType = 2, Dfunc = ListDataFunc104, ToolTip = "Display list with the greatest Cities conquered."},
} 

function DoUpdateListData()
	if not gGTdata then
		LuaEvents.ITGSG_DoLeaderHeadStats()
		LuaEvents.ITGSG_RequestGT();
		gGTdata = MapModData.ITGSG;
		MapModData.ITGSG = nil;
		if not gGTdata then
			print("Unthinkable Error 156163")
			return
		end
		PrepareBasicListsStuff(gGTdata.Globals.ScenarioType)
	end
	for i, instanceID in pairs(cSel) do
		gTopInstances[instanceID].TopClick:SetAlpha(0.6);
		gTopInstances[instanceID].ImageFrame:SetHide(true)
	end
	cSel = {};
	for i = 1, 3 do
		g_PlayerListInstanceManager[i]:ResetInstances();
		local selectedID = gCaNodes[currentIDs[i]];
		Controls["PresentsLabel" .. i]:SetText("");
		Controls["ListNameLabel" .. i]:SetText(gTabOfLists[selectedID].Title);
		table.insert(cSel, selectedID);
		local dataT = aMadeT[selectedID] or GetWhosWinningDataOfType(selectedID);
		for j, data in pairs(dataT) do
			if gTabOfLists[selectedID].EntryType == 2 then
				AddCityEntry(data[4] or data[1]:GetOwner(), data[1], data[2], j, data[3], i, gTabOfLists[selectedID].Font)
			elseif gTabOfLists[selectedID].EntryType == 3 then
				AddDummyEntry(data[1], data[2], j, data[3], i, gTabOfLists[selectedID].Font, data[4], data[5])
			else
				AddPlayerEntry(data[1], data[2], j, data[3], i, gTabOfLists[selectedID].Font)
			end
		end
		Controls["PlayerListStack" .. i]:CalculateSize();
		Controls["PlayerListStack" .. i]:ReprocessAnchoring();
		Controls["PlayerListScrollPanel" .. i]:CalculateInternalSize();
		Controls["PlayerListScrollPanel" .. i]:SetScrollValue(0);
	end
	for i, instanceID in pairs(cSel) do
		gTopInstances[instanceID].TopClick:SetAlpha(1.0);
		gTopInstances[instanceID].ImageFrame:SetHide(false)
	end
end

-------------------------------------------------
-- AddPlayerEntry
-------------------------------------------------
function AddDummyEntry(sText, iScore, iRank, iTooltip, num, fontbyname, iPlayerID, iconData)
	local controlTable = g_PlayerListInstanceManager[num]:GetInstance();
	controlTable.BoxImageID:SetHide(true)
	
	local strName = Locale.ConvertTextKey("TXT_KEY_PROGRESS_SCREEN_NUMBERING", iRank);

	controlTable.PlayerNameText:SetText(strName .. " " .. sText);
	controlTable.ScoreText:SetText(iScore);
	controlTable.ScoreText:SetFontByName(fontbyname or "TwCenMT22");
	if iPlayerID then
		controlTable.BoxImageID:SetHide(false)
		CivIconHookup( iPlayerID, 32, controlTable.Icon, controlTable.CivIconBG, controlTable.CivIconShadow, false, true);  
	else
		controlTable.BoxImageID:SetHide(true)
	end
	if iconData then
		IconHookup( iconData[1], 64, iconData[2], controlTable.Portrait );
	elseif iPlayerID and (not Players[iPlayerID]:IsMinorCiv()) then
		controlTable.PortraitFrame:SetHide(false)
		local leader = GameInfo.Leaders[Players[iPlayerID]:GetLeaderType()];
		IconHookup( leader.PortraitIndex, 64, leader.IconAtlas, controlTable.Portrait );
	else
		controlTable.PortraitFrame:SetHide(true)
	end
	-- Tooltip
	controlTable.PlayerEntryBox:SetToolTipString(iTooltip);
end

function AddPlayerEntry (iPlayerID, iScore, iRank, iTooltip, num, fontbyname)
	local pPlayer = Players[iPlayerID];
	local iTeam = pPlayer:GetTeam();
	local pTeam = Teams[iTeam];

	local controlTable = g_PlayerListInstanceManager[num]:GetInstance();
        
	local strName = Locale.ConvertTextKey("TXT_KEY_PROGRESS_SCREEN_NUMBERING", iRank);
	
	-- Active player
	controlTable.BoxImageID:SetHide(false)
	if (pPlayer:GetID() == Game.GetActivePlayer()) then
		strName = strName .. " " .. Locale.ConvertTextKey( "TXT_KEY_POP_VOTE_RESULTS_YOU" );
	else
		strName = strName .. " " .. Locale.ConvertTextKey(pPlayer:GetNameKey());
	end   
	CivIconHookup( iPlayerID, 32, controlTable.Icon, controlTable.CivIconBG, controlTable.CivIconShadow, false, true);
	if pPlayer:IsMinorCiv() then
		IconHookup( 22, 64, "LEADER_ATLAS", controlTable.Portrait );
	else 
		local leader = GameInfo.Leaders[pPlayer:GetLeaderType()];
		IconHookup( leader.PortraitIndex, 64, leader.IconAtlas, controlTable.Portrait ); 
	end
	controlTable.PortraitFrame:SetHide(false)
	
	controlTable.PlayerNameText:SetText(strName);
	
	controlTable.ScoreText:SetText(iScore);
	controlTable.ScoreText:SetFontByName(fontbyname or "TwCenMT22");
	-- Tooltip
	controlTable.PlayerEntryBox:SetToolTipString(iTooltip);
end

-------------------------------------------------
-- AddCityEntry
-------------------------------------------------
function AddCityEntry(iPlayerID, pCity, iScore, iRank, iTooltip, num, fontbyname)

	local pPlayer = Players[iPlayerID];
	local iTeam = pPlayer:GetTeam();
	local pTeam = Teams[iTeam];
	local iCityID = pCity:GetID();

	local controlTable = g_PlayerListInstanceManager[num]:GetInstance();

    -- Use the Civilization_Leaders table to cross reference from this civ to the Leaders table
    local leader = GameInfo.Leaders[pPlayer:GetLeaderType()];
    local leaderDescription = leader.Description;
        
	local strName = Locale.ConvertTextKey("TXT_KEY_PROGRESS_SCREEN_NUMBERING", iRank);
	controlTable.BoxImageID:SetHide(false)

	strName = strName .. " " .. Locale.ConvertTextKey(pCity:GetNameKey());
	CivIconHookup( iPlayerID, 32, controlTable.Icon, controlTable.CivIconBG, controlTable.CivIconShadow, false, true); 
	if Players[iPlayerID]:IsMinorCiv() then
		IconHookup( 22, 64, "LEADER_ATLAS", controlTable.Portrait );
	else
		IconHookup( leader.PortraitIndex, 64, leader.IconAtlas, controlTable.Portrait );
	end
	controlTable.PortraitFrame:SetHide(false)
	
	controlTable.PlayerNameText:SetText(strName);
	
	-- Formats the # and reduces it to X.XX
--	local strPoints = Locale.ConvertTextKey("TXT_KEY_FORMAT_NUMBER", iScore);
	controlTable.ScoreText:SetText(iScore);
	controlTable.ScoreText:SetFontByName(fontbyname or "TwCenMT22");
	
	-- Tooltip
	controlTable.PlayerEntryBox:SetToolTipString(iTooltip);
	
end

function OnNextData()
	local midID = currentIDs[2];
	if gCaNodes[midID + 3] then
		currentIDs[2] = midID + 3;
	end	
	if gCaNodes[midID + 4] then
		currentIDs[3] = midID + 4;
	end
	if gCaNodes[midID + 5] then
		currentIDs[1] = midID + 5;
	end
	DoUpdateListData()
end
Controls.NextDataButton:RegisterCallback( Mouse.eLClick, OnNextData );

function OnPrevData()
	local midID = currentIDs[2];
	if gCaNodes[midID - 3] then
		currentIDs[2] = midID - 3;
	end	
	if gCaNodes[midID - 2] then
		currentIDs[3] = midID - 2;
	end
	if gCaNodes[midID -1] then
		currentIDs[1] = midID -1;
	end
	DoUpdateListData()
end
Controls.PrevDataButton:RegisterCallback( Mouse.eLClick, OnPrevData );
-------------------------------------------------------------------------------

function GetWhosWinningDataOfType(id)
	rData = {}
	gTabOfLists[id].Dfunc();
	aMadeT[id] = rData;
	return rData;
end

function GetGCNIDFromId(id)
	for i, b in pairs(gCaNodes) do
		if id == b then
			return i;
		end
	end
	print("Unthinkable 56532c")
end

function OnTopPanelClicked(id)
	if gCaNodes[currentIDs[2]] ~= id then
		if gCaNodes[currentIDs[1]] == id then
			currentIDs[1] = currentIDs[2];
			currentIDs[2] = GetGCNIDFromId(id);
		elseif gCaNodes[currentIDs[3]] == id then
			currentIDs[3] = currentIDs[2];
			currentIDs[2] = GetGCNIDFromId(id);
		else
			currentIDs[1] = currentIDs[3];
			currentIDs[3] = currentIDs[2];
			currentIDs[2] = GetGCNIDFromId(id);
		end
		DoUpdateListData()
	end
end

function ShouldNodeBeVisible(i, gType)
	if gTabOfLists[i].Scenario and (not gTabOfLists[i].Scenario[gType]) then
		return false;
	end
	if gTabOfLists[i].NoScenario and (gTabOfLists[i].NoScenario[gType]) then
		return false;
	end
	return true;
end

function PrepareBasicListsStuff(gType)
	gCaNodes = {}
	cSel = {};
	gTopInstances = {}
	g_TopPanelSelection:ResetInstances()
	for i, v in pairs(gTabOfLists) do
		if ShouldNodeBeVisible(i, gType) then
			local controlTable = g_TopPanelSelection:GetInstance();
			controlTable.TopClick:SetText(v.StrIcon)
			controlTable.TopClick:SetVoid1(i)
			controlTable.TopClick:RegisterCallback( Mouse.eLClick, OnTopPanelClicked );
			controlTable.TopClick:SetToolTipString(v.ToolTip)
			controlTable.TopClick:SetAlpha(0.6);
			controlTable.ImageFrame:SetHide(true)
			IconHookup( 62, 32, "ABILITY_ATLAS", controlTable.ImageFrame );
			table.insert(gCaNodes, i)
			gTopInstances[i] = controlTable;
		end
	end
	Controls.TopPanelInfoStack:CalculateSize();
	Controls.TopPanelInfoStack:ReprocessAnchoring();
	Controls.TopPanelScrollPanel:CalculateInternalSize()
end

function PrepareNodesForCurrentEra(gType)
	gGTdata = nil;
end
LuaEvents.ITGLHInitAll.Add(PrepareNodesForCurrentEra)

function ShowHideHandler( bIsHide, bInitState )
    if( not bIsHide ) then
    	DoUpdateListData();
	end
end
ContextPtr:SetShowHideHandler( ShowHideHandler );
