include( "InstanceManager" );
include( "IconSupport" ); 
include( "ITGSG_HelpFunctions.lua" );
include( "FLuaVector" );

local g_TopInstanceNotes = InstanceManager:new( "TopPanelPlayerInstance", "Button", Controls.NoteInfoStack );
local g_InstanceNotes = InstanceManager:new( "NoteInstance", "Root", Controls.NoteDisplayStack );


local tPrepTab = {}; -- holding already done stuff 
local cSelPlayer;
local pTinstances = {}
local mSpeed = 5;
local scrSpeed = 1;
local maxSpeed = 20;
local bPlaying = false;
local ahB = 0.15;

LuaEvents.ITG_ClearInstancesEndEra.Add(function()
	pTinstances = {};
	g_InstanceNotes:ResetInstances();
	g_TopInstanceNotes:ResetInstances();
end)

function SetAhB(i)
	ahB = i;
	DefineSpeedScroll()
end

function DoUpdateNote()
	if bPlaying then
		RPlayStop()
	end
	if not cSelPlayer then
		DoInitLeaderNote()
	end
	if not tPrepTab[cSelPlayer] then
		LuaEvents.ITGSG_HistoryNote(cSelPlayer)
		tPrepTab[cSelPlayer] = MapModData.ITGSG;
		MapModData.ITGSG = nil;
	end
	g_InstanceNotes:ResetInstances();
	for i, datanote in pairs(tPrepTab[cSelPlayer]) do
	--display data
		local theSize = 18;
		local instance = g_InstanceNotes:GetInstance();
		if datanote.ImageAtlas then
			instance.BoxImage:SetHide(false)
			instance.PortraitFrame:SetHide(datanote.HideImageFrame)
			IconHookup( datanote.PortraitIndex, 128, datanote.ImageAtlas, instance.Portrait)
			if datanote.ImageLabel then
				instance.PortraitLabel:SetText(datanote.ImageLabel)
				theSize = math.max(theSize, 128 + instance.PortraitLabel:GetSizeY())
			else
				instance.PortraitLabel:SetText("")
				theSize = math.max(theSize, 128)
			end
			if i % 2 == 1 then
				instance.BoxImage:SetOffsetVal(0,0)
				instance.BoxText:SetOffsetVal(132,0)
				instance.DividerV:SetAnchor("R,T")
			else
				instance.BoxImage:SetOffsetVal(512,0)
				instance.BoxText:SetOffsetVal(0,0)
				instance.DividerV:SetAnchor("L,T")
			end
			instance.DividerV:SetOffsetVal(-1,-1)
			instance.DividerV:SetOffsetVal(-4,0)

			instance.BoxText:SetSizeX(508)
			instance.TitleDivider:SetSizeX(508)
		else
			instance.BoxImage:SetHide(true)
			instance.BoxText:SetOffsetVal(0,0)
			instance.BoxText:SetSizeX(640)
			instance.TitleDivider:SetSizeX(640)
		end
		instance.TextTitle:SetWrapWidth(instance.BoxText:GetSizeX() - 13)
		instance.TextMain:SetWrapWidth(instance.BoxText:GetSizeX() - 13)
		instance.TitleDivider:SetSizeX(instance.BoxText:GetSizeX())
		--here layouts should come handy
		local textSize = 0;
		if datanote.Title then
			instance.TextTitle:SetText(datanote.Title)
			textSize = textSize + instance.TextTitle:GetSizeY() + 20
			instance.TextMain:SetOffsetVal(5, textSize)
		else
			instance.TextMain:SetOffsetVal(5, 0)
			instance.TextTitle:SetText("")
		end
		if datanote.TitleDivider then
			instance.TitleDivider:SetOffsetVal(0, textSize - 13)
			instance.TitleDivider:SetHide(false)
		else
			instance.TitleDivider:SetHide(true)
		end
		instance.TextMain:SetText(datanote.Text)
		textSize = textSize + instance.TextMain:GetSizeY()

		theSize = math.max(theSize, textSize) + 15
		instance.Root:SetSizeY(theSize)
		instance.DividerV:SetSizeY(theSize - 15)
	end
	
	Controls.NoteDisplayStack:CalculateSize();
	Controls.NoteDisplayStack:ReprocessAnchoring();
	Controls.NoteDisplayScrollPanel:CalculateInternalSize();
	RBack();
	Controls.SpeedStackEdit:SetText(mSpeed)
end
-------------------------------------------------------------------------------
function CivSelected(i)
	if cSelPlayer ~= i then
		if pTinstances[cSelPlayer] then
			pTinstances[cSelPlayer].Button:SetAlpha(0.6);
			pTinstances[cSelPlayer].ImageFrame:SetHide(true);
		end
		pTinstances[i].Button:SetAlpha(1);
		pTinstances[i].ImageFrame:SetHide(false);

		cSelPlayer = i;
		DoUpdateNote()
	end
end

function DoInitLeaderNote()
	LuaEvents.ITGSG_RequestGT()
	local gData = MapModData.ITGSG;
	MapModData.ITGSG = nil;
	cSelPlayer = Game.GetActivePlayer();
	if not gData.Players[cSelPlayer] then
		cSelPlayer = nil;
	end
	g_TopInstanceNotes:ResetInstances()
	for i = 0, 21 do
		if gData.Players[i] then
			local controlTable = g_TopInstanceNotes:GetInstance();
			IconHookup( 62, 32, "ABILITY_ATLAS", controlTable.ImageFrame );
			CivIconHookup( i, 32, controlTable.CivIcon, controlTable.CivIconBG, controlTable.CivIconShadow, false, true );
			pTinstances[i] = controlTable;
			controlTable.Button:SetVoid1(i)
			controlTable.Button:RegisterCallback( Mouse.eLClick, CivSelected );
			if not cSelPlayer then
				cSelPlayer = i;
			end
			if cSelPlayer == i then
				controlTable.Button:SetAlpha(1);
				controlTable.ImageFrame:SetHide(false)
			else
				controlTable.Button:SetAlpha(0.6);
				controlTable.ImageFrame:SetHide(true)
			end
		end
	end
	
	Controls.NoteInfoStack:CalculateSize();
	Controls.NoteInfoStack:ReprocessAnchoring();
	Controls.NoteScrollPanel:CalculateInternalSize();

	local screenSizeX, screenSizeY = UIManager:GetScreenSizeVal();
	Controls.NoteDisplayScrollPanel:SetSizeY(screenSizeY - 45 - 54 - 52)
	Controls.NoteDisplayScrollBar:SetSizeY(screenSizeY - 45 - 54 - 52 - 36)
	Controls.ScrollBarDownNote:SetOffsetVal(-5,Controls.NoteDisplayScrollPanel:GetSizeY() - 18)
end

function RSpeedup()
	mSpeed = math.min(maxSpeed, mSpeed + 1);
	Controls.RSpeedButton:SetDisabled(mSpeed == maxSpeed);
	Controls.RSlowButton:SetDisabled(false);
	Controls.SpeedStackEdit:SetText(mSpeed)
	if bPlaying then
		DefineSpeedScroll()
	end
end
function RSlowDown()
	mSpeed = math.max(1, mSpeed - 1);
	Controls.RSlowButton:SetDisabled(mSpeed == 1);
	Controls.RSpeedButton:SetDisabled(false);
	Controls.SpeedStackEdit:SetText(mSpeed)
	if bPlaying then
		DefineSpeedScroll()
	end
end
function RBack()
	Controls.NoteDisplayScrollPanel:SetScrollValue(0);
end
function RPlayStop()
	if bPlaying then
        ContextPtr:ClearUpdate();
		bPlaying = false;
		Controls.RPlayStopImage:SetTexture("ITGMiscPlayButton.dds")
	else
		bPlaying = true;
		Controls.RPlayStopImage:SetTexture("ITGMiscStopButton.dds")
		DefineSpeedScroll()
        ContextPtr:SetUpdate( OnUpdate );
	end
end
Controls.RPlayButton:RegisterCallback( Mouse.eLClick, RPlayStop );
Controls.RReturnButton:RegisterCallback( Mouse.eLClick, RBack );
Controls.RSlowButton:RegisterCallback( Mouse.eLClick, RSlowDown );
Controls.RSpeedButton:RegisterCallback( Mouse.eLClick, RSpeedup );

LuaEvents.ITGLHInitAll.Add(function()
	tPrepTab = {}
end)

function ShowHideHandler( bIsHide, bInitState )
    if( not bIsHide ) then
    	DoUpdateNote();
	else
        ContextPtr:ClearUpdate();
	end
end
ContextPtr:SetShowHideHandler( ShowHideHandler );

function OnUpdate( fDTime )
    local nScroll = scrSpeed + Controls.NoteDisplayScrollPanel:GetScrollValue()
--	(fDTime / m_fAnimSeconds);
    Controls.NoteDisplayScrollPanel:SetScrollValue(nScroll)
    if( nScroll >= 1 ) then
		RPlayStop()
    end
end

function DefineSpeedScroll()
	local tSizeY = math.max( Controls.NoteDisplayScrollPanel:GetSizeY(), Controls.NoteDisplayStack:GetSizeY() ) - Controls.NoteDisplayScrollPanel:GetSizeY();
	if tSizeY == 0 then
		scrSpeed = 1;
	else
		scrSpeed = math.min(1, mSpeed * ahB / tSizeY)
	end
end