include( "InstanceManager" );
include( "IconSupport" );
include( "ITGSG_ModUserData.lua" )
include( "FLuaVector.lua" )

local g_LeaderButtonIM = InstanceManager:new( "LeaderButtonInstance", "LeaderButton", Controls.MajorStack );
local scEraNames = {"The New World", "The Trial", "Age of Titans","Light of Hope", "Sleep of Reason"}
local currentEra;
local TabOfPieceNames = {"ITGLoadSetCPiece", "ITGLoadSetSPiece", "ITGLoadSetWPiece", "ITGLoadSetLPiece", "ITGLoadSetMPiece", "ITGLoadSetNWPiece", "ITGLoadSetAPiece"}
local hPieciesOrder = {};
local lastdoneEra;
local lLoadPuzzleTime = 100;
local waitPuzzleTime = 6;
function SetWaitPuzzleTime(a)
	waitPuzzleTime = a;
end
local rankType = 1;
local semiPreparedData;
local gTicks = 0;
local g_cPanel = 1;
local m_fAnimSeconds = 0.03;
local slimWait3tempo = 100;
local puzzleState = 1
local puzzleWait = 300;
local puzzleChangeTempo = 20;
local lPoz = {}
for i = 1, 24 do
	table.insert(lPoz, i)
end
local puzzleBase = {
"ITG_ScorePanel_Puzzle_Last_Supper.dds",
"ITG_Score_Puzzle_L_Sketches_GDJ.dds",
"ITG_ScorePanel_Puzzle_Starry_Night.dds",
"ITG_ScorePanel_Puzzle_Guernica.dds",
}

local tabSplashBG = {}
local numSplashBG = 0;
local cBGsplash = 0;
g_WaitForNextVBG = 200;
g_InitScaleVBG = 300;
g_InitSize = 0.5
local vicBGdata = {}
local cSplashPanel;
local originalSplashX;
local originalSplashY;
function InitWonderPanelsData()
	cSplashPanel = Controls.WonderSplash;
	originalSplashX = cSplashPanel:GetSizeX();
	originalSplashY = cSplashPanel:GetSizeY();
	tabSplashBG = {};
	local alrDone = {};
	for row in GameInfo.Buildings() do
		if row.WonderSplashImage and (not alrDone[row.WonderSplashImage]) then
			table.insert(tabSplashBG, row.WonderSplashImage);
			alrDone[row.WonderSplashImage] = true;
		end
	end
	numSplashBG = #tabSplashBG
	cBGsplash = math.random(1,numSplashBG);
	JumpToNextSplashBG()
	Controls.WonderClip:SetHide(false)
end
function InitVictoryPanelsData()
	cSplashPanel = Controls.VictoryImage;
	originalSplashX = cSplashPanel:GetSizeX();
	originalSplashY = cSplashPanel:GetSizeY();
	tabSplashBG = {};
	for row in GameInfo.Victories() do
		if row.VictoryBackground then
			table.insert(tabSplashBG, row.VictoryBackground);
		end
	end
	numSplashBG = #tabSplashBG
	cBGsplash = math.random(1,numSplashBG);
	JumpToNextSplashBG()
	Controls.VBGImageClip:SetHide(false)
end

function JumpToNextSplashBG()
	cBGsplash = 1 + ((cBGsplash - 1 + math.random(1,2)) % numSplashBG)
	vicBGdata = {Scale100 = g_InitScaleVBG}
	local fScale = 1 + g_InitSize
	cSplashPanel:SetTextureAndResize(tabSplashBG[cBGsplash])
	cSplashPanel:SetSizeVal( originalSplashX * fScale, originalSplashY * fScale );
end

function Shuffle(iTable)
	local n, order, oTable = #iTable, {}, {}
	for i=1,n do order[i] = { rnd = math.random(), idx = i } end
	table.sort(order, function(a,b) return a.rnd < b.rnd end)
	for i=1,n do oTable[i] = iTable[order[i].idx] end
	return oTable;
end

function RaindropRNG(i, rngData)
	if rngData.SizeX then
		Controls["GiP" .. i]:SetSizeX(math.random(rngData.SizeX[1], rngData.SizeX[2]))
	end
	if rngData.SizeY then
		Controls["GiP" .. i]:SetSizeY(math.random(rngData.SizeY[1], rngData.SizeY[2]))
	end
	if rngData.OffX then
		Controls["GiP" .. i]:SetOffsetX(math.random(rngData.OffX[1], rngData.OffX[2]))
	end
	if rngData.OffY then
		Controls["GiP" .. i]:SetOffsetY(math.random(rngData.OffY[1], rngData.OffY[2]))
	end
	if rngData.AllExtras then
		local aEEx = math.random(rngData.AllExtras[1], rngData.AllExtras[2])
		if aEEx ~= 0 then
			for jj, pp in pairs(gPanels[g_cPanel][i].Cycles) do
				gPanels[g_cPanel][i].Cycles[jj].Extra = (pp.Extra + aEEx) % pp.Time;
			end
		end
	end
end

function LightningSpecial1(i)
	if Controls["GiP" .. i]:IsHidden() then
		Controls["GiP" .. i]:SetOffsetVal(math.random(105, 340) , 0)
		Controls["GiP" .. i]:SetHide(false)
		gPanels[g_cPanel][i].Delay = math.random(5, 12)
		Controls.GiPBG:SetColor({x = 0.6, y = 0.6, z = 0.6, w = 1})
	else
		Controls["GiP" .. i]:SetHide(true)
		gPanels[g_cPanel][i].Delay = math.random(500, 3000)
		Controls.GiPBG:SetColor({x = 0, y = 0, z = 0, w = 1})
	end
end

gPanels = {
--1
{
--{Anchor = "L,T", InitHide = true, Texture = "ITG_ScorePanel_1_Lightning.dds", InitDelayRNG = {10, 2000}, 
--Cycles = {{Type = "FireSpecial"}}, FuncSpecial = LightningSpecial1},
{Anchor = "L,T", Texture = "ITG_ScorePanel_1_Raindrop.dds", RngData = {SizeX = {5, 19}, SizeY = {38,52}, OffX = {125,770}, OffY = {40, 70}, AllExtras = {-1,1}}, AllCycleExtraRNG = {0, 9}, 
Cycles = {{Type = "GoY", Val = 400, Time = 10}, {Type = "FireInit", Time = 10}}, FuncInit = RaindropRNG},
{Anchor = "L,T", Texture = "ITG_ScorePanel_1_Raindrop.dds", RngData = {SizeX = {5, 19}, SizeY = {38,52}, OffX = {125,770}, OffY = {40, 70}, AllExtras = {-1,1}}, AllCycleExtraRNG = {0, 9}, 
Cycles = {{Type = "GoY", Val = 400, Time = 10}, {Type = "FireInit", Time = 10}}, FuncInit = RaindropRNG},
{Anchor = "L,T", Texture = "ITG_ScorePanel_1_Raindrop.dds", RngData = {SizeX = {5, 19}, SizeY = {38,52}, OffX = {125,770}, OffY = {40, 70}, AllExtras = {-1,1}}, AllCycleExtraRNG = {0, 9}, 
Cycles = {{Type = "GoY", Val = 400, Time = 10}, {Type = "FireInit", Time = 10}}, FuncInit = RaindropRNG},
{Anchor = "L,T", Texture = "ITG_ScorePanel_1_Raindrop.dds", RngData = {SizeX = {5, 19}, SizeY = {38,52}, OffX = {125,770}, OffY = {40, 70}, AllExtras = {-1,1}}, AllCycleExtraRNG = {0, 9}, 
Cycles = {{Type = "GoY", Val = 400, Time = 10}, {Type = "FireInit", Time = 10}}, FuncInit = RaindropRNG},
{Anchor = "L,T", Texture = "ITG_ScorePanel_1_Raindrop.dds", RngData = {SizeX = {5, 19}, SizeY = {38,52}, OffX = {125,770}, OffY = {40, 70}, AllExtras = {-1,1}}, AllCycleExtraRNG = {0, 9}, 
Cycles = {{Type = "GoY", Val = 400, Time = 10}, {Type = "FireInit", Time = 10}}, FuncInit = RaindropRNG},
--{Anchor = "L,B", InitResize = true, SizeX = 241, SizeY = 169, OffX = 94, OffY = 185, AllCycleExtraRNG = {75,148}, Texture = "ITG_ScorePanel_1_Wave_1.dds", 
--Cycles = {{Type = "OffX", Val = 900, Time = 150}, {Type = "VisibilityTo", Val = 75, Time = 150}, {Type = "SizeTo", Val = -0.6, Time = 150},  {Type = "AddDelay", Val = 150, Delay = {0,100}, Time = 150}}},
{Anchor = "C,T", SizeX = 668, SizeY = 79, OffX = 20, OffY = 347, Texture = "ITG_ScorePanel_1_Wave_2.dds", 
Cycles = {{Type = "OffY", Val = 20, Half = true, Time = 100}, {Type = "SizeTo", Val = -0.1, Time = 100, Half = true}}},
{Anchor = "L,T", OffX = 237, OffY = 107, Texture = "ITG_ScorePanel_1_Ship.dds", 
Cycles = {{Type = "OffY", Extra = 15, Val = 20, Half = true, Time = 50}, {Type = "OffX", Val = 20, Half = true, Time = 50}}},
{Anchor = "L,B", InitResize = true, preDefX = 329, preDefY = 234, SizeX = 220, SizeY = 187, OffX = 116, OffY = 100, Texture = "ITG_ScorePanel_1_Wave_1.dds", 
Cycles = {{Type = "OffX", Val = 40, Half = true, Time = 40}, {Type = "OffY", Extra = 20, Val = 20, Half = true, Time = 40}, {Type = "SizeTo", Half = true, Val = -0.35, Time = 100}}},
{Anchor = "C,T", InitResize = true, SizeX = 626, SizeY = 75, OffX = 28, OffY = 444, Texture = "ITG_ScorePanel_1_Wave_2.dds", 
Cycles = {{Type = "OffY", Val = -20, Half = true, Time = 100}, {Type = "SizeTo", Extra = 15, Val = -0.1, Time = 100, Half = true}}},
--{Anchor = "L,B", InitResize = true, SizeX = 265, SizeY = 187, OffX = 83, OffY = 45, AllCycleExtraRNG = {0,75}, Texture = "ITG_ScorePanel_1_Wave_1.dds", 
--Cycles = {{Type = "OffX", Val = 1000, Time = 150}, {Type = "VisibilityTo", Val = 75, Time = 150}, {Type = "SizeTo", Val = -0.6, Time = 150}, {Type = "AddDelay", Val = 150, Delay = {0,100}, Time = 150}}},
{Anchor = "C,T", SizeX = 726, SizeY = 87,  OffX = 20, OffY = 487, Texture = "ITG_ScorePanel_1_Wave_2.dds", 
Cycles = {{Type = "OffY", Val = 20, Half = true, Time = 100}, {Type = "SizeTo", Val = -0.2, Time = 100, Half = true} }},
{Anchor = "L,T", Texture = "ITG_ScorePanel_1_Raindrop.dds", RngData = {SizeX = {5, 19}, SizeY = {38,52}, OffX = {125,770}, OffY = {40, 70}, AllExtras = {-1,1}}, AllCycleExtraRNG = {0, 9}, 
Cycles = {{Type = "GoY", Val = 400, Time = 10}, {Type = "FireInit", Time = 10}}, FuncInit = RaindropRNG,},
{Anchor = "L,T", Texture = "ITG_ScorePanel_1_Raindrop.dds", RngData = {SizeX = {5, 19}, SizeY = {38,52}, OffX = {125,770}, OffY = {40, 70}, AllExtras = {-1,1}}, AllCycleExtraRNG = {0, 9}, 
Cycles = {{Type = "GoY", Val = 400, Time = 10}, {Type = "FireInit", Time = 10}}, FuncInit = RaindropRNG,},
{Anchor = "L,T", Texture = "ITG_ScorePanel_1_Raindrop.dds", RngData = {SizeX = {5, 19}, SizeY = {38,52}, OffX = {125,770}, OffY = {40, 70}, AllExtras = {-1,1}}, AllCycleExtraRNG = {0, 9}, 
Cycles = {{Type = "GoY", Val = 400, Time = 10}, {Type = "FireInit", Time = 10}}, FuncInit = RaindropRNG,
},
{Anchor = "L,T", Texture = "ITG_ScorePanel_1_Raindrop.dds", RngData = {SizeX = {5, 19}, SizeY = {38,52}, OffX = {125,770}, OffY = {40, 70}, AllExtras = {-1,1}}, AllCycleExtraRNG = {0, 9}, 
Cycles = {{Type = "GoY", Val = 400, Time = 10}, {Type = "FireInit", Time = 10}}, FuncInit = RaindropRNG,
},
{Anchor = "L,T", Texture = "ITG_ScorePanel_1_Raindrop.dds", RngData = {SizeX = {5, 19}, SizeY = {38,52}, OffX = {125,770}, OffY = {40, 70}, AllExtras = {-1,1}}, AllCycleExtraRNG = {0, 9}, 
Cycles = {{Type = "GoY", Val = 400, Time = 10}, {Type = "FireInit", Time = 10}}, FuncInit = RaindropRNG,
},
},
--2
{
{Anchor = "L,T", OffX = 0, OffY = 0, Texture = "ITG_ScorePanel_2_Sky.dds",
Cycles = {{Type = "Alpha", Val = -400, Val2 = 200, Extra = 150, Half = true, Time = 200}}},
{Anchor = "L,T", OffX = 406, OffY = 344, Texture = "ITG_ScorePanel_2_Sun.dds",
Cycles = {{Type = "Elipse", Val1 = 325, Val2 = 275, Time = 200}, {Type = "VisibilityTo", Val = 140, Extra = 120, Time = 200}}},
{Anchor = "L,T", OffX = 205, OffY = 180, Texture = "ITG_ScorePanel_2_Pyramids.dds",
Cycles = {}},
{Anchor = "L,T", OffX = 140, OffY = 366, Texture = "ITG_ScorePanel_2_Caravan.dds", 
Cycles = {{Type = "OffX", Val = 550, Time = 80}, {Type = "OffY", Val = 2, Half = true, Time = 10}, {Type = "AddDelay", Val = 80, Delay = {2,8}, Val2 = 80, Time = 80}}},
{Anchor = "L,B", OffX = 0, OffY = 0, Texture = "ITG_ScorePanel_2_Desert.dds",
Cycles = {}},
},
--3
{
{Anchor = "C,T", OffX = 0, OffY = 0, Texture = "ITG_ScorePanel_2_Sun.dds",
InitResize = true, SizeX = 128, SizeY = 75, preDefX = 73, TextureOffY = 37, preDefY = 37,
Cycles = {{Type = "SizeTo", Val = 0.05, Time = 10, Half = true}}},
{Anchor = "L,T", OffX = 0, OffY = 146, Texture = "ITG_ScorePanel_3_Horizon_1.dds",
InitResize = true, SizeX = 900, SizeY = 21, preDefX = 900, preDefY = 21,
Cycles = {{Type = "TexOffsetX", Val = 300, Time = 150}}},
{Anchor = "R,T", OffX = 50, OffY = 68, HalfSize = true, Texture = "ITG_ScorePanel_3_Tree_4.dds",
Cycles = {{Type = "SlimLeft", Stage = 1, Tempo = 2, Scale = 0.5}}},
{Anchor = "R,T", OffX = 150, OffY = 72, HalfSize = true, Texture = "ITG_ScorePanel_3_Tree_2.dds",
Cycles = {{Type = "SlimLeft", Stage = 1, Tempo = 2, Scale = 0.5}}},
{Anchor = "R,T", OffX = 250, OffY = 77, HalfSize = true, Texture = "ITG_ScorePanel_3_Tree_3.dds",
Cycles = {{Type = "SlimLeft", Stage = 1, Tempo = 2, Scale = 0.5}}},
{Anchor = "R,T", OffX = 350, OffY = 67, HalfSize = true, Texture = "ITG_ScorePanel_3_Tree_1.dds",
Cycles = {{Type = "SlimLeft", Stage = 1, Tempo = 2, Scale = 0.5}}},
{Anchor = "R,T", OffX = 450, OffY = 72, HalfSize = true, Texture = "ITG_ScorePanel_3_Tree_2.dds",
Cycles = {{Type = "SlimLeft", Stage = 1, Tempo = 2, Scale = 0.5}}},
{Anchor = "R,T", OffX = 550, OffY = 67, HalfSize = true, Texture = "ITG_ScorePanel_3_Tree_1.dds",
Cycles = {{Type = "SlimLeft", Stage = 1, Tempo = 2, Scale = 0.5}}},
{Anchor = "R,T", OffX = 650, OffY = 77, HalfSize = true, Texture = "ITG_ScorePanel_3_Tree_3.dds",
Cycles = {{Type = "SlimLeft", Stage = 1, Tempo = 2, Scale = 0.5}}},
{Anchor = "R,T", OffX = 750, OffY = 68, HalfSize = true, Texture = "ITG_ScorePanel_3_Tree_4.dds",
Cycles = {{Type = "SlimLeft", Stage = 1, Tempo = 2, Scale = 0.5}}},
{Anchor = "L,T", OffX = 0, OffY = 261, Texture = "ITG_ScorePanel_3_Horizon_2.dds",
InitResize = true, SizeX = 900, SizeY = 25, preDefX = 900, preDefY = 25,
Cycles = {{Type = "TexOffsetX", Val = 600, Time = 100}}},

{Anchor = "R,T", OffX = 800, OffY = 85, Texture = "ITG_ScorePanel_3_Tree_1.dds",
Cycles = {{Type = "SlimLeft", Stage = 1, Tempo = 6}}},
{Anchor = "R,T", OffX = 500, OffY = 95, Texture = "ITG_ScorePanel_3_Tree_2.dds",
Cycles = {{Type = "SlimLeft", Stage = 1, Tempo = 6}}},
{Anchor = "R,T", OffX = 200, OffY = 106, Texture = "ITG_ScorePanel_3_Tree_3.dds",
Cycles = {{Type = "SlimLeft", Stage = 1, Tempo = 6}}},
{Anchor = "R,T", OffX = 0, OffY = 101, TextureOffX = -138, Texture = "ITG_ScorePanel_3_Tree_4.dds",
Cycles = {{Type = "SlimLeft", Stage = 3, Tempo = 6, Wait = 80}}},
{Anchor = "L,T", OffX = 223, OffY = 148, Texture = "ITG_ScorePanel_3_Knight.dds",
Cycles = {{Type = "OffY", Extra = math.random(0,25), Val = 20, Half = true, Time = 30}, {Type = "OffX", Extra = math.random(0,35), Val = 30, Half = true, Time = 40}}},
{Anchor = "L,T", OffX = 457, OffY = 184, Texture = "ITG_ScorePanel_3_Knight.dds",
Cycles = {{Type = "OffY", Extra = math.random(0,25), Val = 20, Half = true, Time = 30}, {Type = "OffX", Extra = math.random(0,35), Val = 30, Half = true, Time = 40}}},
{Anchor = "L,T", OffX = 277, OffY = 302, Texture = "ITG_ScorePanel_3_Knight.dds",
Cycles = {{Type = "OffY", Extra = math.random(0,25), Val = 20, Half = true, Time = 30}, {Type = "OffX", Extra = math.random(0,35), Val = 30, Half = true, Time = 40}}},

},
--4 puzzle
{},
--5 init puzzle
{},
}

function OnUpdate( fDTime )
	local tH = math.floor(gTicks)
    gTicks = gTicks + (fDTime / m_fAnimSeconds);
	local numTicks = math.floor(gTicks) - tH;
    if numTicks == 0 then
		return
	end
--	numTicks = 1; -- bad for some animations based on gTicks and numTicks
	if g_cPanel == 6 then
		if vicBGdata.ForNext then
			vicBGdata.ForNext = vicBGdata.ForNext - 1;
			if vicBGdata.ForNext <= 0 then
				JumpToNextSplashBG()
			end
		else
			vicBGdata.Scale100 = vicBGdata.Scale100 - 1;
			local perc = (vicBGdata.Scale100 / g_InitScaleVBG)
			local fScale = 1 + perc * perc * g_InitSize;
    		cSplashPanel:SetSizeVal( originalSplashX * fScale, originalSplashY * fScale );
			if vicBGdata.Scale100 == 0 then
				vicBGdata.ForNext = g_WaitForNextVBG;
			end
		end
		return;
	elseif g_cPanel == 5 then
		--may require slowing down
		lLoadPuzzleTime = lLoadPuzzleTime - numTicks;
		if lLoadPuzzleTime <= 0 then 
			if #hPieciesOrder == 0 then
				hPieciesOrder = Shuffle({1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16})
			end
			Controls["MiniImage" .. hPieciesOrder[1]]:SetTexture(TabOfPieceNames[math.random(1,#TabOfPieceNames)] .. hPieciesOrder[1] .. ".dds")
			table.remove(hPieciesOrder, 1)
			lLoadPuzzleTime = lLoadPuzzleTime + waitPuzzleTime;
		end
		return;
	elseif g_cPanel == 4 then
		for jthb = 1, numTicks do
			puzzleWait = puzzleWait - 1;
			if puzzleState == 1 then
				if puzzleWait <= 0 then
					puzzleState = 2;
					if math.random(1, 20) == 3 then
						lPoz = {}
						for i = 1, 24 do
							table.insert(lPoz, i)
						end
					else
						lPoz = Shuffle(lPoz);
					end
					for i = 1, 24 do
						table.insert(gPanels[g_cPanel][i].Cycles, {Time = 0, OldX = Controls["GiP" .. i]:GetOffsetX(), OldY = Controls["GiP" .. i]:GetOffsetY(), NewX = 1 + ((lPoz[i] - 1) % 6) * 150, NewY = 1 + math.floor((lPoz[i] - 1) / 6) * 150})
					end
					puzzleWait = puzzleChangeTempo;
				end
			else
				for i, v in pairs(gPanels[g_cPanel]) do
					for d, b in pairs(v.Cycles) do
						local nTime = math.min(puzzleChangeTempo, b.Time + 1);
						Controls["GiP" .. i]:SetOffsetVal((nTime * b.NewX + (puzzleChangeTempo - nTime) * b.OldX) / puzzleChangeTempo, (nTime * b.NewY + (puzzleChangeTempo - nTime) * b.OldY) / puzzleChangeTempo)
						gPanels[g_cPanel][i].Cycles[d].Time = nTime;
					end
				end
				if puzzleWait <= 0 then
					puzzleState = 1;
					puzzleWait = math.random(150, 250);
					for i, v in pairs(gPanels[g_cPanel]) do
						gPanels[g_cPanel][i].Cycles = {}
					end
				end
			end
		end
		return;
	end
	for i, v in pairs(gPanels[g_cPanel]) do
		if v.Delay then
			if v.Delay - numTicks <= 0 then
				gPanels[g_cPanel][i].Delay = nil
			else
				gPanels[g_cPanel][i].Delay = v.Delay - numTicks;
			end
		else
			for d, b in pairs(v.Cycles) do
		--	Controls["GiP" .. i]
				if b.Type == "OffY" then
					Controls["GiP" .. i]:SetOffsetY(v.OffY + GetLinearVal(gTicks + (b.Extra or 0), b.Time, b.Val, b.Half))
				elseif b.Type == "GoY" then
					Controls["GiP" .. i]:SetOffsetY(Controls["GiP" .. i]:GetOffsetY() + math.ceil(numTicks * b.Val / b.Time))
				elseif b.Type == "OffX" then
					Controls["GiP" .. i]:SetOffsetX(v.OffX + GetLinearVal(gTicks + (b.Extra or 0), b.Time, b.Val, b.Half))
				elseif b.Type == "VisibilityTo" then
					Controls["GiP" .. i]:SetHide((gTicks + (b.Extra or 0)) % b.Time > b.Val)
				elseif b.Type == "SizeTo" then
					local sizeMod = 1 + GetLinearValNotRounded(gTicks + (b.Extra or 0), b.Time, b.Val, b.Half)
					Controls["GiP" .. i]:SetSizeX(math.ceil(sizeMod * v.SizeX))
					Controls["GiP" .. i]:SetSizeY(math.ceil(sizeMod * v.SizeY))
				elseif b.Type == "FireInit" then
					if (gTicks + (b.Extra or 0)) % b.Time < (gTicks - numTicks + (b.Extra or 0)) % b.Time then
						v.FuncInit(i, v.RngData)
					end
				elseif b.Type == "AddDelay" then
					gPanels[g_cPanel][i].Cycles[d].Time = gPanels[g_cPanel][i].Cycles[d].Time - numTicks;
					if gPanels[g_cPanel][i].Cycles[d].Time <= 0 then
						gPanels[g_cPanel][i].Delay = math.random(b.Delay[1], b.Delay[2]) * (b.Val2 or 1)
						gPanels[g_cPanel][i].Cycles[d].Time = gPanels[g_cPanel][i].Cycles[d].Val;
					end
				elseif b.Type == "FireSpecial" then
					v.FuncSpecial(i)
				elseif b.Type == "Alpha" then
					Controls["GiP" .. i]:SetAlpha(math.min(1,math.max(0, ((b.Val2 or 100) + GetLinearVal(gTicks + (b.Extra or 0), b.Time, b.Val, b.Half)) / 100)))
				elseif b.Type == "Elipse" then
					local time = 6.28 * ((gTicks + (b.Extra or 0)) % b.Time) / b.Time;
					Controls["GiP" .. i]:SetOffsetX(v.OffX + b.Val1 * math.cos(time))
					Controls["GiP" .. i]:SetOffsetY(v.OffY + b.Val2 * math.sin(time))
				elseif b.Type == "TexOffsetX" then
					Controls["GiP" .. i]:SetTextureOffsetVal((gPanels[g_cPanel][i].TextureOffX or 0) + GetLinearVal(gTicks + (b.Extra or 0), b.Time, b.Val, b.Half), gPanels[g_cPanel][i].TextureOffY or 0)
				elseif b.Type == "SlimLeft" then
					for jhb = 1, numTicks do
						if gPanels[g_cPanel][i].Cycles[d].Stage == 0 then
							gPanels[g_cPanel][i].Cycles[d].toX = math.min(0, gPanels[g_cPanel][i].Cycles[d].toX + b.Tempo / (b.Scale or 1))
							Controls["GiP" .. i]:SetTextureOffsetVal(gPanels[g_cPanel][i].Cycles[d].toX, 0)
							if gPanels[g_cPanel][i].Cycles[d].toX == 0 then
								gPanels[g_cPanel][i].Cycles[d].Stage = 1;
							end
						elseif gPanels[g_cPanel][i].Cycles[d].Stage == 1 then
							local tSizex = Controls["GiP" .. i]:GetSizeX();
							Controls["GiP" .. i]:SetOffsetX(math.min(900 - tSizex,Controls["GiP" .. i]:GetOffsetX() + b.Tempo))
							if Controls["GiP" .. i]:GetOffsetX() == 900 - tSizex then
								gPanels[g_cPanel][i].Cycles[d].Stage = 2;
							end
						elseif gPanels[g_cPanel][i].Cycles[d].Stage == 2 then
							gPanels[g_cPanel][i].Cycles[d].toX = math.min((gPanels[g_cPanel][i].Cycles[d].toX or 0) + b.Tempo / (b.Scale or 1), Controls["GiP" .. i]:GetSizeX() / (b.Scale or 1))
							Controls["GiP" .. i]:SetTextureOffsetVal(gPanels[g_cPanel][i].Cycles[d].toX, 0)
							if gPanels[g_cPanel][i].Cycles[d].toX == Controls["GiP" .. i]:GetSizeX() / (b.Scale or 1) then
								gPanels[g_cPanel][i].Cycles[d].Stage = 3;
								gPanels[g_cPanel][i].Cycles[d].Wait = slimWait3tempo * (b.Scale or 1);
							end
						elseif gPanels[g_cPanel][i].Cycles[d].Stage == 3 then
							gPanels[g_cPanel][i].Cycles[d].Wait = gPanels[g_cPanel][i].Cycles[d].Wait - 1;
							if gPanels[g_cPanel][i].Cycles[d].Wait == 0 then
								gPanels[g_cPanel][i].Cycles[d].Stage = 0;
								gPanels[g_cPanel][i].Cycles[d].toX = -Controls["GiP" .. i]:GetSizeX() / (b.Scale or 1);
								Controls["GiP" .. i]:SetOffsetX(0)
								Controls["GiP" .. i]:SetTextureOffsetVal(gPanels[g_cPanel][i].Cycles[d].toX, 0)
							end
						end
					end
				end 
			end
		end
	end
end

function GetLinearValNotRounded(t, fT, val, bHalf)
	if bHalf then
		return val - math.abs(fT / 2 - t % fT) * val * 2 / (fT - 1)
	else
		return (t % fT) * val / (fT - 1)
	end
end

function GetLinearVal(t, fT, val, bHalf)
	if bHalf then
		return math.floor(val - math.abs(fT / 2 - t % fT) * val * 2 / (fT - 1))
	else
		return math.floor((t % fT) * val / (fT - 1))
	end
end

function DoInitPuzzle()
	local puzzleTexture = puzzleBase[math.random(1,#puzzleBase)]
	gPanels[4] = {}
	for i = 1, 500 do
		if Controls["GiP" .. i] then
			if i <= 24 then
				Controls["GiP" .. i]:UnloadTexture();
				Controls["GiP" .. i]:SetTextureAndResize(puzzleTexture)
				Controls["GiP" .. i]:SetTextureSizeVal(148, 148)
				Controls["GiP" .. i]:SetAnchor("L,T")
				Controls["GiP" .. i]:SetAlpha(1)
				Controls["GiP" .. i]:NormalizeTexture()
				Controls["GiP" .. i]:SetSizeX(148)
				Controls["GiP" .. i]:SetSizeY(148)
				table.insert(gPanels[4], {HelpX = (i - 1) % 6, HelpY = math.floor((i - 1) / 6), Cycles = {}})
				Controls["GiP" .. i]:SetTextureOffsetVal(1 + gPanels[4][i].HelpX * 150, 1 + gPanels[4][i].HelpY * 150)
				Controls["GiP" .. i]:SetOffsetVal(1 + gPanels[4][i].HelpX * 150, 1 + gPanels[4][i].HelpY * 150)
				Controls["GiP" .. i]:SetHide(false)
			else	
				Controls["GiP" .. i]:SetHide(true)
			end
		else
			break;
		end
	end
	puzzleState = 1
	puzzleWait = 300;
end

function InitTheGraphicPanel(cccc)
	g_cPanel = cccc;
	gTicks = 0;
	if g_cPanel == 2 then
		Controls.GiPBG:SetColor({x = 0.5, y = 0.5, z = 0.5, w = 1})
	else
		Controls.GiPBG:SetColor({x = 0, y = 0, z = 0, w = 1})
	end
	Controls.GraphicPanel:SetHide(g_cPanel > 4)
	Controls.ImagePuzzle:SetHide(g_cPanel ~= 5)
	Controls.VBGImageClip:SetHide(true)
	Controls.WonderClip:SetHide(true)
	if g_cPanel == 6 then
		if math.random(1,2) == 1 then
			InitVictoryPanelsData()
		else
			InitWonderPanelsData()
		end
		return;
	elseif g_cPanel == 5 then
	    Controls.ImagePuzzle:SetTexture("ITGLoadScreenBackground.dds");
		for i = 1, 16 do
			Controls["MiniImage" .. i]:SetTexture(TabOfPieceNames[math.random(1,#TabOfPieceNames)] .. i .. ".dds")
		end
		return;
	elseif g_cPanel == 4 then
		DoInitPuzzle()
		return;
	end
	for i = 1, 500 do
		if Controls["GiP" .. i] then
			if gPanels[g_cPanel][i] then
				if gPanels[g_cPanel][i].InitDelayRNG then
					gPanels[g_cPanel][i].Delay = math.random(gPanels[g_cPanel][i].InitDelayRNG[1], gPanels[g_cPanel][i].InitDelayRNG[2])
				end
				Controls["GiP" .. i]:UnloadTexture();
				Controls["GiP" .. i]:SetAlpha(1)
				Controls["GiP" .. i]:SetHide(gPanels[g_cPanel][i].InitHide)
				Controls["GiP" .. i]:SetAnchor(gPanels[g_cPanel][i].Anchor)
				Controls["GiP" .. i]:SetOffsetVal(gPanels[g_cPanel][i].OffX, gPanels[g_cPanel][i].OffY)
				if gPanels[g_cPanel][i].AllCycleExtraRNG then
					local rngExtra = math.random(gPanels[g_cPanel][i].AllCycleExtraRNG[1], gPanels[g_cPanel][i].AllCycleExtraRNG[2])
					for dd, bb in pairs(gPanels[g_cPanel][i].Cycles) do
						gPanels[g_cPanel][i].Cycles[dd].Extra = rngExtra;
					end
				end
				if gPanels[g_cPanel][i].SizeX then

					if gPanels[g_cPanel][i].InitResize then
						Controls["GiP" .. i]:SetTextureAndResize(gPanels[g_cPanel][i].Texture)
					--preDefX and preDefY ??
						if gPanels[g_cPanel][i].preDefX then
							Controls["GiP" .. i]:SetTextureSizeVal(gPanels[g_cPanel][i].preDefX, gPanels[g_cPanel][i].preDefY)
							Controls["GiP" .. i]:NormalizeTexture()
							Controls["GiP" .. i]:SetSizeX(gPanels[g_cPanel][i].preDefX)
							Controls["GiP" .. i]:SetSizeY(gPanels[g_cPanel][i].preDefY)
							Controls["GiP" .. i]:SetTextureOffsetVal(gPanels[g_cPanel][i].TextureOffX or 0, gPanels[g_cPanel][i].TextureOffY or 0)
						else
							Controls["GiP" .. i]:SetTextureAndResize(gPanels[g_cPanel][i].Texture)
							Controls["GiP" .. i]:SetTextureOffsetVal(gPanels[g_cPanel][i].TextureOffX or 0, gPanels[g_cPanel][i].TextureOffY or 0)
						end
						Controls["GiP" .. i]:SetSizeX(gPanels[g_cPanel][i].SizeX)
						Controls["GiP" .. i]:SetSizeY(gPanels[g_cPanel][i].SizeY)
					else
						Controls["GiP" .. i]:SetTextureAndResize(gPanels[g_cPanel][i].Texture)
						Controls["GiP" .. i]:SetSizeX(gPanels[g_cPanel][i].SizeX)
						Controls["GiP" .. i]:SetSizeY(gPanels[g_cPanel][i].SizeY)
						Controls["GiP" .. i]:SetTextureOffsetVal(gPanels[g_cPanel][i].TextureOffX or 0, gPanels[g_cPanel][i].TextureOffY or 0)
					end
				else
					Controls["GiP" .. i]:SetTextureAndResize(gPanels[g_cPanel][i].Texture)
					Controls["GiP" .. i]:SetTextureOffsetVal(gPanels[g_cPanel][i].TextureOffX or 0, gPanels[g_cPanel][i].TextureOffY or 0)
					if gPanels[g_cPanel][i].HalfSize then
						Controls["GiP" .. i]:SetSizeX(math.floor(Controls["GiP" .. i]:GetSizeX() / 2)) 
						Controls["GiP" .. i]:SetSizeY(math.floor(Controls["GiP" .. i]:GetSizeY() / 2)) 
					end
				end
				if gPanels[g_cPanel][i].FuncInit then
					gPanels[g_cPanel][i].FuncInit(i, gPanels[g_cPanel][i].RngData)
				end
			else
				Controls["GiP" .. i]:SetHide(true)
			end
		else
			break;
		end
	end
end

function DoUpdateScoreFull()
	ChooseEraToDisplay(currentEra)
end

function CallSemiPreparedData()
	semiPreparedData = {}
	for i, v in pairs(scEraNames) do
		semiPreparedData[i] = {}
	end
	semiPreparedData[-1] = {}
	local tITT = MUD_Get("VIC_INDEX") or 0;
	for i = 1, tITT do
		table.insert(semiPreparedData[MUD_Get("VIC_SAVE_SC_TYPE_" .. i)], {i, MUD_Get("VIC_SAVE_SCORE_" .. i)})
	end
	for i, v in pairs(scEraNames) do
		table.sort(semiPreparedData[i], SortFunctionForGreaterInteger2)
	end
	table.sort(semiPreparedData[-1], SortFunctionForGreaterInteger2)
end

function SortFunctionForGreaterInteger2(a, b)
	local va = (a ~= nil and a[2] ~= nil) and a[2] or 999;
	local vb = (b ~= nil and b[2] ~= nil) and b[2] or 999;
	return tonumber(va) > tonumber(vb);
end

function DoScrollEraEntry(name, void, bDisabled)
	local controlTable = {};
	Controls.ScoreEraPullDown:BuildEntry( "InstanceOne", controlTable );
	controlTable.Button:SetVoid1(void);
	controlTable.Button:SetText(name);
	controlTable.Button:SetDisabled(bDisabled);
end

function DoScrollTypeEntry(name, void)
	local controlTable = {};
	Controls.ScoreTypePullDown:BuildEntry( "InstanceOne", controlTable );
	controlTable.Button:SetVoid1(void);
	controlTable.Button:SetText(name);
end

function GetPremadeListOfScores(gEra)
	LuaEvents.ITGSG_RequestGT();
	local cdata = MapModData.ITGSG;
	MapModData.ITGSG = nil;
	local tab = {}
	if rankType == 1 then
		if cdata.VictoryPoints.EraData and cdata.VictoryPoints.EraData[gEra] then
		--prehistorical
			for g, h in pairs(cdata.VictoryPoints.EraData[gEra]) do
				table.insert(tab, {Players[g]:GetCivilizationType(), h, Players[g]:GetLeaderType(), Players[g]:IsHuman(), g, cdata.EraData[gEra].Players[g].CultureString})
			end
		elseif cdata.Globals.ScenarioType == gEra then
		--current
			for g, h in pairs(cdata.VictoryPoints.Players) do
				table.insert(tab, {Players[g]:GetCivilizationType(), h.Points, Players[g]:GetLeaderType(), Players[g]:IsHuman(), g, cdata.Players[g].CultureString})
			end
		else
		--full run
			for g, h in pairs(cdata.VictoryPoints.Players) do
				table.insert(tab, {Players[g]:GetCivilizationType(), h.TotalPoints, Players[g]:GetLeaderType(), Players[g]:IsHuman(), g, nil})
			end
		end
	else
		if not semiPreparedData then
			CallSemiPreparedData()
		end
		for ith = 1, 20 do
			if semiPreparedData[gEra][ith] then
				local lt = semiPreparedData[gEra][ith][1]  
				table.insert(tab, {MUD_Get("VIC_SAVE_CIV_" .. lt), semiPreparedData[gEra][ith][2], MUD_Get("VIC_SAVE_LEADER_" .. lt), (MUD_Get("VIC_SAVE_ISHUMAN_" .. lt) == 1), nil, MUD_Get("VIC_SAVE_CULT_TYPE_" .. lt), MUD_Get("VIC_SAVE_MAPSIZE_" .. lt) .. " (" .. MUD_Get("VIC_SAVE_NUMPLAYERS_" .. lt) .. ")", MUD_Get("VIC_SAVE_HANDICAP_" .. lt), MUD_Get("VIC_SAVE_DATE_" .. lt), "v" ..  MUD_Get("VIC_SAVE_MODVERSION_" .. lt) })
			else
				break;
			end
		end
	end
	return tab;
end

function ScoreTypePullDown(gType)
	if gType == 1 then
		Controls.ScoreTypePullDown:GetButton():SetText("Current")
	else
		Controls.ScoreTypePullDown:GetButton():SetText("Top 20")
	end
	rankType = gType;
	ChooseEraToDisplay(lastdoneEra)
end
Controls.ScoreTypePullDown:RegisterSelectionCallback(ScoreTypePullDown); 

function ChooseEraToDisplay(gEra)
	if not scEraNames[gEra] then
		Controls.ScoreEraPullDown:GetButton():SetText("Full Run")
	else
		Controls.ScoreEraPullDown:GetButton():SetText(scEraNames[gEra])
	end
	local listToSort = GetPremadeListOfScores(gEra)
	table.sort(listToSort, SortFunctionForGreaterInteger2)

	lastdoneEra = gEra;
	local ttT = {}
	if gEra == currentEra then
		LuaEvents.ITGSG_RequestVictoryPointsDiploList();
		ttT = MapModData.ITGSG;
		MapModData.ITGSG = nil;
	end
	local bScenario = PreGame.GetLoadWBScenario();
	
	g_LeaderButtonIM:ResetInstances();
	for i, v in pairs(listToSort) do
		local controlTable = g_LeaderButtonIM:GetInstance();
		controlTable.LeaderButton:SetHide(false)

				local civType = v[1];
				local civInfo = GameInfo.Civilizations[civType];
				local strCiv = Locale.ConvertTextKey(civInfo.ShortDescription);
				
				local otherLeaderType = v[3];
				local otherLeaderInfo = GameInfo.Leaders[otherLeaderType];
				controlTable.LeaderName:SetText( Locale.Lookup(otherLeaderInfo.Description) );
				if v[4] then
					controlTable.CivName:SetText(strCiv);
				else
					controlTable.CivName:SetText(strCiv .. " (AI)");
				end
				IconHookup( civInfo.PortraitIndex, 32, civInfo.IconAtlas, controlTable.CivIcon );
				
				IconHookup( otherLeaderInfo.PortraitIndex, 64, otherLeaderInfo.IconAtlas, controlTable.LeaderPortrait );			

				controlTable.Score:SetText( v[2] );
				if v[5] and ttT[v[5]] then
					controlTable.Score:SetToolTipString(ttT[v[5]][2]);
				else
					controlTable.Score:SetToolTipString("");
				end
				controlTable.Place:SetText(i .. ".")
				if v[6] and (gEra ~= -1) then
					controlTable.CulturalType:SetHide(false)
					controlTable.CulturalType:SetText(v[6])
				else
					controlTable.CulturalType:SetHide(true)
				end
				for ith, str in pairs({"MapInfo", "HandicapInfo", "DateInfo", "VersionInfo"}) do
					if v[ith + 6] then
						controlTable[str]:SetHide(false)
						controlTable[str]:SetText(v[ith + 6])
					else
						controlTable[str]:SetHide(true)
					end
				end
				controlTable.StatusStack:CalculateSize();
				controlTable.StatusStack:ReprocessAnchoring();

				controlTable.LeaderButton:SetSizeY(math.max(controlTable.StatusStack:GetSizeY() + 10, 58))
				controlTable.Anim1:SetSizeY(math.max(controlTable.StatusStack:GetSizeY() + 7, 51))
				controlTable.Anim2:SetSizeY(math.max(controlTable.StatusStack:GetSizeY() + 7, 51))
		--civ name
		--score
		--civ leader
		--human/ai
		--playerID
		--culturalType
		--numplayers / mapsize
		--handicap
		--date
		--version
		--
	end
	Controls.MajorStack:CalculateSize();
	Controls.ScoreStack:CalculateSize();
	Controls.ScrollPanel:CalculateInternalSize();
	Controls.ScrollPanel:ReprocessAnchoring();
end
Controls.ScoreEraPullDown:RegisterSelectionCallback(ChooseEraToDisplay); 

function GetProperYOffset(y, y2)
	local c = y - 80 - y2;
	if c > Controls.BestScoreGrid:GetSizeY() then
		c = Controls.BestScoreGrid:GetSizeY() + (c - Controls.BestScoreGrid:GetSizeY()) / 2;
	end
	return c;
end

function PrepareOneTimeStuffScore(gType)
	LuaEvents.ITGSG_RequestGT();
	local cdata = MapModData.ITGSG;
	MapModData.ITGSG = nil;
	currentEra = gType;
	Controls.ScoreEraPullDown:ClearEntries();
	local bDisabledFull = false;
	for i, v in pairs({3, 2, 1, 4, 5}) do
		if v == gType or (cdata.EraData and cdata.EraData[v]) then
			DoScrollEraEntry(scEraNames[v], v, false)
		else
			DoScrollEraEntry(scEraNames[v], v, true)
			bDisabledFull = true;
		end
	end
	local screenSizeX, screenSizeY = UIManager:GetScreenSizeVal()
	Controls.ScrollPanel:SetSizeY(screenSizeY - 80)
	Controls.VT1:SetOffsetVal(15 + Controls.ScrollPanel:GetSizeX(), 30)
	Controls.Shadow:SetSizeX(25 + Controls.ScrollPanel:GetSizeX())
	Controls.VT1:SetSizeY(screenSizeY - 70)
	DoScrollEraEntry("Full Run", -1, bDisabledFull)
	Controls.ScoreEraPullDown:CalculateInternals();

	Controls.ScoreTypePullDown:ClearEntries();
	DoScrollTypeEntry("Current", 1)
	DoScrollTypeEntry("Top 20", 2)
	rankType = 1;
	Controls.ScoreTypePullDown:CalculateInternals();
	Controls.ScoreTypePullDown:GetButton():SetText("Current")

	local pOne, pTwo, pOneAI, pTwoAI;
	local pScoreOne, pScoreTwo = 0, 0;
	local pScoreOneAI, pScoreTwoAI = 0, 0;
	for g, h in pairs(cdata.VictoryPoints.Players) do
		if Players[g]:IsHuman() then
			if h.Points > pScoreOne then
				pScoreOne = h.Points;
				pOne = g;
			end
			if h.TotalPoints > pScoreTwo then
				pScoreTwo = h.TotalPoints;
				pTwo = g;
			end
		else
			if h.Points > pScoreOneAI then
				pScoreOneAI = h.Points;
				pOneAI = g;
			end
			if h.TotalPoints > pScoreTwoAI then
				pScoreTwoAI = h.TotalPoints;
				pTwoAI = g;
			end
		end
	end
	if not pOne then
		pOne = pOneAI;
	end
	Controls.BestScoreCiv1:SetText(Players[pOne]:GetName())
	Controls.BestScoreText1:SetText(cdata.VictoryPoints.Players[pOne].Points)
	local pLeaderType1 = GameInfo.Leaders[Players[pOne]:GetLeaderType()];
	IconHookup( pLeaderType1.PortraitIndex, 64, pLeaderType1.IconAtlas, Controls.BestLeaderPortrait1 );
	if not pTwo then
		pTwo = pTwoAI
	end
	local extraYbs = 51; --51;
	if bDisabledFull then
		extraYbs = 0;
	else
		Controls.BestScoreCiv2:SetText(Players[pTwo]:GetName())
		Controls.BestScoreText2:SetText(cdata.VictoryPoints.Players[pTwo].TotalPoints)
		local pLeaderType2 = GameInfo.Leaders[Players[pTwo]:GetLeaderType()];
		IconHookup( pLeaderType2.PortraitIndex, 64, pLeaderType2.IconAtlas, Controls.BestLeaderPortrait2 );			
	end
	Controls.BestScoreGrid:SetSizeY(159 + extraYbs)
	Controls.HID2:SetSizeY(72 + extraYbs)
	Controls.HID6:SetHide(extraYbs ~= 0)
	Controls.HID7:SetHide(extraYbs ~= 0)
	Controls.HID8:SetHide(extraYbs == 0)
	Controls.HID9:SetHide(extraYbs == 0)
	Controls.ModsButton2:SetHide(extraYbs == 0)
	Controls.GraphicPanel:SetOffsetVal(math.max(10, (screenSizeX + Controls.ScrollPanel:GetSizeX() + 10 - Controls.GraphicPanel:GetSizeX()) / 2), 50 + math.max(0, GetProperYOffset(screenSizeY, Controls.GraphicPanel:GetSizeY())))
	Controls.ImagePuzzle:SetOffsetVal(math.max(10, (screenSizeX + Controls.ScrollPanel:GetSizeX() + 10 - Controls.ImagePuzzle:GetSizeX()) / 2), 50 + math.max(0, GetProperYOffset(screenSizeY, Controls.ImagePuzzle:GetSizeY())))
	Controls.VBGImageClip:SetOffsetVal(math.max(10, (screenSizeX + Controls.ScrollPanel:GetSizeX() + 10 - Controls.VBGImageClip:GetSizeX()) / 2), 50 + math.max(0, GetProperYOffset(screenSizeY, Controls.VBGImageClip:GetSizeY())))
	Controls.WonderClip:SetOffsetVal(math.max(10, (screenSizeX + Controls.ScrollPanel:GetSizeX() + 10 - Controls.WonderClip:GetSizeX()) / 2), 50 + math.max(0, GetProperYOffset(screenSizeY, Controls.WonderClip:GetSizeY())))
	Controls.BestScoreGrid:SetOffsetVal(10 + Controls.ScrollPanel:GetSizeX() / 2, math.max(50, Controls.GraphicPanel:GetOffsetY() - Controls.BestScoreGrid:GetSizeY() - 50)) 
	
	gTicks = 0;
	if math.random(1,100) <= 25 then
		InitTheGraphicPanel(6)
	elseif math.random(1,75) <= 40 then
		InitTheGraphicPanel(5)
	elseif math.random(1, #puzzleBase + #gPanels) < #puzzleBase then
		InitTheGraphicPanel(4)
	else
		InitTheGraphicPanel(math.random(1,#gPanels))
	end
	ChooseEraToDisplay(gType)
end
LuaEvents.ITGLHInitAll.Add(PrepareOneTimeStuffScore)

function ShowHideHandler( bIsHide, bInitState )
    if( not bInitState ) then
		if( not bIsHide ) then
    		DoUpdateScoreFull();
			ContextPtr:SetUpdate( OnUpdate );
		else
			ContextPtr:ClearUpdate();
		end
	end
end
ContextPtr:SetShowHideHandler( ShowHideHandler );
