function GetVotesFromResolution34(leagueID)
	local tab = {}
	local tt = {{}, {}, {}, {}, {}}
	for g, s in pairs(gT.Leagues[leagueID].Members) do
		if not Players[g]:IsMinorCiv() then
			tab[g] = 0;
			table.insert(tt[1], {g, GetAverageValueFromCID(g, "Health")})
			table.insert(tt[2], {g, GetAverageValueFromCID(g, "HealthLevel")})
			table.insert(tt[3], {g, GetBestValueFromCID(g, "Health")})
			table.insert(tt[4], {g, GetBestValueFromCID(g, "HealthLevel")})
			table.insert(tt[5], {g, GetWorstValueFromCID(g, "Health")})
		end
	end
	for i = 1, 5 do
		table.sort(tt[i], SortFunctionForGreaterInteger2);
		if tt[i][1][2] ~= tt[i][2][2] then
			tab[tt[i][1][1]] = tab[tt[i][1][1]] + 1;
		end
	end
	return tab;
end

function LinkGetAIValueResolution11(iPlayer, leagueID, extrainfo1, bRenact, resID)
	local balance = 50;
	if gT.Globals.LastTurn - GetITGGameTurn() > 20 then
		if gT.Players[iPlayer].Morale > 15 then
			-- great source of votes;
			balance = balance + 50;
		elseif gT.Players[iPlayer].Morale < 0 then
			if Teams[Players[iPlayer]:GetTeam()]:GetAtWarCount(true) > 0 then
				balance = balance + 15;
			else
				balance = balance - 35;
			end
		else
			if bRenact then
				local bS = 5;
				if gT.Leagues[leagueID].Members[iPlayer].VotesFromResolution[GetInfoFromTabOfProposal(resID, "Name")] then
					balance = balance - 2 * bS + bS * gT.Leagues[leagueID].Members[iPlayer].VotesFromResolution[GetInfoFromTabOfProposal(resID, "Name")];
				end
			else
				if Teams[Players[iPlayer]:GetTeam()]:GetAtWarCount(true) > 0 then
					balance = balance + 5;
				else
					balance = balance - 20 + 3 * gT.Players[iPlayer].Morale
				end
			end
		end
	end
	return balance + LastRandom(-3, 3);
end

function LinkGetAIValueResolution12(iPlayer, leagueID, extrainfo1, bRenact, resID)
	local balance = 50;
	if bRenact then
		local bS = 5;
		if gT.Leagues[leagueID].Members[iPlayer].VotesFromResolution[GetInfoFromTabOfProposal(resID, "Name")] then
			balance = balance - 2 * bS + bS * gT.Leagues[leagueID].Members[iPlayer].VotesFromResolution[GetInfoFromTabOfProposal(resID, "Name")];
		end
		if Teams[Players[iPlayer]:GetTeam()]:GetAtWarCount(true) == 0 then
			balance = balance - 30;
		end
	else
		balance = balance - 10 + math.min(30, 10 * Teams[Players[iPlayer]:GetTeam()]:GetAtWarCount(true))
		if gT.Globals.LastTurn - GetITGGameTurn() > 80 then
			balance = balance + 5;
		end
	end
	return balance + LastRandom(-5, 5);
end

function LinkGetAIValueResolution10(iPlayer, leagueID, extrainfo1, bRenact, resID)
	local balance = 50;
	local bHasTech = Teams[Players[iPlayer]:GetTeam()]:IsHasTech(GameInfoTypes.TECH_ITG_WATER_ALL_PASSAGE);
	local numothers = 0;
	for member, sth in pairs(gT.Leagues[leagueID].Members) do
		if member ~= iPlayer then
			if Teams[Players[member]:GetTeam()]:IsHasTech(GameInfoTypes.TECH_ITG_WATER_ALL_PASSAGE) then
				numothers = numothers + 1;
			end
		end
	end
	if bRenact then
		local bS = 7;
		if gT.Leagues[leagueID].Members[iPlayer].VotesFromResolution[GetInfoFromTabOfProposal(resID, "Name")] then
			balance = balance - 2 * bS + bS * gT.Leagues[leagueID].Members[iPlayer].VotesFromResolution[GetInfoFromTabOfProposal(resID, "Name")];
		end
	else
		if bHasTech then
			balance = balance + 3;
			if numothers == 0 then
				balance = balance + 40;
			end
		elseif numothers > 0 then
			balance = balance - LastRandom(35, 50);
		else
			balance = balance + 5;
		end
	end
	if gT.Globals.LastTurn - GetITGGameTurn() > 80 then
		balance = balance + 5;
	end
	return balance + LastRandom(-5, 5);
end
function LinkGetAIValueResolution9(iPlayer, leagueID, extrainfo1, bRenact, resID)
	local balance = 50;
	balance = balance - gT.Players[iPlayer].AverageHappiness;
	balance = balance - 30 + 5 * GetAIFlavour(iPlayer, "FLAVOR_HAPPINESS");
	balance = balance + math.abs(GetNumOwnResourcesLuxury(iPlayer, true) - 5)
	return balance + LastRandom(-10, 10);
end
function LinkGetAIValueResolution7(iPlayer, leagueID, extrainfo1, bRenact, resID)
	local balance = 50;
	if HasMintAnyCity(iPlayer) then
		balance = balance + 4 * GetAIFlavour(iPlayer, "FLAVOR_GOLD");
	else
		balance = balance - 30;
	end
	return balance + LastRandom(-10, 10);
end