local TabOfProposals;

function ToPFuncName2(extraInfo1)
	return "Invite " .. Players[extraInfo1]:GetCivilizationShortDescription();
end
function ToPFuncName58(extraInfo1, leagueID)
	local nameone = Players[gT.Leagues[leagueID].EndWarTable[extraInfo1][1]]:GetCivilizationAdjective();
	local nametwo = Players[gT.Leagues[leagueID].EndWarTable[extraInfo1][2]]:GetCivilizationAdjective();
	return "End " .. nameone .. "-" .. nametwo .. " War";
end
function ELFTopFunc58(leagueID, iPlayer, ID)
	local hTab = {}
	for str, ideo in pairs(gT.Leagues[leagueID].EndWarTable) do
		table.insert(hTab, {Name = TabOfProposals[ID].FuncName(str, leagueID), ExtraInfo = str})
	end
	return hTab;
end
function ToPFuncName50(extraInfo1, leagueID)
	if extraInfo1 then
		return "Support " .. GetIdeoNameString(extraInfo1);
	else
		return "Global Ideology";
	end
end

function ToPFuncName42(extrainfo1)
	if gT.Leagues[extrainfo1] then
		return "Total War: " .. gT.Leagues[extrainfo1].Name
	else
		return "Total War: " .. Players[extrainfo1]:GetCivilizationShortDescription()
	end
end
function ToPFuncName44(extrainfo1)
	return Locale.Lookup(GameInfo.UnitClasses[extrainfo1].Description or "") .. " Tournament"
end
function LeagueHelpFuncITG42(extrainfo1)
	if not extrainfo1 then
		return "All members will enter permanent war against a chosen foe."
	end
	if gT.Leagues[extrainfo1] then
		local gH = ""
		local iUnknown = 0;
		for member, sth in pairs(gT.Leagues[extrainfo1].Members) do
			if Teams[Game.GetActiveTeam()]:IsHasMet(Players[member]:GetTeam()) then
				if gH == "" then
					gH = Players[member]:GetCivilizationShortDescription()
				else
					gH = gH .. ", " .. Players[member]:GetCivilizationShortDescription()
				end
			else
				iUnknown = iUnknown + 1;
			end
		end
		if iUnknown > 0 then
			if iUnknown == 1 then
				gH = gH .. ", unknown player"
			else
				gH = gH .. ", " .. iUnknown .. " unknown players"
			end
		end
		return "All members will enter permanent war against " .. gT.Leagues[extrainfo1].Name .. " (" .. gH .. ")."
	else
		return "All members will enter permanent war against " .. Players[extrainfo1]:GetCivilizationAdjective() .. " Empire."
	end
end 
function ToPFuncName31(extraInfo1)
	return "Common Foe: " .. Players[extraInfo1]:GetCivilizationShortDescription();
end
function ToPFuncName32(extraInfo1, tot)
	return "Share Influence: " .. Players[extraInfo1]:GetName() .. " (+" .. tot .. "[ICON_INFLUENCE])";
end
function ELFTopFunc2(leagueID, iPlayer, ID)
	local hTab = {}
	local bCanMajorInvite = true;
	for g, gdd in pairs(gT.Players) do
		if gdd.InvitationsLeague[leagueID] then
			if Players[iPlayer]:IsAlive() then
				if not Players[iPlayer]:IsMinorCiv() then
					bCanMajorInvite = false;
					break;
				end
			else
				gT.Players[g].InvitationsLeague[leagueID] = nil;
				local hString = "2x" .. g;
				gT.Leagues[leagueID].Resolutions[hString] = nil;
			end
		end
	end
	if bCanMajorInvite then
		for a, b in pairs(gT.Leagues[leagueID].Proposals) do
			if (b.ResolutionID == 2) and (not Players[b.ExtraInfo]:IsMinorCiv()) then
				bCanMajorInvite = false;
				break;
			end
		end
	end
	for g, gpdata in pairs(gT.Players) do
		if not gT.Leagues[leagueID].Members[g] then
			if not gpdata.DeniedInvitationsLeague[leagueID] then
				if Players[g]:IsMinorCiv() then
					if Players[g]:GetAlly() == iPlayer and Players[g]:IsAlive() then
						table.insert(hTab, {Name = TabOfProposals[ID].FuncName(g), ExtraInfo = g, MainIcon = TabOfProposals[ID].MainIconFunc(g)})
					end
				elseif bCanMajorInvite then
					if CanBeInvitedToTheLeague(leagueID, g) then
						if not gpdata.InvitationsLeague[leagueID] then
							table.insert(hTab, {Name = TabOfProposals[ID].FuncName(g), ExtraInfo = g, MainIcon = TabOfProposals[ID].MainIconFunc(g)})
						end
					end
				end
			end
		end
	end
	return hTab;
end

function ELFTopFunc42(leagueID, iPlayer, ID)
	local hTab = {}
	if gT.Leagues[leagueID].SpecialProposalTag == "LoN" then
		for g, gpdata in pairs(gT.Players) do
			if gpdata.UniqueNumConquered >= 8 then
				if not Players[g]:IsMinorCiv() then
					if g ~= iPlayer then
						if GetNumOccupiedCities(g) >= 4 then
							table.insert(hTab, {Name = TabOfProposals[ID].FuncName(g), ExtraInfo = g, MainIcon = TabOfProposals[ID].MainIconFunc(g), Tooltip = LeagueHelpFuncITG42(g)})
						end
					end
				end
			end
		end
	elseif gT.Leagues[leagueID].SpecialProposalTag == "ancientL" then
		for g, gpdata in pairs(gT.Players) do
			if gpdata.CultureType == 7 then
				if (not iPlayer) or Teams[Players[g]:GetTeam()]:IsHasMet(Players[iPlayer]:GetTeam()) then
					table.insert(hTab, {Name = TabOfProposals[ID].FuncName(g), ExtraInfo = g, MainIcon = TabOfProposals[ID].MainIconFunc(g), Tooltip = LeagueHelpFuncITG42(g)})
				end
			end
		end
		for l, s in pairs(gT.Leagues) do
			if l ~= leagueID then
				if s.SpecialProposalTag == "ancientL" then
					if (not iPlayer) or KnowAnyoneInLeague(iPlayer, l) then
						if not s.Resolutions[42 .. "x" .. leagueID] then -- [[disable mirror]]
							table.insert(hTab, {Name = TabOfProposals[ID].FuncName(l), ExtraInfo = l, Tooltip = LeagueHelpFuncITG42(l)})
						end
					end
				end
			end
		end
	end
	return hTab;
end
function ELFTopFunc44(leagueID, iPlayer, ID)
	local hTab = {}
	if iPlayer then
		for iclass, sth in pairs(gT.Players[iPlayer].UnitClassXP) do
			local itype = Players[iPlayer]:GetPlayerUniqueUnit(iclass);
			if itype ~= -1 then
				if GameInfo.Units[itype].Domain == "DOMAIN_LAND" then
					if Players[iPlayer]:GetUnitClassCount(iclass) > 0 then
						table.insert(hTab, {Name = TabOfProposals[ID].FuncName(iclass), ExtraInfo = iclass})
					end
				end
			end
		end
	end
	return hTab;
end
function ELFTopFunc31(leagueID, iPlayer, ID)
	local pTeam = Teams[Players[iPlayer]:GetTeam()];
	local hTab = {}
	for g, s in pairs(gT.Players) do
		if (not Players[g]:IsMinorCiv()) and (Players[g]:GetNumCities() > 0) then
			if pTeam:IsAtWar(Players[g]:GetTeam()) then
				local gf = false;
				for member, s in pairs(gT.Leagues[leagueID].Members) do
					if member ~= iPlayer then
						if not Players[member]:IsMinorCiv() then
							if not Teams[Players[g]:GetTeam()]:IsAtWar(Players[member]:GetTeam()) then
								if not Players[g]:IsDoF(member) then
									if Teams[Players[member]:GetTeam()]:CanDeclareWar(Players[g]:GetTeam()) then
										gf = true;
										break;
									end
								end
							end
						end
					end
				end
				if gf then
					table.insert(hTab, {Name = TabOfProposals[ID].FuncName(g), ExtraInfo = g, MainIcon = TabOfProposals[ID].MainIconFunc(g)})
				end
			end
		end
	end
	return hTab;
end
function ELFTopFunc32(leagueID, iPlayer, ID)
	local hTab = {}
	for g, s in pairs(gT.Players) do
		if Players[g]:IsMinorCiv() and Players[g]:IsAlive() then
			if not gT.Leagues[leagueID].Members[Players[g]:GetAlly()] then
				local inf = Players[g]:GetMinorCivFriendshipWithMajor(iPlayer)
				local gf = true;
				local tot = 0;
				for member, s in pairs(gT.Leagues[leagueID].Members) do
					if member ~= iPlayer then
						if not Players[member]:IsMinorCiv() then
							local bb = Players[g]:GetMinorCivFriendshipWithMajor(member)
							if bb >= inf then
								gf = false;
								break;
							elseif bb > 0 then
								tot = tot + bb;
							end
						end
					end
				end
				if gf and (tot > 0) then
					table.insert(hTab, {Name = TabOfProposals[ID].FuncName(g, tot), ExtraInfo = g})
				end
			end
		end
	end
	return hTab;
end
function ELFTopFunc16(leagueID, iPlayer, ID)
	local hTab = {}
	for i, city in pairs(GetCityTargetsOfCrusade(iPlayer)) do
		table.insert(hTab, {Name = city:GetName(), ExtraInfo = city:Plot():GetPlotIndex(), Tooltip = "Choose possible targets for next Crusade."})
	end
	return hTab;
end
function GetFuncAnswersProp60(aTab)
	local tab = {}
	local hV = ELFTopFunc60();
	for i, s in pairs(aTab) do
		table.insert(tab, {s, hV[s].Name, hV[s].Tooltip})
	end
	return tab;
end
function ELFTopFunc60(leagueID, iPlayer, ID)
	return {
	{Name = "Research", ExtraInfo = 1, Tooltip = "+1000 [ICON_RESEARCH] Science."},
	{Name = "Training", ExtraInfo = 2, Tooltip = "Free Promotion."},
	{Name = "Hearing", ExtraInfo = 3, Tooltip = "+3 [ICON_ITG_LEGAL_POWER] Legal Power."},
	{Name = "Closed Borders", ExtraInfo = 4, Tooltip = "Great People will neither migrate nor progress their [ICON_TOURISM] migration meters in next 5 turns."},
	{Name = "Defense", ExtraInfo = 5, Tooltip = "All Cities gain +6 [ICON_STRENGTH] Defense."},
	{Name = "Trade", ExtraInfo = 6, Tooltip = "+50 [ICON_CARAVAN] Land and [ICON_CARGO] Naval Trade Route points in all Cities."},
	{Name = "Expansion", ExtraInfo = 7, Tooltip = "Gain +60 [ICON_INFLUENCE] Influence within random City-State."},
	{Name = "Solution", ExtraInfo = 8, Tooltip = "One mechanical unit class will become 25 [ICON_PRODUCTION] Production cheaper to construct."},
	{Name = "Art", ExtraInfo = 9, Tooltip = "+800 [ICON_GREAT_ARTIST] Art points and +1 [ICON_GREAT_WORK] Great Work."},
	{Name = "Serenity", ExtraInfo = 10, Tooltip = "Cities will not [ICON_RESISTANCE] Riot in next 7 turns."},
	{Name = "Redistribution", ExtraInfo = 11, Tooltip = "+1 [ICON_RES_OIL] Oil, [ICON_RES_COAL] Coal and [ICON_RES_URANIUM] Uranium."},
	{Name = "Virtues", ExtraInfo = 12, Tooltip = "Boosts [ICON_ITG_MERITOCRACY] Meritocracy by 20."},
	{Name = "Supply", ExtraInfo = 13, Tooltip = "+2 [ICON_ITG_SUPPLY] Unit Supply."},
	}
end
function ELFTopFunc20(leagueID, iPlayer, ID)
	local iRel = Players[iPlayer]:GetReligionCreatedByPlayer()
	local cBeliefs = Game.GetBeliefsInReligion(iRel);
	local hTab = {}
	for i, beliefType in pairs(cBeliefs) do
		if GetNewBeliefForReformation(beliefType, iPlayer, cBeliefs, 0) then
			table.insert(hTab, {Name = Locale.Lookup(GameInfo.Beliefs[beliefType].ShortDescription), ExtraInfo = beliefType, Tooltip = Locale.Lookup(GameInfo.Beliefs[beliefType].Description)})
		end
	end
	return hTab;
end
function UCDCFuncCant4(iPlayer, leagueID, idR, type)
	if DBScenario.WonderCultureGroup then
		return true;
	end
	return (gT.Globals.ScenarioType == 5);
end
function UCDCFuncCant3(iPlayer, leagueID, idR, type)
	return (gT.Globals.ScenarioType == 5);
end
function UCDCFuncCant10(iPlayer, leagueID, idR, type)
	if gT.Globals.ScenarioType == 5 then
		return true;
	end
	if gT.Globals.ScenarioType == 4 then
		return true;
	end
	return false;
end
function UCDCFuncCant7(iPlayer, leagueID, idR, type)
	if not iPlayer then
		for member, sth in pairs(gT.Leagues[leagueID].Members) do
			if not HasMintAnyCity(member) then
				return true;
			end
		end
		return false;
	end
	return (not HasMintAnyCity(iPlayer));
end
function UCDCFuncCant29(iPlayer, leagueID, idR, type)
	local cGold = GetGoldLegalFromActionLeague(leagueID, 20);
	if cGold == -1 then
		return true;
	end
	for member, s in pairs(gT.Leagues[leagueID].Members) do
		if (member ~= iPlayer) and (not Players[member]:IsMinorCiv()) then
			if Players[member]:GetGold() < cGold then
				return true;
			end
		end
	end
	return false;
end
function UCDCFuncCant30(iPlayer, leagueID, idR, type)
	local cGold = GetGoldLegalFromActionLeague(leagueID, 15);
	if cGold == -1 then
		return true;
	end
	for member, s in pairs(gT.Leagues[leagueID].Members) do
		if (member ~= iPlayer) and (not Players[member]:IsMinorCiv()) then
			if GetTotalLegalPercentAvailable(member) < cGold then
				return true;
			end
		end
	end
	return false;
end
function UCDCFuncCant64(iPlayer, leagueID, idR, type)
	if not gT.Players[iPlayer].HasCodex then
		return true;
	end
	if HasAtLeastXLawsToBeChanged(iPlayer, leagueID, 3) then
		return false;
	end
	return true;
end
function UCDCFuncCant33(iPlayer, leagueID, idR, type)
	local gNApp = GetNGWFromActionLeague(leagueID);
	for member, s in pairs(gT.Leagues[leagueID].Members) do
		if (member ~= iPlayer) and (not Players[member]:IsMinorCiv()) then
			if gT.Players[member].NumGreatWorks < gNApp then
				return true;
			end
		end
	end
	return false;
end
function UCDCFuncCant40(iPlayer, leagueID, idR, type)
	if #gT.Globals.ValidWondersForRace < 5 then
		return true;
	end
	return false;
end
function UCDCFuncCant43(iPlayer, leagueID, idR, type)
	if gT.Globals.OlympicGamesProposed then
		return true;
	end
	return false;
end
function ToPMainIconFunc2(extraInfo1)
	if gT.Leagues[extrainfo1] then
		return nil;
	end
	local civID = Players[extraInfo1]:GetCivilizationType();
	return {IconAtlas = GameInfo.Civilizations[civID].IconAtlas, PortraitIndex = GameInfo.Civilizations[civID].PortraitIndex}
end
function ToPLeagueMilitaryMight(iMember)
	return Players[iMember]:GetMilitaryMight()
end
function ToPLeagueNumAllies(iMember)
	local c = 0;
	for g, gdata in pairs(gT.Players) do
		if Players[g]:IsMinorCiv() then
			if Players[g]:GetAlly() == iMember then
				if Players[g]:IsAlive() then
					c = c + 1;
				end
			end
		end
	end
	return c;
end
function ToPLeagueNumWonders(iMember)
	local c = 0;
	for wonder, sth in pairs(gT.Players[iMember].HasPlayerWonder) do
		c = c + 1;
	end
	return c;
end
function ToPLeagueShareXP(leagueID, idR)
	LinkToPLeagueShareXP(leagueID, idR)
end
function ToPDoSolvePoority(leagueID, idR)
	LinkDoSolvePoority(leagueID)
end
function ToPDoGlobalCulture(leagueID, idR)
	LinkDoGlobalization(leagueID)
end
function ToPDoLegalizeConquest(leagueID, idR)
	local oTab = {} -- shuffle players
	for g, h in pairs(gT.Leagues[leagueID].Members) do
		table.insert(oTab, g);
	end
	oTab = Shuffle(oTab)
	for i, g in pairs(oTab) do
		local valTab = {}
		for iCity in Players[g]:Cities() do
			local pOrigin = iCity:GetOriginalOwner();
			if pOrigin ~= g and (gT.Leagues[leagueID].Members[pOrigin]) then
				if Players[pOrigin]:IsMinorCiv() or (GetNumLegalCities(pOrigin) > 1) then
					table.insert(valTab, iCity:GetID())
				end
			end
		end
		if #valTab > 0 then
			LinkPlayerDoClaimConqueredCity(g, valTab[LastRandom(1,#valTab)]);
		end
	end
end
function ToPDoStartOpenTrade(leagueID, idR)
	ChangeLeagueOpenTradeCount(leagueID, 1)
end
function ToPDoRemoveOpenTrade(bPlayer, leagueID)
	for j, c in pairs(gT.Leagues[leagueID].Members) do
		if bPlayer ~= j then
			gT.Players[bPlayer].OpenTrade[j] = (gT.Players[bPlayer].OpenTrade[j] or 0) - 1;
			gT.Players[j].OpenTrade[bPlayer] = (gT.Players[j].OpenTrade[bPlayer] or 0) - 1;
		end
	end
end
function ChangeLeagueOpenTradeCount(leagueID, count)
	for g, h in pairs(gT.Leagues[leagueID].Members) do
		for j, c in pairs(gT.Leagues[leagueID].Members) do
			if g ~= j then
				gT.Players[g].OpenTrade[j] = (gT.Players[g].OpenTrade[j] or 0) + count;
			end
		end
	end
end
function ToPLeagueRemoveOpenTrade(leagueID)
	ChangeLeagueOpenTradeCount(leagueID, -1)
end
function ToPDoDemilitiarization(leagueID, idR)
	LinkDoDemilitiarization(leagueID)
end
function ToPDoCondemnEspionage(leagueID, idR)
	for member, s in pairs(gT.Leagues[leagueID].Members) do
		if not Players[member]:IsMinorCiv() then
			gT.Players[member].CondemnEspionage = gT.Players[member].CondemnEspionage + 1
		end
	end
end
function ToPDoSupportIdeology(leagueID, extraInfo)
	LinkDoSupportIdeology(leagueID, extraInfo)
end
function ToPForcePeace(leagueID, extraInfo)
	LinkDoForcePeace(leagueID, extraInfo)
end
function ToPDoDenounceWarmongering(leagueID)
	LinkDoDenounceWarmongering(leagueID)
end
function ToPDoHealthOrganization(leagueID, idR)
	DoInitHealthOrganization(leagueID)
end
function ToPShareMapsInLeague(leagueID, idR)
	LinkToPShareMapsInLeague(leagueID, idR)
end
function DoShareOneTechWithinLeague(leagueID)
	DoHelpShareTechLeague(leagueID)
end
function DoInitPantheonBeliefsHarmony(leagueID)
	DoPantheonBeliefsHarmony(leagueID)
end
function DoStartOlympiada(leagueID)
	DoBeginOlympiada(leagueID)
end
function DoInitCityStatesFree(leagueID)
	DoCityStatesFreeLeague(leagueID)
end
function DoTotalWarLeague(leagueID, extraInfo)
	DoDeclareTotalWarLeague(leagueID, extraInfo)
end
function ToPLeagueRemoveTotalWar(leagueID, enemy)
	local tab ={}
	if gT.Leagues[enemy] then
		for member, sth in pairs(gT.Leagues[enemy].Members) do
			table.insert(tab, member)
		end
	else
		table.insert(tab, enemy)
	end
	for member, j in pairs(gT.Leagues[leagueID].Members) do
		for i, pEnemy in pairs(tab) do
			if member ~= pEnemy then
				ChangePeaceWarLock(member, pEnemy, -1, "TotalWar")
			end
		end
	end
end
function ToPLeagueLegitimacyORR(leagueID)
	for member, sth in pairs(gT.Leagues[leagueID].Members) do
		if not Players[member]:IsMinorCiv() then
			gT.Players[member].CodexInfluenceFromLeague = gT.Players[member].CodexInfluenceFromLeague - CODEX_INFLUENCE_FROM_LEAGUE_RES
		end
	end
end
function ToPLeagueLegitimacyOG(member, leagueID)
	if not Players[member]:IsMinorCiv() then
		gT.Players[member].CodexInfluenceFromLeague = gT.Players[member].CodexInfluenceFromLeague - CODEX_INFLUENCE_FROM_LEAGUE_RES
	end
end
function ToPLeagueLegitimacyOW(member, leagueID)
	if not Players[member]:IsMinorCiv() then
		gT.Players[member].CodexInfluenceFromLeague = gT.Players[member].CodexInfluenceFromLeague + CODEX_INFLUENCE_FROM_LEAGUE_RES
	end
end
function ToPLeagueRemoveTotalWarGoodbye(bPlayer, leagueID, enemy)
	local tab ={}
	if gT.Leagues[enemy] then
		for member, sth in pairs(gT.Leagues[enemy].Members) do
			table.insert(tab, member)
		end
	else
		table.insert(tab, enemy)
	end
	for i, pEnemy in pairs(tab) do
		if bPlayer ~= pEnemy then
			ChangePeaceWarLock(bPlayer, pEnemy, -1, "TotalWar")
		end
	end
end
function ToPLeagueAddTotalWar(nPlayer, leagueID, enemy)
	local tab ={}
	if gT.Leagues[enemy] then
		for member, sth in pairs(gT.Leagues[enemy].Members) do
			table.insert(tab, member)
		end
	else
		table.insert(tab, enemy)
	end
	if Players[nPlayer]:IsMinorCiv() then
		for i, pEnemy in pairs(tab) do
			if not Players[pEnemy]:IsMinorCiv() then
				local inf = Players[nPlayer]:GetMinorCivFriendshipWithMajor(pEnemy);
				if inf > 0 then
					Players[nPlayer]:ChangeMinorCivFriendshipWithMajor(pEnemy, -inf)
				end
			end
		end
	else
		for i, pEnemy in pairs(tab) do
			if pEnemy ~= nPlayer then
				if not Players[pEnemy]:IsMinorCiv() then
					if Players[nPlayer]:IsDoF(pEnemy) then
						RemoveBadPlayerLeague(nPlayer, pEnemy, "TotalWar")
						Players[nPlayer]:DoEndDoF(pEnemy, false)
					end
				end
			end
		end
	end
	local mTeam = Players[nPlayer]:GetTeam();
	for i, pEnemy in pairs(tab) do
		if nPlayer ~= pEnemy then
			local pTeam = Players[pEnemy]:GetTeam();
			if not Teams[mTeam]:IsHasMet(pTeam) then
				Teams[mTeam]:Meet(pTeam)
			end
			if not Teams[mTeam]:IsAtWar(pTeam) then
				Teams[mTeam]:DeclareScriptedWar(pTeam);
			end
			ChangePeaceWarLock(nPlayer, pEnemy, 1, "TotalWar")
		end
	end
end
function ToPLeagueDoDefensivePact(leagueID)
	for jMember, sth in pairs(gT.Leagues[leagueID].Members) do
		if (not Players[jMember]:IsMinorCiv()) or (gT.Leagues[leagueID].SpecialProposalTag == "IdeologyL") then
			local jTeam = Players[jMember]:GetTeam();
			for sMember, jth in pairs(gT.Leagues[leagueID].Members) do
				if (not Players[sMember]:IsMinorCiv()) or (gT.Leagues[leagueID].SpecialProposalTag == "IdeologyL") then
					local sTeam = Players[sMember]:GetTeam();
					if jTeam ~= sTeam then
						if not Teams[jTeam]:IsDefensivePact(sTeam) then
							Teams[jTeam]:SetDefensivePact(sTeam, true)
						end
					end
				end
			end
		end
	end
end
function ToPLeagueRemoveDemilitarization(leagueID)
	LinkLeagueRemoveDemilitarization(leagueID)
end
function ToPEndCondemnEspionage(leagueID)
	for member, s in pairs(gT.Leagues[leagueID].Members) do
		if not Players[member]:IsMinorCiv() then
			gT.Players[member].CondemnEspionage = gT.Players[member].CondemnEspionage - 1
		end
	end
end
function ToPLeagueRemoveWarmongerDenounce(leagueID)
	LinkLeagueRemoveWarmongerDenounce(leagueID)
end
function ToPLeagueRemoveIdeologySupport(leagueID, extraInfo)
	gT.Leagues[leagueID].SupportedIdeology = nil;
end
function ToPLeagueRemoveSolvingPoverty(leagueID)
	LinkLeagueRemoveSolvingPoverty(leagueID)
end
function ToPLeagueRemoveDefensivePact(leagueID)
	for jMember, sth in pairs(gT.Leagues[leagueID].Members) do
		local jTeam = Players[jMember]:GetTeam();
		for sMember, jth in pairs(gT.Leagues[leagueID].Members) do
			local sTeam = Players[sMember]:GetTeam();
			if jTeam ~= sTeam then
				if Teams[jTeam]:IsDefensivePact(sTeam) then
					if not ShouldBeInDefensivePact(sTeam, jTeam, leagueID) then
						Teams[jTeam]:SetDefensivePact(sTeam, false)
					end
				end
			end
		end
	end
end
function ToPLeagueHostFunction(leagueID, extra)
--	gT.Leagues[leagueID].HostTurn = (GetITGGameTurn() + 4) % 5;
--	gT.Leagues[leagueID].HostDivider = 5;
	ChooseHostMember(leagueID, true)
end
function ToPLeagueHostOver(leagueID, extra)
	gT.Leagues[leagueID].HostTurn = nil
	gT.Leagues[leagueID].HostDivider = nil;
	gT.Leagues[leagueID].Host = nil;
	UpdateAllVotesLeague(leagueID)
end
function ToPLeagueNewMember(leagueID, extra)
	if Players[extra]:IsMinorCiv() then
		AddAMemberToLeague(leagueID, extra)	
		UpdateMemberVotesInLeague(extra, leagueID)
	else
		if not Players[extra]:IsHuman() then
			table.insert(gT.Players[extra].QueueActionsRealEndTurn, {"LeagueInvite", leagueID});
		end
		gT.Players[extra].InvitationsLeague[leagueID] = GetITGGameTurn();
--		PlayerAcceptedInvitationToTheLeague(leagueID, extra)
	end
end
function ToPLeagueAddDefensivePacts(nPlayer, leagueID)
	if (not Players[nPlayer]:IsMinorCiv()) or (gT.Leagues[leagueID].SpecialProposalTag == "IdeologyL") then
		local jTeam = Players[nPlayer]:GetTeam();
		for sMember, jth in pairs(gT.Leagues[leagueID].Members) do
			if (not Players[sMember]:IsMinorCiv()) or (gT.Leagues[leagueID].SpecialProposalTag == "IdeologyL") then
				local sTeam = Players[sMember]:GetTeam();
				if jTeam ~= sTeam then
					if not Teams[jTeam]:IsDefensivePact(sTeam) then
						Teams[jTeam]:SetDefensivePact(sTeam, true)
					end
					if not Teams[sTeam]:IsDefensivePact(jTeam) then
						Teams[sTeam]:SetDefensivePact(jTeam, true)
					end
				end
			end
		end
	end
end
function ToPLeagueRemoveEmbargosInit(nPlayer, leagueID)
	ToPLeagueDoRemoveEmbargos(leagueID)
end
function ToPDoRemoveCostsPoverty(bPlayer, leagueID)
	LinkedToPDoRemoveCostPovert(bPlayer, leagueID)
end
function ToPDoRemoveWarmongerDenounceOnePlayer(bPlayer, leagueID)
	LinkedToDoRemoveWarmongerDenounceOnePlayer(bPlayer, leagueID)
end
function ToPDoRemoveDemilitarization(bPlayer, leagueID)
	LinkedToPDoDemilitarization(bPlayer, leagueID)
end
function ToPDoRemoveCondemnEspionage(bPlayer, leagueID)
	if not Players[bPlayer]:IsMinorCiv() then
		gT.Players[bPlayer].CondemnEspionage = gT.Players[bPlayer].CondemnEspionage - 1
	end
end
function ToPLeagueRemoveDefensivePacts(bPlayer, leagueID)
	local jTeam = Players[bPlayer]:GetTeam();
	for sMember, jth in pairs(gT.Leagues[leagueID].Members) do
		local sTeam = Players[sMember]:GetTeam();
		if jTeam ~= sTeam then
			if Teams[jTeam]:IsDefensivePact(sTeam) then
				if not ShouldBeInDefensivePact(sTeam, jTeam, leagueID) then
					Teams[jTeam]:SetDefensivePact(sTeam, false)
					Teams[sTeam]:SetDefensivePact(jTeam, false)
				end
			end
		end
	end
end
function Res19Goodbye(bPlayer, leagueID)
	gT.Players[bPlayer].TrialTithe = nil;
end
function ToPLeagueDoAnchorIncrease(leagueID)
	AdoptRemoveResLeagueCSAnchor(leagueID, 1)
end
function ToPLeagueDoRemoveEmbargos(leagueID)
	for index, sth in pairs(gT.CustomsHouses) do
		if sth.Embargo and gT.Leagues[leagueID].Members[sth.Embargo] and gT.Leagues[leagueID].Members[sth.Player] then
			if sth.Active then
				PlayersEmbargoChange(sth.Player, sth.Embargo, -1, false)
			end
			gT.CustomsHouses[index].Embargo = nil;
		end
	end
	for govID, h in pairs(gT.Globals.Governors) do
		if h.TradeEmbargo then
			if gT.Leagues[leagueID].Members[h.TradeEmbargo] and gT.Leagues[leagueID].Members[h.Player] then
				PlayersEmbargoChange(h.Player, h.TradeEmbargo, -1, false)
				gT.Globals.Governors[govID].TradeEmbargo = nil;
			end
		end
	end
end
function ToPLeagueLegitimacyOAR(leagueID)
	for member, sth in pairs(gT.Leagues[leagueID].Members) do
		if not Players[member]:IsMinorCiv() then
			gT.Players[member].CodexInfluenceFromLeague = gT.Players[member].CodexInfluenceFromLeague + CODEX_INFLUENCE_FROM_LEAGUE_RES
		end
	end
end
function ToPLeagueDoAnchorIncreaseRemoved(leagueID)
	AdoptRemoveResLeagueCSAnchor(leagueID, -1)
end
local resourceLuxuriesTab = {}
for row in GameInfo.Resources() do
	if row.Happiness > 0 then
		table.insert(resourceLuxuriesTab, row.ID)
	end
end
function ToPLeagueNumMorale(iMember, leagueID)
	return gT.Players[iMember].Morale - gT.Players[iMember].MoraleFromLeague;
end
function GetAIValueResolution1(iPlayer, leagueID, extrainfo1, bRenact, resID)
	local balance = 50;
	if bRenact then
		local bS = 3;
		if gT.Globals.LastTurn - GetITGGameTurn() < 30 then
			bS = 10;
		end
		if gT.Leagues[leagueID].Members[iPlayer].VotesFromResolution[TabOfProposals[resID].Name] then
			balance = balance - 2 * bS + bS * gT.Leagues[leagueID].Members[iPlayer].VotesFromResolution[TabOfProposals[resID].Name];
		end
	else
	-- need for extra science
		if not Players[iPlayer]:IsMinorCiv() then
			balance = balance - 10 + math.abs(GetITGSciencePerTurn(iPlayer, true) - NiceCostOfTechOrPolicy(iPlayer, GetDBCulturePlayerInfo(iPlayer, "BaseTechCost"), gT.Players[iPlayer].ScienceBonusAdopted, 1)/ 10) / (NiceCostOfTechOrPolicy(iPlayer, GetDBCulturePlayerInfo(iPlayer, "BaseTechCost"), gT.Players[iPlayer].ScienceBonusAdopted, 1) + 1);
		end
	end
	for i, sth in pairs(gT.Academies) do
		if sth.Player == iPlayer then
			balance = balance + 2
		end
	end
	return balance + LastRandom(-5, 5);
end
function GetAIValueResolution2(iPlayer, leagueID, extrainfo1, bRenact, resID)
	local balance = 50;
	if Players[extrainfo1]:IsMinorCiv() then
		balance = balance + 5 * (-5 + gT.Players[iPlayer].LeagueFlavors["MinorMembers"]);
	else
		balance = balance + 5 * (-5 + gT.Players[iPlayer].LeagueFlavors["MoreMembers"]);
		if (not Players[iPlayer]:IsMinorCiv()) and Players[iPlayer]:IsDoF(extrainfo1) then
			balance = balance + 10;
		elseif Teams[Players[iPlayer]:GetTeam()]:IsAtWar(Players[extrainfo1]:GetTeam()) then
			balance = balance - 50;
		end
	end
--	print("New member invite:", iPlayer, extrainfo1, balance)
	return balance + LastRandom(-3, 3);
end
function GetAIValueResolution29(iPlayer, leagueID, extrainfo1, bRenact, resID)
	local balance = 25;
	if Players[iPlayer]:GetGold() < 50 then
		balance = balance + 25;
	end
	if GetITGGameTurn() > 80 then
		balance = balance + 5;
	end
	if GetVoteAdvantageOverOtherMembers(leagueID, iPlayer) > 9 then
		balance = balance + 10;
	end
	return balance;
end
function GetAIValueResolution30(iPlayer, leagueID, extrainfo1, bRenact, resID)
	local balance = 30;
	if gT.Players[iPlayer].LegalPower < 1 then
		balance = balance + 25;
	end
	if GetITGGameTurn() > 80 then
		balance = balance + 5;
	end
	if GetVoteAdvantageOverOtherMembers(leagueID, iPlayer) > 9 then
		balance = balance + 10;
	end
	return balance;
end
function GetAIValueResolution64(iPlayer, leagueID, extrainfo1, bRenact, resID)
	return 30 + 5 * GetAIAttitudeTowardCodexStrength(iPlayer);
end
function GetAIValueResolution31(iPlayer, leagueID, extrainfo1, bRenact, resID)
	local balance = 20;
	local t, k, m = 0, 0, 0;
	for i, s in pairs(gT.Players) do
		if not Players[i]:IsMinorCiv() then
			local imight = GetMilitaryMightDemographics(iPlayer, i, false)
			m = math.max(m, imight);
			 t = t + imight;
			 k = k + 1; 
		end
	end
	if k ~= 0 then
		t = t / k;
		local e = GetMilitaryMightDemographics(iPlayer, extrainfo1, false);
		local o = GetMilitaryMightDemographics(iPlayer, iPlayer,  false);
		if e == m then
			balance = 100;
		else
			if e > t then
				balance = balance + math.floor(40 * e / t);
			end
			if e > o then
				balance = balance + 10;
			end
		end
	end
	local nmajorinleaguenotinwar = 0;
	for g, h in pairs(gT.Leagues[leagueID].Members) do
		if (not Players[g]:IsMinorCiv()) and (g ~= iPlayer) then
			if not gT.Players[g].ScenarioWarLocks[extrainfo1] then
				nmajorinleaguenotinwar = nmajorinleaguenotinwar + 1;
			end
		end
	end
	if nmajorinleaguenotinwar == 0 then
		balance = 0;
	else
		balance = balance + 2 * nmajorinleaguenotinwar;
	end
	return balance;
end
function GetAIValueResolution32(iPlayer, leagueID, extrainfo1, bRenact, resID)
	local influence = 0;
	for im, s in pairs(gT.Leagues[leagueID].Members) do
		if not Players[im]:IsMinorCiv() then
			if im ~= iPlayer then
				influence = influence + math.max(0, Players[extrainfo1]:GetMinorCivFriendshipWithMajor(im));
			end
		end
	end
	local balance = influence;
	local gAlly = Players[extrainfo1]:GetAlly();
	if (gAlly == -1) or (Players[extrainfo1]:GetMinorCivFriendshipWithMajor(gAlly) < influence + Players[extrainfo1]:GetMinorCivFriendshipWithMajor(iPlayer)) then
		balance = balance + 10;
	end
	return balance;
end
function GetAIValueResolution33(iPlayer, leagueID, extrainfo1, bRenact, resID)
	return 100 - GetITGGameTurn();
end
function GetAIValueResolution3(iPlayer, leagueID, extrainfo1, bRenact, resID)
	return LinkGetAIValueResolution3(iPlayer, leagueID, extrainfo1, bRenact, resID)
end
function GetAIValueResolution4(iPlayer, leagueID, extrainfo1, bRenact, resID)
	local balance = 10 + 10 * GetAIFlavour(iPlayer, "FLAVOR_WONDER");
	local ncities = Players[iPlayer]:GetNumCities();
	balance = balance + ncities * 5;
	for member, sth in pairs(gT.Leagues[leagueID].Members) do
		if not Players[member]:IsMinorCiv() then
			if member ~= iPlayer then
				balance = balance - Players[iPlayer]:GetNumCities() * 4;
			end
		end
	end
	if not gT.Players[iPlayer].CanWonderRace then
		balance = balance - 25;
	end
	return balance + LastRandom(-25, 25);
end
function GetAIValueResolution5(iPlayer, leagueID, extrainfo1, bRenact, resID)
	local balance = 50;
	local na = ToPLeagueNumAllies(iPlayer);
	local nott = 0;
	local nob = 0;
	for member, sth in pairs(gT.Leagues[leagueID].Members) do
		if not Players[member]:IsMinorCiv() then
			if member ~= iPlayer then
				local nato =  ToPLeagueNumAllies(member);
				nott = nott + nato;
				if nato > nob then
					nob = nato;
				end
			end
		end
	end
	if na > nob then
		if na > nob * 2 then
			balance = balance + 20;
		end
		balance = balance + 15
	else
		balance = balance - 20 + nott * 10;
	end
	return balance + LastRandom(-3, 3);
end
function GetAIValueResolution34(iPlayer, leagueID, extrainfo1, bRenact, resID)
	local balance = 35 + DBScenario.PlagueStrength;
	balance = balance + GetExtraReasonsForHealthcareLeague(iPlayer, leagueID)
	return balance + LastRandom(-3, 3);
end
function GetAIValueResolution35(iPlayer, leagueID, extrainfo1, bRenact, resID)
	return GetAIValueForClosedTrade(iPlayer, leagueID) + LastRandom(-10, 10); -- trade
end
function GetAIValueResolution36(iPlayer, leagueID, extrainfo1, bRenact, resID)
	return GetNumAIValueKnowledgeSharingLeague(iPlayer, leagueID) + LastRandom(-5, 5); -- tech
end
function GetAIValueResolution37(iPlayer, leagueID, extrainfo1, bRenact, resID)
	if Players[iPlayer]:IsMinorCiv() then
		return LastRandom(42,65);
	end
	local val = 100;
	if Players[iPlayer]:HasCreatedPantheon() then
		val = 100 - 20 * #Game.GetBeliefsInReligion(0, iPlayer)
	end
	return val + LastRandom(-5, 5);
end
function GetAIValueResolution38(iPlayer, leagueID, extrainfo1, bRenact, resID)
	if Players[iPlayer]:IsMinorCiv() then
		return LastRandom(33,88);
	end
	return ProjectAIValueResolution(iPlayer, leagueID);
end
function GetAIValueResolution42(iPlayer, leagueID, extrainfo1, bRenact, resID)
	return TotaWarAIValueResolution(iPlayer, leagueID,extrainfo1);
end
function GetAIValueResolution46(iPlayer, leagueID, extrainfo1, bRenact, resID)
	return ArchaeologicalGrantAIValueResolution(iPlayer, leagueID);
end
function GetAIValueResolution47(iPlayer, leagueID, extrainfo1, bRenact, resID)
	return DoWeBenefitFromSolvingPoority(iPlayer, leagueID);
end
function GetAIValueResolution48(iPlayer, leagueID, extrainfo1, bRenact, resID)
	return DoWeBenefitFromDemilitarization(iPlayer, leagueID);
end
function GetAIValueResolution63(iPlayer, leagueID, extrainfo1, bRenact, resID)
	local base = LastRandom(15, 35);
	for a, b in pairs(gT.Players[iPlayer].SpyActionsBig) do
		if b == "Money Forgery" or b == "Assassination" or b == "Coup" then
			base = base - 4;
		end
	end
	base = base - 5 * gT.Players[iPlayer].NumSpyBought;
	base = base + (12 - GetAIFlavour(iPlayer, "FLAVOR_ESPIONAGE")) * 7;
	return math.max(10, base);
end
function GetAIValueResolution49(iPlayer, leagueID, extrainfo1, bRenact, resID)
	return DoWeFromHealthInAllCities(iPlayer, leagueID);
end
function GetAIValueResolution54(iPlayer, leagueID, extrainfo1, bRenact, resID)
	return DoWeFromHealthInAllCities(iPlayer, leagueID);
end
function GetAIValueResolution58(iPlayer, leagueID, extrainfo1, bRenact, resID)
	return DoWeCareAboutForcingPeace(iPlayer, leagueID,extrainfo1);
end
function GetAIValueResolution59(iPlayer, leagueID, extrainfo1, bRenact, resID)
	local tab = {}
	if Players[iPlayer]:IsMinorCiv() then -- minor can't evaluate ideologies
		for i, answer in pairs(gT.Leagues[leagueID].Proposals[resID].Answers) do
			table.insert(tab, {i, 1})
		end
	else
		GenerateAIIdeologyFavours(iPlayer)
		for i, answer in pairs(gT.Leagues[leagueID].Proposals[resID].Answers) do
			table.insert(tab, {i, math.max(1, GetAIEvalOfIdeologyTenet(iPlayer, answer[1]))})
		end
	end
	return GetRandomFromBiasedChanceTable(tab);
end
function GetAIValueResolution55(iPlayer, leagueID, extrainfo1, bRenact, resID)
	return DoWeWantBanMercenaries(iPlayer, leagueID);
end
function GetAIValueResolution56(iPlayer, leagueID, extrainfo1, bRenact, resID)
	return DoWeWantStabilization(iPlayer, leagueID);
end
function GetAIValueResolution57(iPlayer, leagueID, extrainfo1, bRenact, resID)
	return DoWeWantBalanceAcademies(iPlayer, leagueID);
end
function GetAIValueResolution53(iPlayer, leagueID, extrainfo1, bRenact, resID)
	return DoWeFromSciencePublic(iPlayer, leagueID);
end
function GetAIValueResolution51(iPlayer, leagueID, extrainfo1, bRenact, resID)
	return 100 - DoWeFromHealthInAllCities(iPlayer, leagueID);
end
function GetAIValueResolution52(iPlayer, leagueID, extrainfo1, bRenact, resID)
	return DoWeDenounceWarmongers(iPlayer, leagueID);
end
function GetAIValueResolution61(iPlayer, leagueID, extrainfo1, bRenact, resID)
	for iCity in Players[iPlayer]:Cities() do
		local pOrigin = iCity:GetOriginalOwner();
		if pOrigin ~= iPlayer and (gT.Leagues[leagueID].Members[pOrigin]) and (Players[pOrigin]:IsMinorCiv() or (GetNumLegalCities(pOrigin) > 1)) then
			return LastRandom(70, 85)
		end
	end
	for g, h in pairs(gT.Leagues[leagueID].Members) do
		if g ~= iPlayer then
			for iCity in Players[iPlayer]:Cities() do
				if iCity:GetOriginalOwner() == iPlayer then
					return LastRandom(1,25);
				end
			end
		end
	end
	return LastRandom(20,50);
end
function GetAIValueResolution62(iPlayer, leagueID, extrainfo1, bRenact, resID)
	local eVal = 50;
	for g, h in pairs(gT.Leagues[leagueID].Members) do
		if g ~= iPlayer then
			if gT.Players[iPlayer].Embargos[g] then
				eVal = eVal - 8;
			end
			if gT.Players[g].Embargos[iPlayer] then
				eVal = eVal + 5;
			end
		end	
	end
	return math.max(1, math.min(100, eVal + LastRandom(-5, 5)));
end
function GetAIValueResolution50(iPlayer, leagueID, extrainfo1, bRenact, resID)
	local hTab = {};
	for a, b in pairs(gT.Leagues[leagueID].Proposals[resID].Answers) do
		table.insert(hTab, {a, math.pow(gT.Players[iPlayer].Ideologies[b[1]], 2)})
	end
	hTab = Shuffle(hTab);
	table.sort(hTab, SortFunctionForGreaterInteger2);
	return hTab[1][1];
end
function GetAIValueResolution41(iPlayer, leagueID, extrainfo1, bRenact, resID)
	if Players[iPlayer]:IsMinorCiv() then
		return LastRandom(0,100);
	end
	return CityStateFreeAIValueResolution(iPlayer, leagueID);
end
function GetAIValueResolution43(iPlayer, leagueID, extrainfo1, bRenact, resID)
	return OlympicGamesAIValueResolution(iPlayer, leagueID);
end
function GetAIValueResolution44(iPlayer, leagueID, extrainfo1, bRenact, resID)
	return LeagueTournamentAIValue(iPlayer, leagueID, extrainfo1);
end
function GetAIValueResolution39(iPlayer, leagueID, extrainfo1, bRenact, resID)
	if Players[iPlayer]:IsMinorCiv() then
		return LastRandom(33,88);
	end
	if gT.Players[iPlayer].HasCodex then
		return 0;
	end
	return ProjectAIValueResolution(iPlayer, leagueID);
end
function GetAIValueResolution40(iPlayer, leagueID, extrainfo1, bRenact, resID)
	if Players[iPlayer]:IsMinorCiv() then
		return LastRandom(33,88);
	end
	return ProjectAIValueResolution(iPlayer, leagueID);
end
function GetAIValueResolution45(iPlayer, leagueID, extrainfo1, bRenact, resID)
	return LastRandom(33, 80)
end
function GetAIValueResolution6(iPlayer, leagueID, extrainfo1, bRenact, resID)
	local balance = 50;
	local na = ToPLeagueNumWonders(iPlayer);
	local nott = 0;
	local nob = 0;
	for member, sth in pairs(gT.Leagues[leagueID].Members) do
		if not Players[member]:IsMinorCiv() then
			if member ~= iPlayer then
				local nato =  ToPLeagueNumWonders(member);
				nott = nott + nato;
				if nato > nob then
					nob = nato;
				end
			end
		end
	end
	if na > nob then
		if na > nob * 2 then
			balance = balance + 20;
		end
		balance = balance + 15
	else
--		print("Help league nott value 6: ", nott)
		balance = balance - 18 + nott * GetAIFlavour(iPlayer, "FLAVOR_GREAT_PEOPLE");
	end
	return balance + LastRandom(-3, 3);
end
function GetAIValueResolution7(iPlayer, leagueID, extrainfo1, bRenact, resID)
	return LinkGetAIValueResolution7(iPlayer, leagueID, extrainfo1, bRenact, resID)
end
function GetAIValueResolution8(iPlayer, leagueID, extrainfo1, bRenact, resID)
	local balance = 45 + GetAIAttitudeTowardCodexStrength(iPlayer);
	if gT.Players[iPlayer].Goverment == 1 then
		balance = balance + 25;
	end
	if bRenact then
		local bS = 10;
		if gT.Leagues[leagueID].Members[iPlayer].VotesFromResolution[TabOfProposals[resID].Name] then
			balance = balance - 2 * bS + bS * gT.Leagues[leagueID].Members[iPlayer].VotesFromResolution[TabOfProposals[resID].Name];
		end
	end
	return balance + LastRandom(-10, 10);
end
function GetAIValueResolution9(iPlayer, leagueID, extrainfo1, bRenact, resID)
	return LinkGetAIValueResolution9(iPlayer, leagueID, extrainfo1, bRenact, resID)
end
function GetAIValueResolution10(iPlayer, leagueID, extrainfo1, bRenact, resID)
	return LinkGetAIValueResolution10(iPlayer, leagueID, extrainfo1, bRenact, resID);
end
function GetAIValueResolution11(iPlayer, leagueID, extrainfo1, bRenact, resID)
	return LinkGetAIValueResolution11(iPlayer, leagueID, extrainfo1, bRenact, resID)
end
function GetAIValueResolution12(iPlayer, leagueID, extrainfo1, bRenact, resID)
	return LinkGetAIValueResolution12(iPlayer, leagueID, extrainfo1, bRenact, resID);
end
function GetAIValueResolution13(iPlayer, leagueID, extrainfo1, bRenact, resID)
	local balance = 50;
	if gT.Leagues[leagueID].Members[iPlayer].Votes < 10 then
		balance = balance + 10;
	elseif gT.Leagues[leagueID].Members[iPlayer].Votes > 30 then
		balance = balance - 15;
	end
	balance = balance + 5 * (-5 + gT.Players[iPlayer].LeagueFlavors.Delaying);
	return balance;
end
function GetAIValueResolution14(iPlayer, leagueID, extrainfo1, bRenact, resID)
	local balance = 50;
	if gT.Leagues[leagueID].Members[iPlayer].Votes < 10 then
		balance = balance + 5;
	elseif gT.Leagues[leagueID].Members[iPlayer].Votes > 30 then
		balance = balance + 25;
	end
	balance = balance + 5 * (-5 + gT.Players[iPlayer].LeagueFlavors.ForcingVeto);
	return balance;
end
function GetAIValueResolution15(iPlayer, leagueID, extrainfo1, bRenact, resID)
	local balance = 50;
	local cVotes = gT.Leagues[leagueID].Members[iPlayer].Votes - GetTemporaryVotesLeague(iPlayer, leagueID);
	local bestV = 0;
	for member, sth in pairs(gT.Leagues[leagueID].Members) do
		if member ~= iPlayer then
			bestV = math.max(bestV, sth.Votes - GetTemporaryVotesLeague(member, leagueID))
		end
	end
	if (bestV > cVotes * 2) or (bestV > cVotes + 10) then
		return 5;
	end
	balance = balance - bestV + cVotes; 
	return balance;
end
function GetFuncAnswersProp16(aTab)
	local tab = {}
	for i, s in pairs(aTab) do
		table.insert(tab, {s, Map.GetPlotByIndex(s):GetPlotCity():GetName(), Map.GetPlotByIndex(s):GetPlotCity():GetName() .. " will become the target of next crusade."})
	end
	return tab;
end
function GetFuncAnswersProp50(aTab)
	local tab = {}
	for i, s in pairs(aTab) do
		table.insert(tab, {s, GetIdeoNameString(s)})
	end
	return tab;
end

function GetFuncAnswersProp59(aTab)
	local tab = {}
	for i, s in pairs(aTab) do
		local rowData = GetIdeologyDBRow(s)
		table.insert(tab, {s, rowData.Name, "[COLOR_POSITIVE_TEXT]" .. rowData.Name .. "[ENDCOLOR][NEWLINE]" .. GetIdeologyLettersString(s) .. "[NEWLINE][NEWLINE]" .. rowData.Help})
	end
	return tab;
end
function GetFuncAnswersProp17(aTab)
	return {{1, "Yay"}, {2, "Nay"}}
end
function GetFuncAnswersProp18(aTab)
	return  {{1, "+150[ICON_PEACE]", "Players with most advanced art style will recieve 150 [ICON_PEACE] Faith per each member with obsolete style."}, {2, "+1[ICON_HAPPINESS_1]", "Players with most advanced art style will recieve 1 [ICON_HAPPINESS_1] Happiness empire-wide per each member with obsolete style."}, {3, "+200[ICON_GREAT_ARTIST]", "Players with most advanced art style will recieve 200 [ICON_GREAT_ARTIST] per each member with obsolete style."}}
end
function GetFuncAnswersProp19(aTab)
	return {{1, "1[ICON_PEACE]/4[ICON_GOLD]", "Players will be granted 1 [ICON_PEACE] Faith per 4 [ICON_GOLD] Gold contributed."}, {2, "1[ICON_CULTURE]/5[ICON_GOLD]","Players will be granted 1 [ICON_CULTURE] Culture per 5 [ICON_GOLD] Gold contributed."}, {3, "0.01[ICON_ITG_LEGAL_POWER]/5[ICON_GOLD]", "Players will be granted 0.01 [ICON_ITG_LEGAL_POWER] Legal Power per 5 [ICON_GOLD] Gold contributed."}}
end
function GetFuncAnswersProp67(aTab)
	return {{1, "[ICON_ITG_MERCENARY] Mercenaries.", "Allows spawning famous [ICON_ITG_MERCENARY] Mercenaries near Capital."}, {2, "[ICON_ITG_LEGAL_POWER] Legalization", "Allows claiming ownership of one occupied City."}, {3, "[ICON_ITG_MORALE] Morale.", "Allows boosting [ICON_ITG_MORALE] Morale of troops."}} 
end
function GetFuncAnswersProp65(aTab)
	return {
		{1, "+2[ICON_ITG_MERITOCRACY]", "+2 [ICON_ITG_MERITOCRACY] Meritocracy from pilgrimages to host's cities and holy sites."},
		{2, "+0.05[ICON_ITG_LEGAL_POWER]", "+0.05 [ICON_ITG_LEGAL_POWER] Legal Power from pilgrimages to host's cities and holy sites."},
		{3, "+2[ICON_HAPPINESS_1]", "+2 [ICON_HAPPINESS_1] Happiness for origin city from pilgrimages to host's cities and holy sites."},
	};
end
function GetFuncAnswersProp20(aTab)
	local tab = {}
	for i, s in pairs(aTab) do
		table.insert(tab, {s, Locale.Lookup(GameInfo.Beliefs[s].ShortDescription), Locale.Lookup(GameInfo.Beliefs[s].Description)})
	end
	return tab;
end
function ProvideVotesRes34(leagueID)
	return GetVotesFromResolution34(leagueID)
end
function ProvideVotesRes63(leagueID)
	local tab = {}
	for g, s in pairs(gT.Leagues[leagueID].Members) do
		if not Players[g]:IsMinorCiv() then
			tab[g] = 0;
			for a, b in pairs(gT.Players[g].SpyActionsBig) do
				if b == "Money Forgery" or b == "Assassination" or b == "Coup" then
					tab[g] = tab[g] - 1;
				end
			end
		end
	end
	return tab;
end
function LeagueHelpFuncITG38(extrainfo)
	return "Rewards from League project is based on contribution:[NEWLINE][NEWLINE][ICON_TROPHY_GOLD]Highest Contributor: +1 [ICON_ITG_FESTIVAL] Festival point.[NEWLINE][NEWLINE][ICON_TROPHY_SILVER]" .. DBScenario.LeagueProjectCost /4 .. "+[ICON_PRODUCTION] Contribution: Grants two [ICON_GREAT_WORK] Great Works.[NEWLINE][NEWLINE][ICON_TROPHY_BRONZE]Any Contribution: [ICON_PRODUCTION] Production is added to [ICON_CULTURE] Culture.[NEWLINE][NEWLINE]Project needs at least " .. DBScenario.LeagueProjectCost .. "[ICON_PRODUCTION] Production to be completed."
end
function LeagueHelpFuncITG39(extrainfo)
	return "Rewards from League project is based on contribution:[NEWLINE][NEWLINE][ICON_TROPHY_GOLD]Highest Contributor: Codex cost is discounted by 3 [ICON_HAPPINESS_4][ICON_ITG_LEGAL_POWER] Legal Power.[NEWLINE][NEWLINE][ICON_TROPHY_SILVER]" .. DBScenario.LeagueProjectCost/ 4 .. "+[ICON_PRODUCTION] Contribution: Grants one Free Law change.[NEWLINE][NEWLINE][ICON_TROPHY_BRONZE]Any Contribution: [ICON_PRODUCTION] Production is added to [ICON_ITG_LEGAL_POWER] Legal Power.[NEWLINE][NEWLINE]Project needs at least " .. DBScenario.LeagueProjectCost .. "[ICON_PRODUCTION] Production to be completed."
end
function LeagueHelpFuncITG40(extrainfo)
	return "Rewards from League project is based on contribution:[NEWLINE][NEWLINE][ICON_TROPHY_GOLD]Highest Contributor: The right to construct a new Wonder.[NEWLINE][NEWLINE][ICON_TROPHY_SILVER]Other Contributors with active Wonder Race: [ICON_PRODUCTION] Production is added to [ICON_GREAT_ENGINEER] Wonder Race points.[NEWLINE][NEWLINE][ICON_TROPHY_BRONZE]Other Contributors without active Wonder Race: [ICON_PRODUCTION] Production is added to [ICON_GOLD] Gold.[NEWLINE][NEWLINE]Project needs at least " .. DBScenario.LeagueProjectCost .. "[ICON_PRODUCTION] Production to be completed."
end

function LeagueCrusadeHelpFunc(exInfo)
	local sText = Locale.Lookup(TabOfProposals[16].AfterHelp);
	if exInfo then
		local cName = Map.GetPlotByIndex(exInfo):GetPlotCity():GetName();
		sText = sText .. "[NEWLINE][NEWLINE]Crusade will target " ..  cName .. ".";
	end
	return sText;
end
function LeagueTitheHelpFunc(exInfo)
	local sText = Locale.Lookup(TabOfProposals[19].AfterHelp);
	if exInfo then
		sText = sText .. "[NEWLINE][NEWLINE]Reward: ";
		if exInfo == 1 then
			sText = sText .. "1[ICON_PEACE]/4[ICON_GOLD]"
		elseif exInfo == 2 then
			sText = sText .. "1[ICON_CULTURE]/5[ICON_GOLD]"
		elseif exInfo == 3 then
			sText = sText .. "0.01[ICON_ITG_LEGAL_POWER]/5[ICON_GOLD]"
		end
	end
	return sText;
end
function LeagueDeusVultHelpFunc(exInfo)
	local sText = Locale.Lookup(TabOfProposals[67].AfterHelp);
	if exInfo then
		sText = sText .. "[NEWLINE][NEWLINE]Reward: ";
		if exInfo == 1 then
			sText = sText .. "Acquisition of [ICON_ITG_MERCENARY] Mercenaries."
		elseif exInfo == 2 then
			sText = sText .. "Legalization of conquest."
		elseif exInfo == 3 then
			sText = sText .. "[ICON_ITG_MORALE] Morale boost."
		end
	end
	return sText;
end
function League65HelpFunc(exInfo)
	local sText = Locale.Lookup(TabOfProposals[65].AfterHelp);
	if exInfo then
		sText = sText .. "[NEWLINE][NEWLINE]Reward: ";
		if exInfo == 1 then
			sText = sText .. "+2 [ICON_ITG_MERITOCRACY] Meritocracy."
		elseif exInfo == 2 then
			sText = sText .. "+0.05 [ICON_ITG_LEGAL_POWER] Legal Power."
		elseif exInfo == 3 then
			sText = sText .. "+2 [ICON_HAPPINESS_1] Happiness."
		end
	end
	return sText;
end
function LeagueCultUnifyHelpFunc(exInfo)
	local sText = Locale.Lookup(TabOfProposals[18].AfterHelp);
	if exInfo then
		sText = sText .. "[NEWLINE][NEWLINE]Reward: ";
		if option == 1 then
			sText = sText .. "+150 [ICON_PEACE] Faith" 
		elseif option == 2 then
			sText = sText .. "+1 [ICON_HAPPINESS_1] Happiness empire-wide"
		elseif option == 3 then
			sText = sText .. "+200 [ICON_GREAT_ARTIST] Art points"
		end
	end
	return sText;
end
TabOfProposals = 
{
{ID = 1, Name = "Research Agreement", AIValueFunction = GetAIValueResolution1,CanBeInitial = true, ProvidesVotes = true, ExtraChoice = false, Help = "TXT_KEY_ITG_RESOLUTION_HELP_1"},
{ID = 2, Name = "Invite new Member", NotResolution = true, AIValueFunction = GetAIValueResolution2,FuncName = ToPFuncName2, CannotBeRepealed = true, OnAdoptedResolution = ToPLeagueNewMember, MainIconFunc = ToPMainIconFunc2, ExtraChoice = true, ExtraListFunc = ELFTopFunc2, Help = "TXT_KEY_ITG_RESOLUTION_HELP_2"},
{ID = 3, Name = "Defensive Pact", AIValueFunction = GetAIValueResolution3,CanBeInitial = true, UniqueCantDoFuncC = UCDCFuncCant3, ProvidesVotes = true, OnWelcome = ToPLeagueAddDefensivePacts, OnGoodbye = ToPLeagueRemoveDefensivePacts, OnAdoptedResolution = ToPLeagueDoDefensivePact, OnRemovedResolution = ToPLeagueRemoveDefensivePact, EndTurnHelpPoints = ToPLeagueMilitaryMight, ExtraChoice = false, Help = "TXT_KEY_ITG_RESOLUTION_HELP_3"},
{ID = 4, Name = "Monumental Initiative", AIValueFunction = GetAIValueResolution4, UniqueCantDoFuncC = UCDCFuncCant4, CanBeInitial = true,ProvidesVotes = true, VotesNotEndTurn = true, ExtraChoice = false, Help = "TXT_KEY_ITG_RESOLUTION_HELP_4"},
{ID = 5, Name = "Third-Party Alliances", AIValueFunction = GetAIValueResolution5,CanBeInitial = true,ProvidesVotes = true, OnAdoptedResolution = ToPLeagueDoAnchorIncrease, OnRemovedResolution = ToPLeagueDoAnchorIncreaseRemoved, EndTurnHelpPoints = ToPLeagueNumAllies, ExtraChoice = false, Help = "TXT_KEY_ITG_RESOLUTION_HELP_5"},
{ID = 6, Name = "Grand Tour", AIValueFunction = GetAIValueResolution6,CanBeInitial = true, ProvidesVotes = true, EndTurnHelpPoints = ToPLeagueNumWonders, ExtraChoice = false, Help = "TXT_KEY_ITG_RESOLUTION_HELP_6"},
{ID = 7, Name = "Economic Union", AIValueFunction = GetAIValueResolution7, UniqueCantDoFuncC = UCDCFuncCant7, CanBeInitial = true, ProvidesVotes = true, OnAdoptedResolution = ToPLeagueDoRemoveEmbargos, ExtraChoice = false, Help = "TXT_KEY_ITG_RESOLUTION_HELP_7", OnWelcome = ToPLeagueRemoveEmbargosInit},
{ID = 8, Name = "Legitimacy", AIValueFunction = GetAIValueResolution8, CanBeInitial = true, ProvidesVotes = true, ExtraChoice = false, OnAdoptedResolution = ToPLeagueLegitimacyOAR, OnWelcome = ToPLeagueLegitimacyOW, OnGoodbye = ToPLeagueLegitimacyOG, OnRemovedResolution = ToPLeagueLegitimacyORR, Help = "TXT_KEY_ITG_RESOLUTION_HELP_8"},
{ID = 9, Name = "Luxury Exchange", AIValueFunction = GetAIValueResolution9, CanBeInitial = true, ProvidesVotes = true, ExtraChoice = false, Help = "TXT_KEY_ITG_RESOLUTION_HELP_9"},
{ID = 10, Name = "Map Exchange", AIValueFunction = GetAIValueResolution10,CanBeInitial = true, UniqueCantDoFuncC = UCDCFuncCant10, ProvidesVotes = true, EndTurnFunction = ToPShareMapsInLeague, ExtraChoice = false, Help = "TXT_KEY_ITG_RESOLUTION_HELP_10", VotesNotEndTurn = true},
{ID = 11, Name = "Blood Oath", AIValueFunction = GetAIValueResolution11,CanBeInitial = true, ProvidesVotes = true, ExtraChoice = false, EndTurnHelpPoints = ToPLeagueNumMorale, Help = "TXT_KEY_ITG_RESOLUTION_HELP_11"},
{ID = 12, Name = "Military Training", AIValueFunction = GetAIValueResolution12,CanBeInitial = true,ProvidesVotes = true, EndTurnFunction = ToPLeagueShareXP, ExtraChoice = false, Help = "TXT_KEY_ITG_RESOLUTION_HELP_12"},
{ID = 13, Name = "Quick Sessions", AIValueFunction =  GetAIValueResolution13, ExtraChoice = false, Help = "TXT_KEY_ITG_RESOLUTION_HELP_13"},
{ID = 14, Name = "Majority Vote", AIValueFunction = GetAIValueResolution14, ExtraChoice = false, Help = "TXT_KEY_ITG_RESOLUTION_HELP_14"},
{ID = 15, Name = "Host Position", AIValueFunction = GetAIValueResolution15, OnAdoptedResolution = ToPLeagueHostFunction, OnRemovedResolution = ToPLeagueHostOver, Help = "TXT_KEY_ITG_RESOLUTION_HELP_15"},
{ID = 16, Name = "PROJECT: Crusade", Help = "TXT_KEY_ITG_RESOLUTION_HELP_16", Repetitive = true, SpecialTag = "ChristianL", NumChoices = 3, ExtraListFunc = ELFTopFunc16, AfterHelp = "TXT_KEY_BUILDING_LS_CRUSADE_PROJECT_HELP", HelpFunc = LeagueCrusadeHelpFunc, FuncAnswers = GetFuncAnswersProp16},
{ID = 17, Name = "Holy Inquisition", Help = "TXT_KEY_ITG_RESOLUTION_HELP_17", SpecialTag = "ChristianL", FuncAnswers = GetFuncAnswersProp17},
{ID = 18, Name = "Cultural Unification", Help = "TXT_KEY_ITG_RESOLUTION_HELP_18", SpecialTag = "ChristianL", AfterHelp = "TXT_KEY_ITG_RESOLUTION_AFTERHELP_18", HelpFunc = LeagueCultUnifyHelpFunc, FuncAnswers = GetFuncAnswersProp18},
{ID = 19, Name = "Tithe", Help = "TXT_KEY_ITG_RESOLUTION_HELP_19", SpecialTag = "ChristianL", AfterHelp = "TXT_KEY_ITG_RESOLUTION_AFTERHELP_19", HelpFunc = LeagueTitheHelpFunc, FuncAnswers = GetFuncAnswersProp19, OnGoodbye = Res19Goodbye},
{ID = 20, Name = "Reform Belief", Help = "TXT_KEY_ITG_RESOLUTION_HELP_20", SpecialTag = "ChristianL", NumChoices = 3, ExtraListFunc = ELFTopFunc20, AfterHelp = "TXT_KEY_ITG_RESOLUTION_AFTERHELP_21", FuncAnswers = GetFuncAnswersProp20},
{ID = 21, Name = "Ghazi", Help = "TXT_KEY_ITG_RESOLUTION_HELP_21", SpecialTag = "IslamL", Instant = true},
{ID = 22, Name = "Poetry", Help = "TXT_KEY_ITG_RESOLUTION_HELP_22", SpecialTag = "IslamL", Instant = true},
{ID = 23, Name = "Suzerain", Help = "TXT_KEY_ITG_RESOLUTION_HELP_23", SpecialTag = "IslamL", Instant = true},
{ID = 24, Name = "Holy War",  Help = "TXT_KEY_ITG_RESOLUTION_HELP_24", SpecialTag = "IslamL", Instant = true},
{ID = 25, Name = "Patronage",  Help = "TXT_KEY_ITG_RESOLUTION_HELP_25", SpecialTag = "IslamL", Instant = true},
{ID = 26, Name = "Riches", Help = "TXT_KEY_ITG_RESOLUTION_HELP_26", SpecialTag = "IslamL", Instant = true}, 
{ID = 27, Name = "ACTION: Increase Caliph's power", Help = "TXT_KEY_ITG_RESOLUTION_HELP_27", SpecialTag = "IslamL", Instant = true, Action = true, Cooldown = 15, Cost = 5},
{ID = 28, Name = "War on Schism", Help = "TXT_KEY_ITG_RESOLUTION_HELP_28", SpecialTag = "ChristianL", FuncAnswers = GetFuncAnswersProp17},
{ID = 29, Name = "ACTION: Financial Support", AIValueFunction = GetAIValueResolution29, Help = "TXT_KEY_ITG_RESOLUTION_HELP_29", Instant = true, Action = true, Cooldown = 4, Cost = 5, Above = true, UniqueCantDoFuncC = UCDCFuncCant29},
{ID = 30, Name = "ACTION: Legitimacy", AIValueFunction = GetAIValueResolution30, Help = "TXT_KEY_ITG_RESOLUTION_HELP_30", Instant = true, Action = true, Cooldown = 4, Cost = 5, Above = true, UniqueCantDoFuncC = UCDCFuncCant30},
{ID = 31, Name = "ACTION: Common Foe", AIValueFunction = GetAIValueResolution31, Help = "TXT_KEY_ITG_RESOLUTION_HELP_31", Instant = true, Action = true, Cost = 5, ExtraChoice = true, ExtraListFunc = ELFTopFunc31, FuncName = ToPFuncName31, Above = true, MainIconFunc = ToPMainIconFunc2},
{ID = 32, Name = "ACTION: Share Influence", AIValueFunction = GetAIValueResolution32, Help = "TXT_KEY_ITG_RESOLUTION_HELP_32", Instant = true, Action = true, Cost = 5, Above = true, ExtraChoice = true, Cooldown = 4, ExtraListFunc = ELFTopFunc32, FuncName = ToPFuncName32},
{ID = 33, Name = "ACTION: Request Art", AIValueFunction = GetAIValueResolution33, Help = "TXT_KEY_ITG_RESOLUTION_HELP_33", Instant = true, Action = true, Above = true, Cost = 5, Cooldown = 4, UniqueCantDoFuncC = UCDCFuncCant33},
{ID = 34, Name = "Shared Healthcare", AIValueFunction = GetAIValueResolution34, SpecialVoteFunc = ProvideVotesRes34, CanBeInitial = true, ProvidesVotes = true, ExtraChoice = false, Help = "TXT_KEY_ITG_RESOLUTION_HELP_34"},
{ID = 35, Name = "Trade Pact", Help = "TXT_KEY_ITG_RESOLUTION_HELP_35", AIValueFunction = GetAIValueResolution35, SpecialTag = "ancientL", NormalAnswer = true},
{ID = 36, Name = "Knowledge-Sharing", Help = "TXT_KEY_ITG_RESOLUTION_HELP_36", AIValueFunction = GetAIValueResolution36, SpecialTag = "ancientL", NormalAnswer = true, OnAdoptedResolution = DoShareOneTechWithinLeague},
{ID = 37, Name = "Harmonisation of Beliefs", Help = "TXT_KEY_ITG_RESOLUTION_HELP_37", AIValueFunction = GetAIValueResolution37, SpecialTag = "ancientL", NormalAnswer = true, OnAdoptedResolution = DoInitPantheonBeliefsHarmony},
{ID = 38, Name = "PROJECT: Festival", HelpFunc = LeagueHelpFuncITG38, AIValueFunction = GetAIValueResolution38, SpecialTag = "ancientL", NormalAnswer = true, Project = true},
{ID = 39, Name = "PROJECT: Code of Laws", HelpFunc = LeagueHelpFuncITG39, AIValueFunction = GetAIValueResolution39, SpecialTag = "ancientL", NormalAnswer = true, Project = true},
{ID = 40, Name = "PROJECT: Monument", HelpFunc = LeagueHelpFuncITG40, AIValueFunction = GetAIValueResolution40, SpecialTag = "ancientL", NormalAnswer = true, Project = true, UniqueCantDoFuncC = UCDCFuncCant40},
{ID = 41, Name = "Free City-States", Help = "TXT_KEY_ITG_RESOLUTION_HELP_41", AIValueFunction = GetAIValueResolution41, SpecialTag = "ancientL", NormalAnswer = true, OnAdoptedResolution = DoInitCityStatesFree}, 
{ID = 42, Name = "Total War", ExtraChoice = true, FuncName = ToPFuncName42, HelpFunc = LeagueHelpFuncITG42, SpecialTag = "ancientL", SpecialTag2 = "LoN", NormalAnswer = true, AIValueFunction = GetAIValueResolution42, OnAdoptedResolution = DoTotalWarLeague, ExtraListFunc = ELFTopFunc42, MainIconFunc = ToPMainIconFunc2, OnGoodbye = ToPLeagueRemoveTotalWarGoodbye, OnRemovedResolution = ToPLeagueRemoveTotalWar, OnWelcome = ToPLeagueAddTotalWar, PriorityResolve = true},
{ID = 43, Name = "Olympic Games", Help = "TXT_KEY_ITG_RESOLUTION_HELP_43", AIValueFunction = GetAIValueResolution43, SpecialTag = "ancientL", NormalAnswer = true, OnAdoptedResolution = DoInitOlympicGames, UniqueCantDoFuncC = UCDCFuncCant43, OnAdoptedResolution = DoStartOlympiada},
{ID = 44, Name = "Tournament", ExtraChoice = true, FuncName = ToPFuncName44, Help = "TXT_KEY_ITG_RESOLUTION_HELP_44", NormalAnswer = true, SpecialTag = "ancientL", Project = true,  AIValueFunction = GetAIValueResolution44, ExtraListFunc = ELFTopFunc44},
{ID = 45, Name = "Seeking Seeker", Help = "TXT_KEY_ITG_RESOLUTION_HELP_45", AIValueFunction = GetAIValueResolution45, NormalAnswer = true, SpecialTag = "ancientL", Project = true},
{ID = 46, Name = "Archaeological Rights", Help = "TXT_KEY_ITG_RESOLUTION_HELP_46", NormalAnswer = true, AIValueFunction = GetAIValueResolution46, SpecialTag = "LoN"},
{ID = 47, Name = "Solve Poverty", Help = "TXT_KEY_ITG_RESOLUTION_HELP_47", NormalAnswer = true, AIValueFunction = GetAIValueResolution47, SpecialTag = "LoN", EndTurnFunction = ToPDoSolvePoority, OnAdoptedResolution = ToPDoSolvePoority, OnGoodbye = ToPDoRemoveCostsPoverty, OnRemovedResolution = ToPLeagueRemoveSolvingPoverty},
{ID = 48, Name = "Demilitarization", Help = "TXT_KEY_ITG_RESOLUTION_HELP_48", NormalAnswer = true, AIValueFunction = GetAIValueResolution48, SpecialTag = "LoN", OnAdoptedResolution = ToPDoDemilitiarization, OnGoodbye = ToPDoRemoveDemilitarization, OnRemovedResolution = ToPLeagueRemoveDemilitarization},
{ID = 49, Name = "Health Organization", Help = "TXT_KEY_ITG_RESOLUTION_HELP_49", NormalAnswer = true, AIValueFunction = GetAIValueResolution49, SpecialTag = "LoN"},
{ID = 50, Name = "Global Ideology", FuncName = ToPFuncName50, Help = "TXT_KEY_ITG_RESOLUTION_HELP_50", AIValueFunction = GetAIValueResolution50, SpecialTag = "ResDisabled", CannotBeRepealed = true, OnRemovedResolution = ToPLeagueRemoveIdeologySupport, OnAdoptedResolution = ToPDoSupportIdeology, FuncAnswers = GetFuncAnswersProp50},
{ID = 51, Name = "Globalization", Help = "TXT_KEY_ITG_RESOLUTION_HELP_51", NormalAnswer = true, AIValueFunction = GetAIValueResolution51, SpecialTag = "LoN", EndTurnFunction = ToPDoGlobalCulture},
{ID = 52, Name = "Denounce Warmongers", Help = "TXT_KEY_ITG_RESOLUTION_HELP_52", NormalAnswer = true, AIValueFunction = GetAIValueResolution52, SpecialTag = "LoN", OnAdoptedResolution = ToPDoDenounceWarmongering, EndTurnFunction = ToPDoDenounceWarmongering, OnRemovedResolution = ToPLeagueRemoveWarmongerDenounce, OnGoodbye = ToPDoRemoveWarmongerDenounceOnePlayer},
{ID = 53, Name = "Public Education", Help = "TXT_KEY_ITG_RESOLUTION_HELP_53", NormalAnswer = true, AIValueFunction = GetAIValueResolution53, SpecialTag = "LoN"},
{ID = 54, Name = "Open Migration", Help = "TXT_KEY_ITG_RESOLUTION_HELP_54", NormalAnswer = true, AIValueFunction = GetAIValueResolution54, SpecialTag = "LoN"},
{ID = 55, Name = "Outlaw Mercenaries", Help = "TXT_KEY_ITG_RESOLUTION_HELP_55", NormalAnswer = true, AIValueFunction = GetAIValueResolution55, SpecialTag = "LoN"},
{ID = 56, Name = "Stabilization", Help = "TXT_KEY_ITG_RESOLUTION_HELP_56", NormalAnswer = true,  AIValueFunction = GetAIValueResolution56, SpecialTag = "LoN"},
{ID = 57, Name = "Research organizations", Help = "TXT_KEY_ITG_RESOLUTION_HELP_57", NormalAnswer = true,  AIValueFunction = GetAIValueResolution57, SpecialTag = "LoN"},
{ID = 58, Name = "Force Peace", Help = "TXT_KEY_ITG_RESOLUTION_HELP_58", NotResolution = true,  AIValueFunction = GetAIValueResolution58, SpecialTag = "LoN", FuncName = ToPFuncName58, NormalAnswer = true, OnAdoptedResolution = ToPForcePeace, ExtraChoice = true, ExtraListFunc = ELFTopFunc58},
{ID = 59, Name = "New Idea", Help = "TXT_KEY_ITG_RESOLUTION_HELP_59", NotResolution = true, SpecialTag = "ResDisabled", AIValueFunction = GetAIValueResolution59, FuncAnswers = GetFuncAnswersProp59},
{ID = 60, Name = "Common Progress", Help = "TXT_KEY_ITG_RESOLUTION_HELP_60", SpecialTag = "IdeologyL", NumChoices = 3, ExtraListFunc = ELFTopFunc60, AfterHelp = "TXT_KEY_ITG_RESOLUTION_AFTERHELP_60", FuncAnswers = GetFuncAnswersProp60},
{ID = 61, Name = "Legalize Conquest", Help = "TXT_KEY_ITG_RESOLUTION_HELP_61", NotResolution = true, NormalAnswer = true, AIValueFunction = GetAIValueResolution61, SpecialTag = "LoN", OnAdoptedResolution = ToPDoLegalizeConquest},
{ID = 62, Name = "Free Trade", Help = "TXT_KEY_ITG_RESOLUTION_HELP_62", NormalAnswer = true, AIValueFunction = GetAIValueResolution62, SpecialTag = "LoN", OnAdoptedResolution = ToPDoStartOpenTrade, OnGoodbye = ToPDoRemoveOpenTrade, OnRemovedResolution = ToPLeagueRemoveOpenTrade},
{ID = 63, Name = "Condemn Espionage", Help = "TXT_KEY_ITG_RESOLUTION_HELP_63", ProvidesVotes = true, SpecialVoteFunc = ProvideVotesRes63, NormalAnswer = true, AIValueFunction = GetAIValueResolution63, SpecialTag = "LoN", OnAdoptedResolution = ToPDoCondemnEspionage, OnGoodbye = ToPDoRemoveCondemnEspionage, OnRemovedResolution = ToPEndCondemnEspionage},
{ID = 64, Name = "ACTION: Unify Laws", AIValueFunction = GetAIValueResolution64, Help = "TXT_KEY_ITG_RESOLUTION_HELP_64", Instant = true, Action = true, Cooldown = 4, Cost = 5, Above = true, UniqueCantDoFuncC = UCDCFuncCant64},
{ID = 65, Name = "Indulgences", SpecialTag = "ChristianL", Help = "TXT_KEY_ITG_RESOLUTION_HELP_65", AfterHelp = "TXT_KEY_ITG_RESOLUTION_AFTERHELP_65", HelpFunc = League65HelpFunc, FuncAnswers = GetFuncAnswersProp65},
{ID = 66, Name = "Exploration", Help = "TXT_KEY_ITG_RESOLUTION_HELP_66", SpecialTag = "IslamL", Instant = true},
{ID = 67, Name = "Deus Vult", Help = "TXT_KEY_ITG_RESOLUTION_HELP_67", SpecialTag = "ChristianL", AfterHelp = "TXT_KEY_ITG_RESOLUTION_AFTERHELP_67", HelpFunc = LeagueDeusVultHelpFunc, FuncAnswers = GetFuncAnswersProp67},
}

function FPH913(exInfo)
	return "This league has special assets of rules. Proposals are forced in certain order on set turns:" .. exInfo .. "[NEWLINE]Resolutions can be proposed only once and cannot be reenacted. There are no Votes' modifiers from voting.";
end

function FPH2756(exInfo)
	return "Base rewards from being a Caliph are multiplied by " .. gT.Globals.CaliphateMod .. ".";
end

local fakeProposalHelps = {
[910] = {Help = "TXT_KEY_ITG_RESOLUTION_HELP_910"},
[1589] = {Help = "TXT_KEY_ITG_RESOLUTION_HELP_1589"},
[914] = {Help = "TXT_KEY_ITG_RESOLUTION_HELP_914"},
[915] = {Help = "TXT_KEY_ITG_RESOLUTION_HELP_915"},
[913] = {HelpFunc = FPH913},
[6564] = {Help = "TXT_KEY_ITG_RESOLUTION_HELP_6564"},
[912] = {Help = "TXT_KEY_ITG_RESOLUTION_HELP_912"},
[6789] = {Help = "TXT_KEY_ITG_RESOLUTION_HELP_6789"},
[2756] = {HelpFunc = FPH2756},
[911] = {Help = "TXT_KEY_ITG_RESOLUTION_HELP_911"},
}

function GetProperResolutionHelp(resID, extraInfo, bIgnoreAfterHelp)
	if TabOfProposals[resID] then
		if TabOfProposals[resID].HelpFunc then
			return TabOfProposals[resID].HelpFunc(extraInfo);
		elseif TabOfProposals[resID].AfterHelp and (not bIgnoreAfterHelp) then
			return Locale.Lookup(TabOfProposals[resID].AfterHelp);
		elseif TabOfProposals[resID].Help then
			return Locale.Lookup(TabOfProposals[resID].Help);
		end
	elseif fakeProposalHelps[resID] then
		if fakeProposalHelps[resID].HelpFunc then
			return fakeProposalHelps[resID].HelpFunc(extraInfo);
		elseif fakeProposalHelps[resID].Help then
			return Locale.Lookup(fakeProposalHelps[resID].Help);
		end
	end
	return "Error 53/31/x/12/ Res: " .. resID;
end

LuaEvents.ITGSG_RequestHelpTextResolution.Add(function(a,b)
	MapModData.ITGSG = GetProperResolutionHelp(a, b)
end)

function GetSpecialResolutionsTab(sTag, leagueID, oPlayer, type)
	local tab = {}
	for i, sth in pairs(TabOfProposals) do
		if ((sth.SpecialTag == sTag) or (sth.SpecialTag2 == sTag)) and (not sth.Action) then
			if CanBeProposedRightNow(leagueID, i, type or 1, oPlayer) then
				table.insert(tab, {ID = i, Text = sth.Name, ToolTip = GetProperResolutionHelp(i, nil, true), ExtraChoice = sth.ExtraChoice})
			end
		end
	end
	return tab;
end

function GetInfoFromTabOfProposal(resolution, type)
	return TabOfProposals[resolution][type];
end

function RequestLeagueProposals()
	return TabOfProposals;
end

function GetNiceInitialResForSpecialLeague(amount, bTab)
	local tab = {}
	local ftab = {}
	for i, sth in pairs(TabOfProposals) do
		if sth.CanBeInitial then
			if (not bTab) or (not bTab[i]) then
				table.insert(tab, i)
			end
		end
	end
	tab = Shuffle(tab)
	for i = 1, amount do
		if tab[i] then
			table.insert(ftab, tab[i])
		end
	end
	return ftab;
end

function GetTabOfValidVoteResolutions(cUIDl)
	local tab = {}
	for i, sth in pairs(TabOfProposals) do
		if sth.CanBeInitial then
			if CanBeProposedRightNow(cUIDl, i, 1) then
				table.insert(tab, {ID = i, Text = sth.Name, ToolTip = GetProperResolutionHelp(i, nil, true)})
			end
		end
	end
	return tab;
end

function AddAMemberToLeague(niceUID, iPlayer)
	local mTeam = Players[iPlayer]:GetTeam();
	local bIsMinorCiv = Players[iPlayer]:IsMinorCiv();
	--new stuff for major/minor decay fix
	if not gT.Leagues[niceUID].SpecialProposalTag then
		for member, sth in pairs(gT.Leagues[niceUID].Members) do
			if not Teams[mTeam]:IsHasMet(Players[member]:GetTeam()) then
				if Players[member]:IsAlive() and Players[iPlayer]:IsAlive() then
					Teams[mTeam]:Meet(Players[member]:GetTeam())
				end
			end
			if not Players[member]:IsMinorCiv() then
				if bIsMinorCiv then
					gT.Players[member].LeagueCityStatesDecay[iPlayer] = (gT.Players[member].LeagueCityStatesDecay[iPlayer] or 0 ) + 1;
					if gT.Players[member].LeagueCityStatesDecay[iPlayer] == 1 then
						Players[iPlayer]:ChangeMinorCivDecayModWithMajor(member, -20);
					end
				end
			elseif not bIsMinorCiv then
				gT.Players[iPlayer].LeagueCityStatesDecay[member] = (gT.Players[iPlayer].LeagueCityStatesDecay[member] or 0 ) + 1;
				if gT.Players[iPlayer].LeagueCityStatesDecay[member] == 1 then
					Players[member]:ChangeMinorCivDecayModWithMajor(iPlayer, -20);
				end
			end
		end
	end
	gT.Leagues[niceUID].Members[iPlayer] = {VotesTimeModifiers = {}, VotesFromScripts = {}, InitProposal = false, LastProposal = -1, Votes = 0, VotesFromResolution = {}, HelpPoints = {}};
	for idR, sth in pairs(gT.Leagues[niceUID].Resolutions) do
		local pID = sth.ResID;
		if TabOfProposals[pID].ProvidesVotes then
			gT.Leagues[niceUID].Members[iPlayer].HelpPoints[pID] = 0;
		end
		if TabOfProposals[sth.ResID] and TabOfProposals[sth.ResID].OnWelcome then
			TabOfProposals[sth.ResID].OnWelcome(iPlayer, niceUID, sth.ExtraInfo)
		end
	end
	--new stuff for total war
	for league, lData in pairs(gT.Leagues) do
		if league ~= niceUID then
			for res, resData in pairs(lData.Resolutions) do
				if (resData.ResID == 42) and (resData.ExtraInfo == niceUID) then -- ongoing total war
					local pTeam = Players[iPlayer]:GetTeam();
					for member, mData in pairs(lData.Members) do
						DoTriggerTotalWarBetween(Players[member]:GetTeam(), pTeam, member, iPlayer)
					end
				end
			end
		end
	end
end

function CreateNewLeague(iPlayer, sPlayer, bInitial)
	local gName = GetNiceThematicNameForLeague(iPlayer, sPlayer)
	local niceUID = iPlayer .. "x" .. sPlayer;
	while gT.Leagues[niceUID] do
		niceUID = niceUID .. "s" .. LastRandom(0,9);
	end
	gT.Leagues[niceUID] = {Members = {}, Vetos = {}, ActionCooldowns = {}, ActionLog = {}, HasInitialProposals = true, Name= gName, Resolutions = {}, Proposals = {}, ProposalsHistory = {}};
	AddAMemberToLeague(niceUID, iPlayer)
	AddAMemberToLeague(niceUID, sPlayer)
	
	if gT.Globals.GameGenerated then
		gT.Leagues[niceUID].TurnFoundString = GetTextDate(GetITGGameTurn(), gT.Globals.StartDate)
		ChangeMeritocracy(iPlayer, 8)
		ChangeMeritocracy(sPlayer, 8)
		if gT.Leagues[niceUID].HasInitialProposals then
			DoInitialResolutionForPlayer(iPlayer, niceUID);
			DoInitialResolutionForPlayer(sPlayer, niceUID);
		end
	else
		gT.Leagues[niceUID].TurnFoundString = GetTextDate(LastRandom(-200, -1), gT.Globals.StartDate)
		local tab = Shuffle(GetTabOfValidVoteResolutions(niceUID));
		AddNewResolution(niceUID, tab[1].ID, iPlayer)
		AddNewResolution(niceUID, tab[2].ID, sPlayer)
		for iPlayer, sth in pairs(gT.Leagues[niceUID].Members) do
			gT.Leagues[niceUID].Members[iPlayer].InitProposal = true;
			UpdateMemberVotesInLeague(iPlayer, niceUID)
		end
	end
end

function DoRemoveEffectsFromLeague(badPlayer, uid)
	for i, data in pairs(gT.Leagues[uid].Members[badPlayer].WarLocks or {}) do
		ChangePeaceWarLock(data[1], badPlayer, -1, "League31")
	end
	if gT.Leagues[uid].Members[badPlayer].ExtraCodexInfluence then
		gT.Players[badPlayer].CodexInfluenceFromLeague = gT.Players[badPlayer].CodexInfluenceFromLeague - gT.Leagues[uid].Members[badPlayer].ExtraCodexInfluence;
		gT.Leagues[uid].Members[badPlayer].ExtraCodexInfluence = nil;
	end
	for member, s in pairs(gT.Leagues[uid].Members) do
		if member ~= badPlayer then
			local ph = {}
			for i, data in pairs(s.WarLocks or {}) do
				if data[2] == badPlayer then
					ChangePeaceWarLock(data[1], member, -1, "League31")
					table.insert(ph, i)
				end
			end
			local t = #ph;
			for i = 1, t do
				table.remove(gT.Leagues[uid].Members[member].WarLocks, ph[t + 1 - i])
			end
		end
	end
	if gT.Leagues[uid].Host == badPlayer then
		gT.Leagues[uid].Host = nil;
	end
	for idR, sth in pairs(gT.Leagues[uid].Resolutions) do
		if TabOfProposals[sth.ResID] and TabOfProposals[sth.ResID].OnGoodbye then
			TabOfProposals[sth.ResID].OnGoodbye(badPlayer, uid, sth.ExtraInfo)
		end
	end
	for a, b in pairs(gT.Leagues) do -- other leagues total war against this league
		for c, d in pairs(b.Resolutions) do
			if d.ResID == 42 and d.ExtraInfo == uid then
				for e, f in pairs(b.Members) do
					ChangePeaceWarLock(e, badPlayer, -1, "TotalWar")
				end
			end
		end
	end
	if not gT.Leagues[uid].SpecialProposalTag then -- take care of minordecay mod
		if Players[badPlayer]:IsMinorCiv() then
			for member, sth in pairs(gT.Leagues[uid].Members) do
				if not Players[member]:IsMinorCiv() then
					gT.Players[member].LeagueCityStatesDecay[badPlayer] = gT.Players[member].LeagueCityStatesDecay[badPlayer] - 1;
					if gT.Players[member].LeagueCityStatesDecay[badPlayer] == 0 then
						Players[badPlayer]:ChangeMinorCivDecayModWithMajor(member, 20);
					end
				end
			end
		else
			for member, sth in pairs(gT.Leagues[uid].Members) do
				if Players[member]:IsMinorCiv() then
					gT.Players[badPlayer].LeagueCityStatesDecay[member] = gT.Players[badPlayer].LeagueCityStatesDecay[member] - 1;
					if gT.Players[badPlayer].LeagueCityStatesDecay[member] == 0 then
						Players[member]:ChangeMinorCivDecayModWithMajor(badPlayer, 20);
					end
				end
			end
		end
	end
	gT.Leagues[uid].Members[badPlayer] = nil;
end

function DoEndLeagueProperly(uid)
--here is total war
	LogDestructionOfIdeologyDominationMode(uid)
	for a, b in pairs(gT.Leagues) do
		for c, d in pairs(b.Resolutions) do
			if d.ResID == 42 and d.ExtraInfo == uid then
				DoRemoveResolution(a, c, 42, d.ExtraInfo)
			end
		end
	end
	for member, sth in pairs(gT.Leagues[uid].Members) do
		DoRemoveEffectsFromLeague(member, uid)
	end
	gT.Leagues[uid] = nil;
end

function CanLeagueExistWithoutMember(uid, badPlayer)
	local majorTab = {};
	local cmajor = 0;
	if (not gT.Leagues[uid].DoFindepedent) then
		for member, h in pairs(gT.Leagues[uid].Members) do
			if not Players[member]:IsMinorCiv() then
				if member ~= badPlayer then
					cmajor = cmajor + 1;
					majorTab[member] = true;
				end
			end
		end
		for l, h in pairs(gT.Leagues) do
			if (l ~= uid) and (not h.DoFindepedent) then
				local clc = 0;
				for member, h in pairs(h.Members) do
					if majorTab[member] then
						clc = clc + 1;
					end
				end
				if clc == cmajor then
					return false; -- there is another league that covers all league members
				end
			end
		end
	end
	return true;
end

function RemovePlayerFromLeague(badPlayer, uid, bReason)
	if bReason == "War" then
		DoPenaltyFromBreakingLeague(badPlayer, uid)
	end
	local c = 0;
	for t, h in pairs(gT.Leagues[uid].Members) do
		if not Players[t]:IsMinorCiv() then
			if badPlayer ~= t then
				c = c + 1;
			end
		end
	end
	local extradofstoend = {}
	local cString = gT.Leagues[uid].Name
	if (c < 2) or (gT.Leagues[uid].BreaksIfHalforLess and IsHalfOrLessInLeague(uid, -1)) or (not CanLeagueExistWithoutMember(uid, badPlayer)) then
		for ji, iHuman in pairs(gT.Globals.HumanPlayers) do
			if gT.Leagues[uid].Members[iHuman] then
				if iHuman ~= badPlayer then
					if bReason == "War" then
						Players[iHuman]:AddNotification(94343293, Players[badPlayer]:GetName() .. " has betrayed you, breaking the " .. cString .. " and starting a war!", "League disbanded!", -1, -1, 36)
					elseif bReason == "Legal" then
						Players[iHuman]:AddNotification(94343293, Players[badPlayer]:GetName() .. " has left " .. cString .. " which no longer fulfills its purpose. Remaining members decided to disband league!", "League disbanded!", -1, -1, 36)
					elseif bReason == "Excluded" then
						Players[iHuman]:AddNotification(94343293, Players[badPlayer]:GetName() .. " has been excluded from " .. cString .. " which no longer fulfills its purpose. Remaining members decided to disband league!", "League disbanded!", -1, -1, 36)
					elseif bReason == "TotalWar" then
						Players[iHuman]:AddNotification(94343293, Players[badPlayer]:GetName() .. " was forced to abandon " .. cString .. " which no longer fulfills its purpose. Remaining members decided to disband league!", "League disbanded!", -1, -1, 36)
					elseif bReason == "DefensivePact" then
						Players[iHuman]:AddNotification(94343293, Players[badPlayer]:GetName() .. " ended the " .. cString .. " by declaring war on civilization that is bounded by Defensive Pact with other member!", "League disbanded!", -1, -1, 36)
					else
						Players[iHuman]:AddNotification(94343293, Players[badPlayer]:GetName() .. " lost the legitimacy, which ended the " .. cString .. "!", "League disbanded!", -1, -1, 36)
					end
				end
			end
		end
		DoEndLeagueProperly(uid);
	else
		DoRemoveEffectsFromLeague(badPlayer, uid)
		if bReason ~= "EndEra" then
			for hString, sss in pairs(gT.Leagues[uid].Proposals) do
				if sss.ProposedBy == badPlayer then
					gT.Leagues[uid].Proposals[hString] = nil;
				else
					PlayerProposalAnswer(nil, uid, hString, nil, true)
				end
			end
			if gT.Leagues[uid].ProposalsEndTurn then
				local lkey;
				for h, v in pairs(gT.Leagues[uid].ProposalsEndTurn) do
					if v[2] == badPlayer then
						lkey = h;
					end
				end
				if lkey then
					table.remove(gT.Leagues[uid].ProposalsEndTurn, lkey)
				end
			end
			local lAIkey, humKey;
			for ji, actiondata in pairs(gT.Players[badPlayer].QueueActionsRealEndTurn or {}) do
				if actiondata[1] == "LeagueForcedResolution" then
					if actiondata[2] == uid then
						lAIkey = ji;
					end
				end
			end
			if lAIkey then
				table.remove(gT.Players[badPlayer].QueueActionsRealEndTurn, lAIkey)
			end
			for ji, actiondata in pairs(gT.Players[badPlayer].QueueActionsRealEndTurn or {}) do
				if actiondata[1] == "LeagueForcedResolution" then
					if actiondata[2] == uid then
						humKey = ji;
					end
				end
			end
			for member, sth in pairs(gT.Leagues[uid].Members) do
				if NoReasonToDoFMemberAnymore(badPlayer, member, uid) then
					table.insert(extradofstoend, member);
				end
			end
			if humKey then
				table.remove(gT.Players[badPlayer].QueueActionsRealEndTurn, humKey);
				RefreshAllDirtyPlayer()
			end
			for ji, iHuman in pairs(gT.Globals.HumanPlayers) do
				if gT.Leagues[uid].Members[iHuman] then
					if iHuman ~= badPlayer then
						if bReason == "War" then
							Players[iHuman]:AddNotification(94343293, Players[badPlayer]:GetName() .. " betrayed a " .. cString .. ", starting a war against one of the members!", "Member removed!", -1, -1, 36, badPlayer)
						elseif bReason == "Legal" then
							Players[iHuman]:AddNotification(94343293, Players[badPlayer]:GetName() .. " no longer believes in an institution of " .. cString .. " and revoked the membership!", "Member left!", -1, -1, 36, badPlayer)
						elseif bReason == "Excluded" then
							Players[iHuman]:AddNotification(94343293, Players[badPlayer]:GetName() .. " has been excluded from " .. cString .. "!", "Member removed!", -1, -1, 36, badPlayer)
						elseif bReason == "City-State" then
							Players[iHuman]:AddNotification(94343293, Players[badPlayer]:GetName() .. " could no longer be tolerated in " .. cString .. "!", "Member removed!", -1, -1, 36, badPlayer)
						elseif bReason == "Schism" then
							Players[iHuman]:AddNotification(94343293, Players[badPlayer]:GetName() .. "'s beliefs are not longer tolerated in " .. cString .. "!", "Member removed!", -1, -1, 36, badPlayer)
						elseif bReason == "TotalWar" then
							Players[iHuman]:AddNotification(94343293, Players[badPlayer]:GetName() .. " was forced to abandon " .. cString .. ".", "Member removed!", -1, -1, 36, badPlayer)
						elseif bReason == "DefensivePact" then
							Players[iHuman]:AddNotification(94343293, Players[badPlayer]:GetName() .. " left " .. cString .. " by declaring war on civilization that is bounded by Defensive Pact with other member!", "Member removed!", -1, -1, 36, badPlayer)
						elseif bReason == "LiberDom" then
							Players[iHuman]:AddNotification(94343293, Players[badPlayer]:GetName() .. " was military persuased to abandon " .. cString .. " and start following other ideology!", "Member left!", -1, -1, 36, badPlayer)
						else
							Players[iHuman]:AddNotification(94343293, Players[badPlayer]:GetName() .. " lost the legitimacy, which resulted in removal from " .. cString .. "!", "Member removed!", -1, -1, 36, badPlayer)
						end
					end
				end
			end
		end
	end
	if Players[badPlayer]:IsHuman() then
		if bReason == "War" then
			Players[badPlayer]:AddNotification(94343293, "You decided that " .. cString .. " is a root of all evil and broke all agreements!", "League abandoned!", -1, -1, 36)
		elseif bReason == "Legal" then
			Players[badPlayer]:AddNotification(94343293, "You have legally left " .. cString .. ". It is no longer your business.", "League abandoned!", -1, -1, 36)
		elseif bReason == "Excluded" then
			Players[badPlayer]:AddNotification(94343293, "You have been excluded from " .. cString .. "!", "League abandoned!", -1, -1, 36)
		elseif bReason == "Schism" then
			Players[badPlayer]:AddNotification(94343293, "Your beliefs are not longer tolerated in " .. cString .. "!", "League abandoned!", -1, -1, 36)
		elseif bReason == "DefensivePact" then
			Players[badPlayer]:AddNotification(94343293, "You can no longer be a member of " .. cString .. ", because you attacked civilization that is bounded by Defensive Pact with other member!", "League abandoned!", -1, -1, 36)
		elseif bReason == "TotalWar" then
			Players[badPlayer]:AddNotification(94343293, "You can no longer be a member of " .. cString .. ", because your obligations from other league forced you to declare war on other member!", "League abandoned!", -1, -1, 36)
		else
			Players[badPlayer]:AddNotification(94343293, "You can no longer be a member of " .. cString .. ", because of your lack of legitimacy!", "League abandoned!", -1, -1, 36)
		end
	end
	for a, player in pairs(extradofstoend) do
		Players[badPlayer]:DoEndDoF(player, false)
	end
end

function HandleAILeagueResolutions(iPlayer)
	for leagueNID, sth in pairs(gT.Leagues) do
		if sth.Members[iPlayer] then
			for hs, pData in pairs(sth.Proposals) do
				if pData.ProposedBy ~= iPlayer then
					if not pData.PlayersAnswers[iPlayer] then
						if pData.Special and (not pData.NormalAnswer) then
							DoMakeScriptedAnswer(iPlayer, leagueNID, hs)
						else
							DoAIAnswerResolution(iPlayer, leagueNID, hs)
						end	
					end
				end
			end
			if not Players[iPlayer]:IsMinorCiv() then
				if sth.SpecialProposalTag then
					DoSomeAILogicForScriptedLeagues(leagueNID, iPlayer, sth.SpecialProposalTag);
				else
					if GetITGGameTurn() ~= 100 then
						if LastRandom(1,10) == 3 then
							--AI will randomly propose for now
							local bSelection = GetAIBestProposal(iPlayer, leagueNID, false, 35);
							if bSelection then
								local cCall = {[1] = 1, [2] = 1}
								if sth.Members[iPlayer].Votes > 7 then
									if not gT.Leagues[leagueNID].Resolutions[14] then
										cCall[3] = 1;
									end
								end
								local hString = bSelection[1];
								if bSelection[3] then
									hString = hString .. "x" .. bSelection[3]
								end
						--		local bRenact = gT.Leagues[leagueNID].Resolutions[hString] ~= nil
								local aimtype = GetAIAimTypeForAnswer(leagueNID, iPlayer, hString, false, bSelection[2], bSelection[1])
								if aimtype == "aAccept" then
									if cCall[3] and LastRandom(1, 2) == 1 then
										PlayerProposeChangeToLeague(leagueNID, bSelection[1], iPlayer, bSelection[3], 3);
									elseif LastRandom(1, 2) == 1 then
										PlayerProposeChangeToLeague(leagueNID, bSelection[1], iPlayer, bSelection[3], 2);
									else
										PlayerProposeChangeToLeague(leagueNID, bSelection[1], iPlayer, bSelection[3], 1);
									end
								elseif aimtype == "aRatherAccept" then
									if cCall[3] and LastRandom(1, 6) == 1 then
										PlayerProposeChangeToLeague(leagueNID, bSelection[1], iPlayer, bSelection[3], 3);
									elseif LastRandom(1, 3) == 1 then
										PlayerProposeChangeToLeague(leagueNID, bSelection[1], iPlayer, bSelection[3], 2);
									else
										PlayerProposeChangeToLeague(leagueNID, bSelection[1], iPlayer, bSelection[3], 1);
									end
								elseif aimtype == "aActRandomly" then
									if cCall[3] and LastRandom(1, 12) == 1 then
										PlayerProposeChangeToLeague(leagueNID, bSelection[1], iPlayer, bSelection[3], 3);
									elseif LastRandom(1, 4) == 1 then
										PlayerProposeChangeToLeague(leagueNID, bSelection[1], iPlayer, bSelection[3], 2);
									else
										PlayerProposeChangeToLeague(leagueNID, bSelection[1], iPlayer, bSelection[3], 1);
									end
								else
									print("league proposal is weak: ", bSelection[2], aimtype) 
								end
							end
						end
					end
				end
			end
		end
	end
end

function GetAIAnswerToResolution(iPlayer, leagueNID, hs)
	local lAnswer = {1,5}
	if gT.Leagues[leagueNID].Members[iPlayer].Votes > 4 then
		if not gT.Leagues[leagueNID].Resolutions[14] then
			if not Players[iPlayer]:IsMinorCiv() then
				table.insert(lAnswer, 4)
			end
		end
	end
	if not gT.Leagues[leagueNID].Resolutions[13] then
		if not Players[iPlayer]:IsMinorCiv() then
			if gT.Leagues[leagueNID].Members[iPlayer].Votes >= gT.Leagues[leagueNID].Proposals[hs].DelayCost then
				if gT.Leagues[leagueNID].Proposals[hs].DelayCost <= 4 then
				--ai should never spend 16 votes on delay
					table.insert(lAnswer, 3)
				end
			end
		end
	end
	local nMemb = 0;
	for member, sth in pairs(gT.Leagues[leagueNID].Members) do
		nMemb = nMemb + 1;
	end
	if nMemb > 2 then
		table.insert(lAnswer, 2)
	end
	local cAnswer = {}
	for i, s in pairs(lAnswer) do
		cAnswer[s] = 1;
	end
	local bRenact = (gT.Leagues[leagueNID].Resolutions[hs] ~= nil)
	local gResolutionLikeness = TabOfProposals[gT.Leagues[leagueNID].Proposals[hs].ResolutionID].AIValueFunction(iPlayer, leagueNID, gT.Leagues[leagueNID].Proposals[hs].ExtraInfo, bRenact, gT.Leagues[leagueNID].Proposals[hs].ResolutionID)
	local aimType = GetAIAimTypeForAnswer(leagueNID, iPlayer, hs, bRenact, gResolutionLikeness)
	local turnsToEnd = gT.Globals.LastTurn - GetITGGameTurn();
	local delayCost = gT.Leagues[leagueNID].Proposals[hs].DelayCost
	local votes = gT.Leagues[leagueNID].Members[iPlayer].Votes
	local proposalvotes = 0;
	if gT.Leagues[leagueNID].Members[gT.Leagues[leagueNID].Proposals[hs].ProposedBy] then
		proposalvotes = gT.Leagues[leagueNID].Members[gT.Leagues[leagueNID].Proposals[hs].ProposedBy].Votes
	end
	if cAnswer[3] then
		if turnsToEnd > 10 then
			if delayCost / votes > 0.25 then
				cAnswer[3] = nil;
			end
		end
	end
--	print("AI answer type", iPlayer, leagueNID, hs, aimType, bRenact, gResolutionLikeness)
	if aimType == "aAccept" then
		if cAnswer[2] then
			if LastRandom(1,gT.Leagues[leagueNID].AISupportVal or 4) == 1 then
				return 2;
			end
		end
		if LastRandom(1, 35) == 1 then
			if LastRandom(1,2) == 1 then
				if cAnswer[3] then
					return 3;
				end
			end
			return 5;
		end
		return 1;
	elseif aimType == "aRatherAccept" then
		if cAnswer[2] then
			if LastRandom(1,gT.Leagues[leagueNID].AISupportVal or 5) == 1 then
				return 2;
			end
		end
		if cAnswer[3] then
			if LastRandom(1,3) == 2 then
				return 3;
			end
		end	
		if LastRandom(1, 75) == 1 then
			return 5;
		end
		return 1;
	elseif aimType == "aDeny" then
		if cAnswer[3] then
			if delayCost == 1 then
				return 3;
			elseif delayCost / votes < 0.2 then
				if LastRandom(1,4) ~= 3 then
					return 3;
				end
			end
		end
		if cAnswer[4] then
			if proposalvotes > 7 then
				if LastRandom(1, proposalvotes) > 6 then
					return 4;
				end
			end
		end
		return 5;
	elseif aimType == "aHeavyDeny" then
		if cAnswer[3] then
			if delayCost == 1 then
				return 3;
			elseif delayCost / votes < 0.1 then
				if LastRandom(1,8) ~= 3 then
					return 3;
				end
			end
		end
		if cAnswer[4] then
			if proposalvotes > 7 then
				if LastRandom(1, proposalvotes) > 5 then
					return 4;
				end
			end
			if proposalvotes > 2 * votes then
				return 4;
			end
		end
		return 5;
	elseif aimType == "aActRandomly" then
		local tTab = {{1, 35}, {2, 10}, {5, 40}}
		if cAnswer[3] then
			table.insert(tTab, {3, 10})
		end
		if cAnswer[4] then
			table.insert(tTab, {4, 5})
		end
		return GetRandomFromBiasedChanceTable(tTab)
	end
	print("Woo, find no response somehow?")
end

function PlayerProposeChangeToLeague(leagueID, idR, iPlayer, extrainfo1, proposeStrength, bEndTurn)
	if TabOfProposals[idR].Action then
		gT.Leagues[leagueID].Members[iPlayer].LastAction = GetITGGameTurn() + LEAGUE_PROPOSE_CD;
		PlayerMadeActionInLeague(leagueID, idR, iPlayer, extrainfo1, TabOfProposals[idR].Cost, TabOfProposals[idR].Cooldown)
		return;
	end
	if iPlayer ~= -1 then
		if not gT.Leagues[leagueID].Members[iPlayer].InitProposal then
			if gT.Leagues[leagueID].HasInitialProposals then
				AddNewResolution(leagueID, idR, iPlayer)
				return;
			end
		end
	end
	if gT.Leagues[leagueID].ProposalsEndTurn and (not bEndTurn) then
		gT.Leagues[leagueID].Members[iPlayer].ForcedResolution = nil;
		table.insert(gT.Leagues[leagueID].ProposalsEndTurn, {idR, iPlayer, extrainfo1, proposeStrength})
		return
	end
	if not gT.Leagues[leagueID].ProposalsNoCD then
		gT.Leagues[leagueID].Members[iPlayer].LastAction = GetITGGameTurn() + LEAGUE_PROPOSE_CD;
	end
	local hString = idR;
	if extrainfo1 then
		hString = idR .. "x" .. extrainfo1;
	end
	if not gT.Leagues[leagueID].ProposalsHistory[hString] then
		gT.Leagues[leagueID].ProposalsHistory[hString] = {}
	end
	table.insert(gT.Leagues[leagueID].ProposalsHistory[hString], {ProposedBy = iPlayer, Turn = GetITGGameTurn()})
	if TabOfProposals[idR].SpecialTag then
		PlayerProposeSpecialChange(leagueID, idR, iPlayer, nil, extrainfo1)
		return;
	end
	gT.Leagues[leagueID].Proposals[hString] = {DelayCost = 1, ResolutionID = idR, ExtraInfo = extrainfo1, ProposalStrength = proposeStrength or -1, PlayersAnswers = {}, ProposedBy = iPlayer, Name = TabOfProposals[idR].Name}
	if TabOfProposals[idR].FuncName then
		gT.Leagues[leagueID].Proposals[hString].Name = TabOfProposals[idR].FuncName(extrainfo1, leagueID)
	end
end

function GetAvailableResolutionToPropose(type, player, cUIDl, bUI)
	if gT.Leagues[cUIDl].SpecialProposalTag then
		return GetSpecialProposalsScripted(gT.Leagues[cUIDl].SpecialProposalTag, player, type, cUIDl)
	end
	if (not gT.Leagues[cUIDl].Members[player].InitProposal) and gT.Leagues[cUIDl].HasInitialProposals then
		if type == 1 or type == 3 then
			return GetTabOfValidVoteResolutions(cUIDl);
		else
			return {};
		end
	end
	local hTab = {}
	if (gT.Leagues[cUIDl].Members[player].LastAction or -1) <= GetITGGameTurn() then
		if type == 1 or type == 3 then
			for i, resdata in pairs(TabOfProposals) do
				if (not resdata.SpecialTag) and (not resdata.Action) then
					local bEnabled, bDisabledText = CanBeProposedRightNow(cUIDl, i, 1, player);
					if bEnabled or (bUI and bDisabledText) then
						table.insert(hTab, {ID = i, Text = resdata.Name, ExtraChoice = resdata.ExtraChoice, ToolTip = GetProperResolutionHelp(i, nil, true), Disabled = (not bEnabled), DisabledText = bDisabledText})
					end
				end
			end
			--actions later for UI
			for i, resdata in pairs(TabOfProposals) do
				if (not resdata.SpecialTag) and (resdata.Action) then
					local bEnabled, bDisabledText = CanBeProposedRightNow(cUIDl, i, 1, player);
					if bEnabled or (bUI and bDisabledText) then
						table.insert(hTab, {ID = i, Text = resdata.Name, ExtraChoice = resdata.ExtraChoice, ToolTip = Locale.Lookup(resdata.Help), Disabled = (not bEnabled), DisabledText = bDisabledText})
					end
				end
			end
		end
		if (type == 2 or type == 3) then
			for i, resdata in pairs(TabOfProposals) do
				if (not resdata.SpecialTag) and (not resdata.Action) then
					local bEnabled, bDisabledText = CanBeProposedRightNow(cUIDl, i, 2, player)
					if bEnabled or (bUI and bDisabledText) then
						table.insert(hTab, {ID = i, Text = resdata.Name, ExtraChoice = resdata.ExtraChoice, ToolTip = GetProperResolutionHelp(i, nil, true), Disabled = (not bEnabled), DisabledText = bDisabledText})
					end
				end
			end
		end
	end
	return hTab;
end

function CallForResolutionAvailable(type, player, cUIDl)
	if not player then
		print("No game active player?", type, player, cUIDl)
		return;
	end
	MapModData.ITGSG = GetAvailableResolutionToPropose(type, player, cUIDl, true);
end
LuaEvents.ITGSG_RequestResolutionsForProposal.Add(CallForResolutionAvailable)

function CanBeProposedRightNow(leagueID, idR, type, iPlayer)
	if type == 1 then -- init check to make it not appear at all
		if gT.Leagues[leagueID].Resolutions[idR] then
			return false, nil;
		end
	else
		if not gT.Leagues[leagueID].Resolutions[idR] then
			return false, nil;
		end
	end
	if TabOfProposals[idR].UniqueCantDoFuncC and TabOfProposals[idR].UniqueCantDoFuncC(iPlayer, leagueID, idR, type) then
		return false, nil;
	end
	if type == 1 then
		if TabOfProposals[idR].ExtraChoice then
			if (not iPlayer) or (not HasAtLeastOneViableOptionForProposal(idR, type, leagueID, iPlayer)) then
				return false, "No valid options.";
			end
		elseif gT.Leagues[leagueID].ProposalsOnlyOnce then
			if gT.Leagues[leagueID].ProposalsHistory[idR] then
				return false; --
			end
		end
		if TabOfProposals[idR].Cost then
			if (not iPlayer) then
				return false, "Not enough [ICON_ITG_VOTES] Votes";
			end
			if gT.Leagues[leagueID].Members[iPlayer].Votes < TabOfProposals[idR].Cost then
				return false, "Not enough [ICON_ITG_VOTES] Votes";
			elseif TabOfProposals[idR].Above then
				if GetVoteAdvantageOverOtherMembers(leagueID, iPlayer) < TabOfProposals[idR].Cost then
					return false, "Not enough [ICON_ITG_VOTES] Votes";
				end
			end
		end
	end
	if TabOfProposals[idR].Project then
		if type == 2 then
			return false;
		end
	end
	if TabOfProposals[idR].Action then
		if type == 2 then
			return false;
		end
		if gT.Leagues[leagueID].ActionCooldowns[idR] and (gT.Leagues[leagueID].ActionCooldowns[idR] >= GetITGGameTurn()) then
			return false, "Cooldown (" .. gT.Leagues[leagueID].ActionCooldowns[idR] - GetITGGameTurn() .. "T).";
		end
		return true;
	end
	if gT.Leagues[leagueID].Vetos[idR] then
		if gT.Leagues[leagueID].Vetos[idR] >= GetITGGameTurn() then
			return false, "Veto (" .. gT.Leagues[leagueID].Vetos[idR] - GetITGGameTurn() .. "T).";
		end
	end
	if not TabOfProposals[idR].ExtraChoice then
		if gT.Leagues[leagueID].Proposals[idR] then
			return false, nil;
		end
		local tLeftSinceLastProposal = GetTurnsLeftSinceLastProposal(leagueID, idR)
		if (tLeftSinceLastProposal > 0) then
			return false, "Proposed recently (" .. tLeftSinceLastProposal .. "T).";
		end
	end
	if type == 2 then
		if TabOfProposals[idR].CannotBeRepealed then
			return false, nil;
		elseif TabOfProposals[idR].ExtraChoice then
			if not HasAtLeastOneViableOptionForProposal(idR, type, leagueID, iPlayer) then
				return false, nil;
			end
			--those ones will not affect extra choice
		elseif gT.Leagues[leagueID].Resolutions[idR].InitialResolution then
			if gT.Leagues[leagueID].Members[gT.Leagues[leagueID].Resolutions[idR].InitialResolution] then
				return false, nil;
			else
				gT.Leagues[leagueID].Resolutions[idR].InitialResolution = nil;
			end
		elseif gT.Leagues[leagueID].Resolutions[idR].CannotBeRepealed then
			return false, nil;
		elseif (GetITGGameTurn() - 10 < gT.Leagues[leagueID].Resolutions[idR].EnactedTurn) then
			return false, "Just enacted (" .. gT.Leagues[leagueID].Resolutions[idR].EnactedTurn + 10 - GetITGGameTurn() .. "T).";
		end
	end
	return true, nil;
end

function IsExtraChoiceResolutionProposalActive(leagueID, resID, eInfo)
	for a, b in pairs(gT.Leagues[leagueID].Proposals) do
		if (b.ResolutionID == resID) and (b.ExtraInfo == eInfo) then
			return true;
		end
	end
	return false;
end

function getTabOfViableOptionsResolution(i, type, leagueID, iPlayer)
	local iTurn = GetITGGameTurn();
	if type == 1 then
		local tab = TabOfProposals[i].ExtraListFunc(leagueID, iPlayer, i)
		local ntab = {}
		for j, v in pairs(tab) do
			if (not gT.Leagues[leagueID].ProposalsOnlyOnce) or (not gT.Leagues[leagueID].ProposalsHistory[i .. "x" .. v.ExtraInfo]) then
				if not IsExtraChoiceResolutionProposalActive(leagueID, i, v.ExtraInfo) then
					if GetTurnsLeftSinceLastProposal(leagueID, i .. "x" .. v.ExtraInfo) == 0 then
						if (not gT.Leagues[leagueID].Vetos[i .. "x" .. v.ExtraInfo]) or (gT.Leagues[leagueID].Vetos[i .. "x" .. v.ExtraInfo] < iTurn) then
							table.insert(ntab, v)
						end
					end
				end
			end
		end
		return ntab;
	else
		local hTab = {}
		for ibr, sth in pairs(gT.Leagues[leagueID].Resolutions) do
			if sth.ResID == i then
				if IsValidOptionToRepeal(leagueID, ibr) then
					if not IsExtraChoiceResolutionProposalActive(leagueID, i, v.ExtraInfo) then
						if TabOfProposals[i].MainIconFunc then
							table.insert(hTab, {Name = sth.Name, ExtraInfo = sth.ExtraInfo, MainIcon = TabOfProposals[i].MainIconFunc(sth.ExtraInfo)});
						else
							table.insert(hTab, {Name = sth.Name, ExtraInfo = sth.ExtraInfo});
						end
					end
				end
				--func name, extrainfo?
			end
		end
		return hTab;
	end
end

function IsValidOptionToRepeal(leagueID, ibr)
	if GetTurnsLeftSinceLastProposal(leagueID, ibr) == 0 then
		if (not gT.Leagues[leagueID].Vetos[ibr]) or (gT.Leagues[leagueID].Vetos[ibr] < GetITGGameTurn()) then
			return true;
		end
	end
	return false;
end

function DoRemoveResolution(leagueID, hString, idR, extraInfo)
	if TabOfProposals[idR].ProvidesVotes then
		for member, sth in pairs(gT.Leagues[leagueID].Members) do
			gT.Leagues[leagueID].Members[member].VotesFromResolution[TabOfProposals[idR].Name] = nil;
			gT.Leagues[leagueID].Members[member].HelpPoints[idR] = nil;
		end
		gT.Leagues[leagueID].Resolutions[idR].Votes = nil;
	end
--	gT.Leagues[leagueID].Vetos[hString] = GetITGGameTurn() + 8; --25.01.2022 commented out; should be nice for UI with no gameplay effect
	gT.Leagues[leagueID].Resolutions[hString] = nil;
	if TabOfProposals[idR].OnRemovedResolution then
		TabOfProposals[idR].OnRemovedResolution(leagueID, extraInfo)
	end
end

function AddNewResolution(leagueID, idR, iPlayer, extraInfo)
	local hString = idR
	if extraInfo then
		hString = idR .. "x" .. extraInfo;
	end
	if gT.Leagues[leagueID].Resolutions[hString] then
		DoRemoveResolution(leagueID, hString, idR, extraInfo)
		if iPlayer then
			gT.Players[iPlayer].LHLeagueRes = gT.Players[iPlayer].LHLeagueRes + 1;
		end
	else
		if not TabOfProposals[idR].NotResolution then
			gT.Leagues[leagueID].Resolutions[hString] = {Name = TabOfProposals[idR].Name, EnactedTurn = GetITGGameTurn(), ResID = idR, ExtraInfo = extraInfo}			
			if TabOfProposals[idR].FuncName then
				gT.Leagues[leagueID].Resolutions[hString].Name = TabOfProposals[idR].FuncName(extraInfo, leagueID)
			end
			if TabOfProposals[idR].Project then
				gT.Leagues[leagueID].Resolutions[hString].Project = true
				gT.Leagues[leagueID].Resolutions[hString].ProjectPrepare = true;
				if not gT.Leagues[leagueID].OnGoingProjects then
					gT.Leagues[leagueID].OnGoingProjects = {}
				end
				table.insert(gT.Leagues[leagueID].OnGoingProjects, {idR, extraInfo})
			end
			if iPlayer and (iPlayer ~= -1) then
				if not gT.Leagues[leagueID].Members[iPlayer].InitProposal then
					if gT.Leagues[leagueID].HasInitialProposals then
						gT.Leagues[leagueID].Resolutions[idR].InitialResolution = iPlayer
						gT.Leagues[leagueID].Resolutions[idR].CannotBeRepealed = true
						gT.Leagues[leagueID].Members[iPlayer].InitProposal = true;
					end
				else
					gT.Players[iPlayer].LHLeagueRes = gT.Players[iPlayer].LHLeagueRes + 1;
				end
			end
			if TabOfProposals[idR].ProvidesVotes then
				for member, sth in pairs(gT.Leagues[leagueID].Members) do
					gT.Leagues[leagueID].Members[member].VotesFromResolution[TabOfProposals[idR].Name] = 0;
					gT.Leagues[leagueID].Members[member].HelpPoints[idR] = 0;
				end
				gT.Leagues[leagueID].Resolutions[idR].Votes = {};
			end
			if gT.Leagues[leagueID].SpecialProposalTag == "LoN" then
				if iPlayer and (iPlayer ~= -1) and (Players[iPlayer]:IsHuman()) then
					LuaEvents.ITG_AchievementCompleted(15)
				end
			end
		end
		if TabOfProposals[idR].OnAdoptedResolution then
			TabOfProposals[idR].OnAdoptedResolution(leagueID, extraInfo)
		end
	end
end

function GreatLeagueOverFunction()
	DoTurnOlympics()
	local gTurn = GetITGGameTurn();
	for leagueID, sth in pairs(gT.Leagues) do
		if sth.HostCD then
			if gTurn >= sth.HostCD then
				ChooseHostMember(leagueID)
			end
		elseif sth.HostDivider then
			if gTurn % sth.HostDivider == sth.HostTurn then
				ChooseHostMember(leagueID)
			end
		end
		TakeCareOfOngoingProjects(leagueID)
		TakeCareOfTimeVotesModifiers(leagueID)
		TakeCareOfBadCityStates(leagueID) -- it can disband league
		if gT.Leagues[leagueID] then
			TakeCareOfActionVotePenalty(leagueID);
			TakeCareOfUnfinishedProposals(leagueID);
			TakeCareOfDelayedProposals(leagueID);
			TakeCareOfDelayedResolutions(leagueID)
			TakeCareOfAuthorityVoteLeague(leagueID)
			if sth.SpecialProposalTag then
				DoTurnSpecialLeague(sth.SpecialProposalTag, leagueID, gTurn + 1)
			end
			for idR, gth in pairs(sth.Resolutions) do
				if TabOfProposals[gth.ResID].EndTurnFunction then
					TabOfProposals[gth.ResID].EndTurnFunction(leagueID, idR, gth.ExtraInfo);
				end
				if gth.Votes and (not TabOfProposals[idR].VotesNotEndTurn) then
					local hString = TabOfProposals[idR].Name;
					local tab = {}
					if TabOfProposals[idR].SpecialVoteFunc then
						tab = TabOfProposals[idR].SpecialVoteFunc(leagueID);
					else
						local hTab = {}
						for iMember, vth in pairs(sth.Members) do
							if not Players[iMember]:IsMinorCiv() then
								tab[iMember] = 0;
								local hValue = vth.HelpPoints[idR]
								if TabOfProposals[idR].EndTurnHelpPoints then
									hValue = hValue + TabOfProposals[idR].EndTurnHelpPoints(iMember, leagueID);
								end
								table.insert(hTab, {iMember, hValue})
								gT.Leagues[leagueID].Members[iMember].HelpPoints[idR] = 0;
							end
						end
						table.sort(hTab, SortFunctionForGreaterInteger2);
						if hTab[1][2] ~= 0 then
							if hTab[1][2] == hTab[2][2] then
							--draw is more dynamic
								gT.Leagues[leagueID].Resolutions[idR].Votes = {};
								local vV = hTab[1][2];
								local numDraw = 0;
								for bb, bbt in pairs(hTab) do
									if bbt[2] == vV then
										numDraw = numDraw + 1;
									end
								end
								if numDraw < 6 then
									local iVotesPerDraw = 2;
									if numDraw > 2 then
										iVotesPerDraw = 1;
									end
									for bb, bbt in pairs(hTab) do
										if bbt[2] == vV then
											for jkb = 1, iVotesPerDraw do
												table.insert(gT.Leagues[leagueID].Resolutions[idR].Votes, bbt[1])
											end
										end
									end
									gT.Leagues[leagueID].Resolutions[idR].Votes = Shuffle(gT.Leagues[leagueID].Resolutions[idR].Votes);
								end
							else
								table.insert(gT.Leagues[leagueID].Resolutions[idR].Votes, hTab[1][1])
							end
							if #gT.Leagues[leagueID].Resolutions[idR].Votes > 5 then
								table.remove(gT.Leagues[leagueID].Resolutions[idR].Votes, 1)
							end
						elseif #gth.Votes > 0 then
							table.remove(gT.Leagues[leagueID].Resolutions[idR].Votes, 1)
						end
						for jj, jMember in pairs(gT.Leagues[leagueID].Resolutions[idR].Votes) do
							if tab[jMember] then
								tab[jMember] = tab[jMember] + 1;
							end
						end
					end
					for dMember, votes in pairs(tab) do
						gT.Leagues[leagueID].Members[dMember].VotesFromResolution[hString] = votes;
					end
				end
			end
			for member, hth in pairs(sth.Members) do
				UpdateMemberVotesInLeague(member, leagueID)
			end
		end
	end
	DoScenarioScriptedResolutions(gTurn + 1)
end

function GetAIAimTypeForAnswer(leagueNID, iPlayer, hs, bRenact, gRL, resID, extrainfo)
--	print("More help: ", leagueNID, iPlayer, hs, bRenact, gRL)
	local id;
	if resID then
		id = resID;
	else
		id = gT.Leagues[leagueNID].Proposals[hs].ResolutionID;
	end
	if bRenact then
		if gRL < 30 then
			return "aAccept"
		elseif gRL < 60 then
			if gT.Leagues[leagueNID].Members[iPlayer].VotesFromResolution[TabOfProposals[id].Name] then
				if gT.Leagues[leagueNID].Members[iPlayer].VotesFromResolution[TabOfProposals[id].Name] > 2 then
					return "aDeny"
				else
					return "aRatherAccept"
				end
			else
				return "aActRandomly"
			end
		elseif gRL < 75 then
			return "aDeny"
		else
			return "aHeavyDeny"
		end
	else
		if gRL > 75 then
			return "aAccept"
		elseif gRL > 55 then
			return "aRatherAccept"
		elseif gRL > 45 then
			return "aActRandomly"
		elseif gRL > 30 then
			return "aDeny"
		else
			return "aHeavyDeny"
		end
	end
end

function GetAIBestProposal(iPlayer, leagueNID, bInitial, minVal)
	local tab;
	if bInitial then
		tab = GetTabOfValidVoteResolutions(leagueNID);
	else
		tab = GetAvailableResolutionToPropose(3, iPlayer, leagueNID)
	end
	if #tab > 0 then
		local finalOptions = {}
		for i, data in pairs(tab) do
			local resID = data.ID;
			if not TabOfProposals[resID].ExtraChoice then
				local hs = resID;
				local bRenact = gT.Leagues[leagueNID].Resolutions[hs] ~= nil
				if not TabOfProposals[resID].AIValueFunction then
					print(resID, "Has no ai value function", leagueNID, bInitial, iPlayer)
				else
					local points = TabOfProposals[resID].AIValueFunction(iPlayer, leagueNID, nil, bRenact, resID)
					if bRenact then
						points = 100 - points;
					end
					if (not minVal) or minVal <= points then
						table.insert(finalOptions, {resID, points, nil})
					end
				end
			else
				local extraTab = getTabOfViableOptionsResolution(resID, 1, leagueNID, iPlayer);
				local bExEval, bExChoice; 
				for j, exData in pairs(extraTab) do
					local eVal = TabOfProposals[resID].AIValueFunction(iPlayer, leagueNID, exData.ExtraInfo, false, resID);
					if (not bExEval) or (eVal > bExEval) then
						bExEval = eVal;
						bExChoice = exData.ExtraInfo;
					end
				end
				local extraTab = getTabOfViableOptionsResolution(resID, 2, leagueNID, iPlayer);
				for j, exData in pairs(extraTab) do
					local eVal = math.max(1, math.min(100, 100 - TabOfProposals[resID].AIValueFunction(iPlayer, leagueNID, exData.ExtraInfo, true, resID)));
					if (not bExEval) or (eVal > bExEval) then
						bExEval = eVal;
						bExChoice = exData.ExtraInfo;
					end
				end
				if bExChoice then
					table.insert(finalOptions, {resID, bExEval, bExChoice})
				end
			end
		end
		if #finalOptions > 0 then
			table.sort(finalOptions,SortFunctionForGreaterInteger2)
			local bestO = finalOptions[1][2];
			if (LastRandom(45, 75) < bestO) or (bInitial) then
				local lastSelection = {}
				for i, opd in pairs(finalOptions) do
					if opd[2] >= bestO - 7 then
						table.insert(lastSelection, {opd[1], opd[2], opd[3]})
					else
						break;
					end
				end
				local winnerkey = GetRandomFromBiasedChanceTable(lastSelection, true)
				return lastSelection[winnerkey];
			end
		end
	end
	return nil;
end

function PlayerProposeSpecialChange(leagueID, idR, iPlayer, answerTab, sInfo, bNotSpecial, iExtraVotes)
	if TabOfProposals[idR].Instant then
		SpecialResolutionAdd(leagueID, idR, nil, iPlayer)
	else
		local hString = idR;
		if sInfo then
			hString = idR .. "x" .. sInfo;
		end
		gT.Leagues[leagueID].Proposals[hString] = {ResolutionID = idR, ExtraInfo = sInfo, SupportExtraVotes = iExtraVotes, PlayersAnswers = {}, ProposedBy = iPlayer, Name = TabOfProposals[idR].Name, ProposalStrength = 2, NormalAnswer = TabOfProposals[idR].NormalAnswer}
		if bNotSpecial then
			gT.Leagues[leagueID].Proposals[hString].Special = false;
		else
			gT.Leagues[leagueID].Proposals[hString].Special = true;
		end
		if TabOfProposals[idR].FuncName then
			gT.Leagues[leagueID].Proposals[hString].Name = TabOfProposals[idR].FuncName(sInfo, leagueID)
		end
		if TabOfProposals[idR].FuncAnswers then
			gT.Leagues[leagueID].Proposals[hString].Answers = TabOfProposals[idR].FuncAnswers(answerTab)
		end
		NoteThatLeagueProposedSomething(leagueID, idR)
	end
	if iPlayer ~= -1 then
		gT.Leagues[leagueID].Members[iPlayer].ForcedResolution = nil;
	end
end

function NoteThatLeagueProposedSomething(leagueID, idR)
	if idR == 16 then

	elseif idR == 17 then
		gT.Leagues[leagueID].PHIR = 1;
	elseif idR == 18 then
		gT.Leagues[leagueID].PCHR = 1;
	elseif idR == 19 then

	elseif idR == 20 then

	elseif idR == 28 then
		gT.Leagues[leagueID].PWSR = 1;
	elseif idR == 43 then
		gT.Globals.OlympicGamesProposed = true
	end
end

function SpecialResolutionAdd(leagueID, hString, option, iPlayer)
	if hString == 16 then
		local cName = Map.GetPlotByIndex(option):GetPlotCity():GetName();
		if not gT.Leagues[leagueID].OnGoingProjects then
			gT.Leagues[leagueID].OnGoingProjects = {}
		end
		gT.Leagues[leagueID].Resolutions[hString] = {Name = TabOfProposals[hString].Name, Special = true, EndTurn = GetITGGameTurn() + 15, ExtraInfo = option, Project = true, EnactedTurn = GetITGGameTurn(), ResID = hString}
		table.insert(gT.Leagues[leagueID].OnGoingProjects, {16, nil})
		PrepareInitialDataForProject(leagueID, 16, hString)
		for member, md in pairs(gT.Leagues[leagueID].Members) do
			if Players[member]:IsHuman() then
				Players[member]:AddNotification(94343293, "The Crusade was declared to target " .. cName .. ". All the faithul should contribute [ICON_PRODUCTION] Production (15 turns left)!", "Crusade", -1, -1, 30)
			end
		end
	elseif hString == 17 then
		if option == 1 then
			gT.Leagues[leagueID].Resolutions[hString] = {Name = TabOfProposals[hString].Name, Special = true, EnactedTurn = GetITGGameTurn(), ResID = hString}
			for ji, iHuman in pairs(gT.Globals.HumanPlayers) do
				if gT.Leagues[leagueID].Members[iHuman] then
					Players[iHuman]:AddNotification(NotificationTypes.NOTIFICATION_LEAGUE_VOTING_DONE, "Holy Inquisition has been established. All heathens must tremble in fear right now.", "Resolution Passes", -1, -1, -1)
				end 
			end
			AnihilateHeathensInMostGloriousInquisition(leagueID)
		else
			for ji, iHuman in pairs(gT.Globals.HumanPlayers) do
				if gT.Leagues[leagueID].Members[iHuman] then
					Players[iHuman]:AddNotification(NotificationTypes.NOTIFICATION_LEAGUE_VOTING_DONE, "Holy Inquisition was a dream, too perfect to happen.", "Resolution Fails", -1, -1, -1)
				end
			end
		end
	elseif hString == 18 then
		--1.notification
		for ji, iHuman in pairs(gT.Globals.HumanPlayers) do
			if gT.Leagues[leagueID].Members[iHuman] then
				if option == 1 then
					Players[iHuman]:AddNotification(NotificationTypes.NOTIFICATION_LEAGUE_VOTING_DONE, "Cultural Unification will take place in next 15 turns, players with most advanced artists will be rewarded with [ICON_PEACE] Faith and [ICON_ITG_MERITOCRACY] Meritocracy.", "Resolution Passes", -1, -1, -1)
				elseif option == 2 then
					Players[iHuman]:AddNotification(NotificationTypes.NOTIFICATION_LEAGUE_VOTING_DONE, "Cultural Unification will take place in next 15 turns, players with most advanced artists will be rewarded with [ICON_HAPPINESS_1] Happiness and [ICON_ITG_MERITOCRACY] Meritocracy.", "Resolution Passes", -1, -1, -1)
				elseif option == 3 then
					Players[iHuman]:AddNotification(NotificationTypes.NOTIFICATION_LEAGUE_VOTING_DONE, "Cultural Unification will take place in next 15 turns, players with most advanced artists will be rewarded with [ICON_GREAT_ARITST] Art points and [ICON_ITG_MERITOCRACY] Meritocracy.", "Resolution Passes", -1, -1, -1)
				end
			end
		end
		gT.Leagues[leagueID].Resolutions[hString] = {Name = TabOfProposals[hString].Name, Special = true, EndTurn = GetITGGameTurn() + 15, EnactedTurn = GetITGGameTurn(), ResID = hString, ExtraInfo = option}
	elseif hString == 19 then
		for ji, iHuman in pairs(gT.Globals.HumanPlayers) do
			if gT.Leagues[leagueID].Members[iHuman] then
				if option == 1 then
					Players[iHuman]:AddNotification(NotificationTypes.NOTIFICATION_LEAGUE_VOTING_DONE, "Tithe is now active, 10% of members income will be send to Papacy and rewarded with [ICON_PEACE] Faith.", "Resolution resolved", -1, -1, -1)
				elseif option == 2 then
					Players[iHuman]:AddNotification(NotificationTypes.NOTIFICATION_LEAGUE_VOTING_DONE, "Tithe is now active, 10% of members income will be send to Papacy and rewarded with [ICON_CULTURE] Culture.", "Resolution resolved", -1, -1, -1)
				elseif option == 3 then
					Players[iHuman]:AddNotification(NotificationTypes.NOTIFICATION_LEAGUE_VOTING_DONE, "Tithe is now active, 10% of members income will be send to Papacy and rewarded with [ICON_ITG_LEGAL_POWER] Legal Power.", "Resolution resolved", -1, -1, -1)
				end
			end
		end
		for member, md in pairs(gT.Leagues[leagueID].Members) do
			if member ~= iPlayer then
				ChangeMeritocracy(member, 5);
				gT.Players[member].TrialTithe = {0, iPlayer, option}
			end
		end
		gT.Leagues[leagueID].Resolutions[hString] = {Name = TabOfProposals[hString].Name, Special = true, EnactedTurn = GetITGGameTurn(), ResID = hString, ExtraInfo = option}
	elseif hString == 20 then
		if gT.Leagues[leagueID].OfficialRel then
			local fOwner = GetReligionFounderIfAny(gT.Leagues[leagueID].OfficialRel)
			if fOwner then
				--notification is handled anyway
				DoStartReformation(fOwner, option)
			end
		end
	elseif (hString > 20 and hString < 27) or (hString == 66) then
		for ji, iHuman in pairs(gT.Globals.HumanPlayers) do
			if gT.Leagues[leagueID].Members[iHuman] then
				Players[iHuman]:AddNotification(NotificationTypes.NOTIFICATION_LEAGUE_VOTING_DONE, TabOfProposals[hString].Name .. " is now active in caliphate. (" .. Locale.Lookup(TabOfProposals[hString].Help) .. ")", "Edict", -1, -1, iPlayer)
			end
		end
		gT.Leagues[leagueID].Resolutions[hString] = {Name = TabOfProposals[hString].Name, Special = true, EnactedTurn = GetITGGameTurn(), ResID = hString}
		if hString == 21 then
			for member, sth in pairs(gT.Leagues[leagueID].Members) do
				if not Players[member]:IsMinorCiv() then
					gT.Players[member].CaliphateGhazi = 0;
				end
			end
		elseif hString == 24 then
			gT.Leagues[leagueID].ExtraVotesFromTasks = (gT.Leagues[leagueID].ExtraVotesFromTasks or 0) + 1
		elseif hString == 26 then
			for member, sth in pairs(gT.Leagues[leagueID].Members) do
				if not Players[member]:IsMinorCiv() then
					gT.Players[member].CaliphateTrade = 0;
				end
			end
		end
	elseif hString == 28 then
		if option == 1 then
			gT.Leagues[leagueID].Resolutions[hString] = {Name = TabOfProposals[hString].Name, Special = true, EnactedTurn = GetITGGameTurn(), ResID = hString}
			for ji, iHuman in pairs(gT.Globals.HumanPlayers) do
				if gT.Leagues[leagueID].Members[iHuman] then
					Players[iHuman]:AddNotification(NotificationTypes.NOTIFICATION_LEAGUE_VOTING_DONE, "There is no church outside the papacy! All schismatic players are removed from league and will be purified with fire of war.", "Resolution Passes", -1, -1, -1)
				end
			end
			DeclareWarOnSchism(leagueID)
		else
			for ji, iHuman in pairs(gT.Globals.HumanPlayers) do
				if gT.Leagues[leagueID].Members[iHuman] then
					Players[iHuman]:AddNotification(NotificationTypes.NOTIFICATION_LEAGUE_VOTING_DONE, "No more walls! This day we stand together as brothers in faith. Schismatic players are not gonna be removed from league.", "Resolution Fails", -1, -1, -1)
				end
			end
		end
	elseif hString == 50 then
		ToPDoSupportIdeology(leagueID, option)
		gT.Leagues[leagueID].Resolutions[hString] = {Name = TabOfProposals[hString].FuncName(option), Special = true, EnactedTurn = GetITGGameTurn(), ResID = hString}
		local notstr = "League of Nations decided that " .. GetIdeoNameString(option) .. " should become a global ideology!";
		for g, h in pairs(gT.Leagues[leagueID].Members) do
			if Players[g]:IsHuman() then
				Players[g]:AddNotification(NotificationTypes.NOTIFICATION_LEAGUE_VOTING_DONE, notstr, "Global Ideology", -1, -1, GetCreditLeagueNotificationPlayer(leagueID, hString, option, g))		
			end
		end	
	elseif hString == 59 then
		AddNewResolution(leagueID, 59, -1, option)
		local htPlayer = GetLeagueIdeologyPlayerForTenets(leagueID)
		gT.IdeologyTaken[option] = thePlayer;
		local tideo = GetIdeologyDBRow(option)
		local notstr = "Our brothers and sisters in [COLOR_POSITIVE_TEXT]" .. gT.Leagues[leagueID].Name .. "[ENDCOLOR] have came up with an idea of [COLOR_POSITIVE_TEXT]" .. tideo.Name .. "[ENDCOLOR]."
		for g, h in pairs(gT.Leagues[leagueID].Members) do
			if not Players[g]:IsMinorCiv() then
				AddEffectsOfIdeology(g, option)
				if Players[g]:IsHuman() then
					Players[g]:AddNotification(NotificationTypes.NOTIFICATION_LEAGUE_VOTING_DONE, notstr, "New doctrine", -1, -1, GetCreditLeagueNotificationPlayer(leagueID, hString, option, g))		
				end
			end
		end	
	elseif hString == 60 then
		local hvt = ELFTopFunc60()
		local notification = "Members of " .. gT.Leagues[leagueID].Name .. " decided on next common progress: " .. hvt[option].Name .. " ("; 
		local basicHelpTT = hvt[option].Tooltip
		for member, md in pairs(gT.Leagues[leagueID].Members) do
			if not Players[member]:IsMinorCiv() then
				local specLocalTT;
				if option == 1 then
					ChangeITGScience(member, 1000)
				elseif option == 2 then
					gT.Players[member].NumFreePromotions = gT.Players[member].NumFreePromotions + 1;
				elseif option == 3 then
					ChangeITGLegalPointsPercent(member, 300);
				elseif option == 4 then
					gT.Players[member].GPMigrateBlocker = math.max(GetITGGameTurn(), gT.Players[member].GPMigrateBlocker or -1) + 5;
				elseif option == 5 then
					gT.Players[member].LeagueCityStrength = gT.Players[member].LeagueCityStrength + 600;
					AdjustStrengthOfAllCities(member)
				elseif option == 6 then
					DoBoostTradeProgressInAllCities(iPlayer, 50)
				elseif option == 7 then
					local getvCS = GetValidCSForIdeology60(member, leagueID)
					if getvCS then
						Players[getvCS]:ChangeMinorCivFriendshipWithMajor(member, 60);
						specLocalTT = "+60 [ICON_INFLUENCE] Influence within " .. Players[getvCS]:GetName() .. "."
					end
				elseif option == 8 then
					local mechclass = GetMechClassToMakeCheaper(member)
					if mechclass then
						Players[member]:ChangeUnitClassRawProdDiscount(mechclass, -25);
						specLocalTT = CapitalFL(Locale.Lookup(GameInfo.UnitClasses[mechclass].Description)) .. " unit class became 25 [ICON_PRODUCTION] Production cheaper to construct."
					end
				elseif option == 9 then
					BoostArtisticPoints(member, 800, false)
					CreateGreatWorkOfAmount(member, 1, "Random")
				elseif option == 10 then
					gT.Players[member].RiotBlocker = math.max(GetITGGameTurn(), gT.Players[member].RiotBlocker or -1) + 7;
				elseif option == 11 then
					ChangeITGExtraResources(member, rOil, 1)
					ChangeITGExtraResources(member, rCoal, 1)
					ChangeITGExtraResources(member, rUran, 1)
				elseif option == 12 then
					ChangeMeritocracy(member, 20)
				elseif option == 13 then
					ChangeExtraSupply(member, 2)
				end
				if Players[member]:IsHuman() then
					Players[member]:AddNotification(NotificationTypes.NOTIFICATION_LEAGUE_VOTING_DONE, notification .. (specLocalTT or basicHelpTT) .. ")", "Common Progress", -1, -1, GetCreditLeagueNotificationPlayer(leagueID, hString, option, member))
				end
			end
		end
	elseif hString == 65 then
		for ji, iHuman in pairs(gT.Globals.HumanPlayers) do
			if gT.Leagues[leagueID].Members[iHuman] then
				if option == 1 then
					Players[iHuman]:AddNotification(NotificationTypes.NOTIFICATION_LEAGUE_VOTING_DONE, "Indulgence is now active, pilgrims will be rewarded with [ICON_ITG_MERITOCRACY] Meritocracy.", "Resolution resolved", -1, -1, -1)
				elseif option == 2 then
					Players[iHuman]:AddNotification(NotificationTypes.NOTIFICATION_LEAGUE_VOTING_DONE, "Indulgence is now active, pilgrims will be rewarded with [ICON_ITG_LEGAL_POWER] Legal Power.", "Resolution resolved", -1, -1, -1)
				elseif option == 3 then
					Players[iHuman]:AddNotification(NotificationTypes.NOTIFICATION_LEAGUE_VOTING_DONE, "Indulgence is now active, pilgrims will be rewarded with [ICON_HAPPINESS_1] Happiness.", "Resolution resolved", -1, -1, -1)
				end
			end
		end
		gT.Leagues[leagueID].Resolutions[hString] = {Name = TabOfProposals[hString].Name, Special = true, EnactedTurn = GetITGGameTurn(), ResID = hString, ExtraInfo = option}
	elseif hString == 67 then
		for ji, iHuman in pairs(gT.Globals.HumanPlayers) do
			if gT.Leagues[leagueID].Members[iHuman] then
				if option == 1 then
					Players[iHuman]:AddNotification(NotificationTypes.NOTIFICATION_LEAGUE_VOTING_DONE, "Deus vult! All members can now acquire [ICON_ITG_MERCENARY] Mercenaries with religious bonus.", "Resolution resolved", -1, -1, -1)
				elseif option == 2 then
					Players[iHuman]:AddNotification(NotificationTypes.NOTIFICATION_LEAGUE_VOTING_DONE, "Deus vult! All members can now legalize conquest with religious bonus.", "Resolution resolved", -1, -1, -1)
				elseif option == 3 then
					Players[iHuman]:AddNotification(NotificationTypes.NOTIFICATION_LEAGUE_VOTING_DONE, "Deus vult! All members can now boost [ICON_ITG_MORALE] Morale with religious bonus.", "Resolution resolved", -1, -1, -1)
				end
			end
		end
		gT.Leagues[leagueID].Resolutions[hString] = {Name = TabOfProposals[hString].Name, Special = true, EnactedTurn = GetITGGameTurn(), ResID = hString, ExtraInfo = option}
	end
end

function GetCreditLeagueNotificationPlayer(leagueID, hString, option, member)
	local creditPlayer = -1;
	local mAnswer = gT.Leagues[leagueID].Proposals[hString].PlayersAnswers[member]
	if mAnswer and (gT.Leagues[leagueID].Proposals[hString].Answers[mAnswer][1] == option) then
		creditPlayer = member;
	end
	return creditPlayer;
end

LuaEvents.ITGSG_Civilopedia_PopulateList_Resolutions.Add(function()
	local tab = {{Name = "Resolution", Resolutions = {}}, {Name = "Action", Resolutions = {}}}
	for i, v in pairs(TabOfProposals) do
		if v.Action then
			table.insert(tab[2].Resolutions, {Name = v.Name, ID = i})
		else
			table.insert(tab[1].Resolutions, {Name = v.Name, ID = i})
		end
	end
	MapModData.ITGSG = tab;
end)

LuaEvents.ITGSG_Civilopedia_ResolutionArticle.Add(function(id)
	local tData = {Name = TabOfProposals[id].Name};
	--civilopedia txt
	tData.Help = Locale.Lookup(TabOfProposals[id].Help);
	MapModData.ITGSG = tData;
end)
