local unionStringTab = {"Union", "Alliance", "League", "Confederacy", "Coalition", "Treaty", "Pact", "Entente"}

function UpdateLeaguesUponPlayerLoosingRights(iPlayer)
	if not Players[iPlayer]:IsMinorCiv() then
		for g, gd in pairs(gT.Players) do
			if not Players[g]:IsMinorCiv() then
				if Players[iPlayer]:IsDoF(g) then
					if iPlayer ~= g then
						Players[iPlayer]:DoEndDoF(g, false)
					end
				end
			end
		end
	end
end

function InitialAILeagueFlavours()
	for g, gd in pairs(gT.Players) do
		gT.Players[g].LeagueFlavors = {}
		gT.Players[g].LeagueFlavors["Delaying"] = LastRandom(0, 10);
		gT.Players[g].LeagueFlavors["ForcingVeto"] = LastRandom(0, 10);
		gT.Players[g].LeagueFlavors["MoreMembers"] = LastRandom(0, 10);
		gT.Players[g].LeagueFlavors["MinorMembers"] = LastRandom(0, 10);
	end
end

function CanBeInvitedToTheLeague(leagueID, g)
	if gT.Players[g].DeniedInvitationsLeague[leagueID] then
		return false;
	end
	if not gT.Leagues[leagueID] then
		return false;
	end
	for member, sth in pairs(gT.Leagues[leagueID].Members) do
		if member == g then
			return false;
		elseif (not Players[member]:IsMinorCiv()) and (not Players[member]:IsDoF(g)) then
			return false;
		end
	end
	return true;
end

function IsMosqueWonderActive(iPlayer, leagueID)
	if gT.Players[iPlayer].HasPlayerWonder[GameInfoTypes.BUILDING_ITG_NEW_MEDIEVAL_WONDER_4] then
		local offRel = gT.Players[iPlayer].OfficialReligion;
		if offRel then
			for member, sth in pairs(gT.Leagues[leagueID].Members) do
				if member ~= iPlayer then
					if gT.Players[member].OfficialReligion == offRel then
						if not Players[member]:IsMinorCiv() then
							return true;
						end
					end
				end
			end
		end
	end
	return false;
end

function ShouldBeInDefensivePact(sTeam, jTeam, leagueID)
	local bAnyMinor = Teams[sTeam]:IsMinorCiv() or Teams[jTeam]:IsMinorCiv();
	for league, sth in pairs(gT.Leagues) do
		if league ~= leagueID then
			if sth.Resolutions[3] then
				if (sth.SpecialProposalTag == "IdeologyL") or (not bAnyMinor) then
					local sB, jB = false, false;
					for member, sth in pairs(sth.Members) do
						if Players[member]:GetTeam() == sTeam then
							sB = true;
						elseif Players[member]:GetTeam() == jTeam then
							jB = true;
						end
					end
					if sB and jB then
						return true;
					end
				end
			end
		end
	end
	return false;
end

function TakeCareOfAuthorityVoteLeague(leagueID)
	local bPmhg, bVmhg = nil, -1;
	local bP, bV = nil, -1;
	for member, sth in pairs(gT.Leagues[leagueID].Members) do
		if not Players[member]:IsMinorCiv() then
			if (gT.Players[member].Authority or 0) > bV then
				bV = (gT.Players[member].Authority or 0);
				bP = member;
			elseif (gT.Players[member].Authority or 0) == bV then
				bP = nil;
			end
			if (gT.Players[member].NatUnity or 0) > bVmhg then
				bVmhg = (gT.Players[member].NatUnity or 0)
				if gT.Players[member].CultBonusOn[58] then
					bPmhg = member;
				end
			elseif (gT.Players[member].NatUnity or 0) == bVmhg then
				bPmhg = nil;
			end
		end
	end
	gT.Leagues[leagueID].AuthorityVote = bP;
	gT.Leagues[leagueID].MHGVote = bPmhg;
end

function UpdateMemberVotesInLeague(member, leagueID)
	local votes = gT.Players[member].LeagueBaseVotes + gT.Players[member].NumPrestigeVotes;
	votes = votes + gT.Players[member].VotesFromSocials + gT.Players[member].VotesFromInno;
	votes = votes + gT.Players[member].VotesGP;
	if gT.Leagues[leagueID].Host == member then
		votes = votes + 3;
	end
	for name, nv in pairs(gT.Leagues[leagueID].Members[member].VotesFromScripts) do
		votes = votes + nv;
	end
	for name, nv in pairs(gT.Leagues[leagueID].Members[member].VotesFromResolution) do
		votes = votes + nv;
	end
	for name, nv in pairs(gT.Leagues[leagueID].Members[member].VotesTimeModifiers) do
		if nv.Active then
			votes = votes + nv.Actual;
		end
	end
	gT.Leagues[leagueID].Members[member].VotesFromIdeologies = nil;
	if gT.Leagues[leagueID].SupportedIdeology then
		local idevote = gT.Players[member].Ideologies[gT.Leagues[leagueID].SupportedIdeology];
		gT.Leagues[leagueID].Members[member].VotesFromIdeologies = idevote
		votes = votes + idevote
	end
	if gT.Leagues[leagueID].VotesPerAlliedCS then
		gT.Leagues[leagueID].Members[member].VotesFromAlliedCS = gT.Leagues[leagueID].VotesPerAlliedCS * GetNumAlliedCS(member)
		votes = votes + gT.Leagues[leagueID].Members[member].VotesFromAlliedCS
	end 
	local bIsMosqueWonder = IsMosqueWonderActive(member, leagueID)
	if bIsMosqueWonder then
		votes = votes + 2;
		gT.Leagues[leagueID].Members[member].MosqueWonder = true;
	else
		gT.Leagues[leagueID].Members[member].MosqueWonder = false;
	end
	if gT.Players[member].VotesFromBreakingLeague then
		votes = votes - gT.Players[member].VotesFromBreakingLeague
	end
	if gT.Players[member].VotesBribing then
		votes = votes + gT.Players[member].VotesBribing;
	end
	if member == gT.Leagues[leagueID].AuthorityVote then
		votes = votes + 1;
	end
	if member == gT.Leagues[leagueID].MHGVote then
		votes = votes + 2;
	end
	if gT.Leagues[leagueID].Members[member].BudgetSupport then
		gT.Leagues[leagueID].Members[member].VotesFromBudget = math.floor(gT.Leagues[leagueID].Members[member].BudgetSupport / 15000);
		votes = votes + gT.Leagues[leagueID].Members[member].VotesFromBudget
	end
	gT.Leagues[leagueID].Members[member].Votes = votes;
end

function CreateVotesModifier(iPlayer, leagueID, sReason, modifier, turns, bpRecovery)
--CreateVotesModifier(player, leagueID, " from using Delay option.", gT.Leagues[leagueID].Proposals[hString].DelayCost, 10, true)
	table.insert(gT.Leagues[leagueID].Members[iPlayer].VotesTimeModifiers, {Active = true, Actual = modifier, Total = modifier, Recovery = bpRecovery, Reason = sReason, Duration = turns, EndTurn = GetITGGameTurn() + turns})
	gT.Leagues[leagueID].Members[iPlayer].Votes = gT.Leagues[leagueID].Members[iPlayer].Votes + modifier;
end

function GetTemporaryVotesLeague(iPlayer, leagueID)
	local t = 0;
	for i, nv in pairs(gT.Leagues[leagueID].Members[iPlayer].VotesTimeModifiers) do
		if nv.Active then
			t = t + nv.Actual;
		end
	end
	return t;
end

function TakeCareOfTimeVotesModifiers(leagueID)
	local gTurn = GetITGGameTurn();
	for member, data in pairs(gT.Leagues[leagueID].Members) do
		for i, info in pairs(data.VotesTimeModifiers) do
			if info.Active then
				if gTurn == info.EndTurn then
					gT.Leagues[leagueID].Members[member].VotesTimeModifiers[i].Active = false;
				elseif info.Recovery then
					if info.Total > 0 then
						gT.Leagues[leagueID].Members[member].VotesTimeModifiers[i].Actual = math.ceil(info.Total * (info.EndTurn - gTurn) / info.Duration)
					else
						gT.Leagues[leagueID].Members[member].VotesTimeModifiers[i].Actual = math.floor(info.Total * (info.EndTurn - gTurn) / info.Duration)
					end
				end
			end
		end
	end
end

function TakeCareOfDelayedResolutions(leagueID)
	local gTurn = GetITGGameTurn();
	for h, hdata in pairs(gT.Leagues[leagueID].Proposals) do
		if (hdata.Delayed) and (hdata.Delayed <= gTurn) then
			gT.Leagues[leagueID].Proposals[h].Delayed = nil;
			for member, answer in pairs(hdata.PlayersAnswers) do
				if answer == 3 then
					gT.Leagues[leagueID].Proposals[h].PlayersAnswers[member] = nil;
				end
			end
		end
	end
end

function PlayerAcceptedInvitationToTheLeague(leagueID, player)
	gT.Players[player].InvitationsLeague[leagueID] = nil;
	local hString = "2x" .. player;
	gT.Leagues[leagueID].Resolutions[hString] = nil;
	if CanBeInvitedToTheLeague(leagueID, player) then
		AddAMemberToLeague(leagueID, player)
		UpdateMemberVotesInLeague(player, leagueID)
		local tRemove = {}
		for sleague, ldata in pairs(gT.Leagues) do
			if sleague ~= leagueID then
				if (not ldata.DoFindepedent) then
					local bHasOtherMajor = false;
					for j, mj in pairs(ldata.Members) do
						if not Players[j]:IsMinorCiv() then
							if not gT.Leagues[leagueID].Members[j] then
								bHasOtherMajor = true;
								break;
							end
						end
					end
					if not bHasOtherMajor then
						table.insert(tRemove, sleague)
					end
				end
			end
		end
		for t, b in pairs(tRemove) do
			DoEndLeagueProperly(b)
		end
		DoInitialResolutionForPlayer(player, leagueID)
		for i, human in pairs(gT.Globals.HumanPlayers) do
			if gT.Leagues[leagueID].Members[human] then
				if human ~= player then
					Players[human]:AddNotification(89523412, Players[player]:GetName() .. " accepted an invitation to " .. gT.Leagues[leagueID].Name .. ".", "New Member!", -1, -1)
				end
				LuaEvents.ITG_AchievementCompleted(31)
			end
		end
	end
end

function DoAIAnswerInviteToLeague(iPlayer, leagueID)
	--based on votes; nummembers; defensive pact; turn; projections from dll; probably always denied :D
	if CanBeInvitedToTheLeague(leagueID, iPlayer) then
		if LastRandom(1, 100) < 95 then
			PlayerAcceptedInvitationToTheLeague(leagueID, iPlayer)
		else
			print("Denied invitation")
			PlayerDeniedInvitationToTheLeague(leagueID, iPlayer)
		end
	else
		gT.Players[iPlayer].InvitationsLeague[leagueID] = nil;
		if gT.Leagues[leagueID] then
			local hString = "2x" .. iPlayer;
			gT.Leagues[leagueID].Resolutions[hString] = nil;
		end
	end
end

function PlayerDeniedInvitationToTheLeague(leagueID, iPlayer)
	gT.Players[iPlayer].DeniedInvitationsLeague[leagueID] = GetITGGameTurn();
	gT.Players[iPlayer].InvitationsLeague[leagueID] = nil;
	local hString = "2x" .. iPlayer;
	gT.Leagues[leagueID].Resolutions[hString] = nil;
	for gPlayer, h in pairs(gT.Leagues[leagueID].Members) do
		if Players[gPlayer]:IsHuman() then
			Players[gPlayer]:AddNotification(38459238, Players[player]:GetName() .. " declined an invitation to " .. gT.Leagues[leagueID].Name .. ".", "Invitation declined!", -1, -1)
		end
	end
end

LuaEvents.ITGHumanAnswersInvitationToLeague.Add(function(leagueID, answer)
	if answer == 1 then
		PlayerAcceptedInvitationToTheLeague(leagueID, Game.GetActivePlayer())
	else
		PlayerDeniedInvitationToTheLeague(leagueID, Game.GetActivePlayer())
	end
end)

function GetNiceThematicNameForLeague(iPlayer, sPlayer)
	return Players[iPlayer]:GetCivilizationAdjective() .. "-" .. Players[sPlayer]:GetCivilizationAdjective() .. " " .. unionStringTab[LastRandom(1, #unionStringTab)];
end

function DoAIChooseInitialResolution(iPlayer, niceUID)
	if (not gT.Leagues[niceUID]) or (not gT.Leagues[niceUID].Members[iPlayer]) then
		return;
	end
	local option = GetAIBestProposal(iPlayer, niceUID, true);
	if option then
		PlayerProposeChangeToLeague(niceUID, option[1], iPlayer, nil);
	else
		--not enough resolutions
		gT.Leagues[niceUID].Members[iPlayer].InitProposal = true;
	end
end

function DoInitialResolutionForPlayer(iPlayer, niceUID)
	if Players[iPlayer]:IsHuman() then
		if Players[iPlayer]:IsTurnActive() then
			Events.SerialEventEndTurnDirty()
		end
	elseif Players[iPlayer]:IsTurnActive() then
		DoAIChooseInitialResolution(iPlayer, niceUID)
	else
		table.insert(gT.Players[iPlayer].QueueActionsRealEndTurn, {"LeagueResolutionInitial", niceUID});
	end
end

function AreSharingDoFLeague(iPlayer, sPlayer)
	for l, s in pairs(gT.Leagues) do
		if (not s.DoFindepedent) and (s.Members[sPlayer]) and (s.Members[iPlayer]) then
			return true;
		end
	end
	return false;
end

function DoAddVoteFromLiberation(lPlayer, iPlayer)
	for l, s in pairs(gT.Leagues) do
		if (not s.DoFindepedent) and (s.Members[lPlayer]) and (s.Members[iPlayer]) then
			AddExtraVotesScriptedLeague(iPlayer, l, "City Liberation", 1)
		end
	end
end

function RemoveBadPlayerLeague(badPlayer, sPlayer, sReason)
	local hTT = {}
	for uid, sth in pairs(gT.Leagues) do
		if not sth.DoFindepedent then
			if sth.Members[badPlayer] and sth.Members[sPlayer] then
				table.insert(hTT, uid)
			end
		end
	end
	for i, uid in pairs(hTT) do
		RemovePlayerFromLeague(badPlayer, uid, sReason)
	end
end

function PlayerProposalStrength(player, leagueID, hString, option)
	if gT.Leagues[leagueID].Proposals[hString].ProposedBy == player then
		gT.Leagues[leagueID].Proposals[hString].ProposalStrength = option
	else
		print("Error 124x76")
	end
end

function PlayerProposalAnswer(player, leagueID, hString, option, bRemoval)
--	print("PlayerProposalAnswer", player, leagueID, hString, option)
	if option ~= nil then
		gT.Leagues[leagueID].Proposals[hString].PlayersAnswers[player] = option
	elseif not bRemoval then
		print("Option is nil", player, leagueID, hString, option)
	end
	if gT.Leagues[leagueID].Proposals[hString].Special and (not gT.Leagues[leagueID].Proposals[hString].NormalAnswer) then
		return;
	end
	local bFinished = true
	for dPlayer, sth in pairs(gT.Leagues[leagueID].Members) do
		if not gT.Leagues[leagueID].Proposals[hString].PlayersAnswers[dPlayer] then
			if gT.Leagues[leagueID].Proposals[hString].ProposedBy ~= dPlayer then
				if Players[dPlayer]:IsAlive() then
					bFinished = false;
					break;
				end
			end
		end
	end
	if bFinished then
		if not gT.Leagues[leagueID].ProposalsEndTurn then
			if gT.Leagues[leagueID].Proposals[hString].ProposedBy ~= -1 then
				ResolveResolution(leagueID, hString)
			end
		end
	end
end

function TakeCareOfDelayedProposals(leagueID)
	if gT.Leagues[leagueID].ProposalsEndTurn then
		if #gT.Leagues[leagueID].ProposalsEndTurn > 0 then
			gT.Leagues[leagueID].ProposalsEndTurn = Shuffle(gT.Leagues[leagueID].ProposalsEndTurn)
			for i, data in pairs(gT.Leagues[leagueID].ProposalsEndTurn) do
				local hString = data[1];
				if data[3] then
					hString = data[1] .. "x" .. data[3];
				end
				if not gT.Leagues[leagueID].Proposals[hString] then
					PlayerProposeChangeToLeague(leagueID, data[1], data[2], data[3], data[4], true)
				else
					gT.Leagues[leagueID].Proposals[hString].PlayersAnswers[data[2]] = 2;
				end
			end
			gT.Leagues[leagueID].ProposalsEndTurn = {}
		end
	end
end

function TakeCareOfUnfinishedProposals(leagueID)
	if gT.Leagues[leagueID].ProposalsEndTurn then
		for hs, sth in pairs(gT.Leagues[leagueID].Proposals) do
			if GetInfoFromTabOfProposal(sth.ResolutionID, "PriorityResolve") then
				if GetInfoFromTabOfProposal(sth.ResolutionID, "NormalAnswer") then
					ResolveResolution(leagueID, hs)
				else
					ResolveScriptedResolution(leagueID, hs)
				end
			end
		end
	end
	if gT.Leagues[leagueID].ToRemoveDelay then
		for a, bPlayer in pairs(gT.Leagues[leagueID].ToRemoveDelay) do
			RemovePlayerFromLeague(bPlayer, leagueID, "Excluded")
		end
		gT.Leagues[leagueID].ToRemoveDelay = nil;
	end
	for hs, sth in pairs(gT.Leagues[leagueID].Proposals) do
		if gT.Leagues[leagueID].ProposalsEndTurn then
			if GetInfoFromTabOfProposal(sth.ResolutionID, "NormalAnswer") then
				ResolveResolution(leagueID, hs)
			else
				ResolveScriptedResolution(leagueID, hs)
			end
		else
			if (not sth.Delayed) then
				if (not sth.Special) or (sth.NormalAnswer) then
					local bFinished = true
					for dPlayer, brbr in pairs(gT.Leagues[leagueID].Members) do
						if not sth.PlayersAnswers[dPlayer] then
							if sth.ProposedBy ~= dPlayer then
								if Players[dPlayer]:IsAlive() then
									bFinished = false;
									break;
								end
							end
						end
					end
					if bFinished then
						ResolveResolution(leagueID, hs)
					end
				end
			end
		end
	end
end

function DoAIAnswerResolution(iPlayer, leagueNID, hs)
	PlayerProposalAnswer(iPlayer, leagueNID, hs, GetAIAnswerToResolution(iPlayer, leagueNID, hs))
end

function ResolveResolution(leagueID, hString)
--	print("Resolving resolution", leagueID, hString)
	local bRenact = (gT.Leagues[leagueID].Resolutions[hString] ~= nil)
	local sRenact1 = ""
	local sRenact2 = "passes"
	local sRenact3 = "fails"
	if bRenact then
		sRenact1 = " repealing "
		sRenact2 = "repealed"
		sRenact3 = "stands"
	end
	local bNoVotesModifiers = gT.Leagues[leagueID].NoVotesFromVoting
	local sResName = gT.Leagues[leagueID].Proposals[hString].Name;
	--delay first
	local delayDuration = 2;
	local pPlayer = gT.Leagues[leagueID].Proposals[hString].ProposedBy
	if (not gT.Leagues[leagueID].Members[pPlayer]) and (pPlayer ~= -1) then
		gT.Leagues[leagueID].Proposals[hString] = nil;
		return;
	end
	--lets edit citystates votes if have major ally;
	for member, answer in pairs(gT.Leagues[leagueID].Proposals[hString].PlayersAnswers) do
		if Players[member]:IsAlive() then
			if Players[member]:IsMinorCiv() then
				local gAlly = Players[member]:GetAlly();
				if gT.Leagues[leagueID].Members[gAlly] then
					if gT.Leagues[leagueID].Proposals[hString].ProposedBy == gAlly then
						gT.Leagues[leagueID].Proposals[hString].PlayersAnswers[member] = 2;
					else
						local answerAlly = gT.Leagues[leagueID].Proposals[hString].PlayersAnswers[gAlly];
						if answerAlly then
							if answerAlly == 2 then
								gT.Leagues[leagueID].Proposals[hString].PlayersAnswers[member] = 2;
							elseif answerAlly == 5 then
								gT.Leagues[leagueID].Proposals[hString].PlayersAnswers[member] = 5;
							end
						end
					end
				end
			end
		end
	end
	local bCont = false;
	for player, answer in pairs(gT.Leagues[leagueID].Proposals[hString].PlayersAnswers) do
		if not Players[player]:IsAlive() then
			gT.Leagues[leagueID].Proposals[hString].PlayersAnswers[player] = nil;
		elseif not gT.Leagues[leagueID].Members[player] then
			gT.Leagues[leagueID].Proposals[hString].PlayersAnswers = {}; -- LoN is not invitational
		else
			bCont = true;
		end
	end
	if not bCont then
		gT.Leagues[leagueID].Proposals[hString] = nil;
		return;
	end
	for player, answer in pairs(gT.Leagues[leagueID].Proposals[hString].PlayersAnswers) do
		if answer == 3 then
			delayDuration = delayDuration + 2
			CreateVotesModifier(player, leagueID, 1, -1 * gT.Leagues[leagueID].Proposals[hString].DelayCost, 10, true)
		end
	end
	if delayDuration > 2 then
		gT.Leagues[leagueID].Proposals[hString].Delayed = GetITGGameTurn() + delayDuration;
		gT.Leagues[leagueID].Proposals[hString].DelayCost = 2 * gT.Leagues[leagueID].Proposals[hString].DelayCost
		for dhh, hHuman in pairs(gT.Globals.HumanPlayers) do
			if gT.Leagues[leagueID].Proposals[hString].ProposedBy == hHuman then
				Players[hHuman]:AddNotification(94343293, "Resolution about " .. sRenact1 .. sResName .. " in " .. gT.Leagues[leagueID].Name .. " was delayed for 4 turns.", "Vote delay!", -1, -1, 29)
			end
		end
		return;
	end
--now let's mark it was resolved in history:
	if not gT.Leagues[leagueID].ProposalsHistory[hString] then
		--this can happen in special leagues quite often
		--print("Sweet, proposal without proposalshistory", leagueID, hString);
	else
		for a, b in pairs(gT.Leagues[leagueID].ProposalsHistory[hString]) do
			if not b.ResolvedTurn then
				gT.Leagues[leagueID].ProposalsHistory[hString][a].ResolvedTurn = GetITGGameTurn();
			end
		end
	end
	local bVeto = false;
	local vPlayer;
	for player, answer in pairs(gT.Leagues[leagueID].Proposals[hString].PlayersAnswers) do
		if answer == 4 then
			bVeto = true;
			CreateVotesModifier(player, leagueID, 2, - 5, 5, false)
			vPlayer = player;
		end
	end
	if bVeto then
		if gT.Leagues[leagueID].Resolutions[14] then
			print("Error 91232134! Somebody used veto in quick sessions!", vPlayer, leagueID)
		end
		gT.Leagues[leagueID].Vetos[hString] = GetITGGameTurn() + 20; -- veto also disables reproposal for twice as much time
		if pPlayer ~= -1 then
			if gT.Leagues[leagueID].Proposals[hString].ProposalStrength == 3 then
				CreateVotesModifier(pPlayer, leagueID, 3, 2, 10, false)
			elseif gT.Leagues[leagueID].Proposals[hString].ProposalStrength == 2 then
				CreateVotesModifier(pPlayer, leagueID, 3, 1, 10, false)
			end
		end
		for dhh, hHuman in pairs(gT.Globals.HumanPlayers) do
			if gT.Leagues[leagueID].Members[hHuman] then
				if gT.Leagues[leagueID].Proposals[hString].ProposedBy == hHuman then
					Players[hHuman]:AddNotification(38459238, "Your resolution about " .. sRenact1 .. sResName .. " in " .. gT.Leagues[leagueID].Name  .. " was not passed. " .. Players[vPlayer]:GetName() .. " used veto.", "Veto!", -1, -1)
				elseif vPlayer == hHuman then
					Players[hHuman]:AddNotification(38459238, Players[gT.Leagues[leagueID].Proposals[hString].ProposedBy]:GetName() .. "'s resolution about " .. sRenact1 .. sResName .. " in " .. gT.Leagues[leagueID].Name .. " was not passed due to our veto.", "Veto!", -1, -1)
				else
					Players[hHuman]:AddNotification(38459238, Players[gT.Leagues[leagueID].Proposals[hString].ProposedBy]:GetName() .. "'s resolution about " .. sRenact1 .. sResName .. " was not passed due to " .. Players[vPlayer]:GetName() .. " calling veto.", "Veto!", -1, -1)
				end
			end
		end
		gT.Leagues[leagueID].Proposals[hString] = nil;
		return;
	end
	if gT.Leagues[leagueID].Proposals[hString].ProposalStrength == 3 then
		local bAccept = true;
		for player, answer in pairs(gT.Leagues[leagueID].Proposals[hString].PlayersAnswers) do
			if (answer == 1) or (answer == 2) then
				if not Players[player]:IsMinorCiv() then
					if answer == 1 then
						CreateVotesModifier(player, leagueID, 4, 1, 10, false)
					else
						CreateVotesModifier(player, leagueID, 5, 2, 10, false)
					end
				end
			elseif answer == 5 then
				bAccept = false;
				if not Players[player]:IsMinorCiv() then
					CreateVotesModifier(player, leagueID, 6, 2, 10, false)
				end
			end
		end
		if pPlayer ~= -1 then
			if bAccept then
				CreateVotesModifier(pPlayer, leagueID, 7, -1, 10, false)
			else
				CreateVotesModifier(pPlayer, leagueID, 8, -8, 16, true)
			end
		end
		AddNewResolution(leagueID, gT.Leagues[leagueID].Proposals[hString].ResolutionID, pPlayer, gT.Leagues[leagueID].Proposals[hString].ExtraInfo)
		for dhh, hHuman in pairs(gT.Globals.HumanPlayers) do
			if gT.Leagues[leagueID].Members[hHuman] then
				if gT.Leagues[leagueID].Proposals[hString].ProposedBy == hHuman then
					Players[hHuman]:AddNotification(89523412, "We have successfully forced resolution about " .. sRenact1 .. sResName .. " in " .. gT.Leagues[leagueID].Name .. ".", "Resolution " .. sRenact2 ..  "!", -1, -1)
				else
					Players[hHuman]:AddNotification(89523412, Players[gT.Leagues[leagueID].Proposals[hString].ProposedBy]:GetName() .. " forced resolution about " .. sRenact1 .. sResName .. " in " .. gT.Leagues[leagueID].Name .. ".", "Resolution " .. sRenact2 .. "!", -1, -1)
				end
			end
		end
		gT.Leagues[leagueID].Proposals[hString] = nil;
		return;
	elseif gT.Leagues[leagueID].Proposals[hString].ProposalStrength == 1 then
		local bAccept = true;
		for player, answer in pairs(gT.Leagues[leagueID].Proposals[hString].PlayersAnswers) do
			if answer == 5 then
				if not Players[player]:IsMinorCiv() then
					bAccept = false;
				end
			end
		end
		if bAccept then
			AddNewResolution(leagueID, gT.Leagues[leagueID].Proposals[hString].ResolutionID, pPlayer, gT.Leagues[leagueID].Proposals[hString].ExtraInfo)
			for dhh, hHuman in pairs(gT.Globals.HumanPlayers) do
				if gT.Leagues[leagueID].Members[hHuman] then
					if gT.Leagues[leagueID].Proposals[hString].ProposedBy == hHuman then
						Players[hHuman]:AddNotification(89523412, "Our resolution about " .. sRenact1 .. sResName .. " in " .. gT.Leagues[leagueID].Name .. " has been enacted.", "Resolution " .. sRenact2 .. "!", -1, -1)
					else
						Players[hHuman]:AddNotification(89523412, Players[gT.Leagues[leagueID].Proposals[hString].ProposedBy]:GetName() .. "'s resolution about " .. sRenact1 .. sResName .. " in " .. gT.Leagues[leagueID].Name .. " has been enacted.", "Resolution " .. sRenact2 .. "!", -1, -1)
					end
				end
			end
		else
			for dhh, hHuman in pairs(gT.Globals.HumanPlayers) do
				if gT.Leagues[leagueID].Members[hHuman] then
					if gT.Leagues[leagueID].Proposals[hString].ProposedBy == hHuman then
						Players[hHuman]:AddNotification(38459238, "Our resolution about " .. sRenact1 .. sResName .. " in " .. gT.Leagues[leagueID].Name .. " has been rejected.", "Resolution fails!", -1, -1)
					else
						Players[hHuman]:AddNotification(38459238, Players[gT.Leagues[leagueID].Proposals[hString].ProposedBy]:GetName() .. "'s resolution about " .. sRenact1 .. sResName .. " in " .. gT.Leagues[leagueID].Name .. " has been rejected.", "Resolution " .. sRenact3 .. "!", -1, -1)
					end
				end
			end
		end
		gT.Leagues[leagueID].Proposals[hString] = nil;
		return;
	else
		local bAccept = true;
		for player, answer in pairs(gT.Leagues[leagueID].Proposals[hString].PlayersAnswers) do
			if (answer == 1) or (answer == 2) then
				if not bNoVotesModifiers then
					if not Players[player]:IsMinorCiv() then
						if answer == 1 then
							CreateVotesModifier(player, leagueID, 4, 1, 10, false)
						else
							CreateVotesModifier(player, leagueID, 5, 1, 10, false)
						end
					end
				end
			else
				bAccept = false;
			end
		end
		if bAccept then
			AddNewResolution(leagueID, gT.Leagues[leagueID].Proposals[hString].ResolutionID, pPlayer, gT.Leagues[leagueID].Proposals[hString].ExtraInfo)
			for dhh, hHuman in pairs(gT.Globals.HumanPlayers) do
				if gT.Leagues[leagueID].Members[hHuman] then
					if gT.Leagues[leagueID].Proposals[hString].ProposedBy == hHuman then
						Players[hHuman]:AddNotification(89523412, "Our resolution about " .. sRenact1 .. sResName .. " in " .. gT.Leagues[leagueID].Name .. " has been enacted.", "Resolution " .. sRenact2 .. "!", -1, -1)
					else
						if gT.Leagues[leagueID].Proposals[hString].ProposedBy == -1 then
							Players[hHuman]:AddNotification(89523412, "Resolution about " .. sRenact1 .. sResName .. " in " .. gT.Leagues[leagueID].Name .. " has been enacted.", "Resolution " .. sRenact2 .. "!", -1, -1)
						else
							Players[hHuman]:AddNotification(89523412, Players[gT.Leagues[leagueID].Proposals[hString].ProposedBy]:GetName() .. "'s resolution about " .. sRenact1 .. sResName .. " in " .. gT.Leagues[leagueID].Name .. " has been enacted.", "Resolution " .. sRenact2 .. "!", -1, -1)
						end
					end
				end
			end
		else
			local pVotesPower = 5;
			local oVotesPower = 0;
			if pPlayer ~= -1 then
				pVotesPower = math.max(5, 5 + gT.Leagues[leagueID].Members[pPlayer].Votes);
			end
			pVotesPower = pVotesPower + (gT.Leagues[leagueID].ResSupportExtraVotes or 0)
			pVotesPower = pVotesPower + (gT.Leagues[leagueID].Proposals[hString].SupportExtraVotes or 0);
			for dMember, dAnswer in pairs(gT.Leagues[leagueID].Proposals[hString].PlayersAnswers) do
				local dValVote = 5;
				if Players[dMember]:IsMinorCiv() then
					dValVote = 0;
				end
				if dAnswer == 5 then
					oVotesPower = oVotesPower + math.max(dValVote, dValVote + gT.Leagues[leagueID].Members[dMember].Votes)
				elseif dAnswer == 2 then
					pVotesPower = pVotesPower + math.max(dValVote, dValVote + gT.Leagues[leagueID].Members[dMember].Votes)
				end
			end
			local oExpVote = math.pow(math.max(oVotesPower, 1), 2)
			local pExpVote = math.pow(math.max(pVotesPower, 1), 2)
			if (pExpVote >= LastRandom(1, pExpVote + oExpVote)) or (gT.Leagues[leagueID].Proposals[hString].InfluencedDebate) then
				local wRpC = math.floor(pExpVote * 1000 / (pExpVote +  oExpVote)) / 10;
				if (not bNoVotesModifiers) and (pPlayer ~= -1) then
					CreateVotesModifier(pPlayer, leagueID, 9, -4, 12, true)
				end
				AddNewResolution(leagueID, gT.Leagues[leagueID].Proposals[hString].ResolutionID, pPlayer, gT.Leagues[leagueID].Proposals[hString].ExtraInfo)
				for dhh, hHuman in pairs(gT.Globals.HumanPlayers) do
					if gT.Leagues[leagueID].Members[hHuman] then
						if gT.Leagues[leagueID].Proposals[hString].ProposedBy == hHuman then
							Players[hHuman]:AddNotification(89523412, "Our resolution about " .. sRenact1 .. sResName .. " in " .. gT.Leagues[leagueID].Name .. " has been enacted after a heavy debate ([COLOR_POSITIVE_TEXT]" .. pVotesPower .. "[ENDCOLOR][ICON_ITG_VOTES] vs [COLOR_NEGATIVE_TEXT]" .. oVotesPower .. "[ENDCOLOR][ICON_ITG_VOTES]: " .. wRpC .. "%).", "Resolution " .. sRenact2 .. "!", -1, -1)
						else
							if gT.Leagues[leagueID].Proposals[hString].ProposedBy == -1 then
								Players[hHuman]:AddNotification(89523412, "Resolution about " .. sRenact1 .. sResName .. " in " .. gT.Leagues[leagueID].Name .. " has been enacted after a heavy debate ([COLOR_POSITIVE_TEXT]" .. pVotesPower .. "[ENDCOLOR][ICON_ITG_VOTES] vs [COLOR_NEGATIVE_TEXT]" .. oVotesPower .. "[ENDCOLOR][ICON_ITG_VOTES]: " .. wRpC .. "%).", "Resolution " .. sRenact2 .. "!", -1, -1)
							else
								Players[hHuman]:AddNotification(89523412, Players[gT.Leagues[leagueID].Proposals[hString].ProposedBy]:GetName() .. "'s resolution about " .. sRenact1 .. sResName .. " in " .. gT.Leagues[leagueID].Name .. " has been enacted after a heavy debate ([COLOR_POSITIVE_TEXT]" .. pVotesPower .. "[ENDCOLOR][ICON_ITG_VOTES] vs [COLOR_NEGATIVE_TEXT]" .. oVotesPower .. "[ENDCOLOR][ICON_ITG_VOTES]: " .. wRpC .. "%).", "Resolution " .. sRenact2 .. "!", -1, -1)
							end
						end
					end
				end
			else
				local wRpC = math.floor(oExpVote * 1000 / (pExpVote +  oExpVote)) / 10;
				if not bNoVotesModifiers then
					if pPlayer ~= -1 then
						CreateVotesModifier(pPlayer, leagueID, 10, 1, 12, false)
					end
					for player, answer in pairs(gT.Leagues[leagueID].Proposals[hString].PlayersAnswers) do
						if answer == 5 then
							if not Players[player]:IsMinorCiv() then
								CreateVotesModifier(player, leagueID, 11, -1, 12, false)
							end
						end
					end
				end
				for dhh, hHuman in pairs(gT.Globals.HumanPlayers) do
					if gT.Leagues[leagueID].Members[hHuman] then
						if gT.Leagues[leagueID].Proposals[hString].ProposedBy == hHuman then
							Players[hHuman]:AddNotification(38459238, "Our resolution about " .. sRenact1 .. sResName .. " in " .. gT.Leagues[leagueID].Name .. " has been rejected after a heavy debate ([COLOR_POSITIVE_TEXT]" .. pVotesPower .. "[ENDCOLOR][ICON_ITG_VOTES] vs [COLOR_NEGATIVE_TEXT]" .. oVotesPower .. "[ENDCOLOR][ICON_ITG_VOTES]: " .. wRpC .. "%).", "Resolution " .. sRenact3 .. "!", -1, -1)
						else
							if gT.Leagues[leagueID].Proposals[hString].ProposedBy == -1 then
								Players[hHuman]:AddNotification(38459238, "Resolution about " .. sRenact1 .. sResName .. " in " .. gT.Leagues[leagueID].Name .. " has been rejected after a heavy debate ([COLOR_POSITIVE_TEXT]" .. pVotesPower .. "[ENDCOLOR][ICON_ITG_VOTES] vs [COLOR_NEGATIVE_TEXT]" .. oVotesPower .. "[ENDCOLOR][ICON_ITG_VOTES]: " .. wRpC .. "%).", "Resolution " .. sRenact3 .. "!", -1, -1)
							else
								Players[hHuman]:AddNotification(38459238, Players[gT.Leagues[leagueID].Proposals[hString].ProposedBy]:GetName() .. "'s resolution about " .. sRenact1 .. sResName .. " in " .. gT.Leagues[leagueID].Name .. " has been rejected after a heavy debate ([COLOR_POSITIVE_TEXT]" .. pVotesPower .. "[ENDCOLOR][ICON_ITG_VOTES] vs [COLOR_NEGATIVE_TEXT]" .. oVotesPower .. "[ENDCOLOR][ICON_ITG_VOTES]: " .. wRpC .. "%).", "Resolution " .. sRenact3 .. "!", -1, -1)
							end
						end
					end
				end
			end
		end
		gT.Leagues[leagueID].Proposals[hString] = nil;
		return;
	end
end

LuaEvents.ITGSG_ProposeResolutionStrength.Add(function(player, league, proposal, option)
	PlayerProposalStrength(player, league, proposal, option)
	RefreshAllDirtyPlayer()
end)
LuaEvents.ITGSG_AnswerResolution.Add(function(player, league, proposal, option)
	PlayerProposalAnswer(player, league, proposal, option)
	RefreshAllDirtyPlayer()
end)
LuaEvents.HumanPlayerCallResolution.Add(function(leagueID, idR, extrainfo1)
	PlayerProposeChangeToLeague(leagueID, idR, Game.GetActivePlayer(), extrainfo1)
	RefreshAllDirtyPlayer()
end)
LuaEvents.HumanPlayerCallResolutionMultiple.Add(function(leagueID, idR, answerTab)
	PlayerProposeSpecialChange(leagueID, idR, Game.GetActivePlayer(),answerTab)
	RefreshAllDirtyPlayer()
end)

function HasAtLeastOneViableOptionForProposal(i, type, cUIDl, iPlayer)
	return #getTabOfViableOptionsResolution(i,type, cUIDl, iPlayer) > 0;
end
LuaEvents.ITGGetExtraInfoForProposal.Add(function(leagueID, resolution, type)
	MapModData.ITGSG = getTabOfViableOptionsResolution(resolution, type, leagueID, Game.GetActivePlayer())
	MapModData.ITGSG2 = GetInfoFromTabOfProposal(resolution, "NumChoices")
end)

function TakeCareOfBadCityStates(leagueID)
	local minTab = {}
	local majTab = {}
	for member, sth in pairs(gT.Leagues[leagueID].Members) do
		if Players[member]:IsMinorCiv() then
			table.insert(minTab, member);
		else
			table.insert(majTab, Players[member]:GetTeam());
		end
	end
	for i, minor in pairs(minTab) do
		local valid = false;
		local mTeam = Teams[Players[minor]:GetTeam()];
		for j, jteam in pairs(majTab) do
			if not mTeam:IsAtWar(jteam) then
				valid = true;
				break;
			end
		end
		if not valid then
			RemovePlayerFromLeague(minor, leagueID, "City-State")
		end
	end
end

function ChooseHostMember(leagueID, bUpdate)
	local bestV = 0;
	local bDraw = false;
	local bPlayer;
	local tVotes = {}
	local gTurn = GetITGGameTurn();
	for member, sth in pairs(gT.Leagues[leagueID].Members) do
		if Players[member]:IsAlive() then
			if not Players[member]:IsMinorCiv() then
				tVotes[member] = (tVotes[member] or 0) + sth.Votes
			else
				local gAlly = Players[member]:GetAlly()
				if gT.Leagues[leagueID].Members[gAlly] then
					tVotes[gAlly] = (tVotes[gAlly] or 0) + sth.Votes
				end
			end
		end
	end
	for gPlayer, votes in pairs(tVotes) do
		if votes > bestV then
			bPlayer = gPlayer
			bestV = votes;
			bDraw = false
		elseif votes == bestV then
			bDraw = true;
		end
	end
	if bPlayer and (not bDraw) then
		local cdHost = gT.Leagues[leagueID].HostDivider;
		if not cdHost then
			local minV = bestV;
			for gPlayer, votes in pairs(tVotes) do
				if gPlayer ~= bPlayer then
					minV = math.min(minV, bestV - votes);
				end
			end
			cdHost = 5 + math.min(5, math.floor(10 * minV / bestV))
			gT.Leagues[leagueID].HostCD = gTurn + cdHost;
		end
		for a, human in pairs(gT.Globals.HumanPlayers) do
			if gT.Leagues[leagueID].Members[human] then
				if bPlayer == human then
					Players[human]:AddNotification(94343293, "You have been chosen to lead " .. gT.Leagues[leagueID].Name .. " for next " .. cdHost .. " turns.", "Host chosen!", -1, -1, 31, bPlayer)
				else				
					Players[human]:AddNotification(94343293, GetNameOrUnknown(bPlayer) .. " has been chosen to lead " .. gT.Leagues[leagueID].Name .. " for next " .. cdHost .. " turns.", "Host chosen!", -1, -1, 31, bPlayer)
				end
			end
		end
		gT.Leagues[leagueID].Host = bPlayer;
	else
		if not gT.Leagues[leagueID].HostDivider then
			gT.Leagues[leagueID].Host = nil;
			gT.Leagues[leagueID].HostCD = gTurn + 5;
		end
	end
	if bUpdate then
		UpdateAllVotesLeague(leagueID)
	end
end

function UpdateAllVotesLeague(leagueID)
	for member, hth in pairs(gT.Leagues[leagueID].Members) do
		UpdateMemberVotesInLeague(member, leagueID)
	end
end

function UpdatePlayerVotesInAllLeagues(iPlayer)
	for leagueID, sth in pairs(gT.Leagues) do
		if sth.Members[iPlayer] then
			UpdateMemberVotesInLeague(iPlayer, leagueID)
		end
	end
end

function PlayerMadeActionInLeague(leagueID, idR, iPlayer, extrainfo1, cost, cd)
	if cd then
		gT.Leagues[leagueID].ActionCooldowns[idR] = GetITGGameTurn() + cd;
	end
	--effect
	gT.Players[iPlayer].LHLeagueAction = gT.Players[iPlayer].LHLeagueAction + 1;
	if idR == 27 then
		gT.Globals.CaliphateMod = gT.Globals.CaliphateMod + 1;
		local tR;
		for i, d in pairs(gT.Leagues[leagueID].FakeResolutions) do
			if d.ResID == 2756 then
				tR = i;
			end
		end
		if tR then
			table.remove(gT.Leagues[leagueID].FakeResolutions, tR)
		end
		table.insert(gT.Leagues[leagueID].FakeResolutions, {Name = "Caliph's Influence x" .. gT.Globals.CaliphateMod, EnactedTurn = GetITGGameTurn(), ResID = 2756})
		for ji, iHuman in pairs(gT.Globals.HumanPlayers) do
			if iHuman == iPlayer then
				Players[iPlayer]:AddNotification(94343293, "Base Caliph's rewards are now multiplied by " .. gT.Globals.CaliphateMod .. ".", "Supreme Caliph", -1, -1, 31)
			elseif gT.Leagues[leagueID].Members[iHuman] then 
				Players[iHuman]:AddNotification(94343293, Players[iPlayer]:GetName() .. " has ensured that Caliph's position is supreme in the world (increased Caliph's bonus).", "Supreme Caliph", -1, -1, 31)
			end
		end
	elseif idR == 29 then
		local noM = GetNumMembersMajor(leagueID) -1;
		local gold = GetGoldLegalFromActionLeague(leagueID, 20)
		for im, s in pairs(gT.Leagues[leagueID].Members) do
			if not Players[im]:IsMinorCiv() then
				if im ~= iPlayer then
					SpendITGGold(im, gold)
					if Players[im]:IsHuman() then
						Players[im]:AddNotification(94343293, "We have supported " .. Players[iPlayer]:GetName() .. " with " .. gold .. " [ICON_GOLD] Gold in the time of need.", "Financial Support", -1, -1, 32)
					end
				end
			end
		end
		ChangeITGGold(iPlayer, gold * noM);
		if Players[iPlayer]:IsHuman() then
			Players[iPlayer]:AddNotification(94343293, "In the time of need our allies from " .. gT.Leagues[leagueID].Name .. " supported us with " .. gold * noM .. " [ICON_GOLD] Gold.", "Financial Support", -1, -1, 32)
		end
	elseif idR == 30 then
		local noM = GetNumMembersMajor(leagueID) - 1;
		local gold = GetGoldLegalFromActionLeague(leagueID, 15)
		for im, s in pairs(gT.Leagues[leagueID].Members) do
			if not Players[im]:IsMinorCiv() then
				if im ~= iPlayer then
					SpendITGLegalPowerPercent(im, gold, nil, "LeagueSupport")
					if Players[im]:IsHuman() then
						Players[im]:AddNotification(94343293, "We have supported " .. Players[iPlayer]:GetName() .. " with " .. gold/100 .. " [ICON_ITG_LEGAL_POWER] Legal Power in the time of need.", "Legitimacy", -1, -1, 35)
					end
				end
			end
		end
		ChangeITGLegalPointsPercent(iPlayer, gold * noM);						
		if Players[iPlayer]:IsHuman() then
			Players[iPlayer]:AddNotification(94343293, "In the time of need our allies from " .. gT.Leagues[leagueID].Name .. " supported us with " .. gold * noM / 100 .. " [ICON_ITG_LEGAL_POWER] Legal Power.", "Legitimacy", -1, -1, 35)
		end
	elseif idR == 32 then
		local totalboost = 0;
		for im, s in pairs(gT.Leagues[leagueID].Members) do
			if not Players[im]:IsMinorCiv() then
				if im ~= iPlayer then
					local hh = Players[extrainfo1]:GetMinorCivFriendshipWithMajor(im);
					if hh > 0 then
						totalboost = totalboost + hh;
						Players[extrainfo1]:ChangeMinorCivFriendshipWithMajor(im, -hh);
						if Players[im]:IsHuman() then
							Players[im]:AddNotification(94343293, "Our [ICON_INFLUENCE] Influence with " .. Players[extrainfo1]:GetName() .. " dropped by " .. hh .. " to help out the cause of our ally, " .. Players[iPlayer]:GetName() .. ".", "Shared Influence", -1, -1, 34)
						end
					end
				end
			end
		end
		if totalboost > 0 then
			Players[extrainfo1]:ChangeMinorCivFriendshipWithMajor(iPlayer, totalboost);
			if Players[iPlayer]:IsHuman() then
				Players[iPlayer]:AddNotification(94343293, "Our allies in " .. gT.Leagues[leagueID].Name .. " sacrificied their [ICON_INFLUENCE] Influence with " .. Players[extrainfo1]:GetName() .. " to help out our cause (+" .. totalboost .. "[ICON_INFLUENCE]).", "Shared Influence", -1, -1, 34)
			end
		end
	elseif idR == 33 then
		local gNApp = GetNGWFromActionLeague(leagueID);
		local isj = 0;
		for im, s in pairs(gT.Leagues[leagueID].Members) do
			if not Players[im]:IsMinorCiv() then
				if im ~= iPlayer then
					isj = isj + gNApp;
					for hhj = 1, gNApp do
						DoTransferArt(im, iPlayer, "Random", 10)
					end
					if Players[im]:IsHuman() then
						Players[im]:AddNotification(94343293, "We have happily send " .. gNApp .. " [ICON_GREAT_WORK] Great Works to " .. Players[iPlayer]:GetName() .. ", strengthening our position in union.", "Requested Art", -1, -1, 33)
					end
				end
			end
		end
		if Players[iPlayer]:IsHuman() then
			Players[iPlayer]:AddNotification(94343293, "Allies in " .. gT.Leagues[leagueID].Name .. " send us " .. isj .. " [ICON_GREAT_WORK] Great Works to celebrate our unity.", "Requested Art", -1, -1, 33)
		end
	elseif idR == 31 then
		local exTeam = Players[extrainfo1]:GetTeam();
		for member, s in pairs(gT.Leagues[leagueID].Members) do
			if Players[member]:IsAlive() then
				if not Players[member]:IsMinorCiv() then
					if member ~= iPlayer then
						local mTeam = Teams[Players[member]:GetTeam()];
						if not mTeam:IsAtWar(exTeam) then
							if not Players[extrainfo1]:IsDoF(member) then
								if not mTeam:IsHasMet(exTeam) then
									mTeam:Meet(exTeam);
								end
								if mTeam:CanDeclareWar(exTeam) then
									mTeam:DeclareScriptedWar(exTeam);
									HnGLogWarDeclaredSpecialLeagueForce(mTeam:GetID(), iPlayer); -- note this war was allianced
									for j, h in pairs(gT.Players) do
										if Players[j]:GetTeam() == exTeam then
											ChangePeaceWarLock(j, member, 1, "League31")
											if not gT.Leagues[leagueID].Members[member].WarLocks then
												gT.Leagues[leagueID].Members[member].WarLocks = {}
											end
											table.insert(gT.Leagues[leagueID].Members[member].WarLocks, {j, iPlayer})
										end
									end
									Players[member]:AddNotification(94343293, "Our ally, " .. Players[iPlayer]:GetName() .. " requested assistance in war against " .. Players[extrainfo1]:GetName() .. ".", "Common Foe", -1, -1, 30)
								end
							end
						end
					end
				end
			end
		end
		if not Players[iPlayer]:IsHuman() then
			if DoesNotSeemAsDangerToAI(iPlayer, extrainfo1) then
				DoAddCounterTimePeaceLock(iPlayer, extrainfo1, 25, "AIscript")
			end
		end
	elseif idR == 64 then
		local lawsToChange = GetBestXLawsToBeChange(iPlayer, leagueID, 3);
		local bCheckAchiev = Players[iPlayer]:IsHuman();
		local nmba = 0;
		for member, s in pairs(gT.Leagues[leagueID].Members) do
			if Players[member]:IsAlive() then
				if not Players[member]:IsMinorCiv() then
					if member ~= iPlayer then
						nmba = nmba + 1;
						local lawsstring = "";
						for i, lawID in pairs(lawsToChange) do
							if CanPlayerHaveLaw(member, lawID) then
								if gT.Players[member].Laws[lawID][1] ~= gT.Players[iPlayer].Laws[lawID][1] then
									if bCheckAchiev then
										DoCheckAchievement136(member, lawID, gT.Players[iPlayer].Laws[lawID][1])
									end
									OnLawChanged(member, lawID, gT.Players[iPlayer].Laws[lawID][1], true)
									if lawsstring == "" then
										lawsstring = lawsstring .. "[NEWLINE][COLOR_POSITIVE_TEXT]" .. Locale.Lookup(GetInfoFromLawT(lawID, "Description")) .. "[ENDCOLOR]"
									else
										lawsstring = lawsstring .. ",[NEWLINE][COLOR_POSITIVE_TEXT]" .. Locale.Lookup(GetInfoFromLawT(lawID, "Description")) .. "[ENDCOLOR]"
									end
								end
							end
						end
						if Players[member]:IsHuman() then
							if lawsstring ~= "" then
								Players[member]:AddNotification(94343293, "We have gladly adopted the laws of our ally, " .. Players[iPlayer]:GetName() .. ":" .. lawsstring .. ".", "Unified Laws", -1, -1, 35)
							end
						end
					end
				end
			end
		end
		if nmba > 0 then
			local perP = math.ceil(20 / nmba);
			for member, s in pairs(gT.Leagues[leagueID].Members) do
				if Players[member]:IsAlive() then
					if not Players[member]:IsMinorCiv() then
						if member ~= iPlayer then
							gT.Players[iPlayer].CodexInfluenceFromLeague = gT.Players[iPlayer].CodexInfluenceFromLeague + perP;
							gT.Leagues[leagueID].Members[iPlayer].ExtraCodexInfluence = (gT.Leagues[leagueID].Members[iPlayer].ExtraCodexInfluence or 0) + perP;
							gT.Players[member].CodexInfluenceFromLeague = gT.Players[member].CodexInfluenceFromLeague - perP;
							gT.Leagues[leagueID].Members[member].ExtraCodexInfluence = (gT.Leagues[leagueID].Members[member].ExtraCodexInfluence or 0) - perP;
						end
					end
				end
			end
		end
		if Players[iPlayer]:IsHuman() then
			local lawsstring = "";
			for i, lawID in pairs(lawsToChange) do
				if lawsstring == "" then
					lawsstring = lawsstring .. "[NEWLINE][COLOR_POSITIVE_TEXT]" .. Locale.Lookup(GetInfoFromLawT(lawID, "Description")) .. "[ENDCOLOR]"
				else
					lawsstring = lawsstring .. ",[NEWLINE][COLOR_POSITIVE_TEXT]" .. Locale.Lookup(GetInfoFromLawT(lawID, "Description")) .. "[ENDCOLOR]"
				end
			end
			Players[iPlayer]:AddNotification(94343293, "Our allies in " .. gT.Leagues[leagueID].Name .. " gladly adopted our laws:" .. lawsstring .. ".", "Unified Laws", -1, -1, 35)
		end
	end
	AddExtraVotesScriptedLeague(iPlayer, leagueID, "Actions", -cost)
	table.insert(gT.Leagues[leagueID].ActionLog, {iPlayer, idR, extrainfo1, GetITGGameTurn()})
end

function DoCheckLeagueEffectsOnPeace(teamId, otherTeamId)
	for i, s in pairs(gT.Players) do
		if Players[i]:GetTeam() == teamId then
			PlayerLeagueMadePeaceWithTeam(i, otherTeamId)
		elseif Players[i]:GetTeam() == otherTeamId then
			PlayerLeagueMadePeaceWithTeam(i, teamId)
		end
	end
end

function PlayerLeagueMadePeaceWithTeam(i, team)
	for leage, sth in pairs(gT.Leagues) do
		if sth.Members[i] then
			for b, d in pairs(sth.Members) do
				local ph = {}
				for j, h in pairs(d.WarLocks or {}) do
					if (h[2] == i) or (b == i) then --barbarian conquer force peace, etc.
						if Players[h[1]]:GetTeam() == team then
							ChangePeaceWarLock(h[1], b, -1, "League31")
							table.insert(ph, j)
						end
					end
				end
				local t = #ph;
				for idj = 1, t do
					table.remove(gT.Leagues[leage].Members[b].WarLocks, ph[t + 1 - idj])
				end
			end
		end
	end
end

function GetPlayerVotesWithMinorsLeague(iPlayer, leagueID)
	local base = gT.Leagues[leagueID].Members[iPlayer].Votes 
	for member, data in pairs(gT.Leagues[leagueID].Members) do
		if Players[member]:IsMinorCiv() then
			if Players[member]:IsAlive() and Players[member]:GetAlly() == iPlayer then
				base = base + data.Votes;
			end
		end
	end
	return base;
end

function GetVoteAdvantageOverOtherMembers(uid, iPlayer)
	local votesBh = 999;
	for member, sth in pairs(gT.Leagues[uid].Members) do
		if member ~= iPlayer then
			votesBh = math.min(gT.Leagues[uid].Members[iPlayer].Votes - sth.Votes, votesBh);
		end
	end
	return votesBh;
end

function GetLegalPenaltyBreakingLeague(votesBh)
	local base = 100;
	if votesBh > 0 then
		base = base + math.floor(math.sqrt(votesBh) * 100)
	end
	return base;
end

function DoPenaltyFromBreakingLeague(bPlayer, uid)
	local votesBh = 0;
	for member, sth in pairs(gT.Leagues[uid].Members) do
		votesBh = math.max(sth.Votes - gT.Leagues[uid].Members[bPlayer].Votes, votesBh);
	end
	local nRes = 0;
	for i, s in pairs(gT.Leagues[uid].Resolutions) do
		nRes = nRes + 0.5
	end
	local legalPenalty = GetLegalPenaltyBreakingLeague(votesBh);
	SpendITGLegalPowerPercent(bPlayer, legalPenalty, true, "League break")
	nRes = math.floor(nRes);
	if nRes > 0 then
		BoostHappinessInAllCities(bPlayer, -nRes)
	end
	local moraleloss = LastRandom(3,5)
	TakeCareOfEventMorale(bPlayer, 25, {-moraleloss, "Breaking Union"})
	local vBehindAdd = 1;
	if gT.Players[bPlayer].VotesFromBreakingLeague then
		vBehindAdd = gT.Players[bPlayer].VotesFromBreakingLeague * 2;
	end
	gT.Players[bPlayer].VotesFromBreakingLeague = (gT.Players[bPlayer].VotesFromBreakingLeague or 0) + vBehindAdd
	NoteGovCausesBasicStack(bPlayer, 17)
	if Game.GetActivePlayer() == bPlayer then
		local bString = "Our treason against " .. gT.Leagues[uid].Name .. " made an impact on our subjects and diplomatic position."
		if nRes > 0 then
			bString = bString .. "[NEWLINE][ICON_BULLET]+" .. nRes .. " [ICON_HAPPINESS_4] Unhappiness in all cities."
		end
		bString = bString .. "[NEWLINE][ICON_BULLET]-" .. moraleloss .. "% [ICON_ITG_MORALE] Morale."
		if legalPenalty > 0 then
			bString = bString .. "[NEWLINE][ICON_BULLET]-" .. legalPenalty / 100 .. " [ICON_ITG_LEGAL_POWER] Legal power."
		end
		bString = bString .. "[NEWLINE][ICON_BULLET]-" .. vBehindAdd .. " [ICON_ITG_VOTES] Vote(s) in any league."
		Players[bPlayer]:AddNotification(NotificationTypes.NOTIFICATION_GENERIC, bString, "Breaking Union")
	
	end
end

function GetNumMembersMajor(leagueID)
	local c = 0;
	for i, s in pairs(gT.Leagues[leagueID].Members) do
		if not Players[i]:IsMinorCiv() then
			c = c + 1;
		end
	end
	return c;
end

function GetGoldLegalFromActionLeague(leagueID, th)
	local nMembers = GetNumMembersMajor(leagueID) - 1;
	if nMembers < 1 then
		return -1;
	end
	return math.ceil(th / nMembers) * 25;
end

function GetNGWFromActionLeague(leagueID)
	local nMembers = GetNumMembersMajor(leagueID) - 1;
	if nMembers < 1 then
		return -1;
	end
	if nMembers == 1 then
		return 4;
	elseif nMembers < 4 then
		return 2;
	else
		return 1;
	end
end

function TakeCareOfActionVotePenalty(leagueID)
	local bAll = true;
	for m, s in pairs(gT.Leagues[leagueID].Members) do
		if not Players[m]:IsMinorCiv() then
			if (not s.VotesFromScripts["Actions"]) or (s.VotesFromScripts["Actions"] >= 0) then
				bAll = false;
				break
			end
		end
	end
	if bAll then
		for m, s in pairs(gT.Leagues[leagueID].Members) do
			if not Players[m]:IsMinorCiv() then
				AddExtraVotesScriptedLeague(m, leagueID, "Actions", 1)
			end
		end
	end
end

function TakeCareOfOngoingProjects(leagueID)
	if gT.Leagues[leagueID].OnGoingProjects then
		local trm = {}
		for i, v in pairs(gT.Leagues[leagueID].OnGoingProjects) do
			local resID = v[1];
			local hString = resID;
			if v[2] then
				hString = resID .. "x" .. v[2];
			end
			if gT.Leagues[leagueID].Resolutions[hString].ProjectPrepare then
				PrepareInitialDataForProject(leagueID, resID, hString)
			elseif gT.Leagues[leagueID].Resolutions[hString].Active then
				if resID == 45 then
					SeekerActiveTurnLeagueFunc(leagueID, resID, hString)
				elseif gT.Leagues[leagueID].Resolutions[hString].EndTurn then
					if gT.Leagues[leagueID].Resolutions[hString].EndTurn <= GetITGGameTurn() then
						FinishOngoingLeagueProject(leagueID, resID, hString)
					end
				elseif gT.Leagues[leagueID].Resolutions[hString].TotalContribution >= DBScenario.LeagueProjectCost then
					FinishOngoingLeagueProject(leagueID, resID, hString)
				end
			end
			if (not gT.Leagues[leagueID].Resolutions[hString]) or (gT.Leagues[leagueID].Resolutions[hString].Finished) then
				table.insert(trm, i)
			end
		end
		for i = 1, #trm do
			table.remove(gT.Leagues[leagueID].OnGoingProjects, trm[#trm + 1 - i])
		end
	end
end

function GetNumCrusaderUnitsFromProd(totalprod)
	local bhh = 75;
	local units = 3;
	while totalprod >= bhh do
		units = units + 1;
		totalprod = totalprod - bhh;
		bhh = bhh + 25;
	end
	return units;
end

function FinishOngoingLeagueProject(leagueID, resID, hString)
--rewards
--here hardcode each project
	local hTab = {}
	for member, sth in pairs(gT.Leagues[leagueID].Members) do
		if not Players[member]:IsMinorCiv() then
			table.insert(hTab, {member, gT.Leagues[leagueID].Resolutions[hString].Contributions[member],0})
		end
	end
	hTab = Shuffle(hTab);
	table.sort(hTab, SortFunctionForGreaterInteger2);
	local tresholdsilver = DBScenario.LeagueProjectCost / 4 -- generic
	if resID == 16 then
		local leaders = {}
		local totalprod = 0;
		for i, data in pairs(hTab) do
			totalprod = totalprod + data[2];
			if i == 1 then
				table.insert(leaders, data[1])
				hTab[i][3] = 1;
			end
			if data[2] >= 75 then
				ChangeITGFaith(data[1], 200)
				ChangeMeritocracy(data[1], 3)
				if data[2] >= 200 then
					ChangeMeritocracy(data[1], 3)
					ChangeITGLegalPointsPercent(data[1], 200)
					hTab[i][3] = (hTab[i][3] or 2)
				end
				hTab[i][3] = (hTab[i][3] or 3)
			end
		end
		local unitamount = GetNumCrusaderUnitsFromProd(totalprod) 
		unitamount = math.ceil(unitamount / #leaders)
		local pCity = Map.GetPlotByIndex(gT.Leagues[leagueID].Resolutions[hString].ExtraInfo):GetPlotCity();
		local pOwner = pCity:GetOwner();
		local dPlots = {}
		for i = 1, pCity:GetNumCityPlots() - 1, 1 do
			local plot = pCity:GetCityIndexPlot( i );
			if (plot) then
				if (not plot:IsWater()) and (not plot:IsMountain()) and (not plot:IsCity()) then
					table.insert(dPlots, {plot, plot:GetNumUnits(), math.abs(Map.PlotDistance(pCity:GetX(), pCity:GetY(), plot:GetX(), plot:GetY()) - 2)})
				end
			end
		end
		if #dPlots > 0 then
			table.sort(dPlots, SortFunctionLowest2Lowest3)
			local th = dPlots[1][2];
			local endplots = {}
			for i, pp in pairs(dPlots) do
				if pp[2] == th then
					table.insert(endplots, pp[1])
				else
					break
				end
			end
			local endplots = Shuffle(endplots);
			for i, leader in pairs(leaders) do
				if Players[leader]:IsHuman() then
					LuaEvents.ITG_AchievementCompleted(73)
				end
				local cPlot = endplots[i] or (endplots[LastRandom(1,#endplots)]);
				local bValidTarget = IsValidPlayerToBeTargetOfCrusade(pOwner)
				if bValidTarget  then
					local pTeam = Players[pOwner]:GetTeam();
					local lTeam = Players[leader]:GetTeam();
					if not Teams[lTeam]:IsAtWar(pTeam) then
						Teams[lTeam]:DeclareScriptedWar(pTeam);
					end
				end
				for d = 1, unitamount do
					local hUnit = SimpleGenerateUnitOfType(leader, GetRandomUnitTypeOfDomain(leader, "DOMAIN_LAND"), cPlot, nil, nil, false, false, false, "Crusader")
					if hUnit then
						local uID = hUnit:GetID() .. "," .. leader .. "," .. hUnit:GetGameTurnCreated();
						gT.Players[leader].UnitsByID[uID].Crusader = true;
						SetUnitForcedStackType(hUnit, -1, "Crusade", 8);
						hUnit:SetTargetPlotForCombatMod(pCity:Plot():GetPlotIndex())
						hUnit:SetMadeAttack(true)
					end
				end
				HnGLogCrusade(leader, pOwner, pCity, gT.Leagues[leagueID].Host, bValidTarget)
			end
		end
		for i, iHuman in pairs(gT.Globals.HumanPlayers) do
			if Players[iHuman]:IsAlive() then
				if gT.Leagues[leagueID].Members[iHuman] then
					table.insert(gT.Players[iHuman].TheRaceInfoTable, {Type = "BasicRace", Title = "Crusade", Help = GetProperResolutionHelp(16, gT.Leagues[leagueID].Resolutions[hString].ExtraInfo), OnlyOne = true, Players = hTab})
				end
			end
		end
	elseif resID == 38 then
		for i, data in pairs(hTab) do
			if i == 1 then
				ChangeITGFestivalPoints(data[1], 1)
				CreateGreatWorkOfAmount(data[1], 2, "Random")
				ChangeITGCulture(data[1], math.ceil(data[2]))
				hTab[i][3] = 1;
			elseif data[2] >= tresholdsilver then
				CreateGreatWorkOfAmount(data[1], 2, "Random")
				ChangeITGCulture(data[1], math.ceil(data[2]))
				hTab[i][3] = 2;
			elseif data[2] > 0 then
				ChangeITGCulture(data[1], math.ceil(data[2]))
				hTab[i][3] = 3;
			end
		end
		for i, iHuman in pairs(gT.Globals.HumanPlayers) do
			if Players[iHuman]:IsAlive() then
				if gT.Leagues[leagueID].Members[iHuman] then
					table.insert(gT.Players[iHuman].TheRaceInfoTable, {Type = "BasicRace", Title = "Festival", Help = GetProperResolutionHelp(38, gT.Leagues[leagueID].Resolutions[hString].ExtraInfo), OnlyOne = false, Players = hTab})
				end
			end
		end
	elseif resID == 39 then
		for i, data in pairs(hTab) do
			if i == 1 then
				gT.Players[data[1]].CodexDiscount = (gT.Players[data[1]].CodexDiscount or 0) + 3;
				gT.Players[data[1]].FreeLaws = gT.Players[data[1]].FreeLaws + 1;
				ChangeITGLegalPointsPercent(data[1], math.floor(data[2]))
				hTab[i][3] = 1;
			elseif data[2] >= tresholdsilver then
				gT.Players[data[1]].FreeLaws = gT.Players[data[1]].FreeLaws + 1;
				ChangeITGLegalPointsPercent(data[1], math.floor(data[2]))
				hTab[i][3] = 2;
			elseif data[2] > 0 then
				ChangeITGLegalPointsPercent(data[1], math.floor(data[2]))
				hTab[i][3] = 3;
			end
		end
		for i, iHuman in pairs(gT.Globals.HumanPlayers) do
			if Players[iHuman]:IsAlive() then
				if gT.Leagues[leagueID].Members[iHuman] then
					table.insert(gT.Players[iHuman].TheRaceInfoTable, {Type = "BasicRace", Title = "Code of Laws", Help = GetProperResolutionHelp(39, gT.Leagues[leagueID].Resolutions[hString].ExtraInfo), OnlyOne = false, Players = hTab})
				end
			end
		end
	elseif resID == 40 then
		for i, data in pairs(hTab) do
			if i == 1 then
				AssignWonderComplete(data[1], gT.Leagues[leagueID].Resolutions[hString].Wonder)
				HnGLogWonderData(gT.Leagues[leagueID].Resolutions[hString].Wonder, "LeagueProject", leagueID)
				hTab[i][3] = 1;
			elseif data[2] > 0 then
				if gT.Players[data[1]].CanWonderRace then
					BoostWonderProduction(data[1], data[2])	
					hTab[i][3] = 2;
				else
					ChangeITGGold(data[1], data[2])
					hTab[i][3] = 3;
				end
			end
		end
		for i, iHuman in pairs(gT.Globals.HumanPlayers) do
			if Players[iHuman]:IsAlive() then
				if gT.Leagues[leagueID].Members[iHuman] then
					table.insert(gT.Players[iHuman].TheRaceInfoTable, {Type = "BasicRace", Title = "Monument", Help = GetProperResolutionHelp(40, gT.Leagues[leagueID].Resolutions[hString].ExtraInfo), OnlyOne = true, Players = hTab})
				end
			end
		end
	end
--over
	JustFinishDataProject(leagueID, resID, hString)	
end

function PrepareInitialDataForProject(leagueID, resID, hString)
	gT.Leagues[leagueID].Resolutions[hString].ProjectPrepare = nil;
	if resID == 40 then
	--collect wonder :)
		local gVwtc = GetValidWonderToClaim();
		if not gVwtc then
			gT.Leagues[leagueID].Resolutions[hString].Finished = true;
			return;
		else
			gT.Leagues[leagueID].Resolutions[hString].Wonder = gVwtc;
		end
	elseif resID == 44 then
		ResolveSpecialProjectTournament(leagueID, resID, hString)
		return;
	elseif resID == 45 then
		PrepareSpecialProjectSeeker(leagueID, resID, hString)
		return;
	end
	gT.Leagues[leagueID].Resolutions[hString].Active = true;
	gT.Leagues[leagueID].Resolutions[hString].TotalContribution = 0;
	gT.Leagues[leagueID].Resolutions[hString].Contributions = {}
	for member, sth in pairs(gT.Leagues[leagueID].Members) do
		if not Players[member]:IsMinorCiv() then
			gT.Leagues[leagueID].Resolutions[hString].Contributions[member] = 0;
			gT.Players[member].LeagueProjects[resID] = (gT.Players[member].LeagueProjects[resID] or 0) + 1;
			if not Players[member]:IsHuman() then
				gT.Players[member].AIScriptQueue[3] = resID;
			end
		end
	end
end

function GetBestUnitForContest(member, iClass)
	local hTab = {}
	for iUnit in Players[member]:Units() do
		if iUnit:GetUnitClassType() == iClass then
			table.insert(hTab, {iUnit, GetTournamentStrengthOfUnit(iUnit, iClass, member)})
		end
	end
	if #hTab > 0 then
		hTab = Shuffle(hTab);
		table.sort(hTab, SortFunctionForGreaterInteger2);
		return hTab[1][1]
	end
	return nil
end

function ResolveSpecialProjectTournament(leagueID, resID, hString)
	gT.Leagues[leagueID].Resolutions[hString].Finished = true;
	local partT = {}
	local ppt = 0
	local iClass = gT.Leagues[leagueID].Resolutions[hString].ExtraInfo
	for member, sth in pairs(gT.Leagues[leagueID].Members) do
		local iUnit = GetBestUnitForContest(member, iClass);
		if iUnit then
			partT[member] = iUnit
			ppt = ppt + 1;
		end
	end
	if ppt < 2 then
		return;
	end
	local fTab = {}
	for ip, sp in pairs(partT) do
		local tcv = 0;
		for jp, jsp in pairs(partT) do
			if jp ~= ip then
				tcv = tcv + sp:GetCombatDamageSim(jsp:GetOwner(), jsp:GetID());
			end
		end
		table.insert(fTab, {ip, tcv, 0})
	end
	fTab = Shuffle(fTab);
	table.sort(fTab, SortFunctionForGreaterInteger2);
	for i, data in pairs(fTab) do
		if i == 1 then
			partT[data[1]]:ChangeExperience(50)
			fTab[i][3] = 1;
			if Players[data[1]]:IsHuman() then
				LuaEvents.ITG_AchievementCompleted(25)
			end
		elseif i == 2 then
			partT[data[1]]:ChangeExperience(15)
			fTab[i][3] = 2;
		elseif i == 3 then
			ChangeJustUnitExperience(partT[data[1]], data[1], 15)
			fTab[i][3] = 3;
		end
	end
	for i, iHuman in pairs(gT.Globals.HumanPlayers) do
		if Players[iHuman]:IsAlive() then
			if gT.Leagues[leagueID].Members[iHuman] then
				table.insert(gT.Players[iHuman].TheRaceInfoTable, {Type = "BasicRace", Title = gT.Leagues[leagueID].Resolutions[hString].Name, Help = GetProperResolutionHelp(44, gT.Leagues[leagueID].Resolutions[hString].ExtraInfo), OnlyOne = true, Players = fTab, SpecIcon = " DMG"})
			end
		end
	end
end

function KnowAnyoneInLeague(iPlayer, l)
	local lTeam = Teams[Players[iPlayer]:GetTeam()];
	for member, sth in pairs(gT.Leagues[l].Members) do
		if lTeam:IsHasMet(Players[member]:GetTeam()) then
			return true;
		end
	end
	return false;
end

function IsPlayerObligatedToReturnGWOnArchaeologicalDig(member, owner)
	if owner == -1 or owner == member then
		return false;
	end
	for league, data in pairs(gT.Leagues) do
		if data.Members[member] then
			if data.Resolutions[46] then
				return true;
			end
		end
	end
	return false;
end

function GetPlayerOpinionOnCommonProgressResolution(iPlayer, leagueID, optT)
	local bR = {}
	for a, h in pairs(optT or {1,2,3,4,5,6,7,8,9,10,11,12,13}) do
		local val = LastRandom(4, 6);
		--here calculations
		if h == 1 then
			val = val + GetAIFlavour(iPlayer, "FLAVOR_SCIENCE")
			if GetITGGameTurn() < 50 then
				val = val + 5;
			end
		elseif h == 2 then
			val = val + GetAIFlavour(iPlayer, "FLAVOR_MILITARY_TRAINING")
			if GetITGGameTurn() < 50 then
				val = val + 2;
			end
		elseif h == 3 then
			if gT.Players[iPlayer].Goverment == 1 then
				val = val + 1000;
			end
			val = val + LastRandom(3,5);
		elseif h == 4 then
			val = val + GetNumOfGPCivilOfType(iPlayer)
		elseif h == 5 then
			val = val + Players[iPlayer]:GetNumCities();
			val = val + GetAIFlavour(iPlayer, "FLAVOR_DEFENSE")
		elseif h == 6 then
			val = val + Players[iPlayer]:GetNumCities();
			val = val + GetAIFlavour(iPlayer, "FLAVOR_GOLD")
		elseif h == 7 then
			val = val + GetAIFlavour(iPlayer, "FLAVOR_DIPLOMACY")			
			if GetITGGameTurn() < 25 then
				val = val + 9;
			end
		elseif h == 8 then
			val = val + GetAIFlavour(iPlayer, "FLAVOR_PRODUCTION") + 2
		elseif h == 9 then
			val = val + GetAIFlavour(iPlayer, "FLAVOR_CULTURE") + 2
		elseif h == 10 then
			val = val + Players[iPlayer]:GetNumCities();
			val = val + GetAIFlavour(iPlayer, "FLAVOR_HAPPINESS")
		elseif h == 11 then
			if Players[iPlayer]:GetNumStrategicResourceAvailable(rOil) < 4 then
				if (not DBScenario.StrategicResourceLimit) or (DBScenario.StrategicResourceLimit > Players[iPlayer]:GetNumResourceTotal(rOil, true)) then
					val = val + 8;
				end
			end
			if Players[iPlayer]:GetNumStrategicResourceAvailable(rCoal) < 4 then
				if (not DBScenario.StrategicResourceLimit) or (DBScenario.StrategicResourceLimit > Players[iPlayer]:GetNumResourceTotal(rCoal, true)) then
					val = val + 3;
				end
			end
			if Players[iPlayer]:GetNumStrategicResourceAvailable(rUran) < 4 then
				if (not DBScenario.StrategicResourceLimit) or (DBScenario.StrategicResourceLimit > Players[iPlayer]:GetNumResourceTotal(rUran, true)) then
					val = val + 2;
				end
			end
		elseif h == 12 then
			if gT.Players[iPlayer].MeritocracyLevel > 0 then
				if gT.Players[iPlayer].MeritocracyLevel < 50 then
					val = val + math.ceil((50 - gT.Players[iPlayer].MeritocracyLevel)/ 5)
				end
			end
		elseif h == 13 then
			if Players[iPlayer]:GetNumUnitsOutOfSupply() > 1 then
				val = val + 5;
			end
		end
		val = math.max(val, 1);
		table.insert(bR, {h, val})
	end
	return bR;
end

function GetValidCSForIdeology60(iPlayer, leagueID)
	local iTeam = Players[iPlayer]:GetTeam();
	local t = {}
	for g, h in pairs(gT.Players) do
		if Players[g]:IsMinorCiv() then
			if Players[g]:GetNumCities() > 0 then
				if Teams[iTeam]:IsHasMet(Players[g]:GetTeam()) then
					if not Teams[iTeam]:IsAtWar(Players[g]:GetTeam()) then
						local idel = GetIdeologyLeagueOfPlayer(iPlayer);
						if (not idel) or (idel == leagueID) then
							table.insert(t, g)
						end
					end
				end
			end
		end
	end
	if #t > 0 then
		return t[LastRandom(1,#t)];
	end
	return nil;
end

function NoReasonToDoFMemberAnymore(badPlayer, sPlayer, league)
	if badPlayer == sPlayer then
		return false;
	end
	if Players[badPlayer]:IsMinorCiv() or Players[sPlayer]:IsMinorCiv() then
		return false;
	end
	if not Players[badPlayer]:IsDoF(sPlayer) then
		return false;
	end
	for uid, sth in pairs(gT.Leagues) do
		if (not sth.DoFindepedent) and (uid ~= league) then
			if sth.Members[badPlayer] and sth.Members[sPlayer] then
				return false;
			end
		end
	end
	return true;
end

function GetValidLeagueResolutionToInfluence(iPlayer, g)
	for league, sth in pairs(gT.Leagues) do
		if sth.Members[iPlayer] and sth.Members[g] then
			for h, hdata in pairs(sth.Proposals) do
				if (hdata.Delayed) and (hdata.Delayed > GetITGGameTurn() + 1) then
					if hdata.PlayersAnswers[iPlayer] == 3 then
						if (hdata.ProposedBy == g) and (hdata.ProposalStrength == 2) then
							return {league, h};
						end
					end
				end
			end
		end
	end
	return nil;
end