function GetLeagueProjectDataHelp(resID, iForcedPlayer, iType)
	local sTName = GetInfoFromTabOfProposal(resID, "Name")
	local sT = ""
	local iP = iForcedPlayer or Game.GetActivePlayer();
	for leg, s in pairs(gT.Leagues) do
		if s.Resolutions[resID] then -- it seems work only if resID?
			if s.Members[iP] then
				if s.Resolutions[resID].Finished then
					sT = sT .. " (COMPLETED)"
				elseif s.Resolutions[resID].Contributions[iP] then
					sT = sT .. " (" .. s.Resolutions[resID].Contributions[iP] .. "/" .. s.Resolutions[resID].TotalContribution;
					if s.Resolutions[resID].EndTurn then
						sT = sT .. "[ICON_PRODUCTION], " .. s.Resolutions[resID].EndTurn .. "T"
					else
						sT = sT .. "/" ..  DBScenario.LeagueProjectCost .. "[ICON_PRODUCTION]"
					end
					sT = sT .. ")"
					if iType == 2 then
						return {sTName, sT}
					elseif iType == 3 then
						return sTName .. sT .. "[NEWLINE][NEWLINE]" .. GetProperResolutionHelp(s.Resolutions[resID].ResID, s.Resolutions[resID].ExtraInfo)
					end
				end
			end
		end
	end
	return sTName .. sT;
end

function JustFinishDataProject(leagueID, resID, hString)
	gT.Leagues[leagueID].Resolutions[hString].Finished = true;
	gT.Leagues[leagueID].Resolutions[hString].Active = nil;
	gT.Leagues[leagueID].Resolutions[hString].Contributions = nil;
	gT.Leagues[leagueID].Resolutions[hString].TotalContribution = nil;
	for member, sth in pairs(gT.Leagues[leagueID].Members) do
		if not Players[member]:IsMinorCiv() then
			if gT.Players[member].LeagueProjects[resID] == 1 then
				gT.Players[member].LeagueProjects[resID] = nil;
			else
				gT.Players[member].LeagueProjects[resID] = gT.Players[member].LeagueProjects[resID] - 1;
			end
		end
	end
	if GetInfoFromTabOfProposal(resID, "Repetitive") then --Repeative?
		gT.Leagues[leagueID].Resolutions[hString] = nil;
	end
end

function DoContributionLeagueProject(resID, iP, boost)
	for leg, s in pairs(gT.Leagues) do
		if s.Resolutions[resID] then
			if s.Resolutions[resID].Contributions[iP] then
				gT.Leagues[leg].Resolutions[resID].TotalContribution = gT.Leagues[leg].Resolutions[resID].TotalContribution + boost;
				gT.Leagues[leg].Resolutions[resID].Contributions[iP] = s.Resolutions[resID].Contributions[iP] + boost;
				return;
			end
		end
	end
end

function GetTurnsLeftSinceLastProposal(leagueID, idR)
	local val = 0;
	if gT.Leagues[leagueID].ProposalsHistory[idR] then
		for i, data in pairs(gT.Leagues[leagueID].ProposalsHistory[idR]) do
			val = math.max(val, (data.ResolvedTurn or data.Turn) - GetITGGameTurn() + 10) 
		end
	end
	return val;
end

function CityStateFreeAIValueResolution(iPlayer, leagueID)
	local base = 0;
	for member, s in pairs(gT.Leagues[leagueID].Members) do
		if Players[member]:IsMinorCiv() and Players[member]:GetNumCities() > 0 then
			base = base + 25 - Players[member]:GetMinorCivFriendshipWithMajor(iPlayer);
			local gally = Players[member]:GetAlly();
			if gally ~= -1 then
				if gally ~= iPlayer then
					base = base + Players[member]:GetMinorCivFriendshipWithMajor(gally) / 5
				end
			end
		end
	end
	return math.max(math.min(100, base), 0)
end
function DoCityStatesFreeLeague(leagueID)
	for member, s in pairs(gT.Leagues[leagueID].Members) do
		if Players[member]:IsMinorCiv() then
		-- no bully, no influence with gold,
			ChangeBulliableCorruptableCS(member, 1, 1)
			if not gT.Players[member].FreeCityState then
				gT.Players[member].FreeCityState = {}
			end
		--all influence removed
			for g, h in pairs(gT.Players) do
				if not Players[g]:IsMinorCiv() then
					local inf = Players[member]:GetMinorCivFriendshipWithMajor(g)
					if inf > 0 then
						Players[member]:ChangeMinorCivFriendshipWithMajor(g, -inf)
					end
				end
			end
			--anchor with league
			for jmember, hhd in pairs(gT.Leagues[leagueID].Members) do
				if not Players[jmember]:IsMinorCiv() then
					Players[member]:ChangeMinorCivExtraAnchorWithMajor(jmember, 30)
					gT.Players[member].FreeCityState[jmember] = 30 + (gT.Players[member].FreeCityState[jmember] or 0)
				end
			end
		end
	end
end

function DoPantheonBeliefsHarmony(leagueID)
	local allPantheons = {}
	for member, sth in pairs(gT.Leagues[leagueID].Members) do
		if not Players[member]:IsMinorCiv() then
			if Players[member]:HasCreatedPantheon() then
				local pb = Game.GetBeliefsInReligion(0, member)
				for i, b in pairs(pb) do
					allPantheons[b] = 1;
				end
				if #pb < 5 then
					gT.Players[member].HarmonyPantheon = 5;
				end
			else
				gT.Players[member].HarmonyPantheon = 5;
			end
		end
	end
	gT.Leagues[leagueID].Pantheons = allPantheons;
end

function DoHelpShareTechLeague(leagueID)
	local tab = AllEraValidTechs()
	for tech, i in pairs(tab) do
		for member, sth in pairs(gT.Leagues[leagueID].Members) do
			if Teams[Players[member]:GetTeam()]:IsHasTech(tech) then
				tab[tech] = 2;
				break;
			end
		end
	end
	for member, sth in pairs(gT.Leagues[leagueID].Members) do
		local ll = {}
		for tech, i in pairs(tab) do
			if i == 2 then
				if not Teams[Players[member]:GetTeam()]:IsHasTech(tech) then
					table.insert(ll, tech);
				end
			end
		end
		if #ll > 0 then
			local ltech = ll[LastRandom(1,#ll)];
			PlayerDiscoverTech(member, ltech, nil, "hDT11")
		end
	end
end

function GetNumAIValueKnowledgeSharingLeague(iMember, leagueID)
	local tab = AllEraValidTechs();
	local hhh = {}
	for member, sth in pairs(gT.Leagues[leagueID].Members) do
		hhh[member] = 0;
		local pTeam = Teams[Players[member]:GetTeam()];
		for tech, i in pairs(tab) do
			if pTeam:IsHasTech(tech) then
				hhh[member] = hhh[member] + 1;
			end
		end
	end
	local ibet, iless, ival = 0, 0, hhh[iMember];
	for member, v in pairs(hhh) do
		if member ~= iMember then
			if v > ival then
				ibet = ibet + 1;
			else
				iless = iless + 1;
			end
		end
	end
	local baser = ibet * 25;
	if ibet > iless then
		baser = baser + ibet/iless * 20;
	else
		baser = baser - iless/ibet * 20;
	end
	return baser;
end

function GetAIValueForClosedTrade(iPlayer, leagueID)
	local base = 0;
	local nc = Players[iPlayer]:GetNumCities();
	if nc == 0 then
		return 0;
	end
	if nc == 1 then
		base = base + 25;
	end
	local b, t = 0, 0;
	for member, sth in pairs(gT.Leagues[leagueID].Members) do
		if member ~= iPlayer then
			if Players[member]:GetNumCities() > nc then
				b = b + 1;
			end
			t = t + 1;
		end
	end
	base = base + 80 * (t - b) / t;
	return base;
end

function ProjectAIValueResolution(iPlayer, leagueID)
	local tot = Players[iPlayer]:CalculateTotalYield(yProduction);
	local dif = 9999;
	for member, sth in pairs(gT.Leagues[leagueID].Members) do
		if member ~= iPlayer then
			if not Players[member]:IsMinorCiv() then
				dif = math.min(dif, tot - Players[member]:CalculateTotalYield(yProduction))
			end
		end
	end
	return 50 + dif / tot * 50;
end
function DoWeFromSciencePublic(iPlayer, leagueID)
	local base = Players[iPlayer]:GetTotalPopulation()
	local total, members = 0, 0;
	for member, tt in pairs(gT.Leagues[leagueID].Members) do
		members = members + 1;
		total = total +  Players[member]:GetTotalPopulation();
	end
	local avg = total / members;
	base = base + math.floor(30 * base / avg)
	return base
end
function DoWeWantBanMercenaries(iPlayer, leagueID)
	local base = -18 * gT.Players[iPlayer].NumMercTotal + 45 + GetITGGameTurn();
	return base;
end
function DoWeWantStabilization(iPlayer, leagueID)
	local base = 50;
	if gT.Players[iPlayer].Goverment == 1 then
		base = base - 50; -- we dont care anymore;
	end
	local cCity = Players[iPlayer]:GetCapitalCity();
	if cCity then
		local cID = cCity:Plot():GetPlotIndex() .. "," .. cCity:GetGameTurnFounded();
		base = base + GetGenerateUnhappinessChanceCity(cCity, iPlayer, cID, false, false) / 25;
	end
	return base;
end
function DoWeWantBalanceAcademies(iPlayer, leagueID)
	local base = 30;
	for i, aca in pairs(gT.Academies) do
		if aca.Player == iPlayer then
			if IsAboveAverageAcademyPrestigeRank(i) then
				base = base - 20;
			else
				base = base + 20;
			end
		end
	end
	return base;
end
function DoWeFromHealthInAllCities(iPlayer, leagueID)
	local numcities = Players[iPlayer]:GetNumCities()
	local total, members = 0, 0;
	for member, tt in pairs(gT.Leagues[leagueID].Members) do
		members = members + 1;
		total = total + Players[member]:GetNumCities();
	end
	local avg = total / members;
	local base = 0;
	if avg ~= 0 then
		base = math.floor(60 * numcities / avg) 
	end
	return base;
end
function LinkDoDenounceWarmongering(leagueID)
	for member, sth in pairs(gT.Leagues[leagueID].Members) do
		if not Players[member]:IsMinorCiv() then
			local cRed = GetNumOccupiedCities(member) * 25;
			local pRed = sth.DenounceWarmongerPenalty or 0;
			if cRed ~= pRed then
				for g, h in pairs(gT.Players) do
					if Players[g]:IsMinorCiv() then
						Players[g]:ChangeMinorCivDecayModWithMajor(member, cRed - pRed)
						Players[g]:ChangeMinorCivRecoveryModWithMajor(member, pRed - cRed)
					end
				end
				gT.Leagues[leagueID].Members[member].DenounceWarmongerPenalty = cRed;
			end
		end
	end
end
function LinkLeagueRemoveWarmongerDenounce(leagueID)
	for member, sth in pairs(gT.Leagues[leagueID].Members) do
		LinkedToDoRemoveWarmongerDenounceOnePlayer(member, leagueID)
	end
end
function DoWeDenounceWarmongers(iPlayer, leagueID)
	local base = -30 * GetNumOccupiedCities(iPlayer)
	for member, sth in pairs(gT.Leagues[leagueID].Members) do
		if member ~= iPlayer then
			if not Players[member]:IsMinorCiv() then
				base = base + 5 * GetNumOccupiedCities(member)
			end
		end
	end
	return base + LastRandom(-5, 5)
end
function LinkedToDoRemoveWarmongerDenounceOnePlayer(bPlayer, leagueID)
	if (gT.Leagues[leagueID].Members[bPlayer].DenounceWarmongerPenalty or 0) ~= 0 then
		for g, h in pairs(gT.Players) do
			if Players[g]:IsMinorCiv() then
				Players[g]:ChangeMinorCivDecayModWithMajor(bPlayer, -gT.Leagues[leagueID].Members[bPlayer].DenounceWarmongerPenalty)
				Players[g]:ChangeMinorCivRecoveryModWithMajor(bPlayer, gT.Leagues[leagueID].Members[bPlayer].DenounceWarmongerPenalty)
			end
		end
		gT.Leagues[leagueID].Members[bPlayer].DenounceWarmongerPenalty = nil;
	end
end
function GetWarmongerLeagueEffect(iMajor)
	local t = 0;
	for leagueID, sth in pairs(gT.Leagues) do
		if sth.Members[iMajor] then
			t = t + (sth.Members[iMajor].DenounceWarmongerPenalty or 0)
		end
	end
	return t;
end
function DoWeBenefitFromDemilitarization(iPlayer, leagueID)
	local sp = Players[iPlayer]:GetNumUnitsSupplied() - Players[iPlayer]:GetNumUnitsToSupply()
	if gT.Leagues[leagueID].Resolutions[48] then
		sp = sp + 7;
	end
	local eval = math.min(90,20 + sp * 5);
	return math.max(10, eval) + LastRandom(-5, 5);
end
function LinkDoSupportIdeology(leagueID, extraInfo)
	gT.Leagues[leagueID].SupportedIdeology = extraInfo;
end
function LinkDoForcePeace(leagueID, extraInfo1)
	local playerone = gT.Leagues[leagueID].EndWarTable[extraInfo1][1];
	local playertwo = gT.Leagues[leagueID].EndWarTable[extraInfo1][2]
	local team1 = Players[playerone]:GetTeam()
	local team2 = Players[playertwo]:GetTeam()
	if gT.Players[playerone].IsConsideredBarbarian or gT.Players[playertwo].IsConsideredBarbarian then
		return;
	end
	if Teams[team1]:IsAtWar(team2) then
		Teams[team1]:MakePeace(team2);
		DoAddCounterTimePeaceLock(playerone, playertwo, 10, "ForceLeaguePeace")
	end
end
function DoWeCareAboutForcingPeace(iPlayer, leagueID, extrainfo1)
	local playerone = gT.Leagues[leagueID].EndWarTable[extrainfo1][1]
	local playertwo = gT.Leagues[leagueID].EndWarTable[extrainfo1][2]
	local militone = ToPLeagueMilitaryMight(playerone)
	local milittwo = ToPLeagueMilitaryMight(playertwo)
	if milittwo == 0 then
		milittwo = 1;
	end
	if militone == 0 then
		militone = 1;
	end
	if playerone == iPlayer then
		return math.floor(50 * milittwo/militone)
	elseif playertwo == iPlayer then
		return math.floor(50 * militone/milittwo)
	else
		return -50 + math.max(math.floor(40 * militone/milittwo), math.floor(40 * milittwo/militone))
	end
end
function LinkDoDemilitiarization(leagueID)
	for member, sth in pairs(gT.Leagues[leagueID].Members) do
		ChangeExtraSupply(member, LEAGUE_SUPPLY_DEMILITARIZATION)
	end
end
function LinkDoGlobalization(leagueID)
	local lTab = {}
	for member, tt in pairs(gT.Leagues[leagueID].Members) do
		table.insert(lTab, member)
	end
	local lPlayer = lTab[LastRandom(1,#lTab)]
	for member, tt in pairs(gT.Leagues[leagueID].Members) do
		if lPlayer ~= member then
			AddCulturalPresenceInAllCities(lPlayer, member, 5, true)
		end
	end
end 
function LinkDoSolvePoority(leagueID)
	local total, members = 0, 0
	local membertab = {}
	local totalprovided = 0;
	for member, tt in pairs(gT.Leagues[leagueID].Members) do
		local g = gT.Players[member].PrevTurnGPT;
		membertab[member] = g;
		members = members + 1;
		total = total + g;
	end
	local avg = math.floor(total / members)
	for member, tt in pairs(gT.Leagues[leagueID].Members) do
		if membertab[member] > avg then
			local cgoldprovided = tt.SolvePoorityGold or 0;
			local goldtoprovide = math.min(0, math.max(-25, -1 * membertab[member]))
			if cgoldprovided ~= goldtoprovide then
				gT.Leagues[leagueID].Members[member].SolvePoorityGold = goldtoprovide
				gT.Players[member].SolvePoorityGold = gT.Players[member].SolvePoorityGold + goldtoprovide - cgoldprovided
				gT.Players[member].SolvePoorityProduction = math.min(0, math.floor(gT.Players[member].SolvePoorityGold / 2)) 
			end
			members = members - 1;
			totalprovided = totalprovided - goldtoprovide;
		end
	end
	for member, tt in pairs(gT.Leagues[leagueID].Members) do
		if membertab[member] <= avg then
			local cgoldprovided = tt.SolvePoorityGold or 0;
			local goldtoprovide = math.floor(totalprovided / members)
			if cgoldprovided ~= goldtoprovide then
				gT.Leagues[leagueID].Members[member].SolvePoorityGold = goldtoprovide
				gT.Players[member].SolvePoorityGold = gT.Players[member].SolvePoorityGold + goldtoprovide - cgoldprovided
				gT.Players[member].SolvePoorityProduction = math.min(0, math.floor(gT.Players[member].SolvePoorityGold / 2)) 
			end
		end
	end
	for member, tt in pairs(gT.Leagues[leagueID].Members) do
		DoUpdateSolvePoorityProdMod(member)
	end
end
function LinkLeagueRemoveDemilitarization(leagueID)
	for member, sth in pairs(gT.Leagues[leagueID].Members) do
		ChangeExtraSupply(member, -LEAGUE_SUPPLY_DEMILITARIZATION)
	end
end
function LinkLeagueRemoveSolvingPoverty(leagueID)
	for member, sth in pairs(gT.Leagues[leagueID].Members) do
		LinkedToPDoRemoveCostPovert(member, leagueID)
	end
end
function LinkedToPDoDemilitarization(bPlayer, leagueID)
	ChangeExtraSupply(bPlayer, -LEAGUE_SUPPLY_DEMILITARIZATION)
end
function LinkedToPDoRemoveCostPovert(bPlayer, leagueID)
	gT.Players[bPlayer].SolvePoorityGold = gT.Players[bPlayer].SolvePoorityGold - (gT.Leagues[leagueID].Members[bPlayer].SolvePoorityGold or 0)
	gT.Players[bPlayer].SolvePoorityProduction = math.min(0, math.floor(gT.Players[bPlayer].SolvePoorityGold / 2)) 
	DoUpdateSolvePoorityProdMod(bPlayer)
end
function DoUpdateSolvePoorityProdMod(iPlayer)
	for iCity in Players[iPlayer]:Cities() do
		SetBasicCityYieldRate(iCity, yProduction, gT.Players[iPlayer].SolvePoorityProduction, "CI_POVERTY_PROD")
	end
end
function LinkToPShareMapsInLeague(leagueID, idR)
	if (GetITGGameTurn() - gT.Leagues[leagueID].Resolutions[idR].EnactedTurn) % 5 ~= 0 then
		return;
	end
	local unKnown = {}
	local numUnknown = {}
	local minK = 0;
	for jMember, sth in pairs(gT.Leagues[leagueID].Members) do
		if not Players[jMember]:IsMinorCiv() then
			gT.Leagues[leagueID].Members[jMember].VotesFromResolution["Map Exchange"] = 0;
			unKnown[jMember] = GetTheUnknownTerritoryOfPlayer(jMember)
			numUnknown[jMember] = #ReverseIntoIterable(unKnown[jMember])
			minK = math.max(minK, numUnknown[jMember])
		end
	end
	local evalForVotes = {};
	for member, data in pairs(unKnown) do
		local jTeam = Players[member]:GetTeam();
		table.insert(evalForVotes, {member, minK - numUnknown[member]}) -- the less unknown the better value
		local toAdd = 50;
		local validPlotsToDiscover = {}
		for index, it in pairs(data) do
			local bGood = false;
			for bMember, bData in pairs(unKnown) do
				if not bData[index] then
					bGood = true;
					table.insert(validPlotsToDiscover, index)
					break;
				end
			end
		end
		if #validPlotsToDiscover <= toAdd then
			for jjk, index in pairs(validPlotsToDiscover) do
				Map.GetPlotByIndex(index):SetRevealed(jTeam, true)
			end
		else
			local tBdiscovered = ReverseTable(validPlotsToDiscover)
			validPlotsToDiscover = Shuffle(validPlotsToDiscover)
			for i, v in pairs(validPlotsToDiscover) do
				if toAdd > 0 then
					if tBdiscovered[v] then
						local letsRoll = {}
						table.insert(letsRoll, v);
						while #letsRoll > 0 and (toAdd > 0) do
							local lIndex = letsRoll[1]
							table.remove(letsRoll, 1)
							tBdiscovered[lIndex] = nil;
							local tPlot = Map.GetPlotByIndex(lIndex)
							tPlot:SetRevealed(jTeam, true)
							toAdd = toAdd - 1;
							for jit = 0, 5 do
								local jitPlot = Map.PlotDirection(tPlot:GetX(), tPlot:GetY(), jit);
								if jitPlot and tBdiscovered[jitPlot:GetPlotIndex()] then
									table.insert(letsRoll, jitPlot:GetPlotIndex())
								end 
							end
						end
					end
				else
					break;
				end
			end
		end
		DoDeferredFog(Players[member]:GetTeam())
	end
	if #evalForVotes > 1 then
		table.sort(evalForVotes, SortFunctionForGreaterInteger2);
		local bestScore = evalForVotes[1][2];
		if bestScore ~= 0 then
			if evalForVotes[2][2] ~= bestScore then
				if bestScore - evalForVotes[2][2] <= 20 then
					local cCount = 0;
					for a, b in pairs(evalForVotes) do
						if b[2] == evalForVotes[2][2] then
							cCount = cCount + 1;
						end
					end
					if cCount == 1 then
						if bestScore - evalForVotes[2][2] <= 5 then
							gT.Leagues[leagueID].Members[evalForVotes[1][1]].VotesFromResolution["Map Exchange"] = 3;
							gT.Leagues[leagueID].Members[evalForVotes[2][1]].VotesFromResolution["Map Exchange"] = 2;
						else
							gT.Leagues[leagueID].Members[evalForVotes[1][1]].VotesFromResolution["Map Exchange"] = 4;
							gT.Leagues[leagueID].Members[evalForVotes[2][1]].VotesFromResolution["Map Exchange"] = 1;
						end
					elseif cCount == 2 then
						gT.Leagues[leagueID].Members[evalForVotes[1][1]].VotesFromResolution["Map Exchange"] = 3;
						gT.Leagues[leagueID].Members[evalForVotes[2][1]].VotesFromResolution["Map Exchange"] = 1;
						gT.Leagues[leagueID].Members[evalForVotes[3][1]].VotesFromResolution["Map Exchange"] = 1;
					else
						gT.Leagues[leagueID].Members[evalForVotes[1][1]].VotesFromResolution["Map Exchange"] = 3;
					end
				else
					gT.Leagues[leagueID].Members[evalForVotes[1][1]].VotesFromResolution["Map Exchange"] = 5;
				end
			else
				local cCount = 0;
				for a, b in pairs(evalForVotes) do
					if b[2] == bestScore then
						cCount = cCount + 1;
					end
				end
				local iVotes = 0;
				if cCount == 2 then
					iVotes = 2;
				elseif cCount < 6 then
					iVotes = 1
				end
				if iVotes > 0 then
					for a, b in pairs(evalForVotes) do
						if b[2] == bestScore then
							gT.Leagues[leagueID].Members[b[1]].VotesFromResolution["Map Exchange"] = iVotes;
						end
					end
				end
			end
		end
	end
end
function LinkToPLeagueShareXP(leagueID, idR)
	local classXP = {}
	local tTab = {}
	for jMember, sth in pairs(gT.Leagues[leagueID].Members) do
		tTab[jMember] = 0;
	end
	for jMember, sth in pairs(gT.Leagues[leagueID].Members) do
		classXP[jMember] = {}
		for class, xp in pairs(gT.Players[jMember].UnitClassXP) do
			local boom = 0;
			for bMember, sth in pairs(gT.Leagues[leagueID].Members) do
				if bMember ~= jMember then
					if gT.Players[bMember].UnitClassXP[class] then
						if gT.Players[bMember].UnitClassXP[class] > xp then
							boom = boom + 1;
							tTab[bMember] = tTab[bMember] + 1;
						end
					end
				end
			end
			if boom > 0 then
				classXP[jMember][class] = boom;
			end
		end
	end
	for member, classboosts in pairs(classXP) do
		for iClass, boost in pairs(classboosts) do
			gT.Players[member].UnitClassXP[iClass] = gT.Players[member].UnitClassXP[iClass] + boost;
		end
	end
	for member, val in pairs(tTab) do
		gT.Leagues[leagueID].Members[member].HelpPoints[idR] = val;
	end
end
function LinkGetAIValueResolution3(iPlayer, leagueID, extrainfo1, bRenact, resID)
	local balance = 50;
	local theirMP = ToPLeagueMilitaryMight(iPlayer)
	local bestother = 0;
	local nm = -2;
	for member, sth in pairs(gT.Leagues[leagueID].Members) do
		if not Players[member]:IsMinorCiv() then
			nm = nm + 1;
			if member ~= iPlayer then
				if bestother < ToPLeagueMilitaryMight(member) then
					bestother = ToPLeagueMilitaryMight(member)
				end
			end
		end
	end
	balance = balance + 3 * nm;
	if bestother > theirMP then
		if theirMP == 0 then
			balance = balance + 100;
		elseif (theirMP/ bestother) > 90 then
			balance = balance - 50;
		elseif (theirMP/ bestother) < 50 then
			balance = balance + LastRandom(20, 40);
		elseif (theirMP/ bestother) > 70 then
			balance = balance - math.floor((theirMP/ bestother) * 100 - 80)
		end
	end
	local numwars = Teams[Players[iPlayer]:GetTeam()]:GetAtWarCount(true)
	balance = balance - 7 + 7 * numwars;
	local leftturns = 0
	local leftcities = Players[iPlayer]:GetNumCities();
	if leftcities < 4 then
		balance = balance + 20 - leftcities * 5;
	end
	return balance + LastRandom(-5, 5)
end
function DoTriggerTotalWarBetween(mTeam, pTeam, mPlayer, pPlayer)
	if not Teams[mTeam]:IsHasMet(pTeam) then
		Teams[mTeam]:Meet(pTeam)
	end
	if not Teams[mTeam]:IsAtWar(pTeam) then
		Teams[mTeam]:DeclareScriptedWar(pTeam);
	end
	ChangePeaceWarLock(mPlayer, pPlayer, 1, "TotalWar")
end
function DoDeclareTotalWarLeague(leagueID, enemy)
	local tab = {}
	local tRemovePlayers = {}
	local bPlayerRemoved = false;
	if gT.Leagues[enemy] then
		for member, sth in pairs(gT.Leagues[enemy].Members) do
			table.insert(tab, member)
		end
	else
		table.insert(tab, enemy)
		if Players[enemy]:IsHuman() then
			if gT.Leagues[leagueID].SpecialTag == "LoN" then
				LuaEvents.ITG_AchievementCompleted(127)
			end
		end
	end
	for i, ePlayer in pairs(tab) do
		if gT.Leagues[leagueID].Members[ePlayer] then
			if not gT.Leagues[leagueID].ToRemoveDelay then
				gT.Leagues[leagueID].ToRemoveDelay = {}
			end
			bPlayerRemoved = true;
			table.insert(gT.Leagues[leagueID].ToRemoveDelay, ePlayer);
			tRemovePlayers[ePlayer] = true;
		end
	end
	--first remove any dof with enemy (really silly defensive pacts otherwise)
	for member, sth in pairs(gT.Leagues[leagueID].Members) do
		if not tRemovePlayers[member] then
			if Players[member]:IsMinorCiv() then
				for i, pEnemy in pairs(tab) do
					if not Players[pEnemy]:IsMinorCiv() then
						local inf = Players[member]:GetMinorCivFriendshipWithMajor(pEnemy);
						if inf > 0 then
							Players[member]:ChangeMinorCivFriendshipWithMajor(pEnemy, -inf)
						end
					end
				end
			else
				for i, pEnemy in pairs(tab) do
					if not Players[pEnemy]:IsMinorCiv() then
						if Players[member]:IsDoF(pEnemy) then
							RemoveBadPlayerLeague(member, pEnemy, "TotalWar")
							Players[member]:DoEndDoF(pEnemy, false)
						end
					end
				end
			end
		end
	end
	for member, sth in pairs(gT.Leagues[leagueID].Members) do
		if not tRemovePlayers[member] then
			local mTeam = Players[member]:GetTeam();
			for i, pEnemy in pairs(tab) do
				DoTriggerTotalWarBetween(mTeam, Players[pEnemy]:GetTeam(), member, pEnemy)
			end
		end
	end
	if bPlayerRemoved then
		for hs, sth in pairs(gT.Leagues[leagueID].Proposals) do
			if sth.ResolutionID == 58 then -- force peace will be no longer valid // those resolutions will not be solved
				local tmpeinfo = sth.ExtraInfo;
				if tRemovePlayers[tmpeinfo] or tRemovePlayers[tmpeinfo] then
					gT.Leagues[leagueID].Proposals[hs] = nil;
				end
			end
		end
	end
	for i, pEnemy in pairs(tab) do
		if Players[pEnemy]:IsHuman() then
			Players[pEnemy]:AddNotification(94343293, gT.Leagues[leagueID].Name .. " declared a Total War on us! There will be no Peace.", "Total War!", -1, -1, 30)
		end
	end
	HnGLogWorldWarEvents({Type = "TW", League = leagueID, OtherLeague = enemy})
	DoTriggerDominationMode();
end
function TotaWarAIValueResolution(iPlayer, leagueID,extrainfo1,bRenact)
	local tab= {}
	if gT.Leagues[extrainfo1] then
		for member, sth in pairs(gT.Leagues[extrainfo1].Members) do
			if member == iPlayer then
				return 0;
			end
			table.insert(tab, member)
		end
	else
		if extrainfo1 == iPlayer then
			return 0;
		end
		table.insert(tab, extrainfo1)
	end
	local val = 0;
	for i, v in pairs(tab) do
		if Players[v]:IsMinorCiv() then
			if Players[v]:GetAlly() == iPlayer then
				return 0; --cs are not gonna be in 5th scenario leagues before world war
			end
		elseif Players[v]:IsDoF(iPlayer) then
			if gT.Globals.ScenarioType == 5 then
				val = val - 33;
			else
				return 0;
			end
		end
		for iCity in Players[v]:Cities() do
			if iCity:GetOriginalOwner() == iPlayer then
				val = val + 4;
			end
		end
	end
	local pteam = Teams[Players[iPlayer]:GetTeam()]
	local pPlot = Players[iPlayer]:GetStartingPlot();
	for i, p in pairs(tab) do
		local ival = 100;
		local iteam = Players[p]:GetTeam();
		if pteam:IsHasMet(iteam) then
			if not pteam:IsAtWar(iteam) then
				ival = ival - 20;
				local numcities, lowestdis = 0, 999
				for iCity in Players[p]:Cities() do
					if iCity:Plot():IsRevealed(pteam:GetID()) then
						numcities = numcities + 1;
						lowestdis = math.min(lowestdis, Map.PlotDistance(pPlot:GetX(), pPlot:GetY(), iCity:GetX(), iCity:GetY()))
					end
				end
				ival = ival - 10 * numcities;
				if lowestdis < 8 then
					ival = 0;
				elseif lowestdis < 15 then
					ival = ival - 20;
				elseif lowestdis < 25 then
					ival = ival - 10;
				end
			end
		end
		val = val + ival;
	end
	return math.max(0, val /#tab);
end
function DoWeBenefitFromSolvingPoority(iPlayer, leagueID)
	local base = 5;
	local gpt = gT.Players[iPlayer].PrevTurnGPT;
	if gpt > 50 then
		base = base + 4 * GetInflationFromValue(gpt - 50, 100, 1)
	end
	return base + LastRandom(-5, 5);
end

function ArchaeologicalGrantAIValueResolution(iPlayer, leagueID)
	local base = 40;
	local archpointsperturn = GetArchaeologyPointsPerTurn(iPlayer, true)
	local total = GetTotalArchaeologyGlobal()
	local stored = gT.CurrentArchaelogyData.Players[iPlayer];
	if total ~= 0 then
		if stored / total > 0.33 then
			base = base - 30;
		end
		if stored > archpointsperturn * 6 then
			base = base + 30;
		end
		base = base + 10 - archpointsperturn
	else
		base = base + 20 - archpointsperturn
	end
	local iTeam = Players[iPlayer]:GetTeam();
	for index, sth in pairs(gT.ArchaeologyPlots) do
		if sth ~= -1 then
			if Map.GetPlotByIndex(index):IsRevealed(iTeam) then
				if not sth.PlayerDelays[iPlayer] then
					if Map.GetPlotByIndex(index):GetOwner() == iPlayer then
						base = base + 15;
					else
						base = base - 5;
					end
				end
			end
		end
	end
	return base + LastRandom(-5, 5);
end

function OlympicGamesAIValueResolution(iPlayer, leagueID)
	if Players[iPlayer]:IsMinorCiv() then
		return LastRandom(20,80)
	end
	local base = 40;
	local tS = GetMilitaryMightDemographics(iPlayer, iPlayer, false)
	local tavg, tvotes, tt = 0, 0, 0;
	for member, sth in pairs(gT.Leagues[leagueID].Members) do
		tavg = tavg + GetMilitaryMightDemographics(iPlayer, member,  false)
		tt = tt + 1;
		tvotes = math.max(tvotes, sth.Votes); 
	end
	tavg = tavg / tt;
	if tavg > tS then
		base = base + 30;
	else
		base = base - 10;
	end
	if gT.Leagues[leagueID].Members[iPlayer].Votes == tvotes then
		base = base - 50;
	else
		base = base + 20;
	end
	return base + LastRandom(-5, 5);
end

function DoBeginOlympiada(leagueID)
	local iTurn = GetITGGameTurn() + 1;
	local season = GetSeasonFromTurn(iTurn)
	local nOlympiad = iTurn + (5 - season) % 4 + 1
	gT.Globals.OlympicGames = {OnGoing = false, Next = nOlympiad, Players = {}, League = leagueID}
	for member, sth in pairs(gT.Leagues[leagueID].Members) do
		gT.Globals.OlympicGames.Players[member] = 1;
	end
end

function DoTurnOlympics()
	if gT.Globals.OlympicGames then
		local iTurn = GetITGGameTurn() + 1;
		if gT.Globals.OlympicGames.OnGoing then
			gT.Globals.OlympicGames.OnGoing = false;
			gT.Globals.OlympicGames.Next = iTurn + 15;
			DoOlympicContest()
		elseif gT.Globals.OlympicGames.Next == iTurn then
			gT.Globals.OlympicGames.ScriptWar = {}
			gT.Globals.OlympicGames.OnGoing = true;
			for player, sth in pairs(gT.Globals.OlympicGames.Players) do
				if Players[player]:IsAlive() then
					if not gT.Players[player].IsConsideredBarbarian then
						local iTeam = Players[player]:GetTeam();
						for jplayer, jsth in pairs(gT.Globals.OlympicGames.Players) do
							if Players[jplayer]:IsAlive() then
								if not gT.Players[jplayer].IsConsideredBarbarian then
									local jTeam = Players[jplayer]:GetTeam();
									if iTeam ~= jTeam then
										ChangePeaceWarLock(jplayer, player, 1, "Olympics")
										if Teams[iTeam]:IsAtWar(jTeam) then
											table.insert(gT.Globals.OlympicGames.ScriptWar, {player, jplayer})
											Teams[iTeam]:MakePeace(jTeam);
										end
									end
								end
							end	
						end
					end
				end
			end
			for ji, iHuman in pairs(gT.Globals.HumanPlayers) do
				if gT.Globals.OlympicGames.Players[iHuman] then
					Players[iHuman]:AddNotification(94343293, "We have entered the Olympic Truce, all conflicts are temporary put to the background why our athlets compete for glory.", "Olympic Truce", -1, -1, 14)
				end
			end
		end
	end
end

function DoOlympicContest()
	local hTab ={}
	local might = {}
	local unity = {}
	for player, sth in pairs(gT.Globals.OlympicGames.Players) do
		if Players[player]:IsAlive() then
			table.insert(might, {player, Players[player]:GetMilitaryMight()})
			table.insert(unity, {player, gT.Players[player].NatUnity or 0})
		end
	end
	table.sort(might, SortFunctionForGreaterInteger2);
	table.sort(unity, SortFunctionForGreaterInteger2);
	local pBonusFromMight = {}
	local pBonusFromUnity = {}
	for i, h in pairs(might) do
		pBonusFromMight[h[1]] = #might + 1 - i;
		pBonusFromUnity[unity[i][1]] = #might + 1 - i;
	end
	for player, sth in pairs(gT.Globals.OlympicGames.Players) do
		if Players[player]:IsAlive() then
			table.insert(hTab, {player, GetValueForRandomOlympics(player) + pBonusFromMight[player] + pBonusFromUnity[player]})
		end
	end
	if #hTab > 0 then
		local lWinner = GetRandomFromBiasedChanceTable(hTab)
		AddExtraVotesScriptedLeague(lWinner, gT.Globals.OlympicGames.League, "Olympic Games", 3)

		for ji, iHuman in pairs(gT.Globals.HumanPlayers) do
			if gT.Globals.OlympicGames.Players[iHuman] then
				if iHuman == lWinner then
					Players[iHuman]:AddNotification(94343293, "Our heroes outshined rivals during the Olympic Games (+3 [ICON_ITG_VOTES] Votes). No glory for loosers!", "Olympic Victory", -1, -1, 14)
				else
					Players[iHuman]:AddNotification(94343293, Players[lWinner]:GetCivilizationAdjective() .. " representants were undefeated during this Olympic Games. To participate is the greatest prize, I guess.", "Olympic Games" ,-1, -1, 14)
				end
			end
		end
	end
	for player, sth in pairs(gT.Globals.OlympicGames.Players) do
		for jplayer, jsth in pairs(gT.Globals.OlympicGames.Players) do
			if player ~= jplayer then
				ChangePeaceWarLock(jplayer, player, -1, "Olympics")
			end
		end
	end
	for i, v in pairs(gT.Globals.OlympicGames.ScriptWar) do
		if (not Players[v[1]]:IsMinorCiv()) and (not Players[v[2]]:IsMinorCiv()) then
			DeclareWarInInceOrder(v[1], v[2])
		end
	end
	for player, sth in pairs(gT.Globals.OlympicGames.Players) do
		if Players[player]:IsMinorCiv() then
			local gPlayer = Players[player]:GetAlly();
			if gPlayer ~= -1 then
				for jplayer, jsth in pairs(gT.Globals.OlympicGames.Players) do
					if Teams[Players[gPlayer]:GetTeam()]:IsAtWar(Players[jplayer]:GetTeam()) then
						if not Teams[Players[player]:GetTeam()]:IsAtWar(Players[jplayer]:GetTeam()) then
							DeclareWarInInceOrder(player, jplayer)
						end
					end
				end
			end
		end
	end
end

function DeclareWarInInceOrder(v1, v2)
	if Players[v1]:IsMinorCiv() then
		Teams[Players[v2]:GetTeam()]:DeclareScriptedWar(Players[v1]:GetTeam());
	elseif Players[v2]:IsMinorCiv() then
		Teams[Players[v1]:GetTeam()]:DeclareScriptedWar(Players[v2]:GetTeam());
	else
		local hb1, hb2 = -1, -1;
		for jtt, hpdata in pairs(gT.Players[v1].NumWarsDeclaredOn) do
			if hpdata[1] == v2 then
				hb2 = hpdata[2];
			end
		end
		for jtt, hpdata in pairs(gT.Players[v2].NumWarsDeclaredOn) do
			if hpdata[1] == v1 then
				hb1 = hpdata[2];
			end
		end
		if hb2 > hb1 then
			Teams[Players[v2]:GetTeam()]:DeclareScriptedWar(Players[v1]:GetTeam());
		else
			Teams[Players[v1]:GetTeam()]:DeclareScriptedWar(Players[v2]:GetTeam());
		end
	end
end

function GetValueForRandomOlympics(iPlayer)
	local base = 10;
	local iHealth = 0;
	local iDecadentism = 5- gT.Players[iPlayer].Decadentism;
	if Players[iPlayer]:GetNumCities() > 0 then
		for iCity in Players[iPlayer]:Cities() do
			local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
			iHealth = iHealth + gT.Cities[cID].HealthLevel;
		end
		iHealth = iHealth / Players[iPlayer]:GetNumCities();
	end
	return math.max(1, math.ceil(base + iHealth + iDecadentism))
end

function LeagueTournamentAIValue(iPlayer, leagueID, iclass)
	local base = 0;
	for iUnit in Players[iPlayer]:Units() do
		if iUnit:GetUnitClassType() == iclass then
			base = base + 5 + 5 * GetTournamentStrengthOfUnit(iUnit, iclass, iPlayer)
		end
	end
	return base;
end

function GetTournamentStrengthOfUnit(iUnit, iclass, iPlayer)
	local hpmod = 1 - iUnit:GetDamage() / iUnit:GetMaxHitPoints()
	local base = iUnit:GetLevel();
	if IsGreatGeneralAdmiral(iUnit, "AdmiralName") or IsGreatGeneralAdmiral(iUnit, "GeneralName") then
		base = base + 3;
	elseif iUnit:IsMercenary() then
		base = base + 1;
	end
	for promID, sth in pairs(gT.Players[iPlayer].UnitClassPromotions[iclass] or {}) do
		base = base + 1;
	end
	return math.floor(base + 0.5 * hpmod)
end

function PrepareSpecialProjectSeeker(leagueID, resID, hString)
	gT.Leagues[leagueID].Resolutions[hString].Active = true;
	gT.Leagues[leagueID].Resolutions[hString].TasksDone = {}
	gT.Leagues[leagueID].Resolutions[hString].TaskCompleted = 0;
	gT.Leagues[leagueID].Resolutions[hString].TaskUsed = {};
	for member, sth in pairs(gT.Leagues[leagueID].Members) do
		gT.Leagues[leagueID].Resolutions[hString].TasksDone[member] = 0;
	end
	PrepareSeekerTask(leagueID, resID, hString)
end

function STSAN1(id) return id; end
local stdicetab = {"[NEWLINE]Time to loss the dice.", "[NEWLINE]Have you ever presented me a two-sided dice? What about a dime?", "[NEWLINE]Three? I already have three legs.", "[NEWLINE]I was being chased by four wolves earlier today. Four it is.", "[NEWLINE]Why nobody ever aims for five?", "[NEWLINE]One who doesn't throw a dice can never except to score six."}
function STSAH1(id)
	return stdicetab[id]
end
function STSCT1(answ)
	return "You have correctly foresee that dice will stop at " .. answ .. "."
end
function STSIT1(answ, incansw)
	return "It seems that folks misheard your " .. answ .. " as " .. incansw .. ". After all you knew it was " .. answ .. ", didn't you?";
end
function STSCD2(leagueID)
	if gT.Globals.PlaguesOutbreaks[GetITGGameTurn() + 1] then
		return false;
	end
	return #STSAF2(leagueID) > 2;
end
function STSCD5(leagueID)
	return #STSAF2(leagueID) > 2;
end
function STSAF2(leagueID)
	local tab = {}
	for member, sth in pairs(gT.Leagues[leagueID].Members) do
		local cc = Players[member]:GetCapitalCity();
		if cc then
			table.insert(tab, cc:Plot():GetPlotIndex())
		end
	end
	return tab;
end
function STSAN2(id)
	return Map.GetPlotByIndex(id):GetPlotCity():GetName();
end
function STSAH2(id)
	return "[NEWLINE]You foresee that new Epidemy will start in this city."
end
function STSCT2(answ)
	return "It is a great burden to know what will happen and be unable to prevent it. The citizens of " .. STSAN2(answ) .. " are suffering just as you foresee."
end
function STSIT2(answ, inc)
	return "Well, you were probably ill and you mistook " .. STSAN2(answ) .. " with " .. STSAN2(inc) .. ".";
end
function STSOF2(id, leagueID)
	StartWeakPlagueInCity(Map.GetPlotByIndex(id):GetPlotCity())
end
function STSCD3(leagueID)
	return #GetTabOfValidTargetsSTS3(leagueID) > 0 
end
function GetTabOfValidTargetsSTS3(leagueID)
	local tab = {}
	for g, gd in pairs(gT.Players) do
		if Players[g]:IsMinorCiv() and Players[g]:GetNumCities() > 0 then
			local bc = true;
			for member, sth in pairs(gT.Leagues[leagueID].Members) do
				if Teams[Players[member]:GetTeam()]:IsHasMet(Players[g]:GetTeam()) then
					bc = false;
					break;
				end
			end
			if bc then
				table.insert(tab, g)
			end
		end
	end
	return tab;
end
function STSAF3(leagueID)
	local tab = GetTabOfValidTargetsSTS3(leagueID);
	local luckyCiv = tab[LastRandom(1,#tab)];
	local unMet = {}
	local tType = Players[luckyCiv]:GetMinorCivType();
	for i,v in pairs(tab) do
		unMet[v] = i;
	end
	local bCC = {}
	bCC[tType] = 1;
	for g, h in pairs(gT.Players) do
		if Players[g]:IsMinorCiv() and (not unMet[g]) then
			bCC[Players[g]:GetMinorCivType()] = 1;
		end
	end
	local hBB = {}
	for row in GameInfo.MinorCivilizations() do
		if not bCC[row.ID] then
			table.insert(hBB, row.ID)
		end
	end
	hBB = Shuffle(hBB);
	local fAnswers = {}
	for i, v in pairs(hBB) do
		if i < 5 then
			table.insert(fAnswers, v)
		else
			break;
		end
	end
	table.insert(fAnswers, tType)
	fAnswers = Shuffle(fAnswers);
	return fAnswers, tType;
end
function STSAN3(id)
	return Locale.Lookup(GameInfo.MinorCivilizations[id].Description);
end
function STSAHBlank(id)
	return ""
end
function STSCT3(answ)
	return "Ha! If your eyes can see the existence of " .. STSAN3(answ) .. " then you surely deserve to be the next Oracle!"
end
function STSIT3(answ, inc)
	return "What kind of silly name is " .. STSAN3(answ) .. "? They should be called " .. STSAN3(inc) .. " in our common language!"
end
function STSOF3(id, leagueID)
	local tt
	for g, gt in pairs(gT.Players) do
		if Players[g]:IsMinorCiv() then
			if Players[g]:GetMinorCivType() == id then
				tt = Players[g]:GetTeam();
				break;
			end
		end
	end
	if tt then
		for member, sth in pairs(gT.Leagues[leagueID].Members) do
			Teams[Players[member]:GetTeam()]:Meet(tt)
		end
	end
end
function STSAN4(id)
	local tab = {"Duck","Sparrow","Eagle","Hawk","Seagull"}
	return tab[id];
end
function STSCT4(answ)
	return "Ah, mayestic " .. STSAN4(answ) .. " who looks upon us from the sky, will you share us your wisdom?"
end
function STSIT4(a, b)
	return "Really? We were waiting for some " .. STSAN4(a) .. " for so long? We can now only dream about " .. STSAN4(b) .."."
end
function STSAN5(id)
	return "The rebels will try to overthrow ruler of " .. Players[Map.GetPlotByIndex(id):GetOwner()]:GetCivilizationShortDescription() .. "."
end
function STSCT5(a)
	return "I can predict the rise and fall of the empires, shall this be the lesson for people of " .. Players[Map.GetPlotByIndex(a):GetOwner()]:GetCivilizationShortDescription() .. ".";
end
function STSIT5(a, b)
	return STSAN2(a) .. "? How can people of " .. STSAN2(b) .. " stand this tyrant, are they sheeps?" 
end
local stsgwt = {"Literature", "Music", "Art"}
function STSAF6(a)
	return "Great Work of " .. stsgwt[a];
end
function STSAN6(a)
	return "" -- nice quote aboust literatue / music / art
end
function STSCT6(a)
	return "Ah yes, this is one of the most magnificent " .. stsgwt[a] .. " mankind witnessed." 
end
function STSIT6(a, b)
	return "I excepted " .. stsgwt[b] .. " and I got " .. stsgwt[a] .. ", what is more the mediocre one."
end
function STSOF6(id, leagueID)
	local membertab = {}
	for member, sth in pairs(gT.Leagues[leagueID].Members) do
		if Players[member]:IsAlive() and (not Players[member]:IsMinorCiv()) then
			table.insert(membertab, member)
		end
	end
	if #membertab > 0 then
		local lPlayer = membertab[LastRandom(1, #membertab)];
		CreateGreatWorkOfAmount(lPlayer, 1, stsgwt[id])
	end
end
function STSOF5(id, leagueID)
	local iCity = Map.GetPlotByIndex(id):GetPlotCity();
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	DoSpawnRebels(iCity, cID, iCity:GetOwner())
end
function GetTabOfPlotsSTST7(leagueID)
	local tab = {}
	for member, sth in pairs(gT.Leagues[leagueID].Members) do
		for iCity in Players[member]:Cities() do
			for i = 0, 5 do
				local nPlot = Map.PlotDirection(iCity:GetX(), iCity:GetY(), i);
				if nPlot then
					if nPlot:GetImprovementType() == GameInfoTypes.IMPROVEMENT_MINE then
						if nPlot:GetResourceType() == -1 then
							if nPlot:GetOwner() == member then
								table.insert(tab, nPlot)
							end
						end
					end
				end
			end
		end
	end
	return tab;
end
function STSOF7(id, leagueID)
	local tab = GetTabOfPlotsSTST7(leagueID)
	local lPlot = tab[LastRandom(1, #tab)];
	AddProperlyResourceOnPlot(lPlot, id, true, true)
end
function STSCD7(leagueID)
	if #GetTabOfPlotsSTST7(leagueID) > 0 then
		local a, b, c = STSAF7(leagueID);
		if #a > 2 then
			return true;
		end
	end
	return false;
end
function STSAN7(id)
	return Locale.Lookup(GameInfo.Resources[id].Description)
end
function STSCT7(a)
	return "My unlimited powers allow me too see through mother Earth to unreveal her secrets! I deserve at least half of found " .. STSAN7(a) .. "."; 
end
function STSIT7(a, b)
	return "Do I look like geologists? How could I tell difference between " .. STSAN7(b) .. " and " .. STSAN7(a) .. "."
end
function CitiesToSpySTS(leagueID)
	local ttt = {}
	for member, sth in pairs(gT.Leagues[leagueID].Members) do
		ttt[Players[member]:GetTeam()] = 1;
	end
	local tTab = {}
	for g, gd in pairs(gT.Players) do
		if not gT.Leagues[leagueID].Members[g] then
			for iCity in Players[g]:Cities() do
				if iCity:GetProductionUnit() ~= -1 then
					local iPlot = iCity:Plot();
					local bVis = true;
					for team, sth in pairs(ttt) do
						if not iPlot:IsVisible(team) then
							bVis = false;
							break;
						end
					end
					if bVis then
						table.insert(tTab, iCity);
					end
				end
			end
		end
	end
	return tTab;
end
function STSAF8(leagueID)
	local getCities = CitiesToSpySTS(leagueID);
	local iCity = getCities[LastRandom(1, #getCities)];
	local cAnswer = iCity:GetProductionUnit()
	local hTab = {cAnswer}  
	for row in GameInfo.Units() do
		if iCity:CanTrain(row.ID) then
			if row.ID ~= cAnswer then
				table.insert(hTab,  row.ID)
			end
		end
	end
	hTab = Shuffle(hTab)
	return hTab, cAnswer, iCity:Plot():GetPlotIndex()
end
function STSAF7(leagueID)
	local hTab = {rIron};
	for i, res in pairs({GameInfoTypes.RESOURCE_GOLD, GameInfoTypes.RESOURCE_GEMS, GameInfoTypes.RESOURCE_COPPER, GameInfoTypes.RESOURCE_SALT}) do
		if GetResourcesPresentOnMap(res, true) then
			table.insert(hTab, res)
		end
	end
	return hTab, nil, nil;
end
function STSTTF8(extraInfo)
	return "What is treacherous " .. Map.GetPlotByIndex(extraInfo):GetPlotCity():GetName() .. " training?"
end
function STSCD8(leagueID)
	return #CitiesToSpySTS(leagueID) > 0
end
function STSAN8(id)
	return Locale.Lookup(GameInfo.Units[id].Description)
end
function STSCT8(a)
	return "Who needs spies when my third eye clearly see " .. STSAN8(a) .. " secretly training."
end
function STSIT8(a, b)
	return "They clearly need " .. STSAN8(b) .. " in their army, yet they train useless " .. STSAN8(a) .. "?" 
end
local SeekerTabTasks = {
{ID = 1, Type = "Dice Roll", Answers = {1, 2, 3, 4, 5, 6}, AnswerName = STSAN1, AnswerHelp = STSAH1, CorrectText = STSCT1, IncorrectText = STSIT1, TitleText = "A simple dice roll is the best way to check your abilities."},
{ID = 2, Type = "Incoming Plague", CanDo = STSCD2, AnswersFunc = STSAF2, AnswerName = STSAN2, AnswerHelp = STSAH2, CorrectText = STSCT2, IncorrectText = STSIT2, OnFinished = STSOF2, TitleText = "You must warn citizens before incoming [ICON_ITG_PLAGUE_4] Epidemy."},
{ID = 3, Type = "Beyond Horizon", CanDo = STSCD3, AnswersFunc = STSAF3, AnswerName = STSAN3, AnswerHelp = STSAHBlank, CorrectText = STSCT3, IncorrectText = STSIT3, OnFinished = STSOF3, TitleText = "Merchants are coming back from a distant city, but what is its name?"},
{ID = 4, Type = "On the Sky", Answers = {1, 2, 3, 4, 5}, AnswerName = STSAN4, AnswerHelp = STSAHBlank, CorrectText = STSCT4, IncorrectText =STSIT4, TitleText = "What will see those who observe the sky?"},
{ID = 5, Type = "Hidden Threat", CanDo = STSCD5, AnswersFunc = STSAF2, AnswerName = STSAN2, AnswerHelp = STSAN5, CorrectText = STSCT5,IncorrectText = STSIT5,  OnFinished = STSOF5, TitleText = "The rebels will rise against the oppression."},
{ID = 6, Type = "Great Work", Answers = {1, 2, 3}, AnswerName = STSAF6, AnswerHelp = STSAN6, CorrectText = STSCT6, IncorrectText = STSIT6, OnFinished = STSOF6, TitleText = "The young man will decide to reveal his greatest making to the world."},
{ID = 7, Type = "New Resource", CanDo = STSCD7, AnswersFunc = STSAF7, AnswerName = STSAN7, AnswerHelp = STSAHBlank, CorrectText = STSCT7, IncorrectText = STSIT7, OnFinished = STSOF7, TitleText = "The miners will found a new treasure."},
{ID = 8, Type = "Little Spying", CanDo = STSCD8, AnswersFunc = STSAF8, TitleTextFunc = STSTTF8, AnswerName = STSAN8, AnswerHelp = STSAHBlank, CorrectText = STSCT8, IncorrectText = STSIT8}
}

function GetNextTaskSeeker(leagueID, hString)
	local tab = {}
	for i, data in pairs(SeekerTabTasks) do
		if (not data.CanDo) or data.CanDo(leagueID) then
			table.insert(tab, {i, gT.Leagues[leagueID].Resolutions[hString].TaskUsed[i] or 0})
		end
	end
	tab = Shuffle(tab)
	table.sort(tab,SortFunctionForLowestMapDistance)
	return tab[1][1];
end

function PrepareSeekerTask(leagueID, resID, hString)
	local taskID = GetNextTaskSeeker(leagueID, hString);
	gT.Leagues[leagueID].Resolutions[hString].CurrentTaskID = taskID;
	gT.Leagues[leagueID].Resolutions[hString].TaskUsed[taskID] = (gT.Leagues[leagueID].Resolutions[hString].TaskUsed[taskID] or 0) + 1;
	if SeekerTabTasks[taskID].AnswersFunc then
		local answerT, cAnswer, cExtra = SeekerTabTasks[taskID].AnswersFunc(leagueID);
		gT.Leagues[leagueID].Resolutions[hString].CurrentTaskPossibleAnswers = answerT;
		gT.Leagues[leagueID].Resolutions[hString].CorrectAnswer = cAnswer;
		gT.Leagues[leagueID].Resolutions[hString].ExtraInfoTask = cExtra;
	else
		gT.Leagues[leagueID].Resolutions[hString].CurrentTaskPossibleAnswers = SeekerTabTasks[taskID].Answers
	end
	gT.Leagues[leagueID].Resolutions[hString].MembersGuesses = {};
	for member, sth in pairs(gT.Leagues[leagueID].Members) do
		if not Players[member]:IsHuman() then
			table.insert(gT.Players[member].QueueActionsRealEndTurn, {"LeagueSeekerTask", leagueID});
		else
			local ttText;
			if SeekerTabTasks[taskID].TitleTextFunc then
				ttText = SeekerTabTasks[taskID].TitleTextFunc(gT.Leagues[leagueID].Resolutions[hString].ExtraInfoTask)
			end
			local data = {Text = "PREDICT FUTURE", UniqueOptions = {}, BonusType = "PredictTask", TitleText = ttText or SeekerTabTasks[taskID].TitleText, TitleIconIndex = 6, TitleIconAtlas = "BW_ATLAS_2", Tooltip = "Your league is searching for new Oracle. Proof to be worthy and earn the rewards."}
			for i, answer in pairs(gT.Leagues[leagueID].Resolutions[hString].CurrentTaskPossibleAnswers) do
				table.insert(data.UniqueOptions, {Name = SeekerTabTasks[taskID].AnswerName(answer), ID = i, ExtraInfo = leagueID, Help = SeekerTabTasks[taskID].AnswerHelp(answer)})
			end
			table.insert(gT.Players[member].NewHumanQueueActions, data)
		end
	end
end

function HumanPlayerPredictTask(iPlayer, confirminfo2, confirminfo3, confirminfo4)
	gT.Leagues[confirminfo3].Resolutions[45].MembersGuesses[iPlayer] = gT.Leagues[confirminfo3].Resolutions[45].CurrentTaskPossibleAnswers[confirminfo2];
	GeneralRemoveFirstBonusType(iPlayer, "PredictTask")
end

function DoAIGuessTheSeekingTask(iPlayer, leagueID)
	--maybe some logic one day
	local answer = gT.Leagues[leagueID].Resolutions[45].CurrentTaskPossibleAnswers[LastRandom(1, #gT.Leagues[leagueID].Resolutions[45].CurrentTaskPossibleAnswers)]
	gT.Leagues[leagueID].Resolutions[45].MembersGuesses[iPlayer] = answer;
end

function SeekerActiveTurnLeagueFunc(leagueID, resID, hString)
	local taskID = gT.Leagues[leagueID].Resolutions[hString].CurrentTaskID
	local trueanswer = gT.Leagues[leagueID].Resolutions[hString].CorrectAnswer or gT.Leagues[leagueID].Resolutions[45].CurrentTaskPossibleAnswers[LastRandom(1, #gT.Leagues[leagueID].Resolutions[45].CurrentTaskPossibleAnswers)]
	gT.Leagues[leagueID].Resolutions[hString].CorrectAnswer = nil
	gT.Leagues[leagueID].Resolutions[hString].ExtraInfoTask = nil;
	gT.Leagues[leagueID].Resolutions[hString].TaskCompleted = gT.Leagues[leagueID].Resolutions[hString].TaskCompleted + 1;
	for member, answer in pairs(gT.Leagues[leagueID].Resolutions[hString].MembersGuesses) do
		if answer == trueanswer then
			gT.Leagues[leagueID].Resolutions[hString].TasksDone[member] = gT.Leagues[leagueID].Resolutions[hString].TasksDone[member] + 1;
		end
	end
	if SeekerTabTasks[taskID].OnFinished then
		SeekerTabTasks[taskID].OnFinished(trueanswer, leagueID)
	end
	for i, human in pairs(gT.Globals.HumanPlayers) do
		if gT.Leagues[leagueID].Resolutions[hString].MembersGuesses[human] then
			if gT.Leagues[leagueID].Resolutions[hString].MembersGuesses[human] == trueanswer then
				Players[human]:AddNotification(94343293, SeekerTabTasks[taskID].CorrectText(trueanswer), SeekerTabTasks[taskID].Type, -1,-1, 15)
			else
				Players[human]:AddNotification(94343293, SeekerTabTasks[taskID].IncorrectText(trueanswer, gT.Leagues[leagueID].Resolutions[hString].MembersGuesses[human]), SeekerTabTasks[taskID].Type, -1,-1, 16)
			end
		end
	end
	if gT.Leagues[leagueID].Resolutions[hString].TaskCompleted > 6 then
		ResolveSpecialProjectSeeker(leagueID, resID, hString)
	else
		PrepareSeekerTask(leagueID, resID, hString)
	end
end

function ResolveSpecialProjectSeeker(leagueID, resID, hString)
	gT.Leagues[leagueID].Resolutions[hString].Finished = true;
	gT.Leagues[leagueID].Resolutions[hString].Active = nil;
	local fTab = {}
	for member, sth in pairs(gT.Leagues[leagueID].Resolutions[hString].TasksDone) do
		table.insert(fTab, {member, sth, 0})
	end
	fTab = Shuffle(fTab);
	table.sort(fTab, SortFunctionForGreaterInteger2);
	for i, data in pairs(fTab) do
		if data[2] == 6 then
			Players[data[1]]:SetPlayerUniqueBuilding(GameInfoTypes.BUILDINGCLASS_ITG_NATIONAL_ORACLE, GameInfoTypes.BUILDING_ITG_NATIONAL_ORACLE)
			GenerateGreatSeer(data[1])
			AddExtraVotesScriptedLeague(data[1], leagueID, "Oracle", 2)
			fTab[i][3] = 1;
		elseif data[2] >= 4 then
			GenerateGreatSeer(data[1])
			AddExtraVotesScriptedLeague(data[1], leagueID, "Oracle", 2)
			fTab[i][3] = 2;
		elseif data[2] >= 2 then		
			AddExtraVotesScriptedLeague(data[1], leagueID, "Oracle", 2)
			fTab[i][3] = 3;
		end
	end
	for i, iHuman in pairs(gT.Globals.HumanPlayers) do
		if Players[iHuman]:IsAlive() then
			if gT.Leagues[leagueID].Members[iHuman] then
				table.insert(gT.Players[iHuman].TheRaceInfoTable, {Type = "BasicRace", Title = gT.Leagues[leagueID].Resolutions[hString].Name, Help = GetProperResolutionHelp(45, gT.Leagues[leagueID].Resolutions[hString].ExtraInfo), OnlyOne = false, Players = fTab, SpecIcon = ""})
			end
		end
	end
end
