local relTrialChristian = GameInfoTypes.RELIGION_CHRISTIANITY
local relTrialIslam = GameInfoTypes.RELIGION_ISLAM
local tToForceProposalsChristian = {[13] = 1, [29] = 1, [45] = 1, [61] = 1, [77] = 1}
local tToForceProposalsIslam = {[10] = 1, [30] = 1, [50] = 1, [70] = 1}
local tToForceProposalsIdeology = {[15] = 1, [33] = 1, [51] = 1, [69] = 1, [87] = 1}
--local tToForceProposalsIdeology = {[2] = 1, [4] = 1, [6] = 1, [8] = 1, [10] = 1}
local ancientgreekleagues = {"Koinon", "Bottiaean", "Chrysaorian", "Epirote", "Lycian" ,"Acarnanian", "Achaean", "Aetolian", "Arcadian", "Boeotian", "Chalcidian", "Cretan", "Euboean", "Italiote" ,"Hellenic", "Thessalian", "Delian", "Peloponnesian"}

function AssignScriptedLeagues()
	if gT.Globals.ScenarioType == 2 then
		AssignScriptedLeaguesTheTrial()
	elseif gT.Globals.ScenarioType == 3 then
		AssignScriptedLeaguesTheAncient()
	elseif gT.Globals.ScenarioType == 4 then
		AssignScriptedLeaguesTheHope()
	elseif gT.Globals.ScenarioType == 5 then
		AssignScriptedLeaguesSleep()
	end
end

function AssignScriptedLeaguesSleep()
	local iTer = 1;
	for g, h in pairs(gT.Players) do
		if h.IdeologyFromPlayer == g then
			local gName = h.IdeologyName
			local niceUID = "IdeologyL" .. iTer;
			gT.Leagues[niceUID] = {Members = {}, Vetos = {}, NoVotesFromVoting = true, BudgetTotal = 0, ActionCooldowns = {}, BaseMembers = 0, ActionLog = {}, FakeResolutions = {}, SpecialProposalTag = "IdeologyL", Ideology = g, DoFindepedent = true, HasInitialProposals = false, Name= gName, Resolutions = {}, Proposals = {}, ProposalsHistory = {}};
			--resolutions
			gT.Leagues[niceUID].TurnFoundString = GetTextDate(LastRandom(-120, -40), gT.Globals.StartDate)
			table.insert(gT.Leagues[niceUID].FakeResolutions, {Name = "Host", EnactedTurn = gT.Leagues[niceUID].TurnFoundString, ResID = 1589})
			table.insert(gT.Leagues[niceUID].FakeResolutions, {Name = "Special rules", EnactedTurn = gT.Leagues[niceUID].TurnFoundString, ResID = 911})
			gT.Leagues[niceUID].Host = g;
			AddNewResolution(niceUID, 13)
			AddNewResolution(niceUID, 14)
			--
			for d, gd in pairs(gT.Players) do
				if gd.IdeologyFromPlayer == g then
					AddAMemberToLeague(niceUID, d)
					gT.Leagues[niceUID].Members[d].BudgetSupport = 0;
					gT.Leagues[niceUID].BaseMembers = gT.Leagues[niceUID].BaseMembers + 1;
				end
			end	
			UpdateAllVotesLeague(niceUID)
			iTer = iTer + 1;
		end
	end
end

function GetReligionFounderIfAny(rel)
	for g, h in pairs(gT.Players) do
		if Players[g]:GetReligionCreatedByPlayer() == rel then
			return g;
		end
	end
	return nil
end

function EnoughPlayersOfCTypeToFoundLeague(cType)
	local maj, min = 0, 0;
	for g, gd in pairs(gT.Players) do
		if gd.CultureType == cType then
			if Players[g]:IsMinorCiv() then
				min = min + 1;
			else
				maj = maj + 1;
			end
		end
	end	
	return (maj > 1) and ((maj + min) > 2);
end

function AssignScriptedLeaguesTheTrial()
	--medieval;	
	local cFounder = GetReligionFounderIfAny(relTrialChristian);
	if cFounder and EnoughPlayersOfCTypeToFoundLeague(3) then
		local gName = "Papal Primacy"
		local niceUID = "TrialChristianL";
		gT.Leagues[niceUID] = {Members = {}, Vetos = {}, TimedTemplar = LastRandom(20,40), OfficialRel = relTrialChristian, ActionCooldowns = {}, ActionLog = {}, FakeResolutions = {}, SpecialProposalTag = "ChristianL", DoFindepedent = true, HasInitialProposals = false, Name= gName, Resolutions = {}, Proposals = {}, ProposalsHistory = {}};
		--resolutions
		gT.Leagues[niceUID].TurnFoundString = GetTextDate(LastRandom(-700, -200), gT.Globals.StartDate)
--		gT.Leagues[niceUID].Resolutions[15] = {Name = "Pope", EnactedTurn = gT.Leagues[niceUID].TurnFoundString, ResID = 15, }
		table.insert(gT.Leagues[niceUID].FakeResolutions, {Name = "Pope", EnactedTurn = gT.Leagues[niceUID].TurnFoundString, ResID = 6789})
		table.insert(gT.Leagues[niceUID].FakeResolutions, {Name = "Special rules", EnactedTurn = gT.Leagues[niceUID].TurnFoundString, ResID = 911})
		gT.Leagues[niceUID].Host = cFounder;
		--
		gT.Globals.TemplarOnlyLeague[relTrialChristian] = true;
		TurnOffTemplarProject(relTrialChristian)

		for g, gd in pairs(gT.Players) do
			if gd.CultureType == 3 then
				AddAMemberToLeague(niceUID, g)
			end
		end	
		UpdateAllVotesLeague(niceUID)
	end
	cFounder = GetReligionFounderIfAny(relTrialIslam);
	if cFounder and EnoughPlayersOfCTypeToFoundLeague(4) then
		local gName = "Caliphate"
		local niceUID = "TrialIslamL";
		gT.Leagues[niceUID] = {Members = {}, ActionCooldowns = {}, ProposalsNoCD = true, TimedTemplar = LastRandom(30,55), OfficialRel = relTrialIslam, ActionLog = {},  Vetos = {}, FakeResolutions = {}, SpecialProposalTag = "IslamL", DoFindepedent = true, HasInitialProposals = false, Name = gName, Resolutions = {}, Proposals = {}, ProposalsHistory = {}};
		--resolutions
		gT.Leagues[niceUID].TurnFoundString = GetTextDate(LastRandom(-700, -200), gT.Globals.StartDate)
		table.insert(gT.Leagues[niceUID].FakeResolutions, {Name = "Caliph", EnactedTurn = gT.Leagues[niceUID].TurnFoundString, ResID = 6564})
		table.insert(gT.Leagues[niceUID].FakeResolutions, {Name = "Special rules", EnactedTurn = gT.Leagues[niceUID].TurnFoundString, ResID = 912})
		gT.Leagues[niceUID].HostDivider = 10;
		gT.Leagues[niceUID].HostTurn = 5;
		--
		gT.Globals.TemplarOnlyLeague[relTrialIslam] = true;
		TurnOffTemplarProject(relTrialIslam)

		local nCitiesmax = 0;
		for g, gd in pairs(gT.Players) do
			if gd.CultureType == 4 then
				AddAMemberToLeague(niceUID, g)
				nCitiesmax = math.max(nCitiesmax, Players[g]:GetNumCities())
			end
		end	
		local hP = {}
		for member, md in pairs(gT.Leagues[niceUID].Members) do
			if (nCitiesmax / 2) < Players[member]:GetNumCities() then
				table.insert(hP, {member, Players[member]:GetNumCities()})
			end
		end
		gT.Leagues[niceUID].Host = GetRandomFromBiasedChanceTable(hP);
		UpdateAllVotesLeague(niceUID)
	end
end

function GetPlayer10thBonusFromCaliph(iPlayer)
	if (gT.Leagues["TrialIslamL"]) and (gT.Leagues["TrialIslamL"].Host == iPlayer) then
		return 10 * gT.Globals.CaliphateMod;
	end
	return 0;
end

function GetSpecialProposalsScripted(specialtag, player, type, leagueID)
	if specialtag == "ChristianL" then
		return SpecialProposalsChristianL(player, type, leagueID)
	elseif specialtag == "IslamL" then
		return SpecialProposalsIslamL(player, type, leagueID)
	elseif specialtag == "ancientL" then
		return SpecialProposalsAncientL(player, type, leagueID)
	elseif specialtag == "LoN" then
		return SpecialProposalsLeagueOfNationsL(player, type, leagueID)
	elseif specialtag == "IdeologyL" then
		return SpecialProposalsIdeologyL(player, type, leagueID)
	end
end

function SpecialProposalsIslamL(player, type, leagueID)
	if type == 2 then
		return {}
	end
	if gT.Leagues[leagueID].Host ~= player then
		return {}
	end
	if (not tToForceProposalsIslam[GetITGGameTurn()]) or (not gT.Leagues[leagueID].Members[player].ForcedResolution) then
	-- here add actions if possible;
		local hTab = {}
		if CanBeProposedRightNow(leagueID, 27, 1, player) then
			table.insert(hTab, {ID = 27, Text = GetInfoFromTabOfProposal(27, "Name"), ToolTip = GetProperResolutionHelp(27, nil, true)})
		end
		return hTab
	end
	return GetSpecialResolutionsTab("IslamL", "TrialIslamL")
end

function SpecialProposalsIdeologyL(iPlayer, type, leagueID)
	if type == 2 then
		return {}
	end
	if gT.Leagues[leagueID].Host ~= iPlayer then
		return {}
	end
	if not tToForceProposalsIdeology[GetITGGameTurn()] then
		return {}
	end
	if not gT.Leagues[leagueID].Members[iPlayer].ForcedResolution then
		return {}
	end
	local hTab = {}
	table.insert(hTab, {ID = 60, Text = "Common Progress", ExtraChoice = true, ToolTip = GetProperResolutionHelp(60, nil, true)})
	return hTab
end

function SpecialProposalsChristianL(iPlayer, type, leagueID)
	if type == 2 then
		return {}
	end
	if gT.Leagues[leagueID].Host ~= iPlayer then
		return {}
	end
	if not tToForceProposalsChristian[GetITGGameTurn()] then
		return {}
	end
	if not gT.Leagues[leagueID].Members[iPlayer].ForcedResolution then
		return {}
	end
	local hTab = {}
	local cityTargetsOfCrusade = GetCityTargetsOfCrusade(iPlayer)
	if #cityTargetsOfCrusade > 2 then
		table.insert(hTab, {ID = 16, Text = "Crusade", ExtraChoice = true, ToolTip = GetProperResolutionHelp(16, nil, true)})
	end
	if not gT.Leagues[leagueID].PHIR then
		table.insert(hTab, {ID = 17, Text = "Holy Inquisition", ToolTip = GetProperResolutionHelp(17, nil, true)})
	end
	if not gT.Leagues[leagueID].PCHR then
		table.insert(hTab, {ID = 18, Text = "Cultural Unification", ToolTip = GetProperResolutionHelp(18, nil, true)})
	end
	if not gT.Leagues[leagueID].PWSR then
		local officialRel = gT.Leagues[leagueID].OfficialRel;
		for member, gdata in pairs(gT.Leagues[leagueID].Members) do
			if gT.Players[member].OfficialReligion ~= officialRel then
				table.insert(hTab, {ID = 28, Text = GetInfoFromTabOfProposal(28, "Name"), ToolTip = GetProperResolutionHelp(28, nil, true)})
				break;
			end
		end
	end
	if not gT.Leagues[leagueID].Resolutions[19] then
		table.insert(hTab, {ID = 19, Text = "Tithe", ToolTip = GetProperResolutionHelp(19, nil, true)})
	end
	table.insert(hTab, {ID = 20, Text = "Reform Belief", ExtraChoice = true, ToolTip = GetProperResolutionHelp(20, nil, true)})
	if not gT.Leagues[leagueID].Resolutions[65] then
		table.insert(hTab, {ID = 65, Text = "Indulgence", ToolTip = GetProperResolutionHelp(65, nil, true)})
	end
	if not gT.Leagues[leagueID].Resolutions[67] then
		table.insert(hTab, {ID = 67, Text = "Deus vult", ToolTip = GetProperResolutionHelp(67, nil, true)})
	end
	return hTab
end

function IsValidPlayerToBeTargetOfCrusade(hPlayer)
	if gT.Players[hPlayer].OfficialReligion == relTrialChristian then
		return false;
	end
	if gT.Players[hPlayer].CultureType == 4 or gT.Players[hPlayer].CultureType == 6 then
		return true;
	end
	return false;
end

function GetCityTargetsOfCrusade(iPlayer)
	local tab = {}
	local iTeam = Players[iPlayer]:GetTeam()
	for g, gdata in pairs(gT.Players) do
		if IsValidPlayerToBeTargetOfCrusade(g) then
			for iCity in Players[g]:Cities() do
				if iCity:Plot():IsRevealed(iTeam) then
					table.insert(tab, iCity)
				end
			end
		end
	end
	return tab;
end

function DoAIChooseSpecialResolution(iPlayer, leagueID)
	if leagueID == "TrialChristianL" then
		DoAIChooseChristianLeagueProposal(iPlayer, leagueID)
	elseif leagueID == "TrialIslamL" then
		DoAIChooseIslamLeagueProposal(iPlayer, leagueID)
	elseif gT.Leagues[leagueID].SpecialProposalTag == "ancientL" then
		DoAIChooseAncientLeagueProposal(iPlayer, leagueID)
	elseif leagueID == "LeagueOfNations" then
		DoAIChooseLeagueOfNationsProposal(iPlayer, leagueID)
	elseif gT.Leagues[leagueID].SpecialProposalTag == "IdeologyL" then
		DoAIChooseIdeologyProposal(iPlayer, leagueID)
	end
end

function GetMemberIslamResPower(member, resID, iPlayer)
	if resID == 21 then
		return GetMilitaryMightDemographics(iPlayer, member, false) * (0.95 + 0.05 * Players[member]:GetNumCities());
	elseif resID == 22 then
		return GetCurrentModifierFromCultureEra(member) * (0.95 + 0.05 * Players[member]:GetNumCities());
	elseif resID == 23 then
		local p = 0;
		for g, gdata in pairs(gT.Players) do
			if Players[g]:IsMinorCiv() then
				if Players[g]:GetMinorCivFriendshipLevelWithMajor(member) > 1 then
					p = p + 2;
				end
			end
		end
		return p;
	elseif resID == 24 then
		return Players[member]:GetMilitaryMight() * (0.90 + 0.1 * Players[member]:GetNumCities());
	elseif resID == 25 then
		local g = LastRandom(-3, 3)
		for gpID, hhh in pairs(gT.Players[member].GreatPeople) do
			local gpData = gT.GreatPeople[gpID];
			if gpData.Alive then
				g = g + 1;
			end
		end
		return g;
	elseif resID == 26 then
		return Players[member]:GetNumCities();
	end
	return 0;
end

function GetIslamValueResProposals(iPlayer, leagueID, resID)
	if not gT.Leagues[leagueID].Resolutions[resID] then
		local playerTab = {}
		for member, md in pairs(gT.Leagues[leagueID].Members) do
			if not Players[member]:IsMinorCiv() then
				table.insert(playerTab, {member, GetMemberIslamResPower(member, resID, iPlayer)})
			end
		end
		table.sort(playerTab, SortFunctionForGreaterInteger2)
		local val = 1;
		for i = 1, 3 do
			if playerTab[i] then
				if playerTab[i][1] == iPlayer then
					val = 5 - i;
					break;
				end
			end
		end
		return {resID, val}
	end
	return nil
end

function DoAIChooseIslamLeagueProposal(iPlayer, leagueID)
	local tab = {}
	for i = 21, 26 do
		local valueR = GetIslamValueResProposals(iPlayer, leagueID, i)
		if valueR then
			table.insert(tab, valueR)
		end
	end
	tab = Shuffle(tab)
	table.sort(tab, SortFunctionForGreaterInteger2)
	PlayerProposeSpecialChange(leagueID, tab[1][1], iPlayer)
end

function DoAIChooseIdeologyProposal(iPlayer, leagueID)
	local evalueatetab = GetPlayerOpinionOnCommonProgressResolution(iPlayer, leagueID)
	local hTab = {}
	for i = 1, 3 do
		local lkey = GetRandomFromBiasedChanceTable(evalueatetab, true);
		table.insert(hTab, evalueatetab[lkey][1])
		table.remove(evalueatetab, lkey)
	end
	PlayerProposeSpecialChange(leagueID, 60, iPlayer, hTab)
end

function DoAIChooseChristianLeagueProposal(iPlayer, leagueID)
	if ThereIsSenseOnDeclaringWarOnSchism(leagueID, iPlayer) then
		PlayerProposeSpecialChange(leagueID, 27, iPlayer, {})
		return;
	end
	local cityTargetsOfCrusade = GetCityTargetsOfCrusade(iPlayer)
	if #cityTargetsOfCrusade > 2 then
		local evalueatetab = {}
		local maxodistanco = LastRandom(15,25)
		for i, tCity in pairs(cityTargetsOfCrusade) do
			if tCity:GetDamage() < 50 then 
				local dis = GetClosestCityDistanceToXY(iPlayer, tCity:GetX(), tCity:GetY())
				if dis < maxodistanco then
					table.insert(evalueatetab, {tCity, maxodistanco - dis + tCity:GetPopulation()})
				end
			end
		end
		if #evalueatetab > 2 then
			table.sort(evalueatetab, SortFunctionForGreaterInteger2)
			-- we have trio to make proposals ;
			PlayerProposeSpecialChange(leagueID, 16, iPlayer, {evalueatetab[1][1]:Plot():GetPlotIndex(), evalueatetab[2][1]:Plot():GetPlotIndex(), evalueatetab[3][1]:Plot():GetPlotIndex()})
			return;
		end
	end
	--reform belief
	local reftab = GetThreeBeliefTypes(iPlayer, 25);
	if #reftab == 3 then
		PlayerProposeSpecialChange(leagueID, 20, iPlayer, {reftab[1], reftab[2], reftab[3]})
		return;
	end
	if not gT.Leagues[leagueID].Resolutions[19] then
		local totalgoldperturn = GetTotalGoldPerTurnForTithe(iPlayer)
		--tithe
		if totalgoldperturn > 200 then
			PlayerProposeSpecialChange(leagueID, 19, iPlayer, {})
			return;
		end
	end
	--art forward
	local rngTab = {}
	if not gT.Leagues[leagueID].PCHR then
		table.insert(rngTab, 18)
	end
	if not gT.Leagues[leagueID].Resolutions[65] then
		table.insert(rngTab, 65)
	end
	if not gT.Leagues[leagueID].PHIR then
		table.insert(rngTab, 17)
	end
	if #rngTab > 0 then
		PlayerProposeSpecialChange(leagueID, RandomFromTab(rngTab), iPlayer, {})
		return;
	end
	if not gT.Leagues[leagueID].Resolutions[67] then
		PlayerProposeSpecialChange(leagueID, 67, iPlayer, {})
		return;
	end
	if not gT.Leagues[leagueID].Resolutions[19] then
		PlayerProposeSpecialChange(leagueID, 19, iPlayer, {})
		return;
	end
	--reform belief again
	reftab = GetThreeBeliefTypes(iPlayer, 5);
	if #reftab == 3 then
		PlayerProposeSpecialChange(leagueID, 20, iPlayer, {reftab[1], reftab[2], reftab[3]})
		return;
	end
	if #cityTargetsOfCrusade > 2 then
		cityTargetsOfCrusade = Shuffle(cityTargetsOfCrusade);
		PlayerProposeSpecialChange(leagueID, 16, iPlayer, {cityTargetsOfCrusade[1]:Plot():GetPlotIndex(), cityTargetsOfCrusade[2]:Plot():GetPlotIndex(), cityTargetsOfCrusade[3]:Plot():GetPlotIndex()})
		return;
	end
	print("AI run out of proposals in papal league")
end

function AddExtraVotesScriptedLeague(iPlayer, league, name, amount)
	gT.Leagues[league].Members[iPlayer].Votes = gT.Leagues[league].Members[iPlayer].Votes + amount;
	gT.Leagues[league].Members[iPlayer].VotesFromScripts[name] = (gT.Leagues[league].Members[iPlayer].VotesFromScripts[name] or 0) + amount;
end

function LeagueScriptedSetOfficialReligion(iPlayer, iRel, rPlayer, bInitial)
	if gT.Leagues["TrialChristianL"] then
		if iRel == relTrialChristian then
			if iPlayer ~= rPlayer then
				if gT.Leagues["TrialChristianL"].Members[rPlayer] then
					AddExtraVotesScriptedLeague(rPlayer, "TrialChristianL", "Baptizing Pagans", 3);
					ChangeMeritocracy(iPlayer, 5)
				end
			end
		end
	end
	-- same for islam
	if gT.Leagues["TrialIslamL"] then
		if iRel == relTrialIslam then
			if iPlayer ~= rPlayer then
				if gT.Leagues["TrialIslamL"].Members[rPlayer] then
					AddExtraVotesScriptedLeague(rPlayer, "TrialIslamL", "Spreading the Word", 2 + (gT.Leagues["TrialIslamL"].ExtraVotesFromTasks or 0));
					ChangeMeritocracy(iPlayer, 5)
				end
			end
		end
	end
end

function LinkToLeagueScriptClaimReligion(iPlayer, iRel)
	if gT.Leagues["TrialChristianL"] then
		if iRel == relTrialChristian then
			if gT.Leagues["TrialChristianL"].Members[iPlayer] then
				gT.Leagues["TrialChristianL"].Host = iPlayer;
			else	
				gT.Leagues["TrialChristianL"].Host = nil;
			end
			UpdateAllVotesLeague("TrialChristianL")
		end
	end
end

function FirstConquerOfCityLeagueScript(iCity, newPlayer, jPlayer)
	if gT.Leagues["TrialChristianL"] then
		if gT.Leagues["TrialChristianL"].Members[newPlayer] then
			if gT.Players[jPlayer].OfficialReligion ~= relTrialChristian then
				AddExtraVotesScriptedLeague(newPlayer, "TrialChristianL", "Forced conversion", 1);
				ChangeMeritocracy(newPlayer, 5)
			end
		end
	end
	if gT.Leagues["TrialIslamL"] then
		if gT.Leagues["TrialIslamL"].Members[newPlayer] then
			if gT.Players[jPlayer].OfficialReligion ~= relTrialIslam then
				AddExtraVotesScriptedLeague(newPlayer, "TrialIslamL", "Forced conversion", 1 + (gT.Leagues["TrialIslamL"].ExtraVotesFromTasks or 0));
				ChangeMeritocracy(newPlayer, 5)
			end
		end
	end
end

function DoTurnSpecialLeague(specialtag, leagueID, turn)
	if gT.Leagues[leagueID].TimedTemplar then
		if gT.Leagues[leagueID].TimedTemplar <= turn then
			gT.Leagues[leagueID].TimedTemplar = nil;
			if not gT.TemplarStarted[gT.Leagues[leagueID].OfficialRel] then
				StartTemplarProjectForRel(gT.Leagues[leagueID].OfficialRel, true, 800)
				for member, mdata in pairs(gT.Leagues[leagueID].Members) do
					if Players[member]:IsHuman() then
						Players[member]:AddNotification(NotificationTypes.NOTIFICATION_LEAGUE_VOTING_DONE, "It is time to design a temple for our religion! If we succeed, we will be rewarded with 3 [ICON_ITG_VOTES] Votes in " .. gT.Leagues[leagueID].Name .. ".", "Templar Belief", -1, -1, -1)
					end
				end
			end
		end
	end
	if "ChristianL" == specialtag then
		if tToForceProposalsChristian[turn] then
			local iPlayer = gT.Leagues[leagueID].Host
			if iPlayer then
				gT.Leagues[leagueID].Members[iPlayer].ForcedResolution = turn
				if not Players[iPlayer]:IsHuman() then
					table.insert(gT.Players[iPlayer].QueueActionsRealEndTurn,  {"LeagueForcedResolution", leagueID, turn})
				end
			else
				print("Christian league has no host :)")
			end
		end
	elseif "IslamL" == specialtag then
		if tToForceProposalsIslam[turn] then
			local iPlayer = gT.Leagues[leagueID].Host
			gT.Leagues[leagueID].Members[iPlayer].ForcedResolution = turn
			if not Players[iPlayer]:IsHuman() then
				table.insert(gT.Players[iPlayer].QueueActionsRealEndTurn,  {"LeagueForcedResolution", leagueID, turn})
			end
		end
	elseif "ancientL" == specialtag then
		if gT.Leagues[leagueID].OrderOfResolutions[turn] then
			local iPlayer = gT.Leagues[leagueID].OrderOfResolutions[turn]
			if gT.Leagues[leagueID].Members[iPlayer] then -- can be removed
				gT.Leagues[leagueID].Members[iPlayer].ForcedResolution = turn
				if not Players[iPlayer]:IsHuman() then
					table.insert(gT.Players[iPlayer].QueueActionsRealEndTurn,  {"LeagueForcedResolution", leagueID, turn})
				end
			end
		end
	elseif "LoN" == specialtag then
		if gT.Leagues[leagueID].OrderOfResolutions[turn] then
			for member, sth in pairs(gT.Leagues[leagueID].Members) do
				gT.Leagues[leagueID].Members[member].ForcedResolution = turn
				if not Players[member]:IsHuman() then
					table.insert(gT.Players[member].QueueActionsRealEndTurn,  {"LeagueForcedResolution", leagueID, turn})
				end
			
			end
			gT.Leagues[leagueID].EndWarTable = {}
			PrepareEndWarTable(leagueID)
		end
	elseif "IdeologyL" == specialtag then
		if tToForceProposalsIdeology[turn] then
			local iPlayer = gT.Leagues[leagueID].Host
			if iPlayer then
				gT.Leagues[leagueID].Members[iPlayer].ForcedResolution = turn
				if not Players[iPlayer]:IsHuman() then
					table.insert(gT.Players[iPlayer].QueueActionsRealEndTurn,  {"LeagueForcedResolution", leagueID, turn})
				end
			else
				print("Ideology league has no host :)", leagueID)
			end
		end
	end
	for hString, hData in pairs(gT.Leagues[leagueID].Resolutions) do
		if hData.EndTurn and (not hData.Project) and (hData.EndTurn <= GetITGGameTurn()) then
			if hString == 18 then
				local bestepoque = -1;
				for member, mdata in pairs(gT.Leagues[leagueID].Members) do
					if not Players[member]:IsMinorCiv() then
						if Players[member]:IsAlive() then
							bestepoque = math.max(bestepoque, gT.Players[member].CultureEra)
						end
					end
				end
				local upgrade = 0;
				local rewardP = {}
				for member, mdata in pairs(gT.Leagues[leagueID].Members) do
					if not Players[member]:IsMinorCiv() then
						if Players[member]:IsAlive() then
							if gT.Players[member].CultureEra == bestepoque then
								table.insert(rewardP, member)
							else
								upgrade = upgrade + 1;
								UpgradePlayerToNextCulturalEra(member, true)
								if Players[member]:IsHuman() then
									Players[member]:AddNotification(NotificationTypes.NOTIFICATION_LEAGUE_VOTING_DONE, "Cultural Unification in " .. gT.Leagues[leagueID].Name .. " has ended with success, our artists entered " .. gT.Globals.CultureErasNames[gT.Players[member].CultureType][gT.Players[member].CultureEra] .. ".", "Cultural Unification", -1, -1, -1)
								end
							end
						end
					end
				end
				if upgrade > 0 then
					for i, member in pairs(rewardP) do
						ChangeMeritocracy(member, 10)
						if hData.ExtraInfo == 1 then
							ChangeITGFaith(member, 150 * upgrade)
							if Players[member]:IsHuman() then
								Players[member]:AddNotification(NotificationTypes.NOTIFICATION_LEAGUE_VOTING_DONE, "Cultural Unification in " .. gT.Leagues[leagueID].Name .. " has ended with success, our artists helped less successful ones to spread their wings. We were rewarded with " .. 150 * upgrade .. " [ICON_PEACE] Faith and +10 [ICON_ITG_MERITOCRACY] Meritocracy.", "Cultural Unification", -1, -1, -1)
							end
						elseif hData.ExtraInfo == 2 then
							BoostHappinessInAllCities(member, upgrade)
							if Players[member]:IsHuman() then
								Players[member]:AddNotification(NotificationTypes.NOTIFICATION_LEAGUE_VOTING_DONE, "Cultural Unification in " .. gT.Leagues[leagueID].Name .. " has ended with success, our artists helped less successful ones to spread their wings. That made our people proud (+" .. upgrade .. " [ICON_HAPPINESS_1] Happiness and +10 [ICON_ITG_MERITOCRACY] Meritocracy).", "Cultural Unification", -1, -1, -1)
							end
						else
							BoostArtisticPoints(member, 200 * upgrade)
							if Players[member]:IsHuman() then
								Players[member]:AddNotification(NotificationTypes.NOTIFICATION_LEAGUE_VOTING_DONE, "Cultural Unification in " .. gT.Leagues[leagueID].Name .. " has ended with success, our artists helped less successful ones to spread their wings. It motivated our artists to work harder (+" .. upgrade * 200 .. " [ICON_GREAT_ARTIST] Art points and +10 [ICON_ITG_MERITOCRACY] Meritocracy).", "Cultural Unification", -1, -1, -1)
							end
						end
					end
				else
					for ji, iHuman in pairs(gT.Globals.HumanPlayers) do
						if gT.Leagues[leagueID].Members[iHuman] then
							Players[iHuman]:AddNotification(NotificationTypes.NOTIFICATION_LEAGUE_VOTING_DONE, "Cultural Unification ended with total failure, apparently all artists already have the same style.", "Cultural Unification", -1, -1, -1)
						end
					end
				end
			elseif hString == 19 then
				print("It should no fire 5439534/234")
			end
			gT.Leagues[leagueID].Resolutions[hString] = nil;
		end
	end
	--resolving resolutions special
	for hString, hData in pairs(gT.Leagues[leagueID].Proposals) do
		local bFinished = true
		for dPlayer, sth in pairs(gT.Leagues[leagueID].Members) do
			if Players[dPlayer]:IsAlive() then
				if not hData.PlayersAnswers[dPlayer] then
					if hData.ProposedBy ~= dPlayer then
						bFinished = false;
						break;
					end
				end
			end
		end
		if bFinished then
			if (not gT.Leagues[leagueID].ProposalsEndTurn) or (not GetInfoFromTabOfProposal(hData.ResolutionID, "NormalAnswer")) then
			--above if was added, because technically all members of league of nations could suggest same proposal and it is not supposed to be resolved instantly; 
				ResolveScriptedResolution(leagueID, hString)
			end
		end
	end
end

function DoMakeScriptedAnswer(iPlayer, leagueNID, idR)
	if idR == 16 then
		local tabE = {}
		for i, answer in pairs(gT.Leagues[leagueNID].Proposals[idR].Answers) do
			local iCity = Map.GetPlotByIndex(answer[1]):GetPlotCity();
			local dis = GetClosestCityDistanceToXY(iPlayer, iCity:GetX(), iCity:GetY())
			table.insert(tabE, {i, -dis + iCity:GetPopulation()})
		end
		table.sort(tabE, SortFunctionForGreaterInteger2)
		PlayerProposalAnswer(iPlayer, leagueNID, idR, tabE[1][1])
	elseif idR == 17 then
		--yes no
		local val = 100;
		for iCity in Players[iPlayer]:Cities() do
			if iCity:IsHasBuilding(GameInfoTypes.BUILDING_ITG_NEW_WORLD_INQUISITION) then
				val = val - 8;
			end
			val = val - iCity:GetPopulation();
		end
		for gpID, hhh in pairs(gT.Players[iPlayer].GreatPeople) do
			local gpData = gT.GreatPeople[gpID];
			if gpData.Alive then
				if gpData.Religion ~= relTrialChristian then
					val = val - 5;
				end
			end
		end
		if LastRandom(1, 100) <= val then
			PlayerProposalAnswer(iPlayer, leagueNID, idR, 1)
		else
			PlayerProposalAnswer(iPlayer, leagueNID, idR, 2)
		end
	elseif idR == 18 then
		local ihap = gT.Players[iPlayer].AverageHappiness
		if ihap < 0 then
			PlayerProposalAnswer(iPlayer, leagueNID, idR, 2)
		else
			local ifaithFlavour = GetAIFlavour(iPlayer, "FLAVOR_RELIGION") + LastRandom(0,2)
			local iHapFlavour = GetAIFlavour(iPlayer, "FLAVOR_HAPPINESS") + LastRandom(0,2)
			local iartFlavour = GetAIFlavour(iPlayer, "FLAVOR_CULTURE") + LastRandom(0,2)
			local tab = {{1, ifaithFlavour}, {2, iHapFlavour}, {3, iartFlavour}}
			PlayerProposalAnswer(iPlayer, leagueNID, idR, GetRandomFromBiasedChanceTable(tab))
		end
	elseif idR == 19 then
		if gT.Players[iPlayer].PrevTurnGPT < 0 then
			PlayerProposalAnswer(iPlayer, leagueNID, idR, 1)
		else
			if GetAIFlavour(iPlayer, "FLAVOR_CULTURE") + LastRandom(0,2) > 7 then
				PlayerProposalAnswer(iPlayer, leagueNID, idR, 2)
			else
				PlayerProposalAnswer(iPlayer, leagueNID, idR, 3)
			end
		end
	elseif idR == 20 then
		local tabE = {}
		for i, answer in pairs(gT.Leagues[leagueNID].Proposals[idR].Answers) do
			table.insert(tabE, {i, DLLBasedBeliefScore(iPlayer, answer[1])})
		end
		table.sort(tabE, SortFunctionForLowestMapDistance)
		PlayerProposalAnswer(iPlayer, leagueNID, idR, tabE[1][1])
	elseif idR == 28 then
		PlayerProposalAnswer(iPlayer, leagueNID, idR, GetResponseAnswerToSchism(iPlayer, leagueNID))
	elseif idR == 50 then
		PlayerProposalAnswer(iPlayer, leagueNID, idR, GetAIValueResolution50(iPlayer, leagueNID, nil, false, idR))
	elseif idR == 59 then
		PlayerProposalAnswer(iPlayer, leagueNID, idR, GetAIValueResolution59(iPlayer, leagueNID, nil, false, idR))
	elseif idR == 60 then
		local tabE = {}
		local revot = {}
		for i, answer in pairs(gT.Leagues[leagueNID].Proposals[idR].Answers) do
			table.insert(tabE, answer[1])
			revot[answer[1]] = i;
		end
		PlayerProposalAnswer(iPlayer, leagueNID, idR, revot[GetRandomFromBiasedChanceTable(GetPlayerOpinionOnCommonProgressResolution(iPlayer, leagueNID, tabE))])
	elseif idR == 65 then
		if Players[iPlayer]:IsMinorCiv() then
			PlayerProposalAnswer(iPlayer, leagueNID, idR, LastRandom(1,3))
		else
			local rndTab = {{1, math.max(1, Players[iPlayer]:GetNumCities())}, {2, GetAIFlavour(iPlayer, "FLAVOR_LEGAL")}, {3, GetAIFlavour(iPlayer, "FLAVOR_HAPPINESS")}}
			PlayerProposalAnswer(iPlayer, leagueNID, idR, GetRandomFromBiasedChanceTable(rndTab))
		end
	elseif idR == 67 then
		if Players[iPlayer]:IsMinorCiv() then
			PlayerProposalAnswer(iPlayer, leagueNID, idR, LastRandom(1,3))
		else
			local rndTab = {{1, math.max(1, Players[iPlayer]:GetNumUnitsSupplied() - Players[iPlayer]:GetNumUnitsToSupply())}, {2, math.max(1, GetNumOccupiedCities(iPlayer) * 4)}, {3, math.max(1, -gT.Players[iPlayer].Morale)}}
			PlayerProposalAnswer(iPlayer, leagueNID, idR, GetRandomFromBiasedChanceTable(rndTab))
		end
	else
		print("Error 91235/32412#", idR)
	end
end

function GetThreeBeliefTypes(iPlayer, eValCheck)
	local iRel = Players[iPlayer]:GetReligionCreatedByPlayer()
	local cBeliefs = Game.GetBeliefsInReligion(iRel);
	local numToChooseFrom = GetNumReformBeliefOption(iPlayer);
	local hBTab = {}
	for i, beliefType in pairs(cBeliefs) do
		local hType = GetBeliefTypeITG(beliefType)
		if hType and (hType < 5) then
			local value = DLLBasedBeliefScore(iPlayer, beliefType);
			local op = GetNewBeliefForReformation(beliefType, iPlayer, cBeliefs, 3);
			if op then
				local avValue = 0;
				local vals = {};
				for it, blf in pairs(op) do
					local beliefVal = DLLBasedBeliefScore(iPlayer, blf);
					avValue = avValue + beliefVal;
					table.insert(vals, beliefVal);
				end
				avValue = math.floor(avValue / #op + 0.5);
				if numToChooseFrom > 1 then
					table.sort(vals, SortFunctionHighestInteger)
					avValue = math.max(avValue, vals[math.max(1, #vals + 1 - numToChooseFrom)]);
				end
				table.insert(hBTab, {beliefType, avValue - value})
			end
		end
	end
	if #hBTab > 2 then
		table.sort(hBTab, SortFunctionForGreaterInteger2);
		if hBTab[3][2] >= eValCheck then
			return {hBTab[1][1], hBTab[2][1], hBTab[3][1]}
		end
	end
	return {}
end

function GetTotalGoldPerTurnForTithe(iPlayer)
	local c = 0;
	for g, gdata in pairs(gT.Players) do
		if gdata.CultureType == 3 then
			if g ~= iPlayer then
				c = c + gdata.PrevTurnGPT;
			end
		end
	end
	return c;
end

function ResolveScriptedResolution(leagueID, hString)
	print("Hello trying to resolve special", leagueID, hString)
	for member, answer in pairs(gT.Leagues[leagueID].Proposals[hString].PlayersAnswers) do
		if Players[member]:IsMinorCiv() then
			local gAlly = Players[member]:GetAlly();
			if gT.Leagues[leagueID].Members[gAlly] then
				if (gT.Leagues[leagueID].Proposals[hString].ProposedBy ~= gAlly) then
					gT.Leagues[leagueID].Proposals[hString].PlayersAnswers[member] = gT.Leagues[leagueID].Proposals[hString].PlayersAnswers[gAlly];
				end
			end
		end
	end

	local options = {}
	for i, s in pairs(gT.Leagues[leagueID].Proposals[hString].Answers) do
		table.insert(options, {i, 0})
	end
	for player, answer in pairs(gT.Leagues[leagueID].Proposals[hString].PlayersAnswers) do
		if gT.Leagues[leagueID].Members[player] then
			options[answer][2] = options[answer][2] + gT.Leagues[leagueID].Members[player].Votes
		else
			gT.Leagues[leagueID].Proposals[hString].PlayersAnswers[player] = nil;
		end
	end
	local chosen = GetRandomFromBiasedChanceTable(options)
	SpecialResolutionAdd(leagueID, hString, gT.Leagues[leagueID].Proposals[hString].Answers[chosen][1], gT.Leagues[leagueID].Proposals[hString].ProposedBy)
	--here functions to add properly each resolution or initial effects :) + notification
	gT.Leagues[leagueID].Proposals[hString] = nil;
end

function AnihilateHeathensInMostGloriousInquisition(leagueID)
	for member, sthmember in pairs(gT.Leagues[leagueID].Members) do
		DoChangeLocalTheologyHeresy(member, -50)
		for iCity in Players[member]:Cities() do
			if LastRandom(1, iCity:GetPopulation()) > 1 then
				iCity:ChangePopulation(-1, true)
			end
			DoInquisitionOnCity(member, iCity, true)
		end
		for gpID, hhh in pairs(gT.Players[member].GreatPeople) do
			local gpData = gT.GreatPeople[gpID];
			if gpData.Alive then
				if gpData.Religion ~= relTrialChristian then
					if LastRandom(1, 100) <= 75 then
						KillGreatPerson(gpID)
					end
				end
			end
		end
	end
end

function DeclareWarOnSchism(leagueID)
	local pP = {}
	for member, sth in pairs(gT.Leagues[leagueID].Members) do
		if gT.Players[member].OfficialReligion ~= relTrialChristian then
			table.insert(pP, member)
		end
	end
	for i, player in pairs(pP) do
		RemovePlayerFromLeague(player, leagueID, "Schism")
	end
	for i, player in pairs(pP) do
		local pTeam = Teams[Players[player]:GetTeam()]
		for member, sth in pairs(gT.Leagues[leagueID].Members) do
			ChangePeaceWarLock(player, member, 1, "WarOnSchism")
			gT.Players[player].ScenarioWarLocks[member] = true;
			gT.Players[member].ScenarioWarLocks[player] = true;
			if not pTeam:IsAtWar(Players[member]:GetTeam()) then
				Teams[iTeam]:DeclareScriptedWar(gTeam);
			end
		end
	end
end

function PlayerReturnFromSchismOrDoSchism(player)
	local pTeam = Teams[Players[player]:GetTeam()]
	--exclude minor (just to make it easier during mass schism)
	if Players[player]:IsMinorCiv() then
		return;
	end
	if gT.Players[player].OfficialReligion == relTrialChristian then
		if not gT.Leagues["TrialChristianL"].Members[player] then
		--k, you returned to leadership of papacy but you will no longer be included in league
			for member, sth in pairs(gT.Leagues["TrialChristianL"].Members) do
				if not Players[member]:IsMinorCiv() then
					if gT.Players[member].ScenarioWarLocks[player] then
						gT.Players[member].ScenarioWarLocks[player] = nil;
						gT.Players[player].ScenarioWarLocks[member] = nil;
						ChangePeaceWarLock(player, member, -1, "WarOnSchism")
					end
				end
			end
		end
	elseif gT.Leagues["TrialChristianL"].Members[player] then
		RemovePlayerFromLeague(player, "TrialChristianL", "Schism")
		for member, sth in pairs(gT.Leagues["TrialChristianL"].Members) do
			if not Players[member]:IsMinorCiv() then
				if not gT.Players[member].ScenarioWarLocks[player] then
					ChangePeaceWarLock(player, member, 1, "WarOnSchism")
					gT.Players[player].ScenarioWarLocks[member] = true;
					gT.Players[member].ScenarioWarLocks[player] = true;
					if not pTeam:IsAtWar(Players[member]:GetTeam()) then
						Teams[iTeam]:DeclareScriptedWar(gTeam);
					end
				end
			end
		end
		--peace available with other schismatics
		for g, gd in pairs(gT.Players) do
			if g ~= player then
				if gd.CultureType == 3 then
					if not gT.Leagues["TrialChristianL"].Members[g] then
						if not Players[g]:IsMinorCiv() then
							if gd.ScenarioWarLocks[player] then
								gT.Players[g].ScenarioWarLocks[player] = nil;
								gT.Players[player].ScenarioWarLocks[g] = nil;
								ChangePeaceWarLock(player, g, -1, "WarOnSchism")
							end
						end
					end
				end
			end
		end
	end
end

local VotesFromContest = {5, 3, 1}
local IconFromPlace = {"[ICON_TROPHY_GOLD]", "[ICON_TROPHY_SILVER]", "[ICON_TROPHY_BRONZE]"}

function GetValueForBasicContestsLeagueResolve(leagueID, resID, member)
	if resID == 21 then
		return gT.Players[member].CaliphateGhazi or 0;
	elseif resID == 22 then
		return gT.Players[member].GreatArtistPoints;
	elseif resID == 23 then
		local p = 0 
		for g, gdata in pairs(gT.Players) do
			if Players[g]:IsMinorCiv() then
				if Players[g]:GetMinorCivFriendshipLevelWithMajor(member) > 1 then
					p = p + 4
				elseif Players[g]:GetMinorCivFriendshipLevelWithMajor(member) > 0 then
					p = p + 1
				end
			end
		end
		return p;
	elseif resID == 25 then
		local g = 0
		for gpID, hhh in pairs(gT.Players[member].GreatPeople) do
			local gpData = gT.GreatPeople[gpID];
			if gpData.Alive then
				g = g + 1;
			end
		end
		return g;
	elseif resID == 26 then
		return gT.Players[member].CaliphateTrade or 0;
	elseif resID == 66 then
		local numRevealed = GetNumRevealedPlots(member)
		local numDif = numRevealed - (gT.Leagues[leagueID].Members[member].Res66Count or 0);
		gT.Leagues[leagueID].Members[member].Res66Count = numRevealed
		return numRevealed + numDif * 4;
	end
	return 0;
end

function BasicContestsLeagueResolve(leagueID, resID, sTitle)
--basic yet used only in Caliphate league :<
	local tTab = {}
	local lValue = -1;
	local dPlace = 0;
	local rPlace = 0;
	for member, mdata in pairs(gT.Leagues[leagueID].Members) do
		if not Players[member]:IsMinorCiv() then
			table.insert(tTab, {member, GetValueForBasicContestsLeagueResolve(leagueID, resID, member)})
		end
	end
	table.sort(tTab, SortFunctionForGreaterInteger2)
	for i, v in pairs(tTab) do
		rPlace = rPlace + 1;
		if v[2] ~= lValue then
			lValue = v[2];
			dPlace = rPlace;
		end
		if VotesFromContest[dPlace] then
			AddExtraVotesScriptedLeague(v[1], leagueID, sTitle, VotesFromContest[dPlace])
			ChangeMeritocracy(v[1], VotesFromContest[dPlace]) 
			if Players[v[1]]:IsHuman() then
				Players[v[1]]:AddNotification(NotificationTypes.NOTIFICATION_LEAGUE_VOTING_DONE, IconFromPlace[dPlace] .. " We have gained +" ..  VotesFromContest[dPlace] .. " [ICON_ITG_VOTES] Votes (and [ICON_ITG_MERITOCRACY] Meritocracy) in " .. gT.Leagues[leagueID].Name .. " (" .. sTitle .. ").", sTitle, -1, -1, v[1])
			end
		else
			break;
		end
	end
end

function DoLeagueBonusesBasedOnTurn20th()
	for leagueID, data in pairs(gT.Leagues) do
		if data.Resolutions[22] then
			BasicContestsLeagueResolve(leagueID, 22, "Poetry")
		end
		if data.Resolutions[23] then
			BasicContestsLeagueResolve(leagueID, 23, "Suzerain")
		end
		if data.Resolutions[25] then
			BasicContestsLeagueResolve(leagueID, 25, "Patronage")
		end
		if data.Resolutions[66] then
			BasicContestsLeagueResolve(leagueID, 66, "Exploration")
		end
		if data.Resolutions[26] then
			BasicContestsLeagueResolve(leagueID, 26, "Riches")
			for g, sth in pairs(gT.Players) do
				if not Players[g]:IsMinorCiv() then
					if data.Members[g] then
						gT.Players[g].CaliphateTrade = 0;
					else
						gT.Players[g].CaliphateTrade = nil;
					end
				end
			end
		end
		if data.Resolutions[21] then
			BasicContestsLeagueResolve(leagueID, 21, "Ghazi")
			for g, sth in pairs(gT.Players) do
				if not Players[g]:IsMinorCiv() then
					if data.Members[g] then
						gT.Players[g].CaliphateGhazi = 0;
					else
						gT.Players[g].CaliphateGhazi = nil;
					end
				end
			end
		end
	end
end

function DoSomeAILogicForScriptedLeagues(leagueID, iPlayer, tag)
	if tag == "IslamL" then
		if gT.Leagues[leagueID].Host == iPlayer then
			--well; you are a caliph, shall we increase caliph strength?
			if CanBeProposedRightNow(leagueID, 27, 1, iPlayer) then
				local votesAbove = 20;
				local gv = GetPlayerVotesWithMinorsLeague(iPlayer, leagueID);
				for member, sth in pairs(gT.Leagues[leagueID].Members) do
					if member ~= iPlayer then
						votesAbove = math.min(votesAbove, gv - GetPlayerVotesWithMinorsLeague(member, leagueID));
					end
				end
				if votesAbove > 9 then
					if votesAbove > 14 or (GetITGGameTurn() > 90) or (GetITGGameTurn() > 50 and (GetITGGameTurn()%10 > 5)) then
						PlayerProposeChangeToLeague(leagueID, 27, iPlayer, nil, nil)
					end
				end
			end
		end
	end
end

function ThereIsSenseOnDeclaringWarOnSchism(leagueID, iPlayer)
	local hMajor, hMinor, lMajor, lMinor = 0, 0, 0, 0;
	if gT.Players[iPlayer].OfficialReligion ~= relTrialChristian then
		return false;
	end
	for member in pairs(gT.Leagues[leagueID].Members) do
		if Players[member]:IsMinorCiv() then
			if gT.Players[member].OfficialReligion == relTrialChristian then
				lMinor = lMinor + 1;
			else
				hMinor = hMinor + 1;
			end
		elseif gT.Players[member].OfficialReligion == relTrialChristian then
			lMajor = lMajor + 1;
		else
			hMajor = hMajor + 1;
		end
	end
	if lMajor < 2 or (lMajor < hMajor) then
		return false;
	end
	if hMajor == 1 and (lMajor > 2) then
		return true;
	elseif hMajor == 2 and (lMajor > 4) then
		return true;
	elseif hMajor == 0 and (hMinor > 3) then
		return true;
	end
	return false
end

function GetResponseAnswerToSchism(iPlayer, leagueNID)
	--1 yay
	--2 nay
	if gT.Players[iPlayer].OfficialReligion ~= relTrialChristian then
		return 2;
	end
	local wage = 50;
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_EURO_2, "casdwae") then
		wage= wage + 25; -- we are incapable of schism anyway;
	end
	--smell the danger
	local yMM = GetMilitaryMightDemographics(iPlayer, iPlayer, false)
	local pp = 0
	local tS, tL = 0, 0;
	for member, sth in pairs(gT.Leagues[leagueNID].Members) do
		local sMM = GetMilitaryMightDemographics(iPlayer, member, false)
		if gT.Players[iPlayer].OfficialReligion ~= relTrialChristian then
			tS = tS + sMM;
			pp = pp + 1;
			if sMM > (yMM * 1.5) then
				wage = wage - 15; -- we dont wanna mess with that;
			elseif sMM * 1.5 < yMM then
				wage = wage + 10;
			end
		else
			tL = tL + sMM;
		end
	end
	if tS > tL then
		return 2;
	end
	if tL > tS * 2.5 then
		wage = wage + 20;
	end
	if pp == 0 then
		return LastRandom(1,2);
	end
	if LastRandom(1, 100) <= wage then
		return 1;
	end
	return 2;
end

function AssignScriptedLeaguesTheAncient()
	ancientgreekleagues = Shuffle(ancientgreekleagues);
	local major ={}
	local minor = {}
	for g, h in pairs(gT.Players) do
		if h.CultureType == 8 then
			if Players[g]:IsMinorCiv() then
				table.insert(minor, g)
			else
				table.insert(major, g)
			end
		end
	end
	if #major < 3 then
		return;
	end
	local todol = math.floor(#major / 3);
	major = Shuffle(major)
	minor = Shuffle(minor)
	local iket = 1;
	local playerTabs = {}
	for i = 1, todol do
		playerTabs[i] = {}
	end
	for i, v in pairs(major) do
		table.insert(playerTabs[iket], v)
		iket = math.max(1, (iket + 1) % (todol + 1));
	end
	local nmnr = 1
	if iket ~= 1 then
		for i = 1, todol + 1 - iket do
			if minor[i] then
				table.insert(playerTabs[iket -1 + i], minor[i])
				nmnr = nmnr + 1;
			end
		end
	end
	iket = 1;
	for i, v in pairs(minor) do
		if i >= nmnr then
			if #playerTabs[iket] < 7 then
				table.insert(playerTabs[iket], v)
			end
			iket = math.max(1, (iket + 1) % (todol + 1));
		end
	end
	for jk = 1, todol do
		playerTabs[jk] = Shuffle(playerTabs[jk])
		local gName = ancientgreekleagues[jk]  .. " League"
		local niceUID = "AncientL" .. jk;
		gT.Leagues[niceUID] = {Members = {}, Vetos = {}, ResSupportExtraVotes = 5, ProposalsOnlyOnce = true, ActionCooldowns = {}, NoVotesFromVoting = true, ActionLog = {}, FakeResolutions = {}, SpecialProposalTag = "ancientL", DoFindepedent = true, HasInitialProposals = false, Name= gName, Resolutions = {}, Proposals = {}, ProposalsHistory = {}};
		--ResSupportExtraVotes = 2 * #playerTabs[jk]
		
		--resolutions
		local hString = ""
		local diff = math.floor(77 / #playerTabs[jk])
		local bg = 8 + math.floor((77 - diff * #playerTabs[jk])/2);
		local orderT = {}
		for i, v in pairs(playerTabs[jk]) do
			orderT[(bg + (i - 1) * diff)] = v;
			if v == Game.GetActivePlayer() then
				hString = hString .. "[NEWLINE][ICON_BULLET]You (" .. (bg + (i - 1) * diff)  .. "T)"
			else
				hString = hString .. "[NEWLINE][ICON_BULLET]" .. Players[v]:GetName() .. " (" .. (bg + (i - 1) * diff)  .. "T)"
			end
		end
		gT.Leagues[niceUID].OrderOfResolutions = orderT;
		gT.Leagues[niceUID].TurnFoundString = GetTextDate(LastRandom(-700, -200), gT.Globals.StartDate)
		table.insert(gT.Leagues[niceUID].FakeResolutions, {Name = "Special rules", EnactedTurn = gT.Leagues[niceUID].TurnFoundString, ResID = 913, ExtraInfo = hString})
		AddNewResolution(niceUID, 13)
		AddNewResolution(niceUID, 14)
		local tresT = GetNiceInitialResForSpecialLeague(LastRandom(2,4),{[3] = 1, [4] = 1, [7] = 1})
		for i, resID in pairs(tresT) do
			AddNewResolution(niceUID, resID)
		end
		--
		for i, v in pairs(playerTabs[jk]) do
			AddAMemberToLeague(niceUID, v)
			local iTeam = Players[v]:GetTeam();
			for h, hv in pairs(playerTabs[jk]) do
				local nTeam = Players[hv]:GetTeam();
				if iTeam ~= nTeam then
					if not Teams[iTeam]:IsHasMet(nTeam) then
						MeetProperly(v, hv)
					end
				end
			end
		end	
		UpdateAllVotesLeague(niceUID)
	end
end

function IsHalfOrLessInLeague(uid, am)
	local t, n = 0, am or 0;
	for g, m in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			t = t + 1;
			if gT.Leagues[uid].Members[g] then
				n = n + 1;
			end
		end
	end
	return n <= (t / 2)
end

function AssignScriptedLeaguesTheHope()
	local gName = "League of Nations"
	local niceUID = "LeagueOfNations";
	gT.Leagues[niceUID] = {Members = {}, Vetos = {}, BreaksIfHalforLess = true, AISupportVal = 3, ActionCooldowns = {}, ProposalsEndTurn = {}, VotesPerAlliedCS = 1, NoVotesFromVoting = true, ActionLog = {}, FakeResolutions = {}, SpecialProposalTag = "LoN", DoFindepedent = true, HasInitialProposals = false, Name= gName, Resolutions = {}, Proposals = {}, ProposalsHistory = {}};
	
	gT.Leagues[niceUID].OrderOfResolutions = orderT;
	gT.Leagues[niceUID].TurnFoundString = GetTextDate(LastRandom(-700, -200), gT.Globals.StartDate)
	table.insert(gT.Leagues[niceUID].FakeResolutions, {Name = "Special rules", EnactedTurn = gT.Leagues[niceUID].TurnFoundString, ResID = 914})
	table.insert(gT.Leagues[niceUID].FakeResolutions, {Name = "Delegates", EnactedTurn = gT.Leagues[niceUID].TurnFoundString, ResID = 915})
	AddNewResolution(niceUID, 13) -- add cannot be repealed
	AddNewResolution(niceUID, 14) -- add cannot be repealed
	gT.Leagues[niceUID].Resolutions[13].CannotBeRepealed = true
	gT.Leagues[niceUID].Resolutions[14].CannotBeRepealed = true
--	gT.Leagues[niceUID].OrderOfResolutions = {[2] = 1, [5] = 1, [8] = 1, [11] = 1}; -- 15 etc. it is firing okay turn earlier
	gT.Leagues[niceUID].OrderOfResolutions = {[12] = 1, [37] = 1, [62] = 1, [87] = 1};
	for v, h in pairs(gT.Players) do
		if not Players[v]:IsMinorCiv() then
			AddAMemberToLeague(niceUID, v)
		end	
	end
	UpdateAllVotesLeague(niceUID)
end

function SpecialProposalsLeagueOfNationsL(player, type, leagueID)
	if (not gT.Leagues[leagueID].OrderOfResolutions[GetITGGameTurn()]) or (not gT.Leagues[leagueID].Members[player].ForcedResolution) then
		return {}
	end
	return GetSpecialResolutionsTab("LoN", leagueID, player, type)
end

function SpecialProposalsAncientL(player, type, leagueID)
	if type == 2 then
		return {}
	end
	if (not gT.Leagues[leagueID].OrderOfResolutions[GetITGGameTurn()]) or (not gT.Leagues[leagueID].Members[player].ForcedResolution) then
		return {}
	end
	return GetSpecialResolutionsTab("ancientL", leagueID, player, type)
end

function DoAIChooseAncientLeagueProposal(iPlayer, leagueID)
	local rtab = GetSpecialResolutionsTab("ancientL", leagueID, iPlayer, 1);
	local tab = {}
	for i, data in pairs(rtab) do
		if GetInfoFromTabOfProposal(data.ID, "ExtraListFunc") then
			local extraoptions = GetInfoFromTabOfProposal(data.ID, "ExtraListFunc")(leagueID, iPlayer, data.ID)
			local bestvalue, bestoption = -1, -1;
			for b, v in pairs(extraoptions) do
				local hID = data.ID .. "x" .. v.ExtraInfo;
				if not gT.Leagues[leagueID].Resolutions[hID] then
					local nval = GetInfoFromTabOfProposal(data.ID, "AIValueFunction")(iPlayer, leagueID, v.ExtraInfo, false, data.ID)
					if nval > bestvalue then
						bestvalue = nval;
						bestoption = v.ExtraInfo
					end
				end
			end
			if bestoption ~= -1 then
				table.insert(tab, {data.ID, valueR, bestoption})
			end
		else
			local valueR = GetInfoFromTabOfProposal(data.ID, "AIValueFunction")(iPlayer, leagueID, nil, false, data.ID);
			if valueR then
				table.insert(tab, {data.ID, valueR})
			end
		end
	end
	tab = Shuffle(tab)
	table.sort(tab, SortFunctionForGreaterInteger2)
	PlayerProposeChangeToLeague(leagueID, tab[1][1], iPlayer, tab[1][3], nil)
--	PlayerProposeSpecialChange(leagueID, tab[1][1], iPlayer, nil, specAnswers[tab[1][1]])
end

function DoAIChooseLeagueOfNationsProposal(iPlayer, leagueID)
	local rtab = GetSpecialResolutionsTab("LoN", leagueID, iPlayer);
--	local reptab = GetSpecialResolutionsTab("LoN", leagueID, iPlayer, 2);
	local tab = {}
	local bIgnoreExtraChoices = (LastRandom(1,3) == 2)
	for i, data in pairs(rtab) do
		if GetInfoFromTabOfProposal(data.ID, "ExtraListFunc") then
			if bIgnoreExtraChoices then
				local extraoptions = GetInfoFromTabOfProposal(data.ID, "ExtraListFunc")(leagueID, iPlayer, data.ID)
				local bestvalue, bestoption = -1, -1;
				for b, v in pairs(extraoptions) do
					local nval = GetInfoFromTabOfProposal(data.ID, "AIValueFunction")(iPlayer, leagueID, v.ExtraInfo, false, data.ID)
					if nval > bestvalue then
						bestvalue = nval;
						bestoption = v.ExtraInfo
					end
				end
				if bestoption ~= -1 then
					table.insert(tab, {data.ID, valueR, bestoption})
				end
			end
		else
			local valueR = GetInfoFromTabOfProposal(data.ID, "AIValueFunction")(iPlayer, leagueID, nil, false, data.ID);
			if valueR then
				table.insert(tab, {data.ID, valueR})
			end
		end
	end
	for res, resdata in pairs(gT.Leagues[leagueID].Resolutions) do
		if ((not resdata.ExtraInfo) and CanBeProposedRightNow(leagueID, res, 2, iPlayer)) or (resdata.ExtraInfo and IsValidOptionToRepeal(leagueID, res)) then
			local valueR = 100 - GetInfoFromTabOfProposal(resdata.ResID, "AIValueFunction")(iPlayer, leagueID, resdata.ExtraInfo, true, resdata.ResID);
			if valueR then
				table.insert(tab, {resdata.ResID, valueR, resdata.ExtraInfo})
			else
				print("No value for repeal?", res)
			end
		end
	end
	tab = Shuffle(tab)
	if #tab > 3 then
		for i = 1, 3 do
			table.remove(tab, i)
		end
	end
	table.sort(tab, SortFunctionForGreaterInteger2)
	PlayerProposeChangeToLeague(leagueID, tab[1][1], iPlayer, tab[1][3], nil)
end

function PrepareEndWarTable(leagueID)
	local adone = {}
	for member, h in pairs(gT.Leagues[leagueID].Members) do
		if (not gT.Players[member].IsConsideredBarbarian) and (Players[member]:GetNumCities() > 0) then
			for jmember, b in pairs(gT.Leagues[leagueID].Members) do
				if (not gT.Players[jmember].IsConsideredBarbarian) and (Players[jmember]:GetNumCities() > 0) then
					if member ~= jmember then
						if Teams[Players[member]:GetTeam()]:IsAtWar(Players[jmember]:GetTeam()) then
							if (not adone[member .. "x" .. jmember]) then
								if not ThisWarShouldNotBeForcedToPeace(member, jmember) then
									table.insert(gT.Leagues[leagueID].EndWarTable, {member, jmember})
									adone[jmember .. "x" .. member] = 1;
									adone[member .. "x" .. jmember] = 1;
								end
							end
						end
					end
				end
			end
		end
	end
end

function GetLeagueIdeologyPlayerForTenets(leagueID)
	if gT.Leagues[leagueID].Host then
		return gT.Leagues[leagueID].Host
	else
		for a, b in pairs(gT.Leagues[leagueID].Members) do
			if not Players[a]:IsMinorCiv() then
				return a;
			end
		end
	end
	print("Error 94345234")
end

function DoAddIdeologyLeagueVote(leagueID)
	if not gT.Leagues[leagueID] then
		return; -- could be defeated
	end
	local iPlayer = GetLeagueIdeologyPlayerForTenets(leagueID)
	local answerTab = GetTenetsToChooseFromLeague(iPlayer)
	if #answerTab == 5 then
		PlayerProposeSpecialChange(leagueID, 59, -1, answerTab)
	end
end

function GetModifierBasedOnNumMembers(a)
	if a < 2 then
		return 1;
	elseif a == 2 then
		return 0.55
	elseif a == 3 then
		return 0.4
	elseif a == 4 then
		return 0.32
	elseif a == 5 then
		return 0.26;
	else
		return 1 / (a - 1);
	end
end

local scSleepExtraIdeologyVoting = {[12] = true, [45] = true} --{[12] = true, [34] = true, [56] = true}
function DoScenarioScriptedResolutions(gTurn)
	if gT.Globals.ScenarioType == 5 then
		if scSleepExtraIdeologyVoting[gTurn] then
			gT.Globals.IdeologyVoting = {};
			local lTab = {}
			for leagues, sth in pairs(gT.Leagues) do
				if sth.SpecialProposalTag == "IdeologyL" then
					table.insert(lTab, {leagues, sth.BudgetTotal * GetModifierBasedOnNumMembers(sth.BaseMembers)})
					gT.Leagues[leagues].BudgetTotal = 0
				end
			end
			if #lTab > 0 then
				lTab = Shuffle(lTab)
				table.sort(lTab, SortFunctionForGreaterInteger2)
				DoAddIdeologyLeagueVote(lTab[1][1])
				local turnWait = math.min(5, math.floor(20 / (#lTab - 1)))
				table.remove(lTab, 1)
				for i, data in pairs(lTab) do
					gT.Globals.IdeologyVoting[gTurn + i * turnWait] = data[1]
				end
			end
		elseif gT.Globals.IdeologyVoting and gT.Globals.IdeologyVoting[gTurn] then
			DoAddIdeologyLeagueVote(gT.Globals.IdeologyVoting[gTurn])
		end
		if not gT.Globals.DominationOff then
			if gT.Globals.NextTotalWarSuggestion then
				if gT.Globals.NextTotalWarSuggestion == gTurn then
					local tTab = {}
					local numSides = 0;
					for l, sth in pairs(gT.Leagues) do
						if sth.SpecialProposalTag == "IdeologyL" then
							numSides = numSides + 1;
							for t, bhbh in pairs(gT.Leagues) do
								if bhbh.SpecialProposalTag == "IdeologyL" and l ~= t then
									if not sth.Resolutions[42 .. "x" .. t] then
										if not bhbh.Resolutions[42 .. "x" .. l] then --mirror are irrevelant
											table.insert(tTab, {l, t})
										end
									end
								end
							end
						end
					end
					if #tTab > 0 then
						local iExtraVotes = 5 + math.floor(GetITGGameTurn() / 4) -- extra push towards madness
						tTab = Shuffle(tTab)
						PlayerProposeSpecialChange(tTab[1][1], 42, -1, nil, tTab[1][2], true, iExtraVotes)
						if not gT.Globals.DominationOn then
							gT.Globals.NextTotalWarSuggestion = gTurn + math.max(4, LastRandom(7, 9) - numSides);
						else
							gT.Globals.NextTotalWarSuggestion = gTurn + math.max(4, LastRandom(12, 14) - numSides);
						end
					else
						gT.Globals.NextTotalWarSuggestion = -1;
					end
				end
			else
				gT.Globals.NextTotalWarSuggestion = LastRandom(6, 8);
			end
		end
		if not gT.Globals.EraDefPactsT then
			gT.Globals.EraDefPactsT = LastRandom(20,30);
		elseif gT.Globals.EraDefPactsT == gTurn then
			DoTriggerDefensivePact5thEra()
		end
	elseif gT.Globals.ScenarioType == 4 then
		if GetITGGameTurn() == 40 then
			if gT.Leagues["LeagueOfNations"] then
				PlayerProposeSpecialChange("LeagueOfNations", 50, -1, GetFiveBestIdeologiesRightNow("LeagueOfNations"))
			end
		end
	end
end

function GetFiveBestIdeologiesRightNow(league)
	local hTab = {{"A", 0}, {"R", 0}, {"F", 0}, {"L", 0}, {"O", 0}, {"E", 0}, {"S", 0}}
	for member, mdata in pairs(gT.Leagues[league].Members) do
		for i, t in pairs(hTab) do
			hTab[i][2] = t[2] + gT.Players[member].Ideologies[t[1]]
		end
	end
	hTab = Shuffle(hTab);
	table.sort(hTab, SortFunctionForGreaterInteger2)
	local fTab = {}
	for i = 1, 5 do
		table.insert(fTab, hTab[i][1]) 
	end
	return Shuffle(fTab);
end

function GetIdeologyLeagueOfPlayer(iPlayer)
	for l, h in pairs(gT.Leagues) do
		if h.Members[iPlayer] and h.SpecialProposalTag == "IdeologyL" then
			return l;
		end
	end
	return nil;
end

function DoTriggerDefensivePact5thEra()
	for l, h in pairs(gT.Leagues) do
		if h.SpecialProposalTag == "IdeologyL" then
			if not h.Resolutions[3] then
				HnGLogWorldWarEvents({Type = "Def", League = l})
				AddNewResolution(l, 3)
				for member, sth in pairs(h.Members) do
					if Players[member]:IsHuman() then
						Players[member]:AddNotification(NotificationTypes.NOTIFICATION_LEAGUE_VOTING_DONE, h.Name .. "'s delegates unanimously announced the signing of Defensive Pact to let the wolves out there know that we shall not forsake even the weakest of us in the need. The rumours are that our rivals have done the same scheme.", "Defensive Pact", -1, -1, -1)
					end
				end
			end
		end
	end
end