function RequestGT(bType, iDetail)
	gT.ITGTurn = GetITGGameTurn();
	local iPlayer = Game.GetActivePlayer();
	if bType and (gT.Players) and (gT.Players[iPlayer]) then
		if bType == 1 then
			AllTheTopPanelHelp(iPlayer)
		elseif bType == 2 then
			gT.Players[iPlayer].LHapAvailableToUse = GetAvailableHapForLegalAction(iPlayer)
			gT.Players[iPlayer].LFcost = GetLegalCostWithFaithSecular(iPlayer)
			MapModData.ITGSG2 = PrepareAllTheActionsAvailableToPlayer(iPlayer)
			MapModData.ITGSG3 = GetCodexUIData(iPlayer)
		elseif bType == 5 then
			DoRefreshAcademyForUI(iDetail)
		elseif bType == "TechTree" then
			gT.Players[iPlayer].TPInnovationChance = GetInnoChanceRightNow(iPlayer);
		elseif bType == "InfoCorner" then
			gT.Players[iPlayer].ICrailroadcost = GetCostOfRailroad(iPlayer)
			gT.Players[iPlayer].ICrailroadava = GetNumPossibleRailroadsToBeDone(iPlayer)
			gT.Players[iPlayer].ICgovcava = HasFreeLocationForGovernor(iPlayer)
		elseif bType == "Spy" then
			gT.Players[iPlayer].EspionagePurchaseCostOfAgent = GetCostOfNewAgent(iPlayer)
		elseif bType == "Milit" then
			gT.Players[iPlayer].CurrentNextGeneralTreshold = GetNextGeneralTresholdCost(iPlayer)
			gT.Players[iPlayer].CurrentNextAdmiralTreshold = GetNextAdmiralTresholdCost(iPlayer)
			MapModData.ITGSG2 = GetToolTipsForGGandGA(iPlayer)
		elseif bType == "LegalCost" then
			gT.Players[iPlayer].LHapAvailableToUse = GetAvailableHapForLegalAction(iPlayer)
		elseif bType == "HolySite" then
			gT.TmpInfo1 = GetHolySiteLevelTreshold(iDetail);
		end 
	end
	MapModData.ITGSG = gT;
end
LuaEvents.ITGSG_RequestGT.Add(RequestGT)

function RequestITGTurn()
	MapModData.ITGSG = GetITGGameTurn()
end
LuaEvents.ITGSG_RequestITGTurn.Add(RequestITGTurn)

function RequestITGYear(bYearOnly)
	MapModData.ITGSG = GetTextDate(GetITGGameTurn(), gT.Globals.StartDate, bYearOnly)
end
LuaEvents.ITGSG_RequestITGYear.Add(RequestITGYear)

LuaEvents.ITGSG_RequestMercenaries.Add(function()
	MapModData.ITGSG = gT.Mercenaries;
end)

LuaEvents.ITGSG_RequestRewardsStringOfAcademy.Add(function(index)
	RequestStringAcademyReward(index)
end)

function RequestUnitClassPromotions(iPlayer, iClass)
	MapModData.ITGSG = GetAllNiceInfoForClassPromotion(iPlayer, iClass)
end
LuaEvents.ITGSG_RequestUnitClassPromData.Add(RequestUnitClassPromotions)

function RequestAutomaticFaithPurchase()
	if gT.Players[Game.GetActivePlayer()] then
		MapModData.ITGSG = {gT.Players[Game.GetActivePlayer()].AutomaticFaithPurchase or false, gT.Players[Game.GetActivePlayer()].AutomaticMissionaries or false};
	end
end
LuaEvents.ITGSG_RequestAutomaticFaithPurchase.Add(RequestAutomaticFaithPurchase)

function SetAutomaticFaithPurchase()
	gT.Players[Game.GetActivePlayer()].AutomaticFaithPurchase = (not gT.Players[Game.GetActivePlayer()].AutomaticFaithPurchase);
	if Players[Game.GetActivePlayer()]:IsTurnActive() then
		DoAutomaticTemplarBuildingPurchase(Game.GetActivePlayer())
	end
end
LuaEvents.ITGSG_SetAutomaticFaithPurchase.Add(SetAutomaticFaithPurchase)

function SetAutomaticMissionaries()
	gT.Players[Game.GetActivePlayer()].AutomaticMissionaries = (not gT.Players[Game.GetActivePlayer()].AutomaticMissionaries);
	if Players[Game.GetActivePlayer()]:IsTurnActive() then
		DoAutomaticMissionaries(Game.GetActivePlayer())
	end
end
LuaEvents.ITGSG_SetAutomaticMissionaries.Add(SetAutomaticMissionaries)

function RequestPlayerData(iPlayer)
	if not iPlayer then
		gT.Players[Game.GetActivePlayer()].ITGTurn = GetITGGameTurn();
		MapModData.ITGSG = gT.Players[Game.GetActivePlayer()];
	else
		gT.Players[iPlayer].ITGTurn = GetITGGameTurn();
		MapModData.ITGSG = gT.Players[iPlayer];
	end
end
LuaEvents.ITGSG_RequestPD.Add(RequestPlayerData)

function PrepareVPTable()
	local hTable = {}
	for iplayer, data in pairs(gT.Players) do
		hTable[iplayer] = data.VictoryPoints;
	end
	MapModData.ITGSG = hTable;
end
LuaEvents.ITGSG_RequestVictoryPoints.Add(PrepareVPTable)

function ReturnCityData(pCity)
	MapModData.ITGSG = gT.Cities[pCity:Plot():GetPlotIndex() .. "," .. pCity:GetGameTurnFounded()];
end
LuaEvents.ITGSG_RequestCityData.Add(ReturnCityData)

function InfoCityBannerRequest(iCity)
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	if gT.Cities[cID] then
		local iPlayer = iCity:GetOwner();
		local hTab = {Main = gT.Cities[cID]}
		local tText = "";
		local present, isdominant, highest = SortReligionsAndCheckDominant(gT.Cities[cID].Religions);
		if gT.Cities[cID].HolyCity then
			tText = tText .. "This is a Holy City of:[NEWLINE]"
			local mysterycult = false;
			for it, relID in pairs(gT.Cities[cID].HolyCity) do
				local name = GetReligionNameOrUnknown(iPlayer, relID)
				if (name ==  "Mysterious Cult") then
					mysterycult = true;
				else
					tText = tText .. "[NEWLINE][ICON_BULLET]" .. name;
				end
			end
			if mysterycult then
				tText = tText .. "[NEWLINE][ICON_BULLET]Unknown Cult";
			end
			tText = tText .. "[NEWLINE][NEWLINE]";
		end
		if isdominant == 2 then
			tText = tText .. GetReligionNameOrUnknown(iPlayer, highest) .. " is dominant religion in this city.[NEWLINE]"
			hTab.Icon = gT.Religions[highest].IconIndex;
			hTab.Atlas =  gT.Religions[highest].IconAtlas;
			if gT.Religions[highest].Founder then
				if not Teams[Players[iPlayer]:GetTeam()]:IsHasMet(Players[gT.Religions[highest].Founder]:GetTeam()) then
					hTab.Icon = 11;
					hTab.Atlas = "RELIGION_ATLAS_WHITE";
				end
			end
		elseif isdominant == 1 then
			tText = tText .. "There is no dominant Religion in this city.[NEWLINE]"
			hTab.Icon = 11;
			hTab.Atlas = "RELIGION_ATLAS_WHITE";
		end
		local total = 100;
		for it, data in pairs(present) do
			local name = GetReligionNameOrUnknown(iPlayer, data[1]);
			if (data[1] == highest) then
--			if (data[1] == highest) or (name ~=  "Mysterious Cult") then
				tText = tText .. "[NEWLINE][ICON_BULLET]" .. name .. ": " .. data[2] .. "%";
				total = total - data[2]
			end
		end
		if total > 0 then
			tText = tText .. "[NEWLINE][ICON_BULLET]Minor Cults or Heathens: " .. total .. "%";
		end
		if "" ~= gT.Cities[cID].BeliefEffectHelpString then
			tText = tText .. "[NEWLINE][NEWLINE]Active Beliefs:[NEWLINE]" .. gT.Cities[cID].BeliefEffectHelpString
		end
		hTab.Tooltip = tText;
		MapModData.ITGSG = hTab;
	end
end
LuaEvents.ITGSG_RequestCityBannerInfo.Add(InfoCityBannerRequest)

function InfoReligionUnitPanel(iUnit)
	local iPlayer = iUnit:GetOwner();
	local uID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
	if gT.Players[iPlayer].UnitsByID[uID] then
		if gT.Players[iPlayer].UnitsByID[uID].Religions then
			local iPlayer = iUnit:GetOwner();
			local hTab = {}
			local tText = "";
			local present, isdominant, highest = SortReligionsAndCheckDominant(gT.Players[iPlayer].UnitsByID[uID].Religions);
			if isdominant == 2 then
				tText = tText .. GetReligionNameOrUnknown(iPlayer, highest) .. " is dominant religion of this unit.[NEWLINE]"
				hTab.Icon = gT.Religions[highest].IconIndex;
				hTab.Atlas =  gT.Religions[highest].IconAtlas;
		
				if gT.Religions[highest].Founder then
					if not Teams[Players[iPlayer]:GetTeam()]:IsHasMet(Players[gT.Religions[highest].Founder]:GetTeam()) then
						hTab.Icon = 11;
						hTab.Atlas = "RELIGION_ATLAS_WHITE";
					end
				end
			else
				tText = tText .. "There is no dominant Religion in this unit.[NEWLINE]"
				hTab.Icon = 11;
				hTab.Atlas = "RELIGION_ATLAS_WHITE";
			end
			local total = 100;
			for it, data in pairs(present) do
				local name = GetReligionNameOrUnknown(iPlayer, data[1]);
				if (data[1] == highest) then
--				if (data[1] == highest) or (name ~=  "Mysterious Cult") then
					tText = tText .. "[NEWLINE][ICON_BULLET]" .. name .. ": " .. data[2] .. "%";
					total = total - data[2]
				end
			end
			if total > 0 then
				tText = tText .. "[NEWLINE][ICON_BULLET]Minor Cults or Heathens: " .. total .. "%";
			end
			if "" ~= gT.Players[iPlayer].UnitsByID[uID].BeliefEffectHelpString then
				tText = tText .. "[NEWLINE][NEWLINE]Active Beliefs:[NEWLINE]" .. gT.Players[iPlayer].UnitsByID[uID].BeliefEffectHelpString;
			end
			hTab.Tooltip = tText;
			MapModData.ITGSG = hTab;
		end
	end
end
LuaEvents.ITGSG_RequestUnitPanelReligionInfo.Add(InfoReligionUnitPanel)

function OnLoadScreenRemoveVisionModifier()
	local iPlayer = Game.GetActivePlayer();
	local iTeam = Game.GetActiveTeam();
--	for g, h in pairs(gT.Players) do
--		local tTeam = Players[g]:GetTeam();
--		for it, index in pairs(h.BeforeLoadVisionModifier or {}) do
--			Map.GetPlotByIndex(index):ChangeVisibilityCount(tTeam, -1);
--			if g == iPlayer then
--				Map.GetPlotByIndex(index):UpdateFog()
--			end
--		end
--		gT.Players[g].BeforeLoadVisionModifier = {}
--	end
	if gT.Globals.RequiresReligionReconvert then
		gT.Globals.RequiresReligionReconvert  = false;
		for g, gdata in pairs(gT.Players) do
		--	if gdata.OfficialReligion then
				for jCity in Players[g]:Cities() do
					jCity:AddReligiousPressure(9, jCity:GetReligiousMajority(), 1,  g)
				end
		--	end
		end
	end
	Events.SerialEventCityInfoDirty()
	if gT.Globals.JustGenerated then
		LuaEvents.ITGRemoveAllNotifications()
		gT.Globals.JustGenerated = nil;
	end
end
LuaEvents.ITGSGPlayerClosedLoadScreen.Add(OnLoadScreenRemoveVisionModifier)


function ITGPlayerChoosesUnitPromotion(unit, void1)
	if CanPlayerHavePromotion( unit:GetOwner(), unit:GetUnitClassType()) then
		PlayerChoosesPromotionForClass(unit:GetUnitClassType(), unit:GetOwner(), void1)
	end
end
LuaEvents.ITG_PlayerChoosesUnitPromotion.Add(ITGPlayerChoosesUnitPromotion)

function ITGPlayerChoosesUnitClassProm(promID, iclass, player)
	PlayerChoosesPromotionForClass(iclass, player, promID)
end
LuaEvents.ITG_PlayerChoosesUnitclassProm.Add(ITGPlayerChoosesUnitClassProm)


function ITGRequestedInfoCornerHighlightData(iPlayer, type)
	if type == 1 then
		HighlightProperUnitsForGreatGeneral(iPlayer)
	elseif type == 2 then
		HighlightProperUnitsForGreatAdmiral(iPlayer)
	elseif type == 3 then
		HighlightProperPlotForNewFort(iPlayer)	
	elseif type == 4 then
		HighlightProperPlotForMissionary(iPlayer)
	elseif type == 5 then
		HighlightProperPlotForColonies(iPlayer)
	elseif type == 6 then
		HighlightProperPlotForInquisitors(iPlayer)
	elseif type == 7 then
		HighlighProperPlotsForHolySites(iPlayer)
	elseif type == 8 then
		HighlighProperPlotsForShinobiVisionModifier(iPlayer)
	elseif type == 9 then
		HighlighProperPlotsForMesoSGRModifier(iPlayer)
	elseif type == 10 then
		HighlighProperPlotsForMesoElDorado(iPlayer)
	elseif type == 11 or type == 12 or type == 13 then
		HighlightProperPlotsForGreatImprovement(iPlayer, type)
	elseif type == 14 then
		HighlightProperPlotsForSettlerAction(iPlayer)
	elseif type == 15 then
		HighlightProperPlotsForFestivaAction(iPlayer)
	elseif type == 16 then
		HighlightProperPlotsForRailroad(iPlayer)
	elseif type == 17 then
		HighlightProperPlotsForMilitaryEngineer(iPlayer)
	elseif type == 18 then
		HighlighProperPlotsForReconVisionModifier(iPlayer)
	elseif type == 20 then
		HighlightProperPlotsForSupportPromotion(iPlayer, GameInfoTypes.PROMOTION_ITG_BATTERING_RAM_SUPPORT)
	elseif type == 21 then
		HighlightProperPlotsForSupportPromotion(iPlayer, GameInfoTypes.PROMOTION_ITG_SIEGE_TOWER_SUPPORT)
	elseif type == 23 then
		HighlightProperPlotsSatellite(iPlayer)
	elseif type == 24 then
		HighlighProperPlotsResMovement(iPlayer)
	elseif type == 26 then
		HighlightChateauLocations(iPlayer)
	elseif type == 27 then
		HighlightFeitoriaLocations(iPlayer)
	end
end
LuaEvents.ITGSG_RequestHighlightData.Add(ITGRequestedInfoCornerHighlightData)

LuaEvents.ITG_InfoCornerClickedPlot.Add(function(pPlot, type, iPlayer, bControl)
	if type == 1 then
		PlayerAssignGeneralOnPlot(pPlot, iPlayer)
	elseif type == 2 then
		PlayerAssignAdmiralOnPlot(pPlot, iPlayer)
	elseif type == 3 then
		PlayerChosesFortUpgradeOrNewOnPlot(pPlot, iPlayer)
	elseif type == 4 then
		PlayerChoosesPlotForMissionary(pPlot, iPlayer, bControl)
	elseif type == 5 then
		PlayerChooseColonyOnPlot(pPlot, iPlayer)
	elseif type == 6 then
	elseif type == 7 then
		PlayerChooseHolySiteOnPlot(pPlot, iPlayer)
	elseif type == 8 then
		PlayerChooseShinobiModifierOnPlot(pPlot, iPlayer)
	elseif type == 9 then
		PlayerChooseMesoSGROnPlot(pPlot, iPlayer)
	elseif type == 10 then
		PlayerChooseElDoradoOnPlot(pPlot, iPlayer)
	elseif type == 11 or type == 12 or type == 13 then
		PlayerChooseGreatImprovementOnPlot(pPlot, iPlayer, type)
	elseif type == 14 then
		PlayerChooseSettlerPointOnPlot(pPlot, iPlayer)
	elseif type == 15 then
		PlayerChooseFestivalPointOnPlot(pPlot, iPlayer)
	elseif type == 16 then
		PlayerChooseRailroadOnPlot(pPlot, iPlayer)
	elseif type == 17 then
		PlayerChooseMilitaryEngineerOnPlot(pPlot, iPlayer)
	elseif type == 18 then
		PlayerChooseReconOnPlot(pPlot, iPlayer)
	elseif type == 20 then
		AddSiegeSupportPromOnPlot(iPlayer, pPlot, GameInfoTypes.PROMOTION_ITG_BATTERING_RAM_SUPPORT)
	elseif type == 21 then
		AddSiegeSupportPromOnPlot(iPlayer, pPlot, GameInfoTypes.PROMOTION_ITG_SIEGE_TOWER_SUPPORT)
	elseif type == 23 then
		HumanRepositionSatellite(iPlayer, pPlot)
	elseif type == 24 then
		HumanWantsResMovement(iPlayer, pPlot)
	elseif type == 26 then
		HumanWantsChateau(iPlayer, pPlot)
	elseif type == 27 then
		HumanWantsFeitoria(iPlayer, pPlot)
	end
	RefreshAllDirtyPlayer()
end)

function RefreshAllDirtyPlayer()
	Events.OpenInfoCorner()
	Events.SerialEventEndTurnDirty()
	Events.SerialEventCityInfoDirty()
	LuaEvents.ITGSGTopPanelDirty()
end
LuaEvents.ITG_RequestAllDirtyPlayer.Add(RefreshAllDirtyPlayer)

function IfActiveThenRefreshDirty(iPlayer)
	if Game.GetActivePlayer() == iPlayer then
		RefreshAllDirtyPlayer()
	end
end

function CheckIfCanFinishGame(playerID)
	local data, bool = {}, false;
	local iPlayer = playerID or Game.GetActivePlayer();
	for type, extradata in pairs(gT.Players[iPlayer].HumanQueueActions) do
		table.insert(data, {Text = type, Tooltip = extradata.Tooltip})
	end
	for i, newextradata in pairs(gT.Players[iPlayer].NewHumanQueueActions) do
		table.insert(data, {Text = newextradata.Text, Tooltip = newextradata.Tooltip})
	end
	for i, queue in pairs(gT.Players[iPlayer].CultureBonusQueue) do
		table.insert(data, {Text = "CHOOSE SOCIAL BONUS", Tooltip = "You have to decide about next social development of your people."})
	end
	for i, quue in pairs(gT.Players[iPlayer].TechChooseDecisions) do
		table.insert(data, {Text = "CHOOSE TECHNOLOGY", Tooltip = "Please choose a new Technology."})
	end
	for i, quue in pairs(gT.Players[iPlayer].BeliefChooseDecisions) do
		table.insert(data, {Text = "CHOOSE BELIEF", Tooltip = "Please choose a new Belief."})
	end
	if gT.Players[iPlayer].IsPickingIdeology then
		table.insert(data, {Text = "FORGE IDEOLOGY", Tooltip = "Please choose a new Ideological Tenet."})
	end
	if CanUpgradeAnyPalace(iPlayer) then
		table.insert(data, {Text = "EXPAND PALACE", Tooltip = "Please choose next area to expand a Palace."})
	end
	if gT.Globals.StockActive then
		if CanPlayerEnterStockExchange(iPlayer) then
			if gT.Players[iPlayer].MasterOfCoin then
				DoMakeAIInvestments(iPlayer)
			end
			if gT.Players[iPlayer].StockInvestAvailable > 0 then
				table.insert(data, {Text = "MAKE INVESTMENTS", Tooltip = "Please choose sectors worthy an investment."})
			end 
		end
	end
	if #gT.Players[iPlayer].DiploNotes > 0 then
		table.insert(data, {Text = "ANSWER DIPLO NOTE", Tooltip = "Please resolve diplomatic action."})
	end
	for g, h in pairs(gT.Manufactories) do
		if #h.ToChoose > 0 then
			if h.Player == playerID then
				table.insert(data, {Text = "MANUFACTORY BONUS", Tooltip = "Please choose a trait for Manufactory."})
				break;
			end
		end
	end
	local bAnyResolutionAlready = false;
	for leagueNID, sth in pairs(gT.Leagues) do
		if sth.Members[playerID] then
			if sth.HasInitialProposals then
				if (not sth.Members[playerID].InitProposal) then
					if #GetTabOfValidVoteResolutions(leagueNID) > 0 then
						table.insert(data, {Text = "CHOOSE RESOLUTION", Tooltip = "Please define your goals in new League."})
					else
						gT.Leagues[leagueNID].Members[playerID].InitProposal = true;
					end
				end
			elseif (sth.Members[playerID].ForcedResolution == GetITGGameTurn()) then
				table.insert(data, {Text = "CHOOSE RESOLUTION", Tooltip = "Please set the direction for your League."})
			end
			for hString, pData in pairs(sth.Proposals) do
				if pData.ProposedBy ~= playerID then
					if not bAnyResolutionAlready then
						if (not pData.PlayersAnswers[playerID]) and (not pData.Delayed) then
							table.insert(data, {Text = "ANSWER RESOLUTION", Tooltip = "Please answer to the proposed resolution(s)."})
							bAnyResolutionAlready = true;
						end
					end
				elseif pData.ProposalStrength == -1 then
					table.insert(data, {Text = "SET RESOLUTION", Tooltip = "Please define your determination to pass resolution."})	
				end
			end
		end
	end
	if DBScenario.GoldBudgetOnly then
		if gT.Players[playerID].BudgetPoints > 0 then
			table.insert(data, {Text = "DEFINE BUDGET", Tooltip = "Please complete your Budget declaration."})
		end
	end
	for leagueNID, sth in pairs(gT.Players[playerID].InvitationsLeague) do
		if gT.Leagues[leagueNID] then
			table.insert(data, {Text = "LEAGUE INVITATION", Tooltip = "You have received invitation to the new league."})
		else
			gT.Players[playerID].InvitationsLeague[leagueNID] = nil;
		end
	end
	MapModData.ITGSG = data;
end
LuaEvents.ITGCanEndTurn.Add(CheckIfCanFinishGame)

function RearrangeGreatPeople(iPlayer, type)
	if type == 1 then
	--general
		table.insert(gT.Players[iPlayer].ReservedGenerals, gT.Players[iPlayer].ReservedGenerals[1])
		table.remove(gT.Players[iPlayer].ReservedGenerals, 1)
	elseif type == 2 then
	--admiral
		table.insert(gT.Players[iPlayer].ReservedAdmirals, gT.Players[iPlayer].ReservedAdmirals[1])
		table.remove(gT.Players[iPlayer].ReservedAdmirals, 1)
	end
end
LuaEvents.ITGSG_RearrangeGreatPeople.Add(RearrangeGreatPeople)

local ovSNDsbc;
function SetSoundToPlayerOnSBC(str)
	ovSNDsbc = str;
end

function SimpleBonusChoose(iPlayer, confirminfo1, confirminfo2, confirminfo3, confirminfo4)
	local sndrtn;
	ovSNDsbc = nil;
	if confirminfo1 == "BonusGeneral" then
		HumanPlayerChooseGeneralBonus(iPlayer, confirminfo2, confirminfo3, confirminfo4)
		sndrtn = "AS2D_IF_MILITARY_ADVISOR_STING"
	elseif confirminfo1 == "BonusAdmiral" then
		HumanPlayerChooseAdmiralBonus(iPlayer, confirminfo2, confirminfo3, confirminfo4)
		sndrtn = "AS2D_IF_MILITARY_ADVISOR_STING"
	elseif confirminfo1 == "BonusScience" then
		HumanPlayerChooseScienceBonus(iPlayer, confirminfo2, confirminfo3, confirminfo4)
		sndrtn = "AS2D_IF_SCIENCE_ADVISOR_STING"
	elseif confirminfo1 == "BonusCulture" then
		HumanPlayerChooseCultureBonus(iPlayer, confirminfo2, confirminfo3, confirminfo4)
		sndrtn = PlayRandomGWoM(iPlayer)
	elseif confirminfo1 == "BonusFaith" then
		HumanPlayerChooseFaithBonus(iPlayer, confirminfo2, confirminfo3, confirminfo4)
		sndrtn = "AS2D_INTERFACE_FAITH_PURCHASE"
		--AS2D_INTERFACE_RELIGION_ACTIVATE
	elseif confirminfo1 == "ChooseTechnology" then
		HumanPlayerChooseTechnology(iPlayer, confirminfo2, confirminfo3, confirminfo4)
	elseif confirminfo1 == "ChooseBelief" then
		HumanPlayerChooseBelief(iPlayer, confirminfo2, confirminfo3, confirminfo4)
		sndrtn = "AS2D_INTERFACE_RELIGION_ACTIVATE"
	elseif confirminfo1 == "ChoosePantheon" then
		HumanPlayerDoAddNewPantheonType(iPlayer, confirminfo2, confirminfo3, confirminfo4)
		sndrtn = "AS2D_INTERFACE_RELIGION_ACTIVATE"
	elseif confirminfo1 == "InnovationBonus" then
		HumanPlayerChooseInnovation(iPlayer, confirminfo2, confirminfo3, confirminfo4)
		sndrtn = "AS2D_IF_ECONOMIC_ADVISOR_STING"
		DoTriggerSoundFromTech(iPlayer, nil)
	elseif confirminfo1 == "ChooseTalentGP" then
		HumanPlayerChooseGPTalent(iPlayer, confirminfo2, confirminfo3, confirminfo4)
	elseif confirminfo1 == "TemplarBelief" then
		PlayerChooseTemplarBelief(iPlayer, confirminfo2, confirminfo3, true)
		if Players[iPlayer]:IsTurnActive() then
			DoAutomaticTemplarBuildingPurchase(iPlayer)
		end
		sndrtn = "AS2D_INTERFACE_RELIGION_ACTIVATE"
	elseif confirminfo1 == "SpecialUU" then
		HumanChooseSpecialUU(iPlayer, confirminfo2, confirminfo3)
		sndrtn = "AS2D_IF_MILITARY_ADVISOR_STING"
	elseif confirminfo1 == "Inspiration" then
		AddInspirationToBuildingClass(iPlayer, confirminfo2, confirminfo3, true)
		if confirminfo3 == GameInfoTypes.BUILDINGCLASS_STABLE then
			LuaEvents.ITG_AchievementCompleted(61)
		end
	elseif confirminfo1 == "TradeRoute" then
		HumanPlayerChooseTradeRouteTarget(iPlayer, confirminfo2, confirminfo3, confirminfo4)
	elseif confirminfo1 == "PredictTask" then
		HumanPlayerPredictTask(iPlayer, confirminfo2, confirminfo3, confirminfo4)
	elseif confirminfo1 == "Department" then
		HumanPlayerChoosesAcademyBonus(iPlayer, confirminfo2, confirminfo3, confirminfo4)
	elseif confirminfo1 == "GovPrinciple" then
		HumanPlayerChoosesGovPrinciple(iPlayer, confirminfo2, confirminfo3)
	end
	RefreshAllDirtyPlayer()
	MapModData.ITGSG = ovSNDsbc or sndrtn;
end
LuaEvents.ITGSG_HumanChooseSimpleBonus.Add(SimpleBonusChoose)

LuaEvents.ITG_PlayerChooseIdeologyTenet.Add(function(void1)
	PlayerChooseIdeologyTenet(Game.GetActivePlayer(), void1, true)
	RefreshAllDirtyPlayer()
end)

function NewHumanChooseCultureBonus(iPlayer, cType)
	local lKey;
	for a, b in pairs(gT.Players[iPlayer].CultureBonusQueue) do
		if b == 2 then -- prioritize replace
			lKey = a;
			break;
		elseif not lKey then
			lKey = a;
		end
	end
	local bType = gT.Players[iPlayer].CultureBonusQueue[lKey];
	if bType == 2 then
		gT.Players[iPlayer].LHRechosenCB = gT.Players[iPlayer].LHRechosenCB + 1;
		AddCultureBonusToPlayer(iPlayer, cType, bType)
	elseif bType == 1 then
		table.insert(gT.Globals.GrandCultBonusVote[GetITGGameTurn()], {iPlayer, cType}) 
	end
	table.remove(gT.Players[iPlayer].CultureBonusQueue, lKey);
	RefreshAllDirtyPlayer()
end
LuaEvents.ITGSG_HumanChooseCultureBonus.Add(NewHumanChooseCultureBonus)

function LegalActionChoose(iPlayer, confirminfo1, confirminfo2, confirminfo3, confirminfo4)
	PushLegalActionForPlayer(iPlayer, confirminfo1, confirminfo2, confirminfo3, confirminfo4)
	RefreshAllDirtyPlayer()
end
LuaEvents.ITGSG_HumanChooseLegalAction.Add(LegalActionChoose)

LuaEvents.ITGSG_RequestCityViewData.Add(function(pCity)
	GenerateAllTheTextForCityView(pCity)
end)
	
LuaEvents.ITGSG_CallTheTopPanelQueue.Add(function()
	gT.Players[Game.GetActivePlayer()].TopPanelQueueStack = MapModData.ITGSG
	MapModData.ITGSG = nil;
end)

LuaEvents.RequestUnitCombatBonusesForPanel.Add(function(iUnit, bIsDefending, sUnit, sCity, bRanged)
	MapModData.ITGSG = GetPreparedCombatBonusesForUnit(iUnit, bIsDefending, sUnit, sCity, bRanged)
end)

LuaEvents.ITGSG_RequestToolTipHelp.Add(function(type, city)
	AskForNiceToolTipsCities(type, city)
end);

local IsTemplarBuilding = {}
for i = 1, 500 do
	if GameInfoTypes["BUILDING_ITG_BELIEF_TEMPLE_" .. i] then
		IsTemplarBuilding[GameInfoTypes["BUILDING_ITG_BELIEF_TEMPLE_" .. i]] = 1;
	else
		break;
	end
end
LuaEvents.ITGSG_RequestBuildingUniqueName.Add(function(iBuilding, city, bShort, process)
	local uniquename;
	-- in this case city can be nil!!!
	if process then
		if process == GameInfoTypes.PROCESS_ITG_SHINOBI_PROCESS then
			uniquename = "Agent (" .. gT.Players[Game.GetActivePlayer()].ShinobiProcess .. "[ICON_PRODUCTION])";
		elseif process == GameInfoTypes.PROCESS_ITG_KRONBORG_FORT_PROCESS then
			uniquename = "Fort Construction (" .. gT.Players[Game.GetActivePlayer()].KronborgProcess .. "[ICON_PRODUCTION])";
		elseif process == GameInfoTypes.PROCESS_ITG_KRONBORG_FORT_PROCESS then
			uniquename = "Trial and Error (" .. gT.Players[Game.GetActivePlayer()].InnoProcess .. "/" .. DBScenario.InnovationProcessCost .. "[ICON_PRODUCTION])"
		elseif gT.Globals.CityStateBuildingProcesses[process] then
			local gActive = Game.GetActivePlayer();
			local cSup = 0;
			local endT = 0;
			local cs = gT.Globals.CityStateBuildingProcesses[process];
			for i, quest in pairs(gT.Players[cs].CityStateQuests) do
				if quest.Active then
					if quest.ActivePlayers[gActive] then
						cSup = quest.ActivePlayers[gActive].ProjectDonated or 0;
						endT = quest.EndTurn;
					end
				end
			end
			uniquename = "Support " .. Players[cs]:GetName() .. " (" .. cSup .."[ICON_PRODUCTION], " .. endT .. "T)"
		elseif process == GameInfoTypes.PROCESS_ITG_TEMPLAR_PROJECT then
			if city then
				local iRel = city:GetReligiousMajority();
				if gT.TemplarBonus[iRel] then
					if bShort then
						uniquename = "Temple of " .. Locale.Lookup(Game.GetReligionName(iRel));
					else
						--decided this way
						uniquename = "Temple of " .. Locale.Lookup(Game.GetReligionName(iRel)) .. " ([COLOR_POSITIVE_TEXT]" .. (gT.TemplarBonus[iRel].PlayerContribution[city:GetOwner()] or 0) .. "[ENDCOLOR]/" .. gT.TemplarBonus[iRel].Total .. "/" .. gT.TemplarBonus[iRel].Needed .. "[ICON_PRODUCTION])";
					end
				end
			end
		elseif GetLeagueResOutOfProcess(process) then
			uniquename = GetLeagueProjectDataHelp(GetLeagueResOutOfProcess(process), nil, 1)
		end
	else
		if IsTemplarBuilding[iBuilding] then
			if gT.TemplarNames[iBuilding] then
				uniquename = Locale.Lookup(GameInfo.Buildings[iBuilding].Description) .. " of " .. Locale.Lookup(Game.GetReligionName( gT.TemplarNames[iBuilding]));
			end
		end
	end
	MapModData.ITGSG = uniquename;
end)

LuaEvents.ITGSG_RequestTextForCityProduction.Add(function(iBuilding, iUnit, pCity, iProcess)
	local uniquename;
	if (iProcess ~= -1) then
		if iProcess == GameInfoTypes.PROCESS_ITG_SHINOBI_PROCESS then
			uniquename = {"Agent" ,"(" .. gT.Players[pCity:GetOwner()].ShinobiProcess .. "[ICON_PRODUCTION])"};
		elseif iProcess == GameInfoTypes.PROCESS_ITG_KRONBORG_FORT_PROCESS then
			uniquename = {"Fort Construction", "(" .. gT.Players[pCity:GetOwner()].KronborgProcess .. "[ICON_PRODUCTION])"};
		elseif iProcess == GameInfoTypes.PROCESS_LS_PROJECT_INNOVATION then
			uniquename = {"Trial and Error", "(" .. gT.Players[pCity:GetOwner()].InnoProcess .. "/" .. DBScenario.InnovationProcessCost .. "[ICON_PRODUCTION])"};
		elseif gT.Globals.CityStateBuildingProcesses[iProcess] then
			local gActive = pCity:GetOwner();
			local cSup = 0;
			local endT = 0;
			local cs = gT.Globals.CityStateBuildingProcesses[iProcess];
			for i, quest in pairs(gT.Players[cs].CityStateQuests) do
				if quest.Active then
					if quest.ActivePlayers[gActive] then
						cSup = quest.ActivePlayers[gActive].ProjectDonated or 0;
						endT = quest.EndTurn;
					end
				end
			end
			uniquename = {"Support " .. Players[cs]:GetName(), "(" .. cSup .."[ICON_PRODUCTION], " .. endT .. "T)"}
		elseif iProcess == GameInfoTypes.PROCESS_ITG_TEMPLAR_PROJECT then
			if city then
				local iRel = city:GetReligiousMajority();
				if gT.TemplarBonus[iRel] then
					uniquename = {"Temple of " .. Locale.Lookup(Game.GetReligionName(iRel)), " ([COLOR_POSITIVE_TEXT]" .. (gT.TemplarBonus[iRel].PlayerContribution[city:GetOwner()] or 0) .. "[ENDCOLOR]/" .. gT.TemplarBonus[iRel].Total .. "[ICON_PRODUCTION])"};
				end
			end
		elseif GetLeagueResOutOfProcess(iProcess) then
			uniquename = GetLeagueProjectDataHelp(GetLeagueResOutOfProcess(iProcess), pCity:GetOwner(), 2)
		end
	else
		if IsTemplarBuilding[iBuilding] then
			if gT.TemplarNames[iBuilding] then
				uniquename = {Locale.Lookup(GameInfo.Buildings[iBuilding].Description) .. " of " .. Locale.Lookup(Game.GetReligionName( gT.TemplarNames[iBuilding]))};
			end
		end
	end
	MapModData.ITGSG = uniquename;
end)

LuaEvents.ITGSG_RequestProcessUniqueNameHelp.Add(function(iProcess, city)
	local uniquename;
	if not gT.Players[city:GetOwner()] then
		return;
	end
	if gT.Globals.CityStateBuildingProcesses[iProcess] then
		local gActive = city:GetOwner();
		local cSup = 0;
		local cs = gT.Globals.CityStateBuildingProcesses[iProcess];
		local turnend = 0;
		for i, quest in pairs(gT.Players[cs].CityStateQuests) do
			if quest.Active then
				if quest.ActivePlayers[gActive] then
					cSup = quest.ActivePlayers[gActive].ProjectDonated or 0;
					turnend = quest.EndTurn;
				end
			end
		end
		uniquename = "Helping " .. Players[cs]:GetName() .. " in construction project (" .. cSup .."[ICON_PRODUCTION], " .. turnend .. "T)"
	elseif iProcess == GameInfoTypes.PROCESS_ITG_TEMPLAR_PROJECT then
		local iRel = city:GetReligiousMajority();
		if gT.TemplarBonus[iRel] then
			uniquename = "Grants Templar Belief to " .. GameInfo.Religions[iRel].IconString .. " " .. Locale.Lookup(Game.GetReligionName(iRel)) .. " ([COLOR_POSITIVE_TEXT]" .. (gT.TemplarBonus[iRel].PlayerContribution[city:GetOwner()] or 0) .. "[ENDCOLOR]/" .. gT.TemplarBonus[iRel].Total .. "/" .. gT.TemplarBonus[iRel].Needed .. "[ICON_PRODUCTION])";
		end
	elseif iProcess == GameInfoTypes.PROCESS_ITG_WONDER then
		uniquename = "Compete for the privilige of constructing next World Wonder. (" .. gT.Players[city:GetOwner()].WonderProduction .. " [ICON_PRODUCTION])";
	elseif iProcess == GameInfoTypes.PROCESS_ITG_SHINOBI_PROCESS then
		uniquename = "Grants new Agent (" .. gT.Players[city:GetOwner()].ShinobiProcess .. "/" .. SHINOBI_PROCESS_TRESHOLD .. "[ICON_PRODUCTION])";
	elseif iProcess == GameInfoTypes.PROCESS_LS_PROJECT_INNOVATION then
		uniquename = "Grants an Innovation (" .. gT.Players[city:GetOwner()].InnoProcess .. "/" .. DBScenario.InnovationProcessCost .. "[ICON_PRODUCTION])";
	elseif iProcess == GameInfoTypes.PROCESS_ITG_KRONBORG_FORT_PROCESS then
		uniquename = "Grants +1 Fort. (" .. math.floor(100 * gT.Players[city:GetOwner()].KronborgProcess) / 100 .. "/" .. KRONBORG_PROCESS_TRESHOLD .. "[ICON_PRODUCTION])";
	elseif GetLeagueResOutOfProcess(iProcess) then
		uniquename = GetLeagueProjectDataHelp(GetLeagueResOutOfProcess(iProcess), city:GetOwner(), 3)
	end
	MapModData.ITGSG = uniquename;
end)

LuaEvents.ITGSG_RequestBuildingUniqueNameHelp.Add(function(iBuilding, city)
	local uniquename;
	if not gT.Players[Game.GetActivePlayer()] then
		return;
	end
	-- obsolete for now
	MapModData.ITGSG = uniquename;
end)

local ValToCSValues = {5, 10, 25, 50, 100};
LuaEvents.ITGSG_CityStateContribution.Add(function(cs, val)
	AddContributionToProjectCS(Game.GetActivePlayer(), cs, ValToCSValues[val])
end)

LuaEvents.ITGSG_DoCityTask.Add(function(pCity, taskID)
	DoCityITGTask(pCity, taskID)
end)

LuaEvents.ITGSG_RequestCityTaskData.Add(function(pCity, gPlayer)
	MapModData.ITGSG = GetHumanPlayerTasksOptions(pCity, gPlayer);
end)


LuaEvents.ITGSG_RequestExtraBuildingData.Add(function(bClass, iType, pCity)
	local iPlayer;
	if pCity then
		iPlayer = pCity:GetOwner();
	elseif not gT.Players[Game.GetActivePlayer()] then
		MapModData.ITGSG = 0;
		return;
	else
		iPlayer = Game.GetActivePlayer()
	end
	if iType == 1 then
		MapModData.ITGSG = gT.Players[iPlayer].LegalPointsFromBuildingClasses[bClass] or 0;
	elseif iType == 2 then
		MapModData.ITGSG = gT.Players[iPlayer].GPPointsFromBuildingClasses[bClass] or 0;
	elseif iType == 3 then
		MapModData.ITGSG = gT.Players[iPlayer].CombatExperienceFromBuildingClasses[bClass] or 0;
	elseif iType == 4 then
		MapModData.ITGSG = gT.Players[iPlayer].ArtPointsFromBuildingClasses[bClass] or 0;
	elseif iType == 5 then
		MapModData.ITGSG = gT.Players[iPlayer].WonderPointsFromBuildingClasses[bClass] or 0;
	elseif iType == 6 then
		MapModData.ITGSG = gT.Players[iPlayer].WorkRateFromBuildingClasses[bClass] or 0;
	elseif iType == 7 then
		MapModData.ITGSG = gT.Players[iPlayer].HealthFromBuildingClasses[bClass] or 0;
	end
end)

LuaEvents.ITGSG_PlayerChangeGASetting.Add(function()
	local iPlayer = Game.GetActivePlayer();
	gT.Players[iPlayer].GrandArchitect = not gT.Players[iPlayer].GrandArchitect;
	if gT.Players[iPlayer].GrandArchitect then
		DoAutomaticPalaceUpgrades(iPlayer)
		RefreshAllDirtyPlayer()
	end
end)

LuaEvents.ITGSG_PlayerChangeMOWSettings.Add(function()
	local iPlayer = Game.GetActivePlayer();
	gT.Players[iPlayer].MasterOfWhispers = not gT.Players[iPlayer].MasterOfWhispers;
	if gT.Players[iPlayer].MasterOfWhispers then
		AIReassignSpies(iPlayer)
	end
end)

LuaEvents.ITGSG_HumanChangeVeteranSettings.Add(function()
	local iPlayer = Game.GetActivePlayer();
	gT.Players[iPlayer].MasterOfArmy = not gT.Players[iPlayer].MasterOfArmy;
	if gT.Players[iPlayer].MasterOfArmy then
		AIGoThroughUnitsVeteranProm(iPlayer)
	end
end)

LuaEvents.ITGSG_PlayerChangeMOCSettings.Add(function()
	local iPlayer = Game.GetActivePlayer();
	gT.Players[iPlayer].MasterOfCoin = not gT.Players[iPlayer].MasterOfCoin;
	if gT.Globals.StockActive then
		if gT.Players[iPlayer].MasterOfCoin then
			DoMakeAIInvestments(iPlayer)
		end
		Events.SerialEventEndTurnDirty()
	end
end)

LuaEvents.ITGSG_PlayerBoughtNewAgent.Add(function()
	PlayerBoughtNewAgentWithGold(Game.GetActivePlayer())
end)

LuaEvents.ITGUpdateITGBonusOptionsQuicklyBeforeChoose.Add(function(bonusType, bClassInsp)
	if bonusType == "BonusScience" then
		MapModData.ITGSG = PrepareExtraDataForHumanScienceBonus(Game.GetActivePlayer())
	elseif bonusType == "BonusCulture" then
		MapModData.ITGSG = PrepareExtraDataForHumanCultureBonus(Game.GetActivePlayer())
	elseif bonusType == "BonusFaith" then
		MapModData.ITGSG = PrepareExtraDataForHumanFaithBonus(Game.GetActivePlayer())
	elseif bonusType == "BonusGeneral" then
		MapModData.ITGSG = PrepareExtraDataForHumanGeneralBonus(Game.GetActivePlayer())
	elseif bonusType == "BonusAdmiral" then
		MapModData.ITGSG = PrepareExtraDataForHumanAdmiralBonus(Game.GetActivePlayer())
	elseif bonusType == "Inspiration" then
		MapModData.ITGSG = PrepareExtraDataForHumanInspiration(Game.GetActivePlayer(), bClassInsp)
	end
end)

function GeneralRemoveFirstBonusType(iPlayer, type)
	for i, sth in pairs(gT.Players[iPlayer].NewHumanQueueActions) do
		if sth.BonusType == type then
			lkey = i;
			break;
		end
	end
	if lkey then
		table.remove(gT.Players[iPlayer].NewHumanQueueActions, lkey)
	end
end

LuaEvents.ITGSG_RequestCityBannerSpy.Add(function(playerID, cityIndex)
	local gTab = {false, "", DBScenario.NoFaithGeneration}
	if gT.Players[Game.GetActivePlayer()] then
		for agentID, agentData in pairs(gT.Players[Game.GetActivePlayer()].Agents) do
			if agentData.TargetCity == cityIndex then -- agentData.TargetPlayer == playerID is redundant...
				gTab[1] = true;
				if gTab[2] ~= "" then
					gTab[2] = gTab[2] .. "[NEWLINE]" .. agentData.Name .. " (" .. Locale.Lookup(GetEspActionData(agentData.Mission, "Description")) .. ")";
				else
					gTab[2] = agentData.Name .. " (" .. Locale.Lookup(GetEspActionData(agentData.Mission, "Description")) .. ")";
				end
			end
		end
	end
	MapModData.ITGSG = gTab;
end)

LuaEvents.ITGRequestITGTitle.Add(function(iPlayer)
	if gT.Players[iPlayer].IsConsideredBarbarian then
		return "exile";
	end
	MapModData.ITGSG = GetITGPlayerTitle(iPlayer)
end)


LuaEvents.ITG_CallGoldTPClicked.Add(function()
	if gT.Globals.ScenarioType == 5 then
		LuaEvents.ITG_CallBudgetOverview()
	else
		Events.SerialEventGameMessagePopup( { Type = ButtonPopupTypes.BUTTONPOPUP_ECONOMIC_OVERVIEW, Data2 = -1} );
	end
end)

LuaEvents.ITGSG_RequestHandicapToolTip.Add(function()
	local tt = "AI handicap values:"
	tt = tt .. "[NEWLINE]" .. gT.Handicap.Food .. "% [ICON_FOOD] Cities' growth treshold"
	tt = tt .. "[NEWLINE]" .. gT.Handicap.Production .. "% [ICON_PRODUCTION] Units' and Buildings' production cost"
	tt = tt .. "[NEWLINE]" .. gT.Handicap.Gold .. "% [ICON_GOLD] Units' and Buildings' maintenance"
	tt = tt .. "[NEWLINE]" .. gT.Handicap.Supply .. "% of Military Units requiring [ICON_ITG_SUPPLY] supply"
	MapModData.ITGSG = tt;
end)

LuaEvents.ITGSG_RequestHandicapData.Add(function()
	MapModData.ITGSG = {gT.Handicap.Food, gT.Handicap.Production, gT.Handicap.Gold, gT.Handicap.Supply}
end)

LuaEvents.ITGCallEditHandicap.Add(function(food, prod, gold, supply)
	DoSetAIHandicap(food, prod, gold, supply, false)
end)

function DoSetAIHandicap(food, prod, gold, supply, bAuto)
	gT.Handicap.Food = math.min(100, math.max(20, food))
	gT.Handicap.Gold = math.min(100, math.max(20, gold))
	gT.Handicap.Production = math.min(100, math.max(20, prod))
	gT.Handicap.Supply = math.min(100, math.max(20, supply))
	gT.Handicap.EasiestFood = math.max(gT.Handicap.EasiestFood or 0, gT.Handicap.Food)
	gT.Handicap.EasiestGold = math.max(gT.Handicap.EasiestGold or 0, gT.Handicap.Gold)
	gT.Handicap.EasiestProduction = math.max(gT.Handicap.EasiestProduction or 0, gT.Handicap.Production)
	gT.Handicap.EasiestSupply = math.max(gT.Handicap.EasiestSupply or 0, gT.Handicap.Supply)
	if not bAuto then
		gT.Handicap.RefFood = gT.Handicap.Food
		gT.Handicap.RefGold = gT.Handicap.Gold
		gT.Handicap.RefProduction = gT.Handicap.Production
		gT.Handicap.RefSupply = gT.Handicap.Supply
	end
	Game.DoSetAIHandicap(gT.Handicap.Gold, gT.Handicap.Production, gT.Handicap.Food, gT.Handicap.Supply)
end

LuaEvents.ITGSGGetPoints.Add(function(bFull)
	local pTab = {}
	if gT and gT.VictoryPoints then
		for player, s in pairs(gT.VictoryPoints.Players) do
			if bFull then
				pTab[player] = s.TotalPoints
			else
				pTab[player] = s.Points
			end
		end
	end
	MapModData.ITGSG = pTab;
end)

LuaEvents.ITGSG_RequestVictoryPointsDiploList.Add(function()
	local pTab = {}
	if gT and gT.VictoryPoints then
		for player, s in pairs(gT.VictoryPoints.Players) do
			pTab[player] = {s.Points, GetToolTipVictoryPoints(player)}
		end
	end
	MapModData.ITGSG = pTab;
end)

LuaEvents.ITG_RequestSaveName.Add(function()
	if gT then
		local pTab = {GetScNameForSave(), GetITGGameTurn(), GetTextDateForSave()}
		MapModData.ITGSG = pTab;
	end
end)

LuaEvents.ITG_GameRetired.Add(function()
	if not CanRetireNow() then
		Events.GameplayAlertMessage("You can't do that action now.")
		return;
	end
	gT.Globals.GameRetired = {};
	for i, human in pairs(gT.Globals.HumanPlayers) do
		gT.Players[human].AIFavourOfLaws = {}
		PrepareAIFavoursOfLaws(human)
		table.insert(gT.Globals.GameRetired, human);
		if human ~= iActivePlayer then
			Game.SetPlayerAutoPlayer(human, true);
		end
	end
	gT.Globals.HumanPlayers = {}
	Game.SetAIAutoPlay(500)
end)

function DoReturnRetiredPlayers()
	local rPlayer = GetAutoReturnablePlayer();
	for i, human in pairs(gT.Globals.GameRetired) do
		table.insert(gT.Globals.HumanPlayers, human);
		if rPlayer ~= human then
			Game.SetPlayerAutoPlayer(human, false);
		end
	end
	gT.Globals.GameRetired = nil;
	Game.SetAIAutoPlay(1)
end

function GetAutoReturnablePlayer()
	local bNext = false;
	local iFirst = -1;
	local tCf = {}
	for i, v in pairs(gT.Globals.HumanPlayers) do
		tCf[v] = true;
	end
	for i, v in pairs(Players) do
		if v:IsTurnActive() then
			if tCf[i] then
				return i;
			end
			bNext = true;
		elseif tCf[i] then
			if bNext then
				return i;
			elseif iFirst == -1 then
				iFirst = i;
			end
		end
	end
	if bNext then
		return iFirst;
	end
	return gT.Globals.GameRetired[1];
end

LuaEvents.ITGSG_CanRetire.Add(function()
	MapModData.ITGSG = CanRetireNow();
end)

function IsThereValidSlotToRetire()
	for i = 1, GameDefines.MAX_MAJOR_CIVS-1, 1 do
		if PreGame.GetSlotStatus(i) == SlotStatus.SS_OBSERVER then
			if PreGame.GetSlotClaim(i) == SlotClaim.SLOTCLAIM_RESERVED or PreGame.GetSlotClaim(i) == SlotClaim.SLOTCLAIM_UNASSIGNED then
				return true;
			end
		end
	end
	return false;
end

function CanRetireNow()
	local iActivePlayer = Game.GetActivePlayer();
	if not IsThereValidSlotToRetire() then
		return false;
	end
	if gT.Globals.LastTurn > GetITGGameTurn() then
		for i, human in pairs(gT.Globals.HumanPlayers) do
			if human == iActivePlayer then
				return true;
			end
		end
	end
	return false;
end

LuaEvents.ITG_RequestCultIdeoBonusHelp.Add(function(a, b)
	GiveBackCultIdeoData(a, b)
end)

LuaEvents.ITGSG_RequestUniversitiesKeystones.Add(function(iPlayer)
	MapModData.ITGSG = GetUniversitiesKeystones(iPlayer);
end)

LuaEvents.ITG_RequestUnvisitedGoodyHuts.Add(function()
	local gPlayer = Game.GetActivePlayer();
	if gT and gT.Players[gPlayer] then
		local tab = {};
		local gTeam = Players[gPlayer]:GetTeam();
		for index, ruinsdata in pairs(gT.Globals.AncientRuins) do
			if not Map.GetPlotByIndex(index):AlreadyVisitedGoodyHut(gTeam) then
				if Map.GetPlotByIndex(index):IsRevealed(gTeam) then
					table.insert(tab, index)
				end
			end
		end
		MapModData.ITGSG = tab;
	end
	MapModData.ITGSG = nil;
end)

LuaEvents.ITGSG_LH_GlobalCivInfoRequest.Add(function()
	local tab = {}
	local nextScenarioType = DBScenario.NextScenario
	local numMajorPlayers = 0;
	if nextScenarioType then
		tab.NextScenarioID = ITG_ScenariosTypes[nextScenarioType];
		for row in DB.Query("SELECT * FROM ITG_Scenarios WHERE Type = '" .. nextScenarioType .. "'") do
			tab.CodexChance = row.CodexChance;
			tab.MinCodexDiscount = row.MinCodexDiscount;
			tab.MaxCodexDiscount = row.MaxCodexDiscount;
			tab.MinNatDays = row.MinNatDays;
			tab.MaxNatDays = row.MaxNatDays;
			tab.AlphabetChance = row.AlphabetChance;
		end
		tab.NextPrinciples = GetInitPrinciplesForCivInfo(tab.NextScenarioID)
	
	end
	tab.ScenarioID = gT.Globals.ScenarioType;
	tab.NumCodexes = 0;
	tab.NumAlphabets = 0;
	tab.NumWondersCertain = 0;
	tab.NumWondersContest = 0;
	tab.NumWondersRuins = 0;
	tab.RuinsForgotten = ERA_CONV_RUINS_FORGOTTEN;
	tab.WonderTCertain = ERA_CONV_WONDER_DESIGN_SURE_T;
	for eBuilding, tt in pairs(gT.Globals.WondersAssignedT) do
		if (not gT.Wonders[eBuilding]) then
			if tt >= ERA_CONV_WONDER_DESIGN_SURE_T then
				tab.NumWondersCertain = tab.NumWondersCertain + 1;
			else
				tab.NumWondersContest = tab.NumWondersContest + 1;
			end
		end
	end
	for eBuilding, hh in pairs(gT.Wonders) do
		tab.NumWondersContest = tab.NumWondersContest + 1;
	end
	for a, b in pairs(gT.WondersRuins) do
		tab.NumWondersRuins = tab.NumWondersRuins + 1;
	end	
	tab.SocialChange = ERA_CONV_SOCIAL_CHANGE;
	tab.LawChangeCodex = ERA_CONV_LAW_CHANGE_WITH_CODEX
	tab.LawChangeNoCodex = ERA_CONV_LAW_CHANGE_WITHOUT_CODEX
	local majorPlayers = {}
	for g, h in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			numMajorPlayers = numMajorPlayers + 1;
			table.insert(majorPlayers, g);
		end
		if h.HasCodex then
			tab.NumCodexes = tab.NumCodexes + 1;
		end
		if h.StAlphabet == g then
			tab.NumAlphabets = tab.NumAlphabets + 1;
		end
	end 
	tab.NumWondersToAssign = GetNumWondersAssignBasedOnMajors(numMajorPlayers);
	if tab.NextScenarioID == 5 then
		local numIdeologies = GetNumIdeologiesFromPlayer(numMajorPlayers)
		local ideotab = GetPlayersWithMostDiverseIdeologies(numIdeologies, majorPlayers)
		tab.NumIdeologies = numIdeologies;
		tab.DevelopIdeo = {};
		for i, player in pairs(ideotab) do
			tab.DevelopIdeo[player] = true;
		end
		tab.FollowIdeo = {};
		for i, player in pairs(majorPlayers) do
			if not tab.DevelopIdeo[player] then
				local bestOption, smallestVal;
				for j, jplayer in pairs(ideotab) do
					local dif = GetDifIdeologyOfTwoPlayer(player, jplayer);
					if (not smallestVal) or (smallestVal > dif) then
						smallestVal = dif;
						bestOption = jplayer;
					end
				end
				tab.FollowIdeo[player] = bestOption;
			end
		end
	end
	MapModData.ITGSG = tab;
end)


LuaEvents.ITGSG_LH_CivInfoRequest.Add(function(iPlayer)
	local tab = {}
	tab.HasCodex = gT.Players[iPlayer].HasCodex;
	tab.Alphabet = gT.Players[iPlayer].StAlphabet
	tab.NumDays = gT.Players[iPlayer].NationalDays;
	tab.LawsData = GetCivInfoLawsData(iPlayer)
	tab.CodexDiscount = gT.Players[iPlayer].CodexDiscount;
	tab.NoblePriviligeEC = gT.Players[iPlayer].NoblePriviligeEC;
	tab.SocialDevelopments = GetCivInfoSocialData(iPlayer)
	tab.WonderData = GetCivInfoWonderData(iPlayer)
	tab.MinorIdeology = GetCivInfoMinorIdeologies(iPlayer)
	tab.GovName = GetGovermentForNextScenario(iPlayer)
	tab.Principles = GetCivInfoPrinciples(iPlayer)
	tab.HadInspFromCulture = gT.Players[iPlayer].bInspFromCulture; 
	tab.Inspirations = {};
	for class, option in pairs(gT.Players[iPlayer].Inspirations) do
		table.insert(tab.Inspirations, {class, option})
	end
	tab.Ideologies = {};
	for letter, value in pairs(gT.Players[iPlayer].Ideologies) do
		tab.Ideologies[letter] = value;
	end
	tab.IdeologyTenets = GetCivInfoIdeologyTenets(iPlayer)
	MapModData.ITGSG = tab;
end)