local combT = {}

function GetCombTab()
	return combT;
end

function GetFactorial(v)
	local b = 1;
	for i = 1, v do
		b = b * i;
	end
	return b;
end

function GeneratePossibleCombinations(c)
	if combT[c] then
		return;
	end
	combT[c] = {}
	local taken = {}
	for i = 1, c do
		table.insert(taken, false)
	end
	local ac = GetFactorial(c)	
	for i = 1, ac do
		local comb = {}
		for j, b in pairs(taken) do
			taken[j] = false;
		end
		local hV = i;
		local sCheck = ""
		local div = ac / c;
		for j = 0, c - 1 do
			local nN = 1;
			local dNum = 0;
			if j ~= c - 1 then
				nN = math.ceil(hV / div)
				hV = hV - (nN - 1) * div;			
				div = div / (c - 1 - j);
			end
			for t, b in pairs(taken) do
				if not b then
					nN = nN - 1;
					if nN == 0 then
						dNum = t;
						break;
					end
				end
			end
			taken[dNum] = true;
			table.insert(comb, dNum)
		end
		table.insert(combT[c], comb)
	end
end

function GetNumDigitsFromInput(a)
	for i = 0, 10 do
		if math.pow(10, i) > a then
			return i;
		end
	end
	print("Break now - limited to 10 digits", a)
end

function GetDigitsFromInput(a)
	local nd = GetNumDigitsFromInput(a)
	local dt = {}
	for i = 1, nd do
		local div = math.pow(10, nd - i);
		local ndigit = math.floor(a / div);
		table.insert(dt, ndigit)
		a = a - ndigit * div
	end
	return dt;
end

function IsPseudoVampiricNumber(c)
--does not work for 2-digits numbers
	local numdigits = GetNumDigitsFromInput(c)
	local digitsT = GetDigitsFromInput(c)
	GeneratePossibleCombinations(numdigits)
	local hc = math.max(2, math.floor(numdigits / 2)) -- floor because otherwise it would just repeat "mirrored" options   ; max so we can check 3-digits number
	local tested = 0;
	for i = 2, hc do
		for j, ct in pairs(combT[numdigits]) do
			local tab1 = {}
			local tab2 = {}
			for a, b in pairs(digitsT) do
				if a <= i then
					table.insert(tab1, digitsT[ct[a]])
				else
					table.insert(tab2, digitsT[ct[a]])
				end
			end
			local m1 = GetRealDigitFromTab(tab1)
			local m2 = GetRealDigitFromTab(tab2);
			if m1 > 0 and m2 > 0 then
				tested = tested + 1
				if m1 * m2 == c then
					print("Vampire Number", c, m1, m2)
					return true;
				end
			end
		end
	end
	print("Not a Vampire Number", tested)
	return false;
end

function GetRealDigitFromTab(tab)
	if tab[#tab] == 0 then
		return -1;
	else
		local c = 0;
		for i, b in pairs(tab) do
			c = c + math.pow(10, i - 1) * b
		end
		return c;
	end
end

function LetsFindTheSmallestNumber(limit, min)
	for i = (min or 1), (limit or 9999) do
		local candidate = i * 10 + 9;
		if IsFirstConditionMet(candidate) then
			if IsFirstConditionMet(candidate + 1) then
				print("Number met first condition:", candidate)
				if IsPseudoVampiricNumber(candidate * 35) then
					print("Found the smallest option:", candidate)
					break;
				end
			end
		end
	end
end

function IsFirstConditionMet(num)
	local digT = GetDigitsFromInput(num)
	local tV = 0;
	for a, b in pairs(digT) do
		tV = tV + b;
	end
	if tV % 2 == 1 then
		return false;
	end
	tV = tV / 2;
	local c = 0;
	for a, b in pairs(digT) do
		c = c + b;
		if c == tV then
			return true;
		end
	end
	return false
end