
function DoInitialLuxuryResourcesControl()
	if PreGame.GetGameOption("GAMEOPTION_ITG_RESOURCE_BALANCE") ~= 1 then
		return;
	end
	local tabOtherResources = {}
	local migB = {}
	for row in GameInfo.Resources() do
		if (not row.Migration) then
			if (row.Happiness == 0) then
				table.insert(tabOtherResources, row.ID)
			end
		else
			migB[row.ID] = true;
		end
	end

	local tabResPlotsNum = {}
	local resPlots = {}
	for i = 0, Map:GetNumPlots() - 1, 1 do
		local fPlot = Map.GetPlotByIndex(i);
		local fRes = fPlot:GetResourceType();
		if fRes ~= -1 then
			tabResPlotsNum[fRes] = (tabResPlotsNum[fRes] or 0) + 1;
			if not resPlots[fRes] then
				resPlots[fRes] = {}
			end
			table.insert(resPlots[fRes], fPlot)
		end
	end
	local total = 0;
	for row in GameInfo.Resources() do
		if row.Happiness > 0 and (tabResPlotsNum[row.ID]) then
			total = total + 1;
		else
			resPlots[row.ID] = nil
			tabResPlotsNum[row.ID] = nil;
		end
	end
	local numMajor = 0;
	local numMinor = 0;
	local fixStartingMigration = {}
	for i, v in pairs(Players) do
		if (v:IsEverAlive()) and (not v:IsBarbarian())  then
			if v:IsMinorCiv() then
				numMinor = numMinor + 1;
			else
				numMajor = numMajor + 1;
			end
			local sPosition = v:GetStartingPlot()
			for h, b in pairs(GetPlotsInRadiusOfPlot(sPosition, 3)) do
				if migB[b:GetResourceType()] and b:IsWater() then
					table.insert(fixStartingMigration, b)
					b:SetResourceType(-1);
					b:SetResourceNum(0);
				end
			end
		end
	end
	local water = {}
	local land = {}
	for fRes, h in pairs(resPlots) do
		if h[1]:IsWater() then
			table.insert(water, fRes)
		else
			table.insert(land, fRes)
		end
	end
	if total > NUM_LUXURIES_TOTAL then
		local cWater = #water;
		if cWater > 1 then
			local t = 0;
			for i, res in pairs(water) do
				t = t + tabResPlotsNum[res];
			end
			local excepto = math.max(1, math.ceil(t / numMajor + 0.4))
			for i = excepto + 1, cWater do
				local lKey = LastRandom(1,#water);
				local lRes = water[lKey];
				table.remove(water, lKey)
				for j, plot in pairs(resPlots[lRes]) do
					local bOption = -1;
					local bTH = 100;
					plot:SetResourceType(-1)
					for g, waterRes in pairs(water) do
						if plot:CanHaveResource(waterRes) then
							if tabResPlotsNum[waterRes] < bTH then
								bTH = tabResPlotsNum[waterRes]
								bOption = waterRes;
							end
						end
					end
					if bOption == -1 then
						local bRt = {}
						for i, iRes in pairs(tabOtherResources) do
							if plot:CanHaveResource(iRes) then
								table.insert(bRt, iRes)
							end
						end
						if #bRt > 0 then
							AddProperlyResourceOnPlot(plot, bRt[LastRandom(1,#bRt)], false)
						end
					else
						table.insert(resPlots[bOption], plot)
						tabResPlotsNum[bOption] = 1 + tabResPlotsNum[bOption]
						plot:SetResourceType(bOption);
						plot:SetNumResource(1);
					end
				end
				tabResPlotsNum[lRes] = nil;
				resPlots[lRes] = nil;
				total = total - 1;
			end
		end
		if total > NUM_LUXURIES_TOTAL then
			for i = NUM_LUXURIES_TOTAL + 1, total do
				local tRemT = {}
				for j, res in pairs(land) do
					table.insert(tRemT, {res, tabResPlotsNum[res], j})
				end
				if #tRemT == 0 then
					break;
				end
				tRemT = Shuffle(tRemT);
				table.sort(tRemT, SortFunctionForLowestMapDistance);
				local lRes = tRemT[1][1]
				table.remove(land, tRemT[1][3])
				for j, plot in pairs(resPlots[lRes]) do
					local bOption = -1;
					local bTH = 100;
					plot:SetResourceType(-1)
					for g, waterRes in pairs(land) do
						if plot:CanHaveResource(waterRes) then
							if tabResPlotsNum[waterRes] < bTH then
								bTH = tabResPlotsNum[waterRes]
								bOption = waterRes;
							end
						end
					end
					if bOption == -1 then
						local bRt = {}
						for i, iRes in pairs(tabOtherResources) do
							if plot:CanHaveResource(iRes) then
								table.insert(bRt, iRes)
							end
						end
						if #bRt > 0 then
							AddProperlyResourceOnPlot(plot, bRt[LastRandom(1,#bRt)], false)
						end
					else
						table.insert(resPlots[bOption], plot)
						tabResPlotsNum[bOption] = 1 + tabResPlotsNum[bOption]
						plot:SetResourceType(bOption);
						plot:SetNumResource(1);
					end
				end
				tabResPlotsNum[lRes] = nil;
				resPlots[lRes] = nil;
			end
		end
	end
	-- now, remove resource with too great amount :)
	local numMaxRes = math.max(4, numMajor + math.ceil(numMinor/10));
	local plotsToRefill = {}
	for lRes, num in pairs(tabResPlotsNum) do
		if num > numMaxRes then
			local fnum = num;
			for j, plot in pairs(GetBestResourceToRemoveInit(num - numMaxRes, resPlots[lRes])) do
				plot:SetResourceType(-1)
				table.insert(plotsToRefill, plot);
				fnum = fnum - 1;
			end
			tabResPlotsNum[lRes] = fnum;
		end
	end
	for iji, plot in pairs(plotsToRefill) do
		local bOption = -1;
		local bTH = numMaxRes;
		for nRes, am in pairs(tabResPlotsNum) do
			if am < bTH then
				if plot:CanHaveResource(nRes) then
					bTH = am
					bOption = nRes;
				end
			end
		end
		if bOption == -1 then
			local bRt = {}
			for i, iRes in pairs(tabOtherResources) do
				if plot:CanHaveResource(iRes) then
					table.insert(bRt, iRes)
				end
			end
			if #bRt > 0 then
				AddProperlyResourceOnPlot(plot, bRt[LastRandom(1,#bRt)], false)
			end
		else
			tabResPlotsNum[bOption] = 1 + tabResPlotsNum[bOption]
			plot:SetResourceType(bOption);
			plot:SetNumResource(1); --unneeded
		end
	end
	local fAtoll = GameInfoTypes.FEATURE_ATOLL;
	if #water > 0 then
		fixStartingMigration = Shuffle(fixStartingMigration);
		for j, plot in pairs(fixStartingMigration) do
			local bResAdded = false;
			for g, waterRes in pairs(water) do
				if plot:CanHaveResource(waterRes) then
					if tabResPlotsNum[waterRes] < numMaxRes then
						AddProperlyResourceOnPlot(plot, waterRes, false, false, 1)
						tabResPlotsNum[waterRes] = tabResPlotsNum[waterRes] + 1;
						bResAdded = true;
						break;
					end
				end
			end
			if not bResAdded then
				plot:SetFeatureType(fAtoll);
			end
		end
	else
		for j, plot in pairs(fixStartingMigration) do
			plot:SetFeatureType(fAtoll);
		end
	end
	for lRes, num in pairs(tabResPlotsNum) do
		print("Final resources", GameInfo.Resources[lRes].Type, num)
	end

	DoResetResourcesPresentOnMap()
	DoResetCachedNumResources()
end

function GetBestResourceToRemoveInit(num, plots)
	local tab = {}
	for i, v in pairs(plots) do
		table.insert(tab, {v, EvaluatePlotResourceToRemove(v)})
	end
	tab = Shuffle(tab)
	table.sort(tab, SortFunctionForLowestMapDistance);
	local r = {}
	for i = 1, num do
		table.insert(r, tab[i][1])
	end
	return r;
end

function EvaluatePlotResourceToRemove(plot)
	local val = 0;
	for i, v in pairs(Players) do
		if v:IsEverAlive() and (not v:IsBarbarian()) then
			local sPlot = v:GetStartingPlot();
			val = math.min(val, Map.PlotDistance(plot:GetX(), plot:GetY(), sPlot:GetX(), sPlot:GetY()))
			if val < 4 and v:IsMinorCiv() then
				return 10;
			end
		end
	end
	val = math.min(3, math.ceil(val / 3))
	return 10 - val;
end

function DoStrategicResourceMapScript()
	local maj, min = 0, 0;
	for i,v in pairs(Players) do
		if v:IsEverAlive() then
			if not v:IsBarbarian() then
				if v:IsMinorCiv() then
					min = min + 1;
				else
					maj = maj + 1;
				end
			end
		end
	end
	if gT.Globals.ScenarioType == 5 then
		DoStrategicResourceMapScriptSleepOfReason(maj, min)
	elseif gT.Globals.ScenarioType == 4 then
		DoStrategicResourceMapScriptLightOfHope(maj, min)
	elseif gT.Globals.ScenarioType == 3 then
		DoStrategicResourceMapScriptAgeOfTitans(maj, min)
	elseif gT.Globals.ScenarioType == 2 then
		DoStrategicResourceMapScriptTrial(maj, min)
	elseif gT.Globals.ScenarioType == 1 then
		DoStrategicResourceMapScriptNewWorld(maj, min)
	end
	DoResetResourcesPresentOnMap()
	DoResetCachedNumResources()
end

function DoStrategicResourceMapScriptTrial(maj, min)
	local theTab = {[rHorse] = {MajMin = 1.5, MajMax = 2.5, MinMin = 0.4, MaxMin = 0.7, Q1 = 1, Q2= 1}}
	BasicStrategicBalanceScript(theTab, maj, min)
end

function DoStrategicResourceMapScriptAgeOfTitans(maj, min)
	local theTab = {[rIron] = {MajMin = 1, MajMax = 1.7, MinMin = 0.2, MaxMin = 0.25, Q1 = 1, Q2 = 1}, 
	[rHorse] = {MajMin = 2, MajMax = 3, MinMin = 0.25, MaxMin = 0.33, Q1 = 1, Q2= 1}}
	BasicStrategicBalanceScript(theTab, maj, min)
end

function DoStrategicResourceMapScriptNewWorld(maj, min)
	local theTab = {[rIron] = {MajMin = 1, MajMax = 1.5, MinMin = 0.5, MaxMin = 0.75, Q1 = 2, Q2 = 3}, 
	[rHorse] = {MajMin = 1, MajMax = 1.5, MinMin = 0.5, MaxMin = 0.75, Q1 = 2, Q2 = 3}}
	BasicStrategicBalanceScript(theTab, maj, min)
end

function DoStrategicResourceMapScriptSleepOfReason(maj, min)
	local theTab = {[rOil] = {MajMin = 2.5, MajMax = 3, MinMin = 0.33, MaxMin = 0.5, Q1 = 3, Q2 = 5}, 
	[rUran] = {MajMin = 1.6, MajMax = 2.2, MinMin = 0.25, MaxMin = 0.33, Q1 = 2, Q2 = 2}, 
	[rCoal] = {MajMin = 1.6, MajMax = 2.2, MinMin = 0.25, MaxMin = 0.33, Q1 = 3, Q2= 3}}
	BasicStrategicBalanceScript(theTab, maj, min)
end

function DoStrategicResourceMapScriptLightOfHope(maj, min)
	local theTab = {[rOil] = {MajMin = 1.3, MajMax = 2.5, MinMin = 0.25, MaxMin = 0.5, Q1 = 2, Q2 = 4}, 
	[rHorse] = {MajMin = 1.5, MajMax = 2.5, MinMin = 0.25, MaxMin = 0.33, Q1 = 1, Q2 = 1}, 
	[rIron] = {MajMin = 1.5, MajMax = 2.5, MinMin = 0.25, MaxMin = 0.33, Q1 = 1, Q2 = 1}, 
	[rCoal] = {MajMin = 1.7, MajMax = 2.2, MinMin = 0.25, MaxMin = 0.33, Q1 = 3, Q2= 4}}
	BasicStrategicBalanceScript(theTab, maj, min)
end

function BasicStrategicBalanceScript(resTab, maj, min)
	for res, b in pairs(resTab) do
		resTab[res].OnMap = {}
	end
	local otherRes = {}
	for f = 0, Map.GetNumPlots() - 1 do
		local fPlot = Map.GetPlotByIndex(f);
		fRes = fPlot:GetResourceType(-1);
		if fRes ~= -1 then
			if resTab[fRes] then
				table.insert(resTab[fRes].OnMap, f)
			elseif not otherRes[fRes] then
				if (not GameInfo.Resources[fRes].Migration) and (GameInfo.Resources[fRes].Happiness == 0) then
					otherRes[fRes] = 1;
				else
					otherRes[fRes] = 0;
				end
			end
		end 
	end
	local tRmvT = {}
	for res, b in pairs(resTab) do
		gT.Globals.ResNumReference[res] = {b.Q1, b.Q2}
		resTab[res].OnMap = Shuffle(resTab[res].OnMap)
		resTab[res].Min = math.ceil(b.MajMin * maj + b.MinMin * min );
		resTab[res].Max = math.ceil(b.MajMax * maj + b.MaxMin * min );
		resTab[res].NotEnough = resTab[res].Min - #resTab[res].OnMap;
		local tMany = #resTab[res].OnMap - resTab[res].Max;
		for i = 1, tMany do
			table.insert(tRmvT, resTab[res].OnMap[1])
			gT.Globals.OriginalResource[resTab[res].OnMap[1]] = Map.GetPlotByIndex(resTab[res].OnMap[1]):GetResourceType(-1);
			gT.Globals.ResourceQuantity[resTab[res].OnMap[1]] = Map.GetPlotByIndex(resTab[res].OnMap[1]):GetNumResource()
			Map.GetPlotByIndex(resTab[res].OnMap[1]):SetResourceType(-1);
			table.remove(resTab[res].OnMap, 1)
		end	
	end
	local function StrResReductionStart(res, ivl, ivl2, iLimit)
		local tit = #tRmvT - 1;
		for j = 0, tit do
			local tPlot = Map.GetPlotByIndex(tRmvT[tit + 1 - j]);
			if tPlot:CanHaveResource(res) then
				resTab[res].NotEnough = resTab[res].NotEnough - 1;
				AddProperlyResourceOnPlot(tPlot, res, false, false, LastRandom(ivl, ivl2))
				print("Reduced not enough")
				table.remove(tRmvT, tit + 1 - j)
				if resTab[res].NotEnough <= 0 then
					break;
				end
			end
		end
	end
	for res, sth in pairs(resTab) do
		if resTab[res].NotEnough > 0 then
			StrResReductionStart(res, sth.Q1, sth.Q2)
			if resTab[res].NotEnough > 0 then
				DoStrategicPopulateWithRes(res, resTab[res].NotEnough, sth.Q1, sth.Q2)
			end
		end
	end
	for i, plotIndex in pairs(tRmvT) do
		local tab = {};
		local iPlot = Map.GetPlotByIndex(plotIndex);
		for jRes, val in pairs(otherRes) do
			if (val == 1) and (iPlot:CanHaveResource(jRes)) then
				table.insert(tab, jRes)
			end
		end
		if #tab > 0 then
			AddProperlyResourceOnPlot(iPlot, tab[LastRandom(1,#tab)], false, false, 1)
		else
			AddProperlyResourceOnPlot(iPlot, -1, true, false, 0)
		end
	end
	for res, sth in pairs(resTab) do
		for i, index in pairs(sth.OnMap) do
			ReadjustTempResNum(Map.GetPlotByIndex(index), LastRandom(sth.Q1, sth.Q2))
		end
	end
end

function DoStrategicPopulateWithRes(res, iToAdd, iMin, iMax)
	local bAlready = {}
	local bPlausible = {}
	for i = 0, Map.GetNumPlots() - 1 do
		local tPlot = Map.GetPlotByIndex(i);
		local tRes = tPlot:GetResourceType();
		if tRes == res then
			table.insert(bAlready, tPlot)
		elseif tRes == -1 then
			if tPlot:CanHaveResource(res) then
				table.insert(bPlausible, tPlot)
			end
		end
	end
	if #bPlausible == 0 then
		print("Hello, why this happened? 543/234", res, iToAdd, iMin, iMax)
	end
	bPlausible = Shuffle(bPlausible)
	for j = 1, iToAdd do
		local bestKey, bValue = nil, 1;
		for d, cPlot in pairs(bPlausible) do
			local val = 1000;
			local x, y = cPlot:GetX(), cPlot:GetY();
			for djd, iPlot in pairs(bAlready) do
				val = math.min(val, Map.PlotDistance(x, y, iPlot:GetX(), iPlot:GetY()))
				if val <= bValue then
					break;
				end
			end
			if val > bValue then
				bValue = val;
				bestKey = d;
			end
		end
		if not bestKey then
			return;
		else
			AddProperlyResourceOnPlot(bPlausible[bestKey], res, true, false, LastRandom(iMin, iMax))
			table.insert(bAlready, bPlausible[bestKey]);
			table.remove(bPlausible, bestKey);
		end
	end
end

function DecideUponColonyType()
	local tbplots = {};
	for i = 0, Map:GetNumPlots() - 1, 1 do
		local iPlot = Map.GetPlotByIndex(i);
		if iPlot:GetOwner() == -1 then
			if CanBeNewColonyBasics(iPlot) then
				table.insert(tbplots, iPlot);
			end
		end
	end
	local numExtra = #tbplots;
	if #tbplots < 2 then
		return;
	end
	local avPlayers = {}
	for g, h in pairs(gT.Players) do
		if Players[g]:IsAlive() then
			table.insert(avPlayers, g);
		end
	end
	avPlayers = Shuffle(avPlayers);
	tbplots = Shuffle(tbplots);
	local numplayers = #avPlayers;
	local maxAdded = math.min(2 * numplayers, math.floor(numExtra * 4 / 5))
	local hval = 0;
	for i, iPlot in pairs(tbplots) do
		if not avPlayers[i - hval] then
			hval = hval + numplayers;
		end
		local lPlayer = avPlayers[i - hval];
		if not lPlayer then
			print("Error 4523/2345/c", numplayers, maxAdded, numExtra)
		else
			if IsValidPlotForColonyPlayer(lPlayer, iPlot) then
				CreateColony(iPlot, lPlayer, nil, true, false)	
				maxAdded = maxAdded - 1;
				if maxAdded <= 0 then
					return;
				end
			end
		end
	end
end