local baseMercProm = GameInfoTypes.PROMOTION_ITG_MERCENARY_BASE;
local pPromAdmi = GameInfoTypes.PROMOTION_ITG_GREAT_ADMIRAL_22;
local techAncEmp14 = GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_EMPIRE_14
local techNWAsia2 = GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_ASIA_2
local pPromGen = GameInfoTypes.PROMOTION_GREAT_GENERAL_25;
local tAfrInnoNw4 = GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_AFR_4;
local uMedPikeman3 = GameInfoTypes.UNIT_ITG_TRIAL_PIKEMAN_3;
local IsInvalidForMerc = {
[GameInfoTypes.UNITCLASS_ITG_BATTERING_RAM] = 1,
[GameInfoTypes.UNITCLASS_ITG_SIEGE_TOWER] = 1,
[GameInfoTypes.UNITCLASS_CATAPULT] = 1,
[GameInfoTypes.UNITCLASS_TREBUCHET] = 1,
[GameInfoTypes.UNITCLASS_CANNON] = 1,
}

function AddMercProm14(iUnit, iPlayer, bAdded, iAdd, iOneZero)
	if bAdded then
		iUnit:SetMoves(iUnit:MaxMoves())
	end
end
function AddMercProm15(iUnit, iPlayer, bAdded, iAdd, iOneZero)
	ChangeITGBaseCombatStrength(iUnit, iAdd * 2, iAdd * 2)
end
function AddMercProm17(iUnit, iPlayer, bAdded, iAdd, iOneZero)
	if bAdded then
		SetUnitForcedStackType(iUnit, -1, "fMerc", -1)
	else
		CleanTemporaryITGStackType(iUnit, "fMerc"); 
	end
end
function AddMercProm25(iUnit, iPlayer, bAdded, iAdd, iOneZero)
	iUnit:ChangeUnitClassModifier(iUnit:GetUnitClassType(), iAdd * 33)
end
local mercTabOfBonuses = {
{ID = 1, Promotion = GameInfoTypes.PROMOTION_ITG_MERCENARY_1},
{ID = 2, Promotion = GameInfoTypes.PROMOTION_ITG_MERCENARY_2},
{ID = 3, Promotion = GameInfoTypes.PROMOTION_ITG_MERCENARY_3},
{ID = 4, Promotion = GameInfoTypes.PROMOTION_ITG_MERCENARY_4},
{ID = 5, Promotion = GameInfoTypes.PROMOTION_ITG_MERCENARY_5},
{ID = 6, Promotion = GameInfoTypes.PROMOTION_ITG_MERCENARY_6},
{ID = 7, Promotion = GameInfoTypes.PROMOTION_ITG_MERCENARY_7},
{ID = 8, Promotion = GameInfoTypes.PROMOTION_ITG_MERCENARY_8},
{ID = 9, Promotion = GameInfoTypes.PROMOTION_ITG_MERCENARY_9, Melee = true},
{ID = 10, Promotion = GameInfoTypes.PROMOTION_ITG_MERCENARY_10},
{ID = 11, Promotion = GameInfoTypes.PROMOTION_ITG_MERCENARY_11},
{ID = 12, Promotion = GameInfoTypes.PROMOTION_ITG_MERCENARY_12},
{ID = 13, Promotion = GameInfoTypes.PROMOTION_ITG_MERCENARY_13},
{ID = 14, Promotion = GameInfoTypes.PROMOTION_ITG_MERCENARY_14, OnChanged = AddMercProm14},
{ID = 15, Promotion = GameInfoTypes.PROMOTION_ITG_MERCENARY_15, OnChanged = AddMercProm15},
{ID = 16, Promotion = GameInfoTypes.PROMOTION_ITG_MERCENARY_16},
{ID = 17, Promotion = GameInfoTypes.PROMOTION_ITG_MERCENARY_17, OnChanged = AddMercProm17},
{ID = 18, Promotion = GameInfoTypes.PROMOTION_ITG_MERCENARY_18},
{ID = 19, Promotion = GameInfoTypes.PROMOTION_ITG_MERCENARY_19, Domain = dLand},
{ID = 20, Promotion = GameInfoTypes.PROMOTION_ITG_MERCENARY_20, Domain = dLand},
{ID = 21, Promotion = GameInfoTypes.PROMOTION_ITG_MERCENARY_21},
{ID = 22, Promotion = GameInfoTypes.PROMOTION_ITG_MERCENARY_22},
{ID = 23, Promotion = GameInfoTypes.PROMOTION_ITG_MERCENARY_23},
{ID = 24, Promotion = GameInfoTypes.PROMOTION_ITG_MERCENARY_24},
{ID = 25, Promotion = GameInfoTypes.PROMOTION_ITG_MERCENARY_25, OnChanged = AddMercProm25},
{ID = 26, Promotion = GameInfoTypes.PROMOTION_ITG_MERCENARY_26},
{ID = 27, Promotion = GameInfoTypes.PROMOTION_ITG_MERCENARY_27},
{ID = 28, Promotion = GameInfoTypes.PROMOTION_ITG_MERCENARY_28},
{ID = 29, Promotion = GameInfoTypes.PROMOTION_ITG_MERCENARY_29},
{ID = 30, Promotion = GameInfoTypes.PROMOTION_ITG_MERCENARY_30},
}

local pref = {"White", "Grand", "Sacred", "Swiss", "Black", "Free", "Catalan", "Golden", "Red", "Cretan", "Nameless"}
local suff = {"Company", "Guard", "Band", "Thousand", "Tigers", "Group", "Army", "Brigade"}
local BadClassesForMerc = {[GameInfoTypes.UNITCLASS_SCOUT] = 1, [GameInfoTypes.UNITCLASS_ARCHAEOLOGIST] = 1}
function GetRandomNameForCompany()
	return pref[LastRandom(1,#pref)] .. " " .. suff[LastRandom(1,#suff)];
end

function DoConverToNormalUnitMercenary(iUnit, iPlayer)
	iUnit:SetHasPromotion(baseMercProm, false)
	for i, val in pairs(mercTabOfBonuses) do
		if iUnit:IsHasPromotion(val.Promotion) then
			if val.OnChanged then
				val.OnChanged(iUnit, iPlayer, false, -1, 0)
			end
			iUnit:SetHasPromotion(val.Promotion, false)
			break;
		end
	end
	LuaEvents.ITGUnitFlagMercAdmGenDirty(iPlayer, iUnit:GetID())
end

function IsValidUnitToBeMissionary(iUnit)
	if iUnit:IsCombatUnit() then
		if not BadClassesForMerc[iUnit:GetUnitClassType()] then
			return true;
		end
	end
	return false;
end

function NewMercenaryAcquired(iPlayer, iUnit, iCity, cID)
	gT.Players[iPlayer].NumMercTotal = gT.Players[iPlayer].NumMercTotal + 1;
	iUnit:SetHasPromotion(baseMercProm, true)
	iUnit:SetLevel(LastRandom(4, 6));
	iUnit:SetName(GetRandomNameForCompany())
	local uID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
	AdjustCombatBonusFromLevel(iUnit, uID, iPlayer)
	if not Players[iPlayer]:IsMinorCiv() then
		--resetable values
		gT.Players[iPlayer].MercHolyArm = 0;
		--resetable values
		DoIncreaseCosOfMercenaryUponPurchase(iPlayer)
		BasicCSMissionCompleteFunc(iPlayer, 10, 1)
		DoSetMercCostRightNow(iPlayer)
		local unitclass = iUnit:GetUnitClassType()
		if gT.Mercenaries[unitclass] then
			-- here should be added special bonus
			AcquireNewSpecialMercenary(iUnit, iPlayer, true)
			gT.Mercenaries[unitclass] = gT.Mercenaries[unitclass] - 1;
			BasicCallRandomYieldCH(16, iPlayer)
			if gT.Mercenaries[unitclass] == 0 then
				gT.Mercenaries[unitclass] = nil
			end
		end
	else
		print("Minor civs are purchasing units actually.")
	end
	CheckAchievement44(iPlayer)
	OnNewMercenaryBonuses(iUnit, iPlayer)
end

function OnNewMercenaryBonuses(iUnit, iPlayer)
	if gT.Players[iPlayer].CultBonusOn[200] then
		local uID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
		if not gT.Players[iPlayer].UnitsByID[uID].SocDev200 then
			AwardWithRandomVeteranProms(iUnit, 3)
			gT.Players[iPlayer].UnitsByID[uID].SocDev200 = true;
		end
	end
end

function AcquireNewSpecialMercenary(iUnit, iPlayer, bPurchased)
	local tt = {}
	for i, v in pairs(mercTabOfBonuses) do
		if (not v.Domain) or (v.Domain == iUnit:GetDomainType()) then
			if (not v.Melee) or (iUnit:GetBaseRangedCombatStrength() == 0) then
				table.insert(tt, i)
			end
		end
	end
	local lp = LastRandom(1, #tt);
	iUnit:SetHasPromotion(baseMercProm, false)
	iUnit:SetHasPromotion(mercTabOfBonuses[lp].Promotion, true)
	if mercTabOfBonuses[lp].OnChanged then
		mercTabOfBonuses[lp].OnChanged(iUnit, iPlayer, true, 1, 1)
	end
	gT.Players[iPlayer].NumSpecialMerc = gT.Players[iPlayer].NumSpecialMerc + 1;
	if Players[iPlayer]:IsHuman() and bPurchased then
		LuaEvents.ITG_AchievementCompleted(43)
	end
	if not bPurchased then
		OnNewMercenaryBonuses(iUnit, iPlayer)
	end
end

function InitMercenaryStuff()
	gT.Globals.MercenariesT = {}
	gT.Globals.MercenaryLog = {}
	for g, gdata in pairs(gT.Players) do
		Players[g]:SetMercenaryModifier(0)
		Players[g]:MightEvaluationDirty();
	end
	if not DBScenario.NoMercenaries then
		gT.Globals.MercenariesT = {[LastRandom(17,23)] = 1, [LastRandom(37,43)] = 1, [LastRandom(57,63)] = 1, [LastRandom(77,83)] = 1}
		DoSelectUnitClassesToBeSpecialMercenary()
	end
end

function EndTurnBarbMercenary()
	if not DBScenario.NoMercenaries then
		DoChangeMercenaryCost()
		if gT.Globals.MercenariesT[GetITGGameTurn()] then
			DoSelectUnitClassesToBeSpecialMercenary()
		end
	end
end

function GetPlayerJoinArmyByMercenaryLevel(iPlayer)
	local b = 0;
	if IsHasLaw(iPlayer, 28, 3) then
		b = b + 1;
	end
	return b;
end

function GetLoyalModFromGeneralsAndAdmirals(iPlayer)
	return gT.Players[iPlayer].LoyaltyGA;
end

function IsMercenaryFleeImmune(iPlayer) 
	if HasPlayerTech(iPlayer, techAncEmp14, "kcmaksdae") then
		return true;
	end
	if HasPlayerTech(iPlayer, techNWAsia2, "dedewferger") then
		return true;
	end
	return false;
end

function IsSomehowImmuneToFlee(iUnit, iPlayer)
	if iUnit:IsHasPromotion(GameInfoTypes.PROMOTION_ITG_MERCENARY_9) then
		return true;
	end
	if iUnit:GetUnitType() == uMedPikeman3 then
		if gT.Players[iPlayer] then
			local uID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
			if gT.Players[iPlayer].UnitsByID[uID] and gT.Players[iPlayer].UnitsByID[uID].LastPillage then
				if gT.Players[iPlayer].UnitsByID[uID].LastPillage + 5 >= GetITGGameTurn() then
					return true;
				end
			end
		end
	end
	return false;
end

function GetMercenaryToolTipInfo(iUnit)
	if not iUnit:IsMercenary() then
		return nil;
	end
	local iPlayer = iUnit:GetOwner();
	if IsMercenaryFleeImmune(iPlayer) then
		return {"Mercenaries do not flee due to Innovation.", 0};
	elseif IsSomehowImmuneToFlee(iUnit, iPlayer) then
		if iUnit:IsHasPromotion(GameInfoTypes.PROMOTION_ITG_MERCENARY_9) then
			return {"This famous Mercenaries' Group is known for their loyalty.", 0};
		end
		if iUnit:GetUnitType() == uMedPikeman3 then
			local uID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
			if gT.Players[iPlayer].UnitsByID[uID] and gT.Players[iPlayer].UnitsByID[uID].LastPillage then
				return {"Mercenaries will not flee 5 turns after last pillaging (" .. (gT.Players[iPlayer].UnitsByID[uID].LastPillage + 6 - GetITGGameTurn()) .. "T left)." , 0};
			end
		end
	end
	local text = "Flee chance is affected by:"
	local timeofservice = GetRealGameTurn() - iUnit:GetGameTurnCreated()
	local uID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
	local fTab = {}

	--checked
	table.insert(fTab, {GetFleeChanceFromDanger(iUnit), "danger"})
	table.insert(fTab, {GetFleeChanceFromTimeOfService(iUnit, timeofservice), "service (" .. timeofservice .. "T)"})
	table.insert(fTab, {GetFleeChanceFromRecentDMGTaken(iUnit, uID, iPlayer, false), "recent damage taken"})
	table.insert(fTab, {GetFleeChanceFromCurrentHP(iUnit), "current HP"})
	
	--positive:
	table.insert(fTab, {GetFleeChanceFromCity(iUnit), "City"})
	table.insert(fTab, {GetFleeChanceFromStackedUnit(iUnit, iPlayer), "stacked unit"})
	table.insert(fTab, {GetFleeChanceFromMorale(iUnit, gT.Players[iPlayer].Morale), "morale"})
	table.insert(fTab, {GetFleeChanceFromUnitType(iUnit), "Unit type"})
	table.insert(fTab, {GetFleeFromSocialDevs(iPlayer), "social developments"})
	table.insert(fTab, {GetFleeFromAuthority(iPlayer), "Authority"})
	table.insert(fTab, {GetLoyalModFromGeneralsAndAdmirals(iPlayer), "Great People"})
	table.insert(fTab, {GetFleeFromPillagedImpros(iPlayer), "pillaging"})	
	
	local totalchance = 0;		
	for a, b in pairs(fTab) do
		totalchance = totalchance + b[1];
		if b[1] > 0 then
			text = text .. "[NEWLINE][ICON_BULLET][COLOR_NEGATIVE_TEXT]+" .. b[1] .. "%[ENDCOLOR] [ICON_ITG_MERCENARY] from " .. b[2] .. ".";
		elseif b[1] < 0 then
			text = text .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]" .. b[1] .. "%[ENDCOLOR] [ICON_ITG_MERCENARY] from " .. b[2] .. ".";
		end
	end
	text = text .. "[NEWLINE]----------------[NEWLINE]Total: " .. math.max(0,totalchance) .. "%"
	local iMaxChance = GetMaxFleeFromTimeOfService(timeofservice);
	if iMaxChance < 100 then
		text = text .. "[NEWLINE][NEWLINE]Chance cannot exceed [COLOR_POSITIVE_TEXT]" .. iMaxChance .. "%[ENDCOLOR] (based on turns of service).";
	end
	text = text .. "[NEWLINE][NEWLINE]Flee chance triggers on both start and end of your turn!";
	return {text, math.max(0, math.min(totalchance, iMaxChance))};
end

LuaEvents.ITG_RequestUnitMercenaryData.Add(function(iPlayer, unitID)
	MapModData.ITGSG = GetMercenaryToolTipInfo(Players[iPlayer]:GetUnitByID(unitID))
end)

function GetChanceToJoinArmy(numToJoinArmy,timeofservice)
	return numToJoinArmy * math.ceil(timeofservice/2);
end

function GetFleeChanceFromStackedUnit(iUnit, iPlayer)
	local hPlot = iUnit:GetPlot();
	if not hPlot:IsCity() then
		local id = iUnit:GetID();
		for j = 0, hPlot:GetNumUnits() - 1 do
			local jUnit = hPlot:GetUnit(j);
			if jUnit:GetOwner() == iPlayer then
				if jUnit:GetID() ~= id then
					if jUnit:GetBaseCombatStrength() >= 5 then
						return -3;
					end
				end
			end
		end
	end
	return 0;
end

function GetFleeChanceFromCity(iUnit)
	local cCity = iUnit:GetPlot():GetPlotCity();
	if cCity then
		if cCity:GetDamage() / cCity:GetMaxHitPoints() <= 0.25 then
			return -3;
		end
	end
	return 0;
end

function GetFleeChanceFromUnitType(iUnit)
	return gf_UnitTypeFleeMod[iUnit:GetUnitType()] or 0;
end

function GetFleeChanceFromRecentDMGTaken(iUnit, uID, iPlayer, bNow)
	local b = 0;
	if (gT.Players[iPlayer].UnitsByID[uID].PrevDamage or 10000) < iUnit:GetDamage() then
		b = b + 1;
	end
	if bNow then
		gT.Players[iPlayer].UnitsByID[uID].PrevDamage = iUnit:GetDamage();
	end
	return b;
end

function GetFleeChanceFromDanger(iUnit)
	local x, y = iUnit:GetX(), iUnit:GetY();
	local iPlayer = iUnit:GetOwner();
	local pTeam = Teams[Players[iPlayer]:GetTeam()];
	local danger = 0;
	local mystr = iUnit:GetCurrHitPoints() * math.max(iUnit:GetBaseCombatStrength(true), iUnit:GetBaseRangedCombatStrength())
	for a, plot in pairs(GetPlotsInRadiusOfPlot(iUnit, 2)) do
		local hDis = Map.PlotDistance(x, y, plot:GetX(), plot:GetY())
		if hDis > 0 then
			if plot:IsCity(iUnit) then
				local eCity = plot:GetPlotCity();
				if eCity:GetMaxHitPoints() > eCity:GetDamage() then
					if not eCity:IsResistance() then
						if pTeam:IsAtWar(Players[eCity:GetOwner()]:GetTeam()) then
							if hDis == 1 then
								danger = danger + 2;
							else
								danger = danger + 1;
							end
						end
					end
				end
			elseif plot:IsVisibleEnemyDefender(iUnit) then
				local enemy = plot:GetBestDefender(-1, iPlayer, iUnit, 1)
				if enemy then
					local evalstr = enemy:GetCurrHitPoints() * math.max(enemy:GetBaseCombatStrength(true), enemy:GetBaseRangedCombatStrength())
					if evalstr > 0 then
						danger = danger + 1;
						if hDis == 1 then
							danger = danger + 1;
						end
						if evalstr > mystr then
							danger = danger + 1;
						end
					end
				end
			end
		end
	end
	return danger;
end

function GetFleeChanceFromTimeOfService(iUnit, timeofservice)	
	return math.ceil(math.max(timeofservice - 25, 0) / 10)
end

function GetFleeChanceFromMorale(iUnit, morale)
	if morale >= 10 then
		return -1;
	end
	return 0;
end

function GetMaxFleeFromTimeOfService(timeofservice)
	return math.min(15, math.max(0, math.floor(timeofservice / 2) - 2));
end

function GetFleeChanceFromCurrentHP(iUnit)
	local cHP = iUnit:GetCurrHitPoints()
	if cHP < 80 then
		return math.ceil((80 - cHP) / 10)
	end
	return 0;
end

function DoCheckIfMercenariesShouldFlee(iPlayer)
	local mtab = {}
	if not IsMercenaryFleeImmune(iPlayer) then
		for iUnit in Players[iPlayer]:Units() do
			if iUnit:IsMercenary() then
				if not IsSomehowImmuneToFlee(iUnit, iPlayer) then
					table.insert(mtab, iUnit)
				end
			end
		end
	end
	if #mtab > 0 then
		local iturn = GetRealGameTurn();
		local morale = gT.Players[iPlayer].Morale;
		local playerbaseescape = GetPlayerMercenaryEscapeMod(iPlayer)
		for i, iUnit in pairs(mtab) do
			local timeofservice = iturn - iUnit:GetGameTurnCreated()
			local uID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
--reedited	
			local baseescape = GetFleeChanceFromDanger(iUnit)
			baseescape = baseescape + GetFleeChanceFromCity(iUnit);
			baseescape = baseescape + GetFleeChanceFromTimeOfService(iUnit, timeofservice)
			baseescape = baseescape + GetFleeChanceFromMorale(iUnit, morale)
			baseescape = baseescape + GetFleeChanceFromStackedUnit(iUnit, iPlayer)
			baseescape = baseescape + GetFleeChanceFromRecentDMGTaken(iUnit, uID, iPlayer, true);
			baseescape = baseescape + GetFleeChanceFromCurrentHP(iUnit)
			baseescape = baseescape + GetFleeChanceFromUnitType(iUnit)
			
			baseescape = math.min(baseescape + playerbaseescape, GetMaxFleeFromTimeOfService(timeofservice)) ;-- mercenaries were too unreliable
			if LastChance(baseescape) then
	--			print("Mercenary fleed (player/chance)", iPlayer, baseescape)
				DoMakeMercenaryFlee(iPlayer, iUnit, baseescape)
			end
		end
	end
end

function GetFleeFromPillagedImpros(iPlayer)
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_PAGAN_5, "EGgr") then
		return - math.floor(gT.Players[iPlayer].PillagedImpros / 5)
	end
	return 0;
end

function GetFleeFromSocialDevs(iPlayer)
	local a = 0;
	if gT.Players[iPlayer].CultBonusOn[200] then
		a = a - 1 * gT.Players[iPlayer].DeadMerc;
	end
	return a;
end

function GetFleeFromAuthority(iPlayer)
	return -1 * math.floor((gT.Players[iPlayer].Authority or 0) / 50)
end

function GetPlayerMercenaryEscapeMod(iPlayer)
	local playerbaseescape = GetLoyalModFromGeneralsAndAdmirals(iPlayer) + GetFleeFromPillagedImpros(iPlayer);
	playerbaseescape = playerbaseescape + GetFleeFromAuthority(iPlayer) + GetFleeFromSocialDevs(iPlayer);
	return playerbaseescape
end

function DoMakeMercenaryFlee(iPlayer, iUnit, chance)
	if LastRandom(1,5) == 3 then
		TakeCareOfEventMorale(iPlayer, 25, {-1, "Desertion"})
	end
	if IsHasLaw(iPlayer, 28, 2) then
		gT.Players[iPlayer].RebelChanceExtra = gT.Players[iPlayer].RebelChanceExtra + 3;
	end
	if Players[iPlayer]:IsHuman() then
		Players[iPlayer]:AddNotification(88413212, "Filthy Mercenaries broke their word and left us in the darkest hour (" .. chance .. "%)!", "Desertion!", iUnit:GetX(), iUnit:GetY(), iUnit:GetUnitType(), 13)	
	end
	if iUnit:GetDomainType() == dSea then
		DoPirateFleeNavalUnit(iUnit:GetUnitType(), iUnit:GetMaxHitPoints() - iUnit:GetDamage(), iUnit:GetName(), iPlayer)
	end
	iUnit:Kill(false, -1)
end

function DoSelectUnitClassesToBeSpecialMercenary()
	gT.Mercenaries = {}
	local tClassV = {}
	local nump = 0;
	for i, gd in pairs(gT.Players) do
		for iClass, sth in pairs(gd.UnitClassXP) do
			tClassV[iClass] = (tClassV[iClass] or 0) + sth;
		end
		if not Players[i]:IsMinorCiv() then
			nump = nump + 1;
		end
	end
	local ttab = {}
	for iClass, val in pairs(tClassV) do
		if not IsInvalidForMerc[iClass] then
			if val - (gT.Globals.MercenaryLog[iClass] or 0) > 0 then
				table.insert(ttab, {iClass, val - (gT.Globals.MercenaryLog[iClass] or 0)})
				gT.Globals.MercenaryLog[iClass] = val;
			end
		end
	end
	local toadd = math.max(2, nump + LastRandom(-1, 1))
	if #ttab == 0 then
		print("Not enough mercenary unit classes?")
	end
	for i = 1, toadd do
		local iClassL = GetRandomFromBiasedChanceTable(ttab)
		gT.Mercenaries[iClassL] = (gT.Mercenaries[iClassL] or 0) + 1;
	end
end

function DoChangeMercenaryCost()
	local tMightyOnes, tSo = {}, 0;
	local iTurn = GetITGGameTurn();
	for i, gd in pairs(gT.Players) do
		if not Players[i]:IsMinorCiv() then
			gT.Players[i].MercCostMight = 0;
			if Players[i]:GetMilitaryMight() > tSo then
				tSo = Players[i]:GetMilitaryMight()
				tMightyOnes = {}
				table.insert(tMightyOnes, i)
			elseif Players[i]:GetMilitaryMight() == tSo then
				table.insert(tMightyOnes, i)
			end
			if iTurn >= gd.MercCostLastPurchase + 4 then
				gT.Players[i].MercCostIncrease = math.max(0, gT.Players[i].MercCostIncrease - 20)
			end
			if gd.MercCostDoWed > 0 then
				gT.Players[i].MercCostDoWed = gT.Players[i].MercCostDoWed - 5;
			end
		end
	end
	for i, v in pairs(tMightyOnes) do
		gT.Players[v].MercCostMight = -10;
	end
	for i, gd in pairs(gT.Players) do
		if not Players[i]:IsMinorCiv() then
			DoSetMercCostRightNow(i)
		end
	end
end

function GetMercCostModifierFromBlackArmy(iPlayer)
	if gT.Players[iPlayer].CultBonusOn[198] then
		return -20;
	end
	return 0;
end

function GetMercCostModifierFromLeagues(iPlayer)
	local base = 0;
	for league, sth in pairs(gT.Leagues) do
		if sth.Members[iPlayer] then
			if sth.Resolutions[55] then
				base = base + 50;
			end
		end
	end
	return base;
end

function GetMercCostFromCH(iPlayer)
	if HasPlayerCHIncomingTrait(iPlayer, 16) then
		return -17;
	end
	return 0;
end

function DoChangeMercHolyArmCost(iPlayer, amount)
	gT.Players[iPlayer].MercHolyArm = gT.Players[iPlayer].MercHolyArm + amount;
	DoSetMercCostRightNow(iPlayer)
end 

function DoSetMercCostRightNow(iPlayer)
	local base = gT.Players[iPlayer].MercCostMight + gT.Players[iPlayer].MercCostIncrease + GetMercCostModifierFromLeagues(iPlayer) + GetMercCostModifierFromBlackArmy(iPlayer)
	base = base + GetMercCostModifierFromA(iPlayer) + gT.Players[iPlayer].MercCostDoWed + GetMercCostFromCH(iPlayer) + gT.Players[iPlayer].MercHolyArm;
	if HasPlayerTech(iPlayer, techAncEmp14, "kcmaksdae") then
		base = math.min(base, 100)
	end
	Players[iPlayer]:SetMercenaryModifier(math.max(-80, base))
end

function DoIncreaseCosOfMercenaryUponPurchase(iPlayer)
	if gT.Players[iPlayer].CultBonusOn[199] then
		if gT.Players[iPlayer].Morale < gT.Players[iPlayer].MaxMoraleRange then
			TakeCareOfEventMorale(iPlayer, 25, {1, "Golden Army"})
		end
	else
		gT.Players[iPlayer].MercCostIncrease = gT.Players[iPlayer].MercCostIncrease + MERC_COST_INCREASE;
	end
	gT.Players[iPlayer].MercCostLastPurchase = GetITGGameTurn();
end

function GetNameForMercenaryClass(gPlayer, h)
	local unittype = Players[gPlayer]:GetPlayerUniqueUnit(h);
	if unittype ~= -1 then
		return Locale.Lookup(GameInfo.Units[unittype].Description or "NBAU")
	end
	return Locale.Lookup(GameInfo.UnitClasses[h].Description or "NBA")
end

function GetMercCostModifierFromA(gPlayer)
	local b = 0;
	if HasPlayerTech(gPlayer, tAfrInnoNw4, "tAfrInnonw4") then
		b = b - 33;
	end
	return b;
end

function GetMercenaryTextForTP(gPlayer)
	local avSpecMercenaries = 0;
	for h, v in pairs(gT.Mercenaries) do
		avSpecMercenaries = avSpecMercenaries + v;
	end
	local hstr = ""
	if avSpecMercenaries == 0 then
		hstr = "Right now there is no famous Mercenaries available to purchase.[NEWLINE][NEWLINE]"
	else
		if avSpecMercenaries == 1 then
			hstr = "We know about [COLOR:252:148:41:255]1[ENDCOLOR] famous Companion of Mercenaries that may serve us."
		else
			hstr = "We know about [COLOR:252:148:41:255]" .. avSpecMercenaries .. "[ENDCOLOR] famous Mercenary Groups that may serve us."
		end
		for h, v in pairs(gT.Mercenaries) do
			hstr = hstr .. "[NEWLINE][ICON_BULLET]" .. GetNameForMercenaryClass(gPlayer, h) 
			if v > 1 then
				hstr = hstr .. " (" .. v .. ")"
			end
		end
		hstr = hstr .. "[NEWLINE][NEWLINE]"
	end
	hstr = hstr .. "Mercenary cost temporary increases each time you purchase new unit (+" .. MERC_COST_INCREASE .. "%). Your current cost is [COLOR:252:148:41:255]" .. (Players[gPlayer]:GetMercenaryModifier() + 100) .. "%[ENDCOLOR]."
	local mercTab = {}
	table.insert(mercTab, {gT.Players[gPlayer].MercCostIncrease, "Recent Purchases"})
	table.insert(mercTab, {gT.Players[gPlayer].MercCostMight, "Military Might"})
	table.insert(mercTab, {gT.Players[gPlayer].MercHolyArm, "Holy Arm"})
	table.insert(mercTab, {GetMercCostModifierFromA(gPlayer), "Amabutho"})
	table.insert(mercTab, {GetMercCostModifierFromLeagues(gPlayer), "Leagues"})
	table.insert(mercTab, {GetMercCostFromCH(gPlayer), "Customs Houses"})
	table.insert(mercTab, {gT.Players[gPlayer].MercCostDoWed, "Recently DoWed"})
	table.insert(mercTab, {GetMercCostModifierFromBlackArmy(gPlayer), "Black Army"})
	for i, v in pairs(mercTab) do
		if v[1] > 0 then
			hstr = hstr .. "[NEWLINE][ICON_BULLET][COLOR:252:148:41:255]+" .. v[1] .. "%[ENDCOLOR] from " .. v[2] .. "." 
		elseif v[1] < 0 then
			hstr = hstr .. "[NEWLINE][ICON_BULLET][COLOR:252:148:41:255]" .. v[1] .. "%[ENDCOLOR] from " .. v[2] .. "." 
		end
	end
	if gT.Players[gPlayer].MercCostIncrease > 0 then
		hstr = hstr .. "[NEWLINE][NEWLINE]Once 4 turns pass after your last purchase the extra cost is gonna fall down. Your last purchase was made in " .. gT.Players[gPlayer].MercCostLastPurchase .. " turn."
	end
	if Players[gPlayer]:GetUnitPurchaseCostModifier() ~= 0 then
		hstr = hstr .. "[NEWLINE][NEWLINE]Unit purchase cost is also modified by other bonuses, which is currently at " .. (100 + Players[gPlayer]:GetUnitPurchaseCostModifier())  .. "% rate."
	end
	return hstr;
end

function CanHaveMercenaryFromGoodyHut(iPlayer)
	if not DBScenario.NoMercenaries then
		for iclass, sth in pairs(gT.Mercenaries) do
			if gT.Players[iPlayer].UnitClassXP[iclass] then
				local ut = Players[iPlayer]:GetPlayerUniqueUnit(iclass);
				if ut ~= -1 then
					if GameInfo.Units[ut].Domain == "DOMAIN_LAND" then
						return true;
					end
				end
			end
		end
	end
	return false;
end

function DoSpawnMercenaryFromGoodyHut(iPlayer, iPlot, bDoNotReduce)
	local tgh = {}
	local tct = {}
	for iclass, sth in pairs(gT.Mercenaries) do
		if gT.Players[iPlayer].UnitClassXP[iclass] then
			local ut = Players[iPlayer]:GetPlayerUniqueUnit(iclass);
			if ut ~= -1 then
				if GameInfo.Units[ut].Domain == "DOMAIN_LAND" then
					table.insert(tgh, ut)
					tct[ut] = iclass;
				end
			end
		end
	end
	local unittype = tgh[LastRandom(1,#tgh)];
	if not bDoNotReduce then
		gT.Mercenaries[tct[unittype]] = gT.Mercenaries[tct[unittype]] - 1;
		if gT.Mercenaries[tct[unittype]] == 0 then
			gT.Mercenaries[tct[unittype]] = nil
		end
	end
	local iUnit = Players[iPlayer]:InitUnit(unittype, iPlot:GetX(), iPlot:GetY())
	iUnit:JumpToNearestValidPlot();
	iUnit:SetLevel(LastRandom(4, 6));
	iUnit:SetName(GetRandomNameForCompany())
	ITGSCNewUnitCreated(iPlayer, iUnit, nil, false, nil, nil, false)
	AcquireNewSpecialMercenary(iUnit, iPlayer)
	CheckAchievement44(iPlayer)
end

function GetTabOfMercenaryPromAll(cv)
	local tab = {}
	for i, v in pairs(mercTabOfBonuses) do
		table.insert(tab, v.Promotion)
	end
	return tab;
end

LuaEvents.ITG_RequestUnitHealRateToolTip.Add(function(iPlayer, unitID)
	local iUnit = Players[iPlayer]:GetUnitByID(unitID);
	local iPlot = iUnit:GetPlot();
	local tHR = 0;
	local sText = "Heal Rate sources and modifiers:"
	if iPlot:IsPlague() then
		sText = sText .. "[NEWLINE][ICON_BULLET]Cannot heal within 2 range from [ICON_ITG_PLAGUE_4] Epidemy."
	elseif (iPlot:GetFeatureType() == GameInfoTypes.FEATURE_FALLOUT) and (not iUnit:IsImmobile()) then
		sText = sText .. "[NEWLINE][ICON_BULLET]Cannot heal on Fallout."
	elseif iUnit:IsEmbarked() then
		sText = sText .. "[NEWLINE][ICON_BULLET]Cannot heal while embarked."
	elseif (iUnit:GetMoves() < iUnit:MaxMoves()) and (not iUnit:IsAlwaysHeal()) then
		sText = sText .. "[NEWLINE][ICON_BULLET]Can heal only at full movement."
	else
		local bPass = true;
		if iUnit:GetDomainType() == dSea then
			if (not iUnit:IsHealOutsideFriendly()) and (not iUnit:IsInFriendlyTerritory()) then
				bPass = false;
				if Players[iPlayer]:IsNavalHealCoastal() then
					for j = 0, 5 do
						local nPlot = Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), j);
						if nPlot and (not nPlot:IsWater()) then
							sText = sText .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]+5[ENDCOLOR] Heal Rate from adjacent Coast."
							bPass = true;
						end
					end
				end
			end
		end
		if bPass then
			tHR = iUnit:GetHealRate();
			local iHealFromReligion = iUnit:GetHealRateFromReligion()
			if iHealFromReligion ~= 0 then
				sText = sText .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]+" .. iHealFromReligion .. "[ENDCOLOR] Heal Rate from Religion."
			end
			local iHealFromFreshWater = iUnit:GetExtraHealFreshWater();
			if (iHealFromFreshWater ~= 0) and iPlot:IsFreshWater() then
				sText = sText .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]+" .. iHealFromFreshWater .. "[ENDCOLOR] Heal Rate from Fresh Water."
			end
			if Players[iPlayer]:IsSupplyExtraHeal() then
				if Players[iPlayer]:GetNumUnitsOutOfSupply() == 0 then
					sText = sText .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]+5[ENDCOLOR] Heal Rate from Unit Supply."
				end
			end
			local iMedicHeal = iUnit:GetHealRateFromBestMedic();
			if iMedicHeal ~= 0 then
				sText = sText .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]+" .. iMedicHeal .. "[ENDCOLOR] Heal Rate from Medic."
			end
			local iBaseHeal = iUnit:GetBaseHealRate();
			if iBaseHeal ~= 0 then
				sText = sText .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]+" .. iBaseHeal .. "[ENDCOLOR] Heal Rate from territory (base)."
			end
			local iExtraHeal = iUnit:GetExtraHealRate();
			if iExtraHeal > 0 then
				sText = sText .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]+" .. iExtraHeal .. "[ENDCOLOR] Heal Rate from territory (extra)."
			elseif iExtraHeal < 0 then
				sText = sText .. "[NEWLINE][ICON_BULLET][COLOR_NEGATIVE_TEXT]" .. iExtraHeal .. "[ENDCOLOR] Heal Rate from territory (extra)."
			end
			if iPlot:IsImprovementPillaged() then
				local iPillagedHeal = iUnit:GetPillagedHealRate()
				if iPillagedHeal ~= 0 then
					sText = sText .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]+" .. iPillagedHeal .. "[ENDCOLOR] Heal Rate from pillaged improvement."
				end
			end
			local iUCtype = iUnit:GetUnitCombatType()
			if iUCtype ~= -1 then
				local iUCheal = Players[iPlayer]:GetUnitCombatHealRateChange(iUCtype);
				if iUCheal ~= 0 then
					sText = sText .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]+" .. iUCheal .. "[ENDCOLOR] Heal Rate from Unit Combat Type."
				end
			end
			local iPlayerExtraHeal = Players[iPlayer]:GetExtraHealRateUnits();
			if iPlayerExtraHeal ~= 0 then
				sText = sText .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]+" .. iPlayerExtraHeal .. "[ENDCOLOR] Heal Rate from player."
			end
			--THIS IS PROBABLY LEFT-OVER from civ IV
--			local iModBaseHeal = Players[iPlayer]:GetUnitBaseHealModifier();
			--// removed from DLL
			local iTotalMod = iUnit:GetTotalHealRateMod();
			if iTotalMod ~= 100 then
				sText = sText .. "[NEWLINE][ICON_BULLET]Heal Rate is only [COLOR_NEGATIVE_TEXT]" .. iTotalMod .. "%[ENDCOLOR] effective due to recent combat.";
			end
			sText = sText .. "[NEWLINE]----------------[NEWLINE]Total: [COLOR_POSITIVE_TEXT]+" .. tHR .. "[ENDCOLOR]"

			if iUnit:IsAlwaysHeal() then
				sText = sText .. "[NEWLINE][NEWLINE]This unit can heal even after spending movement."
			end
		else
			sText = sText .. "[NEWLINE][ICON_BULLET]Cannot heal in unfriendly territory."
		end
	end
	MapModData.ITGSG = {sText, tHR}
end)