local bInquisition = GameInfoTypes.BUILDING_ITG_NEW_WORLD_INQUISITION;
local techTRIALpagan1 = GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_PAGAN_1;
local arabtrial4 = GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_ARABIA_4;
local statueofliberty = GameInfoTypes.BUILDING_ITG_NEW_INDUSTRIAL_WONDER_5
local maxReligionITT = -1;
for row in GameInfo.Religions() do
	maxReligionITT = maxReligionITT + 1;
end

function FindGoodCityMigrateTo(fCity, iPlayer, dis, iReason, iextraInfo, avoidPlayer)
	local hTab = {}
	if iReason == 6 then
		for iCity in Players[iPlayer]:Cities() do
			if iCity:GetPopulation() > 14 and iCity:GetPopulation() < 20 then
				if fCity:GetID() ~= iCity:GetID() then
					table.insert(hTab, iCity);
				end
			end
		end
		if #hTab > 0 then
			return hTab[LastRandom(1,#hTab)];
		end
		return nil;
	end
	for g, gdata in pairs(gT.Players) do
		if g ~= avoidPlayer then
			local bHasCustoms12 = HasPlayerCHIncomingTrait(g, 12);
			for iCity in Players[g]:Cities() do
				if not iCity:IsPlague() then
					if Map.PlotDistance(fCity:GetX(), fCity:GetY(), iCity:GetX(), iCity:GetY()) <= dis then
						--iReasons
						if iCity ~= fCity then
							local cID = fCity:Plot():GetPlotIndex() .. "," .. fCity:GetGameTurnFounded();
							local value = 0;
							if iCity:GetDamage() == 0 then
								value = value + 2;
							end
							if iCity:IsHasBuilding(GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_20) then
								value = value + 20;
							end
							if bHasCustoms12 then
								value = value + 10;
							end
							if iReason == 1 then --religion oppression
								if g ~= iPlayer then
									value = value + 1;
									if iCity:GetReligiousMajority() == iextraInfo then
										value = value + 2;
										table.insert(hTab, {iCity, value})
									end
								elseif not iCity:IsHasBuilding(bInquisition) then
									table.insert(hTab, {iCity, value})
								end
							elseif iReason == 2 or iReason == 4 then -- starvation / city conquer
								if g ~= iextraInfo then
									if g == iPlayer then
										value = value + 2;
									end
									if iCity:FoodDifference() > 2 then
										table.insert(hTab, {iCity, value})
									end
								end
							elseif iReason == 3 then -- happiness
								if g == iPlayer then
									value = value + 4;
								end
								if gT.Cities[cID].Happiness > 0 then
									if gT.Cities[cID].Happiness > 5 then
										value = value + 3;
									end
									table.insert(hTab, {iCity, value})
								end
							end
						end
					end
				end
			end
		end
	end
	if #hTab > 0 then
		hTab = Shuffle(hTab);
		table.sort(hTab, SortFunctionForGreaterInteger2)
		return hTab[1][1];
	end
	return nil;
end

function CityCantMigrateAway(iCity, iPlayer)
	if iCity:GetPopulation() <= 1 then
		return true;
	end
	if iCity:IsPlague() then
		if IsHasLaw(iPlayer, 26, 1) then
			return true;
		end
		if HasPlayerTech(iPlayer, arabtrial4, "arabtrial4") then
			return true;
		end
	end
	if gT.Players[iPlayer].HasPlayerWonder[statueofliberty] then
		return true;
	end
	return false;
end

function GetFoodModFromMigrations(tPlayer)
	local m = 1;
	if HasPlayerCHIncomingTrait(tPlayer, 12) then
		m = m + 1;
	end
	return m;
end

function MigrationFromCity(iCity, iPlayer, iReason, iextraInfo, avoidPlayer)
	if CityCantMigrateAway(iCity, iPlayer) then
		return;
	end
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	iCity:ChangePopulation(-1, true);
	local iFood = iCity:GrowthThreshold();
	local tCity = FindGoodCityMigrateTo(iCity, iPlayer, 10, iReason, iextraInfo, avoidPlayer);
	local tPlayer;
	if (not tCity) and (iReason == 6) then
		return; --megacities
	end
	if tCity then
		tPlayer = tCity:GetOwner();
		tCity:ChangeFood(iFood * GetFoodModFromMigrations(tPlayer));
		if tCity:GrowthThreshold() <= tCity:GetFood() then
			tCity:ChangeFood(- math.floor(tCity:GrowthThreshold() * (100 - tCity:GetFoodKept()) / 100))
			tCity:ChangePopulation(1, true);
		end
		CityMigrationToCityInfluence(tCity, iCity)
		if gT.Players[tPlayer].HasPlayerWonder[statueofliberty] then
			if tPlayer ~= iPlayer then
				gT.Players[tPlayer].StatueOfLibertyBonus = gT.Players[tPlayer].StatueOfLibertyBonus + 1;
			end
		end
	end
	if Players[iPlayer]:IsHuman() then
		if iReason ~= 4 then
			local string = "";
			if iReason == 1 then
				string = "People of " .. iCity:GetName() .. " (-1 [ICON_CITIZEN]) has left their homes due to so-called religious oppression." 
			elseif iReason == 2 then
				string = "People of " .. iCity:GetName() .. " (-1 [ICON_CITIZEN]) had flee from town in the time of trouble to avoid starvation."
			elseif iReason == 3 then
				string = "People of " .. iCity:GetName() .. " (-1 [ICON_CITIZEN]) abandoned their homes in their quest for a better life."
			elseif iReason == 5 then
				string = "People of " .. iCity:GetName() .. " (-1 [ICON_CITIZEN]) left their goods behind while escaping from epidemy."
			elseif iReason == 6 then
				string = "People of " .. iCity:GetName() .. " (-1 [ICON_CITIZEN]) are massively migrating to more populated Cities."
			end
			if tCity then
				if tPlayer == iPlayer then
					string = string .. " Most of them have settled in " .. tCity:GetName() .. " (+" .. iFood .. "[ICON_FOOD]).";
				else
					string = string .. " Most of them have settled in " .. tCity:GetName() .. " (" .. Players[tPlayer]:GetCivilizationShortDescription() .. ").";
				end
			else
				string = string .. " Unfortunately, it seems that most of them either died or settled in small villages.";
			end
			Players[iPlayer]:AddNotification(NotificationTypes.NOTIFICATION_STARVING, string, "Migration", iCity:GetX(), iCity:GetY())
		end
	end
	if tPlayer and (tPlayer ~= iPlayer) and Players[tPlayer]:IsHuman() then
		local string = "The city of " .. tCity:GetName() .. " has welcomed emigrants from " .. iCity:GetName()  .. " (+" .. iFood .. "[ICON_FOOD])." 
		Players[tPlayer]:AddNotification(NotificationTypes.NOTIFICATION_CITY_GROWTH, string, "Migration", tCity:GetX(), tCity:GetY())
	end
	if tCity then
		DoSpreadEpidemyMigrants(iCity, tCity)
	end
end

function GetTotalMigrationChanceModifier(iPlayer)
	local b = 1;
	for league, sth in pairs(gT.Leagues) do
		if sth.Members[iPlayer] then
			if sth.Resolutions[54] then
				b = b + 0.33;
			end
		end
	end
	b = b + 0.05 * gT.Players[iPlayer].FascismAuth;
	return b;
end

function MakeMigrationDoTurn(iPlayer)
	gT.Players[iPlayer].MigrationChanceMods = GetTotalMigrationChanceModifier(iPlayer)
	for iCity in Players[iPlayer]:Cities() do
		if ShouldDoMigrationFromPlague(iCity) then
			MigrationFromCity(iCity, iPlayer, 5)
		elseif ShouldDoMigrationFromStarvation(iCity) then
			MigrationFromCity(iCity, iPlayer, 2)
		elseif ShouldDoMigrationFromUnhappy(iCity) then
			MigrationFromCity(iCity, iPlayer, 3)
		elseif ShouldDoMigrationFromMegaCities(iCity, iPlayer) then
			MigrationFromCity(iCity, iPlayer, 6)
		end
	end
end

function ShouldDoMigrationFromMegaCities(iCity, iPlayer)
	if gT.Players[iPlayer].HasIdeology[82] then
		if iCity:GetPopulation() >= 15 then
			return false;
		end
		local h = iCity:GetPopulation();
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		if (gT.Cities[cID].MegaCitiesMigCD or -1) > GetITGGameTurn() then
			return false;
		end
		if LastRandom(1, 100) <= 20 - iCity:GetPopulation() then
			gT.Cities[cID].MegaCitiesMigCD = GetITGGameTurn() + LastRandom(8,12);
			return true;
		end
	end
	return false;
end

function ShouldDoMigrationFromStarvation(iCity)
	if gT.Players[iCity:GetOwner()].HasIdeology[69] then
		return false;
	end
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local gplesslikelytomigrate = GetITGCityInteger(iCity, "CI_GP_LESS_MIGRATE");
	if gplesslikelytomigrate > 0 then
		if LastRandom(1, gplesslikelytomigrate + 2) <= gplesslikelytomigrate then
			return false;
		end
	end
	local chance = -iCity:FoodDifference();
	if chance * (gT.Players[iCity:GetOwner()].MigrationChanceMods) >= LastRandom(1,30) then
		return true;
	end
	return false;
end

function ShouldDoMigrationFromPlague(iCity)
--gp not work here
	if iCity:IsPlague() then
		if LastRandom(1, 100) <= (25 * gT.Players[iCity:GetOwner()].MigrationChanceMods) then
			return true;
		end
	end
	return false;
end

function ShouldDoMigrationFromUnhappy(iCity)
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local lesslikelytomigrate = GetITGCityInteger(iCity, "CI_GP_LESS_MIGRATE");
	if lesslikelytomigrate > 0 then
		if LastRandom(1, lesslikelytomigrate + 2) <= lesslikelytomigrate then
			return false;
		end
	end
	if (-gT.Cities[cID].Happiness) * gT.Players[iCity:GetOwner()].MigrationChanceMods >= LastRandom(1, 250) then
		return true;
	end
	return false;
end

function MakeCityAbandonAllHopes(iCity, newPlayer)
	if iCity:GetPopulation() >= LastRandom(1,20) then
		MigrationFromCity(iCity, newPlayer, 4, newPlayer)
	end
end

function DoReligiousOppressionMigration(iCity, iRel, avoidPlayer)
	if HasPlayerTech(iCity:GetOwner(), techTRIALpagan1, "tp1") then
		return;
	end
	local mRelTab = {};
	local totfol = 0;
	for rel = 1, maxReligionITT do
		if rel ~= iRel then
			if iCity:GetNumFollowers(rel) > 0 then
				totfol = totfol + iCity:GetNumFollowers(rel);
				table.insert(mRelTab, rel);
			end
		end
	end
	if totfol >= LastRandom(1, iCity:GetPopulation() * 2) then
		MigrationFromCity(iCity, iCity:GetOwner(), 1, mRelTab[LastRandom(1,#mRelTab)], avoidPlayer)
	end
end

function DoReligiousOppresionInquisition(iCity, iPlayer)
	local her = GetCityModifierFromHeresy(iCity) * 250;
	if her >= LastRandom(1,1000) then
		local mRelTab = {}
		local iRel = gT.Players[iPlayer].OfficialReligion;
		for rel = 1, maxReligionITT do
			if rel ~= iRel then
				if iCity:GetPressurePerTurn(rel) > 0 then
					table.insert(mRelTab, rel);
				end
			end
		end
		if #mRelTab > 0 then
			MigrationFromCity(iCity, iPlayer, 1, mRelTab[LastRandom(1,#mRelTab)])
		end
	end
end