local techTRIALHorde7 = GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_HORDE_7;
local cBbarracks = GameInfoTypes.BUILDINGCLASS_BARRACKS;
local cBarmory = GameInfoTypes.BUILDINGCLASS_ARMORY
local wonderMoral22 = GameInfoTypes.BUILDING_ITG_NEW_WORLD_WONDER_22;
local wonderMoral21 = GameInfoTypes.BUILDING_ITG_NEW_WORLD_WONDER_21;
local cstateancient2 = GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_2;
local afr8tech = GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_AFR_8;
local techAnc30CS = GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_30
local ValidEpoqueForWoB = {[1] = true, [2] = true, [3] = true}
local fFallout = GameInfoTypes.FEATURE_FALLOUT;
local promMerc30 = GameInfoTypes.PROMOTION_ITG_MERCENARY_30;
local promAdm36	= GameInfoTypes.PROMOTION_ITG_GREAT_ADMIRAL_36;
local promGen41	= GameInfoTypes.PROMOTION_GREAT_GENERAL_41;
local minMoraleUnits = {
[GameInfoTypes.UNIT_ITG_AOT_SWORDSMAN_UU_2] = 15,
[GameInfoTypes.UNIT_ITG_IND_MUSKETMAN_UU_7] = 15,
[GameInfoTypes.UNIT_ITG_TRIAL_KNIGHT_10] = 15,
}

function IsImmuneDoDemoralize(iUnit)
	if minMoraleUnits[iUnit:GetUnitType()] then
		return true;
	end
	if iUnit:IsHasPromotion(promAdm36) or iUnit:IsHasPromotion(promMerc30) or iUnit:IsHasPromotion(promGen41) then
		return true;
	end
	return false;
end

function GetCertainUnitMorale(iUnit, iPlayer)
	local base = gT.Players[iPlayer].Morale;
	if minMoraleUnits[iUnit:GetUnitType()] then
		base = math.max(minMoraleUnits[iUnit:GetUnitType()], base)
	end
	if iUnit:IsHasPromotion(promAdm36) or iUnit:IsHasPromotion(promMerc30) or iUnit:IsHasPromotion(promGen41) then
		base = math.max(15, base);
	end
	return base;
end

function UpdateUnitMoraleBonus(iUnit, iPlayer, bUpgrade)
	if IsCombatClassITGUnit(iUnit:GetUnitClassType(), iPlayer) then
		local uID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
		local tum = GetCertainUnitMorale(iUnit, iPlayer);
		if gT.Players[iPlayer].UnitsByID[uID] then
			iUnit:ChangeCombatPercentModifier(tum - (gT.Players[iPlayer].UnitsByID[uID].MoraleModifier or 0))
			gT.Players[iPlayer].UnitsByID[uID].MoraleModifier = tum;
		end
		if (tum < -10) and (not bUpgrade) then
			if not gT.Players[iPlayer].HasIdeology[51] then
				if LastRandom(1, 50) == 33 then
					iUnit:SetDemoralized(true);
				end
			end
		end
	end
end

function UpdateAllMoraleUnits(iPlayer)
	for iUnit in Players[iPlayer]:Units() do
		UpdateUnitMoraleBonus(iUnit, iPlayer)
	end
end

function AddToMoraleQueueLog(iPlayer, amount, logstring, bCheckRange)
	if bCheckRange then
		if gT.Players[iPlayer].Morale == gT.Players[iPlayer].MaxMoraleRange then
			if amount > 0 then
				return;
			end
		elseif gT.Players[iPlayer].Morale == gT.Players[iPlayer].MinMoraleRange then
			if amount < 0 then
				return;
			end
		end
	end
	table.insert(gT.Players[iPlayer].MoraleQueueLog, {amount, logstring})
end

local bShamanHut = GameInfoTypes.BUILDING_ITG_NW_AFR_HUT;
function GetShamanMoraleTurn(iPlayer)
	if gT.Players[iPlayer].Morale < 10 then
		local iShamanHuts = Players[iPlayer]:CountNumBuildings(bShamanHut)
		for i = 1, iShamanHuts do
			if LastChance(17) then
				return true;
			end
		end
	end
	return false;
end

function DoTurnMoraleUpdate(iPlayer)
	--determine chance of morale change
	local hTab = {{-1, 350}, {1, 350}}
	--rival espionage penalty
	local gTable = GetTabOfAllRivalPlayersDoingFilthyInfiltration(iPlayer)
	local bb = 1;
	if gT.Players[iPlayer].CultBonusOn[159] then
		hTab[2][2] = hTab[2][2] + 350;
	end
	for i, rank in pairs(gTable) do
		bb = bb * (100 - rank * 3) / 100;
	end 
	hTab[2][2] = math.floor(hTab[2][2] * bb);
	--anchor
	local leagueanchor = 0;
	for league, sth in pairs(gT.Leagues) do
		if sth.Members[iPlayer] and sth.Resolutions[11] then
			local bOther = -100;
			for smember, bb in pairs(sth.Members) do
				if smember ~= iPlayer then
					bOther = math.max(bOther, gT.Players[smember].Morale);
				end
			end
			if bOther > gT.Players[iPlayer].Morale then
				leagueanchor = leagueanchor + 1;
			end
			if bOther > 0 then
				leagueanchor = leagueanchor + math.floor(bOther / 10);
			end
		end
	end
	gT.Players[iPlayer].MoraleFromLeague = leagueanchor;

	--prebiased towards balance (annual random matters)
	local cMoraleFRAM = gT.Players[iPlayer].CurrentSituation + gT.Players[iPlayer].MoralePoints - gT.Players[iPlayer].MoraleSituationIgnore
	if 0 > cMoraleFRAM then
		hTab[2][2] = hTab[2][2] - cMoraleFRAM * 50; -- +1
	else
		hTab[1][2] = hTab[1][2] + cMoraleFRAM * 50; -- -1
	end
	if gT.Players[iPlayer].CurrentSituation > 0 then
		hTab[1][2] = hTab[1][2] + gT.Players[iPlayer].CurrentSituation * 5
	else
		hTab[2][2] = hTab[2][2] + gT.Players[iPlayer].CurrentSituation * -5
	end
	AddToMoraleQueueLog(iPlayer, GetRandomFromBiasedChanceTable(hTab), "Annual Random Matters")
	if LastRandom(1, 100) == 5 then
		AddToMoraleQueueLog(iPlayer, -10 + LastRandom(0,1) * 20, "Omen")
	end
	if gT.Players[iPlayer].GovRewards[33] then
		if LastChance(2 * gT.Players[iPlayer].Ideologies.A) then
			AddToMoraleQueueLog(iPlayer, 1, "Autocracy")
		end
	end
	--triumph
	local ift = GetMoraleBoostFromTriumph(iPlayer)
	if ift > 0 then
		AddToMoraleQueueLog(iPlayer, ift, "Triumph");
	end
	--autocracy
	if LastChance(5 * (gT.Players[iPlayer].Ideo78DataTracking[5] + gT.Players[iPlayer].Ideo78DataTracking[7])) then
		AddToMoraleQueueLog(iPlayer, 1, "War Never Ends");
	end
	--shamans hut
	if GetShamanMoraleTurn(iPlayer) then
		AddToMoraleQueueLog(iPlayer, 1, "Shaman's Huts");
	end
	--speech
	if HasPlayerTech(iPlayer, techAnc30CS, "okeed") then
		if LastChance(33) then
			AddToMoraleQueueLog(iPlayer, 1, "Speech");
		end
	end
	--golden age
	if Players[iPlayer]:IsGoldenAge() then
		if gT.Players[iPlayer].HasMinorIdeology[3] then
			AddToMoraleQueueLog(iPlayer, 1, "Golden Age");
		end
	end

	local cMorale = gT.Players[iPlayer].MoralePoints
	--get morale from current should be before morale queue, because it can add some events morale (like peace :))
	gT.Players[iPlayer].CurrentSituation = GetMoraleFromCurrentSituation(iPlayer, Players[iPlayer]:IsHuman())
	for i, data in pairs(gT.Players[iPlayer].MoraleQueueLog) do
		table.insert(gT.Players[iPlayer].MoraleLog, data)
		cMorale = cMorale + data[1];
	end
	gT.Players[iPlayer].MoralePoints = cMorale;
	cMorale = cMorale + gT.Players[iPlayer].CurrentSituation;

	--here some fake anchors from bonuses
	if HasPlayerTech(iPlayer, cstateancient2, "94kld123") then
		cMorale = math.max(cMorale, gT.Players[iPlayer].NumGWoL)
	end
	gT.Players[iPlayer].Morale = math.max(math.min(gT.Players[iPlayer].MaxMoraleRange, cMorale), gT.Players[iPlayer].MinMoraleRange);
	if Players[iPlayer]:IsHuman() then
		local length = #gT.Players[iPlayer].MoraleLog - 10;
		for i = 1, length do
			table.remove(gT.Players[iPlayer].MoraleLog, 1)
		end
	else
		gT.Players[iPlayer].MoraleLog = {};
	end
	gT.Players[iPlayer].MoraleQueueLog = {}
	UpdateAllMoraleUnits(iPlayer)

	if HasPlayerTech(iPlayer, afr8tech, "Fewfewrewr") then	
		AdjustMoraleBonusesOnInno(iPlayer, math.max(0, gT.Players[iPlayer].Morale))
	end
end

function GetTabOfAllRivalPlayersDoingFilthyInfiltration(iPlayer)
	local hTab = {}
	for g, gData in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			for i, data in pairs(gData.Agents) do
				if data.Mission == 2 and  data.TargetPlayer == iPlayer then
					if (not data.IgnoreItForever) then
						if (not data.Rekonwalescencja) then
							table.insert(hTab, data.Rank)
						end
					end
				end
			end
		end
	end
	return hTab;
end

function InitialMoraleAdjust()
	for g, gd in pairs(gT.Players) do
		gT.Players[g].MoralePoints =  LastRandom(-5, 5);
		gT.Players[g].CurrentSituation = GetMoraleFromCurrentSituation(g, Players[g]:IsHuman())
		local cMorale = gT.Players[g].MoralePoints + gT.Players[g].CurrentSituation
		gT.Players[g].Morale = math.max(math.min(gT.Players[g].MaxMoraleRange, cMorale), gT.Players[g].MinMoraleRange);
		UpdateAllMoraleUnits(g)
	end
end

function IsFightingOnPlaguedLand(iPlayer)
	local base = 0;
	local iTeam = Players[iPlayer]:GetTeam();
	for iUnit in Players[iPlayer]:Units() do
		if IsCombatClassITGUnit(iUnit:GetUnitClassType(), iPlayer) then
			if iUnit:GetPlot():GetPlague() > 0 then
				if IsEnemyPlot(iUnit:GetPlot(), iTeam) then
					base = base + 1;
				end
			end
		end
	end
	return (LastRandom(1, 3) <= base)
end
	
function GetMoraleFromCurrentSituation(iPlayer, bLog)
	local cMSit = 0;
	local bMajor = (not Players[iPlayer]:IsMinorCiv())
	gT.Players[iPlayer].MoraleSituationIgnore = 0;
	gT.Players[iPlayer].SituationMorale = {}
	local pTeam = Teams[Players[iPlayer]:GetTeam()];
	local numalliedCS = {}
	local numenemyCS = {}
	local enemyTabMajor = {}
	local scriptedW = 0;
	if bMajor then
		for g, gdata in pairs(gT.Players) do
			if g ~= iPlayer and Players[g]:IsAlive() and (not gdata.IsConsideredBarbarian) then
				if Players[g]:IsMinorCiv() then
					if Players[g]:GetAlly() == iPlayer then
						table.insert(numalliedCS, g);
					elseif pTeam:IsAtWar(Players[g]:GetTeam()) then
						if (gT.Players[iPlayer].WarPeaceLock[g] or 0) > 0 then
							scriptedW = scriptedW + 1;
						end
						table.insert(numenemyCS, g)
					end
				elseif pTeam:IsAtWar(Players[g]:GetTeam()) then
					if (gT.Players[iPlayer].WarPeaceLock[g] or 0) > 0 then
						scriptedW = scriptedW + 1;
					end
					table.insert(enemyTabMajor, g)
				end
			end
		end
		if #enemyTabMajor + #numenemyCS == 0 then
			if LastRandom(1, 3) == 2 then
				AddToMoraleQueueLog(iPlayer, 1, "Peace", true)
			end
		else
			if scriptedW < (#enemyTabMajor + #numenemyCS) then
				if LastRandom(1, 3) == 2 then
					if (not gT.Globals.DominationOn) or gT.Globals.DominationOff or (LastRandom(1, 2) == 2) then
						if not HasPlayerTech(iPlayer, techTRIALHorde7, "Hasceeaa") then
							AddToMoraleQueueLog(iPlayer, -1, "War Weariness", true)
						end
					end
				end
			end
		end
		for g, gp in pairs(gT.Players) do
			if HasPlayerTech(g, techTRIALHorde7, "casdaeae") then
				if g ~= iPlayer then
					if LastRandom(1, 100) <= 50 then
						AddToMoraleQueueLog(iPlayer, -1, "War against Horde", true)
					end
					break;
				end
			end
		end
	end
	if IsFightingOnPlaguedLand(iPlayer) then
		local morB = LastRandom(-3, -1);
		cMSit = DoSituationMoraleSmall(iPlayer, cMSit, morB, bLog,  "Plagued lands (having military units in enemy plagued lands)")
	end
	--War Of Brothers
	if bMajor then
		if ValidEpoqueForWoB[gT.Globals.ScenarioType] then
			for it, g in pairs(enemyTabMajor) do
				if (GetPlayersCulturalDifference(iPlayer, g) == 0) or (gT.Players[g].OfficialReligion == gT.Players[iPlayer].OfficialReligion and (gT.Players[g].OfficialReligion)) then
					local morB = LastRandom(-5, -1);
					cMSit = DoSituationMoraleSmall(iPlayer, cMSit, morB, bLog,  "War of Brothers (being at war against civilization with same culture type or official religion)")
					break;
				end
			end
		end
		if Players[iPlayer]:GetNumCities() > 1 then
			local ioww, occ = 0, 0;
			for iCity in Players[iPlayer]:Cities() do
				if iCity:GetOriginalOwner() == iPlayer then
					ioww = ioww + 1;
				else
					occ = occ + 1;
				end
			end
			ioww = math.max(1, ioww);
			local rocow = occ / ioww;
			if rocow > 0 then
				local morB;
				if rocow >= 3 then
					morB = math.floor(rocow) + 2;
				elseif rocow >= 2 then
					morB = LastRandom(3,5);
				elseif rocow >= 1.5 then
					morB = LastRandom(2,4);
				elseif rocow >= 1 then
					morB = LastRandom(1,3);
				end
				if morB then
					cMSit = DoSituationMoraleSmall(iPlayer, cMSit, -morB, bLog,  "Occupied Territory (occupied cities are at least as numerous as your original cities)")
				end
			end
		end
		--Backstabbo
		for it, g in pairs(numenemyCS) do
			if gT.Players[iPlayer].EverAlliedCS[g] then
				local morB = 1;
				cMSit = DoSituationMoraleSmall(iPlayer, cMSit, morB, bLog, "Backstab (being at war against City-State, which used to be our ally)")
				break;
			end
		end
		--oppressor
		for it, g in pairs(enemyTabMajor) do
			if GetNumOriginalCapitals(g) > 1 then
				local morB = 1;
				cMSit = DoSituationMoraleSmall(iPlayer, cMSit, morB, bLog, "Finest Hour (being at war against civilization that controls multiple original capitals)")
				break;
			end
		end
		--liberation
		for it, g in pairs(enemyTabMajor) do
			if HasAtLeastOneCityOfPlayer(g, iPlayer) then
				local morB = 1;
				cMSit = DoSituationMoraleSmall(iPlayer, cMSit, morB, bLog, "Liberation War (being at war against civilization that owns at least one your city)")
				break
			end
		end
		--overwhelming
		for it, g in pairs(enemyTabMajor) do
			if Players[g]:GetMilitaryMight() >= 2 * Players[iPlayer]:GetMilitaryMight() then
				local morB = LastRandom(-1, 1);
				cMSit = DoSituationMoraleSmall(iPlayer, cMSit, morB, bLog, "Overwhelming Odds (being at war against civilization that is at least twice stronger than us)")
				break;
			end
		end
	end
	--academies
	local totAm = GetNumAcademiesWithAbility(iPlayer, 12);
	if totAm > 0 then
		cMSit = DoSituationMoraleSmall(iPlayer, cMSit, totAm, bLog, "Academies")
	end
	--holy war
	if bMajor then
		local pRel = GetKindaOfficialReligionOfPlayer(iPlayer)
		if pRel then
			for it, g in pairs(enemyTabMajor) do
				if GetKindaOfficialReligionOfPlayer(g, pRel) ~= pRel then
					local morB = LastRandom(1, 3);
					cMSit = DoSituationMoraleSmall(iPlayer, cMSit, morB, bLog, "Holy War (being at war against civilization with different Religion)")
					break;
				end
			end
		end
		--city-states
		if #numalliedCS > 0 and #numenemyCS > 0 then
			if #numenemyCS > #numalliedCS then
				local morB = -1;
				cMSit = DoSituationMoraleSmall(iPlayer, cMSit, morB, bLog, "Axis of Evil (being at war against more City-States than number of allied City-States)")
			elseif #numenemyCS < #numalliedCS then
				local morB = 1;
				cMSit = DoSituationMoraleSmall(iPlayer, cMSit, morB, bLog, "Holy Alliance (being at war against less City-States than number of allied City-States)")
			end
		end
	end
	local morB = 0;
	--edge of exctintion
	if Players[iPlayer]:GetNumCities() < 2 then
		if Players[iPlayer]:GetNumCities() == 0 or Players[iPlayer]:GetCapitalCity():GetDamage() > 100 then
			morB = 100;
		else
			morB = 10;
		end
		cMSit = DoSituationMoraleSmall(iPlayer, cMSit, morB, bLog, "Edge of Extinction (being close to be annihilated)")
	end
	local moraleFromMerc = GetMoraleFromMercenaries(iPlayer)
	if moraleFromMerc > 0 then
		cMSit = DoSituationMoraleSmall(iPlayer, cMSit, moraleFromMerc, bLog, "Mercenaries")
	end
	local moraleSevenSeas = GetMoraleFromSevenSeas(iPlayer)
	if moraleSevenSeas > 0 then
		cMSit = DoSituationMoraleSmall(iPlayer, cMSit, moraleSevenSeas, bLog, "Seven Seas")
	end
	--salary
	local gpt = (gT.Players[iPlayer].PrevTurnGPT or 0);
	if gpt < 0 then
		if Players[iPlayer]:GetGold() + gpt * 20 < 0 then
			morB = -1 * math.min(20 - math.floor(Players[iPlayer]:GetGold() / -gpt), math.min(5, math.floor(math.ceil(-gpt /10))))	
			cMSit = DoSituationMoraleSmall(iPlayer, cMSit, morB, bLog, "Lack of Salary (having negative Gold rate)")
		end
	end
	if bMajor then
		local numtot, numdmg, numfriendlyter, thrill = 0, 0, 0, false;
		local onFallout = 0;
		for iUnit in Players[iPlayer]:Units() do
			if IsCombatClassITGUnit(iUnit:GetUnitClassType(), iPlayer) then
				numtot = numtot + 1;
				if iUnit:GetPlot():GetOwner() == iPlayer then
					numfriendlyter = numfriendlyter + 1;
				end
				if iUnit:GetDamage() > 0 then
					numdmg = numdmg + 1
				end
				if iUnit:IsEnemyCityAdjacent() then
					for i = 0, 5 do
						local nPlot = Map.PlotDirection(iUnit:GetX(), iUnit:GetY(), i);
						if nPlot and nPlot:IsCity() then
							if nPlot:GetPlotCity():GetDamage() > nPlot:GetPlotCity():GetMaxHitPoints() / 2 then
								thrill = true;
							end
							break;
						end
					end
				end
				if iUnit:GetPlot():GetFeatureType() == fFallout then
					if not iUnit:IsImmobile() then
						onFallout = onFallout + 1;
					end
				end
			end
		end
		if onFallout > LastRandom(2, 4) then
			morB = LastRandom(1, 3) * -1
			cMSit = DoSituationMoraleSmall(iPlayer, cMSit, morB, bLog, "Atomic Hell (having units on fallout)")
		end
		if numtot > 0 then
			if numfriendlyter >= numtot * 0.9 then
				morB = 1
				cMSit = DoSituationMoraleSmall(iPlayer, cMSit, morB, bLog, "Defensive Warfare (having majority of units within own territory)")
			end
			if numdmg >= numtot * 0.5 then
				morB = -1
				cMSit = DoSituationMoraleSmall(iPlayer, cMSit, morB, bLog, "Lack of Reinforcements (having majority of units damaged)")
			elseif numdmg <= numtot * 0.25 then
				morB = 1
				cMSit = DoSituationMoraleSmall(iPlayer, cMSit, morB, bLog, "Fresh Forces (having majority of units at full HP)")
			end
		end
		if thrill then
			morB = 1
			cMSit = DoSituationMoraleSmall(iPlayer, cMSit, morB, bLog, "Thrill of Victory (having an unit close to heavily damaged enemy city)")
		end
		if Players[iPlayer]:IsGoldenAge() then
			morB = LastRandom(1, 5)
			cMSit = DoSituationMoraleSmall(iPlayer, cMSit, morB, bLog, "Golden Age")
		end

		local morFromCS = 0;
		for jhjh, minor in pairs(gT.Globals.CSbyTypes[GameInfoTypes.MINOR_TRAIT_IDEOLOGICAL]) do
			if Players[minor]:GetMinorCivFriendshipLevelWithMajor(iPlayer) > 0 then
				if Players[minor]:GetMinorCivFriendshipLevelWithMajor(iPlayer) > 1 then
					morFromCS = morFromCS + 2;
				else
					morFromCS = morFromCS + 1;
				end			
			end
		end
		if gT.Players[iPlayer].CultBonusOn[118] then
			morFromCS = math.floor(morFromCS * 1.5);
		end
		cMSit = DoSituationMoraleSmall(iPlayer, cMSit, morFromCS, bLog, "City-States")
	end
	--leagues
	cMSit = DoSituationMoraleSmall(iPlayer, cMSit, gT.Players[iPlayer].MoraleFromLeague, bLog, "Blood Oath")
	if Players[iPlayer]:GetNumCities() < Players[iPlayer]:GetBuildingClassCount(cBbarracks) + Players[iPlayer]:GetBuildingClassCount(cBarmory) then
		morB = LastRandom(1, 2)
		cMSit = DoSituationMoraleSmall(iPlayer, cMSit, morB, bLog, "Training Facilities (amount of Barracks and Armories within empire")
	end
	--technological
	if bMajor then
		local numtechs = pTeam:GetTeamTechs():GetNumTechsKnown() + 5
		for it, g in pairs(enemyTabMajor) do
			if Teams[Players[g]:GetTeam()]:GetTeamTechs():GetNumTechsKnown() > numtechs  then
				local morB = -1;
				cMSit = DoSituationMoraleSmall(iPlayer, cMSit, morB, bLog, "Technology Gap (being at war against significantly more advanced civilization)")
				break;
			end
		end
	end
	cMSit = DoSituationMoraleSmall(iPlayer, cMSit, gT.Players[iPlayer].ManuMorale, bLog, "Manufactories")
	if Players[iPlayer]:GetNumCities() > 0 then
		local totfood = 0;
		for iCity in Players[iPlayer]:Cities() do
			totfood = totfood + iCity:FoodDifference()
		end
		if totfood < 0 then
			local morB = -1 * math.min(3, math.ceil(-totfood/Players[iPlayer]:GetNumCities()/10))
			cMSit = DoSituationMoraleSmall(iPlayer, cMSit, morB, bLog, "Famine (having negative amount of Food rate within empire")
		end
	end
	cMSit = DoSituationMoraleSmall(iPlayer, cMSit, GetBasicRewardGovFromCodex(iPlayer, 8, 22), bLog, "Codex")
	cMSit = DoSituationMoraleSmall(iPlayer, cMSit, gT.Players[iPlayer].MoraleFromGP, bLog, "Great People")
	if bMajor then
		if IsHasLaw(iPlayer, 11, 2) then
			cMSit = DoSituationMoraleSmall(iPlayer, cMSit, 3, bLog, "Soldier's Pay", true)
		elseif IsHasLaw(iPlayer, 11, 3) then
			cMSit = DoSituationMoraleSmall(iPlayer, cMSit, -3, bLog, "Soldier's Pay", true)
		end
		if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_MODERN_25, "okfeorke") then
			if gT.Players[iPlayer].AuthorityRank == 1 then
				cMSit = DoSituationMoraleSmall(iPlayer, cMSit, 3, bLog, "Propaganda", true)
			end
		end
	end
	if gT.Players[iPlayer].HasPlayerWonder[wonderMoral22] then
		cMSit = DoSituationMoraleSmall(iPlayer, cMSit, 3, bLog, "Amber Fort", true)
	end
	local morWruin = (gT.Players[iPlayer].WonderRuinsEffects[22] or 0)
	if morWruin > 0 then
		cMSit = DoSituationMoraleSmall(iPlayer, cMSit, morWruin, bLog, "Wonder Ruins", true)
	end
	if gT.Players[iPlayer].CultBonusOn[80] then
		cMSit = DoSituationMoraleSmall(iPlayer, cMSit, math.floor(gT.Players[iPlayer].Cult80t[1] / 4), bLog, "Sturdiness", true)
	end
	if gT.Players[iPlayer].HasIdeology[67] then
		cMSit = DoSituationMoraleSmall(iPlayer, cMSit, math.floor(2 * gT.Players[iPlayer].HapComparisionMod), bLog, "Greener Grass", true)
	end
	return cMSit;
end

function IsCombatClassITGUnit(class, iPlayer) 
	if not gT.Players[iPlayer] then
		return false;
	end
	if gT.Players[iPlayer].UnitClassPromotions[class] then
		return true;
	end
	return false;
end

function HasAtLeastOneCityOfPlayer(g, iPlayer)
	for iCity in Players[g]:Cities() do
		if iCity:GetOriginalOwner() == iPlayer then
			return true;
		end
	end
	return false;
end

function DoSituationMoraleSmall(iPlayer, a, b, bLog, sText, bIgnoreSit)
	if b == 0 then
		return a;
	end
	if bLog then
		table.insert(gT.Players[iPlayer].SituationMorale, {b, sText})
	end
	if bIgnoreSit then
		gT.Players[iPlayer].MoraleSituationIgnore = gT.Players[iPlayer].MoraleSituationIgnore + b;
	end
	return a + b;
end

function GetNumOriginalCapitals(iPlayer)
	local num = 0;
	for iCity in Players[iPlayer]:Cities() do
		if iCity:IsOriginalMajorCapital() then
			num = num + 1;
		end
	end
	return num;
end

function GetKindaOfficialReligionOfPlayer(iPlayer, hRespond)
	if gT.Players[iPlayer].OfficialReligion then
		return gT.Players[iPlayer].OfficialReligion;
	end
	if Players[iPlayer]:GetReligionCreatedByPlayer() > 0 then
		return Players[iPlayer]:GetReligionCreatedByPlayer()
	end
	return hRespond;
end

function GetChanceForMoraleToDropOnRiots(iPlayer)
	return 50 - 3 * math.max(0, 10 - GetITGGameTurn() + (gT.Players[iPlayer].MoraleLastRiots or -100));
end
--Events
--AddToMoraleQueueLog(iPlayer, amount, logstring)
function TakeCareOfEventMorale(iPlayer, iType, extraData, bNoExtendLimits)
	if not gT.Players[iPlayer] then
		if iType == 25 then
			print("Barbarian or nil into morale!", iPlayer, iType, extraData[1], extraData[2], bNoExtendLimits)
		else
			print("Barbarian or nil into morale!", iPlayer, iType, extraData, bNoExtendLimits)
		end
		return;
	end
	if iType == 25 then
		AddToMoraleQueueLog(iPlayer, extraData[1], extraData[2], bNoExtendLimits)
	elseif iType == 1 then
		-- riots
		if gT.Players[iPlayer].MoralePoints > -30 then
			if LastChance(GetChanceForMoraleToDropOnRiots(iPlayer)) then -- (30% chance lower if other riots already reduced morale this turn (30/27/24/...) 
				AddToMoraleQueueLog(iPlayer, -1, "Riots")
				gT.Players[iPlayer].MoraleLastRiots = GetITGGameTurn();
			end
		end
	elseif iType == 2 then
		-- wonder
		if gT.Players[iPlayer].MoralePoints < 30 then
			if LastChance(75) then
				AddToMoraleQueueLog(iPlayer, 1, "Wonder Construction")
			end
		end
	elseif iType == 3 then
		--fall of city // probably should be more specific like holy city etc.
		if (gT.Players[iPlayer].FallCityMoraleCD or -1) < GetITGGameTurn() then
			local mor = LastRandom(-3, 1)
			if mor ~= 0 then
				if gT.Players[iPlayer].MoralePoints <= -30 then
					mor = 1;
				elseif gT.Players[iPlayer].MoralePoints >= 30 then
					mor = -3;
				end
				gT.Players[iPlayer].FallCityMoraleCD = GetITGGameTurn() + LastRandom(4,7);
				AddToMoraleQueueLog(iPlayer, mor, "Fall of City")
			end
		end
	elseif iType == 4 then
		if gT.Players[iPlayer].MoralePoints < 30 then
			local chanceToCare = 0;
			if extraData[4] then
				chanceToCare = 100;
			else
				if extraData[3] then
					chanceToCare = chanceToCare + 20;
				end
				chanceToCare = chanceToCare + math.max(0, 43 - gT.Players[iPlayer].NumConquered * 3)
				chanceToCare = chanceToCare + math.max(0, 45 - gT.Players[iPlayer].UniqueNumConquered * 5)
				chanceToCare = math.max(10, chanceToCare);
			end
			--city conquer
			if LastRandom(1, 100) <= chanceToCare then
				if gT.Cities[extraData[1]].NumWonders > 0 then
					AddToMoraleQueueLog(iPlayer, LastRandom(1,2), "City Capture")
				else
					local mor = LastRandom(-1, 2)
					if mor ~= 0 then
						AddToMoraleQueueLog(iPlayer, mor, "City Capture")
					end
				end
			end
		end
	elseif iType == 5 then
		if extraData[1] then
			AddToMoraleQueueLog(iPlayer, -1, "Commander Assassinated")
		else
			local mor = LastRandom(-2, 2)
			if mor ~= 0 then
				if gT.Players[iPlayer].MoralePoints <= -30 then
					mor = 2;
				elseif gT.Players[iPlayer].MoralePoints >= 30 then
					mor = -2;
				end
				AddToMoraleQueueLog(iPlayer, mor, "Commander Fallen")
			end
		end
	elseif iType == 6 then
		local mor = LastRandom(-1, 1)
		if mor ~= 0 then
			AddToMoraleQueueLog(iPlayer, mor, "Commander Escaped")
		end
	elseif iType == 7 then
		if LastRandom(1, 100) <= 25 + gT.Players[iPlayer].MoralePoints then
			AddToMoraleQueueLog(iPlayer, -1, "Fort Fall")
		end
	elseif iType == 8 then
		if gT.Players[iPlayer].MoralePoints < -20 then
			gT.Players[iPlayer].FortCaptureMorChance = 0;
		end
		if LastRandom(1, 100) <= math.max(5, 35 - (gT.Players[iPlayer].FortCaptureMorChance or 0)) then
			gT.Players[iPlayer].FortCaptureMorChance = (gT.Players[iPlayer].FortCaptureMorChance or 0) + 5;
			AddToMoraleQueueLog(iPlayer, 1, "Fort Capture")
		end
	elseif iType == 9 then
		if WasImportantHolySiteToPlayer(extraData[1], iPlayer) then
			if gT.Players[iPlayer].MoralePoints > -30 then
				AddToMoraleQueueLog(iPlayer, -1, "Holy Site Fall")
			end
		end
	elseif iType == 10 then
		if WasImportantHolySiteToPlayer(extraData[1], iPlayer) then
			if gT.Players[iPlayer].MoralePoints < 30 then
				AddToMoraleQueueLog(iPlayer, 1, "Holy Site Capture")
			end
		end
	elseif iType == 11 then
		if gT.Players[iPlayer].MoralePoints < 20 then
			AddToMoraleQueueLog(iPlayer, 1, "Other Player Declared War on our enemy")
		end
	elseif iType == 12 then
		if gT.Players[iPlayer].MoralePoints > -20 then
			AddToMoraleQueueLog(iPlayer, -1, "Declaration of War")
		end
	elseif iType == 13 then
		if gT.Players[iPlayer].CultBonusOn[156] then
			local effectiveBonus = math.min(extraData[1], gT.Players[iPlayer].MaxMoraleRange + 5 - gT.Players[iPlayer].MoralePoints - gT.Players[iPlayer].CurrentSituation)
			if effectiveBonus > 0 then
				AddToMoraleQueueLog(iPlayer, effectiveBonus, "Great Work")
			end
		else
			if LastRandom(1, 100) <= 2 * extraData[1] - math.min(0, gT.Players[iPlayer].MoralePoints) then
				AddToMoraleQueueLog(iPlayer, 1, "Great Work")
			end
		end
	elseif iType == 14 then
		if LastRandom(1, 10) <= math.max(1, 12 - 2 *  gT.Players[iPlayer].LHNumVetProms) then 
		-- instead 1/4 ==> 100 -> 10
			AddToMoraleQueueLog(iPlayer, 1, "Veterancy Promotion")
		end
	elseif iType == 15 then
		if Teams[Players[iPlayer]:GetTeam()]:IsAtWar(Players[extraData[1]]:GetTeam()) then
			AddToMoraleQueueLog(iPlayer, 1, "Converting Enemy City")
		end
	elseif iType == 16 then
		if Teams[Players[iPlayer]:GetTeam()]:IsAtWar(Players[extraData[1]]:GetTeam()) then
			AddToMoraleQueueLog(iPlayer, -1, "City Converted by Enemy")
		end
	elseif iType == 17 then
		local mor = LastRandom(-3, 3)
		if mor ~= 0 then
			if gT.Players[iPlayer].MoralePoints <= -30 then
				mor = 3;
			elseif gT.Players[iPlayer].MoralePoints >= 30 then
				mor = -3;
			end
			AddToMoraleQueueLog(iPlayer, mor, "Modernising Army")
		end
	elseif iType == 18 then
		AddToMoraleQueueLog(iPlayer, LastRandom(1,3), "New Commander Acquired")
	elseif iType == 19 then
		local recentMod = 10 + 10 * (GetITGGameTurn() - (gT.Players[iPlayer].MoraleLastTRPlunder or -100));
		if LastRandom(1, 100) <= recentMod then
			AddToMoraleQueueLog(iPlayer, 1, "Plundering Trade Route")
			gT.Players[iPlayer].MoraleLastTRPlunder = GetITGGameTurn();
		end
	elseif iType == 20 then
		if gT.Players[iPlayer].MoralePoints <= -30 then
			AddToMoraleQueueLog(iPlayer, -1, "Rebellion")
		else
			AddToMoraleQueueLog(iPlayer, LastRandom(-3,-1), "Rebellion")
		end
	elseif iType == 21 then
		if gT.Players[iPlayer].MoralePoints > 30 then
			AddToMoraleQueueLog(iPlayer, 1, "Resistance Outbreak")
		else
			AddToMoraleQueueLog(iPlayer, LastRandom(1,3), "Resistance Outbreak")
		end
	elseif iType == 22 then
		if LastChance(20) then
			if gT.Players[iPlayer].MoralePoints < 30 then
				AddToMoraleQueueLog(iPlayer, 1, "New Troops", true)
			end
		end
	elseif iType == 23 then
		if LastRandom(1, 100) <= 3 + (GetITGGameTurn() - gT.Players[iPlayer].UnitKillMorale) then
			gT.Players[iPlayer].UnitKillMorale = GetITGGameTurn();
			AddToMoraleQueueLog(iPlayer, 1, "Defeating Enemy Unit", true)
		end
	elseif iType == 24 then
		if LastRandom(1, 100) <= 3 + (GetITGGameTurn() - gT.Players[iPlayer].UnitLossMorale) then
			gT.Players[iPlayer].UnitLossMorale = GetITGGameTurn();
			AddToMoraleQueueLog(iPlayer, -1, "Loosing an Unit", true)
		end
	end
end

function WasImportantHolySiteToPlayer(index, iPlayer)
	local iRel = GetKindaOfficialReligionOfPlayer(iPlayer)
	if iRel then
		if gT.HolySites[index].ActiveReligions[iRel] then
			return true;
		end
	end
	return false;
end

local promMerc11 = GameInfoTypes.PROMOTION_ITG_MERCENARY_11
function GetMoraleFromMercenaries(iPlayer)
	for iUnit in Players[iPlayer]:Units() do
		if iUnit:IsHasPromotion(promMerc11) then
			return 4;
		end
	end
	return 0;
end

local promSvnSeas8 = GameInfoTypes.PROMOTION_ITG_SEVEN_SEAS_7
function GetMoraleFromSevenSeas(iPlayer)
	for iUnit in Players[iPlayer]:Units() do
		if iUnit:IsHasPromotion(promSvnSeas8) then
			local uID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
			if gT.Players[iPlayer].UnitsByID[uID] then
				if gT.Players[iPlayer].UnitsByID[uID].LastCombatT then
					return math.max(1, math.min(10, 11 + gT.Players[iPlayer].UnitsByID[uID].LastCombatT - GetITGGameTurn())) 
				else
					return 1;
				end
			else
				return 1;
			end
		end
	end
	return 0;
end