
function PrepareDataFromNationality()
	for g, gdata in pairs(gT.Players) do
		if gdata.EEFNationality then
			return; -- we already did it;
		end
		if not Players[g]:IsMinorCiv() then
			local bsp, bsv = g, 0;
			for jg, jgdata in pairs(gT.Players) do
				if (not Players[jg]:IsMinorCiv()) and (g ~= jg) then	
					local nval = CompareTwoNationsInUniqueness(g, jg)
					if nval > bsv then
						bsv = nval;
						bsp = jg;
					end
				end
			end
			gT.Players[g].EEFNationality = {bsp, bsv}
		end
	end
end

function CompareTwoNationsInUniqueness(fPlayer, sPlayer)
	local tot = 0;
	local sim = 0;

	--goverment
	tot = tot + 70;
	if gT.Players[fPlayer].Goverment == gT.Players[sPlayer].Goverment then
		sim = sim + 70
	end
	local govRewards = {};
	for i, s in pairs(gT.Players[fPlayer].GovSlots) do
		govRewards[s.Principle] = true;
		tot = tot + 15;
	end
	for i, s in pairs(gT.Players[sPlayer].GovSlots) do
		if govRewards[s.Principle] then
			sim = sim + 15;
		end
	end
	--culture type
	tot = tot + 50;
	if gT.Players[fPlayer].CultureType == gT.Players[sPlayer].CultureType then
		sim = sim + 20;
		if gT.Players[fPlayer].SubcultureType == gT.Players[sPlayer].SubcultureType then
			sim = sim + 30;
		end
	end
	--official religion
	tot = tot + 200;
	if GetITGReligion(fPlayer) == GetITGReligion(sPlayer) then
		sim = sim + 200;
	end
	--innovations
	for t, stech in pairs(gT.Players[fPlayer].Innovations) do
		if Teams[Players[fPlayer]:GetTeam()]:IsHasTech(stech) then
			tot = tot + 50;
			if Teams[Players[sPlayer]:GetTeam()]:IsHasTech(stech) then
				sim = sim + 50;
			end
		end
	end
	--inspirations
	for bclass, type in pairs(gT.Players[fPlayer].Inspirations) do
		tot = tot + 30;
		if type == gT.Players[sPlayer].Inspirations[bclass] then
			sim = sim + 30;
		end
	end
	--laws
	tot = tot + 100;
	local totlaws = 0;
	local totsimlaw = 0;
	for jtt, data in pairs(gT.Players[fPlayer].Laws) do
		totlaws = totlaws + 1;
		if gT.Players[sPlayer].Laws[jtt][1] == data[1] then
			totsimlaw = totsimlaw + 1;
		end
	end
	sim = sim + math.ceil(100 * totsimlaw / totlaws);
	--soc policies
	local totpol = 0;
	local totsimpol = 0;
	for cultID, sth in pairs(gT.Players[fPlayer].CultBonusOn) do
		totpol = totpol + 1;
		if gT.Players[sPlayer].CultBonusOn[cultID] then
			totsimpol = totsimpol + 1;
		end
	end
	for letter, value in pairs(gT.Players[fPlayer].Ideologies) do
		totpol = totpol + math.max(value, gT.Players[sPlayer].Ideologies[letter]);
		totsimpol = totsimpol + math.min(value, gT.Players[sPlayer].Ideologies[letter]);
	end
	if totpol > 0 then
		tot = tot + 300;
		sim = sim + math.ceil(300 * totsimpol / totpol)
	end
	--ideology
	for gpID, hhh in pairs(gT.Players[sPlayer].GreatPeople) do
		local gd = gT.GreatPeople[gpID];
		if (gd.OriginPlayer == fPlayer) and	gd.Alive and (not gd.Military) then
			tot = tot + 10;
			sim = sim + 10;
		end
	end
	if AreSharingDoFLeague(fPlayer, sPlayer) then
		tot = tot + 25;
		sim = sim + 25;
	end
	tot = tot + 10 * gT.Players[fPlayer].LHSpecialArmy;
	if gT.Players[fPlayer].StAlphabet ~= -1 then
		if gT.Players[sPlayer].StAlphabet == gT.Players[fPlayer].StAlphabet then
			if gT.Players[fPlayer].StAlphabet == fPlayer then
				tot = tot + 40;
				sim = sim + 40;
			elseif gT.Players[fPlayer].StAlphabet == sPlayer then
				tot = tot + 100;
				sim = sim + 100;
			else
				tot = tot + 70;
				sim = sim + 70;
			end
		elseif gT.Players[fPlayer].StAlphabet == fPlayer then
			tot = tot + 50;
		else
			tot = tot + 20;
		end
	elseif gT.Players[sPlayer].StAlphabet ~= -1 then
		tot = tot + 20;
		sim = sim + 20;
	end
	--wonders constructed
	tot = tot + gT.Players[fPlayer].NumWondersBuild * 25;
	return math.floor(sim / tot* 10000) /100
end

function GetITGReligion(iPlayer)
	if not gT.Players[iPlayer] then
		return -1;
	end
	if gT.Players[iPlayer].OfficialReligion then
		return gT.Players[iPlayer].OfficialReligion;
	end
	if Players[iPlayer]:GetReligionCreatedByPlayer() > 0 then
		return Players[iPlayer]:GetReligionCreatedByPlayer();
	end
	if Players[iPlayer]:GetNumCities() > 0 then
		local relTab = {};
		local tMajorRel = {};
		local maxpop = 0;
		for iCity in Players[iPlayer]:Cities() do
			local major = iCity:GetReligiousMajority();
			if major > 0 then
				tMajorRel[major] = (tMajorRel[major] or 0) + 1; 
			end
			maxpop = maxpop + iCity:GetPopulation();
			for row in GameInfo.Religions() do
				local numf = iCity:GetNumFollowers(row.ID);
				if numf > 0 then
					relTab[row.ID] = (relTab[row.ID] or 0) + numf;
				end
			end
		end
		local bestrel, bestval = nil, 0.63 * maxpop;
		for irel, val in pairs(relTab) do
			if val > bestval then
				bestrel = irel;
				bestval = val;
			end
		end
		if not bestrel then
			local tres = 0.63 * Players[iPlayer]:GetNumCities()
			for mmj, val in pairs(tMajorRel) do
				if val >= tres then
					bestrel = mmj;
					break;
				end
			end
		end
		if bestrel then
			return bestrel;
		end
	end
	return -1;
end