local fReef = GameInfoTypes.FEATURE_REEF
GameEvents.NaturalWonderDiscovered.Add(function(eTeam, eFeatureType, plotX, plotY, bFirst)
	if gT and gT.Globals and gT.Globals.GameGenerated then
		for g, gdata in pairs(gT.Players) do
			if Players[g]:GetTeam() == eTeam then
				if not Players[g]:IsMinorCiv() then
					GiveBonusFromNaturalWonderDiscovery(g, eFeatureType, plotX, plotY, bFirst);
					BasicCSMissionCompleteFunc(g, 4)
				end
			end
		end
	end
end)

function GiveBonusFromNaturalWonderDiscovery(iPlayer, eFeatureType, plotX, plotY, bFirst)
	--science (no meso)
	-- culture
	-- gold
	-- faith (no euro)
	--GA points
	if not gT.Players[iPlayer] then
		return;
	end
	gT.Players[iPlayer].DiscoveredNaturalWonders[Map.GetPlot(plotX, plotY):GetPlotIndex()] = GetITGGameTurn();
	if eFeatureType == fReef then
		if gT.Players[iPlayer].ReefDiscovered then
			return;
		else
			gT.Players[iPlayer].ReefDiscovered = true
		end
	end
	local total, tab = 0, {}
	--faith
	if GetDBCulturePlayerInfo(iPlayer,"CanHaveFaithNaturalWonder") then
		table.insert(tab, {1, 20})
		total = total + 20;
	end
	--science
	if GetDBCulturePlayerInfo(iPlayer, "CanHaveScienceNaturalWonder") then
		table.insert(tab, {2, 20})
		total = total + 20;
	end
	--culture
	table.insert(tab, {3, 20})
	--GA points
	table.insert(tab, {4, 20})
	--gold
	table.insert(tab, {5, 20})
	local pick = GetRandomFromBiasedChanceTable(tab)
	local hStrAlert, hStringFloat;
	if pick == 1 then
		--scenario dependent :) future me
		local bonus = LastRandom(125,155);
		hStrAlert = "Witnessing the " .. Locale.Lookup(GameInfo.Features[eFeatureType].Description) .. " have enriched us spiritually (+" .. bonus .. "[ICON_PEACE]).";
		hStringFloat = "+" .. bonus .. "[ICON_PEACE]";
		ChangeITGFaith(iPlayer, bonus)
	elseif pick == 2 then
		local bonus = LastRandom(135,165);
		hStrAlert = "Investigating the " .. Locale.Lookup(GameInfo.Features[eFeatureType].Description) .. " resulted in scientific debate (+" .. bonus .. "[ICON_RESEARCH]).";
		hStringFloat = "+" .. bonus .. "[ICON_RESEARCH]";
		ChangeITGScience(iPlayer, bonus)
	elseif pick == 3 then
		local bonus = LastRandom(125,155);
		hStrAlert = "Discovering the ageless beauty of " .. Locale.Lookup(GameInfo.Features[eFeatureType].Description) .. " enriched us culturally  (+" .. bonus .. "[ICON_CULTURE]).";
		hStringFloat = "+" .. bonus .. "[ICON_CULTURE]";
		ChangeITGCulture(iPlayer, bonus)
	elseif pick == 4 then
		local bonus = LastRandom(80,120);
		hStrAlert = "Seems like " .. Locale.Lookup(GameInfo.Features[eFeatureType].Description) .. " is so inspirational right now, every artist wants to portray it some way (+" .. bonus .. "[ICON_GREAT_ARTIST]).";
		hStringFloat = "+" .. bonus .. "[ICON_GREAT_ARTIST]";
		BoostArtisticPoints(iPlayer, bonus)
	elseif pick == 5 then
		local bonus = LastRandom(180,240);
		hStrAlert = "The discovery of " .. Locale.Lookup(GameInfo.Features[eFeatureType].Description) .. ", inspired our wealthy citizens to sponsor another expedition (+" .. bonus .. "[ICON_GOLD]).";
		hStringFloat = "+" .. bonus .. "[ICON_GOLD]";
		ChangeITGGold(iPlayer, bonus)
	end
	--academies
	for h, aca in pairs(gT.Academies) do
		if aca.Player == iPlayer then
			if aca.Active then
				AddPrestigeToAcademy(h, LastRandom(25, 50), "Natural Wonder")
			end
		end
	end

	if iPlayer == Game.GetActivePlayer() then
		if hStrAlert then
			Events.GameplayAlertMessage(hStrAlert)
		end
		if hStringFloat then
			local hex = ToHexFromGrid(Vector2(plotX, plotY));
			Events.AddPopupTextEvent(HexToWorld(hex), hStringFloat, 0.5)
		end
		LuaEvents.ITGSGTopPanelDirty()
	end
end

function IsValidForKiliCrit(iPlayer, cPlot)
	if cPlot:IsHills() then
		return HasPlayerNatureWonder(iPlayer, GameInfoTypes.FEATURE_KILIMANJARO)
	end
	return false;
end

function IsValidForDesertRouteCrit(iPlayer, cPlot)
	if cPlot:GetTerrainType() == tDesert then
		return HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_MEDIEVAL_AFR_8, "Vcerrew")
	end
	return false;
end

function HasPlayerNatureWonder(iPlayer, type)
	if gT.Globals.NaturalWonders[type] then
		if gT.Players[iPlayer] and gT.Players[iPlayer].CultBonusOn[164] then
			if Map.GetPlotByIndex(gT.Globals.NaturalWonders[type]):IsRevealed(Players[iPlayer]:GetTeam()) then
				return true;
			end
		elseif Map.GetPlotByIndex(gT.Globals.NaturalWonders[type]):GetOwner() == iPlayer then
			return true;
		end
	end
	return false;
end