local uSettler = GameInfoTypes.UNIT_SETTLER;
local rRoad = GameInfoTypes.ROUTE_ROAD;
local rRailroad = GameInfoTypes.ROUTE_RAILROAD;
local CityLocations = {}
local scType = 1;
local hMinorTab = {}
local hMajorTab = {}
local bCityPosLinked = (PreGame.GetGameOption("GAMEOPTION_ITG_CITY_NAME_POSITION") == 1)
local GlobalCityFoundQueue = {}
local maxMinorConquest;

function InitHandicapITG()
	local saveData = Modding.OpenSaveData();
	DoSetAIHandicap(saveData.GetValue("ITG_pgd_HI_Food"), saveData.GetValue("ITG_pgd_HI_Production"), saveData.GetValue("ITG_pgd_HI_Gold"), saveData.GetValue("ITG_pgd_HI_Supply"), false)
	saveData = nil;
end

function OnFirstGameStart(forcedScenario)
	scType = forcedScenario or GetScenarioTypeOfNewGame();
	SetCurrentScenarioData(scType) -- CALL TO DB
	gT.Players = {}
	gT.LabelsToAdd = {}
	local bFirstInit = false;
	gT.ITGTurn = 0;
	if not gT.PoliticVictories then
		bFirstInit = true;
		gT.PoliticVictories = {};
		gT.FToptions = {};
		gT.GlobalInfos = {};
		gT.AchievementData = {};
		gT.PlotsCityName = {};
		gT.RelicInfluence = {}
		gT.WondersConstructed = {};
		gT.WondersRuins = {};
		gT.LastChosenInspiration = {}
		gT.Handicap = {}
		InitHandicapITG()
		InitIdeologiesPosition()
		if PreGame.GetGameOption("GAMEOPTION_ITG_LIMITED_SOCIALS") == 1 then
			LimitSocialDevelopments()
		end 
		SimpleMapScriptsInitGameTruely(scType)
		DoInitAIFlavours()
		local bHtst = Game:IsGameMultiPlayer()
		for i,v in pairs(Players) do
			if v:IsEverAlive() then
				if not v:IsBarbarian() then
					if not v:GetStartingPlot() then
						v:SetNeverAlive(); -- implications?
					else
						v:SetInitStartingPlot(v:GetStartingPlot())
						if bHtst and v:IsHuman() and (Game.GetActivePlayer() ~= i) then
							v:SetIgnoreDiplomacyThisTurn(true)
						end
					end
				end
			end
		end
		Game.SetITGWarmUpTurn(Game.GetGameTurn())
	else
		gT.ITGTurn = -1
	end
	gT.Heresies = {};
	gT.AuctionHouse = {}
	gT.AuctionPrices = {}
	gT.Globals = {LastTurn = 100, Provokes = {}, WonderTreshold = DBScenario.WonderTreshold, ResNumReference = {}, BannedBeliefs = {}, PlotCombatT = {}, UprisingCID = {}, NumBestPrinciples = 0, DDplantations = {}, Embassies = {}, PlotAreas = {}, TechFirstTeams = {}, PirateDeals = {}, Chateaus = {}, PirateMod = 0, CurrencyBaseVal = 200, AuctionDeals = {}, AuctionDealHistory = {}, AuctionPriceData = {}, HumanPlayers = {}, PeaceTreaties = {}, LawsChangeLog = {}, TemporaryRoads = {}, CasinoBonus = 0, TechFirstCiv = {}, YieldIfNotPillaged = {}, WondersAssignedT = {}, ExcludedTechs = {}, CaliphateMod = 1, TotalTimer = 0, CurrentTimer = os.clock(), CityStateBuildingProcesses = {}, CurrentGoldenAgeLength = 16, DiscoveredNaturalWonders = {}, 
	GrandCultBonusVote = {}, BaseArtCost = DBScenario.BaseArtCost, TradeRouteLog = {}, CodexInfPrinciples = {}, CodexInfReduction = 0, GreaterArtCost = DBScenario.GreaterArtCost, LastTimeWonderWinner = 0, BestCodex = 100, TemplarOnlyLeague = {}, BadContIDs = {}, GreatPersonNamesUsed = {}, PeaceLockCount = {}, ForcedWarRelation = {}, Diameter = GetMapSizeDiameter(), HeresyGlobal = LastRandom(0,15), GlobalInflation = 0, CSbyTypes = {}, NaturalWonders = {}, CultBonus174 = 0, RebelSponsors = {}, ExportLog = {}, AlphabetCost = 3,
	StartDate = LastRandom(DBScenario.MinStartDate,DBScenario.MaxStartDate), WondersAssigned = {}, LastPlayer = Game.GetActivePlayer(), AncientRuins = {}, WaterResources = {}, BadPoints = {}, Improvements = {}, StartingPlots = {}, ScenarioType = scType, NoFreeManContinents = {}, InfoLabels = {}, AverageMintBonus = 0, WorldWideEconomy = 0}
	gT.Globals.Season = GetSeasonFromTurn(GetITGGameTurn());
	PopulateGlobalInfos()
	--kept global data
	gT.Globals.DhamekStupa = GetGlobalDataKept("DhamekStupa")
	for h, hplayer in pairs(GetGlobalDataKept("HumanPlayers") or {}) do
		table.insert(gT.Globals.HumanPlayers, hplayer)
	end
	local bInitHuman = (#gT.Globals.HumanPlayers == 0)

	gT.TechsDisc = {}

	gT.Globals.ResourceQuantity = {}
	gT.Globals.OriginalResource = {}
	gT.Globals.OriginalFeature = {}
	if PreGame.GetGameOption("GAMEOPTION_ITG_MAP_MODIFICATIONS") == 1 then
		gT.Globals.OriginalTerrain = {}
		if bFirstInit then
			DoMapModificationKrakatoa()
		end
		DoColdWarmClimate(LastRandom(0, 2))
		if scType == 1 then
			DoMapModificationOnStartNewWorld();
		elseif scType == 2 then
			DoMapModificationOnStartTheTrial();
		elseif scType == 3 then
			DoMapModificationOnStartTheTitans();
		elseif scType == 4 then
			DoMapModificationOnStartHope(bFirstInit);
		elseif scType == 5 then
			DoMapModificationOnStartSoR(bFirstInit);
		end
		Map.RecalculateAreas();
		gT.Globals.RequireReload = true;
	end
	-------
	DoCoreContinentFunctions()
	-------
	gT.Cities = {}
	gT.SetXY = {AncientRuinsRadar = {}, Colonialism = {}}
	gT.Forts, gT.PlotFortControl, gT.FortsByUnitID = {}, {}, {}
	gT.ElDoradoByUnitID, gT.ElDorados = {}, {};
	gT.WarPeaceModInTime, gT.ShortWarPeaceLock = {}, {};
	gT.TemplarBuildingsUsed, gT.TemplarRelBuilding, gT.WonderConstructedTurn = {}, {}, {};
	gT.TemplarBonus = {}; 
	gT.TemplarStarted = {}; 
	gT.TemplarNames = {};
	gT.Leagues = {};
	gT.SettlementsByUnitID = {};
	gT.Wonders = {};
	gT.TemplarFreeBuildings = {};
	gT.Plots = {GreatAndeanBonus = {}, Tunnels = {}}
	gT.HolySites, gT.Settlements, gT.HolySitesUnits =  {}, {}, {}
	gT.ArchaeologySites = {}
	gT.ValidOceanFish = {}
	PrepareValidOceanFishMigration()
	gT.GreatPeople = {};
	gT.Academies, gT.CustomsHouses, gT.Manufactories = {}, {}, {};
	gT.ColoniesByUnitID, gT.Colonies = {}, {}
-- Game DLL settings
	Game.SetOneZeroNavalCombatMode(DBScenario.OneZeroNavalCombat)
	Game.SetBarbariansFullyStackable(DBScenario.BarbariansFullyStackable)
	Game.SetAIShouldNotExplore(DBScenario.AINoExplore)
	Game.SetBarbarianSpawnIncrease(DBScenario["BarbariansSpawnIncrease"])
	Game.SetExtraDamageModifierMeleeCombat(DBScenario.ExtraDamageModMeleeCombat)
	Game.SetExtraDamageModifierFromCity(DBScenario["DamageModFromCityCombat"])
	Game.SetBullyGoldAmount(DBScenario["BullyGoldAmount"])
	Game.SetProductionOverflowBuildings(DBScenario["BuildingProductionOverflow"]);
	Game.SetGoldPurchasingDisabled(DBScenario["NoGoldPurchasing"]);
	Game.SetStrategicReserveOn(DBScenario["StrategicReserveMod"]);
	Game.SetCultureFromCityState(DBScenario["CultureFromCS"]);
	Game.SetFaithFromCityState(DBScenario["FaithFromCS"]);
	Game.SetManufactoryResource(MF_ResourceIndex)
	Game.SetMinJointWarDistance(DBScenario["JointWarDistance"])
	Game.SetNonCombatUnitRangedDamage(DBScenario["NonCombatRangedDMG"] or 40)
	Game.SetStrategicResourceStorable(DBScenario.StrategicResStorage)
	Game.SetStrategicResourceLimit(DBScenario["StrategicResourceLimit"] or 0);
	Game.SetUnitRequireStrategicResource(DBScenario["UnitsRequireStrategicRes"])
-- Game.SetITGAirVsCityDMGMod(67)
-- Game.SetITGAirVsUnitDMGModPerDMG(50) -- 50 means that for every 2 dmg of target,both sides will take 1% damage less
-- Game.SetITGAirVsUnitDMGModPerMax(50) -- it means at least 50% dmg will be taken
	ReplaceUnvalidResourcesWithProperOnes()
	DoGenerateOceanCurrents()
	DoGenerateExtra10PercentHiddenLuxuryResources()
	DoStrategicResourceMapScript()
	DoBanBeliefsIfNoValidResources()
	hMinorTab = {}
	hMajorTab = {}
	for i,v in pairs(Players) do
		if v:IsEverAlive() then
			gT.Globals.Provokes[i] = {};
			if not v:IsBarbarian() then
				if v:IsHuman() and bInitHuman then
					table.insert(gT.Globals.HumanPlayers, i)
				end
				gT.Players[i] = {NumPrinciples = 0, ForeignDiploActionPenalty = 0, ForeignGovernors = {}, DiploNotes = {}, PowerSources = {}, WarLockReasons = {}, TradingPost = 0, NatSeasons = {}, NatDays = {}, NumCaughtSpies = 0, SettlerLog = {}, Ind5NatUnity = 0, NumGovernorChanges = 0, ArchFromManu = 0, PirateVision = {}, PiratePerks = {}, InvestLog = {}, InvestCurrencyPower = 150, AIWarningZone = {}, FreePalacePoints = 0, AISpendLegalLog = {}, PledgesOfProtection = {}, NumMaxPledges = 1, CSAlertQuest = {}, WonderRuinsEffects = {}, AverageHappiness = 0, NumDiscoveredInno = 0, MigrationChanceMods = 0, GoneCultureDevs = {}, ArchaFromTech = 0, ArchaeologistNum = 0, ArchaeologyNotes = {}, ProdFromTech = 0, TheRaceInfoTable = {}, CanUseMissionaries = false, CulturalPresenceAura = 0, CultureToPresence = 1, RebelChanceExtra = 0, TradeRouteGoldInTime = {}, NextTurnTradeRouteGold = 0, TotalTradeRouteGold = 0,
				Decadentism = LastRandom(0,3), AcaHealth = 0, AcaNatUnity = 0, NavalAcaCritical = 0, LandAcaCritical = 0, NumAncientRuins = 0, PrestigePerTurn = 0, AcadPointsPerTurn = 0, ExtraArcheologistMoves = 0, NumPrestigeVotes = 0, AcademyRewards = {}, AIScriptDoWFromRiots = {}, QuarantineUnitCost = 0, NationalDays = 0, HealthFromTech = 0, HelpCSGiftsLog = {0,0,0,0,0,0,0,0,0}, SettlerPointsFromTech = 0, CanGeneralBeKilledInBattle = 0, RailroadDiscount = 0,
				GoldFromTech = 0, LastAncientRuinT = 0, CondemnEspionage = 0, AuctionSpecialDeals = {}, GovSlots = {}, InnoProcess = 0, GovRewards = {}, TradeTargetChoiceNum = 1, PolioLabMod = 0, FestivalBonusesActive = {}, FestivalChanceMod = 1, LastFestivalTA = LastRandom(2,8), FestivalVarious = 0, LegalGainDisabled = 0, FestivalPoints = 0, YieldModGreatPeople = {}, TradeDestinationVisits = {}, BuildingIntoWonderMod = 0, ReligionUnityMod = 1, MaintenanceFreeClasses = {}, CSfriendanchor = {}, LeagueCityStatesDecay = {}, InvitationsLeague = {}, DeniedInvitationsLeague = {}, GeneralGoody = 0, AdmiralGoody = 0, FallenGenerals = 0, FallenAdmirals = 0, NoIdeologyBonus = 0, RailroadsPT = 5, RailroadMadeT = 0, ChateauAuthority = 0, ChateauCharges = 0, OpenTrade = {}, ModFromArtPeriod = 0, NavalTRTresholdChange = 0,
				ScenarioWarLocks = {}, LiberatedCities = {}, NextTechExtraOption = 0, NextInnoChance = 0, GPMeritocracy = 0, ResLockedT = {}, PilgrimVisitors = {}, ConsumedRes = {}, AnchorPenaltyLog = {}, RevolutionCost = 15, StatueOfLibertyBonus = 0, SolvePoorityGold = 0, GeneralGlobalAura = 0, SolvePoorityProduction = 0, CanPurchaseAcademy = false, BonusesAcquired = {}, LegalCorruptionMod = 1, TechColonyPoints = 0, AncientRuinsVisMod = {}, HealthFromBuildingClasses = {}, ExtraTileNewCity = 0, LeagueBaseVotes = 4, VotesFromSocials = 0, VotesFromInno = 0, MoraleFromLeague = 0, HapFromLeague = 0, LastAllyChange = 0, ExtraHealRateFromMorale = 0, DomainCaptureChance = {}, EverControlReligion = {}, Law22SciencePoints = 0, Law22FaithPoints = 0, Law22LegalPoints = 0, LegalActionCD = {}, SettlerPoints = 0, AIScriptQueue = {}, SettlerGenerationPoints = math.floor(LastRandom(0, 55) * DBScenario.SettlerTreshold / 100), RiotsHapChance = 0, UnitKillMorale = 0, UnitLossMorale = 0, RelationModifiers = {}, 
				LastCallCharges = 0, InfluenceIRGP = 0, NatDCount = {0, 0}, CodexInfGlobal = 0, PilgrimFromTech = 0, PowerFromTech = 0, CPForeignOwned = 0, EmbargoCount = 0, ExtraGPAttractions = 0, DefAgainstCounterfeit = 0, WorkRateToScience = 0, ImproGWChance = 0, CultPresOnGW = 0, CultPresWeakerCurrency = 0, UlamaChanceFestival = 0, MedievalFairFestival = 0, GWCultureIntoNU = 0.5, FestivalTriumph = 0, FreeLaws = 0, FortGenTimer = 0, LeagueProjects = {}, ExtraUnitMaintFromLaws = 0, GPYieldsMod = 1, ResGenPT = {}, AlreadyTradedCurrencyThisTurn = {}, ReligiousTradePressure = 1, ConversionLossBonusesModifier = 1, PotalaCD = 0, HasPlayerWonder = {}, KingUnitCD = 0, MoraleSituationIgnore = 0, ExtraCityStateAnchor = {}, MintSituation = {}, GreatArtistModifier = 0, NumFirstTechs = 0, PeaceLockAtExctintion = {}, BackwardTechHelp = 0, AILogicForCSProductionProject = {}, CanPlaceHolySiteOnMountain = false, ExtraFoodFromFish = 0,
				ResCurrencyAmountMod = 1, Ideo41 = 0, MintStability = 0, PowerFromEspionage = 0, ExtraAcademyCost = 0, CHeritageProject = 0, NumFreeRailroads = 0, PlotsClaimedBySetXY = {}, CurrentSituation = 0, GeneralTresholdMod = 1, AdmiralTresholdMod = 1, MoraleFromGP = 0, EverAlliedCS = {}, SituationMorale = {}, Inspirations = {}, MinMoraleRange = -15, MaxMoraleRange = 15, MoralePoints = 0, Morale = 0, MoraleQueueLog = {}, MoraleLog = {}, ObsoleteUnitClasses = {}, NewHumanQueueActions = {}, AcademyPoints = {}, CustomHousePoints = {}, ManufactoryPoints = {}, CentralizeDiscount = 0, BeliefReplacedT = {}, CurrGoldInternal = 0, TempCurrData = {}, CurrFromWarfare = 0, CurrCounterfeit = 0, CurrFromTR = 0, ResManuDiscount = 0, MinMeritocracy = 0, SmugglingArt = 0, GovernorshipRange = 0, CodexInfluenceFromLeague = 0, GPCodexInfluence = 0, AcaCodexInfluence = 0, ConsCodex = 0,
				LegalCSVisitCD = {}, GPPower = 0, GreatestCityPopCaptured = 0, UnhapIdeo12 = 0, NumUniqueGPTypes = 0, NumCivilGP = 0, NumGPArtStyles = 0, NumGPType = {}, CDIdeology12 = 0, ExtraWorkboats = 0, Law25Int = 0, CSMissions = {}, MercCostIncrease = 0, GekokujoAuthority = 0, MercCostLastPurchase = -1, WorkRateToHealSpend = 0, MercCostDoWed = 0, MercCostMight = 0, Ideo89CD = LastRandom(0,7), CurrentGPQueue = 0, GPNumTalentsOption = 1, GPHumanActionReserver = {}, GPQueue = {}, TemploMayorCD = -1, FounderBeliefModifier = 1, NumPointsChangeSocialBonus = 0, LastTimeChangedLaw = -10, GPPfromTech = 0, FaithFromTech = 0, ArtFromTech = 0, CultureFromTech = 0, WonderFromTech = 0, ScienceFromTech = 0, FortPowerFromTech = 0, NumFreeMaintenanceUnitsFromLaw = 0, CannotHaveTech = {}, MesoElDoradoPoints = 0, MesoSGRPoints = 0, MesoSGRGenerated = 0, SecularCFB = 1, MercHolyArm = 0,
				ShinobiVisionCooldown = -1, DeadMerc = 0, VotesGP = 0, ParadropTPrev = {}, CityStrengthFromTech = 0, CapitalAuthMod = 1, ParadropTNow = {}, MissionaryGrowth = 0, GovActivityMod = 1, AcademyMeritocracy = 0, ResMovementCooldown = -1, UnitGoldCostChange = 0, GovTraitMod = 1, DefenseFromSabotage = 0, EradicatedCorruption = -10, CanHaveShinobiVision = false, GPDoNotMigrateAway = 0, BaseGPFromHap = 10, ColonyTresholdModifier = 1, GPPointsFromBuildingClasses = {}, GPfromDoFs = 7, InnovationChance = 50, Gold100 = 0, NumGWoM = 0, NumGWoL = 0, NumGWoA = 0, CultIndFromGP = 0, HapChanceFromGP = 0, EmigratedGP = {}, CapturedGP = {}, CanGABeProlonged = {}, GreatPeoplePoints = LastRandom(0,517), GreatPeopleFavourType = {}, GreatPeopleFavourTowards = {}, Ideo78DataTracking = {0,0,0,0,0,0,0,0}, SpyTurnReduction = 0, AuctionOffers = {}, Authority = 0, StAlphabet = -1, NumCounterfeited = 0, Governors = {}, GovCauses = {},
				ShinobiCooldown = -1, AltUnlockBuildings = {}, LeagueCityStrength = 0, CultureFromMap = 0, AltUnlockUnits = {}, ExtraResources = {}, ManufactoryOrder = {}, BudgetAcaMod = 0, AIPalaceScript = LastRandom(4, 7), SettlingGlobally = false, NumPantheonsToChoose = 1, AIWonderProjectLog = {}, AIWonderLog = {}, SettlersReached = 0, LastWonderResult = 0, ShinobiProcess = 0, KronborgProcess = 0, KronborgCooldown = -1, AIFlavours = {Legal = LastRandom(4, 9)}, AIManagementValues = {}, MasterOfWhispers = false, GrandArchitect = false, MasterOfArmy = false, GlobalCultPresFromWonder = 0, GlobalCultPresFromTech = 0, ExtraAlliedCultPres = 0, AcaUnifyMod = 0, AcaDivideMod = 0, LegalSpendLastTurn = 0, LastTurnLegalSpend = -20, LastTurnTRorPlunder = -20, LastTurnCityCaptured = -20, LastTurnGPAscended = -20, LastTimeAttackedBySpy = -20, LastTurnCityLost = -20,
				NumSpyBought = 0, TRCulture = 0, TRCultureStored = 0, TRScience = 0, TRScienceStored = 0, FeatureRemovalMod = 1, CSImproCount = 0, ExtraMaxGovernors = 0, ResourcesUsed = {}, CulturePresAnchorFromCities = 0, CulturePresAnchor = 100, WonderPointsFromBuildingClasses = {}, ArtPointsFromBuildingClasses = {}, LegalPointsFromBuildingClasses = {}, CombatExperienceFromBuildingClasses = {}, CityStateQuests = {}, HadGoldenAge = false, TotalGoldenAgePoints = 0, GoldenAgePointsFrom = {}, GreatPeople = {}, WarPeaceLock = {}, DiscoveredNaturalWonders = {}, RelBonusMod = 1, MaxHapChanceFromLuxury = 9, BaseUnitRebornTurns = 0, TechChooseDecisions = {}, BeliefChooseDecisions = {}, HeadhuntingDone = 0, Ideo88Anchor = 0, DemographicsWonderMin = {}, DifLandMassConnect = 0, FeitoriaCharges = 0, MeritocracyFromTech = 0,
				NumTechToChooseFrom = 1, NoAuthYieldsFromPalaceMod = 1, AHScienceComp = 0, GoldPTPancras = 0, ExtraSupply = 0, BrandenburgMod = 0, CityIndex = 0, TradeGoldModAcademies = 0, UnitClassMaxNumPromotions = {}, UnitClassNumPromotions = {}, QueueActionsRealEndTurn = {}, ScienceFromHolySitesPerTurn = 0, UnitClassXPNeededNext = {}, SpecialUUTresholdRed = 0, LastScienceBonusCost = 0, LastTurnColoniesPoints = 0, LastTurnGreatArtistPoints = 0, HasIdeology = {}, HasMinorIdeology = {}, LastSabotage = -20, NumMilitaryEngineers = 0, HapComparisionMod = 0, VisionIdeo77 = {}, DiplomaticMarriages = {}, CSTargetRelation = {}, WLTKTurns = LastRandom(7, 12), CHFestChance = 0, WLTKChance = 0, HapChanceLuxuryLost = 0, CultINDMemorial = 0, InfCodexFromPrinciples = 0,
				AIhateValues = {}, WorkRateFromBuildingClasses = {}, CultureBonusQueue = {}, ProcessMod = 1, CultBonusOn = {}, LastAnarchyRevolution = -50, TradeRoutesLost = {}, Embargos = {}, NatUnity = 0, Agents = {}, CanUseRecon = false, InflationLastTurn = 0, BuildingsIdeo64 = {}, NumAssassinatedGP = 0, SiegeTowerSupport = 0, BatteringSupport = 0, GoldFromAuctionHouse = 0, ImproCostMod = 1, Luxury1T = {}, CritGrievances = {}, BrokenAHDeals = 0, MeritocracyLevel = 50, MeritocracyValues = {}, GoverCodexInfluence = 0, EspCodexInfluence = 0,
				GovMinorAnchor = {}, Satellites = {}, MF_MaintCostRed = 0, CSUnbulliable = 0, ManuMorale = 0, RetiredGPPoints = 0, CSUncorruptable = 0, LegalFromTech = 0, GovMinorDecay = {}, GovMinorRecovery = {}, LegalPower = LastRandom(0,3), LegalPowerPercent = LastRandom(0, 75), NegativeSpyActions = {}, EspionageLog = {}, RivalSpiesActive = {}, MintPower = 0, GoldSpendInternally = 0, MintBonus = 0, Currencies = -1, UsedBeliefs = {}, FishLost = 0, CurrentCultureTreshold = 1, HapGuaranteeFunds = 0, HapFromIncomeChange = false, LuckyCombatFromSpies = 0, Ideo90CritChance = 0, FairFestival = 0, LoyaltyGA = 0, GhostUnits = {}, Cult147T = {}, HeresyLocal = 0, HeresyPilgrimSlayer = 0, BullyLog = {},
				CurrentReligionTreshold = 1, AchvT42 = {}, WorkFromTech = 0, FascismMod = 0, FascismAuth = 0, CurrPowerAcad = 0,	GPfromAca = 0, NumFreePromotions = 0, NumRealFreePromotions = 0, MaxClassPromotions = 5, FreeColonies = 0, GreatArtistPoints = 0, ColonyPoints = LastRandom(0,45), NumGreatWorks = 0, TotalHapChanceFromLuxuries = 0, SleepHapChanceFromLuxuries = {}, HapChanceFromLuxuries = {}, CanWonderRace = false, HumanQueueActions = {}, NumFortPoints = 0, UnitClassDelayedXPGain = {}, UnitClassAIPromPath = {}, UnitClassFreePromUsed = {}, UnitClassTreshold = {}, UnitClassXP = {}, 
				ColonyTreshold = DBScenario.ColonyTreshold + LastRandom(0,3) * DBScenario.ColonyTresholdIncrease, NumCounterSpies = 0, HolySitePoints = 0, UnitClassPromotions = {}, UnitsByID = {}, StartingPlot = v:GetStartingPlot():GetPlotIndex(), BeforeLoadVisionModifier = {}, Improvements = {}}
				for jjj = 1, 15 do
					gT.Players[i].YieldModGreatPeople[jjj] = 1;
				end
				for ki, kv in pairs(Players) do
					if kv:IsEverAlive() then
						gT.Players[i].AIhateValues[ki] = 0;
					end
				end
				for row in GameInfo.Domains() do
					gT.Players[i].DomainCaptureChance[row.ID] = 0;
				end
				if v:IsMinorCiv() then
					gT.Players[i].LeagueBaseVotes = 2;
					table.insert(hMinorTab, i);
				else
					table.insert(hMajorTab, i);
				end
			end
		end
	end
	for i, human in pairs(gT.Globals.HumanPlayers) do
		gT.Players[human].IsHuman = true;
	end
	if DBScenario.EmptyCont then
		FindMostProperEmptyCont(hMajorTab)
	end
	gT.Globals.NumPlayersMajor = #hMajorTab;

	gT.Globals.MintTotalBonus = 25;
	AssignCultureFunction(hMinorTab, hMajorTab)
	InitCityStates(hMinorTab)
	
	InitialAILeagueFlavours()
	DoScenarioEffectsInitial()
	OnInitialBuildings()
	for i, minorID in pairs(hMinorTab) do
		for iUnit in Players[minorID]:Units() do
			if iUnit:GetUnitType() == uSettler then
				GenerateCity(minorID, iUnit:GetPlot(), "minorInit")
			end
			iUnit:Kill(false, -1)
		end
	end
	print("NGG 1")
	AssignTechnologies() -- TECHS here;
	DoSetPalaceReplacementInit();
	GeneratePossibleCityLocations()
	for it, i in pairs(hMajorTab) do
		OnInitialPlayer(i)
	end
	if (PreGame.GetGameOption("GAMEOPTION_ITG_BLOB_TERRITORIES") == 1) then
		BlobTerritoryInitCities()
	end
	GlobalCityFoundQueue = Shuffle(GlobalCityFoundQueue);
	for it, qplayer in pairs(GlobalCityFoundQueue) do
		local sPlot = GetPossibleCityLocation(qplayer);
		if sPlot then
			CityLocations[sPlot:GetPlotIndex()] = nil;
			GenerateCity(qplayer, sPlot, "InitFound")
		end
	end
	GlobalCityFoundQueue = {};
	print("NGG 2")
	local tabToFill = {}
	for i, data in pairs(gT.Players) do
		if data.NumStartingCities then
			if data.NumStartingCities > Players[i]:GetNumCities() then
				table.insert(tabToFill, {i, data.NumStartingCities - Players[i]:GetNumCities()})
			end
		end
	end
	if #tabToFill > 0 then
		FillWithCities(tabToFill)
	end
	if DBScenario.ExtraCityFill then
		ClearCityLocations()
		GeneratePossibleCityLocations(6)
		HeavyFillWithCities(#hMajorTab)
	end
	for g, h in pairs(gT.Players) do -- PRINT TO BE REMOVED
		if not Players[g]:IsMinorCiv() then
			print("Player/NumCities/TargetNumCities", g, Players[g]:GetNumCities(), h.NumStartingCities);
		end
	end
	ClearCityLocations()
	GeneratePossibleCityLocations(3)
	print("NGG 3")
	DoInitMeritocracy() 
	InitialFortsAndCitadels()
	FillWithResourceTreasuryCont()
	LittleConquer(hMinorTab, hMajorTab) -- CONQUEST
	SpecialArmyDoInit(hMajorTab)
	AssignInitialUnits()
	PlaguesInitialData()
	CultureCitiesInitialData()
	AssignTheVision()
	print("NGG 4")
	InitBarbarians()
--	MeetThePlayers()
	--HERE :)
	AssignTheColonies()
	RedoInspirations(); -- before wonders
	print("NGG 5")
	AssignTheWonders() -- solomon temple, should be before assigning the religions // yet hanging temple and many others should be after :)
	AssignTheReligions(hMajorTab, hMinorTab)  -- RELIGION
	OnInitialScience(hMajorTab)
	OnInitialCulture(hMajorTab)
	InitialGeneralsAndAdmirals(hMajorTab)
	AssignUniqueCityStateUnitsBasedOnCulture(hMinorTab)
	AssignUniqueImprovementsToPlayers(hMajorTab, hMinorTab)
	print("NGG 6")
	GenerateBaseRelationsOnStart(hMinorTab, hMajorTab)
	AssignInitialRelations()
	AssignInitialSettlerMatters()
	AssignTheAncientRuinsStuff() -- this before impro
	AssignTheCityPlotsValid() -- here are initial improvements! after tech
	NoFreeManLandStuff() -- this must be after assign the city plots valid!
	PostNoFreeLandAncientRuins() -- this after nofreemanland
	AssignTheColoniesSpecial()
	for i, data in pairs(gT.Players) do
		if Players[i]:GetNumCities() > 1 then
			MakeTheRoadsForPlayer(i)
		end
	end
	FixTheRoads()
	TakeCareOfCurrencyResources()
	OnInitialFestivals(hMajorTab)
	
	AssignInitialAcademies(#hMajorTab)
	AssignInitialCustomsHouses()
	AssignInitialManufactories()
	
	OnInitialAssignCurrencies(hMajorTab)
	AssignTheCityStuffAfterConquerValid()
	AssignInitialDecayAnchorRecovery(hMajorTab, hMinorTab)
	GenerateHolySitesLocations()
	AnnualFishMigration()
	AssignInitialGoverment() -- goverment
	AssignEspionage()
	print("NGG 7")
	InitialHappinessStuff()
	GenerateInitialCivilianGP() -- GREAT PEOPLE HERE
	DistributeInitialCultureBonuses()
	InitialLawsAllPlayers(); -- laws
	RemoveTooManyWorkBoats();
	PrepareStuffForEndEra();
	InitRailroads();
	InitialMintRelatedStuff()
	AssignEndTurnMintPowerChanges()
	ChangeTradeabilityOfStrategicResources(1)
	OnInitialAIDiagnosis()
	AssignInitialCodexes();
	AssignInitialGreatWorks()
	InitialAddAIScripts();
	RedopoliticsVictories()
	HealthInitial();
	InitIdelogies(hMajorTab)  -- IDEOLOGIES -> gov tenets should be after that :/
	DoInitGovTenets(hMajorTab)
	DoInitialRelations(); -- checkpoint
	InitMercenaryStuff();
	InitialAcademyMatters();
	for g, gdata in pairs(gT.Players) do
		DefinePlayerForcedUpgradeCost(g)
	end
	print("NGG 8") -- it was the last print (except not finidng trade route 70 dis) before not repeatable CTD
	GenerateStartingTradeRoutes(hMajorTab)
	DoInitAuthorityMatters()
	InitialCultureIndicator()
	InitArchaeologySystem()
	RecalculateKasbahsBonus()
	InititalGoldenAge()
	InitialDirtyHeresyMod()
	InitialMoraleAdjust()
	print("NGG 8.6")
	AssignScriptedLeagues()
	print("NGG 8.7")
	DoInitPrevGPTValues();
	DoInitialGoldBudget();
	GameInitStockExchange()
	InitVictoryConditions(hMajorTab)
	UncontrollableUnitsNewGame()

	--GameGenerated / Generate Infos
	RestoreAIFlavours(hMajorTab)
	DoStoreGlobalsInfo()
	if PreGame.GetGameOption("GAMEOPTION_ITG_AI_GAME") ~= 1 then
		for i, human in pairs(gT.Globals.HumanPlayers) do
			GenerateTheDoMData(human)
			HumanSetAIAutoManagementAuctionH(human, 4)
		end
		DoCheckInitialAchievements()
	else
		for i, human in pairs(gT.Globals.HumanPlayers) do
			gT.Players[human].AIFavourOfLaws = {}
			PrepareAIFavoursOfLaws(human)
		end
		gT.Globals.HumanPlayers = {}
	end
	print("Start End Turn", GetRealGameTurn(), gT.Globals.LastTurn, GetITGGameTurn())
	Game.SetITGEndTurn(GetRealGameTurn() + gT.Globals.LastTurn - GetITGGameTurn())
	for i, major in pairs(hMajorTab) do
		Players[major]:ITGMiniDiploReset(); -- it resets diplomacy (ex. ai angry about religious conversion)
	end
	ClearNoLongerNeededEraData()
	gT.Globals.BadPoints = {} -- this data is no longer needed to be saved
	gT.Globals.GameGenerated = true;
	gT.Globals.JustGenerated = true;
end

function EvalBlobTerritoryInitCity(iPlayer, data)
	local eVal = LastRandom(900, 999);
	for a, b in pairs(data) do
		if a ~= iPlayer then
			eVal = math.min(eVal, b);
		end
	end
	return eVal;
end

function BlobTerritoryInitCities()
	-- heavy
	local cAmountCities = {}
	for a, b in pairs(GlobalCityFoundQueue) do
		cAmountCities[b] = 1 + (cAmountCities[b] or 0);
	end
	local doneCities = 0;
	GlobalCityFoundQueue = {}
	local bContinue = true;
	local dnca = {}
	while bContinue do
		local tdPlayers = {};
		bContinue = false;
		for iPlayer, am in pairs(cAmountCities) do
			if not dnca[iPlayer] then
				table.insert(tdPlayers, iPlayer)
			end
		end
		tdPlayers = Shuffle(tdPlayers);
		local clphh = {}
		for iPlotIndex, i in pairs(CityLocations) do
			local iPlot = Map.GetPlotByIndex(iPlotIndex)
			local iPlotX, iPlotY = iPlot:GetX(), iPlot:GetY();
			clphh[iPlotIndex] = {};
			for a, iPlayer in pairs(tdPlayers) do
				clphh[iPlotIndex][iPlayer] = GetClosestCityDistanceToXY(iPlayer, iPlotX, iPlotY)
			end
		end
		for a, iPlayer in pairs(tdPlayers) do
			local bestindex;
			local besteval = 0;
			for index, data in pairs(clphh) do
				if data[iPlayer] and (data[iPlayer] < 9) then -- may need change to 8;
					local tEval = EvalBlobTerritoryInitCity(iPlayer, data);
					if tEval > besteval then
						besteval = tEval;
						bestindex = index;
					end
				end
			end
			if bestindex then
				GenerateCity(iPlayer, Map.GetPlotByIndex(bestindex), "InitFoundBlob")
				cAmountCities[iPlayer] = cAmountCities[iPlayer] - 1;
				doneCities = doneCities + 1;
				if cAmountCities[iPlayer] == 0 then
					cAmountCities[iPlayer] = nil;
				else
					bContinue = true;
				end 
				clphh[bestindex] = nil;
				CityLocations[bestindex] = nil;
			else
				dnca[iPlayer] = true;
			end
		end
	end
	local aLeft = 0;
	for iPlayer, am in pairs(cAmountCities) do
		aLeft = aLeft + am + 0.01;
		for i = 1, am do
			table.insert(GlobalCityFoundQueue, iPlayer);
		end
	end
	print("Blob Territory init Cities left:", aLeft, doneCities)
end

function GetPossibleCityLocation(iPlayer)
	local hTab = {}
	local sPlot = Map.GetPlotByIndex(gT.Players[iPlayer].StartingPlot);
	local npc = GetDBCulturePlayerInfo(iPlayer, "NeedPassabilityCheck")
	for iPlotIndex, i in pairs(CityLocations) do
		local iPlot = Map.GetPlotByIndex(iPlotIndex)
		if (not npc) or (GetPassabilityAreaID(iPlot) == GetPassabilityAreaID(sPlot)) then
			local bDistance = LastRandom(10,14);
			if AreConnectedWithWater(iPlot, sPlot) then
				bDistance = 21;
			end
			if Map.PlotDistance(sPlot:GetX(), sPlot:GetY(), iPlot:GetX(), iPlot:GetY()) < bDistance then
				table.insert(hTab, iPlot)
			end
		end
	end
	if #hTab > 0 then
		return hTab[LastRandom(1, #hTab)]
	end
	return nil;
end

function IsPossibleCity(x,y,hmindis, bBadID)
	if gT.Globals.BadContIDs[GetContID(Map.GetPlot(x,y), 15325)] then
		return false;
	end
	if gT.Globals.BadPoints[Map.GetPlot(x,y):GetPlotIndex()] then
		if gT.Globals.BadPoints[Map.GetPlot(x,y):GetPlotIndex()][1] ~= bBadID then
			return false;
		end
	end
	for index, ddd in pairs(gT.Globals.BadPoints) do
		if (ddd[2] > 0) and (ddd[1] ~= bBadID) then
			if ddd[2] >= Map.PlotDistance(x, y, Map.GetPlotByIndex(index):GetX(), Map.GetPlotByIndex(index):GetY()) then
				return false;
			end
		end
	end
	local minDis = hmindis or LastRandom(4,6);
	for iPlayer, data in pairs(gT.Players) do
		local iPlot = Map.GetPlotByIndex(data.StartingPlot);
		if Map.PlotDistance(x,y, iPlot:GetX(), iPlot:GetY()) < minDis then
			return false;
		end
	end
	for g, gh in pairs(gT.Players) do
		for iCity in Players[g]:Cities() do
			if Map.PlotDistance(x,y, iCity:GetX(), iCity:GetY()) < minDis then
				return false;
			end
		end
	end
	for iPlotIndex, i in pairs(CityLocations) do
		local iPlot = Map.GetPlotByIndex(iPlotIndex)
		if Map.PlotDistance(x,y, iPlot:GetX(), iPlot:GetY()) < minDis then
			return false;
		end
	end
	return true;
end

function IsThereASenseForACity(fPlot)
	if fPlot:GetTerrainType() == tSnow then
		return false;
	end
	local contID = GetContID(fPlot, 5325345)
	if GetSizeOfCont(contID) < 15 then
		return true;
	end
	local imp, mount = GetMountainAndImpassableData(fPlot);
	if imp > 4 then
		return false;
	end
	if mount == 4 then
		return true;
	end
	return true;
end

function ClearCityLocations()
	CityLocations = {}
end

function GetCityLocations()
	return CityLocations;
end

function GeneratePossibleCityLocations(hmindis, bSplots, bBadID, bMidGame)
	local hTab = {}
	if bSplots then
		for g, h in pairs(gT.Players) do
			CityLocations[Players[g]:GetStartingPlot():GetPlotIndex()] = 1;
		end
	end
	local storedEvals = {}
	for i = 0, Map:GetNumPlots() - 1, 1 do
		local fPlot = Map.GetPlotByIndex( i );
		if CanPlotBeCityVeryBasic(fPlot) then
			if fPlot:GetImprovementType() == -1 then
				if (not bMidGame) or ((fPlot:GetOwner() == -1) and (not IsSpecialControlPlotBlockingSettlementOnPlot(fPlot))) then
					local plotEval = GetValueAIOfPlotForSettle(fPlot);
					table.insert(hTab, {i, plotEval})
					storedEvals[i] = plotEval;
				end
			end
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for it, data in pairs(hTab) do
		if data[2] > 55 then
			local hPlot = Map.GetPlotByIndex(data[1]);
			local bContinue = true;
--new stuff for oceans and canals
			local bPlot, bPOV = nil, 0;
			for j = 0, 5 do
				local nPlot = Map.PlotDirection(hPlot:GetX(), hPlot:GetY(), j)
				if nPlot and ((storedEvals[nPlot:GetPlotIndex()] or 0) >= 0.85 * data[2]) then
					local nPOV = GetInitValAsNavalCity(nPlot);
					if nPOV > bPOV then
						bPOV = nPOV;
						bPlot = nPlot;
					end
				end
			end
			if bPlot and (bPOV > GetInitValAsNavalCity(hPlot) + 9) then
				if IsThereASenseForACity(bPlot) then
					if IsPossibleCity(bPlot:GetX(), bPlot:GetY(), hmindis, bBadID) then
						bContinue = false;
						print("Better Ocean Cities from/to", data[1], bPlot:GetPlotIndex())
						CityLocations[bPlot:GetPlotIndex()] = 1;
					end
				end
			end
			if bContinue then
				if IsThereASenseForACity(hPlot) then
					if IsPossibleCity(hPlot:GetX(), hPlot:GetY(), hmindis, bBadID) then
						CityLocations[data[1]] = 1;
					end
				end
			end
		end
	end
end

function IsValidPlotForCityToClaim(iPlot, iPlayer)
--	if (not (iPlot:IsWater() and iPlot:GetFeatureType() == -1)) and (not iPlot:IsMountain()) and (iPlot:GetTerrainType() ~= tDesert or iPlot:GetFeatureType() ~= -1 or iPlot:GetResourceType() ~= -1 or iPlot:IsHills()) then
	return true;
end

local alAIT = {}
local pAIval = {}
local GetRiverValDis = {6,5,2}
local GetResValDis = {9,6,2}
local GetNatWondDis = {20, 10, 4}
local GetMouDist = {4, 1, 0}
local GetNWDis = {2,1,0}
local GetCtRFDis = {7,3,0}
function GetValueAIOfPlotForSettle(iPlot)
	if not pAIval[iPlot] then
		local val = 0;
		if iPlot:GetTerrainType() == tSnow then
			pAIval[iPlot] = 0;
		else
			if iPlot:IsHills() then
				val = val + 7;
			end
			if iPlot:IsRiver() then
				val = val + 5;
			end
			if iPlot:GetResourceType() == -1 then
				val = val + 3;
			end
			if iPlot:IsCoastalLand() then
		--		val = val + 8;
				for i, OceanID in pairs(GetCoastOfOceanTab(iPlot)) do
					if gT.ValidOceanFish[OceanID] then
						if GetSizeOfOcean(OceanID) > 100 then
							val = val + 18;
						else
							val = val + 10;
						end
					end
				end
			end
			local tOc = {}
			local ihCC = 0;
			for ix = -3, 3 do
				for iy = -3, 3 do
					local nPlot = Map.GetPlot(iPlot:GetX() + ix, iPlot:GetY() + iy)
					if nPlot then
						local dis = Map.PlotDistance(iPlot:GetX(), iPlot:GetY(), nPlot:GetX(), nPlot:GetY());
						if dis < 4 and dis > 0 then
							if dis == 1 then
								if nPlot:IsWater() and (not nPlot:IsImpassable()) then
									local nOceanID = GetOceanID(nPlot)
									if not tOc[nOceanID] then
										ihCC = ihCC + 1;
										tOc[nOceanID] = true;
									end
								end
							end
							if nPlot:GetOwner() == -1 then
								if nPlot:IsWater() then
									if HasValidWaterResource(nPlot) then
										val = val + 2 * GetResValDis[dis];
									end
								else
									if nPlot:IsRiver() then
										val = val + GetRiverValDis[dis];
									end
									if nPlot:GetResourceType() ~= -1 then
										val = val + GetResValDis[dis];
									end
									if nPlot:GetFeatureType() ~= -1 then
										if GameInfo.Features[nPlot:GetFeatureType()].NaturalWonder then
											val = val + GetNatWondDis[dis];
										end
									end
									if nPlot:IsMountain() then
										val = val + GetMouDist[dis];
									end
									if not nPlot:IsWater() then
										val = val + GetNWDis[dis];
									end
									if nPlot:IsCityRadius() == 0 then
										val = val + GetCtRFDis[dis];
									end
								end
							end
						end
					end
				end
			end
			if ihCC > 1 then
				local icanalval = 100; -- max eval is +25
				for oceanID, hhh in pairs(tOc) do
					icanalval = math.min(icanalval, GetSizeOfOcean(oceanID))
				end
				val = val + math.floor(icanalval/4)
			end
			pAIval[iPlot] = val;
		end
	end
	return pAIval[iPlot];
end

function GetInitValAsNavalCity(iPlot)
	local eval = 0;
	for i, OceanID in pairs(GetCoastOfOceanTab(iPlot)) do
		if gT.ValidOceanFish[OceanID] then
			local iSize = GetSizeOfOcean(OceanID);
			if eval > 0 then
				eval = eval + 10;
			end
			if iSize > 100 then
				eval = eval + 10;
			elseif iSize > 50 then
				eval = eval + 5;
			end
		end
	end
	return eval;
end

function OnInitialPlayer(i)
	local pPlayer = Players[i];
	local iPlot = Players[i]:GetStartingPlot();
	GenerateCity(i, iPlot, "StartingInitPlayer")
	local cTg = LastRandom(4, 9);
	if gT.Players[i].ScenarioForcedStartingCities then
		cTg = gT.Players[i].ScenarioForcedStartingCities;
		gT.Players[i].ScenarioForcedStartingCities = nil;
	else
		local msc = GetDBCulturePlayerInfo(i, "MinStartCities")
		if msc then
			local msc2 = GetDBCulturePlayerInfo(i, "MaxStartCities")
			cTg = LastRandom(msc, msc2);
			if HasSettlerBless(i) then
				cTg = math.max(cTg, LastRandom(msc, msc2));
			end
		end
	end
	gT.Players[i].NumStartingCities = cTg;
	for iT = 1, cTg - 1 do
		table.insert(GlobalCityFoundQueue, i)
	end
	for iUnit in pPlayer:Units() do
		iUnit:Kill(false, -1)
	end
end

function CityFoundedMain(iPlayer, iCityX, iCityY)
	local iCity = Map.GetPlot(iCityX, iCityY):GetPlotCity();
	local bCap = iCity:IsCapital();
	local minPop, maxPop = 0, 0;
	if bCap then
		minPop, maxPop = 1, 3;
	end
	local hdata = GetDBStartingPopVar(iPlayer)
	local pop = LastRandom(hdata[1] + minPop, hdata[2] + maxPop);
--	local ptc = math.max(0, pop - LastRandom(2,5))
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	gT.Players[iPlayer].CityIndex = gT.Players[iPlayer].CityIndex + 1;
	local cityPlayerindex = iPlayer .. "x" .. gT.Players[iPlayer].CityIndex
	gT.Cities[cID] = {PalaceUpgrades = 0, MTnavalTR = 0, TRAttrFromGP = 0, PilgrimLog = {}, LastRangedStrike = -1, UnhapFromTrained = 0, MTlandTR = 0, FishInTime = {}, FishTotalT = 0, FishNextT = 0, FishProd = 0, Tplagues = 0, SpeedUpTrade = 0, AcademyPrestigeGen = 0, AcademyPassiveGen = 0, CHUpgradePassive = 0,
AcademyRewards = {}, NumBuildingConstructed = 0, HeresyMod = 0, FeaturesRemoved = 0, Academies = {}, CustomsHouses = {}, Manufactories = {}, PlagueDefense = 0, HealthFromGP = 0, MaxHealthEver = 0, HealthFromEpidemy = 0, Health = 0, HealthLevel = 0, Epidemies = {}, HasCultBonus = {}, ExtraHPFromJungle = 0, ExtraHPFromCult127 = 0, ExtraHPFromCult129 = 0, LastAcquired = -10,
LastRebellion = -100, KasbahTR = 0, GPTradeRoutesModifier = 0, RoadConnected = {}, DoNotCheckRoads = {}, LHBombPop = 0, LHBombBuildings = 0, PilgrimProgress = 0, PilgrimGP = 0, TRFoodNext = 0, TRFoodT = 0, FoodTRInTime = {}, TRProdT = 0, TRProdNext = 0, ProdTRInTime = {},
UnhapGenerated = {}, ReadyToRiot = false, LastRiots = LastRandom(-7, -3), HapChanceFromFestival = 0, LastTurnTrainedUnit = -20, LastReligionChange = -16, TRattrFest = 0, Cult57 = 0,
geIndex = cityPlayerindex, Mountain = GetMountainCityValue(iCity), CPfromAca = 0, CanDoTradeProcess = 0, HapChanceFromGP = 0, NumAttackesEverMade = 0, NumWonders = 0, RelPressureFromFollowers = {}, ConnectedByRiver = false, RiotsEnter = 0, RiotsBuildingDestroyed = 0, FishFoodTotal = 0, FishFoodReduction = 0, NumAttacks = 1, NumAttacksWorkRate = 0, SpiesActive = {}, CurrencyResYield = {}, SpiesRelPressure = {}, HolySitesPressures = {}, ImprovementCost = 200, TradeRoutesCompleted = {}, 
CaravanProgress = 0, CargoProgress = 0, LastTimeDamaged = -10, CurrentWorkAction = -1, WorkRate = LastRandom(0,75) * 10, Happiness = LastRandom(-10,20), Riots = -1, BeliefsActive = {}, Colonies = {}, Plot = iCity:Plot():GetPlotIndex(), StartPopulation = pop}
	AdjustStrengthOfAllCities(iPlayer)
	DoSelectionOnCityFoundSettlerPlots(iCity)
	DoLogCityLocation(iCity:Plot())
	if gT.Globals.GameGenerated then
		VictoryTaskCompletion(iPlayer, 31)
		VictoryTaskCompletion(iPlayer, 32)
		gT.Players[iPlayer].CitiesFounded = gT.Players[iPlayer].CitiesFounded + 1;
		if gT.Players[iPlayer].CitiesFounded == 5 then
			if Players[iPlayer]:IsHuman() then
				LuaEvents.ITG_AchievementCompleted(18)
			end
		end
		gT.Cities[cID].HighestPop = iCity:GetPopulation();
		gT.Cities[cID].HighestPopFood = iCity:GetFood();
		gT.Cities[cID].StartingPop = iCity:GetPopulation();
		gT.Cities[cID].StartingPopFood = iCity:GetFood();
		gT.Cities[cID].LastTurnDamage = 0;
		gT.Cities[cID].TotalDamage = 0;
		gT.Cities[cID].WorkRate = 0;
		gT.Cities[cID].LastRiots = GetITGGameTurn()
		gT.Cities[cID].InitAntiCorruption = GetITGGameTurn();

		DoApplySocialPoliciesOnNewCity(iPlayer, iCity, cID, true)
		DoApplyLawEffectsOnNewCity(iPlayer, iCity, cID, nil)
		DoApplyInnovationBonuses(iPlayer, iCity, cID, nil)
		DoApplyIdeologyBonusesNewCity(iPlayer, iCity, cID)
		UpdateCityMaxHitPoints(cID, iPlayer, iCity)
		DoDirtyBudgetValues(iPlayer)
		local sRel = gT.Players[iPlayer].OfficialReligion;
		if sRel then
			MakeReligionPercentageOfTotal(sRel, iCity, 85)
		end
		local getnaval, fishboats, lPlot, cMakeWorkboats = GetCityNavalUnitsBasedOnBasinSize(iCity:Plot(), gT.Players[iPlayer].CultureType)
		gT.Cities[cID].CanDoWorkboats = cMakeWorkboats;
		AddFreeBuildings(iCity, iPlayer)
		if gT.Players[iPlayer].CannotBeConverted then
			iCity:SetSpreadImmune(true)
		end
		for i = 1, (gT.Players[iPlayer].ExtraTileNewCity or 0) do
			DoITGCityAcquirePlot(iCity)
		end
		DoInitialNearbyCities(iCity, false)
		DoInitialCityCulture(cID, iCity, iPlayer)
		UpdatePressureOfAllHolySites()
		NewCityFoundedForTradeRoutes(iCity)
		if gT.Players[iPlayer].IsConsideredBarbarian then
			RemoveBarbarianStatus(iPlayer, "Found new city")
		end
		NewCityForGovernors(iPlayer, iCity, cID)
		AchievementCheckOnCityFound(iPlayer, iCity, cID)
	else
		--name reconsideration
		if bCityPosLinked then
			if (not Players[iPlayer]:IsMinorCiv()) and (not gT.Players[iPlayer].MovedLocation) then
				local hNameTab = {};
				for i = 0, 5 do
					local nPlot = Map.PlotDirection(iCity:GetX(), iCity:GetY(), i);
					if nPlot then
						local nIndex = nPlot:GetPlotIndex();
						if gT.PlotsCityName[nIndex] and (not gT.Players[gT.PlotsCityName[nIndex][1]].MovedLocation) then
							table.insert(hNameTab, gT.PlotsCityName[nIndex][2])
						end
					end
				end
				if gT.PlotsCityName[iCity:Plot():GetPlotIndex()] then
					table.insert(hNameTab, gT.PlotsCityName[iCity:Plot():GetPlotIndex()])
				end
				if #hNameTab > 0 then
					local hName = hNameTab[LastRandom(1, #hNameTab)];
					if hName ~= iCity:GetName() then
						local bcity = GetCityByName(hName)
						if bcity then
							local vCityName = iCity:GetName();
							for i = 1, 10 do
								local vrn = "EtHCity" .. LastRandom(1, 1000);
								if not GetCityByName(vrn) then
									iCity:SetName(vrn)
									bcity:SetName(vCityName)
									iCity:SetName(hName)
									break;
								end
							end 
						else
							iCity:SetName(hName)
						end
					end
				end
			end
		end
	end
	if not gT.PlotsCityName[iCity:Plot():GetPlotIndex()] then
		if not Players[iPlayer]:IsMinorCiv() then
			if not gT.Players[iPlayer].MovedLocation then
				gT.PlotsCityName[iCity:Plot():GetPlotIndex()] = {iPlayer, iCity:GetName()};
			end
		end
	end
	for i = 0, 5 do
		local nhp = Map.PlotDirection(iCity:GetX(), iCity:GetY(), i);
		if nhp then
			gT.PlotFortControl[nhp:GetPlotIndex()] = nil;
		end
	end
--	ManageInitialCityData(cID, iCity, iPlayer)
--	UpdateCityData(cID, iCity, iPlayer)
end
GameEvents.PlayerCityFounded.Add(CityFoundedMain)

function AssignTheCityStuffAfterConquerValid()
	for iPlayer,v in pairs(Players) do
		if gT.Players[iPlayer] then
			for iCity in v:Cities() do
				local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
				if iCity:IsResistance() then
					if LastRandom(1,10) < 10 then
						iCity:ChangeResistanceTurns(-1)
						iCity:SetDamage(0)
					else
						iCity:ChangeResistanceTurns(LastRandom(0, 4))
						iCity:SetDamage(LastRandom(1, iCity:GetMaxHitPoints() - 1))
					end
				end
				DoTrickToMakeCityInTheMiddleOfGame(iCity, iPlayer)
				if iCity:FoodDifference() < 0 then
					if DBScenario.FreeGranaries then
						local buildingType = Players[iPlayer]:GetPlayerUniqueBuilding(GameInfoTypes.BUILDINGCLASS_GRANARY);
						if (buildingType ~= -1) and (not iCity:IsHasBuilding(buildingType)) then
							if iCity:CanConstruct(buildingType, 1, 1) then
								iCity:SetNumRealBuilding(buildingType, 1)
							end
						end
						if iCity:FoodDifference() < 0 then 
							buildingType = Players[iPlayer]:GetPlayerUniqueBuilding(GameInfoTypes.BUILDINGCLASS_AQUEDUCT);
							if (buildingType ~= -1) and (not iCity:IsHasBuilding(buildingType)) then
								if iCity:CanConstruct(buildingType, 1, 1) then
									iCity:SetNumRealBuilding(buildingType, 1)
								end
							end
						end
					end
				end
			end
		end
	end
end

function DoTrickToMakeCityInTheMiddleOfGame(iCity, iPlayer)
	local cType = gT.Players[iPlayer].CultureType;
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local pop = gT.Cities[cID].StartPopulation
	gT.Cities[cID].LastTurnDamage = iCity:GetDamage();
	gT.Cities[cID].TotalDamage = 0;
	gT.Cities[cID].WorkRate = LastRandom(1,15) * 10;
	AssignStartingBuildigns(iCity, cType, pop, iPlayer)
	local iLeftPop = pop - iCity:GetPopulation();
	while iLeftPop > 0 do
		if iCity:GetSpecialistCount( GameDefines.DEFAULT_SPECIALIST ) < 2 then
			iCity:ChangePopulation(math.min(2, iLeftPop), true);
			iLeftPop = iLeftPop - 2;
		else
			print("Cannot work with citizens", iCity:GetName(), iCity:GetPopulation(), pop, iLeftPop)
			iLeftPop = -1;
		end
	end
--	iCity:SetPopulation(pop, true);
	iCity:ChangeFood(LastRandom(0, math.floor(iCity:GrowthThreshold() * 3/4)))
	iCity:SetJONSCultureStored(LastRandom(0, math.ceil(iCity:GetJONSCultureThreshold() * 3 / 4)))
	AssignAIConstructionProcess(iCity, true)
end

local g_CityPlotsAcquired = {}
function AssignTheCityPlotsValid()
	local roulette = {}
	g_CityPlotsAcquired = {}
	for iPlayer, g in pairs(gT.Players) do
		for iCity in Players[iPlayer]:Cities() do
			local cType = g.CultureType;
			local exPlotPerPlot = GetDBCulturePlayerInfo(iPlayer, "ExtraPlotsPerPop") / 100;
			local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
			local cindex = iCity:Plot():GetPlotIndex()
			local pop = gT.Cities[cID].StartPopulation;
			local ptc = math.max(0, pop * (1 + exPlotPerPlot) - LastRandom(0,2))
			if iCity:IsCapital() then
				ptc = ptc + 2;
			end
			for i = 1, ptc do
				table.insert(roulette, cindex)
			end
			g_CityPlotsAcquired[cindex] = {}
			for i = 0, 5 do
				local iPlot = Map.PlotDirection(iCity:GetX(), iCity:GetY(), i);
				if iPlot then
					if not IsValidPlotForCityToClaim(iPlot, iPlayer) then -- some kind of ancient function?
						iPlot:SetOwner(-1)
					elseif iPlot:GetImprovementType() == -1 then
						table.insert(g_CityPlotsAcquired[cindex], iPlot)
					end
				end
			end
		end
	end
	roulette = Shuffle(roulette)
	for a, b in pairs(roulette) do
		local iCity = Map.GetPlotByIndex(b):GetPlotCity();
		local cPlot = iCity:GetNextBuyablePlot();
		if cPlot then
			local lDis = Map.PlotDistance(iCity:GetX(), iCity:GetY(), cPlot:GetX(), cPlot:GetY());
			if (lDis < 3) or IsPlayerAdjacentToPlot(cPlot, iCity:GetOwner()) then
				cPlot:SetOwner(iCity:GetOwner(), iCity:GetID())
				iCity:ChangeJONSCultureLevel(1)
				if cPlot:GetImprovementType() == -1 then
					if lDis < 4 then
						table.insert(g_CityPlotsAcquired[b], cPlot)
					end
				end
			end
		end
	end
	for iPlayer, g in pairs(gT.Players) do
		local iTeam = Players[iPlayer]:GetTeam();
		for iCity in Players[iPlayer]:Cities() do
			local cindex = iCity:Plot():GetPlotIndex()
			local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
			local pop = gT.Cities[cID].StartPopulation;
			local cPlots = {}
			local nImpro = LastRandom(math.max(0, pop - 2), pop + 2);
			gT.Cities[cID].ImprovementCost = 200;
			for it, cPlot in pairs(g_CityPlotsAcquired[cindex]) do
				table.insert(cPlots,{cPlot, GetSimplePlotValueForAI(cPlot, iTeam)})
			end
			cPlots = Shuffle(cPlots)
			table.sort(cPlots, SortFunctionForGreaterInteger2)
			for it, idata in pairs(cPlots) do
				if it <= nImpro then
					gT.Cities[cID].ImprovementCost = math.min(1000, gT.Cities[cID].ImprovementCost + 200)
					MakeAnyValidImprovement(idata[1], true, nil, nil, true)
				end
			end
		end
	end
	g_CityPlotsAcquired = nil;
end

function DoInitialPlotsOfCity(iPlayer, iCity) -- old function, still used (but for innovation)
	local exPlotPerPlot = GetDBCulturePlayerInfo(iPlayer, "ExtraPlotsPerPop") / 100;
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local cPlots = {}
	local pop = gT.Cities[cID].StartPopulation;
	local ptc = math.max(0, pop * (1 + exPlotPerPlot) - LastRandom(0,2))
	if iCity:IsCapital() then
		ptc = ptc + 2;
	end
	for i = 1, ptc do
		local cPlot = iCity:GetNextBuyablePlot();
		if cPlot then
		--	if IsValidPlotForCityToClaim(cPlot) then
			cPlot:SetOwner(iPlayer, iCity:GetID())
			iCity:ChangeJONSCultureLevel(1)
			if cPlot:GetImprovementType() == -1 then
				if Map.PlotDistance(iCity:GetX(), iCity:GetY(), cPlot:GetX(), cPlot:GetY()) < 4 then
					table.insert(cPlots, cPlot)
				end
			end
		end
	end
	for i = 0, 5 do
		local iPlot = Map.PlotDirection(iCity:GetX(), iCity:GetY(), i);
		if iPlot then
			if not IsValidPlotForCityToClaim(iPlot, iPlayer) then
				iPlot:SetOwner(-1)
			elseif iPlot:GetImprovementType() == -1 then
				table.insert(cPlots, iPlot)
			end
		end
	end
	local nImpro = LastRandom(math.max(0, pop - 2), pop + 2);
	gT.Cities[cID].ImprovementCost = 200;
	local iTeam = Players[iPlayer]:GetTeam();
	for it, cPlot in pairs(cPlots) do
		cPlots[it] = {cPlot, GetSimplePlotValueForAI(cPlot, iTeam)}
	end
	cPlots = Shuffle(cPlots)
	table.sort(cPlots, SortFunctionForGreaterInteger2)
	for it, idata in pairs(cPlots) do
		if it <= nImpro then
			gT.Cities[cID].ImprovementCost = math.min(1000, gT.Cities[cID].ImprovementCost + 200)
			MakeAnyValidImprovement(idata[1], true)
		end
	end
end

function GetInitRoadType(iPlayer)
	if DBScenario.RailroadInitChance >= LastRandom(1, 100) then
		return rRailroad;
	end
	return rRoad;
end

function MakeTheRoadsForPlayer(iPlayer)
	local nmCities = Players[iPlayer]:GetNumCities() - 1;
	for i = 1, nmCities do
		if LastRandom(1, 10) > DBScenario.RoadInitChance then
			nmCities = nmCities - 1;
		end
	end
	if nmCities <= 0 then
		return;
	end
	local iTeam = Players[iPlayer]:GetTeam();
	local tabH = {}
	for iCity in Players[iPlayer]:Cities() do
		table.insert(tabH, iCity)
	end
	tabH = Shuffle(tabH);
	for i, iCity in pairs(tabH) do
		local iPlot = iCity:Plot();
		local contID = GetContID(iPlot, 6346346);
		local getroadTabRev;
		local getroadTab;
		for j, jCity in pairs(tabH) do
			if j > i then
				local jPlot = jCity:Plot();
				if contID == GetContID(jPlot, 634213634) then
					if not getroadTabRev then
						getroadTabRev = RoadConnections(iPlot, nil)
						getroadTab = {}
						for iplot, sth in pairs(getroadTabRev) do
							table.insert(getroadTab, Map.GetPlotByIndex(iplot))
						end
					end
					if (not getroadTabRev[jPlot:GetPlotIndex()]) then
						local nTab = GenerateShortestPath(getroadTab, RoadConnections(jPlot, nil), false, 15, nil, nil, nil, nil, nil, nil, iPlayer, true)
						local getInitialRoadType = GetInitRoadType(iPlayer)
						if nTab then
							for dhi, rPlot in pairs(nTab) do
								if (not rPlot:IsCity()) then
									if rPlot:GetRouteType() == -1 then
										rPlot:SetRouteType(getInitialRoadType)
									end
									RevealNowPlot(rPlot, iTeam, iPlayer)
									local mk = LastRandom(-1, 5);
									for jk = 0, mk do
										local iPlot = Map.PlotDirection(rPlot:GetX(), rPlot:GetY(), LastRandom(0,5));
										if iPlot then
											RevealNowPlot(iPlot, Players[iPlayer]:GetTeam(), iPlayer)
										end
									end
								end
							end
							nmCities = nmCities- 1;
							if nmCities <= 0 then
								return;
							end
						end	
					end
				end
			end
		end
	end
end

function RoadConnections(sPlot, iPlayer) -- bNearby is no used, and removed
	rConnectionGlobalT = {}
	MakeTheRoadFind(sPlot, iPlayer)
	return rConnectionGlobalT;
end

function MakeTheRoadFind(sPlot, iPlayer)
	rConnectionGlobalT[sPlot:GetPlotIndex()] = 1;
	for j = 0, 5 do
		local jPlot = Map.PlotDirection(sPlot:GetX(), sPlot:GetY(), j);
		if jPlot then
			if jPlot:GetRouteType() ~= -1 then -- edited from equal to road
				if (not iPlayer) or (jPlot:GetOwner() == -1) or (jPlot:GetOwner() == iPlayer) then	
					if not rConnectionGlobalT[jPlot:GetPlotIndex()] then
						MakeTheRoadFind(jPlot, iPlayer)
					end
				end
			end
		end
	end
end

function GenerateCity(iPlayer, iPlot, hText)
	if Players[iPlayer]:IsBarbarian() then
		print("Barbarian tried to found city.", hText)
		return;
	end
	local bTricky = (iPlayer == Game.GetActivePlayer()) and Players[iPlayer]:IsTurnActive() and gT.Globals.GameGenerated 
	if bTricky then
		LuaEvents.ITGTurnOffTopPanel(true, true)
	end
	Players[iPlayer]:Found(iPlot:GetX(), iPlot:GetY())
	if bTricky then
		LuaEvents.ITGTurnOffTopPanel(false)
	end
end

local revATabI = {}
local revCAA = 0;
local revTabAllDone = {}
function AssignTheVision()
	if gT.Globals.ScenarioType == 4 then
		DoLightOfHopeVisionStuff()
		return;
	elseif gT.Globals.ScenarioType == 5 then
		DoSleepOfReasonVisionStuff()
		return;
	end
	for i, data in pairs(gT.Players) do
		local toMeetPlots = {}
		toMeetPlots[Map.GetPlotByIndex(Players[i]:GetStartingPlot())] = 1;
		local iTeam = Players[i]:GetTeam();
		local nFractal = LastRandom(5,13);
		local posSP = {Map.GetPlotByIndex(gT.Players[i].StartingPlot)}
		for iCity in Players[i]:Cities() do
			table.insert(posSP, iCity:Plot())
			toMeetPlots[iCity:Plot()] = 1;
		end
		for j = 1, nFractal do
			local sPlot = posSP[LastRandom(1, #posSP)];
			tempFrac = {}
			fracPower = LastRandom(6,16);
			BoomTheFractal(sPlot)
			ReleaseAFractal(tempFrac, iTeam, i)
		end
--		for iPlotIndex, stuff in pairs(data.ExtraFractals) do
--			CreateAFractalVision(iPlotIndex, stuff, iTeam, i)
--			toMeetPlots[Map.GetPlotByIndex(iPlotIndex)] = 1;
--		end
--		DoGreatMeeting(i, toMeetPlots)
		for b = 0, Map:GetNumPlots() - 1, 1 do
			local fPlot = Map.GetPlotByIndex( b );
			if not fPlot:IsRevealed(iTeam) then
				if IsSurroundedByVisible(fPlot, iTeam) then
					RevealNowPlot(fPlot, iTeam, i)	
				end
			end
		end
	-- 1. do get tabs of visible; connect the closest; recalculate?
		revATabI = {}
		revCAA = 0;
		revTabAllDone = {}
		for ki = 0, Map:GetNumPlots() - 1, 1 do
			local fPlot = Map.GetPlotByIndex( ki );
			if not revTabAllDone[fPlot] then
				if fPlot:IsRevealed(iTeam) then
					revCAA = revCAA + 1;
					revATabI[revCAA] = {}
					VisibleITPArea(fPlot, revCAA, iTeam)
				end
			end
		end
		if revCAA > 1 then
			local gSizeTab = {}
			for ki = 1, revCAA do
				gSizeTab[ki] = GetTableSizeInteger(revATabI[ki], "Vision Area")
			end
			local pairsToConnect = {}
			for ki = 1, revCAA - 1 do
				if gSizeTab[ki] > 1 then
					for kj = ki + 1, revCAA do
						if gSizeTab[kj] > 1 then
							local dis, plotA, plotB = GetDataForAreaVisionPathing(ki, kj)
							table.insert(pairsToConnect, {ki, kj, dis, plotA, plotB})
						end
					end
				end
			end
			if #pairsToConnect > 0 then
				local gConnected = {}
				gConnected[pairsToConnect[1][1]] = 1;
				for hi, hsth in pairs(pairsToConnect) do
					if ((not gConnected[hsth[1]]) and gConnected[hsth[2]]) or ((not gConnected[hsth[2]]) and gConnected[hsth[1]]) then
						local rTab = GenerateShortestPath({hsth[4]}, {[hsth[5]:GetPlotIndex()] = 1}, nil, 35, nil, true, nil, nil, nil, nil)	
						if rTab then
							gConnected[hsth[1]] = 1;
							gConnected[hsth[2]] = 1;
							for j, jplot in pairs(rTab) do
								RevealNowPlot(jplot, iTeam, i)
								for h = 0, 5 do
									local hPlot = Map.PlotDirection(jplot:GetX(), jplot:GetY(), h)
									if hPlot then
										RevealNowPlot(hPlot, iTeam, i)
										for hh = 0, 2 do
											if LastRandom(1,4) == 3 then
												local hhPlot = Map.PlotDirection(hPlot:GetX(), hPlot:GetY(), (h -1 + hh) % 6)
												if hhPlot then
													RevealNowPlot(hhPlot, iTeam, i)
												end
											end
										end
									end
								end
							end
						end
					end
				end
			end
		end
	end
	tempFrac = nil;
	if gT.Globals.ScenarioType == 1 then
		DoNewWorldVisionStuff()
	end
end

function GetDataForAreaVisionPathing(ki, kj)
	local mindis, aPlot, bPlot = 9999, nil, nil;
	for iPlot, sth in pairs(revATabI[ki]) do
		local iX, iY = iPlot:GetX(), iPlot:GetY();
		for jPlot, jth in pairs(revATabI[kj]) do
			local dis = Map.PlotDistance(iX, iY, jPlot:GetX(), jPlot:GetY());
			if dis < mindis then
				mindis = dis;
				aPlot = iPlot;
				bPlot = jPlot;
			end
		end
	end
	return mindis, aPlot, bPlot;
end

function VisibleITPArea(fPlot, aIndex, iTeam)
	revTabAllDone[fPlot] = 1;
	revATabI[aIndex][fPlot] = 1;
	for ki = 0, 5 do
		local iPlot = Map.PlotDirection(fPlot:GetX(), fPlot:GetY(), ki);
		if iPlot and (not revTabAllDone[iPlot]) and (iPlot:IsRevealed(iTeam)) then
			VisibleITPArea(iPlot, aIndex, iTeam)	
		end
	end
end

function ReleaseAFractal(tempFrac, iTeam, i)
	for dPlot, k in pairs(tempFrac) do
		RevealNowPlot(dPlot, iTeam, i)
		for ki = 0, 5 do
			local iPlot = Map.PlotDirection(dPlot:GetX(), dPlot:GetY(), ki);
			if iPlot then
				RevealNowPlot(iPlot, iTeam, i)	
			end
		end
	end
end

function IsSurroundedByVisible(dPlot, iTeam)
	for j = 0, 5 do
		local iPlot = Map.PlotDirection(dPlot:GetX(), dPlot:GetY(), j);
		if iPlot then
			if not iPlot:IsRevealed(iTeam) then
				return false;
			end
		else
			return false;	
		end
	end
	return true;
end

function BoomTheFractal(sPlot)
	tempFrac[sPlot] = 1;
	local jInt = Shuffle({0,1,2,3,4,5})
	for i, dir in pairs(jInt) do
		local iPlot = Map.PlotDirection(sPlot:GetX(), sPlot:GetY(), dir);
		if iPlot then
			if not tempFrac[iPlot] then
				if fracPower > 0 then
					fracPower = fracPower - 1;
					BoomTheFractal(iPlot)
				end
			end
		end
	end
end

function MeetThePlayers()
	for i, data in pairs(gT.Players) do
		if not Players[i]:IsMinorCiv() then
			local iTeam = Players[i]:GetTeam()
			--make it more nice; continents, culture;
			local supposeMeet = LastRandom(1, GetTableSizeInteger(gT.Players) - i -1) - Teams[iTeam]:GetHasMetCivCount(true);
			if supposeMeet > 0 then
				local hTeamTable = {}
				for j, gdata in pairs(gT.Players) do
					if j > i then
						if not Teams[Players[j]:GetTeam()]:IsHasMet(iTeam) then
							table.insert(hTeamTable, j)
						end
					end
				end
				hTeamTable = Shuffle(hTeamTable)
				for ki = 1, supposeMeet do
					if hTeamTable[ki] then
						if LastRandom(1,4) < 4 then
							MeetProperly(i, hTeamTable[ki])
						end
					end
				end
			end
		end
	end
end

function GetTableOfErasFull(eraType)
	local tTab = {}
	for row in GameInfo.Eras() do
		if row.ID < eraType then
			tTab[row.Type] = row.ID;
		end
	end
	return tTab;
end

function AssignTechnologies()
	local GetErasFull = GetTableOfErasFull(GameInfo.Eras[DBScenario.StartingEra].ID)
	for i, data in pairs(gT.Players) do
		local cType = data.CultureType;
		local cTeam = Players[i]:GetTeam();
		local MaybeLater = {}
		local totOpt = 0;
		local acqOpt = 0;
		local tMustHaveTechs, tOptionalTech = GetPlayerInitTechData(i)
		for row in GameInfo.Technologies() do
			if row.Show and (not row.IsInnovation) then
				if (row.Era and GetErasFull[row.Era]) or tMustHaveTechs[row.ID] then
					Teams[cTeam]:SetHasTech(row.ID, true, nil, nil, false)
					gT.Globals.TechFirstTeams[row.ID] = -1;
				elseif tOptionalTech[row.ID] then
					totOpt = totOpt + 1;
					if (LastRandom(1, 100) <= tOptionalTech[row.ID])  then
						if HasAllNeededPrereqs(i, Teams[cTeam], row.Type) then
							acqOpt = acqOpt + 1;
							Teams[cTeam]:SetHasTech(row.ID, true, nil, nil, false)
							gT.Globals.TechFirstTeams[row.ID] = -1;
						else
							table.insert(MaybeLater, {row.ID, row.Type})
						end
					end
				end
			end
		end
		for a, tech in pairs(MaybeLater) do
			if HasAllNeededPrereqs(i, Teams[cTeam], tech[2]) then
				acqOpt = acqOpt + 1;
				Teams[cTeam]:SetHasTech(tech[1], true, nil, nil, false)
				gT.Globals.TechFirstTeams[tech[1]] = -1;
			end
		end
		if not Players[i]:IsMinorCiv() then
			local minSc = GetDBCulturePlayerInfo(i, "MinScienceStartCost")
			local maxSc = GetDBCulturePlayerInfo(i, "MaxScienceStartCost")
			if totOpt == 0 then
				gT.Players[i].ScienceBonusAdopted = LastRandom(minSc, maxSc);
			else
				local hv = (acqOpt / totOpt) * (maxSc - minSc);
				gT.Players[i].ScienceBonusAdopted  = minSc + LastRandom(math.floor(hv), math.ceil(hv))
			end
		end
	end
	ClearInitTechData()
end

function MeetProperly(iPlayer, jPlayer)
	Teams[Players[iPlayer]:GetTeam()]:Meet(Players[jPlayer]:GetTeam());
end


function AddFreeBuildings(iCity, iPlayer)
	for it, buildingclass in pairs(GetFreeBuildingClassesOnCityFound(iPlayer)) do
		local buildingType = Players[iPlayer]:GetPlayerUniqueBuilding(buildingclass);
		if iCity:CanConstruct(buildingType, 1, 1) then
			iCity:SetNumFreeBuilding(buildingType, 1)
		end
	end
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_NW_TROPICAL_1, "vokrokoe") then
		local cCity = Players[iPlayer]:GetCapitalCity();
		if cCity:GetID() ~= iCity:GetID() then
			DoAddBuildingsOfCapital(iCity, cCity, iPlayer)
		end
	end
end

function AssignStartingBuildigns(iCity, CultureType, citypop, iPlayer)
	for it, buildingclass in pairs(GetFreeBuildingClassesOnCityFound(iPlayer)) do
		local buildingType = Players[iPlayer]:GetPlayerUniqueBuilding(buildingclass);
		if iCity:CanConstruct(buildingType, 1, 1) then
			iCity:SetNumFreeBuilding(buildingType, 1)
		end
	end
	local bBuildingBless = (HasBuildingBless(iPlayer) ~= nil)
	local hTab = GetOptionalBuildingClassesOnCityFound(iPlayer)
	hTab = Shuffle(hTab);
	for it, data in pairs(hTab) do
		if LastRandom(1,data[2]) <= citypop or (bBuildingBless and (LastRandom(1,data[2]) <= citypop)) then
			if data[3] >= LastRandom(1,100) or (bBuildingBless and (data[3] >= LastRandom(1,100))) then
				local buildingType = Players[iPlayer]:GetPlayerUniqueBuilding(data[1]);
				if iCity:CanConstruct(buildingType, 1, 1) then
					iCity:SetNumRealBuilding(buildingType, 1)
				end
			end
		end
	end
end

function MajorPlayerTryInitConquer(iPlayer)
	local options = {};
	local hConquerDis = GetInitConquerDistance(iPlayer);
	for g, h in pairs(gT.Players) do
		if g ~= iPlayer then
			if (Players[g]:IsMinorCiv() and (maxMinorConquest > 0)) or ((h.NumStartingCities or 1000) < Players[g]:GetNumCities()) then
				for iCity in Players[g]:Cities() do
					if GetClosestCityDistanceToXY(iPlayer, iCity:GetX(), iCity:GetY()) <= hConquerDis then
						table.insert(options, iCity:Plot():GetPlotIndex())
					end
				end
			end
		end
	end
	if #options > 0 then
		local iCity = Map.GetPlotByIndex(RandomFromTab(options)):GetPlotCity();
		if Players[iCity:GetOwner()]:IsMinorCiv() then
			maxMinorConquest = maxMinorConquest - 1;
		end
		print("Player init conquering city", iPlayer, iCity:GetName());
		Players[iPlayer]:AcquireCity(iCity, false, false)
		return true;
	end
	return false
end

function PlayerTryInitBeConquered(iPlayer)
	local options = {};
	local bCityState = Players[iPlayer]:IsMinorCiv();
	local conquerors = {};
	for g, h in pairs(gT.Players) do
		if g ~= iPlayer then
			if bCityState or Players[g]:IsMinorCiv() or (h.NumStartingCities > Players[g]:GetNumCities()) then
				table.insert(conquerors, g);
			end
		end
	end
	for iCity in Players[iPlayer]:Cities() do
		local cIndex = iCity:Plot():GetPlotIndex();
		for i, player in pairs(conquerors) do
			if GetClosestCityDistanceToXY(player, iCity:GetX(), iCity:GetY()) <= GetInitConquerDistance(player) then
				table.insert(options, {player, cIndex})
			end	
		end
	end
	if #options > 0 then
		local lOption = RandomFromTab(options);
		local iCity = Map.GetPlotByIndex(lOption[2]):GetPlotCity();
		print("Player init conquered", iPlayer, lOption[1], iCity:GetName());
		Players[lOption[1]]:AcquireCity(iCity, false, false)
		return true;
	end
	return false;
end

function LittleConquer(minor, major)
	local totCities = 0;
	for g, h in pairs(gT.Players) do
		totCities = totCities + Players[g]:GetNumCities();
	end
	maxMinorConquest = math.min(3, math.floor(0.3 * #minor));
	local minConquer = math.min(3, math.ceil(totCities / 20));
	local maxConquer = math.min(8, math.ceil(totCities / 15));
	local priorityTab = {}
	for i, iPlayer in pairs(major) do
		for j = Players[iPlayer]:GetNumCities(), gT.Players[iPlayer].NumStartingCities - 1 do
			table.insert(priorityTab, iPlayer);
		end
	end
	local aConquer = 0;
	if #priorityTab > 0 then
		priorityTab = Shuffle(priorityTab);
		for i, iPlayer in pairs(priorityTab) do
			if MajorPlayerTryInitConquer(iPlayer) then
				aConquer = aConquer + 1;
				if aConquer >= maxConquer then
					break;
				end
			end
		end
	end
	if aConquer < minConquer then
		local secConquer = {}
		for i, iPlayer in pairs(major) do
			for j = gT.Players[iPlayer].NumStartingCities, Players[iPlayer]:GetNumCities() - 1 do
				table.insert(secConquer, iPlayer);
			end
		end
		if #secConquer > 0 then
			secConquer = Shuffle(secConquer);
			for i, iPlayer in pairs(secConquer) do
				if PlayerTryInitBeConquered(iPlayer) then
					aConquer = aConquer + 1;
					if aConquer >= minConquer then
						return;
					end
				end
			end
		end
		for i, iPlayer in pairs(Shuffle(minor)) do
			if maxMinorConquest > 0 then
				if PlayerTryInitBeConquered(iPlayer) then
					maxMinorConquest = maxMinorConquest - 1;
					aConquer = aConquer + 1;
					if aConquer >= minConquer then
						return;
					end
				end
			else
				break;
			end
		end
	end
end

function GetNumberValueOfCenterArea(majPlayer, majTab, chosenCont, numcolonists)
	local iPlot = Map.GetPlotByIndex(gT.Players[majPlayer].StartingPlot);
	local hTab, val, pTab = {}, 0, {majPlayer};
	for it, player in pairs(majTab) do
		if majPlayer ~= majTab then
			local nPlot = Map.GetPlotByIndex(gT.Players[player].StartingPlot);
			local dis = Map.PlotDistance(nPlot:GetX(), nPlot:GetY(), iPlot:GetX(), iPlot:GetY());
			if chosenCont == GetContID(nPlot, 643634) then
				dis = dis * 0.8;
			end
			table.insert(hTab, {player, dis})
		end
	end
	table.sort(hTab, SortFunctionForGreaterInteger2)
	for it, data in pairs(hTab) do
		if it <= numcolonists - 1 then
			val = val + data[2];
			table.insert(pTab, data[1])
		else
			break
		end
	end
	return val, pTab;
end

function CheckIfBadContNearby(iPlot)
	if iPlot:IsWater() then
		local bNoNearby = true;
		for i = 0, 5 do
			local nPlot = Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), i);
			if nPlot and (not nPlot:IsWater()) then
				if gT.Globals.BadContIDs[GetContID(nPlot, 5293583295)] then
					return true;
				else
					bNoNearby = false;
				end
			end
		end
		return bNoNearby;
	elseif gT.Globals.BadContIDs[GetContID(iPlot, 634634)] then
		return true;
	end
	return false;
end

function AssignTheColonies()
	local selection = {}
	for i = 0, Map:GetNumPlots() - 1, 1 do
		local iPlot = Map.GetPlotByIndex(i);
		if iPlot:GetOwner() == -1 then
			if not gT.Globals.BadPoints[i] then
				if not CheckIfBadContNearby(iPlot) then
					if CanBeNewColonyBasics(iPlot) then
						table.insert(selection, i)
					end
				end
			end
		end
	end
	selection = Shuffle(selection)
	local minDistPlayers = {}
	for g, h in pairs(gT.Players) do
		minDistPlayers[g] = GetDBCulturePlayerInfo(g, "InitColonyDistance")
	end
	local dirtab = {0, 1, 2, 3, 4, 5}
	local toDoSo = math.min(#hMajorTab * 2, #selection)
	local initDoneColonies = 0;
	for i = 1, toDoSo do
		local colPos = Map.GetPlotByIndex(selection[i]);
		local validPlayers = {}
		local done;
		local rx, ry = colPos:GetX(), colPos:GetY();
		dirtab = Shuffle(dirtab) 
		for kt, j in pairs(dirtab) do
			local dirplot = Map.PlotDirection(rx, ry, j);
			if dirplot then
				local dPlayer = dirplot:GetOwner();
				if dPlayer ~= -1 then
					local iResType = colPos:GetResourceType(Players[dPlayer]:GetTeam()); 
					if iResType ~= -1 then
						if CanSeeUseResource(dPlayer, iResType)  then
							CreateColony(colPos, dPlayer, Players[dPlayer]:GetCityByID(dirplot:GetCityPurchaseID()), true)
							done = true;
							initDoneColonies = initDoneColonies + 1;
							break;
						end
					end
				end
			end 
		end
		if not done then
			for gPlayer, gData in pairs(gT.Players) do
				local iResType = colPos:GetResourceType(Players[gPlayer]:GetTeam()); 
				if iResType ~= -1 then
					if CanSeeUseResource(gPlayer, iResType)  then
						local lessDist = 99;
						local hCity;
						for iCity in Players[gPlayer]:Cities() do
							if Map.PlotDistance(iCity:GetX(), iCity:GetY(),rx, ry) < lessDist then
								lessDist = Map.PlotDistance(iCity:GetX(), iCity:GetY(),rx, ry);
								hCity = iCity;
							end
						end
						if hCity then
							--dist for colony 18
							if lessDist <= minDistPlayers[gPlayer] then
								table.insert(validPlayers, {gPlayer, hCity})
							end
						end
					end
				end
			end
			if #validPlayers > 0 then
				local luckyData = validPlayers[LastRandom(1, #validPlayers)];
				CreateColony(colPos, luckyData[1], luckyData[2], true)
				initDoneColonies = initDoneColonies + 1;
			end
		end
	end
	print("Script created initial colonies", initDoneColonies);
end

function AssignTheColoniesSpecial()
	if gT.Globals.ScenarioType == 5 then
		local sRes = rOil;
		for i = 0, Map.GetNumPlots() - 1 do
			local iPlot = Map.GetPlotByIndex(i);
			if iPlot:GetResourceType() == sRes then
				local iPlayer = iPlot:GetOwner()
				if iPlayer ~= -1 then
					if IsValidPlotForColonyPlayer(iPlayer, iPlot) then
						CreateColony(iPlot, iPlayer, nil, true, false)	
					end
				else
					local gProperMajor = GetMajorNeedingResForBalance(sRes, iPlot:GetNumResource());
					if gProperMajor then
						if IsValidPlotForColonyPlayer(gProperMajor, iPlot) then
							CreateColony(iPlot, gProperMajor, nil, true, false)	
						end
					else
						local gRminor = GetRandomMinorPlayer();
						if gRminor then
							if IsValidPlotForColonyPlayer(gRminor, iPlot) then
								CreateColony(iPlot, gRminor, nil, true, false)	
							end
						end
					end
				end
			end
		end
	elseif gT.Globals.ScenarioType == 4 then
		DecideUponColonyType()
	end
end

function GetNumWondersAssignBasedOnMajors(imajors)
	if imajors < 7 then
		return imajors;
	elseif imajors < 11 then
		return 7;
	elseif imajors < 15 then
		return 8;
	elseif imajors < 20 then
		return 9;
	end
	return 10;
end

function GetRandomGCityIndexFromPlayer(player)
	local gct = {}
	for iCity in Players[player]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		table.insert(gct, gT.Cities[cID].geIndex);
	end
	if #gct > 0 then
		return gct[LastRandom(1,#gct)];
	else
		return nil;
	end
end

function AssignTheWonders()
	local cTable = {}
	gT.Globals.WonderCTTresholds = {}
	if DBScenario.WonderCultureGroup then
		for i, cultType in pairs(ITG_ScenarioCultures[gT.Globals.ScenarioType]) do
			gT.Globals.WonderCTTresholds[cultType] = ITG_CultureData[cultType].InitWonderTreshold;
		end
	end
	local LmajTab = {}
	gT.Globals.NoMoreWonderRace = (gT.Globals.ScenarioType == 5)
	for i, data in pairs(gT.Players) do
		if not Players[i]:IsMinorCiv() then
			table.insert(LmajTab, i)
			gT.Players[i].WonderProduction = 0;
			if not gT.Globals.NoMoreWonderRace then
				gT.Players[i].CanWonderRace = 3 == LastRandom(1,5);
				if gT.Players[i].CanWonderRace then
					gT.Players[i].WonderProduction = LastRandom(0,1500) / 100;
				end
			end
			if not GetDBCulturePlayerInfo(i,"CantHaveInitWonders") then
				for iCity in Players[i]:Cities() do
					table.insert(cTable, iCity)
				end
			end
		end
	end
	for wonderID, iPlayer in pairs(gT.WondersConstructed) do
		AddEffectUponConstructing(wonderID, iPlayer, false)
	end
	local numWPossible = #GetTableOfInitialWondersOption(true);
	local numWAssign = DBScenario.WondersAmount or math.min(GetNumWondersAssignBasedOnMajors(#hMajorTab), LastRandom(math.ceil(numWPossible/2), numWPossible));
	print("We are aiming in assigning wonders", numWAssign, numWPossible)
	if gT.EraData and gT.PreviousEra then  
		local mpp = {} -- so only one unconstructed wonder per player is always done
		local tba = {}
		local wondercities = {}
		local citieswonder = {}
		local cityindexplayer = {}
		for eBuilding, player in pairs(gT.EraData[gT.PreviousEra].WondersAssigned) do
			if (not gT.EraData[gT.PreviousEra].Wonders[eBuilding]) then
				if (not mpp[player]) and (gT.EraData[gT.PreviousEra].WondersAssignedT[eBuilding]) and (gT.EraData[gT.PreviousEra].WondersAssignedT[eBuilding] >= ERA_CONV_WONDER_DESIGN_SURE_T) then
					--assigned but not built
					table.insert(tba, {player, eBuilding})
					mpp[player] = eBuilding;
				else
					--never built, less priority   -- or add randomly to existing player cities owned :)
					local geIndex = GetRandomGCityIndexFromPlayer(player)
					if geIndex then
						if not citieswonder[geIndex] then
							citieswonder[geIndex] = {}
							table.insert(wondercities, geIndex)
						end
						cityindexplayer[geIndex] = player;
						table.insert(citieswonder[geIndex], eBuilding)
					end
				end
			else
				local geIndex = gT.EraData[gT.PreviousEra].Wonders[eBuilding];
				if not citieswonder[geIndex] then
					citieswonder[geIndex] = {}
					table.insert(wondercities, geIndex)
				end
				cityindexplayer[geIndex] = player;
				table.insert(citieswonder[geIndex], eBuilding)
			end
		end
		numWAssign = numWAssign - #tba;
		if numWAssign > 0 then
			wondercities = Shuffle(wondercities)
			local todoso = numWAssign;
			local i = 0;
			while numWAssign > 0 do
				i = i + 1;
				if not wondercities[i] then
					print("Not enough wonder cities?", #wondercities, todoso, numWAssign)
					break;
				else
					local tgIndex = wondercities[i]
					local iCity = GetCityFromGEIndex(tgIndex);
					if iCity then
						local bCanAny = false;
						for tht, eWonder in pairs(citieswonder[tgIndex]) do
							if CheckIfCityCanBuildWonder(iCity, eWonder) then
								bCanAny = true;
							end
						end
						if not bCanAny then
							print("City is not valid for a wonder. Find substitute.", iCity:GetName(), #citieswonder[tgIndex])
							iCity = nil;
						end
					else
						print("City no longer exists. Find substitute.")
					end
					--if not exist
					if not iCity then 
						local tt = {}
						local tPlayer = cityindexplayer[tgIndex];
						for gCity in Players[tPlayer]:Cities() do
							local cID = gCity:Plot():GetPlotIndex() .. "," .. gCity:GetGameTurnFounded();
							local ged = gT.Cities[cID].geIndex
							if not cityindexplayer[ged] then
								for tht, eWonder in pairs(citieswonder[tgIndex]) do
									if CheckIfCityCanBuildWonder(gCity, eWonder) then
										table.insert(tt, {gCity, ged})
									end
								end
							end
						end
						if #tt > 0 then
							local lngc = LastRandom(1,#tt)
							tgIndex = tt[lngc][2];
							citieswonder[tgIndex] = {}
							gT.WondersRuins[tgIndex] = nil;
							for hhx, hhy in pairs(citieswonder[wondercities[i]]) do
								table.insert(citieswonder[tgIndex],hhy)
							end
							citieswonder[wondercities[i]] = nil;
							wondercities[i] = tgIndex;
							iCity = tt[lngc][1];
						else
							print("Can't find reserve city for wonder")
						end
					end
					if iCity then
						local wTab = {}
						for tht, eWonder in pairs(citieswonder[tgIndex]) do
							if CheckIfCityCanBuildWonder(iCity, eWonder) then
								table.insert(wTab, eWonder);
							end
						end
						if #wTab == 0 then
							print("ERROR 943534/34523234/23");
						end
						local eBuilding = wTab[LastRandom(1, #wTab)];
						iCity:SetNumRealBuilding(eBuilding, 1);
						AssignWonderToThePlayer(iCity:GetOwner(), eBuilding, -1)
						WonderAssigned(iCity, iCity:GetOwner(), eBuilding)
						numWAssign = numWAssign - 1;
						print("Assigned wonder", iCity:GetName(), Locale.Lookup(GameInfo.Buildings[eBuilding].Description))
					else
						print("Couldn't find valid city for a wonder!")
					end
				end
			end
		end
		for i, data in pairs(tba) do
			local eCity = GetBestCityForWonderInit(data[1], data[2])
			if eCity then
				eCity:SetNumRealBuilding(data[2], 1);
				AssignWonderToThePlayer(eCity:GetOwner(), data[2], -1)
				WonderAssigned(eCity, data[1], data[2])
			end
		end
		local tRtpp = {}
		for ged, sth in pairs(gT.WondersRuins) do
			if not LastChance(15) then
				tRtpp[ged] = {sth}
			end
		end
		gT.WondersRuins = {}
		for ged, data in pairs(citieswonder) do
			if not tRtpp[ged] then
				tRtpp[ged] = {}
			end
			for i, wond in pairs(data) do
				if not gT.Globals.WondersAssigned[wond] then
					table.insert(tRtpp[ged], wond)
				end
			end
		end
		DoAssignInitialRuinsOnEraConv(tRtpp)
	else
		if #cTable < numWAssign then
			print("No enough valid cities for wonders!")
			return;
		end
		for i = 1, numWAssign do
			local lKey = LastRandom(1,#cTable)
			AssignTheWonderForCity(cTable[lKey])
			table.remove(cTable, lKey)
		end
		cTable = Shuffle(cTable);
		local numRuins = DBScenario.StartingWonderRuins + LastRandom(-1, 1);
		for i = 1, numRuins do
			if cTable[i] then
				AssignTheWonderRuinsForCity(cTable[i])
			end
		end
		local numCons = math.floor(DBScenario.StartingWonderDusted * LastRandom(75, 125) / 100)
		for i = 1, numCons do
			AssignTheWonderDusted(LmajTab[LastRandom(1, #LmajTab)])
		end
	end
end

local TAIWonders;
function GetTableOfInitialWondersOption(bClear)
	if (not TAIWonders) or bClear then
		TAIWonders = {}
		local cWonderTag = DBScenario.ActiveWonderTag or "NO_WONDER";
		gT.Globals.ValidWondersForRace = {}
		for row in GameInfo.Buildings() do
			if START_WONDER_TAGS[row.WonderEra] then
				table.insert(TAIWonders, row.ID)
			end
			if cWonderTag == row.WonderEra then
				table.insert(gT.Globals.ValidWondersForRace, row.ID)
			end
		end
	end
	return TAIWonders;
end

function AssignTheWonderForCity(iCity)
	local Thewonders = Shuffle(GetTableOfInitialWondersOption());
	local iPlayer = iCity:GetOwner();
	for iT, wonderID in pairs(Thewonders) do
		if not gT.Globals.WondersAssigned[wonderID] then
			if CheckIfCityCanBuildWonder(iCity, wonderID) then
			--	gT.Globals.WondersAssigned[wonderID] = {Player = iCity:GetOwner(), PlotID = iCity:Plot():GetPlotIndex()};
				AssignWonderToThePlayer(iPlayer, wonderID, -1)
				iCity:SetNumRealBuilding(wonderID, 1);
				WonderAssigned(iCity, iCity:GetOwner(), wonderID)
				if GetDBCulturePlayerInfo(iPlayer, "OnlyOneWonder") then
					gT.Players[iPlayer].WonderProduction = 0;
					gT.Players[iPlayer].CanWonderRace = false;
					gT.Players[iPlayer].NoMoreWonderRace = false;
				end
				return;
			end
		end
	end
end

function AssignTheWonderDusted(iPlayer)
	local Thewonders = Shuffle(GetTableOfInitialWondersOption());
	for iT, wonderID in pairs(Thewonders) do
		if not gT.WondersConstructed[wonderID] then
			AssignConstructingPlayer(wonderID, iPlayer)
			local lkey = GetIDOfElement(gT.Globals.ValidWondersForRace, wonderID)
			if lkey then
				table.remove(gT.Globals.ValidWondersForRace, lkey)
			end
			return;
		end
	end
end

function AssignTheWonderRuinsForCity(iCity)
	local Thewonders = Shuffle(GetTableOfInitialWondersOption());
	local iPlayer = iCity:GetOwner();
	for iT, wonderID in pairs(Thewonders) do
		if not gT.WondersConstructed[wonderID] then
			if CheckIfCityCanBuildWonder(iCity, wonderID) then
				AssignWonderRuinsToCity(iCity, iPlayer, wonderID)
				local lkey = GetIDOfElement(gT.Globals.ValidWondersForRace, wonderID)
				if lkey then
					table.remove(gT.Globals.ValidWondersForRace, lkey)
				end
				return;
			end
		end
	end
end

function AssignUniqueImprovementsToPlayers(majTab, minorTab)
	local gTypesCult = {}
	for i, player in pairs(majTab) do
		gT.Players[player].UniqueImprovements = {}
		local gType = ITG_CultureData[gT.Players[player].CultureType].Type;
		if not gTypesCult[gType] then
			gTypesCult[gType] = {}
		end
		table.insert(gTypesCult[gType], player)
		if gT.Players[player].SubcultureType then
			local sType = ITG_SubcultureData[gT.Players[player].SubcultureType].Type;
			if not gTypesCult[sType] then
				gTypesCult[sType] = {}
			end
			table.insert(gTypesCult[sType], player)
		end
	end
	for i, player in pairs(minorTab) do
		gT.Players[player].UniqueImprovements = {}
	end
	for row in DB.Query("SELECT * FROM ITG_CultureImprovements") do
		local improID = GameInfo.Improvements[row.ImprovementType].ID;
		for i, player in pairs(gTypesCult[row.CultureType] or {}) do
			if LastChance(row.Chance) then
				gT.Players[player].UniqueImprovements[improID] = true;
			end
		end
	end
end

