local euroTinno3 = GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_EURO_3;

GameEvents.NuclearDetonation.Add(function(iPlayer, iX, iY, bDeclareWar, bBystander)
--	print("NucDet", iPlayer, iX, iY, bDeclareWar, bBystander)
	DoCEhLog("NDS", nil, "NDS", iPlayer, iX, iY, bDeclareWar, bBystander)
	gT.Players[iPlayer].LHNuclearStrikes = gT.Players[iPlayer].LHNuclearStrikes + 1;
	DoCallNukeMode(iPlayer)
	if gT.Players[iPlayer].LHNuclearStrikes < 3 then
		--nuclear glory
			TakeCareOfEventMorale(iPlayer, 25, {2, "Atomic Awe"})
	elseif LastRandom(1,3) == 2 then
		-- atomic doom
		TakeCareOfEventMorale(iPlayer, 25, {-1, "Atomic Doom"})
	end
	ChangeNumResourcesUsed(iPlayer, rUran, 1)
	local oPlayer = Map.GetPlot(iX, iY):GetOwner();
	if oPlayer ~= -1 then
		if oPlayer == iPlayer then
			-- nuking self
			TakeCareOfEventMorale(iPlayer, 25, {-1, "Nuking own Territory"})
		else
			if LastRandom(1,4) == 3 then
				-- being nuked :(
				TakeCareOfEventMorale(oPlayer, 25, {-1, "Atomic Explosion"})
			end
		end
	end
end)

GameEvents.NuclearDetonationEnded.Add(function(iPlayer, iX, iY)
	DoCEhLog("NDE", "NDS", nil, iPlayer, iX, iY)
--	print("NucDetEnded", iPlayer, iX, iY)
	DoCallNukeMode(nil)
	DoPostNuclearBuildingsDestruction(iX, iY);
	DoLogDominationEvent(5, iPlayer, nil, 30, nil, false, iX, iY)
	HnGLogNucDet(iPlayer, Map.GetPlot(iX, iY))
end)

function InitNuclearRaceByTechDiscovery()
	if gT.Globals.NuclearProjectTreshold then
		return;
	end
	gT.Globals.NuclearProjectTreshold = 200000;
	gT.Globals.NuclearProjectNextT = GetITGGameTurn() + 7;
end

function DoTurnNuclearProject(gTurn)
	if gT.Globals.NuclearProjectNextT == GetITGGameTurn() then
		local bestscore, bt = 50000, {}
		for g, h in pairs(gT.Players) do
			if not Players[g]:IsMinorCiv() then
				if not h.NuclearProjectDone then
					if h.BudgetOptions[8][2] > bestscore then
						bt = {}
						bestscore = h.BudgetOptions[8][2]
						table.insert(bt, g)
					elseif h.BudgetOptions[8][2] == bestscore then
						table.insert(bt, g)
					end
				end
			end
		end
		for p, h in pairs(bt) do
			PlayerFinishedNuclearProject(h, false)
		end
		gT.Globals.NuclearProjectTreshold = math.max(100000, gT.Globals.NuclearProjectTreshold - 20000)
		gT.Globals.NuclearProjectNextT = gT.Globals.NuclearProjectNextT + 8;
	end
	if DBScenario.GoldBudgetOnly and (not gT.Globals.PolioDone) then
		local totalContr = GetTotalPolioProgress();
		if totalContr > 1000000 then
			gT.Globals.PolioContributers = {}
			local maxOne = 1;
			for g, h in pairs(gT.Players) do
				if not Players[g]:IsMinorCiv() then
					if h.BudgetOptions[14][2] >= 100 then
						maxOne = math.max(h.BudgetOptions[14][2], maxOne);
						gT.Globals.PolioContributers[g] = h.BudgetOptions[14][2];
					end
					if h.BudgetOptions[14][1] ~= 0 then
						DoChangePlayerBudgetValue(g, 14, -gT.Players[g].BudgetOptions[14][1])
					end
				end
			end
			gT.Globals.PolioDone = GetITGGameTurn();
			for g, c in pairs(gT.Globals.PolioContributers) do
				local hap = math.floor(c / 20000);
				local merit = math.floor(c / 15000);
				if hap > 0 then
					DistributeRandomlyHappiness(g, hap)
				end
				if merit > 0 then
					ChangeMeritocracy(g, merit)
				end
				local prestige = 10 * math.floor(c / 10000);
				if prestige > 0 then
					for index, data in pairs(gT.Academies) do
						if data.Player == g then
							if IsAcademyActiveRightNow(index) then
								AddPrestigeToAcademy(index, prestige, "Polio Vaccine")
							end
						end
					end
				end
				if maxOne == c then
				--free scientists
					GenerateNewCivilianGP(g, false, GetITGGameTurn(), {Type = 3})
					GenerateNewCivilianGP(g, false, GetITGGameTurn(), {Type = 3})
				end
				if Players[g]:IsHuman() then
					local str = "We have contributed " .. math.floor(c/100) .. " [ICON_GOLD] in developing Polio Vaccine, which now provides +4 [ICON_ITG_HEALTH_1] Health in all Cities globally."
					if maxOne == c then
						str = str .. "[NEWLINE][ICON_BULLET]We were leading the development! (2 free Scientists)"
						LuaEvents.ITG_AchievementCompleted(45)
					end
					if hap > 0 then
						str = str .. "[NEWLINE][ICON_BULLET]Citizens are happy with our input. (+" .. hap .. " [ICON_HAPPINESS_1] Happiness distributed randomly)"
					end
					if merit > 0 then
						str = str .. "[NEWLINE][ICON_BULLET]Our society is motivated to work for a common good. (+" .. merit .. " [ICON_ITG_MERITOCRACY] Meritocracy)"
					end
					if prestige > 0 then
						str = str .. "[NEWLINE][ICON_BULLET]The scientific community appreciate our help. (+" .. prestige .. " [ICON_ITG_ACADEMY_1] Prestige in all active Academies)"
					end
					Players[g]:AddNotification(563469232, str, "Polio Vaccine", -1, -1, 3, -1)
				end
			end
			for i, human in pairs(gT.Globals.HumanPlayers) do
				if not gT.Globals.PolioContributers[human] then
					--notify other human players;
					Players[human]:AddNotification(563469232, "United effort of scientists across the globe resulted in creation of Polio Vaccine! +4 [ICON_ITG_HEALTH_1] Health in all Cities.", "Polio Vaccine", -1, -1, 3, -1)
				end
			end
		end
	end
end

function GetTotalPolioProgress()
	local totalContr = 0;
	for g, h in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			totalContr = totalContr + h.BudgetOptions[14][2]
		end
	end
	return totalContr;
end

function DoChangeNuclearContribution(iPlayer, iChange)
	if not gT.Players[iPlayer].NuclearProjectDone then
		gT.Players[iPlayer].BudgetOptions[8][2] = gT.Players[iPlayer].BudgetOptions[8][2] + iChange;
		BudgetOnTurnFunc8(iPlayer, 8)
	end
end

function DoChangeSpaceflightContribution(iPlayer, iChange)
	if not gT.Players[iPlayer].SpaceFlightDone then
		gT.Players[iPlayer].BudgetOptions[9][2] = gT.Players[iPlayer].BudgetOptions[9][2] + iChange;
		BudgetOnTurnFunc9(iPlayer, 9)
	end
end


function PlayerFinishedNuclearProject(iPlayer, bTreshold)
	Teams[Players[iPlayer]:GetTeam()]:ChangeProjectCount(GameInfoTypes.PROJECT_MANHATTAN_PROJECT, 1)
	gT.Players[iPlayer].NuclearProjectDone = true;
	gT.Players[iPlayer].LHNuclearTurn = GetITGGameTurn();
	if gT.Players[iPlayer].BudgetOptions[8][1] ~= 0 then
		DoChangePlayerBudgetValue(iPlayer, 8, -gT.Players[iPlayer].BudgetOptions[8][1])
	end
	if Players[iPlayer]:GetNumCities() > 0 then
		SimpleGenerateUnitOfType(iPlayer, GameInfoTypes.UNIT_ITG_ATOMIC_BOMB)
	end
	local bFirst = (not gT.Globals.NuclearPt) or (gT.Globals.NuclearPt == GetITGGameTurn())
	if bFirst then
		gT.Globals.NuclearPt = GetITGGameTurn()
	end
	VictoryTaskCompletion(iPlayer, 15, bFirst)
	DoLogDominationEvent(6, iPlayer, nil, 150)
	if Players[iPlayer]:IsHuman() then
		LuaEvents.ITG_AchievementCompleted(33)
	end
end

function DoAISatellites(iPlayer)
	if #gT.Players[iPlayer].Satellites > 0 then
		if LastRandom(1, 4) == 3 then
 			local nPlot = GetNiceAITargetForShinobiVision(iPlayer)
			if nPlot then
				local cSat = LastRandom(1, #gT.Players[iPlayer].Satellites);
				gT.Players[iPlayer].Satellites[cSat].PlannedMove = nPlot:GetPlotIndex();
			end
		end
	end
end

function IsWithinRangeOfSatellites(plot, iPlayer, range)
	for a, b in pairs(gT.Players[iPlayer].Satellites) do
		if b.Pos then
			local bPlot = Map.GetPlotByIndex(b.Pos);
			if Map.PlotDistance(plot:GetX(), plot:GetY(), bPlot:GetX(), bPlot:GetY()) <= range then
				return true;
			end
		end
	end
	return false;
end

function HumanRepositionSatellite(iPlayer, pPlot)
	gT.Players[iPlayer].Satellites[gT.Players[iPlayer].SatSelected or 1].PlannedMove = pPlot:GetPlotIndex();
end

LuaEvents.ITG_HumanRearrangesSatelliteSelection.Add(function()
	local iPlayer = Game.GetActivePlayer();
	if #gT.Players[iPlayer].Satellites > 1 then
		gT.Players[iPlayer].SatSelected = math.max(1, ((gT.Players[iPlayer].SatSelected or 1) + 1) % (#gT.Players[iPlayer].Satellites + 1))
		local plot = Map.GetPlotByIndex(gT.Players[iPlayer].Satellites[gT.Players[iPlayer].SatSelected].Pos)
		local hex = ToHexFromGrid(Vector2(plot:GetX(),plot:GetY()));
		Events.GameplayFX(hex.x, hex.y, -1)
		UI.LookAt(plot)
	end
end)

function IsValidPlotForSatellite(iPlayer, iPlotIndex)
	for i, b in pairs(gT.Players[iPlayer].Satellites) do
		if b.Pos == iPlotIndex then
			return false;
		end
	end
	return true;
end

function DoCreateNewSatellite(iPlayer)
	local iPos;
	for i = 1, 1000 do
		local iPlotIndex = LastRandom(0, Map.GetNumPlots() - 1)
		if IsValidPlotForSatellite(iPlayer, iPlotIndex) then
			iPos = iPlotIndex;
			break;
		end
	end
	if not iPos then
		print("Error 95324235")
		return;
	end
	table.insert(gT.Players[iPlayer].Satellites, {Name = GenerateFancyNameForSatellite(), Visibility = {}})
	MoveSatelliteToPosition(iPlayer, #gT.Players[iPlayer].Satellites, iPos, true);
	if Game.GetActivePlayer() == iPlayer then
		RefreshAllDirtyPlayer()
	end
end

function EndTurnMoveSatellites()
	for g, h in pairs(gT.Players) do
		for a, t in pairs(h.Satellites) do
			if t.PlannedMove then
				if IsValidPlotForSatellite(g, t.PlannedMove) then
					MoveSatelliteToPosition(g, a, t.PlannedMove)
				else
					gT.Players[g].Satellites[a].PlannedMove = nil;
				end
			end
		end
	end
end

function MoveSatelliteToPosition(iPlayer, iSat, iPos, bInitial)
	local iTeam = Players[iPlayer]:GetTeam();
	if Players[iPlayer]:IsHuman() then
		if gT.Players[iPlayer].Satellites[iSat].Pos then
			RemoveLabelOnPlot(Map.GetPlotByIndex(gT.Players[iPlayer].Satellites[iSat].Pos), "Satellite", nil, nil, iPlayer)
		end
		LuaEvents.ITG_AchievementCompleted(90)
	end
	for i, iPlotIndex in pairs(gT.Players[iPlayer].Satellites[iSat].Visibility or {}) do
		Map.GetPlotByIndex(iPlotIndex):ChangeVisibilityCount(iTeam, -1)
	end
	gT.Players[iPlayer].Satellites[iSat].Visibility = {}
	if not iPos then
		return;
	end
	local pPlot = Map.GetPlotByIndex(iPos)
	local sTab = GetPlotsInRadiusOfPlot(pPlot, 5);
	for h, hPlot in pairs(sTab) do
		hPlot:ChangeVisibilityCount(iTeam, 1)
		table.insert(gT.Players[iPlayer].Satellites[iSat].Visibility , hPlot:GetPlotIndex());
	end
	gT.Players[iPlayer].Satellites[iSat].Pos = iPos;
	gT.Players[iPlayer].Satellites[iSat].PlannedMove = nil;
	if Players[iPlayer]:IsHuman() then
		AddSmallInfo(pPlot, nil, "Satellite", nil, nil, nil, nil, iPlayer)
	end
end

function HighlightProperPlotsSatellite(iPlayer)
	local hTab = {}
	for b = 0, Map:GetNumPlots() - 1, 1 do
		table.insert(hTab, Map.GetPlotByIndex( b ))
	end
	MapModData.ITGSG = hTab;
end

function GenerateFancyNameForSatellite()
	local tH = ""
	for j = 1, 3 do
		if tH ~= "" then
			tH = tH .. "-"
		end
		for i = LastRandom(1, 4), 5 do
			if LastRandom(1, 10) <= 7 then
				tH = tH .. string.upper(string.char(LastRandom(97,122)))
			else
				tH = tH .. LastRandom(0, 9)
			end
		end
	end
	return tH
end

local tabOfUnitsBombardiero = {
[GameInfoTypes.UNIT_ITG_BOMBER] = {66, 33, 8, 15, 3},
[GameInfoTypes.UNIT_ITG_FIGHTER_UU_4] = {33, 16, 4, 8, 1},
[GameInfoTypes.UNIT_ITG_BATTLESHIP_UU_8] = {33, 16, 4, 8, 1},
[GameInfoTypes.UNIT_ITG_BOMBER_UU_0] = {66, 33, 8, 15, 3},
[GameInfoTypes.UNIT_ITG_BOMBER_UU_1] = {66, 33, 8, 15, 3},
[GameInfoTypes.UNIT_ITG_BOMBER_UU_2] = {66, 33, 8, 15, 3},
[GameInfoTypes.UNIT_ITG_BOMBER_UU_3] = {66, 33, 8, 15, 3},
[GameInfoTypes.UNIT_ITG_BOMBER_UU_4] = {66, 33, 8, 15, 3},
[GameInfoTypes.UNIT_ITG_BOMBER_UU_5] = {66, 33, 8, 15, 3},
[GameInfoTypes.UNIT_ITG_BOMBER_UU_6] = {66, 33, 8, 15, 3},
[GameInfoTypes.UNIT_ITG_BOMBER_UU_7] = {66, 33, 8, 15, 3},
[GameInfoTypes.UNIT_ITG_BOMBER_UU_8] = {66, 33, 8, 15, 3},
[GameInfoTypes.UNIT_ITG_BOMBER_UU_9] = {66, 33, 8, 15, 3},
[GameInfoTypes.UNIT_ITG_BOMBER_UU_10] = {100, 33, 8, 15, 3},
[GameInfoTypes.UNIT_ITG_BOMBER_UU_11] = {66, 33, 8, 15, 3},
[GameInfoTypes.UNIT_ITG_BOMBER_UU_12] = {66, 33, 8, 15, 3},
[GameInfoTypes.UNIT_ITG_BOMBER_UU_13] = {66, 33, 8, 15, 3},
[GameInfoTypes.UNIT_ITG_BOMBER_UU_14] = {66, 33, 8, 15, 3},
[GameInfoTypes.UNIT_ITG_BOMBER_UU_15] = {66, 33, 8, 15, 3},
[GameInfoTypes.UNIT_ITG_GUIDED_MISSILE] = {80, 30, 8, 20, 0},
[GameInfoTypes.UNIT_ITG_CARRIER] = {25, 15, 4, 0, 3},
}

local tabOfPromsBombardiero = {
[GameInfoTypes.PROMOTION_AIR_SIEGE_1] = {20,0,0,5,1},
[GameInfoTypes.PROMOTION_AIR_SIEGE_2] = {20,0,0,5,1},
[GameInfoTypes.PROMOTION_AIR_SIEGE_3] = {20,0,0,5,1},
}

function GetUnitChanceOfBombardment(iUnit, type)
	local chance = 0;
	if tabOfUnitsBombardiero[iUnit:GetUnitType()] then
		chance = chance + tabOfUnitsBombardiero[iUnit:GetUnitType()][type]
	end
	for iProm, v in pairs(tabOfPromsBombardiero) do
		if iUnit:IsHasPromotion(iProm) then
			chance = chance + v[type];
		end
	end
	return chance;
end

function GetDefChanceAgainstBombard(iPlayer, iCity)
	local t = 100 + 100 * GetNumCityManufactoryTrait(iCity, 14);
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_RADAR, "$#t5453") then
		t = t + 100;
	end
	return t;
end

function BombardmentCityStrike(iCity, iPlayer, iUnit)
	if tabOfUnitsBombardiero[iUnit:GetUnitType()] then
		local delay = 1;
		local ciplot = iCity:Plot():GetPlotIndex();
		local cID = ciplot .. "," .. iCity:GetGameTurnFounded();
		local defChance = GetDefChanceAgainstBombard(iCity:GetOwner(), iCity)
		local hexXX, hexYY = iCity:GetX(), iCity:GetY();
		local bDisplay = (Game.GetActivePlayer() == iPlayer or Game.GetActivePlayer() == iCity:GetOwner())
		local chancemod = 1;
		if iUnit:GetUnitClassType() == GameInfoTypes.UNITCLASS_BOMBER and HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_MODERN_13, "535x35") then
			chancemod = chancemod + 0.5;
		end
		if not gT.Players[iPlayer].AchvT42[ciplot] then
			gT.Players[iPlayer].AchvT42[ciplot] = {}
		end
		if GetITGCityInteger(iCity, "CI_GP_BOMB_IMMUNE") < 1 then
			if LastRandom(1, defChance) <= GetUnitChanceOfBombardment(iUnit, 1) * chancemod then
				if not CanPreventNegativeBombardmentEffect(iCity:GetOwner(), iCity) then
					local bToDestroy = GetBuildingToDestroyInBombardment(iCity);
					if bToDestroy then
						iCity:SetNumRealBuilding(bToDestroy, 0)
						iCity:SetNumFreeBuilding(bToDestroy, 0)
						if not gT.Players[iPlayer].AchVFBombardment then
							if Players[iPlayer]:IsHuman() then
								if GameInfo.Buildings[bToDestroy].BuildingClass == "BUILDINGCLASS_PUBLIC_SCHOOL" then
									LuaEvents.ITG_AchievementCompleted(121)
								end
							end
						end
						if gT.Players[iPlayer].AchvT42[ciplot][bToDestroy] then
							if Players[iPlayer]:IsHuman() then
								LuaEvents.ITG_AchievementCompleted(42)
							end
						else
							gT.Players[iPlayer].AchvT42[ciplot][bToDestroy] = true;
						end
						gT.Cities[cID].LHBombBuildings = gT.Cities[cID].LHBombBuildings + 1;
						if bDisplay then
							delay = delay + 0.5;
							Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(hexXX, hexYY))), "[COLOR_NEGATIVE_TEXT]" .. Locale.Lookup(GameInfo.Buildings[bToDestroy].Description), delay)
						end
					end
				end
			end
		end
		if LastRandom(1, defChance) <= GetUnitChanceOfBombardment(iUnit, 2) * chancemod then
			if iCity:GetPopulation() > 1 then
				iCity:ChangePopulation(-1, true)
				gT.Cities[cID].LHBombPop = gT.Cities[cID].LHBombPop + 1;
				if iCity:GetPopulation() == 1 then
					if Players[iPlayer]:IsHuman() then
						LuaEvents.ITG_AchievementCompleted(96)
					end
				end
			else
				iCity:SetFood(0);
			end
			if bDisplay then
				delay = delay + 0.5;
				Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(hexXX, hexYY))), "-[ICON_CITIZEN]", delay)
			end
		end
		if LastRandom(1, defChance) <= GetUnitChanceOfBombardment(iUnit, 3) * chancemod then
			if gT.Cities[cID].Palace then
				if gT.Cities[cID].Palace.NumUpgrades > 0 then
					if not CanPreventNegativeBombardmentEffect(iCity:GetOwner(), iCity) then
						RemoveUpgradeFromPalace(iCity, cID, iCity:GetOwner(), GetRandomValidUpgradePalaceToRemove(cID))
						table.insert(gT.Cities[cID].PalaceLog, {GetITGGameTurn(), 7, iPlayer})
						if bDisplay then
							delay = delay + 0.5;
							Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(hexXX, hexYY))), "[COLOR_NEGATIVE_TEXT]Palace", delay)
						end
					end
				end
			end
		end
		if LastRandom(1, defChance) <= GetUnitChanceOfBombardment(iUnit, 4) * chancemod then
			ChangeITGCityInteger(iCity, "CI_TEMP_PROD", -200)
			iCity:ChangeYieldRateModifier(yProduction, -200)
			if bDisplay then
				delay = delay + 0.5;
				Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(hexXX, hexYY))), "-200%[ICON_PRODUCTION]", delay)
			end
		end
		if LastRandom(1, defChance) <= GetUnitChanceOfBombardment(iUnit, 5) * chancemod then
			local vPlots = {}
			for i = 0, 5 do
				local nPlot = Map.PlotDirection(iCity:GetX(), iCity:GetY(), i)
				if nPlot and (nPlot:GetImprovementType() ~= -1) and (not nPlot:IsImprovementPillaged()) then
					table.insert(vPlots, nPlot)
				end
			end
			if #vPlots > 0 then
				local lPlot = vPlots[LastRandom(1,#vPlots)];
				lPlot:SetImprovementPillaged(true)
				if bDisplay then
					delay = delay + 0.5;
					Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(hexXX, hexYY))), "[COLOR_NEGATIVE_TEXT]" .. Locale.Lookup(GameInfo.Improvements[lPlot:GetImprovementType()].Description), delay)
				end
			end
		end
		gT.Players[iPlayer].AchVFBombardment = true;
	end
end

function BombardmentPlotStrike(iX, iY, iPlayer, iUnit, chance)
	if chance and (LastRandom(1, 100) > chance) then
		return;
	end
	local iPlot = Map.GetPlot(iX, iY);
	if iPlot:GetOwner() ~= -1 then
		if Teams[Players[iPlayer]:GetTeam()]:IsAtWar(Players[iPlot:GetOwner()]:GetTeam()) then
			if iPlot:GetImprovementType() ~= -1 then
				if not iPlot:IsImprovementPillaged() then
					if not IsSpecialControlPlot(iPlot:GetPlotIndex()) then
						if not GameInfo.Improvements[iPlot:GetImprovementType()].Permanent then
							iPlot:SetImprovementPillaged(true);
							if Game.GetActivePlayer() == iPlayer or Game.GetActivePlayer() == iPlot:GetOwner() then
								Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(iX, iY))), "[ICON_RAZING]", 0.5)
							end
						end
					end
				end
			end
		end
	end
end

function DoHealAdjacentUnitOfDomain(iPlayer, toX, toY, dType, amount)
	local tab = {}
	for i = 0, 5 do
		local nPlot = Map.PlotDirection(toX, toY, i);
		if nPlot then
			for j = 0, nPlot:GetNumUnits() - 1 do
				local jUnit = nPlot:GetUnit(j);
				if jUnit:GetOwner() == iPlayer and jUnit:GetDomainType() == dType and (jUnit:GetDamage() > 0) then
					table.insert(tab, jUnit);
				end
			end
		end
	end
	if #tab > 0 then
		tab[LastRandom(1, #tab)]:ChangeDamage(-amount);
	end
end

GameEvents.ParadropAt.Add(function(iPlayer, unitID, fromX, fromY, toX, toY)
	local iUnit = Players[iPlayer]:GetUnitByID(unitID);
	local toPlot = Map.GetPlot(toX, toY);
	local toOwner = toPlot:GetOwner();
	if iUnit:GetUnitClassType() == GameInfoTypes.UNITCLASS_PARATROOPER then
		if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_MODERN_10, "353453") then
			local numUnitsThere = toPlot:GetNumUnits();
			if numUnitsThere < 2 then
				iUnit:SetMadeAttack(false);
				if numUnitsThere == 0 then
					print("Actually THERE CAN BE 0 units on plot after paradrop")
				end
			end
		end
	end
	gT.Players[iPlayer].ParadropTNow[toOwner] = true;
	if iUnit:GetUnitType() == GameInfoTypes.UNIT_ITG_PARATROOPER_UU_2 then
		if toOwner ~= iPlayer then
			BasicRangedStrikeAtTurnStart(iUnit, iPlayer, 1, true, 50, true, 1, true)
		end
	elseif iUnit:GetUnitType() == GameInfoTypes.UNIT_ITG_PARATROOPER_UU_4 then
		if IsEnemyPlot(toPlot, Players[iPlayer]:GetTeam()) then
			DoHealAdjacentUnitOfDomain(iPlayer, toX, toY, dLand, 15)
		end
	elseif iUnit:GetUnitType() == GameInfoTypes.UNIT_ITG_PARATROOPER_UU_5 then
		if IsEnemyPlot(toPlot, Players[iPlayer]:GetTeam()) then
			DoTrySabotageMiscPlot(iPlayer, toPlot)
		end
	end
end)

LuaEvents.RequestBombardDataForPanel.Add(function(iUnit, pCity)
	local tab = {}
	local chancemod = 1;
	if iUnit:GetUnitClassType() == GameInfoTypes.UNITCLASS_BOMBER and HasPlayerTech(iUnit:GetOwner(), GameInfoTypes.TECH_UNIQUE_ITG_MODERN_13, "535x35") then
		chancemod = chancemod + 0.5;
	end
	chancemod = chancemod * 100
	local defChance =  GetDefChanceAgainstBombard(pCity:GetOwner(), pCity)
	for i, string in pairs({"Building loss", "Population loss", "Palace loss", "Production loss"}) do	
		table.insert(tab, {string, math.floor(GetUnitChanceOfBombardment(iUnit, i) * chancemod / defChance)})
	end
	MapModData.ITGSG = tab;
end)

function CanPreventNegativeBombardmentEffect(iPlayer, iCity)
	if gT.Players[iPlayer].HasIdeology[34] then
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		if gT.Cities[cID].WorkRate >= 100 then
			MakeCitySpendWorkRate(iCity, iPlayer, 100)
			return true;
		end
	end
	return false;
end

function DisablesOpponentCrits(iUnit, dUnit, iPlayer, dPlayer, iCity, dCity, bReversed)
	local bNegated = false;
	if iUnit then
		if DoesUnitDisableCrits(iUnit) then
			bNegated = true;
		end
	end
	if gT.Players[iPlayer] then
		if gT.Players[iPlayer].HasIdeology[9] then
			if LastChance(30) then
				bNegated = true;
			end
		end
		if HasPlayerTech(iPlayer, euroTinno3, "okesd") then
			if iUnit and dUnit then
				if iUnit:GetCriticalPercent() < dUnit:GetCriticalPercent() then
					bNegated = true;
					iUnit:SetCriticalPercent(0)
				end
			end
		end
	end
	if bNegated then
		if dUnit then
			DoNegateCriticalOfUnitNow(dUnit, iPlayer)
		end
	end
	if not bReversed then
		DisablesOpponentCrits(dUnit, iUnit, dPlayer, iPlayer, dCity, iCity, true)
	end	
end

function DoNegateCriticalOfUnitNow(iUnit, iPlayer)
	if Players[iPlayer]:IsHuman() then
		if iUnit:GetCriticalPercent() >= 200 then
			LuaEvents.ITG_AchievementCompleted(114)
		end
	end
	iUnit:SetCriticalPercent(0)
end

function DoesUnitDisableCrits(iUnit)
	if iUnit:GetUnitType() == GameInfoTypes.UNIT_ITG_BATTLESHIP_UU_2 then
		return true;
	elseif iUnit:GetUnitType() == GameInfoTypes.UNIT_ITG_ANTI_TANK_GUN_UU_6 then
		return true;
	end
	if iUnit:IsHasPromotion(GameInfoTypes.PROMOTION_ITG_GREAT_ADMIRAL_35) then
		return true;
	end
	if iUnit:IsHasPromotion(GameInfoTypes.PROMOTION_GREAT_GENERAL_40) then
		return true;
	end
	if iUnit:IsHasPromotion(GameInfoTypes.PROMOTION_ITG_MERCENARY_26) then
		return true;
	end
	return false;
end

function GetNukeBuildingDestructionChance(dis)
	if dis == 0 then
		return 40;
	elseif dis == 1 then
		return 20;
	else
		return 10;
	end
end

function DoPostNuclearBuildingsDestruction(iX, iY)
	local ePlot = Map.GetPlot(iX, iY);
	for i, plot in pairs(GetPlotsInRadiusOfPlot(ePlot, 2)) do
		if plot:IsCity() then
			local iCity = plot:GetPlotCity();
			local dis = Map.PlotDistance(iX, iY, iCity:GetX(), iCity:GetY());
			local ctdbod = GetNukeBuildingDestructionChance(dis);
			for row in GameInfo.Buildings() do
				if iCity:GetNumRealBuilding(row.ID) == 1 then
					if row.Cost > 0 then
						if GameInfo.BuildingClasses[row.BuildingClass].MaxGlobalInstances == -1 then
							if GameInfo.BuildingClasses[row.BuildingClass].MaxPlayerInstances == -1 then
								if not row.HolyCity then
									if LastChance(ctdbod) then
										iCity:SetNumRealBuilding(row.ID, 0)
									end
								end
							end
						end
					end
				end
			end
		end
	end
end