--: ) : ) : ) : ) Make new way of currents - just connect two plots within reasonable distance

local tOcean = GameInfoTypes.TERRAIN_OCEAN;
local AlreadyDoneCurrents = {}
local gOceanTab = {}
local gHCurrentTab = {}
local gHCurrentPlots = {}
local gHCurrentCount = 0;

function FillWithMicroCurrentsForPercentage(oceanID, oSize, perc)
	local nummin = math.floor(oSize * perc / 100)
	local hTab = {}
	for index, sth in pairs(gOceanTab[oceanID]) do
		local iPlot = Map.GetPlotByIndex(index)
		if iPlot:GetTerrainType() == tOcean then
			if iPlot:GetCurrentDirection() == -1 then
				table.insert(hTab, iPlot)
			else
				nummin = nummin - 1;
			end
		end
	end
	hTab = Shuffle(hTab)
	for i = 1, nummin do
		if hTab[i] then
			AddMostProbablyCurrent(hTab[i])
		else
			break;
		end
	end
end

function AddMostProbablyCurrent(iPlot)
	local iChanceDir = {}
	local otherDir = {}
	for i = 0, 5 do
		local nPlot = Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), i);
		if nPlot then
			if nPlot:IsWater() then	
				local nDir = nPlot:GetCurrentDirection()
				if nDir == -1 or (Map.PlotDirection(nPlot:GetX(), nPlot:GetY(), nDir) ~= iPlot) then
					if nPlot:GetTerrainType() == tOcean then
						table.insert(otherDir, {i, 1})
					else
						table.insert(otherDir, {i, 5})
					end
					iChanceDir[nDir] = (iChanceDir[nDir] or 0) + 5;
				end
			end
		end
	end
	if (#otherDir > 0) then
		for i, data in pairs(otherDir) do
			otherDir[i] = {data[1], data[2] + (iChanceDir[data[1]] or 0)}
		end
		local ldir = GetRandomFromBiasedChanceTable(otherDir)
		iPlot:SetCurrentDirection(ldir)
	end
end

function DoMicroCurrents(oceanID)
	for index, sth in pairs(gOceanTab[oceanID]) do
		local iPlot = Map.GetPlotByIndex(index)
		if iPlot:GetTerrainType() == tOcean and (not iPlot:IsImpassable()) then
			if iPlot:GetCurrentDirection() == -1 then
				if LastRandom(1, 10) < 7 then
					local coastDir = {}
					local iChanceDir = {}
					local otherDir = {}
					for i = 0, 5 do
						local nPlot = Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), i);
						if nPlot then
							if nPlot:IsWater() then	
								local nDir = nPlot:GetCurrentDirection()
								if nDir == -1 or (Map.PlotDirection(nPlot:GetX(), nPlot:GetY(), nDir) ~= iPlot) then
									if nPlot:GetTerrainType() == tOcean then
										table.insert(otherDir, {i, 1})
									else
										table.insert(coastDir, {i, 1})
									end
									iChanceDir[nDir] = (iChanceDir[nDir] or 0) + 5;
								end
							end
						end
					end
					if #coastDir > 0 then
						for i, data in pairs(coastDir) do
							coastDir[i] = {data[1], data[2] + (iChanceDir[data[1]] or 0)}
						end
						local ldir = GetRandomFromBiasedChanceTable(coastDir)
						iPlot:SetCurrentDirection(ldir)
					elseif LastRandom(1, 5) == 1 and (#otherDir > 0) then
						for i, data in pairs(otherDir) do
							otherDir[i] = {data[1], data[2] + (iChanceDir[data[1]] or 0)}
						end
						local ldir = GetRandomFromBiasedChanceTable(otherDir)
						iPlot:SetCurrentDirection(ldir)
					end
				end
			end
		end
	end
end

function DoGenerateOceanCurrents()
	gOceanTab = RequestOceansOnly();
	for i = 0, Map:GetNumPlots() - 1, 1 do
		local fPlot = Map.GetPlotByIndex( i );
		if fPlot:GetTerrainType() == tOcean and (not fPlot:IsImpassable()) then
			local oceanID = GetJustOceanID(fPlot);
			if not AlreadyDoneCurrents[oceanID] then
				local oSize = GetSizeOfJustOceanPlot(fPlot);
				AlreadyDoneCurrents[oceanID] = 1;
				if oSize > 525 then
					GenerateCurrentBasedOnDistancePath(oceanID, oSize, 7)
					TryToGenerateLongCurrents(oceanID, oSize)
				elseif oSize > 125 then
					GenerateCurrentBasedOnDistancePath(oceanID, oSize, 3)
					TryToGenerateLongCurrents(oceanID, oSize)
				elseif oSize > 55 then
					TryToGenerateLongCurrents(oceanID, oSize)
				end
				DoMicroCurrents(oceanID)
				FillWithMicroCurrentsForPercentage(oceanID, oSize, LastRandom(21, 35))
		--		IterateCurrentTillPossible(fPlot)
			end
		end
	end
end

function IterateCurrentTillPossible(fPlot)
--not used right now
	local fChance = {}
	local PosOptions = {}
	for i = 0, 5 do
		local nPlot = Map.PlotDirection(fPlot:GetX(), fPlot:GetY(), i)
		if nPlot then
			if nPlot:IsWater() then
				local cDir = nPlot:GetCurrentDirection();
				if cDir ~= -1 then
					if Map.PlotDirection(nPlot:GetX(), nPlot:GetY(), cDir) ~= fPlot then
						fChance[cDir] = (fChance[cDir] or 0) + 18;
						table.insert(PosOptions, {i, 1})
					end
				else
					table.insert(PosOptions, {i, 1})
				end
			end
		end
	end
	if #PosOptions > 0 then
		for i, data in pairs(PosOptions) do
			PosOptions[i] = {data[1], data[2] + (fChance[data[1]] or 0)}
		end
		local ldir = GetRandomFromBiasedChanceTable(PosOptions)
		fPlot:SetCurrentDirection(ldir)
		local lPlot = Map.PlotDirection(fPlot:GetX(), fPlot:GetY(), ldir);
		if lPlot:GetTerrainType() == tOcean then
			if lPlot:GetCurrentDirection() == -1 then
				IterateCurrentTillPossible(lPlot)
			end
		end
	end
end

function GenerateCurrentBasedOnDistancePath(oceanID, oSize, many)
	for i = 1, many do
		local revTab = {}
		for index, sth in pairs(gOceanTab[oceanID]) do
			local iPlot = Map.GetPlotByIndex(index);
			if iPlot:GetCurrentDirection() == -1 then
				if iPlot:GetTerrainType() == tOcean then
					table.insert(revTab, iPlot)
				end
			end
		end
		for ddf = 1, math.max(1, oSize / 500) do
			revTab = Shuffle(revTab)
			local chosenones = {}
			for i = 1, 5 do
				table.insert(chosenones, revTab[LastRandom(1, #revTab)]);
			end
			local maxdis, gsPlot, gtPlot = 10, nil, nil;
			for i, iPlot in pairs(revTab) do
				for j, cPlot in pairs(chosenones) do
					local dis = Map.PlotDistance(iPlot:GetX(), iPlot:GetY(), cPlot:GetX(), cPlot:GetY());
					if dis > maxdis then
						maxdis = dis;
						gsPlot = cPlot;
						gtPlot = iPlot;
					end
				end
			end
			if gsPlot then
				local tTab = GenerateShortestPath({gsPlot}, {[gtPlot:GetPlotIndex()] = 1}, true, 999, nil, nil, nil, {[tOcean] = 1}, nil, true);
				if tTab then
					local pp = 0;
					for i, plot in pairs(tTab) do
						if i ~= #tTab then
							if plot:GetTerrainType() == tOcean then
								plot:SetCurrentDirection(GetDirectionFromPlotTo(plot, tTab[i+1]))
								pp = pp + 1;
							end
						end
					end
				else
					print("Seriously?")
					return
				end
			else
				return
			end
		end
	end
end

function GetDirectionFromPlotTo(plot, nplot)
	for i = 0, 5 do
		if Map.PlotDirection(plot:GetX(), plot:GetY(), i) == nplot then
			return i;
		end
	end
	return -1;
end

function TryToGenerateLongCurrents(oceanID, size)
	local revTab = {}
	for index, sth in pairs(gOceanTab[oceanID]) do
		local iPlot = Map.GetPlotByIndex(index)
		if iPlot:GetCurrentDirection() == -1 then
			if iPlot:GetTerrainType() == tOcean then
				table.insert(revTab, iPlot)
			end
		end
	end
	local bestSoFar = {}
	local bestAmount = 0;
	for i = 1, 5 do
		local lPlotStart = revTab[LastRandom(1,#revTab)];
		gHCurrentTab = {}
		gHCurrentPlots = {}
		gHCurrentCount = 0;
		IteratePossibleLongCurrent(lPlotStart)
		if bestAmount < gHCurrentCount then
			bestAmount = gHCurrentCount
			for j, k in pairs(gHCurrentTab) do
				bestSoFar[j] = k;
			end
		end
		if gHCurrentCount > 70 or gHCurrentCount > (size / 14) or i == 5 then
			for plot, dir in pairs(bestSoFar) do
				plot:SetCurrentDirection(dir)
			end
			break;
		end
	end
end

function IteratePossibleLongCurrent(fPlot)
	gHCurrentCount = gHCurrentCount + 1;
	gHCurrentPlots[fPlot] = 1;
	local fChance = {}
	local PosOptions = {}
	for i = 0, 5 do
		local nPlot = Map.PlotDirection(fPlot:GetX(), fPlot:GetY(), i)
		if nPlot then
			if nPlot:IsWater() then
				if nPlot:GetTerrainType() == tOcean and (not nPlot:IsImpassable()) then
					local cDir = nPlot:GetCurrentDirection();
					if cDir ~= -1 then
						if Map.PlotDirection(nPlot:GetX(), nPlot:GetY(), cDir) ~= fPlot then
							fChance[cDir] = (fChance[cDir] or 0) + 18;
							table.insert(PosOptions, {i, 1})
						end
					elseif gHCurrentTab[nPlot] then
						if Map.PlotDirection(nPlot:GetX(), nPlot:GetY(), gHCurrentTab[nPlot]) ~= fPlot then
							fChance[gHCurrentTab[nPlot]] = (fChance[gHCurrentTab[nPlot]] or 0) + 18;
							table.insert(PosOptions, {i, 1})
						end
					else
						table.insert(PosOptions, {i, 100})
					end
				end
			end
		end
	end
	if #PosOptions > 0 then
		for i, data in pairs(PosOptions) do
			PosOptions[i] = {data[1], data[2] + (fChance[data[1]] or 0)}
		end
		local ldir = GetRandomFromBiasedChanceTable(PosOptions)
--		fPlot:SetCurrentDirection(ldir)
		gHCurrentTab[fPlot] = ldir;
		local lPlot = Map.PlotDirection(fPlot:GetX(), fPlot:GetY(), ldir);
		if lPlot:GetCurrentDirection() == -1 and not gHCurrentPlots[lPlot] then
			IteratePossibleLongCurrent(lPlot)
		end
	end
end