local uGarrison = GameInfoTypes.UNIT_GARRISON;
local arab4tech = GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_ARAB_4;
local innoindu5 = GameInfoTypes.TECH_UNIQUE_ITG_INDUSTRIAL_5
local sot100oncc = 0;
local unitRecruitedCQ = {}
local cityDMGratio = 0.5;
local ccfdelay = 0;
local reinstallBuildingClasses = {}

--local occupiedBuilding = GameInfoTypes.BUILDING_DUMMY_OCCUPIED_CITY;

function HandleCCFloat(iPlayer, x, y, text)
	if iPlayer == Game.GetActivePlayer() then
		ccfdelay = ccfdelay + 0.5;
		Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(x, y))), text, ccfdelay)
	end
end

GameEvents.CityCaptureStart.Add(function(x, y, nPlayer, bConquest)
	if Players[nPlayer]:IsBarbarian() then
		print("Oh no, Barbarian conquered a city!", x, y, nPlayer, bConquest)
	end
	ccfdelay = 0;
	reinstallBuildingClasses = {}
	local unitRecruitedCQ = {}
	local iPlot = Map.GetPlot(x, y);
	local cityID = iPlot:GetPlotCity():GetID();
	local iPlayer = iPlot:GetOwner();
	local bLastCity = Players[iPlayer]:GetNumCities() == 1;
	local iCity = iPlot:GetPlotCity()
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	sot100oncc = iCity:GetYieldRateTimes100(yScience)
	if Players[iPlayer]:IsMinorCiv() then
		if bLastCity then
			DoEndAllPledgesOfProtectionOfMinor(iPlayer)
			if HasPlayerTech(nPlayer, GameInfoTypes.TECH_UNIQUE_ITG_MEDIEVAL_AFR_6, "Veaded") then
				for iUnit in Players[iPlayer]:Units() do
					if gT.Players[nPlayer].UnitClassXP[iUnit:GetUnitClassType()] then
						table.insert(unitRecruitedCQ, {iUnit:GetUnitType(), iUnit:GetDamage(), iUnit:GetX(), iUnit:GetY()})
					end
				end
			end
			for iUnit in Players[iPlayer]:Units() do
				iUnit:Kill(false, -1);
			end
			for fIndex, fdata in pairs(gT.Colonies) do
				if iPlayer == fdata.Player then
					ColonyTakeOver(nPlayer, iPlayer, Map.GetPlotByIndex(fIndex))
				end
			end			
			for fIndex, fdata in pairs(gT.Forts) do
				if iPlayer == fdata.Player then
					FortTakeOver(nPlayer, iPlayer, Map.GetPlotByIndex(fIndex))
				end
			end
			for fIndex, fdata in pairs(gT.HolySites) do
				if iPlayer == fdata.Player then
					HolySiteTakeOver(nPlayer, iPlayer, Map.GetPlotByIndex(fIndex), true)
				end
			end
			return;
		end
	else
		if iCity:IsCapital() then
			ChooseNextCapital(iPlayer, iCity)
		end
		if bLastCity and gT.Players[iPlayer].AISettlerPointsManagement then
			if gT.Players[iPlayer].AISettlerPointsManagement.Type ~= 1 then
				gT.Players[iPlayer].AISettlerPointsManagement = nil;
			end
		end
	end
	if gT.Globals.GameGenerated then
		CityCaptureStartAchievementCheck(iCity, iPlayer, nPlayer)
		GeneralCleanOfCitiesSpecialPoint("Forts", bLastCity, iPlayer, cityID)
		GeneralCleanOfCitiesSpecialPoint("Colonies", bLastCity, iPlayer, cityID)
		GeneralCleanOfCitiesSpecialPoint("HolySites", bLastCity, iPlayer, cityID)
		GeneralCleanOfCitiesSpecialPoint("Settlements", bLastCity, iPlayer, cityID)
		gT.Cities[cID].TotalDamage = iCity:GetMaxHitPoints() - gT.Cities[cID].LastTurnDamage + gT.Cities[cID].TotalDamage;
		if gT.Players[nPlayer] then
			if gT.Players[nPlayer].HasIdeology[25] then
				for buildingclass, insptype in pairs(gT.Players[nPlayer].Inspirations) do
					local buildingType = Players[iPlayer]:GetPlayerUniqueBuilding(buildingclass)
					if (buildingType ~= -1) and iCity:IsHasBuilding(buildingType) then
						reinstallBuildingClasses[buildingclass] = true;
					end
				end
			end
		end
	end
end)

function GeneralCleanOfCitiesSpecialPoint(type, bLastCity, iPlayer, cityID)
	local cleaned, clextra = 0, 0;
	for index, data in pairs(gT[type]) do
		if data.Player == iPlayer then
			local nPlot = Map.GetPlotByIndex(index)
			if bLastCity or (nPlot:GetCityPurchaseID() == cityID) then
				if nPlot:IsCity() then
					print("Error 92/4634/212/", type, bLastCity, iPlayer, cityID, index)
				else
					nPlot:SetOwner(-1, -1)
					cleaned = cleaned + 1;
				end
			end
			if data.AdjacentPlots then --only forts
				for it, indexplot in pairs( data.AdjacentPlots) do
					if gT.PlotFortControl[indexplot] then
						local iPlot = Map.GetPlotByIndex(indexplot);
						if iPlot:GetOwner() == data.Player then
							if bLastCity or (iPlot:GetCityPurchaseID() == cityID) then
								if iPlot:IsCity() then
									print("Error 92/4634/212/2", type, bLastCity, iPlayer, cityID, indexplot)
								else
									iPlot:SetOwner(-1, -1)
									clextra = clextra + 1;
								end
							end
						end
					end
				end
			end
		end
	end
end

function ClearCurrentModifiers(iCity, cID, iPlayer)
	--cID variables that should be adjusted upon conquest
	gT.Cities[cID].FestivalCD = nil;
	gT.Cities[cID].CultGuild = nil;
	gT.Cities[cID].ReadyToRiot = false;
	gT.Cities[cID].ModernRange21 = nil; --99% extra range will not survive oncapture
	--reinstalling GP abilities is important!!!
	if GetITGCityInteger(iCity, "CI_GP_FOOD_MOD") ~= 0 then
		iCity:ChangeYieldRateModifier(yFood, GetITGCityInteger(iCity, "CI_GP_FOOD_MOD"))
	end
	if GetITGCityInteger(iCity, "CI_GP_GOLD") ~= 0 then
		iCity:ChangeYieldRateModifier(yGold, GetITGCityInteger(iCity, "CI_GP_GOLD"))
	end
	if GetITGCityInteger(iCity, "CI_GP_STRIKE_MOD") ~= 0 then
		iCity:ChangeAttackMod(100 * GetITGCityInteger(iCity, "CI_GP_STRIKE_MOD"));
	end
	if (gT.Cities[cID].GPplotCultcost or 0) ~= 0 then
		iCity:ChangePlotCultureCostModifier(gT.Cities[cID].GPplotCultcost)
	end
	if gT.Cities[cID].ProdFromBridge then
		iCity:ChangeBaseYieldRateFromBuildings(yProduction, gT.Cities[cID].ProdFromBridge)
	end
	MakeCityMintBonuses(iCity, gT.Players[iPlayer].MintBonus)
end

function CityDirtOccupiedPenalty(iPlayer, hReason)
	local num, numgp = GetPlayerNumPenaltyFromOccupiedCity(iPlayer);
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		local val = 0;
		local valgp = 0;
		if iCity:GetOriginalOwner() ~= iPlayer then
			val = -num;
			valgp = -numgp;
		end
		iCity:ChangeBaseGreatPeopleRateModifier(valgp - GetITGCityInteger(iCity, "CI_OCCUPIED_GP_RATE"))
		SetITGCityInteger(iCity, "CI_OCCUPIED_GP_RATE", valgp)
		iCity:ChangeYieldRateModifier(yGold, val - GetITGCityInteger(iCity, "CI_OCCUPIED_GOLD_RATE"))
		SetITGCityInteger(iCity, "CI_OCCUPIED_GOLD_RATE", val)
		iCity:ChangeYieldRateModifier(yScience, val - GetITGCityInteger(iCity, "CI_OCCUPIED_SCIENCE_RATE"))
		SetITGCityInteger(iCity, "CI_OCCUPIED_SCIENCE_RATE", val)
	end
end

function GetPlayerNumPenaltyFromOccupiedCity(iPlayer)
	local base, gpbase = 20, 50;
	if gT.Players[iPlayer] then
		if gT.Players[iPlayer].Goverment == 3 then
			base = base - 10 * gT.Players[iPlayer].GovTraitMod;
			gpbase = gpbase - 25 * gT.Players[iPlayer].GovTraitMod;
		end
	end
	return base, gpbase;
end

function CityCaptureMain(jPlayer,  capital,  x,  y,  newPlayer,  iPop,  bConquest)
	local iCity = Map.GetPlot(x,y):GetPlotCity();
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	ClearCurrentModifiers(iCity, cID, newPlayer)
	DoClearFishOnConquest(cID)
	local timeConqerued = (gT.Cities[cID].NumConquered or 0) + 1;
	local iPrePop = iCity:GetPopulation();
	local bPogrom = false;
	local bAddSetPoints = false;
	local bVeryFirstConquer = false;
	local bNotableConquest = false;
	local bDiplomaticMarriage = false;
	if (not bConquest) and gT.Globals.GameGenerated then
		if gT.Players[newPlayer].DiplomaticMarriages[jPlayer] then
			bDiplomaticMarriage = true;
			timeConqerued = timeConqerued - 1;
			if iCity:GetResistanceTurns() > 1 then
				iCity:ChangeResistanceTurns(-iCity:GetResistanceTurns())
			end
		end
	end
	cityDMGratio = iCity:GetDamage() / iCity:GetMaxHitPoints();
	local numSetPoints = 0;
	iCity:SetSpreadImmune(false)
	local preconqhap = gT.Cities[cID].Happiness;
	local bCanTriggerSpammableEvents = false;
	if not bDiplomaticMarriage then
		if gT.Players[newPlayer].HasIdeology[34] then
			DoDistributeWorkRateBetweenCities(newPlayer, gT.Cities[cID].WorkRate, iCity)
		end
		gT.Cities[cID].WorkRate = 0;
		if (not gT.Cities[cID].CaptureEventsCD) or (gT.Cities[cID].CaptureEventsCD < GetITGGameTurn()) then
			bCanTriggerSpammableEvents = true
			gT.Cities[cID].CaptureEventsCD = GetITGGameTurn() + 5;
		else
			gT.Cities[cID].CaptureEventsCD = GetITGGameTurn() + 1;
		end
	end
	gT.Cities[cID].CurrencyResYield = {}
	for i, index in pairs(gT.Cities[cID].Academies) do
		local acaNowPlayer = Map.GetPlotByIndex(index):GetOwner();
		local acaOldPlayer = gT.Academies[index].Player;
		if acaOldPlayer ~= acaNowPlayer then
			DoRemoveAllKeystonesRelatedAcademy(index, acaOldPlayer)
			gT.Academies[index].Player = acaNowPlayer;
			DoAddAllKeystonesRelatedAcademy(index, acaNowPlayer)
		end
	end
	for i, index in pairs(gT.Cities[cID].CustomsHouses) do
		TriggerConquerOfCustomHouse(index)
	end
	local bHasManufactory = false;
	for i, index in pairs(gT.Cities[cID].Manufactories) do
		TriggerConquerOfManufactory(index)
		bHasManufactory = true;
	end
	if gT.Cities[cID].UniAcademyRewardActive then
		RemoveUniversityAcademyBonus(iCity, jPlayer)
	end
	UpdateProductionFromAcademies(newPlayer)
	TakeCareOfColoniesUponCityConquer()
	if Players[newPlayer]:GetNumCities() == 1 then
		gT.Players[newPlayer].TurnsToConsiderBarb = 0;
	end
	UpdateHealthInSingleCity(iCity, newPlayer)
	for wonderID, sth in pairs(gT.Globals.WondersAssigned) do
		if iCity:IsHasBuilding(wonderID) then
			WonderWasConquered(newPlayer, jPlayer, wonderID, iCity)
		end
	end
	if gT.Cities[cID].WonderRuin then
		WonderRuinWasConquered(newPlayer, jPlayer, gT.Cities[cID].WonderRuin, iCity, cID)
	end
	if gT.Globals.GameGenerated then
		gT.Cities[cID].NumConquered = timeConqerued;
--		gT.Cities[cID].LastTurnDamage = iCity:GetDamage();
		gT.Cities[cID].LastTimeDamaged = GetITGGameTurn();
		gT.Cities[cID].LastAcquired = GetITGGameTurn();
		gT.Players[jPlayer].LastTurnCityLost = GetITGGameTurn();
		if bConquest then
			if iPrePop > (gT.Cities[cID].HighestPopConquer or 0) then
				gT.Cities[cID].HighestPopConquer = iPrePop;
				gT.Cities[cID].HighestPopPlayer = newPlayer;
				gT.Cities[cID].HighestPopTurn = GetITGGameTurn();
			end
			if gT.Players[newPlayer] then
				gT.Players[newPlayer].GreatestCityPopCaptured = math.max(gT.Players[newPlayer].GreatestCityPopCaptured, iPrePop)
			end
			PeaceLockDataConquest(newPlayer, jPlayer)
			if bCanTriggerSpammableEvents then
				local popChange = math.max(-1 * LastRandom(0,2), -1 * iPrePop + 1)
				numSetPoints = numSetPoints - popChange;
				iCity:ChangePopulation(popChange, true)
				MakeCityAbandonAllHopes(iCity, newPlayer)
				CityConqueredCultureOwnership(jPlayer, newPlayer, iCity, cID)
				bNotableConquest = true; -- NOTABLE CONQUEST because was not conquered in last 5 turns
				if (bHasManufactory) then
					if DBScenario.ManufactoryPurchaseCD > 0 then
						gT.Players[jPlayer].ManuPurchaseCD = GetITGGameTurn() + DBScenario.ManufactoryPurchaseCD;
					end
				end
			end
			if iCity:GetOriginalOwner() ~= newPlayer then
				iCity:ChangeResistanceTurns(-1 * iCity:GetResistanceTurns() + LastRandom(2,4))
			else
				if gT.Cities[cID].LastRebellion >= GetRealGameTurn() - 5 and bConquest then
					DoNationalMovementOfRebels(jPlayer, newPlayer)
				end
			end
			MakeHappinessChangeOnConquer(iCity, newPlayer, jPlayer)
		else
			MakeJumpAwayFromSpecialPoint(newPlayer, iCity:Plot())
		end
		TakeCareOfGPCapture(iCity, cID, newPlayer, jPlayer, not bConquest)
		DoDirtyBudgetValues(jPlayer)
		DoGovernorMattersOnCityConquer(iCity, cID, newPlayer, jPlayer)
		DiploNoteDirty(newPlayer, 27)
	end
	EndImmediatelyFestival(iCity, cID, jPlayer, newPlayer) -- always before palace
	CityConquerPalaceMatters(iCity, cID, newPlayer, jPlayer, bConquest)

	if gT.Players[jPlayer] then
		if gT.Globals.GameGenerated then
			if not bDiplomaticMarriage then
				bAddSetPoints = true;
				CityCaptureCityStateLog(newPlayer, jPlayer)
				local total = 0;
				for row in GameInfo.Religions() do
					total = total + iCity:GetNumReligionPressure(row.ID)
				end
				local atheists = iCity:GetNumReligionPressure(-1);
				if atheists > 0 then
					total = total + atheists;
				end
				local lRel = iCity:GetReligiousMajority();
				if total > 30000 then
					local iDhDD = math.ceil(total/30000);
					for row in GameInfo.Religions() do
						if lRel ~= row.ID then
							iCity:SetNumReligionPressure(row.ID, math.ceil(iCity:GetNumReligionPressure(row.ID) / iDhDD))
						end
					end
					if -1 ~= lRel then
						iCity:SetNumReligionPressure(-1, math.ceil(iCity:GetNumReligionPressure(-1) / iDhDD))
					end
					iCity:SetNumReligionPressure(lRel, math.ceil(iCity:GetNumReligionPressure(lRel) / iDhDD))
				end
				if gT.Players[newPlayer].GovOnNextConquest then
					gT.Players[newPlayer].GovOnNextConquest = nil;
					AppointNewGovernor(newPlayer)
				end
			end
			DoUpdateCitiesGovCorruption(jPlayer)
			DoUpdateWonderAndInnovationsModifiers(iCity, cID, newPlayer)
			if capital then
				if not Players[jPlayer]:IsMinorCiv() then
					DoTriggerAnarchyChance(jPlayer, "Conquest")
				end
			end
		end
		if not HasMintAnyCity(jPlayer) then
			PlayerMayJustLooseAMint(jPlayer)
		end
		CheckBonusForOracle(jPlayer)
	end
	if not Players[newPlayer]:IsBarbarian() then
		AdjustStrengthOfAllCities(newPlayer)
		if gT.Globals.GameGenerated then
			if iCity:IsPlague() then
				UpdateUnitCostFromQuarantine(newPlayer)
				UpdateUnitCostFromQuarantine(jPlayer)
			end
			if (not bDiplomaticMarriage) and HasPlayerTech(newPlayer, arab4tech, "cczxere") and (iCity:GetOriginalOwner() ~= newPlayer) and (Players[iCity:GetOriginalOwner()]:IsMinorCiv() or (GetNumLegalCities(iCity:GetOriginalOwner()) > 1)) then 
				bPogrom = true;
			end
				
			if gT.Players[newPlayer].IsConsideredBarbarian then
				RemoveBarbarianStatus(newPlayer, "City Capture")
			end
			DoUpdateCitiesGovCorruption(newPlayer)
			DoDirtyBudgetValues(newPlayer)

			if (not bDiplomaticMarriage) then
				gT.Players[newPlayer].NumConquered = gT.Players[newPlayer].NumConquered + 1;
				gT.Players[newPlayer].LastTurnCityCaptured = GetITGGameTurn();
				if not gT.Players[newPlayer].AlreadyConqueredCID[cID] then
					bNotableConquest = true -- NOTABLE CONQUEST because it is first time player conquers this city
					gT.Players[newPlayer].AlreadyConqueredCID[cID] = GetRealGameTurn();
					gT.Players[newPlayer].UniqueNumConquered = gT.Players[newPlayer].UniqueNumConquered + 1;
					bVeryFirstConquer = true;
					DoRelationScriptOnCityCapture(newPlayer, iCity)
					FirstConquerOfCityLeagueScript(iCity, newPlayer, jPlayer)
					--here first conquer of city bonuses
					if GetDBCulturePlayerInfo(newPlayer, "AlternatedInnovation") == "Conquest" then
						if not Players[newPlayer]:IsMinorCiv() then
							DoInnovationFromConquest(newPlayer, iCity)
						end
					end
					if HasPlayerTech(newPlayer, GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_EMPIRE_12, "dedefuiyr") then
						gT.Players[newPlayer].FestivalTriumph = gT.Players[newPlayer].FestivalTriumph + 10;
					end
					if HasPlayerTech(newPlayer, GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_TRIBE_8, "8ghkiorbdvf") then
						if LastRandom(1, 100) <= GetChanceToHaveGWStolenInCityCapture(jPlayer) then
							DoTransferArt(jPlayer, newPlayer, "Random", 20)
						end
					end
				end
			end
			for i, buildingclass in pairs(GetFreeBuildingClassesOnCityFound(newPlayer)) do
				local bType = Players[newPlayer]:GetPlayerUniqueBuilding(buildingclass)
				if bType ~= -1 then
					if iCity:CanConstruct(bType, 1, 1) then
						iCity:SetNumFreeBuilding(bType, 1)
					end
				end
			end
			for buildingclass, tht in pairs(reinstallBuildingClasses) do
				local bType = Players[newPlayer]:GetPlayerUniqueBuilding(buildingclass)
				if bType ~= -1 then
					if not iCity:IsHasBuilding(bType) then
						iCity:SetNumRealBuilding(bType, 1)
					end
				end
			end
			--!! This values resets on city capture!!
			local eResource = gT.Players[newPlayer].Currencies;
			if eResource ~= -1 then
				local gStrengthOfGoldCurr = GetStrengthOfCurrencyGold(newPlayer, iCity)
				iCity:ChangeResourceExtraYield(eResource, yGold, gStrengthOfGoldCurr)
				gT.Cities[cID].CurrencyResYield[eResource] = gStrengthOfGoldCurr;
			end

			BasicCSMissionCompleteFunc(newPlayer, 39, nil, iCity:Plot():GetPlotIndex())
			TakeCareOfEventMorale(jPlayer, 3, {cID, iCity, bNotableConquest, bVeryFirstConquer})
			TakeCareOfEventMorale(newPlayer, 4, {cID, iCity, bNotableConquest, bVeryFirstConquer})
		end
		local sRel = gT.Players[newPlayer].OfficialReligion;
		if sRel then
			MakeReligionPercentageOfTotal(sRel, iCity, 85, 1000)
		elseif Players[newPlayer]:HasCreatedPantheon() then
			if Players[newPlayer]:GetReligionCreatedByPlayer() < 1 then
				if iCity:GetReligiousMajority() == -1 then
					if iCity:GetNumReligionPressure(0) < 10000 then
						iCity:SetNumReligionPressure(0, 10000)
					end
				end
			end
		end
		if gT.Players[newPlayer].CannotBeConverted then
			iCity:SetSpreadImmune(true)
		else
			iCity:SetSpreadImmune(false)
		end
	end

	--
	--
	WonderRuinsCityDirty(iCity)
	DoApplyCurrencyChangeOnCityCapture(jPlayer, newPlayer)
	CityAcquiredBeliefBonuses(iCity, jPlayer, newPlayer)
	DoApplySocialPoliciesOnNewCity(newPlayer, iCity, cID)
	DoApplyIdeologyBonusesNewCity(newPlayer, iCity, cID, jPlayer)
	DoApplyLawEffectsOnNewCity(newPlayer, iCity, cID, jPlayer)
	DoApplyInnovationBonuses(newPlayer, iCity, cID, jPlayer, bConquest, bVeryFirstConquer)
	CityDirtOccupiedPenalty(newPlayer, "Conq")
	CityOccupyCountDirty(newPlayer)
	CityOccupyCountDirty(jPlayer)
	DirtyProductionFromGPInACity(iCity, newPlayer)
	DirtyProductionFromTechInACity(iCity, newPlayer)
	DetermineUnitConquerorAndRelatedBonuses(iCity, newPlayer, bNotableConquest);
	if bAddSetPoints then
		if not DBScenario.SettlersOff then
			ChangeITGSettlerPoints(jPlayer, numSetPoints, nil, "CityConquer")
		end
	end
	if (not bDiplomaticMarriage) and bNotableConquest and bConquest then
		DoTriggerNotableConquest(jPlayer, newPlayer, iCity, cID, preconqhap, bVeryFirstConquer)
	else
		DiploNoteDirty(jPlayer, 42)
		DoLogDominationEvent(-1, newPlayer, jPlayer, 15, -15, false)
	end
	for exI, exUnitD in pairs(unitRecruitedCQ) do
		local jUnit = Players[newPlayer]:InitUnit(exUnitD[1], exUnitD[3], exUnitD[4])
		jUnit:SetDamage(exUnitD[2])
		jUnit:SetMoves(0)
		ITGSCNewUnitCreated(newPlayer, jUnit, nil, false, nil, nil, false)
	end
	if gT.Cities[cID].Heresy then
		EndHeresyImmediately(gT.Cities[cID].Heresy, -1, true)
	end
	EndUprisingImmediately(iCity, cID, -1, true)
	if bPogrom then  	--should be last
		local popChange = -1* iCity:GetPopulation() + 1;
		numSetPoints = numSetPoints - popChange;
		iCity:ChangePopulation(popChange, true)
		DoInitialCityCulture(cID, iCity, newPlayer)
		SetOriginalOwnerOfCityITG(iCity, newPlayer, "Pogrom")
	end
	iCity:SetDamage(cityDMGratio * iCity:GetMaxHitPoints())
	gT.Cities[cID].LastTurnDamage = iCity:GetDamage();
	CityStatusForResistanceVisionDirty(iCity)
	DoRecheckSpiesActive(jPlayer, newPlayer, iCity, cID)
	HnGLogCityCapture({Prev = jPlayer, New = newPlayer, Plot = iCity:Plot():GetPlotIndex(), Conquest = bConquest, Notable = bNotableConquest, NumConquer = gT.Cities[cID].NumConquered, Turn = GetITGGameTurn()})
	AchievementCheckOnCityCapture(iCity, jPlayer, newPlayer, bConquest)
end
GameEvents.CityCaptureComplete.Add(CityCaptureMain)

function GetNewBestOriginalCapital(iPlayer, iCity)
	local nCity = Players[iPlayer]:GetCapitalCity()
	local iCityIndex = iCity:Plot():GetPlotIndex();
	if nCity and (nCity:Plot():GetPlotIndex() ~= iCityIndex) and (nCity:GetOriginalOwner() == iPlayer) then
		return nCity;
	end
	local tab = {}
	for g, h in pairs(gT.Players) do
		for jCity in Players[g]:Cities() do
			if jCity:GetOriginalOwner() == iPlayer then
				if jCity:Plot():GetPlotIndex() ~= iCityIndex then
					table.insert(tab, jCity)
				end
			end
		end
	end
	if #tab > 0 then
		return tab[LastRandom(1,#tab)];
	end
	return nil;
end

function ITGDoSetOriginalCapital(iCity)
	iCity:SetOriginalCapital(); -- always for current original owner
	GovernorDirtyCapital(iCity:GetOwner())
end

function SetOriginalOwnerOfCityITG(iCity, iPlayer, s)
	if iCity:IsOriginalCapital() then
		local pOriginalPlayer = iCity:GetOriginalOwner();
		if pOriginalPlayer ~= iPlayer then
			local cCity = GetNewBestOriginalCapital(pOriginalPlayer, iCity);
			if cCity then -- then we try to replace
				ITGDoSetOriginalCapital(cCity)
			elseif not Players[pOriginalPlayer]:IsMinorCiv() then
				print("Error 8345/345 no replacing original capital found", pOriginalPlayer, iCity:GetName(), s)
			end
		else
			print("Now, this is true error #534213?", iPlayer, extrainfo1, s)
		end
	end
	if gT.Players[iPlayer] then
		if gT.Players[iPlayer].CultBonusOn[168] then
			local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
			if #gT.Cities[cID].Manufactories > 0 then
				iCity:ChangeAttackMod(20)
			end
		end
	end
	iCity:SetOriginalOwner(iPlayer)
	DoDirtyFreeUnitsFromNumCities(iPlayer)
	CityDirtOccupiedPenalty(iPlayer, s)
	CityOccupyCountDirty(iPlayer)
	CityStatusForResistanceVisionDirty(iCity)
	DoDirtyBudgetValues(iPlayer)
end

function TakeCareOfSpecialPlotsOfType(type)
	for index, data in pairs(gT[type]) do
		if data.Player ~= Map.GetPlotByIndex(index):GetOwner() then
			local nPlot = Map.GetPlotByIndex(index)
			nPlot:SetOwner(data.Player, GetClosestCityIDToPlotOrNil(data.Player, nPlot))
		end
		if data.AdjacentPlots then
			for it, indexplot in pairs(data.AdjacentPlots) do
				if gT.PlotFortControl[indexplot] == index then
					local iPlot = Map.GetPlotByIndex(indexplot);
					if iPlot:GetOwner() ~= data.Player then
						iPlot:SetOwner(data.Player, GetClosestCityIDToPlotOrNil(data.Player, iPlot))
					end
				end
			end
		end
	end
end

function TakeCareOfColoniesUponCityConquer()
	TakeCareOfSpecialPlotsOfType("Forts")
	TakeCareOfSpecialPlotsOfType("Colonies")
	TakeCareOfSpecialPlotsOfType("HolySites")
	TakeCareOfSpecialPlotsOfType("Settlements")
end

function GetUnitOnPlot(newPlayer, plot)
	for i = 0, plot:GetNumUnits() -1 do
		local iUnit = plot:GetUnit(i);
		if iUnit:GetOwner() == newPlayer then
			return iUnit;
		end
	end
	return nil;
end

function DoTriggerNotableConquest(jPlayer, newPlayer, iCity, cID, preconqhap, bVeryFirstConquer)
	local bForeignCity = iCity:GetOriginalOwner() ~= newPlayer;
	gT.Players[jPlayer].BlockMissilesT = true;
	gT.Players[newPlayer].BlockMissilesT = false;
	if gT.Players[newPlayer].HasMinorIdeology[8] then
		for iUnit in Players[jPlayer]:Units() do
			if Map.PlotDistance(iUnit:GetX(), iUnit:GetY(), iCity:GetX(), iCity:GetY()) <= 2 then
				iUnit:ChangeDamage(35, newPlayer)
			end
		end
	end
	if gT.Players[newPlayer].HasMinorIdeology[9] then
--		local healamount = math.floor(iCity:GetDamage() / 2)
--		HealCityDamage(iCity, healamount)
		cityDMGratio = cityDMGratio * 0.5;
		if iCity:GetResistanceTurns() > 1 then
			iCity:ChangeResistanceTurns(1 - iCity:GetResistanceTurns())
		end
	end
	if gT.Players[newPlayer].HasIdeology[10] then
		local csTab = {};
		for g, h in pairs(gT.Players) do
			if Players[g]:IsMinorCiv() and (Players[g]:GetNumCities() > 0) then
				if Players[g]:GetMinorCivFriendshipLevelWithMajor(newPlayer) == 1 then
					table.insert(csTab, g);
				end
			end
		end
		if #csTab > 0 then
			local csPlayer = RandomFromTab(csTab);
			Players[csPlayer]:ChangeMinorCivFriendshipWithMajor(newPlayer, 20);
		end
	end
	if gT.Players[newPlayer].HasIdeology[66] then
		DoAddTemporalCurrencyPower(newPlayer, LastRandom(40,60))
	end
	if gT.Players[newPlayer].HasIdeology[58] and (sot100oncc >= 10) then
		local scBonus = math.floor(sot100oncc / 10);
		ChangeITGScience(newPlayer, scBonus)
		HandleCCFloat(newPlayer, iCity:GetX(), iCity:GetY(), "+" .. scBonus .. "[ICON_RESEARCH]")
	end
	if HasPlayerTech(newPlayer, GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_HORDE_6, "kfoekroe") then
		ChangeMeritocracy(newPlayer, 5)
	end
	if HasPlayerTech(newPlayer, innoindu5, "vefverfefr") then
		gT.Players[newPlayer].Ind5NatUnity = gT.Players[newPlayer].Ind5NatUnity + 1;
		ChangeMeritocracy(newPlayer, 1)
	end
	if gT.Players[newPlayer].HasMinorIdeology[10] then
		DistributeRandomlyHappiness(newPlayer, 5, {iCity:GetID()})
	end
	if gT.Players[newPlayer].HasMinorIdeology[11] then
		if Players[newPlayer]:GetNumUnitsOutOfSupply() <= 0 then
			local am = 1;
			if (iCity:GetOriginalOwner() ~= jPlayer) or (gT.Cities[cID].CultureOwner ~= jPlayer) then
				am = 2;
			end
			for i = 1, am do
				local rut = GetAnyValidMilitaryUnitType(newPlayer, dLand)
				local jUnit = Players[newPlayer]:InitUnit(rut, iCity:GetX(), iCity:GetY())
				jUnit:SetMoves(0)
				jUnit:JumpToNearestValidPlot()
				ITGSCNewUnitCreated(newPlayer, jUnit, nil, false, nil, nil, false)
			end
		end
	end
	if gT.Players[newPlayer].HasIdeology[3] then
		if preconqhap < 0 then
			local thechance = preconqhap * -5;
			for i = 1, 5 do
				if LastRandom(1, 100) <= thechance then
					if Players[newPlayer]:GetNumUnitsOutOfSupply() <= 0 then
						local rut = GetAnyValidMilitaryUnitType(newPlayer, dLand)
						local jUnit = Players[newPlayer]:InitUnit(rut, iCity:GetX(), iCity:GetY())
						jUnit:SetMoves(0)
						jUnit:JumpToNearestValidPlot()
						ITGSCNewUnitCreated(newPlayer, jUnit, nil, false, nil, nil, false)
						thechance = thechance + preconqhap
					else
						break;
					end
				else
					break;
				end
			end
		end
	end
	if gT.Players[newPlayer].HasMinorIdeology[12] then
		DoChangeCityCultureOwnership(cID, iCity, newPlayer, 150)
	end
	local iNumAca70 = GetNumAcademiesWithAbility(newPlayer, 70)
	if iNumAca70 > 0 then
		DoChangeCityCultureOwnership(cID, iCity, newPlayer, iNumAca70 * 40)
	end

	if gT.Players[newPlayer].HasMinorIdeology[13] then
		local dLc, dSc = 0, 0;
		for iUnit in Players[newPlayer]:Units() do
			if Map.PlotDistance(iUnit:GetX(), iUnit:GetY(), iCity:GetX(), iCity:GetY()) <= 2 then
				if iUnit:GetDomainType() == dSea then
					dSc = dSc + 1;
				elseif iUnit:GetDomainType() == dLand then
					dLc = dLc + 1;
				end
			end			
		end
		if dLc + dSc == 0 then
			if LastRandom(1, 2) == 2 then
				Players[newPlayer]:ChangeCombatExperience(75)
			else
				Players[newPlayer]:ChangeNavalCombatExperience(75)
			end
		else
			local tab = {{1, dLc}, {2, dSc}}
			if 1 == GetRandomFromBiasedChanceTable(tab) then
				Players[newPlayer]:ChangeCombatExperience(75)
			else
				Players[newPlayer]:ChangeNavalCombatExperience(75)
			end
		end
	end
	if gT.Players[newPlayer].HasMinorIdeology[14] then
		SetITGCityInteger(iCity, "CI_EQUALITY_CONQUEST", 100)
		SetITGCityInteger(iCity, "CI_EQUALITY_TURN", GetITGGameTurn() + 15);
		iCity:ChangeYieldRateModifier(yProduction, 100)
	end
	if bForeignCity then
		if gT.Players[newPlayer].HasIdeology[33] or HasPlayerTech(newPlayer, GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_EMPIRE_15 ,"frfefewG") then
			SatrapsOnConquest(newPlayer, iCity)
		end
	end
	DoLogDominationEvent(7, newPlayer, jPlayer, 100, -100, false, iCity:Plot():GetPlotIndex())
	VictoryTaskCompletion(newPlayer, 21)
	GovernorClaimVictoryOverNotableConquest(newPlayer)
end

function DetermineUnitConquerorAndRelatedBonuses(iCity, newPlayer, bNotable)
	local cUnit;
	for iUnit in Players[newPlayer]:Units() do
		if iUnit:GetX() == iCity:GetX() and iUnit:GetY() == iCity:GetY() then
			cUnit = iUnit;
			break;
		end
	end
	if cUnit then
		if bNotable then
			if gT.Players[newPlayer].HasIdeology[52] then
				if IsGreatITGPerson(cUnit) then
					GeneralAdmiralRivalry(cUnit, 3)
				end
			end
		end
	end
end