local IsMint = {[GameInfoTypes.BUILDING_ITG_MINT] = 1}
local bForeignDis = GameInfoTypes.BUILDING_ITG_INNO_FOREIGN_DISTRICT
local placmarka1 = GameInfoTypes.BUILDING_ITG_NEW_WORLD_WONDER_25;
local cbOracleNat = GameInfoTypes.BUILDING_ITG_NATIONAL_ORACLE;
local innoindu18 = GameInfoTypes.TECH_UNIQUE_ITG_INDUSTRIAL_18;
local bChateau = GameInfoTypes.BUILDING_ITG_LS_CHATEAU;
local bInquisition = GameInfoTypes.BUILDING_ITG_NEW_WORLD_INQUISITION;
local csInno32 = GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_32;
local wonderTab = {}
local wonderClassTab = {}
local palaceExpandT = {}
for row in GameInfo.BuildingClasses() do
	if row.MaxGlobalInstances == 1 then
		wonderClassTab[row.ID] = 1		
	end
end
for row in GameInfo.Buildings() do
	if wonderClassTab[GameInfoTypes[row.BuildingClass]] then
		wonderTab[row.ID] = 1
	end	
	if row.BuildingClass == "BUILDINGCLASS_ITG_LS_PALACE_UPGRADE" then
		palaceExpandT[row.ID] = 1;
	end
end

function ITGCityPurchasedBuilding(iCity, unitP, bGold, bFaith, bTask, bNoNewTask)	
	if bTask then
		if bNoNewTask then
			iCity:PopOrder(0, 1, 1)
		else
			local bAuto = iCity:IsProductionAutomated();
			iCity:SetProductionAutomated(true);
			iCity:PopOrder(0, 1, 1)
			iCity:SetProductionAutomated(bAuto);
		end
	else
		iCity:SetNumRealBuilding(unitP, 1)
		CityConstructedOn(iCity:GetOwner(), iCity:GetID(), unitP, bGold, bFaith)
	end
end

function CityConstructedOn(iPlayer, cityId, buildingType, bGold, bFaithOrCulture)
	local iCity = Players[iPlayer]:GetCityByID(cityId);
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local bBuilding = true;
	if wonderTab[buildingType] then
		WonderConstructed(iPlayer, iCity, cID, buildingType)
		bBuilding = false;
	end
	if buildingType == cbOracleNat then
		 CheckBonusForOracle(iPlayer)
	elseif buildingType == bInquisition then
		DoReligiousOppresionInquisition(iCity, iPlayer)
	elseif bForeignDis == buildingType then
		UpdateAllFoodForeignDis(iPlayer)
	end
	if GameInfo.Buildings[buildingType].MutuallyExclusiveGroup == 7 then
		OnDirtyCulturalGuilds(iPlayer)
	end
	if IsMint[buildingType] then
		for eResource, sth in pairs(gT.Cities[cID].CurrencyResYield) do
			iCity:ChangeResourceExtraYield(eResource, yGold, 2)
			gT.Cities[cID].CurrencyResYield[eResource] = sth + 2;
		end
	end
	if bChateau == buildingType then
		gT.Players[iPlayer].ChateauCharges = gT.Players[iPlayer].ChateauCharges + 1;
		iCity:SetNumRealBuilding(buildingType, 0)
		bBuilding = false;
		return;
	elseif palaceExpandT[buildingType] then
		CallCityCreatedPalaceExpand(iCity, cID, iPlayer, true)
		iCity:SetNumRealBuilding(buildingType, 0)
		bBuilding = false;
		return;
	elseif not wonderTab[buildingType] then
		if iCity:IsHasBuilding(placmarka1) then
			if GameInfo.Buildings[buildingType].GoldMaintenance > 0 then
				iCity:SetNumFreeBuilding(buildingType, 1)
				iCity:SetNumRealBuilding(buildingType, 0)
			end
		end
	end
	if bGold then
		if HasPlayerTech(iPlayer, innoindu18, "kdakeda") then
			local cVl = gT.Players[iPlayer].CommercBuildingMod or 0;
			local nVl = math.min(25, cVl + 5);
			if cVl ~= nVl then
				Players[iPlayer]:ChangeBuildingPurchaseCostMod(cVl - nVl)
				gT.Players[iPlayer].CommercBuildingMod = nVl;
			end
			gT.Players[iPlayer].CommercModEndTurn = GetITGGameTurn() + 7;
		end
		if gT.Players[iPlayer] then
			ChangeGoldSpendInternally(iPlayer, iCity:GetBuildingPurchaseCost( buildingType ))
		end
		if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_MEDIEVAL_AFR_1, "%$T4334") then
			ChangeITGFaith(iPlayer, math.ceil(GameInfo.Buildings[buildingType].Cost * 0.5))
		end
	elseif bFaithOrCulture then
		if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_MEDIEVAL_AFR_1, "%$T4334") then
			DoChangeCityCultureOwnership(cID, iCity, iPlayer, 50, "FaithPurchase") 
		end
	else
		local spbcfa = GetNumCityAcademiesWithAbility(iCity, 6)
		if spbcfa > 0 then
			if not Players[iPlayer]:IsMinorCiv() then
				ChangeITGScience(iPlayer, iCity:GetBuildingProductionNeeded(buildingType) * spbcfa)
			end
		end
		if gT.Players[iPlayer].CanWonderRace then
			if gT.Players[iPlayer].BuildingIntoWonderMod > 0 then
				local reward = math.ceil(GameInfo.Buildings[buildingType].Cost * gT.Players[iPlayer].BuildingIntoWonderMod)
				if reward > 0 then
					BoostWonderProduction(iPlayer, reward)
				end
			end
		end
		if gT.Globals.GameGenerated then
			if bBuilding then
				VictoryTaskCompletion(iPlayer, 35)
				DoIncreasementStockExchange(1)
				gT.Cities[cID].NumBuildingConstructed = gT.Cities[cID].NumBuildingConstructed + 1;
			end
		end
	end
	if bBuilding then -- it also excludes wonders!
		gT.Players[iPlayer].LHBuildingsConstructed = gT.Players[iPlayer].LHBuildingsConstructed + 1; 
		BasicCSMissionCompleteFunc(iPlayer, 2, 1, buildingType)
		if gT.Players[iPlayer].MaintenanceFreeClasses[GameInfoTypes[GameInfo.Buildings[buildingType].BuildingClass]] then
			iCity:SetNumFreeBuilding(buildingType, 1)
			iCity:SetNumRealBuilding(buildingType, 0)
		end
		if gT.Players[iPlayer].HasIdeology[45] then
			if gT.Players[iPlayer].Inspirations[GameInfo.Buildings[buildingType].BuildingClass] then
				ChangeITGHappinessInTheCity(iCity, 2, nil, "erecerfada")
			end
		end
		if HasPlayerTech(iPlayer, csInno32, "vfeffe") then
			ChangeMeritocracy(iPlayer, 1)
		end
		if gT.Players[iPlayer].HasIdeology[64] then
			if IsPresentInAllCities(iPlayer, iCity:GetID(), buildingType) then
				ChangeITGHappinessInTheCity(iCity, 5, nil, "123cserq23")
				ChangeITGCulture(iPlayer, 100)
				gT.Players[iPlayer].BuildingsIdeo64[buildingType] = 1;
			end
		end
		if bGold then
			DiploNoteDirty(iPlayer, 25)
		end
	end
end
GameEvents.CityConstructed.Add(CityConstructedOn)

function IsPresentInAllCities(iPlayer, cityID, buildingType)
	if gT.Players[iPlayer].BuildingsIdeo64[buildingType] then
		return false;
	end
	for iCity in Players[iPlayer]:Cities() do
		if iCity:GetID() ~= cityID then
			if not iCity:IsHasBuilding(buildingType) then
				return false;
			end
		end
	end
	return true;
end

function IsValidForKailasaTemple(iBuilding)
	if IsWonder(iBuilding) then
		return false
	end
	if palaceExpandT[iBuilding] then
		return false;
	end
	return true;
end

function DoAddFreeBuildingIfPossible(iCity, iPlayer)
	for row in GameInfo.BuildingClasses() do
		local buildingType = Players[iPlayer]:GetPlayerUniqueBuilding(row.ID);
		if iCity:CanConstruct(buildingType, 1, 1) then
			if IsValidForKailasaTemple(buildingType) then
				if iCity:GetProductionBuilding() ~= buildingType then
					iCity:SetNumFreeBuilding(buildingType, 1)
					return true;
				end
			end
		end
	end
	return false;
end

GameEvents.CitySoldBuilding.Add(function(iPlayer, cityID, buildingType)
	local iCity = Players[iPlayer]:GetCityByID(cityID);
--	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	if gT.Players[iPlayer].HasIdeology[45] then
		if gT.Players[iPlayer].Inspirations[GameInfo.Buildings[buildingType].BuildingClass] then
			ChangeITGHappinessInTheCity(iCity, -2, nil, "jgjskger")
		end
	end
	if HasPlayerTech(iPlayer, csInno32, "vfeffe") then
		ChangeMeritocracy(iPlayer, -1)
	end
end)
