local AncientRuins = GameInfoTypes.IMPROVEMENT_ITGSG_ANCIENT_RUINS;
local FakeOasis = GameInfoTypes.RESOURCE_ITGSG_OASIS;
local SolomonMine = GameInfoTypes.IMPROVEMENT_ITGSG_SOLOMON_MINES;
local AfterLoad = false;
local uCaravan = GameInfoTypes.UNIT_ITGSG_CARAVAN;
local uBarbSettler = GameInfoTypes.UNIT_BARB_SETTLER;
local innoTasia7 = GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_ASIA_7;
local RelProm20NearHolyCities= GameInfoTypes.PROMOTION_ITG_REL_NEAR_HOLY_CITIES_20;
local cuScout = GameInfoTypes.UNITCLASS_SCOUT;
local tPIE = {}
local RangAtt = GameInfoTypes.MISSION_RANGE_ATTACK;
local promEngRoads = GameInfoTypes.PROMOTION_ROAD_ENGINEER
local rRoad = GameInfoTypes.ROUTE_ROAD;
local CanRangeStrikeAtTheEnd = {
[GameInfoTypes.UNIT_ITG_AOT_CHARIOT_SCYTHIA] = true;
}
local ScythedMovement = {
[GameInfoTypes.UNIT_ITG_AOT_CHARIOT_UU_1] = 20;
}

for i, v in pairs(Players) do
	for iUnit in v:Units() do
		if iUnit:GetUnitType() == HerdID then
			tPIE[iUnit] = 1;
		end
	end
end

function SetXYLoaded(value)
	AfterLoad = value;
end

function IsValidToClaim(iPlot, iPlayer)
	if (iPlot:GetOwner() == -1 and (not iPlot:IsWater()) and (Players[iPlayer]:GetCapitalCity())) then
		for j = 0, 5 do	
			local jPlot = Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), j);
			if jPlot and (jPlot:GetOwner() ~= -1  and jPlot:GetOwner() ~= iPlayer) then
				return false
			end
		end
		return true;
	end
	return false;
end

function WalkingHet(iPlayer, unit, x, y, oldX, oldY)
	local iPlot = Map.GetPlot(x,y)
	if iPlot then
		local iUnit = Players[iPlayer]:GetUnitByID(unit);
		local iPlotIndex = iPlot:GetPlotIndex();
		local uID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
		if gT.SetXY.Colonialism[iPlayer] then
			if IsValidToClaim(iPlot, iPlayer) then
				iPlot:SetOwner(iPlayer, Players[iPlayer]:GetCapitalCity());
				gT.Players[iPlayer].PlotsClaimedBySetXY[iPlot:GetPlotIndex()] = 1;
			end
		end
		if iUnit:IsHasPromotion(promEngRoads) then
			if Players[iPlayer]:IsTurnActive() then
				if IsValidPlotForTemporaryRoute(iPlot) then
					iPlot:SetRouteType(rRoad)
					gT.Globals.TemporaryRoads[iPlot:GetPlotIndex()] = 1;
				end
			end
		end
		if iUnit:GetUnitType() == uCaravan then
			if HasPlayerTech(iPlayer, innoTasia7, "innoTasia7") then
				if (iPlot:GetOwner() == iPlayer) or (iPlot:GetOwner() == -1) then
					iPlot:SetRouteType(rRoad)
				end
			end
		end
		if gT.SetXY.AncientRuinsRadar[iPlayer] then
			if iUnit:GetUnitClassType() == cuScout then
				local iTeam = Players[iPlayer]:GetTeam();
				for index, data in pairs(gT.Players[iPlayer].AncientRadarLeft) do
					if Map.PlotDistance(data[1], data[2], x, y) <= 6 then
						Map.GetPlotByIndex(index):SetRevealed(iTeam, true);
						gT.Players[iPlayer].AncientRadarLeft[index] = nil;
					end
				end
			end
		end
		local uType = iUnit:GetUnitType();
		if CanRangeStrikeAtTheEnd[uType] then
			if tPIE[iUnit] then
				if iUnit:GetMoves() <= 0 then
					SearchRangeStrikeSkulaAttack(iUnit)
				end
			else
				tPIE[iUnit] = 1; -- this is after purchase
			end
		end
		if ScythedMovement[uType] and (LastRandom(1,100) <= ScythedMovement[uType]) then
			ScythedZoCCheck(iUnit, iPlayer, iPlot, Map.GetPlot(oldX, oldY))
		end
	--	if GameInfo.Units[iUnit:GetUnitType()].StackITGType ~= -2 then
		if iUnit:GetITGStackType() ~= -2 then
			if gT.Colonies[iPlotIndex] then
				if gT.Colonies[iPlotIndex].Player ~= iPlayer then
					local cPlayer = gT.Colonies[iPlotIndex].Player;
					if Teams[Players[iPlayer]:GetTeam()]:IsAtWar(Players[cPlayer]:GetTeam()) then
						ColonyTakeOver(iPlayer, cPlayer, iPlot, false, iUnit)
					end
				end
			elseif gT.HolySites[iPlotIndex] then
				if gT.HolySites[iPlotIndex].Player ~= iPlayer then
					local cPlayer = gT.HolySites[iPlotIndex].Player;
					if Teams[Players[iPlayer]:GetTeam()]:IsAtWar(Players[cPlayer]:GetTeam()) then
						HolySiteTakeOver(iPlayer, cPlayer, iPlot, nil, nil, iUnit)
					end
				end
			elseif gT.Forts[iPlotIndex] then
				if gT.Forts[iPlotIndex].Player ~= iPlayer then
					local cPlayer = gT.Forts[iPlotIndex].Player;
					if Teams[Players[iPlayer]:GetTeam()]:IsAtWar(Players[cPlayer]:GetTeam()) then
						FortTakeOver(iPlayer, cPlayer, iPlot, nil, iUnit)
					end
				end
			elseif gT.ElDorados[iPlotIndex] then
				if gT.ElDorados[iPlotIndex].Player ~= iPlayer then
					local cPlayer = gT.ElDorados[iPlotIndex].Player;
					if Teams[Players[iPlayer]:GetTeam()]:IsAtWar(Players[cPlayer]:GetTeam()) then
						ElDoradoTakeOver(iPlayer, cPlayer, iPlot)
					end
				end
			end
		end
	end
end
GameEvents.UnitSetXY.Add(WalkingHet)

function SearchRangeStrikeSkulaAttack(jUnit)
	local bX = jUnit:GetX();
	local bY = jUnit:GetY();
	local hTab = {}
	jUnit:SetMoves(1)
	for iX = -3, 3 do
		for iY = -3, 3 do
			local plot = Map.PlotXYWithRangeCheck(bX, bY, iX, iY, 3)
			if plot then
				if jUnit:CanStartMission(RangAtt, plot:GetX(), plot:GetY()) then
					table.insert(hTab, plot)
				end
			end
		end
	end
	if #hTab > 0 then
		local ePlot = hTab[math.random(1, #hTab)];
		jUnit:PushMission(RangAtt, ePlot:GetX(), ePlot:GetY())
	end
	jUnit:SetMoves(0);
end

function HighlightProperPlotsForMilitaryEngineer(iPlayer)
	MapModData.ITGSG = GetTabOfAllPossibleMilitaryEngineersToMake(iPlayer) 
end

function GetTabOfAllPossibleMilitaryEngineersToMake(iPlayer) 
	local tab = {}
	for iUnit in Players[iPlayer]:Units() do
		if IsValidToBecomeMilitaryEngineer(iUnit, iPlayer) then
			table.insert(tab, iUnit:GetPlot())
		end
	end
	return tab;
end

function IsValidToBecomeMilitaryEngineer(iUnit, iPlayer)
	if gT.Players[iPlayer].UnitClassXP[iUnit:GetUnitClassType()] then
		if not iUnit:IsHasPromotion(promEngRoads) then
			if iUnit:GetDomainType() == dLand then
				return true;
			end
		end
	end
	return false;
end

function IsValidPlotForTemporaryRoute(iPlot)
	if iPlot:GetRouteType() == -1 then
		if not iPlot:IsWater() then
			return true;
		end
	end
	return false;
end

function GetUnitForMilitaryEngineer(pPlot, iPlayer)
	for iUnit in Players[iPlayer]:Units() do
		if iUnit:GetPlot() == pPlot then
			if IsValidToBecomeMilitaryEngineer(iUnit, iPlayer) then
				return iUnit;
			end
		end
	end
	return nil;
end

function PlayerChooseMilitaryEngineerOnPlot(pPlot, iPlayer)
	local tUnit = GetUnitForMilitaryEngineer(pPlot, iPlayer)
	if tUnit then
		tUnit:SetHasPromotion(promEngRoads, true)
		gT.Players[iPlayer].NumMilitaryEngineers = gT.Players[iPlayer].NumMilitaryEngineers - 1;
		if IsValidPlotForTemporaryRoute(tUnit:GetPlot()) then
			tUnit:GetPlot():SetRouteType(rRoad)
			gT.Globals.TemporaryRoads[tUnit:GetPlot():GetPlotIndex()] = 1;
		end
	end
end

function DoAILogicForMilitaryEngineers(iPlayer)
	local tab = {}
	for iUnit in Players[iPlayer]:Units() do
		if IsValidToBecomeMilitaryEngineer(iUnit, iPlayer) then
			table.insert(tab, {iUnit, iUnit:MaxMoves()})
		end
	end
	table.sort(tab, SortFunctionForGreaterInteger2)
	for i, t in pairs(tab) do
		if gT.Players[iPlayer].NumMilitaryEngineers > 0 then
			local tUnit = t[1]
			tUnit:SetHasPromotion(promEngRoads, true)
			gT.Players[iPlayer].NumMilitaryEngineers = gT.Players[iPlayer].NumMilitaryEngineers - 1;
			if IsValidPlotForTemporaryRoute(tUnit:GetPlot()) then
				tUnit:GetPlot():SetRouteType(rRoad)
				gT.Globals.TemporaryRoads[tUnit:GetPlot():GetPlotIndex()] = 1;
			end
		else
			break;
		end
	end
end

function ScythedZoCCheck(cUnit, iPlayer, iPlot, fromPlot)
	if not fromPlot then
		return;
	end
	if Map.PlotDistance(iPlot:GetX(), iPlot:GetY(), fromPlot:GetX(), fromPlot:GetY()) ~= 1  then
		return;
	end
	for i = 0, 5 do
		if iPlot == Map.PlotDirection(fromPlot:GetX(), fromPlot:GetY(), i) then
			local theMoves = cUnit:GetMoves();
			local bOutOfAttacks = cUnit:IsOutOfAttacks()
			cUnit:SetMadeAttack(false);
			if theMoves == 0 then
				cUnit:ChangeMoves(1);
			end
			for j = 1, 2 do
				local tPlot = Map.PlotDirection(fromPlot:GetX(), fromPlot:GetY(), (i + 6 + math.pow(-1, j))%6)
				if tPlot and cUnit:CanStartMission(RangAtt, tPlot:GetX(), tPlot:GetY()) then
					cUnit:PushMission(RangAtt, tPlot:GetX(), tPlot:GetY())
					break;
				end
			end
			cUnit:SetMoves(theMoves);
			cUnit:SetMadeAttack(bOutOfAttacks);
			break;
		end
	end
end
