local KUDH = {}
local pKillingUID = {}
local uKillingUID = {}
local iNukeModUID = {}
local uHeretic = GameInfoTypes.UNIT_ITG_HERETIC;
local uCaravan = GameInfoTypes.UNIT_ITGSG_CARAVAN;
local uGarrison = GameInfoTypes.UNIT_GARRISON;
local uWorkboat = GameInfoTypes.UNIT_WORKBOAT;
local uGallowglass = GameInfoTypes.UNIT_ITG_TRIAL_LONGSWORDSMAN_3
local ucSiege = GameInfoTypes.UNITCOMBAT_SIEGE;
local ucSubmarine = GameInfoTypes.UNITCLASS_SUBMARINE;
local ancCSinno2 = GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_2;
local afro8 = GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_AFR_8;
local titv8 = GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_VIKING_8;
local titv6 = GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_VIKING_6;
local innoAncientPatriotism = GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_17;
local tite3 = GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_EURO_3;
local rbifol36 = GameInfoTypes.BELIEF_ITG_FOLLOWER_36;
local rbifol37 = GameInfoTypes.BELIEF_ITG_FOLLOWER_37
local rbifol38 = GameInfoTypes.BELIEF_ITG_FOLLOWER_38
local rbifol39 = GameInfoTypes.BELIEF_ITG_FOLLOWER_39
local timodern7 = GameInfoTypes.TECH_UNIQUE_ITG_MODERN_7;
local tiaemp9 = GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_EMPIRE_9;
local tinm4 = GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_MESOAMERICAN_4;
local tina2 = GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_ASIA_2;
local tAncientTR14 = GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_TRIBE_14;
local innoANCtr7 = GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_TRIBE_7
local medwonder9 = GameInfoTypes.BUILDING_ITG_NEW_MEDIEVAL_WONDER_9;
local uPrivateer = GameInfoTypes.UNIT_ITG_PRIVATEER
local promEngRoads = GameInfoTypes.PROMOTION_ROAD_ENGINEER
local ValidDomainToCapture = {[dLand] = 1, [dSea] = 1}
local iNukePlayerMode;
local iCityKillingStrike;
local msnrad = {}

local CivilianClasses = {
[GameInfoTypes.UNITCLASS_WORKBOAT] = "Workboat",
[GameInfoTypes.UNITCLASS_SCOUT] = "Scout",
[GameInfoTypes.UNITCLASS_CARGO_SHIP] = "Cargo Ship",
[GameInfoTypes.UNITCLASS_CARAVAN] = "Caravan",
[GameInfoTypes.UNITCLASS_ARCHAEOLOGIST] = "Archaeologist",
[GameInfoTypes.UNITCLASS_ITG_PILGRIM] = "Pilgrim",
}
local totallyIgnoredKills = {
[GameInfoTypes.UNIT_ITG_MESO_BARB_TRAINING] = true,
[GameInfoTypes.UNIT_ITG_GUIDED_MISSILE] = true,
[GameInfoTypes.UNIT_ITG_ATOMIC_BOMB] = true,
}

local ITGTimeDiagnosisOnUnitKilled = {}
LuaEvents.ITGCallForTimeDiagnosis.Add(function()
	DoPrintTimeDiagnosisITG(ITGTimeDiagnosisOnUnitKilled, "Unit Killed 1")
end)

function DoCallNukeMode(iPlayer)
	iNukePlayerMode = iPlayer;
end

function DoCallCityStrikeMode(iPlotIndex)
	--unused
end

function PreKillFunction(unitOwnerId, unitId, unitType, unitX, unitY, bDelay, eKillingPlayer)
--	local timer = os.clock();
	if ITGdebug then
		print("KillingUnit", unitOwnerId, unitId, unitType, unitX, unitY, bDelay, eKillingPlayer)
	end
	if not gT.Globals.GameGenerated then
		return;
	end
	if totallyIgnoredKills[unitType] then
		return;
	end
	if (unitType == uHeretic) then
		CallToEndHeresy(unitId, eKillingPlayer)
		return;
	end
	if unitOwnerId == 63 then
		CheckUnitUprisingKill(unitId, eKillingPlayer)
	end
	if unitOwnerId ~= eKillingPlayer then
		if bDelay then
			local kUnit = Players[unitOwnerId]:GetUnitByID(unitId);
			pKillingUID[unitOwnerId .. "," .. unitId] = eKillingPlayer
			iNukeModUID[unitOwnerId .. "," .. unitId] = iNukePlayerMode;
			if gT.Players[unitOwnerId] then
				UpdateXPOfUnit(kUnit, unitOwnerId, true)
			end
			if eKillingPlayer ~= -1 then
				GenerateKUDHInfo(unitOwnerId, unitId, kUnit, unitType, eKillingPlayer, unitX, unitY)
			end
		else
			if unitType == uWorkboat then
				if gT.Players[unitOwnerId] then
					gT.Players[unitOwnerId].FishLost = math.max(gT.Players[unitOwnerId].FishLost + 1, 3)
				end
			end
			local bUnit;
			local hID = unitOwnerId .. "," .. unitId
			if uKillingUID[hID] then
				bUnit = Players[pKillingUID[hID]]:GetUnitByID(uKillingUID[unitOwnerId .. "," .. unitId])
			end
			local bMayBeScrap = ((pKillingUID[hID] or -1) == -1) and (eKillingPlayer == -1);
			UnitKillingImportantStuffThatAlwaysHaveToBeFired(bUnit, unitX, unitY, unitOwnerId, unitId, bMayBeScrap, pKillingUID[unitOwnerId .. "," .. unitId] or -1, iNukeModUID[unitOwnerId .. "," .. unitId], unitType)
			if KUDH[hID] then
				if not msnrad[hID .. "," .. Game.GetGameTurn()] then
					-- this can fire on city capture for sure // any void damage // etc. etc.
					UnitKillingMain(nil, unitX, unitY, unitOwnerId .. "," .. unitId, nil, nil, "Pk")
				end
			end
			pKillingUID[hID] = nil;
			iNukeModUID[hID] = nil;
			uKillingUID[hID] = nil;
		end
	end
--	table.insert(ITGTimeDiagnosisOnUnitKilled, os.clock() - timer)
	if ITGdebug then
		print("EndKillingUnit")
	end
end
GameEvents.UnitPrekill.Add(PreKillFunction)

function GenerateKUDHInfo(unitOwnerId, unitId, kUnit, unitType, eKillingPlayer, unitX, unitY, bFire)
	if KUDH[unitOwnerId .. "," .. unitId] then
		return;
	end
	if msnrad[unitOwnerId .. "," .. unitId .. "," .. Game.GetGameTurn()] then
		return;
	end
	KUDH[unitOwnerId .. "," .. unitId] = {NukePlayer = iNukePlayerMode, Level = kUnit:GetLevel(), Str = math.max(kUnit:GetBaseCombatStrength(true), kUnit:GetBaseRangedCombatStrength()), BatteringRam = kUnit:IsHasPromotion(GameInfoTypes.PROMOTION_ITG_BATTERING_RAM_SUPPORT), SiegeTower = kUnit:IsHasPromotion(GameInfoTypes.PROMOTION_ITG_SIEGE_TOWER_SUPPORT), 
	Plot = Map.GetPlot(unitX, unitY), Owner = unitOwnerId, UnitType = unitType, UnitClass = kUnit:GetUnitClassType(), KillingPlayer = eKillingPlayer, Mercenary = kUnit:IsMercenary(), ITGID = kUnit:GetID() .. "," .. unitOwnerId .. "," .. kUnit:GetGameTurnCreated(), Domain = kUnit:GetDomainType(), IsRealCombat = IsRealCombatUnit(kUnit), UnitCombatType = kUnit:GetUnitCombatType(),
	IsRamming = kUnit:IsHasPromotion(GameInfoTypes.PROMOTION_ITG_MODERN_RAMMING), UnitID = unitId, RebelAgainst = kUnit:GetRebelAgainst()}
end

GameEvents.UnitKillTraitBonuses.Add(function(kPlayer, kUnitID, jPlayer, jUnitID, kCityID, bRanged)
	local jUnit = Players[jPlayer]:GetUnitByID(jUnitID);
	local unitType = jUnit:GetUnitType();
	if totallyIgnoredKills[unitType] then
		return;
	end
	if (unitType == uHeretic) then
		return;
	end
	local hID = jPlayer .. "," .. jUnitID;
	local iDMGbefore = jUnit:GetDamage();
	pKillingUID[hID] = kPlayer;
	if kUnitID ~= -1 then
		uKillingUID[hID] = kUnitID;
	end
	GenerateKUDHInfo(jPlayer, jUnitID, jUnit, jUnit:GetUnitType(), kPlayer, jUnit:GetX(), jUnit:GetY())
	UnitKillingMain(Players[kPlayer]:GetUnitByID(kUnitID), jUnit:GetX(), jUnit:GetY(), hID, Players[kPlayer]:GetCityByID(kCityID), bRanged, "Tr")
end)

local meso3 = GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_MESOAMERICAN_3;
local meso8 = GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_MESOAMERICAN_8;
local gen13x2 = GameInfoTypes.PROMOTION_GREAT_GENERAL_13_2;
local adm11x2 = GameInfoTypes.PROMOTION_ITG_GREAT_ADMIRAL_11_2;
local gen15 = GameInfoTypes.PROMOTION_GREAT_GENERAL_15;
local gen20 = GameInfoTypes.PROMOTION_GREAT_GENERAL_20;
local adm13 = GameInfoTypes.PROMOTION_ITG_GREAT_ADMIRAL_13;
local adm18 = GameInfoTypes.PROMOTION_ITG_GREAT_ADMIRAL_18;
local adm24 = GameInfoTypes.PROMOTION_ITG_GREAT_ADMIRAL_24;
local gen27 = GameInfoTypes.PROMOTION_GREAT_GENERAL_27;
local arabtrial2 = GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_ARABIA_2;

function UnitKillingMain(jUnit, unitX, unitY, hID, jCity, bRanged, strH)
	if msnrad[hID .. "," .. Game.GetGameTurn()] then
		print("Repeated UKM", hID, Game.GetGameTurn(), strH, msnrad[hID .. "," .. Game.GetGameTurn()]);
		return;
	end
	if KUDH[hID] then
		msnrad[hID .. "," .. Game.GetGameTurn()] = strH;
		local deaduID = KUDH[hID].ITGID;
		local jPlayer = KUDH[hID].Owner;
		local kPlayer = KUDH[hID].KillingPlayer;
		local delay = 0.5;
		local barbarianKills = Players[kPlayer]:IsBarbarian();
		local barbKilled = Players[jPlayer]:IsBarbarian();
		local killinggenID, killingID;
		if gT.ColoniesByUnitID[deaduID] then
			ColonyTakeOver(kPlayer, jPlayer, Map.GetPlotByIndex(gT.ColoniesByUnitID[deaduID]), nil, jUnit)
			gT.ColoniesByUnitID[deaduID] = nil;
			SpecialPointTakenCSQuestLog(kPlayer, jPlayer, 1)
		elseif gT.HolySitesUnits[deaduID] then
			HolySiteTakeOver(kPlayer, jPlayer, Map.GetPlotByIndex(gT.HolySitesUnits[deaduID]), nil, nil, jUnit)
			gT.HolySitesUnits[deaduID] = nil;
			SpecialPointTakenCSQuestLog(kPlayer, jPlayer, 2)
		elseif gT.FortsByUnitID[deaduID] then
			if ThereIsValidCircumstancesForPlayerToTakeOverFort(kPlayer, jPlayer, unitX, unitY, KUDH[hID].UnitID) then
				FortTakeOver(kPlayer, jPlayer, Map.GetPlotByIndex(gT.FortsByUnitID[deaduID]), nil, jUnit)
				gT.FortsByUnitID[deaduID] = nil;
			else
				Map.GetPlot(unitX, unitY):SetImprovementPillaged(true);
			end
			SpecialPointTakenCSQuestLog(kPlayer, jPlayer, 3)
		elseif gT.SettlementsByUnitID[deaduID] then
			DestroySettlementOnPlot(unitX, unitY, kPlayer, jPlayer)
			SpecialPointTakenCSQuestLog(kPlayer, jPlayer, 5)
		elseif gT.ElDoradoByUnitID[deaduID] then
			if ThereIsValidCircumstancesForPlayerToTakeOverFort(kPlayer, jPlayer, unitX, unitY, KUDH[hID].UnitID) then
				BasicCSMissionCompleteFunc(kPlayer, 50);
				ElDoradoTakeOver(kPlayer, jPlayer, Map.GetPlotByIndex(gT.FortsByUnitID[deaduID]))
				gT.ElDoradoByUnitID[deaduID] = nil;
			else
				Map.GetPlot(unitX, unitY):SetImprovementPillaged(true);
			end
			SpecialPointTakenCSQuestLog(kPlayer, jPlayer, 4)
		else
			if gT.Players[kPlayer] then
				if kPlayer ~= jPlayer then
					DoLogDominationEvent(-1, kPlayer, jPlayer, 3, -3)
					if gT.Players[kPlayer].CaliphateGhazi then
						if GetITGReligion(kPlayer) ~= GetITGReligion(jPlayer) then
							gT.Players[kPlayer].CaliphateGhazi = gT.Players[kPlayer].CaliphateGhazi + 1;
						end
					end
					if Players[jPlayer]:IsBarbarian() then
						gT.Players[kPlayer].TotalBarbKilled = gT.Players[kPlayer].TotalBarbKilled + 1;
						VictoryTaskCompletion(kPlayer, 24)
					elseif gT.Players[jPlayer].CultureType == 1 then
						VictoryTaskCompletion(kPlayer, 73)
					end
					UnitKilledCSQuestLog(kPlayer, jPlayer, KUDH[hID].UnitType)
					gT.Players[kPlayer].AIhateValues[jPlayer] = gT.Players[kPlayer].AIhateValues[jPlayer] + 1;
					if CivilianClasses[KUDH[hID].UnitClass] then
						if gT.Players[kPlayer].CultBonusOn[8] then
							for iCity in Players[kPlayer]:Cities() do
								if Map.PlotDistance(iCity:GetX(), iCity:GetY(), unitX, unitY) < 3 then
									DoTriggerHappinessChanceInCity(iCity, kPlayer, nil, GetPlayerHapChance(kPlayer))
								end
							end
						end
						gT.Players[kPlayer].AIhateValues[jPlayer] = gT.Players[kPlayer].AIhateValues[jPlayer] + 1;
		--				print("Civilian just killed", KUDH[hID].UnitClass, deaduID, kPlayer, jPlayer, Players[kPlayer]:IsTurnActive())
						gT.Players[kPlayer].KilledCivilians[CivilianClasses[KUDH[hID].UnitClass]] = 1 + (gT.Players[kPlayer].KilledCivilians[CivilianClasses[KUDH[hID].UnitClass]] or 0);
					else
						local bMeleeKill = jUnit and (((jUnit:GetBaseRangedCombatStrength() == 0) or (jUnit:GetX() == unitX) and (jUnit:GetY() == unitY)) or (not Players[kPlayer]:IsTurnActive()));
						TakeCareOfEventMorale(kPlayer, 23)
						if gT.Players[jPlayer] then
							TakeCareOfEventMorale(jPlayer, 24)
							if KUDH[hID].Mercenary then
								gT.Players[jPlayer].DeadMerc = gT.Players[jPlayer].DeadMerc + 1;
							end
						end
						--killing player bonuses
						local yBonusTab = {
							LegalPower = 0,
							Gold = 0,
							Culture = 0,
							Happiness = 0,
							Meritocracy = 0,
							XP = 0,
							GreatPeople = 0,
							Food = 0,
							GreatWork = 0, --seems unused
							Power = 0, --bonus must be applied // this is only for floating text
							Faith = 0,
							Settler = 0, --seems unused
							Wonder = 0,
							WorkRate = 0,
							Presence = 0,
							PresenceRange = 0, -- must be used with max(yBonusTab.PresenceRange, 5)
							Science = 0,
							Mint = 0,
							Art = 0,
							Morale = 0, --bonus must be applied // this is only for floating text
						}
						if jUnit then
							local jID = jUnit:GetID() .. "," .. kPlayer .. "," .. jUnit:GetGameTurnCreated();
							if gT.Players[kPlayer].UnitsByID[jID] then -- MARKS WHEN UNIT MADE LAST KILL
								if not gT.Players[kPlayer].UnitsByID[jID].LastKillData then
									if gT.Players[kPlayer].CultBonusOn[14] then
										if jUnit:GetUnitCombatType() == GameInfoTypes.UNITCOMBAT_ARCHER then
											yBonusTab.Culture = yBonusTab.Culture + 10;
										end
									end
								end
								gT.Players[kPlayer].UnitsByID[jID].LastKillData = {GetITGGameTurn(), gT.Globals.LastPlayer}
							end
							local jUnitType = jUnit:GetUnitType();
							if KUDH[hID].IsRealCombat and (KUDH[hID].Domain == jUnit:GetDomainType()) and ValidDomainToCapture[KUDH[hID].Domain] then
								if Map.PlotDistance(jUnit:GetX(), jUnit:GetY(), unitX, unitY) < 2 then
									local basechance = 0;
									if KUDH[hID].Domain == dSea then
										if jUnitType == uPrivateer then
											basechance = basechance + 25;
										end
										if gT.Players[kPlayer].PiratePerks[2] then
											basechance = basechance + 15;
										end
									end
									if jUnitType == uGallowglass then
										if KUDH[hID].Mercenary then
											basechance = basechance + 50;
										else
											basechance = basechance + 8;
										end
									end
									if jUnit:IsHasPromotion(adm18) or jUnit:IsHasPromotion(gen20) then
										basechance = basechance + 5;
									end
									if jUnit:IsHasPromotion(GameInfoTypes.PROMOTION_ITG_MERCENARY_9) then
										basechance = basechance + 25;
									end
									if not barbKilled then
										if gT.Players[kPlayer].DomainCaptureChance[KUDH[hID].Domain] then
											basechance = basechance + gT.Players[kPlayer].DomainCaptureChance[KUDH[hID].Domain];
										end
										if gT.Players[kPlayer].CultBonusOn[178] then
											if KUDH[hID].Domain == dSea then
												basechance = basechance + 15;
											end
										end
										if gT.Players[kPlayer].CultBonusOn[179] then
											if KUDH[hID].UnitCombatType == ucSiege then
												basechance = basechance + 25;
											elseif LastChance(25) then
												if KUDH[hID].BatteringRam then
													if CanHaveBatteringRamSupport(jUnit, kPlayer, GameInfoTypes.PROMOTION_ITG_BATTERING_RAM_SUPPORT, true) then
														jUnit:SetHasPromotion(GameInfoTypes.PROMOTION_ITG_BATTERING_RAM_SUPPORT, true)
														if kPlayer == Game.GetActivePlayer() then
															Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(unitX, unitY))), Locale.Lookup(GameInfo.UnitPromotions[GameInfoTypes.PROMOTION_ITG_BATTERING_RAM_SUPPORT].Description), delay)
															delay = delay + 0.5;
														end
													end
												elseif KUDH[hID].SiegeTower then
													if CanHaveBatteringRamSupport(jUnit, kPlayer, GameInfoTypes.PROMOTION_ITG_SIEGE_TOWER_SUPPORT, true) then
														jUnit:SetHasPromotion(GameInfoTypes.PROMOTION_ITG_SIEGE_TOWER_SUPPORT, true)
														if kPlayer == Game.GetActivePlayer() then
															Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(unitX, unitY))), Locale.Lookup(GameInfo.UnitPromotions[GameInfoTypes.PROMOTION_ITG_SIEGE_TOWER_SUPPORT].Description), delay)
															delay = delay + 0.5;
														end
													end
												end
											end
										end
										if HasPlayerTech(kPlayer, innoANCtr7, "teddacewf") then 
											if KUDH[hID].Domain == dSea then
												basechance = basechance + 25;
											end
										end
										if HasPlayerTech(kPlayer, arabtrial2, "czczaeaedae") then
											if KUDH[hID].Domain == dSea then
												basechance = basechance + 33;
											end
										end
										if gT.Globals.ScenarioType == 4 then
											if KUDH[hID].UnitCombatType == ucSiege then
												basechance = basechance + 15;
											end
										end
										if gT.Players[kPlayer].HasIdeology[3] then
											if gT.Players[jPlayer] then
												basechance = basechance + math.max(0, -1 * gT.Players[jPlayer].Morale) + math.max(0, -1 * gT.Players[jPlayer].AverageHappiness)
											else
												basechance = basechance + 3;
											end
										end
									end
									if LastRandom(1, 100) <= basechance then
										-- capturing
										local cClass = GameInfoTypes[GameInfo.Units[KUDH[hID].UnitType].Class];
										if gT.Players[kPlayer].UnitClassXP[cClass] then
											if Players[kPlayer]:GetNumUnitsOutOfSupply() <= 0 then
												local bPlotToSpawnNewUnit = GetBestPlotToSpawnUnit(unitX, unitY, jUnit, jID, KUDH[hID].ITGID, KUDH[hID].UnitType, jPlayer);
												local cnUnit = Players[kPlayer]:InitUnit(KUDH[hID].UnitType, bPlotToSpawnNewUnit:GetX(), bPlotToSpawnNewUnit:GetY());
												cnUnit:SetMoves(0);
												cnUnit:SetDamage(LastRandom(50, 75))
												ITGSCNewUnitCreated(kPlayer, cnUnit, nil, false, nil, nil, false)
											end
										end
									else
										if gT.Players[kPlayer].PiratePerks[2] then
											if KUDH[hID].Domain == dSea then
												yBonusTab.Gold = yBonusTab.Gold + 15;
											end
										end
									end
								end
							end
							if gT.Players[kPlayer].HasIdeology[52] then
								if KUDH[hID].IsRealCombat then
									if IsGreatITGPerson(jUnit) then
										GeneralAdmiralRivalry(jUnit, 1)
									end
								end
							end
							if KUDH[hID].IsRamming then
								if KUDH[hID].UnitClass == jUnit:GetUnitClassType() then
									jUnit:SetDamage(jUnit:GetMaxHitPoints() - 1);
								end
							end
							if gT.Players[kPlayer].CultBonusOn[51] then
								if KUDH[hID].UnitClass == jUnit:GetUnitClassType() then
									if LastRandom(1, 2) == 2 then
										local iPromotion = GetValidPromToLearn(jUnit, kPlayer, jPlayer, KUDH[hID].UnitClass)
										if iPromotion then
											jUnit:SetHasPromotion(iPromotion, true)
											if kPlayer == Game.GetActivePlayer() then
												Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(unitX, unitY))), Locale.Lookup(GameInfo.UnitPromotions[iPromotion].Description), delay)
												delay = delay + 0.5;
											end
										end
									end
								end
							end
							if barbKilled then
								if HasPlayerTech(kPlayer, afro8, "czceadaedaeda") then
									if gT.Players[kPlayer].Morale < 10 then
										TakeCareOfEventMorale(kPlayer, 25, {1, "Warrior Spirit"})
										yBonusTab.Morale = yBonusTab.Morale + 1;
									end
								end
								if gT.Players[kPlayer].CultBonusOn[45] then
									if KUDH[hID].RebelAgainst == -1 then
										if LastChance(7) then
											gT.Players[kPlayer].NumFortPoints = gT.Players[kPlayer].NumFortPoints + 1;
											if kPlayer == Game.GetActivePlayer() then
												Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(unitX, unitY))), "+1 FORT", delay)
												delay = delay + 0.5;
												RefreshAllDirtyPlayer()
											end
										end
									end
								end
							end
							if HasPlayerTech(kPlayer, meso3, "Faaeratwer") then 
								DoIncrementInFearAuraMeso(jUnit, kPlayer)
							end
							if HasPlayerTech(kPlayer, GameInfoTypes.TECH_UNIQUE_ITG_MEDIEVAL_AFR_6, "vefsed") then
								if bMeleeKill and (Players[kPlayer]:IsTurnActive()) then
									local stres = KUDH[hID].Str * 10 + KUDH[hID].Level;
									for sUnit in Players[jPlayer]:Units() do
										if Map.PlotDistance(sUnit:GetX(), sUnit:GetY(), unitX, unitY) == 1 then
											if (not IsImmuneDoDemoralize(sUnit)) then
												local sSstr = math.max(sUnit:GetBaseCombatStrength(true), sUnit:GetBaseRangedCombatStrength()) * 10 + sUnit:GetLevel();
												if sSstr < stres then
													sUnit:SetDemoralized(true);
													if kPlayer == Game.GetActivePlayer() or (jPlayer == Game.GetActivePlayer()) then
														Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(sUnit:GetX(), sUnit:GetY()))), "[ICON_DENOUNCE]", 0.5)
													end
												end
											end
										end
									end
								end
							end
							if jUnit:IsHasPromotion(GameInfoTypes.PROMOTION_ITG_SEVEN_SEAS_6) then
								if bMeleeKill and (Players[kPlayer]:IsTurnActive()) then
									for i = 0, 5 do
										local nhPlot = Map.PlotDirection(unitX, unitY, i)
										if nhPlot then
											DoPirateDemoralizeArea(nhPlot, kPlayer)
										end
									end
								end
								local bRthV = DoPirateDemoralizeArea(Map.GetPlot(unitX, unitY), kPlayer) 
								if (kPlayer == Game.GetActivePlayer()) or (bRthV == Game.GetActivePlayer()) then
									Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(unitX, unitY))), "[ICON_DENOUNCE]", delay)
									delay = delay + 0.5;
								end
							end
							if HasPlayerTech(kPlayer, tAncientTR14, "juyiyutrsfer") then 
								if bMeleeKill then
									jUnit:ChangeExtraTemporaryDefense(200)
								end
							end
							if jUnit:IsHasPromotion(gen13x2) or jUnit:IsHasPromotion(adm11x2) then
								yBonusTab.XP = yBonusTab.XP + 8;
							end
							if jUnit:IsHasPromotion(gen15) or jUnit:IsHasPromotion(adm13) then 
								yBonusTab.LegalPower = yBonusTab.LegalPower + 5;
							end
							if jUnitType == GameInfoTypes.UNIT_ITG_AOT_ARCHER_EGYPT then
								yBonusTab.Faith = yBonusTab.Faith + math.ceil(KUDH[hID].Str/ 2);
							elseif jUnitType == GameInfoTypes.UNIT_ITG_AOT_SWORDSMAN_UU_8 then
								yBonusTab.Faith = yBonusTab.Faith + math.ceil(KUDH[hID].Str);
							elseif jUnitType == GameInfoTypes.UNIT_ITG_AOT_WARRIOR_UU_0 then
								yBonusTab.Faith = yBonusTab.Faith + math.ceil(KUDH[hID].Str);
							elseif jUnitType == GameInfoTypes.UNIT_ITG_NW_AZTEC_JAGUAR then
								DemoralizeAdjacentEnemiesWithChance(unitX, unitY, kPlayer, 35)
							elseif jUnitType == GameInfoTypes.UNIT_ITG_AOT_SPEARMAN_EGYPT then
								yBonusTab.Wonder = yBonusTab.Wonder + math.ceil(KUDH[hID].Str/ 2);
							elseif jUnitType == GameInfoTypes.UNIT_ITG_TRIAL_LONGSWORDSMAN_5 then
								yBonusTab.Culture = yBonusTab.Culture + math.ceil(KUDH[hID].Str / 2);
								yBonusTab.Art = yBonusTab.Art +  math.ceil(KUDH[hID].Str / 2);
							elseif jUnitType == GameInfoTypes.UNIT_ITG_TANK_UU_9 then
								if KUDH[hID].UnitCombatType == GameInfoTypes.UNITCOMBAT_ARMOR then
									jUnit:ChangeDamage(-33)
								end
							elseif jUnitType == GameInfoTypes.UNIT_ITG_AOT_HORSEMAN_UU_6 then
								yBonusTab.Art = yBonusTab.Art + KUDH[hID].Str;
							elseif jUnitType == GameInfoTypes.UNIT_ITG_AOT_SWORDSMAN_GAL then
								jUnit:ChangeMaxHitPoints(5)
							elseif jUnitType == GameInfoTypes.UNIT_ITG_TRIAL_HORSEMAN_4 then
								if GetITGGameTurn() ~= gT.Players[kPlayer].AndalusianCD then
									if GetITGReligion(kPlayer) ~= GetITGReligion(jPlayer) then
										gT.Players[kPlayer].AndalusianCD = GetITGGameTurn();
										TakeCareOfEventMorale(kPlayer, 25, {1, "Andalusian Cavalry"})
										yBonusTab.Morale = yBonusTab.Morale + 1;
									end
								end
							end
							if gT.Players[kPlayer].UnitsByID[jID] then
								if gT.Players[kPlayer].UnitsByID[jID].IsKing then
									yBonusTab.Power = yBonusTab.Power + 5;
									BoostPlayerPower(kPlayer, "Warrior King", 5)
								end
								if gT.Players[kPlayer].UnitsByID[jID].GreatPersonID then
									if HasPlayerTech(kPlayer, meso8, "casdaweawr") then
										if LastChance(25) then
											yBonusTab.Faith = yBonusTab.Faith + KUDH[hID].Str * 2;
										end
									end
								end
							end
							if jUnit:IsHasPromotion(adm24) or jUnit:IsHasPromotion(gen27) then
								yBonusTab.Presence = yBonusTab.Presence + KUDH[hID].Str;
								yBonusTab.PresenceRange = math.max(yBonusTab.PresenceRange, 5);
							end
							if HasPlayerTech(kPlayer, tite3, "Daedadeaed") then
								if bMeleeKill and LastChance(20) then
									yBonusTab.Culture = yBonusTab.Culture + 5 * KUDH[hID].Str
								end
							end
							if jUnit:IsHasPromotion(GameInfoTypes.PROMOTION_ITG_MERCENARY_22) then
								yBonusTab.Gold = yBonusTab.Gold + KUDH[hID].Str;
							end
							if jUnit:IsHasPromotion(GameInfoTypes.PROMOTION_ITG_MERCENARY_23) then
								yBonusTab.WorkRate = yBonusTab.WorkRate + KUDH[hID].Str;
							end
							if gT.Players[kPlayer].HasIdeology[58] and LastChance(20) then
								yBonusTab.Science = yBonusTab.Science + 5 * KUDH[hID].Str;
							end
							if gT.Players[kPlayer].HasIdeology[66] then
								if LastChance(25) then
									yBonusTab.Mint = yBonusTab.Mint + math.floor(KUDH[hID].Str)
								end
							end
							if Players[kPlayer]:IsHuman() then
								DoOnUnitKillCheckAchievement(kPlayer, jUnit, KUDH[hID].UnitType, KUDH[hID].UnitClass, jPlayer, KUDH[hID].RebelAgainst)
							end
						end
						local relModFaithBeliefs = RelBeliefsFaithOnKill(kPlayer, Map.GetPlot(unitX, unitY))
						if relModFaithBeliefs > 0 then
							yBonusTab.Faith = yBonusTab.Faith + math.ceil(KUDH[hID].Str * relModFaithBeliefs);
						end
						if gT.Players[kPlayer].CultBonusOn[28] then
							if LastChance(25) then
								yBonusTab.Gold = yBonusTab.Gold + math.ceil(KUDH[hID].Str * 3);
							end
						end
						if HasPlayerTech(kPlayer, ancCSinno2, "Gefd") then
							if LastChance(20) then
								yBonusTab.Art = yBonusTab.Art + math.ceil(KUDH[hID].Str * 3);
							end
						end
						if HasPlayerTech(kPlayer, titv6, "BAdaeae") then
							if LastChance(25) then
								yBonusTab.Faith = yBonusTab.Faith + KUDH[hID].Str * 2;
							end
							if (bMeleeKill) and (jUnit) then
								jUnit:ChangeMaxHitPoints(7)
							end
						end
						if HasPlayerTech(kPlayer, titv8, "caadaweqwe") then
							gT.Players[kPlayer].FestivalVarious = gT.Players[kPlayer].FestivalVarious + 1;
						end
						if HasPlayerTech(kPlayer, tiaemp9, "kkdeadae") then
							if Players[jPlayer]:IsBarbarian() then
								yBonusTab.Culture = yBonusTab.Culture + KUDH[hID].Str;
							end
						end
						if gT.Players[kPlayer].GovRewards[8] then
							if LastChance(15) then
								yBonusTab.LegalPower = yBonusTab.LegalPower + math.ceil(KUDH[hID].Str / 2);
							end
						end
						if gT.Players[kPlayer].GovRewards[51] then
							if LastChance(15) then
								yBonusTab.Faith = yBonusTab.Faith + 3 * KUDH[hID].Str;
							end
						end
						if gT.Players[kPlayer].CultBonusOn[51] then
							if LastChance(10) then
								if IsUnitClassValidToBeUnlocked(kPlayer, Teams[Players[kPlayer]:GetTeam()], {[jPlayer] = true}, KUDH[hID].UnitClass) then
									DoUnlockUnitClass(kPlayer, KUDH[hID].UnitClass, "Social")
								end
							end
						end
						if gT.Players[kPlayer].CultBonusOn[137] then
							if LastChance(20) then
								yBonusTab.GreatPeople = yBonusTab.GreatPeople + KUDH[hID].Str;
							end
						end
						if IsWithinProperDistanceForKillingBeliefBonus(unitX, unitY, rbifol36, kPlayer, 4) then
							yBonusTab.LegalPower = yBonusTab.LegalPower + math.ceil(KUDH[hID].Str / 10);
						end
						if IsWithinProperDistanceForKillingBeliefBonus(unitX, unitY, rbifol37, kPlayer, 4) then
							yBonusTab.Gold = yBonusTab.Gold + math.ceil(KUDH[hID].Str);
						end
						if IsWithinProperDistanceForKillingBeliefBonus(unitX, unitY, rbifol38, kPlayer, 4) then
							yBonusTab.Culture = yBonusTab.Culture + math.ceil(KUDH[hID].Str / 2);
						end
						if HasPlayerTech(kPlayer, innoAncientPatriotism, "Vdfsade") then
							if LastChance(20) then
								if Players[kPlayer]:GetNumCities() < Players[jPlayer]:GetNumCities() then
									yBonusTab.Meritocracy = yBonusTab.Meritocracy + 5; 
								end
							end
						end
						if gT.Players[kPlayer].CultBonusOn[132] then
							if SpreadPresenceToAnyOccupiedCity(kPlayer, jPlayer, KUDH[hID].Str) then
								if kPlayer == Game.GetActivePlayer() then
									Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(unitX, unitY))), "+" .. KUDH[hID].Str .. " [ICON_ITG_PRESENCE]", delay)
									delay = delay + 0.5;
								end
							end
						end
						if HasPlayerTech(kPlayer, tinm4, "Vsfwerqwe") then 
							if LastChance(25) then
								yBonusTab.Food = yBonusTab.Food + KUDH[hID].Str * 2;
							end
						end
						if IsWithinProperDistanceForHappinessBeliefBonus(unitX, unitY, rbifol39, kPlayer, 4) then
							yBonusTab.Happiness = yBonusTab.Happiness + 1;
						end
						if HasPlayerTech(kPlayer, tina2, "ywerqweqw") then
							local iKabukiTheatre = Players[kPlayer]:GetBuildingClassCount(GameInfoTypes.BUILDINGCLASS_ITG_KABUKI_BUSHIDO);
							for ijok = 1, iKabukiTheatre do
								if LastChance(10) then
									yBonusTab.GreatPeople = yBonusTab.GreatPeople + KUDH[hID].Str;
								end
							end
						end
						if gT.Players[kPlayer].HasPlayerWonder[GameInfoTypes.BUILDING_ITG_NEW_MEDIEVAL_WONDER_13] then
							if LastChance(25) then
								yBonusTab.Presence = yBonusTab.Presence + KUDH[hID].Str * 2;
								yBonusTab.PresenceRange = math.max(yBonusTab.PresenceRange, 5);
							end
						end
						if gT.Players[kPlayer].CultBonusOn[143] then
							if gT.Players[jPlayer] then
								if gT.Players[jPlayer].UnitsByID[deaduID] then
									if gT.Players[jPlayer].UnitsByID[deaduID].RedTempMaxHP then
										yBonusTab.XP = yBonusTab.XP + 10;
									end
								end
							end
						end
						if gT.Players[kPlayer].CultBonusOn[86] then
							if LastChance(25) then
								yBonusTab.WorkRate = yBonusTab.WorkRate + KUDH[hID].Str * 8;
							end
						end
						--CALL
						for a, gfunc in pairs(gf_OnUnitKilledInCombat) do
							for c, d in pairs(gfunc(jPlayer, kPlayer, unitX, unitY, jUnit, KUDH[hID], bMeleeKill)) do
								yBonusTab[c] = yBonusTab[c] + d;
							end
						end
						--APPLY bonuses
						if yBonusTab.WorkRate > 0 then
							local cityID = GetClosestCityIDToPlotOrNil(kPlayer, Map.GetPlot(unitX, unitY))
							if cityID then
								local tCity = Players[kPlayer]:GetCityByID(cityID);
								ChangeITGWorkRate(tCity, yBonusTab.WorkRate)
								if kPlayer == Game.GetActivePlayer() then
									Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(unitX, unitY))), "+" .. yBonusTab.WorkRate .. " [ICON_WORKER]", delay)
									delay = delay + 0.5;
								end
							end
						end
						if yBonusTab.Presence > 0 then
							if DoSpreadCulturalPresenceInRange(kPlayer, yBonusTab.Presence, unitX, unitY, yBonusTab.PresenceRange) then
								if kPlayer == Game.GetActivePlayer() then
									Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(unitX, unitY))), "+" .. yBonusTab.Presence .. " [ICON_ITG_PRESENCE]", delay)
									delay = delay + 0.5;
								end
							end
						end
						if yBonusTab.Meritocracy > 0 then
							ChangeMeritocracy(kPlayer, yBonusTab.Meritocracy);
							if kPlayer == Game.GetActivePlayer() then
								Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(unitX, unitY))), "+" .. yBonusTab.Meritocracy .. " [ICON_ITG_MERITOCRACY]", delay)
								delay = delay + 0.5;
							end
						end
						if yBonusTab.GreatWork > 0 then
							CreateGreatWorkOfAmount(kPlayer, yBonusTab.GreatWork)
							if kPlayer == Game.GetActivePlayer() then
								Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(unitX, unitY))), "+" .. yBonusTab.GreatWork .. " [ICON_GREAT_WORK]", delay)
								delay = delay + 0.5;
							end
						end
						if yBonusTab.Science > 0 then
							ChangeITGScience(kPlayer, yBonusTab.Science)
							if kPlayer == Game.GetActivePlayer() then
								Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(unitX, unitY))), "+" .. yBonusTab.Science .. " [ICON_RESEARCH]", delay)
								delay = delay + 0.5;
							end
						end
						if yBonusTab.Art > 0 then
							BoostArtisticPoints(kPlayer, yBonusTab.Art, false)
							if kPlayer == Game.GetActivePlayer() then
								Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(unitX, unitY))), "+" .. yBonusTab.Art .. " [ICON_GREAT_ARTIST]", delay)
								delay = delay + 0.5;
							end
						end
						if yBonusTab.Morale > 0 then
							if kPlayer == Game.GetActivePlayer() then
								Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(unitX, unitY))), "+" .. yBonusTab.Morale .. " [ICON_ITG_MORALE]", delay)
								delay = delay + 0.5;
							end
						end
						if yBonusTab.Power > 0 then
							if kPlayer == Game.GetActivePlayer() then
								Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(unitX, unitY))), "+" .. yBonusTab.Power .. " [ICON_ITG_POWER]", delay)
								delay = delay + 0.5;
							end
						end
						if yBonusTab.Faith > 0 then
							ChangeITGFaith(kPlayer, yBonusTab.Faith)
							if kPlayer == Game.GetActivePlayer() then
								Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(unitX, unitY))), "+" .. yBonusTab.Faith .. " [ICON_PEACE]", delay)
								delay = delay + 0.5;
							end
						end
						if yBonusTab.LegalPower > 0 then
							ChangeITGLegalPointsPercent(kPlayer, yBonusTab.LegalPower, nil, "OnUnitKilled")
							if kPlayer == Game.GetActivePlayer() then
								Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(unitX, unitY))), "+" .. yBonusTab.LegalPower/100 .. " [ICON_ITG_LEGAL_POWER]", delay)
								delay = delay + 0.5;
							end
						end
						if yBonusTab.Wonder > 0 then
							if gT.Players[kPlayer].CanWonderRace then
								BoostWonderProduction(kPlayer, yBonusTab.Wonder, false)
								if kPlayer == Game.GetActivePlayer() then
									Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(unitX, unitY))), "+" .. yBonusTab.Wonder .. " [ICON_GREAT_ENGINEER]", delay)
									delay = delay + 0.5;
								end
							end
						end
						if yBonusTab.Gold > 0 then
							ChangeITGGold(kPlayer, yBonusTab.Gold)
							if kPlayer == Game.GetActivePlayer() then
								Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(unitX, unitY))), "+" .. yBonusTab.Gold .. " [ICON_GOLD]", delay)
								delay = delay + 0.5;
							end
						end
						if yBonusTab.Culture > 0 then
							ChangeITGCulture(kPlayer, yBonusTab.Culture)
							if kPlayer == Game.GetActivePlayer() then
								Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(unitX, unitY))), "+" .. yBonusTab.Culture .. " [ICON_CULTURE]", delay)
								delay = delay + 0.5;
							end
						end
						if yBonusTab.Settler > 0 then
							ChangeITGSettlerPoints(kPlayer, yBonusTab.Settler)
							if kPlayer == Game.GetActivePlayer() then
								Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(unitX, unitY))), "+" .. yBonusTab.Settler .. " [ICON_ITG_SETTLER]", delay)
								delay = delay + 0.5;
							end
						end
						if yBonusTab.Happiness > 0 then
							if kPlayer == Game.GetActivePlayer() then
								Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(unitX, unitY))), "+" .. yBonusTab.Happiness .. " [ICON_HAPPINESS_1]", delay)
								delay = delay + 0.5;
							end
						end
						if yBonusTab.Food > 0 then
							if GetFoodBonusToNearestCity(kPlayer, unitX, unitY, yBonusTab.Food) > 0 then
								if kPlayer == Game.GetActivePlayer() then
									Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(unitX, unitY))), "+" .. yBonusTab.Food .. " [ICON_FOOD]", delay)
									delay = delay + 0.5;
								end
							end
						end
						if yBonusTab.Mint > 0 then
							if CanHaveMintPower(kPlayer) then
								DoAddTemporalCurrencyPower(kPlayer, yBonusTab.Mint)
								if kPlayer == Game.GetActivePlayer() then
									Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(unitX, unitY))), "+" .. yBonusTab.Mint .. " [ICON_INVEST]", delay)
									delay = delay + 0.5;
								end
							end
						end
						if yBonusTab.GreatPeople > 0 then
							ChangeITGGreatPeopleCivilPoints(kPlayer, yBonusTab.GreatPeople)
							if kPlayer == Game.GetActivePlayer() then
								Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(unitX, unitY))), "+" .. yBonusTab.GreatPeople .. " [ICON_GREAT_PEOPLE]", delay)
								delay = delay + 0.5;
							end
						end
						if (yBonusTab.XP > 0) and jUnit then
							jUnit:ChangeExperience(yBonusTab.XP)
						end
						gT.Players[kPlayer].UnitKilled = gT.Players[kPlayer].UnitKilled + 1;
						gT.Players[kPlayer].Ideo78DataTracking[6] = gT.Players[kPlayer].Ideo78DataTracking[6] + 1;
					end
				end
			end
			if kPlayer ~= jPlayer then
				-- logging piracy naval kill
				if KUDH[hID].Domain == dSea then
					NavalUnitSinked(jPlayer)
				end
	-- on death in combat effects?
				if KUDH[hID].UnitType == GameInfoTypes.UNIT_ITG_AOT_WARRIOR_BRUTE then
					if LastChance(25) then
						DoTryToSpawnUnitInUndamagedCity(jPlayer, GameInfoTypes.UNIT_ITG_AOT_WARRIOR_BRUTE);
					end
				end
			end
			if gT.Players[jPlayer] then
				if kPlayer ~= jPlayer then
					if not CivilianClasses[KUDH[hID].UnitClass] then
						if gT.Players[jPlayer].UnitClassXP[KUDH[hID].UnitClass] then
							if gT.Players[jPlayer].CultBonusOn[61] then
								if LastRandom(1, 100) <= 17 then
									table.insert(gT.Players[jPlayer].GhostUnits, {KUDH[hID].UnitType, unitX, unitY, GetITGGameTurn() + 2})
								end
							end
							gT.Players[jPlayer].UnitLost = gT.Players[jPlayer].UnitLost + 1;
							gT.Players[jPlayer].Ideo78DataTracking[8] = gT.Players[jPlayer].Ideo78DataTracking[8] + 1;
							gT.Players[jPlayer].AIhateValues[kPlayer] = gT.Players[jPlayer].AIhateValues[kPlayer] + 2;
							--killed player bonuses
							if gT.Players[jPlayer].CultBonusOn[12] then
								if LastChance(15) then
									CreateGreatWorkOfAmount(jPlayer, 1)
									if jPlayer == Game.GetActivePlayer() then
										Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(unitX, unitY))), "+1 [ICON_GREAT_WORK]", delay)
										delay = delay + 0.5;
									end
								end
								local hTab = {}
								for iUnit in Players[jPlayer]:Units() do
									if iUnit:GetDamage() > 0 and (iUnit:GetDamage() < iUnit:GetMaxHitPoints()) and (iUnit:GetID() ~= KUDH[hID].UnitID) then
										if Map.PlotDistance(iUnit:GetX(), iUnit:GetY(), unitX, unitY) < 2 then
											if IsRealCombatUnit(iUnit) then
												table.insert(hTab, {iUnit, iUnit:GetDamage()})
											end
										end
									end
								end
								table.sort(hTab, SortFunctionForGreaterInteger2);
								local hPleft = 50;
								for i, data in pairs(hTab) do
									local amHeal = math.min(hPleft, data[2]);
									data[1]:ChangeDamage(- amHeal);
									hPleft = hPleft - amHeal;
									if hPleft <= 0 then
										break;
									end
								end
							end
						end
					else
						gT.Players[jPlayer].AIhateValues[kPlayer] = gT.Players[jPlayer].AIhateValues[kPlayer] + 1;
					end
				end
				if gT.Players[jPlayer].UnitsByID[deaduID] then
					if gT.Players[jPlayer].UnitsByID[deaduID].TargetAdjacent then
						CaravanTradeCargoKilled(jPlayer, unitX, unitY, delay, deaduID, KUDH[hID].UnitType, kPlayer, jUnit)
					end
				end
			end
		end
		KUDH[hID] = nil;
	end
end

function UnitKillingImportantStuffThatAlwaysHaveToBeFired(bUnit, unitX, unitY, jPlayer, unitId, bMayBeScrap, ePlayer, nukeMod, unitType)
	local dUnit = Players[jPlayer]:GetUnitByID(unitId);
	local jID = unitId .. "," .. jPlayer .. "," .. dUnit:GetGameTurnCreated()
	if gT.Players[jPlayer] then
		if dUnit:IsHasPromotion(promEngRoads) then
			gT.Players[jPlayer].NumMilitaryEngineers = gT.Players[jPlayer].NumMilitaryEngineers + 1;
		end
		if gT.Players[jPlayer].UnitsByID[jID] then
			if gT.Players[jPlayer].UnitsByID[jID].GeneralName then
				PlayerKilledGeneral(jPlayer, jID, Map.GetPlot(unitX, unitY), bMayBeScrap, ePlayer, nukeMod, unitType)
			elseif gT.Players[jPlayer].UnitsByID[jID].AdmiralName then
				PlayerKilledAdmiral(jPlayer, jID, Map.GetPlot(unitX, unitY), bMayBeScrap, ePlayer, nukeMod, unitType)
			end
			if gT.Players[jPlayer].UnitsByID[jID].IsKing then
				gT.Players[jPlayer].KingUnitAlive = false;
			end
		end
	end
	-- still caravans might not be logged into log, but phew
end

function CaravanTradeCargoKilled(jPlayer, unitX, unitY, idelay, jID, unitType, kPlayer, jUnit, bForceGold)
	if gT.Players[jPlayer].UnitsByID[jID].Pilgrim then	
		PilgrimKilled(jPlayer, unitX, unitY, idelay, jID, unitType, kPlayer, jUnit, bForceGold)
		return;
	end
	local delay = idelay;
	local iGoldFromInsurance = gT.Players[jPlayer].UnitsByID[jID].Insurance or 0;
	if gT.Players[jPlayer].CultBonusOn[124] then
		iGoldFromInsurance = iGoldFromInsurance + 50;
	end
	if iGoldFromInsurance > 0 then
		ChangeITGGold(jPlayer, iGoldFromInsurance)
		if jPlayer == Game.GetActivePlayer() then
			Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(unitX, unitY))), "+" .. iGoldFromInsurance .."[ICON_GOLD]", delay)
			delay = delay + 0.5;
		end
	end
	gT.Players[jPlayer].LastTurnTRorPlunder = GetITGGameTurn();
	gT.Players[jPlayer].HapGuaranteeFunds = 0;
	local logTab = {DomainType = 2, From = gT.Players[jPlayer].UnitsByID[jID].OriginTrade,
					FromPlayer = jPlayer,
					To = gT.Players[jPlayer].UnitsByID[jID].TargetAdjacent,
					ToPlayer =  Map.GetPlotByIndex(gT.Players[jPlayer].UnitsByID[jID].TargetAdjacent):GetOwner(),
					Killed = true,
					Turn = GetITGGameTurn()}
	local goldbonus = 100;
	local isLand = (unitType == uCaravan);
	if isLand then
		goldbonus = goldbonus - 50;
		logTab.DomainType = 1;
		DoIncreasementStockExchange(8, -1)
	else
		DoIncreasementStockExchange(9, -1)
		PirateLogCargoDown(jPlayer, kPlayer)
	end
	CaravanTakenDownCSQuestLog(kPlayer, jPlayer, isLand)
	table.insert(gT.Globals.TradeRouteLog, logTab)
	local iCity = Map.GetPlotByIndex(gT.Players[jPlayer].UnitsByID[jID].TargetAdjacent):GetPlotCity()
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local fCity = Map.GetPlotByIndex(gT.Players[jPlayer].UnitsByID[jID].OriginTrade):GetPlotCity()
	local fcID = fCity:Plot():GetPlotIndex() .. "," .. fCity:GetGameTurnFounded();
	table.insert(gT.Players[jPlayer].TradeRoutesLost, {GetITGGameTurn(), iCity:Plot():GetPlotIndex(), iCity:GetOwner(), fCity:Plot():GetPlotIndex(), unitType})
	if gT.Players[kPlayer] then
		if bForceGold or (jUnit and ((jUnit:GetDomainType() == dSea and (not isLand)) or (isLand and jUnit:GetDomainType() == dLand))) then
			TakeCareOfEventMorale(kPlayer, 19)
			local norigCity = GetNewManagementOriginCity(kPlayer, iCity, unitX, unitY, isLand)
			if norigCity then
				local nmUnit, nmuID, nmcID = CreateTradeUnit(norigCity, kPlayer, unitType, unitX, unitY, iCity)
				nmUnit:SetMoves(0);
			else
				if gT.Players[kPlayer].PiratePerks[7] then
					goldbonus = goldbonus + 50;
				end
				if gT.Players[kPlayer].PiratePerks[8] then
					goldbonus = goldbonus + 50;
				end
				if jUnit then
					if jUnit:GetUnitClassType() == ucSubmarine then
						if HasPlayerTech(kPlayer, timodern7, "kdaodef") then
							jUnit:ChangeExperience(10);
						end
					end
					for a, gfunc in pairs(gf_TradeRoutePlundered) do
						gfunc(jUnit, kPlayer, unitX, unitY, jPlayer, isLand)
					end
				end
				ChangeITGGold(kPlayer, goldbonus)
				if kPlayer == Game.GetActivePlayer() then
					Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(unitX, unitY))), goldbonus .. " [ICON_GOLD]", delay)
					delay = delay + 0.5;
				end
			end
		end
		DoLogDominationEvent(-1, kPlayer, jPlayer, 5, -3)
		VictoryTaskCompletion(kPlayer, 62)
	end
end

function RemoveUnitFromGeneralTable(genID, jID, jPlayer)
	local key;
	for it, uID in pairs(gT.Players[jPlayer].Generals[genID].Units) do
		if uID == jID then
			key = it;
		end
	end
	if key then
		table.remove(gT.Players[jPlayer].Generals[genID].Units, key)
	end
end

function IsValidToTakeBackColonyHolySiteFort(nPlayer, pOwner)
	if pOwner then
		if nPlayer ~= pOwner then
			if Players[pOwner]:IsAlive() then
				local pTeam = Teams[Players[nPlayer]:GetTeam()];
				local iTeam = Players[pOwner]:GetTeam();
				if pTeam:IsHasMet(iTeam) and (not pTeam:IsAtWar(iTeam)) then
					return true
				end
			end
		end
	end
	return false
end

function ColonyTakeOver(nPlayer, jPlayer, iColPlot, bFriendly, rUnit)
	if iColPlot:GetOwner() == jPlayer then
		local index = iColPlot:GetPlotIndex()
		if not bFriendly then
			if Players[jPlayer]:IsBarbarian() then
				local pOwner = gT.Colonies[iColPlot:GetPlotIndex()].PreBarbPlayer;
				if IsValidToTakeBackColonyHolySiteFort(nPlayer, pOwner) then
					ColonyTakeOver(pOwner, jPlayer, iColPlot)
					SpecialPlotReturned(pOwner, nPlayer, "Colony", iColPlot)
					return;
				end
			end
			if gT.Colonies[index].ControlPlayer then
				if gT.Colonies[index].ControlPlayer ~= jPlayer then
					if IsValidToTakeBackColonyHolySiteFort(nPlayer, gT.Colonies[index].ControlPlayer) then
						ColonyTakeOver(gT.Colonies[index].ControlPlayer, jPlayer, iColPlot)
						SpecialPlotReturned(gT.Colonies[index].ControlPlayer, nPlayer, "Colony", iColPlot)
						return;
					end
				end
			end
			if Players[nPlayer]:IsBarbarian() then
				 gT.Colonies[iColPlot:GetPlotIndex()].PreBarbPlayer = jPlayer;
			end
			if gT.Players[nPlayer] then
				gT.Players[nPlayer].AIhateValues[jPlayer] = gT.Players[nPlayer].AIhateValues[jPlayer] + 1;
				gT.Colonies[iColPlot:GetPlotIndex()].UnitRebornTurns = gT.Players[nPlayer].BaseUnitRebornTurns;
			else
				gT.Colonies[iColPlot:GetPlotIndex()].UnitRebornTurns = 0;
			end		
			if gT.Players[jPlayer] then
				gT.Players[jPlayer].AIhateValues[jPlayer] = gT.Players[jPlayer].AIhateValues[nPlayer] + 1;
			end
			iColPlot:SetImprovementPillaged(true);
			ConquerSpecialPlotBonuses(nPlayer, iColPlot, rUnit)
		else
			local unittab = {}
			for i = 0, iColPlot:GetNumUnits() -1 do
				local iUnit = iColPlot:GetUnit(i);
				local jID = iUnit:GetID() .. "," .. iUnit:GetOwner() .. "," .. iUnit:GetGameTurnCreated();
				if gT.ColoniesByUnitID[jID] == index then
					table.insert(unittab, iUnit)
				end
			end			
			for i, iUnit in pairs(unittab) do
				local iDmg = iUnit:GetDamage();
				iUnit:Kill(true, iUnit:GetOwner()) -- should be ignore by on kill function
				SpawnColonyUnit(nPlayer, iColPlot, iDmg)
			end
			if #unittab > 0 then
				MakeJumpAwayFromSpecialPoint(nPlayer, iColPlot)
			end
		end
		gT.Colonies[index].Player = nPlayer;
		local cityID = GetClosestCityIDToPlotOrNil(nPlayer, iColPlot);
		iColPlot:SetOwner(nPlayer, cityID)
	end
end

function HolySiteTakeOver(nPlayer, jPlayer, iColPlot, bForce, bFriendly, rUnit)
	if iColPlot:GetOwner() == jPlayer then
		if (not bForce) then
			if gT.Players[jPlayer] then
				if gT.Players[jPlayer].HasPlayerWonder[medwonder9] then
					return;
				end
			end
		end
		local index = iColPlot:GetPlotIndex();
		if not bFriendly then
			if Players[jPlayer]:IsBarbarian() then
				local pOwner = gT.HolySites[index].PreBarbPlayer;
				if IsValidToTakeBackColonyHolySiteFort(nPlayer, pOwner) then
					HolySiteTakeOver(pOwner, jPlayer, iColPlot, bForce)
					SpecialPlotReturned(pOwner, nPlayer, "Holy Site", iColPlot)
					return;
				end
			end
			if gT.HolySites[index].ControlPlayer then
				if gT.HolySites[index].ControlPlayer ~= jPlayer then
					if IsValidToTakeBackColonyHolySiteFort(nPlayer, gT.HolySites[index].ControlPlayer) then
						HolySiteTakeOver(gT.HolySites[index].ControlPlayer, jPlayer, iColPlot, bForce)
						SpecialPlotReturned(gT.HolySites[index].ControlPlayer, nPlayer, "Holy Site", iColPlot)
						return;
					end
				end
			end
			if Players[nPlayer]:IsBarbarian() then
				 gT.HolySites[index].PreBarbPlayer = jPlayer;
			end		
			if gT.Players[nPlayer] then
				gT.Players[nPlayer].AIhateValues[jPlayer] = gT.Players[nPlayer].AIhateValues[jPlayer] + 1;
				gT.HolySites[index].UnitRebornTurns = gT.Players[nPlayer].BaseUnitRebornTurns;
			else
				gT.HolySites[index].UnitRebornTurns = 0;
			end		
			if gT.Players[jPlayer] then
				gT.Players[jPlayer].AIhateValues[jPlayer] = gT.Players[jPlayer].AIhateValues[nPlayer] + 1;
			end
			iColPlot:SetImprovementPillaged(true);
			ConquerSpecialPlotBonuses(nPlayer, iColPlot, rUnit)
		else
			local unittab = {}
			for i = 0, iColPlot:GetNumUnits() -1 do
				local iUnit = iColPlot:GetUnit(i);
				local jID = iUnit:GetID() .. "," .. iUnit:GetOwner() .. "," .. iUnit:GetGameTurnCreated();
				if gT.HolySitesUnits[jID] == index then
					table.insert(unittab, iUnit)
				end
			end			
			for i, iUnit in pairs(unittab) do
				local iDmg = iUnit:GetDamage();
				iUnit:Kill(true, iUnit:GetOwner()) -- should be ignore by on kill function
				SpawnHolySiteUnit(nPlayer, iColPlot, iDmg)
			end
			if #unittab > 0 then
				MakeJumpAwayFromSpecialPoint(nPlayer, iColPlot)
			end
		end
		gT.HolySites[index].Player = nPlayer;
		local cityID = GetClosestCityIDToPlotOrNil(nPlayer, iColPlot);
		iColPlot:SetOwner(nPlayer, cityID)
		DoUpdatePressureOfHolySite(index)
		RefreshReligionLabelOnPlot(index)
	end
end

function ElDoradoTakeOver(nPlayer, jPlayer, iColPlot, bFriendly)
	if iColPlot:GetOwner() == jPlayer then
		local index = iColPlot:GetPlotIndex()
		if not bFriendly then
			if Players[jPlayer]:IsBarbarian() then
				local pOwner = gT.ElDorados[index].PreBarbPlayer;
				if IsValidToTakeBackColonyHolySiteFort(nPlayer, pOwner) then
					ElDoradoTakeOver(pOwner, jPlayer, iColPlot)
					return;
				end
			end
			if gT.ElDorados[index].ControlPlayer then
				if gT.ElDorados[index].ControlPlayer ~= jPlayer then
					if IsValidToTakeBackColonyHolySiteFort(nPlayer, gT.ElDorados[index].ControlPlayer) then
						ElDoradoTakeOver(gT.ElDorados[index].ControlPlayer, jPlayer, iColPlot)
						return;
					end
				end
			end
			if Players[nPlayer]:IsBarbarian() then
				 gT.ElDorados[index].PreBarbPlayer = jPlayer;
			elseif Players[nPlayer]:IsHuman() then
				LuaEvents.ITG_AchievementCompleted(55)
			end
		end
		--so far so good
		if bFriendly then
			local unittab = {}
			for i = 0, iColPlot:GetNumUnits() -1 do
				local iUnit = iColPlot:GetUnit(i);
				local jID = iUnit:GetID() .. "," .. iUnit:GetOwner() .. "," .. iUnit:GetGameTurnCreated();
				if gT.ElDoradoByUnitID[jID] == index then
					table.insert(unittab, iUnit)
				end
			end			
			for i, iUnit in pairs(unittab) do
				local iDmg = iUnit:GetDamage();
				iUnit:Kill(true, iUnit:GetOwner()) -- should be ignore by on kill function
				SpawnElDoradoUnit(nPlayer, iColPlot, iDmg)
			end
			if #unittab > 0 then
				MakeJumpAwayFromSpecialPoint(nPlayer, iColPlot)
			end
			gT.ElDorados[index].Player = nPlayer;
			local cityID = GetClosestCityIDToPlotOrNil(nPlayer, iColPlot);
			iColPlot:SetOwner(nPlayer, cityID)
		elseif CanPlayerCaptureElDoradoOrPlunderIt(nPlayer) then
			if gT.Players[nPlayer] then
				gT.Players[nPlayer].AIhateValues[jPlayer] = gT.Players[nPlayer].AIhateValues[jPlayer] + 1;
				gT.ElDorados[index].UnitRebornTurns = gT.Players[nPlayer].BaseUnitRebornTurns;
			else
				gT.ElDorados[index].UnitRebornTurns = 0;
			end		
			if gT.Players[jPlayer] then
				gT.Players[jPlayer].AIhateValues[jPlayer] = gT.Players[jPlayer].AIhateValues[nPlayer] + 1;
			end
			gT.ElDorados[index].Player = nPlayer;
			local cityID = GetClosestCityIDToPlotOrNil(nPlayer, iColPlot);
			iColPlot:SetImprovementPillaged(true);
			iColPlot:SetOwner(nPlayer, cityID)
		else
			iColPlot:SetImprovementType(-1)
			iColPlot:SetImprovementPillaged(false);
			iColPlot:SetSpecialControl(false)
			iColPlot:SetOwner(-1, -1)
			gT.ElDorados[index] = nil;
			RemoveLabelOnPlot(iColPlot, "ElDorado")
			local lumpgold = LastRandom(500, 750);
			ChangeITGGold(nPlayer, lumpgold)
			if Players[nPlayer]:IsHuman() then
				Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(iColPlot:GetX(), iColPlot:GetY()))), lumpgold .. " [ICON_GOLD]", 0.5)
			end
		end
	end
end

function FortTakeOver(nPlayer, jPlayer, iColPlot, bFriendly, rUnit)
	if iColPlot:GetOwner() == jPlayer then
		local index = iColPlot:GetPlotIndex()
		if not bFriendly then
			DoLogDominationEvent(-1, nPlayer, jPlayer, 8, -5)
			if Players[jPlayer]:IsBarbarian() then
				local pOwner = gT.Forts[index].PreBarbPlayer;
				if IsValidToTakeBackColonyHolySiteFort(nPlayer, pOwner) then
					FortTakeOver(pOwner, jPlayer, iColPlot)
					SpecialPlotReturned(pOwner, nPlayer, "Fort", iColPlot)
					return;
				end
			end
			if gT.Forts[index].ControlPlayer then
				if gT.Forts[index].ControlPlayer ~= jPlayer then
					if IsValidToTakeBackColonyHolySiteFort(nPlayer, gT.Forts[index].ControlPlayer) then
						FortTakeOver(gT.Forts[index].ControlPlayer, jPlayer, iColPlot)
						SpecialPlotReturned(gT.Forts[index].ControlPlayer, nPlayer, "Fort", iColPlot)
						return;
					end
				end
			end
			if Players[nPlayer]:IsBarbarian() then
				 gT.Forts[index].PreBarbPlayer = jPlayer;
				 gT.Forts[index].BarbSpawn = 0;
			end
		end
		if bFriendly then
			local unittab = {}
			for i = 0, iColPlot:GetNumUnits() -1 do
				local iUnit = iColPlot:GetUnit(i);
				local jID = iUnit:GetID() .. "," .. iUnit:GetOwner() .. "," .. iUnit:GetGameTurnCreated();
				if gT.FortsByUnitID[jID] == index then
					table.insert(unittab, iUnit)
				end
			end
			for i, iUnit in pairs(unittab) do
				local iDmg = iUnit:GetDamage();
				iUnit:Kill(true, iUnit:GetOwner()) -- should be ignore by on kill function
				SpawnFortUnit(nPlayer, iColPlot, gT.Forts[index].Type, iDmg)
			end
			if #unittab > 0 then
				MakeJumpAwayFromSpecialPoint(nPlayer, iColPlot)
			end
		else
			if gT.Players[nPlayer] then
				gT.Players[nPlayer].AIhateValues[jPlayer] = gT.Players[nPlayer].AIhateValues[jPlayer] + 1;
				gT.Forts[index].UnitRebornTurns = gT.Players[nPlayer].BaseUnitRebornTurns;
				if gT.Players[nPlayer].InstantWar == GetITGGameTurn() then
					gT.Forts[index].UnitRebornTurns = 10;
					gT.Forts[index].ControlPlayer = nPlayer;
				end
			else
				gT.Forts[index].UnitRebornTurns = 0;
			end		
			if gT.Players[jPlayer] then
				gT.Players[jPlayer].AIhateValues[jPlayer] = gT.Players[jPlayer].AIhateValues[nPlayer] + 1;
			end
			iColPlot:SetImprovementPillaged(true);
			ConquerSpecialPlotBonuses(nPlayer, iColPlot, rUnit)
		end
		gT.Forts[index].Player = nPlayer;
		local type = gT.Forts[index].Type
		local cityID = GetClosestCityIDToPlotOrNil(nPlayer, iColPlot);
		iColPlot:SetOwner(nPlayer, cityID)
		for it, indexplot in pairs( gT.Forts[index].AdjacentPlots) do
			if gT.PlotFortControl[indexplot] == index then
				if IsSpecialControlPlot(indexplot, nil, nil, true) then
					gT.PlotFortControl[indexplot] = nil;
				else
					local iPlot = Map.GetPlotByIndex(indexplot);
					iPlot:SetOwner(nPlayer, cityID)
				end
			end
		end
	end
end

--0 Holy Site, Fort, Colony
--1 Trade/FishingBoats
--2 Siege
--3 Normal combat

local GetTypeStuff = {}
--GetTypeStuff[GameInfoTypes.UNITCLASS_CARGO_SHIP] = 1;
--GetTypeStuff[GameInfoTypes.UNIT_ITGSG_CARAVAN] = 1;
--GetTypeStuff[GameInfoTypes.UNITCLASS_WORKBOAT] = 1;
--GetTypeStuff[GameInfoTypes.UNITCLASS_ITGSG_CATAPULT] = 2;
--GetTypeStuff[GameInfoTypes.UNITCLASS_ITGSG_SIEGE_TOWER] = 2;
--GetTypeStuff[GameInfoTypes.UNIT_ITGSG_BATTERING_RAM] = 2;


function GetUnitKilledTypeHelp(kUnit)
	local jID = kUnit:GetID() .. "," .. kUnit:GetOwner() .. "," .. kUnit:GetGameTurnCreated();
	--gT.HolySitesUnits[jID]
	if gT.ColoniesByUnitID[jID] or gT.FortsByUnitID[jID] then
		return 0;
	end
	return GetTypeStuff[kUnit:GetUnitClassType()] or 3;
end

function ThereIsValidCircumstancesForPlayerToTakeOverFort(kPlayer, jPlayer, unitX, unitY, jID)
	local vPlot = Map.GetPlot(unitX, unitY);
	local hasDef = false;
	for i = 0, vPlot:GetNumUnits() -1 do
		local iUnit = vPlot:GetUnit(i);
		if iUnit then
			if iUnit:GetOwner() == kPlayer then
				return true;	
			elseif iUnit:GetID() ~= jID then
				if iUnit:GetBaseCombatStrength(true) > 4 then
					if iUnit:GetCurrHitPoints() > 0 then
						hasDef = true;
					end
				end
			end
		end
	end
	return not hasDef;
end

function SpecialPlotReturned(pOwner, nPlayer, type, iColPlot)
	if Players[pOwner]:IsMinorCiv() then
		if gT.Players[nPlayer] then
			if not Players[nPlayer]:IsMinorCiv() then
				Players[pOwner]:ChangeMinorCivFriendshipWithMajor(nPlayer, GameDefines.FRIENDSHIP_PER_BARB_KILLED)
				if Game.GetActivePlayer() == nPlayer then
					Events.GameplayAlertMessage("We have freed " .. Players[pOwner]:GetCivilizationAdjective() .. " " .. type .. " (+" .. GameDefines.FRIENDSHIP_PER_BARB_KILLED .. "[ICON_INFLUENCE]).")
				end
			end
		end
	end
end

function RelBeliefsFaithOnKill(iPlayer, iPlot)
	local b = 0;
	for iCity in Players[iPlayer]:Cities() do
		if IsBeliefPresentInACity(iCity, GameInfoTypes.BELIEF_GOD_WAR) then
			if Map.PlotDistance(iCity:GetX(), iCity:GetY(), iPlot:GetX(), iPlot:GetY()) <= 4 then
				b = b + 0.5;
				break;
			end
		end
	end
	return b;
end

function GetDataOfSpecialPlotsFriendlyTakeOver(iPlayer, ePlayer, string)
	local tab = {}
	for fIndex, fdata in pairs(gT[string]) do
		if fdata.Player == ePlayer then
			table.insert(tab, fIndex)
		end
		if fdata.ControlPlayer == ePlayer then
			gT[string][fIndex].ControlPlayer = iPlayer;
		end
		if fdata.PreBarbPlayer == ePlayer then
			gT[string][fIndex].ControlPlayer = iPlayer;
		end
	end
	return tab;
end

function MakeFriendlyTakeOverOfAllControlPlots(iPlayer, ePlayer)
	for i, index in pairs(GetDataOfSpecialPlotsFriendlyTakeOver(iPlayer, ePlayer, "Colonies")) do
		ColonyTakeOver(iPlayer, ePlayer, Map.GetPlotByIndex(index), true)
	end
	for i, index in pairs(GetDataOfSpecialPlotsFriendlyTakeOver(iPlayer, ePlayer, "Forts")) do
		FortTakeOver(iPlayer, ePlayer, Map.GetPlotByIndex(index), true)
	end
	for i, index in pairs(GetDataOfSpecialPlotsFriendlyTakeOver(iPlayer, ePlayer, "HolySites")) do
		HolySiteTakeOver(iPlayer, ePlayer, Map.GetPlotByIndex(index), true, true)
	end
	for i, index in pairs(GetDataOfSpecialPlotsFriendlyTakeOver(iPlayer, ePlayer, "ElDorados")) do
		ElDoradoTakeOver(iPlayer, ePlayer, Map.GetPlotByIndex(index), true)
	end	
end

function GetBestPlotToSpawnUnit(unitX, unitY, jUnit, jID, kID, kUnitType, jPlayer)
	local tPlot = Map.GetPlot(unitX, unitY);
	if not tPlot:IsCity() then
		local bKillingUnitOnPlot = false;
		for j = 0, tPlot:GetNumUnits() - 1 do
			local hUnit = tPlot:GetUnit(j);
			local hID = hUnit:GetID() .. "," .. hUnit:GetOwner() .. "," .. hUnit:GetGameTurnCreated();
			if hID ~= kID and hID ~= jID then
				local stgType = hUnit:GetITGStackType();
				if hUnit:GetOwner() == jPlayer then
					return jUnit:GetPlot();
				end
				if (stgType > 0) and (stgType ~= 4) then
					return jUnit:GetPlot();
				end
			end
		end
		return tPlot;
	end
	return jUnit:GetPlot();
end

function GetNewManagementOriginCity(kPlayer, tCity, x, y, isLand)
	if gT.Players[kPlayer].CultBonusOn[34] then
		local hPlot = Map.GetPlot(x, y)
		if hPlot:IsWater() == isLand then
			return;
		end
		local bCanOcean = false;
		local trOceanID;
		if not isLand then
			bCanOcean = CanCrossOcean(kPlayer)
			if bCanOcean then
				trOceanID = GetOceanID(hPlot)
			else
				trOceanID = GetBasinCoastID(hPlot)
			end
		end
		local tIndexPlot = tCity:Plot():GetPlotIndex();
		local trLandAreaID = GetLandAreaID(hPlot)
		if isLand and (trLandAreaID ~= GetLandAreaID(tCity:Plot())) then
			print("CultBonus34 Caravan moved to another land area?", tIndexPlot, hPlot:GetPlotIndex())
			return;
		end
		if (not isLand) then
			local bMovedSomewhere = true;
			local tabToCheck;
			if bCanOcean then
				tabToCheck = GetCoastOfOceanTab(tCity:Plot());
			else
				tabToCheck = GetCoastOfCoastsTab(tCity:Plot());
			end
			for a, oceanID in pairs(tabToCheck) do
				if oceanID == trOceanID then
					bMovedSomewhere = false;
					break;
				end
			end
			if bMovedSomewhere then
				print("CultBonus34 Caravan moved to another water area?", tIndexPlot, hPlot:GetPlotIndex())
				return;
			end
		end
		for iCity in Players[kPlayer]:Cities() do
			if iCity:Plot():GetPlotIndex() ~= tIndexPlot then
				if isLand then
					if GetLandAreaID(iCity:Plot()) == trLandAreaID then
						return iCity;
					end
				else
					local tabToCheck;
					if bCanOcean then
						tabToCheck = GetCoastOfOceanTab(iCity:Plot());
					else
						tabToCheck = GetCoastOfCoastsTab(iCity:Plot());
					end 
					for a, oceanID in pairs(tabToCheck) do
						if oceanID == trOceanID then
							return iCity;
						end
					end
				end
			end
		end
	end
end