local titv8 = GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_VIKING_8
local ancEmpinno17 = GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_EMPIRE_17
local ucScout = GameInfoTypes.UNITCLASS_SCOUT;
local hCaitypeCC = 0;
local hCaitypeCCall = 0;
local outdelay;
local ExtraCopiesT = {
--[GameInfoTypes.UNIT_ITG_GUIDED_MISSILE] = 1,
}
local HelpMinoStrength = {
[GameInfoTypes.UNIT_WORKBOAT] = 1
}
local tCombinedArmsProdMod = {
[GameInfoTypes.UNITCOMBAT_ARMOR] = true,
[GameInfoTypes.UNITCOMBAT_FIGHTER] = true,
[GameInfoTypes.UNITCOMBAT_BOMBER] = true,
[GameInfoTypes.UNITCOMBAT_NAVALRANGED] = true,
[GameInfoTypes.UNITCOMBAT_NAVALMELEE] = true,
[GameInfoTypes.UNITCOMBAT_CARRIER] = true,
}

function HandleOUTFloat(iPlayer, x, y, text)
	if iPlayer == Game.GetActivePlayer() then
		outdelay = outdelay + 0.5;
		Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(x, y))), text, outdelay)
	end
end

function DoDirtyCombinedArmsBonus(iPlayer)
	for i, v in pairs(gT.Players[iPlayer].TCombinedArms or {}) do
		Players[iPlayer]:ChangeUnitCombatProductionModifiers(v, -TCOMBINE_ARMS_PROD_MOD)
	end
	if not HasPlayerTech(iPlayer, GameInfoTypes.TECH_COMBINED_ARMS, "grer") then
		return;
	end
	gT.Players[iPlayer].TCombinedArms = {};
	local bCount = {}
	for class, t in pairs(tCombinedArmsProdMod) do
		bCount[class] = 0;
	end
	for iUnit in Players[iPlayer]:Units() do
		local unitcombattype = iUnit:GetUnitCombatType();
		if bCount[unitcombattype] then
			bCount[unitcombattype] = bCount[unitcombattype] + 1;
		end
	end
	local iMin = 1000;
	for class, count in pairs(bCount) do
		iMin = math.min(iMin, count); 
	end
	for class, count in pairs(bCount) do
		if count == iMin then
			table.insert(gT.Players[iPlayer].TCombinedArms, class);
			Players[iPlayer]:ChangeUnitCombatProductionModifiers(class, TCOMBINE_ARMS_PROD_MOD)
		end 
	end
end

function ITGSCNewUnitCreated(iPlayer, iUnit, iCity, bInitial, generalID, extraData, bSupposedToMove)
	if Players[iPlayer]:IsBarbarian() then
		return;
	end
	local cID;
	local iClass = iUnit:GetUnitClassType();
	local unitType = iUnit:GetUnitType();
	local forcedData = extraData or {}
	local uID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
	gT.Players[iPlayer].UnitsByID[uID] = {}
	if iUnit:GetDomainType() == dLand then
		local iPlot = iUnit:GetPlot();
		if not iPlot:IsWater() then
			local contID = GetContID(iUnit:GetPlot(), 5813583)
			gT.Players[iPlayer].UnitsByID[uID].BirthContID = contID;
			iUnit:SetITGContID(contID)
		end
	end
	if HelpMinoStrength[unitType] then
		iUnit:SetBaseCombatStrength(HelpMinoStrength[iUnit:GetUnitType()])
	end
--	if forcedData.RelData then
--		gT.Players[iPlayer].UnitsByID[uID].Religions = forcedData.RelData
--	end
	if forcedData.Damage then
		iUnit:SetDamage(forcedData.Damage)
	end
	if forcedData.Moves then
		iUnit:SetDamage(forcedData.Moves)
	end
	if iCity then
		cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		if gT.Players[iPlayer].HasIdeology[11] then
			if CanBeSpeedUpByAnything(iUnit) then
				iUnit:ChangeTemporaryMoves(2)
			end
		end
		if gT.Players[iPlayer].UnitClassPromotions[iClass] or IsCombatUnitWithNoXP(unitType) then
			local cmps = GetITGCityInteger(iCity, "CI_COMMON_MIL_SERVICE");
			if cmps > 0 then
				iCity:ChangeDomainProductionModifier(dLand, -cmps)
				iCity:ChangeDomainProductionModifier(dSea, -cmps)
				iCity:ChangeDomainProductionModifier(dAir, -cmps)
				SetITGCityInteger(iCity, "CI_COMMON_MIL_SERVICE", 0)
			end
		end
	end
	if gT.Players[iPlayer].UnitClassPromotions[iClass] then
		if iCity then
			TriggerUnhappinessChanceForMilitaryUnit(iCity, iPlayer, iUnit)
			if IsHasLaw(iPlayer, 2, 3) then
				DoChangeCityCultureOwnership(cID, iCity, iPlayer, 20, "Law2")
			end
			local bonusXP, hXP = GetBonusXPForTrainedUnit(iCity, iPlayer, iUnit:GetDomainType(), iUnit:GetUnitCombatType(), iUnit:GetUnitType())
			if gT.Players[iPlayer].CultBonusOn[49] then
				if bonusXP > 10 then
					local unitType = iUnit:GetUnitType();
					local cbs = math.max(0, GameInfo.Units[unitType].Combat or 0)
					local cbsr = math.max(0, GameInfo.Units[unitType].RangedCombat or 0)
					ChangeITGBaseCombatStrength(iUnit, math.min(math.ceil(0.25 * cbs), math.floor(bonusXP / 10)), math.min(math.ceil(0.25 * cbsr), math.floor(bonusXP / 10)))
				end
			end
			local numVetProm = GetNumTrainedVeteranPromotions(iPlayer, iCity, iClass)
			if numVetProm > 0 then
				AwardWithRandomVeteranProms(iUnit, numVetProm)
			end
			gT.Cities[cID].LogTrainedXP = bonusXP; -- for AI help
			if bonusXP + hXP >= 100 then
				if Players[iPlayer]:IsHuman() then
					LuaEvents.ITG_AchievementCompleted(130)
				end
			end
			iUnit:ChangeExperience(bonusXP + hXP)
			local mod = 1;
			if gT.Players[iPlayer].CultBonusOn[126] then
				mod = mod - 0.5;
			end
			bonusXP = math.ceil(bonusXP * mod)
			gT.Players[iPlayer].UnitsByID[uID].XP = bonusXP + hXP;
			TakeCareOfEventMorale(iPlayer, 22)
			SetITGCityInteger(iCity, "CI_NEXT_UNIT_XP", 0)
			gT.Cities[cID].LastTurnTrainedUnit = GetITGGameTurn();
		else
			if bInitial then
				iUnit:ChangeExperience(LastRandom(0,27));
			end
			gT.Players[iPlayer].UnitsByID[uID].XP = iUnit:GetExperience();
		end
		for promID, sth in pairs(gT.Players[iPlayer].UnitClassPromotions[iClass] or {}) do
			iUnit:SetHasPromotion(promID, true)
		end
		AdjustCombatBonusFromLevel(iUnit, uID, iPlayer)
	end
	NewUnitCreatedForBasicAbilitiesThatShouldBeDLL(iUnit)
	NewUnitCreatedForSocialPolicyBonuses(iPlayer, iUnit, iCity, uID)
	NewUnitCreatedForInnovations(iPlayer, iUnit, iCity, uID) -- also secures ideologies
	if bSupposedToMove then
		NewlyCreatedInitialUnitMovedAround(iUnit)
	end
	hCaitypeCCall = hCaitypeCCall + 1;
	if iUnit:GetUnitAIType() == 0 then
		hCaitypeCC = hCaitypeCC + 1;
		iUnit:SetUnitAIType(GameInfoTypes[GameInfo.Units[iUnit:GetUnitType()].DefaultUnitAI]);
	--	if iUnit:GetUnitClassType() == ucScout then
	--		iUnit:SetUnitAIType(GameInfoTypes.UNITAI_EXPLORE)
	--	end			
	end
	SingleUnitEmbarkIssue(iPlayer, iUnit)
end

function DoCallLogsUnitAITypeBase()
	print(hCaitypeCC, hCaitypeCCall)
end

function ITGCityPurchasedUnit(iCity, unitP, bGold, bFaith, bHurry)
	local iPlayer = iCity:GetOwner();
	local jUnit = Players[iPlayer]:InitUnit(unitP, iCity:GetX(), iCity:GetY())
	jUnit:SetMoves(0);
	if bHurry then
		iCity:SetUnitProduction(unitP, 0);
	end
	OnCityTrained(iPlayer, iCity:GetID(), jUnit:GetID(), bGold, bFaith)
end

function OnCityTrained(ownerId, cityId, unitId, bGold, bFaithOrCulture)
	outdelay = 0;
	local iUnit = Players[ownerId]:GetUnitByID(unitId);
	local unitType = iUnit:GetUnitType();
	local unitClass = iUnit:GetUnitClassType();
	local iCity = Players[ownerId]:GetCityByID(cityId);
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local cHapPre = gT.Cities[cID].Happiness
	ITGSCNewUnitCreated(ownerId, iUnit, iCity)
	if iUnit:GetUnitType() == GameInfoTypes.UNIT_WORKBOAT then
		BasicCSMissionCompleteFunc(ownerId, 36, 1);
	end
	if DBScenario.StrategicResStorage then
		OnTrainedUnitResourceConsume(ownerId, unitType)
	end
	if DBScenario.ResLockedTurns then
		OnTrainedUnitResourceLock(ownerId, unitType, iCity)
	end
	--extra copies
	if (not bGold) and (not bFaithOrCulture) and gT.Players[ownerId].UnitClassXP[unitClass]then
		--log for special unit
		local iStrReward = math.max(iUnit:GetBaseCombatStrength(true), iUnit:GetBaseRangedCombatStrength())
		DoLogUnitTrainedForSpecialUU(ownerId, unitClass)
		if unitType == GameInfoTypes.UNIT_ITG_BOMBER_UU_0 then
			HealUnitsOfType(ownerId, unitType, 20)
		end
		local extraCopies = (ExtraCopiesT[unitType] or 0);
		if HasPlayerTech(ownerId, GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_TRIBE_5, "xnhgjudsav") then
			if IsResourceUnit(iUnit, rHorse) then
				extraCopies = extraCopies + 1;
			end
		end
		if HasPlayerTech(ownerId, GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_AFR_4, "Dacaeaeea") then
			if gT.Players[ownerId].UnitClassXP[iUnit:GetUnitClassType()] then
				if iUnit:GetDomainType() == dLand then
					extraCopies = extraCopies + 1;
					ChangeMeritocracy(ownerId, 1);
				end
			end
		end
		if Players[ownerId]:IsMinorCiv() then
			local gAlly = Players[ownerId]:GetAlly();
			if gT.Players[gAlly] and gT.Players[gAlly].HasIdeology[5] then
				extraCopies = extraCopies + 1;
			end
		end
		if HasPlayerTech(ownerId, GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_4, "xnhgjudsav") then
			if iUnit:GetDomainType() == dSea then
				if gT.Players[ownerId].UnitClassXP[iUnit:GetUnitClassType()] then
					for hh = 1, math.floor(GetNumAlliedCS(ownerId)/ 2) do
						extraCopies = extraCopies + 1;
					end
					DoBoostNearestCityStateInfluence(ownerId, iUnit:GetX(), iUnit:GetY(), iStrReward, true, true)	
				end
			end
		end
		for i, v in pairs(gT.Cities[cID].Manufactories) do
			if gT.Manufactories[v].Active then
				for j, b in pairs(gT.Manufactories[v].Traits) do
					if b.ID == 10 and (b.CD or 0) <= 0 then
						gT.Manufactories[v].Traits[j].CD = 10;
						extraCopies = extraCopies + 1;
					end
				end
			end
		end
		for i = 1, extraCopies do
			local jUnit = Players[ownerId]:InitUnit(iUnit:GetUnitType(), iCity:GetX(), iCity:GetY());
			ITGSCNewUnitCreated(ownerId, jUnit, iCity)
		end
		--extra copies end
		local scienceReward = GetNumPlayerManufactoryTrait(ownerId, 23) * iStrReward
		local extraHP = 0;
		if iUnit:GetDomainType() == dLand then
			extraHP = extraHP + 10 * GetNumCityManufactoryTrait(iCity, 45)
		elseif iUnit:GetDomainType() == dSea then
			extraHP = extraHP + 10 * GetNumCityManufactoryTrait(iCity, 46)
		elseif iUnit:GetDomainType() == dAir then
			extraHP = extraHP + 10 * GetNumCityManufactoryTrait(iCity, 47)
		end
		if gT.Players[ownerId].HasIdeology[56] then
			ChangeITGCulture(ownerId, iStrReward)
			DoChangeCityCultureOwnership(cID, iCity, ownerId, iStrReward, "ideo56")
			HandleOUTFloat(ownerId, iCity:GetX(), iCity:GetY(), "+" .. iStrReward .. "[ICON_CULTURE][ICON_ITG_PRESENCE]")
		end
		if scienceReward > 0 then
			if not Players[ownerId]:IsMinorCiv() then
				ChangeITGScience(ownerId, scienceReward)
			end
		end
		if HasPlayerTech(ownerId, GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_TRIBE_19, "Fskfokeofe") then
			if iStrReward > 0 then
				ChangeITGCulture(ownerId, iStrReward)
				ChangeITGFaith(ownerId, iStrReward)
			end
		end
		if extraHP ~= 0 then -- should extra HP affect copies? yes :0
			iUnit:ChangeMaxHitPoints(extraHP, true);
		end
	end
	--here some basic abilities on trained
	if (not bGold) and (not bFaithOrCulture) then
		if HasPlayerTech(ownerId, GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_TRIBE_13, "dacviyute") then
			ChangeITGSettlerPoints(ownerId, 1);
		end
	end
	if gT.Players[ownerId] then
		gT.Players[ownerId].LHUntisTrained = gT.Players[ownerId].LHUntisTrained + 1; 
	end
	if bGold then
		if gT.Players[ownerId] then
			if IsValidUnitToBeMissionary(iUnit) then
				NewMercenaryAcquired(ownerId, iUnit, iCity, cID)
				DoIncreasementStockExchange(3)
			end
			ChangeGoldSpendInternally(ownerId, iCity:GetUnitPurchaseCost( iUnit:GetUnitType() ))
		end
	elseif not bFaithOrCulture then
		VictoryTaskCompletion(iPlayer, 34)
		if iUnit:GetUnitCombatType() == GameInfoTypes.UNITCOMBAT_MOUNTED then
			VictoryTaskCompletion(iPlayer, 41)
		end
		if iUnit:GetDomainType() == dAir then
			VictoryTaskCompletion(iPlayer, 46)
		elseif iUnit:GetDomainType() == dSea then
			VictoryTaskCompletion(iPlayer, 45)
			DoIncreasementStockExchange(7)
			if gT.Players[ownerId].PiratePerks[10] then
				TakeCareOfEventMorale(ownerId, 25, {1, "Corsair"})
			end
		end
		ChangeITGCityInteger(iCity, "CI_LH_TRAINED_UNITS", 1)
		gT.Cities[cID].UnhapFromTrained = gT.Cities[cID].UnhapFromTrained + math.max(0, cHapPre - gT.Cities[cID].Happiness)
		if IsResourceUnit(iUnit, rHorse) then
			DoIncreasementStockExchange(13)
		end
		if IsResourceUnit(iUnit, rOil) then
			DoIncreasementStockExchange(18)
		end
		if GameInfo.Units[iUnit:GetUnitType()].StackITGType == 7 then
			DoIncreasementStockExchange(17)
		end
		local numKA22 = GetNumCityAcademiesWithAbility(iCity, 22)
		if numKA22 > 0 then
			if not Players[ownerId]:IsMinorCiv() then
				ChangeITGScience(ownerId, numKA22 * iCity:GetUnitProductionNeeded(iUnit:GetUnitType()))
			end
		end
	end
end
GameEvents.CityTrained.Add(OnCityTrained)

function GenerateNavalUnits(iPlayer, num)
	local sPlots = {}
	for iCity in Players[iPlayer]:Cities() do
		if #IsCoastOfHugeArea(iCity:Plot()) > 0 then
			table.insert(sPlots, iCity:Plot())
		end
	end
	for it, sPlot in pairs(IsCoastOfHugeArea(Map.GetPlotByIndex(gT.Players[iPlayer].StartingPoint))) do
		table.insert(sPlots, sPlot)
	end
	if #sPlots > 0 then
		local canWorkboat = 2 - math.ceil(Players[iPlayer]:GetNumCities() / 100)
		for j = 1, num do
			local rType = LastRandom(canWorkboat, #UnitNavalClassesT);
			local jType = gT.Players[iPlayer].UnitClasses[UnitNavalClassesT[rType]] or GameInfoTypes[GameInfo.UnitClasses[UnitNavalClassesT[rType]].DefaultUnit];
			local dPlot = sPlots[LastRandom(1, #sPlots)]
			local jUnit = Players[iPlayer]:InitUnit(jType, dPlot:GetX(), dPlot:GetY())
			jUnit:JumpToNearestValidPlot()
			ITGSCNewUnitCreated(iPlayer, jUnit)
			NewlyCreatedInitialUnitMovedAround(jUnit)
		end
	end
end

function GetBestPlotForNewUnitSimple(iPlayer, fdomain)
	if fdomain == "DOMAIN_SEA" then
		local bCity = GetCityWithLargestOcean(iPlayer, 15)
		if bCity then
			return bCity:Plot();
		end
	else
		if Players[iPlayer]:GetCapitalCity() then
			return Players[iPlayer]:GetCapitalCity():Plot();
		end
	end
	if fdomain == "DOMAIN_AIR" then
		for iUnit in Players[iPlayer]:Units() do
			if iUnit:CargoSpace() > 0 then
				return iUnit:GetPlot();
			end
		end
	else
		for iUnit in Players[iPlayer]:Units() do
			local cPlot = iUnit:GetPlot()
			if ((fdomain or "DOMAIN_LAND") == "DOMAIN_LAND") == (not cPlot:IsWater()) then
				return cPlot;
			end
		end
	end
	if (fdomain or "DOMAIN_LAND") == "DOMAIN_LAND" then
		return Players[iPlayer]:GetStartingPlot();
	end
	return nil;
end

function SimpleGenerateUnitOfType(iPlayer, type, iPlot, extraStr, extraRangedStr, bJump, bNoMoves, bFullyStackable, nName, hpLeft, bMercenary)
	if not type then
		return;
	end
	if not GameInfo.Units[type] then
		print("SimpleGenerateUnitOfType-1", iPlayer, type, iPlot, extraStr, extraRangedStr, bJump, bNoMoves, bFullyStackable, nName, hpLeft, bMercenary)
		return;
	end
	if not iPlot then
		iPlot = GetBestPlotForNewUnitSimple(iPlayer, GameInfo.Units[type].Domain)
		if not iPlot then
			print("No plot found for unit simple generation", iPlayer, GameInfo.Units[type].Domain);
			return;
		end
	end
	local jUnit = Players[iPlayer]:InitUnit(type, iPlot:GetX(), iPlot:GetY())
	ITGSCNewUnitCreated(iPlayer, jUnit)
	if bJump then
		if jUnit:GetDomainType() ~= dAir then
			jUnit:JumpToNearestValidPlot()
		end
	end
	if bNoMoves then
		jUnit:SetMoves(0);
	end
	if bFullyStackable then
		SetUnitForcedStackType(jUnit, -1, "sGen", -1)
	end
	if nName then
		jUnit:SetName(nName);
	end
	if extraStr or extraRangedStr then
		ChangeITGBaseCombatStrength(jUnit, extraStr, extraRangedStr)
	end
	if hpLeft then
		jUnit:SetDamage(jUnit:GetMaxHitPoints() - hpLeft);
	end
	if bMercenary then
		jUnit:SetHasPromotion(GameInfoTypes.PROMOTION_ITG_MERCENARY_BASE, true)
	end
	return jUnit;
end

function NewlyCreatedInitialUnitMovedAround(jUnit)
	local moves = math.floor(LastRandom(0,12)/2 * jUnit:MaxMoves() / 60);
	local IsWater = (jUnit:GetDomainType() == dSea)
	if isWater then
		moves = moves * 2;
	end
	local hasAlreadyVisited = {[jUnit:GetPlot()] = 1}
	while moves > 0 do
		moves = moves - 1;
		local jPlot = jUnit:GetPlot();
		local jTab = {}
		for i = 0, 5 do
			local tPlot = Map.PlotDirection(jPlot:GetX(), jPlot:GetY(), i);
			if tPlot then
				if not hasAlreadyVisited[tPlot] then
					if tPlot:GetNumUnits() == 0 then
						if not tPlot:IsImpassable() then
							if not tPlot:IsMountain() then
								if (not tPlot:IsCity()) or (tPlot:GetOwner() == jUnit:GetOwner()) then
									if tPlot:IsWater() == IsWater then
										if jUnit:CanMoveThrough(tPlot) or jUnit:CanMoveOrAttackInto(tPlot) then
											table.insert(jTab, tPlot)
										end
									end
								end
							end
						end
					end
				end
			end
		end
		if #jTab > 0 then
			local rPlot = jTab[LastRandom(1, #jTab)];
			hasAlreadyVisited[rPlot] = 1;
			jUnit:SetXY(rPlot:GetX(), rPlot:GetY())
		else
			return
		end
	end
end

local diagCFT = 0
local sType3 = GameInfoTypes.UNIT_ITG_SETTLER_POINTS;
local cstateancient1 = GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_1;
local sType3anc = GameInfoTypes.UNIT_ITG_SETTLER_POINTS_ANCIENT;
local batRamSup = GameInfoTypes.UNIT_ITG_BATTERING_RAM_SUPPORT
local siegeTsup = GameInfoTypes.UNIT_ITG_SIEGE_TOWER_SUPPORT
GameEvents.CityFakeTrained.Add(function(iPlayer, unitType, cityID)
	diagCFT = diagCFT + 1;
	if unitType == sType3 or unitType == sType3anc then
		gT.Players[iPlayer].LHsettlers = gT.Players[iPlayer].LHsettlers + 1; 
		ChangeITGSettlerPoints(iPlayer, GetSettlerPointsFromSettler(iPlayer), nil, "Trained");
		if HasPlayerTech(iPlayer, cstateancient1, "hhvewqw") then
			ChangeMeritocracy(iPlayer, 1)
		end
	elseif unitType == batRamSup then
		gT.Players[iPlayer].BatteringSupport = gT.Players[iPlayer].BatteringSupport + 1;
	elseif unitType == siegeTsup then
		gT.Players[iPlayer].SiegeTowerSupport = gT.Players[iPlayer].SiegeTowerSupport + 1;
	end
end)

function GetSettlerPointsFromSettler(iPlayer)
	local b = 15;
	if HasPlayerTech(iPlayer, cstateancient1, "hhvewqw") then
		b = b + 5;
	end
	return b;
end

function GetBonusXPForTrainedUnit(iCity, iPlayer, domainType, combatType, unitType, bToolTip)
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local bonusXP, hXP = GetITGCityInteger(iCity, "CI_NEXT_UNIT_XP"), 0;
	bonusXP = bonusXP + GetXPFromLaws(iPlayer, iCity, cID);
	bonusXP = bonusXP + GetXPFromInnovations(iPlayer, iCity, cID);
	bonusXP = bonusXP + GetXPFromSocialDev(iPlayer, iCity, cID);
	bonusXP = bonusXP + GetXPFromCultureType(iPlayer, iCity, cID) + GetXPFromGovernance(iCity)
	bonusXP = bonusXP + GetXPFromBeliefs(iPlayer, iCity, cID) + GetXPFromAcademies(iPlayer, iCity, cID);
	bonusXP = bonusXP + GetXPFromIdeologies(iPlayer, iCity, cID);
	if domainType ~= -1 then
		bonusXP = bonusXP + GetXPFromDomainType(unitType, iPlayer, iCity, cID)
	elseif bToolTip then
		bonusXP = bonusXP + GetXPforAnyDomainFromBuildings(iCity)
	end
	if combatType ~= -1 then
		bonusXP = bonusXP + GetXPFromUnitCombatType(combatType, iPlayer, iCity, cID)
	end
	if unitType ~= -1 then
		bonusXP = bonusXP + GetXPFromResourceRequirement(unitType, iPlayer, iCity, cID);
	end
	return bonusXP, hXP;
end

function GetXPFromCultureType(iPlayer, iCity, cID)
	local bonusXP = 0;
	if gT.Players[iPlayer].SubcultureType == 9 then
		bonusXP = bonusXP + 15;
	end
	return bonusXP;
end

function GetXPFromInnovations(iPlayer, iCity, cID)
	local bonusXP = 0;
	if HasPlayerTech(iPlayer, titv8, "Dacaeae") then
		bonusXP = bonusXP + gT.Players[iPlayer].NumGWoL;
	end
	if HasPlayerTech(iPlayer, ancEmpinno17, "veadade") then
		local bColosseum = Players[iPlayer]:GetPlayerUniqueBuilding(GameInfoTypes.BUILDINGCLASS_COLOSSEUM);
		if bColosseum ~= -1 and iCity:IsHasBuilding(bColosseum) then
			bonusXP = bonusXP + 10;
		end
	end
	return bonusXP;
end

function GetXPFromSocialDev(iPlayer, iCity, cID)
	local bonusXP = 0;
	if gT.Players[iPlayer].CultBonusOn[125] then
		bonusXP = bonusXP + 15;
	end
	if gT.Players[iPlayer].CultBonusOn[30] then
		bonusXP = bonusXP + gT.Cities[cID].FishNextT;
	end
	return bonusXP;
end

function GetXPFromLaws(iPlayer, iCity, cID)
	local bonusXP = 0;
	if IsHasLaw(iPlayer, 2, 1) then	
		bonusXP = bonusXP + 10;
	end
	return bonusXP;
end

function GetXPFromGovernance(iCity)
	return GetITGCityInteger(iCity, "CI_XP_FROM_GOV")
end

function GetXPFromAcademies(iPlayer, iCity, cID)
	local bonusXP = 10 * GetNumCityAcademiesWithAbility(iCity, 71);
	return bonusXP;
end

function GetXPFromBeliefs(iPlayer, iCity, cID)
	local bonusXP = 0;
	if IsBeliefPresentInACity(iCity, GameInfoTypes.BELIEF_ITG_PANTHEON_15) then
		bonusXP = bonusXP + 5;
	end
	return bonusXP;
end

function GetXPFromIdeologies(iPlayer, iCity, cID)
	local bonusXP = 0;
	if gT.Players[iPlayer].HasIdeology[29] then
		for a, h in pairs(gT.Players[iPlayer].Agents) do
			if (not h.IgnoreItForever) then
				if not h.Rekonwalescencja then
					bonusXP = bonusXP + 5;
				end
			end
		end
	end
	if gT.Players[iPlayer].HasIdeology[30] then
		bonusXP = bonusXP + gT.Cities[cID].Health;
	end
	if Players[iPlayer]:IsGoldenAge() then
		if gT.Players[iPlayer].HasMinorIdeology[3] then
			bonusXP = bonusXP + 15;
		end
	end
	if gT.Players[iPlayer].HasMinorIdeology[17] then
		if HasWonderOrRuin(iCity) then
			bonusXP = bonusXP + 20;
		end
	end
	return bonusXP;
end

function GetXPforAnyDomainFromBuildings(iCity)
	local tc = {[dSea] = 0, [dLand] = 0, [dAir] = 0}
	for row in GameInfo.Building_DomainFreeExperiences() do
		if iCity:IsHasBuilding(GameInfoTypes[row.BuildingType]) and (tc[DomainTypes[row.DomainType]]) then
			tc[DomainTypes[row.DomainType]] = tc[DomainTypes[row.DomainType]] + row.Experience
		end
	end
	local mXP;
	for domain, bxp in pairs(tc) do
		if (not mXP) or (mXP > bxp) then
			mXP = bxp;
		end
	end
	return mXP;
end

function GetXPFromDomainType(unitType, iPlayer, iCity, cID)
	local bonusXP = iCity:GetProductionExperience(unitType);
--[[	for row in GameInfo.Building_DomainFreeExperiences() do
		if iCity:IsHasBuilding(GameInfoTypes[row.BuildingType]) then
			if domainType == DomainTypes[row.DomainType] then
				bonusXP = bonusXP + row.Experience
			end
		end
	end ]] 
	if domainType == dAir then
		bonusXP = bonusXP + 10 * GetNumPlayerManufactoryTrait(iPlayer, 1)
	elseif domainType == dSea then
		bonusXP = bonusXP + 10 * GetNumPlayerManufactoryTrait(iPlayer, 2)
	end
	return bonusXP;
end

function GetXPFromResourceRequirement(unitType, iPlayer, iCity, cID)
	local bonusXP = 0;
	if iCity:IsHasBuilding(GameInfoTypes.BUILDING_ITG_NW_ONLY_STABLE) and IsResourceUnitType(unitType, rHorse) then
		bonusXP = bonusXP + 15;
	end
	if iCity:IsHasBuilding(GameInfoTypes.BUILDING_ITG_NW_ONLY_FORGE) and IsResourceUnitType(unitType, rIron) then
		bonusXP = bonusXP + 15;
	end
	return bonusXP;
end

function GetXPFromUnitCombatType(combatType, iPlayer, iCity, cID)
	local bonusXP = 0;
	if combatType == GameInfoTypes.UNITCOMBAT_ARMOR then
		bonusXP = bonusXP + 10 * GetNumPlayerManufactoryTrait(iPlayer, 3)
	elseif combatType == GameInfoTypes.UNITCOMBAT_GUN then
		bonusXP = bonusXP + 10 * GetNumPlayerManufactoryTrait(iPlayer, 4)
	elseif combatType == GameInfoTypes.UNITCOMBAT_MELEE then
		bonusXP = bonusXP + 10 * GetNumPlayerManufactoryTrait(iPlayer, 5)
	elseif combatType == GameInfoTypes.UNITCOMBAT_MOUNTED then
		bonusXP = bonusXP + 10 * GetNumPlayerManufactoryTrait(iPlayer, 6)
	elseif combatType == GameInfoTypes.UNITCOMBAT_ARCHER then
		bonusXP = bonusXP + 10 * GetNumPlayerManufactoryTrait(iPlayer, 7)
	end
	return bonusXP;
end

function GetNumTrainedVeteranPromotions(iPlayer, iCity, iClass)
	local v = 0; 			
	if gT.Players[iPlayer].HasIdeology[11] then
		if gT.Players[iPlayer].UnitClassXP[iClass] then
			local cRv = 250;
			local cXP = gT.Players[iPlayer].UnitClassXP[iClass];
			while cXP >= cRv do
				cXP = cXP - cRv;
				cRv = cRv + 250;
				v = v + 1;
			end
		end
	end
	return v;
end