local pilgrimUnit = GameInfoTypes.UNIT_ITGSG_PILGRIM;
local itgwonder25 = GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_25;
local CitiesByLCP;
local itgprenwWonder32 = GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_32;
local tPilgrimStr = {10, 7, 5, 10, 10};
--function GetCoastLandPassableAreaID(iPlot)

--killing unit
--follower belief
--starting pilgrims

--[ICON_ITG_PILGRIM]

function ReInitializePilgridRouteData()
	CitiesByLCP = nil;
end

function GetPilgrimageCost(iPlayer)
	return DBScenario.PilgrimCost;
end

function CanCityPilgrimage(iCity, cID, iPlayer)
	if GetDBCulturePlayerInfo(iPlayer, "CanPilgrim") then
		return true;
	end
	if gT.Globals.ScenarioType == 5 then
		return false;
	end
	if gT.Cities[cID].PilgrimGP > 0 then
		return true;
	end
	if gT.Players[iPlayer].HasPlayerWonder[itgprenwWonder32] then
		return true;
	end
	if gT.Players[iPlayer].CultBonusOn[10] then
		return true;
	end
	if GetNumCityAcademiesWithAbility(iCity, 67) > 0 then
		return true;
	end
	if IsBeliefPresentInACity(iCity, GameInfoTypes.BELIEF_ITG_FOLLOWER_48) then
		return true;
	end
	return false;
end

function GetPilgrimagePT(iCity, cID, iPlayer, tradeVal)
	if CanCityPilgrimage(iCity, cID, iPlayer) then
		local base = math.min(iCity:GetFaithPerTurn(), tradeVal) + gT.Cities[cID].PilgrimGP;
		if gT.Players[iPlayer].HasPlayerWonder[itgprenwWonder32] then
			base = base + 2;
		end
		if IsBeliefPresentInACity(iCity, GameInfoTypes.BELIEF_ITG_FOLLOWER_48) then
			base = base + 2;
		end
		if gT.Players[iPlayer].CultBonusOn[10] then
			base = base + 1;
		end
		base = base + gT.Players[iPlayer].PilgrimFromTech;
		base = base + 3 * GetNumCityAcademiesWithAbility(iCity, 67)
		if IsHasLaw(iPlayer, 22, 4) then
			base = base - GetNumCityTemplarBuildings(iCity); 
		end
		return math.max(0, base);
	end
	return 0;
end

function DoCityProcessPilgrimPoints(iCity, cID, iPlayer, pGain)
	if pGain + gT.Cities[cID].PilgrimProgress >= GetPilgrimageCost(iPlayer) then
		if not GeneratePilgrimageIfPossibleTarget(iCity, iPlayer, false) then
			--something here? // no valid target; grant some faith.
			ChangeITGFaith(iPlayer, 20, true)
		end
		gT.Cities[cID].PilgrimProgress = pGain + gT.Cities[cID].PilgrimProgress - GetPilgrimageCost(iPlayer);
	else
		gT.Cities[cID].PilgrimProgress = pGain + gT.Cities[cID].PilgrimProgress;
	end
end

function GetModifiersToPilgrimageTargetAndReligion(iCity, iPlayer)
	local tRelChance = {}
	local tExtraPlayerTarget = {};
	for league, h in pairs(gT.Leagues) do
		if h.Resolutions[65] then
			if h.Members[iPlayer] and (h.Host ~= iPlayer) then
				if h.OfficialRel then
					tRelChance[h.OfficialRel] = (tRelChance[h.OfficialRel] or 0) + 10;
				end
				if h.Host then
					tExtraPlayerTarget[h.Host] = (tExtraPlayerTarget[h.Host] or 0) + 10;
				end
			end
		end
	end
	return tRelChance, tExtraPlayerTarget;
end

function GeneratePilgrimageIfPossibleTarget(iCity, iPlayer, bInitial)
--determine religions
	local cOriginPlotIndex = iCity:Plot():GetPlotIndex();
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local relTab = {}
	for row in GameInfo.Religions() do
		if row.ID ~= 0 then
			local numfol = iCity:GetNumFollowers(row.ID);
			if numfol > 0 then
				relTab[row.ID] = numfol;
			end
		end
	end
	local extraRelChance, extraPlayerTarget = GetModifiersToPilgrimageTargetAndReligion(iCity, iPlayer)
	for iRel, extra in pairs(extraRelChance) do
		relTab[iRel] = (relTab[iRel] or 0) + extra;
	end
	if gT.Players[iPlayer].OfficialReligion then
		relTab[gT.Players[iPlayer].OfficialReligion] = (relTab[gT.Players[iPlayer].OfficialReligion] or 0) + 10;
	end
	local relC = Players[iPlayer]:GetReligionCreatedByPlayer();
	if (relC > 0) and (relTab[relC]) then
		relTab[relC] = relTab[relC] * 2;
	end
--determine targets
	local mainTargets = {}
	local reserveTargets = {}
	local lcpareaID = GetCoastLandPassableAreaID(iCity:Plot());
	for index, sth in pairs(gT.HolySites) do
		if sth.LCP_ID == lcpareaID then
			local iPlot = Map.GetPlotByIndex(index);
			if Map.PlotDistance(iCity:GetX(), iCity:GetY(), iPlot:GetX(), iPlot:GetY()) >= MIN_PILGRIMAGE_DISTANCE_HS then
				local val = extraPlayerTarget[iPlot:GetOwner()] or 0;
				for b, rel in pairs(sth.Religions) do
					val = val + (relTab[rel] or 0);
				end
				if val > 0 then
					table.insert(mainTargets, {index, val})
				else
					table.insert(reserveTargets, index)
				end
			end
		end
	end
	if not CitiesByLCP then
		GenerateCitiesByLCP()
	end
	local forcedTargets = {}
	for b, index in pairs(CitiesByLCP[lcpareaID]) do
		if index ~= cOriginPlotIndex then
			local hCity = Map.GetPlotByIndex(index):GetPlotCity();
		-- no minimum distance here! // achievement and ensures target
			if hCity:IsHasBuilding(itgwonder25) then
				if hCity:GetReligiousMajority() == iCity:GetReligiousMajority() and hCity:GetReligiousMajority() > 0 then
					if not gT.Cities[cID].DomeOfTheRockTRP then
						table.insert(forcedTargets, index)
					end
				end
			end
			local bReserve = false;
			local val = extraPlayerTarget[hCity:GetOwner()] or 0;
			for row in GameInfo.Religions() do
				if row.ID ~= 0 then
					if hCity:IsHolyPlaceForReligion(row.ID) then
						if relTab[row.ID] then
							val = val + relTab[row.ID] + 5;
							break;
						else
							bReserve = true;
						end
					end
				end
			end
			if val > 0 then
				table.insert(mainTargets, {index, val})
			elseif bReserve then
				table.insert(reserveTargets, index)
			end
		end
	end
	local targetIndex;
	if #forcedTargets > 0 then
		targetIndex = forcedTargets[LastRandom(1,#forcedTargets)];
	elseif #mainTargets > 0 then
		targetIndex = GetRandomFromBiasedChanceTable(mainTargets)
	elseif #reserveTargets > 0 then
		targetIndex = reserveTargets[LastRandom(1,#reserveTargets)];
	end
	if targetIndex then
		local tPlot = Map.GetPlotByIndex(targetIndex);
		local bHolyCity = tPlot:IsCity();
		local cRel;
		if bHolyCity then
			local tCity = tPlot:GetPlotCity();
			local vh = {}
			local reserves = {}
			for row in GameInfo.Religions() do
				if row.ID ~= 0 then
					if tCity:IsHolyPlaceForReligion(row.ID) then
						if relTab[row.ID] then
							table.insert(vh, {row.ID, relTab[row.ID]})
						else
							table.insert(reserves, row.ID)
						end
					end
				end
			end
			if #vh > 0 then
				cRel = GetRandomFromBiasedChanceTable(vh)
			else
				cRel = reserves[LastRandom(1,#reserves)];
			end
		else
			local vh = {}
			for i, rel in pairs(gT.HolySites[targetIndex].Religions) do
				if relTab[rel] then
					table.insert(vh, {rel, relTab[rel]})
				end
			end
			if #vh > 0 then
				cRel = GetRandomFromBiasedChanceTable(vh)
			else
				cRel = gT.HolySites[targetIndex].Religions[LastRandom(1,#gT.HolySites[targetIndex].Religions)];
			end
		end
		GeneratePilgrimageToDestination(iCity, iPlayer, tPlot, cRel, bInitial)
		return true;
	end
	return false;
end

function GenerateCitiesByLCP()
	CitiesByLCP = {}
	for g, h in pairs(gT.Players) do
		for iCity in Players[g]:Cities() do
			local lcpareaID = GetCoastLandPassableAreaID(iCity:Plot());
			if not CitiesByLCP[lcpareaID] then
				CitiesByLCP[lcpareaID] = {}
			end
			table.insert(CitiesByLCP[lcpareaID], iCity:Plot():GetPlotIndex())
		end
	end
end

function NewCityLogForLCP(iCity)
	if CitiesByLCP then
		local lcpareaID = GetCoastLandPassableAreaID(iCity:Plot());
		if not CitiesByLCP[lcpareaID] then
			CitiesByLCP[lcpareaID] = {}
		end
		table.insert(CitiesByLCP[lcpareaID], iCity:Plot():GetPlotIndex())
	end
end

function GetPilgrimMovesBasedOnDistance(dis)
	local val = math.floor(dis / 7)
	if LastRandom(1, 7) <= (dis - val * 7) then
		val = val + 1;
	end
	return math.min(3,val)
end

function GeneratePilgrimageToDestination(iCity, iPlayer, targetPlot, iRel, bInitial)
	local jUnit = Players[iPlayer]:InitUnit(pilgrimUnit, iCity:GetX(), iCity:GetY())
	jUnit:SetMaxXPValue(0)
	jUnit:SetBaseCombatStrength(tPilgrimStr[gT.Globals.ScenarioType] or 10)
	ITGSCNewUnitCreated(iPlayer, jUnit, iCity)
	local uID = jUnit:GetID() .. "," .. iPlayer .. "," .. jUnit:GetGameTurnCreated();
--	jUnit:SetBaseRangedCombatStrength(GetBaseRangedStrengthForCaravanCargo(iPlayer, jUnit))
	gT.Players[iPlayer].UnitsByID[uID].TargetAdjacent = targetPlot:GetPlotIndex();
	gT.Players[iPlayer].UnitsByID[uID].OriginTrade = iCity:Plot():GetPlotIndex();
	gT.Players[iPlayer].UnitsByID[uID].OriginReligion = iRel;
	jUnit:SetReligionType(iRel);
	LuaEvents.ITGUnitFlagMercAdmGenDirty(iPlayer, jUnit:GetID())
	gT.Players[iPlayer].UnitsByID[uID].Pilgrim = true;
	gT.Players[iPlayer].UnitsByID[uID].Uncontrollable = true;
	gT.Players[iPlayer].UnitsByID[uID].ExtraPilgrimMoves = GetPilgrimMovesBasedOnDistance(Map.PlotDistance(iCity:GetX(), iCity:GetY(), targetPlot:GetX(), targetPlot:GetY()));

	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	if targetPlot:IsCity() then
		local tCity = targetPlot:GetPlotCity();
		if tCity:IsHasBuilding(itgwonder25) then
			gT.Cities[cID].DomeOfTheRockTRP = true;
		end
	end
	if bInitial then
		local gh = GenerateShortestPath({iCity:Plot()}, {[targetPlot:GetPlotIndex()] = 1}, nil, 70, nil, nil, {[GameInfoTypes.TERRAIN_OCEAN] = true}, nil, false, false, nil, nil, true)
		if gh then
			if #gh > 6 then
				local dlPlot = gh[LastRandom(3,#gh -3)] 
				jUnit:SetXY(dlPlot:GetX(), dlPlot:GetY())
				if dlPlot:IsWater() then
					jUnit:SetEmbarked(true)
				end
			else
				print("Add minimum distance for initial pilgrimage?")
			end
		end
	else
		MoveForwardITG(jUnit, targetPlot, uID, iPlayer)
	end
end

function PilgrimSetXY(iPlayer, iUnit, iPlot, iPlotIndex, uID)
	if gT.Players[iPlayer].UnitsByID[uID].TargetAdjacent then
		local destPlot = Map.GetPlotByIndex(gT.Players[iPlayer].UnitsByID[uID].TargetAdjacent);
		if Map.PlotDistance(iPlot:GetX(), iPlot:GetY(), destPlot:GetX(), destPlot:GetY()) < 2 then
			GetRewardFromPilgrimage(iUnit, iPlayer, destPlot, uID)
			iUnit:Kill(false, -1)
		end
	end
end

function GetRewardFromPilgrimage(iUnit, iPlayer, destPlot, uID)
	gT.Players[iPlayer].LHPilgrimage = gT.Players[iPlayer].LHPilgrimage + 1;
	VictoryTaskCompletion(iPlayer, 77)
	if Players[iPlayer]:IsHuman() then
		LuaEvents.ITG_AchievementCountChange(117, 1)
	end
	local dPlayer = destPlot:GetOwner();
	local originPlot = Map.GetPlotByIndex(gT.Players[iPlayer].UnitsByID[uID].OriginTrade)
	local oCity = originPlot:GetPlotCity();
	local ocID = oCity:Plot():GetPlotIndex() .. "," .. oCity:GetGameTurnFounded();
	table.insert(gT.Cities[ocID].PilgrimLog, destPlot:GetPlotIndex());
	local rdis = Map.PlotDistance(originPlot:GetX(), originPlot:GetY(), destPlot:GetX(), destPlot:GetY());
	ResetFTDelay(0.5)
	local rel = gT.Players[iPlayer].UnitsByID[uID].OriginReligion;
	local iActive = (iPlayer == Game.GetActivePlayer())
	local dActive = (dPlayer == Game.GetActivePlayer())
	local hexXX, hexYY = destPlot:GetX(), destPlot:GetY();
	if iActive then
		hexXX, hexYY = iUnit:GetX(), iUnit:GetY();
	end
	local relPressure = 0;
	if gT.Players[iPlayer].HasPlayerWonder[itgprenwWonder32] then
		if rel == Players[iPlayer]:GetReligionCreatedByPlayer() then
			relPressure = REL_PRESSURE_PILGRIMAGE * gT.Players[iPlayer].ReligiousTradePressure;
		end
	end
	local bHolyCity = destPlot:IsCity();
	local function DoEffectAuraPilgrim(tCity)
		if relPressure > 0 then
			local tPlayer = tCity:GetOwner();
			if not tCity:IsSpreadImmune() then
				tCity:AddReligiousPressure(9, rel, relPressure, iPlayer)
				AddFloatingText(tPlayer,tCity:GetX(), tCity:GetY(), Locale.Lookup(Game.GetReligionName(rel)) .. ": " .. relPressure / 10 .. " " .. GameInfo.Religions[rel].IconString, nil, "Trade")
			elseif gT.Players[tPlayer].OfficialReligion then
				if gT.Players[tPlayer].OfficialReligion == rel then
		--			// do not add happiness!
				elseif ShouldGenerateUnhappyFromTradeRouteHeresy(tPlayer, tCity, rel) then
					ChangeITGHappinessInTheCity(tCity, -1, nil, "gerergd");
					AddFloatingText(tPlayer,tCity:GetX(), tCity:GetY(), "+1[ICON_HAPPINESS_4]", nil, "Trade")
				end
			else
				print("What kind of sorcery? City is rel spread immune, but doesn't have official rel?", tCity:GetName(), tCity:GetOwner())
			end
		end
	end
	--spread aura effects
	DoEffectAuraPilgrim(oCity)
	local theHolyCity = destPlot:GetPlotCity(); -- can be nil;
	if not Players[iPlayer]:IsMinorCiv() then
		if HasPlayerCHIncomingTrait(iPlayer, 17) then
			local av1, av2, av3 = GetBaseAndExtraGoldFromTradeRoutes(rdis, (iPlayer == dPlayer), theHolyCity, iPlayer, dPlayer)
			AddGoldFromTradeRoutes(iPlayer, av1 + av3, false)
			if iActive then
				AddFloatingText(nil,hexXX,hexYY, "+" .. (av1 + av3) .. "[ICON_GOLD]", nil, "Trade")
			end
		end
	end
	if bHolyCity then
		DoEffectAuraPilgrim(theHolyCity)
		local hID = theHolyCity:Plot():GetPlotIndex() .. "," .. theHolyCity:GetGameTurnFounded();
		for h, cIndex in pairs(GetNearCities(hID, 10)) do
			if cIndex ~= gT.Players[iPlayer].UnitsByID[uID].OriginTrade then
				DoEffectAuraPilgrim(Map.GetPlotByIndex(cIndex):GetPlotCity())
			end
		end
	else
		for cIndex, h in pairs(gT.HolySites[destPlot:GetPlotIndex()].NearbyCities) do
			if cIndex ~= gT.Players[iPlayer].UnitsByID[uID].OriginTrade then
				DoEffectAuraPilgrim(Map.GetPlotByIndex(cIndex):GetPlotCity())
			end
		end
		HolySiteVisitedByPilgrim(destPlot:GetPlotIndex(), iPlayer)
	end
	--bonuses for origin
	local hapOrigin = 1; -- this happiness may be removed as well?
	local legalBonus = LastRandom(1, 1 + math.floor(rdis/ 20))
	local faithBonus = 20 + LastRandom(0, rdis)
	local artPoints = 25 + LastRandom(0, 1 + math.floor(rdis / 5)) * 5
	local imeritocracy = 0;
	--bonuses for destination
	if gT.Players[dPlayer] then -- can be barb!!
		ChangeITGFaith(dPlayer, 25)
		gT.Players[dPlayer].PilgrimVisitors[iPlayer] = true;
		local destGoldFromPilgrim = 20;
		if HasPlayerCHIncomingTrait(dPlayer, 17) then
			local av1, av2, av3 = GetBaseAndExtraGoldFromTradeRoutes(rdis, (iPlayer == dPlayer), theHolyCity, iPlayer, dPlayer)
			destGoldFromPilgrim = destGoldFromPilgrim + av1 + av2;
		end
		AddGoldFromTradeRoutes(iPlayer, destGoldFromPilgrim, Players[dPlayer]:IsMinorCiv())
		if dActive then
			AddFloatingText(nil,hexXX,hexYY, "[COLOR_YIELD_GOLD]+" .. destGoldFromPilgrim .. "[ENDCOLOR][ICON_GOLD]", nil, "Trade")
			AddFloatingText(nil,hexXX,hexYY, "+25[ICON_PEACE]", nil, "Trade")
		end

		for league, h in pairs(gT.Leagues) do
			if h.Resolutions[65] then
				if h.Members[iPlayer] and (h.Host ~= iPlayer) then
					if h.Members[dPlayer] and (h.Host == dPlayer) then
						if h.Resolutions[65].ExtraInfo == 1 then
							imeritocracy = imeritocracy + 2;
						elseif h.Resolutions[65].ExtraInfo == 2 then
							legalBonus = legalBonus + 5;
						elseif h.Resolutions[65].ExtraInfo == 3 then
							hapOrigin = hapOrigin + 2;
						end
					end
				end
			end
		end
	end
	if gT.Players[iPlayer].CultBonusOn[10] then
		SetRawCityYield(oCity, yProduction, math.max(GetITGCityInteger(oCity, "CI_PILGRIM_PROD"), math.ceil(rdis / 8)), "CI_PILGRIM_PROD")
	end
	--bonuses for incoming
	ChangeITGLegalPointsPercent(iPlayer, legalBonus, nil, "Pilgrim")
	ChangeITGFaith(iPlayer, faithBonus, true)
	BoostArtisticPoints(iPlayer, artPoints)
	local hapOrigin = 1; -- this happiness may be removed as well?
	ChangeITGHappinessInTheCity(oCity, hapOrigin, nil, "g4efw")
	if iActive then
		AddFloatingText(nil,hexXX,hexYY, "+" .. faithBonus .. "[ICON_PEACE]", nil, "Trade")
		AddFloatingText(nil,hexXX,hexYY, "+" .. legalBonus / 100 .. "[ICON_ITG_LEGAL_POWER]", nil, "Trade")
		AddFloatingText(nil,hexXX,hexYY, "+" .. artPoints .. "[ICON_GREAT_ARTIST]", nil, "Trade")
		AddFloatingText(nil,hexXX,hexYY, "+" .. hapOrigin .. "[ICON_HAPPINESS_1]", nil, "Trade")
	end
	if imeritocracy > 0 then
		ChangeMeritocracy(iPlayer, imeritocracy)
		AddFloatingText(iPlayer,hexXX,hexYY, "+" .. imeritocracy .. "[ICON_ITG_MERITOCRACY]", nil, "Trade")
	end
	DoIncreasementStockExchange(20, 5)
	if bHolyCity then
		--plague
		local tCity = destPlot:GetPlotCity();
		DoTradeEpidemy(tCity, oCity, "Pilgrims");
		DoTradeEpidemy(oCity, tCity, "Pilgrims");
		--wonder
		if tCity:IsHasBuilding(GameInfoTypes.BUILDING_ITG_NEW_MEDIEVAL_WONDER_16) then
			gT.Globals.DhamekStupa = (gT.Globals.DhamekStupa or 0) + 1;
			tCity:ChangeJONSCulturePerTurnFromBuildings(1)
			tCity:ChangeFaithPerTurnFromBuildings(1)
		end
	end
	-- log
	local gTurn = GetITGGameTurn();
	local hTab = {To = destPlot:GetPlotIndex(),
		From = originPlot:GetPlotIndex(),
		ToPlayer = dPlayer,
		FromPlayer = iPlayer,
		Distance = rdis,
		Killed = false,
		Pilgrim = true,
		Turn = gTurn};
	table.insert(gT.Globals.TradeRouteLog, hTab)
end

function PilgrimKilled(jPlayer, unitX, unitY, idelay, jID, unitType, kPlayer, jUnit, bForceGold)
	local logTab = {Pilgrim = true, From = gT.Players[jPlayer].UnitsByID[jID].OriginTrade,
	FromPlayer = jPlayer,
	To = gT.Players[jPlayer].UnitsByID[jID].TargetAdjacent,
	ToPlayer = Map.GetPlotByIndex(gT.Players[jPlayer].UnitsByID[jID].TargetAdjacent):GetOwner(),
	Killed = true,
	Turn = GetITGGameTurn()}
	table.insert(gT.Globals.TradeRouteLog, logTab)
	CaravanTakenDownCSQuestLog(kPlayer, jPlayer, isLand) -- let's make it that way
	if gT.Players[kPlayer] then
		if GetITGReligion(kPlayer) ~= gT.Players[jPlayer].UnitsByID[jID].OriginReligion then
			ChangeITGFaith(kPlayer, 50)
			if kPlayer == Game.GetActivePlayer() then
				Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(unitX, unitY))), "50 [ICON_PEACE]", idelay)
				idelay = idelay + 0.5;
			end
			local cFm = 10;
			if gT.Players[kPlayer].OfficialReligion then
				cFm = 75;
			end
			if gT.Players[jPlayer].OfficialReligion or (Players[jPlayer]:GetReligionCreatedByPlayer() > 0) then
				DoIncreaseAngryCrit(jPlayer, kPlayer, 12, "PilgrimKilled12")
			else
				DoIncreaseAngryCrit(jPlayer, kPlayer, 4, "PilgrimKilled4")
			end
			if LastRandom(1, 100) <= cFm then
				TakeCareOfEventMorale(kPlayer, 25, {1, "Killed Pilgrim"})
			end
		else
			local cFm = 10;
			if gT.Players[kPlayer].OfficialReligion then
				cFm = 75;
				--heresy chance
				gT.Players[kPlayer].HeresyPilgrimSlayer = gT.Players[kPlayer].HeresyPilgrimSlayer + 10;
			end
			if LastRandom(1, 100) <= cFm then
				TakeCareOfEventMorale(kPlayer, 25, {-1, "Killed Pilgrim"})
			end
		end
		DoLogDominationEvent(-1, kPlayer, jPlayer, 5, -3)
	end
end

function DoFadeProductionFromCultBonus10(iPlayer)
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		if GetITGCityInteger(iCity, "CI_PILGRIM_PROD") > 0 then
			iCity:ChangeBaseYieldRateFromBuildings(yProduction, -1)
			ChangeITGCityInteger(iCity, "CI_PILGRIM_PROD", -1)
		end
	end
end