local pirateUnitTab = {GameInfoTypes.UNIT_ITG_NW_CARAVEL , GameInfoTypes.UNIT_ITG_NW_GALLEON , GameInfoTypes.UNIT_ITG_NW_CORVETTE, GameInfoTypes.UNIT_ITG_NW_CARRACK, GameInfoTypes.UNIT_ITG_PRIVATEER}
local gPirateMods = {
{ID = 1, Text = "Gain +80 [ICON_GOLD] Gold each time Barbarian unit plunder [ICON_CARGO] Naval Trade Route."},
{ID = 2, Text = "+15% chance to capture defeated naval units. +15 [ICON_GOLD] Gold if capture failed."},
{ID = 3, Text = "+10 [ICON_ITG_PRESENCE] Cultural Presence in Cities that are alone on their landmasses."},
{ID = 4, Text = "Plundering Cities steal up to 3 [ICON_GREAT_WORK] Great Works. Naval melee units can attack coastal land."},
{ID = 5, Text = "Barbarian units spawned by Global Piracy have 15% chance to have double combat strength."},
{ID = 6, Text = "+5 [ICON_CULTURE] Culture each time other player looses Naval Unit."},
{ID = 7, Text = "Reveals location of enemy [ICON_CARGO] Naval Trade Routes within revealed territory. +50 [ICON_GOLD] Gold from plundering Trade-Routes."},
{ID = 8, Text = "Upon plundering [ICON_CARGO] Naval Trade Route there is 25% chance to steal Luxury Resource for 20 turns. +50 [ICON_GOLD] Gold from plundering Trade-Routes."},
{ID = 9, Text = "50% chance that [ICON_ITG_MERCENARY] Mercenary unit fleeing from another player will join you."},
{ID = 10, Text = "+1% [ICON_ITG_MORALE] Morale each time you train Naval Unit. +15% [ICON_PRODUCTION] Production while training naval units."},
}

LuaEvents.ITG_RequestPirateInfo.Add(function(id, type)
	MapModData.ITGSG = gPirateMods[id].Type;
end)

function EndEraClearPirateMods(iPlayer)
	CleanPirateVision(iPlayer)
	if gT.Players[iPlayer].PiratePerks[10] then
		Players[iPlayer]:ChangeDomainProductionModifier(dSea, 15)
	end
	if gT.Players[iPlayer].PiratePerks[4] then
		Players[iPlayer]:ChangeCanNavalMeleeAttackCoast(-1);
	end
end

function CleanPirateVision(iPlayer)
	local iTeam = Players[iPlayer]:GetTeam();
	for a, b in pairs(gT.Players[iPlayer].PirateVision) do
		Map.GetPlotByIndex(b):ChangeVisibilityCount(iTeam, -1)
	end
	gT.Players[iPlayer].PirateVision = {}
end

function DoPirateFleeNavalUnit(unitType, unitHP, unitName, iPlayer)
	local tab = {}
	for g, h in pairs(gT.Players) do
		if h.PiratePerks[9] then
			if g ~= iPlayer then
				if LastRandom(1,100) <= 50 then
					table.insert(tab, g)
				end
			end
		end
	end
	if #tab > 0 then
		local nPlayer = tab[LastRandom(1,#tab)];
		local nUnit = SimpleGenerateUnitOfType(nPlayer, unitType, nil, nil, nil, nil, nil, nil, unitName, unitHP)
		if Players[nPlayer]:IsHuman() then
			Players[nPlayer]:AddNotification(94343293, unitName .. " had to flee from the oppression of former master and joined our cause!", "Corsair", nUnit:GetX(), nUnit:GetY(), 27)
		end
	end
end

function DoTurnPirateVision(iPlayer)
	CleanPirateVision(iPlayer)
	if gT.Players[iPlayer].PiratePerks[7] then
		local iTeam = Players[iPlayer]:GetTeam();
		for g, h in pairs(gT.Players) do
			if Teams[iTeam]:IsAtWar(Players[g]:GetTeam()) then
				for iUnit in Players[g]:Units() do
					if iUnit:GetUnitType() == GameInfoTypes.UNIT_ITGSG_CARGO_SHIP then
						local iPlot = iUnit:GetPlot();
						if iPlot:IsRevealed(iTeam) then
							iPlot:ChangeVisibilityCount(iTeam, 1)
							table.insert(gT.Players[iPlayer].PirateVision, iPlot:GetPlotIndex())
						end
					end
				end
			end
		end
	end
end


function PirateLogCargoDown(jPlayer, kPlayer)
	if kPlayer == 63 then
		for g, gh in pairs(gT.Players) do
			if gh.PiratePerks[1] then
				if g ~= jPlayer then
					ChangeITGGold(g, 80);
				end
			end
		end
	elseif gT.Players[kPlayer].PiratePerks[8] then
		if gT.Players[jPlayer] then
			if LastRandom(1, 4) == 3 then
				local tab = {}
				local preftab = {}
				local resTab = GetResourcesPresentOnMap()
				for row in GameInfo.Resources() do
					if not row.Migration then
						if row.Happiness > 0 then
							if resTab[row.ID] then
								if Players[jPlayer]:GetNumResourceTotal(row.ID, true) > 0 then
									table.insert(tab, row.ID)
									if Players[kPlayer]:GetNumResourceTotal(row.ID, true) == 0 then
										table.insert(preftab, row.ID)
									end	
								end
							end
						end
					end
				end
				if #tab > 0 then
					local iRes;
					if #preftab > 0 then
						iRes = preftab[LastRandom(1,#preftab)];
					else
						iRes = tab[LastRandom(1,#tab)];
					end
					DoExportResource(jPlayer, kPlayer, iRes, 1)
					table.insert(gT.Globals.PirateDeals, {Res = iRes, ToPlayer = kPlayer, FromPlayer = jPlayer, TurnStart = GetITGGameTurn(), Duration = 20})
					if Players[kPlayer]:IsHuman() then
						Players[kPlayer]:AddNotification(94343293, "We have acquired a copy of " .. GameInfo.Resources[iRes].IconString .. " " .. Locale.Lookup(GameInfo.Resources[iRes].Description) .. " for 20 turns.", "Corsair", -1, -1, 27)
					end
					if Players[jPlayer]:IsHuman() then
						Players[jPlayer]:AddNotification(94343293, "We have lost a copy of " .. GameInfo.Resources[iRes].IconString .. " " .. Locale.Lookup(GameInfo.Resources[iRes].Description) .. " for 20 turns.", "Corsair", -1, -1, 28)
					end
				end
			end
		end
	end
end

function NavalUnitSinked(jPlayer)
	for g, gh in pairs(gT.Players) do
		if gh.PiratePerks[6] then
			if g ~= jPlayer then
				ChangeITGCulture(g, 5)
			end
		end
	end
end	

function AddNewPirateMod(iPlayer)
	local tab = {}
	for i, h in pairs(gPirateMods) do
		if not gT.Players[iPlayer].PiratePerks[i] then
			table.insert(tab, i)
		end
	end
	local lPerk = tab[LastRandom(1,#tab)];
	gT.Players[iPlayer].PiratePerks[lPerk] = true;
	--meh, but only 10;
	if lPerk == 10 then
		Players[iPlayer]:ChangeDomainProductionModifier(dSea, 15)
	elseif lPerk == 4 then
		Players[iPlayer]:ChangeCanNavalMeleeAttackCoast(1);
	end
	if Players[iPlayer]:IsHuman() then
		Players[iPlayer]:AddNotification(94343293, gPirateMods[lPerk].Text, "Corsair", -1, -1, 27)
	end
	gT.Players[iPlayer].NumPirateMods = gT.Players[iPlayer].NumPirateMods + 1;
	gT.Globals.PirateMod = math.max(gT.Globals.PirateMod, gT.Players[iPlayer].NumPirateMods)
	return lPerk;
end

function CanHaveNewPirateMod(iPlayer)
	if gT.Players[iPlayer].NumPirateMods then
		if gT.Players[iPlayer].NumPirateMods < 10 then
			return true;
		end
	end
	return false;
end

function DoublePirateStrength()
	local chance = 0;
	for g, gd in pairs(gT.Players) do
		if gd.PiratePerks[5] then
			chance = chance + 15;
		end
	end
	return (LastRandom(1, 100) <= chance)
end

function DoTurnPirateBarb()
	local tChance = gT.Globals.PirateMod;
	while tChance > 0 do
		if LastRandom(1, 10) <= tChance then
			local pPlot = GetValidPiratePlotFromOcean(GetSizeOfLargestOcean(true))
			if pPlot then
				local jUnit = Players[63]:InitUnit(pirateUnitTab[LastRandom(1,#pirateUnitTab)], pPlot:GetX(), pPlot:GetY())
				if DoublePirateStrength() then
					ChangeITGBaseCombatStrength(jUnit, jUnit:GetBaseCombatStrength(true), jUnit:GetBaseRangedCombatStrength())
				end
			else
				print("Error 9534234")
			end
			for g, h in pairs(gT.Players) do
				if h.IsConsideredBarbarian then
					if HasPlayerTech(g, GameInfoTypes.TECH_UNIQUE_ITG_NW_TROPICAL_2, "rgttew") then
						local nPlot = GetValidPiratePlotFromOcean(GetSizeOfLargestOcean(true))
						if nPlot then
							SimpleGenerateUnitOfType(g, pirateUnitTab[LastRandom(1,#pirateUnitTab)], nPlot)
						end
					end
				end
			end
		end
		tChance = tChance - 10;
	end
end

function GetTopPanelPirateTT(iPlayer)
	local text = "Your unusual situation forced you to measures some people may call unhonourable or even unnatural. Right now your Corsairs provide:"
	for a, b in pairs(gT.Players[iPlayer].PiratePerks) do
		text = text .. "[NEWLINE][ICON_BULLET]" .. gPirateMods[a].Text
	end
	text = text .. "[NEWLINE][NEWLINE]Global Piracy modifier is " .. gT.Globals.PirateMod * 10 .. "% (chance for extra barbarian naval unit to spawn each turn)."
	return text;
end

function DoPirateCall(iPlayer)
-- try to limit to 20 units max;
	local oceanTT = {}
	for iUnit in Players[63]:Units() do
		if iUnit:GetDomainType() == dSea then
			local iPlot = iUnit:GetPlot();
			if iPlot:IsWater() then
				local oceanID = GetOceanID(iPlot)
				if not oceanTT[oceanID] then
					oceanTT[oceanID] = {}
				end
				table.insert(oceanTT[oceanID], iUnit)
			end
		end
	end
	local tab = {}
	for oceanID, hh in pairs(oceanTT) do
		table.insert(tab, {oceanID, #hh})
	end
	local eReward = 20;
	if #tab > 0 then
		table.sort(tab, SortFunctionForGreaterInteger2)
		local addedT = {}
		for i, data in pairs(tab) do
			if #addedT < 20 then
				for j, iUnit in pairs(oceanTT[data[1]]) do
					table.insert(addedT, {iUnit:GetUnitType(), iUnit:GetMaxHitPoints() - iUnit:GetDamage(), iUnit:GetX(), iUnit:GetY()})
					iUnit:Kill(false, -1);
				end
			else
				break;
			end
		end
		eReward = eReward - #addedT;
		for i, unitData in pairs(addedT) do
			SimpleGenerateUnitOfType(iPlayer, unitData[1], Map.GetPlot(unitData[3], unitData[4]), nil, nil, nil, nil, nil, nil, unitData[2])
		end
	end
	if eReward > 0 then
		ChangeMeritocracy(iPlayer, 2 * eReward)
		ChangeITGScience(iPlayer, 25 * eReward)
		ChangeITGGold(iPlayer, 50 * eReward)
		ChangeITGCulture(iPlayer, 25 * eReward)
		ChangeITGLegalPointsPercent(iPlayer, 5 * eReward);
	end
end

function TryToAttractNearbyCargos(iPlayer)
	if Players[iPlayer]:GetNumCities() == 0 then
		return;
	end
	for g, h in pairs(gT.Players) do
		if g ~= iPlayer then
			for iUnit in Players[g]:Units() do
				if iUnit:GetUnitType() == GameInfoTypes.UNIT_ITGSG_CARGO_SHIP then
					if LastRandom(1,5) == 3 then
						local uID = iUnit:GetID() .. "," .. g .. "," .. iUnit:GetGameTurnCreated();
						if Map.GetPlotByIndex(h.UnitsByID[uID].TargetAdjacent):GetOwner() ~= iPlayer then
							local iOcean = GetOceanID(iUnit:GetPlot());
							if iOcean ~= -1 then
								local nCh = GetNearestCityOfPlayerToPlot(iUnit:GetX(), iUnit:GetY(), iPlayer, 8)
								if nCh then
									if IsCoastOfOceanOrOcean(nCh:Plot(), iOcean) then
										print("Changing destination of trade unit", uID, iPlayer)
										gT.Players[g].UnitsByID[uID].TargetAdjacent = nCh:Plot():GetPlotIndex();
									end
								end
							end
						end
					end
				end
			end	
		end
	end 
end

function DoPirateDemoralizeArea(nhPlot, kPlayer)
	local kTeam = Teams[Players[kPlayer]:GetTeam()]
	local ph = -1;
	for i = 0, nhPlot:GetNumUnits() - 1 do
		local nUnit = nhPlot:GetUnit(i);
		if kTeam:IsAtWar(Players[nUnit:GetOwner()]:GetTeam()) and (not IsImmuneDoDemoralize(nUnit)) then
			local nDamage = math.min(25, nUnit:GetMaxHitPoints() - nUnit:GetDamage() - 1)
			if nDamage > 0 then
				nUnit:ChangeDamage(nDamage);
			end
			nUnit:SetDemoralized(true);
			ph = nUnit:GetOwner();
		end
	end
	return ph;
end