local uGarrison = GameInfoTypes.UNIT_GARRISON;
local toptimer = 0;
local cWonderC19Pre = GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_19;
local cPantheon10 = GameInfoTypes.BELIEF_ITG_PANTHEON_10;
local taskAnnex = TaskTypes.TASK_ANNEX_PUPPET;
local promUnc = GameInfoTypes.PROMOTION_ITGSC_UNCONTROLLABLE;
local cWalls = GameInfoTypes.BUILDINGCLASS_WALLS;
local uBombard = GameInfoTypes.UNIT_ITG_SIEGE_OTT_TREBUCHET;
local innoindu19 = GameInfoTypes.TECH_UNIQUE_ITG_INDUSTRIAL_19;
local prommerc24 = GameInfoTypes.PROMOTION_ITG_MERCENARY_24;

function HandlePlayerTurnDo(iPlayer)
	local timer = os.clock()
	if ITGdebug then
		print(iPlayer .. " new turn")
	end
	if Game.GetActivePlayer() == gT.Globals.LastPlayer then
		LuaEvents.ITGTurnOffTopPanel(true)
	end
	ClearUnitTempEffects(iPlayer, gT.Globals.LastPlayer)
	local timer2 = os.clock();
	MakePreviousTurnPlayer(gT.Globals.LastPlayer)
	local timer3 = os.clock();
	MakeCurrentTurnPlayer(iPlayer);
	gT.Globals.LastPlayer = iPlayer;
	local time = os.clock() - timer;
	if ITGdebug then
		print(iPlayer .. " end turn with time: " .. time, timer2 - timer, timer3 - timer)
	end
end
GameEvents.PlayerDoTurn.Add(HandlePlayerTurnDo)

function MakeCurrentTurnPlayer(iPlayer)
	local timersT = {}
	table.insert(timersT, {os.clock(), "Start"})
	local gTurn = GetITGGameTurn();
	for iCity in Players[iPlayer]:Cities() do
		iCity:SetDefenseBroken(false)
		if iCity:IsPuppet() then
			iCity:DoTask(taskAnnex)
		end
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		gT.Cities[cID].FishFoodReduction = 0;
		SetBasicCityYieldRate(iCity, yProduction, 0, "CI_TEMP_PROD")
	end
	PlayerDoTurnVariousUnitsBonuses(iPlayer)
	if ITGdebug then
		print("Hinvestigation", 0)
	end
	if Players[iPlayer]:IsBarbarian() then
		GreatEndOfTurnFunction()
	elseif gT.Players[iPlayer] then
		OnTurnPopProcess(iPlayer)
		local bMajor = (not Players[iPlayer]:IsMinorCiv());
		gT.Players[iPlayer].RailroadMadeT = 0;
		gT.Players[iPlayer].TurnPreVeryActive = false;		
		gT.Players[iPlayer].AlreadyTradedCurrencyThisTurn = {};
		DoEmbarkIssue(iPlayer) --HP based embarktion
		for iUnit in Players[iPlayer]:Units() do --ghost ships...
			local uID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
			if not gT.Players[iPlayer].UnitsByID[uID] then
				print("Hello unidentified unit", GameInfo.Units[iUnit:GetUnitType()].Type, uID)
				gT.Players[iPlayer].UnitsByID[uID] = {}
				gT.Players[iPlayer].UnitsByID[uID].XP = 0;
				for promID, sth in pairs(gT.Players[iPlayer].UnitClassPromotions[iUnit:GetUnitClassType()] or {}) do
					iUnit:SetHasPromotion(promID, true)
				end
			end
		end
		
		if ITGdebug then
			print("Hinvestigation", 1)
		end
		WonderEffectsDoTurn(iPlayer)
		PrepareCitiesDataForAmountOfAttacks(iPlayer)
		UpdateXPUnits(iPlayer)
		DoTurnPirateVision(iPlayer)
		DoHandleTemporarYieldModifiers(iPlayer)
		if bMajor then
			DoTurnSocialPoliciesBonuses(iPlayer, gTurn)
			GoldBudgetPlayerDoTurn(iPlayer); -- this should be pre science/legal/etc.
		else
			DoLogProtectionEndEra(iPlayer)
			CityStateQuestDoTurn(iPlayer)
		end
		
		if ITGdebug then
			print("Hinvestigation", 2)
		end
		table.insert(timersT, {os.clock(), "PreHelpTurn"})
		if Game.GetITGWarmUpTurn() < Game.GetGameTurn() then
			table.insert(timersT, {os.clock(), "AfterCodex"})
			DoTurnAcademiesReward(iPlayer)
			DoTurnManufactoriesReward(iPlayer)
			table.insert(timersT, {os.clock(), "AfterAcaManu"})
			TheCultureIndicatorTurn(iPlayer, bMajor)
			table.insert(timersT, {os.clock(), "AfterCultInd"})
			DoWorkRate(iPlayer)
			table.insert(timersT, {os.clock(), "AfterWorkRate"})
			PlayerTurnEndEraData(iPlayer)
			table.insert(timersT, {os.clock(), "AfterTurnEnd"})
			if bMajor then
				DoTurnEconomicCaravans(iPlayer)
				DoCheckIfMercenariesShouldFlee(iPlayer)
				NewTurnPlayerAdmiralsAndGenerals(iPlayer)
				--this one add diagnosis tab
				table.insert(timersT, {os.clock(), "AfterEcoMercGenAdm"})
				NewTurnPlayerScience(iPlayer)
				--this one add diagnosis tab
				table.insert(timersT, {os.clock(), "AfterScience"})
				NewTurnPlayerCulture(iPlayer)
				UpdatePlayerFaithDoTurn(iPlayer)
				table.insert(timersT, {os.clock(), "AfterCultureFaith"})
				DoTurnGreatPeoplePoints(iPlayer)
				--this one add diagnosis tab
				table.insert(timersT, {os.clock(), "AfterGP"})
				DoTurnLegalPostApocalypse(iPlayer)
				table.insert(timersT, {os.clock(), "AfterLegalPost"})
				DoTurnInnovationsAbilityRelated(iPlayer)
				DoTurnFestivals(iPlayer)
				DoTurnMeritocracy(iPlayer) -- no reason to mess with city-states;
				DoTurnPlayerGovernors(iPlayer)
			end
			PlayerDoTurnIdeology(iPlayer)
			DoTurnMoraleUpdate(iPlayer)
		end
		PlayerCheckAuctionDeals(iPlayer)
		table.insert(timersT, {os.clock(), "AuctionDeals"})
		if ITGdebug then
			print("Hinvestigation", 3)
		end
		if bMajor then
			CultureBonusFunctionDoTurn(iPlayer)
		end
		--REAL END TURN (ALL BONUSES BEFORE THAT! ACTIONS AFTER THAT)
		if not Players[iPlayer]:IsHuman() then
			AIConstructTrainHelpFunction(iPlayer)
			DoAIConsiderMakingRailroad(iPlayer)
			if bMajor then
				DoAIAuctionHouseManagemenet(iPlayer)
				AIReassignSpies(iPlayer)
				AIYieldManagementHelp(iPlayer)
			end
		else
			if gT.Players[iPlayer].MasterOfWhispers then
				AIReassignSpies(iPlayer)
			end
			DoAIAuctionHouseManagemenet(iPlayer)
			PrepareCSAlerts(iPlayer)
			DoTurnAchievementCheck(iPlayer)
		end
		for gpID, sth in pairs(gT.Players[iPlayer].GPQueue) do
			FinishAddingNewGPToThePlayer(iPlayer, gpID)
		end
		if ITGdebug then
			print("Hinvestigation", 4)
		end
		gT.Players[iPlayer].GPQueue = {};
		DoAILogicForAbilitiesAndPoints(iPlayer, bMajor)
		gT.Players[iPlayer].QueueActionsRealEndTurn = {};
		table.insert(timersT, {os.clock(), "AILogic"})
	end
	
	if ITGdebug then
		print("Hinvestigation", 6)
	end
	UncontrollableUnitsNewGame(iPlayer)
	if Game.GetActivePlayer() == iPlayer then
		Events.OpenInfoCorner()
		Events.SerialEventEndTurnDirty()
		LuaEvents.ITGSGTopPanelDirty()
	end
	table.insert(timersT, {os.clock(), "Final"})
	if timersT[#timersT][1] - timersT[1][1] > 0.5 then
		if iPlayer == 63 then
			print("Barb turn: ", timersT[#timersT][1] - timersT[1][1])
		else
			for i, td in pairs(timersT) do
				if timersT[i-1] then
					if timersT[i][1] - timersT[i-1][1] > 0.35 then
						print("Very Long", iPlayer, timersT[i][1] - timersT[i-1][1], timersT[i][2], timersT[i-1][2]) 
					end
				end
			end
		end
	end
end

function UncontrollableUnitsNewGame(bPlayer)
	local iPlayer = bPlayer or Game.GetActivePlayer()
	for iUnit in Players[iPlayer]:Units() do
		if iUnit:IsHasPromotion(promUnc) then
			iUnit:SetMoves(0);
		end
	end
end

function GetMaxWorkRateIntoHeal(iPlayer)
	local base = 50;
	if HasPlayerTech(iPlayer, innoindu19, "3453423") then
		base = base + 50;
	end
	if gT.Players[iPlayer].HasIdeology[34] then
		base = base + 50;
	end
	return base;
end

function CityCanHealNormally(iCity, iPlayer)
	if gT.Players[iPlayer].CultBonusOn[43] then
		if iCity:GetDamage() > (iCity:GetMaxHitPoints() / 2) then
			return true;
		end
	end
	if (not iCity:IsResistance()) and ((not iCity:HasPerformedRangedStrikeThisTurn()) or (iCity:GetMaxHitPoints() - iCity:GetDamage() <= 1)) then
		return true;
	end
	return false;
end

function GetCityHealRateTooltip(iCity, cID, iPlayer)
	local bCanCityHealNormally = CityCanHealNormally(iCity, iPlayer);
	local text = "Heal Rate sources:"
	local hTab = {}
	local total = 0;
	local bCanIdeologyPop = false;
	local mod = 1;
	if bCanCityHealNormally then
		table.insert(hTab, {10, "Base"});
	end
	if gT.Players[iPlayer].HasIdeology[51] then
		table.insert(hTab, {math.floor(iCity:GetDamage() / 20), "Finest Hour"});
	end
	table.insert(hTab, {gT.Players[iPlayer].ExtraHealRateFromMorale, "Morale"});
	if iCity:IsHasBuilding(cWonderC19Pre) then
		table.insert(hTab, {10, "Wonder"});
	end
	if iCity:CanWorkRateHeal() then
		local workRInHeal = math.floor(math.min(GetMaxWorkRateIntoHeal(iPlayer), gT.Cities[cID].WorkRate)/5)*5;
		if workRInHeal > 0 then
			table.insert(hTab, {workRInHeal / 5, "Work Rate (" .. workRInHeal .. "[ICON_WORKER])"});
		end
	end
	for a, b in pairs(hTab) do
		if b[1] ~= 0 then
			text = text .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]" .. b[1] .. "[ENDCOLOR] from " .. b[2] .. ".";
			total = total + b[1];
		end
	end
	if bCanCityHealNormally then
		if gT.Cities[cID].LastTimeDamaged < GetITGGameTurn() -4 then
			text = text .. "[NEWLINE][ICON_BULLET]+300% base Heal Rate due to not being damaged in last four turns."
			mod = mod + 3;
		end
	else
		if iCity:IsResistance() then
			text = text .. "[NEWLINE]Base Heal Rate is disabled due to [ICON_RESISTANCE] Resistance.";
		elseif iCity:HasPerformedRangedStrikeThisTurn() and (iCity:GetMaxHitPoints() - iCity:GetDamage() > 1) then
			text = text .. "[NEWLINE]Base Heal Rate is disabled due to City performing a ranged strike this turn.";
		end
		bCanIdeologyPop = true;
	end
	total = math.floor(total * mod);
	if gT.Players[iPlayer].HasIdeology[50] and bCanIdeologyPop then
		if iCity:GetDamage() / iCity:GetMaxHitPoints() > 50 then 
			if iCity:GetPopulation() > 1 then
				total = total + 50;
				text = text .. "[NEWLINE][ICON_BULLET]An extra [COLOR_POSITIVE_TEXT]+50[ENDCOLOR] points for the cost of 1 [ICON_CITIZEN] Citizen from ideology."
			end
		end
	end
	if IsBeliefPresentInACity(iCity, cPantheon10) then
		text = text .. "[NEWLINE][ICON_BULLET]An extra [COLOR_POSITIVE_TEXT]+7[ENDCOLOR] points from belief."
		total = total + 7; 
	end
	text = text .. "[NEWLINE]----------------[NEWLINE]Total heal rate: [COLOR_POSITIVE_TEXT]" .. total .. "[ENDCOLOR].";
	return text;
end

function GetHealRate(iCity,cID,iPlayer, bNow)
	local base, mod, extra = 10, 1, 0;
	local bJustDamaged = false;
	if CityCanHealNormally(iCity, iPlayer) then
		if gT.Cities[cID].LastTimeDamaged < GetITGGameTurn() -4 then
			mod = mod + 3;
		elseif gT.Cities[cID].LastTimeDamaged < GetITGGameTurn() -2 then
			mod = mod + 1;
		end
	else
		bJustDamaged = true;
		base = base - 10;
	end
	if gT.Players[iPlayer].HasIdeology[51] then
		base = base + math.floor(iCity:GetDamage() / 20);
	end
	base = base + gT.Players[iPlayer].ExtraHealRateFromMorale;
	if iCity:IsHasBuilding(cWonderC19Pre) then
		base = base + 10;
	end
	if iCity:CanWorkRateHeal() then
		local workRInHeal = math.floor(math.min(GetMaxWorkRateIntoHeal(iPlayer), gT.Cities[cID].WorkRate)/5)*5;
		if workRInHeal > 0 then
			base = base + workRInHeal / 5
			if bNow then
				MakeCitySpendWorkRate(iCity, iPlayer, workRInHeal)
			end
		end
	end
	local tps = math.floor(base * mod);
	if bNow and bJustDamaged and gT.Players[iPlayer].HasIdeology[50] then
		if iCity:GetDamage() / iCity:GetMaxHitPoints() > 50 then 
			if iCity:GetPopulation() > 1 then
				extra = extra + 50;
				iCity:ChangePopulation(-1, true)
			end
		end
	end
	if IsBeliefPresentInACity(iCity, cPantheon10) then
		extra = extra + 7;
	end
	return tps + extra;
end

function ShouldHeal(iCity, cID, iPlayer)
	if not iCity:IsResistance() then
		if not iCity:HasPerformedRangedStrikeThisTurn() then
			return true;
		end
	end
	return false;
end

function DoOnEndTurnUnitsBonuses(iPlayer)
	for iUnit in Players[iPlayer]:Units() do
		local unitType = iUnit:GetUnitType();
		if unitType == uBombard then
			local uID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
			local lTurn = gT.Players[iPlayer].UnitsByID[uID].LastAttackTurn == GetRealGameTurn();
			local bonus = 5;
			if lTurn then
				bonus = 0;
			end
			local cBonus = gT.Players[iPlayer].UnitsByID[uID].BombardBonus or 0;
			if cBonus ~= bonus then
				ChangeITGBaseCombatStrength(iUnit, nil, bonus - cBonus)
				gT.Players[iPlayer].UnitsByID[uID].BombardBonus = bonus;
			end
		elseif unitType == GameInfoTypes.UNIT_ITG_AOT_CHARIOT_UU_3 then
			EndTurnParthianShot(iUnit, iPlayer)
		elseif unitType == GameInfoTypes.UNIT_ITG_AOT_SWORDSMAN_UU_1 then
			ProvokeNearbyEnemiesWithChance(iUnit, iPlayer, 33)
		elseif unitType == GameInfoTypes.UNIT_ITG_AOT_SPEARMAN_UU_2 then
			if iUnit:GetFortifyTurns() > 0 then
				ProvokeNearbyEnemiesWithChance(iUnit, iPlayer, 50)
			else
				ProvokeNearbyEnemiesWithChance(iUnit, iPlayer, 25)
			end
		elseif unitType == GameInfoTypes.UNIT_ITG_AOT_SPEARMAN_UU_0 then
			DemoralizeAdjacentEnemiesWithChance(iUnit:GetX(), iUnit:GetY(), iPlayer, 33)
		end
		if iUnit:IsHasPromotion(prommerc24) then
			DemoralizeAdjacentEnemiesWithChance(iUnit:GetX(), iUnit:GetY(), iPlayer, 33)
		end
	end
end

function HealCityDamage(iCity, amount)
	local activeheal = math.min(amount, iCity:GetDamage());
	if activeheal > 0 then
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		iCity:ChangeDamage(- activeheal)
		gT.Cities[cID].LastTurnDamage = gT.Cities[cID].LastTurnDamage - activeheal;
	end
end

function MakePreviousTurnPlayer(iPlayer)
	local bDefDirt = false;
	if gT.Players[iPlayer] then
		for iCity in Players[iPlayer]:Cities() do
			if iCity:GetDamage() > 0 then
				local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
				if gT.Cities[cID].LastTurnDamage ~= iCity:GetDamage() then
					gT.Cities[cID].TotalDamage = gT.Cities[cID].TotalDamage + iCity:GetDamage() - gT.Cities[cID].LastTurnDamage;
					if gT.Cities[cID].TotalDamage ~= math.floor(gT.Cities[cID].TotalDamage) then
						print("Investigation Total Damage check", iCity:GetID(), iPlayer, gT.Cities[cID].TotalDamage, iCity:GetDamage(), gT.Cities[cID].LastTurnDamage)
					end
					gT.Cities[cID].LastTimeDamaged = GetITGGameTurn();
				end
				local healRate = GetHealRate(iCity,cID,iPlayer, true);
				if healRate > 0 then
					iCity:ChangeDamage(- healRate);
				end
				gT.Cities[cID].LastTurnDamage = iCity:GetDamage()
				if iCity:GetDamage() == 0 then
					if GetITGCityInteger(iCity, "CI_IDEO_50") > 0 then
						SetITGCityInteger(iCity, "CI_IDEO_50", 0)
						bDefDirt = true;
					end
				end
			end
		end
		if gT.Players[iPlayer].HasIdeology[34] then
			local totava = math.floor(GetTotalWorkRateStored(iPlayer) / 4) ;
			for jUnit in Players[iPlayer]:Units() do
				local jID = jUnit:GetID() .. "," .. iPlayer .. "," .. jUnit:GetGameTurnCreated();
				if gT.FortsByUnitID[jID] then
					local tHealMax = math.min(math.min(jUnit:GetDamage(), 20), totava)
					if tHealMax > 0 then
						jUnit:ChangeDamage(-tHealMax)
						DoPayInWorkRateCloseToPlot(iPlayer, jUnit:GetPlot(), tHealMax * 4, "HealingFort")
						totava = totava - tHealMax;
						if totava <= 0 then
							break;
						end
					end
				end
			end
		end
		if bDefDirt then
			AdjustStrengthOfAllCities(iPlayer)
		end
		DoSpyActionAfterTurn(iPlayer)
		DoMakeIdeologyBonusesPostTurn(iPlayer)
		OnEndTurnPeaceLock(iPlayer)
		DoOnEndTurnUnitsBonuses(iPlayer)
		DoOnEndTurnInnovations(iPlayer)
		DoHandleAngryCrit(iPlayer)
		if not Players[iPlayer]:IsMinorCiv() then
			DoCheckIfMercenariesShouldFlee(iPlayer)
		end
	end
	EndTurnCombatStuff(iPlayer)
end

function AssignAIConstructionProcess(iCity)
	local hTab = {}
	for row in GameInfo.Buildings() do
		if iCity:CanConstruct(row.ID) then
			table.insert(hTab, {1, row.ID})
		end
	end
	for row in GameInfo.Units() do
		if iCity:CanTrain(row.ID) then
			table.insert(hTab, {2, row.ID})
		end
	end
	if #hTab > 0 then
		local ldata = hTab[LastRandom(1, #hTab)];
		if ldata[1] == 1 then
			iCity:PushOrder(OrderTypes.ORDER_CONSTRUCT, ldata[2])
		else
			iCity:PushOrder(OrderTypes.ORDER_TRAIN, ldata[2])
		end
	end
end

LuaEvents.ITG_CallRandomCityOrders.Add(function()
	for iCity in Players[Game.GetActivePlayer()]:Cities() do
		if (iCity:GetProductionBuilding() == -1) and (iCity:GetProductionUnit() == -1) and (iCity:GetProductionProcess() == -1) then
			AssignAIConstructionProcess(iCity)
		end
	end
end)

local ITGTimeDiagnosisSpy = {}
local iTGTimeDiagnosisMint = {}
local ITGTimeDiagnosisMilitaryPen = {}
local ITGTimeDiagnosisFortAndColonies = {}
local ITGTimeDiagnosisProcess = {}
local iTGTimeDiagnosisCultureBonus = {}
local ITGTimeDiagnosisPlotBonuses = {}
local iTGTimeDiagnosisWonderOverview = {}
local ITGTimeDiagnosisArtistOver = {}
local iTGTimeDiagnosisWarPeace = {}
local iTGTimeDiagnosisOther = {}
local ITGTimeDiagnosisFable = {}

function DoPrintTimeDiagnosisITG(tab, string)
	local max, total = 0, 0;
	for i, time in pairs(tab) do
		if time > max then
			max = time;
		end
		total = total + time;
	end
	print("ITGDiagnosis Time:", string, "Max:", max, "Total:", total)
end

--[[LuaEvents.ITGCallForTimeDiagnosis.Add(function()
	DoPrintTimeDiagnosisITG(ITGTimeDiagnosisSpy, "ENDTURNBARB SPY")
	DoPrintTimeDiagnosisITG(iTGTimeDiagnosisMint, "ENDTURNBARB MINT")
	DoPrintTimeDiagnosisITG(ITGTimeDiagnosisMilitaryPen, "ENDTURNBARB MILITARY PEN")
	DoPrintTimeDiagnosisITG(ITGTimeDiagnosisFortAndColonies, "ENDTURNBARB FORT AND COLONIES")
	DoPrintTimeDiagnosisITG(ITGTimeDiagnosisProcess, "ENDTURNBARB PROCESSES")
	DoPrintTimeDiagnosisITG(iTGTimeDiagnosisCultureBonus, "ENDTURNBARB CULTURE")
	DoPrintTimeDiagnosisITG(ITGTimeDiagnosisPlotBonuses, "ENDTURNBARB PLOT")
	DoPrintTimeDiagnosisITG(iTGTimeDiagnosisWonderOverview, "ENDTURNBARB WONDER")
	DoPrintTimeDiagnosisITG(ITGTimeDiagnosisArtistOver, "ENDTURNBARB ARTIST")
	DoPrintTimeDiagnosisITG(iTGTimeDiagnosisOther, "ENDTURNBARB OTHER")
	DoPrintTimeDiagnosisITG(ITGTimeDiagnosisFable, "ENDTURNBARB FABLE")
end)]]

function GreatEndOfTurnFunction()
	local nTurn = GetITGGameTurn() + 1
	--right now everything that can prevent process from working must be run instantly:
	GreatOverTurnPlague()
	TakeCareOfAllOtherProcesses()
	--processes should be first
	AcademiesPrestigeOverTurn()
	CustomsHousesOverTurn()
	ManufactoriesOverTurn()
	GreatSpyFunction()
	AssignEndTurnMintPowerChanges()
	AdjustMilitaryPenalty()
	CheckEmptyFortsAndColonies()
	GreatOverCultureBonusFunctionDoTurn()
	GreatRecheckOfPlotBonuses()
	GreatWonderOverFunction()
	GreatArtistOverFunction()
	WarPeaceLockOverStuff()
	GreatLeagueOverFunction()
	DoTurnPirateBarb()
	EndTurnBarbMercenary() --after leagues
	DoTurnGlobalization()
	DoCheckAllHeresies()
	DoUprisingsTurn()
	ArchaeologyDoTurn()
	DoTurnUniqueImprovements()
	DoTurnStockExchange()
	DoTurnNuclearProject()
	EndTurnAuctionManagement() -- HERE readjustments of possible negative amount of resources :/
	DoTurnSpecialAuctionDeals()
	DoCodexOverTurn()
	StrayGovernorsDoTurn()
	FascismAndCommercialismDoTurn()
	DoTurnBarbAuthority()
	DoOverturnDominationMode()
	SpecialArmyDoTurn()
	DoTurnIdeologies() -- last so everything may interfere with nat unity fires first
	DoTurnVictoryPoints()
	EndTurnMoveSatellites()
	if gT.Globals.FreeTechForBackwardCiv[nTurn] then
		DoFreeTechForMostBackwardCivs()
	end
	local season = GetSeasonFromTurn(nTurn);
	if season == 4 then
		AnnualFishMigration()
	end
	if (nTurn) % 5 == 0 then
		DoRecalculateFollowersInOfficialStates()
		DoClearGTTable()
	end
	AIAutoHandicap(nTurn - 1)
	PlayerBarbTurnEndEraData()	
	CheckTheIncomingYear(season, nTurn) -- kinda last
	if gT.Globals.LastTurn == (nTurn - 1) then
		EndTheEraGameStuff()
	elseif gT.Globals.GameRetired then
		if gT.Globals.LastTurn == nTurn then
			DoReturnRetiredPlayers();
		end
	end
end

function EndTheEraGameStuff(bReload)
	gT.Globals.EndGamePanel = true;
	PrepareDataFromNationality()
	Game.SetITGPaused(true)
	if not bReload then
		gT.Globals.TotalTimer = gT.Globals.TotalTimer + os.clock() - gT.Globals.CurrentTimer;
		gT.Globals.CurrentTimer = os.clock();
		SaveScoresVictory()
		CheckAchievementsOnScenarioEnd()
		DoStoreGlobalsInfo()
	end
	LuaEvents.ITG_AnythingBlockEndEra()
	local bBlock = MapModData.ITGSG;
	MapModData.ITGSG = nil;
	if not bBlock then
		LuaEvents.ITG_EndOfAllTheStuff()
	end
end

LuaEvents.ITG_EndEraPanelClosing.Add(function()
	gT.Globals.EndGamePanel = false;
end)

function AssignAIConstructionProcess(iCity, bInitial)
	local hTab = {}
	for row in GameInfo.Buildings() do
		if iCity:CanConstruct(row.ID) then
			table.insert(hTab, {1, row.ID})
		end
	end
	for row in GameInfo.Units() do
		if iCity:CanTrain(row.ID) then
			table.insert(hTab, {2, row.ID})
		end
	end
	if #hTab > 0 then
		local ldata = hTab[LastRandom(1, #hTab)];
		if ldata[1] == 1 then
			iCity:PushOrder(OrderTypes.ORDER_CONSTRUCT, ldata[2])
			if bInitial then
				iCity:SetBuildingProduction(ldata[2], LastRandom(0, math.floor(iCity:GetBuildingProductionNeeded(ldata[2])*3/4)))
			end
		else
			iCity:PushOrder(OrderTypes.ORDER_TRAIN, ldata[2])
			if bInitial then
				iCity:SetUnitProduction(ldata[2],  LastRandom(0, math.floor(iCity:GetUnitProductionNeeded(ldata[2])*3/4)))
			end
		end
	end
end

function ActivePlayerQueueGeneralChoose()
	if gT.Globals.TruelyRequireReload then
		print("Game reload on ActivePlayerTurnStart")
		LuaEvents.ITG_HideLeaderHead();
		DoQuickReload();
		return;
	end
	local iPlayer = Game.GetActivePlayer()
--	SciencePlayerDoTurn(iPlayer)
--	FaithPlayerDoTurn(iPlayer)
--	for it, data in pairs(gT.Players[iPlayer].HumanQueueActions) do
--		LuaEvents.ITGSG_CallQueueOfHumanDecisions(data)
--	end
--	print("New Player Active Turn")
	for it, data in pairs(gT.Players[iPlayer].TheRaceInfoTable) do
		LuaEvents.ITGSG_CallRaceInfo(data)
	end
	if gT.Players[iPlayer].SocDevPopup then
		MapModData.ITGSG = gT.Players[iPlayer].SocDevPopup;
		LuaEvents.ITGSG_CallSocDevPopup()
		gT.Players[iPlayer].SocDevPopup = nil;
	end
	if gT.Players[iPlayer].RandomRewardPopup then
		MapModData.ITGSG = gT.Players[iPlayer].RandomRewardPopup;
		LuaEvents.ITGSG_CallRandomRewardPopup()
		gT.Players[iPlayer].RandomRewardPopup = nil;
	end
	CleanGTInfoLabels()
	gT.Players[iPlayer].TheRaceInfoTable = {}
	DoCreateLabels()
	DoAutomaticTemplarBuildingPurchase(iPlayer)
	DoAutomaticMissionaries(iPlayer)
	DoAutomaticAcademySupport(iPlayer)
	DoAutomaticRailroadMaking(iPlayer)
	DoAutomaticBullying(iPlayer)
	DoAutomaticConstructionOrder(iPlayer)
	DoAutomaticConstructionOrder(iPlayer)
	DoAutomaticBombardmentCities(iPlayer)
	DoAutomaticPalaceUpgrades(iPlayer)
-- make it block turn... easier than that
	LuaEvents.ITGTurnOffTopPanel(false)
end
Events.ActivePlayerTurnStart.Add(ActivePlayerQueueGeneralChoose)

function CleanGTInfoLabels()
	if gT and gT.InfoClean then
		for i, data in pairs(gT.InfoClean) do
			RemoveLabelOnPlot(Map.GetPlotByIndex(data[1]), data[2], true, nil, data[3])
		end
		gT.InfoClean = nil;
	end
end

function OnActivePlayerTurnEnd()
	CleanGTInfoLabels()
end
Events.ActivePlayerTurnEnd.Add( OnActivePlayerTurnEnd );

function EraseTradeRoutesBeneath(iPlayer)
	local toCheck = {}
	for iUnit in Players[iPlayer]:Units() do
		if IsRealCombatUnit(iUnit) and (not iUnit:IsImmobile()) then
			local iPlot = iUnit:GetPlot();
			if iPlot:GetNumUnits() > 1 then
				toCheck[iPlot] = 1;
			end
		end
	end
	for iCity in Players[iPlayer]:Cities() do
		toCheck[iCity:Plot()] = 1;
	end
	local pTeam = Teams[Players[iPlayer]:GetTeam()];
	local toKill = {}
	for iPlot, s in pairs(toCheck) do
		for i = 0, iPlot:GetNumUnits() - 1 do
			local iUnit = iPlot:GetUnit(i);
			local iOwner = iUnit:GetOwner();
			if iOwner ~= iPlayer then
				if pTeam:IsAtWar(Players[iOwner]:GetTeam()) then
					if (not IsRealCombatUnit(iUnit)) and (not iUnit:IsImmobile()) then
						table.insert(toKill, iUnit)
					end
				end
			end
		end
	end
	for i, iUnit in pairs(toKill) do
		local jPlayer = iUnit:GetOwner();
		local jID = iUnit:GetID() .. "," .. jPlayer .. "," .. iUnit:GetGameTurnCreated()
		if gT.Players[jPlayer] then
			if gT.Players[jPlayer].UnitsByID[jID] then
				if gT.Players[jPlayer].UnitsByID[jID].TargetAdjacent then
					local unitType = iUnit:GetUnitType();
					local dType = iUnit:GetDomainType();
					local kUnit;
					local iPlot = iUnit:GetPlot();
					iUnit:JumpToNearestValidPlot();
					iPlot = iUnit:GetPlot();
					if iPlot:IsCity() and iPlot:GetOwner() == iPlayer then
						print("This seems to never fire 923/12/6/32/2");
						CaravanTradeCargoKilled(jPlayer, iPlot:GetX(), iPlot:GetY(), 0, jID, unitType, iPlayer, nil, true)
						iUnit:Kill(false, -1);
					else
						for j = 0, iPlot:GetNumUnits() - 1 do
							local jUnit = iPlot:GetUnit(j);
							if jUnit:GetOwner() == iPlayer then
								if IsRealCombatUnit(jUnit) and (not jUnit:IsImmobile()) then
									if jUnit:GetDomainType() == dType then
										kUnit = jUnit;
										break;
									end
								end
							end
						end
						if kUnit then
						--	print("Caravan or not just pseudo-killed", kUnit:GetName(), jID, iPlayer, jPlayer)
							CaravanTradeCargoKilled(jPlayer, iPlot:GetX(), iPlot:GetY(), 0, jID, unitType, iPlayer, kUnit)
							iUnit:Kill(false, -1);
						end
					end
				end
			end
		else
			print("Unit beneath", jPlayer, iUnit:GetName())
		end
	end
end

local ccgtc = 0;
function ITGdiagnosisTool93423()
	return ccgtc;
end
function DoClearGTTable()
	for g, h in pairs(gT.Players) do
		local hTab = {}
		for iUnit in Players[g]:Units() do	
			local uID = iUnit:GetID() .. "," .. g .. "," .. iUnit:GetGameTurnCreated();
			hTab[uID] = true;
		end
		for uID, data in pairs(h.UnitsByID) do
			if not hTab[uID] then
				gT.Players[g].UnitsByID[uID] = nil;
				ccgtc = ccgtc + 1;
			end
		end
	end
end

