local pPromAdmi21 = GameInfoTypes.PROMOTION_ITG_GREAT_ADMIRAL_21;
local pPromAdmi31 = GameInfoTypes.PROMOTION_ITG_GREAT_ADMIRAL_31;
local pPromGen23 = GameInfoTypes.PROMOTION_GREAT_GENERAL_23;
local pPromGen36 = GameInfoTypes.PROMOTION_GREAT_GENERAL_36;
local pPromGen35 = GameInfoTypes.PROMOTION_GREAT_GENERAL_35;
local uMedLongsword8 = GameInfoTypes.UNIT_ITG_TRIAL_LONGSWORDSMAN_8;
local mercProm18 = GameInfoTypes.PROMOTION_ITG_MERCENARY_18;
local uBalestrieli = GameInfoTypes.UNIT_ITG_TRIAL_CROSSBOWMAN_2;
local uDestroyer5 = GameInfoTypes.UNIT_ITG_DESTROYER_UU_5;
local uTank13 = GameInfoTypes.UNIT_ITG_TANK_UU_13;
local uAntiTank2 = GameInfoTypes.UNIT_ITG_ANTI_TANK_GUN_UU_2;
local uAntiTank5 = GameInfoTypes.UNIT_ITG_ANTI_TANK_GUN_UU_5;
local uParthain = GameInfoTypes.UNIT_ITG_AOT_CHARIOT_UU_3
local uGGuard = GameInfoTypes.UNIT_ITG_AOT_SWORDSMAN_UU_4;
local uChosenSword = GameInfoTypes.UNIT_ITG_AOT_SWORDSMAN_UU_5;
local uPortRifleman = GameInfoTypes.UNIT_ITG_IND_LINE_INFANTRY_UU_7;
local RangAtt = GameInfoTypes.MISSION_RANGE_ATTACK;
local uSipahiIndustrial = GameInfoTypes.UNIT_ITG_IND_LANCER_UU_4;

function PlayerDoTurnVariousUnitsBonuses(iPlayer)
	local tEqualize = {}
	for iUnit in Players[iPlayer]:Units() do
		local unitType = iUnit:GetUnitType();
		if unitType == uGGuard then
			tEqualize[uGGuard] = true;
		elseif unitType == uChosenSword then
			if iUnit:GetCurrHitPoints() <= 10 then
				iUnit:ChangeDamage(-50);
			end
		elseif unitType == uBalestrieli then
			if iUnit:IsEmbarked() then
				BasicRangedStrikeAtTurnStart(iUnit, iPlayer, 2)
			end
		elseif unitType == uAntiTank2 then
			if (iUnit:GetPlot():IsCity()) or (gT.Forts[iUnit:GetPlot():GetPlotIndex()] and (not iUnit:GetPlot():IsImprovementPillaged())) then
				iUnit:ChangeTemporaryMoves(3);
			end
		elseif unitType == uMedLongsword8 then
			if iUnit:IsNearGreatGeneral() then
				iUnit:ChangeTemporaryMoves(1);
			end
		elseif unitType == uDestroyer5 then
			BasicRangedStrikeAtTurnStart(iUnit, iPlayer, 1, true, 45)
		elseif unitType == uTank13 then
			BasicRangedStrikeAtTurnStart(iUnit, iPlayer, 2, true, 50)
		elseif unitType == uAntiTank5 then
			if (iUnit:GetPlot():IsCity()) or (gT.Forts[iUnit:GetPlot():GetPlotIndex()] and (not iUnit:GetPlot():IsImprovementPillaged())) then
				BasicRangedStrikeAtTurnStart(iUnit, iPlayer, 2, true, 45)
			end
		elseif unitType == uPortRifleman then
			DoPortugeseRiflemanCounterStrike(iUnit, iPlayer)
		elseif unitType == uParthain then
			DoParthianShot(iUnit, iPlayer)
		elseif unitType == uSipahiIndustrial then
			local uID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
			if gT.Players[iPlayer] and gT.Players[iPlayer].UnitsByID[uID].TempSipahi then
				ChangeITGBaseCombatStrength(iUnit, -4, nil)
				gT.Players[iPlayer].UnitsByID[uID].TempSipahi = nil;
			end
		elseif gf_DoTurnUnitType[unitType] then
			gf_DoTurnUnitType[unitType](iUnit, iPlayer)
		end
		if iUnit:IsHasPromotion(mercProm18) or iUnit:IsHasPromotion(pPromGen23) or iUnit:IsHasPromotion(pPromAdmi21) then
			DoSpeedUpAdjacentUnits(iUnit, iPlayer, 2)
		end
		if iUnit:IsHasPromotion(pPromGen36) then
			DoTryPlacingFort(iUnit:GetPlot(), iPlayer, 4)
		end
		if iUnit:IsHasPromotion(pPromGen35) or iUnit:IsHasPromotion(pPromAdmi31) then
			DoChangeSpecializationProgress(iPlayer, 9)
		end
	end
	for unitType, sth in pairs(tEqualize) do
		EqualizeHPOfUnitType(iPlayer, unitType);
	end
	HandleProvocations(iPlayer)
end

function DoSpeedUpAdjacentUnits(iUnit, iPlayer, num)
	local tab = {}
	local dd = iUnit:GetDomainType();
	for dUnit in Players[iPlayer]:Units() do
		if dUnit:GetDomainType() == dd then
			if CanBeSpeedUpByAnything(dUnit) then
				if Map.PlotDistance(dUnit:GetX(), dUnit:GetY(), iUnit:GetX(), iUnit:GetY()) < 2 then
					table.insert(tab, dUnit)
				end
			end
		end
	end
	tab = Shuffle(tab);
	for i = 1, num do
		if tab[i] then
			tab[i]:ChangeTemporaryMoves(1)
		end
	end
end

local bDuringRainOfArrows = false;
function DoRainOfArrowsAbility(iUnit, iPlayer, iX, iY)
	if bDuringRainOfArrows then
		return;
	end
	bDuringRainOfArrows = true;
	local uType = iUnit:GetUnitType();
	for jUnit in Players[iPlayer]:Units() do
		if jUnit:GetUnitType() == uType then
			if jUnit:GetID() ~= iUnit:GetID() and (not jUnit:IsEmbarked()) then
				if Map.PlotDistance(jUnit:GetX(), jUnit:GetY(), iUnit:GetX(), iUnit:GetY()) < 2 then
					if DoCheckIfCanExtraAttackPlot(jUnit, iX, iY) then
						break;
					end
				end
			end
		end
	end
	bDuringRainOfArrows = false;
end

function DoCheckIfCanExtraAttackPlot(jUnit, iX, iY)
	local bDone = false;
	local iMoves = jUnit:GetMoves();
	local bOutOfAttacks = jUnit:IsOutOfAttacks();
	jUnit:SetMadeAttack(false);
	if jUnit:CanStartMission(GameInfoTypes.MISSION_RANGE_ATTACK, iX, iY) then
		jUnit:PushMission(GameInfoTypes.MISSION_RANGE_ATTACK, iX, iY)
		bDone = true;
	end
	jUnit:SetMoves(iMoves);
	jUnit:SetMadeAttack(bOutOfAttacks);
	return bDone;
end

function DoParthianShot(iUnit, iPlayer)
	if gT.Players[iPlayer] then
		local uID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
		if not gT.Players[iPlayer].UnitsByID[uID] then
			return;
		end
		if not gT.Players[iPlayer].UnitsByID[uID].ParthianShot then
			gT.Players[iPlayer].UnitsByID[uID].ParthianShot = {};
			return;
		end
		local iMoves = iUnit:GetMoves();
		if iUnit:IsOutOfAttacks() or (iMoves == 0) then --demorale, etc.
			return;
		end
		if iUnit:IsEmbarked() then
			return;
		end
		for j = 0, 5 do
			local nPlot = Map.PlotDirection(iUnit:GetX(), iUnit:GetY(), j);
			if nPlot and (not nPlot:IsCity()) then
				if iUnit:CanStartMission(GameInfoTypes.MISSION_RANGE_ATTACK, nPlot:GetX(), nPlot:GetY()) then
					local tUnit = nPlot:GetBestDefender(-1, iPlayer, iUnit, 1);
					if tUnit then
						local tID = tUnit:GetID() .. "," .. tUnit:GetOwner() .. "," .. tUnit:GetGameTurnCreated();
						if not gT.Players[iPlayer].UnitsByID[uID].ParthianShot[tID] then
							iUnit:PushMission(GameInfoTypes.MISSION_RANGE_ATTACK, nPlot:GetX(), nPlot:GetY())
							iUnit:SetMoves(iMoves);
							iUnit:SetMadeAttack(false);
						end
					end
				end
			end
		end
	end
end

function EndTurnParthianShot(iUnit, iPlayer)
	if gT.Players[iPlayer] then
		local uID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
		if not gT.Players[iPlayer].UnitsByID[uID] then
			return;
		end
		gT.Players[iPlayer].UnitsByID[uID].ParthianShot = {};
		for j = 0, 5 do
			local nPlot = Map.PlotDirection(iUnit:GetX(), iUnit:GetY(), j);
			if nPlot and (not nPlot:IsCity()) then
				for n = 0, nPlot:GetNumUnits() - 1 do
					local nUnit = nPlot:GetUnit(n);
					if nUnit:GetOwner() ~= iPlayer then
						gT.Players[iPlayer].UnitsByID[uID].ParthianShot[nUnit:GetID() .. "," .. nUnit:GetOwner() .. "," .. nUnit:GetGameTurnCreated()] = true;		
					end
				end
			end
		end
	end
end

function EqualizeHPOfUnitType(iPlayer, unitType)
	local tab = {}
	for iUnit in Players[iPlayer]:Units() do
		if iUnit:GetUnitType() == unitType then
			table.insert(tab, iUnit)
		end
	end
	if #tab < 2 then
		return;
	end
	local cdmgtotal = 0;
	for i, iUnit in pairs(tab) do
		cdmgtotal = cdmgtotal + iUnit:GetDamage();
	end
	cdmgtotal = math.floor(cdmgtotal / #tab);
	for i, iUnit in pairs(tab) do
		iUnit:SetDamage(math.min(cdmgtotal, iUnit:GetMaxHitPoints() - 1))
	end
end

function DemoralizeAdjacentEnemiesWithChance(x, y, iPlayer, chance100)
	local pTeam = Teams[Players[iPlayer]:GetTeam()]
	for j = 0, 5 do
		local jPlot = Map.PlotDirection(x, y, j)
		if jPlot then
			for i = 0, jPlot:GetNumUnits() - 1 do
				local nUnit = jPlot:GetUnit(i);
				if nUnit:IsCombatUnit() and (not nUnit:IsDelayedDeath()) then
					if LastChance(chance100) then
						if pTeam:IsAtWar(Players[nUnit:GetOwner()]:GetTeam()) then
							if (not IsImmuneDoDemoralize(nUnit)) then
								nUnit:SetDemoralized(true);
								if iPlayer == Game.GetActivePlayer() or (nUnit:GetOwner() == Game.GetActivePlayer()) then
									Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(nUnit:GetX(), nUnit:GetY()))), "[ICON_DENOUNCE]", 0.5)
								end
							end
						end
					end
				end
			end
		end
	end
end

function ProvokeNearbyEnemiesWithChance(iUnit, iPlayer, chance100)
	local pTeam = Teams[Players[iPlayer]:GetTeam()]
	for j = 0, 5 do
		local jPlot = Map.PlotDirection(iUnit:GetX(), iUnit:GetY(), j)
		if jPlot then
			for i = 0, jPlot:GetNumUnits() - 1 do
				local nUnit = jPlot:GetUnit(i);
				if nUnit:IsCombatUnit() then
					if LastRandom(1, 100) <= chance100 then
						if pTeam:IsAtWar(Players[nUnit:GetOwner()]:GetTeam()) then
							gT.Globals.Provokes[nUnit:GetOwner()][nUnit:GetID()] = {iPlayer, iUnit:GetID()}
						end
					end
				end
			end
		end
	end
end

function HandleProvocations(iPlayer)
	for d, b in pairs(gT.Globals.Provokes[iPlayer]) do
		local tUnit = Players[b[1]]:GetUnitByID(b[2]);
		if b[3] then --city was provoked -- badly coded? can cityID == unitID :> it does not work then;
			local nCity = Players[iPlayer]:GetCityByID(d);
			if nCity and tUnit then
				if nCity:CanRangeStrikeAt(tUnit:GetX(), tUnit:GetY()) then
					nCity:DoTask(TaskTypes.TASK_RANGED_ATTACK, tUnit:GetX(), tUnit:GetY())
					if (iPlayer == Game.GetActivePlayer() or b[1] == Game.GetActivePlayer()) then
						Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(nCity:GetX(), nCity:GetY()))), "[COLOR_NEGATIVE_TEXT]PROVOKED", 0.25)
					end
				end
			end
		else
			local nUnit = Players[iPlayer]:GetUnitByID(d);
			if nUnit and tUnit then
				local nPlot = nUnit:GetPlot();
				local tPlot = tUnit:GetPlot();
				if nPlot and tPlot and (Map.PlotDistance(nPlot:GetX(), nPlot:GetY(), tPlot:GetX(), tPlot:GetY()) == 1) then
					local bDone = false;
					if nUnit:CanStartMission(GameInfoTypes.MISSION_RANGE_ATTACK, tPlot:GetX(), tPlot:GetY()) then
						bDone = true;
						nUnit:PushMission(GameInfoTypes.MISSION_RANGE_ATTACK, tPlot:GetX(), tPlot:GetY())
					elseif nUnit:CanStartMission(GameInfoTypes.MISSION_MOVE_TO, tPlot:GetX(), tPlot:GetY()) then
						bDone = true;
						nUnit:PushMission(GameInfoTypes.MISSION_MOVE_TO, tPlot:GetX(), tPlot:GetY())
					end
					if bDone and (iPlayer == Game.GetActivePlayer() or b[1] == Game.GetActivePlayer()) then
						Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(nPlot:GetX(), nPlot:GetY()))), "[COLOR_NEGATIVE_TEXT]PROVOKED", 0.25)
					end
				end
			end
		end
	end
	gT.Globals.Provokes[iPlayer] = {};
end

function DoBoostUnitOfTypeCS(iPlayer, unitType, cs, rcs)
	for iUnit in Players[iPlayer]:Units() do
		if iUnit:GetUnitType() == unitType then
			ChangeITGBaseCombatStrength(iUnit, cs, rcs)
		end
	end
end

function DoPortugeseRiflemanCounterStrike(iUnit, iPlayer)
	if not gT.Players[iPlayer] then
		return;
	end
	local uID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
	if not gT.Players[iPlayer].UnitsByID[uID] then
		return;
	end
	if not gT.Players[iPlayer].UnitsByID[uID].LastAttacker then
		return;
	end
	if not iUnit:IsEmbarked() then
		local ttt = StringSplitToNumbers(gT.Players[iPlayer].UnitsByID[uID].LastAttacker, ",")
		local tUnit = Players[ttt[2]]:GetUnitByID(ttt[1]);
		if tUnit then
			local iMoves = iUnit:GetMoves();
			local bOutOfAttacks = iUnit:IsOutOfAttacks();
			iUnit:SetMadeAttack(false);
			iUnit:SetMoves(iUnit:MaxMoves());
			iUnit:SetBaseRangedCombatStrength(30)
			iUnit:ChangeExtraRange(2)
			if iUnit:CanStartMission(RangAtt, tUnit:GetX(), tUnit:GetY()) then
				iUnit:PushMission(RangAtt, tUnit:GetX(), tUnit:GetY())
			end
			iUnit:SetMadeAttack(bOutOfAttacks);
			iUnit:SetMoves(iMoves);
			iUnit:SetBaseRangedCombatStrength(0)
			iUnit:ChangeExtraRange(-2)
		end
	end
end

function DoTryPlacingFort(plot, iPlayer, chance)
	if LastChance(chance) then
		local iOwner = plot:GetOwner();
		if (iOwner ~= -1) and Teams[Players[iPlayer]:GetTeam()]:IsAtWar(Players[iOwner]:GetTeam()) then
			PlayerChosesFortUpgradeOrNewOnPlot(plot, iPlayer, true, true)
		end
	end
end