local pKronborg = GameInfoTypes.PROCESS_ITG_KRONBORG_FORT_PROCESS;
local pInnovation = GameInfoTypes.PROCESS_LS_PROJECT_INNOVATION;
local infrastructureP = GameInfoTypes.PROCESS_ITG_INFRASTRUCTURE;
local dWonderProcess = GameInfoTypes.PROCESS_ITG_WONDER;
local leshanbuddha1 = GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_35;
local culturalP = GameInfoTypes.PROCESS_ITG_DRAMA;
local pShinobi = GameInfoTypes.PROCESS_ITG_SHINOBI_PROCESS
--local pMesoHap = GameInfoTypes.BUILDING_LS_MESO_HAP;
local pTemplarBelief = GameInfoTypes.PROCESS_ITG_TEMPLAR_PROJECT
local iWealthProcess = GameInfoTypes.PROCESS_WEALTH;
local tradeProcess = GameInfoTypes.PROCESS_ITG_TRADE;

function TakeCareOfAllOtherProcesses()
--[[for i, v in pairs(Players) do
		for iCity in v:Cities() do
			if ITGCityCanWorkDoAction(iCity) then
				local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
				local iBuilding = iCity:GetProductionBuilding()
				local iUnitType = iCity:GetProductionUnit()
				local iProcess = iCity:GetProductionProcess()
				if iBuilding == -1 and iProcess == -1 and iUnitType == -1 then
					print("Detected city doing nothing", iCity:GetName(), i)					
				end
			end
		end
	end ]]
	for iRel, sth in pairs(gT.TemplarBonus) do
		if sth.Total >= sth.Needed then
			DoFinalTemplarProjectContributions(iRel)
			FinishTemplarProjectITG(iRel)
		end
	end
end

function IsHasBuildingClass(iCity, iClass)
	local buildingType = Players[iCity:GetOwner()]:GetPlayerUniqueBuilding(iClass);
	if buildingType ~= -1 and iCity:IsHasBuilding(buildingType) then
		return true;
	end
	return false;
end

function GetHasBuildingClass(iCity, iClass)
	local buildingType = Players[iCity:GetOwner()]:GetPlayerUniqueBuilding(iClass);
	if buildingType ~= -1 and iCity:IsHasBuilding(buildingType) then
		return buildingType;
	end
	return -1;
end

GameEvents.ProcessCityProduction.Add(function(cityID, cityOwner, process, production100)
--	print("Process:", cityOwner, cityID, process, production100)
	if process == infrastructureP then
		local iCity = Players[cityOwner]:GetCityByID(cityID)
		ChangeITGWorkRate(iCity, math.floor((20 + math.floor(production100/ 100))) * gT.Players[cityOwner].ProcessMod)
	elseif culturalP == process then
		local iCity = Players[cityOwner]:GetCityByID(cityID)
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		DoChangeCityCultureOwnership(cID, iCity, cityOwner, CULT_HERITAGE_PRESENCE_VAL, "cProcess")
		gT.Players[cityOwner].CHeritageProject = gT.Players[cityOwner].CHeritageProject + production100 / 100 * gT.Players[cityOwner].ProcessMod;
		local artPoints = math.floor(gT.Players[cityOwner].CHeritageProject * DBScenario.CultHeritagePercent / 100);
		if artPoints > 0 then
			BoostArtisticPoints(cityOwner, artPoints, true)
			gT.Players[cityOwner].CHeritageProject = gT.Players[cityOwner].CHeritageProject - artPoints * 100 / DBScenario.CultHeritagePercent;
		end
	elseif process == tradeProcess then
		local iCity = Players[cityOwner]:GetCityByID(cityID)
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		local cboost =  math.floor(production100 * GetTradeProcessDivider(iCity, cID, cityOwner) * gT.Players[cityOwner].ProcessMod);
		local nBoost = 0;
		if IsHasBuildingClass(iCity, GameInfoTypes.BUILDINGCLASS_LIGHTHOUSE) then
			nBoost = math.ceil(cboost / 2);
			cboost = nBoost;
		end
		gT.Cities[cID].CaravanProgress = (gT.Cities[cID].CaravanProgress or 0) + cboost;
		gT.Cities[cID].CargoProgress = (gT.Cities[cID].CargoProgress or 0) + nBoost;
	elseif process == iWealthProcess then
		gT.Players[cityOwner].MintPowerFromWealthProcess = (gT.Players[cityOwner].MintPowerFromWealthProcess or 0) + math.ceil(production100 / 400 * gT.Players[cityOwner].ProcessMod)
	elseif process == pShinobi then
		gT.Players[cityOwner].ShinobiProcess = gT.Players[cityOwner].ShinobiProcess + production100 / 100;
	elseif process == pKronborg then
		gT.Players[cityOwner].KronborgProcess = gT.Players[cityOwner].KronborgProcess + production100 / 100;
	elseif process == pInnovation then
		gT.Players[cityOwner].InnoProcess = gT.Players[cityOwner].InnoProcess + production100 / 100;
	elseif process == pTemplarBelief then
		local iRel = Players[cityOwner]:GetCityByID(cityID):GetReligiousMajority();
		if gT.TemplarBonus[iRel] then
			gT.TemplarBonus[iRel].PlayerContribution[cityOwner] = (gT.TemplarBonus[iRel].PlayerContribution[cityOwner] or 0) + production100 / 100;
			gT.TemplarBonus[iRel].Total = gT.TemplarBonus[iRel].Total + production100 / 100;
		end
	elseif process == dWonderProcess then
		if GetITGGameTurn() % 10 ~= 0 then
			local iCity = Players[cityOwner]:GetCityByID(cityID)
			local aModBoost = math.floor(production100 * GetTotalWonderProcessMod(iCity, cityOwner) ) / 100;
			BoostWonderProduction(cityOwner, aModBoost, true)
			if gT.Players[cityOwner].HasPlayerWonder[leshanbuddha1] then
				ChangeITGFaith(cityOwner, math.floor(aModBoost/4))
				ChangeITGCulture(cityOwner, math.floor(aModBoost/4))
			end
		end
	elseif gT.Globals.CityStateBuildingProcesses[process] then
		local cS = gT.Globals.CityStateBuildingProcesses[process];
		for iQuest, data in pairs(gT.Players[cS].CityStateQuests) do
			if (data.Active) and (data.ActivePlayers[cityOwner]) then
				gT.Players[cityOwner].HelpCSGiftsLog[2] = gT.Players[cityOwner].HelpCSGiftsLog[2] + production100 / 100;
				gT.Players[cS].CityStateQuests[iQuest].ActivePlayers[cityOwner].ProjectDonated = gT.Players[cS].CityStateQuests[iQuest].ActivePlayers[cityOwner].ProjectDonated + production100 / 100;
				return;
			end
		end
		print("We couldn't find proper City-State quest!", cS, process, cityOwner);
	elseif GetLeagueResOutOfProcess(process) then
		DoContributionLeagueProject(GetLeagueResOutOfProcess(process), cityOwner, production100 / 100)
	end
end)

function DoFinalTemplarProjectContributions(iRel)
	for g, h in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			for iCity in Players[g]:Cities() do
				if iCity:GetProductionProcess() == pTemplarBelief then
					if iCity:GetReligiousMajority() == iRel then
						if WillITGCityAbleToWorkNextTurn(iCity) then
							local boost = iCity:GetCurrentProductionDifferenceTimes100(false, false) / 100;
							gT.TemplarBonus[iRel].PlayerContribution[g] = (gT.TemplarBonus[iRel].PlayerContribution[g] or 0) + boost;
							gT.TemplarBonus[iRel].Total = gT.TemplarBonus[iRel].Total + boost;
						end
					end
				end
			end
		end
	end
end

function OnTurnPopProcess(iPlayer)
--method of self-process projects
	if gT.Players[iPlayer].KronborgProcess >= KRONBORG_PROCESS_TRESHOLD then
		if gT.Players[iPlayer].KronborgCooldown <= GetRealGameTurn() then
			gT.Players[iPlayer].KronborgProcess = gT.Players[iPlayer].KronborgProcess - KRONBORG_PROCESS_TRESHOLD;
			gT.Players[iPlayer].KronborgCooldown = GetRealGameTurn() + 10;
			gT.Players[iPlayer].NumFortPoints = gT.Players[iPlayer].NumFortPoints + 1;
			for iCity in Players[iPlayer]:Cities() do
				if iCity:GetProductionProcess() == pKronborg then
					iCity:PopOrder(0, 1, 1)
				end
			end
		end
	end
	if gT.Players[iPlayer].InnoProcess >= DBScenario.InnovationProcessCost then
		gT.Players[iPlayer].InnoProcess = 0;
		DoGrantRandomInnovationIfPossible(iPlayer, true)
--		gT.Players[iPlayer].GovSlots[gT.Players[iPlayer].GovRewards[23]].Used = true; --IT CAN BE DIRTY
		for slot, data in pairs(gT.Players[iPlayer].GovSlots) do
			if data.Principle == 23 then
				gT.Players[iPlayer].GovSlots[slot].Used = true;
			end
		end
		for iCity in Players[iPlayer]:Cities() do
			if iCity:GetProductionProcess() == pInnovation then
				iCity:PopOrder(0, 1, 1)
			end
		end
	end


	if gT.Players[iPlayer].ShinobiProcess >= SHINOBI_PROCESS_TRESHOLD then
		if gT.Players[iPlayer].ShinobiCooldown <= GetRealGameTurn() then
			gT.Players[iPlayer].ShinobiProcess = gT.Players[iPlayer].ShinobiProcess - SHINOBI_PROCESS_TRESHOLD;
			gT.Players[iPlayer].ShinobiCooldown = GetRealGameTurn() + 10;
			CreateAgentNew(iPlayer, false, true, nil)
			for iCity in Players[iPlayer]:Cities() do
				if iCity:GetProductionProcess() == pShinobi then
					iCity:PopOrder(0, 1, 1)
				end
			end
		end
	end
end

function GetWorkRateFromProcess(iCity)
	if infrastructureP == iCity:GetProductionProcess() then
		return (20 + math.floor(iCity:GetYieldRateTimes100(yProduction) / 100)) * gT.Players[iCity:GetOwner()].ProcessMod
	end
	return 0;
end

function GetCulturalPresenceFromProcess(iCity)
	if culturalP == iCity:GetProductionProcess() then
		return CULT_HERITAGE_PRESENCE_VAL;
	end
	return 0;
end

function GetTradeProcessDivider(iCity, cID, iPlayer)
	local val = 0.25 * gT.Cities[cID].CanDoTradeProcess;
	if gT.Players[iPlayer].HasIdeology[14] then
		val = val + 0.25;
	end
	return val * 0.01;
end

function GetTradeGainFromProcess(iCity)
	local l, n = 0,0
	if tradeProcess == iCity:GetProductionProcess() then
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		l =  math.floor(iCity:GetYieldRateTimes100(yProduction)  * gT.Players[iCity:GetOwner()].ProcessMod * GetTradeProcessDivider(iCity, cID, iCity:GetOwner()))
		if IsHasBuildingClass(iCity, GameInfoTypes.BUILDINGCLASS_LIGHTHOUSE) then
			n = math.ceil(l / 2);
			l = n;
		end
	end
	return l, n;
end

function GetEstimatedArtPointsFromProcess(iPlayer)
	local totalprod = 0;
	for iCity in Players[iPlayer]:Cities() do
		if iCity:GetProductionProcess() == culturalP then
			if ITGCityCanWorkDoAction(iCity) then
				totalprod = totalprod + iCity:GetCurrentProductionDifferenceTimes100(false, false) / 100 * gT.Players[iPlayer].ProcessMod;
			end
		end
	end
	if totalprod > 0 then
		local tArtPoints = math.floor((gT.Players[iPlayer].CHeritageProject + totalprod) * DBScenario.CultHeritagePercent / 100)
		if tArtPoints > 0 then
			local iMod = GetPlayerCityModTowardsArtPoints(iPlayer);
			if iMod ~= 0 then
				return math.floor(100 * tArtPoints * (1 + iMod) + 0.5) / 100;
			end
			return tArtPoints;
		end
	end
	return 0;
end