local rRailroad = GameInfoTypes.ROUTE_RAILROAD;
local rRoad = GameInfoTypes.ROUTE_ROAD;
local numrailroadspossible;
local wonderindu15 = GameInfoTypes.BUILDING_ITG_NEW_INDUSTRIAL_WONDER_15;

function InitRailroads()
	gT.Railroads = {}
	--in 5th scenario there will be starting railroads // handled with normal roads
end

function GetCostOfRailroad(iPlayer)
	return math.max(50, 250 - gT.Players[iPlayer].RailroadDiscount);
end

function AIRailroadOnlySelf(iPlayer)
	if gT.Players[iPlayer].HasPlayerWonder[wonderindu15] then
		return nil;
	end
	return iPlayer;
end

function PlayerMakesRailroadOnPlot(iPlayer, iPlot, bAI)
	DoIncreasementStockExchange(12)
	DoPayInWorkRateCloseToPlot(iPlayer, iPlot, GetCostOfRailroad(iPlayer), "Railroad")
	iPlot:SetRouteType(rRailroad)
	gT.Railroads[iPlot:GetPlotIndex()] = iPlayer;
	gT.Players[iPlayer].RailroadMadeT = gT.Players[iPlayer].RailroadMadeT + 1;
	gT.Players[iPlayer].NumRailroadsMade = gT.Players[iPlayer].NumRailroadsMade + 1;
	VictoryTaskCompletion(iPlayer, 13)
	BasicCSMissionCompleteFunc(iPlayer, 3, 1)
	local delay = 0.25;
	local iActivePlayer = (Game.GetActivePlayer() == iPlayer);
	if iActivePlayer then
		Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(iPlot:GetX(),iPlot:GetY()))), "[ICON_WORKER]", delay)
		delay = delay + 0.5;
	end
	if gT.Players[iPlayer].HasPlayerWonder[wonderindu15] then
		local iOwner = iPlot:GetOwner();
		if (iOwner ~= -1) and (iOwner ~= iPlayer) then
			if Players[iOwner]:IsMinorCiv() then
				Players[iOwner]:ChangeMinorCivFriendshipWithMajor(iPlayer, 5);
				if iActivePlayer then
					Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(iPlot:GetX(),iPlot:GetY()))), "+5[ICON_INFLUENCE]", delay)
					delay = delay + 0.5;
				end
			else
				gT.Players[iPlayer].GoldPTPancras = gT.Players[iPlayer].GoldPTPancras + 0.5; 
				if iActivePlayer then
					Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(iPlot:GetX(),iPlot:GetY()))), "[ICON_GOLD]", delay)
					delay = delay + 0.5;
				end
			end
		end
	end
	if bAI then
		numrailroadspossible = numrailroadspossible - 1;
		local cnPlot;
		if numrailroadspossible > 0 then
			for j = 0, 5 do
				local jPlot = Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), j);
				if jPlot then
					if CanBeRailroad(iPlayer, jPlot, GetValidPlayerTableForRailroad(iPlayer), AIRailroadOnlySelf(iPlayer), true) then
						cnPlot = jPlot;
						break;
					end
				end
			end
		end
		if cnPlot then
			PlayerMakesRailroadOnPlot(iPlayer, cnPlot, true)
		end
	end
end

function DoPayInWorkRateCloseToPlot(iPlayer, iPlot, amount, sType)
	local hTab = {}
	if sType == "Railroad" then
		if gT.Players[iPlayer].NumFreeRailroads > 0 then
			gT.Players[iPlayer].NumFreeRailroads = gT.Players[iPlayer].NumFreeRailroads - 1;
			return;
		end
	end
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		table.insert(hTab, {iCity, Map.PlotDistance(iCity:GetX(), iCity:GetY(), iPlot:GetX(), iPlot:GetY()), gT.Cities[cID].WorkRate})
	end
	table.sort(hTab, SortFunctionForLowestMapDistance)
	for h, data in pairs(hTab) do
		local tspend = math.min(amount, data[3])
		if tspend > 0 then
			amount = amount - tspend;
			MakeCitySpendWorkRate(data[1], iPlayer, tspend, sType == "HealingFort")
		end
		if amount <= 0 then
			return;
		end
	end
	print("Player just pay for railroad without enough work rate!?", iPlayer, amount, sType)
end

function GetTotalWorkRateStored(iPlayer)
	local b = 0;
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		b = b + gT.Cities[cID].WorkRate;
	end
	return b;
end

function GetNumPossibleRailroadsToBeDone(iPlayer)
	return math.floor(GetTotalWorkRateStored(iPlayer) / GetCostOfRailroad(iPlayer)) + gT.Players[iPlayer].NumFreeRailroads
end

function DoAIConsiderMakingRailroad(iPlayer, bForce)
	if not gT.Players[iPlayer].CanDoRailroad then
		return;
	end
	if (LastRandom(1,4) < 4) and ((gT.Players[iPlayer].CSMissions[3] or 0) == 0) and (not bForce) then
		return;
	end
	numrailroadspossible = GetNumPossibleRailroadsToBeDone(iPlayer)
	if numrailroadspossible == 0 then
		return;
	end
	local gTab;
	if gT.Players[iPlayer].HasPlayerWonder[wonderindu15] then
		gTab = GetTabOfAllPossibleRailRoadsToMake(iPlayer, true, true);
	else
		gTab = GetTabOfAllPossibleRailRoadsToMake(iPlayer, numrailroadspossible > 50, numrailroadspossible > 20) -- ai will not consider outside lands
	end
	if #gTab == 0 then
		return;
	end
	numrailroadspossible = math.min(numrailroadspossible, gT.Players[iPlayer].RailroadsPT - gT.Players[iPlayer].RailroadMadeT)
	if numrailroadspossible == 0 then
		return;
	end
	gTab = Shuffle(gTab);
	PlayerMakesRailroadOnPlot(iPlayer, gTab[1], true) -- ai iterates later!!
end

function CheckPlotOwnershipForRailroad(iPlayer, fPlot, validPlayers, fPlayer)
	local fOwner = fPlot:GetOwner();
	if fPlayer and fPlayer ~= fOwner then
		return false;
	end
	if validPlayers[fOwner] then
		return true;
	end
	if fPlot:IsOpenBorderRouteForEveryone() then
		if IsPlayerAdjacentToPlot(fPlot, iPlayer) then
			if not Teams[Players[iPlayer]:GetTeam()]:IsAtWar(Players[fPlot:GetOwner()]:GetTeam()) then
				return true;
			end
		end
	end
	return false;
end

function CanBeRailroad(iPlayer, fPlot, validPlayers, fPlayer, bLonely)
	if fPlot:GetRouteType() == rRoad then
		if not gT.Globals.TemporaryRoads[fPlot:GetPlotIndex()] then
			if CheckPlotOwnershipForRailroad(iPlayer, fPlot, validPlayers, fPlayer) then
				if not fPlot:IsCity() then
					for i = 0, 5 do
						local nPlot = Map.PlotDirection(fPlot:GetX(), fPlot:GetY(), i);
						if nPlot then
							if nPlot:IsCity() then
								if CanDoWorkOnPlotNow(fPlot, iPlayer, true) then
									return true;
								else
									return false;
								end
							end 
							if (nPlot:GetRouteType() == rRailroad) and (bLonely or (validPlayers[nPlot:GetOwner()])) then
								if CanDoWorkOnPlotNow(fPlot, iPlayer, true) then
									return true;
								else
									return false;
								end
							end
						end
					end
				end
			end
		end
	end
	return false;
end

function GetTabOfAllPossibleRailRoadsToMake(iPlayer, bIncludeFriendly, bIncludeLonely) 
	local validPlayers = GetValidPlayerTableForRailroad(iPlayer)
	local fPlayer;
	local tTab = {}
	if not bIncludeFriendly then
		fPlayer = iPlayer;
	end
	for i = 0, Map:GetNumPlots() - 1, 1 do
		local fPlot = Map.GetPlotByIndex( i );
		if CanBeRailroad(iPlayer, fPlot, validPlayers, fPlayer, bIncludeLonely) then
			table.insert(tTab, fPlot)
		end
	end
	return tTab;
end

function HighlightProperPlotsForRailroad(iPlayer)
	if math.min(gT.Players[iPlayer].RailroadsPT - gT.Players[iPlayer].RailroadMadeT, GetNumPossibleRailroadsToBeDone(iPlayer)) <= 0 then
		MapModData.ITGSG = {}
		return;
	end
	local tab = GetTabOfAllPossibleRailRoadsToMake(iPlayer, true, true) 
	local bCall = true;
	if #tab == 0 then
		bCall = false;
	else
		for j, jPlot in pairs(tab) do
			if jPlot:GetOwner() == iPlayer then
				bCall = false;
				break;
			end
		end
		if #tab == 1 then
			UI.LookAt(tab[1])
		end
	end
	if bCall then
		Events.GameplayAlertMessage("Valid targets are only outside your territory.")
	end
	MapModData.ITGSG = tab;
end

function GetValidPlayerTableForRailroad(iPlayer)
	local validPlayers = {}
	validPlayers[iPlayer] = true;
	local bAnyPlayer = false;
	if gT.Players[iPlayer].HasPlayerWonder[wonderindu15] then
		bAnyPlayer = true;
	end
	for g, gh in pairs(gT.Players) do
		if bAnyPlayer or (Players[g]:IsMinorCiv() and Players[g]:GetMinorCivFriendshipLevelWithMajor(iPlayer) > 0) then
			validPlayers[g] = true;
		end
	end
	return validPlayers;
end

function PlayerChooseRailroadOnPlot(pPlot, iPlayer)
	if CanBeRailroad(iPlayer, pPlot, GetValidPlayerTableForRailroad(iPlayer), nil, true) then
		PlayerMakesRailroadOnPlot(iPlayer, pPlot)
		if Players[iPlayer]:IsHuman() then
			LuaEvents.ITG_AchievementCountChange(92, 1)
		end
	end
end

--end era fable

function GetRouteTypeToIterate()
	for g, h in pairs(gT.Players) do
		if gT.Players[g].NumRailroadsMade > 0 then
			return rRailroad
		end
	end
	return rRoad
end

local rTypeToIterate;
local RTAC = {}
local RTADC = 0;
local RTLSC = {}
local RTOFCITIES = {}

LuaEvents.ITGSG_DoLeaderHeadStats.Add(function()
	if gT.Globals.LHlongestRoutes then
		return;
	end
	rTypeToIterate = GetRouteTypeToIterate()
	for i = 0, Map:GetNumPlots() - 1, 1 do
		local fPlot = Map.GetPlotByIndex( i );
		if not RTAC[i] then
			if fPlot:GetRouteType() == rTypeToIterate then
				RTADC = RTADC + 1;
				RTLSC[RTADC] = {}
				RTOFCITIES[RTADC] = {}
				RoutesRailroadITP(fPlot, RTADC)
			end
		end
	end
	for g, gh in pairs(gT.Players) do
		for iCity in Players[g]:Cities() do
			local iPlot = iCity:Plot();
			for i, data in pairs(GetTabOfRoutesIndexes(iPlot:GetPlotIndex())) do
				table.insert(RTOFCITIES[data], iPlot)
			end
		end
	end
	local alldistances = {}
	for i, v in pairs(RTOFCITIES) do
		for j, city in pairs(v) do
			for h, hcity in pairs(RTOFCITIES[i]) do
				if h > j then
					table.insert(alldistances, {city:GetPlotIndex(), Map.PlotDistance(city:GetX(), city:GetY(), hcity:GetX(), hcity:GetY()), hcity:GetPlotIndex()})
				end
			end
		end
	end
	table.sort(alldistances, SortFunctionForGreaterInteger2)
	gT.Globals.LHlongestRoutes = {}
	local thth = {}
	for i, v in pairs(alldistances) do
		local owner1 = Map.GetPlotByIndex(v[1]):GetOwner();
		local owner2 = Map.GetPlotByIndex(v[3]):GetOwner();
		if not thth[owner1 .. "x" .. owner2] then
			thth[owner1 .. "x" .. owner2] = true;
			thth[owner2 .. "x" .. owner1] = true;
			local pcp;
			if owner1 == owner2 then
				pcp = owner1;
			end
			table.insert(gT.Globals.LHlongestRoutes, {v[1], v[2], v[3], pcp})
			if #gT.Globals.LHlongestRoutes >= 20 then
				break;
			end
		end
	end
	--also trade appeals by city
	for g, h in pairs(gT.Players) do
		for iCity in Players[g]:Cities() do
			local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
			gT.Cities[cID].LHTradeAppeal = GetBaseCityTRAttractiveness(iCity, g, cID)
		end
	end
end)

function GetTabOfRoutesIndexes(index)
	local tab = {}
	for h, v in pairs(RTLSC) do
		if v[index] then
			table.insert(tab, h)
		end
	end
	return tab;
end

function RoutesRailroadITP(iPlot, routeID)
	RTAC[iPlot:GetPlotIndex()] = 1;
	RTLSC[routeID][iPlot:GetPlotIndex()] = 1;
	for j = 0, 5 do
		local jPlot = Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), j);
		if jPlot then
			if not RTAC[jPlot:GetPlotIndex()] then
				if jPlot:GetRouteType() == rTypeToIterate then
					RoutesRailroadITP(jPlot, routeID)
				end
			end
		end
	end
end

function DoAutomaticRailroadMaking(iPlayer)
	if gT.Players[iPlayer].AIRailroad then
		DoAIConsiderMakingRailroad(iPlayer, true)
	end
end