local bInquisition = GameInfoTypes.BUILDING_ITG_NEW_WORLD_INQUISITION;
local itgfortfaithwonder1 = GameInfoTypes.BUILDING_ITG_NEW_MEDIEVAL_WONDER_6
local arabtrial7 = GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_ARABIA_7
local luxortemple1 = GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_38;
local empireancient3 = GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_EMPIRE_3;
local gmedwonder11 = GameInfoTypes.BUILDING_ITG_NEW_MEDIEVAL_WONDER_11;
local ancTRinno14 = GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_TRIBE_14;
local maxReligionITT = -1;
for row in GameInfo.Religions() do
	maxReligionITT = maxReligionITT + 1;
end
function HasActiveReligionHolySite(index, iRel)
	if gT.HolySites[index].ActiveReligions[iRel] then
		if gT.HolySites[index].ActiveReligions[iRel] > 0 then
			return true;
		end
	end
	return false;
end

function GetFaithFromElDorados(iPlayer)
	local total = GetNumSpecialControlPoint(iPlayer, "ElDorados", false) * 10;
	return total;
end

function GetFaithFromTechnologies(iPlayer)
	return gT.Players[iPlayer].FaithFromTech
end

function GetFaithFromMorale(iPlayer)
	local b = 0;
	if HasPlayerTech(iPlayer, ancTRinno14, "1321255dda") then
		b = b + math.max(0, math.floor(gT.Players[iPlayer].Morale))
	end
	return b;
end

function GetFaithFromHappiness(iPlayer)
	local b = 0;
	if HasPlayerTech(iPlayer, empireancient3, "1321255dda") then
		b = b + math.max(0, math.floor(gT.Players[iPlayer].AverageHappiness))
	end
	return b;
end

function GetFaithFromForts(iPlayer)
	local r = 0;
	if gT.Players[iPlayer].HasPlayerWonder[itgfortfaithwonder1] then
		r =r + 5 * GetNumSpecialControlPoint(iPlayer, "Forts", false);
	end
	return r;
end

function GetFaithFromHolySites(iPlayer)
	local faith = 0;
	local extra = 0;
	if HasPlayerNatureWonder(iPlayer, GameInfoTypes.FEATURE_MT_KAILASH) then
		extra = extra + 1;
	end
	local iRel = Players[iPlayer]:GetReligionCreatedByPlayer();
	local bFounderRel5 = IsReligionHaveBelief(iRel, GameInfoTypes.BELIEF_ITG_FOUNDER_5);
	for index, data in pairs(gT.HolySites) do
		if (data.Player == iPlayer) and (not Map.GetPlotByIndex(index):IsImprovementPillaged()) then
			faith = faith + extra + data.BasicBonuses[1];
		end
		if bFounderRel5 and (HasActiveReligionHolySite(index, iRel)) then
			faith = faith + 3 * gT.Players[iPlayer].FounderBeliefModifier;
		end
	end
	return faith;
end

function CanDoSchism(iPlayer)
	if not gT.Players[iPlayer].SecularState then
		if Players[iPlayer]:GetReligionCreatedByPlayer() < 1 then
			if gT.Players[iPlayer].OfficialReligion then
				if Players[iPlayer]:GetNumCities() > 0 then
					return true;
				end
			end
		end
	end
	return false;
end

function MakeReligionPercentageOfTotal(iRel, iCity, percent, min)
	local tot = iCity:GetNumReligionPressure(-1)
	for relHID = 1, maxReligionITT do
		if relHID ~= iRel then
			if iCity:GetNumReligionPressure(relHID) > 0 then
				tot = tot + iCity:GetNumReligionPressure(relHID)
			end
		end
	end
	if percent >= 100 then
		percent = 99;
		print("Relpercent is over 99!!!", percent)
	end
	iCity:SetNumReligionPressure(iRel, math.max(min or 500, math.ceil(tot / (100 - percent) * percent)), true)
	iCity:SetNumReligionPressure(-1, 1, true)
	iCity:SetNumReligionPressure(0, 1, false)
	if iCity:GetReligiousMajority() ~= iRel then
		print("Make Religion Percentage of Total failed", iRel, iCity:GetName(), percent, min, tot)
	end
end

function DoUnhapForEveryCitizenWithDifferentReligion(iPlayer, iRel, div)
	for iCity in Players[iPlayer]:Cities() do
		local fPres = 0
		for relHID = 1, maxReligionITT do
			if iCity:GetNumFollowers(relHID) > 0 and relHID ~= iRel then
				fPres = fPres + iCity:GetNumFollowers(relHID);
			end
		end
		if fPres >= div then
			ChangeITGHappinessInTheCity(iCity, -math.floor(fPres / div), nil, "kowegwer")
		end
	end
end

function EraseForeignReligionsFromPlayer(iPlayer, tCity)
	local bTb ={}
	local pRel = gT.Players[iPlayer].OfficialReligion;
	for g, gdata in pairs(gT.Players) do
		if g ~= iPlayer then
			local iRel = Players[g]:GetReligionCreatedByPlayer();
			if iRel > 0 then
				if pRel ~= iRel then
					table.insert(bTb, iRel)
				end
			end
		end
	end
	for iCity in Players[iPlayer]:Cities() do
		if (not tCity) or (tCity == iCity) then
			for i, rel in pairs(bTb) do
				iCity:SetNumReligionPressure(rel, 0)
			end
		end
	end
	Events.SerialEventCityInfoDirty()
end

function PreparedDataForOfficialReligionAction(iPlayer)
	local pOpt = {}
	local oRel = Players[iPlayer]:GetReligionCreatedByPlayer()
	if oRel > 0 then
		pOpt[oRel] = 1;
	end
	for iCity in Players[iPlayer]:Cities() do
		for relHID = 1, maxReligionITT do
			if (iCity:GetNumFollowers(relHID) > 0  or iCity:GetPressurePerTurn(relHID) > 10) then
				pOpt[relHID] = 1;
			end
		end
	end
	local data = {BonusType = 5, UniqueOptions = {}, SpecialType = "Action", TitleText = "Choose your official religion.", TitleIconIndex = 16, TitleIconAtlas = "EXPANSION_UNIT_ATLAS_1"}
	if gT.Globals.ScenarioType == 2 then
		if gT.Players[iPlayer].OfficialReligion then
			return data;
		end
	end
	if gT.Players[iPlayer].SecularState then
		return data;
	end
	local hTab = {}
	for res, sth in pairs(pOpt) do
		if gT.Players[iPlayer].OfficialReligion ~= res then
			local name;
			if oRel == res then
				name = "Adopt " .. Locale.Lookup(GameInfo.Religions[res].Description) .. " ([COLOR_POSITIVE_TEXT]Your Religion[ENDCOLOR])"
			else
				name = "Adopt " .. Locale.Lookup(GameInfo.Religions[res].Description)
			end
			table.insert(hTab, {Name = name,
					ID = res,
					PortraitIndex = GameInfo.Religions[res].PortraitIndex,
					IconAtlas = GameInfo.Religions[res].IconAtlas,
					Help = "[NEWLINE]" .. GameInfo.Religions[res].IconString .. " " .. Locale.Lookup(GameInfo.Religions[res].Description) .. " will become your official religion, becoming majority religion in every city.";
					})	
		end	
	end
	data.UniqueOptions = hTab;
	return data;
end

function DoAdoptSecularState(iPlayer, bInit)
	gT.Players[iPlayer].SecularState = true;	
	DoRemoveOfficialReligion(iPlayer)
	if not bInit then
		HnGLogSecularState(iPlayer)
		DoIncreasePointsTowardGoldenAge(iPlayer, nil, nil, nil, true)
	end
	DoMeritocracyRemoveReligiousPrinciples(iPlayer)
	if not bInit then
		PlayerRequestedFillingGovSlot(iPlayer, 12)
	end
end

function DoRemoveOfficialReligion(iPlayer)
	DoRemoveLawsBasedOnOfficialReligion(iPlayer)
	Players[iPlayer]:SetITGOfficialReligion(-1);
	gT.Players[iPlayer].CannotBeConverted = false;
	gT.Players[iPlayer].OfficialReligion = nil;
	for iCity in Players[iPlayer]:Cities() do
		iCity:SetSpreadImmune(false)
		iCity:SetNumRealBuilding(bInquisition, 0)
		iCity:SetNumFreeBuilding(bInquisition, 0)
	end
end

function SetOfficialReligion(iPlayer, iRel, rPlayer, bInitial)
	Players[iPlayer]:SetITGOfficialReligion(iRel);
	gT.Players[iPlayer].CannotBeConverted = true;
	local prevOfficialRel = gT.Players[iPlayer].OfficialReligion;
	gT.Players[iPlayer].OfficialReligion = iRel;
	for iCity in Players[iPlayer]:Cities() do
		if not bInitial then
			DoReligiousOppressionMigration(iCity, iRel, iPlayer)
		end
		MakeReligionPercentageOfTotal(iRel, iCity, 85)
		iCity:SetSpreadImmune(true)
	end
	UpdatePressureOfAllHolySites()
	--notification
	for a, human in pairs(gT.Globals.HumanPlayers) do
		if human ~= iPlayer then
			if not bInitial then
				if not rPlayer then
					print("No rPlayer in setofficialRel", iPlayer, iRel)
					rPlayer = iPlayer;
				end
				if Teams[Players[rPlayer]:GetTeam()]:IsHasMet(Players[human]:GetTeam()) then
					local str = Players[rPlayer]:GetName() .. " has established " .. GameInfo.Religions[iRel].IconString .. " " .. Locale.Lookup(Game.GetReligionName(iRel)) .. " as the official religion of " .. Players[iPlayer]:GetCivilizationShortDescription() .. ".";
					Players[human]:AddNotification(NotificationTypes.NOTIFICATION_RELIGION_ENHANCED,str, "Official Religion")
				end
			end
		end
	end
	ScenarioEffectsDoAdoptOfficialReligion(iPlayer, iRel)
	LeagueScriptedSetOfficialReligion(iPlayer, iRel, rPlayer, bInitial)
	if not bInitial then
		HnGLogOfficialReligion(iPlayer, iRel, prevOfficialRel, rPlayer);
	end
end

function GetBestBeliefToReformForAI(iPlayer)
	local iRel = Players[iPlayer]:GetReligionCreatedByPlayer()
	local cBeliefs = Game.GetBeliefsInReligion(iRel);
	local numToChooseFrom = GetNumReformBeliefOption(iPlayer)
	local hBTab = {}
	for i, beliefType in pairs(cBeliefs) do
		local hType = GetBeliefTypeITG(beliefType);
		if hType and (hType < 5) then
			local value = DLLBasedBeliefScore(iPlayer, beliefType);
			local op = GetNewBeliefForReformation(beliefType, iPlayer, cBeliefs, 3);
			if op then
				local avValue = 0;
				local vals = {};
				for it, blf in pairs(op) do
					local beliefVal = DLLBasedBeliefScore(iPlayer, blf);
					avValue = avValue + beliefVal;
					table.insert(vals, beliefVal);
				end
				avValue = math.floor(avValue / #op + 0.5);
				if numToChooseFrom > 1 then
					table.sort(vals, SortFunctionHighestInteger)
					avValue = math.max(avValue, vals[math.max(1, #vals + 1 - numToChooseFrom)]);
				end
				table.insert(hBTab, {beliefType, avValue - value})
			end
		end
	end
	if #hBTab > 0 then
		table.sort(hBTab, SortFunctionForGreaterInteger2);
		return hBTab[1][1], hBTab[1][2];
	end
	return -1, -1;
end

function DoAddPantheonBeliefLuxor(iPlayer)
	DoIncreaseHeresyProbability(2)	
	return DoAddNewBeliefOfType(iPlayer, 1)
end

function IsValidForLuxorBonus(iPlayer) -- THIS IS ONLY FOR LUXOR WONDER
	local iRel = Players[iPlayer]:GetReligionCreatedByPlayer()
	if iRel > 0 then
		return GetNewBeliefForReformation(nil, iPlayer, Game.GetBeliefsInReligion(iRel), 0, 1)
	end
	return false;
end

function CanFoundPantheonRightNow(iPlayer)
	if Players[iPlayer]:GetNumCities() == 0 then
		return false;
	end
	return gT.Globals.ScenarioType == 3;
end

function DoNewReligion(nPlayer, hCity)
	local newreligiondata, nrb = GetNewReligionData(1, gT.Players[nPlayer].CultureType)
	if Players[nPlayer]:HasCreatedPantheon() then
		local panths = Game.GetBeliefsInReligion(0, nPlayer)
		local tAdd = math.ceil(#panths / 2) - 1
		Game.FoundReligion(nPlayer, newreligiondata, nil,  nrb[2], nrb[3], -1, -1, hCity)
		ITGNewReligion(nPlayer, newreligiondata, false)
		if tAdd > 0 then
			local kTremove = -1;
			local bBt = {}
			for i, v in pairs(Game.GetBeliefsInReligion(newreligiondata)) do
				bBt[v] = 1;
			end
			for i, v in pairs(panths) do
				if bBt[v] then
					kTremove = i;
					break;
				end
			end
			if kTremove ~= -1 then
				table.remove(panths, kTremove)
			else
				print("Hello, error 9123/5/35325")
			end
			panths = Shuffle(panths);
			for i = 1, tAdd do
				Game.AddBeliefToReligion(nPlayer, newreligiondata, panths[i])
				ITGBeliefAdded(nPlayer, newreligiondata, panths[i])
			end
		end
	else
		Game.FoundReligion(nPlayer, newreligiondata, nrb[1],  nrb[2], nrb[3], -1, -1, hCity)
		ITGNewReligion(nPlayer, newreligiondata, true)
	end
	hCity:ConvertPercentFollowers(newreligiondata, -1, 85)

	if gT.Players[nPlayer].HarmonyPantheon then
		gT.Players[nPlayer].HarmonyPantheon = nil
	end
	for relHID = 0, maxReligionITT do
		hCity:ConvertPercentFollowers(newreligiondata, relHID, 85)
	end
	if gT.Globals.PantheonCost then
		if not gT.Players[nPlayer].AfterRelTresholdScale then
			gT.Players[nPlayer].AfterRelTresholdScale = true;
			gT.Players[nPlayer].ReligionRewardTreshold = math.min(3, math.ceil(gT.Globals.PantheonCost / 100))
		end
	end
	if gT.Players[nPlayer].HolySiteOnFoundRel then
		gT.Players[nPlayer].HolySiteOnFoundRel = nil;
		gT.Players[nPlayer].HolySitePoints = gT.Players[nPlayer].HolySitePoints + 1;
	end
	HnGLogReligionFound(nPlayer, newreligiondata, hCity)
	VictoryTaskCompletion(nPlayer, 26)
	DoIncreaseHeresyProbability(5)
end


function PlayerChoosesPlotForMissionary(pPlot, iPlayer, bControl)
	if CanDoConversionOnPlot(pPlot, iPlayer) then
		if bControl then
			local iRel = Players[iPlayer]:GetReligionCreatedByPlayer();
			local xdd = 0;
			local iCity = pPlot:GetPlotCity();
			local todo = math.max(1, math.min(math.min(10, gT.Players[iPlayer].FreeMissioniares), GetNumSpreadsNeededWithMax(iRel, GetMissionaryConversionStrength(iPlayer, iCity), iCity, MAX_MISSIONARY_CHECK)));
			for i = 1, todo do
				if iCity:GetReligiousMajority() ~= iRel then
					DoMissionaryConversionOnCity(iPlayer, iCity, xdd, -1)
					xdd = xdd + 0.35;
				end
			end
		else
			DoMissionaryConversionOnCity(iPlayer, pPlot:GetPlotCity(), nil, -1)
		end
	end
end

function CanDoConversionOnPlot(pPlot, iPlayer)
	local iCity = pPlot:GetPlotCity();
	local iTeam = Players[iPlayer]:GetTeam();
	if iCity then
		local iOwner = iCity:GetOwner();
		if pPlot:IsRevealed(Players[iPlayer]:GetTeam()) then
			if not gT.Players[iOwner].SecularState then
				if (not gT.Players[iOwner].UntargetByMissionary) or (iOwner == iPlayer) then
					if not iCity:IsSpreadImmune() then
						if Players[iCity:GetOwner()]:GetTeam() == iTeam or Teams[iTeam]:IsHasMet(Players[iCity:GetOwner()]:GetTeam()) then
							return true;
						end
					end
				end
			end
		end
	end
	return false;
end

function HighlightProperPlotForMissionary(iPlayer)
	if gT.Players[iPlayer].FreeMissioniares > 0 then
		MapModData.ITGSG = GetValidCityConversionTargetsWithNumNeededToConvert(Players[iPlayer]:GetReligionCreatedByPlayer(), Players[iPlayer]:GetTeam(), iPlayer);
	else
		MapModData.ITGSG = {}
	end
end

function HighlightProperPlotForInquisitors(iPlayer)
	local hTab = {}
--	if (Players[iPlayer]:GetFaith() >= gT.Players[iPlayer].InquisitorCost) then
--		for iCity in Players[iPlayer]:Cities() do
--			if not iCity:IsHasBuilding(bInquisition) then
--				if not IsHeresyInCity(iCity) then
--					table.insert(hTab, iCity:Plot())
--				end
--			end
--		end
--	end
	MapModData.ITGSG = hTab;
end

function GetBasePantheonExistence(type, bMajor)
	if type == 1 then
		return LastRandom(0,1000)
	elseif type == 2 then
		return LastRandom(500,1500)
	elseif type == 3 then
		return LastRandom(0,1200)
	elseif type == 4 then
		return LastRandom(0,800)
	elseif type == 5 then
		return LastRandom(800,2000)
	elseif type == 6 then
		return LastRandom(0,1000)
	elseif type == 7 then
		return LastRandom(500, 1000)
	elseif type == 8 then
		return LastRandom(400, 750)
	elseif type == 9 then
		return LastRandom(250, 500)
	elseif type == 10 then
		return LastRandom(100, 200)
	end
	print("You forgot about base Pantheon presence", type, bMajor)
	return LastRandom(0, 1000)
end

function GetBaseAtheistExistence(type, bMajor)
	if bMajor then
		if type == 1 then
			return LastRandom(500,1500)
		elseif type == 2 then
			return LastRandom(250,1000)
		elseif type == 3 then
			return LastRandom(250,500)
		elseif type == 4 then
			return LastRandom(150,300)
		elseif type == 5 then
			return LastRandom(100,300)
		elseif type == 6 then
			return LastRandom(200,1000)
		elseif type == 7 then
			return LastRandom(100,200)
		elseif type == 8 then
			return LastRandom(100,300)
		elseif type == 9 then
			return LastRandom(100,200)
		elseif type == 10 then
			return LastRandom(600, 1200)
		end
	else
		if type == 1 then
			return LastRandom(200,500)
		elseif type == 2 then
			return LastRandom(650,2500)
		elseif type == 3 then
			return LastRandom(200,500)
		elseif type == 4 then
			return LastRandom(200,500)
		elseif type == 5 then
			return LastRandom(900,3500)
		elseif type == 6 then
			return LastRandom(300,800)
		elseif type == 7 then
			return LastRandom(100,300)
		elseif type == 8 then
			return LastRandom(100,250)
		elseif type == 9 then
			return LastRandom(100,200)
		elseif type == 10 then
			return LastRandom(200, 500)
		end
	end
	print("You forgot about base atheist presence", type, bMajor)
	return LastRandom(0, 1000)
end

function IsPlayerHaveBelief(iPlayer, iBelief)
	if not iPlayer then
		print("Error 9583259: ", iBelief)
	end
	local iRel = Players[iPlayer]:GetReligionCreatedByPlayer();
	return IsReligionHaveBelief(iRel, iBelief)
end

function IsReligionHaveBelief(iRel, iBelief, iPlayer)
	if iRel > 0 or (iRel == 0 and iPlayer) then
		for i, belief in pairs(Game.GetBeliefsInReligion(iRel, iPlayer)) do
			if belief == iBelief then
				return true;
			end
		end
	end
	return false
end

function GetFaithFromLaws(iPlayer)
	local t = 0
	return t;
end

function GetFaithFromLuxuries(iPlayer)
	if gT.Players[iPlayer].GovRewards[54] then
		return math.floor(gT.Players[iPlayer].TotalHapChanceFromLuxuries / 2);
	end
	return 0;
end

function GetFaithFromGW(iPlayer)
	if gT.Players[iPlayer].GovRewards[50] then
		return math.floor(gT.Players[iPlayer].NumGreatWorks / 2);
	end
	return 0;
end

function GetFaithFromGPC(iPlayer)
	local t = 0;
	for gpID, hhh in pairs(gT.Players[iPlayer].GreatPeople) do
		local gpData = gT.GreatPeople[gpID];
		if gpData.Alive then
			if gpData.Faith then
				t = t + gpData.Faith * gT.Players[iPlayer].YieldModGreatPeople[gpData.Type]
			end
		end
	end
	if HasPlayerTech(iPlayer, arabtrial7, "adaweqdqw") then
		t = t + 5 * GetNumOfGPCivilOfType(iPlayer, 9)
	end
	local extraMod = 0;
	if gT.Players[iPlayer].GovRewards[52] then
		extraMod = extraMod + 1;
	end
	return t * (gT.Players[iPlayer].GPYieldsMod + extraMod);
end

function GetTotalFaithFromExtraSourcesITG(iPlayer, bTooltip, bIgnoreConvert)
	local iTotal = GetFaithFromForts(iPlayer) + GetFaithFromBuildingMaint(iPlayer) + GetFaithFromHolySites(iPlayer) + GetFaithFromHappiness(iPlayer) + GetFaithFromTechnologies(iPlayer) + GetFaithFromGPC(iPlayer) + GetFaithFromElDorados(iPlayer) + GetFaithFromLaws(iPlayer)
	iTotal = iTotal + Players[iPlayer]:GetTotalFaithPerTurn() + GetFaithFromLuxuries(iPlayer) + GetFaithFromGW(iPlayer) + GetFaithFromMorale(iPlayer)
	if bTooltip then
		iTotal = iTotal + GetFaithCultureFromWonderProcess(iPlayer) + GetFaithFromTithe(iPlayer) + EstimatedFaithFromHeresy(iPlayer);
		iTotal = iTotal + EstimatedFaithSectGain(iPlayer)
		if not bIgnoreConvert then
			local cTotal = iTotal;
			iTotal = iTotal + GetConvertedFaithIntoLegal(iPlayer, cTotal);
			iTotal = iTotal - 3 * GetConvertedLegalIntoFaith(iPlayer, GetLegalPointsPerTurn(iPlayer, true, false, true))
			iTotal = iTotal - 5 * GetConvertedScienceIntoFaith(iPlayer, GetITGSciencePerTurn(iPlayer, true, true)) / 3;
		end
	end
	return iTotal;
end

function ChangeITGFaith(iPlayer, amount, bNotConvertable)
	if amount > 0 then
		if not bNotConvertable then
	--[[	if IsHasLaw(iPlayer, 22, 1) then
				local lnew = gT.Players[iPlayer].Law22FaithPoints + amount;
				local lred = math.floor(lnew / 20);
				if lred > 0 then
					amount = amount - 5 * lred;
					gT.Players[iPlayer].Law22FaithPoints = lnew - lred * 20;
					ChangeITGLegalPointsPercent(iPlayer, lred, true, "Faith Convert")
				end
			end ]]
		end
	elseif amount < 0 then
		print("ChangeITGFaith should be used only for positive stuff :)", iPlayer, amount, bNotConvertable)
		SpendITGFaith(iPlayer, -amount)
		return;
	end
	Players[iPlayer]:ChangeFaith(amount);
end

function EstimatedFaithFromHeresy(iPlayer)
	local t = 0;
	return t;
end

function GetNumSpreadsNeededWithMax(iRel, gStrength, iCity, max)
	for i = 1, max do
		if iCity:GetMajorityReligionAfterSpread(iRel, 10 * gStrength * i) == iRel then
			return i;
		end
	end
	return max + 1;
end

function SpendITGFaith(iPlayer, value)
	gT.Players[iPlayer].FaithLost = gT.Players[iPlayer].FaithLost + value;
	Players[iPlayer]:ChangeFaith(-1 * value)
	if iPlayer == Game.GetActivePlayer() then
		LuaEvents.ITGSGTopPanelDirty()
	end
end

function CanFoundReligionRightNow(iPlayer)
	if Players[iPlayer]:GetNumCities() == 0 then
		return false;
	end
	if Players[iPlayer]:GetBuildingClassCount(GameInfoTypes.BUILDINGCLASS_ITG_NEW_WORLD_WONDER_16) > 0 then
		return true;
	end
	if Players[iPlayer]:HasCreatedPantheon() then
		if #Game.GetBeliefsInReligion(0, iPlayer) > 4 then
			return true;
		end
	end
	return false;
end

function IsItGoodIdeaForAIToMakeNewPantheon(iPlayer)
	local baseV = 25 + Players[iPlayer]:GetNumCities() * 5;
	if Players[iPlayer]:HasCreatedPantheon() then
		local numL = #Game.GetBeliefsInReligion(0, iPlayer);
		if numL == 4 then
			baseV = baseV + 130 - GetITGGameTurn();
		elseif numL == 3 then
			baseV = baseV + 20 + (100 - GetITGGameTurn()) / 2;
		elseif numL == 2 then
			baseV = baseV + 10 + (100 - GetITGGameTurn()) / 3;
		else
			baseV = baseV + (100 - GetITGGameTurn()) / 4;
		end
	else
		baseV = baseV + 60 - GetITGGameTurn();
	end
	return LastRandom(1, 100) <= baseV;
end

function GetNumPantheonsAvailableToChooseFrom(iPlayer)
	local base = GetNumOptionsPantheonBelief(iPlayer) 
	if base > 1 then
		local tt = GetNewBeliefForReformation(nil, iPlayer, GetCurrentBeliefs(iPlayer), 4, 1, true)
		return math.min(base, #tt)
	end
	return base;
end

function GetCurrentBeliefs(iPlayer)
	local iRel = Players[iPlayer]:GetReligionCreatedByPlayer()
	if iRel > 0 then
		return Game.GetBeliefsInReligion(iRel)
	elseif Players[iPlayer]:HasCreatedPantheon() then
		return Game.GetBeliefsInReligion(0, iPlayer)
	end
	return {}
end

function GetNumOptionsPantheonBelief(iPlayer)
	local b = gT.Players[iPlayer].NumPantheonsToChoose;
	return b;
end

function PlayerWantsToAdoptNewPantheon(iPlayer, bForceOne)
	local c = GetNumPantheonsAvailableToChooseFrom(iPlayer);
	DoIncreaseHeresyProbability(2)
	if c == 1 or bForceOne then
		DoAddNewBeliefOfType(iPlayer, 1)		
		if gT.Players[iPlayer].HasPlayerWonder[luxortemple1] then
			DoAddNewBeliefOfType(iPlayer, 1)
		end
	else
		local gTab = GetNewBeliefForReformation(nil, iPlayer, GetCurrentBeliefs(iPlayer), 1, 1, true);
		if Players[iPlayer]:IsHuman() then
			local data = {Text = "CHOOSE PANTHEON", UniqueOptions = {}, BonusType = "ChoosePantheon", TitleText = "Choose your bonus wisely.", TitleIconIndex = 16, TitleIconAtlas = "EXPANSION_UNIT_ATLAS_1", Tooltip = "Many beliefs to choose from..."}
			for i, answer in pairs(gTab) do
				if i <= c then
					table.insert(data.UniqueOptions, {
						Name = Locale.Lookup(GameInfo.Beliefs[answer].ShortDescription),
						Help = "[NEWLINE]" .. Locale.Lookup(GameInfo.Beliefs[answer].Description),
						ID = answer
					})
				else
					break;
				end
			end
			table.insert(gT.Players[iPlayer].NewHumanQueueActions, data)
			LuaEvents.ITG_GeneralChooseWithPriority("CHOOSE PANTHEON");
		else
			local bv, bo = -1, -1;
			for i, answer in pairs(gTab) do
				if i <= c then
					local value = DLLBasedBeliefScore(iPlayer, answer);
					if value > bv then
						bv = value;
						bo = answer;
					end
				end
			end
			if bo == -1 then
				print("Error 912831123", iPlayer)
			else
				DoAddNewPantheonType(iPlayer, bo)
			end
		end
	end
end

function HumanPlayerDoAddNewPantheonType(iPlayer, confirminfo2, confirminfo3, confirminfo4)
	DoAddNewPantheonType(iPlayer, confirminfo2)
	GeneralRemoveFirstBonusType(iPlayer, "ChoosePantheon")
end

function DoAddNewPantheonType(iPlayer, cBelief)
	DoAddNewBeliefOfType(iPlayer, 1, cBelief)	
	if gT.Players[iPlayer].HasPlayerWonder[luxortemple1] then
		DoAddNewBeliefOfType(iPlayer, 1)
	end
end

function DoRecalculateFollowersInOfficialStates()
	for g, h in pairs(gT.Players) do
		if h.OfficialReligion then
			for iCity in Players[g]:Cities() do
				CityRecalucateFollowersOfficial(iCity, h.OfficialReligion)
			end
		end
	end
end

function CityRecalucateFollowersOfficial(iCity, iRel)
	local baseRel = iCity:GetNumReligionPressure(iRel) --65+%
	local bGood = (iCity:GetReligiousMajority() == iRel);
	local presPresent = {}
	local totadding = 0;
	for relHID = 1, maxReligionITT do
		local gnp = iCity:GetPressurePerTurn(relHID)
		if gnp > 0 then
			presPresent[relHID] = gnp;
			totadding = totadding + gnp;
		end
		if iCity:GetNumReligionPressure(relHID) > 0 then
			if relHID ~= iRel then
				iCity:SetNumReligionPressure(relHID, 0, true)
			end
		end
	end
	if totadding == 0 then
		return;
	end
	if baseRel > 90000 then
		baseRel = 9000;
	end
	if baseRel < 10000 then
		baseRel = 10000;
	end
	local ultitotal = baseRel * 20 / 13
	if (presPresent[iRel] or 0) / totadding < 0.65 then
		iCity:SetNumReligionPressure(iRel, baseRel, true)
		ultitotal = ultitotal * 7 / 20;
		totadding = totadding - (presPresent[iRel] or 0);
		presPresent[iRel] = nil;
	end
	for otherrel, sth in pairs(presPresent) do
		iCity:SetNumReligionPressure(otherrel, math.floor( ultitotal * sth / totadding), true )
	end
	for i = -1, 0 do
		if iCity:GetNumReligionPressure(i) > 0 then
			iCity:SetNumReligionPressure(i, 0, true)
		end
	end
	iCity:SetNumReligionPressure(iRel, iCity:GetNumReligionPressure(iRel))
	if iCity:GetReligiousMajority() ~= iRel then
		print("Recalculating of Religion followers official rel?!?", iRel, iCity:GetID(), iCity:GetOwner(), iCity:GetPopulation(), bGood, maxReligionITT)
		for relHID = 1, maxReligionITT do
			if iCity:GetNumReligionPressure(relHID) > 0 then
				print("MMG", relHID, iCity:GetNumReligionPressure(relHID))
			end
		end
		if iCity:GetReligiousMajority() == iRel then
			print("Above Issue fixed")
		end
	end
end

function GetFaithFromBuildingMaint(iPlayer)
	local b = 0;
	if gT.Players[iPlayer].HasPlayerWonder[gmedwonder11] then
		b = b + math.floor(Players[iPlayer]:GetBuildingGoldMaintenance() / 2)
	end
	return b;
end

function HasAIReasonNotToSendMissionaryToCity(iCity, iPlayer, iRel)
	if iCity:GetReligiousMajority() == iRel then
		return true;
	end
	local plotIndex = iCity:Plot():GetPlotIndex();
	local numCinLast8turns = 0;
	local gTurn = GetITGGameTurn() - 10;
	local tV = #gT.Globals.HnGData.CityCaptures
	for i = 0, tV - 1 do
		if gT.Globals.HnGData.CityCaptures[tV].Turn >= gTurn then
			if gT.Globals.HnGData.CityCaptures[tV].Plot == plotIndex then
				numCinLast8turns = numCinLast8turns + 1;
			end
		else
			break;
		end
	end
	return numCinLast8turns > 2;
end