local bInquisition = GameInfoTypes.BUILDING_ITG_NEW_WORLD_INQUISITION;
local maxReligionITT = -1;
local techinnoasia6 = GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_ASIA_6;
local relDLLscale = 10;
for row in GameInfo.Religions() do
	maxReligionITT = maxReligionITT + 1;
end
local templeofLiterature = GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_29;
local techinnomeso8 = GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_MESOAMERICAN_8
local bcGrandTemple = GameInfoTypes.BUILDINGCLASS_GRAND_TEMPLE;
local hwang1 = GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_36;
local luxortemple1 = GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_38;
local wonderFortAllowing = GameInfoTypes.BUILDING_ITG_NEW_MEDIEVAL_WONDER_6

local beliefTypeFilter = {}
for row in GameInfo.Beliefs() do
	if row.Pantheon then
		beliefTypeFilter[row.ID] = 1;
	elseif row.Founder then
		beliefTypeFilter[row.ID] = 3;
	elseif row.Follower then
		beliefTypeFilter[row.ID] = 2;
	elseif row.Enhancer then
		beliefTypeFilter[row.ID] = 4;
	elseif row.Templar then
		beliefTypeFilter[row.ID] = 5;
	end
end

function GetBeliefTypeITG(beliefID)
	return beliefTypeFilter[beliefID] or nil;
end

--new lua
--GetMajorityReligionAfterSpread(irel, iAmount)
--and more
--AddReligiousPressure(type, irel, amount, player)
--[[0
  0  FOLLOWER_CHANGE_POP_CHANGE,
    FOLLOWER_CHANGE_HOLY_CITY,
  2  FOLLOWER_CHANGE_ADJACENT_PRESSURE,
    FOLLOWER_CHANGE_RELIGION_FOUNDED,
  4  FOLLOWER_CHANGE_PANTHEON_FOUNDED,
    FOLLOWER_CHANGE_CONQUEST,
  6  FOLLOWER_CHANGE_MISSIONARY,
    FOLLOWER_CHANGE_PROPHET,
  8  FOLLOWER_CHANGE_REMOVE_HERESY,
	FOLLOWER_CHANGE_SCRIPTED_CONVERSION,
	FOLLOWER_CHANGE_SPY_PRESSURE,
]]

function HaveAtLeastOneCityFollowing(d, iRel)
	for iCity in Players[d]:Cities() do
		if iCity:GetReligiousMajority() == iRel then
			return true;
		end
	end
	return false;
end

function AssignTheReligions(majTab, hMinorTab)
	if gT.Globals.ScenarioType == 1 then
		AssignReligionForNewWorld(majTab, hMinorTab)
	elseif gT.Globals.ScenarioType == 2 then
		AssignReligionForMedieval(majTab, hMinorTab)
	elseif gT.Globals.ScenarioType == 3 then
		AssignReligionForAncient(majTab, hMinorTab)
	elseif gT.Globals.ScenarioType == 4 then
		AssignReligionForIndustrial(majTab, hMinorTab)
	elseif gT.Globals.ScenarioType == 5 then
		AssignReligionForModern(majTab, hMinorTab)
	else
		print("No religion assign function for scenario!", gT.Globals.ScenarioType)
	end
	DoRecalculateFollowersInOfficialStates()
	gT.Globals.RequiresReligionReconvert  = true;
	DoBaseDataForReligion()
	RemoveTemplarOptionsBasedOnNumMajorPlayers()
	if gT.Globals.ScenarioType == 1 then
		AssignTemplarBonusesNewWorld()
	elseif gT.Globals.ScenarioType == 2 then
		AssignTemplarBonusesMedieval()
	elseif gT.Globals.ScenarioType == 3 then
	
	elseif gT.Globals.ScenarioType == 4 then
		AssignTemplarBonusesIndustrial()
	elseif gT.Globals.ScenarioType == 5 then

	else
		print("No religion assign templar for scenario!", gT.Globals.ScenarioType)
	end
	if gT.Globals.HangingTempleDelay then
		local iCity = Map.GetPlotByIndex(gT.Globals.HangingTempleDelay):GetPlotCity();
		DoNearbyHolySiteOnMountain(iCity:GetOwner(), iCity)
		gT.Globals.HangingTempleDelay = nil;
	end
	AssignAdditionalHolyPlaces()
	for g, gd in pairs(gT.Players) do --?? is it a relic?
		for iCity in Players[g]:Cities() do 
			iCity:ChangePopulation(1, true); 
			iCity:ChangePopulation(-1, true)
		end
	end
end
	
local ReligionCultureTypes = {
[1] = {GameInfoTypes.RELIGION_CHRISTIANITY, GameInfoTypes.RELIGION_ISLAM, GameInfoTypes.RELIGION_JUDAISM, GameInfoTypes.RELIGION_TAOISM, GameInfoTypes.RELIGION_ORTHODOXY, GameInfoTypes.RELIGION_PROTESTANTISM, GameInfoTypes.RELIGION_ITGSG_EXTRA_7, GameInfoTypes.RELIGION_ITGSG_EXTRA_8,GameInfoTypes.RELIGION_ITGSG_EXTRA_9, GameInfoTypes.RELIGION_ITGSG_EXTRA_12,
GameInfoTypes.RELIGION_ITGSG_EXTRA_13, GameInfoTypes.RELIGION_ITGSG_EXTRA_14, GameInfoTypes.RELIGION_ITGSG_EXTRA_15},
[2] = {GameInfoTypes.RELIGION_CONFUCIANISM, GameInfoTypes.RELIGION_BUDDHISM, GameInfoTypes.RELIGION_HINDUISM, GameInfoTypes.RELIGION_SIKHISM, GameInfoTypes.RELIGION_SHINTO, GameInfoTypes.RELIGION_SIKHISM, GameInfoTypes.RELIGION_TENGRIISM, GameInfoTypes.RELIGION_ZOROASTRIANISM, GameInfoTypes.RELIGION_ITGSG_EXTRA_0,
GameInfoTypes.RELIGION_ITGSG_EXTRA_3, GameInfoTypes.RELIGION_ITGSG_EXTRA_4, GameInfoTypes.RELIGION_ITGSG_EXTRA_5, GameInfoTypes.RELIGION_ITGSG_EXTRA_11},
[3] = {GameInfoTypes.RELIGION_CHRISTIANITY, GameInfoTypes.RELIGION_JUDAISM, GameInfoTypes.RELIGION_TAOISM, GameInfoTypes.RELIGION_ZOROASTRIANISM, GameInfoTypes.RELIGION_ORTHODOXY, GameInfoTypes.RELIGION_PROTESTANTISM, GameInfoTypes.RELIGION_ITGSG_EXTRA_1, GameInfoTypes.RELIGION_ITGSG_EXTRA_6, GameInfoTypes.RELIGION_ITGSG_EXTRA_7, GameInfoTypes.RELIGION_ITGSG_EXTRA_8, GameInfoTypes.RELIGION_ITGSG_EXTRA_9, GameInfoTypes.RELIGION_ITGSG_EXTRA_10, GameInfoTypes.RELIGION_ITGSG_EXTRA_12, GameInfoTypes.RELIGION_ITGSG_EXTRA_13, GameInfoTypes.RELIGION_ITGSG_EXTRA_14, GameInfoTypes.RELIGION_ITGSG_EXTRA_15
},
[4] = {GameInfoTypes.RELIGION_ISLAM, GameInfoTypes.RELIGION_JUDAISM, GameInfoTypes.RELIGION_TAOISM, GameInfoTypes.RELIGION_ZOROASTRIANISM, GameInfoTypes.RELIGION_ITGSG_EXTRA_0, GameInfoTypes.RELIGION_ITGSG_EXTRA_3, GameInfoTypes.RELIGION_ITGSG_EXTRA_4, GameInfoTypes.RELIGION_ITGSG_EXTRA_5
},
[5] = {GameInfoTypes.RELIGION_BUDDHISM, GameInfoTypes.RELIGION_CONFUCIANISM, GameInfoTypes.RELIGION_HINDUISM, GameInfoTypes.RELIGION_SHINTO, GameInfoTypes.RELIGION_SIKHISM, GameInfoTypes.RELIGION_TAOISM, GameInfoTypes.RELIGION_ITGSG_EXTRA_11
},
[6] = {GameInfoTypes.RELIGION_CHRISTIANITY, GameInfoTypes.RELIGION_CONFUCIANISM, GameInfoTypes.RELIGION_HINDUISM, GameInfoTypes.RELIGION_SIKHISM, GameInfoTypes.RELIGION_TAOISM, GameInfoTypes.RELIGION_TENGRIISM, GameInfoTypes.RELIGION_ITGSG_EXTRA_1, GameInfoTypes.RELIGION_ITGSG_EXTRA_2
},
[7] = {GameInfoTypes.RELIGION_BUDDHISM, GameInfoTypes.RELIGION_CHRISTIANITY, GameInfoTypes.RELIGION_CONFUCIANISM, GameInfo.RELIGION_HINDUISM, GameInfoTypes.RELIGION_ZOROASTRIANISM, GameInfoTypes.RELIGION_ITGSG_EXTRA_6, GameInfoTypes.RELIGION_ITGSG_EXTRA_7, GameInfoTypes.RELIGION_ITGSG_EXTRA_15},
[8] = {GameInfoTypes.RELIGION_BUDDHISM, GameInfoTypes.RELIGION_CHRISTIANITY, GameInfoTypes.RELIGION_CONFUCIANISM, GameInfo.RELIGION_HINDUISM, GameInfoTypes.RELIGION_JUDAISM, GameInfoTypes.RELIGION_SHINTO, GameInfoTypes.RELIGION_ITGSG_EXTRA_6, GameInfoTypes.RELIGION_ITGSG_EXTRA_15},
[9] = {GameInfoTypes.RELIGION_JUDAISM, GameInfoTypes.RELIGION_SHINTO, GameInfoTypes.RELIGION_SIKHISM, GameInfoTypes.RELIGION_ZOROASTRIANISM, GameInfoTypes.RELIGION_ITGSG_EXTRA_2, GameInfoTypes.RELIGION_ITGSG_EXTRA_3, GameInfoTypes.RELIGION_ITGSG_EXTRA_6, GameInfoTypes.RELIGION_ITGSG_EXTRA_15},
[10] = {
GameInfoTypes.RELIGION_BUDDHISM, GameInfoTypes.RELIGION_CHRISTIANITY, GameInfoTypes.RELIGION_CONFUCIANISM, GameInfoTypes.RELIGION_HINDUISM
, GameInfoTypes.RELIGION_ISLAM, GameInfoTypes.RELIGION_JUDAISM, GameInfoTypes.RELIGION_SHINTO, GameInfoTypes.RELIGION_SIKHISM, GameInfoTypes.RELIGION_TAOISM
, GameInfoTypes.RELIGION_TENGRIISM, GameInfoTypes.RELIGION_ZOROASTRIANISM, GameInfoTypes.RELIGION_ORTHODOXY, GameInfoTypes.RELIGION_PROTESTANTISM
, GameInfoTypes.RELIGION_ITGSG_EXTRA_0, GameInfoTypes.RELIGION_ITGSG_EXTRA_1, GameInfoTypes.RELIGION_ITGSG_EXTRA_2, GameInfoTypes.RELIGION_ITGSG_EXTRA_3
, GameInfoTypes.RELIGION_ITGSG_EXTRA_4, GameInfoTypes.RELIGION_ITGSG_EXTRA_5, GameInfoTypes.RELIGION_ITGSG_EXTRA_6, GameInfoTypes.RELIGION_ITGSG_EXTRA_7
, GameInfoTypes.RELIGION_ITGSG_EXTRA_8, GameInfoTypes.RELIGION_ITGSG_EXTRA_9, GameInfoTypes.RELIGION_ITGSG_EXTRA_10, GameInfoTypes.RELIGION_ITGSG_EXTRA_11
, GameInfoTypes.RELIGION_ITGSG_EXTRA_12, GameInfoTypes.RELIGION_ITGSG_EXTRA_13, GameInfoTypes.RELIGION_ITGSG_EXTRA_14, GameInfoTypes.RELIGION_ITGSG_EXTRA_15
}
}

function GetJustReligionType(scType, culType, iPlayer)
	if gT.EraData and gT.PreviousEra and iPlayer then 
		local relTab = {}
		for anyprev, h in pairs(gT.EraData) do
			for iReligion, sBeliefs in pairs(h.Players[iPlayer].ReligionCreated or {}) do
				if not Game.GetHolyCityForReligion(iReligion, -1) then
					table.insert(relTab, iReligion);
				end
			end
		end
		if #relTab > 0 then
			return RandomFromTab(relTab);
		end
	end
	local relType;
	local hRT = {}
	for i, rel in pairs(ReligionCultureTypes[culType]) do
		if not Game.GetHolyCityForReligion(rel, -1) then
			table.insert(hRT, rel)
		end
	end
	if #hRT == 0 then
		for relHID = 1, maxReligionITT do
			if not Game.GetHolyCityForReligion(relHID, -1) then
				relType = relHID;
				break;
			end
		end
	else
		relType = hRT[LastRandom(1,#hRT)];
	end
	return relType;
end

function GetNewReligionData(scType, culType, iPlayer)
	local relType = GetJustReligionType(scType, culType, iPlayer)
	if not relType then
		print("No reltype for", scType, culType, iPlayer)
		return -1, -1;
	end
	local relBeliefs = GetBeliefsForReligion(scType, culType, iPlayer)
	if #relBeliefs < 5 then
		print("No beliefs for", scType, culType, iPlayer)
		return -1, -1;
	end
	return relType, relBeliefs;
end

local CultureBeliefsType = { [1] = {
{GameInfoTypes.BELIEF_ITG_PANTHEON_23, GameInfoTypes.BELIEF_ITG_PANTHEON_1, GameInfoTypes.BELIEF_ITG_PANTHEON_2, GameInfoTypes.BELIEF_ITG_PANTHEON_3, GameInfoTypes.BELIEF_ITG_PANTHEON_5, GameInfoTypes.BELIEF_ITG_PANTHEON_6, GameInfoTypes.BELIEF_ITG_PANTHEON_7, GameInfoTypes.BELIEF_ITG_PANTHEON_9, GameInfoTypes.BELIEF_ITG_PANTHEON_11, GameInfoTypes.BELIEF_ITG_PANTHEON_12, GameInfoTypes.BELIEF_ITG_PANTHEON_13, GameInfoTypes.BELIEF_ITG_PANTHEON_17, GameInfoTypes.BELIEF_ITG_PANTHEON_18, GameInfoTypes.BELIEF_ITG_PANTHEON_19, GameInfoTypes.BELIEF_ITG_PANTHEON_20, GameInfoTypes.BELIEF_ITG_PANTHEON_21, GameInfoTypes.BELIEF_ITG_PANTHEON_22, GameInfoTypes.BELIEF_SACRED_WATERS, GameInfoTypes.BELIEF_MESSENGER_GODS, GameInfoTypes.BELIEF_GODDESS_LOVE, GameInfoTypes.BELIEF_GOD_KING, GameInfoTypes.BELIEF_EARTH_MOTHER, GameInfoTypes.BELIEF_GODDESS_HUNT, GameInfoTypes.BELIEF_FERTILITY_RITES, GameInfoTypes.BELIEF_GOD_CRAFTSMEN, GameInfoTypes.BELIEF_GOD_SEA, GameInfoTypes.BELIEF_OPEN_SKY, GameInfoTypes.BELIEF_FORMAL_LITURGY, GameInfoTypes.BELIEF_STONE_CIRCLES, GameInfoTypes.BELIEF_GOD_WAR, GameInfoTypes.BELIEF_RELIGIOUS_SETTLEMENTS, GameInfoTypes.BELIEF_GOD_FESTIVALS, GameInfoTypes.BELIEF_ORAL_TRADITION, GameInfoTypes.BELIEF_DESERT_FOLKLORE, GameInfoTypes.BELIEF_GODDESS_STRATEGY, GameInfoTypes.BELIEF_SACRED_PATH, GameInfoTypes.BELIEF_FAITH_HEALERS},
{GameInfoTypes.BELIEF_ITG_FOLLOWER_48,GameInfoTypes.BELIEF_ITG_FOLLOWER_41, GameInfoTypes.BELIEF_ITG_FOLLOWER_42, GameInfoTypes.BELIEF_ITG_FOLLOWER_43, GameInfoTypes.BELIEF_ITG_FOLLOWER_44, GameInfoTypes.BELIEF_ITG_FOLLOWER_45, GameInfoTypes.BELIEF_ITG_FOLLOWER_46, GameInfoTypes.BELIEF_ITG_FOLLOWER_23, GameInfoTypes.BELIEF_ITG_FOLLOWER_24, GameInfoTypes.BELIEF_ITG_FOLLOWER_25, GameInfoTypes.BELIEF_ITG_FOLLOWER_26, GameInfoTypes.BELIEF_ITG_FOLLOWER_27, GameInfoTypes.BELIEF_ITG_FOLLOWER_30, GameInfoTypes.BELIEF_ITG_FOLLOWER_31, GameInfoTypes.BELIEF_ITG_FOLLOWER_33, GameInfoTypes.BELIEF_ITG_FOLLOWER_34, GameInfoTypes.BELIEF_ITG_FOLLOWER_35, GameInfoTypes.BELIEF_ITG_FOLLOWER_37, GameInfoTypes.BELIEF_ITG_FOLLOWER_38, GameInfoTypes.BELIEF_ITG_FOLLOWER_1, GameInfoTypes.BELIEF_ITG_FOLLOWER_2, GameInfoTypes.BELIEF_ITG_FOLLOWER_5, GameInfoTypes.BELIEF_ITG_FOLLOWER_6, GameInfoTypes.BELIEF_ITG_FOLLOWER_7, GameInfoTypes.BELIEF_ITG_FOLLOWER_8, GameInfoTypes.BELIEF_ITG_FOLLOWER_10, GameInfoTypes.BELIEF_ITG_FOLLOWER_12, GameInfoTypes.BELIEF_ITG_FOLLOWER_13, GameInfoTypes.BELIEF_ITG_FOLLOWER_14, GameInfoTypes.BELIEF_ITG_FOLLOWER_17, GameInfoTypes.BELIEF_ITG_FOLLOWER_18, GameInfoTypes.BELIEF_ITG_FOLLOWER_20, GameInfoTypes.BELIEF_ITG_FOLLOWER_21, GameInfoTypes.BELIEF_FEED_WORLD, GameInfoTypes.BELIEF_GURUSHIP, GameInfoTypes.BELIEF_PEACE_GARDENS, GameInfoTypes.BELIEF_CHORAL_MUSIC, GameInfoTypes.BELIEF_LITURGICAL_DRAMA, GameInfoTypes.BELIEF_ASCETISM, GameInfoTypes.BELIEF_RELIGIOUS_CENTER, GameInfoTypes.BELIEF_RELIGIOUS_COMMUNITY, GameInfoTypes.BELIEF_DIVINE_INSPIRATION},
{GameInfoTypes.BELIEF_INTERFAITH_DIALOGUE, GameInfoTypes.BELIEF_ITG_FOUNDER_1, GameInfoTypes.BELIEF_ITG_FOUNDER_17, GameInfoTypes.BELIEF_ITG_FOUNDER_18, GameInfoTypes.BELIEF_ITG_FOUNDER_2, GameInfoTypes.BELIEF_ITG_FOUNDER_4, GameInfoTypes.BELIEF_ITG_FOUNDER_6, GameInfoTypes.BELIEF_ITG_FOUNDER_7, GameInfoTypes.BELIEF_ITG_FOUNDER_8, GameInfoTypes.BELIEF_ITG_FOUNDER_9, GameInfoTypes.BELIEF_ITG_FOUNDER_10, GameInfoTypes.BELIEF_ITG_FOUNDER_12, GameInfoTypes.BELIEF_ITG_FOUNDER_13, GameInfoTypes.BELIEF_ITG_FOUNDER_14, GameInfoTypes.BELIEF_ITG_FOUNDER_15, GameInfoTypes.BELIEF_CHURCH_PROPERTY, GameInfoTypes.BELIEF_TITHE, GameInfoTypes.BELIEF_PILGRIMAGE, GameInfoTypes.BELIEF_WORLD_CHURCH},
{GameInfoTypes.BELIEF_ITG_ENHANCER_2, GameInfoTypes.BELIEF_ITG_ENHANCER_15, GameInfoTypes.BELIEF_ITG_ENHANCER_4, GameInfoTypes.BELIEF_ITG_ENHANCER_5, GameInfoTypes.BELIEF_ITG_ENHANCER_6, GameInfoTypes.BELIEF_ITG_ENHANCER_7, GameInfoTypes.BELIEF_ITG_ENHANCER_10, GameInfoTypes.BELIEF_ITG_ENHANCER_11, GameInfoTypes.BELIEF_ITG_ENHANCER_14, GameInfoTypes.BELIEF_DEFENDER_FAITH, GameInfoTypes.BELIEF_ITINERANT_PREACHERS, GameInfoTypes.BELIEF_JUST_WAR, GameInfoTypes.BELIEF_MISSIONARY_ZEAL, GameInfoTypes.BELIEF_RELIGIOUS_TEXTS}},
[2] = {{GameInfoTypes.BELIEF_ITG_PANTHEON_23, GameInfoTypes.BELIEF_ITG_PANTHEON_1, GameInfoTypes.BELIEF_ITG_PANTHEON_2, GameInfoTypes.BELIEF_ITG_PANTHEON_4, GameInfoTypes.BELIEF_ITG_PANTHEON_5, GameInfoTypes.BELIEF_ITG_PANTHEON_6, GameInfoTypes.BELIEF_ITG_PANTHEON_8, GameInfoTypes.BELIEF_ITG_PANTHEON_10, GameInfoTypes.BELIEF_ITG_PANTHEON_11, GameInfoTypes.BELIEF_ITG_PANTHEON_12, GameInfoTypes.BELIEF_ITG_PANTHEON_13, GameInfoTypes.BELIEF_ITG_PANTHEON_14, GameInfoTypes.BELIEF_ITG_PANTHEON_15, GameInfoTypes.BELIEF_ITG_PANTHEON_16, GameInfoTypes.BELIEF_ITG_PANTHEON_17, GameInfoTypes.BELIEF_ITG_PANTHEON_18, GameInfoTypes.BELIEF_ITG_PANTHEON_19, GameInfoTypes.BELIEF_ITG_PANTHEON_20, GameInfoTypes.BELIEF_SACRED_WATERS, GameInfoTypes.BELIEF_GODDESS_LOVE, GameInfoTypes.BELIEF_SUN_GOD, GameInfoTypes.BELIEF_EARTH_MOTHER, GameInfoTypes.BELIEF_DANCE_AURORA, GameInfoTypes.BELIEF_ONE_WITH_NATURE, GameInfoTypes.BELIEF_GODDESS_HUNT, GameInfoTypes.BELIEF_FERTILITY_RITES, GameInfoTypes.BELIEF_GOD_CRAFTSMEN, GameInfoTypes.BELIEF_GOD_SEA, GameInfoTypes.BELIEF_OPEN_SKY, GameInfoTypes.BELIEF_FORMAL_LITURGY, GameInfoTypes.BELIEF_STONE_CIRCLES, GameInfoTypes.BELIEF_GOD_WAR, GameInfoTypes.BELIEF_RELIGIOUS_SETTLEMENTS, GameInfoTypes.BELIEF_GOD_FESTIVALS, GameInfoTypes.BELIEF_ORAL_TRADITION, GameInfoTypes.BELIEF_DESERT_FOLKLORE, GameInfoTypes.BELIEF_GODDESS_STRATEGY, GameInfoTypes.BELIEF_SACRED_PATH, GameInfoTypes.BELIEF_FAITH_HEALERS},
{GameInfoTypes.BELIEF_ITG_FOLLOWER_48,GameInfoTypes.BELIEF_ITG_FOLLOWER_47, GameInfoTypes.BELIEF_ITG_FOLLOWER_41, GameInfoTypes.BELIEF_ITG_FOLLOWER_42, GameInfoTypes.BELIEF_ITG_FOLLOWER_44, GameInfoTypes.BELIEF_ITG_FOLLOWER_24, GameInfoTypes.BELIEF_ITG_FOLLOWER_26, GameInfoTypes.BELIEF_ITG_FOLLOWER_27, GameInfoTypes.BELIEF_ITG_FOLLOWER_28, GameInfoTypes.BELIEF_ITG_FOLLOWER_29, GameInfoTypes.BELIEF_ITG_FOLLOWER_30, GameInfoTypes.BELIEF_ITG_FOLLOWER_31, GameInfoTypes.BELIEF_ITG_FOLLOWER_32, GameInfoTypes.BELIEF_ITG_FOLLOWER_34, GameInfoTypes.BELIEF_ITG_FOLLOWER_35, GameInfoTypes.BELIEF_ITG_FOLLOWER_36, GameInfoTypes.BELIEF_ITG_FOLLOWER_37, GameInfoTypes.BELIEF_ITG_FOLLOWER_38, GameInfoTypes.BELIEF_ITG_FOLLOWER_39, GameInfoTypes.BELIEF_ITG_FOLLOWER_40, GameInfoTypes.BELIEF_ITG_FOLLOWER_2, GameInfoTypes.BELIEF_ITG_FOLLOWER_3, GameInfoTypes.BELIEF_ITG_FOLLOWER_4, GameInfoTypes.BELIEF_ITG_FOLLOWER_5, GameInfoTypes.BELIEF_ITG_FOLLOWER_6, GameInfoTypes.BELIEF_ITG_FOLLOWER_7, GameInfoTypes.BELIEF_ITG_FOLLOWER_8, GameInfoTypes.BELIEF_ITG_FOLLOWER_9, GameInfoTypes.BELIEF_ITG_FOLLOWER_10, GameInfoTypes.BELIEF_ITG_FOLLOWER_11, GameInfoTypes.BELIEF_ITG_FOLLOWER_11, GameInfoTypes.BELIEF_ITG_FOLLOWER_14, GameInfoTypes.BELIEF_ITG_FOLLOWER_15, GameInfoTypes.BELIEF_ITG_FOLLOWER_16, GameInfoTypes.BELIEF_ITG_FOLLOWER_17, GameInfoTypes.BELIEF_ITG_FOLLOWER_19, GameInfoTypes.BELIEF_ITG_FOLLOWER_20, GameInfoTypes.BELIEF_ITG_FOLLOWER_21, GameInfoTypes.BELIEF_ITG_FOLLOWER_22, GameInfoTypes.BELIEF_FEED_WORLD, GameInfoTypes.BELIEF_GURUSHIP, GameInfoTypes.BELIEF_PEACE_GARDENS, GameInfoTypes.BELIEF_CHORAL_MUSIC, GameInfoTypes.BELIEF_LITURGICAL_DRAMA, GameInfoTypes.BELIEF_ASCETISM, GameInfoTypes.BELIEF_RELIGIOUS_CENTER, GameInfoTypes.BELIEF_RELIGIOUS_COMMUNITY, GameInfoTypes.BELIEF_DIVINE_INSPIRATION},
{GameInfoTypes.BELIEF_ITG_FOUNDER_2, GameInfoTypes.BELIEF_ITG_FOUNDER_19, GameInfoTypes.BELIEF_ITG_FOUNDER_3, GameInfoTypes.BELIEF_ITG_FOUNDER_5, GameInfoTypes.BELIEF_ITG_FOUNDER_8, GameInfoTypes.BELIEF_ITG_FOUNDER_10, GameInfoTypes.BELIEF_ITG_FOUNDER_11, GameInfoTypes.BELIEF_ITG_FOUNDER_15, GameInfoTypes.BELIEF_ITG_FOUNDER_16,GameInfoTypes.BELIEF_CHURCH_PROPERTY, GameInfoTypes.BELIEF_TITHE, GameInfoTypes.BELIEF_PILGRIMAGE, GameInfoTypes.BELIEF_WORLD_CHURCH},
{GameInfoTypes.BELIEF_ITG_ENHANCER_1, GameInfoTypes.BELIEF_ITG_ENHANCER_15, GameInfoTypes.BELIEF_ITG_ENHANCER_2, GameInfoTypes.BELIEF_ITG_ENHANCER_3, GameInfoTypes.BELIEF_ITG_ENHANCER_5, GameInfoTypes.BELIEF_ITG_ENHANCER_8, GameInfoTypes.BELIEF_ITG_ENHANCER_9, GameInfoTypes.BELIEF_ITG_ENHANCER_11, GameInfoTypes.BELIEF_ITG_ENHANCER_12, GameInfoTypes.BELIEF_ITG_ENHANCER_13, GameInfoTypes.BELIEF_ITG_ENHANCER_14, GameInfoTypes.BELIEF_DEFENDER_FAITH, GameInfoTypes.BELIEF_JUST_WAR, GameInfoTypes.BELIEF_MISSIONARY_ZEAL}},
[3] = {{GameInfoTypes.BELIEF_ITG_PANTHEON_23, GameInfoTypes.BELIEF_GODDESS_HUNT, GameInfoTypes.BELIEF_GOD_CRAFTSMEN, GameInfoTypes.BELIEF_GOD_SEA, GameInfoTypes.BELIEF_OPEN_SKY, GameInfoTypes.BELIEF_FORMAL_LITURGY, GameInfoTypes.BELIEF_GOD_WAR, GameInfoTypes.BELIEF_RELIGIOUS_SETTLEMENTS, GameInfoTypes.BELIEF_GOD_FESTIVALS, GameInfoTypes.BELIEF_FAITH_HEALERS, GameInfoTypes.BELIEF_EARTH_MOTHER, GameInfoTypes.BELIEF_ITG_PANTHEON_1, GameInfoTypes.BELIEF_ITG_PANTHEON_2, GameInfoTypes.BELIEF_ITG_PANTHEON_5, GameInfoTypes.BELIEF_ITG_PANTHEON_6, GameInfoTypes.BELIEF_ITG_PANTHEON_7, GameInfoTypes.BELIEF_ITG_PANTHEON_8, GameInfoTypes.BELIEF_ITG_PANTHEON_9, GameInfoTypes.BELIEF_ITG_PANTHEON_12, GameInfoTypes.BELIEF_ITG_PANTHEON_13, GameInfoTypes.BELIEF_ITG_PANTHEON_16, GameInfoTypes.BELIEF_ITG_PANTHEON_18},
{GameInfoTypes.BELIEF_ITG_FOLLOWER_48,GameInfoTypes.BELIEF_FEED_WORLD, GameInfoTypes.BELIEF_PEACE_GARDENS, GameInfoTypes.BELIEF_CHORAL_MUSIC, GameInfoTypes.BELIEF_LITURGICAL_DRAMA, GameInfoTypes.BELIEF_ASCETISM, GameInfoTypes.BELIEF_RELIGIOUS_CENTER, GameInfoTypes.BELIEF_RELIGIOUS_COMMUNITY, GameInfoTypes.BELIEF_DIVINE_INSPIRATION, GameInfoTypes.BELIEF_ITG_FOLLOWER_1, GameInfoTypes.BELIEF_ITG_FOLLOWER_2, GameInfoTypes.BELIEF_ITG_FOLLOWER_3, GameInfoTypes.BELIEF_ITG_FOLLOWER_4, GameInfoTypes.BELIEF_ITG_FOLLOWER_5, GameInfoTypes.BELIEF_ITG_FOLLOWER_6, GameInfoTypes.BELIEF_ITG_FOLLOWER_7, GameInfoTypes.BELIEF_ITG_FOLLOWER_12, GameInfoTypes.BELIEF_ITG_FOLLOWER_17, GameInfoTypes.BELIEF_ITG_FOLLOWER_18, GameInfoTypes.BELIEF_ITG_FOLLOWER_19, GameInfoTypes.BELIEF_ITG_FOLLOWER_20, GameInfoTypes.BELIEF_ITG_FOLLOWER_21, GameInfoTypes.BELIEF_ITG_FOLLOWER_22, GameInfoTypes.BELIEF_ITG_FOLLOWER_23, GameInfoTypes.BELIEF_ITG_FOLLOWER_31, GameInfoTypes.BELIEF_ITG_FOLLOWER_40, GameInfoTypes.BELIEF_ITG_FOLLOWER_42, GameInfoTypes.BELIEF_ITG_FOLLOWER_44},
{GameInfoTypes.BELIEF_CHURCH_PROPERTY, GameInfoTypes.BELIEF_TITHE, GameInfoTypes.BELIEF_ITG_FOUNDER_19, GameInfoTypes.BELIEF_PAPAL_PRIMACY, GameInfoTypes.BELIEF_PILGRIMAGE, GameInfoTypes.BELIEF_WORLD_CHURCH, GameInfoTypes.BELIEF_ITG_FOUNDER_1, GameInfoTypes.BELIEF_ITG_FOUNDER_2, GameInfoTypes.BELIEF_ITG_FOUNDER_4, GameInfoTypes.BELIEF_ITG_FOUNDER_6, GameInfoTypes.BELIEF_ITG_FOUNDER_9, GameInfoTypes.BELIEF_ITG_FOUNDER_12, GameInfoTypes.BELIEF_ITG_FOUNDER_16},
{GameInfoTypes.BELIEF_RELIGIOUS_TEXTS, GameInfoTypes.BELIEF_ITG_ENHANCER_15, GameInfoTypes.BELIEF_JUST_WAR, GameInfoTypes.BELIEF_DEFENDER_FAITH, GameInfoTypes.BELIEF_ITINERANT_PREACHERS, GameInfoTypes.BELIEF_MISSIONARY_ZEAL, GameInfoTypes.BELIEF_ITG_ENHANCER_4, GameInfoTypes.BELIEF_ITG_ENHANCER_5, GameInfoTypes.BELIEF_ITG_ENHANCER_6, GameInfoTypes.BELIEF_ITG_ENHANCER_7, GameInfoTypes.BELIEF_ITG_ENHANCER_8, GameInfoTypes.BELIEF_ITG_ENHANCER_10, GameInfoTypes.BELIEF_ITG_ENHANCER_11, GameInfoTypes.BELIEF_ITG_ENHANCER_12}},
[4] = {{GameInfoTypes.BELIEF_ITG_PANTHEON_23, GameInfoTypes.BELIEF_FERTILITY_RITES, GameInfoTypes.BELIEF_GOD_CRAFTSMEN, GameInfoTypes.BELIEF_GOD_SEA, GameInfoTypes.BELIEF_OPEN_SKY, GameInfoTypes.BELIEF_MESSENGER_GODS, GameInfoTypes.BELIEF_GOD_WAR, GameInfoTypes.BELIEF_RELIGIOUS_SETTLEMENTS, GameInfoTypes.BELIEF_DESERT_FOLKLORE, GameInfoTypes.BELIEF_FAITH_HEALERS, GameInfoTypes.BELIEF_TEARS_OF_GODS, GameInfoTypes.BELIEF_EARTH_MOTHER, GameInfoTypes.BELIEF_ITG_PANTHEON_1, GameInfoTypes.BELIEF_ITG_PANTHEON_2, GameInfoTypes.BELIEF_ITG_PANTHEON_3, GameInfoTypes.BELIEF_ITG_PANTHEON_5, GameInfoTypes.BELIEF_ITG_PANTHEON_6, GameInfoTypes.BELIEF_ITG_PANTHEON_7, GameInfoTypes.BELIEF_ITG_PANTHEON_9, GameInfoTypes.BELIEF_ITG_PANTHEON_12, GameInfoTypes.BELIEF_ITG_PANTHEON_13, GameInfoTypes.BELIEF_ITG_PANTHEON_17, GameInfoTypes.BELIEF_ITG_PANTHEON_19, GameInfoTypes.BELIEF_ITG_PANTHEON_20},
{GameInfoTypes.BELIEF_ITG_FOLLOWER_48,GameInfoTypes.BELIEF_FEED_WORLD, GameInfoTypes.BELIEF_PEACE_GARDENS, GameInfoTypes.BELIEF_CHORAL_MUSIC, GameInfoTypes.BELIEF_LITURGICAL_DRAMA, GameInfoTypes.BELIEF_ASCETISM, GameInfoTypes.BELIEF_RELIGIOUS_CENTER, GameInfoTypes.BELIEF_DIVINE_INSPIRATION, GameInfoTypes.BELIEF_ITG_FOLLOWER_1, GameInfoTypes.BELIEF_ITG_FOLLOWER_2, GameInfoTypes.BELIEF_ITG_FOLLOWER_3, GameInfoTypes.BELIEF_ITG_FOLLOWER_4, GameInfoTypes.BELIEF_ITG_FOLLOWER_5, GameInfoTypes.BELIEF_ITG_FOLLOWER_6, GameInfoTypes.BELIEF_ITG_FOLLOWER_7, GameInfoTypes.BELIEF_ITG_FOLLOWER_8, GameInfoTypes.BELIEF_ITG_FOLLOWER_16, GameInfoTypes.BELIEF_ITG_FOLLOWER_17, GameInfoTypes.BELIEF_ITG_FOLLOWER_18, GameInfoTypes.BELIEF_ITG_FOLLOWER_19, GameInfoTypes.BELIEF_ITG_FOLLOWER_20, GameInfoTypes.BELIEF_ITG_FOLLOWER_21, GameInfoTypes.BELIEF_ITG_FOLLOWER_22, GameInfoTypes.BELIEF_ITG_FOLLOWER_32, GameInfoTypes.BELIEF_ITG_FOLLOWER_33, GameInfoTypes.BELIEF_ITG_FOLLOWER_34, GameInfoTypes.BELIEF_ITG_FOLLOWER_35, GameInfoTypes.BELIEF_ITG_FOLLOWER_42},
{GameInfoTypes.BELIEF_CHURCH_PROPERTY, GameInfoTypes.BELIEF_TITHE, GameInfoTypes.BELIEF_ITG_FOUNDER_19, GameInfoTypes.BELIEF_PAPAL_PRIMACY, GameInfoTypes.BELIEF_PILGRIMAGE, GameInfoTypes.BELIEF_WORLD_CHURCH, GameInfoTypes.BELIEF_ITG_FOUNDER_1, GameInfoTypes.BELIEF_ITG_FOUNDER_2, GameInfoTypes.BELIEF_ITG_FOUNDER_5, GameInfoTypes.BELIEF_ITG_FOUNDER_6, GameInfoTypes.BELIEF_ITG_FOUNDER_9, GameInfoTypes.BELIEF_ITG_FOUNDER_10, GameInfoTypes.BELIEF_ITG_FOUNDER_12, GameInfoTypes.BELIEF_ITG_FOUNDER_15, GameInfoTypes.BELIEF_ITG_FOUNDER_16},
{GameInfoTypes.BELIEF_RELIGIOUS_TEXTS, GameInfoTypes.BELIEF_JUST_WAR, GameInfoTypes.BELIEF_DEFENDER_FAITH, GameInfoTypes.BELIEF_ITG_ENHANCER_15, GameInfoTypes.BELIEF_ITINERANT_PREACHERS, GameInfoTypes.BELIEF_MISSIONARY_ZEAL, GameInfoTypes.BELIEF_ITG_ENHANCER_3, GameInfoTypes.BELIEF_ITG_ENHANCER_4, GameInfoTypes.BELIEF_ITG_ENHANCER_5, GameInfoTypes.BELIEF_ITG_ENHANCER_6, GameInfoTypes.BELIEF_ITG_ENHANCER_7, GameInfoTypes.BELIEF_ITG_ENHANCER_8, GameInfoTypes.BELIEF_ITG_ENHANCER_10, GameInfoTypes.BELIEF_ITG_ENHANCER_11, GameInfoTypes.BELIEF_ITG_ENHANCER_12}},
[5] = {{GameInfoTypes.BELIEF_ITG_PANTHEON_23, GameInfoTypes.BELIEF_GODDESS_HUNT, GameInfoTypes.BELIEF_FERTILITY_RITES, GameInfoTypes.BELIEF_GOD_CRAFTSMEN, GameInfoTypes.BELIEF_GOD_SEA, GameInfoTypes.BELIEF_OPEN_SKY, GameInfoTypes.BELIEF_MESSENGER_GODS, GameInfoTypes.BELIEF_ONE_WITH_NATURE, GameInfoTypes.BELIEF_SACRED_WATERS, GameInfoTypes.BELIEF_GODDESS_LOVE, GameInfoTypes.BELIEF_GOD_FESTIVALS, GameInfoTypes.BELIEF_ORAL_TRADITION, GameInfoTypes.BELIEF_ANCESTOR_WORSHIP, GameInfoTypes.BELIEF_SACRED_PATH, GameInfoTypes.BELIEF_GODDESS_STRATEGY, GameInfoTypes.BELIEF_TEARS_OF_GODS, GameInfoTypes.BELIEF_GOD_KING, GameInfoTypes.BELIEF_SUN_GOD, GameInfoTypes.BELIEF_ITG_PANTHEON_3, GameInfoTypes.BELIEF_ITG_PANTHEON_6, GameInfoTypes.BELIEF_ITG_PANTHEON_7, GameInfoTypes.BELIEF_ITG_PANTHEON_11, GameInfoTypes.BELIEF_ITG_PANTHEON_14, GameInfoTypes.BELIEF_ITG_PANTHEON_17, GameInfoTypes.BELIEF_ITG_PANTHEON_18, GameInfoTypes.BELIEF_ITG_PANTHEON_20},
{GameInfoTypes.BELIEF_ITG_FOLLOWER_48,GameInfoTypes.BELIEF_ITG_FOLLOWER_47, GameInfoTypes.BELIEF_FEED_WORLD, GameInfoTypes.BELIEF_GURUSHIP, GameInfoTypes.BELIEF_PEACE_GARDENS, GameInfoTypes.BELIEF_CHORAL_MUSIC, GameInfoTypes.BELIEF_ASCETISM, GameInfoTypes.BELIEF_RELIGIOUS_CENTER, GameInfoTypes.BELIEF_RELIGIOUS_COMMUNITY, GameInfoTypes.BELIEF_DIVINE_INSPIRATION, GameInfoTypes.BELIEF_ITG_FOLLOWER_1, GameInfoTypes.BELIEF_ITG_FOLLOWER_2, GameInfoTypes.BELIEF_ITG_FOLLOWER_3, GameInfoTypes.BELIEF_ITG_FOLLOWER_4, GameInfoTypes.BELIEF_ITG_FOLLOWER_5, GameInfoTypes.BELIEF_ITG_FOLLOWER_8, GameInfoTypes.BELIEF_ITG_FOLLOWER_11, GameInfoTypes.BELIEF_ITG_FOLLOWER_14, GameInfoTypes.BELIEF_ITG_FOLLOWER_17, GameInfoTypes.BELIEF_ITG_FOLLOWER_18, GameInfoTypes.BELIEF_ITG_FOLLOWER_19, GameInfoTypes.BELIEF_ITG_FOLLOWER_20, GameInfoTypes.BELIEF_ITG_FOLLOWER_21, GameInfoTypes.BELIEF_ITG_FOLLOWER_22, GameInfoTypes.BELIEF_ITG_FOLLOWER_26, GameInfoTypes.BELIEF_ITG_FOLLOWER_27, GameInfoTypes.BELIEF_ITG_FOLLOWER_40, GameInfoTypes.BELIEF_ITG_FOLLOWER_41, GameInfoTypes.BELIEF_ITG_FOLLOWER_44},
{GameInfoTypes.BELIEF_INTERFAITH_DIALOGUE, GameInfoTypes.BELIEF_PEACE_LOVING, GameInfoTypes.BELIEF_ITG_FOUNDER_19, GameInfoTypes.BELIEF_CEREMONIAL_BURIAL, GameInfoTypes.BELIEF_PILGRIMAGE, GameInfoTypes.BELIEF_ITG_FOUNDER_1, GameInfoTypes.BELIEF_ITG_FOUNDER_2, GameInfoTypes.BELIEF_ITG_FOUNDER_3, GameInfoTypes.BELIEF_ITG_FOUNDER_5, GameInfoTypes.BELIEF_ITG_FOUNDER_10, GameInfoTypes.BELIEF_ITG_FOUNDER_11, GameInfoTypes.BELIEF_ITG_FOUNDER_15, GameInfoTypes.BELIEF_ITG_FOUNDER_16},
{GameInfoTypes.BELIEF_ITINERANT_PREACHERS, GameInfoTypes.BELIEF_ITG_ENHANCER_15, GameInfoTypes.BELIEF_ITG_ENHANCER_1, GameInfoTypes.BELIEF_ITG_ENHANCER_2, GameInfoTypes.BELIEF_ITG_ENHANCER_3, GameInfoTypes.BELIEF_ITG_ENHANCER_5, GameInfoTypes.BELIEF_ITG_ENHANCER_8, GameInfoTypes.BELIEF_ITG_ENHANCER_10, GameInfoTypes.BELIEF_ITG_ENHANCER_13}},
[6] = {{GameInfoTypes.BELIEF_ITG_PANTHEON_23, GameInfoTypes.BELIEF_GODDESS_HUNT, GameInfoTypes.BELIEF_FERTILITY_RITES, GameInfoTypes.BELIEF_GOD_CRAFTSMEN, GameInfoTypes.BELIEF_GOD_SEA, GameInfoTypes.BELIEF_OPEN_SKY, GameInfoTypes.BELIEF_ONE_WITH_NATURE, GameInfoTypes.BELIEF_FORMAL_LITURGY, GameInfoTypes.BELIEF_GOD_WAR, GameInfoTypes.BELIEF_GODDESS_LOVE, GameInfoTypes.BELIEF_GOD_FESTIVALS, GameInfoTypes.BELIEF_ANCESTOR_WORSHIP, GameInfoTypes.BELIEF_SACRED_PATH, GameInfoTypes.BELIEF_DANCE_AURORA, GameInfoTypes.BELIEF_EARTH_MOTHER, GameInfoTypes.BELIEF_SUN_GOD, GameInfoTypes.BELIEF_ITG_PANTHEON_4, GameInfoTypes.BELIEF_ITG_PANTHEON_8, GameInfoTypes.BELIEF_ITG_PANTHEON_10, GameInfoTypes.BELIEF_ITG_PANTHEON_14, GameInfoTypes.BELIEF_ITG_PANTHEON_15, GameInfoTypes.BELIEF_ITG_PANTHEON_16, GameInfoTypes.BELIEF_ITG_PANTHEON_19},
{GameInfoTypes.BELIEF_ITG_FOLLOWER_48,GameInfoTypes.BELIEF_ITG_FOLLOWER_47, GameInfoTypes.BELIEF_GURUSHIP, GameInfoTypes.BELIEF_ASCETISM, GameInfoTypes.BELIEF_RELIGIOUS_CENTER, GameInfoTypes.BELIEF_ITG_FOLLOWER_6, GameInfoTypes.BELIEF_ITG_FOLLOWER_8, GameInfoTypes.BELIEF_ITG_FOLLOWER_9, GameInfoTypes.BELIEF_ITG_FOLLOWER_24, GameInfoTypes.BELIEF_ITG_FOLLOWER_25, GameInfoTypes.BELIEF_ITG_FOLLOWER_28, GameInfoTypes.BELIEF_ITG_FOLLOWER_29, GameInfoTypes.BELIEF_ITG_FOLLOWER_30, GameInfoTypes.BELIEF_ITG_FOLLOWER_31, GameInfoTypes.BELIEF_ITG_FOLLOWER_36, GameInfoTypes.BELIEF_ITG_FOLLOWER_37, GameInfoTypes.BELIEF_ITG_FOLLOWER_38, GameInfoTypes.BELIEF_ITG_FOLLOWER_39},
{GameInfoTypes.BELIEF_PEACE_LOVING, GameInfoTypes.BELIEF_CEREMONIAL_BURIAL, GameInfoTypes.BELIEF_TITHE, GameInfoTypes.BELIEF_PILGRIMAGE, GameInfoTypes.BELIEF_ITG_FOUNDER_4, GameInfoTypes.BELIEF_ITG_FOUNDER_5, GameInfoTypes.BELIEF_ITG_FOUNDER_11},
{GameInfoTypes.BELIEF_JUST_WAR, GameInfoTypes.BELIEF_DEFENDER_FAITH, GameInfoTypes.BELIEF_ITG_ENHANCER_15, GameInfoTypes.BELIEF_ITG_ENHANCER_1, GameInfoTypes.BELIEF_ITG_ENHANCER_2, GameInfoTypes.BELIEF_ITG_ENHANCER_3, GameInfoTypes.BELIEF_ITG_ENHANCER_5, GameInfoTypes.BELIEF_ITG_ENHANCER_8, GameInfoTypes.BELIEF_ITG_ENHANCER_11, GameInfoTypes.BELIEF_ITG_ENHANCER_14}},
[7] = {{GameInfoTypes.BELIEF_FERTILITY_RITES, GameInfoTypes.BELIEF_GOD_CRAFTSMEN, GameInfoTypes.BELIEF_GOD_SEA, GameInfoTypes.BELIEF_MESSENGER_GODS, GameInfoTypes.BELIEF_FORMAL_LITURGY, GameInfoTypes.BELIEF_GOD_WAR, GameInfoTypes.BELIEF_SACRED_WATERS, GameInfoTypes.BELIEF_GODDESS_LOVE, GameInfoTypes.BELIEF_GOD_FESTIVALS, GameInfoTypes.BELIEF_ANCESTOR_WORSHIP, GameInfoTypes.BELIEF_TEARS_OF_GODS, GameInfoTypes.BELIEF_GOD_KING, GameInfoTypes.BELIEF_EARTH_MOTHER, GameInfoTypes.BELIEF_SUN_GOD, GameInfoTypes.BELIEF_ITG_PANTHEON_1, GameInfoTypes.BELIEF_ITG_PANTHEON_2, GameInfoTypes.BELIEF_ITG_PANTHEON_9, GameInfoTypes.BELIEF_ITG_PANTHEON_11},
{GameInfoTypes.BELIEF_FEED_WORLD, GameInfoTypes.BELIEF_FEED_WORLD, GameInfoTypes.BELIEF_FEED_WORLD, GameInfoTypes.BELIEF_FEED_WORLD, GameInfoTypes.BELIEF_ITG_FOLLOWER_9, GameInfoTypes.BELIEF_ITG_FOLLOWER_10, GameInfoTypes.BELIEF_ITG_FOLLOWER_11, GameInfoTypes.BELIEF_ITG_FOLLOWER_19, GameInfoTypes.BELIEF_ITG_FOLLOWER_25, GameInfoTypes.BELIEF_ITG_FOLLOWER_26, GameInfoTypes.BELIEF_ITG_FOLLOWER_27, GameInfoTypes.BELIEF_ITG_FOLLOWER_35, GameInfoTypes.BELIEF_ITG_FOLLOWER_40},
{GameInfoTypes.BELIEF_CEREMONIAL_BURIAL, GameInfoTypes.BELIEF_CHURCH_PROPERTY, GameInfoTypes.BELIEF_PILGRIMAGE, GameInfoTypes.BELIEF_ITG_FOUNDER_4, GameInfoTypes.BELIEF_ITG_FOUNDER_5, GameInfoTypes.BELIEF_ITG_FOUNDER_6, GameInfoTypes.BELIEF_ITG_FOUNDER_11, GameInfoTypes.BELIEF_ITG_FOUNDER_19},
{GameInfoTypes.BELIEF_JUST_WAR, GameInfoTypes.BELIEF_DEFENDER_FAITH, GameInfoTypes.BELIEF_ITG_ENHANCER_1, GameInfoTypes.BELIEF_ITG_ENHANCER_2, GameInfoTypes.BELIEF_ITG_ENHANCER_11}},
[8] = {{GameInfoTypes.BELIEF_FERTILITY_RITES, GameInfoTypes.BELIEF_GOD_CRAFTSMEN, GameInfoTypes.BELIEF_GOD_SEA, GameInfoTypes.BELIEF_STONE_CIRCLES, GameInfoTypes.BELIEF_GOD_WAR, GameInfoTypes.BELIEF_SACRED_WATERS, GameInfoTypes.BELIEF_GOD_FESTIVALS, GameInfoTypes.BELIEF_ORAL_TRADITION, GameInfoTypes.BELIEF_GODDESS_STRATEGY, GameInfoTypes.BELIEF_FAITH_HEALERS, GameInfoTypes.BELIEF_TEARS_OF_GODS, GameInfoTypes.BELIEF_ITG_PANTHEON_1, GameInfoTypes.BELIEF_ITG_PANTHEON_2, GameInfoTypes.BELIEF_ITG_PANTHEON_10, GameInfoTypes.BELIEF_ITG_PANTHEON_11, GameInfoTypes.BELIEF_ITG_PANTHEON_14, GameInfoTypes.BELIEF_ITG_PANTHEON_23},
{GameInfoTypes.BELIEF_FEED_WORLD, GameInfoTypes.BELIEF_FEED_WORLD, GameInfoTypes.BELIEF_FEED_WORLD, GameInfoTypes.BELIEF_FEED_WORLD, GameInfoTypes.BELIEF_ITG_FOLLOWER_9, GameInfoTypes.BELIEF_ITG_FOLLOWER_10, GameInfoTypes.BELIEF_ITG_FOLLOWER_11, GameInfoTypes.BELIEF_ITG_FOLLOWER_19, GameInfoTypes.BELIEF_ITG_FOLLOWER_25, GameInfoTypes.BELIEF_ITG_FOLLOWER_26, GameInfoTypes.BELIEF_ITG_FOLLOWER_27, GameInfoTypes.BELIEF_ITG_FOLLOWER_28, GameInfoTypes.BELIEF_ITG_FOLLOWER_32, GameInfoTypes.BELIEF_ITG_FOLLOWER_35, GameInfoTypes.BELIEF_ITG_FOLLOWER_40},
{GameInfoTypes.BELIEF_CEREMONIAL_BURIAL, GameInfoTypes.BELIEF_CHURCH_PROPERTY, GameInfoTypes.BELIEF_PILGRIMAGE, GameInfoTypes.BELIEF_ITG_FOUNDER_4, GameInfoTypes.BELIEF_ITG_FOUNDER_5, GameInfoTypes.BELIEF_ITG_FOUNDER_11, GameInfoTypes.BELIEF_ITG_FOUNDER_19},
{GameInfoTypes.BELIEF_JUST_WAR, GameInfoTypes.BELIEF_DEFENDER_FAITH, GameInfoTypes.BELIEF_ITG_ENHANCER_1, GameInfoTypes.BELIEF_ITG_ENHANCER_2, GameInfoTypes.BELIEF_ITG_ENHANCER_5}},
[9] = {{GameInfoTypes.BELIEF_GODDESS_HUNT, GameInfoTypes.BELIEF_FERTILITY_RITES, GameInfoTypes.BELIEF_OPEN_SKY, GameInfoTypes.BELIEF_STONE_CIRCLES, GameInfoTypes.BELIEF_GOD_WAR, GameInfoTypes.BELIEF_ORAL_TRADITION, GameInfoTypes.BELIEF_DESERT_FOLKLORE, GameInfoTypes.BELIEF_SACRED_PATH, GameInfoTypes.BELIEF_FAITH_HEALERS, GameInfoTypes.BELIEF_DANCE_AURORA, GameInfoTypes.BELIEF_EARTH_MOTHER, GameInfoTypes.BELIEF_SUN_GOD, GameInfoTypes.BELIEF_ITG_PANTHEON_4, GameInfoTypes.BELIEF_ITG_PANTHEON_15, GameInfoTypes.BELIEF_ITG_PANTHEON_23},
{GameInfoTypes.BELIEF_FEED_WORLD, GameInfoTypes.BELIEF_ITG_FOLLOWER_11, GameInfoTypes.BELIEF_ITG_FOLLOWER_25, GameInfoTypes.BELIEF_ITG_FOLLOWER_27, GameInfoTypes.BELIEF_ITG_FOLLOWER_28, GameInfoTypes.BELIEF_ITG_FOLLOWER_37, GameInfoTypes.BELIEF_ITG_FOLLOWER_40},
{GameInfoTypes.BELIEF_CEREMONIAL_BURIAL, GameInfoTypes.BELIEF_CHURCH_PROPERTY, GameInfoTypes.BELIEF_PILGRIMAGE, GameInfoTypes.BELIEF_ITG_FOUNDER_4, GameInfoTypes.BELIEF_ITG_FOUNDER_5, GameInfoTypes.BELIEF_ITG_FOUNDER_11, GameInfoTypes.BELIEF_ITG_FOUNDER_19},
{GameInfoTypes.BELIEF_JUST_WAR, GameInfoTypes.BELIEF_DEFENDER_FAITH, GameInfoTypes.BELIEF_ITG_ENHANCER_1, GameInfoTypes.BELIEF_ITG_ENHANCER_2}},
[10] = {{GameInfoTypes.BELIEF_FERTILITY_RITES, GameInfoTypes.BELIEF_GOD_CRAFTSMEN, GameInfoTypes.BELIEF_OPEN_SKY, GameInfoTypes.BELIEF_SACRED_WATERS, GameInfoTypes.BELIEF_RELIGIOUS_SETTLEMENTS, GameInfoTypes.BELIEF_ITG_PANTHEON_2, GameInfoTypes.BELIEF_ITG_PANTHEON_9, GameInfoTypes.BELIEF_ITG_PANTHEON_18, GameInfoTypes.BELIEF_ITG_PANTHEON_20, GameInfoTypes.BELIEF_ITG_PANTHEON_23},
{GameInfoTypes.BELIEF_FEED_WORLD, GameInfoTypes.BELIEF_GURUSHIP, GameInfoTypes.BELIEF_PEACE_GARDENS, GameInfoTypes.BELIEF_CHORAL_MUSIC, GameInfoTypes.BELIEF_RELIGIOUS_COMMUNITY, GameInfoTypes.BELIEF_ITG_FOLLOWER_1, GameInfoTypes.BELIEF_ITG_FOLLOWER_2, GameInfoTypes.BELIEF_ITG_FOLLOWER_3, GameInfoTypes.BELIEF_ITG_FOLLOWER_4, GameInfoTypes.BELIEF_ITG_FOLLOWER_5, GameInfoTypes.BELIEF_ITG_FOLLOWER_16, GameInfoTypes.BELIEF_DIVINE_INSPIRATION, GameInfoTypes.BELIEF_ITG_FOLLOWER_19, GameInfoTypes.BELIEF_ITG_FOLLOWER_21, GameInfoTypes.BELIEF_ITG_FOLLOWER_20, GameInfoTypes.BELIEF_ITG_FOLLOWER_23, GameInfoTypes.BELIEF_ITG_FOLLOWER_27, GameInfoTypes.BELIEF_ITG_FOLLOWER_29, GameInfoTypes.BELIEF_ITG_FOLLOWER_32, GameInfoTypes.BELIEF_ITG_FOLLOWER_33, GameInfoTypes.BELIEF_ITG_FOLLOWER_35, GameInfoTypes.BELIEF_ITG_FOLLOWER_40, GameInfoTypes.BELIEF_ITG_FOLLOWER_42, GameInfoTypes.BELIEF_ITG_FOLLOWER_47},
{GameInfoTypes.BELIEF_ITG_FOUNDER_RELIGIOUS_DECLINE},
{GameInfoTypes.BELIEF_ITG_ENHANCER_RELIGIOUS_DECLINE}}
}

function IsBeliefUsedByAnyEra(beliefID)
	for a, b in pairs(CultureBeliefsType) do
		for c, d in pairs(b) do
			for e, f in pairs(d) do
				if f == beliefID then
					return true;
				end
			end
		end
	end
	return false;
end

function GetAvBeliefsCultType(cultType, type)
	local tab = {};
	for a, belief in pairs(CultureBeliefsType[cultType][type]) do
		if not gT.Globals.BannedBeliefs[belief] then
			table.insert(tab, belief);
		end
	end
	return tab;
end

function GetBeliefsForReligion(scType, culType, iPlayer)
	local overridepanth;
	local pBel, fBel, found, enchan = GetAvBeliefsCultType(culType, 1), GetAvBeliefsCultType(culType, 2), GetAvBeliefsCultType(culType, 3), GetAvBeliefsCultType(culType, 4)
	fBel = Shuffle(fBel);
	if not gT.Globals.GameGenerated then
		if gT.EraData and gT.PreviousEra then 
			if iPlayer then
				local beliefs = {{}, {}, {}, {}}
				local bAnyRel = false;
				for bhe, stg in pairs(gT.EraData) do
					if stg.Players[iPlayer].ReligionCreated then
						for h, sb in pairs(stg.Players[iPlayer].ReligionCreated) do
							bAnyRel = true;
							for j, s in pairs(sb) do
								local btype = GetBeliefTypeITG(s);
								if btype and beliefs[btype] then
									if not gT.Globals.BannedBeliefs[s] then
										if IsInTable(CultureBeliefsType[culType][btype], s) then
											table.insert(beliefs[btype], s)
										end
									end
								end
							end
						end
					end
				end
				if bAnyRel then
					for i = 1, 4 do
						beliefs[i] = Shuffle(beliefs[i]);
					end
					local fFol, sFol = beliefs[2][1], beliefs[2][2];
					if not sFol then
						if not fFol then
							fFol = fBel[1];
							sFol = fBel[2];
						else
							if fBel[1] == fFol then
								sFol = fBel[1];
							else
								sFol = fBel[2];
							end
						end
					elseif sFol == fFol then
						if fBel[1] == sFol then
							sFol = fBel[1];
						else
							sFol = fBel[2];
						end
					end
					return {beliefs[1][1] or pBel[LastRandom(1,#pBel)], fFol, beliefs[3][1] or found[LastRandom(1,#found)], sFol, beliefs[4][1] or enchan[LastRandom(1,#enchan)]}
				else
					local panths = {}
					for bhe, stg in pairs(gT.EraData) do
						for h, sb in pairs(stg.Players[iPlayer].Pantheons) do
							if not gT.Globals.BannedBeliefs[sb] then
								if IsInTable(CultureBeliefsType[culType][1], sb) then
									table.insert(panths, sb);
								end
							end
						end
					end
					if #panths > 0 then 
						overridepanth = panths[LastRandom(1,#panths)];
					end
				end
			end
		end
	end
	if gT.Globals.ScenarioType == 2 then
		if iPlayer and (not CanEnchanceReligion(iPlayer)) then
			return {overridepanth or pBel[LastRandom(1,#pBel)], fBel[1], found[LastRandom(1,#found)], -1, -1}
		end
	end
	return {overridepanth or pBel[LastRandom(1,#pBel)], fBel[1], found[LastRandom(1,#found)], fBel[2], enchan[LastRandom(1,#enchan)]}
end

function GetBeliefTypeDifferentThan(type, badTab, gType)
	local hTab = {}
	for i, belief in pairs(CultureBeliefsType[gType][type]) do
		if not badTab[belief] then
			if not gT.Globals.BannedBeliefs[belief] then
				table.insert(hTab, belief)
			end
		end
	end
	return hTab[LastRandom(1,#hTab)]
end

function GetHolyCityForPlayer(iPlayer)
	for iCity in Players[iPlayer]:Cities() do
		if iCity:IsHasBuilding(GameInfoTypes.BUILDING_ITG_NEW_WORLD_WONDER_16) then
			return iCity;
		elseif iCity:IsHasBuilding(GameInfoTypes.BUILDING_ITG_NEW_WORLD_WONDER_9) then
			return iCity;
		elseif iCity:IsHasBuilding(GameInfoTypes.BUILDING_ITG_NEW_WORLD_WONDER_4) then
			return iCity;
		end
	end
	return Players[iPlayer]:GetCapitalCity();
end


function GetNicePlayerForSchism(majTab, hMinorTab, hPlot, culType, bPlayer)
	local hTab, cc = {}, 0;
	for it, player in pairs(majTab) do
		if player ~= bPlayer then
			if gT.Players[player].CultureType == culType then
				if Players[player]:GetReligionCreatedByPlayer() == -1 then
					if Players[player]:GetNumCities() > 0 then
						local sPlot = Players[player]:GetStartingPlot()
						local dis = Map.PlotDistance(hPlot:GetX(), hPlot:GetY(), sPlot:GetX(), sPlot:GetY()) 
						table.insert(hTab, {player, dis})
						cc = cc + dis;
					end
				end
			end
		end
	end
	for it, player in pairs(hMinorTab) do
		if gT.Players[player].CultureType == culType then
			if Players[player]:GetReligionCreatedByPlayer() == -1 then
				if Players[player]:GetNumCities() > 0 then
					local sPlot = Players[player]:GetStartingPlot()
					local dis = math.floor(Map.PlotDistance(hPlot:GetX(), hPlot:GetY(), sPlot:GetX(), sPlot:GetY()))
					table.insert(hTab, {player, dis})
					cc = cc + dis;
				end
			end
		end
	end
	local ll = LastRandom(1, cc)
	for it, hdata in pairs(hTab) do
		if ll <= hdata[2] then
			return hdata[1];
		else
			ll = ll - hdata[2];
		end
	end
end

function DetermineChanceForAnyKindOfRelConversion(dis, diameter, rPlot, iPlot, bPlayer)
	local mindis = 16;
	local basechance, step = 100, 4;
	if bPlayer then
		mindis = mindis + 8;
		step = step + 1;
	end
	if dis > mindis then
		local reducement = math.min(8, diameter / 8);
		local hdis = dis;
		while hdis > reducement do
			hdis = hdis - reducement;
			step = step - 1;
			basechance = basechance / 2;
		end
		basechance = basechance - basechance / 2 * (hdis / reducement);
	end
	if GetContID(rPlot, 1236124) == GetContID(iPlot, 1242494) then
		basechance = basechance + 10;
		step = step + 1;
	end
	step = math.max(1, step);
	local hchance = math.min(33, basechance)
	for i = 1, 10 - step do
		if LastRandom(1,100) <= hchance then
			step = step + 1;
		else
			break;
		end
	end
	return basechance, math.min(10,step);
end

local nativeHelpTab = {{100,700}, {300, 1000}, {500, 1500}, {800,1800}, {1000, 2000}, {1200, 2300}, {1400, 2500}, {1500, 2700}, {1800, 3000}, {2000, 3500}}
function MakeNiceNativeConversion(iCity, relType, diameter, iPlayer, rPlayer)
	local rCity = Game.GetHolyCityForReligion(relType, -1);
	if rCity then
		local dis = Map.PlotDistance(rCity:GetX(), rCity:GetY(), iCity:GetX(), iCity:GetY())
		local basechance, step = DetermineChanceForAnyKindOfRelConversion(dis, diameter, rCity:Plot(), iCity:Plot(), iPlayer == rPlayer)
		if LastRandom(1,100) <= basechance then
			local pres = LastRandom(nativeHelpTab[step][1], nativeHelpTab[step][2]);
			iCity:AddReligiousPressure(9, relType, pres* relDLLscale, rPlayer)
		end
	else
		print("Error R122", relType, iPlayer, rPlayer)
	end
end

function UpdatePlayerReligionUnitsCost(g)
	local bonusm = 1;
	if gT.Players[g].HasPlayerWonder[GameInfoTypes.BUILDING_ITG_NEW_WORLD_WONDER_6] then
		bonusm = bonusm + 0.25;
	end
	local iRel = Players[g]:GetReligionCreatedByPlayer();
	if IsReligionHaveBelief(iRel, GameInfoTypes.BELIEF_MISSIONARY_ZEAL) then
		bonusm = bonusm + 0.25;
	end
	gT.Players[g].MissionaryStrength = 1000 * bonusm;
end

function GetNiceAmountOfFaithBoomBoom(iPlayer, numReasons)
	local fPT = GetTotalFaithFromExtraSourcesITG(iPlayer, true, not gT.Globals.GameGenerated)
	local getNextCost = NiceCostOfNextFaithBonus(iPlayer, gT.Players[iPlayer].ReligionRewardTreshold)
	local max = math.floor((getNextCost - 30) / 50);
	if numReasons > 8 then
		return 1;
	elseif numReasons > 3 then
		return math.min(max , 2);
	else
		if fPT >= 50 then
			return math.min(max, 5);
		else
			return LastRandom(1, max)
		end
	end
end

function GetMissionaryGrowthFromBuildings(iPlayer)
	local lGain = 0;
	for iCity in Players[iPlayer]:Cities() do
		lGain = lGain + iCity:GetMissionaryGrowth()
	end
	return lGain;
end

function GetMissionaryGrowthFromHolySites(iPlayer)
	local faith = 0;
	for index, data in pairs(gT.HolySites) do
		if (data.Player == iPlayer) and (not Map.GetPlotByIndex(index):IsImprovementPillaged()) then
			faith = faith + data.BasicBonuses[3];
		end
	end
	return faith;
end

function  GetMissionaryGrowthFromReligion(iPlayer)
	local mg = 0;
	if IsPlayerHaveBelief(iPlayer, GameInfoTypes.BELIEF_ITG_ENHANCER_15) then
		mg = mg + Game.GetNumCitiesFollowing(Players[iPlayer]:GetReligionCreatedByPlayer())
	end
	return mg;
end

function ToolTipMissionaryGrowth(gPlayer)
	local sText = "Upon reaching a treshold you receive a free [ICON_MISSIONARY] Missionary to spread your Religion."
	local tTab = {}
	table.insert(tTab, {GetMissionaryGrowthFromBuildings(gPlayer), "Buildings"})
	table.insert(tTab, {GetMissionaryGrowthFromHolySites(gPlayer), "Holy Sites"})
	table.insert(tTab, {GetMissionaryGrowthFromReligion(gPlayer), "Religion"})
	table.insert(tTab, {CollectCityBonusesEmpireWide(gPlayer, 19), "Governance"})
	for tt, ttd in pairs(tTab) do
		if ttd[1] > 0 then
			sText = sText .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]+" .. ttd[1] .. "[ENDCOLOR][ICON_MISSIONARY] from " .. ttd[2] .. ".";
		elseif ttd[1] < 0 then
			sText = sText .. "[NEWLINE][ICON_BULLET][COLOR_NEGATIVE_TEXT]" .. ttd[1] .. "[ENDCOLOR][ICON_MISSIONARY] from " .. ttd[2] .. ".";
		end
	end
	return sText
end

function GetTotalMissionaryGrowth(iPlayer)
	local base = GetMissionaryGrowthFromBuildings(iPlayer) + GetMissionaryGrowthFromHolySites(iPlayer) + GetMissionaryGrowthFromReligion(iPlayer) + CollectCityBonusesEmpireWide(iPlayer, 19)
	return base;
end

function GetMissionaryGrowthTreshold(iPlayer)
	return 100;
end

function IsReligiousBonusChosenRandomly(iPlayer)
	if GetGovernorWithExtraCredentials(iPlayer, "HighPriest") then
		return true;
	end
	return false;
end

function UpdatePlayerFaithDoTurn(iPlayer)
	if DBScenario.NoFaithGeneration then
		Players[iPlayer]:SetFaith(0);
		return;
	end
	local faithFromHolySites = GetTotalFaithFromExtraSourcesITG(iPlayer)
	DoTurnBeliefBonuses(iPlayer)
	ChangeITGFaith(iPlayer, faithFromHolySites)
	local theFaith = Players[iPlayer]:GetFaith();
	local isAI = not Players[iPlayer]:IsHuman();
	if not gT.Players[iPlayer].SecularState then
		local iRel = Players[iPlayer]:GetReligionCreatedByPlayer()
		if iRel > 0 then
			gT.Players[iPlayer].MissionaryGrowth = GetTotalMissionaryGrowth(iPlayer) + gT.Players[iPlayer].MissionaryGrowth;
			local misTreshold = GetMissionaryGrowthTreshold(iPlayer);
			if gT.Players[iPlayer].MissionaryGrowth >= misTreshold then
				local extraMis = math.floor(gT.Players[iPlayer].MissionaryGrowth / misTreshold)
				gT.Players[iPlayer].MissionaryGrowth = gT.Players[iPlayer].MissionaryGrowth - misTreshold * extraMis;
				gT.Players[iPlayer].FreeMissioniares =  gT.Players[iPlayer].FreeMissioniares + extraMis;
			end
		end
		local getNextCost = NiceCostOfNextFaithBonus(iPlayer, gT.Players[iPlayer].ReligionRewardTreshold)
		if theFaith >= getNextCost then
			--religious bonus
			if IsReligionHaveBelief(iRel, GameInfoTypes.BELIEF_ITG_ENHANCER_4) then
				 gT.Players[iPlayer].FreeMissioniares =  gT.Players[iPlayer].FreeMissioniares + 2;
			end

			SpendITGFaith(iPlayer, getNextCost);
			DoYieldBonuses(iPlayer, "Faith", getNextCost)
			if gT.Players[iPlayer].ReligionRewardTreshold >= 10 then
				gT.Players[iPlayer].ReligionRewardTreshold =  gT.Players[iPlayer].ReligionRewardTreshold + 2;
			else
				gT.Players[iPlayer].ReligionRewardTreshold =  gT.Players[iPlayer].ReligionRewardTreshold + 1;
			end
			gT.Players[iPlayer].CurrentReligionTreshold = getNextCost;
			if gT.Players[iPlayer].HasPlayerWonder[GameInfoTypes.BUILDING_ITG_NEW_WORLD_WONDER_21] then
				TakeCareOfEventMorale(iPlayer, 25, {5, "El Tajin"})
				ChangeITGFestivalPoints(iPlayer, 1)
			end
			AddGraphData(iPlayer, 3, 1, false)
			if IsReligiousBonusChosenRandomly(iPlayer) then
				local tabOptions = PrepareExtraDataForHumanFaithBonus(iPlayer).UniqueOptions;
				if #tabOptions == 0 then
					print("Impossiblue 532432", iPlayer)
				else
					local lTab = tabOptions[GetProperRandomYieldBonus(tabOptions)];
					local baseRngData = HumanPlayerChooseFaithBonus(iPlayer, lTab.ID, lTab.ExtraInfo, true)
					if Players[iPlayer]:IsHuman() then
						local govIDHighPriest = GetGovernorWithExtraCredentials(iPlayer, "HighPriest")
						local notstr = "High Priest [ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govIDHighPriest].Name) .. " has chosen '" .. lTab.Name .. "' as a reward from religious bonus.";
						Players[iPlayer]:AddNotification(81468343,notstr,"High Priest",-1,-1, govIDHighPriest)
						baseRngData.Title = lTab.Name;
						baseRngData.Type = 3;
						baseRngData.GovID = govIDHighPriest;
						if not gT.Players[iPlayer].RandomRewardPopup then
							gT.Players[iPlayer].RandomRewardPopup = {};
						end
						table.insert(gT.Players[iPlayer].RandomRewardPopup, baseRngData);
					end
				end
			else
				if Players[iPlayer]:IsHuman() then
					gT.Players[iPlayer].HumanQueueActions["CHOOSE RELIGIOUS BONUS"] = PrepareExtraDataForHumanFaithBonus(iPlayer);
				else
					AIPlayerChooseReligiousBonus(iPlayer)
					gT.Players[iPlayer].PilgrimVisitors = {};
				end
			end
		end
	end
	if isAI then
		if gT.Players[iPlayer].FreeMissioniares > 0 then
			if Players[iPlayer]:GetReligionCreatedByPlayer() > 0 then
				DoAIConsiderSendingMissionary(iPlayer, true)
			else
				print("Just wonderful ^23434/325324", iPlayer) -- 
			end
		end
		if gT.Players[iPlayer].HolySitePoints > 0 then
			DoAIConsiderPlacingHolySite(iPlayer)
		end
	end
end

function CanPlayerUseMissionares(iPlayer)
	return (Players[iPlayer]:GetReligionCreatedByPlayer() > 0) and gT.Players[iPlayer].CanUseMissionaries
end

function EqualizedBonusCost(iPlayer)
	local total = NiceCostOfNextFaithBonus(iPlayer, gT.Players[iPlayer].ReligionRewardTreshold, true) + NiceCostOfTechOrPolicy(iPlayer, GetDBCulturePlayerInfo(iPlayer, "BaseCultureCost"), gT.Players[iPlayer].CultureBonusAdopted, 2, true) + NiceCostOfTechOrPolicy(iPlayer, GetDBCulturePlayerInfo(iPlayer, "BaseTechCost"), gT.Players[iPlayer].ScienceBonusAdopted, 1, true)
	return math.floor(total/15) * 5;
end

function GetReligiousTresholdModFromWonder(iPlayer)
	local relMod = 0;
	if gT.Players[iPlayer].HasPlayerWonder[hwang1] then
		relMod = relMod - 0.1;
	end
	return relMod;
end
function GetReligiousTresholdModFromSubculture(iPlayer)
	local relMod = 0;
	if gT.Players[iPlayer].SubcultureType == 10 then
		relMod = relMod - 0.15;
	end
	return relMod;
end
function GetReligiousTresholdModFromGovernors(iPlayer)
	local relMod = 0;
	for govID, bool in pairs(gT.Players[iPlayer].Governors) do
		if gT.Globals.Governors[govID].RelBonusDiscount then
			relMod = relMod - gT.Globals.Governors[govID].RelBonusDiscount;
		end
	end	
	return relMod;
end
function GetReligiousTresholdModFromSocials(iPlayer) -- ToolTIP ONLY
	local relMod = 0;
	if gT.Players[iPlayer].CultBonusOn[77] then
		relMod = relMod - 0.05;
	end
	if gT.Players[iPlayer].CultBonusOn[82] then
		relMod = relMod - 0.15;
	end
	return relMod;
end
function GetReligiousTresholdModFromOccupiedCities(iPlayer)
	local relMod = 0;
	for iCity in Players[iPlayer]:Cities() do
		if iCity:GetOriginalOwner() ~= iPlayer then
			relMod = relMod + 0.01;
		end
	end
	return relMod;
end
function GetReligiousTresholdModFromHarmonizedBeliefs(iPlayer)
	local relMod = 0;
	if gT.Players[iPlayer].HarmonyPantheon then
		relMod = relMod - gT.Players[iPlayer].HarmonyPantheon / 100;
	end
	return relMod;
end
function GetReligiousTresholdModFromLaws(iPlayer) -- tooltip only
	local relMod = 0;
	if not IsHasLaw(iPlayer, 15, 0) then
		if IsHasLaw(iPlayer, 15, 2) then
			relMod = relMod - 0.1;
		else
			relMod = relMod + 0.03;
		end
	end
	return relMod;
end
function GetReligiousTresholdModFromBeliefs(iPlayer) -- tooltip only
	local relMod = 0;
	if IsPlayerHaveBelief(iPlayer, GameInfoTypes.BELIEF_ITG_ENHANCER_4) then
		relMod = relMod - 0.15;
	end
	return relMod;
end
function GetReligiousTresholdModFromIdeologies(iPlayer)
	local mod = 0;
	if gT.Players[iPlayer].HasIdeology[81] then
		mod = mod - 0.04;
	end
	return mod;
end

function NiceCostOfNextFaithBonus(iPlayer, treshold, bIgnoreEqual)
	if HasPlayerTech(iPlayer, techinnoasia6, "6234dde") then
		if not bIgnoreEqual then
			return EqualizedBonusCost(iPlayer)
		end
	end
	local numcitiescost = 0;
	local relMod = gT.Players[iPlayer].RelBonusMod;
	relMod = relMod + GetReligiousTresholdModFromWonder(iPlayer);
	relMod = relMod + GetReligiousTresholdModFromSubculture(iPlayer);
	relMod = relMod + GetReligiousTresholdModFromGovernors(iPlayer);
	relMod = relMod + GetReligiousTresholdModFromIdeologies(iPlayer);
	relMod = relMod + GetReligiousTresholdModFromOccupiedCities(iPlayer);
	relMod = relMod + GetReligiousTresholdModFromHarmonizedBeliefs(iPlayer);
	
	local cr = treshold * 100;
	if gT.Globals.PantheonCost then
		if Players[iPlayer]:GetReligionCreatedByPlayer() < 1 then
			cr = gT.Globals.PantheonCost
			if Players[iPlayer]:GetNumCities() > 1 then
				numcitiescost = (Players[iPlayer]:GetNumCities() - 1) * 5;
			end
			if gT.Players[iPlayer].CultureType == 7 then
				cr = cr * 2;
			end
		end
	end
	local basecost = cr * (relMod) + 0.5 + numcitiescost;
	basecost = math.floor(basecost/5) * 5;
	if HasPlayerNatureWonder(iPlayer, GameInfoTypes.FEATURE_ULURU) then
		basecost = math.max(basecost - 50, 10)
	end
	return basecost;
end

function AIPlayerChooseReligiousBonus(iPlayer)
	--EnchanceReligion
	--WonderRace
	--WonderPush
	--CreateHolySite
	--Great Work/Legal Points
	local iRel = Players[iPlayer]:GetReligionCreatedByPlayer();
	if iRel < 1 then
		if CanFoundReligionRightNow(iPlayer) then
			HumanPlayerChooseFaithBonus(iPlayer, 9, nil, false, true)
			return;
		end
	end
	if CanEnchanceReligion(iPlayer) then
		HumanPlayerChooseFaithBonus(iPlayer, 1, nil, false, true)
		return
	elseif HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_EUROPE_1, "^1234124") then
		if (iRel > 0) and (not gT.Players[iPlayer].ReligiousDecline) then
			if GetITGGameTurn() > 75 then
				HumanPlayerChooseFaithBonus(iPlayer, 8, nil, false, true)
				return; 
			end
		end
	end
	if ShouldAIDoGoldenAge(iPlayer, 4, "Religion") then
		HumanPlayerChooseFaithBonus(iPlayer, 7, nil, false, true)
		return;
	end
	if CanFoundPantheonRightNow(iPlayer) then
		if IsItGoodIdeaForAIToMakeNewPantheon(iPlayer) then
			HumanPlayerChooseFaithBonus(iPlayer, 16, nil, false, true)
			return false;
		end
	end
	if ShouldAISpendBonusOnWonderRaceBoost(iPlayer) then
		HumanPlayerChooseFaithBonus(iPlayer, 2, nil, false, true)
		return;
	end
	local bHolySiteSeemsOk = false;
	if iRel > 0 then
		if gT.Players[iPlayer].HasPlayerWonder[luxortemple1] then
			if IsValidForLuxorBonus(iPlayer) then
				DoAddPantheonBeliefLuxor(iPlayer);
				return;
			end
		end		
		if CanDoReformation(iPlayer) then	
			local eBelief, value = GetBestBeliefToReformForAI(iPlayer);
			if value >= 30 then
				DoStartReformation(iPlayer, eBelief)
				return
			end
		end
		if gT.Players[iPlayer].CanUseMissionaries then
			if gT.Players[iPlayer].FreeMissioniares < 3 then
				if GetMissionariesFromReligiousBonus(iPlayer) > 10 then
					DoAcquireMissionariesFromRelBonus(iPlayer) 
					-- 10 missionares is 10000, which means holy site has to generate about 100 per turn, be in range of 16 cities... rework Holy Sites!
					return;
				end
			end
		end
		if not gT.Players[iPlayer].NoMoreHolySites then
			if GetDBCulturePlayerInfo(iPlayer, "CanNewHolySite") then
				if gT.Players[iPlayer].HolySitePoints < 1 then
					if not gT.Players[iPlayer].AIIgnoreHolySiteAcq then
						if GetITGGameTurn() < LastRandom(55, 65) then
							local iplot, ival = GetBestPlotForHolySiteForAI(iPlayer);
							if ival > 30 then
								gT.Players[iPlayer].HolySitePoints = gT.Players[iPlayer].HolySitePoints + 1;
								return
							elseif ival < 25 then
								if GetITGGameTurn() >= LastRandom(20, 30) then
									gT.Players[iPlayer].AIIgnoreHolySiteAcq = true;
								end
							end
						elseif gT.Globals.ScenarioType == 3 and (GetITGGameTurn() < 92) then
							bHolySiteSeemsOk = true;
						end
					end
				end
			end
		end
	end
	if gT.Players[iPlayer].HasPlayerWonder[templeofLiterature] then
		local pTab = GetValidTableOfTechs(iPlayer);
		if #pTab > 0 then
			PlayerWantsToAdoptNewTech(iPlayer, nil, true)
			return;			
		end
	end
	if HasPlayerTech(iPlayer, techinnomeso8, "&3f3434") then
		--one day may be here logic for admirals
		HumanPlayerChooseFaithBonus(iPlayer, 10, nil, false, true)
		return;
	end
	if gT.WondersConstructed[wonderFortAllowing] == iPlayer then
--		if GetDBCulturePlayerInfo(iPlayer, "CanControlForts") then
			HumanPlayerChooseFaithBonus(iPlayer, 15, nil, false, true)
			return;
--		end
	end
	local unlocktab = GetUnitClassesToUnlock(iPlayer, gT.Players[iPlayer].PilgrimVisitors);
	if (#unlocktab > 0) then
		local buildingTab = GetBuildingClassesToUnlock(iPlayer, gT.Players[iPlayer].PilgrimVisitors);
		if (#buildingTab > 0) then
			DoUnlockUnitClass(iPlayer, unlocktab[LastRandom(1,#unlocktab)], "Religious")
			DoUnlockBuildingClass(iPlayer, buildingTab[LastRandom(1,#buildingTab)], "Religious")
			return;
		end
	end
	for l, h in pairs(gT.Leagues) do
		if h.Resolutions[67] and h.Members[iPlayer] then
			if h.ExtraInfo == 1 then
				if Players[iPlayer]:GetNumCities() > 0 then
					if CanHaveMercenaryFromGoodyHut(iPlayer) then
						HumanPlayerChooseFaithBonus(iPlayer, 22, nil, false, true)
						return;
					end
				end
			elseif h.ExtraInfo == 2 then
				if GetCityToLegalizeOwnership(iPlayer, true) then
					HumanPlayerChooseFaithBonus(iPlayer, 23, nil, false, true)
					return;
				end
			elseif h.ExtraInfo == 3 then
				if gT.Players[iPlayer].Morale < 0 then
					HumanPlayerChooseFaithBonus(iPlayer, 24, nil, false, true)
					return;
				end
			end
			break;
		end
	end
	local gpFromRel = GetGPFromReligiousBonus(iPlayer);
	if gpFromRel > 0 then
		HumanPlayerChooseFaithBonus(iPlayer, 14, nil, false, true)
		return;
	end
	if gT.Players[iPlayer].GovRewards[51] then
		HumanPlayerChooseFaithBonus(iPlayer, 19, nil, false, true)
		return;
	end
	if gT.Players[iPlayer].GovRewards[53] then
		HumanPlayerChooseFaithBonus(iPlayer, 20, nil, false, true)
		return;
	end
	if gT.Players[iPlayer].GovRewards[54] then
		HumanPlayerChooseFaithBonus(iPlayer, 17, nil, false, true)
		return;
	end
	local legalFromRel = GetPlayerFaithLegalCost(iPlayer);
	if (legalFromRel > 0) then
		if ShouldAIuseRelBonusForLegal(iPlayer, legalFromRel) then
			ChangeITGLegalPointsPercent(iPlayer, legalFromRel, true, "RelBonusShouldNotBeConvertable!")
			return;
		end
	end
	if bHolySiteSeemsOk then
		HumanPlayerChooseFaithBonus(iPlayer, 5, nil, false, true)
		return;
	end
	HumanPlayerChooseFaithBonus(iPlayer, 3, nil, false, true)
end

function GetEnhancerBelief(iRel)
	for i,v in pairs(Game.GetBeliefsInReligion(iRel)) do
		if v ~= -1 then
			if GameInfo.Beliefs[v].Enhancer then
				return v;
			end
		end
	end
	return nil;
end

function IsEnchancedReligion(iRel)
	if iRel > 0 then
		for i,v in pairs(Game.GetBeliefsInReligion(iRel)) do
			if v ~= -1 then
				if GameInfo.Beliefs[v].Enhancer then
					return true;
				end
			end
		end
	end
	return false;
end

function CanEnchanceReligion(iPlayer)
	if gT.Globals.ScenarioType == 3 then
		return false;
	end
	local iRel = Players[iPlayer]:GetReligionCreatedByPlayer();
	if iRel > 0 then
		if HasPlayerTech(iPlayer, GameInfoTypes.TECH_THEOLOGY, "^@#$c21$@#%") then
			for i,v in pairs(Game.GetBeliefsInReligion(iRel)) do
				if v ~= -1 then
					if GameInfo.Beliefs[v].Enhancer then
						return false;
					end
				end
			end
			return true;
		end
	end
	return false;
end

function GetBonusesFromReligiousDecline(iPlayer)
	local iRel = Players[iPlayer]:GetReligionCreatedByPlayer(iPlayer)
	local legal, gold, culture, gp, hap = 1, 300, 200, 250, 2;
	local numfollowers = Game.GetNumFollowers(iRel)
	local numcities = Game.GetNumCitiesFollowing(iRel)
	legal = legal + numfollowers / 100 + numcities / 4;
	gold = gold + numfollowers * 2 + numcities * 4;
	culture = culture + numfollowers + numcities * 2;
	gp = gp + numfollowers * 3;
	hap = math.floor(hap + numfollowers / 50 + numcities / 6)
	return legal, gold, culture, gp, hap;
end

function DoReligiousDecline(iPlayer)
	local iRel = Players[iPlayer]:GetReligionCreatedByPlayer(iPlayer)
	gT.Players[iPlayer].ReligiousDecline = true;
	local legal, gold, culture, gp, hap = GetBonusesFromReligiousDecline(iPlayer);
	local rBeliefs = {}
	local cBeliefs = Game.GetBeliefsInReligion(iRel);
	Game.ResetBeliefsInReligion(iPlayer, iRel)
	for it, belief in pairs(cBeliefs) do
		if GameInfo.Beliefs[belief].Enhancer or GameInfo.Beliefs[belief].Founder then
			table.insert(rBeliefs, belief)
		else
			Game.AddBeliefToReligion(iPlayer, iRel, belief)
		end
	end
	Game.AddBeliefToReligion(iPlayer, iRel, GameInfoTypes.BELIEF_ITG_FOUNDER_RELIGIOUS_DECLINE)
	Game.AddBeliefToReligion(iPlayer, iRel, GameInfoTypes.BELIEF_ITG_ENHANCER_RELIGIOUS_DECLINE)
	for i, eBelief in pairs(rBeliefs) do
		ITGBeliefRemoved(iPlayer, iRel, eBelief)
	end
	ITGBeliefAdded(iPlayer, iRel, GameInfoTypes.BELIEF_ITG_FOUNDER_RELIGIOUS_DECLINE)
	ITGBeliefAdded(iPlayer, iRel, GameInfoTypes.BELIEF_ITG_ENHANCER_RELIGIOUS_DECLINE)
end

function CanDoReformation(iPlayer)
	if gT.Players[iPlayer].ScenarioType == 2 then
		if Players[iPlayer]:GetReligionCreatedByPlayer() == GameInfoTypes.RELIGION_CHRISTIANITY then
			return false;
		end
	end
	if gT.Players[iPlayer].SecularState then
		return false;
	end
	return gT.Players[iPlayer].CanDoReformation;
end

function PrepareExtraDataForHumanFaithBonus(iPlayer)
	local data = {BonusType = "BonusFaith", TitleText = "Choose your bonus wisely.", TitleIconIndex = 16, TitleIconAtlas = "EXPANSION_UNIT_ATLAS_1", Tooltip = "You have accumulated enough faith for extra bonus."}
	local hTab = {}

	local iRel = Players[iPlayer]:GetReligionCreatedByPlayer();
	if iRel > 0 then
		if CanEnchanceReligion(iPlayer) then
			table.insert(hTab, {Name = "Enhance Religion",
							ID = 1,
							PortraitIndex = 16,
							IconAtlas = "EXPANSION_UNIT_ATLAS_1",
							Help = "[NEWLINE]Your religion will acquire two new randomly chosen beliefs, follower and enhancer ones."})
		elseif HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_EUROPE_1, "&dwerwe412") then
			if not gT.Players[iPlayer].ReligiousDecline then
				if gT.Players[iPlayer].Goverment ~= 4 then
					local lb, rdgb, rdcb, rdgpb, rdhp = GetBonusesFromReligiousDecline(iPlayer)
					table.insert(hTab, {Name = "Religious Decline",
								ID = 8,
								PortraitIndex = 16,
								IconAtlas = "EXPANSION_UNIT_ATLAS_1",
								Help = "[NEWLINE]Your religion's enhancer and founder bonus will be removed. Allows adopting Secular State through legal action, grants " .. lb .. " [ICON_ITG_LEGAL_POWER], " .. rdgb .. " [ICON_GOLD] Gold, " .. rdcb .. " [ICON_CULTURE] Culture, " .. rdgpb .. " [ICON_GREAT_PEOPLE] Great People points and " .. rdhp .. "[ICON_HAPPINESS_1] Happiness empire-wide."})
				end
			end
		end
		if gT.Players[iPlayer].CanUseMissionaries then
			table.insert(hTab, {Name = "Mission",
								ID = 18,
								PortraitIndex = 20,
								IconAtlas = "EXPANSION_UNIT_ATLAS_1",
								Help = "[NEWLINE]Acquire [COLOR_POSITIVE_TEXT]" .. GetMissionariesFromReligiousBonus(iPlayer) .. "[ENDCOLOR] Missionaries."})
		end
		if CanDoReformation(iPlayer) then
			local btt = Game.GetBeliefsInReligion(iRel);
			if #btt > 3 then
				local bTab = {}
				for i, belief in pairs(btt) do
					if GetNewBeliefForReformation(belief, iPlayer, btt, 0) then
						if not IsHumanInMiddleOfReformingBelief(iPlayer, belief) then
							table.insert(bTab, belief)
						end
					end
				end
				if #bTab > 0 then
					table.insert(hTab, {Name = "Reform a Belief",
								ID = 4,						
								PortraitIndex = 16,
								IconAtlas = "EXPANSION_UNIT_ATLAS_1",
								Help = "[NEWLINE]Replace a chosen belief with prefered new one (up to " .. GetNumReformBeliefOption(iPlayer) .. " options will be available).",
								ExtraInfo = bTab,
								DoubleChooseType = "Reformation"})
				end
			end
		end
		if GetDBCulturePlayerInfo(iPlayer, "CanNewHolySite") then
			if not gT.Players[iPlayer].NoMoreHolySites then
				local str = "[NEWLINE]Allows you create one new Holy Site that will spread your religion within certain range (base distance is 10) and yield extra [ICON_PEACE] Faith."
				table.insert(hTab, {Name = "New Holy Site",
								ID = 5,						
								PortraitIndex = 1,
								IconAtlas = "EXPANSION_TERRAIN_ATLAS",
								Help = str})
			end
		end
	elseif CanFoundReligionRightNow(iPlayer) then
		if Players[iPlayer]:GetNumCities() > 0 then
			table.insert(hTab, {Name = "Found Religion",
							ID = 9,
							PortraitIndex = 16,
							IconAtlas = "EXPANSION_UNIT_ATLAS_1",
							Help = "[NEWLINE]You will found new Religion with randomly chosen 3 beliefs."})
		end
	elseif CanFoundPantheonRightNow(iPlayer) then
		local hstring = "[NEWLINE]Your citizens will start following new Pantheon belief."
		local numoptions = GetNumPantheonsAvailableToChooseFrom(iPlayer)
		if numoptions > 1 then
			hstring = "[NEWLINE]Choose a new Pantheon belief from " .. numoptions .. " randomly selected ones.";
		end
		table.insert(hTab, {Name = "Found Pantheon",
							ID = 16,
							PortraitIndex = 16,
							IconAtlas = "EXPANSION_UNIT_ATLAS_1",
							Help = hstring})
	end
	if CanDoWonderRaceRightNow(iPlayer, "Faith") or CanDoWonderBoost(iPlayer, "Faith") then
		local sText = Locale.Lookup("TXT_KEY_ITG_NEW_WONDER_RACE_START")
		if gT.Players[iPlayer].CanWonderRace then
			sText = Locale.ConvertTextKey("TXT_KEY_ITG_NEW_WONDER_RACE_BOOST", GetRewardWonderPushProd());
		end
		table.insert(hTab, {Name = "Wonder",
							ID = 2,
							PortraitIndex = 0,
							IconAtlas = "INTL_PROJECT_ATLAS_EXP2",
							Help = sText})
	end

	local numGreatWorks = 3 + GetExtraGreatWorksFromCulturalFaithBonuses(iPlayer, "Faith");
	table.insert(hTab, {Name = "Great Work",
					ID = 3,						
					PortraitIndex = 6,
					IconAtlas = "EXPANSION2_UNIT_ATLAS",
					Help = "[NEWLINE]Create " .. numGreatWorks .. " [ICON_GREAT_WORK] Great Works. Increases [ICON_ITG_MERITOCRACY] Meritocracy by 1.",
					ExtraInfo = numGreatWorks})
	local fConv = GetPlayerFaithLegalCost(iPlayer);
	if fConv > 0 then
		table.insert(hTab, {Name = "Mandate of Heaven",
					ID = 6,						
					PortraitIndex = 63,
					IconAtlas = "BW_ATLAS_1",
					Help = "[NEWLINE]Legitimate your rule by boosting your [ICON_ITG_LEGAL_POWER] Legal Power by " .. fConv / 100 .. ".",
					ExtraInfo = fConv})
	end
	if (not gT.Players[iPlayer].HadGoldenAge) then
		local pointsGA = GetGoldenAgePointsFromType(iPlayer, 4);
		table.insert(hTab, {Name = "Golden Age",
				ID = 7,						
				PortraitIndex = 40,
				IconAtlas = "POLICY_ATLAS",
				Help = Locale.ConvertTextKey("TXT_KEY_ITG_NEW_GOLDEN_AGE_POINTS", pointsGA, pointsGA * MERITOCRACY_PER_GOLDEN_AGE_POINT)})
	elseif Players[iPlayer]:IsGoldenAge() then
		if not gT.Players[iPlayer].CanGABeProlonged["Religion"] then
			table.insert(hTab, {Name = "Prolong Golden Age",
					ID = 7,						
					PortraitIndex = 40,
					IconAtlas = "POLICY_ATLAS",
					Help = "[NEWLINE]Increases duration of current [ICON_GOLDEN_AGE] Golden Age by " .. GetNumTurnsPrelongGoldenAge(iPlayer) .. " turns."})
		end
	end
	if HasPlayerTech(iPlayer, techinnomeso8, "&54235wedwe") then
		table.insert(hTab, {Name = "Great General",
			ID = 10,
			PortraitIndex = 48,
			IconAtlas = "UNIT_ATLAS_2",
			Help = "[NEWLINE]Allows you to assign the Great General promotion to one of your land military units, which increases combat bonus of nearby units."})
		table.insert(hTab, {Name = "Great Admiral",
			ID = 11,
			PortraitIndex = 15,
			IconAtlas = "EXPANSION_UNIT_ATLAS_1",
			Help = "[NEWLINE]Allows you to assign the Great Admiral promotion to one of your naval military units, which increases combat bonus of nearby units."})
	end
	if gT.Players[iPlayer].HasPlayerWonder[templeofLiterature] then
		local pTab = GetValidTableOfTechs(iPlayer);
		if #pTab > 0 then
			table.insert(hTab, {Name = "Technology",
								ID = 12,
								PortraitIndex = 7,
								IconAtlas = "CITIZEN_ATLAS",
								Help = GetTechnologyBonusString(iPlayer, pTab)})
		end
	end
	if gT.Players[iPlayer].HasPlayerWonder[luxortemple1] then
		if IsValidForLuxorBonus(iPlayer) then
			table.insert(hTab, {Name = "New Pantheon",
								ID = 13,
								PortraitIndex = 16,
								IconAtlas = "EXPANSION_UNIT_ATLAS_1",
								Help = "[NEWLINE]Adds new Pantheon belief to your religion."})
		end
	end
	local gGPfromRelBonus = GetGPFromReligiousBonus(iPlayer)
	if gGPfromRelBonus > 0 then
		table.insert(hTab, {Name = "Ascendancy",
							ID = 14,
							PortraitIndex = 16,
							IconAtlas = "EXPANSION_UNIT_ATLAS_1",
							Help = "[NEWLINE]Adds +" .. gGPfromRelBonus .. " [ICON_GREAT_PEOPLE] Great People points."})
	end
	if gT.WondersConstructed[wonderFortAllowing] == iPlayer then
--		if GetDBCulturePlayerInfo(iPlayer, "CanControlForts") then
			table.insert(hTab, {Name = "Defender of Faith",
								ID = 15,
								PortraitIndex = 0,
								IconAtlas = "UNIT_ITG_2_ATLAS",
								Help = "[NEWLINE]Allows you to create new Fort or upgrade the existing one into a more powerful Citadel."})
--		end
	end
	if gT.Players[iPlayer].GovRewards[51] then
		table.insert(hTab, {Name = "God with Us",
							ID = 19,
							PortraitIndex = 21,
							IconAtlas = "POLICY_ATLAS",
							Help = "[NEWLINE]Allows you to choose one Promotion for any military class for Free (without increasing the cost of future ones, though it doesn't increase the total number of promotions available).[NEWLINE]Unitclass can only obtain one free promotion that way."})
	end
	if gT.Players[iPlayer].GovRewards[53] then
		table.insert(hTab, {Name = "Tithe",
							ID = 20,
							PortraitIndex = 45,
							IconAtlas = "POLICY_ATLAS",
							Help = "[NEWLINE]Gain " .. gT.Players[iPlayer].CurrentReligionTreshold .. " [ICON_GOLD] Gold."})
	
	end
	if gT.Players[iPlayer].GovRewards[54] then
		table.insert(hTab, {Name = "Divine Blessing",
							ID = 17,
							PortraitIndex = 43,
							IconAtlas = "POLICY_ATLAS",
							Help = "[NEWLINE]" .. math.ceil(gT.Players[iPlayer].CurrentReligionTreshold / 75) .. " [ICON_HAPPINESS_1] Happiness will be distributed among your Cities (one City cannot gain more than 4 [ICON_HAPPINESS_1] Happiness)."})
	end
	local unlocktab = GetUnitClassesToUnlock(iPlayer, gT.Players[iPlayer].PilgrimVisitors);
	local buildingTab = GetBuildingClassesToUnlock(iPlayer, gT.Players[iPlayer].PilgrimVisitors);
	if #unlocktab + #buildingTab > 0 then
		local hstr = ""
		if #unlocktab > 0 then
			hstr = hstr .. "[NEWLINE]Unlock training new Unit (randomly):"
			for a, class in pairs(unlocktab) do
				local iUnitType = Players[iPlayer]:GetPlayerUniqueUnit(class);
				hstr = hstr .. "[NEWLINE][ICON_BULLET]" .. Locale.Lookup(GameInfo.Units[iUnitType].Description);
			end
			hstr = hstr .. "[NEWLINE]Once you discover technology that normally unlocks this Unit you will be awarded with +100XP for this unit class.";
		end
		if #buildingTab > 0 then
			hstr = hstr .. "[NEWLINE]Unlock constructing new Building (randomly):"
			for a, class in pairs(buildingTab) do
				local iBuilding = Players[iPlayer]:GetPlayerUniqueBuilding(class);
				hstr = hstr .. "[NEWLINE][ICON_BULLET]" .. Locale.Lookup(GameInfo.Buildings[iBuilding].Description);
			end
			hstr = hstr .. "[NEWLINE]Once you discover technology that normally unlocks this Building your [ICON_PROPHET] Heresy from local theology will be decreased by 3%."
		end
		if (#buildingTab == 0) or (#unlocktab == 0) then
			hstr = hstr .. "[NEWLINE][NEWLINE]This action will also reduce [ICON_PROPHET] Heresy from local theology by 3%."
		end
		hstr = hstr .. "[NEWLINE][NEWLINE]This action is available only if you were visited by a [ICON_ITG_PILGRIM] Pilgrim from more advanced civilization since the last acquisition of religious bonus."
		table.insert(hTab, {Name = "Pilgrims' Knowledge",
							ID = 21,
							PortraitIndex = 20,
							IconAtlas = "EXPANSION_UNIT_ATLAS_1",
							Help = hstr})
	end
	for l, h in pairs(gT.Leagues) do
		if h.Resolutions[67] and h.Members[iPlayer] then
			if h.ExtraInfo == 1 then
				if Players[iPlayer]:GetNumCities() > 0 then
					if CanHaveMercenaryFromGoodyHut(iPlayer) then
						table.insert(hTab, {Name = "Deus vult: Crusaders",
								ID = 22,
								PortraitIndex = 27,
								IconAtlas = "TECH_ATLAS_1",
								Help = GetNumFamousMercFromDeusVult(iPlayer) .. " [ICON_ITG_MERCENARY] famous Mercenaries will spawn near Capital."})
					end
				end
			elseif h.ExtraInfo == 2 then
				if GetCityToLegalizeOwnership(iPlayer, true) then
					table.insert(hTab, {Name = "Deus vult: Claim city",
								ID = 23,
								PortraitIndex = 27,
								IconAtlas = "TECH_ATLAS_1",
								Help = "Legalize ownership of one conquered city."})
				end
			elseif h.ExtraInfo == 3 then
				table.insert(hTab, {Name = "Deus vult: Morale",
							ID = 24,
							PortraitIndex = 27,
							IconAtlas = "TECH_ATLAS_1",
							Help = "+" .. GetMoraleBoostFromDeusVult(iPlayer) .. " [ICON_ITG_MORALE] Morale."})
			end
			break;
		end
	end
	data.UniqueOptions = hTab;
	return data;
end

function GetNumFamousMercFromDeusVult(iPlayer)
	return math.min(4, 1 + math.ceil(gT.Players[iPlayer].CurrentReligionTreshold / 400))
end
function GetMoraleBoostFromDeusVult(iPlayer)
	return math.min(10, 2 + math.ceil(gT.Players[iPlayer].CurrentReligionTreshold / 150))
end

function DoEnchanceReligion(iPlayer)
	local gType = gT.Players[iPlayer].CultureType;
	local beliefs = GetBeliefsForReligion(gT.Globals.scType, gType);
	local iRel = Players[iPlayer]:GetReligionCreatedByPlayer();
	Game.EnhanceReligion(iPlayer, iRel, beliefs[4], beliefs[5])
	ITGBeliefAdded(iPlayer, iRel, beliefs[4])
	ITGBeliefAdded(iPlayer, iRel, beliefs[5])
	UpdatePlayerReligionUnitsCost(iPlayer)
	UpdatePressureOfAllHolySites()
	StartTemplarProjectForRel(iRel)
	DoIncreaseHeresyProbability(2)
end

function ClearReligionBonusFromHuman(iPlayer)
	gT.Players[iPlayer].HumanQueueActions["CHOOSE RELIGIOUS BONUS"] = nil;
	gT.Players[iPlayer].PilgrimVisitors = {};
end

function DoAcquireMissionariesFromRelBonus(iPlayer)
	gT.Players[iPlayer].FreeMissioniares = gT.Players[iPlayer].FreeMissioniares + GetMissionariesFromReligiousBonus(iPlayer)
end

function GetValidCityConversionTargetsWithNumNeededToConvert(iRel, iTeam, iPlayer, bForceHumanLike)
	local hTab = {}
	local bHuman = bForceHumanLike or Players[iPlayer]:IsHuman();
	for g, gdata in pairs(gT.Players) do
		if not gdata.SecularState then
			if (not gdata.UntargetByMissionary) or (g == iPlayer) then
				if Players[g]:GetTeam() == iTeam or Teams[iTeam]:IsHasMet(Players[g]:GetTeam()) then
					for iCity in Players[g]:Cities() do
						if not iCity:IsSpreadImmune() then
							if iCity:Plot():IsRevealed(iTeam) then
								if bHuman or (not HasAIReasonNotToSendMissionaryToCity(iCity, iPlayer, iRel)) then
									table.insert(hTab, {iCity, GetNumSpreadsNeededWithMax(iRel, GetMissionaryConversionStrength(iPlayer, iCity), iCity, MAX_MISSIONARY_CHECK)})
								end
							end
						end
					end
				end
			end
		end
	end
	return hTab;
end

function DoInquisitionOnCity(iPlayer, iCity, bScripted)
	DoReligiousOppresionInquisition(iCity, iPlayer)
	iCity:SetNumRealBuilding(bInquisition, 1)
--	if not bScripted then
--		SpendITGFaith(iPlayer, gT.Players[iPlayer].InquisitorCost) 
--	end
	if iPlayer == Game.GetActivePlayer() then
		local hex = ToHexFromGrid(Vector2(iCity:GetX(),iCity:GetY()));
		if LastRandom(1,100) == 15 then
			Events.AddPopupTextEvent(HexToWorld(hex), "Nobody expects...", 0.5)
		else
			Events.AddPopupTextEvent(HexToWorld(hex), "Inquisition", 0.5)
		end
		Events.GameplayFX(hex.x, hex.y, -1)
	end
end

function GetMissionaryConversionStrength(iPlayer, iCity)
	local base = gT.Players[iPlayer].MissionaryStrength + 150 * (gT.Players[iPlayer].WonderRuinsEffects[1] or 0);
	local iOwner = iCity:GetOwner();
	local mod = 100 + GetMissionaryStrengthModFromHolySites(iPlayer, iCity, iOwner);
	if iOwner ~= iPlayer then
		if gT.Players[iOwner].CultBonusOn[16] then
			mod = mod - 25;
		end
	end
	return math.ceil(base * mod / 100)
end

local techinnomeso8 = GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_MESOAMERICAN_8
function DoMissionaryConversionOnCity(iPlayer, iCity, xdd, sManual)
	if gT.Players[iPlayer].FreeMissioniares > 0 then
		gT.Players[iPlayer].FreeMissioniares = gT.Players[iPlayer].FreeMissioniares - 1;
	else
		print("Missionary even without charges!", iPlayer, xdd)
	end
	gT.Players[iPlayer].LHMissionaries = gT.Players[iPlayer].LHMissionaries + 1;
	local biActive = (iPlayer == Game.GetActivePlayer());
	local bPlotVisibleForActive = iCity:Plot():IsVisible(Game.GetActiveTeam());

	ResetFTDelay(0.5 + (xdd or 0))
	local iRel = Players[iPlayer]:GetReligionCreatedByPlayer();
	local hex = ToHexFromGrid(Vector2(iCity:GetX(),iCity:GetY()));
	local cityOwner = iCity:GetOwner();
	local iOwner = iCity:GetOwner();
	if Teams[Players[iPlayer]:GetTeam()]:IsAtWar(Players[cityOwner]:GetTeam()) then
		if LastRandom(1,4) == 3 then
			gT.Players[iPlayer].LHMartyrs = gT.Players[iPlayer].LHMartyrs + 1;
			if (not bITGObserverMode) and (bPlotVisibleForActive or biActive) then
				AddFloatingText(nil,iCity:GetX(),iCity:GetY(),Locale.Lookup(Game.GetReligionName(iRel)) .. " - Martyr",nil, sManual or "Missionary")
				Events.GameplayFX(hex.x, hex.y, -1)
			end
			DoHolySiteMartyrdomEffects(iPlayer, iCity, cID, biActive, sManual or "Missionary", iRel)
			if Players[iPlayer]:IsHuman() then
				LuaEvents.ITG_AchievementCompleted(30)
			end
			return;
		end
	end
	DoIncreasementStockExchange(20, 1)
	local gStrength = GetMissionaryConversionStrength(iPlayer, iCity);
	if Players[cityOwner]:IsMinorCiv() then
		BasicCSMissionCompleteFunc(iPlayer, 16, 1, nil, cityOwner)
	end
	if Players[iPlayer]:IsHuman() then
		LuaEvents.ITG_AchievementCountChange(85, 1)
	end
	local prev = iCity:GetReligiousMajority()
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	if HasPlayerTech(iPlayer, techinnomeso8, "346ffer5235") then
		if gT.Cities[cID].MesoMissionaryHeal ~= GetITGGameTurn() then
			gT.Cities[cID].MesoMissionaryHeal = GetITGGameTurn()
			HealCityDamage(iCity, 30)
		end
	end
	-- enhancer bonuses
	local ngoR = iCity:GetFollowersOtherReligions(iRel);
	local preConvFol = iCity:GetNumFollowers(iRel);

	if IsReligionHaveBelief(iRel, GameInfoTypes.BELIEF_ITG_ENHANCER_12) then
		if LastRandom(1,4) == 3 then
			gStrength = gStrength * 2;
		end
	end
	local cRel = iCity:GetReligiousMajority();
	if IsReligionHaveBelief(cRel, GameInfoTypes.BELIEF_ITG_ENHANCER_8) then
		iCity:AddReligiousPressure(9, cRel, 3000, Game.GetFounder(cRel, -1))
		if (not bITGObserverMode) and (bPlotVisibleForActive or biActive) then
			AddFloatingText(iPlayer,iCity:GetX(),iCity:GetY(),Locale.Lookup(Game.GetReligionName(cRel)) .. ": " .. 300 .. " [ICON_PEACE]",nil, sManual or "Missionary")
		end
	end

	DoHolySiteMissionaryEffects(iPlayer, iCity, cID, biActive, sManual or "Missionary", iRel)

	if IsReligionHaveBelief(iRel, GameInfoTypes.BELIEF_ITG_ENHANCER_7) then
		for relHID = 1, maxReligionITT do
			if relHID ~= iRel then
				local reducement = math.min(math.floor(gStrength * relDLLscale / 4), iCity:GetNumReligionPressure(relHID))
				if reducement > 0 then
					iCity:AddReligiousPressure(9, relHID, -reducement, iPlayer)
				end
			end
		end
	end
	iCity:AddReligiousPressure(6, iRel, gStrength * relDLLscale, iPlayer)
	local gNfol = math.max(math.min(ngoR, 2 * (preConvFol - iCity:GetNumFollowers())), 0) * gT.Players[iPlayer].FounderBeliefModifier;

	if gNfol > 0 then
		if IsReligionHaveBelief(iRel, GameInfoTypes.BELIEF_ITG_FOUNDER_2) then
			--gold
			ChangeITGGold(iPlayer, 25 * gNfol)
			AddFloatingText(iPlayer,iCity:GetX(),iCity:GetY(),25 * gNfol .. "[ICON_GOLD]",nil, sManual or "Missionary")
		end
		if IsReligionHaveBelief(iRel, GameInfoTypes.BELIEF_ITG_FOUNDER_3) then
			--culture
			ChangeITGCulture(iPlayer, 10 * gNfol)
			AddFloatingText(iPlayer,iCity:GetX(),iCity:GetY(),10 * gNfol .. "[ICON_CULTURE]",nil, sManual or "Missionary")
		end
		if IsReligionHaveBelief(iRel, GameInfoTypes.BELIEF_ITG_FOUNDER_9) then
			if Players[iCity:GetOwner()]:IsMinorCiv() and (not Players[iPlayer]:IsMinorCiv()) then
				Players[iCity:GetOwner()]:ChangeMinorCivFriendshipWithMajor(iPlayer, gNfol * 5)
				AddFloatingText(iPlayer,iCity:GetX(),iCity:GetY(),5 * gNfol .. "[ICON_INFLUENCE]",nil, sManual or "Missionary")
			end
			--influence
		end
		if IsReligionHaveBelief(iRel, GameInfoTypes.BELIEF_ITG_FOUNDER_12) then
			--legal power
			ChangeITGLegalPointsPercent(iPlayer, 1 * gNfol)
			AddFloatingText(iPlayer,iCity:GetX(),iCity:GetY(),gNfol/100 .. "[ICON_ITG_LEGAL_POWER]",nil, sManual or "Missionary")
		end
		if IsReligionHaveBelief(iRel, GameInfoTypes.BELIEF_ITG_FOUNDER_18) then
			--settlerpoint
			ChangeITGSettlerPoints(iPlayer, 0.5 * gNfol, nil, "Belief1")
			AddFloatingText(iPlayer,iCity:GetX(),iCity:GetY(),math.ceil(gNfol * 0.5) .. "[ICON_ITG_SETTLER]",nil, sManual or "Missionary")
		end
		if IsReligionHaveBelief(iRel, GameInfoTypes.BELIEF_INTERFAITH_DIALOGUE) then
			--science
			ChangeITGScience(iPlayer, 10 * gNfol)
			AddFloatingText(iPlayer,iCity:GetX(),iCity:GetY(),10 * gNfol .. "[ICON_RESEARCH]",nil, sManual or "Missionary")
		end
	end
	if (not bITGObserverMode) and (bPlotVisibleForActive or biActive) then
		AddFloatingText(iPlayer,iCity:GetX(),iCity:GetY(),Locale.Lookup(Game.GetReligionName(iRel)) .. ": " .. gStrength .. " [ICON_PEACE]",nil, sManual or "Missionary")
		Events.GameplayFX(hex.x, hex.y, -1)
	end
	if gT.Players[cityOwner].CultBonusOn[71] then
		ChangeITGHappinessInTheCity(iCity, 2)
		AddFloatingText(cityOwner,iCity:GetX(),iCity:GetY(),"+2[ICON_HAPPINESS_1]",nil, sManual or "Missionary")
	end
	if iCity:GetReligiousMajority() == iRel and prev ~= iRel then
		if not Players[cityOwner]:IsMinorCiv() then
			if cityOwner ~= iPlayer then
				TakeCareOfEventMorale(iPlayer, 15, {iOwner})
				TakeCareOfEventMorale(iOwner, 16, {iPlayer})
			end
		end
	end
	UpdateCityPressureFromFollowers(iCity)
end

function GetMinimumFaithPlusForReligionConv(iRel, iCity, bPoints, iStrength)
	if iRel < 1 then
		print(iRel, "bad religion")
	end
	if bPoints then
		--to 10
		for i = 1, 20 do
			if iCity:GetMajorityReligionAfterSpread(iRel, 1000 * i) == iRel then
				local base = 1000 * (i - 1)
				for j = 1, 10 do
					if iCity:GetMajorityReligionAfterSpread(iRel, base + 100 * j) == iRel then
						base = base + 100 * (j-1)
						for k = 1, 10 do
							if iCity:GetMajorityReligionAfterSpread(iRel, base + 10 * k) == iRel then
								return base + 10 * (k-1)
							end
						end
					end
				end
			end
		end
		return 25000;
	else
		local tStrength = iStrength or 1000;
		for i = 1, 20 do
			if iCity:GetMajorityReligionAfterSpread(iRel, tStrength * i) == iRel then
				if iStrength then
					return i;
				else
					return i * tStrength * LastRandom(10,15) * 0.1;
				end
			end
		end
		return 25000;
	end
end

function DoASchism(nPlayer, oReligion, hCity)
	local changebelief = LastRandom(2,4)
	local oldBeliefs = Game.GetBeliefsInReligion(oReligion)
	local founderb, enchancerb, follower1, follower2;
	for i, belief in pairs(oldBeliefs) do
		if belief ~= -1 then
			if GameInfo.Beliefs[belief].Founder then
				founderb = belief;
			elseif GameInfo.Beliefs[belief].Enhancer then
				enchancerb = belief;
			elseif GameInfo.Beliefs[belief].Follower then
				if not follower1 then
					follower1 = belief;
				else
					follower2 = belief;
				end
			end
		end
	end
	local newreligiondata, nrb = GetNewReligionData(1, gT.Players[nPlayer].CultureType)
	if changebelief == 2 then
		if (not follower2) or (LastRandom(1,2) == 2) then
			Game.FoundReligion(nPlayer, newreligiondata, nil,  GetBeliefTypeDifferentThan(2, {[follower1] = 1, [follower2 or -1] = 1}, gT.Players[nPlayer].CultureType), founderb, follower2 or -1, enchancerb or -1, hCity)
		else
			Game.FoundReligion(nPlayer, newreligiondata, nil,  follower1, founderb, GetBeliefTypeDifferentThan(2, {[follower1] = 1, [follower2] = 1}, gT.Players[nPlayer].CultureType), enchancerb or -1, hCity)
		end
	elseif (not enchancerb) or (changebelief == 3) then
		Game.FoundReligion(nPlayer, newreligiondata, nil,  follower1, GetBeliefTypeDifferentThan(3, {[founderb] = 1}, gT.Players[nPlayer].CultureType), follower2 or -1, enchancerb or -1, hCity)
	else
		Game.FoundReligion(nPlayer, newreligiondata, nil,  follower1, founderb, follower2 or -1, GetBeliefTypeDifferentThan(4, {[enchancerb] =1}, gT.Players[nPlayer].CultureType), hCity)
	end
	if enchancerb then
		StartTemplarProjectForRel(newreligiondata)
	end

	ITGNewReligion(nPlayer, newreligiondata, false)
	if gT.Globals.ScenarioType == 2 then
		if gT.Players[nPlayer].CultureType == 3 or gT.Players[nPlayer].CultureType == 4 then
			if not Players[nPlayer]:IsMinorCiv() then
				DoScriptedOfficialReligionOnSchism(nPlayer, newreligiondata, oReligion)
			end
		end
	end
	SetOfficialReligion(nPlayer, newreligiondata, nPlayer)
	local str = ""
	DoIncreaseHeresyProbability(20, nPlayer)
	for itt, humanp in pairs(gT.Globals.HumanPlayers) do
		if humanp ~= nPlayer then
			if Teams[nPlayer]:IsHasMet(Players[humanp]:GetTeam()) then
				 str = Players[nPlayer]:GetName() .. " has abandoned the light of " .. Locale.Lookup(Game.GetReligionName(oReligion)) .. ", claiming it has lost its purity and established new religion, " .. Locale.Lookup(Game.GetReligionName(newreligiondata)) .. ".";
			else
				 str = "Unknown player has abandoned the light of " .. Locale.Lookup(Game.GetReligionName(oReligion)) .. ", claiming it has lost its purity and established new religion, " .. Locale.Lookup(Game.GetReligionName(newreligiondata)) .. ".";
			end
			Players[humanp]:AddNotification(NotificationTypes.NOTIFICATION_RELIGION_ENHANCED,str, "Schism")
		end
	end
	HnGLogSchism(nPlayer, newreligiondata, oReligion, hCity)
end

function DoAddNewBeliefOfType(iPlayer, type, iBeliefForce)
	local iRel = Players[iPlayer]:GetReligionCreatedByPlayer()
	local getNewBelief = iBeliefForce;
	local bPanth = Players[iPlayer]:HasCreatedPantheon();
	if not getNewBelief then
		if iRel < 0 then
			if Players[iPlayer]:HasCreatedPantheon() then
				getNewBelief = GetNewBeliefForReformation(nil, iPlayer, Game.GetBeliefsInReligion(0, iPlayer), 2, type, true)
			else
				getNewBelief = GetNewBeliefForReformation(nil, iPlayer, {}, 2, type, true)
			end
		else
			getNewBelief = GetNewBeliefForReformation(nil, iPlayer, Game.GetBeliefsInReligion(iRel), 2, type)
		end
	end
	if iRel < 0 then
		if bPanth then
			Game.AddBeliefToReligion(iPlayer, 0, getNewBelief)
			ITGNewPantheon(iPlayer, getNewBelief)
		else
			Game.FoundPantheon(iPlayer, getNewBelief)
			ITGNewPantheon(iPlayer,  getNewBelief)
		end
		if Players[iPlayer]:IsHuman() then
			local str = "You have founded new pantheon, [COLOR_POSITIVE_TEXT]" .. Locale.Lookup(GameInfo.Beliefs[getNewBelief].ShortDescription) .. "[ENDCOLOR] (" .. Locale.Lookup(GameInfo.Beliefs[getNewBelief].Description) .. ").";
			Players[iPlayer]:AddNotification(NotificationTypes.NOTIFICATION_PANTHEON_FOUNDED_ACTIVE_PLAYER,str, "Founded Pantheon")
		end
		HnGLogPantheonFound(iPlayer, getNewBelief);
	else
		Game.AddBeliefToReligion(iPlayer, iRel, getNewBelief)
		ITGBeliefAdded(iPlayer, iRel, getNewBelief)
	end
	if iRel > 0 then
		local stype = "pantheon"
		local stitle = "New Pantheon"
		if type == 2 then
			stype = "follower"
			stitle = "New follower belief"
		elseif type == 3 then
			stype = "founder"
			stitle = "Religion empowered!"
		elseif type == 4 then
			stype = "follower"
			stitle = "Religion enhanced!"
		end
		for i, iHuman in pairs(gT.Globals.HumanPlayers) do
			if iPlayer ~= iHuman then
				local str = Locale.Lookup(Game.GetReligionName(iRel)) .. " has adopted new " .. stype .. " belief, " .. Locale.Lookup(GameInfo.Beliefs[getNewBelief].ShortDescription) .. ".";
				Players[iHuman]:AddNotification(NotificationTypes.NOTIFICATION_RELIGION_ENHANCED,str, stitle)
			else
				local str = "Your religion, " .. Locale.Lookup(Game.GetReligionName(iRel)) .. ", has adopted new " .. stype .. " belief, " .. Locale.Lookup(GameInfo.Beliefs[getNewBelief].ShortDescription) .. ".";
				Players[iHuman]:AddNotification(NotificationTypes.NOTIFICATION_RELIGION_ENHANCED,str, stitle)
			end
		end
	end
	UpdatePlayerReligionUnitsCost(iPlayer)
	UpdatePressureOfAllHolySites()
	return getNewBelief;
end

function GetNumReformBeliefOption(iPlayer)
	local b = 3
	if HasPlayerNatureWonder(iPlayer, GameInfoTypes.FEATURE_MT_SINAI) then
		b = b + 2;
	end
	return b;
end

function DoStartReformation(iPlayer, eBelief, bRightNow)
	local iRel = Players[iPlayer]:GetReligionCreatedByPlayer()
	local cBeliefs = Game.GetBeliefsInReligion(iRel);
	local getNewBeliefT = GetNewBeliefForReformation(eBelief, iPlayer, cBeliefs, 1)
	if #getNewBeliefT > 0 then
		if #getNewBeliefT > 1 then	
			local lOptionTab = {}
			for i = 1, GetNumReformBeliefOption(iPlayer) do
				if getNewBeliefT[i] then
					table.insert(lOptionTab, getNewBeliefT[i])
				end
			end
			if Players[iPlayer]:IsHuman() then
				table.insert(gT.Players[iPlayer].BeliefChooseDecisions, lOptionTab)
				table.insert(gT.Players[iPlayer].BeliefReplacedT, eBelief)
				if bRightNow then
					LuaEvents.ITG_GeneralChooseWithPriority("CHOOSE BELIEF");
				end
			else
				--ai instant...
				local bBelief, bValue = nil, nil;
				for i, nBelief in pairs(getNewBeliefT) do
					local cValue = DLLBasedBeliefScore(iPlayer, nBelief);
					if (not bValue) or (cValue > bValue) then
						bBelief = nBelief;
						bValue = cValue;
					end
				end
				if bBelief then
					CompleteReformation(iPlayer, eBelief, bBelief)
				else
					print("AI has not chosen any belief for reformation!")
				end
			end
		else
			CompleteReformation(iPlayer, eBelief, getNewBeliefT[1])
		end
	else
		print("Not enough belief for Reformation!", iPlayer, eBelief)
	end
end

function IsHumanInMiddleOfReformingBelief(iPlayer, belief)
	for i, rbelief in pairs(gT.Players[iPlayer].BeliefReplacedT) do
		if rbelief == belief then
			return true;
		end
	end
	return false;
end

function HumanPlayerChooseBelief(iPlayer, belief, confirminfo3, confirminfo4)
	CompleteReformation(iPlayer, gT.Players[iPlayer].BeliefReplacedT[1], belief)
	table.remove(gT.Players[iPlayer].BeliefChooseDecisions, 1)
	table.remove(gT.Players[iPlayer].BeliefReplacedT, 1)
end

function CompleteReformation(iPlayer, eBelief, getNewBelief)
	gT.Players[iPlayer].UsedBeliefs[eBelief] = 1;
	local iRel = Players[iPlayer]:GetReligionCreatedByPlayer()
	local cBeliefs = Game.GetBeliefsInReligion(iRel);
	Game.ResetBeliefsInReligion(iPlayer, iRel)
	for it, belief in pairs(cBeliefs) do
		if belief ~= eBelief then
			Game.AddBeliefToReligion(iPlayer, iRel, belief)
		end
	end
	Game.AddBeliefToReligion(iPlayer, iRel, getNewBelief)
	ITGBeliefRemoved(iPlayer, iRel, eBelief)
	ITGBeliefAdded(iPlayer, iRel, newBelief)
	--notification
	for ji, iHuman in pairs(gT.Globals.HumanPlayers) do
		if iPlayer ~= iHuman then
			local str = Locale.Lookup(Game.GetReligionName(iRel)) .. " has replaced " .. Locale.Lookup(GameInfo.Beliefs[eBelief].ShortDescription) .. " belief with new one: " .. Locale.Lookup(GameInfo.Beliefs[getNewBelief].ShortDescription) .. ".";
			Players[iHuman]:AddNotification(NotificationTypes.NOTIFICATION_RELIGION_ENHANCED,str, "Reformation")
		else
			local str = "Your religion, " .. Locale.Lookup(Game.GetReligionName(iRel)) .. ", has replaced " .. Locale.Lookup(GameInfo.Beliefs[eBelief].ShortDescription) .. " belief with new one: " .. Locale.Lookup(GameInfo.Beliefs[getNewBelief].ShortDescription) .. ".";
			Players[iHuman]:AddNotification(NotificationTypes.NOTIFICATION_RELIGION_ENHANCED,str, "Reformation")
		end
	end
	UpdatePlayerReligionUnitsCost(iPlayer)
	UpdatePressureOfAllHolySites()
	DoIncreaseHeresyProbability(10, iPlayer)
	HnGLogReformation(iPlayer, iRel, eBelief, getNewBelief)
end

function NewBeliefPrioritization(iPlayer, pT, iTypeReturn)
	if iTypeReturn == 4 then
		return pT;
	end
	local priorityTab = {};
	local oTab = {}
	for a, belief in pairs(pT) do
		if IsBeliefPrioritizedForPlayer(belief, iPlayer) then
			table.insert(priorityTab, belief);
		else
			table.insert(oTab, belief);
		end
	end
	if iTypeReturn == 2 then -- random with prioritization
		if #priorityTab > 0 then
			return RandomFromTab(priorityTab);
		end
		return RandomFromTab(oTab)
	elseif iTypeReturn == 1 then -- prepared randomly prioritized to choose
		local rTab = Shuffle(priorityTab);
		oTab = Shuffle(oTab)
		for i, belief in pairs(oTab) do
			table.insert(rTab, belief);
		end
		return rTab;
	elseif iTypeReturn == 3 then -- AI evaluation
		if #priorityTab >= GetNumReformBeliefOption(iPlayer) then
			return priorityTab;
		end
		return pT;
	end
end

function GetNewBeliefForReformation(eBelief, iPlayer, beliefs, iTypeReturn, fType, bLeaguePanth)
	local type = fType or GetBeliefTypeITG(eBelief);
	if (not type) or (type > 4) then
		return nil; -- templar beliefs should be unreplaced
	end
	local cBeliefs = {}
	for it, bel in pairs(beliefs) do
		cBeliefs[bel] = 1;
	end
	--special case
	if bLeaguePanth and type == 1 then
		local pT = {}
		for l, s in pairs(gT.Leagues or {}) do
			if s.Resolutions[37] then
				if s.Members[iPlayer] then
					for bel, k in pairs(s.Pantheons) do
						if not cBeliefs[bel] then
							if iTypeReturn == 0 then
								return bel;
							end
							table.insert(pT, bel);
						end
					end
				end
			end
		end
		if #pT > 0 then
			return NewBeliefPrioritization(iPlayer, pT, iTypeReturn);
		end
	end
	local hTab = {}
	for i, belief in pairs(CultureBeliefsType[gT.Players[iPlayer].CultureType][type]) do
		if not cBeliefs[belief] then
			if not gT.Players[iPlayer].UsedBeliefs[belief] then
				if not gT.Globals.BannedBeliefs[belief] then
					if iTypeReturn == 0 then
						return belief;
					end
					table.insert(hTab, belief)
				end
			end
		end
	end
	if #hTab > 0 then
		return NewBeliefPrioritization(iPlayer, hTab, iTypeReturn);
	else
		return nil;
	end
end

function GetAllAvBeliefsOfType(type)
	local tab = {}
	local alRt = {}
	for i, v in pairs(CultureBeliefsType) do
		for j, belief in pairs(v[type]) do
			if not alRt[belief] then
				table.insert(tab, belief)
				alRt[belief] = true;
			end
		end
	end
	return tab;
end

LuaEvents.ITGCivilopediaRequestBeliefs.Add(function()
	local tab = {}
	tab[1] = GetAllAvBeliefsOfType(1)
	tab[2] = GetAllAvBeliefsOfType(3)
	tab[3] = GetAllAvBeliefsOfType(2)
	tab[4] = GetAllAvBeliefsOfType(4)
	MapModData.ITGSG = tab;
end)

LuaEvents.ITGCivilopediaRequestAvNowBeliefs.Add(function(iPlayer)
	local tab = {}
	if gT.Players[iPlayer] then
		for i, v in pairs(CultureBeliefsType[gT.Players[iPlayer].CultureType] or {}) do
			for j, belief in pairs(v) do
				if not gT.Globals.BannedBeliefs[belief] then
					tab[belief] = true;
				end
			end
		end
	end
	MapModData.ITGSG = tab;
end)

function DoAIConsiderSendingMissionary(iPlayer, bAInotAutomatic)
	DoSpecialAbilitiesRelatedToMissionariesAI(iPlayer)	
	if gT.Players[iPlayer].FreeMissioniares < 1 then
		return;
	end
	local gTurn = GetITGGameTurn();
	if (not bAInotAutomatic) or ((gT.Players[iPlayer].DelayAIMissionary or -1) < gTurn) then
		DoAILogicSpendMissionaries(iPlayer, bAInotAutomatic)
		if bAInotAutomatic then
			gT.Players[iPlayer].DelayAIMissionary = gTurn + LastRandom(5,9);
		end
		if gT.Players[iPlayer].FreeMissioniares < 1 then
			return;
		end
	end
	if gTurn == 100 then
		DoClownFiesta100Missionary(iPlayer)
	end
end

function DoSpecialAbilitiesRelatedToMissionariesAI(iPlayer)	
	if HasPlayerTech(iPlayer, techinnomeso8, "123d4aer5") then
		for iCity in Players[iPlayer]:Cities() do
			if iCity:GetDamage() > 100 then
				DoMissionaryConversionOnCity(iPlayer, iCity)
				if gT.Players[iPlayer].FreeMissioniares == 0 then
					break;
				end
			end
		end
	end
end

function DoAILogicSpendMissionaries(iPlayer, bAInotAutomatic)
	local iTeam = Players[iPlayer]:GetTeam();
	local iRel = Players[iPlayer]:GetReligionCreatedByPlayer();
	local xdd = 0;
	if gT.Players[iPlayer].FreeMissioniares >= 2 then
		--CS missions
		for g, h in pairs(gT.Players) do
			if Players[g]:IsMinorCiv() and (not h.SecularState) and (not h.UntargetByMissionary) then
				for q, questdata in pairs(h.CityStateQuests) do
					if questdata.Active then
						if questdata.ActivePlayers[iPlayer] then
							if (questdata.ActivePlayers[iPlayer].CSMission.ID == 16) and (not questdata.ActivePlayers[iPlayer].CSMission.Count) then
								local iCity = Players[g]:GetCapitalCity();
								if iCity and (not iCity:IsSpreadImmune()) and (iCity:Plot():IsRevealed(iTeam)) then
									for thth = 1, 2 do
										DoMissionaryConversionOnCity(iPlayer, iCity, xdd)
										xdd = xdd + 0.35;
									end
								end
							end
						end
					end
				end
				if gT.Players[iPlayer].FreeMissioniares < 2 then
					break;
				end
			end
		end
		if gT.Players[iPlayer].FreeMissioniares == 0 then
			return;
		end
	end
	local hTab = GetValidCityConversionTargetsWithNumNeededToConvert(iRel, iTeam, iPlayer);
	table.sort(hTab, SortFunctionForLowestMapDistance)
	--1. easy conversions:
	for i, data in pairs(hTab) do
		if data[2] > 1 then
			break;
		elseif data[2] == 1 then
			DoMissionaryConversionOnCity(iPlayer, data[1], xdd)
			xdd = xdd + 0.35;
			if gT.Players[iPlayer].FreeMissioniares == 0 then
				return;
			end
		end
	end
	local setMax = LastRandom(5, 8);
	--2. own cities conversions
	local bDone = {};
	for i, data in pairs(hTab) do
		if data[2] > 1 then
			if data[1]:GetOwner() == iPlayer then
				if data[2] <= setMax and (data[2] <= gT.Players[iPlayer].FreeMissioniares) then
					for j = 1, data[2] do
						DoMissionaryConversionOnCity(iPlayer, data[1], xdd)
						xdd = xdd + 0.35;
					end
					bDone[i] = true;
					if gT.Players[iPlayer].FreeMissioniares == 0 then
						return;
					end
				end
			end
		end
	end
	if gT.Players[iPlayer].FreeMissioniares < 5 then
		return;
	end
	--3. one random hard conversion
	for i, data in pairs(hTab) do
		if (data[2] > 1) and (data[2] <= setMax) and (data[2] <= gT.Players[iPlayer].FreeMissioniares) and (not bDone[i]) then
			for j = 1, data[2] do
				DoMissionaryConversionOnCity(iPlayer, data[1], xdd)
				xdd = xdd + 0.35;
			end
			return;
		end
	end
end

function DoClownFiesta100Missionary(iPlayer)
	local iTeam = Players[iPlayer]:GetTeam();
	local iRel = Players[iPlayer]:GetReligionCreatedByPlayer();
	local tab = GetValidCityConversionTargetsWithNumNeededToConvert(iRel, iTeam, iPlayer, true)
	if #tab == 0 then
		return;
	end
	local xdd = 0;
	local toThrow = gT.Players[iPlayer].FreeMissioniares;
	for i = 1, toThrow do
		DoMissionaryConversionOnCity(iPlayer, tab[LastRandom(1,#tab)][1], xdd)
		xdd = xdd + 0.35;
	end
end

function GetTTFaithString(gPlayer)
	local pPlayer = Players[gPlayer];
	local strText = Locale.ConvertTextKey("TXT_KEY_TP_FAITH_ACCUMULATED", pPlayer:GetFaith());
	strText = strText .. "[NEWLINE]";
	local fTab = {}
	table.insert(fTab, {pPlayer:GetFaithPerTurnFromCities(), "Cities"})
	table.insert(fTab, {GetFaithFromGPC(gPlayer), "Great People"})
	table.insert(fTab, {GetFaithFromLuxuries(gPlayer), "Luxuries"})
	table.insert(fTab, {GetFaithFromGW(gPlayer), "Great Works"})
	table.insert(fTab, {pPlayer:GetFaithPerTurnFromMinorCivs(), "City-States"})
	table.insert(fTab, {pPlayer:GetFaithPerTurnFromReligion(), "Religion"})
	table.insert(fTab, {GetFaithFromTechnologies(gPlayer), "Technologies"})
	table.insert(fTab, {GetFaithFromMorale(gPlayer), "Morale"})
	table.insert(fTab, {GetFaithFromHappiness(gPlayer), "Happiness"})
	table.insert(fTab, {GetFaithCultureFromWonderProcess(gPlayer), "Wonder Process"})
	table.insert(fTab, {GetFaithFromHolySites(gPlayer), "Holy Sites"})
	table.insert(fTab, {GetFaithFromForts(gPlayer), "Forts"})
	table.insert(fTab, {GetFaithFromLaws(gPlayer), "Laws"})
	table.insert(fTab, {GetFaithFromBuildingMaint(gPlayer), "Kok-Gumbaz"})
	table.insert(fTab, {GetFaithFromElDorados(gPlayer), "Golden Cities"})
	table.insert(fTab, {EstimatedFaithSectGain(gPlayer), "Spies"})
	table.insert(fTab, {EstimatedFaithFromHeresy(gPlayer), "Heresy"})
	table.insert(fTab, {GetFaithFromTithe(gPlayer), "Tithe"})
	local totalbase = 0;
	for i, v in pairs(fTab) do
		totalbase = totalbase + v[1];
	end
	table.insert(fTab, {-5 * GetConvertedScienceIntoFaith(gPlayer, GetITGSciencePerTurn(gPlayer, true, true)) / 3 , "[ICON_RESEARCH] Science"})
	table.insert(fTab, {-3 * GetConvertedLegalIntoFaith(gPlayer, GetLegalPointsPerTurn(gPlayer, true, false, true)), "[ICON_ITG_LEGAL_POWER] Legal Power"})
	table.insert(fTab, {GetConvertedFaithIntoLegal(gPlayer, totalbase), "conversion to [ICON_ITG_LEGAL_POWER] Legal Power"})

	for i, v in pairs(fTab) do
		if v[1] > 0 then
			strText = strText .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]+" .. v[1] .. "[ENDCOLOR] produced by " .. v[2] .. ".";
		elseif v[1] < 0 then
			strText = strText .. "[NEWLINE][ICON_BULLET][COLOR_NEGATIVE_TEXT]" .. v[1] .. "[ENDCOLOR] produced by " .. v[2] .. ".";
		end
	end
	if not gT.Players[gPlayer].SecularState then
		local getNextCost = NiceCostOfNextFaithBonus(gPlayer, gT.Players[gPlayer].ReligionRewardTreshold)
		strText = strText .. "[NEWLINE][NEWLINE]You need " .. getNextCost .. " [ICON_PEACE] Faith for next religious bonus.";
	end
	local modTreshold = {};
	--HERE treshold
	if HasPlayerTech(gPlayer, techinnoasia6, "gsdds") then
		strText = strText .. "[NEWLINE]Treshold is equalized with cultural and scientific bonuses."
	end
	table.insert(modTreshold, {100 * GetReligiousTresholdModFromSocials(gPlayer), "Social Developments"})	
	table.insert(modTreshold, {100 * GetReligiousTresholdModFromHarmonizedBeliefs(gPlayer), "Harmonized Beliefs"})	
	table.insert(modTreshold, {100 * GetReligiousTresholdModFromGovernors(gPlayer), "Governors"})	
	table.insert(modTreshold, {100 * GetReligiousTresholdModFromOccupiedCities(gPlayer), "Occupied Cities"})	
	table.insert(modTreshold, {100 * GetReligiousTresholdModFromWonder(gPlayer), "Wonders"})	
	table.insert(modTreshold, {100 * GetReligiousTresholdModFromSubculture(gPlayer), "Subculture"})	
	table.insert(modTreshold, {100 * GetReligiousTresholdModFromLaws(gPlayer), "Laws"})	
	table.insert(modTreshold, {100 * GetReligiousTresholdModFromBeliefs(gPlayer), "Beliefs"})	
	table.insert(modTreshold, {100 * GetReligiousTresholdModFromIdeologies(gPlayer), "Ideologies"})	
	strText = HandleGGAttTresholdMods(strText, modTreshold)

	if IsReligiousBonusChosenRandomly(gPlayer) then
		strText = strText .. "[NEWLINE][NEWLINE]Religious bonus is chosen randomly.";
	end
	return strText;
end