function DoScenarioEffectsInitial()
	if gT.Globals.ScenarioType == 2 then
		DoAddTheTrialInitialEffects()
	end
end

function WarDeclarationPlayerVSPlayer(i, j, bScripted, bMinorAlly)
	if gT.Players[i].CultureType == 3 then
		if gT.Players[j].CultureType == 4 or (gT.Players[j].CultureType == 6 and (not Players[j]:IsMinorCiv())) then
			ChangePeaceWarLock(i, j, 1, "SCrule")
			gT.Players[i].ScenarioWarLocks[j] = true;
			gT.Players[j].ScenarioWarLocks[i] = true;
		end
	elseif gT.Players[i].CultureType == 4 then
		if gT.Players[j].CultureType == 3 then
			ChangePeaceWarLock(i, j, 1, "SCrule")
			gT.Players[i].ScenarioWarLocks[j] = true;
			gT.Players[j].ScenarioWarLocks[i] = true;
		end
	elseif gT.Players[i].CultureType == 6 then
		if (not Players[i]:IsMinorCiv()) and gT.Players[j].CultureType == 3 then
			ChangePeaceWarLock(i, j, 1, "SCrule")
			gT.Players[i].ScenarioWarLocks[j] = true;
			gT.Players[j].ScenarioWarLocks[i] = true;
		end
	end
	if (not bScripted) and (not bMinorAlly) then
		if gT.Globals.GameGenerated then
			local iTA = GetTurnActivePlayer();
			if (iTA == -1) or (iTA < j) then
				gT.Players[j].MercCostDoWed = 15;
				DoSetMercCostRightNow(j)
			else
				gT.Players[j].MercCostDoWed = 20;
			end
		end
	end
	if Players[i]:IsMinorCiv() then
		if IsITGProtectedByMajor(j, i) then
			RemovePledgeOfProtectionByMinor(j, i, "Scripted")
		end
	else
		if HasPlayerTech(j, GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_ASIA_8, "456vgr23e") then
			if gT.Players[i].Authority > gT.Players[j].Authority then
				gT.Players[j].GekokujoAuthority = gT.Players[j].GekokujoAuthority + 1;
			end
		end
		CheckForGovernorSecretPact(i, j)
	end
	if Players[j]:IsMinorCiv() then
		if IsITGProtectedByMajor(i, j) then
			RemovePledgeOfProtectionByMinor(i, j, "Scripted")
		end
	else
		AIPanicScriptDoW(j, i)
	end
end


function DoAddTheTrialInitialEffects()
	gT.Globals.DoubleFounderBenefits = true;
	local cTypes = {{}, {}, {}, {}}
	for g, gd in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			gT.Players[g].FounderBeliefModifier = gT.Players[g].FounderBeliefModifier + 1;
			Players[g]:ChangeFounderBeliefModifier(1);
		end
		table.insert(cTypes[gd.CultureType - 2], g)
	end
	local christianmajors = {}
	for i, player in pairs(cTypes[1]) do
		if not Players[player]:IsMinorCiv() then
			table.insert(christianmajors, player)
		end

	end 
	if #christianmajors > 0 then
		local hTab = {}
		for i, player in pairs(christianmajors) do
			table.insert(hTab, {player, GetTotalDistanceToNeighbours(player, christianmajors)})
		end
		local lPlayer =  GetRandomFromBiasedChanceTable(hTab)
		gT.Globals.ChristianFounder =  lPlayer
		gT.Players[lPlayer].ScenarioForcedStartingCities = LastRandom(1,3);
	end
end

function GetTotalDistanceToNeighbours(player, tab)
	local sPlot = Players[player]:GetStartingPlot()
	local x, y = sPlot:GetX(), sPlot:GetY();
	local tot = 1;
	for i, j in pairs(tab) do
		if j ~= player then
			tot = tot + Map.PlotDistance(x, y, Players[j]:GetStartingPlot():GetX(), Players[j]:GetStartingPlot():GetY())
		end
	end
	return tot;
end

function ScenarioEffectsDoAdoptOfficialReligion(iPlayer, iRel)
	if gT.Players[iPlayer].CultureType == 6 then
		for g, gd in pairs(gT.Players) do
			if gd.CultureType == 3 then
				if gd.ScenarioWarLocks[iPlayer] then
					if iRel == gd.OfficialReligion then
						gT.Players[g].ScenarioWarLocks[iPlayer] = nil;
						gT.Players[iPlayer].ScenarioWarLocks[g] = nil;
						ChangePeaceWarLock(iPlayer, g, -1, "SCrule")
					end
				end
			end
		end
	elseif gT.Players[iPlayer].CultureType == 3 then
		if gT.Leagues["TrialChristianL"] then
			if gT.Leagues["TrialChristianL"].Resolutions[27] then
				PlayerReturnFromSchismOrDoSchism(iPlayer)
			end
		end
	end
	if gT.Globals.ScenarioType == 2 then
		if iRel == GameInfoTypes.RELIGION_CHRISTIANITY then
			local cFounder = Game.GetFounder(GameInfoTypes.RELIGION_CHRISTIANITY, -1);
			if cFounder and (Players[cFounder]) then
				if cFounder ~= iPlayer then
					local fTeam = Teams[Players[cFounder]:GetTeam()];
					local iTeam = Players[iPlayer]:GetTeam();
					if not fTeam:IsHasMet(iTeam) then
						fTeam:Meet(iTeam)
					end
				end
			end
		end
	end
end

function DoScriptedOfficialReligionOnSchism(iPlayer, nRel, oData)
	local done = 0;
	local tt = {}
	for g, h in pairs(gT.Players) do
		if Players[g]:IsMinorCiv() then
			if h.OfficialReligion == oData then
				local value = 1;
				if Teams[Players[g]:GetTeam()]:IsHasMet(Players[iPlayer]:GetTeam()) then
					value = 2;
					if Players[g]:GetAlly() == iPlayer then
						value = 3;
					end
				end
				table.insert(tt, {g, value})
			end
		end
	end
	if #tt <= 2 then
		return;
	end
	local amount = LastRandom(math.ceil(#tt/ 5), math.ceil(2 * #tt/ 5));
	tt = Shuffle(tt)
	table.sort(tt, SortFunctionForGreaterInteger2)
	for i, b in pairs(tt) do
		if amount > 0 then
			amount = amount - 1;
			SetOfficialReligion(b[1], nRel, iPlayer)
		else
			return;
		end
	end
end
