local unitSettlement = GameInfoTypes.UNIT_ITG_SETTLER;
local improSettlement = GameInfoTypes.IMPROVEMENT_ITG_SETTLEMENT;
local improSettlement2 = GameInfoTypes.IMPROVEMENT_ITG_SETTLEMENT_2;
local cstateancient1 = GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_1;
local barbcampImpro = GameInfoTypes.IMPROVEMENT_BARBARIAN_CAMP;

function UpdateSettlementOnThePlot(pPlot, index, iPlayer)
	DoIncreasementStockExchange(10)
	if gT.Settlements[index].Level == 2 then
		RemoveLabelOnPlot(pPlot, "Settlement", nil, true)
		
		pPlot:SetImprovementType(-1)	
		gT.Settlements[index] = nil;	
		for iUnit in Players[iPlayer]:Units() do
			local uID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
			if gT.SettlementsByUnitID[uID] == index then
				iUnit:Kill(false, -1)
				break;
			end
		end
		--bonuses upon founding city;
		if HasPlayerTech(iPlayer, cstateancient1, "hhvewqw") then
			ChangeITGSettlerPoints(iPlayer, 5)
			ChangeMeritocracy(iPlayer, 1)
		end
		--/over
		BasicCSMissionCompleteFunc(iPlayer, 49);
		GenerateCity(iPlayer, pPlot, "Settlement")
		pPlot:SetSpecialControl(false)
	else
		gT.Settlements[index].Level = 1 + gT.Settlements[index].Level;
		gT.Settlements[index].LastUpdate = GetITGGameTurn();
		for iUnit in Players[iPlayer]:Units() do
			local uID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
			if gT.SettlementsByUnitID[uID] == index then
				iUnit:SetBaseCombatStrength( GetCurrentSettlementDefense(iPlayer, gT.Settlements[index].Level) )
				break;
			end
		end
		DoDelayExile(iPlayer)
		if iPlayer == Game.GetActivePlayer() then
			local hex = ToHexFromGrid(Vector2(pPlot:GetX(),pPlot:GetY()));
			Events.GameplayFX(hex.x, hex.y, -1)
		end
	end
end

function GetCurrentSettlementDefense(iPlayer, iLevel)
	return gT.Players[iPlayer].BaseSettlementStrength + (iLevel - 1) * GetDBCulturePlayerInfo(iPlayer, "SettlementStrengthPerLevel")
end

function GetStartingLevelSettlement(iPlayer, iPlot)
	local a = 1;
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_TRIBE_16 , "Fekfekfo") then
		if GetNumUnimprovedFeaturesAdjacent(iPlot) > 2 then
			a = math.max(a, 2);
		end
	end
	return a;
end

function DoCreateNewSettlement(iPlot, index, iPlayer)
	if IsSettlementBlockedBySomething(iPlot, iPlayer) then
		if iPlayer == Game.GetActivePlayer() then
			Events.GameplayAlertMessage("Enemies have slaughtered our settlers!")
		end
		return;
	end
	DoIncreasementStockExchange(10)
	iPlot:SetSpecialControl(true)
	MakeJumpAwayFromSpecialPoint(iPlayer, iPlot)
	gT.PlotFortControl[iPlot:GetPlotIndex()] = nil;
	local jUnit = Players[iPlayer]:InitUnit(unitSettlement, iPlot:GetX(), iPlot:GetY())
	local jID = jUnit:GetID() .. "," .. iPlayer .. "," .. jUnit:GetGameTurnCreated();
	gT.Players[iPlayer].UnitsByID[jID] = {XP = 0}
	jUnit:PushMission(GameInfoTypes.MISSION_SLEEP);
	jUnit:SetMoves(0);
	if iPlot:IsVisible(Game.GetActiveTeam()) then
		local hex = ToHexFromGrid(Vector2(jUnit:GetX(), jUnit:GetY()));
		Events.GameplayFX(hex.x, hex.y, -1);
	end
	gT.SettlementsByUnitID[jID] = iPlot:GetPlotIndex();
	iPlot:SetImprovementType(improSettlement2, -1);
	iPlot:SetImprovementPillaged(false);
	AddSmallInfo(iPlot, nil, "Settlement")
	gT.Settlements[index] = {Level = GetStartingLevelSettlement(iPlayer, iPlot), Player = iPlayer, LastUpdate = GetITGGameTurn()}
	jUnit:SetBaseCombatStrength(GetCurrentSettlementDefense(iPlayer, gT.Settlements[index].Level));
	DoDelayExile(iPlayer)
	if iPlot:GetOwner() == iPlayer then
		gT.Settlements[index].OriginOwner = true;
	else
		iPlot:SetOwner(iPlayer, GetClosestCityIDToPlotOrNil(iPlayer, iPlot));
	end
end

function DestroySettlementOnPlot(unitX, unitY, kPlayer, jPlayer)
	local pPlot = Map.GetPlot(unitX, unitY)
	local index = pPlot:GetPlotIndex();
	RemoveLabelOnPlot(pPlot, "Settlement", nil, true)
	pPlot:SetImprovementType(GameInfoTypes.IMPROVEMENT_CITY_RUINS, -1)
	if not gT.Settlements[index].OriginOwner then
		pPlot:SetOwner(-1, -1);
	end
	table.insert(gT.Players[jPlayer].AIWarningZone, {pPlot:GetPlotIndex(), kPlayer})
	gT.Settlements[index] = nil;
	if kPlayer and (kPlayer ~= -1) and Players[kPlayer]:IsHuman() and (kPlayer ~= jPlayer) then
		LuaEvents.ITG_AchievementCompleted(41)
	end
	pPlot:SetSpecialControl(false)
end

function GetAISettlerStrategy(iPlayer)
	if gT.Players[iPlayer].CanSettleNewCity or gT.Players[iPlayer].CanSettleForeignCont then
		--ancient
		if gT.Globals.ScenarioType == 1 then
			local tH = 15;
			if gT.Players[iPlayer].CultureType == 7 then
				--empire
				tH = tH + 8 * Players[iPlayer]:GetNumCities();
				tH = tH + LastRandom(5, 20);
			elseif gT.Players[iPlayer].CultureType == 8 then
				--cs
				tH = tH + LastRandom(-5, 40);
				if gT.Players[iPlayer].SubcultureType == 7 then
					tH = tH + 30;
				end
			elseif gT.Players[iPlayer].CultureType == 9 then
				--tribe
				tH = tH + LastRandom(-5, 60);
			end
			return math.min(75,tH);
		elseif gT.Globals.ScenarioType == 1 then
			--renesans
			local tH = 30;
			if gT.Players[iPlayer].CultureType == 1 then
--				tH = tH + Players[iPlayer]:GetNumCities() * 7;
--				tH = tH + LastRandom(-15, 25)
				tH = 75; --WE WANT TO SETTLE STUFF;
			else
				tH = tH + Players[iPlayer]:GetNumCities() * 4;
				tH = tH + LastRandom(-15, 25)
			end
			return math.min(75,tH);
		else
			--if we can settle due to some special abilities; let's roll
			return 75;
		end
	end
	return -1; -- no focusing on settling
end

function HasAIHopeToFinishSettlement(iPlayer, gPT)
	local divider = GetITGGameTurn()
	if divider < 8 then
		return true;
	end
	return (gPT / divider * 100) > (3 * GetTresholdForNextSettler(iPlayer))
end

function AIDefineSettlerUsage(iPlayer)
	gT.Players[iPlayer].AISettlerPointsManagement = {}
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_14, "tgrgerg") then 
		if Players[iPlayer]:GetNumCities() > 2 then
			gT.Players[iPlayer].AISettlerPointsManagement.Type = 4;
			return;
		end
	end
	if gT.Players[iPlayer].CanSettleNewCity or gT.Players[iPlayer].CanSettleForeignCont then
		local gPT = gT.Players[iPlayer].SettlerGenerationPoints - gT.Players[iPlayer].SettlerPointsStart + gT.Players[iPlayer].SettlerPointsSpend;
		if gPT > 0 then
	--		print("Settler AI values", iPlayer, GetTresholdForNextSettler(iPlayer), gT.Players[iPlayer].SettlerGenerationPoints, gPT, divider)
			if (gT.Players[iPlayer].SettlerPoints > 2) or (Players[iPlayer]:GetNumCities() == 0) or HasAIHopeToFinishSettlement(iPlayer, gPT) then
				--find the best place, relatively safe;
				local iPlot = GetBestPlaceForAIToSettleOrNil(iPlayer);
				if iPlot then
					gT.Players[iPlayer].AISettlerPointsManagement.Type = 1;
					gT.Players[iPlayer].AISettlerPointsManagement.Target = iPlot:GetPlotIndex();
					return;
				else
					print("Couldn't find city plot to settle (can happen)", iPlayer)
				end
			end
		end
	end
	if gT.Players[iPlayer].AISettlerStrategy <= GetITGGameTurn() then
		--flavor food
		gT.Players[iPlayer].AISettlerManagementReset = GetITGGameTurn() + LastRandom(12,18);
		if gT.Players[iPlayer].CultBonusOn[24] then
			gT.Players[iPlayer].AISettlerPointsManagement.Type = RandomFromTab({2,4});
		elseif GetAIFlavour(iPlayer, "FLAVOR_GROWTH") >= 8 then
			gT.Players[iPlayer].AISettlerPointsManagement.Type = 3;
		elseif GetAIFlavour(iPlayer, "FLAVOR_CULTURE") >= 8 then
			gT.Players[iPlayer].AISettlerPointsManagement.Type = 4;
		else
			gT.Players[iPlayer].AISettlerPointsManagement.Type = 2;
		end
	else
		gT.Players[iPlayer].AISettlerPointsManagement.Type = 5;
		gT.Players[iPlayer].AISettlerPointsManagement.Delay = GetITGGameTurn() + LastRandom(3,5);
	end
end

function HandleSettlerPointsAI(iPlayer)
	-- here make ai decide how to spent settler points
	if gT.Players[iPlayer].SettlerPoints > 0 then
		if not gT.Players[iPlayer].AISettlerStrategy then
			gT.Players[iPlayer].AISettlerStrategy = GetAISettlerStrategy(iPlayer)
		end
		local divider = math.max(GetITGGameTurn(), 1);
		if (gT.Players[iPlayer].AISettlerManagementReset or 200) <= GetITGGameTurn() then
			gT.Players[iPlayer].AISettlerManagementReset = nil;
			gT.Players[iPlayer].AISettlerPointsManagement = nil;
		end
		if not gT.Players[iPlayer].AISettlerPointsManagement then
			AIDefineSettlerUsage(iPlayer)
		end
		if gT.Players[iPlayer].AISettlerPointsManagement.Type == 1 then
			local activeSettlements = 0;
			for index, sth in pairs(gT.Settlements) do
				if sth.Player == iPlayer then
					if CanSettlementBeUpdatedNow(index, iPlayer) then
						if (LastRandom(1, 2) <= sth.Level) or IsRelativelySafeToSettleAround(index, iPlayer) then
							PlayerChooseSettlerPointOnPlot(Map.GetPlotByIndex(index), iPlayer)
							if gT.Players[iPlayer].SettlerPoints < 1 then
								return;
							end
						end
					end
					activeSettlements = activeSettlements + 1;
				end
			end
			local index;
			if (activeSettlements == 0) or (gT.Players[iPlayer].SettlerPoints > 1) then
				if Players[iPlayer]:GetNumCities() > 0 then
					if not gT.Players[iPlayer].AISettlerPointsManagement.Target then
						local iPlot = GetBestPlaceForAIToSettleOrNil(iPlayer, true);
						if iPlot then
							gT.Players[iPlayer].AISettlerPointsManagement.Target = iPlot:GetPlotIndex();
						end
					end
					index = gT.Players[iPlayer].AISettlerPointsManagement.Target;
				end
			end
			if index then
				local iPlot = Map.GetPlotByIndex(index)
				if IsOkForNewSettlement(iPlot, {[-1] = 1, [iPlayer] = 1}, iPlayer) then
					if IsRelativelySafeToSettleAround(index, iPlayer) then
						gT.Players[iPlayer].AISettlerPointsManagement.Target = nil;
						PlayerChooseSettlerPointOnPlot(iPlot, iPlayer)
						return;
					end
				end
				if LastRandom(1,5) ~= 4 then
					return; -- let's wait a bit
				end
			end
			if activeSettlements == 0 then
				gT.Players[iPlayer].AISettlerPointsManagement = nil;
			end
		elseif gT.Players[iPlayer].AISettlerPointsManagement.Type == 2 then
			for g, gd in pairs(gT.Players) do
				if Players[g]:IsMinorCiv() then
					local tc = IsCSValidForPlayerToSettler(g, iPlayer)
					if tc then
						if Players[g]:GetFriendshipNeededForNextLevel(iPlayer) < 5 then
							PlayerChooseSettlerPointOnPlot(tc, iPlayer)
							if divider < 70 then
								gT.Players[iPlayer].AISettlerPointsManagement = nil;
							end
							return;
						end
					end
				end
			end
		elseif gT.Players[iPlayer].AISettlerPointsManagement.Type == 3 then
			for iCity in Players[iPlayer]:Cities() do
				if iCity:GetDamage() == 0 then
					PlayerChooseSettlerPointOnPlot(iCity:Plot(), iPlayer)
					if divider < 70 then
						gT.Players[iPlayer].AISettlerPointsManagement = nil;
					end
					return;
				end
			end
		elseif gT.Players[iPlayer].AISettlerPointsManagement.Type == 4 then
			local iTeam = Teams[Players[iPlayer]:GetTeam()];
			local hTab = {}
			for g, gdata in pairs(gT.Players) do
				if not Players[g]:IsMinorCiv() then
					if g ~= iPlayer then
						if iTeam:IsHasMet(Players[g]:GetTeam()) and not iTeam:IsAtWar(Players[g]:GetTeam()) then
							local iVal = 0;
							if not Players[iPlayer]:IsDoF(g) then
								if gdata.CultureType == gT.Players[iPlayer].CultureType then
									iVal = iVal + 10;
									if gdata.SubcultureType == gT.Players[iPlayer].SubcultureType then
										iVal = iVal + 5;
									end
								end
								for iCity in Players[g]:Cities() do
									if iCity:Plot():IsRevealed(iTeam:GetID()) then
										table.insert(hTab, {iCity:Plot(), iVal + 10 - iCity:GetPopulation()})
									end
								end	
							end
						end
					end
				end
			end
			if #hTab > 0 then
				table.sort(hTab, SortFunctionForGreaterInteger2)
				PlayerChooseSettlerPointOnPlot(hTab[1][1], iPlayer)
				if divider < 70 then
					gT.Players[iPlayer].AISettlerPointsManagement = nil;
				end
				return;
			end
		elseif gT.Players[iPlayer].AISettlerPointsManagement.Type == 5 then
			if gT.Players[iPlayer].AISettlerPointsManagement.Delay <= GetITGGameTurn() then
				gT.Players[iPlayer].AISettlerFoundDiscount = (gT.Players[iPlayer].AISettlerFoundDiscount or 0) + 7;
				gT.Players[iPlayer].AISettlerPointsManagement = nil;
				return;
			end
		end
	end
end

function IsCSValidForPlayerToSettler(g, iPlayer)
	local cc = Players[g]:GetCapitalCity();
	local gTeam = Players[iPlayer]:GetTeam();
	if cc and cc:Plot():IsRevealed(gTeam) then
		if Teams[gTeam]:IsHasMet(Players[g]:GetTeam()) and not Teams[gTeam]:IsAtWar(Players[g]:GetTeam()) then
			return cc:Plot();
		end
	end
	return nil;
end

function IsRelativelySafeToSettleAround(index, iPlayer)
	local iPlot = Map.GetPlotByIndex(index);
	for i, sPlot in pairs(GetPlotsInRadiusOfPlot(iPlot, 2)) do
		if sPlot:IsVisibleEnemyUnit(iPlayer) then
			return false;
		end
	end
	local bIsDanger = false;
	for i, dangerzone in pairs(gT.Players[iPlayer].AIWarningZone) do
		local bPlot = Map.GetPlotByIndex(dangerzone[1])
		if Map.PlotDistance(iPlot:GetX(), iPlot:GetY(), bPlot:GetX(), bPlot:GetY()) < 4 then
			if Teams[Players[iPlayer]:GetTeam()]:IsAtWar(Players[dangerzone[2]]:GetTeam()) then
				bIsDanger = true;
				break;
			end
		end
	end
	if bIsDanger then
		if (not iPlot:IsVisible(Players[iPlayer]:GetTeam())) or (GetNumUnitsNearbyPlot(iPlayer, iPlot:GetX(), iPlot:GetY(), 2, true) < 1) then
			if LastRandom(1, 20) < 19 then
				return false 
			end
		end
	end
	return true;
end

function GenerateDistantCity(iPlayer)
	ClearCityLocations()
	GeneratePossibleCityLocations(4, nil, nil, true)
	local cityLocations = GetCityLocations()
	local sPlot = Players[iPlayer]:GetStartingPlot();
	local valTab = {}
	for hIndex, i in pairs(cityLocations) do
		local iPlot = Map.GetPlotByIndex(hIndex)
		local val = Map.PlotDistance(sPlot:GetX(), sPlot:GetY(), iPlot:GetX(), iPlot:GetY())
		local nv, nt = 0, 0;
		for g, gh in pairs(gT.Players) do
			if not Players[g]:IsMinorCiv() then
				nt = nt + 1;
				if iPlot:IsRevealed(Players[g]:GetTeam()) then
					nv = nv  + 1;
				end
			end
		end
		val = val + 100 - 100 * nv / nt;
		table.insert(valTab, {hIndex, val})
	end
	if #valTab == 0 then
		print("No valid city locations during mid game")
		return;
	end
	table.sort(valTab, SortFunctionForGreaterInteger2)
	local lPlot = Map.GetPlotByIndex(valTab[1][1]);
	MakeJumpAwayFromSpecialPoint(iPlayer, lPlot)
	IgnoreNextCityForGovernorAction()
	GenerateCity(iPlayer, lPlot, "Distant City")
	local iCity = lPlot:GetPlotCity();
	if not iCity then
		print("FOR SOME REASON WE CANNOT FOUND CITY IN THIS VERY NICE SPOT", lPlot:GetPlotIndex(), iPlayer)
		return;
	end
	DoInitialPlotsOfCity(iPlayer, iCity)
	DoTrickToMakeCityInTheMiddleOfGame(iCity, iPlayer)
	StartingUnitsForCity(iCity, gT.Players[iPlayer].CultureType, 2, iPlayer)
	ClearCityLocations()
end

function IsSettlementBlockedBySomething(dPlot, iPlayer)
	if dPlot:GetImprovementType() == barbcampImpro then
		return true;
	end
	local iTeam = Players[iPlayer]:GetTeam();
	for i = 0, dPlot:GetNumUnits() - 1 do
		local dUnit = dPlot:GetUnit(i);
		if dUnit:IsCombatUnit() then
			if Teams[iTeam]:IsAtWar(Players[dUnit:GetOwner()]:GetTeam()) then
				if (not dUnit:IsDelayedDeath()) and (not dUnit:IsDead()) then
					return true;
				else
					print("Check for delayed death barb camp settlement is needed.")
				end
			end
		end
	end
	return false
end

function CanSettlementBeUpdatedNow(index, iPlayer)
	if gT.Settlements[index].LastUpdate + 3 <= GetITGGameTurn() then
		for iUnit in Players[iPlayer]:Units() do
			local uID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
			if gT.SettlementsByUnitID[uID] == index then
				if iUnit:GetDamage() == 0 then
					return true;
				end
				break;
			end
		end
	end
	return false;
end