local iAncientRuins = GameInfoTypes.IMPROVEMENT_ITGSG_ANCIENT_RUINS;
local belfol46 = GameInfoTypes.BELIEF_ITG_FOLLOWER_46;
local improFarm = GameInfoTypes.IMPROVEMENT_FARM;
local bananawonder1 = GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_47;
local PreSelectedTabOfValidPlots = {}
local classGranary = GameInfoTypes.BUILDINGCLASS_GRANARY;
local innoTropical1 = GameInfoTypes.TECH_UNIQUE_ITG_NW_TROPICAL_1;

function DoTurnSettlerPointsCollect(iPlayer)
	if not DBScenario.SettlersOff then
		ChangeITGSettlerPoints(iPlayer, GetSettlerPointsPerTurn(iPlayer, false), nil, "DoTurn")
	end
end

function SpendITGSettlerGenPoints(iPlayer, value)
	gT.Players[iPlayer].SettlerGenerationPoints = gT.Players[iPlayer].SettlerGenerationPoints - value;
	gT.Players[iPlayer].SettlerPointsSpend = gT.Players[iPlayer].SettlerPointsSpend + value;
	if iPlayer == Game.GetActivePlayer() then
		LuaEvents.ITGSGTopPanelDirty()
	end
end

function ChangeITGSettlerPoints(iPlayer, amount, bNotConvertable, hString)
	if DBScenario.SettlersOff then
		print("Something is chaning settler points!", iPlayer, amount, bNotConvertable, hString)
		return;
	end
	if amount < 0 then
		if amount ~= -1 then
			print("Well, where the hell is this reduction from?", iPlayer, amount, bNotConvertable, hString)
		end
		gT.Players[iPlayer].SettlerGenerationPoints = math.max(gT.Players[iPlayer].SettlerGenerationPoints + amount, 0);
	else
		gT.Players[iPlayer].SettlerGenerationPoints = gT.Players[iPlayer].SettlerGenerationPoints + amount;
		local sgpt = GetTresholdForNextSettler(iPlayer);
		local bNewSettlerEarned = false;
		if gT.Players[iPlayer].SettlerGenerationPoints >= sgpt then
			gT.Players[iPlayer].SettlerGenerationPoints = gT.Players[iPlayer].SettlerGenerationPoints - sgpt;
			bNewSettlerEarned = true;
		elseif gT.Players[iPlayer].CultBonusOn[117] and (hString == "DoTurn") and (gT.Players[iPlayer].SettlerGenerationPoints + amount >= sgpt) and LastChance(50) then
			gT.Players[iPlayer].SettlerGenerationPoints = 0;
			bNewSettlerEarned = true;
		end
		if bNewSettlerEarned then
			DoIncreaseSettlerPoint(iPlayer, 1)
			gT.Players[iPlayer].SettlersReached = gT.Players[iPlayer].SettlersReached + 1;
			gT.Players[iPlayer].SettlerPointsSpend = gT.Players[iPlayer].SettlerPointsSpend + sgpt;
			if iPlayer == Game.GetActivePlayer() then
				Events.OpenInfoCorner()
			end
		end
	end
	if iPlayer == Game.GetActivePlayer() then
		LuaEvents.ITGSGTopPanelDirty()
	end
end

function DoIncreaseSettlerPoint(iPlayer, val)
	if DBScenario.SettlerInstant then
		AddSettlerInstantInfluenceNow(iPlayer)
	else
		gT.Players[iPlayer].SettlerPoints = gT.Players[iPlayer].SettlerPoints + val;
	end
end

function GetSettlerPointsFromColonies(iPlayer)
	local tot = 0;
	if gT.Players[iPlayer].CultBonusOn[171] then -- this one is off;
		tot = tot + GetNumSpecialControlPoint(iPlayer, "Colonies", false) * 0.5;
	end
	return tot;
end

function GetSettlerPointsFromPopGrowth(iPlayer)
	local tot = 0;
	for iCity in Players[iPlayer]:Cities() do
		if iCity:GetFoodTurnsLeft() == 1 then
			tot = tot + 1;
		end
	end
	return tot;
end

function GetSettlerPointsCityFromFoodDif(iCity, iPlayer)
	return math.max(iCity:FoodDifference(), 0) * GetPercentageOfCityFoodIntoSettler(iCity, iPlayer);
end

function GetSettlerPointsCityFromBuildings(iCity, iPlayer)
	return iCity:GetSettlerPoints();
end

function GetSettlerPointsCityFromPopulation(iCity)
	return iCity:GetPopulation() * iCity:GetPopulationToSettlerPercent()/ 100;
end

function GetSettlerPointsCityFromBeliefs(iCity, iPlayer)
	local tot = 0;
	if IsBeliefPresentInACity(iCity, belfol46) then
		local bClass = GameInfoTypes.BUILDINGCLASS_HARBOR;
		local bb = Players[iPlayer]:GetPlayerUniqueBuilding(bClass);
		if iCity:IsHasBuilding(bb) then
			local numBuilding = iCity:GetNumRealBuilding(bb) + iCity:GetNumFreeBuilding(bb);
			tot = tot + numBuilding * 1;
		end
	end
	return tot;
end

function GetSettlerPointsCityFromFarms(iCity, iPlayer)
	local tot = 0;
	if iCity:IsHasBuilding(bananawonder1) then
		local cx = iCity:GetX()
		local cy = iCity:GetY();
		for ix = -3, 3 do
			for iy = -3, 3 do
				local iPlot = Map.GetPlot(cx + ix, cy + iy);
				if iPlot then
					if iPlot:GetImprovementType() == improFarm then
						if iPlot:GetOwner() == iPlayer then
							if Map.PlotDistance(cx, cy, cx + ix, cy + iy) <= 3 then
								tot = tot + 1;	
							end
						end
					end
				end
			end
		end
	end
	return tot;
end

function GetSettlerPointsFromCity(iCity, iPlayer, bMod)
	local tot = 0;
	tot = tot + GetSettlerPointsCityFromFoodDif(iCity, iPlayer) + GetSettlerPointsCityFromBuildings(iCity, iPlayer)
	tot = tot + GetSettlerPointsCityFromPopulation(iCity) + GetSettlerPointsCityFromBeliefs(iCity, iPlayer)
	tot = tot + GetSettlerPointsCityFromFarms(iCity, iPlayer)
	if bMod then
		local setMod = GetSettlerModifierForCities(iPlayer);
		if setMod ~= 100 then
			tot = math.floor(tot * setMod) / 100;
		end
	end
	return tot;
end

function GetSettlerModifierForCities(iPlayer)
	local base = 100;
	local nc = Players[iPlayer]:GetNumCities() - 1;
	if nc > 0 then
		base = math.max(25, base - nc);
	end
	return base;
end

function GetSettlerPointsFromCities(iPlayer)
	local tot = 0;
	for iCity in Players[iPlayer]:Cities() do
		tot = tot + GetSettlerPointsFromCity(iCity, iPlayer)
	end
	local setMod = GetSettlerModifierForCities(iPlayer);
	if setMod ~= 100 then
		tot = math.floor(tot * setMod) / 100;
	end
	return tot;
end

function GetSettlerPointsFromGP(iPlayer)
	local tot = 0;
	for gpID, hhh in pairs(gT.Players[iPlayer].GreatPeople) do
		local gd = gT.GreatPeople[gpID];
		if gd.Alive and (not gd.Military) then
			if gd.Ability == 40 then
				tot = tot + 1;
			end
		end
	end
	return tot * GetGreatPeopleYieldModifierAll(iPlayer);
end

function GetSettlerPointsFromCultureType(iPlayer)
	local base = 0;
	if gT.Players[iPlayer].SubcultureType == 7 then
		base = base + 1;
	end
	return base;
end

function GetSettlerPointsFromReligion(iPlayer)
	local base = 0;
	if IsPlayerHaveBelief(iPlayer, GameInfoTypes.BELIEF_ITG_FOUNDER_17) then
		base = base + math.floor(Players[iPlayer]:GetNumForeignFollowers(true) / 5) * gT.Players[iPlayer].FounderBeliefModifier;
	end
	return base;
end

function GetSettlerPointsFromTech(iPlayer)
	return gT.Players[iPlayer].SettlerPointsFromTech;
end

function GetSettlerPointsFromCultBonus(iPlayer)
	local a = 0;
	if gT.Players[iPlayer].Cult32t then
		a = a + 4 * gT.Players[iPlayer].Cult32t[2];
	end
	return a;
end

function GetSettlerPointsFromEmigration(iPlayer)
	if Players[iPlayer]:GetNumCities() == 0 then
		return DBScenario.EmigrationSettlers;
	end
	return 0;
end

function GetSettlerPointsFromSettlements(iPlayer)
	local b = 0;
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_NW_TROPICAL_1, "vokrokoe") then
		for a, c in pairs(gT.Settlements) do
			b = b + 0.25;
		end
	end
	return b;
end

function GetSettlerPointsFromInnovations(iPlayer)
	local a = 0;
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_NW_TROPICAL_7, "okdoe") then
		for govID, h in pairs(gT.Players[iPlayer].Governors) do
			if not gT.Globals.Governors[govID].City then
				a = a + 3;
			end
		end
	end
	return a;
end

function GetSettlerPointsPerTurn(iPlayer, bTop, bIgnoreConvert)
	local tot = 0;
	tot = tot + GetSettlerPointsFromCities(iPlayer);
	tot = tot + GetSettlerPointsFromColonies(iPlayer) + GetSettlerPointsFromEmigration(iPlayer);
	tot = tot + GetSettlerPointsFromGP(iPlayer) + GetSettlerPointsFromCultureType(iPlayer);
	tot = tot + GetSettlerPointsFromReligion(iPlayer) + GetSettlerPointsFromTech(iPlayer);
	tot = tot + GetSettlerPointsFromSettlements(iPlayer) + GetSettlerPointsFromInnovations(iPlayer);
	if bTop then
		tot = tot + GetSettlerPointsFromPopGrowth(iPlayer);
	end
	return tot;
end

function GetTresholdForNextSettler(iPlayer)
	local tresh = DBScenario.SettlerTreshold + GetDBCulturePlayerInfo(iPlayer, "SettlerCostPerCity") * Players[iPlayer]:GetNumCities();
	if DBScenario.SettlerTresholdPer10 then
		tresh = tresh + math.floor(gT.Players[iPlayer].SettlersReached / 10) * 10;
	end
	if HasPlayerTech(iPlayer, innoTropical1, "vokrokoe") then
		tresh = math.min(tresh, 50);
	end
	return tresh;
end

function SetPopulationSettlerBoost(iPlayer, amount)
	if gT.Globals.GameGenerated and (not DBScenario.SettlersOff) then
		if gT.Players[iPlayer].TurnPreVeryActive then
			ChangeITGSettlerPoints(iPlayer, amount, nil, "SPSB")
			if math.abs(amount) > 1 then
				print("Player received more than 1 change settler", iPlayer, amount)
			end
		end
	end
end

function GetPercentageFoodSurplusFromBuildings(iCity, iPlayer)
	local base = iCity:GetSettlerFoodPercent();
	if IsHasLaw(iPlayer, 20, 2) or IsHasLaw(iPlayer, 20, 3) then
		if IsHasBuildingClass(iCity, classGranary) then
			base = base - 3;
		end		
	end
	return base;
end

function GetPercentageFoodSurplusFromLaws(iCity, iPlayer)
	local perc = 0;
	if IsHasLaw(iPlayer, 20, 1) then
		if IsHasBuildingClass(iCity, classGranary) then
			perc = perc + 4;
		end
	end	
	return perc;
end

function GetPercentageFoodSurplusFromSocDev(iCity, iPlayer)
	local perc = 0;
	if gT.Players[iPlayer].CultBonusOn[177] then
		perc = perc + 5;
	end
	return perc;
end

local panth22 = GameInfoTypes.BELIEF_ITG_PANTHEON_22;
function GetPercentageFoodSurplusFromBeliefs(iCity, iPlayer)
	local perc = 0;
	if IsBeliefPresentInACity(iCity, panth22) then
		if IsHasBuildingClass(iCity, classGranary) then
			perc = perc + 5;
		end
	end
	return perc;
end

function GetPercentageFoodSurplusFromHealth(iCity, iPlayer, cID)
	local perc = 0;
	if gT.Cities[cID].HealthLevel > 0 then
		perc = perc + gT.Cities[cID].HealthLevel;
	end
	return perc;
end

function GetPercentageOfCityFoodIntoSettler(iCity, iPlayer)
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local perc = GetPercentageFoodSurplusFromBuildings(iCity, iPlayer) + GetPercentageFoodSurplusFromLaws(iCity, iPlayer);
	perc = perc + GetPercentageFoodSurplusFromSocDev(iCity, iPlayer) + GetPercentageFoodSurplusFromBeliefs(iCity, iPlayer)
	perc = perc + GetPercentageFoodSurplusFromHealth(iCity, iPlayer, cID);
	return perc / 100;
end

function ApplyFreeSettlerToRandomForeignCity(iPlayer)
	local hTab = {}
	local gTeam = Teams[Players[iPlayer]:GetTeam()];
	for g, gd in pairs(gT.Players) do
		if g ~= iPlayer then
			if CanCityBeTargetedForSettlerRelocation(nil, g, gTeam, iPlayer) then
				for icity in Players[g]:Cities() do
					if icity:Plot():IsRevealed(gTeam:GetID()) then
						table.insert(hTab, icity:Plot():GetPlotIndex())
					end
				end
			end
		end
	end
	if #hTab > 0 then
		PlayerChooseSettlerPointOnPlot(Map.GetPlotByIndex(RandomFromTab(hTab)), iPlayer, true)
	end
end

function HighlightProperPlotsForSettlerAction(iPlayer)
	local hTab = {}
	local gTeam = Teams[Players[iPlayer]:GetTeam()];
	local GoodOwnerT = {[-1] = 1, [iPlayer] = 1}
	if gT.Players[iPlayer].CanSettleNewCity or gT.Players[iPlayer].CanSettleForeignCont then
		for dIndex, sth in pairs(PreSelectedTabOfValidPlots) do
			local dPlot = Map.GetPlotByIndex(dIndex);
			if dPlot:IsRevealed(gTeam:GetID()) then
				if IsOkForNewSettlement(dPlot, GoodOwnerT, iPlayer) then
					table.insert(hTab, dPlot)
				end
			end
		end
	end
	for g, gd in pairs(gT.Players) do
		if CanCityBeTargetedForSettlerRelocation(nil, g, gTeam, iPlayer) then
			for icity in Players[g]:Cities() do
				if icity:Plot():IsRevealed(gTeam:GetID()) then
					table.insert(hTab, icity:Plot())
				end
			end
		end
	end
	for index, sth in pairs(gT.Settlements) do
		if sth.Player == iPlayer then
			if CanSettlementBeUpdatedNow(index, iPlayer) then
				table.insert(hTab, Map.GetPlotByIndex(index))
			end
		end
	end
	MapModData.ITGSG = hTab;
end

function IsSpecialControlPlotBlockingSettlementOnPlot(dPlot)
	if IsSpecialControlPlot(dPlot:GetPlotIndex()) then
		return true;
	end
	for i = 0, 5 do
		local iPlot = Map.PlotDirection(dPlot:GetX(), dPlot:GetY(), i);
		if (not iPlot) or IsSpecialControlPlot(iPlot:GetPlotIndex(), nil, true) then
			return true;
		end
	end
	for index, sth in pairs(gT.Settlements) do
		local sPlot = Map.GetPlotByIndex(index);
		if Map.PlotDistance(dPlot:GetX(), dPlot:GetY(), sPlot:GetX(), sPlot:GetY()) < 4 then
			return true;
		end
	end
	return false;
end

function IsOkForNewSettlement(dPlot, GoodOwnerT, iPlayer, bRightNow)
	if not bRightNow then
		if (not gT.Players[iPlayer].CanSettleNewCity) and gT.Players[iPlayer].CanSettleForeignCont then
			if GetContID(dPlot, 12366) == GetContID(Players[iPlayer]:GetStartingPlot(), 5454) then
				return false;
			end
		end
	end
	local bCont = true;
	if not PreSelectedTabOfValidPlots[dPlot:GetPlotIndex()] then
		return false;
	end
	for i = 0, 5 do
		local iPlot = Map.PlotDirection(dPlot:GetX(), dPlot:GetY(), i);
		if (not iPlot) or (not GoodOwnerT[iPlot:GetOwner()]) then
			return false;
		end
	end
	if IsSpecialControlPlotBlockingSettlementOnPlot(dPlot) then
		return false;
	end
	if dPlot:IsVisible(Players[iPlayer]:GetTeam()) and IsSettlementBlockedBySomething(dPlot, iPlayer) then
		return false;
	end
	if not gT.Players[iPlayer].SettlingGlobally then
		if Players[iPlayer]:GetNumCities() > 0 then
			if not HasCityWithinADistance(iPlayer, dPlot, 25) then
				return false;
			end
		end
	end
	return true
end

function CanPlotBeCityVeryBasic(fPlot)
	if not fPlot:IsImpassable() and not fPlot:IsWater() and not fPlot:IsMountain() then
		if fPlot:GetTerrainType() ~= tSnow then
			if not IsEdgeOfMap(fPlot) then
				return true;
			end
		end
	end
	return false;
end

function DoPreSelectionOnGameInitLoadSettlerPlots()
	for i = 0, Map:GetNumPlots() - 1, 1 do
		local fPlot = Map.GetPlotByIndex( i );
		if CanPlotBeCityVeryBasic(fPlot) then
			PreSelectedTabOfValidPlots[i] = 1;
		end
	end
	for g, gd in pairs(gT.Players) do
		for iCity in Players[g]:Cities() do
			local sTab = GetPlotsInRadiusOfPlot(iCity:Plot(), 3)
			for d, bPlot in pairs(sTab) do
				PreSelectedTabOfValidPlots[bPlot:GetPlotIndex()] = nil;
			end
		end
	end
end

function DoSelectionOnCityFoundSettlerPlots(iCity)
	local sTab = GetPlotsInRadiusOfPlot(iCity:Plot(), 3)
	for d, bPlot in pairs(sTab) do
		PreSelectedTabOfValidPlots[bPlot:GetPlotIndex()] = nil;
	end
end

function CanCityBeTargetedForSettlerRelocation(iCity, sPlayer, gTeam, iPlayer)
	if iPlayer ~= sPlayer then
		if HasPlayerTech(sPlayer, GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_ASIA_3, "Adaweq") then
			return false;
		end
	end
	if not gTeam:IsAtWar(Players[sPlayer]:GetTeam()) then
		if gTeam:IsHasMet(Players[sPlayer]:GetTeam()) then
			return true;
		end
	end
	return false;
end

function GetCulturePresenceChangeFromSettlerBasedOnEra(iPlayer)
	local base = GetCPFromSettlerScType()
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_14, "ofkesde") then 
		base = base + 80;
	end
	if gT.Players[iPlayer].CultBonusOn[24] then
		base = math.floor(1.25 * base)
	end
	return base;
end

function GetCPFromSettlerScType()
	if gT.Globals.ScenarioType == 1 then
		return LastRandom(85, 105)
	elseif gT.Globals.ScenarioType == 2 then
		return LastRandom(65, 95)
	elseif gT.Globals.ScenarioType == 3 then
		return LastRandom(35, 65)
	elseif gT.Globals.ScenarioType == 4 then
		return LastRandom(100, 150)
	elseif gT.Globals.ScenarioType == 5 then
		return LastRandom(150, 200)
	end
	return LastRandom(77, 79)
end

function PlayerChooseSettlerPointOnPlot(pPlot, iPlayer, bFree)
	local gTeam = Teams[Players[iPlayer]:GetTeam()];
	if pPlot:IsRevealed(gTeam:GetID()) then
		local index = pPlot:GetPlotIndex();
		if pPlot:IsCity() then
			local iCity = pPlot:GetPlotCity();
			local sPlayer = iCity:GetOwner();
			if sPlayer == iPlayer then
				iCity:ChangeFood(DBScenario.FoodFromSettler);
				if not bFree then
					gT.Players[iPlayer].SettlerPoints = gT.Players[iPlayer].SettlerPoints - 1;
				end
				DoITGCityAcquirePlot(iCity)
				if iPlayer == Game.GetActivePlayer() then
					local hex = ToHexFromGrid(Vector2(iCity:GetX(),iCity:GetY()));
					Events.AddPopupTextEvent(HexToWorld(hex), "[COLOR_FONT_GREEN]+" .. DBScenario.FoodFromSettler .. "[ENDCOLOR][ICON_FOOD]", 0.5)
					Events.GameplayFX(hex.x, hex.y, -1)
				end
				table.insert(gT.Players[iPlayer].SettlerLog, {0, sPlayer, pPlot:GetPlotIndex(), GetITGGameTurn()})
			else
				if CanCityBeTargetedForSettlerRelocation(iCity, sPlayer, gTeam, iPlayer) then
					if not bFree then
						gT.Players[iPlayer].SettlerPoints = gT.Players[iPlayer].SettlerPoints - 1;
					end
					local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
					iCity:ChangeFood(DBScenario.FoodFromSettler);
					local bCheckAchievement99 = (Players[iPlayer]:IsHuman() and (gT.Cities[cID].CultureOwner ~= iPlayer))
					local cpChange = GetCulturePresenceChangeFromSettlerBasedOnEra(iPlayer);
					if bCheckAchievement99 and (gT.Cities[cID].CultureOwner == iPlayer) then
						LuaEvents.ITG_AchievementCompleted(99)
					end
					if Players[sPlayer]:IsMinorCiv() then
						cpChange = math.floor(8 * cpChange / 5);
						Players[sPlayer]:ChangeMinorCivFriendshipWithMajor(iPlayer, 10);
						DoChangeCityCultureOwnership(cID, iCity, iPlayer, cpChange)
						if iPlayer == Game.GetActivePlayer() then
							local hex = ToHexFromGrid(Vector2(iCity:GetX(),iCity:GetY()));
							Events.AddPopupTextEvent(HexToWorld(hex), "[COLOR_FONT_GREEN]+" .. DBScenario.FoodFromSettler .. "[ENDCOLOR][ICON_FOOD]", 0.5)
							Events.GameplayFX(hex.x, hex.y, -1)
							Events.AddPopupTextEvent(HexToWorld(hex), "10[ICON_INFLUENCE]", 1)
							Events.AddPopupTextEvent(HexToWorld(hex), "+" .. cpChange .. "[ICON_ITG_PRESENCE]", 1.5)
						end
						table.insert(gT.Players[iPlayer].SettlerLog, {1, sPlayer, pPlot:GetPlotIndex(), GetITGGameTurn()})
					else
						DoChangeCityCultureOwnership(cID, iCity, iPlayer, cpChange)
						if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_14, "tgrgerg") then 
							ChangeITGSettlerPoints(iPlayer, 7, nil, "InnoCS14")
						end
						if sPlayer == Game.GetActivePlayer() or iPlayer == Game.GetActivePlayer() then
							local hex = ToHexFromGrid(Vector2(iCity:GetX(),iCity:GetY()));
							Events.AddPopupTextEvent(HexToWorld(hex), "[COLOR_FONT_GREEN]+" .. DBScenario.FoodFromSettler .. "[ENDCOLOR][ICON_FOOD]", 0.5)
							Events.GameplayFX(hex.x, hex.y, -1)
							Events.AddPopupTextEvent(HexToWorld(hex), "+" .. cpChange .. "[ICON_ITG_PRESENCE]", 1)
						end
						table.insert(gT.Players[iPlayer].SettlerLog, {2, sPlayer, pPlot:GetPlotIndex(), GetITGGameTurn()})
						table.insert(gT.Players[sPlayer].SettlerLog, {3, iPlayer, pPlot:GetPlotIndex(), GetITGGameTurn()})
					end
				end
			end
		elseif gT.Players[iPlayer].CanSettleNewCity or gT.Players[iPlayer].CanSettleForeignCont then
			if gT.Settlements[index] then
				if gT.Settlements[index].Player == iPlayer then
					if CanSettlementBeUpdatedNow(index, iPlayer) then
						if not bFree then
							gT.Players[iPlayer].SettlerPoints = gT.Players[iPlayer].SettlerPoints - 1;
						end
						UpdateSettlementOnThePlot(pPlot, index, iPlayer)
						if gT.Settlements[index] then
							table.insert(gT.Players[iPlayer].SettlerLog, {5, -1, pPlot:GetPlotIndex(), GetITGGameTurn()})
						else
							table.insert(gT.Players[iPlayer].SettlerLog, {6, -1, pPlot:GetPlotIndex(), GetITGGameTurn()})
						end
					end
				end
			else
				if IsOkForNewSettlement(pPlot, {[-1] = 1, [iPlayer] = 1}, iPlayer) then
					if not bFree then
						gT.Players[iPlayer].SettlerPoints = gT.Players[iPlayer].SettlerPoints - 1;
					end
					table.insert(gT.Players[iPlayer].SettlerLog, {4, -1, pPlot:GetPlotIndex(), GetITGGameTurn()})
					DoCreateNewSettlement(pPlot, index, iPlayer)
				end
			end
		end
	end
end

function GetMinValueForAISettling(iPlayer, bIgnoreDiscount)
	if bAItestFoundValueNewITG then
		return -1;
	end
	if Players[iPlayer]:GetNumCities() == 0 then
		return -1;
	end
	local base = 220;
	if gT.Globals.ScenarioType == 1 then
		base = 180;
	end
	if not bIgnoreDiscount then
		base = base - (gT.Players[iPlayer].AISettlerFoundDiscount or 0);
	end
	if gT.Players[iPlayer].SettlerPoints > 4 then
		base = base - 50;
	end
	return math.max(120,base);
end

function GetBestPlaceForAIToSettleOrNil(iPlayer, bIgnoreDiscount)
	local hTab = {}
	local gTeam = Teams[Players[iPlayer]:GetTeam()];
	local GoodOwnerT = {[-1] = 1, [iPlayer] = 1}
	local maxvalue = GetMinValueForAISettling(iPlayer, bIgnoreDiscount);
--	local rVal = 0;
--	local estimated = 0;
--	local preestimated = 0;
	local nPlot;
	for dIndex, sth in pairs(PreSelectedTabOfValidPlots) do
		local dPlot = Map.GetPlotByIndex(dIndex)
		if dPlot:IsRevealed(gTeam:GetID()) then
--			preestimated = preestimated + 1;
			if IsOkForNewSettlement(dPlot, GoodOwnerT, iPlayer) then
				local value = EvaluateFoundValue(dPlot, iPlayer)
		--		rVal = math.max(value, rVal);
		--		estimated = estimated + 1;
				if value > maxvalue then
					if IsRelativelySafeToSettleAround(dIndex, iPlayer) then
						maxvalue = value;
						nPlot = dPlot;
					end
				end
			end
		end
	end
	return nPlot;
end

local cSettler = GameInfoTypes.UNITCLASS_ITG_SETTLER_POINTS
function AssignInitialSettlerMatters()
	for g, pg in pairs(gT.Players) do
		if Players[g]:IsMinorCiv() then
			Players[g]:SetPlayerUniqueUnit(cSettler, -1)
		else
			local sUnitType = GetDBCulturePlayerInfo(g, "SettlerUnitType")
			if sUnitType and GameInfo.Units[sUnitType] then
				Players[g]:SetPlayerUniqueUnit(cSettler, GameInfo.Units[sUnitType].ID)
			else
				Players[g]:SetPlayerUniqueUnit(cSettler, -1)
			end
		end
	end
end

--write own getfoundvalue again (both ren and ancient)

function EvaluateFoundValue(dPlot, iPlayer)
	local value = 0;
	local cx = dPlot:GetX()
	local cy = dPlot:GetY();
	local iTeam = Players[iPlayer]:GetTeam();
	if gT.Globals.PlotAreas[dPlot:GetPlotIndex()] == "TI" then
		value = value +10;
	end
	for ix = -3, 3 do
		for iy = -3, 3 do
			local iPlot = Map.GetPlot(cx + ix, cy + iy);
			if iPlot then
				local dis = Map.PlotDistance(cx, cy, cx + ix, cy + iy);
				if (dis < 3 and dis > 0) then
					value = value + EvaluatePlotForSettleNearby(iPlot, dis, iPlayer, iTeam)
				end
			else
				return 0;
			end
		end
	end
	local contID = GetContID(dPlot, 12366);
	if GetSizeOfCont(contID) == 1 then
		value = value - 20;
	end
	if dPlot:IsHills() then
		value = value + 20;
	end
	if dPlot:IsRiver() then
		value = value + 15;
	end
	local cityID = GetClosestCityIDToPlotOrNil(iPlayer, dPlot)
	if not cityID then
		value = value + 50;
	else
		local oCity = Players[iPlayer]:GetCityByID(cityID);
		local cDist = Map.PlotDistance(oCity:GetX(), oCity:GetY(), cx, cy);
		if cDist < 8 then
			value = value + 20;
		elseif cDist < 13 then
			value = value + 5;
		end
	end
	value = value + math.min(50, 10 * (9 - dPlot:GetYield(yFood)- dPlot:GetYield(yProduction)- dPlot:GetYield(yGold)))
	local oceansID = {}
	for j = 0, 5 do
		local jPlot = Map.PlotDirection(cx, cy, j);
		if jPlot then
			if jPlot:IsWater() then
				if not jPlot:IsImpassable() then
					local oceanID = GetOceanID(jPlot)
					if not oceansID[oceanID] then
						oceansID[oceanID] = true;
						local aSize = GetSizeOfOcean(oceanID)
						if gT.ValidOceanFish[oceanID] then
							value = value + 6;
						end
						if aSize >= 200 then
							value = value + 4;
						end
						local vFc = 0;
						for iCity in Players[iPlayer]:Cities() do
							for chd, b in pairs(GetCoastOfOceanTab(iCity:Plot())) do
								if b == oceanID then
									vFc = vFc + 2;
									break;
								end
							end
						end
						value = value + math.min(vFc, 10);
					end
				end
			end
		end
	end
	return value;
end

function EvaluatePlotForSettleNearby(iPlot, dis, iPlayer, iTeam)
	local index = iPlot:GetPlotIndex();
	local value = 0;
	if not iPlot:IsRevealed(iTeam) then
		return 5;
	end
	if IsSpecialControlPlot(index) then
		return 0;
	end
	local iOwner = iPlot:GetOwner()
	if iOwner ~= -1 then
		if iOwner ~= iPlayer then
			return -3;
		elseif iPlot:IsPlayerCityRadius(iPlayer) then
			return 0;
		end
	end
	for i, h in pairs(gT.Globals.DiscoveredNaturalWonders) do
		if h == index then
			if dis == 1 then
				return 80;
			else
				return 50;
			end
		end
	end
	local resType = iPlot:GetResourceType(iTeam)
	if resType ~= -1 then
		if GameInfo.Resources[resType].Happiness > 0 then
			if dis == 1 then
				value = value + 25;
			else
				value = value + 15;
			end
		elseif GameInfo.Resources[resType].Migration then
			value = value - 3;
		else
			for b, a in pairs(gT.Globals.ResourcesInScenario) do
				if b == resType then
					if dis == 1 then
						value = value + 20;
					else
						value = value + 10;
					end
					break;
				end
			end
		end
	end
	value = value + 3 * iPlot:GetYield(yFood) + 3 * iPlot:GetYield(yProduction) + iPlot:GetYield(yGold)
	return value;
end
