local specClassAvSc = {};
local specBasicTresholds = {};
for row in DB.Query("SELECT * FROM ITG_ScenarioSpecialUnitTresholds") do
	local scIndex = ITG_ScenariosTypes[row.ScenarioType];
	if not specBasicTresholds[scIndex] then
		specBasicTresholds[scIndex] = {};
	end
	specBasicTresholds[scIndex][GameInfo.UnitClasses[row.UnitClassType].ID] = row.Treshold;
end
for row in DB.Query("SELECT * FROM ITG_ScenarioSpecialUnits") do
	local scIndex = ITG_ScenariosTypes[row.ScenarioType];
	if not specClassAvSc[scIndex] then
		specClassAvSc[scIndex] = {};
	end
	local unitclassID = GameInfo.UnitClasses[row.UnitClassType].ID;
	if not specClassAvSc[scIndex][unitclassID] then
		specClassAvSc[scIndex][unitclassID] = {};
	end
	table.insert(specClassAvSc[scIndex][unitclassID], GameInfo.Units[row.UnitType].ID);
end

local extraUnitCivilopedia = {
[3] = {GameInfoTypes.UNIT_ITG_AOT_SWORDSMAN_ROMAN},
[4] = {GameInfoTypes.UNIT_ITG_ARCHAEOLOGIST},
}

function GetExtraSpecialUnits(a, tab)
	local hAlrMade = ReverseTable(tab);
	for iClass, data in pairs(specClassAvSc[a] or {}) do
		for i, unittype in pairs(data) do
			if not hAlrMade[unittype] then
				table.insert(tab, unittype);
				hAlrMade[unittype] = true;
			end
		end
	end
	for i, unittype in pairs(extraUnitCivilopedia[a] or {}) do
		table.insert(tab, unittype);
	end
	return tab;
end

function SpecialArmyDoTurn()
	if not gT.Globals.SpecializationOn then
		return;
	end
	local Plausible = {}
	for g, h in pairs(gT.Players) do
		for class, amount in pairs(h.SpecialUUProgress or {}) do
			local ghb = GetProgressToTresholdDiff(g, class)
			if ghb >= 0 then
				table.insert(Plausible, {g, ghb, class})
			end
		end
	end
	if #Plausible < 1 then
		return;
	end
	table.sort(Plausible, SortFunctionForGreaterInteger2)
	local bClasses = {}
	local bPlayers = {}
	for i, v in pairs(Plausible) do
		if (not bClasses[v[3]]) and (not bPlayers[v[1]]) and (#gT.Globals.SpecialClassesAv[v[3]] > 0) then
			bClasses[v[3]] = true;
			gT.Players[v[1]].SpecialExtraTreshold = gT.Players[v[1]].SpecialExtraTreshold + DBScenario.PlayerUUTresholdGrowth
			gT.Globals.SpecialTreshold[v[3]] = gT.Globals.SpecialTreshold[v[3]] + TRESHOLD_SPECIAL_UU_GROWTH_CLASS

			if #gT.Globals.SpecialClassesAv[v[3]] == 1 then
				PlayerChooseSpecialUU(v[1], v[3], gT.Globals.SpecialClassesAv[v[3]][1])
			else
				bPlayers[v[1]] = true;
				gT.Players[v[1]].SpecialUUProgress[v[3]] = nil;
				if Players[v[1]]:IsHuman() then
					local cUnitType = Players[v[1]]:GetPlayerUniqueUnit(v[3]);
					if cUnitType == -1 then
						cUnitType = GameInfo.UnitClasses[v[3]].DefaultUnit;
					end
					local sClass = Locale.Lookup(GameInfo.Units[cUnitType].Description)
					local sPI = GameInfo.Units[cUnitType].PortraitIndex
					local sAtlas = GameInfo.Units[cUnitType].IconAtlas
					local data = {BonusType = "SpecialUU", Class = v[3], UniqueOptions = {}, Text = "CHOOSE SPECIAL UNIT", TitleText = "Choose unique replacement for " .. sClass .. ".", TitleIconIndex = sPI, TitleIconAtlas = sAtlas, Tooltip = "You have reached treshold for a new unique unit."}
					for jhj, unitType in pairs(gT.Globals.SpecialClassesAv[v[3]]) do
						table.insert(data.UniqueOptions, {Name = Locale.Lookup(GameInfo.Units[unitType].Description),
							ID = unitType,						
							PortraitIndex = GameInfo.Units[unitType].PortraitIndex,
							IconAtlas = GameInfo.Units[unitType].IconAtlas,
							Help = GetHelpTextForUnit(unitType, false, true),
							ExtraInfo = v[3]})
					end
					table.insert(gT.Players[v[1]].NewHumanQueueActions, data)
				else
					gT.Players[v[1]].AIchooseSpecialUU = v[3];
				end
			end
		end
	end
end

function DoLogUnitTrainedForSpecialUU(iPlayer, iClass)
	if not gT.Players[iPlayer].SpecialUUProgress then
		return;
	end
	if gT.Players[iPlayer].SpecialUUProgress[iClass] then
		gT.Players[iPlayer].SpecialUUProgress[iClass] = gT.Players[iPlayer].SpecialUUProgress[iClass] + PROGRESS_SPECIAL_UU_TRAINED;
	end
end

function GetPlayerTotalTresholdForSpecialUU(g, class)
	return math.max(10, gT.Players[g].SpecialExtraTreshold + gT.Players[g].SpecialUUTresholdRed + gT.Globals.SpecialTreshold[class] + gT.Globals.SpecialBaseTreshold[class]);
end

function GetPlayerTotalProgressTowardsSpecialUU(g, class)
	local val = gT.Players[g].SpecialUUProgress[class];
	val = val + math.floor(XP_TO_PROGRESS_SPECIAL_UU * gT.Players[g].UnitClassXP[class]);
	return val;
end

function GetProgressToTresholdDiff(g, class)
	return GetPlayerTotalProgressTowardsSpecialUU(g, class) - GetPlayerTotalTresholdForSpecialUU(g, class)
end

function SpecialArmyDoInit(majTab)
	for i, player in pairs(majTab) do
		gT.Players[player].SpecialUULog = {}
	end
	if not specClassAvSc[gT.Globals.ScenarioType] then
		return
	end
	gT.Globals.SpecializationOn = true;
	gT.Globals.SpecialClassesAv = {}
	gT.Globals.SpecialTreshold = {}
	gT.Globals.SpecialBaseTreshold = {}
	local limit = #majTab;
	for class, data in pairs(specClassAvSc[gT.Globals.ScenarioType]) do
		gT.Globals.SpecialClassesAv[class] = {}
		gT.Globals.SpecialTreshold[class] = 0;
		gT.Globals.SpecialBaseTreshold[class] = specBasicTresholds[gT.Globals.ScenarioType][class] or 571;
		if #data > limit then
			local tempData = Shuffle(data);
			for i = 1, limit do
				table.insert(gT.Globals.SpecialClassesAv[class], tempData[i])
			end
		else
			for j, b in pairs(data) do
				table.insert(gT.Globals.SpecialClassesAv[class], b)
			end
		end
	end
	for i, player in pairs(majTab) do
		gT.Players[player].SpecialUUProgress = {}
		gT.Players[player].SpecialExtraTreshold = 0;
		for class, data in pairs(specClassAvSc[gT.Globals.ScenarioType]) do
			gT.Players[player].SpecialUUProgress[class] = 0;
		end
	end
	if gT.Globals.ScenarioType == 5 then
		DoInitialSleepOfReasonUUs(majTab)
	elseif gT.Globals.ScenarioType == 3 then
		DoInitialAgeOfTitansUUs(majTab)
	elseif gT.Globals.ScenarioType == 2 then
		DoInitialTheTrialUUs(majTab)
	end
end

function DoInitialTheTrialUUs(majTab)
	for i, gPlayer in pairs(majTab) do
		if gT.Players[gPlayer].SubcultureType == 4 then
			gT.Players[gPlayer].SpecialUUProgress[GameInfoTypes.UNITCLASS_KNIGHT] = nil
			gT.Players[gPlayer].SpecialUUProgress[GameInfoTypes.UNITCLASS_LONGSWORDSMAN] = nil
			gT.Players[gPlayer].SpecialUUProgress[GameInfoTypes.UNITCLASS_PIKEMAN] = nil
		elseif gT.Players[gPlayer].SubcultureType == 5 then
			gT.Players[gPlayer].SpecialUUProgress[GameInfoTypes.UNITCLASS_LONGSWORDSMAN] = nil
		end
	end
end

function DoInitialAgeOfTitansUUs(majTab)
	majTab = Shuffle(majTab);
	local lClasses = {GameInfoTypes.UNITCLASS_ARCHER, GameInfoTypes.UNITCLASS_CHARIOT_ARCHER, GameInfoTypes.UNITCLASS_HORSEMAN, GameInfoTypes.UNITCLASS_SPEARMAN}
	for i, gPlayer in pairs(majTab) do
		local bGive = false;
		if gT.Players[gPlayer].CultureType == 7 or gT.Players[gPlayer].CultureType == 9 then
			bGive = (LastRandom(1,2) == 2)
		elseif gT.Players[gPlayer].CultureType == 8 and gT.Players[gPlayer].SubcultureType == 9 then
			bGive = true;
		end
		if bGive then
			local lClass = lClasses[LastRandom(1,#lClasses)];
			local options = {}
			for b, iType in pairs(gT.Globals.SpecialClassesAv[lClass]) do
				table.insert(options, iType)
			end
			if #options > 0 then
				PlayerChooseSpecialUU(gPlayer, lClass, options[LastRandom(1,#options)], true)
			end
		end
	end
end

function DoBasicUUSpecialInitFromInit()
	for g, h in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			for iUnit in Players[g]:Units() do
				local cClass = iUnit:GetUnitClassType();
				if h.SpecialUUProgress[cClass] then
					gT.Players[g].SpecialUUProgress[cClass] = gT.Players[g].SpecialUUProgress[cClass] + 30;
				end
			end
			for t, c in pairs(gT.Players[g].SpecialUUProgress) do
				gT.Players[g].SpecialUUProgress[t] = math.min(c, math.floor(gT.Globals.SpecialBaseTreshold[t] / 2))
			end
		end
	end
end

function NowThatUnitsAreGeneratedCalculateSpecial()
	if gT.Globals.ScenarioType == 3 then
		DoBasicUUSpecialInitFromInit()
	end
end

function DoInitialSleepOfReasonUUs(majTab)
	if LastRandom(1, 2) == 2 then
		majTab = Shuffle(majTab);
		for i, v in pairs(majTab) do	
			local options = {}
			for it, iClass in pairs({GameInfoTypes.UNITCLASS_BOMBER, GameInfoTypes.UNITCLASS_TANK, GameInfoTypes.UNITCLASS_FIGHTER, GameInfoTypes.UNITCLASS_DESTROYER}) do
				for b, iType in pairs(gT.Globals.SpecialClassesAv[iClass]) do
					table.insert(options, {iClass, iType})
				end
			end
			if #options > 0 then
				local cKey = LastRandom(1,#options);
				PlayerChooseSpecialUU(v, options[cKey][1], options[cKey][2], true)
			end
		end
	else
		for i, v in pairs(majTab) do	
			for it, iClass in pairs({GameInfoTypes.UNITCLASS_BOMBER, GameInfoTypes.UNITCLASS_TANK, GameInfoTypes.UNITCLASS_FIGHTER, GameInfoTypes.UNITCLASS_DESTROYER}) do
				gT.Players[v].SpecialUUProgress[iClass] = LastRandom(0,40) * 5;
			end
		end
	end
end

function DoLogSpecialUnitForPlayer(iPlayer, iClass, iType)
	if gT.Players[iPlayer].SpecialUULog then
		if gT.Players[iPlayer].SpecialUULog[iClass] then
			gT.Players[iPlayer].SpecialUULog[iClass][2] = iType;
		elseif iType ~= -1 then
			gT.Players[iPlayer].SpecialUULog[iClass] = {Players[iPlayer]:GetPlayerUniqueUnit(iClass), iType}
		end
	end
end

function HumanChooseSpecialUU(iPlayer, iType, iClass)
	GeneralRemoveFirstBonusType(iPlayer, "SpecialUU")
	PlayerChooseSpecialUU(iPlayer, iClass, iType)
end

function PlayerChooseSpecialUU(iPlayer, iClass, iType, bTresholds, bNotify)
	if not iType then
		print("Uh oh no Player Choose nil as special unit", iPlayer, iClass, iType, bTresholds, bNotify)
	end
	local iFtype = Players[iPlayer]:GetPlayerUniqueUnit(iClass);
	SetUniqueUnitProperly(iPlayer, iClass, iType)
	gT.Players[iPlayer].SpecialUUProgress[iClass] = nil;
	table.remove(gT.Globals.SpecialClassesAv[iClass], GetKeyFromIntegerTable(gT.Globals.SpecialClassesAv[iClass], iType))
	Players[iPlayer]:SetPlayerForcedUpgradeClass(iClass, iClass); -- self upgrade of older models
	DoLogDominationEvent(15, iPlayer, nil, 40, nil, false, nil)
	VictoryTaskCompletion(iPlayer, 76)
	if bTresholds then
		gT.Players[iPlayer].SpecialExtraTreshold = gT.Players[iPlayer].SpecialExtraTreshold + DBScenario.PlayerUUTresholdGrowth
		gT.Globals.SpecialTreshold[iClass] = gT.Globals.SpecialTreshold[iClass] + TRESHOLD_SPECIAL_UU_GROWTH_CLASS
	end
	if gT.Globals.GameGenerated then
		gT.Players[iPlayer].LHSpecialArmy = gT.Players[iPlayer].LHSpecialArmy + 1;
		ChangeMeritocracy(iPlayer, 4);
		HnGLogSpecialUnit(iPlayer, iType)
		if Players[iPlayer]:IsHuman() then
			LuaEvents.ITG_AchievementCountChange(102, 1)
			local bCompleted = true;
			for class, sth in pairs(gT.Players[iPlayer].SpecialUUProgress) do
				bCompleted = false;
				break;
			end
			if bCompleted then
				LuaEvents.ITG_AchievementCompleted(101)
			end
		end
		if bNotify then
			if Players[iPlayer]:IsHuman() then
				if iFtype == -1 then
					iFtype = GameInfo.UnitClasses[iClass].DefaultUnit
				end
				Players[iPlayer]:AddNotification(58128355, "Our army newest development is [COLOR_POSITIVE_TEXT]" .. Locale.Lookup(GameInfo.Units[iType].Description) .. "[ENDCOLOR] which will replace [COLOR_GREY]" .. Locale.Lookup(GameInfo.Units[iFtype].Description) .. "[ENDCOLOR] (+4 [ICON_ITG_MERITOCRACY] Meritocracy).", "Specialized Unit", -1, -1, iType)
			end
		end
	end
end

function DoAddSpecialUnitForced(iPlayer, class, uType)
	DoRemoveAnyCurrentSpecialUnitChoose(iPlayer, iClass)
	PlayerChooseSpecialUU(iPlayer, class, uType, false)	
end

function DoRemoveAnyCurrentSpecialUnitChoose(iPlayer, iClass)
	if Players[iPlayer]:IsHuman() then
		for i, sth in pairs(gT.Players[iPlayer].NewHumanQueueActions) do
			if (sth.BonusType == "SpecialUU") and (sth.Class == iClass) then
				lkey = i;
				break;
			end
		end
		if lkey then
			table.remove(gT.Players[iPlayer].NewHumanQueueActions, lkey)
		end
	elseif gT.Players[iPlayer].AIchooseSpecialUU == iClass then
		gT.Players[iPlayer].AIchooseSpecialUU = nil;
	end
end

function AIChooseSpecialUU(iPlayer, iClass)
	gT.Players[iPlayer].AIchooseSpecialUU = nil;
	local validOptions = {}
	for i, type in pairs(gT.Globals.SpecialClassesAv[iClass]) do
		table.insert(validOptions, type)
	end
	if #validOptions > 0 then
		PlayerChooseSpecialUU(iPlayer, iClass, validOptions[LastRandom(1,#validOptions)])
		-- maybe one day some logic for AI :)?
	end
end

function CanUseTechBonusForSpecialUU(iPlayer)
	if not gT.Globals.SpecializationOn then
		return false;
	end
	if gT.Players[iPlayer].UsedTechForUU then
		return false;
	end
	if gT.Globals.ScenarioType == 2 then
		return false;
	end
	for iClass, sth in pairs(gT.Globals.SpecialClassesAv) do
		if #sth > 0 then
			if gT.Players[iPlayer].SpecialUUProgress[iClass] then
				return true;
			end
		end
	end
	return false;
end

function DoAddRandomSpecialUU(iPlayer)
	gT.Players[iPlayer].UsedTechForUU = true;
	local prefClasses = {}
	local secClasses = {}
	local pTeam = Teams[Players[iPlayer]:GetTeam()];
	for iClass, sth in pairs(gT.Globals.SpecialClassesAv) do
		if #sth > 0 then
			if gT.Players[iPlayer].SpecialUUProgress[iClass] then
				local cUnitType = Players[iPlayer]:GetPlayerUniqueUnit(iClass);
				if cUnitType == -1 then
					table.insert(secClasses, iClass);
				else
					local tech = GameInfo.Units[cUnitType].PrereqTech;
					if tech and (not pTeam:IsHasTech(GameInfo.Technologies[tech])) then
						table.insert(secClasses, iClass);
					else
						table.insert(prefClasses, iClass);
					end
				end
			end
		end
	end
	if #prefClasses > 0 then
		return DoAddRandomSpecialUUFromClass(iPlayer, prefClasses[LastRandom(1,#prefClasses)])
	elseif #secClasses > 0 then
		return DoAddRandomSpecialUUFromClass(iPlayer, secClasses[LastRandom(1,#secClasses)])
	end
end

function DoAddRandomSpecialUUFromClass(iPlayer, iClass)
	DoRemoveAnyCurrentSpecialUnitChoose(iPlayer, iClass)
	local iUnitType = gT.Globals.SpecialClassesAv[iClass][LastRandom(1,#gT.Globals.SpecialClassesAv[iClass])];
	PlayerChooseSpecialUU(iPlayer, iClass, iUnitType, true, true)
	return iUnitType;
end

LuaEvents.ITGSG_RequestPreciseUISpecialUUData.Add(function(iPlayer)
	local tab = {}
	for iClass, data in pairs(gT.Players[iPlayer].SpecialUUProgress) do
		tab[iClass] = {}
		tab[iClass].Treshold = GetPlayerTotalTresholdForSpecialUU(iPlayer, iClass)
		tab[iClass].Progress = GetPlayerTotalProgressTowardsSpecialUU(iPlayer, iClass)
	end
	MapModData.ITGSG = tab;
end)

function GetBestClassForSpecializationBonus(iPlayer, bCheckGoody)
	if not gT.Globals.SpecializationOn then
		return nil;
	end
	if not gT.Players[iPlayer].SpecialUUProgress then
		return nil; --minor civ
	end
	local tab = {}
	for iClass, sth in pairs(gT.Globals.SpecialClassesAv) do
		if #sth > 0 then
			if gT.Players[iPlayer].SpecialUUProgress[iClass] then
				table.insert(tab, {iClass, Players[iPlayer]:GetUnitClassCountPlusMaking(iClass), GetPlayerTotalProgressTowardsSpecialUU(iPlayer, iClass)})
			end
		end
	end
	if #tab > 0 then
		table.sort(tab, SortFunctionGreatest2Greatest3)
		if bCheckGoody then
			if tab[1][2] == 0 then
				return nil;
			end
		end
		return tab[1][1];
	end
	return nil;
end

function DoChangeSpecializationProgress(iPlayer, amount)
	local iClass = GetBestClassForSpecializationBonus(iPlayer);
	if not iClass then
		return;
	end
	gT.Players[iPlayer].SpecialUUProgress[iClass] = gT.Players[iPlayer].SpecialUUProgress[iClass] + amount;
	return iClass;
end