local wonderindRoyalSalt = GameInfoTypes.BUILDING_ITG_NEW_INDUSTRIAL_WONDER_28

function GetPlayerStockExchangeRewardMod(g, gPrateChange)
	if gT.Players[g].HasPlayerWonder[wonderindRoyalSalt] then
		return 1 + math.max(0, gPrateChange) / 100;
	end
	return 1;
end

function SEignore5th()
	return (gT.Globals.ScenarioType == 5)
end

function SEignore45th()
	return (gT.Globals.ScenarioType == 5) or (gT.Globals.ScenarioType == 4);
end

function SEignoreNot5th()
	return (gT.Globals.ScenarioType ~= 5)
end

function SEreligion()
	return (gT.Globals.ScenarioType ~= 1) and (gT.Globals.ScenarioType ~= 2)
end

function GetTotalWorldPopulation()
	local t = 0;
	for g, gh in pairs(gT.Players) do
		t = t + Players[g]:GetTotalPopulation()
	end
	return t;
end

function GetTotalWorldProductionUsage()
	local t = 0;
	for g, gh in pairs(gT.Players) do
		for iCity in Players[g]:Cities() do
			t = t + iCity:GetCurrentProductionDifferenceTimes100(false, false);
		end
	end
	return t / 100;
end

local StockTabG = {
{ID = 1, Name = "Construction", Help = "[COLOR_POSITIVE_TEXT]Construction's[ENDCOLOR] rating is based on amount of buildings constructed globally.", BaseValue = 0, Exponent = 1, AIFlavour = "FLAVOR_INFRASTRUCTURE"},
{ID = 2, Name = "Entertainment", Help = "[COLOR_POSITIVE_TEXT]Entertainment's[ENDCOLOR] rating is based on amount of [ICON_ITG_FESTIVAL] Festivals started.", BaseValue = 5, Exponent = 1, AIFlavour = "FLAVOR_CULTURE"},
{ID = 3, Name = "Construction", Help = "", BaseValue = 0, Exponent = 1, Ignore = true},
{ID = 4, Name = "Technology", Help = "Investing in [COLOR_POSITIVE_TEXT]Technology[ENDCOLOR] is investing in future. Each time a player discovers new technology or develop an innovation the rating goes up.", BaseValue = 10, Exponent = 1, AIFlavour = "FLAVOR_SCIENCE"},
{ID = 5, Name = "Construction", Help = "", BaseValue = 0, Exponent = 1, Ignore = true},
{ID = 6, Name = "Research", Help = "[COLOR_POSITIVE_TEXT]Research's[ENDCOLOR] rating increases each time any player supports an [ICON_ITG_ACADEMY_2] Academy.", BaseValue = 5, Exponent = 1, AIFlavour = "FLAVOR_GREAT_PEOPLE"},
{ID = 7, Name = "Shipbuilding", Help = "[COLOR_POSITIVE_TEXT]Shipbuilding's[ENDCOLOR] rating is based on amount of Naval units build around the world.", BaseValue = 0, Exponent = 1, AIFlavour = "FLAVOR_NAVAL"},
{ID = 8, Name = "Construction", Help = "", BaseValue = 0, Exponent = 1, Ignore = true},
{ID = 9, Name = "Construction", Help = "", BaseValue = 0, Exponent = 1, Ignore = true},
{ID = 10, Name = "Colonization", Help = "[COLOR_POSITIVE_TEXT]Colonization's[ENDCOLOR] rating increases each time any player establishes a new Colony, Settlement or upgrade existing Settlement.", BaseValue = 5, Exponent = 1, AIFlavour = "FLAVOR_GOLD", IgnoreFunc = SEignore45th},
{ID = 11, Name = "Fishing", Help = "[COLOR_POSITIVE_TEXT]Fishing's[ENDCOLOR] rating is based on amount of Fishing Resources acquired globally.", BaseValue = 0, Exponent = 1, AIFlavour = "FLAVOR_NAVAL_TILE_IMPROVEMENT"},
{ID = 12, Name = "Roads", Help = "[COLOR_POSITIVE_TEXT]Roads'[ENDCOLOR] rating is based on amount of Roads and Railroads constructed around the world.", BaseValue = 10, Exponent = 1, AIFlavour = "FLAVOR_TILE_IMPROVEMENT"},
{ID = 13, Name = "Horse Breeding", Help = "[COLOR_POSITIVE_TEXT]Horse Breeding's[ENDCOLOR] rating is based on amount of [ICON_RES_HORSE] Horse units trained around the world.", BaseValue = 5, Exponent = 1, AIFlavour = "FLAVOR_MOBILE", IgnoreFunc = SEignore5th},
{ID = 14, Name = "Luxuries", Help = "[COLOR_POSITIVE_TEXT]Luxuries'[ENDCOLOR] rating goes up each time any player acquires a new Luxury Resource.", BaseValue = 5, Exponent = 1, AIFlavour = "FLAVOR_HAPPINESS"},
{ID = 15, Name = "Estates", Help = "[COLOR_POSITIVE_TEXT]Estates'[ENDCOLOR] rating is based on world's total population.", BaseValue = 0, Exponent = 1, EndFunc = GetTotalWorldPopulation, AIFlavour = "FLAVOR_GROWTH"},
{ID = 16, Name = "Art", Help = "[COLOR_POSITIVE_TEXT]Art's[ENDCOLOR] rating increases each time any player advances into new Art Style.", BaseValue = 5, Exponent = 1, AIFlavour = "FLAVOR_WONDER"},
{ID = 17, Name = "Aviation", Help = "[COLOR_POSITIVE_TEXT]Aviation's[ENDCOLOR] rating is based on amount of Aircraft units trained around the world.", BaseValue = 5, Exponent = 1, AIFlavour = "FLAVOR_AIR", IgnoreFunc = SEignoreNot5th},
{ID = 18, Name = "Oil", Help = "[COLOR_POSITIVE_TEXT]Art's[ENDCOLOR] rating is based on amount of [ICON_RES_OIL] Oil units trained around the world.", BaseValue = 5, Exponent = 1, AIFlavour = "FLAVOR_OFFENSE", IgnoreFunc = SEignoreNot5th},
{ID = 19, Name = "Energetics", Help = "[COLOR_POSITIVE_TEXT]Energetics'[ENDCOLOR] rating is based on world's total [ICON_PRODUCTION] Production consumption.", BaseValue = 0, Exponent = 1, AIFlavour = "FLAVOR_PRODUCTION", DoTurnFunc = GetTotalWorldProductionUsage, IgnoreFunc = SEignoreNot5th},
{ID = 20, Name = "Reliquaries", Help = "[COLOR_POSITIVE_TEXT]Reliquaries'[ENDCOLOR] rating is based on amount of successful [ICON_ITG_PILGRIM] Pilgrimages (x5) and [ICON_MISSIONARY] Missionaries spent.", BaseValue = 50, Exponent = 1, AIFlavour = "FLAVOR_RELIGION", IgnoreFunc = SEreligion},
}

LuaEvents.ITGSG_RequestStockBasicData.Add(function()
	local tab = {}
	for j, b in pairs(StockTabG) do
		table.insert(tab, {b.Name, b.Help, b.BaseValue, b.Exponent})
	end
	MapModData.ITGSG = tab;
end)
--[[
1. Buildings							OK
2. Festivals started					OK
3. Mercenaries							REMOVE
4. Innovations 5 (tech x1)				OK
5. Plagues								REMOVE
6. Academies support					OK
7. Naval units trained					OK
8. Land TR made							~ ~ even with init probably remove
9. Naval TR made						~ ~ even with init probably remove
10. Colonies Made						OK
11. Fishing								OK
12. Roads							(MEDIUM) (double railroad? for flavour)
13. Horse Units							OK
14. Acquiring New Luxury Resource       OK
15. total population					OK
16. Art Style advance				~ ~
]]

function DoIncreasementStockExchange(type, value)
	if gT.Globals.GameGenerated then
		gT.StockExchange[type].Currently = gT.StockExchange[type].Currently + (value or 1);
	end
end

function GameInitStockExchange()
	gT.StockExchange = {}
	gT.StockCurrency = {}
	for i, v in pairs(StockTabG) do
		gT.StockExchange[i] = {Active = true, DataRates = {}, Currently = 0, GvrnInvest = {}, PlayerInvest = {}, Ignore = v.Ignore}
		if v.IgnoreFunc then
			gT.StockExchange[i].Ignore = v.IgnoreFunc();
		end
	end
	for g, h in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			gT.StockCurrency[g] = {DataRates = {}, PlayerInvest = {}, GvrnInvest = {}}
		end
	end
end

function DoTurnStockExchange()
	local gTurn = GetITGGameTurn();
	gT.Globals.StockActive = false;
	
	for i, st in pairs(gT.StockExchange or {}) do
		if not st.Ignore then
			if StockTabG[i].DoTurnFunc then
				DoIncreasementStockExchange(i, StockTabG[i].DoTurnFunc())
			end
		end
	end
	if gTurn % 14 == 0 then
		if (gTurn > 0) then
			SolutionStockExchange(gTurn)
		end
	end
end

function SolutionStockExchange(gTurn)
	local playerInvestReturn = {}
--bonuses from innovations
	for hg, h in pairs(gT.Players) do
		if HasPlayerTech(hg, GameInfoTypes.TECH_UNIQUE_ITG_NW_TROPICAL_5, "ceper") then
			if gT.StockCurrency[hg] then
				for g, invest in pairs(gT.StockCurrency[hg].PlayerInvest or {}) do
					if g ~= hg then
						ChangeITGGold(hg, invest)
					end
				end
			end
		end
	end

--non related stuff ends
	for gCc, st in pairs(gT.StockCurrency) do
		local cRating = gT.Players[gCc].MintPower
		if (#st.DataRates > 0) and (st.DataRates[#st.DataRates] > 0) then
			local gPrateChange = math.ceil((gT.Globals.CurrencyBaseVal + cRating) / (gT.Globals.CurrencyBaseVal + st.DataRates[#st.DataRates]) * 100) - 100;
			local gold = 0;
			local cPower = 0;
			if gPrateChange > 0 then
				cPower = math.ceil((100 + gPrateChange) / 2);
				gold = cPower - 50;
				if gPrateChange >= 30 then
					table.insert(gT.LHStockRises, {Players[gCc]:GetCivilizationAdjective() .. " Currency",gPrateChange, gTurn})
					if gPrateChange >= 100 then
						for g, invest in pairs(st.PlayerInvest) do
							if HasMintAnyCity(g) and Players[g]:IsHuman() then
								LuaEvents.ITG_AchievementCompleted(8)
							end
						end
					end
				end
				for jkj, governorID in pairs(st.GvrnInvest) do
					GovernorFinancistStock(governorID, gPrateChange)
				end
			else
				cPower = math.max(0, 50 + gPrateChange)
			end
			for g, invest in pairs(st.PlayerInvest) do
				if HasMintAnyCity(g) then
					local realI = invest / 50;
					if not playerInvestReturn[g] then
						playerInvestReturn[g] = {};
					end
					local rewardMod = GetPlayerStockExchangeRewardMod(g, gPrateChange);
					local cPowerChange = math.ceil(cPower * rewardMod);
					local iGoldChange = math.ceil(gold * rewardMod);
					for j = 1, realI do
						table.insert(playerInvestReturn[g], {iGoldChange, cPowerChange, 2, gCc, gPrateChange}) 
					end
				end
			end
		end
		table.insert(gT.StockCurrency[gCc].DataRates, cRating);
		gT.StockCurrency[gCc].PlayerInvest = {}
		gT.StockCurrency[gCc].GvrnInvest = {}
	end
	for i, st in pairs(gT.StockExchange) do
		if not st.Ignore then
			if StockTabG[i].EndFunc then
				DoIncreasementStockExchange(i, StockTabG[i].EndFunc())
			end
			if st.Active then
				if #st.DataRates > 0 then
					--let's mark the change
					local gPrateChange = math.ceil((StockTabG[i].BaseValue + st.Currently) / (StockTabG[i].BaseValue + st.DataRates[#st.DataRates]) * 100) - 100;
					local gold = 0;
					local cPower = 0;
					if gPrateChange > 0 then
--						cPower = math.ceil(50 * math.pow((100 + gPrateChange) / 100, StockTabG[i].Exponent));
						cPower = math.ceil((100 + gPrateChange) / 2); -- exponent removed
						gold = cPower - 50;
						if gPrateChange >= 30 then
							table.insert(gT.LHStockRises, {StockTabG[i].Name,gPrateChange, gTurn})
							if gPrateChange >= 100 then
								for g, invest in pairs(st.PlayerInvest) do
									if HasMintAnyCity(g) and Players[g]:IsHuman() then
										LuaEvents.ITG_AchievementCompleted(8)
									end
								end
							end
						end
						for jkj, governorID in pairs(st.GvrnInvest) do
							GovernorFinancistStock(governorID, gPrateChange)
						end
					else
						cPower = math.max(0, 50 + gPrateChange)
					end
					for g, invest in pairs(st.PlayerInvest) do
						if HasMintAnyCity(g) then
							local realI = invest / 50;
							if not playerInvestReturn[g] then
								playerInvestReturn[g] = {};
							end
							local rewardMod = GetPlayerStockExchangeRewardMod(g, gPrateChange);
							local cPowerChange = math.ceil(cPower * rewardMod);
							local iGoldChange = math.ceil(gold * rewardMod);
							for j = 1, realI do
								table.insert(playerInvestReturn[g], {iGoldChange, cPowerChange, 1, i, gPrateChange}) 
							end
						end
					end
				end
				table.insert(gT.StockExchange[i].DataRates, st.Currently);
				if st.Currently == 0 then
					gT.StockExchange[i].Active = false;
				else
					gT.StockExchange[i].Currently = 0;
				end
				gT.StockExchange[i].PlayerInvest = {}
				gT.StockExchange[i].GvrnInvest = {};
			else
				table.insert(gT.StockExchange[i].DataRates, st.Currently);
				if st.Currently == 0 then
					gT.StockExchange[i].AlmostActive = nil;
				else
					if st.AlmostActive then
						gT.StockExchange[i].AlmostActive = nil;
						gT.StockExchange[i].Active = true;
					else
						gT.StockExchange[i].AlmostActive = true;
					end
					gT.StockExchange[i].Currently = 0;
				end
			end
		end
	end
	for g, data in pairs(playerInvestReturn) do
		local hTab = data;
		table.sort(hTab, SortFunctionForGreaterInteger2)
		if gT.Players[g].CultBonusOn[106] then
			hTab[1][1] = hTab[1][1] * 2;
		end
		if gT.Players[g].IgnoreWorstInvest then
			local numIgnore = #hTab - gT.Players[g].IgnoreWorstInvest; 
			for j, b in pairs(hTab) do
				if j > numIgnore then
					hTab[j][1] = 0;
					hTab[j][2] = 0;
				end
			end
		end
		local logT = {{}, {}}
		local cpower = 0;
		local cgold = 0;
		for j, b in pairs(hTab) do
			cpower = cpower + b[2];
			cgold = cgold + b[1]
			if logT[b[3]][b[4]] then
				logT[b[3]][b[4]][1] = logT[b[3]][b[4]][1] + b[1];
				logT[b[3]][b[4]][2] = logT[b[3]][b[4]][2] + b[2];
				logT[b[3]][b[4]][4] = logT[b[3]][b[4]][4] + 50;
			else
				logT[b[3]][b[4]] = {b[1], b[2], b[5], 50}
			end 
		end
		local nmsc = GetNumAcademiesWithAbility(g, 66)
		--REWARD GOLD + VictoryPoints from that
		ChangeITGGold(g, cgold)
		VictoryTaskCompletion(g, 47, cgold)
		if nmsc > 0 then
			--REWARD SCIENCE
			ChangeITGScience(g, nmsc * cgold)
		end
		--LOG
		for i, v in pairs(logT) do
			for c, d in pairs(v) do
				table.insert(gT.Players[g].InvestLog, {c, d[4], d[3], d[1], d[2], gTurn, i})
			end
		end
		--REWARD CURRENCY POWER
		gT.Players[g].InvestCurrencyPower = cpower;
		table.insert(gT.Players[g].LHStockCurrency, cpower)
		if Players[g]:IsHuman() then
			--NOTIFICATION
			local nottype = 21
			if cpower >= 200 then
				nottype = 22;
			end
			local strnmsc = ""
			if (nmsc > 0) and (cgold > 0) then
				strnmsc = ", " .. nmsc * cgold .. " [ICON_RESEARCH] Science" 
			end
			Players[g]:AddNotification(94343293, "Our Investments granted us " .. cpower .. " [ICON_INVEST] Currency Power" .. strnmsc .. " and " .. cgold .. " [ICON_GOLD] Gold.", "Trading Session", -1, -1, nottype)
		end
	end
	if gTurn < 90 then
		gT.Globals.StockActive = true;
		for g, gdata in pairs(gT.Players) do
			gT.Players[g].StockInvestAvailable = GetStockInvestAvailable(g);
			MakePlayerGovernorsInvestInStock(g)
		end
	else
		gT.Globals.StockIsOver = true;
	end
end

function GetStockInvestAvailable(iPlayer)
	local base = 200;
	gT.Players[iPlayer].IgnoreWorstInvest = nil;
	base = base + 50 * Players[iPlayer]:GetBuildingClassCount(GameInfoTypes.BUILDINGCLASS_ITG_INDIA_COMPANY);
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_MODERN_28, "53534") then
		base = base + 50;
	end
	if HasPlayerCHIncomingTrait(iPlayer, 14) then
		base = base + 50;
	end
	if gT.Players[iPlayer].HasIdeology[35] then
		if gT.Players[iPlayer].MintBonus <= gT.Globals.AverageMintBonus then
			base = base + 50;
		end
	end
	if gT.Players[iPlayer].CultBonusOn[106] then
		base = base + 100;
		gT.Players[iPlayer].IgnoreWorstInvest = (gT.Players[iPlayer].IgnoreWorstInvest or 0) + 2;
	end
	return base;
end

function CanPlayerEnterStockExchange(gPlayer)
	if HasPlayerTech(gPlayer, GameInfoTypes.TECH_GUILDS, "daedae") or HasPlayerTech(gPlayer, GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_HORDE_3, "looefee") then
		if HasMintAnyCity(gPlayer) then
			return true;
		end
	end
	return false;
end

LuaEvents.ITG_CanPlayerEnterStockExchange.Add(function()
	MapModData.ITGSG = CanPlayerEnterStockExchange(Game.GetActivePlayer());
end)

LuaEvents.ITG_CheckIfStockExchangeStillAvailable.Add(function()
	if not CanPlayerEnterStockExchange(Game.GetActivePlayer()) then
		Events.SerialEventEndTurnDirty()
	end
end)

function MakeAnInvestmentInCurrency(iPlayer, id, val)
	gT.StockCurrency[id].PlayerInvest[iPlayer] = (gT.StockCurrency[id].PlayerInvest[iPlayer] or 0) + (val or 50);
	gT.Players[iPlayer].StockInvestAvailable = gT.Players[iPlayer].StockInvestAvailable - (val or 50);
	if gT.StockCurrency[id].PlayerInvest[iPlayer] == 0 then
		gT.StockCurrency[id].PlayerInvest[iPlayer] = nil
	end
end

function MakeAnInvestmentInStock(iPlayer, id, val)
	gT.StockExchange[id].PlayerInvest[iPlayer] = (gT.StockExchange[id].PlayerInvest[iPlayer] or 0) + (val or 50);
	gT.Players[iPlayer].StockInvestAvailable = gT.Players[iPlayer].StockInvestAvailable - (val or 50);
	if gT.StockExchange[id].PlayerInvest[iPlayer] == 0 then
		gT.StockExchange[id].PlayerInvest[iPlayer] = nil
	end
end

LuaEvents.ITGSG_PlayerChangeInvestStock.Add(function(iPlayer, id, change, type)
	if type == "StockCurrency" then
		if gT.Players[id].MintPower <= 0 then
			return;
		end
	end
	if change > 0 then
		if gT.Players[iPlayer].StockInvestAvailable <= 0 then
			return;
		end
	elseif (gT[type][id].PlayerInvest[iPlayer] or 0) == 0 then
		return;
	end
	gT[type][id].PlayerInvest[iPlayer] = (gT[type][id].PlayerInvest[iPlayer] or 0) + change * 50;
	gT.Players[iPlayer].StockInvestAvailable = gT.Players[iPlayer].StockInvestAvailable - change * 50;
	MapModData.ITGSG = {gT[type][id].PlayerInvest[iPlayer], gT.Players[iPlayer].StockInvestAvailable}
	Events.SerialEventEndTurnDirty()
end)

function CheckThisRandomActivePlayerInvestingInMintJustDestroyed(j)
	local iPlayer = Game.GetActivePlayer();
	if Players[iPlayer]:IsTurnActive() then
		if (gT.StockCurrency[j].PlayerInvest[iPlayer] or 0) > 0 then
			gT.Players[iPlayer].StockInvestAvailable = gT.Players[iPlayer].StockInvestAvailable + gT.StockCurrency[j].PlayerInvest[iPlayer];
			gT.StockCurrency[j].PlayerInvest[iPlayer] = 0;
			Events.SerialEventEndTurnDirty()
		end
	end
end

LuaEvents.ITGSG_PrepareStockLogData.Add(function(iPlayer)
	local tab = {}
	for a, b in pairs(gT.Players[iPlayer].InvestLog) do
		if b[2] > 0 then
			local sTT = ""
			if b[7] == 1 then
				if b[3] >= 0 then
					sTT = "Invested " .. b[2] .. " [ICON_INVEST] points in [COLOR_SELECTED_TEXT]" .. StockTabG[b[1]].Name .. "[ENDCOLOR] ([COLOR_POSITIVE_TEXT]+" .. b[3] .. "%[ENDCOLOR])."
				else
					sTT = "Invested " .. b[2] .. " [ICON_INVEST] points in [COLOR_SELECTED_TEXT]" .. StockTabG[b[1]].Name .. "[ENDCOLOR] ([COLOR_NEGATIVE_TEXT]" .. b[3] .. "%[ENDCOLOR])."
				end
			elseif b[7] == 2 then
				if b[3] >= 0 then
					sTT = "Invested " .. b[2] .. " [ICON_INVEST] points in [COLOR_SELECTED_TEXT]" .. Players[b[1]]:GetCivilizationAdjective() .. " Currency[ENDCOLOR] ([COLOR_POSITIVE_TEXT]+" .. b[3] .. "%[ENDCOLOR])."
				else
					sTT = "Invested " .. b[2] .. " [ICON_INVEST] points in [COLOR_SELECTED_TEXT]" .. Players[b[1]]:GetCivilizationAdjective() .. " Currency[ENDCOLOR] ([COLOR_NEGATIVE_TEXT]" .. b[3] .. "%[ENDCOLOR])."
				end
			end
			table.insert(tab, {b[6] .. "T", b[5] .. "[ICON_INVEST]", b[4] .. "[ICON_GOLD]", sTT})
		end
	end
	if not gT.Globals.StockActive then
		for i, stockD in pairs(gT.StockExchange) do
			if (stockD.PlayerInvest[iPlayer] or 0) > 0 then
				table.insert(tab, {"", "", "", "Currently investing " .. stockD.PlayerInvest[iPlayer] .. " [ICON_INVEST] points in [COLOR_SELECTED_TEXT]" .. StockTabG[i].Name .. "[ENDCOLOR]."})		
			end
		end
		for gCc, stockD in pairs(gT.StockCurrency) do
			if (stockD.PlayerInvest[iPlayer] or 0) > 0 then
				table.insert(tab, {"", "", "", "Currently investing " .. stockD.PlayerInvest[iPlayer] .. " [ICON_INVEST] points in [COLOR_SELECTED_TEXT]" .. Players[gCc]:GetCivilizationAdjective() .. " Currency[ENDCOLOR]."})		
			end
		end
	end
	MapModData.ITGSG = tab;
end)

function GetAIStockExchangeType(iPlayer)
	if not gT.Players[iPlayer].AIStockType then
		gT.Players[iPlayer].AIStockPU = GetRandomFromBiasedChanceTable({{1, 57}, {2, 20}, {3, 13}, {4, 10}})
		if Players[iPlayer]:IsHuman() then
			local humanTab = {2,3,4,5,6,7,8,9,10}
			return humanTab[LastRandom(1,#humanTab)];
		else
			local AItab = {1,2,3,4,5,6,7,8,9,10}
			gT.Players[iPlayer].AIStockType = AItab[LastRandom(1,#AItab)];
		end
	end
	return gT.Players[iPlayer].AIStockType;
end

local cTabToInvestCurrency = {};
local cTabToInvestStock = {};
function IsValidStockInvestment(type)
	for i, v in pairs(cTabToInvestStock) do
		if v == type then
			return true;
		end
	end
	return false;
end

function DoMakeAIInvestments(iPlayer)
	local numAv = gT.Players[iPlayer].StockInvestAvailable / 50;
	if numAv <= 0 then
		return;
	end
	cTabToInvestCurrency = {};
	cTabToInvestStock = {};
	for gCc, st in pairs(gT.StockCurrency) do
		if gT.Players[gCc].MintPower > 0 then
			if (gCc ~= iPlayer) then
				if (Teams[Players[iPlayer]:GetTeam()]:IsHasMet(Players[gCc]:GetTeam())) then
					table.insert(cTabToInvestCurrency, gCc)
				end
			end
		end
	end
	for i, st in pairs(gT.StockExchange) do
		if not st.Ignore then
			if st.Active then
				table.insert(cTabToInvestStock, i)
			end
		end
	end
	local iAIType = GetAIStockExchangeType(iPlayer)
	local bExcludeAlreadyHadOne = false;
	local iEmergencyChecks = 4;
	if gT.Players[iPlayer].IgnoreWorstInvest then
		bExcludeAlreadyHadOne = true;
	end
	local bFirstStock = GetITGGameTurn() < 20;
	for i = 1, numAv do
		local pereUsage = math.min(gT.Players[iPlayer].AIStockPU, numAv)
		local gInvest, gType = GetInvestForAINow(iPlayer, iAIType, bFirstStock)
		if gType == 1 then
			if bExcludeAlreadyHadOne and gT.StockExchange[gInvest].PlayerInvest[iPlayer] and iEmergencyChecks > 0 then
				iEmergencyChecks = iEmergencyChecks - 1;
			else
				numAv = numAv - pereUsage;
				MakeAnInvestmentInStock(iPlayer, gInvest, 50 * pereUsage)
			end
		elseif gType == 2 then
			if bExcludeAlreadyHadOne and gT.StockCurrency[gInvest].PlayerInvest[iPlayer] and iEmergencyChecks > 0 then
				iEmergencyChecks = iEmergencyChecks - 1;
			else
				numAv = numAv - pereUsage;
				MakeAnInvestmentInCurrency(iPlayer, gInvest, 50 * pereUsage)
			end
		else
			print("ERROR SO BAD 7345345")
		end
		if numAv < 1 then
			return;
		end
	end
end


function StockEval2Func(i, gTs)
	local c = 1;
	for a, b in pairs(gT[gTs][i].DataRates) do
		if a > 1 then
			if b > gT[gTs][i].DataRates[a-1] then
				c = c + 1;
			else
				c = 1;
			end
		end
	end
	return c;
end

function StockEval3Func(i, gTs)
	if gT[gTs][i].DataRates[#gT[gTs][i].DataRates] < gT[gTs][i].DataRates[#gT[gTs][i].DataRates - 1] then -- recent fall
		local baseV = gT.Globals.CurrencyBaseVal
		if gTs == "StockExchange" then
			baseV = StockTabG[i].BaseValue;
		end
		return math.ceil((baseV + gT[gTs][i].DataRates[#gT[gTs][i].DataRates - 1]) / (baseV + gT[gTs][i].DataRates[#gT[gTs][i].DataRates - 2]) * 100) - 100;
	end
	return 0;
end

function StockEval4Func(i, gTs)
	return gT[gTs][i].DataRates[#gT[gTs][i].DataRates]
end

function StockEval7Func(i, gTs) -- percent change last one
	local baseV = gT.Globals.CurrencyBaseVal;
	if gTs == "StockExchange" then
		baseV = StockTabG[i].BaseValue;
	end
	return math.ceil((baseV + gT[gTs][i].DataRates[#gT[gTs][i].DataRates]) / (baseV + gT[gTs][i].DataRates[#gT[gTs][i].DataRates - 1]) * 100) - 100;
end

function StockEval8Func(i, gTs)
	local hMax = 0;
	for d, b in pairs(gT[gTs][i].DataRates) do
		hMax = math.max(hMax, b)
	end
	return hMax / math.max(gT[gTs][i].DataRates[#gT[gTs][i].DataRates], 1)
end

function GenericEvaluationOfStockType(evalFunc, bExcludeCurr, bExcludeStock)
	local hTab = {}
	if not bExcludeStock then
		for i, v in pairs(cTabToInvestStock) do
			table.insert(hTab, {v, evalFunc(v, "StockExchange"), 1})
		end
	end
	if not bExcludeCurr then
		for i, v in pairs(cTabToInvestCurrency) do
			table.insert(hTab, {v, evalFunc(v, "StockCurrency"), 2})
		end
	end
	hTab = Shuffle(hTab)
	table.sort(hTab, SortFunctionForGreaterInteger2)
	return hTab;
end

function GetInvestFromPremadeStockTab(premDeTabS)
	local hTab = {}
	for i, v in pairs(premDeTabS) do
		if IsValidStockInvestment(v) then
			table.insert(hTab, v)
		end
	end
	if #hTab > 0 then
		return hTab[LastRandom(1,#hTab)];
	end
end

function GetInvestForAINow(iPlayer, iAIType, bFirstStock, bExcludeAlreadyHadOne)
	if iAIType == 1 then
-- full random
		if (LastRandom(1, 3) == 1) and (#cTabToInvestCurrency > 0) then
			return cTabToInvestCurrency[LastRandom(1,#cTabToInvestCurrency)],2;
		else
			return cTabToInvestStock[LastRandom(1,#cTabToInvestStock)],1;
		end
	elseif iAIType == 2 then
-- very careful, those who rise steadily
		if bFirstStock then
			if LastRandom(1, 2) == 1 then
				local premDeTabS = {1, 11, 15}
				local invest = GetInvestFromPremadeStockTab(premDeTabS);
				if invest then
					return invest, 1;
				end
			end
		else
			local nTab = GenericEvaluationOfStockType(StockEval2Func)
			local cTab = {}
			local hIjo = nTab[1][2];
			for a, b in pairs(nTab) do
				if b[2] == hIjo then
					table.insert(cTab, {b[1], b[3]})
				end
			end
			local key = LastRandom(1,#cTab);
			return cTab[key][1], cTab[key][2];
		end
	elseif iAIType == 3 then
-- great increase followed by recent fall priority
		if GetITGGameTurn() < 30 then
			if LastRandom(1, 2) == 1 then
				local premDeTabS = {2, 4, 10, 14}
				local invest = GetInvestFromPremadeStockTab(premDeTabS);
				if invest then
					return invest, 1;
				end
			end
		else
			local nTab = GenericEvaluationOfStockType(StockEval3Func)
			local cTab = {}
			for a, b in pairs(nTab) do
				if b[2] > 0 then
					table.insert(cTab, {b[1], b[3]})
				end
			end
			if #cTab > 0 then
				local key = math.min(#cTab, LastRandom(1,3))
				return cTab[key][1], cTab[key][2];
			end
		end
	elseif iAIType == 4 then
-- weakest currencies
		local cTab = GenericEvaluationOfStockType(StockEval4Func, false, true)
		if #cTab > 0 then
			local key = math.max(1, #cTab - LastRandom(0, 2));
			return cTab[key][1], cTab[key][3];
		end
	elseif iAIType == 5 then
-- very much premade stock
		local invest = GetMostPremadeInvestStock()
		if invest then
			return invest, 1;
		end
	elseif iAIType == 6 then
-- biggest recent drops (non- currency)
		if bFirstStock then
			if LastRandom(1, 3) == 3 then
				local premDeTabS = {2,4,6,10,12,14,16}
				local invest = GetInvestFromPremadeStockTab(premDeTabS);
				if invest then
					return invest, 1;
				end
			elseif LastRandom(1, 2) == 2 then
				return GetInvestForAINow(iPlayer, 4, bFirstStock);
			end
		else
			local cTab = GenericEvaluationOfStockType(StockEval7Func, true)
			local key = math.max(1, #cTab - LastRandom(0, 3));
			return cTab[key][1], cTab[key][3];
		end
	elseif iAIType == 7 then
-- medium
		if GetITGGameTurn() < 30 then
			if LastRandom(1, 2) == 1 then
				local premDeTabS = {2, 4, 10, 16}
				local invest = GetInvestFromPremadeStockTab(premDeTabS);
				if invest then
					return invest, 1;
				end
			end
		else
			local cTab = GenericEvaluationOfStockType(StockEval7Func)
			local key = math.max(math.floor(#cTab / 2 + LastRandom(0,1) * 0.5), 1) 
			return cTab[key][1], cTab[key][3];
		end
	elseif iAIType == 8 then
--biggest difference to best noted value
		if GetITGGameTurn() < 30 then
			if LastRandom(1, 2) == 1 then
				return GetInvestForAINow(iPlayer, 4, bFirstStock);
			else
				local premDeTabS = {1, 12, 14, 16}
				local invest = GetInvestFromPremadeStockTab(premDeTabS);
				if invest then
					return invest, 1;
				end
			end
		else
			local cTab = GenericEvaluationOfStockType(StockEval8Func)
			local key = math.min(#cTab, LastRandom(1,3))
			return cTab[key][1], cTab[key][3];
		end
	elseif iAIType == 9 then
--based on players flavours :>
		local hTab = {}
		for i, v in pairs(cTabToInvestStock) do
			table.insert(hTab, {v, GetAIFlavour(iPlayer, StockTabG[v].AIFlavour) + LastRandom(0, 2)})
		end
		hTab = Shuffle(hTab)
		table.sort(hTab, SortFunctionForGreaterInteger2)
		return hTab[1][1], 1;
	elseif iAIType == 10 then
--mix of earlier non-random types
		if bFirstStock then
			local tab = {9, 5, 4}
			return GetInvestForAINow(iPlayer, tab[LastRandom(1,#tab)], bFirstStock);
		else
			local tab = {9, 8, 7, 6, 5, 4, 3, 2}
			return GetInvestForAINow(iPlayer, tab[LastRandom(1,#tab)], bFirstStock);
		end
	end
	--AI not decided
	if iAIType ~= 1 then
		return GetInvestForAINow(iPlayer, 1, bFirstStock);
	end
	print("Error 9453242")
end

function GetMostPremadeInvestStock()
	if GetITGGameTurn() < 50 then
	--early invest
		if gT.Globals.ScenarioType == 3 then
			local premDeTabS = {16, 14, 12, 10, 4, 1}
			return GetInvestFromPremadeStockTab(premDeTabS);
		elseif gT.Globals.ScenarioType == 1 then
			local premDeTabS = {16, 15, 14, 12, 10, 4, 1}
			return GetInvestFromPremadeStockTab(premDeTabS);
		else
			local premDeTabS = {16, 15, 14, 12, 4, 1}
			return GetInvestFromPremadeStockTab(premDeTabS);
		end 
	else
	--late game invest
		if gT.Globals.ScenarioType == 3 then
			local premDeTabS = {7, 6, 1}
			return GetInvestFromPremadeStockTab(premDeTabS);
		elseif gT.Globals.ScenarioType == 1 then
			local premDeTabS = {15, 13, 11, 7, 6}
			return GetInvestFromPremadeStockTab(premDeTabS);
		else
			local premDeTabS = {15, 13, 11, 7, 6}
			return GetInvestFromPremadeStockTab(premDeTabS);
		end 
	end
end