function TeamMeetingHandler(team1, team2)
	if bEraConversionNow then
		return;
	end
	--disallow different team setups
	local player1, player2 = team1, team2;
	if player1 > player2 then
		player1 = player2;
		player2 = team1;
	end
	for i, v in pairs(gT.Players) do
		if Players[i]:GetTeam() == team1 then
			PlayerMetTeam(i, team2)
		elseif Players[i]:GetTeam() == team2 then
			PlayerMetTeam(i, team1)
		end
	end
--[[	if (gT.Globals.PeaceLockCount[player1 .. "," .. player2] or 0) > 0 then
		Teams[team1]:SetPermanentWarPeace(team2, true)
	end
	if gT.Globals.ForcedWarRelation[player1 .. "," .. player2] then
		if not Teams[team1]:IsAtWar(team2) then
			if LastRandom(1,2) == 1 then
				Teams[team2]:DeclareWar(team1)
			else
				Teams[team1]:DeclareWar(team2)
			end
		end
	end]]
end
GameEvents.TeamMeet.Add(TeamMeetingHandler)

local techAncCs29 = GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_29
local apacostam1 = GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_39
function PlayerMetTeam(i, team)
	if gT.Players[i] then
		for g, b in pairs(gT.Players) do
			if Players[g]:GetTeam() == team then
				if Players[g]:IsMinorCiv() then
					BasicCSMissionCompleteFunc(i, 13, 1)
					DiploNoteDirty(i, 52)
				end
			end
		end
		if HasPlayerTech(i, techAncCs29, "okewooe") then
			for g, gdata in pairs(gT.Players) do
				if Players[g]:GetTeam() == team then
					if Players[g]:IsMinorCiv() then
						DoMeetCSRevealMap(i, g)
					end
				end
			end
		end
		if gT.Players[i].IsConsideredBarbarian then
			Teams[Players[i]:GetTeam()]:DeclareScriptedWar(team);
		else
			-- peace locks :!
			for g, gdata in pairs(gT.Players) do
				if Players[g]:GetTeam() == team then
					if gdata.WarPeaceLock[i] and (gdata.WarPeaceLock[i] > 0) then
						Teams[Players[i]:GetTeam()]:DeclareScriptedWar(team);
						break;
					end
				end
			end
		end
		if gT.Players[i].HasPlayerWonder[apacostam1] then
			if not Players[i]:IsMinorCiv() then
				for si, v in pairs(Players) do
					if v:GetTeam() == team then
						if v:IsMinorCiv() then
							v:ChangeMinorCivFriendshipWithMajor(i, 50);
						else
							ChangeITGLegalPointsPercent(i, 100)
						end
					end
				end
			end
		end
		if not Teams[team]:IsMinorCiv() then
			VictoryTaskCompletion(i, 51)
		end
		DoAlphabetPlayerMeetTeam(i, team)
	end
end

function ChangePeaceLockCount(iPlayer, jPlayer, amount)
	local l1, l2 = iPlayer, jPlayer;
	if iPlayer > jPlayer then
		l1 = l2;
		l2 = iPlayer;
	end
	local cCurrent = gT.Globals.PeaceLockCount[l1 .. "," .. l2] or 0;
	gT.Globals.PeaceLockCount[l1 .. "," .. l2] = cCurrent + amount;
	if cCurrent == 0 and amount > 0 then
		if Teams[Players[l1]:GetTeam()]:IsAtWar(Players[l2]:GetTeam()) then
			Teams[Players[l1]:GetTeam()]:MakePeace(Players[l2]:GetTeam())
		end
	elseif cCurrent + amount == 0 then
		local prelockrelation = gT.Globals.BaseRelations[l1 .. "," .. l2] or 0;
		if prelockrelation == 0 then
			if not Teams[Players[l1]:GetTeam()]:IsAtWar(Players[l2]:GetTeam()) then
				Teams[Players[l1]:GetTeam()]:DeclareScriptedWar(Players[l2]:GetTeam())
			end
		end
	end
end

function SetPreLockRelation(iPlayer, jPlayer, value)
	local l1, l2 = iPlayer, jPlayer;
	if iPlayer > jPlayer then
		l1 = l2;
		l2 = iPlayer;
	end
	gT.Globals.BaseRelations[l1 .. "," .. l2] = value;
end

function IsHasRelation(iPlayer, jPlayer)
	return gT.Globals.BaseRelations[iPlayer .. "," .. jPlayer] or gT.Globals.BaseRelations[jPlayer .. "," .. iPlayer];
end

function AssignInitialRelations()
--here special code for scenario types
	if gT.Globals.ScenarioType == 2 then
		--1. every muslim nation should met each other
		--2. every christian nation has 55% chance to meet each other
		local mTab = {{}, {}, {}, {}}
		for i, gd in pairs(gT.Players) do
			table.insert(mTab[gd.CultureType - 2], i)
		end
		for i = 1, #mTab[2] -1 do
			local iTeam = Players[mTab[2][i]]:GetTeam();
			for j = i + 1, #mTab[2] do
				local jTeam = Players[mTab[2][j]]:GetTeam();
				if not Teams[iTeam]:IsHasMet(jTeam) then
					Teams[iTeam]:Meet(jTeam);
				end
			end
		end
		for i = 1, #mTab[1] -1 do
			local iTeam = Players[mTab[1][i]]:GetTeam();
			for j = i + 1, #mTab[1] do
				local jTeam = Players[mTab[1][j]]:GetTeam();
				if not Teams[iTeam]:IsHasMet(jTeam) then
					if LastRandom(1, 20) < 12 then
						Teams[iTeam]:Meet(jTeam);
					end
				end
			end
		end
	end
	for g, gdata in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			local mPlayers = {}
			for gj, gjata in pairs(gT.Players) do
				if not Players[gj]:IsMinorCiv() then
					if gj ~= g then
						local modifier = LastRandom(1,10) * 5;
						if LastRandom(1,4) == 3 then
							Players[g]:SetNumITGDiplo(gj, -modifier)
						else
							Players[g]:SetNumITGDiplo(gj, modifier)
						end
						if Teams[Players[g]:GetTeam()]:IsHasMet(Players[gj]:GetTeam()) then
							table.insert(mPlayers, gj)
						end
					end
				end
			end
			if #mPlayers > 0 then
				mPlayers = Shuffle(mPlayers);
				local numembassy = math.floor(#mPlayers / 100 * LastRandom(GetDBCulturePlayerInfo(g,"EmbassyInitMin"), GetDBCulturePlayerInfo(g,"EmbassyInitMax")) + 0.5)
				for i, sth in pairs(mPlayers) do
					if numembassy > 0 then
						if CanHaveInitialRelation(g, sth) then
							numembassy = numembassy - 1;
							PlayerSetEmbasssy(g, sth, true)
						end
					else
						break;
					end
				end
			end
		end
	end
end

function GetCommonCultureAnchorBonus(iMinor, iMajor)
	local b = 0;
	if gT.Players[iMajor].CultureType == gT.Players[iMinor].CultureType then
		b = b + 10 * GetNumGPWithAbility(iMajor, 16);
		if not DBScenario.NoCSCultureAffection then
			b = b + 15;
		end
		if HasPlayerTech(iMajor, GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_12, "GVemlkerf") then
			b = b + 100;
			if gT.Players[iMajor].SubcultureType == gT.Players[iMinor].SubcultureType then
				b = b + 100;
			end
		end
	end
	return b;
end

function GetGPAnchorBonus(iMinor, iMajor)
	return 7 * GetNumGPWithAbility(iMajor, 36);
end

function IsAnThirdPartyAllianceActive(iMinor, iMajor, iInfluenceAnchor)
	if (Players[iMinor]:GetMinorCivFriendshipTreshold() + 5) == iInfluenceAnchor then
		return Players[iMinor]:IsAnchorGrantFriendship(iMajor);
	end
	return false;
end

LuaEvents.ITGSG_RequestCSAnchorAndInfluenceChange.Add(function(iMinor, iMajor, iInfluence, iInfluenceAnchor, iInfluenceChangeThisTurn)
	if not gT then
		return;
	end
	if not gT.Players[iMajor] then
		return;
	end
	local str = "[NEWLINE][NEWLINE]"
	if iInfluenceAnchor >= 0 then
		str = str .. "[ICON_INFLUENCE] Influence resting point: [COLOR_POSITIVE_TEXT]" .. iInfluenceAnchor .. "[ENDCOLOR]."
	else
		str = str .. "[ICON_INFLUENCE] Influence resting point: [COLOR_NEGATIVE_TEXT]" .. iInfluenceAnchor .. "[ENDCOLOR]."
	end
	local tab = {};
	if gT.PoliticVictories[iMinor] and (gT.PoliticVictories[iMinor][iMajor]) then
		table.insert(tab, {gT.PoliticVictories[iMinor][iMajor], "Shared Politics"})
	end
	if gT.RelicInfluence[iMinor] and gT.RelicInfluence[iMinor][iMajor] then
		table.insert(tab, {gT.RelicInfluence[iMinor][iMajor], "Relics Found"})
	end
	table.insert(tab, {(gT.Players[iMajor].Ideo88Anchor or 0), "Soil of the Earth"})
	table.insert(tab, {GetCommonCultureAnchorBonus(iMinor, iMajor), "Shared Culture"})
	if gT.Globals.TechFirstTeams[GameInfoTypes.TECH_UNIQUE_ITG_INDUSTRIAL_7] == iMajor then
		table.insert(tab, {MINOR_CIV_ANCHOR_FASCISM, "Fascism"})
	end
	table.insert(tab, {GetGPAnchorBonus(iMinor, iMajor), "Great People"})
	table.insert(tab, {gT.Players[iMajor].AnchorPenaltyLog[iMinor] or 0, "Unhonourable Actions"})
	if gT.Players[iMajor].HasIdeology[84] then
		table.insert(tab, {50, "World Leadership"})
	end
	if Players[iMinor]:IsProtectedByMajor(iMajor) then
		local eAFP = 0;
		for i, v in pairs(gT.Players[iMajor].PledgesOfProtection) do
			if v[1] == iMinor then
				if v[3] then
					eAFP = eAFP + CS_ANCHOR_FROM_PROTECTION
				end
			end
		end
		if gT.Players[iMajor].CultBonusOn[31] then
			eAFP = eAFP + 100;
		end
		table.insert(tab, {eAFP, "Protection"})
	end
	if gT.Players[iMinor].FreeCityState then
		table.insert(tab, {gT.Players[iMinor].FreeCityState[iMajor] or 0, "Free City-State"})
	end
	table.insert(tab, {gT.Players[iMajor].ExtraCityStateAnchor[iMinor] or 0, "Innovations"})
	table.insert(tab, {(gT.Players[iMajor].GovMinorAnchor[iMinor] or 0), "Shared Goverment"})
	for i, v in pairs(tab) do
		if v[1] > 0 then
			str = str .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]+" ..  v[1] .. "[ENDCOLOR] from " .. v[2] .. ".";
		elseif v[1] < 0 then
			str = str .. "[NEWLINE][ICON_BULLET][COLOR_NEGATIVE_TEXT]" ..  v[1] .. "[ENDCOLOR] from " .. v[2] .. ".";
		end
	end
	if IsAnThirdPartyAllianceActive(iMinor, iMajor, iInfluenceAnchor) then
		str = str .. "[NEWLINE][ICON_BULLET]Anchor is increased to [COLOR_POSITIVE_TEXT]" .. iInfluenceAnchor .. "[ENDCOLOR] (Third-party alliance).";
	end
	if iInfluenceChangeThisTurn < 0 then
		str = str .. "[NEWLINE][NEWLINE][ICON_INFLUENCE] Influence drops by [COLOR_NEGATIVE_TEXT]" .. -iInfluenceChangeThisTurn .. "[ENDCOLOR] each turn."
		tab = {}
		table.insert(tab, {gT.Players[iMajor].GovMinorDecay[iMinor] or 0, "Goverment"})
		table.insert(tab, {GetMinorEnemyDiplomats(iMinor, iMajor) * DIPLOMAT_RIVAL_RATE_MOD, "Rival Diplomats"})
		if HasMinorDiplomat(iMinor, iMajor) then
			table.insert(tab, {-DIPLOMAT_YOUR_RATE_MOD, "Diplomat"})
		end
		table.insert(tab, {GetWarmongerLeagueEffect(iMajor), "League (denounced Warmonger)"})
		if not DBScenario.NoCSCultureAffection then
			if gT.Players[iMinor].CultureType ~= gT.Players[iMajor].CultureType then
				table.insert(tab, {25, "different Cultures"})
			end
		end
		if gT.Players[iMinor].StAlphabet == iMajor then
			table.insert(tab, {-ALPHABET_INFLUENCE_MOD, "Shared Alphabet"})
		end
		if (gT.Players[iMajor].CultBonusOn[87]) and (Players[iMinor]:GetAlly() == iMajor) then
			table.insert(tab, {-50, "Oath"})
		end
		if (gT.Players[iMajor].LeagueCityStatesDecay[iMinor] or 0) > 0 then
			table.insert(tab, {-20, "shared League"})
		end
		if HasPlayerTech(iMajor, GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_ARAB_8, "kokeoroe") then
			table.insert(tab, {-10, "Grand Sultan"})
		end
		if gT.Globals.TechFirstTeams[GameInfoTypes.TECH_UNIQUE_ITG_INDUSTRIAL_17] == iMajor then
			table.insert(tab, {-20, "Psychology"})
		end
		str = str .. GetBaseHostilityDropMinor(iMinor, iMajor)
		for i, v in pairs(tab) do
			if v[1] > 0 then
				str = str .. "[NEWLINE][ICON_BULLET][COLOR_NEGATIVE_TEXT]+" ..  v[1]  .. "%[ENDCOLOR] from " .. v[2] .. ".";
			elseif v[1] < 0 then
				str = str .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]" ..  v[1]  .. "%[ENDCOLOR] from " .. v[2] .. ".";
			end
		end
	--add influence changes	
	elseif iInfluenceChangeThisTurn > 0 then
		str = str .. "[NEWLINE][NEWLINE][ICON_INFLUENCE] Influence rises by [COLOR_POSITIVE_TEXT]" .. iInfluenceChangeThisTurn .. "[ENDCOLOR] each turn."
		tab = {}
		table.insert(tab, {gT.Players[iMajor].GovMinorRecovery[iMinor] or 0, "Goverment"})
		table.insert(tab, {GetMinorEnemyDiplomats(iMinor, iMajor) * -DIPLOMAT_RIVAL_RATE_MOD, "Rival Diplomats"})
		if HasMinorDiplomat(iMinor, iMajor) then
			table.insert(tab, {DIPLOMAT_YOUR_RATE_MOD, "Diplomat"})
		end
		if not DBScenario.NoCSCultureAffection then
			if gT.Players[iMinor].CultureType ~= gT.Players[iMajor].CultureType then
				table.insert(tab, {-25, "Different Cultures"})
			end
		end
		if gT.Players[iMinor].StAlphabet == iMajor then
			table.insert(tab, {ALPHABET_INFLUENCE_MOD, "shared Alphabet"})
		end		
		if HasPlayerTech(iMajor, GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_12, "gtrvfe") then
			if gT.Players[iMajor].CultureType == gT.Players[iMinor].CultureType then
				if gT.Players[iMajor].SubcultureType == gT.Players[iMinor].SubcultureType then
					table.insert(tab, {200 ,"shared Culture"})
				else
					table.insert(tab, {100 ,"shared Culture"})
				end
			end
		end
		if gT.Players[iMajor].HasIdeology[84] then
			table.insert(tab, {100, "World Leadership"})
		end
		if gT.Globals.TechFirstTeams[GameInfoTypes.TECH_UNIQUE_ITG_INDUSTRIAL_17] == iMajor then
			table.insert(tab, {20, "Psychology"})
		end
		table.insert(tab, {- GetWarmongerLeagueEffect(iMajor), "League (denounced Warmonger)"})
	--add influence changes
		local tabOfArtificialIncreases = {};
		local extraUp = 0;
		if Players[iMinor]:CanMajorBullyGold(iMajor, true) then
			local rise = GetAfraidInfluenceModPolicies(iMajor)
			if rise > 0 then
				table.insert(tabOfArtificialIncreases, {rise/100, "them being Afraid"});
			end
		end
		for i, v in pairs(tabOfArtificialIncreases) do
			extraUp = extraUp + v[1];
		end
		if extraUp < iInfluenceChangeThisTurn then
			str = str .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]1[ENDCOLOR] Base Increase.";
		else
			str = str .. GetBaseHostilityDropMinor(iMinor, iMajor)
		end
		for i, v in pairs(tab) do
			if v[1] > 0 then
				str = str .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]+" ..  v[1] .. "%[ENDCOLOR] from " .. v[2] .. ".";
			elseif v[1] < 0 then
				str = str .. "[NEWLINE][ICON_BULLET][COLOR_NEGATIVE_TEXT]" ..  v[1]  .. "%[ENDCOLOR] from " .. v[2] .. ".";
			end
		end
		for i, v in pairs(tabOfArtificialIncreases) do
			if v[1] > 0 then
				str = str .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]" .. v[1] .. "[ENDCOLOR] extra from " .. v[2] .. ".";
			end
		end
	end
	MapModData.ITGSG = str;
end)

function GetBaseHostilityDropMinor(iMinor, iMajor)
	local s = "[NEWLINE][ICON_BULLET][COLOR_NEGATIVE_TEXT]"
	if Players[iMinor]:GetPersonality() == MinorCivPersonalityTypes.MINOR_CIV_PERSONALITY_HOSTILE then
		s = s .. "1.5"
	elseif Teams[Players[iMajor]:GetTeam()]:IsMinorCivAggressor() then
		s = s .. "2"
	else
		s = s .. "1"
	end
	s = s .. "[ENDCOLOR] Base Decay.";
	return s;
end

function GetAfraidInfluenceModPolicies(iMajor)
	return Players[iMajor]:GetMinorAfraidPerTurnInfluence();
end

GameEvents.UnitMeetCiv.Add(function(iPlayer, unitID, sTeam, sPlayer, sUnitID, iTeam)
--note: it fires before Team::Meet
	if (not gT) then
		return;
	end
	if iPlayer ~= -1 then
		UnitMetTeam(iPlayer, Players[iPlayer]:GetUnitByID(unitID), sTeam)
	end
	if sUnitID ~= -1 then
		UnitMetTeam(sPlayer, Players[sPlayer]:GetUnitByID(sUnitID), iTeam)
	end
end)

function UnitMetTeam(iPlayer, iUnit, sTeam)
	if not gT.Players[iPlayer] then
		return;
	end
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_TRIBE_18, "Vkadefe") then
		if iUnit:GetUnitClassType() == GameInfoTypes.UNITCLASS_SCOUT then
			if Players[iPlayer]:GetNumUnitsSupplied() >= Players[iPlayer]:GetNumUnitsToSupply() then
				local numToSpawn = 4;
				local cPlot = iUnit:GetPlot();
				if Teams[sTeam]:IsMinorCiv() then
					numToSpawn = 2;
				end
				for i = 1, numToSpawn do
					local hUnit = SimpleGenerateUnitOfType(iPlayer, GetRandomUnitTypeOfDomain(iPlayer, "DOMAIN_LAND"), cPlot)
					if hUnit then
						SetUnitForcedStackType(hUnit, -1, "Tribe18", 8);
					end
				end
			end
		end
	end
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_13, "gefwbhh") then
		if gT.Players[iPlayer].UnitClassXP[iUnit:GetUnitClassType()] then
			if Teams[sTeam]:IsMinorCiv() then
				iUnit:ChangeExperience(15);
			else
				iUnit:ChangeExperience(30);
			end
		end
	end
end