local bHalfClassAdapt = {GameInfoTypes.BUILDINGCLASS_ITG_NEW_WORLD_WONDER_7};
local techPhilosophy = GameInfoTypes.TECH_PHILOSOPHY;
local abusimbel1 = GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_21;
local HelpLocalizeText = {
["AcadPointsPerTurn"] = "TXT_KEY_TBT_SIMPLY_ACADEMY_DEVELOP",
["ArchaFromTech"] = "TXT_KEY_TBT_SIMPLE_ARCHAEOLOGY",
["ExtraWorkboats"] = "TXT_KEY_TBT_SIMPLE_EXTRA_WORKBOAT",
["FaithFromTech"] = "TXT_KEY_TBT_SIMPLE_FAITH",
["FortPowerFromTech"] = "TXT_KEY_TBT_SIMPLE_FORT_STRENGTH",
["GoldFromTech"] = "TXT_KEY_TBT_SIMPLE_GOLD",
["GPPfromTech"] = "TXT_KEY_TBT_SIMPLE_GREATPEOPLE",
["HealthFromTech"] = "TXT_KEY_TBT_SIMPLE_HEALTH",
["MeritocracyFromTech"] = "TXT_KEY_TBT_SIMPLE_MERITOCRACY",
["PrestigePerTurn"] = "TXT_KEY_TBT_SIMPLE_PRESTIGE",
["ProdFromTech"] = "TXT_KEY_TBT_SIMPLE_PRODUCTION",
["ScienceFromTech"] = "TXT_KEY_TBT_SIMPLE_SCIENCE",
["WonderFromTech"] = "TXT_KEY_TBT_SIMPLE_WONDER_POINTS",
["WorkFromTech"] = "TXT_KEY_TBT_SIMPLE_WORKRATE",
}
local lTechStrengthBonus = {}
LuaEvents.ITG_DB_Initialized.Add(function()
	lTechStrengthBonus = {}
	for row in DB.Query("SELECT TechType, Value FROM ITG_ScenarioTechDefense WHERE ScenarioType = '" .. DBScenario.Type .. "'") do
		lTechStrengthBonus[GameInfo.Technologies[row.TechType].ID] = row.Value;
	end
end)

--1: GP
--2: great impro / festival
	--1. Academy
	--2. Manufactory
	--3. Customs House
	--4. Festival
--3: special points
--4: inspiration
-- this never affect minor players
local freebiesFromTechs = {
[GameInfoTypes.TECH_ARCHITECTURE] = {{4, GameInfoTypes.BUILDINGCLASS_MONUMENT, 1}},
[GameInfoTypes.TECH_BANKING] = {{1, 5, 1, nil, 3}},
[GameInfoTypes.TECH_CHIVALRY] = {{3, "NumFortPoints", 2}},
--[GameInfoTypes.TECH_CURRENCY] = {},
[GameInfoTypes.TECH_DRAMA] = {{2, 4, 2}},
[GameInfoTypes.TECH_EDUCATION] = {{1, 3, 1, nil, 3}},
--[GameInfoTypes.TECH_INDUSTRIALIZATION] = {,
[GameInfoTypes.TECH_MACHINERY] = {{3, "NumFortPoints", 2}},
--[GameInfoTypes.TECH_METAL_CASTING] = {},
[GameInfoTypes.TECH_NAVIGATION] = {{3, "FeitoriaCharges", 1}},
[GameInfoTypes.TECH_PHILOSOPHY] = {{1, 9, 3}},
[GameInfoTypes.TECH_PHYSICS] = {{3, "NumFortPoints", 1, 2}, {2, 2, 2}},
--[GameInfoTypes.TECH_SCIENTIFIC_THEORY] = {},
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_2] = {{1, 7}},
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_3] = {{1, 3}},
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_10] = {{2, 2}},
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_24] = {{2, 4}},
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_EMPIRE_1] = {{2, 2}},
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_EMPIRE_2] = {{2, 2}},
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_EMPIRE_10] = {{4, GameInfoTypes.BUILDINGCLASS_COURTHOUSE}},
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_EMPIRE_16] = {{4, GameInfoTypes.BUILDINGCLASS_GRANARY}},
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_EMPIRE_17] = {{4, GameInfoTypes.BUILDINGCLASS_COLOSSEUM}},
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_EMPIRE_18] = {{1, 5}},
[GameInfoTypes.TECH_UNIQUE_ITG_MEDIEVAL_AFR_4] = {{2, 3}},
[GameInfoTypes.TECH_UNIQUE_ITG_INDUSTRIAL_10] = {{4, GameInfoTypes.BUILDINGCLASS_CASTLE}, {4, GameInfoTypes.BUILDINGCLASS_BANK}},
[GameInfoTypes.TECH_UNIQUE_ITG_MODERN_21] = {{3, "NumFortPoints"}, {4, GameInfoTypes.BUILDINGCLASS_MILITARY_BASE}},
[GameInfoTypes.TECH_UNIQUE_ITG_MODERN_23] = {{1, 4}},
[GameInfoTypes.TECH_UNIQUE_ITG_MODERN_24] = {{4, GameInfoTypes.BUILDINGCLASS_HOSPITAL}},
[GameInfoTypes.TECH_UNIQUE_ITG_MODERN_26] = {{4, GameInfoTypes.BUILDINGCLASS_AIRPORT}},
[GameInfoTypes.TECH_UNIQUE_ITG_MODERN_28] = {{1, 5}, {4, GameInfoTypes.BUILDINGCLASS_STOCK_EXCHANGE}},
[GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_ARAB_2] = {{2, 3}},
[GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_ARAB_5] = {{1, 3}},
[GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_ASIA_6] = {{4, GameInfoTypes.BUILDINGCLASS_GARDEN}},
[GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_EUROPE_3] = {{3, "FeitoriaCharges"}},
[GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_EUROPE_5] = {{2, 1}, {2, 2}, {2, 3}},
[GameInfoTypes.TECH_UNIQUE_ITG_NW_TROPICAL_5] = {{3, "FeitoriaCharges"}},
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_ARABIA_1] = {{1, 3}, {4, GameInfoTypes.BUILDINGCLASS_LIBRARY}},
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_ARABIA_7] = {{1, 9}},
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_ASIA_1] = {{1, 3}},
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_EURO_4] = {{4, GameInfoTypes.BUILDINGCLASS_STABLE}},
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_EURO_5] = {{4, GameInfoTypes.BUILDINGCLASS_FORGE}},
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_HORDE_2] = {{3, "NumFortPoints"}},
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_HORDE_6] = {{1, 4}},
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_PAGAN_7] = {{1, 4}},
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_VIKING_8] = {{1, 7}},
}

local TechForceResReveal = {[1] = {},
[2] = {[GameInfoTypes.TECH_CHIVALRY] = {rHorse}},
[3] = {},
[4] = {},
[5] = {},
[6] = {},
[7] = {[GameInfoTypes.TECH_ANIMAL_HUSBANDRY] = {rHorse}},
[8] = {[GameInfoTypes.TECH_ANIMAL_HUSBANDRY] = {rHorse}},
[9] = {[GameInfoTypes.TECH_ANIMAL_HUSBANDRY] = {rHorse}},
[10] = {[GameInfoTypes.TECH_UNIQUE_ITG_INDUSTRIAL_11] = {rOil}},
[11] = {},
}

local basicValfromTechs = {
[GameInfoTypes.TECH_ARCHAEOLOGY] = {{10, "ArchaFromTech"}},
[GameInfoTypes.TECH_ARCHITECTURE] = {{2, "GPPfromTech"}},
[GameInfoTypes.TECH_BALLISTICS] = {{3, "FortPowerFromTech", 5}},
[GameInfoTypes.TECH_CALENDAR] = {{5, "WorkFromTech", 3}},
[GameInfoTypes.TECH_CONSTRUCTION] = {{1, "FortPowerFromTech", 3}},
[GameInfoTypes.TECH_COMBINED_ARMS] = {{3, "FortPowerFromTech", 5}},
[GameInfoTypes.TECH_COMBUSTION] = {{1, "ExtraWorkboats", 5}},
[GameInfoTypes.TECH_COMPUTERS] = {{20, "AcadPointsPerTurn", 5}},
[GameInfoTypes.TECH_CHEMISTRY] = {{1, "HealthFromTech"}, {4, "ScienceFromTech"}, {5, "PrestigePerTurn", 1}, {5, "AcadPointsPerTurn", 1}, {1, "FortPowerFromTech", 1}},
[GameInfoTypes.TECH_CIVIL_SERVICE] = {{1, "HealthFromTech"}, {10, "WorkFromTech"}, {1, "MeritocracyFromTech", 2}},
[GameInfoTypes.TECH_CHIVALRY] = {{1, "MeritocracyFromTech"}, {1, "FortPowerFromTech", 2}},
[GameInfoTypes.TECH_CURRENCY] = {{5, "GoldFromTech", 2}, {2, "GoldFromTech", 3}},
--[GameInfoTypes.TECH_DRAMA] = {{3, "CultureFromTech", 2}},
[GameInfoTypes.TECH_DYNAMITE] = {{2, "FortPowerFromTech", 4}},
[GameInfoTypes.TECH_ECOLOGY] = {{1, "MeritocracyFromTech"}},
[GameInfoTypes.TECH_EDUCATION] = {{5, "PrestigePerTurn", 2}, {5, "AcadPointsPerTurn", 2}},
[GameInfoTypes.TECH_ELECTRICITY] = {{2, "ProdFromTech"}, {1, "MeritocracyFromTech"}},
[GameInfoTypes.TECH_ENGINEERING] = {{15, "WorkFromTech", 3}, {2, "ProdFromTech", nil, 8}, {3, "ProdFromTech", nil, 6}, {1, "MeritocracyFromTech", nil, 6}, {1, "FortPowerFromTech", 2}},
[GameInfoTypes.TECH_ECONOMICS] = {{1, "MeritocracyFromTech"}},
[GameInfoTypes.TECH_FERTILIZER] = {{10, "WorkFromTech", 4}},
[GameInfoTypes.TECH_GUNPOWDER] = {{1, "FortPowerFromTech", 1}},
[GameInfoTypes.TECH_INDUSTRIALIZATION] = {{2, "FortPowerFromTech", 4}},
[GameInfoTypes.TECH_MACHINERY] = {{1, "MeritocracyFromTech", nil, 6}},
[GameInfoTypes.TECH_MASONRY] = {{1, "FortPowerFromTech", 3}},
[GameInfoTypes.TECH_MATHEMATICS] = {{4, "ScienceFromTech", 3}, {2, "ScienceFromTech", nil, 6}},
[GameInfoTypes.TECH_METAL_CASTING] = {{1, "FortPowerFromTech", 2}},
[GameInfoTypes.TECH_MINING] = {{5, "WorkFromTech", 3}},
[GameInfoTypes.TECH_OPTICS] = {{1, "HealthFromTech"}},
[GameInfoTypes.TECH_PENICILIN] = {{5, "HealthFromTech"}},
[GameInfoTypes.TECH_PHILOSOPHY] = {{1, "MeritocracyFromTech"}},
[GameInfoTypes.TECH_PHYSICS] = {{5, "PrestigePerTurn", 2}, {5, "AcadPointsPerTurn", 2}},
[GameInfoTypes.TECH_PLASTIC] = { {2, "ProdFromTech"}},
[GameInfoTypes.TECH_PRINTING_PRESS] = {{4, "ScienceFromTech"}, {4, "GPPfromTech", 1}},
--[GameInfoTypes.TECH_RADIO] = {},
[GameInfoTypes.TECH_RAILROAD] = { {10, "WorkFromTech"}},
[GameInfoTypes.TECH_ROCKETRY] = {{3, "FortPowerFromTech", 5}},
[GameInfoTypes.TECH_REFRIGERATION] = {{1, "ExtraWorkboats", 5}},
[GameInfoTypes.TECH_SAILING] = {{1, "ExtraWorkboats", 3}},
[GameInfoTypes.TECH_SCIENTIFIC_THEORY] = {{5, "PrestigePerTurn", 4}},
[GameInfoTypes.TECH_WRITING] = {{1, "HealthFromTech"}},
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_EMPIRE_2] = {{5, "WonderFromTech"}},
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_EMPIRE_7] = {{2, "FortPowerFromTech"}},
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_8] = {{20, "WorkFromTech"}},
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_11] = {{10, "WorkFromTech"}},
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_17] = {{1, "HealthFromTech"}, {1, "MeritocracyFromTech"}},
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_TRIBE_20] = {{10, "WorkFromTech"}},
[GameInfoTypes.TECH_UNIQUE_ITG_INDUSTRIAL_2] = {{1, "HealthFromTech"}},
[GameInfoTypes.TECH_UNIQUE_ITG_INDUSTRIAL_9] = {{8, "ArchaFromTech"}},
[GameInfoTypes.TECH_UNIQUE_ITG_INDUSTRIAL_16] = {{1, "HealthFromTech"}},
[GameInfoTypes.TECH_UNIQUE_ITG_INDUSTRIAL_17] = {{1, "HealthFromTech"}},
[GameInfoTypes.TECH_UNIQUE_ITG_INDUSTRIAL_19] = {{2, "FortPowerFromTech"}},
[GameInfoTypes.TECH_UNIQUE_ITG_MODERN_21] = {{4, "FortPowerFromTech"}},
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_ARABIA_4] = {{3, "HealthFromTech"}},
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_ASIA_3] = {{2, "HealthFromTech"}},
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_HORDE_1] = {{1, "MeritocracyFromTech"}},
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_HORDE_3] = {{10, "GoldFromTech"}},
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_PAGAN_2] = {{5, "FaithFromTech"}},
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_PAGAN_4] = {{3, "MeritocracyFromTech"}},
}

local gResourcesOnTech = {
[GameInfoTypes.TECH_ANIMAL_HUSBANDRY] = {{Res = rHorse, Amount = 1, Scenario = 3, CS = false}},
[GameInfoTypes.TECH_ATOMIC_THEORY] = {{Res = rUran, Amount = 3, Scenario = 5, CS = false}},
[GameInfoTypes.TECH_INDUSTRIALIZATION] = {{Res = rCoal, Amount = 50, Scenario = 4, CS = false, Storage = true}},
[GameInfoTypes.TECH_IRON_WORKING] = {{Res = rIron, Amount = 1, Scenario = 3, CS = false}},
[GameInfoTypes.TECH_METALLURGY] = {{Res = rIron, Amount = 2, Scenario = 4, CS = false, IfBelow20 = true}},
[GameInfoTypes.TECH_RAILROAD] = {{Res = rCoal, Amount = 3, Scenario = 5, CS = false}},
[GameInfoTypes.TECH_REFRIGERATION] = {{Res = rOil, Amount = 4, Scenario = 5, CS = false}},
}

function GetNewlineIfNotNilString(hString, aString)
	if hString == "" then
		return aString
	end
	return hString .. "[NEWLINE]" .. aString;
end

function GetTechButtonMoreInfo(iTech, iScenario, iCultureType, iSubCultureType)
	-- for now basicValfromTechs supported
	local tab = {}
	local techType = GameInfo.Technologies[iTech].Type;
	local hString = "";
	local iPlayer = Game.GetActivePlayer();
	if basicValfromTechs[iTech] then
		for i, v in pairs(basicValfromTechs[iTech]) do
			if (not v[3]) or (v[3] == iScenario) then
				if (not v[4]) or (v[4] == iCultureType) then
					if HelpLocalizeText[v[2]] then
						if hString ~= "" then
							hString = hString .. "[NEWLINE]" .. Locale.ConvertTextKey(HelpLocalizeText[v[2]], v[1])
						else
							hString = Locale.ConvertTextKey(HelpLocalizeText[v[2]], v[1])
						end
					else
						print("Missing tech button text for: ", v[2])
					end
				end
			end
		end
	end
	if lTechStrengthBonus[iTech] then
		if hString ~= "" then
			hString = hString .. "[NEWLINE]" .. Locale.ConvertTextKey("TXT_KEY_TECHBI_CITY_STRENGTH", lTechStrengthBonus[iTech] / 100)
		else
			hString = Locale.ConvertTextKey("TXT_KEY_TECHBI_CITY_STRENGTH", lTechStrengthBonus[iTech] / 100)
		end
	end
	if GetDBSubCultureInfo(iCultureType, iSubCultureType, "ReformationTech") == techType then
		table.insert(tab, Locale.Lookup("TXT_KEY_TECHBI_ALLOWS_REFORMING_RELIGION"))
	end
	if GetDBSubCultureInfo(iCultureType, iSubCultureType, "TechCultureStyles") == techType then
		table.insert(tab, Locale.Lookup("TXT_KEY_TECHBI_LAST_ART_STYLES"))
	end
	for a, b in pairs(GetTechButtonUnlockLegalAction(iTech)) do
		table.insert(tab, b)
	end
	local fString = "";
	local inspString = "";
	for i, v in pairs(freebiesFromTechs[iTech] or {}) do
		if (not v[3]) or (v[3] == iScenario) then
			if (not v[4]) or (v[4] == iCultureType) then
				if (not v[5]) or (v[5] == iSubCultureType) then
					if v[1] == 1 then
						fString = GetNewlineIfNotNilString(fString, "Free " .. GetNiceGPString(v[2]) .. ".")
					elseif v[1] == 2 then
						if v[2] == 1 then
							fString = GetNewlineIfNotNilString(fString, "Free [ICON_ITG_ACADEMY_1] Academy.")
						elseif v[2] == 2 then
							fString = GetNewlineIfNotNilString(fString, "Free [ICON_ITG_MANUFACTORY] Manufactory. Maintenance cost of Manufactories is adequately reduced.")
						elseif v[2] == 3 then
							fString = GetNewlineIfNotNilString(fString, "Free [ICON_ITG_CUSTOMS_HOUSE] Customs House.")
						elseif v[2] == 4 then
							fString = GetNewlineIfNotNilString(fString, "Free [ICON_ITG_FESTIVAL] Festival.")
						end
					elseif v[1] == 3 then
						if v[2] == "NumFortPoints" then
							fString = GetNewlineIfNotNilString(fString, "Free Fort.")
						elseif v[2] == "FeitoriaCharges" then
							fString = GetNewlineIfNotNilString(fString, "Free Feitoria.")
						end
					elseif v[1] == 4 then
						inspString = GetNewlineIfNotNilString(inspString, "Grants Inspiration to " .. GetBuildingClassBestString(iPlayer, v[2]) ..  ".")
					end
				end
			end
		end
	end
	if hString ~= "" then
		table.insert(tab, hString)
	end
	local resString = ""
	for hij, resData in pairs(gResourcesOnTech[iTech] or {}) do
		if (not resData.Scenario) or (resData.Scenario == gT.Globals.ScenarioType) then
			local resName = GameInfo.Resources[resData.Res].IconString .. " " .. Locale.Lookup(GameInfo.Resources[resData.Res].Description);
			if resString ~= "" then
				resString = resString .. "[NEWLINE]";
			end
			if resData.IfBelow20 then
				resString = resString .. "Generates " .. resData.Amount / RES_IRON_HORSE_GEN_RATIO .. " " .. resName .. " per turn if you have less than 20 " .. resName .. " stored.";
			elseif resData.Storage then
				resString = resString .. "+" .. resData.Amount .. " " .. resName .. ".";	
			else
				resString = resString .. resData.Amount .. " " .. resName .. ".";
			end
		end
	end
	local tabWithIcons = {};
	tabWithIcons = GetTechRelatedToBudget(iTech, tabWithIcons)
	if inspString ~= "" then
		table.insert(tabWithIcons, {inspString, "ITG_SMALL_TECH_BUTTONS_ATLAS", 14});
	end
	if fString ~= "" then
		table.insert(tabWithIcons, {fString, "ITG_SMALL_TECH_BUTTONS_ATLAS", 15});
	end
	if resString ~= "" then
		table.insert(tabWithIcons, {resString, "ITG_SMALL_TECH_BUTTONS_ATLAS", 16});
	end
	MapModData.ITGSG = {tab, tabWithIcons};
end
LuaEvents.ITG_TechButtonMoreInfo.Add(GetTechButtonMoreInfo)

local TechGrantingPassageOcean = {
[GameInfoTypes.TECH_ASTRONOMY] = {[1] = 1, [2] = 1, [10] = 1, [11] = 1},
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_ARABIA_5] = {[4] = 1},
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_VIKING_3] = {[6] = 1},
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_16] = {[8] = 1},
}
local MissionaryGrantingTechs = 
{
[GameInfoTypes.TECH_THEOLOGY] = 1
}
local GlobalSettlingTechs = 
{
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_VIKING_3] = 1,
[GameInfoTypes.TECH_ASTRONOMY] = 1,
}
local FakeDummyTechs = {
[GameInfoTypes.TECH_ITG_DUMMY_WONDER_PRE_49] = 1,
[GameInfoTypes.TECH_ITG_WATER_ALL_PASSAGE] = 1,
}
function SetCanGlobalSettling(iPlayer)
	gT.Players[iPlayer].SettlingGlobally = CanGlobalSettling(iPlayer)
end
local RailroadGrantingTech = {
[GameInfoTypes.TECH_DYNAMITE] = 1,
}
function SetCanDoRailrod(iPlayer)
	gT.Players[iPlayer].CanDoRailroad = CanMakeRailroads(iPlayer)
end

function CanMakeRailroads(iPlayer)
	for tech, sth in pairs(RailroadGrantingTech) do
		if HasPlayerTech(iPlayer, tech, "oo34r535kede") then
			return true;
		end
	end
	return false
end

function CanGlobalSettling(iPlayer)
	for tech, sth in pairs(GlobalSettlingTechs) do
		if HasPlayerTech(iPlayer, tech, "ookede") then
			return true;
		end
	end
	return false
end

local techFakeEmbarkedAllWaters = GameInfoTypes.TECH_ITG_WATER_ALL_PASSAGE;
function SetOceanPassingTech(iPlayer) 
	local bHas = HasPlayerTech(iPlayer, techFakeEmbarkedAllWaters, "kveedad")
	local bShould = ShouldHaveOceanPassage(iPlayer)
	if bHas and (not bShould) then
		Teams[Players[iPlayer]:GetTeam()]:SetHasTech(techFakeEmbarkedAllWaters, false)
	elseif bShould and (not bHas) then
		Teams[Players[iPlayer]:GetTeam()]:SetHasTech(techFakeEmbarkedAllWaters, true, nil, nil, false)
	end
end

function SetCanUseMissionares(iPlayer)
	gT.Players[iPlayer].CanUseMissionaries = CanUseMissionares(iPlayer)
end

function CanUseMissionares(iPlayer)
	local gType = gT.Players[iPlayer].CultureType;
	if gT.Globals.ScenarioType == 4 then
		return false;
	end
	for i, v in pairs(MissionaryGrantingTechs) do
		if HasPlayerTech(iPlayer, i, "Vadadekde") then
			gT.Players[iPlayer].NoMoreHolySites = true;
			return true;
		end
	end
	if gT.Players[iPlayer].HasPlayerWonder[abusimbel1] then
		return true;
	end
	return false;
end

function ShouldHaveOceanPassage(iPlayer)
	local gType = gT.Players[iPlayer].CultureType;
	for i, v in pairs(TechGrantingPassageOcean) do
		if v[gType] then
			if HasPlayerTech(iPlayer, i, "Vadadekde") then
				return true;
			end
		end
	end
	return false;
end

GameEvents.TeamSetHasTech.Add(function(iTeam, iTech, bNewValue)
	if not bNewValue then
		return;
	end
	if FakeDummyTechs[iTech] then
		return;
	end
	local tTech = GameInfo.Technologies[iTech];
	if (not tTech.IsInnovation) and tTech.Show then
		for gplayer, gdata in pairs(gT.Players) do
			local hasHalfScienceAdapt = false;
			for i, bclass in pairs(bHalfClassAdapt) do
				if Players[gplayer]:GetBuildingClassCount(bclass) > 0 then
					hasHalfScienceAdapt = true;
					break
				end
			end
			if hasHalfScienceAdapt then
				if Players[gplayer]:GetTeam() ~= iTeam then
					if not Teams[Players[gplayer]:GetTeam()]:IsHasTech(iTech) then
						DoPorcelainCheck(Players[gplayer]:GetTeam(), iTech, gplayer)
					end
				end
			end
		end
	end
	for gplayer, gdata in pairs(gT.Players) do
		if Players[gplayer]:GetTeam() == iTeam then
			if (not gT.Globals.GlobalizationTech) or (gT.Globals.GlobalizationTech[iTech] ~= -99) then
				TechInnoDiscoveredAcademyPrestige(gplayer, iTech, iTeam)
			end
			if not gT.Globals.TechFirstCiv then
				if gT.Globals.GameGenerated then
					gT.Globals.TechFirstCiv[iTech] = gplayer;
					PlayerDiscoveredTechFirst(gplayer, iTech)
				else
					gT.Globals.TechFirstCiv[iTech] = -1;
				end
			end
			if gT.Globals.GlobalizationTech then
				CheckForExistingInnoGlobalization(gplayer)
			end
			if gT.Globals.GameGenerated then
				if #GetValidTableOfTechs(gplayer, true) == 0 then
					if not gT.Players[gplayer].TechTreeCompleted then
						gT.Players[gplayer].TechTreeCompleted = GetITGGameTurn();
						if Players[gplayer]:IsHuman() then
							LuaEvents.ITG_AchievementCompleted(23)
						end
					end
				end
			end
			if Players[gplayer]:IsMinorCiv() then
				if GameInfo.Technologies[iTech].IsInnovation then
					print("Minor acquired innovation.", iTech, gplayer, Players[gplayer]:IsTurnActive())
				end
			end
			OnSetHasTechCheckForUnlockedBuildings(gplayer, iTech)
			OnSetHasTechCheckForUnlockedUnits(gplayer, iTech)
			DoAddRemoveTechEffect(gplayer, iTech, 1, true, 0)
			DiploNoteDirty(gplayer, 36)
		end
	end
end)

function GetNumInnoKnownBySecondPlayerOnly(iTeam, dTeam)
	local a = 0;
	for row in GameInfo.Technologies() do
		if row.IsInnovation then
			if dTeam:IsHasTech(row.ID) and (not iTeam:IsHasTech(row.ID)) then
				a = a + 1;
			end
		end
	end
	return a;
end

function GetUnknownValidTechs(dPlayer, iPlayer, bTradeRoutes)
	local dTeam, iTeam = Teams[Players[dPlayer]:GetTeam()], Teams[Players[iPlayer]:GetTeam()];
	local dc, ic = 0, 0
	if dTeam ~= iTeam then
		for row in GameInfo.Technologies() do
			if row.Show then
				if row.Era and gT.Globals.GoodEras[row.Era] then
					if dTeam:IsHasTech(row.ID) then
						if not iTeam:IsHasTech(row.ID) then
							ic = ic +1;
						end
					elseif iTeam:IsHasTech(row.ID) then
						dc = dc + 1;
					end
				end
			end
		end
	end
	if bTradeRoutes then
		if gT.Players[iPlayer].CultBonusOn[98] then
			ic = ic + GetNumInnoKnownBySecondPlayerOnly(iTeam, dTeam);
		end
		if gT.Players[dPlayer].CultBonusOn[98] then
			dc = dc + GetNumInnoKnownBySecondPlayerOnly(dTeam, iTeam);
		end
	end
	return dc, ic;
end

function GetDefStrengthFromGoverment(iPlayer)
	local base = 0;
	if gT.Players[iPlayer].Goverment == 5 then
		base = base + DBScenario.RepublicExtraDef * gT.Players[iPlayer].GovTraitMod;
	end
	return base;
end

function GetDefStrengthFromTechs(iPlayer)
	return gT.Players[iPlayer].CityStrengthFromTech;
end

LuaEvents.ITGSG_RequestTextForCityDefense.Add(function(iCity)
	local text = "Sources of defense:"
	local iPlayer = iCity:GetOwner();
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local hTab = {}
	table.insert(hTab, {GameDefines["CITY_STRENGTH_DEFAULT"], "Base"});
	table.insert(hTab, {GameDefines["CITY_STRENGTH_POPULATION_CHANGE"] * iCity:GetPopulation(), "Population"});
	table.insert(hTab, {GetDBCulturePlayerInfo(iPlayer, "BaseTechStrength"), "Scenario"});
	
	if iCity:Plot():IsHills() then
		table.insert(hTab, {GameDefines["CITY_STRENGTH_HILL_CHANGE"], "Hills"});
	end
	local bDefBroken = iCity:IsDefenseBroken();
--	if not iCity:IsDefenseBroken() then
		table.insert(hTab, {gT.Players[iPlayer].LeagueCityStrength, "Leagues", bDefBroken});
		table.insert(hTab, {iCity:GetBuildingDefense(), "Buildings", bDefBroken});
		if gT.Cities[cID].Palace then
			table.insert(hTab, {gT.Cities[cID].Palace.Defense, "Palace", bDefBroken});
		end
		if IsCityHaveWonderRuinWithAbility(iCity, 6) then
			table.insert(hTab, {300, "Wonder or Wonder Ruin", bDefBroken});
		end
		table.insert(hTab, {100 * GetCityGovTraitBonus(iCity, 8), "Governance", bDefBroken});
		table.insert(hTab, {400 * GetNumCityAcademiesWithAbility(iCity, 16), "Academies", bDefBroken});
		table.insert(hTab, {GetITGCityInteger(iCity, "CI_GP_DEFENSE"), "Great People", bDefBroken});
		table.insert(hTab, {iCity:GetGarrisonedStrength(), "Garrison", bDefBroken});
--	end

	table.insert(hTab, {GetDefStrengthFromGoverment(iPlayer), "Goverment"});
	table.insert(hTab, {GetDefStrengthFromTechs(iPlayer), "Technologies"});
	table.insert(hTab, {gT.Players[iPlayer].DefFromMA or 0, "Military Advancement"});
	table.insert(hTab, {gT.Cities[cID].DefFestival or 0, "Festival"});
	table.insert(hTab, {GetITGCityInteger(iCity, "CI_IDEO_50"), "Fight Everywhere"});
	
	for i, v in pairs(hTab) do
		if v[1] > 0 then
			text = text .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]+" .. v[1] / 100 .. "[ENDCOLOR] "
			if v[3] then
				text = text .. "[ICON_ITG_DEFENSE_BROKEN]"
			else
				text = text .. "[ICON_STRENGTH]"
			end
			text = text .. " from " .. v[2] .. ".";
		elseif v[1] < 0 then
			text = text .. "[NEWLINE][ICON_BULLET][COLOR_NEGATIVE_TEXT]" .. v[1] / 100 .. "[ENDCOLOR] [ICON_STRENGTH] from " .. v[2] .. ".";
		end
	end
	local modifier = Players[iPlayer]:GetCityStrengthMod()
	if modifier ~= 0 then
		text = text .. "[NEWLINE][NEWLINE]Defense is increased by " .. modifier .. "% (player's ability)."
	end
	--HEAL RATE
	text = text .. "[NEWLINE][NEWLINE]" .. GetCityHealRateTooltip(iCity, cID, iPlayer)
	
	if gT.Cities[cID].TotalDamage == 0 then
		text = text .. "[NEWLINE][NEWLINE]City was never damaged in combat."
	else
		text = text .. "[NEWLINE][NEWLINE]City took [COLOR_NEGATIVE_TEXT]" .. gT.Cities[cID].TotalDamage .. "[ENDCOLOR] damage during this scenario."
	end
	MapModData.ITGSG = text;
end)

function AdjustStrengthOfAllCities(iPlayer)
	local base = GetDBCulturePlayerInfo(iPlayer, "BaseTechStrength") + GetDefStrengthFromGoverment(iPlayer) + GetDefStrengthFromTechs(iPlayer);
	base = base + (gT.Players[iPlayer].DefFromMA or 0);
	local affectedByBreak = gT.Players[iPlayer].LeagueCityStrength;

	if Players[iPlayer]:IsMinorCiv() then
		local gAlly = Players[iPlayer]:GetAlly()
		if gT.Players[gAlly] and gT.Players[gAlly].HasIdeology[5] then
			affectedByBreak = affectedByBreak + 1000; -- this one has no tooltip text :)
		end
	end

	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		local cityBaseExtra = (gT.Cities[cID].DefFestival or 0) + GetITGCityInteger(iCity, "CI_IDEO_50");
		local cityextra = DEF_FROM_ACA_ABILITY * GetNumCityAcademiesWithAbility(iCity, 16) + 100 * GetCityGovTraitBonus(iCity, 8) + GetITGCityInteger(iCity, "CI_GP_DEFENSE");
		if IsCityHaveWonderRuinWithAbility(iCity, 6) then
			cityextra = cityextra + 300;
		end
		if gT.Cities[cID].Palace then
			cityextra = cityextra + gT.Cities[cID].Palace.Defense;
		end
		iCity:SetForcedDefenseFromTech(base + cityBaseExtra)
		iCity:SetDefFromBreakableSources(affectedByBreak + cityextra)
	end
end

function AdjustStrengthOfOneCity(iCity, val, bBreakable)
	if bBreakable then
		iCity:ChangeDefFromBreakableSources(val)
	else
		iCity:ChangeForcedDefenseFromTech(val)
	end
end

function AllCitiesDirtyProductionFromTech(iPlayer)
	for iCity in Players[iPlayer]:Cities() do
		DirtyProductionFromTechInACity(iCity, iPlayer)
	end
end

function DirtyProductionFromTechInACity(iCity, iPlayer)
	SetRawCityYield(iCity, yProduction, gT.Players[iPlayer].ProdFromTech, "CI_PROD_FROM_TECH")
end

function PlayerDiscoveredTechFirst(iPlayer, iTech)
	if gT.Players[iPlayer].GlobalCultPresFromTech > 0 then
		AddCulturalPresenceWorldWide(iPlayer, gT.Players[iPlayer].GlobalCultPresFromTech, nil, false)
	end
end

function DoAddRemoveTechEffect(gplayer, iTech, iAdd, bAdd, iZeroOne)
	if TechForceResReveal[gT.Players[gplayer].CultureType][iTech] then
		for i, resID in pairs(TechForceResReveal[gT.Players[gplayer].CultureType][iTech]) do
			Teams[Players[gplayer]:GetTeam()]:SetForceRevealedResource(resID, bAdd)
		end
	end
	if bAdd and (not Players[gplayer]:IsMinorCiv()) and gT.Globals.GameGenerated then
		for i, v in pairs(freebiesFromTechs[iTech] or {}) do
			if (not v[3]) or (v[3] == gT.Globals.ScenarioType) then
				if (not v[4]) or (v[4] == gT.Players[gplayer].CultureType) then
					if (not v[5]) or (v[5] == gT.Players[gplayer].SubcultureType) then
						if v[1] == 1 then
							GenerateNewCivilianGP(gplayer, false, GetITGGameTurn(), {Type = v[2]})
						elseif v[1] == 2 then
							if v[2] == 1 then
								table.insert(gT.Players[gplayer].AcademyPoints, "FREE")
							elseif v[2] == 2 then
								AddFreeManufactory(gplayer)
							elseif v[2] == 3 then
								table.insert(gT.Players[gplayer].CustomHousePoints, "FREE")
							elseif v[3] == 4 then
								ChangeITGFestivalPoints(gplayer, 1)
							end
							IfActiveThenRefreshDirty(gplayer)
						elseif v[1] == 3 then
							gT.Players[gplayer][v[2]] = gT.Players[gplayer][v[2]] + 1;
						elseif v[1] == 4 then
							AddInspirationChooseToPlayer(gplayer, v[2])
						end
					end
				end
			end
		end
	end
	if basicValfromTechs[iTech] then
		for i, v in pairs(basicValfromTechs[iTech]) do
			if (not v[3]) or (v[3] == gT.Globals.ScenarioType) then
				if (not v[4]) or (v[4] == gT.Players[gplayer].CultureType) then
					gT.Players[gplayer][v[2]] = gT.Players[gplayer][v[2]] + iAdd * v[1];
					if "HealthFromTech" == v[2] then
						UpdateHealthInAllCities(gplayer)
					elseif "FortPowerFromTech" == v[2] then
						DirtyUpdateAllFortsPower()
					elseif "ProdFromTech" == v[2] then
						AllCitiesDirtyProductionFromTech(gplayer)
					end
				end
			end
		end
	end
	if TechGrantingPassageOcean[iTech] then
		SetOceanPassingTech(gplayer)
	end
	if MissionaryGrantingTechs[iTech] then
		SetCanUseMissionares(gplayer)
	end
	if GlobalSettlingTechs[iTech] then
		SetCanGlobalSettling(gplayer)
	end
	if RailroadGrantingTech[iTech] then
		SetCanDoRailrod(gplayer)
	end
	if GetDBCulturePlayerInfo(gplayer, "ReformationTech") == GameInfo.Technologies[iTech].Type then
		gT.Players[gplayer].CanDoReformation = false;
	end
	if iTech == techPhilosophy then
		gT.Players[gplayer].CanPurchaseAcademy = bAdd;
	end
	for hij, resData in pairs(gResourcesOnTech[iTech] or {}) do
		if (not resData.Scenario) or (resData.Scenario == gT.Globals.ScenarioType) then
			if resData.CS or (not Players[gplayer]:IsMinorCiv()) then
				if resData.IfBelow20 then
					gT.Players[gplayer].ResGenPT[resData.Res] = (gT.Players[gplayer].ResGenPT[resData.Res] or 0) + iAdd * resData.Amount;
				elseif resData.Storage then
					if iAdd > 0 then
						DoStoreResource(gplayer, resData.Res, resData.Amount)
					end
				else
					ChangeITGExtraResources(gplayer, resData.Res, iAdd * resData.Amount)
				end
			end
		end
	end
	if gT.Globals.ScenarioType == 2 then
		if iTech == GameInfoTypes.TECH_STEEL then
			Players[gplayer]:ChangeBarbarianCombatBonus(iAdd * 15)
		elseif iTech == GameInfoTypes.TECH_CONSTRUCTION then
			if bAdd and gT.Players[gplayer].SubcultureType == 3 then
				Players[gplayer]:SetPlayerUniqueBuilding(GameInfoTypes.BUILDINGCLASS_WORKSHOP, GameInfoTypes.BUILDING_ITG_WORKSHOP)
				Players[gplayer]:DoOverideBuildingTechRequirement(GameInfoTypes.BUILDING_ITG_WORKSHOP, true)
			end
		end
	elseif gT.Globals.ScenarioType == 1 then
		if iTech == GameInfoTypes.TECH_ARCHITECTURE then
			if bAdd and (not Players[gplayer]:IsMinorCiv()) then
				AddFreePalaceUpgrade(gplayer, 2)
			end
			ChangeArtModFromArtPeriod(gplayer, iAdd)
		elseif iTech == GameInfoTypes.TECH_METALLURGY then
			Players[gplayer]:ChangeFreePromotionCount(GameInfoTypes.PROMOTION_ITG_TECH_METALLURGY, iAdd)
		elseif iTech == GameInfoTypes.TECH_NAVIGATION then
			if gT.Players[gplayer].CultureType == 1 then
				if bAdd then
					gT.Players[gplayer].UniqueImprovements[GameInfoTypes.IMPROVEMENT_POLDER] = true;
				else
					gT.Players[gplayer].UniqueImprovements[GameInfoTypes.IMPROVEMENT_POLDER] = nil;
				end
			end
			if gT.Players[gplayer].SubcultureType == 14 then
				Players[gplayer]:SetCanUseCurrents(bAdd);
				if gplayer == Game.GetActivePlayer() then
					LuaEvents.ITGPlayerSuddenlyCanSeeCurrents();
				end
			end
			if gT.Players[gplayer].CultureType == 2 then
				gT.Players[gplayer].ExtraFoodFromFish = gT.Players[gplayer].ExtraFoodFromFish + iAdd * 3;
			end
			if gT.Players[gplayer].SubcultureType == 3 then
				gT.Players[gplayer].NavalTRTresholdChange = gT.Players[gplayer].NavalTRTresholdChange + iAdd * 25;
			end
		elseif iTech == GameInfoTypes.TECH_CHIVALRY then
			if bAdd and (gT.Players[gplayer].CultureType == 2) then
				Players[gplayer]:SetPlayerUniqueBuilding(GameInfoTypes.BUILDINGCLASS_STABLE, GameInfoTypes.BUILDING_ITG_NW_ONLY_STABLE)
			end
		elseif iTech == GameInfoTypes.TECH_BANKING then
			if gT.Players[gplayer].SubcultureType == 14 then
				ChangeOccupyLimit(gplayer, iAdd)
			end
		elseif iTech == GameInfoTypes.TECH_PRINTING_PRESS then
			if bAdd and gT.Globals.GameGenerated then
				if gT.Players[gplayer].SubcultureType == 3 then
					if not Players[gplayer]:IsMinorCiv() then
						DoGrantRandomInnovationIfPossible(gplayer)
					end
				end
			end
			DoChangeNewManufactoryCost(gplayer, 7 * iAdd)
		end
	elseif gT.Globals.ScenarioType == 3 then
		if iTech == GameInfoTypes.TECH_PHILOSOPHY then
			gT.Players[gplayer].NumPantheonsToChoose = gT.Players[gplayer].NumPantheonsToChoose + iAdd;
		elseif iTech == GameInfoTypes.TECH_CALENDAR then
			gT.Players[gplayer].NumPantheonsToChoose = gT.Players[gplayer].NumPantheonsToChoose + iAdd;
		elseif iTech == GameInfoTypes.TECH_CURRENCY then
			if gT.Players[gplayer].CultureType == 9 then
				ChangeOccupyLimit(gplayer, iAdd)
			end
		elseif iTech == GameInfoTypes.TECH_MATHEMATICS then
			if not Players[gplayer]:IsMinorCiv() then
				gT.Players[gplayer].SpecialUUTresholdRed = gT.Players[gplayer].SpecialUUTresholdRed - 50 * iAdd;
			end
		elseif iTech == GameInfoTypes.TECH_CONSTRUCTION then
			if gT.Players[gplayer].CultureType == 9 then
				ChangeOccupyLimit(gplayer, iAdd)
			end
			Players[gplayer]:ChangeBuildingProductionModifier(25 * iAdd)
		elseif iTech == GameInfoTypes.TECH_BRONZE_WORKING then
			if gT.Players[gplayer].CultureType == 9 then
				if not Players[gplayer]:IsMinorCiv() then
					gT.Players[gplayer].SpecialUUTresholdRed = gT.Players[gplayer].SpecialUUTresholdRed - 80 * iAdd;
				end
			end
		end
	elseif gT.Globals.ScenarioType == 4 then
		if iTech == GameInfoTypes.TECH_DYNAMITE then
			Players[gplayer]:SetPlayerHasTrait(GameInfoTypes.TRAIT_ITG_DYNAMITE_INDUSTRIAL, iZeroOne);
		elseif iTech == GameInfoTypes.TECH_RIFLING then
			Players[gplayer]:ChangeBarbarianCombatBonus(10 * iAdd)
		elseif iTech == TECH_BIOLOGY then
			if bAdd then
				gT.Players[gplayer].UniqueImprovements[GameInfoTypes.IMPROVEMENT_POLDER] = true;
			else
				gT.Players[gplayer].UniqueImprovements[GameInfoTypes.IMPROVEMENT_POLDER] = nil;
			end
		elseif iTech == GameInfoTypes.TECH_STEAM_POWER then
			DoChangeNewManufactoryCost(gplayer, 20 * iAdd)
		end
	elseif gT.Globals.ScenarioType == 5 then
		if iTech == GameInfoTypes.TECH_ATOMIC_THEORY then
			if bAdd then
				InitNuclearRaceByTechDiscovery()
			end
		elseif iTech == GameInfoTypes.TECH_PENICILIN then
			Players[gplayer]:ChangeUnitCombatHealRateChange(GameInfoTypes.UNITCOMBAT_GUN, 10 * iAdd)
		elseif iTech == GameInfoTypes.TECH_COMBINED_ARMS then
			Players[gplayer]:ChangeUnitCombatHealRateChange(GameInfoTypes.UNITCOMBAT_ARMOR, 5 * iAdd)
			Players[gplayer]:ChangeUnitCombatHealRateChange(GameInfoTypes.UNITCOMBAT_FIGHTER, 5 * iAdd)
			Players[gplayer]:ChangeUnitCombatHealRateChange(GameInfoTypes.UNITCOMBAT_BOMBER, 5 * iAdd)
			Players[gplayer]:ChangeUnitCombatHealRateChange(GameInfoTypes.UNITCOMBAT_NAVALRANGED, 5 * iAdd)
			Players[gplayer]:ChangeUnitCombatHealRateChange(GameInfoTypes.UNITCOMBAT_NAVALMELEE, 5 * iAdd)
			Players[gplayer]:ChangeUnitCombatHealRateChange(GameInfoTypes.UNITCOMBAT_CARRIER, 5 * iAdd)
			Players[gplayer]:ChangeUnitCombatHealRateChange(GameInfoTypes.UNITCOMBAT_SUBMARINE, 5 * iAdd)
			DoDirtyCombinedArmsBonus(gplayer)
		elseif iTech == GameInfoTypes.TECH_NUCLEAR_FISSION then
			if bAdd and (not Players[gplayer]:IsMinorCiv()) then
				DoChangeNuclearContribution(gplayer, 20000)
			end
		elseif iTech == GameInfoTypes.TECH_ECOLOGY then
			gT.Globals.EcologyOn = bAdd;
		elseif iTech == GameInfoTypes.TECH_ROCKETRY then
			if bAdd and (not Players[gplayer]:IsMinorCiv()) then
				DoCreateNewSatellite(gplayer)
				DoCreateNewSatellite(gplayer)
			end
		end
	end
	if lTechStrengthBonus[iTech] then
		gT.Players[gplayer].CityStrengthFromTech = gT.Players[gplayer].CityStrengthFromTech + iAdd * lTechStrengthBonus[iTech];
		AdjustStrengthOfAllCities(gplayer)
	end
end