function PreWarDeclaredFT(teamId, otherTeamId, bScripted, bDefensivePact, bMinorAlly)
	if bDefensivePact then
		PreWarDeclaredFT(otherTeamId, teamId, bScripted, false, bMinorAlly)
		return;
	end
	if gT.Globals.GameGenerated then
		if not bMinorAlly then
			MoveOutAllUnitsFrom(teamId, otherTeamId)
		end
	end
end
GameEvents.PreDeclareWar.Add(PreWarDeclaredFT)

function MoveOutAllUnitsFrom(attackingTeam, defendingTeam)
	local bTP = {}
	local bCont = false;
	for g, gh in pairs(gT.Players) do
		if Players[g]:GetTeam() == defendingTeam then
			if not Players[g]:IsMinorCiv() then
				bCont = true;
				bTP[g] = 1;
			end
		end
	end
	if bCont then
		Teams[attackingTeam]:SetPreWarOnTeam(defendingTeam) -- it ignores rival territory free rule for a moment;
		for g, gh in pairs(gT.Players) do
			if Players[g]:GetTeam() == attackingTeam then
				for iUnit in Players[g]:Units() do
					if bTP[iUnit:GetPlot():GetOwner()] then
						if iUnit:GetRebelAgainst() ~= defendingTeam then
							if gh.UnitClassXP[iUnit:GetUnitClassType()] then
								local indexP = iUnit:GetPlot():GetPlotIndex()
								iUnit:JumpToNearestValidPlot()
								if iUnit:GetPlot():GetPlotIndex() ~= indexP then
									iUnit:SetMadeAttack(true)
								end
							end
						end
						if bTP[iUnit:GetPlot():GetOwner()] then
							if iUnit:GetPlot():IsCity() then
								iUnit:JumpToNearestValidPlot()
								iUnit:SetMadeAttack(true)
							end
						end
					end
				end
			end
		end
		Teams[attackingTeam]:SetPreWarOnTeam(-1);
	end
end

function WarDeclared(teamId, otherTeamId, bScripted, bDefensivePact, bMinorAlly, bDoNotLog)
	if teamId == 63 or otherTeamId == 63 then
		return;
	end
	if not bDoNotLog then
		HnGLogWarDeclared(teamId, otherTeamId, bScripted, bDefensivePact, bMinorAlly)
	end
	if bDefensivePact then
		for a, b in pairs(gT.Globals.HumanPlayers) do
			if Players[b]:GetTeam() == teamId then
				for jt, hh in pairs(gT.Players) do
					if Players[jt]:GetTeam() == otherTeamId then
						if not Players[jt]:IsMinorCiv() then
							Players[b]:AddNotification(NotificationTypes.NOTIFICATION_WAR_ACTIVE_PLAYER, "Honouring a Defensive Pact signed by your hand, our empire declared war on treacherous " .. Players[jt]:GetName() .. "!", "Defensive Pact", -1, -1, jt)
						end
					end
				end
			end
		end
		for g, gdata in pairs(gT.Players) do
			if (Players[g]:GetTeam() == teamId) and (not Players[g]:IsMinorCiv()) then
				for j, jdata in pairs(gT.Players) do
					if (Players[j]:GetTeam() == otherTeamId) and (not Players[j]:IsMinorCiv()) then
						DoAddCounterTimePeaceLock(g, j, TURNS_WAR_LOCKED_ON_DEF_PACT, "DefPact")
					end
				end
			end
		end
		WarDeclared(otherTeamId, teamId, bScripted, false, bMinorAlly, true)
		return;
	end
	DominationWarDeclared(teamId, otherTeamId);
	local fTable = GetTableOfTeam(teamId, otherTeamId);
	local sTable = GetTableOfTeam(otherTeamId, teamId);
	if #fTable > 0 then
		DoMinorSwitchSides(fTable, teamId)
	end
	if #sTable > 0 then
		DoMinorSwitchSides(sTable, otherTeamId)
	end
	--
	local majTab = {}
	for i, v in pairs(Players) do
		if v:GetTeam() == teamId then
			if not v:IsMinorCiv() then
				DiploNoteDirty(i, 28)
				CheckIfWarNotDeclaredOnMinor(i, otherTeamId);
				if not gT.Players[i].IsConsideredBarbarian then
					table.insert(majTab, i)
				end
			end
			DoRecheckSpiesActive(i, nil, nil, nil)
			for j, g in pairs(Players) do
				if g:GetTeam() == otherTeamId then
					WarDeclarationPlayerVSPlayer(i, j, bScripted, bMinorAlly)
				end
			end
		elseif v:GetTeam() == otherTeamId then
			DoRecheckSpiesActive(i, nil, nil, nil)
		end
	end
	if gT.Globals.GameGenerated and (not bScripted) then
		DoWarLogAgainstMajors(majTab, otherTeamId, teamId)
		if (not bDefensivePact) and (not bMinorAlly) then
			for i,v in pairs(Players) do
				if v:IsTurnActive() then
					if not v:IsMinorCiv() then
						if v:GetTeam() == teamId then
							MajorActivePlayerPunishForDeclaringWar(i, otherTeamId)
						end
					end
					break;
				end
			end 
			DoReallyRemoveEmbassiesOnWar(teamId, otherTeamId);
		end
	end
	ReconvertAllRebels(teamId, otherTeamId)
	ReconvertAllRebels(otherTeamId, teamId)
	SpecialControlPlotOnWar(otherTeamId, teamId)
end
GameEvents.DeclareWar.Add(WarDeclared)

function MajorActivePlayerPunishForDeclaringWar(iPlayer, teamId)
--NOTE: THE UNHONOURABLE now only works against minor, against major they are pushed away on predeclarewar.
	local bTer = {}
	for i, v in pairs(Players) do
		if v:GetTeam() == teamId then
			bTer[i] = true;
		end
	end
	local ic = 0;
	for iUnit in Players[iPlayer]:Units() do
		if gT.Players[iPlayer].UnitClassXP[iUnit:GetUnitClassType()] then
			local fullStackType = (iUnit:GetITGStackType() == -2)
			if not fullStackType then
				if iUnit:GetRebelAgainst() ~= teamId then
					if bTer[iUnit:GetPlot():GetOwner()] then
						ic = ic + 1;
						iUnit:SetMadeAttack(true)
					end
				end
			end
			local bPlot = iUnit:GetPlot();
			for it = 0, bPlot:GetNumUnits() - 1 do
				local ttUnit = bPlot:GetUnit(it);
				if bTer[ttUnit:GetOwner()] then
					if (not fullStackType) or (ttUnit:GetITGStackType() ~= -2) then
						iUnit:JumpToNearestValidPlot()
						break;
					end
				end
			end
		end
	end
	if ic >= LastRandom(2, 5) then
		gT.Players[iPlayer].VotesFromBreakingLeague = (gT.Players[iPlayer].VotesFromBreakingLeague or 0) + 1;
		NoteGovCausesBasicStack(iPlayer, 17)
		ic = math.min(6, ic)
		for g, gt in pairs(gT.Players) do
			if Players[g]:IsMinorCiv() then
				if Teams[Players[g]:GetTeam()]:IsHasMet(Players[iPlayer]:GetTeam()) then
					gT.Players[iPlayer].AnchorPenaltyLog[g] = (gT.Players[iPlayer].AnchorPenaltyLog[g] or 0) -5 * math.ceil(ic / 2)
					Players[g]:ChangeMinorCivExtraAnchorWithMajor(iPlayer, -5 * math.ceil(ic / 2))
					Players[g]:ChangeMinorCivFriendshipWithMajor(iPlayer, -5 * math.ceil(ic / 2))
				end
			end
		end
		if Players[iPlayer]:IsHuman() then
			Players[iPlayer]:AddNotification(NotificationTypes.NOTIFICATION_GENERIC, "Our war declaration was considered unhonourable by other civilizations, which reduces our [ICON_ITG_VOTES] Votes in all Leagues and [ICON_INFLUENCE] Influence within all met [ICON_CITY_STATE] City-States.", "Sneaky Invasion!")
		end
	end
end

function PeaceDone(teamId, otherTeamId)
	for i,v in pairs(Players) do
		if v:GetTeam() == teamId then
			if not v:IsMinorCiv() then
				if gT.Players[i] then
					DoForcePeaceWithAlliesOf(i, otherTeamId)
				end
			end
		elseif v:GetTeam() == otherTeamId then
			if not v:IsMinorCiv() then
				if gT.Players[i] then
					DoForcePeaceWithAlliesOf(i, teamId)
				end
			end
		end
	end
	if ShouldReaddDefensivePact(teamId, otherTeamId) then
		Teams[teamId]:SetDefensivePact(otherTeamId, true)
		Teams[otherTeamId]:SetDefensivePact(teamId, true)
	end
	ReInstallEmbassyOnPeace(teamId, otherTeamId)
	ReInstallEmbassyOnPeace(otherTeamId, teamId)
	DoCheckLeagueEffectsOnPeace(teamId, otherTeamId)
	CheckTemporaryControlOfHolySitesForstETC(teamId, otherTeamId)
	table.insert(gT.Globals.PeaceTreaties, {teamId, otherTeamId, GetITGGameTurn()})
end
GameEvents.MakePeace.Add(PeaceDone)

function ShouldReaddDefensivePact(a, bTeam)
	if Teams[a]:IsAtWar(bTeam) then
		return false;
	end
	local bAnyMinor = Teams[a]:IsMinorCiv() or Teams[bTeam]:IsMinorCiv();
	for g, h in pairs(gT.Players) do
		if Players[g]:GetTeam() == a then
			for l, b in pairs(gT.Leagues) do
				if b.Members[g] then
					if b.Resolutions[3] then
						if (b.SpecialProposalTag == "IdeologyL") or (not bAnyMinor) then
							for s, t in pairs(b.Members) do	
								if Players[s]:GetTeam() == bTeam then
									return true;
								end
							end
						end
					end
				end
			end
		end
	end
	return false;
end

function WereAtWarDuringThisScenario(iTeam, hTeam)
	for i, b in pairs(gT.Globals.PeaceTreaties) do
		if (b[1] == iTeam and b[2] == hTeam) or (b[1] == hTeam and b[2] == iTeam) then
			return true;
		end
	end
	if Teams[iTeam]:IsAtWar(hTeam) then
		return true;
	end
	return false;
end



function DoForcePeaceWithAlliesOf(i, teamId)
	for j, v in pairs(Players) do
		if v:IsMinorCiv() then
			if v:GetAlly() == i then
				Teams[v:GetTeam()]:MakePeace(teamId)
			end
		end
	end
end

--WARPEACE LOCKING

function OnEndTurnPeaceLock(iPlayer)
	if Players[iPlayer]:GetNumCities() == 0 then
		if not Players[iPlayer]:IsMinorCiv() then
			if not gT.Players[iPlayer].IsConsideredBarbarian then
				local timer = (gT.Players[iPlayer].TurnsToConsiderBarb or 0)  + 1;
				if timer >= TURNS_TO_CONSIDER_BARB then
					LuaEvents.ITG_NotificationBadPlayers(iPlayer)
					MakePlayerBarbarianAndGoodBye(iPlayer)
					if Players[iPlayer]:IsHuman() then
						Players[iPlayer]:AddNotification(344332, "You failed to find a new [ICON_CAPITAL] Capital and became Exile, an easy target without any rights!", "Exile", -1, -1, iPlayer)
						if Players[iPlayer]:IsHuman() then
							LuaEvents.ITG_AchievementCompleted(59)
						end
					end
					for j, human in pairs(gT.Globals.HumanPlayers) do
						if human ~= iPlayer then
							if Teams[Players[iPlayer]:GetTeam()]:IsHasMet(Players[human]:GetTeam()) then
								Players[human]:AddNotification(344332, Players[iPlayer]:GetName() .. " failed to find a new [ICON_CAPITAL] Capital and became Exile, an easy target for an advanced civilizations like ours!", "Exile", -1, -1, iPlayer)
							end
						end
					end
					gT.Players[iPlayer].TurnsToConsiderBarb = 0;
				else
					gT.Players[iPlayer].TurnsToConsiderBarb = timer;
					if Players[iPlayer]:IsHuman() then
						Players[iPlayer]:AddNotification(NotificationTypes.NOTIFICATION_WAR_ACTIVE_PLAYER, "You have " .. 5 - timer .. " turn(s) to find new [ICON_CAPITAL] Capital or you will become exile (barbarian-like)!", "Lackland", iPlayer)
					end
				end 
			end
		end
	end
end

function MakePlayerBarbarianAndGoodBye(iPlayer)
	UpdateLeaguesUponPlayerLoosingRights(iPlayer)
	gT.Players[iPlayer].TurnsToConsiderBarb = 0;
	gT.Players[iPlayer].IsConsideredBarbarian = true;
	HnGLogExile(iPlayer, true)
	local iTeam = Players[iPlayer]:GetTeam();
	HnGLogNextWarsAreExile(true)
	for g, gdata in pairs(gT.Players) do
		if (Players[g]:IsMinorCiv()) then
			if IsITGProtectedByMajor(iPlayer, minor) then
				RemovePledgeOfProtectionByMinor(iPlayer, minor, "Exile")
			end
			local influence = Players[g]:GetMinorCivFriendshipWithMajor(iPlayer);
			if influence > 0 then
				Players[g]:ChangeMinorCivFriendshipWithMajor(iPlayer, - influence);
			end
		end
	end
	for g, gdata in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			local gTeam = Players[g]:GetTeam()
			if gTeam ~= iTeam then
				if Teams[gTeam]:IsHasMet(iTeam) and not Teams[iTeam]:IsAtWar(gTeam) then
					Teams[iTeam]:DeclareScriptedWar(gTeam);
				end
			end
			ChangePeaceWarLock(iPlayer, g, 1, "Exile")
		end
	end
	HnGLogNextWarsAreExile(false)
end

function RebelPeaceLock(iPlayer, ePlayer)
	if not Players[iPlayer]:IsHuman() then
		if ePlayer > iPlayer then
			DoAddCounterTimePeaceLock(iPlayer, ePlayer, 2, "Rebel")
		else
			DoAddCounterTimePeaceLock(iPlayer, ePlayer, 1, "Rebel")
		end
	end
end

function PeaceLockDataConquest(i, g)
	if Players[i]:GetNumCities() == 1 then
		if not Players[i]:IsMinorCiv() and (not Players[i]:IsHuman()) then
			RemovePeaceLockOnEdgeOfExctintion(i)
		end
	end
	if Players[g]:GetNumCities() == 0 then
		if not Players[g]:IsMinorCiv() and (not Players[g]:IsHuman()) then
			AddPeaceLockOnEdgeOfExctintion(g)
		end
	end
	ChangePeaceWarLock(i, g, 1, "Temp")
	table.insert(gT.ShortWarPeaceLock, {i, g, "Conquest"});
	if Players[g]:GetNumCities() == 0 then
		if Players[g]:IsHuman() then
			Players[g]:AddNotification(NotificationTypes.NOTIFICATION_WAR_ACTIVE_PLAYER, "You have " .. 5 .. " turn(s) to find new [ICON_CAPITAL] Capital or you will become exile (barbarian-like)!", "Lackland", iPlayer)
		end
	end
end

function RemovePeaceLockOnEdgeOfExctintion(g)
	for j, sth in pairs(gT.Players[g].PeaceLockAtExctintion) do
		ChangePeaceWarLock(g, j, -1, "EoE")
	end
	gT.Players[g].PeaceLockAtExctintion = {};
end

function AddPeaceLockOnEdgeOfExctintion(g)
	local gTeam = Teams[Players[g]:GetTeam()];
	for j, jdata in pairs(gT.Players) do
		if gTeam:IsAtWar(Players[j]:GetTeam()) then
			gT.Players[g].PeaceLockAtExctintion[j] = 1;
			ChangePeaceWarLock(g, j, 1, "EoE")
		end
	end
end

function ChangePeaceWarLock(iPlayer, sPlayer, amount, hString)
	if (not gT.Players[iPlayer]) or (not gT.Players[sPlayer]) then
		print("Barb peace lock", iPlayer, sPlayer, amount, hString)
		return
	end
	local cValue = gT.Players[iPlayer].WarPeaceLock[sPlayer] or 0;
	gT.Players[iPlayer].WarPeaceLock[sPlayer] = cValue + amount;
	gT.Players[sPlayer].WarPeaceLock[iPlayer] = cValue + amount;
	if not gT.Players[iPlayer].WarLockReasons[sPlayer] then
		gT.Players[iPlayer].WarLockReasons[sPlayer] = {}
		gT.Players[sPlayer].WarLockReasons[iPlayer] = {}
	end
	if not hString then
		print("Missing hstring in war lock!")
	else
	--Exile both sides so +int instead bool
		gT.Players[sPlayer].WarLockReasons[iPlayer][hString] = (gT.Players[sPlayer].WarLockReasons[iPlayer][hString] or 0) + amount;
		gT.Players[iPlayer].WarLockReasons[sPlayer][hString] = (gT.Players[iPlayer].WarLockReasons[sPlayer][hString] or 0) + amount;
		if (gT.Players[iPlayer].WarLockReasons[sPlayer][hString] <= 0) then
			gT.Players[iPlayer].WarLockReasons[sPlayer][hString] = nil;
			gT.Players[sPlayer].WarLockReasons[iPlayer][hString] = nil;
		end
	end
	if (cValue <= 0) and (cValue + amount > 0) then
		Teams[Players[iPlayer]:GetTeam()]:SetPermanentWarPeace(Players[sPlayer]:GetTeam(), true);
		Teams[Players[sPlayer]:GetTeam()]:SetPermanentWarPeace(Players[iPlayer]:GetTeam(), true);
	elseif (cValue > 0) and (cValue + amount) <= 0 then
		Teams[Players[iPlayer]:GetTeam()]:SetPermanentWarPeace(Players[sPlayer]:GetTeam(), false);
		Teams[Players[sPlayer]:GetTeam()]:SetPermanentWarPeace(Players[iPlayer]:GetTeam(), false);
	end
	if cValue < 0 then
		print("CPWL", iPlayer, sPlayer, amount, hString, cValue)
	end
end

function CheckIfWarNotDeclaredOnMinor(i, team)
	for g, gdata in pairs(gT.Players) do
		if Players[g]:GetTeam() == team then
			if Players[g]:IsMinorCiv() then
				DoAddCounterTimePeaceLock(i, g, TURNS_WAR_LOCKED_ON_MINOR, "WarOnMinor")
			end
		end
	end
end

function DoAddCounterTimePeaceLock(i, g, time, hstr)
	if (i > g) then
		DoAddCounterTimePeaceLock(g, i, time, hstr)
		return;
	end
	local string = i .. "pl" .. g;
	if gT.WarPeaceModInTime[string] then
		if GetITGGameTurn() + time > gT.WarPeaceModInTime[string].Turn then
			gT.WarPeaceModInTime[string].Turn = GetITGGameTurn() + time;
			gT.WarPeaceModInTime[string].Reason = hstr;
		end
	else
		gT.WarPeaceModInTime[string] = {PlayerOne = i, PlayerTwo = g, Reason = hstr, Turn = GetITGGameTurn() + time};
		ChangePeaceWarLock(i, g, 1, "Temp") -- keep it as temp
	end
end

function WarPeaceLockOverStuff()
	local gTurn = GetITGGameTurn();
	for i, data in pairs(gT.ShortWarPeaceLock) do
		ChangePeaceWarLock(data[1], data[2], -1, "Temp")
	end
	gT.ShortWarPeaceLock = {};
	for string, data in pairs(gT.WarPeaceModInTime) do
		if data.Turn <= gTurn then
			ChangePeaceWarLock(data.PlayerOne, data.PlayerTwo, -1, "Temp") -- keep it as temp
			gT.WarPeaceModInTime[string] = nil;
		end
	end
end

function RemoveOnCSDeathPeaceLocks(jPlayer)
	for i, player in pairs(gT.Players[jPlayer].CSOnDeathPeaceLocks or {}) do
		ChangePeaceWarLock(jPlayer, player, -1, "CSD")
	end
	gT.Players[jPlayer].CSOnDeathPeaceLocks = nil;
end

function CreateOnCSDeathPeaceLocks(jPlayer)
	local jTeam = Players[jPlayer]:GetTeam();
	gT.Players[jPlayer].CSOnDeathPeaceLocks = {}
	for g, gdata in pairs(gT.Players) do
		if g ~= jPlayer and Teams[jTeam]:IsAtWar(Players[g]:GetTeam()) then
			table.insert(gT.Players[jPlayer].CSOnDeathPeaceLocks, g)
			ChangePeaceWarLock(jPlayer, g, 1, "CSD")
		end
	end
end

LuaEvents.ITG_RequestWarLockedReason.Add(function(iEnemyPlayer, iActive)
	MapModData.ITGSG = GetReasonForLockedWar(iEnemyPlayer, iActive)
end)

function GetReasonForLockedWar(iEnemyPlayer, iActive)
	for str, bb in pairs(gT.Players[iEnemyPlayer].WarLockReasons[iActive] or {}) do
		if str == "Exile" then
			if gT.Players[iActive].IsConsideredBarbarian then
				return "You can't make peace as long as you are considered Exile!"
			else
				if LastRandom(1,100) == 2 then
					return "This Exile is dangerous fugitive which should be shot on sight!"
				else
					return "This Exile is not worthy diplomatic relations!"
				end
			end
		elseif str == "CSD" then
			return "City-states are not eager for peace talks when they do not own a single city."
		elseif str == "EoE" then
			return "Enemy is determined to reconquer at least one city!"
		elseif str == "WarOnSchism" then
			return "War is locked due to religious dispute.";
		elseif str == "TotalWar" then
			return "One side belongs to league which declared Total War on second side!";
		elseif str == "DomM" then
			return "Peace is impossible during World at War event.";
		elseif str == "League31" then
			return "War cannot be resolved because one side is tied to it by an alliance agreement.";
		elseif str == "SCrule" then
			return "Peace is locked due to scenario rule.";
		end
-- Only peace forcing:
-- "PPledge"
-- "Olympics"
	end
	local string = iEnemyPlayer .. "pl" .. iActive;
	if iActive < iEnemyPlayer then
		string = iActive .. "pl" .. iEnemyPlayer;
	end
	if gT.WarPeaceModInTime[string] then
		if gT.WarPeaceModInTime[string].Reason == "Rebel" then
			return "Peace impossible due to recent rebellion (" .. (gT.WarPeaceModInTime[string].Turn - GetITGGameTurn())  ..  "T)."
		elseif gT.WarPeaceModInTime[string].Reason == "WarOnMinor" then
			return "Cannot make peace so quickly after declaring war on minor (" .. (gT.WarPeaceModInTime[string].Turn - GetITGGameTurn())  ..  "T)."
		elseif gT.WarPeaceModInTime[string].Reason == "DefPact" then
			return "Cannot make peace so quickly during war triggered by defensive pact (" .. (gT.WarPeaceModInTime[string].Turn - GetITGGameTurn())  ..  "T)."
		elseif gT.WarPeaceModInTime[string].Reason == "DiploAction" then
			return "Peace is temporary locked due to resolved diplomatic action (" .. (gT.WarPeaceModInTime[string].Turn - GetITGGameTurn())  ..  "T)."
		end
	end
	for i, dd in pairs(gT.ShortWarPeaceLock) do
		if (dd[1] == iEnemyPlayer or dd[2] == iEnemyPlayer) and (dd[1] == iActive or dd[2] == iActive) then
			if dd[3] == "Conquest" then
				return "Peace is not an option due to recent city capture (1T)."
			end
		end
	end
	return nil;
end


function DoWarLogAgainstMajors(majTab, otherTeamId, teamId)
	if #majTab > 0 then
		local tStringHelp;
		for g, gData in pairs(gT.Players) do
			if Players[g]:GetTeam() == otherTeamId then
				if not Players[g]:IsMinorCiv() then
					TakeCareOfEventMorale(g, 12)
					if gT.Players[g].NumWarsDeclaredOn then
						table.insert(gT.Players[g].NumWarsDeclaredOn, {majTab[1], GetITGGameTurn()})
					end
					tStringHelp = g;
					for ddg, ddgdata in pairs(gT.Players) do
						if Teams[Players[ddg]:GetTeam()]:IsAtWar(otherTeamId) then
							if Players[ddg]:GetTeam() ~= teamId then
								if not Players[ddg]:IsMinorCiv() then
									TakeCareOfEventMorale(ddg, 11)
								end
							end
						end
					end
				end
			end
		end
		if tStringHelp then
			for i, sb in pairs(majTab) do
				table.insert(gT.Players[sb].NumWarsDeclared, {tStringHelp, GetITGGameTurn()})
			end
		end
	end	
end

local techinnoasia7 = GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_ASIA_7;
function GetTableOfTeam(a, b)
	local hMinorT = {}
	if Teams[a]:IsHasTech(techinnoasia7) then
		for minor, gdata in pairs(gT.Players) do
			if Players[minor]:IsAlive() and Players[minor]:IsMinorCiv() then
				local iPlayer = Players[minor]:GetAlly();
				if iPlayer ~= -1 then
					if Players[iPlayer]:GetTeam() == b then
						table.insert(hMinorT, minor)
					end
				end
			end
		end
	end
	return hMinorT;
end

function DoMinorSwitchSides(tab, team)
	for it, minorID in pairs(tab) do
		local hTab = {}
		for iPlayer, gd in pairs(gT.Players) do
			if Players[iPlayer]:GetTeam() == team then
				if Players[iPlayer]:IsAlive() then
					local hfriend = math.floor(Players[minorID]:GetMinorCivFriendshipWithMajor(iPlayer)/2);
					local chance = math.max(10, math.min(75, hfriend))
					if LastChance(chance) then
						table.insert(hTab, iPlayer)
					end
				end
			end
		end
		if #hTab > 0 then
			local lPlayer = hTab[math.random(1,#hTab)];
			local cAlly = Players[minorID]:GetAlly()
			local cInfluence = Players[minorID]:GetMinorCivFriendshipWithMajor(cAlly);
			if lPlayer == Game.GetActivePlayer() then
				Players[lPlayer]:AddNotification( NotificationTypes.NOTIFICATION_MINOR , "The City-State of " .. Players[minorID]:GetName() .. " is tired of its current ally, " .. Players[cAlly]:GetName() .. ", and will support you during the incoming war!", "Gekokujo")
			end
			Players[minorID]:ChangeMinorCivFriendshipWithMajor(cAlly, -1 * cInfluence);
			Players[minorID]:ChangeMinorCivFriendshipWithMajor(lPlayer, cInfluence - Players[minorID]:GetMinorCivFriendshipWithMajor(minorID));
		end
	end
end

function ReconvertAllRebels(teamId, otherTeamId)
	for iUnit in Players[63]:Units() do
		local vPlayer = iUnit:GetRebelOrigin();
		if vPlayer ~= -1 and (Players[vPlayer]:GetTeam() == teamId) then
			if iUnit:GetRebelAgainst() == otherTeamId then
				local iPlot = iUnit:GetPlot();
				local iType = iUnit:GetUnitType();
				local iDmg = iUnit:GetDamage();
				local iLevel = iUnit:GetLevel();
				local iExperience = iUnit:GetExperience();
				iUnit:Kill(false, -1);
				local jUnit = Players[vPlayer]:InitUnit(iType, iPlot:GetX(), iPlot:GetY())
				jUnit:SetLevel(iLevel)
				jUnit:SetExperience(iExperience)
				ITGSCNewUnitCreated(vPlayer, jUnit, nil, false, nil, {Damage = iDmg}, false)
			end
		end
	end
end

function RemoveBarbarianStatus(newPlayer, sType)
	print("Barb status removed", newPlayer, sType)
	gT.Players[newPlayer].IsConsideredBarbarian = false;
	HnGLogExile(newPlayer, false)
	LuaEvents.ITG_NotificationBadPlayers(newPlayer, true)
	local boost = math.floor((100 - gT.Players[newPlayer].MeritocracyLevel) / 2);
	if boost > 0 then
		ChangeMeritocracy(newPlayer, boost)
	end
	for g, gdata in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			ChangePeaceWarLock(newPlayer, g, -1, "Exile")
		end
	end
end

function DoDelayExile(iPlayer)
	gT.Players[iPlayer].TurnsToConsiderBarb = 0;
end

function ThisWarShouldNotBeForcedToPeace(member, jmember)
	for str, bb in pairs(gT.Players[member].WarLockReasons[jmember] or {}) do
		if str == "League31" then
			return true;
		end
	end
	return false;
end

function SpecialControlPlotOnWar(iTeam, eTeam)
	for g, h in pairs(gT.Players) do
		if Players[g]:GetTeam() == iTeam then
			for iUnit in Players[g]:Units() do
				if iUnit:GetITGStackType() ~= -2 then
					local iPlot = iUnit:GetPlot();
					local iPlotOwner = iPlot:GetOwner();
					if (iPlotOwner ~= -1) and (Players[iPlotOwner]:GetTeam() == eTeam) then
						if iPlot:IsImprovementPillaged() then
							local iPlotIndex = iPlot:GetPlotIndex();
							if gT.Colonies[iPlotIndex] then
								if gT.Colonies[iPlotIndex].Player == iPlotOwner then
									ColonyTakeOver(g, iPlotOwner, iPlot, false, iUnit)
								end
							elseif gT.HolySites[iPlotIndex] then
								if gT.HolySites[iPlotIndex].Player == iPlotOwner then
									HolySiteTakeOver(g, iPlotOwner, iPlot, nil, nil, iUnit)
								end
							elseif gT.Forts[iPlotIndex] then
								if gT.Forts[iPlotIndex].Player == iPlotOwner then
									FortTakeOver(g, iPlotOwner, iPlot, nil, iUnit)
								end
							elseif gT.ElDorados[iPlotIndex] then
								if gT.ElDorados[iPlotIndex].Player == iPlotOwner then
									ElDoradoTakeOver(g, iPlotOwner, iPlot)
								end
							end
						end
					end
				end
			end
		end
	end
end