function BasicTAddRemovePromotion(iPlayer, iProm, bAdd, CanHaveProm, CanHaveProm2)
	if bAdd then
		for iUnit in Players[iPlayer]:Units() do
			if (not CanHaveProm) or CanHaveProm(iPlayer, iUnit) then
				if (not CanHaveProm2) or CanHaveProm2(iPlayer, iUnit) then
					iUnit:SetHasPromotion(iProm, true)
				end
			end
		end
	else
		for iUnit in Players[iPlayer]:Units() do
			iUnit:SetHasPromotion(iProm, false)
		end
	end
end
function TARUnitClassPromotion(iPlayer, iUnitclass, iProm, bAdd)
	for iUnit in Players[iPlayer]:Units() do
		if iUnit:GetUnitClassType() == iUnitclass then
			iUnit:SetHasPromotion(iProm, bAdd);
		end
	end
end
function TARIsDomainLand(iPlayer, iUnit)
	return (iUnit:GetDomainType() == dLand);
end
function TARIsDomainSea(iPlayer, iUnit)
	return (iUnit:GetDomainType() == dSea);
end
function TARIsUnitClassXP(iPlayer, iUnit)
	if gT.Players[iPlayer].UnitClassXP[iUnit:GetUnitClassType()] then
		return true;
	end
	return false
end
function TARBasicModernUnitclass(iPlayer, bAdd, unitclass, hVal)
	if bAdd then
		SimpleGenerateUnitOfType(iPlayer, Players[iPlayer]:GetPlayerUniqueUnit(unitclass))
	end
	Players[iPlayer]:ChangeUnitClassRawProdDiscount(unitclass, hVal);
end

function TAddRemoveNWAsia1(iPlayer, selfID, bAdd, iAdd, iOneZero)
	gT.Players[iPlayer].CanHaveShinobiVision = bAdd;
	if not bAdd then
		AddShinobiVisionModifierForPlayer(iPlayer, nil, true);
	end
end
function TAddRemoveNWAsia2(iPlayer, selfID, bAdd, iAdd, iOneZero)
	DoUpdateHPInstantlyOnVeteranProm(iPlayer, iAdd)
	Players[iPlayer]:ChangeLevelExperienceModifier(-20 * iAdd);
end
function TAddRemoveNWAsia3(iPlayer, selfID, bAdd, iAdd, iOneZero)
	gT.Players[iPlayer].GPDoNotMigrateAway = gT.Players[iPlayer].GPDoNotMigrateAway + iAdd;
end
function TAddRemoveNWAsia5(iPlayer, selfID, bAdd, iAdd, iOneZero)
	Players[iPlayer]:ChangeFreePromotionCount(GameInfoTypes.PROMOTION_ITG_FORBIDDEN_CITY, iAdd)
	if bAdd then
		DoInnovationForbiddenPalace(iPlayer)
	end
	gT.Players[iPlayer].CapitalAuthMod = gT.Players[iPlayer].CapitalAuthMod + iAdd;
end
function TAddRemoveNWAsia7(iPlayer, selfID, bAdd, iAdd, iOneZero)
	Players[iPlayer]:ChangeUnitBonusVersusSameType(25 * iAdd);
end
function TAddRemoveNWAsia8(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then
		DoSpawnKingUnit(iPlayer)
	end
end
function TAddRemoveNWAfrica1(iPlayer, selfID, bAdd, iAdd, iOneZero)
	Players[iPlayer]:ChangeBorderObstacleCount(iAdd)
end
function TAddRemoveNWAfrica2(iPlayer, selfID, bAdd, iAdd, iOneZero)
	Players[iPlayer]:ChangeCitiesStrikeRange(2 * iAdd)
	Players[iPlayer]:ChangeGarrisonDefMod(100 * iAdd)
end
function TAddRemoveNWAfrica3(iPlayer, selfID, bAdd, iAdd, iOneZero)	
	for iUnit in Players[iPlayer]:Units() do
		if iUnit:GetDomainType() == dLand then
			if iUnit:GetUnitCombatType() ~= GameInfoTypes.UNITCOMBAT_SIEGE then
				if bAdd then
					SetUnitForcedStackType(iUnit, -1, "nwAfr3", -1);
				else
					CleanTemporaryITGStackType(iUnit, "nwAfr3")
				end
			end
		end
	end
end
function TAddRemoveNWAfrica4(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then
		for iUnit in Players[iPlayer]:Units() do
			if iUnit:GetUnitCombatType() == GameInfoTypes.UNITCOMBAT_SIEGE then
				iUnit:Kill(false, -1);
			end
		end
		SetUniqueUnitProperly(iPlayer, GameInfoTypes.UNITCLASS_CATAPULT, -1)
		SetUniqueUnitProperly(iPlayer, GameInfoTypes.UNITCLASS_TREBUCHET, -1)
		SetUniqueUnitProperly(iPlayer, GameInfoTypes.UNITCLASS_CANNON, -1)
		DoSetMercCostRightNow(iPlayer)
	end
	Players[iPlayer]:SetIgnoreStrategicResources(bAdd)
end
function TAddRemoveNWAfrica5(iPlayer, selfID, bAdd, iAdd, iOneZero)
	for iUnit in Players[iPlayer]:Units() do
		iUnit:SetHasPromotion(GameInfoTypes.PROMOTION_ITG_INNO_DESERT_AFR, bAdd)
	end
	for iCity in Players[iPlayer]:Cities() do
		iCity:ChangeTerrainExtraYield(tDesert, yProduction, 2 * iAdd)
	end
	if bAdd then
		DoDiscoverExtraOasis(iPlayer, 5);
	end
end
function TAddRemoveNWAfrica6(iPlayer, selfID, bAdd, iAdd, iOneZero)
	for iUnit in Players[iPlayer]:Units() do
		iUnit:SetHasPromotion(GameInfoTypes.PROMOTION_ITG_INNO_JUNGLE_AFR, bAdd)
	end
	for iCity in Players[iPlayer]:Cities() do
		iCity:ChangeFeatureExtraYield(fJungle, yGold, 1 * iAdd)
		UpdateCityMaxHitPoints(iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded(), iPlayer, iCity)
	end
	if bAdd then
		local fTeams = {}
		for g, h in pairs(gT.Players) do
			if not Players[g]:IsMinorCiv() then
				if g ~= iPlayer then
					table.insert(fTeams, Players[g]:GetTeam())
				end
			end
		end
		for f = 0, Map.GetNumPlots() - 1 do
			local fPlot = Map.GetPlotByIndex(f);
			if fPlot:GetOwner() == iPlayer then
				for i, iTeam in pairs(fTeams) do
					if fPlot:IsRevealed(iTeam) and (not fPlot:IsVisible(iTeam)) then
						HidePlotDuringGame(iTeam, fPlot)
					end
				end
			end
		end
	end
end
function TAddRemoveNWAfrica8(iPlayer, selfID, bAdd, iAdd, iOneZero)
	AdjustMoraleBonusesOnInno(iPlayer, iOneZero * math.max(0, gT.Players[iPlayer].Morale))
end
function TAddRemoveTrialEuro1(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then
		if Players[iPlayer]:GetReligionCreatedByPlayer() < 1 then
			DoASchism(iPlayer, gT.Players[iPlayer].OfficialReligion, GetHolyCityForPlayer(iPlayer))
		else
			DoAddNewBeliefOfType(iPlayer, 3)
		end
		DoChangeLocalTheologyHeresy(iPlayer, -40)
		DoIncreaseHeresyProbability(40)
	end
	gT.Players[iPlayer].PilgrimFromTech = gT.Players[iPlayer].PilgrimFromTech + iAdd;
end
function TAddRemoveTrialEuro2(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then
		GenerateThreeTroubadours(iPlayer)
		UpgradePlayerToNextCulturalEra(iPlayer, true, false)
	end
end
function TAddRemoveTrialEuro3(iPlayer, selfID, bAdd, iAdd, iOneZero)
	for iUnit in Players[iPlayer]:Units() do
		if iUnit:GetUnitCombatType() == GameInfoTypes.UNITCOMBAT_MELEE then
			iUnit:ChangeAdjacentSameClassModifier(8 * iAdd);
		end
	end
end
function TAddRemoveTrialEuro4(iPlayer, selfID, bAdd, iAdd, iOneZero)
	Players[iPlayer]:ChangeNumResourceTotal(rHorse, iAdd);
end
function TAddRemoveTrialEuro5(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then
		gT.Players[iPlayer].GlassTdisc = GetNumManufactories(iPlayer);
		Players[iPlayer]:ChangeNumResourceTotal(GameInfoTypes.RESOURCE_ITG_GLASS, 1 + gT.Players[iPlayer].GlassTdisc);
	else
		Players[iPlayer]:ChangeNumResourceTotal(GameInfoTypes.RESOURCE_ITG_GLASS, -1 - gT.Players[iPlayer].GlassTdisc);
		gT.Players[iPlayer].GlassTdisc = nil;
	end
end
function TAddRemoveTrialEuro6(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then
		DoRetroactiveBonusFromAntiquity(iPlayer)
		DoInstantWonderRebuilt(iPlayer)
		DoIncreasePointsTowardGoldenAge(iPlayer, 6, "Technology", 2);
	end
end
function TAddRemoveTrialEuro7(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then
		ByImperialOrderUpgradeRightThere(iPlayer, GameInfoTypes.UNITCLASS_COMPOSITE_BOWMAN, GameInfoTypes.UNITCLASS_CROSSBOWMAN)
	end
end
function TAddRemoveTrialEuro8(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then
		ByImperialOrderUpgradeRightThere(iPlayer, GameInfoTypes.UNITCLASS_GALLEASS, GameInfoTypes.UNITCLASS_ITG_GRAND_GALLEAS)
	end
end
function TAddRemoveTrialArab1(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then
		if not HaveUnlockedBuildingClass(iPlayer, GameInfoTypes.BUILDINGCLASS_UNIVERSITY, "Inno") then
			gT.Players[iPlayer].InnovationChance = gT.Players[iPlayer].InnovationChance + 20;
		end
		if not HaveUnlockedBuildingClass(iPlayer, GameInfoTypes.BUILDINGCLASS_WORKSHOP, "Inno") then
			gT.Players[iPlayer].InnovationChance = gT.Players[iPlayer].InnovationChance + 20;
		end
	end
	Players[iPlayer]:ChangePlayerBuildingClassYieldChange(GameInfoTypes.BUILDINGCLASS_LIBRARY, yProduction, iAdd);
	Players[iPlayer]:ChangePlayerBuildingClassYieldChange(GameInfoTypes.BUILDINGCLASS_WORKSHOP, yProduction, iAdd);
	Players[iPlayer]:ChangePlayerBuildingClassYieldChange(GameInfoTypes.BUILDINGCLASS_UNIVERSITY, yProduction, iAdd);
end
function TAddRemoveTrialArab2(iPlayer, selfID, bAdd, iAdd, iOneZero)
	Players[iPlayer]:ChangeUnitCombatProductionModifiers(GameInfoTypes.UNITCOMBAT_NAVALMELEE, iAdd * 33)
	Players[iPlayer]:ChangeUnitCombatProductionModifiers(GameInfoTypes.UNITCOMBAT_NAVALRANGED, iAdd * 33)
	for iUnit in Players[iPlayer]:Units() do
		if iUnit:GetDomainType() == dSea then
			if gT.Players[iPlayer].UnitClassXP[iUnit:GetUnitClassType()] then
				if bAdd then
					SetUnitForcedStackType(iUnit, -1, "tArab2", -1)
				else
					CleanTemporaryITGStackType(iUnit, "tArab2")
				end
			end
		end
	end
end
function TAddRemoveTrialArab3(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then
		for g, aca in pairs(gT.Academies) do
			if aca.Player == iPlayer then
				for i = 1, 4 do
					AddBonusToAcademy(g, "Random")
				end
			end
		end
	end
end
function TAddRemoveTrialArab5(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then
		if not HaveUnlockedBuildingClass(iPlayer, GameInfoTypes.BUILDINGCLASS_HARBOR, "Inno") then
			gT.Players[iPlayer].InnovationChance = gT.Players[iPlayer].InnovationChance + 20;
		end
		DoDiscoverCertainAmountOfPlotsNotRandomly(iPlayer, 500)
	end
end
function TAddRemoveTrialArab6(iPlayer, selfID, bAdd, iAdd, iOneZero)
	ChangeExtraLegalFromBuildingClass(iPlayer, GameInfoTypes.BUILDINGCLASS_LIBRARY, iAdd)
	ChangeExtraLegalFromBuildingClass(iPlayer, GameInfoTypes.BUILDINGCLASS_TEMPLE, iAdd)
end
function TAddRemoveTrialArab8(iPlayer, selfID, bAdd, iAdd, iOneZero)
	gT.Players[iPlayer].PowerFromTech = gT.Players[iPlayer].PowerFromTech + 100 * iAdd;
	gT.Players[iPlayer].GovActivityMod = gT.Players[iPlayer].GovActivityMod + 0.5 * iAdd;
	gT.Players[iPlayer].ExtraMaxGovernors = gT.Players[iPlayer].ExtraMaxGovernors + iAdd;
	if bAdd then
		AppointNewGovernor(iPlayer)
	end
end
function TAddRemoveTrialAsia1(iPlayer, selfID, bAdd, iAdd, iOneZero)
	gT.Players[iPlayer].YieldModGreatPeople[3] = gT.Players[iPlayer].YieldModGreatPeople[3] + iAdd;
	AllCitiesDirtyProductionFromGP(iPlayer)
	for iCity in Players[iPlayer]:Cities() do
		SetBasicCityYieldRate(iCity, yGold, 10 * iOneZero, "CI_CALCULUS_GOLD")
	end
	if bAdd then
		gT.Players[iPlayer].CalculusTurn = GetITGGameTurn();
	else
		gT.Players[iPlayer].CalculusTurn = nil;
	end
end
function TAddRemoveTrialAsia2(iPlayer, selfID, bAdd, iAdd, iOneZero)
	Players[iPlayer]:ChangeCityStrengthMod(25 * iAdd);
end
function TAddRemoveTrialAsia3(iPlayer, selfID, bAdd, iAdd, iOneZero)
	Players[iPlayer]:ChangeNumResourceTotal(GameInfoTypes.RESOURCE_ITG_DRIED_HERBS, iAdd * 2);
end
function TAddRemoveTrialAsia4(iPlayer, selfID, bAdd, iAdd, iOneZero)
	SetBuildingClassMaintenanceFree(iPlayer, GameInfoTypes.BUILDINGCLASS_TEMPLE, not bAdd)
	gT.Players[iPlayer].ReligionUnityMod = gT.Players[iPlayer].ReligionUnityMod + iAdd;
end
function TAddRemoveTrialAsia6(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then
		DoDiscoverCertainAmountOfPlotsNotRandomly(iPlayer, 300)
		GenerateGreatAdmiralForPlayer(iPlayer)
	end
end
function TAddRemoveTrialAsia8(iPlayer, selfID, bAdd, iAdd, iOneZero)
	DoImperialExaminationCheck(iPlayer)
end
function TAddRemoveTrialPagan1(iPlayer, selfID, bAdd, iAdd, iOneZero)	
	if bAdd then
		Players[iPlayer]:SetPlayerUniqueBuilding(GameInfoTypes.BUILDINGCLASS_TEMPLE, GameInfoTypes.BUILDING_ITG_NEW_WORLD_CATHEDRAL)
	end
	Players[iPlayer]:DoOverideBuildingTechRequirement(GameInfoTypes.BUILDING_ITG_NEW_WORLD_CATHEDRAL, bAdd)
	Players[iPlayer]:ChangeReligionSoakingMod(100 * iAdd);
end
function TAddRemoveTrialPagan2(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then
		if Players[iPlayer]:GetReligionCreatedByPlayer() < 1 then
			DoNewReligion(iPlayer, GetHolyCityForPlayer(iPlayer))
		end
		EraseForeignReligionsFromPlayer(iPlayer)
	end
end
function TAddRemoveTrialPagan3(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then
		Players[iPlayer]:SetPlayerUniqueBuilding(GameInfoTypes.BUILDINGCLASS_LIBRARY, GameInfoTypes.BUILDING_LIBRARY)
		Players[iPlayer]:SetPlayerUniqueBuilding(GameInfoTypes.BUILDINGCLASS_CASTLE, GameInfoTypes.BUILDING_ITG_CASTLE)
		Players[iPlayer]:SetPlayerUniqueBuilding(GameInfoTypes.BUILDINGCLASS_UNIVERSITY, GameInfoTypes.BUILDING_ITG_UNIVERSITY)
		if not HaveUnlockedBuildingClass(iPlayer, GameInfoTypes.BUILDINGCLASS_WORKSHOP, "Inno") then
			gT.Players[iPlayer].InnovationChance = gT.Players[iPlayer].InnovationChance + 20;
		end
	end
	Players[iPlayer]:DoOverideBuildingTechRequirement(GameInfoTypes.BUILDING_LIBRARY, bAdd)
	Players[iPlayer]:DoOverideBuildingTechRequirement(GameInfoTypes.BUILDING_ITG_CASTLE, bAdd)
	Players[iPlayer]:DoOverideBuildingTechRequirement(GameInfoTypes.BUILDING_ITG_UNIVERSITY, bAdd)
end
function TAddRemoveTrialPagan4(iPlayer, selfID, bAdd, iAdd, iOneZero)
	gT.Players[iPlayer].LegalGainDisabled = gT.Players[iPlayer].LegalGainDisabled + iAdd;
	Players[iPlayer]:ChangeMilitaryProductionModifier(iAdd * 100);
end
function TAddRemoveTrialPagan5(iPlayer, selfID, bAdd, iAdd, iOneZero)
	local iSupplyChange = math.floor(gT.Players[iPlayer].PillagedImpros / 8)
	if iSupplyChange ~= 0 then
		ChangeExtraSupply(iPlayer, iSupplyChange * iAdd)
	end
	for iUnit in Players[iPlayer]:Units() do
		iUnit:SetHasPromotion(GameInfoTypes.PROMOTION_ITG_TRIAL_PAGAN_5, bAdd)
	end
end
function TAddRemoveTrialPagan6(iPlayer, selfID, bAdd, iAdd, iOneZero)
	for iCity in Players[iPlayer]:Cities() do
		iCity:ChangeFeatureExtraYield(fForest, yFood, iAdd)
	end
end
function TAddRemoveTrialPagan7(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then
		SetUniqueUnitProperly(iPlayer, GameInfoTypes.UNITCLASS_TREBUCHET, GameInfoTypes.UNIT_ITG_SIEGE_CATAPULT)
		SetUniqueUnitProperly(iPlayer, GameInfoTypes.UNITCLASS_ITG_SIEGE_TOWER, GameInfoTypes.UNIT_ITG_SIEGE_TOWER_SUPPORT)
		SetUniqueUnitProperly(iPlayer, GameInfoTypes.UNITCLASS_GALLEASS, GameInfoTypes.UNIT_ITG_NW_GALLEASS)
		DoUnlockUnitClass(iPlayer, GameInfoTypes.UNITCLASS_TREBUCHET, -1)
		DoUnlockUnitClass(iPlayer, GameInfoTypes.UNITCLASS_ITG_SIEGE_TOWER, -1)
		DoUnlockUnitClass(iPlayer, GameInfoTypes.UNITCLASS_GALLEASS, -1)
	else
		Players[iPlayer]:DoOverideUnitTechRequirement(GameInfoTypes.UNIT_ITG_SIEGE_CATAPULT, false)
		Players[iPlayer]:DoOverideUnitTechRequirement(GameInfoTypes.UNIT_ITG_SIEGE_TOWER_SUPPORT, false)
		Players[iPlayer]:DoOverideUnitTechRequirement(GameInfoTypes.UNIT_ITG_NW_GALLEASS, false)
	end
end
function TPromPagan8(iPlayer, iUnit)
	if iUnit:GetDomainType() == dLand then
		if gT.Players[iPlayer].UnitClassXP[iUnit:GetUnitClassType()] then
			if CanBeSpeedUpByAnything(iUnit) then
				return true;
			end
		end
	end
	return false;
end
function TAddRemoveTrialPagan8(iPlayer, selfID, bAdd, iAdd, iOneZero)
	BasicTAddRemovePromotion(iPlayer, GameInfoTypes.PROMOTION_ITG_TECH_AMBUSH, bAdd, TPromPagan8)
end
function TAddRemoveTrialHorde1(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then
		for iClass, tProms in pairs() do
			if GetPlayerUnitclassDomain(iPlayer, iClass) == dLand then
				AddUnitclassPromotion(iPlayer, iClass, GameInfoTypes.PROMOTION_MARCH, true)
				AddUnitclassPromotion(iPlayer, iClass, GameInfoTypes.PROMOTION_MOBILITY, true)
			end
		end
	end
end
function TAddRemoveTrialHorde2(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then
		Players[iPlayer]:SetPlayerUniqueBuilding(GameInfoTypes.BUILDINGCLASS_ARMORY, GameInfoTypes.BUILDING_ITG_ARMORY)
		Players[iPlayer]:SetPlayerUniqueBuilding(GameInfoTypes.BUILDINGCLASS_BARRACKS, GameInfoTypes.BUILDING_ITG_NEW_BARRACKS)
		Players[iPlayer]:SetPlayerUniqueBuilding(GameInfoTypes.BUILDINGCLASS_CASTLE, GameInfoTypes.BUILDING_ITG_CASTLE)
		Players[iPlayer]:SetPlayerUniqueBuilding(GameInfoTypes.BUILDINGCLASS_WALLS, GameInfoTypes.BUILDING_ITG_NEW_WORLD_WALLS)
	end
	Players[iPlayer]:DoOverideBuildingTechRequirement(GameInfoTypes.BUILDING_ITG_ARMORY, bAdd)
	Players[iPlayer]:DoOverideBuildingTechRequirement(GameInfoTypes.BUILDING_ITG_NEW_BARRACKS, bAdd)
	Players[iPlayer]:DoOverideBuildingTechRequirement(GameInfoTypes.BUILDING_ITG_CASTLE, bAdd)
	Players[iPlayer]:DoOverideBuildingTechRequirement(GameInfoTypes.BUILDING_ITG_NEW_WORLD_WALLS, bAdd)
end
function TAddRemoveTrialHorde3(iPlayer, selfID, bAdd, iAdd, iOneZero)
	MintBuildingTypeDirty(iPlayer)
	Players[iPlayer]:DoOverideBuildingTechRequirement(GameInfoTypes.BUILDING_ITG_MINT, bAdd)
end
function TAddRemoveTrialHorde4(iPlayer, selfID, bAdd, iAdd, iOneZero)
	gT.Players[iPlayer].CanGeneralBeKilledInBattle = gT.Players[iPlayer].CanGeneralBeKilledInBattle + iAdd;
	Players[iPlayer]:ChangeGreatGeneralCombatBonus(iAdd * 15);
	if bAdd then
		for gpID, sth in pairs(gT.Players[iPlayer].GreatPeople) do
			if gT.GreatPeople[gpID].Type == 1 then
				for aID, agdata in pairs(gT.GreatPeople[gpID].RivalSpiesActive or {}) do
					MakeSpyUnassigned(agdata[1], agdata[2])				
				end
			end
		end
		GenerateGreatGeneralForPlayer(iPlayer)
	end
end
function TAddRemoveTrialHorde5(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then
		Players[iPlayer]:SetPlayerUniqueBuilding(GameInfoTypes.BUILDINGCLASS_LIGHTHOUSE, GameInfoTypes.BUILDING_ITG_LIGHTHOUSE)
		Players[iPlayer]:SetPlayerUniqueBuilding(GameInfoTypes.BUILDINGCLASS_HARBOR, GameInfoTypes.BUILDING_ITG_HARBOR)
		Players[iPlayer]:DoOverideBuildingTechRequirement(GameInfoTypes.BUILDING_ITG_LIGHTHOUSE, true)
		Players[iPlayer]:DoOverideBuildingTechRequirement(GameInfoTypes.BUILDING_ITG_HARBOR, true)
		SetUniqueUnitProperly(iPlayer, GameInfoTypes.UNITCLASS_TRIREME, GameInfoTypes.UNIT_ITG_NW_TRIREME)
		SetUniqueUnitProperly(iPlayer, GameInfoTypes.UNITCLASS_GALLEASS, GameInfoTypes.UNIT_ITG_NW_GALLEASS)
		DoUnlockUnitClass(iPlayer, GameInfoTypes.UNITCLASS_TRIREME, -1)
		DoUnlockUnitClass(iPlayer, GameInfoTypes.UNITCLASS_GALLEASS, -1)
	else
		Players[iPlayer]:DoOverideBuildingTechRequirement(GameInfoTypes.BUILDING_ITG_LIGHTHOUSE, false)
		Players[iPlayer]:DoOverideBuildingTechRequirement(GameInfoTypes.BUILDING_ITG_HARBOR, false)
		Players[iPlayer]:DoOverideUnitTechRequirement(GameInfoTypes.UNIT_ITG_NW_TRIREME, false)
		Players[iPlayer]:DoOverideUnitTechRequirement(GameInfoTypes.UNIT_ITG_NW_GALLEASS, false)
	end
	Teams[Players[iPlayer]:GetTeam()]:ChangeEmbarkedExtraMoves(iAdd)
end
function TAddRemoveTrialHorde6(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then
		SetUniqueUnitProperly(iPlayer, GameInfoTypes.UNITCLASS_TREBUCHET, GameInfoTypes.UNIT_ITG_TRIAL_SIEGE_TREBUCHET)
		DoUnlockUnitClass(iPlayer, GameInfoTypes.UNITCLASS_TREBUCHET, -1)
	else
		Players[iPlayer]:DoOverideUnitTechRequirement(GameInfoTypes.UNIT_ITG_TRIAL_SIEGE_TREBUCHET, false)
	end
	Players[iPlayer]:ChangeAttackCityDamageModifier(iAdd * 25);	
end
function TAddRemoveTrialHorde8(iPlayer, selfID, bAdd, iAdd, iOneZero)
	gT.Players[iPlayer].CanSettleNewCity = bAdd;
	gT.Players[iPlayer].ExtraTileNewCity = gT.Players[iPlayer].ExtraTileNewCity + 6 * iAdd;
	gT.Players[iPlayer].SettlerPointsFromTech = gT.Players[iPlayer].SettlerPointsFromTech + 7 * iAdd;
	gT.Players[iPlayer].ExtraMaxGovernors = gT.Players[iPlayer].ExtraMaxGovernors + iAdd;
	if bAdd then
		AppointNewGovernor(iPlayer)
	end
end
function TAddRemoveTrialViking2(iPlayer, selfID, bAdd, iAdd, iOneZero)
	Players[iPlayer]:IncreaseDamageOnCoastalCities(50 * iAdd);
	Players[iPlayer]:ChangeLeadershipAnyDomainCount(iAdd);
	Players[iPlayer]:ChangeCombatModFromStackedEmbarked(30 * iAdd);
	BasicTAddRemovePromotion(iPlayer, GameInfoTypes.PROMOTION_ITG_TRIAL_VIKING_2, bAdd, TARIsUnitClassXP)
end
function TAddRemoveTrialViking3(iPlayer, selfID, bAdd, iAdd, iOneZero)
	Players[iPlayer]:ChangeNavalHealCoastal(iAdd);
	gT.Players[iPlayer].SettlerPointsFromTech = gT.Players[iPlayer].SettlerPointsFromTech + 5 * iAdd;
	gT.Players[iPlayer].CanSettleForeignCont = bAdd;
end
function TAddRemoveTrialViking4(iPlayer, selfID, bAdd, iAdd, iOneZero)
	BasicTAddRemovePromotion(iPlayer, GameInfoTypes.PROMOTION_ITG_INNO_VIK_EMBARK, bAdd, TARIsDomainLand)
	for iUnit in Players[iPlayer]:Units() do
		if iUnit:GetDomainType() == dSea then
			if bAdd then
				SetUnitForcedStackType(iUnit, -1, "tVik4", -1)
			else
				CleanTemporaryITGStackType(iUnit, "tVik4")
			end
		end
	end
	Players[iPlayer]:ChangeEmbarkedFullyStackable(iAdd);
	Players[iPlayer]:ChangeFullMovesDisembark(iAdd);
end
function TAddRemoveTrialViking5(iPlayer, selfID, bAdd, iAdd, iOneZero)
	gT.Players[iPlayer].ExtraWorkboats = gT.Players[iPlayer].ExtraWorkboats + 3 * iAdd;
	BasicTAddRemovePromotion(iPlayer, GameInfoTypes.PROMOTION_ITG_INNO_VIKING_SEA_SIGHT, bAdd, TARIsDomainSea)
	TARUnitClassPromotion(iPlayer, GameInfoTypes.UNITCLASS_WORKBOAT, GameInfoTypes.PROMOTION_ITG_INNO_VIK_FISHBOATS, bAdd)
end
function TAddRemoveTrialViking7(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then
		EraseForeignReligionsFromPlayer(iPlayer)
		ChangeMeritocracy(iPlayer, 25)
		TakeCareOfEventMorale(iPlayer, 25, {5, "Fury of Old Gods"})
		AddCulturalPresenceInAllCities(iPlayer, iPlayer, 100)
		for iCity in Players[iPlayer]:Cities() do
			iCity:SetNumReligionPressure(0, 5000 + iCity:GetNumReligionPressure(0))
		end
	end
	Players[iPlayer]:ChangeFuryOfGods(iAdd * 25);
	gT.Players[iPlayer].UntargetByMissionary = bAdd;
end
function TAddRemoveTrialViking8(iPlayer, selfID, bAdd, iAdd, iOneZero)
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		if gT.Cities[cID].FestivalET then
			iCity:ChangeYieldRateModifier(yCulture, 50 * iAdd)
		end
	end
end
function TAddRemoveAncientEmpire1(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then
		DoAddSpecialUnitForced(iPlayer, GameInfoTypes.UNITCLASS_SWORDSMAN, GameInfoTypes.UNIT_ITG_AOT_SWORDSMAN_ROMAN)
	end
end
function TAddRemoveAncientEmpire2(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then
		SetUniqueUnitProperly(iPlayer, GameInfoTypes.UNITCLASS_CATAPULT, GameInfoTypes.UNIT_ITG_ANCIENT_BALLISTA)
	end
end
function TAddRemoveAncientEmpire3(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then
		DoAddNewBeliefOfType(iPlayer, 1)
	end
end
function TAddRemoveAncientEmpire4(iPlayer, selfID, bAdd, iAdd, iOneZero)
	Teams[Players[iPlayer]:GetTeam()]:ChangeRouteChange(-10 * iAdd)
	if bAdd then
		CreateGPImprovementNearCapital(iPlayer, GameInfoTypes.IMPROVEMENT_CUSTOMS_HOUSE)
	end
end
function TAddRemoveAncientEmpire5(iPlayer, selfID, bAdd, iAdd, iOneZero)
	Players[iPlayer]:SetITGMountainPassable(bAdd)
	Players[iPlayer]:SetTreatUnitsAsRoad(bAdd)
end
function TAddRemoveAncientEmpire6(iPlayer, selfID, bAdd, iAdd, iOneZero)
	gT.Players[iPlayer].NumMaxPledges =  gT.Players[iPlayer].NumMaxPledges + 2 * iAdd;
	InnoAlliesNotBulliable(iPlayer, iAdd)
end
function TAddRemoveAncientEmpire8(iPlayer, selfID, bAdd, iAdd, iOneZero)
	Players[iPlayer]:SetPlayerHasTrait(GameInfoTypes.TRAIT_ITG_ANCIENT_EMPIRE_8, iOneZero);
	gT.Players[iPlayer].CapitalAuthMod = gT.Players[iPlayer].CapitalAuthMod + iAdd;
end
function TAddRemoveAncientEmpire9(iPlayer, selfID, bAdd, iAdd, iOneZero)
	Players[iPlayer]:ChangeBarbarianCombatBonus(iAdd * 15);
	Players[iPlayer]:ChangeAlwaysSeeBarbCampsCount(iAdd);
	if bAdd then
		Players[iPlayer]:SetMaxBarbarianXP(99999);
	else
		Players[iPlayer]:SetMaxBarbarianXP(30)
	end
end
function TAddRemoveAncientEmpire10(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then
		if gT.Players[iPlayer].HasCodex then
			ChangeITGLegalPointsPercent(iPlayer, 400);
		else
			EstablishCodex(iPlayer)
		end
	end
end
function TAddRemoveAncientEmpire11(iPlayer, selfID, bAdd, iAdd, iOneZero)
	gT.Players[iPlayer].MinMeritocracy = gT.Players[iPlayer].MinMeritocracy + 20 * iAdd;
end
function TAddRemoveAncientEmpire13(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then
		if CanDoWonderRaceRightNow(iPlayer) then
			StartWonderRace(iPlayer)
		end
	end
end
function TAddRemoveAncientEmpire15(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then
		AppointNewGovernor(iPlayer)
	end
	gT.Players[iPlayer].ExtraMaxGovernors = gT.Players[iPlayer].ExtraMaxGovernors + iAdd;
end
function TAddRemoveAncientEmpire16(iPlayer, selfID, bAdd, iAdd, iOneZero)
	for iCity in Players[iPlayer]:Cities() do
		iCity:ChangeMaxFoodKeptPercent(25 * iAdd)
	end
end
function TAddRemoveAncientEmpire17(iPlayer, selfID, bAdd, iAdd, iOneZero)
	Players[iPlayer]:DoOverideBuildingTechRequirement(GameInfoTypes.BUILDING_ITG_COLOSSEUM, bAdd)
end
function TAddRemoveAncientEmpire19(iPlayer, selfID, bAdd, iAdd, iOneZero)
	Players[iPlayer]:ChangeCulturePerGarrisonedUnit(1);
	Players[iPlayer]:ChangeGarrisonFreeMaintenanceCount(1);
	Players[iPlayer]:ChangeHappinessPerGarrisonedUnit(1);
	gT.Players[iPlayer].SpecialUUTresholdRed = gT.Players[iPlayer].SpecialUUTresholdRed - 80 * iAdd;
end
function TAddRemoveAncientEmpire20(iPlayer, selfID, bAdd, iAdd, iOneZero)
	Players[iPlayer]:SetWarmongeringIgnorableByCS(bAdd);
	Players[iPlayer]:SetPlayerHasTrait(GameInfoTypes.TRAIT_ITG_ANCIENT_EMPIRE_20, iOneZero);
end
function TAddRemoveAncientCS1(iPlayer, selfID, bAdd, iAdd, iOneZero)
	gT.Players[iPlayer].BaseSettlementStrength = gT.Players[iPlayer].BaseSettlementStrength + 2 * iAdd;
end
function TAddRemoveAncientCS4(iPlayer, selfID, bAdd, iAdd, iOneZero)
	Players[iPlayer]:SetPlayerHasTrait(GameInfoTypes.TRAIT_ITG_ANCIENT_CS_4, iOneZero);
end
function TAddRemoveAncientCS5(iPlayer, selfID, bAdd, iAdd, iOneZero)
	Players[iPlayer]:SetOlympusFaith(bAdd)
	if bAdd then
		DoAddNewBeliefOfType(iPlayer, 1)
		if Players[iPlayer]:GetReligionCreatedByPlayer() > 0 then
			gT.Players[iPlayer].HolySitePoints = gT.Players[iPlayer].HolySitePoints + 1;
		else
			gT.Players[iPlayer].HolySiteOnFoundRel = true;
		end
	end
end
function TAddRemoveAncientCS6(iPlayer, selfID, bAdd, iAdd, iOneZero)
	ChangeStrengthOfAllGenAdm(iPlayer, 3 * iAdd)
	Players[iPlayer]:ChangeExtraDefensePerAttack(50 * iAdd)
end
function TAddRemoveAncientCS9(iPlayer, selfID, bAdd, iAdd, iOneZero)
	Teams[Players[iPlayer]:GetTeam()]:SetCanSeeHiddenResource(bAdd)
	if bAdd then
		DoAddNewColonyPoint(iPlayer, 1)
		PlayerFindsHiddenResources()
	end
	gT.Players[iPlayer].TechColonyPoints = gT.Players[iPlayer].TechColonyPoints + 5 * iAdd;
end
function TAddRemoveAncientCS11(iPlayer, selfID, bAdd, iAdd, iOneZero)
	gT.Players[iPlayer].FeatureRemovalMod = gT.Players[iPlayer].FeatureRemovalMod + iAdd;
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		if gT.Cities[cID].FeaturesRemoved > 0 then
			iCity:ChangeMaxHitPoints(iAdd * 25 * gT.Cities[cID].FeaturesRemoved)
			ChangeITGCityInteger(iCity, "CI_HEALTH_FROM_INNO", iAdd * gT.Cities[cID].FeaturesRemoved)
		end
	end
end
function TAddRemoveAncientCS12(iPlayer, selfID, bAdd, iAdd, iOneZero)
	for g, gd in pairs(gT.Players) do
		if Players[g]:IsMinorCiv() then
			if gd.CultureType == gT.Players[iPlayer].CultureType then
				Players[g]:ChangeMinorCivExtraAnchorWithMajor(iPlayer, 100 * iAdd)
				Players[g]:ChangeMinorCivRecoveryModWithMajor(iPlayer, 100 * iAdd)
				if gd.SubcultureType == gT.Players[iPlayer].SubcultureType then
					Players[g]:ChangeMinorCivExtraAnchorWithMajor(iPlayer, 100 * iAdd)
					Players[g]:ChangeMinorCivRecoveryModWithMajor(iPlayer, 100 * iAdd)
				end
			end
		end
	end
end
function TAddRemoveAncientCS13(iPlayer, selfID, bAdd, iAdd, iOneZero)
	gT.Players[iPlayer].VotesFromInno = gT.Players[iPlayer].VotesFromInno + iAdd;
	gT.Players[iPlayer].PowerFromTech = gT.Players[iPlayer].PowerFromTech + 10 * iAdd;
end
function TAddRemoveAncientCS14(iPlayer, selfID, bAdd, iAdd, iOneZero)
	Players[iPlayer]:SetCPOwnedYields(bAdd)
	gT.Players[iPlayer].CPForeignOwned = gT.Players[iPlayer].CPForeignOwned + iAdd * 2; 
end
function TAddRemoveAncientCS15(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then
		for i = 1, 3 do
			SimpleGenerateUnitOfType(iPlayer, GameInfoTypes.UNIT_WORKBOAT)
		end
	end
	gT.Players[iPlayer].ExtraWorkboats = gT.Players[iPlayer].ExtraWorkboats + 3 * iAdd;
	gT.Players[iPlayer].ExtraFoodFromFish = gT.Players[iPlayer].ExtraFoodFromFish + 5 * iAdd;
	Players[iPlayer]:DoOverideUnitTechRequirement(GameInfoTypes.UNIT_WORKBOAT, bAdd)
end
function TAddRemoveAncientCS16(iPlayer, selfID, bAdd, iAdd, iOneZero)
	Players[iPlayer]:ChangeITGOceanAttrition(50 * iAdd)
end
function TAddRemoveAncientCS17(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then
		for gpID, h in pairs(gT.Players[iPlayer].GreatPeople) do
			if gT.GreatPeople[gpID].Alive and (not gT.GreatPeople[gpID].Military) then
				gT.GreatPeople[gpID].DoNotMigrate = true;
			end
		end
	end
end
function TAddRemoveAncientCS18(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then
		local gTurn = GetITGGameTurn()
		for i = 1, 5 do
			GenerateNewCivilianGP(iPlayer, false, gTurn)
		end
	end
end
function TAddRemoveAncientCS19(iPlayer, selfID, bAdd, iAdd, iOneZero)
	Players[iPlayer]:SetPlayerHasTrait(GameInfoTypes.TRAIT_ITG_ANCIENT_CS_19, iOneZero);
end
function TAddRemoveAncientCS20(iPlayer, selfID, bAdd, iAdd, iOneZero)
	gT.Players[iPlayer].CulturalPresenceAura = gT.Players[iPlayer].CulturalPresenceAura + iAdd;
	gT.Players[iPlayer].CultureToPresence = gT.Players[iPlayer].CultureToPresence + 0.5 * iAdd;
end
function TAddRemoveAncientCS21(iPlayer, selfID, bAdd, iAdd, iOneZero)
	Players[iPlayer]:ChangeCitiesStrikeRange(iAdd);
end
function TAddRemoveAncientCS22(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then
		CreateGPImprovementNearCapital(iPlayer, GameInfoTypes.IMPROVEMENT_CUSTOMS_HOUSE)
	end
end
function TAddRemoveAncientCS23(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then
		Players[iPlayer]:DoOverideBuildingTechRequirement(GameInfoTypes.BUILDING_ITG_MINT_ANCIENT, true)
	end
end
function TAddRemoveAncientCS24(iPlayer, selfID, bAdd, iAdd, iOneZero)
	DoInitialDionysia(iPlayer, iAdd)
end
function TAddRemoveAncientCS25(iPlayer, selfID, bAdd, iAdd, iOneZero)
	Players[iPlayer]:ChangeCoastalCityYieldChange(yFood, iAdd * 3);
	Players[iPlayer]:ChangeCoastalCityYieldChange(yProduction, iAdd * 3);
end
function TAddRemoveAncientCS27(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then
		for i = 1, 3 do
			SimpleGenerateUnitOfType(iPlayer, GameInfoTypes.UNIT_ITG_AOT_HORSEMAN_GREEK, nil, 4, nil, true)
		end
	end
end
function TAddRemoveAncientCS28(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then
		gT.Players[iPlayer].NextInnoChance = gT.Players[iPlayer].NextInnoChance + 30;
		local numGw = 0;
		for type, val in pairs(gT.Players[iPlayer].BonusesAcquired) do
			numGw = numGw + 1;
		end
		if numGw > 0 then
			CreateGreatWorkOfAmount(iPlayer, numGw, "Random")
		end
	end
end
function TAddRemoveAncientCS29(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then
		InitialRadiusEmbassyInno(iPlayer)
		DoAdjustBonusFromCartographers(iPlayer)
	else
		gT.Players[iPlayer].CultureFromMap = 0;
	end
end
function TAddRemoveAncientCS31(iPlayer, selfID, bAdd, iAdd, iOneZero)
	Players[iPlayer]:SetPlayerHasTrait(GameInfoTypes.TRAIT_ITG_ANCIENT_CS_31, iOneZero);
	SetDirtyCanDominateCS(iPlayer)
end
function TAddRemoveAncientCS32(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then
		AppointNewGovernor(iPlayer)
	end
	gT.Players[iPlayer].ExtraMaxGovernors = gT.Players[iPlayer].ExtraMaxGovernors + iAdd;
	gT.Players[iPlayer].GovActivityMod = gT.Players[iPlayer].GovActivityMod + 0.5 * iAdd;
end
function TAddRemoveAncientTribe1(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then
		Players[iPlayer]:SetCannotConquerCities(false)
		gT.Players[iPlayer].OccupyLimit = nil;
	end
	gT.Players[iPlayer].GovOnNextConquest = bAdd;
end
function TAddRemoveAncientTribe2(iPlayer, selfID, bAdd, iAdd, iOneZero)
	Players[iPlayer]:SetPlayerHasTrait(GameInfoTypes.TRAIT_ITG_ANCIENT_TRIBE_2, iOneZero);
	if bAdd then
		DoAddNewBeliefOfType(iPlayer, 1)
		GenerateGreatSeer(iPlayer)
	end
end
function TAddRemoveAncientTribe3(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then
		SpawnRandomUnits(iPlayer, 12, true)
		ChangeITGGold(iPlayer, 120)
		ChangeMeritocracy(iPlayer, 12);
	end
end
function TAddRemoveAncientTribe4(iPlayer, selfID, bAdd, iAdd, iOneZero)
	Players[iPlayer]:SetFullyStackableWithBarbs(bAdd)
	if bAdd then
		Teams[63]:MakePeace(Players[iPlayer]:GetTeam())
		Teams[Players[iPlayer]:GetTeam()]:SetPermanentWarPeace(63, true)
	else
		Teams[63]:DeclareScriptedWar(Players[iPlayer]:GetTeam())
		Players[iPlayer]:SetFullyStackableWithBarbs(false)
	end
end
function TAddRemoveAncientTribe6(iPlayer, selfID, bAdd, iAdd, iOneZero)
	Players[iPlayer]:ChangeMinorAfraidPerTurnInfluence(iAdd * 300);
	Players[iPlayer]:ChangeMinorBullyScoreMod(iAdd * 25);
	Players[iPlayer]:SetAllCSGiftUnits(bAdd)
end
function TAddRemoveAncientTribe7(iPlayer, selfID, bAdd, iAdd, iOneZero)
	BasicTAddRemovePromotion(iPlayer, GameInfoTypes.PROMOTION_ITG_VANDAL_NAVY, bAdd, TARIsDomainSea, TARIsUnitClassXP)
end
function TAddRemoveAncientTribe8(iPlayer, selfID, bAdd, iAdd, iOneZero)
	Players[iPlayer]:SetPlayerHasTrait(GameInfoTypes.TRAIT_ITG_ANCIENT_TRIBE_8, iOneZero);
end
function TAddRemoveAncientTribe9(iPlayer, selfID, bAdd, iAdd, iOneZero)
	DoUpdateYieldModifiersVarious(iPlayer)
end
function TAddRemoveAncientTribe10(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then
		gT.Players[iPlayer].NationalDays = gT.Players[iPlayer].NationalDays + 2;
		table.insert(gT.Players[iPlayer].NatDays, 173)
		table.insert(gT.Players[iPlayer].NatDays, 357)
		gT.Players[iPlayer].NatSeasons[2] = (gT.Players[iPlayer].NatSeasons[2] or 0) + 1;
		gT.Players[iPlayer].NatSeasons[4] = (gT.Players[iPlayer].NatSeasons[4] or 0) + 1;
	end
end
function TAddRemoveAncientTribe11(iPlayer, selfID, bAdd, iAdd, iOneZero)
	Players[iPlayer]:SetPlayerHasTrait(GameInfoTypes.TRAIT_ITG_TECH_INNO_ATRIBE_11, iOneZero);
	local iTeam = Players[iPlayer]:GetTeam()
	if bAdd then
		for index, info in pairs(gT.Globals.AncientRuins) do
			if Map.GetPlotByIndex(index):AlreadyVisitedGoodyHut(iTeam) then
				AddOneRadiusVisibility(Map.GetPlotByIndex(index), iPlayer, "AncientRuinsVisMod")
			end
		end
	else
		for index, sth in pairs(gT.Players[iPlayer].AncientRuinsVisMod) do
			Map.GetPlotByIndex(index):ChangeVisibilityCount(iTeam, -sth)
		end
		gT.Players[iPlayer].AncientRuinsVisMod = {}
	end
end
function TAddRemoveAncientTribe12(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then
		GenerateDistantCity(iPlayer)
	end
end
function TAddRemoveAncientTribe15(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then
		DoAddRandomSpecialUU(iPlayer)
	end
end
function TAddRemoveAncientTribe17(iPlayer, selfID, bAdd, iAdd, iOneZero)
	local hVal = iAdd * 2;
	for iCity in Players[iPlayer]:Cities() do
		iCity:ChangeResourceExtraYield(GameInfoTypes.RESOURCE_GOLD, yCulture, hVal)
		iCity:ChangeResourceExtraYield(rIron, yCulture, hVal)
		iCity:ChangeResourceExtraYield(GameInfoTypes.RESOURCE_SILVER, yCulture, hVal)
		iCity:ChangeResourceExtraYield(GameInfoTypes.RESOURCE_COPPER, yCulture, hVal)
		iCity:ChangeResourceExtraYield(GameInfoTypes.RESOURCE_GOLD, yProduction, hVal)
		iCity:ChangeResourceExtraYield(rIron, yProduction, hVal)
		iCity:ChangeResourceExtraYield(GameInfoTypes.RESOURCE_SILVER, yProduction, hVal)
		iCity:ChangeResourceExtraYield(GameInfoTypes.RESOURCE_COPPER, yProduction, hVal)
	end
end
function TAddRemoveAncientTribe18(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then
		SimpleGenerateUnitOfType(iPlayer, Players[iPlayer]:GetPlayerUniqueUnit(GameInfoTypes.UNITCLASS_SCOUT))
	end
	TARUnitClassPromotion(iPlayer, GameInfoTypes.UNITCLASS_SCOUT, GameInfoTypes.PROMOTION_ITG_INNO_ANCIENT_TR_18, bAdd)
end
function TAddRemoveAncientTribe20(iPlayer, selfID, bAdd, iAdd, iOneZero)
	for iCity in Players[iPlayer]:Cities() do
		if bAdd then
			for i = 1, 6 do
				DoITGCityAcquirePlot(iCity)
			end
		end
		iCity:ChangeWorkersAmount(iAdd)
	end
end
function TAddRemoveNWArab1(iPlayer, selfID, bAdd, iAdd, iOneZero)
	Players[iPlayer]:ChangeBuildingClassProdModifier(GameInfoTypes.BUILDINGCLASS_ITG_LS_PALACE_UPGRADE, iAdd * 33)
end
function TAddRemoveNWArab2(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then
		for iCity in Players[iPlayer]:Cities() do
			local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
			if #gT.Cities[cID].CustomsHouses > 0 then
				iCity:ChangeExtraLuxuryCount(iAdd)
			end
		end
		IfActiveThenRefreshDirty(iPlayer)
	end
end
function TAddRemoveNWArab3(iPlayer, selfID, bAdd, iAdd, iOneZero)
	Players[iPlayer]:ChangePlayerBuildingClassYieldChange(GameInfoTypes.BUILDINGCLASS_FORGE, yProduction, 2 * iAdd);
	Players[iPlayer]:ChangePlayerBuildingClassYieldChange(GameInfoTypes.BUILDINGCLASS_STABLE, yProduction, 2 * iAdd);
	if bAdd then
		AddFreeManufactory(iPlayer) -- KEEP HERE; good order
		for i, v in pairs(gT.Manufactories) do
			if v.Player == iPlayer then
				DoAddFreeAbilityManufactory(i, "bDamascus")
			end
		end
	end
	for iUnit in Players[iPlayer]:Units() do
		if iUnit:GetUnitCombatType() == GameInfoTypes.UNITCOMBAT_MELEE then
			ChangeITGBaseCombatStrength(iUnit, 2 * iAdd, nil)
		end			
	end
end
function TAddRemoveNWArab7(iPlayer, selfID, bAdd, iAdd, iOneZero)
	gT.Players[iPlayer].ConversionLossBonusesModifier = gT.Players[iPlayer].ConversionLossBonusesModifier + 0.5 * iAdd;
end
function TAddRemoveNWArab8(iPlayer, selfID, bAdd, iAdd, iOneZero)
	Players[iPlayer]:ChangeMinorGoldFriendshipMod(iAdd * 25);
	for g, j in pairs(gT.Players) do
		if Players[g]:IsMinorCiv() then
			Players[g]:ChangeMinorCivDecayModWithMajor(iPlayer, -10 * iAdd)
		end
	end
	ChangeNumMaxPledgesOfProtection(iPlayer, iAdd)
end
function TAddRemoveNWMeso1(iPlayer, selfID, bAdd, iAdd, iOneZero)
	Players[iPlayer]:ChangeITGAttritionDamage(-25 * iAdd);
	if bAdd then
		gT.Players[iPlayer].UniqueImprovements[GameInfoTypes.IMPROVEMENT_TERRACE_FARM] = true;
		DoReplacePlayerImproWithUnique(iPlayer, GameInfoTypes.IMPROVEMENT_TERRACE_FARM, GameInfoTypes.IMPROVEMENT_FARM)
	end
end
function TAddRemoveNWMeso2(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then	
		gT.Players[iPlayer].MesoElDoradoPoints = 1 + gT.Players[iPlayer].MesoElDoradoPoints
	end
end
function TAddRemoveNWMeso3(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then
		Players[iPlayer]:SetMaxBarbarianXP(99999);
	else
		Players[iPlayer]:SetMaxBarbarianXP(30)
	end
	for iUnit in Players[iPlayer]:Units() do
		if iUnit:GetUnitType() == GameInfoTypes.UNIT_GARRISON then
			iUnit:SetHasPromotion(GameInfoTypes.PROMOTION_ITG_INNOVATION_AZTEC_FEAR_10, bAdd)
		end
	end
end
function TAddRemoveNWMeso5(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then
		DoCheckMeso5Beliefs(iPlayer)
	end
end
function TAddRemoveNWMeso6(iPlayer, selfID, bAdd, iAdd, iOneZero)
	gT.Players[iPlayer].HasMintAlways = (gT.Players[iPlayer].HasMintAlways or 0) + iAdd;
	gT.Players[iPlayer].ResCurrencyAmountMod = gT.Players[iPlayer].ResCurrencyAmountMod + iAdd * 2;
	Players[iPlayer]:SetIgnoreStrategicResources(bAdd)
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		for res, sth in pairs(gT.Cities[cID].CurrencyResYield) do
			iCity:ChangeResourceExtraYield(res, yGold, 6 * iAdd)
			gT.Cities[cID].CurrencyResYield[res] = sth + 6 * iAdd;
		end
	end
end
function TAddRemoveNWMeso7(iPlayer, selfID, bAdd, iAdd, iOneZero)
	Players[iPlayer]:SetPlayerHasTrait(GameInfoTypes.TRAIT_ITG_TECH_INNO_MESO_7, iOneZero);
	if bAdd then
		gT.SetXY.AncientRuinsRadar[iPlayer] = 1;
		DoInitialRadarAncientData(iPlayer)
	else
		gT.SetXY.AncientRuinsRadar[iPlayer] = nil;
	end
end
function TAddRemoveNWEuro3(iPlayer, selfID, bAdd, iAdd, iOneZero)
	Players[iPlayer]:SetCanUseCurrents(bAdd);
	gT.Players[iPlayer].DifLandMassConnect = gT.Players[iPlayer].DifLandMassConnect + iAdd;
	if iPlayer == Game.GetActivePlayer() then
		LuaEvents.ITGPlayerSuddenlyCanSeeCurrents();
	end
end
function TAddRemoveNWEuro4(iPlayer, selfID, bAdd, iAdd, iOneZero)
	ChangeYieldModFromPalace(iPlayer, 1 * iAdd)
	BoostPlayerPower(iPlayer, "Absolutism", 100 * iAdd);
end
function TAddRemoveNWEuro6(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then
		gT.SetXY.Colonialism[iPlayer] = 1;
	else
		gT.SetXY.Colonialism[iPlayer] = nil;
	end
	Teams[Players[iPlayer]:GetTeam()]:SetCanSeeHiddenResource(bAdd)
	if bAdd then
		PlayerFindsHiddenResources()
	end
end
function TAddRemoveNWEuro7(iPlayer, selfID, bAdd, iAdd, iOneZero)
	Players[iPlayer]:ChangeSetUpMovesCost(-60 * iAdd);
	Players[iPlayer]:ChangeUnitCombatProductionModifiers(GameInfoTypes.UNITCOMBAT_SIEGE, iAdd * 25)
	for iUnit in Players[iPlayer]:Units() do
		if iUnit:GetUnitCombatType() == GameInfoTypes.UNITCOMBAT_SIEGE then
			ChangeITGBaseCombatStrength(iUnit, nil, 2 * iAdd)
		end
	end
	if bAdd then
		if not HaveUnlockedUnitClass(iPlayer, GameInfoTypes.UNITCLASS_TREBUCHET, "Inno") then
			if not HaveUnlockedUnitClass(iPlayer, GameInfoTypes.UNITCLASS_CANNON, "Inno") then
				gT.Players[iPlayer].UnitClassXP[GameInfoTypes.UNITCLASS_CANNON] = gT.Players[iPlayer].UnitClassXP[GameInfoTypes.UNITCLASS_CANNON] + 100;
			-- it is ranged unit !!!
			--	if not HaveUnlockedUnitClass(iPlayer, GameInfoTypes.UNITCLASS_GATLINGGUN, "Inno") then
			end
		end
	end
end
function TAddRemoveNWEuro8(iPlayer, selfID, bAdd, iAdd, iOneZero)
	gT.Players[iPlayer].GPYieldsMod = 1 * iAdd + gT.Players[iPlayer].GPYieldsMod
	gT.Players[iPlayer].ExtraGPAttractions = 10 * iAdd + gT.Players[iPlayer].ExtraGPAttractions
end
function TAddRemoveIndustrial1(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd and (gT.Globals.TechFirstTeams[selfID] == iPlayer) then
		SimpleGenerateUnitOfType(iPlayer, Players[iPlayer]:GetPlayerUniqueUnit(GameInfoTypes.UNITCLASS_CAVALRY))
		SimpleGenerateUnitOfType(iPlayer, Players[iPlayer]:GetPlayerUniqueUnit(GameInfoTypes.UNITCLASS_RIFLEMAN))
		SimpleGenerateUnitOfType(iPlayer, Players[iPlayer]:GetPlayerUniqueUnit(GameInfoTypes.UNITCLASS_ITG_IND_CANNON_2))
	end
end
function TAddRemoveIndustrial2(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd and (gT.Globals.TechFirstTeams[selfID] == iPlayer) then
		for index, data in pairs(gT.Academies) do
			if data.Player == iPlayer then
				if IsAcademyActiveRightNow(index) then
					AddPrestigeToAcademy(index, 200, "Vaccination")
				end
			end
		end
	end
end
function TAddRemoveIndustrial3(iPlayer, selfID, bAdd, iAdd, iOneZero)
	gT.Players[iPlayer].CanHeadhunt = bAdd;
	ChangeGeneralGlobalAura(iPlayer, iAdd)
end
function TAddRemoveIndustrial4(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd and (gT.Globals.TechFirstTeams[selfID] == iPlayer) then
		IncreaseGeneralPointsByNonCombat(iPlayer, 200)
		IncreaseAdmiralPointsByNonCombat(iPlayer, 200)
	end
end
function TAddRemoveIndustrial5(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd and (gT.Globals.TechFirstTeams[selfID] == iPlayer) then
		CreateGreatWorkOfAmount(iPlayer, 3, "Art")
	end
end
function TAddRemoveIndustrial6(iPlayer, selfID, bAdd, iAdd, iOneZero)
	gT.Globals.AbolitionMovement = bAdd;
end
function TAddRemoveIndustrial7(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if gT.Globals.TechFirstTeams[selfID] == iPlayer then
		for g, h in pairs(gT.Players) do
			if Players[g]:IsMinorCiv() then
				Players[g]:ChangeMinorCivExtraAnchorWithMajor(iPlayer, iAdd * MINOR_CIV_ANCHOR_FASCISM)
			end
		end
	end
end
function TAddRemoveIndustrial8(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then
		CreateAgentNew(iPlayer, false, true)
	end
	gT.Players[iPlayer].PowerFromTech = gT.Players[iPlayer].PowerFromTech + iAdd * 10;
end
function TAddRemoveIndustrial9(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if gT.Globals.TechFirstTeams[selfID] == iPlayer then
		SetBuildingClassMaintenanceFree(iPlayer, GameInfoTypes.BUILDINGCLASS_MUSEUM, not bAdd)
	end
end
function TAddRemoveIndustrial10(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then
		if gT.Globals.TechFirstTeams[selfID] == iPlayer then
			if gT.Players[iPlayer].CultureEra < 9 and ((gT.Players[iPlayer].CultureEra ~= 6) or Teams[Players[iPlayer]:GetTeam()]:IsHasTech(gT.Players[iPlayer].LastCultureTechPrereq)) then
				UpgradePlayerToNextCulturalEra(iPlayer)
			else
				ChangeITGCulture(iPlayer, 1000)		
			end
		end
	end
end
function TAddRemoveIndustrial11(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if gT.Globals.TechFirstTeams[selfID] == iPlayer then
		ChangeITGExtraResources(iPlayer, rOil, iAdd * 5)
	end
end
function TAddRemoveIndustrial12(iPlayer, selfID, bAdd, iAdd, iOneZero)
	gT.Players[iPlayer].ResCurrencyAmountMod = gT.Players[iPlayer].ResCurrencyAmountMod + iAdd * 2;
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		for res, sth in pairs(gT.Cities[cID].CurrencyResYield) do
			iCity:ChangeResourceExtraYield(res, yGold, 3 * iAdd)
			gT.Cities[cID].CurrencyResYield[res] = sth + 3 * iAdd;
		end
	end
end
function TAddRemoveIndustrial13(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then
		if gT.Globals.TechFirstTeams[selfID] == iPlayer then
			GenerateNewCivilianGP(iPlayer, false, GetITGGameTurn(), {Type = 3})
			GenerateNewCivilianGP(iPlayer, false, GetITGGameTurn(), {Type = 3})
		end
		AddAnExtraDepartment(iPlayer, "Electromagnetism", "Science")
	end
end
function TAddRemoveIndustrial14(iPlayer, selfID, bAdd, iAdd, iOneZero)
	local improPlantation = GameInfoTypes.IMPROVEMENT_PLANTATION;
	if gT.Globals.TechFirstTeams[selfID] == iPlayer then
		Players[iPlayer]:ChangeImprovementYieldChange(improPlantation, yGold, iAdd)
	end
	if bAdd then
		local improFarm = GameInfoTypes.IMPROVEMENT_FARM;
		local resWheat = GameInfoTypes.RESOURCE_WHEAT;
		local bHighlight = iPlayer == Game.GetActivePlayer();
		local iTeam = Players[iPlayer]:GetTeam();
		local hTab = {};
		for b = 0, Map:GetNumPlots() - 1, 1 do
			local fPlot = Map.GetPlotByIndex( b );
			if fPlot:GetOwner() == iPlayer then
				local iImpro = fPlot:GetImprovementType();
				if iImpro == -1 then
					if not fPlot:IsCity() then
						if fPlot:CanHaveImprovement(improFarm, iTeam) then
							CreateNewImprovementOnPlot(fPlot, improFarm, false, false)
						elseif fPlot:CanHaveImprovement(iPlantation, iTeam) then
							CreateNewImprovementOnPlot(fPlot, iPlantation, false, false)
						end
					end
				elseif fPlot:GetResourceType() == -1 then
					if not fPlot:IsImprovementPillaged() then
						if iImpro == improFarm then
							if fPlot:CanHaveResource(resWheat) then
								table.insert(hTab, b)
							end
						end
					end
				end
			end
		end
		local hCount = 5;
		hTab = Shuffle(hTab);
		for j, v in pairs(hTab) do
			hCount = hCount + 1;
			if hCount == 6 then
				hCount = 0;
				AddProperlyResourceOnPlot(Map.GetPlotByIndex(v), resWheat, true, bHighlight)
			end
		end
	end
end
function TAddRemoveIndustrial15(iPlayer, selfID, bAdd, iAdd, iOneZero)
	Players[iPlayer]:ChangeBarbarianCombatBonus(33 * iAdd)
	Players[iPlayer]:ChangeCombatModVSSmallerCivs(10 * iAdd)
	if gT.Globals.TechFirstTeams[selfID] == iPlayer then
		Players[iPlayer]:ChangeCombatModVSSmallerCivs(10 * iAdd)
	end
end
function TAddRemoveIndustrial16(iPlayer, selfID, bAdd, iAdd, iOneZero)
	for iCity in Players[iPlayer]:Cities() do
		iCity:ChangeWorkersAmount(iAdd)
	end
	if bAdd and (gT.Globals.TechFirstTeams[selfID] == iPlayer) then
		GenerateNewCivilianGP(iPlayer, false, GetITGGameTurn(), {Type = 9})
		GenerateNewCivilianGP(iPlayer, false, GetITGGameTurn(), {Type = 9})
	end
end
function TAddRemoveIndustrial17(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then
		GenerateNewCivilianGP(iPlayer, false, GetITGGameTurn(), {Type = 9, ForcedBonusClass = 3})
	end
	if gT.Globals.TechFirstTeams[selfID] == iPlayer then
		for g, h in pairs(gT.Players) do
			if Players[g]:IsMinorCiv() then
				Players[g]:ChangeMinorCivDecayModWithMajor(iPlayer, -20 * iAdd)
				Players[g]:ChangeMinorCivRecoveryModWithMajor(iPlayer, 20 * iAdd)
			end
		end
	end
end
function TAddRemoveIndustrial18(iPlayer, selfID, bAdd, iAdd, iOneZero)
	Players[iPlayer]:ChangeBuildingClassHappiness(GameInfoTypes.BUILDINGCLASS_MARKET, iAdd)
	Players[iPlayer]:ChangeBuildingClassHappiness(GameInfoTypes.BUILDINGCLASS_BANK, iAdd)
end
function TAddRemoveIndustrial19(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd and (gT.Globals.TechFirstTeams[selfID] == iPlayer) then
		gT.Players[iPlayer].NumFortPoints = gT.Players[iPlayer].NumFortPoints + 1; 
	end
end
function TAddRemoveIndustrial20(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then
		local active = {}
		local any = {}
		for g, s in pairs(gT.Academies) do
			if s.Player == iPlayer then
				if IsAcademyActiveRightNow(g) then
					table.insert(active, g)
				else
					table.insert(any, g)
				end		
			end
		end
		local mod = 0.25;
		if gT.Globals.TechFirstTeams[selfID] == iPlayer then
			mod = 0.33;
		end
		if #active > 0 then
			gT.Academies[active[LastRandom(1,#active)]].NationalMod = mod;
		elseif #any > 0 then
			gT.Academies[any[LastRandom(1,#any)]].NationalMod = mod;
		else
			gT.Players[iPlayer].NextAcademyIsNational = mod;
		end
	end
end
function TAddRemoveTrialAfrica1(iPlayer, selfID, bAdd, iAdd, iOneZero)
	Players[iPlayer]:ChangeHurryModifier(GameInfoTypes.HURRY_GOLD, -20 * iAdd)
	UpdateOverRiderFaithCost(iPlayer)
end
function TAddRemoveTrialAfrica2(iPlayer, selfID, bAdd, iAdd, iOneZero)
	for row in GameInfo.Resources() do
		if row.Happiness > 0 then
			for iCity in Players[iPlayer]:Cities() do
				iCity:ChangeResourceExtraYield(rowID, yGold, 3 * iAdd)
			end
		end
	end
end
function TAddRemoveTrialAfrica3(iPlayer, selfID, bAdd, iAdd, iOneZero)
	gT.Players[iPlayer].PalaceAttraction = bAdd;
	Players[iPlayer]:ChangeBuildingClassProdModifier(GameInfoTypes.BUILDINGCLASS_ITG_LS_PALACE_UPGRADE, iAdd * 100)
	Players[iPlayer]:ChangeBuildingClassProdModifier(GameInfoTypes.BUILDINGCLASS_LS_WONDER_PROCESS, iAdd * 25)
end
function TAddRemoveTrialAfrica4(iPlayer, selfID, bAdd, iAdd, iOneZero)
	gT.Players[iPlayer].HasMintAlways = (gT.Players[iPlayer].HasMintAlways or 0) + iAdd;
	gT.Players[iPlayer].ImproCostMod = gT.Players[iPlayer].ImproCostMod - iAdd * 0.3;
	if bAdd then
		local iTeam = Players[iPlayer]:GetTeam();
		local vTab = {}
		for b = 0, Map:GetNumPlots() - 1, 1 do
			local fPlot = Map.GetPlotByIndex( b );
			if fPlot:GetOwner() == iPlayer then
				if fPlot:GetResourceType() == -1 then
					if fPlot:CanHaveResource(gT.Players[iPlayer].Currencies) then
						table.insert(vTab, fPlot)
						break;
					end
				end
			end
		end
		vTab = Shuffle(vTab)
		local bActiveP = iPlayer == Game.GetActivePlayer();
		for i = 1, 6 do
			if vTab[i] then
				AddProperlyResourceOnPlot(vTab[i], gT.Players[iPlayer].Currencies, true, bActiveP)
			end
		end
	end
end
function TAddRemoveTrialAfrica5(iPlayer, selfID, bAdd, iAdd, iOneZero)
	Players[iPlayer]:ChangeBorderEndMoves(iAdd)
	Players[iPlayer]:ChangeCitiesStrikeRange(iAdd)
end
function TAddRemoveTrialAfrica6(iPlayer, selfID, bAdd, iAdd, iOneZero)
	for iUnit in Players[iPlayer]:Units() do
		local jID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
		if gT.FortsByUnitID[jID] then
			iUnit:SetHasPromotion(GameInfoTypes.PROMOTION_ITG_MED_INNO_AFR_6, bAdd)
		end
	end
end
function TAddRemoveTrialAfrica7(iPlayer, selfID, bAdd, iAdd, iOneZero)
	Players[iPlayer]:ChangeFreePromotionCount(GameInfoTypes.PROMOTION_AMPHIBIOUS,iAdd)
	Players[iPlayer]:ChangeFreePromotionCount(GameInfoTypes.PROMOTION_WAR_CANOES,iAdd)
end
function TAddRemoveTrialAfrica8(iPlayer, selfID, bAdd, iAdd, iOneZero)
	Players[iPlayer]:SetPlayerHasTrait(GameInfoTypes.TRAIT_INNO_AFR_MED_8, iOneZero);
end
function TAddRemoveNWTropical2(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then
		DoPirateCall(iPlayer)
	end
	ChangeOccupyLimit(iPlayer, iAdd)
end
function TAddRemoveNWTropical3(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then
		local nCb = gT.Players[iPlayer].NumPirateMods
		for i = 1, 10 do
			if i <= nCb then
				GenerateGreatAdmiralForPlayer(iPlayer)
			else
				AddNewPirateMod(iPlayer)
			end
		end
	end
end
function TAddRemoveNWTropical5(iPlayer, selfID, bAdd, iAdd, iOneZero)
	ChangeGoldFromImportingAllDeals(iPlayer, iAdd)
	ChangeGoldFromExportingAllDeals(iPlayer, 2 * iAdd)
end
function TAddRemoveNWTropical6(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then
		DoTurnSevenSeasPromotions(iPlayer)
	end
end
function TAddRemoveNWTropical7(iPlayer, selfID, bAdd, iAdd, iOneZero)
	if bAdd then
		AppointNewGovernor(iPlayer)
	end
	gT.Players[iPlayer].ExtraMaxGovernors = gT.Players[iPlayer].ExtraMaxGovernors + iAdd;
end
function TAddRemoveNWTropical8(iPlayer, selfID, bAdd, iAdd, iOneZero)
	Players[iPlayer]:ChangeTropicalRepairCity(iAdd);
	TARUnitClassPromotion(iPlayer, GameInfoTypes.UNITCLASS_CARGO_SHIP, GameInfoTypes.PROMOTION_ITG_FLEE_TROPICAL_INNO, bAdd)
end
function TAddRemoveModern1(iPlayer, selfID, bAdd, iAdd, iOneZero)
	TARBasicModernUnitclass(iPlayer, bAdd, GameInfoTypes.UNITCLASS_TANK, -15 * iAdd);
	TARUnitClassPromotion(iPlayer, GameInfoTypes.UNITCLASS_TANK, GameInfoTypes.PROMOTION_ITG_MODERN_RAMMING, bAdd)
end
function TAddRemoveModern2(iPlayer, selfID, bAdd, iAdd, iOneZero)
	TARBasicModernUnitclass(iPlayer, bAdd, GameInfoTypes.UNITCLASS_TANK, -15 * iAdd);
	for iUnit in Players[iPlayer]:Units() do
		if iUnit:GetUnitClassType() == GameInfoTypes.UNITCLASS_TANK then
			iUnit:ChangeMaxHitPoints(35 * iAdd);
		end
	end
end
function TAddRemoveModern3(iPlayer, selfID, bAdd, iAdd, iOneZero)
	TARBasicModernUnitclass(iPlayer, bAdd, GameInfoTypes.UNITCLASS_TANK, -15 * iAdd);
end
function TAddRemoveModern4(iPlayer, selfID, bAdd, iAdd, iOneZero)
	TARBasicModernUnitclass(iPlayer, bAdd, GameInfoTypes.UNITCLASS_CARRIER, -15 * iAdd);
	for iUnit in Players[iPlayer]:Units() do
		if iUnit:GetUnitClassType() == GameInfoTypes.UNITCLASS_CARRIER then
			iUnit:ChangeCargoSpace(iAdd)
		end
	end
end
function TAddRemoveModern5(iPlayer, selfID, bAdd, iAdd, iOneZero)
	TARBasicModernUnitclass(iPlayer, bAdd, GameInfoTypes.UNITCLASS_CARRIER, -15 * iAdd);
	for iUnit in Players[iPlayer]:Units() do
		if iUnit:GetUnitClassType() == GameInfoTypes.UNITCLASS_CARRIER then
			local uID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
			if bAdd then
				if iUnit:GetDamage() == 0 then
					if not gT.Players[iPlayer].UnitsByID[uID].InnoModern5 then
						gT.Players[iPlayer].UnitsByID[uID].InnoModern5 = true;
						iUnit:ChangeMaxHitPoints(200);
					end
				end
			else
				if gT.Players[iPlayer].UnitsByID[uID].InnoModern5 then
					gT.Players[iPlayer].UnitsByID[uID].InnoModern5 = false;
					iUnit:ChangeMaxHitPoints(-200);
				end
			end
		end
	end
end
function TAddRemoveModern6(iPlayer, selfID, bAdd, iAdd, iOneZero)
	TARBasicModernUnitclass(iPlayer, bAdd, GameInfoTypes.UNITCLASS_DESTROYER, -15 * iAdd);
end
function TAddRemoveModern7(iPlayer, selfID, bAdd, iAdd, iOneZero)
	TARBasicModernUnitclass(iPlayer, bAdd, GameInfoTypes.UNITCLASS_SUBMARINE, -30 * iAdd);
	for iUnit in Players[iPlayer]:Units() do
		if iUnit:GetUnitClassType() == GameInfoTypes.UNITCLASS_SUBMARINE then
				if bAdd then
				local ts = iUnit:GetMoves() / iUnit:MaxMoves();
				iUnit:SetHasPromotion(GameInfoTypes.PROMOTION_ITG_MODERN_LONG_HUNT, true);
				iUnit:SetMoves(math.floor(iUnit:MaxMoves() * ts));
			else
				iUnit:SetHasPromotion(GameInfoTypes.PROMOTION_ITG_MODERN_LONG_HUNT, false)
			end
		end
	end
end
function TAddRemoveModern8(iPlayer, selfID, bAdd, iAdd, iOneZero)
	TARBasicModernUnitclass(iPlayer, bAdd, GameInfoTypes.UNITCLASS_SUBMARINE, -15 * iAdd);
	TARUnitClassPromotion(iPlayer, GameInfoTypes.UNITCLASS_SUBMARINE, GameInfoTypes.PROMOTION_ITG_MODERN_HIT_AND_RUN, bAdd)
end
function TAddRemoveModern9(iPlayer, selfID, bAdd, iAdd, iOneZero)
	TARBasicModernUnitclass(iPlayer, bAdd, GameInfoTypes.UNITCLASS_FIGHTER, -15 * iAdd);
	for iUnit in Players[iPlayer]:Units() do
		if iUnit:GetUnitClassType() == GameInfoTypes.UNITCLASS_FIGHTER then
			iUnit:ChangeMaxCombatFromCombatsMade(50 * iAdd);
			iUnit:ChangeBonusPerCombatMade(2 * iAdd);
		end
	end
end
function TAddRemoveModern10(iPlayer, selfID, bAdd, iAdd, iOneZero)
	TARBasicModernUnitclass(iPlayer, bAdd, GameInfoTypes.UNITCLASS_PARATROOPER, -15 * iAdd);
end
function TAddRemoveModern11(iPlayer, selfID, bAdd, iAdd, iOneZero)
	TARBasicModernUnitclass(iPlayer, bAdd, GameInfoTypes.UNITCLASS_BATTLESHIP, -15 * iAdd);
end
function TAddRemoveModern12(iPlayer, selfID, bAdd, iAdd, iOneZero)
	TARBasicModernUnitclass(iPlayer, bAdd, GameInfoTypes.UNITCLASS_BATTLESHIP, -15 * iAdd);
	TARUnitClassPromotion(iPlayer, GameInfoTypes.UNITCLASS_BATTLESHIP, GameInfoTypes.PROMOTION_ITG_MODERN_SONAR, bAdd)
end
function TAddRemoveModern13(iPlayer, selfID, bAdd, iAdd, iOneZero)
	TARBasicModernUnitclass(iPlayer, bAdd, GameInfoTypes.UNITCLASS_BOMBER, -15 * iAdd);
end
function TAddRemoveModern14(iPlayer, selfID, bAdd, iAdd, iOneZero)
	TARBasicModernUnitclass(iPlayer, bAdd, GameInfoTypes.UNITCLASS_BOMBER, -15 * iAdd);
end
function TAddRemoveModern15(iPlayer, selfID, bAdd, iAdd, iOneZero)
	Players[iPlayer]:ChangeUnitClassRawProdDiscount(GameInfoTypes.UNITCLASS_BATTLESHIP, -20 * iAdd);
	Players[iPlayer]:ChangeUnitClassRawProdDiscount(GameInfoTypes.UNITCLASS_DESTROYER, -20 * iAdd);
	Players[iPlayer]:ChangeUnitClassRawProdDiscount(GameInfoTypes.UNITCLASS_CARRIER, -20 * iAdd);
	Players[iPlayer]:ChangeUnitClassRawProdDiscount(GameInfoTypes.UNITCLASS_SUBMARINE, -20 * iAdd);
end
function TAddRemoveModern16(iPlayer, selfID, bAdd, iAdd, iOneZero)
	TARBasicModernUnitclass(iPlayer, bAdd, GameInfoTypes.UNITCLASS_ANTI_AIRCRAFT_GUN, -15 * iAdd);
	TARUnitClassPromotion(iPlayer, GameInfoTypes.UNITCLASS_ANTI_AIRCRAFT_GUN, GameInfoTypes.PROMOTION_ITG_MODERN_COVER_AREA, bAdd)
end
function TAddRemoveModern17(iPlayer, selfID, bAdd, iAdd, iOneZero)
	TARBasicModernUnitclass(iPlayer, bAdd, GameInfoTypes.UNITCLASS_ANTI_AIRCRAFT_GUN, -15 * iAdd);
	TARUnitClassPromotion(iPlayer, GameInfoTypes.UNITCLASS_ANTI_AIRCRAFT_GUN, GameInfoTypes.PROMOTION_ITG_MODERN_EXTRA_INTERCEPTION, bAdd)
end
function TAddRemoveModern18(iPlayer, selfID, bAdd, iAdd, iOneZero)
	TARUnitClassPromotion(iPlayer, GameInfoTypes.UNITCLASS_INFANTRY, GameInfoTypes.PROMOTION_ITG_MODERN_INF_ANTI_TANK, bAdd)
	for iUnit in Players[iPlayer]:Units() do
		if iUnit:GetUnitClassType() == GameInfoTypes.UNITCLASS_ANTI_TANK_GUN then
			ChangeITGBaseCombatStrength(iUnit, iAdd * 10)
		end
	end
end
function TAddRemoveModern19(iPlayer, selfID, bAdd, iAdd, iOneZero)
	TARBasicModernUnitclass(iPlayer, bAdd, GameInfoTypes.UNITCLASS_INFANTRY, -15 * iAdd);
	TARUnitClassPromotion(iPlayer, GameInfoTypes.UNITCLASS_INFANTRY, GameInfoTypes.PROMOTION_ITG_MODERN_INF_REINFORCEMENT, bAdd)
end
function TAddRemoveModern20(iPlayer, selfID, bAdd, iAdd, iOneZero)
	TARBasicModernUnitclass(iPlayer, bAdd, GameInfoTypes.UNITCLASS_INFANTRY, -15 * iAdd);
end
function TAddRemoveModern21(iPlayer, selfID, bAdd, iAdd, iOneZero)
	for iUnit in Players[iPlayer]:Units() do
		local jID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
		if gT.FortsByUnitID[jID] then
			iUnit:SetHasPromotion(GameInfoTypes.PROMOTION_ANTI_TANK, bAdd)
			iUnit:SetHasPromotion(GameInfoTypes.PROMOTION_ANTI_AIR, bAdd)
		end
	end
	local cMilit = GameInfoTypes.BUILDINGCLASS_MILITARY_BASE;
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		if bAdd then
			if IsHasBuildingClass(iCity, cMilit) then
				iCity:ChangeExtraRangeStrike(1);
				gT.Cities[cID].ModernRange21 = true;
			end
		elseif gT.Cities[cID].ModernRange21 then
			iCity:ChangeExtraRangeStrike(-1);
			gT.Cities[cID].ModernRange21 = nil;
		end
	end
end
function TAddRemoveModern22(iPlayer, selfID, bAdd, iAdd, iOneZero)
	gT.Players[iPlayer].CanResMovement = bAdd;
	if bAdd then
		CreateAgentNew(iPlayer, false, true)
		InitResistanceVision(iPlayer)
	else
		RemoveResistanceVision(iPlayer)
	end
end
function TAddRemoveModern23(iPlayer, selfID, bAdd, iAdd, iOneZero)
	DoChangeNewManufactoryCost(iPlayer, iAdd * 4)
end
function TAddRemoveModern26(iPlayer, selfID, bAdd, iAdd, iOneZero)
	Players[iPlayer]:ChangeAirStrikeDodgeChance(iAdd * 15)
end
function TAddRemoveModern27(iPlayer, selfID, bAdd, iAdd, iOneZero)
	TARBasicModernUnitclass(iPlayer, bAdd, GameInfoTypes.UNITCLASS_CARRIER, -15 * iAdd);
end
function TAddRemoveModern30(iPlayer, selfID, bAdd, iAdd, iOneZero)
	TARBasicModernUnitclass(iPlayer, bAdd, GameInfoTypes.UNITCLASS_PARATROOPER, -15 * iAdd);
end


local InnoEffectsTab = {
[GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_ASIA_1] = TAddRemoveNWAsia1,
[GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_ASIA_2] = TAddRemoveNWAsia2,
[GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_ASIA_3] = TAddRemoveNWAsia3,
[GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_ASIA_5] = TAddRemoveNWAsia5,
[GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_ASIA_7] = TAddRemoveNWAsia7,
[GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_ASIA_8] = TAddRemoveNWAsia8,
[GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_AFR_1] = TAddRemoveNWAfrica1,
[GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_AFR_2] = TAddRemoveNWAfrica2,
[GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_AFR_3] = TAddRemoveNWAfrica3,
[GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_AFR_4] = TAddRemoveNWAfrica4,
[GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_AFR_5] = TAddRemoveNWAfrica5,
[GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_AFR_6] = TAddRemoveNWAfrica6,
[GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_AFR_8] = TAddRemoveNWAfrica8,
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_EURO_1] = TAddRemoveTrialEuro1,
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_EURO_2] = TAddRemoveTrialEuro2,
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_EURO_3] = TAddRemoveTrialEuro3,
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_EURO_4] = TAddRemoveTrialEuro4,
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_EURO_5] = TAddRemoveTrialEuro5,
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_EURO_6] = TAddRemoveTrialEuro6,
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_EURO_7] = TAddRemoveTrialEuro7,
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_EURO_8] = TAddRemoveTrialEuro8,
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_ARABIA_1] = TAddRemoveTrialArab1,
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_ARABIA_2] = TAddRemoveTrialArab2,
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_ARABIA_3] = TAddRemoveTrialArab3,
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_ARABIA_5] = TAddRemoveTrialArab5,
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_ARABIA_6] = TAddRemoveTrialArab6,
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_ARABIA_8] = TAddRemoveTrialArab8,
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_ASIA_1] = TAddRemoveTrialAsia1,
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_ASIA_2] = TAddRemoveTrialAsia2,
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_ASIA_3] = TAddRemoveTrialAsia3,
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_ASIA_4] = TAddRemoveTrialAsia4,
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_ASIA_6] = TAddRemoveTrialAsia6,
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_ASIA_8] = TAddRemoveTrialAsia8,
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_PAGAN_1] = TAddRemoveTrialPagan1,
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_PAGAN_2] = TAddRemoveTrialPagan2,
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_PAGAN_3] = TAddRemoveTrialPagan3,
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_PAGAN_4] = TAddRemoveTrialPagan4,
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_PAGAN_5] = TAddRemoveTrialPagan5,
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_PAGAN_6] = TAddRemoveTrialPagan6,
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_PAGAN_7] = TAddRemoveTrialPagan7,
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_PAGAN_8] = TAddRemoveTrialPagan8,
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_HORDE_1] = TAddRemoveTrialHorde1,
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_HORDE_2] = TAddRemoveTrialHorde2,
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_HORDE_3] = TAddRemoveTrialHorde3,
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_HORDE_4] = TAddRemoveTrialHorde4,
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_HORDE_5] = TAddRemoveTrialHorde5,
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_HORDE_6] = TAddRemoveTrialHorde6,
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_HORDE_8] = TAddRemoveTrialHorde8,
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_VIKING_2] = TAddRemoveTrialViking2,
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_VIKING_3] = TAddRemoveTrialViking3,
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_VIKING_4] = TAddRemoveTrialViking4,
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_VIKING_5] = TAddRemoveTrialViking5,
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_VIKING_7] = TAddRemoveTrialViking7,
[GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_VIKING_8] = TAddRemoveTrialViking8,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_EMPIRE_1] = TAddRemoveAncientEmpire1,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_EMPIRE_2] = TAddRemoveAncientEmpire2,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_EMPIRE_3] = TAddRemoveAncientEmpire3,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_EMPIRE_4] = TAddRemoveAncientEmpire4,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_EMPIRE_5] = TAddRemoveAncientEmpire5,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_EMPIRE_6] = TAddRemoveAncientEmpire6,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_EMPIRE_8] = TAddRemoveAncientEmpire8,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_EMPIRE_9] = TAddRemoveAncientEmpire9,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_EMPIRE_10] = TAddRemoveAncientEmpire10,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_EMPIRE_11] = TAddRemoveAncientEmpire11,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_EMPIRE_13] = TAddRemoveAncientEmpire13,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_EMPIRE_15] = TAddRemoveAncientEmpire15,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_EMPIRE_16] = TAddRemoveAncientEmpire16,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_EMPIRE_17] = TAddRemoveAncientEmpire17,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_EMPIRE_19] = TAddRemoveAncientEmpire19,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_EMPIRE_20] = TAddRemoveAncientEmpire20,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_1] = TAddRemoveAncientCS1,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_4] = TAddRemoveAncientCS4,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_5] = TAddRemoveAncientCS5,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_6] = TAddRemoveAncientCS6,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_9] = TAddRemoveAncientCS9,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_11] = TAddRemoveAncientCS11,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_12] = TAddRemoveAncientCS12,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_13] = TAddRemoveAncientCS13,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_14] = TAddRemoveAncientCS14,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_15] = TAddRemoveAncientCS15,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_16] = TAddRemoveAncientCS16,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_17] = TAddRemoveAncientCS17,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_18] = TAddRemoveAncientCS18,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_19] = TAddRemoveAncientCS19,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_20] = TAddRemoveAncientCS20,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_21] = TAddRemoveAncientCS21,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_22] = TAddRemoveAncientCS22,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_23] = TAddRemoveAncientCS23,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_24] = TAddRemoveAncientCS24,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_25] = TAddRemoveAncientCS25,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_27] = TAddRemoveAncientCS27,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_28] = TAddRemoveAncientCS28,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_29] = TAddRemoveAncientCS29,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_31] = TAddRemoveAncientCS31,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_32] = TAddRemoveAncientCS32,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_TRIBE_1] = TAddRemoveAncientTribe1,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_TRIBE_2] = TAddRemoveAncientTribe2,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_TRIBE_3] = TAddRemoveAncientTribe3,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_TRIBE_4] = TAddRemoveAncientTribe4,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_TRIBE_6] = TAddRemoveAncientTribe6,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_TRIBE_7] = TAddRemoveAncientTribe7,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_TRIBE_8] = TAddRemoveAncientTribe8,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_TRIBE_9] = TAddRemoveAncientTribe9,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_TRIBE_10] = TAddRemoveAncientTribe10,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_TRIBE_11] = TAddRemoveAncientTribe11,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_TRIBE_12] = TAddRemoveAncientTribe12,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_TRIBE_15] = TAddRemoveAncientTribe15,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_TRIBE_17] = TAddRemoveAncientTribe17,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_TRIBE_18] = TAddRemoveAncientTribe18,
[GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_TRIBE_20] = TAddRemoveAncientTribe20,
[GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_ARAB_1] = TAddRemoveNWArab1,
[GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_ARAB_2] = TAddRemoveNWArab2,
[GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_ARAB_3] = TAddRemoveNWArab3,
[GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_ARAB_7] = TAddRemoveNWArab7,
[GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_ARAB_8] = TAddRemoveNWArab8,
[GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_MESOAMERICAN_1] = TAddRemoveNWMeso1,
[GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_MESOAMERICAN_2] = TAddRemoveNWMeso2,
[GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_MESOAMERICAN_3] = TAddRemoveNWMeso3,
[GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_MESOAMERICAN_5] = TAddRemoveNWMeso5,
[GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_MESOAMERICAN_6] = TAddRemoveNWMeso6,
[GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_MESOAMERICAN_7] = TAddRemoveNWMeso7,
[GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_EUROPE_3] = TAddRemoveNWEuro3,
[GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_EUROPE_4] = TAddRemoveNWEuro4,
[GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_EUROPE_6] = TAddRemoveNWEuro6,
[GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_EUROPE_7] = TAddRemoveNWEuro7,
[GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_EUROPE_8] = TAddRemoveNWEuro8,
[GameInfoTypes.TECH_UNIQUE_ITG_INDUSTRIAL_1] = TAddRemoveIndustrial1,
[GameInfoTypes.TECH_UNIQUE_ITG_INDUSTRIAL_2] = TAddRemoveIndustrial2,
[GameInfoTypes.TECH_UNIQUE_ITG_INDUSTRIAL_3] = TAddRemoveIndustrial3,
[GameInfoTypes.TECH_UNIQUE_ITG_INDUSTRIAL_4] = TAddRemoveIndustrial4,
[GameInfoTypes.TECH_UNIQUE_ITG_INDUSTRIAL_5] = TAddRemoveIndustrial5,
[GameInfoTypes.TECH_UNIQUE_ITG_INDUSTRIAL_6] = TAddRemoveIndustrial6,
[GameInfoTypes.TECH_UNIQUE_ITG_INDUSTRIAL_7] = TAddRemoveIndustrial7,
[GameInfoTypes.TECH_UNIQUE_ITG_INDUSTRIAL_8] = TAddRemoveIndustrial8,
[GameInfoTypes.TECH_UNIQUE_ITG_INDUSTRIAL_9] = TAddRemoveIndustrial9,
[GameInfoTypes.TECH_UNIQUE_ITG_INDUSTRIAL_10] = TAddRemoveIndustrial10,
[GameInfoTypes.TECH_UNIQUE_ITG_INDUSTRIAL_11] = TAddRemoveIndustrial11,
[GameInfoTypes.TECH_UNIQUE_ITG_INDUSTRIAL_12] = TAddRemoveIndustrial12,
[GameInfoTypes.TECH_UNIQUE_ITG_INDUSTRIAL_13] = TAddRemoveIndustrial13,
[GameInfoTypes.TECH_UNIQUE_ITG_INDUSTRIAL_14] = TAddRemoveIndustrial14,
[GameInfoTypes.TECH_UNIQUE_ITG_INDUSTRIAL_15] = TAddRemoveIndustrial15,
[GameInfoTypes.TECH_UNIQUE_ITG_INDUSTRIAL_16] = TAddRemoveIndustrial16,
[GameInfoTypes.TECH_UNIQUE_ITG_INDUSTRIAL_17] = TAddRemoveIndustrial17,
[GameInfoTypes.TECH_UNIQUE_ITG_INDUSTRIAL_18] = TAddRemoveIndustrial18,
[GameInfoTypes.TECH_UNIQUE_ITG_INDUSTRIAL_19] = TAddRemoveIndustrial19,
[GameInfoTypes.TECH_UNIQUE_ITG_INDUSTRIAL_20] = TAddRemoveIndustrial20,
[GameInfoTypes.TECH_UNIQUE_ITG_MEDIEVAL_AFR_1] = TAddRemoveTrialAfrica1,
[GameInfoTypes.TECH_UNIQUE_ITG_MEDIEVAL_AFR_2] = TAddRemoveTrialAfrica2,
[GameInfoTypes.TECH_UNIQUE_ITG_MEDIEVAL_AFR_3] = TAddRemoveTrialAfrica3,
[GameInfoTypes.TECH_UNIQUE_ITG_MEDIEVAL_AFR_4] = TAddRemoveTrialAfrica4,
[GameInfoTypes.TECH_UNIQUE_ITG_MEDIEVAL_AFR_5] = TAddRemoveTrialAfrica5,
[GameInfoTypes.TECH_UNIQUE_ITG_MEDIEVAL_AFR_6] = TAddRemoveTrialAfrica6,
[GameInfoTypes.TECH_UNIQUE_ITG_MEDIEVAL_AFR_7] = TAddRemoveTrialAfrica7,
[GameInfoTypes.TECH_UNIQUE_ITG_MEDIEVAL_AFR_8] = TAddRemoveTrialAfrica8,
[GameInfoTypes.TECH_UNIQUE_ITG_NW_TROPICAL_2] = TAddRemoveNWTropical2,
[GameInfoTypes.TECH_UNIQUE_ITG_NW_TROPICAL_3] = TAddRemoveNWTropical3,
[GameInfoTypes.TECH_UNIQUE_ITG_NW_TROPICAL_5] = TAddRemoveNWTropical5,
[GameInfoTypes.TECH_UNIQUE_ITG_NW_TROPICAL_6] = TAddRemoveNWTropical6,
[GameInfoTypes.TECH_UNIQUE_ITG_NW_TROPICAL_7] = TAddRemoveNWTropical7,
[GameInfoTypes.TECH_UNIQUE_ITG_NW_TROPICAL_8] = TAddRemoveNWTropical8,

[GameInfoTypes.TECH_UNIQUE_ITG_MODERN_1] = TAddRemoveModern1,
[GameInfoTypes.TECH_UNIQUE_ITG_MODERN_2] = TAddRemoveModern2,
[GameInfoTypes.TECH_UNIQUE_ITG_MODERN_3] = TAddRemoveModern3,
[GameInfoTypes.TECH_UNIQUE_ITG_MODERN_4] = TAddRemoveModern4,
[GameInfoTypes.TECH_UNIQUE_ITG_MODERN_5] = TAddRemoveModern5,
[GameInfoTypes.TECH_UNIQUE_ITG_MODERN_6] = TAddRemoveModern6,
[GameInfoTypes.TECH_UNIQUE_ITG_MODERN_7] = TAddRemoveModern7,
[GameInfoTypes.TECH_UNIQUE_ITG_MODERN_8] = TAddRemoveModern8,
[GameInfoTypes.TECH_UNIQUE_ITG_MODERN_9] = TAddRemoveModern9,
[GameInfoTypes.TECH_UNIQUE_ITG_MODERN_10] = TAddRemoveModern10,
[GameInfoTypes.TECH_UNIQUE_ITG_MODERN_11] = TAddRemoveModern11,
[GameInfoTypes.TECH_UNIQUE_ITG_MODERN_12] = TAddRemoveModern12,
[GameInfoTypes.TECH_UNIQUE_ITG_MODERN_13] = TAddRemoveModern13,
[GameInfoTypes.TECH_UNIQUE_ITG_MODERN_14] = TAddRemoveModern14,
[GameInfoTypes.TECH_UNIQUE_ITG_MODERN_15] = TAddRemoveModern15,
[GameInfoTypes.TECH_UNIQUE_ITG_MODERN_16] = TAddRemoveModern16,
[GameInfoTypes.TECH_UNIQUE_ITG_MODERN_17] = TAddRemoveModern17,
[GameInfoTypes.TECH_UNIQUE_ITG_MODERN_18] = TAddRemoveModern18,
[GameInfoTypes.TECH_UNIQUE_ITG_MODERN_19] = TAddRemoveModern19,
[GameInfoTypes.TECH_UNIQUE_ITG_MODERN_20] = TAddRemoveModern20,
[GameInfoTypes.TECH_UNIQUE_ITG_MODERN_21] = TAddRemoveModern21,
[GameInfoTypes.TECH_UNIQUE_ITG_MODERN_22] = TAddRemoveModern22,
[GameInfoTypes.TECH_UNIQUE_ITG_MODERN_23] = TAddRemoveModern23,
[GameInfoTypes.TECH_UNIQUE_ITG_MODERN_24] = TAddRemoveModern24,
[GameInfoTypes.TECH_UNIQUE_ITG_MODERN_26] = TAddRemoveModern26,
[GameInfoTypes.TECH_UNIQUE_ITG_MODERN_27] = TAddRemoveModern27,
[GameInfoTypes.TECH_UNIQUE_ITG_MODERN_30] = TAddRemoveModern30,
}

function PlayerDiscoverTech(iPlayer, lTech, bGlobal, hPrint)
	if (not iPlayer) or (not lTech) then
		print("PlayerDiscoverTech ERROR ", iPlayer, lTech, bGlobal, hPrint)
		return;
	end
	if not gT.Globals.TechFirstTeams[lTech] then
		gT.Globals.TechFirstTeams[lTech] = iPlayer;
		gT.Players[iPlayer].NumFirstTechs = gT.Players[iPlayer].NumFirstTechs + 1;
	end
	local iTeam = Players[iPlayer]:GetTeam();
	if Teams[iTeam]:IsHasTech(lTech) then
		print("ERROR tech discovered already known", iPlayer, lTech, bGlobal, hPrint);
	end
	if GameInfo.Technologies[lTech].IsInnovation then
		if not bGlobal then
			DoIncreasementStockExchange(4, 1)
			if Players[iPlayer]:IsHuman() then
				LuaEvents.ITG_AchievementCountChange(77, 1)
			end
			VictoryTaskCompletion(iPlayer, 11)
		end
		gT.Players[iPlayer].NumDiscoveredInno = gT.Players[iPlayer].NumDiscoveredInno + 1;
		HnGLogInnovation(iPlayer, lTech)
		if DBScenario.InnoPairs then
			MakePlayerUnableToDiscoverSecondOfPair(lTech, iPlayer)
		end
		if DBScenario.TempExclusiveInnovations then
			if not gT.Globals.NoMoreExcludedTechs then
				-- this works only for 1 culture group inno set
				local bLast = true;
				for i, tech in pairs(gT.Players[iPlayer].Innovations or {}) do
					if not gT.Globals.ExcludedTechs[tech] then
						bLast = false;
						break;
					end
				end
				if bLast then
					gT.Globals.NoMoreExcludedTechs = true;
					gT.Globals.ExcludedTechs = {};
				end
			end
		end
		DoLogDominationEvent(8, iPlayer, nil, 15, nil, false, lTech)
	else
		if not bGlobal then
			VictoryTaskCompletion(iPlayer, 10)
			DoIncreasementStockExchange(4, 1)
		end
		if gT.Players[iPlayer].HasIdeology[46] then
			if gT.Globals.GameGenerated then
				GrantExtraRewardForDiscoveringTechnology(iPlayer, lTech)
			end
		end
	end
	if gT.Players[iPlayer].HasIdeology[66] then
		DoAddTemporalCurrencyPower(iPlayer, LastRandom(40,60))
	end
	if gT.Players[iPlayer].CultBonusOn[22] then
		local bRefund = false;
		for g, gdata in pairs(gT.Players) do
			if Players[g]:IsAlive() then
				if not Players[g]:IsMinorCiv() then
					if g ~= iPlayer then
						local pTeam = Teams[Players[g]:GetTeam()];
						if pTeam:IsHasTech(lTech) then
							if pTeam:IsHasMet(Players[iPlayer]:GetTeam()) then
								bRefund = true;
								break;
							end
						end
					end
				end
			end
		end
		if bRefund then
			ChangeITGScience(iPlayer, math.ceil(gT.Players[iPlayer].LastScienceBonusCost * 15 / 100))
		end
	end
	Teams[iTeam]:SetHasTech(lTech, true);
	if InnoEffectsTab[lTech] then
		InnoEffectsTab[lTech](iPlayer, lTech, true, 1, 1)
	end
	if Game.GetActivePlayer() == iPlayer then
		Events.OpenInfoCorner()
		Events.SerialEventEndTurnDirty()
		Events.SerialEventCityInfoDirty()
		LuaEvents.ITGSGTopPanelDirty()
	end
end

function ITGRemoveEffectOfTech(iPlayer, lTech)
	if InnoEffectsTab[lTech] then
		InnoEffectsTab[lTech](iPlayer, lTech, false, -1, 0)
	end
	if DBScenario.InnoPairs then
		if GameInfo.Technologies[lTech].IsInnovation then
			MakePlayerUnableToDiscoverSecondOfPair(lTech, iPlayer, true)
		end
	end
	if gT.Globals.GameGenerated then
		if Game.GetActivePlayer() == iPlayer then
			Events.OpenInfoCorner()
			Events.SerialEventEndTurnDirty()
			Events.SerialEventCityInfoDirty()
			LuaEvents.ITGSGTopPanelDirty()
		end
	end
end