local hRelBeliefBuildingTab = {}
for i = 1, 500 do
	if GameInfoTypes["BELIEF_ITG_TEMPLAR_" .. i] then
		hRelBeliefBuildingTab[GameInfoTypes["BELIEF_ITG_TEMPLAR_" .. i]] = GameInfoTypes["BUILDING_ITG_BELIEF_TEMPLE_" .. i]
	else
		break;
	end
end
local beliefbuildingsFlavTab = {}
local hagiasophie = GameInfoTypes.BUILDING_ITG_NEW_WORLD_WONDER_4;

function GetExistingTemplarBuildingsInCity(iCity)
	local tab = {}
	for i, b in pairs(hRelBeliefBuildingTab) do
		if iCity:IsHasBuilding(b) then
			table.insert(tab, b)
		end
	end
	return tab;
end

function AssignVictoryOfTemplarProject(iPlayer, iRel)
	if Players[iPlayer]:IsHuman() then
		--TitleIconTexture = "NotificationPantheon128.dds", 
		local data = {BonusType = "TemplarBelief", Religion = iRel, Text = "CHOOSE TEMPLE", TitleText = "Choose temple for " .. GameInfo.Religions[iRel].IconString .. " "  .. Locale.Lookup(Game.GetReligionName(iRel)) .. ".", TitleIconIndex = 16, TitleIconAtlas = "EXPANSION_UNIT_ATLAS_1", Tooltip = "You have contributed the most [ICON_PRODUCTION] Production into Temple design."}
		local hTab = {}
		for belief, building in pairs(hRelBeliefBuildingTab) do
			if not gT.TemplarBuildingsUsed[belief] then
				table.insert(hTab, {Name = Locale.Lookup(GameInfo.Buildings[building].Description),
					ID = belief,						
					PortraitIndex = GameInfo.Buildings[building].PortraitIndex,
					IconAtlas = GameInfo.Buildings[building].IconAtlas,
					Help = GetHelpTextForBuilding(building, true, false, true, nil),
					ExtraInfo = iRel})
			end
		end
		if #hTab < 2 then
			if #hTab == 0 then
				PlayerChooseTemplarBelief(nil, gT.TemplarLastUsed, iRel)
			else
				PlayerChooseTemplarBelief(nil, hTab[1].ID, iRel)
			end
		else
			data.UniqueOptions = hTab;
			table.insert(gT.Players[iPlayer].NewHumanQueueActions, data)
		end
	else
		table.insert(gT.Players[iPlayer].QueueActionsRealEndTurn, {"TemplarBelief", iRel})
	end
end

function GetBeliefAITemplarValue(belief, iPlayer)
	local base = 0;
	if not beliefbuildingsFlavTab[belief] then
		beliefbuildingsFlavTab[belief] = {}
		local bBbT = GameInfo.Buildings[hRelBeliefBuildingTab[belief]].Type;
		for row in GameInfo.Building_Flavors() do
			if row.BuildingType == bBbT then
				beliefbuildingsFlavTab[belief][row.FlavorType] = row.Flavor
			end
		end
		local lP = GameInfo.Buildings[bBbT].LegalPower;
		if lP > 0 then
			beliefbuildingsFlavTab[belief]["FLAVOR_LEGAL"] = lP * 2;
		end
	end
	for flavor, amount in pairs(beliefbuildingsFlavTab[belief]) do
		base = base + GetAIFlavour(iPlayer, flavor) * amount;
	end
	return base;
end

function AIPlayerChooseTemplarBelief(iPlayer, iRel)
	local hTab = {}
	for belief, building in pairs(hRelBeliefBuildingTab) do
		if not gT.TemplarBuildingsUsed[belief] then
			table.insert(hTab, belief)
		end
	end
	if #hTab < 2 then
		if #hTab == 0 then
			PlayerChooseTemplarBelief(nil, gT.TemplarLastUsed, iRel)
		else
			PlayerChooseTemplarBelief(nil, hTab[1], iRel)
		end
	else
		local bRel = Players[iPlayer]:GetReligionCreatedByPlayer();
		local bIsTreatedAsOwn = (bRel < 1) or (bRel == iRel);
		local fvtab = {}
		for i, belief in pairs(hTab) do
			table.insert(fvtab, {belief, GetBeliefAITemplarValue(belief, iPlayer)})
		end
		table.sort(fvtab, SortFunctionForGreaterInteger2)
		if bIsTreatedAsOwn then
			PlayerChooseTemplarBelief(iPlayer, fvtab[1][1], iRel)
		else
			PlayerChooseTemplarBelief(iPlayer, fvtab[math.min(#fvtab, LastRandom(4,6))][1], iRel)
		end
	end
end

function AddRandomTemplarBeliefValid(iRel)
	local sTab = {}
	for belief, building in pairs(hRelBeliefBuildingTab) do
		if not gT.TemplarBuildingsUsed[belief] then
			table.insert(sTab, belief);
		end
	end
	if #sTab > 0 then
		AddProperlyBeliefTemplarToRel(Game.GetFounder(iRel, -1), iRel, sTab[LastRandom(1,#sTab)])
	end
end

function PlayerChooseTemplarBelief(iPlayer, beliefID, iRel, bRemove)
	if bRemove then
		local lkey;
		for i, sth in pairs(gT.Players[iPlayer].NewHumanQueueActions) do
			if sth.BonusType == "TemplarBelief" and sth.Religion == iRel then
				lkey = i;
				break;
			end
		end
		if lkey then
			table.remove(gT.Players[iPlayer].NewHumanQueueActions, lkey)
		end
	end
	local bPlayer = Game.GetFounder(iRel, -1);
	AddProperlyBeliefTemplarToRel(bPlayer, iRel, beliefID)
	for i, player in pairs(gT.TemplarFreeBuildings[iRel] or {}) do
		AddFreeBuildingOfTemplarBonus(player, beliefID, iRel)
	end
--	gT.TemplarFreeBuildings[iRel] = nil;
	if iPlayer then
		for i, human in pairs(gT.Globals.HumanPlayers) do
			if iPlayer ~= human then
				if Teams[Players[human]:GetTeam()]:IsHasMet(Players[iPlayer]:GetTeam()) then
					local str = Locale.Lookup(GameInfo.Buildings[hRelBeliefBuildingTab[beliefID]].Description) .. " of " .. Locale.Lookup(Game.GetReligionName(iRel));
					Players[human]:AddNotification(NotificationTypes.NOTIFICATION_RELIGION_ENHANCED, "The new templar belief was chosen: " .. str .. ".", str)
				end
			end
		end
		HnGLogTemplarBelief(iPlayer, iRel, hRelBeliefBuildingTab[beliefID])
		gT.Players[iPlayer].AchV19 = (gT.Players[iPlayer].AchV19 or 0) + 1;
		if gT.Players[iPlayer].AchV19 == 2 then
			if Players[iPlayer]:IsHuman() then
				LuaEvents.ITG_AchievementCompleted(19)
			end
		end
		for g, h in pairs(gT.Leagues) do
			if h.OfficialRel == iRel then
				if h.Members[iPlayer] then
					AddExtraVotesScriptedLeague(iPlayer, g, "Templar Belief", 3);
				end
			end
		end
		VictoryTaskCompletion(iPlayer, 75)
	end
	DoIncreaseHeresyProbability(2)
end

function StartTemplarProjectForRel(iRel, bForceLeague, iForceAmount)
	if not gT.TemplarStarted[iRel] then
		if bForceLeague or (not gT.Globals.TemplarOnlyLeague[iRel]) then
			gT.TemplarBonus[iRel] = {Total = 0, PlayerContribution = {}, Needed = (iForceAmount or DBScenario.TemplarBeliefCost)};
			gT.TemplarStarted[iRel] = GetITGGameTurn();
		end
	end
end

function TurnOffTemplarProject(iRel)
	gT.TemplarBonus[iRel] = nil;
	gT.TemplarStarted[iRel] = nil;
end

function AddFreeBuildingOfTemplarBonus(player, beliefID, iRel)
	if Players[player]:GetNumCities() > 0 then
		local bestcity, bestval = Players[player]:GetCapitalCity(), 0;
		for iCity in Players[player]:Cities() do
			if not iCity:IsHasBuilding(hRelBeliefBuildingTab[beliefID]) then
				local numf = iCity:GetNumFollowers(iRel);
				if numf > bestval then
					bestcity = iCity;
					bestval = numf;
				end
			end
		end
		bestcity:SetNumFreeBuilding(hRelBeliefBuildingTab[beliefID], 1)
	end
end

function FinishTemplarProjectITG(iRel)
	local bestplayer, bestvalue = nil, 0;
	local tresholdFreeTemple = math.floor(0.25 * gT.TemplarBonus[iRel].Needed);
	gT.TemplarFreeBuildings[iRel] = {}
	for player, amount in pairs(gT.TemplarBonus[iRel].PlayerContribution) do
		if amount > bestvalue then
			bestplayer = player;
			bestvalue = amount;
		end
		if amount >= tresholdFreeTemple then
			table.insert(gT.TemplarFreeBuildings[iRel], player)
		end
		ChangeITGFaith(player, math.ceil(amount/2))
	end
	AssignVictoryOfTemplarProject(bestplayer, iRel)
	for ji, iHuman in pairs(gT.Globals.HumanPlayers) do
		if gT.TemplarBonus[iRel].PlayerContribution[iHuman] then
			local str = GameInfo.Religions[iRel].IconString .. " " .. Locale.Lookup(Game.GetReligionName(iRel)) .. " has finalized its temple's design.[NEWLINE][ICON_TROPHY_BRONZE] We have acquired " ..  math.ceil(gT.TemplarBonus[iRel].PlayerContribution[iHuman]/2) .. "[ICON_PEACE] Faith."
			if gT.TemplarBonus[iRel].PlayerContribution[iHuman] >= tresholdFreeTemple then
				str = str .. "[NEWLINE][ICON_TROPHY_SILVER] We will acquire one free Templar building once it will be chosen.";
			end
			if bestplayer == iHuman then
				str = str .. "[NEWLINE][ICON_TROPHY_GOLD] We have the right to choose Templar belief for this religion.";
			end
			Players[iHuman]:AddNotification(NotificationTypes.NOTIFICATION_RELIGION_ENHANCED, str, "Templar Belief")
		end
	end
	gT.TemplarBonus[iRel] = nil;
end

function GetBestReligionFromThePast(g, iRel)
	if gT.EraData[gT.PreviousEra].Players[g].ReligionCreated[iRel] then
		return iRel;
	end
	for hRel, sth in pairs(gT.EraData[gT.PreviousEra].Players[g].ReligionCreated) do
		return hRel;
	end
	return nil;
end

function ChooseInitialTemplarBelief(g, iRel, bDoNotDistribute)
	local cCity = Players[g]:GetCapitalCity();
	local bbb;
	if gT.EraData and gT.PreviousEra then
		if gT.EraData[gT.PreviousEra].Players[g].ReligionCreated then
			local hRel = GetBestReligionFromThePast(g, iRel);
			if hRel then
				for h, belief in pairs(gT.EraData[gT.PreviousEra].Players[g].ReligionCreated[hRel]) do
					if GetBeliefTypeITG(belief) == 5 then
						if not gT.TemplarBuildingsUsed[belief] then
							bbb = belief;
							break;
						end
					end
				end
			end
		end
	end
	if not bbb then
		local sTab = {}
		for belief, building in pairs(hRelBeliefBuildingTab) do
			if not  gT.TemplarBuildingsUsed[belief] then
				table.insert(sTab, belief);
			end
		end
		bbb = sTab[LastRandom(1,#sTab)];
	end
	AddProperlyBeliefTemplarToRel(g, iRel, bbb)
	if cCity then
		cCity:SetNumFreeBuilding(hRelBeliefBuildingTab[bbb], 1);
	end
	if not bDoNotDistribute then
		for gj, gdata in pairs(gT.Players) do
			local gChance = GetDBCulturePlayerInfo(gj, "InitTemplarChance")
			if gChance > 0 then
				for iCity in Players[gj]:Cities() do
					if iCity:GetReligiousMajority() == iRel then
						if LastChance(gChance) then
							if iCity ~= cCity then
								iCity:SetNumFreeBuilding(hRelBeliefBuildingTab[bbb], 1);
							end
						end
					end
				end
			end
		end
	end
end

function AddProperlyBeliefTemplarToRel(g, iRel, bbb)
	Game.AddBeliefToReligion(g, iRel, bbb)
	ITGBeliefAdded(g, iRel, bbb)
	gT.TemplarBuildingsUsed[bbb] = 1;
	gT.TemplarRelBuilding[iRel] = hRelBeliefBuildingTab[bbb];
	gT.TemplarLastUsed = bbb;
	gT.TemplarNames[hRelBeliefBuildingTab[bbb]] = iRel;
	if gT.Wonders[hagiasophie] then
		HagiaSophiaCheck(Map.GetPlotByIndex(gT.Wonders[hagiasophie]):GetPlotCity())
	end
end

function RemoveTemplarOptionsBasedOnNumMajorPlayers()
	local tRemove = 0;
	local tKeep = gT.Globals.NumPlayersMajor + 2;
	for g, gdata in pairs(gT.Players) do
		if Players[g]:IsMinorCiv() then
			if Players[g]:GetReligionCreatedByPlayer() > 0 then
				tKeep = tKeep + 1;
			end
		end
	end
	for sth, stmh in pairs(hRelBeliefBuildingTab) do
		tKeep = tKeep - 1;
	end
	tRemove = - tKeep;
	if tRemove > 0 then
		local sTab = {};
		for belief, sth in pairs(hRelBeliefBuildingTab) do
			table.insert(sTab, belief);
		end
		sTab = Shuffle(sTab);
		for i = 1, tRemove do
			gT.TemplarBuildingsUsed[sTab[i]] = 1;
		end
	end
end

GameEvents.CityConvertsReligion.Add(function(owner, iRel, x, y)
	local iCity = Map.GetPlot(x, y):GetPlotCity();
	if gT.Globals.GameGenerated then
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		if gT.Cities[cID] then
			gT.Cities[cID].LastReligionChange = GetITGGameTurn()
		end
	end
end)

function HasAnyTemplarBuilding(iCity)
	for sb, building in pairs(hRelBeliefBuildingTab) do
		if iCity:IsHasBuilding(building) then
			return true;
		end
	end
	return false
end

function GetReligiousBuildingsForCivilopedia()
	local tab = {}
	for i, v in pairs(hRelBeliefBuildingTab) do
		table.insert(tab, v)
	end
	return tab;
end

function ChangeYieldFromTemplarBuilding(iPlayer, yieldType, iAdd)
	for i = 1, 500 do
		if GameInfoTypes["BUILDINGCLASS_ITG_BELIEF_TEMPLE_" .. i] then
			Players[iPlayer]:ChangePlayerBuildingClassYieldChange(GameInfoTypes["BUILDINGCLASS_ITG_BELIEF_TEMPLE_" .. i], yieldType, iAdd);
		else
			break;
		end
	end
end

function GetNumPlayerTemplarBuildings(iPlayer)
	local t = 0;
	for i = 1, 500 do
		if GameInfoTypes["BUILDINGCLASS_ITG_BELIEF_TEMPLE_" .. i] then
			t = t + Players[iPlayer]:GetBuildingClassCount(GameInfoTypes["BUILDINGCLASS_ITG_BELIEF_TEMPLE_" .. i]);
		else
			break;
		end
	end
	return t;
end

function GetNumCityTemplarBuildings(iCity)
	local t = 0;
	for sb, building in pairs(hRelBeliefBuildingTab) do
		t = t + iCity:GetNumRealBuilding(building) + iCity:GetNumFreeBuilding(building);
	end
	return t;
end