local bInquisition = GameInfoTypes.BUILDING_ITG_NEW_WORLD_INQUISITION;

local TabClimateText = {
TXT_KEY_ITG_COLD_CLIMATE,
TXT_KEY_ITG_WARM_CLIMATE,
}

function GenerateTheDoMData(iPlayer)
	gT.Players[iPlayer].DoMdata = {
		SettlerType = Players[iPlayer]:GetPlayerUniqueUnit(GameInfoTypes.UNITCLASS_ITG_SETTLER_POINTS),
		NumAgents = #gT.Players[iPlayer].Agents,
		NumGovernors = GetNumActiveGovernors(iPlayer),
		InitCustomsH = {},
		InitManufactory = {},
		InitAcademy = {},
		InitCurrency = {},
		InitSocialDevs = {},
		IdeoFromPlayer = gT.Players[iPlayer].IdeologyFromPlayer,
		UniqueImprovements = {},
		SpecialUULog = {},
		NoMoreWonderRace = gT.Players[iPlayer].NoMoreWonderRace,
		CanWonderRace = gT.Players[iPlayer].CanWonderRace,
		Wonders = {},
		WonderRuins = {},
		Principles = {},
		WonderAssigned = {},
		CultureEra = gT.Players[iPlayer].CultureEra,
		Goverment = gT.Players[iPlayer].Goverment,
		OfficialReligion = gT.Players[iPlayer].OfficialReligion,
		CreatedReligion = Players[iPlayer]:GetReligionCreatedByPlayer(),
	}
	for slot, elo in pairs(gT.Players[iPlayer].GovSlots) do
		table.insert(gT.Players[iPlayer].DoMdata.Principles, elo.Principle)
	end
	if gT.Players[iPlayer].DoMdata.CreatedReligion > 0 then
		gT.Players[iPlayer].DoMdata.CanReform = CanDoReformation(iPlayer)
		gT.Players[iPlayer].DoMdata.IsEnhanced = IsEnchancedReligion(gT.Players[iPlayer].DoMdata.CreatedReligion)
	end
	for iClass, uuData in pairs(gT.Players[iPlayer].SpecialUULog or {}) do
		table.insert(gT.Players[iPlayer].DoMdata.SpecialUULog, uuData[2])
	end
	for uniqueimpro, sth in pairs(gT.Players[iPlayer].UniqueImprovements) do
		table.insert(gT.Players[iPlayer].DoMdata.UniqueImprovements, uniqueimpro)
	end
	for index, sth in pairs(gT.CustomsHouses) do
		if sth.Player == iPlayer then
			table.insert(gT.Players[iPlayer].DoMdata.InitCustomsH, sth.City)
		end
	end
	for index, sth in pairs(gT.Manufactories) do
		if sth.Player == iPlayer then
			table.insert(gT.Players[iPlayer].DoMdata.InitManufactory, index)
		end
	end
	for index, sth in pairs(gT.Academies) do
		if sth.Player == iPlayer then
			table.insert(gT.Players[iPlayer].DoMdata.InitAcademy, index)
		end
	end
	table.insert(gT.Players[iPlayer].DoMdata.InitCurrency, gT.Players[iPlayer].Currencies)
	for jkx, jkxdata in pairs(gT.Players[iPlayer].CultBonusOn) do
		table.insert(gT.Players[iPlayer].DoMdata.InitSocialDevs, jkx)
	end
	local cstructedB = {}
	for wonderID, wPlayer in pairs(gT.Globals.WondersAssigned) do
		if wPlayer == iPlayer then
			cstructedB[wonderID] = true;
			table.insert(gT.Players[iPlayer].DoMdata.WonderAssigned, wonderID)
		end
	end
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		local ged = gT.Cities[cID].geIndex
		if gT.WondersRuins[ged] then
			cstructedB[gT.WondersRuins[ged]] = true;
			table.insert(gT.Players[iPlayer].DoMdata.WonderRuins, {ged, iCity:Plot():GetPlotIndex(), gT.WondersRuins[ged]})
		end
	end
	for a, b in pairs(gT.Players[iPlayer].FestivalBonusesActive) do
		gT.Players[iPlayer].DoMdata.FestivalReward = {a, b}
	end
	for wonderID, player in pairs(gT.WondersConstructed) do
		if wPlayer == iPlayer then
			if not cstructedB[wonderID] then
				table.insert(gT.Players[iPlayer].DoMdata.Wonders, wonderID)
			end
		end
	end
end

function GenerateTheDoMText(iPlayer)
	local domTab = {}
	if (not gT.Players[iPlayer]) or (not gT.Players[iPlayer].DoMdata) then
		MapModData.ITGSG = domTab;
		return;
	end
	local itgCtype = ITG_CultureData[gT.Players[iPlayer].CultureType].Type;
	local itgDBcultsearch = "CultureType = '" .. itgCtype .. "'"
	local itgStype;
	if gT.Players[iPlayer].SubcultureType then
		itgStype = ITG_SubcultureData[gT.Players[iPlayer].SubcultureType].Type;
		itgDBcultsearch = itgDBcultsearch .. " OR CultureType = '" .. itgStype .. "'";
	end
	local str = "[NEWLINE]"
	str = str .. Locale.Lookup(DBScenario.Description .. "_DOM")
	table.insert(domTab, {str, ""})
	str = ""
	for i = 1, 20 do
		local hText = Locale.Lookup(DBScenario.Description .. "_DOM_EFFECT_" .. i);
		if hText == DBScenario.Description .. "_DOM_EFFECT_" .. i then
			break;
		else
			table.insert(domTab, {str .. "[NEWLINE][ICON_BULLET]" .. hText, Locale.Lookup(DBScenario.Description .. "_DOM_EFFECT_TT_" .. i )})
		end
	end
	local hCultDescTXT = GetDBCulturePlayerInfo(iPlayer, "Description")
	str = str .. "[NEWLINE][NEWLINE]" .. Locale.Lookup(hCultDescTXT .. "_DOM");
	table.insert(domTab, {str, ""})
	str = ""
	for i = 1, 20 do
		local hText = Locale.Lookup(hCultDescTXT .. "_DOM_EFFECT_" .. i);
		if hText == hCultDescTXT .. "_DOM_EFFECT_" .. i then
			break;
		else
			table.insert(domTab, {str .. "[NEWLINE][ICON_BULLET]" .. hText, Locale.Lookup(hCultDescTXT .. "_DOM_EFFECT_TT_" .. i )})
		end
	end

	if not DBScenario.NoCSCultureAffection then
		str = "[NEWLINE][ICON_BULLET]City-States in your Culture group have their resting point for [ICON_INFLUENCE] Influence increased by 15. [ICON_INFLUENCE] Influence recovers 25% slower and decays 25% faster in [ICON_CITY_STATE] City-States in other Culture groups." 
	end
	--
	if not DBScenario.NoFaithGeneration then
		local iRel = gT.Players[iPlayer].DoMdata.CreatedReligion;
		str = str .. "[NEWLINE][NEWLINE]RELIGION[NEWLINE]"
		if iRel > 0 then
			str = str .. "[ICON_BULLET]You are the founder of the " .. GameInfo.Religions[iRel].IconString .. " " .. Locale.Lookup(GameInfo.Religions[iRel].Description) .. ".[NEWLINE]"
			if not gT.Players[iPlayer].DoMdata.IsEnhanced then
				str =  str .. "[ICON_BULLET]Your religion is not yet enhanced.[NEWLINE]"
			elseif gT.Players[iPlayer].DoMdata.CanReform  then	
				str = str .. "[ICON_BULLET]Your religion is already enhanced and you can reform beliefs.[NEWLINE]"
			else
				str = str .. "[ICON_BULLET]Your religion is already enhanced.[NEWLINE]";
			end
		end
		if gT.Players[iPlayer].DoMdata.OfficialReligion then
			local oRel = gT.Players[iPlayer].DoMdata.OfficialReligion;
			str = str .. "[ICON_BULLET]" .. GameInfo.Religions[oRel].IconString .. " " .. Locale.Lookup(GameInfo.Religions[oRel].Description) .. " is the official religion. Your cities are immune to any kind of conversion, but the pressure of rival religions might cause Heresy in your cities.[NEWLINE]";
		elseif gT.Players[iPlayer].SecularState then
			str = str .. "[ICON_BULLET]Your state is secular. You are not affected by Heresy.[NEWLINE]"
		else
			str = str .. "[ICON_BULLET]You have no official religion. Your cities can be converted by religious pressure or Missionares. You are not affected by Heresy.[NEWLINE]"
		end
	end
	table.insert(domTab, {str, ""})
	str = ""
--goverment
	str = str .. "[NEWLINE]" .. string.upper(CallDataFromGovTab(gT.Players[iPlayer].DoMdata.Goverment, "Name")) .. " - GOVERMENT[NEWLINE]"
	str = str .. "City-States with identical goverment type have their [ICON_INFLUENCE] Influence resting point for increased by 10 (excluding Anarchy). [ICON_INFLUENCE] Influence recovers 20% slower and decays 20% faster for [ICON_CITY_STATE] City-states with other goverment types." 
	--
	table.insert(domTab, {str, PrepareNiceToolTipForGov(gT.Players[iPlayer].DoMdata.Goverment)})
	if #gT.Players[iPlayer].DoMdata.Principles == 0 then
		str = "[NEWLINE]Your goverment adopted no principles yet."
	else
		str = "[NEWLINE]Your goverment adopted " .. #gT.Players[iPlayer].DoMdata.Principles .. " principle(s):"
	end
	table.insert(domTab, {str, ""})
	for i, principleID in pairs(gT.Players[iPlayer].DoMdata.Principles) do
		local gstdata = RequestGovSlotData(principleID);
		table.insert(domTab, {"[NEWLINE][ICON_BULLET]" .. Locale.Lookup(gstdata.Name), Locale.Lookup(gstdata.Help)})
	end
	str = "[NEWLINE]GOVERNORS[NEWLINE]"
	if gT.Players[iPlayer].DoMdata.NumGovernors == 0 then
		str = str .. "[ICON_BULLET]You have no [ICON_ITG_GOVERNOR] Governors.[NEWLINE]"
	else 
		str = str .. "[ICON_BULLET]You start with " .. gT.Players[iPlayer].DoMdata.NumGovernors .. " [ICON_ITG_GOVERNOR] Governor(s).[NEWLINE]"
	end
	table.insert(domTab, {str, ""})
	str = "[NEWLINE]CULTURE[NEWLINE]"
	local cEra = gT.Players[iPlayer].DoMdata.CultureEra;
	str = str .. "[ICON_BULLET]Your current art style is " .. gT.Globals.CultureErasNames[gT.Players[iPlayer].CultureType][cEra] .. " (Level " .. cEra .. "/9). Having a higher level than other civilizations in your culture group results in bonus towards [ICON_GREAT_WORK] Art points generation.[NEWLINE]"
--wonders
	str = str .. "[NEWLINE]WONDERS";
	--First Add to TAB!
	table.insert(domTab, {str, ""})
	str = ""
	local anyWonder = false;
	for jkj, wonderID in pairs(gT.Players[iPlayer].DoMdata.WonderAssigned) do
		anyWonder = true;
		local cstring = ""
		if gT.WondersConstructed[wonderID] == iPlayer then
			cstring = "Constructed "
		end
		str = str .. "[NEWLINE][ICON_BULLET]" .. cstring .. Locale.Lookup(GameInfo.Buildings[wonderID].Description) .. " in " .. Map.GetPlotByIndex(gT.Wonders[wonderID]):GetPlotCity():GetName() .. ".";
		local tt = GetHelpTextForBuilding(wonderID, false, false, false, nil) or ""
		table.insert(domTab, {str, tt})
		str = ""
	end
	for jkj, wdata in pairs(gT.Players[iPlayer].DoMdata.WonderRuins) do
		local ged = wdata[1];
		local iCity = Map.GetPlotByIndex(wdata[2]):GetPlotCity();
		anyWonder = true;
		local wonderID = wdata[3];
		local cstring = "";
		if gT.WondersConstructed[wonderID] == iPlayer then
			cstring = "constructed "
		end
		str = str .. "[NEWLINE][ICON_BULLET]Ruins of " .. cstring .. Locale.Lookup(GameInfo.Buildings[wonderID].Description) .. " in " .. iCity:GetName() .. ".";
		local tt = GetToolTipOfWondeRuin(wonderID) -- get help for ruins bonus
		table.insert(domTab, {str, tt})
		str = ""
	end
	for jkj, wonderID in pairs(gT.Players[iPlayer].DoMdata.Wonders) do
		anyWonder = true;
		if IsExistingWonder(wonderID) then
			str = str .. "[NEWLINE][ICON_BULLET]Constructed " .. Locale.Lookup(GameInfo.Buildings[wonderID].Description) .. ".";
		else
			str = str .. "[NEWLINE][ICON_BULLET]" .. Locale.Lookup(GameInfo.Buildings[wonderID].Description) .. " turned into dust.";
		end
		local tt = GetToolTipOfWonderConstructor(wonderID)   -- get help for constructing bonus
		table.insert(domTab, {str, tt})
		str = ""
	end
	if not anyWonder then
		str = str .. "[NEWLINE][ICON_BULLET]You have no initial wonders."
	end
	if gT.Players[iPlayer].DoMdata.NoMoreWonderRace or gT.Globals.NoMoreWonderRace then
		str = str .. "[NEWLINE][ICON_BULLET]You cannot compete to design new wonder in this era."
	else
		if gT.Players[iPlayer].DoMdata.CanWonderRace then
			str = str .. "[NEWLINE][ICON_BULLET]You start with the right to compete for the next World Wonder."
		else
			str = str .. "[NEWLINE][ICON_BULLET]You must first earn the right to compete for the next World Wonder."
		end
		if DBScenario.WonderCultureGroup then
			str = str .. "[NEWLINE][ICON_BULLET]You are only competing for new wonder against civilizations within your Culture Group."
		end
		if GetDBCulturePlayerInfo(iPlayer, "OnlyOneWonder") then
			str = str .. "[NEWLINE][ICON_BULLET]You can only design one wonder in this era."
		end
	end
	str = str .. "[NEWLINE][NEWLINE]UNIQUE COMPONENTS"
	local anyUC = false;
	table.insert(domTab, {str, ""})
	str = ""
	for jkj, unitType in pairs(gT.Players[iPlayer].DoMdata.SpecialUULog or {}) do
		str = str .. "[NEWLINE][ICON_BULLET]Unique Unit: " .. Locale.Lookup(GameInfo.Units[unitType].Description) .. "."
		anyUC = true;
		local tt = GetHelpTextForUnit(unitType, true) or ""
		table.insert(domTab, {str, tt})
		str = ""
	end
	local function AddUniqueImpro(uniqueimpro)
		str = str .. "[NEWLINE][ICON_BULLET]Unique Improvement: " .. Locale.Lookup(GameInfo.Improvements[uniqueimpro].Description) .. "."
		anyUC = true;
		local tt = GetHelpTextForImprovement(uniqueimpro, false, false, false) or ""
		table.insert(domTab, {str, tt})
		str = ""
	end
	if GetDBCulturePlayerInfo(iPlayer, "CanAcquireChateau") then
		AddUniqueImpro(GameInfoTypes.IMPROVEMENT_CHATEAU)
	end
	if GetDBCulturePlayerInfo(iPlayer, "CanAcquireFeitoria") then
		AddUniqueImpro(GameInfoTypes.IMPROVEMENT_FEITORIA)
	end
	for jkj, uniqueimpro in pairs(gT.Players[iPlayer].DoMdata.UniqueImprovements) do
		AddUniqueImpro(uniqueimpro)
	end
	if not anyUC then
		str = str .. "[NEWLINE][ICON_BULLET]You have no unique components.[NEWLINE]"
	end
	--Social Bonuses
	str = str .. "[NEWLINE]SOCIAL BONUSES"
	if gT.Globals.ScenarioType == 5 then
		if gT.Players[iPlayer].DoMdata.IdeoFromPlayer == iPlayer then
			str = str .. "[NEWLINE][ICON_BULLET]You have developed entire Ideology.[NEWLINE]"
		else
			str = str .. "[NEWLINE][ICON_BULLET]You are following " .. Players[gT.Players[iPlayer].DoMdata.IdeoFromPlayer]:GetCivilizationAdjective() .. " Ideology.[NEWLINE]"
		end
	else
		local anySoc = false;
		table.insert(domTab, {str, ""})
		str = ""
		for bh, jkx in pairs(gT.Players[iPlayer].DoMdata.InitSocialDevs) do
			str = str .. "[NEWLINE][ICON_BULLET]" .. RequestCultureTypeData(jkx, "Name") .. "."
			anySoc = true;
			local tt = RequestCultureTypeData(jkx, "Help") or ""
			table.insert(domTab, {str, tt})
			str = ""
		end
		if not anySoc then
			str = str .. "[NEWLINE][ICON_BULLET]You have not developed any Social Bonuses.[NEWLINE]"
		end
	end
	--Currency
	str = str .. "[NEWLINE]CURRENCY[NEWLINE]"
	local anyCur = false;
	for jkj, eRes in pairs(gT.Players[iPlayer].DoMdata.InitCurrency) do
		str = str .. "[ICON_BULLET]" .. GameInfo.Resources[eRes].IconString .. " " .. Locale.Lookup(GameInfo.Resources[eRes].Description) .. " is your official currency.[NEWLINE]";
		anyCur = true;
	end
	if not anyCur then
		str = str .. "[ICON_BULLET]You have no official currency yet.[NEWLINE]"
	end
	if HasMintAnyCity(iPlayer) then
		str = str .. "[ICON_BULLET]You have a Mint and actively participate in rivalization for economic bonus.[NEWLINE]"
	else
		str = str .. "[ICON_BULLET]You have no Mint and do not participate in rivalization for economic bonus yet.[NEWLINE]"
	end
	--STRATEGIC RESOURCES
	str = str .. "[NEWLINE]STRATEGIC RESOURCES[NEWLINE]"
	if DBScenario.StrategicReserveMod > 0 then
		str = str .. "[ICON_BULLET]Strategic Reserves are set at " .. DBScenario.StrategicReserveMod .. "% (you will always have this percentage of maximum total strategic resource ever owned).[NEWLINE]"
	end
	if DBScenario.StrategicResourceLimit then
		str = str .. "[ICON_BULLET]Total amount of strategic resources owned is limited to " .. DBScenario.StrategicResourceLimit .. ".[NEWLINE]"
	end
	if DBScenario.UnitsRequireStrategicRes then
		str = str .. "[ICON_BULLET]Trained units still require strategic resources and fight less effectively if you lack those resources.[NEWLINE]";
	else
		str = str .. "[ICON_BULLET]Once units are trained they no longer require strategic resources and receive no combat penalty without them.[NEWLINE]";
	end
	if DBScenario.ResLockedTurns then
		str = str .. "[ICON_BULLET]Upon training unit or constructing building requiring a resource, that resource will be locked from further use for " .. DBScenario.ResLockedTurns .. " turns.[NEWLINE]";
	end
	if DBScenario.StrategicResStorage then
		str = str .. "[ICON_BULLET]Strategic resources are storable, each source of them will generate 1 stored resource per turn. Training units and some buildings consume stored resources.[NEWLINE]";
	end
	if gT.Globals.ScenarioType == 5 then
		str = str .. "[ICON_BULLET]Detonating Atomic Bombs permanently increases usage of [ICON_RES_URANIUM] Uranium.[NEWLINE]"
	end
	if not DBScenario.MF_ImproCost100 then
		str = str .. "[ICON_BULLET]Manufactories cannot be purchased or upgraded manually.[NEWLINE]";
	else
		str = str .. "[ICON_BULLET]Manufactories are strategically linked to the " .. GetManufactoryResourceTotalString() .. ".[NEWLINE]"
	end
	if DBScenario.MF_UpgradeTime then
		str = str .. "[ICON_BULLET]Manufactories upgrade automatically once they were active for " .. DBScenario.MF_UpgradeTime .. " turns.[NEWLINE]";
	end
	if DBScenario.MF_RequireRes then
		local gMnRIcon = GetManufactoryResourceIconString()
		str = str .. "[ICON_BULLET]Manufactories require resources to be operative (" .. DBScenario.MF_ImproCost100 / 100 .. " " .. gMnRIcon .. " base, " .. (DBScenario.MF_ImproCost100 / 100 + DBScenario.MF_UpgradeCost100 / 100).. " " .. gMnRIcon .. " if upgraded).[NEWLINE]";
	end
	for row in DB.Query("SELECT ResourceType from ITG_ScenarioUntradeable WHERE ScenarioType = '" .. DBScenario.Type .. "'") do
		local res = GameInfo.Resources[row.ResourceType]
		if gT.Globals.ResourcesInScenario[res.ID] then
			str = str .. "[ICON_BULLET]" .. res.IconString .. " " .. Locale.Lookup(res.Description) .. " is untradeable.[NEWLINE]"
		end
	end
	--Academies
	str = str .. "[NEWLINE]ACADEMIES[NEWLINE]"
	str = str .. GetAcademiesTextGenerating(iPlayer);
	--Customs Houses
	str = str .. "[NEWLINE]CUSTOMS HOUSES[NEWLINE]"
	str = str .. GetCustomsHousesTextGenerating(iPlayer);
	str = str .. "[NEWLINE]MANUFACTORIES[NEWLINE]"
	str = str .. GetManufactoriesTextGenerating(iPlayer);
	--miscellaneous
	str = str .. "[NEWLINE]MISCELLANEOUS[NEWLINE]"
	str = str .. "[ICON_BULLET]Number of Agents available: " .. gT.Players[iPlayer].DoMdata.NumAgents .. ".[NEWLINE]";
	if (DBScenario.BackwardFreeTech or 0) > 0 then
		str = str .. "[ICON_BULLET]Step Forward Bonus is active. Every " .. DBScenario.BackwardFreeTech .. " turns, backward civilizations may discover one common technology.[NEWLINE]";
	end
	if GetDBCulturePlayerInfo(iPlayer, "AlternatedInnovation") == "Conquest" then
		str = str .."[ICON_BULLET]You have a chance to acquire Innovation upon conquering city. Cannot acquire Innovation with [ICON_RESEARCH] Science."
	end
	if DBScenario.IgnorePrereqTech then
		str = str .. "[ICON_BULLET]Technologies have no prerequisites.[NEWLINE]";
	end
	if GetDBCulturePlayerInfo(iPlayer, "CanPilgrim") then
		str = str .. "[ICON_BULLET]Cities can generate Pilgrims.[NEWLINE]";
	end
	str = str .. "[ICON_BULLET]Production to [ICON_GREAT_ARTIST] Art points from Cultural Heritage conversion rate: " .. DBScenario.CultHeritagePercent .. "%.[NEWLINE]"; 
	str = str .. "[ICON_BULLET]Base Unit maintenance: " .. GetDBCulturePlayerInfo(iPlayer, "GoldPerUnitTimes100") / 100 .. " [ICON_GOLD].[NEWLINE]";
	if DBScenario.InnoPairs then
		str = str .. "[ICON_BULLET]Innovations are grouped in mutually exclusive pairs.[NEWLINE]";
	elseif DBScenario.TempExclusiveInnovations then
		str = str .. "[ICON_BULLET]Innovations are exclusive to the first civilization that discover them until all Innovations are taken.[NEWLINE]";
	else
		str = str .. "[ICON_BULLET]Innovations are exclusive to the first civilization that discover them.[NEWLINE]";
	end
	str = str .. "[ICON_BULLET]Reward from [ICON_ITG_FESTIVAL] Festivals: " .. GetFestivalRewardString(gT.Players[iPlayer].DoMdata.FestivalReward[1], gT.Players[iPlayer].DoMdata.FestivalReward[2]) .. " [ICON_GOLD].[NEWLINE]";
	if DBScenario.SettlersOff then
		str = str .. "[ICON_BULLET]Settlers are disabled.[NEWLINE]";
	else
		if gT.Players[iPlayer].DoMdata.SettlerType == -1 then
			str = str .. "[ICON_BULLET]You cannot train Settlers.[NEWLINE]";
		end
		if GetDBCulturePlayerInfo(iPlayer, "SettlerCostPerCity") > 0 then
			str = str .. "[ICON_BULLET]Cost of [ICON_ITG_SETTLER] Settler is increased by " .. GetDBCulturePlayerInfo(iPlayer, "SettlerCostPerCity") .. " points per city.[NEWLINE]";
		end
		if DBScenario.SettlerInstant then
			str = str .. "[ICON_BULLET]Cannot acquire Settlers. Upon reaching a treshold [ICON_ITG_PRESENCE] Cultural Presence is increased in a random foreign City by 100 instead.[NEWLINE]"
		end
	end
	if TabClimateText[gT.Globals.ClimateType] then
		str = str .. "[ICON_BULLET]" .. Locale.Lookup(TabClimateText[gT.Globals.ClimateType]) .. "[NEWLINE]";
	end
	if DBScenario.ColonyInstant then
		str = str .. "[ICON_BULLET]Cannot acquire Colonies. Upon generating new point [ICON_INFLUENCE] Influence within all City-States is increased by " .. BASE_INFLUENCE_FROM_GLOBAL_COLONY .. " instead.[NEWLINE]"
	end
	str = str .. "[ICON_BULLET]Base Unit supply: " .. GetDBCulturePlayerInfo(iPlayer, "UnitSupply") .. " [ICON_ITG_SUPPLY].[NEWLINE]";
	if DBScenario.NoFaithGeneration then
		str = str .. "[ICON_BULLET]Faith and Religion are disabled.[NEWLINE]";
	else
		if not GetDBCulturePlayerInfo(iPlayer, "CanHaveFaithGoodyHuts") then
			str = str .. "[ICON_BULLET]You cannot gain [ICON_PEACE] Faith from Ancient Ruins.[NEWLINE]";
		end
		if not GetDBCulturePlayerInfo(iPlayer, "CanHaveScienceNaturalWonder") then
			str = str .. "[ICON_BULLET]You cannot gain [ICON_PEACE] Faith from discovering Natural Wonders.[NEWLINE]";
		end
	end
	for row in DB.Query("SELECT * FROM ITG_CultureFreeResources WHERE " .. itgDBcultsearch) do
		str = str .. "[ICON_BULLET]Starts with " .. row.Amount .. " " .. GameInfo.Resources[row.ResourceType].IconString .. " " .. Locale.Lookup(GameInfo.Resources[row.ResourceType].Description) .. "[NEWLINE].";
	end
	if not GetDBCulturePlayerInfo(iPlayer, "CanHaveScienceNaturalWonder") then
		str = str .. "[ICON_BULLET]You cannot gain [ICON_RESEARCH] Science from discovering Natural Wonders.[NEWLINE]";
	end
	if not GetDBCulturePlayerInfo(iPlayer, "CanBuyAgents") then
		str = str .. "[ICON_BULLET]You cannot purchase [ICON_SPY] Agents with [ICON_GOLD] Gold.[NEWLINE]";
	end
	str = str .. "[ICON_BULLET]Amount of [ICON_GOLD] Gold from City Connections not affected by -50% modifier: " .. GetDBCulturePlayerInfo(iPlayer, "UnmoddedCityConnection") .. ".[NEWLINE]";
	if not GetDBCulturePlayerInfo(iPlayer, "CanMigrateToOther") then
		str = str .. "[ICON_BULLET]Your [ICON_GREAT_PEOPLE] Great People does not migrate away to civilizations of other cultural groups.[NEWLINE]";
	end
	if not GetDBCulturePlayerInfo(iPlayer, "CanControlForts") then
		str = str .. "[ICON_BULLET]You cannot acquire Forts with basic bonuses.[NEWLINE]";
	end
	--Miscellanous
	str = str .. "[NEWLINE]VICTORY POINTS"
	table.insert(domTab, {str, ""})
	for a, bb in pairs(GetPlayerVictoryTasksForDoM(iPlayer)) do
		table.insert(domTab, {"[NEWLINE][ICON_BULLET]" .. bb[1], bb[2]})
	end
	MapModData.ITGSG = domTab;
end
LuaEvents.ITGSG_RequestDoMinfo.Add(GenerateTheDoMText)

function TopPanelTextGenerating(type)
	local strText = ""
	local gPlayer = Game.GetActivePlayer()
	local pPlayer = Players[gPlayer];
	if type == "WonderRace" then
		strText = "Amount of points stored toward next Wonder Race, which took place every 10 turns. The winner earns the right to build new World Wonder.[NEWLINE]";
		local tab = {}
		table.insert(tab, {GetWonderPointsFromCities(gPlayer, true),"Cities"})
		table.insert(tab, {GetWonderPointsFromManufactories(gPlayer),"Manufactories"})
		table.insert(tab, {GetWonderPointsFromFaith(gPlayer),"Faith"})
		table.insert(tab, {GetWonderPointsFromCS(gPlayer),"City-States"})
		table.insert(tab, {GetWonderPointsFromGPC(gPlayer),"Great People"})
		table.insert(tab, { math.floor(10 * GetEstimatedWonderPointsFromProcess(gPlayer)) / 10,"Wonder Process"})
		table.insert(tab, {GetEstimatedWonderPointsFromWorkRate(gPlayer),"Work Rate"})
		table.insert(tab, {GetWonderPointsFromSphinx(gPlayer),"Sphinx"})
		table.insert(tab, {GetWonderPointsFromTechs(gPlayer),"Technologies"})
		table.insert(tab, {GetWonderPointsFromMountainTemple(gPlayer),"Kailasa temple"})
		table.insert(tab, {GetWonderPointsFromAcademies(gPlayer),"Academies"})
		table.insert(tab, {GetWonderPointsFromLuxuries(gPlayer),"Luxuries"})
		for i, data in pairs(tab) do
			if data[1] > 0 then
				strText = strText .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]+" .. data[1] .. "[ENDCOLOR] [ICON_GREAT_ENGINEER] from " .. data[2]
			elseif data[1] < 0 then
				strText = strText .. "[NEWLINE][ICON_BULLET][COLOR_NEGATIVE_TEXT]" .. data[1] .. "[ENDCOLOR] [ICON_GREAT_ENGINEER] from " .. data[2]
			end
		end
	--process
		strText = strText .. "[NEWLINE][NEWLINE]The generation rate is reduced by the amount of your cities ([COLOR_NEGATIVE_TEXT]" .. GetNegativeModifierFromCitiesGPWonderArt(gPlayer)*100 .. "%[ENDCOLOR])."
		if DBScenario.WonderCultureGroup then
			strText = strText .. "[NEWLINE][NEWLINE]Current minimum treshold to acquire Wonder is " .. gT.Globals.WonderCTTresholds[gT.Players[gPlayer].CultureType] .. " [ICON_GREAT_ENGINEER] for your culture group."
		else
			strText = strText .. "[NEWLINE][NEWLINE]Current minimum treshold to acquire Wonder is " .. gT.Globals.WonderTreshold .. " [ICON_GREAT_ENGINEER]."
		end
		if GetDBCulturePlayerInfo(gPlayer, "OnlyOneWonder") then
			strText = strText .. "[NEWLINE][NEWLINE]You can only design one wonder in this era."
		end
	elseif type == "GreatWork" then
		strText = "Amount of Great Works your empire created. They yield " .. gT.Players[gPlayer].CulturePerGW .. " [ICON_CULTURE] Culture and " .. gT.Players[gPlayer].GWCultureIntoNU .. " [ICON_ITG_UNIFY] unifying presence.[NEWLINE]"
		strText = strText .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]" .. gT.Players[gPlayer].NumGWoM .. "[ENDCOLOR] [ICON_GREAT_WORK] Great Works of Music (provide [ICON_HAPPINESS_1])"
		strText = strText .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]" .. gT.Players[gPlayer].NumGWoL .. "[ENDCOLOR] [ICON_GREAT_WORK] Great Works of Literature (provide [ICON_RESEARCH])"
		strText = strText .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]" .. gT.Players[gPlayer].NumGWoA .. "[ENDCOLOR] [ICON_GREAT_WORK] Great Works of Art (provide [ICON_GOLD])"
		local music,literature,art,total = GetPlayerChanceForCreatingGreatWorksOfType(gPlayer);
		strText = strText .. "[NEWLINE][NEWLINE]Chances for next [ICON_GREAT_WORK] Great Work:"
		strText = strText .. "[NEWLINE][ICON_BULLET]Art: " .. math.floor(art * 1000 / total)/10 .. "%"
		strText = strText .. "[NEWLINE][ICON_BULLET]Literature: " .. math.floor(literature * 1000 / total)/10 .. "%"
		strText = strText .. "[NEWLINE][ICON_BULLET]Music: " .. math.floor(music * 1000 / total)/10 .. "%"
	elseif type == "Festival" then
		strText = GetFestivalTextForTP(gPlayer)
	elseif type == "Mercenary" then
		strText = GetMercenaryTextForTP(gPlayer)
	elseif type == "Colony" then
		if DBScenario.ColonyInstant then
			strText = "Upon generating enough Colony points you receive +" .. GetInfluenceFromGlobalColony(gPlayer) .. " [ICON_INFLUENCE] Influence within all met City-States and treshold will increase."
		else
			strText = "Upon generating enough Colony points, you can place a new Colony, connecting the new resource to your empire or boost [ICON_INFLUENCE] Influence with city-state."
		end
		local bFirst = true;
		local tTab = {}
		table.insert(tTab, {GetColonyPointsFromCities(gPlayer, true), "Cities"})
		table.insert(tTab, {GetColonyPointsFromReligion(gPlayer, true), "Religion"})
		table.insert(tTab, {GetColonyPointsFromTech(gPlayer), "Technologies"})
		table.insert(tTab, {GetColonyPointsFromInnovations(gPlayer), "Innovations"})
		table.insert(tTab, {GetColonyPointsFromCS(gPlayer), "City-States"})
		local totalbase = 0;
		for i, v in pairs(tTab) do
			totalbase = totalbase + v[1];
		end
		for i, v in pairs(tTab) do
			if v[1] > 0 or v[1] < 0 then
				if bFirst then
					strText = strText .. "[NEWLINE]";
					bFirst = false;
				end
				if v[1] > 0 then
					strText = strText .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]+" .. v[1] .. "[ENDCOLOR] [ICON_GREAT_MERCHANT] from " .. v[2]
				else
					strText = strText .. "[NEWLINE][ICON_BULLET][COLOR_NEGATIVE_TEXT]" .. v[1] .. "[ENDCOLOR] [ICON_GREAT_MERCHANT] from " .. v[2]
				end
			end
		end
		strText = strText .. "[NEWLINE][NEWLINE]For next Colony you need to collect " .. GetColonyITGTreshold(gPlayer) .. " [ICON_GREAT_MERCHANT] Colony points."
		if IsHasLaw(gPlayer, 16, 1) then
			strText = strText .. "[NEWLINE][NEWLINE]Law: Every eighth [ICON_GREAT_MERCHANT] Colony point is transformed into [ICON_ITG_SETTLER] Settler point."
		end
		--if law then
	elseif type == "Settler" then
		if DBScenario.SettlerInstant then
			strText = "Progress towards next Settler, which increases your [ICON_ITG_PRESENCE] Cultural Presence in a random City outside the empire by 100. Points are earned from Granaries, cities' growth and loss."
		else
			strText = "Progress towards next Settler, which can be used to found a new city or distribute [ICON_FOOD] Food to target city. Points are earned from Granaries, cities' growth and loss.";
		end
		local bFirst = true;
		local bTT = {}
		table.insert(bTT, {GetSettlerPointsFromCities(gPlayer), "Cities"})
		table.insert(bTT, {GetSettlerPointsFromPopGrowth(gPlayer), "Population Growth"})
		table.insert(bTT, {GetSettlerPointsFromColonies(gPlayer), "Colonies"})
		table.insert(bTT, {GetSettlerPointsFromGP(gPlayer), "Great People"})
		table.insert(bTT, {GetSettlerPointsFromTech(gPlayer), "Technologies"})
		table.insert(bTT, {GetSettlerPointsFromInnovations(gPlayer), "Innovations"})
		table.insert(bTT, {GetSettlerPointsFromCultureType(gPlayer), "Cultural Trait"})
		table.insert(bTT, {GetSettlerPointsFromReligion(gPlayer), "Religion"})
		table.insert(bTT, {GetSettlerPointsFromEmigration(gPlayer), "Emigration (no Cities)"})
		table.insert(bTT, {GetSettlerPointsFromSettlements(gPlayer), "Settlements"})
		for i, bb in pairs(bTT) do
			if bb[1] ~= 0 then
				if bFirst then
					strText = strText .. "[NEWLINE]";
					bFirst = false;
				end
				if bb[1] > 0 then
					strText = strText .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]+" .. bb[1] .. "[ENDCOLOR] [ICON_ITG_SETTLER] from " .. bb[2]
				else
					strText = strText .. "[NEWLINE][ICON_BULLET][COLOR_NEGATIVE_TEXT]" .. bb[1] .. "[ENDCOLOR] [ICON_ITG_SETTLER] from " .. bb[2]
				end
			end
		end
		local numSetLog = #gT.Players[gPlayer].SettlerLog - 10;
		local sh = ""
		for i, v in pairs(gT.Players[gPlayer].SettlerLog) do
			if i > numSetLog then
				local tempStr;
				if v[1] == 0 then
					tempStr = "We have relocated citizens to [ICON_FOOD] " .. Map.GetPlotByIndex(v[3]):GetPlotCity():GetName() .. "."
				elseif v[1] == 1 then
					tempStr = "We have created a commune in [ICON_CITY_STATE] " .. Map.GetPlotByIndex(v[3]):GetPlotCity():GetName() .. "."
				elseif v[1] == 2 then
					tempStr = "Our citizens settled in [ICON_ITG_PRESENCE] " .. Map.GetPlotByIndex(v[3]):GetPlotCity():GetName() .. "."
				elseif v[1] == 3 then
					tempStr = Map.GetPlotByIndex(v[3]):GetPlotCity():GetName() .. " was a target of [ICON_ITG_PRESENCE] " .. Players[v[2]]:GetCivilizationAdjective() .. " immigrants."
				elseif v[1] == 4 then
					tempStr = "We have created a new [ICON_ITG_SETTLER] settlement."
				elseif v[1] == 5 then
					tempStr = "We have expanded an existing [ICON_ITG_SETTLER] settlement."
				elseif v[1] == 6 then
					tempStr = "Our settlement grew into a new city - " .. Map.GetPlotByIndex(v[3]):GetPlotCity():GetName() .. "."
				end
				sh = "[NEWLINE][ICON_BULLET]" .. v[4] .. "T: " .. tempStr .. sh;
			end
		end
		if sh ~= "" then
			strText = strText .. "[NEWLINE][NEWLINE]Recent actions:" .. sh
		end
		if not gT.Players[gPlayer].CanSettleNewCity then
			strText = strText .. "[NEWLINE][NEWLINE][COLOR_NEGATIVE_TEXT]You cannot found new settlements in this scenario.[ENDCOLOR]" 
		elseif gT.Players[gPlayer].SettlingGlobally then
			strText = strText .. "[NEWLINE][NEWLINE]You can create new Settlements around the globe. Upgrading a Settlement twice will result in founding new City. You can upgrade a Settlement once every 3 turns and only if it is not damaged."
		else
			strText = strText .. "[NEWLINE][NEWLINE]New Settlements must be within 25 radius to your city if you have one. Upgrading a Settlement twice will result in founding new City. You can upgrade a Settlement once very 3 turns and only if it is not damaged."
		end
		if IsHasLaw(gPlayer, 16, 2) then
			strText = strText .. "[NEWLINE][NEWLINE]Law: Every sixth [ICON_ITG_SETTLER] Settler point is transformed into [ICON_GREAT_MERCHANT] Colony point. This includes points generated by training Settlers."
		end
	elseif type == "GreatArtist" then
		strText = "Amount of [ICON_GREAT_ARTIST] Art your empire generated in current artistic period. Each artistic period lasts 20 turns, after that points are reset and [ICON_GREAT_WORK] Great Works are acquired based on them.[NEWLINE][NEWLINE]Your current Art Style is "
		strText = strText .. gT.Globals.CultureErasNames[gT.Players[gPlayer].CultureType][gT.Players[gPlayer].CultureEra] .. " (" .. gT.Players[gPlayer].CultureEra .. "/9), which grants [COLOR_POSITIVE_TEXT]" .. GetCurrentModifierFromCultureEra(gPlayer) .. "%[ENDCOLOR] bonus towards generating [ICON_GREAT_ARTIST] Art points.[NEWLINE]"; 
		local tTab = {}
		table.insert(tTab, {math.floor(GetArtistPointsCitiesPerTurn(gPlayer, true)),"Cities"})
		table.insert(tTab, {GetArtPointsFromFaith(gPlayer),"Faith"})
		table.insert(tTab, {GetArtPointsFromTechnologies(gPlayer),"Technologies"})
		table.insert(tTab, {GetArtistPointsFromInnovations(gPlayer),"Innovations"})
		table.insert(tTab, {GetArtPointsFromLeagues(gPlayer),"Leagues"})
		table.insert(tTab, {GetArtistPointsFromHap(gPlayer),"Happiness"})
		table.insert(tTab, {GetArtistPointsFromPalace(gPlayer),"Palaces"})
		table.insert(tTab, {GetArtFromIdeologies(gPlayer),"Ideologies"})
		table.insert(tTab, {GetArtPointsFromLaws(gPlayer),"Laws"})
		table.insert(tTab, {GetEstimatedArtPointsFromProcess(gPlayer), "Cultural Heritage"})
		table.insert(tTab, {GetArtistPointsFromAuthority(gPlayer),"Authority"})
		table.insert(tTab, {GetArtistPointsFromGPC(gPlayer),"Great People"})
		table.insert(tTab, {GetArtistPointsFromSmuggling(gPlayer),"Smuggling Art"})
		table.insert(tTab, {CollectCityBonusesEmpireWide(gPlayer, 18),"Governance"})
		table.insert(tTab, {GetArtistPointsFromCS(gPlayer),"City-States"})
		table.insert(tTab, {GetGPnArtFromFestivalChance(gPlayer),"Festival chance"})
		table.insert(tTab, {GetArtFromCodex(gPlayer),"Codex"})
		table.insert(tTab, {GetArtPointsFromGovernors(gPlayer),"Governors"})
		table.insert(tTab, {GetArtistPointsFromJewellery(gPlayer),"Jewellery"})
		table.insert(tTab, {GetArtistPointsFromAcademies(gPlayer),"Academies"})
		table.insert(tTab, {math.floor(10 * GetArtistPointsFromWonderPoints(gPlayer))/10,"Wonder Points"})
		for i, v in pairs(tTab) do
			if v[1] > 0 then
				strText = strText .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]+" .. v[1] .. "[ENDCOLOR] [ICON_GREAT_ARTIST] from " .. v[2]
			elseif v[1] < 0 then
				strText = strText .. "[NEWLINE][ICON_BULLET][COLOR_NEGATIVE_TEXT]" .. v[1] .. "[ENDCOLOR] [ICON_GREAT_ARTIST] from " .. v[2]
			end
		end

		strText = strText .. "[NEWLINE][NEWLINE]The generation rate is reduced by the amount of your cities ([COLOR_NEGATIVE_TEXT]" .. GetNegativeModifierFromCitiesGPWonderArt(gPlayer)*100 .. "%[ENDCOLOR])."
	elseif type == "Faith" then
		strText = GetTTFaithString(gPlayer)
	elseif type == "Happiness" then
		strText = "Cities' list with current Happiness and chance for generating unhappiness/legal unhappiness/happiness per turn:[NEWLINE]"
		local thh = GetCitiesConsideredForAverageHappiness(gPlayer) 
		for ji, index in pairs(thh) do
			local iCity = Map.GetPlotByIndex(index):GetPlotCity();
			local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
			if iCity:GetOwner() == gPlayer then
				if gT.Cities[cID].Happiness < 0 then
					strText = strText .. "[NEWLINE][ICON_BULLET][COLOR_NEGATIVE_TEXT]"  .. gT.Cities[cID].Happiness .. "[ENDCOLOR][ICON_HAPPINESS_4] "
				else
					strText = strText .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]"  .. gT.Cities[cID].Happiness .. "[ENDCOLOR][ICON_HAPPINESS_1] ";
				end
				strText = strText .. iCity:GetName() .. " (" .. GetGenerateUnhappinessChanceCity(iCity, gPlayer, cID, true)/10 .. "%[ICON_HAPPINESS_4], " .. math.min(100,GetGenerateHappinessChanceCity(iCity, gPlayer, cID, nil, true)/10) .. "%[ICON_HAPPINESS_1])";
			elseif gT.Cities[cID].Happiness < 0 then
				strText = strText .. "[NEWLINE][ICON_BULLET][COLOR_NEGATIVE_TEXT]"  .. gT.Cities[cID].Happiness .. "[ENDCOLOR][ICON_HAPPINESS_4] " .. iCity:GetName();
			else
				strText = strText .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]"  .. gT.Cities[cID].Happiness .. "[ENDCOLOR][ICON_HAPPINESS_1] " .. iCity:GetName();
			end
		end
		if (gT.Players[gPlayer].ExtraAvgHap or 0) > 0 then
			strText = strText .. "[NEWLINE][NEWLINE]Average happiness increased by [COLOR_POSITIVE_TEXT]" .. gT.Players[gPlayer].ExtraAvgHap .. "[ENDCOLOR] from special effects."
		elseif (gT.Players[gPlayer].ExtraAvgHap or 0) < 0 then
			strText = strText .. "[NEWLINE][NEWLINE]Average happiness increased by [COLOR_NEGATIVE_TEXT]" .. gT.Players[gPlayer].ExtraAvgHap .. "[ENDCOLOR] from special effects."
		end
		strText = strText .. "[NEWLINE][NEWLINE]Base empire-wide chance that cities are gonna generate +1 [ICON_HAPPINESS_1]: " .. GetPlayerHapChance(gPlayer)/10 .. "%."
		strTExt = strText .. "[NEWLINE][NEWLINE]Luxury resources:"
		local lLostR = {}
		for row in GameInfo.Resources() do
			if row.Happiness > 0 then
				if Players[gPlayer]:GetNumResourceTotal(row.ID, true) > 0 then
					if gT.Players[gPlayer].HapChanceFromLuxuries[row.ID] then
						strText = strText .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]" .. gT.Players[gPlayer].HapChanceFromLuxuries[row.ID]  .. "%[ENDCOLOR] " .. row.IconString .. " " .. Locale.Lookup(row.Description) 
						if Players[gPlayer]:GetNumResourceTotal(row.ID, false) > 0 then
							strText = strText .. " (" .. Players[gPlayer]:GetNumResourceTotal(row.ID, true) .. ")."
						else
							strText = strText .. " ([COLOR_YIELD_FOOD]" .. Players[gPlayer]:GetNumResourceTotal(row.ID, true) .. "[ENDCOLOR])."
						end
					else
						strText = strText .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]0%[ENDCOLOR] " .. row.IconString .. " " .. Locale.Lookup(row.Description) .. " (" .. Players[gPlayer]:GetNumResourceTotal(row.ID, true) .. ")."
					end
				elseif gT.Players[gPlayer].HapChanceFromLuxuries[row.ID] then
					table.insert(lLostR, row.ID)
				end
			end
		end
		if #lLostR > 0 then
			strText = strText .. "[NEWLINE][NEWLINE]Recently lost luxury resources:"
			for it, res in pairs(lLostR) do
				strText = strText .. "[NEWLINE][ICON_BULLET]" .. GameInfo.Resources[res].IconString .. " " .. Locale.Lookup(GameInfo.Resources[res].Description)
			end
		end
		local numAuctionHouse = GetNumAvailableLuxuriesAH(gPlayer)
		if numAuctionHouse > 0 then
			if numAuctionHouse == 1 then
				strText = strText .. "[NEWLINE][NEWLINE]There is [COLOR_POSITIVE_TEXT]1[ENDCOLOR] Luxury resource available in Auction House.";
			else
				strText = strText .. "[NEWLINE][NEWLINE]There are [COLOR_POSITIVE_TEXT]" .. numAuctionHouse .. "[ENDCOLOR] Luxury resources available in Auction House.";
			end
		end

		local tab = {}
		table.insert(tab, {GetHapChanceFromDecadentism(gPlayer), "Decadence"})
		table.insert(tab, {GetHappinessChanceFromMinorCivs(gPlayer), "City-States"})
		table.insert(tab, {GetHapChanceFromReligion(gPlayer), "Religion"})
		table.insert(tab, {GetHapChanceFromSocialDev(gPlayer), "Social Developments"})
		table.insert(tab, {GetPlayerHapChanceFromInnovations(gPlayer), "Innovations"})
		table.insert(tab, {GetHapChanceFromMorale(gPlayer), "Morale"})
		table.insert(tab, {GetHapChanceFromGoverment(gPlayer), "Goverment"})
		table.insert(tab, {GetHapChanceFromRebels(gPlayer), "lack of rebellions", "rebellions and riots"})
		table.insert(tab, {GetHapChanceFromNumCities(gPlayer), "Number of Cities"})
		table.insert(tab, {GetHapChanceFromHolySites(gPlayer), "Holy Sites"})
		table.insert(tab, {GetHapChanceFromGP(gPlayer), "Great People"})
		table.insert(tab, {GetHapChanceFromGW(gPlayer), "Great Works"})
		table.insert(tab, {GetHapChanceFromLeagues(gPlayer), "Leagues"})
		table.insert(tab, {GetHapChanceFromCivilWar(gPlayer), "Cultural Tensions"})
		table.insert(tab, {GetHapChanceFromLuxuryLost(gPlayer), "Recently lost Luxury"})
		 
		table.insert(tab, {GetHapChanceFromIdeology(gPlayer), "Ideologies"})
		table.insert(tab, {GetHapChanceFromCodex(gPlayer), "Codex"})
		local hEstring = "";
		for gji, data in pairs(tab) do
			if data[1] > 0 then
				hEstring = hEstring .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]" .. data[1]/10 .. "%[ENDCOLOR] from " .. data[2] .. "."
			elseif data[1] < 0 then
				hEstring = hEstring .. "[NEWLINE][ICON_BULLET][COLOR_NEGATIVE_TEXT]" .. data[1]/10 .. "%[ENDCOLOR] from " .. (data[3] or data[2]) .. "."
			end
		end
		if hEstring ~= "" then
			strText = strText .. "[NEWLINE][NEWLINE]Other sources of Happiness chance:" .. hEstring;
		end
		strText = strText .. "[NEWLINE][NEWLINE]Loosing a luxury resource may trigger an additional [ICON_HAPPINESS_4] Unhappiness roll.[NEWLINE]Creating a military unit will trigger an extra [ICON_HAPPINESS_4] Unhappiness roll with [COLOR_NEGATIVE_TEXT]" .. GetUnhappinessChanceForMilitaryUnit(gPlayer, nil, true)/10 .. "[ENDCOLOR]% base chance.";
		strText = strText .. "[NEWLINE][NEWLINE]Citizens of unhappy cities may start [ICON_RESISTANCE] Riots or migrate away.";
	elseif type == "Culture" then
		strText = GetTTCultureString(gPlayer)
	elseif type == "Science" then
		strText = GetTTScienceString(gPlayer)
	elseif type == "Morale" then
		strText = "[ICON_ITG_MORALE] Morale is a minor combat modifier (" .. gT.Players[gPlayer].MinMoraleRange .. " to " .. gT.Players[gPlayer].MaxMoraleRange .. "%) dependent on the troops' mood. It is based on current situation and events, while also changing randomly each turn by 1."
		local knmd = #gT.Players[gPlayer].MoraleLog;
		if #gT.Players[gPlayer].SituationMorale > 0 then
			local mfscrg = gT.Players[gPlayer].CurrentSituation;
			if mfscrg > 0 then
				strText = strText .. "[NEWLINE][NEWLINE]Current situation of [ICON_ITG_MORALE] Morale ([COLOR_POSITIVE_TEXT]+" .. mfscrg  .. "%[ENDCOLOR]):"
			else
				strText = strText .. "[NEWLINE][NEWLINE]Current situation of [ICON_ITG_MORALE] Morale ([COLOR_NEGATIVE_TEXT]" .. mfscrg  .. "%[ENDCOLOR]):"
			end
			for i, data in pairs(gT.Players[gPlayer].SituationMorale) do
				if data[1] >= 0 then
					strText = strText .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]+" .. data[1] .. "%[ENDCOLOR] [ICON_ITG_MORALE] from " .. data[2] .. "."; 
				else
					strText = strText .. "[NEWLINE][ICON_BULLET][COLOR_NEGATIVE_TEXT]" .. data[1] .. "%[ENDCOLOR] [ICON_ITG_MORALE] from " .. data[2] .. "."; 
				end
			end
		end
		if knmd > 0 then
			if gT.Players[gPlayer].MoralePoints >= 0 then
				strText = strText .. "[NEWLINE][NEWLINE]List of recent events related to [ICON_ITG_MORALE] Morale ([COLOR_POSITIVE_TEXT]+" .. gT.Players[gPlayer].MoralePoints .. "%[ENDCOLOR]):"
			else
				strText = strText .. "[NEWLINE][NEWLINE]List of recent events related to [ICON_ITG_MORALE] Morale ([COLOR_NEGATIVE_TEXT]" .. gT.Players[gPlayer].MoralePoints .. "%[ENDCOLOR]):"
			end
			for i = 1, knmd do
				local kid = knmd + 1 - i;
				if gT.Players[gPlayer].MoraleLog[kid][1] >= 0 then
					strText = strText .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]+" .. gT.Players[gPlayer].MoraleLog[kid][1] .. "%[ENDCOLOR] [ICON_ITG_MORALE] from " .. gT.Players[gPlayer].MoraleLog[kid][2] .. "."; 
				else
					strText = strText .. "[NEWLINE][ICON_BULLET][COLOR_NEGATIVE_TEXT]" .. gT.Players[gPlayer].MoraleLog[kid][1] .. "%[ENDCOLOR] [ICON_ITG_MORALE] from " .. gT.Players[gPlayer].MoraleLog[kid][2] .. "."; 
				end
			end
			strText = strText .. "[NEWLINE][NEWLINE][ICON_ITG_MORALE] Morale below -10% may cause units to loose attack ability for a turn.[NEWLINE][ICON_ITG_MORALE] Morale above 10% reduces chances for Rebels to spawn."
		end
	elseif type == "Resource" then
		strText = GetResourceTooltipITG(gPlayer);
	elseif type == "Gold" then
		local pPlayer = Players[gPlayer];
		local pTeam = Teams[pPlayer:GetTeam()];
		local iTotalGold = pPlayer:GetGold();
		if DBScenario.GoldBudgetOnly then
			strText = "In this scenario stored [ICON_GOLD] Gold above " .. GetGoldBudgetLimit(gPlayer) .. " is spend according to set budget. Most common ways to spend [ICON_GOLD] Gold are disabled.[NEWLINE][NEWLINE]"
		end

		local tGoldTab = {}
		table.insert(tGoldTab,{GetGoldFromTech(gPlayer), "Technologies"})
		table.insert(tGoldTab,{GetPlayer10thBonusFromCaliph(gPlayer), "Caliphate"})
		table.insert(tGoldTab,{math.max(0, GetGoldFromGreatPeople(gPlayer)), "Great People"})
		table.insert(tGoldTab,{GetGoldFromHolySites(gPlayer), "Holy Sites"})
		table.insert(tGoldTab,{GetGoldFromCityStates(gPlayer), "City-States"})
		table.insert(tGoldTab,{GetGoldFromColonies(gPlayer), "Colonies"})
		table.insert(tGoldTab,{GetGoldPTFromPancras(gPlayer), "St Pancras Station"})
		table.insert(tGoldTab,{GetGoldFromGreatWorks(gPlayer), "[ICON_GREAT_WORK] Great Works"})
		table.insert(tGoldTab,{pPlayer:GetGoldPerTurnFromReligion(), "Religion"})
		table.insert(tGoldTab,{GetGoldFromWorldWideEconomy(), "Worldwide Economy"})
		table.insert(tGoldTab,{pPlayer:GetGoldFromCitiesMinusTradeRoutesTimes100() / 100, "Cities"})
		table.insert(tGoldTab,{pPlayer:GetCityConnectionGoldTimes100() / 100, "City Connections"})
		table.insert(tGoldTab,{GetGoldFromCasino(gPlayer), "Casino"})
		table.insert(tGoldTab,{-1 * GetTitheGoldReduction(gPlayer), "Tithe"})
		table.insert(tGoldTab,{GetPlayerQuarantineCost(gPlayer), "Quarantine"})
		table.insert(tGoldTab,{GetExtraCostOfMercenaries(gPlayer), "Mercenaries"})
		table.insert(tGoldTab,{GetPlayerGreatPeopleCost(gPlayer), "Patronage of State"})
		table.insert(tGoldTab,{GetIdeology41Gold(gPlayer), "Liberty of Mind"})
		local unitmaintcost = -1 * pPlayer:CalculateUnitCost();
		local nationalparkscost = GetPlayerNationalParkCost(gPlayer);
		unitmaintcost = unitmaintcost + nationalparkscost;
		table.insert(tGoldTab,{unitmaintcost, "Unit Maintenance (x" .. gT.Players[gPlayer].TPGoldPerUnit100 / 100 .. "[ICON_GOLD])"})
		table.insert(tGoldTab,{nationalparkscost, "National Parks"})
		table.insert(tGoldTab,{-1 * pPlayer:CalculateUnitSupply(), "Unit Supply"})
		table.insert(tGoldTab,{-1 * pPlayer:GetBuildingGoldMaintenance(), "Building Maintenance"})
		table.insert(tGoldTab,{-1 * pPlayer:GetImprovementGoldMaintenance(), "Improvement Maintenance"})
		table.insert(tGoldTab,{pPlayer:GetGoldPerTurnFromTraits() , "Traits"})
		local iGoldPerTurnFromOtherPlayers = pPlayer:GetGoldPerTurnFromDiplomacy() + GetGoldFromAuctionDeals(gPlayer);
		local iGoldPerTurnToOtherPlayers = 0;
		if (iGoldPerTurnFromOtherPlayers < 0) then
			iGoldPerTurnToOtherPlayers = -iGoldPerTurnFromOtherPlayers;
			iGoldPerTurnFromOtherPlayers = 0;
		end
		table.insert(tGoldTab,{iGoldPerTurnFromOtherPlayers, "Deals"})
		local fTradeRouteGold = (pPlayer:GetGoldFromCitiesTimes100() - pPlayer:GetGoldFromCitiesMinusTradeRoutesTimes100()) / 100;
		table.insert(tGoldTab,{fTradeRouteGold , "Vanilla Trade Routes Should be 0"})
		table.insert(tGoldTab,{GetGoldFromTradeRoutesInTime(gPlayer) , "Trade Routes (" .. gT.Players[gPlayer].TotalTradeRouteGold .. ")"})
		table.insert(tGoldTab,{GetGoldFromSolvePoority(gPlayer), "Solving Poority"})
		table.insert(tGoldTab,{GetGoldFromLeagues(gPlayer), "Leagues"})
		
		if (pPlayer:IsAnarchy()) then
			strText = strText .. Locale.ConvertTextKey("TXT_KEY_TP_ANARCHY", pPlayer:GetAnarchyNumTurns());
			strText = strText .. "[NEWLINE][NEWLINE]";
		end
		local fTotalIncome = 0;
		local iTotalExpenses = 0;
		for i, v in pairs(tGoldTab) do
			if v[1] > 0 then
				fTotalIncome = fTotalIncome + v[1];
			else
				iTotalExpenses = iTotalExpenses + v[1];
			end
		end
	
		strText = strText .. "[COLOR:150:255:150:255]";
		strText = strText .. "+" .. Locale.ConvertTextKey("TXT_KEY_TP_TOTAL_INCOME", math.floor(fTotalIncome));
		for i, v in pairs(tGoldTab) do
			if v[1] > 0 then
				strText = strText .. "[NEWLINE]  [ICON_BULLET]" .. v[1] .. " from " .. v[2] .. ".";
			end
		end
	
		strText = strText .. "[/COLOR]";
		
		strText = strText .. "[NEWLINE]";
		strText = strText .. "[COLOR:255:150:150:255]";
		strText = strText .. "[NEWLINE]" .. Locale.ConvertTextKey("TXT_KEY_TP_TOTAL_EXPENSES", iTotalExpenses);
		for i, v in pairs(tGoldTab) do
			if v[1] < 0 then
				strText = strText .. "[NEWLINE]  [ICON_BULLET]" .. -1 * v[1] .. " spent on " .. v[2] .. ".";
			end
		end
	
		if (iGoldPerTurnToOtherPlayers > 0) then
			strText = strText .. "[NEWLINE]  [ICON_BULLET]" .. Locale.ConvertTextKey("TXT_KEY_TP_GOLD_TO_OTHERS", iGoldPerTurnToOtherPlayers);
		end

		strText = strText .. "[/COLOR]";
	
		if (fTotalIncome - iTotalExpenses + iTotalGold < 0) then
			strText = strText .. "[NEWLINE][COLOR:255:60:60:255]" .. Locale.ConvertTextKey("TXT_KEY_TP_LOSING_SCIENCE_FROM_DEFICIT") .. "[/COLOR]";
		end

	elseif type == "Currency" then
		strText = strText .. "Official currency:[NEWLINE][ICON_BULLET]([COLOR_POSITIVE_TEXT]" .. GetNumCurrencyResource(gPlayer, gT.Players[gPlayer].Currencies) .. "[ENDCOLOR]/" .. gT.CurrencyResources[gT.Players[gPlayer].Currencies].GlobalAmount .. ") " .. GameInfo.Resources[gT.Players[gPlayer].Currencies].IconString .. " " .. Locale.Lookup(GameInfo.Resources[gT.Players[gPlayer].Currencies].Description) .. ": +" .. GetStrengthOfCurrencyGold(gPlayer, nil) .. "[ICON_GOLD] from working.";
		strText = strText .. "[NEWLINE][NEWLINE]Other Currency Resources:"
		for res, hhg in pairs(gT.CurrencyResources) do
			if gT.Players[gPlayer].Currencies ~= res then
				strText = strText .. "[NEWLINE][ICON_BULLET](" .. GetNumCurrencyResource(gPlayer, res) .. "/" .. hhg.GlobalAmount .. ") " .. GameInfo.Resources[res].IconString .. " " .. Locale.Lookup(GameInfo.Resources[res].Description) .. ".";
			end
		end
		if HasMintAnyCity(gPlayer) then
			strText = strText .. "[NEWLINE][NEWLINE]The strength and reliability of your currency is " .. gT.Players[gPlayer].MintPower .. "[ICON_INVEST], which boosts [ICON_GOLD] Gold output from Cities and Trade Routes by " .. gT.Players[gPlayer].MintBonus .. "%.[NEWLINE]";
			strText = strText .. GetMintSituationOfPlayer(gPlayer)

			if gT.Players[gPlayer].ForeignReserve then
				strText = strText .. "[NEWLINE][NEWLINE]You have reserves in " .. Players[gT.Players[gPlayer].ForeignReserve]:GetCivilizationAdjective() .. " currency."
			end

			local tgCity = GetCityWithMint(gPlayer)
			if tgCity then
				strText = strText .. "[NEWLINE][NEWLINE]Mint is located in " .. tgCity:GetName() .. "."
			end
		else
			strText = strText .. "[NEWLINE][NEWLINE]You have no control of your currency as long as you have no Mint build."
		end
		strText = strText .. "[NEWLINE][NEWLINE]The total available bonus, being adequately distributed towards all competitors, is: " .. GetCurrentMintBonusTotal() .. "%. Make sure your currency's strength outclasses the rivals' ones."
	elseif type == "FishSup" then
		strText = GetFishSupTextForTP(gPlayer)
	elseif type == "GoldenAge" then
		if Players[gPlayer]:IsGoldenAge() then
			strText = "Your empire is in [ICON_GOLDEN_AGE] Golden Age! Once it ends, you cannot enter another one in this scenario. However you can prolong an existing [ICON_GOLDEN_AGE] Golden Age by utilising bonuses or through the [ICON_ITG_LEGAL_POWER] Legal Power.[NEWLINE]"
			strText = strText .. Locale.Lookup("TXT_KEY_ITG_UI_GA_EFFECTS")			
			local bAny = false;
			for string, sth in pairs(gT.Players[gPlayer].CanGABeProlonged) do
				if not bAny then
					bAny = true;
					strText = strText .. "[NEWLINE][NEWLINE]Your [ICON_GOLDEN_AGE] Golden Age was already prolonged with:"
				end
				strText = strText .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]" .. string;
			end
		elseif gT.Players[gPlayer].HadGoldenAge then
			strText = "Your [ICON_GOLDEN_AGE] Golden Age has ended. You cannot start another one during this era.";
		else
			strText = "Your empire has not yet entered a [ICON_GOLDEN_AGE] Golden Age. Current length for next [ICON_GOLDEN_AGE] Golden Age is " .. GetPlayerGoldenAgeLength(gPlayer) .. ".[NEWLINE]"
			strText = strText .. Locale.Lookup("TXT_KEY_ITG_UI_GA_EFFECTS")			
			strText = strText .. "[NEWLINE][NEWLINE][ICON_GOLDEN_AGE] Golden Age progress:[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]" .. (gT.Players[gPlayer].GoldenAgePointsFrom[1] or 0) .. "[ENDCOLOR] from Science.";
			strText = strText .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]" .. (gT.Players[gPlayer].GoldenAgePointsFrom[2] or 0) .. "[ENDCOLOR] from Culture.";
			strText = strText .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]" .. (gT.Players[gPlayer].GoldenAgePointsFrom[3] or 0) .. "[ENDCOLOR] from Military.";
			strText = strText .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]" .. (gT.Players[gPlayer].GoldenAgePointsFrom[4] or 0) .. "[ENDCOLOR] from Faith.";
			strText = strText .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]" .. (gT.Players[gPlayer].GoldenAgePointsFrom[5] or 0) .. "[ENDCOLOR] from Legal Rights.";
			strText = strText .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]" .. (gT.Players[gPlayer].GoldenAgePointsFrom[6] or 0) .. "[ENDCOLOR] from other sources.";
		end
	elseif type == "GreatPeople" then
		strText = "Each time you acquire " .. GetGPCivilianTreshold(gPlayer) .. " [ICON_GREAT_PEOPLE] Great People points one random civilian Great Person ascends."
		local tab = {}
		table.insert(tab, {GetGreatPeopleCivilFromHappiness(gPlayer), "Happiness"})
		table.insert(tab, {GetGreatPeopleCivilFromCities(gPlayer, true), "Cities"})
		table.insert(tab, {GetGPPointsFromReligion(gPlayer), "Religion"})
		table.insert(tab, {GetGPFromGovermentType(gPlayer), "Goverment"})
		table.insert(tab, {GetGPFromHumanism(gPlayer), "Humanism"})
		table.insert(tab, {GetGPFromLeagues(gPlayer), "Leagues"})
		table.insert(tab, {GetGPFromLaws(gPlayer), "Laws"})
		table.insert(tab, {GetGreatPeoplePointsFromTechnologies(gPlayer), "Technologies"})
		table.insert(tab, {GetGreatPeopleFromAcademies(gPlayer), "Academies"})
		table.insert(tab, {GetGreatPeopleFromCodex(gPlayer), "Codex"})
		table.insert(tab, {GetGPnArtFromFestivalChance(gPlayer), "Festival chance"})
		table.insert(tab, {GetGreatPeopleFromPalaces(gPlayer), "Palaces"})
		table.insert(tab, {GetGreatPeopleFromManufactories(gPlayer), "Manufactories"})
		table.insert(tab, {GetGreatPeopleFromNoravank(gPlayer), "Novarank"})
		table.insert(tab, {GetGreatPeopleFromPenaPalace(gPlayer), "Pena Palace"})
		table.insert(tab, {GetGreatPeopleFromCityStates(gPlayer), "City-States"})
		table.insert(tab, {GetGreatPeopleFromEmbassies(gPlayer), "Embassies"})
		table.insert(tab, {GetGPFromIdeologies(gPlayer), "Ideologies"})
		table.insert(tab, {GetGPFromSocialDevs(gPlayer), "Social Developments"})
		table.insert(tab, {GetGreatPeopleCivilFromGPC(gPlayer), "Great People"})
		table.insert(tab, {GetGreatPeoplePointsFromScience(gPlayer), "Science"})
		table.insert(tab, {GetGreatPeoplePointsFromBranderburg(gPlayer), "Brandenburg Gate"})
		table.insert(tab, {GetGreatPeopleCivilFromDoF(gPlayer), "Declarations of Friendship"})
		for i, t in pairs(tab) do
			if t[1] > 0 then
				strText = strText .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]+" .. t[1] .. "[ENDCOLOR][ICON_GREAT_PEOPLE] from " .. t[2] .. ".";
			elseif t[1] < 0 then
				strText = strText .. "[NEWLINE][ICON_BULLET][COLOR_NEGATIVE_TEXT]" .. t[1] .. "[ENDCOLOR][ICON_GREAT_PEOPLE] from " .. t[2] .. ".";
			end
		end
		strText = strText .. "[NEWLINE][NEWLINE]The generation rate is reduced by the amount of your cities ([COLOR_NEGATIVE_TEXT]" .. GetNegativeModifierFromCitiesGPWonderArt(gPlayer)*100 .. "%[ENDCOLOR])."
		if gT.Players[gPlayer].GovRewards[22] then
			if not gT.Players[gPlayer].GovSlots[gT.Players[gPlayer].GovRewards[22]].Used then
				strText = strText .. "[NEWLINE][NEWLINE]So far you have generated " .. gT.Players[gPlayer].GPCivilGenerated .. " civilian Great People."
			else
				strText = strText .. "[NEWLINE][NEWLINE]You have already acquired Innovation through Goverment Principle."
			end
		end
		if gT.Players[gPlayer].HasIdeology[8] then
			strText = strText .. "[NEWLINE][NEWLINE]You acquire +1 [ICON_HAPPINESS_1] Happiness in all Cities and +250 [ICON_CULTURE] Culture instead normal reward (Equality-Mediocrity)."
		end
	elseif type == "Legal" then
		strText = "Legal Power allows you to control many aspects of your empire.[NEWLINE]"
		local tLegalTab = {}
		table.insert(tLegalTab,{GetCurrentLegalPowerPerTurnFromGoverment(gPlayer), "Goverment"})
		table.insert(tLegalTab,{AllCitiesLegalPointsPerTurn(gPlayer), "Cities"})
		table.insert(tLegalTab,{GetCorruptionLegal(gPlayer, tLegalTab[2][1]), "Corruption"})
		table.insert(tLegalTab,{LegalPointsFromLaws(gPlayer), "Laws"})
		table.insert(tLegalTab,{LegalPointsFromHeresy(gPlayer), "Heresy"})
		table.insert(tLegalTab,{LegalPointsFromCodex(gPlayer), "Codex"})
		table.insert(tLegalTab,{GetLegalPercentFromTithe(gPlayer), "Tithe"})
		table.insert(tLegalTab,{GetLegalPointsFromPalace(gPlayer), "Palaces"})
		table.insert(tLegalTab,{LegalPointsFromDoFs(gPlayer), "Declarations of Friendship"})
		table.insert(tLegalTab,{LegalPointsFromPriviliges(gPlayer), "Noble Privileges"})
		table.insert(tLegalTab,{GetLegalPointsFromAuthority(gPlayer), "Authority"})
		table.insert(tLegalTab,{GetLegalFromPrinciplesPT(gPlayer), "Principles"})
		table.insert(tLegalTab,{LegalPointsFromManufactories(gPlayer), "Manufactories"})
		table.insert(tLegalTab,{GetLegalPointsFromInnovations(gPlayer), "Innovations"})
		table.insert(tLegalTab,{LegalPointsFromLeagues(gPlayer), "Leagues"})
		table.insert(tLegalTab,{LegalPointsFromOccupiedCities(gPlayer), "Occupied Cities"})
		table.insert(tLegalTab,{LegalPointsFromAlliedCSs(gPlayer), "City-States"})
		table.insert(tLegalTab,{FortsAndCitadelsLegalPointsPerTurn(gPlayer), "Forts and Citadels"})
		table.insert(tLegalTab,{LegalPointsFromReligion(gPlayer), "Religion"})
		table.insert(tLegalTab,{LegalPointsFromTechnology(gPlayer), "Technologies"})
		table.insert(tLegalTab,{GreatPeopleLegalPointsPerTurn(gPlayer), "Great People"})
		table.insert(tLegalTab,{WorldWonderLegalPointsPerTurn(gPlayer), "Wonders"})
		table.insert(tLegalTab,{LegalPointsFromIdeologies(gPlayer, true), "Ideologies"})
		table.insert(tLegalTab,{GetEstimatedLegalFromBudget(gPlayer), "Budget"})
		table.insert(tLegalTab,{LegalPointsFromShogunate(gPlayer), "Shogunate"})
		table.insert(tLegalTab,{AllEmbassiesLegalPointsPerTurn(gPlayer), "Embassies"})
		table.insert(tLegalTab,{EstimatedLegalGrowthFromSpies(gPlayer), "Spies"})
		table.insert(tLegalTab,{GetPlayer10thBonusFromCaliph(gPlayer), "Caliphate"})
		local totalbase = 0;
		for i, v in pairs(tLegalTab) do
			totalbase = totalbase + v[1];
		end
		table.insert(tLegalTab, {-2 * GetConvertedFaithIntoLegal(gPlayer, GetTotalFaithFromExtraSourcesITG(gPlayer, true, true)) / 5, "[ICON_PEACE] Faith"})
		table.insert(tLegalTab, {GetConvertedLegalIntoFaith(gPlayer, totalbase), "conversion to [ICON_PEACE] Faith"})
		for tt, ttd in pairs(tLegalTab) do
			if (ttd[1] ~= 0) then
				if ttd[1] > 0 then
					strText = strText .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]+" .. ttd[1] / 100 .. "[ENDCOLOR][ICON_ITG_LEGAL_POWER] from " .. ttd[2] .. ".";
				else
					strText = strText .. "[NEWLINE][ICON_BULLET][COLOR_NEGATIVE_TEXT]" .. ttd[1] / 100 .. "[ENDCOLOR][ICON_ITG_LEGAL_POWER] from " .. ttd[2] .. ".";
				end
			end
		end
		if gT.Players[gPlayer].LegalGainDisabled > 0 then
			strText = strText .. "[NEWLINE][NEWLINE][COLOR_NEGATIVE_TEXT]Legal Power gain from most sources is disabled.";
		end
		if gT.Players[gPlayer].LegalPower < 0 then
			strText = strText .. "[NEWLINE][NEWLINE]Negative amount of [ICON_ITG_LEGAL_POWER] Legal Power increases chance to generate [ICON_APPINESS_4] Unhappiness and may turn empire into Anarchy."
		end
	elseif type == "Authority" then
		strText = GetAuthorityTextForTP(gPlayer)
	elseif type == "Meritocracy" then
		strText = GetMeritocracyPTToolTip(gPlayer)
	elseif type == "Pirate" then
		strText = GetTopPanelPirateTT(gPlayer)
	elseif type == "Heresy" then
		strText = GetHeresyTextForTP(gPlayer)
	elseif type == "Archaeology" then
		strText = GetArchaeologyTextForTP(gPlayer)
	elseif type == "OlympicGames" then
		strText = "Olympic Games happen every 16th turn during which all competitors enter temporary peace. Determined randomly Winner gains eternal glory (+3 [ICON_ITG_VOTES] Votes)."
	elseif type == "CultureIndicator" then
		strText = ToolTipNatUnit(gPlayer);
	elseif type == "USupply" then
		strText = ToolTipUSupply(gPlayer)
	elseif type == "Missionary" then
		strText = ToolTipMissionaryGrowth(gPlayer);
	elseif type == "OccupyLimit" then
		strText = ToolTipOccupyLimit(gPlayer);
	end

	MapModData.ITGSG = strText;
end
LuaEvents.ITGSG_RequestTopPanelTooltip.Add(TopPanelTextGenerating)

function PrepareStuffForEndEra()
	gT.ReligionsEE = {}
	gT.LHStockRises = {}
	for g, gdata in pairs(gT.Players) do
		if not Players[g]:IsMinorCiv() then
			AddGraphData(g, 8, GetLegalPointsPerTurn(g, false, true), false, 0)
		end
		gT.Players[g].ScienceLost = 0;
		gT.Players[g].FaithLost = 0;
		gT.Players[g].CultureLost = 0;
		gT.Players[g].ScienceStart = gdata.Science;
		gT.Players[g].CultureStart = gdata.Culture;
		gT.Players[g].FaithStart = Players[g]:GetFaith();
		gT.Players[g].GeneralCombatStart = Players[g]:GetCombatExperience()
		gT.Players[g].GeneralCombatLost = 0;
		gT.Players[g].AdmiralCombatStart =  Players[g]:GetNavalCombatExperience();
		gT.Players[g].SettlerPointsStart = gT.Players[g].SettlerGenerationPoints;
		gT.Players[g].SettlerPointsSpend = 0;
		gT.Players[g].AdmiralCombatLost = 0;
		gT.Players[g].NumConquered = 0;
		gT.Players[g].UniqueNumConquered = 0;
		gT.Players[g].LHsettlers = 0;
		gT.Players[g].AlreadyConqueredCID = {}
		gT.Players[g].LHMissionaries = 0;
		gT.Players[g].LHNuclearStrikes = 0;
		gT.Players[g].LHAirRangedStrikes = 0;
		gT.Players[g].LHAirMissiles = 0;
		gT.Players[g].LHAirSweeps = 0;
		gT.Players[g].LHUntisTrained = 0;
		gT.Players[g].LHBuildingsConstructed = 0;
		Players[g]:SetInterceptionCount(0);
		gT.Players[g].LHMartyrs = 0;
		gT.Players[g].LHSpecialArmy = 0;
		gT.Players[g].LHIdeoVictories = 0;
		gT.Players[g].LHIdeoLosses = 0;
		gT.Players[g].NumWondersBuild = 0;
		gT.Players[g].LHAuctionDeals = 0;
		gT.Players[g].LHAuctionDealsBuy = 0;
		gT.Players[g].LHSpecialDeals = 0;
		gT.Players[g].GoldFromTradeRoutes = 0;
		gT.Players[g].LHScienceTR = 0;
		gT.Players[g].LHFoodTR = 0;
		gT.Players[g].LHProdTR = 0;
		gT.Players[g].LHCultureTR = 0;
		gT.Players[g].UnitKilled = 0;
		gT.Players[g].UnitLost = 0;
		gT.Players[g].GoldSpentOnAcademies = 0;
		gT.Players[g].WorkRateSpent = 0;
		gT.Players[g].TotalGoldSpendInternally = 0;
		gT.Players[g].SpyActionsBig = {}
		gT.Players[g].LawsChanged = 0;
		gT.Players[g].NumFestivalsStarted = 0;
		gT.Players[g].PillagedImpros = 0;
		gT.Players[g].PillagedImprosGold = 0;
		gT.Players[g].LHOwnChosenCB = 0;
		gT.Players[g].LHRechosenCB = 0;
		gT.Players[g].LHRebelsSpawned = 0;
		gT.Players[g].LHRebelsSpawnedNB = 0;
		gT.Players[g].LHStockCurrency = {}
		--new ones
		gT.Players[g].KilledCivilians = {};
		gT.Players[g].SpendLegalPower = 0;
		gT.Players[g].CityStateAlly = 0;
		gT.Players[g].MaxCityStateAlly = 0;
		gT.Players[g].CityStateFriends = 0;
		gT.Players[g].GPMigratedAway = 0;
		gT.Players[g].GPMigratedTo = 0;
		gT.Players[g].LHInitCities = Players[g]:GetNumCities();
		gT.Players[g].GPPointsEarned = 0;
		gT.Players[g].LHCombatLand = 0;
		gT.Players[g].LHCombatNaval = 0;
		gT.Players[g].LHNumVetProms = 0;
		gT.Players[g].LHNumUnitLevelsUP = 0;
		gT.Players[g].GPCivilGenerated = 0;
		gT.Players[g].GoldSpendOnMinorGifts = 0;
		gT.Players[g].InfluenceFromGoldGifts = 0;
		gT.Players[g].LHTotalAuthority = 0;
		gT.Players[g].LHMaxAuthority = 0;
		gT.Players[g].LHNumPalaceUpgrades = 0;
		gT.Players[g].AverageLuxuryCount = 0;
		gT.Players[g].AverageFortCount = 0;
		gT.Players[g].GreatestNumFortOwned = 0;
		gT.Players[g].AverageColoniesCount = 0;
		gT.Players[g].AverageMorale = 0;
		gT.Players[g].GreatestMoraleEver = 0;
		gT.Players[g].GreatestNumColoniesOwned = 0;
		gT.Players[g].AverageTurnCounted = 0;
		gT.Players[g].CitiesFounded = 0;
		gT.Players[g].NumWarsDeclared = {};
		gT.Players[g].NumWarsDeclaredOn = {};
		gT.Players[g].EEFTurnsOfPeace = 0;
		gT.Players[g].EEFMTurnsOfPeace = 0;
		gT.Players[g].EEFTurnsOfAnarchy = 0;
		gT.Players[g].EEFAnarchyOutbreaks = 0;
		gT.Players[g].CSBulliedGold = 0;
		gT.Players[g].CSBulliedX = 0;
		gT.Players[g].CSBulliedTimes = 0;
		gT.Players[g].NumWonCityQuests = 0;
		gT.Players[g].LengthGoldenAge = 0;
		gT.Players[g].TotalDecadentism = 0;
		gT.Players[g].LHLeagueForm = 0;
		gT.Players[g].LHPilgrimage = 0;
		gT.Players[g].LHLeagueDisband = 0;
		gT.Players[g].LHLeagueRes = 0;
		gT.Players[g].LHLeagueAction = 0;
		gT.Players[g].TotalBarbCleared = 0;
		gT.Players[g].TotalBarbKilled = 0;
		gT.Players[g].ArchPointsTotal = 0;
		gT.Players[g].ArchLocatedFirst = 0;
		gT.Players[g].ArchSitesDigged = 0;
		gT.Players[g].MeleeCombatsP = 0;
		gT.Players[g].RangedCombatP = 0;
		gT.Players[g].NumUnitsUpdated = 0;
		gT.Players[g].NumSpecialMerc = 0;
		gT.Players[g].NumMercTotal = 0;
		gT.Players[g].GreatestNumLuxuryOwned = 0;
		gT.Players[g].NumRailroadsMade = 0;
		gT.Players[g].GreatestHappiness = gT.Players[g].AverageHappiness;
		gT.Players[g].AverageLuxuryTurnCounted = 0;
		gT.Players[g].LHAverageHappiness = 0;
		gT.Players[g].AverageHappinessCounted = 0;
		gT.Players[g].StartTechKnown = GetRealNumTechsKnown(Players[g]:GetTeam());
		gT.Players[g].TotalStartLand = Players[g]:GetTotalLand();
		gT.Players[g].TotalBestLand = gT.Players[g].TotalStartLand;

		if Players[g]:GetReligionCreatedByPlayer() > 0 then
			local iRel = Players[g]:GetReligionCreatedByPlayer();
			gT.ReligionsEE[iRel] = {}
			local totalpres = GetReligiousPressureTotal(Players[g]:GetReligionCreatedByPlayer())
			gT.ReligionsEE[iRel].BestReligiousPressure = totalpres;
			gT.ReligionsEE[iRel].StartReligiousPressure = totalpres;
		end
		for iCity in Players[g]:Cities() do
			local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
			gT.Cities[cID].HighestPop = iCity:GetPopulation()
			gT.Cities[cID].HighestPopFood = iCity:GetFood()
			gT.Cities[cID].StartingPop = iCity:GetPopulation()
			gT.Cities[cID].StartingPopFood = iCity:GetFood()
		end
		gT.Players[g].TurnDataCollected = 0;
	end
	StartHistoriographyDataCollecting()
end

function GenerateAllTheTextForCityView(iCity)
	local tTab = {}
	local iPlayer = iCity:GetOwner();
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	tTab.WorkRate = "+" .. GetWorkRateIncreasement(iPlayer, iCity, cID, true)
	tTab.StoredWorkRate = gT.Cities[cID].WorkRate
	tTab.StoredLandTradeRoute = gT.Cities[cID].CaravanProgress;
	tTab.StoredNavalTradeRoute = gT.Cities[cID].CargoProgress;
	tTab.StoredPilgrim = gT.Cities[cID].PilgrimProgress;
	if DBScenario.SettlersOff then
		tTab.SettlerPT = -1;
	else
		tTab.SettlerPT = GetSettlerPointsFromCity(iCity, iPlayer, true);
	end
	tTab.LandTradeRouteChange, tTab.NavalTradeRouteChange, tTab.PilgrimChange = GetTradeRoutePointsPerTurn(iCity, iPlayer, nil, true);
	tTab.LandTradeRouteChangeTT, tTab.NavalTradeRouteChangeTT, tTab.PilgrimChangeTT = TRCityViewToolTip(iCity, iPlayer, tTab.LandTradeRouteChange, tTab.NavalTradeRouteChange, tTab.PilgrimChange)
	tTab.WonderPointsChange = 0;
	if gT.Players[iPlayer].CanWonderRace then
		tTab.WonderPointsChange = GetWonderPointsFromCity(iCity, iPlayer, true, true)
		tTab.WonderPointsTT = WonderCityViewToolTip(iCity, iPlayer, tTab.WonderPointsChange)
	end
	tTab.WonderPoints = gT.Players[iPlayer].WonderProduction;
	tTab.CanWonderRace = gT.Players[iPlayer].CanWonderRace;

	tTab.GovIcon, tTab.GovIndex, tTab.GovToolTip, tTab.GovLabel = GetCityViewGovernorInfo(iPlayer, iCity, cID)
	
	tTab.ArtPointsChange = GetArtPointsFromCity(iCity, iPlayer, true);
	tTab.GreatArtistPoints = gT.Players[iPlayer].GreatArtistPoints;
	if tTab.ArtPointsChange > 0 then
		tTab.ArtPointsTT = ArtCityViewToolTip(iCity, iPlayer, tTab.ArtPointsChange)
	end
	tTab.ColonyTreshold = GetColonyITGTreshold(iPlayer)
	tTab.ColonyPoints = gT.Players[iPlayer].ColonyPoints
	tTab.ColonyPointsChange = GetColonyPointsFromCity(iCity, iPlayer, true);
	if tTab.ColonyPointsChange > 0 then
		tTab.ColonyPointsTT = ColonyCityViewToolTip(iCity, iPlayer, tTab.ColonyPointsChange)
	end
	tTab.HeresyString = GetCityHeresyStringOrNil(iCity)
	tTab.GPProgress = math.floor(gT.Players[iPlayer].GreatPeoplePoints);
	tTab.GPTreshold  = GetGPCivilianTreshold(iPlayer);
	tTab.GPPointsChange = GetGPPointsFromCity(iCity, iPlayer, true)
	if tTab.GPPointsChange > 0 then
		tTab.GPPointsTT = GPCityViewToolTip(iCity, iPlayer, tTab.GPPointsChange)
	end

	tTab.LandTradeRouteCost = GetLandTradeRouteCost(iPlayer);
	tTab.NavalTradeRouteCost = GetNavalTradeRouteCost(iPlayer);
	tTab.PilgrimCost = GetPilgrimageCost(iPlayer)
	tTab.LegalPoints = GetLegalPointsPerTurnCity(iCity, iPlayer);
	tTab.Unhapchance = math.floor(GetGenerateUnhappinessChanceCity(iCity, iPlayer, cID, true, false) / 10)
	tTab.Hapchance = math.floor(GetGenerateHappinessChanceCity(iCity, iPlayer, cID, nil, true) / 10)
	tTab.CurrentHapp = gT.Cities[cID].Happiness
	tTab.LegalPointsStored = gT.Players[iPlayer].LegalPowerPercent
	tTab.DisablePurchase = IsCityThreatened(iCity, iPlayer)
	tTab.HealthLevel = gT.Cities[cID].HealthLevel
	tTab.GPattr = GetBaseCityGPAttractiveness(iCity, iPlayer, cID)
	tTab.TRattr = GetBaseCityTRAttractiveness(iCity, iPlayer, cID)
	
	MapModData.ITGSG = tTab;
end

local ITGTimeDiagnosisTopPanel1 = {}
local ITGTimeDiagnosisTopPanel2 = {}
local ITGTimeDiagnosisTopPanel3 = {}
local ITGTimeDiagnosisTopPanel4 = {}
LuaEvents.ITGCallForTimeDiagnosis.Add(function()
	DoPrintTimeDiagnosisITG(ITGTimeDiagnosisTopPanel1, "TOPPanel 1")
	DoPrintTimeDiagnosisITG(ITGTimeDiagnosisTopPanel2, "TOPPanel 2")
	DoPrintTimeDiagnosisITG(ITGTimeDiagnosisTopPanel3, "TOPPanel 3")
	DoPrintTimeDiagnosisITG(ITGTimeDiagnosisTopPanel4, "TOPPanel 4")
end)

function AllTheTopPanelHelp(iPlayer)
--	local timer1 = os.clock()
	gT.Players[iPlayer].TPTotalFaith = GetTotalFaithFromExtraSourcesITG(iPlayer, true)
	gT.Players[iPlayer].TPExtraSciencePerTurn = GetITGSciencePerTurn(iPlayer, true)
--	local timer2 = os.clock();
--	table.insert(ITGTimeDiagnosisTopPanel1, timer2 - timer1)
--	if gT.Globals.GameGenerated then
	gT.Players[iPlayer].TPGPCivilPerTurn = GetTotalBoostOfGreatPeoplePointsPT(iPlayer, true);
	gT.Players[iPlayer].TPGPCivilTreshold = GetGPCivilianTreshold(iPlayer);
	gT.Players[iPlayer].TPLegalPerTurn = GetLegalPointsPerTurn(iPlayer, true)
	gT.Players[iPlayer].TPRealGoldRate = GetRealCalculateGoldRate(iPlayer, true)
	gT.Players[iPlayer].TPTotalCulturePerTurn = GetTotalCulturePerTurn(iPlayer, true);
	gT.Players[iPlayer].TPGoldenAgeCost = GetPointsCostForGoldenEra(iPlayer);
	gT.Players[iPlayer].TPResConsumedPT = GetTPResourcesConsumedPerT(iPlayer);
--	timer1 = os.clock()
--	table.insert(ITGTimeDiagnosisTopPanel2, timer1 - timer2)
	gT.Players[iPlayer].TPColonyTreshold = GetColonyITGTreshold(iPlayer);
	gT.Players[iPlayer].TPMeritocracyPT = GetMeritocracyChangePerTurn(iPlayer, true);
	gT.Players[iPlayer].TPSuppFishBoats = GetSupportedFishingBoats(iPlayer);
	gT.Players[iPlayer].TPHap = GetHappinessTopPanel(iPlayer);
	gT.Players[iPlayer].TPGPColonyPerTurn = GetEstimatedColonyPointsPerTurn(iPlayer, true)
--	timer2 = os.clock();
--	table.insert(ITGTimeDiagnosisTopPanel3, timer2 - timer1)
--	work on those two art wonder and gpcivil;
	gT.Players[iPlayer].TPHeresy = GetHeresyChanceRightNow(nil, nil, iPlayer) / 10;
	gT.Players[iPlayer].SettlerTreshold = GetTresholdForNextSettler(iPlayer);
	gT.Players[iPlayer].TPSettlerPT = GetSettlerPointsPerTurn(iPlayer, true);
	gT.Players[iPlayer].PredictedArchaeologyNewTurn = GetArchaeologyPointsPerTurn(iPlayer, true);
	gT.Players[iPlayer].TotalArchaeologyGlobal = GetTotalArchaeologyGlobal();
	gT.Players[iPlayer].TPArtPointsPerTurn = GetTotalArtPointsPerTurn(iPlayer, true);
	gT.Players[iPlayer].TPWonderPointsPerTurn = GetTotalWonderProductionFromAllSources(iPlayer, true)
	gT.Players[iPlayer].TPFestivalChance = GetChanceForFestivalPoint(iPlayer) / 10
	if gT.Players[iPlayer].SecularState then
		gT.Players[iPlayer].TPNextFaithCost = nil;
		gT.Players[iPlayer].TPMissionaryGrowth = nil;
	else
		if Players[iPlayer]:GetReligionCreatedByPlayer() > 0 then
			gT.Players[iPlayer].TPMissionaryGrowth = GetTotalMissionaryGrowth(iPlayer)
			gT.Players[iPlayer].TPMissionaryTreshold = GetMissionaryGrowthTreshold(iPlayer)
		else
			gT.Players[iPlayer].TPMissionaryGrowth = nil
		end
		gT.Players[iPlayer].TPNextFaithCost = NiceCostOfNextFaithBonus(iPlayer, gT.Players[iPlayer].ReligionRewardTreshold)
	end
	gT.Players[iPlayer].TPNextScienceCost = NiceCostOfTechOrPolicy(iPlayer, GetDBCulturePlayerInfo(iPlayer, "BaseTechCost"), gT.Players[iPlayer].ScienceBonusAdopted, 1, nil, "hadsxre")
	gT.Players[iPlayer].TPNextCultureCost = NiceCostOfTechOrPolicy(iPlayer, GetDBCulturePlayerInfo(iPlayer, "BaseCultureCost"), gT.Players[iPlayer].CultureBonusAdopted, 2)
	gT.Players[iPlayer].TPAnarchyLegalLeft = GetAnarchyTPString(iPlayer)
--	timer1 = os.clock()
--	table.insert(ITGTimeDiagnosisTopPanel4, timer1 - timer2)
end

function AskForNiceToolTipsCities(type, iCity)
	local str = "";
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local iOwner = iCity:GetOwner();
	if type == "Religion" then
		local iRel = gT.Players[iOwner].OfficialReligion;
		if gT.Players[iOwner].SecularState then
			str = "[NEWLINE][NEWLINE]City belongs to Secular State.";
		elseif iRel then
			str = "[NEWLINE][NEWLINE]Official religion is " .. GameInfo.Religions[iRel].IconString .. " " .. Locale.Lookup(Game.GetReligionName(iRel)) .. ".";
			if iCity:IsHasBuilding(bInquisition) then
				str = str .. " The Office of Inquisition nullifies any negative aspect caused by heretical pressure.";
			else
				if IsHasLaw(iOwner, 21, 1) then
					if GetITGCityInteger(iCity, "CI_HERESY_GOLD") == 0 then
						str = str .. " There is no heretical pressure."
					else
						str = str .. " Heretical pressure reduces [ICON_GOLD] Gold generation by " .. GetITGCityInteger(iCity, "CI_HERESY_GOLD") .. "%.";
					end
				elseif IsHasLaw(iOwner, 21, 2) then
					local eVal = GetPresenceModfromHeresy(iOwner, iCity);
					if eVal == 0 then
						str = str .. " There is no heretical pressure."
					else
						str = str .. " Heretical pressure reduces [ICON_ITG_PRESENCE] Cultural Presence generation by " .. eVal .. "%.";
					end
				elseif IsHasLaw(iOwner, 21, 3) then
					if GetITGCityInteger(iCity, "CI_HERESY_SCIENCE") == 0 then
						str = str .. " There is no heretical pressure."
					else
						str = str .. " Heretical pressure reduces [ICON_RESEARCH] Science generation by " .. GetITGCityInteger(iCity, "CI_HERESY_SCIENCE") .. "%.";
					end
				else
					local eVal = GetHapModifierFromHeresy(iCity, true)/10
					if eVal == 0 then
						str = str .. " There is no heretical pressure."
					else
						str = str .. " Heretical pressure increases chance to generate [ICON_HAPPINESS_4] Unhappiness by " .. eVal .. "%.";
					end
				end
			end
		elseif Players[Game.GetActivePlayer()]:GetReligionCreatedByPlayer() > 0 then
			local pRel = Players[Game.GetActivePlayer()]:GetReligionCreatedByPlayer();
			if iCity:GetReligiousMajority() ~= pRel then
			--	local numTConvert = GetMinimumFaithPlusForReligionConv(pRel, iCity, false, GetMissionaryConversionStrength(Game.GetActivePlayer(), iCity) * 10)
				if CanPlayerUseMissionares(Game.GetActivePlayer()) or (gT.Players[Game.GetActivePlayer()].FreeMissioniares > 0) then
					local numTConvert = GetNumSpreadsNeededWithMax(pRel, GetMissionaryConversionStrength(Game.GetActivePlayer(), iCity), iCity, MAX_MISSIONARY_CHECK)
					if numTConvert == 1 then
						str = str .. "[NEWLINE][NEWLINE]To convert this city to " .. GameInfo.Religions[pRel].IconString .. " " .. Locale.Lookup(Game.GetReligionName(pRel)) .. " you need to send there " .. numTConvert .. " Missionairy.";
					elseif numTConvert == MAX_MISSIONARY_CHECK + 1 then
						str = str .. "[NEWLINE][NEWLINE]To convert this city to " .. GameInfo.Religions[pRel].IconString .. " " .. Locale.Lookup(Game.GetReligionName(pRel)) .. " you need to send more than " .. MAX_MISSIONARY_CHECK .. " Missionaires.";
					else
						str = str .. "[NEWLINE][NEWLINE]To convert this city to " .. GameInfo.Religions[pRel].IconString .. " " .. Locale.Lookup(Game.GetReligionName(pRel)) .. " you need to send there " .. numTConvert .. " Missionaires.";
					end
					local gPlayer = Game.GetActivePlayer();
					if gPlayer ~= iOwner then
						if Teams[Players[iOwner]:GetTeam()]:IsAtWar(Players[gPlayer]:GetTeam()) then
							str = str .. "[NEWLINE][NEWLINE]At war Missionary has 25% chance of dying before conversion.";
						end
					end
				end
			end
		end
	end
	MapModData.ITGSG = str;
end