local uCaravan = GameInfoTypes.UNIT_ITGSG_CARAVAN;
local mmt = MissionTypes.MISSION_MOVE_TO;
local uCargo = GameInfoTypes.UNIT_ITGSG_CARGO_SHIP;
local innoTrialAsia7 = GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_ASIA_7;
local wonderPetra = GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_9;
local tribeInno17 = GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_TRIBE_17;
local hCityContinentTab = {}
local bContinueWithTR = true;
--local hCityCoastTab = {}
--local hCityCoastCoastTab = {}
--local hCityCoastIsOcean = {}
local CitiesOnOceanCoast = {}
local CitiesOnBasicCoast = {}
local bInitialized = false;

local beliefITgfol25 = GameInfoTypes.BELIEF_ITG_FOLLOWER_25;
local cWonderNew12 = GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_12;
local tUniqueInnoMeso5 = GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_MESOAMERICAN_5;
local itgwonder25 = GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_25;
local mesoinno1 = GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_MESOAMERICAN_1;
local beliefitgfol34 = GameInfoTypes.BELIEF_ITG_FOLLOWER_34;
local templeClass = GameInfoTypes.BUILDINGCLASS_TEMPLE;
local folbelief35 = GameInfoTypes.BELIEF_ITG_FOLLOWER_35;
local tPasssageAllWater = GameInfoTypes.TECH_ITG_WATER_ALL_PASSAGE;
local promEmbark = GameInfoTypes.PROMOTION_EMBARKATION;
local tInnoEuro3 =  GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_EUROPE_3;
local bGreatZimb = GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_40;
local arabtrial3 = GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_ARABIA_3;
local arabtrial5 = GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_ARABIA_5;
local innotrial7asia = GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_ASIA_7;
local hordeinno3 = GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_HORDE_3;
local itiv1 = GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_VIKING_1;
local tAncCs22 = GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_22;
local techAncCS7 = GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_7;
local techAncCS29 = GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_29;
local wonderColsss = GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_6;
local renWonder29 = GameInfoTypes.BUILDING_ITG_NEW_WORLD_WONDER_29;
local innoNWafr5 = GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_AFR_5
local GrandTemples = {}
for row in GameInfo.Buildings() do
	if row.BuildingClass == "BUILDINGCLASS_GRAND_TEMPLE" then
		table.insert(GrandTemples, {row.ID, row.TradeDestinationReligionChance})
	end
end

function GetPlayerTradeRoutePointsFromLeagues(iPlayer)
--only those requiring at least 1 point
	local t = 0;
	for l, s in pairs(gT.Leagues) do
		if s.Members[iPlayer] then
			if s.Resolutions[35] then
				t = t + 1;
			end
		end
	end
	return t;
end

function GetLNTRPointsFromBuildings(iCity)
	return iCity:GetLandTradeRoutePoints(), iCity:GetNavalTradeRoutePoints();
end

function GetLandTRFromFaith(iCity, iPlayer)
--	if gT.Players[iPlayer].HasPlayerWonder[itgprenwWonder32] then
--		lGain = lGain + math.floor(iCity:GetFaithPerTurn() / 3)
--	end
	return 0;
end

function GetLandNavalTRFromTechs(iCity, iPlayer, cID)
	local lGain, nGain = 0, 0;
	if HasPlayerTech(iPlayer, mesoinno1, "&235324") then
		lGain = lGain + 2 * gT.Cities[cID].Mountain;
	end
	if HasPlayerTech(iPlayer, hordeinno3, "&23412") then
		lGain = lGain + 4;
	end
	if IsCityHaveWonderRuinWithAbility(iCity, 14) then
		lGain = lGain + 2;
	end
	if HasPlayerTech(iPlayer, techAncCS7, "1234gbvawe") then
		lGain = lGain + gT.Cities[cID].MTlandTR;
		nGain = nGain + gT.Cities[cID].MTnavalTR;
	end
	return lGain, nGain;
end

function GetLandNavalTRFromReligion(iCity, iPlayer, cID)
	local lGain, nGain = 0, 0;
	if IsBeliefPresentInACity(iCity, folbelief35) then
		if iCity:GetNumFollowers(iCity:GetReligiousMajority()) >= 5 then
			lGain = lGain + 1;
			nGain = nGain + 1;
		end
	end
	if IsBeliefPresentInACity(iCity, beliefitgfol34) then
		local bb = Players[iPlayer]:GetPlayerUniqueBuilding(templeClass);
		if iCity:IsHasBuilding(bb) then
			lGain = lGain + 2;
			nGain = nGain + 2;
		end
	end
	return lGain, nGain;
end

function GetLandNavalTRFromIdeology(iCity, iPlayer, cID)
	local lGain, nGain = 0, 0;
	return lGain, nGain;
end

function GetLandNavalTRFromCustomsHouses(iCity, iPlayer, cID)
	local lGain, nGain = 0, 0;
	return lGain, nGain;
end

function GetLandTRFromDefense(iCity, iPlayer, cID)
	local lGain = 0;
	if iCity:IsHasBuilding(bGreatZimb) then
		lGain = lGain + math.ceil(iCity:GetBuildingDefense() / 100);
	end
	return lGain;
end

function GetLandNavalTRFromAcademies(iCity, iPlayer, cID)
	local lGain, nGain = 0, 0;
	nGain = nGain + 5 * GetNumCityAcademiesWithAbility(iCity, 10);
	lGain = lGain + 5 * GetNumCityAcademiesWithAbility(iCity, 51);
	return lGain, nGain;
end

function GetTRPointsIfAtLeastOneGenerated(iCity, iPlayer, cID, fromLeague)
	local t = fromLeague or GetPlayerTradeRoutePointsFromLeagues(iPlayer);
	if HasPlayerTech(iPlayer, innotrial7asia, "^234324") then
		t = t + 2;
	end
	if gT.Players[iPlayer].CultBonusOn[9] then
		t = t + 1;
	end
	if Players[iPlayer]:IsGoldenAge() then
		if gT.Players[iPlayer].HasMinorIdeology[4] then
			t = t + 3;
		end
	end
	if gT.Players[iPlayer].HasIdeology[18] then
		if gT.Players[iPlayer].LastTurnTRorPlunder + 1 < GetITGGameTurn() then
			t = t + 4;
		end
	end
	if gT.Players[iPlayer].HasIdeology[36] then
		if gT.Players[iPlayer].MeritocracyLevel > 50 then
			t = t + 1;
		end
	end
	return t;
end

function GetTradeRoutePointsPerTurn(iCity, iPlayer, lLeagueV, bTooltip)
	local lGain, nGain, pGain = 0, 0, 0;
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	if ITGCityCanWorkDoAction(iCity) then
		local lHbTR, nHbTR = GetLNTRPointsFromBuildings(iCity);
		local lHtTR, nHtTR = GetLandNavalTRFromTechs(iCity, iPlayer, cID)
		local lHrTR, nHrTR = GetLandNavalTRFromReligion(iCity, iPlayer, cID)
		local lHiTR, nHiTr = GetLandNavalTRFromIdeology(iCity, iPlayer, cID);
		local lHaTR, nHaTr = GetLandNavalTRFromAcademies(iCity, iPlayer, cID);
		local lHaTR, nHaTr = GetLandNavalTRFromCustomsHouses(iCity, iPlayer, cID);
		lGain = lGain + lHbTR + lHtTR + lHrTR + lHiTR + lHaTR;
		nGain = nGain + nHbTR + nHtTR + nHrTR + nHiTr + nHaTr;
		lGain = lGain + GetLandTRFromFaith(iCity, iPlayer) + GetLandTRFromDefense(iCity, iPlayer, cID)
		lGain = lGain + GetITGCityInteger(iCity, "CI_GOV_LAND_TR")

		--Here are bonuses based on if city generates at least 1 respective point <don't generate Naval in land locked Cities>
		local pialo = GetTRPointsIfAtLeastOneGenerated(iCity, iPlayer, cID, lLeagueV);
		if lGain > 0 then
			lGain = lGain + pialo;
		end
		if nGain > 0 then
			nGain = nGain + pialo;
		end
		if bTooltip then
			local pl, pn = GetTradeGainFromProcess(iCity)
			lGain = lGain + pl;
			nGain = nGain + pn;
		end
		pGain = GetPilgrimagePT(iCity, cID, iPlayer, math.max(lGain, nGain))
	end
	return lGain, nGain, pGain;
end

function GetSpeedUpOfTradeUnit(fcID, iUnit, iPlayer, uID, iCity)
	local s = gT.Cities[fcID].SpeedUpTrade;
	if gT.Players[iPlayer].HasIdeology[36] then
		s = s + 4;
	end
	if gT.Players[iPlayer].HasIdeology[36] then
		s = s + 1;
	end
	if gT.Players[iPlayer].UnitsByID[uID].UnknownDestinationMoves then
		s = s + 2;
	end
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_COMBUSTION, "%46435") then
		s = s + 1;
	end
	if HasPlayerTech(iPlayer, techAncCS29, "9kewk") then
		s = s + 2;
	end
	if HasPlayerTech(iPlayer, innoNWafr5, "innoNWafr5") then
		if iUnit:GetPlot():GetTerrainType() == tDesert then
			s = s + 3;
		end
	end
	return s;
end

function GetModTransferUnusedTradePoints(iPlayer)
	local mod = 0.2;
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_NW_TROPICAL_4, "453223") then
		mod = math.max(1, mod)
	end	
	return mod;
end

function GetLandTradeRouteCost(iPlayer)
	return DBScenario.TradeRouteCost;
end

function GetNavalTradeRouteCost(iPlayer)
	return DBScenario.TradeRouteCost + gT.Players[iPlayer].NavalTRTresholdChange;
end

function HasPreventGoldDropFromTR(iPlayer)
	if gT.Players[iPlayer].GovRewards[46] then
		if IsCurrentlyNThNatDay(iPlayer, 7) then
			return true;
		end
	end
	return false;
end

function DoBoostTradeProgressInAllCities(iPlayer, iBonus)
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		gT.Cities[cID].CaravanProgress = (gT.Cities[cID].CaravanProgress or 0) + iBonus
		gT.Cities[cID].CargoProgress = (gT.Cities[cID].CargoProgress or 0) + iBonus;
	end
end

function DoTurnEconomicCaravans(iPlayer)
	local timer = os.clock();
-- reduce gold in time from trade routes first
	if not HasPreventGoldDropFromTR(iPlayer) then
		DoReductionOfGoldInTime(iPlayer, GetITGGameTurn())
	end
	DoFadeProductionFromCultBonus10(iPlayer)
	for iUnit in Players[iPlayer]:Units() do
		local uID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
		if gT.Players[iPlayer].UnitsByID[uID] and gT.Players[iPlayer].UnitsByID[uID].TargetAdjacent then
		--here any speed ups
			local originTrade = gT.Players[iPlayer].UnitsByID[uID].OriginTrade;
			local fCity = Map.GetPlotByIndex(originTrade):GetPlotCity();
			local fcID = fCity:Plot():GetPlotIndex() .. "," .. fCity:GetGameTurnFounded();
			local gmspeedup = 0;
			if not gT.Players[iPlayer].UnitsByID[uID].Pilgrim then
				gmspeedup = GetSpeedUpOfTradeUnit(fcID, iUnit, iPlayer, uID, fCity)
			else
				gmspeedup = gT.Players[iPlayer].UnitsByID[uID].ExtraPilgrimMoves;
			end
			if gmspeedup > 0 then
				iUnit:ChangeTemporaryMoves(gmspeedup)
			end
			MoveForwardITG(iUnit, Map.GetPlotByIndex(gT.Players[iPlayer].UnitsByID[uID].TargetAdjacent), uID, iPlayer)
		elseif iUnit:GetUnitType() == uCaravan or iUnit:GetUnitType() == uCargo then
			print("Killed extra trade route unit with no destination", iUnit:GetID(), iPlayer, iUnit:GetGameTurnCreated())	
			iUnit:Kill(false, -1);
		end
	end
	local lLeagueV = GetPlayerTradeRoutePointsFromLeagues(iPlayer)
	for iCity in Players[iPlayer]:Cities() do
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		local lGain, nGain, pGain =  GetTradeRoutePointsPerTurn(iCity, iPlayer, lLeagueV)
		local cCaravanProgress = gT.Cities[cID].CaravanProgress or 0;
		local bLandTR, bNavalTR = false, false;
		local lTRcost, nTRcost = GetLandTradeRouteCost(iPlayer), GetNavalTradeRouteCost(iPlayer);
		if lGain + cCaravanProgress >= lTRcost then
			gT.Cities[cID].CaravanProgress = lGain + cCaravanProgress - lTRcost;
			bLandTR = true;
		elseif gT.Players[iPlayer].CultBonusOn[117] and (cCaravanProgress + lGain * 2 >= lTRcost) and LastChance(50) then
			gT.Cities[cID].CaravanProgress = 0;
			bLandTR = true;
		else
			gT.Cities[cID].CaravanProgress = lGain + cCaravanProgress;
		end
		if bLandTR then
			if not GenerateCaravanIfPossibleTarget(iCity, iPlayer, false) then
				if (gT.Cities[cID].CargoProgress or 0) + nGain > 0 then
					gT.Cities[cID].CargoProgress = (gT.Cities[cID].CargoProgress or 0) + math.floor(lTRcost * GetModTransferUnusedTradePoints(iPlayer))
				end
			end
			if iCity:IsHasBuilding(DoTurnEconomicCaravans) then
				gT.Cities[cID].CargoProgress = (gT.Cities[cID].CargoProgress or 0) + 20;
			end
		end
		local cCargop = gT.Cities[cID].CargoProgress or 0;
		if nGain + cCargop >= nTRcost then
			gT.Cities[cID].CargoProgress = nGain + cCargop - nTRcost;
			bNavalTR = true;
		elseif gT.Players[iPlayer].CultBonusOn[117] and (cCargop + nGain * 2 >= nTRcost) and LastChance(50) then
			gT.Cities[cID].CargoProgress = 0;
			bNavalTR = true;
		else
			gT.Cities[cID].CargoProgress = nGain + cCargop;
		end
		if bNavalTR then
			if not GenerateCaravanIfPossibleTarget(iCity, iPlayer, false, true) then
				if (gT.Cities[cID].CaravanProgress or 0) + lGain > 0 then
					gT.Cities[cID].CaravanProgress = (gT.Cities[cID].CaravanProgress or 0) + math.floor(nTRcost * GetModTransferUnusedTradePoints(iPlayer))
				end
			end
			if iCity:IsHasBuilding(cWonderNew12) then
				gT.Cities[cID].CaravanProgress = (gT.Cities[cID].CaravanProgress or 0) + 20;
			end
		end
		if gT.Players[iPlayer].HasIdeology[18] then
			SetBasicCityYieldRate(iCity, yProduction, math.max(lGain, nGain), "CI_PROD_UNREG_TRADE")
		elseif GetITGCityInteger(iCity, "CI_PROD_UNREG_TRADE") > 0 then
			SetBasicCityYieldRate(iCity, yProduction, 0, "CI_PROD_UNREG_TRADE")
		end
		DoCityProcessPilgrimPoints(iCity, cID, iPlayer, pGain)
	end
end

function GetAValidTargetForCargoType(bplot, bNaval, bOcean)
	if bNaval then
		if bOcean then
			return GetCitiesFromSameCoast(GetCoastOfOceanTab(bplot), bOcean);
		else
			return GetCitiesFromSameCoast(GetCoastOfCoastsTab(bplot), bOcean)
		end
	else
		return GetCitiesFromContinent(GetLandAreaID(bplot))
	end
end

function AreCitiesOnSameCoast(bplot, splot, bOcean)
	local coastTab;
	local sCoastTab;
	if bOcean then
		coastTab = GetCoastOfOceanTab(bplot);
		sCoastTab = GetCoastOfOceanTab(splot);
		if #coastTab > 0 and #sCoastTab > 0 then
			local cB = GetAllConnectedAquens(coastTab[1], bOcean);
			if cB[sCoastTab[1]] then
				return true;
			end
		end
	else
		sCoastTab = GetCoastOfCoastsTab(splot);
		coastTab = GetCoastOfCoastsTab(bplot);
		if #coastTab > 0 and #sCoastTab > 0 then
			local cB = GetAllConnectedAquens(coastTab[1], bOcean);
			if cB[sCoastTab[1]] then
				return true;
			end
		end
	end
	return false;
end

--[[function GetCitiesFromSameCoast(coastTab, bOcean)
	local cidh = "TR";
	if bOcean then
		cidh = cidh .. "B";
	end
	table.sort(coastTab, SortFunctionLowestInteger);
	local dnr = {}
	for i, coastID in pairs(coastTab) do
		if not dnr[coastID] then
			cidh = cidh .. coastID .. "TR";
			dnr[coastID] = true;
		end
	end
	if not hCityCoastTab[cidh] then
		hCityCoastCoastTab[cidh] = {}
		hCityCoastIsOcean[cidh] = bOcean;
		for i, coastID in pairs(coastTab) do
			hCityCoastCoastTab[cidh][coastID] = 1;
		end
		hCityCoastTab[cidh] = {}
		for i,v in pairs(Players) do
			for iCity in v:Cities() do
				local icoast;
				if hCityCoastIsOcean[cidh] then
					icoast = GetCoastOfOceanTab(iCity:Plot());
				else
					icoast = GetCoastOfCoastsTab(iCity:Plot())
				end
				for it, cc in pairs(icoast) do
					if hCityCoastCoastTab[cidh][cc] then
						hCityCoastTab[cidh][iCity:Plot():GetPlotIndex()] = 1;
						break;
					end
				end
			end
		end
	end
	return hCityCoastTab[cidh];
end ]]

function ReInitializeTradeRouteData()
	bInitialized = false;
	CitiesOnOceanCoast = {};
	CitiesOnBasicCoast = {};
	hCityContinentTab = {};
end

function GetCitiesFromCertainAquenArea(coastTab, bOcean)
	local aVC = GetAllConnectedAquens(coastTab[1], bOcean);
	local rTH = {}
	for v, i in pairs(aVC) do
		for j, index in pairs(CitiesOnOceanCoast[v] or {}) do
			table.insert(rTH, Map.GetPlotByIndex(index):GetPlotCity());
		end
	end
	return rTH;
end

function GetCitiesFromSameCoast(coastTab, bOcean)
	if not bInitialized then
		InitializeCoastsAndOceansIndexes()
		bInitialized = true;
	end
	if #coastTab == 0 then
		return {}
	end
	local aVC = GetAllConnectedAquens(coastTab[1], bOcean);
	local rTH = {}
	if bOcean then
		for v, i in pairs(aVC) do
			for j, index in pairs(CitiesOnOceanCoast[v] or {}) do
				rTH[index] = true;
			end
		end
	else
		for v, i in pairs(aVC) do
			for j, index in pairs(CitiesOnBasicCoast[v] or {}) do
				rTH[index] = true;
			end
		end
	end
	return rTH;
end

function InitializeCoastsAndOceansIndexes()
	for i, g in pairs(gT.Players) do
		for iCity in Players[i]:Cities() do
			InitializeCityCoastsAndOceans(iCity)
		end
	end
end

function InitializeCityCoastsAndOceans(iCity)
	local cityplotindex = iCity:Plot():GetPlotIndex();
	local tHOcean = GetCoastOfOceanTab(iCity:Plot());
	local tHBasic = GetCoastOfCoastsTab(iCity:Plot());
	for it, cc in pairs(tHOcean) do
		if not CitiesOnOceanCoast[cc] then
			CitiesOnOceanCoast[cc] = {}
		end
		table.insert(CitiesOnOceanCoast[cc], cityplotindex)
		for jt, ss in pairs(tHOcean) do
			if jt > it then
				OceanCoastCanalConnect(cc, ss, 1)
			end
		end
	end
	for it, cc in pairs(tHBasic) do
		if not CitiesOnBasicCoast[cc] then
			CitiesOnBasicCoast[cc] = {}
		end
		table.insert(CitiesOnBasicCoast[cc], cityplotindex)
		for jt, ss in pairs(tHBasic) do
			if jt > it then
				BasicCoastCanalConnect(cc, ss, 1)
			end
		end
	end
end

function NewCityFoundedForTradeRoutes(iCity)
	for contID, sth in pairs(hCityContinentTab) do
		if GetLandAreaID(iCity:Plot()) == contID then
			if HasNearbyValidLandPlot(iCity:Plot()) then
				hCityContinentTab[contID][iCity:Plot():GetPlotIndex()] = 1;
			end
		end
	end
	InitializeCityCoastsAndOceans(iCity)
	NewCityLogForLCP(iCity)
end

function GetCitiesFromContinent(contID)
	if not hCityContinentTab[contID] then
		hCityContinentTab[contID] = {}
		for i,v in pairs(Players) do
			for iCity in v:Cities() do
				if GetLandAreaID(iCity:Plot()) == contID then
					if HasNearbyValidLandPlot(iCity:Plot()) then
						hCityContinentTab[contID][iCity:Plot():GetPlotIndex()] = 1;
					end
				end
			end
		end
	end
	return hCityContinentTab[contID];
end

function MaxCaravanDistance(iPlayer, bNaval)
	if bNaval then
		return 60;
	else
		return 40;
	end
end

function CanGenerateTradeRouteFrom(iCity, cCity, bNaval, iPlayer) 
	if bNaval then
		return AreCitiesOnSameCoast(iCity:Plot(), cCity:Plot(), Teams[Players[iPlayer]:GetTeam()]:IsHasTech(tPasssageAllWater))
	else
		if GetLandAreaID(iCity:Plot()) == GetLandAreaID(cCity:Plot()) then
			if HasNearbyValidLandPlot(cCity:Plot()) then
				return true;
			end
		end
		return false;
	end
end

function GetExclusiveTabOfDestination(iPlayer)
	local bex
	for l, s in pairs(gT.Leagues) do
		if s.Resolutions[35] then
			if s.Members[iPlayer] then
				local tab = {}
				for member, d in pairs(s.Members) do
					tab[member] = 1;
				end
				if not bex then
					bex = {}
					for h, b in pairs(tab) do
						bex[h] = b;
					end
				else
					for h, b in pairs(bex) do	
						if not tab[h] then
							bex[h] = nil;
						end
					end
				end
			end
		end
	end
	return bex;
end

function GetPreTradeBiasesDestinations(iCity, iPlayer, bNaval, exclusion, bOnlyVisible)
	local hCityTab = GetAValidTargetForCargoType(iCity:Plot(), bNaval, CanCrossOcean(iPlayer))
	local sHTab = {}
	local iTeam = Players[iPlayer]:GetTeam();
	local tExclusive = GetExclusiveTabOfDestination(iPlayer)
	local sFtab = {};
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	for bPlotIndex, sth in pairs(hCityTab) do
		local bPlot = Map.GetPlotByIndex(bPlotIndex)
		if (not bOnlyVisible) or (bPlot:IsRevealed(iTeam)) then
			if bPlot:IsCity() then
				local bCity = bPlot:GetPlotCity();
				if bCity ~= iCity then
					if bCity:IsHasBuilding(itgwonder25) then
						if bCity:GetReligiousMajority() == iCity:GetReligiousMajority() and bCity:GetReligiousMajority() > 0 then
							if not gT.Cities[cID].DomeOfTheRockTR then
								table.insert(sFtab, bPlotIndex);
							end
						end
					end
				end
			end
		end
	end
	if #sFtab > 0 then
		return sFtab;
	end
	local reserveOptions = {};
	for bPlotIndex, sth in pairs(hCityTab) do
		local bPlot = Map.GetPlotByIndex(bPlotIndex)
		if (not bOnlyVisible) or (bPlot:IsRevealed(iTeam)) then
			--if bPlot:IsCity() then
				local bCity = bPlot:GetPlotCity();
				if bCity ~= iCity then
					if (not tExclusive) or (tExclusive[bCity:GetOwner()]) then
						if bCity ~= exclusion then
							local mdis = Map.PlotDistance(iCity:GetX(), iCity:GetY(), bCity:GetX(), bCity:GetY());
							if mdis <= MaxCaravanDistance(iPlayer, bNaval) then
								if mdis > 7 then
									table.insert(sHTab, bPlotIndex)
								else
									table.insert(reserveOptions, bPlotIndex);
								end
							end
						end
					end
				end
		--	end
		end
	end
	if #sHTab < 3 then
		for a, index in pairs(sHTab) do
			table.insert(reserveOptions, index);
		end
		return reserveOptions;
	end
	return sHTab;
end

function GetJustTabOfDestination(iCity, iPlayer, initial, bNaval, exclusion)
	local pTab = GetPreTradeBiasesDestinations(iCity, iPlayer, bNaval, exclusion);
	local rTab = {}
	for a, b in pairs(pTab) do
		local bCity = Map.GetPlotByIndex(b):GetPlotCity();
		local vl = GetChanceForCityToBeTarget(bCity, iCity, iPlayer, bNaval);
		table.insert(rTab, {bCity, vl})
	end
	return rTab;
end

function GenerateCaravanIfPossibleTarget(iCity, iPlayer, initial, bNaval)
	local ttt = os.clock();
	local sHTab = GetJustTabOfDestination(iCity, iPlayer, initial, bNaval)
	if not initial then
		ChangeXPCityCustomsHousesTRGen(iCity)
	end
	if #sHTab > 0 then
		if (not initial) and gT.Players[iPlayer].TradeTargetChoiceNum > 1 then
			local hubTab = {}
			for i = 1, gT.Players[iPlayer].TradeTargetChoiceNum do
				if #sHTab > 0 then
					local lKey = GetRandomFromBiasedChanceTable(sHTab, true)
					table.insert(hubTab, sHTab[lKey][1])
					table.remove(sHTab, lKey)
				end
			end
			if #hubTab > 1 then
				if Players[iPlayer]:IsHuman() then
					local iconIndex = 3;
					local sDomain = "land"
					local iconAtlas = "EXPANSION2_UNIT_ATLAS"
					local tid = iCity:Plot():GetPlotIndex() .. "k";
					if bNaval then
						sDomain = "naval"
						iconIndex = 4;
						tid = tid .. "n"
					else
						tid = tid .. "l"
					end
					local data = {BonusType = "TradeRoute", TID = tid, Naval = bNaval, Origin = iCity:Plot():GetPlotIndex(), Text = "TRADE ROUTE TARGET", TitleText = "Choose a target for " .. sDomain .. " Trade Route originating from " .. iCity:GetName() .. ".", TitleIconIndex = iconIndex, TitleIconAtlas = iconAtlas, Tooltip = "Please choose a target for Trade Route."}
					local hTab = {}
					for i, city in pairs(hubTab) do
						local iIndex, iAtlas;
						local sName = "Unknown City"
						if Teams[Players[iPlayer]:GetTeam()]:IsHasMet(Players[city:GetOwner()]:GetTeam()) then
							local civtype = Players[city:GetOwner()]:GetCivilizationType();
							iIndex = GameInfo.Civilizations[civtype].PortraitIndex;
							iAtlas = GameInfo.Civilizations[civtype].IconAtlas;
						end
						if city:Plot():IsRevealed(Players[iPlayer]:GetTeam()) then
							sName = city:GetName();
						end
						table.insert(hTab, {Name = sName,
							ID = city:Plot():GetPlotIndex(),						
							PortraitIndex = iIndex,
							IconAtlas = iAtlas,
							ExtraInfo = tid})
					end
					data.UniqueOptions = hTab;
					table.insert(gT.Players[iPlayer].NewHumanQueueActions, data)
				else
					local aivalues = {}
					for i, city in pairs(hubTab) do
						table.insert(aivalues, {city, GetAIValueToSendTradeRouteToTheCity(iPlayer, city)})
					end
					aivalues = Shuffle(aivalues);
					table.sort(aivalues,SortFunctionForGreaterInteger2)
					GenerateCaravanToDestination(iCity, iPlayer, initial, bNaval, aivalues[1][1])
				end
			else
				GenerateCaravanToDestination(iCity, iPlayer, initial, bNaval, hubTab[1])
			end
		else
			local dKey = GetRandomFromBiasedChanceTable(sHTab, true);
			local destination = sHTab[dKey][1]
			GenerateCaravanToDestination(iCity, iPlayer, initial, bNaval, destination)
		end
	else
		return false;
	end
	return true;
end

function HumanPlayerChooseTradeRouteTarget(iPlayer, targetplotID, tid)
	local lkey;
	local origincity;
	local bNaval;
	local targetCity = Map.GetPlotByIndex(targetplotID):GetPlotCity();
	for i, sth in pairs(gT.Players[iPlayer].NewHumanQueueActions) do
		if sth.BonusType == "TradeRoute" and sth.TID == tid then
			lkey = i;
			origincity = Map.GetPlotByIndex(sth.Origin):GetPlotCity();
			bNaval = sth.Naval
			break;
		end
	end
	if origincity:GetOwner() == iPlayer then
		GenerateCaravanToDestination(origincity, iPlayer, false, bNaval, targetCity)
	end
	table.remove(gT.Players[iPlayer].NewHumanQueueActions, lkey)
end

function GetAIValueToSendTradeRouteToTheCity(iPlayer, city)
	local value = 0;
	local iOwner = city:GetOwner();
	if iOwner == iPlayer then
		value = value + 2
	elseif not Teams[Players[iPlayer]:GetTeam()]:IsAtWar(Players[iOwner]:GetTeam()) then
		value = value + 1;
	end
	return value;
end

function CreateTradeUnit(iCity, iPlayer, uType, x, y, dCity)
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local jUnit = Players[iPlayer]:InitUnit(uType, x, y)
	jUnit:SetMaxXPValue(0)
	ITGSCNewUnitCreated(iPlayer, jUnit, iCity)
	local uID = jUnit:GetID() .. "," .. iPlayer .. "," .. jUnit:GetGameTurnCreated();
	jUnit:SetBaseRangedCombatStrength(GetBaseRangedStrengthForCaravanCargo(iPlayer, jUnit))
	gT.Players[iPlayer].UnitsByID[uID].TargetAdjacent = dCity:Plot():GetPlotIndex();
	gT.Players[iPlayer].UnitsByID[uID].OriginTrade = iCity:Plot():GetPlotIndex();
	if iCity:GetReligiousMajority() > 0 then
		gT.Players[iPlayer].UnitsByID[uID].OriginReligion = iCity:GetReligiousMajority();
	end
	gT.Players[iPlayer].UnitsByID[uID].Uncontrollable = true;
	gT.Players[iPlayer].UnitsByID[uID].OriginExtraGoldMod = GetExtraModUponGeneratingTR(cID, iPlayer, uID, iCity, dCity)
	return jUnit, uID, cID;
end

function GenerateCaravanToDestination(iCity, iPlayer, initial, bNaval, destination, iMoves)
	if iMoves and iMoves < 0 then
		return;
	end
	local uType = uCaravan;
	if bNaval then
		uType = uCargo;
		DoIncreasementStockExchange(9)
	else
		DoIncreasementStockExchange(8)
	end
	local jUnit, uID, cID = CreateTradeUnit(iCity, iPlayer, uType, iCity:GetX(), iCity:GetY(), destination) 
	local hMoves;
	if iMoves then
		jUnit:SetMoves(iMoves)
	else
		hMoves = jUnit:GetMoves()
	end
	if destination:IsHasBuilding(itgwonder25) then
		gT.Cities[cID].DomeOfTheRockTR = true;
	end
	if bNaval then
		gT.Cities[cID].MTnavalTR = gT.Cities[cID].MTnavalTR + 1;
	else
		gT.Cities[cID].MTlandTR = gT.Cities[cID].MTlandTR + 1;
	end
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_MEDIEVAL_AFR_8, ",6gVRe") then
		if not bNaval then
			ChangeITGHappinessInTheCity(iCity, 1, nil, "ojgvmgr");
		end
	end
	if initial then
		local ndis = Map.PlotDistance(destination:GetX(), destination:GetY(), iCity:GetX(), iCity:GetY());
		local bT;
		if not CanCrossOcean(iPlayer) then
			bT = {[tOcean] = 1}
		end
		local gh = GenerateShortestPath({iCity:Plot()}, {[destination:Plot():GetPlotIndex()] = 1}, bNaval, 70, nil, nil, bT, nil, nil, nil, nil, nil, true)
		if gh then
			if #gh > 6 then
				local dlPlot = gh[LastRandom(3,#gh -3)] 
				jUnit:SetXY(dlPlot:GetX(), dlPlot:GetY())
			else
				print("Add minimum distance for initial trade routes?")
			end
		else
			print("Not finding a route within 70 distance, could  be possible :)", iCity:Plot():GetPlotIndex(), destination:Plot():GetPlotIndex(), ndis, iPlayer)
		end
	else
		if not iMoves then
			local gmspeedup = GetSpeedUpOfTradeUnit(cID, jUnit, iPlayer, uID, iCity)
			if gmspeedup > 0 then
				jUnit:ChangeTemporaryMoves(gmspeedup)
			end
		end
		MoveForwardITG(jUnit, destination:Plot(), uID, iPlayer)
		if HasPlayerTech(iPlayer, tUniqueInnoMeso5, "742234") then
			local cCity = Players[iPlayer]:GetCapitalCity();
			if destination ~= cCity then
				if cCity ~= iCity then
					if CanGenerateTradeRouteFrom(iCity, cCity, bNaval, iPlayer) then
						GenerateCaravanToDestination(iCity, iPlayer, initial, bNaval, cCity)
					end
				end
			end
		end
		if gT.Players[iPlayer].HasIdeology[37]  then
			local chance = 25;
			if #gT.Cities[cID].CustomsHouses > 0 then
				chance = chance + 8
			end
			if LastRandom(1, 100) <= chance then
				GenerateCaravanToDestination(iCity, iPlayer, initial, bNaval, destination, (iMoves or hMoves) - 60)
			end
		end
	end
end

function HasNearbyValidLandPlot(plot)
	for i = 0, 5 do
		local iPlot = Map.PlotDirection(plot:GetX(), plot:GetY(), i);
		if iPlot then
			if ValidPlotToMoveLand(iPlot) then
				return true;
			end
		end
	end
	return false;
end

function ValidPlotToMoveLand(iPlot)
	return not (iPlot:IsWater() or iPlot:IsImpassable());
end

function ExecuteStepByStepTRPath(jUnit, iPlayer, uID, destination)
	local bContinue = true;
	local pMoves = 0;
	while(jUnit:GetMoves() > 0 and bContinue) do
		local nextPlot = Map.GetPlotByIndex(gT.Players[iPlayer].UnitsByID[uID].TRpath[1]);
		jUnit:PushMission(mmt, nextPlot:GetX(), nextPlot:GetY())
		if jUnit:GetPlot():GetPlotIndex() == gT.Players[iPlayer].UnitsByID[uID].TRpath[1] then
			table.remove(gT.Players[iPlayer].UnitsByID[uID].TRpath, 1)
			pMoves = pMoves + 1;
			if #gT.Players[iPlayer].UnitsByID[uID].TRpath == 0 then
				return;
			end
		else
			bContinue = false;
			if nextPlot == destination then
				print("Okay we moved with TR next to destination")
				return;
			elseif jUnit:GetMoves() == 0 then
				print("TR lost of movement? ZoC?", iPlayer, uID, pMoves, jUnit:MaxMoves(), pMoves)
				return;
			else
				print("Okay we couldn't move one tile further TR", nextPlot:GetTerrainType(), nextPlot:IsCity(), nextPlot:IsVisibleEnemyUnit(iPlayer), nextPlot:GetNumUnits(), nextPlot:GetPlotIndex(), nextPlot:IsImpassable(), iPlayer, CanCrossOcean(iPlayer))
				print("Okay extra data", iPlayer, uID, jUnit:GetID(), destination:GetPlotIndex())
				gT.Players[iPlayer].UnitsByID[uID].TRpath = nil; 
				DoRedirectTR(iPlayer, uID, jUnit, destination)
				return;
			end
		end
	end
end

function PushSneakyMoveMission(jUnit, destination, iPlayer, uID)
	--move to adjacent valid tile
	local bPilgrim = (gT.Players[iPlayer].UnitsByID[uID].Pilgrim ~= nil);
	if not bPilgrim then
		jUnit:SetHasPromotion(promEmbark, false)
	end
	local sPlot = jUnit:GetPlot()
	local sPlotIndex = sPlot:GetPlotIndex();
	if gT.Players[iPlayer].UnitsByID[uID].TRpath then
		ExecuteStepByStepTRPath(jUnit, iPlayer, uID, destination)
	end
	jUnit:PushMission(mmt, destination:GetX(), destination:GetY())
	if sPlotIndex == jUnit:GetPlot():GetPlotIndex() then
		print("Let's Hope it will become obsolete one day x1", bPilgrim, jUnit:GetDomainType(), iPlayer)
		local validAdjacentTarget = GetProperAdjacentPlotForTradeRoute(jUnit, destination, iPlayer, bPilgrim)
		if validAdjacentTarget then
			jUnit:SetMoves(jUnit:MaxMoves());
			jUnit:PushMission(mmt, validAdjacentTarget:GetX(), validAdjacentTarget:GetY())
		end
	end
	if sPlotIndex == jUnit:GetPlot():GetPlotIndex() then
	-- it will be like instantly path creation
	-- if already path creation than redirect
		print("Let's Hope it will become obsolete one day x2", bPilgrim, jUnit:GetDomainType(), iPlayer)
		if jUnit:GetDomainType() == dSea then
			local bT;
			if not CanCrossOcean(iPlayer) then
				bT = {[tOcean] = 1}
			end
			local fCity = Map.GetPlotByIndex(gT.Players[iPlayer].UnitsByID[uID].OriginTrade):GetPlotCity()
			local fPlots = GenerateShortestPath({jUnit:GetPlot()}, {[destination:GetPlotIndex()] = 1}, true, 250, nil, nil, bT, nil, nil, nil, nil, nil, true) -- was situation for 190 distance
			if fPlots then
				gT.Players[iPlayer].UnitsByID[uID].TRpath = {}
				for i, plot in pairs(fPlots) do
					if i ~= 1 then
						table.insert(gT.Players[iPlayer].UnitsByID[uID].TRpath, plot:GetPlotIndex())
					end
				end
				print("Generated path for TR", sPlotIndex, CanCrossOcean(iPlayer), iPlayer, jUnit:GetName(), destination:GetPlotCity():GetName(), destination:GetPlotIndex(), fCity:GetName(), fCity:Plot():GetPlotIndex(), #gT.Players[iPlayer].UnitsByID[uID].TRpath)
				ExecuteStepByStepTRPath(jUnit, iPlayer, uID, destination)
			else
				local fCity = Map.GetPlotByIndex(gT.Players[iPlayer].UnitsByID[uID].OriginTrade):GetPlotCity()
				print("We couldn't find route in 250 distance!", sPlotIndex, CanCrossOcean(iPlayer), iPlayer, jUnit:GetName(), destination:GetPlotCity():GetName(), destination:GetPlotIndex(), fCity:GetName(), fCity:Plot():GetPlotIndex())
				DoRedirectTR(iPlayer, uID, jUnit, destination)
			end
		elseif gT.Players[iPlayer].UnitsByID[uID].Pilgrim then
			print("Pilgrim got stuck!", sPlotIndex, uID, iPlayer)
		else
			DoRedirectTR(iPlayer, uID, jUnit, destination)
		end
	end
end

function CannotBeRedirectedTR(fCity, bSea, cPlot, iPlayer)
	if bSea then
		if CanCrossOcean(iPlayer) then
			local cOceanID = GetOceanID(cPlot);
			if cOceanID == -1 then
				return true;
			end
			for i, b in pairs(GetCoastOfOceanTab(fCity:Plot())) do
				if b == cOceanID then
					return false;
				end
			end
			return true;
		else
			local cOceanID = GetBasinCoastID(cPlot)
			if cOceanID == -1 then
				return true;
			end
			for i, b in pairs(GetCoastOfCoastsTab(fCity:Plot())) do
				if b == cOceanID then
					return false;
				end
			end
			return true;
		end
	else
		return (GetContID(fCity:Plot()) ~= GetContID(cPlot))
	end
end

function DoRedirectTR(iPlayer, uID, jUnit, destination)
	local fCity = Map.GetPlotByIndex(gT.Players[iPlayer].UnitsByID[uID].OriginTrade):GetPlotCity()
	if CannotBeRedirectedTR(fCity, jUnit:GetDomainType() == dSea, jUnit:GetPlot(), iPlayer) then
		print("TR jumped to other ocean/cont.")
		bContinueWithTR = false;
		jUnit:Kill(false, -1);
		return;
	end
	local lshTab = GetJustTabOfDestination(fCity, iPlayer, nil, jUnit:GetDomainType() == dSea, destination:GetPlotCity())
	local cID = fCity:Plot():GetPlotIndex() .. "," .. fCity:GetGameTurnFounded();
	local lnewDestiny = GetRandomFromBiasedChanceTable(lshTab)
	if not lnewDestiny then
		print("Redestination kills units because no other valid city", fCity:GetName(), destination:GetPlotCity():GetName())
		bContinueWithTR = false;
		jUnit:Kill(false, -1);
		return;
	end
	gT.Players[iPlayer].UnitsByID[uID].TargetAdjacent = lnewDestiny:Plot():GetPlotIndex();
	gT.Players[iPlayer].UnitsByID[uID].OriginExtraGoldMod = GetExtraModUponGeneratingTR(cID, iPlayer, uID, fCity, lnewDestiny)
end

function GetProperAdjacentPlotForTradeRoute(jUnit, dPlot, iPlayer, bPilgrim)
	local isWater = jUnit:GetDomainType() == dSea;
	local hTab = {}
	for i = 0, 5 do
		local iPlot = Map.PlotDirection(dPlot:GetX(), dPlot:GetY(), i);
		if iPlot then
			if bPilgrim or (iPlot:IsWater() == isWater) then
				if (not iPlot:IsImpassable()) and (not iPlot:IsMountain()) then
					table.insert(hTab, {iPlot, Map.PlotDistance(iPlot:GetX(), iPlot:GetY(), jUnit:GetX(), jUnit:GetY())})
				end
			end
		end
	end
	if #hTab > 0 then
		table.sort(hTab, SortFunctionForLowestMapDistance)
		return hTab[1][1];
	else
		return nil;
	end	
end

function MoveForwardITG(jUnit, destination, uID, iPlayer)
	bContinueWithTR = true;
	if gT.Players[iPlayer].UnitsByID[uID].Pilgrim then
		PushSneakyMoveMission(jUnit, destination, iPlayer, uID)
		if bContinueWithTR then
			jUnit:SetMoves(0)
			PilgrimSetXY(iPlayer, jUnit, jUnit:GetPlot(), destination:GetPlotIndex(), uID)
		end
	elseif destination:IsCity() then
		PushSneakyMoveMission(jUnit, destination, iPlayer, uID)
		if bContinueWithTR then
			jUnit:SetMoves(0)
			CaravanSetXY(iPlayer, jUnit, jUnit:GetPlot(), destination:GetPlotIndex(), uID)
		end
	else
		jUnit:Kill(false, -1);
	end
end

function ShouldContinueJourneyTR(iPlayer, uID, destPlot)
	if HasPlayerTech(iPlayer, techAncCS7, "1234gbvawe") and LastRandom(1, 2) == 2 then
		return true;
	end
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_ASIA_7, "38459345") and LastRandom(1, 2) == 2 then
		local cID = destPlot:GetPlotIndex() .. "," .. destPlot:GetPlotCity():GetGameTurnFounded();
		if #gT.Cities[cID].CustomsHouses > 0 then
			return true;
		end
	end 
	return false;
end

function CaravanSetXY(iPlayer, iUnit, iPlot, iPlotIndex, uID)
	if gT.Players[iPlayer].UnitsByID[uID].TargetAdjacent then
		local destPlot = Map.GetPlotByIndex(gT.Players[iPlayer].UnitsByID[uID].TargetAdjacent);
		if Map.PlotDistance(iPlot:GetX(), iPlot:GetY(), destPlot:GetX(), destPlot:GetY()) < 2 then
			local dis = Map.GetPlotByIndex(gT.Players[iPlayer].UnitsByID[uID].OriginTrade)
			local rdis = Map.PlotDistance(dis:GetX(), dis:GetY(), destPlot:GetX(), destPlot:GetY());
			GetGoldFromCaravan(iUnit, rdis, iPlayer, destPlot)
--			print("Trade Unit reached target", iUnit:GetName(), uID, iUnit:GetPlot():GetOwner(), iPlayer)
			if ShouldContinueJourneyTR(iPlayer, uID, destPlot) then
				local sHTab = GetJustTabOfDestination(Map.GetPlotByIndex(gT.Players[iPlayer].UnitsByID[uID].OriginTrade):GetPlotCity(), iPlayer, false, (iUnit:GetUnitType() == uCargo), destPlot:GetPlotCity())
				if #sHTab > 0 then
					gT.Players[iPlayer].UnitsByID[uID].TargetAdjacent = GetRandomFromBiasedChanceTable(sHTab):Plot():GetPlotIndex();
					iUnit:SetMoves(0)
				else
					iUnit:Kill(false, -1)	
				end
			else
				iUnit:Kill(false, -1)
			end
		end
	end
end

function GetTRinternalBuffDuration()
	return DOMESTIC_TR_BONUS_DURATION;
end

function GetGoldFromCaravan(iUnit, ldis, iPlayer, destPlot)
	if destPlot:IsCity() then
		local iCity = destPlot:GetPlotCity();
		ResetFTDelay(0);
		local uID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
		local originTrade = gT.Players[iPlayer].UnitsByID[uID].OriginTrade;
		local fCity = Map.GetPlotByIndex(originTrade):GetPlotCity();
		local fcID = fCity:Plot():GetPlotIndex() .. "," .. fCity:GetGameTurnFounded();
		local dPlayer = iCity:GetOwner()
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		local gTurn = GetITGGameTurn();
		gT.Players[iPlayer].LastTurnTRorPlunder = gTurn;
		local bNaval = (iUnit:GetUnitType() == uCargo);
		local numCompleted = 0
		local bIPlayerActive = iPlayer == Game.GetActivePlayer();
		local bDPlayerActive = dPlayer == Game.GetActivePlayer();
		local hexXX, hexYY = iCity:GetX(), iCity:GetY();
		BasicCSMissionCompleteFunc(iPlayer, 41, nil, destPlot:GetPlotIndex())
		if bIPlayerActive then
			hexXX, hexYY = iUnit:GetX(), iUnit:GetY();
		end
		local bInternal = iPlayer == dPlayer
		if (not bInternal) and bNaval then
			if HasPlayerTech(iPlayer, itiv1, "6234321") then
				--it is a raid!
				iCity:ChangeDamage(LastRandom(50,100));
				local iBGold = LastRandom(50,150) + LastRandom(5 * iCity:GetPopulation(), 10 * iCity:GetPopulation())
				ChangeITGGold(iPlayer, iBGold)
				gT.Players[iPlayer].GoldFromTradeRoutes = gT.Players[iPlayer].GoldFromTradeRoutes + iBGold
				AddFloatingText(iPlayer,hexXX,hexYY,"[COLOR_YIELD_GOLD]+" .. iBGold .. "[ENDCOLOR][ICON_GOLD]", nil, "Trade")
				local hTab = {To = destPlot:GetPlotIndex(), From = originTrade, ToPlayer = dPlayer, FromPlayer = iPlayer, Distance = ldis,
							Killed = false, DomainType = 2, Turn = gTurn, 
							GoldEarned = iBGold, 
							CurrencyBonus = 0, 
							CultureEarned = 0, 
							TargetFood = 0,
							ScienceGain = 0, 
							Influence = 0,
							ToScienceGain = 0,
							ToGoldEarned = 0,
							ToCultureEarned = 0,
							};
				table.insert(gT.Globals.TradeRouteLog, hTab)
				return;
			end
		end
		local bMinor = Players[dPlayer]:IsMinorCiv();
		for i, data in pairs(gT.Cities[cID].TradeRoutesCompleted) do
			if gTurn - data[1] < 20 then
				numCompleted = numCompleted + 1;
			end
		end
		local domain = 1;
		if bNaval then
			domain = 2;
		end
		TradeRouteCompletedCSLog(iPlayer, dPlayer, domain)
		-- gold calculations
		local modBoth, goldmodI, goldmodTarget = GetGoldModifiersForTradeRoute(iPlayer, dPlayer, fcID, numCompleted, bInternal, fCity, iCity, uID, bNaval, cID);
		local baseGold, extraD, extraI = GetBaseAndExtraGoldFromTradeRoutes(ldis, bInternal, iCity, iPlayer, dPlayer)
		local iBGold = math.max(0, math.floor(baseGold * math.max(0.1, (1 + modBoth + goldmodI))) + extraI)
		local dBGold = math.max(0, math.floor(baseGold * math.max(0.1, (1 + modBoth + goldmodTarget)) / 4) + extraD);
		-- pre mint gold over
		local iCpowerChange = 3;
		local dCpowerChange = 2;
		if bInternal then
			dCpowerChange = 0;
		else
			local difMint = (gT.Players[iPlayer].MintBonus or 0) - (gT.Players[dPlayer].MintBonus or 0)
			if difMint > 0 then
				iCpowerChange = iCpowerChange + 1;
			elseif difMint < 0 then
				dCpowerChange = dCpowerChange + 1;
			end
		end
		AddGoldFromTradeRoutes(iPlayer, iBGold, false)
		gT.Players[iPlayer].CurrFromTR = gT.Players[iPlayer].CurrFromTR + iCpowerChange;
		local iEcoGoldString = "[COLOR_YIELD_GOLD]+" .. iBGold .. "[ENDCOLOR][ICON_GOLD]";
		if CanHaveMintPower(iPlayer) and (iCpowerChange > 0) then
			iEcoGoldString = iEcoGoldString .. " [COLOR_YIELD_GOLD]+" .. iCpowerChange .. "[ENDCOLOR][ICON_INVEST]"
		end
		AddFloatingText(iPlayer,hexXX,hexYY,iEcoGoldString, nil, "Trade")
		local bonusC, bonusCd = 0, 0;
		if not bInternal then
			local cPresence;
			if gT.Players[iPlayer].CultureType ~= gT.Players[dPlayer].CultureType then
				bonusC = LastRandom(15,25);
				bonusCd = bonusC;
				cPresence = bonusC;
			elseif gT.Players[iPlayer].SubcultureType ~= gT.Players[dPlayer].SubcultureType then
				bonusC = LastRandom(8,16);
				bonusCd = bonusC;
				cPresence = bonusC;
			else
				cPresence = LastRandom(5, 12);
			end
			DoChangeCityCultureOwnership(fcID, fCity, dPlayer, cPresence)
			DoChangeCityCultureOwnership(cID, iCity, iPlayer, cPresence)
			if gT.Players[iPlayer].CultBonusOn[98] then
				bonusC = bonusC + math.floor(gT.Players[dPlayer].NumGreatWorks / 2);
			end
			if gT.Players[dPlayer].CultBonusOn[98] then
				bonusCd = bonusCd + math.floor(gT.Players[iPlayer].NumGreatWorks / 2);
			end
		end
		if gT.Players[dPlayer].HasPlayerWonder[renWonder29] then
			DoChangeCityCultureOwnership(cID, iCity, dPlayer, 15)
		end
		if iCity:IsHasBuilding(wonderColsss) then
			DoChangeCityCultureOwnership(fcID, fCity, iCity:GetOwner(), 30)
		elseif fCity:IsHasBuilding(wonderColsss) then
			DoChangeCityCultureOwnership(cID, iCity, fCity:GetOwner(), 30)
		end
		if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_ARAB_1, "&23432") then
			if LastRandom(1, 5) == 2 then
				CreateGreatWorkOfAmount(iPlayer, 1, "Literature")
				AddFloatingText(iPlayer,hexXX,hexYY,"[ICON_GREAT_WORK]", nil, "Trade")
			else
				local exArabB = LastRandom(15,35);
				bonusC = bonusC + exArabB;
				DoChangeCityCultureOwnership(cID, iCity, iPlayer, exArabB)
			end
		end
		if bonusC > 0 then
			gT.Players[iPlayer].TRCultureStored = gT.Players[iPlayer].TRCultureStored + bonusC;
			if gT.Players[iPlayer].TRCultureStored > 0 then
				gT.Players[iPlayer].TRCulture = gT.Players[iPlayer].TRCulture + 1;
				gT.Players[iPlayer].LHCultureTR = gT.Players[iPlayer].LHCultureTR + 100 - gTurn;
				gT.Players[iPlayer].TRCultureStored = gT.Players[iPlayer].TRCultureStored - 100 + gTurn;
				AddFloatingText(iPlayer,hexXX,hexYY,"[COLOR_YIELD_CULTURE]+1[ENDCOLOR][ICON_CULTURE]", nil, "Trade")
			end
		end
		local dScience, iScience = GetUnknownValidTechs(dPlayer, iPlayer, true)
		dScience = dScience + 50 * GetNumCityAcademiesWithAbility(iCity, 3);
		iScience = iScience + 50 * GetNumCityAcademiesWithAbility(fCity, 3);
		local dFood = 0;
		local dProd = 0;
		local iDomesticMod = 1;
		if gT.Players[dPlayer].CultBonusOn[55] then
			iDomesticMod = iDomesticMod + 1;
		end
		if gT.Players[dPlayer].GovRewards[31] then
			iDomesticMod = iDomesticMod + 0.5;
		end
		if bInternal then
			dFood = DBScenario.FoodFromTR;
			dProd = DBScenario.ProdFromTR;
			if gT.Players[dPlayer].HasIdeology[71] then
				iDomesticMod = iDomesticMod + 1;
			end
		else
			--laws related
			if IsHasLaw(dPlayer, 18, 1) then
				dFood = DBScenario.FoodFromTR;
			elseif IsHasLaw(dPlayer, 18, 2) then
				dProd = DBScenario.ProdFromTR;
			elseif IsHasLaw(dPlayer, 18, 3) then
				dFood = DBScenario.FoodFromTR;
				local cExtraPresence = math.floor(GetCulturePresenceChangeFromSettlerBasedOnEra(iPlayer) / 2)
				AddFloatingText(dPlayer,hexXX,hexYY,"[COLOR_NEGATITVE_TEXT]+" .. cExtraPresence .. "[ICON_ITG_PRESENCE]", nil, "Trade")
				DoChangeCityCultureOwnership(cID, iCity, iPlayer, cExtraPresence)
			elseif IsHasLaw(dPlayer, 18, 4) then
				dProd = DBScenario.ProdFromTR;
				local cExtraPresence = math.floor(GetCulturePresenceChangeFromSettlerBasedOnEra(iPlayer) / 2)
				AddFloatingText(dPlayer,hexXX,hexYY,"[COLOR_NEGATITVE_TEXT]+" .. cExtraPresence .. "[ICON_ITG_PRESENCE]", nil, "Trade")
				DoChangeCityCultureOwnership(cID, iCity, iPlayer, cExtraPresence)
			end
			if HasPlayerTech(dPlayer, arabtrial3, "&234324") then
				dScience = dScience + 101 - gTurn;
			end
		end
		if dFood > 0 then
			dFood = math.floor(dFood * iDomesticMod);
			AddFoodTRInTime(cID, iCity, dFood, GetTRinternalBuffDuration())
			dFood = dFood * GetTRinternalBuffDuration()
			gT.Players[dPlayer].LHFoodTR = gT.Players[dPlayer].LHFoodTR + dFood;
			AddFloatingText(dPlayer,hexXX,hexYY,"+" .. dFood .. "[ICON_FOOD]", nil, "Trade")
		end
		if dProd > 0 then
			dProd = math.floor(dProd * iDomesticMod);
			AddProdTRInTime(cID, iCity, dProd, GetTRinternalBuffDuration())
			dProd = dProd * GetTRinternalBuffDuration()
			gT.Players[dPlayer].LHProdTR = gT.Players[dPlayer].LHProdTR + dProd;
			AddFloatingText(dPlayer,hexXX,hexYY,"+" .. dProd .. "[ICON_PRODUCTION]", nil, "Trade")
		end
		if iScience > 0 then
			gT.Players[iPlayer].TRScienceStored = gT.Players[iPlayer].TRScienceStored + iScience;
			if gT.Players[iPlayer].TRScienceStored > 0 then
				gT.Players[iPlayer].TRScience = gT.Players[iPlayer].TRScience + 1;
				gT.Players[iPlayer].LHScienceTR = gT.Players[iPlayer].LHScienceTR + 100 - gTurn;
				gT.Players[iPlayer].TRScienceStored = gT.Players[iPlayer].TRScienceStored - 100 + gTurn;
				AddFloatingText(iPlayer,hexXX,hexYY,"[COLOR_YIELD_SCIENCE]+1[ENDCOLOR][ICON_RESEARCH]", nil, "Trade")
			end
		end
		--HERESY // RELIGION
		local iRel = gT.Players[iPlayer].UnitsByID[uID].OriginReligion
		if iRel then
			--Cannot be missionary conv, because AI is gonna hate
			if gT.Players[dPlayer] and iCity:GetReligiousMajority() ~= iRel then
				if gT.Players[dPlayer].OfficialReligion then
					if ShouldGenerateUnhappyFromTradeRouteHeresy(dPlayer, iCity, iRel, iPlayer) then
						ChangeITGHappinessInTheCity(iCity, -1, nil, "kpbltrr");
						AddFloatingText(dPlayer,hexXX,hexYY,"+1[ICON_HAPPINESS_4]", nil, "Trade")
					end
				else
					--easy conversion 250 strength
					local traderoutestrength = 2500;
					if iRel == Players[iPlayer]:GetReligionCreatedByPlayer() then
						traderoutestrength = traderoutestrength * gT.Players[iPlayer].ReligiousTradePressure;
					end
					iCity:AddReligiousPressure(9, iRel, traderoutestrength, dPlayer)
					if bDPlayerActive or bIPlayerActive then
						AddFloatingText(nil,hexXX,hexYY,Locale.Lookup(Game.GetReligionName(iRel)) .. ": " .. traderoutestrength / 10 .. " " .. GameInfo.Religions[iRel].IconString, nil, "Trade")
					end
				end
			end
		end
		if (not DBScenario.NoFaithGeneration) then
			if gT.Players[iPlayer].CultBonusOn[124] then
				ChangeITGFaith(iPlayer, 50)
				AddFloatingText(iPlayer,hexXX,hexYY,"+50[ICON_PEACE]", nil, "Trade")
			end
			if IsCityHaveWonderRuinWithAbility(iCity, 16) then
				ChangeITGFaith(dPlayer, 25)
				AddFloatingText(dPlayer,hexXX,hexYY,"+25[ICON_PEACE]", nil, "Trade")
			end
		end
		--END RELIGION
		local dHapDestiny = 0;
		if gT.Players[dPlayer] then
			if gT.Players[dPlayer].CultBonusOn[74] then
				dHapDestiny = dHapDestiny + 1;
			end
			if HasPlayerTech(dPlayer, tAncCs22, "jnrtgrt") then
				dHapDestiny = dHapDestiny + 1;
				RevealTerrainInRadius(Players[dPlayer]:GetTeam(), fCity:Plot(), 3)
			end
		end
		if dHapDestiny > 0 then
			ChangeITGHappinessInTheCity(iCity, dHapDestiny, nil, "pkovrfvre");
			AddFloatingText(dPlayer,hexXX,hexYY, "+" .. dHapDestiny .. "[ICON_HAPPINESS_1]", nil, "Trade")
		end
		--legal and influence
		local influencebonus = 0;
		if not bInternal then
			DoCustomsHouseTRIncoming(cID, iCity, dPlayer, fCity, bDPlayerActive, Map.GetPlot(hexXX, hexYY), bNaval)
			if gT.Players[dPlayer].CultBonusOn[55] then
				ChangeITGSettlerPoints(dPlayer, 3)
				AddFloatingText(dPlayer,hexXX,hexYY, "+3[ICON_ITG_SETTLER]", nil, "Trade")
			end
			AddGoldFromTradeRoutes(dPlayer, dBGold, bMinor)
			gT.Players[dPlayer].CurrFromTR = gT.Players[dPlayer].CurrFromTR + dCpowerChange;
			local dEcoGoldString = "[COLOR_YIELD_GOLD]+" .. dBGold .. "[ENDCOLOR][ICON_GOLD]";
			if CanHaveMintPower(dPlayer) and (dCpowerChange > 0) then
				dEcoGoldString = dEcoGoldString .. " [COLOR_YIELD_GOLD]+" .. dCpowerChange .. "[ENDCOLOR][ICON_INVEST]"
			end
			AddFloatingText(dPlayer,hexXX,hexYY, dEcoGoldString, nil, "Trade")
			if bMinor then
				influencebonus = GetInfluenceFromTR(iPlayer, dPlayer);
				if influencebonus > 0 then
					Players[dPlayer]:ChangeMinorCivFriendshipWithMajor(iPlayer, influencebonus);
					AddFloatingText(iPlayer,hexXX,hexYY, "+10[ICON_INFLUENCE]", nil, "Trade")
				end
			else
				if gT.Players[dPlayer].CultBonusOn[66] then
					if IsValidForFestival(dPlayer, iCity) and (LastRandom(1, 20) == 5) then
						DoStartFestival(dPlayer, iCity, true, true)
						AddFloatingText(dPlayer,hexXX,hexYY, "[ICON_ITG_FESTIVAL]", nil, "Trade")
					else
						gT.Players[dPlayer].FairFestival = gT.Players[dPlayer].FairFestival + 1;
					end
				end
				if bonusCd > 0 then
					gT.Players[dPlayer].TRCultureStored = gT.Players[dPlayer].TRCultureStored + bonusCd;
					if gT.Players[dPlayer].TRCultureStored > 0 then
						gT.Players[dPlayer].TRCulture = gT.Players[dPlayer].TRCulture + 1;
						gT.Players[dPlayer].LHCultureTR = gT.Players[dPlayer].LHCultureTR + 100 - gTurn;
						gT.Players[dPlayer].TRCultureStored = gT.Players[dPlayer].TRCultureStored - 100 + gTurn;
						AddFloatingText(dPlayer,hexXX,hexYY, "[COLOR_YIELD_CULTURE]+1[ENDCOLOR][ICON_CULTURE]", nil, "Trade")
					end
				end
				if dScience > 0 then
					gT.Players[dPlayer].TRScienceStored = gT.Players[dPlayer].TRScienceStored + dScience;
					if gT.Players[dPlayer].TRScienceStored > 0 then
						gT.Players[dPlayer].TRScience = gT.Players[dPlayer].TRScience + 1;
						gT.Players[dPlayer].LHScienceTR = gT.Players[dPlayer].LHScienceTR + 100 - gTurn;
						gT.Players[dPlayer].TRScienceStored = gT.Players[dPlayer].TRScienceStored - 100 + gTurn;
						AddFloatingText(dPlayer,hexXX,hexYY, "[COLOR_YIELD_SCIENCE]+1[ENDCOLOR][ICON_RESEARCH]", nil, "Trade")
					end
				end
			end
		end
		DoTradeEpidemy(iCity, fCity, nil, false);
		DoTradeEpidemy(fCity, iCity, nil, true);
		--//end of effects
		--logs and other
		if iCity:IsHasBuilding(GameInfoTypes.BUILDING_ITG_NEW_MEDIEVAL_WONDER_16) then
			gT.Globals.DhamekStupa = (gT.Globals.DhamekStupa or 0) + 1;
			iCity:ChangeJONSCulturePerTurnFromBuildings(1)
			iCity:ChangeFaithPerTurnFromBuildings(1)
		end
		if not bInternal then
			ChangeXPCityCustomsHousesOnTRIncoming(iCity)
		end
		if gT.Players[iPlayer].CaliphateTrade then
			gT.Players[iPlayer].CaliphateTrade = gT.Players[iPlayer].CaliphateTrade + 1;
		end
		if gT.Players[dPlayer].HasIdeology[14] then
			ChangeITGCityInteger(iCity, "CI_LOGISTICS", 1)
			iCity:ChangeBaseYieldRateFromBuildings(yProduction, 1)
		end
		if gT.Players[iPlayer].HasIdeology[36] then
			gT.Players[iPlayer].HapGuaranteeFunds = math.min(100, gT.Players[iPlayer].HapGuaranteeFunds + 5);
		end
		if gT.Players[iPlayer].HasIdeology[44] then
			if not bInternal then
				if (gT.Players[iPlayer].Ideo44CD or -1) < gTurn then
					local dTypeOfNewUnit = dLand;
					if bNaval then
						dTypeOfNewUnit = dSea;
					end
					local tPlot = GetValidPlotForGunboat(iUnit, iPlayer)
					if tPlot then	
						local tnunit = SimpleGenerateUnitOfType(iPlayer, GetAnyValidMilitaryUnitType(iPlayer, dTypeOfNewUnit), tPlot, nil, nil, false, true)
						if tnunit then
							gT.Players[iPlayer].Ideo44CD = gTurn + 7;
							tnunit:SetHasPromotion(GameInfoTypes.PROMOTION_ITG_IDEOLOGY_44, true)
							if tPlot:GetNumUnits() > 2 or (tPlot:GetNumUnits() > 1 and (iUnit:GetPlot() ~= tPlot)) then
								tnunit:JumpToNearestValidPlot();
							end
						end
					end
				end
			end
		end
		local hTab = {To = destPlot:GetPlotIndex(),
					From = originTrade,
					ToPlayer = destPlot:GetOwner(),
					FromPlayer = iPlayer,
					Distance = ldis,
					Killed = false,
					DomainType = domain,
					GoldEarned = iBGold,
					CultureEarned = bonusC,
					TargetFood = dFood,
					ScienceGain = iScience,
					Influence = influencebonus,
					Turn = gTurn};
		if CanHaveMintPower(iPlayer) then
			hTab.CurrencyBonus = iCpowerChange;
		end
		if not bInternal then
			if gT.Players[dPlayer] then
				hTab.ToScienceGain = dScience;
				hTab.ToGoldEarned = dBGold;
				hTab.ToCultureEarned = bonusCd;
				if CanHaveMintPower(dPlayer) then
					hTab.ToCurrencyBonus = dCpowerChange;
				end
			end
		end
		table.insert(gT.Globals.TradeRouteLog, hTab)
		if iUnit:GetPlot():IsVisible(Game.GetActiveTeam()) then
			local hex = ToHexFromGrid(Vector2(iUnit:GetX(), iUnit:GetY()));
			Events.GameplayFX(hex.x, hex.y, -1);
		end
		if Players[iPlayer]:IsHuman() then
			LuaEvents.ITG_AchievementCountChange(83, 1)
		end
		if Players[iPlayer]:IsHuman() or Players[dPlayer]:IsHuman() then
			if iPlayer ~= dPlayer then
				local ngtrll = #gT.Globals.TradeRouteLog;
				local dpindex = destPlot:GetPlotIndex();
				for i = 2, ngtrll do
					local bsc = gT.Globals.TradeRouteLog[ngtrll + 1 - i];
					if (bsc.Turn == gTurn) then
						if (not bsc.Pilgrim) and bsc.From == dpindex and bsc.To == originTrade then
							LuaEvents.ITG_AchievementCompleted(97)
							break;
						end
					else
						break;
					end
				end
			end
		end
		VictoryTaskCompletion(iPlayer, 6)	
		table.insert(gT.Cities[cID].TradeRoutesCompleted, {gTurn, ldis, iPlayer, iUnit:GetUnitType()})
		gT.Players[iPlayer].TradeDestinationVisits[destPlot:GetPlotIndex()] = (gT.Players[iPlayer].TradeDestinationVisits[destPlot:GetPlotIndex()] or 0 ) + 1
	end
end

function GenerateStartingTradeRoutes(hMajorTab)
	for i, player in pairs(hMajorTab) do
		for iCity in Players[player]:Cities() do
			local lGain, nGain, pGain = GetTradeRoutePointsPerTurn(iCity, player);
			local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
			if nGain > 0 then
				if LastRandom(1, 7) == 4 then
					GenerateCaravanIfPossibleTarget(iCity, player, true, true)
				end
			end
			if lGain > 0 then
				if LastRandom(1, 6) == 3 then	
					GenerateCaravanIfPossibleTarget(iCity, player, true, false)
				end
			end
			if pGain > 0 then
				if LastRandom(1, 7) == 3 then	
					GeneratePilgrimageIfPossibleTarget(iCity, player, true)
				end
			end
			gT.Cities[cID].PilgrimProgress = LastRandom(0, math.min(GetPilgrimageCost(player) - 15, 12 * pGain))
			gT.Cities[cID].CaravanProgress = LastRandom(0, math.min(GetLandTradeRouteCost(player) - 15, 12 * lGain))
			gT.Cities[cID].CargoProgress = LastRandom(0, math.min(GetNavalTradeRouteCost(player) - 15, 12 * nGain))
--			print("init trade route values", gT.Cities[cID].CaravanProgress, gT.Cities[cID].CargoProgress, lGain, nGain, player)
		end
		local trGoldInstances = LastRandom(0, math.max(2, Players[player]:GetNumCities()))
		for j = 1, trGoldInstances do
			AddTradeRouteGoldInTime(player, LastRandom(5,12), LastRandom(3,6))
		end
	end
end

function GetBaseCityTRattrCapital(bCity, bPlayer, cID)
	local base = 0;
	if HasPlayerTech(bPlayer, tAncCs22, "bhfdrrf") then
		if bCity:IsCapital() then
			base = base + 15;
		end
	end
	return base;
end

function GetBaseCityTRattrBuildings(iCity)
	return iCity:GetTradeAppeal();
end

function GetBaseCityTRattrLaws(iCity, iPlayer)
	local a = 0;
	if IsHasLaw(iPlayer, 30, 4) then
		a = a - 1;
	end
	if IsHasLaw(iPlayer, 9, 3) then
		if not iCity:IsOccupied() then
			a = a + GetNumOccupiedCities(iPlayer);
		else
			a = a - GetNumNonOccupiedCities(iPlayer);
		end
	end
	return a;
end

function GetBaseCityTRattrWonders(bCity, bPlayer, cID)
	local base = 0;
	if bCity:IsHasBuilding(bGreatZimb) then
		base = base + math.floor(bCity:GetBuildingDefense() / 100);
	end
	if bCity:IsHasBuilding(wonderPetra) then
		local iLast = #gT.Cities[cID].TradeRoutesCompleted;
		if (iLast == 0) or (gT.Cities[cID].TradeRoutesCompleted[iLast][1] + 10 < GetITGGameTurn()) then
			base = base + 100;
		end
	end
	return base;
end

function GetBaseCityTRattrKasbahs(cID)
	return gT.Cities[cID].KasbahTR * 10;
end

function GetBaseCityTRattrReligion(bCity, bPlayer, cID)
	local base = 0;
	if IsBeliefPresentInACity(bCity, beliefITgfol25) then
		base = base + 10;
	end
	return base;
end

function GetCityTRattrFestival(bCity, bPlayer, cID)
	local t = gT.Cities[cID].TRattrFest;
	if gT.Cities[cID].FestivalET then
		if gT.Players[bPlayer].FestivalBonusesActive[10] then
			t = t + gT.Players[bPlayer].FestivalBonusesActive[10];
		end
	end
	if IsHasLaw(bPlayer, 25, 2) then
		if gT.Cities[cID].FestivalET then
			t = t + 8 * gT.Players[bPlayer].Law25Int;
		elseif gT.Players[bPlayer].Law25Int > 0 then
			t = t - 8;
		end
	end
	return t;
end

function GetCityTRAttrFromCustomsHouse(bCity, bPlayer, cID)
	local t = 0;
	for i, index in pairs(gT.Cities[cID].CustomsHouses) do
		if gT.CustomsHouses[index].Active then
			t = t + gT.CustomsHouses[index].BasicBonuses[4];
			if gT.CustomsHouses[index].IncomingBonuses[11] then
				t = t + 15;
			end
			if not gT.CustomsHouses[index].Embargo then
				t = t + 3;
			end
		end
	end
	return t;
end

function GetBaseCityTRattrGoldenAge(iCity, iPlayer, cID)
	local t = 0;
	if Players[iPlayer]:IsGoldenAge() then
		if gT.Players[iPlayer].HasMinorIdeology[4] then
			t = t + 15;
		end
	end
	return t;
end

function GetBaseCityTRattrGoverment(iCity, cID, iPlayer)
	local t = 0;
	if gT.Players[iPlayer].AuthorityRank == 1 then
		if gT.Players[iPlayer].GovRewards[4] then
			t = t + 3;
		end
	end
	return t;
end

function GetBaseCityTRPalace(iCity, iPlayer, cID)
	local t = 0;
	if gT.Cities[cID].Palace then
		if gT.Cities[cID].Palace.TradeAppeal ~= 0 then
			t = t + gT.Cities[cID].Palace.TradeAppeal * GetCityPalaceYieldMod(iCity, cID, iPlayer);
		end
	end
	return t;
end

function GetBaseCityTRAttractiveness(bCity, bPlayer, cID)
	local base = 10 + GetBaseCityTRattrCapital(bCity, bPlayer, cID) + GetBaseCityTRattrReligion(bCity, bPlayer, cID) + GetBaseCityTRattrWonders(bCity, bPlayer, cID) + GetBaseCityTRattrBuildings(bCity)
	base = base + gT.Cities[cID].TRAttrFromGP + GetITGCityInteger(bCity, "CI_GOV_TR_APPEAL") + GetCityTRattrFestival(bCity, bPlayer, cID) + GetCityTRAttrFromCustomsHouse(bCity, bPlayer, cID) + GetBaseCityTRattrKasbahs(cID)
	base = base + GetBaseCityTRPalace(bCity, bPlayer, cID) + GetBaseCityTRattrLaws(bCity, bPlayer) + GetBaseCityTRattrGoverment(bCity, cID, bPlayer) + GetBaseCityTRattrGoldenAge(bCity, bPlayer, cID)
	return base;
end

function GetCityTRAttractivenessHolyCity(bCity)
	local base = 0;
	if bCity:IsHolyCityAnyReligion() then
		for i, type in pairs(GrandTemples) do
			if bCity:IsHasBuilding(type[1]) then
				base = base + type[2];
			end
		end
	end
	return base;
end

function GetCityTRAttrLawInternational(bPlayer)
	local base = 0;
	if IsHasLaw(bPlayer, 3, 1) then
		base = base - 3;
	elseif IsHasLaw(bPlayer, 3, 2) then
		base = base + 3;
	end	
	return base;
end

function GetTRAppealFromEmbargos(iPlayer, bPlayer)
	local base = 0;
	if gT.Players[iPlayer].Embargos[bPlayer] and ((gT.Players[iPlayer].OpenTrade[bPlayer] or 0) == 0) then
		base = base - 20 * gT.Players[iPlayer].Embargos[bPlayer];
	end
	if gT.Players[bPlayer].Embargos[iPlayer] and ((gT.Players[bPlayer].OpenTrade[iPlayer] or 0) == 0) then
		base = base - 20 * gT.Players[bPlayer].Embargos[iPlayer];
	end
	return base;
end

function GetTRAttrDomestic(iPlayer)
	local base = 0;
	if gT.Players[iPlayer].CultBonusOn[55] then
		base = base + 30;
	end
	if gT.Players[iPlayer].HasIdeology[71] then
		base = base + 30;
	end
	return base;
end

function GetChanceForCityToBeTarget(bCity, iCity, iPlayer, bNaval, bToolTip)
	if bCity:IsPlague() then
		if bToolTip then
			return {1, "There is a [ICON_ITG_PLAGUE_4] Epidemy in the City."}
		else
			return 1;
		end
	end
	local toolTipS = "Estimated [ICON_TRADE_WHITE] Trade Appeal of the City:";
	local bPlayer = bCity:GetOwner();
	local homeland = (bPlayer == iPlayer);
	local cID = bCity:Plot():GetPlotIndex() .. "," .. bCity:GetGameTurnFounded();
	local mod = 1;
	--always
	local base = GetBaseCityTRAttractiveness(bCity, bPlayer, cID);
	if bToolTip then
		toolTipS = toolTipS .. "[NEWLINE][ICON_BULLET]" .. base .. " [ICON_TRADE_WHITE] from City.";
	end
	--embargos
	local itrAembargo = GetTRAppealFromEmbargos(iPlayer, bPlayer);
	if itrAembargo ~= 0 then
		base = base + itrAembargo;
		if bToolTip then
			toolTipS = toolTipS .. "[NEWLINE][ICON_BULLET]" .. itrAembargo .. " [ICON_TRADE_WHITE] from Embargos.";
		end
	end
	--foreign
	if not homeland then
		local intTRaLaw = GetCityTRAttrLawInternational(bPlayer);
		if itrAembargo ~= 0 then
			base = base + intTRaLaw;
			if bToolTip then
				toolTipS = toolTipS .. "[NEWLINE][ICON_BULLET]" .. intTRaLaw .. " [ICON_TRADE_WHITE] from target's Laws.";
			end
		end
		if Teams[Players[bPlayer]:GetTeam()]:HasEmbassyAtTeam(Players[iPlayer]:GetTeam()) then
			base = base + 5;
			if bToolTip then
				toolTipS = toolTipS .. "[NEWLINE][ICON_BULLET]5 [ICON_TRADE_WHITE] from Embassy.";
			end
		end
		if gT.Players[iPlayer].StAlphabet == bPlayer then
			base = base + 10;
			if bToolTip then
				toolTipS = toolTipS .. "[NEWLINE][ICON_BULLET]10 [ICON_TRADE_WHITE] from Alphabet.";
			end
		end
		if Teams[Players[iPlayer]:GetTeam()]:IsAtWar(Players[bPlayer]:GetTeam()) then
			base = base - 30;
			if bToolTip then
				toolTipS = toolTipS .. "[NEWLINE][ICON_BULLET]-30 [ICON_TRADE_WHITE] from War.";
			end
		end
	else
	--domestic
		local iExtraTRaDomestic = GetTRAttrDomestic(iPlayer)
		if iExtraTRaDomestic ~= 0 then
			base = base + iExtraTRaDomestic;
			if bToolTip then
				toolTipS = toolTipS .. "[NEWLINE][ICON_BULLET]" .. iExtraTRaDomestic .. " [ICON_TRADE_WHITE] from Domestic favour.";
			end
		end
	end
	--religion
	local iRel = iCity:GetReligiousMajority();
	if iRel > 0 then
		if bCity:IsHolyPlaceForReligion(iRel) then
			local iExtraFromHolyPlace = GetCityTRAttractivenessHolyCity(bCity)
			if iExtraFromHolyPlace ~= 0 then
				base = base + iExtraFromHolyPlace;
				if bToolTip then
					toolTipS = toolTipS .. "[NEWLINE][ICON_BULLET]" .. iExtraFromHolyPlace .. " [ICON_TRADE_WHITE] from Holy Place.";
				end
			end
		end
	end
	--cheesy governor
	if not bToolTip then
		local govID = gT.Cities[cID].Governor;
		if govID and (govID ~= -1) then
			if gT.Globals.Governors[govID].ForeignContacts[bPlayer] and gT.Globals.Governors[govID].ForeignContacts[bPlayer].TradeTarget then
				base = base + 50;
			end
		end
	end
	--based on lost Trade-routes
	local gTurn = GetITGGameTurn();
	local fcpIndex = iCity:Plot():GetPlotIndex();
	local itrLostTR = 0;
	for i, data in pairs(gT.Players[iPlayer].TradeRoutesLost) do
		if ((data[3] == bPlayer) and (not homeland)) or (data[4] == fcpIndex) then
			itrLostTR = itrLostTR - 1;
			if gTurn - data[1] < 20 then
				itrLostTR = itrLostTR - 1;
				if gTurn - data[1] < 10 then
					itrLostTR = itrLostTR - 1;
					if gTurn - data[1] < 5 then
						itrLostTR = itrLostTR - 2;
					end
				end
				if (data[5] == uCaravan) ~= bNaval then
					itrLostTR = itrLostTR - 2;
				end
			end
		end 
	end
	if itrLostTR ~= 0 then
		base = base + itrLostTR;
		if bToolTip then
			toolTipS = toolTipS .. "[NEWLINE][ICON_BULLET]" .. itrLostTR .. " [ICON_TRADE_WHITE] from plundered Trade-Routes.";
		end
	end
	--Special
	if HasPlayerTech(iPlayer, innoTrialAsia7, "9i5345") then
		if #gT.Cities[cID].CustomsHouses > 0 then
			base = base + 10;
			if bToolTip then
				toolTipS = toolTipS .. "[NEWLINE][ICON_BULLET]10 [ICON_TRADE_WHITE] from plundered Silk Road.";
			end
		end
	end
	--mods;
	if gT.Players[iPlayer] then
		if gT.Players[iPlayer].CultBonusOn[83] then
			if not bCity:Plot():IsRevealed(Players[iPlayer]:GetTeam()) then
				mod = mod + 1;
			end
		end
	end
	if bToolTip then
		return {math.max(1,math.floor(base * mod + 0.5)), toolTipS};
	end
	return math.max(1,math.floor(base * mod + 0.5));
end

function GetBaseRangedStrengthForCaravanCargo(iPlayer, jUnit)
	return DBScenario.RangedDefTradeRoutes
end

function IsEnemyPlot(plot, iTeam)
	if plot:GetOwner() == -1 then
		return false;
	end
	return Teams[iTeam]:IsAtWar(Players[plot:GetOwner()]:GetTeam());
end

function GetGoldModifiersForTradeRoute(iPlayer, dPlayer, fcID, numCompleted, bInternal, fCity, iCity, uID, bNaval, cID)
	local modBoth = math.max(0, 0.25 - 0.125 * numCompleted)
	local goldmodI, goldmodTarget = gT.Players[iPlayer].UnitsByID[uID].OriginExtraGoldMod, (0 + gT.Cities[fcID].GPTradeRoutesModifier);
	goldmodI = goldmodI + math.min(0.5, 0.02 * (1 - Players[iPlayer]:GetNumCities()));
	goldmodTarget = goldmodTarget + math.min(0.5, 0.02 * (1 - Players[dPlayer]:GetNumCities()));
	goldmodI = goldmodI + gT.Players[iPlayer].TradeGoldModAcademies;
	goldmodTarget = goldmodTarget + gT.Players[dPlayer].TradeGoldModAcademies;
	if gT.Players[iPlayer].HasIdeology[36] then
		goldmodI = goldmodI - 0.1;
		goldmodTarget = goldmodTarget - 0.1;
	end
	if IsCityHaveWonderRuinWithAbility(iCity, 10) then
		if bInternal then
			goldmodI = goldmodI + 0.25;
		else
			goldmodTarget = goldmodTarget + 0.25;
		end
	end
	if bNaval then
		if gT.Players[iPlayer].CultBonusOn[65] then
			goldmodI = goldmodI + 0.33;
		end
	end
	if IsCityHaveWonderRuinWithAbility(fCity, 10) then
		goldmodI = goldmodI + 0.25;
	end
	if bMinor then
		if gT.Players[iPlayer].CultBonusOn[54] then
			goldmodI = goldmodI + 0.3;
		end
	end
	if HasPlayerTech(iPlayer, tInnoEuro3, "&1234124") then
		goldmodI = goldmodI + 0.5;
	end
	if not bInternal then
		if gT.Players[iPlayer].SubcultureType == 8 then
			goldmodI = goldmodI + 0.2;
		end
		if gT.Players[dPlayer].SubcultureType == 8 then
			goldmodTarget = goldmodTarget + 0.2;
		end
		goldmodTarget = goldmodTarget + GetCityGovTraitBonus(iCity, 11) / 100;
		if gT.Globals.ScenarioType == 1 then
			if GetContID(fCity:Plot()) ~= GetContID(iCity:Plot()) then
				modBoth = modBoth + 0.5;
			end				
		end
		if HasPlayerTech(iPlayer, tribeInno17, "tribeInno17") then
			goldmodI = goldmodI + 0.15;
		end		
		if HasPlayerTech(dPlayer, tribeInno17, "tribeInno17") then
			goldmodTarget = goldmodTarget + 0.15;
		end

		if gT.Players[dPlayer].Laws then
			if IsHasLaw(dPlayer, 3, 1) then
				goldmodTarget = goldmodTarget + 0.25;
			elseif IsHasLaw(dPlayer, 3, 2) then
				goldmodTarget = goldmodTarget - 0.2;
			end
		end
		if HasPlayerTech(iPlayer, innotrial7asia, "%^T$3fr45") then
			local numTRP = 0;
			local tDpindex = iCity:Plot():GetPlotIndex();
			for i, b in pairs(gT.Globals.TradeRouteLog) do
				if (b.To == tDpindex) and (not b.Pilgrim) and (b.FromPlayer == iPlayer) then
					if not b.Killed then
						numTRP = numTRP + 1;
					end
				end
			end
			goldmodI = goldmodI + math.min(0.2 * numTRP, 1);
		end
		if bNaval and HasPlayerNatureWonder(dPlayer, GameInfoTypes.FEATURE_GIBRALTAR) then
			goldmodTarget = goldmodTarget + 0.5;
		end
		if IsHasLaw(dPlayer, 18, 1) or IsHasLaw(dPlayer, 18, 2) then
			goldmodTarget = goldmodTarget - 0.25;
		end
		if HasPlayerCHIncomingTrait(dPlayer, 5) then
			if gT.Players[iPlayer].VotesFromBreakingLeague then
				goldmodI = goldmodI - 0.25;
			end
			if Teams[Players[dPlayer]:GetTeam()]:IsAtWar(Players[iPlayer]:GetTeam()) then
				goldmodI = goldmodI - 0.25;
			end
			if not Teams[iPlayer]:HasEmbassyAtTeam(Players[dPlayer]:GetTeam()) then
				goldmodI = goldmodI - 0.2;
			end
			if gT.Players[dPlayer].Embargos[iPlayer] and ((gT.Players[dPlayer].OpenTrade[iPlayer] or 0) == 0) then
				goldmodI = goldmodI - 0.25;
			end
		end
		local difMint = (gT.Players[iPlayer].MintBonus or 0) - (gT.Players[dPlayer].MintBonus or 0)
		if difMint > 0 then
			goldmodI = goldmodI + 0.01 * difMint;
		elseif difMint < 0 then
			goldmodTarget = goldmodTarget - 0.01 * difMint;
		end
		if gT.Players[dPlayer].Embargos[iPlayer] and ((gT.Players[dPlayer].OpenTrade[iPlayer] or 0) == 0) then
			goldmodI = goldmodI - 0.25 * gT.Players[dPlayer].Embargos[iPlayer];
		end
	else
		goldmodI = goldmodI - 0.33; -- all domestic got nerfed by 33%
		if gT.Players[iPlayer].HasIdeology[71] then
			goldmodI = goldmodI - 0.33;
		end
	end
	return modBoth, goldmodI, goldmodTarget;
end

function GetBaseAndExtraGoldFromTradeRoutes(ldis, bInternal, iCity, iPlayer, dPlayer, bAverage)
--note it is used for Pilgrims now as well!
	local baseGold = math.floor(ldis/4)
	if bAverage then
		baseGold = baseGold + 28;
	else
		baseGold = baseGold + LastRandom(18,38);
	end
	if iCity then
		baseGold = baseGold + iCity:GetPopulation();
	end
	local extraD, extraI = 0, 0;
	if not bInternal then
		for row in GameInfo.Resources() do
			if row.Happiness > 0 then
				local bCurrency = false;
				if gT.Players[iPlayer].Currencies == row.ID then
					bCurrency = true;
					if Players[dPlayer]:GetNumResourceAvailable(row.ID, true) > 0 then
						extraI = extraI + 2 + math.max(0, Players[dPlayer]:GetNumResourceAvailable(row.ID, true)-Players[iPlayer]:GetNumResourceAvailable(row.ID, true)) * 5;
					end
				end
				if gT.Players[dPlayer].Currencies == row.ID then
					bCurrency = true;
					if Players[iPlayer]:GetNumResourceAvailable(row.ID, true) > 0 then
						extraD = extraD + 2 + math.max(0, Players[iPlayer]:GetNumResourceAvailable(row.ID, true)-Players[dPlayer]:GetNumResourceAvailable(row.ID, true)) * 5;
					end
				end

				if not bCurrency then
					if Players[iPlayer]:GetNumResourceAvailable(row.ID, true) < 1 then
						if Players[dPlayer]:GetNumResourceAvailable(row.ID, true) > 0 then
							baseGold = baseGold + 1;
						end
					elseif Players[dPlayer]:GetNumResourceAvailable(row.ID, true) < 1 then
						baseGold = baseGold + 1;
					end
				end
			end
		end
	end
	return baseGold, extraD, extraI;
end

function AddGoldFromTradeRoutes(iPlayer, iGold, bMinor)
	if bMinor then
		ChangeITGGold(iPlayer, iGold)
	else
		local duration = GetDurationOfTradeGold(iPlayer)
		local basemod = math.floor(iGold / duration)
		local secondarymodduration = iGold - basemod * duration;
		AddTradeRouteGoldInTime(iPlayer, basemod, duration)
		if secondarymodduration > 0 then
			AddTradeRouteGoldInTime(iPlayer, 1, secondarymodduration)
		end
		gT.Players[iPlayer].GoldFromTradeRoutes = gT.Players[iPlayer].GoldFromTradeRoutes + iGold
		if iPlayer == Game.GetActivePlayer() then
			LuaEvents.ITGSGTopPanelDirty()
		end
	end
end

function GetDurationOfTradeGold(iPlayer)
	return 8;
end

function AddTradeRouteGoldInTime(iPlayer, amount, duration)
	gT.Players[iPlayer].TotalTradeRouteGold = gT.Players[iPlayer].TotalTradeRouteGold + amount * duration;
	gT.Players[iPlayer].NextTurnTradeRouteGold = gT.Players[iPlayer].NextTurnTradeRouteGold + amount;
	table.insert(gT.Players[iPlayer].TradeRouteGoldInTime, {amount, GetITGGameTurn() + duration})
end

function GetGoldFromTradeRoutesInTime(iPlayer)
	return gT.Players[iPlayer].NextTurnTradeRouteGold;
end

function GetGoldFromSolvePoority(iPlayer)
	return gT.Players[iPlayer].SolvePoorityGold
end

function TradeRouteGoldDead(iPlayer)
	gT.Players[iPlayer].TotalTradeRouteGold = 0;
	gT.Players[iPlayer].NextTurnTradeRouteGold = 0;
	gT.Players[iPlayer].TradeRouteGoldInTime = {};
end

function DoReductionOfGoldInTime(iPlayer, tTurn)
	local totred = 0;
	local nextred = 0;
	local tRem = {}
	for i, v in pairs(gT.Players[iPlayer].TradeRouteGoldInTime) do
		totred = totred + v[1];
		if v[2] <= tTurn then
			nextred = nextred + v[1]
			table.insert(tRem, i)
		end
	end
	gT.Players[iPlayer].TotalTradeRouteGold = gT.Players[iPlayer].TotalTradeRouteGold - totred;
	gT.Players[iPlayer].NextTurnTradeRouteGold = gT.Players[iPlayer].NextTurnTradeRouteGold - nextred;
	for i = 1, #tRem do
		table.remove(gT.Players[iPlayer].TradeRouteGoldInTime, tRem[#tRem + 1 - i])
	end
end

function GetInfluenceFromTR(iPlayer, dPlayer)
	if Teams[Players[dPlayer]:GetTeam()]:IsAtWar(Players[iPlayer]:GetTeam()) then
		return 0;
	end
	local gAlly = Players[dPlayer]:GetAlly();
	if (gAlly ~= -1) and gT.Players[gAlly].HasIdeology[16] and (gAlly ~= iPlayer) then
		return 0;
	end
	local influencebonus = 10 + 7 * GetNumGPWithAbility(iPlayer, 37);
	if gT.Players[iPlayer].CultBonusOn[54] then
		influencebonus = influencebonus + 10;
	end
	if gT.Players[iPlayer].HasIdeology[16] then
		influencebonus = influencebonus + 30;
	end
	return influencebonus;
end

function GetValidPlotForGunboat(iUnit, iPlayer)
	local bWater = iUnit:GetDomainType() == dSea;
	local iPlot = iUnit:GetPlot()
	if not iPlot:IsCity() then
		return iPlot;
	end
	local t = {}
	for i = 0, 5 do
		local tH = Map.PlotDirection(iPlot:GetX(), iPlot:GetY(), i);
		if tH and (tH:IsWater() == bWater) then
			if (not tH:IsImpassable()) then
				table.insert(t, tH)
			end
		end
	end
	if #t > 0 then
		return t[LastRandom(1,#t)];
	end
	return nil;
end

function GetExtraModUponGeneratingTR(cID, iPlayer, uID, iCity, destination)
	local base = gT.Cities[cID].GPTradeRoutesModifier;
	if gT.Players[iPlayer].CultBonusOn[83] then
		if not destination:Plot():IsRevealed(Players[iPlayer]:GetTeam()) then
			gT.Players[iPlayer].UnitsByID[uID].UnknownDestinationMoves = true; -- keep on redirection
			base = base + 1;
		end
	end
	--ch new base effect:
	for i, index in pairs(gT.Cities[cID].CustomsHouses) do
		if gT.CustomsHouses[index].Active then
			base = base + 0.15;
		end
	end
	if gT.Players[iPlayer].CultBonusOn[123] then
		base = base + 0.02 * gT.Cities[cID].FishNextT;
	end
	return base;
end


LuaEvents.ITGSG_RequestCityTradeInfo.Add(function(iPlayer, cityID)
	local tab = {};
	local iCity = Players[iPlayer]:GetCityByID(cityID);
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	tab.StoredLandTradeRoute = gT.Cities[cID].CaravanProgress;
	tab.StoredNavalTradeRoute = gT.Cities[cID].CargoProgress;
	tab.LandTradeRouteChange, tab.NavalTradeRouteChange, tab.PilgrimChange = GetTradeRoutePointsPerTurn(iCity, iPlayer, nil, true);
	tab.LandTradeRouteChangeTT, tab.NavalTradeRouteChangeTT, tab.PilgrimChangeTT = TRCityViewToolTip(iCity, iPlayer, tab.LandTradeRouteChange, tab.NavalTradeRouteChange, tab.PilgrimChange)
	tab.LandTradeRouteCost = GetLandTradeRouteCost(iPlayer);
	tab.NavalTradeRouteCost = GetNavalTradeRouteCost(iPlayer);
	MapModData.ITGSG = tab;
end)

function TRWillGenerateCultureMuchLikely(iPlayer, dPlayer)
	if iPlayer ~= dPlayer then
		if gT.Players[iPlayer].CultureType ~= gT.Players[dPlayer].CultureType then
			return true;
		elseif gT.Players[iPlayer].SubcultureType ~= gT.Players[dPlayer].SubcultureType then
			return true;
		end
		if gT.Players[iPlayer].CultBonusOn[98] then
			return true;
		end
	end
	return false;
end

function TRWillGenerateScienceMuchLikely(iPlayer, dPlayer, numTechs, bHasIntel)
	if iPlayer ~= dPlayer then
		local dTechs, dInnos = GetNumKnownTechsDemographics(iPlayer, dPlayer, bHasIntel, true, 4)
		if dTechs > numTechs then
			return true;
		end
		if bHasIntel then
			if dInnos > 0 then
				if gT.Players[iPlayer].CultBonusOn[98] then
					return true;
				end
			end
		end
	end
	return false;
end

LuaEvents.ITGSG_RequestCityTradeTargets.Add(function(iPlayer, cityID, m_iDomain)
	local tab = {};
	local iCity = Players[iPlayer]:GetCityByID(cityID);
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local bNaval = (m_iDomain == dSea);
	local pTab = GetPreTradeBiasesDestinations(iCity, iPlayer, bNaval, nil, true);
	local bHasIntel = (HasAgentGatheringIntel(iPlayer) > 0);
	local numTechs, numInnos = GetNumKnownTechsDemographics(iPlayer, iPlayer, bHasIntel, false, 4)
	local bScienceFromAca = GetNumCityAcademiesWithAbility(iCity, 3) > 0;
	for a, b in pairs(pTab) do
		local bPlot = Map.GetPlotByIndex(b);
		local bCity = bPlot:GetPlotCity();
		local bPlayer = bCity:GetOwner()
		local vl = GetChanceForCityToBeTarget(bCity, iCity, iPlayer, bNaval, true);
		local bg, extraD, extraI = GetBaseAndExtraGoldFromTradeRoutes(Map.PlotDistance(iCity:GetX(), iCity:GetY(), bCity:GetX(), bCity:GetY()), (bPlayer == iPlayer), bCity, iPlayer, bPlayer, true)
		local bCulture = TRWillGenerateCultureMuchLikely(iPlayer, bPlayer);
		local bScience = bScienceFromAca or TRWillGenerateScienceMuchLikely(iPlayer, bPlayer, numTechs, bHasIntel);
		local bInfluence = false;
		if Players[bPlayer]:IsMinorCiv() then
			if GetInfluenceFromTR(iPlayer, bPlayer) > 0 then
				bInfluence = true;
			end
		end 
		table.insert(tab, {b, vl[1], bg, extraI, bCulture, bScience, bInfluence, vl[2]});
	end
	table.sort(tab,SortFunctionForGreaterInteger2)
	MapModData.ITGSG = tab;
end)

LuaEvents.ITGSG_RequestTradeModifiers.Add(function(iPlayer)
	local tab = {};
	table.insert(tab, {"Exclusive Trade", "+25% [ICON_GOLD] Gold if no other Trade-Route reached this City in last 20 turns (half a bonus if there was only one such Trade-Route)."})
	if Players[iPlayer]:GetNumCities() > 1 then
		table.insert(tab, {"Number of Cities", "You gain -" .. math.min(50, 2 * (Players[iPlayer]:GetNumCities() - 1)) .. "% [ICON_GOLD] Gold."})
	end
	if gT.Players[iPlayer].TradeGoldModAcademies > 0 then
		table.insert(tab, {"Academies", "You gain +" .. gT.Players[iPlayer].TradeGoldModAcademies .. "% [ICON_GOLD] Gold."})
	end
	if (gT.Players[iPlayer].MintBonus or 0) > 0 then
		table.insert(tab, {"Currency Bonus", "You gain an extra [ICON_GOLD] Gold modifier from international trade-routes if your [ICON_INVEST] Currency Bonus is greater than rival's (the difference)."})
	end
	if gT.Players[iPlayer].HasIdeology[36] then
		table.insert(tab, {"Trade Funds Guarantee", "-10% [ICON_GOLD] Gold from your Trade-Routes."})
	end
	if gT.Players[iPlayer].CultBonusOn[65] then
		table.insert(tab, {"Voyagers", "You gain +33% [ICON_GOLD] Gold from your naval Trade-Routes."})
	end
	if gT.Players[iPlayer].CultBonusOn[54] then
		table.insert(tab, {"Trade Union", "You gain +30% [ICON_GOLD] Gold from your Trade-Routes to City-States."})
	end
	if HasPlayerTech(iPlayer, tInnoEuro3, "&1234124") then
		table.insert(tab, {"Volta do mar", "You gain +50% [ICON_GOLD] Gold from your Trade-Routes."})
	end
	if gT.Players[iPlayer].SubcultureType == 8 then
		table.insert(tab, {"Mercantile City-State", "You gain +20% [ICON_GOLD] Gold from Trade-Routes."})
	end
	for a, b in pairs(gT.CustomsHouses) do
		if b.Player == iPlayer then
			table.insert(tab, {"Customs House", "You gain +15% [ICON_GOLD] Gold from your Trade-Routes per active Customs House in origin City."})
			break;
		end
	end
	if gT.Globals.ScenarioType == 1 then
		table.insert(tab, {"New World", "+50% [ICON_GOLD] Gold from international Trade-Routes between different landmasses."})
	end
	table.insert(tab, {"Domestic", "-33% [ICON_GOLD] Gold from domestic Trade-Routes."})
	if gT.Players[iPlayer].HasIdeology[71] then
		table.insert(tab, {"Planned economy", "-33% [ICON_GOLD] Gold from domestic Trade-Routes."})
	end
	if HasPlayerTech(iPlayer, tribeInno17, "tribeInno17") then
		table.insert(tab, {"Advanced Jewellery", "You gain +15% [ICON_GOLD] Gold from international Trade-Routes."})
	end
	local iLawIncoming = 0;
	if IsHasLaw(iPlayer, 3, 1) then
		iLawIncoming = iLawIncoming + 0.25;
	elseif IsHasLaw(iPlayer, 3, 2) then
		iLawIncoming = iLawIncoming - 0.2;
	end
	if IsHasLaw(iPlayer, 18, 1) or IsHasLaw(iPlayer, 18, 2) then
		iLawIncoming = iLawIncoming - 0.25;
	end
	if iLawIncoming ~= 0 then
		iLawIncoming = iLawIncoming * 100;
		if iLawIncoming > 0 then
			iLawIncoming = "+" .. iLawIncoming;
		end
		table.insert(tab, {"Laws", "You gain " .. iLawIncoming .. "% [ICON_GOLD] Gold from incoming international Trade-Routes."})
	end
	if HasPlayerNatureWonder(iPlayer, GameInfoTypes.FEATURE_GIBRALTAR) then
		table.insert(tab, {"Gibraltar", "You gain +50% [ICON_GOLD] Gold from incoming international naval Trade-Routes."})
	end
	if HasPlayerTech(iPlayer, innotrial7asia, "%^T$3fr45") then
		table.insert(tab, {"Silk Road", "You gain +20% (up to 100%) [ICON_GOLD] Gold from your international Trade Routes for each previous Trade Route you have established with the target city."})
	end
	table.insert(tab, {"Embargos", "You gain -25% [ICON_GOLD] Gold from your international Trade-Routes for each embargo target player established on you."})
	MapModData.ITGSG = tab;
end)