local hXPBaseNewPromotionTreshold = {50, 150, 350, 750, 1550, 3150, 6300}
local terrac1 = GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_10;
local alhambra1 = GameInfoTypes.BUILDING_ITG_NEW_WORLD_WONDER_8;
local mTabRangeStrikeAppend = {}
local RangAtt = GameInfoTypes.MISSION_RANGE_ATTACK;
local IsMechanicalTab = {
[GameInfoTypes.UNITCOMBAT_BOMBER] = true,
[GameInfoTypes.UNITCOMBAT_CARRIER] = true,
[GameInfoTypes.UNITCOMBAT_FIGHTER] = true,
[GameInfoTypes.UNITCOMBAT_NAVALRANGED] = true,
[GameInfoTypes.UNITCOMBAT_NAVALMELEE] = true,
[GameInfoTypes.UNITCOMBAT_SUBMARINE] = true,
[GameInfoTypes.UNITCOMBAT_ARMOR] = true,
}

local PromotionTreesTypes = {
{
--1
[GameInfoTypes.PROMOTION_SHOCK_1] = {{}},
[GameInfoTypes.PROMOTION_SHOCK_2] = {{GameInfoTypes.PROMOTION_SHOCK_1}},
[GameInfoTypes.PROMOTION_SHOCK_3] = {{GameInfoTypes.PROMOTION_SHOCK_2}},
[GameInfoTypes.PROMOTION_DRILL_1] = {{}},
[GameInfoTypes.PROMOTION_DRILL_2] = {{GameInfoTypes.PROMOTION_DRILL_1}},
[GameInfoTypes.PROMOTION_DRILL_3] = {{GameInfoTypes.PROMOTION_DRILL_2}},
[GameInfoTypes.PROMOTION_SENTRY] = {{},1},
[GameInfoTypes.PROMOTION_MEDIC] = {{},2},
[GameInfoTypes.PROMOTION_MEDIC_II] = {{GameInfoTypes.PROMOTION_MEDIC}},
[GameInfoTypes.PROMOTION_FORMATION_1] = {{}, 2},
[GameInfoTypes.PROMOTION_FORMATION_2] = {{GameInfoTypes.PROMOTION_FORMATION_2}},
[GameInfoTypes.PROMOTION_COVER_1] = {{}, 2},
[GameInfoTypes.PROMOTION_COVER_2] = {{GameInfoTypes.PROMOTION_COVER_1}},
[GameInfoTypes.PROMOTION_MARCH] = {{}, 3, {GameInfoTypes.PROMOTION_BLITZ, GameInfoTypes.PROMOTION_WOODSMAN, GameInfoTypes.PROMOTION_SIEGE}},
[GameInfoTypes.PROMOTION_BLITZ] = {{}, 3, {GameInfoTypes.PROMOTION_MARCH}},
[GameInfoTypes.PROMOTION_WOODSMAN] = {{}, 3, {GameInfoTypes.PROMOTION_MARCH}},
[GameInfoTypes.PROMOTION_SIEGE] = {{}, 3, {GameInfoTypes.PROMOTION_MARCH}}
},
{
--2
[GameInfoTypes.PROMOTION_SHOCK_1] = {{}},
[GameInfoTypes.PROMOTION_SHOCK_2] = {{GameInfoTypes.PROMOTION_SHOCK_1}},
[GameInfoTypes.PROMOTION_SHOCK_3] = {{GameInfoTypes.PROMOTION_SHOCK_2}},
[GameInfoTypes.PROMOTION_DRILL_1] = {{}},
[GameInfoTypes.PROMOTION_DRILL_2] = {{GameInfoTypes.PROMOTION_DRILL_1}},
[GameInfoTypes.PROMOTION_DRILL_3] = {{GameInfoTypes.PROMOTION_DRILL_2}},
[GameInfoTypes.PROMOTION_SENTRY] = {{GameInfoTypes.PROMOTION_SHOCK_1, GameInfoTypes.PROMOTION_DRILL_1}},
[GameInfoTypes.PROMOTION_MEDIC] = {{GameInfoTypes.PROMOTION_SHOCK_2, GameInfoTypes.PROMOTION_DRILL_2}},
[GameInfoTypes.PROMOTION_MEDIC_II] = {{GameInfoTypes.PROMOTION_MEDIC}},
[GameInfoTypes.PROMOTION_CHARGE] = {{GameInfoTypes.PROMOTION_SHOCK_2, GameInfoTypes.PROMOTION_DRILL_2}},
[GameInfoTypes.PROMOTION_FORMATION_1] = {{GameInfoTypes.PROMOTION_SHOCK_2, GameInfoTypes.PROMOTION_DRILL_2}},
[GameInfoTypes.PROMOTION_FORMATION_2] = {{GameInfoTypes.PROMOTION_FORMATION_2}},
[GameInfoTypes.PROMOTION_MARCH] = {{}, 3, {GameInfoTypes.PROMOTION_BLITZ, GameInfoTypes.PROMOTION_MOBILITY}},
[GameInfoTypes.PROMOTION_MOBILITY] = {{}, 3, {GameInfoTypes.PROMOTION_MARCH}},
[GameInfoTypes.PROMOTION_BLITZ] = {{}, 3, {GameInfoTypes.PROMOTION_MARCH}},

},
{
--3
[GameInfoTypes.PROMOTION_COASTAL_RAIDER_1] = {{}},
[GameInfoTypes.PROMOTION_COASTAL_RAIDER_2] = {{GameInfoTypes.PROMOTION_COASTAL_RAIDER_1}},
[GameInfoTypes.PROMOTION_COASTAL_RAIDER_3] = {{GameInfoTypes.PROMOTION_COASTAL_RAIDER_2}},
[GameInfoTypes.PROMOTION_BOARDING_PARTY_1] = {{}},
[GameInfoTypes.PROMOTION_BOARDING_PARTY_2] = {{GameInfoTypes.PROMOTION_BOARDING_PARTY_1}},
[GameInfoTypes.PROMOTION_BOARDING_PARTY_3] = {{GameInfoTypes.PROMOTION_BOARDING_PARTY_2}},
[GameInfoTypes.PROMOTION_SENTRY] = {{}, 1},
[GameInfoTypes.PROMOTION_SUPPLY] = {{}, 2},
[GameInfoTypes.PROMOTION_MOBILITY] = {{},2},
}
,
{
--4  -- siege - replace logistic and range
[GameInfoTypes.PROMOTION_ACCURACY_1] = {{}},
[GameInfoTypes.PROMOTION_ACCURACY_2] = {{GameInfoTypes.PROMOTION_ACCURACY_1}},
[GameInfoTypes.PROMOTION_ACCURACY_3] = {{GameInfoTypes.PROMOTION_ACCURACY_2}},
[GameInfoTypes.PROMOTION_BARRAGE_1] = {{}},
[GameInfoTypes.PROMOTION_BARRAGE_2] = {{GameInfoTypes.PROMOTION_BARRAGE_1}},
[GameInfoTypes.PROMOTION_BARRAGE_3] = {{GameInfoTypes.PROMOTION_BARRAGE_2}},
[GameInfoTypes.PROMOTION_MARCH] = {{}, 3},
[GameInfoTypes.PROMOTION_ITG_DEFENSE_BREAK_CHANCE_I] = {{}, 3, {GameInfoTypes.PROMOTION_ITG_CHANCE_33_VS_CITY}},
[GameInfoTypes.PROMOTION_ITG_CHANCE_33_VS_CITY] = {{}, 3, {GameInfoTypes.PROMOTION_ITG_DEFENSE_BREAK_CHANCE_I}},
[GameInfoTypes.PROMOTION_COVER_1] = {{}, 2},
[GameInfoTypes.PROMOTION_COVER_2] = {{GameInfoTypes.PROMOTION_COVER_1}},
[GameInfoTypes.PROMOTION_VOLLEY] = {{}, 1},
},
{
--5
[GameInfoTypes.PROMOTION_ACCURACY_1] = {{}},
[GameInfoTypes.PROMOTION_ACCURACY_2] = {{GameInfoTypes.PROMOTION_ACCURACY_1}},
[GameInfoTypes.PROMOTION_ACCURACY_3] = {{GameInfoTypes.PROMOTION_ACCURACY_2}},
[GameInfoTypes.PROMOTION_BARRAGE_1] = {{}},
[GameInfoTypes.PROMOTION_BARRAGE_2] = {{GameInfoTypes.PROMOTION_BARRAGE_1}},
[GameInfoTypes.PROMOTION_BARRAGE_3] = {{GameInfoTypes.PROMOTION_BARRAGE_2}},
[GameInfoTypes.PROMOTION_MARCH] = {{}, 3, {GameInfoTypes.PROMOTION_RANGE, GameInfoTypes.PROMOTION_ITG_PRECISION}},
[GameInfoTypes.PROMOTION_ITG_PRECISION] = {{}, 3, {GameInfoTypes.PROMOTION_RANGE, GameInfoTypes.PROMOTION_MARCH}},
[GameInfoTypes.PROMOTION_RANGE] = {{}, 3, {GameInfoTypes.PROMOTION_MARCH, GameInfoTypes.PROMOTION_ITG_PRECISION}},
[GameInfoTypes.PROMOTION_COVER_1] = {{GameInfoTypes.PROMOTION_ACCURACY_2, GameInfoTypes.PROMOTION_BARRAGE_2}},
[GameInfoTypes.PROMOTION_COVER_2] = {{GameInfoTypes.PROMOTION_COVER_1}},
},
{
--6
[GameInfoTypes.PROMOTION_TARGETING_1] = {{}},
[GameInfoTypes.PROMOTION_TARGETING_2] = {{GameInfoTypes.PROMOTION_TARGETING_1}},
[GameInfoTypes.PROMOTION_TARGETING_3] = {{GameInfoTypes.PROMOTION_TARGETING_2}},
[GameInfoTypes.PROMOTION_BOMBARDMENT_1] = {{}},
[GameInfoTypes.PROMOTION_BOMBARDMENT_2] = {{GameInfoTypes.PROMOTION_BOMBARDMENT_1}},
[GameInfoTypes.PROMOTION_BOMBARDMENT_3] = {{GameInfoTypes.PROMOTION_BOMBARDMENT_2}},
[GameInfoTypes.PROMOTION_SENTRY] = {{GameInfoTypes.PROMOTION_TARGETING_1, GameInfoTypes.PROMOTION_BOMBARDMENT_1}},
[GameInfoTypes.PROMOTION_SUPPLY] = {{GameInfoTypes.PROMOTION_TARGETING_2, GameInfoTypes.PROMOTION_BOMBARDMENT_2}},
[GameInfoTypes.PROMOTION_MOBILITY] = {{GameInfoTypes.PROMOTION_TARGETING_1, GameInfoTypes.PROMOTION_BOMBARDMENT_1}},
[GameInfoTypes.PROMOTION_RANGE] = {{}, 3, {GameInfoTypes.PROMOTION_ITG_PRECISION, GameInfoTypes.PROMOTION_ITG_INDIRECT_FIRE}},
[GameInfoTypes.PROMOTION_ITG_PRECISION] = {{}, 3, {GameInfoTypes.PROMOTION_RANGE, GameInfoTypes.PROMOTION_ITG_INDIRECT_FIRE}},
[GameInfoTypes.PROMOTION_ITG_INDIRECT_FIRE] = {{}, 3, {GameInfoTypes.PROMOTION_ITG_PRECISION, GameInfoTypes.PROMOTION_RANGE}}
},
--7
{
},
{
--8
[GameInfoTypes.PROMOTION_SHOCK_1] = {{}},
[GameInfoTypes.PROMOTION_SHOCK_2] = {{GameInfoTypes.PROMOTION_SHOCK_1}},
[GameInfoTypes.PROMOTION_SHOCK_3] = {{GameInfoTypes.PROMOTION_SHOCK_2}},
[GameInfoTypes.PROMOTION_DRILL_1] = {{}},
[GameInfoTypes.PROMOTION_DRILL_2] = {{GameInfoTypes.PROMOTION_DRILL_1}},
[GameInfoTypes.PROMOTION_DRILL_3] = {{GameInfoTypes.PROMOTION_DRILL_2}},
[GameInfoTypes.PROMOTION_SENTRY] = {{GameInfoTypes.PROMOTION_SHOCK_1, GameInfoTypes.PROMOTION_DRILL_1}},
[GameInfoTypes.PROMOTION_CHARGE] = {{GameInfoTypes.PROMOTION_SHOCK_2, GameInfoTypes.PROMOTION_DRILL_2}},
[GameInfoTypes.PROMOTION_REPAIR] = {{}, 3, {GameInfoTypes.PROMOTION_BLITZ, GameInfoTypes.PROMOTION_MOBILITY}},
[GameInfoTypes.PROMOTION_MOBILITY] = {{}, 3, {GameInfoTypes.PROMOTION_REPAIR}},
[GameInfoTypes.PROMOTION_BLITZ] = {{}, 3, {GameInfoTypes.PROMOTION_REPAIR}},
},
--9 carrier
{
[GameInfoTypes.PROMOTION_FLIGHT_DECK_1] = {{}},
[GameInfoTypes.PROMOTION_FLIGHT_DECK_2] = {{GameInfoTypes.PROMOTION_FLIGHT_DECK_1}},
[GameInfoTypes.PROMOTION_FLIGHT_DECK_3] = {{GameInfoTypes.PROMOTION_FLIGHT_DECK_2}},
[GameInfoTypes.PROMOTION_SENTRY] = {{}},
[GameInfoTypes.PROMOTION_MOBILITY] = {{}, 3, {GameInfoTypes.PROMOTION_SUPPLY}},
[GameInfoTypes.PROMOTION_SUPPLY] = {{}, 3, {GameInfoTypes.PROMOTION_MOBILITY} },
[GameInfoTypes.PROMOTION_ARMOR_PLATING_1] = {{}},
[GameInfoTypes.PROMOTION_ARMOR_PLATING_2] = {{GameInfoTypes.PROMOTION_ARMOR_PLATING_1}},
[GameInfoTypes.PROMOTION_ARMOR_PLATING_3] = {{GameInfoTypes.PROMOTION_ARMOR_PLATING_2}},
},
--10 fighter
{
[GameInfoTypes.PROMOTION_INTERCEPTION_1] = {{}},
[GameInfoTypes.PROMOTION_INTERCEPTION_2] = {{GameInfoTypes.PROMOTION_INTERCEPTION_1}},
[GameInfoTypes.PROMOTION_INTERCEPTION_3] = {{GameInfoTypes.PROMOTION_INTERCEPTION_3}},
[GameInfoTypes.PROMOTION_AIR_TARGETING_1] = {{}},
[GameInfoTypes.PROMOTION_AIR_TARGETING_2] = {{GameInfoTypes.PROMOTION_AIR_TARGETING_1}},
[GameInfoTypes.PROMOTION_AIR_AMBUSH_1] = {{}},
[GameInfoTypes.PROMOTION_AIR_AMBUSH_2] = {{GameInfoTypes.PROMOTION_AIR_AMBUSH_1}},
[GameInfoTypes.PROMOTION_DOGFIGHTING_1] = {{}},
[GameInfoTypes.PROMOTION_DOGFIGHTING_2] = {{GameInfoTypes.PROMOTION_DOGFIGHTING_1}},
[GameInfoTypes.PROMOTION_DOGFIGHTING_3] = {{GameInfoTypes.PROMOTION_DOGFIGHTING_2}},
[GameInfoTypes.PROMOTION_AIR_REPAIR] = {{}, 3, {GameInfoTypes.PROMOTION_AIR_RANGE, GameInfoTypes.PROMOTION_SORTIE}},
[GameInfoTypes.PROMOTION_SORTIE] = {{}, 3, {GameInfoTypes.PROMOTION_AIR_RANGE, GameInfoTypes.PROMOTION_AIR_REPAIR}},
[GameInfoTypes.PROMOTION_AIR_RANGE] = {{}, 3, {GameInfoTypes.PROMOTION_SORTIE, GameInfoTypes.PROMOTION_AIR_REPAIR}},

},
--11 bomber
{
[GameInfoTypes.PROMOTION_AIR_SIEGE_1] = {{}},
[GameInfoTypes.PROMOTION_AIR_SIEGE_2] = {{GameInfoTypes.PROMOTION_AIR_SIEGE_1}},
[GameInfoTypes.PROMOTION_AIR_SIEGE_3] = {{GameInfoTypes.PROMOTION_AIR_SIEGE_2}},
[GameInfoTypes.PROMOTION_AIR_TARGETING_1] = {{}},
[GameInfoTypes.PROMOTION_AIR_TARGETING_2] = {{GameInfoTypes.PROMOTION_AIR_TARGETING_1}},
[GameInfoTypes.PROMOTION_AIR_AMBUSH_1] = {{}},
[GameInfoTypes.PROMOTION_AIR_AMBUSH_2] = {{GameInfoTypes.PROMOTION_AIR_AMBUSH_1}},
[GameInfoTypes.PROMOTION_AIR_BOMBARDMENT_1] = {{}},
[GameInfoTypes.PROMOTION_AIR_BOMBARDMENT_2] = {{GameInfoTypes.PROMOTION_AIR_BOMBARDMENT_1}},
[GameInfoTypes.PROMOTION_AIR_BOMBARDMENT_3] = {{GameInfoTypes.PROMOTION_AIR_BOMBARDMENT_2}},
[GameInfoTypes.PROMOTION_AIR_REPAIR] = {{}, 3, {GameInfoTypes.PROMOTION_EVASION, GameInfoTypes.PROMOTION_ITG_RELIABILITY}},
[GameInfoTypes.PROMOTION_ITG_RELIABILITY] = {{}, 3, {GameInfoTypes.PROMOTION_EVASION, GameInfoTypes.PROMOTION_AIR_REPAIR}},
[GameInfoTypes.PROMOTION_EVASION] = {{}, 3, {GameInfoTypes.PROMOTION_ITG_RELIABILITY, GameInfoTypes.PROMOTION_AIR_REPAIR}},
[GameInfoTypes.PROMOTION_AIR_RANGE] = {{}, 3},
},
{
--12 submarine
[GameInfoTypes.PROMOTION_TARGETING_1] = {{}},
[GameInfoTypes.PROMOTION_TARGETING_2] = {{GameInfoTypes.PROMOTION_TARGETING_1}},
[GameInfoTypes.PROMOTION_TARGETING_3] = {{GameInfoTypes.PROMOTION_TARGETING_2}},
[GameInfoTypes.PROMOTION_ITG_QUICK_SUBMERGE_I] = {{}},
[GameInfoTypes.PROMOTION_ITG_QUICK_SUBMERGE_II] = {{GameInfoTypes.PROMOTION_ITG_QUICK_SUBMERGE_I}},
[GameInfoTypes.PROMOTION_ITG_QUICK_SUBMERGE_III] = {{GameInfoTypes.PROMOTION_ITG_QUICK_SUBMERGE_II}},
[GameInfoTypes.PROMOTION_SENTRY] = {{GameInfoTypes.PROMOTION_TARGETING_1, GameInfoTypes.PROMOTION_ITG_QUICK_SUBMERGE_I}},
[GameInfoTypes.PROMOTION_SUPPLY] = {{GameInfoTypes.PROMOTION_TARGETING_2, GameInfoTypes.PROMOTION_ITG_QUICK_SUBMERGE_II}},
[GameInfoTypes.PROMOTION_MOBILITY] = {{GameInfoTypes.PROMOTION_TARGETING_1, GameInfoTypes.PROMOTION_ITG_QUICK_SUBMERGE_I}},
[GameInfoTypes.PROMOTION_RANGE] = {{}, 3, {GameInfoTypes.PROMOTION_ITG_PRECISION, GameInfoTypes.PROMOTION_ITG_SUB_STEER_LOCKED}},
[GameInfoTypes.PROMOTION_ITG_PRECISION] = {{}, 3, {GameInfoTypes.PROMOTION_RANGE, GameInfoTypes.PROMOTION_ITG_SUB_STEER_LOCKED}},
[GameInfoTypes.PROMOTION_ITG_SUB_STEER_LOCKED] = {{}, 3, {GameInfoTypes.PROMOTION_ITG_PRECISION, GameInfoTypes.PROMOTION_RANGE}}
},
{
--13  modern infantry without AMBUSH
[GameInfoTypes.PROMOTION_SHOCK_1] = {{}},
[GameInfoTypes.PROMOTION_SHOCK_2] = {{GameInfoTypes.PROMOTION_SHOCK_1}},
[GameInfoTypes.PROMOTION_SHOCK_3] = {{GameInfoTypes.PROMOTION_SHOCK_2}},
[GameInfoTypes.PROMOTION_DRILL_1] = {{}},
[GameInfoTypes.PROMOTION_DRILL_2] = {{GameInfoTypes.PROMOTION_DRILL_1}},
[GameInfoTypes.PROMOTION_DRILL_3] = {{GameInfoTypes.PROMOTION_DRILL_2}},
[GameInfoTypes.PROMOTION_SENTRY] = {{},1},
[GameInfoTypes.PROMOTION_MEDIC] = {{},2},
[GameInfoTypes.PROMOTION_MEDIC_II] = {{GameInfoTypes.PROMOTION_MEDIC}},
[GameInfoTypes.PROMOTION_AMBUSH_1] = {{}, 2},
[GameInfoTypes.PROMOTION_AMBUSH_2] = {{GameInfoTypes.PROMOTION_AMBUSH_2}},
[GameInfoTypes.PROMOTION_COVER_1] = {{}, 2},
[GameInfoTypes.PROMOTION_COVER_2] = {{GameInfoTypes.PROMOTION_COVER_1}},
[GameInfoTypes.PROMOTION_MARCH] = {{}, 3, {GameInfoTypes.PROMOTION_BLITZ, GameInfoTypes.PROMOTION_WOODSMAN, GameInfoTypes.PROMOTION_SIEGE}},
[GameInfoTypes.PROMOTION_BLITZ] = {{}, 3, {GameInfoTypes.PROMOTION_MARCH}},
[GameInfoTypes.PROMOTION_WOODSMAN] = {{}, 3, {GameInfoTypes.PROMOTION_MARCH}},
[GameInfoTypes.PROMOTION_SIEGE] = {{}, 3, {GameInfoTypes.PROMOTION_MARCH}}
},
{
--14 // battleship // naval ranged with base indirect fire //
[GameInfoTypes.PROMOTION_TARGETING_1] = {{}},
[GameInfoTypes.PROMOTION_TARGETING_2] = {{GameInfoTypes.PROMOTION_TARGETING_1}},
[GameInfoTypes.PROMOTION_TARGETING_3] = {{GameInfoTypes.PROMOTION_TARGETING_2}},
[GameInfoTypes.PROMOTION_BOMBARDMENT_1] = {{}},
[GameInfoTypes.PROMOTION_BOMBARDMENT_2] = {{GameInfoTypes.PROMOTION_BOMBARDMENT_1}},
[GameInfoTypes.PROMOTION_BOMBARDMENT_3] = {{GameInfoTypes.PROMOTION_BOMBARDMENT_2}},
[GameInfoTypes.PROMOTION_SENTRY] = {{GameInfoTypes.PROMOTION_TARGETING_1, GameInfoTypes.PROMOTION_BOMBARDMENT_1}},
[GameInfoTypes.PROMOTION_SUPPLY] = {{GameInfoTypes.PROMOTION_TARGETING_2, GameInfoTypes.PROMOTION_BOMBARDMENT_2}},
[GameInfoTypes.PROMOTION_MOBILITY] = {{GameInfoTypes.PROMOTION_TARGETING_1, GameInfoTypes.PROMOTION_BOMBARDMENT_1}},
[GameInfoTypes.PROMOTION_RANGE] = {{}, 3, {GameInfoTypes.PROMOTION_ITG_PRECISION, GameInfoTypes.PROMOTION_ITG_BATTLESHIP_MAX_HP}},
[GameInfoTypes.PROMOTION_ITG_PRECISION] = {{}, 3, {GameInfoTypes.PROMOTION_RANGE, GameInfoTypes.PROMOTION_ITG_BATTLESHIP_MAX_HP}},
[GameInfoTypes.PROMOTION_ITG_BATTLESHIP_MAX_HP] = {{}, 3, {GameInfoTypes.PROMOTION_ITG_PRECISION, GameInfoTypes.PROMOTION_RANGE}}
},
}

local UnitClassPromotionTree = {
[GameInfoTypes.UNITCLASS_ARCHER] = 5,
[GameInfoTypes.UNITCLASS_WARRIOR] = 1,
[GameInfoTypes.UNITCLASS_SPEARMAN] = 1,
[GameInfoTypes.UNITCLASS_PIKEMAN] = 1,
[GameInfoTypes.UNITCLASS_ITG_NW_TERCIO] = 1,
[GameInfoTypes.UNITCLASS_LONGSWORDSMAN] = 1,
[GameInfoTypes.UNITCLASS_MUSKETMAN] = 1,
[GameInfoTypes.UNITCLASS_KNIGHT] = 2,
[GameInfoTypes.UNITCLASS_LANCER] = 2,
[GameInfoTypes.UNITCLASS_CARAVEL] = 3,
[GameInfoTypes.UNITCLASS_TRIREME] = 3,
[GameInfoTypes.UNITCLASS_FRIGATE] = 6,
[GameInfoTypes.UNITCLASS_TREBUCHET] = 4,
[GameInfoTypes.UNITCLASS_CANNON] = 4,
[GameInfoTypes.UNITCLASS_COMPOSITE_BOWMAN] = 5,
[GameInfoTypes.UNITCLASS_CROSSBOWMAN] = 5,
[GameInfoTypes.UNITCLASS_GALLEASS] = 6,
[GameInfoTypes.UNITCLASS_CATAPULT] = 4,
[GameInfoTypes.UNITCLASS_HORSEMAN] = 2,
[GameInfoTypes.UNITCLASS_PRIVATEER] = 3,
[GameInfoTypes.UNITCLASS_CHARIOT_ARCHER] = 5,
[GameInfoTypes.UNITCLASS_SWORDSMAN] = 1,
[GameInfoTypes.UNITCLASS_ITG_SIEGE_TOWER] = 7,
[GameInfoTypes.UNITCLASS_ITG_BATTERING_RAM] = 7,
[GameInfoTypes.UNITCLASS_ITG_GRAND_GALLEAS] = 6,
[GameInfoTypes.UNITCLASS_ITG_GRAND_GALLEAS_MELEE] = 3,
[GameInfoTypes.UNITCLASS_CAVALRY] = 2,
[GameInfoTypes.UNITCLASS_RIFLEMAN] = 1,
[GameInfoTypes.UNITCLASS_ARTILLERY] = 4,
[GameInfoTypes.UNITCLASS_IRONCLAD] = 3,
[GameInfoTypes.UNITCLASS_GATLINGGUN] = 5,
[GameInfoTypes.UNITCLASS_ITG_IND_SOTL] = 6,
[GameInfoTypes.UNITCLASS_ITG_IND_CUIRASS] = 2,
[GameInfoTypes.UNITCLASS_ITG_IND_CANNON_1] = 4,
[GameInfoTypes.UNITCLASS_ITG_IND_CANNON_2] = 4,
[GameInfoTypes.UNITCLASS_INFANTRY] = 13,
[GameInfoTypes.UNITCLASS_TANK] = 8,
[GameInfoTypes.UNITCLASS_PARATROOPER] = 13,
[GameInfoTypes.UNITCLASS_BOMBER] = 11,
[GameInfoTypes.UNITCLASS_FIGHTER] = 10,
[GameInfoTypes.UNITCLASS_CARRIER] = 9,
[GameInfoTypes.UNITCLASS_ANTI_AIRCRAFT_GUN] = 13,
[GameInfoTypes.UNITCLASS_ANTI_TANK_GUN] = 13,
[GameInfoTypes.UNITCLASS_DESTROYER] = 3,
[GameInfoTypes.UNITCLASS_SUBMARINE] = 12,
[GameInfoTypes.UNITCLASS_BATTLESHIP] = 14,
[GameInfoTypes.UNITCLASS_ROCKET_ARTILLERY] = 4,
[GameInfoTypes.UNITCLASS_MARINE] = 13,
[GameInfoTypes.UNITCLASS_WWI_TANK] = 8,
[GameInfoTypes.UNITCLASS_MACHINE_GUN] = 5,
[GameInfoTypes.UNITCLASS_BAZOOKA] = 5,
[GameInfoTypes.UNITCLASS_ROCKET_ARTILLERY] = 4, 
[GameInfoTypes.UNITCLASS_GREAT_WAR_INFANTRY] = 13,
[GameInfoTypes.UNITCLASS_MECHANIZED_INFANTRY] = 1, --TBD
[GameInfoTypes.UNITCLASS_MOBILE_SAM] = 1, --TBD
[GameInfoTypes.UNITCLASS_HELICOPTER_GUNSHIP] = 1, --TBD
[GameInfoTypes.UNITCLASS_TRIPLANE] = 1, --TBD
[GameInfoTypes.UNITCLASS_WWI_BOMBER] = 1, --TBD
}

local TypesAIPromotionProgress = {
--1
{{GameInfoTypes.PROMOTION_SHOCK_1, GameInfoTypes.PROMOTION_DRILL_1, GameInfoTypes.PROMOTION_COVER_1, GameInfoTypes.PROMOTION_MARCH, GameInfoTypes.PROMOTION_COVER_2},
{GameInfoTypes.PROMOTION_SHOCK_1, GameInfoTypes.PROMOTION_DRILL_1, GameInfoTypes.PROMOTION_MEDIC, GameInfoTypes.PROMOTION_MARCH, GameInfoTypes.PROMOTION_MEDIC_II},
{GameInfoTypes.PROMOTION_SHOCK_1, GameInfoTypes.PROMOTION_DRILL_1, GameInfoTypes.PROMOTION_FORMATION_1, GameInfoTypes.PROMOTION_MARCH, GameInfoTypes.PROMOTION_FORMATION_2},
{GameInfoTypes.PROMOTION_DRILL_1, GameInfoTypes.PROMOTION_SHOCK_1, GameInfoTypes.PROMOTION_COVER_1, GameInfoTypes.PROMOTION_BLITZ, GameInfoTypes.PROMOTION_SIEGE},
{GameInfoTypes.PROMOTION_DRILL_1, GameInfoTypes.PROMOTION_SENTRY, GameInfoTypes.PROMOTION_COVER_1, GameInfoTypes.PROMOTION_WOODSMAN, GameInfoTypes.PROMOTION_BLITZ},
{GameInfoTypes.PROMOTION_SHOCK_1, GameInfoTypes.PROMOTION_SHOCK_2, GameInfoTypes.PROMOTION_SHOCK_3, GameInfoTypes.PROMOTION_MARCH, GameInfoTypes.PROMOTION_COVER_1},
{GameInfoTypes.PROMOTION_SHOCK_1, GameInfoTypes.PROMOTION_SHOCK_2, GameInfoTypes.PROMOTION_SHOCK_3, GameInfoTypes.PROMOTION_BLITZ, GameInfoTypes.PROMOTION_SIEGE},
{GameInfoTypes.PROMOTION_DRILL_1, GameInfoTypes.PROMOTION_DRILL_2, GameInfoTypes.PROMOTION_DRILL_3, GameInfoTypes.PROMOTION_WOODSMAN, GameInfoTypes.PROMOTION_BLITZ},
{GameInfoTypes.PROMOTION_SHOCK_1, GameInfoTypes.PROMOTION_SENTRY, GameInfoTypes.PROMOTION_COVER_1, GameInfoTypes.PROMOTION_MARCH, GameInfoTypes.PROMOTION_MEDIC},
{GameInfoTypes.PROMOTION_SHOCK_1, GameInfoTypes.PROMOTION_SHOCK_2, GameInfoTypes.PROMOTION_COVER_1, GameInfoTypes.PROMOTION_MARCH, GameInfoTypes.PROMOTION_SHOCK_3}},
--2
{{GameInfoTypes.PROMOTION_SHOCK_1, GameInfoTypes.PROMOTION_DRILL_1, GameInfoTypes.PROMOTION_CHARGE, GameInfoTypes.PROMOTION_MARCH, GameInfoTypes.PROMOTION_SENTRY},
{GameInfoTypes.PROMOTION_SHOCK_1, GameInfoTypes.PROMOTION_DRILL_1, GameInfoTypes.PROMOTION_MEDIC, GameInfoTypes.PROMOTION_MARCH, GameInfoTypes.PROMOTION_MEDIC_II},
{GameInfoTypes.PROMOTION_SHOCK_1, GameInfoTypes.PROMOTION_DRILL_1, GameInfoTypes.PROMOTION_FORMATION_1, GameInfoTypes.PROMOTION_MARCH, GameInfoTypes.PROMOTION_FORMATION_2},
{GameInfoTypes.PROMOTION_DRILL_1, GameInfoTypes.PROMOTION_SHOCK_1, GameInfoTypes.PROMOTION_CHARGE, GameInfoTypes.PROMOTION_BLITZ, GameInfoTypes.PROMOTION_MOBILITY},
{GameInfoTypes.PROMOTION_DRILL_1, GameInfoTypes.PROMOTION_SENTRY, GameInfoTypes.PROMOTION_CHARGE, GameInfoTypes.PROMOTION_MOBILITY, GameInfoTypes.PROMOTION_BLITZ},
{GameInfoTypes.PROMOTION_SHOCK_1, GameInfoTypes.PROMOTION_SHOCK_2, GameInfoTypes.PROMOTION_SHOCK_3, GameInfoTypes.PROMOTION_MARCH, GameInfoTypes.PROMOTION_CHARGE},
{GameInfoTypes.PROMOTION_SHOCK_1, GameInfoTypes.PROMOTION_SHOCK_2, GameInfoTypes.PROMOTION_SHOCK_3, GameInfoTypes.PROMOTION_BLITZ, GameInfoTypes.PROMOTION_MOBILITY},
{GameInfoTypes.PROMOTION_DRILL_1, GameInfoTypes.PROMOTION_DRILL_2, GameInfoTypes.PROMOTION_DRILL_3, GameInfoTypes.PROMOTION_MOBILITY, GameInfoTypes.PROMOTION_BLITZ},
{GameInfoTypes.PROMOTION_SHOCK_1, GameInfoTypes.PROMOTION_SENTRY, GameInfoTypes.PROMOTION_CHARGE, GameInfoTypes.PROMOTION_MARCH, GameInfoTypes.PROMOTION_MEDIC},
{GameInfoTypes.PROMOTION_SHOCK_1, GameInfoTypes.PROMOTION_SHOCK_2, GameInfoTypes.PROMOTION_CHARGE, GameInfoTypes.PROMOTION_MARCH, GameInfoTypes.PROMOTION_SHOCK_3}},
--3
{
{GameInfoTypes.PROMOTION_COASTAL_RAIDER_1, GameInfoTypes.PROMOTION_MOBILITY, GameInfoTypes.PROMOTION_SUPPLY, GameInfoTypes.PROMOTION_COASTAL_RAIDER_2, GameInfoTypes.PROMOTION_COASTAL_RAIDER_3},
{GameInfoTypes.PROMOTION_BOARDING_PARTY_1, GameInfoTypes.PROMOTION_MOBILITY, GameInfoTypes.PROMOTION_SUPPLY, GameInfoTypes.PROMOTION_BOARDING_PARTY_2, GameInfoTypes.PROMOTION_BOARDING_PARTY_3},
{GameInfoTypes.PROMOTION_COASTAL_RAIDER_1, GameInfoTypes.PROMOTION_MOBILITY, GameInfoTypes.PROMOTION_SUPPLY, GameInfoTypes.PROMOTION_SENTRY, GameInfoTypes.PROMOTION_COASTAL_RAIDER_2},
{GameInfoTypes.PROMOTION_BOARDING_PARTY_1, GameInfoTypes.PROMOTION_MOBILITY, GameInfoTypes.PROMOTION_SUPPLY, GameInfoTypes.PROMOTION_SENTRY, GameInfoTypes.PROMOTION_BOARDING_PARTY_2}},
--4
{
{GameInfoTypes.PROMOTION_ACCURACY_1, GameInfoTypes.PROMOTION_ACCURACY_2, GameInfoTypes.PROMOTION_ACCURACY_3, GameInfoTypes.PROMOTION_ITG_DEFENSE_BREAK_CHANCE_I, GameInfoTypes.PROMOTION_VOLLEY},
{GameInfoTypes.PROMOTION_BARRAGE_1, GameInfoTypes.PROMOTION_BARRAGE_2, GameInfoTypes.PROMOTION_BARRAGE_3, GameInfoTypes.PROMOTION_ITG_CHANCE_33_VS_CITY, GameInfoTypes.PROMOTION_VOLLEY},
{GameInfoTypes.PROMOTION_ACCURACY_1, GameInfoTypes.PROMOTION_ACCURACY_2, GameInfoTypes.PROMOTION_ACCURACY_3, GameInfoTypes.PROMOTION_ITG_DEFENSE_BREAK_CHANCE_I, GameInfoTypes.PROMOTION_VOLLEY},
{GameInfoTypes.PROMOTION_BARRAGE_1, GameInfoTypes.PROMOTION_BARRAGE_2, GameInfoTypes.PROMOTION_BARRAGE_3, GameInfoTypes.PROMOTION_ITG_DEFENSE_BREAK_CHANCE_I, GameInfoTypes.PROMOTION_VOLLEY},
{GameInfoTypes.PROMOTION_ACCURACY_1, GameInfoTypes.PROMOTION_ACCURACY_2, GameInfoTypes.PROMOTION_COVER_1, GameInfoTypes.PROMOTION_ITG_DEFENSE_BREAK_CHANCE_I, GameInfoTypes.PROMOTION_COVER_2},
{GameInfoTypes.PROMOTION_ACCURACY_1, GameInfoTypes.PROMOTION_BARRAGE_1, GameInfoTypes.PROMOTION_VOLLEY, GameInfoTypes.PROMOTION_ITG_CHANCE_33_VS_CITY, GameInfoTypes.PROMOTION_BARRAGE_2},
{GameInfoTypes.PROMOTION_ACCURACY_1, GameInfoTypes.PROMOTION_ACCURACY_2, GameInfoTypes.PROMOTION_ACCURACY_3, GameInfoTypes.PROMOTION_MARCH, GameInfoTypes.PROMOTION_VOLLEY},
{GameInfoTypes.PROMOTION_BARRAGE_1, GameInfoTypes.PROMOTION_BARRAGE_2, GameInfoTypes.PROMOTION_BARRAGE_3, GameInfoTypes.PROMOTION_MARCH, GameInfoTypes.PROMOTION_VOLLEY},
{GameInfoTypes.PROMOTION_ACCURACY_1, GameInfoTypes.PROMOTION_ACCURACY_2, GameInfoTypes.PROMOTION_ACCURACY_3, GameInfoTypes.PROMOTION_ITG_DEFENSE_BREAK_CHANCE_I, GameInfoTypes.PROMOTION_BARRAGE_1},
{GameInfoTypes.PROMOTION_ACCURACY_1, GameInfoTypes.PROMOTION_ACCURACY_2, GameInfoTypes.PROMOTION_ACCURACY_3, GameInfoTypes.PROMOTION_ITG_CHANCE_33_VS_CITY, GameInfoTypes.PROMOTION_BARRAGE_1}},
--5
{
{GameInfoTypes.PROMOTION_ACCURACY_1, GameInfoTypes.PROMOTION_ACCURACY_2, GameInfoTypes.PROMOTION_ACCURACY_3, GameInfoTypes.PROMOTION_ITG_PRECISION, GameInfoTypes.PROMOTION_BARRAGE_1},
{GameInfoTypes.PROMOTION_BARRAGE_1, GameInfoTypes.PROMOTION_BARRAGE_2, GameInfoTypes.PROMOTION_BARRAGE_3, GameInfoTypes.PROMOTION_RANGE, GameInfoTypes.PROMOTION_ACCURACY_1},
{GameInfoTypes.PROMOTION_ACCURACY_1, GameInfoTypes.PROMOTION_ACCURACY_2, GameInfoTypes.PROMOTION_ACCURACY_3, GameInfoTypes.PROMOTION_ITG_PRECISION, GameInfoTypes.PROMOTION_BARRAGE_1},
{GameInfoTypes.PROMOTION_BARRAGE_1, GameInfoTypes.PROMOTION_BARRAGE_2, GameInfoTypes.PROMOTION_BARRAGE_3, GameInfoTypes.PROMOTION_ITG_PRECISION, GameInfoTypes.PROMOTION_ACCURACY_1},
{GameInfoTypes.PROMOTION_ACCURACY_1, GameInfoTypes.PROMOTION_ACCURACY_2, GameInfoTypes.PROMOTION_COVER_1, GameInfoTypes.PROMOTION_ITG_PRECISION, GameInfoTypes.PROMOTION_COVER_2},
{GameInfoTypes.PROMOTION_ACCURACY_1, GameInfoTypes.PROMOTION_BARRAGE_1, GameInfoTypes.PROMOTION_BARRAGE_2, GameInfoTypes.PROMOTION_RANGE, GameInfoTypes.PROMOTION_BARRAGE_3},
{GameInfoTypes.PROMOTION_ACCURACY_1, GameInfoTypes.PROMOTION_ACCURACY_2, GameInfoTypes.PROMOTION_ACCURACY_3, GameInfoTypes.PROMOTION_MARCH, GameInfoTypes.PROMOTION_COVER_1},
{GameInfoTypes.PROMOTION_BARRAGE_1, GameInfoTypes.PROMOTION_BARRAGE_2, GameInfoTypes.PROMOTION_BARRAGE_3, GameInfoTypes.PROMOTION_MARCH, GameInfoTypes.PROMOTION_COVER_1},
{GameInfoTypes.PROMOTION_ACCURACY_1, GameInfoTypes.PROMOTION_ACCURACY_2, GameInfoTypes.PROMOTION_ACCURACY_3, GameInfoTypes.PROMOTION_ITG_PRECISION, GameInfoTypes.PROMOTION_BARRAGE_1},
{GameInfoTypes.PROMOTION_ACCURACY_1, GameInfoTypes.PROMOTION_ACCURACY_2, GameInfoTypes.PROMOTION_ACCURACY_3, GameInfoTypes.PROMOTION_RANGE, GameInfoTypes.PROMOTION_BARRAGE_1}},
--6
{
{GameInfoTypes.PROMOTION_TARGETING_1, GameInfoTypes.PROMOTION_TARGETING_2, GameInfoTypes.PROMOTION_TARGETING_3, GameInfoTypes.PROMOTION_ITG_PRECISION, GameInfoTypes.PROMOTION_BOMBARDMENT_1},
{GameInfoTypes.PROMOTION_BOMBARDMENT_1, GameInfoTypes.PROMOTION_BOMBARDMENT_2, GameInfoTypes.PROMOTION_BOMBARDMENT_3, GameInfoTypes.PROMOTION_RANGE, GameInfoTypes.PROMOTION_TARGETING_1},
{GameInfoTypes.PROMOTION_TARGETING_1, GameInfoTypes.PROMOTION_TARGETING_2, GameInfoTypes.PROMOTION_TARGETING_3, GameInfoTypes.PROMOTION_ITG_PRECISION, GameInfoTypes.PROMOTION_SUPPLY},
{GameInfoTypes.PROMOTION_BOMBARDMENT_1, GameInfoTypes.PROMOTION_BOMBARDMENT_2, GameInfoTypes.PROMOTION_MOBILITY, GameInfoTypes.PROMOTION_ITG_PRECISION, GameInfoTypes.PROMOTION_SUPPLY},
{GameInfoTypes.PROMOTION_TARGETING_1, GameInfoTypes.PROMOTION_TARGETING_2, GameInfoTypes.PROMOTION_SENTRY, GameInfoTypes.PROMOTION_ITG_PRECISION, GameInfoTypes.PROMOTION_SUPPLY},
{GameInfoTypes.PROMOTION_TARGETING_1, GameInfoTypes.PROMOTION_BOMBARDMENT_1, GameInfoTypes.PROMOTION_BOMBARDMENT_2, GameInfoTypes.PROMOTION_RANGE, GameInfoTypes.PROMOTION_SUPPLY},
{GameInfoTypes.PROMOTION_TARGETING_1, GameInfoTypes.PROMOTION_TARGETING_2, GameInfoTypes.PROMOTION_TARGETING_3, GameInfoTypes.PROMOTION_RANGE, GameInfoTypes.PROMOTION_SENTRY},
{GameInfoTypes.PROMOTION_BOMBARDMENT_1, GameInfoTypes.PROMOTION_BOMBARDMENT_2, GameInfoTypes.PROMOTION_BOMBARDMENT_3, GameInfoTypes.PROMOTION_RANGE, GameInfoTypes.PROMOTION_SENTRY},
{GameInfoTypes.PROMOTION_TARGETING_1, GameInfoTypes.PROMOTION_TARGETING_2, GameInfoTypes.PROMOTION_MOBILITY, GameInfoTypes.PROMOTION_ITG_PRECISION, GameInfoTypes.PROMOTION_SUPPLY},
{GameInfoTypes.PROMOTION_TARGETING_1, GameInfoTypes.PROMOTION_TARGETING_2, GameInfoTypes.PROMOTION_TARGETING_3, GameInfoTypes.PROMOTION_RANGE, GameInfoTypes.PROMOTION_SUPPLY},
{GameInfoTypes.PROMOTION_TARGETING_1, GameInfoTypes.PROMOTION_TARGETING_2, GameInfoTypes.PROMOTION_TARGETING_3, GameInfoTypes.PROMOTION_ITG_INDIRECT_FIRE, GameInfoTypes.PROMOTION_SUPPLY},
{GameInfoTypes.PROMOTION_TARGETING_1, GameInfoTypes.PROMOTION_BOMBARDMENT_1, GameInfoTypes.PROMOTION_BOMBARDMENT_2, GameInfoTypes.PROMOTION_ITG_INDIRECT_FIRE, GameInfoTypes.PROMOTION_SUPPLY},
{GameInfoTypes.PROMOTION_TARGETING_1, GameInfoTypes.PROMOTION_TARGETING_2, GameInfoTypes.PROMOTION_TARGETING_3, GameInfoTypes.PROMOTION_ITG_INDIRECT_FIRE, GameInfoTypes.PROMOTION_SENTRY},
{GameInfoTypes.PROMOTION_BOMBARDMENT_1, GameInfoTypes.PROMOTION_BOMBARDMENT_2, GameInfoTypes.PROMOTION_BOMBARDMENT_3, GameInfoTypes.PROMOTION_ITG_INDIRECT_FIRE, GameInfoTypes.PROMOTION_TARGETING_1}
},
--7 right now it is not being used (melee siege into supportive promotions)
{
},
--8
{{GameInfoTypes.PROMOTION_SHOCK_1, GameInfoTypes.PROMOTION_DRILL_1, GameInfoTypes.PROMOTION_CHARGE, GameInfoTypes.PROMOTION_REPAIR, GameInfoTypes.PROMOTION_SENTRY},
{GameInfoTypes.PROMOTION_DRILL_1, GameInfoTypes.PROMOTION_SHOCK_1, GameInfoTypes.PROMOTION_CHARGE, GameInfoTypes.PROMOTION_BLITZ, GameInfoTypes.PROMOTION_MOBILITY},
{GameInfoTypes.PROMOTION_DRILL_1, GameInfoTypes.PROMOTION_SENTRY, GameInfoTypes.PROMOTION_CHARGE, GameInfoTypes.PROMOTION_MOBILITY, GameInfoTypes.PROMOTION_BLITZ},
{GameInfoTypes.PROMOTION_SHOCK_1, GameInfoTypes.PROMOTION_SHOCK_2, GameInfoTypes.PROMOTION_SHOCK_3, GameInfoTypes.PROMOTION_REPAIR, GameInfoTypes.PROMOTION_CHARGE},
{GameInfoTypes.PROMOTION_SHOCK_1, GameInfoTypes.PROMOTION_SHOCK_2, GameInfoTypes.PROMOTION_SHOCK_3, GameInfoTypes.PROMOTION_BLITZ, GameInfoTypes.PROMOTION_MOBILITY},
{GameInfoTypes.PROMOTION_DRILL_1, GameInfoTypes.PROMOTION_DRILL_2, GameInfoTypes.PROMOTION_DRILL_3, GameInfoTypes.PROMOTION_MOBILITY, GameInfoTypes.PROMOTION_BLITZ},
{GameInfoTypes.PROMOTION_SHOCK_1, GameInfoTypes.PROMOTION_SHOCK_2, GameInfoTypes.PROMOTION_CHARGE, GameInfoTypes.PROMOTION_REPAIR, GameInfoTypes.PROMOTION_SHOCK_3}},
--9
{
{GameInfoTypes.PROMOTION_FLIGHT_DECK_1, GameInfoTypes.PROMOTION_FLIGHT_DECK_2, GameInfoTypes.PROMOTION_FLIGHT_DECK_3, GameInfoTypes.PROMOTION_SUPPLY, GameInfoTypes.PROMOTION_SENTRY},
{GameInfoTypes.PROMOTION_FLIGHT_DECK_1, GameInfoTypes.PROMOTION_FLIGHT_DECK_2, GameInfoTypes.PROMOTION_FLIGHT_DECK_3, GameInfoTypes.PROMOTION_MOBILITY, GameInfoTypes.PROMOTION_SENTRY},
{GameInfoTypes.PROMOTION_ARMOR_PLATING_1, GameInfoTypes.PROMOTION_ARMOR_PLATING_2, GameInfoTypes.PROMOTION_ARMOR_PLATING_3, GameInfoTypes.PROMOTION_SUPPLY, GameInfoTypes.PROMOTION_SENTRY},
{GameInfoTypes.PROMOTION_ARMOR_PLATING_1, GameInfoTypes.PROMOTION_ARMOR_PLATING_2, GameInfoTypes.PROMOTION_ARMOR_PLATING_3, GameInfoTypes.PROMOTION_MOBILITY, GameInfoTypes.PROMOTION_SENTRY},
{GameInfoTypes.PROMOTION_FLIGHT_DECK_1, GameInfoTypes.PROMOTION_SENTRY, GameInfoTypes.PROMOTION_FLIGHT_DECK_2, GameInfoTypes.PROMOTION_SUPPLY, GameInfoTypes.PROMOTION_FLIGHT_DECK_3},
{GameInfoTypes.PROMOTION_FLIGHT_DECK_1, GameInfoTypes.PROMOTION_SENTRY, GameInfoTypes.PROMOTION_FLIGHT_DECK_2, GameInfoTypes.PROMOTION_MOBILITY, GameInfoTypes.PROMOTION_FLIGHT_DECK_3},
{GameInfoTypes.PROMOTION_ARMOR_PLATING_1, GameInfoTypes.PROMOTION_SENTRY, GameInfoTypes.PROMOTION_ARMOR_PLATING_2, GameInfoTypes.PROMOTION_SUPPLY, GameInfoTypes.PROMOTION_ARMOR_PLATING_3},
{GameInfoTypes.PROMOTION_ARMOR_PLATING_1, GameInfoTypes.PROMOTION_SENTRY, GameInfoTypes.PROMOTION_ARMOR_PLATING_2, GameInfoTypes.PROMOTION_MOBILITY, GameInfoTypes.PROMOTION_ARMOR_PLATING_3},

},
--10
{
{GameInfoTypes.PROMOTION_INTERCEPTION_1, GameInfoTypes.PROMOTION_INTERCEPTION_2, GameInfoTypes.PROMOTION_INTERCEPTION_3, GameInfoTypes.PROMOTION_AIR_REPAIR, GameInfoTypes.PROMOTION_AIR_AMBUSH_1},
{GameInfoTypes.PROMOTION_INTERCEPTION_1, GameInfoTypes.PROMOTION_INTERCEPTION_2, GameInfoTypes.PROMOTION_INTERCEPTION_3, GameInfoTypes.PROMOTION_SORTIE, GameInfoTypes.PROMOTION_AIR_AMBUSH_1},
{GameInfoTypes.PROMOTION_DOGFIGHTING_1, GameInfoTypes.PROMOTION_DOGFIGHTING_2, GameInfoTypes.PROMOTION_DOGFIGHTING_3, GameInfoTypes.PROMOTION_AIR_REPAIR, GameInfoTypes.PROMOTION_AIR_AMBUSH_1},
{GameInfoTypes.PROMOTION_DOGFIGHTING_1, GameInfoTypes.PROMOTION_DOGFIGHTING_2, GameInfoTypes.PROMOTION_DOGFIGHTING_3, GameInfoTypes.PROMOTION_AIR_REPAIR, GameInfoTypes.PROMOTION_AIR_TARGETING_1},
{GameInfoTypes.PROMOTION_AIR_AMBUSH_1, GameInfoTypes.PROMOTION_AIR_TARGETING_1, GameInfoTypes.PROMOTION_AIR_AMBUSH_2, GameInfoTypes.PROMOTION_AIR_REPAIR, GameInfoTypes.PROMOTION_AIR_TARGETING_2},
{GameInfoTypes.PROMOTION_DOGFIGHTING_1, GameInfoTypes.PROMOTION_INTERCEPTION_1, GameInfoTypes.PROMOTION_AIR_TARGETING_1, GameInfoTypes.PROMOTION_AIR_REPAIR, GameInfoTypes.PROMOTION_AIR_AMBUSH_1},
{GameInfoTypes.PROMOTION_INTERCEPTION_1, GameInfoTypes.PROMOTION_AIR_TARGETING_1, GameInfoTypes.PROMOTION_AIR_AMBUSH_1, GameInfoTypes.PROMOTION_AIR_REPAIR, GameInfoTypes.PROMOTION_DOGFIGHTING_1},

},
--11
{
{GameInfoTypes.PROMOTION_AIR_SIEGE_1, GameInfoTypes.PROMOTION_AIR_SIEGE_2, GameInfoTypes.PROMOTION_AIR_SIEGE_3, GameInfoTypes.PROMOTION_AIR_REPAIR, GameInfoTypes.PROMOTION_AIR_AMBUSH_1},
{GameInfoTypes.PROMOTION_AIR_SIEGE_1, GameInfoTypes.PROMOTION_AIR_SIEGE_2, GameInfoTypes.PROMOTION_AIR_SIEGE_3, GameInfoTypes.PROMOTION_ITG_RELIABILITY, GameInfoTypes.PROMOTION_AIR_AMBUSH_1},
{GameInfoTypes.PROMOTION_AIR_AMBUSH_1, GameInfoTypes.PROMOTION_AIR_AMBUSH_2, GameInfoTypes.PROMOTION_AIR_SIEGE_1, GameInfoTypes.PROMOTION_EVASION, GameInfoTypes.PROMOTION_AIR_SIEGE_2},
{GameInfoTypes.PROMOTION_AIR_AMBUSH_1, GameInfoTypes.PROMOTION_AIR_AMBUSH_2, GameInfoTypes.PROMOTION_AIR_SIEGE_1, GameInfoTypes.PROMOTION_AIR_REPAIR, GameInfoTypes.PROMOTION_AIR_TARGETING_1},
{GameInfoTypes.PROMOTION_AIR_TARGETING_1, GameInfoTypes.PROMOTION_AIR_TARGETING_2, GameInfoTypes.PROMOTION_AIR_SIEGE_1, GameInfoTypes.PROMOTION_ITG_RELIABILITY, GameInfoTypes.PROMOTION_AIR_SIEGE_2},
{GameInfoTypes.PROMOTION_AIR_TARGETING_1, GameInfoTypes.PROMOTION_AIR_TARGETING_2, GameInfoTypes.PROMOTION_AIR_SIEGE_1, GameInfoTypes.PROMOTION_EVASION, GameInfoTypes.PROMOTION_AIR_SIEGE_2},
{GameInfoTypes.PROMOTION_AIR_BOMBARDMENT_1, GameInfoTypes.PROMOTION_AIR_BOMBARDMENT_2, GameInfoTypes.PROMOTION_AIR_BOMBARDMENT_3, GameInfoTypes.PROMOTION_AIR_REPAIR, GameInfoTypes.PROMOTION_AIR_AMBUSH_1},
{GameInfoTypes.PROMOTION_AIR_BOMBARDMENT_1, GameInfoTypes.PROMOTION_AIR_BOMBARDMENT_2, GameInfoTypes.PROMOTION_AIR_BOMBARDMENT_3, GameInfoTypes.PROMOTION_ITG_RELIABILITY, GameInfoTypes.PROMOTION_AIR_AMBUSH_1},
{GameInfoTypes.PROMOTION_AIR_AMBUSH_1, GameInfoTypes.PROMOTION_AIR_AMBUSH_2, GameInfoTypes.PROMOTION_AIR_BOMBARDMENT_1, GameInfoTypes.PROMOTION_EVASION, GameInfoTypes.PROMOTION_AIR_BOMBARDMENT_2},
{GameInfoTypes.PROMOTION_AIR_AMBUSH_1, GameInfoTypes.PROMOTION_AIR_AMBUSH_2, GameInfoTypes.PROMOTION_AIR_BOMBARDMENT_1, GameInfoTypes.PROMOTION_AIR_REPAIR, GameInfoTypes.PROMOTION_AIR_TARGETING_1},
{GameInfoTypes.PROMOTION_AIR_TARGETING_1, GameInfoTypes.PROMOTION_AIR_TARGETING_2, GameInfoTypes.PROMOTION_AIR_BOMBARDMENT_1, GameInfoTypes.PROMOTION_ITG_RELIABILITY, GameInfoTypes.PROMOTION_AIR_BOMBARDMENT_2},
{GameInfoTypes.PROMOTION_AIR_TARGETING_1, GameInfoTypes.PROMOTION_AIR_TARGETING_2, GameInfoTypes.PROMOTION_AIR_BOMBARDMENT_1, GameInfoTypes.PROMOTION_EVASION, GameInfoTypes.PROMOTION_AIR_BOMBARDMENT_2},
},
--12
{
{GameInfoTypes.PROMOTION_TARGETING_1, GameInfoTypes.PROMOTION_TARGETING_2, GameInfoTypes.PROMOTION_TARGETING_3, GameInfoTypes.PROMOTION_ITG_PRECISION, GameInfoTypes.PROMOTION_ITG_QUICK_SUBMERGE_I},
{GameInfoTypes.PROMOTION_ITG_QUICK_SUBMERGE_I, GameInfoTypes.PROMOTION_ITG_QUICK_SUBMERGE_II, GameInfoTypes.PROMOTION_ITG_QUICK_SUBMERGE_III, GameInfoTypes.PROMOTION_RANGE, GameInfoTypes.PROMOTION_TARGETING_1},
{GameInfoTypes.PROMOTION_TARGETING_1, GameInfoTypes.PROMOTION_TARGETING_2, GameInfoTypes.PROMOTION_TARGETING_3, GameInfoTypes.PROMOTION_ITG_PRECISION, GameInfoTypes.PROMOTION_SUPPLY},
{GameInfoTypes.PROMOTION_ITG_QUICK_SUBMERGE_I, GameInfoTypes.PROMOTION_ITG_QUICK_SUBMERGE_II, GameInfoTypes.PROMOTION_MOBILITY, GameInfoTypes.PROMOTION_ITG_PRECISION, GameInfoTypes.PROMOTION_SUPPLY},
{GameInfoTypes.PROMOTION_TARGETING_1, GameInfoTypes.PROMOTION_TARGETING_2, GameInfoTypes.PROMOTION_SENTRY, GameInfoTypes.PROMOTION_ITG_PRECISION, GameInfoTypes.PROMOTION_SUPPLY},
{GameInfoTypes.PROMOTION_TARGETING_1, GameInfoTypes.PROMOTION_ITG_QUICK_SUBMERGE_I, GameInfoTypes.PROMOTION_ITG_QUICK_SUBMERGE_II, GameInfoTypes.PROMOTION_RANGE, GameInfoTypes.PROMOTION_SUPPLY},
{GameInfoTypes.PROMOTION_TARGETING_1, GameInfoTypes.PROMOTION_TARGETING_2, GameInfoTypes.PROMOTION_TARGETING_3, GameInfoTypes.PROMOTION_RANGE, GameInfoTypes.PROMOTION_SENTRY},
{GameInfoTypes.PROMOTION_ITG_QUICK_SUBMERGE_I, GameInfoTypes.PROMOTION_ITG_QUICK_SUBMERGE_II, GameInfoTypes.PROMOTION_ITG_QUICK_SUBMERGE_III, GameInfoTypes.PROMOTION_RANGE, GameInfoTypes.PROMOTION_SENTRY},
{GameInfoTypes.PROMOTION_TARGETING_1, GameInfoTypes.PROMOTION_TARGETING_2, GameInfoTypes.PROMOTION_MOBILITY, GameInfoTypes.PROMOTION_ITG_PRECISION, GameInfoTypes.PROMOTION_SUPPLY},
{GameInfoTypes.PROMOTION_TARGETING_1, GameInfoTypes.PROMOTION_TARGETING_2, GameInfoTypes.PROMOTION_TARGETING_3, GameInfoTypes.PROMOTION_RANGE, GameInfoTypes.PROMOTION_SUPPLY},
{GameInfoTypes.PROMOTION_TARGETING_1, GameInfoTypes.PROMOTION_TARGETING_2, GameInfoTypes.PROMOTION_TARGETING_3, GameInfoTypes.PROMOTION_ITG_SUB_STEER_LOCKED, GameInfoTypes.PROMOTION_SUPPLY},
{GameInfoTypes.PROMOTION_TARGETING_1, GameInfoTypes.PROMOTION_ITG_QUICK_SUBMERGE_I, GameInfoTypes.PROMOTION_ITG_QUICK_SUBMERGE_II, GameInfoTypes.PROMOTION_ITG_SUB_STEER_LOCKED, GameInfoTypes.PROMOTION_SUPPLY},
{GameInfoTypes.PROMOTION_TARGETING_1, GameInfoTypes.PROMOTION_TARGETING_2, GameInfoTypes.PROMOTION_TARGETING_3, GameInfoTypes.PROMOTION_ITG_SUB_STEER_LOCKED, GameInfoTypes.PROMOTION_SENTRY},
{GameInfoTypes.PROMOTION_ITG_QUICK_SUBMERGE_I, GameInfoTypes.PROMOTION_ITG_QUICK_SUBMERGE_II, GameInfoTypes.PROMOTION_ITG_QUICK_SUBMERGE_III, GameInfoTypes.PROMOTION_ITG_SUB_STEER_LOCKED, GameInfoTypes.PROMOTION_TARGETING_1}
},
--13
{{GameInfoTypes.PROMOTION_SHOCK_1, GameInfoTypes.PROMOTION_DRILL_1, GameInfoTypes.PROMOTION_COVER_1, GameInfoTypes.PROMOTION_MARCH, GameInfoTypes.PROMOTION_COVER_2},
{GameInfoTypes.PROMOTION_SHOCK_1, GameInfoTypes.PROMOTION_DRILL_1, GameInfoTypes.PROMOTION_MEDIC, GameInfoTypes.PROMOTION_MARCH, GameInfoTypes.PROMOTION_MEDIC_II},
{GameInfoTypes.PROMOTION_SHOCK_1, GameInfoTypes.PROMOTION_DRILL_1, GameInfoTypes.PROMOTION_AMBUSH_1, GameInfoTypes.PROMOTION_MARCH, GameInfoTypes.PROMOTION_AMBUSH_2},
{GameInfoTypes.PROMOTION_DRILL_1, GameInfoTypes.PROMOTION_SHOCK_1, GameInfoTypes.PROMOTION_COVER_1, GameInfoTypes.PROMOTION_BLITZ, GameInfoTypes.PROMOTION_SIEGE},
{GameInfoTypes.PROMOTION_DRILL_1, GameInfoTypes.PROMOTION_SENTRY, GameInfoTypes.PROMOTION_COVER_1, GameInfoTypes.PROMOTION_WOODSMAN, GameInfoTypes.PROMOTION_BLITZ},
{GameInfoTypes.PROMOTION_SHOCK_1, GameInfoTypes.PROMOTION_SHOCK_2, GameInfoTypes.PROMOTION_SHOCK_3, GameInfoTypes.PROMOTION_MARCH, GameInfoTypes.PROMOTION_COVER_1},
{GameInfoTypes.PROMOTION_SHOCK_1, GameInfoTypes.PROMOTION_SHOCK_2, GameInfoTypes.PROMOTION_SHOCK_3, GameInfoTypes.PROMOTION_BLITZ, GameInfoTypes.PROMOTION_SIEGE},
{GameInfoTypes.PROMOTION_DRILL_1, GameInfoTypes.PROMOTION_DRILL_2, GameInfoTypes.PROMOTION_DRILL_3, GameInfoTypes.PROMOTION_WOODSMAN, GameInfoTypes.PROMOTION_BLITZ},
{GameInfoTypes.PROMOTION_SHOCK_1, GameInfoTypes.PROMOTION_SENTRY, GameInfoTypes.PROMOTION_COVER_1, GameInfoTypes.PROMOTION_MARCH, GameInfoTypes.PROMOTION_MEDIC},
{GameInfoTypes.PROMOTION_SHOCK_1, GameInfoTypes.PROMOTION_SHOCK_2, GameInfoTypes.PROMOTION_COVER_1, GameInfoTypes.PROMOTION_MARCH, GameInfoTypes.PROMOTION_SHOCK_3}},
--14
{
{GameInfoTypes.PROMOTION_TARGETING_1, GameInfoTypes.PROMOTION_TARGETING_2, GameInfoTypes.PROMOTION_TARGETING_3, GameInfoTypes.PROMOTION_ITG_PRECISION, GameInfoTypes.PROMOTION_BOMBARDMENT_1},
{GameInfoTypes.PROMOTION_BOMBARDMENT_1, GameInfoTypes.PROMOTION_BOMBARDMENT_2, GameInfoTypes.PROMOTION_BOMBARDMENT_3, GameInfoTypes.PROMOTION_RANGE, GameInfoTypes.PROMOTION_TARGETING_1},
{GameInfoTypes.PROMOTION_TARGETING_1, GameInfoTypes.PROMOTION_TARGETING_2, GameInfoTypes.PROMOTION_TARGETING_3, GameInfoTypes.PROMOTION_ITG_PRECISION, GameInfoTypes.PROMOTION_SUPPLY},
{GameInfoTypes.PROMOTION_BOMBARDMENT_1, GameInfoTypes.PROMOTION_BOMBARDMENT_2, GameInfoTypes.PROMOTION_MOBILITY, GameInfoTypes.PROMOTION_ITG_PRECISION, GameInfoTypes.PROMOTION_SUPPLY},
{GameInfoTypes.PROMOTION_TARGETING_1, GameInfoTypes.PROMOTION_TARGETING_2, GameInfoTypes.PROMOTION_SENTRY, GameInfoTypes.PROMOTION_ITG_PRECISION, GameInfoTypes.PROMOTION_SUPPLY},
{GameInfoTypes.PROMOTION_TARGETING_1, GameInfoTypes.PROMOTION_BOMBARDMENT_1, GameInfoTypes.PROMOTION_BOMBARDMENT_2, GameInfoTypes.PROMOTION_RANGE, GameInfoTypes.PROMOTION_SUPPLY},
{GameInfoTypes.PROMOTION_TARGETING_1, GameInfoTypes.PROMOTION_TARGETING_2, GameInfoTypes.PROMOTION_TARGETING_3, GameInfoTypes.PROMOTION_RANGE, GameInfoTypes.PROMOTION_SENTRY},
{GameInfoTypes.PROMOTION_BOMBARDMENT_1, GameInfoTypes.PROMOTION_BOMBARDMENT_2, GameInfoTypes.PROMOTION_BOMBARDMENT_3, GameInfoTypes.PROMOTION_RANGE, GameInfoTypes.PROMOTION_SENTRY},
{GameInfoTypes.PROMOTION_TARGETING_1, GameInfoTypes.PROMOTION_TARGETING_2, GameInfoTypes.PROMOTION_MOBILITY, GameInfoTypes.PROMOTION_ITG_PRECISION, GameInfoTypes.PROMOTION_SUPPLY},
{GameInfoTypes.PROMOTION_TARGETING_1, GameInfoTypes.PROMOTION_TARGETING_2, GameInfoTypes.PROMOTION_TARGETING_3, GameInfoTypes.PROMOTION_RANGE, GameInfoTypes.PROMOTION_SUPPLY},
{GameInfoTypes.PROMOTION_TARGETING_1, GameInfoTypes.PROMOTION_TARGETING_2, GameInfoTypes.PROMOTION_TARGETING_3, GameInfoTypes.PROMOTION_ITG_BATTLESHIP_MAX_HP, GameInfoTypes.PROMOTION_SUPPLY},
{GameInfoTypes.PROMOTION_TARGETING_1, GameInfoTypes.PROMOTION_BOMBARDMENT_1, GameInfoTypes.PROMOTION_BOMBARDMENT_2, GameInfoTypes.PROMOTION_ITG_BATTLESHIP_MAX_HP, GameInfoTypes.PROMOTION_SUPPLY},
{GameInfoTypes.PROMOTION_TARGETING_1, GameInfoTypes.PROMOTION_TARGETING_2, GameInfoTypes.PROMOTION_TARGETING_3, GameInfoTypes.PROMOTION_ITG_BATTLESHIP_MAX_HP, GameInfoTypes.PROMOTION_SENTRY},
{GameInfoTypes.PROMOTION_BOMBARDMENT_1, GameInfoTypes.PROMOTION_BOMBARDMENT_2, GameInfoTypes.PROMOTION_BOMBARDMENT_3, GameInfoTypes.PROMOTION_ITG_BATTLESHIP_MAX_HP, GameInfoTypes.PROMOTION_TARGETING_1}
},
}
local ResUnitTab = {}
for row in GameInfo.Unit_ResourceQuantityRequirements() do
	local resID = GameInfoTypes[row.ResourceType];
	if not ResUnitTab[resID] then
		ResUnitTab[resID] = {}
	end
	ResUnitTab[resID][GameInfoTypes[row.UnitType]] = row.Cost;
end

LuaEvents.ITG_RequestPromotionClassData.Add(function(iPlayer, iClass)
	local tab = {Promotions = PromotionTreesTypes[GetHelpTypeOfUnitClassITG(iPlayer, iClass)], PromotionsToPick = {}}
	local data = GetAllNiceInfoForClassPromotion(iPlayer, iClass)
	tab.CanHavePromotion = data[1];
	tab.OnlyFreeProm = data[3];
	if data[1] then
		for i, promID in pairs(data[2]) do
			tab.PromotionsToPick[promID] = true;
		end
	end
	MapModData.ITGSG = tab;
end)

function GetTechValueForOrderX(text)
	if not text then
		return -1;
	end
	if not GameInfo.Technologies[text] then
		print("Bad unit prereq", text)
		return -1;
	elseif GameInfo.Technologies[text].IsInnovation then
		return nil
	else
		return GameInfo.Technologies[text].GridX;
	end
end

local techOrderOfUnits = {} -- units from inno does not exists
for row in GameInfo.Units() do
	techOrderOfUnits[row.ID] = GetTechValueForOrderX(row.PrereqTech)
end

function IsValidForTechnologicalCrit(iUnit, sUnit)
	local sType = sUnit:GetUnitType();
	local iType = iUnit:GetUnitType();
	if techOrderOfUnits[iType] and techOrderOfUnits[sType] then
		if techOrderOfUnits[iType] > techOrderOfUnits[sType] then
			local sPlayer = sUnit:GetOwner();
			local iPlayer = iUnit:GetOwner();
			if gT.Players[iPlayer] and gT.Players[sPlayer] then
				if gT.Players[iPlayer].UnitClassXP[iUnit:GetUnitClassType()] then
					if gT.Players[sPlayer].UnitClassXP[sUnit:GetUnitClassType()] then
						return true;
					end
				end
			end
		end
	end
	return false;
end

function GetAvailablePromForClass(iclass)
	local type = UnitClassPromotionTree[iclass];
	return PromotionTreesTypes[type];
end

function GetNumTresholdOfXP(xp, iPlayer, iclass)
	for i, t in pairs(hXPBaseNewPromotionTreshold) do
		if xp < GetPlayerTresholdForNextXPLevel(iPlayer, i, iclass) then
			return i - 1;
		end
	end
	return GetPlayerTresholdForNextXPLevel(iPlayer, #hXPBaseNewPromotionTreshold, iclass);
end

function GetPlayerTresholdForNextXPLevel(iPlayer, tres, iclass)
	local base = hXPBaseNewPromotionTreshold[tres] or hXPBaseNewPromotionTreshold[#hXPBaseNewPromotionTreshold];
	local mod = 0;
	if gT.Players[iPlayer].CultBonusOn[33] then
		mod = mod - 0.1;
	end
	return math.ceil(base * (1 + mod));
end

function XPTresholdsDirty(iPlayer)
	for iclass, treshold in pairs(gT.Players[iPlayer].UnitClassTreshold) do
		gT.Players[iPlayer].UnitClassXPNeededNext[iclass] = GetPlayerTresholdForNextXPLevel(iPlayer, treshold, iclass)
	end
end

function DoInitialClassXPLevel(iPlayer, iclass)
	local unittype = Players[iPlayer]:GetPlayerUniqueUnit(iclass);
	if unittype ~= -1 then
		local tech = GameInfo.Units[unittype].PrereqTech;
		if (not tech) or Teams[Players[iPlayer]:GetTeam()]:IsHasTech(GameInfoTypes[tech]) then
			local xp = LastRandom(0,120);
			if LastRandom(1,20) == 3 then
				xp = LastRandom(0,350);
			end
			local tt = GetNumTresholdOfXP(xp, iPlayer, iclass)
			gT.Players[iPlayer].UnitClassXP[iclass] = xp;
			for i = 1, tt do
				PlayerChoosesPromotionForClass(iclass, iPlayer, GetNextAIPromForClass(iPlayer, iclass))
			end
			gT.Players[iPlayer].UnitClassTreshold[iclass] = tt + 1;
			gT.Players[iPlayer].UnitClassXPNeededNext[iclass] = GetPlayerTresholdForNextXPLevel(iPlayer, tt + 1, iclass)
		else
			gT.Players[iPlayer].UnitClassTreshold[iclass] = 1;
			gT.Players[iPlayer].UnitClassXPNeededNext[iclass] = GetPlayerTresholdForNextXPLevel(iPlayer, 1, iclass)
		end
	else
		gT.Players[iPlayer].UnitClassTreshold[iclass] = 1; -- rather repeating init
		gT.Players[iPlayer].UnitClassXPNeededNext[iclass] = GetPlayerTresholdForNextXPLevel(iPlayer, 1, iclass)
	end
end

function GetRandomValidAIPromPathForClass(iClass, iPlayer)
	local type = GetHelpTypeOfUnitClassITG(iPlayer, iClass);
	return LastRandom(1,#TypesAIPromotionProgress[type])
end

function GetChosenAIPromPathForClass(iClass, iPlayer)
	local type = GetHelpTypeOfUnitClassITG(iPlayer, iClass);
	return TypesAIPromotionProgress[type][gT.Players[iPlayer].UnitClassAIPromPath[iClass]];
end

function GetNextAIPromForClass(iPlayer, iClass)
	for i, promID in pairs(GetChosenAIPromPathForClass(iClass, iPlayer)) do
		if not gT.Players[iPlayer].UnitClassPromotions[iClass][promID] then
			return promID;
		end
	end
	print("Big error for unitclass promotions!", iPlayer, iClass)
end

function GetHelpTypeOfUnitClassITG(iPlayer, iClass)
	return UnitClassPromotionTree[iClass];
end

function CanHaveITGPRomotion(iClass, iPlayer, promID, fTab)
	local hTab = fTab or gT.Players[iPlayer].UnitClassPromotions[iClass];
	local type = GetHelpTypeOfUnitClassITG(iPlayer, iClass);
	if not type then
		return false;
	end
	local hasPrereq = false;
	for i, prom in pairs(PromotionTreesTypes[type][promID][1]) do
		if hTab[prom] then
		--gT.Players[iPlayer].UnitClassPromotions[iClass][prom] then
			hasPrereq = true;
			break;
		end
	end
	if hasPrereq or (#PromotionTreesTypes[type][promID][1] == 0) then
		if PromotionTreesTypes[type][promID][2] then
			local num = 0;
			for iprom, turn in pairs(hTab) do
		--	for iprom, turn in pairs(gT.Players[iPlayer].UnitClassPromotions[iClass]) do
				num = num + 1;
			end
			if PromotionTreesTypes[type][promID][2] > num then
				return false;
			end
		end
		if PromotionTreesTypes[type][promID][3] then
			for it, badprom in pairs(PromotionTreesTypes[type][promID][3]) do
				if hTab[badprom] then
				--if gT.Players[iPlayer].UnitClassPromotions[iClass][badprom] then
					return false;
				end
			end
		end
		return true
	end
	return false
end

function IsPlayerHaveToUseFreePromotion(iPlayer, iClass)
	if ( gT.Players[iPlayer].UnitClassXPNeededNext[iClass] <= gT.Players[iPlayer].UnitClassXP[iClass] ) then
		return false;
	end
	return true;
end

function CanPlayerHavePromotion(iPlayer, iClass)
	if ( gT.Players[iPlayer].UnitClassXPNeededNext[iClass] <= gT.Players[iPlayer].UnitClassXP[iClass] ) then
		return true;
	elseif gT.Players[iPlayer].NumFreePromotions > 0 and (not gT.Players[iPlayer].UnitClassFreePromUsed[iClass]) then
		return true;
	elseif gT.Players[iPlayer].NumRealFreePromotions > 0 then
		return true;
	end
	return false;
end

function GetAllNiceInfoForClassPromotion(iPlayer, iClass)
	if not gT.Players[iPlayer].UnitClassTreshold[iClass] then
		return {false}
	end
	if gT.Players[iPlayer].UnitClassMaxNumPromotions[iClass] <= gT.Players[iPlayer].UnitClassNumPromotions[iClass] then
		return {false}
	end
	if CanPlayerHavePromotion(iPlayer, iClass) then
		local type = GetHelpTypeOfUnitClassITG(iPlayer, iClass);
		local hTab = {}
		if type then
			for promID, sth in pairs(PromotionTreesTypes[type] or {}) do
				if not gT.Players[iPlayer].UnitClassPromotions[iClass][promID] then
					if CanHaveITGPRomotion(iClass, iPlayer, promID) then
						table.insert(hTab, promID);
					end
				end
			end
		end
		if #hTab > 0 then
			return {true, hTab, IsPlayerHaveToUseFreePromotion(iPlayer, iClass)}
		end
	end
	return {false}
end

function GetValidPromToLearn(jUnit, kPlayer, jPlayer, iClass)
	if not gT.Players[jPlayer] then
		return nil;
	end
	if not gT.Players[jPlayer].UnitClassPromotions[iClass] then
		return nil;
	end
	local tab = {}
	for promID, sth in pairs(gT.Players[jPlayer].UnitClassPromotions[iClass]) do
		if not jUnit:IsHasPromotion(promID) then
			table.insert(tab, promID)
		end
	end
	if #tab > 0 then
		return tab[LastRandom(1,#tab)]
	else
		return nil;
	end
end

function AssignUnitclassPromotion(iClass, iPlayer, promID)
	gT.Players[iPlayer].UnitClassPromotions[iClass][promID] = GetRealGameTurn();
	gT.Players[iPlayer].UnitClassNumPromotions[iClass] = gT.Players[iPlayer].UnitClassNumPromotions[iClass] + 1;
	local tres = gT.Players[iPlayer].UnitClassTreshold[iClass];
	if gT.Players[iPlayer].UnitClassXPNeededNext[iClass] <= gT.Players[iPlayer].UnitClassXP[iClass] then
		gT.Players[iPlayer].UnitClassTreshold[iClass] = tres + 1;
		gT.Players[iPlayer].UnitClassXPNeededNext[iClass] = GetPlayerTresholdForNextXPLevel(iPlayer, tres + 1, iclass)
	elseif (gT.Players[iPlayer].NumFreePromotions > 0) and (not gT.Players[iPlayer].UnitClassFreePromUsed[iClass]) then
		gT.Players[iPlayer].NumFreePromotions = gT.Players[iPlayer].NumFreePromotions - 1;
		gT.Players[iPlayer].UnitClassFreePromUsed[iClass] = true;
	else
		gT.Players[iPlayer].NumRealFreePromotions = gT.Players[iPlayer].NumRealFreePromotions - 1;
		if gT.Players[iPlayer].NumRealFreePromotions < 0 then
			print("NumRealFreePromotions below 0! ERROR", iPlayer)
		end
	end
	for iUnit in Players[iPlayer]:Units() do
		if iUnit:GetUnitClassType() == iClass then
			iUnit:SetHasPromotion(promID, true)
			local uID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
			for type, prom in pairs(gT.Players[iPlayer].UnitsByID[uID].UniqueFreeClassProm or {}) do
				if prom == promID then
					AssignFreeSpecialClassProm(iUnit, uID, iPlayer, type)
				end
			end
		end
	end
end

function PlayerChoosesPromotionForClass(iClass, iPlayer, promID)
	if CanHaveITGPRomotion(iClass, iPlayer, promID) then
		AssignUnitclassPromotion(iClass, iPlayer, promID)
		if gT.Players[iPlayer].HasPlayerWonder[terrac1] then
			ChangeITGCulture(iPlayer, 25)
		end
		if gT.Players[iPlayer].HasPlayerWonder[alhambra1] then
			BoostArtisticPoints(iPlayer, 30, false)
		end
		if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_PAGAN_6, "TP6") then
			ChangeExtraSupply(iPlayer, 1)
		end
		if gT.Globals.GameGenerated then
			if Players[iPlayer]:IsHuman() then
				LuaEvents.ITG_AchievementCountChange(89, 1)
			end
			VictoryTaskCompletion(iPlayer, 43)
		end
	end
end

local bcdojo = GameInfoTypes.BUILDINGCLASS_ITG_DOJO;
function UpdateXPUnits(iPlayer)
	for iUnit in Players[iPlayer]:Units() do
		UpdateXPOfUnit(iUnit, iPlayer)
	end
	local numdojos = Players[iPlayer]:GetBuildingClassCount(bcdojo)
	if numdojos > 0 then
		local hTab = {}
		for iUnit in Players[iPlayer]:Units() do
			if gT.Players[iPlayer].UnitClassXP[iUnit:GetUnitClassType()] then
				table.insert(hTab, iUnit:GetUnitClassType())
			end
		end
		if #hTab > 0 then
			for i = 1, numdojos do
				local lClass = hTab[LastRandom(1,#hTab)];
				gT.Players[iPlayer].UnitClassXP[lClass] = gT.Players[iPlayer].UnitClassXP[lClass] + 10;
			end
		end
	end
	for iClass, boost in pairs(gT.Players[iPlayer].UnitClassDelayedXPGain) do
		if not gT.Players[iPlayer].ObsoleteUnitClasses[iClass] then
			if boost > 0 then
				gT.Players[iPlayer].UnitClassXP[iClass] = gT.Players[iPlayer].UnitClassXP[iClass] + boost;
				gT.Players[iPlayer].UnitClassDelayedXPGain[iClass] = 0;
			end
		end
	end
	if not Players[iPlayer]:IsHuman() then
		for iClass, XP in pairs(gT.Players[iPlayer].UnitClassXP) do
			if gT.Players[iPlayer].UnitClassXPNeededNext[iClass] <= XP then
				if gT.Players[iPlayer].UnitClassMaxNumPromotions[iClass] > gT.Players[iPlayer].UnitClassNumPromotions[iClass] then
					PlayerChoosesPromotionForClass(iClass, iPlayer, GetNextAIPromForClass(iPlayer, iClass))
				end
			end
		end
	end
end

function UpdateAllVeteranBonusUnits(iPlayer)
	for iUnit in Players[iPlayer]:Units() do
		local uID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
		AdjustCombatBonusFromLevel(iUnit, uID, iPlayer)
	end
end

function UpdateXPOfUnit(iUnit, iPlayer, bKilled)
	local iClass = iUnit:GetUnitClassType();
	if gT.Players[iPlayer].UnitClassXP[iClass] then
		local uID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
		if gT.Players[iPlayer].UnitsByID[uID] then
			if not gT.Players[iPlayer].UnitsByID[uID].XP then
				print(iUnit:GetName(), iUnit:GetUnitType(), iUnit:GetID(), iPlayer, bKilled, "XP lacking :(")
			end
			if iUnit:GetExperience() > gT.Players[iPlayer].UnitsByID[uID].XP then
				local boost = iUnit:GetExperience() - gT.Players[iPlayer].UnitsByID[uID].XP;
				gT.Players[iPlayer].UnitsByID[uID].XP = iUnit:GetExperience();
				if (not gT.Players[iPlayer].ObsoleteUnitClasses[iClass]) then
					if bKilled then
						gT.Players[iPlayer].UnitClassDelayedXPGain[iClass] = gT.Players[iPlayer].UnitClassDelayedXPGain[iClass] + boost;
					else
						gT.Players[iPlayer].UnitClassXP[iClass] = gT.Players[iPlayer].UnitClassXP[iClass] + boost;
						DoTestITGVeteranPromotion(iPlayer, iUnit:GetID())
						AdjustCombatBonusFromLevel(iUnit, uID, iPlayer)
					end
				end
--				local genID = gT.Players[iPlayer].UnitsByID[uID].GeneralID;
--				if genID then
--					BoostPopularity(iPlayer, genID, boost)
--				end
			end
		end
	end
end

function ChangeJustUnitExperience(iUnit, iPlayer, amount)
	iUnit:ChangeExperience(amount)
	local uID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
	gT.Players[iPlayer].UnitsByID[uID].XP = gT.Players[iPlayer].UnitsByID[uID].XP + amount;
end

function IsValidToWork(iPlot, playerID)
	if iPlot:GetNumUnits() == 0 then
		return true;
	else
		local canBe = true;
		for b = 0, iPlot:GetNumUnits() - 1 do
			local bUnit = iPlot:GetUnit(b);
			if bUnit:GetOwner() == playerID then
				if bUnit:GetUnitType() == uWorker then
					canBe = false;
					break
				end 
			else
				canBe = false;
				break
			end
		end
		if canBe then
			return true;
		end
	end
end

function ChangeUnitOwnership(iUnit, unitdata, nPlayer, bTreason)
	if iUnit:GetPlot():IsCity() then
		iUnit:JumpToNearestValidPlot();
	end
	if iUnit:GetPlot():IsCity() then
		if bTreason then

		end
		--dunno
		return;
	end
	local jUnit = Players[nPlayer]:InitUnit(iUnit:GetUnitType(), iUnit:GetX(), iUnit:GetY());
	jUnit:SetExperience(iUnit:GetExperience());
	if iUnit:IsEmbarked() then
		jUnit:Embark(jUnit:GetPlot())
	end
	local uID = jUnit:GetID() .. "," ..  nPlayer .. "," .. jUnit:GetGameTurnCreated();
	ITGSCNewUnitCreated(nPlayer, jUnit, nil, true)
	iUnit:Kill(false, -1)
end

function ConvertUnit(iUnit, newtype)
	local iPlayer = iUnit:GetOwner();
	local uID = iUnit:GetID() .. "," ..  iPlayer .. "," .. iUnit:GetGameTurnCreated();
	local dataUnit = gT.Players[iPlayer].UnitsByID[uID];
	local hp, moves, isembarked, maxmoves = iUnit:GetDamage(), iUnit:GetMoves(), iUnit:IsEmbarked(), iUnit:MaxMoves();
	local jUnit = Players[iPlayer]:InitUnit(newtype, iUnit:GetX(), iUnit:GetY())
	jUnit:SetMoves(jUnit:MaxMoves() * moves / maxmoves)
	jUnit:SetDamage(hp);
	if isembarked then
	-- in future more complicated for naval land conversions
		jUnit:Embark(jUnit:GetPlot())
	end
	local jID = jUnit:GetID() .. "," ..  iPlayer .. "," .. jUnit:GetGameTurnCreated();
	ITGSCNewUnitCreated(iPlayer, jUnit, nil, nil, "NO_GENERAL")
	if dataUnit then
		 gT.Players[iPlayer].UnitsByID[jID] = dataUnit;
		 local genID = gT.Players[iPlayer].UnitsByID[jID].GeneralID;
		 if genID then
			AssignUnitToGeneral(iPlayer, jID, genID, jUnit)
		 end
	end
	iUnit:Kill(false, -1);
end

function IsHasAnyRookiePenalty(iUnit)
	for i, iProm in pairs(RookiePromTab) do
		if iUnit:IsHasPromotion(iProm) then
			return true;
		end
	end
	return false;
end

function AIChooseFreeMilitaryPromotion(iPlayer)
	--numunits of type, numtreshold promotion (and missing?);
	local iClassFunTab = {}
	for iClass, XP in pairs(gT.Players[iPlayer].UnitClassXP) do
		if CanPlayerHavePromotion(iPlayer, iClass) then
			local XPneeded = math.min(1, gT.Players[iPlayer].UnitClassXPNeededNext[iClass] - XP);
			local numprom = gT.Players[iPlayer].UnitClassNumPromotions[iClass];
			if gT.Players[iPlayer].MaxClassPromotions > numprom then
				table.insert(iClassFunTab, {iClass, (XPneeded + numprom * 100) * (10 + Players[iPlayer]:GetUnitClassCount(iClass))})
			end
		end
	end
	if #iClassFunTab > 0 then
		table.sort(iClassFunTab, SortFunctionForGreaterInteger2);
		local iClass = iClassFunTab[1][1];
		PlayerChoosesPromotionForClass(iClass, iPlayer, GetNextAIPromForClass(iPlayer, iClass))
	else
		print("Very Bad Error 12346")
	end
end

local fakeCivilianTypes = {}
for row in GameInfo.Units() do
	if row.FakeCivilian then
		fakeCivilianTypes[row.ID] = 1;
	end
end

function IsRealCombatUnit(iUnit)
	if iUnit:IsCombatUnit() then
		if not fakeCivilianTypes[iUnit:GetUnitType()] then
			return true;
		end
	end
	return false;
end

local embTech = {{GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_25, 1000}, {GameInfoTypes.TECH_STEAM_POWER, 75}, {GameInfoTypes.TECH_NAVIGATION, 50}, {GameInfoTypes.TECH_COMPASS, 33},{GameInfoTypes.TECH_OPTICS, 15}}
function GetTresholdOfEmbarkDamage(iPlayer)
	local iTeam = Teams[Players[iPlayer]:GetTeam()]
	for i, data in pairs(embTech) do
		if iTeam:IsHasTech(data[1]) then
			return data[2];
		end
	end
	return -1;
end

local promEmbark = GameInfoTypes.PROMOTION_EMBARKATION;
function DoEmbarkIssue(iPlayer)
	local hpTresh = GetTresholdOfEmbarkDamage(iPlayer)
	for iUnit in Players[iPlayer]:Units() do
		local uID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
		if (not gT.Players[iPlayer].UnitsByID[uID]) or (not gT.Players[iPlayer].UnitsByID[uID].TargetAdjacent) then
			if iUnit:GetDomainType() == dLand then
				if not iUnit:IsEmbarked() then
					iUnit:SetHasPromotion(promEmbark, iUnit:GetDamage() <= hpTresh);
				end
			end
		end
	end
end

function SingleUnitEmbarkIssue(iPlayer, iUnit)
	if iUnit:GetDomainType() == dLand then
		local hpTresh = GetTresholdOfEmbarkDamage(iPlayer)
		if iUnit:GetDamage() <= hpTresh then
			local uID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
			if (not gT.Players[iPlayer].UnitsByID[uID]) or (not gT.Players[iPlayer].UnitsByID[uID].TargetAdjacent) then
				iUnit:SetHasPromotion(promEmbark, true);
			end
		end
	end
end

function GetRandomAvClassPromForUnit(iClass, iPlayer)
	local hTab = {}
	local type = GetHelpTypeOfUnitClassITG(iPlayer, iClass);
	for promID, sth in pairs(PromotionTreesTypes[type] or {}) do
		if not gT.Players[iPlayer].UnitClassPromotions[iClass][promID] then
			if CanHaveITGPRomotion(iClass, iPlayer, promID) then
				table.insert(hTab, promID);
			end
		end
	end
	if #hTab > 0 then
		return hTab[LastRandom(1,#hTab)];
	end
	return nil;
end

function BasicRangedStrikeAtTurnStart(jUnit, iPlayer, range, bAddRemoveRange, rangedStrength, bDoNotRefreshAttack, iAppend, bLand)
	local hTab = {}
	local bX = jUnit:GetX();
	local bY = jUnit:GetY();
	local bEmbarked = jUnit:IsEmbarked();
	local bDelayReturn = false;
	if bEmbarked then
		jUnit:SetEmbarked(false);
	end
	if bAddRemoveRange then
		jUnit:ChangeExtraRange(range)
	end
	local cRangedStr = jUnit:GetBaseRangedCombatStrength()
	if rangedStrength then
		jUnit:SetBaseRangedCombatStrength(rangedStrength)
	end
	local iMoves = jUnit:GetMoves();
	local bOutOfAttacks = jUnit:IsOutOfAttacks();
	jUnit:SetMadeAttack(false);
	jUnit:SetMoves(jUnit:MaxMoves());
	for iX = -range, range do
		for iY = -range, range do
			local plot = Map.PlotXYWithRangeCheck(bX, bY, iX, iY, range)
			if plot then
				if (not bLand) or (not plot:IsWater()) then
					if jUnit:CanStartMission(RangAtt, plot:GetX(), plot:GetY()) then
						table.insert(hTab, plot)
					end
				end
			end
		end
	end
	if #hTab > 0 then
		local ePlot = hTab[math.random(1, #hTab)];
		jUnit:PushMission(RangAtt, ePlot:GetX(), ePlot:GetY(), 0, iAppend)
		if iAppend then
			bDelayReturn = true;
		end
	end
	if bDelayReturn then
		table.insert(mTabRangeStrikeAppend, {jUnit:GetOwner(), jUnit:GetID(), bEmbarked, rangedStrength, cRangedStr, bAddRemoveRange, range, iMoves, bOutOfAttacks, bDoNotRefreshAttack})
	else
		DoReturnToNormalFromFakeRangedStrike(jUnit, bEmbarked, rangedStrength, cRangedStr, bAddRemoveRange, range, iMoves, bOutOfAttacks, bDoNotRefreshAttack)
	end
end

function PostRangedStrikeReturnToNormal(iUnit, unitID, iPlayer)
	local lKey 
	for i, v in pairs(mTabRangeStrikeAppend) do
		if v[1] == iPlayer and v[2] == unitID then
			DoReturnToNormalFromFakeRangedStrike(iUnit, v[3], v[4], v[5], v[6], v[7], v[8], v[9], v[10])
			lKey = i;
			break;
		end
	end
	if lKey then
		table.remove(mTabRangeStrikeAppend, lKey)
	end
end

function DoReturnToNormalFromFakeRangedStrike(jUnit, bEmbarked, rangedStrength, cRangedStr, bAddRemoveRange, range, iMoves, bOutOfAttacks, bDoNotRefreshAttack)
	if bEmbarked then
		jUnit:SetEmbarked(true);
	end
	if rangedStrength then
		jUnit:SetBaseRangedCombatStrength(cRangedStr)
	end
	if bAddRemoveRange then
		jUnit:ChangeExtraRange(-range)
	end
	jUnit:SetMoves(iMoves);
	if bDoNotRefreshAttack then
		jUnit:SetMadeAttack(bOutOfAttacks);
	else
		jUnit:SetMadeAttack(false);
	end
end

function GetBestForcedStackType(iPlayer, uID)
	local iRtn = -11;
	if gT.Players[iPlayer].UnitsByID[uID].ForceITGStackType then
		for i, v in pairs(gT.Players[iPlayer].UnitsByID[uID].ForceITGStackType) do
			if v[1] == -2 then
				return -2;
			elseif (iRtn ~= -1) then
				iRtn = v[1];
			end
		end
	end
	return iRtn;
end

function SetUnitForcedStackType(iUnit, type, sType, hTurns)
	if iUnit:GetITGStackType() == -2 then
		return; -- nothing should mess with that;
	end
	local iPlayer = iUnit:GetOwner();
	local uID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
	if not gT.Players[iPlayer].UnitsByID[uID].ForceITGStackType then
		gT.Players[iPlayer].UnitsByID[uID].ForceITGStackType = {};
	end
	if hTurns == -1 then
		gT.Players[iPlayer].UnitsByID[uID].ForceITGStackType[sType] = {type, hTurns}
	else
		gT.Players[iPlayer].UnitsByID[uID].ForceITGStackType[sType] = {type, GetITGGameTurn() + hTurns}
	end
	iUnit:SetForcedITGStackType(GetBestForcedStackType(iPlayer, uID));
end

function CleanTemporaryITGStackType(iUnit, sType)
	local iPlayer = iUnit:GetOwner();
	local uID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
	if not gT.Players[iPlayer].UnitsByID[uID] then
		return;
	end
	if gT.Players[iPlayer].UnitsByID[uID].ForceITGStackType then
		gT.Players[iPlayer].UnitsByID[uID].ForceITGStackType[sType] = nil;
		local bAnyLeft = false; --this is for tooltip unitpanel to indicate properly when stack type is temp affected
		for a, b in pairs(gT.Players[iPlayer].UnitsByID[uID].ForceITGStackType) do
			bAnyLeft = true;
			break;
		end
		if not bAnyLeft then
			gT.Players[iPlayer].UnitsByID[uID].ForceITGStackType = nil;
		end
	else
		print("ClearTempITGStackType weird", iPlayer, uID, sType);
	end
	local bSNow = GetBestForcedStackType(iPlayer, uID)
	if iUnit:GetITGStackType() ~= bSNow then
		iUnit:SetForcedITGStackType(bSNow);
		local st = iUnit:GetITGStackType();
		if st > -2 then
			local lPlot = iUnit:GetPlot();
			for jj = 0, lPlot:GetNumUnits() -1 do
				local jUnit = lPlot:GetUnit(jj);
				if jUnit and (jUnit:GetID() ~= iUnit:GetID()) then
					if jUnit:GetITGStackType() == st and ((st ~= -1) or (jUnit:GetOwner() ~= iUnit:GetOwner()))  then
						if (jUnit:GetUnitType() ~= iUnit:GetUnitType()) or (not GameInfo.Units[jUnit:GetUnitType()].StackableInType) then
							iUnit:JumpToNearestValidPlot()
							break;
						end
					end
				end
			end
		end
	end
end

local noSpeedUpUnits = {}
for row in GameInfo.Units() do
	if (row.Moves <= 0) or row.Immobile then
		noSpeedUpUnits[row.ID] = 1;
	end
end

function CanBeSpeedUpByAnything(iUnit)
	if noSpeedUpUnits[iUnit:GetUnitType()] then
		return false;
	end
	if iUnit:GetDomainType() == dAir then
		return false;
	end
	return true;
end

function IsResourceUnitType(unittype, res)
	if ResUnitTab[res] then
		if ResUnitTab[res][unittype] then
			return true;
		end
	end
	return false
end

function IsResourceUnit(iUnit, res)
	if ResUnitTab[res] then
		if ResUnitTab[res][iUnit:GetUnitType()] then
			return true;
		end
	end
	return false
end

function HasResourceReqForUnlock(pTeam, iPlayer, iUnitType)
	for res, h in pairs(ResUnitTab) do
		if h[iUnitType] then
			if not CanSeeUseResource(iPlayer, res) then
				return false;
			end
		end
	end
	return true;
end

function OnTrainedUnitResourceConsume(iPlayer, unitType)
	for res, sth in pairs(ResUnitTab) do
		if sth[unitType] then
			DoConsumeResource(iPlayer, res, sth[unitType], true);
		end
	end
end

function GetTurnsLocked(iPlayer, iCity, res, unitType)
	local base = DBScenario.ResLockedTurns
	if res == rHorse then
		if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_TRIBE_5, "Gewjfewf") then
			base = math.max(0, base - 3);
		end
		if iCity:IsHasBuilding(GameInfoTypes.BUILDING_ITG_STABLE_ANCIENT) then
			base = math.max(0, base - 3);
		end
	elseif res == rIron then
		if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_EMPIRE_1, "4ffregreh") then
			base = math.max(0, base - 3);
		end
		if iCity:IsHasBuilding(GameInfoTypes.BUILDING_ITG_FORGE_ANCIENT) then
			base = math.max(0, base - 3);
		end
		if unitType == GameInfoTypes.UNIT_ITG_AOT_SWORDSMAN_GAL then
			base = math.max(0, base - 3);
		end
	end
	return base;
end

function GetNumUnitsOfType(iPlayer, unitType)
	local t = 0;
	for iUnit in Players[iPlayer]:Units() do
		if iUnit:GetUnitType() == unitType then
			t = t + 1;
		end
	end
	return t;
end

function OnTrainedUnitResourceLock(iPlayer, unitType, iCity)
	for res, sth in pairs(ResUnitTab) do
		if sth[unitType] then
			local gTh = GetTurnsLocked(iPlayer, iCity, res, unitType);
			if gTh > 0 then
				ChangeNumResourcesUsed(iPlayer, res, sth[unitType])
				table.insert(gT.Players[iPlayer].ResLockedT, {res, sth[unitType], GetITGGameTurn() + gTh})
			end
		end
	end
end


function IsSpecialUnit(jID)
	if gT.ColoniesByUnitID[jID] or gT.HolySitesUnits[jID] or gT.FortsByUnitID[jID] or gT.SettlementsByUnitID[jID] or gT.ElDoradoByUnitID[jID] then
		return true
	end
	return false;
end

function IsITGTradeUnit(iUnit, jID)
	local jPlayer = iUnit:GetOwner();
	if gT.Players[jPlayer].UnitsByID[jID] then
		if gT.Players[jPlayer].UnitsByID[jID].TargetAdjacent then
			return true;
		end
	end
	return false;
end

function IsValidToBeConverted(iUnit)
	if CanBeSpeedUpByAnything(iUnit) then
		local uID = iUnit:GetID() .. "," .. iUnit:GetOwner() .. "," .. iUnit:GetGameTurnCreated();
		if not IsSpecialUnit(uID) then
			if not IsITGTradeUnit(iUnit, uID) then
				return true;
			end
		end
	end
	return false;
end

function GetNumExistingTradeUnits(iPlayer)
	local c = 0;
	for iUnit in Players[iPlayer]:Units() do
		local uID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
		if IsITGTradeUnit(iUnit, uID) then
			c = c +1;
		end
	end
	return c;
end

function ChangeITGBaseCombatStrength(iUnit, iCmb, iRcmb)
	if iCmb then
		if iUnit:GetDomainType() ~= dAir then
		-- air units with base combat strength work very weird
		-- true is ignoring EMBARKED state :>
			iUnit:SetBaseCombatStrength(math.max(1,iUnit:GetBaseCombatStrength(true) + iCmb))
		end
	end
	if iRcmb then
		if iUnit:GetBaseRangedCombatStrength() > 0 then
			iUnit:SetBaseRangedCombatStrength(math.max(1,iUnit:GetBaseRangedCombatStrength() + iRcmb))
		end
	end
end

local ValidForRamOrSiegeTUnitCombat = {[GameInfoTypes.UNITCOMBAT_MELEE] = 1, [GameInfoTypes.UNITCOMBAT_MOUNTED] = 1}
function CanHaveBatteringRamSupport(iUnit, iPlayer, sProm, bInit)
	if bInit or ((iUnit:GetMoves() == iUnit:MaxMoves()) and (iUnit:GetPlot():GetOwner() == iPlayer) and (iUnit:GetDamage() == 0)) then
		if gT.Players[iPlayer].UnitClassXP[iUnit:GetUnitClassType()] then
			if not iUnit:IsHasPromotion(sProm) then
				if ValidForRamOrSiegeTUnitCombat[iUnit:GetUnitCombatType()] then
					local uID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
					if not IsSpecialUnit(uID) then
						return true;
					end
				end
			end
		end
	end
	return false;
end

function GetValidUnitForBatRamFromPlot(iPlot, iPlayer, sProm)
	for i = 0, iPlot:GetNumUnits() - 1 do
		local iUnit = iPlot:GetUnit(i);
		if iUnit:GetOwner() == iPlayer then
			if CanHaveBatteringRamSupport(iUnit, iPlayer, sProm) then
				return iUnit;
			end
		end
	end
	return nil;
end

function AddSiegeSupportPromOnPlot(iPlayer, iPlot, sProm)
	local hUnit = GetValidUnitForBatRamFromPlot(iPlot, iPlayer, sProm);
	if hUnit then
		AddSupportPromToUnit(hUnit, iPlayer, sProm)
	end
end

function AddSupportPromToUnit(hUnit, iPlayer, sProm)
	hUnit:SetHasPromotion(sProm, true)
	if sProm == GameInfoTypes.PROMOTION_ITG_BATTERING_RAM_SUPPORT then
		gT.Players[iPlayer].BatteringSupport = gT.Players[iPlayer].BatteringSupport - 1;
	elseif sProm == GameInfoTypes.PROMOTION_ITG_SIEGE_TOWER_SUPPORT then
		gT.Players[iPlayer].SiegeTowerSupport = gT.Players[iPlayer].SiegeTowerSupport - 1;
	end
	LuaEvents.ITGUnitFlagPromotionsDirty(iPlayer, hUnit:GetID())
	if iPlayer == Game.GetActivePlayer() then
		local hex = ToHexFromGrid(Vector2(hUnit:GetX(),hUnit:GetY()));
		Events.GameplayFX(hex.x, hex.y, -1)
	end
end

function DoIncreaseAngryCrit(iPlayer, ePlayer, val, sReason)
	gT.Players[iPlayer].CritGrievances[ePlayer] = (gT.Players[iPlayer].CritGrievances[ePlayer] or 0) + val;
end

function DoHandleAngryCrit(iPlayer)
	for e, val in pairs(gT.Players[iPlayer].CritGrievances) do
		local nval = math.floor(val * 9 / 10)
		if nval == 0 then
			gT.Players[iPlayer].CritGrievances[e] = nil;
		else
			gT.Players[iPlayer].CritGrievances[e] = nval;
		end
	end
end

function HighlightProperPlotsForSupportPromotion(iPlayer, sProm)
	local hTab = {}
	local sAdded = {}
	for iUnit in Players[iPlayer]:Units() do
		if CanHaveBatteringRamSupport(iUnit, iPlayer, sProm) then
			local iPlot = iUnit:GetPlot();
			if not sAdded[iPlot:GetPlotIndex()] then
				sAdded[iPlot:GetPlotIndex()] = true;
				table.insert(hTab, iPlot)
			end
		end
	end
	MapModData.ITGSG = hTab;
end

function AIAddsSupportProm(iPlayer, sProm, hmI)
	local tab = {}
	for iUnit in Players[iPlayer]:Units() do
		if CanHaveBatteringRamSupport(iUnit, iPlayer, sProm) then
			table.insert(tab, {iUnit, iUnit:GetBaseCombatStrength(true)})
		end
	end
	table.sort(tab, SortFunctionForGreaterInteger2)
	for i, h in pairs(tab) do
		if i <= hmI then
			if h[2] > 7 then
				AddSupportPromToUnit(h[1], iPlayer, sProm)	
			end
		else
			return;
		end
	end
end

function GetMechClassToMakeCheaper(iPlayer, bNotOnlyMech)
	local tab = {}
	for iClass, h in pairs(gT.Players[iPlayer].UnitClassXP) do
		if Players[iPlayer]:GetUnitClassCount(iClass) > 0 then
			local unittype = Players[iPlayer]:GetPlayerUniqueUnit(iClass);
			if unittype ~= -1 then
				local ccc = GameInfo.Units[unittype].CombatClass
				if ccc then
					if bNotOnlyMech or IsMechanicalTab[GameInfoTypes[ccc]] then
						if GameInfo.Units[unittype].Cost + Players[iPlayer]:GetUnitClassRawProdDiscount(iClass) > 50 then
							table.insert(tab, iClass);
						end
					end
				end
			end
		end
	end
	if #tab > 0 then
		return tab[LastRandom(1,#tab)]
	end
	return nil;
end

function GetClassPromsOfType(iv)
	local tab = {}
	for it, th in pairs(PromotionTreesTypes[iv]) do
		table.insert(tab, it)
	end
	return tab;
end

function ChangeExtraSupply(iPlayer, val)
	gT.Players[iPlayer].ExtraSupply = gT.Players[iPlayer].ExtraSupply + val;
	SupplyBaseValDirty(iPlayer)
end

function SupplyBaseValDirty(iPlayer)
	local val = GetDBCulturePlayerInfo(iPlayer, "UnitSupply");
	val = val + gT.Players[iPlayer].ExtraSupply;
	for govID, h in pairs(gT.Players[iPlayer].Governors) do
		val = val + (gT.Globals.Governors[govID].Supply or 0);
	end
	Players[iPlayer]:SetBaseSupplyValue(val);
end

function IsDemilitarizationActive(iPlayer)
	for l, h in pairs(gT.Leagues) do
		if h.Resolutions[48] and h.Members[iPlayer] then
			return true;
		end
	end
	return false;
end

function ToolTipUSupply(iPlayer)
	local strText = "Unit Supply indicates the number of military units your empire can support. Extending this value will result in increasing penalties in all Cities:"
	strText = strText .. "[NEWLINE][ICON_BULLET][COLOR_NEGATIVE_TEXT]-5%[ENDCOLOR] [ICON_PRODUCTION] Production."
	strText = strText .. "[NEWLINE][ICON_BULLET]An extra [COLOR_NEGATIVE_TEXT]-5%[ENDCOLOR] [ICON_PRODUCTION] Production while training units."
	strText = strText .. "[NEWLINE][NEWLINE]Currently you have " .. Players[iPlayer]:GetNumUnitsToSupply() .. " units to supply."
	strText = strText .. "[NEWLINE][NEWLINE]You can supply " .. Players[iPlayer]:GetNumUnitsSupplied() .. " units:"
	local tab = {}
	table.insert(tab, {GetDBCulturePlayerInfo(iPlayer, "UnitSupply"), "Base"});
	--table.insert(tab, {Players[iPlayer]:GetNumUnitsSuppliedByCities(), "Cities"});
	-- divided into cities and occupied cities for better display
	local nOc = GetNumOccupiedCities(iPlayer)
	local nTc = Players[iPlayer]:GetNumCities();
	table.insert(tab, {nTc - nOc, "Cities"});
	table.insert(tab, {-1 * math.min(nTc - nOc, nOc), "Occupied Cities"});

	
	table.insert(tab, {Players[iPlayer]:GetNumUnitsSuppliedByBuildings(), "Buildings"});
	table.insert(tab, {GetUnitSupplyFromGovernors(iPlayer), "Governors"});
	local otherS = gT.Players[iPlayer].ExtraSupply;
	if gT.Players[iPlayer].CultBonusOn[48] then
		otherS = otherS - 4;
		table.insert(tab, {4, "Military Tradition"});
	end
	if IsDemilitarizationActive(iPlayer) then
		otherS = otherS - LEAGUE_SUPPLY_DEMILITARIZATION;
		table.insert(tab, {LEAGUE_SUPPLY_DEMILITARIZATION, "Demilitarization"});
	end
	local fromAca = GetNumAcademiesWithAbility(iPlayer, 60) * 3;
	otherS = otherS - fromAca;
	if gT.Globals.DominationOn and (not gT.Globals.DominationOff) then
		table.insert(tab, {UNIT_SUPPLY_WORLD_AT_WAR, "World at War"});
		otherS = otherS - UNIT_SUPPLY_WORLD_AT_WAR;
	end
	table.insert(tab, {fromAca, "Academies"});
	table.insert(tab, {otherS, "Other Sources"}); -- mostly city-state quests rewards now
	for i, v in pairs(tab) do
		if v[1] > 0 then
			strText = strText .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]+" ..  v[1] .. "[ENDCOLOR] from " .. v[2] .. ".";
		elseif v[1] < 0 then
			strText = strText .. "[NEWLINE][ICON_BULLET][COLOR_NEGATIVE_TEXT]" ..  v[1] .. "[ENDCOLOR] from " .. v[2] .. ".";
		end
	end
	local penalty = Players[iPlayer]:GetUnitProductionMaintenanceMod();
	if penalty ~= 0 then
		strText = strText .. "[NEWLINE][NEWLINE][COLOR_NEGATIVE_TEXT]" .. penalty / 2 .. " (" .. -penalty .. ")% penalty modifier!"
	end
	return strText;
end

function DoDirtyUnitGoldCost(iPlayer)
	local val = GetDBCulturePlayerInfo(iPlayer, "GoldPerUnitTimes100")
	val = val + gT.Players[iPlayer].UnitGoldCostChange;
	if IsHasLaw(iPlayer, 11, 1) or IsHasLaw(iPlayer, 11, 2) then
		val = val + 25;
	elseif IsHasLaw(iPlayer, 11, 3) or IsHasLaw(iPlayer, 11, 4) then
		val = val - 25;
	end
	gT.Players[iPlayer].TPGoldPerUnit100 = math.max(val, 25);
	Players[iPlayer]:SetGoldPerUnitTimes100(gT.Players[iPlayer].TPGoldPerUnit100);
end

function GetPlayerQuarantineCost(iPlayer)
	return gT.Players[iPlayer].QuarantineUnitCost;
end

function GetExtraCostOfMercenaries(iPlayer)
	local ival = 0;
	if IsHasLaw(iPlayer, 28, 1) then
		for iUnit in Players[iPlayer]:Units() do
			if iUnit:IsMercenary() then
				ival = ival - 2;
			end
		end
	end
	return ival;
end

function GetPlayerNationalParkCost(iPlayer)
	if not IsHasLaw(iPlayer, 29, 0) then
		return Players[iPlayer]:GetGoldPerUnitTimes100() / -25;
	end
	return 0;
end

function GetPlayerGreatPeopleCost(iPlayer)
	if IsHasLaw(iPlayer, 13, 1) then
		return -2 * GetNumOfGPCivilOfType(iPlayer)
	end
	return 0;
end

function DoTryToSpawnUnitInUndamagedCity(iPlayer, unitType)
--only land support!
	local cc = {}
	for iCity in Players[iPlayer]:Cities() do
		if iCity:GetDamage() == 0 then
			table.insert(cc, iCity:Plot())
		end
	end
	if #cc > 0 then
		local lPlot = cc[LastRandom(1,#cc)];
		SimpleGenerateUnitOfType(iPlayer, unitType, lPlot, nil, nil, true, true)
	end
end

function HealUnitsOfType(iPlayer, type, heal)
	for iUnit in Players[iPlayer]:Units() do
		if iUnit:GetUnitType() == type then
			iUnit:ChangeDamage(-heal);
		end
	end
end

function GetNumAdjacentUnitsOfTypeToPlot(iPlot, iPlayer, unitType, unitID)
	local tv = 0;
	for iUnit in Players[iPlayer]:Units() do
		if (iUnit:GetUnitType() == unitType) and (iUnit:GetID() ~= unitID) then
			if Map.PlotDistance(iPlot:GetX(), iPlot:GetY(), iUnit:GetX(), iUnit:GetY()) == 1 then
				tv = tv + 1;
			end
		end
	end
	return tv;
end

function DoSamuraiCombatStr(iUnit, iPlayer, unitType)
	if gT.Players[iPlayer] then	
		local uID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
		if not gT.Players[iPlayer].UnitsByID[uID].FoughtTypes then
			gT.Players[iPlayer].UnitsByID[uID].FoughtTypes = {};
		end
		if not gT.Players[iPlayer].UnitsByID[uID].FoughtTypes[unitType] then
			gT.Players[iPlayer].UnitsByID[uID].FoughtTypes[unitType] = true;
			ChangeITGBaseCombatStrength(iUnit, 1, nil)
		end
	end
end

function DoEffectsUponRebelesSpawning(iPlayer)
	for iUnit in Players[iPlayer]:Units() do
		if iUnit:GetUnitType() == GameInfoTypes.UNIT_ITG_TRIAL_KNIGHT_9 then
			iUnit:ChangeTemporaryCombatStrength(3);
			iUnit:ChangeTemporaryMoves(3)
		end
	end
end

function GetBestUnitClassToUnlock(iPlayer, options) -- exclude naval units if civ is landlocked
	local tab = Shuffle(options)
	local reserveClasses = {};
	for i, lClass in pairs(tab) do
		local unitType = Players[iPlayer]:GetPlayerUniqueUnit(lClass);
		if GetBestPlotForNewUnitSimple(iPlayer, GameInfo.Units[unitType].Domain) then
			return lClass;
		else
			table.insert(reserveClasses, lClass);
		end
	end
	if #reserveClasses > 0 then
		return RandomFromTab(reserveClasses);
	end
	print("Que 45.123/1323?", iPlayer, #options)
	return nil;
end

function GetUnitClassesToUnlock(iPlayer, pTab)
	local tab = {};
	local pTeam = Teams[Players[iPlayer]:GetTeam()];
	for class, sth in pairs(gT.Players[iPlayer].UnitClassXP) do
		if IsUnitClassValidToBeUnlocked(iPlayer, pTeam, pTab, class) then
			table.insert(tab, class)
		end
	end
	return tab;
end

function IsUnitClassValidToBeUnlocked(iPlayer, pTeam, pTab, class)
	if not gT.Players[iPlayer].AltUnlockUnits[class] then
		local iUnitType = Players[iPlayer]:GetPlayerUniqueUnit(class);
		if iUnitType ~= -1 then
			local techType = GameInfo.Units[iUnitType].PrereqTech;
			if techType then
				local techID = GameInfoTypes[techType];
				if (not pTeam:IsHasTech(techID)) then
					if (not GameInfo.Technologies[techID].IsInnovation) or gT.Globals.GlobalizationTech then
						if not GetPlayerDisabledTechs(iPlayer)[techID] then
							if not gT.Players[iPlayer].CannotHaveTech[techID] then
								if not Players[iPlayer]:IsUnitTechRequirementOverridden(iUnitType) then
									if AnyMajorPlayerHasTech(techID, pTab) then
										if HasResourceReqForUnlock(pTeam, iPlayer, iUnitType) then
											return true;
										end
									end
								end
							end
						end
					end
				end
			end
		end
	end
	return false;
end

function HaveUnlockedUnitClass(iPlayer, class, type)
	local iUnit = Players[iPlayer]:GetPlayerUniqueUnit(class);
	if iUnit == -1 then
		return false;
	end
	if Players[iPlayer]:IsUnitTechRequirementOverridden(iUnit) then
		return false;
	end
	local techType = GameInfo.Units[iUnit].PrereqTech;
	if not techType then
		return false;
	end
	local techID = GameInfo.Technologies[techType].ID;
	if Teams[Players[iPlayer]:GetTeam()]:IsHasTech(techID) then
		return false;
	end
	DoUnlockUnitClass(iPlayer, class, type)
	return true;
end

function DoUnlockUnitClass(iPlayer, class, type)
	local iUnit = Players[iPlayer]:GetPlayerUniqueUnit(class);
	local techType = GameInfo.Units[iUnit].PrereqTech;
	local techID = GameInfoTypes[techType];
	gT.Players[iPlayer].AltUnlockUnits[class] = {techID, type};
	Players[iPlayer]:DoOverideUnitTechRequirement(iUnit, true)
	DiploNoteDirty(iPlayer, 36)
	if (iPlayer == Game.GetActivePlayer()) and (type ~= -1) then
		LuaEvents.ITG_TechTreeDirty()
		local strName = Locale.Lookup(GameInfo.Units[iUnit].Description)
		Players[iPlayer]:AddNotification(94343293, "We can now train " .. strName .. ".",  strName .. " unlocked", -1, -1, 37)
	end
end

function OnSetHasTechCheckForUnlockedUnits(iPlayer, tech)
	for class, data in pairs(gT.Players[iPlayer].AltUnlockUnits) do
		if data[1] == tech then
			if data[2] == "Gold" then
				gT.Players[iPlayer].UnitClassXP[class] = gT.Players[iPlayer].UnitClassXP[class] + 100;
			elseif data[2] == "Military" then
				gT.Players[iPlayer].UnitClassXP[class] = gT.Players[iPlayer].UnitClassXP[class] + 100;
			elseif data[2] == "Religious" then
				gT.Players[iPlayer].UnitClassXP[class] = gT.Players[iPlayer].UnitClassXP[class] + 100;
			elseif data[2] == "Governor" then
				gT.Players[iPlayer].UnitClassXP[class] = gT.Players[iPlayer].UnitClassXP[class] + 100;
			elseif data[2] == "Inno" then
				gT.Players[iPlayer].UnitClassXP[class] = gT.Players[iPlayer].UnitClassXP[class] + 100;
			elseif data[2] == "Social" then
				gT.Players[iPlayer].UnitClassXP[class] = gT.Players[iPlayer].UnitClassXP[class] + 100;
			end
			-- it does not seem like they will be any unique one...
		end
	end
end

function GetITGNumMilitaryUnits(iPlayer)
	local t = 0;
	for iUnit in Players[iPlayer]:Units() do
		if gT.Players[iPlayer].UnitClassXP[iUnit:GetUnitClassType()] then
			t = t + 1;
		end
	end
	return t;
end

function GetPlayerUnitclassDomain(iPlayer, iClass)
	local unittype = Players[iPlayer]:GetPlayerUniqueUnit(iClass);
	if unittype ~= -1 then
		return GameInfo.Domains[GameInfo.Units[unittype].Domain].ID;
	end
	local defUnit = GameInfo.UnitClasses[iClass].DefaultUnit;
	return GameInfo.Domains[GameInfo.Units[defUnit].Domain].ID;
end

function AddUnitclassPromotion(iPlayer, iClass, iPromotion, bRandomIfAlready)
	if gT.Players[iPlayer].UnitClassPromotions[iClass][iPromotion] then
		if bRandomIfAlready then
			AssignRandomUnitclassPromotion(iPlayer, iClass)
		end
	elseif GetAvailablePromForClass(iClass)[iPromotion] then
		AssignUnitclassPromotion(iClass, iPlayer, iPromotion)
	end
end

function AssignRandomUnitclassPromotion(iPlayer, iClass)
	local type = GetHelpTypeOfUnitClassITG(iPlayer, iClass);
	local hTab = {}
	if type then
		for promID, sth in pairs(PromotionTreesTypes[type] or {}) do
			if not gT.Players[iPlayer].UnitClassPromotions[iClass][promID] then
				if CanHaveITGPRomotion(iClass, iPlayer, promID) then
					table.insert(hTab, promID);
				end
			end
		end
	end
	if #hTab > 0 then
		AssignUnitclassPromotion(iClass, iPlayer, RandomFromTab(hTab))
	end
end