local dWonderProcess = GameInfoTypes.PROCESS_ITG_WONDER;
local leshanbuddha1 = GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_35;
local beliefpanth11 = GameInfoTypes.BELIEF_ITG_PANTHEON_11;
local belieffollower26 = GameInfoTypes.BELIEF_ITG_FOLLOWER_26;
local innoindu5 = GameInfoTypes.TECH_UNIQUE_ITG_INDUSTRIAL_5
local ancemptech13 = GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_EMPIRE_13;
local wonderrailroad = GameInfoTypes.BUILDING_ITG_NEW_INDUSTRIAL_WONDER_15;
local templeofsolomon1 = GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_34;
local WonderPreferReligion = {
[GameInfoTypes.BUILDING_ITG_NEW_MEDIEVAL_WONDER_15] = true,
[GameInfoTypes.BUILDING_ITG_NEW_WORLD_WONDER_6] = true,
[GameInfoTypes.BUILDING_ITG_NEW_MEDIEVAL_WONDER_2] = true,
}

function BorobudurPlayerCheck(iPlayer)
	if not gT.Players[iPlayer].SecularState then
		if Players[iPlayer]:GetReligionCreatedByPlayer() <= 0 then
			return true;
		end
	end
	return false;
end

function GZigguratPlayerCheck(iPlayer)
	return (gT.Players[iPlayer].StAlphabet ~= iPlayer)
end

local WonderFuncCheck = {
[GameInfoTypes.BUILDING_ITG_NEW_WORLD_WONDER_9] = BorobudurPlayerCheck,
[templeofsolomon1] = BorobudurPlayerCheck,
[GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_15] = GZigguratPlayerCheck
}

function GetModifierPenaltyFromNumberOfCities(iPlayer)
	if Players[iPlayer]:GetNumCities() > 1 then
		return - (Players[iPlayer]:GetNumCities() - 1) * 0.01;
	end
	return 0;
end

function BoostWonderProduction(iPlayer, base, bMod)
	local boost = base;
	local mod = 1;
	if bMod then
		mod = mod + GetModifierPenaltyFromNumberOfCities(iPlayer)
		boost = math.floor(100 * boost * (mod) + 0.5) / 100;
	end
	gT.Players[iPlayer].WonderProduction = gT.Players[iPlayer].WonderProduction + boost;
	gT.Players[iPlayer].AIWonderLog[GetITGGameTurn()] = (gT.Players[iPlayer].AIWonderLog[GetITGGameTurn()] or 0) + boost;
	if gT.Players[iPlayer].CultBonusOn[23] then
		BoostArtisticPoints(iPlayer,  math.ceil(0.15 * boost), bMod)
	end
end

function GetFaithCultureFromWonderProcess(iPlayer)
	local base = 0;
	if gT.Players[iPlayer].HasPlayerWonder[leshanbuddha1] then
		base = base + math.floor(GetEstimatedWonderPointsFromProcess(iPlayer) / 4)
	end
	return base;
end

function GetEstimatedWonderPointsCityFromProcess(iCity)
	if iCity:GetProductionProcess() == dWonderProcess then
		if WillITGCityAbleToWorkNextTurn(iCity) then
			local baseWonder = iCity:GetCurrentProductionDifferenceTimes100(false, false);
			return math.floor(baseWonder * GetTotalWonderProcessMod(iCity, iPlayer) ) / 100;
		end
	end
	return 0; 
end

function GetTotalWonderProcessMod(iCity, iPlayer)
	return 1 + GetPercentModifierGreatWonderBelief(iCity) / 100 + 0.5 * GetNumCityManufactoryTrait(iCity, 19)
end

function GetEstimatedWonderPointsFromProcess(iPlayer, bEndTurn)
	local boost = 0;
	local ailog, ailog2 = 0, 0
	for iCity in Players[iPlayer]:Cities() do
		if iCity:GetProductionProcess() == dWonderProcess then
			if WillITGCityAbleToWorkNextTurn(iCity) then
				local baseWonder = iCity:GetCurrentProductionDifferenceTimes100(false, false) --/ 100
				boost = boost + math.floor(baseWonder * GetTotalWonderProcessMod(iCity, iPlayer)) / 100; -- here divided
				ailog2 = ailog2 + 1;
			end
		else
			ailog = ailog + 1;
		end
	end
	if bEndTurn then
		table.insert(gT.Players[iPlayer].AIWonderProjectLog, ailog2 / math.max(1,ailog + ailog2))
	end
	return boost;
end

function GreatWonderOverFunction()
	if gT.Globals.ScenarioType ~= 5 then
		local turnOfSolution = ((GetITGGameTurn()+1)%10  == 0) and (GetITGGameTurn() > 5)
		for gplayer, gdata in pairs(gT.Players) do
			if gdata.CanWonderRace then
				local boost = GetEstimatedWonderPointsFromProcess(gplayer, true); -- purely AI help other than turnOfSolution
				if turnOfSolution then
					if gdata.HasPlayerWonder[leshanbuddha1] then
						ChangeITGFaith(gplayer, math.floor(boost/4))
						ChangeITGCulture(gplayer, math.floor(boost/4))
					end
					BoostWonderProduction(gplayer, boost, true)
				end
			end
		end
		if turnOfSolution then
			if not gT.Globals.NoMoreWonderRace then
				if DBScenario.WonderCultureGroup then
					CultureWonderRaceSolution()
				else
					BasicWonderRaceSolution()
				end
				EndWonderRaceDoWonderDemoMin()
				if not gT.Globals.NoMoreWonderRace then
					for gplayer, gdata in pairs(gT.Players) do
						if gdata.CanWonderRace then
							if not Players[gplayer]:IsHuman() then
								DecideIfPlayerShouldLetWondersGo(gplayer)
							end
						end
					end
				end
				DoAIScriptOnWonderRaceBeingResolved()
			end
		end
	end
end


function GetValueForWonder(iCity)
	local value = LastRandom(1,20) + iCity:GetPopulation();
	return value;
end

function GetValidWonderToClaim(iPlayer)
	if #gT.Globals.ValidWondersForRace > 0 then
		if #gT.Globals.ValidWondersForRace > 1 or gT.Globals.NoMoreWonderRace then
			local lkey = GetProperWonderIfPossible(iPlayer);
			local iBuilding = gT.Globals.ValidWondersForRace[lkey];
			table.remove(gT.Globals.ValidWondersForRace, lkey)
			return iBuilding;
		end
	end
	return nil
end

function GetProperWonderIfPossible(iPlayer)
	local vTab = {}
	for i, wonderID in pairs(gT.Globals.ValidWondersForRace) do
		if not iPlayer then
			table.insert(vTab, i)
		else
			if (not WonderPreferReligion[wonderID]) or (Players[iPlayer]:GetReligionCreatedByPlayer() > 0) then
				if (not WonderFuncCheck[wonderID]) or WonderFuncCheck[wonderID](iPlayer) then
					for iCity in Players[iPlayer]:Cities() do
						if CheckIfCityCanBuildWonder(iCity, wonderID) then
							table.insert(vTab, i)
							break;
						end
					end
				end
			end
		end
	end
	if #vTab > 0 then
		return vTab[LastRandom(1,#vTab)];
	end
	return LastRandom(1,#gT.Globals.ValidWondersForRace);
end

--ON CONSTRUCTION STUFF

local sistineChapel1 = GameInfoTypes.BUILDING_ITG_NEW_WORLD_WONDER_1
local himejiCastle1 = GameInfoTypes.BUILDING_ITG_NEW_WORLD_WONDER_2;
local tChivlary = GameInfoTypes.TECH_CHIVALRY
local hagiasophia1 = GameInfoTypes.BUILDING_ITG_NEW_WORLD_WONDER_4;
local angkor1 = GameInfoTypes.BUILDING_ITG_NEW_WORLD_WONDER_5;
local djenne1 = GameInfoTypes.BUILDING_ITG_NEW_WORLD_WONDER_6;
local porcelain1 = GameInfoTypes.BUILDING_ITG_NEW_WORLD_WONDER_7;
local alhambra1 = GameInfoTypes.BUILDING_ITG_NEW_WORLD_WONDER_8;
local borodur1 = GameInfoTypes.BUILDING_ITG_NEW_WORLD_WONDER_9;
local redfort1 = GameInfoTypes.BUILDING_ITG_NEW_WORLD_WONDER_10;
local azharWonder1 = GameInfoTypes.BUILDING_ITG_NEW_MEDIEVAL_WONDER_4
local catacomsb1med = GameInfoTypes.BUILDING_ITG_NEW_MEDIEVAL_WONDER_2
local longleat1 = GameInfoTypes.BUILDING_ITG_NEW_WORLD_WONDER_13;
local greatwall1 = GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_5;
local oracle1 = GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_7;
local terrac1 = GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_10;
local abumsimbel1 = GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_21;
local duomo1 = GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_13;
local ziggurat1 = GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_15; 
local bGateSune1 = GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_17;
local stpeterbasilic1 = GameInfoTypes.BUILDING_ITG_NEW_WORLD_WONDER_16;
local hawamahal1 = GameInfoTypes.BUILDING_ITG_NEW_WORLD_WONDER_18;
local greatlibrary1 = GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_3;
local globetheather1 = GameInfoTypes.BUILDING_ITG_NEW_WORLD_WONDER_19;
local heaventemple1 = GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_28;
local topkapipalace1 = GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_27;
local westabbey1 = GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_26;
local domeoftherock1 = GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_25;
local shepagoda1 = GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_24;
local hangingtemple1 = GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_23;
local potala1 = GameInfoTypes.BUILDING_ITG_NEW_WORLD_WONDER_24;
local placmarka1 = GameInfoTypes.BUILDING_ITG_NEW_WORLD_WONDER_25;
local hassantower1 = GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_30;
local someburmesetemple1 = GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_31;
local samarra1 = GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_32;
local armenianCatacombs1 = GameInfoTypes.BUILDING_ITG_NEW_MEDIEVAL_WONDER_3
local cairocitadel1 = GameInfoTypes.BUILDING_ITG_NEW_MEDIEVAL_WONDER_1
local malborkcastle1 = GameInfoTypes.BUILDING_ITG_NEW_MEDIEVAL_WONDER_7
local oxforduni1 = GameInfoTypes.BUILDING_ITG_NEW_MEDIEVAL_WONDER_8
local stonehenge1 = GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_2;
local goblotroblo1 = GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_46;
local bananawonder1 = GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_47;
local aquebride1 = GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_48;
local gmedwonder10 = GameInfoTypes.BUILDING_ITG_NEW_MEDIEVAL_WONDER_10;
local medwonder9 = GameInfoTypes.BUILDING_ITG_NEW_MEDIEVAL_WONDER_9
local medwonder13 = GameInfoTypes.BUILDING_ITG_NEW_MEDIEVAL_WONDER_13;
local induwonder1 = GameInfoTypes.BUILDING_ITG_NEW_INDUSTRIAL_WONDER_1
local flatro1 = GameInfoTypes.BUILDING_ITG_NEW_INDUSTRIAL_WONDER_20;
local indowonder7 = GameInfoTypes.BUILDING_ITG_NEW_INDUSTRIAL_WONDER_7;
local wonderindu8 = GameInfoTypes.BUILDING_ITG_NEW_INDUSTRIAL_WONDER_8;
local wonderindu13 = GameInfoTypes.BUILDING_ITG_NEW_INDUSTRIAL_WONDER_13
local wonderindu9 = GameInfoTypes.BUILDING_ITG_NEW_INDUSTRIAL_WONDER_9;
local induwonder19 = GameInfoTypes.BUILDING_ITG_NEW_INDUSTRIAL_WONDER_19
local palacevo1 = GameInfoTypes.BUILDING_ITG_NEW_INDUSTRIAL_WONDER_23
local palaceriofrio1 = GameInfoTypes.BUILDING_ITG_NEW_INDUSTRIAL_WONDER_22
local hangGarden = GameInfoTypes.BUILDING_ITG_PRE_NEW_WORLD_WONDER_8
local penaPalace = GameInfoTypes.BUILDING_ITG_NEW_INDUSTRIAL_WONDER_27
local grandbridge = GameInfoTypes.BUILDING_ITG_NEW_WORLD_WONDER_33;
local hardwickhall = GameInfoTypes.BUILDING_ITG_NEW_WORLD_WONDER_32
local dhamekStupa = GameInfoTypes.BUILDING_ITG_NEW_MEDIEVAL_WONDER_16
local prambanan = GameInfoTypes.BUILDING_ITG_NEW_MEDIEVAL_WONDER_15
local nwWonder17 = GameInfoTypes.BUILDING_ITG_NEW_WORLD_WONDER_17;

function WonderConstructed(iPlayer, iCity, cID, wonderID)
	TakeCareOfEventMorale(iPlayer, 2)
	BoostGovernorPowerInCity(iCity, "Wonders", 2, true, true)
	gT.Wonders[wonderID] = iCity:Plot():GetPlotIndex();
	HnGLogWonderData(wonderID, "ConstructT", GetITGGameTurn())
	gT.Players[iPlayer].NumWondersBuild = gT.Players[iPlayer].NumWondersBuild + 1;
	WonderAssigned(iCity, iPlayer, wonderID)
	WonderRuinsCityDirty(iCity)
	if HasPlayerTech(iPlayer, innoindu5, "vokeode") then
		gT.Players[iPlayer].Ind5NatUnity = gT.Players[iPlayer].Ind5NatUnity + 1;
		ChangeMeritocracy(iPlayer, 1)
	end
	if gT.Players[iPlayer].GlobalCultPresFromWonder > 0 then
		AddCulturalPresenceWorldWide(iPlayer, gT.Players[iPlayer].GlobalCultPresFromWonder, nil, false)
	end
	if sistineChapel1 == wonderID then
		CreateGreatWorkOfAmount(iPlayer, 3)
	elseif ziggurat1 == wonderID then
		if gT.Players[iPlayer].StAlphabet ~= iPlayer then
			LinkPlayerDoStandardiseAlphabet(iPlayer)
		end
	elseif palaceriofrio1 == wonderID then
		DoChangeCityCultureOwnership(cID, iCity, iPlayer, 250)
	elseif grandbridge == wonderID then
		DoInitialBridgeWonder(iPlayer)
	elseif wonderindu9 == wonderID then
		AppointNewGovernor(iPlayer)
	elseif prambanan == wonderID then
		UpdatePressureOfAllHolySites()
	elseif penaPalace == wonderID then
		local freePalaces = gT.Players[iPlayer].CultureEra - 1;
		if freePalaces > 0 then
			AddFreePalaceUpgrade(iPlayer, freePalaces)
		end
	elseif wonderindu13 == wonderID then
		GenerateNewCivilianGP(iPlayer, false, GetITGGameTurn(), {Type = 6})
	elseif armenianCatacombs1 == wonderID then
		SetBasicCityYieldRate(iCity, yScience, math.floor(GetCityMajorityReligionPressure(iCity) / 10), "CI_ETCH_CATHEDRAL")
	elseif medwonder9 == wonderID then
		gT.Players[iPlayer].HolySitePoints = gT.Players[iPlayer].HolySitePoints + 1;
 	elseif goblotroblo1 == wonderID then
		local bHuman = Players[iPlayer]:IsHuman();
		local hTeam = Players[iPlayer]:GetTeam();
		for index, data in pairs(gT.Globals.AncientRuins) do
			local iPlot = Map.GetPlotByIndex(index)
			if iPlot:AlreadyVisitedGoodyHut(hTeam) then
				iPlot:SetAlreadyVisitedGoodyHut(hTeam, false)
				if bHuman then
					AddSmallInfo(iPlot, nil, "AncientRuin", nil, nil, nil, nil, iPlayer)
				end
			end
		end
	elseif bananawonder1 == wonderID then
		for i = 0, iCity:GetNumCityPlots() - 1 do
			local fPlot = iCity:GetCityIndexPlot( i );
			if fPlot then
				if fPlot:GetOwner() == iPlayer then
					if fPlot:GetImprovementType() == GameInfoTypes.IMPROVEMENT_FARM then
						AddBasicYieldIfNotPillaged(fPlot, yFood, 1)
					end
				end
			end
		end
	elseif greatlibrary1 == wonderID then
		local tabAca = {}
		for h, s in pairs(gT.Academies) do
			if s.Player == iPlayer then
				table.insert(tabAca, h);
			end
		end
		if #tabAca > 0 then
			local lAca = tabAca[LastRandom(1,#tabAca)];
			for i = 1, 4 do
				AddBonusToAcademy(lAca, "Random")
			end
		else
			table.insert(gT.Players[iPlayer].AcademyPoints, "FREE")
		end
	elseif indowonder7 == wonderID then
		table.insert(gT.Players[iPlayer].AcademyPoints, "FREE")
	elseif catacomsb1med == wonderID then
		local iRel = Players[iPlayer]:GetReligionCreatedByPlayer();
		if iRel > 0 then
			AddRandomTemplarBeliefValid(iRel)
		end
	elseif someburmesetemple1 == wonderID then
		BoostHappinessInAllCities(iPlayer, 15)
	elseif stonehenge1 == wonderID then
		if Players[iPlayer]:GetReligionCreatedByPlayer() > 0 then
			gT.Players[iPlayer].HolySitePoints = gT.Players[iPlayer].HolySitePoints + 1;
		else
			DoAddNewBeliefOfType(iPlayer, 1)
			DoAddNewBeliefOfType(iPlayer, 1)
		end
	elseif placmarka1 == wonderID then
		for row in GameInfo.Buildings() do
			if row.GoldMaintenance > 0 then
				if iCity:GetNumRealBuilding(row.ID) == 1 then
					iCity:SetNumFreeBuilding(row.ID, 1)
					iCity:SetNumRealBuilding(row.ID, 0)
				end
			end
		end
	elseif gmedwonder10 == wonderID then
		table.insert(gT.Players[iPlayer].AcademyPoints, "FREE")
	elseif terrac1 == wonderID then
		gT.Players[iPlayer].NumRealFreePromotions = 2 + gT.Players[iPlayer].NumRealFreePromotions;
	elseif alhambra1 == wonderID then
		gT.Players[iPlayer].NumRealFreePromotions = 2 + gT.Players[iPlayer].NumRealFreePromotions;
	elseif borodur1 == wonderID then
		if not gT.Players[iPlayer].SecularState then
			if Players[iPlayer]:GetReligionCreatedByPlayer() <= 0 then
				DoNewReligion(iPlayer, iCity)
				SetOfficialReligion(iPlayer, Players[iPlayer]:GetReligionCreatedByPlayer());
				gT.Players[iPlayer].FreeMissioniares = gT.Players[iPlayer].FreeMissioniares + 8;
			end
		end
	elseif templeofsolomon1 == wonderID then
		if Players[iPlayer]:GetReligionCreatedByPlayer() < 1 then
			DoNewReligion(iPlayer, iCity)
		end
	elseif greatwall1 == wonderID then
		gT.Players[iPlayer].NumFortPoints = gT.Players[iPlayer].NumFortPoints + 3;	
	elseif redfort1 == wonderID then
		gT.Players[iPlayer].NumFortPoints = gT.Players[iPlayer].NumFortPoints + 1;
	elseif oracle1 == wonderID then
--		if Players[iPlayer]:IsHuman() then
--			gT.Players[iPlayer].HumanQueueActions["ORACLE CULTURAL BONUS"] = PrepareExtraDataForHumanCultureBonus(iPlayer, "Oracle grants free Cultural Bonus.");
--		else
--			AIPlayerChooseCultureBonus(iPlayer)
--		end
	elseif wonderID == heaventemple1 then
		DoGrantRandomInnovationIfPossible(iPlayer)
	elseif domeoftherock1 == wonderID then
--		local iRel = GetITGReligion(iPlayer)
--		if iRel > 0 then
--			iCity:ChangeBaseReligionPressure(iRel, 50)
--		end
	elseif globetheather1 == wonderID then
		GenerateNewCivilianGP(iPlayer, nil, nil, {Type = 7, Player = iPlayer, City = iCity})
	elseif longleat1 == wonderID then
		ChangeITGLegalPointsPercent(iPlayer, 500)
	elseif duomo1 == wonderID then
		DoDuomoGoldenAgeBonus(iPlayer)
	end
	--bonuses upon construction any wonder
	if HasPlayerTech(iPlayer, ancemptech13, "deaqeadde") then
		ChangeITGHappinessInTheCity(iCity, 5, nil, "plvplerfe")
	end
	DoBoostUnitOfTypeCS(iPlayer, GameInfoTypes.UNIT_ITG_AOT_SPEARMAN_EGYPT, 1)
end

function CanDoWonderRaceRightNow(iPlayer, tag)
	if tag then
		if tag == "Faith" then
			if gT.Globals.ScenarioType == 4 then
				return false;
			end
		end
	end
	if (not gT.Globals.NoMoreWonderRace) then
		if (not gT.Players[iPlayer].CanWonderRace) then
			if (not gT.Players[iPlayer].NoMoreWonderRace) then
				return true;
			end
		end
	end
	return false;
end

function CanDoWonderBoost(iPlayer, tag)
	if tag then
		if tag == "Faith" then
			if gT.Globals.ScenarioType == 4 then
				return false;
			end
		end
	end
	if gT.Players[iPlayer].CanWonderRace then
		if (not gT.Players[iPlayer].CannotWonderBoost) then
			return true;
		end
	end
	return false;
end

function WonderAssigned(iCity, iPlayer, wonderID, bConq)
	gT.Players[iPlayer].HasPlayerWonder[wonderID] = true;
	gT.Wonders[wonderID] = iCity:Plot():GetPlotIndex();
	AssignConstructingPlayer(wonderID, iPlayer)
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	if not bConq then
		gT.Cities[cID].NumWonders = gT.Cities[cID].NumWonders + 1;
	end
	if greatwall1 == wonderID then
		DirtyUpdateAllFortsPower()
	elseif wonderID == nwWonder17 then
		gT.Players[iPlayer].BaseGPFromHap = gT.Players[iPlayer].BaseGPFromHap + 5;
	elseif hangGarden == wonderID then
		Players[iPlayer]:SetPlagueWorking(true)
	elseif flatro1 == wonderID then
		Players[iPlayer]:ChangeBuildingProductionModifier(33)
	elseif aquebride1 == wonderID then
		Teams[Players[iPlayer]:GetTeam()]:SetHasTech(GameInfoTypes.TECH_ITG_DUMMY_WONDER_PRE_49, true)
	elseif palaceriofrio1 == wonderID then
		Players[iPlayer]:ChangeCombatVSRebels(25)
	elseif hardwickhall == wonderID then
		if not gT.Players[iPlayer].HardwickTab then
			DoTriggerHardwickHall(iPlayer)
		else
			for i, class in pairs(gT.Players[iPlayer].HardwickTab) do
				Players[iPlayer]:ChangeBuildingClassProdModifier(iClass, 33)
			end
		end
	elseif wonderrailroad == wonderID then
		gT.Players[iPlayer].RailroadsPT = gT.Players[iPlayer].RailroadsPT + 2; 
	elseif oxforduni1 == wonderID then
		gT.Globals.OfxordUni = iPlayer;
	elseif wonderindu9 == wonderID then
		gT.Players[iPlayer].ExtraMaxGovernors = gT.Players[iPlayer].ExtraMaxGovernors + 1;
	elseif dhamekStupa == wonderID then
		if gT.Globals.DhamekStupa then
			iCity:ChangeJONSCulturePerTurnFromBuildings(gT.Globals.DhamekStupa)
			iCity:ChangeFaithPerTurnFromBuildings(gT.Globals.DhamekStupa)
		end
	elseif induwonder19 == wonderID then
		if gT.Globals.GameGenerated then
			UpdateAllTheBonusOfCultureEras()
		end
	elseif catacomsb1med == wonderID then
		UpdateOverRiderFaithCost(iPlayer)
	elseif wonderindu8 == wonderID then
		gT.Players[iPlayer].GWCultureIntoNU = gT.Players[iPlayer].GWCultureIntoNU + 0.5;
	elseif cairocitadel1 == wonderID then
		UpdateGoldCostToPurchaseLegalAuthority(iPlayer)
	elseif gmedwonder10 == wonderID then
		for g, aca in pairs(gT.Academies) do
			if aca.Player == iPlayer then
				if not aca.SultanHassan then
					gT.Academies[g].SultanHassan = true;
					if aca.Bonuses["Faith"] then
						for i = 1, 4 do
							AddBonusToAcademy(g, "Faith")
						end
					end
				end
			end
		end
	elseif induwonder1 == wonderID then
		Players[iPlayer]:ChangeCombatModVSSmallerCivs(33)
	elseif wonderID == azharWonder1 then
		gT.Globals.AzharWpi = iCity:Plot():GetPlotIndex();
	elseif shepagoda1 == wonderID then
		iCity:ChangeMinimumYieldFromPlot(yFaith, 1);
	elseif abumsimbel1 == wonderID then
		SetCanUseMissionares(iPlayer)
	elseif hangingtemple1 == wonderID then
		gT.Players[iPlayer].CanPlaceHolySiteOnMountain = true;
		if gT.Globals.GameGenerated then
			DoNearbyHolySiteOnMountain(iPlayer, iCity)
		else
			gT.Globals.HangingTempleDelay = iCity:Plot():GetPlotIndex();
		end
	elseif himejiCastle1 == wonderID then
		for h, iClass in pairs({GameInfoTypes.BUILDINGCLASS_CASTLE, GameInfoTypes.BUILDINGCLASS_ARSENAL, GameInfoTypes.BUILDINGCLASS_MILITARY_BASE}) do
			Players[iPlayer]:ChangePlayerBuildingClassYieldChange(iClass, yCulture, 1);
			Players[iPlayer]:ChangeBuildingClassProdModifier(iClass, 100)
			HaveUnlockedBuildingClass(iPlayer, iClass, "Himeji")
		end
	elseif hagiasophia1 == wonderID then
		HagiaSophiaCheck(iCity)
	elseif samarra1 == wonderID then
		gT.Players[iPlayer].ReligiousTradePressure = gT.Players[iPlayer].ReligiousTradePressure + 1;
	elseif hassantower1 == wonderID then
		gT.Players[iPlayer].ConversionLossBonusesModifier = 1 + gT.Players[iPlayer].ConversionLossBonusesModifier
	elseif djenne1 == wonderID then
		UpdatePlayerReligionUnitsCost(iPlayer)
	elseif stpeterbasilic1 == wonderID then
		gT.Players[iPlayer].FounderBeliefModifier = gT.Players[iPlayer].FounderBeliefModifier + 1;
		Players[iPlayer]:ChangeFounderBeliefModifier(1);
	elseif stbasilcath1 == wonderID then
		for i = 1, 500 do
			if GameInfoTypes["BUILDINGCLASS_ITG_BELIEF_TEMPLE_" .. i] then
				ChangeExtraArtPointsFromBuildingClass(iPlayer, GameInfoTypes["BUILDINGCLASS_ITG_BELIEF_TEMPLE_" .. i], 2);
			else
				break;
			end
		end
		ChangeExtraArtPointsFromBuildingClass(iPlayer, GameInfoTypes.BUILDINGCLASS_TEMPLE, 2);
	elseif malborkcastle1 == wonderID then
		DoAddMalborkEffectOnExistingForts(iPlayer)
	elseif angkor1 == wonderID then
		if CanDoWonderRaceRightNow(iPlayer) then
			StartWonderRace(iPlayer)
		end
	elseif hawamahal1 == wonderID then
		gT.Players[iPlayer].GPNumTalentsOption = gT.Players[iPlayer].GPNumTalentsOption + 3;
	elseif ziggurat1 == wonderID then
		gT.Players[iPlayer].NumTechToChooseFrom = gT.Players[iPlayer].NumTechToChooseFrom + 1;
	elseif wonderID == heaventemple1 then
		gT.Players[iPlayer].InnovationChance = gT.Players[iPlayer].InnovationChance + 50;
	elseif porcelain1 == wonderID then
		local iTeam = Players[iPlayer]:GetTeam();
		for row in GameInfo.Technologies() do
			if row.Show then
				if not row.IsInnovation then
					if not Teams[iTeam]:IsHasTech(row.ID) then
						DoPorcelainCheck(iTeam, row.ID, iPlayer)
					end
				end
			end
		end
	elseif topkapipalace1 == wonderID then
		Players[iPlayer]:SetTopkapiPalace(20);
		gT.Players[iPlayer].TopkapiPalace = true;
		for i, plot in pairs(GetPlotsInRadiusOfPlot(iCity:Plot(), 3)) do
			plot:SetTopkapiPalaceNearby(true);
		end
	elseif palacevo1 == wonderID then
		gT.Globals.Vorontsov = {}
		local yTab = {yFood, yGold, yProduction, yScience, yCulture, yFaith}
		for i, plot in pairs(GetPlotsInRadiusOfPlot(iCity:Plot(), 3)) do
			local cYield = yTab[LastRandom(1,#yTab)]
			Game.SetPlotExtraYield(plot:GetX(), plot:GetY(), cYield, 1)
			gT.Globals.Vorontsov[plot:GetPlotIndex()] = cYield;
		end
	end
end

function WonderWasConquered(newPlayer, jPlayer, wonderID, iCity, bForce)
	if not bForce then
		gT.Players[newPlayer].HasPlayerWonder[wonderID] = true;
		WonderAssigned(iCity, newPlayer, wonderID, true)
	end
	gT.Players[jPlayer].HasPlayerWonder[wonderID] = nil;
	if djenne1 == wonderID then
		UpdatePlayerReligionUnitsCost(jPlayer)
	elseif hangGarden == wonderID then
		Players[jPlayer]:SetPlagueWorking(false)
	elseif palaceriofrio1 == wonderID then
		Players[jPlayer]:ChangeCombatVSRebels(-25)
	elseif flatro1 == wonderID then
		Players[jPlayer]:ChangeBuildingProductionModifier(-33)
	elseif wonderindu8 == wonderID then
		gT.Players[jPlayer].GWCultureIntoNU = gT.Players[jPlayer].GWCultureIntoNU - 0.5;
	elseif induwonder1 == wonderID then
		Players[jPlayer]:ChangeCombatModVSSmallerCivs(-33)
	elseif wonderindu9 == wonderID then
		gT.Players[jPlayer].ExtraMaxGovernors = gT.Players[jPlayer].ExtraMaxGovernors - 1;
	elseif catacomsb1med == wonderID then
		UpdateOverRiderFaithCost(jPlayer)
	elseif wonderrailroad == wonderID then
		gT.Players[jPlayer].RailroadsPT = gT.Players[jPlayer].RailroadsPT - 2; 
	elseif hangingtemple1 == wonderID then
		gT.Players[jPlayer].CanPlaceHolySiteOnMountain = false;
	elseif aquebride1 == wonderID then
		Teams[Players[jPlayer]:GetTeam()]:SetHasTech(GameInfoTypes.TECH_ITG_DUMMY_WONDER_PRE_49, false)
	elseif stpeterbasilic1 == wonderID then
		gT.Players[jPlayer].FounderBeliefModifier = gT.Players[jPlayer].FounderBeliefModifier - 1;
		Players[jPlayer]:ChangeFounderBeliefModifier(-1);
	elseif samarra1 == wonderID then
		gT.Players[jPlayer].ReligiousTradePressure = gT.Players[jPlayer].ReligiousTradePressure - 1;
	elseif hawamahal1 == wonderID then
		gT.Players[jPlayer].GPNumTalentsOption = gT.Players[jPlayer].GPNumTalentsOption - 3;
	elseif greatwall1 == wonderID then
		DirtyUpdateAllFortsPower()
	elseif abumsimbel1 == wonderID then
		SetCanUseMissionares(jPlayer)
	elseif malborkcastle1 == wonderID then
		DoRemoveMalborkEffectOnExistingForts(jPlayer)
	elseif stbasilcath1 == wonderID then
		for i = 1, 500 do
			if GameInfoTypes["BUILDINGCLASS_ITG_BELIEF_TEMPLE_" .. i] then
				ChangeExtraArtPointsFromBuildingClass(jPlayer, GameInfoTypes["BUILDINGCLASS_ITG_BELIEF_TEMPLE_" .. i], -2);
			else
				break;
			end
		end
		ChangeExtraArtPointsFromBuildingClass(jPlayer, GameInfoTypes.BUILDINGCLASS_TEMPLE, -2);
	elseif himejiCastle1 == wonderID then
		for h, iClass in pairs({GameInfoTypes.BUILDINGCLASS_CASTLE, GameInfoTypes.BUILDINGCLASS_ARSENAL, GameInfoTypes.BUILDINGCLASS_MILITARY_BASE}) do
			Players[jPlayer]:ChangePlayerBuildingClassYieldChange(iClass, yCulture, -1);
			Players[jPlayer]:ChangeBuildingClassProdModifier(iClass, -100)
		end
	elseif hardwickhall == wonderID then
		for i, class in pairs(gT.Players[jPlayer].HardwickTab) do
			Players[jPlayer]:ChangeBuildingClassProdModifier(iClass, -33)
		end
	elseif wonderID == heaventemple1 then
		gT.Players[jPlayer].InnovationChance = gT.Players[jPlayer].InnovationChance - 50;
	elseif hassantower1 == wonderID then
		gT.Players[jPlayer].ConversionLossBonusesModifier = gT.Players[jPlayer].ConversionLossBonusesModifier - 1;
	elseif topkapipalace1 == wonderID then
		gT.Players[jPlayer].TopkapiPalace = false;
		Players[jPlayer]:SetTopkapiPalace(0);
	elseif ziggurat1 == wonderID then
		gT.Players[jPlayer].NumTechToChooseFrom = gT.Players[jPlayer].NumTechToChooseFrom - 1
	end
end

function DoPorcelainCheck(iTeam, tech, iPlayer)
	local k, t = 0, 0;
	for g, gdata in pairs(gT.Players) do
		if Players[g]:IsAlive() then
			if not Players[g]:IsMinorCiv() then
				t = t + 1;
				if Teams[Players[g]:GetTeam()]:IsHasTech(tech) then
					k = k + 1;
				end
			end
		end
	end
	if k >= t / 2 then
		PlayerDiscoverTech(iPlayer, tech, nil, "hDT10")
	end
end

function GetRewardWonderPushProd()
	return math.min(600, gT.Globals.WonderTreshold);
end

function WonderEffectsDoTurn(iPlayer)
	if gT.Players[iPlayer].HasPlayerWonder[bGateSune1] then
		if season == 2 then
			DoIncreaseSettlerPoint(iPlayer, 1)
		end
	end
	if gT.Players[iPlayer].HasPlayerWonder[potala1] then
		gT.Players[iPlayer].PotalaCD = gT.Players[iPlayer].PotalaCD  + 1;
		if gT.Players[iPlayer].PotalaCD >= 8 then
			gT.Players[iPlayer].PotalaCD = 0;
			local csMinor = DoRandomCSImproveRelation(iPlayer)
			if csMinor and Players[iPlayer]:IsHuman() then
				Players[iPlayer]:AddNotification(NotificationTypes.NOTIFICATION_MINOR, "We have welcomed a delegation from [COLOR_POSITIVE_TEXT]" .. Players[csMinor]:GetName() .. "[ENDCOLOR] in Potala Palace (+" .. GetMinorCivFriendshipFromImproveRelation(iPlayer, csMinor) .. "[ICON_INFLUENCE]).", "Relations Improved", GetXXOfMinorCapital(csMinor, "x"), GetXXOfMinorCapital(csMinor, "y"))
			end
		end
	end
end

function DoRandomCSImproveRelation(iPlayer)
	local getCSTab = PreparedDataForInfluenceImprove(iPlayer);
	if #getCSTab.UniqueOptions > 0 then
		local luckyMinor = getCSTab.UniqueOptions[LastRandom(1,#getCSTab.UniqueOptions)].ID;
		LinkPlayerChooseImproveRelation(iPlayer, luckyMinor)
		return luckyMinor
	end
end

function HagiaSophiaCheck(iCity)
	for iRel, building in pairs(gT.TemplarRelBuilding) do
		if not iCity:IsHasBuilding(building) then
			iCity:SetNumFreeBuilding(building, 1);
		end
	end
end

function DoNearbyHolySiteOnMountain(iPlayer, iCity)
	local iRel = GetITGReligion(iPlayer)
	if iRel < 1 then
		iRel = nil;
	end
	local pPlot = GetPlotsInRadiusOfPlot(iCity:Plot(), 2);
	local hTab = {}
	for i, plot in pairs(pPlot) do
		if plot:IsMountain() and plot:GetOwner() == iPlayer then
			table.insert(hTab, plot)
		end
	end
	if #hTab > 0 then
		AddHolySiteToAPlot(hTab[LastRandom(1,#hTab)], iRel, iPlayer)
	end
end

function DoCatacombsWonderDisplay(x, y, reward, iPlayer)
	ChangeITGFaith(iPlayer, reward * 50)
	ChangeITGCulture(iPlayer, reward * 50)
	if iPlayer == Game.GetActivePlayer() then
		Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(x, y))), "+" .. reward * 50 .. "[ICON_PEACE]", 0.5)
		Events.AddPopupTextEvent(HexToWorld(ToHexFromGrid(Vector2(x, y))), "+" .. reward * 50 .. "[ICON_CULTURE]", 1)
	end
end

function BasicWonderRaceSolution()
	local hTab = {}
	local values = {}
	local PlayerScores = {}
	local yieldT = {}
	local gpT = {}
	local tBuilding = {};
	local luckywinner
	for gplayer, gdata in pairs(gT.Players) do
		if gdata.CanWonderRace then
			gT.Players[gplayer].CannotWonderBoost = nil;
			local val = 100 * gdata.WonderProduction;
			gT.Players[gplayer].LastWonderResult = gdata.WonderProduction;
			PlayerScores[gplayer] = val;
			if not hTab[val] then
				table.insert(values, val)
				hTab[val] = {gplayer}
			else
				table.insert(hTab[val], gplayer)
			end
		else
			gT.Players[gplayer].LastWonderResult = 0;
		end
	end
	if #values > 0 then
		table.sort(values, SortFunctionHighestInteger)
		local winnersTab = {}
		local bestleaguev, bestleagueID = -1, nil;
		local bTieInLeagues = true;
		for league, sth in pairs(gT.Leagues) do
			if sth.Resolutions[4] then
				local leaguescore = 0;
				for member, t in pairs(sth.Members) do
					if PlayerScores[member] then
						leaguescore = leaguescore + PlayerScores[member];
					end
				end
				if leaguescore > bestleaguev then
					bestleaguev = leaguescore;
					bTieInLeagues = false;
					bestleagueID = league;
				elseif leaguescore == bestleaguev then
					bTieInLeagues = true;
				end
			end
		end
		local winnerval = values[1];
		luckywinner = hTab[winnerval][1];
		local bTie = #hTab[winnerval] > 1;
		local victoriousleague;
		local ExtraPlayersToEraseAllWP = {}
		local lTeHTt = {}
		local rwinnerval = math.max(winnerval, bestleaguev);
		local bReachedTreshold = ((rwinnerval / 100) >= gT.Globals.WonderTreshold)
		if bestleaguev > winnerval then
			if bTieInLeagues then
				bTie = true;
			elseif bReachedTreshold then
				--determine victory in league :)
				local lRealWinner, lWinnerValue, bTieInLeagueInLeague = nil, -1, true;
				for member, sth in pairs(gT.Leagues[bestleagueID].Members) do
					lTeHTt[member] = 1;
					if PlayerScores[member] then
						if PlayerScores[member] > lWinnerValue then
							lWinnerValue =  PlayerScores[member];
							lRealWinner = member;
							bTieInLeagueInLeague = false;
						elseif lWinnerValue == PlayerScores[member] then
							bTieInLeagueInLeague = true;
						end
					end
					ExtraPlayersToEraseAllWP[member] = 1;
				end
				if bTieInLeagueInLeague then
					bTie = true;
					ExtraPlayersToEraseAllWP = {}
				else
					victoriousleague = bestleagueID;
					luckywinner = lRealWinner;
				end
			end
		end
		-- now votes for leagues
		for league, sth in pairs(gT.Leagues) do
			if sth.Resolutions[4] then
				local bestHere = -1;
				for member, mdata in pairs(sth.Members) do
					gT.Leagues[league].Members[member].VotesFromResolution["Monumental Initiative"] = 0;
					if member ~= luckywinner then
						if PlayerScores[member] then
							if PlayerScores[member] > bestHere then
								bestHere = PlayerScores[member];
							end
						end
					end
				end
				local min, max = 0, 3;
				if victoriousleague == league then
					max = 5;
					min = 1;
				end
				for member, mdata in pairs(sth.Members) do
					if member ~= luckywinner then
						if PlayerScores[member] then
							gT.Leagues[league].Members[member].VotesFromResolution["Monumental Initiative"] = math.max(min, math.floor(max * PlayerScores[member] / bestHere));
						end
					end
				end
			end
		end
		-- end votes for leagues
		gT.Globals.LastTimeWonderWinner = winnerval;
		if #gT.Globals.ValidWondersForRace == 0 or GetITGGameTurn() > 95 then
			gT.Globals.NoMoreWonderRace = true;
		end
		if bTie or (not bReachedTreshold) then
			luckywinner = nil;
			for g, h in pairs(gT.Players) do
				gT.Players[g].AIWonderBlock = nil;
			end
			print("No winner, tie or lack of production, lose no production", rwinnerval, gT.Globals.WonderTreshold * 100)
		else
			local attt;
			gpT[luckywinner], attt = HandleTheWinnerWonderRace(luckywinner);
			if attt then
				winnersTab[luckywinner] = true;
				tBuilding[luckywinner] = attt;
			end
		end
		--handle the selimye Mosque
		for g, h in pairs(gT.Players) do
			if h.HasPlayerWonder[GameInfoTypes.BUILDING_ITG_NEW_WORLD_WONDER_30] then
				if h.CanWonderRace then
					if h.WonderProduction >= gT.Globals.WonderTreshold then
						if luckywinner ~= g then
							local attt;
							print("We have selimye winner of wonder race")
							gpT[g], attt = HandleTheWinnerWonderRace(g)
							if attt then
								winnersTab[g] = true;
								tBuilding[g] = attt;
							end
							break;
						end
					end
				end
			end
		end
		--end of selimye Mosque

		for val, players in pairs(hTab) do
		--	if val ~= winnerval then
				local cType = 0.5;
				if val / 100 >= gT.Globals.WonderTreshold then
					cType = 0.25;
				end
				for i, player in pairs(players) do
					if not winnersTab[player] then
						local numconverted;
						if gT.Globals.NoMoreWonderRace or (ExtraPlayersToEraseAllWP[player] and (not CanContinueWonderRace(player))) then
							gT.Players[player].CanWonderRace = false;
							numconverted = math.floor(val / 100);
						else
							numconverted = math.floor(val/ 100 *cType);
						end
						if numconverted > 0 then
							local gpPoints = math.min(250, math.floor(numconverted * 0.15)) * gT.Players[player].ConversionLossBonusesModifier;
							if gpPoints > 0 then
								gpT[player] = gpPoints .. "[ICON_GREAT_PEOPLE]"
							end
							ChangeITGGreatPeopleCivilPoints(player, gpPoints, 4);
							gT.Players[player].WonderProduction = gT.Players[player].WonderProduction - numconverted;
							if cType == 0.5 then
								local realCultureGain = math.min(numconverted, 200) * gT.Players[player].ConversionLossBonusesModifier 
								ChangeITGCulture(player, realCultureGain)
								yieldT[player] = "+" .. realCultureGain .. "[ICON_CULTURE]"
							else
								local realGoldGain = math.min(numconverted, 500) * gT.Players[player].ConversionLossBonusesModifier 
								ChangeITGGold(player, realGoldGain);
								yieldT[player] = "+" .. realGoldGain.. "[ICON_GOLD]"
							end
						end
					end
				end
	--		end
		end
		for i, iHuman in pairs(gT.Globals.HumanPlayers) do
			if Players[iHuman]:IsAlive() then
				if tBuilding[iHuman] then
					if lTeHTt[iHuman] then -- human won, human part of league
						if PlayerScores[iHuman] ~= values[1] then
							LuaEvents.ITG_AchievementCompleted(72)
						end
					end
				end
				table.insert(gT.Players[iHuman].TheRaceInfoTable, {Type = "WonderRace", CTreshold = gT.Globals.WonderTreshold, Data = {hTab, values}, Wonder = tBuilding[iHuman], Winner = luckywinner, ExtraYieldData = yieldT, GPPointsT = gpT, LeagueTag = lTeHTt}) 
			end
		end
		if luckywinner then
			gT.Globals.WonderTreshold = gT.Globals.WonderTreshold + DBScenario.WonderTresholdIncrease;
		end
	end
end

function CultureWonderRaceSolution()
	local values = {}
	local yieldT = {}
	local gpT = {}
	local iBuilding;
	local luckywinner
	local cClassesTab = {}
	local tBuilding = {}
	local allpTab = {}
	local hTab = {}
	local bContinue = false
	for gplayer, gdata in pairs(gT.Players) do
		if gdata.CanWonderRace then
			gT.Players[gplayer].LastWonderResult = gdata.WonderProduction;
			if not hTab[gdata.CultureType] then
				hTab[gdata.CultureType] = {}
				values[gdata.CultureType] = {}
				table.insert(cClassesTab,gdata.CultureType)
			end
			gT.Players[gplayer].CannotWonderBoost = nil;
			local val = 100 * gdata.WonderProduction;
			if not hTab[gdata.CultureType][val] then
				table.insert(values[gdata.CultureType], val)
				hTab[gdata.CultureType][val] = {gplayer}
			else
				table.insert(hTab[gdata.CultureType][val], gplayer)
			end
			table.insert(allpTab, {gplayer, val, gdata.CultureType})
			bContinue = true
		else
			gT.Players[gplayer].LastWonderResult = 0;
		end
	end	
	if bContinue then
		local winningplayers = {}
		local apbuildingwon;
		table.sort(allpTab, SortFunctionForGreaterInteger2)
		if #gT.Globals.ValidWondersForRace < #cClassesTab or GetITGGameTurn() > 95 then
			gT.Globals.NoMoreWonderRace = true;
		end
		for i, cClass in pairs(cClassesTab) do
			table.sort(values[cClass], SortFunctionHighestInteger)
			local winnerval = values[cClass][1];
			luckywinner = hTab[cClass][winnerval][1];
			local bTie = #hTab[cClass][winnerval] > 1;
			if bTie or (winnerval / 100) < gT.Globals.WonderCTTresholds[cClass] then
				for g, h in pairs(gT.Players) do
					if h.CultureType == cClass then
						gT.Players[g].AIWonderBlock = nil;
					end
				end
				print("No winner, tie or lack of production, lose no production", winnerval)
			else
				local tActiveWonder;
				gpT[luckywinner], tActiveWonder = HandleTheWinnerWonderRace(luckywinner);
				if tActiveWonder then
					winningplayers[luckywinner] = 1;
					tBuilding[luckywinner] = tActiveWonder;
				end
				gT.Globals.WonderCTTresholds[cClass] = (gT.Globals.WonderCTTresholds[cClass] * ITG_CultureData[cClass].WonderTresholdMultiply) + ITG_CultureData[cClass].WonderTresholdAdd
			end
		end
--here we are ending races if needed			
		for i, class in pairs(cClassesTab) do
			for val, players in pairs(hTab[class]) do
				local cType = 0.20; --only gold refund (20%)
				for i, player in pairs(players) do
					if not winningplayers[player] then
						local numconverted;
						if gT.Globals.NoMoreWonderRace then
							gT.Players[player].CanWonderRace = false;
							numconverted = math.floor(val / 100);
						else
							numconverted = math.floor(val/ 100 * cType);
						end
						if numconverted > 0 then
							local gpPoints = math.min(250, math.floor(numconverted * 0.15)) * gT.Players[player].ConversionLossBonusesModifier;
							if gpPoints > 0 then
								gpT[player] = gpPoints .. "[ICON_GREAT_PEOPLE]"
							end
							ChangeITGGreatPeopleCivilPoints(player, gpPoints, 4);
							gT.Players[player].WonderProduction = gT.Players[player].WonderProduction - numconverted;
							local realGoldGain = math.min(numconverted, 500) * gT.Players[player].ConversionLossBonusesModifier 
							ChangeITGGold(player, realGoldGain);
							yieldT[player] = "+" .. realGoldGain .. "[ICON_GOLD]"
						end
					end
				end
			end
		end
		for i, iHuman in pairs(gT.Globals.HumanPlayers) do
			if Players[iHuman]:IsAlive() then
				local cpTreshold = gT.Globals.WonderCTTresholds[gT.Players[iHuman].CultureType]
				table.insert(gT.Players[iHuman].TheRaceInfoTable, {Type = "WonderRaceCT", OnlyOne = GetDBCulturePlayerInfo(iHuman, "OnlyOneWonder"), CPTreshold = cpTreshold, CTreshold = gT.Globals.WonderCTTresholds[gT.Players[Game.GetActivePlayer()].CultureType], Data = allpTab, Wonder = tBuilding[iHuman], Winners = winningplayers, ExtraYieldData = yieldT, GPPointsT = gpT}) 
				--in this scenario are no league-wonder stuff!!
			end
		end
	end
end

function CanContinueWonderRace(iPlayer)
	if gT.Globals.NoMoreWonderRace then
		return false;
	end	
	if gT.Players[iPlayer].NoMoreWonderRace then
		return false;
	end
	if gT.Players[iPlayer].HasPlayerWonder[angkor1] then
		return true;
	end
	if HasPlayerTech(iPlayer, ancemptech13, "oqjdjbioqew") then
		return true;
	end
	return false;
end

function HandleTheWinnerWonderRace(luckywinner)
	local lkey = GetProperWonderIfPossible(luckywinner);
	if not lkey then
		return;
	end
	local activeWonder;
	gT.Players[luckywinner].AIWonderBlock = nil
	iBuilding = gT.Globals.ValidWondersForRace[lkey];
	table.remove(gT.Globals.ValidWondersForRace, lkey)
	if not CanContinueWonderRace(luckywinner) then
		gT.Players[luckywinner].CanWonderRace = false
	end
	local gpPoints = math.min(250, math.floor(gT.Players[luckywinner].WonderProduction * 0.15)) * gT.Players[luckywinner].ConversionLossBonusesModifier;
	ChangeITGGreatPeopleCivilPoints(luckywinner, gpPoints, 4);
	gT.Players[luckywinner].WonderProduction = 0;
	AssignWonderComplete(luckywinner, iBuilding)
	if GetDBCulturePlayerInfo(luckywinner, "OnlyOneWonder") then
		gT.Players[luckywinner].WonderProduction = 0;
		gT.Players[luckywinner].CanWonderRace = false;
		gT.Players[luckywinner].NoMoreWonderRace = true;
	end
	if Players[luckywinner]:IsHuman() then
		LuaEvents.ITG_AchievementCompleted(7)
	end
	VictoryTaskCompletion(luckywinner, 1);
	-- various bonuses --
	if HasPlayerTech(luckywinner, GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_EMPIRE_13, "gsdgsdgv") then	
		BoostPlayerPower(luckywinner, "Wonders", 20)
	end

	return gpPoints .. "[ICON_GREAT_PEOPLE]", iBuilding;
end

function AssignWonderComplete(iPlayer, eBuilding)
	AssignWonderToThePlayer(iPlayer, eBuilding, nil)
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_MEDIEVAL_AFR_3, "innoTafr3") then
		ChangeMeritocracy(iPlayer, 15)
	end
	if iPlayer == Game.GetActivePlayer() then
		local strTitle = "Wonder Designed!";
		local string = "The engineers of our empire designed new great project: " .. Locale.Lookup(GameInfo.Buildings[eBuilding].Description) .."!";
		Players[iPlayer]:AddNotification(48558833, string, strTitle, -1, -1, eBuilding, iPlayer)
	end
end

function AssignWonderToThePlayer(iPlayer, eBuilding, tTurn)
	if tTurn then
		gT.Globals.WondersAssignedT[eBuilding] = tTurn;
	else
		gT.Globals.WondersAssignedT[eBuilding] = GetITGGameTurn();
		HnGLogWonderData(eBuilding, "DesignT", GetITGGameTurn())
		HnGLogWonderData(eBuilding, "Player", iPlayer)
	end
	gT.Globals.WondersAssigned[eBuilding] = iPlayer;
	if (not Players[iPlayer]:IsHuman()) and (not tTurn) then
		if DBScenario.WonderCultureGroup then
			DoTriggerAIWonderConstructScript(iPlayer)
		end
	end
end

function ShouldAIDoWonderRace(iPlayer)
	if gT.Globals.WondersAssigned[angkor1] == iPlayer then
		if not gT.Wonders[angkor1] then
			return false;
		end
	end
	if gT.Players[iPlayer].CultureType == 9 then
		if gT.Globals.WonderCTTresholds[9] >= 800 then
			return false;
		end
	end
	if HasCSMission(iPlayer, 20) then
		return true;
	end
	return LastRandom(1,2) == 2;
end

function ShouldAIBoostWonderRace(iPlayer)
	if gT.Players[iPlayer].AIScriptQueue[1] then
		return true;
	end
	if DBScenario.WonderCultureGroup then
		if (GetRewardWonderPushProd() + gT.Players[iPlayer].WonderProduction) > gT.Globals.WonderCTTresholds[gT.Players[iPlayer].CultureType] then
			return true;
		end
	elseif (GetRewardWonderPushProd() + gT.Players[iPlayer].WonderProduction) > gT.Globals.LastTimeWonderWinner then
		return true;
	end
	return false;
end

function DecideIfPlayerShouldLetWondersGo(iPlayer)
--1. average gain in last 5 turns
	local iTurn = GetITGGameTurn();
	local total = 0;
	local ittb = 5;
	for i = 1, ittb do
		if gT.Players[iPlayer].AIWonderLog[i] then
			total = total + gT.Players[iPlayer].AIWonderLog[i]
		else
			return; -- just started working on wonder
		end
	end
	local average = total / ittb;
	local reverse = #gT.Players[iPlayer].AIWonderProjectLog;
	if reverse < 5 then
		return; -- just started working
	end
	local processperc = 0;
	for i = 0, 4 do
		processperc = processperc + gT.Players[iPlayer].AIWonderProjectLog[reverse - i];
	end
	processperc = processperc / 5; -- avg over last 5 turns;
	if processperc < 0.21 then
		return; -- small input
	end
	local tojumpover = 0;
	local gc;
	if DBScenario.WonderCultureGroup then
		gc = gT.Players[iPlayer].CultureType
	end
	for g, gdata in pairs(gT.Players) do
		if gdata.CanWonderRace then
			if g ~= iPlayer then
				if (not gc) or gdata.CultureType == gc then
					tojumpover = math.max(tojumpover, gdata.LastWonderResult or 0)
				end
			end
		end
	end
	tojumpover = tojumpover * 1.25;
	local estimated = 10 * average + gT.Players[iPlayer].WonderProduction + GetRewardWonderPushProd();
	if estimated < processperc * tojumpover then
		print("Huge input with little reward chance AI wonder", iPlayer, estimated, tojumpover, processperc);
		gT.Players[iPlayer].AIWonderBlock = true;
	end
	gT.Players[iPlayer].AIWonderProjectLog = {} -- don't bother storing too much data
end

function GetNumWondersAssignedOnCity(plotIndex)
	local c = 0;
	for wonder, hh in pairs(gT.Wonders) do
		if hh == plotIndex then
			c = c + 1;
		end
	end
	return c;
end

function GetBestCityForWonderInit(iPlayer, wonderID)
	local tTab = {}
	for iCity in Players[iPlayer]:Cities() do
		if CheckIfCityCanBuildWonder(iCity, wonderID) then
			table.insert(tTab, {iCity, GetNumWondersAssignedOnCity(iCity:Plot():GetPlotIndex())})
		end
	end
	if #tTab == 0 then
		for iCity in Players[iPlayer]:Cities() do
			table.insert(tTab, {iCity, GetNumWondersAssignedOnCity(iCity:Plot():GetPlotIndex())})
		end
	end
	if #tTab > 0 then
		tTab = Shuffle(tTab)
		table.sort(tTab, SortFunctionForLowestMapDistance)
		return tTab[1][1];
	else
		print("Player without cities? Error 12332/423")
	end
end

function DoInitialBridgeWonder(iPlayer)
	for iCity in Players[iPlayer]:Cities() do
		local nb = GetNumCityBridges(iCity)
		if nb > 0 then
			local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
			gT.Cities[cID].ProdFromBridge = nb;
			iCity:ChangeBaseYieldRateFromBuildings(yProduction, nb)
		end
		local iPlot = iCity:Plot();
		for i = 0, 5 do
			local nPlot = Map.PlotDirection(iCity:GetX(), iCity:GetY(), i);
			if nPlot and (nPlot:GetRouteType() == -1) then
				if HasRiverBetweenPlots(iPlot, nPlot, i) then 
					nPlot:SetRouteType(GameInfoTypes.ROUTE_ROAD)
				end
			end
		end
	end
end

function GetNumCityBridges(iCity)
	--! should check for tech
	local h = 0;
	local iPlot = iCity:Plot();
	for i = 0, 5 do
		local nPlot = Map.PlotDirection(iCity:GetX(), iCity:GetY(), i);
		if nPlot and (nPlot:GetRouteType() ~= -1) then
			if HasRiverBetweenPlots(iPlot, nPlot, i) then 
				h = h + 1;
			end
		end
	end
	return h;
end

function ShouldAISpendBonusOnWonderRaceBoost(iPlayer)
	return (CanDoWonderRaceRightNow(iPlayer) and ShouldAIDoWonderRace(iPlayer)) or (CanDoWonderBoost(iPlayer) and ShouldAIBoostWonderRace(iPlayer));
end

function DoStartOrBoostWonderRace(iPlayer, bIgnoreMeritocracy)
	if not bIgnoreMeritocracy then
		ChangeMeritocracy(iPlayer, 3)
	end
	if gT.Players[iPlayer].CanWonderRace then
		gT.Players[iPlayer].CannotWonderBoost = true;
		local boost = GetRewardWonderPushProd();
		BoostWonderProduction(iPlayer, boost)
		return {2, boost}
	else
		StartWonderRace(iPlayer)
		return {1}
	end	
end

function StartWonderRace(iPlayer)
	gT.Players[iPlayer].CanWonderRace = true;
	ClearAllStoredWonderPointsFromSpec(iPlayer)
	if gT.Globals.GameGenerated then
		BasicCSMissionCompleteFunc(iPlayer, 20)
	end
end

function GetWondersCivilopediaSc(sWonderTag)
	local sTab = {}
	for building in GameInfo.Buildings() do
		if building.WonderEra == sWonderTag then
			local article = {};
			local name = Locale.ConvertTextKey( building.Description )
			article.entryName = name;
			article.Description = building.Description;
			article.entryID = building.ID;		

			table.insert(sTab, article);
		end
	end
	return sTab;
end