include( "IconSupport" );
----------------------------------------------------------------
----------------------------------------------------------------
local m_bIsEndGame = (ContextPtr:GetID() == "EndGameDemographics");
local listinstanceTab = {}
local cSelectedList = nil;
local g_PianoKeys = {
	[0] = {19/255,32/255,46/255,120/255},
	[1] = {12/255,22/255,30/255,120/255},
}
local bTickTock = false;

local g_CurrentTab = nil;		-- The currently selected Tab.
local g_Tabs = {
	["PanelOne"] = {
		Panel = Controls.DemographicContainer,
		SelectHighlight = Controls.PanelDemoSelectHighlight,
	},
	
	["PanelTwo"] = {
		Panel = Controls.VictoryPointsContainer,
		SelectHighlight = Controls.PanelVPSelectHighlight,
	},
}

function TabSelect(tab)

	for i,v in pairs(g_Tabs) do
		local bHide = i ~= tab;
		v.Panel:SetHide(bHide);
		v.SelectHighlight:SetHide(bHide);
	end
	g_CurrentTab = tab;
	g_Tabs[tab].RefreshContent();	
end
Controls.TabButtonPanelDemo:RegisterCallback( Mouse.eLClick, function() TabSelect("PanelOne"); end);
Controls.TabButtonPanelVP:RegisterCallback( Mouse.eLClick, function() TabSelect("PanelTwo"); end );

function RefreshPanelOne()
	BuildList( Game.GetActivePlayer() );
end
g_Tabs["PanelOne"].RefreshContent = RefreshPanelOne;

function RefreshPanelTwo()
    Controls.VPStack:DestroyAllChildren();
	LuaEvents.ITG_RequestVictoryPointsData(Game.GetActivePlayer())
	local gData = MapModData.ITGSG;
	MapModData.ITGSG = nil;
	if gData then
		for i, v in pairs(gData) do
		    local instance = {};
		    ContextPtr:BuildInstanceForControl( "VPInstance", instance, Controls.VPStack );
			
			instance.Base:SetColorVal(unpack(bTickTock and g_PianoKeys[0] or g_PianoKeys[1]));

			local sColour = ""
			if v[4] then
				sColour = "[COLOR_GREY]";
			end
			instance.Name:SetText(sColour .. v[1]);
			instance.Help:SetString(sColour .. v[2]);
			if v[3] > 0 then
				instance.Value:SetString("[COLOR_POSITIVE_TEXT]" .. v[3]);
			elseif v[3] < 0 then
				instance.Value:SetString("[COLOR_NEGATIVE_TEXT]" ..  v[3]);
			else
				instance.Value:SetString(v[3]);
			end		
			
			local width, height = instance.Help:GetSizeVal();
			local baseWidth, baseHeight = instance.Base:GetSizeVal();
			instance.Base:SetSizeVal(baseWidth, height + 22);
		end
	end
	Controls.VPStack:CalculateSize();
    Controls.VPStack:ReprocessAnchoring();
    Controls.VPScroll:CalculateInternalSize();
end
g_Tabs["PanelTwo"].RefreshContent = RefreshPanelTwo;

----------------------------------------------------------------
----------------------------------------------------------------
--   local instance = {};
--    ContextPtr:BuildInstanceForControl( "Entry", instance, Controls.MainStack );

function PopulateRanks()
	local iPlayer = Game.GetActivePlayer();
    Controls.MainStack:DestroyAllChildren();
	for i, data in pairs(listinstanceTab) do
		if data[3] == cSelectedList then
			data[1].SelectHighlight:SetHide(false);
		else
			data[1].SelectHighlight:SetHide(true);
		end
	end
	LuaEvents.ITGSG_RequestDemographicsPopulate(iPlayer, cSelectedList);
	local gData = MapModData.ITGSG;
	MapModData.ITGSG = nil;
	if gData then
		Controls.HeaderValue1:SetText(gData.Val1Text)
		Controls.HeaderValue2:SetText(gData.Val2Text)
		for i, b in pairs(gData.List) do
			local instance = {};
		    ContextPtr:BuildInstanceForControl( "Entry", instance, Controls.MainStack );
			instance.Rank:SetText(i)
			instance.Name:SetText(b[1])
			CivIconHookup( b[3], 32, instance.Icon, instance.CivIconBG, instance.CivIconShadow, false, true);  
			instance.Value1:SetText(b[4])
			instance.ValueTT1:SetToolTipString(b[6])
			instance.Value2:SetText(b[5])
			instance.ValueTT2:SetToolTipString(b[7])
		end
	end
	Controls.MainStack:CalculateSize();
    Controls.MainStack:ReprocessAnchoring();
    Controls.MainScroll:CalculateInternalSize();
    Controls.BigStack:ReprocessAnchoring();
end

function OnListClick(void1)
	cSelectedList = void1;
	PopulateRanks()
end
----------------------------------------------------------------
----------------------------------------------------------------
function BuildList( iPlayer )
    Controls.MainStack:DestroyAllChildren();
	Controls.ListStack:DestroyAllChildren();
	Controls.HeaderValue1:SetText("")
	Controls.HeaderValue2:SetText("")
	local bRefresh = false;
	listinstanceTab = {}
	LuaEvents.ITGSG_RequestDemographicsList(iPlayer);
	local gData = MapModData.ITGSG;
	MapModData.ITGSG = nil;
	if gData then
		for i, h in pairs(gData) do
			if h[1] == cSelectedList then
				if not h[3] then
					bRefresh = true;
				end
			end
		    local instance = {};
		    ContextPtr:BuildInstanceForControl( "ListItem", instance, Controls.ListStack );
			instance.Text:SetText(h[2])
			instance.Base:SetVoid1(h[1])
			instance.Base:SetDisabled(h[3])
			if h[3] then
				instance.Base:SetAlpha(0.33)
			else
				instance.Base:SetAlpha(1)
			end
			instance.Base:SetToolTipString(h[4])
			instance.Base:RegisterCallback( Mouse.eLClick, OnListClick );
			instance.SelectHighlight:SetHide(true);
			table.insert(listinstanceTab, {instance, h[2], h[1]})
		end
	end
	if bRefresh then
		PopulateRanks()
	end
    Controls.MainStack:CalculateSize();
    Controls.MainStack:ReprocessAnchoring();
    Controls.MainScroll:CalculateInternalSize();
    Controls.ListStack:CalculateSize();
    Controls.ListStack:ReprocessAnchoring();
    Controls.ListScroll:CalculateInternalSize();
    Controls.BigStack:ReprocessAnchoring();
    CivIconHookup( iPlayer, 64, Controls.Icon, Controls.CivIconBG, Controls.CivIconShadow, false, true);  
end


----------------------------------------------------------------
----------------------------------------------------------------
function ShowHideHandler( bIsHide, bIsInit )

    if( not bIsInit ) then
        if( not bIsHide ) then

			TabSelect(g_CurrentTab);
            
            if( not m_bIsEndGame ) then
	            UI.incTurnTimerSemaphore();
	            Events.SerialEventGameMessagePopupShown(m_PopupInfo);
            end
        else
			Events.SerialEventGameMessagePopupProcessed.CallImmediate(ButtonPopupTypes.BUTTONPOPUP_DEMOGRAPHICS, 0);
            if( not m_bIsEndGame ) then
	            UI.decTurnTimerSemaphore();
            end
        end
    end
end
ContextPtr:SetShowHideHandler( ShowHideHandler );

if( m_bIsEndGame ) then
    Controls.BGBlock:SetHide( true );
    Controls.InGameSet:SetHide( true );
end
    

-------------------------------------------------
-- On Popup
-------------------------------------------------
function OnPopup( popupInfo )
	
	-- End game is its own deal that shouldn't come up when we hit a hotkey or something
	if (m_bIsEndGame) then
		return
	end
	
	if( popupInfo.Type == ButtonPopupTypes.BUTTONPOPUP_DEMOGRAPHICS ) then
		m_PopupInfo = popupInfo;
		if( m_PopupInfo.Data1 == 1 ) then
        	if( ContextPtr:IsHidden() == false ) then
        	    OnBack();
            else
            	UIManager:QueuePopup( ContextPtr, PopupPriority.InGameUtmost );
        	end
    	else
        	UIManager:QueuePopup( ContextPtr, PopupPriority.Demographics );
    	end
	end
end
Events.SerialEventGameMessagePopup.Add( OnPopup );

----------------------------------------------------------------
----------------------------------------------------------------
function OnBack()
	UIManager:DequeuePopup( ContextPtr );
end
Controls.BackButton:RegisterCallback( Mouse.eLClick, OnBack );
    

----------------------------------------------------------------
-- Key Down Processing
----------------------------------------------------------------
function InputHandler( uiMsg, wParam, lParam )
    if( uiMsg == KeyEvents.KeyDown ) then
        if( wParam == Keys.VK_RETURN or wParam == Keys.VK_ESCAPE ) then
			OnBack();
            return true;
        end
    end
end
if( not m_bIsEndGame ) then
	ContextPtr:SetInputHandler( InputHandler );
end

----------------------------------------------------------------
-- 'Active' (local human) player has changed
----------------------------------------------------------------
Events.GameplaySetActivePlayer.Add(OnBack);
TabSelect("PanelOne");