-------------------------------------------------
-- Economic
-------------------------------------------------

include( "IconSupport" );

local m_CurrentPanel = Controls.EconomicGeneralInfo;

-------------------------------------------------
-- On Popup
-------------------------------------------------
function OnPopup( popupInfo )
	if( popupInfo.Type == ButtonPopupTypes.BUTTONPOPUP_ECONOMIC_OVERVIEW ) then
		m_PopupInfo = popupInfo;
		if m_PopupInfo.Data2 == 3 then
			OnCurrencyExchangeButton()
		elseif m_PopupInfo.Data2 == 2 then
			OnGreatPersonButton()
		elseif m_PopupInfo.Data2 == 4 then
			OnHappinessButton()
		end
		if( m_PopupInfo.Data1 == 1 ) then
        	if( ContextPtr:IsHidden() == false ) then
        	    OnClose();
        	    return;
    	    else
            	UIManager:QueuePopup( ContextPtr, PopupPriority.InGameUtmost );
        	end
    	else
        	UIManager:QueuePopup( ContextPtr, PopupPriority.EconOverview );
    	end
	end
end
Events.SerialEventGameMessagePopup.Add( OnPopup );

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function OnClose()
    UIManager:DequeuePopup( ContextPtr );
end
Controls.CloseButton:RegisterCallback( Mouse.eLClick, OnClose);


-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function InputHandler( uiMsg, wParam, lParam )
    if uiMsg == KeyEvents.KeyDown then
        if wParam == Keys.VK_ESCAPE or wParam == Keys.VK_RETURN then
            OnClose();
            return true;
        end
    end
end
ContextPtr:SetInputHandler( InputHandler );


-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function ShowHideHandler( bIsHide, bInitState )
    local pPlayer = Players[ Game.GetActivePlayer() ];
    if( pPlayer == nil ) then
        print( "Could not get player... huh?" );
        return;
    end
    
	-- Set Civ Icon
	CivIconHookup( Game.GetActivePlayer(), 64, Controls.CivIcon, Controls.CivIconBG, Controls.CivIconShadow, false, true );
	
    if( not bInitState ) then
        if( not bIsHide ) then
        	UI.incTurnTimerSemaphore();
        	
        	-- trigger the show/hide handler to update state
        	m_CurrentPanel:SetHide( false );
        	
        	Events.SerialEventGameMessagePopupShown(m_PopupInfo);
        else
            UI.decTurnTimerSemaphore();
            Events.SerialEventGameMessagePopupProcessed.CallImmediate(ButtonPopupTypes.BUTTONPOPUP_ECONOMIC_OVERVIEW, 0);
        end
    end
end
ContextPtr:SetShowHideHandler( ShowHideHandler );


-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function OnGeneralInfoButton()
	-- Set Tabs
	Controls.GeneralInfoSelectHighlight:SetHide(false);
	Controls.HappinessSelectHighlight:SetHide(true);
	Controls.StockExchangeSelectHighlight:SetHide(true);
	Controls.CurrencyExchangeSelectHighlight:SetHide(true);
	
	-- Set Panels
    Controls.EconomicGeneralInfo:SetHide( false );
    Controls.AuctionHouseInfo:SetHide( true );
	Controls.StockExchangeInfo:SetHide( true );
	Controls.CurrencyExchangeInfo:SetHide(true)
    m_CurrentPanel = Controls.EconomicGeneralInfo;
end
Controls.GeneralInfoButton:RegisterCallback( Mouse.eLClick, OnGeneralInfoButton );


-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function OnHappinessButton()
	-- Set Tabs
	Controls.GeneralInfoSelectHighlight:SetHide(true);
	Controls.HappinessSelectHighlight:SetHide(false);
	Controls.StockExchangeSelectHighlight:SetHide(true);
	Controls.CurrencyExchangeSelectHighlight:SetHide(true);
	
	-- Set Panels
    Controls.EconomicGeneralInfo:SetHide( true );
    Controls.AuctionHouseInfo:SetHide( false );
	Controls.StockExchangeInfo:SetHide( true );
	Controls.CurrencyExchangeInfo:SetHide(true)
    m_CurrentPanel = Controls.AuctionHouseInfo;
end
Controls.HappinessButton:RegisterCallback( Mouse.eLClick, OnHappinessButton );

function OnGreatPersonButton()
	-- Set Tabs
	Controls.GeneralInfoSelectHighlight:SetHide(true);
	Controls.HappinessSelectHighlight:SetHide(true);
	Controls.StockExchangeSelectHighlight:SetHide(false);
	Controls.CurrencyExchangeSelectHighlight:SetHide(true);
	
	-- Set Panels
    Controls.EconomicGeneralInfo:SetHide( true );
    Controls.AuctionHouseInfo:SetHide( true );
	Controls.StockExchangeInfo:SetHide( false );
	Controls.CurrencyExchangeInfo:SetHide(true)
    m_CurrentPanel = Controls.StockExchangeInfo;
end
Controls.StockExchangeButton:RegisterCallback(Mouse.elClick, OnGreatPersonButton);


function OnCurrencyExchangeButton()
	-- Set Tabs
	Controls.GeneralInfoSelectHighlight:SetHide(true);
	Controls.HappinessSelectHighlight:SetHide(true);
	Controls.StockExchangeSelectHighlight:SetHide(true);
	Controls.CurrencyExchangeSelectHighlight:SetHide(false);
	
	-- Set Panels
    Controls.EconomicGeneralInfo:SetHide( true );
    Controls.AuctionHouseInfo:SetHide( true );
    Controls.StockExchangeInfo:SetHide( true );
	Controls.CurrencyExchangeInfo:SetHide(false)
    m_CurrentPanel = Controls.CurrencyExchangeInfo;
end
Controls.CurrencyExchangeButton:RegisterCallback(Mouse.elClick, OnCurrencyExchangeButton);

OnGeneralInfoButton();

----------------------------------------------------------------
-- 'Active' (local human) player has changed
----------------------------------------------------------------
Events.GameplaySetActivePlayer.Add(OnClose);
