-------------------------------------------------
-- Happiness Info
-------------------------------------------------
include( "IconSupport" );
include( "InstanceManager" );

local bOptions = {}
local strOptions = {"Active","Completed","Killed","Pilgrim","Land","Naval","Incoming","Outgoing"}
local GetSeason = {"Spring", "Summer", "Autumn", "Winter"}
function GetTextDate(turn, StartDate, bOnlyNumber)
	local year = -4000 + math.floor((StartDate + turn)/4);
	local season = GetSeason[(StartDate + turn)%4 + 1];
	if year < 0 then
	--season .. " " .. -year .. " BC";
		if bOnlyNumber then
			return -year;
		end
		return -year .. " BC";
	else
		if bOnlyNumber then
			return year;
		end
		return year .. " AD";
	end
end

function CenterUnitOnMap(void)
	if void then
		local iUnit = Players[Game.GetActivePlayer()]:GetUnitByID(void);
		if iUnit then
			UI.LookAt(Map.GetPlot(iUnit:GetX(), iUnit:GetY()))
		end
	end
end

-------------------------------------------------
-------------------------------------------------
function UpdateScreen()

	local iPlayer = Game.GetActivePlayer();
	LuaEvents.ITGSG_RequestGT();
	local gData = MapModData.ITGSG;
	MapModData.ITGSG = nil;
	if not gData then
		print("Unthinkable Error 1521463")
		return
	end
	if not gData.Players[iPlayer] then
		return;
	end

	Controls.MainStack:DestroyAllChildren();
	if (bOptions.Completed or bOptions.Killed) and (bOptions.Outgoing or bOptions.Incoming) and (bOptions.Land or bOptions.Naval or bOptions.Pilgrim) then
		for i,v in ipairs(gData.Globals.TradeRouteLog) do
			if (v.FromPlayer == iPlayer) or (v.ToPlayer == iPlayer) then
				local bYours = (v.FromPlayer == iPlayer)
				local bToYours = (v.ToPlayer == iPlayer)
				local bNaval = (v.DomainType == 2);
				local bLand = (v.DomainType == 1);
				local bShow = false;
				if (bYours and bOptions.Outgoing) or ((not bYours) and bOptions.Incoming) then
					if (v.Killed and bOptions.Killed) or ((not v.Killed) and bOptions.Completed) then
						if (bLand and bOptions.Land) or (bNaval and bOptions.Naval) or (v.Pilgrim and bOptions.Pilgrim) then
							bShow = true;
						end
					end
				end
				if bShow then
					local instance = {};
					ContextPtr:BuildInstanceForControl( "TRInstance", instance, Controls.MainStack );
				--	instance.Domain_Land:SetHide(bNaval);
				--	instance.Domain_Sea:SetHide(not bNaval);
					if bNaval then
						instance.Domain_Type:SetText("[ICON_CARGO]")
					elseif bLand then
						instance.Domain_Type:SetText("[ICON_CARAVAN]")
					elseif v.Pilgrim then
						instance.Domain_Type:SetText("[ICON_ITG_PILGRIM]")
					end

					CivIconHookup(v.FromPlayer, 32, instance.FromCivIcon, instance.FromCivIconBG, instance.FromCivIconShadow, false, true, instance.FromCivIconHighlight);
					--Since I don't know which icon to use, use em all!
					local fromcivname = Players[v.FromPlayer]:GetCivilizationShortDescription();
					instance.FromCivIcon:SetToolTipString(fromcivname);
					instance.FromCivIconBG:SetToolTipString(fromcivname);
					instance.FromCivIconShadow:SetToolTipString(fromcivname);
					instance.FromCivIconHighlight:SetToolTipString(fromcivname);
					instance.FromCity:SetText(Map.GetPlotByIndex(v.From):GetPlotCity():GetName());
		
					local destPlot = Map.GetPlotByIndex(v.To);
					local bReve = destPlot:IsRevealed(Players[iPlayer]:GetTeam());
					local civtoName = "Unknown Civilization"
					local cityName = "Unknown City";
					if bReve then
						if destPlot:IsCity() then
							cityName = destPlot:GetPlotCity():GetName();
						else
							cityName = "[ICON_RELIGION]" .. gData.HolySites[destPlot:GetPlotIndex()].Name
						end
						civtoName = Players[v.ToPlayer]:GetCivilizationShortDescription();
						CivIconHookup(v.ToPlayer, 32, instance.ToCivIcon, instance.ToCivIconBG, instance.ToCivIconShadow, false, true, instance.ToCivIconHighlight);
					else
						if not destPlot:IsCity() then	
							cityName = "Unknown Holy Site"
						end
						CivIconHookup(-1, 32, instance.ToCivIcon, instance.ToCivIconBG, instance.ToCivIconShadow, false, true, instance.ToCivIconHighlight);
					end
					instance.ToCivIcon:SetToolTipString(civtoName);
					instance.ToCivIconBG:SetToolTipString(civtoName);
					instance.ToCivIconShadow:SetToolTipString(civtoName);
					instance.ToCivIconHighlight:SetToolTipString(civtoName);
					instance.ToCity:SetText(cityName);
		
		
		
		
					instance.Distance:SetText(" ");
					instance.ToInfluence:SetText(" ");
					instance.ToFood:SetText(" ");
					instance.ToCulture:SetText(" ");
					instance.ToCurrency:SetText(" ");
					instance.FromScience:SetText(" ");
					instance.FromGPT:SetText(" ");
					instance.Root:SetAlpha(1);
					instance.Root:SetVoid1(nil)
					if (v.Killed) then
						instance.EndedStatus:SetText("Killed")
					else
						instance.EndedStatus:SetText(GetTextDate(v.Turn, gData.Globals.StartDate))
						if bYours then
							if (v.Influence or 0) > 0 then
								instance.ToInfluence:SetText(v.Influence);
							end	
							if (v.GoldEarned or 0) > 0 then
								instance.FromGPT:SetText(v.GoldEarned);
							end
							if (v.CurrencyBonus or 0) > 0 then
								instance.ToCurrency:SetText(v.CurrencyBonus);
							end
							if (v.CultureEarned or 0) > 0 then
								instance.ToCulture:SetText(v.CultureEarned);
							end
							if (v.ScienceGain or 0) > 0 then
								instance.FromScience:SetText(v.ScienceGain);
							end
						else
							if (v.ToGoldEarned or 0) > 0 then
								instance.FromGPT:SetText(v.ToGoldEarned);
							end
							if (v.ToCurrencyBonus or 0) > 0 then
								instance.ToCurrency:SetText(v.ToCurrencyBonus);
							end
							if (v.ToCultureEarned or 0) > 0 then
								instance.ToCulture:SetText(v.ToCultureEarned);
							end
							if (v.ToScienceGain or 0) > 0 then
								instance.FromScience:SetText(v.ToScienceGain);
							end
						end
						if ((v.TargetFood or 0) > 0) and bToYours then
							instance.ToFood:SetText(v.TargetFood);
						end		
						if (v.Distance or 0) > 0 then
							instance.Distance:SetText(v.Distance);
						end
					end
				end
			end
		end
    end
	if bOptions.Active and bOptions.Outgoing and (bOptions.Land or bOptions.Naval or bOptions.Pilgrim) then
		for iUnit in Players[iPlayer]:Units() do
			local uID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
			if gData.Players[iPlayer].UnitsByID[uID] then
				if gData.Players[iPlayer].UnitsByID[uID].TargetAdjacent then
					local bNaval = false;
					local bLand = false;
					local bPilgrim = false;
					if gData.Players[iPlayer].UnitsByID[uID].Pilgrim then
						bPilgrim = true;
					elseif iUnit:GetDomainType() == DomainTypes.DOMAIN_SEA then
						bNaval = true;
					else
						bLand = true;
					end
					if (bLand and bOptions.Land) or (bNaval and bOptions.Naval) or (bPilgrim and bOptions.Pilgrim) then
						local instance = {};
						ContextPtr:BuildInstanceForControl( "TRInstance", instance, Controls.MainStack );
						if bPilgrim then
							instance.Domain_Type:SetText("[ICON_ITG_PILGRIM]")
						elseif bNaval then
							instance.Domain_Type:SetText("[ICON_CARGO]")
						elseif bLand then
							instance.Domain_Type:SetText("[ICON_CARAVAN]")
						end
						CivIconHookup(iPlayer, 32, instance.FromCivIcon, instance.FromCivIconBG, instance.FromCivIconShadow, false, true, instance.FromCivIconHighlight);
						--Since I don't know which icon to use, use em all!
						local fromcivname = Players[iPlayer]:GetCivilizationShortDescription();
						instance.FromCivIcon:SetToolTipString(fromcivname);
						instance.FromCivIconBG:SetToolTipString(fromcivname);
						instance.FromCivIconShadow:SetToolTipString(fromcivname);
						instance.FromCivIconHighlight:SetToolTipString(fromcivname);
						instance.FromCity:SetText(Map.GetPlotByIndex(gData.Players[iPlayer].UnitsByID[uID].OriginTrade):GetPlotCity():GetName());

						local destPlot = Map.GetPlotByIndex(gData.Players[iPlayer].UnitsByID[uID].TargetAdjacent);
						local bReve = destPlot:IsRevealed(Players[iPlayer]:GetTeam());
						local civtoName = "Unknown Civilization"
						local cityName = "Unknown City";
				
						if bReve then
							if destPlot:IsCity() then
								cityName = destPlot:GetPlotCity():GetName();
							elseif gData.Players[iPlayer].UnitsByID[uID].Pilgrim then
								cityName = "[ICON_RELIGION]" .. gData.HolySites[destPlot:GetPlotIndex()].Name
							end
							civtoName = Players[destPlot:GetOwner()]:GetCivilizationShortDescription();
							CivIconHookup(destPlot:GetOwner(), 32, instance.ToCivIcon, instance.ToCivIconBG, instance.ToCivIconShadow, false, true, instance.ToCivIconHighlight);
						else
							if not destPlot:IsCity() then	
								if gData.Players[iPlayer].UnitsByID[uID].Pilgrim then
									cityName = "Unknown Holy Site"
								end
							end
							CivIconHookup(-1, 32, instance.ToCivIcon, instance.ToCivIconBG, instance.ToCivIconShadow, false, true, instance.ToCivIconHighlight);
						end
						instance.ToCivIcon:SetToolTipString(civtoName);
						instance.ToCivIconBG:SetToolTipString(civtoName);
						instance.ToCivIconShadow:SetToolTipString(civtoName);
						instance.ToCivIconHighlight:SetToolTipString(civtoName);
						instance.ToCity:SetText(cityName);
		
						instance.Distance:SetText(" ");
						instance.ToInfluence:SetText(" ");
						instance.ToFood:SetText(" ");
						instance.ToCulture:SetText(" ");
						instance.ToCurrency:SetText(" ");
						instance.FromScience:SetText(" ");
						instance.FromGPT:SetText(" ");
				
						instance.Root:SetVoid1(iUnit:GetID())
						instance.Root:RegisterCallback( Mouse.eLClick, CenterUnitOnMap );

						instance.EndedStatus:SetText("Active")
						instance.Root:SetAlpha(0.6);
					end
				end
			end
		end
	end
    Controls.MainStack:CalculateSize();
    Controls.MainStack:ReprocessAnchoring();
    Controls.MainScroll:CalculateInternalSize();
    

end

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function ShowHideHandler( bIsHide, bInitState )
    if( not bIsHide ) then
    	UpdateScreen();
	end
end
ContextPtr:SetShowHideHandler( ShowHideHandler );

function RegisterOptions()
	for a, b in pairs(strOptions) do
		bOptions[b] = true;
		Controls["Check" .. b]:RegisterCheckHandler( function(bCheck)
			bOptions[b] = bCheck;
			UpdateScreen();
		end);
	end
end

function OnOptions()	
	Controls.OptionsPanel:SetHide( not Controls.OptionsPanel:IsHidden() );
end
Controls.OptionsButton:RegisterCallback( Mouse.eLClick, OnOptions );
Controls.MainOptionStack:CalculateSize();
Controls.OptionsPanel:DoAutoSize();
RegisterOptions()