include( "IconSupport" );
include( "InstanceManager" );
include( "FLuaVector" );
local genericUnitHexBorder = "GUHB";
local vTileImprovementColor = Vector4( 0.5, 0.0, 1.0, 1.0 );
local FakeInterFaceOn = false;
local GetRomanNumberString = {"I", "II", "III", "IV", "V", "VI", "VII", "VIII", "IX", "X", "XI", "XII"}
local bOkayToProcess = true;
local bAdmCanBe = false;
local bGenCanBe = false;
local bFirstTooltips = true;

function GetNameOfGreatPerson(string, que)
	local name = Locale.Lookup(string);
	if que then
		name = name .. " " .. GetRomanNumberString[que];
	end
	return name;
end

IconHookup(38, 64, "TERRAIN_ATLAS", Controls.TechMain1);
IconHookup(12, 64, "TECH_ITG_ATLAS_1", Controls.TechMain12);
IconHookup(44, 64, "UNIT_ATLAS_2", Controls.TechMain3);
IconHookup(0, 64, "INTL_PROJECT_ATLAS_EXP2", Controls.TechMain4);
--IconHookup(46, 64, "UNIT_ATLAS_2", Controls.TechMain5);
--IconHookup(16, 64, "EXPANSION_UNIT_ATLAS_1", Controls.TechMain8);
IconHookup(10, 64, "TECH_ITG_ATLAS_1", Controls.TechMain11);
function DefineGPIcons()
	if MapModData.DBScenario.AltGreatPeopleArt then
		IconHookup(53, 45, "UNIT_ATLAS_2", Controls.iGenerals);
		IconHookup(15, 45, "EXPANSION_UNIT_ATLAS_1", Controls.IAdmirals);
	else
		IconHookup(48, 45, "UNIT_ATLAS_2", Controls.iGenerals);
		IconHookup(26, 45, "EXPANSION_UNIT_ATLAS_1", Controls.IAdmirals);
	end
end
IconHookup(0, 45, "UNIT_ITG_2_ATLAS", Controls.IForts);
IconHookup(20, 45, "EXPANSION_UNIT_ATLAS_1", Controls.IMissionares);
IconHookup( 1, 45, "UNIT_ITG_2_ATLAS", Controls.IColonies);
IconHookup( 6 , 45, "TECH_ITG_ATLAS_1", Controls.IShinobi);
IconHookup( 17, 45, "EXPANSION_UNIT_ATLAS_1", Controls.IInquisitors);
IconHookup( 2, 45, "UNIT_ITG_2_ATLAS", Controls.IHolySites);
IconHookup( 4, 45, "UNIT_ATLAS_1", Controls.IMesoSGR);
IconHookup( 0, 45, "NW_ATLAS_DLC", Controls.IMesoElD);
IconHookup( 57, 45, "UNIT_ACTION_ATLAS", Controls.ICustomH);
IconHookup( 23, 45, "UNIT_ACTION_ATLAS", Controls.IAcademy);
IconHookup( 56, 45, "UNIT_ACTION_ATLAS", Controls.IManuF);
IconHookup( 0, 45, "UNIT_ATLAS_1", Controls.ISettlers);
IconHookup( 44, 45, "UNIT_ATLAS_2", Controls.IFestivals);
IconHookup( 45, 45, "TECH_ATLAS_1", Controls.IRailroad);
IconHookup( 37, 45, "PROMOTION_ATLAS", Controls.IMilRecon);
IconHookup( 9, 45, "PROMOTION_ATLAS", Controls.IInstantWar);
IconHookup( 17, 45, "EXPANSION2_UNIT_ATLAS", Controls.ISupportSiege);
IconHookup( 2, 45, "EXPANSION_UNIT_ATLAS_1", Controls.ISupportRam);
IconHookup( 0, 45, "PROCESS_ITG_ATLAS_1", Controls.ICSAlert);
IconHookup( 2, 45, "TECH_ATLAS_2", Controls.ISatellites);
IconHookup( 10, 45, "TECH_ATLAS_1", Controls.IResMovement);
IconHookup( 11, 45, "TECH_ATLAS_1", Controls.ILastCall);
IconHookup( 2, 45, "TERRAIN_IMPROVEMENT_ICON_ATLAS_EXP2", Controls.IChateau);
IconHookup( 3, 45, "TERRAIN_IMPROVEMENT_ICON_ATLAS_EXP2", Controls.IFeitoria);

IconHookup( 3, 45, "TECH_ITG_ATLAS_1", Controls.ICS100turnHelp);

local firstTime = true;

local m_MilitaryIM = InstanceManager:new( "UnitInstance", "Quote", Controls.MissionTextStack );
local bOkayToProcess = true;
local cHighlightType = -1;


local killitwithfire = false;
LuaEvents.ITGCheckIfCanDoDiploPopup.Add(function()
	if FakeInterFaceOn or killitwithfire then
		MapModData.ITGSG = true;
		killitwithfire = false;
	end
end)

function InputHandler( uiMsg, wParam, lParam )
	if wParam == Keys.VK_F10 then
		return true; -- this is important! disables strategic view!
	end
	if not Controls.MainDoM:IsHidden() then
		if uiMsg == KeyEvents.KeyDown then
			if wParam == Keys.VK_ESCAPE or wParam == Keys.VK_RETURN then
				Controls.MainDoM:SetHide(true)
				return true;
			end
	    end
	elseif FakeInterFaceOn then
		if not bOkayToProcess then
			Events.ClearHexHighlights()
			FakeInterFaceOn = false;
			return true;
		end
		if uiMsg == MouseEvents.LButtonUp or uiMsg == MouseEvents.RButtonUp or uiMsg == MouseEvents.PointerUp then
			local pPlot = Map.GetPlot( UI.GetMouseOverHex() );
			if (pPlot == nil) then
				return;
			end
--			if pPlot:IsCity() then
--				if Players[pPlot:GetOwner()]:IsMinorCiv() then
--					killitwithfire = true;
--				end
--			end
			LuaEvents.ITG_InfoCornerClickedPlot(pPlot, cHighlightType, Game.GetActivePlayer(), UIManager:GetControl())
			Events.ClearHexHighlights()
			FakeInterFaceOn = false;
			return true;
		elseif uiMsg == KeyEvents.KeyDown then
			if wParam == Keys.VK_ESCAPE or wParam == Keys.VK_RETURN then
				Events.ClearHexHighlights()
				FakeInterFaceOn = false;
			end
			return true;
	    elseif uiMsg == MouseEvents.RButtonDown then
			return true;
		end
--		return true; LButtonUp	514
--[[ MButtonDoubleClick	521
 MouseLast	526
 MButtonUp	520
 PointerDown	582
 RButtonDoubleClick	518
 XButtonDoubleClick	525
 RButtonUp	517
 PointerUp	583
 XButtonUp	524
 MouseWheel	522
	 RButtonDown	516
 PointerUpdate	581
 MouseMove	512
 LButtonDoubleClick	515
	 LButtonDown	513
 MButtonDown	519
 XButtonDown	523
 MouseFirst	512 ]]
--		print("FakeInterFace", uiMsg, wParam, lParam)
		return false;
	else
		if uiMsg == KeyEvents.KeyDown then
			if wParam == Keys.R and UI:ShiftKeyDown() then
				if (not Controls.GRailroad:IsHidden()) and (not Controls.GRailroad:IsDisabled()) then
					OnHighlightClicked(16)
					return true;
				end
			elseif wParam == Keys.M and UI:ShiftKeyDown() then
				if (not Controls.GMissionares:IsHidden()) and (not Controls.GMissionares:IsDisabled()) then
					OnHighlightClicked(4)
					return true;
				end
			end
	    end
	end
end
ContextPtr:SetInputHandler( InputHandler );

Events.UnitSelectionChanged.Add(function()
	FakeInterFaceOn = false;
end)

function OnActivePlayerTurnEnd()
	bOkayToProcess = false;
end
Events.ActivePlayerTurnEnd.Add( OnActivePlayerTurnEnd );

function OnActivePlayerTurnStart()
	bOkayToProcess = true;
end
Events.ActivePlayerTurnStart.Add( OnActivePlayerTurnStart );

function OnRearrangeGreatPeople(type)
	if bOkayToProcess then
		LuaEvents.ITGSG_RearrangeGreatPeople(Game.GetActivePlayer(), type)
		UpdateSignals()
	end
end

function OnHighlightClicked(type)
	if bOkayToProcess then
		Events.ClearHexHighlights()
		if (type == 1 and (not bGenCanBe)) or (type == 2 and (not bAdmCanBe)) then
			Events.GameplayAlertMessage("This Great Person cannot be assigned this turn.")
			return;
		end
		LuaEvents.ITGSG_RequestHighlightData(Game.GetActivePlayer(), type)
		local gData = MapModData.ITGSG;
		MapModData.ITGSG = nil;
		if gData and #gData > 0 then
			if type == 4 then
				for i, plotdata in pairs(gData) do
					local iHexID = ToHexFromGrid( Vector2( plotdata[1]:GetX(), plotdata[1]:GetY()) );
					local vTileReligionColor = Vector4( 1.0, 0.25, 0.25, 1.0 );
					if plotdata[2] < 10 then
						if plotdata[2] == 1 then
							vTileReligionColor = Vector4( 0, 1.0, 0.25, 1.0 );
						else
							vTileReligionColor = Vector4( (plotdata[2] - 1) * 0.11, 1.0 - (plotdata[2] - 1) * 0.08, 0.25, 1.0 );
						end
					end
					Events.SerialEventHexHighlight( iHexID, true, vTileReligionColor, genericUnitHexBorder );
				end
			else
				for i, plot in pairs(gData) do
					local iHexID = ToHexFromGrid( Vector2( plot:GetX(), plot:GetY()) );
					Events.SerialEventHexHighlight( iHexID, true, vTileImprovementColor, genericUnitHexBorder );
				end
			end
			cHighlightType = type;
			FakeInterFaceOn = true;
		elseif gData then
			Events.GameplayAlertMessage("You can't do that action now.")
		end
	end
end
function CallInstantWar()
	if Players[Game.GetActivePlayer()]:IsTurnActive() then
		Events.ClearHexHighlights()
		LuaEvents.ITGCallInstantWar(Game.GetActivePlayer())
	end
end
function CallLastCall()
	if Players[Game.GetActivePlayer()]:IsTurnActive() then
		Events.ClearHexHighlights()
		LuaEvents.ITGCallLastCall(Game.GetActivePlayer())
	end
end
function CallCSAlert()
	if Players[Game.GetActivePlayer()]:IsTurnActive() then
		Events.ClearHexHighlights()
		LuaEvents.ITGCallCSQuestAlert()
	end
end
function CallOpenCSGiftingPanel()
	LuaEvents.ITG_OpenCSProjectsPanel()
end

function Call100Turn()
	if Players[Game.GetActivePlayer()]:IsTurnActive() then
		Events.ClearHexHighlights()
		LuaEvents.ITG_CallRandomCityOrders();
		UpdateSignals();
	end
end
function OnRearrangeSatellites()
	if Players[Game.GetActivePlayer()]:IsTurnActive() then
		LuaEvents.ITG_HumanRearrangesSatelliteSelection()
		UpdateSignals();
	end
end

Controls.GGenerals:RegisterCallback( Mouse.eLClick, function() OnHighlightClicked(1) end );
Controls.GAdmirals:RegisterCallback( Mouse.eLClick, function() OnHighlightClicked(2) end )
Controls.GGenerals:RegisterCallback( Mouse.eRClick, function() OnRearrangeGreatPeople(1) end )
Controls.GAdmirals:RegisterCallback( Mouse.eRClick, function() OnRearrangeGreatPeople(2) end )
Controls.GForts:RegisterCallback( Mouse.eLClick, function() OnHighlightClicked(3) end );
Controls.GMissionares:RegisterCallback( Mouse.eLClick, function() OnHighlightClicked(4) end );
Controls.GColonies:RegisterCallback( Mouse.eLClick, function() OnHighlightClicked(5) end );
Controls.GInquisitors:RegisterCallback( Mouse.eLClick, function() OnHighlightClicked(6) end );
Controls.GHolySites:RegisterCallback( Mouse.eLClick, function() OnHighlightClicked(7) end );
Controls.GShinobi:RegisterCallback( Mouse.eLClick, function() OnHighlightClicked(8) end );
Controls.GMesoSGR:RegisterCallback( Mouse.eLClick, function() OnHighlightClicked(9) end );
Controls.GMesoElD:RegisterCallback( Mouse.eLClick, function() OnHighlightClicked(10) end );
Controls.GAcademy:RegisterCallback( Mouse.eLClick, function() OnHighlightClicked(11) end );
Controls.GCustomH:RegisterCallback( Mouse.eLClick, function() OnHighlightClicked(12) end );
Controls.GManuF:RegisterCallback( Mouse.eLClick, function() OnHighlightClicked(13) end );
Controls.GSettlers:RegisterCallback( Mouse.eLClick, function() OnHighlightClicked(14) end );
Controls.GFestivals:RegisterCallback( Mouse.eLClick, function() OnHighlightClicked(15) end );
Controls.GRailroad:RegisterCallback( Mouse.eLClick, function() OnHighlightClicked(16) end );
Controls.GMilEngineer:RegisterCallback( Mouse.eLClick, function() OnHighlightClicked(17) end );
Controls.GMilRecon:RegisterCallback( Mouse.eLClick, function() OnHighlightClicked(18) end );
Controls.GInstantWar:RegisterCallback( Mouse.eLClick, function() CallInstantWar() end );
Controls.GSupportRam:RegisterCallback( Mouse.eLClick, function() OnHighlightClicked(20) end );
Controls.GSupportSiege:RegisterCallback( Mouse.eLClick, function() OnHighlightClicked(21) end );
Controls.GSatellites:RegisterCallback( Mouse.eLClick, function() OnHighlightClicked(23) end );
Controls.GResMovement:RegisterCallback( Mouse.eLClick, function() OnHighlightClicked(24) end );
Controls.GChateau:RegisterCallback( Mouse.eLClick, function() OnHighlightClicked(26) end );
Controls.GFeitoria:RegisterCallback( Mouse.eLClick, function() OnHighlightClicked(27) end );

Controls.GLastCall:RegisterCallback( Mouse.eLClick, function() CallLastCall() end );
Controls.GSatellites:RegisterCallback( Mouse.eRClick, function() OnRearrangeSatellites() end )
Controls.GCSAlert:RegisterCallback( Mouse.eLClick, function() CallCSAlert() end );
Controls.GCSAlert:RegisterCallback( Mouse.eRClick, function() CallOpenCSGiftingPanel() end );
Controls.GCS100turnHelp:RegisterCallback( Mouse.eLClick, function() Call100Turn() end);

function GenerateTheDoM()	
	m_MilitaryIM:ResetInstances();
	local civIndex = PreGame.GetCivilization( Game:GetActivePlayer() );
    
    local civ = GameInfo.Civilizations[civIndex];
    -- Sets up Selected Civ Slot
    if ( civ ~= nil ) then
		
        -- Use the Civilization_Leaders table to cross reference from this civ to the Leaders table
        local leader = GameInfo.Leaders[GameInfo.Civilization_Leaders( "CivilizationType = '" .. civ.Type .. "'" )().LeaderheadType];
        local leaderDescription = leader.Description;

		-- Set Leader & Civ Text
		Controls.Civilization:LocalizeAndSetText( Locale.Lookup(civ.ShortDescription) );
		Controls.Leader:SetText( Locale.Lookup(leaderDescription) .. "," );
        
        -- Set Civ Leader Icon
		IconHookup( leader.PortraitIndex, 128, leader.IconAtlas, Controls.Portrait );
		
		-- Set Civ Icon
		SimpleCivIconHookup( Game.GetActivePlayer(), 80, Controls.IconShadow );
		
         -- Set Text
		LuaEvents.ITGSG_RequestGT();
		local gData = MapModData.ITGSG;
		MapModData.ITGSG = nil;
		local gActivePlayer = Game.GetActivePlayer()
		if gData then
			LuaEvents.ITGSG_RequestDoMinfo(gActivePlayer)
			local domTab = MapModData.ITGSG;
			MapModData.ITGSG = nil
			for i, tt in pairs(domTab or {}) do
				local instance;
				instance = m_MilitaryIM:GetInstance();
				instance.Quote:SetText( tt[1]);
				instance.Quote:SetToolTipString( tt[2] or "");
			end
		end
        
        -- Sets Dawn of Man Image
        Controls.Image:SetTexture(civ.DawnOfManImage);
		Controls.Image:SetHide(true);
		iCivID = civ.ID;
        --print("iCivID: " .. iCivID);
	end
	
    Controls.MissionTextStack:CalculateSize();
	Controls.MissionScroll:SetSizeY(500);
    Controls.MissionScroll:CalculateInternalSize();
    Controls.MissionScroll:ReprocessAnchoring();
	--new stuff
	--to make it look nice...
	Controls.ActivateButtonText:LocalizeAndSetText("Continue")
	Controls.BlackGrid:SetHide(false)
end
local g_ResourceEntries = {}

function OnEcoClicked()
	if Controls.Signal5:IsHidden() then
		Events.SerialEventGameMessagePopup( { Type = ButtonPopupTypes.BUTTONPOPUP_ECONOMIC_OVERVIEW, Data2 = -1} );
	else
		Events.SerialEventGameMessagePopup( { Type = ButtonPopupTypes.BUTTONPOPUP_ECONOMIC_OVERVIEW, Data2 = 4} );
		Controls.Signal5:SetHide(true);
	end
end
Controls.Economy:RegisterCallback( Mouse.eLClick, OnEcoClicked );

function OnEcoRightClicked()
	LuaEvents.ITG_RequestClearAHIndicator()
	Controls.Signal5:SetHide(true);
end
Controls.Economy:RegisterCallback( Mouse.eRClick, OnEcoRightClicked );


function OnTechClicked()
	LuaEvents.ITG_CallStateOverview(1)
end
Controls.Technology:RegisterCallback( Mouse.eLClick, OnTechClicked );


function OnWGPI()
	LuaEvents.ITG_CallWonderOverview()
end
Controls.WonderGPInspirations:RegisterCallback( Mouse.eLClick, OnWGPI );

function OnCouncilClicked()
	LuaEvents.ITG_CallManagementOverview();
end
Controls.Council:RegisterCallback( Mouse.eLClick, OnCouncilClicked );

function OnCultureClicked()
	Events.SerialEventGameMessagePopup( { Type = ButtonPopupTypes.BUTTONPOPUP_CHOOSEPOLICY, Data2 = -1} );
end
Controls.Culture:RegisterCallback( Mouse.eLClick, OnCultureClicked );

function OnReligionClicked()
	
	Events.SerialEventGameMessagePopup( { Type = ButtonPopupTypes.BUTTONPOPUP_RELIGION_OVERVIEW, Data2 = -1} );

end
Controls.Religion:RegisterCallback( Mouse.eLClick, OnReligionClicked );

function OnBudgetClicked()
	LuaEvents.ITG_CallBudgetOverview()
end
Controls.Budget:RegisterCallback( Mouse.eLClick, OnBudgetClicked );

function OnDominationClicked()
	LuaEvents.ITG_CallDominationOverview()
end
Controls.Domination:RegisterCallback( Mouse.eLClick, OnDominationClicked );

function OnGovermentClicked()
	LuaEvents.ITG_CallGovermentOverview()
end
Controls.Goverment:RegisterCallback( Mouse.eLClick, OnGovermentClicked );

function OnEspionageClicked()
	Events.SerialEventGameMessagePopup{ Type = ButtonPopupTypes.BUTTONPOPUP_ESPIONAGE_OVERVIEW, };
end
Controls.EspionageButton:RegisterCallback( Mouse.eLClick, OnEspionageClicked );

function OnDataMissionsRequest()
	Controls.MainDoM:SetHide(false)
	GenerateTheDoM()
	UpdateSignals()
end
Controls.Raport:RegisterCallback( Mouse.eLClick, OnDataMissionsRequest );

function UpdateSignals()
	local gPlayer = Game.GetActivePlayer()
	LuaEvents.ITGSG_RequestGT("InfoCorner");
	local gData = MapModData.ITGSG;
	MapModData.ITGSG = nil;
	if not gData then
		return
	end
	if (not Players[gPlayer]:IsAlive()) then
		Controls.StackHP1:SetHide(true);
		return;
	else
		Controls.StackHP1:SetHide(false);
	end
	if bFirstTooltips then
		DefineGPIcons()
		Controls.GSettlers:SetToolTipString(Locale.ConvertTextKey("TXT_KET_ITG_UI_IC_SETTLER", MapModData.DBScenario.FoodFromSettler));
		bFirstTooltips = false;
	end
	local gturn = gData.ITGTurn;
	local numadmirals = #gData.Players[gPlayer].ReservedAdmirals;
	local numgenerals = #gData.Players[gPlayer].ReservedGenerals;
	local numforts = gData.Players[gPlayer].NumFortPoints;
	local numcolonies = gData.Players[gPlayer].FreeColonies;
	local numHolySites = gData.Players[gPlayer].HolySitePoints;
	Controls.Religion:SetHide(MapModData.DBScenario.NoFaithGeneration);
	Controls.Budget:SetHide(not MapModData.DBScenario.GoldBudgetOnly);
	Controls.Domination:SetHide(not gData.Globals.DominationOn);
	Controls.GInquisitors:SetHide(true)
	Controls.GMissionares:SetDisabled(false);
	if gData.Players[gPlayer].FreeMissioniares > 0 then
		Controls.NumAva4:SetText("[COLOR_POSITIVE_TEXT]" .. gData.Players[gPlayer].FreeMissioniares .. "[ENDCOLOR]")
		Controls.GMissionares:SetHide(Players[gPlayer]:GetReligionCreatedByPlayer() < 1)
	else
		Controls.GMissionares:SetHide(true)
	end
	if (Players[gPlayer]:GetReligionCreatedByPlayer() > 0) and (numHolySites > 0) then
		Controls.GHolySites:SetHide(false)
	else
		Controls.GHolySites:SetHide(true)
	end
	Controls.NumAva7:SetText("[COLOR_POSITIVE_TEXT]" .. numHolySites .. "[ENDCOLOR]")
	Controls.GAdmirals:SetHide(numadmirals < 1)
	if numadmirals > 0 then
		local gpID = gData.Players[gPlayer].ReservedAdmirals[1].GPID;
		local getname = GetNameOfGreatPerson(gData.GreatPeople[gpID].Name, gData.GreatPeople[gpID].Que)
		local sAdmTT;
		LuaEvents.ITGSG_RequestGPAbilities(gpID);
		local shabData = MapModData.ITGSG;
		MapModData.ITGSG = nil;
		sAdmTT = "Assign Great Admiral to chosen unit.[NEWLINE][NEWLINE][COLOR_POSITIVE_TEXT]" .. getname .. "[ENDCOLOR][NEWLINE]" .. shabData.Help
		if gData.Players[gPlayer].CultBonusOn[114] then
			sAdmTT = sAdmTT .. "[NEWLINE]" .. shabData.SecHelp
		end
		if numadmirals > 1 then
			sAdmTT = sAdmTT .. "[NEWLINE][NEWLINE]Right-Click to select next Admiral."
		end
		if gData.Players[gPlayer].ReservedAdmirals[1].CD == gData.ITGTurn then
			sAdmTT = sAdmTT .. "[NEWLINE][NEWLINE]This great person cannot be assigned this turn."
			bAdmCanBe = false;
		else
			bAdmCanBe = true;
		end
		Controls.GAdmirals:SetToolTipString(sAdmTT)
	end
	Controls.GGenerals:SetHide(numgenerals < 1)
	if numgenerals > 0 then
		local gpID = gData.Players[gPlayer].ReservedGenerals[1].GPID;
		local getname = GetNameOfGreatPerson(gData.GreatPeople[gpID].Name, gData.GreatPeople[gpID].Que)
		local sGenTT;
		LuaEvents.ITGSG_RequestGPAbilities(gpID);
		local shabData = MapModData.ITGSG;
		MapModData.ITGSG = nil;
		sGenTT = "Assign Great General to chosen unit.[NEWLINE][NEWLINE][COLOR_POSITIVE_TEXT]" .. getname .. "[ENDCOLOR][NEWLINE]" .. shabData.Help
		if gData.Players[gPlayer].CultBonusOn[114] then
			sGenTT = sGenTT .. "[NEWLINE]" .. shabData.SecHelp
		end
		if numgenerals > 1 then
			sGenTT = sGenTT .. "[NEWLINE][NEWLINE]Right-Click to select next General."
		end
		
		if gData.Players[gPlayer].ReservedGenerals[1].CD == gData.ITGTurn then
			sGenTT = sGenTT .. "[NEWLINE][NEWLINE]This great person cannot be assigned this turn."
			bGenCanBe = false;
		else
			bGenCanBe = true;
		end
		Controls.GGenerals:SetToolTipString(sGenTT)
	end
	local numacad = #gData.Players[gPlayer].AcademyPoints
	local numcust = #gData.Players[gPlayer].CustomHousePoints
	local nummanuf = #gData.Players[gPlayer].ManufactoryPoints
	local numsett = gData.Players[gPlayer].SettlerPoints
	local numfestivalpoints = gData.Players[gPlayer].FestivalPoints

	Controls.GAcademy:SetHide(numacad < 1)
	Controls.GCustomH:SetHide(numcust < 1)
	Controls.GManuF:SetHide(nummanuf < 1)
	Controls.GSettlers:SetHide(numsett < 1)
	Controls.GFestivals:SetHide(numfestivalpoints < 1)
	Controls.GRailroad:SetHide(not gData.Players[gPlayer].CanDoRailroad)
	if gData.Players[gPlayer].CanDoRailroad then
		local railrTT = "Each railroad costs " .. gData.Players[gPlayer].ICrailroadcost .. " [ICON_WORKER] Work Rate from nearest Cities."
		if gData.Players[gPlayer].NumFreeRailroads == 0 then
			Controls.NumAva17:SetText(gData.Players[gPlayer].ICrailroadava)
		else
			Controls.NumAva17:SetText("[COLOR_POSITIVE_TEXT]" .. gData.Players[gPlayer].ICrailroadava .. "[ENDCOLOR]")
			railrTT = railrTT .. "[NEWLINE][NEWLINE]You can place [COLOR_POSITIVE_TEXT]" .. gData.Players[gPlayer].NumFreeRailroads .. "[ENDCOLOR] Railroads for FREE."
		end
		railrTT = railrTT .. "[NEWLINE][NEWLINE]Each turn you can place only " .. gData.Players[gPlayer].RailroadsPT .. " railroads (" .. gData.Players[gPlayer].RailroadsPT - gData.Players[gPlayer].RailroadMadeT .. " left)."
		railrTT = railrTT .. "[NEWLINE][NEWLINE][COLOR_GREY]Shift + R[ENDCOLOR]"
		Controls.GRailroad:SetToolTipString(railrTT)
	end
	Controls.GMilEngineer:SetHide(gData.Players[gPlayer].NumMilitaryEngineers <= 0)
	Controls.NumAva18:SetText(gData.Players[gPlayer].NumMilitaryEngineers)
	if numfestivalpoints > 0 then
		LuaEvents.ITGSG_RequestFestivalStringNewOne(gPlayer)
		Controls.GFestivals:SetToolTipString(MapModData.ITGSG or "")
		MapModData.ITGSG = nil;
	end
	Controls.GMilRecon:SetHide(not gData.Players[gPlayer].CanUseRecon)
	Controls.GInstantWar:SetHide((not gData.Players[gPlayer].InstantWar) or (gData.Players[gPlayer].InstantWar + 12 > gData.ITGTurn))

	Controls.GSupportRam:SetHide(gData.Players[gPlayer].BatteringSupport  <= 0)
	Controls.GSupportSiege:SetHide(gData.Players[gPlayer].SiegeTowerSupport  <= 0)
	Controls.NumAva20:SetText("[COLOR_POSITIVE_TEXT]" .. gData.Players[gPlayer].BatteringSupport .. "[ENDCOLOR]")
	Controls.NumAva21:SetText("[COLOR_POSITIVE_TEXT]" .. gData.Players[gPlayer].SiegeTowerSupport .. "[ENDCOLOR]")
	Controls.GCSAlert:SetHide(#gData.Players[gPlayer].CSAlertQuest <= 0)
	Controls.NumAva22:SetText("[COLOR_POSITIVE_TEXT]" .. #gData.Players[gPlayer].CSAlertQuest .. "[ENDCOLOR]")
		
	if #gData.Players[gPlayer].Satellites > 0 then
		Controls.GSatellites:SetHide(false)
		Controls.NumAva23:SetText(#gData.Players[gPlayer].Satellites)
		local cSatSel = gData.Players[gPlayer].SatSelected or 1
		local cPlot = Map.GetPlotByIndex(gData.Players[gPlayer].Satellites[cSatSel].Pos)
		local satText = "Currently selected satellite: " .. gData.Players[gPlayer].Satellites[cSatSel].Name .. ".[NEWLINE][NEWLINE]Location: " .. cPlot:GetX() .. ", " .. cPlot:GetY() .. "."
		if gData.Players[gPlayer].Satellites[cSatSel].PlannedMove then
			local sNextPlot = Map.GetPlotByIndex(gData.Players[gPlayer].Satellites[cSatSel].PlannedMove);
			satText = satText .. "[NEWLINE][NEWLINE]Planned reposition to: " .. sNextPlot:GetX() .. ", " .. sNextPlot:GetY() .. "."
		end
		satText = satText .. "[NEWLINE][NEWLINE]Left-click to set new position for satellite (movement is done next turn).[NEWLINE][NEWLINE]Right-click to select next satellite."
		Controls.GSatellites:SetToolTipString(satText)
	else
		Controls.GSatellites:SetHide(true)
	end
	local bHide100Turn = true;
	if gData.ITGTurn == 100 then
		for iCity in Players[gPlayer]:Cities() do
			if (iCity:GetProductionBuilding() == -1) and (iCity:GetProductionUnit() == -1) and (iCity:GetProductionProcess() == -1) then
				bHide100Turn = false;
				break;
			end
		end
	end
	Controls.GCS100turnHelp:SetHide(bHide100Turn)

	Controls.NumAva16:SetText("[COLOR_POSITIVE_TEXT]" .. numfestivalpoints .. "[ENDCOLOR]")
	Controls.NumAva15:SetText("[COLOR_POSITIVE_TEXT]" .. numsett .. "[ENDCOLOR]")
	Controls.NumAva12:SetText("[COLOR_POSITIVE_TEXT]" .. numacad .. "[ENDCOLOR]")
	Controls.NumAva13:SetText("[COLOR_POSITIVE_TEXT]" .. numcust .. "[ENDCOLOR]")
	Controls.NumAva14:SetText("[COLOR_POSITIVE_TEXT]" .. nummanuf .. "[ENDCOLOR]")

	Controls.GForts:SetHide(numforts < 1)
	Controls.GColonies:SetHide(numcolonies < 1)
	Controls.NumAva1:SetText("[COLOR_POSITIVE_TEXT]" .. numgenerals .. "[ENDCOLOR]")
	Controls.NumAva2:SetText("[COLOR_POSITIVE_TEXT]" .. numadmirals .. "[ENDCOLOR]")
	Controls.NumAva3:SetText("[COLOR_POSITIVE_TEXT]" .. numforts .. "[ENDCOLOR]")
	Controls.NumAva5:SetText("[COLOR_POSITIVE_TEXT]" .. numcolonies .. "[ENDCOLOR]")
	local nummesosgr = gData.Players[gPlayer].MesoSGRPoints;
	Controls.NumAva10:SetText("[COLOR_POSITIVE_TEXT]" .. nummesosgr .. "[ENDCOLOR]")
	Controls.GMesoSGR:SetHide(nummesosgr < 1)
	Controls.GShinobi:SetHide((not gData.Players[gPlayer].CanHaveShinobiVision) or (Game.GetGameTurn() <= gData.Players[gPlayer].ShinobiVisionCooldown))
	Controls.GResMovement:SetHide((not gData.Players[gPlayer].CanResMovement) or (Game.GetGameTurn() <= gData.Players[gPlayer].ResMovementCooldown))
	Controls.GLastCall:SetHide(gData.Players[gPlayer].LastCallCharges == 0)
	Controls.NumAva25:SetText("[COLOR_POSITIVE_TEXT]" .. gData.Players[gPlayer].LastCallCharges .. "[ENDCOLOR]")
	

	Controls.GChateau:SetHide(gData.Players[gPlayer].ChateauCharges == 0)
	Controls.NumAva26:SetText("[COLOR_POSITIVE_TEXT]" .. gData.Players[gPlayer].ChateauCharges .. "[ENDCOLOR]")
	Controls.GFeitoria:SetHide(gData.Players[gPlayer].FeitoriaCharges == 0)
	Controls.NumAva27:SetText("[COLOR_POSITIVE_TEXT]" .. gData.Players[gPlayer].FeitoriaCharges .. "[ENDCOLOR]")
	

	Controls.GMesoElD:SetHide(gData.Players[gPlayer].MesoElDoradoPoints < 1)
	--espionage
	local numSpies = 0;
	local numGovsToAssign = 0;
	if gData.Players[gPlayer].Goverment ~= 1 then
		for i, data in pairs(gData.Players[gPlayer].Agents) do
			if data.Mission == -1 then
				if (not data.IgnoreItForever) then 
					if data.IsAlive then
						if (gturn- data.LastTimeRelocated) >= 4 then
							numSpies = numSpies + 1;
						end
					end
				end
			end
		end
		if gData.Players[gPlayer].ICgovcava then
			for igv, gvbbb in pairs(gData.Players[gPlayer].Governors) do
				if not gData.Globals.Governors[igv].City then
					numGovsToAssign = numGovsToAssign + 1;	
				end
			end
		end
	end
	Controls.Signal6:SetHide(numSpies == 0);
	Controls.Signal6:SetText(numSpies)

	Controls.Signal2:SetHide(numGovsToAssign == 0);
	Controls.Signal2:SetText(numGovsToAssign)
	
	local cAHoffers = 0;
	if gData.Players[gPlayer].NotifyAHDeals then
		for jkj, hjh in pairs(gData.Players[gPlayer].AuctionSpecialDeals) do
			cAHoffers = cAHoffers + 1;
		end
		Controls.Signal5:SetText(cAHoffers)
	end
	Controls.Signal5:SetHide(cAHoffers == 0);
end

function OnActivateButtonClicked ()
	Controls.MainDoM:SetHide(true)
end
Controls.ActivateButton:RegisterCallback( Mouse.eLClick, OnActivateButtonClicked );
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------

local maxIdx = 0;
if( InfoCornerID["Resources"] == nil ) then
    for index, value in pairs(InfoCornerID) do
        maxIdx = maxIdx + 1;
    end
    InfoCornerID["Resources"] = maxIdx;
	maxIdx = maxIdx + 1;
	InfoCornerID["GP"] = maxIdx;
else
    maxIdx = InfoCornerID.GP;
end

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
m_InfoData = {};
m_InfoData[ InfoCornerID.None ] = {
    ToolTip="TXT_KEY_CLOSE",
    Image="assets/UI/Art/Icons/MainOpen.dds",
    HL="assets/UI/Art/Icons/MainOpenHL.dds" };
    
m_InfoData[ InfoCornerID.Tech ] = {
    ToolTip="TXT_KEY_IC_RESEARCH",
    Image="assets/UI/Art/Icons/MainTechButton.dds",
    HL="assets/UI/Art/Icons/MainTechButtonHL.dds" };
    
m_InfoData[ InfoCornerID.Units ] = {
    ToolTip="TXT_KEY_IC_UNIT",
    Image="assets/UI/Art/Icons/MainUnitButton.dds",
    HL="assets/UI/Art/Icons/MainUnitButtonHL.dds" };
    
m_InfoData[ InfoCornerID.Cities ] = {
    ToolTip="TXT_KEY_IC_CITY",
    Image="assets/UI/Art/Icons/MainCityButton.dds",
    HL="assets/UI/Art/Icons/MainCityButtonHL.dds" };

m_InfoData[ InfoCornerID.Resources ] = {
    ToolTip="TXT_KEY_IC_RESOURCE",
	Image="assets/DLC/Shared/UI/Art/Icons/MainResourceButton.dds",
	HL="assets/DLC/Shared/UI/Art/Icons/MainResourceButtonHL.dds" };
	
m_InfoData[ InfoCornerID.GP ] = {
    ToolTip="TXT_KEY_IC_GP",
    Image="assets/DLC/Shared/UI/Art/Icons/MainGreatPersonButton.dds",
    HL="assets/DLC/Shared/UI/Art/Icons/MainGreatPersonButtonHL.dds" };

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------

local g_CurrentInfoCornerID = -1;
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function OnOpenInfoCorner( iInfoType )
    g_CurrentInfoCornerID = iInfoType;
	UpdateSignals()
end
Events.OpenInfoCorner.Add( OnOpenInfoCorner );

local g_PerPlayerState = {};
----------------------------------------------------------------
-- 'Active' (local human) player has changed
----------------------------------------------------------------
function OnInfoCornerActivePlayerChanged( iActivePlayer, iPrevActivePlayer )
	UpdateSignals()
	-- Restore the state per player
	local bIsHidden = ContextPtr:IsHidden() == true;
	-- Save the state per player
	if (iPrevActivePlayer ~= -1) then
		g_PerPlayerState[ iPrevActivePlayer + 1 ] = g_CurrentInfoCornerID;
	end
	
	if (iActivePlayer ~= -1) then
		if (g_PerPlayerState[ iActivePlayer + 1 ] == nil or g_PerPlayerState[ iActivePlayer + 1 ] == -1) then
			Events.OpenInfoCorner( InfoCornerID.None );
		else
			local iWantInfoCorner = g_PerPlayerState[ iActivePlayer + 1 ];
			if ( iWantInfoCorner ~= g_CurrentInfoCornerID) then
				Events.OpenInfoCorner( iWantInfoCorner );
			end
		end
	end
end
Events.GameplaySetActivePlayer.Add(OnInfoCornerActivePlayerChanged);



