
-------------------------------------------------
-- SocialPolicy Chooser Popup
-------------------------------------------------

include( "IconSupport" );
include( "InstanceManager" );
include( "CommonBehaviors" );
include( "FLuaVector" );

local bLimitedSocials = PreGame.GetGameOption("GAMEOPTION_ITG_LIMITED_SOCIALS") == 1;

local rsydis = 0;
local iBasePoffX = 6;
local iBasePoffY = 8;
local sx, sy, xdis, perrow, ydis, sydis = 12, 15, 80, 12, 75, 50
function SetSXY(x, y, d, p, dy, sbot, khj, jhk)
	sx, sy, xdis, perrow, ydis, sydis = x, y, d, p, dy, sbot;
	iBasePoffX = khj;
	iBasePoffY = jhk;
end
if bLimitedSocials then
	perrow = 4;
	iBasePoffX = 326;
	iBasePoffY = 45;
end

local bSimplifiedView = false;
local bIsIdeology = false;
local g_PolicyIcons = InstanceManager:new( "PolicyButton", "PolicyIcon", Controls.MainPolicyStack );
local g_IdeologyIcons = InstanceManager:new( "IdeologyITGButton", "IdeologyIcon", Controls.MainIdeologyStack );
local g_hasPolicyIcons = InstanceManager:new( "PolicyButton", "PolicyIcon", Controls.HasPolicyStack );
local g_MiniIdeologyIcons = InstanceManager:new("IdeologyMiniITGButton", "IdeologyIcon", Controls.MainPolicyStack );
local g_HasMiniIdeologyIcons = InstanceManager:new("IdeologyMiniITGButton", "IdeologyIcon", Controls.HasPolicyStack );
local g_otherCivIdeologies = InstanceManager:new("IdeologyInfoCiv", "OtherIdeologyInfo", Controls.OthersInfoIdeologyStack );
local g_HighlightTab = InstanceManager:new("HighlightTabInstance", "Button", Controls.HighlightTabStack1 );
local g_HighlightTab2 = InstanceManager:new("HighlightTabInstance", "Button", Controls.HighlightTabStack2 );
local g_PlayersCG = InstanceManager:new("CultureGroupPlayerInstance", "Button", Controls.CulturalGroupTabStack );

local bInitHighlight = false;
local HighlightTabData = {
{Check = "WarOffense", Value = false, IconText = "[ICON_WAR]", ToolTip = "Military"},
{Check = "WarDefensive", Value = false, IconText = "[ICON_STRENGTH]", ToolTip = "Defense"},
{Check = "Trade", Value = false, IconText = "[ICON_TRADE_WHITE]", ToolTip = "Trade"},
{Check = "Festival", Value = false, IconText = "[ICON_ITG_FESTIVAL]", ToolTip = "Festival"},
{Check = "Gold", Value = false, IconText = "[ICON_GOLD]", ToolTip = "Gold"},
{Check = "CityState", Value = false, IconText = "[ICON_CITY_STATE]", ToolTip = "City-States"},
{Check = "Faith", Value = false, IconText = "[ICON_PEACE]", ToolTip = "Faith"},
{Check = "GeneralAdmiral", Value = false, IconText = "[ICON_GREAT_GENERAL]", ToolTip = "Generals and Admirals"},
{Check = "Happiness", Value = false, IconText = "[ICON_HAPPINESS_1]", ToolTip = "Happiness"},
{Check = "Food", Value = false, IconText = "[ICON_FOOD]", ToolTip = "Food"},
{Check = "Settler", Value = false, IconText = "[ICON_ITG_SETTLER]", ToolTip = "Settlers"},
{Check = "Wonder", Value = false, IconText = "[ICON_GREAT_ENGINEER]", ToolTip = "Wonders"},
{Check = "Legal", Value = false, IconText = "[ICON_ITG_LEGAL_POWER]", ToolTip = "Legal"},
{Check = "Maritime", Value = false, IconText = "[ICON_RES_FISH]", ToolTip = "Maritime"},
{Check = "Economy", Value = false, IconText = "[ICON_INVEST]", ToolTip = "Currency"},
{Check = "Mobility", Value = false, IconText = "[ICON_MOVES]", ToolTip = "Mobility"},
{Check = "Exploration", Value = false, IconText = "[ICON_GREAT_EXPLORER]", ToolTip = "Exploration"},
{Check = "Work", Value = false, IconText = "[ICON_WORKER]", ToolTip = "Work Rate"},
{Check = "Riots", Value = false, IconText = "[ICON_RESISTANCE]", ToolTip = "Riots"},
{Check = "GreatPeople", Value = false, IconText = "[ICON_GREAT_PEOPLE]", ToolTip = "Great People"},
{Check = "Espionage", Value = false, IconText = "[ICON_SPY]", ToolTip = "Espionage"},
{Check = "Authority", Value = false, IconText = "[ICON_ITG_AUTHORITY]", ToolTip = "Authority"},
{Check = "Science", Value = false, IconText = "[ICON_RESEARCH]", ToolTip = "Science"},
{Check = "Health", Value = false, IconText = "[ICON_ITG_HEALTH_1]", ToolTip = "Health"},
{Check = "Presence", Value = false, IconText = "[ICON_ITG_PRESENCE]", ToolTip = "Cultural Presence"},
{Check = "Production", Value = false, IconText = "[ICON_PRODUCTION]", ToolTip = "Production"},
{Check = "GreatWorks", Value = false, IconText = "[ICON_GREAT_WORK]", ToolTip = "Great Works"},
{Check = "Academy", Value = false, IconText = "[ICON_ITG_ACADEMY_2]", ToolTip = "Academy"},
{Check = "Religion", Value = false, IconText = "[ICON_PROPHET]", ToolTip = "Religion"},
{Check = "CustomsHouse", Value = false, IconText = "[ICON_ITG_CUSTOMS_HOUSE]", ToolTip = "Customs House"},
{Check = "Manufactory", Value = false, IconText = "[ICON_ITG_MANUFACTORY]", ToolTip = "Manufactory"},
{Check = "Meritocracy", Value = false, IconText = "[ICON_ITG_MERITOCRACY]", ToolTip = "Meritocracy"},
{Check = "Governor", Value = false, IconText = "[ICON_ITG_GOVERNOR]", ToolTip = "Governors"},
{Check = "Colony", Value = false, IconText = "[ICON_GREAT_MERCHANT]", ToolTip = "Colony"},
{Check = "Culture", Value = false, IconText = "[ICON_CULTURE]", ToolTip = "Culture"},

{Check = "Other", Value = false, IconText = "[ICON_PLUS]", ToolTip = "Other"},
}

local fullColor = {x = 1, y = 1, z = 1, w = 1};
local fadeColor = {x = 1, y = 1, z = 1, w = 0};
local fadeColorRV = {x = 1, y = 1, z = 1, w = 0.2};
local pinkColor = {x = 2, y = 0, z = 2, w = 1};
local lockTexture = "48Lock.dds";
local checkTexture = "48Checked.dds";
local itg3DtreeLevel = 3;
local revIdeoPos;

function GetPositionOfIdeology(tab, id)
	if not revIdeoPos then
		revIdeoPos = {}
		for a, b in pairs(tab) do
			revIdeoPos[b] = a;
		end
	end
	return revIdeoPos[id];
end

LuaEvents.ITG_SocialPolicyDefine.Add(function(bValue)
	bIsIdeology = bValue;
end)

function GetPlayerNiceCivName(i)
	if Game.GetActivePlayer() == i then
		return "You"
	elseif Teams[Game.GetActiveTeam()]:IsHasMet(Players[i]:GetTeam()) then
		return Players[i]:GetCivilizationShortDescription()
	end
	return "Unknown Player"
end

local cTab;
local ideologyTab;
local MinitideologyTab;
local ideostringTab = {
R = "[ICON_IDEOLOGY_REASON]", O = "[ICON_IDEOLOGY_ORDER]", F = "[ICON_IDEOLOGY_FREEDOM]", A = "[ICON_IDEOLOGY_AUTOCRACY]", L = "[ICON_IDEOLOGY_LIBERTY]", E = "[ICON_IDEOLOGY_EQUALITY]", S = "[ICON_IDEOLOGY_SUPREMACY]"
}

local unshowvalue = 0.15;
function SetUnshowValue(c)
	unshowvalue = c;
end

function GetToolTipIdeologyMini(i, iOwner)
	local t = MinitideologyTab[i].Name .. "[NEWLINE]----------------[NEWLINE]" .. ideostringTab[MinitideologyTab[i].Ideology] .. ": 1[NEWLINE]----------------[NEWLINE]" .. MinitideologyTab[i].Help
	if iOwner and (iOwner ~= Game.GetActivePlayer()) then
		t = t .. "[NEWLINE][NEWLINE]Adopted by " .. GetPlayerNiceCivName(iOwner) .. "."
	end
	return t;
end

function GetToolTipIdeology(i, iOwner, bAva, realPos)
	local t = ideologyTab[i].Name .. "[NEWLINE]----------------[NEWLINE]"
	for h, v in pairs(ideostringTab) do
		if ideologyTab[realPos][h] > 0 then
			t = t .. v .. ": " .. ideologyTab[realPos][h] .. "[NEWLINE]"
		end
	end
	t = t .. "----------------[NEWLINE]" .. ideologyTab[i].Help
	if iOwner then
		t = t .. "[NEWLINE][NEWLINE]Adopted by " .. GetPlayerNiceCivName(iOwner) .. "."
	elseif not bAva then
		t = t .. "[NEWLINE][NEWLINE][COLOR_NEGATIVE_TEXT]Is locked right now.[ENDCOLOR]"
	end
	return t;
end

function DefineTables()
	if not cTab then
		LuaEvents.ITG_RequestTenetsAndPoliciesData();
		cTab = MapModData.ITGSG
		ideologyTab = MapModData.ITGSG2
		MinitideologyTab = MapModData.ITGSG3
		MapModData.ITGSG = nil;
		MapModData.ITGSG2 = nil;
		MapModData.ITGSG3 = nil;
	end
end

function GetAlphaBasedOnCheckboxes(i)
	local bAny = false;
	for jj, data in pairs(HighlightTabData) do
		if data.Value then
			bAny = true;
			if cTab[i][data.Check] then
				return 1;
			end
		end
	end
	if bAny then
		return unshowvalue;
	else
		return 1;
	end
end

function CheckBoxRegister(bCheck, a)
	HighlightTabData[a].Value = bCheck;
	UpdateCulture()
end

function GetHTD()
	return HighlightTabData;
end

function InitHighlights()
	if bInitHighlight then
		return;
	end
	bInitHighlight = true;
	for i, data in pairs(HighlightTabData) do
		if i <= 19 then
			HighlightTabData[i].Instance = g_HighlightTab:GetInstance();
		else
			HighlightTabData[i].Instance = g_HighlightTab2:GetInstance();
		end
		HighlightTabData[i].Instance.Checkbox:SetVoid1(i)
		HighlightTabData[i].Instance.Checkbox:RegisterCheckHandler(CheckBoxRegister)
		HighlightTabData[i].Instance.Checkbox:GetTextButton():SetText(data.IconText)
		HighlightTabData[i].Instance.Checkbox:SetToolTipString(data.ToolTip)
	end
	Controls.HighlightTabStack1:CalculateSize();
	Controls.HighlightTabStack1:ReprocessAnchoring();
	Controls.HighlightTabStack2:CalculateSize();
	Controls.HighlightTabStack2:ReprocessAnchoring();
end

function OnClearAllHighlights()
	for i, data in pairs(HighlightTabData) do
		HighlightTabData[i].Value = false;
		data.Instance.Checkbox:SetCheck(false)
	end
	UpdateCulture()
end
Controls.ClearAllHighlights:RegisterCallback( Mouse.eLClick, OnClearAllHighlights)

g_Tabs = {
	["SocialPolicies"] = {
		Button = Controls.TabButtonSocialPolicies,
		Panel = Controls.SocialPolicyPane,
		SelectHighlight = Controls.TabButtonSocialPoliciesHL,
	},
	
	["Ideologies"] = {
		Button = Controls.TabButtonIdeologies,
		Panel = Controls.IdeologyPane,
		SelectHighlight = Controls.TabButtonIdeologiesHL,
	},
}

function GetPlayerNiceIndexForIcon(i)
	if Game.GetActivePlayer() == i then
		return i
	elseif Teams[Game.GetActiveTeam()]:IsHasMet(Players[i]:GetTeam()) then
		return i
	end
	return -1
end

function OnPopupMessage(popupInfo)
	
	local popupType = popupInfo.Type;
	if popupType ~= ButtonPopupTypes.BUTTONPOPUP_CHOOSEPOLICY then
		return;
	end
	
	m_PopupInfo = popupInfo;

	UpdateDisplay();
	
	if(m_PopupInfo.Data2 == 2) then
		TabSelect(g_Tabs["Ideologies"]);
	else
		if bIsIdeology then
			TabSelect(g_Tabs["Ideologies"]);
		else
			TabSelect(g_Tabs["SocialPolicies"]);
		end
	end
	
	if( m_PopupInfo.Data1 == 1 ) then
    	if( ContextPtr:IsHidden() == false ) then
    	    OnClose();
    	else
        	UIManager:QueuePopup( ContextPtr, PopupPriority.InGameUtmost );
    	end
	else
    	UIManager:QueuePopup( ContextPtr, PopupPriority.SocialPolicy );
	end
end
Events.SerialEventGameMessagePopup.Add( OnPopupMessage );

-------------------------------------------------
-------------------------------------------------
function UpdateDisplay()
	DefineTables()
    local player = Players[Game.GetActivePlayer()];
   	CivIconHookup( player:GetID(), 64, Controls.CivIcon, Controls.CivIconBG, Controls.CivIconShadow, false, true );
	UpdateCulture()
	UpdateIdeology()
end

local globXoffsetIdeology = 270;
local globYoffsetIdeology = 60;
local globLeveloffset = -5;
local globLeveloffsetY = -5;
local ideoXspace = 110;
local ideoYspace = 110;
local hColor1 = "";
local hColor2 = "[COLOR_GREY]";
function SetGlobalOffsetes(a, b, c, d, e, f, g ,h)
	globXoffsetIdeology = a;
	globYoffsetIdeology = b;
	globLeveloffset = c;
	ideoXspace = d
	ideoYspace = e
	globLeveloffsetY = f
	hColor1 = g;
	hColor2 = h
end

function OnIdeologyUp()
	itg3DtreeLevel = itg3DtreeLevel + 1;
	UpdateIdeology()
end
Controls.IdeologyGoUp:RegisterCallback( Mouse.eLClick, OnIdeologyUp );

function OnIdeologyDown()
	itg3DtreeLevel = itg3DtreeLevel - 1;
	UpdateIdeology()
end
Controls.IdeologyGoDown:RegisterCallback( Mouse.eLClick, OnIdeologyDown );

local ideostringTab = {
R = "[ICON_IDEOLOGY_REASON]", O = "[ICON_IDEOLOGY_ORDER]", F = "[ICON_IDEOLOGY_FREEDOM]", A = "[ICON_IDEOLOGY_AUTOCRACY]", L = "[ICON_IDEOLOGY_LIBERTY]", E = "[ICON_IDEOLOGY_EQUALITY]", S = "[ICON_IDEOLOGY_SUPREMACY]"
}

function IdeologyTenetSelected(void1)
	LuaEvents.ITG_PlayerChooseIdeologyTenet(void1)
	UpdateIdeology()
end

function MiniIdeologyTenetSelected(void1)
	LuaEvents.ITG_PlayerChooseIdeologyTenet(void1)
	UpdateCulture()
end

function UpdateIdeology()
--itg3DtreeLevel
	LuaEvents.ITGSG_RequestGT();
	local gData = MapModData.ITGSG;
	MapModData.ITGSG = nil;
	if not gData then
		return
	end

	local bHideEverything = not MapModData.DBScenario.IdeologyOn;
	Controls.IdeologyGoUp:SetHide(bHideEverything)
	Controls.IdeologyGoDown:SetHide(bHideEverything)
	Controls.FreeTenetsLabel:SetHide(bHideEverything)
	Controls.InfoIdeologyStack:SetHide(bHideEverything)
	Controls.OthersInfoIdeologyStack:SetHide(bHideEverything)
	Controls.IdeologyName:SetText("")
	Controls.DisabledIdeology:SetHide(not bHideEverything)
	g_IdeologyIcons:ResetInstances();
	if not bHideEverything then
		local activePlayer = Game.GetActivePlayer();
		g_otherCivIdeologies:ResetInstances();
		numotherciv = 0;
		local hColor = hColor1
		for g, h in pairs(gData.Players) do
			if not Players[g]:IsMinorCiv() then
		--		if g ~= activePlayer then
					controlTable = g_otherCivIdeologies:GetInstance();
					for letter, sth in pairs(h.Ideologies) do
						controlTable["OtherIdeInfo" .. letter]:SetText(hColor .. sth)
					end
					CivIconHookup( GetPlayerNiceIndexForIcon(g), 32, controlTable.Icon, controlTable.CivIconBG, controlTable.CivIconShadow, false, true);  
					controlTable.BoxImageID:SetToolTipString(h.IdeologyName or (Players[g]:GetCivilizationAdjective() .. " Ideology"))
					numotherciv = numotherciv + 1;
					sglobaclotherinfo = controlTable;
					if hColor == hColor1 then
						hColor = hColor2
					else
						hColor = hColor1
					end
	--			end
			end
		end
		Controls.OthersInfoIdeologyStack:SetOffsetVal(20, 280 - numotherciv * 11)
		if not gData.Players[activePlayer] then
			return;
		end
		Controls.IdeologyName:SetText(gData.Players[activePlayer].IdeologyName or "")
		Controls.IdeologyGoUp:SetDisabled(itg3DtreeLevel >= 5)
		Controls.IdeologyGoDown:SetDisabled(itg3DtreeLevel <= 1)
		local bCanChoose = gData.Players[activePlayer].IsPickingIdeology
		if bCanChoose then
			Controls.FreeTenetsLabel:SetText("You can select a new Ideological Tenet right now.")
		end
		for letter, value in pairs(gData.Players[activePlayer].Ideologies) do
			Controls["GovInfoLabel" .. letter]:SetText(value)
		end
		Controls.FreeTenetsLabel:SetHide(not bCanChoose)
		if (bSimplifiedView) and (not bCanChoose) then
			local hICount = 1;
			for j, vdata in pairs(ideologyTab) do
				if gData.Players[activePlayer].HasIdeology[j] then
					local controlTable = g_IdeologyIcons:GetInstance();
					controlTable.IdeologyIcon:SetOffsetVal(globXoffsetIdeology + ideoXspace * (hICount % 5), globYoffsetIdeology + ideoYspace * (math.floor((hICount - 1) / 5)));
					local bDisable = true;
					local sTexture = "IdeologyITGTaken.dds";
					controlTable.BoxImageID:SetHide(false)
					controlTable.IdeoFont1:SetAlpha(1.0)
					controlTable.IdeoFont2:SetAlpha(1.0)
					controlTable.IdeoFont3:SetAlpha(1.0)
					controlTable.IdeoFont4:SetAlpha(1.0)
					controlTable.BoxImageID:SetAlpha(1.0)
					controlTable.IdeologyImage:SetColor({x = 1, y = 1, z = 1, w = 1})
					local currentPos = GetPositionOfIdeology(gData.IdeologiesPosition,j);
					controlTable.IdeologyIcon:SetToolTipString(GetToolTipIdeology(j, gData.IdeologyTaken[j], gData.AvailableIdeologies[j], currentPos))
					CivIconHookup( activePlayer, 32, controlTable.Icon, controlTable.CivIconBG, controlTable.CivIconShadow, false, true);
					controlTable.IdeologyIcon:SetDisabled(bDisable)
					controlTable.IdeologyImage:SetTexture(sTexture)
					controlTable.IdeologyImage:SetHide(not bDisable)
					gtcontrol = controlTable;
					local h = 1;
					--for shuffle here only letters
					local letterDataPos = ideologyTab[currentPos]
					for tss, iconstring in pairs(ideostringTab) do
						for hv = 1, letterDataPos[tss] do
							if h < 5 then
								controlTable["IdeoFont" .. h]:SetText(iconstring)
								h = h + 1;
							end
						end
					end
					hICount = hICount + 1;
				end
			end
		else
			for i = 1, 5 do
				if i <= itg3DtreeLevel then
					local leveloffset = (i - 1) * globLeveloffset;
					local leveloffsety = (i - 1) * globLeveloffsetY;
					for posHID, posIdeoID in pairs(gData.IdeologiesPosition) do
						if ideologyTab[posHID].z == i and ((not bSimplifiedView) or gData.AvailableIdeologies[posIdeoID]) then
							local posdata = ideologyTab[posHID];
							local bDisable = true;
							local sTexture;
							--decide if disable button
							local controlTable = g_IdeologyIcons:GetInstance();
							controlTable.IdeologyIcon:SetOffsetVal(leveloffset + globXoffsetIdeology + ideoXspace * (posdata.x - 1), leveloffsety + globYoffsetIdeology + ideoYspace * (posdata.y - 1));
							if i == itg3DtreeLevel then
								controlTable.IdeoFont1:SetAlpha(1.0)
								controlTable.IdeoFont2:SetAlpha(1.0)
								controlTable.IdeoFont3:SetAlpha(1.0)
								controlTable.IdeoFont4:SetAlpha(1.0)
								controlTable.BoxImageID:SetAlpha(1.0)
								controlTable.IdeologyImage:SetColor({x = 1, y = 1, z = 1, w = 1})
								controlTable.IdeologyIcon:SetToolTipString(GetToolTipIdeology(posIdeoID, gData.IdeologyTaken[posIdeoID], gData.AvailableIdeologies[posIdeoID], posHID))
							else
								controlTable.IdeologyImage:SetColor({x = 0.3, y = 0.3, z = 0.3, w = 1})
								controlTable.IdeoFont1:SetAlpha(0.3)
								controlTable.IdeoFont2:SetAlpha(0.3)
								controlTable.IdeoFont3:SetAlpha(0.3)
								controlTable.IdeoFont4:SetAlpha(0.3)
								controlTable.BoxImageID:SetAlpha(0.3)
								controlTable.IdeologyIcon:SetToolTipString("")
							end
							if gData.IdeologyTaken[posIdeoID] then
								if gData.IdeologyTaken[posIdeoID] == activePlayer or gData.Players[activePlayer].HasIdeology[posIdeoID] then
									CivIconHookup( activePlayer, 32, controlTable.Icon, controlTable.CivIconBG, controlTable.CivIconShadow, false, true);  
									sTexture = "IdeologyITGTaken.dds"
								else
									CivIconHookup( GetPlayerNiceIndexForIcon(gData.IdeologyTaken[posIdeoID]), 32, controlTable.Icon, controlTable.CivIconBG, controlTable.CivIconShadow, false, true);  
									sTexture = "IdeologyITGTakenByOtherCiv.dds"
								end
								controlTable.BoxImageID:SetHide(false)
							else
								controlTable.BoxImageID:SetHide(true)
								if gData.AvailableIdeologies[posIdeoID] then
									sTexture = "IdeologyITGCanBeChosen.dds"
									if bCanChoose then
										if itg3DtreeLevel == i then
											bDisable = false;
											controlTable.IdeologyIcon:SetVoid1( posIdeoID );
											controlTable.IdeologyIcon:RegisterCallback( Mouse.eLClick, IdeologyTenetSelected );
										end
									end
								else
									sTexture = "IdeologyITGCannotBeChosen.dds"
									if bCanChoose and (itg3DtreeLevel == i) then
										controlTable.IdeologyImage:SetColor({x = 0.8, y = 0.8, z = 0.8, w = 1})
										controlTable.IdeoFont1:SetAlpha(0.8)
										controlTable.IdeoFont2:SetAlpha(0.8)
										controlTable.IdeoFont3:SetAlpha(0.8)
										controlTable.IdeoFont4:SetAlpha(0.8)
									end
								end 
							end
							controlTable.IdeologyIcon:SetDisabled(bDisable)
							controlTable.IdeologyImage:SetTexture(sTexture)
							controlTable.IdeologyImage:SetHide(not bDisable)
							gtcontrol = controlTable;
							local h = 1;
							for tss, iconstring in pairs(ideostringTab) do
								for hv = 1, posdata[tss] do
									if h < 5 then
										controlTable["IdeoFont" .. h]:SetText(iconstring)
										h = h + 1;
									end
								end
							end
						end
					end
				end
			end
		end
	end
end

function SocialDevSelected(void1)
	LuaEvents.ITGSG_HumanChooseCultureBonus(Game.GetActivePlayer(), void1)
	Events.AudioPlay2DSound("AS2D_INTERFACE_POLICY");	
	UpdateCulture()
end

local GetNameScenarioType = {"Colonial Era", "Medieval Age", "Classical Era"}
local ScenarioCultOrder = {3, 2, 1}
local mIbaseXoffset = 690;
local mIbaseYoffset = 24;
local mIoffsetXper = 100;
function SetMIHasOffsets(a, b, c)
	mIbaseXoffset = a;
	mIbaseYoffset = b;
	mIoffsetXper = c;
end
			
local mIYoffset = 200;
local mIXper = 120;
local mIXoffset = 100;
function SetMIOffset(a, b, c)
	mIYoffset = a;
	mIXper = b;
	mIXoffset = c;
end

function MeetTheRequirementsCultureBonus(iPlayer, id, scenario)
	local pTeam = Teams[Players[iPlayer]:GetTeam()];
	for i, techID in pairs(cTab[id].Technologies or {}) do
		if not pTeam:IsHasTech(techID) then
			return false;
		end
	end
	if cTab[id].Scenario ~= scenario then
		return false;
	end
	return true;
end

function UpdateCulture()
	Controls.FreePoliciesLabel:SetText("")
	Controls.FreePoliciesLabel:SetHide(false)
	InitHighlights()
	g_PolicyIcons:ResetInstances();
	g_hasPolicyIcons:ResetInstances();
	g_MiniIdeologyIcons:ResetInstances();
	g_HasMiniIdeologyIcons:ResetInstances(); 
	LuaEvents.ITGSG_RequestGT();
	local gData = MapModData.ITGSG;
	MapModData.ITGSG = nil;
	if not gData then
		return
	end
	local iPlayer = Game.GetActivePlayer();
	if not gData.Players[iPlayer] then
		return;
	end
	local isChoosing = false;
	if gData.Players[iPlayer].CultureBonusQueue[1] then
		isChoosing = true;
		local lType = 1;
		for a, b in pairs(gData.Players[iPlayer].CultureBonusQueue) do
			if b == 2 then
				lType = 2;
				break;
			end
		end
		if lType == 1 then
			Controls.FreePoliciesLabel:SetText("Your entire cultural group is now developing new social bonus! The strongest culture enforces its will.")
		elseif lType == 2 then
			Controls.FreePoliciesLabel:SetText("You are now choosing the next social development, which you are not gonna be able to replace in future.")
		end
	end
	Controls.PlayerTitleLabel:SetHide(isChoosing)
	Controls.PlayerTitleLabel:SetText("Available Social Developments");
	local scType = gData.Globals.ScenarioType;
	local count = 0;
	local row = 0;
	local bShowCulturePerks = true;
	
	if not MapModData.DBScenario.IdeologyOn then
		if gData.Players[iPlayer].IsPickingIdeology then
			bShowCulturePerks = false;
		end
	end
	if not bShowCulturePerks then
		Controls.FreePoliciesLabel:SetText("You are now choosing Ideological Tenet.")
		local hc = 0;
		for i, data in pairs(MinitideologyTab) do
			if data.Scenario == gData.Globals.ScenarioType then
				controlTable = g_MiniIdeologyIcons:GetInstance();
				controlTable.IdeoFont1:SetText(ideostringTab[data.Ideology])
				controlTable.IdeologyIcon:SetOffsetVal(mIXoffset + (hc) * mIXper, mIYoffset)
				local tPlayer;
				if gData.AvailableIdeologies[i] then
					controlTable.IdeologyIcon:SetDisabled(false)
					controlTable.IdeologyImage:SetHide(true)
					controlTable.BoxImageID:SetHide(true)
					controlTable.IdeologyIcon:SetVoid1( i );
					controlTable.IdeologyIcon:RegisterCallback( Mouse.eLClick, MiniIdeologyTenetSelected );
				else
					for h, v in pairs(gData.Players) do
						if v.HasMinorIdeology[i] then
							tPlayer = h;
							break;
						end
					end
					controlTable.BoxImageID:SetHide(false)
					controlTable.IdeologyIcon:SetDisabled(true)
					controlTable.IdeologyImage:SetHide(false)
					CivIconHookup( GetPlayerNiceIndexForIcon(tPlayer), 32, controlTable.Icon, controlTable.CivIconBG, controlTable.CivIconShadow, false, true);  
					controlTable.IdeologyImage:SetTexture("IdeologyITGSingleTakenByOtherCiv.dds")
				end
				controlTable.IdeologyIcon:SetToolTipString(GetToolTipIdeologyMini(i, tPlayer))
				hc = hc + 1;
			end
		end
	else
		for i, data in pairs(cTab) do
			if data.Scenario == scType then
				if (not gData.LimitSocials) or (gData.LimitSocials[i]) then
					controlTable = g_PolicyIcons:GetInstance();

					controlTable.PolicyIcon:SetOffsetVal(iBasePoffX + sx + count * xdis, iBasePoffY + sy + row * ydis);

					controlTable.PolicyIcon:SetVoid1( i );
					controlTable.PolicyIcon:RegisterCallback( Mouse.eLClick, SocialDevSelected );
					controlTable.PolicyIcon:SetToolTipString("[COLOR_POSITIVE_TEXT]" .. data.Name .. "[ENDCOLOR][NEWLINE][NEWLINE]" .. data.Help);

					if gData.Players[iPlayer].CultBonusOn[i] then
						IconHookup( data.PortIndex, 64, data.IconAtlasC, controlTable.PolicyImage );
						controlTable.PolicyIcon:SetDisabled(true);
						controlTable.MouseOverContainer:SetHide( true )
						controlTable.PolicyImage:SetColor( fullColor )
						controlTable.PolicyIcon:SetAlpha(GetAlphaBasedOnCheckboxes(i))
					else
						controlTable.PolicyImage:SetColor( fadeColorRV )
						controlTable.MouseOverContainer:SetHide( false )
						controlTable.PolicyIcon:SetDisabled((not isChoosing) or (not MeetTheRequirementsCultureBonus(iPlayer, i, gData.Globals.ScenarioType)))
						IconHookup( data.PortIndex, 64, data.IconAtlas, controlTable.PolicyImage );
						controlTable.PolicyIcon:SetAlpha(GetAlphaBasedOnCheckboxes(i))
					end
					count = count + 1;
					if count == perrow then
						row = row + 1;
						count = 0;
					end
				end
			end
		end
	end
	local count = 0;
	local row = 0;
	local beforeTrollol = 0;
	local cultByEras = {}
	for i, sth in pairs(gData.Players[iPlayer].CultBonusOn) do
		local data = cTab[i];
		if data.Scenario ~= gData.Globals.ScenarioType then
			beforeTrollol = beforeTrollol + 1;
		end
		if not cultByEras[data.Scenario] then
			cultByEras[data.Scenario] = {}
		end
		table.insert(cultByEras[data.Scenario], i)
	end
	local bmcm = 0.5;
	beforeTrollol = beforeTrollol + #gData.Players[iPlayer].GoneCultureDevs
	if beforeTrollol > 0 then
		bmcm = 0.8 / beforeTrollol
	end
	rsydis = 0;
	--mini ideologies have
	for h, v in pairs(gData.Players[iPlayer].HasMinorIdeology) do
		local controlTable = g_HasMiniIdeologyIcons:GetInstance();
		controlTable.BoxImageID:SetHide(false)
		controlTable.IdeologyIcon:SetDisabled(true)
		controlTable.IdeologyImage:SetHide(false)
		controlTable.IdeologyImage:SetTexture("IdeologyITGSingleTaken.dds")
		CivIconHookup( iPlayer, 32, controlTable.Icon, controlTable.CivIconBG, controlTable.CivIconShadow, false, true);  
		controlTable.IdeologyIcon:SetToolTipString(GetToolTipIdeologyMini(h, iPlayer))
		controlTable.IdeologyIcon:SetOffsetVal(mIbaseXoffset + (3 - v) * mIoffsetXper, mIbaseYoffset)
		controlTable.IdeoFont1:SetText(ideostringTab[MinitideologyTab[h].Ideology])
	end
	--
	for jid, sct in pairs(ScenarioCultOrder) do
		for i, policyID in pairs(gData.Players[iPlayer].GoneCultureDevs) do
			if cTab[policyID].Scenario == sct then
				controlTable = g_hasPolicyIcons:GetInstance();
				controlTable.PolicyIcon:SetOffsetVal(rsydis + sx + math.floor(count/2) * (xdis + 20), -6 + sy + row * 60);
				if rsydis == 0 then
					rsydis = sydis;
					row = 1;
				else
					rsydis = 0;
					row = 0;
				end
				local sText = "[COLOR_POSITIVE_TEXT]" .. cTab[policyID].Name .. "[ENDCOLOR][NEWLINE][NEWLINE]" .. cTab[policyID].Help .. "[NEWLINE][NEWLINE]";
				sText = sText .. "[COLOR_GREY]" .. GetNameScenarioType[sct] .. "[ENDCOLOR]";
				sText = sText .. "[NEWLINE][NEWLINE]This development is forgotten."
				controlTable.PolicyIcon:SetAlpha(math.max(0.20, 1.0 - bmcm * beforeTrollol));
				beforeTrollol = beforeTrollol - 1;
				controlTable.PolicyIcon:SetToolTipString(sText);
				
				IconHookup( cTab[policyID].PortIndex, 64, cTab[policyID].IconAtlasC, controlTable.PolicyImage );
				controlTable.PolicyIcon:SetDisabled(true);
				controlTable.MouseOverContainer:SetHide( true )
				controlTable.PolicyImage:SetColor( fadeColorRV )

				count = count + 1;
			end
		end
		for jkk, cultID in pairs(cultByEras[sct] or {}) do
			local data = cTab[cultID];
			controlTable = g_hasPolicyIcons:GetInstance();
			controlTable.PolicyIcon:SetOffsetVal(rsydis + sx + math.floor(count/2) * (xdis + 20), -6 + sy + row * 60);
			if rsydis == 0 then
				rsydis = sydis;
				row = 1;
			else
				rsydis = 0;
				row = 0;
			end
			local sText = "[COLOR_POSITIVE_TEXT]" .. data.Name .. "[ENDCOLOR][NEWLINE][NEWLINE]" .. data.Help .. "[NEWLINE][NEWLINE]";
			sText = sText .. "[COLOR_GREY]" .. GetNameScenarioType[data.Scenario] .. "[ENDCOLOR]";
			if gData.Players[iPlayer].CultBonusOn[cultID].Type == 1 and gData.Globals.ScenarioType == data.Scenario then
				sText = sText .. "[NEWLINE][NEWLINE]Can be replaced."
			end
			if data.Scenario == gData.Globals.ScenarioType then
				controlTable.PolicyIcon:SetAlpha(1.0);
			else
				controlTable.PolicyIcon:SetAlpha(math.max(0.20, 1.0 - bmcm * beforeTrollol));
				beforeTrollol = beforeTrollol - 1;
			end
			controlTable.PolicyIcon:SetToolTipString(sText);
			IconHookup( data.PortIndex, 64, data.IconAtlasC, controlTable.PolicyImage );
			controlTable.PolicyIcon:SetDisabled(true);
			controlTable.MouseOverContainer:SetHide( true )
			controlTable.PolicyImage:SetColor( fullColor )

			count = count + 1;
	--		if count == perrow then
	--			row = row + 1;
	--			count = 0;
	--		end
		end
	end
	Controls.NoSocialDevLabel:SetHide(count + row ~= 0);
	
	local bScenarioHasCultDevs = (not MapModData.DBScenario.CultDevelopOff)
	--cultural group info
	Controls.CultureGroupTab:SetHide(not bScenarioHasCultDevs);
	if bScenarioHasCultDevs then
		LuaEvents.ITGSG_RequestDemographicsCulturalGroup(iPlayer)
		local cgTab = MapModData.ITGSG
		MapModData.ITGSG = nil
		g_PlayersCG:ResetInstances();
		for hjh, hjhdata in pairs(cgTab) do
			local itemInstance = g_PlayersCG:GetInstance();
			CivIconHookup( hjhdata[1], 32, itemInstance.Icon, itemInstance.CivIconBG, itemInstance.CivIconShadow, false, true);
			itemInstance.InfoLabel:SetText(hjhdata[2] .. "[ICON_ITG_NAT_UNITY]");
		end
		Controls.CulturalGroupTabStack:CalculateSize();
		Controls.CulturalGroupTabStack:ReprocessAnchoring();
		Controls.CultureGroupTab:SetSizeY(90 + Controls.CulturalGroupTabStack:GetSizeY())
		Controls.CultureGroupTabBg:SetSizeY(Controls.CultureGroupTab:GetSizeY())
	end
end

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function OnClose()
    UIManager:DequeuePopup( ContextPtr );
end
Controls.CloseButton:RegisterCallback( Mouse.eLClick, OnClose );
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function InputHandler( uiMsg, wParam, lParam )
    ----------------------------------------------------------------        
    -- Key Down Processing
    ----------------------------------------------------------------        
    if uiMsg == KeyEvents.KeyDown then
        if (wParam == Keys.VK_RETURN or wParam == Keys.VK_ESCAPE) then
			if(Controls.PolicyConfirm:IsHidden() and Controls.TenetConfirm:IsHidden() and Controls.ChooseTenet:IsHidden() and Controls.ChangeIdeologyConfirm:IsHidden())then
	            OnClose();
	        else
				if(Controls.TenetConfirm:IsHidden()) then
					Controls.ChooseTenet:SetHide(true);
					Controls.PolicyConfirm:SetHide(true);
					Controls.BGBlock:SetHide(false);
				
				else
					Controls.TenetConfirm:SetHide(true);
				end
			end
			return true;
        end
    end
end
ContextPtr:SetInputHandler( InputHandler );

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------

function OnYes( )
	Controls.PolicyConfirm:SetHide(true);
	Controls.BGBlock:SetHide(false);
	
	Events.AudioPlay2DSound("AS2D_INTERFACE_POLICY");		
end
Controls.Yes:RegisterCallback( Mouse.eLClick, OnYes );

function OnNo( )
	Controls.PolicyConfirm:SetHide(true);
	Controls.BGBlock:SetHide(false);
end
Controls.No:RegisterCallback( Mouse.eLClick, OnNo );

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function ShowHideHandler( bIsHide, bInitState )
    if( not bInitState ) then
        if( not bIsHide ) then
        	UI.incTurnTimerSemaphore();
        	Events.SerialEventGameMessagePopupShown(m_PopupInfo);
        else
            UI.decTurnTimerSemaphore();
            Events.SerialEventGameMessagePopupProcessed.CallImmediate(ButtonPopupTypes.BUTTONPOPUP_CHOOSEPOLICY, 0);
        end
    end
end
ContextPtr:SetShowHideHandler( ShowHideHandler );

function OnShowSimplifiedView( bIsChecked )
	bSimplifiedView = bIsChecked;
	UpdateIdeology()
end
Controls.SimplifiedViewCB:RegisterCheckHandler( OnShowSimplifiedView );

----------------------------------------------------------------
-- 'Active' (local human) player has changed
----------------------------------------------------------------
function OnActivePlayerChanged()
	if (not Controls.PolicyConfirm:IsHidden() or not Controls.TenetConfirm:IsHidden() or not Controls.ChangeIdeologyConfirm:IsHidden()) then
		Controls.TenetConfirm:SetHide(true);
		Controls.ChangeIdeologyConfirm:SetHide(true);
		Controls.PolicyConfirm:SetHide(true);
    	Controls.BGBlock:SetHide(false);
	end
	OnClose();
end
Events.GameplaySetActivePlayer.Add(OnActivePlayerChanged);
-- Register tabbing behavior and assign global TabSelect routine.
TabSelect = RegisterTabBehavior(g_Tabs, g_Tabs["SocialPolicies"]);