-------------------------------------------------
-- Include file that has handy stuff for the tech tree and other screens that need to show a tech button
-------------------------------------------------
include( "IconSupport" );
include( "InfoTooltipInclude" );

-- List the textures that we will need here
local defaultErrorTextureSheet;
local ExtraUnitsByTech = {}
local ExtraResSmallButtons = {}
local ExtraCultureSmallButtons = {}
local ExtraBuildingsByTech = {}
local ExtraBuildsByTech = {}
local cgScenario;
local cgCultureType;
local cgSubcultureType;

local extraUnlockData = {
Gold = {{"ITG_SMALL_TECH_BUTTONS_ATLAS", 2, "TXT_KEY_ITG_UNLOCK_UNIT_GOLD"}, {"ITG_SMALL_TECH_BUTTONS_ATLAS", 0, "TXT_KEY_ITG_UNLOCK_BUILDING_GOLD"}},
Military = {{"ITG_SMALL_TECH_BUTTONS_ATLAS", 3, "TXT_KEY_ITG_UNLOCK_UNIT_MILITARY"}, {"ITG_SMALL_TECH_BUTTONS_ATLAS", 1, "TXT_KEY_ITG_UNLOCK_BUILDING_MILITARY"}},
Religious = {{"ITG_SMALL_TECH_BUTTONS_ATLAS", 5, "TXT_KEY_ITG_UNLOCK_UNIT_RELIGIOUS"}, {"ITG_SMALL_TECH_BUTTONS_ATLAS", 4, "TXT_KEY_ITG_UNLOCK_BUILDING_RELIGIOUS"}},
Governor = {{"ITG_SMALL_TECH_BUTTONS_ATLAS", 7, "TXT_KEY_ITG_UNLOCK_UNIT_GOVERNOR"}, {"ITG_SMALL_TECH_BUTTONS_ATLAS", 6, "TXT_KEY_ITG_UNLOCK_BUILDING_GOVERNOR"}},
Inno = {{"ITG_SMALL_TECH_BUTTONS_ATLAS", 9, "TXT_KEY_ITG_UNLOCK_UNIT_INNOVATION"}, {"ITG_SMALL_TECH_BUTTONS_ATLAS", 8, "TXT_KEY_ITG_UNLOCK_BUILDING_INNOVATION"}},
Social = {{"ITG_SMALL_TECH_BUTTONS_ATLAS", 11, "TXT_KEY_ITG_UNLOCK_UNIT_SOCIAL_DEVELOPMENT"}, {"ITG_SMALL_TECH_BUTTONS_ATLAS", 10, "TXT_KEY_ITG_UNLOCK_BUILDING_SOCIAL_DEVELOPMENT"}},
Himeji = {{}, {"ITG_SMALL_TECH_BUTTONS_ATLAS", 12, "TXT_KEY_ITG_UNLOCK_BUILDING_HIMEJI"}},
HHall = {{}, {"ITG_SMALL_TECH_BUTTONS_ATLAS", 13, "TXT_KEY_ITG_UNLOCK_BUILDING_H_HALL"}},
}

local extraButtonsScenario = {
[1] = {["TECH_ARCHITECTURE"] = {"2 free Palace upgrades.", "Art Style grants +1% extra [ICON_GREAT_ARTIST] Art modifier per level."},
["TECH_METALLURGY"] = {"+20% [ICON_STRENGTH] Combat vs Crossbowman, Pikeman, Swordsman, Composite Bowman."},
["TECH_PRINTING_PRESS"] = {"Reduces resource cost for [ICON_ITG_MANUFACTORY] Manufactories by 7."},
},
[2] = {
["TECH_STEEL"] = {"+15% [ICON_STRENGTH] Combat bonus vs Barbarians."},
["TECH_GUILDS"] = {"Customs Houses are upgraded by 3 [ICON_ITG_CUSTOMS_HOUSE] additional points per turn."},
},
[3] = {
["TECH_MATHEMATICS"] = {"Reduces treshold to acquire new special unit by 50 [ICON_ITG_SPECIALIZATION]."},
["TECH_CONSTRUCTION"] = {"+25% [ICON_PRODUCTION] Production towards Buildings."},
["TECH_CALENDAR"] = {"You can choose from an extra belief upon founding new Pantheon."},
["TECH_PHILOSOPHY"] = {"You can choose from an extra belief upon founding new Pantheon."},
["TECH_ANIMAL_HUSBANDRY"] = {"Reveals horses."},
},
[4] = {
["TECH_DYNAMITE"] = {"Amount of [ICON_RES_IRON] Iron, [ICON_RES_COAL] Coal sources is increased by 100%."},
["TECH_RIFLING"] = {"+10% [ICON_STRENGTH] Combat bonus vs Barbarians."},
["TECH_STEAM_POWER"] = {"Reduces resource cost for [ICON_ITG_MANUFACTORY] Manufactories by 20."},
},
[5] = {
["TECH_COMPUTERS"] = {"[ICON_ITG_ACADEMY_1] Prestige growth from Cities' Science doubled in all Academies."},
["TECH_PENICILIN"] = {"Increases Heal Rate of gun Units by 10."},
["TECH_COMBINED_ARMS"] = {"Increases Heal Rate of Submarines, Carriers, Naval melee, Naval Ranged, Bombers, Fighters and Armour units by 5.", "+15% [ICON_PRODUCTION] Production modifier towards mechanical Unitcombat classes (Submarines, Carriers, Naval melee, Naval Ranged, Bombers, Fighters and Armour) the least represented in your army."},
["TECH_NUCLEAR_FISSION"] = {"+200 [ICON_GOLD] Gold toward Nuclear Project if not finished yet."},
["TECH_COMBUSTION"] = {"Trade Units gain +1 [ICON_MOVES] Movement."},
["TECH_PLASTIC"] = {"Reduces [ICON_WORKER] Work Rate cost of repairing Improvements by half."},
["TECH_ECOLOGY"] = {"[ICON_RES_FISH] Fishes within your City's radius do not migrate away.", "Gain extra [ICON_INVEST] Currency Power for each Forest and Jungle within your territory."},
["TECH_ROCKETRY"] = {"Provides 2 free Satellites."},
["TECH_RADAR"] = {"Enemy bombardment becomes less likely to destroy Building or Population.", "25% chance for +200% Defense Bonus against Submarines."},
},

}
local CultureGroupsExSmButtons = {
	[2] = {
		["TECH_NAVIGATION"] = {"+3 [ICON_FOOD] Food from Fishing."},
		},
	[203] = {
		["TECH_NAVIGATION"] = {"+3 [ICON_FOOD] Food from Fishing.", "-25 [ICON_CARGO] Naval Trade Route treshold."},
		["TECH_PRINTING_PRESS"] = {"Grants an Innovation upon discovery (if possible)."},
		},
	[114] = {
		["TECH_BANKING"] = {"Allows to [ICON_OCCUPIED] occupy one more City."},
		["TECH_NAVIGATION"] = {"Allows you to make usage of currents, which reduces movement cost while unit is moving in proper direction."},
		},
	[9] = {
		["TECH_CURRENCY"] = {"Allows to [ICON_OCCUPIED] occupy one more City."},
		["TECH_CONSTRUCTION"] = {"Allows to [ICON_OCCUPIED] occupy one more City."},
		["TECH_BRONZE_WORKING"] = {"Reduces treshold to acquire new special unit by 80 [ICON_ITG_SPECIALIZATION]."},
	}
}

local PremadeExtraBuildsByTech = {
[1] = {["TECH_NAVIGATION"] = {GameInfoTypes.BUILD_POLDER}},
[2] = {["TECH_UNIQUE_ITG_NEW_WORLD_MESOAMERICAN_1"] = {GameInfoTypes.BUILD_TERRACE_FARM}},
[10] = {["TECH_UNIQUE_ITG_INDUSTRIAL_11"] = {GameInfoTypes.BUILD_WELL, GameInfoTypes.BUILD_OFFSHORE_PLATFORM},
["TECH_BIOLOGY"] = {GameInfoTypes.BUILD_POLDER},
},
}
local PreResSmallButtonsSubC = {
[201] = {}, --just to remove horse icon
[203] = {}, --just to remove horse icon
}
local PremadeResourceSmallButtons = {
[2] = {["TECH_CHIVALRY"] = {GameInfoTypes.RESOURCE_HORSE}},
[6] = {["TECH_ANIMAL_HUSBANDRY"] = {GameInfoTypes.RESOURCE_HORSE}},
[7] = {["TECH_ANIMAL_HUSBANDRY"] = {GameInfoTypes.RESOURCE_HORSE}},
[8] = {["TECH_ANIMAL_HUSBANDRY"] = {GameInfoTypes.RESOURCE_HORSE}},
[9] = {["TECH_ANIMAL_HUSBANDRY"] = {GameInfoTypes.RESOURCE_HORSE}},
[10] = {["TECH_UNIQUE_ITG_INDUSTRIAL_11"] = {GameInfoTypes.RESOURCE_OIL}}
}
local PremadeExtraUnitButtons = 
{
[6] =
{
["TECH_UNIQUE_ITG_TRIAL_PAGAN_7"] = {GameInfoTypes.UNIT_ITG_SIEGE_CATAPULT, GameInfoTypes.UNIT_ITG_SIEGE_TOWER_SUPPORT, GameInfoTypes.UNIT_ITG_NW_GALLEASS}
},
[604] =
{
["TECH_UNIQUE_ITG_TRIAL_HORDE_5"] = {GameInfoTypes.UNIT_ITG_NW_GALLEASS, GameInfoTypes.UNIT_ITG_NW_TRIREME},
["TECH_UNIQUE_ITG_TRIAL_HORDE_6"] = {GameInfoTypes.UNIT_ITG_TRIAL_SIEGE_TREBUCHET},
},
[7] = { --legion, ballista
["TECH_UNIQUE_ITG_ANCIENT_EMPIRE_1"] = {GameInfoTypes.UNIT_ITG_AOT_SWORDSMAN_ROMAN},
["TECH_UNIQUE_ITG_ANCIENT_EMPIRE_2"] = {GameInfoTypes.UNIT_ITG_ANCIENT_BALLISTA},
},
[802] = {
["TECH_UNIQUE_ITG_ANCIENT_CSTATE_15"] = {GameInfoTypes.UNIT_WORKBOAT},
}
}
local PremadeExtraBuildingsButtons = 
{
[2] = {
["TECH_CHIVALRY"] = {GameInfoTypes.BUILDING_ITG_NW_ONLY_STABLE},
},
[6] =
{
["TECH_UNIQUE_ITG_TRIAL_PAGAN_1"] = {GameInfoTypes.BUILDING_ITG_NEW_WORLD_CATHEDRAL},
["TECH_UNIQUE_ITG_TRIAL_PAGAN_3"] = {GameInfoTypes.BUILDING_LIBRARY, GameInfoTypes.BUILDING_ITG_CASTLE, GameInfoTypes.BUILDING_ITG_UNIVERSITY}
},
[604] = {
["TECH_UNIQUE_ITG_TRIAL_HORDE_2"] = {GameInfoTypes.BUILDING_ITG_NEW_WORLD_WALLS, GameInfoTypes.BUILDING_ITG_CASTLE, GameInfoTypes.BUILDING_ITG_NEW_BARRACKS, GameInfoTypes.BUILDING_ITG_ARMORY},
["TECH_UNIQUE_ITG_TRIAL_HORDE_3"] = {GameInfoTypes.BUILDING_ITG_MINT},
["TECH_CONSTRUCTION"] = {GameInfoTypes.BUILDING_ITG_WORKSHOP},
["TECH_UNIQUE_ITG_TRIAL_HORDE_5"] = {GameInfoTypes.BUILDING_ITG_LIGHTHOUSE, GameInfoTypes.BUILDING_ITG_HARBOR},
},
[7] = {
["TECH_UNIQUE_ITG_ANCIENT_EMPIRE_17"] = {GameInfoTypes.BUILDING_ITG_COLOSSEUM}
},
[808] = {
["TECH_UNIQUE_ITG_ANCIENT_CSTATE_23"] = {GameInfoTypes.BUILDING_ITG_MINT_ANCIENT}
}
}

techPediaSearchStrings = {};

if g_UseSmallIcons then
	defaultErrorTextureSheet = "UnitActions360.dds";
else
	defaultErrorTextureSheet = "UnitActions.dds";
end

local validUnitBuilds = nil;
local validBuildingBuilds = nil;
local validImprovementBuilds = nil;

turnsString = Locale.ConvertTextKey("TXT_KEY_TURNS");
freeString = Locale.ConvertTextKey("TXT_KEY_FREE");
lockedString = "[ICON_LOCKED]"; --Locale.ConvertTextKey("TXT_KEY_LOCKED");

function GetTechPedia( void1, void2, button )
	local searchString = techPediaSearchStrings[tostring(button)];
	Events.SearchForPediaEntry( searchString );		
end

function GatherInfoAboutUniqueStuff( civType, player )
	LuaEvents.ITGSG_RequestGT();
	local gData = MapModData.ITGSG;
	MapModData.ITGSG = nil;
	if gData and player and (gData.Players[player]) then
		local csID = gData.Players[player].CultureType;
		cgScenario = gData.Globals.ScenarioType
		cgCultureType = gData.Players[player].CultureType
		cgSubcultureType = gData.Players[player].SubcultureType
		if gData.Players[player].SubcultureType then
			csID = (gData.Players[player].SubcultureType or 0) + 100 * gData.Players[player].CultureType;
		end
		local gtID = gData.Players[player].CultureType
		ExtraResSmallButtons = {}
		if PreResSmallButtonsSubC[csID] then
			ExtraResSmallButtons = PreResSmallButtonsSubC[csID];
		elseif PremadeResourceSmallButtons[gtID] then
			ExtraResSmallButtons = PremadeResourceSmallButtons[gtID];
		end
		ExtraCultureSmallButtons = {}
		if CultureGroupsExSmButtons[csID] then
			ExtraCultureSmallButtons = CultureGroupsExSmButtons[csID];
		elseif CultureGroupsExSmButtons[gtID] then
			ExtraCultureSmallButtons = CultureGroupsExSmButtons[gtID];
		end
		ExtraUnitsByTech = {}
		if PremadeExtraUnitButtons[csID] then
			ExtraUnitsByTech = PremadeExtraUnitButtons[csID];
		end
		ExtraBuildingsByTech = {}
		if PremadeExtraBuildingsButtons[csID] then
			ExtraBuildingsByTech = PremadeExtraBuildingsButtons[csID];
		elseif PremadeExtraBuildingsButtons[gtID] then
			ExtraBuildingsByTech = PremadeExtraBuildingsButtons[gtID];
		end
		ExtraBuildsByTech = {}
		if PremadeExtraBuildsByTech[gtID] then
			ExtraBuildsByTech = PremadeExtraBuildsByTech[gtID];
		end
	end
		

	validUnitBuilds = {};
	validBuildingBuilds = {};
	validImprovementBuilds = {};

	-- put in the default units for any civ
	for thisUnitClass in GameInfo.UnitClasses() do
		validUnitBuilds[thisUnitClass.Type]	= thisUnitClass.DefaultUnit;	
	end

	-- put in my overrides
	if player then
		for thisUnitClass in GameInfo.UnitClasses() do
			local type = Players[player]:GetPlayerUniqueUnit(thisUnitClass.ID);
			if type == -1 then
				validUnitBuilds[thisUnitClass.Type]	= -1;
			else
				validUnitBuilds[thisUnitClass.Type]	= GameInfo.Units[type].Type;
			end
		end
	else
		for thisOverride in GameInfo.Civilization_UnitClassOverrides() do
 			if thisOverride.CivilizationType == civType then
				validUnitBuilds[thisOverride.UnitClassType]	= thisOverride.UnitType;
 			end
		end
	end

	-- put in the default buildings for any civ
	for thisBuildingClass in GameInfo.BuildingClasses() do
		validBuildingBuilds[thisBuildingClass.Type]	= thisBuildingClass.DefaultBuilding;	
	end

	-- put in my overrides
	if player then
		for thisBuildingClass in GameInfo.BuildingClasses() do
			local type = Players[player]:GetPlayerUniqueBuilding(thisBuildingClass.ID);
			if type == -1 then
				validBuildingBuilds[thisBuildingClass.Type]	= -1;
			else
				validBuildingBuilds[thisBuildingClass.Type]	= GameInfo.Buildings[type].Type;
			end
		end
	else
		for thisOverride in GameInfo.Civilization_BuildingClassOverrides() do
 			if thisOverride.CivilizationType == civType then
				validBuildingBuilds[thisOverride.BuildingClassType]	= thisOverride.BuildingType;	
 			end
		end
	end
	
	-- add in support for unique improvements
	for thisImprovement in GameInfo.Improvements() do
		if thisImprovement.CivilizationType == civType or thisImprovement.CivilizationType == nil then
			validImprovementBuilds[thisImprovement.Type] = thisImprovement.Type;	
		else
			validImprovementBuilds[thisImprovement.Type] = nil;	
		end
	end
end

function TBI_GenericButton(thisTechButtonInstance, textureSize, buttonNum, v, portIndex, iconAtlas)
	local buttonName = "B"..tostring(buttonNum);
	local thisButton = thisTechButtonInstance[buttonName];
	if(thisButton ~= nil) then
		IconHookup( portIndex or 0, textureSize, iconAtlas or "GENERIC_FUNC_ATLAS", thisButton );
		thisButton:SetHide( false );
		thisButton:SetToolTipString(v);
		buttonNum = buttonNum + 1;
	end
	return buttonNum;
end

function HandleExtraITGUnlockButton(unlockType, iUnitBuilding, desc, thisButton, textureSize)
	IconHookup( extraUnlockData[unlockType][iUnitBuilding][2], textureSize, extraUnlockData[unlockType][iUnitBuilding][1], thisButton );
	thisButton:SetToolTipString(Locale.ConvertTextKey( extraUnlockData[unlockType][iUnitBuilding][3], Locale.Lookup(desc)));
	thisButton:SetHide( false );
end

function AddSmallButtonsToTechButton( thisTechButtonInstance, tech, maxSmallButtons, textureSize )
	-- This has a few assumptions, the main one being that the small buttons are named "B1", "B2", "B3"... and that GatherInfoAboutUniqueStuff() has been called before this

	-- first, hide the ones we aren't using
	for buttonNum = 1, maxSmallButtons, 1 do
		local buttonName = "B"..tostring(buttonNum);
		thisTechButtonInstance[buttonName]:SetHide(true);
	end
	
	if tech == nil then
		return;
	end

	local buttonNum = 1;

	local techType = tech.Type;

	LuaEvents.ITG_RequestTechSmallButtonsData(Game.GetActivePlayer(), tech.ID)
	local extraITGData = MapModData.ITGSG
	MapModData.ITGSG = nil;
	
	local extraTechInfo;
	if cgScenario then 
		LuaEvents.ITG_TechButtonMoreInfo(tech.ID, cgScenario, cgCultureType, cgSubcultureType)
		extraTechInfo = MapModData.ITGSG;
		MapModData.ITGSG = nil;
	end

	-- add the stuff granted by this tech here
  	for thisUnitInfo in GameInfo.Units(string.format("PreReqTech = '%s'", techType)) do
 		-- if this tech grants this player the ability to make this unit
		if validUnitBuilds[thisUnitInfo.Class] == thisUnitInfo.Type then
			local buttonName = "B"..tostring(buttonNum);
			local thisButton = thisTechButtonInstance[buttonName];
			if thisButton then
				if extraITGData and extraITGData.Units[thisUnitInfo.ID] then
					HandleExtraITGUnlockButton(extraITGData.Units[thisUnitInfo.ID], 1, thisUnitInfo.Description, thisButton, textureSize)
				else 
					AdjustArtOnGrantedUnitButton( thisButton, thisUnitInfo, textureSize );
				end
				buttonNum = buttonNum + 1;
			end
		end
 	end
	if ExtraUnitsByTech[techType] then
		for i, unit in pairs(ExtraUnitsByTech[techType]) do
			local buttonName = "B"..tostring(buttonNum);
			local thisButton = thisTechButtonInstance[buttonName];
			if thisButton then
				if extraITGData and extraITGData.Units[unit] then
					HandleExtraITGUnlockButton(extraITGData.Units[unit], 1, GameInfo.Units[unit].Description, thisButton, textureSize)
				else 
					AdjustArtOnGrantedUnitButton( thisButton, GameInfo.Units[unit], textureSize );
				end
				buttonNum = buttonNum + 1;
			end
		end
	end
 	for thisBuildingInfo in GameInfo.Buildings(string.format("PreReqTech = '%s'", techType)) do
 		-- if this tech grants this player the ability to construct this building
		if validBuildingBuilds[thisBuildingInfo.BuildingClass] == thisBuildingInfo.Type then
			local buttonName = "B"..tostring(buttonNum);
			local thisButton = thisTechButtonInstance[buttonName];
			if thisButton then
				if extraITGData and extraITGData.Buildings[thisBuildingInfo.ID] then
					HandleExtraITGUnlockButton(extraITGData.Buildings[thisBuildingInfo.ID], 2, thisBuildingInfo.Description, thisButton, textureSize)
				else 
					AdjustArtOnGrantedBuildingButton( thisButton, thisBuildingInfo, textureSize );
				end
				buttonNum = buttonNum + 1;
			end
		end
 	end
	if ExtraBuildingsByTech[techType] then
		for i, building in pairs(ExtraBuildingsByTech[techType]) do
			local buttonName = "B"..tostring(buttonNum);
			local thisButton = thisTechButtonInstance[buttonName];
			if thisButton then
				if extraITGData and extraITGData.Buildings[building] then
					HandleExtraITGUnlockButton(extraITGData.Buildings[building], 2, GameInfo.Buildings[building].Description, thisButton, textureSize)
				else 
					AdjustArtOnGrantedBuildingButton( thisButton, GameInfo.Buildings[building], textureSize );
				end
				buttonNum = buttonNum + 1;
			end
		end
	end
	if ExtraBuildsByTech[techType] then
		for i, build in pairs(ExtraBuildsByTech[techType]) do
			local buttonName = "B"..tostring(buttonNum);
			local thisButton = thisTechButtonInstance[buttonName];
			if thisButton then
				AdjustArtOnGrantedActionButton( thisButton, GameInfo.Builds[build], textureSize );
 				buttonNum = buttonNum + 1;
 			end
		end
	end

 	for thisResourceInfo in GameInfo.Resources(string.format("TechReveal = '%s'", techType)) do
 		-- if this tech grants this player the ability to reveal this resource
		local buttonName = "B"..tostring(buttonNum);
		local thisButton = thisTechButtonInstance[buttonName];
		if thisButton then
			AdjustArtOnGrantedResourceButton( thisButton, thisResourceInfo, textureSize );
			buttonNum = buttonNum + 1;
		end
 	end
 
 	for thisProjectInfo in GameInfo.Projects(string.format("TechPrereq = '%s'", techType)) do
 		-- if this tech grants this player the ability to build this project
		local buttonName = "B"..tostring(buttonNum);
		local thisButton = thisTechButtonInstance[buttonName];
 		if thisButton then
			AdjustArtOnGrantedProjectButton( thisButton, thisProjectInfo, textureSize );
 			buttonNum = buttonNum + 1;
 		end
	end
	if extraTechInfo then
		for i, v in pairs(extraTechInfo[2]) do
			buttonNum = TBI_GenericButton(thisTechButtonInstance, textureSize, buttonNum, v[1], v[3], v[2])
		end
	end

	-- if this tech grants this player the ability to perform this action (usually only workers can do these)
	for thisBuildInfo in GameInfo.Builds(string.format("PrereqTech = '%s'", techType)) do
		if thisBuildInfo.ImprovementType then
			if validImprovementBuilds[thisBuildInfo.ImprovementType] == thisBuildInfo.ImprovementType then
				local buttonName = "B"..tostring(buttonNum);
				local thisButton = thisTechButtonInstance[buttonName];
				if thisButton then
					AdjustArtOnGrantedActionButton( thisButton, thisBuildInfo, textureSize );
 					buttonNum = buttonNum + 1;
 				end
 			end
		else
			local buttonName = "B"..tostring(buttonNum);
			local thisButton = thisTechButtonInstance[buttonName];
			if thisButton then
				AdjustArtOnGrantedActionButton( thisButton, thisBuildInfo, textureSize );
 				buttonNum = buttonNum + 1;
 			end
		end
	end
	
	-- show processes
	local processCondition = "TechPrereq = '" .. techType .. "'";
	for row in GameInfo.Processes(processCondition) do
		local buttonName = "B"..tostring(buttonNum);
		local thisButton = thisTechButtonInstance[buttonName];
		if thisButton then
			IconHookup( row.PortraitIndex, textureSize, row.IconAtlas, thisButton );
			thisButton:SetHide( false );
			local strPText = Locale.ConvertTextKey( row.Description );
			thisButton:SetToolTipString( Locale.ConvertTextKey( "TXT_KEY_ENABLE_PRODUCITON_CONVERSION", strPText) );
		end
		buttonNum = buttonNum + 1;
	end

	--HERE THE DUMMY BUTTONS
	if cgScenario then
		for i, v in pairs(extraButtonsScenario[cgScenario][techType] or {}) do
			buttonNum = TBI_GenericButton(thisTechButtonInstance, textureSize, buttonNum, v)
		end
		if extraTechInfo then
			for i, v in pairs(extraTechInfo[1]) do
				buttonNum = TBI_GenericButton(thisTechButtonInstance, textureSize, buttonNum, v)
			end
		end
	end

	for i = 1, 10 do
		local hText = "TXT_KEY_TBT_" .. techType .. "_" .. i;
		local lText = Locale.Lookup(hText)
		if hText == lText then
			break;
		else
			buttonNum = TBI_GenericButton(thisTechButtonInstance, textureSize, buttonNum, lText)
		end
	end

	
 	if ExtraResSmallButtons[techType] then
		for i, res in pairs(ExtraResSmallButtons[techType]) do
			local buttonName = "B"..tostring(buttonNum);
			local thisButton = thisTechButtonInstance[buttonName];
			if thisButton then
				AdjustArtOnGrantedResourceButton( thisButton, GameInfo.Resources[res], textureSize )
				buttonNum = buttonNum + 1;
			end
		end
	end
	for i, v in pairs(ExtraCultureSmallButtons[techType] or {}) do
		buttonNum = TBI_GenericButton(thisTechButtonInstance, textureSize, buttonNum, v)
	end

		
 	-- todo: need to add abilities, etc.
	local condition = "TechType = '" .. techType .. "'";
		
	for row in GameInfo.Route_TechMovementChanges(condition) do
		buttonNum = TBI_GenericButton(thisTechButtonInstance, textureSize, buttonNum, Locale.ConvertTextKey("TXT_KEY_FASTER_MOVEMENT", GameInfo.Routes[row.RouteType].Description ) )
	end	
	
	local ITG_text_OneButtonForYieldChanges = ""

	local yieldChanges = {};
	for row in GameInfo.Improvement_TechYieldChanges(condition) do
		local improvementType = row.ImprovementType;	
		local improvement = GameInfo.Improvements[row.ImprovementType];
		local yield = GameInfo.Yields[row.YieldType];
		local sTempTxt = Locale.Lookup( "TXT_KEY_YIELD_IMPROVED", improvement.Description , yield.Description, row.Yield);
		if ITG_text_OneButtonForYieldChanges == "" then
			ITG_text_OneButtonForYieldChanges = sTempTxt
		else
			ITG_text_OneButtonForYieldChanges = ITG_text_OneButtonForYieldChanges .. "[NEWLINE][NEWLINE]" .. sTempTxt 
		end
	end
	for row in GameInfo.Improvement_TechNoFreshWaterYieldChanges(condition) do
		local sTempTxt = Locale.ConvertTextKey("TXT_KEY_NO_FRESH_WATER", GameInfo.Improvements[row.ImprovementType].Description , GameInfo.Yields[row.YieldType].Description, row.Yield);
		if ITG_text_OneButtonForYieldChanges == "" then
			ITG_text_OneButtonForYieldChanges = sTempTxt
		else
			ITG_text_OneButtonForYieldChanges = ITG_text_OneButtonForYieldChanges .. "[NEWLINE][NEWLINE]" .. sTempTxt 
		end
	end	
	
	for row in GameInfo.Improvement_TechFreshWaterYieldChanges(condition) do
		local sTempTxt = Locale.ConvertTextKey("TXT_KEY_FRESH_WATER", GameInfo.Improvements[row.ImprovementType].Description , GameInfo.Yields[row.YieldType].Description, row.Yield);
		if ITG_text_OneButtonForYieldChanges == "" then
			ITG_text_OneButtonForYieldChanges = sTempTxt
		else
			ITG_text_OneButtonForYieldChanges = ITG_text_OneButtonForYieldChanges .. "[NEWLINE][NEWLINE]" .. sTempTxt 
		end
	end	
	
	if ITG_text_OneButtonForYieldChanges ~= "" then
		buttonNum = TBI_GenericButton(thisTechButtonInstance, textureSize, buttonNum, ITG_text_OneButtonForYieldChanges )
	end	


	if tech.EmbarkedMoveChange > 0 then
		buttonNum = TBI_GenericButton(thisTechButtonInstance, textureSize, buttonNum, Locale.ConvertTextKey( "TXT_KEY_FASTER_EMBARKED_MOVEMENT" ) )
	end

-- this one is handled differently by ITG	
--	if tech.AllowsEmbarking then
--		buttonNum = TBI_GenericButton(thisTechButtonInstance, textureSize, buttonNum, Locale.ConvertTextKey( "TXT_KEY_ALLOWS_EMBARKING" ) )
--	end
	
	if tech.AllowsDefensiveEmbarking then
		buttonNum = TBI_GenericButton(thisTechButtonInstance, textureSize, buttonNum, Locale.ConvertTextKey( "TXT_KEY_ABLTY_DEFENSIVE_EMBARK_STRING" ) )
	end
	
	if tech.EmbarkedAllWaterPassage then
		buttonNum = TBI_GenericButton(thisTechButtonInstance, textureSize, buttonNum, Locale.ConvertTextKey( "TXT_KEY_ALLOWS_CROSSING_OCEANS" ) )
	end
	
	if tech.UnitFortificationModifier > 0 then
		buttonNum = TBI_GenericButton(thisTechButtonInstance, textureSize, buttonNum, Locale.ConvertTextKey( "TXT_KEY_UNIT_FORTIFICATION_MOD", tech.UnitFortificationModifier ) )
	end
	
	if tech.UnitBaseHealModifier > 0 then
		buttonNum = TBI_GenericButton(thisTechButtonInstance, textureSize, buttonNum, Locale.ConvertTextKey( "TXT_KEY_UNIT_BASE_HEAL_MOD", tech.UnitBaseHealModifier ) )
	end
	
	if tech.AllowEmbassyTradingAllowed then
		buttonNum = TBI_GenericButton(thisTechButtonInstance, textureSize, buttonNum, Locale.ConvertTextKey( "TXT_KEY_ALLOWS_EMBASSY" ) )
	end
	
	if tech.OpenBordersTradingAllowed then
		buttonNum = TBI_GenericButton(thisTechButtonInstance, textureSize, buttonNum, Locale.ConvertTextKey( "TXT_KEY_ALLOWS_OPEN_BORDERS" ) )
	end
	
	if tech.DefensivePactTradingAllowed then
		buttonNum = TBI_GenericButton(thisTechButtonInstance, textureSize, buttonNum, Locale.ConvertTextKey( "TXT_KEY_ALLOWS_DEFENSIVE_PACTS" ) )
	end
	
	if tech.ResearchAgreementTradingAllowed then
		buttonNum = TBI_GenericButton(thisTechButtonInstance, textureSize, buttonNum, Locale.ConvertTextKey( "TXT_KEY_ALLOWS_RESEARCH_AGREEMENTS" ) )
	end
	
	if tech.TradeAgreementTradingAllowed then
		buttonNum = TBI_GenericButton(thisTechButtonInstance, textureSize, buttonNum, Locale.ConvertTextKey( "TXT_KEY_ALLOWS_TRADE_AGREEMENTS" ) )
	end
	
	if tech.BridgeBuilding then
		buttonNum = TBI_GenericButton(thisTechButtonInstance, textureSize, buttonNum, Locale.ConvertTextKey( "TXT_KEY_ALLOWS_BRIDGES" ) )
	end

	if tech.MapVisible then
		buttonNum = TBI_GenericButton(thisTechButtonInstance, textureSize, buttonNum, Locale.ConvertTextKey( "TXT_KEY_REVEALS_ENTIRE_MAP" ) )
	end
	
	for row in GameInfo.Technology_FreePromotions(condition) do
		local promotion = GameInfo.UnitPromotions[row.PromotionType];
		local buttonName = "B"..tostring(buttonNum);
		local thisButton = thisTechButtonInstance[buttonName];
		if thisButton and promotion ~= nil then
			IconHookup( promotion.PortraitIndex, textureSize, promotion.IconAtlas, thisButton );
			thisButton:SetHide( false );
			thisButton:SetToolTipString( Locale.ConvertTextKey("TXT_KEY_FREE_PROMOTION_FROM_TECH", promotion.Description, promotion.Help) );
			buttonNum = buttonNum + 1;
		else
			break;
		end
	end
	
	return buttonNum;
	
end


function AddCallbackToSmallButtons( thisTechButtonInstance, maxSmallButtons, void1, void2, thisEvent, thisCallback )
	for buttonNum = 1, maxSmallButtons, 1 do
		local buttonName = "B"..tostring(buttonNum);
		thisTechButtonInstance[buttonName]:SetVoids(void1, void2);
		thisTechButtonInstance[buttonName]:RegisterCallback(thisEvent, thisCallback);
	end
end


function AdjustArtOnGrantedUnitButton( thisButton, thisUnitInfo, textureSize )
	-- if we have one, update the unit picture
	if thisButton then
		
		-- Tooltip
		local bIncludeRequirementsInfo = true;
		thisButton:SetToolTipString( GetHelpTextForUnit(thisUnitInfo.ID, bIncludeRequirementsInfo) );
		local portraitOffset, portraitAtlas = UI.GetUnitPortraitIcon(thisUnitInfo.ID);
		local textureOffset, textureSheet = IconLookup( portraitOffset, textureSize, portraitAtlas );				
		if textureOffset == nil then
			textureSheet = defaultErrorTextureSheet;
			textureOffset = nullOffset;
		end				
		thisButton:SetTexture( textureSheet );
		thisButton:SetTextureOffset( textureOffset );
		thisButton:SetHide( false );
		techPediaSearchStrings[tostring(thisButton)] = Locale.ConvertTextKey(thisUnitInfo.Description);
		thisButton:RegisterCallback( Mouse.eRClick, GetTechPedia );
	end
end


function AdjustArtOnGrantedBuildingButton( thisButton, thisBuildingInfo, textureSize )
	-- if we have one, update the building (or wonder) picture
	if thisButton then
		
		-- Tooltip
		local bExcludeName = false;
		local bExcludeHeader = false;
		thisButton:SetToolTipString( GetHelpTextForBuilding(thisBuildingInfo.ID, bExcludeName, bExcludeHeader, false, nil) );
		
		local textureOffset, textureSheet = IconLookup( thisBuildingInfo.PortraitIndex, textureSize, thisBuildingInfo.IconAtlas );				
		if textureOffset == nil then
			textureSheet = defaultErrorTextureSheet;
			textureOffset = nullOffset;
		end				
		thisButton:SetTexture( textureSheet );
		thisButton:SetTextureOffset( textureOffset );
		thisButton:SetHide( false );
		techPediaSearchStrings[tostring(thisButton)] = Locale.ConvertTextKey(thisBuildingInfo.Description);
		thisButton:RegisterCallback( Mouse.eRClick, GetTechPedia );
	end
end


function AdjustArtOnGrantedProjectButton( thisButton, thisProjectInfo, textureSize )
	-- if we have one, update the project picture
	if thisButton then
		
		-- Tooltip
		local bIncludeRequirementsInfo = true;
		thisButton:SetToolTipString( GetHelpTextForProject(thisProjectInfo.ID, bIncludeRequirementsInfo) );

		local textureOffset, textureSheet = IconLookup( thisProjectInfo.PortraitIndex, textureSize, thisProjectInfo.IconAtlas );				
		if textureOffset == nil then
			textureSheet = defaultErrorTextureSheet;
			textureOffset = nullOffset;
		end				
		thisButton:SetTexture( textureSheet );
		thisButton:SetTextureOffset( textureOffset );
		thisButton:SetHide( false );
		techPediaSearchStrings[tostring(thisButton)] = Locale.ConvertTextKey(thisProjectInfo.Description);
		thisButton:RegisterCallback( Mouse.eRClick, GetTechPedia );
	end
end


function AdjustArtOnGrantedResourceButton( thisButton, thisResourceInfo, textureSize )
	if thisButton then
		thisButton:SetToolTipString( Locale.ConvertTextKey("TXT_KEY_REVEALS_RESOURCE_ON_MAP", thisResourceInfo.Description)); 

		local textureOffset, textureSheet = IconLookup( thisResourceInfo.PortraitIndex, textureSize, thisResourceInfo.IconAtlas );				
		if textureOffset == nil then
			textureSheet = defaultErrorTextureSheet;
			textureOffset = nullOffset;
		end				
		thisButton:SetTexture( textureSheet );
		thisButton:SetTextureOffset( textureOffset );
		thisButton:SetHide( false );
		techPediaSearchStrings[tostring(thisButton)] =  Locale.Lookup(thisResourceInfo.Description);
		thisButton:RegisterCallback( Mouse.eRClick, GetTechPedia );
	end
end

function AdjustArtOnGrantedActionButton( thisButton, thisBuildInfo, textureSize )
	if thisButton then
		thisButton:SetToolTipString( Locale.ConvertTextKey( thisBuildInfo.Description ) );
		local textureOffset, textureSheet = IconLookup( thisBuildInfo.IconIndex, textureSize, thisBuildInfo.IconAtlas );				
		if textureOffset == nil then
			textureSheet = defaultErrorTextureSheet;
			textureOffset = nullOffset;
		end				
		thisButton:SetTexture( textureSheet );
		thisButton:SetTextureOffset( textureOffset );
		thisButton:SetHide(false);

		if thisBuildInfo.RouteType then
			techPediaSearchStrings[tostring(thisButton)] = Locale.ConvertTextKey( GameInfo.Routes[thisBuildInfo.RouteType].Description );
		elseif thisBuildInfo.ImprovementType then
			techPediaSearchStrings[tostring(thisButton)] = Locale.ConvertTextKey( GameInfo.Improvements[thisBuildInfo.ImprovementType].Description );
		else -- we are a choppy thing
			techPediaSearchStrings[tostring(thisButton)] = Locale.ConvertTextKey( GameInfo.Concepts["CONCEPT_WORKERS_CLEARINGLAND"].Description );
		end
		thisButton:RegisterCallback( Mouse.eRClick, GetTechPedia );
		--techPediaSearchStrings[tostring(thisButton)] = Locale.ConvertTextKey( thisBuildInfo.Description );
		--thisButton:RegisterCallback( Mouse.eRClick, GetTechPedia );
	end
end

function GetCivilopediaTechDetails(techID)
	local tab = {};
	if cgScenario then
		LuaEvents.ITG_TechButtonMoreInfo(techID, cgScenario, cgCultureType, cgSubcultureType)
		local moreITGbuttoninfo = MapModData.ITGSG;
		MapModData.ITGSG = nil;
		local techType = GameInfo.Technologies[techID].Type;
		for i, v in pairs(moreITGbuttoninfo[2]) do
			table.insert(tab, v[1])
		end
		for i, text in pairs(extraButtonsScenario[cgScenario][techType] or {}) do
			table.insert(tab, text)
		end
		for i, v in pairs(moreITGbuttoninfo[1]) do
			table.insert(tab, v)
		end
		for i = 1, 10 do
			local hText = "TXT_KEY_TBT_" .. techType .. "_" .. i;
			local lText = Locale.Lookup(hText)
			if hText == lText then
				break;
			else
				table.insert(tab, lText)
			end
		end
	end
	return tab;
end