-------------------------------------------------
-- Religion Overview Popup
-------------------------------------------------
include( "IconSupport" );
include( "InstanceManager" );
include( "ITGSG_HelpFunctions" );
include( "InfoTooltipInclude" );
-------------------------------------------------
-- Global Constants
-------------------------------------------------

local ltBlue = {19/255,32/255,46/255,180/255};
local dkBlue = {12/255,22/255,30/255,180/255};
local bTickTock = false;
local m_BasicLegalInfo_IM = InstanceManager:new("BasicLegalInfoInstance", "BasicLegalInfoBox", Controls.InfoGovStack)
local m_Actions_IM = InstanceManager:new( "BudgetInstance", "Button", Controls.MainStack );
local m_ActionsR_IM = InstanceManager:new( "BudgetInstance", "Button", Controls.MainStackR );
local maxValForSliders = {}
local ghinst = {}

function OnClose()
	UIManager:DequeuePopup(ContextPtr);
end
Controls.CloseButton:RegisterCallback(Mouse.eLClick, OnClose)

--make database 2 include

g_Tabs = {
	["YourReligion"] = {
		Panel = Controls.YourReligionPanel,
		SelectHighlight = Controls.YourReligionSelectHighlight,
	},
}


-------------------------------------------------
-- Global Variables
-------------------------------------------------
g_CurrentTab = nil;		-- The currently selected Tab.

-------------------------------------------------
-------------------------------------------------
	
-------------------------------------------------
-------------------------------------------------
function OnPopupMessage(popupInfo)
	
	local popupType = popupInfo.Type;
	if popupType ~= 6463435 then
		return;
	end
	g_PopupInfo = popupInfo;
	if g_CurrentTab then
		TabSelect(g_CurrentTab);
	end
	
	if( g_PopupInfo.Data1 == 1 ) then
    	if( ContextPtr:IsHidden() == false ) then
    		OnClose();
		else
        	UIManager:QueuePopup( ContextPtr, PopupPriority.InGameUtmost );
    	end
	else
		UIManager:QueuePopup( ContextPtr, PopupPriority.SocialPolicy );
	end   	
end
Events.SerialEventGameMessagePopup.Add( OnPopupMessage );

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function InputHandler( uiMsg, wParam, lParam )
    ----------------------------------------------------------------        
    -- Key Down Processing
    ----------------------------------------------------------------        
    if(uiMsg == KeyEvents.KeyDown) then
        if (wParam == Keys.VK_ESCAPE) then
			OnClose();
			return true;
        end
        
        -- Do Nothing.
        if(wParam == Keys.VK_RETURN) then
			return true;
        end
    end
end
ContextPtr:SetInputHandler( InputHandler );
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------


-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function TabSelect(tab)

	for i,v in pairs(g_Tabs) do
		local bHide = i ~= tab;
		v.Panel:SetHide(bHide);
		v.SelectHighlight:SetHide(bHide);
	end
	g_CurrentTab = tab;
	g_Tabs[tab].RefreshContent();	
end
Controls.TabButtonYourReligion:RegisterCallback( Mouse.eLClick, function() TabSelect("YourReligion"); end);

function AddSmallGovInfo(a, b, c)
	local controlTable = m_BasicLegalInfo_IM:GetInstance();
	controlTable.MainInfo:SetText(a or "")
	controlTable.DataInfo:SetText(b or "")
	controlTable.BasicLegalInfoBox:SetToolTipString(c or "")
end

function OnReduceBudget(i)
	LuaEvents.ITG_GoldBudgetChangeCall(Game.GetActivePlayer(), i, -1)
	RefreshYourReligion()
end

function OnIncreaseBudget(i)
	LuaEvents.ITG_GoldBudgetChangeCall(Game.GetActivePlayer(), i, 1)
	RefreshYourReligion()
end

function OnBudgetSlider( fValue, void1 )
	local theInput = math.min(math.floor((fValue + 0.01) * 20), maxValForSliders[void1])
	if theInput == maxValForSliders[void1] and (ghinst[void1].TheSlider:GetValue() ~= maxValForSliders[void1] / 20) then
		ghinst[void1].TheSlider:SetValue(maxValForSliders[void1] / 20)
	end
	LuaEvents.ITG_GoldBudgetSliderChange(Game.GetActivePlayer(), void1, theInput)
end

function RefreshYourReligion()
	local gPlayer = Game.GetActivePlayer();
	LuaEvents.ITGSG_RequestBudget(gPlayer);
	local gData = MapModData.ITGSG;
	MapModData.ITGSG = nil;
	if not gData then
		return
	end
	
	m_BasicLegalInfo_IM:ResetInstances()
	for a, b in pairs(gData.MiniData) do
		AddSmallGovInfo(b[1], b[2], b[3]);
	end
	
	m_Actions_IM:ResetInstances();
	m_ActionsR_IM:ResetInstances();
	local tH = 1
	maxValForSliders = {}
	ghinst = {}
	for a, b in pairs(gData.MajorData) do
		local instance;
		if tH % 2 == 1 then
			instance = m_Actions_IM:GetInstance();
		else
			instance = m_ActionsR_IM:GetInstance();
		end
		instance.Type:SetText(b.Name)
		instance.Percentage:SetText("[COLOR_YIELD_GOLD]" .. b.Input * 5 .. "%")
		IconHookup( b.PortraitIndex, 64, b.IconAtlas, instance.Image )	
		instance.Button:SetToolTipString(b.Help);
		
		instance.RemoveFromBudget:SetDisabled(b.Input == 0)
		instance.AddToBudget:SetDisabled((gData.BPoints == 0) or (b.Input == gData.BMax))
		instance.RemoveFromBudget:SetVoid1(b.ID);
		instance.AddToBudget:SetVoid1(b.ID);
		instance.RemoveFromBudget:RegisterCallback(Mouse.eLClick, OnReduceBudget)
		instance.AddToBudget:RegisterCallback(Mouse.eLClick, OnIncreaseBudget)
		
		instance.TheSlider:SetVoid1(b.ID);
		instance.TheSlider:RegisterSliderCallback( OnBudgetSlider );
		instance.TheSlider:SetValue(b.Input / 20);
		maxValForSliders[b.ID] = math.min(gData.BMax, gData.BPoints + b.Input);
		if (math.floor(tH / 2) % 2) == 0 then
			instance.Box:SetColorVal(unpack(ltBlue));
		else
			instance.Box:SetColorVal(unpack(dkBlue));
		end
		bTickTock = not bTickTock;
		ghinst[b.ID] = instance;
		tH = tH + 1;
	end

	Controls.FreeBudgetLabel:SetHide(gData.BPoints == 0);
	
	Controls.MainStack:CalculateSize();
	Controls.MainStackR:CalculateSize();
    Controls.ScrollPanel:CalculateInternalSize();
    Controls.ScrollPanel:ReprocessAnchoring();
end
g_Tabs["YourReligion"].RefreshContent = RefreshYourReligion;

LuaEvents.ITG_RefreshBudgetPage.Add(RefreshYourReligion)
-- Updates the sort option structure

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function ShowHideHandler( bIsHide, bInitState )
	CivIconHookup( 0, 64, Controls.Icon, Controls.CivIconBG, Controls.CivIconShadow, false, true );
    if( not bInitState ) then
        if( not bIsHide ) then
        	UI.incTurnTimerSemaphore();  
        	Events.SerialEventGameMessagePopupShown(g_PopupInfo);
        	
        	TabSelect(g_CurrentTab);
        else
			if(g_PopupInfo ~= nil) then
				Events.SerialEventGameMessagePopupProcessed.CallImmediate(6463435, 0);
            end
            UI.decTurnTimerSemaphore();
        end
    end
end
ContextPtr:SetShowHideHandler( ShowHideHandler );


LuaEvents.ITG_CallBudgetOverview.Add(function()
	if Players[Game.GetActivePlayer()]:IsTurnActive() then
   		if( ContextPtr:IsHidden() == false ) then
   			OnClose();
		else
	   		UIManager:QueuePopup( ContextPtr, PopupPriority.InGameUtmost );
   		end
	end
end)

----------------------------------------------------------------
-- 'Active' (local human) player has changed
----------------------------------------------------------------
function OnActivePlayerChanged()
	--if (not Controls.ChooseConfirm:IsHidden()) then
	--	Controls.ChooseConfirm:SetHide(true);
	--end
end
Events.GameplaySetActivePlayer.Add(OnActivePlayerChanged);

-----------------------------------------------------------------
ContextPtr:SetHide(true)
TabSelect("YourReligion");
Controls.HelpImageId1:SetAlpha(0.7)