-------------------------------------------------
-- Religion Overview Popup
-------------------------------------------------
include( "IconSupport" );
include( "InstanceManager" );

local TabOfEventTypes = {
"Combat", --admiral defeat
"Combat", --general combat
"Training", --admiral acquisition
"Training", --general acquisition
"Nuclear", -- nuclear explosion
"Nuclear", -- nuclear project
"Combat", -- notable city capture
"Progress", -- Innovation
"State", --Anarchy
"State", -- Centralized power
"Defeat", --Elemination
"Espionage", --Money Forgery   --sabotage without event
"Espionage", --Assassination
"Espionage", --Hostile takeover
"Training", --special unit
}
local m_SimpleText = InstanceManager:new( "UnitInstance", "Quote", Controls.StackMiniText );
local m_LeagueInstance = InstanceManager:new( "LeagueInstance", "InfoLabelStack", Controls.LeagueStack );
local g_IntrigueManager = GenerationalInstanceManager:new( "IntrigueMessageInstance", "Base", Controls.IntrigueMessageStack);
-- Used for Piano Keys
local g_PianoKeys = {
	[0] = {19/255,32/255,46/255,120/255},
	[1] = {12/255,22/255,30/255,120/255},
}

-------------------------------------------------
-- Global Constants
-------------------------------------------------
g_Tabs = {
	["TabOne"] = {
		Panel = Controls.YourReligionPanel,
		SelectHighlight = Controls.YourReligionSelectHighlight,
	},
	
	["TabTwo"] = {
		Panel = Controls.WorldReligionPanel,
		SelectHighlight = Controls.WorldReligionsSelectHighlight,
	},
}


-------------------------------------------------
-- Global Variables
-------------------------------------------------
g_CurrentTab = nil;		-- The currently selected Tab.

-------------------------------------------------
-------------------------------------------------
	
-------------------------------------------------
-------------------------------------------------
--[[function OnPopupMessage(popupInfo)
	
	local popupType = popupInfo.Type;
	if popupType ~= ButtonPopupTypes.BUTTONPOPUP_RELIGION_OVERVIEW then
		return;
	end
	
	if(not Game.IsOption(GameOptionTypes.GAMEOPTION_NO_RELIGION)) then
		g_PopupInfo = popupInfo;
	
		if( g_PopupInfo.Data1 == 1 ) then
    		if( ContextPtr:IsHidden() == false ) then
    			OnClose();
			else
        		UIManager:QueuePopup( ContextPtr, PopupPriority.InGameUtmost );
    		end
		else
			UIManager:QueuePopup( ContextPtr, PopupPriority.SocialPolicy );
		end   	
   	end
end
Events.SerialEventGameMessagePopup.Add( OnPopupMessage );]]

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function InputHandler( uiMsg, wParam, lParam )
    ----------------------------------------------------------------        
    -- Key Down Processing
    ----------------------------------------------------------------        
    if(uiMsg == KeyEvents.KeyDown) then
        if (wParam == Keys.VK_ESCAPE) then
			OnClose();
			return true;
        end
        
        -- Do Nothing.
        if(wParam == Keys.VK_RETURN) then
			return true;
        end
    end
end
ContextPtr:SetInputHandler( InputHandler );
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function OnClose()
	UIManager:DequeuePopup(ContextPtr);
end
Controls.CloseButton:RegisterCallback(Mouse.eLClick, OnClose);
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------


-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function TabSelect(tab)
	for i,v in pairs(g_Tabs) do
		local bHide = i ~= tab;
		v.Panel:SetHide(bHide);
		v.SelectHighlight:SetHide(bHide);
	end
	g_CurrentTab = tab;
	g_Tabs[tab].RefreshContent();	
end
Controls.TabButtonYourReligion:RegisterCallback( Mouse.eLClick, function() TabSelect("TabOne"); end);
Controls.TabButtonWorldReligions:RegisterCallback( Mouse.eLClick, function() TabSelect("TabTwo"); end );

function AddTextInstruction(t, tt)
	local instance = m_SimpleText:GetInstance();
	instance.Quote:SetText( t);
	instance.Quote:SetToolTipString( tt or "");
end

function GetWarningColourIfBelow80(val1, val2, tPercent)
	if val1 >= (tPercent or 0.8) * val2 then
		return val1;
	end
	return "[COLOR_YELLOW]" .. val1;
end

function RefreshYourReligion()
	m_SimpleText:ResetInstances();
	m_LeagueInstance:ResetInstances();
	LuaEvents.ITGSG_RequestGT();
	local gData = MapModData.ITGSG;
	if not gData then
		return;
	end
	if not gData.Globals.Domination then
		return;
	end

	if gData.Globals.DominationOff then
		AddTextInstruction("Great War has already ended, humanity produly enters new age of completely different mistakes, but this is another story.")
		AddTextInstruction("[ICON_BULLET]War Break", "The Great War started in " .. gData.Globals.Domination.TurnStart .. " turn.")
		AddTextInstruction("[ICON_BULLET]Peace", "The Great War ended in " .. gData.Globals.Domination.TurnEnd .. " turn.")
	else
		AddTextInstruction("World at War is currently ongoing domination mode between all major ideological Leagues. It has specific rules that lead to elemination of certain fraction which members will loose all Ideological Tenets.[NEWLINE][NEWLINE]Rules:")
		AddTextInstruction("[ICON_BULLET]War Break", "The Great War started in " .. gData.Globals.Domination.TurnStart .. " turn.")
		AddTextInstruction("[ICON_BULLET]Total War", "Any new war declared between major members of different ideological Leagues will be permanent.")
		AddTextInstruction("[ICON_BULLET]City-States", "City-States will join Ideological League once their next politics are resolved. Make your fraction the most appealing by completing missions and helping out with their projects.")
		AddTextInstruction("[ICON_BULLET]War Focus", "Revolution is temporary unavailable.")
		AddTextInstruction("[ICON_BULLET]Survival", "League cannot be eleminated as long as it has 80% of original Cities, Territory or Population, or 90% of the Military Might.")
		AddTextInstruction("[ICON_BULLET]Elemination", "Elemination is determined by turn passed, overall power in comparision to the strongest league and on victories and losses.")
		AddTextInstruction("[ICON_BULLET]Victories and Losses", "Defeating units, capturing Cities, discovering technologies and acquiring Nuclear Weapons grant positive points.")
		AddTextInstruction("[ICON_BULLET]Peace", "World at War ends once at least one faction was eleminated and there are no more than two remaining Leagues. All Total War resolutions will be removed then.")		
	end
	for d, b in pairs(gData.Globals.Domination.Sides) do
		local itemInstance = m_LeagueInstance:GetInstance();
		itemInstance.Data2Stack:DestroyAllChildren();
		itemInstance.Label1:SetText(b.Acronym)
		if gData.Leagues[d] then
			itemInstance.Label1:SetToolTipString(gData.Leagues[d].Name)
			local minorc, lastminor = "", nil;
			local vHelpfulT = {}
			local uiu = 1;
			for ju, jk in pairs(gData.Leagues[d].Members) do
				if Players[ju]:IsMinorCiv() then
					if minorc == "" then
						minorc = Players[ju]:GetName();
					else
						minorc = minorc .. "[NEWLINE]" .. Players[ju]:GetName();
					end
					lastminor = ju;
				elseif uiu < 13 then
					table.insert(vHelpfulT, {ju, Players[ju]:GetCivilizationShortDescription()})
					uiu = uiu + 1;
				end
			end
			if lastminor and (uiu < 13) then
				table.insert(vHelpfulT, {lastminor, minorc})
			end
			local tsize = 32;
			if #vHelpfulT > 9 then
				tsize = 16;
			elseif #vHelpfulT > 7 then
				tsize = 20;
			elseif #vHelpfulT > 6 then
				tsize = 26;
			else
				tsize = 32;
			end
			for kkk, mmm in pairs(vHelpfulT) do
				local instance = {};
				ContextPtr:BuildInstanceForControl( "CivIconInstance", instance, itemInstance.Data2Stack );
				instance.Base:SetToolTipString(mmm[2]);
				CivIconHookup( mmm[1], 32, instance.Icon, instance.CivIconBG, instance.CivIconShadow, false, true); 
				instance.Base:SetSizeX(tsize);
				instance.Base:SetHide(false)
			end
		else
			itemInstance.Label1:SetToolTipString(b.Name)
			local instance = {};
			ContextPtr:BuildInstanceForControl( "CivIconInstance", instance, itemInstance.Data2Stack );
			instance.Base:SetToolTipString("Defeated");
			CivIconHookup( 63, 32, instance.Icon, instance.CivIconBG, instance.CivIconShadow, false, true); 
			instance.Base:SetSizeX(32);
			instance.Base:SetHide(false)
		end
		if b.Active then
			itemInstance.InfoLabelStack:SetAlpha(1)
		else
			itemInstance.InfoLabelStack:SetAlpha(0.7)
		end
		itemInstance.Label3:SetText(GetWarningColourIfBelow80(math.ceil(b.MilitaryPower / 5000) * 5000, math.ceil(b.Initial.MilitaryPower / 5000) * 5000, 0.9))
		itemInstance.Label3:SetToolTipString("Initial value: " .. math.ceil(b.Initial.MilitaryPower / 5000) * 5000)
		itemInstance.Label4:SetText(GetWarningColourIfBelow80(b.Population, b.Initial.Population))
		itemInstance.Label4:SetToolTipString("Initial value: " .. b.Initial.Population)
		itemInstance.Label5:SetText(GetWarningColourIfBelow80(b.Territory, b.Initial.Territory))
		itemInstance.Label5:SetToolTipString("Initial value: " .. b.Initial.Territory)
		itemInstance.Label6:SetText(GetWarningColourIfBelow80(b.Cities, b.Initial.Cities))
		itemInstance.Label6:SetToolTipString("Initial value: " .. b.Initial.Cities)
		itemInstance.Label7:SetText(b.Victories or 0)
		itemInstance.Label8:SetText(b.Losses or 0)
		itemInstance.Label9:SetText(b.Espionage or 0)
		itemInstance.Label10:SetText(b.NuclearWeapons or 0)
		jjbbcc = itemInstance;
	end
    Controls.LeagueStack:CalculateSize();
    Controls.LeagueStack:ReprocessAnchoring();
    Controls.TechTreeScrollPanel:CalculateInternalSize();
end
g_Tabs["TabOne"].RefreshContent = RefreshYourReligion;

function RefreshWorldReligions()
	LuaEvents.ITGSG_RequestGT();
	local gData = MapModData.ITGSG;
	MapModData.ITGSG = nil;
	if not gData then
		return
	end
	if not gData.Globals.Domination then
		return;
	end
	local iPlayer = Game.GetActivePlayer()

	g_IntrigueManager:ResetInstances();
	local bTickTock = true;
	for i,v in pairs(gData.Globals.Domination.Events) do
			
		local instance = g_IntrigueManager:GetInstance();
		instance.Base:SetColorVal(unpack(bTickTock and g_PianoKeys[0] or g_PianoKeys[1]));
		instance.Turn:SetText(v[2] .. "T");
		instance.Type:SetText(TabOfEventTypes[v[1]] or "???");
		local tt1, tt2 = "", "";
		if v[3] then
			tt1 = Players[v[3]]:GetCivilizationShortDescription();
			IconHookup(GameInfo.Civilizations[Players[v[3]]:GetCivilizationType()].PortraitIndex, 32, GameInfo.Civilizations[Players[v[3]]:GetCivilizationType()].IconAtlas, instance.CivIcon1);
			instance.CivIcon1:SetHide(false)
		else
			instance.CivIcon1:SetHide(true)
		end
		if v[4] then
			tt2 = Players[v[4]]:GetCivilizationShortDescription();
			IconHookup(GameInfo.Civilizations[Players[v[4]]:GetCivilizationType()].PortraitIndex, 32, GameInfo.Civilizations[Players[v[4]]:GetCivilizationType()].IconAtlas, instance.CivIcon2);
			instance.CivIcon2:SetHide(false)
		else
			instance.CivIcon2:SetHide(true)
		end
		if v[7] then
			instance.CivilizationName1:SetText(gData.Globals.Domination.Sides[v[7]].Acronym)
			if v[3] then
				tt1 = tt1 .. " of "
			end
			tt1 = tt1 .. gData.Globals.Domination.Sides[v[7]].Name;
		else
			instance.CivilizationName1:SetText("");
		end
		if v[8] then
			instance.CivilizationName2:SetText(gData.Globals.Domination.Sides[v[8]].Acronym)
			if v[4] then
				tt2 = tt2 .. " of "
			end
			tt2 = tt2 .. gData.Globals.Domination.Sides[v[8]].Name;
		else
			instance.CivilizationName2:SetText("");
		end
		instance.BoxSide1:SetToolTipString(tt1)
		instance.BoxSide2:SetToolTipString(tt2)
		
		local valuestring = ""
		if v[5] then
			if v[5] > 0 then
				valuestring = "[COLOR_POSITIVE_TEXT]+" .. v[5] .. "[ENDCOLOR]"
			else
				valuestring = "[COLOR_NEGATIVE_TEXT]+" .. v[5] .. "[ENDCOLOR]"
			end
		end
		if v[6] then
			if v[6] > 0 then
				valuestring = valuestring .. "/[COLOR_POSITIVE_TEXT]" .. v[6] .. "[ENDCOLOR]"
			else
				valuestring = valuestring .. "/[COLOR_NEGATIVE_TEXT]" .. v[6] .. "[ENDCOLOR]"
			end
		end
		instance.Value:SetText(valuestring)

		

		if v[1] == 1 then
			instance.Message:SetString(SimplePlayerName(v[3]) .. " has killed admiral " .. Locale.Lookup(gData.GreatPeople[v[10]].Name) .. " in combat.")
		elseif v[1] == 2 then
			instance.Message:SetString(SimplePlayerName(v[3]) .. " has killed general " .. Locale.Lookup(gData.GreatPeople[v[10]].Name) .. " in combat.")
		elseif v[1] == 3 then
			instance.Message:SetString(SimplePlayerName(v[3]) .. " nominated new admiral, " .. Locale.Lookup(gData.GreatPeople[v[10]].Name) .. ".")
		elseif v[1] == 4 then
			instance.Message:SetString(SimplePlayerName(v[3]) .. " nominated new general, " .. Locale.Lookup(gData.GreatPeople[v[10]].Name) .. ".")
		elseif v[1] == 5 then
			local iPlot = Map.GetPlot(v[10], v[11]);
			if iPlot:GetOwner() == -1 then
				instance.Message:SetString(SimplePlayerName(v[3]) .. " has used Atomic Bomb.")
			elseif iPlot:IsCity() then
				instance.Message:SetString(SimplePlayerName(v[3]) .. " has dropped Atomic Bomb on " .. iPlot:GetPlotCity():GetName() .. ".")
			elseif iPlot:GetOwner() == v[3] then
				instance.Message:SetString("In desperation, " .. SimplePlayerName(v[3]) .. " has dropped Atomic Bomb on own territory.")
			else
				instance.Message:SetString(SimplePlayerName(v[3]) .. " has dropped Atomic Bomb on " .. Players[iPlot:GetOwner()]:GetName() .. "'s land.")
			end
		elseif v[1] == 6 then
			instance.Message:SetString(GetPlayerAdjectiveForm(iPlayer) .. " scientists have developed Nuclear Weapon.")
		elseif v[1] == 7 then
			instance.Message:SetString("Troops of " .. SimplePlayerName(v[3]) .. " have entered the city of " .. Map.GetPlotByIndex(v[10]):GetPlotCity():GetName() .. ".")
		elseif v[1] == 8 then
			instance.Message:SetString("Scientists from " .. Players[v[3]]:GetCivilizationShortDescription() .. " have developed " .. Locale.Lookup(GameInfo.Technologies[v[10]].Description) .. ".")
		elseif v[1] == 9 then
			instance.Message:SetString("Civil unrest have lead to Anarchy in " .. Players[v[3]]:GetCivilizationShortDescription() .. ".")
		elseif v[1] == 10 then
			instance.Message:SetString(SimplePlayerName(v[3]) .. " managed to centralize power within " .. Players[v[3]]:GetCivilizationShortDescription() .. ".")
		elseif v[1] == 11 then
			instance.Message:SetString("Leaders of " .. gData.Globals.Domination.Sides[v[7]].Name .. " announced their unconditional surrender.")
		elseif v[1] == 12 then
			instance.Message:SetString(SimplePlayerName(v[3]) .. " counterfeited " .. GetPlayerAdjectiveForm(v[4]) .. " currency.")
		elseif v[1] == 13 then
			instance.Message:SetString(Players[v[3]]:GetCivilizationAdjective() .. " agents have assasinated " .. Locale.Lookup(gData.GreatPeople[v[10]].Name) .. ".") 
		elseif v[1] == 14 then
			instance.Message:SetString(Players[v[3]]:GetCivilizationAdjective() .. " agents made a hostile takeover of " .. GetPlayerAdjectiveForm(v[4]) .. " agencies making " .. SimplePlayerName(v[3]) .. " vulnerable.")
		elseif v[1] == 15 then
			instance.Message:SetString(SimplePlayerName(v[3]) .. " has acquired new special force.")
		else
			instance.Message:SetString("???");
		end
		
		local width, height = instance.Message:GetSizeVal();
		local baseWidth, baseHeight = instance.Base:GetSizeVal();
		instance.Base:SetSizeVal(baseWidth, height + 22);
		
		letsworkinstance = instance;
		bTickTock = not bTickTock;
	end
	Controls.IntrigueMessageStack:CalculateSize();
	Controls.IntrigueMessageStack:ReprocessAnchoring();
	Controls.IntrigueMessageScrollPanel:CalculateInternalSize();
end
g_Tabs["TabTwo"].RefreshContent = RefreshWorldReligions;

function SimplePlayerName(iPlayer)
	if iPlayer == Game.GetActivePlayer() then
		return "You"
	else
		return Players[iPlayer]:GetName();
	end
end

function GetPlayerAdjectiveForm(iPlayer)
	if iPlayer == Game.GetActivePlayer() then
		return "Your"
	else
		return Players[iPlayer]:GetName() .. "'s";
	end
end

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function ShowHideHandler( bIsHide, bInitState )
	CivIconHookup( 0, 64, Controls.Icon, Controls.CivIconBG, Controls.CivIconShadow, false, true );
    if( not bInitState ) then
        if( not bIsHide ) then
        	UI.incTurnTimerSemaphore();  
 --       	Events.SerialEventGameMessagePopupShown(g_PopupInfo);
        	
        	TabSelect(g_CurrentTab);
        else
			if(g_PopupInfo ~= nil) then
--				Events.SerialEventGameMessagePopupProcessed.CallImmediate(g_PopupInfo.Type, 0);
            end
            UI.decTurnTimerSemaphore();
        end
    end
end
ContextPtr:SetShowHideHandler( ShowHideHandler );

LuaEvents.ITG_CallDominationOverview.Add(function()
	if Players[Game.GetActivePlayer()]:IsTurnActive() then
   		if( ContextPtr:IsHidden() == false ) then
   			OnClose();
		else
	   		UIManager:QueuePopup( ContextPtr, PopupPriority.InGameUtmost );
   		end
	end
end)

----------------------------------------------------------------
-- 'Active' (local human) player has changed
----------------------------------------------------------------
function OnActivePlayerChanged()
	--if (not Controls.ChooseConfirm:IsHidden()) then
	--	Controls.ChooseConfirm:SetHide(true);
	--end
end
Events.GameplaySetActivePlayer.Add(OnActivePlayerChanged);

-----------------------------------------------------------------
ContextPtr:SetHide(true)
TabSelect("TabOne");