-------------------------------------------------
-- Religion Overview Popup
-------------------------------------------------
include( "IconSupport" );
include( "InstanceManager" );
include( "InfoTooltipInclude" );
-------------------------------------------------
-- Global Constants
-------------------------------------------------

local ltBlue = {19/255,32/255,46/255,120/255};
local dkBlue = {12/255,22/255,30/255,120/255};
local bShowWholeTree = true;
local g_GovTenets = InstanceManager:new( "PolicyButton", "PolicyIcon", Controls.GovTreeStack );
local g_LineSegment = InstanceManager:new("GraphLineInstance","LineSegment", Controls.GovTreeStackLines);

local hTextureTab = {
{"ITG_Gov_Anarchy_Background.dds",0,150,0.4,"Anarchy"},
{"ITG_Gov_Monarchy_Background.dds",0,90,0.4,"Monarchy"},
{"ITG_Gov_Despotism_Background.dds",0,60,0.4,"Despotism"},
{"ITG_Gov_Fundamentalism_Background.dds",0,0,0.5,"Fundamentalism"},
{"ITG_Gov_Republic_Background.dds",0,150,0.5,"Republic"},
{"ITG_Gov_Oligarchy_Background.dds",0,120,0.5,"Oligarchy"},
{"ITG_Gov_Feudalism_Background.dds",0,80,0.25,"Feudalism"},
}

function OnClose()
	Controls.ITGPrinciple_AlphaAnim:SetToEnd()
	UIManager:DequeuePopup(ContextPtr);
end
Controls.CloseButton:RegisterCallback(Mouse.eLClick, OnClose);

local SeasonTableName = {"Spring", "Summer", "Autumn", "Winter"}
local bShowLaws = true;
local bShowActions = true;
local m_Actions_IM = InstanceManager:new( "ActionInstance", "Button", Controls.LegalActionStack );
local m_Laws_IM = InstanceManager:new("LawInstance", "Button", Controls.LawsStack);
local m_Cities_IM = InstanceManager:new("CityInstance", "Button", Controls.COMainStack);
local m_BasicLegalInfo_IM = InstanceManager:new("BasicLegalInfoInstance", "BasicLegalInfoBox", Controls.InfoGovStack)
local m_BasicGovInfo_IM = InstanceManager:new("GovInfoInstance", "GovStackInfo", Controls.GovInfoStack1)
--make database 2 include

function GetThStNdRd(number)
	local tens = math.floor(number / 10)
	if tens == 1 then
		return "th"
	end
	local ith = number % 10;
	if ith == 1 then
		return "st"
	elseif ith == 2 then
		return "nd"
	elseif ith == 3 then
		return "rd"
	end
	return "th";
end

function GetTextDate(turn, StartDate, bYearOnly, bNumberOnly)
	local year = -4000 + math.floor((StartDate + turn)/4);
	local season = SeasonTableName[(StartDate + turn)%4 + 1];
	if year < 0 then
		if bYearOnly then
	--		if bNumberOnly then
	--			return -year;
	--		end
			return -year .. " BC";
		else
			return season .. " " .. -year .. " BC";
		end
	else
		if bYearOnly then
			if bNumberOnly and (year > 99) then
				return year;
			end
			return year .. " AD";
		else
			return season .. " " .. year .. " AD";
		end
	end
end

function GetNationalDayDate(iDay)
	local day, month, year = ("01-01-2000"):match("(%d%d)-(%d%d)-(%d%d%d%d)")
	local result = os.time({day = day + iDay - 1, month = month, year = year})
	local iNum = tonumber(os.date("%d", result))
	return iNum	.. GetThStNdRd(iNum) .. os.date(" of %B", result)
end

g_Tabs = {
	["LegalActions"] = {
		Panel = Controls.LegalActionsPanel,
		SelectHighlight = Controls.LegalActionsSelectHighlight,
	},
	
	["Goverment"] = {
		Panel = Controls.GovermentPanel,
		SelectHighlight = Controls.GovermentsSelectHighlight,
	},
	
	["Beliefs"] = {
		Panel = Controls.BeliefsPanel,
		SelectHighlight = Controls.BeliefsSelectHighlight,
	},

	["Palaces"] = {
		Panel = Controls.PalacesInfo,
		SelectHighlight = Controls.WondersSelectHighlight,
	},
}


-------------------------------------------------
-- Global Variables
-------------------------------------------------
g_CurrentTab = nil;		-- The currently selected Tab.

-------------------------------------------------
-------------------------------------------------
	
-------------------------------------------------
-------------------------------------------------
function OnPopupMessage(popupInfo)
	
	local popupType = popupInfo.Type;
	if popupType ~= 99392 then
		return;
	end
	print("It is being fired at all? 5435234342")
	g_PopupInfo = popupInfo;
	if g_PopupInfo.Data2 then
		if g_PopupInfo.Data2 == 2 then
	        TabSelect("Goverment");
		elseif g_PopupInfo.Data2 == 3 then
	        TabSelect("Beliefs");
		else
	        TabSelect("LegalActions");
		end
	end
	
	if( g_PopupInfo.Data1 == 1 ) then
    	if( ContextPtr:IsHidden() == false ) then
    		OnClose();
		else
        	UIManager:QueuePopup( ContextPtr, PopupPriority.InGameUtmost );
    	end
	else
		UIManager:QueuePopup( ContextPtr, PopupPriority.SocialPolicy );
	end   	
end
Events.SerialEventGameMessagePopup.Add( OnPopupMessage );

function CalledGovOver(val1, val2, val3)
   	if( ContextPtr:IsHidden() == false ) then
		if (val1 == 3) and val2 then
			TabSelect("Goverment")
			Controls.ITGPrinciple_AlphaAnim:SetOffsetVal(val2 + 12, val3 + 12)
			Controls.ITGPrinciple_AlphaAnim:SetHide(false)
			Controls.ITGPrinciple_AlphaAnim:SetToBeginning();
			Controls.ITGPrinciple_AlphaAnim:Play();
		else
	   		OnClose();
		end
	else
		if val1 == 4 then
			TabSelect("Palaces");
		elseif val1 == 3 then
			TabSelect("Goverment")
			if val2 then
				Controls.ITGPrinciple_AlphaAnim:SetOffsetVal(val2 + 12, val3 + 12)
				Controls.ITGPrinciple_AlphaAnim:SetHide(false)
				Controls.ITGPrinciple_AlphaAnim:SetToBeginning();
				Controls.ITGPrinciple_AlphaAnim:Play();
			end
		else
			TabSelect("LegalActions");
		end
	   	UIManager:QueuePopup( ContextPtr, PopupPriority.InGameUtmost );
   	end
end
LuaEvents.ITG_CallGovermentOverview.Add(CalledGovOver)

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function IgnoreLeftClick( Id )
	-- just swallow it
end
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function InputHandler( uiMsg, wParam, lParam )
    ----------------------------------------------------------------        
    -- Key Down Processing
    ----------------------------------------------------------------        
    if(uiMsg == KeyEvents.KeyDown) then
        if (wParam == Keys.VK_ESCAPE) then
			OnClose();
			return true;
        end
        
        -- Do Nothing.
        if(wParam == Keys.VK_RETURN) then
			return true;
        end
    end
end
ContextPtr:SetInputHandler( InputHandler );
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------


-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function TabSelect(tab)

	for i,v in pairs(g_Tabs) do
		local bHide = i ~= tab;
		v.Panel:SetHide(bHide);
		v.SelectHighlight:SetHide(bHide);
	end
	g_CurrentTab = tab;
	g_Tabs[tab].RefreshContent();	
end
Controls.TabButtonLegalActions:RegisterCallback( Mouse.eLClick, function() TabSelect("LegalActions"); end);
Controls.TabButtonGoverments:RegisterCallback( Mouse.eLClick, function() TabSelect("Goverment"); end );
Controls.TabButtonBeliefs:RegisterCallback( Mouse.eLClick, function() TabSelect("Beliefs"); end );
Controls.TabButtonWonder:RegisterCallback( Mouse.eLClick, function() TabSelect("Palaces"); end );

function PurchaseLegalFunc()
	if not Players[Game.GetActivePlayer()]:IsTurnActive() then
		return;
	end
	LuaEvents.ITG_CallPurchaseLegalForGold(Game.GetActivePlayer())
	RefreshLegalActions()
end
Controls.PurchaseLegal:RegisterCallback( Mouse.eLClick, PurchaseLegalFunc);

function PurchaseLegalWithFaithFunc()
	if not Players[Game.GetActivePlayer()]:IsTurnActive() then
		return;
	end
	LuaEvents.ITG_CallPurchaseLegalForFaith(Game.GetActivePlayer())
	RefreshLegalActions()
end
Controls.PurchaseLegalWithFaith:RegisterCallback( Mouse.eLClick, PurchaseLegalWithFaithFunc);

function OnActionClicked(id)
	if not Players[Game.GetActivePlayer()]:IsTurnActive() then
		return;
	end
	LuaEvents.ITG_CallActionUIHumanLegal(Game.GetActivePlayer(), id)
	RefreshLegalActions()
end

function OnLawClicked(id, option)
	if not Players[Game.GetActivePlayer()]:IsTurnActive() then
		return;
	end
	LuaEvents.ITG_CallLawUIHumanLegal(Game.GetActivePlayer(), id, option)
	RefreshLegalActions()
end

function AddSmallGovInfo(a, b, c)
	local controlTable = m_BasicLegalInfo_IM:GetInstance();
	controlTable.MainInfo:SetText(a or "")
	controlTable.DataInfo:SetText(b or "")
	controlTable.BasicLegalInfoBox:SetToolTipString(c or "")
end

function IsMinorThenIcon(aPlayer)
	if Players[aPlayer]:IsMinorCiv() then
		return "[ICON_CITY_STATE] "
	end
	return ""
end

function RefreshLegalActions()
	Controls.PurchaseLegal:SetHide(true)
	Controls.PurchaseLegalWithFaith:SetHide(true)

	LuaEvents.ITGSG_RequestGT(2);
	local gData = MapModData.ITGSG;
	local apldft = MapModData.ITGSG2;
	local codexTT = MapModData.ITGSG3;
	MapModData.ITGSG3 = nil;
	MapModData.ITGSG2 = nil;
	MapModData.ITGSG = nil;
	if not gData then
		return
	end
    local iPlayer = Game.GetActivePlayer();
    local pPlayer = Players[ iPlayer ];
    if not gData.Players[iPlayer] then
		return;
	end
	m_BasicLegalInfo_IM:ResetInstances()
	AddSmallGovInfo("Legal Power:", gData.Players[iPlayer].LegalPower .. "[ICON_ITG_LEGAL_POWER]", "Stored [ICON_ITG_LEGAL_POWER] Legal Power.")
	AddSmallGovInfo("Happiness:", gData.Players[iPlayer].LHapAvailableToUse .. "[ICON_HAPPINESS_1]", "Legal Power from current [ICON_HAPPINESS_1] Happiness.")
	local total = gData.Players[iPlayer].LHapAvailableToUse + gData.Players[iPlayer].LegalPower; -- using below!
	AddSmallGovInfo("Total:", total .. "[ICON_HAPPINESS_1][ICON_ITG_LEGAL_POWER]", "Total amount of Legal Power available.[NEWLINE]If possible [ICON_HAPPINESS_1] Happiness is spend first.")

	if gData.Players[iPlayer].FreeLaws > 0 then
		AddSmallGovInfo("Free Laws:", "[COLOR_POSITIVE_TEXT]" .. gData.Players[iPlayer].FreeLaws, "Amount of Laws you can change without using [ICON_ITG_LEGAL_POWER] Legal Power.")
	end
	local govTTnow = "Current goverment is " .. Locale.Lookup(gData.Players[iPlayer].GovString) .. "."
	if gData.Players[iPlayer].Goverment == 1 then
		govTTnow = "Our empire is in Anarchy now! We should centralize power in your humble hands as soon as possible, restoring " .. hTextureTab[gData.Players[iPlayer].GovermentBeforeAnarchy][5] .. ".";
	elseif gData.Players[iPlayer].RevolutionGoverment then
		govTTnow = "You have reformed our empire into " .. Locale.Lookup(gData.Players[iPlayer].GovString) .. "."
	end
	AddSmallGovInfo("Goverment:", Locale.Lookup(gData.Players[iPlayer].GovString), govTTnow)
	
	if gData.Players[iPlayer].HasCodex then
		AddSmallGovInfo(Players[iPlayer]:GetName() .. "'s Codex")
		AddSmallGovInfo("[ICON_BULLET]Date:", gData.Players[iPlayer].CodexDate)
		AddSmallGovInfo("[ICON_BULLET]Strength:", gData.Players[iPlayer].CodexStrength .. "%[ICON_ITG_CODEX]","Every five turns legislators compare all world laws and determine [ICON_ITG_CODEX] strength of invidual Codexes based on global popularity of its laws.")
		AddSmallGovInfo("[ICON_BULLET]Legal:", 0.03 + 0.01 * (math.floor(gData.Players[iPlayer].CodexStrength / 20)) .. "[ICON_ITG_LEGAL_POWER]","+0.03 [ICON_ITG_LEGAL_POWER] Legal Power from base and +0.01 [ICON_ITG_LEGAL_POWER] Legal Power per 20% [ICON_ITG_CODEX] strength.")
		AddSmallGovInfo("[ICON_BULLET]Authority:", gData.Players[iPlayer].AuthorityCodex .. "[ICON_ITG_AUTHORITY]", "Codex increases [ICON_ITG_AUTHORITY] Authority by 1 per 40% [ICON_ITG_CODEX] strength. You gain extra +1 [ICON_ITG_AUTHORITY] Authority if no other known player has [ICON_ITG_CODEX] stronger Codex.")
		AddSmallGovInfo("[ICON_BULLET]Laws:", codexTT[3], codexTT[4])
	elseif gData.Players[iPlayer].CodexDiscount then
		AddSmallGovInfo("Codex Discount", -gData.Players[iPlayer].CodexDiscount .. "[ICON_ITG_LEGAL_POWER]", "Cost of creating Codex is reduced with every Law changed or by special abilities. The cost cannot drop below 3.")
	end
	AddSmallGovInfo("[ICON_BULLET]Influence:", codexTT[1] .. "%[ICON_ITG_LAWS_INFLUENCE]", codexTT[2])


	AddSmallGovInfo("Pledges of Protection", #gData.Players[iPlayer].PledgesOfProtection .. "/" .. gData.Players[iPlayer].NumMaxPledges, "Number of used/available Pledges of Protection")
	for i, v in pairs(gData.Players[iPlayer].PledgesOfProtection) do
		local sh;
		if not v[3] then
			sh = "City-State was bullied in last 10 turns, we are not receiving extra bonuses from protection.[NEWLINE]"
		else
			sh = "Bonuses from protection are now active.[NEWLINE]"
		end
		AddSmallGovInfo("[ICON_BULLET]Protecting:", Players[v[1]]:GetName(), sh .. "Protecting since " .. GetTextDate(v[2], gData.Globals.StartDate, true) .. ".")
	end
	if gData.Players[iPlayer].ForeignReserve then
		AddSmallGovInfo("Foreign reserve:", Players[gData.Players[iPlayer].ForeignReserve]:GetCivilizationAdjective(), "Having reserves in foreign currency reduces negative effects of having your currency counterfeited or mint lost. However you are slightly affected whenever this foreign currency is countrefeited.")
	end
	local olcCity;
	for i, v in pairs(Players) do
		for iCity in v:Cities() do
			if iCity:IsOriginalMajorCapital() then
				if iCity:GetOriginalOwner() == iPlayer then
					olcCity = iCity;
					break;
				end
			end
		end
	end
	if olcCity then
		local tt = ""
		if olcCity:GetOwner() == iPlayer then
			tt = olcCity:GetName() .. " is your legal Capital."
		else
			tt = "You don't own your legal Capital, " .. olcCity:GetName() .. " is currently occupied by " .. Players[olcCity:GetOwner()]:GetName() .. "."
		end
		AddSmallGovInfo("Capital:", olcCity:GetName(), tt)
	end
	local sphjk = gData.Players[iPlayer].StAlphabet;
	if sphjk ~= -1 then
		if sphjk == iPlayer then
			local sTTalph = "Increases [ICON_ITG_PRESENCE] National Cultural Presence anchor by 50.";
			local alphT = {};
			for agh, aghdata in pairs(gData.Players) do
				if (aghdata.StAlphabet == iPlayer) and (iPlayer ~= agh) then
					table.insert(alphT, agh);
				end
			end
			if #alphT > 0 then
				sTTalph = sTTalph .. "[NEWLINE]Your Cities have +10 [ICON_ITG_CHARM] Charm for foreign Great People using your Alphabet and +10 [ICON_TRADE_WHITE] Trade Appeal for foreign Trade-Routes from Cities which use your Alphabet. [ICON_INFLUENCE] Influence decay rate is reduced by 20% and recovery is increased by 20% in City-States which use your Alphabet.[NEWLINE][NEWLINE]List of civilizations using your alphabet:"  
				for jij, aPlayer in pairs(alphT) do
					sTTalph = sTTalph .. "[NEWLINE][ICON_BULLET]" .. IsMinorThenIcon(aPlayer) .. Players[aPlayer]:GetCivilizationShortDescription()
				end
			end
			AddSmallGovInfo("Alphabet:", Players[sphjk]:GetCivilizationAdjective(), sTTalph)
		else
			AddSmallGovInfo("Alphabet:", Players[sphjk]:GetCivilizationAdjective(), "Your Trade-Routes and Great People have increased chance to choose " .. Players[sphjk]:GetCivilizationAdjective() .. " cities as their destination.")
		end
	end
	if gData.Players[iPlayer].NationalDays > 0 then
		local strToolTip = "Established National Days increase [ICON_ITG_NAT_UNITY] National Unity and chance for new [ICON_ITG_FESTIVAL] Festival:"
		for ajd, bbd in pairs(gData.Players[iPlayer].NatDays) do
			strToolTip = strToolTip .. "[NEWLINE][ICON_BULLET]" .. GetNationalDayDate(bbd)
		end
		strToolTip = strToolTip .. "[NEWLINE][NEWLINE]By seasons:"
		for akj, jnd in pairs(gData.Players[iPlayer].NatSeasons) do
			strToolTip = strToolTip .. "[NEWLINE][ICON_BULLET]" .. SeasonTableName[akj] .. ": [COLOR_POSITIVE_TEXT]" .. jnd .. "[ENDCOLOR]"
		end
		AddSmallGovInfo("National Days:",  gData.Players[iPlayer].NationalDays, strToolTip)
	end
	if gData.Players[iPlayer].LegalAuthorityCost ~= -1 then
		Controls.PurchaseLegal:SetHide(false)
		Controls.PurchaseLegalLabel:SetText("1[ICON_ITG_LEGAL_POWER]/" .. gData.Players[iPlayer].LegalAuthorityCost .. "[ICON_GOLD]")
		Controls.PurchaseLegal:SetDisabled(gData.Players[iPlayer].LegalAuthorityCost > Players[iPlayer]:GetGold())
	end
	if gData.Players[iPlayer].LFcost ~= -1 then
		Controls.PurchaseLegalWithFaith:SetHide(false)
		Controls.FaithLegalLabel:SetText("1[ICON_ITG_LEGAL_POWER]/" .. gData.Players[iPlayer].LFcost .. "[ICON_PEACE]")
		Controls.PurchaseLegalWithFaith:SetDisabled(gData.Players[iPlayer].LFcost > Players[iPlayer]:GetFaith())
	end

	local bHasFreeLaw = gData.Players[iPlayer].FreeLaws > 0;
	m_Actions_IM:ResetInstances();
	m_Laws_IM:ResetInstances();
	if bShowActions then
		for i, action in pairs(apldft) do
			local instance = m_Actions_IM:GetInstance();
			instance.Type:SetText("Action")
			instance.Name:SetText(action.Name)
			if action.CD then
				instance.CostLabel:SetText(action.CD .. "T")
				instance.ActButton:SetDisabled(true)
			else
				if action.OnlyLegal then
					if action.TriggerUnhap then
						instance.CostLabel:SetText(action.Cost .. "[ICON_ITG_LEGAL_POWER]" .. action.TriggerUnhap .. "[ICON_HAPPINESS_4]")
					else
						instance.CostLabel:SetText(action.Cost .. "[ICON_ITG_LEGAL_POWER]")
					end
					instance.ActButton:SetDisabled(action.Cost > gData.Players[iPlayer].LegalPower)
				else
					instance.CostLabel:SetText(action.Cost .. "[ICON_HAPPINESS_1][ICON_ITG_LEGAL_POWER]")
					instance.ActButton:SetDisabled(action.Cost > total)
				end
			end
			instance.Help:SetText(action.Help)
			instance.ActButton:SetVoid1(action.ID)
			instance.ActButton:RegisterCallback(Mouse.eLClick, OnActionClicked);

			local buttonWidth, buttonHeight = instance.Button:GetSizeVal();
			local descWidth, descHeight = instance.Help:GetSizeVal();
			local newHeight = descHeight + 50;	
			instance.Button:SetSizeVal(buttonWidth, newHeight);
			instance.Box:SetSizeVal(buttonWidth, newHeight);
			instance.BounceAnim:SetSizeVal(buttonWidth, newHeight + 5);
			instance.BounceGrid:SetSizeVal(buttonWidth, newHeight + 5);
		end
	end
	local bHasCodex = gData.Players[iPlayer].HasCodex;
	if bShowLaws then
		local alphaLaw = 1;
		if gData.Players[iPlayer].Goverment == 1 then
			alphaLaw = 0.5;
		end
		LuaEvents.ITGSG_RequestAvailableLaws(iPlayer);
		local pAvailableLaws = MapModData.ITGSG;
		MapModData.ITGSG = nil;
		for itAL, jLawID in pairs(pAvailableLaws) do
			LuaEvents.ITGSG_LawData(jLawID);
			local data = MapModData.ITGSG
			MapModData.ITGSG = nil;

			local instance = m_Laws_IM:GetInstance();
			gtth = instance;

			instance.Button:SetAlpha(alphaLaw);
			instance.Type:SetText("Law")
			instance.Name:SetText(Locale.Lookup(data.Description))
			instance.Help:SetText(Locale.Lookup(data.Help))
			if bHasFreeLaw then
				instance.LawCost:SetText("[COLOR_POSITIVE_TEXT]FREE[ENDCOLOR]")
			else
				instance.LawCost:SetText("1[ICON_ITG_LEGAL_POWER]")
			end	
			local bMultiple = data.NumOptions > 1;
			for j = 1, 5 do
				if j <= data.NumOptions then
					instance["LawwButton" .. j]:SetHide(false);
					local text = Locale.Lookup("TXT_KEY_ITG_LAW_" .. jLawID .. "_OPTION_" .. j)
					local tooltipstring = text;
					local colour;
					if gData.Players[iPlayer].Laws[data.ID][1] == j then
						colour = "[COLOR_POSITIVE_TEXT]"
						tooltipstring = tooltipstring .. "[NEWLINE][NEWLINE]Click here to remove this law."
					elseif bMultiple then
						tooltipstring = tooltipstring .. "[NEWLINE][NEWLINE]Enacting this option will deactive any current one."
					end
					local bDisabled = false;
					if gData.Players[iPlayer].Laws[data.ID][2] == gData.ITGTurn then
						bDisabled = true;
						tooltipstring = tooltipstring .. "[NEWLINE][NEWLINE]Same law cannot be changed twice in one turn."
					elseif gData.Players[iPlayer].LegalPower < 1 then
						bDisabled = true;
					end
					instance["LawwButton" .. j]:SetDisabled(bDisabled)
					if not colour and bDisabled then
						colour = "[COLOR_GREY]"
					end
					instance["LawwButton" .. j]:SetVoid1( data.ID );
					instance["LawwButton" .. j]:SetVoid2( j );
					instance["LawwButton" .. j]:RegisterCallback(Mouse.eLClick, OnLawClicked);

					if colour then
						text = colour .. text .. "[ENDCOLOR]"
					end
					instance["LawwButton" .. j]:SetToolTipString(tooltipstring)
					instance["LawLabelText" .. j]:SetText(text)
				else
					instance["LawwButton" .. j]:SetHide(true);
				end 
			end
			instance.LawMainStack:CalculateSize();
			local buttonWidth, buttonHeight = instance.Button:GetSizeVal();
			local descWidth, descHeight = instance.LawMainStack:GetSizeVal();

			local newHeight = descHeight + 20;	
			instance.Button:SetSizeVal(buttonWidth, newHeight);
			instance.Box:SetSizeVal(buttonWidth, newHeight);
			instance.BounceAnim:SetSizeVal(buttonWidth, newHeight + 5);
			instance.BounceGrid:SetSizeVal(buttonWidth, newHeight + 5);
		end
	end
	--instances
	Controls.LegalActionStack:CalculateSize();
	Controls.LawsStack:CalculateSize();
	Controls.MainStack:CalculateSize();
    Controls.ScrollPanel:CalculateInternalSize();
    Controls.ScrollPanel:ReprocessAnchoring();

end
g_Tabs["LegalActions"].RefreshContent = RefreshLegalActions;

function OnHideLaws( bIsChecked )
	bShowLaws = bIsChecked;
	TabSelect("LegalActions")
end
function OnHideActions( bIsChecked )
	bShowActions = bIsChecked;
	TabSelect("LegalActions")
end
Controls.HideLawsCheck:RegisterCheckHandler( OnHideLaws );
Controls.HideActionsCheck:RegisterCheckHandler( OnHideActions );

function OnShowWholeTree( bIsChecked )
	bShowWholeTree = bIsChecked;
	PopulateGovermentData()
end
Controls.ShowWholeTreeCheck:RegisterCheckHandler( OnShowWholeTree );

function SortFunctionForLowestMapDistance(a, b)
	local va = (a ~= nil and a[2] ~= nil) and a[2] or -1;
	local vb = (b ~= nil and b[2] ~= nil) and b[2] or -1;
	return tonumber(va) < tonumber(vb);
end

function RefreshGoverments()
	PopulateGovermentData()
end
g_Tabs["Goverment"].RefreshContent = RefreshGoverments;

function GetColouredCurrentMeritocracy(val)
	if val < 20 then
		return "[COLOR_NEGATIVE_TEXT]" .. val .. "[ICON_ITG_MERITOCRACY][ENDCOLOR]"
	elseif val < 40 then
		return "[COLOR_YIELD_FOOD]" .. val .. "[ICON_ITG_MERITOCRACY][ENDCOLOR]"
	elseif val < 60 then
		return "[COLOR_YELLOW]" .. val .. "[ICON_ITG_MERITOCRACY][ENDCOLOR]"
	elseif val < 80 then
		return "[COLOR_POSITIVE_TEXT]" .. val .. "[ICON_ITG_MERITOCRACY][ENDCOLOR]"
	else
		return "[COLOR_GREEN]" .. val .. "[ICON_ITG_MERITOCRACY][ENDCOLOR]"
	end
end

function GetColouredMeritocracyPT(val)
	if val > 0 then
		return "([COLOR_POSITIVE_TEXT]+" .. val .. "[ENDCOLOR])";
	elseif val < 0 then
		return "([COLOR_NEGATIVE_TEXT]" .. val .. "[ENDCOLOR])";
	else
		return "([COLOR_YELLOW]+" .. val .. "[ENDCOLOR])";
	end
end

local govTreeTextures = {
"GovTree1.dds",
"GovTree2.dds",
"GovTree3.dds",
"GovTree4.dds",
"GovTree5.dds",
}

local coloursLines = {
{Red = 26/255, Green = 84/255, Blue = 77/255, Alpha = 1},
{Red = 26/255, Green = 120/255, Blue = 90/255, Alpha = 0.4},
}
function RedefineTree(c)
	coloursLines = c;
	PopulateGovermentData();
end

function DrawALine(x1, y1, x2, y2, color)
	local lineSegment = g_LineSegment:GetInstance();
	lineSegment.LineSegment:SetStartVal(x1 + 12, y1 + 12);
	lineSegment.LineSegment:SetEndVal(x2 + 12, y2 + 12);
	lineSegment.LineSegment:SetColorVal(color.Red, color.Green, color.Blue, color.Alpha);
end

function DoFillGovSlot(slotID)
	if Players[Game.GetActivePlayer()]:IsTurnActive() then
		LuaEvents.ITG_PushLegalActionIfPossible(Game.GetActivePlayer(), 33, slotID)
	end
end

function PopulateGovermentData()
	LuaEvents.ITGSG_RequestGT(2);
	local gData = MapModData.ITGSG;
	MapModData.ITGSG = nil;
	if not gData then
		return
	end
	local iPlayer = Game.GetActivePlayer();
	local govType = gData.Players[iPlayer].Goverment
	Controls.HelpImageId2:SetTexture(hTextureTab[govType][1])
	Controls.HelpImageId2:SetTextureOffset(Vector2(hTextureTab[govType][2],hTextureTab[govType][3]))
	Controls.HelpImageId2:SetAlpha(hTextureTab[govType][4])
	
	Controls.GovermentName:SetText(string.upper(hTextureTab[govType][5]))


	for letter, value in pairs(gData.Players[iPlayer].Ideologies) do
		Controls["GovInfoLabel" .. letter]:SetText(value)
	end

	m_BasicGovInfo_IM:ResetInstances()
	LuaEvents.ITGSG_RequestMeritocracyData(iPlayer);
	local mData = MapModData.ITGSG;
	MapModData.ITGSG = nil;
	Controls.MeritocracyBox:SetToolTipString(mData.ToolTip)
	Controls.MeritocracyMeter:SetPercent( gData.Players[iPlayer].MeritocracyLevel / 100 )
	Controls.MeritoBoxLabel:SetText("MERITOCRACY: " .. GetColouredCurrentMeritocracy(gData.Players[iPlayer].MeritocracyLevel) .. GetColouredMeritocracyPT(mData.PerTurn))
	local numslots = 1;
	for slot, d in pairs(gData.Players[iPlayer].GovSlots) do
		numslots = numslots + 1;
	end
	Controls.GovImageTree:SetTexture(govTreeTextures[math.min(5, numslots)])
	for i, v in pairs(mData.MiniInfos) do
		cInstance = m_BasicGovInfo_IM:GetInstance();
		cInstance.GovStackTitle:SetText(v.Txt1);
		cInstance.GovStackTitle:SetToolTipString(v.ToolTip1 or v.ToolTip1);
		cInstance.GovStackLabel:SetText(v.Txt2);
		cInstance.GovStackLabel:SetToolTipString(v.ToolTip2 or v.ToolTip1);
		cInstance.GovStackMaxLabel:SetText(v.Txt3);
		cInstance.GovStackMaxLabel:SetToolTipString(v.ToolTip3 or v.ToolTip1);
		cInstance.GovStackMaxDiv:SetHide(v.Txt3 == "");
	end
	Controls.GovInfoStack1:CalculateSize()
	Controls.BoxGovInfo1:SetSizeY(math.max(100, 92 + Controls.GovInfoStack1:GetSizeY()))
	Controls.GovInfoStack1Bg:SetSizeY(math.max(100, 92 + Controls.GovInfoStack1:GetSizeY()))
--
--	
--	
	g_GovTenets:ResetInstances()
	g_LineSegment:ResetInstances()
	LuaEvents.ITGSG_RequestGovermentTree(iPlayer, bShowWholeTree);
	local govt = MapModData.ITGSG;
	local bCanAfford = MapModData.ITGSG2;
	MapModData.ITGSG = nil;
	MapModData.ITGSG2 = nil;
	for i, v in pairs(govt[2]) do
		DrawALine(v.X1, v.Y1, v.X2, v.Y2, coloursLines[v.Type])
	end
	for i, v in pairs(govt[1]) do
		local instance = g_GovTenets:GetInstance();
		instance.PolicyIcon:SetOffsetVal(v.x -4, v.y - 4);
		instance.PolicyIcon:SetDisabled((v.Showcase == 3) or ((not bCanAfford) and (v.Showcase == 2)));
		instance.PolicyImage:SetHide(v.Showcase ~= 1);
		instance.PolicyIcon:SetToolTipString(v.ToolTip);
		IconHookup( v.PortraitIndex, 32, v.IconAtlas, instance.PolicyImage );
		instance.PolicyIcon:SetVoid1(v.ID);
		if v.Showcase == 1 then
			instance.PolicyIcon:RegisterCallback(Mouse.eLClick, function() end);
		else
			instance.PolicyIcon:RegisterCallback(Mouse.eLClick, DoFillGovSlot);
		end
	end
	
	Controls.Hvvid1:SetToolTipString(mData.GovToolTip)

	LuaEvents.ITGSG_RequestPrincipleTT(iPlayer);
	local principleData = MapModData.ITGSG;
	MapModData.ITGSG = nil;
	Controls.PrinciplesNumButton:SetToolTipString(principleData[2])
	Controls.PrinciplesNumButton:SetHide(principleData[3])
	Controls.PrinciplesNumLabel:SetText(principleData[1])
end

function OnCitySelected(index)
	UI.LookAt(Map.GetPlotByIndex(index));
end

function RefreshBeliefs()
	m_Cities_IM:ResetInstances()
	LuaEvents.ITGSG_RequestGT();
	local gData = MapModData.ITGSG;
	MapModData.ITGSG = nil;
	if not gData then
		return
	end
	local iPlayer = Game.GetActivePlayer();
	
	local function AddNewCity(iCity)
		local controlTable = m_Cities_IM:GetInstance();
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		controlTable.CityName:SetText(iCity:GetName())
		LuaEvents.ITGSG_RequestCityCultureOwnership(iCity:Plot():GetPlotIndex(), cID);
		local ghh = MapModData.ITGSG;
		MapModData.ITGSG = nil;
		local iOwner = iCity:GetOwner();
		local iOrigin = iCity:GetOriginalOwner()
		if iPlayer == iOwner then
			LuaEvents.ITGSG_RequestCityGovernshipString(iPlayer, cID);
			controlTable.GovName:SetText(MapModData.ITGSG);
			MapModData.ITGSG = nil;
		else
			controlTable.GovName:SetText("N/A")
		end
		local iCulture = ghh.COwner
		CivIconHookup( iOwner, 32, controlTable.Icon, controlTable.CivIconBG, controlTable.CivIconShadow, false, true);  
		CivIconHookup( iOrigin, 32, controlTable.Icon2, controlTable.CivIconBG2, controlTable.CivIconShadow2, false, true);  
		CivIconHookup( iCulture, 32, controlTable.Icon3, controlTable.CivIconBG3, controlTable.CivIconShadow3, false, true); 
		controlTable.BoxImageID3:SetToolTipString(ghh.ToolTip)
		controlTable.BoxImageID3:SetAlpha(ghh.Alpha)
		controlTable.Button:SetVoid1( iCity:Plot():GetPlotIndex() );
		controlTable.Button:RegisterCallback(Mouse.eLClick, OnCitySelected);
		local eReligion = iCity:GetReligiousMajority();
		if (eReligion >= 0) then
			controlTable.BoxImageID4:SetHide(false)
			local religion = GameInfo.Religions[eReligion];
			IconHookup( religion.PortraitIndex, 32, religion.IconAtlas, controlTable.Icon4 );
			IconHookup( religion.PortraitIndex, 32, religion.IconAtlas, controlTable.CivIconShadow4 );
			controlTable.BoxImageID4:SetToolTipString(GetReligionTooltip(iCity))
		else
			controlTable.BoxImageID4:SetHide(true)
		end	
	end
	for iCity in Players[iPlayer]:Cities() do
		AddNewCity(iCity)
	end
	local aTeam = Game.GetActiveTeam()
	for g, h in pairs(gData.Players) do
		if g ~= iPlayer then
			for iCity in Players[g]:Cities() do
				if iCity:Plot():IsRevealed(aTeam) then
					if iCity:GetOriginalOwner() == iPlayer then
						AddNewCity(iCity)
					else
						local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
						if gData.Cities[cID].CultureOwner == iPlayer then
							AddNewCity(iCity)
						end
					end
				end
			end
		end
	end
    Controls.COMainStack:CalculateSize();
    Controls.COMainStack:ReprocessAnchoring();
    Controls.COScrollPanel:CalculateInternalSize();
end
g_Tabs["Beliefs"].RefreshContent = RefreshBeliefs;

function RefreshWonders()
end
g_Tabs["Palaces"].RefreshContent = RefreshWonders;

-- Updates the sort option structure

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function ShowHideHandler( bIsHide, bInitState )
	CivIconHookup( 0, 64, Controls.Icon, Controls.CivIconBG, Controls.CivIconShadow, false, true );
    if( not bInitState ) then
        if( not bIsHide ) then
        	UI.incTurnTimerSemaphore();  
        	Events.SerialEventGameMessagePopupShown(g_PopupInfo);
        	
        	TabSelect(g_CurrentTab);
        else
			if(g_PopupInfo ~= nil) then
				Events.SerialEventGameMessagePopupProcessed.CallImmediate(99392, 0);
            end
            UI.decTurnTimerSemaphore();
        end
    end
end
ContextPtr:SetShowHideHandler( ShowHideHandler );

----------------------------------------------------------------
-- 'Active' (local human) player has changed
----------------------------------------------------------------
function OnActivePlayerChanged()
	--if (not Controls.ChooseConfirm:IsHidden()) then
	--	Controls.ChooseConfirm:SetHide(true);
	--end
end
Events.GameplaySetActivePlayer.Add(OnActivePlayerChanged);

-----------------------------------------------------------------
ContextPtr:SetHide(true)
TabSelect("LegalActions");

Controls.HelpImageId1:SetAlpha(0.7)
Controls.GovInfoStack1Bg:SetAlpha(0.5)
Controls.GovInfoStack2Bg:SetAlpha(0.5)
Controls.Hvvid1:SetAlpha(0.5)
Controls.PrinciplesImage:SetColor({x = 0.4, y= 0.7, z = 0.7, w= 1})