include( "InstanceManager" );
include( "IconSupport" );
include( "SupportFunctions" );
include( "ITGSG_AchievementDB.lua" )
include( "ITGSG_ModUserData.lua" )

-- Global Constants
local g_InstanceManager = InstanceManager:new( "LoadButton", "InstanceRoot", Controls.LoadFileButtonStack );
local g_ACompactInstance = InstanceManager:new( "AchievementCompactInstance", "RootButton", Controls.StackCompact );

local achievData = GetAchieveTab()
local tViewTab = {"Normal", "Compact"}
g_InstanceList = {}
local cIndexSel;
local cType = MUD_Get("ACH_BROWSER_VIEW_TYPE") or 1;
local ProgressIconT = {
{100, "LEADER_ATLAS", 17},
{99, "LEADER_ATLAS", 11},
{97, "EXPANSION2_UNIT_ATLAS", 12},
{95, "UNIT_ATLAS_1", 29},
{93, "EXPANSION2_UNIT_ATLAS", 20},
{90, "LEADER_ATLAS", 9},
{88, "LEADER_ATLAS",13},
{85, "EXPANSION2_UNIT_ATLAS", 6},
{82, "LEADER_ATLAS",15},
{80, "LEADER_ATLAS", 7},
{78, "EXPANSION_LEADER_ATLAS",7},
{75, "UNIT_ATLAS_2", 45},
{72, "EXPANSION_LEADER_ATLAS",6},
{70, "LEADER_ATLAS", 5},
{68, "EXPANSION_LEADER_ATLAS",3},
{65, "UNIT_ATLAS_2", 48},
{62, "EXPANSION_LEADER_ATLAS",5},
{60, "GENGHIS_LEADER_ATLAS", 0},
{58, "EXPANSION_LEADER_ATLAS",2},
{55, "UNIT_ATLAS_2", 47},
{52, "EXPANSION_LEADER_ATLAS",1},
{50, "LEADER_ATLAS", 16},
{48, "EXPANSION2_LEADER_ATLAS",8},
{45, "UNIT_ATLAS_2", 46},
{42, "EXPANSION2_LEADER_ATLAS",6},
{40, "EXPANSION_LEADER_ATLAS", 4},
{38, "EXPANSION2_LEADER_ATLAS",5},
{35, "UNIT_ATLAS_1", 10},
{32, "EXPANSION2_LEADER_ATLAS",2},
{30, "EXPANSION_LEADER_ATLAS", 0},
{28, "EXPANSION2_LEADER_ATLAS",7},
{25, "UNIT_ATLAS_1", 37},
{22, "EXPANSION2_LEADER_ATLAS",4},
{20, "EXPANSION_LEADER_ATLAS", 8},
{18, "EXPANSION2_LEADER_ATLAS",0},
{15, "GENGHIS_UNIT_ATLAS", 0},
{12, "EXPANSION2_LEADER_ATLAS", 3},
{10, "LEADER_ATLAS", 8},
{8, "EXPANSION2_UNIT_ATLAS", 3},
{5, "EXPANSION2_UNIT_ATLAS", 9},
{3, "LEADER_ATLAS", 20},
{1, "EXPANSION2_UNIT_ATLAS", 10},
}

-- Global Variables
----------------------------------------------------------------        
----------------------------------------------------------------        
----------------------------------------------------------------        
---------------------------------------------------------------- 

function GetImageBasedOnProgress(iDone, iTotal)
	local percent = math.floor((iDone * 100) / iTotal)
	for i, v in pairs(ProgressIconT) do
		if v[1] <= percent then
			return v[2], v[3]
		end
	end
	return "UNIT_ATLAS_1", 25;
end

     
function OnBack()
    UIManager:DequeuePopup( ContextPtr );
end
Controls.BackButton:RegisterCallback( Mouse.eLClick, OnBack );

----------------------------------------------------------------        
----------------------------------------------------------------        
function SetSelected( index )
	if not achievData[index] then
		return;
	end

	Controls.AchievementName:SetText(string.upper(achievData[index].Name))
	Controls.AchievementHelp:SetText(achievData[index].Help)
	if achievData[index].Count then
		Controls.AchievementCount:SetText("Progress: " .. (MUD_Get("ACHIEV_" .. index .. "_COUNT") or 0) .. "/" .. achievData[index].Count)
	else
		Controls.AchievementCount:SetText("")
	end
	local isDone = MUD_Get("ACHIEV_" .. index);
	if isDone then
		Controls.Date:SetText(isDone)
		if achievData[index].IconAtlas then
			IconHookup( achievData[index].PortIndex, 80, achievData[index].IconAtlas, Controls.AchievementImage );
			IconHookup( achievData[index].PortIndex, 80, achievData[index].IconAtlas .. "_DARK", Controls.AchievementImageDark );
		else
			IconHookup( 3, 80, "ACHIEVEMENT_ITG_ATLAS_1", Controls.AchievementImage );
			IconHookup( 3, 80, "ACHIEVEMENT_ITG_ATLAS_1_DARK", Controls.AchievementImageDark );
		end
		Controls.AchievementGrid:SetHide(false)
	else
		Controls.Date:SetText("")
		Controls.AchievementGrid:SetHide(true)
	end
	if cIndexSel then
		g_InstanceList[cIndexSel].SelectHighlight:SetHide(true)
	end
	cIndexSel = index
	g_InstanceList[index].SelectHighlight:SetHide(false)
end

----------------------------------------------------------------        
---------------------------------------------------------------- 
function DoScrollPDEntry(control, name, void)
	local controlTable = {};
	control:BuildEntry( "InstanceOne", controlTable );
	controlTable.Button:SetVoid1(void);
	controlTable.Button:SetText(name);
end
----------------------------------------------------------------        
----------------------------------------------------------------        
function SetupFileButtonList()
	Controls.AchievementViewPullDown:ClearEntries();
	for i, text in pairs(tViewTab) do
		DoScrollPDEntry(Controls.AchievementViewPullDown,text, i)
	end
	Controls.AchievementViewPullDown:CalculateInternals();
	UpdateTheList(cType)
	Controls.AchievementViewPullDown:GetButton():SetText(tViewTab[cType])
	UpdateTheList(cType)
end

function UpdateTheList(iType)
	Controls.ScrollPanelCompact:SetHide(iType == 1)
	Controls.dde12:SetHide(iType == 1)
	Controls.BoxNormalViewScroll:SetHide(iType == 2)
	Controls.DetailsBox:SetHide(iType == 2)
	Controls.AchievementGrid:SetHide(iType == 2)
	local iDone = 0;
	if iType == 1 then
		g_InstanceManager:ResetInstances();
		for i, v in pairs(achievData) do
			local controlTable = g_InstanceManager:GetInstance();
			controlTable.ButtonText:SetText(v.Name);
			controlTable.Button:SetVoid1( i );
			local isDone = MUD_Get("ACHIEV_" .. i);
			if isDone then
				iDone = iDone + 1;
				controlTable.Button:SetAlpha(1)
			else
				controlTable.Button:SetAlpha(0.5)
			end
			controlTable.SelectHighlight:SetHide(true)
			controlTable.Button:RegisterCallback( Mouse.eLClick, SetSelected );
			table.insert(g_InstanceList, controlTable);
		end
		Controls.LoadFileButtonStack:CalculateSize();
		Controls.LoadFileButtonStack:ReprocessAnchoring();
		Controls.ScrollPanel:CalculateInternalSize();
		SetSelected( math.random(1,#achievData) )
	else
		g_ACompactInstance:ResetInstances();
		for i, v in pairs(achievData) do
			local controlTable = g_ACompactInstance:GetInstance();
			controlTable.Name:SetText(v.Name);
			controlTable.Help:SetText(v.Help);
			local isDone = MUD_Get("ACHIEV_" .. i);
			if v.IconAtlas then
				IconHookup( v.PortIndex, 80, v.IconAtlas, controlTable.AchievementImage );
				IconHookup( v.PortIndex, 80, v.IconAtlas .. "_DARK", controlTable.AchievementImageDark );
			else
				IconHookup( 3, 80, "ACHIEVEMENT_ITG_ATLAS_1", controlTable.AchievementImage );
				IconHookup( 3, 80, "ACHIEVEMENT_ITG_ATLAS_1_DARK", controlTable.AchievementImageDark );
			end
			if isDone then
				iDone = iDone + 1;
				controlTable.AnimGlowIcon:Play();
				controlTable.AchievementImageDark:Play();
				controlTable.AnimHL:Play();
			else
				controlTable.AnimGlowIcon:Stop();
				controlTable.AchievementImageDark:Stop();
				controlTable.AnimHL:Stop();
			end
			controlTable.AnimHL:SetHide(not isDone)
			controlTable.Date:SetText(isDone or "");

			controlTable.HelpBox:SetSizeY(math.max(controlTable.Help:GetSizeY() + 30, 50))
			controlTable.AnimGridHL:SetSizeY(math.max(controlTable.Help:GetSizeY() + 30, 50) + 34)
			controlTable.AnimHL:SetSizeY(math.max(controlTable.Help:GetSizeY() + 30, 50) + 32)
			controlTable.RootButton:SetSizeY(30 + controlTable.HelpBox:GetSizeY())
			--sizeY
			gHelpNow = controlTable;
		end
		Controls.StackCompact:CalculateSize();
		Controls.StackCompact:ReprocessAnchoring();
		Controls.ScrollPanelCompact:CalculateInternalSize();
	end
	SetMeterProgress(iDone, #achievData)
end

function AchievementViewPullDownSelect(gType)
	if cType ~= gType then
		cType = gType;
		Controls.AchievementViewPullDown:GetButton():SetText(tViewTab[cType])
		MUD_Save("ACH_BROWSER_VIEW_TYPE", gType)
		UpdateTheList(gType)
	end
end
Controls.AchievementViewPullDown:RegisterSelectionCallback(AchievementViewPullDownSelect); 

function SetMeterProgress(iDone, iTotal)
	Controls.ProgressMeter:SetPercent( iDone / iTotal );
	Controls.ProgressLabel:SetText( "Progress: " ..  iDone .. "/" .. iTotal );

	local atlas, index = GetImageBasedOnProgress(iDone, iTotal)
	IconHookup( index, 64, atlas, Controls.ProgressImage );
end

----------------------------------------------------------------        
-- Key Down Processing
----------------------------------------------------------------        
function InputHandler( uiMsg, wParam, lParam )
    if uiMsg == KeyEvents.KeyDown then
        if wParam == Keys.VK_ESCAPE then
	        OnBack();
        end
    end
    return true;
end
ContextPtr:SetInputHandler( InputHandler );

----------------------------------------------------------------        
----------------------------------------------------------------        
function ShowHideHandler(isHide)
    if( not isHide ) then
		SetupFileButtonList();
	end
end
ContextPtr:SetShowHideHandler( ShowHideHandler );