-------------------------------------------------
-- Military
-------------------------------------------------
include( "IconSupport" );
include( "ITGSG_AchievementDB.lua" )
include( "ITGSG_ModUserData.lua" )

local m_PopupInfo = nil;
local managerATD = {}
local achievData = GetAchieveTab()

-------------------------------------------------
-- On Popup
-------------------------------------------------
--[[function OnPopup( popupInfo )
	if( popupInfo.Type == 1972135 ) then
    	m_PopupInfo = popupInfo;
        if( ContextPtr:IsHidden() == false ) then    
        else
            UIManager:QueuePopup( ContextPtr, PopupPriority.InGameUtmost );
        end
	end
end
Events.SerialEventGameMessagePopup.Add( OnPopup ); ]]

function AchievementAcquiredRightNow(index)
	table.insert(managerATD, index)
--	if ContextPtr:IsHidden() then
	if Controls.AchievementGrid:IsHidden() then
		UpdateScreen()
		Controls.AchievementGrid:SetHide(false)
--		Events.SerialEventGameMessagePopup({Type = 1972135})
	elseif #managerATD == 1 then
		Controls.ProceedButton:SetText("NEXT")
	end
end

function AchievementCompleted(id)
	if achievData[id] then
		if not MUD_Get("ACHIEV_" .. id) then
			MUD_Save("ACHIEV_" .. id, os.date("%Y/%m/%d %H:%M:%S") or "000") -- save era, civ?
			AchievementAcquiredRightNow(id)
		end
	end
end
LuaEvents.ITG_AchievementCompleted.Add(AchievementCompleted)

LuaEvents.ITG_AchievementCountChange.Add(function(id, change)
	if achievData[id] then
		local cCount = MUD_Get("ACHIEV_" .. id .. "_COUNT") or 0;
		MUD_Save("ACHIEV_" .. id .. "_COUNT", cCount + change)
		if (cCount < achievData[id].Count) and (cCount + change >= achievData[id].Count) then
			AchievementCompleted(id)
		end
	end
end)

function ResetAllAchievements()
	for i, v in pairs(achievData) do
		MUD_Save("ACHIEV_" .. i, nil)
	end
end
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function OnClose()
	managerATD = {}
	Controls.AchievementGrid:SetHide(true)
--    UIManager:DequeuePopup( ContextPtr );
end

function OnProceed()
	if #managerATD > 0 then
		UpdateScreen()
	else
		OnClose()
		LuaEvents.ITGDoMRemovedCheckIfEndPanelOn(true)
	end
end
Controls.ProceedButton:RegisterCallback( Mouse.eLClick, OnProceed);
Controls.ModsButton:RegisterCallback( Mouse.eLClick, OnProceed);


LuaEvents.ITG_AnythingBlockEndEra.Add(function()
	if not Controls.AchievementGrid:IsHidden() then
		MapModData.ITGSG = true;
	end
end)
 
function GetFontBasedOnLenght(iLength)
	if iLength > 28 then
		if iLength > 32 then
			if iLength > 36 then
				if iLength > 38 then
					return "TwCenMT14";
				end
				return "TwCenMT16";
			end
			return "TwCenMT18";
		end
		return "TwCenMT20";
	end
	return "TwCenMT22";
end
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function UpdateScreen()
	if #managerATD == 0 then
		OnClose()
		return;
	end
	Controls.AchievementGrid:SetToolTipString("Achievement completed:[NEWLINE]" .. achievData[managerATD[1]].Help)
	Controls.AchieveText:SetText(string.upper(achievData[managerATD[1]].Name));
	Controls.AchieveText:SetFontByName(GetFontBasedOnLenght(string.len(achievData[managerATD[1]].Name)));
				
	if achievData[managerATD[1]].IconAtlas then
		IconHookup( achievData[managerATD[1]].PortIndex, 80, achievData[managerATD[1]].IconAtlas, Controls.AchievementImage );
		IconHookup( achievData[managerATD[1]].PortIndex, 80, achievData[managerATD[1]].IconAtlas .. "_DARK", Controls.AchievementImageDark );
	else
		IconHookup( 3, 80, "ACHIEVEMENT_ITG_ATLAS_1", Controls.AchievementImage );
		IconHookup( 3, 80, "ACHIEVEMENT_ITG_ATLAS_1_DARK", Controls.AchievementImageDark );
	end
	table.remove(managerATD, 1)
	if #managerATD > 0 then
		Controls.ProceedButton:SetText("NEXT")
	else
		Controls.ProceedButton:SetText("PROCEED")
	end
	Events.AudioPlay2DSound("AS2D_EVENT_NOTIFICATION_VERY_GOOD"); -- AS2D_INTERFACE_WONDER_COMPLETED would be nice as well
end
        
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
--[[
function ShowHideHandler( bIsHide, bInitState )
    if( not bInitState ) then
        if( not bIsHide ) then
        	UI.incTurnTimerSemaphore();
			UpdateScreen()
        	Events.SerialEventGameMessagePopupShown(m_PopupInfo);
        else
            UI.decTurnTimerSemaphore();
            Events.SerialEventGameMessagePopupProcessed.CallImmediate(1972135, 0);
        end
    end
end
ContextPtr:SetShowHideHandler( ShowHideHandler );
]]
----------------------------------------------------------------
-- 'Active' (local human) player has changed
----------------------------------------------------------------
Events.GameplaySetActivePlayer.Add(OnClose);
