-------------------------------------------------
-- Happiness Info
-------------------------------------------------
include( "IconSupport" );
include( "InstanceManager" );
local g_AuctionHouseManager = GenerationalInstanceManager:new( "MyOfferInstance", "Base", Controls.StackMyTrade);
local g_WorldOfferManager = GenerationalInstanceManager:new( "AvOfferInstance", "Base", Controls.StackOtherTrade);
local g_LogStockManager = GenerationalInstanceManager:new( "TransactionMessageInstance", "Base", Controls.IntrigueMessageStack);
local ltBlue = {19/255,32/255,46/255,120/255};
local dkBlue = {12/255,22/255,30/255,120/255};
local m_CurrentStock = 1;
local myOfferInstances = {}
local gCurrentResSelected = -1;
local cv1, cv2, cv3, cv4 = 0.25, 0.5, 0.33, 0.9;
function SetColour(a, b, c, d)
	cv1, cv2, cv3, cv4 = a, b, c, d
end
local AImanagementT = {
{Name = "Manual", Type = -1, Help = "Offer management is inactive."},
{Name = "Everything", Type = 1, Help = "Every single resource available will be put up for sale."},
{Name = "Everything 200+", Type = 9, Help = "Every single resource available that is priced at least 200 [ICON_GOLD] Gold will be put up for sale."},
{Name = "Keep a copy", Type = 4, Help = "Offer management will leave one copy of every luxury, rest will be put up for sale."},
{Name = "Keep a copy 200+", Type = 3, Help = "Offer management will leave one copy of every luxury, rest will be put up for sale. Resources with price lesser than 200 [ICON_GOLD] Gold will be ignored."},
{Name = "Low-key", Type = 5, Help = "Offer management will leave one copy of every luxury, and will put only one copy of certain luxury up for sale at a time."},
{Name = "Really low-key", Type = 6, Help = "Offer management will leave one copy of every luxury, and will put only one copy of certain luxury up for sale at a time. Resources with price lesser than 200 [ICON_GOLD] Gold will be ignored."},
{Name = "Variety", Type = 8, Help = "Offer management will put one copy of each luxury up for sale at a time."},
{Name = "Variety 200+", Type = 7, Help = "Offer management will put one copy of each luxury up for sale at a time. Resources with price lesser than 200 [ICON_GOLD] Gold will be ignored."},
}
-------------------------------------------------
-------------------------------------------------
function SortFunctionForLowestMapDistance(a, b)
	local va = (a ~= nil and a[2] ~= nil) and a[2] or -1;
	local vb = (b ~= nil and b[2] ~= nil) and b[2] or -1;
	return tonumber(va) < tonumber(vb);
end

function GetNewGraphSpecialDeal(id)
	LuaEvents.ITGSG_RequestSpecialDealGraphData(id)
	local gData = MapModData.ITGSG;
	MapModData.ITGSG = nil;
	if not gData then
		return;
	end
	local hMax = gData.Max;
	local hMin = gData.Min;
	if gData.Max < gData.Min then
		hMax = gData.Min;
		hMin = gData.Max;
	end
	hMax = hMax + 25;
	hMin = hMin - 25;
	local vsM = 120;
	Controls.BoxGraph:DestroyAllChildren();
	
	local instance = {};
	ContextPtr:BuildInstanceForControl( "GraphLineInstance", instance, Controls.BoxGraph );
	instance.LineSegment:SetColorVal(cv1, cv2, cv3, cv4);
	instance.LineSegment:SetStartVal(gData.T1 * 3, vsM - math.floor(vsM * (gData.P1 - hMin) / (hMax - hMin)));
	instance.LineSegment:SetEndVal(gData.T2 * 3, vsM - math.floor(vsM * (gData.P2 - hMin) / (hMax - hMin)));
	instance.LineSegment:SetHide(false);	
		
	Controls.BoxGraph:SetToolTipString("")
	Controls.VerticalLabel1:SetText(hMin)
	Controls.VerticalLabel2:SetText(hMax)
	Controls.ResourceGraphLabel:SetText("")
	Controls.BoxGraph2:SetHide(false)
end

function TakeCareOfGraph()
	if gCurrentResSelected == -1 then
		Controls.BoxGraph2:SetHide(true)
	else
		local hMax = 225;
		LuaEvents.ITGSG_RequestGT()
		local gData = MapModData.ITGSG;
		MapModData.ITGSG = nil;
		if not gData then
			return;
		end

		local grTab = {}

		local tab = {{"AuctionDealHistory", 0.8}, {"AuctionDeals", 1}}
		for i, tt in pairs(tab) do
			for a, b in pairs(gData.Globals[tt[1]]) do
				if b.Res == gCurrentResSelected then
					hMax = math.max(hMax, b.FullGold);
					table.insert(grTab, {b.FullGold,  b.TurnStart})
				end
			end
		end
		table.sort(grTab, SortFunctionForLowestMapDistance)
		local finData = {}
		local cT = -1;
		local tt = ""
		local dealstt = ""
		for a, b in pairs(grTab) do
			dealstt = dealstt .. "[NEWLINE][ICON_BULLET]" ..  b[1] .. " [ICON_GOLD] Gold in " .. b[2] .. "T.";
			if cT ~= b[2] then
				table.insert(finData, {b[1], b[2]})
				cT = b[2];
			else
				finData[#finData][1] = math.max(finData[#finData][1], b[1])
			end
		end
		if #finData > 0 then
			if cT ~= gData.ITGTurn then
				table.insert(finData, {gData.AuctionPrices[gCurrentResSelected], gData.ITGTurn})
				hMax = math.max(hMax, gData.AuctionPrices[gCurrentResSelected])
			end
		end
		Controls.BoxGraph:DestroyAllChildren();
		hMax = hMax + 25;
		local vsM = 120;
		local prevX, prevY;
		for i, dd in pairs(finData) do
			local instance = {};
			ContextPtr:BuildInstanceForControl( "GraphLineInstance", instance, Controls.BoxGraph );
			local cX, cY = dd[2] * 3, (vsM - math.floor(vsM * dd[1] / hMax));
			if not prevX then
				prevX = cX-1;
				prevY = cY;
			end
			instance.LineSegment:SetColorVal(cv1, cv2, cv3, cv4);
			instance.LineSegment:SetStartVal(prevX, prevY);
			instance.LineSegment:SetEndVal(cX, cY);
			instance.LineSegment:SetHide(false);	
			prevX = cX;
			prevY = cY;
		end
		if dealstt ~= "" then
			tt = "History of deals (" .. GameInfo.Resources[gCurrentResSelected].IconString .. " " .. Locale.Lookup(GameInfo.Resources[gCurrentResSelected].Description) .. "):" .. dealstt;
		else
			tt = "There is no logged deals so far."
		end
		tt = tt .. "[NEWLINE][NEWLINE]Current average price is: [COLOR_POSITIVE_TEXT]" .. gData.AuctionPrices[gCurrentResSelected] .. "[ENDCOLOR] [ICON_GOLD]."
		Controls.BoxGraph:SetToolTipString(tt)
		Controls.VerticalLabel1:SetText(0)
		Controls.VerticalLabel2:SetText(hMax)
		Controls.ResourceGraphLabel:SetText(GameInfo.Resources[gCurrentResSelected].IconString)
		Controls.BoxGraph2:SetHide(false)
	end
end

function GetNewGraphResource(iRes)
	gCurrentResSelected = iRes;
	TakeCareOfGraph()
end

function UpdateScreen(iType)
	Controls.MarketPanel:SetHide(m_CurrentStock ~= 1)
	Controls.DealsHistoryPanel:SetHide(m_CurrentStock ~= 2)
	if m_CurrentStock == 1 then
		UpdateMarketData()
	elseif m_CurrentStock == 2 then
		CallLogMessages()
	end
end

function CallLogMessages()
	local iPlayer = Game.GetActivePlayer() ;
    local pPlayer = Players[iPlayer];
	local iTeam = pPlayer:GetTeam();
	LuaEvents.ITGSG_RequestGT()
	local gData = MapModData.ITGSG;
	MapModData.ITGSG = nil;
	if not gData then
		return;
	end
	Controls.BrokenDeals:SetHide(gData.Players[iPlayer].BrokenAHDeals == 0)
	Controls.BrokenDealsLabel:SetText(gData.Players[iPlayer].BrokenAHDeals)
	local cHID = 1;
	local tab = {{"AuctionDealHistory", 0.8}, {"AuctionDeals", 1}}
	g_LogStockManager:ResetInstances();
	for i, tt in pairs(tab) do
		for a, b in pairs(gData.Globals[tt[1]]) do
			if (b.FromPlayer == iPlayer) or (b.ToPlayer == iPlayer) then
				local itemInstance = g_LogStockManager:GetInstance();
				itemInstance.Base:SetAlpha(tt[2])
				itemInstance.helpID:SetText(cHID);
				if b.Res then
					itemInstance.Resource:SetText(GameInfo.Resources[b.Res].IconString .. " " .. Locale.Lookup(GameInfo.Resources[b.Res].Description))
				else
					itemInstance.Resource:SetText(b.Name);
				end
				if b.FromPlayer then
					if b.FromPlayer == iPlayer then
						itemInstance.LumpGold:SetText("");
						itemInstance.Status:SetText("Exporting")
					else
						itemInstance.Status:SetText("Importing")
						itemInstance.LumpGold:SetText("-" .. b.GoldLumpSum .. "[ICON_GOLD]");
					end
				else
					itemInstance.Status:SetText("Deal")
					itemInstance.LumpGold:SetText("-" .. b.GoldLumpSum .. "[ICON_GOLD]");
				end
				itemInstance.Duration:SetText(b.Duration);
				if b.GPT then
					if b.FromPlayer == iPlayer then
						itemInstance.GPT:SetText("+" .. b.GPT .. "[ICON_GOLD]");
					else
						itemInstance.GPT:SetText("-" .. b.GPT .. "[ICON_GOLD]");
					end
				else
					itemInstance.GPT:SetText("")
				end
				if b.TurnStart then
					itemInstance.TStart:SetText(b.TurnStart .. "T");
				else
					itemInstance.TStart:SetText("");
				end
				if (i == 1) and (b.TurnEnd) then
					itemInstance.TEnd:SetText(b.TurnEnd .. "T");
				else
					itemInstance.TEnd:SetText("");
				end
				cHID = cHID + 1
			end
		end
	end
	Controls.NoInvestAvailable:SetHide(cHID ~= 1)
	
    Controls.IntrigueMessageStack:CalculateSize();
    Controls.IntrigueMessageStack:ReprocessAnchoring();
    Controls.LogMessageScrollPanel:CalculateInternalSize();
end
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function ShowHideHandler( bIsHide, bInitState )
    if( not bIsHide ) then
		gCurrentResSelected = -1;
    	UpdateScreen();
	end
end
ContextPtr:SetShowHideHandler( ShowHideHandler );

function SetCurrentSelection(v1, v2)
	Controls.AutomaticOfferPD:GetButton():LocalizeAndSetText(AImanagementT[v1].Name);		
	Controls.AutomaticOfferPD:GetButton():SetToolTipString(AImanagementT[v1].Help);
	if v2 == 1 then
		LuaEvents.ITGHumanPlayerChooseAIAuctionManagement(Game.GetActivePlayer(), AImanagementT[v1].Type);
		UpdateMarketData()
	end
end

function GetIDFromAIManagement(ah)
	for hh, bb in pairs(AImanagementT) do
		if bb.Type == ah then
			return hh;
		end
	end
	return 1;
end

function MyOfferIncrease(res)
	DoHumanChangeHisOffer(res,1)
end

function MyOfferRemove(res)
	DoHumanChangeHisOffer(res,-1)
end

function DoHumanChangeHisOffer(res,am)
	LuaEvents.ITGAuctionHouseHumanChangeOffer(Game.GetActivePlayer(), res, am)
	local gData = MapModData.ITGSG;
	MapModData.ITGSG = nil;
	if gData then
		myOfferInstances[res].ResourceOffer:SetText(gData[1]);
		myOfferInstances[res].AddInvest:SetDisabled(gData[1] >= gData[2])
		myOfferInstances[res].RemoveInvest:SetDisabled(gData[1] == 0)
		local nleft = gData[2] - gData[1];
		if nleft == 0 then
			myOfferInstances[res].ResourceAvailable:SetText("[COLOR_NEGATIVE_TEXT]" .. nleft);
		elseif nleft > 1 then
			myOfferInstances[res].ResourceAvailable:SetText("[COLOR_POSITIVE_TEXT]" .. nleft);
		else
			myOfferInstances[res].ResourceAvailable:SetText(nleft);
		end		
	end
end

function PurchaseItem(res, price)
	if Players[Game.GetActivePlayer()]:IsTurnActive() then
		LuaEvents.ITG_HumanPlayerBuysResource(Game.GetActivePlayer(), res, price)
		UpdateMarketData()
		Events.AudioPlay2DSound("AS2D_INTERFACE_BUY_TILE")
	end
end

function PurchaseBasicItem(id, info2)
	if Players[Game.GetActivePlayer()]:IsTurnActive() then
		LuaEvents.ITG_HumanPlayerBuysBasicDeal(Game.GetActivePlayer(), id)
		UpdateMarketData()
		Events.AudioPlay2DSound("AS2D_INTERFACE_BUY_TILE")
	end
end

function PurchaseSpecialItem(id, info2)
	if Players[Game.GetActivePlayer()]:IsTurnActive() then
		LuaEvents.ITG_HumanPlayerBuysSpecialDeal(Game.GetActivePlayer(), id)
		UpdateMarketData()
		Events.AudioPlay2DSound("AS2D_INTERFACE_BUY_TILE")
	end
end

function UpdateMarketData()
	local iPlayer = Game.GetActivePlayer() ;
    local pPlayer = Players[iPlayer];
	local iTeam = pPlayer:GetTeam();
	LuaEvents.ITGSG_RequestGT()
	local gData = MapModData.ITGSG;
	MapModData.ITGSG = nil;
	if not gData then
		return;
	end
	Controls.BrokenDeals:SetHide(gData.Players[iPlayer].BrokenAHDeals == 0)
	Controls.BrokenDealsLabel:SetText(gData.Players[iPlayer].BrokenAHDeals)

	g_AuctionHouseManager:ResetInstances();
	g_WorldOfferManager:ResetInstances();
	myOfferInstances = {};
	for row in GameInfo.Resources() do
		if not row.Migration then
			if row.Happiness > 0 then
				if not gData.CurrencyResources[row.ID] then
					local inumRes = Players[iPlayer]:GetNumResourceTotal(row.ID);
					if inumRes > 0 then
						local itemInstance = g_AuctionHouseManager:GetInstance();
					
						itemInstance.ResourceName:SetText(Locale.Lookup(row.Description) .. " (" .. gData.AuctionPrices[row.ID] .. "[ICON_GOLD])");
						itemInstance.ResourceName:SetToolTipString("Suggested price may differs from final transaction.");
						IconHookup( row.PortraitIndex, 80, row.IconAtlas, itemInstance.HH2 )
					
						local numOffered = gData.Players[iPlayer].AuctionOffers[row.ID] or 0;

						itemInstance.ResourceOffer:SetText(numOffered);
						local nleft = inumRes - numOffered;
						if nleft == 0 then
							itemInstance.ResourceAvailable:SetText("[COLOR_NEGATIVE_TEXT]" .. nleft);
						elseif nleft > 1 then
							itemInstance.ResourceAvailable:SetText("[COLOR_POSITIVE_TEXT]" .. nleft);
						else
							itemInstance.ResourceAvailable:SetText(nleft);
						end				
						itemInstance.Base:SetVoid1(row.ID)
						itemInstance.AddInvest:SetVoid1(row.ID)
						itemInstance.RemoveInvest:SetVoid1(row.ID)
						itemInstance.AddInvest:SetDisabled(numOffered >= inumRes)
						itemInstance.RemoveInvest:SetDisabled(numOffered == 0)
						itemInstance.AddInvest:RegisterCallback( Mouse.eLClick, MyOfferIncrease );
						itemInstance.RemoveInvest:RegisterCallback( Mouse.eLClick, MyOfferRemove );
						itemInstance.Base:RegisterCallback( Mouse.eLClick, GetNewGraphResource );
						
						itemInstance.EmbargoBuyers:DestroyAllChildren();
						itemInstance.PotentialBuyers:DestroyAllChildren();
						local tabPotent = {}
						local tabEmbargo = {}				
						for g, h in pairs(gData.Players) do
							if not Players[g]:IsMinorCiv() then
								if Teams[iTeam]:IsHasMet(Players[g]:GetTeam()) then
									if g ~= iPlayer then
										if Players[g]:GetNumResourceTotal(row.ID, true) <= 0 then
											if gData.Players[iPlayer].Embargos[g] then
												table.insert(tabEmbargo, g)
											else
												table.insert(tabPotent, g)
											end
										end
									end
								end
							end
						end
						for ijj, g in pairs(tabPotent) do
							local instance = {};
							ContextPtr:BuildInstanceForControl( "CivIconInstance", instance, itemInstance.PotentialBuyers );
							instance.Base:SetToolTipString(Players[g]:GetCivilizationShortDescription());
							CivIconHookup( g, 32, instance.Icon, instance.CivIconBG, instance.CivIconShadow, false, true);  
							if #tabPotent > 8 then
								instance.Base:SetSizeX(16);
							else
								instance.Base:SetSizeX(32);
							end
						end
						if #tabPotent > 8 then
							itemInstance.PotentialBuyers:SetOffsetVal(213,20);
						else
							itemInstance.PotentialBuyers:SetOffsetVal(205,20);
						end
						for ijj, g in pairs(tabEmbargo) do
							local instance = {};
							ContextPtr:BuildInstanceForControl( "CivIconInstance", instance, itemInstance.EmbargoBuyers );
							instance.Base:SetToolTipString(Players[g]:GetCivilizationShortDescription());
							CivIconHookup( g, 32, instance.Icon, instance.CivIconBG, instance.CivIconShadow, false, true);  
							if #tabEmbargo > 8 then
								instance.Base:SetSizeX(16);
							else
								instance.Base:SetSizeX(32);
							end
						end
						if #tabEmbargo > 8 then
							itemInstance.EmbargoBuyers:SetOffsetVal(213,-3);
						else
							itemInstance.EmbargoBuyers:SetOffsetVal(205,-3);
						end
						itemInstance.EmbargoBuyers:CalculateSize();
						itemInstance.EmbargoBuyers:ReprocessAnchoring();
						itemInstance.PotentialBuyers:CalculateSize();
						itemInstance.PotentialBuyers:ReprocessAnchoring();
						myOfferInstances[row.ID] = itemInstance
					end
				end
			end
		end
	end

	LuaEvents.ITGSG_PrepareItemsToBuyAuctionHouse(Game.GetActivePlayer())
	local tbtt = MapModData.ITGSG;
	MapModData.ITGSG = nil;
	if tbtt then
		for a, b in pairs(tbtt.Data) do
			local itemInstance = g_WorldOfferManager:GetInstance();
			itemInstance.ResourceNamePrice:SetText(GameInfo.Resources[b[1]].IconString .. " " .. Locale.Lookup(GameInfo.Resources[b[1]].Description) .. " ([COLOR_POSITIVE_TEXT]" .. b[3] .. "[ENDCOLOR])")
			itemInstance.Base:SetVoid1(b[1])
			itemInstance.Base:SetToolTipString("")
			itemInstance.Base:RegisterCallback( Mouse.eLClick, GetNewGraphResource );
			itemInstance.Base:SetDisabled(false)
			itemInstance.Purchase30T:SetVoid1(b[1])
			itemInstance.Purchase30T:SetVoid2(30)
			itemInstance.Purchase30T:SetText(b[2] .. "[ICON_GOLD] 30T")
			itemInstance.Purchase30T:SetDisabled((b[5] > Players[iPlayer]:GetGold()) or (b[4] > tbtt.GPT))
			itemInstance.Purchase30T:SetToolTipString(b[8])
			itemInstance.Purchase30T:RegisterCallback( Mouse.eLClick, PurchaseItem );
			itemInstance.L1:SetHide(true)
			itemInstance.L2:SetHide(true)
			itemInstance.L3:SetHide(true)
			itemInstance.L4:SetHide(true)
			itemInstance.Purchase30T:SetSizeX(105);
			itemInstance.Purchase30T:SetSizeX(math.max(itemInstance.Purchase30T:GetTextControl():GetSizeX() + 20, 105))
			itemInstance.Purchase15T:SetHide(true);
		end

		for a, b in pairs(tbtt.Basic) do
			local itemInstance = g_WorldOfferManager:GetInstance();
			itemInstance.ResourceNamePrice:SetText(b.Name)
			itemInstance.Base:SetDisabled(true)
			itemInstance.Base:SetToolTipString(b.ToolTip)
			itemInstance.Purchase30T:SetVoid1(b.ID)
			itemInstance.Purchase30T:SetVoid2(-1)
			itemInstance.Purchase30T:SetText(b.StrCost or (b.Cost .. "[ICON_GOLD]"))
			itemInstance.Purchase30T:SetDisabled(b.Disabled)
			itemInstance.Purchase30T:SetToolTipString("This offer has no duration and costs raw lump of [ICON_GOLD] Gold.")
			itemInstance.Purchase30T:RegisterCallback( Mouse.eLClick, PurchaseBasicItem );
			itemInstance.L1:SetHide(true)
			itemInstance.L2:SetHide(true)
			itemInstance.L3:SetHide(true)
			itemInstance.L4:SetHide(true)
			itemInstance.Purchase30T:SetSizeX(105);
			itemInstance.Purchase30T:SetSizeX(math.max(itemInstance.Purchase30T:GetTextControl():GetSizeX() + 20, 105))
			itemInstance.Purchase15T:SetHide(true);
		end

		for a, b in pairs(tbtt.Special) do
			local itemInstance = g_WorldOfferManager:GetInstance();
			itemInstance.ResourceNamePrice:SetText(b.Name)
			itemInstance.Base:SetDisabled(false)
			itemInstance.Base:RegisterCallback( Mouse.eLClick, GetNewGraphSpecialDeal );
			itemInstance.Base:SetToolTipString(b.ToolTip)
			itemInstance.Base:SetVoid1(b.ID)
			itemInstance.Purchase30T:SetVoid1(b.ID)
			itemInstance.Purchase30T:SetVoid2(-1)
			itemInstance.Purchase30T:SetText(b.Cost .. "[ICON_GOLD]")
			itemInstance.Purchase30T:SetDisabled(b.Disabled)
			itemInstance.Purchase30T:SetToolTipString("This offer has limited duration. [ICON_GOLD] Gold must be paid upfront.")
			itemInstance.Purchase30T:RegisterCallback( Mouse.eLClick, PurchaseSpecialItem );
			itemInstance.L1:SetHide(false)
			itemInstance.L2:SetHide(false)
			itemInstance.L3:SetHide(false)
			itemInstance.L4:SetHide(false)
			itemInstance.Purchase15T:SetHide(true);
			itemInstance.Purchase30T:SetSizeX(105);
			itemInstance.Purchase30T:SetSizeX(math.max(itemInstance.Purchase30T:GetTextControl():GetSizeX() + 20, 105))
		end
	end
	
	
    Controls.StackMyTrade:CalculateSize();
    Controls.StackMyTrade:ReprocessAnchoring();
    Controls.MyScrollTrade:CalculateInternalSize();
    Controls.StackOtherTrade:CalculateSize();
    Controls.StackOtherTrade:ReprocessAnchoring();
    Controls.OtherScrollTrade:CalculateInternalSize();


	--PULLDOWN
	local automaticPurchasePullDown = Controls.AutomaticOfferPD;
	function AddToPullDown(text, tooltip, v1, v2)
		local controlTable = {};
		automaticPurchasePullDown:BuildEntry( "InstanceOne", controlTable );
		
		controlTable.Button:SetVoids(v1, v2);
		controlTable.Button:SetText(text);
		controlTable.Button:SetToolTipString(tooltip);
	end
	automaticPurchasePullDown:ClearEntries();
	for a, b in pairs(AImanagementT) do
		AddToPullDown(b.Name, b.Help, a, 1)
	end
	SetCurrentSelection(GetIDFromAIManagement(gData.Players[iPlayer].AIAuctionManager), 2);
	automaticPurchasePullDown:CalculateInternals();
	automaticPurchasePullDown:RegisterSelectionCallback(function(v1, v2)
		SetCurrentSelection(v1, v2);
	end); 

	TakeCareOfGraph()
end


function OnCurrencyStockButton()
	Controls.TradeHighlight:SetHide(false);
	Controls.DealsHistoryHighlight:SetHide(true);
    m_CurrentStock = 1;
	UpdateScreen()
end
Controls.MarketButton:RegisterCallback(Mouse.elClick, OnCurrencyStockButton);

function OnTransactionLogExchangeButton()
	Controls.TradeHighlight:SetHide(true);
	Controls.DealsHistoryHighlight:SetHide(false);
    m_CurrentStock = 2;
	UpdateScreen()
end
Controls.DealsHistoryButton:RegisterCallback(Mouse.elClick, OnTransactionLogExchangeButton);
