include( "InstanceManager" );
include( "IconSupport" );
include( "SupportFunctions" );


local m_HeadlinesIM = InstanceManager:new( "HeadlineInstance", "Quote", Controls.Stack );
local m_TextsIM = InstanceManager:new( "TextInstance", "Quote", Controls.Stack );

function OnBack()
    UIManager:DequeuePopup( ContextPtr );
end
Controls.BackButton:RegisterCallback( Mouse.eLClick, OnBack );

----------------------------------------------------------------        
----------------------------------------------------------------

function MakeBigHeadline(str, fontbyname)
	local instance = m_HeadlinesIM:GetInstance();
	instance.Quote:SetFontByName(fontbyname or "TwCenMT18");
	instance.Quote:LocalizeAndSetText(str);
end

function MakeText(str, preAnchor, prefix)
	local instance = m_TextsIM:GetInstance();
	instance.Quote:SetAnchor(preAnchor or "L,T")
	instance.Quote:SetText((prefix or "") .. Locale.Lookup(str));
end

function UpdateTheList()
	m_HeadlinesIM:ResetInstances();
	m_TextsIM:ResetInstances();
	--let's go
	MakeBigHeadline("TXT_KEY_ITG_CHANGELOG_FOREWORD_HEADLINE", "TwCenMT22")
	MakeText("TXT_KEY_ITG_CHANGELOG_FOREWORD_TEXT", "C,T")
	MakeBigHeadline("TXT_KEY_ITG_CHANGELOG_BIG_HEADLINE", "TwCenMT22")
	for j = 1, 100 do
		local hText = "TXT_KEY_ITG_CHANGELOG_HEADLINE_" .. j;
		if Locale.Lookup(hText) == hText then
			break;
		else
			MakeBigHeadline("TXT_KEY_ITG_CHANGELOG_HEADLINE_" .. j)
			for i = 1, 100 do
				hText = "TXT_KEY_ITG_CHANGELOG_" .. j .. "_TEXT_" .. i;
				if Locale.Lookup(hText) == hText then
					break;
				else
					MakeText("TXT_KEY_ITG_CHANGELOG_" .. j .. "_TEXT_" .. i, nil, "[ICON_BULLET]")
				end
			end
		end
	end
	MakeText(" ", nil, "[NEWLINE]")

	Controls.Stack:CalculateSize();
	Controls.ScrollPanel:CalculateInternalSize();
	Controls.ScrollPanel:ReprocessAnchoring();
end

----------------------------------------------------------------        
---------------------------------------------------------------- 
----------------------------------------------------------------        
----------------------------------------------------------------        
function SetupFileButtonList()
	UpdateTheList()
end

----------------------------------------------------------------        
-- Key Down Processing
----------------------------------------------------------------        
function InputHandler( uiMsg, wParam, lParam )
    if uiMsg == KeyEvents.KeyDown then
        if wParam == Keys.VK_ESCAPE then
	        OnBack();
        end
    end
    return true;
end
ContextPtr:SetInputHandler( InputHandler );

----------------------------------------------------------------        
----------------------------------------------------------------        
function ShowHideHandler(isHide)
    if( not isHide ) then
		SetupFileButtonList();
	end
end
ContextPtr:SetShowHideHandler( ShowHideHandler );