
-------------------------------------------------
-- Choose Pantheon Popup
-------------------------------------------------

include( "IconSupport" );
include( "InstanceManager" );
include( "TechButtonInclude" );
include( "TechHelpInclude" );
include( "CityStateStatusHelper" );

-- Used for Piano Keys
local ltBlue = {19/255,32/255,46/255,120/255};
local dkBlue = {12/255,22/255,30/255,120/255};
local GetITDS = {1, 2, 5, 10, 20}

local g_ItemManager = InstanceManager:new( "ItemInstance", "Button", Controls.ItemStack );
--localize it
g_CityStates = {};
g_InstanceY = 100;

local screenSizeX, screenSizeY = UIManager:GetScreenSizeVal()
local spWidth, spHeight = Controls.ItemScrollPanel:GetSizeVal();
-- Original UI designed at 1050px 
local heightOffset = screenSizeY - 1020;
spHeight = spHeight + heightOffset;
Controls.ItemScrollPanel:SetSizeVal(spWidth, spHeight); 
Controls.ItemScrollPanel:CalculateInternalSize();
Controls.ItemScrollPanel:ReprocessAnchoring();
local bpWidth, bpHeight = Controls.BottomPanel:GetSizeVal();
--bpHeight = bpHeight * heightRatio;
bpHeight = bpHeight + heightOffset 
Controls.BottomPanel:SetSizeVal(bpWidth, bpHeight);
Controls.BottomPanel:ReprocessAnchoring();

-------------------------------------------------
-------------------------------------------------
function OnPopupMessage()

   	UIManager:QueuePopup( ContextPtr, PopupPriority.InGameUtmost );
end
LuaEvents.ITG_OpenCSProjectsPanel.Add(OnPopupMessage)
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function OnRealClose()
	UIManager:DequeuePopup(ContextPtr)
end
Controls.RealCloseButton:RegisterCallback( Mouse.eLClick, OnRealClose );

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------

function OnLookAt(index)
	UI.LookAt(Map.GetPlotByIndex(index))
end

function OnProcessITGClicked(val, minor)
	LuaEvents.ITGSG_CityStateContribution(minor , val);
	RefreshContribution()
end

function RefreshContribution()
	LuaEvents.ITGSG_RequestCityStateProjectContributions()
	local gData = MapModData.ITGSG;
	MapModData.ITGSG = nil;
	if not gData then
		return;
	end
	for minor, instance in pairs(g_CityStates) do
		if not gData[minor] then
			instance.ContributionContainer:SetHide(true)
		else
			instance.Contribution:SetText(gData[minor][1])
			if not instance.ContributionContainer:IsHidden() then
				for a, b in pairs(GetITDS) do
					instance["Give" .. b]:SetDisabled(gData[minor][2] < b)
				end
			end
		end
	end
end

function RefreshListFull()
	local g_iPlayer = Game.GetActivePlayer();
	CivIconHookup( g_iPlayer, 64, Controls.CivIcon, Controls.CivIconBG, Controls.CivIconShadow, false, true );
	LuaEvents.ITGSG_RequestCityStateProjectPanelData()
	local gData = MapModData.ITGSG;
	MapModData.ITGSG = nil;
	if not gData then
		return;
	end
	local g_iTeam = Game.GetActiveTeam();
	local bTickTock = true;
	g_CityStates = {}
	g_ItemManager:ResetInstances();
	for a, data in pairs(gData) do
		local controlTable = g_ItemManager:GetInstance();
		controlTable.QuestIcon:SetText(data.OngoingQuestIcon);
		controlTable.QuestIcon:SetToolTipString(data.OngoingQuest);
		local minor = data.PlayerID
		local iAlly = Players[minor]:GetAlly();
		
		local _, primaryColor = Players[minor]:GetPlayerColors();
		local color = Vector4(primaryColor.x, primaryColor.y, primaryColor.z, 1);
		local minorCivType = Players[minor]:GetMinorCivType();
		local civInfo = GameInfo.MinorCivilizations[minorCivType];
			
		controlTable.MinorName:SetText( Locale.ConvertTextKey( civInfo.Description ) );
		controlTable.MinorName:SetColor( color, 0 );
		if data.PlotIndex then
			controlTable.SelectPlot:SetHide(false)
			controlTable.SelectPlot:RegisterCallback( Mouse.eLClick, OnLookAt );
			controlTable.SelectPlot:SetVoid1(data.PlotIndex)
		else
			controlTable.SelectPlot:SetHide(true)
		end	
		local sMinorCivType = Players[minor]:GetMinorCivType();
		local strStatusTT = GetCityStateStatusToolTip(g_iPlayer, minor, true);
		local trait = Players[minor]:GetMinorCivTrait() 
		UpdateCityStateStatusUI(g_iPlayer, minor, controlTable.PositiveStatusMeter, controlTable.NegativeStatusMeter, controlTable.StatusMeterMarker, controlTable.StatusIconBG);
		controlTable.StatusIcon:SetTexture(GameInfo.MinorCivTraits[trait].TraitIcon);
		controlTable.StatusIcon:SetColor( {x=1, y=1, z=1, w=1 } );
		if (GetCityStateStatusType(g_iPlayer, minor) == "MINOR_FRIENDSHIP_STATUS_NEUTRAL" and color) then
			controlTable.StatusIcon:SetColor(color);
		end
		controlTable.StatusIconBG:SetToolTipString(strStatusTT);

		local iTrait = Players[minor]:GetMinorCivTrait();
        if( iTrait == GameInfoTypes.MINOR_TRAIT_CULTURED ) then
        	controlTable.MinorType:LocalizeAndSetText( "TXT_KEY_CITY_STATE_CULTURED_ADJECTIVE" );
        elseif( iTrait == GameInfoTypes.MINOR_TRAIT_MILITARISTIC ) then
        	controlTable.MinorType:LocalizeAndSetText( "TXT_KEY_CITY_STATE_MILITARISTIC_ADJECTIVE" );
        elseif( iTrait == GameInfoTypes.MINOR_TRAIT_MARITIME ) then
        	controlTable.MinorType:LocalizeAndSetText( "TXT_KEY_CITY_STATE_MARITIME_ADJECTIVE" );
        elseif(iTrait == GameInfoTypes.MINOR_TRAIT_MERCANTILE) then
        	controlTable.MinorType:LocalizeAndSetText( "TXT_KEY_CITY_STATE_MERCANTILE_ADJECTIVE" );
        elseif(iTrait == GameInfoTypes.MINOR_TRAIT_RELIGIOUS) then
        	controlTable.MinorType:LocalizeAndSetText( "TXT_KEY_CITY_STATE_RELIGIOUS_ADJECTIVE" );
        elseif(iTrait == GameInfoTypes.MINOR_TRAIT_ECONOMIC) then
        	controlTable.MinorType:LocalizeAndSetText( "TXT_KEY_CITY_STATE_ECONOMIC_ADJECTIVE" );
        elseif(iTrait == GameInfoTypes.MINOR_TRAIT_TRADITIONAL) then
        	controlTable.MinorType:LocalizeAndSetText( "TXT_KEY_CITY_STATE_TRADITIONAL_ADJECTIVE" );
        elseif(iTrait == GameInfoTypes.MINOR_TRAIT_IDEOLOGICAL) then
        	controlTable.MinorType:LocalizeAndSetText( "TXT_KEY_CITY_STATE_IDEOLOGICAL_ADJECTIVE" );
        elseif(iTrait == GameInfoTypes.MINOR_TRAIT_AGRICULTURAL) then
        	controlTable.MinorType:LocalizeAndSetText( "TXT_KEY_CITY_STATE_AGRICULTURAL_ADJECTIVE" );
        elseif(iTrait == GameInfoTypes.MINOR_TRAIT_ANTIQUE) then
        	controlTable.MinorType:LocalizeAndSetText( "TXT_KEY_CITY_STATE_ANTIQUE_ADJECTIVE" );
        elseif(iTrait == GameInfoTypes.MINOR_TRAIT_ENLIGHTENED) then
        	controlTable.MinorType:LocalizeAndSetText( "TXT_KEY_CITY_STATE_ENLIGHTENED_ADJECTIVE" );
        end
		local civType = Players[minor]:GetCivilizationType();
		local civInfo = GameInfo.Civilizations[civType];

		IconHookup( civInfo.PortraitIndex, 32, civInfo.AlphaIconAtlas, controlTable.LeaderPortrait );
		controlTable.LeaderPortrait:SetColor( color );

		local bHideIcon = true;
		if (iAlly ~= nil and iAlly ~= -1) then
			if (iAlly == g_iPlayer or Teams[Players[iAlly]:GetTeam()]:IsHasMet(g_iTeam) or Game.IsOption("GAMEOPTION_ITG_AI_GAME")) then
				bHideIcon = false;
				CivIconHookup(iAlly, 32, controlTable.AllyIcon, controlTable.AllyIconBG, controlTable.AllyIconShadow, false, true);
			else
				bHideIcon = false;
				CivIconHookup(-1, 32, controlTable.AllyIcon, controlTable.AllyIconBG, controlTable.AllyIconShadow, false, true);
			end
		end
		local strAllyTT = GetAllyToolTip(g_iPlayer, minor);
		controlTable.AllyIcon:SetToolTipString(strAllyTT);
		controlTable.AllyIconBG:SetToolTipString(strAllyTT);
		controlTable.AllyIconShadow:SetToolTipString(strAllyTT);
		controlTable.AllyIconShadow:SetToolTipString(strAllyTT);
		controlTable.MeterContainer:SetToolTipString(strAllyTT);
		controlTable.AllyIconContainer:SetHide(bHideIcon);
		
		controlTable.ContributionContainer:SetHide(true)
		controlTable.UnavailableLabel:SetText("")
		if data.War then	
			if data.CanChangeWarPeace then
				controlTable.UnavailableLabel:SetText("[COLOR_NEGATIVE_TEXT]WAR!")
			else
				controlTable.UnavailableLabel:SetText("[COLOR_NEGATIVE_TEXT]WAR! LOCKED!")
			end
		elseif data.ProjectType == 2 then
			controlTable.UnavailableLabel:SetText("[ICON_PRODUCTION] PRODUCTION PROJECT.")
		else
			controlTable.ContributionContainer:SetHide(false)
			for a, b in pairs(GetITDS) do
				controlTable["Give" .. b]:SetText(5 * b * data.ProjectScale .. data.ProjectIcon)
				controlTable["Give" .. b]:SetVoid1(a);
				controlTable["Give" .. b]:SetVoid2(minor);
				controlTable["Give" .. b]:RegisterCallback( Mouse.eLClick, OnProcessITGClicked );
			end
		end

		if data.TurnsLeft <= 1 then
			controlTable.TurnsLeft:SetText("[COLOR_NEGATIVE_TEXT]" .. data.TurnsLeft .. "T")
		else
			controlTable.TurnsLeft:SetText(data.TurnsLeft .. "T")
		end

		if(bTickTock == false) then
			controlTable.Box:SetColorVal(unpack(ltBlue));
		else
			controlTable.Box:SetColorVal(unpack(dkBlue));
		end
		local buttonWidth, buttonHeight = controlTable.Button:GetSizeVal();
		controlTable.Button:SetSizeVal(buttonWidth, g_InstanceY);
		controlTable.Box:SetSizeVal(buttonWidth + 20, g_InstanceY);
		bTickTock = not bTickTock;

		g_CityStates[data.PlayerID] = controlTable;
	end
	
	Controls.ItemStack:CalculateSize();
	Controls.ItemStack:ReprocessAnchoring();
	Controls.ItemScrollPanel:CalculateInternalSize();

	RefreshContribution()
end

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function ShowHideHandler( bIsHide, bInitState )

	bHidden = bIsHide;
    if( not bInitState ) then
        if( not bIsHide ) then
        	UI.incTurnTimerSemaphore();
        	Events.SerialEventGameMessagePopupShown(g_PopupInfo);
        	
        	RefreshListFull();
        
			local unitPanel = ContextPtr:LookUpControl( "/InGame/WorldView/UnitPanel/Base" );
			if( unitPanel ~= nil ) then
				unitPanel:SetHide( true );
			end
			
			local infoCorner = ContextPtr:LookUpControl( "/InGame/WorldView/InfoCorner" );
			if( infoCorner ~= nil ) then
				infoCorner:SetHide( true );
			end
               	
        else
      
			local unitPanel = ContextPtr:LookUpControl( "/InGame/WorldView/UnitPanel/Base" );
			if( unitPanel ~= nil ) then
				unitPanel:SetHide(false);
			end
			
			local infoCorner = ContextPtr:LookUpControl( "/InGame/WorldView/InfoCorner" );
			if( infoCorner ~= nil ) then
				infoCorner:SetHide(false);
			end
			
			if(g_PopupInfo ~= nil) then
				Events.SerialEventGameMessagePopupProcessed.CallImmediate(g_PopupInfo.Type, 0);
			end
            UI.decTurnTimerSemaphore();
        end
    end
end
ContextPtr:SetShowHideHandler( ShowHideHandler );

----------------------------------------------------------------
-- 'Active' (local human) player has changed
----------------------------------------------------------------
function OnActivePlayerChanged()
end
Events.GameplaySetActivePlayer.Add(OnActivePlayerChanged);

function InputHandler( uiMsg, wParam, lParam )
    if uiMsg == KeyEvents.KeyDown then
        if wParam == Keys.VK_ESCAPE or wParam == Keys.VK_RETURN then
            OnRealClose();
            return true;
        end
    end
end
ContextPtr:SetInputHandler( InputHandler );

ContextPtr:SetHide(true)