-------------------------------------------------
-- Happiness Info
-------------------------------------------------
include( "IconSupport" );
include( "InstanceManager" );
local g_CurrencyList = GenerationalInstanceManager:new( "CurrencyInstance", "Base", Controls.GoldStack);
local ltBlue = {19/255,32/255,46/255,120/255};
local dkBlue = {12/255,22/255,30/255,120/255};
local g_SortFunction;
local l_SortOptions = {
	{
		Button = Controls.BPSortbyName,
		ImageControl = Controls.BPSortbyNameImage,
		Column = 1,
		DefaultDirection = "asc",
		CurrentDirection = "asc",
	},
	{
		Button = Controls.BPSortbyResourceName,
		ImageControl = Controls.BPSortbyResourceNameImage,
		Column = 2,
		DefaultDirection = "desc",
		CurrentDirection = nil,
	},
	{
		Button = Controls.BPSortbyPower,
		ImageControl = Controls.BPSortbyPowerImage,
		Column = 3,
		DefaultDirection = "desc",
		CurrentDirection = nil,
		SortType = "numeric",
	},
	{
		Button = Controls.BPSortbyBonus,
		ImageControl = Controls.BPSortbyBonusImage,
		Column = 4,
		DefaultDirection = "desc",
		CurrentDirection = nil,
		SortType = "numeric",
	},
	{
		Button = Controls.BPSortbyEstablished,
		ImageControl = Controls.BPSortbyEstablishedImage,
		Column = 5,
		DefaultDirection = "desc",
		CurrentDirection = nil,
		SortType = "numeric",
	},
	{
		Button = Controls.BPSortbyCounterfeited,
		ImageControl = Controls.BPSortbyCounterfeitedImage,
		Column = 6,
		DefaultDirection = "desc",
		CurrentDirection = nil,
		SortType = "numeric",
	},
	{
		Button = Controls.BPSortbyReserves,
		ImageControl = Controls.BPSortbyReservesImage,
		Column = 7,
		DefaultDirection = "desc",
		CurrentDirection = nil,
	},
};
-------------------------------------------------
-------------------------------------------------
function GetNiceAdjectiveOfPlayer(tPlayer, iPlayer, bNotYour)
	if tPlayer == iPlayer then
		if bNotYour then
			return Players[tPlayer]:GetCivilizationAdjective()
		else
			return "Your"
		end
	else
		if Teams[Players[iPlayer]:GetTeam()]:IsHasMet(Players[tPlayer]:GetTeam()) then
			return Players[tPlayer]:GetCivilizationAdjective()
		else
			return "Unknown"
		end
	end
end

function UpdateScreen()
	UpdateGPT();
end
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function ShowHideHandler( bIsHide, bInitState )
    if( not bIsHide ) then
    	UpdateScreen();
	end
end
ContextPtr:SetShowHideHandler( ShowHideHandler );

function UpdateGPT()
	local iPlayer = Game.GetActivePlayer() ;
    local pPlayer = Players[iPlayer];
	LuaEvents.ITGSG_RequestGT("LegalCost");
	local gData = MapModData.ITGSG;
	MapModData.ITGSG = nil;
	if not gData then
		return
	end
	local bDisable = (not pPlayer:IsTurnActive())
	local bAnyCurrency = false;
	g_CurrencyList:ResetInstances();

	local preData = {}
	for g, gdata in pairs(gData.Players) do
		if gdata.MintPower > 0 then
    		local adjName = GetNiceAdjectiveOfPlayer(g, iPlayer);
			local resName = Locale.Lookup(GameInfo.Resources[gdata.Currencies].Description)
			local reserve = "None"
			if gdata.ForeignReserve then
				reserve = GetNiceAdjectiveOfPlayer(gdata.ForeignReserve, iPlayer, true);
			end
			table.insert(preData, {adjName,resName,gdata.MintPower,gdata.MintBonus,gdata.MintEstablished or gData.ITGTurn,gdata.NumCounterfeited,reserve,g})
		end
	end
	table.sort(preData, g_SortFunction);
	for a, b in pairs(preData) do
		local g = b[8];
		local gdata = gData.Players[g];
		local itemInstance = g_CurrencyList:GetInstance();
		local civAdj = GetNiceAdjectiveOfPlayer(g, iPlayer);
		if civAdj == "Unknown" then
			CivIconHookup( -1, 32, itemInstance.Icon, itemInstance.CivIconBG, itemInstance.CivIconShadow, false, true);
		else
			CivIconHookup( g, 32, itemInstance.Icon, itemInstance.CivIconBG, itemInstance.CivIconShadow, false, true);
		end
		itemInstance.CivName:SetText(civAdj .. " Currency");
	
		itemInstance.ResCurrencies:SetText(GameInfo.Resources[gdata.Currencies].IconString .. " " .. Locale.Lookup(GameInfo.Resources[gdata.Currencies].Description) .. " (" .. Players[g]:GetNumResourceTotal(gdata.Currencies, true) .. ")");
		itemInstance.MintPower:SetText(gdata.MintPower .. " [ICON_INVEST]")
		itemInstance.MintBonus:SetText(gdata.MintBonus .. "%")
		local iEstT = (gdata.MintEstablished or gData.ITGTurn);
		if iEstT == -1 then
			itemInstance.Established:SetText("")
		else
			itemInstance.Established:SetText(iEstT .. "T")
		end
		itemInstance.Counterfeited:SetText(gdata.NumCounterfeited)
		local tCurPower = "Sources:"
		LuaEvents.ITG_RequestMintSituation(g);
		tCurPower = tCurPower .. MapModData.ITGSG;
		MapModData.ITGSG = nil;

		itemInstance.MintPower:SetToolTipString(tCurPower);
		if not gdata.ForeignReserve then
			itemInstance.IconRes:SetHide(true);
			itemInstance.CivIconBGRes:SetHide(true);
			itemInstance.CivIconShadowRes:SetHide(true);
			itemInstance.ReserveLabel:SetAnchor("C,C");
			itemInstance.ReserveLabel:SetOffsetX(0);
			itemInstance.ReserveLabel:SetText("None")
		else
			itemInstance.ReserveLabel:SetAnchor("L,C");
			itemInstance.ReserveLabel:SetOffsetX(40);
			itemInstance.IconRes:SetHide(false);
			itemInstance.CivIconBGRes:SetHide(false);
			itemInstance.CivIconShadowRes:SetHide(false);
			local civResAdj = GetNiceAdjectiveOfPlayer(gdata.ForeignReserve, iPlayer, true);
			if civResAdj == "Unknown" then
				CivIconHookup( -1, 32, itemInstance.IconRes, itemInstance.CivIconBGRes, itemInstance.CivIconShadowRes, false, true);
			else
				CivIconHookup( gdata.ForeignReserve, 32, itemInstance.IconRes, itemInstance.CivIconBGRes, itemInstance.CivIconShadowRes, false, true);
			end
			itemInstance.ReserveLabel:SetText(civResAdj)
		end

		if(bTickTock == false) then
			itemInstance.Base:SetColorVal(unpack(ltBlue));
		else
			itemInstance.Base:SetColorVal(unpack(dkBlue));
		end
		bTickTock = not bTickTock;
		bAnyCurrency = true;
	end
	Controls.NoCurrencies:SetHide(bAnyCurrency)
    Controls.GoldStack:CalculateSize();
    Controls.GoldStack:ReprocessAnchoring();
    Controls.GoldScroll:CalculateInternalSize();

	Controls.CurrencyButton:SetDisabled(bDisable or (4 > (gData.Players[iPlayer].LHapAvailableToUse + gData.Players[iPlayer].LegalPower)));
	Controls.ReservesButton:SetDisabled(bDisable or (1 > (gData.Players[iPlayer].LHapAvailableToUse + gData.Players[iPlayer].LegalPower)));
	Controls.ReservesButton:SetHide(gData.Players[iPlayer].ForeignReserve or (gData.Players[iPlayer].MintPower <= 0))
end

function CurrencyButtonClicked()
	local iPlayer = Game.GetActivePlayer();
	if (Players[iPlayer]:IsTurnActive()) then
		LuaEvents.ITG_CallActionUIHumanLegal(Game.GetActivePlayer(), 1)
	end
end
Controls.CurrencyButton:RegisterCallback( Mouse.eLClick, CurrencyButtonClicked );

function ReservesButtonClicked()
	local iPlayer = Game.GetActivePlayer();
	if (Players[iPlayer]:IsTurnActive()) then
		LuaEvents.ITG_CallActionUIHumanLegal(Game.GetActivePlayer(), 31)
	end
end
Controls.ReservesButton:RegisterCallback( Mouse.eLClick, ReservesButtonClicked );

LuaEvents.ITG_UI_CurrencyListRefresh.Add(function()
	if not ContextPtr:IsHidden() then
		UpdateGPT()	
	end
end)

function SortOptionSelected(option)
	UpdateSortOptionState(l_SortOptions, option);
	UpdateSortOptionsDisplay(l_SortOptions);
	g_SortFunction = GetSortFunction(l_SortOptions);
	
	UpdateGPT();
end

function GetSortFunction(sortOptions)
	local orderBy = nil;
	for i,v in ipairs(sortOptions) do
		if(v.CurrentDirection ~= nil) then
			if(v.SortType == "numeric") then
				return NumericSortFunction(v.Column, v.CurrentDirection);
			else
				return AlphabeticalSortFunction(v.Column, v.CurrentDirection);
			end
		end
	end
	
	return nil;
end

function UpdateSortOptionState(sortOptions, selectedOption)
	for i,v in ipairs(sortOptions) do
		if(v == selectedOption) then
			if(v.CurrentDirection == nil) then			
				v.CurrentDirection = v.DefaultDirection;
			else
				if(v.CurrentDirection == "asc") then
					v.CurrentDirection = "desc";
				else
					v.CurrentDirection = "asc";
				end
			end
		else
			v.CurrentDirection = nil;
		end
	end
end

function AlphabeticalSortFunction(field, direction)
	if(direction == "asc") then
		return function(a,b)
			return Locale.Compare(a[field], b[field]) == -1;
		end
	elseif(direction == "desc") then
		return function(a,b)
			return Locale.Compare(a[field], b[field]) == 1;
		end
	end
end

function NumericSortFunction(field, direction)
	if(direction == "asc") then
		return function(a,b)
			return a[field] <= b[field];
		end
	elseif(direction == "desc") then
		return function(a,b)
			return a[field] > b[field];
		end
	end
end

function UpdateSortOptionsDisplay(sortOptions)
	for i,v in ipairs(sortOptions) do
		local imageControl = v.ImageControl;
		if(imageControl ~= nil) then
			if(v.CurrentDirection == nil) then
				imageControl:SetHide(true);
			else
				local imageToUse = "SelectedUp.dds";
				if(v.CurrentDirection == "desc") then
					imageToUse = "SelectedDown.dds";
				end
				imageControl:SetTexture(imageToUse);
				
				imageControl:SetHide(false);
			end
		end
	end
end

function RegisterSortOptions()
	for i,v in ipairs(l_SortOptions) do
		if(v.Button ~= nil) then
			v.Button:RegisterCallback(Mouse.eLClick, function() SortOptionSelected(v); end);
		end
	end
	UpdateSortOptionsDisplay(l_SortOptions);
	g_SortFunction = GetSortFunction(l_SortOptions);
end
RegisterSortOptions()