include( "FLuaVector" );
include( "InstanceManager" );
include("IconSupport.lua")

-------------------------------------------------
-- Yield Icon Manager
-------------------------------------------------
local g_AnchorIM = InstanceManager:new( "AnchorInstance", "Anchor", Controls.Scrap );

local text = "ITGCurrentDir0.dds";
local afterLoad = false;
local gTA = {}
local gTD = {}
local ftR = {}
local fUP = {
[0] = {0,10,0,0},
[1] = {0,10,0,0},
[2] = {0,10,0,0},
[3] = {0,10,0,0},
[4] = {0,10,0,0},
[5] = {0,10,0,0}
}

function BuildYield( x, y, fdir)
	local fPlot = Map.GetPlot(x, y);
	local AnchorInstance = g_AnchorIM:GetInstance();
	local sPlot = Map.PlotDirection(x, y, fdir);
	local cc1 = HexToWorld(ToHexFromGrid(Vector2(x, y)));
	local cc2 = HexToWorld(ToHexFromGrid(Vector2(sPlot:GetX(), sPlot:GetY())))
	if x == 0 or sPlot:GetX() == 0 then
		AnchorInstance.Anchor:SetWorldPosition( {["x"] = cc1.x + 2 * fUP[fdir][1], ["y"] = (cc1.y + cc2.y) / 2 + fUP[fdir][2], ["w"] = (cc1.w + cc2.w) /2 + fUP[fdir][3], ["z"] = (cc1.z + cc2.z) / 2 + fUP[fdir][4]} );
	else
--	AnchorInstance.Anchor:SetWorldPosition( VecAdd( HexToWorld( ToHexFromGrid( Vector2( x, y) ) ), {x = 0, y = 0, z = cc1.z} ) );
		AnchorInstance.Anchor:SetWorldPosition( {["x"] = (cc1.x + cc2.x)/2 + fUP[fdir][1], ["y"] = (cc1.y + cc2.y) / 2 + fUP[fdir][2], ["w"] = (cc1.w + cc2.w) /2 + fUP[fdir][3], ["z"] = (cc1.z + cc2.z) / 2 + fUP[fdir][4]} );
	end
	AnchorInstance.Anchor:ChangeParent( Controls.YieldStore );
	AnchorInstance.Image:SetTexture("ITGCurrentDir" .. fdir .. ".dds");
	AnchorInstance.Image:SetHide(true);
	gTA[fPlot] = AnchorInstance;
	gTD[fPlot] = fdir;
end

function UpdatePositions(i, x, y, w, z, alpha)
	fUP[i] = {x, y, w, z}
	for fPlot, instance in pairs(gTA) do
		local sPlot = Map.PlotDirection(fPlot:GetX(), fPlot:GetY(), gTD[fPlot]);
		local cc1 = HexToWorld(ToHexFromGrid(Vector2(fPlot:GetX(), fPlot:GetY())))
		local cc2 = HexToWorld(ToHexFromGrid(Vector2(sPlot:GetX(), sPlot:GetY())))
		if fPlot:GetX() == 0 or sPlot:GetX() == 0 then
			instance.Anchor:SetWorldPosition( {["x"] = cc1.x + 2 * fUP[gTD[fPlot]][1], ["y"] = (cc1.y + cc2.y) / 2 + fUP[gTD[fPlot]][2], ["w"] = (cc1.w + cc2.w) /2 + fUP[gTD[fPlot]][3], ["z"] = (cc1.z + cc2.z) / 2 + fUP[gTD[fPlot]][4]} );
		else
			instance.Anchor:SetWorldPosition( {["x"] = (cc1.x + cc2.x)/2 + fUP[gTD[fPlot]][1], ["y"] = (cc1.y + cc2.y) / 2 + fUP[gTD[fPlot]][2], ["w"] = (cc1.w + cc2.w) /2 + fUP[gTD[fPlot]][3], ["z"] = (cc1.z + cc2.z) / 2 + fUP[gTD[fPlot]][4]} );
		end
		instance.Image:SetAlpha(alpha)
	end
end

Events.SequenceGameInitComplete.Add(function()
	print("SGIC", os.clock())
	Controls.YieldStore:ChangeParent( ContextPtr:LookUpControl("/InGame/YieldIconManager/YieldStore"))
	for i = 0, Map:GetNumPlots() - 1, 1 do
		local fPlot = Map.GetPlotByIndex( i );
		local fDir = fPlot:GetCurrentDirection();
		if fDir ~= -1 then
			BuildYield(fPlot:GetX(), fPlot:GetY(), fDir)
		end
	end
	if Players[Game.GetActivePlayer()]:CanUseCurrents() then
		UpdateVisibilityAll()
	end
	afterLoad = true;
end)


function UpdateVisibilityAll()
	local gTeam = Game.GetActiveTeam()
	for fPlot, instance in pairs(gTA) do
		local bHide = true;
		if fPlot:IsRevealed(gTeam) then
			local sPlot = Map.PlotDirection(fPlot:GetX(), fPlot:GetY(), gTD[fPlot])
			bHide = not sPlot:IsRevealed(gTeam)
		end
		instance.Image:SetHide(bHide)
	end
end
LuaEvents.ITGPlayerSuddenlyCanSeeCurrents.Add(UpdateVisibilityAll)

function CheckThePlot(nPlot, gTeam)
	if gTA[nPlot] then
		local sPlot = Map.PlotDirection(nPlot:GetX(), nPlot:GetY(), gTD[nPlot]);
		if sPlot:IsRevealed(gTeam) and nPlot:IsRevealed(gTeam) then
			gTA[nPlot].Image:SetHide(false);
		end
	end
end

function DoCurrentsUpdateWithinPlot(plot)
	if Players[Game.GetActivePlayer()]:CanUseCurrents() then
		local gTeam = Game.GetActiveTeam()
		CheckThePlot(plot, gTeam)
		for i = 0, 5 do
			local nPlot = Map.PlotDirection(plot:GetX(), plot:GetY(), i);
			if nPlot then
				CheckThePlot(nPlot, gTeam)
			end
		end
	end
end

function OnHexFogEvent( hexPos, fowType, bWholeMap )
	if afterLoad then
		if fowType == 2 or fowType == 1 then
			local gridPosX, gridPosY = ToGridFromHex( hexPos.x, hexPos.y );
			local plot = Map.GetPlot( gridPosX, gridPosY );
			if plot then
				if not ftR[plot] then
					ftR[plot] = 1;
					DoCurrentsUpdateWithinPlot(plot)
				end
			end
		end
	end
end
Events.HexFOWStateChanged.Add( OnHexFogEvent );
