-------------------------------------------------
-- ITG CustomsHouse
-------------------------------------------------
include( "IconSupport" );
include( "InstanceManager" );

-------------------------------------------------
-------------------------------------------------
local lastCustomH = nil;
local ltBlue = {19/255,32/255,46/255,120/255};
local dkBlue = {12/255,22/255,30/255,120/255};
local bTickTock = false;
local bShowOnlyYours = true;
local g_ListCH = GenerationalInstanceManager:new( "CHListInstance", "Base", Controls.CustomsHousesStack);
local g_TraitsIncomingCH = GenerationalInstanceManager:new( "CHIncomingTraitInstance", "Root", Controls.CustHousDetailStack);
local g_TraitsMainCH = GenerationalInstanceManager:new( "CHMainTraitInstance", "ButtonZoneTrait", Controls.ChooseMainTraitPanel);

function GetPlayerNiceCivName(i)
	if Game.GetActivePlayer() == i then
		return "You"
	elseif Teams[Game.GetActiveTeam()]:IsHasMet(Players[i]:GetTeam()) then
		return Players[i]:GetCivilizationShortDescription()
	end
	return "Unknown Player"
end

function OnFindOnMapButtonClicked ()
	UI.LookAt(Map.GetPlotByIndex(lastCustomH), 0);
end
Controls.FindOnMapButton:RegisterCallback( Mouse.eLClick, OnFindOnMapButtonClicked );

function OnCancelMainTraitChangeClicked()
	Controls.ChooseMainTraitPanel:SetHide(true)
end
Controls.CancelChangingMainTrait:RegisterCallback( Mouse.eLClick, OnCancelMainTraitChangeClicked );

function ChooseMainTrait(index)
	LuaEvents.ITG_CH_ChangeMainTrait(lastCustomH, index)
	OnDetailedCustomsHouse(lastCustomH)
	Controls.ChooseMainTraitPanel:SetHide(true)
end

function OnEmbargoClicked()
	if not Players[Game.GetActivePlayer()]:IsTurnActive() then
		return;
	end
	LuaEvents.ITG_CustomsHouseChangeEmbargo(Game.GetActivePlayer(), lastCustomH);
end
Controls.EmbargoTraitButton:RegisterCallback( Mouse.eLClick, OnEmbargoClicked )


LuaEvents.ITGSG_RefreshCHDetail.Add(function()
	UpdateScreen()
end)

function OnChangeMainTraitClicked()
	if not Players[Game.GetActivePlayer()]:IsTurnActive() then
		return;
	end
	LuaEvents.ITG_RequestAvMainTraitCH(lastCustomH)
	local gData = MapModData.ITGSG;
	MapModData.ITGSG = nil;
	g_TraitsMainCH:ResetInstances();
	local screenSizeX, screenSizeY = UIManager:GetScreenSizeVal();
	local iPerRow = math.max(3, math.floor(screenSizeX / 360))
	local iNumRows = math.ceil(#gData / iPerRow)
	
	for i, v in pairs(gData) do
    	local itemInstance = g_TraitsMainCH:GetInstance();
		itemInstance.NameZoneTrait:SetText( v[2] );
		itemInstance.DescriptionZoneTrait:SetText( v[3] )
		itemInstance.ButtonZoneTrait:SetVoid1( v[1] )
		itemInstance.ButtonZoneTrait:RegisterCallback( Mouse.eLClick, ChooseMainTrait )
		local yOffset = 33 - iNumRows * 68 + 136 * math.floor((i - 1) / iPerRow)
		local xOffset = 180 - iPerRow * 180 + 360 * ((i - 1) % iPerRow)

		itemInstance.ButtonZoneTrait:SetOffsetVal(xOffset, yOffset)
	end 
	Controls.ChooseMainTraitPanel:SetHide(false)
end
--Controls.ChangeZoneTrait:RegisterCallback( Mouse.eLClick, OnChangeMainTraitClicked )

function OnDetailedCustomsHouse(void1)
	if void1 then
		Controls.CustHouseDetailBox:SetHide(false)
		lastCustomH = void1;
	else
		Controls.CustHouseDetailBox:SetHide(true)
		return;
	end
	LuaEvents.ITGSG_RequestGT();
	local gData = MapModData.ITGSG;
	MapModData.ITGSG = nil;
	if not gData then
		return
	end
	local iCity = Map.GetPlotByIndex(gData.CustomsHouses[void1].City):GetPlotCity();
	local iOwner = Map.GetPlotByIndex(void1):GetOwner();
	local bDisableAll = iOwner ~= Game.GetActivePlayer();
	local bInActive = (not gData.CustomsHouses[void1].Active)

--	Controls.ChangeZoneTrait:SetHide(bDisableAll)
	Controls.BIRgold:SetText(gData.CustomsHouses[void1].BasicBonuses[1] .. "[ICON_GOLD]")
	Controls.BIRcurrency:SetText(gData.CustomsHouses[void1].BasicBonuses[2] .. "[ICON_INVEST]")
--	Controls.BIRtrademod:SetText(gData.CustomsHouses[void1].BasicBonuses[3] .. "%[ICON_GOLD]")
	Controls.BIRattract:SetText(gData.CustomsHouses[void1].BasicBonuses[4] .. "[ICON_TRADE_WHITE]")
	Controls.BIRvisitLog:SetText(#gData.CustomsHouses[void1].VisitLog .. "[ICON_INTERNATIONAL_TRADE]")
	local visLogTT = "Amount of international Trade-Routes that arrived to this city."
	for a, b in pairs(gData.CustomsHouses[void1].VisitLog) do
		if b[3] then
			visLogTT = visLogTT .. "[NEWLINE][ICON_BULLET]" .. b[2] .. "T [ICON_CARGO] from " .. Players[b[1]]:GetCivilizationShortDescription(); 
		else
			visLogTT = visLogTT .. "[NEWLINE][ICON_BULLET]" .. b[2] .. "T [ICON_CARAVAN] from " .. Players[b[1]]:GetCivilizationShortDescription(); 
		end
	end
	Controls.BIRvisitLog:SetToolTipString(visLogTT)

	local civInfo = GameInfo.Civilizations[Players[iOwner]:GetCivilizationType()];
	IconHookup(civInfo.PortraitIndex, 128, civInfo.AlphaIconAtlas, Controls.AlphaCivIcon)
	g_TraitsIncomingCH:ResetInstances();
	LuaEvents.ITG_Request_CH_Inc_Traits(void1)
	local bTraitsStrings = MapModData.ITGSG
	MapModData.ITGSG = nil;
	for j, hstring in pairs(bTraitsStrings.IntIncT) do
    	local itemInstance = g_TraitsIncomingCH:GetInstance();
		itemInstance.Text:SetText(hstring[2])
--		itemInstance.Root:SetSizeY(math.max(34, itemInstance.Text:GetSizeY() + 10))
		Controls.CustHousTraitLabel:SetText(hstring[1])
	end
    Controls.CustHousDetailStack:CalculateSize();
    Controls.CustHousDetailStack:ReprocessAnchoring();
    Controls.CustHousDetailsScroll:CalculateInternalSize();

--	Controls.NameZoneTrait:SetText(bTraitsStrings.MainTN)
--	Controls.DescriptionZoneTrait:SetText(bTraitsStrings.MainTS)

	local embargoOnCD = ((gData.CustomsHouses[void1].EmbargoCD or -1) >= gData.ITGTurn)
	Controls.EmbargoTraitButton:SetDisabled(bDisableAll or embargoOnCD or bInActive)
	if gData.CustomsHouses[void1].Embargo then
		if Teams[Game.GetActiveTeam()]:IsHasMet(Players[gData.CustomsHouses[void1].Embargo]:GetTeam()) then
			CivIconHookup( gData.CustomsHouses[void1].Embargo, 64, Controls.EmbargoIcon, Controls.EmbargoIconBG, Controls.EmbargoIconShadow, false, true );
		else
			CivIconHookup( -1, 64, Controls.EmbargoIcon, Controls.EmbargoIconBG, Controls.EmbargoIconShadow, false, true );
		end
		Controls.EmbargoIconFrame:SetHide(false)
		Controls.EmbargoNoneLabel:SetHide(true)
		if bDisableAll then
			Controls.EmbargoHelp:SetText("")
		elseif embargoOnCD then
			Controls.EmbargoHelp:SetText("Cannot be changed for another " .. (gData.CustomsHouses[void1].EmbargoCD + 1 - gData.ITGTurn) .. " turns.");
		else
			Controls.EmbargoHelp:SetText("Click to change.")
		end
	else
		Controls.EmbargoIconFrame:SetHide(true)
		Controls.EmbargoNoneLabel:SetHide(false)
		if bDisableAll then
			Controls.EmbargoHelp:SetText("")
		elseif embargoOnCD then
			Controls.EmbargoHelp:SetText("Cannot be established for another " .. (gData.CustomsHouses[void1].EmbargoCD + 1 - gData.ITGTurn) .. " turns.");
		else
			Controls.EmbargoHelp:SetText("Click to establish.")
		end
	end

--	if gData.CustomsHouses[void1].MainCD  > gData.ITGTurn then
--		Controls.ChangeZoneTrait:SetDisabled(true)
--		Controls.ChangeZoneTraitLabel:SetText(gData.CustomsHouses[void1].MainCD  - gData.ITGTurn .. "[ICON_LOCKED]")
--	else
--		Controls.ChangeZoneTrait:SetDisabled(bInActive)
--		Controls.ChangeZoneTraitLabel:SetText("Change")
--	end
--	Controls.ChangeZoneTrait:SetToolTipString("You can change Customs House's targeting preference every 30 turns.")

	local name = "[ICON_ITG_CUSTOMS_HOUSE] Customs House of " .. iCity:GetName()
	if bInActive then
		name = name .. " [ICON_RAZING]"
	end
	Controls.CustHousDetailName:SetText(name)

	local treshold = bTraitsStrings.Treshold;
	Controls.GPMeter:SetPercent( gData.CustomsHouses[void1].XP / treshold )
	Controls.GPMeter2:SetPercent( gData.CustomsHouses[void1].XP / treshold )
	Controls.MeterImage:SetToolTipString("Progress towards next upgrade: " .. gData.CustomsHouses[void1].XP .. "/" .. treshold .. "[ICON_ITG_CUSTOMS_HOUSE].[NEWLINE][NEWLINE]Each upgrade increases [ICON_GOLD] Gold by 1, [ICON_INVEST] Currency Power by 2 and [ICON_TRADE_WHITE] Trade Appeal by 2.[NEWLINE][NEWLINE]Progress is earned from:[NEWLINE][ICON_BULLET]+" .. bTraitsStrings.TurnXP .. " [ICON_ITG_CUSTOMS_HOUSE] per turn.[NEWLINE][ICON_BULLET]+" .. bTraitsStrings.GenXP .. " [ICON_ITG_CUSTOMS_HOUSE] each time City generates Trade-Route.[NEWLINE][ICON_BULLET]+" .. bTraitsStrings.IncomingXP .. " [ICON_ITG_CUSTOMS_HOUSE] each time foreign Trade-Route arrives to City.")
end

function Alphabetically(a, b)
	return Locale.Compare(a[2], b[2]) == -1;
end

function PurchaseCHFunct()
	if not Players[Game.GetActivePlayer()]:IsTurnActive() then
		return;
	end
	LuaEvents.ITG_PushLegalActionIfPossible(Game.GetActivePlayer(), 30)
	UpdateScreen()
end
Controls.PurchaseCH:RegisterCallback(Mouse.eLClick, PurchaseCHFunct)

function UpdateScreen(bNotInit)
	LuaEvents.ITGSG_RequestGT();
	local gData = MapModData.ITGSG;
	MapModData.ITGSG = nil;
	if not gData then
		return
	end
	local iTeam = Game.GetActiveTeam();
	local iPlayer = Game.GetActivePlayer();
	
	LuaEvents.ITG_BasicGovLegalRequest(30)
	local tabBuyNew = MapModData.ITGSG
	MapModData.ITGSG = nil;
	if tabBuyNew[1] then
		Controls.PurchaseCHLabel:SetText(tabBuyNew[3] .. " for Customs House")
		Controls.PurchaseCH:SetDisabled(not tabBuyNew[2])
		Controls.PurchaseCH:SetHide(false)
	else
		Controls.PurchaseCH:SetHide(true)
	end

	if lastCustomH then
		if not Map.GetPlotByIndex(lastCustomH):IsRevealed(Game.GetActiveTeam()) then
			lastCustomH = nil;
		end
	end

	g_ListCH:ResetInstances();
	local tabAlph = {}
	for index, gdd in pairs(gData.CustomsHouses) do
		if Map.GetPlotByIndex(index):IsRevealed(iTeam) then
			if (not bShowOnlyYours) or (gdd.Player == iPlayer) then
				table.insert(tabAlph, {index, Map.GetPlotByIndex(gdd.City):GetPlotCity():GetName(), gdd.Embargo})
			end
		end
	end
	table.sort(tabAlph, Alphabetically)
	for i, v in pairs(tabAlph) do
		local index = v[1]
		local gPlot = Map.GetPlotByIndex(index)
		local gPlayer = gPlot:GetOwner();
    	local itemInstance = g_ListCH:GetInstance();
		local dn = v[2];
				
		itemInstance.Base:SetDisabled(false)
		if not gData.CustomsHouses[index].Active then
			dn = dn .. " [ICON_RAZING]"
		end
		for jkb, cdb in pairs(gData.CustomsHouses[index].IncomingBonuses) do
			dn = dn .. " (" .. Locale.Lookup("TXT_KEY_CH_INCOMING_TR_TRAIT_NAME_" .. jkb) .. ")";
		end
		itemInstance.Description:SetText( dn );
		if v[3] then
			itemInstance.Embargo:SetText("Embargo: " .. GetPlayerNiceCivName(v[3]))
			itemInstance.Embargo:SetHide(false)
			itemInstance.Description:SetOffsetY(-8)
		else
			itemInstance.Embargo:SetHide(true)
			itemInstance.Description:SetOffsetY(0)
		end


		if(bTickTock == false) then
			itemInstance.Box:SetColorVal(unpack(ltBlue));
		else
			itemInstance.Box:SetColorVal(unpack(dkBlue));
		end
		CivIconHookup( gPlayer, 32, itemInstance.Icon, itemInstance.CivIconBG, itemInstance.CivIconShadow, false, true);  

		itemInstance.Base:SetVoid1(index)
		itemInstance.Base:RegisterCallback(Mouse.eLClick, OnDetailedCustomsHouse);

		local buttonWidth, buttonHeight = itemInstance.Base:GetSizeVal();
		itemInstance.Base:SetSizeVal(buttonWidth, 32);
		itemInstance.Box:SetSizeVal(buttonWidth + 20, 32);
		itemInstance.BounceAnim:SetSizeVal(buttonWidth + 20, 35);
		itemInstance.BounceGrid:SetSizeVal(buttonWidth + 20, 35);
		bTickTock = not bTickTock
	end
    Controls.CustomsHousesStack:CalculateSize();
    Controls.CustomsHousesStack:ReprocessAnchoring();
    Controls.CustomsHousesScroll:CalculateInternalSize();

	OnDetailedCustomsHouse(lastCustomH)
end

function OnShowOnlyYoursCH( bIsChecked )
	bShowOnlyYours = bIsChecked;
	UpdateScreen();
end
Controls.HideShowOnlyYoursCH:RegisterCheckHandler( OnShowOnlyYoursCH );

LuaEvents.ITG_CallCustomsHouse.Add(function(val2)
	lastCustomH = val2;
end)

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function ShowHideHandler( bIsHide, bInitState )
    if( not bIsHide ) then
    	UpdateScreen();
	end
end
ContextPtr:SetShowHideHandler( ShowHideHandler );

Controls.BGCustomHouse:SetAlpha(0.4)