
include( "IconSupport" );
include( "InstanceManager" );

local ltBlue = {19/255,32/255,46/255,120/255};
local ltGreen = {19/255,52/255,46/255,120/255};
local dkBlue = {12/255,22/255,30/255,120/255};
local cgData;
local selectedAction;
local selectedOutcome;
local bOnCloseTryNext = false;
local g_Actions= GenerationalInstanceManager:new( "DiploNoteInstance", "Button", Controls.ActionsStack);
local g_Outcomes= GenerationalInstanceManager:new( "DiploNoteInstance", "Button", Controls.OutcomesStack);
local g_Results= GenerationalInstanceManager:new( "DiploNoteInstance", "Button", Controls.ResultsStack);

function RequestedUI(bVoid)
   	if not ContextPtr:IsHidden() then
   		OnClose();
	else
		PopulateWithFirstFoundData(bVoid)
	   	UIManager:QueuePopup( ContextPtr, PopupPriority.InGameUtmost );
   	end
end
LuaEvents.ITG_RequestDiploNoteResolve.Add(RequestedUI)

function SelectAction(id)
	if cgData.Active then
		selectedAction = id;
		DoPopulateInfo()
	end
end

function SelectOutcome(id)
	if cgData.Active then
		selectedOutcome = id;
		DoPopulateInfo()
	end
end

function PopulateWithFirstFoundData(bVoid)
	selectedAction = nil;
	selectedOutcome = nil;
	if not bVoid then
		LuaEvents.ITG_RequestFirstDiploNote(Game.GetActivePlayer())
	end
	cgData = MapModData.ITGSG
	MapModData.ITGSG = nil;
	DoPopulateInfo()
end

function DoPopulateInfo()
	g_Actions:ResetInstances()
	g_Outcomes:ResetInstances()
	g_Results:ResetInstances()
	if not cgData then
		PopulateNoLongerValidData()
	else
		PopulateBasedOnCGData()
	end
	
	Controls.OutcomesStack:CalculateSize();
	Controls.OutcomesStack:ReprocessAnchoring();
    Controls.OutcomesScrollPanel:CalculateInternalSize();
	Controls.ActionsStack:CalculateSize();
	Controls.ActionsStack:ReprocessAnchoring();
    Controls.ActionsScrollPanel:CalculateInternalSize();
	Controls.ResultsStack:CalculateSize();
	Controls.ResultsStack:ReprocessAnchoring();
    Controls.ResultsScrollPanel:CalculateInternalSize();
end

function ResizeDNInstance(instance, x, y)
	instance.Button:SetSizeVal(x, y)
	instance.BoxColour:SetSizeVal(x, y)
	instance.SelBounceAnim:SetSizeVal(x, y + 6)
	instance.SelBounceGrid:SetSizeVal(x, y + 6)
	instance.BounceAnim:SetSizeVal(x, y + 6)
	instance.BounceGrid:SetSizeVal(x, y + 6)
	instance.bb1:SetSizeX(x)
	instance.bb2:SetSizeX(x)
end

function PopulateBasedOnCGData()
	LuaEvents.ITGSG_RequestGT();
	local gData = MapModData.ITGSG;
	MapModData.ITGSG = nil;
	if not gData then
		return;
	end
	local iPlayer = Game.GetActivePlayer();
	if cgData.GovID then
		Controls.LeaderButton:SetHide(false)
		if gData.Globals.Governors[cgData.GovID].Player ~= -1 then
			Controls.LeaderSubIconFrame:SetHide(false)
			CivIconHookup(gData.Globals.Governors[cgData.GovID].Player , 45, Controls.LeaderSubIcon, Controls.LeaderSubIconBG, Controls.LeaderSubIconShadow, true, true, Controls.LeaderSubIconHighlight);
		else
			Controls.LeaderSubIconFrame:SetHide(true)
		end
		IconHookup(gData.Globals.Governors[cgData.GovID].PIndex, 128, gData.Globals.Governors[cgData.GovID].IconAtlas, Controls.LeaderIcon);
		Controls.GovernorNameLabel:SetText("[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gData.Globals.Governors[cgData.GovID].Name) .. " (" .. gData.Globals.Governors[cgData.GovID].Power .. " [ICON_ITG_POWER])");
	else
		Controls.LeaderButton:SetHide(true)
		Controls.GovernorNameLabel:SetText("");
	end
	Controls.DescriptionText:SetText(cgData.MainText)
	Controls.DescriptionText:SetOffsetY((90 - Controls.DescriptionText:GetSizeY()) / 2 - 1)
	Controls.DiploActionNameLabel:SetText(string.upper(cgData.Headline))
	Controls.ConfirmButton:SetHide(not cgData.Active)
	Controls.ConfirmButton:SetDisabled(not selectedAction)
	Controls.CloseButtonLabel:SetText(Locale.Lookup("TXT_KEY_CLOSE"))
	if (not cgData.Active) and (#gData.Players[iPlayer].DiploNotes > 0) then
		bOnCloseTryNext = true;
		Controls.CloseButtonLabel:SetText("NEXT")
	else
		Controls.CloseButtonLabel:SetText(Locale.Lookup("TXT_KEY_CLOSE"))
	end
	for a, b in pairs(cgData.Actions) do
		if not b.Hide then
			local bSelected = (selectedAction == b.ID) or ((not cgData.Active) and (not b.Disabled))
			actionInstance = g_Actions:GetInstance();
			actionInstance.Name:SetText(b.Text or "")
			actionInstance.Description:SetText(b.Help or "")
			actionInstance.Button:SetToolTipString(b.ToolTip or "")
			actionInstance.Button:SetVoid1(b.ID)
			actionInstance.Description:SetWrapWidth(220)
			actionInstance.BounceAnim:SetHide((not cgData.Active) and (b.Disabled));
			actionInstance.Button:SetDisabled(b.Disabled);
			actionInstance.SelBounceAnim:SetHide(true)
			actionInstance.Button:RegisterCallback(Mouse.eLClick, SelectAction);
			ResizeDNInstance(actionInstance, 238, 42 + actionInstance.Description:GetSizeY())
			if (bSelected) then
				actionInstance.Button:SetAlpha(1);
				if cgData.Active then
					actionInstance.SelBounceAnim:SetHide(false)
					actionInstance.BoxColour:SetColorVal(unpack(ltGreen));
				else
					actionInstance.BoxColour:SetColorVal(unpack(ltBlue));
				end
				for c, d in pairs(b.Outcomes) do
					local bSelectedOutcome = (selectedOutcome == d.ID) or ((not cgData.Active) and (not d.Disabled))
					if d.Text ~= "VoidResultAlways" then
						outcomeInstance = g_Outcomes:GetInstance();
						outcomeInstance.Name:SetText(d.Text or "")
						outcomeInstance.Description:SetText(d.Help or "")
						outcomeInstance.Description:SetWrapWidth(220)
						outcomeInstance.SelBounceAnim:SetHide(true)
						outcomeInstance.Button:SetToolTipString(d.ToolTip or "")
						outcomeInstance.Button:SetVoid1(d.ID)
						outcomeInstance.BounceAnim:SetHide((not cgData.Active) and (d.Disabled));
						outcomeInstance.Button:SetDisabled(d.Disabled);
						ResizeDNInstance(outcomeInstance, 238, 42 + outcomeInstance.Description:GetSizeY())
						if (bSelectedOutcome) then
							outcomeInstance.Button:SetAlpha(1);
							if cgData.Active then
								outcomeInstance.SelBounceAnim:SetHide(false)
								outcomeInstance.BoxColour:SetColorVal(unpack(ltGreen));
							else
								outcomeInstance.BoxColour:SetColorVal(unpack(ltBlue));
							end
						else
							if cgData.Active then
								outcomeInstance.Button:SetAlpha(1);
							else
								outcomeInstance.Button:SetAlpha(0.2);
							end
							outcomeInstance.BoxColour:SetColorVal(unpack(dkBlue));
						end
						outcomeInstance.Button:RegisterCallback(Mouse.eLClick, SelectOutcome);
					end
					if (d.Text == "VoidResultAlways") or bSelectedOutcome then
						for e, f in pairs(d.Results) do
							resultInstance = g_Results:GetInstance();
							resultInstance.Name:SetText("")
							resultInstance.SelBounceAnim:SetHide(true)
							resultInstance.Description:SetText(f[1])
							resultInstance.Button:SetToolTipString(f[2])
							resultInstance.Description:SetWrapWidth(440)
							resultInstance.BounceAnim:SetHide(true);
							resultInstance.Button:SetDisabled(f.Disabled);
							resultInstance.Button:RegisterCallback(Mouse.eLClick, function() end);
							ResizeDNInstance(resultInstance, 476, 42 + resultInstance.Description:GetSizeY())
							if (not f.Disabled) then
								resultInstance.Button:SetAlpha(1);
								resultInstance.BoxColour:SetColorVal(unpack(ltBlue));
							else
								resultInstance.Button:SetAlpha(0.2);
								resultInstance.BoxColour:SetColorVal(unpack(dkBlue));
							end
						end
					end
				end
			else
				if cgData.Active then
					if b.Disabled then
						actionInstance.Button:SetAlpha(0.5)
					else
						actionInstance.Button:SetAlpha(1);
					end
				else
					actionInstance.Button:SetAlpha(0.2);
				end
				actionInstance.BoxColour:SetColorVal(unpack(dkBlue));
			end
		end
	end
end

function PopulateNoLongerValidData()
	LuaEvents.ITGSG_RequestGT();
	local gData = MapModData.ITGSG;
	MapModData.ITGSG = nil;
	if not gData then
		return;
	end
	local iPlayer = Game.GetActivePlayer();
	Controls.LeaderButton:SetHide(true)
	Controls.GovernorNameLabel:SetText("");
	Controls.DiploActionNameLabel:SetText("OUTDATED ACTION");
	Controls.DescriptionText:SetText("It seems that this diplomatic action is outdated (prerequisites are no longer met). No effect took place.")
	Controls.ConfirmButton:SetHide(true)
	Controls.DescriptionText:SetOffsetY((90 - Controls.DescriptionText:GetSizeY()) / 2 - 1)
	if (#gData.Players[iPlayer].DiploNotes > 0) then
		bOnCloseTryNext = true;
		Controls.CloseButtonLabel:SetText("NEXT")
	else
		Controls.CloseButtonLabel:SetText(Locale.Lookup("TXT_KEY_CLOSE"))
	end
end

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function InputHandler( uiMsg, wParam, lParam )
    ----------------------------------------------------------------        
    -- Key Down Processing
    ----------------------------------------------------------------        
    if(uiMsg == KeyEvents.KeyDown) then
        if (wParam == Keys.VK_ESCAPE) then
			OnClose();
			return true;
        end
        
        -- Do Nothing.
        if(wParam == Keys.VK_RETURN) then
			return true;
        end
    end
end
ContextPtr:SetInputHandler( InputHandler );
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function OnClose()
	if bOnCloseTryNext then
		bOnCloseTryNext = false;
		PopulateWithFirstFoundData()	
	else
		UIManager:DequeuePopup(ContextPtr);
	end
end
Controls.CloseButton:RegisterCallback(Mouse.eLClick, OnClose);

function OnConfirm()
	if cgData.VoidEvent then
		LuaEvents.ITG_HumanResolveVoidedDiploNote(cgData.SelfID, selectedAction, cgData.GovID);
	else
		LuaEvents.ITG_HumanAnswerDiploNote(selectedAction);
	end
	cgData = MapModData.ITGSG; 
	MapModData.ITGSG = nil;
	selectedAction = nil;
	selectedOutcome = nil;
	DoPopulateInfo()
	LuaEvents.ITG_RequestAllDirtyPlayer();
end
Controls.ConfirmButton:RegisterCallback(Mouse.eLClick, OnConfirm);
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function ShowHideHandler( bIsHide, bInitState )
	CivIconHookup( 0, 64, Controls.Icon, Controls.CivIconBG, Controls.CivIconShadow, false, true );
    if( not bInitState ) then
        if( not bIsHide ) then
        	UI.incTurnTimerSemaphore();  
 --       	Events.SerialEventGameMessagePopupShown(g_PopupInfo);
        else
			if(g_PopupInfo ~= nil) then
--				Events.SerialEventGameMessagePopupProcessed.CallImmediate(g_PopupInfo.Type, 0);
            end
            UI.decTurnTimerSemaphore();
        end
    end
end
ContextPtr:SetShowHideHandler( ShowHideHandler );

----------------------------------------------------------------
-- 'Active' (local human) player has changed
----------------------------------------------------------------
function OnActivePlayerChanged()
	--if (not Controls.ChooseConfirm:IsHidden()) then
	--	Controls.ChooseConfirm:SetHide(true);
	--end
end
Events.GameplaySetActivePlayer.Add(OnActivePlayerChanged);

ContextPtr:SetHide(true)