-------------------------------------------------
-- Happiness Info
-------------------------------------------------
include( "IconSupport" );
include( "InstanceManager" );

local bShowDead = true;
local bShowEmigration = true;
local bShowCivilian = true;
local bShowMilitary = true;
local bHeadhunting = false;
local GetSeason = {"Spring", "Summer", "Autumn", "Winter"}
function GetTextDate(turn, StartDate)
	local year = -4000 + math.floor((StartDate + turn)/4);
	local season = GetSeason[(StartDate + turn)%4 + 1];
	if year < 0 then
	--season .. " " .. -year .. " BC";
		return -year .. " BC";
	else
		return year .. " AD";
	end
end
function GetNiceShortCityDescription(index)
	local iPlot = Map.GetPlotByIndex(index)
	if iPlot:IsRevealed(Game.GetActiveTeam()) or Teams[Game.GetActiveTeam()]:IsHasMet(Players[iPlot:GetOwner()]:GetTeam()) then
		return iPlot:GetPlotCity():GetName()
	end
	return "Unknown";
end

function GetNiceShortDescription(i)
	if i == Game.GetActivePlayer() or Teams[Game.GetActiveTeam()]:IsHasMet(Players[i]:GetTeam()) then
		return Players[i]:GetCivilizationShortDescription()
	else
		return "Unknown";
	end
end
function GetNicePlayerID(i)
	if i == Game.GetActivePlayer() or Teams[Game.GetActiveTeam()]:IsHasMet(Players[i]:GetTeam()) then
		return i;
	else
		return -1;
	end
end

function OnCenterGP(index)
	LuaEvents.ITG_RequestCenterGP(index)
end

function OnHeadhunterCalled(void1)
	if Players[Game.GetActivePlayer()]:IsTurnActive() then
		LuaEvents.ITGDoCallHeadhunter(Game.GetActivePlayer(), void1)
		UpdateScreen()
	end
end
-------------------------------------------------
-------------------------------------------------
function UpdateScreen()

	local iPlayer = Game.GetActivePlayer();
	if bHeadhunting then
		LuaEvents.ITGSG_RequesUpdateHeadhunterOptions();
	end
	LuaEvents.ITGSG_RequestGT();
	local gData = MapModData.ITGSG;
	MapModData.ITGSG = nil;
	if (not gData) or (not gData.Players[iPlayer]) then
		return
	end
	local iHeadhuntCD = (gData.Players[iPlayer].HeadhuntCD or -1) - gData.ITGTurn; 

	LuaEvents.ITGSG_RequestGPChances(iPlayer);
	local hRtH = MapModData.ITGSG;
	MapModData.ITGSG = nil;
	for i = 1, 10 do
		Controls["GPchances" .. i]:SetHide(true);
	end
	for j, h in pairs(hRtH) do
		if h[2] ~= 0 then
			Controls["GPchances" .. h[1]]:SetText(h[2] .. "%" .. h[4])
			Controls["GPchances" .. h[1]]:SetToolTipString(h[3])
			Controls["GPchances" .. h[1]]:SetHide(false);
		end
	end

	Controls.MainStack:DestroyAllChildren(); 

	local function DoAddGPInstance(i, v, alpha, addtext, price, indexHH)
			local instance = {};
			LuaEvents.ITGSG_RequestGPInfoForOverview(i);
			local gpInfo = MapModData.ITGSG;
			MapModData.ITGSG = nil;
			ContextPtr:BuildInstanceForControl( "GPInstance", instance, Controls.MainStack );
			IconHookup(gpInfo.PortraitIndex, 128, gpInfo.IconAtlas, instance.LeaderPortrait);
			CivIconHookup(GetNicePlayerID(v.OriginPlayer), 64, instance.CivSymbol, instance.CivIconBG, instance.CivIconShadow, false, true);
			local namestring = gpInfo.Name; 
			instance.GPName:SetText(namestring .. addtext);
			instance.Button:SetAlpha(alpha)
			instance.GPBDied:SetHide(true)
			if v.TurnDied then
				if v.Retired then
					instance.GPBDied:SetText("Retired: " .. GetTextDate(v.TurnDied, gData.Globals.StartDate))
				else
					instance.GPBDied:SetText("Death: " .. GetTextDate(v.TurnDied, gData.Globals.StartDate))
				end
				instance.GPBDied:SetHide(false)
				instance.GPLocation:SetHide(true)
			else
				instance.GPLocation:SetHide(false)
			end
			if gpInfo.MigrationData[1] then
				instance.GPMigrateMeter:SetText(gpInfo.MigrationData[2])
				instance.GPMigrateMeter:SetToolTipString(gpInfo.MigrationData[3])
				instance.GPMigrateMeter:SetHide(false)
			else
				instance.GPMigrateMeter:SetHide(true)
			end
			instance.GPType:SetText(Locale.Lookup(gpInfo.NameType))
			instance.GPBorn:SetText("Ascendancy: " .. GetTextDate(v.Ascendancy, gData.Globals.StartDate))
			if v.OriginCity then
				local octt = GetNiceShortCityDescription(v.OriginCity);
				if octt == "Unknown" then
					instance.GPOrigin:SetText("Origin: Unknown")
				else
					instance.GPOrigin:SetText("Origin: " .. octt .. " (" .. GetNiceShortDescription(v.OriginPlayer) .. ")");
				end		
			else
				instance.GPOrigin:SetText("Origin: " .. GetNiceShortDescription(v.OriginPlayer))
			end

			local locationstring;
			if v.Military then
				for iUnit in Players[iPlayer]:Units() do
					local uID = iUnit:GetID() .. "," .. iPlayer .. "," .. iUnit:GetGameTurnCreated();
					if gData.Players[iPlayer].UnitsByID[uID] then
						if gData.Players[iPlayer].UnitsByID[uID].GreatPersonID == i then
							locationstring = "Unit: " .. Locale.Lookup(GameInfo.Units[iUnit:GetUnitType()].Description)
							break;
						end
					end
				end
				if not locationstring then
					locationstring = "Unassigned";
				end
			else
				if v.City then
					local iPlot = Map.GetPlotByIndex(v.City);
					local iCity = iPlot:GetPlotCity();
					locationstring = "City: " .. iCity:GetName();
				end
				if not locationstring then
					locationstring = "Travelling";
				end
			end
			instance.GPLocation:SetText(locationstring)
			if v.CultEra then
				instance.GPArtStyle:SetText(gData.Globals.CultureErasNames[v.CultEraType][v.CultEra])
			end
			instance.GPArtStyle:SetHide((not v.CultEra))		
			if v.Religion then
				instance.GPReligion:SetText("Religion: " .. GameInfo.Religions[v.Religion].IconString .. " " .. Locale.Lookup(GameInfo.Religions[v.Religion].Description))
			end
	--		instance.GPReligion:SetHide((not v.Religion) or gData.Players[iPlayer].OfficialReligion)
			instance.GPReligion:SetHide((not v.Religion))		
			--
			local bAny = false;
			if v.CanBeAssassinated then
				instance.SpyKillable:SetHide(false)
				instance.Div2:SetHide(false)
				bAny = true;
			else
				instance.SpyKillable:SetHide(true)
				instance.Div2:SetHide(true)
			end
			if v.Science then
				instance.ScienceGPC:SetText(v.Science .. "[ICON_RESEARCH]")
				instance.ScienceGPC:SetHide(false)
				instance.Div3:SetHide(false)
				bAny = true;
			else
				instance.ScienceGPC:SetHide(true)
				instance.Div3:SetHide(true)
			end
			if v.Legal then
				instance.LegalGPC:SetText(v.Legal / 100 .. "[ICON_ITG_LEGAL_POWER]")
				instance.LegalGPC:SetHide(false)
				instance.Div4:SetHide(false)
				bAny = true;
			else
				instance.LegalGPC:SetHide(true)
				instance.Div4:SetHide(true)
			end
			if v.Production then
				instance.ProdGPC:SetText(v.Production .. "[ICON_PRODUCTION]")
				instance.ProdGPC:SetHide(false)
				instance.Div5:SetHide(false)
				bAny = true;
			else
				instance.ProdGPC:SetHide(true)
				instance.Div5:SetHide(true)
			end
			if v.Faith then
				instance.FaithGPC:SetText(v.Faith .. "[ICON_PEACE]")
				instance.FaithGPC:SetHide(false)
				instance.Div6:SetHide(false)
				bAny = true;
			else
				instance.FaithGPC:SetHide(true)
				instance.Div6:SetHide(true)
			end
			if v.HapChance then
				instance.HapGPC:SetText(v.HapChance .. "%[ICON_HAPPINESS_1]")
				instance.HapGPC:SetHide(false)
				instance.Div7:SetHide(false)
				bAny = true;
			else
				instance.HapGPC:SetHide(true)
				instance.Div7:SetHide(true)
			end

			if v.ArtPoints then
				instance.ArtGPC:SetText(v.ArtPoints .. "[ICON_GREAT_ARTIST]")
				instance.ArtGPC:SetHide(false)
				instance.Div8:SetHide(false)
				bAny = true;
			else
				instance.ArtGPC:SetHide(true)
				instance.Div8:SetHide(true)
			end
			if v.WonderPoints then
				instance.WonderGPC:SetText(v.WonderPoints .. "[ICON_GREAT_ENGINEER]")
				instance.WonderGPC:SetHide(false)
				instance.Div9:SetHide(false)
				bAny = true;
			else
				instance.WonderGPC:SetHide(true)
				instance.Div9:SetHide(true)
			end
			if v.GPPoints then
				instance.GreatPeopleGPC:SetText(v.GPPoints .. "[ICON_GREAT_PEOPLE]")
				instance.GreatPeopleGPC:SetHide(false)
				instance.Div10:SetHide(false)
				bAny = true;
			else
				instance.GreatPeopleGPC:SetHide(true)
				instance.Div10:SetHide(true)
			end
			if v.Archaeology then
				instance.ArchaeologyGPC:SetText(v.Archaeology .. "[ICON_RES_ARTIFACTS]")
				instance.ArchaeologyGPC:SetHide(false)
				instance.Div13:SetHide(false)
				bAny = true;
			else
				instance.ArchaeologyGPC:SetHide(true)
				instance.Div13:SetHide(true)
			end

			if v.DNIC then
				instance.DNICGPC:SetHide(false)
				instance.Div11:SetHide(false)
				bAny = true;
			else
				instance.DNICGPC:SetHide(true)
				instance.Div11:SetHide(true)
			end

			if v.ICTAO then
				instance.GCFNofkindGPC:SetHide(false)
				instance.GCFNofkindGPC:SetText(gpInfo.IconString or "[ICON_ITG_MENTOR]")
				instance.Div12:SetHide(false)
				bAny = true;
			else
				instance.GCFNofkindGPC:SetHide(true)
				instance.Div12:SetHide(true)
			end
			instance.Div1:SetHide(not bAny)
			
	--		instance.InfoStack:CalculateSize();
	--		instance.InfoStack:ReprocessAnchoring();
	--		instance.InfoScroll:CalculateInternalSize();
			LuaEvents.ITGSG_RequestGPAbilities(i);
			local shabData = MapModData.ITGSG;
			MapModData.ITGSG = nil;
			--
			local abilitystring = "[COLOR_POSITIVE_TEXT]TALENT: [ENDCOLOR]" .. (v.LifeDone or shabData.Help);
			if v.Type == 1 or v.Type == 2 then
				if gData.Players[iPlayer].CultBonusOn[114] then
					abilitystring = abilitystring .. "[NEWLINE][COLOR_POSITIVE_TEXT]SECONDARY TALENT: [ENDCOLOR]" .. shabData.SecHelp;
				end
			end
			instance.Abilities:SetText(abilitystring)
			instance.PlayerInfoStack:CalculateSize()
			local newSizeY = math.max(136, instance.Abilities:GetSizeY() + 30);
			newSizeY = math.max(instance.PlayerInfoStack:GetSizeY() + 10, newSizeY);
			instance.Button:SetSizeY(newSizeY);
			instance.ButtonAnim:SetSizeY(newSizeY);
			instance.ButtonAnimGrid:SetSizeY(newSizeY+5);

			-- price, chance, indexHH
			instance.HeadhunterButton:SetHide(not bHeadhunting)
			instance.FindOnMapButton:SetHide(bHeadhunting)
			
			if bHeadhunting then
				instance.HeadhunterButton:SetDisabled((iHeadhuntCD > 0) or (Players[iPlayer]:GetGold() < price))
				if iHeadhuntCD > 0 then
					instance.HeadhunterButton:SetToolTipString("Operation is unavailable for the next " .. iHeadhuntCD .. " turn(s).")
				else
					instance.HeadhunterButton:SetToolTipString("Displays [ICON_GOLD] Gold cost of an operation.")
				end				
				instance.HeadhunterButtonLabel:SetText(price .. "[ICON_GOLD]")
				instance.HeadhunterButton:SetVoid1(indexHH)
				instance.HeadhunterButton:RegisterCallback( Mouse.eLCLick, OnHeadhunterCalled);
			else
				instance.FindOnMapButton:SetVoid1(i)
				instance.FindOnMapButton:RegisterCallback( Mouse.eLCLick, OnCenterGP);
			end
		--	gpidinstance = instance;
	end
	local bCanHeadhunt = (Players[iPlayer]:GetNumCities() > 0) and gData.Players[iPlayer].CanHeadhunt;
	if bHeadhunting then
		if not bCanHeadhunt then
			bHeadhunting = false;
		end
	end
	Controls.HeadhunterButton:SetHide(not bCanHeadhunt)
	-- show button at bottom
	if bHeadhunting then
		for i, v in pairs(gData.Players[iPlayer].HeadhuntingData) do
			local alpha = 1;
			local namestring = " - [COLOR_POSITIVE_TEXT]Bribe[ENDCOLOR]"
			DoAddGPInstance(v.GP, gData.GreatPeople[v.GP], alpha, namestring, v.Price, i)
		end
		Controls.HeadhunterLabel:SetText("Back to List")
	else
		for i,v in pairs(gData.GreatPeople) do
			if (v.Player == iPlayer) and ((bShowMilitary and v.Military) or (bShowCivilian and (not v.Military))) then
				if bShowDead or (v.Alive) then
					local namestring = ""
					local alpha = 1;
					if not v.Alive then
						if v.Retired then
							namestring = " - [COLOR_NEGATIVE_TEXT]Retired[ENDCOLOR]"
						else
							namestring = " - [COLOR_NEGATIVE_TEXT]Dead[ENDCOLOR]"
						end
						alpha = 0.6
					end
					DoAddGPInstance(i, v, alpha, namestring)
				end
			end
		end
		if bShowEmigration then
			for gpID, sth in pairs(gData.Players[iPlayer].CapturedGP) do
				DoAddGPInstance(gpID, gData.GreatPeople[gpID], 0.6, " - [COLOR_NEGATIVE_TEXT]Captured[ENDCOLOR]")
			end
			for gpID, sth in pairs(gData.Players[iPlayer].EmigratedGP) do
				DoAddGPInstance(gpID, gData.GreatPeople[gpID], 0.6, " - [COLOR_NEGATIVE_TEXT]Emigrated[ENDCOLOR]")
			end
		end
		Controls.HeadhunterLabel:SetText("Headhunting")
	end

    Controls.MainStack:CalculateSize();
    Controls.MainStack:ReprocessAnchoring();
    Controls.MainScroll:CalculateInternalSize();

end

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function ShowHideHandler( bIsHide, bInitState )
    if( not bIsHide ) then
		Controls.OptionsPanel:SetHide(true);
    	UpdateScreen();
	end
end
ContextPtr:SetShowHideHandler( ShowHideHandler );

function OnHeadhunterButton()
	bHeadhunting = (not bHeadhunting);
	UpdateScreen()
end
Controls.HeadhunterButton:RegisterCallback( Mouse.eLCLick, OnHeadhunterButton);

function OnCheckOnlyPresent( bIsChecked )
	bShowEmigration = bIsChecked;
	if not bHeadhunting then
		UpdateScreen();
	end
end
Controls.CheckOnlyPresent:RegisterCheckHandler( OnCheckOnlyPresent );

function OnCheckOnlyAlive( bIsChecked )
	bShowDead = bIsChecked;
	if not bHeadhunting then
		UpdateScreen();
	end
end
Controls.CheckOnlyAlive:RegisterCheckHandler( OnCheckOnlyAlive );

function OnCheckMilitary( bIsChecked )
	bShowMilitary = bIsChecked;
	if not bHeadhunting then
		UpdateScreen();
	end
end
Controls.CheckMilitary:RegisterCheckHandler( OnCheckMilitary );

function OnCheckNonMilitary( bIsChecked )
	bShowCivilian = bIsChecked;
	if not bHeadhunting then
		UpdateScreen();
	end
end
Controls.CheckNonMilitary:RegisterCheckHandler( OnCheckNonMilitary );

function OnOptions()	
	Controls.OptionsPanel:SetHide( not Controls.OptionsPanel:IsHidden() );
end
Controls.OptionsButton:RegisterCallback( Mouse.eLClick, OnOptions );
Controls.MainOptionStack:CalculateSize();
Controls.OptionsPanel:DoAutoSize();

Controls.HelpImageId1:SetAlpha(0.25)