-------------------------------------------------
-- Happiness Info
-------------------------------------------------
include( "IconSupport" );
include( "InstanceManager" );

local m_Inspiration_IM = InstanceManager:new("InspirationInstance", "Button", Controls.MainStack);

-------------------------------------------------
-------------------------------------------------
function UpdateScreen()

	local iPlayer = Game.GetActivePlayer();
	LuaEvents.ITGSG_RequestGT();
	local gData = MapModData.ITGSG;
	MapModData.ITGSG = nil;
	if not gData then
		return
	end
	LuaEvents.ITG_RequestInspirationDB()
	local InspHelpTab = MapModData.ITGSG;
	MapModData.ITGSG = nil;
	m_Inspiration_IM:ResetInstances()
	local bHaveAny = false;
	for iClass, iType in pairs(gData.Players[iPlayer].Inspirations) do
		local controlTable = m_Inspiration_IM:GetInstance();
		local buildingType = Players[iPlayer]:GetPlayerUniqueBuilding( iClass);
		local bHasBuilding = buildingType ~= -1;
		if not bHasBuilding then
			buildingType = GameInfoTypes[GameInfo.BuildingClasses[iClass].DefaultBuilding]
			controlTable.Button:SetAlpha(0.75)
			controlTable.Button:SetToolTipString("It seems you cannot construct this building in current Scenario.")
		else
			controlTable.Button:SetAlpha(1);
			controlTable.Button:SetToolTipString("")
		end
		IconHookup( GameInfo.Buildings[buildingType].PortraitIndex, 64, GameInfo.Buildings[buildingType].IconAtlas, controlTable.Icon1 );
		
		controlTable.InspBuilding:SetText(Locale.Lookup(GameInfo.Buildings[buildingType].Description) .. " of " .. InspHelpTab[iType].Name)
		controlTable.InspHelp:SetText(InspHelpTab[iType].Reward)
		bHaveAny = true;
	end
	Controls.NoInspAvailable:SetHide(bHaveAny);
    Controls.MainStack:CalculateSize();
    Controls.MainStack:ReprocessAnchoring();
    Controls.MainScroll:CalculateInternalSize();
end

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function ShowHideHandler( bIsHide, bInitState )
    if( not bIsHide ) then
    	UpdateScreen();
	end
end
ContextPtr:SetShowHideHandler( ShowHideHandler );
