-------------------------------------------------
-- ITG CustomsHouse
-------------------------------------------------
include( "IconSupport" );
include( "InstanceManager" );

local g_ListCH = GenerationalInstanceManager:new( "MFListInstance", "Base", Controls.ManufactoriesStack);
local g_DetailsTraits = GenerationalInstanceManager:new( "ManuTraitInstance", "ButtonTrait", Controls.ManuDetailTraitStack);
local g_ChooseTraits = GenerationalInstanceManager:new( "ManuTraitInstance", "ButtonTrait", Controls.ChooseMainTraitPanel);

-------------------------------------------------
-------------------------------------------------
local lastManu;
local ltBlue = {19/255,32/255,46/255,120/255};
local dkBlue = {12/255,22/255,30/255,120/255};
local bTickTock = false;
local bShowOnlyYours = true;
local typeUbb = 1;

function ChooseMainTrait(id)
	LuaEvents.ITG_ChosenTraitForManufactory(lastManu, id)
	Controls.ChooseMainTraitPanel:SetHide(true)
	UpdateScreen()
end

function DoDisplayNewTraitOptions(void1)
	if not Players[Game.GetActivePlayer()]:IsTurnActive() then
		return;
	end
	LuaEvents.ITG_RequestChooseTraitMF(void1)
	local gData = MapModData.ITGSG;
	MapModData.ITGSG = nil;
	g_ChooseTraits:ResetInstances();
	local screenSizeX, screenSizeY = UIManager:GetScreenSizeVal();
	screenSizeY = screenSizeY - 120;
	local baseYChange = -10;
	local baseXChange = 0;
	local dimX, dimY = 698,116
	local spacing = 20;
	local iPerRow = math.max(2, math.floor(screenSizeX / (dimX + spacing)))
	local iNumRows = math.ceil(#gData.Traits / iPerRow)
	
	for i, v in pairs(gData.Traits) do
    	local itemInstance = g_ChooseTraits:GetInstance();
		itemInstance.NameTrait:SetText( v[2] );
		itemInstance.DescriptionTrait:SetText( v[3] )
		itemInstance.ButtonTrait:SetVoid1( v[1] )
		itemInstance.ButtonTrait:RegisterCallback( Mouse.eLClick, ChooseMainTrait )
		local yOffset = baseYChange + spacing + (dimY - iNumRows * (dimY + spacing)) / 2 + (dimY + spacing) * math.floor((i - 1) / iPerRow)
		local xOffset = baseXChange + spacing + (dimX - iPerRow * (dimX + spacing)) / 2 + (dimX + spacing) * ((i - 1) % iPerRow)


		if(((i - 1) + math.floor((i - 1) / iPerRow) ) % 2 == 1 ) then
			itemInstance.BoxZoneTrait:SetColorVal(unpack(ltBlue));
		else
			itemInstance.BoxZoneTrait:SetColorVal(unpack(dkBlue));
		end
		bTickTock = not bTickTock

		itemInstance.ButtonTrait:SetOffsetVal(xOffset, yOffset)
	end 

	Controls.MFTraitLabelToChoose:SetText("CHOOSE AN ABILITY FOR " .. string.upper(gData.Name))
	Controls.ChooseMainTraitPanel:SetHide(false)
end

function OnCancelChoosingTrait()
	Controls.ChooseMainTraitPanel:SetHide(true)
end
Controls.CancelChangingMainTrait:RegisterCallback( Mouse.eLClick, OnCancelChoosingTrait );

LuaEvents.ITG_CallManufactory.Add(function(val2)
	lastManu = val2;
end)

function OnFindOnMapButtonClicked ()
	UI.LookAt(Map.GetPlotByIndex(lastManu), 0);
end
Controls.FindOnMapButton:RegisterCallback( Mouse.eLClick, OnFindOnMapButtonClicked );

function OnShowOnlyYoursCH( bIsChecked )
	bShowOnlyYours = bIsChecked;
	UpdateScreen();
end
Controls.HideShowOnlyYoursCH:RegisterCheckHandler( OnShowOnlyYoursCH );

function OnDetailedManufactory(void1)
	if void1 then
		Controls.ManudemyDetailBox:SetHide(false)
		lastManu = void1;
	else
		Controls.ManudemyDetailBox:SetHide(true)
		return;
	end
	LuaEvents.ITGSG_RequestGT();
	local gData = MapModData.ITGSG;
	MapModData.ITGSG = nil;
	if not gData then
		return
	end
	local iCity = Map.GetPlotByIndex(gData.Manufactories[void1].City):GetPlotCity();
	local iOwner = Map.GetPlotByIndex(void1):GetOwner();
	local bNotOwned = iOwner ~= Game.GetActivePlayer();
	local bInActive = (not gData.Manufactories[void1].Active)

	LuaEvents.ITG_Request_ManufactoryDetails(void1)
	local bTraitsStrings = MapModData.ITGSG
	MapModData.ITGSG = nil;

	Controls.UpdateButton:SetHide(bNotOwned)

	Controls.DisactiveManufactoryBox:SetHide(not bInActive);
	if bInActive then
		if gData.Manufactories[void1].SpecDisactive then
			if MapModData.DBScenario.MF_RequireRes then
				Controls.DisactiveManufactoryLabel:SetText("Insufficient resource!")
			else
				Controls.DisactiveManufactoryLabel:SetText(">>>???")
			end
		else
			Controls.DisactiveManufactoryLabel:SetText("Pillaged!")
		end
	else
		Controls.DisactiveManufactoryLabel:SetText("")
	end

	g_DetailsTraits:ResetInstances()
	for i, v in pairs(bTraitsStrings.Traits) do
		local itemInstance = g_DetailsTraits:GetInstance();
		itemInstance.NameTrait:SetText(v[1])
		itemInstance.DescriptionTrait:SetText(v[2])

		if(bTickTock == false) then
			itemInstance.BoxZoneTrait:SetColorVal(unpack(ltBlue));
		else
			itemInstance.BoxZoneTrait:SetColorVal(unpack(dkBlue));
		end
		bTickTock = not bTickTock
	end
	if not bNotOwned then
		if #gData.Manufactories[void1].ToChoose > 0 then
			DoDisplayNewTraitOptions(void1)
			typeUbb = 1;
			Controls.UpdateButtonLabel:SetText("CHOOSE NEW ABILITY FOR MANUFACTORY")
			Controls.UpdateButton:SetDisabled(false)
			Controls.UpdateButton:SetToolTipString("")
		elseif (not MapModData.DBScenario.MF_UpgradeCost100) then
			Controls.UpdateButton:SetHide(true);
		else
			typeUbb = 2;
			Controls.UpdateButtonLabel:SetText("UPGRADE MANUFACTORY WITH NEW TRAIT (" .. bTraitsStrings.UpCost .. ")")
			Controls.UpdateButton:SetDisabled(not bTraitsStrings.UpPossible)
			if MapModData.DBScenario.StrategicResStorage then
				Controls.UpdateButton:SetToolTipString("In order to upgrade Manufactory you need to pay with stored resources and lump sum of [ICON_GOLD] Gold.[NEWLINE][NEWLINE]Right now you have [COLOR_POSITIVE_TEXT]" .. bTraitsStrings.iAvailable .. "[ENDCOLOR] " .. bTraitsStrings.FullText .. ".")
			elseif MapModData.DBScenario.MF_Resource then
				Controls.UpdateButton:SetToolTipString("In order to upgrade Manufactory you need to have enough total amount of strategic resource and pay lump sum of [ICON_GOLD] Gold.[NEWLINE][NEWLINE]Right now you have [COLOR_POSITIVE_TEXT]" .. bTraitsStrings.iAvailable .. "[ENDCOLOR] " .. bTraitsStrings.FullText .. ".")
			elseif gData.Globals.ScenarioType == 1 then
				Controls.UpdateButton:SetToolTipString("In order to upgrade Manufactory you need to have enough population and pay lump sum of [ICON_GOLD] Gold.[NEWLINE][NEWLINE]Right now you have [COLOR_POSITIVE_TEXT]" .. bTraitsStrings.iAvailable .. "[ENDCOLOR] " .. bTraitsStrings.FullText .. ".")
			elseif gData.Globals.ScenarioType == 3 then
				Controls.UpdateButton:SetToolTipString("In order to upgrade Manufactory you need to have enough resources and pay lump sum of [ICON_GOLD] Gold.[NEWLINE][NEWLINE]Right now you have [COLOR_POSITIVE_TEXT]" .. bTraitsStrings.iAvailable .. "[ENDCOLOR] " .. bTraitsStrings.FullText .. ".")
			else
				Controls.UpdateButton:SetToolTipString("???");
			end
			if bTraitsStrings.DoneWithUp then
				Controls.UpdateButton:SetHide(true);
			end
		end
	end
	Controls.UpdateButton:SetSizeX(Controls.UpdateButtonLabel:GetSizeX() + 35)
    Controls.ManuDetailTraitStack:CalculateSize();
    Controls.ManuDetailTraitStack:ReprocessAnchoring();
    Controls.ManuDetailStack:CalculateSize();
    Controls.ManuDetailStack:ReprocessAnchoring();
    Controls.ManuDetailsScroll:CalculateInternalSize();

	local sName = "[ICON_ITG_MANUFACTORY] " ..  gData.Manufactories[void1].Name;
	if bInActive then
		sName = sName .. " [ICON_BLOCKADED]"
	end
	Controls.ManuDetailFounded:SetText(gData.Manufactories[void1].Year)
	Controls.ManuDetailName:SetText(sName)
	Controls.MFprod:SetText(bTraitsStrings.BaseProd + gData.Manufactories[void1].ActiveProd .. "[ICON_PRODUCTION]")
	Controls.MFwonder:SetText(gData.Manufactories[void1].WonderP .. "[ICON_GREAT_ENGINEER]")
	Controls.MFwonder:SetHide(gData.Globals.NoMoreWonderRace);
	Controls.MFactiveT:SetText(gData.Manufactories[void1].TActive .. "[ICON_ITG_MANUFACTORY]")
	if MapModData.DBScenario.MF_RequireRes then
		if bTraitsStrings.DoneWithUp then
			Controls.MFresource:SetText((MapModData.DBScenario.MF_ImproCost100 / 100 + MapModData.DBScenario.MF_UpgradeCost100 / 100)  .. bTraitsStrings.IconString)
		else
			Controls.MFresource:SetText(MapModData.DBScenario.MF_ImproCost100 / 100  .. bTraitsStrings.IconString)
		end
	end
	Controls.MFresource:SetHide(not MapModData.DBScenario.MF_RequireRes)
	local mfrtt = "Displays amount of resource needed for Manufactory to be operative (have traits active)."
	if not bNotOwned then
		mfrtt = mfrtt .. "[NEWLINE][NEWLINE]Right now you have [COLOR_POSITIVE_TEXT]" .. bTraitsStrings.iAvailable .. "[ENDCOLOR] " .. bTraitsStrings.FullText .. " that are distributed among Manufactories by acquisition order."
		if bTraitsStrings.MaintRed ~= 0 then
			mfrtt = mfrtt .. "[NEWLINE][NEWLINE]This value is increased by [COLOR_POSITIVE_TEXT]" .. bTraitsStrings.MaintRed .. "[ENDCOLOR] (special bonuses).";
		end
	end
	Controls.MFresource:SetToolTipString(mfrtt);
	Controls.MFprod:SetToolTipString("Bonus production from working Manufactory. Base value (" .. bTraitsStrings.BaseProd .. ") is increased by 1 for every " .. bTraitsStrings.ProdDiv .. " turns Manufactory was active.")
	Controls.MFwonder:SetToolTipString("Bonus Wonder points from Manufactory. Base value (" .. bTraitsStrings.BaseWonder .. ") is increased by 1 for every " .. bTraitsStrings.WonderDiv .. " turns Manufactory was active.")
end

function UpdateButtonClicked()
	if not Players[Game.GetActivePlayer()]:IsTurnActive() then
		return;
	end
	if typeUbb == 1 then
		DoDisplayNewTraitOptions(lastManu)
	elseif typeUbb == 2 then		
		LuaEvents.ITG_RequestUpgradeManufactory(lastManu)
	end
	OnDetailedManufactory(lastManu)
end
Controls.UpdateButton:RegisterCallback( Mouse.eLClick, UpdateButtonClicked );

function Alphabetically(a, b)
	return Locale.Compare(a[2], b[2]) == -1;
end

function UpdateScreen()	
	LuaEvents.ITGSG_RequestGT();
	local gData = MapModData.ITGSG;
	MapModData.ITGSG = nil;
	if not gData then
		return
	end
	local iTeam = Game.GetActiveTeam();
	local iPlayer = Game.GetActivePlayer();
	g_ListCH:ResetInstances();
	local tabAlph = {}
	for index, gdd in pairs(gData.Manufactories) do
		if Map.GetPlotByIndex(index):IsRevealed(iTeam) then
			if (not bShowOnlyYours) or (gdd.Player == iPlayer) then
				table.insert(tabAlph, {index, gdd.Name})
			end
		end
	end
	table.sort(tabAlph, Alphabetically)
	for i, v in pairs(tabAlph) do
		local index = v[1]
		local gPlot = Map.GetPlotByIndex(index)
		local gPlayer = gPlot:GetOwner();
    	local itemInstance = g_ListCH:GetInstance();
		local dn = v[2];
				
		itemInstance.Base:SetDisabled(false)
		if not gData.Manufactories[index].Active then
			dn = dn .. " [ICON_BLOCKADED]"
		end
		local numTraits = 0;
		for hB, hBv in pairs(gData.Manufactories[index].Traits) do
			numTraits = numTraits + 1;
		end
		dn = dn .. " ";
		for i = 2, numTraits do
			dn = dn .. "[ICON_PLUS]";
		end
		itemInstance.Description:SetText( dn );
		
		if(bTickTock == false) then
			itemInstance.Box:SetColorVal(unpack(ltBlue));
		else
			itemInstance.Box:SetColorVal(unpack(dkBlue));
		end
		CivIconHookup( gPlayer, 32, itemInstance.Icon, itemInstance.CivIconBG, itemInstance.CivIconShadow, false, true);  

		itemInstance.Base:SetVoid1(index)
		itemInstance.Base:RegisterCallback(Mouse.eLClick, OnDetailedManufactory);

		local buttonWidth, buttonHeight = itemInstance.Base:GetSizeVal();
		itemInstance.Base:SetSizeVal(buttonWidth, 32);
		itemInstance.Box:SetSizeVal(buttonWidth + 20, 32);
		itemInstance.BounceAnim:SetSizeVal(buttonWidth + 20, 35);
		itemInstance.BounceGrid:SetSizeVal(buttonWidth + 20, 35);
		bTickTock = not bTickTock
	end
	if lastManu == -111 then
		lastManu = nil;
		for index, gdd in pairs(gData.Manufactories) do
			if #gdd.ToChoose > 0 then
				if gdd.Player == iPlayer then
					lastManu = index;
					break;
				end
			end
		end
	end


	if lastManu then
		if not Map.GetPlotByIndex(lastManu):IsRevealed(Game.GetActiveTeam()) then
			lastManu = nil;
		end
	end
    Controls.ManufactoriesStack:CalculateSize();
    Controls.ManufactoriesStack:ReprocessAnchoring();
    Controls.ManufactoriesScroll:CalculateInternalSize();
	
	if MapModData.DBScenario.MF_ImproCost100 then
		LuaEvents.ITG_Request_ManufactoryPurchaseData(iPlayer)
		local bt = MapModData.ITGSG
		MapModData.ITGSG = nil;
		Controls.PurchaseMFLabel:SetText(bt.Str .. " for Manufactory")
		Controls.PurchaseMF:SetDisabled(not bt.CanPurchase)
		Controls.PurchaseMF:SetToolTipString(bt.ToolTip);
		Controls.PurchaseMF:SetHide(false)
	else
		Controls.PurchaseMF:SetHide(true)
	end
	OnDetailedManufactory(lastManu)
end

function PurchaseMFClicked()
	if not Players[Game.GetActivePlayer()]:IsTurnActive() then
		return;
	end
	LuaEvents.ITG_RequestPurchaseManufactory(Game.GetActivePlayer())
	UpdateScreen();
end
Controls.PurchaseMF:RegisterCallback( Mouse.eLClick, PurchaseMFClicked );

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function ShowHideHandler( bIsHide, bInitState )
    if( not bIsHide ) then
    	UpdateScreen();
	end
end
ContextPtr:SetShowHideHandler( ShowHideHandler );
