-------------------------------------------------
-- Happiness Info
-------------------------------------------------
include( "IconSupport" );
include( "InstanceManager" );

local bTickTock = true;
local ltBlue = {19/255,32/255,46/255,120/255};
local dkBlue = {12/255,22/255,30/255,120/255};

local m_MilitaryIM = InstanceManager:new( "UnitInstance", "Root", Controls.MilitaryStack );
local m_CivilianIM = InstanceManager:new( "UnitInstance", "Root", Controls.CivilianStack );
local m_UnitClassIM = InstanceManager:new( "UnitClassInfoInstance", "Root", Controls.MilitaryStack );

local bMasterOfWhispers = false;
local m_SortTable;
local eName     = 0;
local eStatus   = 1;
local eMovement = 2;
local eMoves    = 3;
local eStrength = 4;
local eRanged   = 5;

local m_SortMode = eName;
local m_bSortReverse = false;
local isUnitList = true;
-------------------------------------------------
-------------------------------------------------



function OnChangeType()
   isUnitList = not isUnitList;
   if isUnitList then
	Controls.SwitchListsLabel:SetText("Class Info")
   else
	Controls.SwitchListsLabel:SetText("Unit List")
   end
   UpdateScreen()
end
Controls.SwitchLists:RegisterCallback( Mouse.eLClick, OnChangeType);
Controls.SwitchListsLabel:SetText("Class Info")
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function UnitClicked(unitID)
    local pSelectedUnit = UI:GetHeadSelectedUnit();
    if( pSelectedUnit ~= nil and
        pSelectedUnit:GetID() == unitID ) then
        UI.LookAtSelectionPlot(0);
    else
	    Events.SerialEventUnitFlagSelected( Game:GetActivePlayer(), unitID );
    end
end
        

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function UpdateScreen()
	LuaEvents.ITGSG_RequestGT("Milit");
	local gData = MapModData.ITGSG;
	local meterTooltipData = MapModData.ITGSG2;
	MapModData.ITGSG = nil;
	MapModData.ITGSG2 = nil;
	if not gData then
		return
	end
    local iPlayer = Game.GetActivePlayer();
    local pPlayer = Players[ iPlayer ];
    
    --------------------------------------------------------
    -- Great General Progress
    local fThreshold = gData.Players[iPlayer].CurrentNextGeneralTreshold
    local fProgress  = pPlayer:GetCombatExperience();
    Controls.GPMeter:SetPercent( fProgress / fThreshold );
	local sGenMeterToolTip = Locale.Lookup("TXT_KEY_MO_GENERAL_TT", fProgress, fThreshold) .. meterTooltipData.GenTT
    Controls.GPBox:SetToolTipString( sGenMeterToolTip );
    
    --------------------------------------------------------
    -- Great Admiral Progress
    fThreshold = gData.Players[iPlayer].CurrentNextAdmiralTreshold
    fProgress  = pPlayer:GetNavalCombatExperience();
    Controls.GAMeter:SetPercent( fProgress / fThreshold );
	sGenMeterToolTip = Locale.Lookup("TXT_KEY_MO_ADMIRAL_TT", fProgress, fThreshold) .. meterTooltipData.AdmTT
    Controls.GABox:LocalizeAndSetToolTip( sGenMeterToolTip );

	bMasterOfWhispers = gData.Players[iPlayer].MasterOfArmy;
    RefreshMoA()

    --------------------------------------------------------
    -- Supply Details
    Controls.HandicapSupplyValue:SetText(   pPlayer:GetBaseSupplyValue() );
    Controls.CitiesSupplyValue:SetText(     pPlayer:GetNumUnitsSuppliedByCities() );
    Controls.BuildingsSupplyValue:SetText(  pPlayer:GetNumUnitsSuppliedByBuildings() );
    Controls.PopulationSupplyValue:SetText( gData.Players[iPlayer].ExtraSupply );
    Controls.SupplyCapValue:SetText(        pPlayer:GetNumUnitsSupplied() );
    Controls.SupplyUseValue:SetText(        pPlayer:GetNumUnitsToSupply() );
    
    local iSupplyDeficit = pPlayer:GetNumUnitsOutOfSupply();
    local bInDeficit = (iSupplyDeficit ~= 0 );
    
    if( not bInDeficit ) then
		Controls.SupplyRemainingValue:SetText( pPlayer:GetNumUnitsSupplied() - pPlayer:GetNumUnitsToSupply() );
    else
	    Controls.SupplyDeficitValue:SetText( iSupplyDeficit );
	    Controls.SupplyDeficitPenaltyValue:SetText( pPlayer:GetUnitProductionMaintenanceMod() .. "%" );
    end
    
    Controls.SupplyRemaining:SetHide( bInDeficit );
    Controls.SupplyDeficit:SetHide( not bInDeficit );
    Controls.DeficitPenalty:SetHide( not bInDeficit );
    
    
    --------------------------------------------------------
	Controls.Promotions:SetHide(isUnitList)
	Controls.BlockXP:SetHide(isUnitList)
	Controls.BlockOne:SetHide(isUnitList)
	Controls.BlockTwo:SetHide(isUnitList)
	Controls.SortNumUnitsInClass:SetHide(isUnitList)
	
	Controls.SortStatus:SetHide(not isUnitList)
	Controls.SortMovement:SetHide(not isUnitList)
	Controls.SortMoves:SetHide(not isUnitList)
	Controls.SortRanged:SetHide(not isUnitList)
	Controls.SortStrength:SetHide(not isUnitList)
	
	
    -- Unit List
	if isUnitList then
	    BuildUnitList();
	else
		BuildClassData()
	end
end


function UnitPromChosen(promID, iclass)
	LuaEvents.ITG_PlayerChoosesUnitclassProm(promID, iclass, Game.GetActivePlayer())
	UpdateScreen()
end


function BuildClassData()
        
    m_MilitaryIM:ResetInstances();
    m_CivilianIM:ResetInstances();
	m_UnitClassIM:ResetInstances();
	local iplayer = Game.GetActivePlayer();
	LuaEvents.ITGSG_RequestGT();
	local gData = MapModData.ITGSG;
	MapModData.ITGSG = nil;
	if gData then
		for iclass, xp in pairs(gData.Players[iplayer].UnitClassXP) do
			local type = Players[iplayer]:GetPlayerUniqueUnit(iclass);
			if type ~= -1 then
				local tech = GameInfo.Units[type].PrereqTech;
				if (not tech) or Teams[Players[iplayer]:GetTeam()]:IsHasTech(tech) then
					LuaEvents.ITG_RequestPromotionClassData(iplayer, iclass)
					local promData = MapModData.ITGSG;
					MapModData.ITGSG = nil;
					local canhaveprom = promData.CanHavePromotion;
					local avapromT = promData.Promotions;
					local nowPossibleT = promData.PromotionsToPick;

					local instance = m_UnitClassIM:GetInstance();
					instance.FreeLabel:SetHide(not promData.OnlyFreeProm) -- label for free promotion only
					ginstance = instance;
					instance.UnitName:SetText(Locale.Lookup(GameInfo.Units[type].Description))
					local iTreshold = gData.Players[iplayer].UnitClassXPNeededNext[iclass];

					instance.PromotionIndicator:SetHide(not canhaveprom)
					instance.NumUnits:SetText(Players[iplayer]:GetUnitClassCount(iclass))
					if canhaveprom then
						instance.Exp:SetText("[COLOR_POSITIVE_TEXT]" .. xp .. "/" .. iTreshold .. "[ENDCOLOR]")
					else
						instance.Exp:SetText(xp .. "/" .. iTreshold)
					end
					local num = 0;
					for iprom, sth in pairs(gData.Players[iplayer].UnitClassPromotions[iclass]) do
						num = num + 1;
						local bb = instance["UnitPromotionImage" .. num]
						local unitPromotion = GameInfo.UnitPromotions[iprom]
						IconHookup( unitPromotion.PortraitIndex, 32, unitPromotion.IconAtlas, bb );
						local strToolTip = Locale.ConvertTextKey(unitPromotion.Description);
						strToolTip = strToolTip .. "[NEWLINE][NEWLINE]" .. Locale.ConvertTextKey(unitPromotion.Help)
						bb:SetToolTipString(strToolTip);
						bb:SetHide(false)
					end
					for i = num + 1, 7 do
						instance["UnitPromotionImage" .. i]:SetHide(true)
					end
					num = 0;

					for promID, data in pairs(avapromT) do
						if not gData.Players[iplayer].UnitClassPromotions[iclass][promID] then
							num = num + 1;
							local bb = instance["AvaPromotionImage" .. num]
							local buttonb = instance["AvaPromotionButton" .. num]
							local unitPromotion = GameInfo.UnitPromotions[promID]
							IconHookup( unitPromotion.PortraitIndex, 32, unitPromotion.IconAtlas, bb );
							local strToolTip = Locale.ConvertTextKey(unitPromotion.Description);
							strToolTip = strToolTip .. "[NEWLINE][NEWLINE]" .. Locale.ConvertTextKey(unitPromotion.Help)
							if #data[1] > 0 then
								if #data[1] > 1 then
									strToolTip = strToolTip .. "[NEWLINE][NEWLINE]This promotion requires one of the following promotions: "
								else
									strToolTip = strToolTip .. "[NEWLINE][NEWLINE]This promotion requires following promotion: "
								end
								for it, prom in pairs(data[1]) do
									local up = GameInfo.UnitPromotions[prom];
									strToolTip = strToolTip .. "[COLOR_POSITIVE_TEXT]" .. Locale.ConvertTextKey(up.Description) .. "[ENDCOLOR]"
									if it == #data[1] then
										strToolTip = strToolTip .. "."
									else
										strToolTip = strToolTip .. ", "
									end
								end
							end
							if data[2] then
								if data[2] > 1 then
									strToolTip = strToolTip .. "[NEWLINE][NEWLINE]This promotion requires to have at least " .. data[2] .. " other promotions."
								else
									strToolTip = strToolTip .. "[NEWLINE][NEWLINE]This promotion requires to have at least " .. data[2] .. " other promotion."
								end
							end
							if data[3] then
								if #data[3] > 1 then
									strToolTip = strToolTip .. "[NEWLINE][NEWLINE]This promotion cannot be chosen alongside following promotions: "
								else
									strToolTip = strToolTip .. "[NEWLINE][NEWLINE]This promotion cannot be chosen alongside following promotion: "
								end
								for it, prom in pairs(data[3]) do
									local up = GameInfo.UnitPromotions[prom];
									strToolTip = strToolTip .. "[COLOR_NEGATIVE_TEXT]" .. Locale.ConvertTextKey(up.Description) .. "[ENDCOLOR]"
									if it == #data[3] then
										strToolTip = strToolTip .. "."
									else
										strToolTip = strToolTip .. ", "
									end
								end
							end
							buttonb:SetDisabled(true)
							buttonb:SetAlpha(0.6)
							if canhaveprom then
								if nowPossibleT[promID] then
									buttonb:SetDisabled(false)
									buttonb:SetAlpha(1.0)
									buttonb:SetVoid1(promID)
									buttonb:SetVoid2(iclass)
									buttonb:RegisterCallback( Mouse.eLClick, UnitPromChosen );
								end
							end
							bb:SetToolTipString(strToolTip);
							bb:SetHide(false)
						end
					end
					for i = num + 1, 20 do
						instance["AvaPromotionButton" .. i]:SetHide(true)
					end
				end
			end
		end
	end

	Controls.MilitaryStack:CalculateSize();
    Controls.CivilianStack:CalculateSize();
    
    Controls.MainStack:CalculateSize();
    Controls.ScrollPanel:CalculateInternalSize();
    
    Controls.ScrollPanel:ReprocessAnchoring();
end

--------------------------------------------------------
--------------------------------------------------------
function BuildUnitList()

    m_SortTable = {};
    
    local iPlayer = Game.GetActivePlayer();
    local pPlayer = Players[ iPlayer ];
    
    local bFoundMilitary = false;
    local bFoundCivilian = false;
    
    local pSelectedUnit = UI:GetHeadSelectedUnit();
    local iSelectedUnit = -1;
    if( pSelectedUnit ~= nil ) then
        iSelectedUnit = pSelectedUnit:GetID();
    end
    
    m_MilitaryIM:ResetInstances();
    m_CivilianIM:ResetInstances();
	m_UnitClassIM:ResetInstances();
    
    for unit in pPlayer:Units() do
        local instance;
        local iUnit = unit:GetID();
        
        if( unit:GetUnitCombatType() ~= -1 or unit:CanNuke()) then
            instance = m_MilitaryIM:GetInstance();
            bFoundMilitary = true;
        else
            instance = m_CivilianIM:GetInstance();
            bFoundCivilian = true;
        end
        
        local sortEntry = {};
        m_SortTable[ tostring( instance.Root ) ] = sortEntry;
        
        instance.Button:RegisterCallback( Mouse.eLClick, UnitClicked );
        instance.Button:SetVoid1( unit:GetID() );
        
        sortEntry.DisplayName = Locale.Lookup(unit:GetNameKey());
        instance.UnitName:SetText( sortEntry.DisplayName );
        
        if( unit:MovesLeft() > 0 ) then
            instance.Button:SetAlpha( 1.0 );
        else
            instance.Button:SetAlpha( 0.6 );
        end
        
        instance.SelectionFrame:SetHide( not (iSelectedUnit == iUnit) );
       
        sortEntry.hasPromotion = unit:GetExperience() >= unit:ExperienceNeeded(); 
        instance.PromotionIndicator:SetHide( not sortEntry.hasPromotion );

        ---------------------------------------------------------
        -- Status field
        local buildType = unit:GetBuildType();
        local activityType = unit:GetActivityType();
        if( unit:IsEmbarked() ) then
            sortEntry.status = "TXT_KEY_UNIT_STATUS_EMBARKED";
            instance.Status:SetHide( false );
                        
        elseif( unit:IsGarrisoned()) then
			sortEntry.status = "TXT_KEY_MISSION_GARRISON";
            instance.Status:SetHide( false );
            
        elseif( unit:IsAutomated()) then
			if(unit:IsWork()) then
				sortEntry.status = "TXT_KEY_ACTION_AUTOMATE_BUILD";
				instance.Status:SetHide( false );
			else
				sortEntry.status = "TXT_KEY_ACTION_AUTOMATE_EXPLORE";
				instance.Status:SetHide( false );
			end
					
		elseif( activityType == ActivityTypes.ACTIVITY_HEAL ) then
			sortEntry.status = "TXT_KEY_MISSION_HEAL";
			instance.Status:SetHide( false );
			
		elseif( activityType == ActivityTypes.ACTIVITY_SENTRY ) then
			sortEntry.status = "TXT_KEY_MISSION_ALERT";
			instance.Status:SetHide( false );
			
        elseif( unit:GetFortifyTurns() > 0 ) then
            sortEntry.status = "TXT_KEY_UNIT_STATUS_FORTIFIED";
            instance.Status:SetHide( false );
            
        elseif( activityType == ActivityTypes.ACTIVITY_SLEEP ) then
			sortEntry.status = "TXT_KEY_MISSION_SLEEP";
			instance.Status:SetHide( false );
            
        elseif( buildType ~= -1) then -- this is a worker who is actively building something
    		local thisBuild = GameInfo.Builds[buildType];
    		local civilianUnitStr = Locale.ConvertTextKey(thisBuild.Description);
   -- 		local iTurnsLeft = unit:GetPlot():GetBuildTurnsLeft(buildType,Game.GetActivePlayer(), 0, 0);

    --		local iTurnsTotal = unit:GetPlot():GetBuildTurnsTotal(buildType);	
    	--	if (iTurnsLeft < 4000 and iTurnsLeft > 0) then
    		--	civilianUnitStr = civilianUnitStr.." ("..tostring(iTurnsLeft)..")";
    --		end
            sortEntry.status = civilianUnitStr;
            instance.Status:SetHide( false );
            
    	else
            sortEntry.status = nil;
            instance.Status:SetHide( true );
        end
        if( sortEntry.status ~= nil ) then
            instance.Status:LocalizeAndSetText( sortEntry.status );
        else
            instance.Status:SetText( "" );
        end
        
               
	    local move_denominator = GameDefines["MOVE_DENOMINATOR"];
	    local moves_left = math.floor(unit:MovesLeft() / move_denominator);
	    local max_moves = math.floor(unit:MaxMoves() / move_denominator);
	    
        if( moves_left == max_moves ) then
            instance.MovementPip:SetTextureOffsetVal( 0, 0 );
        elseif( moves_left == 0 ) then
            instance.MovementPip:SetTextureOffsetVal( 0, 96 );
        else
            instance.MovementPip:SetTextureOffsetVal( 0, 32 );
        end
	    
        sortEntry.movement = moves_left;
        sortEntry.moves = max_moves;
        instance.Movement:SetText( moves_left .. "/" .. max_moves );
        
        sortEntry.strength = unit:GetBaseCombatStrength();
        if( sortEntry.strength == 0 ) then
            instance.Strength:SetText( "-" );
        else
            instance.Strength:SetText( sortEntry.strength );
        end
        
        sortEntry.ranged = unit:GetBaseRangedCombatStrength();
        if( sortEntry.ranged == 0 ) then
            instance.RangedAttack:SetText( "-" );
        else
            instance.RangedAttack:SetText( sortEntry.ranged );
        end
        
        sortEntry.unit = unit;
    end

    if( bFoundMilitary and bFoundCivilian ) then
        Controls.CivilianSeperator:SetHide( false );
    else
        Controls.CivilianSeperator:SetHide( true );
    end
    
    Controls.MilitaryStack:CalculateSize();
    Controls.CivilianStack:CalculateSize();
    
    Controls.MainStack:CalculateSize();
    Controls.ScrollPanel:CalculateInternalSize();
    
    Controls.ScrollPanel:ReprocessAnchoring();
end


-------------------------------------------------
-------------------------------------------------
function SortFunction( a, b )
    local valueA, valueB;
    local entryA = m_SortTable[ tostring( a ) ];
    local entryB = m_SortTable[ tostring( b ) ];

    if (entryA == nil) or (entryB == nil) then 
		if entryA and (entryB == nil) then
			return false;
		elseif (entryA == nil) and entryB then
			return true;
		else
			if( m_bSortReverse ) then
				return tostring(a) > tostring(b); -- gotta do something deterministic
			else
				return tostring(a) < tostring(b); -- gotta do something deterministic
			end
        end;
    else
		if( m_SortMode == eName ) then
			valueA = entryA.DisplayName;
			valueB = entryB.DisplayName;
		elseif( m_SortMode == eStatus ) then
			valueA = entryA.status or "";
			valueB = entryB.status or "";
			
			if(valueA ~= valueB) then
				if(m_bSortReverse) then
					return Locale.Compare(valueA, valueB) == -1;
				else
					return Locale.Compare(valueA, valueB) == 1;
				end
			end
			
		elseif( m_SortMode == eMovement ) then
			valueA = entryA.movement;
			valueB = entryB.movement;
		elseif( m_SortMode == eMoves ) then
			valueA = entryA.moves;
			valueB = entryB.moves;
		elseif( m_SortMode == eStrength ) then
			valueA = entryA.strength;
			valueB = entryB.strength;
		elseif( m_SortMode == eRanged ) then
			valueA = entryA.ranged;
			valueB = entryB.ranged;
		end
	    
		if( valueA == valueB ) then
			valueA = entryA.unit:GetID();
			valueB = entryB.unit:GetID();
		end
	   
		if( m_bSortReverse ) then
			return valueA > valueB;
		else
			return valueA < valueB;
		end
	end
end

function RefreshMoA()
	if bMasterOfWhispers then
		Controls.MastersOfArmyLabel:SetText("Master of Arms: [COLOR_POSITIVE_TEXT]ON[ENDCOLOR]");
		Controls.MastersOfArmy:SetToolTipString("Master of Arms is automatically managing Veterancy promotions. Right now Master of Arms is active.");
	else
		Controls.MastersOfArmyLabel:SetText("Master of Arms: [COLOR_NEGATIVE_TEXT]OFF[ENDCOLOR]");
		Controls.MastersOfArmy:SetToolTipString("Master of Arms manages Veterancy promotions if you appoint one. Right now Master of Arms is inactive.");
	end
end

function OnPlayerMoA( )
	LuaEvents.ITGSG_HumanChangeVeteranSettings();
	bMasterOfWhispers = not bMasterOfWhispers;
	RefreshMoA()
end
Controls.MastersOfArmy:RegisterCallback( Mouse.eLClick, OnPlayerMoA );

-------------------------------------------------
-------------------------------------------------
function OnSort( type )
    if( m_SortMode == type ) then
        m_bSortReverse = not m_bSortReverse;
    else
        m_bSortReverse = false;
    end
    
    m_SortMode = type;
    Controls.MilitaryStack:SortChildren( SortFunction );
    Controls.CivilianStack:SortChildren( SortFunction );
end
Controls.SortName:RegisterCallback( Mouse.eLClick, OnSort );
Controls.SortStatus:RegisterCallback( Mouse.eLClick, OnSort );
Controls.SortMovement:RegisterCallback( Mouse.eLClick, OnSort );
Controls.SortMoves:RegisterCallback( Mouse.eLClick, OnSort );
Controls.SortStrength:RegisterCallback( Mouse.eLClick, OnSort );
Controls.SortRanged:RegisterCallback( Mouse.eLClick, OnSort );
Controls.SortName:SetVoid1( eName );
Controls.SortStatus:SetVoid1( eStatus );
Controls.SortMovement:SetVoid1( eMovement );
Controls.SortMoves:SetVoid1( eMoves );
Controls.SortStrength:SetVoid1( eStrength );
Controls.SortRanged:SetVoid1( eRanged );

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function ShowHideHandler( bIsHide, bInitState )
    if( not bIsHide ) then
    	UpdateScreen();
	end
end
ContextPtr:SetShowHideHandler( ShowHideHandler );
