-------------------------------------------------
-- Choose Free Item Popup
-------------------------------------------------
include("IconSupport");
include("InfoTooltipInclude");

local m_ITGpopupID = 5443534;
local m_queuedInfo = {};
local rngBonusesTypes = {
{ID = 1, Name = "SCIENTIFIC BONUS", IconAtlas = "CITIZEN_ATLAS", PortraitIndex = 2, GovTitle = "Chancellor"},
{ID = 2, Name = "CULTURAL BONUS", IconAtlas = "CITIZEN_ATLAS", PortraitIndex = 4, GovTitle = "Protector"},
{ID = 3, Name = "RELIGIOUS BONUS", IconAtlas = "EXPANSION_UNIT_ATLAS_1", PortraitIndex = 16, GovTitle = "High Priest"},
{ID = 4, Name = "GENERAL BONUS", IconAtlas = "UNIT_ATLAS_2", PortraitIndex = 48, GovTitle = "Commander-in-Chief"},
{ID = 5, Name = "ADMIRAL BONUS", IconAtlas = "EXPANSION_UNIT_ATLAS_1", PortraitIndex = 15, GovTitle = "Commander-in-Chief"},
}

function DoPopulatePopup()
	local iActivePlayer = Game.GetActivePlayer();
	local currentData = m_queuedInfo[1];
	local type = currentData.Type;
	local bonus = currentData.Bonus;
	local exInfo = currentData.ExtraInfo;
	LuaEvents.ITGSG_RequestGT();
	local gData = MapModData.ITGSG;
	MapModData.ITGSG = nil;
	
	IconHookup(rngBonusesTypes[type].PortraitIndex, 64, rngBonusesTypes[type].IconAtlas, Controls.Icon);
	
	local hText = ""
	if currentData.GovID then
		IconHookup(gData.Globals.Governors[currentData.GovID].PIndex, 64, gData.Globals.Governors[currentData.GovID].IconAtlas, Controls.MemberIcon);
		Controls.GovButtonBox:SetHide(false)
		hText = rngBonusesTypes[type].GovTitle .. " [ICON_ITG_GOVERNOR] " .. Locale.Lookup(gData.Globals.Governors[currentData.GovID].Name) .. " has chosen " .. string.lower(rngBonusesTypes[type].Name) .. "."
	else
		Controls.GovButtonBox:SetHide(true)
		if currentData.ReasonID == 1 then
			hText = "Random " .. string.lower(rngBonusesTypes[type].Name) .. " from Scientific Liberty."
		elseif currentData.ReasonID == 2 then
			hText = "Extra " .. string.lower(rngBonusesTypes[type].Name) .. " from Law Supremacy."
		elseif currentData.ReasonID == 3 then
			hText = "Extra " .. string.lower(rngBonusesTypes[type].Name) .. " from Megalomania."
		end
	end
	hText = hText .. "[NEWLINE][NEWLINE]" .. currentData.Title .. "[NEWLINE]"
	--effect
	--very long very hardcoded
	if type == 1 then
		if bonus == 1 then
			if exInfo then
				if GameInfo.Technologies[exInfo].IsInnovation then
					hText = hText .. "We have acquired a new innovation, [COLOR_POSITIVE_TEXT]" .. Locale.Lookup(GameInfo.Technologies[exInfo].Description) .. "[ENDCOLOR].";
				else
					hText = hText .. "We have acquired a new technology, [COLOR_POSITIVE_TEXT]" .. Locale.Lookup(GameInfo.Technologies[exInfo].Description) .. "[ENDCOLOR].";
				end
			else
				hText = hText .. "We can choose a new technology.";
			end
		elseif bonus == 2 then
			if exInfo[1] == 1 then
				hText = hText .. "We have started developing new World Wonder."
			else
				hText = hText .. "+" .. exInfo[2] .. " [ICON_GREAT_ENGINEER] World Wonder progress.";
			end
		elseif bonus == 3 then
			hText = hText .. "We can assign a free unitclass promotion."
		elseif bonus == 4 then
			hText = hText .. "We have reformed the belief of " .. Locale.Lookup(GameInfo.Beliefs[exInfo].ShortDescription) .. ".";
		elseif bonus == 5 then
			if exInfo then
				hText = hText .. "Our [ICON_GOLDEN_AGE] Golden Age has been prolonged."
			else
				hText = hText .. "We have made a progress towards next [ICON_GOLDEN_AGE] Golden Age."
			end
		elseif bonus == 6 then
			hText = hText .. "We have gained +" .. exInfo .. " [ICON_ITG_LEGAL_POWER] Legal Power.";
		elseif bonus == 7 then
			hText = hText .. "We have developed a new specialized unit: [COLOR_POSITIVE_TEXT]" .. Locale.Lookup(GameInfo.Units[exInfo].Description) .. "[ENDCOLOR].";
		end
	elseif type == 2 then
		if bonus == 1 then
			hText = hText .. "We have advanced to the next Art Style.";
		elseif bonus == 2 then
			if exInfo[1] == 1 then
				hText = hText .. "We have started developing new World Wonder."
			else
				hText = hText .. "+" .. exInfo[2] .. " [ICON_GREAT_ENGINEER] World Wonder progress.";
			end
		elseif bonus == 3 then
			hText = hText .. "We created " .. exInfo .. " [ICON_GREAT_WORK] Great Works (+1[ICON_ITG_MERITOCRACY]).";
		elseif bonus == 4 then
			LuaEvents.ITG_QuickSocDevInfo(exInfo[1]);
			local perkInfo1 = MapModData.ITGSG;
			MapModData.ITGSG = nil;
			LuaEvents.ITG_QuickSocDevInfo(exInfo[2]);
			local perkInfo2 = MapModData.ITGSG;
			MapModData.ITGSG = nil;
			hText = hText .. "We have replace a social development, " .. perkInfo1.Name .. ", with a new one: [COLOR_POSITIVE_TEXT]" .. perkInfo2.Name .. "[ENDCOLOR].";
		elseif bonus == 5 then
			if exInfo then
				hText = hText .. "Our [ICON_GOLDEN_AGE] Golden Age has been prolonged."
			else
				hText = hText .. "We have made a progress towards next [ICON_GOLDEN_AGE] Golden Age."
			end
		elseif bonus == 6 then
			hText = hText .. "20 [ICON_HAPPINESS_1] Happiness was distributed randomly among our cities (one city couldn't gain more than +4 [ICON_HAPPINESS_1] Happiness). +4 [ICON_ITG_MERITOCRACY] Meritocracy.";
		elseif bonus == 7 then
			local buildingType = Players[iActivePlayer]:GetPlayerUniqueUnit(exInfo[2])
			hText = hText .. "We can choose an inspiration for " .. Locale.Lookup(GameInfo.Buildings[buildingType].Description) .. "."; 
		elseif bonus == 8 then
			if MapModData.DBScenario.InnoPairs then
				hText = hText .. "We can choose a new Innovation.";
			else
				hText = hText .. "We have acquired a new innovation, [COLOR_POSITIVE_TEXT]" .. Locale.Lookup(GameInfo.Technologies[exInfo].Description) .. "[ENDCOLOR].";
			end
		elseif bonus == 9 then
			local sCityString = ""
			for i, sIndex in pairs(exInfo) do
				if i ~= 1 then
					sCityString = sCityString .. " and "
				end
				sCityString = sCityString .. Map.GetPlotByIndex(sIndex):GetPlotCity():GetName();
			end
			hText = "Inspired by our culture citizens of " .. sCityString .. " decided to start uprising against their oppressors (+3 [ICON_ITG_MORALE] Morale)."	
		elseif bonus == 10 then
			hText = "+400 [ICON_INVEST] Currency Power (fades by 25 each turn). +5 [ICON_CARAVAN] Land and [ICON_CARGO] Naval Trade-Route points in all Cities."
		elseif bonus == 11 then
			hText = hText .. "1000 [ICON_ITG_PRESENCE] Presence was distributed randomly among our cities (one city couldn't gain more than +200 [ICON_ITG_PRESENCE] Presence). +5 XP for next trained unit in all Cities.";
		elseif bonus == 12 then
			local hcs = #exInfo;
			local sCityStates = ""
			for i, citystate in pairs(exInfo) do
				if i == 1 then
				elseif i == hcs then
					sCityStates = sCityStates .. " and "
				else
					sCityStates = sCityStates .. ", "
				end
				sCityStates = sCityStates .. Players[citystate]:GetName();
			end
			hText = "We have improved relations with " .. sCityStates .. ". +15% [ICON_ITG_LAWS_INFLUENCE] Codex Influence."
		elseif bonus == 13 then
			hText = "Our Great People had their [ICON_TOURISM] migration progress reduced. +1 [ICON_PRODUCTION] Production in all Cities."
			if exInfo > 0 then
				hText = hText .. " +" .. exInfo .. " [ICON_GREAT_PEOPLE] Great People points."
			end 		
		end
	elseif type == 3 then
		if bonus == 1 then
			hText = hText .. "We have enhanced our religion."
		elseif bonus == 2 then
			if exInfo[1] == 1 then
				hText = hText .. "We have started developing new World Wonder."
			else
				hText = hText .. "+" .. exInfo[2] .. " [ICON_GREAT_ENGINEER] World Wonder progress.";
			end
		elseif bonus == 3 then
			hText = hText .. "We created " .. exInfo .. " [ICON_GREAT_WORK] Great Works (+1[ICON_ITG_MERITOCRACY]).";
		elseif bonus == 4 then
			hText = hText .. "We have reformed the belief of " .. Locale.Lookup(GameInfo.Beliefs[exInfo].ShortDescription) .. ".";
		elseif bonus == 5 then
			hText = hText .. "We can create a new Holy Site."
		elseif bonus == 6 then
			hText = hText .. "We have gained +" .. exInfo / 100 .. " [ICON_ITG_LEGAL_POWER] Legal Power."
		elseif bonus == 7 then
			if exInfo then
				hText = hText .. "Our [ICON_GOLDEN_AGE] Golden Age has been prolonged."
			else
				hText = hText .. "We have made a progress towards next [ICON_GOLDEN_AGE] Golden Age."
			end
		elseif bonus == 8 then
			hText = hText .. "We have lost enhancer and founder beliefs. We can now turn into Secular State with [ICON_ITG_LEGAL_POWER] Legal Power. We have gained " .. exInfo[1] .. " [ICON_ITG_LEGAL_POWER] Legal Power, " .. exInfo[2] .. " [ICON_GOLD] Gold, " .. exInfo[3] .. " [ICON_CULTURE] Culture, " .. exInfo[4] .. " [ICON_GREAT_PEOPLE] Great People points and " .. exInfo[5] .. " [ICON_HAPPINESS_1] Happiness empire-wide."
		elseif bonus == 9 then
			hText = hText .. "We have founded a new Religion."
		elseif bonus == 10 then
			hText = hText .. gData.GreatPeople[exInfo].Name .. " has been promoted to the rank of [ICON_GREAT_GENERAL] General."
		elseif bonus == 11 then
			hText = hText .. gData.GreatPeople[exInfo].Name .. " has been promoted to the rank of [ICON_GREAT_ADMIRAL] Admiral."
		elseif bonus == 12 then
			if exInfo then
				if GameInfo.Technologies[exInfo].IsInnovation then
					hText = hText .. "We have acquired a new innovation, [COLOR_POSITIVE_TEXT]" .. Locale.Lookup(GameInfo.Technologies[exInfo].Description) .. "[ENDCOLOR].";
				else
					hText = hText .. "We have acquired a new technology, [COLOR_POSITIVE_TEXT]" .. Locale.Lookup(GameInfo.Technologies[exInfo].Description) .. "[ENDCOLOR].";
				end
			else
				hText = hText .. "We can choose a new technology.";
			end
		elseif bonus == 13 then
			hText = hText .. "We have adopted a new belief: [COLOR_POSITIVE_TEXT]" .. Locale.Lookup(GameInfo.Beliefs[exInfo].ShortDescription) .. "[ENDCOLOR].";
		elseif bonus == 14 then
			hText = hText .. "We have gained +" .. exInfo .. " [ICON_GREAT_PEOPLE] Great People points."
		elseif bonus == 15 then
			hText = hText .. "We can construct a new Fort or upgrade existing one into Citadel."
		elseif bonus == 16 then
			hText = hText .. "We can adopt a new Pantheon."
		elseif bonus == 17 then
			hText = hText .. exInfo .. " [ICON_HAPPINESS_1] Happiness were distributed among our cities.";
		elseif bonus == 18 then
			hText = hText .. "We have acquired " .. exInfo .. " [ICON_MISSIONARY] Missionaries.";
		elseif bonus == 19 then
			hText = hText .. "We can assign a free unitclass promotion."
		elseif bonus == 20 then
			hText = hText .. "We have acquired " .. exInfo .. " [ICON_GOLD] Gold.";
		elseif bonus == 21 then
			if exInfo[1] and exInfo[2] then
				local unitType = Players[iActivePlayer]:GetPlayerUniqueUnit(exInfo[1])
				local buildingType = Players[iActivePlayer]:GetPlayerUniqueUnit(exInfo[2])
				hText = hText .. "We can now train " .. Locale.Lookup(GameInfo.Units[unitType].Description) .. " and construct " .. Locale.Lookup(GameInfo.Buildings[buildingType].Description) .. ".";
			elseif exInfo[1] then
				local unitType = Players[iActivePlayer]:GetPlayerUniqueUnit(exInfo[1])
				hText = hText .. "We can now train " .. Locale.Lookup(GameInfo.Units[unitType].Description) .. ". -3% [ICON_PROPHET] Heresy from local theology.";
			else
				local buildingType = Players[iActivePlayer]:GetPlayerUniqueUnit(exInfo[2])
				hText = hText .. "We can now construct " .. Locale.Lookup(GameInfo.Buildings[buildingType].Description) .. ". -3% [ICON_PROPHET] Heresy from local theology.";
			end
		elseif bonus == 22 then
			hText = hText .. exInfo .. " [ICON_ITG_MERCENARY] famous Mercenaries joined our cause!";
		elseif bonus == 23 then
			hText = hText .. "We have legalized ownership of " .. Map.GetPlotByIndex(exInfo):GetPlotCity():GetName() .. ".";
		elseif bonus == 24 then
			hText = hText .. "+" .. exInfo .. " [ICON_ITG_MORALE] Morale.";
		end
	elseif type == 4 then
		if bonus == 1 then
			hText = hText .. gData.GreatPeople[exInfo].Name .. " has been promoted to the rank of [ICON_GREAT_GENERAL] General (+2[ICON_ITG_MERITOCRACY])."
		elseif bonus == 2 then
			hText = hText .. "We can construct a new Fort or upgrade existing one into Citadel."
		elseif bonus == 3 then
			hText = hText .. "We can assign a free unitclass promotion."
		elseif bonus == 4 then
			if exInfo then
				hText = hText .. "Our [ICON_GOLDEN_AGE] Golden Age has been prolonged."
			else
				hText = hText .. "We have made a progress towards next [ICON_GOLDEN_AGE] Golden Age."
			end
		elseif bonus == 5 then
			LuaEvents.ITG_RequestPirateInfo(exInfo, "Text")
			hText = hText .. "PIRATE: " .. MapModData.ITGSG;
			MapModData.ITGSG = nil;
		elseif bonus == 6 or bonus == 7 then
			if MapModData.DBScenario.InnoPairs then
				hText = hText .. "We can choose a new Innovation.";
			else
				hText = hText .. "We have acquired a new innovation, [COLOR_POSITIVE_TEXT]" .. Locale.Lookup(GameInfo.Technologies[exInfo].Description) .. "[ENDCOLOR].";
			end
		elseif bonus == 8 then
			local unitType = Players[iActivePlayer]:GetPlayerUniqueUnit(exInfo[1])
			if exInfo[2] then
				local buildingType = Players[iActivePlayer]:GetPlayerUniqueBuilding(exInfo[2])
				hText = hText .. "We can now train " .. Locale.Lookup(GameInfo.Units[unitType].Description) .. " and construct " .. Locale.Lookup(GameInfo.Buildings[buildingType].Description) .. ".";
			else
				hText = hText .. "We can now train " .. Locale.Lookup(GameInfo.Units[unitType].Description) .. ". +2 [ICON_STRENGTH] Defense in all Cities.";
			end
		elseif bonus == 9 then
			hText = hText .. "+" .. exInfo .. " [ICON_ITG_MORALE] Morale and " .. (exInfo * 3) .. " [ICON_ITG_MERITOCRACY] Meritocracy.";
		end
	elseif type == 5 then
		if bonus == 1 then
			hText = hText .. gData.GreatPeople[exInfo].Name .. " has been promoted to the rank of [ICON_GREAT_ADMIRAL] Admiral (+2[ICON_ITG_MERITOCRACY])."
		elseif bonus == 2 then
			hText = hText .. "We can construct a new Fort or upgrade existing one into Citadel."
		elseif bonus == 3 then
			hText = hText .. "We can assign a free unitclass promotion."
		elseif bonus == 4 then
			if exInfo then
				hText = hText .. "Our [ICON_GOLDEN_AGE] Golden Age has been prolonged."
			else
				hText = hText .. "We have made a progress towards next [ICON_GOLDEN_AGE] Golden Age."
			end
		elseif bonus == 5 then
			LuaEvents.ITG_RequestPirateInfo(exInfo, "Text")
			hText = hText .. "PIRATE: " .. MapModData.ITGSG;
			MapModData.ITGSG = nil;
		elseif bonus == 6 or bonus == 8 then
			if MapModData.DBScenario.InnoPairs then
				hText = hText .. "We can choose a new Innovation.";
			else
				hText = hText .. "We have acquired a new innovation, [COLOR_POSITIVE_TEXT]" .. Locale.Lookup(GameInfo.Technologies[exInfo].Description) .. "[ENDCOLOR].";
			end
		elseif bonus == 7 then
			hText = hText .. "We can construct another Feitoria."
		elseif bonus == 9 then
			local unitType = Players[iActivePlayer]:GetPlayerUniqueUnit(exInfo[1])
			if exInfo[2] then
				local buildingType = Players[iActivePlayer]:GetPlayerUniqueUnit(exInfo[2])
				hText = hText .. "We can now train " .. Locale.Lookup(GameInfo.Units[unitType].Description) .. " and construct " .. Locale.Lookup(GameInfo.Buildings[buildingType].Description) .. ".";
			else
				hText = hText .. "We can now train " .. Locale.Lookup(GameInfo.Units[unitType].Description) .. ". +2 [ICON_STRENGTH] Defense in all Cities.";
			end
		elseif bonus == 10 then
			hText = hText .. "+" .. exInfo .. " [ICON_ITG_MORALE] Morale and " .. (exInfo * 3) .. " [ICON_ITG_MERITOCRACY] Meritocracy.";
		end
	end

	Controls.DescriptionLabel:SetText(hText);
	Controls.TitleLabel:SetText(rngBonusesTypes[type].Name)

	table.remove(m_queuedInfo, 1);
	if #m_queuedInfo > 0 then
		Controls.CloseLabel:SetText("Proceed")
	else
		Controls.CloseLabel:SetText("Close")
	end
	Controls.MainStack:CalculateSize();
	Controls.MainGrid:SetSizeY(Controls.MainStack:GetSizeY() + 120)
end

function OnClose()
	if #m_queuedInfo > 0 then
		DoPopulatePopup()
	else
		UIManager:DequeuePopup(ContextPtr);
	end
end
Controls.CloseButton:RegisterCallback(Mouse.eLClick, OnClose);

function CalledGovOver()
   	if( ContextPtr:IsHidden() == false ) then
	   	OnClose();
	else
		m_queuedInfo = MapModData.ITGSG;
		MapModData.ITGSG = nil;

		DoPopulatePopup()
	   	UIManager:QueuePopup( ContextPtr, PopupPriority.WhosWinning );
   	end
end
LuaEvents.ITGSG_CallRandomRewardPopup.Add(CalledGovOver)

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function InputHandler( uiMsg, wParam, lParam )
    ----------------------------------------------------------------        
    -- Key Down Processing
    ----------------------------------------------------------------        
    if uiMsg == KeyEvents.KeyDown then
        if (wParam == Keys.VK_ESCAPE) then
		    OnClose();
	    	return true;
        end
        
        -- Do Nothing.
        if(wParam == Keys.VK_RETURN) then
			return true;
        end
    end
end
ContextPtr:SetInputHandler( InputHandler );
  
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function ShowHideHandler( bIsHide, bInitState )
    if( not bInitState ) then
        if( not bIsHide ) then
        	UI.incTurnTimerSemaphore();
        	Events.SerialEventGameMessagePopupShown(nil);
        else
            UI.decTurnTimerSemaphore();
            Events.SerialEventGameMessagePopupProcessed.CallImmediate(m_ITGpopupID, 0);
        end
    end
end
ContextPtr:SetShowHideHandler( ShowHideHandler );

----------------------------------------------------------------
-- 'Active' (local human) player has changed
----------------------------------------------------------------
function OnActivePlayerChanged( iActivePlayer, iPrevActivePlayer )
	if (not ContextPtr:IsHidden()) then
		ContextPtr:SetHide(true);
	end
end
Events.GameplaySetActivePlayer.Add(OnActivePlayerChanged);

ContextPtr:SetHide(true)