-------------------------------------------------
-- Choose Free Item Popup
-------------------------------------------------
include("IconSupport");
include("InfoTooltipInclude");
include( "InstanceManager" )

local g_ItemManager = GenerationalInstanceManager:new( "ItemInstance", "Base", Controls.ItemStack);
local m_ITGpopupID = 91233843;

function DoPopulatePopup()
	local cData = MapModData.ITGSG;
	MapModData.ITGSG = nil;
	local cNameAcquired;
	local iActivePlayer = Game.GetActivePlayer();
	local civType = Players[iActivePlayer]:GetCivilizationType();
	g_ItemManager:ResetInstances();
	for i, perkData in pairs(cData.PerkData) do
		local instance = g_ItemManager:GetInstance();
		
		LuaEvents.ITG_QuickSocDevInfo(perkData[1]);
		local perkInfo = MapModData.ITGSG;
		MapModData.ITGSG = nil;
		
		instance.Votes:SetString(perkData[2]);
		instance.SocialDev:SetToolTipString(perkInfo.Help)
		
		if perkData[1] == cData.Chosen then
			IconHookup(GameInfo.Civilizations[civType].PortraitIndex, 32, GameInfo.Civilizations[civType].IconAtlas, instance.CivIcon);
			instance.CivIcon:SetHide(false)
		else
			instance.CivIcon:SetHide(true);
		end
		if perkData[1] == cData.Acquired then
			IconHookup(perkInfo.PortIndex, 64, perkInfo.IconAtlasC, Controls.PolicyImageL);
			IconHookup(perkInfo.PortIndex, 64, perkInfo.IconAtlasC, Controls.PolicyImageR);
			instance.SocialDev:SetText("[COLOR_POSITIVE_TEXT]" .. perkInfo.Name .. "[ENDCOLOR]")
			cNameAcquired = perkInfo.Name;
		else
			instance.SocialDev:SetText(perkInfo.Name)
		end
	end
	if cData.Type == 1 then
		Controls.DescriptionLabel:SetText("Your cultural group is strongly divided, each civilization acquired a social development of their choice.")
	elseif cData.Type == 2 then
		Controls.DescriptionLabel:SetText("You set a direction for your cultural group, [COLOR_POSITIVE_TEXT]" .. cNameAcquired .. "[ENDCOLOR] must be a correct path.")
	elseif cData.Type == 3 then
		Controls.DescriptionLabel:SetText("Your cultural group was influenced by an idea of [COLOR_POSITIVE_TEXT]" .. cNameAcquired .. "[ENDCOLOR], could it be a correct choice after all?")
	elseif cData.Type == 4 then
		Controls.DescriptionLabel:SetText("The rest of your cultural group choose a social development your people know for some time, we proudly move forward with [COLOR_POSITIVE_TEXT]" .. cNameAcquired .. "[ENDCOLOR].")
	elseif cData.Type == 5 then
--special case // full random, could be one of voted perks
		if not cNameAcquired then
			local instance = g_ItemManager:GetInstance();
			LuaEvents.ITG_QuickSocDevInfo(cData.Acquired);
			local perkInfo = MapModData.ITGSG;
			MapModData.ITGSG = nil;
			instance.Votes:SetString("N/A");
			instance.SocialDev:SetToolTipString(perkInfo.Help)
			instance.CivIcon:SetHide(true);
			IconHookup(perkInfo.PortIndex, 64, perkInfo.IconAtlasC, Controls.PolicyImageL);
			IconHookup(perkInfo.PortIndex, 64, perkInfo.IconAtlasC, Controls.PolicyImageR);
			instance.SocialDev:SetText("[COLOR_POSITIVE_TEXT]" .. perkInfo.Name .. "[ENDCOLOR]")
			cNameAcquired = perkInfo.Name;
		end
		Controls.DescriptionLabel:SetText("Your genius tried to develop skills your people have already adopted. You were randomly assigned [COLOR_POSITIVE_TEXT]" .. cNameAcquired .. "[ENDCOLOR].")
	end
	Controls.CanBeChangedLabel:SetHide(not cData.CanBeChanged)
	Controls.CanBeChangedLabel:SetText("You can replace it with cultural bonus.")
	Controls.TitleLabel:SetText("New Social Development")
	Controls.ItemStack:CalculateSize();
	Controls.MainStack:CalculateSize();
	--setsizy
	Controls.MainGrid:SetSizeY(Controls.MainStack:GetSizeY() + 120)
end

function OnClose()
	UIManager:DequeuePopup(ContextPtr);
end
Controls.CloseButton:RegisterCallback(Mouse.eLClick, OnClose);

function CalledGovOver()
   	if( ContextPtr:IsHidden() == false ) then
	   	OnClose();
	else
		DoPopulatePopup()
	   	UIManager:QueuePopup( ContextPtr, PopupPriority.WhosWinning );
   	end
end
LuaEvents.ITGSG_CallSocDevPopup.Add(CalledGovOver)

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function InputHandler( uiMsg, wParam, lParam )
    ----------------------------------------------------------------        
    -- Key Down Processing
    ----------------------------------------------------------------        
    if uiMsg == KeyEvents.KeyDown then
        if (wParam == Keys.VK_ESCAPE) then
		    OnClose();
	    	return true;
        end
        
        -- Do Nothing.
        if(wParam == Keys.VK_RETURN) then
			return true;
        end
    end
end
ContextPtr:SetInputHandler( InputHandler );
  
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function ShowHideHandler( bIsHide, bInitState )
    if( not bInitState ) then
        if( not bIsHide ) then
        	UI.incTurnTimerSemaphore();
        	Events.SerialEventGameMessagePopupShown(nil);
        else
            UI.decTurnTimerSemaphore();
            Events.SerialEventGameMessagePopupProcessed.CallImmediate(m_ITGpopupID, 0);
        end
    end
end
ContextPtr:SetShowHideHandler( ShowHideHandler );

----------------------------------------------------------------
-- 'Active' (local human) player has changed
----------------------------------------------------------------
function OnActivePlayerChanged( iActivePlayer, iPrevActivePlayer )
	if (not ContextPtr:IsHidden()) then
		ContextPtr:SetHide(true);
	end
end
Events.GameplaySetActivePlayer.Add(OnActivePlayerChanged);

ContextPtr:SetHide(true)