-------------------------------------------------
-- Happiness Info
-------------------------------------------------
include( "IconSupport" );
include( "InfoTooltipInclude" );
include( "InstanceManager" );

local bTickTock = true;
local ltBlue = {19/255,32/255,46/255,120/255};
local dkBlue = {12/255,22/255,30/255,120/255};
local bShowCompleted = true;

local g_SpecialManager1 = GenerationalInstanceManager:new( "SpecialInstance", "Base", Controls.SpecialStack1);
local g_SpecialManager2 = GenerationalInstanceManager:new( "SpecialInstance", "Base", Controls.SpecialStack2);
-------------------------------------------------
-------------------------------------------------

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function UpdateScreen()
	LuaEvents.ITGSG_RequestGT()
	local gData = MapModData.ITGSG;
	MapModData.ITGSG = nil;
	if not gData then
		return;
	end
	local iPlayer = Game.GetActivePlayer() ;
    local pPlayer = Players[iPlayer];
	g_SpecialManager1:ResetInstances();
	g_SpecialManager2:ResetInstances();
	local bFirstInst = true;
	local bAny = false;

	for iClass, data in pairs(gData.Players[iPlayer].SpecialUULog) do
		if data[2] ~= -1 and data[2] ~= data[1] then
			bAny = true;
			if bShowCompleted then
				local itemInstance;
				if bFirstInst then
					itemInstance = g_SpecialManager1:GetInstance();
				else
					itemInstance = g_SpecialManager2:GetInstance();
				end
				bFirstInst = not bFirstInst;
				local sTooltip = "[COLOR_POSITIVE_TEXT]" .. Locale.Lookup(GameInfo.Units[data[2]].Description) .. "[ENDCOLOR] is replacing basic [COLOR_GREY]"
				itemInstance.Name:SetText("[COLOR_POSITIVE_TEXT]" .. Locale.Lookup(GameInfo.Units[data[2]].Description)) 
				itemInstance.ProgressBar:SetHide(false)
				itemInstance.MainProgress:SetPercents( 1, 1 );	
				itemInstance.Frame2:SetHide(false)
				IconHookup(GameInfo.Units[data[2]].PortraitIndex, 64, GameInfo.Units[data[2]].IconAtlas, itemInstance.NewImage);
				
				itemInstance.BGImage:SetAlpha(0.15)
				if data[1] ~= -1 then
					sTooltip = sTooltip .. Locale.Lookup(GameInfo.Units[data[1]].Description) .. "[ENDCOLOR]."
					itemInstance.Frame1:SetHide(false)
					itemInstance.OldImage:SetAlpha(0.75)
					IconHookup(GameInfo.Units[data[1]].PortraitIndex, 64, GameInfo.Units[data[1]].IconAtlas, itemInstance.OldImage);
				else
					sTooltip = sTooltip .. Locale.Lookup(GameInfo.Units[GameInfo.UnitClasses[iClass].DefaultUnit].Description) .. "[ENDCOLOR]."
					itemInstance.Frame1:SetHide(true)
				end
				sTooltip = sTooltip .. "[NEWLINE]" .. GetHelpTextForUnit(data[2], false, true) 
				itemInstance.Availability:SetText("")
				
				itemInstance.Base:SetToolTipString(sTooltip)
			end
		end
	end
	if gData.Globals.SpecializationOn then
		LuaEvents.ITGSG_RequestPreciseUISpecialUUData(iPlayer)
		local extraData = MapModData.ITGSG;
		MapModData.ITGSG = nil;
		for iClass, data in pairs(gData.Players[iPlayer].SpecialUUProgress) do
			local cUnitType = Players[iPlayer]:GetPlayerUniqueUnit(iClass)
			if cUnitType ~= -1 then -- this actually happens in medieval (longswordsman, knight?)
				bAny = true;
				local itemInstance;
				if bFirstInst then
					itemInstance = g_SpecialManager1:GetInstance();
				else
					itemInstance = g_SpecialManager2:GetInstance();
				end
				bFirstInst = not bFirstInst;
				local sTooltip = ""
				local nAv = #gData.Globals.SpecialClassesAv[iClass];
				local sName = Locale.Lookup(GameInfo.Units[cUnitType].Description);
				if nAv == 0 then
					itemInstance.Name:SetText("[COLOR_GREY]" .. sName)
					itemInstance.BGImage:SetAlpha(0.15)
					itemInstance.ProgressBar:SetHide(true)
					itemInstance.Availability:SetText("No more available")
					sTooltip = "There are not available unique options left. We have to stick with basic [COLOR_GREY]" .. sName .. "[ENDCOLOR]."
				else
					itemInstance.BGImage:SetAlpha(0.15)
					itemInstance.Name:SetText(sName)
					sTooltip = "Progress: [COLOR_POSITIVE_TEXT]" .. extraData[iClass].Progress .. "/" .. extraData[iClass].Treshold .. "[ENDCOLOR] [ICON_ITG_SPECIALIZATION][NEWLINE][NEWLINE]"
					sTooltip = sTooltip .. "Total unitclass progress is based on experience (50%), amount of trained units (x40[ICON_ITG_SPECIALIZATION]) and can be speed up by special abilities (manufactories, great people, governors or budget). Treshold is based on how many unique units we have already developed and on amount of unique " .. sName .. " already chosen. Treshold:"  
					sTooltip = sTooltip .. "[NEWLINE][ICON_BULLET][COLOR_NEGATIVE_TEXT]" .. gData.Globals.SpecialBaseTreshold[iClass] .. "[ENDCOLOR] [ICON_ITG_SPECIALIZATION] from Base"
					sTooltip = sTooltip .. "[NEWLINE][ICON_BULLET][COLOR_NEGATIVE_TEXT]" .. gData.Players[iPlayer].SpecialExtraTreshold ..  "[ENDCOLOR] [ICON_ITG_SPECIALIZATION] from Your developments"
					sTooltip = sTooltip .. "[NEWLINE][ICON_BULLET][COLOR_NEGATIVE_TEXT]" .. gData.Globals.SpecialTreshold[iClass] .. "[ENDCOLOR] [ICON_ITG_SPECIALIZATION] from Global developments"
					sTooltip = sTooltip .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]" .. gData.Players[iPlayer].SpecialUUTresholdRed ..  "[ENDCOLOR] [ICON_ITG_SPECIALIZATION] from various rewards"

				
					sTooltip = sTooltip .. "[NEWLINE][NEWLINE]Available options remaining:"
					for jkj, utyp in pairs(gData.Globals.SpecialClassesAv[iClass]) do
						sTooltip = sTooltip .. "[NEWLINE][ICON_BULLET][COLOR_POSITIVE_TEXT]" .. Locale.Lookup(GameInfo.Units[utyp].Description) .. "[ENDCOLOR]"
					end
					itemInstance.ProgressBar:SetHide(false)
					local progressperc = math.min(extraData[iClass].Progress / extraData[iClass].Treshold, 1);
					itemInstance.MainProgress:SetPercents( progressperc, progressperc );	
					itemInstance.Availability:SetText("Available options: " .. nAv)
				end
				itemInstance.Frame2:SetHide(true)
				itemInstance.Frame1:SetHide(false);
				itemInstance.OldImage:SetAlpha(1)
				IconHookup(GameInfo.Units[cUnitType].PortraitIndex, 64, GameInfo.Units[cUnitType].IconAtlas, itemInstance.OldImage);
			
				itemInstance.Base:SetToolTipString(sTooltip)
				lastInstance = itemInstance;
			end
		end
	end

	Controls.NoAvailable:SetHide(bAny);

    Controls.SpecialStack1:CalculateSize();
    Controls.SpecialStack2:CalculateSize();
    Controls.SpecialStack1:ReprocessAnchoring();
    Controls.SpecialStack2:ReprocessAnchoring();
    Controls.MainScrollPanel:CalculateInternalSize();
end

function OnCheckClicked( )
	bShowCompleted = not bShowCompleted
	UpdateScreen()
end
Controls.CheckCompleted:RegisterCallback( Mouse.eLClick, OnCheckClicked );
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function ShowHideHandler( bIsHide, bInitState )
    if( not bIsHide ) then
    	UpdateScreen();
	end
end
ContextPtr:SetShowHideHandler( ShowHideHandler );
