-------------------------------------------------
-- Religion Overview Popup
-------------------------------------------------
include( "IconSupport" );
include( "InstanceManager" );
include( "ITGSG_AcademiesRewards.lua" );
include( "InfoTooltipInclude" );
-------------------------------------------------
-- Global Constants
-------------------------------------------------

local lastAcademy;
local g_CurrencyExchange = GenerationalInstanceManager:new( "GoldExchangeInstance", "Base", Controls.AcademiesStack);
local g_DetailInstance = GenerationalInstanceManager:new( "AcademyDetailInstance", "Root", Controls.AcaDetailStack);
local g_universityInstance = GenerationalInstanceManager:new( "UniversityAcademyInstance", "Root", Controls.UniversityStack);
local ltBlue = {19/255,32/255,46/255,120/255};
local dkBlue = {12/255,22/255,30/255,120/255};
local cupTab = {"[ICON_TROPHY_GOLD]", "[ICON_TROPHY_SILVER]", "[ICON_TROPHY_BRONZE]"}
local fWonderSortFunction;
local AImanagementT = {
{Name = "Manual", Type = -1, Help = "Support management is inactive."},
{Name = "Always Random", Type = 1, Help = "If you have at least 125 [ICON_GOLD] Gold at the turn start then academies (in undamaged cities) will be supported (random branch for 100 [ICON_GOLD] Gold)."},
{Name = "Keystone or Random", Type = 2, Help = "If you have at least 125 [ICON_GOLD] Gold at the turn start then academies (in undamaged cities) will be supported in following manner: branches needing one point for next keystone are gonna be prioritized, otherwise random branch for 100 [ICON_GOLD] Gold will be supported."},
{Name = "Always Highest", Type = 3, Help = "If you have at least 125 [ICON_GOLD] Gold at the turn start then academies (in undamaged cities) will be supported (branch with the highest amount of points)."},
}

function GetIDFromAIManagement(ah)
	for hh, bb in pairs(AImanagementT) do
		if bb.Type == ah then
			return hh;
		end
	end
	return 1;
end

function GetNiceShortCityDescription(index)
	local iPlot = Map.GetPlotByIndex(index)
	if iPlot:IsRevealed(Game.GetActiveTeam()) or Teams[Game.GetActiveTeam()]:IsHasMet(Players[iPlot:GetOwner()]:GetTeam()) then
		return iPlot:GetPlotCity():GetName()
	end
	return "Unknown";
end

function GetNiceShortDescription(i)
	if i == Game.GetActivePlayer() or Teams[Game.GetActiveTeam()]:IsHasMet(Players[i]:GetTeam()) then
		return Players[i]:GetCivilizationShortDescription()
	else
		return "Unknown";
	end
end
function GetNicePlayerID(i)
	if i == Game.GetActivePlayer() or Teams[Game.GetActiveTeam()]:IsHasMet(Players[i]:GetTeam()) then
		return i;
	else
		return -1;
	end
end

function OnClose()
	UIManager:DequeuePopup(ContextPtr);
end
Controls.CloseButton:RegisterCallback(Mouse.eLClick, OnClose);

local academyKeystones = GetAcademyKeystonesTab();
local bShowOnlyYours = false;
local m_Wonders_IM = InstanceManager:new("WonderInstance", "Button", Controls.WonderMainStack);
--make database 2 include

g_Tabs = {
	
	["WorldReligion"] = {
		Panel = Controls.WorldReligionPanel,
		SelectHighlight = Controls.WorldReligionsSelectHighlight,
	},

	["CustomsHouse"] = {
		Panel = Controls.CustomsHouseInfo,
		SelectHighlight = Controls.CustomsHouseSelectHighlight,
	},

	["Manufactories"] = {
		Panel = Controls.ManufactoriesInfo,
		SelectHighlight = Controls.ManufactoriesSelectHighlight,
	},
}


-------------------------------------------------
-- Global Variables
-------------------------------------------------
g_CurrentTab = nil;		-- The currently selected Tab.

-------------------------------------------------
-------------------------------------------------
	
-------------------------------------------------
-------------------------------------------------
function OnPopupMessage(popupInfo)
	
	local popupType = popupInfo.Type;
	if popupType ~= 199392 then
		return;
	end
	print("It is being fired at all? 3534324234")
	
	g_PopupInfo = popupInfo;
	if g_PopupInfo.Data2 then
		if g_PopupInfo.Data2 == 2 then
	        TabSelect("WorldReligion");
		elseif g_PopupInfo.Data2 == 4 then
	        TabSelect("CustomsHouse");
		elseif g_PopupInfo.Data2 == 5 then
	        TabSelect("Manufactories");
		end
	end
	
	if( g_PopupInfo.Data1 == 1 ) then
    	if( ContextPtr:IsHidden() == false ) then
    		OnClose();
		else
        	UIManager:QueuePopup( ContextPtr, PopupPriority.InGameUtmost );
    	end
	else
		UIManager:QueuePopup( ContextPtr, PopupPriority.SocialPolicy );
	end   	
end
Events.SerialEventGameMessagePopup.Add( OnPopupMessage );

function CalledGovOver(val1, val2)
   	if( ContextPtr:IsHidden() == false ) then
   		OnClose();
	else
		if not val1 then
			TabSelect("WorldReligion");
		elseif val1 == 1 then
			if val2 then
				lastAcademy = val2;
			end
			TabSelect("WorldReligion");
		elseif val1 == 4 then
			LuaEvents.ITG_CallCustomsHouse(val2)
			TabSelect("CustomsHouse");
		elseif val1 == 5 then
			LuaEvents.ITG_CallManufactory(val2)
			TabSelect("Manufactories");
		end
	   	UIManager:QueuePopup( ContextPtr, PopupPriority.InGameUtmost );
   	end
end
LuaEvents.ITG_CallStateOverview.Add(CalledGovOver)

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function InputHandler( uiMsg, wParam, lParam )
    ----------------------------------------------------------------        
    -- Key Down Processing
    ----------------------------------------------------------------        
    if(uiMsg == KeyEvents.KeyDown) then
        if (wParam == Keys.VK_ESCAPE) then
			OnClose();
			return true;
        end
        
        -- Do Nothing.
        if(wParam == Keys.VK_RETURN) then
			return true;
        end
    end
end
ContextPtr:SetInputHandler( InputHandler );

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function TabSelect(tab)

	for i,v in pairs(g_Tabs) do
		local bHide = i ~= tab;
		v.Panel:SetHide(bHide);
		v.SelectHighlight:SetHide(bHide);
	end
	g_CurrentTab = tab;
	g_Tabs[tab].RefreshContent();	
end
Controls.TabButtonWorldReligions:RegisterCallback( Mouse.eLClick, function() TabSelect("WorldReligion"); end );
Controls.TabButtonCustomsHouse:RegisterCallback( Mouse.eLClick, function() TabSelect("CustomsHouse"); end );
Controls.TabButtonManufactories:RegisterCallback( Mouse.eLClick, function() TabSelect("Manufactories"); end );

function PurchaseAcademyFunct()
	if not Players[Game.GetActivePlayer()]:IsTurnActive() then
		return;
	end
	LuaEvents.ITG_CallPurchaseAcademy(Game.GetActivePlayer())
	RefreshWorldReligions()
	Events.AudioPlay2DSound("AS2D_INTERFACE_BUY_TILE")
end
Controls.PurchaseAcademy:RegisterCallback(Mouse.eLClick, PurchaseAcademyFunct)

local TabOfDetBonusStrings  = {
Science = {"Research", "[ICON_RESEARCH]", "Support Research Department. Action will increase adequate bonus by 1 and has 10 turns of cooldown.", "+1 [ICON_RESEARCH] Science from working Academy per normal bonus. Unique bonuses are mostly scientific."},
Production = {"Engineering", "[ICON_PRODUCTION]", "Support Faculty of Engineering. Action will increase adequate bonus by 1 and has 10 turns of cooldown.", "+1% [ICON_PRODUCTION] Production modifier in a city per normal bonus. Unique bonuses are mostly industrial."},
Health = {"Medicine", "[ICON_ITG_HEALTH_1]", "Support Medical Department. Action will increase adequate bonus by 1 and has 10 turns of cooldown.", "+1 [ICON_ITG_HEALTH_1] Health modifier in a city per normal bonus. Unique bonuses are mostly Health related."},
Military = {"Military", "[ICON_GREAT_GENERAL]", "Support Militaristic Department. Action will increase adequate bonus by 1 and has 10 turns of cooldown.", "+1 [ICON_GREAT_GENERAL] Great General point every turn per normal bonus. Unique bonuses are mostly focused on land military."},
Faith = {"Theology", "[ICON_PEACE]", "Support Faculty of Theology. Action will increase adequate bonus by 1 and has 10 turns of cooldown.", "+1 [ICON_PEACE] Faith from working Academy per normal bonus. Unique bonuses are mostly religious."},
Naval = {"Marine", "[ICON_GREAT_ADMIRAL]", "Support Marinal Department. Action will increase adequate bonus by 1 and has 10 turns of cooldown.", "+1 [ICON_GREAT_ADMIRAL] Great Admiral point every turn per normal bonus. Unique bonuses are mostly focused on naval military."},
Economy = {"Economy", "[ICON_INVEST]","Support Economic Department. Action will increase adequate bonus by 1 and has 10 turns of cooldown.", "+1% [ICON_GOLD] Gold modifier in a city per normal bonus. Unique bonuses are mostly focused on Economy."},
National = {"National", "[ICON_ITG_UNIFY]", "Support National Department. Action will increase adequate bonus by 1 and has 10 turns of cooldown.", "+0.5 [ICON_ITG_UNIFY] Unifying Presence per normal bonus. Unique bonuses are mostly focused on National Unity."},
Archaeology = {"Archaeology", "[ICON_RES_ARTIFACTS]", "Support Archeological Department. Action will increase adequate bonus by 1 and has 10 turns of cooldown.", "+2 [ICON_RES_ARTIFACTS] Archeological points every turn per normal bonus. Unique bonuses are mostly focused on Archaeology."},
}

function OnSupportAcademyClicked(type)
	LuaEvents.ITGSG_PlayerSupportAcademy(lastAcademy, Game.GetActivePlayer(), type)
	OnDetailedAcademy(lastAcademy)
	Events.AudioPlay2DSound("AS2D_INTERFACE_BUY_TILE")
end

function OnDetailedAcademy(void1)
	if void1 then
		Controls.AcademyDetailBox:SetHide(false)
		lastAcademy = void1;
	else
		Controls.AcademyDetailBox:SetHide(true)
		return;
	end
	LuaEvents.ITGSG_RequestGT(5, void1);
	local gData = MapModData.ITGSG;
	MapModData.ITGSG = nil;
	if not gData then
		return
	end
	local bDisableAll = (not Players[Game.GetActivePlayer()]:IsTurnActive()) or (MapModData.DBScenario.GoldBudgetOnly)
	Controls.AcaDetailFounded:SetText(gData.Academies[void1].Year) 

	if gData.Academies[void1].FounderGP then
		Controls.AcaDetailFounder:SetText(Locale.Lookup(gData.Academies[void1].FounderGP))
		Controls.AcaDetailFounder:SetHide(false)
	else
		Controls.AcaDetailFounder:SetHide(true)
	end 
	local bOwner = Game.GetActivePlayer() ~= gData.Academies[void1].Player;
	local itgTurn = Game.GetGameTurn() - (gData.ITGReduceTurns or 0);
	local bDisable = itgTurn <= gData.Academies[void1].SupportCD;

-- START
	LuaEvents.ITGSG_RequestRewardsStringOfAcademy(void1);
	local gHH = MapModData.ITGSG;
	MapModData.ITGSG = nil;
	Controls.AcaDetailRank:SetText("Rank: " .. (gData.Academies[void1].Rank or "N/A"))
	Controls.AcaDetailRank:SetToolTipString(gHH[3]);

	Controls.AcaDetailPrestige:SetText("(" .. math.floor(gData.Academies[void1].Prestige) .. " [ICON_ITG_ACADEMY_1])") 
	Controls.AcaDetailPrestige:SetToolTipString(gHH[9]);

	Controls.AcaDetailGrowth:SetText("[COLOR_POSITIVE_TEXT]+" .. gHH[4])
	Controls.AcaDetailFade:SetText("[COLOR_NEGATIVE_TEXT]" .. gHH[5])
	local iChangePrestige = gHH[4] + gHH[5];
	if iChangePrestige > 0 then
		Controls.AcaDetailNetto:SetText("[COLOR_POSITIVE_TEXT]+" .. iChangePrestige)
	else
		Controls.AcaDetailNetto:SetText("[COLOR_NEGATIVE_TEXT]" .. iChangePrestige)
	end
	Controls.AcaDetailGrowth:SetToolTipString(gHH[6]);
	Controls.AcaDetailFade:SetToolTipString(gHH[7]);
	Controls.AcaDetailNetto:SetToolTipString(gHH[8]);



	if gHH[1] ~= "" then
		Controls.AcaDetailName:SetText("[ICON_ITG_ACADEMY_2] " .. gData.Academies[void1].Name .. " (" .. gHH[1] .. ")")
		Controls.AcaDetailName:SetToolTipString("Current rewards from [ICON_ITG_ACADEMY_1] Prestige:" .. gHH[2]);
	else
		Controls.AcaDetailName:SetText("[ICON_ITG_ACADEMY_2] " .. gData.Academies[void1].Name)
		Controls.AcaDetailName:SetToolTipString("")
	end


	--// END PRESTIGE TOOLTIP
	
	
	
	g_DetailInstance:ResetInstances();
	Controls.SupportButtonRandom:SetHide(bOwner or MapModData.DBScenario.GoldBudgetOnly)
	Controls.SupportButtonRandom:SetDisabled(bDisableAll or bDisable or (Players[gData.Academies[void1].Player]:GetGold() < 100) or (not gData.Academies[void1].Active)  or (not gData.Academies[void1].Bonuses))
	if bDisable then
		Controls.SupportRandomLabel:SetText(1 + gData.Academies[void1].SupportCD - itgTurn .. "[ICON_SWAP]")
	else
		Controls.SupportRandomLabel:SetText("100[ICON_GOLD]")
	end
	for hh, ss in pairs(gData.Academies[void1].Bonuses or {}) do
		local itemInstance = g_DetailInstance:GetInstance();
		itemInstance.Type:SetText(TabOfDetBonusStrings[hh][1])

		if(bTickTock == false) then
			itemInstance.Root:SetColorVal(unpack(ltBlue));
		else
			itemInstance.Root:SetColorVal(unpack(dkBlue));
		end
		bTickTock = not bTickTock;
		local bonus = ""
		local numminis = ss - math.floor(ss/5);
		for i = 1, numminis do
			bonus = bonus .. TabOfDetBonusStrings[hh][2];
		end
		itemInstance.Bonus:SetText(bonus)
		itemInstance.Type:SetToolTipString(TabOfDetBonusStrings[hh][4])
		itemInstance.Bonus:SetToolTipString(TabOfDetBonusStrings[hh][4] .. "[NEWLINE]Currently " .. numminis .. " points and " .. (ss - numminis) .. " abilities acquired.")
		itemInstance.SupportButton:SetHide(bOwner or MapModData.DBScenario.GoldBudgetOnly)
		itemInstance.SupportButton:SetDisabled(bDisableAll or bDisable or (Players[gData.Academies[void1].Player]:GetGold() < 125) or (not gData.Academies[void1].Active))
		itemInstance.SupportButton:SetToolTipString(TabOfDetBonusStrings[hh][3])
		if bDisable then
			itemInstance.SupportLabel:SetText(1 + gData.Academies[void1].SupportCD - itgTurn .. "[ICON_SWAP]")
		else
			itemInstance.SupportLabel:SetText("125[ICON_GOLD]")
		end
		itemInstance.SupportButton:RegisterCallback(Mouse.eLClick, function() OnSupportAcademyClicked(hh) end);

		--keystones
		local hhh1 = 1;
		local sToolTS = ""
		for h, d in pairs(gData.Academies[void1].KeyAbilities) do
			if d[2] == hh then
				if hhh1 < 6 then
					sToolTS = academyKeystones[h].Help
					itemInstance["KeystoneImage" .. hhh1]:SetHide(false)
					IconHookup( academyKeystones[h].PortIndex, 45, academyKeystones[h].IconAtlas, itemInstance["KeystoneImage" .. hhh1] );				
					itemInstance["KeystoneImage" .. hhh1]:SetToolTipString(sToolTS)
					hhh1 = hhh1 + 1;
				else
					sToolTS = sToolTS .. academyKeystones[h].Help
					itemInstance["KeystoneImage5"]:SetToolTipString(sToolTS)
				end
			end
		end
		for ddj = hhh1, 5 do
			itemInstance["KeystoneImage" .. ddj]:SetHide(true)
		end
	end
	Controls.AcaDetailStack:CalculateSize();
    Controls.AcaDetailStack:ReprocessAnchoring();
    Controls.AcaDetailsScroll:CalculateInternalSize();


	local treshold = 100 + 20 * gData.Academies[void1].NumAcquiredBonuses;
	Controls.GPMeter:SetPercent( gData.Academies[void1].PointsTowardBonus / treshold )
	Controls.GPMeter2:SetPercent( (gData.Academies[void1].PointsTowardBonus + gData.Academies[void1].UIapgpt) / treshold )
	Controls.MeterImage:SetToolTipString("Progress towards next Development bonus: " .. gData.Academies[void1].PointsTowardBonus .. "/" .. treshold .. "[ICON_ITG_ACADEMY_2].[NEWLINE]Each turn Academy earns " .. gData.Academies[void1].UIapgpt .. " [ICON_ITG_ACADEMY_2] Development points if active.")
end
Controls.SupportButtonRandom:RegisterCallback(Mouse.eLClick, function() OnSupportAcademyClicked("Random") end);
Controls.SupportButtonRandom:SetToolTipString("Support Academy. Action will increase random bonus by 1 and has 10 turns of cooldown.")

function SortFunctionForLowestMapDistance(a, b)
	local va = (a ~= nil and a[2] ~= nil) and a[2] or -1;
	local vb = (b ~= nil and b[2] ~= nil) and b[2] or -1;
	return tonumber(va) < tonumber(vb);
end

function SetCurrentSelection(v1, v2)
	Controls.AutomaticSupportPD:GetButton():LocalizeAndSetText(AImanagementT[v1].Name);		
	Controls.AutomaticSupportPD:GetButton():SetToolTipString(AImanagementT[v1].Help);
	if v2 == 1 then
		LuaEvents.ITGHumanPlayerChooseAIAcademyManagement(Game.GetActivePlayer(), AImanagementT[v1].Type);
		RefreshWorldReligions()
	end
end

function RefreshWorldReligions()
	LuaEvents.ITGSG_RequestGT();
	local gData = MapModData.ITGSG;
	MapModData.ITGSG = nil;
	if not gData then
		return
	end
	local iTeam = Game.GetActiveTeam();
	local iPlayer = Game.GetActivePlayer();
	if not gData.Players[iPlayer] then
		return;
	end
	g_CurrencyExchange:ResetInstances();
	if false then --gData.Players[iPlayer].CultBonusOn[69] then
		g_universityInstance:ResetInstances()
		LuaEvents.ITGSG_RequestUniversitiesKeystones(iPlayer);
		local uData = MapModData.ITGSG;
		MapModData.ITGSG = nil;
		for a, b in pairs(uData) do
    		local itemInstance = g_universityInstance:GetInstance();
			IconHookup( b.PortIndex, 45, b.IconAtlas, itemInstance.KeystoneImage );
			itemInstance.KeystoneImage:SetToolTipString(b.Help)
			itemInstance.KeyButton:SetDisabled(b.Disable)
		end
		Controls.UniversityStack:CalculateSize();
		Controls.UniversityStack:ReprocessAnchoring();
		Controls.UniversityScroll:CalculateInternalSize();
		Controls.UniversityBox:SetHide(false)
	else
		Controls.UniversityBox:SetHide(true)
	end
	local listH = {}
	for index, gdd in pairs(gData.Academies) do
		if gdd.Rank then
			table.insert(listH, {index, gdd.Rank});
		end
	end
	table.sort(listH, SortFunctionForLowestMapDistance);
	for index, gdd in pairs(gData.Academies) do
		if not gdd.Rank then
			table.insert(listH, {index, 0})
		end
	end
	for hhi, vv in pairs(listH) do
		local gdd = gData.Academies[vv[1]];
		local gPlot = Map.GetPlotByIndex(vv[1])
		local gPlayer = gPlot:GetOwner();
		if (not bShowOnlyYours) or (gPlayer == iPlayer) then
    		local itemInstance = g_CurrencyExchange:GetInstance();
			local dn = gdd.Name;
			if not Map.GetPlotByIndex(vv[1]):IsRevealed(iTeam) then
				dn = "Unknown";
				gPlayer = -1;
				itemInstance.Base:SetDisabled(true)
			else
				itemInstance.Base:SetDisabled(false)
			end
			if gdd.Rank then
				local ss = ""
				for i, reward in pairs(gData.Globals.AcademyRewards) do
					if gdd.ActiveRewards[reward] then
						ss = ss .. cupTab[i];
					end
				end
		
				if ss ~= "" then
					itemInstance.Description:SetText(gdd.Rank .. ". " .. dn .. "[NEWLINE]" .. ss);
				else
					itemInstance.Description:SetText(gdd.Rank .. ". " .. dn);
				end
			else
				itemInstance.Description:SetText("N/A " .. dn);
			end
			itemInstance.CurrencyPercent:SetText(math.floor(gdd.Prestige) .. " [ICON_ITG_ACADEMY_1]")



			if(bTickTock == false) then
				itemInstance.Box:SetColorVal(unpack(ltBlue));
			else
				itemInstance.Box:SetColorVal(unpack(dkBlue));
			end
			CivIconHookup( gPlayer, 32, itemInstance.Icon, itemInstance.CivIconBG, itemInstance.CivIconShadow, false, true);  

			itemInstance.Base:SetVoid1(vv[1])
			itemInstance.Base:RegisterCallback(Mouse.eLClick, OnDetailedAcademy);

			local buttonWidth, buttonHeight = itemInstance.Base:GetSizeVal();
			itemInstance.Base:SetSizeVal(buttonWidth, 65);
			itemInstance.Box:SetSizeVal(buttonWidth + 20, 65);
			itemInstance.BounceAnim:SetSizeVal(buttonWidth + 20, 70);
			itemInstance.BounceGrid:SetSizeVal(buttonWidth + 20, 70);
			bTickTock = not bTickTock;
--			hinstance = itemInstance;
		end
	end
    Controls.AcademiesStack:CalculateSize();
    Controls.AcademiesStack:ReprocessAnchoring();
    Controls.AcademiesScroll:CalculateInternalSize();

	LuaEvents.ITGSG_CanPlayerPurchaseAcademy(iPlayer);
	Controls.PurchaseAcademy:SetHide(not MapModData.ITGSG);
	MapModData.ITGSG = nil;
	if gData.Players[iPlayer] then
		Controls.PurchaseAcademyLabel:SetText((MapModData.DBScenario.AcademyCost + gData.Players[iPlayer].ExtraAcademyCost) .. "[ICON_GOLD] for Academy")
		Controls.PurchaseAcademy:SetDisabled((MapModData.DBScenario.AcademyCost + gData.Players[iPlayer].ExtraAcademyCost) > Players[iPlayer]:GetGold())
	end
--academy support button
	local automaticPurchasePullDown = Controls.AutomaticSupportPD;
	function AddToPullDown(text, tooltip, v1, v2)
		local controlTable = {};
		automaticPurchasePullDown:BuildEntry( "InstanceOne", controlTable );
		
		controlTable.Button:SetVoids(v1, v2);
		controlTable.Button:SetText(text);
		controlTable.Button:SetToolTipString(tooltip);
	end
	automaticPurchasePullDown:ClearEntries();
	for a, b in pairs(AImanagementT) do
		AddToPullDown(b.Name, b.Help, a, 1)
	end
	if gData.Players[iPlayer] then
		SetCurrentSelection(GetIDFromAIManagement(gData.Players[iPlayer].AIAcademyManager), 2);
		automaticPurchasePullDown:CalculateInternals();
		automaticPurchasePullDown:RegisterSelectionCallback(function(v1, v2)
			SetCurrentSelection(v1, v2);
		end); 
	end
	Controls.StackPulldownAI:SetHide(gData.Globals.ScenarioType == 5);
	OnDetailedAcademy(lastAcademy)
end
g_Tabs["WorldReligion"].RefreshContent = RefreshWorldReligions;

function RefreshCustomsHouses()

end
g_Tabs["CustomsHouse"].RefreshContent = RefreshCustomsHouses;

function RefreshManufactories()

end
g_Tabs["Manufactories"].RefreshContent = RefreshManufactories;

function OnShowOnlyYours( bIsChecked )
	bShowOnlyYours = bIsChecked;
	TabSelect("WorldReligion")
end
Controls.HideShowOnlyYours:RegisterCheckHandler( OnShowOnlyYours );

-- Updates the sort option structure

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function ShowHideHandler( bIsHide, bInitState )
	if( not bInitState ) then
        if( not bIsHide ) then
        	CivIconHookup( 0, 64, Controls.Icon, Controls.CivIconBG, Controls.CivIconShadow, false, true );
			UI.incTurnTimerSemaphore();  
        	Events.SerialEventGameMessagePopupShown(g_PopupInfo);
        	
        	TabSelect(g_CurrentTab);
        else
			if(g_PopupInfo ~= nil) then
				Events.SerialEventGameMessagePopupProcessed.CallImmediate(199392, 0);
            end
            UI.decTurnTimerSemaphore();
        end
    end
end
ContextPtr:SetShowHideHandler( ShowHideHandler );

----------------------------------------------------------------
-- 'Active' (local human) player has changed
----------------------------------------------------------------
--function OnActivePlayerChanged()
	--if (not Controls.ChooseConfirm:IsHidden()) then
	--	Controls.ChooseConfirm:SetHide(true);
	--end
--end
--Events.GameplaySetActivePlayer.Add(OnActivePlayerChanged);

-----------------------------------------------------------------
ContextPtr:SetHide(true)
TabSelect("WorldReligion");

Controls.GreatPersonLabel:SetText("  [ICON_ITG_ACADEMY_2] New Passive Point[ICON_ITG_ACADEMY_2]")
Controls.GPMeter2:SetAlpha(0.5)

function OnFindOnMapButtonClicked ()
	UI.LookAt(Map.GetPlotByIndex(lastAcademy), 0);
end
Controls.FindOnMapButton:RegisterCallback( Mouse.eLClick, OnFindOnMapButtonClicked );
