local dgActions;
local galTab;
local gAlreadyConsidered;
local csInno32 = GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_CSTATE_32;
local empireInno14 = GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_EMPIRE_14;

function GovConsiderAction1(govID, selfID)
	local chance = 40 + GetGovActionChanceFromDream(govID, selfID);
	local gLoyalty = gT.Globals.Governors[govID].Character.LoyaltyType;
	local cP = gT.Globals.Governors[govID].Player;
	local lP = gT.Globals.Governors[govID].LastPlayer;
	if cP ~= -1 then
		if gT.Globals.Governors[govID].Type ~= 7 then
			local numContact = GetGovernorForeignContactsActive(govID);
			if gLoyalty == 1 then
				if numContact > 0 then
					return false;
				end
			elseif numContact > 2 then
				return false;
			end
			if numContact == 0 then
				chance = chance + 10;
			end
		else
			chance = chance + 10;
		end
	else
		chance = chance + 40;
	end
	if not gT.Globals.Governors[govID].City then
		chance = chance + 20;
	end
	if not LastChance(chance) then
		return false;
	end
	local options = {}
	for g, h in pairs(gT.Players) do
		if (not Players[g]:IsMinorCiv()) and (Players[g]:IsAlive()) then
			if not gT.Globals.Governors[govID].ForeignContacts[g] then
				if (cP == -1 and Teams[Players[lP]:GetTeam()]:IsHasMet(Players[g]:GetTeam())) or ((cP ~= -1) and (Teams[Players[cP]:GetTeam()]:HasEmbassyAtTeam(Players[g]:GetTeam())) or (Teams[Players[g]:GetTeam()]:HasEmbassyAtTeam(Players[cP]:GetTeam()))) then
					local eval = GetGovernorEvaluationOfForeignPlayer(govID, g);
					if cP ~= -1 then
						if Teams[Players[cP]:GetTeam()]:IsAtWar(Players[g]:GetTeam()) then
							if (gLoyalty == 1) or (gLoyalty == 2) then
								eval = eval - 1000;
							elseif gLoyalty == 5 then
								eval = eval + 20;
							end
						elseif Players[cP]:IsDoF(g) then
							eval = eval + 5;
						end
						if gLoyalty == 10 then
							for jgovId, bool in pairs(gT.Players[cP].Governors) do
								if (gT.Globals.Governors[jgovId].ForeignContacts[g]) then
									if gT.Globals.Governors[jgovId].ForeignContacts[g].Failed then
										eval = eval - 5;
									else
										eval = eval + 5;
									end
								end
							end
						end
					end
					if eval > 0 then
						table.insert(options, {g, eval})
					end
				end
			end
		end
	end
	if #options > 0 then
		GenerateDiploNote(GetBasicGovernorOptionFromEvalTab(options, gLoyalty), govID, selfID)
		return true;
	end
	return false;
end

function GetGovernorEvaluationOfForeignPlayer(govID, g)
	local eval = 10 + Players[g]:GetNumCities() - GetNumActiveGovernors(g);
	eval = eval - math.floor(gT.Players[g].ForeignDiploActionPenalty / 2)
	local iPlayer = gT.Globals.Governors[govID].Player;
	if iPlayer == -1 then
		iPlayer = gT.Globals.Governors[govID].LastPlayer;
	end
	if gT.Players[iPlayer].CultureType == gT.Players[g].CultureType then
		eval = eval + 3;
		if gT.Players[iPlayer].SubcultureType == gT.Players[g].SubcultureType then
			eval = eval + 2;
		end
	end
	if HasPlayerTech(g, GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_HORDE_7, "itgTh7") then
		eval = eval + 5;
	end
	if gT.Globals.Governors[govID].CityReligion then
		if Players[g]:GetReligionCreatedByPlayer() == gT.Globals.Governors[govID].CityReligion then
			eval = eval + 8;
		elseif gT.Players[g].OfficialReligion == gT.Globals.Governors[govID].CityReligion then
			eval = eval + 4;
		end
	end
	return eval;
end

function GetBasicGovernorOptionFromEvalTab(options, gLoyalty)
	if gLoyalty == 8 then
		return options[LastRandom(1,#options)][1];
	elseif gLoyalty == 9 then
		table.sort(options, SortFunctionForGreaterInteger2)
		return options[1][1];
	else
		return GetRandomFromBiasedChanceTable(options)
	end
end

function GetForeignOfferLoyaltyModifier(govID, gLoyalty)
	local base = 1;
	if gLoyalty == 1 or gLoyalty == 2 then
		base = 0.1;
	elseif gLoyalty == 5 then
		base = 2;
	elseif gLoyalty == 7 then
		base = 65 / math.max(gT.Globals.Governors[govID].Power, 20)
	end
	if gT.Globals.Governors[govID].Dream and gT.Globals.Governors[govID].Dream.Active and gT.Globals.Governors[govID].Dream.ID == 7 then
		base = base * 2;
	end
	return base;
end

function HasPlayerUnrevealedCity(iPlayer, g)
	local iTeam = Players[g]:GetTeam();
	for iCity in Players[iPlayer]:Cities() do
		if not iCity:Plot():IsRevealed(iTeam) then
			return true;
		end
	end
	return false;
end

function IsPlayerGoodForSecretPact(iPlayer, g, govID)
	local iTeam = Players[iPlayer]:GetTeam();
	local sTeam = Players[g]:GetTeam();
	if gT.Globals.Governors[govID].ForeignContacts[g].Favour >= LastRandom(6,18) then
		if Teams[sTeam]:IsHasMet(iTeam) then
			if Teams[sTeam]:CanDeclareWar(sTeam) then
				if not Players[iPlayer]:IsDoF(g) then
					if not Teams[iTeam]:IsDefensivePact(sTeam) then
						local iCity = Map.GetPlotByIndex(gT.Globals.Governors[govID].City):GetPlotCity();
						local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
						for h, sIndex in pairs(GetNearCities(cID, GetGovernorRange(iPlayer, govID))) do
							local sCity = Map.GetPlotByIndex(sIndex):GetPlotCity();
							if sCity:GetOwner() == g then
								return true;
							end
						end
					end
				end
			end
		end
	end
	return false;
end

function HasPlayerUnitBuildingToUnlock(iPlayer, g, govID)
	if #GetBuildingClassesToUnlock(g, {[iPlayer] = true}) > 0 then
		return true;
	end
	return (#GetUnitClassesToUnlock(g, {[iPlayer] = true}) > 0)
end

function BasicForeignConsiderAction(govID, selfID, basechance, Checkfunc)
	local iPlayer = gT.Globals.Governors[govID].Player;
	local gLoyalty = gT.Globals.Governors[govID].Character.LoyaltyType;
	local chance = math.max(1, basechance * GetForeignOfferLoyaltyModifier(govID, gLoyalty));
	if LastChance(chance) then
		local options = {}
		for g, h in pairs(gT.Globals.Governors[govID].ForeignContacts) do
			if (not h.Failed) and (not h.Offers[selfID]) and (Players[g]:IsAlive()) then
				if not HasPlayerDiploNoteOfTypeWaiting(g, selfID) then
					if (not Checkfunc) or Checkfunc(iPlayer, g, govID) then
						table.insert(options, {g, GetGovernorEvaluationOfForeignPlayer(govID, g)})
						break;
					end
				end
			end
		end
		if #options > 0 then
			local tPlayer = GetBasicGovernorOptionFromEvalTab(options, gLoyalty);
			if (gT.Players[tPlayer].ForeignDiploActionPenalty == 0) or (not LastChance(gT.Players[tPlayer].ForeignDiploActionPenalty)) then
				GenerateDiploNote(tPlayer, govID, selfID)
				return true;
			end
		end
	end
	return false;
end
function GovConsiderAction33(govID, selfID)
	return BasicForeignConsiderAction(govID, selfID, 10, IsPlayerGoodForSecretPact)
end

function GovConsiderAction9(govID, selfID)
	return BasicForeignConsiderAction(govID, selfID, 7, HasPlayerUnrevealedCity)
end
function GovConsiderAction36(govID, selfID)
	return BasicForeignConsiderAction(govID, selfID, 9, HasPlayerUnitBuildingToUnlock)
end
function CanOfferSpyProtectionTo(iPlayer, g, govID)
	return (not HasGovernorProtectionOverSpies(g, iPlayer))
end
function GovConsiderAction53(govID, selfID)
	if gT.Globals.Governors[govID].IntelInsight then
		return BasicForeignConsiderAction(govID, selfID, 9, CanOfferSpyProtectionTo)
	end
end
function GetIntroduceCSForGovAction(iPlayer, sPlayer)
	local valid = {};
	local sTeam = Players[sPlayer]:GetTeam();
	local iTeam = Players[iPlayer]:GetTeam();
	local tab = {};
	for g, h in pairs(gT.Players) do
		if Players[g]:IsMinorCiv() and (Players[g]:GetNumCities() > 0) then
			if Teams[iTeam]:IsHasMet(Players[g]:GetTeam()) and (not Teams[sTeam]:IsHasMet(Players[g]:GetTeam())) then
				table.insert(tab, g);
			end
		end
	end
	if #tab > 0 then
		return RandomFromTab(tab);
	end
	return nil;
end
function GovConsiderAction52(govID, selfID)
	local iPlayer = gT.Globals.Governors[govID].Player;
	local gTurn = GetITGGameTurn() - 5;
	local options = {}
	for g, h in pairs(gT.Globals.Governors[govID].ForeignContacts) do
		if (not h.Failed) and (not h.Offers[selfID]) and (Players[g]:IsAlive()) then
			if h.Established >= gTurn then
				if LastChance(75) then
					if GetNumDiploNotesOfTypeWaiting(iPlayer, selfID) == 0 then -- do not want to repeat that
						local csToMeet = GetIntroduceCSForGovAction(iPlayer, g)
						if csToMeet then
							table.insert(options, {g, csToMeet})
						end
					end
				end		
			end
		end
	end
	if #options > 0 then
		local tab = RandomFromTab(options);
		local tPlayer = tab[1];
		if (gT.Players[tPlayer].ForeignDiploActionPenalty == 0) or (not LastChance(gT.Players[tPlayer].ForeignDiploActionPenalty)) then
			GenerateDiploNote(tPlayer, govID, selfID, {tab[2]})
			return true;
		end
	end
	return false;
end
function GovConsiderAction10(govID, selfID)
	return BasicForeignConsiderAction(govID, selfID, 9, GetValidAgentToExpose)
end
function GovConsiderAction11(govID, selfID)
	return BasicForeignConsiderAction(govID, selfID, 25, GetValidLeagueResolutionToInfluence)
end
function GovConsiderAction12(govID, selfID)
	return BasicForeignConsiderAction(govID, selfID, 1000, nil)
end
function GovConsiderAction20(govID, selfID)
	if not gT.Globals.Governors[govID].City then
		return false;
	end
	for a, b in pairs(gT.Globals.Governors[govID].ForeignContacts) do
		if b.TradeTarget then -- only one
			return false;
		end
	end
	return BasicForeignConsiderAction(govID, selfID, 3, nil)
end
function GovConsiderAction21(govID, selfID)
	return BasicForeignConsiderAction(govID, selfID, 5, GetValidGPForGovernorToInvite)
end

function GetGovActionBasicActionChance(govID, selfID, base, decisivemod, repeatMod, causesExtra)
	local chance = base + gT.Globals.Governors[govID].Character.Decisiveness * decisivemod;
	local gLoyalty = gT.Globals.Governors[govID].Character.LoyaltyType;
	chance = chance + GetGovActionChanceBasedOnCareerType(selfID, gT.Globals.Governors[govID].Type)
	chance = chance + GetGovActionChanceFromDream(govID, selfID)
	if causesExtra then
		local iPlayer = gT.Globals.Governors[govID].Player;
		for cause, bonus in pairs(causesExtra) do
			if gT.Players[iPlayer].GovCauses[cause] then
				chance = chance + bonus;
			end
		end
	end
	chance = chance - (gT.Globals.Governors[govID].ProposalsMade[selfID] or 0) * repeatMod;
	chance = math.max(math.floor(chance), 1)
	return chance;
end

function GovConsiderAction2(govID, selfID)
	local iPlayer = gT.Globals.Governors[govID].Player;
	if Players[iPlayer]:GetGold() > 100 then
		return false;
	end
	if gT.Players[iPlayer].PrevTurnGPT > -8 then
		return false;
	end
	if Players[iPlayer]:GetNumCities() < 3 then
		return false;
	end
	if LastChance(GetGovActionBasicActionChance(govID, selfID, 3, 0.5, 5, {[6] = 10})) then
		GenerateDiploNote(iPlayer, govID, selfID)
		return true;
	end
	return false;
end

function GovConsiderAction3(govID, selfID)
	local iPlayer = gT.Globals.Governors[govID].Player;
	if not gT.Players[iPlayer].GovCauses[5] then
		return false;
	end
	if LastChance(GetGovActionBasicActionChance(govID, selfID, 10, 0.5, 3, {[2] = 5})) then
		GenerateDiploNote(iPlayer, govID, selfID)
		return true;
	end
	return false;
end

function GovConsiderAction4(govID, selfID)
	local iPlayer = gT.Globals.Governors[govID].Player;
	if LastChance(GetGovActionBasicActionChance(govID, selfID, 3, 0.3, 3)) then
		local csValidTab = {};
		local gCity = Map.GetPlotByIndex(gT.Globals.Governors[govID].City):GetPlotCity();
		local cID = gCity:Plot():GetPlotIndex() .. "," .. gCity:GetGameTurnFounded();
		for h, sIndex in pairs(GetNearCities(cID, GetGovernorRange(iPlayer, govID))) do
			local iOwner = Map.GetPlotByIndex(sIndex):GetOwner();
			if Players[iOwner]:IsMinorCiv() then
				if Teams[Players[iPlayer]:GetTeam()]:IsHasMet(Players[iOwner]:GetTeam()) then
					if not Teams[Players[iPlayer]:GetTeam()]:IsAtWar(Players[iOwner]:GetTeam()) then
						table.insert(csValidTab, iOwner);
					end
				end
			end
		end
		if #csValidTab > 0 then
			GenerateDiploNote(iPlayer, govID, selfID, csValidTab[LastRandom(1,#csValidTab)])
			return true;
		end
	end
	return false;
end

function GovConsiderAction5(govID, selfID)
	local iPlayer = gT.Globals.Governors[govID].Player;
	local iValid = 0;
	for a, h in pairs(gT.Players[iPlayer].Agents) do
		if (not h.IgnoreItForever) then
			if h.Rank < 3 then
				iValid = iValid + 1;
			end
		end
	end
	if iValid < 3 then
		return false;
	end
	if gT.Globals.Governors[govID].IntelInsight then
		return false;
	end
	if LastChance(GetGovActionBasicActionChance(govID, selfID, 1, 0.25, 20)) then
		GenerateDiploNote(iPlayer, govID, selfID)
		return true;
	end
	return false;
end

function GovConsiderAction6(govID, selfID)
	local iPlayer = gT.Globals.Governors[govID].Player;
	if Players[iPlayer]:GetReligionCreatedByPlayer() < 1 then
		return false;
	end
	local iBaseChance = math.max(1, math.min(5, GetNumSpecialControlPoint(iPlayer, "HolySites", true)))
	if LastChance(GetGovActionBasicActionChance(govID, selfID, iBaseChance, 0.3, 15)) then
		GenerateDiploNote(iPlayer, govID, selfID)
		return true;
	end
	return false;
end

function GovConsiderAction7(govID, selfID)
	local iPlayer = gT.Globals.Governors[govID].Player;
	if gT.Globals.Governors[govID].ExtraRange then
		return false;
	end
	if LastChance(GetGovActionBasicActionChance(govID, selfID, Players[iPlayer]:GetNumCities(), 0.24, 15)) then
		GenerateDiploNote(iPlayer, govID, selfID)
		return true;
	end
	return false;
end
function GovConsiderAction43(govID, selfID)
	local iPlayer = gT.Globals.Governors[govID].Player;
	if gT.Globals.Governors[govID].Art > 0 then
		if gT.Globals.ScenarioType == 3 then
			return false;
		end
	end
	if LastChance(GetGovActionBasicActionChance(govID, selfID, 3, 0.1, 1)) then
		GenerateDiploNote(iPlayer, govID, selfID)
		return true;
	end
	return false;
end
function GovConsiderAction49(govID, selfID)
	local iPlayer = gT.Globals.Governors[govID].Player;
	if gT.Globals.Governors[govID].CodexInfluence then
		return false;
	end
	if not gT.Players[iPlayer].HasCodex then
		return false;
	end
	if LastChance(GetGovActionBasicActionChance(govID, selfID, 3, 0.1, 1)) then
		GenerateDiploNote(iPlayer, govID, selfID)
		return true;
	end
	return false;
end
function GovConsiderAction51(govID, selfID)
	if not DBScenario.NoMercenaries then
		local iPlayer = gT.Globals.Governors[govID].Player;
		if LastChance(GetGovActionBasicActionChance(govID, selfID, 4, 0.1, 1)) then
			if gT.Players[iPlayer].LastTurnCityLost + 8 > GetITGGameTurn() then
				if Teams[Players[iPlayer]:GetTeam()]:GetAtWarCount(true, true) > 0 then
					if CanHaveMercenaryFromGoodyHut(iPlayer) then
						if Players[iPlayer]:GetNumUnitsSupplied() >= 2 + Players[iPlayer]:GetNumUnitsToSupply() then
							GenerateDiploNote(iPlayer, govID, selfID)
							return true;
						end
					end
				end
			end
		end
	end
	return false;
end
function GovConsiderAction30(govID, selfID)
	local iPlayer = gT.Globals.Governors[govID].Player;
	if not gT.Globals.Governors[govID].GPHonour then
		return false;
	end
	if not CanPlayerDoNationalDay(iPlayer) then
		return false;
	end
	if gT.Players[iPlayer].LegalPower >= 5 then
		return false;
	end
	if gT.Globals.Governors[govID].ProposalsMade[selfID] then
		return false;
	end
	if LastChance(GetGovActionBasicActionChance(govID, selfID, 8, 0.35, 10)) then
		GenerateDiploNote(iPlayer, govID, selfID, {gT.Globals.Governors[govID].GPHonour})
		return true;
	end
	return false;
end
function GovConsiderAction31(govID, selfID)
	local iPlayer = gT.Globals.Governors[govID].Player;
	if gT.Players[iPlayer].SettlerPoints > 0 then
		return;
	end
	if LastChance(GetGovActionBasicActionChance(govID, selfID, 10, 1, 2)) then
		local lIndex;
		for index, sth in pairs(gT.Settlements) do
			if sth.Player == iPlayer then
				if lIndex then
					return false;
				end
				lIndex = index;
			end
		end
		if lIndex then
			if CanSettlementBeUpdatedNow(lIndex, iPlayer) then
				if gT.Settlements[lIndex].Level == 2 then
					if gT.Settlements[lIndex].LastUpdate + 8 < GetITGGameTurn() then
						local iPlot = Map.GetPlotByIndex(gT.Globals.Governors[govID].City);
						local sPlot = Map.GetPlotByIndex(lIndex);
						if Map.PlotDistance(iPlot:GetX(), iPlot:GetY(), sPlot:GetX(), sPlot:GetY()) <= 10 then
							GenerateDiploNote(iPlayer, govID, selfID, {lIndex})
							return true;
						end
					end
				end
			end
		end
	end
	return false;
end
function GovConsiderAction35(govID, selfID)
	local iPlayer = gT.Globals.Governors[govID].Player;
	if gT.Globals.Governors[govID].TradeEmbargo then
		return false;
	end
	if LastChance(GetGovActionBasicActionChance(govID, selfID, 5, 0.5, 10)) then
		local iPlot = Map.GetPlotByIndex(gT.Globals.Governors[govID].City);
		local tOptions = {};
		for g, h in pairs(gT.Players) do
			if h.Embargos[iPlayer] and (not gT.Players[iPlayer].Embargos[g]) and (not Players[g]:IsMinorCiv()) and Players[g]:IsAlive() then
				if CanBeTargetOfEmbargo(iPlayer, g) then
					if GetNearestCityOfPlayerToPlot(iPlot:GetX(), iPlot:GetY(), g, 10) then
						table.insert(tOptions, g)	
					end
				end
			end
		end
		if #tOptions > 0 then
			GenerateDiploNote(iPlayer, govID, selfID, {RandomFromTab(tOptions)})
			return true;
		end
	end
	return true;
end
function GovConsiderAction37(govID, selfID)
	local iPlayer = gT.Globals.Governors[govID].Player;
	if gT.Globals.Governors[govID].ProposalsMade[selfID] then
		return false;
	end
	if LastRandom(4,6) <= gT.Globals.Governors[govID].Character.Conflict then
		return false;
	end
	if LastChance(GetGovActionBasicActionChance(govID, selfID, 4, 0.2, 10)) then
		if CanAppointGovernor(iPlayer) then
			GenerateDiploNote(iPlayer, govID, selfID)
			return true;
		end
	end
	return false;
end
function GovConsiderAction15(govID, selfID)
	local iPlayer = gT.Globals.Governors[govID].Player;
	if #GetTabOfCitiesNotOwnedCulturally(iPlayer) < 3 then
		return;
	end
	if NAT_UNITY_PENALTY_FREE <= gT.Players[iPlayer].NatUnity then
		return;
	end
	if LastChance(GetGovActionBasicActionChance(govID, selfID, 8, 0.8, 10, {[2] = 5})) then
		GenerateDiploNote(iPlayer, govID, selfID)
		return true;
	end
	return false;
end
function GovConsiderAction16(govID, selfID)
	local iPlayer = gT.Globals.Governors[govID].Player;
	if gT.Globals.ScenarioType == 5 then
		if LastChance(70) then
			return false;
		end
	end
	if LastChance(GetGovActionBasicActionChance(govID, selfID, 5, 0.5, 4, {[3] = 5})) then
		GenerateDiploNote(iPlayer, govID, selfID, acadData)
		return true;
	end
	return false;
end
function GovConsiderAction18(govID, selfID)
	local iPlayer = gT.Globals.Governors[govID].Player;
	if LastChance(GetGovActionBasicActionChance(govID, selfID, 6, 0.5, 3, {[3] = 5})) then
		local iCity = Map.GetPlotByIndex(gT.Globals.Governors[govID].City):GetPlotCity();
		if iCity:GetDamage() == 0 then
			local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
			for ha, index in pairs(gT.Cities[cID].Academies) do
				if gT.Academies[index].Active and IsAcademyActiveRightNow(index) then
					if gT.Academies[index].SupportCD < GetITGGameTurn() then
						local tab = {}
						for string, sth in pairs(gT.Academies[index].Bonuses) do
							table.insert(tab, string)
						end
						if #tab > 0 then
							GenerateDiploNote(iPlayer, govID, selfID, {index, tab[LastRandom(1,#tab)], gT.Globals.Governors[govID].City})
							return true;
						end
					end
				end
			end
		end
	end
	return false;
end
function GovConsiderAction22(govID, selfID)
	if gT.Globals.Governors[govID].LegalCity then
		return false;
	end
	local iPlayer = gT.Globals.Governors[govID].Player;
	if LastChance(GetGovActionBasicActionChance(govID, selfID, 5, 0.5, 10, {[7] = 5})) then
		for iCity in Players[iPlayer]:Cities() do
			if CanCityBeLegalizedNow(iPlayer, iCity) then
				local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
				if gT.Cities[cID].Governor == govID then
					GenerateDiploNote(iPlayer, govID, selfID, {iCity:Plot():GetPlotIndex()})
					return true;
				end
			end
		end
	end
	return false;
end
function GovConsiderAction44(govID, selfID)
	local iPlayer = gT.Globals.Governors[govID].Player;
	local bCanUse = false;
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_ANCIENT_EMPIRE_18, "123345f") then
		bCanUse = true;
	end
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_ASIA_8, "ogkoewfe") then
		bCanUse = true;
	end
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_ASIA_5, "okfokefe") then
		bCanUse = true;
	end
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_MODERN_25, "geger") then
		if gT.Players[iPlayer].AuthorityRank == 1 then
			bCanUse = true;
		end
	end
	if not bCanUse then
		return false;
	end
	if LastChance(GetGovActionBasicActionChance(govID, selfID, 10, 0.25, 3)) then
		local slots = GetAvailableGovSlotsToFill(iPlayer);
		if #slots > 0 then
			GenerateDiploNote(iPlayer, govID, selfID, {RandomFromTab(slots)})
			return true;
		end
	end
	return false;
end
function GovConsiderAction23(govID, selfID)
	local iPlayer = gT.Globals.Governors[govID].Player;
	if gT.Globals.Governors[govID].Supply then
		return false;
	end
	if (not gT.Players[iPlayer].GovCauses[11]) then
		return false;
	end
	if LastChance(GetGovActionBasicActionChance(govID, selfID, 8, 0.5, 5)) then
		GenerateDiploNote(iPlayer, govID, selfID)
		return true;
	end
	return false;
end
function GovConsiderAction24(govID, selfID)
	local iPlayer = gT.Globals.Governors[govID].Player;
	if LastChance(GetGovActionBasicActionChance(govID, selfID, 4, 0.6, 20)) then
		local iClass = GetBestClassForSpecializationBonus(iPlayer);
		if iClass and (GetPlayerTotalProgressTowardsSpecialUU(iPlayer, iClass) + 115 < GetPlayerTotalTresholdForSpecialUU(iPlayer, iClass)) then
			if Players[iPlayer]:GetUnitClassCountPlusMaking(iClass) > 0 then
				GenerateDiploNote(iPlayer, govID, selfID, iClass)
				return true;
			end
		end
	end
	return false;
end
function GovConsiderAction48(govID, selfID)
	local iPlayer = gT.Globals.Governors[govID].Player;
	if gT.Globals.ScenarioType ~= ITG_ScenariosTypes["SCENARIO_TRIAL"] then
		if gT.Globals.ScenarioType ~= ITG_ScenariosTypes["SCENARIO_AGE_OF_TITANS"] then
			return false;
		end
	end
	local baseChance = 5;
	if gT.Globals.Governors[govID].CityTrait == 12 then
		baseChance = 10;
	end
	if LastChance(GetGovActionBasicActionChance(govID, selfID, baseChance, 0.8, 10)) then
		if GetValidCityStateGovAction48(iPlayer) then
			GenerateDiploNote(iPlayer, govID, selfID);
			return true;
		end
	end
	return false;
end
function GovConsiderAction25(govID, selfID)
	local iPlayer = gT.Globals.Governors[govID].Player;
	if LastChance(GetGovActionBasicActionChance(govID, selfID, 5, 0.5, 2)) then
		local iBuilding = GetValidGovernorBuilding(govID, Map.GetPlotByIndex(gT.Globals.Governors[govID].City):GetPlotCity());
		if iBuilding then
			GenerateDiploNote(iPlayer, govID, selfID, {iBuilding, gT.Globals.Governors[govID].City})
			return true;
		end
	end
	return false;
end
function GovConsiderAction26(govID, selfID)
	local iPlayer = gT.Globals.Governors[govID].Player;
	local govRel = gT.Globals.Governors[govID].CityReligion;
	if gT.Globals.Governors[govID].ProposalsMade[selfID] then
		return false; -- we failed or we were bamboozled later?
	end
	if not govRel then
		return false;
	end
	if Players[iPlayer]:GetNumCities() < 5 then
		return false;
	end
	local cByPlayer = Players[iPlayer]:GetReligionCreatedByPlayer();
	if (cByPlayer > 0) and (cByPlayer ~= govRel) then
		return false;
	end
	local baseChance = 5;
	if gT.Players[iPlayer].OfficialReligion then
		if gT.Players[iPlayer].OfficialReligion == govRel then
			return false;
		end
	end
	if LastChance(GetGovActionBasicActionChance(govID, selfID, baseChance + GetChanceFromForeignSupport(govID, selfID, 20), 1, 0, {[10] = 5, [5] = 5, [2] = 5, [8] = 3})) then
		if not PrepareGovForeignSupport(iPlayer, govID, 26) then
			GenerateDiploNote(iPlayer, govID, selfID, {})
		end
		return true;
	end
	return false;
end
function GovConsiderAction38(govID, selfID, bForce)
	local iPlayer = gT.Globals.Governors[govID].Player;
	if GovHasSignificantPosition(govID) then
		return false;
	end
	local pos = GetBestPositionToAspireTo(govID, iPlayer);
	if not pos then
		return false;
	end
	if bForce or LastChance(GetGovActionBasicActionChance(govID, selfID, 15, 2, 0)) then
		GenerateDiploNote(iPlayer, govID, selfID, {pos})
		return true;
	end
	return false;
end
function GovConsiderAction40(govID, selfID, bForce)
	local iPlayer = gT.Globals.Governors[govID].Player;
	if gT.Players[iPlayer].Goverment == 1 then
		return false;
	end
	if gT.Globals.Governors[govID].LoyaltyType == 2 then
		return false;
	end
	if gT.Globals.Governors[govID].Goverment and (gT.Globals.Governors[govID].Goverment ~= gT.Players[iPlayer].Goverment) then
		local pos = GetBestPositionToAspireTo(govID, iPlayer);
		if not pos then
			return false;
		end
		if not IsTheStrongestGovernor(govID, iPlayer) then
			return false;
		end
		if bForce or LastChance(GetGovActionBasicActionChance(govID, selfID, 3 + GetChanceFromForeignSupport(govID, selfID, 15), 2, 0)) then
			if IsThereEnoughCausesForRevolution(iPlayer, 2) then
				if not PrepareGovForeignSupport(iPlayer, govID, 40) then
					GenerateDiploNote(iPlayer, govID, selfID, {gT.Globals.Governors[govID].Goverment, pos})
				end
				return true;
			end			
		end
	end
	return false;
end
function GovConsiderAction39(govID, selfID)
	local iPlayer = gT.Globals.Governors[govID].Player;
	if not gT.Globals.Governors[govID].City then
		return false;
	end
	if LastRandom(3,10) > gT.Globals.Governors[govID].Character.Conflict then
		return false;
	end
	if LastChance(GetGovActionBasicActionChance(govID, selfID, 5, 0.25, 0)) then
		local option = {}
		local cPlot = Map.GetPlotByIndex(gT.Globals.Governors[govID].City);
		for iCity in Players[iPlayer]:Cities() do
			local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
			local sGov = gT.Cities[cID].Governor;
			if sGov and (sGov ~= -1) and (sGov ~= govID) then
				if Map.PlotDistance(iCity:GetX(), iCity:GetY(), cPlot:GetX(), cPlot:GetY()) <= 10 then
					if ShouldStartConflictWithThirdGovernor(govID, sGov) then
						table.insert(option, sGov);
					end
				end
			end
		end
		if #option > 0 then
			local lGov = RandomFromTab(option);
			GenerateDiploNote(iPlayer, govID, selfID, {lGov, gT.Globals.Governors[lGov].Power})
			return true;
		end
	end
	return false;
end
function GovConsiderAction27(govID, selfID)
	local iPlayer = gT.Globals.Governors[govID].Player;
	local loyaltyType = gT.Globals.Governors[govID].Character.LoyaltyType;
	if (loyaltyType == 1) or (loyaltyType == 2) then
		return false;
	end
	if Players[iPlayer]:GetNumCities() < 5 then
		return false;
	end
	if LastChance(GetGovActionBasicActionChance(govID, selfID, 5 + GetChanceFromForeignSupport(govID, selfID, 4), 1, 10, {[13] = 5})) then
		local iCity = Map.GetPlotByIndex(gT.Globals.Governors[govID].City):GetPlotCity();
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		local valTab = {}
		local optionGifts = {};
		if not iCity:IsOriginalMajorCapital() then
			table.insert(optionGifts, iCity)
		end
		for h, sIndex in pairs(GetNearCities(cID, GetGovernorRange(iPlayer, govID))) do
			local sCity = Map.GetPlotByIndex(sIndex):GetPlotCity();
			local sPlayer = sCity:GetOwner();
			if Players[sPlayer]:IsMinorCiv() then
				if Teams[Players[sPlayer]:GetTeam()]:IsHasMet(Players[iPlayer]:GetTeam()) then
					if not Teams[Players[sPlayer]:GetTeam()]:IsAtWar(Players[iPlayer]:GetTeam()) then
						if not gT.Players[sPlayer].GovAsLeader then
							local influence = Players[sPlayer]:GetMinorCivFriendshipWithMajor(iPlayer)
							if influence > 0 then
								local eval = 50 * Players[sPlayer]:GetNumCities() + sCity:GetPopulation();
								eval = eval - 20 * GetPlayersCulturalDifference(iPlayer, sPlayer);
								if Players[sPlayer]:GetAlly() == iPlayer then
									eval = eval + (GetITGGameTurn() - (gT.Players[sPlayer].LastAllyChange or 0)) * 4;
								end
								table.insert(valTab, {sCity:Plot():GetPlotIndex(), eval})
							end
						end
					end
				end
			elseif sPlayer == iPlayer then
				if not sCity:IsOriginalMajorCapital() then
					local sID = sCity:Plot():GetPlotIndex() .. "," .. sCity:GetGameTurnFounded();
					if gT.Cities[sID].Governor == govID then
						table.insert(optionGifts, sCity)
					end
				end
			end
		end
		if (#valTab > 0) and (#optionGifts > 0) then
			table.sort(valTab, SortFunctionForGreaterInteger2)
			local tPlot = Map.GetPlotByIndex(valTab[1][1])
			local hDist, gCity = 999, nil;
			for i, hCity in pairs(optionGifts) do
				local mDis = Map.PlotDistance(tPlot:GetX(), tPlot:GetY(), hCity:GetX(), hCity:GetY())
				if mDis < hDist then
					gCity = hCity;
					hDist = mDis;
				end
			end
			if not PrepareGovForeignSupport(iPlayer, govID, 27, tPlot:GetOwner()) then
				GenerateDiploNote(iPlayer, govID, selfID, {tPlot:GetOwner(), gCity:Plot():GetPlotIndex(), tPlot:GetPlotIndex()})
			end
			return true;
		end
	end
	return false;
end
function GovConsiderAction28(govID, selfID, bForce)
	local iPlayer = gT.Globals.Governors[govID].Player;
	if GetITGGameTurn() < 15 + gT.Players[iPlayer].LastTurnCityCaptured then
		return false;
	end
	if bForce or (not LastChance(GetMilitarySharesGovernors(iPlayer, govID))) then
		return false;
	end
	if bForce or LastChance(GetGovActionBasicActionChance(govID, selfID, 5, 0.5, 5, {[1] = 5})) then
	--let's find target
		local iCity = Map.GetPlotByIndex(gT.Globals.Governors[govID].City):GetPlotCity();
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		local valTab = {}
		local iTeam = Players[iPlayer]:GetTeam();
		for h, sIndex in pairs(GetNearCities(cID, GetGovernorRange(iPlayer, govID))) do
			local sCity = Map.GetPlotByIndex(sIndex):GetPlotCity();
			local sPlayer = sCity:GetOwner();
			if sPlayer ~= iPlayer then
				local sTeam = Players[sPlayer]:GetTeam();
				if Teams[sTeam]:IsHasMet(iTeam) then
					if Teams[iTeam]:CanDeclareWar(sTeam) then
						if Players[sPlayer]:IsMinorCiv() then
							if Players[sPlayer]:GetAlly() ~= iPlayer then
								if not Players[sPlayer]:IsProtectedByMajor(iPlayer) then
									table.insert(valTab, {sPlayer, LastRandom(15,30)})
								end
							end
						elseif GetMilitaryMightDemographics(iPlayer, iPlayer) > GetMilitaryMightDemographics(iPlayer, sPlayer) then
							if not Players[iPlayer]:IsDoF(sPlayer) then
								if not Teams[iTeam]:IsDefensivePact(sTeam) then
									table.insert(valTab, {sPlayer, LastRandom(18,22)})
								end
							end
						end
					end
				end
			end
		end
		if #valTab > 0 then
			table.sort(valTab, SortFunctionForGreaterInteger2)
			GenerateDiploNote(iPlayer, govID, selfID, {valTab[1][1]})
			return true;
		end
	end
	return false;
end
function GovConsiderAction19(govID, selfID)
	local iPlayer = gT.Globals.Governors[govID].Player;
	if (not gT.Players[iPlayer].GovCauses[10]) then
		return false;
	end
	if LastChance(GetGovActionBasicActionChance(govID, selfID, 5, 0.5, 2)) then
		local iTurn = GetITGGameTurn() - 10;
		for a, b in pairs(gT.Heresies) do
			if (b.Active) and (b.Start <= iTurn) then
				if Map.GetPlotByIndex(b.City):GetOwner() == iPlayer then
					GenerateDiploNote(iPlayer, govID, selfID, {a})
					return true;
				end
			end
		end
	end
	return false;
end

function GovConsiderAction8(govID, selfID)
	local iPlayer = gT.Globals.Governors[govID].Player;
	if LastChance(GetGovActionBasicActionChance(govID, selfID, 15, 1, 10, {[2] = 5, [3] = 5, [7] = 5})) then
		local avTargets = {}
		local iTeam = Players[iPlayer]:GetTeam();
		for fPlayer, data in pairs(gT.Globals.Governors[govID].ForeignContacts) do
			if not data.Failed then
				if CanEstablishEmbassyWithPlayer(iPlayer, iTeam, fPlayer) then
					table.insert(avTargets, fPlayer);
				end
			end
		end
		if #avTargets > 0 then
			GenerateDiploNote(iPlayer, govID, selfID, avTargets[LastRandom(1,#avTargets)])
			return true;
		end
	end
	return false;
end

function GetBendTheKneeSituationChances(govID, iPlayer, govPower, intrigueV, extraGood, extraBad)
	local playerPower = GetPlayerGovernorPower(iPlayer);
	local option1, option2 = math.min(playerPower, govPower), math.max(0, govPower - playerPower) + gT.Globals.Governors[govID].Character.Pettiness * 10;
	option1 = option1 + (extraGood or 0)
	option2 = option2 + (extraBad or 0)
	local gLoyalty = gT.Globals.Governors[govID].Character.LoyaltyType;
	local percentHap = GovEvalOfSituationInState(govID)
	local percentSecurePos = GovEvalOfHisPositionInState(govID, iPlayer)
	if IsGovDuringDreamRelatedSituation(govID, iPlayer) then
		option2 = option2 + 200;
	end
	option1 = option1 + percentHap + percentSecurePos;
	option2 = option2 + 100 - percentHap;
	if gLoyalty == 1 then
		option2 = 1;
	elseif gLoyalty == 2 then
		option2 = 1;
	elseif gLoyalty == 3 then
		option2 = option2 + 50;
	elseif gLoyalty == 6 then
		option2 = option2 + 50;
	elseif gLoyalty == 7 then
		option1 = option1 + govPower - 50;
	elseif gLoyalty == 8 then
		option1 = 100;
		option2 = 100;
	elseif gLoyalty == 9 then
		if option1 > option2 then
			option1 = option1 * 2;
		elseif option2 > option1 then
			option2 = option2 * 2;
		end
	elseif gLoyalty == 10 then
		for a, d in pairs(gT.Players[iPlayer].GovDiploLog) do
			if (d.ID == 13) and (d.Action == 2) then
				if d.Outcome == 1 then
					option1 = option1 + 100;
				else
					option2 = option2 + 100;
				end
			end
		end
	end
	option1 = AffectGovOutcomeWithVisibility(option1, intrigueV, true, govID)
	print("Bend the knee: cYes cNot govID loyal power intrigue exGood exBad", math.max(option1, 1), math.max(1,option2), govID, gLoyalty, govPower, intrigueV, extraGood, extraBad)
	return math.max(option1, 1), math.max(1,option2);
end

function GovConsiderAction13(govID, selfID)
	if gT.Globals.Governors[govID].ProposalsMade[selfID] then
		return false; -- we asked once for assigment; leader should remember us, right :<?
	end
	local iPlayer = gT.Globals.Governors[govID].Player;
	if not HasFreeLocationForGovernor(iPlayer) then
		return false; -- has no place for us; understandable -> plot to overthrow other governor or leader
	end
	local waitTurns = GetITGGameTurn() - (gT.Globals.Governors[govID].LastRemovedT or 0);
	if waitTurns < 5 then
		return false;
	end
	local extraChance = 0;
	if gT.Players[iPlayer].GovCauses[2] then
		extraChance = extraChance + 5;
	end
	if gT.Players[iPlayer].GovCauses[5] then
		extraChance = extraChance + 5;
	end
	if LastChance(waitTurns * 10 + extraChance) then
		GenerateDiploNote(iPlayer, govID, selfID)
		return true;
	end
	return false;
end

function GovConsiderAction14(govID, selfID)
	if gT.Globals.Governors[govID].CityReligion then
		return;
	end
	local iCity = Map.GetPlotByIndex(gT.Globals.Governors[govID].City):GetPlotCity();
	local options = {};
	local div = GameDefines["RELIGION_MISSIONARY_PRESSURE_MULTIPLIER"];
	for g, h in pairs(gT.Players) do
		local cRel = Players[g]:GetReligionCreatedByPlayer();
		if cRel > 0 then
			local iPressure, iNumTR = iCity:GetPressurePerTurn(cRel);
			local eval = math.ceil(iPressure / div) + 10 * iCity:GetNumFollowers(cRel);
			if eval > 0 then
				table.insert(options, {cRel, eval})
			end
		end
	end
	if #options > 0 then
		gT.Globals.Governors[govID].CityReligion = GetBasicGovernorOptionFromEvalTab(options, gT.Globals.Governors[govID].Character.LoyaltyType);
		table.insert(gT.Players[gT.Globals.Governors[govID].Player].GovDiploLog, 1, {ID = 1005, GovID = govID, Turn = GetITGGameTurn(), Data = {gT.Globals.Governors[govID].CityReligion}})
	end
end

function GovConsiderAction17(govID, selfID)
	if gT.Globals.Governors[govID].Goverment then
		return;
	end
	gT.Globals.Governors[govID].Goverment = LastRandom(2,7);
end

function GovActionResolve1(iPlayer, actionID, fIndex, selfID)
	local pIndex = fIndex or 1;
	local govID = gT.Players[iPlayer].DiploNotes[pIndex].Governor;
	local blog1, blog2;
	local uiTab = {GovID = govID, Headline = Locale.Lookup(dgActions[selfID].Name)}
	uiTab.Actions = {
		{ID = 1, Text = "ACCEPT", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{Locale.Lookup("TXT_KEY_GOV_ACTION_1_RESULT_1_MAIN"),Locale.Lookup("TXT_KEY_GOV_ACTION_1_RESULT_1_MAIN_TT")},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_CAUSE", GeneratePuppetRulerStackChance(iPlayer), Locale.Lookup(GetGovCauseData(8, "Name"))),GenerateNiceCauseTooltip(8)},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_PLAYER_POWER_REDUCTION",1),""},
				}}}}, 
	{ID = 2, Text = "DENY", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{Locale.Lookup("TXT_KEY_GOV_ACTION_1_RESULT_2_MAIN"),Locale.Lookup("TXT_KEY_GOV_ACTION_1_RESULT_2_MAIN_TT")},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_MORALE_CHANCE","[COLOR_POSITIVE_TEXT]30","+1"),""},
				}}}}
	}
	if actionID == -1 then
		uiTab.Active = true;
		uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_1")
	else
		for a, b in pairs(uiTab.Actions) do
			if b.ID ~= actionID then
				uiTab.Actions[a].Disabled = true;
			end
		end
		if actionID == 1 then
			local outcomeID = 1;
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_1_ACTION_1")
			if LastChance(GeneratePuppetRulerStackChance(iPlayer)) then
				NoteGovCausesBasicStack(iPlayer, 8)
				blog1 = true;
			else
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[2].Disabled = true;
			end
			EstablishRelationsWithForeignGovernor(iPlayer, govID)
			BoostPlayerPower(iPlayer, "Foreign Relations", -1)
		elseif actionID == 2 then
			local outcomeID = 1;
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_1_ACTION_2")
			gT.Globals.Governors[govID].ForeignContacts[iPlayer] = {Failed = true}
			if LastChance(30) then
				TakeCareOfEventMorale(iPlayer, 25, {1, "Diplo Action"})
				blog2 = true;
			else
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[2].Disabled = true;
			end
		end
		table.insert(gT.Players[iPlayer].GovDiploLog, 1, {ID = selfID, Turn = GetITGGameTurn(), GovID = govID, Action = actionID, Data = {blog1, blog2}})
	end
	return uiTab;
end

function GovActionResolve2(iPlayer, actionID, fIndex, selfID)
	local pIndex = fIndex or 1;
	local govID = gT.Players[iPlayer].DiploNotes[pIndex].Governor;
	local extraData = gT.Players[iPlayer].DiploNotes[pIndex].ExtraData;
	local blog1, blog2;
	local uiTab = {GovID = govID, Headline = Locale.Lookup(dgActions[selfID].Name)}
	uiTab.Actions = {
		{ID = 1, Text = "ACCEPT", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{"+" .. extraData[3] .. " [ICON_GOLD] Gold per City.",""},
				{"+" .. extraData[2] .. " [ICON_HAPPINESS_4] Unhappiness in all Cities.",""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_CAUSE", extraData[4], Locale.Lookup(GetGovCauseData(9, "Name"))),GenerateNiceCauseTooltip(9)},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_GOVERNOR_POWER_GAIN", extraData[1]),""},
				}}}}, 
	{ID = 2, Text = "REFUSE", Help = "", ToolTip = "", 
		Outcomes = {
			{Text = "VoidResultAlways", Results = {
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_GRUDGE",5,Locale.Lookup(GetGrudgeData(4, "Name"))),GenerateNiceGrudgeTooltip(4, true)},
				}}}}
	}
	if actionID == -1 then
		uiTab.Active = true;
		uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_2")
	else
		for a, b in pairs(uiTab.Actions) do
			if b.ID ~= actionID then
				uiTab.Actions[a].Disabled = true;
			end
		end
		if actionID == 1 then
			local outcomeID = 1;
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_2_ACTION_1")
			ChangeITGGold(iPlayer, Players[iPlayer]:GetNumCities() * extraData[3])
			BoostHappinessInAllCities(iPlayer, -extraData[2])
			if LastChance(extraData[4]) then
				NoteGovCausesBasicStack(iPlayer, 9)
				blog1 = true;
			else
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[3].Disabled = true;
			end
			BoostGovernorPower(govID, "Actions", extraData[1], false)
		elseif actionID == 2 then
			local outcomeID = 1;
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_2_ACTION_2")
			if GenerateChancedGrudge(govID, 4, 5) then
				blog2 = true;
			else
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[1].Disabled = true;
			end
		end
		table.insert(gT.Players[iPlayer].GovDiploLog, 1, {ID = selfID, Turn = GetITGGameTurn(), GovID = govID, Action = actionID, Data = {blog1, blog2, Players[iPlayer]:GetNumCities() * extraData[3], extraData[1]}})
	end
	return uiTab;
end

function GovActionResolve3(iPlayer, actionID, fIndex, selfID)
	local pIndex = fIndex or 1;
	local govID = gT.Players[iPlayer].DiploNotes[pIndex].Governor;
	local extraData = gT.Players[iPlayer].DiploNotes[pIndex].ExtraData;
	local blog1, blog2;
	local uiTab = {GovID = govID, Headline = Locale.Lookup(dgActions[selfID].Name)}
	uiTab.Actions = {
		{ID = 1, Text = "ACCEPT", Help = "", ToolTip = "", 
		Outcomes = {{
				Text = "VoidResultAlways", Results = {
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_MERITOCRACY_GAIN", extraData[3]), ""},
				{"+" .. extraData[2] .. " [ICON_HAPPINESS_4] Unhappiness in all Cities.",""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_GOVERNOR_POWER_GAIN", extraData[1]),""},
				{"[ICON_ITG_GOVERNOR] Governor will provide +1 [ICON_ITG_MERITOCRACY] Meritocracy and earn +1 extra [ICON_ITG_POWER] Power each turn.",""},
				}}}}, 
	{ID = 2, Text = "REFUSE", Help = "", ToolTip = "", 
		Outcomes = {
			{Text = "VoidResultAlways", Results = {
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_GRUDGE",5,Locale.Lookup(GetGrudgeData(4, "Name"))),GenerateNiceGrudgeTooltip(4, true)},
				}}}}
	}
	if actionID == -1 then
		uiTab.Active = true;
		uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_3")
	else
		for a, b in pairs(uiTab.Actions) do
			if b.ID ~= actionID then
				uiTab.Actions[a].Disabled = true;
			end
		end
		if actionID == 1 then
			local outcomeID = 1;
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_3_ACTION_1")
			ChangeMeritocracy(iPlayer, extraData[3])
			BoostHappinessInAllCities(iPlayer, -extraData[2])
			BoostGovernorPower(govID, "Actions", extraData[1], false)
			gT.Globals.Governors[govID].MeritPT = (gT.Globals.Governors[govID].MeritPT or 0) + 1;
		elseif actionID == 2 then
			local outcomeID = 1;
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_3_ACTION_2")
			if GenerateChancedGrudge(govID, 4, 5) then
				blog2 = true;
			else
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[1].Disabled = true;
			end
		end
		table.insert(gT.Players[iPlayer].GovDiploLog, 1, {ID = selfID, Turn = GetITGGameTurn(), GovID = govID, Action = actionID, Data = {blog1, blog2, extraData[3], extraData[1]}})
	end
	return uiTab;
end

function GovActionResolve4(iPlayer, actionID, fIndex, selfID)
	local pIndex = fIndex or 1;
	local govID = gT.Players[iPlayer].DiploNotes[pIndex].Governor;
	local intrigueV = gT.Players[iPlayer].DiploNotes[pIndex].Intrigue;
	local extraData = gT.Players[iPlayer].DiploNotes[pIndex].ExtraData;
	local csPlayer = extraData[2];
	if Teams[Players[iPlayer]:GetTeam()]:IsAtWar(Players[csPlayer]:GetTeam()) then
		return nil;
	end
	if not Players[csPlayer]:IsAlive() then
		return;
	end
	local blog1, blog2;
	local a1o1c = 950;
	local a1o2c = AffectGovOutcomeWithVisibility(50, intrigueV, false)
	local uiTab = {GovID = govID, Headline = Locale.Lookup(dgActions[selfID].Name)}
	uiTab.Actions = {
		{ID = 1, Text = "ACCEPT", Help = "", ToolTip = "", Outcomes = {
				{ID = 1, Text = "SUCCESS", Help = "[COLOR_POSITIVE_TEXT]" .. math.floor(a1o1c / (a1o2c + a1o1c) * 1000) / 10 .. "%", ToolTip = "", Results = {
				{"+" .. extraData[3] .. " [ICON_INFLUENCE] Influence with " .. Players[csPlayer]:GetName () .. ".",""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_GOVERNOR_POWER_GAIN", extraData[1]),""},
				}},
				{ID = 2, Text = "DIPLOMATIC INCIDENT", Help = "[COLOR_NEGATIVE_TEXT]" .. math.floor(a1o2c / (a1o2c + a1o1c) * 1000) / 10 .. "%", ToolTip = Locale.Lookup("TXT_KEY_GOV_OUTCOME_CHANCE_REDUCE_BY_VISIBILITY"), Results = {
					{"-50 [ICON_INFLUENCE] Influence with " .. Players[csPlayer]:GetName () .. ".",""},
					{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_GOVERNOR_POWER_LOSS", 10),""},
				},
				}}}, 
	{ID = 2, Text = "REFUSE", Help = "", ToolTip = "", Outcomes = {
			{Text = "VoidResultAlways", Results = {
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_GRUDGE",5,Locale.Lookup(GetGrudgeData(4, "Name"))),GenerateNiceGrudgeTooltip(4, true)},
				}}}}
	}
	if actionID == -1 then
		uiTab.Active = true;
		uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_4", Players[csPlayer]:GetName ())
	else
		local outcomeID = 1;
		if actionID == 1 then
			outcomeID = GetRandomFromBiasedChanceTable({{1,a1o1c}, {2, a1o2c}})
			if outcomeID == 1 then
				uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_4_ACTION_1_OUTCOME_1")
				Players[csPlayer]:ChangeMinorCivFriendshipWithMajor(iPlayer, extraData[3])
				BoostGovernorPower(govID, "Actions", extraData[1], false)
			else
				uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_4_ACTION_1_OUTCOME_2")
				Players[csPlayer]:ChangeMinorCivFriendshipWithMajor(iPlayer, -50)
				BoostGovernorPower(govID, "Incompetence", -10, false)
			end
		elseif actionID == 2 then
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_4_ACTION_2")
			if GenerateChancedGrudge(govID, 4, 5) then
				blog2 = true;
			else
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[1].Disabled = true;
			end
		end
		uiTab = PrepareResolveTabForUI(uiTab, actionID, outcomeID);
		table.insert(gT.Players[iPlayer].GovDiploLog, 1, {ID = selfID, Turn = GetITGGameTurn(), GovID = govID, Action = actionID, Outcome = outcomeID, Data = {blog1, blog2, extraData[3], extraData[1], extraData[2]}})
	end
	return uiTab;
end

function GovActionResolve5(iPlayer, actionID, fIndex, selfID)
	local pIndex = fIndex or 1;
	local govID = gT.Players[iPlayer].DiploNotes[pIndex].Governor;
	local extraData = gT.Players[iPlayer].DiploNotes[pIndex].ExtraData;
	local csPlayer = extraData[2];
	local blog1, blog2;
	local uiTab = {GovID = govID, Headline = Locale.Lookup(dgActions[selfID].Name)}
	uiTab.Actions = {
		{ID = 1, Text = "ACCEPT", Help = "", ToolTip = "", Outcomes = {{
				Text = "VoidResultAlways", Results = {
				{"+" .. extraData[2] .. " XP for all Agents.",""},
				{"Your [ICON_ITG_POWER] Power becomes 25% less effective against this [ICON_ITG_GOVERNOR] Governor.",""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_GOVERNOR_POWER_GAIN", extraData[1]),""},
				}}}}, 
	{ID = 2, Text = "REFUSE", Help = "", ToolTip = "", Outcomes = {
			{Text = "VoidResultAlways", Results = {
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_GRUDGE",5,Locale.Lookup(GetGrudgeData(4, "Name"))),GenerateNiceGrudgeTooltip(4, true)},
				}}}}
	}
	if actionID == -1 then
		uiTab.Active = true;
		uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_5")
	else
		for a, b in pairs(uiTab.Actions) do
			if b.ID ~= actionID then
				uiTab.Actions[a].Disabled = true;
			end
		end
		if actionID == 1 then
			local outcomeID = 1;
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_5_ACTION_1")
			ChangeAllSpiesExperience(iPlayer, extraData[2])
			BoostGovernorPower(govID, "Actions", extraData[1], false)
			gT.Globals.Governors[govID].IntelInsight = true;
		elseif actionID == 2 then
			local outcomeID = 1;
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_5_ACTION_2")
			if GenerateChancedGrudge(govID, 4, 5) then
				blog2 = true;
			else
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[1].Disabled = true;
			end
		end
		table.insert(gT.Players[iPlayer].GovDiploLog, 1, {ID = selfID, Turn = GetITGGameTurn(), GovID = govID, Action = actionID, Data = {blog1, blog2, extraData[2], extraData[1]}})
	end
	return uiTab;
end

function GovActionResolve6(iPlayer, actionID, fIndex, selfID)
	local pIndex = fIndex or 1;
	local govID = gT.Players[iPlayer].DiploNotes[pIndex].Governor;
	local extraData = gT.Players[iPlayer].DiploNotes[pIndex].ExtraData;
	if Players[iPlayer]:GetReligionCreatedByPlayer() < 1 then
		return nil;
	end
	local blog1, blog2;
	local uiTab = {GovID = govID, Headline = Locale.Lookup(dgActions[selfID].Name)}
	uiTab.Actions = {
		{ID = 1, Text = "ACCEPT", Help = "", ToolTip = "", Outcomes = {{
				Text = "VoidResultAlways", Results = {
				{"+" .. extraData[2] .. " [ICON_MISSIONARY] Missionaries.",""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_GOVERNOR_POWER_GAIN", extraData[1]),""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_MERITOCRACY_GAIN", 1), ""},
				}}}}, 
	{ID = 2, Text = "REFUSE", Help = "", ToolTip = "", Outcomes = {
			{Text = "VoidResultAlways", Results = {
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_GRUDGE",5,Locale.Lookup(GetGrudgeData(4, "Name"))),GenerateNiceGrudgeTooltip(4, true)},
				}}}}
	}
	if actionID == -1 then
		uiTab.Active = true;
		uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_6")
	else
		for a, b in pairs(uiTab.Actions) do
			if b.ID ~= actionID then
				uiTab.Actions[a].Disabled = true;
			end
		end
		if actionID == 1 then
			local outcomeID = 1;
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_6_ACTION_1")
			gT.Players[iPlayer].FreeMissioniares =  gT.Players[iPlayer].FreeMissioniares + extraData[2];
			BoostGovernorPower(govID, "Actions", extraData[1], false)
			ChangeMeritocracy(iPlayer, 1)
		elseif actionID == 2 then
			local outcomeID = 1;
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_6_ACTION_2")
			if GenerateChancedGrudge(govID, 4, 5) then
				blog2 = true;
			else
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[1].Disabled = true;
			end
		end
		table.insert(gT.Players[iPlayer].GovDiploLog, 1, {ID = selfID, Turn = GetITGGameTurn(), GovID = govID, Action = actionID, Data = {blog1, blog2, extraData[2], extraData[1]}})
	end
	return uiTab;
end

function GovActionResolve7(iPlayer, actionID, fIndex, selfID)
	local pIndex = fIndex or 1;
	local govID = gT.Players[iPlayer].DiploNotes[pIndex].Governor;
	local extraData = gT.Players[iPlayer].DiploNotes[pIndex].ExtraData;
	local blog1, blog2;
	local uiTab = {GovID = govID, Headline = Locale.Lookup(dgActions[selfID].Name)}
	uiTab.Actions = {
		{ID = 1, Text = "ACCEPT", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{"+" .. extraData[3] .. " [ICON_WORKER] Work Rate in all Cities.",""},
				{"Governor will contest Cities for governorship in an extra " .. extraData[2] .. " range.",""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_CAUSE", extraData[4], Locale.Lookup(GetGovCauseData(9, "Name"))),GenerateNiceCauseTooltip(9)},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_GOVERNOR_POWER_GAIN", extraData[1]),""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_MERITOCRACY_GAIN", extraData[2]), ""},
				{"+1 [ICON_HAPPINESS_4] Unhappiness in all Cities.",""},
				}}}
	}, 
	{ID = 2, Text = "REFUSE", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_GRUDGE",5,Locale.Lookup(GetGrudgeData(4, "Name"))),GenerateNiceGrudgeTooltip(4, true)},
			}}}}
	}
	if actionID == -1 then
		uiTab.Active = true;
		uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_7")
	else
		local outcomeID = 1;
		if actionID == 1 then
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_7_ACTION_1")
			IncreaseWorkRateInAllCities(iPlayer, extraData[3])
			gT.Globals.Governors[govID].ExtraRange = (gT.Globals.Governors[govID].ExtraRange or 0) + extraData[2];
			if LastChance(extraData[4]) then
				NoteGovCausesBasicStack(iPlayer, 9)
				blog1 = true;
			else
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[3].Disabled = true;
			end
			ChangeMeritocracy(iPlayer, extraData[2])
			BoostHappinessInAllCities(iPlayer, -1)
			BoostGovernorPower(govID, "Actions", extraData[1], false)
			DoDefineGovernorCityOwnership(iPlayer)
		elseif actionID == 2 then
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_7_ACTION_2")
			if GenerateChancedGrudge(govID, 4, 5) then
				blog2 = true;
			else
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[1].Disabled = true;
			end
		end
		uiTab = PrepareResolveTabForUI(uiTab, actionID, outcomeID);
		table.insert(gT.Players[iPlayer].GovDiploLog, 1, {ID = selfID, Turn = GetITGGameTurn(), GovID = govID, Action = actionID, Data = {blog1, blog2, extraData[3], extraData[1]}})
	end
	return uiTab;
end
function GovActionResolve43(iPlayer, actionID, fIndex, selfID)
	local pIndex = fIndex or 1;
	local govID = gT.Players[iPlayer].DiploNotes[pIndex].Governor;
	local extraData = gT.Players[iPlayer].DiploNotes[pIndex].ExtraData;
	local blog1, blog2;
	local uiTab = {GovID = govID, Headline = Locale.Lookup(dgActions[selfID].Name)}
	uiTab.Actions = {
		{ID = 1, Text = "ACCEPT", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{"+" .. extraData[3] .. " [ICON_GREAT_ARTIST] Art points per turn from [ICON_ITG_GOVERNOR] Governor.",""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_GOVERNOR_POWER_GAIN", extraData[1]),""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_MERITOCRACY_GAIN", extraData[2]), ""},
				}}}
	}, 
	{ID = 2, Text = "REFUSE", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_GRUDGE",5,Locale.Lookup(GetGrudgeData(4, "Name"))),GenerateNiceGrudgeTooltip(4, true)},
			}}}}
	}
	if actionID == -1 then
		uiTab.Active = true;
		uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_43")
	else
		local outcomeID = 1;
		if actionID == 1 then
			gT.Globals.Governors[govID].Art = gT.Globals.Governors[govID].Art + extraData[3];
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_43_ACTION_1")
			ChangeMeritocracy(iPlayer, extraData[2])
			BoostGovernorPower(govID, "Actions", extraData[1], false)
		elseif actionID == 2 then
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_43_ACTION_2")
			if GenerateChancedGrudge(govID, 4, 5) then
				blog2 = true;
			else
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[1].Disabled = true;
			end
		end
		uiTab = PrepareResolveTabForUI(uiTab, actionID, outcomeID);
		table.insert(gT.Players[iPlayer].GovDiploLog, 1, {ID = selfID, Turn = GetITGGameTurn(), GovID = govID, Action = actionID, Data = {blog1, blog2, extraData[3], extraData[1]}})
	end
	return uiTab;
end
function GovActionResolve49(iPlayer, actionID, fIndex, selfID)
	local pIndex = fIndex or 1;
	local govID = gT.Players[iPlayer].DiploNotes[pIndex].Governor;
	local extraData = gT.Players[iPlayer].DiploNotes[pIndex].ExtraData;
	local blog1, blog2;
	local uiTab = {GovID = govID, Headline = Locale.Lookup(dgActions[selfID].Name)}
	uiTab.Actions = {
		{ID = 1, Text = "ACCEPT", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{"+" .. extraData[3] .. "% [ICON_ITG_LAWS_INFLUENCE] Codex Influence from [ICON_ITG_GOVERNOR] Governor.",""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_GOVERNOR_POWER_GAIN", extraData[1]),""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_MERITOCRACY_GAIN", extraData[2]), ""},
				}}}
	}, 
	{ID = 2, Text = "REFUSE", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_GRUDGE",5,Locale.Lookup(GetGrudgeData(4, "Name"))),GenerateNiceGrudgeTooltip(4, true)},
			}}}}
	}
	if actionID == -1 then
		uiTab.Active = true;
		uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_49")
	else
		local outcomeID = 1;
		if actionID == 1 then
			gT.Globals.Governors[govID].CodexInfluence = extraData[3];
			gT.Players[iPlayer].GoverCodexInfluence = gT.Players[iPlayer].GoverCodexInfluence + extraData[3];
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_49_ACTION_1")
			ChangeMeritocracy(iPlayer, extraData[2])
			BoostGovernorPower(govID, "Actions", extraData[1], false)
		elseif actionID == 2 then
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_49_ACTION_2")
			if GenerateChancedGrudge(govID, 4, 5) then
				blog2 = true;
			else
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[1].Disabled = true;
			end
		end
		uiTab = PrepareResolveTabForUI(uiTab, actionID, outcomeID);
		table.insert(gT.Players[iPlayer].GovDiploLog, 1, {ID = selfID, Turn = GetITGGameTurn(), GovID = govID, Action = actionID, Data = {blog1, blog2, extraData[3], extraData[1]}})
	end
	return uiTab;
end
function GovActionResolve51(iPlayer, actionID, fIndex, selfID)
	local pIndex = fIndex or 1;
	local govID = gT.Players[iPlayer].DiploNotes[pIndex].Governor;
	if not gT.Globals.Governors[govID].City then
		return;
	end
	if not CanHaveMercenaryFromGoodyHut(iPlayer) then
		return;
	end
	local iCity = Map.GetPlotByIndex(gT.Globals.Governors[govID].City):GetPlotCity();
	local extraData = gT.Players[iPlayer].DiploNotes[pIndex].ExtraData;
	local blog1, blog2;
	local uiTab = {GovID = govID, Headline = Locale.Lookup(dgActions[selfID].Name)}
	uiTab.Actions = {
		{ID = 1, Text = "ACCEPT", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{"2 famous [ICON_ITG_MERCENARY] Mercenaries will spawn near " .. iCity:GetName() .. ".",""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_GOVERNOR_POWER_GAIN", 12),""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_MERITOCRACY_GAIN", 1), ""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_MORALE_BOOST","1-3"),""},
				}}}
	}, 
	{ID = 2, Text = "REFUSE", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_GRUDGE",5,Locale.Lookup(GetGrudgeData(4, "Name"))),GenerateNiceGrudgeTooltip(4, true)},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_CAUSE", 25, Locale.Lookup(GetGovCauseData(12, "Name"))),GenerateNiceCauseTooltip(12)},
			}}}}
	}
	if actionID == -1 then
		uiTab.Active = true;
		uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_51")
	else
		local outcomeID = 1;
		if actionID == 1 then
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_51_ACTION_1")
			ChangeMeritocracy(iPlayer, 1)
			BoostGovernorPower(govID, "Actions", 12, false)
			for mi = 1, 2 do
				DoSpawnMercenaryFromGoodyHut(iPlayer, iCity:Plot(), true)
			end
			local moraleGain = LastRandom(1,3);
			uiTab.Actions[actionID].Outcomes[outcomeID].Results[4] = {Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_MORALE_BOOST", GetGovernorActionRNGTextSolved(1,3,moraleGain,"[COLOR_POSITIVE_TEXT]")),""} 
			TakeCareOfEventMorale(iPlayer, 25, {moraleGain, "Diplo Action"})
		elseif actionID == 2 then
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_51_ACTION_2")
			if LastChance(25) then
				NoteGovCausesBasicStack(iPlayer, 12)
				blog1 = true;
			else
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[2].Disabled = true;
			end
			if GenerateChancedGrudge(govID, 4, 5) then
				blog2 = true;
			else
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[1].Disabled = true;
			end
		end
		uiTab = PrepareResolveTabForUI(uiTab, actionID, outcomeID);
		table.insert(gT.Players[iPlayer].GovDiploLog, 1, {ID = selfID, Turn = GetITGGameTurn(), GovID = govID, Action = actionID, Data = {blog1, blog2}})
	end
	return uiTab;
end
function GovActionResolve30(iPlayer, actionID, fIndex, selfID)
	local pIndex = fIndex or 1;
	local govID = gT.Players[iPlayer].DiploNotes[pIndex].Governor;
	local extraData = gT.Players[iPlayer].DiploNotes[pIndex].ExtraData;
	local blog1, blog2;
	if not CanPlayerDoNationalDay(iPlayer) then
		return;
	end
	local gpName = GetGreatPersonName(extraData[1])
	local uiTab = {GovID = govID, Headline = Locale.Lookup(dgActions[selfID].Name)}
	uiTab.Actions = {
		{ID = 1, Text = "ACCEPT", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{"Establishes new National Day.", GetHelpForLegalAction(19, iPlayer)},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_GOVERNOR_POWER_GAIN", 25),""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_MERITOCRACY_GAIN", 5), ""},
				}}}
	}, 
	{ID = 2, Text = "REFUSE", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_GRUDGE",50,Locale.Lookup(GetGrudgeData(8, "Name"))),GenerateNiceGrudgeTooltip(4, true)},
			}}}}
	}
	if actionID == -1 then
		uiTab.Active = true;
		uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_30", gpName)
	else
		local outcomeID = 1;
		if actionID == 1 then
			uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_30_ACTION_1", gpName)
			LinkPlayerDoNationalDay(iPlayer);
			ChangeMeritocracy(iPlayer, 5)
			BoostGovernorPower(govID, "Actions", 25, false)
		elseif actionID == 2 then
			uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_30_ACTION_2", gpName)
			if GenerateChancedGrudge(govID, 8, 50) then
				blog2 = true;
			else
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[1].Disabled = true;
			end
		end
		uiTab = PrepareResolveTabForUI(uiTab, actionID, outcomeID);
		table.insert(gT.Players[iPlayer].GovDiploLog, 1, {ID = selfID, Turn = GetITGGameTurn(), GovID = govID, Action = actionID, Data = {blog1, blog2, extraData[1]}})
	end
	return uiTab;
end
function GovActionResolve31(iPlayer, actionID, fIndex, selfID)
	local pIndex = fIndex or 1;
	local govID = gT.Players[iPlayer].DiploNotes[pIndex].Governor;
	local extraData = gT.Players[iPlayer].DiploNotes[pIndex].ExtraData;
	local blog1, blog2;
	local lIndex = extraData[1];
	if (not gT.Settlements[lIndex]) or (not CanSettlementBeUpdatedNow(lIndex, iPlayer)) then
		return;
	end
	local uiTab = {GovID = govID, Headline = Locale.Lookup(dgActions[selfID].Name)}
	uiTab.Actions = {
		{ID = 1, Text = "ACCEPT", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{"Expands Settlement to a City.",""},
				{"+1 [ICON_HAPPINESS_4] Unhappiness in all Cities.",""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_GOVERNOR_POWER_GAIN", 15),""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_CAUSE", 10, Locale.Lookup(GetGovCauseData(9, "Name"))),GenerateNiceCauseTooltip(9)},
				}}}
	}, 
	{ID = 2, Text = "REFUSE", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_GRUDGE",5,Locale.Lookup(GetGrudgeData(4, "Name"))),GenerateNiceGrudgeTooltip(4, true)},
			}}}}
	}
	if actionID == -1 then
		uiTab.Active = true;
		uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_31")
	else
		local outcomeID = 1;
		if actionID == 1 then
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_31_ACTION_1")
			UpdateSettlementOnThePlot(Map.GetPlotByIndex(lIndex), lIndex, iPlayer)
			BoostHappinessInAllCities(iPlayer, -1)
			if LastChance(10) then
				NoteGovCausesBasicStack(iPlayer, 9)
				blog1 = true;
			else
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[3].Disabled = true;
			end
			BoostGovernorPower(govID, "Actions", 15, false)
		elseif actionID == 2 then
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_31_ACTION_2")
			if GenerateChancedGrudge(govID, 4, 5) then
				blog2 = true;
			else
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[1].Disabled = true;
			end
		end
		uiTab = PrepareResolveTabForUI(uiTab, actionID, outcomeID);
		table.insert(gT.Players[iPlayer].GovDiploLog, 1, {ID = selfID, Turn = GetITGGameTurn(), GovID = govID, Action = actionID, Data = {blog1, blog2, extraData[1]}})
	end
	return uiTab;
end
function GovActionResolve35(iPlayer, actionID, fIndex, selfID)
	local pIndex = fIndex or 1;
	local govID = gT.Players[iPlayer].DiploNotes[pIndex].Governor;
	local extraData = gT.Players[iPlayer].DiploNotes[pIndex].ExtraData;
	local blog1, blog2;
	local tPlayer = extraData[1];
	if gT.Players[tPlayer].Embargos[tPlayer] or (not Players[tPlayer]:IsAlive()) then
		return;
	end
	local pCivName = Players[tPlayer]:GetCivilizationShortDescription();
	local uiTab = {GovID = govID, Headline = Locale.Lookup(dgActions[selfID].Name)}
	uiTab.Actions = {
		{ID = 1, Text = "ACCEPT", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{"Set Trade Embargo on " .. pCivName .. ".","Note: this Embargo will be active as long as [ICON_ITG_GOVERNOR] Governor serves you."},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_GOVERNOR_POWER_GAIN", 10),""},
				}}}
	}, 
	{ID = 2, Text = "REFUSE", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_GRUDGE",5,Locale.Lookup(GetGrudgeData(4, "Name"))),GenerateNiceGrudgeTooltip(4, true)},
			}}}}
	}
	if actionID == -1 then
		uiTab.Active = true;
		uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_35", pCivName)
	else
		local outcomeID = 1;
		if actionID == 1 then
			uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_35_ACTION_1", pCivName)
			gT.Globals.Governors[govID].TradeEmbargo = tPlayer;
			PlayersEmbargoChange(iPlayer, tPlayer, 1)
			BoostGovernorPower(govID, "Actions", 10, false)
		elseif actionID == 2 then
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_35_ACTION_2")
			if GenerateChancedGrudge(govID, 4, 5) then
				blog2 = true;
			else
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[1].Disabled = true;
			end
		end
		uiTab = PrepareResolveTabForUI(uiTab, actionID, outcomeID);
		table.insert(gT.Players[iPlayer].GovDiploLog, 1, {ID = selfID, Turn = GetITGGameTurn(), GovID = govID, Action = actionID, Data = {blog1, blog2, extraData[1]}})
	end
	return uiTab;
end
function GovActionResolve36(iPlayer, actionID, fIndex, selfID)
	local pIndex = fIndex or 1;
	local govID = gT.Players[iPlayer].DiploNotes[pIndex].Governor;
	local fPlayer = gT.Globals.Governors[govID].Player;
	if (not fPlayer) or (fPlayer == -1) then
		return;
	end
	local extraData = gT.Players[iPlayer].DiploNotes[pIndex].ExtraData;
	local blog1, blog2;
	local tType = extraData[1];
	local iClass = extraData[2];
	local ubType;
	local ubName;
	if tType == 1 then
		if IsBuildingClassValidToBeUnlocked(iPlayer, Teams[Players[iPlayer]:GetTeam()], {[fPlayer] = true}, iClass) then
			ubType = Players[iPlayer]:GetPlayerUniqueBuilding(iClass);
			ubName = Locale.Lookup(GameInfo.Buildings[ubType].Description)
		else
			print("GovAction36 Building no longer valid (can happen)", iPlayer, fPlayer, iClass)
			return;
		end
	else
		if IsUnitClassValidToBeUnlocked(iPlayer, Teams[Players[iPlayer]:GetTeam()], {[fPlayer] = true}, iClass) then
			ubType = Players[iPlayer]:GetPlayerUniqueUnit(iClass);
			ubName = Locale.Lookup(GameInfo.Units[ubType].Description)
		else
			print("GovAction36 Unit no longer valid (can happen)", iPlayer, fPlayer, iClass)
			return;
		end
	end
	local uiTab = {GovID = govID, Headline = Locale.Lookup(dgActions[selfID].Name)}
	uiTab.Actions = {
		{ID = 1, Text = "ACCEPT", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{"",""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_CAUSE", GeneratePuppetRulerStackChance(iPlayer), Locale.Lookup(GetGovCauseData(8, "Name"))),GenerateNiceCauseTooltip(8)},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_FAVOUR_EARNED", 10), Locale.Lookup("TXT_KEY_GOV_ACTION_FAVOUR_TT")},
				}}}
	}, 
	{ID = 2, Text = "REFUSE", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
			}}}}
	}
	if tType == 1 then
		uiTab.Actions[1].Outcomes[1].Results[1] = {"Unlocks constructing " .. ubName .. ".", "Once you discover technology that normally unlocks this Building you will be awarded with +10 [ICON_ITG_MERITOCRACY] Meritocracy."}
	else
		uiTab.Actions[1].Outcomes[1].Results[1] = {"Unlocks training " .. ubName .. ".", "Once you discover technology that normally unlocks this Unit you will be awarded with +100XP for this unit class."}
	end
	if actionID == -1 then
		uiTab.Active = true;
		uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_36", ubName)
	else
		local outcomeID = 1;
		if actionID == 1 then
			uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_36_ACTION_1", ubName)
			if tType == 1 then
				DoUnlockBuildingClass(iPlayer, iClass, "Governor")
			else
				DoUnlockUnitClass(iPlayer, iClass, "Governor")
			end
			if LastChance(GeneratePuppetRulerStackChance(iPlayer)) then
				NoteGovCausesBasicStack(iPlayer, 8)
				blog1 = true;
			else
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[2].Disabled = true;
			end
			gT.Globals.Governors[govID].ForeignContacts[iPlayer].Favour = gT.Globals.Governors[govID].ForeignContacts[iPlayer].Favour + 10;
		elseif actionID == 2 then
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_36_ACTION_2")
		end
		uiTab = PrepareResolveTabForUI(uiTab, actionID, outcomeID);
		table.insert(gT.Players[iPlayer].GovDiploLog, 1, {ID = selfID, Turn = GetITGGameTurn(), GovID = govID, Action = actionID, Data = {blog1, blog2, extraData[1], ubType}})
	end
	return uiTab;
end
function GovActionResolve52(iPlayer, actionID, fIndex, selfID)
	local pIndex = fIndex or 1;
	local govID = gT.Players[iPlayer].DiploNotes[pIndex].Governor;
	local fPlayer = gT.Globals.Governors[govID].Player;
	local extraData = gT.Players[iPlayer].DiploNotes[pIndex].ExtraData;
	local blog1, blog2;
	local cityState = extraData[1];
	if Teams[Players[iPlayer]:GetTeam()]:IsHasMet(Players[cityState]:GetTeam()) then
		print("Met city-state govaction52")
		return;
	end
	local uiTab = {GovID = govID, Headline = Locale.Lookup(dgActions[selfID].Name)}
	uiTab.Actions = {
		{ID = 1, Text = "ACCEPT", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{"Meet an unknown City-State.",""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_CAUSE", GeneratePuppetRulerStackChance(iPlayer), Locale.Lookup(GetGovCauseData(8, "Name"))),GenerateNiceCauseTooltip(8)},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_FAVOUR_EARNED", 7), Locale.Lookup("TXT_KEY_GOV_ACTION_FAVOUR_TT")},
				}}}
	}, 
	{ID = 2, Text = "REFUSE", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
			}}}}
	}
	if actionID == -1 then
		uiTab.Active = true;
		uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_52")
	else
		local outcomeID = 1;
		if actionID == 1 then
			local csName = Players[cityState]:GetName();
			uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_52_ACTION_1", csName)
			uiTab.Actions[1].Outcomes[1].Results[1][1] = "You have met " .. csName .. "."
			Teams[Players[iPlayer]:GetTeam()]:Meet(Players[cityState]:GetTeam())
			if LastChance(GeneratePuppetRulerStackChance(iPlayer)) then
				NoteGovCausesBasicStack(iPlayer, 8)
				blog1 = true;
			else
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[2].Disabled = true;
			end
			gT.Globals.Governors[govID].ForeignContacts[iPlayer].Favour = gT.Globals.Governors[govID].ForeignContacts[iPlayer].Favour + 7;
		elseif actionID == 2 then
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_52_ACTION_2")
		end
		uiTab = PrepareResolveTabForUI(uiTab, actionID, outcomeID);
		table.insert(gT.Players[iPlayer].GovDiploLog, 1, {ID = selfID, Turn = GetITGGameTurn(), GovID = govID, Action = actionID, Data = {blog1, blog2, cityState}})
	end
	return uiTab;
end
function GovActionResolve53(iPlayer, actionID, fIndex, selfID)
	local pIndex = fIndex or 1;
	local govID = gT.Players[iPlayer].DiploNotes[pIndex].Governor;
	local fPlayer = gT.Globals.Governors[govID].Player;
	local extraData = gT.Players[iPlayer].DiploNotes[pIndex].ExtraData;
	local blog1, blog2;
	if (not fPlayer) or (fPlayer == -1) then
		print("Lacks player govaction53")
		return;
	end
	if HasGovernorProtectionOverSpies(iPlayer, fPlayer) then
		print("Already has a protection govaction53")
		return;
	end
	local uiTab = {GovID = govID, Headline = Locale.Lookup(dgActions[selfID].Name)}
	uiTab.Actions = {
		{ID = 1, Text = "ACCEPT", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{"Cooperation with your Agents.","Your Agents working in rival cities will have chance to be detected reduced by 50%. It does not affect operations (ex. Sabotage, Assassination)."},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_CAUSE", GeneratePuppetRulerStackChance(iPlayer), Locale.Lookup(GetGovCauseData(8, "Name"))),GenerateNiceCauseTooltip(8)},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_FAVOUR_EARNED", 20), Locale.Lookup("TXT_KEY_GOV_ACTION_FAVOUR_TT")},
				}}}
	}, 
	{ID = 2, Text = "REFUSE", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
			}}}}
	}
	if actionID == -1 then
		uiTab.Active = true;
		uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_53")
	else
		local outcomeID = 1;
		if actionID == 1 then
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_53_ACTION_1")
			gT.Globals.Governors[govID].ForeignContacts[iPlayer].SpyProtection = true;
			if LastChance(GeneratePuppetRulerStackChance(iPlayer)) then
				NoteGovCausesBasicStack(iPlayer, 8)
				blog1 = true;
			else
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[2].Disabled = true;
			end
			gT.Globals.Governors[govID].ForeignContacts[iPlayer].Favour = gT.Globals.Governors[govID].ForeignContacts[iPlayer].Favour + 20;
		elseif actionID == 2 then
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_53_ACTION_2")
		end
		uiTab = PrepareResolveTabForUI(uiTab, actionID, outcomeID);
		table.insert(gT.Players[iPlayer].GovDiploLog, 1, {ID = selfID, Turn = GetITGGameTurn(), GovID = govID, Action = actionID, Data = {blog1, blog2}})
	end
	return uiTab;
end
function GovActionResolve37(iPlayer, actionID, fIndex, selfID)
	local pIndex = fIndex or 1;
	local govID = gT.Players[iPlayer].DiploNotes[pIndex].Governor;
	local extraData = gT.Players[iPlayer].DiploNotes[pIndex].ExtraData;
	local blog1, blog2;
	if not CanAppointGovernor(iPlayer) then
		return;
	end
	local uiTab = {GovID = govID, Headline = Locale.Lookup(dgActions[selfID].Name)}
	uiTab.Actions = {
		{ID = 1, Text = "ACCEPT", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{"New [ICON_ITG_GOVERNOR] Governor is appointed.",""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_GOVERNOR_POWER_GAIN", 25),""},
				}}}
	}, 
	{ID = 2, Text = "REFUSE", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_GRUDGE",25,Locale.Lookup(GetGrudgeData(8, "Name"))),GenerateNiceGrudgeTooltip(8, true)},
			}}}}
	}
	if actionID == -1 then
		uiTab.Active = true;
		uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_37")
	else
		local outcomeID = 1;
		if actionID == 1 then
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_37_ACTION_1")
			AppointNewGovernor(iPlayer)
			blog1 = #gT.Globals.Governors
			DoChangeRelationsBetweenGovs(govID, blog1, 50, true)
			BoostGovernorPower(govID, "Actions", 25, false)
		elseif actionID == 2 then
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_37_ACTION_2")
			if GenerateChancedGrudge(govID, 8, 25) then
				blog2 = true;
			else
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[1].Disabled = true;
			end
		end
		uiTab = PrepareResolveTabForUI(uiTab, actionID, outcomeID);
		table.insert(gT.Players[iPlayer].GovDiploLog, 1, {ID = selfID, Turn = GetITGGameTurn(), GovID = govID, Action = actionID, Data = {blog1, blog2}})
	end
	return uiTab;
end
function GovActionResolve32(iPlayer, actionID, govID, selfID)
	local uiTab = {GovID = govID, VoidEvent = true, SelfID = selfID, Headline = Locale.Lookup(dgActions[selfID].Name)}
	local govPower = gT.Globals.Governors[govID].Power;
	local intrigueV = GetPlayerGovernorPower(iPlayer)
	local cExec, cEscape = GetGovExecutionChances(iPlayer, govPower, intrigueV, 2, govID)
	local bHideHeresy = true;
	local blog1, blog2;
	local iForeignPlotting = math.min(100, gT.Globals.Governors[govID].PowerSources["Foreign Relations"] or 0)
	if gT.Globals.Governors[govID].Type == 7 then
		iForeignPlotting = 0;
	end
	local iCompetence = math.min(100, -1 * (gT.Globals.Governors[govID].PowerSources["Incompetence"] or 0))
	local escapepowerloss = math.ceil(govPower / 20);
	if gT.Players[iPlayer].OfficialReligion and (gT.Players[iPlayer].OfficialReligion ~= gT.Globals.Governors[govID].CityReligion) then
		bHideHeresy = false;
	end
	local cityPlaced, cityPlacedTT, noPlaced, noPlacedTT = GetGovCitiesForAction(govID, iPlayer);
	local extraUnits = math.max(2, math.min(5, math.ceil(govPower / 40)))
	local iDMG = math.max(25, math.min(75, math.ceil(govPower / 3)))
	local iResistance = math.max(2, math.min(4, math.ceil(govPower / 50)))
	local iMilitShare = GetMilitarySharesGovernors(iPlayer, govID)
	uiTab.Actions = {
		{ID = 1, Text = "NO REASON", Help = "", ToolTip = "", 
		Outcomes = {
			{ID = 1, Text = "EXECUTION", Help = "[COLOR_POSITIVE_TEXT]" .. math.floor(cExec / (cExec + cEscape) * 1000) / 10 .. "%", ToolTip = "", Results = {
				{"[ICON_ITG_GOVERNOR] Governor dies.",""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_CAUSE", 100, Locale.Lookup(GetGovCauseData(13, "Name"))),GenerateNiceCauseTooltip(13)},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_CAUSE", 10, Locale.Lookup(GetGovCauseData(15, "Name"))),GenerateNiceCauseTooltip(15)},
			}},
			{ID = 2, Text = "ESCAPE", Help = "[COLOR_NEGATIVE_TEXT]" .. math.floor(cEscape / (cExec + cEscape) * 1000) / 10 .. "%", ToolTip = Locale.Lookup("TXT_KEY_GOV_OUTCOME_CHANCE_REDUCE_BY_VISIBILITY_VS_GOV"), Results = {
				DoTriggerGovernorTypeBadEffect(iPlayer, govID, govPower, true),
				{"[ICON_ITG_GOVERNOR] Governor leaves the state.",""},
				{"[ICON_RESISTANCE] Riots start in all Cities governed by [ICON_ITG_GOVERNOR] Governor.", cityPlacedTT},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_PLAYER_POWER_REDUCTION",escapepowerloss),""},
			}},		
			{ID = 3, Text = "TREASON", Help = "[COLOR_NEGATIVE_TEXT]?%", ToolTip = "An alternative to Escape. This can only happen if [ICON_ITG_GOVERNOR] Governor had already a Secret Pact with other player.", Results = {
				{"Cities under [ICON_ITG_GOVERNOR] Governor will receive " .. iDMG .. " DMG and enter " .. iResistance .. " turns of resistance.", cityPlacedTT},
				{"Every military unit will have " .. iMilitShare .. "% chance to take 25 non-lethal damage and become [ICON_DENOUNCE] Demoralized.", ""},
				{"[ICON_ITG_GOVERNOR] Governor abandons you."},
				{"Opponent declares war on you.", ""},
			}},
		}},
		{ID = 2, Text = "PLOTTING", Help = "", Hide = (iForeignPlotting == 0), ToolTip = "", 
		Outcomes = {
			{ID = 1, Text = "EXECUTION", Help = "[COLOR_POSITIVE_TEXT]" .. math.floor(cExec / (cExec + cEscape) * 1000) / 10 .. "%", ToolTip = "", Results = {
				{"[ICON_ITG_GOVERNOR] Governor dies.",""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_CAUSE", 100 - iForeignPlotting, Locale.Lookup(GetGovCauseData(13, "Name"))),GenerateNiceCauseTooltip(13)},
			}},
			{ID = 2, Text = "ESCAPE", Help = "[COLOR_NEGATIVE_TEXT]" .. math.floor(cEscape / (cExec + cEscape) * 1000) / 10 .. "%", ToolTip = Locale.Lookup("TXT_KEY_GOV_OUTCOME_CHANCE_REDUCE_BY_VISIBILITY_VS_GOV"), Results = {
				DoTriggerGovernorTypeBadEffect(iPlayer, govID, govPower, true),
				{"[ICON_ITG_GOVERNOR] Governor leaves the state.",""},
				{"[ICON_RESISTANCE] Riots start in all Cities governed by [ICON_ITG_GOVERNOR] Governor.", cityPlacedTT},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_PLAYER_POWER_REDUCTION",escapepowerloss),""},
			}},	
			{ID = 3, Text = "TREASON", Help = "[COLOR_NEGATIVE_TEXT]?%", ToolTip = "An alternative to Escape. This can only happen if [ICON_ITG_GOVERNOR] Governor had already a Secret Pact with other player.", Results = {
				{"Cities under [ICON_ITG_GOVERNOR] Governor will receive " .. iDMG .. " DMG and enter " .. iResistance .. " turns of resistance.", cityPlacedTT},
				{"Every military unit will have " .. iMilitShare .. "% chance to take 25 non-lethal damage and become [ICON_DENOUNCE] Demoralized.", ""},
				{"[ICON_ITG_GOVERNOR] Governor abandons you."},
				{"Opponent declares war on you.", ""},
			}},
		}},
		{ID = 3, Text = "HERESY", Help = "", Hide = bHideHeresy, ToolTip = "", 
		Outcomes = {
			{ID = 1, Text = "EXECUTION", Help = "[COLOR_POSITIVE_TEXT]" .. math.floor(cExec / (cExec + cEscape) * 1000) / 10 .. "%", ToolTip = "", Results = {
				{"[ICON_ITG_GOVERNOR] Governor dies.",""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_CAUSE", 50, Locale.Lookup(GetGovCauseData(13, "Name"))),GenerateNiceCauseTooltip(13)},
				{"Increases [ICON_PROPHET] Heresy from local theology by 1%.", ""},
			}},
			{ID = 2, Text = "ESCAPE", Help = "[COLOR_NEGATIVE_TEXT]" .. math.floor(cEscape / (cExec + cEscape) * 1000) / 10 .. "%", ToolTip = Locale.Lookup("TXT_KEY_GOV_OUTCOME_CHANCE_REDUCE_BY_VISIBILITY_VS_GOV"), Results = {
				DoTriggerGovernorTypeBadEffect(iPlayer, govID, govPower, true),
				{"[ICON_ITG_GOVERNOR] Governor leaves the state.",""},
				{"[ICON_RESISTANCE] Riots start in all Cities governed by [ICON_ITG_GOVERNOR] Governor.", cityPlacedTT},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_PLAYER_POWER_REDUCTION",escapepowerloss),""},
				{"Increases [ICON_PROPHET] Heresy from local theology by 2%.", ""},
			}},	
			{ID = 3, Text = "TREASON", Help = "[COLOR_NEGATIVE_TEXT]?%", ToolTip = "An alternative to Escape. This can only happen if [ICON_ITG_GOVERNOR] Governor had already a Secret Pact with other player.", Results = {
				{"Cities under [ICON_ITG_GOVERNOR] Governor will receive " .. iDMG .. " DMG and enter " .. iResistance .. " turns of resistance.", cityPlacedTT},
				{"Every military unit will have " .. iMilitShare .. "% chance to take 25 non-lethal damage and become [ICON_DENOUNCE] Demoralized.", ""},
				{"[ICON_ITG_GOVERNOR] Governor abandons you."},
				{"Opponent declares war on you.", ""},
			}},
		}},
		{ID = 4, Text = "INCOMPETENCE", Help = "", Hide = (iCompetence == 0), ToolTip = "", 
		Outcomes = {
			{ID = 1, Text = "EXECUTION", Help = "[COLOR_POSITIVE_TEXT]" .. math.floor(cExec / (cExec + cEscape) * 1000) / 10 .. "%", ToolTip = "", Results = {
				{"[ICON_ITG_GOVERNOR] Governor dies.",""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_CAUSE", 100 - iCompetence, Locale.Lookup(GetGovCauseData(13, "Name"))),GenerateNiceCauseTooltip(13)},
			}},
			{ID = 2, Text = "ESCAPE", Help = "[COLOR_NEGATIVE_TEXT]" .. math.floor(cEscape / (cExec + cEscape) * 1000) / 10 .. "%", ToolTip = Locale.Lookup("TXT_KEY_GOV_OUTCOME_CHANCE_REDUCE_BY_VISIBILITY_VS_GOV"), Results = {
				DoTriggerGovernorTypeBadEffect(iPlayer, govID, govPower, true),
				{"[ICON_ITG_GOVERNOR] Governor leaves the state.",""},
				{"[ICON_RESISTANCE] Riots start in all Cities governed by [ICON_ITG_GOVERNOR] Governor.", cityPlacedTT},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_PLAYER_POWER_REDUCTION",escapepowerloss),""},
			}},	
			{ID = 3, Text = "TREASON", Help = "[COLOR_NEGATIVE_TEXT]?%", ToolTip = "An alternative to Escape. This can only happen if [ICON_ITG_GOVERNOR] Governor had already a Secret Pact with other player.", Results = {
				{"Cities under [ICON_ITG_GOVERNOR] Governor will receive " .. iDMG .. " DMG and enter " .. iResistance .. " turns of resistance.", cityPlacedTT},
				{"Every military unit will have " .. iMilitShare .. "% chance to take 25 non-lethal damage and become [ICON_DENOUNCE] Demoralized.", ""},
				{"[ICON_ITG_GOVERNOR] Governor abandons you."},
				{"Opponent declares war on you.", ""},
			}},
		}},
	}
	if actionID == -1 then
		uiTab.Active = true;
		uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_32")
	else
		local outcomeID = GetRandomFromBiasedChanceTable({{1,cExec}, {2, cEscape}});
		if outcomeID == 1 then
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_32_OUTCOME_1")
			if actionID == 1 then
				NoteGovCausesBasicStack(iPlayer, 13)
				if LastChance(10) then
					NoteGovCausesBasicStack(iPlayer, 15)
					blog2 = true;
				else
					uiTab.Actions[actionID].Outcomes[outcomeID].Results[3].Disabled = true;
				end
			elseif actionID == 2 then
				if LastChance(100 - iForeignPlotting) then
					NoteGovCausesBasicStack(iPlayer, 13)
					blog2 = true;
				else
					uiTab.Actions[actionID].Outcomes[outcomeID].Results[2].Disabled = true;
				end
			elseif actionID == 3 then
				if LastChance(50) then
					NoteGovCausesBasicStack(iPlayer, 13)
					blog2 = true;
				else
					uiTab.Actions[actionID].Outcomes[outcomeID].Results[2].Disabled = true;
				end
				DoChangeLocalTheologyHeresy(iPlayer, 10)
			elseif actionID == 4 then
				if LastChance(100 - iCompetence) then
					NoteGovCausesBasicStack(iPlayer, 13)
					blog2 = true;
				else
					uiTab.Actions[actionID].Outcomes[outcomeID].Results[2].Disabled = true;
				end
			end
			KillGovernor(govID, true)
		else
			local treasonPlayer = GetTreasonPlayerForGovernor(iPlayer, govID);
			if not treasonPlayer then
				uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_32_OUTCOME_2")
				blog1 = DoTriggerGovernorTypeBadEffect(iPlayer, govID, govPower, false)
				if not blog1 then
					uiTab.Actions[actionID].Outcomes[outcomeID].Results[1].Disabled = true;
				end
				BoostPlayerPower(iPlayer, "Failed Execution", -escapepowerloss)
				for i, iCity in pairs(cityPlaced) do
					DoRiotsInCity(iPlayer, iCity, iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded())
				end
				if actionID == 3 then
					DoChangeLocalTheologyHeresy(iPlayer, 20)
				end
				MakeGovernorChangePlayer(govID, -1)
			else
				outcomeID = 3;
				blog1 = treasonPlayer;
				Players[treasonPlayer]:AddNotification(81468343,"[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. " made a move against " .. Players[iPlayer]:GetName() .. " starting a war (granted us " .. extraUnits .. " military units).","Secret Pact",-1,-1, govID)
				table.insert(gT.Players[treasonPlayer].GovDiploLog, 1, {GovID = govID, ID = 1009, Turn = GetITGGameTurn(), Data = {iPlayer}})
				DoBetrayalOfGovernor(govID, iPlayer, treasonPlayer, iDMG, iResistance, iMilitShare, extraUnits, false)
				Teams[Players[treasonPlayer]:GetTeam()]:DeclareWar(Players[iPlayer]:GetTeam())
				uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_32_OUTCOME_3", Players[blog1]:GetCivilizationShortDescription())
			end
		end
		uiTab = PrepareResolveTabForUI(uiTab, actionID, outcomeID);
		table.insert(gT.Players[iPlayer].GovDiploLog, 1, {ID = selfID, Turn = GetITGGameTurn(), GovID = govID, Action = actionID, Outcome = outcomeID, Data = {blog1, blog2}})
	end
	return uiTab;
end
function GovActionResolve50(iPlayer, actionID, govID, selfID)
	local uiTab = {GovID = govID, VoidEvent = true, SelfID = selfID, Headline = Locale.Lookup(dgActions[selfID].Name)}
	local govPower = gT.Globals.Governors[govID].Power;
	local intrigueV = GetPlayerGovernorPower(iPlayer)
	local blog1, blog2;
	local avTab = GetAvailableGovPositions(iPlayer)
	local grudgeOmittedTT = GetGrudgeBasedOnMorePowerfulGovs(iPlayer, govID)
	uiTab.Actions = {
		{ID = 1, Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{"",""},
				{"[ICON_ITG_GOVERNOR] Governor will discount religious bonus by 15%.", ""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_GOVERNOR_POWER_GAIN", 15),""},
				{"Other [ICON_ITG_GOVERNOR] Governors with greater [ICON_ITG_POWER] Power have 50% to generate [COLOR_NEGATIVE_TEXT]Omitted[ENDCOLOR] grudge.", grudgeOmittedTT},
				}}}
		},
		{ID = 2, Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{"",""},
				{"[ICON_ITG_GOVERNOR] Governor will discount general and admiral bonus by 15%.", ""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_GOVERNOR_POWER_GAIN", 15),""},
				{"Other [ICON_ITG_GOVERNOR] Governors with greater [ICON_ITG_POWER] Power have 50% to generate [COLOR_NEGATIVE_TEXT]Omitted[ENDCOLOR] grudge.", grudgeOmittedTT},
				}}}
		},
		{ID = 3, Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{"",""},
				{"[ICON_ITG_GOVERNOR] Governor will discount scientific bonus by 15%.", ""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_GOVERNOR_POWER_GAIN", 15),""},
				{"Other [ICON_ITG_GOVERNOR] Governors with greater [ICON_ITG_POWER] Power have 50% to generate [COLOR_NEGATIVE_TEXT]Omitted[ENDCOLOR] grudge.", grudgeOmittedTT},
				}}}
		},
		{ID = 4, Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{"",""},
				{"[ICON_ITG_GOVERNOR] Governor will discount cultural bonus by 15%.", ""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_GOVERNOR_POWER_GAIN", 15),""},
				{"Other [ICON_ITG_GOVERNOR] Governors with greater [ICON_ITG_POWER] Power have 50% to generate [COLOR_NEGATIVE_TEXT]Omitted[ENDCOLOR] grudge.", grudgeOmittedTT},
				}}}
		},
	}
	for i = 1, 4 do
		local posData = GetDataForGovPositionID(i);
		uiTab.Actions[i].Text = string.upper(posData[1]);
		uiTab.Actions[i].Hide = (not avTab[posData[3]]);
		uiTab.Actions[i].Outcomes[1].Results[1][1] = "[ICON_ITG_GOVERNOR] Governor becomes " .. posData[1] .. ".";
		uiTab.Actions[i].Outcomes[1].Results[1][2] = posData[2];
	end
	if actionID == -1 then
		uiTab.Active = true;
		uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_50")
	else
		local outcomeID = 1;
		local posData = GetDataForGovPositionID(actionID);
		uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_50_OUTCOME_1", posData[1])
		blog2 = false;
		for sGovID, bool in pairs(gT.Players[iPlayer].Governors) do
			if (sGovID ~= govID) and (gT.Globals.Governors[sGovID].Power > gT.Globals.Governors[govID].Power) then
				if GenerateChancedGrudge(sGovID, 9, 50) then
					blog2 = true;
				end
			end
		end
		uiTab.Actions[actionID].Outcomes[outcomeID].Results[4].Disabled = (not blog2);
		BoostGovernorPower(govID, "Nomination", 15, false)
		if actionID == 1 then
			gT.Globals.Governors[govID].HighPriest = true;
			gT.Globals.Governors[govID].RelBonusDiscount = 0.15;
		elseif actionID == 2 then
			gT.Globals.Governors[govID].CommanderInChief = true;
			gT.Globals.Governors[govID].MilBonusDiscount = 0.15;
			gT.Players[iPlayer].AdmiralTresholdMod = gT.Players[iPlayer].AdmiralTresholdMod - 0.15;
			gT.Players[iPlayer].GeneralTresholdMod = gT.Players[iPlayer].GeneralTresholdMod - 0.15;
		elseif actionID == 3 then
			gT.Globals.Governors[govID].Chancellor = true;
			gT.Globals.Governors[govID].ScienceBonusDiscount = 0.15;
		elseif actionID == 4 then
			gT.Globals.Governors[govID].Curator = true;
			gT.Globals.Governors[govID].CultureBonusDiscount = 0.15;
		end
		uiTab = PrepareResolveTabForUI(uiTab, actionID, outcomeID);
		table.insert(gT.Players[iPlayer].GovDiploLog, 1, {ID = selfID, Turn = GetITGGameTurn(), GovID = govID, Action = actionID, Outcome = outcomeID, Data = {blog1, blog2}})
	end
	return uiTab;
end
function GovActionResolve41(iPlayer, actionID, fIndex, selfID)
	local pIndex = fIndex or 1;
	local extraData = gT.Players[iPlayer].DiploNotes[pIndex].ExtraData;
	local iCity = Players[iPlayer]:GetCityByID(extraData.CityID);
	local blog1, blog2;
	if not iCity then
		return;
	end
	local uiTab = {Headline = Locale.Lookup(dgActions[selfID].Name), Actions = {}}
	local iCount = 1;
	for a, b in pairs(extraData.Options) do
		if gT.Players[iPlayer].Governors[b[1]] then
			local goverName = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[b[1]].Name);
			local hStr, hText;
			if b[2] == 1 then
				hStr = "Territory"
				hText = "City acquires " .. 2 * b[3] .. " new plots."
			elseif b[2] == 2 then
				hStr = "[ICON_CITIZEN] Population"
				hText = "City gains +" .. b[3] .. " [ICON_CITIZEN] Population.";
			elseif b[2] == 3 then
				hStr = "[ICON_ITG_PRESENCE] Cultural Presence"
				hText = "City gains +" .. 20 + b[3] * 30 .. " [ICON_ITG_PRESENCE] Cultural Presence.";
			elseif b[2] == 4 then
				hStr = "[ICON_PRODUCTION] Buildings"
				hText = "City is given with " .. b[3] .. " free building(s).";
			end
			table.insert(uiTab.Actions, {ID = iCount, Text = string.upper(goverName), Help = hStr, ToolTip = "", Outcomes = {
				{Text = "VoidResultAlways", Results = {
				{hText, ""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_GOVERNOR_POWER_GAIN", 4 + b[3] * 2),""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_MERITOCRACY_GAIN", 5), ""},
			}}}})
			iCount = iCount + 1;
		end
	end
	if iCount == 1 then
		return;
	end
	table.insert(uiTab.Actions, {ID = iCount, Text = "NO EXTRA HELP", Help = "+7 [ICON_ITG_MERITOCRACY] Meritocracy", ToolTip = "", Outcomes = {
		{Text = "VoidResultAlways", Results = {
		{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_MERITOCRACY_GAIN", 7), ""},
	}}}})
	if actionID == -1 then
		uiTab.Active = true;
		uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_41", iCity:GetName())
	else
		local outcomeID = 1;
		local iGovOption, gBonus = -1, -1;
		local cHelpCount = actionID;
		for a, b in pairs(extraData.Options) do
			if gT.Players[iPlayer].Governors[b[1]] then
				if cHelpCount == 1 then
					local gvName = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[b[1]].Name);
					iGovOption = b[1];
					gBonus = b[2];
					blog1 = ApplyGovernorBonusOnCityFound(iPlayer, gBonus, b[3], iCity, iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded());
					if blog1 then
						blog2 = 4 + b[3] * 2
						BoostGovernorPower(b[1], "New City", blog2, false)
						uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_41_ACTION_1", gvName)
					else
						uiTab.Actions[actionID].Outcomes[outcomeID].Results[1].Disabled = true;
						uiTab.Actions[actionID].Outcomes[outcomeID].Results[2].Disabled = true;
						uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_41_ACTION_1_FAIL", gvName)
					end
					break;
				else
					cHelpCount = cHelpCount - 1;
				end
			end
		end
		if iGovOption == -1 then
			ApplyGovernorBonusOnCityFound(iPlayer, -1, nil, nil, nil)
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_41_ACTION_2")
		end
		uiTab = PrepareResolveTabForUI(uiTab, actionID, outcomeID);
		table.insert(gT.Players[iPlayer].GovDiploLog, 1, {ID = selfID, Turn = GetITGGameTurn(), Action = actionID, Outcome = outcomeID, Data = {blog1, blog2, iGovOption, gBonus, iCity:Plot():GetPlotIndex()}})
	end
	return uiTab;
end
function GovActionResolve42(iPlayer, actionID, fIndex, selfID)
	local pIndex = fIndex or 1;
	local extraData = gT.Players[iPlayer].DiploNotes[pIndex].ExtraData;
	local iCity = Players[iPlayer]:GetCityByID(extraData.CityID);
	local blog1, blog2;
	if not iCity then
		return;
	end
	local uiTab = {Headline = Locale.Lookup(dgActions[selfID].Name), Actions = {}}
	local iCount = 1;
	for a, b in pairs(extraData.Options) do
		if gT.Players[iPlayer].Governors[b[1]] then
			local goverName = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[b[1]].Name);
			local hStr, hText;
			if b[2] == 1 then
				hStr = "Secure the conquest"
				hText = "City gains +" .. 50 + b[3] * 25 .. " max HP."
			elseif b[2] == 2 then
				hStr = "[ICON_ITG_MORALE] Announce victory"
				hText = "+" .. 2 + b[3] .. " [ICON_ITG_MORALE] Morale.";
			elseif b[2] == 3 then
				hStr = "[ICON_ITG_PRESENCE] Cultural Presence"
				hText = "City gains +" .. 20 + b[3] * 30 .. " [ICON_ITG_PRESENCE] Cultural Presence.";
			elseif b[2] == 4 then
				hStr = "[ICON_HAPPINESS_1] Reorganize population"
				hText = "City gains +" .. 5 + b[3] * 2 .. " [ICON_HAPPINESS_1] Happiness.";
			elseif b[2] == 5 then
				hStr = "[ICON_RESEARCH] Gather knowledge"
				hText = "+" .. 5 + b[3] .. "% chance for next Innovation.";
			elseif b[2] == 6 then
				local cityState = GetNearestCityStateToXY(iPlayer, iCity:GetX(), iCity:GetY(), true, false)
				hStr = "[ICON_INFLUENCE] Intimidate region"
				if cityState then
					hText = "+" .. 20 + 10 * b[3] .. " [ICON_INFLUENCE] Influence in the " .. Players[cityState]:GetName() .. "."
				else
					hText = "+" .. 20 + 10 * b[3] .. " [ICON_INFLUENCE] Influence in the nearest City-State."
				end
			elseif b[2] == 7 then
				hStr = "[ICON_GOLD] More looting"
				hText = "+" .. 100 + 50 * b[3] .. " [ICON_GOLD] Gold."
			elseif b[2] == 8 then
				hStr = "[ICON_WORKER] Enslave population"
				hText = "+" .. 100 + 50 * b[3] .. " [ICON_WORKER] Work Rate in all Cities."
			elseif b[2] == 9 then
				hStr = "[ICON_ITG_LEGAL_POWER] Recreate legislation"
				hText = "+" .. 0.4 + 0.1 * b[3] .. " [ICON_ITG_LEGAL_POWER] Legal Power."
			end
			table.insert(uiTab.Actions, {ID = iCount, Text = string.upper(goverName), Help = hStr, ToolTip = "", Outcomes = {
				{Text = "VoidResultAlways", Results = {
				{hText, ""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_GOVERNOR_POWER_GAIN", 3 + b[3]),""},
			}}}})
			iCount = iCount + 1;
		end
	end
	if iCount == 1 then
		return;
	end
	table.insert(uiTab.Actions, {ID = iCount, Text = "REWARD SOLDIERS", Help = "+5 [ICON_ITG_MERITOCRACY] Meritocracy", ToolTip = "", Outcomes = {
		{Text = "VoidResultAlways", Results = {
		{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_MERITOCRACY_GAIN", 5), ""},
	}}}})
	if actionID == -1 then
		uiTab.Active = true;
		uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_42", iCity:GetName())
	else
		local outcomeID = 1;
		local iGovOption, gBonus = -1, -1;
		local cHelpCount = actionID;
		for a, b in pairs(extraData.Options) do
			if gT.Players[iPlayer].Governors[b[1]] then
				if cHelpCount == 1 then
					local gvName = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[b[1]].Name);
					local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
					iGovOption = b[1];
					gBonus = b[2];
					local gLevel = b[3];
					blog1 = true;
					if gBonus == 1 then
						iCity:ChangeMaxHitPoints(50 + 25 * gLevel);		
					elseif gBonus == 2 then
						TakeCareOfEventMorale(iPlayer, 25, {2 + gLevel, "Satraps"})
					elseif gBonus == 3 then
						DoChangeCityCultureOwnership(cID, iCity, iPlayer, 20 + 30 * gLevel, "OnFoundedGov")
					elseif gBonus == 4 then
						ChangeITGHappinessInTheCity(iCity, 5 + 2 * gLevel, nil, "Satraps")
					elseif gBonus == 5 then
						gT.Players[iPlayer].NextInnoChance = gT.Players[iPlayer].NextInnoChance + 50 + 10 * gLevel;
					elseif gBonus == 6 then
						DoBoostNearestCityStateInfluence(iPlayer, iCity:GetX(), iCity:GetY(), 20 + 10 * gLevel, true, false)
					elseif gBonus == 7 then
						ChangeITGGold(iPlayer, 100 + 50 * gLevel)
					elseif gBonus == 8 then
						IncreaseWorkRateInAllCities(iPlayer, 100 + 50 * gLevel)
					elseif gBonus == 9 then
						ChangeITGLegalPointsPercent(iPlayer, 30 + 10 * gLevel)
					end
					if blog1 then
						blog2 = 3 + b[3]
						BoostGovernorPower(b[1], "Satraps", blog2, false)
						uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_42_ACTION_1", gvName)
					else
						uiTab.Actions[actionID].Outcomes[outcomeID].Results[1].Disabled = true;
						uiTab.Actions[actionID].Outcomes[outcomeID].Results[2].Disabled = true;
						uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_42_ACTION_1_FAIL", gvName)
					end
					break;
				else
					cHelpCount = cHelpCount - 1;
				end
			end
		end
		if iGovOption == -1 then
			ChangeMeritocracy(iPlayer, 5)
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_42_ACTION_2")
		end
		uiTab = PrepareResolveTabForUI(uiTab, actionID, outcomeID);
		table.insert(gT.Players[iPlayer].GovDiploLog, 1, {ID = selfID, Turn = GetITGGameTurn(), Action = actionID, Outcome = outcomeID, Data = {blog1, blog2, iGovOption, gBonus, iCity:Plot():GetPlotIndex()}})
	end
	return uiTab;
end

function GovActionResolve45(iPlayer, actionID, fIndex, selfID)
	local pIndex = fIndex or 1;
	local extraData = gT.Players[iPlayer].DiploNotes[pIndex].ExtraData;
	local blog1, blog2;
	local uiTab = {Headline = Locale.Lookup(dgActions[selfID].Name), Actions = {}}
	local iCount = 1;
	for a, b in pairs(extraData.Options) do
		if gT.Players[iPlayer].Governors[b[1]] then
			local goverName = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[b[1]].Name);
			local hStr, hText;
			if b[2] == 1 then
				hStr = "[ICON_ITG_ACADEMY_1] International"
				hText = "All active Academies gain +" .. 40 + b[3] * 20 .. " [ICON_ITG_ACADEMY_1] Prestige."
			elseif b[2] == 2 then
				hStr = "[ICON_WORKER] Community"
				hText = "+" .. 80 + 40 * b[3] .. " [ICON_WORKER] Work Rate in all Cities.";
			elseif b[2] == 3 then
				hStr = "[ICON_RESEARCH] Scientific"
				hText = "+" .. 150 + b[3] * 50 .. " [ICON_RESEARCH] Science.";
			elseif b[2] == 4 then
				hStr = "[ICON_CULTURE] Cultural"
				hText = "+" .. 150 + b[3] * 50 .. " [ICON_CULTURE] Culture.";
			elseif b[2] == 5 then
				hStr = "[ICON_ITG_ACADEMY_2] Progress"
				hText = "All active Academies gain +" .. 10 + b[3] * 10 .. " [ICON_ITG_ACADEMY_2] development."	
			elseif b[2] == 6 then
				hStr = "[ICON_GOLD] Economic";
				hText = "+" .. 150 + b[3] * 50 .. " [ICON_GOLD] Gold."
			elseif b[2] == 7 then
				hStr = "[ICON_VICTORY_SPACE] Futuristic"
				hText = "+" .. 4 + b[3] .. "% chance for next Innovation."
			end
			table.insert(uiTab.Actions, {ID = iCount, Text = string.upper(goverName), Help = hStr, ToolTip = "", Outcomes = {
				{Text = "VoidResultAlways", Results = {
				{hText, ""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_GOVERNOR_POWER_GAIN", 3 + b[3]),""},
			}}}})
			iCount = iCount + 1;
		end
	end
	if iCount == 1 then
		return;
	end
	table.insert(uiTab.Actions, {ID = iCount, Text = "REWARD SCIENTISTS", Help = "+5 [ICON_ITG_MERITOCRACY] Meritocracy.", ToolTip = "", Outcomes = {
		{Text = "VoidResultAlways", Results = {
		{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_MERITOCRACY_GAIN", 5), ""},
	}}}})
	if actionID == -1 then
		uiTab.Active = true;
		uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_45")
	else
		local outcomeID = 1;
		local iGovOption, gBonus = -1, -1;
		local cHelpCount = actionID;
		for a, b in pairs(extraData.Options) do
			if gT.Players[iPlayer].Governors[b[1]] then
				if cHelpCount == 1 then
					local gvName = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[b[1]].Name);
					iGovOption = b[1];
					gBonus = b[2];
					local gLevel = b[3];
					blog1 = true;
					if gBonus == 1 then
						for index, data in pairs(gT.Academies) do
							if data.Player == iPlayer then
								if IsAcademyActiveRightNow(index) then
									AddPrestigeToAcademy(index, 40 + 20 * gLevel, "Symposium")
								end
							end
						end
					elseif gBonus == 2 then
						IncreaseWorkRateInAllCities(iPlayer, 80 + 40 * gLevel);
					elseif gBonus == 3 then
						ChangeITGScience(iPlayer, 150 + 50 * gLevel)
					elseif gBonus == 4 then
						ChangeITGCulture(iPlayer, 150 + 50 * gLevel)
					elseif gBonus == 5 then
						for index, data in pairs(gT.Academies) do
							if data.Player == iPlayer then
								if IsAcademyActiveRightNow(index) then
									ChangeAcademyProgress(index, 10 + 10 * gLevel)
								end
							end
						end
					elseif gBonus == 6 then
						ChangeITGGold(iPlayer, 150 + 50 * gLevel)
					elseif gBonus == 7 then
						gT.Players[iPlayer].NextInnoChance = gT.Players[iPlayer].NextInnoChance + 40 + 10 * gLevel;
					end
					if blog1 then
						blog2 = 3 + b[3]
						BoostGovernorPower(b[1], "Symposium", blog2, false)
						uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_45_ACTION_1", gvName)
					else
						uiTab.Actions[actionID].Outcomes[outcomeID].Results[1].Disabled = true;
						uiTab.Actions[actionID].Outcomes[outcomeID].Results[2].Disabled = true;
						uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_45_ACTION_1_FAIL")
					end
					break;
				else
					cHelpCount = cHelpCount - 1;
				end
			end
		end
		if iGovOption == -1 then
			ChangeMeritocracy(iPlayer, 5)
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_45_ACTION_2")
		end
		uiTab = PrepareResolveTabForUI(uiTab, actionID, outcomeID);
		table.insert(gT.Players[iPlayer].GovDiploLog, 1, {ID = selfID, Turn = GetITGGameTurn(), Action = actionID, Outcome = outcomeID, Data = {blog1, blog2, iGovOption, gBonus}})
	end
	return uiTab;
end
function GovActionResolve46(iPlayer, actionID, fIndex, selfID)
	local pIndex = fIndex or 1;
	local extraData = gT.Players[iPlayer].DiploNotes[pIndex].ExtraData;
	local blog1, blog2;
	local uiTab = {Headline = Locale.Lookup(dgActions[selfID].Name), Actions = {}}
	local iCount = 1;
	for a, b in pairs(extraData.Options) do
		if gT.Players[iPlayer].Governors[b[1]] then
			local goverName = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[b[1]].Name);
			local hStr, hText;
			if b[2] == 1 then
				hStr = "[ICON_WORKER] Celebrations"
				hText = "All Cities convert their [ICON_WORKER] Work Rate into [ICON_HAPPINESS_1] Happiness (200:1)."
			elseif b[2] == 2 then
				hStr = "[ICON_CITIZEN] Terror"
				hText = "All Cities gain +5 [ICON_HAPPINESS_1] Happiness. Cities loose 1 [ICON_CITIZEN] Citizen (or [ICON_FOOD] Food stored)."
			elseif b[2] == 3 then
				hStr = "[ICON_ITG_MERITOCRACY] Corrupt"
				hText = "-20 [ICON_ITG_MERITOCRACY] Meritocracy. All Cities gain +6 [ICON_HAPPINESS_1] Happiness."
			elseif b[2] == 4 then
				hStr = "[ICON_CITY_STATE] Blame City-State"
				hText = "Loose [ICON_INFLUENCE] Influence with " .. Players[b[3]]:GetName() .. ". All Cities gain +1 [ICON_HAPPINESS_1] Happiness per 20 [ICON_INFLUENCE] Influence lost."
			elseif b[2] == 5 then
				hStr = "[ICON_GOLD] Free distribution"
				hText = "[ICON_GOLD] Gold is converted into empire-wide [ICON_HAPPINESS_1] Happiness (150:1)."
			elseif b[2] == 6 then
				hStr = "[ICON_RESISTANCE] Controlled Riots"
				hText = "All Cities gain +7 [ICON_HAPPINESS_1] Happiness and enter 2-3 turns of [ICON_RESISTANCE] Resistance."
			elseif b[2] == 7 then
				hStr = "[ICON_HAPPINESS_4] False Promises"
				hText = "All Cities gain +6 [ICON_HAPPINESS_1] Happiness. [ICON_HAPPINESS_4] Unhappiness chance is increased by 5% for the rest of the game."
			elseif b[2] == 8 then
				hStr = "[ICON_GREAT_ARTIST] Propaganda"
				hText = "[ICON_GREAT_ARTIST] Art points are converted into empire-wide [ICON_HAPPINESS_1] Happiness (100:1)."
			end
			table.insert(uiTab.Actions, {ID = iCount, Text = string.upper(goverName), Help = hStr, ToolTip = "", Outcomes = {
				{Text = "VoidResultAlways", Results = {
				{hText, ""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_GOVERNOR_POWER_GAIN", 10),""},
			}}}})
			iCount = iCount + 1;
		end
	end
	if iCount == 1 then
		return;
	end
	table.insert(uiTab.Actions, {ID = iCount, Text = "IGNORE SITUATION", Help = "", ToolTip = "", Outcomes = {
		{Text = "VoidResultAlways", Results = {
		{"Nothing happens.", ""},
	}}}})
	if actionID == -1 then
		uiTab.Active = true;
		uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_46")
	else
		local outcomeID = 1;
		local iGovOption, gBonus = -1, -1;
		local cHelpCount = actionID;
		for a, b in pairs(extraData.Options) do
			if gT.Players[iPlayer].Governors[b[1]] then
				if cHelpCount == 1 then
					local gvName = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[b[1]].Name);
					iGovOption = b[1];
					gBonus = b[2];
					blog2 = b[3];
					blog1 = true;
					if gBonus == 1 then
						blog1 = false;
						for iCity in Players[iPlayer]:Cities() do
							local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
							local hap = math.floor(gT.Cities[cID].WorkRate / 200);
							if hap > 0 then
								ChangeITGHappinessInTheCity(iCity, hap, nil, "GovAction46")
								MakeCitySpendWorkRate(iCity, iPlayer, hap * 200)
								blog1 = true;
							end
						end
					elseif gBonus == 2 then
						for iCity in Players[iPlayer]:Cities() do
							if iCity:GetPopulation() > 1 then
								iCity:ChangePopulation(-1, true)
							else
								iCity:SetFood(0)
							end
						end
						BoostHappinessInAllCities(iPlayer, 5)
					elseif gBonus == 3 then
						if GetMeritocracyAvailable(iPlayer) < 20 then
							blog1 = false;
						else
							ChangeMeritocracy(iPlayer, -20);
							BoostHappinessInAllCities(iPlayer, 6)
						end
					elseif gBonus == 4 then
						local hap = math.floor(Players[blog2]:GetMinorCivFriendshipWithMajor(iPlayer) / 20)
						if hap > 0 then
							Players[blog2]:ChangeMinorCivFriendshipWithMajor(iPlayer, -20 * hap)
							BoostHappinessInAllCities(iPlayer, hap)
						else
							blog1 = false;
						end
					elseif gBonus == 5 then
						local iHap = math.floor(Players[iPlayer]:GetGold() / 150)
						if iHap > 0 then
							SpendITGGold(iPlayer, iHap * 150, true)
							BoostHappinessInAllCities(iPlayer, iHap)
						else
							blog1 = false;
						end
					elseif gBonus == 6 then
						for iCity in Players[iPlayer]:Cities() do
							StartBasicResistance(iCity, iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded(), LastRandom(2,3), true)
						end
						BoostHappinessInAllCities(iPlayer, 7)
					elseif gBonus == 7 then
						BoostHappinessInAllCities(iPlayer, 6)
						gT.Players[iPlayer].UnhapIdeo12 = gT.Players[iPlayer].UnhapIdeo12 + 50;
					elseif gBonus == 8 then
						local hap = math.floor(gT.Players[iPlayer].GreatArtistPoints / 100);
						if hap > 0 then
							BoostArtisticPoints(iPlayer, -100 * hap, false)
							BoostHappinessInAllCities(iPlayer, hap)
						else
							blog1 = false;
						end
					end
					if blog1 then
						BoostGovernorPower(b[1], "For the People", 10, false)
						uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_46_ACTION_1", gvName)
					else
						for i = 1, 5 do
 							if uiTab.Actions[actionID].Outcomes[outcomeID].Results[i] then
								uiTab.Actions[actionID].Outcomes[outcomeID].Results[i].Disabled = true;
							end
						end
						uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_46_ACTION_1_FAIL")
					end
					break;
				else
					cHelpCount = cHelpCount - 1;
				end
			end
		end
		if iGovOption == -1 then
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_46_ACTION_2")
		end
		uiTab = PrepareResolveTabForUI(uiTab, actionID, outcomeID);
		table.insert(gT.Players[iPlayer].GovDiploLog, 1, {ID = selfID, Turn = GetITGGameTurn(), Action = actionID, Outcome = outcomeID, Data = {blog1, blog2, iGovOption, gBonus}})
	end
	return uiTab;
end
function GovActionResolve47(iPlayer, actionID, fIndex, selfID)
	local pIndex = fIndex or 1;
	local extraData = gT.Players[iPlayer].DiploNotes[pIndex].ExtraData;
	local blog1, blog2;
	local uiTab = {Headline = Locale.Lookup(dgActions[selfID].Name), Actions = {}}
	local iCount = 1;
	for a, b in pairs(extraData.Options) do
		if gT.Players[iPlayer].Governors[b[1]] then
			local goverName = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[b[1]].Name);
			local hStr, hText;
			if b[2] == 1 then
				hStr = "[ICON_HAPPINESS_1] Celebrations"
				hText = "+3 [ICON_HAPPINESS_1] Happiness in all Cities."
			elseif b[2] == 2 then
				hStr = "[ICON_PROPHET] Dispute"
				hText = "-5% [ICON_PROPHET] Heresy from local Theology."
			elseif b[2] == 3 then
				hStr = "[ICON_MISSIONARY] Proselytism"
				hText = "+8 [ICON_MISSIONARY] Missionaries."
			elseif b[2] == 4 then
				hStr = "[ICON_ITG_MORALE] Holy War"
				hText = "+6% [ICON_ITG_MORALE] Morale."
			elseif b[2] == 5 then
				hStr = "[ICON_ITG_LEGAL_POWER] Legislation"
				hText = "Enforce official religion in one allied City-State."
			elseif b[2] == 6 then
				hStr = "[ICON_GREAT_PEOPLE] Holy Spirit"
				hText = "+300 [ICON_GREAT_PEOPLE] Great People points."
			elseif b[2] == 7 then
				hStr = "[ICON_GREAT_ARTIST] Divine Inspiration"
				hText = "+400 [ICON_GREAT_ARTIST] Art points."
			elseif b[2] == 8 then
				hStr = "[ICON_ITG_PRESENCE] Religious Unity"
				hText = "+120 [ICON_ITG_PRESENCE] Cultural Presence in all Cities."
			end
			table.insert(uiTab.Actions, {ID = iCount, Text = string.upper(goverName), Help = hStr, ToolTip = "", Outcomes = {
				{Text = "VoidResultAlways", Results = {
				{hText, ""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_GOVERNOR_POWER_GAIN", 10),""},
			}}}})
			iCount = iCount + 1;
		end
	end
	if iCount == 1 then
		return;
	end
	table.insert(uiTab.Actions, {ID = iCount, Text = "PRAYER", Help = "+8 [ICON_ITG_MERITOCRACY] Meritocracy.", ToolTip = "", Outcomes = {
		{Text = "VoidResultAlways", Results = {
		{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_MERITOCRACY_GAIN", 8), ""},
	}}}})
	if actionID == -1 then
		uiTab.Active = true;
		uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_47")
	else
		local blog3;
		local outcomeID = 1;
		local iGovOption, gBonus = -1, -1;
		local cHelpCount = actionID;
		for a, b in pairs(extraData.Options) do
			if gT.Players[iPlayer].Governors[b[1]] then
				if cHelpCount == 1 then
					local gvName = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[b[1]].Name);
					iGovOption = b[1];
					gBonus = b[2];
					blog2 = b[3];
					blog1 = true;
					if gBonus == 1 then
						BoostHappinessInAllCities(iPlayer, 3)
					elseif gBonus == 2 then
						DoChangeLocalTheologyHeresy(iPlayer, -50)
					elseif gBonus == 3 then
						gT.Players[iPlayer].FreeMissioniares =  gT.Players[iPlayer].FreeMissioniares + 8;
					elseif gBonus == 4 then
						TakeCareOfEventMorale(iPlayer, 25, {6, "Gathering"})
					elseif gBonus == 5 then
						local tabOfCS = PreparedDataForEnforcingOfficialReligion(iPlayer).UniqueOptions
						if gT.Players[iPlayer].OfficialReligion and (#tabOfCS > 0) then
							blog3 = tabOfCS[LastRandom(1,#tabOfCS)].ID;
							SetOfficialReligion(blog3, gT.Players[iPlayer].OfficialReligion, iPlayer)
						else
							blog1 = false;
						end
					elseif gBonus == 6 then
						ChangeITGGreatPeopleCivilPoints(iPlayer, 300)
					elseif gBonus == 7 then
						BoostArtisticPoints(iPlayer, 400)
					elseif gBonus == 8 then
						AddCulturalPresenceInAllCities(iPlayer, iPlayer, 120)
					end
					if blog1 then
						BoostGovernorPower(b[1], "Gathering", 10, false)
						uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_47_ACTION_1", gvName)
					else
						for i = 1, 5 do
 							if uiTab.Actions[actionID].Outcomes[outcomeID].Results[i] then
								uiTab.Actions[actionID].Outcomes[outcomeID].Results[i].Disabled = true;
							end
						end
						uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_47_ACTION_1_FAIL")
					end
					break;
				else
					cHelpCount = cHelpCount - 1;
				end
			end
		end
		if iGovOption == -1 then
			ChangeMeritocracy(iPlayer, 8)
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_47_ACTION_2")
		end
		uiTab = PrepareResolveTabForUI(uiTab, actionID, outcomeID);
		table.insert(gT.Players[iPlayer].GovDiploLog, 1, {ID = selfID, Turn = GetITGGameTurn(), Action = actionID, Outcome = outcomeID, Data = {blog1, blog2, iGovOption, gBonus, blog3}})
	end
	return uiTab;
end
function GovActionResolve34(iPlayer, actionID, fIndex, selfID)
	local pIndex = fIndex or 1;
	local extraData = gT.Players[iPlayer].DiploNotes[pIndex].ExtraData;
	local numPrinciples = GetNumGovSlotsFilled(iPlayer);
	local afRevoltSlots = math.max(math.min(numPrinciples - 1, math.ceil(numPrinciples * 0.4)),0)
	local uiTab = {Headline = Locale.Lookup(dgActions[selfID].Name), Actions = {}}
	local blog1, blog2;
	local bChoosable = (#extraData[1] > 1)
	for i, gdata in pairs(extraData[1]) do
		if gdata.Old then
			local hStr = "Reestablishment"
			local goverName = CallDataFromGovTab(gdata.Gov, "Name");
			if #gdata.Support > 0 then
				hStr = hStr .. "[NEWLINE]Supported by:"
				for a, govID in pairs(gdata.Support) do
					hStr = hStr .. "[NEWLINE][ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name)
				end
			end
			table.insert(uiTab.Actions, {ID = i, Text = string.upper(goverName), Help = hStr, ToolTip = "", Outcomes = {
				{Text = "VoidResultAlways", Results = {
				{"Reestablishes " .. goverName .. " (with " .. numPrinciples .. " current principles).", ""},
				{"Boosts [ICON_ITG_MERITOCRACY] Meritocracy by 40% missing.", ""},
			}}}})
			if bChoosable then
				table.insert(uiTab.Actions[i].Outcomes[1].Results, {"+10 [ICON_ITG_POWER] Power for every [ICON_ITG_GOVERNOR] Governor that supports this option.",""})
			end
		else
			local hStr = "Revolution"
			local goverName = CallDataFromGovTab(gdata.Gov, "Name");
			if #gdata.Support > 0 then
				hStr = hStr .. "[NEWLINE]Supported by:"
				for a, govID in pairs(gdata.Support) do
					hStr = hStr .. "[NEWLINE][ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name)
				end
			end
			table.insert(uiTab.Actions, {ID = i, Text = string.upper(goverName), Help = hStr, ToolTip = "", Outcomes = {
				{Text = "VoidResultAlways", Results = {
				{"Establishes " .. goverName .. " (with " .. afRevoltSlots .. " random principles).", ""},
				{"Boosts [ICON_ITG_MERITOCRACY] Meritocracy by 80% missing.", ""},
				{"+30 [ICON_ITG_POWER] Power for every [ICON_ITG_GOVERNOR] Governor that supports this option.",""},
			}}}})
		end
	end
	if actionID == -1 then
		uiTab.Active = true;
		uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_34")
	else
		local outcomeID = 1;
		local goverment = extraData[1][actionID].Gov;
		local goverName = CallDataFromGovTab(goverment, "Name");
		blog1 = extraData[1][actionID].Old
		if blog1 then
			ChooseNewGoverment(iPlayer, goverment)
			if bChoosable then
				for jij, sGovID in pairs(extraData[1][actionID].Support) do
					BoostGovernorPower(sGovID, "Centralize Power", 10, false)
				end
			end
			local boost = math.floor((100 - gT.Players[iPlayer].MeritocracyLevel) * 0.4);
			if boost > 0 then
				ChangeMeritocracy(iPlayer, boost)
			end
			uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_34_BACK", goverName)
		else
			DoRevolution(iPlayer, goverment, afRevoltSlots)
			local boost = math.floor((100 - gT.Players[iPlayer].MeritocracyLevel) * 0.8);
			if boost > 0 then
				ChangeMeritocracy(iPlayer, boost)
			end
			for jij, sGovID in pairs(extraData[1][actionID].Support) do
				BoostGovernorPower(sGovID, "Revolution", 30, false)
			end
			uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_34_NEW", goverName)
		end
		uiTab = PrepareResolveTabForUI(uiTab, actionID, outcomeID);
		table.insert(gT.Players[iPlayer].GovDiploLog, 1, {ID = selfID, Turn = GetITGGameTurn(), Action = actionID, Data = {blog1, blog2, goverment}})
	end
	return uiTab;
end
function GovActionResolve18(iPlayer, actionID, fIndex, selfID)
	local pIndex = fIndex or 1;
	local govID = gT.Players[iPlayer].DiploNotes[pIndex].Governor;
	local extraData = gT.Players[iPlayer].DiploNotes[pIndex].ExtraData;
	local iCity = Map.GetPlotByIndex(extraData[3]):GetPlotCity();
	if iCity:GetDamage() > 0 or (iCity:GetOwner() ~= iPlayer) then
		return;
	end
	if (not gT.Academies[extraData[1]].Active) or (not IsAcademyActiveRightNow(extraData[1])) or (gT.Academies[extraData[1]].SupportCD >= GetITGGameTurn()) then
		return;
	end
	local blog1, blog2;
	local uiTab = {GovID = govID, Headline = Locale.Lookup(dgActions[selfID].Name)}
	uiTab.Actions = {
		{ID = 1, Text = "ACCEPT", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{"Supports " .. GetNameOfDeparmentType(extraData[2], true) .. " of " .. gT.Academies[extraData[1]].Name .. ".",""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_GOVERNOR_POWER_GAIN", 10),""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_MERITOCRACY_GAIN", 1), ""},
				}}}
	}, 
	{ID = 2, Text = "REFUSE", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_GRUDGE",5,Locale.Lookup(GetGrudgeData(4, "Name"))),GenerateNiceGrudgeTooltip(4, true)},
			}}}},
		{ID = 3, Text = "PREEMPTIVE ACTION", Help = "Support academy", ToolTip = "By supporting academy on your own you can make this diplomatic note no longer valid.", Disabled = true, Outcomes = {
		}},
	}
	if actionID == -1 then
		uiTab.Active = true;
		uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_18", gT.Academies[extraData[1]].Name, GetNameOfDeparmentType(extraData[2], true))
	else
		local outcomeID = 1;
		if actionID == 1 then
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_18_ACTION_1")
			DoSupportToAcademy(extraData[1], iPlayer, extraData[2], true)
			BoostGovernorPower(govID, "Actions", 10, false)
			ChangeMeritocracy(iPlayer, 1)
		elseif actionID == 2 then
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_18_ACTION_2")
			if GenerateChancedGrudge(govID, 4, 5) then
				blog2 = true;
			else
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[1].Disabled = true;
			end
			DoAutomaticAcademySupport(iPlayer, true) -- AUTOMATIC support will not support before we resolve this diplo note
		end
		uiTab = PrepareResolveTabForUI(uiTab, actionID, outcomeID);
		table.insert(gT.Players[iPlayer].GovDiploLog, 1, {ID = selfID, Turn = GetITGGameTurn(), GovID = govID, Action = actionID, Data = {blog1, blog2, extraData[1]}})
	end
	return uiTab;
end

function GovActionResolve22(iPlayer, actionID, fIndex, selfID)
	local pIndex = fIndex or 1;
	local govID = gT.Players[iPlayer].DiploNotes[pIndex].Governor;
	local extraData = gT.Players[iPlayer].DiploNotes[pIndex].ExtraData;
	local iCity = Map.GetPlotByIndex(extraData[1]):GetPlotCity();
	if not CanCityBeLegalizedNow(iPlayer, iCity) then
		return;
	end
	local blog1, blog2;
	local uiTab = {GovID = govID, Headline = Locale.Lookup(dgActions[selfID].Name)}
	uiTab.Actions = {
		{ID = 1, Text = "ACCEPT", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{"Legalize ownership of " .. iCity:GetName() .. ".","Note: upon city or [ICON_ITG_GOVERNOR] Governor loss the effect will be undone."},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_GOVERNOR_POWER_GAIN", 10),""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_MERITOCRACY_GAIN", "1-5"), ""},
				}}}
	}, 
	{ID = 2, Text = "REFUSE", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_GRUDGE",5,Locale.Lookup(GetGrudgeData(4, "Name"))),GenerateNiceGrudgeTooltip(4, true)},
			}}}},
		{ID = 3, Text = "PREEMPTIVE ACTION", Help = "Legalize ownership", ToolTip = "By legalizing ownership of the city with [ICON_ITG_LEGAL_POWER] Legal Power you can make this diplomatic note no longer valid.", Disabled = true, Outcomes = {
		}},
	}
	if actionID == -1 then
		uiTab.Active = true;
		uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_22", iCity:GetName())
	else
		local outcomeID = 1;
		if actionID == 1 then
			uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_22_ACTION_1", iCity:GetName())
			gT.Globals.Governors[govID].LegalCity = {extraData[1], iCity:GetOriginalOwner()};
			SetOriginalOwnerOfCityITG(iCity, iPlayer, "Governor")
			BoostGovernorPower(govID, "Actions", 10, false)
			local meritGain = LastRandom(1,5);
			uiTab.Actions[actionID].Outcomes[outcomeID].Results[3] = {Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_MERITOCRACY_GAIN", GetGovernorActionRNGTextSolved(1,5,meritGain,"[COLOR_POSITIVE_TEXT]")),""} 
			ChangeMeritocracy(iPlayer, meritGain)
		elseif actionID == 2 then
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_22_ACTION_2")
			if GenerateChancedGrudge(govID, 4, 5) then
				blog2 = true;
			else
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[1].Disabled = true;
			end
		end
		uiTab = PrepareResolveTabForUI(uiTab, actionID, outcomeID);
		table.insert(gT.Players[iPlayer].GovDiploLog, 1, {ID = selfID, Turn = GetITGGameTurn(), GovID = govID, Action = actionID, Outcome = outcomeID, Data = {blog1, blog2, extraData[1]}})
	end
	return uiTab;
end
function GovActionResolve44(iPlayer, actionID, fIndex, selfID)
	local pIndex = fIndex or 1;
	local govID = gT.Players[iPlayer].DiploNotes[pIndex].Governor;
	local extraData = gT.Players[iPlayer].DiploNotes[pIndex].ExtraData;
	local slotID = extraData[1];
	for a, b in pairs(gT.Players[iPlayer].NewHumanQueueActions) do
		if b.BonusType == "GovPrinciple" then
			return;
		end
	end
	if not CanHaveThisSlotRightNow(iPlayer, slotID) then
		return;
	end
	local blog1, blog2;
	local uiTab = {GovID = govID, Headline = Locale.Lookup(dgActions[selfID].Name)}
	uiTab.Actions = {
		{ID = 1, Text = "ACCEPT", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{"Adopts new Principle (#" .. slotID .. ").",Locale.Lookup(GetDataFromSlotType(nil, "Help", slotID))},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_GOVERNOR_POWER_GAIN", 15),""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_MERITOCRACY_GAIN", "10-20"), ""},
				}}}
		}, 
		{ID = 2, Text = "REFUSE", Help = "", ToolTip = "", 
			Outcomes = {{Text = "VoidResultAlways", Results = {
					{"No effects.",""},
				}}}},
		{ID = 3, Text = "PREEMPTIVE ACTION", Help = "Reform Goverment", ToolTip = "By filling Principle slot with [ICON_ITG_LEGAL_POWER] Legal Power you can make this diplomatic note no longer valid.", Disabled = true, Outcomes = {
		}},
	}
	if actionID == -1 then
		uiTab.Active = true;
		uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_44")
	else
		local outcomeID = 1;
		if actionID == 1 then
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_44_ACTION_1")
			PlayerRequestedFillingGovSlot(iPlayer, slotID)
			BoostGovernorPower(govID, "Actions", 15, false)
			local meritGain = LastRandom(10,20);
			uiTab.Actions[actionID].Outcomes[outcomeID].Results[3] = {Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_MERITOCRACY_GAIN", GetGovernorActionRNGTextSolved(10,20,meritGain,"[COLOR_POSITIVE_TEXT]")),""} 
			ChangeMeritocracy(iPlayer, meritGain)
		elseif actionID == 2 then
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_44_ACTION_2")
		end
		uiTab = PrepareResolveTabForUI(uiTab, actionID, outcomeID);
		table.insert(gT.Players[iPlayer].GovDiploLog, 1, {ID = selfID, Turn = GetITGGameTurn(), GovID = govID, Action = actionID, Outcome = outcomeID, Data = {blog1, blog2}})
	end
	return uiTab;
end

function GovActionResolve23(iPlayer, actionID, fIndex, selfID)
	local pIndex = fIndex or 1;
	local govID = gT.Players[iPlayer].DiploNotes[pIndex].Governor;
	local extraData = gT.Players[iPlayer].DiploNotes[pIndex].ExtraData;
	local blog1, blog2;
	local uiTab = {GovID = govID, Headline = Locale.Lookup(dgActions[selfID].Name)}
	uiTab.Actions = {
		{ID = 1, Text = "ACCEPT", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{"[ICON_ITG_GOVERNOR] Governor will provide +4 [ICON_ITG_SUPPLY] Unit Supply and earn +1 extra [ICON_ITG_POWER] Power each turn.",""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_GOVERNOR_POWER_GAIN", 5),""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_MERITOCRACY_GAIN", "1-5"), ""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_MORALE_BOOST","1-3"),""},
				}}}
	}, 
	{ID = 2, Text = "REFUSE", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_GRUDGE",5,Locale.Lookup(GetGrudgeData(4, "Name"))),GenerateNiceGrudgeTooltip(4, true)},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_CAUSE", 25, Locale.Lookup(GetGovCauseData(12, "Name"))),GenerateNiceCauseTooltip(12)},
		}}}}
	}
	if actionID == -1 then
		uiTab.Active = true;
		uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_23")
	else
		local outcomeID = 1;
		if actionID == 1 then
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_23_ACTION_1")
			gT.Globals.Governors[govID].Supply = 4;
			SupplyBaseValDirty(iPlayer)
			BoostGovernorPower(govID, "Actions", 5, false)
			local meritGain = LastRandom(1,5);
			local moraleGain = LastRandom(1,3);
			uiTab.Actions[actionID].Outcomes[outcomeID].Results[3] = {Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_MERITOCRACY_GAIN", GetGovernorActionRNGTextSolved(1,5,meritGain,"[COLOR_POSITIVE_TEXT]")),""} 
			uiTab.Actions[actionID].Outcomes[outcomeID].Results[4] = {Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_MORALE_BOOST", GetGovernorActionRNGTextSolved(1,3,moraleGain,"[COLOR_POSITIVE_TEXT]")),""} 
			ChangeMeritocracy(iPlayer, meritGain)
			TakeCareOfEventMorale(iPlayer, 25, {moraleGain, "Diplo Action"})
		elseif actionID == 2 then
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_23_ACTION_2")
			if LastChance(25) then
				NoteGovCausesBasicStack(iPlayer, 12)
				blog1 = true;
			else
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[2].Disabled = true;
			end
			if GenerateChancedGrudge(govID, 4, 5) then
				blog2 = true;
			else
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[1].Disabled = true;
			end
		end
		uiTab = PrepareResolveTabForUI(uiTab, actionID, outcomeID);
		table.insert(gT.Players[iPlayer].GovDiploLog, 1, {ID = selfID, Turn = GetITGGameTurn(), GovID = govID, Action = actionID, Outcome = outcomeID, Data = {blog1, blog2}})
	end
	return uiTab;
end
function GovActionResolve24(iPlayer, actionID, fIndex, selfID)
	local pIndex = fIndex or 1;
	local govID = gT.Players[iPlayer].DiploNotes[pIndex].Governor;
	local extraData = gT.Players[iPlayer].DiploNotes[pIndex].ExtraData;
	local blog1, blog2;
	local iClass = extraData[1];
	if not gT.Players[iPlayer].SpecialUUProgress[iClass] then
		return;
	end
	local cUnitType = Players[iPlayer]:GetPlayerUniqueUnit(iClass)
	local sName = Locale.Lookup(GameInfo.Units[cUnitType].Description);
	local uiTab = {GovID = govID, Headline = Locale.Lookup(dgActions[selfID].Name)}
	uiTab.Actions = {
		{ID = 1, Text = "ACCEPT", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{"+" .. extraData[2] .. " [ICON_ITG_SPECIALIZATION] points towards specialization for " .. sName .. ".",""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_GOVERNOR_POWER_GAIN", extraData[3]),""},
				}}}
	}, 
	{ID = 2, Text = "REFUSE", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_GRUDGE",5,Locale.Lookup(GetGrudgeData(4, "Name"))),GenerateNiceGrudgeTooltip(4, true)},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_CAUSE", 10, Locale.Lookup(GetGovCauseData(12, "Name"))),GenerateNiceCauseTooltip(12)},
		}}}}
	}
	if actionID == -1 then
		uiTab.Active = true;
		uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_24", sName)
	else
		local outcomeID = 1;
		if actionID == 1 then
			uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_24_ACTION_1", sName)
			gT.Players[iPlayer].SpecialUUProgress[iClass] = gT.Players[iPlayer].SpecialUUProgress[iClass] + extraData[2];
			BoostGovernorPower(govID, "Actions", extraData[3], false)
		elseif actionID == 2 then
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_24_ACTION_2")
			if LastChance(10) then
				NoteGovCausesBasicStack(iPlayer, 12)
				blog1 = true;
			else
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[2].Disabled = true;
			end
			if GenerateChancedGrudge(govID, 4, 5) then
				blog2 = true;
			else
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[1].Disabled = true;
			end
		end
		uiTab = PrepareResolveTabForUI(uiTab, actionID, outcomeID);
		table.insert(gT.Players[iPlayer].GovDiploLog, 1, {ID = selfID, Turn = GetITGGameTurn(), GovID = govID, Action = actionID, Outcome = outcomeID, Data = {blog1, blog2, extraData[1], extraData[2], extraData[3]}})
	end
	return uiTab;
end

function GetValidCityStateGovAction48(iPlayer)
	local iCapital = Players[iPlayer]:GetCapitalCity();
	if iCapital then
		local tab = {};
		local iHindex = GetCoastLandPassableAreaID(iCapital:Plot())
		local pTeam = Teams[Players[iPlayer]:GetTeam()];
		for g, h in pairs(gT.Players) do
			if Players[g]:IsMinorCiv() then
				if not pTeam:IsHasMet(Players[g]:GetTeam()) then
					local gCapital = Players[g]:GetCapitalCity();
					if gCapital then
						if GetCoastLandPassableAreaID(gCapital:Plot()) == iHindex then
							table.insert(tab, g)
						end
					end				
				end
			end
		end
		if #tab > 0 then
			return RandomFromTab(tab);
		end
	end
	return nil;
end

function GovActionResolve48(iPlayer, actionID, fIndex, selfID)
	local pIndex = fIndex or 1;
	local govID = gT.Players[iPlayer].DiploNotes[pIndex].Governor;
	local blog1, blog2;
	local iMinor = GetValidCityStateGovAction48(iPlayer)
	if not iMinor then
		return;
	end
	local uiTab = {GovID = govID, Headline = Locale.Lookup(dgActions[selfID].Name)}
	uiTab.Actions = {
		{ID = 1, Text = "ACCEPT", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{"Scouting expedition will be formed (meets an unknown City-State).",""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_GOVERNOR_POWER_GAIN", 12),""},
				}}}
	}, 
	{ID = 2, Text = "REFUSE", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_GRUDGE",5,Locale.Lookup(GetGrudgeData(4, "Name"))),GenerateNiceGrudgeTooltip(4, true)},
		}}}}
	}
	if actionID == -1 then
		uiTab.Active = true;
		uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_48")
	else
		local outcomeID = 1;
		if actionID == 1 then
			sName = Players[iMinor]:GetName();
			Teams[Players[iPlayer]:GetTeam()]:Meet(Players[iMinor]:GetTeam())
			DoSnowflakeReveal(Players[iPlayer]:GetTeam(), Players[iMinor]:GetCapitalCity():Plot(), 3, {100, 90, 70})
			DoDeferredFog(Players[iPlayer]:GetTeam())
			blog1 = iMinor;
			uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_48_ACTION_1", sName)
			BoostGovernorPower(govID, "Actions", 12, false)
		elseif actionID == 2 then
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_48_ACTION_2")
			if GenerateChancedGrudge(govID, 4, 5) then
				blog2 = true;
			else
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[1].Disabled = true;
			end
		end
		uiTab = PrepareResolveTabForUI(uiTab, actionID, outcomeID);
		table.insert(gT.Players[iPlayer].GovDiploLog, 1, {ID = selfID, Turn = GetITGGameTurn(), GovID = govID, Action = actionID, Outcome = outcomeID, Data = {blog1, blog2}})
	end
	return uiTab;
end
function GovActionResolve25(iPlayer, actionID, fIndex, selfID)
	local pIndex = fIndex or 1;
	local govID = gT.Players[iPlayer].DiploNotes[pIndex].Governor;
	local extraData = gT.Players[iPlayer].DiploNotes[pIndex].ExtraData;
	local blog1, blog2;
	local iCity = Map.GetPlotByIndex(extraData[2]):GetPlotCity();
	if (iCity:GetOwner() ~= iPlayer) or (not IsValidBuildingToBeGivenToCity(iCity, extraData[1])) then
		return
	end
	local sName = Locale.Lookup(GameInfo.Buildings[extraData[1]].Description)
	local uiTab = {GovID = govID, Headline = Locale.Lookup(dgActions[selfID].Name)}
	uiTab.Actions = {
		{ID = 1, Text = "ACCEPT", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{sName .. " appears in " .. iCity:GetName() .. ".",""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_GOVERNOR_POWER_GAIN", 8),""},
				}}}
	}, 
	{ID = 2, Text = "REFUSE", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_GRUDGE",5,Locale.Lookup(GetGrudgeData(4, "Name"))),GenerateNiceGrudgeTooltip(4, true)},
		}}}},
		{ID = 3, Text = "PREEMPTIVE ACTION", Help = "Purchase building", ToolTip = "By purchasing building yourself you can make this diplomatic note no longer valid.", Disabled = true, Outcomes = {
		}},
	}
	if actionID == -1 then
		uiTab.Active = true;
		uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_25", sName, iCity:GetName())
	else
		local outcomeID = 1;
		if actionID == 1 then
			uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_25_ACTION_1", sName, iCity:GetName())
			iCity:SetNumRealBuilding(extraData[1], 1)
			BoostGovernorPower(govID, "Actions", 8, false)
		elseif actionID == 2 then
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_25_ACTION_2")
			if GenerateChancedGrudge(govID, 4, 5) then
				blog2 = true;
			else
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[1].Disabled = true;
			end
		end
		uiTab = PrepareResolveTabForUI(uiTab, actionID, outcomeID);
		table.insert(gT.Players[iPlayer].GovDiploLog, 1, {ID = selfID, Turn = GetITGGameTurn(), GovID = govID, Action = actionID, Outcome = outcomeID, Data = {blog1, blog2, extraData[1], extraData[2]}})
	end
	return uiTab;
end

function GetGovExecutionChances(iPlayer, govPower, intrigueV, govMod, govID)
	local utah = govPower * govMod;
	utah = utah + 25 * (gT.Players[iPlayer].GovCauses[13] or 0)
	if GovHasSignificantPosition(govID) then
		utah = utah + 150;
	end
	utah = math.max(math.floor(utah), 50)
	local exec = math.max(500, 1000 - utah);
	utah = AffectGovOutcomeWithVisibility(utah, intrigueV, false, govID)
	if gT.Globals.Governors[govID].GrowWary then
		exec = math.min(math.max(1, math.floor(exec/2)), 4 * utah);
	end
	return exec, utah;
end
function GovActionResolve39(iPlayer, actionID, fIndex, selfID)
	local pIndex = fIndex or 1;
	local govID = gT.Players[iPlayer].DiploNotes[pIndex].Governor;
	local sGovID = gT.Players[iPlayer].DiploNotes[pIndex].ExtraData[1];
	if not gT.Players[iPlayer].Governors[sGovID] then
		return;
	end
	local govPower = gT.Players[iPlayer].DiploNotes[pIndex].GovernorPower;
	local sGovPower = gT.Players[iPlayer].DiploNotes[pIndex].ExtraData[2];
	local intrigueV = gT.Players[iPlayer].DiploNotes[pIndex].Intrigue;
	local blog1, blog2;
	local govName = Locale.Lookup(gT.Globals.Governors[govID].Name);
	local sGovName = Locale.Lookup(gT.Globals.Governors[sGovID].Name);
	local uiTab = {GovID = govID, Headline = Locale.Lookup(dgActions[selfID].Name)}
	local a2o1c = AffectGovOutcomeWithVisibility(govPower, intrigueV, false, govID);
	local a2o2c = govPower * 2;
	local a2o3c = govPower * 2 + sGovPower * 2;
	local a2o4c = sGovPower * 2;
	local a2o5c = AffectGovOutcomeWithVisibility(sGovPower, intrigueV, false, sGovID);
	local a2tc = a2o1c + a2o2c + a2o3c + a2o4c + a2o5c;
	uiTab.Actions = {
		{ID = 1, Text = "[ICON_ITG_GOVERNOR]" .. string.upper(govName), Help = "(Support)", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
			{"Increases [ICON_ITG_POWER] Power of [ICON_ITG_GOVERNOR] " .. govName .. " by [COLOR_NEGATIVE_TEXT]10[ENDCOLOR].",""},
			{"Decreases [ICON_ITG_POWER] Power of [ICON_ITG_GOVERNOR] " .. sGovName .. " by [COLOR_POSITIVE_TEXT]30[ENDCOLOR].",""},
			{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_GRUDGE",33,Locale.Lookup(GetGrudgeData(7, "Name"))),GenerateNiceGrudgeTooltip(7, true)},
			}
		}}}, -- end of action 1
		{ID = 2, Text = "NEUTRALITY", Help = "(Ignore)", ToolTip = "",
		Outcomes = {
		{ID = 1, Text = "[ICON_PIRATE]" .. string.upper(sGovName), Help = math.floor(a2o1c / (a2tc) * 1000) / 10 .. "%", ToolTip = "", Results = {
			{"Increases [ICON_ITG_POWER] Power of [ICON_ITG_GOVERNOR] " .. govName .. " by [COLOR_NEGATIVE_TEXT]30[ENDCOLOR].",""},
			{"[ICON_ITG_GOVERNOR] " .. string.upper(sGovName) .. " is murdered.",""},
			{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_CAUSE", 10, Locale.Lookup(GetGovCauseData(14, "Name"))),GenerateNiceCauseTooltip(14)},
		}},
		{ID = 2, Text = "[ICON_ITG_GOVERNOR]" .. string.upper(govName), Help = math.floor(a2o2c / (a2tc) * 1000) / 10 .. "%", ToolTip = "", Results = {
			{"Increases [ICON_ITG_POWER] Power of [ICON_ITG_GOVERNOR] " .. govName .. " by [COLOR_NEGATIVE_TEXT]30[ENDCOLOR].",""},
			{"Decreases [ICON_ITG_POWER] Power of [ICON_ITG_GOVERNOR] " .. sGovName .. " by [COLOR_POSITIVE_TEXT]20[ENDCOLOR].",""},
		}},
		{ID = 3, Text = "STALEMATE", Help = math.floor(a2o3c / (a2tc) * 1000) / 10 .. "%", ToolTip = "", Results = {
			{"Nothing happens.", ""},
		}},
		{ID = 4, Text = "[ICON_ITG_GOVERNOR]" .. string.upper(sGovName), Help = math.floor(a2o4c / (a2tc) * 1000) / 10 .. "%", ToolTip = "", Results = {
			{"Increases [ICON_ITG_POWER] Power of [ICON_ITG_GOVERNOR] " .. sGovName .. " by [COLOR_NEGATIVE_TEXT]30[ENDCOLOR].",""},
			{"Decreases [ICON_ITG_POWER] Power of [ICON_ITG_GOVERNOR] " .. govName .. " by [COLOR_POSITIVE_TEXT]20[ENDCOLOR].",""},
		}},
		{ID = 5, Text = "[ICON_PIRATE]" .. string.upper(govName), Help = math.floor(a2o5c / (a2tc) * 1000) / 10 .. "%", ToolTip = "", Results = {
			{"Increases [ICON_ITG_POWER] Power of [ICON_ITG_GOVERNOR] " .. sGovName .. " by [COLOR_NEGATIVE_TEXT]30[ENDCOLOR].",""},
			{"[ICON_ITG_GOVERNOR] " .. string.upper(govName) .. " is murdered.",""},
			{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_CAUSE", 10, Locale.Lookup(GetGovCauseData(14, "Name"))),GenerateNiceCauseTooltip(14)},
		}},
		}}, -- end of action 2
		{ID = 3, Text = "[ICON_ITG_GOVERNOR]" .. string.upper(sGovName), Help = "(Support)", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
			{"Increases [ICON_ITG_POWER] Power of [ICON_ITG_GOVERNOR] " .. sGovName .. " by [COLOR_NEGATIVE_TEXT]10[ENDCOLOR].",""},
			{"Decreases [ICON_ITG_POWER] Power of [ICON_ITG_GOVERNOR] " .. govName .. " by [COLOR_POSITIVE_TEXT]30[ENDCOLOR].",""},
			{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_GRUDGE",33,Locale.Lookup(GetGrudgeData(7, "Name"))),GenerateNiceGrudgeTooltip(7, true)},
			}
		}}}, -- end of action 3
	}
	if actionID == -1 then
		uiTab.Active = true;
		uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_39", sGovName)
	else
		local outcomeID = 1;
		DoChangeRelationsBetweenGovs(govID, sGovID, -100, true)
		if actionID == 1 then
			BoostGovernorPower(govID, "Actions", 10, false)
			BoostGovernorPower(sGovID, "Punishment", -30, false)
			if GenerateChancedGrudge(sGovID, 7, 33) then
				blog2 = true;
			else
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[3].Disabled = true;
			end
			uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_39_ACTION_1", govName)
		elseif actionID == 2 then
			outcomeID = GetRandomFromBiasedChanceTable({{1,a2o1c}, {2, a2o2c}, {3, a2o3c}, {4, a2o4c}, {5, a2o5c}});
			if outcomeID == 1 then
				BoostGovernorPower(govID, "Conflict", 30, false)
				KillGovernor(sGovID, false)
				if LastRandom(1, 100) <= 10 then
					NoteGovCausesBasicStack(iPlayer, 14)
					blog2 = true;
				else
					uiTab.Actions[actionID].Outcomes[outcomeID].Results[3].Disabled = true;
				end
				uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_39_ACTION_2_OUTCOME_1", govName, sGovName)
			elseif outcomeID == 2 then
				BoostGovernorPower(govID, "Conflict", 30, false)
				BoostGovernorPower(sGovID, "Conflict", -20, false)
				uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_39_ACTION_2_OUTCOME_2", govName, sGovName)
			elseif outcomeID == 3 then
			-- nothing
				uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_39_ACTION_2_OUTCOME_3")
			elseif outcomeID == 4 then
				BoostGovernorPower(sGovID, "Conflict", 30, false)
				BoostGovernorPower(govID, "Conflict", -20, false)
				uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_39_ACTION_2_OUTCOME_2", sGovName, govName)
			elseif outcomeID == 5 then
				BoostGovernorPower(sGovID, "Conflict", 30, false)
				KillGovernor(govID, false)
				if LastRandom(1, 100) <= 10 then
					NoteGovCausesBasicStack(iPlayer, 14)
					blog2 = true;
				else
					uiTab.Actions[actionID].Outcomes[outcomeID].Results[3].Disabled = true;
				end
				uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_39_ACTION_2_OUTCOME_1", sGovName, govName)
			end
		elseif actionID == 3 then
			BoostGovernorPower(sGovID, "Actions", 10, false)
			BoostGovernorPower(govID, "Punishment", -30, false)
			if GenerateChancedGrudge(govID, 7, 33) then
				blog2 = true;
			else
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[3].Disabled = true;
			end
			uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_39_ACTION_1", sGovName)
		end
		uiTab = PrepareResolveTabForUI(uiTab, actionID, outcomeID);
		table.insert(gT.Players[iPlayer].GovDiploLog, 1, {ID = selfID, Turn = GetITGGameTurn(), GovID = govID, Action = actionID, Outcome = outcomeID, Data = {blog1, blog2, sGovID}})
	end
	return uiTab;
end
function GovActionResolve40(iPlayer, actionID, fIndex, selfID)
	local pIndex = fIndex or 1;
	if gT.Players[iPlayer].Goverment == 1 then
		return;
	end
	local govID = gT.Players[iPlayer].DiploNotes[pIndex].Governor;
	local extraData = gT.Players[iPlayer].DiploNotes[pIndex].ExtraData;
	local supPlayer = extraData[3];
	local intrigueV = gT.Players[iPlayer].DiploNotes[pIndex].Intrigue;
	local govPower = gT.Players[iPlayer].DiploNotes[pIndex].GovernorPower;
	local cityPlaced, cityPlacedTT, noPlaced, noPlacedTT = GetGovCitiesForAction(govID, iPlayer);
	local posString, posStringTT = GetStringFromGovPosition(extraData[2]);
	local goverName = CallDataFromGovTab(extraData[1], "Name");
	local numPrinciples = GetNumGovSlotsFilled(iPlayer);
	local afRevoltSlots = math.max(math.min(numPrinciples - 1, math.ceil(numPrinciples * 0.4)),0)
	local a3o1chance = AffectGovOutcomeWithVisibility(50, intrigueV, true, govID);
	local uiTab = {GovID = govID, Headline = Locale.Lookup(dgActions[selfID].Name)}
	uiTab.Actions = {
		{ID = 1, Text = "ALLOW IT", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
			{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_GOVERNOR_POWER_GAIN", "50"),""},
			{"[ICON_ITG_GOVERNOR] Governor becomes the " .. posString .. ".", posStringTT},
			{"Establishes " .. goverName .. " (with " .. afRevoltSlots .. " random principles).", ""},
			{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_CAUSE", 100, Locale.Lookup(GetGovCauseData(14, "Name"))),GenerateNiceCauseTooltip(14)},
			{"Boosts [ICON_ITG_MERITOCRACY] Meritocracy by 30% missing.", ""},
			}
		}}}, -- end of action 1
		{ID = 2, Text = "GATHER", Help = "(Defend)", ToolTip = "Every [ICON_ITG_GOVERNOR] Governor will choose side in this conflict.",
		Outcomes = {{ID = 1, Text = "VICTORY", Help= "", ToolTip = "Outcomes' chances are based on decisions of invidual [ICON_ITG_GOVERNOR] Governors. Displays chance if all [ICON_ITG_GOVERNOR] Governors are against you.", Results = {
			{"Leads to next diplomatic note.", "You will decide what to do with defiant [ICON_ITG_GOVERNOR] Governor."},
			{"Increases [ICON_ITG_POWER] Power of [ICON_ITG_GOVERNOR] Governors supporting you by [COLOR_NEGATIVE_TEXT]30[ENDCOLOR].", ""},
			{"[ICON_RESISTANCE] Riots start in all Cities governed by [ICON_ITG_GOVERNOR] Governors supporting the revolution.", cityPlacedTT},
		}},
		{ID = 2, Text = "STALEMATE", Help = "[COLOR_YELLOW]?%", ToolTip = "", Results = {
			{"Anarchy.",""},
			{"(20%) [ICON_RESISTANCE] Riots will start in any City.", ""},
			{"(20%) Rebels will spawn near any City.", ""},
			{Locale.Lookup("TXT_KEY_GOV_ACTION_GREW_WARY"), Locale.Lookup("TXT_KEY_GOV_ACTION_GREW_WARY_TT")},
			{"Foreign power declares war on you.", "This only happens if action was supported by foreign civilization."},
		}},
		{ID = 3, Text = "LOSS", Help = "", ToolTip = "Outcomes' chances are based on decisions of invidual [ICON_ITG_GOVERNOR] Governors. Displays chance if no other [ICON_ITG_GOVERNOR] Governor supports the revolution.", Results = {
			{"[ICON_ITG_GOVERNOR] Governor becomes the " .. posString .. ".", posStringTT},
			{"Establishes " .. goverName .. " (with " .. afRevoltSlots .. " random principles).", ""},
			{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_CAUSE", 10, Locale.Lookup(GetGovCauseData(14, "Name"))),GenerateNiceCauseTooltip(14)},
			{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_CAUSE", 100, Locale.Lookup(GetGovCauseData(16, "Name"))),GenerateNiceCauseTooltip(16)},
			{"Increases [ICON_ITG_POWER] Power of [ICON_ITG_GOVERNOR] Governors supporting revolution by [COLOR_NEGATIVE_TEXT]30[ENDCOLOR].", ""},
			{"Boosts [ICON_ITG_MERITOCRACY] Meritocracy by 30% missing.", ""},
		}},
		}}, -- end of action 2
		{ID = 3, Text = "ELEMINATE", Help = "Assassination attempt", ToolTip = "",
		Outcomes = {{ID = 1, Text = "SUCCESS", Help = "[COLOR_POSITIVE_TEXT]" .. a3o1chance / 10 .. "%", ToolTip = Locale.Lookup("TXT_KEY_GOV_OUTCOME_CHANCE_INCREASE_BY_VISIBILITY_VS_GOV"), Results = {
			{"[ICON_ITG_GOVERNOR] Governor dies.",""},
			{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_CAUSE", 50, Locale.Lookup(GetGovCauseData(13, "Name"))),GenerateNiceCauseTooltip(13)},
			{"Can lead to next diplomatic note.", "Another [ICON_ITG_GOVERNOR] Governor may carry on the revolution banner."},
		}},
		{ID = 2, Text = "FLEE", Help = "[COLOR_NEGATIVE_TEXT]?%", ToolTip = "", Results = {
			{"[ICON_ITG_GOVERNOR] Governor abandons you.","If action was supported by foreign power, [ICON_ITG_GOVERNOR] Governor will flee there."},
			DoTriggerGovernorTypeBadEffect(iPlayer, govID, govPower, true),
			{"(50%) Other [ICON_ITG_GOVERNOR] Governors supporting revolution may also leave the country.", ""},
		}},
		{ID = 3, Text = "REVOLT", Help = "[COLOR_NEGATIVE_TEXT]?%", ToolTip = "", Results = {
			{"Anarchy.",""},
			{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_PLAYER_POWER_REDUCTION",10),""},
			{"Foreign power declares war on you.", "This only happens if action was supported by foreign civilization."},
		}},
		{ID = 4, Text = "COUP", Help = "[COLOR_NEGATIVE_TEXT]?%", ToolTip = "", Results = {
			{"[ICON_ITG_GOVERNOR] Governor becomes the " .. posString .. ".", posStringTT},
			{"Establishes " .. goverName .. " (with " .. afRevoltSlots .. " random principles).", ""},
			{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_CAUSE", 100, Locale.Lookup(GetGovCauseData(16, "Name"))),GenerateNiceCauseTooltip(16)},
			{"Palaces in all Cities are damaged (-1 upgrade).", ""},
			{"Boosts [ICON_ITG_MERITOCRACY] Meritocracy by 30% missing.", ""},
		}},
		}}, -- end of action 3;
	}
	local playerPower = AffectGovOutcomeWithVisibility(GetPlayerGovernorPower(iPlayer), intrigueV, true);
	local totPower = 0;
	for shgov, h in pairs(gT.Players[iPlayer].Governors) do
		if shgov ~= govID then
			totPower = totPower + math.max(gT.Globals.Governors[shgov].Power, 1);
		end
	end
	if totPower == 0 then
		local tChances = govPower + playerPower + math.min(playerPower, govPower)
		uiTab.Actions[2].Outcomes[1].Help = "[COLOR_POSITIVE_TEXT]" .. math.floor(playerPower / tChances * 1000) / 10 .. "%"
		uiTab.Actions[2].Outcomes[2].Help = "[COLOR_YELLOW]" .. math.floor(math.min(playerPower, govPower) / tChances * 1000) / 10 .. "%"
		uiTab.Actions[2].Outcomes[3].Help = "[COLOR_NEGATIVE_TEXT]" .. math.floor(govPower / tChances * 1000) / 10 .. "%"
	else
		uiTab.Actions[2].Outcomes[1].Help = "[COLOR_POSITIVE_TEXT]" .. math.floor(playerPower / (playerPower + govPower + totPower + math.min(playerPower, govPower + totPower)) * 1000) / 10 .. "%"
		uiTab.Actions[2].Outcomes[3].Help = "[COLOR_NEGATIVE_TEXT]" .. math.floor(govPower / (playerPower + govPower + totPower + math.min(playerPower + totPower, govPower)) * 1000) / 10 .. "%"
	end
	if actionID == -1 then
		uiTab.Active = true;
		if extraData[3] then
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_40_ALT")
		else
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_40")
		end
	else
		local outcomeID = 1;
		local a2o1c, a2o3c = playerPower, govPower;
		local pgSupport = {};
		local ggSupport = {};
		local govName = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name);
		local hstrSupportPlayer = ""
		local hstrSupportRevolution = "[ICON_BULLET][ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name)
		for shgov, h in pairs(gT.Players[iPlayer].Governors) do
			if shgov ~= govID then
				if (gT.Globals.Governors[shgov].Goverment == extraData[1]) or ((gT.Globals.Governors[shgov].Goverment ~= gT.Players[iPlayer].Goverment) and DoesThirdGovernorSupportGovernorCause(shgov, iPlayer, govID)) then
					table.insert(ggSupport, shgov);
					a2o1c = a2o1c + math.max(gT.Globals.Governors[shgov].Power, 1);
					hstrSupportRevolution = hstrSupportRevolution .. "[NEWLINE][ICON_BULLET][ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[shgov].Name)
				else
					table.insert(pgSupport, shgov);
					a2o3c = a2o3c + math.max(gT.Globals.Governors[shgov].Power, 1);
					if hstrSupportPlayer ~= "" then
						hstrSupportPlayer = hstrSupportPlayer .. "[NEWLINE][ICON_BULLET]";
					end
					hstrSupportPlayer = hstrSupportPlayer .. "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[shgov].Name)
				end
			end
		end
		local bAnyGovSupportsPlayer = true;
		if hstrSupportPlayer == "" then
			hstrSupportPlayer = "[ICON_BULLET]None"
			bAnyGovSupportsPlayer = false;
		end
		if actionID == 1 then
			DoRevolution(iPlayer, extraData[1], afRevoltSlots)
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_40_ACTION_1")
			BoostGovernorPower(govID, "Revolution", 50, false)
			local boost = math.floor((100 - gT.Players[iPlayer].MeritocracyLevel) * 0.3);
			if boost > 0 then
				ChangeMeritocracy(iPlayer, boost)
			end
			gT.Globals.Governors[govID][extraData[2]] = true;
			NoteGovCausesBasicStack(iPlayer, 14)
			if supPlayer then
				ChangeITGLegalPointsPercent(supPlayer, 300, nil, "SupRev")
				Players[supPlayer]:AddNotification(81468343,"While " .. govName .. " successfully established " .. goverName .. " in " .. Players[iPlayer]:GetCivilizationShortDescription() .. " our support was not forgotten (+3 [ICON_ITG_LEGAL_POWER] Legal Power).","Revolution!",-1,-1, govID)
				table.insert(gT.Players[supPlayer].GovDiploLog, 1, {GovID = govID, ID = 1013, Turn = GetITGGameTurn(), Data = {iPlayer, 40, 1}})
			end
		elseif actionID == 2 then
		-- this conflict changes relations :)
			for ikkj, hhhgovID in pairs(pgSupport) do
				for jkkj, ggggovID in pairs(ggSupport) do
					DoChangeRelationsBetweenGovs(ggggovID, hhhgovID, -10, true)
				end
				DoChangeRelationsBetweenGovs(govID, hhhgovID, -10, true)
				for gtrer, uuugovID in pairs(pgSupport) do
					if uuugovID ~= hhhgovID then
						DoChangeRelationsBetweenGovs(uuugovID, hhhgovID, 10, true)
					end
				end
			end
			for jkkj, ggggovID in pairs(ggSupport) do
				DoChangeRelationsBetweenGovs(govID, ggggovID, 10, true)
				for gtrer, uuugovID in pairs(ggSupport) do
					if uuugovID ~= ggggovID then
						DoChangeRelationsBetweenGovs(ggggovID, uuugovID, 10, true)
					end
				end
			end
			
			local hToolTip = "Governors supporting you:[NEWLINE]" .. hstrSupportPlayer .. "[NEWLINE][NEWLINE]Governors supporting revolution:[NEWLINE]" .. hstrSupportRevolution
			local a2o2c = math.min(a2o1c, a2o3c)
			local hTpower = a2o1c + a2o2c + a2o3c;
			uiTab.Actions[actionID].Outcomes[1].Help = "[COLOR_POSITIVE_TEXT]" .. math.floor(a2o1c / hTpower * 1000) / 10 .. "%"
			uiTab.Actions[actionID].Outcomes[2].Help = "[COLOR_YELLOW]" .. math.floor(a2o2c / hTpower * 1000) / 10 .. "%"
			uiTab.Actions[actionID].Outcomes[3].Help = "[COLOR_NEGATIVE_TEXT]" .. math.floor(a2o3c / hTpower * 1000) / 10 .. "%"
			uiTab.Actions[actionID].Outcomes[1].ToolTip = hToolTip;
			uiTab.Actions[actionID].Outcomes[2].ToolTip = hToolTip;
			uiTab.Actions[actionID].Outcomes[3].ToolTip = hToolTip;
			outcomeID = GetRandomFromBiasedChanceTable({{1,a2o1c}, {2, a2o2c}, {3, a2o3c}});
			if outcomeID == 1 then
				for a, b in pairs(pgSupport) do
					BoostGovernorPower(b, "Actions", 30, false)
				end
				local tRG = {[govID] = true};
				for a, b in pairs(ggSupport) do
					tRG[b] = true;
				end
				local ha2o1r3tt = "This affected:"
				for iCity in Players[iPlayer]:Cities() do
					local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
					if gT.Cities[cID].Governor and tRG[gT.Cities[cID].Governor] then
						DoRiotsInCity(iPlayer, iCity, cID)
						ha2o1r3tt = ha2o1r3tt .. "[NEWLINE][ICON_BULLET]" .. iCity:GetName();
					end
				end
				if bAnyGovSupportsPlayer then
					uiTab.Actions[actionID].Outcomes[outcomeID].Results[2][2] = "This affected:[NEWLINE]" .. hstrSupportPlayer;
				else
					uiTab.Actions[actionID].Outcomes[outcomeID].Results[2].Disabled = true;
				end
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[3][2] = ha2o1r3tt;
				GenerateDiploNote(iPlayer, govID, 29, {40})
				GovernorDreamShatteredVengeanceNow(govID, iPlayer, selfID)
				uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_40_ACTION_2_OUTCOME_1")
			elseif outcomeID == 2 then
				if DoStartAnarchy(iPlayer, "GovernorRevolt") then	
					blog1 = true;
				else
					uiTab.Actions[actionID].Outcomes[outcomeID].Results[1].Disabled = true;
				end
				if supPlayer and (not Teams[Players[supPlayer]:GetTeam()]:IsAtWar(Players[iPlayer]:GetTeam())) then
					Teams[Players[supPlayer]:GetTeam()]:DeclareScriptedWar(Players[iPlayer]:GetTeam());
					Players[supPlayer]:AddNotification(81468343, govName .. " asks for our military intervention in order to establish " .. goverName .. " in " .. Players[iPlayer]:GetCivilizationShortDescription() .. ".","War!",-1,-1, govID)
					table.insert(gT.Players[supPlayer].GovDiploLog, 1, {GovID = govID, ID = 1013, Turn = GetITGGameTurn(), Data = {iPlayer, 40, 2}})
				else
					uiTab.Actions[actionID].Outcomes[outcomeID].Results[5].Disabled = true;
				end
				local bAnyRiots, bAnyRebels = false, false;
				local ha2o2r2tt = "This affected:"
				local ha2o2r3tt = "This affected:"
				for iCity in Players[iPlayer]:Cities() do
					if LastChance(20) then
						bAnyRiots = true;
						DoRiotsInCity(iPlayer, iCity, iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded())
						ha2o2r2tt = ha2o2r2tt .. "[NEWLINE][ICON_BULLET]" .. iCity:GetName();
					end
					if LastChance(20) then
						bAnyRebels = true;
						DoSpawnBarbarians(iCity, iPlayer, LastRandom(2,4), 63)
						ha2o2r3tt = ha2o2r3tt .. "[NEWLINE][ICON_BULLET]" .. iCity:GetName();
					end
				end
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[2].Disabled = not bAnyRiots;
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[3].Disabled = not bAnyRebels;
				if bAnyRiots then
					uiTab.Actions[actionID].Outcomes[outcomeID].Results[2][2] = ha2o2r2tt;
				end
				if bAnyRebels then
					uiTab.Actions[actionID].Outcomes[outcomeID].Results[3][2] = ha2o2r3tt;
				end
				gT.Globals.Governors[govID].GrowWary = true;
				GovernorDreamShatteredVengeanceNow(govID, iPlayer, selfID)
				uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_40_ACTION_2_OUTCOME_2")
			elseif outcomeID == 3 then
				DoRevolution(iPlayer, extraData[1], afRevoltSlots)
				gT.Globals.Governors[govID][extraData[2]] = true;
				if LastChance(10) then
					NoteGovCausesBasicStack(iPlayer, 14)
					blog1 = true;
				else
					uiTab.Actions[actionID].Outcomes[outcomeID].Results[3].Disabled = true;
				end
				BoostGovernorPower(govID, "Revolution", 30, false)	
				for a, b in pairs(ggSupport) do
					BoostGovernorPower(b, "Revolution", 30, false)
				end
				local boost = math.floor((100 - gT.Players[iPlayer].MeritocracyLevel) * 0.3);
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[5][2] = "This affected:[NEWLINE]" .. hstrSupportRevolution;
				if boost > 0 then
					ChangeMeritocracy(iPlayer, boost)
				end
				if supPlayer then
					ChangeITGLegalPointsPercent(supPlayer, 300, nil, "SupRev")
					Players[supPlayer]:AddNotification(81468343,"While " .. govName .. " successfully established " .. goverName .. " in " .. Players[iPlayer]:GetCivilizationShortDescription() .. " our support was not forgotten (+3 [ICON_ITG_LEGAL_POWER] Legal Power).","Revolution!",-1,-1, govID)
					table.insert(gT.Players[supPlayer].GovDiploLog, 1, {GovID = govID, ID = 1013, Turn = GetITGGameTurn(), Data = {iPlayer, 40, 1}})
				end
				NoteGovCausesBasicStack(iPlayer, 16)
				uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_40_ACTION_2_OUTCOME_3")
			end
		elseif actionID == 3 then
			if LastRandom(1,1000) > a3o1chance then
				outcomeID = GetRandomFromBiasedChanceTable({{2,20 - gT.Globals.Governors[govID].Character.Conflict - gT.Globals.Governors[govID].Character.Decisiveness}, {3, gT.Globals.Governors[govID].Character.Conflict + gT.Globals.Governors[govID].Character.Pettiness}, {4, gT.Globals.Governors[govID].Character.Conflict + gT.Globals.Governors[govID].Character.Decisiveness}});
			end
			if outcomeID == 1 then
				if LastChance(50) then
					NoteGovCausesBasicStack(iPlayer, 13)
					blog1 = true;
				else
					uiTab.Actions[actionID].Outcomes[outcomeID].Results[2].Disabled = true;
				end
				local fUpGov;
				for a, b in pairs(ggSupport) do
					if LastChance(50) then
						fUpGov = b;
					end
				end
				if fUpGov then
					GenerateDiploNote(iPlayer, fUpGov, 40, {extraData[1], extraData[2], govID})
				else
					uiTab.Actions[actionID].Outcomes[outcomeID].Results[3].Disabled = true;
				end
				KillGovernor(govID, true)
				uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_40_ACTION_3_OUTCOME_1")
			elseif outcomeID == 2 then
				if supPlayer then
					table.insert(gT.Players[supPlayer].GovDiploLog, 1, {GovID = govID, ID = 1013, Turn = GetITGGameTurn(), Data = {iPlayer, 40, 3}})
					Players[supPlayer]:AddNotification(81468343, govName .. " had failed to establish " .. goverName .. " in " .. Players[iPlayer]:GetCivilizationShortDescription() .. " and seeks asylum in our empire.","Exile!",-1,-1, govID)
					MakeGovernorChangePlayer(govID, supPlayer)
				else
					MakeGovernorChangePlayer(govID, -1)
				end
				blog1 = DoTriggerGovernorTypeBadEffect(iPlayer, govID, govPower, false)
				blog2 = false;
				local ha3o2r3tt = "This affected:"
				for a, b in pairs(ggSupport) do
					if LastChance(50) then
						MakeGovernorChangePlayer(b, -1)
						ha3o2r3tt = ha3o2r3tt .. "[NEWLINE][ICON_BULLET]" .. Locale.Lookup(gT.Globals.Governors[b].Name)
						blog2 = true;
					end
				end
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[2].Disabled = not blog1;
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[3].Disabled = not blog2;
				if blog2 then
					uiTab.Actions[actionID].Outcomes[outcomeID].Results[3][2] = ha3o2r3tt;
				end
				uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_40_ACTION_3_OUTCOME_2")
			elseif outcomeID == 3 then
				if DoStartAnarchy(iPlayer, "GovernorRevolt") then	
					blog1 = true;
				else
					uiTab.Actions[actionID].Outcomes[outcomeID].Results[1].Disabled = true;
				end
				if supPlayer and (not Teams[Players[supPlayer]:GetTeam()]:IsAtWar(Players[iPlayer]:GetTeam())) then
					Teams[Players[supPlayer]:GetTeam()]:DeclareScriptedWar(Players[iPlayer]:GetTeam());
					Players[supPlayer]:AddNotification(81468343, govName .. " asks for our military intervention in order to establish " .. goverName .. " in " .. Players[iPlayer]:GetCivilizationShortDescription() .. ".","War!",-1,-1, govID)
					table.insert(gT.Players[supPlayer].GovDiploLog, 1, {GovID = govID, ID = 1013, Turn = GetITGGameTurn(), Data = {iPlayer, 40, 2}})
				else
					uiTab.Actions[actionID].Outcomes[outcomeID].Results[3].Disabled = true;
				end
				BoostPlayerPower(iPlayer, "Revolt", -10)
				uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_40_ACTION_3_OUTCOME_3")
			elseif outcomeID == 4 then
				DoRevolution(iPlayer, extraData[1], afRevoltSlots)
				gT.Globals.Governors[govID][extraData[2]] = true;
				NoteGovCausesBasicStack(iPlayer, 16)
				for iCity in Players[iPlayer]:Cities() do
					local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
					if gT.Cities[cID].Palace then
						if gT.Cities[cID].Palace.NumUpgrades > 0 then
							RemoveUpgradeFromPalace(iCity, cID, iPlayer, GetRandomValidUpgradePalaceToRemove(cID))
							table.insert(gT.Cities[cID].PalaceLog, {GetITGGameTurn(), 9, govID})
						else
							DestroyPalaceInCity(iCity, cID, iPlayer, 8, govID)
						end
					end
				end
				local boost = math.floor((100 - gT.Players[iPlayer].MeritocracyLevel) * 0.3);
				if boost > 0 then
					ChangeMeritocracy(iPlayer, boost)
				end
				if supPlayer then
					ChangeITGLegalPointsPercent(supPlayer, 300, nil, "SupRev")
					Players[supPlayer]:AddNotification(81468343,"While " .. govName .. " successfully established " .. goverName .. " in " .. Players[iPlayer]:GetCivilizationShortDescription() .. " our support was not forgotten (+3 [ICON_ITG_LEGAL_POWER] Legal Power).","Revolution!",-1,-1, govID)
					table.insert(gT.Players[supPlayer].GovDiploLog, 1, {GovID = govID, ID = 1013, Turn = GetITGGameTurn(), Data = {iPlayer, 40, 1}})
				end
				uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_40_ACTION_3_OUTCOME_4")
			end
		end
		uiTab = PrepareResolveTabForUI(uiTab, actionID, outcomeID);
		table.insert(gT.Players[iPlayer].GovDiploLog, 1, {ID = selfID, Turn = GetITGGameTurn(), GovID = govID, Action = actionID, Outcome = outcomeID, Data = {blog1, blog2, extraData[1], extraData[2], extraData[3]}})
	end
	return uiTab;
end
function GovActionResolve38(iPlayer, actionID, fIndex, selfID)
	local pIndex = fIndex or 1;
	local govID = gT.Players[iPlayer].DiploNotes[pIndex].Governor;
	local extraData = gT.Players[iPlayer].DiploNotes[pIndex].ExtraData;
	local intrigueV = gT.Players[iPlayer].DiploNotes[pIndex].Intrigue;
	local govPower = gT.Players[iPlayer].DiploNotes[pIndex].GovernorPower;
	local a2o2anarchyChance = math.min(1000,math.max(35, math.floor(govPower * 4)))
	local blog1, blog2;
	local posString, posStringTT = GetStringFromGovPosition(extraData[1]);
	local cityPlaced, cityPlacedTT, noPlaced, noPlacedTT = GetGovCitiesForAction(govID, iPlayer);
	local uiTab = {GovID = govID, Headline = Locale.Lookup(dgActions[selfID].Name)}
	local extraUnits = math.max(2, math.min(5, govPower / 40))
	local iDMG = math.max(25, math.min(75, govPower / 3))
	local iResistance = math.max(2, math.min(4, govPower / 50))
	local iMilitShare = GetMilitarySharesGovernors(iPlayer, govID)
	local a3o2anarchyChance = math.max(10, math.floor(govPower * 1.5))
	local a3o2powerloss = math.ceil(govPower / 20);
	local unhapExec = math.ceil(govPower / 50);
	local a3o1chance, a3o2chance = GetGovExecutionChances(iPlayer, govPower, intrigueV, 1, govID)
	uiTab.Actions = {
		{ID = 1, Text = "ACCEPT", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
			{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_GOVERNOR_POWER_GAIN", "10"),""},
			{"[ICON_ITG_GOVERNOR] Governor becomes the " .. posString .. ".", posStringTT},
			}
		}}}, -- end of action 1
		{ID = 2, Text = "DENY", Help = "", ToolTip = "",
		Outcomes = {{ID = 1, Text = "BEND THE KNEE", Help="[COLOR_POSITIVE_TEXT]?%", ToolTip = Locale.Lookup("TXT_KEY_GOV_OUTCOME_CHANCE_RANDOM_GOVERNOR") .. "[NEWLINE][NEWLINE]" .. Locale.Lookup("TXT_KEY_GOV_OUTCOME_CHANCE_INCREASE_BY_VISIBILITY_VS_GOV"), Results = {
			{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_GRUDGE",50,Locale.Lookup(GetGrudgeData(6, "Name"))),GenerateNiceGrudgeTooltip(6, true)},
			{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_PLAYER_POWER_GAIN", "5-10"), ""},
		}},
		{ID = 2, Text = "OPEN CONFLICT", Help = "[COLOR_NEGATIVE_TEXT]?%", ToolTip = Locale.Lookup("TXT_KEY_GOV_OUTCOME_CHANCE_RANDOM_GOVERNOR"), Results = {
			{"([COLOR_NEGATIVE_TEXT]" .. a2o2anarchyChance / 10 .. "%[ENDCOLOR]) Anarchy.",""},
			{"[ICON_RESISTANCE] Riots start in all Cities governed by [ICON_ITG_GOVERNOR] Governor.", cityPlacedTT},
			{"Other [ICON_ITG_GOVERNOR] Governors may support the cause (cities under their governance will also [ICON_RESISTANCE] Riot).",""},
			{Locale.Lookup("TXT_KEY_GOV_ACTION_GREW_WARY"), Locale.Lookup("TXT_KEY_GOV_ACTION_GREW_WARY_TT")}, 
		}},
		{ID = 3, Text = "TREASON", Help = "[COLOR_NEGATIVE_TEXT]?%", ToolTip = "An alternative to Open Conflict. This can only happen if [ICON_ITG_GOVERNOR] Governor had already a Secret Pact with other player.", Results = {
			{"Cities under [ICON_ITG_GOVERNOR] Governor will receive " .. iDMG .. " DMG and enter " .. iResistance .. " turns of resistance.", cityPlacedTT},
			{"Every military unit will have " .. iMilitShare .. "% chance to take 25 non-lethal damage and become [ICON_DENOUNCE] Demoralized.", ""},
			{"[ICON_ITG_GOVERNOR] Governor abandons you."},
			{"Opponent declares war on you.", ""},
		}},
		}}, -- end of action 2
		{ID = 3, Text = "ELEMINATE", Help = "Death Penalty", ToolTip = "",
		Outcomes = {{ID = 1, Text = "EXECUTION", Help = "[COLOR_POSITIVE_TEXT]" .. math.floor(a3o1chance / (a3o1chance + a3o2chance) * 1000) / 10 .. "%", ToolTip = "", Results = {
			{"[ICON_ITG_GOVERNOR] Governor dies.",""},
			{"+" .. unhapExec .. " [ICON_HAPPINESS_4] Unhappiness in all Cities governed by [ICON_ITG_GOVERNOR] Governor.",cityPlacedTT},
			{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_CAUSE", 100, Locale.Lookup(GetGovCauseData(13, "Name"))),GenerateNiceCauseTooltip(13)},
			DoTriggerGovernorTypeBadEffect(iPlayer, govID, govPower, true),
		}},
		{ID = 2, Text = "ESCAPE", Help = "[COLOR_NEGATIVE_TEXT]" .. math.floor(a3o2chance / (a3o1chance + a3o2chance) * 1000) / 10 .. "%", ToolTip = Locale.Lookup("TXT_KEY_GOV_OUTCOME_CHANCE_REDUCE_BY_VISIBILITY_VS_GOV"), Results = {
			{"[ICON_ITG_GOVERNOR] Governor abandons you.",""},
			{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_PLAYER_POWER_REDUCTION",a3o2powerloss),""},
			{"[ICON_RESISTANCE] Riots start in all Cities governed by [ICON_ITG_GOVERNOR] Governor.", cityPlacedTT},
			{"([COLOR_NEGATIVE_TEXT]" .. a3o2anarchyChance / 10 .. "%[ENDCOLOR]) Anarchy.",""}
		}},
		}}, -- end of action 3;
	}

	if actionID == -1 then
		uiTab.Active = true;
		uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_38", posString)
	else
		local outcomeID = 1;
		if actionID == 1 then
			BoostGovernorPower(govID, "Nomination", 10, false)
			gT.Globals.Governors[govID][extraData[1]] = true;
			uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_38_ACTION_1", posString)
		elseif actionID == 2 then
			local a2o1c, a2o2c = GetBendTheKneeSituationChances(govID, iPlayer, govPower, intrigueV, 0, 25)
			outcomeID = GetRandomFromBiasedChanceTable({{1,a2o1c}, {2, a2o2c}});
			if outcomeID == 1 then
				if GenerateChancedGrudge(govID, 6, 50) then
					blog1 = true;
				else
					uiTab.Actions[actionID].Outcomes[outcomeID].Results[1].Disabled = true;
				end
				blog2 = LastRandom(5, 10);
				BoostPlayerPower(iPlayer, "Allegiance", blog2)
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[2] = {Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_PLAYER_POWER_GAIN", GetGovernorActionRNGTextSolved(5,10,blog2,"[COLOR_POSITIVE_TEXT]")),""} 
				uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_38_ACTION_2_OUTCOME_1")
				GovernorDreamShatteredVengeanceNow(govID, iPlayer, selfID)
			else
				local treasonPlayer = GetTreasonPlayerForGovernor(iPlayer, govID);
				if not treasonPlayer then
					blog2 = false;
					local tRG = {[govID] = true};
					for oGov, h in pairs(gT.Players[iPlayer].Governors) do
						if oGov ~= govID and DoesThirdGovernorSupportGovernorCause(oGov, iPlayer, govID) then
							blog2 = true;
							tRG[oGov] = true;
						end
					end
					for iCity in Players[iPlayer]:Cities() do
						local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
						if gT.Cities[cID].Governor and tRG[gT.Cities[cID].Governor] then
							DoRiotsInCity(iPlayer, iCity, cID)
						end
					end
					if not blog2 then
						uiTab.Actions[actionID].Outcomes[outcomeID].Results[3].Disabled = true;
					end
					gT.Globals.Governors[govID].GrowWary = true;
					if (LastRandom(1,1000) <= a2o2anarchyChance) and DoStartAnarchy(iPlayer, "GovernorRevolt") then	
						blog1 = true;
					else
						uiTab.Actions[actionID].Outcomes[outcomeID].Results[1].Disabled = true;
					end
					uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_38_ACTION_2_OUTCOME_2")
				else
					outcomeID = 3;
					blog1 = treasonPlayer;
					Players[treasonPlayer]:AddNotification(81468343,"[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. " made a move against " .. Players[iPlayer]:GetName() .. " starting a war (granted us " .. extraUnits .. " military units).","Secret Pact",-1,-1, govID)
					table.insert(gT.Players[treasonPlayer].GovDiploLog, 1, {GovID = govID, ID = 1009, Turn = GetITGGameTurn(), Data = {iPlayer}})
					DoBetrayalOfGovernor(govID, iPlayer, treasonPlayer, iDMG, iResistance, iMilitShare, extraUnits, false)
					Teams[Players[treasonPlayer]:GetTeam()]:DeclareWar(Players[iPlayer]:GetTeam())
					uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_38_ACTION_2_OUTCOME_3", Players[blog1]:GetCivilizationShortDescription())
				end
			end
		elseif actionID == 3 then
			outcomeID = GetRandomFromBiasedChanceTable({{1,a3o1chance}, {2, a3o2chance}});
			if outcomeID == 1 then
				NoteGovCausesBasicStack(iPlayer, 13)
				for i, iCity in pairs(cityPlaced) do
					ChangeITGHappinessInTheCity(iCity, -unhapExec, nil, "53gov")
				end
				blog1 = DoTriggerGovernorTypeBadEffect(iPlayer, govID, govPower, false)
				if not blog1 then
					uiTab.Actions[actionID].Outcomes[outcomeID].Results[4].Disabled = true;
				end
				KillGovernor(govID, true)
				uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_38_ACTION_3_OUTCOME_1")
			elseif outcomeID == 2 then
				for i, iCity in pairs(cityPlaced) do
					DoRiotsInCity(iPlayer, iCity, iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded())
				end
				if (LastRandom(1,1000) <= a3o2anarchyChance) and DoStartAnarchy(iPlayer, "GovernorRevolt") then
					blog1 = true;
				else
					uiTab.Actions[actionID].Outcomes[outcomeID].Results[4].Disabled = true;
				end
				BoostPlayerPower(iPlayer, "Failed Execution", -a3o2powerloss)
				MakeGovernorChangePlayer(govID, -1)
				uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_38_ACTION_3_OUTCOME_2")
			end
		end
		uiTab = PrepareResolveTabForUI(uiTab, actionID, outcomeID);
		table.insert(gT.Players[iPlayer].GovDiploLog, 1, {ID = selfID, Turn = GetITGGameTurn(), GovID = govID, Action = actionID, Outcome = outcomeID, Data = {blog1, blog2, extraData[1]}})
	end
	return uiTab;
end

function GovActionResolve26(iPlayer, actionID, fIndex, selfID)
	local pIndex = fIndex or 1;
	local govID = gT.Players[iPlayer].DiploNotes[pIndex].Governor;
	local extraData = gT.Players[iPlayer].DiploNotes[pIndex].ExtraData;
	local supPlayer = extraData[1];
	local intrigueV = gT.Players[iPlayer].DiploNotes[pIndex].Intrigue;
	local blog1, blog2;
	local nRel = gT.Globals.Governors[govID].CityReligion
	if not nRel then
		print("Big issue no gov religion for official one", iPlayer, govID, nRel)
		return;
	end
	if nRel == gT.Players[iPlayer].OfficialReligion then
		return;
	end
	local govPower = gT.Players[iPlayer].DiploNotes[pIndex].GovernorPower;
	local a1o1heresyChance = AffectGovOutcomeWithVisibility(50, intrigueV, false)
	local a2o2heresyChance = math.max(10, math.floor(govPower/ 4))
	local a2o2anarchyChance = math.max(10, math.floor(govPower/ 6))
	local a3o2anarchyChance = math.max(10, math.floor(govPower/ 3))
	local extraUnits = math.max(2, math.min(5, govPower / 40))
	local iDMG = math.max(25, math.min(75, govPower / 3))
	local iResistance = math.max(2, math.min(4, govPower / 50))
	local iMilitShare = GetMilitarySharesGovernors(iPlayer, govID)
	local a3o2powerloss = math.ceil(govPower / 20);
	local a3o1chance, a3o2chance = GetGovExecutionChances(iPlayer, govPower, intrigueV, 1, govID)
	local unhapExec = math.ceil(govPower / 50);
	local cityPlaced, cityPlacedTT, noPlaced, noPlacedTT = GetGovCitiesForAction(govID, iPlayer);
	local relIconName = GameInfo.Religions[nRel].IconString .. " " .. Locale.Lookup(GameInfo.Religions[nRel].Description);
	local uiTab = {GovID = govID, Headline = Locale.Lookup(dgActions[selfID].Name)}
	local hStrNumFollowers = "This affects:"
	for iCity in Players[iPlayer]:Cities() do
		local iRebels = math.min(3, iCity:GetNumFollowers(nRel))
		if iRebels > 0 then
			hStrNumFollowers = hStrNumFollowers .. "[NEWLINE][ICON_BULLET]" .. iCity:GetName() .. " (" .. iRebels .. ")";
		end
	end
	local posString, posStringTT = GetStringFromGovPosition("HighPriest");
	local uiTab = {GovID = govID, Headline = Locale.Lookup(dgActions[selfID].Name)}
	uiTab.Actions = {
		{ID = 1, Text = "SUPPORT", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{relIconName .. " becomes official religion.",""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_GOVERNOR_POWER_GAIN", "15-25"),""},
				{"[ICON_ITG_GOVERNOR] Governor becomes the High Priest.", posStringTT},
				{"Each City has [COLOR_NEGATIVE_TEXT]" .. a1o1heresyChance / 10 .. "%[ENDCOLOR] chance to spawn [ICON_PROPHET] Heretics.",Locale.Lookup("TXT_KEY_GOV_OUTCOME_CHANCE_REDUCE_BY_VISIBILITY")}
			}
		}}}, -- end of action 1
		{ID = 2, Text = "FORBID", Help = "", ToolTip = "",
		Outcomes = {{ID = 1, Text = "BEND THE KNEE", Help="[COLOR_POSITIVE_TEXT]?%", ToolTip = Locale.Lookup("TXT_KEY_GOV_OUTCOME_CHANCE_RANDOM_GOVERNOR") .. "[NEWLINE][NEWLINE]" .. Locale.Lookup("TXT_KEY_GOV_OUTCOME_CHANCE_INCREASE_BY_VISIBILITY_VS_GOV"), Results = {
			{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_GRUDGE",50,Locale.Lookup(GetGrudgeData(6, "Name"))),GenerateNiceGrudgeTooltip(6, true)},
			{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_PLAYER_POWER_GAIN", "5-10"), ""},
		}},
		{ID = 2, Text = "REVOLT", Help = "[COLOR_NEGATIVE_TEXT]?%", ToolTip = Locale.Lookup("TXT_KEY_GOV_OUTCOME_CHANCE_RANDOM_GOVERNOR"), Results = {
			{"[ICON_PROPHET] Heresy starts in all Cities governed by [ICON_ITG_GOVERNOR] Governor.", cityPlacedTT},
			{"Other Cities have [COLOR_NEGATIVE_TEXT]" .. a2o2heresyChance / 10 .. "%[ENDCOLOR] chance to spawn [ICON_PROPHET] Heretics.", noPlacedTT},
			{"([COLOR_NEGATIVE_TEXT]" .. a2o2anarchyChance / 10 .. "%[ENDCOLOR]) Anarchy.",""},
			{"[ICON_ITG_GOVERNOR] Governor abandons you.",""},
		}},
		{ID = 3, Text = "TREASON", Help = "[COLOR_NEGATIVE_TEXT]?%", ToolTip = "An alternative to Revolt. This can only happen if [ICON_ITG_GOVERNOR] Governor had already a Secret Pact with other player.", Results = {
			{"Cities under [ICON_ITG_GOVERNOR] Governor will receive " .. iDMG .. " DMG and enter " .. iResistance .. " turns of resistance.", cityPlacedTT},
			{"Every military unit will have " .. iMilitShare .. "% chance to take 25 non-lethal damage and become [ICON_DENOUNCE] Demoralized.", ""},
			{"[ICON_ITG_GOVERNOR] Governor abandons you.", ""},
			{"Opponent declares war on you.", ""},
		}},
		}}, -- end of action 2
		{ID = 3, Text = "CONDEMN", Help = "Death Penalty", ToolTip = "",
		Outcomes = {{ID = 1, Text = "EXECUTION", Help = "[COLOR_POSITIVE_TEXT]" .. math.floor(a3o1chance / (a3o1chance + a3o2chance) * 1000) / 10 .. "%", ToolTip = "", Results = {
			{"[ICON_ITG_GOVERNOR] Governor dies.",""},
			{"+" .. unhapExec .. " [ICON_HAPPINESS_4] Unhappiness in all Cities governed by [ICON_ITG_GOVERNOR] Governor.",cityPlacedTT},
			{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_CAUSE", 100, Locale.Lookup(GetGovCauseData(13, "Name"))),GenerateNiceCauseTooltip(13)},
			DoTriggerGovernorTypeBadEffect(iPlayer, govID, govPower, true), -- RESERVED FOR RESULT UNIQUE TO GOV TYPE;				
		}},
		{ID = 2, Text = "ESCAPE", Help = "[COLOR_NEGATIVE_TEXT]" .. math.floor(a3o2chance / (a3o1chance + a3o2chance) * 1000) / 10 .. "%", ToolTip = Locale.Lookup("TXT_KEY_GOV_OUTCOME_CHANCE_REDUCE_BY_VISIBILITY_VS_GOV"), Results = {
			{"[ICON_ITG_GOVERNOR] Governor abandons you.","If action was supported by foreign power, [ICON_ITG_GOVERNOR] Governor will flee there."},
			{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_PLAYER_POWER_REDUCTION",a3o2powerloss),""},
			{"[ICON_RESISTANCE] Riots start in all Cities governed by [ICON_ITG_GOVERNOR] Governor.", cityPlacedTT},
			{"Cities will spawn a rebel unit for each follower of " .. relIconName .. " (max 3).", hStrNumFollowers},
			{"([COLOR_NEGATIVE_TEXT]" .. a3o2anarchyChance / 10 .. "%[ENDCOLOR]) Anarchy.",""}
		}},
		}}, -- end of action 3;
	}
	if actionID == -1 then
		uiTab.Active = true;
		uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_26", relIconName)
	else
		local govName = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name);
		local outcomeID = 1;
		if actionID == 1 then
			SetOfficialReligion(iPlayer, nRel, iPlayer)
			blog1 = LastRandom(15,25);
			BoostGovernorPower(govID, "Nomination", blog1, false)
			uiTab.Actions[actionID].Outcomes[outcomeID].Results[2] = {Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_GOVERNOR_POWER_GAIN", GetGovernorActionRNGTextSolved(15,25,blog1,"[COLOR_NEGATIVE_TEXT]")),""} 
			gT.Globals.Governors[govID].HighPriest = true;
			blog2 = false;
			for iCity in Players[iPlayer]:Cities() do
				if LastRandom(1,1000) <= a1o1heresyChance then
					if DoHeresyOnRiots(iCity, iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded(), iPlayer, true) then
						blog2 = true;
					end
				end
			end
			if not blog2 then
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[4].Disabled = true;
			end
			if supPlayer then
				ChangeITGFaith(supPlayer, 300)
				Players[supPlayer]:AddNotification(81468343,"While " .. govName .. " successfully established " .. relIconName .. " as an official religion of " .. Players[iPlayer]:GetCivilizationShortDescription() .. " our support was not forgotten (+300 [ICON_PEACE] Faith).","Official religion!",-1,-1, govID)
				table.insert(gT.Players[supPlayer].GovDiploLog, 1, {GovID = govID, ID = 1013, Turn = GetITGGameTurn(), Data = {iPlayer, 26, 1}})
			end
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_26_ACTION_1")
		elseif actionID == 2 then
			local a2o1c, a2o2c = GetBendTheKneeSituationChances(govID, iPlayer, govPower, intrigueV, 0, 20)
			outcomeID = GetRandomFromBiasedChanceTable({{1,a2o1c}, {2, a2o2c}});
			if outcomeID == 1 then
				if GenerateChancedGrudge(govID, 6, 50) then
					blog1 = true;
				else
					uiTab.Actions[actionID].Outcomes[outcomeID].Results[1].Disabled = true;
				end
				blog2 = LastRandom(5, 10);
				BoostPlayerPower(iPlayer, "Allegiance", blog2)
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[2] = {Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_PLAYER_POWER_GAIN", GetGovernorActionRNGTextSolved(5,10,blog2,"[COLOR_POSITIVE_TEXT]")),""} 
				uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_26_ACTION_2_OUTCOME_1")
			else
				local treasonPlayer = supPlayer or GetTreasonPlayerForGovernor(iPlayer, govID);
				if not treasonPlayer then
					for i, iCity in pairs(cityPlaced) do
						DoHeresyOnRiots(iCity, iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded(), iPlayer, true)
					end
					for i, iCity in pairs(noPlaced) do
						if LastRandom(1,1000) <= a2o2anarchyChance then
							DoHeresyOnRiots(iCity, iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded(), iPlayer, true)
						end
					end
					if (LastRandom(1,1000) <= a2o2anarchyChance) and DoStartAnarchy(iPlayer, "GovernorRevolt") then	
						blog1 = true;
					else
						uiTab.Actions[actionID].Outcomes[outcomeID].Results[3].Disabled = true;
					end
					MakeGovernorChangePlayer(govID, -1)
					uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_26_ACTION_2_OUTCOME_2")
				else
					outcomeID = 3;
					blog1 = treasonPlayer;
					if supPlayer then
						Players[supPlayer]:AddNotification(81468343, govName .. " asks for our military intervention in order to establish " .. relIconName .. " as an official religion of " .. Players[iPlayer]:GetCivilizationShortDescription() .. " (granted us " .. extraUnits .. " military units).","Holy War!",-1,-1, govID)
						table.insert(gT.Players[supPlayer].GovDiploLog, 1, {GovID = govID, ID = 1013, Turn = GetITGGameTurn(), Data = {iPlayer, 26, 2}})
					else
						Players[treasonPlayer]:AddNotification(81468343, govName .. " made a move against " .. Players[iPlayer]:GetName() .. " starting a war (granted us " .. extraUnits .. " military units).","Secret Pact",-1,-1, govID)
						table.insert(gT.Players[treasonPlayer].GovDiploLog, 1, {GovID = govID, ID = 1009, Turn = GetITGGameTurn(), Data = {iPlayer}})
					end
					DoBetrayalOfGovernor(govID, iPlayer, treasonPlayer, iDMG, iResistance, iMilitShare, extraUnits, false)
					if not Teams[Players[treasonPlayer]:GetTeam()]:IsAtWar(Players[iPlayer]:GetTeam()) then
						if supPlayer then
							Teams[Players[treasonPlayer]:GetTeam()]:DeclareScriptedWar(Players[iPlayer]:GetTeam())
						else
							Teams[Players[treasonPlayer]:GetTeam()]:DeclareWar(Players[iPlayer]:GetTeam())
						end
					end
					uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_26_ACTION_2_OUTCOME_3", Players[blog1]:GetCivilizationShortDescription())
				end
			end
		elseif actionID == 3 then
			outcomeID = GetRandomFromBiasedChanceTable({{1,a3o1chance}, {2, a3o2chance}});
			if outcomeID == 1 then
				NoteGovCausesBasicStack(iPlayer, 13)
				for i, iCity in pairs(cityPlaced) do
					ChangeITGHappinessInTheCity(iCity, -unhapExec, nil, "53gov")
				end
				--unique gov type action
				blog1 = DoTriggerGovernorTypeBadEffect(iPlayer, govID, govPower, false)
				if not blog1 then
					uiTab.Actions[actionID].Outcomes[outcomeID].Results[4].Disabled = true;
				end
				KillGovernor(govID, true)
				uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_26_ACTION_3_OUTCOME_1")
			elseif outcomeID == 2 then
				for i, iCity in pairs(cityPlaced) do
					DoRiotsInCity(iPlayer, iCity, iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded())
				end
				for iCity in Players[iPlayer]:Cities() do
					local iRebels = math.min(3, iCity:GetNumFollowers(nRel))
					if iRebels > 0 then
						DoSpawnBarbarians(iCity, iPlayer, iRebels, 63)
					end
				end
				if (LastRandom(1,1000) <= a3o2anarchyChance) and DoStartAnarchy(iPlayer, "GovernorRevolt") then
					blog1 = true;
				else
					uiTab.Actions[actionID].Outcomes[outcomeID].Results[5].Disabled = true;
				end
				BoostPlayerPower(iPlayer, "Failed Execution", -a3o2powerloss)
				if supPlayer then
					table.insert(gT.Players[supPlayer].GovDiploLog, 1, {GovID = govID, ID = 1013, Turn = GetITGGameTurn(), Data = {iPlayer, 26, 3}})
					Players[supPlayer]:AddNotification(81468343, govName .. " had failed to establish " .. relIconName .. " as an official religion of " .. Players[iPlayer]:GetCivilizationShortDescription() .. " and seeks asylum in our empire.","Exile!",-1,-1, govID)
					MakeGovernorChangePlayer(govID, supPlayer)
				else
					MakeGovernorChangePlayer(govID, -1)
				end
				uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_26_ACTION_3_OUTCOME_2")
			end
		end
		uiTab = PrepareResolveTabForUI(uiTab, actionID, outcomeID);
		table.insert(gT.Players[iPlayer].GovDiploLog, 1, {ID = selfID, Turn = GetITGGameTurn(), GovID = govID, Action = actionID, Outcome = outcomeID, Data = {blog1, blog2, nRel, supPlayer}})
	end
	return uiTab;
end

function GovActionResolve27(iPlayer, actionID, fIndex, selfID)
	local pIndex = fIndex or 1;
	local govID = gT.Players[iPlayer].DiploNotes[pIndex].Governor;
	local extraData = gT.Players[iPlayer].DiploNotes[pIndex].ExtraData;
	local intrigueV = gT.Players[iPlayer].DiploNotes[pIndex].Intrigue;
	local blog1, blog2;
	local govPower = gT.Players[iPlayer].DiploNotes[pIndex].GovernorPower;
	local csPlayer = extraData[1];
	local giftCity = Map.GetPlotByIndex(extraData[2]):GetPlotCity();
	local csPlot = Map.GetPlotByIndex(extraData[3]);
	local supPlayer = extraData[4];
	if (giftCity:GetOwner() ~= iPlayer) then
		print("GovA27 giftCity wrong owner", iPlayer, govID, csPlayer, extraData[2], extraData[3], GetITGGameTurn())
		return;
	end
	if (csPlot:GetOwner() ~= csPlayer) then
		print("GovA27 csPlot wrong owner", iPlayer, govID, csPlayer, extraData[2], extraData[3], GetITGGameTurn())
		return;
	end
	if (Players[csPlayer]:GetNumCities() == 0) then
		print("GovA27 csPlayer no cities?!?", iPlayer, govID, csPlayer, extraData[2], extraData[3], GetITGGameTurn())
		return;
	end
	if gT.Players[csPlayer].GovAsLeader then
		print("GovA27 GovAsLeader", iPlayer, govID, csPlayer, extraData[2], extraData[3], GetITGGameTurn())
		return;
	end
	local csName = Players[csPlayer]:GetName();
	local cityName = giftCity:GetName();
	local infCS = Players[csPlayer]:GetMinorCivFriendshipWithMajor(iPlayer)
	local a3o1c, a3o2c = GetGovExecutionChances(iPlayer, govPower, intrigueV, 1, govID)
	local a1o1c = 500 + govPower + Players[csPlayer]:GetMinorCivFriendshipWithMajor(iPlayer)
	local a1o2c = AffectGovOutcomeWithVisibility(100, intrigueV, false)
	local a3o2nummilitaryunits = math.max(3, math.ceil(GetGovernorPowerForMilitaryShare(iPlayer, govID) / 25));
	local cityPlaced, cityPlacedTT, noPlaced, noPlacedTT = GetGovCitiesForAction(govID, iPlayer);
	local a3o2powerloss = math.ceil(govPower / 20);
	local title = GetITGPlayerTitle(csPlayer)
	local uiTab = {GovID = govID, Headline = Locale.Lookup(dgActions[selfID].Name)}
	uiTab.Actions = {
		{ID = 1, Text = "SUPPORT", Help = "", ToolTip = "", Outcomes = {
			{ID = 1, Text = "SUCCESS", Help = "[COLOR_POSITIVE_TEXT]" .. math.floor(a1o1c / (a1o1c + a1o2c) * 1000) / 10 .. "%", ToolTip = "", Results = {
				{"[ICON_ITG_GOVERNOR] Governor becomes leader of " .. csName .. ".", "[ICON_ITG_GOVERNOR] Governor leaves the service. City-States with leaders cannot be incorporated."},
				{"+200 [ICON_INFLUENCE] Influence with " .. csName .. ".", ""},
				{cityName .. " is gifted to " .. csName .. ".", "This also changes legal ownership of the city."},
			}},
			{ID = 2, Text = "FAILURE", Help = "[COLOR_NEGATIVE_TEXT]" .. math.floor(a1o2c / (a1o1c + a1o2c) * 1000) / 10 .. "%", ToolTip = Locale.Lookup("TXT_KEY_GOV_OUTCOME_CHANCE_REDUCE_BY_VISIBILITY"), Results = {
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_GOVERNOR_POWER_LOSS", 30),""},
				{"-30 [ICON_INFLUENCE] Influence with " .. csName .. ".", ""},
				{csName .. " declares war on you (with 20T peace block).",""},
			}},
		}},
		{ID = 2, Text = "FORBID", Help = "", ToolTip = "", Outcomes = {
			{ID = 1, Text = "BEND THE KNEE", Help = "[COLOR_POSITIVE_TEXT]?%", ToolTip = Locale.Lookup("TXT_KEY_GOV_OUTCOME_CHANCE_RANDOM_GOVERNOR") .. "[NEWLINE][NEWLINE]" .. Locale.Lookup("TXT_KEY_GOV_OUTCOME_CHANCE_INCREASE_BY_VISIBILITY_VS_GOV"), Results = {
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_GRUDGE",50,Locale.Lookup(GetGrudgeData(6, "Name"))),GenerateNiceGrudgeTooltip(6, true)},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_PLAYER_POWER_GAIN", "5-10"), ""},
			}},
			{ID = 2, Text = "OUTLAWRY", Help = "[COLOR_YELLOW]?%", ToolTip = Locale.Lookup("TXT_KEY_GOV_OUTCOME_CHANCE_RANDOM_GOVERNOR"), Results = {
				{"[ICON_ITG_GOVERNOR] Governor becomes leader of " .. csName .. " without your blessing.", "[ICON_ITG_GOVERNOR] Governor leaves the service. City-States with leaders cannot be incorporated."},
				{"-30 [ICON_INFLUENCE] Influence with " .. csName .. ".", ""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_PLAYER_POWER_REDUCTION",4),""},
			}},
			{ID = 3, Text = "TREASON", Help = "[COLOR_NEGATIVE_TEXT]?%", ToolTip = Locale.Lookup("TXT_KEY_GOV_OUTCOME_CHANCE_RANDOM_GOVERNOR"), Results = {
				{"[ICON_ITG_GOVERNOR] Governor becomes leader of " .. csName .. " without your blessing.", "[ICON_ITG_GOVERNOR] Governor leaves the service. City-States with leaders cannot be incorporated."},
				{"You loss any positive [ICON_INFLUENCE] Influence with " .. csName .. ".", "Currently: " .. infCS .. " [ICON_INFLUENCE]."},
				{csName .. " declares war on you (with 20T peace block).",""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_PLAYER_POWER_REDUCTION",8),""},
				{"Foreign power declares war on you.", "This only happens if action was supported by foreign civilization."},
			}},
		}},
		{ID = 3, Text = "CONDEMN", Help = "Death Penalty", ToolTip = "", Outcomes = {
			{ID = 1, Text = "EXECUTION", Help = "[COLOR_POSITIVE_TEXT]" .. math.floor(a3o1c / (a3o1c + a3o2c) * 1000) / 10 .. "%", ToolTip = "", Results = {
				{"[ICON_ITG_GOVERNOR] Governor dies.",""},
				{"-30 [ICON_INFLUENCE] Influence with " .. csName .. ".", ""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_CAUSE", 100, Locale.Lookup(GetGovCauseData(13, "Name"))),GenerateNiceCauseTooltip(13)},
				DoTriggerGovernorTypeBadEffect(iPlayer, govID, govPower, true),
			}},
			{ID = 2, Text = "ESCAPE", Help = "[COLOR_NEGATIVE_TEXT]" .. math.floor(a3o2c / (a3o1c + a3o2c) * 1000) / 10 .. "%", ToolTip = Locale.Lookup("TXT_KEY_GOV_OUTCOME_CHANCE_REDUCE_BY_VISIBILITY_VS_GOV"), Results = {
				{"[ICON_ITG_GOVERNOR] Governor flees to become a leader of " .. csName .. ".", "[ICON_ITG_GOVERNOR] Governor leaves the service. City-States with leaders cannot be incorporated."},
				{"You loss any positive [ICON_INFLUENCE] Influence with " .. csName .. ".", "Currently: " .. infCS .. " [ICON_INFLUENCE]."},
				{csName .. " declares war on you (with 20T peace block).",""},
				{a3o2nummilitaryunits .. " military units spawn for " .. csName .. ".","Amount of units is based on [ICON_ITG_GOVERNOR] Governor's [ICON_ITG_POWER] Power and control over military."},
				{"[ICON_RESISTANCE] Riots start in all Cities governed by [ICON_ITG_GOVERNOR] Governor.", cityPlacedTT},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_PLAYER_POWER_REDUCTION",a3o2powerloss),""},
				{"Foreign power declares war on you.", "This only happens if action was supported by foreign civilization."},
			}},
		}},
		{ID = 4, Text = "PREEMPTIVE ACTION", Help = "Conquer City-State", ToolTip = "If City-State mysteriously loose its capital then this diplomatic note will be no longer valid.", Disabled = true, Outcomes = {
		}},
	}
	
	if actionID == -1 then
		uiTab.Active = true;
		uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_27", csName, title)
	else
		local govName = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name);
		local outcomeID = 1;
		local csTeam = Players[csPlayer]:GetTeam();
		local iTeam = Players[iPlayer]:GetTeam();
		if actionID == 1 then
			outcomeID = GetRandomFromBiasedChanceTable({{1,a1o1c}, {2, a1o2c}});
			if outcomeID == 1 then
				Players[csPlayer]:ChangeMinorCivFriendshipWithMajor(iPlayer, 200)
				MakeGovernorChangePlayer(govID, -1)
				gT.Players[csPlayer].GovAsLeader = govID;
				gT.Globals.Governors[govID].CSLeader = csPlayer;
				Players[csPlayer]:AcquireCity(giftCity, false, true) -- first usage of acquirecity after game generation :Hmmm
				local ntCity = Map.GetPlotByIndex(extraData[2]):GetPlotCity(); --new city object, pretty sure
				if ntCity:GetOriginalOwner() ~= csPlayer then
					SetOriginalOwnerOfCityITG(ntCity, csPlayer, "GovernorCSKing")
				end
				if supPlayer then
					Players[csPlayer]:ChangeMinorCivFriendshipWithMajor(supPlayer, 60);
					Players[supPlayer]:AddNotification(81468343, govName .. " is a new leader of " .. csName .. "! Our support was not forgotten (+60 [ICON_INFLUENCE] Influence).","New Leader!",-1,-1, govID)
					table.insert(gT.Players[supPlayer].GovDiploLog, 1, {GovID = govID, ID = 1013, Turn = GetITGGameTurn(), Data = {iPlayer, 27, 1, csPlayer}})
				end
				uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_27_ACTION_1_OUTCOME_1", csName, title)
			elseif outcomeID == 2 then
				Players[csPlayer]:ChangeMinorCivFriendshipWithMajor(iPlayer, -30)
				BoostGovernorPower(govID, "Incompetence", -30, false)
				if not Teams[csTeam]:IsAtWar(iTeam) then
					Teams[csTeam]:DeclareScriptedWar(iTeam);
				end
				DoAddCounterTimePeaceLock(iPlayer, csPlayer, 20, "DiploAction")
				uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_27_ACTION_1_OUTCOME_2", csName)
			end
		elseif actionID == 2 then
			local a2o1c, a2o2c = GetBendTheKneeSituationChances(govID, iPlayer, govPower, intrigueV, 0, 20)
			outcomeID = GetRandomFromBiasedChanceTable({{1,a2o1c}, {2, a2o2c}});
			if outcomeID == 1 then
				if GenerateChancedGrudge(govID, 6, 50) then
					blog1 = true;
				else
					uiTab.Actions[actionID].Outcomes[outcomeID].Results[1].Disabled = true;
				end
				blog2 = LastRandom(5, 10);
				BoostPlayerPower(iPlayer, "Allegiance", blog2)
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[2] = {Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_PLAYER_POWER_GAIN", GetGovernorActionRNGTextSolved(5,10,blog2,"[COLOR_POSITIVE_TEXT]")),""} 
				uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_27_ACTION_2_OUTCOME_1")
				GovernorDreamShatteredVengeanceNow(govID, iPlayer, selfID)
			else
				local gOutCharacter, bOutCharacter = GetBasicGovernorCharacterBehaviour(govID)
				outcomeID = GetRandomFromBiasedChanceTable({{2,gOutCharacter}, {3, bOutCharacter}});
				if outcomeID == 2 then
					MakeGovernorChangePlayer(govID, -1)
					gT.Players[csPlayer].GovAsLeader = govID;
					gT.Globals.Governors[govID].CSLeader = csPlayer;
					Players[csPlayer]:ChangeMinorCivFriendshipWithMajor(iPlayer, -30);
					BoostPlayerPower(iPlayer, "Disobedience", -4)
					if supPlayer then
						Players[csPlayer]:ChangeMinorCivFriendshipWithMajor(supPlayer, 60);
						Players[supPlayer]:AddNotification(81468343, govName .. " is a new leader of " .. csName .. "! Our support was not forgotten (+60 [ICON_INFLUENCE] Influence).","New Leader!",-1,-1, govID)
						table.insert(gT.Players[supPlayer].GovDiploLog, 1, {GovID = govID, ID = 1013, Turn = GetITGGameTurn(), Data = {iPlayer, 27, 1, csPlayer}})
					end
					uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_27_ACTION_2_OUTCOME_2", csName)
				elseif outcomeID == 3 then
					if infCS > 0 then
						Players[csPlayer]:ChangeMinorCivFriendshipWithMajor(iPlayer, -infCS);
					end
					MakeGovernorChangePlayer(govID, -1)
					gT.Players[csPlayer].GovAsLeader = govID;
					gT.Globals.Governors[govID].CSLeader = csPlayer;
					BoostPlayerPower(iPlayer, "Treason", -8)
					if not Teams[csTeam]:IsAtWar(iTeam) then
						Teams[csTeam]:DeclareScriptedWar(iTeam);
					end	
					if supPlayer and (not Teams[Players[supPlayer]:GetTeam()]:IsAtWar(iTeam)) then
						Players[csPlayer]:ChangeMinorCivFriendshipWithMajor(supPlayer, 60);
						Teams[Players[supPlayer]:GetTeam()]:DeclareScriptedWar(iTeam);
						Players[supPlayer]:AddNotification(81468343, govName .. " asks for our military intervention in " .. Players[iPlayer]:GetCivilizationShortDescription() .. " to secure leadership of " .. csName .. " (+60[ICON_INFLUENCE]).","War!",-1,-1, govID)
						table.insert(gT.Players[supPlayer].GovDiploLog, 1, {GovID = govID, ID = 1013, Turn = GetITGGameTurn(), Data = {iPlayer, 27, 2, csPlayer}})
					else
						uiTab.Actions[actionID].Outcomes[outcomeID].Results[5].Disabled = true;
					end
					DoAddCounterTimePeaceLock(iPlayer, csPlayer, 20, "DiploAction")
					uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_27_ACTION_2_OUTCOME_3", csName)
				end
			end
		elseif actionID == 3 then
			outcomeID = GetRandomFromBiasedChanceTable({{1,a3o1c}, {2, a3o2c}});
			if outcomeID == 1 then
				NoteGovCausesBasicStack(iPlayer, 13)
				Players[csPlayer]:ChangeMinorCivFriendshipWithMajor(iPlayer, -30);
				blog1 = DoTriggerGovernorTypeBadEffect(iPlayer, govID, govPower, false)
				if not blog1 then
					uiTab.Actions[actionID].Outcomes[outcomeID].Results[4].Disabled = true;
				end
				KillGovernor(govID, true)
				uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_27_ACTION_3_OUTCOME_1", csName)
			elseif outcomeID == 2 then
				if infCS > 0 then
					Players[csPlayer]:ChangeMinorCivFriendshipWithMajor(iPlayer, -infCS);
				end
				for i, iCity in pairs(cityPlaced) do
					DoRiotsInCity(iPlayer, iCity, iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded())
				end
				BoostPlayerPower(iPlayer, "Failed Execution", -a3o2powerloss)
				MakeGovernorChangePlayer(govID, -1)
				gT.Players[csPlayer].GovAsLeader = govID;
				gT.Globals.Governors[govID].CSLeader = csPlayer;
				if not Teams[csTeam]:IsAtWar(iTeam) then
					Teams[csTeam]:DeclareScriptedWar(iTeam);
				end
				if supPlayer and (not Teams[Players[supPlayer]:GetTeam()]:IsAtWar(iTeam)) then
					Players[csPlayer]:ChangeMinorCivFriendshipWithMajor(supPlayer, 60);
					Teams[Players[supPlayer]:GetTeam()]:DeclareScriptedWar(iTeam);
					Players[supPlayer]:AddNotification(81468343, govName .. " asks for our military intervention in " .. Players[iPlayer]:GetCivilizationShortDescription() .. " to secure leadership of " .. csName .. " (+60[ICON_INFLUENCE]).","War!",-1,-1, govID)
					table.insert(gT.Players[supPlayer].GovDiploLog, 1, {GovID = govID, ID = 1013, Turn = GetITGGameTurn(), Data = {iPlayer, 27, 2, csPlayer}})
				else
					uiTab.Actions[actionID].Outcomes[outcomeID].Results[7].Disabled = true;
				end
				DoAddCounterTimePeaceLock(iPlayer, csPlayer, 20, "DiploAction")
				SpawnRandomUnitsAroundPlot(csPlayer, a3o2nummilitaryunits, csPlot)
				uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_27_ACTION_3_OUTCOME_2", csName)
			end
		end
		uiTab = PrepareResolveTabForUI(uiTab, actionID, outcomeID);
		table.insert(gT.Players[iPlayer].GovDiploLog, 1, {ID = selfID, Turn = GetITGGameTurn(), GovID = govID, Action = actionID, Outcome = outcomeID, Data = {blog1, blog2, csPlayer, extraData[2], supPlayer}})
	end
	return uiTab;
end
function GovActionResolve28(iPlayer, actionID, fIndex, selfID)
	local pIndex = fIndex or 1;
	local govID = gT.Players[iPlayer].DiploNotes[pIndex].Governor;
	local extraData = gT.Players[iPlayer].DiploNotes[pIndex].ExtraData;
	local intrigueV = gT.Players[iPlayer].DiploNotes[pIndex].Intrigue;
	local blog1, blog2;
	local govPower = gT.Players[iPlayer].DiploNotes[pIndex].GovernorPower;
	local tPlayer = extraData[1];
	local playerName = Players[tPlayer]:GetCivilizationShortDescription();
	if Players[tPlayer]:GetNumCities() == 0 then
		return;
	end
	if not Teams[Players[iPlayer]:GetTeam()]:CanDeclareWar(Players[tPlayer]:GetTeam()) then
		return;
	end
	if not gT.Globals.Governors[govID].City then
		return;
	end
	local a3o1c, a3o2c = GetGovExecutionChances(iPlayer, govPower, intrigueV, 1, govID)
	local a2o4moraledrop = -1 * math.max(4, math.ceil(govPower / 20));
	local extraUnits = math.max(2, math.ceil(govPower / 40));
	local a3o2powerloss = math.ceil(govPower / 20);
	local militaryshare = GetMilitarySharesGovernors(iPlayer, govID)
	local cityPlaced, cityPlacedTT, noPlaced, noPlacedTT = GetGovCitiesForAction(govID, iPlayer);
	local uiTab = {GovID = govID, Headline = Locale.Lookup(dgActions[selfID].Name)}
	uiTab.Actions = {
		{ID = 1, Text = "SUPPORT", Help = "", ToolTip = "", Outcomes = {
			{Text = "VoidResultAlways", Results = {
				{"We declare war on " .. playerName .. ".", ""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_MORALE_BOOST", 3),""},
				{"[ICON_ITG_GOVERNOR] Governor provides an extra " .. extraUnits .. " military units.", "They will spawn near the [ICON_ITG_GOVERNOR] Governor's location."},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_GOVERNOR_POWER_GAIN", 25),""},
			}},
		}},
		{ID = 2, Text = "FORBID", Help = "", ToolTip = "", Outcomes = {
			{ID = 1, Text = "BEND THE KNEE", Help = "[COLOR_POSITIVE_TEXT]?%", ToolTip = Locale.Lookup("TXT_KEY_GOV_OUTCOME_CHANCE_RANDOM_GOVERNOR") .. "[NEWLINE][NEWLINE]" .. Locale.Lookup("TXT_KEY_GOV_OUTCOME_CHANCE_INCREASE_BY_VISIBILITY_VS_GOV"), Results = {
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_GRUDGE",25,Locale.Lookup(GetGrudgeData(6, "Name"))),GenerateNiceGrudgeTooltip(6, true)},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_PLAYER_POWER_GAIN", "3-7"), ""},
			}},
			{ID = 2, Text = "INCIDENT", Help = "[COLOR_NEGATIVE_TEXT]?%", ToolTip = Locale.Lookup("TXT_KEY_GOV_OUTCOME_CHANCE_RANDOM_GOVERNOR"), Results = {
				{"[ICON_ITG_GOVERNOR] Governor declares war on " .. playerName .. ".", ""},
				{"Leads to next diplomatic note.", "You will decide what to do with defiant [ICON_ITG_GOVERNOR] Governor."},
			}},
			{ID = 3, Text = "DENUNCIATION", Help = "[COLOR_NEGATIVE_TEXT]?%", ToolTip = Locale.Lookup("TXT_KEY_GOV_OUTCOME_CHANCE_RANDOM_GOVERNOR"), Results = {
				{"[ICON_ITG_GOVERNOR] Governor abandons you.",""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_PLAYER_POWER_REDUCTION", 3), ""},
			}},
			{ID = 4, Text = "SUICIDE", Help = "[COLOR_NEGATIVE_TEXT]?%", ToolTip = Locale.Lookup("TXT_KEY_GOV_OUTCOME_CHANCE_RANDOM_GOVERNOR"), Results = {
				{"[ICON_ITG_GOVERNOR] Governor dies.",""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_MORALE_LOSS", a2o4moraledrop), ""},
			}},			
		}},
		{ID = 3, Text = "CONDEMN", Help = "Death Penalty", ToolTip = "", Outcomes = {
			{ID = 1, Text = "EXECUTION", Help = "[COLOR_POSITIVE_TEXT]" .. math.floor(a3o1c / (a3o1c + a3o2c) * 1000) / 10 .. "%", ToolTip = "", Results = {
				{"[ICON_ITG_GOVERNOR] Governor dies.",""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_CAUSE", 100, Locale.Lookup(GetGovCauseData(13, "Name"))),GenerateNiceCauseTooltip(13)},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_CAUSE", 50, Locale.Lookup(GetGovCauseData(12, "Name"))),GenerateNiceCauseTooltip(12)},
				DoTriggerGovernorTypeBadEffect(iPlayer, govID, govPower, true),
			}},
			{ID = 2, Text = "ESCAPE", Help = "[COLOR_NEGATIVE_TEXT]" .. math.floor(a3o2c / (a3o1c + a3o2c) * 1000) / 10 .. "%", ToolTip = Locale.Lookup("TXT_KEY_GOV_OUTCOME_CHANCE_REDUCE_BY_VISIBILITY_VS_GOV"), Results = {
				{"[ICON_RESISTANCE] Riots start in all Cities governed by [ICON_ITG_GOVERNOR] Governor.", cityPlacedTT},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_PLAYER_POWER_REDUCTION",a3o2powerloss),""},
				{"Generals and Admirals have " .. militaryshare .. "% chance to leave you.", "This affects " .. GetNumAliveCommanders(iPlayer) .. " commander(s)."},
				{"[ICON_ITG_GOVERNOR] Governor leaves you.", ""},
			}},
		}},
		{ID = 4, Text = "PREEMPTIVE ACTION", Help = "Declare War", ToolTip = "By declaring war yourself you can make this diplomatic note no longer valid.", Disabled = true, Outcomes = {
		}},
	}
	if actionID == -1 then
		uiTab.Active = true;
		uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_28", playerName)
	else
		local outcomeID = 1;
		if actionID == 1 then
			uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_28_ACTION_1_OUTCOME_1", playerName)
			BoostGovernorPower(govID, "Actions", 25, false)
			Teams[Players[iPlayer]:GetTeam()]:DeclareWar(Players[tPlayer]:GetTeam())
			SpawnRandomUnitsAroundPlot(iPlayer, extraUnits, Map.GetPlotByIndex(gT.Globals.Governors[govID].City))
			TakeCareOfEventMorale(iPlayer, 25, {3, "Diplo Action"})
		elseif actionID == 2 then
			local a2o1c, a2o2c = GetBendTheKneeSituationChances(govID, iPlayer, govPower, intrigueV, 0, 5)
			outcomeID = GetRandomFromBiasedChanceTable({{1,a2o1c}, {2, a2o2c}});
			if outcomeID == 1 then
				if GenerateChancedGrudge(govID, 6, 25) then
					blog1 = true;
				else
					uiTab.Actions[actionID].Outcomes[outcomeID].Results[1].Disabled = true;
				end
				blog2 = LastRandom(3, 7);
				BoostPlayerPower(iPlayer, "Allegiance", blog2)
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[2] = {Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_PLAYER_POWER_GAIN", GetGovernorActionRNGTextSolved(3,7,blog2,"[COLOR_POSITIVE_TEXT]")),""} 
				uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_28_ACTION_2_OUTCOME_1")
				GovernorDreamShatteredVengeanceNow(govID, iPlayer, selfID)
			else
				outcomeID = GetGovernorCounterAction28(govID, iPlayer)
				if outcomeID == 2 then
					Teams[Players[iPlayer]:GetTeam()]:DeclareWar(Players[tPlayer]:GetTeam())
					GenerateDiploNote(iPlayer, govID, 29, {28})
					uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_28_ACTION_2_OUTCOME_2", playerName)
				elseif outcomeID == 3 then
					MakeGovernorChangePlayer(govID, -1)
					BoostPlayerPower(iPlayer, "Denunciation", -3)
					uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_28_ACTION_2_OUTCOME_3")
				elseif outcomeID == 4 then
					KillGovernor(govID, false)
					TakeCareOfEventMorale(iPlayer, 25, {a2o4moraledrop, "Diplo Action"})
					uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_28_ACTION_2_OUTCOME_4")
				end
			end
		elseif actionID == 3 then
			outcomeID = GetRandomFromBiasedChanceTable({{1,a3o1c}, {2, a3o2c}});
			if outcomeID == 1 then
				NoteGovCausesBasicStack(iPlayer, 13)
				blog1 = DoTriggerGovernorTypeBadEffect(iPlayer, govID, govPower, false)
				if not blog1 then
					uiTab.Actions[actionID].Outcomes[outcomeID].Results[4].Disabled = true;
				end
				KillGovernor(govID, true)
				if LastChance(50) then
					NoteGovCausesBasicStack(iPlayer, 12)
					blog2 = true;
				else
					uiTab.Actions[actionID].Outcomes[outcomeID].Results[3].Disabled = true;
				end
				uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_28_ACTION_3_OUTCOME_1", playerName)
			elseif outcomeID == 2 then
				for i, iCity in pairs(cityPlaced) do
					DoRiotsInCity(iPlayer, iCity, iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded())
				end
				BoostPlayerPower(iPlayer, "Failed Execution", -a3o2powerloss)
				MakeGovernorChangePlayer(govID, -1)
				blog1 = TriggerChanceForCommandersToLeave(iPlayer, militaryshare)
				if not blog1 then
					uiTab.Actions[actionID].Outcomes[outcomeID].Results[3].Disabled = true;
				end
				uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_28_ACTION_3_OUTCOME_2", playerName)
			end
		end
		uiTab = PrepareResolveTabForUI(uiTab, actionID, outcomeID);
		table.insert(gT.Players[iPlayer].GovDiploLog, 1, {ID = selfID, Turn = GetITGGameTurn(), GovID = govID, Action = actionID, Outcome = outcomeID, Data = {blog1, blog2, tPlayer}})
	end
	return uiTab;
end
function GovActionResolve29(iPlayer, actionID, fIndex, selfID)
	local pIndex = fIndex or 1;
	local govID = gT.Players[iPlayer].DiploNotes[pIndex].Governor;
	local extraData = gT.Players[iPlayer].DiploNotes[pIndex].ExtraData;
	local intrigueV = gT.Players[iPlayer].DiploNotes[pIndex].Intrigue;
	local blog1, blog2;
	local govPower = gT.Players[iPlayer].DiploNotes[pIndex].GovernorPower;
	local a1powerlessC = AffectGovOutcomeWithVisibility(100, intrigueV, false)
	local a2powerlessC = AffectGovOutcomeWithVisibility(500, intrigueV, false)
	local uiTab = {GovID = govID, Headline = Locale.Lookup(dgActions[selfID].Name)}
	uiTab.Actions = {
		{ID = 1, Text = "REWARD", Help = "", ToolTip = "", Outcomes = {
			{Text = "VoidResultAlways", Results = {
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_GOVERNOR_POWER_GAIN","10-30"), ""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_CAUSE", a1powerlessC / 10, Locale.Lookup(GetGovCauseData(14, "Name"))),GenerateNiceCauseTooltip(14)},
			}},
		}},
		{ID = 2, Text = "IGNORE", Help = "", ToolTip = "", Outcomes = {
			{Text = "VoidResultAlways", Results = {
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_PLAYER_POWER_REDUCTION", 5), ""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_CAUSE", a2powerlessC / 10, Locale.Lookup(GetGovCauseData(14, "Name"))),GenerateNiceCauseTooltip(14)},
			}},
		}},
		{ID = 3, Text = "PUNISH", Help = "", ToolTip = "", Outcomes = {
			{Text = "VoidResultAlways", Results = {
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_GOVERNOR_POWER_LOSS","20-30"), ""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_GRUDGE",50,Locale.Lookup(GetGrudgeData(7, "Name"))),GenerateNiceGrudgeTooltip(7, true)},
			}},
		}},
		{ID = 4, Text = "EXECUTE", Help = "", ToolTip = "", Outcomes = {
			{Text = "VoidResultAlways", Results = {
				{"[ICON_ITG_GOVERNOR] Governor dies.",""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_CAUSE", 50, Locale.Lookup(GetGovCauseData(13, "Name"))),GenerateNiceCauseTooltip(13)},
			}},
		}},
	}
	if extraData[1] == 28 then
		table.insert(uiTab.Actions[1].Outcomes[1].Results, {"[ICON_ITG_GOVERNOR] Governor provides an extra military unit.", "They will spawn near the [ICON_ITG_GOVERNOR] Governor's location."})
		table.insert(uiTab.Actions[3].Outcomes[1].Results, {Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_CAUSE", 35, Locale.Lookup(GetGovCauseData(12, "Name"))),GenerateNiceCauseTooltip(12)})
		table.insert(uiTab.Actions[4].Outcomes[1].Results, {Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_CAUSE", 75, Locale.Lookup(GetGovCauseData(12, "Name"))),GenerateNiceCauseTooltip(12)})
		table.insert(uiTab.Actions[4].Outcomes[1].Results, {Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_MORALE_LOSS", 3-5), ""})
	elseif extraData[1] == 40 then
		uiTab.Actions[1].Text = "FORGIVE"
		table.insert(uiTab.Actions[1].Outcomes[1].Results, {"+4 [ICON_HAPPINESS_1] Happiness in all Cities.", ""})
		table.insert(uiTab.Actions[2].Outcomes[1].Results, {"+2 [ICON_HAPPINESS_1] Happiness in all Cities.", ""})
		table.insert(uiTab.Actions[3].Outcomes[1].Results, {"+1 [ICON_ITG_LEGAL_POWER] Legal Power.", ""})
		table.insert(uiTab.Actions[4].Outcomes[1].Results, {"+2 [ICON_ITG_LEGAL_POWER] Legal Power.", ""})
	end
	if actionID == -1 then
		uiTab.Active = true;
		uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_29")
	else
		local outcomeID = 1;
		if actionID == 1 then
			blog1 = LastRandom(10,30);
			BoostGovernorPower(govID, "Reward", blog1, false)
			uiTab.Actions[actionID].Outcomes[outcomeID].Results[1] = {Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_GOVERNOR_POWER_GAIN", GetGovernorActionRNGTextSolved(10,30,blog1,"[COLOR_NEGATIVE_TEXT]")),""} 
			if LastRandom(1, 1000) <= a1powerlessC then
				NoteGovCausesBasicStack(iPlayer, 14)
				blog2 = true;
			else
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[2].Disabled = true;
			end
			if extraData[1] == 28 then
				SpawnRandomUnitsAroundPlot(iPlayer, 1, Map.GetPlotByIndex(gT.Globals.Governors[govID].City))
			elseif extraData[1] == 40 then
				BoostHappinessInAllCities(iPlayer, 4)
			end
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_29_ACTION_1")
		elseif actionID == 2 then
			BoostPlayerPower(iPlayer, "Powerless", -5)
			if LastRandom(1, 1000) <= a2powerlessC then
				NoteGovCausesBasicStack(iPlayer, 14)
				blog2 = true;
			else
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[2].Disabled = true;
			end
			if extraData[1] == 40 then
				BoostHappinessInAllCities(iPlayer, 2)
			end
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_29_ACTION_2")
		elseif actionID == 3 then
			blog1 = LastRandom(20,30);
			BoostGovernorPower(govID, "Punishment", -blog1, false)
			uiTab.Actions[actionID].Outcomes[outcomeID].Results[1] = {Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_GOVERNOR_POWER_LOSS", GetGovernorActionRNGTextSolved(20,30,blog1,"[COLOR_POSITIVE_TEXT]")),""} 
			if GenerateChancedGrudge(govID, 7, 50) then
				blog2 = true;
			else
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[2].Disabled = true;
			end
			if extraData[1] == 28 then
				if LastChance(35) then
					NoteGovCausesBasicStack(iPlayer, 12)
				end
			elseif extraData[1] == 40 then
				ChangeITGLegalPointsPercent(iPlayer, 100, nil, "Punishment")
			end
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_29_ACTION_3")
		elseif actionID == 4 then
			KillGovernor(govID, true)
			if LastChance(50) then
				NoteGovCausesBasicStack(iPlayer, 13)
				blog2 = true;
			else
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[2].Disabled = true;
			end
			if extraData[1] == 28 then
				if LastChance(75) then
					NoteGovCausesBasicStack(iPlayer, 12)
				end
				local mDrop = LastRandom(3,5);
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[4] = {Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_MORALE_LOSS", GetGovernorActionRNGTextSolved(3,5,mDrop,"[COLOR_NEGATIVE_TEXT]")),""} 
				TakeCareOfEventMorale(iPlayer, 25, {-mDrop, "Diplo Action"})
			elseif extraData[1] == 40 then
				ChangeITGLegalPointsPercent(iPlayer, 200, nil, "Punishment")
			end
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_29_ACTION_4")
		end
		uiTab = PrepareResolveTabForUI(uiTab, actionID, outcomeID);
		table.insert(gT.Players[iPlayer].GovDiploLog, 1, {ID = selfID, Turn = GetITGGameTurn(), GovID = govID, Action = actionID, Outcome = outcomeID, Data = {blog1, blog2, extraData[1]}})
	end
	return uiTab;
end
function PrepareResolveTabForUI(uiTab, actionID, outcomeID)
	for a, b in pairs(uiTab.Actions) do
		if b.ID ~= actionID then
			uiTab.Actions[a].Disabled = true;
		else
			for c, d in pairs(b.Outcomes) do
				uiTab.Actions[a].Outcomes[c].Disabled = (c ~= outcomeID);
			end
		end
	end
	return uiTab;
end

function GovActionResolve19(iPlayer, actionID, fIndex, selfID)
	local pIndex = fIndex or 1;
	local govID = gT.Players[iPlayer].DiploNotes[pIndex].Governor;
	local intrigueV = gT.Players[iPlayer].DiploNotes[pIndex].Intrigue;
	local govPower = gT.Players[iPlayer].DiploNotes[pIndex].GovernorPower;
	if gT.Globals.Governors[govID].Type == 7 then
		govPower = govPower + 25;
	end
	local iHeresyID = gT.Players[iPlayer].DiploNotes[pIndex].ExtraData[1];
	local iCity = Map.GetPlotByIndex(gT.Heresies[iHeresyID].City):GetPlotCity();
	if (not gT.Heresies[iHeresyID].Active) or (iCity:GetOwner() ~= iPlayer) then
		return;
	end
	local blog1, blog2;
	local a1o1c = AffectGovOutcomeWithVisibility(500 + govPower, intrigueV, true);
	local a1o2c = 500;
	local uiTab = {GovID = govID, Headline = Locale.Lookup(dgActions[selfID].Name)}
	uiTab.Actions = {
		{ID = 1, Text = "ACCEPT", Help = "", ToolTip = "", 
		Outcomes = {{ID = 1, Text = "SUCCESS", Help = math.floor(a1o1c / (a1o2c + a1o1c) * 1000) / 10 .. "%", ToolTip = Locale.Lookup("TXT_KEY_GOV_OUTCOME_CHANCE_INCREASE_BY_VISIBILITY"), Results = {
				{"Heresy in " .. iCity:GetName() .. " ends.",""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_GOVERNOR_POWER_GAIN", 10),""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_MERITOCRACY_GAIN", 2), ""},
				}},
				{ID = 2, Text = "FAILURE", Help = math.floor(a1o2c / (a1o2c + a1o1c) * 1000) / 10 .. "%", ToolTip = "", Results = {
				{"2 extra Heretics will spawn.", ""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_GOVERNOR_POWER_LOSS", 3),""},
				}},
			}
	}, 
	{ID = 2, Text = "REFUSE", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_GRUDGE",5,Locale.Lookup(GetGrudgeData(4, "Name"))),GenerateNiceGrudgeTooltip(4, true)},
			}}}}
	}
	if actionID == -1 then
		uiTab.Active = true;
		uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_19", iCity:GetName(), gT.Heresies[iHeresyID].Name)
	else
		local outcomeID = 1;
		if actionID == 1 then
			outcomeID = GetRandomFromBiasedChanceTable({{1,a1o1c}, {2, a1o2c}})
			if outcomeID == 1 then
				uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_19_ACTION_1_OUTCOME_1")
				EndHeresyDiplomatically(iHeresyID)
				BoostGovernorPower(govID, "Actions", 10, false)
				ChangeMeritocracy(iPlayer, 2)
			else
				uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_19_ACTION_1_OUTCOME_2")
				SpawnExtraHeretics(iHeresyID, 2)
				BoostGovernorPower(govID, "Incompetence", -3, false)
			end
		elseif actionID == 2 then
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_19_ACTION_2")
			if GenerateChancedGrudge(govID, 4, 5) then
				blog2 = true;
			else
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[1].Disabled = true;
			end
		end
		uiTab = PrepareResolveTabForUI(uiTab, actionID, outcomeID);
		table.insert(gT.Players[iPlayer].GovDiploLog, 1, {ID = selfID, Turn = GetITGGameTurn(), GovID = govID, Action = actionID, Outcome = outcomeID, Data = {blog1, blog2, iHeresyID}})
	end
	return uiTab;
end

function GovActionResolve8(iPlayer, actionID, fIndex, selfID)
	local pIndex = fIndex or 1;
	local govID = gT.Players[iPlayer].DiploNotes[pIndex].Governor;
	local extraData = gT.Players[iPlayer].DiploNotes[pIndex].ExtraData;
	if not CanEstablishEmbassyWithPlayer(iPlayer, Players[iPlayer]:GetTeam(), extraData[2]) then
		return nil;
	end
	local blog1, blog2;
	local uiTab = {GovID = govID, Headline = Locale.Lookup(dgActions[selfID].Name)}
	uiTab.Actions = {
		{ID = 1, Text = "ACCEPT", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{"Establish embassy in " .. Players[extraData[2]]:GetCivilizationAdjective() .. " Capital.",""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_GOVERNOR_POWER_GAIN", extraData[1]),""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_MERITOCRACY_GAIN", 1), ""},
				}}}
	}, 
	{ID = 2, Text = "REFUSE", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_GRUDGE",5,Locale.Lookup(GetGrudgeData(4, "Name"))),GenerateNiceGrudgeTooltip(4, true)},
			}}}}
	}
	if actionID == -1 then
		uiTab.Active = true;
		uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_8", Players[extraData[2]]:GetCivilizationAdjective())
	else
		local outcomeID = 1;
		if actionID == 1 then
			uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_8_ACTION_1", Players[extraData[2]]:GetCivilizationAdjective())
			PlayerSetEmbasssy(iPlayer, extraData[2])
			BoostGovernorPower(govID, "Actions", extraData[1], false)
			ChangeMeritocracy(iPlayer, 1)
		elseif actionID == 2 then
			uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_8_ACTION_2", Players[extraData[2]]:GetCivilizationAdjective())
			if GenerateChancedGrudge(govID, 4, 5) then
				blog2 = true;
			else
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[1].Disabled = true;
			end
		end
		uiTab = PrepareResolveTabForUI(uiTab, actionID, outcomeID);
		table.insert(gT.Players[iPlayer].GovDiploLog, 1, {ID = selfID, Turn = GetITGGameTurn(), GovID = govID, Action = actionID, Data = {blog1, blog2, extraData[2], extraData[1]}})
	end
	return uiTab;
end

function GovActionResolve9(iPlayer, actionID, fIndex, selfID)
	local pIndex = fIndex or 1;
	local govID = gT.Players[iPlayer].DiploNotes[pIndex].Governor;
	local extraData = gT.Players[iPlayer].DiploNotes[pIndex].ExtraData;
	local blog1, blog2;
	local uiTab = {GovID = govID, Headline = Locale.Lookup(dgActions[selfID].Name)}
	uiTab.Actions = {
		{ID = 1, Text = "ACCEPT", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{"Reveals territory of " .. Players[extraData[1]]:GetCivilizationShortDescription() .. ".",""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_CAUSE", GeneratePuppetRulerStackChance(iPlayer), Locale.Lookup(GetGovCauseData(8, "Name"))),GenerateNiceCauseTooltip(8)},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_FAVOUR_EARNED", 10), Locale.Lookup("TXT_KEY_GOV_ACTION_FAVOUR_TT")},
				}}}
	}, 
	{ID = 2, Text = "REFUSE", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
			}}}}
	}
	if actionID == -1 then
		uiTab.Active = true;
		uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_9", Players[extraData[1]]:GetCivilizationAdjective())
	else
		for a, b in pairs(uiTab.Actions) do
			if b.ID ~= actionID then
				uiTab.Actions[a].Disabled = true;
			end
		end
		local outcomeID = 1;
		if actionID == 1 then
			uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_9_ACTION_1", Players[extraData[1]]:GetCivilizationAdjective())
			DoRevealTerritoryOfPlayer(iPlayer, extraData[1])		
			if LastChance(GeneratePuppetRulerStackChance(iPlayer)) then
				NoteGovCausesBasicStack(iPlayer, 8)
				blog1 = true;
			else
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[2].Disabled = true;
			end
			gT.Globals.Governors[govID].ForeignContacts[iPlayer].Favour = gT.Globals.Governors[govID].ForeignContacts[iPlayer].Favour + 10;
		elseif actionID == 2 then
			uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_9_ACTION_2", Players[extraData[1]]:GetCivilizationAdjective())
		end
		table.insert(gT.Players[iPlayer].GovDiploLog, 1, {ID = selfID, Turn = GetITGGameTurn(), GovID = govID, Action = actionID, Data = {blog1, blog2, extraData[1]}})
	end
	return uiTab;
end

function GovActionResolve10(iPlayer, actionID, fIndex, selfID)
	local pIndex = fIndex or 1;
	local govID = gT.Players[iPlayer].DiploNotes[pIndex].Governor;
	local extraData = gT.Players[iPlayer].DiploNotes[pIndex].ExtraData;
	local blog1, blog2;
	local uiTab = {GovID = govID, Headline = Locale.Lookup(dgActions[selfID].Name)}
	uiTab.Actions = {
		{ID = 1, Text = "ACCEPT", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{"Expose " .. Players[extraData[1]]:GetCivilizationAdjective() .. " spy hiding in your empire.","Spy will be caught upon making next action. Note: Spy may be moved away before that happens."},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_CAUSE", GeneratePuppetRulerStackChance(iPlayer), Locale.Lookup(GetGovCauseData(8, "Name"))),GenerateNiceCauseTooltip(8)},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_FAVOUR_EARNED", 10), Locale.Lookup("TXT_KEY_GOV_ACTION_FAVOUR_TT")},
				}}}
	}, 
	{ID = 2, Text = "REFUSE", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
			}}}}
	}
	if actionID == -1 then
		uiTab.Active = true;
		uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_10")
	else
		for a, b in pairs(uiTab.Actions) do
			if b.ID ~= actionID then
				uiTab.Actions[a].Disabled = true;
			end
		end
		if actionID == 1 then
			local outcomeID = 1;
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_10_ACTION_1")
			gT.Players[extraData[1]].Agents[extraData[2]].Exposed = iPlayer;	
			if LastChance(GeneratePuppetRulerStackChance(iPlayer)) then
				NoteGovCausesBasicStack(iPlayer, 8)
				blog1 = true;
			else
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[2].Disabled = true;
			end
			gT.Globals.Governors[govID].ForeignContacts[iPlayer].Favour = gT.Globals.Governors[govID].ForeignContacts[iPlayer].Favour + 10;
		elseif actionID == 2 then
			local outcomeID = 1;
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_10_ACTION_2")
		end
		table.insert(gT.Players[iPlayer].GovDiploLog, 1, {ID = selfID, Turn = GetITGGameTurn(), GovID = govID, Action = actionID, Data = {blog1, blog2, extraData[1]}})
	end
	return uiTab;
end

function GovActionResolve11(iPlayer, actionID, fIndex, selfID)
	local pIndex = fIndex or 1;
	local govID = gT.Players[iPlayer].DiploNotes[pIndex].Governor;
	local extraData = gT.Players[iPlayer].DiploNotes[pIndex].ExtraData;
	if not gT.Leagues[extraData[1]] then
		print("GovAction11 no longer valid league")
		return nil;
	end
	if not gT.Leagues[extraData[1]].Proposals[extraData[2]] then
		print("GovAction11 no longer valid proposal")
		return nil;
	end
	local blog1, blog2;
	local lName, resName = gT.Leagues[extraData[1]].Name, gT.Leagues[extraData[1]].Proposals[extraData[2]].Name
	local uiTab = {GovID = govID, Headline = Locale.Lookup(dgActions[selfID].Name)}
	uiTab.Actions = {
		{ID = 1, Text = "ACCEPT", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{"Debate over " .. resName .. " in " .. lName .. " will be influenced towards our case.","Note: this action will have no effect against Veto. Proposal can be also further delayed."},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_CAUSE", GeneratePuppetRulerStackChance(iPlayer), Locale.Lookup(GetGovCauseData(8, "Name"))),GenerateNiceCauseTooltip(8)},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_FAVOUR_EARNED", 10), Locale.Lookup("TXT_KEY_GOV_ACTION_FAVOUR_TT")},
				}}}
	}, 
	{ID = 2, Text = "REFUSE", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
			}}}}
	}
	if actionID == -1 then
		uiTab.Active = true;
		uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_11", lName, resName)
	else
		for a, b in pairs(uiTab.Actions) do
			if b.ID ~= actionID then
				uiTab.Actions[a].Disabled = true;
			end
		end
		if actionID == 1 then
			local outcomeID = 1;
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_11_ACTION_1")
			gT.Leagues[extraData[1]].Proposals[extraData[2]].InfluencedDebate = true;		
			if LastChance(GeneratePuppetRulerStackChance(iPlayer)) then
				NoteGovCausesBasicStack(iPlayer, 8)
				blog1 = true;
			else
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[2].Disabled = true;
			end
			gT.Globals.Governors[govID].ForeignContacts[iPlayer].Favour = gT.Globals.Governors[govID].ForeignContacts[iPlayer].Favour + 10;
		elseif actionID == 2 then
			local outcomeID = 1;
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_11_ACTION_2")
		end
		table.insert(gT.Players[iPlayer].GovDiploLog, 1, {ID = selfID, Turn = GetITGGameTurn(), GovID = govID, Action = actionID, Data = {blog1, blog2, lName}})
	end
	return uiTab;
end
function GovActionResolve54(iPlayer, actionID, fIndex, selfID)
	local pIndex = fIndex or 1;
	local govID = gT.Players[iPlayer].DiploNotes[pIndex].Governor;
	local govPower = gT.Players[iPlayer].DiploNotes[pIndex].GovernorPower;
	local extraData = gT.Players[iPlayer].DiploNotes[pIndex].ExtraData;
	local sActionType = extraData[1];
	local tPlayer = extraData[2];
	if tPlayer ~= gT.Globals.Governors[govID].Player then
		return;
	end
	if not Teams[Players[iPlayer]:GetTeam()]:CanDeclareWar(Players[tPlayer]:GetTeam()) then
		return;
	end
	if not gT.Globals.Governors[govID].ForeignContacts[iPlayer] then
		return;
	end
	local playerName = Players[tPlayer]:GetCivilizationShortDescription();
	local leaderName = Players[tPlayer]:GetName();
	local playerAdj = Players[tPlayer]:GetCivilizationAdjective();

	local chanceToBreakRelations = math.min(75, 20 + gT.Globals.Governors[govID].ForeignContacts[iPlayer].Favour);
	local blog1, blog2;
	local uiTab = {GovID = govID, Headline = Locale.Lookup(dgActions[selfID].Name)}
	uiTab.Actions = {
		{ID = 1, Text = "SUPPORT", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
			
				}}}
		},
		{ID = 2, Text = "REFUSE", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
			{"([COLOR_NEGATIVE_TEXT]" .. chanceToBreakRelations .. "%[ENDCOLOR]) [ICON_ITG_GOVERNOR] Governor ends diplomatic relations with us.",""},
			}}}}
	}
	if sActionType == 40 then
		local goverName = CallDataFromGovTab(gT.Globals.Governors[govID].Goverment, "Name");
		table.insert(uiTab.Actions[1].Outcomes[1].Results, {"[ICON_ITG_GOVERNOR] Governor will initialize Revolution in " .. playerName .. " in near future.", "[ICON_ITG_GOVERNOR] Governor is fond of " .. goverName .. "."})
		table.insert(uiTab.Actions[1].Outcomes[1].Results, {"You will be affected by an outcome of this Revolution.", "Based on an outcome you may:[NEWLINE][ICON_BULLET]Gain +3 [ICON_ITG_LEGAL_POWER] Legal Power.[NEWLINE][ICON_BULLET]Start a war with " .. leaderName .. " (scripted: no diplomatic penalties).[NEWLINE][ICON_BULLET]Grant a shelter to an exiled [ICON_ITG_GOVERNOR] Governor."})
	elseif sActionType == 26 then
		table.insert(uiTab.Actions[1].Outcomes[1].Results, {"[ICON_ITG_GOVERNOR] Governor will try to enforce your Religion as an official one of " .. playerName .. " in near future.", ""})
		table.insert(uiTab.Actions[1].Outcomes[1].Results, {"You will be affected by an outcome of this initiative.", "Based on an outcome you may:[NEWLINE][ICON_BULLET]Gain +300 [ICON_PEACE] Faith.[NEWLINE][ICON_BULLET]Start a war with " .. leaderName .. " (scripted: no diplomatic penalties).[NEWLINE][ICON_BULLET]Grant a shelter to an exiled [ICON_ITG_GOVERNOR] Governor."})
	elseif sActionType == 27 then
		table.insert(uiTab.Actions[1].Outcomes[1].Results, {"[ICON_ITG_GOVERNOR] Governor will try to become a leader of [ICON_CITY_STATE] " .. Players[extraData[3]]:GetName() .. " in near future.", ""})
		table.insert(uiTab.Actions[1].Outcomes[1].Results, {"You will be affected by an outcome of this ambition.", "Based on an outcome you may:[NEWLINE][ICON_BULLET]Gain +60 [ICON_INFLUENCE] Influence.[NEWLINE][ICON_BULLET]Start a war with " .. leaderName .. " (scripted: no diplomatic penalties)."})
	end
	if actionID == -1 then
		uiTab.Active = true;
		uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_54_" .. sActionType, playerName)
	else
		local outcomeID = 1;
		if actionID == 1 then
			gT.Globals.Governors[govID].QueueForeignSupport = {sActionType, iPlayer, extraData[3]};
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_54_" .. sActionType .. "_ACTION_1")
		elseif actionID == 2 then
			if LastChance(chanceToBreakRelations) then
				EndForeignRelation(govID, iPlayer)
				blog1 = true;
			else
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[1].Disabled = true;
			end
			if LastChance(50) then
				gT.Globals.Governors[govID].QueueForeignSupport = {sActionType, nil, extraData[3]};
			end
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_54_ACTION_2")
		end
		uiTab = PrepareResolveTabForUI(uiTab, actionID, outcomeID);
		table.insert(gT.Players[iPlayer].GovDiploLog, 1, {ID = selfID, Turn = GetITGGameTurn(), GovID = govID, Action = actionID, Outcome = outcomeID, Data = {blog1, blog2, sActionType, tPlayer, extraData[3]}})
	end
	return uiTab;
end
function GovActionResolve33(iPlayer, actionID, fIndex, selfID)
	local pIndex = fIndex or 1;
	local govID = gT.Players[iPlayer].DiploNotes[pIndex].Governor;
	local govPower = gT.Players[iPlayer].DiploNotes[pIndex].GovernorPower;
	local extraData = gT.Players[iPlayer].DiploNotes[pIndex].ExtraData;
	local tPlayer = extraData[1];
	if not gT.Globals.Governors[govID].City then
		return;
	end
	if tPlayer ~= gT.Globals.Governors[govID].Player then
		return;
	end
	if not Teams[Players[iPlayer]:GetTeam()]:CanDeclareWar(Players[tPlayer]:GetTeam()) then
		return;
	end
	local playerName = Players[tPlayer]:GetCivilizationShortDescription();
	local leaderName = Players[tPlayer]:GetName();
	local playerAdj = Players[tPlayer]:GetCivilizationAdjective();
	local blog1, blog2;
	local cityPlaced, cityPlacedTT, noPlaced, noPlacedTT = GetGovCitiesForAction(govID, tPlayer);
	local extraUnits = math.max(2, math.min(5, govPower / 40))
	local iDMG = math.max(25, math.min(75, govPower / 3))
	local iResistance = math.max(2, math.min(4, govPower / 50))
	local iMilitShare = GetMilitarySharesGovernors(iPlayer, govID)
	local uiTab = {GovID = govID, Headline = Locale.Lookup(dgActions[selfID].Name)}
	uiTab.Actions = {
		{ID = 1, Text = "LET'S MOVE", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_FAVOUR_EARNED", 20), Locale.Lookup("TXT_KEY_GOV_ACTION_FAVOUR_TT")},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_CAUSE", GeneratePuppetRulerStackChance(iPlayer), Locale.Lookup(GetGovCauseData(8, "Name"))),GenerateNiceCauseTooltip(8)},
				{"Rival Cities under [ICON_ITG_GOVERNOR] Governor will receive " .. iDMG .. " DMG and enter " .. iResistance .. " turns of resistance.", cityPlacedTT},
				{"Every " .. playerAdj .. " military unit will have " .. iMilitShare .. "% chance to take 25 non-lethal damage and become [ICON_DENOUNCE] Demoralized.", ""},
				{"[ICON_ITG_GOVERNOR] Governor joins you.", "Whenever you conquer " .. playerAdj .. " city, this [ICON_ITG_GOVERNOR] Governor will be relocated there if not yet assigned."},
				{"[ICON_ITG_GOVERNOR] Governor provides an extra " .. extraUnits .. " military units.", "They will spawn next to City closest to current [ICON_ITG_GOVERNOR] Governor's location."},
				{"Declares war on " .. playerName .. ".", ""},
				}}}
		}, 
		{ID = 2, Text = "ACCEPT", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{"Secret Pact", Locale.Lookup("TXT_KEY_GOV_ACTION_SECRET_PACT_TT")},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_CAUSE", GeneratePuppetRulerStackChance(iPlayer), Locale.Lookup(GetGovCauseData(8, "Name"))),GenerateNiceCauseTooltip(8)},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_FAVOUR_EARNED", 20), Locale.Lookup("TXT_KEY_GOV_ACTION_FAVOUR_TT")},
				}}}
		}, 
		{ID = 3, Text = "REFUSE", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
			}}}}
	}
	if actionID == -1 then
		uiTab.Active = true;
		uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_33", leaderName)
	else
		local outcomeID = 1;
		if actionID == 1 then
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_33_ACTION_1")
			if LastChance(GeneratePuppetRulerStackChance(iPlayer)) then
				NoteGovCausesBasicStack(iPlayer, 8)
				blog1 = true;
			else
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[2].Disabled = true;
			end
			gT.Globals.Governors[govID].ForeignContacts[iPlayer].Favour = gT.Globals.Governors[govID].ForeignContacts[iPlayer].Favour + 20;
			DoBetrayalOfGovernor(govID, tPlayer, iPlayer, iDMG, iResistance, iMilitShare, extraUnits, false)
			Teams[Players[iPlayer]:GetTeam()]:DeclareWar(Players[tPlayer]:GetTeam())
		elseif actionID == 2 then
			uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_33_ACTION_2", leaderName)
			if LastChance(GeneratePuppetRulerStackChance(iPlayer)) then
				NoteGovCausesBasicStack(iPlayer, 8)
				blog1 = true;
			else
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[2].Disabled = true;
			end
			gT.Globals.Governors[govID].ForeignContacts[iPlayer].Favour = gT.Globals.Governors[govID].ForeignContacts[iPlayer].Favour + 20;
			gT.Globals.Governors[govID].ForeignContacts[iPlayer].SecretPact = true;
		elseif actionID == 3 then
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_33_ACTION_3")
		end
		uiTab = PrepareResolveTabForUI(uiTab, actionID, outcomeID);
		table.insert(gT.Players[iPlayer].GovDiploLog, 1, {ID = selfID, Turn = GetITGGameTurn(), GovID = govID, Action = actionID, Outcome = outcomeID, Data = {blog1, blog2, tPlayer}})
	end
	return uiTab;
end

function GovActionResolve20(iPlayer, actionID, fIndex, selfID)
	local pIndex = fIndex or 1;
	local govID = gT.Players[iPlayer].DiploNotes[pIndex].Governor;
	local extraData = gT.Players[iPlayer].DiploNotes[pIndex].ExtraData;
	if not gT.Globals.Governors[govID].City then
		return;
	end
	local blog1, blog2;
	local uiTab = {GovID = govID, Headline = Locale.Lookup(dgActions[selfID].Name)}
	uiTab.Actions = {
		{ID = 1, Text = "ACCEPT", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{"Your Cities will have +50 [ICON_TRADE_WHITE] Trade Appeal for Trade-Routes from Cities under Governor's influence.","Note: this will not result in 100% chance of becoming a target."},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_CAUSE", GeneratePuppetRulerStackChance(iPlayer), Locale.Lookup(GetGovCauseData(8, "Name"))),GenerateNiceCauseTooltip(8)},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_FAVOUR_EARNED", 10), Locale.Lookup("TXT_KEY_GOV_ACTION_FAVOUR_TT")},
				}}}
	}, 
	{ID = 2, Text = "REFUSE", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
			}}}}
	}
	if actionID == -1 then
		uiTab.Active = true;
		uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_20")
	else
		for a, b in pairs(uiTab.Actions) do
			if b.ID ~= actionID then
				uiTab.Actions[a].Disabled = true;
			end
		end
		if actionID == 1 then
			local outcomeID = 1;
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_20_ACTION_1")
			gT.Globals.Governors[govID].ForeignContacts[iPlayer].TradeTarget = true;
			if LastChance(GeneratePuppetRulerStackChance(iPlayer)) then
				NoteGovCausesBasicStack(iPlayer, 8)
				blog1 = true;
			else
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[2].Disabled = true;
			end
			gT.Globals.Governors[govID].ForeignContacts[iPlayer].Favour = gT.Globals.Governors[govID].ForeignContacts[iPlayer].Favour + 10;
		elseif actionID == 2 then
			local outcomeID = 1;
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_20_ACTION_2")
		end
		table.insert(gT.Players[iPlayer].GovDiploLog, 1, {ID = selfID, Turn = GetITGGameTurn(), GovID = govID, Action = actionID, Data = {blog1, blog2}})
	end
	return uiTab;
end

function GovActionResolve21(iPlayer, actionID, fIndex, selfID)
	local pIndex = fIndex or 1;
	local govID = gT.Players[iPlayer].DiploNotes[pIndex].Governor;
	local extraData = gT.Players[iPlayer].DiploNotes[pIndex].ExtraData;
	local gpID = extraData[1];
	if (not gT.GreatPeople[gpID].Alive) or (gT.GreatPeople[gpID].Player ~= gT.Globals.Governors[govID].Player) then
		return;
	end
	local blog1, blog2;
	local uiTab = {GovID = govID, Headline = Locale.Lookup(dgActions[selfID].Name)}
	uiTab.Actions = {
		{ID = 1, Text = "ACCEPT", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{GetGreatPersonName(gpID) .. " will emigrate to your empire in near future.","Note: Great Person may die/retire/etc. before travel."},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_CAUSE", GeneratePuppetRulerStackChance(iPlayer), Locale.Lookup(GetGovCauseData(8, "Name"))),GenerateNiceCauseTooltip(8)},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_FAVOUR_EARNED", 10), Locale.Lookup("TXT_KEY_GOV_ACTION_FAVOUR_TT")},
				}}}
	}, 
	{ID = 2, Text = "REFUSE", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
			}}}}
	}
	if actionID == -1 then
		uiTab.Active = true;
		uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_21", GetGreatPersonName(gpID))
	else
		for a, b in pairs(uiTab.Actions) do
			if b.ID ~= actionID then
				uiTab.Actions[a].Disabled = true;
			end
		end
		if actionID == 1 then
			local outcomeID = 1;
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_21_ACTION_1")
			gT.GreatPeople[gpID].TravelTo = iPlayer;	
			if LastChance(GeneratePuppetRulerStackChance(iPlayer)) then
				NoteGovCausesBasicStack(iPlayer, 8)
				blog1 = true;
			else
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[2].Disabled = true;
			end
			gT.Globals.Governors[govID].ForeignContacts[iPlayer].Favour = gT.Globals.Governors[govID].ForeignContacts[iPlayer].Favour + 10;
		elseif actionID == 2 then
			local outcomeID = 1;
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_21_ACTION_2")
		end
		table.insert(gT.Players[iPlayer].GovDiploLog, 1, {ID = selfID, Turn = GetITGGameTurn(), GovID = govID, Action = actionID, Data = {blog1, blog2, extraData[1]}})
	end
	return uiTab;
end

function GovActionResolve12(iPlayer, actionID, fIndex, selfID)
	local pIndex = fIndex or 1;
	local govID = gT.Players[iPlayer].DiploNotes[pIndex].Governor;
	local extraData = gT.Players[iPlayer].DiploNotes[pIndex].ExtraData;
	local blog1, blog2;
	local uiTab = {GovID = govID, Headline = Locale.Lookup(dgActions[selfID].Name)}
	uiTab.Actions = {
		{ID = 1, Text = "ACCEPT", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{"Appoints foreign [ICON_ITG_GOVERNOR] Governor.",""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_CAUSE", GeneratePuppetRulerStackChance(iPlayer), Locale.Lookup(GetGovCauseData(8, "Name"))),GenerateNiceCauseTooltip(8)},
				}}}
	}, 
	{ID = 2, Text = "DENY", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{Locale.Lookup("TXT_KEY_GOV_ACTION_1_RESULT_2_MAIN"),Locale.Lookup("TXT_KEY_GOV_ACTION_1_RESULT_2_MAIN_TT")}
			}}}}
	}
	local fEarned = gT.Globals.Governors[govID].ForeignContacts[iPlayer].Favour;
	if fEarned > 0 then
		table.insert(uiTab.Actions[1].Outcomes[1].Results, {"[ICON_ITG_GOVERNOR] Governor earns " .. fEarned .. " [ICON_ITG_POWER] Power for earlier favours.",""})
		table.insert(uiTab.Actions[2].Outcomes[1].Results, {"[ICON_ITG_GOVERNOR] Foreign Governors will be less likely to cooperate with you.",""})
		table.insert(uiTab.Actions[2].Outcomes[1].Results, {Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_PLAYER_POWER_REDUCTION",math.floor(fEarned/5)),""})
	end
	if actionID == -1 then
		uiTab.Active = true;
		uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_12")
	else
		for a, b in pairs(uiTab.Actions) do
			if b.ID ~= actionID then
				uiTab.Actions[a].Disabled = true;
			end
		end
		if actionID == 1 then
			local outcomeID = 1;
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_12_ACTION_1")
			if LastChance(GeneratePuppetRulerStackChance(iPlayer)) then
				NoteGovCausesBasicStack(iPlayer, 8)
				blog1 = true;
			else
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[2].Disabled = true;
			end
			MakeGovernorChangePlayer(govID, iPlayer)
		elseif actionID == 2 then
			local outcomeID = 1;
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_12_ACTION_2")
			gT.Globals.Governors[govID].ForeignContacts[iPlayer] = {Failed = true}
			gT.Players[iPlayer].ForeignGovernors[govID] = nil;
			gT.Players[iPlayer].ForeignDiploActionPenalty = math.max(fEarned, gT.Players[iPlayer].ForeignDiploActionPenalty);
			BoostPlayerPower(iPlayer, "Unrequited favours", - math.floor(fEarned / 5))
		end
		table.insert(gT.Players[iPlayer].GovDiploLog, 1, {ID = selfID, Turn = GetITGGameTurn(), GovID = govID, Action = actionID, Data = {blog1, blog2}})
	end
	return uiTab;
end

function GovActionResolve13(iPlayer, actionID, fIndex, selfID)
	local pIndex = fIndex or 1;
	local govID = gT.Players[iPlayer].DiploNotes[pIndex].Governor;
	local intrigueV = gT.Players[iPlayer].DiploNotes[pIndex].Intrigue;
	local govPower = gT.Players[iPlayer].DiploNotes[pIndex].GovernorPower;
	local extraData = gT.Players[iPlayer].DiploNotes[pIndex].ExtraData;
	local iCity = Map.GetPlotByIndex(extraData[1]):GetPlotCity();
	if (iCity:GetOwner() ~= iPlayer) or (iCity:IsCapital()) or (gT.Cities[iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded()].PlacedGovernor) then
		return;
	end
	local blog1, blog2;
	local uiTab = {GovID = govID, Headline = Locale.Lookup(dgActions[selfID].Name)}
	uiTab.Actions = {
		{ID = 1, Text = "ACCEPT", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{"[ICON_ITG_GOVERNOR] Governor will be assigned to " .. iCity:GetName() .. ".",""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_GOVERNOR_POWER_GAIN", 5),""},
				}}}
	}, 
	{ID = 2, Text = "DENY", Help = "", ToolTip = "", 
		Outcomes = {{ID = 1, Text = "BEND THE KNEE", Help="[COLOR_POSITIVE_TEXT]?%", ToolTip = Locale.Lookup("TXT_KEY_GOV_OUTCOME_CHANCE_RANDOM_GOVERNOR") .. "[NEWLINE][NEWLINE]" .. Locale.Lookup("TXT_KEY_GOV_OUTCOME_CHANCE_INCREASE_BY_VISIBILITY_VS_GOV"), Results = {
			{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_GRUDGE",75,Locale.Lookup(GetGrudgeData(5, "Name"))),GenerateNiceGrudgeTooltip(5, true)},
			}},
			{ID = 2, Text = "DENUNCIATION", Help = "[COLOR_NEGATIVE_TEXT]?%", ToolTip = Locale.Lookup("TXT_KEY_GOV_OUTCOME_CHANCE_RANDOM_GOVERNOR"), Results = {
			{"[ICON_ITG_GOVERNOR] Governor abandons you.",""},
			{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_PLAYER_POWER_REDUCTION", 3), ""},
			}},
			}}
	}
	if actionID == -1 then
		uiTab.Active = true;
		uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_13", iCity:GetName())
	else
		local outcomeID = 1;
		if actionID == 1 then
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_13_ACTION_1")
			AssignGovernorToCity(iPlayer, govID, extraData[1], false, true)
			BoostGovernorPower(govID, "Actions", 5, false)
		elseif actionID == 2 then
			local a2o1c, a2o2c = GetBendTheKneeSituationChances(govID, iPlayer, govPower, intrigueV, 0, 0)
			outcomeID = GetRandomFromBiasedChanceTable({{1,a2o1c}, {2, a2o2c}});
			if outcomeID == 1 then
				if GenerateChancedGrudge(govID, 5, 75) then
					blog2 = true;
				else
					uiTab.Actions[actionID].Outcomes[outcomeID].Results[1].Disabled = true;
				end
				uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_13_ACTION_2_OUTCOME_1")
			else
				MakeGovernorChangePlayer(govID, -1)
				BoostPlayerPower(iPlayer, "Denunciation", -3)
				uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_13_ACTION_2_OUTCOME_2")
			end
		end
		uiTab = PrepareResolveTabForUI(uiTab, actionID, outcomeID);
		table.insert(gT.Players[iPlayer].GovDiploLog, 1, {ID = selfID, Turn = GetITGGameTurn(), GovID = govID, Action = actionID, Outcome = outcomeID, Data = {blog1, blog2, extraData[1]}})
	end
	return uiTab;
end

function AffectGovOutcomeWithVisibility(baseVal, playerPower, bPositive, govID)
	local intrigueV = 0;
	if govID then
		local effect = 1;
		if gT.Globals.Governors[govID].Type == 2 then
			effect = effect - 0.25;
		end
		if gT.Globals.Governors[govID].IntelInsight then
			effect = effect - 0.25;
		end
		intrigueV = math.max(0, math.floor(effect * playerPower) - gT.Globals.Governors[govID].Power);
	else
		intrigueV = math.max(0, playerPower - 100);
	end
	if bPositive then
		return math.ceil(baseVal * (100 + intrigueV * INTRIGUE_EFFECTIVENESS_MOD) / 100);
	else
		return math.ceil(baseVal * 100 / (100 + intrigueV * INTRIGUE_EFFECTIVENESS_MOD));
	end
end

function GovActionResolve15(iPlayer, actionID, fIndex, selfID)
	local pIndex = fIndex or 1;
	local govID = gT.Players[iPlayer].DiploNotes[pIndex].Governor;
	local intrigueV = gT.Players[iPlayer].DiploNotes[pIndex].Intrigue;
	local extraData = gT.Players[iPlayer].DiploNotes[pIndex].ExtraData;
	local cityTab = GetTabOfCitiesNotOwnedCulturally(iPlayer)
	if #cityTab == 0 then
		return nil;
	end
	local hA1O1R1tt = "This affects:"
	for a, b in pairs(cityTab) do
		hA1O1R1tt = hA1O1R1tt .. "[NEWLINE][ICON_BULLET]" .. b:GetName();
	end
	local blog1, blog2;
	local a1o1c = 400;
	local a1o2c = AffectGovOutcomeWithVisibility(100, intrigueV, false)
	local uiTab = {GovID = govID, Headline = Locale.Lookup(dgActions[selfID].Name)}
	uiTab.Actions = {
		{ID = 1, Text = "ACCEPT", Help = "", ToolTip = "", 
		Outcomes = {{ID = 1, Text = "SUCCESS", Help = "[COLOR_POSITIVE_TEXT]" .. math.floor(a1o1c / (a1o2c + a1o1c) * 1000) / 10 .. "%", ToolTip = "", Results = {
				{"Controlled Cities which are not owned culturally gain +"  .. extraData[2] .. " [ICON_ITG_PRESENCE] Cultural Presence.",hA1O1R1tt},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_GOVERNOR_POWER_GAIN", extraData[1]),""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_MERITOCRACY_GAIN", 1), ""},
				}},
				{ID = 2, Text = "REVOLT", Help = "[COLOR_NEGATIVE_TEXT]" .. math.floor(a1o2c / (a1o2c + a1o1c) * 1000) / 10 .. "%", ToolTip = Locale.Lookup("TXT_KEY_GOV_OUTCOME_CHANCE_REDUCE_BY_VISIBILITY_VS_GOV"), Results = {
				{"Controlled Cities which are not owned culturally spawn rebels.",hA1O1R1tt},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_GOVERNOR_POWER_LOSS", 10),""},
				}},
				}
	}, 
	{ID = 2, Text = "REFUSE", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_GRUDGE",5,Locale.Lookup(GetGrudgeData(4, "Name"))),GenerateNiceGrudgeTooltip(4, true)},
			}}}}
	}
	if actionID == -1 then
		uiTab.Active = true;
		uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_15")
	else
		local outcomeID = 1;
		if actionID == 1 then
			outcomeID = GetRandomFromBiasedChanceTable({{1,a1o1c}, {2, a1o2c}})
			for a, b in pairs(uiTab.Actions[actionID].Outcomes) do
				if b.ID ~= outcomeID then
					uiTab.Actions[actionID].Outcomes[a].Disabled = true;
				end
			end
			if outcomeID == 1 then
				uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_15_ACTION_1_OUTCOME_1")
				for a, b in pairs(cityTab) do
					DoChangeCityCultureOwnership(b:Plot():GetPlotIndex() .. "," .. b:GetGameTurnFounded(), b, iPlayer, extraData[2], "DAction")
				end
				BoostGovernorPower(govID, "Actions", extraData[1], false)
				ChangeMeritocracy(iPlayer, 1)
			else
				uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_15_ACTION_1_OUTCOME_2")
				for a, b in pairs(cityTab) do
					local cID = b:Plot():GetPlotIndex() .. "," .. b:GetGameTurnFounded();
					local tPlayer = gT.Cities[cID].CultureOwner;
					if (tPlayer == 63) or (tPlayer == iPlayer) then
						tPlayer = nil;
					end
					DoSpawnRebels(b, cID, iPlayer, tPlayer)
				end
				BoostGovernorPower(govID, "Incompetence", -10, false)
			end
		elseif actionID == 2 then
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_15_ACTION_2")
			if GenerateChancedGrudge(govID, 4, 5) then
				blog2 = true;
			else
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[1].Disabled = true;
			end
		end
		uiTab = PrepareResolveTabForUI(uiTab, actionID, outcomeID);
		table.insert(gT.Players[iPlayer].GovDiploLog, 1, {ID = selfID, Turn = GetITGGameTurn(), GovID = govID, Action = actionID, Outcome = outcomeID, Data = {blog1, blog2, extraData[2], extraData[1]}})
	end
	return uiTab;
end

function GetGovernorActionRNGTextSolved(min,max,val,color)
	if min == val then
		if color then
			return color .. val .. "[ENDCOLOR][COLOR_GREY]-" .. max .. "[ENDCOLOR]"
		else
			return val .. "[COLOR_GREY]-" .. max .. "[ENDCOLOR]"
		end
	elseif max == val then
		if color then
			return "[COLOR_GREY]" .. min .. "-[ENDCOLOR]" .. color .. max .. "[ENDCOLOR]"
		else
			return "[COLOR_GREY]" .. min .. "-[ENDCOLOR]" .. max
		end
	else
		if color then
			return "[COLOR_GREY]" .. min .. "-[ENDCOLOR]" .. color .. val .. "[ENDCOLOR][COLOR_GREY]-" .. max .. "[ENDCOLOR]"
		else
			return "[COLOR_GREY]" .. min .. "-[ENDCOLOR]" .. val .. "[COLOR_GREY]-" .. max .. "[ENDCOLOR]"
		end
	end
end

function GovActionResolve16(iPlayer, actionID, fIndex, selfID)
	local pIndex = fIndex or 1;
	local govID = gT.Players[iPlayer].DiploNotes[pIndex].Governor;
	local intrigueV = gT.Players[iPlayer].DiploNotes[pIndex].Intrigue;
	local extraData = gT.Players[iPlayer].DiploNotes[pIndex].ExtraData;
	local iCity = Map.GetPlotByIndex(extraData[1]):GetPlotCity();
	if iCity:GetOwner() ~= iPlayer then
		return;
	end
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	if gT.Cities[cID].Palace then
		if gT.Cities[cID].PalaceUpgrades + gT.Cities[cID].Palace.NumUpgrades >= 10 then
			return;
		end
	end
	local blog1, blog2;
	local a1o1c = 950;
	local a1o2c = AffectGovOutcomeWithVisibility(50, intrigueV, false)
	local uiTab = {GovID = govID, Headline = Locale.Lookup(dgActions[selfID].Name)}
	uiTab.Actions = {
		{ID = 1, Text = "ACCEPT", Help = "", ToolTip = "", 
		Outcomes = {{ID = 1, Text = "SUCCESS", Help = "[COLOR_POSITIVE_TEXT]" .. math.floor(a1o1c / (a1o2c + a1o1c) * 1000) / 10 .. "%", ToolTip = "", Results = {
				{"Expands a Palace in " .. iCity:GetName() .. ".","This action will create a Palace if not yet present."},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_GOVERNOR_POWER_GAIN", 10),""},
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CITY_UNHAPPINESS", iCity:GetName(), "2-4"),""},
				}},
				{ID = 2, Text = "LOCAL UNREST", Help = "[COLOR_NEGATIVE_TEXT]" .. math.floor(a1o2c / (a1o2c + a1o1c) * 1000) / 10 .. "%", ToolTip = Locale.Lookup("TXT_KEY_GOV_OUTCOME_CHANCE_REDUCE_BY_VISIBILITY"), Results = {
					{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CITY_RESISTANCE", iCity:GetName(), "2-4"),""},
					{"Rebels spawn near " .. iCity:GetName() .. ".",""},
					{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_GOVERNOR_POWER_LOSS", 6),""},
				}},
				}
	}, 
	{ID = 2, Text = "REFUSE", Help = "", ToolTip = "", 
		Outcomes = {{Text = "VoidResultAlways", Results = {
				{Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CHANCE_FOR_GRUDGE",5,Locale.Lookup(GetGrudgeData(4, "Name"))),GenerateNiceGrudgeTooltip(4, true)},
			}}}}
	}
	if actionID == -1 then
		uiTab.Active = true;
		uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_16", iCity:GetName())
	else
		local outcomeID = 1;
		if actionID == 1 then
			outcomeID = GetRandomFromBiasedChanceTable({{1,a1o1c}, {2, a1o2c}})
			if outcomeID == 1 then
				uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_16_ACTION_1_OUTCOME_1", iCity:GetName())
				CallCityCreatedPalaceExpand(iCity, cID, iPlayer)
				BoostGovernorPower(govID, "Actions", 10, false)
				local unHap = LastRandom(2,4);
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[3] = {Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CITY_UNHAPPINESS", iCity:GetName(), GetGovernorActionRNGTextSolved(2,4,unHap,"[COLOR_NEGATIVE_TEXT]")),""} 
				ChangeITGHappinessInTheCity(iCity, -unHap, nil, "al=gd")
			else 
				uiTab.MainText = Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_HEADLINE_16_ACTION_1_OUTCOME_2", iCity:GetName())
				local tRes = LastRandom(2,4);
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[1] = {Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_CITY_RESISTANCE", iCity:GetName(), GetGovernorActionRNGTextSolved(2,4,tRes,"[COLOR_NEGATIVE_TEXT]")),""} 
				BoostGovernorPower(govID, "Incompetence", -6, false)
				StartBasicResistance(iCity, cID, tRes, true)
				DoSpawnBarbarians(iCity, iPlayer, LastRandom(2,4), 63)
			end
		elseif actionID == 2 then
			uiTab.MainText = Locale.Lookup("TXT_KEY_GOV_ACTION_HEADLINE_16_ACTION_2")
			if GenerateChancedGrudge(govID, 4, 5) then
				blog2 = true;
			else
				uiTab.Actions[actionID].Outcomes[outcomeID].Results[1].Disabled = true;
			end
		end
		uiTab = PrepareResolveTabForUI(uiTab, actionID, outcomeID);
		table.insert(gT.Players[iPlayer].GovDiploLog, 1, {ID = selfID, Turn = GetITGGameTurn(), GovID = govID, Action = actionID, Outcome = outcomeID, Data = {blog1, blog2, extraData[1]}})
	end
	return uiTab;
end

function GetAmplifyOfGovAction(iPlayer, govID, selfID)
	local actionPower = math.max(gT.Globals.Governors[govID].Power, 1)
	if IsAplifiedGovAction(selfID, gT.Globals.Governors[govID].Type) then
		actionPower = actionPower + 25;
	end
	return math.min(3, LastRandom(1, math.ceil(actionPower / 35))), actionPower;
end

function GovActionExtraData2(iPlayer, govID, actionID)
	local amplify, actionPower = GetAmplifyOfGovAction(iPlayer, govID, actionID)
	return {5 + LastRandom(3,5) * amplify, amplify, math.floor((25 + actionPower / 4) * amplify),3 + 2 * amplify};
end

function GovActionExtraData3(iPlayer, govID, actionID)
	local amplify, actionPower = GetAmplifyOfGovAction(iPlayer, govID, actionID)
	return {8 + LastRandom(4,6) * amplify, amplify, math.floor(20 + math.min(20, (5 + actionPower / 10)) * amplify)}
end

function GovActionExtraData4(iPlayer, govID, actionID, moreData)
	local amplify, actionPower = GetAmplifyOfGovAction(iPlayer, govID, actionID)
	return {6 + LastRandom(1,4) * amplify, moreData, math.floor(5 + (actionPower / 20) * (3 + amplify))}
end

function GovActionExtraData5(iPlayer, govID, actionID, moreData)
	local amplify, actionPower = GetAmplifyOfGovAction(iPlayer, govID, actionID)
	return {7 + LastRandom(2,5) * amplify, math.floor((4 + actionPower / 6) * (3 + amplify))}
end

function GovActionExtraData15(iPlayer, govID, actionID, moreData)
	local amplify, actionPower = GetAmplifyOfGovAction(iPlayer, govID, actionID)
	return {8 + LastRandom(2,3) * amplify, math.floor((35 + actionPower / 4) * amplify)}
end

function GovActionExtraData16(iPlayer, govID, actionID, moreData)
	return {gT.Globals.Governors[govID].City}
end

function GovActionExtraData36(iPlayer, govID, actionID, moreData)
	local fPlayer = gT.Globals.Governors[govID].Player;
	local bTab = GetBuildingClassesToUnlock(iPlayer, {[fPlayer] = true})
	local uTab = GetUnitClassesToUnlock(iPlayer, {[fPlayer] = true})
	local bCount = #bTab;
	local lOption = LastRandom(1, bCount + #uTab);
	if lOption <= bCount then
		return {1, bTab[lOption]}
	end
	return {2, uTab[lOption - bCount]}
end

function GovActionExtraData6(iPlayer, govID, actionID, moreData)
	local amplify, actionPower = GetAmplifyOfGovAction(iPlayer, govID, actionID)
	if gT.Globals.ScenarioType == 3 then	
		return {5 + LastRandom(2,4) * amplify, math.floor(1 + amplify)}
	end
	return {5 + LastRandom(2,4) * amplify, math.floor((2 + actionPower / 50) * amplify)}
end

function GovActionExtraDataJustPass(iPlayer, govID, actionID, moreData)
	return moreData;
end

function GovActionExtraData24(iPlayer, govID, actionID, moreData)
	local amplify, actionPower = GetAmplifyOfGovAction(iPlayer, govID, actionID)
	return {moreData, math.floor((30 + actionPower / 20) * amplify), 3 + LastRandom(2,3) * amplify}
end

function GovActionExtraData7(iPlayer, govID, actionID)
	local amplify, actionPower = GetAmplifyOfGovAction(iPlayer, govID, actionID)
	local workRate = 0;
	if gT.Globals.ScenarioType == 1 then
		workRate = 180 + math.floor((80 + actionPower / 2) * amplify)
	elseif gT.Globals.ScenarioType == 4 or gT.Globals.ScenarioType == 5 then
		workRate = 250 + math.floor((90 + actionPower / 2) * amplify)
	else
		workRate = 120 + math.floor((70 + actionPower / 2) * amplify)
	end
	return {4 + LastRandom(2,3) * amplify, amplify, workRate,3 + 2 * amplify}
end
function GovActionExtraData43(iPlayer, govID, actionID)
	local amplify, actionPower = GetAmplifyOfGovAction(iPlayer, govID, actionID)
	local base = 3;
	if gT.Globals.ScenarioType == 3 then
		base = 1;
	end
	return {5 + LastRandom(1,2) * amplify, amplify, base + math.floor(actionPower / 50) + amplify}
end
function GovActionExtraData49(iPlayer, govID, actionID)
	local amplify, actionPower = GetAmplifyOfGovAction(iPlayer, govID, actionID)
	local base = 30;
	return {5 + LastRandom(1,2) * amplify, amplify, base + math.floor(actionPower / 50) * 5 + amplify * 5}
end
function GovActionExtraData8(iPlayer, govID, actionID, moreData)
	local amplify, actionPower = GetAmplifyOfGovAction(iPlayer, govID, actionID)
	return {19 + amplify, moreData}
end

function GovActionExtraData9(iPlayer, govID, actionID, moreData)
	return {gT.Globals.Governors[govID].Player} -- funnily it can be dirty in the moment of resolving action
end
function GovActionExtraData10(iPlayer, govID, actionID, moreData)
	return {gT.Globals.Governors[govID].Player, GetValidAgentToExpose(gT.Globals.Governors[govID].Player, iPlayer)}
end
function GovActionExtraData11(iPlayer, govID, actionID, moreData)
	return GetValidLeagueResolutionToInfluence(gT.Globals.Governors[govID].Player, iPlayer)
end
function GovActionExtraData13(iPlayer, govID, actionID)
	local options = {};
	for iCity in Players[iPlayer]:Cities() do
		if not iCity:IsCapital() then
			local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
			if not gT.Cities[cID].PlacedGovernor then
				local eval = iCity:GetPopulation() + 10;
				if iCity:GetDamage() == 0 then
					eval = eval + 5;
				end
				if not gT.Cities[cID].Governor then
					eval = eval + 5;
				end
				table.insert(options, {iCity:Plot():GetPlotIndex(), eval})
			end
		end
	end
	return {GetBasicGovernorOptionFromEvalTab(options, gT.Globals.Governors[govID].LoyaltyType)}
end
function GovActionExtraData21(iPlayer, govID, actionID)
	return {GetValidGPForGovernorToInvite(gT.Globals.Governors[govID].Player, iPlayer)}
end

function GovLogString1(govID, actionID, data)
	local str = ""
	if actionID == 1 then
		str = "You have established relations with [ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. ".";
		if data[1] then
			str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_CAUSE", Locale.Lookup(GetGovCauseData(8, "Name")))
		end
	else
		str = "You have not allowed [ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. " to visit your court, preventing any kind of contact in future.";
		if data[2] then
			str = str .. " This action generated [COLOR_POSITIVE_TEXT]+1% [ICON_ITG_MORALE] Morale[ENDCOLOR]."
		end
	end
	return str;
end
function GovLogString12(govID, actionID, data)
	local str = ""
	if actionID == 1 then
		str = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. " becomes part of your administration.";
		if data[1] then
			str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_CAUSE", Locale.Lookup(GetGovCauseData(8, "Name")))
		end
	else
		str = "You have not opened borders for [ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. " which ends this cooperation.";
	end
	return str;
end
function GovLogString13(govID, actionID, data, iPlayer, outcome)
	local str = ""
	if actionID == 1 then
		str = "You have fulfilled [ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. "'s  (+5[ICON_ITG_POWER]) request of being assigned to " .. Map.GetPlotByIndex(data[3]):GetPlotCity():GetName() .. ".";
	else
		if outcome == 1 then
			str = "You have not assigned [ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. " to city of " .. Map.GetPlotByIndex(data[3]):GetPlotCity():GetName() .. ".";
			if data[2] then
				str = str .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_GRUDGE", Locale.Lookup(GetGovCauseData(5, "Name")))
			end
		else
			str = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. " left administration after you rejected a request for assigment.";
		end
	end
	return str;
end

function GovLogString9(govID, actionID, data)
	local str = ""
	if actionID == 1 then
		str = "Foreign governor, [ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. ", has provided you maps of " .. Players[data[3]]:GetCivilizationAdjective() .. " territory.";
		if data[1] then
			str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_CAUSE", Locale.Lookup(GetGovCauseData(8, "Name")))
		end
	else
		str = "You have rejected maps of " .. Players[data[3]]:GetCivilizationAdjective() .. " territories offered by [ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. ".";
	end
	return str;
end
function GovLogString36(govID, actionID, data)
	local str = ""
	local ubName;
	if data[3] == 1 then
		ubName = Locale.Lookup(GameInfo.Buildings[data[4]].Description)
	else
		ubName = Locale.Lookup(GameInfo.Units[data[4]].Description)
	end
	local govName = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name);
	if actionID == 1 then
		str = "Foreign governor, " .. govName .. ", shared a knowledge of " .. ubName .. " with us.";
		if data[1] then
			str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_CAUSE", Locale.Lookup(GetGovCauseData(8, "Name")))
		end
	else
		str = "You were not interested in knowledge of " .. ubName .. " offered by " .. govName .. ".";
	end
	return str;
end
function GovLogString52(govID, actionID, data)
	local govName = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name);
	if actionID == 1 then
		str = "Foreign governor, " .. govName .. ", introduced us to the people of " .. Players[data[3]]:GetName() .. ".";
		if data[1] then
			str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_CAUSE", Locale.Lookup(GetGovCauseData(8, "Name")))
		end
	else
		str = govName .. " wanted us to hook up with some folks from minor civilization but we passed on that offer."
	end
	return str;
end
function GovLogString53(govID, actionID, data)
	local govName = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name);
	if actionID == 1 then
		str = "Your Agents started cooperation with a foreign governor, " .. govName .. ".";
		if data[1] then
			str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_CAUSE", Locale.Lookup(GetGovCauseData(8, "Name")))
		end
	else
		str = govName .. " have shown a suspicious interest in our espionage."
	end
	return str;
end
function GovLogString54(govID, actionID, data)
	local govName = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name);
	if data[3] == 40 then
		if actionID == 1 then
			str = "You have assured " .. govName .. " of support in overthrowing " .. Players[data[4]]:GetCivilizationAdjective() .. " goverment.";
		else
			str = "You have declined " .. govName .. "'s request for support in overthrowing " .. Players[data[4]]:GetCivilizationAdjective() .. " goverment"
			if data[1] then
				str = str .. " which ended your diplomatic relations."
			else
				str = str .. "."
			end
		end
	elseif data[3] == 26 then
		if actionID == 1 then
			str = "You have promised " .. govName .. " help in establishing your Religion as an official one of " .. Players[data[4]]:GetCivilizationAdjective() .. ".";
		else
			str = "You have denied " .. govName .. "'s any help in proselytizing " .. Players[data[4]]:GetCivilizationShortDescription()
			if data[1] then
				str = str .. " which ended your diplomatic relations."
			else
				str = str .. "."
			end
		end
	elseif data[3] == 27 then
		if actionID == 1 then
			str = "You have granted " .. govName .. " a blessing to become a leader of " .. Players[data[5]]:GetName() .. ".";
		else
			str = "You were not interested in helping " .. govName .. " to become a leader of " .. Players[data[5]]:GetName()
			if data[1] then
				str = str .. " which ended your diplomatic relations."
			else
				str = str .. "."
			end
		end
	end
	return str;
end

function GovLogString10(govID, actionID, data)
	local str = ""
	if actionID == 1 then
		str = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. " exposed a rival spy working in our territory.";
		if data[1] then
			str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_CAUSE", Locale.Lookup(GetGovCauseData(8, "Name")))
		end
	else
		str = "You were not interested in espionage intel provided by [ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. ".";
	end
	return str;
end

function GovLogString20(govID, actionID, data)
	local str = ""
	if actionID == 1 then
		str = "You have made a trade agreement with foreign [ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. ".";
		if data[1] then
			str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_CAUSE", Locale.Lookup(GetGovCauseData(8, "Name")))
		end
	else
		str = "You were not interested in trade agreement with [ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. ".";
	end
	return str;
end

function GovLogString21(govID, actionID, data)
	local str = ""
	if actionID == 1 then
		str = "You have invited " .. GetGreatPersonName(data[3]) .. " to your empire (thanks to [ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. ").";
		if data[1] then
			str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_CAUSE", Locale.Lookup(GetGovCauseData(8, "Name")))
		end
	else
		str = "You were not interested in inviting " .. GetGreatPersonName(data[3]) .. " (proposed by [ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. ").";
	end
	return str;
end

function GovLogString11(govID, actionID, data)
	local str = ""
	if actionID == 1 then
		str = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. " influenced a debate for us in " .. data[3] .. ".";
		if data[1] then
			str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_CAUSE", Locale.Lookup(GetGovCauseData(8, "Name")))
		end
	else
		str = "You have rejected [ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. "'s help in influencing delegates in " .. data[3] .. ".";
	end
	return str;
end

function GovLogString2(govID, actionID, data)
	local str = ""
	if actionID == 1 then
		str = "Special tax proposed by [ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. " (+" .. data[4] .. "[ICON_ITG_POWER]) provided +" .. data[3] .. " [ICON_GOLD] Gold for the empire."
		if data[1] then
			str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_CAUSE", Locale.Lookup(GetGovCauseData(9, "Name")))
		end
	elseif actionID == 2 then
		str = "You have not endorsed extra tax proposed by [ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. "."
		if data[2] then
			str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_GRUDGE", Locale.Lookup(GetGrudgeData(4, "Name")))
		end
	end
	return str;
end

function GovLogString3(govID, actionID, data)
	local str = ""
	if actionID == 1 then
		str = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. " (+" .. data[4] .. "[ICON_ITG_POWER]) exposed numerous corrupted officials which increased [ICON_ITG_MERITOCRACY] Meritocracy wihin empire by " .. data[3] .. "."
	elseif actionID == 2 then
		str = "You have not supported [ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. "'s plan to expose corrupted officials."
		if data[2] then
			str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_GRUDGE", Locale.Lookup(GetGrudgeData(4, "Name")))
		end
	end
	return str;
end

function GovLogString4(govID, actionID, data, iPlayer, outcome)
	local str = ""
	if actionID == 1 then
		if outcome == 1 then
			str = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. " (+" .. data[4] .. "[ICON_ITG_POWER]) has visited " .. Players[data[5]]:GetName() .. " (+" .. data[3] .. "[ICON_INFLUENCE])."
		else
			str = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. " (-10[ICON_ITG_POWER]) has visited " .. Players[data[5]]:GetName() .. " (-50[ICON_INFLUENCE])."
		end
	elseif actionID == 2 then
		str = "You have not allowed [ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. " to go on diplomatic mission."
		if data[2] then
			str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_GRUDGE", Locale.Lookup(GetGrudgeData(4, "Name")))
		end
	end
	return str;
end

function GovLogString5(govID, actionID, data)
	local str = ""
	if actionID == 1 then
		str = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. " (+" .. data[4] .. "[ICON_ITG_POWER]) started cooperation with your Agents (+" .. data[3] .. "XP)."
	elseif actionID == 2 then
		str = "You have not granted [ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. " access to your Agents."
		if data[2] then
			str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_GRUDGE", Locale.Lookup(GetGrudgeData(4, "Name")))
		end
	end
	return str;
end

function GovLogString6(govID, actionID, data)
	local str = ""
	if actionID == 1 then
		str = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. " (+" .. data[4] .. "[ICON_ITG_POWER]) sponsoured " .. data[3] .. " [ICON_MISSIONARY] Missionaries."
	elseif actionID == 2 then
		str = "You rejected [ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. "'s support in proselytizing heathens."
		if data[2] then
			str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_GRUDGE", Locale.Lookup(GetGrudgeData(4, "Name")))
		end
	end
	return str;
end

function GovLogString15(govID, actionID, data, iPlayer, outcome)
	local str = ""
	if actionID == 1 then
		if outcome == 1 then
			str = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. " (+" .. data[4] .. "[ICON_ITG_POWER]) started indoctrination of foreign citizens (+" .. data[3] .. " [ICON_ITG_PRESENCE] Cultural Presence in Cities not culturally owned)."
		elseif outcome == 2 then
			str = "Several Cities rebelled due to cultural indoctrination initialized by [ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. " (-10[ICON_ITG_POWER])."
		end
	elseif actionID == 2 then
		str = "You ignored [ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. "'s call to indoctrinate foreign citizens."
		if data[2] then
			str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_GRUDGE", Locale.Lookup(GetGrudgeData(4, "Name")))
		end
	end
	return str;
end

function GovLogString16(govID, actionID, data, iPlayer, outcome)
	local str = ""
	local govName = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name);
	if actionID == 1 then
		if outcome == 1 then
			str = govName .. " (+10[ICON_ITG_POWER]) expanded a palace in " .. Map.GetPlotByIndex(data[3]):GetPlotCity():GetName() .. "."
		else
			str = govName .. " (-6[ICON_ITG_POWER]) caused a local unrest while trying to expand Palace in " .. Map.GetPlotByIndex(data[3]):GetPlotCity():GetName() .. "."
		end	
	elseif actionID == 2 then
		str = "You rejected [ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. "'s offer to expand a Palace."
		if data[2] then
			str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_GRUDGE", Locale.Lookup(GetGrudgeData(4, "Name")))
		end
	end
	return str;
end

function GovLogString7(govID, actionID, data)
	local str = ""
	if actionID == 1 then
		str = "Civil Service project proposed by [ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. " (+" .. data[4] .. "[ICON_ITG_POWER]) generated an extra " .. data[3] .. " [ICON_WORKER] Work Rate in all Cities."
		if data[1] then
			str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_CAUSE", Locale.Lookup(GetGovCauseData(9, "Name")))
		end
	elseif actionID == 2 then
		str = "You have rejected Civil Service project proposed by [ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. "."
		if data[2] then
			str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_GRUDGE", Locale.Lookup(GetGrudgeData(4, "Name")))
		end
	end
	return str;
end
function GovLogString43(govID, actionID, data)
	local str = ""
	if actionID == 1 then
		str = "You have allowed [ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. " (+" .. data[4] .. "[ICON_ITG_POWER]) to patronize artists (+" .. data[3] .. "[ICON_GREAT_ARTIST] per turn)."
	elseif actionID == 2 then
		str = "You have not allowed [ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. " to fund local artists."
		if data[2] then
			str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_GRUDGE", Locale.Lookup(GetGrudgeData(4, "Name")))
		end
	end
	return str;
end
function GovLogString49(govID, actionID, data)
	local str = ""
	if actionID == 1 then
		str = "You have allowed [ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. " (+" .. data[4] .. "[ICON_ITG_POWER]) to propagate our codex (+" .. data[3] .. "%[ICON_ITG_LAWS_INFLUENCE])."
	elseif actionID == 2 then
		str = "You have not allowed [ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. " to spread a good word about our law."
		if data[2] then
			str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_GRUDGE", Locale.Lookup(GetGrudgeData(4, "Name")))
		end
	end
	return str;
end
function GovLogString51(govID, actionID, data)
	local str = ""
	local govName = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name)
	if actionID == 1 then
		str = govName .. " has hired some [ICON_ITG_MERCENARY] Mercenaries to fight for our cause (+12[ICON_ITG_POWER])."
	elseif actionID == 2 then
		str = "You have not allowed " .. govName .. " to invite [ICON_ITG_MERCENARY] Mercenaries into our army."
		if data[2] then
			str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_GRUDGE", Locale.Lookup(GetGrudgeData(4, "Name")))
		end
		if data[1] then
			str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_CAUSE", Locale.Lookup(GetGovCauseData(12, "Name")))
		end
	end
	return str;
end
function GovLogString44(govID, actionID, data)
	local str = ""
	local govName = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name)
	if actionID == 1 then
		str = "Our goverment inspired by " .. govName .. " (+15[ICON_ITG_POWER]) adopted new Principle."
	elseif actionID == 2 then
		str = govName .. " was begging you to adopt new Principle, but you were not interested.";
	end
	return str;
end

function GovLogString30(govID, actionID, data)
	local str = ""
	local gpName = GetGreatPersonName(data[3])
	local govName = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name)
	if actionID == 1 then
		str = "We established new National Day to honour ".. gpName .. " (suggested by " .. govName .. " +25[ICON_ITG_POWER]+5[ICON_ITG_MERITOCRACY])."
	elseif actionID == 2 then
		str = "You have decided not to honour " .. gpName .. " (friend of " .. govName .. ").";
		if data[2] then
			str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_GRUDGE", Locale.Lookup(GetGrudgeData(8, "Name")))
		end
	end
	return str;
end
function GovLogString31(govID, actionID, data)
	local str = ""
	local gpName = GetGreatPersonName(data[1])
	local govName = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name)
	if actionID == 1 then
		str = "Our settlement grew into " .. Map.GetPlotByIndex(data[1]):GetPlotCity():GetName() .. " thanks to " .. govName .. " (+15[ICON_ITG_POWER])."
		if data[1] then
			str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_CAUSE", Locale.Lookup(GetGovCauseData(9, "Name")))
		end
	elseif actionID == 2 then
		str = "You disallowed mandatory relocation of your citizens to speed up a growth of settlement (suggested by " .. govName .. ").";
		if data[2] then
			str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_GRUDGE", Locale.Lookup(GetGrudgeData(4, "Name")))
		end
	end
	return str;
end
function GovLogString32(govID, actionID, data, iPlayer, outcome)
	local str = ""
	local govName = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name)
	if outcome == 1 then
		str = govName .. " was executed."
		if actionID == 1 then
			str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_CAUSE", Locale.Lookup(GetGovCauseData(13, "Name")))
			if data[2] then
				str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_CAUSE", Locale.Lookup(GetGovCauseData(15, "Name")))
			end
		elseif actionID == 2 then
			if data[2] then
				str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_CAUSE", Locale.Lookup(GetGovCauseData(13, "Name")))
			end
		elseif actionID == 3 then
			if data[2] then
				str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_CAUSE", Locale.Lookup(GetGovCauseData(13, "Name")))
			end
		elseif actionID == 4 then
			if data[2] then
				str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_CAUSE", Locale.Lookup(GetGovCauseData(13, "Name")))
			end
		end
	elseif outcome == 2 then
		str = govName .. " managed to flee the country before the execution, social unrest!"
		if data[1] then
			str = str .. " " .. GetGovernorCareerBadEffectLogString(govID)
		end
	elseif outcome == 3 then
		str = govName .. " not only managed to flee before planned execution, but also found an ally, " .. Players[data[1]]:GetCivilizationShortDescription() .. ", who declared war on us!"
	end
	return str;
end
function GovLogString50(govID, actionID, data, iPlayer, outcome)
	local str = ""
	local govName = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name)
	local posData = GetDataForGovPositionID(actionID)
	str = govName .. " was nominated to the position of " .. posData[1] .. " (+15[ICON_ITG_POWER])."
	if data[2] then
		str = str " Other [ICON_ITG_GOVERNOR] Governor(s) felt [COLOR_NEGATIVE_TEXT]Omitted[ENDCOLOR] by your decision."
	end
	return str;
end

function GovLogString33(govID, actionID, data, iPlayer, outcome)
	local str = ""
	local govName = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name)
	local playerName = Players[data[3]]:GetName()
	if actionID == 1 then
		str = govName .. " (+20[ICON_ITG_POWER]) betrayed " .. playerName .. " and joined our side, we started a war with an advantage!";
		if data[1] then
			str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_CAUSE", Locale.Lookup(GetGovCauseData(8, "Name")))
		end
	elseif actionID == 2 then
		str = "We have signed a Secret Pact with " .. govName .. " (+20[ICON_ITG_POWER]) against " .. playerName .. ".";
		if data[1] then
			str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_CAUSE", Locale.Lookup(GetGovCauseData(8, "Name")))
		end
	elseif actionID == 3 then
		str = govName .. " wanted us to cooperate against " .. playerName .. " but we were not interested."
	end
	return str;
end
function GovLogString34(govID, actionID, data, iPlayer, outcome)
	local str = ""
	local goverName = CallDataFromGovTab(data[3], "Name");
	if data[1] then
		str = "We have reestablished " .. goverName .. ".";
	else
		str = "Revolution! Our country turned into " .. goverName .. ".";
	end
	return str;
end
function GovLogString35(govID, actionID, data, iPlayer, outcome)
	local str = ""
	local govName = Locale.Lookup(gT.Globals.Governors[govID].Name)
	if actionID == 1 then
		str = govName .. " (+10[ICON_ITG_POWER]) established trade embargo on " .. Players[data[3]]:GetCivilizationShortDescription() .. "."
	elseif actionID == 2 then
		str = "You have not allowed " .. govName .. " to establish trade embargo on " .. Players[data[3]]:GetCivilizationShortDescription() .. ".";
		if data[2] then
			str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_GRUDGE", Locale.Lookup(GetGrudgeData(4, "Name")))
		end
	end
	return str;
end
function GovLogString37(govID, actionID, data, iPlayer, outcome)
	local str = ""
	local govName = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name)
	if actionID == 1 then
		str = govName .. " (+25[ICON_ITG_POWER]) is glad that you appointed [ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[data[1]].Name) .. " as a new governor."
	elseif actionID == 2 then
		str = govName .. " was disappointed that you have not appointed recommended person as a new governor.";
		if data[2] then
			str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_GRUDGE", Locale.Lookup(GetGrudgeData(8, "Name")))
		end
	end
	return str;
end
function GovLogString18(govID, actionID, data)
	local str = ""
	if actionID == 1 then
		str = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. " (+10[ICON_ITG_POWER]) supported " .. gT.Academies[data[3]].Name .. "."
	elseif actionID == 2 then
		str = "You have not allowed [ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. " to support " .. gT.Academies[data[3]].Name .. "."
		if data[2] then
			str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_GRUDGE", Locale.Lookup(GetGrudgeData(4, "Name")))
		end
	end
	return str;
end

function GovLogString22(govID, actionID, data)
	local str = ""
	if actionID == 1 then
		str = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. " (+10[ICON_ITG_POWER]) legalized our ownership of " .. Map.GetPlotByIndex(data[3]):GetPlotCity():GetName() .. "."
	elseif actionID == 2 then
		str = "You have not relied on [ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. " to legalize ownership of " .. Map.GetPlotByIndex(data[3]):GetPlotCity():GetName() .. "."
		if data[2] then
			str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_GRUDGE", Locale.Lookup(GetGrudgeData(4, "Name")))
		end
	end
	return str;
end

function GovLogString23(govID, actionID, data)
	local str = ""
	if actionID == 1 then
		str = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. " (+5[ICON_ITG_POWER]) is now providing +4 [ICON_ITG_SUPPLY] Unit Supply."
	elseif actionID == 2 then
		str = "You have not relied on [ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. " to provide [ICON_ITG_SUPPLY] Unit Supply."
		if data[2] then
			str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_GRUDGE", Locale.Lookup(GetGrudgeData(4, "Name")))
		end
		if data[1] then
			str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_CAUSE", Locale.Lookup(GetGovCauseData(12, "Name")))
		end
	end
	return str;
end
function GovLogString24(govID, actionID, data, iPlayer)
	local str = ""
	if actionID == 1 then
		str = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. " (+" .. data[5] .. "[ICON_ITG_POWER]) helped in specializing " .. Locale.Lookup(GameInfo.Units[Players[iPlayer]:GetPlayerUniqueUnit(data[3])].Description) .. " (+" .. data[4] .. "[ICON_ITG_SPECIALIZATION])."
	elseif actionID == 2 then
		str = "You were not interested in specializing your troops (proposed by [ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. ")."
		if data[2] then
			str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_GRUDGE", Locale.Lookup(GetGrudgeData(4, "Name")))
		end
		if data[1] then
			str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_CAUSE", Locale.Lookup(GetGovCauseData(12, "Name")))
		end
	end
	return str;
end
function GovLogString48(govID, actionID, data)
	local str = ""
	local govName = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name);
	if actionID == 1 then
		str = govName .. " (+12[ICON_ITG_POWER]) established contact with city-state of " .. Players[data[1]]:GetName() .. "."; 
	elseif actionID == 2 then
		str = "You were not interested in scouting unknown territories (proposed by " .. govName .. ")."
		if data[2] then
			str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_GRUDGE", Locale.Lookup(GetGrudgeData(4, "Name")))
		end
	end
	return str;
end
function GovLogString25(govID, actionID, data)
	local str = ""
	if actionID == 1 then
		str = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. " (+8[ICON_ITG_POWER]) constructed " .. Locale.Lookup(GameInfo.Buildings[data[3]].Description) .. " in " .. Map.GetPlotByIndex(data[4]):GetPlotCity():GetName() .. "."
	elseif actionID == 2 then
		str = "You were not interested in specializing your troops (proposed by [ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. ")."
		if data[2] then
			str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_GRUDGE", Locale.Lookup(GetGrudgeData(4, "Name")))
		end
	end
	return str;
end
function GovLogString38(govID, actionID, data, iPlayer, outcome)
	local str = ""
	local posString, posStringTT = GetStringFromGovPosition(data[3]);
	local govName = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name);
	if actionID == 1 then
		str = govName .. " (+10 [ICON_ITG_POWER]) became the " .. posString .. ".";
	elseif actionID == 2 then
		if outcome == 1 then
			str = "You have not granted " .. govName .. " a rank of " .. posString .. ".";
			if data[1] then
				str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_GRUDGE", Locale.Lookup(GetGrudgeData(6, "Name")))
			end
		elseif outcome == 2 then
			str = govName .. " was displeased of not being granted a rank of " .. posString .. " which lead to great social unrest."
			if data[1] then
				str = str .. " Our empire turned into Anarchy."
			end
		elseif outcome == 3 then
			str = "You have not granted " .. govName .. " a rank of " .. posString .. ".";
		end
	elseif actionID == 3 then
		if outcome == 1 then
			str = "Overambitious " .. govName .. " was executed, which lead to unrest in some cities ([ICON_HAPPINESS_4])."
			if data[1] then
				str = str .. " " .. GetGovernorCareerBadEffectLogString(govID)
			end
			str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_CAUSE", Locale.Lookup(GetGovCauseData(13, "Name")))
		else
			str = govName .. " escaped before an execution. Those events triggered [ICON_RESISTANCE] Riots"
			if data[1] then
				str = str .. " and our empire turned into Anarchy"
			end
			str = str .. "."
		end
	end
	return str;
end
function GovLogString41(govID, actionID, data, iPlayer, outcome)
	local str = "";
	local cityName = Map.GetPlotByIndex(data[5]):GetPlotCity():GetName();
	if data[3] == -1 then
		str = "You have denied newly founded city of " .. cityName .. " any help from [ICON_ITG_GOVERNOR] Governors.";
	else
		local govName = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[data[3]].Name);
		if not data[1] then
			str = "You have send " .. govName .. " to help newly founded city of " .. cityName .. ", but it was not too effective.";
		else
			if data[4] == 1 then
				str = govName .. " (+" .. data[2] .. "[ICON_ITG_POWER]) acquired new territory for " .. cityName .. ".";
			elseif data[4] == 2 then
				str = govName .. " (+" .. data[2] .. "[ICON_ITG_POWER]) attracted new [ICON_CITIZEN] Citizens into " .. cityName .. ".";
			elseif data[4] == 3 then
				str = govName .. " (+" .. data[2] .. "[ICON_ITG_POWER]) spread our [ICON_ITG_PRESENCE] Culture in " .. cityName .. ".";
			elseif data[4] == 4 then
				str = govName .. " (+" .. data[2] .. "[ICON_ITG_POWER]) constructed new buildings for " .. cityName .. ".";
			end
		end
	end
	return str;
end
function GovLogString42(govID, actionID, data, iPlayer, outcome)
	local str = "";
	local cityName = Map.GetPlotByIndex(data[5]):GetPlotCity():GetName();
	if data[3] == -1 then
		str = "You have rewarded conquerors of " .. cityName .. " with land grants.";
	else
		local govName = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[data[3]].Name);
		if not data[1] then
			str = "You have send " .. govName .. " to help newly conquered city of " .. cityName .. ", but it was not too effective.";
		else
			if data[4] == 1 then
				str = govName .. " (+" .. data[2] .. "[ICON_ITG_POWER]) increased defenses of " .. cityName .. ".";
			elseif data[4] == 2 then
				str = govName .. " (+" .. data[2] .. "[ICON_ITG_POWER]) boosted [ICON_ITG_MORALE] Morale of our soldiers upon capture of " .. cityName .. ".";
			elseif data[4] == 3 then
				str = govName .. " (+" .. data[2] .. "[ICON_ITG_POWER]) spread our [ICON_ITG_PRESENCE] Culture in " .. cityName .. ".";
			elseif data[4] == 4 then
				str = govName .. " (+" .. data[2] .. "[ICON_ITG_POWER]) silenced unhappy noises in newly captured " .. cityName .. ".";
			elseif data[4] == 5 then
				str = govName .. " (+" .. data[2] .. "[ICON_ITG_POWER]) learnt a lot from citizens of newly acquired " .. cityName .. ".";
			elseif data[4] == 6 then
				str = govName .. " (+" .. data[2] .. "[ICON_ITG_POWER]) spread our [ICON_INFLUENCE] Influence in region after conquest of " .. cityName .. ".";
			elseif data[4] == 7 then
				str = govName .. " (+" .. data[2] .. "[ICON_ITG_POWER]) decided to personally overlook the plundering of " .. cityName .. ".";
			elseif data[4] == 8 then
				str = govName .. " (+" .. data[2] .. "[ICON_ITG_POWER]) enslaved the population of " .. cityName .. ".";
			elseif data[4] == 9 then
				str = govName .. " (+" .. data[2] .. "[ICON_ITG_POWER]) prepared new legislation for " .. cityName .. ".";
			end
		end
	end
	return str;
end
function GovLogString45(govID, actionID, data, iPlayer, outcome)
	local str = "";
	if data[3] == -1 then
		str = "You have rewarded the most notable scientists (+5[ICON_ITG_MERITOCRACY]).";
	else
		local govName = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[data[3]].Name);
		if not data[1] then
			str = "You have let " .. govName .. " organize a symposium, which resulted in total failure.";
		else
			if data[4] == 1 then
				str = govName .. " (+" .. data[2] .. "[ICON_ITG_POWER]) organized international symposium ([ICON_ITG_ACADEMY_1]).";
			elseif data[4] == 2 then
				str = govName .. " (+" .. data[2] .. "[ICON_ITG_POWER]) gathered scientists to solve infrastructual issues ([ICON_WORKER]).";
			elseif data[4] == 3 then
				str = govName .. " (+" .. data[2] .. "[ICON_ITG_POWER]) organized scientific symposium ([ICON_RESEARCH]).";
			elseif data[4] == 4 then
				str = govName .. " (+" .. data[2] .. "[ICON_ITG_POWER]) gathered scientists on sophisticated party ([ICON_CULTURE]).";
			elseif data[4] == 5 then
				str = govName .. " (+" .. data[2] .. "[ICON_ITG_POWER]) asked scientists how to improve their workplaces ([ICON_ITG_ACADEMY_2]).";
			elseif data[4] == 6 then
				str = govName .. " (+" .. data[2] .. "[ICON_ITG_POWER]) gathered the most notable economists of our empire ([ICON_GOLD]).";
			elseif data[4] == 7 then
				str = govName .. " (+" .. data[2] .. "[ICON_ITG_POWER]) organized futuristic symposium.";
			end
		end
	end
	return str;
end
function GovLogString47(govID, actionID, data, iPlayer, outcome)
	local str = "";
	if data[3] == -1 then
		str = "Religious leaders gathered together to pray (+8[ICON_ITG_MERITOCRACY]).";
	else
		local govName = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[data[3]].Name);
		if not data[1] then
			str = "You have let " .. govName .. " organize a religious gathering, which resulted in total failure.";
		else
			if data[4] == 1 then
				str = govName .. " (+" .. data[2] .. "[ICON_ITG_POWER]) turned religious gathering into a celebration (+3[ICON_HAPPINESS_1]).";
			elseif data[4] == 2 then
				str = govName .. " (+" .. data[2] .. "[ICON_ITG_POWER]) asked religious leaders to resolves spiritual disputes (-5%[ICON_PROPHET]).";
			elseif data[4] == 3 then
				str = govName .. " (+" .. data[2] .. "[ICON_ITG_POWER]) focused spiritual leaders on expansion (+10[ICON_MISSIONARY]).";
			elseif data[4] == 4 then
				str = govName .. " (+" .. data[2] .. "[ICON_ITG_POWER]) mobilized religious leaders (+8[ICON_ITG_MORALE]).";
			elseif data[4] == 5 then
				str = govName .. " (+" .. data[2] .. "[ICON_ITG_POWER]) invited religious leaders of " .. Players[data[5]]:GetName() .. " to enforce our official religion there ([ICON_CITY_STATE]).";
			elseif data[4] == 6 then
				str = govName .. " (+" .. data[2] .. "[ICON_ITG_POWER]) met several very talented and spiritual people (+300[ICON_GREAT_PEOPLE]).";
			elseif data[4] == 7 then
				str = govName .. " (+" .. data[2] .. "[ICON_ITG_POWER]) was more interested in artistic aspect of faith (+400[ICON_GREAT_ARTIST]).";
			elseif data[4] == 8 then
				str = govName .. " (+" .. data[2] .. "[ICON_ITG_POWER]) reminded religious leaders that faith needs unity (+120[ICON_ITG_PRESENCE]).";
			end
		end
	end
	return str;
end
function GovLogString46(govID, actionID, data, iPlayer, outcome)
	local str = "";
	if data[3] == -1 then
		str = "You have ignored arising social unrest.";
	else
		local govName = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[data[3]].Name);
		if not data[1] then
			str = govName .. " failed in calming down unhappy citizens.";
		else
			if data[4] == 1 then
				str = govName .. " (+10[ICON_ITG_POWER]) spend some [ICON_WORKER] Work Rate to increase social [ICON_HAPPINESS_1] Happiness.";
			elseif data[4] == 2 then
				str = govName .. " (+10[ICON_ITG_POWER]) decided to eradicate [ICON_HAPPINESS_4] Unhappiness by removing unhappy citizens.";
			elseif data[4] == 3 then
				str = govName .. " (+10[ICON_ITG_POWER]) corrupted local authorities to take care of unhappy citizens.";
			elseif data[4] == 4 then
				str = govName .. " (+10[ICON_ITG_POWER]) blamed " .. Players[data[2]]:GetName() .. " for all the bad situation of our citizens.";
			elseif data[4] == 5 then
				str = govName .. " (+10[ICON_ITG_POWER]) threw some [ICON_GOLD] Gold on unhappy peasants.";
			elseif data[4] == 6 then
				str = govName .. " (+10[ICON_ITG_POWER]) started controlled [ICON_RESISTANCE] Riots to reduce tension in society.";
			elseif data[4] == 7 then
				str = govName .. " (+10[ICON_ITG_POWER]) promised some stuff we will never deliver to unhappy citizens.";
			elseif data[4] == 8 then
				str = govName .. " (+10[ICON_ITG_POWER]) started propaganda campaign to calm down unhappy citizens.";
			end
		end
	end
	return str;
end
function GovLogString40(govID, actionID, data, iPlayer, outcome)
	local str = "";
	local posString, posStringTT = GetStringFromGovPosition(data[4]);
	local goverName = CallDataFromGovTab(data[3], "Name");
	local govName = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name);
	if actionID == 1 then
		str = govName .. " (+50[ICON_ITG_POWER]) has overthrew your goverment, established " .. goverName .. " and became the " .. posString .. ".";
		str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_CAUSE", Locale.Lookup(GetGovCauseData(14, "Name")))
	elseif actionID == 2 then
		if outcome == 1 then
			str = govName .. " (caught) was stopped by your supporters while trying to establish " .. goverName .. ".";
		elseif outcome == 2 then
			str = govName .. " has challenged your goverment which lead to anarchy and great social unrest."
			if data[5] then
				str = str .. " " .. Players[data[5]]:GetName() .. " declared war on us in order to support " .. govName .. ".";
			end
		elseif outcome == 3 then
			str = "You have tried to stop " .. govName .. " (+30[ICON_ITG_POWER]) from establishing " .. goverName .. ". Unfortunately you failed and " .. govName .. " became the " .. posString .. "."
			str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_CAUSE", Locale.Lookup(GetGovCauseData(16, "Name")))
		end
	elseif actionID == 3 then
		if outcome == 1 then
			str = "You have send an assassin to deal with " .. govName .. " who tried to overthrow you!"
			if data[1] then
				str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_CAUSE", Locale.Lookup(GetGovCauseData(13, "Name")))
			end
		elseif outcome == 2 then
			str = "Your assassin failed to kill " .. govName .. " who was plotting against you. [ICON_ITG_GOVERNOR] Governor "
			if data[2] then
				str = str .. " and other conspirators "
			end
			str = str .. "fled from the state."
			if data[1] then
				str = str .. " " .. GetGovernorCareerBadEffectLogString(govID)
			end
		elseif outcome == 3 then
			str = "Your assassin could not reach treacherous " .. govName .. " who responded with empire-wide revolt, turning our state into Anarchy."
			if data[5] then
				str = str .. " " .. Players[data[5]]:GetName() .. " declared war on us in order to support " .. govName .. ".";
			end
		elseif outcome == 4 then
			str = "Your assassin failed miserable to stop supporters of " .. govName .. " from reaching a palace! After some looting the order was restored and " .. goverName .. " was established."
			str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_CAUSE", Locale.Lookup(GetGovCauseData(16, "Name")))
		end
	end
	return str;
end
function GovLogString39(govID, actionID, data, iPlayer, outcome)
	local str = ""
	local govName = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name);
	local sGovName = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[data[3]].Name);
	if actionID == 1 then
		str = "You have resolved dispute between " .. govName .. " (+10[ICON_ITG_POWER]) and " .. sGovName .. " (-30[ICON_ITG_POWER])."
		if data[2] then
			str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_GRUDGE", Locale.Lookup(GetGrudgeData(7, "Name")))
		end
	elseif actionID == 3 then
		str = "You have resolved dispute between " .. sGovName .. " (+10[ICON_ITG_POWER]) and " .. govName .. " (-30[ICON_ITG_POWER])."
		if data[2] then
			str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_GRUDGE", Locale.Lookup(GetGrudgeData(7, "Name")))
		end
	elseif actionID == 2 then
		if outcome == 1 then
			str = sGovName .. " was killed by " .. govName .. "'s supporters (+30[ICON_ITG_POWER])."
			if data[2] then
				str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_CAUSE", Locale.Lookup(GetGovCauseData(14, "Name")))
			end
		elseif outcome == 2 then
			str = govName .. " (+30[ICON_ITG_POWER]) won over territorial dispute with " .. sGovName .. " (-20[ICON_ITG_POWER])."
		elseif outcome == 3 then
			str = govName .. " is fighting for influence with " .. sGovName .. ".";
		elseif outcome == 4 then
			str = sGovName .. " (+30[ICON_ITG_POWER]) won over territorial dispute with " .. govName .. " (-20[ICON_ITG_POWER])."
		elseif outcome == 5 then
			str = govName .. " was killed by " .. sGovName .. "'s supporters (+30[ICON_ITG_POWER])."
			if data[2] then
				str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_CAUSE", Locale.Lookup(GetGovCauseData(14, "Name")))
			end
		end
	end
	return str;
end
function GovLogString26(govID, actionID, data, iPlayer, outcome)
	local str = ""
	local govName = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name);
	local relIconName = GameInfo.Religions[data[3]].IconString .. " " .. Locale.Lookup(GameInfo.Religions[data[3]].Description);
	if actionID == 1 then
		str = "Our state adopted " .. relIconName .. " as official religion. " .. govName .. " (+" .. data[1] .. "[ICON_ITG_POWER]) became a High Priest."
		if data[2] then
			str = " Some heretics tried to stop that."
		end
	elseif actionID == 2 then
		if outcome == 1 then
			str = "You have killed an initiative to establish " .. relIconName .. " as an official religion (proposed by " .. govName .. ")."
			if data[1] then
				str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_GRUDGE", Locale.Lookup(GetGrudgeData(6, "Name")))
			end
		elseif outcome == 2 then
			str = govName .. " revolted because you have not accepted " .. relIconName .. " as official religion. Heretics have spawned"
			if data[1] then
				str = str .. " and our empire turned into Anarchy"
			end
			str = str .. ".";
		elseif outcome == 3 then
			str = govName .. " couldn't stand your heresy and with the help of an ally, " .. Players[data[1]]:GetCivilizationShortDescription() .. ", declared war on us!"
		end
	elseif actionID == 3 then
		if outcome == 1 then
			str = govName .. " was executed for heretical movement, which lead to unrest in some cities ([ICON_HAPPINESS_4])."
			if data[1] then
				str = str .. " " .. GetGovernorCareerBadEffectLogString(govID)
			end
			str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_CAUSE", Locale.Lookup(GetGovCauseData(13, "Name")))
		else
			str = govName .. " escaped while being transported to meet a hangman. On this occassion we faced some [ICON_RESISTANCE] Riots and Rebels"
			if data[1] then
				str = str .. " and our empire turned into Anarchy. That wasn't a good day"
			end
			str = str .. "."
		end
	end
	return str;
end
function GovLogString27(govID, actionID, data, iPlayer, outcome)
	local str = ""
	local govName = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name);
	local csName = Players[data[3]]:GetName()
	local gCityName = Map.GetPlotByIndex(data[4]):GetPlotCity():GetName();
	local title = GetITGPlayerTitle(data[3])
	if actionID == 1 then
		if outcome == 1 then
			str = "You have annointed " .. govName .. " as " .. title .. " of " .. csName .. " (+200 [ICON_INFLUENCE]). City of " .. gCityName .. " joined " .. csName .. "."; 
		elseif outcome == 2 then
			str = "You have tried to annoint " .. govName .. " (-30[ICON_ITG_POWER]) as " .. title .. " of " .. csName .. ", but they didn't like it (-30[ICON_INFLUENCE]) and declared war on you! How rude!";
		end
	elseif actionID == 2 then
		if outcome == 1 then
			str = "You have not allowed " .. govName .. " to become a " .. title .. " of " .. csName .. "."
			if data[1] then
				str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_GRUDGE", Locale.Lookup(GetGrudgeData(6, "Name")))
			end
		elseif outcome == 2 then
			str = govName .. " abandoned you to become " .. title .. " of " .. csName .. ". Good riddance?";
		elseif outcome == 3 then
			str = govName .. " became a " .. title .. " of " .. csName .. " and betrayed you (war)!"
			if data[5] then
				str = str .. " " .. Players[data[5]]:GetName() .. " allied with " .. govName .. " and declared war on us as well.";
			end
		end
	elseif actionID == 3 then
		if outcome == 1 then
			str = govName .. " was executed for badly placed ambition (-30 [ICON_INFLUENCE] in " .. csName .. ")."
			if data[1] then
				str = str .. " " .. GetGovernorCareerBadEffectLogString(govID)
			end
			str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_CAUSE", Locale.Lookup(GetGovCauseData(13, "Name")))
		elseif outcome == 2 then
			str = govName .. " managed to flee to " .. csName .. " before an execution which lead to some social unrest and a war with " .. csName .. "."
			if data[5] then
				str = str .. " " .. Players[data[5]]:GetName() .. " allied with " .. govName .. " and declared war on us as well.";
			end
		end
	end
	return str;
end
function GovLogString28(govID, actionID, data, iPlayer, outcome)
	local str = ""
	local civName = Players[data[3]]:GetCivilizationShortDescription();
	local govName = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name);
	if actionID == 1 then
		str = govName .. " (+25[ICON_ITG_POWER]) lead us into war with " .. civName .. " (+3%[ICON_ITG_MORALE]).";
	elseif actionID == 2 then
		if outcome == 1 then
			str = "You have not mobilized an army against " .. civName .. " (initiated by " .. govName .. ")."
			if data[1] then
				str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_GRUDGE", Locale.Lookup(GetGrudgeData(6, "Name")))
			end
		elseif outcome == 2 then
			str = govName .. " started a war with " .. civName .. " without your permission!";
		elseif outcome == 3 then
			str = govName .. " was not happy that you decided not to declare war on " .. civName .. ".";
		elseif outcome == 4 then
			str = govName .. " couldn't stand your leadership anymore."
		end
	elseif actionID == 3 then
		if outcome == 1 then
			str = govName .. " was executed for excessive warmongering."
			if data[1] then
				str = str .. " " .. GetGovernorCareerBadEffectLogString(govID)
			end
			str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_CAUSE", Locale.Lookup(GetGovCauseData(13, "Name")))
			if blog2 then
				str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_CAUSE", Locale.Lookup(GetGovCauseData(12, "Name")))
			end
		elseif outcome == 2 then
			str = govName .. " didn't wait for the execution and flee from the state which lead to some unrest in the countryside."
			if data[1] then
				str = str .. " What is more, some of our command staff dediced to follow this path."
			end
		end
	end
	return str;
end
function GovLogString29(govID, actionID, data, iPlayer, outcome)
	local str = "";
	local govName = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name);
	if actionID == 1 then
		str = "You have rewarded " .. govName .. " (+" .. data[1] .. "[ICON_ITG_POWER]) for disobedience.";
		if data[2] then
			str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_CAUSE", Locale.Lookup(GetGovCauseData(14, "Name")))
		end
	elseif actionID == 2 then
		str = "You have ignored disobedience of " .. govName .. ".";
		if data[2] then
			str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_CAUSE", Locale.Lookup(GetGovCauseData(14, "Name")))
		end
	elseif actionID == 3 then
		str = "You have punished " .. govName .. " (-" .. data[1] .. "[ICON_ITG_POWER]) for disobedience.";
		if data[2] then
			str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_GRUDGE", Locale.Lookup(GetGrudgeData(7, "Name")))
		end
	elseif actionID == 4 then
		str = "You have executed " .. govName .. " for disobedience.";
		if data[2] then
			str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_CAUSE", Locale.Lookup(GetGovCauseData(13, "Name")))
		end
	end
	return str;
end
function GovLogString19(govID, actionID, data, iPlayer, outcome)
	local str = ""
	if actionID == 1 then
		if outcome == 1 then
			str = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. " (+10[ICON_ITG_POWER]) has successfully mediated with heretics of " .. gT.Heresies[data[3]].Name .. ".";
		else
			str = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. "'s (-3[ICON_ITG_POWER]) attempt to mediate with heretics of " .. gT.Heresies[data[3]].Name .. " has failed.";
		end
	elseif actionID == 2 then
		str = "You have not allowed [ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. " to mediate with heretics."
		if data[2] then
			str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_GRUDGE", Locale.Lookup(GetGrudgeData(4, "Name")))
		end
	end
	return str;
end

function GovLogString8(govID, actionID, data)
	local str = ""
	if actionID == 1 then
		str = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. " (+" .. data[4] .. "[ICON_ITG_POWER]) have established our embassy in " .. Players[data[3]]:GetCivilizationAdjective() .. " Capital."
	elseif actionID == 2 then
		str = "You have not allowed [ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. " to establish embassy in " .. Players[data[3]]:GetCivilizationAdjective() .. " Capital."
		if data[2] then
			str = str .. " " .. Locale.ConvertTextKey("TXT_KEY_GOV_ACTION_LOG_GRUDGE", Locale.Lookup(GetGrudgeData(4, "Name")))
		end
	end
	return str;
end

function GovAIAction1(iPlayer, fIndex)
	local pIndex = fIndex or 1;
	local nfg = 0
	for g, h in pairs(gT.Players[iPlayer].ForeignGovernors) do
		nfg = nfg + 1;
	end
	local chv = -gT.Players[iPlayer].GovActionsFlavors.Power + LastRandom(-gT.Players[iPlayer].GovActionsFlavors.Random, gT.Players[iPlayer].GovActionsFlavors.Random);
	chv = chv + 10;
	if nfg == 0 then
		chv = chv + 20;
	end
	if gT.Players[iPlayer].GovActionsFlavors.Foreign > 6 then
		chv = chv + gT.Players[iPlayer].GovActionsFlavors.Foreign * 10;
	elseif gT.Players[iPlayer].GovActionsFlavors.Foreign > 3 then
		chv = chv + gT.Players[iPlayer].GovActionsFlavors.Foreign * 10 - nfg * 5;
	elseif nfg < 4 then
		chv = chv + gT.Players[iPlayer].GovActionsFlavors.Foreign * 7
	end
	chv = math.max(chv, gT.Players[iPlayer].GovActionsFlavors.Random);
	if LastChance(chv) then
		return 1;
	end
	return 2;
end

function GovAIAction9(iPlayer, fIndex)
	return BasicAIChanceToTakeGovernorBasicAction(iPlayer, fIndex, GetAIFlavour(iPlayer, "FLAVOR_RECON"), gT.Players[iPlayer].GovActionsFlavors.Power, false)
end
function GovAIAction36(iPlayer, fIndex)
	return BasicAIChanceToTakeGovernorBasicAction(iPlayer, fIndex, GetAIFlavour(iPlayer, "FLAVOR_PRODUCTION"), GetAIFlavour(iPlayer, "FLAVOR_SCIENCE"), false)
end
function GovAIAction52(iPlayer, fIndex)
	return 1; -- it is designed as a freebie
end
function GovAIAction53(iPlayer, fIndex)
	local chance = 10 + 3 * GetNumAgents(iPlayer, true) + GetAIFlavour(iPlayer, "FLAVOR_ESPIONAGE");
	local pIndex = fIndex or 1;
	local govID = gT.Players[iPlayer].DiploNotes[pIndex].Governor;
	local fPlayer = gT.Globals.Governors[govID].Player;
	chance = chance + 40 * GetNumAgentsWorkingDailyInTargetPlayer(iPlayer, fPlayer);
	if LastChance(chance) then	
		return 1;
	end
	return 2;
end
function GovAIAction54(iPlayer, fIndex)
	if DoesNotSeemAsDangerToAI(iPlayer, gT.Players[iPlayer].DiploNotes[fIndex or 1].ExtraData[2]) then
		return 1;
	end
	return 2;
end
function GovAIAction10(iPlayer, fIndex)
	return BasicAIChanceToTakeGovernorBasicAction(iPlayer, fIndex, GetAIFlavour(iPlayer, "FLAVOR_ESPIONAGE"), gT.Players[iPlayer].GovActionsFlavors.Power, false)
end
function GovAIAction20(iPlayer, fIndex)
	return BasicAIChanceToTakeGovernorBasicAction(iPlayer, fIndex, GetAIFlavour(iPlayer, "FLAVOR_GOLD"), gT.Players[iPlayer].GovActionsFlavors.Power, false)
end
function GovAIAction21(iPlayer, fIndex)
	return BasicAIChanceToTakeGovernorBasicAction(iPlayer, fIndex, GetAIFlavour(iPlayer, "FLAVOR_GREAT_PEOPLE"), gT.Players[iPlayer].GovActionsFlavors.Power, false)
end
function GovAIAction11(iPlayer, fIndex)
	return BasicAIChanceToTakeGovernorBasicAction(iPlayer, fIndex, GetAIFlavour(iPlayer, "FLAVOR_DIPLOMACY"), gT.Players[iPlayer].GovActionsFlavors.Power, false)
end
function GovAIAction18(iPlayer, fIndex)
	return BasicAIChanceToTakeGovernorBasicAction(iPlayer, fIndex, GetAIFlavour(iPlayer, "FLAVOR_GOLD"), gT.Players[iPlayer].GovActionsFlavors.Power, false)
end
function GovAIAction19(iPlayer, fIndex)
	return BasicAIChanceToTakeGovernorBasicAction(iPlayer, fIndex, gT.Players[iPlayer].GovActionsFlavors.Random, GetAIFlavour(iPlayer, "FLAVOR_OFFENSE"), false)
end
function GovAIAction22(iPlayer, fIndex)
	return BasicAIChanceToTakeGovernorBasicAction(iPlayer, fIndex, GetAIFlavour(iPlayer, "FLAVOR_LEGAL"), gT.Players[iPlayer].GovActionsFlavors.Power, false)
end
function GovAIAction23(iPlayer, fIndex)
	return BasicAIChanceToTakeGovernorBasicAction(iPlayer, fIndex, GetAIFlavour(iPlayer, "FLAVOR_MILITARY_TRAINING"), gT.Players[iPlayer].GovActionsFlavors.Power, false)
end
function GovAIAction24(iPlayer, fIndex)
	return BasicAIChanceToTakeGovernorBasicAction(iPlayer, fIndex, GetAIFlavour(iPlayer, "FLAVOR_MILITARY_TRAINING"), gT.Players[iPlayer].GovActionsFlavors.Power, false)
end
function GovAIAction48(iPlayer, fIndex)
	return BasicAIChanceToTakeGovernorBasicAction(iPlayer, fIndex, GetAIFlavour(iPlayer, "FLAVOR_RECON"), gT.Players[iPlayer].GovActionsFlavors.Power, false)
end
function GovAIAction25(iPlayer, fIndex)
	return BasicAIChanceToTakeGovernorBasicAction(iPlayer, fIndex, GetAIFlavour(iPlayer, "FLAVOR_PRODUCTION"), gT.Players[iPlayer].GovActionsFlavors.Power, false)
end
function GovAIAction26(iPlayer, fIndex)
	local pIndex = fIndex or 1;
	local govID = gT.Players[iPlayer].DiploNotes[pIndex].Governor;
	local nRel = gT.Globals.Governors[govID].CityReligion
	local a1, a2, a3 = 100, 20, GetAIReasonToExecuteGovernor(iPlayer, govID);
-- official religion is not too invasive; AI should care to minimize damage
	if GetGovernorWithExtraCredentials(iPlayer, "HighPriest") then
		a1 = a1 + 100; -- cannot choose religious bonus anyway;
	end
	if Players[iPlayer]:GetReligionCreatedByPlayer() == nRel then
		a1 = a1 + 200;
	end
	if LastRandom(5, 10) <= gT.Players[iPlayer].GovActionsFlavors.Random then
		a2 = a2 + 100; -- we feel lucky to highroll
	end
	return GetRandomFromBiasedChanceTable({{1,a1}, {2, a2}, {3, a3}});
end
function GovAIAction38(iPlayer, fIndex)
	local pIndex = fIndex or 1;
	local govID = gT.Players[iPlayer].DiploNotes[pIndex].Governor;
	local a1, a2, a3 = 150, 20, GetAIReasonToExecuteGovernor(iPlayer, govID);
	if LastRandom(5, 10) <= gT.Players[iPlayer].GovActionsFlavors.Random then
		a2 = a2 + 50; -- we feel lucky to highroll
	end
	return GetRandomFromBiasedChanceTable({{1,a1}, {2, a2}, {3, a3}});
end
function GovAIAction39(iPlayer, fIndex)
	local pIndex = fIndex or 1;
	local govPower = gT.Players[iPlayer].DiploNotes[pIndex].GovernorPower;
	local sGovPower = gT.Players[iPlayer].DiploNotes[pIndex].ExtraData[2];
	if gT.Players[iPlayer].GovActionsFlavors.Conflict == 1 then
		if govPower > sGovPower then
			return 1;
		end
		return 3;
	elseif gT.Players[iPlayer].GovActionsFlavors.Conflict == 2 then
		return LastRandom(1,3)
	elseif gT.Players[iPlayer].GovActionsFlavors.Conflict == 3 then
		return 2;
	elseif gT.Players[iPlayer].GovActionsFlavors.Conflict == 4 then
		if govPower > sGovPower then
			return 3;
		end
		return 1;
	end
end
function GovAIAction41(iPlayer, fIndex)
	local pIndex = fIndex or 1;
	local cCount = 1;
	local tabOfOptions = {}
	for a, b in pairs(gT.Players[iPlayer].DiploNotes[pIndex].ExtraData.Options) do
		if gT.Players[iPlayer].Governors[b[1]] then
			local eVal = b[3];
			if b[2] == 1 then
				eVal = eVal + GetAIFlavour(iPlayer, "FLAVOR_EXPANSION")
			elseif b[2] == 2 then
				eVal = eVal + GetAIFlavour(iPlayer, "FLAVOR_GROWTH")
			elseif b[2] == 3 then
				eVal = eVal + GetAIFlavour(iPlayer, "FLAVOR_CULTURE")
			elseif b[2] == 4 then
				eVal = eVal + GetAIFlavour(iPlayer, "FLAVOR_PRODUCTION")
			end
			table.insert(tabOfOptions, {cCount, eVal})
			cCount = cCount + 1;
		end
	end
	table.insert(tabOfOptions, {cCount, 3})
	return GetRandomFromBiasedChanceTable(tabOfOptions);
end
function GovAIAction42(iPlayer, fIndex)
	local pIndex = fIndex or 1;
	local cCount = 1;
	local tabOfOptions = {}
	for a, b in pairs(gT.Players[iPlayer].DiploNotes[pIndex].ExtraData.Options) do
		if gT.Players[iPlayer].Governors[b[1]] then
			local eVal = b[3];
			if b[2] == 1 then
				eVal = eVal + GetAIFlavour(iPlayer, "FLAVOR_DEFENSE")
			elseif b[2] == 2 then
				eVal = eVal + GetAIFlavour(iPlayer, "FLAVOR_OFFENSE")
			elseif b[2] == 3 then
				eVal = eVal + GetAIFlavour(iPlayer, "FLAVOR_CULTURE")
			elseif b[2] == 4 then
				eVal = eVal + GetAIFlavour(iPlayer, "FLAVOR_HAPPINESS")
			elseif b[2] == 5 then
				eVal = eVal + GetAIFlavour(iPlayer, "FLAVOR_SCIENCE")
			elseif b[2] == 6 then
				eVal = eVal + GetAIFlavour(iPlayer, "FLAVOR_DIPLOMACY")
			elseif b[2] == 7 then
				eVal = eVal + GetAIFlavour(iPlayer, "FLAVOR_GOLD")
			elseif b[2] == 8 then
				eVal = eVal + GetAIFlavour(iPlayer, "FLAVOR_INFRASTRUCTURE")
			elseif b[2] == 9 then
				eVal = eVal + GetAIFlavour(iPlayer, "FLAVOR_LEGAL")
			end
			table.insert(tabOfOptions, {cCount, eVal})
			cCount = cCount + 1;
		end
	end
	table.insert(tabOfOptions, {cCount, 3})
	return GetRandomFromBiasedChanceTable(tabOfOptions);
end
function GovAIAction45(iPlayer, fIndex)
	local pIndex = fIndex or 1;
	local cCount = 1;
	local tabOfOptions = {}
	for a, b in pairs(gT.Players[iPlayer].DiploNotes[pIndex].ExtraData.Options) do
		if gT.Players[iPlayer].Governors[b[1]] then
			local eVal = b[3];
			if b[2] == 1 then
				eVal = eVal + GetAIFlavour(iPlayer, "FLAVOR_AUTHORITY")
			elseif b[2] == 2 then
				eVal = eVal + GetAIFlavour(iPlayer, "FLAVOR_INFRASTRUCTURE")
			elseif b[2] == 3 then
				eVal = eVal + GetAIFlavour(iPlayer, "FLAVOR_SCIENCE")
			elseif b[2] == 4 then
				eVal = eVal + GetAIFlavour(iPlayer, "FLAVOR_CULTURE")
			elseif b[2] == 5 then
				eVal = eVal + 5;
			elseif b[2] == 6 then
				eVal = eVal + GetAIFlavour(iPlayer, "FLAVOR_GOLD")
			elseif b[2] == 7 then
				eVal = eVal + LastRandom(1,9);
			end
			table.insert(tabOfOptions, {cCount, eVal})
			cCount = cCount + 1;
		end
	end
	table.insert(tabOfOptions, {cCount, 3})
	return GetRandomFromBiasedChanceTable(tabOfOptions);
end
function GovAIAction46(iPlayer, fIndex)
	local pIndex = fIndex or 1;
	local cCount = 1;
	local tabOfOptions = {}
	for a, b in pairs(gT.Players[iPlayer].DiploNotes[pIndex].ExtraData.Options) do
		if gT.Players[iPlayer].Governors[b[1]] then
			local eVal = 0;
			if b[2] == 1 then
				eVal = eVal + math.max(1, 12 - GetAIFlavour(iPlayer, "FLAVOR_INFRASTRUCTURE"))
			elseif b[2] == 2 then
				eVal = eVal + math.max(1, 12 - GetAIFlavour(iPlayer, "FLAVOR_GROWTH"))
			elseif b[2] == 3 then
				eVal = eVal + 6;
			elseif b[2] == 4 then
				eVal = eVal + math.max(1, 12 - GetAIFlavour(iPlayer, "FLAVOR_DIPLOMACY"))
			elseif b[2] == 5 then
				eVal = eVal + math.max(1, 12 - GetAIFlavour(iPlayer, "FLAVOR_GOLD"))
			elseif b[2] == 6 then
				eVal = eVal + math.max(1, 12 - GetAIFlavour(iPlayer, "FLAVOR_PRODUCTION"))
			elseif b[2] == 7 then
				eVal = eVal + math.max(1, 12 - GetAIFlavour(iPlayer, "FLAVOR_HAPPINESS"))
			elseif b[2] == 8 then
				eVal = eVal + math.max(1, 12 - GetAIFlavour(iPlayer, "FLAVOR_CULTURE"))
			end
			table.insert(tabOfOptions, {cCount, eVal})
			cCount = cCount + 1;
		end
	end
	table.insert(tabOfOptions, {cCount, math.max(1, 12 - GetAIFlavour(iPlayer, "FLAVOR_HAPPINESS"))})
	return GetRandomFromBiasedChanceTable(tabOfOptions);
end
function GovAIAction47(iPlayer, fIndex)
	local pIndex = fIndex or 1;
	local cCount = 1;
	local tabOfOptions = {}
	for a, b in pairs(gT.Players[iPlayer].DiploNotes[pIndex].ExtraData.Options) do
		if gT.Players[iPlayer].Governors[b[1]] then
			local eVal = 0;
			if b[2] == 1 then
				if Players[iPlayer]:GetNumCities() > 3 then
					eVal = eVal + GetAIFlavour(iPlayer, "FLAVOR_HAPPINESS")
				end
			elseif b[2] == 2 then
				if GetHeresyChanceRightNow(nil, nil, iPlayer) > 60 then
					eVal = eVal + GetAIFlavour(iPlayer, "FLAVOR_HAPPINESS")
				end
			elseif b[2] == 3 then
				eVal = eVal + GetAIFlavour(iPlayer, "FLAVOR_RELIGION")
			elseif b[2] == 4 then
				if gT.Players[iPlayer].Morale < 15 then
					eVal = eVal + GetAIFlavour(iPlayer, "FLAVOR_OFFENSE")
				end
			elseif b[2] == 5 then
				if Players[iPlayer]:GetReligionCreatedByPlayer() == gT.Players[iPlayer].OfficialReligion then
					eVal = eVal + GetAIFlavour(iPlayer, "FLAVOR_RELIGION")
				end
			elseif b[2] == 6 then
				eVal = eVal + GetAIFlavour(iPlayer, "FLAVOR_GREAT_PEOPLE")
			elseif b[2] == 7 then
				eVal = eVal + GetAIFlavour(iPlayer, "FLAVOR_CULTURE")
			elseif b[2] == 8 then
				if Players[iPlayer]:GetNumCities() > 3 then
					eVal = eVal + GetAIFlavour(iPlayer, "FLAVOR_CULTURE")
				end
			end
			if eVal > 0 then
				table.insert(tabOfOptions, {cCount, eVal})
			end
			cCount = cCount + 1;
		end
	end
	table.insert(tabOfOptions, {cCount, 5})
	return GetRandomFromBiasedChanceTable(tabOfOptions);
end
function GovAIAction40(iPlayer, fIndex)
	local pIndex = fIndex or 1;
	local govID = gT.Players[iPlayer].DiploNotes[pIndex].Governor;
	local govPower = gT.Players[iPlayer].DiploNotes[pIndex].GovernorPower;
	local intrigueV = gT.Players[iPlayer].DiploNotes[pIndex].Intrigue;
	local playerPower = AffectGovOutcomeWithVisibility(GetPlayerGovernorPower(iPlayer), intrigueV, true);
	local totPower = 0;
	for shgov, h in pairs(gT.Players[iPlayer].Governors) do
		if shgov ~= govID then
			totPower = totPower + math.max(gT.Globals.Governors[shgov].Power, 1);
		end
	end
	if (playerPower + totPower) / (govPower + totPower) > 0.8 then
		return 2;
	end
	if LastChance(25) then
		return 3;
	end
	return 1;
end

function GovAIAction27(iPlayer, fIndex)
	local pIndex = fIndex or 1;
	local govID = gT.Players[iPlayer].DiploNotes[pIndex].Governor;
	local csPlayer = gT.Players[iPlayer].DiploNotes[pIndex].ExtraData[1];
	local infCS = Players[csPlayer]:GetMinorCivFriendshipWithMajor(iPlayer)
	local iCity = Map.GetPlotByIndex(gT.Players[iPlayer].DiploNotes[pIndex].ExtraData[2]):GetPlotCity();
	local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
	local a1, a2, a3 = 20, 20, GetAIReasonToExecuteGovernor(iPlayer, govID);
	a1 = a1 + math.max(0, 100 - iCity:GetPopulation() * 10)
	a1 = a1 + math.max(0, Players[iPlayer]:GetNumCities() * 20 - 160);
	a1 = a1 + math.max(0, Players[csPlayer]:GetNumCities() * 20 - 20);
	local mahcity = 20 * (#gT.Cities[cID].Manufactories + #gT.Cities[cID].Academies + #gT.Cities[cID].CustomsHouses)
	if HasWonderOrRuin(iCity, true) then
		mahcity = mahcity + 20;
	end
	a2 = a2 + mahcity;
	a3 = a3 + mahcity;
	if LastRandom(5, 10) <= gT.Players[iPlayer].GovActionsFlavors.Random then
		a2 = a2 + 100; -- we feel lucky to highroll
	end
	return GetRandomFromBiasedChanceTable({{1,a1}, {2, a2}, {3, a3}});
end
function GovAIAction28(iPlayer, fIndex)
	local pIndex = fIndex or 1;
	local govID = gT.Players[iPlayer].DiploNotes[pIndex].Governor;
	local tPlayer = gT.Players[iPlayer].DiploNotes[pIndex].ExtraData[1];
	local iReasonDP = GetAIReasonToExecuteGovernor(iPlayer, govID);
	local mcApproach = Players[iPlayer]:GetMajorCivApproach(tPlayer);
	if mcApproach == MajorCivApproachTypes.MAJOR_CIV_APPROACH_WAR then
		if LastChance(iReasonDP) and LastChance(50) then
			Teams[Players[iPlayer]:GetTeam()]:DeclareWar(Players[tPlayer]:GetTeam()) -- governor will got no reward
		end
		return 1;
	end
	local a2 = 20;
	if LastRandom(5, 10) <= gT.Players[iPlayer].GovActionsFlavors.Random then
		a2 = a2 + 100; -- we feel lucky to highroll
	end
	if mcApproach == MajorCivApproachTypes.MAJOR_CIV_APPROACH_FRIENDLY then
		a2 = math.floor(a2 / 4);
	end
	return GetRandomFromBiasedChanceTable({{2, a2}, {3, iReasonDP}});
end
function GovAIAction29(iPlayer, fIndex)
	local pIndex = fIndex or 1;
	local govID = gT.Players[iPlayer].DiploNotes[pIndex].Governor;
	if gT.Players[iPlayer].GovActionsFlavors.Punish == 3 then
		if LastChance(GetAIReasonToExecuteGovernor(iPlayer, govID)) then
			return 4;
		end
	end
	return gT.Players[iPlayer].GovActionsFlavors.Punish;
end
function BasicAIChanceToTakeGovernorBasicAction(iPlayer, fIndex, val1, val2, bPower)
	local pIndex = fIndex or 1;
	local chance = 50 * val1 / val2 + LastRandom(-gT.Players[iPlayer].GovActionsFlavors.Random, gT.Players[iPlayer].GovActionsFlavors.Random)
	if bPower then
		chance = chance - gT.Players[iPlayer].DiploNotes[pIndex].GovernorPower / (15 - gT.Players[iPlayer].GovActionsFlavors.Power);
	end
	chance = math.max(math.floor(chance), gT.Players[iPlayer].GovActionsFlavors.Random);
	if LastChance(chance) then
		return 1;
	end
	return 2;
end

function GovAIAction2(iPlayer, fIndex)
	return BasicAIChanceToTakeGovernorBasicAction(iPlayer, fIndex, GetAIFlavour(iPlayer, "FLAVOR_GOLD"), GetAIFlavour(iPlayer, "FLAVOR_HAPPINESS"), true)
end

function GovAIAction3(iPlayer, fIndex)
	local pIndex = fIndex or 1;
	local govPower = gT.Players[iPlayer].DiploNotes[pIndex].GovernorPower
	local meritocracygained = gT.Players[iPlayer].DiploNotes[pIndex].ExtraData[3];
	local powerF = gT.Players[iPlayer].GovActionsFlavors.Power;
	local hapF = GetAIFlavour(iPlayer, "FLAVOR_HAPPINESS");
	local chance = meritocracygained * 4 + LastRandom(-gT.Players[iPlayer].GovActionsFlavors.Random, gT.Players[iPlayer].GovActionsFlavors.Random)
	chance = chance - govPower / (15 - powerF) - Players[iPlayer]:GetNumCities() * gT.Players[iPlayer].DiploNotes[pIndex].ExtraData[2] / (20 - hapF);
	chance = math.max(math.floor(chance), gT.Players[iPlayer].GovActionsFlavors.Random);
	if LastChance(chance) then
		return 1;
	end
	return 2;
end

function GovAIAction33(iPlayer, fIndex)
	local pIndex = fIndex or 1;
	local tPlayer = gT.Players[iPlayer].DiploNotes[pIndex].ExtraData[1];
	local mcApproach = Players[iPlayer]:GetMajorCivApproach(tPlayer);
	if mcApproach == MajorCivApproachTypes.MAJOR_CIV_APPROACH_WAR then
		if LastChance(60) then
			return 1;
		end
	elseif mcApproach == MajorCivApproachTypes.MAJOR_CIV_APPROACH_FRIENDLY then
		return 3;
	elseif mcApproach == MajorCivApproachTypes.MAJOR_CIV_APPROACH_NEUTRAL then
		if LastChance(50) then
			return 3;
		end
	elseif mcApproach == MajorCivApproachTypes.MAJOR_CIV_APPROACH_AFRAID then
		if LastChance(80) then
			return 3;
		end
	elseif mcApproach == MajorCivApproachTypes.MAJOR_CIV_APPROACH_GUARDED then
		if GetMilitaryMightDemographics(iPlayer, iPlayer) > 1.5 * GetMilitaryMightDemographics(iPlayer, tPlayer) then
			return 1;
		end
		if LastChance(33) then
			return 3;
		end
	elseif mcApproach == MajorCivApproachTypes.MAJOR_CIV_APPROACH_HOSTILE then
		return 2;
	end
	return 2;
end
function GovAIAction34(iPlayer, fIndex)
	local pIndex = fIndex or 1;
	local evals = {}
	for a, govData in pairs(gT.Players[iPlayer].DiploNotes[pIndex].ExtraData[1]) do
		local baseEval = 20 + gT.Players[iPlayer].GovActionsFlavors.Random;
		if govData.Old then
			baseEval = baseEval - 15;
		end
		for b, gov in pairs(govData.Support) do
			baseEval = baseEval - gT.Players[iPlayer].GovActionsFlavors.Power;
		end

		table.insert(evals, {a, math.max(1, baseEval)})
	end
	return GetRandomFromBiasedChanceTable(evals);
end
function GovAIAction4(iPlayer, fIndex)
	return BasicAIChanceToTakeGovernorBasicAction(iPlayer, fIndex, GetAIFlavour(iPlayer, "FLAVOR_DIPLOMACY"), gT.Players[iPlayer].GovActionsFlavors.Power, false)
end
function GovAIAction5(iPlayer, fIndex)
	return BasicAIChanceToTakeGovernorBasicAction(iPlayer, fIndex, GetAIFlavour(iPlayer, "FLAVOR_RELIGION"), gT.Players[iPlayer].GovActionsFlavors.Power, false)
end
function GovAIAction6(iPlayer, fIndex)
	return BasicAIChanceToTakeGovernorBasicAction(iPlayer, fIndex, GetAIFlavour(iPlayer, "FLAVOR_RELIGION"), gT.Players[iPlayer].GovActionsFlavors.Power, false)
end
function GovAIAction7(iPlayer, fIndex)
	return BasicAIChanceToTakeGovernorBasicAction(iPlayer, fIndex, GetAIFlavour(iPlayer, "FLAVOR_INFRASTRUCTURE"), gT.Players[iPlayer].GovActionsFlavors.Power, false)
end
function GovAIAction43(iPlayer, fIndex)
	return BasicAIChanceToTakeGovernorBasicAction(iPlayer, fIndex, GetAIFlavour(iPlayer, "FLAVOR_CULTURE"), gT.Players[iPlayer].GovActionsFlavors.Power, false)
end
function GovAIAction49(iPlayer, fIndex)
	return BasicAIChanceToTakeGovernorBasicAction(iPlayer, fIndex, GetAIAttitudeTowardCodexStrength(iPlayer), gT.Players[iPlayer].GovActionsFlavors.Power, false)
end
function GovAIAction51(iPlayer, fIndex)
	return BasicAIChanceToTakeGovernorBasicAction(iPlayer, fIndex, GetAIFlavour(iPlayer, "FLAVOR_OFFENSE") + 2, gT.Players[iPlayer].GovActionsFlavors.Power, false)
end
function GovAIAction44(iPlayer, fIndex)
	return BasicAIChanceToTakeGovernorBasicAction(iPlayer, fIndex, GetAIFlavour(iPlayer, "FLAVOR_LEGAL") * 2, gT.Players[iPlayer].GovActionsFlavors.Power, false)
end
function GovAIAction30(iPlayer, fIndex)
	return 1; --hmm, right now it is just good value and should be rare
end
function GovAIAction31(iPlayer, fIndex)
	return BasicAIChanceToTakeGovernorBasicAction(iPlayer, fIndex, GetAIFlavour(iPlayer, "FLAVOR_EXPANSION"), GetAIFlavour(iPlayer, "FLAVOR_HAPPINESS"), true)
end
function GovAIAction35(iPlayer, fIndex)
	return BasicAIChanceToTakeGovernorBasicAction(iPlayer, fIndex, GetAIFlavour(iPlayer, "FLAVOR_DISRUPTIVE"), gT.Players[iPlayer].GovActionsFlavors.Power, false)
end
function GovAIAction37(iPlayer, fIndex)
	return BasicAIChanceToTakeGovernorBasicAction(iPlayer, fIndex, GetAIFlavour(iPlayer, "FLAVOR_LEGAL"), gT.Players[iPlayer].GovActionsFlavors.Power, false)
end
function GovAIAction8(iPlayer, fIndex)
	return BasicAIChanceToTakeGovernorBasicAction(iPlayer, fIndex, GetAIFlavour(iPlayer, "FLAVOR_DIPLOMACY"), gT.Players[iPlayer].GovActionsFlavors.Power, false)
end
function GovAIAction15(iPlayer, fIndex)
	return BasicAIChanceToTakeGovernorBasicAction(iPlayer, fIndex, GetAIFlavour(iPlayer, "FLAVOR_PRESENCE"), GetAIFlavour(iPlayer, "FLAVOR_HAPPINESS"), true)
end
function GovAIAction16(iPlayer, fIndex)
	return BasicAIChanceToTakeGovernorBasicAction(iPlayer, fIndex, GetAIFlavour(iPlayer, "FLAVOR_AUTHORITY"), GetAIFlavour(iPlayer, "FLAVOR_HAPPINESS"), true)
end
function GovAIAction12(iPlayer, fIndex)
	local pIndex = fIndex or 1;
	local govID = gT.Players[iPlayer].DiploNotes[pIndex].Governor;
	local chance = gT.Players[iPlayer].GovActionsFlavors.Foreign + LastRandom(-gT.Players[iPlayer].GovActionsFlavors.Random, gT.Players[iPlayer].GovActionsFlavors.Random);
	chance = chance + gT.Globals.Governors[govID].ForeignContacts[iPlayer].Favour;
	chance = chance + 3 * Players[iPlayer]:GetNumCities();
	chance = math.max(chance, gT.Players[iPlayer].GovActionsFlavors.Random);
	if LastChance(chance) then
		return 1;
	end
	return 2;
end
function GovAIAction13(iPlayer, fIndex)
	return 1; -- for now we accept all assigned requests
end

dgActions = {
	{ID = 1, Name = "Establish relations", GovActionType = -1, ConsiderFunc = GovConsiderAction1, ResolveFunc = GovActionResolve1, AIFunc = GovAIAction1, LogString = GovLogString1, PreTurn = 90},
{ID = 2, Name = "Collect Extra Taxes", GovActionType = 1, ConsiderFunc = GovConsiderAction2, ResolveFunc = GovActionResolve2, AIFunc = GovAIAction2, LogString = GovLogString2, NoRepeat = true, ExtraData = GovActionExtraData2, PreTurn = 96},
{ID = 3, Name = "Expose Corruption", GovActionType = 1, ConsiderFunc = GovConsiderAction3, ResolveFunc = GovActionResolve3, AIFunc = GovAIAction3, LogString = GovLogString3, NoRepeat = true, ExtraData = GovActionExtraData3, PreTurn = 96},
{ID = 4, Name = "Influence City-State", GovActionType = 1, ConsiderFunc = GovConsiderAction4, ResolveFunc = GovActionResolve4, AIFunc = GovAIAction4, LogString = GovLogString4, NoRepeat = true, ExtraData = GovActionExtraData4, PreTurn = 92},
{ID = 5, Name = "Share Intel", GovActionType = 1, ConsiderFunc = GovConsiderAction5, ResolveFunc = GovActionResolve5, AIFunc = GovAIAction5, LogString = GovLogString5, NoRepeat = true, ExtraData = GovActionExtraData5, PreTurn = 88},
{ID = 6, Name = "Sponsour Missionaries", GovActionType = 1, ConsiderFunc = GovConsiderAction6, ResolveFunc = GovActionResolve6, AIFunc = GovAIAction6, LogString = GovLogString6, NoRepeat = true, Sc = {[1] = true, [2] = true, [3] = true}, ExtraData = GovActionExtraData6, PreTurn = 94},
{ID = 7, Name = "Civil Service", GovActionType = 1, ConsiderFunc = GovConsiderAction7, ResolveFunc = GovActionResolve7, AIFunc = GovAIAction7, LogString = GovLogString7, NoRepeat = true, ExtraData = GovActionExtraData7, PreTurn = 93},
{ID = 8, Name = "Establish Embassy", GovActionType = 1, ConsiderFunc = GovConsiderAction8, ResolveFunc = GovActionResolve8, AIFunc = GovAIAction8, LogString = GovLogString8, NoRepeat = true, ExtraData = GovActionExtraData8, PreTurn = 88},
	{ID = 9, Name = "Maps", GovActionType = 3, ConsiderFunc = GovConsiderAction9, ResolveFunc = GovActionResolve9, AIFunc = GovAIAction9, LogString = GovLogString9, ExtraData = GovActionExtraData9, Sc = {[1] = true, [2] = true, [3] = true}, PreTurn = 92},
	{ID = 10, Name = "Expose Spy", GovActionType = 3, ConsiderFunc = GovConsiderAction10, ResolveFunc = GovActionResolve10, AIFunc = GovAIAction10, LogString = GovLogString10, ExtraData = GovActionExtraData10, PreTurn = 96},
	{ID = 11, Name = "Influence Voting", GovActionType = 3, ConsiderFunc = GovConsiderAction11, ResolveFunc = GovActionResolve11, AIFunc = GovAIAction11, LogString = GovLogString11, ExtraData = GovActionExtraData11},
	{ID = 12, Name = "Offer Service", GovActionType = -1, ConsiderFunc = GovConsiderAction12, ResolveFunc = GovActionResolve12, AIFunc = GovAIAction12, LogString = GovLogString12, Betrayal = true, PreTurn = 85},
		{ID = 13, Name = "Asking for Assigment", GovActionType = -1, ConsiderFunc = GovConsiderAction13, ResolveFunc = GovActionResolve13, AIFunc = GovAIAction13, LogString = GovLogString13, ExtraData = GovActionExtraData13},
		{ID = 14, Name = "Follow Religion", GovActionType = -1, ConsiderFunc = GovConsiderAction14, Sc = {[1] = true, [2] = true, [3] = true}},
{ID = 15, Name = "Cultural nationalization", GovActionType = 1, ConsiderFunc = GovConsiderAction15, ResolveFunc = GovActionResolve15, AIFunc = GovAIAction15, LogString = GovLogString15, NoRepeat = true, ExtraData = GovActionExtraData15, PreTurn = 92},
{ID = 16, Name = "Expand Palace", GovActionType = 1, ConsiderFunc = GovConsiderAction16, ResolveFunc = GovActionResolve16, AIFunc = GovAIAction16, LogString = GovLogString16, NoRepeat = true, ExtraData = GovActionExtraData16, PreTurn = 98},
		{ID = 17, Name = "Favourite Goverment", GovActionType = -1, GovActionType = -1, ConsiderFunc = GovConsiderAction17},
{ID = 18, Name = "Support Academy", GovActionType = 1, ConsiderFunc = GovConsiderAction18, ResolveFunc = GovActionResolve18, AIFunc = GovAIAction18, LogString = GovLogString18, NoRepeat = true, ExtraData = GovActionExtraDataJustPass, Sc = {[1] = true, [2] = true, [3] = true, [4] = true}, PreTurn = 97},
{ID = 19, Name = "Persuade Heretics", GovActionType = 1, ConsiderFunc = GovConsiderAction19, ResolveFunc = GovActionResolve19, AIFunc = GovAIAction19, LogString = GovLogString19, NoRepeat = true, ExtraData = GovActionExtraDataJustPass},
	{ID = 20, Name = "Influence Traders", GovActionType = 3, ConsiderFunc = GovConsiderAction20, ResolveFunc = GovActionResolve20, AIFunc = GovAIAction20, LogString = GovLogString20, PreTurn = 84},
	{ID = 21, Name = "Invite Great Person", GovActionType = 3, ConsiderFunc = GovConsiderAction21, ResolveFunc = GovActionResolve21, AIFunc = GovAIAction21, LogString = GovLogString21, ExtraData = GovActionExtraData21, PreTurn = 92},
{ID = 22, Name = "Legalize Conquest", GovActionType = 1, ConsiderFunc = GovConsiderAction22, ResolveFunc = GovActionResolve22, AIFunc = GovAIAction22, LogString = GovLogString22, NoRepeat = true, ExtraData = GovActionExtraDataJustPass, PreTurn = 95},
{ID = 23, Name = "Supply Troops", GovActionType = 1, ConsiderFunc = GovConsiderAction23, ResolveFunc = GovActionResolve23, AIFunc = GovAIAction23, LogString = GovLogString23, NoRepeat = true, PreTurn = 92},
{ID = 24, Name = "Develop Army", GovActionType = 1, ConsiderFunc = GovConsiderAction24, ResolveFunc = GovActionResolve24, AIFunc = GovAIAction24, LogString = GovLogString24, NoRepeat = true, ExtraData = GovActionExtraData24, PreTurn = 88},
{ID = 25, Name = "Construct Building", GovActionType = 1, ConsiderFunc = GovConsiderAction25, ResolveFunc = GovActionResolve25, AIFunc = GovAIAction25, LogString = GovLogString25, Sc = {[1] = true, [2] = true, [3] = true, [4] = true}, ExtraData = GovActionExtraDataJustPass, PreTurn = 95},
		{ID = 26, Name = "Official Religion", GovActionType = 2, ConsiderFunc = GovConsiderAction26, ResolveFunc = GovActionResolve26, AIFunc = GovAIAction26, LogString = GovLogString26, NoRepeat = true, Sc = {[1] = true, [2] = true, [3] = true}, ExtraData = GovActionExtraDataJustPass, PreTurn = 95},
		{ID = 27, Name = "New Kingdom", GovActionType = 2, ConsiderFunc = GovConsiderAction27, ResolveFunc = GovActionResolve27, AIFunc = GovAIAction27, LogString = GovLogString27, NoRepeat = true, ExtraData = GovActionExtraDataJustPass, PreTurn = 95},
		{ID = 28, Name = "Into the War", GovActionType = 2, ConsiderFunc = GovConsiderAction28, ResolveFunc = GovActionResolve28, AIFunc = GovAIAction28, LogString = GovLogString28, NoRepeat = true, ExtraData = GovActionExtraDataJustPass, PreTurn = 90},
		{ID = 29, Name = "Punishment", GovActionType = -1, ResolveFunc = GovActionResolve29, AIFunc = GovAIAction29, LogString = GovLogString29, ExtraData = GovActionExtraDataJustPass},
{ID = 30, Name = "National Day", GovActionType = 1, ConsiderFunc = GovConsiderAction30, ResolveFunc = GovActionResolve30, AIFunc = GovAIAction30, LogString = GovLogString30, NoRepeat = true, ExtraData = GovActionExtraDataJustPass, PreTurn = 98},
{ID = 31, Name = "New Settlement", GovActionType = 1, ConsiderFunc = GovConsiderAction31, ResolveFunc = GovActionResolve31, AIFunc = GovAIAction31, LogString = GovLogString31, NoRepeat = true, ExtraData = GovActionExtraDataJustPass, Sc = {[1] = true, [3] = true}},
		{ID = 32, Name = "Execution", GovActionType = -1, ResolveFunc = GovActionResolve32, LogString = GovLogString32},
	{ID = 33, Name = "Secret Pact", GovActionType = -1, ConsiderFunc = GovConsiderAction33, ResolveFunc = GovActionResolve33, AIFunc = GovAIAction33, LogString = GovLogString33, Betrayal = true, PreTurn = 90},
		{ID = 34, Name = "Centralize Power", GovActionType = -1, ResolveFunc = GovActionResolve34, AIFunc = GovAIAction34, LogString = GovLogString34, ExtraData = GovActionExtraDataJustPass, BlocksCPAction = true},
{ID = 35, Name = "Trade Embargo", GovActionType = 1, ConsiderFunc = GovConsiderAction35, ResolveFunc = GovActionResolve35, AIFunc = GovAIAction35, LogString = GovLogString35, NoRepeat = true, ExtraData = GovActionExtraDataJustPass, PreTurn = 90},
	{ID = 36, Name = "Share knowledge", GovActionType = 3, ConsiderFunc = GovConsiderAction36, ResolveFunc = GovActionResolve36, AIFunc = GovAIAction36, LogString = GovLogString36, ExtraData = GovActionExtraData36, PreTurn = 91},
{ID = 37, Name = "Recommendation", GovActionType = 1, ConsiderFunc = GovConsiderAction37, ResolveFunc = GovActionResolve37, AIFunc = GovAIAction37, LogString = GovLogString37, NoRepeat = true, PreTurn = 82},
		{ID = 38, Name = "Nomination", GovActionType = -1, ConsiderFunc = GovConsiderAction38, ResolveFunc = GovActionResolve38, AIFunc = GovAIAction38, LogString = GovLogString38, NoRepeat = true, ExtraData = GovActionExtraDataJustPass, PreTurn = 92},
		{ID = 39, Name = "Conflict", GovActionType = -1, ConsiderFunc = GovConsiderAction39, ResolveFunc = GovActionResolve39, AIFunc = GovAIAction39, LogString = GovLogString39, NoRepeat = true, ExtraData = GovActionExtraDataJustPass, PreTurn = 95},
		{ID = 40, Name = "Revolution", GovActionType = -1, ConsiderFunc = GovConsiderAction40, ResolveFunc = GovActionResolve40, AIFunc = GovAIAction40, LogString = GovLogString40, NoRepeat = true, ExtraData = GovActionExtraDataJustPass, Betrayal = true, PreTurn = 88, BlocksCPAction = true},
		{ID = 41, Name = "New City", GovActionType = -1, ResolveFunc = GovActionResolve41, AIFunc = GovAIAction41, LogString = GovLogString41, ExtraData = GovActionExtraDataJustPass},
		{ID = 42, Name = "Conquest", GovActionType = -1, ResolveFunc = GovActionResolve42, AIFunc = GovAIAction42, LogString = GovLogString42, ExtraData = GovActionExtraDataJustPass},
{ID = 43, Name = "Patronize Art", GovActionType = 1, ConsiderFunc = GovConsiderAction43, ResolveFunc = GovActionResolve43, AIFunc = GovAIAction43, LogString = GovLogString43, ExtraData = GovActionExtraData43, PreTurn = 82},
{ID = 44, Name = "New Principle", GovActionType = 1, ConsiderFunc = GovConsiderAction44, ResolveFunc = GovActionResolve44, AIFunc = GovAIAction44, LogString = GovLogString44, ExtraData = GovActionExtraDataJustPass, PreTurn = 98},
		{ID = 45, Name = "Symposium", GovActionType = -1, ResolveFunc = GovActionResolve45, AIFunc = GovAIAction45, LogString = GovLogString45, ExtraData = GovActionExtraDataJustPass}, 
		{ID = 46, Name = "For the People", GovActionType = -1, ResolveFunc = GovActionResolve46, AIFunc = GovAIAction46, LogString = GovLogString46, ExtraData = GovActionExtraDataJustPass}, 
		{ID = 47, Name = "The Gathering", GovActionType = -1, ResolveFunc = GovActionResolve47, AIFunc = GovAIAction47, LogString = GovLogString47, ExtraData = GovActionExtraDataJustPass}, 
{ID = 48, Name = "Expedition", GovActionType = 1, ConsiderFunc = GovConsiderAction48, ResolveFunc = GovActionResolve48, AIFunc = GovAIAction48, LogString = GovLogString48, NoRepeat = true, PreTurn = 85},
{ID = 49, Name = "Propagate Codex", GovActionType = 1, ConsiderFunc = GovConsiderAction49, ResolveFunc = GovActionResolve49, AIFunc = GovAIAction49, LogString = GovLogString49, ExtraData = GovActionExtraData49, PreTurn = 82},
		{ID = 50, Name = "Nomination", GovActionType = -1, ResolveFunc = GovActionResolve50, LogString = GovLogString50},
{ID = 51, Name = "Sponsour Mercenaries", GovActionType = 1, ConsiderFunc = GovConsiderAction51, ResolveFunc = GovActionResolve51, AIFunc = GovAIAction51, LogString = GovLogString51, PreTurn = 92},
	{ID = 52, Name = "Introductions", GovActionType = 3, ConsiderFunc = GovConsiderAction52, ResolveFunc = GovActionResolve52, AIFunc = GovAIAction52, LogString = GovLogString52, ExtraData = GovActionExtraDataJustPass, PreTurn = 75},
	{ID = 53, Name = "Spy Protection", GovActionType = 3, ConsiderFunc = GovConsiderAction53, ResolveFunc = GovActionResolve53, AIFunc = GovAIAction53, LogString = GovLogString53, PreTurn = 75},
		{ID = 54, Name = "Request Support", GovActionType = -1, ResolveFunc = GovActionResolve54, AIFunc = GovAIAction54, LogString = GovLogString54, ExtraData = GovActionExtraDataJustPass},
}

--[[
-1. special actions
1. minor internal actions
2. big internal actions
3. Foreign minor favours
]]--

local tGovActionByTypes = {};
for a, b in pairs(dgActions) do
	local hIndex = b.GovActionType;
	if not tGovActionByTypes[hIndex] then
		tGovActionByTypes[hIndex] = {};
	end
	table.insert(tGovActionByTypes[hIndex], a);
end

function DoGovernorsActions(iPlayer)
	local gTurn = GetITGGameTurn();
	for govID, bool in pairs(gT.Players[iPlayer].Governors) do
		local govData = gT.Globals.Governors[govID];
		if govData.QueueForeignSupport then
			GovernorDoQueuedAction(govID, iPlayer)
			gT.Globals.Governors[govID].QueueForeignSupport = nil;
		else
			local cTC = ((gTurn - govData.LastTAction) / 2 + govData.Character.Decisiveness) * gT.Players[iPlayer].GovActivityMod
			if LastRandom(1,100) <= cTC then
				GovernorConsiderActionToMake(govID, iPlayer)
			end
			for sGov, hhh in pairs(gT.Players[iPlayer].Governors) do
				if sGov ~= govID then
					DoOnTurnGovRelationChange(govID, sGov, iPlayer)
				end
			end
		end
	end
end

function StrayGovernorsDoTurn()
	local gTurn = GetITGGameTurn();
	for govID, sth in pairs(gT.Globals.Governors) do
		if IsGovernorActive(govID) and ((sth.Player == -1) or (not Players[sth.Player]:IsAlive())) then
			local govData = gT.Globals.Governors[govID];
			local cTC = (gTurn - govData.LastTAction) / 2 + govData.Character.Decisiveness * 4;
			if LastRandom(1,100) <= cTC then
				GovernorConsiderActionToMake(govID, sth.Player)
			end
		end
	end
end

function CanGovernorDoBetrayalAction(govID)
	local govData = gT.Globals.Governors[govID];
	local iPlayer = govData.Player;
	if (iPlayer == -1) then
		return true;
	end
	if govData.LoyaltyType ~= 1 and govData.LoyaltyType ~= 2 then
		return false;
	end
	if HasPlayerTech(iPlayer, csInno32, "vkofkoewa") then
		return false;
	end
	if HasPlayerTech(iPlayer, empireInno14, "empireInno14") then
		return false;
	end
	return true;
end

function DoGovernorConsiderActionIfPossible(govID, actionID, bForce)
	if gAlreadyConsidered[actionID] then
		return false;
	end
	gAlreadyConsidered[actionID] = true;
	if (not dgActions[actionID].NoRepeat) or (not HasPlayerDiploNoteOfTypeWaiting(gT.Globals.Governors[govID].Player, actionID)) then
		if bForce then
			return dgActions[actionID].ConsiderFunc(govID, actionID, true);
		end
		if (not dgActions[actionID].Sc) or (dgActions[actionID].Sc[gT.Globals.ScenarioType]) then
			if (not dgActions[actionID].Betrayal) or (CanGovernorDoBetrayalAction(govID)) then
				if (not dgActions[actionID].PreTurn) or (GetITGGameTurn() <= dgActions[actionID].PreTurn) then
					return dgActions[actionID].ConsiderFunc(govID, actionID);
				end
			end
		end
	end
	return false;
end

function GovernorDoQueuedAction(govID, iPlayer)
	local actionType = gT.Globals.Governors[govID].QueueForeignSupport[1];
	local sPlayer = gT.Globals.Governors[govID].QueueForeignSupport[2];
	if not gT.Globals.Governors[govID].City then
		return;
	end
	if sPlayer and (Players[sPlayer]:GetNumCities() == 0) then
		return;
	end
	if actionType == 40 then
		if gT.Players[iPlayer].Goverment == 1 then
			return;
		end
		local pos = GetBestPositionToAspireTo(govID, iPlayer);
		if not pos then
			return;
		end
		GenerateDiploNote(iPlayer, govID, actionType, {gT.Globals.Governors[govID].Goverment, pos, sPlayer})
	elseif actionType == 27 then
		local csPlayer = gT.Globals.Governors[govID].QueueForeignSupport[3];
		local iCity = Map.GetPlotByIndex(gT.Globals.Governors[govID].City):GetPlotCity();
		local cID = iCity:Plot():GetPlotIndex() .. "," .. iCity:GetGameTurnFounded();
		local csCityPlot;
		local optionGifts = {};
		if not iCity:IsOriginalMajorCapital() then
			table.insert(optionGifts, iCity:Plot():GetPlotIndex())
		end
		for h, sIndex in pairs(GetNearCities(cID, GetGovernorRange(iPlayer, govID))) do
			local sCity = Map.GetPlotByIndex(sIndex):GetPlotCity();
			local osPlayer = sCity:GetOwner();
			if osPlayer == iPlayer then
				if not sCity:IsOriginalMajorCapital() then
					local sID = sCity:Plot():GetPlotIndex() .. "," .. sCity:GetGameTurnFounded();
					if gT.Cities[sID].Governor == govID then
						table.insert(optionGifts, sCity:Plot():GetPlotIndex())
					end
				end
			elseif osPlayer == csPlayer then
				if not csCityPlot then
					if not Teams[Players[osPlayer]:GetTeam()]:IsAtWar(Players[iPlayer]:GetTeam()) then
						if not gT.Players[osPlayer].GovAsLeader then
							local influence = Players[osPlayer]:GetMinorCivFriendshipWithMajor(iPlayer)
							if influence > 0 then
								csCityPlot = sCity:Plot();
							end
						end
					end
				end
			end
		end
		if csCityPlot then
			local hDist, gCityPlot = 999, nil;
			for i, hindex in pairs(optionGifts) do
				local hPlot = Map.GetPlotByIndex(hindex);
				local mDis = Map.PlotDistance(csCityPlot:GetX(), csCityPlot:GetY(), hPlot:GetX(), hPlot:GetY())
				if mDis < hDist then
					gCityPlot = hindex;
					hDist = mDis;
				end
			end
			GenerateDiploNote(iPlayer, govID, actionType, {csPlayer, gCityPlot, csCityPlot:GetPlotIndex(), sPlayer})
		end
	elseif actionType == 26 then
		if (Players[iPlayer]:GetReligionCreatedByPlayer() > 0) then
			return;
		end
		if gT.Players[iPlayer].OfficialReligion == gT.Globals.Governors[govID].CityReligion then
			return;
		end
		GenerateDiploNote(iPlayer, govID, actionType, {sPlayer})
	end
end

function GovernorConsiderActionToMake(govID, iPlayer)
-- it will be complicated logic function
	gAlreadyConsidered = {}
	local govData = gT.Globals.Governors[govID];
	if iPlayer == -1 then -- exiled governors will try to find new home
		if DoGovernorConsiderActionIfPossible(govID, 12) then return; end
		if DoGovernorConsiderActionIfPossible(govID, 1) then return; end
		return;
	elseif not Players[iPlayer]:IsAlive() then -- governors of not alive player will try to find new home
		if DoGovernorConsiderActionIfPossible(govID, 12) then return; end
		if DoGovernorConsiderActionIfPossible(govID, 1) then return; end
		return;
	end
	if gT.Globals.Governors[govID].City then
		if GovernorDreamActionToMake(govID, iPlayer) then return; end
	end
	gAlreadyConsidered = {}; -- clear so dream action can actually chance twice
	if DoGovernorConsiderActionIfPossible(govID, 40) then return; end -- revolution first
	local percentHap = GovEvalOfSituationInState(govID)
	local percentSecurePost = GovEvalOfHisPositionInState(govID, iPlayer)
--	table.insert(gT.Globals.logGovCATM, {iPlayer, percentHap, percentSecurePost})
	if LastChance(5) then
		DoGovernorConsiderActionIfPossible(govID, 17) -- adopt favourite goverment
	end
	for a, b in pairs(Shuffle({1,2})) do
		if b == 1 then
			if gT.Globals.Governors[govID].City then
				if LastChance(7) then
					DoGovernorConsiderActionIfPossible(govID, 14) -- adopt religion
				end
				-- placed governors may offer some help
				if not LastChance(percentSecurePost) then -- no longer bothers
					if (not gT.Globals.Governors[govID].Grudges[4]) or (LastRandom(1,2 + gT.Globals.Governors[govID].Grudges[4]) == 2) then
						for i, actionID in pairs(Shuffle(tGovActionByTypes[1])) do
							if DoGovernorConsiderActionIfPossible(govID, actionID) then return; end
						end
					end
				else
					for i, actionID in pairs(Shuffle(tGovActionByTypes[2])) do
						if DoGovernorConsiderActionIfPossible(govID, actionID) then return; end
					end
				end
			else
				if DoGovernorConsiderActionIfPossible(govID, 13) then return; end
			end
		elseif b == 2 then
			--foreign minor actions
			for i, actionID in pairs(Shuffle(tGovActionByTypes[3])) do
				if DoGovernorConsiderActionIfPossible(govID, actionID) then return; end
			end
		end
	end
	local iBetrayalTreshold = GetTresholdForGovernorBetrayal(govID, iPlayer); -- 30 base;
	if gT.Globals.Governors[govID].City then
		if (percentHap < iBetrayalTreshold) then
			if DoGovernorConsiderActionIfPossible(govID, 33) then return; end
		end
	end
	if (percentHap < iBetrayalTreshold + 30) and (percentSecurePost < iBetrayalTreshold - 5) then
		local hChance = iBetrayalTreshold + 30;
		if not gT.Globals.Governors[govID].City then
			hChance = hChance + 20;
			if gT.Globals.Governors[govID].ProposalsMade[13] then
				hChance = hChance + 40;
			end
		end
		if LastChance(60 - percentHap) or (LastRandom(1,10) <= (gT.Players[iPlayer].GovCauses[13] or 0)) then
			if DoGovernorConsiderActionIfPossible(govID, 12) then return; end
		end
	end
	if percentSecurePost >= 90 then
		if DoGovernorConsiderActionIfPossible(govID, 38) then return; end
	end
	if DoGovernorConsiderActionIfPossible(govID, 39) then return; end
--let's just make new diplomatic contact;
	if DoGovernorConsiderActionIfPossible(govID, 1) then return; end
end

local tHorde7 = GameInfoTypes.TECH_UNIQUE_ITG_TRIAL_HORDE_7
function GetTresholdForGovernorBetrayal(govID, iPlayer)
	local base = 30;
	for g, h in pairs(gT.Globals.Governors[govID].ForeignContacts) do
		if not h.Failed then
			if HasPlayerTech(g, tHorde7, "tinnoh7") then
				base = base + 10;
			end  
		end
	end
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_ASIA_2, "kofer") then
		base = base - 20;
	end
	if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_NEW_WORLD_MESOAMERICAN_2, "elder") then
		for index, sth in pairs(gT.ElDorados) do
			if sth.Player == iPlayer then
				base = base - 20;
				break;
			end
		end
	end
	return math.max(5, base);
end

function GetGovernorForeignContactsActive(govID)
	local numContact = 0;
	for g, h in pairs(gT.Globals.Governors[govID].ForeignContacts) do
		if not h.Failed then
			numContact = numContact + 1;
		end
	end
	return numContact;
end

function GenerateDiploNote(tPlayer, govID, actionID, moreData)
	local tab = {Type = actionID, Governor = govID, Intrigue = GetPlayerGovernorPower(tPlayer)}
	if dgActions[actionID].ExtraData then
		tab.ExtraData = dgActions[actionID].ExtraData(tPlayer, govID, actionID, moreData)
	end
	if govID then
		if tPlayer ~= gT.Globals.Governors[govID].Player then
			if gT.Globals.Governors[govID].ForeignContacts[tPlayer] and gT.Globals.Governors[govID].ForeignContacts[tPlayer].Offers then
				gT.Globals.Governors[govID].ForeignContacts[tPlayer].Offers[actionID] = true;
			end
		end
		tab.GovernorPower = math.max(1,gT.Globals.Governors[govID].Power)
		gT.Globals.Governors[govID].ProposalsMade[actionID] = 1 + (gT.Globals.Governors[govID].ProposalsMade[actionID] or 0)
	end
	table.insert(gT.Players[tPlayer].DiploNotes, tab)
end

function DiploNoteDirty(iPlayer, actionID)
	if not Players[iPlayer]:IsHuman() then
		return;
	end
	local bNeedRefresh = false;
	local nNotes = #gT.Players[iPlayer].DiploNotes;
	for i = 1, nNotes do
		local iNoteID = nNotes + 1 - i;
		if gT.Players[iPlayer].DiploNotes[iNoteID].Type == actionID then
			if not gT.Players[iPlayer].DiploNotes[iNoteID].Ongoing then
				if not dgActions[actionID].ResolveFunc(iPlayer, -1, iNoteID, actionID) then
					table.remove(gT.Players[iPlayer].DiploNotes, iNoteID)
					print("Gov Removed Obsolete Action", iPlayer, iNoteID)
					bNeedRefresh = true;
				end
			end
		end
	end
	if bNeedRefresh then
		RefreshAllDirtyPlayer()
	end
end

function ResolveCurrentDiploNote(iPlayer, actionID)
	return ResolveDiploNote(iPlayer, 1, actionID);
end

function ResolveDiploNote(iPlayer, diploNote, actionID)
	gT.Players[iPlayer].DiploNotes[diploNote].Ongoing = true;
	local tab = dgActions[gT.Players[iPlayer].DiploNotes[diploNote].Type].ResolveFunc(iPlayer, actionID, diploNote, gT.Players[iPlayer].DiploNotes[diploNote].Type);
	if not tab then
		print("Diplo note outdated (AI)", gT.Players[iPlayer].DiploNotes[diploNote].Type)
	end
	table.remove(gT.Players[iPlayer].DiploNotes, diploNote)
	return tab;
end

function GetNumDiploNotesOfTypeWaiting(iPlayer, type)
	local c = 0;
	for i, b in pairs(gT.Players[iPlayer].DiploNotes) do
		if b.Type == type then
			c = c + 1;
		end
	end
	return c;
end

function IsDiploNoteFromGovernorWaiting(iPlayer, govID, type)
	for i, b in pairs(gT.Players[iPlayer].DiploNotes) do
		if (not type) or (b.Type == type) then
			if b.Governor == govID then
				return true;
			end
		end
	end
	return false;
end

function AIAnswersDiploNotes(iPlayer)
	while #gT.Players[iPlayer].DiploNotes > 0 do
		ResolveCurrentDiploNote(iPlayer, dgActions[gT.Players[iPlayer].DiploNotes[1].Type].AIFunc(iPlayer, 1))
	end
end

function GenerateAIGovernorActionsFlavours(iPlayer)
	gT.Players[iPlayer].GovActionsFlavors = {
		Foreign = LastRandom(1,10),
		Power = LastRandom(1,10),
		Random = LastRandom(1,10),
		Punish = LastRandom(1,3),
		Conflict = LastRandom(1,4),
	}
end

function GLogString1001(govID, data, iPlayer)
	return "You have become " .. data[1] .. " of " .. Players[iPlayer]:GetCivilizationShortDescription() .. ".";
end
function GLogString1002(govID, data, iPlayer)
	return "You have appointed new [ICON_ITG_GOVERNOR] governor, " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. "."
end
function GLogString1003(govID, data, iPlayer)
	return "You have assigned [ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. " to city of " .. Map.GetPlotByIndex(data[1]):GetPlotCity():GetName() .. ".";
end
function GLogString1004(govID, data, iPlayer)
	return "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. " has left you.";
end
function GLogString1005(govID, data, iPlayer)
	return "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. " started following " .. GameInfo.Religions[data[1]].IconString .. " " .. Locale.Lookup(Game.GetReligionName(data[1])) .. ".";
end
function GLogString1006(govID, data, iPlayer)
	return "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. " betrayed us for " .. Players[data[1]]:GetName() .. ".";
end
function GLogString1007(govID, data, iPlayer)
	return "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. " betrayed " .. Players[data[1]]:GetName() .. " for us.";
end
function GLogString1008(govID, data, iPlayer)
	return "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. " did not honour Secret Pact and broke contact with us.";
end
function GLogString1009(govID, data, iPlayer)
	return "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. " betrayed " .. Players[data[1]]:GetName() .. " which lead to war.";
end
function GLogString1010(govID, data, iPlayer)
	return "(Bow and Serve) [ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. " joined you.";
end
function GLogString1011(govID, data, iPlayer)
	return "We have killed [ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. " usurping the rights to lead [ICON_CITY_STATE] " .. Players[data[1]]:GetName() .. "."
end
function GLogString1012(govID, data, iPlayer)
	return "We have established relations with [ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) .. "."
end
function GLogString1013(govID, data, iPlayer)
	local govName = "[ICON_ITG_GOVERNOR] " .. Locale.Lookup(gT.Globals.Governors[govID].Name) ;
	if data[2] == 40 then
		if data[3] == 1 then
			return govName .. " successfully established a new goverment with our support in " .. Players[data[1]]:GetCivilizationShortDescription() .. " (+3 [ICON_ITG_LEGAL_POWER])."
		elseif data[3] == 2 then
			return govName .. " asked for our military intervention in " .. Players[data[1]]:GetCivilizationShortDescription() .. " in order to overthrow corrupt goverment."
		elseif data[3] == 3 then
			return govName .. " had to flee to our empire after an unsuccessful attempt to overthrow goverment in " .. Players[data[1]]:GetCivilizationShortDescription() .. "."
		end
	elseif data[2] == 26 then
		if data[3] == 1 then
			return govName .. " successfully established your religion as an official one of " .. Players[data[1]]:GetCivilizationShortDescription() .. " (+300 [ICON_PEACE])."
		elseif data[3] == 2 then
			return govName .. " asked for our military intervention in " .. Players[data[1]]:GetCivilizationShortDescription() .. " to enforce your religion as an official one."
		elseif data[3] == 3 then
			return govName .. " had to flee to our empire after an unsuccessful attempt to establish your religion as an official one in " .. Players[data[1]]:GetCivilizationShortDescription() .. "."
		end
	elseif data[2] == 27 then
		if data[3] == 1 then
			return govName .. " became a leader of " .. Players[data[4]]:GetName() .. " (+60 [ICON_INFLUENCE])."
		elseif data[3] == 2 then
			return govName .. " asked for our military intervention in " .. Players[data[1]]:GetCivilizationShortDescription() .. " to secure leadership of " .. Players[data[4]]:GetName()  .. " (+60 [ICON_INFLUENCE])."
		end
	end
	return "GLogString1013_" .. data[2] .. "_" .. iPlayer;
end
galTab = {
[1001] = GLogString1001,
[1002] = GLogString1002,
[1003] = GLogString1003,
[1004] = GLogString1004,
[1005] = GLogString1005,
[1006] = GLogString1006,
[1007] = GLogString1007,
[1008] = GLogString1008,
[1009] = GLogString1009,
[1010] = GLogString1010,
[1011] = GLogString1011,
[1012] = GLogString1012,
[1013] = GLogString1013,
}

LuaEvents.ITG_RequestGovActionLog.Add(function(iPlayer, govID)
	local gTab = {}
	for a, d in pairs(gT.Players[iPlayer].GovDiploLog) do
		if (not govID) or (d.GovID == govID) then
			if dgActions[d.ID] then
				table.insert(gTab, {d.Turn, dgActions[d.ID].LogString(d.GovID, d.Action, d.Data, iPlayer, d.Outcome)})
			elseif galTab[d.ID] then
				table.insert(gTab, {d.Turn, galTab[d.ID](d.GovID, d.Data, iPlayer)})
			else
				print("Missing gov log print", iPlayer, a, d.ID)
			end
		end
	end
	MapModData.ITGSG = gTab;
end)

LuaEvents.ITG_RequestFirstDiploNote.Add(function(iPlayer)
	if gT.Players[iPlayer].DiploNotes[1] then
		MapModData.ITGSG = dgActions[gT.Players[iPlayer].DiploNotes[1].Type].ResolveFunc(iPlayer, -1, 1, gT.Players[iPlayer].DiploNotes[1].Type);
		if not MapModData.ITGSG then
			print("Diplo note outdated (Human)", gT.Players[iPlayer].DiploNotes[1].Type)
			table.remove(gT.Players[iPlayer].DiploNotes, 1)
			Events.SerialEventEndTurnDirty();
		end
	end
end)

function HasPlayerDiploNoteOfTypeWaiting(iPlayer, actionID)
	for a, b in pairs(gT.Players[iPlayer].DiploNotes) do
		if b.Type == actionID then
			return true;
		end
	end
	return false;
end

LuaEvents.ITG_HumanAnswerDiploNote.Add(function(actionID)
	MapModData.ITGSG = ResolveCurrentDiploNote(Game.GetActivePlayer(), actionID)
	Events.AudioPlay2DSound("AS2D_INTERFACE_POLICY");
	LuaEvents.ITG_AchievementCountChange(123, 1)
end)

LuaEvents.ITG_HumanResolveVoidedDiploNote.Add(function(typeID, actionID, govID)
	MapModData.ITGSG = dgActions[typeID].ResolveFunc(Game.GetActivePlayer(), actionID, govID, typeID);
	Events.AudioPlay2DSound("AS2D_INTERFACE_POLICY");
end)

function AIResolveVoidedDiploNote(iPlayer, typeID, actionID, govID)
	dgActions[typeID].ResolveFunc(iPlayer, actionID, govID, typeID);
end

function ClearDiploNotesOnDeath(jPlayer)
	if gT and gT.Players then
		if gT and gT.Players and gT.Players[jPlayer] then
			gT.Players[jPlayer].DiploNotes = {};
		end
	end
end

LuaEvents.ITG_HumanOpensNominateGovernor.Add(function(govID)
	local iPlayer = Game.GetActivePlayer()
	MapModData.ITGSG = dgActions[50].ResolveFunc(iPlayer, -1, govID, 50);
	LuaEvents.ITG_RequestDiploNoteResolve(true);
end)

LuaEvents.ITG_HumanOpensExecuteGovernor.Add(function(govID)
	local iPlayer = Game.GetActivePlayer()
	MapModData.ITGSG = dgActions[32].ResolveFunc(iPlayer, -1, govID, 32);
	LuaEvents.ITG_RequestDiploNoteResolve(true);
end)

function DoGenerateEndAnarchyDiploNote(iPlayer)
	local tabOptions = {};
	local bHuman = Players[iPlayer]:IsHuman();
	local bActivePlayer = (iPlayer == Game.GetActivePlayer());
	local usedGovs = {}
	usedGovs[gT.Players[iPlayer].GovermentBeforeAnarchy] = 1;
	table.insert(tabOptions, {Gov = gT.Players[iPlayer].GovermentBeforeAnarchy, Old = true, Support = {}})
	for govID, h in pairs(gT.Players[iPlayer].Governors) do
		local goverment = gT.Globals.Governors[govID].Goverment;
		if goverment then
			if usedGovs[goverment] then
				table.insert(tabOptions[usedGovs[goverment]].Support, govID)
			else
				usedGovs[goverment] = #tabOptions + 1;
				table.insert(tabOptions, {Gov = goverment, Old = false, Support = {govID}})
			end
		end
	end
	local pIndex = 1 + #gT.Players[iPlayer].DiploNotes;
	GenerateDiploNote(iPlayer, nil, 34, {tabOptions})
	if #tabOptions > 1 then
		if bHuman then
			if bActivePlayer then
				LuaEvents.ITG_RequestDiploNoteResolve();
				RefreshAllDirtyPlayer()
			end
		else
			ResolveDiploNote(iPlayer, pIndex, GovAIAction34(iPlayer, pIndex))
		end
	else
		if bHuman then
			MapModData.ITGSG = ResolveDiploNote(iPlayer, pIndex, 1)
			LuaEvents.ITG_RequestDiploNoteResolve(true);
		else
			ResolveDiploNote(iPlayer, pIndex, 1)
		end
	end
end

local bIgnoreNextCity = false;
function IgnoreNextCityForGovernorAction()
	bIgnoreNextCity = true;
end
function NewCityForGovernors(iPlayer, iCity, cID)
	DoDefineGovernorCityOwnership(iPlayer)
	if bIgnoreNextCity then
		bIgnoreNextCity = false;
		return;
	end
	local tabOptions = {}
	local options = Shuffle({1,2,3,4})
	local cOption = 1;
	for govID, h in pairs(gT.Players[iPlayer].Governors) do
		local cIndex = gT.Globals.Governors[govID].City;
		local chance;
		if cIndex then
			local cPlot = Map.GetPlotByIndex(cIndex);
			if Map.PlotDistance(iCity:GetX(), iCity:GetY(), cPlot:GetX(), cPlot:GetY()) <= 10 then
				chance = 100;
			else
				chance = 60;
			end
		else
			chance = 80;
		end
		if LastChance(chance) and options[cOption] then
			table.insert(tabOptions, {govID, options[cOption], gT.Globals.Governors[govID].CityLevel})
			cOption = cOption + 1;
		end
	end
	if #tabOptions > 0 then
		if HasPlayerTech(iPlayer, GameInfoTypes.TECH_UNIQUE_ITG_NW_TROPICAL_7, "kdoaked") then
			for a, b in pairs(tabOptions) do
				ApplyGovernorBonusOnCityFound(iPlayer, b[2], b[3], iCity, cID, true)
			end
			ApplyGovernorBonusOnCityFound(iPlayer, -1);
		else
			GenerateDiploNote(iPlayer, nil, 41, {CityID = iCity:GetID(), Options = tabOptions})
			if iPlayer == Game.GetActivePlayer() then
				RefreshAllDirtyPlayer()
			elseif not Players[iPlayer]:IsHuman() then
				if #gT.Players[iPlayer].DiploNotes == 1 then
					ResolveDiploNote(iPlayer, 1, GovAIAction41(iPlayer, 1))
				end
			end
		end
	end
end

function GenerateGovGathering(iPlayer)
	local tabOptions = {}
	local options = {1,4,6,7,8}
	if Players[iPlayer]:GetReligionCreatedByPlayer() > 0 then
		table.insert(options, 3)
	end
	if gT.Globals.ScenarioType == 2 or gT.Globals.ScenarioType == 3 then
		table.insert(options, 2)
	end
	if gT.Players[iPlayer].OfficialReligion then
		if #PreparedDataForEnforcingOfficialReligion(iPlayer).UniqueOptions > 0 then
			table.insert(options, 5)
		end
	end
	options = Shuffle(options)
	local cOption = 1;
	for govID, h in pairs(gT.Players[iPlayer].Governors) do
		local cIndex = gT.Globals.Governors[govID].City;
		if options[cOption] then
			table.insert(tabOptions, {govID, options[cOption], gT.Globals.Governors[govID].CityLevel})
			cOption = cOption + 1;
		end
	end
	if #tabOptions > 0 then
		GenerateDiploNote(iPlayer, nil, 47, {Options = tabOptions})
		if iPlayer == Game.GetActivePlayer() then
			RefreshAllDirtyPlayer()
		elseif not Players[iPlayer]:IsHuman() then
			if #gT.Players[iPlayer].DiploNotes == 1 then
				ResolveDiploNote(iPlayer, 1, GovAIAction47(iPlayer, 1))
			end
		end
	end
end

function SatrapsOnConquest(iPlayer, iCity)
	local tabOptions = {}
	local options = Shuffle({1,2,3,4,5,7,8,9})
	if GetNearestCityStateToXY(iPlayer, iCity:GetX(), iCity:GetY(), true, false) then
		table.insert(options, LastRandom(1, #options), 6)
	end
	local cOption = 1;
	for govID, h in pairs(gT.Players[iPlayer].Governors) do
		local cIndex = gT.Globals.Governors[govID].City;
		if options[cOption] then
			table.insert(tabOptions, {govID, options[cOption], gT.Globals.Governors[govID].CityLevel})
			cOption = cOption + 1;
		end
	end
	if #tabOptions > 0 then
		GenerateDiploNote(iPlayer, nil, 42, {CityID = iCity:GetID(), Options = tabOptions})
		if iPlayer == Game.GetActivePlayer() then
			RefreshAllDirtyPlayer()
		elseif not Players[iPlayer]:IsHuman() then
			if #gT.Players[iPlayer].DiploNotes == 1 then
				ResolveDiploNote(iPlayer, 1, GovAIAction42(iPlayer, 1))
			end
		end
	end
end

function GenerateSymposium(iPlayer)
	local tabOptions = {}
	local options = {2,3,4,6,7}
	for index, data in pairs(gT.Academies) do
		if data.Player == iPlayer then
			if IsAcademyActiveRightNow(index) then
				table.insert(options, 1)
				table.insert(options, 5)
				break;
			end
		end
	end
	options = Shuffle(options)
	local cOption = 1;
	for govID, h in pairs(gT.Players[iPlayer].Governors) do
		local cIndex = gT.Globals.Governors[govID].City;
		if options[cOption] then
			table.insert(tabOptions, {govID, options[cOption], gT.Globals.Governors[govID].CityLevel})
			cOption = cOption + 1;
		end
	end
	if #tabOptions > 0 then
		GenerateDiploNote(iPlayer, nil, 45, {Options = tabOptions})
		if iPlayer == Game.GetActivePlayer() then
			RefreshAllDirtyPlayer()
		elseif not Players[iPlayer]:IsHuman() then
			if #gT.Players[iPlayer].DiploNotes == 1 then
				ResolveDiploNote(iPlayer, 1, GovAIAction45(iPlayer, 1))
			end
		end
	end
end

function GetIdeo12CSToBlame(iPlayer)
	local cstb = {};
	for g, h in pairs(gT.Players) do
		if Players[g]:IsMinorCiv() then
			if Players[g]:GetMinorCivFriendshipWithMajor(iPlayer) > 60 then
				table.insert(cstb, g)
			end
		end
	end
	if #cstb > 0 then
		return RandomFromTab(cstb);
	end
	return nil;
end

function DoGenerateGovActionIdeo12(iPlayer)
	local tabOptions = {}
	local options = {}
	if Players[iPlayer]:GetNumCities() > 4 then
		table.insert(options, 1)
		table.insert(options, 6)
	end
	if Players[iPlayer]:GetTotalPopulation() > 15 then
		table.insert(options, 2)
	end
	if GetMeritocracyAvailable(iPlayer) > 25 then
		table.insert(options, 3);
	end
	local csToBlame = GetIdeo12CSToBlame(iPlayer);
	if csToBlame then
		table.insert(options, 4);
	end
	if Players[iPlayer]:GetGold() > 600 then
		table.insert(options, 5);
	end
	if gT.Players[iPlayer].UnhapIdeo12 < 250 then
		table.insert(options, 7);
	end
	if gT.Players[iPlayer].GreatArtistPoints > 400 then
		table.insert(options, 8)
	end
	if not options[1] then
		return;
	end
	options = Shuffle(options)
	local cOption = 1;
	for govID, h in pairs(gT.Players[iPlayer].Governors) do
		local cIndex = gT.Globals.Governors[govID].City;
		if options[cOption] then
			table.insert(tabOptions, {govID, options[cOption]})
			if options[cOption] == 4 then
				tabOptions[cOption][3] = csToBlame;
			end
			cOption = cOption + 1;
		end
	end
	if #tabOptions > 0 then
		GenerateDiploNote(iPlayer, nil, 46, {Options = tabOptions})
		if iPlayer == Game.GetActivePlayer() then
			RefreshAllDirtyPlayer()
		elseif not Players[iPlayer]:IsHuman() then
			if #gT.Players[iPlayer].DiploNotes == 1 then
				ResolveDiploNote(iPlayer, 1, GovAIAction46(iPlayer, 1))
			end
		end
	end
end

function DoPrintGovDiploLog()
	local aT = {}
	for a, b in pairs(dgActions) do
		aT[a] = 0;
	end
	for g, v in pairs(gT.Players) do
		for c, d in pairs(v.GovDiploLog or {}) do
			if aT[d.ID] then
				aT[d.ID] = aT[d.ID] + 1;
			end
		end
	end
	for a, b in pairs(dgActions) do
		print("GovDiplo", b.Name, aT[b.ID])
	end
--[[	print("///")
	print("///")
	print("///")
	local byPlayers = {}
	local totpH, totpSP = 0, 0;
	local cDc = 0;
	local mSecurity, mHappy = 0, 100;
	for a, b in pairs(gT.Globals.logGovCATM) do
		cDc = cDc + 1;
		mHappy = math.min(mHappy, b[2])
		mSecurity = math.max(mSecurity, b[3])
		totpH = totpH + b[2]
		totpSP = totpSP + b[3] ]]
--		if not byPlayers[b[1]] then
--			byPlayers[b[1]] = {0, 0, 0}
--		end
--		byPlayers[b[1]][1] = byPlayers[b[1]][1] + b[2];
--		byPlayers[b[1]][2] = byPlayers[b[1]][2] + b[3];
--		byPlayers[b[1]][3] = byPlayers[b[1]][3] + 1;
--[[	end
	if cDc > 0 then
		print("GovDecisions based on (minHappy, avg Happy, max Security, avg Security, #data)", mHappy, totpH / cDc, mSecurity, totpSP / cDc, cDc)
		for player, data in pairs(byPlayers) do
			print("GovDecisions (player, avg Happy, avg Security, #data)", player, data[1] / data[3], data[2] / data[3], data[3])
		end
	end ]]
end

function HasNoDiploPopupBlockingCentralizePower(iPlayer)
	for i, d in pairs(gT.Players[iPlayer].DiploNotes) do
		if dgActions[d.Type].BlocksCPAction then
			return false;
		end
	end
	return true;
end

function IsValidForSupportRequest(govID, g, actionType, idata1)
	if actionType == 40 then
		return (gT.Globals.Governors[govID].Goverment == gT.Players[g].Goverment)
	elseif actionType == 26 then
		return (gT.Globals.Governors[govID].CityReligion == Players[g]:GetReligionCreatedByPlayer())
	elseif actionType == 27 then
		if not idata1 then
			return true;
		end
		local gTeam = Players[g]:GetTeam();
		local csTeam = Players[idata1]:GetTeam();
		if Teams[gTeam]:IsHasMet(csTeam) then
			if not Teams[gTeam]:IsAtWar(csTeam) then
				if Players[idata1]:GetAlly() ~= g then
					return true;
				end
			end
		end
		return false;
	end
	print("Missing gov support request valid", actionType)
	return false;
end

function GetChanceFromForeignSupport(govID, actionType, exVal)
	for g, h in pairs(gT.Globals.Governors[govID].ForeignContacts) do
		if (not h.Failed) and (not h.Offers[selfID]) and (Players[g]:IsAlive()) then
			if Players[g]:GetNumCities() > 0 then
				if IsValidForSupportRequest(govID, g, actionType, nil) then
					return exVal or 5;
				end
			end
		end
	end
	return 0;
end

function PrepareGovForeignSupport(iPlayer, govID, actionType, idata1)
	if GetITGGameTurn() > 95 then
		return false;
	end
	local tab = {};
	for g, h in pairs(gT.Globals.Governors[govID].ForeignContacts) do
		if (not h.Failed) and (not h.Offers[selfID]) and (Players[g]:IsAlive()) then
			if Players[g]:GetNumCities() > 0 then
				if LastChance(h.Favour + 20) then
					if IsValidForSupportRequest(govID, g, actionType, idata1) then
						table.insert(tab, g);
					end
				end
			end
		end
	end
	if #tab > 0 then
		local sPlayer = RandomFromTab(tab);
		GenerateDiploNote(sPlayer, govID, 54, {actionType, iPlayer, idata1})
		return true;
	end
	return false;
end